/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(V){for(var t=[],i=0,P=V.length;i<P;i++)t[i]=ie[V[i]];return t};const Ce=this,ze=typeof global=="object"?global:{};var ge;(function(V){V.global=Ce;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(ge||(ge={}));var ge;(function(V){class t{constructor(o,v,h){this.type=o,this.detail=v,this.timestamp=h}}V.LoaderEvent=t;class i{constructor(o){this._events=[new t(1,"",o)]}record(o,v){this._events.push(new t(o,v,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=i;class P{record(o,v){}getEvents(){return[]}}P.INSTANCE=new P,V.NullLoaderEventRecorder=P})(ge||(ge={}));var ge;(function(V){class t{static fileUriToFilePath(P,y){if(y=decodeURI(y).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(y))return y.substr(8);if(/^file:\/\//.test(y))return y.substr(5)}else if(/^file:\/\//.test(y))return y.substr(7);return y}static startsWith(P,y){return P.length>=y.length&&P.substr(0,y.length)===y}static endsWith(P,y){return P.length>=y.length&&P.substr(P.length-y.length)===y}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,y){if(P){let o;for(o in P)P.hasOwnProperty(o)&&y(o,P[o])}}static isEmpty(P){let y=!0;return t.forEachProperty(P,()=>{y=!1}),y}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let y=Array.isArray(P)?[]:{};return t.forEachProperty(P,(o,v)=>{v&&typeof v=="object"?y[o]=t.recursiveClone(v):y[o]=v}),y}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(ge||(ge={}));var ge;(function(V){function t(y){if(y instanceof Error)return y;const o=new Error(y.message||String(y)||"Unknown Error");return y.stack&&(o.stack=y.stack),o}V.ensureError=t;class i{static validateConfigurationOptions(o){function v(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=v),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(V.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",o.onError(h),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,v=null){let h=V.Utilities.recursiveClone(v||{});return V.Utilities.forEachProperty(o,(l,u)=>{l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(u):l==="paths"&&typeof h.paths<"u"?V.Utilities.forEachProperty(u,(c,p)=>h.paths[c]=p):l==="config"&&typeof h.config<"u"?V.Utilities.forEachProperty(u,(c,p)=>h.config[c]=p):h[l]=V.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(h)}}V.ConfigurationOptionsUtil=i;class P{constructor(o,v){if(this._env=o,this.options=i.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(o,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:o,to:v}):this.sortedPathsRules.push({from:o,to:[v]})}),this.sortedPathsRules.sort((o,v)=>v.from.length-o.from.length)}cloneAndMerge(o){return new P(this._env,i.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let v;for(let h=0,l=this.sortedPathsRules.length;h<l;h++)if(v=this.sortedPathsRules[h],V.Utilities.startsWith(o,v.from)){let u=[];for(let c=0,p=v.to.length;c<p;c++)u.push(v.to[c]+o.substr(v.from.length));return u}return[o]}_addUrlArgsToUrl(o){return V.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let v=0,h=o.length;v<h;v++)o[v]=this._addUrlArgsToUrl(o[v]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let v=o,h;if(!V.Utilities.endsWith(v,".js")&&!V.Utilities.isAbsolutePath(v)){h=this._applyPaths(v);for(let l=0,u=h.length;l<u;l++)this.isBuild()&&h[l]==="empty:"||(V.Utilities.isAbsolutePath(h[l])||(h[l]=this.options.baseUrl+h[l]),!V.Utilities.endsWith(h[l],".js")&&!V.Utilities.containsQueryString(h[l])&&(h[l]=h[l]+".js"))}else!V.Utilities.endsWith(v,".js")&&!V.Utilities.containsQueryString(v)&&(v=v+".js"),h=[v];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(o){let v=o;return V.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],V.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}V.Configuration=P})(ge||(ge={}));var ge;(function(V){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,c,p,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new y;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new i;let m={callback:p,errorback:b};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(m);return}this._callbackMap[c]=[m],this._scriptLoader.load(u,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(u){let c=this._callbackMap[u];delete this._callbackMap[u];for(let p=0;p<c.length;p++)c[p].callback()}triggerErrorback(u,c){let p=this._callbackMap[u];delete this._callbackMap[u];for(let b=0;b<p.length;b++)p[b].errorback(c)}}class i{attachListeners(u,c,p){let b=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=N=>{b(),c()},e=N=>{b(),p(N)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,c,p,b){if(/^node\|/.test(c)){let m=u.getConfig().getOptionsLiteral(),e=v(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),N=c.split("|"),j=null;try{j=e(N[1])}catch(L){b(L);return}u.enqueueDefineAnonymousModule([],()=>j),p()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,p,b);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),m.setAttribute("src",c);const{cspNonce:N}=u.getConfig().getOptionsLiteral();N&&m.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(m)}}}function P(l){const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class y{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(u)),this._cachedCanUseEval}load(u,c,p,b){if(/^node\|/.test(c)){const m=u.getConfig().getOptionsLiteral(),e=v(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),N=c.split("|");let j=null;try{j=e(N[1])}catch(L){b(L);return}u.enqueueDefineAnonymousModule([],function(){return j}),p()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(c).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${c}`,(m?self.eval(m.createScript("",N)):new Function(N)).call(self),p()}).then(void 0,b);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),p()}catch(N){b(N)}}}}class o{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,c){const{nodeCachedData:p}=c.getConfig().getOptionsLiteral();if(!p||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=u("module");function e(N){const j=N.constructor;let L=function(d){try{return N.require(d)}finally{}};return L.resolve=function(d,a){return j._resolveFilename(d,N,!1,a)},L.resolve.paths=function(d){return j._resolveLookupPaths(d,N)},L.main=process.mainModule,L.extensions=j._extensions,L.cache=j._cache,L}m.prototype._compile=function(N,j){const L=m.wrap(N.replace(/^#!.*/,"")),$=c.getRecorder(),d=b._getCachedDataPath(p,j),a={filename:j};let f;try{const R=b._fs.readFileSync(d);f=R.slice(0,16),a.cachedData=R.slice(16),$.record(60,d)}catch{$.record(61,d)}const n=new b._vm.Script(L,a),s=n.runInThisContext(a),w=b._path.dirname(j),g=e(this),A=[this.exports,g,this,j,w,process,ze,Buffer],E=s.apply(this.exports,A);return b._handleCachedData(n,L,d,!a.cachedData,c),b._verifyCachedData(n,L,d,f,c),E}}load(u,c,p,b){const m=u.getConfig().getOptionsLiteral(),e=v(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),N=m.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,u);let j=u.getRecorder();if(/^node\|/.test(c)){let L=c.split("|"),$=null;try{$=e(L[1])}catch(d){b(d);return}u.enqueueDefineAnonymousModule([],()=>$),p()}else{c=V.Utilities.fileUriToFilePath(this._env.isWindows,c);const L=this._path.normalize(c),$=this._getElectronRendererScriptPathOrUri(L),d=!!m.nodeCachedData,a=d?this._getCachedDataPath(m.nodeCachedData,c):void 0;this._readSourceAndCachedData(L,a,j,(f,n,s,w)=>{if(f){b(f);return}let g;n.charCodeAt(0)===o._BOM?g=o._PREFIX+n.substring(1)+o._SUFFIX:g=o._PREFIX+n+o._SUFFIX,g=N(g,L);const A={filename:$,cachedData:s},E=this._createAndEvalScript(u,g,A,p,b);this._handleCachedData(E,g,a,d&&!s,u),this._verifyCachedData(E,g,a,w,u)})}}_createAndEvalScript(u,c,p,b,m){const e=u.getRecorder();e.record(31,p.filename);const N=new this._vm.Script(c,p),j=N.runInThisContext(p),L=u.getGlobalAMDDefineFunc();let $=!1;const d=function(){return $=!0,L.apply(null,arguments)};return d.amd=L.amd,j.call(V.global,u.getGlobalAMDRequireFunc(),d,p.filename,this._path.dirname(p.filename)),e.record(32,p.filename),$?b():m(new Error(`Didn't receive define call in ${p.filename}!`)),N}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let c=u.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,c){const p=this._crypto.createHash("md5").update(c,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(c).replace(/\.js$/,"");return this._path.join(u.path,`${b}-${p}.code`)}_handleCachedData(u,c,p,b,m){u.cachedDataRejected?this._fs.unlink(p,e=>{m.getRecorder().record(62,p),this._createAndWriteCachedData(u,c,p,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(u,c,p,m)}_createAndWriteCachedData(u,c,p,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,j;const L=()=>{setTimeout(()=>{j||(j=this._crypto.createHash("md5").update(c,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||N>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(p,Buffer.concat([j,$]),d=>{d&&b.getConfig().onError(d),b.getRecorder().record(63,p),L()})}},m*Math.pow(4,N++))};L()}_readSourceAndCachedData(u,c,p,b){if(!c)this._fs.readFile(u,{encoding:"utf8"},b);else{let m,e,N,j=2;const L=$=>{$?b($):--j===0&&b(void 0,m,e,N)};this._fs.readFile(u,{encoding:"utf8"},($,d)=>{m=d,L($)}),this._fs.readFile(c,($,d)=>{!$&&d&&d.length>0?(N=d.slice(0,16),e=d.slice(16),p.record(60,c)):p.record(61,c),L()})}}_verifyCachedData(u,c,p,b,m){b&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${p}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(p,N=>{N&&m.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function v(l,u){if(u.__$__isRecorded)return u;const c=function(b){l.record(33,b);try{return u(b)}finally{l.record(34,b)}};return c.__$__isRecorded=!0,c}V.ensureRecordedNodeRequire=v;function h(l){return new t(l)}V.createScriptLoader=h})(ge||(ge={}));var ge;(function(V){class t{constructor(l){let u=l.lastIndexOf("/");u!==-1?this.fromModulePath=l.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(l){let u=l,c;for(c=/\/\.\//;c.test(u);)u=u.replace(c,"/");for(u=u.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(u);)u=u.replace(c,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(l){let u=l;return V.Utilities.isAbsolutePath(u)||(V.Utilities.startsWith(u,"./")||V.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),V.ModuleIdResolver=t;class i{constructor(l,u,c,p,b,m){this.id=l,this.strId=u,this.dependencies=c,this._callback=p,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,u){try{return{returnedValue:l.apply(V.global,u),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(l,u,c,p){return l.shouldInvokeFactory(u)?l.shouldCatchError()?this._safeInvokeFunction(c,p):{returnedValue:c.apply(V.global,p),producedError:null}:{returnedValue:null,producedError:null}}complete(l,u,c,p){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=i._invokeFactory(u,this.strId,this._callback,c);b=m.producedError,l.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=V.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=p(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}V.Module=i;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let u=this._strModuleIdToIntModuleId.get(l);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(l,u),this._intModuleIdToStrModuleId[u]=l),u}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class y{constructor(l){this.id=l}}y.EXPORTS=new y(0),y.MODULE=new y(1),y.REQUIRE=new y(2),V.RegularDependency=y;class o{constructor(l,u,c){this.id=l,this.pluginId=u,this.pluginParam=c}}V.PluginDependency=o;class v{constructor(l,u,c,p,b=0){this._env=l,this._scriptLoader=u,this._loaderAvailableTimestamp=b,this._defineFunc=c,this._requireFunc=p,this._moduleIdProvider=new P,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,u){let c=m=>m.replace(/\\/g,"/"),p=c(l),b=u.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],j=e[2],L=e[3],$=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr($),N=c(N),N===p){let d={line:parseInt(j,10),col:parseInt(L,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],u=0;for(let c=0,p=this._modules2.length;c<p;c++){let b=this._modules2[c];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,N=this._buildInfoDependencies[b.id];l[u++]={id:b.strId,path:m,defineLocation:m&&e?v._findRelevantLocationInStack(m,e):null,dependencies:N,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:l,callback:u}}defineModule(l,u,c,p,b,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let N=new i(e,l,this._normalizeDependencies(u,m),c,p,m);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(N.dependencies||[]).map(j=>this._moduleIdProvider.getStrModuleId(j.id))),this._resolve(N)}_normalizeDependency(l,u){if(l==="exports")return y.EXPORTS;if(l==="module")return y.MODULE;if(l==="require")return y.REQUIRE;let c=l.indexOf("!");if(c>=0){let p=u.resolveModule(l.substr(0,c)),b=u.resolveModule(l.substr(c+1)),m=this._moduleIdProvider.getModuleId(p+"!"+b),e=this._moduleIdProvider.getModuleId(p);return new o(m,e,b)}return new y(this._moduleIdProvider.getModuleId(u.resolveModule(l)))}_normalizeDependencies(l,u){let c=[],p=0;for(let b=0,m=l.length;b<m;b++)c[p++]=this._normalizeDependency(l[b],u);return c}_relativeRequire(l,u,c,p){if(typeof u=="string")return this.synchronousRequire(u,l);this.defineModule(V.Utilities.generateAnonymousModule(),u,c,p,null,l)}synchronousRequire(l,u=new t(l)){let c=this._normalizeDependency(l,u),p=this._modules2[c.id];if(!p)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!p.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(p.error)throw p.error;return p.exports}configure(l,u){let c=this._config.shouldRecordStats();u?this._config=new V.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),u.dependencies,u.callback,null,u.stack)}}_createLoadError(l,u){let c=this._moduleIdProvider.getStrModuleId(l),p=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=V.ensureError(u);return b.phase="loading",b.moduleId=c,b.neededBy=p,b}_onLoadError(l,u){const c=this._createLoadError(l,u);this._modules2[l]||(this._modules2[l]=new i(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let p=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)p[e]=!1;let b=!1,m=[];for(m.push(l),p[l]=!0;m.length>0;){let e=m.shift(),N=this._modules2[e];N&&(b=N.onDependencyError(c)||b);let j=this._inverseDependencies2[e];if(j)for(let L=0,$=j.length;L<$;L++){let d=j[L];p[d]||(m.push(d),p[d]=!0)}}b||this._config.onError(c)}_hasDependencyPath(l,u){let c=this._modules2[l];if(!c)return!1;let p=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)p[m]=!1;let b=[];for(b.push(c),p[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let N=0,j=e.length;N<j;N++){let L=e[N];if(L.id===u)return!0;let $=this._modules2[L.id];$&&!p[L.id]&&(p[L.id]=!0,b.push($))}}return!1}_findCyclePath(l,u,c){if(l===u||c===50)return[l];let p=this._modules2[l];if(!p)return null;let b=p.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let N=this._findCyclePath(b[m].id,u,c+1);if(N!==null)return N.push(l),N}return null}_createRequire(l){let u=(c,p,b)=>this._relativeRequire(l,c,p,b);return u.toUrl=c=>this._config.requireToUrl(l.resolveModule(c)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(c,p=!1)=>{this.configure(c,p)},u.__$__nodeRequire=V.global.nodeRequire,u}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let u=this._moduleIdProvider.getStrModuleId(l),c=this._config.moduleIdToPaths(u),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||p.test(u))&&c.push("node|"+u);let b=-1,m=e=>{if(b++,b>=c.length)this._onLoadError(l,e);else{let N=c[b],j=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[l]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}j.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=N),j.record(11,N),this._onLoad(l)},L=>{j.record(12,N),m(L)})}};m(null)}_loadPluginDependency(l,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let c=p=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],p,null,null)};c.error=p=>{this._config.onError(this._createLoadError(u.id,p))},l.load(u.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(l){let u=l.dependencies;if(u)for(let c=0,p=u.length;c<p;c++){let b=u[c];if(b===y.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===y.MODULE){l.unresolvedDependenciesCount--;continue}if(b===y.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof o){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let N=this._inversePluginDependencies2.get(b.pluginId);N||(N=[],this._inversePluginDependencies2.set(b.pluginId,N)),N.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let u=this.getRecorder();if(l.isComplete())return;let c=l.dependencies,p=[];if(c)for(let N=0,j=c.length;N<j;N++){let L=c[N];if(L===y.EXPORTS){p[N]=l.exports;continue}if(L===y.MODULE){p[N]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(L===y.REQUIRE){p[N]=this._createRequire(l.moduleIdResolver);continue}let $=this._modules2[L.id];if($){p[N]=$.exports;continue}p[N]=null}const b=N=>(this._inverseDependencies2[N]||[]).map(j=>this._moduleIdProvider.getStrModuleId(j));l.complete(u,this._config,p,b);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let N=0,j=m.length;N<j;N++){let L=m[N],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let N=0,j=e.length;N<j;N++)this._loadPluginDependency(l.exports,e[N])}}}V.ModuleManager=v})(ge||(ge={}));var re,ge;(function(V){const t=new V.Environment;let i=null;const P=function(h,l,u){typeof h!="string"&&(u=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(u=l,l=null),l||(l=["require","exports","module"]),h?i.defineModule(h,l,u,null,null):i.enqueueDefineAnonymousModule(l,u)};P.amd={jQuery:!0};const y=function(h,l=!1){i.configure(h,l)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){y(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=y,o.getConfig=function(){return i.getConfig().getOptionsLiteral()},o.reset=function(){i=i.reset()},o.getBuildInfo=function(){return i.getBuildInfo()},o.getStats=function(){return i.getLoaderEvents()},o.define=P;function v(){if(typeof V.global.require<"u"||typeof require<"u"){const h=V.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const l=V.ensureRecordedNodeRequire(i.getRecorder(),h);V.global.nodeRequire=l,o.nodeRequire=l,o.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(V.global.define=P),V.global.require=o)}V.init=v,(typeof V.global.define!="function"||!V.global.define.amd)&&(i=new V.ModuleManager(t,V.createScriptLoader(t),P,o,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&o.config(V.global.require),re=function(){return P.apply(null,arguments)},re.amd=P.amd,typeof doNotInitLoader>"u"&&v())})(ge||(ge={})),re(ie[71],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(h,l,u,c){if(c=c||{},(c["vs/css"]||{}).disabled){u({});return}const b=l.toUrl(h+".css");P(h,b,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+b+".")})}function P(h,l,u,c){if(y(h,l)){u();return}o(h,l,u,c)}function y(h,l){const u=window.document.getElementsByTagName("link");for(let c=0,p=u.length;c<p;c++){const b=u[c].getAttribute("data-name"),m=u[c].getAttribute("href");if(b===h||m===l)return!0}return!1}function o(h,l,u,c){const p=document.createElement("link");p.setAttribute("rel","stylesheet"),p.setAttribute("type","text/css"),p.setAttribute("data-name",h),v(h,p,u,c),p.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(p)}function v(h,l,u,c){const p=()=>{l.removeEventListener("load",b),l.removeEventListener("error",m)},b=e=>{p(),u()},m=e=>{p(),c(e)};l.addEventListener("load",b),l.addEventListener("error",m)}}),re("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=c,t.localize2=p,t.getConfiguredDefaultLocale=b,t.setPseudoTranslation=m,t.create=e,t.load=N;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function y(j,L){let $;return L.length===0?$=j:$=j.replace(/\{(\d+)\}/g,(d,a)=>{const f=a[0],n=L[f];let s=d;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function o(j,L){let $=j[L];return $||($=j["*"],$)?$:null}function v(j){return j.charAt(j.length-1)==="/"?j:j+"/"}async function h(j,L,$){const d=v(j)+v(L)+"vscode/"+v($),a=await fetch(d);if(a.ok)return await a.json();throw new Error(`${a.status} - ${a.statusText}`)}function l(j){return function(L,$){const d=Array.prototype.slice.call(arguments,2);return y(j[L],d)}}function u(j){return(L,$,...d)=>({value:y(j[L],d),original:y($,d)})}function c(j,L,...$){return y(L,$)}function p(j,L,...$){const d=y(L,$);return{value:d,original:d}}function b(j){}function m(j){i=j}function e(j,L){return{localize:l(L[j]),localize2:u(L[j]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}function N(j,L,$,d){const a=d["vs/nls"]??{};if(!j||j.length===0)return $({localize:c,localize2:p,getConfiguredDefaultLocale:()=>a.availableLanguages?.["*"]});const f=a.availableLanguages?o(a.availableLanguages,j):null,n=f===null||f===P;let s=".nls";n||(s=s+"."+f);const w=g=>{Array.isArray(g)?(g.localize=l(g),g.localize2=u(g)):(g.localize=l(g[j]),g.localize2=u(g[j])),g.getConfiguredDefaultLocale=()=>a.availableLanguages?.["*"],$(g)};typeof a.loadBundle=="function"?a.loadBundle(j,f,(g,A)=>{g?L([j+".nls"],w):w(A)}):a.translationServiceUrl&&!n?(async()=>{try{const g=await h(a.translationServiceUrl,f,j);return w(g)}catch(g){if(!f.includes("-"))return console.error(g),L([j+".nls"],w);try{const A=f.split("-")[0],E=await h(a.translationServiceUrl,A,j);return a.availableLanguages??={},a.availableLanguages["*"]=A,w(E)}catch(A){return console.error(A),L([j+".nls"],w)}}})():L([j+s],w,g=>{if(s===".nls"){console.error("Failed trying to load default language strings",g);return}console.error(`Failed to load message bundle for language ${f}. Falling back to the default language:`,g),L([j+".nls"],w)})}}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function i(c,p){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(c,p)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(c,p)}catch(b){console.warn(b);return}}const P=i("amdLoader",{createScriptURL:c=>c,createScript:(c,...p)=>{const b=p.slice(0,-1).join(","),m=p.pop().toString();return`(function anonymous(${b}) { ${m}
})`}});function y(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((c,p)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&y()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,p);return}P?importScripts(P.createScriptURL(b)):importScripts(b),c()})}function v(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function h(c){o().then(()=>{v(),require([c],function(p){setTimeout(function(){const b=p.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>b.onmessage(m.data,m.ports);u.length>0;){const m=u.shift();b.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let l=!0;const u=[];globalThis.onmessage=c=>{if(!l){u.push(c);return}l=!1,h(c.data)}}(),re(ie[9],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=P,t.$hb=y,t.$ib=o,t.$jb=v,t.$kb=h,t.$lb=l,t.$nb=c,t.$ob=p,t.$pb=b,t.$qb=m,t.$rb=e;function i(N,j,L){const $=P(N,j);if($!==-1)return N[$]}function P(N,j,L=N.length-1){for(let $=L;$>=0;$--){const d=N[$];if(j(d))return $}return-1}function y(N,j){const L=o(N,j);return L===-1?void 0:N[L]}function o(N,j,L=0,$=N.length){let d=L,a=$;for(;d<a;){const f=Math.floor((d+a)/2);j(N[f])?d=f+1:a=f}return d-1}function v(N,j){const L=h(N,j);return L===N.length?void 0:N[L]}function h(N,j,L=0,$=N.length){let d=L,a=$;for(;d<a;){const f=Math.floor((d+a)/2);j(N[f])?a=f:d=f+1}return d}function l(N,j,L=0,$=N.length){const d=h(N,j,L,$);return d===N.length?-1:d}class u{static{this.assertInvariants=!1}constructor(j){this.e=j,this.c=0}findLastMonotonous(j){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!j($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=j}const L=o(this.e,j,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=u;function c(N,j){if(N.length===0)return;let L=N[0];for(let $=1;$<N.length;$++){const d=N[$];j(d,L)>0&&(L=d)}return L}function p(N,j){if(N.length===0)return;let L=N[0];for(let $=1;$<N.length;$++){const d=N[$];j(d,L)>=0&&(L=d)}return L}function b(N,j){return c(N,(L,$)=>-j(L,$))}function m(N,j){if(N.length===0)return-1;let L=0;for(let $=1;$<N.length;$++){const d=N[$];j(d,N[L])>0&&(L=$)}return L}function e(N,j){for(const L of N){const $=j(L);if($!==void 0)return $}}}),re(ie[35],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=P,t.$M=y,t.$N=o;function i(v,h){const l=Object.create(null);for(const u of v){const c=h(u);let p=l[c];p||(p=l[c]=[]),p.push(u)}return l}function P(v,h){const l=[],u=[];for(const c of v)h.has(c)||l.push(c);for(const c of h)v.has(c)||u.push(c);return{removed:l,added:u}}function y(v,h){const l=[],u=[];for(const[c,p]of v)h.has(c)||l.push(p);for(const[c,p]of h)v.has(c)||u.push(p);return{removed:l,added:u}}function o(v,h){const l=new Set;for(const u of h)v.has(u)&&l.add(u);return l}}),re(ie[36],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ct=t.$Bt=t.$At=t.$zt=void 0;function i(h,l){const u=Math.pow(10,l);return Math.round(h*u)/u}class P{constructor(l,u,c,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=i(Math.max(Math.min(1,p),0),3)}static equals(l,u){return l.r===u.r&&l.g===u.g&&l.b===u.b&&l.a===u.a}}t.$zt=P;class y{constructor(l,u,c,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,p),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.l===u.l&&l.a===u.a}static fromRGBA(l){const u=l.r/255,c=l.g/255,p=l.b/255,b=l.a,m=Math.max(u,c,p),e=Math.min(u,c,p);let N=0,j=0;const L=(e+m)/2,$=m-e;if($>0){switch(j=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),m){case u:N=(c-p)/$+(c<p?6:0);break;case c:N=(p-u)/$+2;break;case p:N=(u-c)/$+4;break}N*=60,N=Math.round(N)}return new y(N,j,L,b)}static i(l,u,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?l+(u-l)*6*c:c<1/2?u:c<2/3?l+(u-l)*(2/3-c)*6:l}static toRGBA(l){const u=l.h/360,{s:c,l:p,a:b}=l;let m,e,N;if(c===0)m=e=N=p;else{const j=p<.5?p*(1+c):p+c-p*c,L=2*p-j;m=y.i(L,j,u+1/3),e=y.i(L,j,u),N=y.i(L,j,u-1/3)}return new P(Math.round(m*255),Math.round(e*255),Math.round(N*255),b)}}t.$At=y;class o{constructor(l,u,c,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,p),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.v===u.v&&l.a===u.a}static fromRGBA(l){const u=l.r/255,c=l.g/255,p=l.b/255,b=Math.max(u,c,p),m=Math.min(u,c,p),e=b-m,N=b===0?0:e/b;let j;return e===0?j=0:b===u?j=((c-p)/e%6+6)%6:b===c?j=(p-u)/e+2:j=(u-c)/e+4,new o(Math.round(j*60),N,b,l.a)}static toRGBA(l){const{h:u,s:c,v:p,a:b}=l,m=p*c,e=m*(1-Math.abs(u/60%2-1)),N=p-m;let[j,L,$]=[0,0,0];return u<60?(j=m,L=e):u<120?(j=e,L=m):u<180?(L=m,$=e):u<240?(L=e,$=m):u<300?(j=e,$=m):u<=360&&(j=m,$=e),j=Math.round((j+N)*255),L=Math.round((L+N)*255),$=Math.round(($+N)*255),new P(j,L,$,b)}}t.$Bt=o;class v{static fromHex(l){return v.Format.CSS.parseHex(l)||v.red}static equals(l,u){return!l&&!u?!0:!l||!u?!1:l.equals(u)}get hsla(){return this.i?this.i:y.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof P)this.rgba=l;else if(l instanceof y)this.i=l,this.rgba=y.toRGBA(l);else if(l instanceof o)this.j=l,this.rgba=o.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&P.equals(this.rgba,l.rgba)&&y.equals(this.hsla,l.hsla)&&o.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=v.k(this.rgba.r),u=v.k(this.rgba.g),c=v.k(this.rgba.b),p=.2126*l+.7152*u+.0722*c;return i(p,4)}static k(l){const u=l/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(l){const u=this.getRelativeLuminance(),c=l.getRelativeLuminance();return u>c?(u+.05)/(c+.05):(c+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const u=this.getRelativeLuminance(),c=l.getRelativeLuminance();return u>c}isDarkerThan(l){const u=this.getRelativeLuminance(),c=l.getRelativeLuminance();return u<c}lighten(l){return new v(new y(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new v(new y(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:u,g:c,b:p,a:b}=this.rgba;return new v(new P(u,c,p,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const u=l.rgba,c=this.rgba.a,p=u.a,b=c+p*(1-c);if(b<1e-6)return v.transparent;const m=this.rgba.r*c/b+u.r*p*(1-c)/b,e=this.rgba.g*c/b+u.g*p*(1-c)/b,N=this.rgba.b*c/b+u.b*p*(1-c)/b;return new v(new P(m,e,N,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:u,g:c,b:p,a:b}=this.rgba;return new v(new P(l.rgba.r-b*(l.rgba.r-u),l.rgba.g-b*(l.rgba.g-c),l.rgba.b-b*(l.rgba.b-p),1))}flatten(...l){const u=l.reduceRight((c,p)=>v.o(p,c));return v.o(this,u)}static o(l,u){const c=1-l.rgba.a;return new v(new P(c*u.rgba.r+l.rgba.a*l.rgba.r,c*u.rgba.g+l.rgba.a*l.rgba.g,c*u.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(l,u,c){if(l.isLighterThan(u))return l;c=c||.5;const p=l.getRelativeLuminance(),b=u.getRelativeLuminance();return c=c*(b-p)/b,l.lighten(c)}static getDarkerColor(l,u,c){if(l.isDarkerThan(u))return l;c=c||.5;const p=l.getRelativeLuminance(),b=u.getRelativeLuminance();return c=c*(p-b)/p,l.darken(c)}static{this.white=new v(new P(255,255,255,1))}static{this.black=new v(new P(0,0,0,1))}static{this.red=new v(new P(255,0,0,1))}static{this.blue=new v(new P(0,0,255,1))}static{this.green=new v(new P(0,255,0,1))}static{this.cyan=new v(new P(0,255,255,1))}static{this.lightgrey=new v(new P(211,211,211,1))}static{this.transparent=new v(new P(0,0,0,0))}}t.$Ct=v,function(h){let l;(function(u){let c;(function(p){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:h.Format.CSS.formatRGBA(n)}p.formatRGB=b;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}p.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(n)}p.formatHSL=e;function N(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}p.formatHSLA=N;function j(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function L(n){return`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}`}p.formatHex=L;function $(n,s=!1){return s&&n.rgba.a===1?h.Format.CSS.formatHex(n):`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}${j(Math.round(n.rgba.a*255))}`}p.formatHexA=$;function d(n){return n.isOpaque()?h.Format.CSS.formatHex(n):h.Format.CSS.formatRGBA(n)}p.format=d;function a(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const w=16*f(n.charCodeAt(1))+f(n.charCodeAt(2)),g=16*f(n.charCodeAt(3))+f(n.charCodeAt(4)),A=16*f(n.charCodeAt(5))+f(n.charCodeAt(6));return new h(new P(w,g,A,1))}if(s===9){const w=16*f(n.charCodeAt(1))+f(n.charCodeAt(2)),g=16*f(n.charCodeAt(3))+f(n.charCodeAt(4)),A=16*f(n.charCodeAt(5))+f(n.charCodeAt(6)),E=16*f(n.charCodeAt(7))+f(n.charCodeAt(8));return new h(new P(w,g,A,E/255))}if(s===4){const w=f(n.charCodeAt(1)),g=f(n.charCodeAt(2)),A=f(n.charCodeAt(3));return new h(new P(16*w+w,16*g+g,16*A+A))}if(s===5){const w=f(n.charCodeAt(1)),g=f(n.charCodeAt(2)),A=f(n.charCodeAt(3)),E=f(n.charCodeAt(4));return new h(new P(16*w+w,16*g+g,16*A+A,(16*E+E)/255))}return null}p.parseHex=a;function f(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=u.CSS||(u.CSS={}))})(l=h.Format||(h.Format={}))}(v||(t.$Ct=v={}))}),re(ie[37],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=void 0;class i{constructor(y,o,v,h){this.originalStart=y,this.originalLength=o,this.modifiedStart=v,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$bt=i}),re(ie[3],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=P,t.$Z=y,t.$1=o,t.$2=v,t.$3=h,t.$4=u,t.$6=p,t.$7=b,t.$8=m,t.$0=N;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function P(f){t.$X.setUnexpectedErrorHandler(f)}function y(f){if(!f||typeof f!="object")return!1;const n=f;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function o(f){u(f)||t.$X.onUnexpectedError(f)}function v(f){u(f)||t.$X.onUnexpectedExternalError(f)}function h(f){if(f instanceof Error){const{name:n,message:s}=f,w=f.stacktrace||f.stack;return{$isError:!0,name:n,message:s,stack:w,noTelemetry:d.isErrorNoTelemetry(f)}}return f}const l="Canceled";function u(f){return f instanceof c?!0:f instanceof Error&&f.name===l&&f.message===l}class c extends Error{constructor(){super(l),this.name=this.message}}t.$5=c;function p(){const f=new Error(l);return f.name=f.message,f}function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}function m(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function N(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=j;class L extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class d extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof d)return n;const s=new d;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=d;class a extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.$cb=a}),re(ie[6],se([0,1,3,9]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=y,t.$tb=o,t.$ub=v,t.$vb=h,t.$wb=l,t.$xb=u,t.$yb=c,t.$zb=p,t.$Ab=b,t.$Bb=m,t.$Cb=e,t.$Db=N,t.$Eb=j,t.top=L,t.$Gb=$,t.$Hb=a,t.$Ib=f,t.$Jb=n,t.$Kb=s,t.$Lb=w,t.$Mb=g,t.$Nb=A,t.$Ob=E,t.$Pb=R,t.$Qb=F,t.$Rb=k,t.$Sb=M,t.$Tb=S,t.$Ub=D,t.$Vb=I,t.$Wb=O,t.$Xb=G,t.$Yb=ne,t.$Zb=Z,t.$1b=Y,t.$2b=T,t.$3b=W,t.$4b=te,t.$5b=K,t.$6b=he,t.$7b=we,t.$8b=Ae,t.$$b=Se;function y(B,z=0){return B[B.length-(1+z)]}function o(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function v(B,z,C=(Q,H)=>Q===H){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let Q=0,H=B.length;Q<H;Q++)if(!C(B[Q],z[Q]))return!1;return!0}function h(B,z){const C=B.length-1;z<C&&(B[z]=B[C]),B.pop()}function l(B,z,C){return u(B.length,Q=>C(B[Q],z))}function u(B,z){let C=0,Q=B-1;for(;C<=Q;){const H=(C+Q)/2|0,J=z(H);if(J<0)C=H+1;else if(J>0)Q=H-1;else return H}return-(C+1)}function c(B,z,C){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const Q=z[Math.floor(z.length*Math.random())],H=[],J=[],U=[];for(const ee of z){const ue=C(ee,Q);ue<0?H.push(ee):ue>0?J.push(ee):U.push(ee)}return B<H.length?c(B,H,C):B<H.length+U.length?U[0]:c(B-(H.length+U.length),J,C)}function p(B,z){const C=[];let Q;for(const H of B.slice(0).sort(z))!Q||z(Q[0],H)!==0?(Q=[H],C.push(Q)):Q.push(H);return C}function*b(B,z){let C,Q;for(const H of B)Q!==void 0&&z(Q,H)?C.push(H):(C&&(yield C),C=[H]),Q=H;C&&(yield C)}function m(B,z){for(let C=0;C<=B.length;C++)z(C===0?void 0:B[C-1],C===B.length?void 0:B[C])}function e(B,z){for(let C=0;C<B.length;C++)z(C===0?void 0:B[C-1],B[C],C+1===B.length?void 0:B[C+1])}function N(B,z,C){const Q=[];function H(ee,ue,le){if(ue===0&&le.length===0)return;const fe=Q[Q.length-1];fe&&fe.start+fe.deleteCount===ee?(fe.deleteCount+=ue,fe.toInsert.push(...le)):Q.push({start:ee,deleteCount:ue,toInsert:le})}let J=0,U=0;for(;;){if(J===B.length){H(J,0,z.slice(U));break}if(U===z.length){H(J,B.length-J,[]);break}const ee=B[J],ue=z[U],le=C(ee,ue);le===0?(J+=1,U+=1):le<0?(H(J,1,[]),J+=1):le>0&&(H(J,0,[ue]),U+=1)}return Q}function j(B,z,C){const Q=N(B,z,C),H=[],J=[];for(const U of Q)H.push(...B.slice(U.start,U.start+U.deleteCount)),J.push(...U.toInsert);return{removed:H,added:J}}function L(B,z,C){if(C===0)return[];const Q=B.slice(0,C).sort(z);return d(B,z,Q,C,B.length),Q}function $(B,z,C,Q,H){return C===0?Promise.resolve([]):new Promise((J,U)=>{(async()=>{const ee=B.length,ue=B.slice(0,C).sort(z);for(let le=C,fe=Math.min(C+Q,ee);le<ee;le=fe,fe=Math.min(fe+Q,ee)){if(le>C&&await new Promise(ce=>setTimeout(ce)),H&&H.isCancellationRequested)throw new i.$5;d(B,z,ue,le,fe)}return ue})().then(J,U)})}function d(B,z,C,Q,H){for(const J=C.length;Q<H;Q++){const U=B[Q];if(z(U,C[J-1])<0){C.pop();const ee=(0,P.$kb)(C,ue=>z(U,ue)<0);C.splice(ee,0,U)}}}function a(B){return B.filter(z=>!!z)}function f(B){let z=0;for(let C=0;C<B.length;C++)B[C]&&(B[z]=B[C],z+=1);B.length=z}function n(B,z,C){B.splice(C,0,B.splice(z,1)[0])}function s(B){return!Array.isArray(B)||B.length===0}function w(B){return Array.isArray(B)&&B.length>0}function g(B,z=C=>C){const C=new Set;return B.filter(Q=>{const H=z(Q);return C.has(H)?!1:(C.add(H),!0)})}function A(B){const z=new Set;return C=>{const Q=B(C);return z.has(Q)?!1:(z.add(Q),!0)}}function E(B,z){return B.length>0?B[0]:z}function R(B,z){return B.length>0?B[B.length-1]:z}function F(B,z,C=(Q,H)=>Q===H){let Q=0;for(let H=0,J=Math.min(B.length,z.length);H<J&&C(B[H],z[H]);H++)Q++;return Q}function k(B){return[].concat(...B)}function M(B,z){let C=typeof z=="number"?B:0;typeof z=="number"?C=B:(C=0,z=B);const Q=[];if(C<=z)for(let H=C;H<z;H++)Q.push(H);else for(let H=C;H>z;H--)Q.push(H);return Q}function S(B,z,C){return B.reduce((Q,H)=>(Q[z(H)]=C?C(H):H,Q),Object.create(null))}function D(B,z){return B.push(z),()=>I(B,z)}function I(B,z){const C=B.indexOf(z);if(C>-1)return B.splice(C,1),z}function O(B,z,C){const Q=B.slice(0,z),H=B.slice(z);return Q.concat(C,H)}function G(B,z){let C;if(typeof z=="number"){let Q=z;C=()=>{const H=Math.sin(Q++)*179426549;return H-Math.floor(H)}}else C=Math.random;for(let Q=B.length-1;Q>0;Q-=1){const H=Math.floor(C()*(Q+1)),J=B[Q];B[Q]=B[H],B[H]=J}}function ne(B,z){const C=B.indexOf(z);C>-1&&(B.splice(C,1),B.unshift(z))}function Z(B,z){const C=B.indexOf(z);C>-1&&(B.splice(C,1),B.push(z))}function Y(B,z){for(const C of z)B.push(C)}function T(B,z){return Array.isArray(B)?B.map(z):z(B)}function W(B){return Array.isArray(B)?B:[B]}function te(B){return B[Math.floor(Math.random()*B.length)]}function K(B,z,C){const Q=r(B,z),H=B.length,J=C.length;B.length=H+J;for(let U=H-1;U>=Q;U--)B[U+J]=B[U];for(let U=0;U<J;U++)B[U+Q]=C[U]}function he(B,z,C,Q){const H=r(B,z);let J=B.splice(H,C);return J===void 0&&(J=[]),K(B,H,Q),J}function r(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var de;(function(B){function z(J){return J<0}B.isLessThan=z;function C(J){return J<=0}B.isLessThanOrEqual=C;function Q(J){return J>0}B.isGreaterThan=Q;function H(J){return J===0}B.isNeitherLessOrGreaterThan=H,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(de||(t.CompareResult=de={}));function we(B,z){return(C,Q)=>z(B(C),B(Q))}function Ae(...B){return(z,C)=>{for(const Q of B){const H=Q(z,C);if(!de.isNeitherLessOrGreaterThan(H))return H}return de.neitherLessOrGreaterThan}}const Fe=(B,z)=>B-z;t.$9b=Fe;const ye=(B,z)=>(0,t.$9b)(B?1:0,z?1:0);t.$0b=ye;function Se(B){return(z,C)=>-B(z,C)}class xe{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let C=this.c;for(;C<this.g.length&&z(this.g[C]);)C++;const Q=C===this.c?null:this.g.slice(this.c,C);return this.c=C,Q}takeFromEndWhile(z){let C=this.d;for(;C>=0&&z(this.g[C]);)C--;const Q=C===this.d?null:this.g.slice(C+1,this.d+1);return this.d=C,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const C=this.g.slice(this.c,this.c+z);return this.c+=z,C}}t.$_b=xe;class je{static{this.empty=new je(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(C=>(z(C),!0))}toArray(){const z=[];return this.iterate(C=>(z.push(C),!0)),z}filter(z){return new je(C=>this.iterate(Q=>z(Q)?C(Q):!0))}map(z){return new je(C=>this.iterate(Q=>C(z(Q))))}some(z){let C=!1;return this.iterate(Q=>(C=z(Q),!C)),C}findFirst(z){let C;return this.iterate(Q=>z(Q)?(C=Q,!1):!0),C}findLast(z){let C;return this.iterate(Q=>(z(Q)&&(C=Q),!0)),C}findLastMaxBy(z){let C,Q=!0;return this.iterate(H=>((Q||de.isGreaterThan(z(H,C)))&&(Q=!1,C=H),!0)),C}}t.$ac=je}),re(ie[13],se([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=P,t.$9c=y,t.$0c=o,t.$$c=v,t.$_c=h,t.$ad=l;function P(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function y(u,c="Unreachable"){throw new Error(c)}function o(u){if(!u)throw new i.$cb("Assertion Failed")}function v(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function h(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function l(u,c){let p=0;for(;p<u.length-1;){const b=u[p],m=u[p+1];if(!c(b,m))return!1;p++}return!0}}),re(ie[19],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(P,y){const o=this;let v=!1,h;return function(){if(v)return h;if(v=!0,y)try{h=P.apply(o,arguments)}finally{y()}else h=P.apply(o,arguments);return h}}}),re(ie[20],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(P){function y(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}P.is=y;const o=Object.freeze([]);function v(){return o}P.empty=v;function*h(n){yield n}P.single=h;function l(n){return y(n)?n:h(n)}P.wrap=l;function u(n){return n||o}P.from=u;function*c(n){for(let s=n.length-1;s>=0;s--)yield n[s]}P.reverse=c;function p(n){return!n||n[Symbol.iterator]().next().done===!0}P.isEmpty=p;function b(n){return n[Symbol.iterator]().next().value}P.first=b;function m(n,s){for(const w of n)if(s(w))return!0;return!1}P.some=m;function e(n,s){for(const w of n)if(s(w))return w}P.find=e;function*N(n,s){for(const w of n)s(w)&&(yield w)}P.filter=N;function*j(n,s){let w=0;for(const g of n)yield s(g,w++)}P.map=j;function*L(...n){for(const s of n)yield*s}P.concat=L;function $(n,s,w){let g=w;for(const A of n)g=s(g,A);return g}P.reduce=$;function*d(n,s,w=n.length){for(s<0&&(s+=n.length),w<0?w+=n.length:w>n.length&&(w=n.length);s<w;s++)yield n[s]}P.slice=d;function a(n,s=Number.POSITIVE_INFINITY){const w=[];if(s===0)return[w,n];const g=n[Symbol.iterator]();for(let A=0;A<s;A++){const E=g.next();if(E.done)return[w,P.empty()];w.push(E.value)}return[w,{[Symbol.iterator](){return g}}]}P.consume=a;async function f(n){const s=[];for await(const w of n)s.push(w);return Promise.resolve(s)}P.asyncToArray=f})(i||(t.Iterable=i={}))}),re(ie[38],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$jr=t.$ir=t.$hr=t.$gr=t.$fr=t.ScanCode=t.KeyCode=void 0,t.$kr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class y{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,j){this._keyCodeToStr[N]=j,this._strToKeyCode[j.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const o=new y,v=new y,h=new y;t.$fr=new Array(230),t.$gr={};const l=[],u=Object.create(null),c=Object.create(null);t.$hr={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>u[e]||0,toString:e=>l[e]||"None"},t.$ir=[],t.$jr=[];for(let e=0;e<=193;e++)t.$ir[e]=-1;for(let e=0;e<=132;e++)t.$jr[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],j=[],L=[];for(const $ of N){const[d,a,f,n,s,w,g,A,E]=$;if(L[a]||(L[a]=!0,l[a]=f,u[f]=a,c[f.toLowerCase()]=a,d&&(t.$ir[a]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$jr[n]=a))),!j[n]){if(j[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${f}`);o.define(n,s),v.define(n,A||s),h.define(n,E||A||s)}w&&(t.$fr[w]=n),g&&(t.$gr[g]=n)}t.$jr[3]=46})();var p;(function(e){function N(f){return o.keyCodeToStr(f)}e.toString=N;function j(f){return o.strToKeyCode(f)}e.fromString=j;function L(f){return v.keyCodeToStr(f)}e.toUserSettingsUS=L;function $(f){return h.keyCodeToStr(f)}e.toUserSettingsGeneral=$;function d(f){return v.strToKeyCode(f)||h.strToKeyCode(f)}e.fromUserSettings=d;function a(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(f)}e.toElectronAccelerator=a})(p||(t.KeyCodeUtils=p={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,N){const j=(N&65535)<<16>>>0;return(e|j)>>>0}}),re(ie[39],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(y){this.d=y,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(y){this.c=y}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),re(ie[21],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(o){this.element=o,this.next=i.Undefined,this.prev=i.Undefined}}class P{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let o=this.a;for(;o!==i.Undefined;){const v=o.next;o.prev=i.Undefined,o.next=i.Undefined,o=v}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,v){const h=new i(o);if(this.a===i.Undefined)this.a=h,this.b=h;else if(v){const u=this.b;this.b=h,h.prev=u,u.next=h}else{const u=this.a;this.a=h,h.next=u,u.prev=h}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(h))}}shift(){if(this.a!==i.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==i.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==i.Undefined&&o.next!==i.Undefined){const v=o.prev;v.next=o.next,o.next.prev=v}else o.prev===i.Undefined&&o.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):o.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):o.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==i.Undefined;)yield o.element,o=o.next}}t.$4c=P}),re(ie[22],se([0,1]),function(V,t){"use strict";var i,P,y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=void 0,t.$xc=o,t.$yc=v,t.$zc=h,t.$Hc=$;function o(d,a,f){let n=d.get(a);return n===void 0&&(n=f,d.set(a,n)),n}function v(d){const a=[];return d.forEach((f,n)=>{a.push(`${n} => ${f}`)}),`Map(${d.size}) {${a.join(", ")}}`}function h(d){const a=[];return d.forEach(f=>{a.push(f)}),`Set(${d.size}) {${a.join(", ")}}`}class l{constructor(a,f){this.uri=a,this.value=f}}function u(d){return Array.isArray(d)}class c{static{this.c=a=>a.toString()}constructor(a,f){if(this[i]="ResourceMap",a instanceof c)this.d=new Map(a.d),this.e=f??c.c;else if(u(a)){this.d=new Map,this.e=f??c.c;for(const[n,s]of a)this.set(n,s)}else this.d=new Map,this.e=a??c.c}set(a,f){return this.d.set(this.e(a),new l(a,f)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,f){typeof f<"u"&&(a=a.bind(f));for(const[n,s]of this.d)a(s.value,s.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Ac=c;class p{constructor(a,f){this[P]="ResourceSet",!a||typeof a=="function"?this.c=new c(a):(this.c=new c(f),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,f){this.c.forEach((n,s)=>a.call(f,s,s,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=p;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[y]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,f=0){const n=this.c.get(a);if(n)return f!==0&&this.l(n,f),n.value}set(a,f,n=0){let s=this.c.get(a);if(s)s.value=f,n!==0&&this.l(s,n);else{switch(s={key:a,value:f,next:void 0,previous:void 0},n){case 0:this.j(s);break;case 1:this.i(s);break;case 2:this.j(s);break;default:this.j(s);break}this.c.set(a,s),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const f=this.c.get(a);if(f)return this.c.delete(a),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.k(a),this.f--,a.value}forEach(a,f){const n=this.g;let s=this.d;for(;s;){if(f?a.bind(f)(s.value,s.key,this):a(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:n.key,done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return s}values(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:n.value,done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return s}entries(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:[n.key,n.value],done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return s}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let f=this.d,n=this.size;for(;f&&n>a;)this.c.delete(f.key),f=f.next,n--;this.d=f,this.f=n,f&&(f.previous=void 0),this.g++}i(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}j(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}k(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const f=a.next,n=a.previous;if(!f||!n)throw new Error("Invalid list");f.previous=n,n.next=f}a.next=void 0,a.previous=void 0,this.g++}l(a,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(a===this.d)return;const n=a.next,s=a.previous;a===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(f===2){if(a===this.e)return;const n=a.next,s=a.previous;a===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((f,n)=>{a.push([n,f])}),a}fromJSON(a){this.clear();for(const[f,n]of a)this.set(f,n)}}t.$Cc=m;class e extends m{constructor(a,f=1){super(),this.m=a,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(a){this.m=a,this.o()}get ratio(){return this.n}set ratio(a){this.n=Math.min(Math.max(0,a),1),this.o()}get(a,f=2){return super.get(a,f)}peek(a){return super.get(a,0)}set(a,f){return super.set(a,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class N{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let f=this.c.get(a)||0;return f===0?!1:(f--,f===0?this.c.delete(a):this.c.set(a,f),!0)}has(a){return this.c.has(a)}}t.$Ec=N;class j{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[f,n]of a)this.set(f,n)}clear(){this.c.clear(),this.d.clear()}set(a,f){this.c.set(a,f),this.d.set(f,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const f=this.c.get(a);return f===void 0?!1:(this.c.delete(a),this.d.delete(f),!0)}forEach(a,f){this.c.forEach((n,s)=>{a.call(f,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=j;class L{constructor(){this.c=new Map}add(a,f){let n=this.c.get(a);n||(n=new Set,this.c.set(a,n)),n.add(f)}delete(a,f){const n=this.c.get(a);n&&(n.delete(f),n.size===0&&this.c.delete(a))}forEach(a,f){const n=this.c.get(a);n&&n.forEach(f)}get(a){const f=this.c.get(a);return f||new Set}}t.$Gc=L;function $(d,a){if(d===a)return!0;if(d.size!==a.size)return!1;for(const[f,n]of d)if(!a.has(f)||a.get(f)!==n)return!1;for(const[f]of a)if(!d.has(f))return!1;return!0}}),re(ie[10],se([0,1,6,35,22,19,20]),function(V,t,i,P,y,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Ic=void 0,t.$Jc=c,t.$Kc=p,t.$Lc=b,t.$Mc=N,t.$Nc=j,t.$Oc=L,t.$Pc=$,t.$Qc=d,t.$Rc=a,t.$2c=k;const h=!1;let l=null;class u{constructor(){this.b=new Map}static{this.a=0}c(D){let I=this.b.get(D);return I||(I={parent:null,source:null,isSingleton:!1,value:D,idx:u.a++},this.b.set(D,I)),I}trackDisposable(D){const I=this.c(D);I.source||(I.source=new Error().stack)}setParent(D,I){const O=this.c(D);O.parent=I}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,I){const O=I.get(D);if(O)return O;const G=D.parent?this.f(this.c(D.parent),I):D;return I.set(D,G),G}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,D).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(D=10,I){let O;if(I)O=I;else{const T=new Map,W=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,T).isSingleton);if(W.length===0)return;const te=new Set(W.map(K=>K.value));if(O=W.filter(K=>!(K.parent&&te.has(K.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function G(T){function W(K,he){for(;K.length>0&&he.some(r=>typeof r=="string"?r===K[0]:K[0].match(r));)K.shift()}const te=T.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return W(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const ne=new y.$Gc;for(const T of O){const W=G(T);for(let te=0;te<=W.length;te++)ne.add(W.slice(0,te).join(`
`),T)}O.sort((0,i.$7b)(T=>T.idx,i.$9b));let Z="",Y=0;for(const T of O.slice(0,D)){Y++;const W=G(T),te=[];for(let K=0;K<W.length;K++){let he=W[K];he=`(shared with ${ne.get(W.slice(0,K+1).join(`
`)).size}/${O.length} leaks) at ${he}`;const de=ne.get(W.slice(0,K).join(`
`)),we=(0,P.$K)([...de].map(Ae=>G(Ae)[K]),Ae=>Ae);delete we[W[K]];for(const[Ae,Fe]of Object.entries(we))te.unshift(`    - stacktraces of ${Fe.length} other leaks continue with ${Ae}`);te.unshift(he)}Z+=`


==================== Leaking disposable ${Y}/${O.length}: ${T.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return O.length>D&&(Z+=`


... and ${O.length-D} more leaking disposables

`),{leaks:O,details:Z}}}t.$Ic=u;function c(S){l=S}if(h){const S="__is_disposable_tracked__";c(new class{trackDisposable(D){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[S]||console.log(I)},3e3)}setParent(D,I){if(D&&D!==n.None)try{D[S]=!0}catch{}}markAsDisposed(D){if(D&&D!==n.None)try{D[S]=!0}catch{}}markAsSingleton(D){}})}function p(S){return l?.trackDisposable(S),S}function b(S){l?.markAsDisposed(S)}function m(S,D){l?.setParent(S,D)}function e(S,D){if(l)for(const I of S)l.setParent(I,D)}function N(S){return l?.markAsSingleton(S),S}function j(S){return typeof S.dispose=="function"&&S.dispose.length===0}function L(S){if(v.Iterable.is(S)){const D=[];for(const I of S)if(I)try{I.dispose()}catch(O){D.push(O)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function $(S){for(const D of S)j(D)&&D.dispose();return[]}function d(...S){const D=a(()=>L(S));return e(S,D),D}function a(S){const D=p({dispose:(0,o.$db)(()=>{b(D),S()})});return D}class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return m(D,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),m(D,null))}}t.$Sc=f;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,p(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}t.$Tc=n;class s{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&m(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&m(D,null),D}}t.$Uc=s;class w{constructor(D){this.a=new s,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=w;class g{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=g;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(D){let I=D;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,b(this))},this}}t.$Xc=A;class E{constructor(){this.a=new Map}acquire(D,...I){let O=this.a.get(D);O||(O={counter:0,object:this.b(D,...I)},this.a.set(D,O));const{object:G}=O,ne=(0,o.$db)(()=>{--O.counter===0&&(this.c(D,O.object),this.a.delete(D))});return O.counter++,{object:G,dispose:ne}}}t.$Yc=E;class R{constructor(D){this.a=D}async acquire(D,...I){const O=this.a.acquire(D,...I);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(G){throw O.dispose(),G}}}t.$Zc=R;class F{constructor(D){this.object=D}dispose(){}}t.$1c=F;function k(S){const D=new f;try{S(D)}finally{D.dispose()}}class M{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,I,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(D)?.dispose(),this.a.set(D,I)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=M}),re(ie[23],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(o){return new P(o)}constructor(o){this.c=i&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$2d=P}),re(ie[11],se([0,1,3,19,10,21,23]),function(V,t,i,P,y,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$4d=t.Event=void 0,t.$5d=b;const h=!1,l=!1;var u;(function(k){k.None=()=>y.$Tc.None;function M(H){if(l){const{onDidAddListener:J}=H,U=e.create();let ee=0;H.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),J?.()}}}function S(H,J){return te(H,()=>{},0,void 0,!0,void 0,J)}k.defer=S;function D(H){return(J,U=null,ee)=>{let ue=!1,le;return le=H(fe=>{if(!ue)return le?le.dispose():ue=!0,J.call(U,fe)},null,ee),ue&&le.dispose(),le}}k.once=D;function I(H,J,U){return T((ee,ue=null,le)=>H(fe=>ee.call(ue,J(fe)),null,le),U)}k.map=I;function O(H,J,U){return T((ee,ue=null,le)=>H(fe=>{J(fe),ee.call(ue,fe)},null,le),U)}k.forEach=O;function G(H,J,U){return T((ee,ue=null,le)=>H(fe=>J(fe)&&ee.call(ue,fe),null,le),U)}k.filter=G;function ne(H){return H}k.signal=ne;function Z(...H){return(J,U=null,ee)=>{const ue=(0,y.$Qc)(...H.map(le=>le(fe=>J.call(U,fe))));return W(ue,ee)}}k.any=Z;function Y(H,J,U,ee){let ue=U;return I(H,le=>(ue=J(ue,le),ue),ee)}k.reduce=Y;function T(H,J){let U;const ee={onWillAddFirstListener(){U=H(ue.fire,ue)},onDidRemoveLastListener(){U?.dispose()}};J||M(ee);const ue=new d(ee);return J?.add(ue),ue.event}function W(H,J){return J instanceof Array?J.push(H):J&&J.add(H),H}function te(H,J,U=100,ee=!1,ue=!1,le,fe){let ce,me,Me,De=0,Pe;const Ie={leakWarningThreshold:le,onWillAddFirstListener(){ce=H(ve=>{De++,me=J(me,ve),ee&&!Me&&(ke.fire(me),me=void 0),Pe=()=>{const Oe=me;me=void 0,Me=void 0,(!ee||De>1)&&ke.fire(Oe),De=0},typeof U=="number"?(clearTimeout(Me),Me=setTimeout(Pe,U)):Me===void 0&&(Me=0,queueMicrotask(Pe))})},onWillRemoveListener(){ue&&De>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,ce.dispose()}};fe||M(Ie);const ke=new d(Ie);return fe?.add(ke),ke.event}k.debounce=te;function K(H,J=0,U){return k.debounce(H,(ee,ue)=>ee?(ee.push(ue),ee):[ue],J,void 0,!0,void 0,U)}k.accumulate=K;function he(H,J=(ee,ue)=>ee===ue,U){let ee=!0,ue;return G(H,le=>{const fe=ee||!J(le,ue);return ee=!1,ue=le,fe},U)}k.latch=he;function r(H,J,U){return[k.filter(H,J,U),k.filter(H,ee=>!J(ee),U)]}k.split=r;function de(H,J=!1,U=[],ee){let ue=U.slice(),le=H(me=>{ue?ue.push(me):ce.fire(me)});ee&&ee.add(le);const fe=()=>{ue?.forEach(me=>ce.fire(me)),ue=null},ce=new d({onWillAddFirstListener(){le||(le=H(me=>ce.fire(me)),ee&&ee.add(le))},onDidAddFirstListener(){ue&&(J?setTimeout(fe):fe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ee&&ee.add(ce),ce.event}k.buffer=de;function we(H,J){return(ee,ue,le)=>{const fe=J(new Fe);return H(function(ce){const me=fe.evaluate(ce);me!==Ae&&ee.call(ue,me)},void 0,le)}}k.chain=we;const Ae=Symbol("HaltChainable");class Fe{constructor(){this.f=[]}map(J){return this.f.push(J),this}forEach(J){return this.f.push(U=>(J(U),U)),this}filter(J){return this.f.push(U=>J(U)?U:Ae),this}reduce(J,U){let ee=U;return this.f.push(ue=>(ee=J(ee,ue),ee)),this}latch(J=(U,ee)=>U===ee){let U=!0,ee;return this.f.push(ue=>{const le=U||!J(ue,ee);return U=!1,ee=ue,le?ue:Ae}),this}evaluate(J){for(const U of this.f)if(J=U(J),J===Ae)break;return J}}function ye(H,J,U=ee=>ee){const ee=(...ce)=>fe.fire(U(...ce)),ue=()=>H.on(J,ee),le=()=>H.removeListener(J,ee),fe=new d({onWillAddFirstListener:ue,onDidRemoveLastListener:le});return fe.event}k.fromNodeEventEmitter=ye;function Se(H,J,U=ee=>ee){const ee=(...ce)=>fe.fire(U(...ce)),ue=()=>H.addEventListener(J,ee),le=()=>H.removeEventListener(J,ee),fe=new d({onWillAddFirstListener:ue,onDidRemoveLastListener:le});return fe.event}k.fromDOMEventEmitter=Se;function xe(H){return new Promise(J=>D(H)(J))}k.toPromise=xe;function je(H){const J=new d;return H.then(U=>{J.fire(U)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}k.fromPromise=je;function B(H,J,U){return J(U),H(ee=>J(ee))}k.runAndSubscribe=B;class z{constructor(J,U){this._observable=J,this.f=0,this.g=!1;const ee={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};U||M(ee),this.emitter=new d(ee),U&&U.add(this.emitter)}beginUpdate(J){this.f++}handlePossibleChange(J){}handleChange(J,U){this.g=!0}endUpdate(J){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function C(H,J){return new z(H,J).emitter.event}k.fromObservable=C;function Q(H){return(J,U,ee)=>{let ue=0,le=!1;const fe={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(H.reportChanges(),le&&(le=!1,J.call(U)))},handlePossibleChange(){},handleChange(){le=!0}};H.addObserver(fe),H.reportChanges();const ce={dispose(){H.removeObserver(fe)}};return ee instanceof y.$Sc?ee.add(ce):Array.isArray(ee)&&ee.push(ce),ce}}k.fromObservableLight=Q})(u||(t.Event=u={}));class c{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${c.f++}`,c.all.add(this)}start(M){this.g=new v.$2d,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}t.$4d=c;let p=-1;function b(k){const M=p;return p=k,{dispose(){p=M}}}class m{constructor(M,S=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=S,this.g=0}dispose(){this.f?.clear()}check(M,S){const D=this.threshold;if(D<=0||S<D)return;this.f||(this.f=new Map);const I=this.f.get(M.value)||0;if(this.f.set(M.value,I+1),this.g-=1,this.g<=0){this.g=D*.5;let O,G=0;for(const[ne,Z]of this.f)(!O||G<Z)&&(O=ne,G=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${G}):`),console.warn(O)}return()=>{const O=this.f.get(M.value)||0;this.f.set(M.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let N=0;class j{constructor(M){this.value=M,this.id=N++}}const L=2,$=(k,M)=>{if(k instanceof j)M(k);else for(let S=0;S<k.length;S++){const D=k[S];D&&M(D)}};class d{constructor(M){this.w=0,this.f=M,this.g=p>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new c(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const M=this.t;queueMicrotask(()=>{$(M,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,S,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),y.$Tc.None;if(this.m)return y.$Tc.None;S&&(M=M.bind(S));const I=new j(M);let O,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(I.stack=e.create(),O=this.g.check(I.stack,this.w+1)),h&&(I.stack=G??e.create()),this.t?this.t instanceof j?(this.u??=new f,this.t=[this.t,I]):this.t.push(I):(this.f?.onWillAddFirstListener?.(this),this.t=I,this.f?.onDidAddFirstListener?.(this)),this.w++;const ne=(0,y.$Rc)(()=>{O?.(),this.x(I)});return D instanceof y.$Sc?D.add(ne):Array.isArray(D)&&D.push(ne),ne},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,D=S.indexOf(M);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[D]=void 0;const I=this.u.current===this;if(this.w*L<=S.length){let O=0;for(let G=0;G<S.length;G++)S[G]?S[O++]=S[G]:I&&(this.u.end--,O<this.u.i&&this.u.i--);S.length=O}}y(M,S){if(!M)return;const D=this.f?.onListenerError||i.$1;if(!D){M.value(S);return}try{M.value(S)}catch(I){D(I)}}z(M){const S=M.current.t;for(;M.i<M.end;)this.y(S[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof j)this.y(this.t,M);else{const S=this.u;S.enqueue(this,M,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$6d=d;const a=()=>new f;t.$7d=a;class f{constructor(){this.i=-1,this.end=0}enqueue(M,S,D){this.i=0,this.end=D,this.current=M,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends d{async fireAsync(M,S,D){if(this.t)for(this.h||(this.h=new o.$4c),$(this.t,I=>this.h.push([I.value,M]));this.h.size>0&&!S.isCancellationRequested;){const[I,O]=this.h.shift(),G=[],ne={...O,token:S,waitUntil:Z=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");D&&(Z=D(Z,I)),G.push(Z)}};try{I(ne)}catch(Z){(0,i.$1)(Z);continue}Object.freeze(G),await Promise.allSettled(G).then(Z=>{for(const Y of Z)Y.status==="rejected"&&(0,i.$1)(Y.reason)})}}}t.$8d=n;class s extends d{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new o.$4c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}t.$9d=s;class w extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}t.$0d=w;class g extends d{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$$d=g;class A{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const S={event:M,listener:null};this.h.push(S),this.g&&this.m(S);const D=()=>{this.g&&this.o(S);const I=this.h.indexOf(S);this.h.splice(I,1)};return(0,y.$Rc)((0,P.$db)(D))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(S=>this.f.fire(S))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}t.$_d=A;class E{constructor(M,S,D,I){this.f=new y.$Sc;const O=this.f.add(new A),G=this.f.add(new y.$3c);function ne(Z){G.set(Z,O.add(I(Z)))}for(const Z of M)ne(Z);this.f.add(S(Z=>{ne(Z)})),this.f.add(D(Z=>{G.deleteAndDispose(Z)})),this.event=O.event}dispose(){this.f.dispose()}}t.$ae=E;class R{constructor(){this.f=[]}wrapEvent(M){return(S,D,I)=>M(O=>{const G=this.f[this.f.length-1];G?G.push(()=>S.call(D,O)):S.call(D,O)},void 0,I)}bufferEvents(M){const S=[];this.f.push(S);const D=M();return this.f.pop(),S.forEach(I=>I()),D}}t.$be=R;class F{constructor(){this.f=!1,this.g=u.None,this.h=y.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ce=F}),re(ie[24],se([0,1,11]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.CancellationToken=void 0;const P=Object.freeze(function(h,l){const u=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(u)}}});var y;(function(h){function l(u){return u===h.None||u===h.Cancelled||u instanceof o?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(y||(t.CancellationToken=y={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new i.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=y.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=y.None}}t.$de=v}),re(ie[40],se([0,1,24]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qe=t.$Pe=t.$Oe=void 0;class P{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new i.$de,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Oe=P;class y{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const l=JSON.stringify(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}t.$Pe=y;class o{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const l=this.b(h);return this.a.set(h,l),l}}t.$Qe=o}),re(ie[7],se([0,1,40,39]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.$Qf=t.GraphemeBreakType=t.$Gf=t.$Af=t.$tf=t.$sf=void 0,t.$Te=y,t.$Ue=v,t.$Ve=l,t.$We=u,t.$Xe=c,t.$Ye=p,t.$Ze=b,t.$1e=m,t.$2e=e,t.$3e=N,t.$4e=j,t.$5e=L,t.$6e=$,t.$7e=d,t.$8e=a,t.$9e=f,t.$0e=n,t.$$e=s,t.$_e=w,t.$af=g,t.$bf=A,t.$cf=E,t.$df=R,t.$ef=F,t.$ff=k,t.$gf=M,t.$hf=S,t.$if=D,t.$jf=I,t.$kf=O,t.$lf=G,t.$mf=ne,t.$nf=Z,t.$of=Y,t.$pf=T,t.$qf=W,t.$rf=te,t.$uf=de,t.$vf=we,t.$wf=Ae,t.$xf=Fe,t.$yf=xe,t.$zf=B,t.$Bf=z,t.$Cf=C,t.$Df=Q,t.$Ef=H,t.$Ff=ee,t.$Hf=ue,t.$If=le,t.$Jf=fe,t.$Kf=ce,t.$Lf=me,t.$Mf=Me,t.$Nf=De,t.$Of=Pe,t.$Pf=He;function y(x){return!x||typeof x!="string"?!0:x.trim().length===0}const o=/{(\d+)}/g;function v(x,...q){return q.length===0?x:x.replace(o,function(X,_){const ae=parseInt(_,10);return isNaN(ae)||ae<0||ae>=q.length?X:q[ae]})}const h=/{([^}]+)}/g;function l(x,q){return Object.keys(q).length===0?x:x.replace(h,(X,_)=>q[_]??X)}function u(x){return x.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function c(x){return x.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function p(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(x,q){let X=0;const _=q.charCodeAt(0);for(let ae=x.length-1;ae>=0;ae--)x.charCodeAt(ae)===_&&X++;return X}function m(x,q,X="\u2026"){return x.length<=q?x:`${x.substr(0,q)}${X}`}function e(x,q,X="\u2026"){if(x.length<=q)return x;const _=Math.ceil(q/2)-X.length/2,ae=Math.floor(q/2)-X.length/2;return`${x.substr(0,_)}${X}${x.substr(x.length-ae)}`}function N(x,q=" "){const X=j(x,q);return L(X,q)}function j(x,q){if(!x||!q)return x;const X=q.length;if(X===0||x.length===0)return x;let _=0;for(;x.indexOf(q,_)===_;)_=_+X;return x.substring(_)}function L(x,q){if(!x||!q)return x;const X=q.length,_=x.length;if(X===0||_===0)return x;let ae=_,oe=-1;for(;oe=x.lastIndexOf(q,ae-1),!(oe===-1||oe+X!==ae);){if(oe===0)return"";ae=oe}return x.substring(0,ae)}function $(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(x){return x.replace(/\*/g,"")}function a(x,q,X={}){if(!x)throw new Error("Cannot create regex from empty string");q||(x=p(x)),X.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let _="";return X.global&&(_+="g"),X.matchCase||(_+="i"),X.multiline&&(_+="m"),X.unicode&&(_+="u"),new RegExp(x,_)}function f(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}function n(x){return x.split(/\r\n|\r|\n/)}function s(x){const q=[],X=x.split(/(\r\n|\r|\n)/);for(let _=0;_<Math.ceil(X.length/2);_++)q.push(X[2*_]+(X[2*_+1]??""));return q}function w(x){for(let q=0,X=x.length;q<X;q++){const _=x.charCodeAt(q);if(_!==32&&_!==9)return q}return-1}function g(x,q=0,X=x.length){for(let _=q;_<X;_++){const ae=x.charCodeAt(_);if(ae!==32&&ae!==9)return x.substring(q,_)}return x.substring(q,X)}function A(x,q=x.length-1){for(let X=q;X>=0;X--){const _=x.charCodeAt(X);if(_!==32&&_!==9)return X}return-1}function E(x,q,X){const _=[];let ae=0;for(const oe of x.matchAll(q)){if(_.push(x.slice(ae,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ae=oe.index+oe[0].length,_.push(X(oe[0],...oe.slice(1),oe.index,x,oe.groups))}return _.push(x.slice(ae)),Promise.all(_).then(oe=>oe.join(""))}function R(x,q){return x<q?-1:x>q?1:0}function F(x,q,X=0,_=x.length,ae=0,oe=q.length){for(;X<_&&ae<oe;X++,ae++){const Le=x.charCodeAt(X),Ne=q.charCodeAt(ae);if(Le<Ne)return-1;if(Le>Ne)return 1}const be=_-X,Ee=oe-ae;return be<Ee?-1:be>Ee?1:0}function k(x,q){return M(x,q,0,x.length,0,q.length)}function M(x,q,X=0,_=x.length,ae=0,oe=q.length){for(;X<_&&ae<oe;X++,ae++){let Le=x.charCodeAt(X),Ne=q.charCodeAt(ae);if(Le===Ne)continue;if(Le>=128||Ne>=128)return F(x.toLowerCase(),q.toLowerCase(),X,_,ae,oe);D(Le)&&(Le-=32),D(Ne)&&(Ne-=32);const $e=Le-Ne;if($e!==0)return $e}const be=_-X,Ee=oe-ae;return be<Ee?-1:be>Ee?1:0}function S(x){return x>=48&&x<=57}function D(x){return x>=97&&x<=122}function I(x){return x>=65&&x<=90}function O(x,q){return x.length===q.length&&M(x,q)===0}function G(x,q){const X=q.length;return q.length>x.length?!1:M(x,q,0,X)===0}function ne(x,q){const X=Math.min(x.length,q.length);let _;for(_=0;_<X;_++)if(x.charCodeAt(_)!==q.charCodeAt(_))return _;return X}function Z(x,q){const X=Math.min(x.length,q.length);let _;const ae=x.length-1,oe=q.length-1;for(_=0;_<X;_++)if(x.charCodeAt(ae-_)!==q.charCodeAt(oe-_))return _;return X}function Y(x){return 55296<=x&&x<=56319}function T(x){return 56320<=x&&x<=57343}function W(x,q){return(x-55296<<10)+(q-56320)+65536}function te(x,q,X){const _=x.charCodeAt(X);if(Y(_)&&X+1<q){const ae=x.charCodeAt(X+1);if(T(ae))return W(_,ae)}return _}function K(x,q){const X=x.charCodeAt(q-1);if(T(X)&&q>1){const _=x.charCodeAt(q-2);if(Y(_))return W(_,X)}return X}class he{get offset(){return this.e}constructor(q,X=0){this.c=q,this.d=q.length,this.e=X}setOffset(q){this.e=q}prevCodePoint(){const q=K(this.c,this.e);return this.e-=q>=65536?2:1,q}nextCodePoint(){const q=te(this.c,this.d,this.e);return this.e+=q>=65536?2:1,q}eol(){return this.e>=this.d}}t.$sf=he;class r{get offset(){return this.c.offset}constructor(q,X=0){this.c=new he(q,X)}nextGraphemeLength(){const q=ve.getInstance(),X=this.c,_=X.offset;let ae=q.getGraphemeBreakType(X.nextCodePoint());for(;!X.eol();){const oe=X.offset,be=q.getGraphemeBreakType(X.nextCodePoint());if(Ie(ae,be)){X.setOffset(oe);break}ae=be}return X.offset-_}prevGraphemeLength(){const q=ve.getInstance(),X=this.c,_=X.offset;let ae=q.getGraphemeBreakType(X.prevCodePoint());for(;X.offset>0;){const oe=X.offset,be=q.getGraphemeBreakType(X.prevCodePoint());if(Ie(be,ae)){X.setOffset(oe);break}ae=be}return _-X.offset}eol(){return this.c.eol()}}t.$tf=r;function de(x,q){return new r(x,q).nextGraphemeLength()}function we(x,q){return new r(x,q).prevGraphemeLength()}function Ae(x,q){q>0&&T(x.charCodeAt(q))&&q--;const X=q+de(x,q);return[X-we(x,X),X]}function Fe(x){const q=new r(x);let X=0;for(;!q.eol();)X++,q.nextGraphemeLength();return X}let ye;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function xe(x){return ye||(ye=Se()),ye.test(x)}const je=/^[\t\n\r\x20-\x7E]*$/;function B(x){return je.test(x)}t.$Af=/[\u2028\u2029]/;function z(x){return t.$Af.test(x)}function C(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}function Q(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}function H(x,q,X=""){const _=x.trimStart();if(_.length<q)return _;const ae=/\b/g;let oe=0;for(;ae.test(_)&&!(_.length-ae.lastIndex<q);)oe=ae.lastIndex,ae.lastIndex+=1;return oe===0?_:X+_.substring(oe).trimStart()}const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,U=/\x1b\].*?\x07/g;function ee(x){return x&&(x=x.replace(J,"").replace(U,"")),x}t.$Gf="\uFEFF";function ue(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}function le(x){return ue(x)?x.substr(1):x}function fe(x,q){if(!x||!q||x.length<q.length)return!1;const X=q.length,_=x.toLowerCase();let ae=0,oe=-1;for(;ae<X;){const be=_.indexOf(q[ae],oe+1);if(be<0)return!1;oe=be,ae++}return!0}function ce(x,q=!1){return x?(q&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}function me(x){return x.charAt(0).toUpperCase()+x.slice(1)}function Me(x,q=1){if(q===0)return"";let X=-1;do X=x.indexOf(`
`,X+1),q--;while(q>0&&X>=0);return X===-1?x:(x[X-1]==="\r"&&X--,x.substr(0,X))}function De(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}function Pe(x){return ve.getInstance().getGraphemeBreakType(x)}function Ie(x,q){return x===0?q!==5&&q!==7:x===2&&q===3?!1:x===4||x===2||x===3||q===4||q===2||q===3?!0:!(x===8&&(q===8||q===9||q===11||q===12)||(x===11||x===9)&&(q===9||q===10)||(x===12||x===10)&&q===10||q===5||q===13||q===7||x===1||x===13&&q===14||x===6&&q===6)}var ke;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Oe()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const X=this.d,_=X.length/3;let ae=1;for(;ae<=_;)if(q<X[3*ae])ae=2*ae;else if(q>X[3*ae+1])ae=2*ae+1;else return X[3*ae+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(x,q){if(x===0)return 0;const X=Ge(x,q);if(X!==void 0)return X;const _=new he(q,x);return _.prevCodePoint(),_.offset}function Ge(x,q){const X=new he(q,x);let _=X.prevCodePoint();for(;Xe(_)||_===65039||_===8419;){if(X.offset===0)return;_=X.prevCodePoint()}if(!Q(_))return;let ae=X.offset;return ae>0&&X.prevCodePoint()===8205&&(ae=X.offset),ae}function Xe(x){return 127995<=x&&x<=127999}var We;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$Qf="\xA0";class Te{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Pe(q=>{function X($e){const Re=new Map;for(let pe=0;pe<$e.length;pe+=2)Re.set($e[pe],$e[pe+1]);return Re}function _($e,Re){const pe=new Map($e);for(const[Be,Ve]of Re)pe.set(Be,Ve);return pe}function ae($e,Re){if(!$e)return Re;const pe=new Map;for(const[Be,Ve]of $e)Re.has(Be)&&pe.set(Be,Ve);return pe}const oe=this.c.value;let be=q.filter($e=>!$e.startsWith("_")&&$e in oe);be.length===0&&(be=["_default"]);let Ee;for(const $e of be){const Re=X(oe[$e]);Ee=ae(Ee,Re)}const Le=X(oe._common),Ne=_(Le,Ee);return new Te(Ne)})}static getInstance(q){return Te.d.get(Array.from(q))}static{this.e=new P.$V(()=>Object.keys(Te.c.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Te.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Rf=Te;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(q){return qe.e().has(q)}static get codePoints(){return qe.e()}}t.$Sf=qe}),re(ie[41],se([0,1,7]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aj=t.$$i=void 0,t.$7i=P,t.$8i=y,t.$9i=o,t.$0i=h,t.$_i=N;function P(L){return y(L,0)}function y(L,$){switch(typeof L){case"object":return L===null?o(349,$):Array.isArray(L)?l(L,$):u(L,$);case"string":return h(L,$);case"boolean":return v(L,$);case"number":return o(L,$);case"undefined":return o(937,$);default:return o(617,$)}}function o(L,$){return($<<5)-$+L|0}function v(L,$){return o(L?433:863,$)}function h(L,$){$=o(149417,$);for(let d=0,a=L.length;d<a;d++)$=o(L.charCodeAt(d),$);return $}function l(L,$){return $=o(104579,$),L.reduce((d,a)=>y(a,d),$)}function u(L,$){return $=o(181387,$),Object.keys(L).sort().reduce((d,a)=>(d=h(a,d),y(L[a],d)),$)}class c{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}t.$$i=c;var p;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function b(L,$,d=32){const a=d-$,f=~((1<<a)-1);return(L<<$|(f&L)>>>a)>>>0}function m(L,$=0,d=L.byteLength,a=0){for(let f=0;f<d;f++)L[$+f]=a}function e(L,$,d="0"){for(;L.length<$;)L=d+L;return L}function N(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}class j{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const d=$.length;if(d===0)return;const a=this.p;let f=this.r,n=this.u,s,w;for(n!==0?(s=n,w=-1,n=0):(s=$.charCodeAt(0),w=0);;){let g=s;if(i.$of(s))if(w+1<d){const A=$.charCodeAt(w+1);i.$pf(A)?(w++,g=i.$qf(s,A)):g=65533}else{n=s;break}else i.$pf(s)&&(g=65533);if(f=this.w(a,f,g),w++,w<d)s=$.charCodeAt(w);else break}this.r=f,this.u=n}w($,d,a){return a<128?$[d++]=a:a<2048?($[d++]=192|(a&1984)>>>6,$[d++]=128|(a&63)>>>0):a<65536?($[d++]=224|(a&61440)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0):($[d++]=240|(a&1835008)>>>18,$[d++]=128|(a&258048)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=j.g,d=this.q;for(let R=0;R<64;R+=4)$.setUint32(R,d.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)$.setUint32(R,b($.getUint32(R-12,!1)^$.getUint32(R-32,!1)^$.getUint32(R-56,!1)^$.getUint32(R-64,!1),1),!1);let a=this.h,f=this.l,n=this.m,s=this.n,w=this.o,g,A,E;for(let R=0;R<80;R++)R<20?(g=f&n|~f&s,A=1518500249):R<40?(g=f^n^s,A=1859775393):R<60?(g=f&n|f&s|n&s,A=2400959708):(g=f^n^s,A=3395469782),E=b(a,5)+g+w+A+$.getUint32(R*4,!1)&4294967295,w=s,s=n,n=b(f,30),f=a,a=E;this.h=this.h+a&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+w&4294967295}}t.$aj=j}),re(ie[25],se([0,1,37,41]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.$ct=void 0,t.$dt=o;class y{constructor(b){this.a=b}getElements(){const b=this.a,m=new Int32Array(b.length);for(let e=0,N=b.length;e<N;e++)m[e]=b.charCodeAt(e);return m}}t.$ct=y;function o(p,b,m){return new c(new y(p),new y(b)).ComputeDiff(m).changes}class v{static Assert(b,m){if(!b)throw new Error(m)}}class h{static Copy(b,m,e,N,j){for(let L=0;L<j;L++)e[N+L]=b[m+L]}static Copy2(b,m,e,N,j){for(let L=0;L<j;L++)e[N+L]=b[m+L]}}var l;(function(p){p[p.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$bt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(b,m,e=null){this.a=e,this.b=b,this.c=m;const[N,j,L]=c.o(b),[$,d,a]=c.o(m);this.d=L&&a,this.e=N,this.f=j,this.g=$,this.h=d,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const m=b.getElements();if(c.n(m)){const e=new Int32Array(m.length);for(let N=0,j=m.length;N<j;N++)e[N]=(0,P.$0i)(m[N],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(b,m){return this.f[b]!==this.h[m]?!1:this.d?this.e[b]===this.g[m]:!0}q(b,m){if(!this.p(b,m))return!1;const e=c.r(this.b,b),N=c.r(this.c,m);return e===N}static r(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}s(b,m){return this.f[b]!==this.f[m]?!1:this.d?this.e[b]===this.e[m]:!0}u(b,m){return this.h[b]!==this.h[m]?!1:this.d?this.g[b]===this.g[m]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,m,e,N,j){const L=[!1];let $=this.w(b,m,e,N,L);return j&&($=this.z($)),{quitEarly:L[0],changes:$}}w(b,m,e,N,j){for(j[0]=!1;b<=m&&e<=N&&this.p(b,e);)b++,e++;for(;m>=b&&N>=e&&this.p(m,N);)m--,N--;if(b>m||e>N){let n;return e<=N?(v.Assert(b===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$bt(b,0,e,N-e+1)]):b<=m?(v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$bt(b,m-b+1,e,0)]):(v.Assert(b===m+1,"originalStart should only be one more than originalEnd"),v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const L=[0],$=[0],d=this.y(b,m,e,N,L,$,j),a=L[0],f=$[0];if(d!==null)return d;if(!j[0]){const n=this.w(b,a,e,f,j);let s=[];return j[0]?s=[new i.$bt(a+1,m-(a+1)+1,f+1,N-(f+1)+1)]:s=this.w(a+1,m,f+1,N,j),this.H(n,s)}return[new i.$bt(b,m-b+1,e,N-e+1)]}x(b,m,e,N,j,L,$,d,a,f,n,s,w,g,A,E,R,F){let k=null,M=null,S=new u,D=m,I=e,O=w[0]-E[0]-N,G=-1073741824,ne=this.k.length-1;do{const Z=O+b;Z===D||Z<I&&a[Z-1]<a[Z+1]?(n=a[Z+1],g=n-O-N,n<G&&S.MarkNextChange(),G=n,S.AddModifiedElement(n+1,g),O=Z+1-b):(n=a[Z-1]+1,g=n-O-N,n<G&&S.MarkNextChange(),G=n-1,S.AddOriginalElement(n,g+1),O=Z-1-b),ne>=0&&(a=this.k[ne],b=a[0],D=1,I=a.length-1)}while(--ne>=-1);if(k=S.getReverseChanges(),F[0]){let Z=w[0]+1,Y=E[0]+1;if(k!==null&&k.length>0){const T=k[k.length-1];Z=Math.max(Z,T.getOriginalEnd()),Y=Math.max(Y,T.getModifiedEnd())}M=[new i.$bt(Z,s-Z+1,Y,A-Y+1)]}else{S=new u,D=L,I=$,O=w[0]-E[0]-d,G=1073741824,ne=R?this.m.length-1:this.m.length-2;do{const Z=O+j;Z===D||Z<I&&f[Z-1]>=f[Z+1]?(n=f[Z+1]-1,g=n-O-d,n>G&&S.MarkNextChange(),G=n+1,S.AddOriginalElement(n+1,g+1),O=Z+1-j):(n=f[Z-1],g=n-O-d,n>G&&S.MarkNextChange(),G=n,S.AddModifiedElement(n+1,g+1),O=Z-1-j),ne>=0&&(f=this.m[ne],j=f[0],D=1,I=f.length-1)}while(--ne>=-1);M=S.getChanges()}return this.H(k,M)}y(b,m,e,N,j,L,$){let d=0,a=0,f=0,n=0,s=0,w=0;b--,e--,j[0]=0,L[0]=0,this.k=[],this.m=[];const g=m-b+(N-e),A=g+1,E=new Int32Array(A),R=new Int32Array(A),F=N-e,k=m-b,M=b-e,S=m-N,I=(k-F)%2===0;E[F]=b,R[k]=m,$[0]=!1;for(let O=1;O<=g/2+1;O++){let G=0,ne=0;f=this.J(F-O,O,F,A),n=this.J(F+O,O,F,A);for(let Y=f;Y<=n;Y+=2){Y===f||Y<n&&E[Y-1]<E[Y+1]?d=E[Y+1]:d=E[Y-1]+1,a=d-(Y-F)-M;const T=d;for(;d<m&&a<N&&this.p(d+1,a+1);)d++,a++;if(E[Y]=d,d+a>G+ne&&(G=d,ne=a),!I&&Math.abs(Y-k)<=O-1&&d>=R[Y])return j[0]=d,L[0]=a,T<=R[Y]&&1447>0&&O<=1448?this.x(F,f,n,M,k,s,w,S,E,R,d,m,j,a,N,L,I,$):null}const Z=(G-b+(ne-e)-O)/2;if(this.a!==null&&!this.a(G,Z))return $[0]=!0,j[0]=G,L[0]=ne,Z>0&&1447>0&&O<=1448?this.x(F,f,n,M,k,s,w,S,E,R,d,m,j,a,N,L,I,$):(b++,e++,[new i.$bt(b,m-b+1,e,N-e+1)]);s=this.J(k-O,O,k,A),w=this.J(k+O,O,k,A);for(let Y=s;Y<=w;Y+=2){Y===s||Y<w&&R[Y-1]>=R[Y+1]?d=R[Y+1]-1:d=R[Y-1],a=d-(Y-k)-S;const T=d;for(;d>b&&a>e&&this.p(d,a);)d--,a--;if(R[Y]=d,I&&Math.abs(Y-F)<=O&&d<=E[Y])return j[0]=d,L[0]=a,T>=E[Y]&&1447>0&&O<=1448?this.x(F,f,n,M,k,s,w,S,E,R,d,m,j,a,N,L,I,$):null}if(O<=1447){let Y=new Int32Array(n-f+2);Y[0]=F-f+1,h.Copy2(E,f,Y,1,n-f+1),this.k.push(Y),Y=new Int32Array(w-s+2),Y[0]=k-s+1,h.Copy2(R,s,Y,1,w-s+1),this.m.push(Y)}}return this.x(F,f,n,M,k,s,w,S,E,R,d,m,j,a,N,L,I,$)}z(b){for(let m=0;m<b.length;m++){const e=b[m],N=m<b.length-1?b[m+1].originalStart:this.f.length,j=m<b.length-1?b[m+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<j&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const d=[null];if(m<b.length-1&&this.I(b[m],b[m+1],d)){b[m]=d[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let N=0,j=0;if(m>0){const n=b[m-1];N=n.originalStart+n.originalLength,j=n.modifiedStart+n.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let d=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,w=e.modifiedStart-n;if(s<N||w<j||L&&!this.s(s,s+e.originalLength)||$&&!this.u(w,w+e.modifiedLength))break;const A=(s===N&&w===j?5:0)+this.G(s,e.originalLength,w,e.modifiedLength);A>a&&(a=A,d=n)}e.originalStart-=d,e.modifiedStart-=d;const f=[null];if(m>0&&this.I(b[m-1],b[m],f)){b[m-1]=f[0],b.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=b.length;m<e;m++){const N=b[m-1],j=b[m],L=j.originalStart-N.originalStart-N.originalLength,$=N.originalStart,d=j.originalStart+j.originalLength,a=d-$,f=N.modifiedStart,n=j.modifiedStart+j.modifiedLength,s=n-f;if(L<5&&a<20&&s<20){const w=this.A($,a,f,s,L);if(w){const[g,A]=w;(g!==N.originalStart+N.originalLength||A!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=g-N.originalStart,N.modifiedLength=A-N.modifiedStart,j.originalStart=g+L,j.modifiedStart=A+L,j.originalLength=d-j.originalStart,j.modifiedLength=n-j.modifiedStart)}}}return b}A(b,m,e,N,j){if(m<j||N<j)return null;const L=b+m-j+1,$=e+N-j+1;let d=0,a=0,f=0;for(let n=b;n<L;n++)for(let s=e;s<$;s++){const w=this.B(n,s,j);w>0&&w>d&&(d=w,a=n,f=s)}return d>0?[a,f]:null}B(b,m,e){let N=0;for(let j=0;j<e;j++){if(!this.p(b+j,m+j))return 0;N+=this.e[b+j].length}return N}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,m){if(this.C(b)||this.C(b-1))return!0;if(m>0){const e=b+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,m){if(this.E(b)||this.E(b-1))return!0;if(m>0){const e=b+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,m,e,N){const j=this.D(b,m)?1:0,L=this.F(e,N)?1:0;return j+L}H(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.I(b[b.length-1],m[0],e)){const N=new Array(b.length+m.length-1);return h.Copy(b,0,N,0,b.length-1),N[b.length-1]=e[0],h.Copy(m,1,N,b.length,m.length-1),N}else{const N=new Array(b.length+m.length);return h.Copy(b,0,N,0,b.length),h.Copy(m,0,N,b.length,m.length),N}}I(b,m,e){if(v.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),v.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const N=b.originalStart;let j=b.originalLength;const L=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(j=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new i.$bt(N,j,L,$),!0}else return e[0]=null,!1}J(b,m,e,N){if(b>=0&&b<N)return b;const j=e,L=N-e-1,$=m%2===0;if(b<0){const d=j%2===0;return $===d?0:1}else{const d=L%2===0;return $===d?N-1:N-2}}}t.$et=c}),re(ie[26],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=i,t.$Uf=P,t.$Vf=y,t.$Wf=o,t.$Xf=v,t.$Yf=h,t.$Zf=l,t.$1f=u,t.$2f=c,t.$3f=p,t.$4f=b,t.$5f=m,t.$6f=e,t.$7f=j,t.$8f=L,t.$9f=$,t.$0f=d,t.$$f=a;function i(f){return typeof f=="string"}function P(f){return Array.isArray(f)&&f.every(n=>i(n))}function y(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function o(f){const n=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof n}function v(f){return typeof f=="number"&&!isNaN(f)}function h(f){return!!f&&typeof f[Symbol.iterator]=="function"}function l(f){return f===!0||f===!1}function u(f){return typeof f>"u"}function c(f){return!p(f)}function p(f){return u(f)||f===null}function b(f,n){if(!f)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function m(f){if(p(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function e(...f){const n=[];for(let s=0;s<f.length;s++){const w=f[s];if(p(w))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(w)}return n}const N=Object.prototype.hasOwnProperty;function j(f){if(!y(f))return!1;for(const n in f)if(N.call(f,n))return!1;return!0}function L(f){return typeof f=="function"}function $(...f){return f.length>0&&f.every(L)}function d(f,n){const s=Math.min(f.length,n.length);for(let w=0;w<s;w++)a(f[w],n[w])}function a(f,n){if(i(n)){if(typeof f!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(L(n)){try{if(f instanceof n)return}catch{}if(!p(f)&&f.constructor===n||n.length===1&&n.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),re(ie[27],se([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=y,t.$Bj=o;const P=Object.create(null);function y(v,h){if((0,i.$Tf)(h)){const l=P[h];if(l===void 0)throw new Error(`${v} references an unknown codicon: ${h}`);h=l}return P[v]=h,{id:v}}function o(){return P}}),re(ie[42],se([0,1,27]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=void 0,t.$Cj={add:(0,i.$Aj)("add",6e4),plus:(0,i.$Aj)("plus",6e4),gistNew:(0,i.$Aj)("gist-new",6e4),repoCreate:(0,i.$Aj)("repo-create",6e4),lightbulb:(0,i.$Aj)("lightbulb",60001),lightBulb:(0,i.$Aj)("light-bulb",60001),repo:(0,i.$Aj)("repo",60002),repoDelete:(0,i.$Aj)("repo-delete",60002),gistFork:(0,i.$Aj)("gist-fork",60003),repoForked:(0,i.$Aj)("repo-forked",60003),gitPullRequest:(0,i.$Aj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Aj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Aj)("record-keys",60005),keyboard:(0,i.$Aj)("keyboard",60005),tag:(0,i.$Aj)("tag",60006),gitPullRequestLabel:(0,i.$Aj)("git-pull-request-label",60006),tagAdd:(0,i.$Aj)("tag-add",60006),tagRemove:(0,i.$Aj)("tag-remove",60006),person:(0,i.$Aj)("person",60007),personFollow:(0,i.$Aj)("person-follow",60007),personOutline:(0,i.$Aj)("person-outline",60007),personFilled:(0,i.$Aj)("person-filled",60007),gitBranch:(0,i.$Aj)("git-branch",60008),gitBranchCreate:(0,i.$Aj)("git-branch-create",60008),gitBranchDelete:(0,i.$Aj)("git-branch-delete",60008),sourceControl:(0,i.$Aj)("source-control",60008),mirror:(0,i.$Aj)("mirror",60009),mirrorPublic:(0,i.$Aj)("mirror-public",60009),star:(0,i.$Aj)("star",60010),starAdd:(0,i.$Aj)("star-add",60010),starDelete:(0,i.$Aj)("star-delete",60010),starEmpty:(0,i.$Aj)("star-empty",60010),comment:(0,i.$Aj)("comment",60011),commentAdd:(0,i.$Aj)("comment-add",60011),alert:(0,i.$Aj)("alert",60012),warning:(0,i.$Aj)("warning",60012),search:(0,i.$Aj)("search",60013),searchSave:(0,i.$Aj)("search-save",60013),logOut:(0,i.$Aj)("log-out",60014),signOut:(0,i.$Aj)("sign-out",60014),logIn:(0,i.$Aj)("log-in",60015),signIn:(0,i.$Aj)("sign-in",60015),eye:(0,i.$Aj)("eye",60016),eyeUnwatch:(0,i.$Aj)("eye-unwatch",60016),eyeWatch:(0,i.$Aj)("eye-watch",60016),circleFilled:(0,i.$Aj)("circle-filled",60017),primitiveDot:(0,i.$Aj)("primitive-dot",60017),closeDirty:(0,i.$Aj)("close-dirty",60017),debugBreakpoint:(0,i.$Aj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Aj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Aj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Aj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Aj)("primitive-square",60018),edit:(0,i.$Aj)("edit",60019),pencil:(0,i.$Aj)("pencil",60019),info:(0,i.$Aj)("info",60020),issueOpened:(0,i.$Aj)("issue-opened",60020),gistPrivate:(0,i.$Aj)("gist-private",60021),gitForkPrivate:(0,i.$Aj)("git-fork-private",60021),lock:(0,i.$Aj)("lock",60021),mirrorPrivate:(0,i.$Aj)("mirror-private",60021),close:(0,i.$Aj)("close",60022),removeClose:(0,i.$Aj)("remove-close",60022),x:(0,i.$Aj)("x",60022),repoSync:(0,i.$Aj)("repo-sync",60023),sync:(0,i.$Aj)("sync",60023),clone:(0,i.$Aj)("clone",60024),desktopDownload:(0,i.$Aj)("desktop-download",60024),beaker:(0,i.$Aj)("beaker",60025),microscope:(0,i.$Aj)("microscope",60025),vm:(0,i.$Aj)("vm",60026),deviceDesktop:(0,i.$Aj)("device-desktop",60026),file:(0,i.$Aj)("file",60027),fileText:(0,i.$Aj)("file-text",60027),more:(0,i.$Aj)("more",60028),ellipsis:(0,i.$Aj)("ellipsis",60028),kebabHorizontal:(0,i.$Aj)("kebab-horizontal",60028),mailReply:(0,i.$Aj)("mail-reply",60029),reply:(0,i.$Aj)("reply",60029),organization:(0,i.$Aj)("organization",60030),organizationFilled:(0,i.$Aj)("organization-filled",60030),organizationOutline:(0,i.$Aj)("organization-outline",60030),newFile:(0,i.$Aj)("new-file",60031),fileAdd:(0,i.$Aj)("file-add",60031),newFolder:(0,i.$Aj)("new-folder",60032),fileDirectoryCreate:(0,i.$Aj)("file-directory-create",60032),trash:(0,i.$Aj)("trash",60033),trashcan:(0,i.$Aj)("trashcan",60033),history:(0,i.$Aj)("history",60034),clock:(0,i.$Aj)("clock",60034),folder:(0,i.$Aj)("folder",60035),fileDirectory:(0,i.$Aj)("file-directory",60035),symbolFolder:(0,i.$Aj)("symbol-folder",60035),logoGithub:(0,i.$Aj)("logo-github",60036),markGithub:(0,i.$Aj)("mark-github",60036),github:(0,i.$Aj)("github",60036),terminal:(0,i.$Aj)("terminal",60037),console:(0,i.$Aj)("console",60037),repl:(0,i.$Aj)("repl",60037),zap:(0,i.$Aj)("zap",60038),symbolEvent:(0,i.$Aj)("symbol-event",60038),error:(0,i.$Aj)("error",60039),stop:(0,i.$Aj)("stop",60039),variable:(0,i.$Aj)("variable",60040),symbolVariable:(0,i.$Aj)("symbol-variable",60040),array:(0,i.$Aj)("array",60042),symbolArray:(0,i.$Aj)("symbol-array",60042),symbolModule:(0,i.$Aj)("symbol-module",60043),symbolPackage:(0,i.$Aj)("symbol-package",60043),symbolNamespace:(0,i.$Aj)("symbol-namespace",60043),symbolObject:(0,i.$Aj)("symbol-object",60043),symbolMethod:(0,i.$Aj)("symbol-method",60044),symbolFunction:(0,i.$Aj)("symbol-function",60044),symbolConstructor:(0,i.$Aj)("symbol-constructor",60044),symbolBoolean:(0,i.$Aj)("symbol-boolean",60047),symbolNull:(0,i.$Aj)("symbol-null",60047),symbolNumeric:(0,i.$Aj)("symbol-numeric",60048),symbolNumber:(0,i.$Aj)("symbol-number",60048),symbolStructure:(0,i.$Aj)("symbol-structure",60049),symbolStruct:(0,i.$Aj)("symbol-struct",60049),symbolParameter:(0,i.$Aj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Aj)("symbol-type-parameter",60050),symbolKey:(0,i.$Aj)("symbol-key",60051),symbolText:(0,i.$Aj)("symbol-text",60051),symbolReference:(0,i.$Aj)("symbol-reference",60052),goToFile:(0,i.$Aj)("go-to-file",60052),symbolEnum:(0,i.$Aj)("symbol-enum",60053),symbolValue:(0,i.$Aj)("symbol-value",60053),symbolRuler:(0,i.$Aj)("symbol-ruler",60054),symbolUnit:(0,i.$Aj)("symbol-unit",60054),activateBreakpoints:(0,i.$Aj)("activate-breakpoints",60055),archive:(0,i.$Aj)("archive",60056),arrowBoth:(0,i.$Aj)("arrow-both",60057),arrowDown:(0,i.$Aj)("arrow-down",60058),arrowLeft:(0,i.$Aj)("arrow-left",60059),arrowRight:(0,i.$Aj)("arrow-right",60060),arrowSmallDown:(0,i.$Aj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Aj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Aj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Aj)("arrow-small-up",60064),arrowUp:(0,i.$Aj)("arrow-up",60065),bell:(0,i.$Aj)("bell",60066),bold:(0,i.$Aj)("bold",60067),book:(0,i.$Aj)("book",60068),bookmark:(0,i.$Aj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Aj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Aj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Aj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Aj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Aj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Aj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Aj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Aj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Aj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Aj)("briefcase",60076),broadcast:(0,i.$Aj)("broadcast",60077),browser:(0,i.$Aj)("browser",60078),bug:(0,i.$Aj)("bug",60079),calendar:(0,i.$Aj)("calendar",60080),caseSensitive:(0,i.$Aj)("case-sensitive",60081),check:(0,i.$Aj)("check",60082),checklist:(0,i.$Aj)("checklist",60083),chevronDown:(0,i.$Aj)("chevron-down",60084),chevronLeft:(0,i.$Aj)("chevron-left",60085),chevronRight:(0,i.$Aj)("chevron-right",60086),chevronUp:(0,i.$Aj)("chevron-up",60087),chromeClose:(0,i.$Aj)("chrome-close",60088),chromeMaximize:(0,i.$Aj)("chrome-maximize",60089),chromeMinimize:(0,i.$Aj)("chrome-minimize",60090),chromeRestore:(0,i.$Aj)("chrome-restore",60091),circleOutline:(0,i.$Aj)("circle-outline",60092),circle:(0,i.$Aj)("circle",60092),debugBreakpointUnverified:(0,i.$Aj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Aj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Aj)("circle-slash",60093),circuitBoard:(0,i.$Aj)("circuit-board",60094),clearAll:(0,i.$Aj)("clear-all",60095),clippy:(0,i.$Aj)("clippy",60096),closeAll:(0,i.$Aj)("close-all",60097),cloudDownload:(0,i.$Aj)("cloud-download",60098),cloudUpload:(0,i.$Aj)("cloud-upload",60099),code:(0,i.$Aj)("code",60100),collapseAll:(0,i.$Aj)("collapse-all",60101),colorMode:(0,i.$Aj)("color-mode",60102),commentDiscussion:(0,i.$Aj)("comment-discussion",60103),creditCard:(0,i.$Aj)("credit-card",60105),dash:(0,i.$Aj)("dash",60108),dashboard:(0,i.$Aj)("dashboard",60109),database:(0,i.$Aj)("database",60110),debugContinue:(0,i.$Aj)("debug-continue",60111),debugDisconnect:(0,i.$Aj)("debug-disconnect",60112),debugPause:(0,i.$Aj)("debug-pause",60113),debugRestart:(0,i.$Aj)("debug-restart",60114),debugStart:(0,i.$Aj)("debug-start",60115),debugStepInto:(0,i.$Aj)("debug-step-into",60116),debugStepOut:(0,i.$Aj)("debug-step-out",60117),debugStepOver:(0,i.$Aj)("debug-step-over",60118),debugStop:(0,i.$Aj)("debug-stop",60119),debug:(0,i.$Aj)("debug",60120),deviceCameraVideo:(0,i.$Aj)("device-camera-video",60121),deviceCamera:(0,i.$Aj)("device-camera",60122),deviceMobile:(0,i.$Aj)("device-mobile",60123),diffAdded:(0,i.$Aj)("diff-added",60124),diffIgnored:(0,i.$Aj)("diff-ignored",60125),diffModified:(0,i.$Aj)("diff-modified",60126),diffRemoved:(0,i.$Aj)("diff-removed",60127),diffRenamed:(0,i.$Aj)("diff-renamed",60128),diff:(0,i.$Aj)("diff",60129),diffSidebyside:(0,i.$Aj)("diff-sidebyside",60129),discard:(0,i.$Aj)("discard",60130),editorLayout:(0,i.$Aj)("editor-layout",60131),emptyWindow:(0,i.$Aj)("empty-window",60132),exclude:(0,i.$Aj)("exclude",60133),extensions:(0,i.$Aj)("extensions",60134),eyeClosed:(0,i.$Aj)("eye-closed",60135),fileBinary:(0,i.$Aj)("file-binary",60136),fileCode:(0,i.$Aj)("file-code",60137),fileMedia:(0,i.$Aj)("file-media",60138),filePdf:(0,i.$Aj)("file-pdf",60139),fileSubmodule:(0,i.$Aj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Aj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Aj)("file-symlink-file",60142),fileZip:(0,i.$Aj)("file-zip",60143),files:(0,i.$Aj)("files",60144),filter:(0,i.$Aj)("filter",60145),flame:(0,i.$Aj)("flame",60146),foldDown:(0,i.$Aj)("fold-down",60147),foldUp:(0,i.$Aj)("fold-up",60148),fold:(0,i.$Aj)("fold",60149),folderActive:(0,i.$Aj)("folder-active",60150),folderOpened:(0,i.$Aj)("folder-opened",60151),gear:(0,i.$Aj)("gear",60152),gift:(0,i.$Aj)("gift",60153),gistSecret:(0,i.$Aj)("gist-secret",60154),gist:(0,i.$Aj)("gist",60155),gitCommit:(0,i.$Aj)("git-commit",60156),gitCompare:(0,i.$Aj)("git-compare",60157),compareChanges:(0,i.$Aj)("compare-changes",60157),gitMerge:(0,i.$Aj)("git-merge",60158),githubAction:(0,i.$Aj)("github-action",60159),githubAlt:(0,i.$Aj)("github-alt",60160),globe:(0,i.$Aj)("globe",60161),grabber:(0,i.$Aj)("grabber",60162),graph:(0,i.$Aj)("graph",60163),gripper:(0,i.$Aj)("gripper",60164),heart:(0,i.$Aj)("heart",60165),home:(0,i.$Aj)("home",60166),horizontalRule:(0,i.$Aj)("horizontal-rule",60167),hubot:(0,i.$Aj)("hubot",60168),inbox:(0,i.$Aj)("inbox",60169),issueReopened:(0,i.$Aj)("issue-reopened",60171),issues:(0,i.$Aj)("issues",60172),italic:(0,i.$Aj)("italic",60173),jersey:(0,i.$Aj)("jersey",60174),json:(0,i.$Aj)("json",60175),kebabVertical:(0,i.$Aj)("kebab-vertical",60176),key:(0,i.$Aj)("key",60177),law:(0,i.$Aj)("law",60178),lightbulbAutofix:(0,i.$Aj)("lightbulb-autofix",60179),linkExternal:(0,i.$Aj)("link-external",60180),link:(0,i.$Aj)("link",60181),listOrdered:(0,i.$Aj)("list-ordered",60182),listUnordered:(0,i.$Aj)("list-unordered",60183),liveShare:(0,i.$Aj)("live-share",60184),loading:(0,i.$Aj)("loading",60185),location:(0,i.$Aj)("location",60186),mailRead:(0,i.$Aj)("mail-read",60187),mail:(0,i.$Aj)("mail",60188),markdown:(0,i.$Aj)("markdown",60189),megaphone:(0,i.$Aj)("megaphone",60190),mention:(0,i.$Aj)("mention",60191),milestone:(0,i.$Aj)("milestone",60192),gitPullRequestMilestone:(0,i.$Aj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Aj)("mortar-board",60193),move:(0,i.$Aj)("move",60194),multipleWindows:(0,i.$Aj)("multiple-windows",60195),mute:(0,i.$Aj)("mute",60196),noNewline:(0,i.$Aj)("no-newline",60197),note:(0,i.$Aj)("note",60198),octoface:(0,i.$Aj)("octoface",60199),openPreview:(0,i.$Aj)("open-preview",60200),package:(0,i.$Aj)("package",60201),paintcan:(0,i.$Aj)("paintcan",60202),pin:(0,i.$Aj)("pin",60203),play:(0,i.$Aj)("play",60204),run:(0,i.$Aj)("run",60204),plug:(0,i.$Aj)("plug",60205),preserveCase:(0,i.$Aj)("preserve-case",60206),preview:(0,i.$Aj)("preview",60207),project:(0,i.$Aj)("project",60208),pulse:(0,i.$Aj)("pulse",60209),question:(0,i.$Aj)("question",60210),quote:(0,i.$Aj)("quote",60211),radioTower:(0,i.$Aj)("radio-tower",60212),reactions:(0,i.$Aj)("reactions",60213),references:(0,i.$Aj)("references",60214),refresh:(0,i.$Aj)("refresh",60215),regex:(0,i.$Aj)("regex",60216),remoteExplorer:(0,i.$Aj)("remote-explorer",60217),remote:(0,i.$Aj)("remote",60218),remove:(0,i.$Aj)("remove",60219),replaceAll:(0,i.$Aj)("replace-all",60220),replace:(0,i.$Aj)("replace",60221),repoClone:(0,i.$Aj)("repo-clone",60222),repoForcePush:(0,i.$Aj)("repo-force-push",60223),repoPull:(0,i.$Aj)("repo-pull",60224),repoPush:(0,i.$Aj)("repo-push",60225),report:(0,i.$Aj)("report",60226),requestChanges:(0,i.$Aj)("request-changes",60227),rocket:(0,i.$Aj)("rocket",60228),rootFolderOpened:(0,i.$Aj)("root-folder-opened",60229),rootFolder:(0,i.$Aj)("root-folder",60230),rss:(0,i.$Aj)("rss",60231),ruby:(0,i.$Aj)("ruby",60232),saveAll:(0,i.$Aj)("save-all",60233),saveAs:(0,i.$Aj)("save-as",60234),save:(0,i.$Aj)("save",60235),screenFull:(0,i.$Aj)("screen-full",60236),screenNormal:(0,i.$Aj)("screen-normal",60237),searchStop:(0,i.$Aj)("search-stop",60238),server:(0,i.$Aj)("server",60240),settingsGear:(0,i.$Aj)("settings-gear",60241),settings:(0,i.$Aj)("settings",60242),shield:(0,i.$Aj)("shield",60243),smiley:(0,i.$Aj)("smiley",60244),sortPrecedence:(0,i.$Aj)("sort-precedence",60245),splitHorizontal:(0,i.$Aj)("split-horizontal",60246),splitVertical:(0,i.$Aj)("split-vertical",60247),squirrel:(0,i.$Aj)("squirrel",60248),starFull:(0,i.$Aj)("star-full",60249),starHalf:(0,i.$Aj)("star-half",60250),symbolClass:(0,i.$Aj)("symbol-class",60251),symbolColor:(0,i.$Aj)("symbol-color",60252),symbolConstant:(0,i.$Aj)("symbol-constant",60253),symbolEnumMember:(0,i.$Aj)("symbol-enum-member",60254),symbolField:(0,i.$Aj)("symbol-field",60255),symbolFile:(0,i.$Aj)("symbol-file",60256),symbolInterface:(0,i.$Aj)("symbol-interface",60257),symbolKeyword:(0,i.$Aj)("symbol-keyword",60258),symbolMisc:(0,i.$Aj)("symbol-misc",60259),symbolOperator:(0,i.$Aj)("symbol-operator",60260),symbolProperty:(0,i.$Aj)("symbol-property",60261),wrench:(0,i.$Aj)("wrench",60261),wrenchSubaction:(0,i.$Aj)("wrench-subaction",60261),symbolSnippet:(0,i.$Aj)("symbol-snippet",60262),tasklist:(0,i.$Aj)("tasklist",60263),telescope:(0,i.$Aj)("telescope",60264),textSize:(0,i.$Aj)("text-size",60265),threeBars:(0,i.$Aj)("three-bars",60266),thumbsdown:(0,i.$Aj)("thumbsdown",60267),thumbsup:(0,i.$Aj)("thumbsup",60268),tools:(0,i.$Aj)("tools",60269),triangleDown:(0,i.$Aj)("triangle-down",60270),triangleLeft:(0,i.$Aj)("triangle-left",60271),triangleRight:(0,i.$Aj)("triangle-right",60272),triangleUp:(0,i.$Aj)("triangle-up",60273),twitter:(0,i.$Aj)("twitter",60274),unfold:(0,i.$Aj)("unfold",60275),unlock:(0,i.$Aj)("unlock",60276),unmute:(0,i.$Aj)("unmute",60277),unverified:(0,i.$Aj)("unverified",60278),verified:(0,i.$Aj)("verified",60279),versions:(0,i.$Aj)("versions",60280),vmActive:(0,i.$Aj)("vm-active",60281),vmOutline:(0,i.$Aj)("vm-outline",60282),vmRunning:(0,i.$Aj)("vm-running",60283),watch:(0,i.$Aj)("watch",60284),whitespace:(0,i.$Aj)("whitespace",60285),wholeWord:(0,i.$Aj)("whole-word",60286),window:(0,i.$Aj)("window",60287),wordWrap:(0,i.$Aj)("word-wrap",60288),zoomIn:(0,i.$Aj)("zoom-in",60289),zoomOut:(0,i.$Aj)("zoom-out",60290),listFilter:(0,i.$Aj)("list-filter",60291),listFlat:(0,i.$Aj)("list-flat",60292),listSelection:(0,i.$Aj)("list-selection",60293),selection:(0,i.$Aj)("selection",60293),listTree:(0,i.$Aj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Aj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Aj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Aj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Aj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Aj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Aj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Aj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Aj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Aj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Aj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Aj)("symbol-string",60301),debugReverseContinue:(0,i.$Aj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Aj)("debug-step-back",60303),debugRestartFrame:(0,i.$Aj)("debug-restart-frame",60304),debugAlt:(0,i.$Aj)("debug-alt",60305),callIncoming:(0,i.$Aj)("call-incoming",60306),callOutgoing:(0,i.$Aj)("call-outgoing",60307),menu:(0,i.$Aj)("menu",60308),expandAll:(0,i.$Aj)("expand-all",60309),feedback:(0,i.$Aj)("feedback",60310),gitPullRequestReviewer:(0,i.$Aj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Aj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Aj)("ungroup-by-ref-type",60312),account:(0,i.$Aj)("account",60313),gitPullRequestAssignee:(0,i.$Aj)("git-pull-request-assignee",60313),bellDot:(0,i.$Aj)("bell-dot",60314),debugConsole:(0,i.$Aj)("debug-console",60315),library:(0,i.$Aj)("library",60316),output:(0,i.$Aj)("output",60317),runAll:(0,i.$Aj)("run-all",60318),syncIgnored:(0,i.$Aj)("sync-ignored",60319),pinned:(0,i.$Aj)("pinned",60320),githubInverted:(0,i.$Aj)("github-inverted",60321),serverProcess:(0,i.$Aj)("server-process",60322),serverEnvironment:(0,i.$Aj)("server-environment",60323),pass:(0,i.$Aj)("pass",60324),issueClosed:(0,i.$Aj)("issue-closed",60324),stopCircle:(0,i.$Aj)("stop-circle",60325),playCircle:(0,i.$Aj)("play-circle",60326),record:(0,i.$Aj)("record",60327),debugAltSmall:(0,i.$Aj)("debug-alt-small",60328),vmConnect:(0,i.$Aj)("vm-connect",60329),cloud:(0,i.$Aj)("cloud",60330),merge:(0,i.$Aj)("merge",60331),export:(0,i.$Aj)("export",60332),graphLeft:(0,i.$Aj)("graph-left",60333),magnet:(0,i.$Aj)("magnet",60334),notebook:(0,i.$Aj)("notebook",60335),redo:(0,i.$Aj)("redo",60336),checkAll:(0,i.$Aj)("check-all",60337),pinnedDirty:(0,i.$Aj)("pinned-dirty",60338),passFilled:(0,i.$Aj)("pass-filled",60339),circleLargeFilled:(0,i.$Aj)("circle-large-filled",60340),circleLarge:(0,i.$Aj)("circle-large",60341),circleLargeOutline:(0,i.$Aj)("circle-large-outline",60341),combine:(0,i.$Aj)("combine",60342),gather:(0,i.$Aj)("gather",60342),table:(0,i.$Aj)("table",60343),variableGroup:(0,i.$Aj)("variable-group",60344),typeHierarchy:(0,i.$Aj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Aj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Aj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Aj)("git-pull-request-create",60348),runAbove:(0,i.$Aj)("run-above",60349),runBelow:(0,i.$Aj)("run-below",60350),notebookTemplate:(0,i.$Aj)("notebook-template",60351),debugRerun:(0,i.$Aj)("debug-rerun",60352),workspaceTrusted:(0,i.$Aj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Aj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Aj)("workspace-unknown",60355),terminalCmd:(0,i.$Aj)("terminal-cmd",60356),terminalDebian:(0,i.$Aj)("terminal-debian",60357),terminalLinux:(0,i.$Aj)("terminal-linux",60358),terminalPowershell:(0,i.$Aj)("terminal-powershell",60359),terminalTmux:(0,i.$Aj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Aj)("terminal-ubuntu",60361),terminalBash:(0,i.$Aj)("terminal-bash",60362),arrowSwap:(0,i.$Aj)("arrow-swap",60363),copy:(0,i.$Aj)("copy",60364),personAdd:(0,i.$Aj)("person-add",60365),filterFilled:(0,i.$Aj)("filter-filled",60366),wand:(0,i.$Aj)("wand",60367),debugLineByLine:(0,i.$Aj)("debug-line-by-line",60368),inspect:(0,i.$Aj)("inspect",60369),layers:(0,i.$Aj)("layers",60370),layersDot:(0,i.$Aj)("layers-dot",60371),layersActive:(0,i.$Aj)("layers-active",60372),compass:(0,i.$Aj)("compass",60373),compassDot:(0,i.$Aj)("compass-dot",60374),compassActive:(0,i.$Aj)("compass-active",60375),azure:(0,i.$Aj)("azure",60376),issueDraft:(0,i.$Aj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Aj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Aj)("git-pull-request-draft",60379),debugAll:(0,i.$Aj)("debug-all",60380),debugCoverage:(0,i.$Aj)("debug-coverage",60381),runErrors:(0,i.$Aj)("run-errors",60382),folderLibrary:(0,i.$Aj)("folder-library",60383),debugContinueSmall:(0,i.$Aj)("debug-continue-small",60384),beakerStop:(0,i.$Aj)("beaker-stop",60385),graphLine:(0,i.$Aj)("graph-line",60386),graphScatter:(0,i.$Aj)("graph-scatter",60387),pieChart:(0,i.$Aj)("pie-chart",60388),bracket:(0,i.$Aj)("bracket",60175),bracketDot:(0,i.$Aj)("bracket-dot",60389),bracketError:(0,i.$Aj)("bracket-error",60390),lockSmall:(0,i.$Aj)("lock-small",60391),azureDevops:(0,i.$Aj)("azure-devops",60392),verifiedFilled:(0,i.$Aj)("verified-filled",60393),newline:(0,i.$Aj)("newline",60394),layout:(0,i.$Aj)("layout",60395),layoutActivitybarLeft:(0,i.$Aj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Aj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Aj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Aj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Aj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Aj)("layout-panel-right",60401),layoutPanel:(0,i.$Aj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Aj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Aj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Aj)("layout-statusbar",60405),layoutMenubar:(0,i.$Aj)("layout-menubar",60406),layoutCentered:(0,i.$Aj)("layout-centered",60407),target:(0,i.$Aj)("target",60408),indent:(0,i.$Aj)("indent",60409),recordSmall:(0,i.$Aj)("record-small",60410),errorSmall:(0,i.$Aj)("error-small",60411),terminalDecorationError:(0,i.$Aj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Aj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Aj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Aj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Aj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Aj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Aj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Aj)("layout-sidebar-left-off",60418),blank:(0,i.$Aj)("blank",60419),heartFilled:(0,i.$Aj)("heart-filled",60420),map:(0,i.$Aj)("map",60421),mapFilled:(0,i.$Aj)("map-filled",60422),circleSmall:(0,i.$Aj)("circle-small",60423),bellSlash:(0,i.$Aj)("bell-slash",60424),bellSlashDot:(0,i.$Aj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Aj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Aj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Aj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Aj)("search-fuzzy",60429),commentDraft:(0,i.$Aj)("comment-draft",60430),send:(0,i.$Aj)("send",60431),sparkle:(0,i.$Aj)("sparkle",60432),insert:(0,i.$Aj)("insert",60433),mic:(0,i.$Aj)("mic",60434),thumbsdownFilled:(0,i.$Aj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Aj)("thumbsup-filled",60436),coffee:(0,i.$Aj)("coffee",60437),snake:(0,i.$Aj)("snake",60438),game:(0,i.$Aj)("game",60439),vr:(0,i.$Aj)("vr",60440),chip:(0,i.$Aj)("chip",60441),piano:(0,i.$Aj)("piano",60442),music:(0,i.$Aj)("music",60443),micFilled:(0,i.$Aj)("mic-filled",60444),repoFetch:(0,i.$Aj)("repo-fetch",60445),copilot:(0,i.$Aj)("copilot",60446),lightbulbSparkle:(0,i.$Aj)("lightbulb-sparkle",60447),robot:(0,i.$Aj)("robot",60448),sparkleFilled:(0,i.$Aj)("sparkle-filled",60449),diffSingle:(0,i.$Aj)("diff-single",60450),diffMultiple:(0,i.$Aj)("diff-multiple",60451),surroundWith:(0,i.$Aj)("surround-with",60452),share:(0,i.$Aj)("share",60453),gitStash:(0,i.$Aj)("git-stash",60454),gitStashApply:(0,i.$Aj)("git-stash-apply",60455),gitStashPop:(0,i.$Aj)("git-stash-pop",60456),vscode:(0,i.$Aj)("vscode",60457),vscodeInsiders:(0,i.$Aj)("vscode-insiders",60458),codeOss:(0,i.$Aj)("code-oss",60459),runCoverage:(0,i.$Aj)("run-coverage",60460),runAllCoverage:(0,i.$Aj)("run-all-coverage",60461),coverage:(0,i.$Aj)("coverage",60462),githubProject:(0,i.$Aj)("github-project",60463)}}),re(ie[43],se([0,1,27,42]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fj=t.$Ej=void 0,t.$Dj=y;function y(){return Object.values(t.$Fj)}t.$Ej={dialogError:(0,i.$Aj)("dialog-error","error"),dialogWarning:(0,i.$Aj)("dialog-warning","warning"),dialogInfo:(0,i.$Aj)("dialog-info","info"),dialogClose:(0,i.$Aj)("dialog-close","close"),treeItemExpanded:(0,i.$Aj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Aj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Aj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Aj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Aj)("tree-item-loading","loading"),menuSelection:(0,i.$Aj)("menu-selection","check"),menuSubmenu:(0,i.$Aj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Aj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Aj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Aj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Aj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Aj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Aj)("toolbar-more","more"),quickInputBack:(0,i.$Aj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Aj)("drop-down-button",60084),symbolCustomColor:(0,i.$Aj)("symbol-customcolor",60252),exportIcon:(0,i.$Aj)("export",60332),workspaceUnspecified:(0,i.$Aj)("workspace-unspecified",60355),newLine:(0,i.$Aj)("newline",60394),thumbsDownFilled:(0,i.$Aj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Aj)("thumbsup-filled",60436),gitFetch:(0,i.$Aj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Aj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Aj)("debug-breakpoint-pending",60377)},t.$Fj={...P.$Cj,...t.$Ej}}),re(ie[14],se([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mn=P,t.$Nn=y,t.$On=v,t.$Pn=l,t.$Qn=u,t.$Rn=c,t.$Sn=p,t.$Tn=b,t.$Un=m,t.$Vn=e,t.$Wn=N,t.$Xn=j;function P(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([d,a])=>{$[d]=a&&typeof a=="object"?P(a):a}),$}function y(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const d=$.shift();Object.freeze(d);for(const a in d)if(o.call(d,a)){const f=d[a];typeof f=="object"&&!Object.isFrozen(f)&&!(0,i.$Wf)(f)&&$.push(f)}}return L}const o=Object.prototype.hasOwnProperty;function v(L,$){return h(L,$,new Set)}function h(L,$,d){if((0,i.$3f)(L))return L;const a=$(L);if(typeof a<"u")return a;if(Array.isArray(L)){const f=[];for(const n of L)f.push(h(n,$,d));return f}if((0,i.$Vf)(L)){if(d.has(L))throw new Error("Cannot clone recursive data-structure");d.add(L);const f={};for(const n in L)o.call(L,n)&&(f[n]=h(L[n],$,d));return d.delete(L),f}return L}function l(L,$,d=!0){return(0,i.$Vf)(L)?((0,i.$Vf)($)&&Object.keys($).forEach(a=>{a in L?d&&((0,i.$Vf)(L[a])&&(0,i.$Vf)($[a])?l(L[a],$[a],d):L[a]=$[a]):L[a]=$[a]}),L):$}function u(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let d,a;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(d=0;d<L.length;d++)if(!u(L[d],$[d]))return!1}else{const f=[];for(a in L)f.push(a);f.sort();const n=[];for(a in $)n.push(a);if(n.sort(),!u(f,n))return!1;for(d=0;d<f.length;d++)if(!u(L[f[d]],$[f[d]]))return!1}return!0}function c(L){const $=new Set;return JSON.stringify(L,(d,a)=>{if((0,i.$Vf)(a)||Array.isArray(a)){if($.has(a))return"[Circular]";$.add(a)}return a})}function p(L,$){const d=Object.create(null);return!L||!$||Object.keys($).forEach(f=>{const n=L[f],s=$[f];u(n,s)||(d[f]=s)}),d}function b(L,$){const d=$.toLowerCase(),a=Object.keys(L).find(f=>f.toLowerCase()===d);return a?L[a]:L[$]}function m(L,$){const d=Object.create(null);for(const[a,f]of Object.entries(L))$(a,f)&&(d[a]=f);return d}function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}function N(L){const $=[];for(const d of e(L))typeof L[d]=="function"&&$.push(d);return $}function j(L,$){const d=f=>function(){const n=Array.prototype.slice.call(arguments,0);return $(f,n)},a={};for(const f of L)a[f]=d(f);return a}}),re(ie[28],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$Re=P,t.$Se=y;var i;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function P(o){return o<0?0:o>255?255:o|0}function y(o){return o<0?0:o>4294967295?4294967295:o|0}}),re(ie[29],se([0,1,28]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wt=t.$vt=void 0;class P{constructor(h){const l=(0,i.$Re)(h);this.c=l,this.a=P.d(l),this.b=new Map}static d(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const u=(0,i.$Re)(l);h>=0&&h<256?this.a[h]=u:this.b.set(h,u)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$vt=P;var y;(function(v){v[v.False=0]="False",v[v.True=1]="True"})(y||(y={}));class o{constructor(){this.a=new P(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$wt=o}),re(ie[4],se([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=t.$ft=void 0;class P{static addRange(v,h){let l=0;for(;l<h.length&&h[l].endExclusive<v.start;)l++;let u=l;for(;u<h.length&&h[u].start<=v.endExclusive;)u++;if(l===u)h.splice(l,0,v);else{const c=Math.min(v.start,h[l].start),p=Math.max(v.endExclusive,h[u-1].endExclusive);h.splice(l,u-l,new P(c,p))}}static tryCreate(v,h){if(!(v>h))return new P(v,h)}static ofLength(v){return new P(0,v)}static ofStartAndLength(v,h){return new P(v,v+h)}constructor(v,h){if(this.start=v,this.endExclusive=h,v>h)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new P(this.start+v,this.endExclusive+v)}deltaStart(v){return new P(this.start+v,this.endExclusive)}deltaEnd(v){return new P(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(v){return this.start===v.start&&this.endExclusive===v.endExclusive}containsRange(v){return this.start<=v.start&&v.endExclusive<=this.endExclusive}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new P(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const h=Math.max(this.start,v.start),l=Math.min(this.endExclusive,v.endExclusive);if(h<=l)return new P(h,l)}intersects(v){const h=Math.max(this.start,v.start),l=Math.min(this.endExclusive,v.endExclusive);return h<l}intersectsOrTouches(v){const h=Math.max(this.start,v.start),l=Math.min(this.endExclusive,v.endExclusive);return h<=l}isBefore(v){return this.endExclusive<=v.start}isAfter(v){return this.start>=v.endExclusive}slice(v){return v.slice(this.start,this.endExclusive)}substring(v){return v.substring(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}map(v){const h=[];for(let l=this.start;l<this.endExclusive;l++)h.push(v(l));return h}forEach(v){for(let h=this.start;h<this.endExclusive;h++)v(h)}}t.$ft=P;class y{constructor(){this.a=[]}addRange(v){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<v.start;)h++;let l=h;for(;l<this.a.length&&this.a[l].start<=v.endExclusive;)l++;if(h===l)this.a.splice(h,0,v);else{const u=Math.min(v.start,this.a[h].start),c=Math.max(v.endExclusive,this.a[l-1].endExclusive);this.a.splice(h,l-h,new P(u,c))}}toString(){return this.a.map(v=>v.toString()).join(", ")}intersectsStrict(v){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=v.start;)h++;return h<this.a.length&&this.a[h].start<v.endExclusive}intersectWithRange(v){const h=new y;for(const l of this.a){const u=l.intersect(v);u&&h.addRange(u)}return h}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this.a.reduce((v,h)=>v+h.length,0)}}t.$gt=y}),re(ie[5],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=void 0;class i{constructor(y,o){this.lineNumber=y,this.column=o}with(y=this.lineNumber,o=this.column){return y===this.lineNumber&&o===this.column?this:new i(y,o)}delta(y=0,o=0){return this.with(this.lineNumber+y,this.column+o)}equals(y){return i.equals(this,y)}static equals(y,o){return!y&&!o?!0:!!y&&!!o&&y.lineNumber===o.lineNumber&&y.column===o.column}isBefore(y){return i.isBefore(this,y)}static isBefore(y,o){return y.lineNumber<o.lineNumber?!0:o.lineNumber<y.lineNumber?!1:y.column<o.column}isBeforeOrEqual(y){return i.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,o){return y.lineNumber<o.lineNumber?!0:o.lineNumber<y.lineNumber?!1:y.column<=o.column}static compare(y,o){const v=y.lineNumber|0,h=o.lineNumber|0;if(v===h){const l=y.column|0,u=o.column|0;return l-u}return v-h}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new i(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$0s=i}),re(ie[2],se([0,1,5]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$s=void 0;class P{constructor(o,v,h,l){o>h||o===h&&v>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=o,this.endColumn=v):(this.startLineNumber=o,this.startColumn=v,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return P.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return P.containsPosition(this,o)}static containsPosition(o,v){return!(v.lineNumber<o.startLineNumber||v.lineNumber>o.endLineNumber||v.lineNumber===o.startLineNumber&&v.column<o.startColumn||v.lineNumber===o.endLineNumber&&v.column>o.endColumn)}static strictContainsPosition(o,v){return!(v.lineNumber<o.startLineNumber||v.lineNumber>o.endLineNumber||v.lineNumber===o.startLineNumber&&v.column<=o.startColumn||v.lineNumber===o.endLineNumber&&v.column>=o.endColumn)}containsRange(o){return P.containsRange(this,o)}static containsRange(o,v){return!(v.startLineNumber<o.startLineNumber||v.endLineNumber<o.startLineNumber||v.startLineNumber>o.endLineNumber||v.endLineNumber>o.endLineNumber||v.startLineNumber===o.startLineNumber&&v.startColumn<o.startColumn||v.endLineNumber===o.endLineNumber&&v.endColumn>o.endColumn)}strictContainsRange(o){return P.strictContainsRange(this,o)}static strictContainsRange(o,v){return!(v.startLineNumber<o.startLineNumber||v.endLineNumber<o.startLineNumber||v.startLineNumber>o.endLineNumber||v.endLineNumber>o.endLineNumber||v.startLineNumber===o.startLineNumber&&v.startColumn<=o.startColumn||v.endLineNumber===o.endLineNumber&&v.endColumn>=o.endColumn)}plusRange(o){return P.plusRange(this,o)}static plusRange(o,v){let h,l,u,c;return v.startLineNumber<o.startLineNumber?(h=v.startLineNumber,l=v.startColumn):v.startLineNumber===o.startLineNumber?(h=v.startLineNumber,l=Math.min(v.startColumn,o.startColumn)):(h=o.startLineNumber,l=o.startColumn),v.endLineNumber>o.endLineNumber?(u=v.endLineNumber,c=v.endColumn):v.endLineNumber===o.endLineNumber?(u=v.endLineNumber,c=Math.max(v.endColumn,o.endColumn)):(u=o.endLineNumber,c=o.endColumn),new P(h,l,u,c)}intersectRanges(o){return P.intersectRanges(this,o)}static intersectRanges(o,v){let h=o.startLineNumber,l=o.startColumn,u=o.endLineNumber,c=o.endColumn;const p=v.startLineNumber,b=v.startColumn,m=v.endLineNumber,e=v.endColumn;return h<p?(h=p,l=b):h===p&&(l=Math.max(l,b)),u>m?(u=m,c=e):u===m&&(c=Math.min(c,e)),h>u||h===u&&l>c?null:new P(h,l,u,c)}equalsRange(o){return P.equalsRange(this,o)}static equalsRange(o,v){return!o&&!v?!0:!!o&&!!v&&o.startLineNumber===v.startLineNumber&&o.startColumn===v.startColumn&&o.endLineNumber===v.endLineNumber&&o.endColumn===v.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(o){return new i.$0s(o.endLineNumber,o.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(o){return new i.$0s(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,v){return new P(this.startLineNumber,this.startColumn,o,v)}setStartPosition(o,v){return new P(o,v,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(o){return new P(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(o){return new P(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new P(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,v=o){return new P(o.lineNumber,o.column,v.lineNumber,v.column)}static lift(o){return o?new P(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,v){return!(o.endLineNumber<v.startLineNumber||o.endLineNumber===v.startLineNumber&&o.endColumn<v.startColumn||v.endLineNumber<o.startLineNumber||v.endLineNumber===o.startLineNumber&&v.endColumn<o.startColumn)}static areIntersecting(o,v){return!(o.endLineNumber<v.startLineNumber||o.endLineNumber===v.startLineNumber&&o.endColumn<=v.startColumn||v.endLineNumber<o.startLineNumber||v.endLineNumber===o.startLineNumber&&v.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,v){if(o&&v){const u=o.startLineNumber|0,c=v.startLineNumber|0;if(u===c){const p=o.startColumn|0,b=v.startColumn|0;if(p===b){const m=o.endLineNumber|0,e=v.endLineNumber|0;if(m===e){const N=o.endColumn|0,j=v.endColumn|0;return N-j}return m-e}return p-b}return u-c}return(o?1:0)-(v?1:0)}static compareRangesUsingEnds(o,v){return o.endLineNumber===v.endLineNumber?o.endColumn===v.endColumn?o.startLineNumber===v.startLineNumber?o.startColumn-v.startColumn:o.startLineNumber-v.startLineNumber:o.endColumn-v.endColumn:o.endLineNumber-v.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$$s=P}),re(ie[44],se([0,1,2]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=void 0;class P{static insert(o,v){return{range:new i.$$s(o.lineNumber,o.column,o.lineNumber,o.column),text:v,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,v){return{range:o,text:v}}static replaceMove(o,v){return{range:o,text:v,forceMoveMarkers:!0}}}t.$_s=P}),re(ie[12],se([0,1,3,4,2,9]),function(V,t,i,P,y,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$ht=void 0;class v{static fromRange(u){return new v(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new v(u.startLineNumber,u.endLineNumber+1)}static subtract(u,c){return c?u.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<u.endLineNumberExclusive?[new v(u.startLineNumber,c.startLineNumber),new v(c.endLineNumberExclusive,u.endLineNumberExclusive)]:c.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<u.endLineNumberExclusive?[new v(Math.max(c.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new v(u.startLineNumber,Math.min(c.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let c=new h(u[0].slice());for(let p=1;p<u.length;p++)c=c.getUnion(new h(u[p].slice()));return c.ranges}static ofLength(u,c){return new v(u,u+c)}static deserialize(u){return new v(u[0],u[1])}constructor(u,c){if(u>c)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=u,this.endLineNumberExclusive=c}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new v(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new v(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new v(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const c=Math.max(this.startLineNumber,u.startLineNumber),p=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(c<=p)return new v(c,p)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new y.$$s(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new y.$$s(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const c=[];for(let p=this.startLineNumber;p<this.endLineNumberExclusive;p++)c.push(u(p));return c}forEach(u){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)u(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new P.$ft(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$ht=v;class h{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const c=(0,o.$kb)(this.c,b=>b.endLineNumberExclusive>=u.startLineNumber),p=(0,o.$ib)(this.c,b=>b.startLineNumber<=u.endLineNumberExclusive)+1;if(c===p)this.c.splice(c,0,u);else if(c===p-1){const b=this.c[c];this.c[c]=b.join(u)}else{const b=this.c[c].join(this.c[p-1]).join(u);this.c.splice(c,p-c,b)}}contains(u){const c=(0,o.$hb)(this.c,p=>p.startLineNumber<=u);return!!c&&c.endLineNumberExclusive>u}intersects(u){const c=(0,o.$hb)(this.c,p=>p.startLineNumber<u.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const c=[];let p=0,b=0,m=null;for(;p<this.c.length||b<u.c.length;){let e=null;if(p<this.c.length&&b<u.c.length){const N=this.c[p],j=u.c[b];N.startLineNumber<j.startLineNumber?(e=N,p++):(e=j,b++)}else p<this.c.length?(e=this.c[p],p++):(e=u.c[b],b++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new v(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(m),m=e)}return m!==null&&c.push(m),new h(c)}subtractFrom(u){const c=(0,o.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),p=(0,o.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(c===p)return new h([u]);const b=[];let m=u.startLineNumber;for(let e=c;e<p;e++){const N=this.c[e];N.startLineNumber>m&&b.push(new v(m,N.startLineNumber)),m=N.endLineNumberExclusive}return m<u.endLineNumberExclusive&&b.push(new v(m,u.endLineNumberExclusive)),new h(b)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const c=[];let p=0,b=0;for(;p<this.c.length&&b<u.c.length;){const m=this.c[p],e=u.c[b],N=m.intersect(e);N&&!N.isEmpty&&c.push(N),m.endLineNumberExclusive<e.endLineNumberExclusive?p++:b++}return new h(c)}getWithDelta(u){return new h(this.c.map(c=>c.delta(u)))}}t.$it=h}),re(ie[45],se([0,1,5,2]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=t.SelectionDirection=void 0;var y;(function(v){v[v.LTR=0]="LTR",v[v.RTL=1]="RTL"})(y||(t.SelectionDirection=y={}));class o extends P.$$s{constructor(h,l,u,c){super(h,l,u,c),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=u,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return o.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,h,l):new o(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new i.$0s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$0s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new o(h,l,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new o(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new o(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new o(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new o(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let u=0,c=h.length;u<c;u++)if(!this.selectionsEqual(h[u],l[u]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,u,c,p){return p===0?new o(h,l,u,c):new o(u,c,h,l)}}t.$at=o}),re(ie[46],se([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yt=t.$xt=t.WordCharacterClass=void 0;var P;(function(v){v[v.Regular=0]="Regular",v[v.Whitespace=1]="Whitespace",v[v.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class y extends i.$vt{constructor(h){super(0);for(let l=0,u=h.length;l<u;l++)this.set(h.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$xt=y;function o(v){const h={};return l=>(h.hasOwnProperty(l)||(h[l]=v(l)),h[l])}t.$yt=o(v=>new y(v))}),re(ie[30],se([0,1,20,10,21]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=t.$Js=void 0,t.$Ls=v,t.$Ms=l,t.$Ns=u,t.$Js="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(p=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Js)p.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.$Ks=o();function v(p){let b=t.$Ks;if(p&&p instanceof RegExp)if(p.global)b=p;else{let m="g";p.ignoreCase&&(m+="i"),p.multiline&&(m+="m"),p.unicode&&(m+="u"),b=new RegExp(p.source,m)}return b.lastIndex=0,b}const h=new y.$4c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(p){const b=h.unshift(p);return(0,P.$Rc)(b)}function u(p,b,m,e,N){if(b=v(b),N||(N=i.Iterable.first(h)),m.length>N.maxLen){let a=p-N.maxLen/2;return a<0?a=0:e+=a,m=m.substring(a,p+N.maxLen/2),u(p,b,m,e,N)}const j=Date.now(),L=p-1-e;let $=-1,d=null;for(let a=1;!(Date.now()-j>=N.timeBudget);a++){const f=L-N.windowSize*a;b.lastIndex=Math.max(0,f);const n=c(b,m,L,$);if(!n&&d||(d=n,f<=0))break;$=f}if(d){const a={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return b.lastIndex=0,a}return null}function c(p,b,m,e){let N;for(;N=p.exec(b);){const j=N.index||0;if(j<=m&&p.lastIndex>=m)return N;if(e>0&&j>e)return null}return null}}),re(ie[8],se([0,1,6,3,4]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r2=t.$q2=t.$p2=t.$o2=t.$n2=void 0;class o{static trivial(p,b){return new o([new v(y.$ft.ofLength(p.length),y.$ft.ofLength(b.length))],!1)}static trivialTimedOut(p,b){return new o([new v(y.$ft.ofLength(p.length),y.$ft.ofLength(b.length))],!0)}constructor(p,b){this.diffs=p,this.hitTimeout=b}}t.$n2=o;class v{static invert(p,b){const m=[];return(0,i.$Bb)(p,(e,N)=>{m.push(v.fromOffsetPairs(e?e.getEndExclusives():h.zero,N?N.getStarts():new h(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),m}static fromOffsetPairs(p,b){return new v(new y.$ft(p.offset1,b.offset1),new y.$ft(p.offset2,b.offset2))}constructor(p,b){this.seq1Range=p,this.seq2Range=b}swap(){return new v(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(p){return new v(this.seq1Range.join(p.seq1Range),this.seq2Range.join(p.seq2Range))}delta(p){return p===0?this:new v(this.seq1Range.delta(p),this.seq2Range.delta(p))}deltaStart(p){return p===0?this:new v(this.seq1Range.deltaStart(p),this.seq2Range.deltaStart(p))}deltaEnd(p){return p===0?this:new v(this.seq1Range.deltaEnd(p),this.seq2Range.deltaEnd(p))}intersectsOrTouches(p){return this.seq1Range.intersectsOrTouches(p.seq1Range)||this.seq2Range.intersectsOrTouches(p.seq2Range)}intersect(p){const b=this.seq1Range.intersect(p.seq1Range),m=this.seq2Range.intersect(p.seq2Range);if(!(!b||!m))return new v(b,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$o2=v;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(p,b){this.offset1=p,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(p){return p===0?this:new h(this.offset1+p,this.offset2+p)}equals(p){return this.offset1===p.offset1&&this.offset2===p.offset2}}t.$p2=h;class l{static{this.instance=new l}isValid(){return!0}}t.$q2=l;class u{constructor(p){if(this.e=p,this.c=Date.now(),this.d=!0,p<=0)throw new P.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$r2=u}),re(ie[31],se([0,1,4,8]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w2=void 0;class y{compute(u,c,p=P.$q2.instance){if(u.length===0||c.length===0)return P.$n2.trivial(u,c);const b=u,m=c;function e(s,w){for(;s<b.length&&w<m.length&&b.getElement(s)===m.getElement(w);)s++,w++;return s}let N=0;const j=new v;j.set(0,e(0,0));const L=new h;L.set(0,j.get(0)===0?null:new o(null,0,0,j.get(0)));let $=0;e:for(;;){if(N++,!p.isValid())return P.$n2.trivialTimedOut(b,m);const s=-Math.min(N,m.length+N%2),w=Math.min(N,b.length+N%2);for($=s;$<=w;$+=2){let g=0;const A=$===w?-1:j.get($+1),E=$===s?-1:j.get($-1)+1;g++;const R=Math.min(Math.max(A,E),b.length),F=R-$;if(g++,R>b.length||F>m.length)continue;const k=e(R,F);j.set($,k);const M=R===A?L.get($+1):L.get($-1);if(L.set($,k!==R?new o(M,R,F,k-R):M),j.get($)===b.length&&j.get($)-$===m.length)break e}}let d=L.get($);const a=[];let f=b.length,n=m.length;for(;;){const s=d?d.x+d.length:0,w=d?d.y+d.length:0;if((s!==f||w!==n)&&a.push(new P.$o2(new i.$ft(s,f),new i.$ft(w,n))),!d)break;f=d.x,n=d.y,d=d.prev}return a.reverse(),new P.$n2(a,!1)}}t.$w2=y;class o{constructor(u,c,p,b){this.prev=u,this.x=c,this.y=p,this.length=b}}class v{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){if(u<0){if(u=-u-1,u>=this.b.length){const p=this.b;this.b=new Int32Array(p.length*2),this.b.set(p)}this.b[u]=c}else{if(u>=this.a.length){const p=this.a;this.a=new Int32Array(p.length*2),this.a.set(p)}this.a[u]=c}}}class h{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){u<0?(u=-u-1,this.b[u]=c):this.a[u]=c}}}),re(ie[47],se([0,1,6,4,8]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A2=o,t.$B2=u,t.$C2=c,t.$D2=b,t.$E2=m;function o(e,N,j){let L=j;return L=v(e,N,L),L=v(e,N,L),L=h(e,N,L),L}function v(e,N,j){if(j.length===0)return j;const L=[];L.push(j[0]);for(let d=1;d<j.length;d++){const a=L[L.length-1];let f=j[d];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const n=f.seq1Range.start-a.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(f.seq1Range.start-s)!==e.getElement(f.seq1Range.endExclusive-s)||N.getElement(f.seq2Range.start-s)!==N.getElement(f.seq2Range.endExclusive-s));s++);if(s--,s===n){L[L.length-1]=new y.$o2(new P.$ft(a.seq1Range.start,f.seq1Range.endExclusive-n),new P.$ft(a.seq2Range.start,f.seq2Range.endExclusive-n));continue}f=f.delta(-s)}L.push(f)}const $=[];for(let d=0;d<L.length-1;d++){const a=L[d+1];let f=L[d];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const n=a.seq1Range.start-f.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(f.seq1Range.start+s,f.seq1Range.endExclusive+s)||!N.isStronglyEqual(f.seq2Range.start+s,f.seq2Range.endExclusive+s));s++);if(s===n){L[d+1]=new y.$o2(new P.$ft(f.seq1Range.start+n,a.seq1Range.endExclusive),new P.$ft(f.seq2Range.start+n,a.seq2Range.endExclusive));continue}s>0&&(f=f.delta(s))}$.push(f)}return L.length>0&&$.push(L[L.length-1]),$}function h(e,N,j){if(!e.getBoundaryScore||!N.getBoundaryScore)return j;for(let L=0;L<j.length;L++){const $=L>0?j[L-1]:void 0,d=j[L],a=L+1<j.length?j[L+1]:void 0,f=new P.$ft($?$.seq1Range.endExclusive+1:0,a?a.seq1Range.start-1:e.length),n=new P.$ft($?$.seq2Range.endExclusive+1:0,a?a.seq2Range.start-1:N.length);d.seq1Range.isEmpty?j[L]=l(d,e,N,f,n):d.seq2Range.isEmpty&&(j[L]=l(d.swap(),N,e,n,f).swap())}return j}function l(e,N,j,L,$){let a=1;for(;e.seq1Range.start-a>=L.start&&e.seq2Range.start-a>=$.start&&j.isStronglyEqual(e.seq2Range.start-a,e.seq2Range.endExclusive-a)&&a<100;)a++;a--;let f=0;for(;e.seq1Range.start+f<L.endExclusive&&e.seq2Range.endExclusive+f<$.endExclusive&&j.isStronglyEqual(e.seq2Range.start+f,e.seq2Range.endExclusive+f)&&f<100;)f++;if(a===0&&f===0)return e;let n=0,s=-1;for(let w=-a;w<=f;w++){const g=e.seq2Range.start+w,A=e.seq2Range.endExclusive+w,E=e.seq1Range.start+w,R=N.getBoundaryScore(E)+j.getBoundaryScore(g)+j.getBoundaryScore(A);R>s&&(s=R,n=w)}return e.delta(n)}function u(e,N,j){const L=[];for(const $ of j){const d=L[L.length-1];if(!d){L.push($);continue}$.seq1Range.start-d.seq1Range.endExclusive<=2||$.seq2Range.start-d.seq2Range.endExclusive<=2?L[L.length-1]=new y.$o2(d.seq1Range.join($.seq1Range),d.seq2Range.join($.seq2Range)):L.push($)}return L}function c(e,N,j){const L=y.$o2.invert(j,e.length),$=[];let d=new y.$p2(0,0);function a(n,s){if(n.offset1<d.offset1||n.offset2<d.offset2)return;const w=e.findWordContaining(n.offset1),g=N.findWordContaining(n.offset2);if(!w||!g)return;let A=new y.$o2(w,g);const E=A.intersect(s);let R=E.seq1Range.length,F=E.seq2Range.length;for(;L.length>0;){const k=L[0];if(!(k.seq1Range.intersects(A.seq1Range)||k.seq2Range.intersects(A.seq2Range)))break;const S=e.findWordContaining(k.seq1Range.start),D=N.findWordContaining(k.seq2Range.start),I=new y.$o2(S,D),O=I.intersect(k);if(R+=O.seq1Range.length,F+=O.seq2Range.length,A=A.join(I),A.seq1Range.endExclusive>=k.seq1Range.endExclusive)L.shift();else break}R+F<(A.seq1Range.length+A.seq2Range.length)*2/3&&$.push(A),d=A.getEndExclusives()}for(;L.length>0;){const n=L.shift();n.seq1Range.isEmpty||(a(n.getStarts(),n),a(n.getEndExclusives().delta(-1),n))}return p(j,$)}function p(e,N){const j=[];for(;e.length>0||N.length>0;){const L=e[0],$=N[0];let d;L&&(!$||L.seq1Range.start<$.seq1Range.start)?d=e.shift():d=N.shift(),j.length>0&&j[j.length-1].seq1Range.endExclusive>=d.seq1Range.start?j[j.length-1]=j[j.length-1].join(d):j.push(d)}return j}function b(e,N,j){let L=j;if(L.length===0)return L;let $=0,d;do{d=!1;const a=[L[0]];for(let f=1;f<L.length;f++){let w=function(A,E){const R=new P.$ft(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(A.seq1Range.length+A.seq2Range.length>5||E.seq1Range.length+E.seq2Range.length>5)};const n=L[f],s=a[a.length-1];w(s,n)?(d=!0,a[a.length-1]=a[a.length-1].join(n)):a.push(n)}L=a}while($++<10&&d);return L}function m(e,N,j){let L=j;if(L.length===0)return L;let $=0,d;do{d=!1;const f=[L[0]];for(let n=1;n<L.length;n++){let g=function(E,R){const F=new P.$ft(w.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(F)>5||F.length>500)return!1;const M=e.getText(F).trim();if(M.length>20||M.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(E.seq1Range),D=E.seq1Range.length,I=N.countLinesIn(E.seq2Range),O=E.seq2Range.length,G=e.countLinesIn(R.seq1Range),ne=R.seq1Range.length,Z=N.countLinesIn(R.seq2Range),Y=R.seq2Range.length,T=2*40+50;function W(te){return Math.min(te,T)}return Math.pow(Math.pow(W(S*40+D),1.5)+Math.pow(W(I*40+O),1.5),1.5)+Math.pow(Math.pow(W(G*40+ne),1.5)+Math.pow(W(Z*40+Y),1.5),1.5)>(T**1.5)**1.5*1.3};const s=L[n],w=f[f.length-1];g(w,s)?(d=!0,f[f.length-1]=f[f.length-1].join(s)):f.push(s)}L=f}while($++<10&&d);const a=[];return(0,i.$Cb)(L,(f,n,s)=>{let w=n;function g(M){return M.length>0&&M.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const A=e.extendToFullLines(n.seq1Range),E=e.getText(new P.$ft(A.start,n.seq1Range.start));g(E)&&(w=w.deltaStart(-E.length));const R=e.getText(new P.$ft(n.seq1Range.endExclusive,A.endExclusive));g(R)&&(w=w.deltaEnd(R.length));const F=y.$o2.fromOffsetPairs(f?f.getEndExclusives():y.$p2.zero,s?s.getStarts():y.$p2.max),k=w.intersect(F);a.length>0&&k.getStarts().equals(a[a.length-1].getEndExclusives())?a[a.length-1]=a[a.length-1].join(k):a.push(k)}),a}}),re(ie[48],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z2=void 0;class i{constructor(o,v){this.a=o,this.b=v}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const v=o===0?0:P(this.b[o-1]),h=o===this.b.length?0:P(this.b[o]);return 1e3-(v+h)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,v){return this.b[o]===this.b[v]}}t.$z2=i;function P(y){let o=0;for(;o<y.length&&(y.charCodeAt(o)===32||y.charCodeAt(o)===9);)o++;return o}}),re(ie[15],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$u2=t.$s2=void 0,t.$t2=P;class i{constructor(v,h){this.width=v,this.height=h,this.a=[],this.a=new Array(v*h)}get(v,h){return this.a[v+h*this.width]}set(v,h,l){this.a[v+h*this.width]=l}}t.$s2=i;function P(o){return o===32||o===9}class y{static{this.a=new Map}static b(v){let h=this.a.get(v);return h===void 0&&(h=this.a.size,this.a.set(v,h)),h}constructor(v,h,l){this.range=v,this.lines=h,this.source=l,this.d=[];let u=0;for(let c=v.startLineNumber-1;c<v.endLineNumberExclusive-1;c++){const p=h[c];for(let m=0;m<p.length;m++){u++;const e=p[m],N=y.b(e);this.d[N]=(this.d[N]||0)+1}u++;const b=y.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=u}computeSimilarity(v){let h=0;const l=Math.max(this.d.length,v.d.length);for(let u=0;u<l;u++)h+=Math.abs((this.d[u]??0)-(v.d[u]??0));return 1-h/(this.c+v.c)}}t.$u2=y}),re(ie[49],se([0,1,4,8,15]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$v2=void 0;class o{compute(h,l,u=P.$q2.instance,c){if(h.length===0||l.length===0)return P.$n2.trivial(h,l);const p=new y.$s2(h.length,l.length),b=new y.$s2(h.length,l.length),m=new y.$s2(h.length,l.length);for(let a=0;a<h.length;a++)for(let f=0;f<l.length;f++){if(!u.isValid())return P.$n2.trivialTimedOut(h,l);const n=a===0?0:p.get(a-1,f),s=f===0?0:p.get(a,f-1);let w;h.getElement(a)===l.getElement(f)?(a===0||f===0?w=0:w=p.get(a-1,f-1),a>0&&f>0&&b.get(a-1,f-1)===3&&(w+=m.get(a-1,f-1)),w+=c?c(a,f):1):w=-1;const g=Math.max(n,s,w);if(g===w){const A=a>0&&f>0?m.get(a-1,f-1):0;m.set(a,f,A+1),b.set(a,f,3)}else g===n?(m.set(a,f,0),b.set(a,f,1)):g===s&&(m.set(a,f,0),b.set(a,f,2));p.set(a,f,g)}const e=[];let N=h.length,j=l.length;function L(a,f){(a+1!==N||f+1!==j)&&e.push(new P.$o2(new i.$ft(a+1,N),new i.$ft(f+1,j))),N=a,j=f}let $=h.length-1,d=l.length-1;for(;$>=0&&d>=0;)b.get($,d)===3?(L($,d),$--,d--):b.get($,d)===1?$--:d--;return L(-1,-1),e.reverse(),new P.$n2(e,!1)}}t.$v2=o}),re(ie[32],se([0,1,9,4,5,2,15]),function(V,t,i,P,y,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x2=void 0;class h{constructor(e,N,j){this.lines=e,this.considerWhitespaceChanges=j,this.b=[],this.c=[],this.d=[];let L=!1;N.start>0&&N.endExclusive>=e.length&&(N=new P.$ft(N.start-1,N.endExclusive),L=!0),this.lineRange=N,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let d=e[$],a=0;if(L)a=d.length,d="",L=!1;else if(!j){const f=d.trimStart();a=d.length-f.length,d=f.trimEnd()}this.d.push(a);for(let f=0;f<d.length;f++)this.b.push(d.charCodeAt(f));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new P.$ft(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(N=>String.fromCharCode(N)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const N=b(e>0?this.b[e-1]:-1),j=b(e<this.b.length?this.b[e]:-1);if(N===7&&j===8)return 0;if(N===8)return 150;let L=0;return N!==j&&(L+=10,N===0&&j===1&&(L+=1)),L+=p(N),L+=p(j),L}translateOffset(e){if(this.lineRange.isEmpty)return new y.$0s(this.lineRange.start+1,1);const N=(0,i.$ib)(this.c,j=>j<=e);return new y.$0s(this.lineRange.start+N+1,e-this.c[N]+this.d[N]+1)}translateRange(e){return o.$$s.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let N=e;for(;N>0&&l(this.b[N-1]);)N--;let j=e;for(;j<this.b.length&&l(this.b[j]);)j++;return new P.$ft(N,j)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,N){return this.b[e]===this.b[N]}extendToFullLines(e){const N=(0,i.$hb)(this.c,L=>L<=e.start)??0,j=(0,i.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new P.$ft(N,j)}}t.$x2=h;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var u;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const c={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function p(m){return c[m]}function b(m){return m===10?8:m===13?7:(0,v.$t2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),re(ie[33],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nt=t.$mt=void 0;class i{constructor(o,v,h){this.changes=o,this.moves=v,this.hitTimeout=h}}t.$mt=i;class P{constructor(o,v){this.lineRangeMapping=o,this.changes=v}flip(){return new P(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$nt=P}),re(ie[16],se([0,1,12]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lt=t.$kt=t.$jt=void 0;class P{static inverse(h,l,u){const c=[];let p=1,b=1;for(const e of h){const N=new P(new i.$ht(p,e.original.startLineNumber),new i.$ht(b,e.modified.startLineNumber));N.modified.isEmpty||c.push(N),p=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const m=new P(new i.$ht(p,l+1),new i.$ht(b,u+1));return m.modified.isEmpty||c.push(m),c}static clip(h,l,u){const c=[];for(const p of h){const b=p.original.intersect(l),m=p.modified.intersect(u);b&&!b.isEmpty&&m&&!m.isEmpty&&c.push(new P(b,m))}return c}constructor(h,l){this.original=h,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new P(this.modified,this.original)}join(h){return new P(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$jt=P;class y extends P{constructor(h,l,u){super(h,l),this.innerChanges=u}flip(){return new y(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$kt=y;class o{constructor(h,l){this.originalRange=h,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$lt=o}),re(ie[50],se([0,1,8,16,6,9,22,12,4,32,15,31]),function(V,t,i,P,y,o,v,h,l,u,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y2=b;function b(d,a,f,n,s,w){let{moves:g,excludedChanges:A}=e(d,a,f,w);if(!w.isValid())return[];const E=d.filter(F=>!A.has(F)),R=N(E,n,s,a,f,w);return(0,y.$1b)(g,R),g=L(g),g=g.filter(F=>{const k=F.original.toOffsetRange().slice(a).map(S=>S.trim());return k.join(`
`).length>=15&&m(k,S=>S.length>=2)>=2}),g=$(d,g),g}function m(d,a){let f=0;for(const n of d)a(n)&&f++;return f}function e(d,a,f,n){const s=[],w=d.filter(E=>E.modified.isEmpty&&E.original.length>=3).map(E=>new c.$u2(E.original,a,E)),g=new Set(d.filter(E=>E.original.isEmpty&&E.modified.length>=3).map(E=>new c.$u2(E.modified,f,E))),A=new Set;for(const E of w){let R=-1,F;for(const k of g){const M=E.computeSimilarity(k);M>R&&(R=M,F=k)}if(R>.9&&F&&(g.delete(F),s.push(new P.$jt(E.range,F.range)),A.add(E.source),A.add(F.source)),!n.isValid())return{moves:s,excludedChanges:A}}return{moves:s,excludedChanges:A}}function N(d,a,f,n,s,w){const g=[],A=new v.$Gc;for(const M of d)for(let S=M.original.startLineNumber;S<M.original.endLineNumberExclusive-2;S++){const D=`${a[S-1]}:${a[S+1-1]}:${a[S+2-1]}`;A.add(D,{range:new h.$ht(S,S+3)})}const E=[];d.sort((0,y.$7b)(M=>M.modified.startLineNumber,y.$9b));for(const M of d){let S=[];for(let D=M.modified.startLineNumber;D<M.modified.endLineNumberExclusive-2;D++){const I=`${f[D-1]}:${f[D+1-1]}:${f[D+2-1]}`,O=new h.$ht(D,D+3),G=[];A.forEach(I,({range:ne})=>{for(const Y of S)if(Y.originalLineRange.endLineNumberExclusive+1===ne.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){Y.originalLineRange=new h.$ht(Y.originalLineRange.startLineNumber,ne.endLineNumberExclusive),Y.modifiedLineRange=new h.$ht(Y.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),G.push(Y);return}const Z={modifiedLineRange:O,originalLineRange:ne};E.push(Z),G.push(Z)}),S=G}if(!w.isValid())return[]}E.sort((0,y.$$b)((0,y.$7b)(M=>M.modifiedLineRange.length,y.$9b)));const R=new h.$it,F=new h.$it;for(const M of E){const S=M.modifiedLineRange.startLineNumber-M.originalLineRange.startLineNumber,D=R.subtractFrom(M.modifiedLineRange),I=F.subtractFrom(M.originalLineRange).getWithDelta(S),O=D.getIntersection(I);for(const G of O.ranges){if(G.length<3)continue;const ne=G,Z=G.delta(-S);g.push(new P.$jt(Z,ne)),R.addRange(ne),F.addRange(Z)}}g.sort((0,y.$7b)(M=>M.original.startLineNumber,y.$9b));const k=new o.$mb(d);for(let M=0;M<g.length;M++){const S=g[M],D=k.findLastMonotonous(W=>W.original.startLineNumber<=S.original.startLineNumber),I=(0,o.$hb)(d,W=>W.modified.startLineNumber<=S.modified.startLineNumber),O=Math.max(S.original.startLineNumber-D.original.startLineNumber,S.modified.startLineNumber-I.modified.startLineNumber),G=k.findLastMonotonous(W=>W.original.startLineNumber<S.original.endLineNumberExclusive),ne=(0,o.$hb)(d,W=>W.modified.startLineNumber<S.modified.endLineNumberExclusive),Z=Math.max(G.original.endLineNumberExclusive-S.original.endLineNumberExclusive,ne.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let Y;for(Y=0;Y<O;Y++){const W=S.original.startLineNumber-Y-1,te=S.modified.startLineNumber-Y-1;if(W>n.length||te>s.length||R.contains(te)||F.contains(W)||!j(n[W-1],s[te-1],w))break}Y>0&&(F.addRange(new h.$ht(S.original.startLineNumber-Y,S.original.startLineNumber)),R.addRange(new h.$ht(S.modified.startLineNumber-Y,S.modified.startLineNumber)));let T;for(T=0;T<Z;T++){const W=S.original.endLineNumberExclusive+T,te=S.modified.endLineNumberExclusive+T;if(W>n.length||te>s.length||R.contains(te)||F.contains(W)||!j(n[W-1],s[te-1],w))break}T>0&&(F.addRange(new h.$ht(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+T)),R.addRange(new h.$ht(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+T))),(Y>0||T>0)&&(g[M]=new P.$jt(new h.$ht(S.original.startLineNumber-Y,S.original.endLineNumberExclusive+T),new h.$ht(S.modified.startLineNumber-Y,S.modified.endLineNumberExclusive+T)))}return g}function j(d,a,f){if(d.trim()===a.trim())return!0;if(d.length>300&&a.length>300)return!1;const s=new p.$w2().compute(new u.$x2([d],new l.$ft(0,1),!1),new u.$x2([a],new l.$ft(0,1),!1),f);let w=0;const g=i.$o2.invert(s.diffs,d.length);for(const F of g)F.seq1Range.forEach(k=>{(0,c.$t2)(d.charCodeAt(k))||w++});function A(F){let k=0;for(let M=0;M<d.length;M++)(0,c.$t2)(F.charCodeAt(M))||k++;return k}const E=A(d.length>a.length?d:a);return w/E>.6&&E>10}function L(d){if(d.length===0)return d;d.sort((0,y.$7b)(f=>f.original.startLineNumber,y.$9b));const a=[d[0]];for(let f=1;f<d.length;f++){const n=a[a.length-1],s=d[f],w=s.original.startLineNumber-n.original.endLineNumberExclusive,g=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(w>=0&&g>=0&&w+g<=2){a[a.length-1]=n.join(s);continue}a.push(s)}return a}function $(d,a){const f=new o.$mb(d);return a=a.filter(n=>{const s=f.findLastMonotonous(A=>A.original.startLineNumber<n.original.endLineNumberExclusive)||new P.$jt(new h.$ht(1,1),new h.$ht(1,1)),w=(0,o.$hb)(d,A=>A.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==w}),a}}),re(ie[51],se([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,16]),function(V,t,i,P,y,o,v,h,l,u,c,p,b,m,e,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$F2=void 0,t.$G2=L,t.$H2=$;class j{constructor(){this.e=new l.$v2,this.f=new u.$w2}computeDiff(a,f,n){if(a.length<=1&&(0,i.$ub)(a,f,(T,W)=>T===W))return new e.$mt([],[],!1);if(a.length===1&&a[0].length===0||f.length===1&&f[0].length===0)return new e.$mt([new N.$kt(new y.$ht(1,a.length+1),new y.$ht(1,f.length+1),[new N.$lt(new v.$$s(1,1,a.length,a[0].length+1),new v.$$s(1,1,f.length,f[0].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?h.$q2.instance:new h.$r2(n.maxComputationTimeMs),w=!n.ignoreTrimWhitespace,g=new Map;function A(T){let W=g.get(T);return W===void 0&&(W=g.size,g.set(T,W)),W}const E=a.map(T=>A(T.trim())),R=f.map(T=>A(T.trim())),F=new b.$z2(E,a),k=new b.$z2(R,f),M=F.length+k.length<1700?this.e.compute(F,k,s,(T,W)=>a[T]===f[W]?f[W].length===0?.1:1+Math.log(1+f[W].length):.99):this.f.compute(F,k);let S=M.diffs,D=M.hitTimeout;S=(0,p.$A2)(F,k,S),S=(0,p.$D2)(F,k,S);const I=[],O=T=>{if(w)for(let W=0;W<T;W++){const te=G+W,K=ne+W;if(a[te]!==f[K]){const he=this.j(a,f,new h.$o2(new o.$ft(te,te+1),new o.$ft(K,K+1)),s,w);for(const r of he.mappings)I.push(r);he.hitTimeout&&(D=!0)}}};let G=0,ne=0;for(const T of S){(0,P.$_c)(()=>T.seq1Range.start-G===T.seq2Range.start-ne);const W=T.seq1Range.start-G;O(W),G=T.seq1Range.endExclusive,ne=T.seq2Range.endExclusive;const te=this.j(a,f,T,s,w);te.hitTimeout&&(D=!0);for(const K of te.mappings)I.push(K)}O(a.length-G);const Z=L(I,a,f);let Y=[];return n.computeMoves&&(Y=this.h(Z,a,f,E,R,s,w)),(0,P.$_c)(()=>{function T(te,K){if(te.lineNumber<1||te.lineNumber>K.length)return!1;const he=K[te.lineNumber-1];return!(te.column<1||te.column>he.length+1)}function W(te,K){return!(te.startLineNumber<1||te.startLineNumber>K.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>K.length+1)}for(const te of Z){if(!te.innerChanges)return!1;for(const K of te.innerChanges)if(!(T(K.modifiedRange.getStartPosition(),f)&&T(K.modifiedRange.getEndPosition(),f)&&T(K.originalRange.getStartPosition(),a)&&T(K.originalRange.getEndPosition(),a)))return!1;if(!W(te.modified,f)||!W(te.original,a))return!1}return!0}),new e.$mt(Z,Y,D)}h(a,f,n,s,w,g,A){return(0,c.$y2)(a,f,n,s,w,g).map(F=>{const k=this.j(f,n,new h.$o2(F.original.toOffsetRange(),F.modified.toOffsetRange()),g,A),M=L(k.mappings,f,n,!0);return new e.$nt(F,M)})}j(a,f,n,s,w){const g=new m.$x2(a,n.seq1Range,w),A=new m.$x2(f,n.seq2Range,w),E=g.length+A.length<500?this.e.compute(g,A,s):this.f.compute(g,A,s);let R=E.diffs;return R=(0,p.$A2)(g,A,R),R=(0,p.$C2)(g,A,R),R=(0,p.$B2)(g,A,R),R=(0,p.$E2)(g,A,R),{mappings:R.map(k=>new N.$lt(g.translateRange(k.seq1Range),A.translateRange(k.seq2Range))),hitTimeout:E.hitTimeout}}}t.$F2=j;function L(d,a,f,n=!1){const s=[];for(const w of(0,i.$Ab)(d.map(g=>$(g,a,f)),(g,A)=>g.original.overlapOrTouch(A.original)||g.modified.overlapOrTouch(A.modified))){const g=w[0],A=w[w.length-1];s.push(new N.$kt(g.original.join(A.original),g.modified.join(A.modified),w.map(E=>E.innerChanges[0])))}return(0,P.$_c)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||f.length-s[s.length-1].modified.endLineNumberExclusive!==a.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,P.$ad)(s,(w,g)=>g.original.startLineNumber-w.original.endLineNumberExclusive===g.modified.startLineNumber-w.modified.endLineNumberExclusive&&w.original.endLineNumberExclusive<g.original.startLineNumber&&w.modified.endLineNumberExclusive<g.modified.startLineNumber)),s}function $(d,a,f){let n=0,s=0;d.modifiedRange.endColumn===1&&d.originalRange.endColumn===1&&d.originalRange.startLineNumber+n<=d.originalRange.endLineNumber&&d.modifiedRange.startLineNumber+n<=d.modifiedRange.endLineNumber&&(s=-1),d.modifiedRange.startColumn-1>=f[d.modifiedRange.startLineNumber-1].length&&d.originalRange.startColumn-1>=a[d.originalRange.startLineNumber-1].length&&d.originalRange.startLineNumber<=d.originalRange.endLineNumber+s&&d.modifiedRange.startLineNumber<=d.modifiedRange.endLineNumber+s&&(n=1);const w=new y.$ht(d.originalRange.startLineNumber+n,d.originalRange.endLineNumber+1+s),g=new y.$ht(d.modifiedRange.startLineNumber+n,d.modifiedRange.endLineNumber+1+s);return new N.$kt(w,g,[d])}}),re(ie[34],se([0,1,25,33,16,7,2,13,12]),function(V,t,i,P,y,o,v,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pt=t.$ot=void 0;const u=3;class c{computeDiff(n,s,w){const A=new L(n,s,{maxComputationTime:w.maxComputationTimeMs,shouldIgnoreTrimWhitespace:w.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),E=[];let R=null;for(const F of A.changes){let k;F.originalEndLineNumber===0?k=new l.$ht(F.originalStartLineNumber+1,F.originalStartLineNumber+1):k=new l.$ht(F.originalStartLineNumber,F.originalEndLineNumber+1);let M;F.modifiedEndLineNumber===0?M=new l.$ht(F.modifiedStartLineNumber+1,F.modifiedStartLineNumber+1):M=new l.$ht(F.modifiedStartLineNumber,F.modifiedEndLineNumber+1);let S=new y.$kt(k,M,F.charChanges?.map(D=>new y.$lt(new v.$$s(D.originalStartLineNumber,D.originalStartColumn,D.originalEndLineNumber,D.originalEndColumn),new v.$$s(D.modifiedStartLineNumber,D.modifiedStartColumn,D.modifiedEndLineNumber,D.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===S.modified.startLineNumber||R.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new y.$kt(R.original.join(S.original),R.modified.join(S.modified),R.innerChanges&&S.innerChanges?R.innerChanges.concat(S.innerChanges):void 0),E.pop()),E.push(S),R=S}return(0,h.$_c)(()=>(0,h.$ad)(E,(F,k)=>k.original.startLineNumber-F.original.endLineNumberExclusive===k.modified.startLineNumber-F.modified.endLineNumberExclusive&&F.original.endLineNumberExclusive<k.original.startLineNumber&&F.modified.endLineNumberExclusive<k.modified.startLineNumber)),new P.$mt(E,[],A.quitEarly)}}t.$ot=c;function p(f,n,s,w){return new i.$et(f,n,s).ComputeDiff(w)}class b{constructor(n){const s=[],w=[];for(let g=0,A=n.length;g<A;g++)s[g]=$(n[g],1),w[g]=d(n[g],1);this.lines=n,this.a=s,this.b=w}getElements(){const n=[];for(let s=0,w=this.lines.length;s<w;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,w){const g=[],A=[],E=[];let R=0;for(let F=s;F<=w;F++){const k=this.lines[F],M=n?this.a[F]:1,S=n?this.b[F]:k.length+1;for(let D=M;D<S;D++)g[R]=k.charCodeAt(D-1),A[R]=F+1,E[R]=D,R++;!n&&F<w&&(g[R]=10,A[R]=F+1,E[R]=k.length+1,R++)}return new m(g,A,E)}}class m{constructor(n,s,w){this.a=n,this.b=s,this.d=w}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,w,g,A,E,R,F){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=w,this.originalEndColumn=g,this.modifiedStartLineNumber=A,this.modifiedStartColumn=E,this.modifiedEndLineNumber=R,this.modifiedEndColumn=F}static createFromDiffChange(n,s,w){const g=s.getStartLineNumber(n.originalStart),A=s.getStartColumn(n.originalStart),E=s.getEndLineNumber(n.originalStart+n.originalLength-1),R=s.getEndColumn(n.originalStart+n.originalLength-1),F=w.getStartLineNumber(n.modifiedStart),k=w.getStartColumn(n.modifiedStart),M=w.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),S=w.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(g,A,E,R,F,k,M,S)}}function N(f){if(f.length<=1)return f;const n=[f[0]];let s=n[0];for(let w=1,g=f.length;w<g;w++){const A=f[w],E=A.originalStart-(s.originalStart+s.originalLength),R=A.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(E,R)<u?(s.originalLength=A.originalStart+A.originalLength-s.originalStart,s.modifiedLength=A.modifiedStart+A.modifiedLength-s.modifiedStart):(n.push(A),s=A)}return n}class j{constructor(n,s,w,g,A){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=w,this.modifiedEndLineNumber=g,this.charChanges=A}static createFromDiffResult(n,s,w,g,A,E,R){let F,k,M,S,D;if(s.originalLength===0?(F=w.getStartLineNumber(s.originalStart)-1,k=0):(F=w.getStartLineNumber(s.originalStart),k=w.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(M=g.getStartLineNumber(s.modifiedStart)-1,S=0):(M=g.getStartLineNumber(s.modifiedStart),S=g.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),E&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&A()){const I=w.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),O=g.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(I.getElements().length>0&&O.getElements().length>0){let G=p(I,O,A,!0).changes;R&&(G=N(G)),D=[];for(let ne=0,Z=G.length;ne<Z;ne++)D.push(e.createFromDiffChange(G[ne],I,O))}}return new j(F,k,M,S,D)}}class L{constructor(n,s,w){this.a=w.shouldComputeCharChanges,this.b=w.shouldPostProcessCharChanges,this.d=w.shouldIgnoreTrimWhitespace,this.e=w.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new b(n),this.j=new b(s),this.k=a(w.maxComputationTime),this.l=a(w.maxComputationTime===0?0:Math.min(w.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=p(this.h,this.j,this.k,this.e),s=n.changes,w=n.quitEarly;if(this.d){const R=[];for(let F=0,k=s.length;F<k;F++)R.push(j.createFromDiffResult(this.d,s[F],this.h,this.j,this.l,this.a,this.b));return{quitEarly:w,changes:R}}const g=[];let A=0,E=0;for(let R=-1,F=s.length;R<F;R++){const k=R+1<F?s[R+1]:null,M=k?k.originalStart:this.f.length,S=k?k.modifiedStart:this.g.length;for(;A<M&&E<S;){const D=this.f[A],I=this.g[E];if(D!==I){{let O=$(D,1),G=$(I,1);for(;O>1&&G>1;){const ne=D.charCodeAt(O-2),Z=I.charCodeAt(G-2);if(ne!==Z)break;O--,G--}(O>1||G>1)&&this.m(g,A+1,1,O,E+1,1,G)}{let O=d(D,1),G=d(I,1);const ne=D.length+1,Z=I.length+1;for(;O<ne&&G<Z;){const Y=D.charCodeAt(O-1),T=D.charCodeAt(G-1);if(Y!==T)break;O++,G++}(O<ne||G<Z)&&this.m(g,A+1,O,ne,E+1,G,Z)}}A++,E++}k&&(g.push(j.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),A+=k.originalLength,E+=k.modifiedLength)}return{quitEarly:w,changes:g}}m(n,s,w,g,A,E,R){if(this.n(n,s,w,g,A,E,R))return;let F;this.a&&(F=[new e(s,w,s,g,A,E,A,R)]),n.push(new j(s,s,A,A,F))}n(n,s,w,g,A,E,R){const F=n.length;if(F===0)return!1;const k=n[F-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===s&&k.modifiedEndLineNumber===A?(this.a&&k.charChanges&&k.charChanges.push(new e(s,w,s,g,A,E,A,R)),!0):k.originalEndLineNumber+1===s&&k.modifiedEndLineNumber+1===A?(k.originalEndLineNumber=s,k.modifiedEndLineNumber=A,this.a&&k.charChanges&&k.charChanges.push(new e(s,w,s,g,A,E,A,R)),!0):!1}}t.$pt=L;function $(f,n){const s=o.$_e(f);return s===-1?n:s+1}function d(f,n){const s=o.$bf(f);return s===-1?n:s+2}function a(f){if(f===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<f}}),re(ie[52],se([0,1,34,51]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I2=void 0,t.$I2={getLegacy:()=>new i.$ot,getDefault:()=>new P.$F2}}),re(ie[53],se([0,1,36]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J2=p;function P(b){const m=[];for(const e of b){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&m.push(N)}return m}function y(b,m,e,N){return{red:b/255,blue:e/255,green:m/255,alpha:N}}function o(b,m){const e=m.index,N=m[0].length;if(!e)return;const j=b.positionAt(e);return{startLineNumber:j.lineNumber,startColumn:j.column,endLineNumber:j.lineNumber,endColumn:j.column+N}}function v(b,m){if(!b)return;const e=i.$Ct.Format.CSS.parseHex(m);if(e)return{range:b,color:y(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(b,m,e){if(!b||m.length!==1)return;const j=m[0].values(),L=P(j);return{range:b,color:y(L[0],L[1],L[2],e?L[3]:1)}}function l(b,m,e){if(!b||m.length!==1)return;const j=m[0].values(),L=P(j),$=new i.$Ct(new i.$At(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:y($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(b,m){return typeof b=="string"?[...b.matchAll(m)]:b.findMatches(m)}function c(b){const m=[],N=u(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const j of N){const L=j.filter(f=>f!==void 0),$=L[1],d=L[2];if(!d)continue;let a;if($==="rgb"){const f=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;a=h(o(b,j),u(d,f),!1)}else if($==="rgba"){const f=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=h(o(b,j),u(d,f),!0)}else if($==="hsl"){const f=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;a=l(o(b,j),u(d,f),!1)}else if($==="hsla"){const f=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=l(o(b,j),u(d,f),!0)}else $==="#"&&(a=v(o(b,j),$+d));a&&m.push(a)}return m}function p(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:c(b)}}),re(ie[54],se([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i2=t.$h2=t.State=void 0,t.$j2=b;var P;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class y{constructor(e,N,j){const L=new Uint8Array(e*N);for(let $=0,d=e*N;$<d;$++)L[$]=j;this.a=L,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,j){this.a[e*this.cols+N]=j}}class o{constructor(e){let N=0,j=0;for(let $=0,d=e.length;$<d;$++){const[a,f,n]=e[$];f>N&&(N=f),a>j&&(j=a),n>j&&(j=n)}N++,j++;const L=new y(j,N,0);for(let $=0,d=e.length;$<d;$++){const[a,f,n]=e[$];L.set(a,f,n)}this.a=L,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.$h2=o;let v=null;function h(){return v===null&&(v=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),v}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let u=null;function c(){if(u===null){u=new i.$vt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<m.length;N++)u.set(m.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)u.set(e.charCodeAt(N),2)}return u}class p{static a(e,N,j,L,$){let d=$-1;do{const a=N.charCodeAt(d);if(e.get(a)!==2)break;d--}while(d>L);if(L>0){const a=N.charCodeAt(L-1),f=N.charCodeAt(d);(a===40&&f===41||a===91&&f===93||a===123&&f===125)&&d--}return{range:{startLineNumber:j,startColumn:L+1,endLineNumber:j,endColumn:d+2},url:N.substring(L,d+1)}}static computeLinks(e,N=h()){const j=c(),L=[];for(let $=1,d=e.getLineCount();$<=d;$++){const a=e.getLineContent($),f=a.length;let n=0,s=0,w=0,g=1,A=!1,E=!1,R=!1,F=!1;for(;n<f;){let k=!1;const M=a.charCodeAt(n);if(g===13){let S;switch(M){case 40:A=!0,S=0;break;case 41:S=A?0:1;break;case 91:R=!0,E=!0,S=0;break;case 93:R=!1,S=E?0:1;break;case 123:F=!0,S=0;break;case 125:S=F?0:1;break;case 39:case 34:case 96:w===M?S=1:w===39||w===34||w===96?S=0:S=1;break;case 42:S=w===42?1:0;break;case 124:S=w===124?1:0;break;case 32:S=R?0:1;break;default:S=j.get(M)}S===1&&(L.push(p.a(j,a,$,s,n)),k=!0)}else if(g===12){let S;M===91?(E=!0,S=0):S=j.get(M),S===1?k=!0:g=13}else g=N.nextState(g,M),g===0&&(k=!0);k&&(g=1,A=!1,E=!1,F=!1,s=n+1,w=M),n++}g===13&&L.push(p.a(j,a,$,s,f))}return L}}t.$i2=p;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:p.computeLinks(m)}}),re(ie[55],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$k2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(y,o,v,h,l){if(y&&o){const u=this.a(o,l);if(u)return{range:y,value:u}}if(v&&h){const u=this.a(h,l);if(u)return{range:v,value:u}}return null}a(y,o){const v=this.b(y,o);return v!==null?v:this.d(y,o)}b(y,o){const v=Math.pow(10,y.length-(y.lastIndexOf(".")+1));let h=Number(y);const l=parseFloat(y);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!o?null:(h=Math.floor(h*v),h+=o?v:-v,String(h/v)):null}d(y,o){return this.e(this.c,y,o)}e(y,o,v){let h=null;for(let l=0,u=y.length;h===null&&l<u;l++)h=this.f(y[l],o,v);return h}f(y,o,v){let h=y.indexOf(o);return h>=0?(h+=v?1:-1,h<0?h=y.length-1:h%=y.length,y[h]):null}}t.$k2=i}),re(ie[56],se([0,1,14]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wv=t.$vv=t.$uv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$sv=t.$rv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$tv=m,t.$xv=d;var P;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var y;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=3]="Right"})(y||(t.GlyphMarginLane=y={}));var o;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var v;(function(a){a[a.Both=0]="Both",a[a.Right=1]="Right",a[a.Left=2]="Left",a[a.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var h;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var l;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var u;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));class c{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),f.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,f.indentSize|0),this.a=!1),this.insertSpaces=!!f.insertSpaces,this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=!!f.trimAutoWhitespace,this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.a===f.a&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,i.$Qn)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}t.$rv=c;class p{constructor(f,n){this._findMatchBrand=void 0,this.range=f,this.matches=n}}t.$sv=p;var b;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function m(a){return a&&typeof a.read=="function"}var e;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None",a[a.LeftOfInjectedText=3]="LeftOfInjectedText",a[a.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class j{constructor(f,n,s,w,g,A){this.identifier=f,this.range=n,this.text=s,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=g,this._isTracked=A}}t.$uv=j;class L{constructor(f,n,s){this.regex=f,this.wordSeparators=n,this.simpleSearch=s}}t.$vv=L;class ${constructor(f,n,s){this.reverseEdits=f,this.changes=n,this.trimAutoWhitespaceLineNumbers=s}}t.$wv=$;function d(a){return!a.isTooLargeForSyncing()&&!a.isForSimpleWidget}}),re(ie[57],se([0,1,6,28]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cv=t.$Bv=t.$Av=void 0;class y{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,u){l=(0,P.$Se)(l);const c=this.a,p=this.b,b=u.length;return b===0?!1:(this.a=new Uint32Array(c.length+b),this.a.set(c.subarray(0,l),0),this.a.set(c.subarray(l),l+b),this.a.set(u,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(p.subarray(0,this.c[0]+1)),!0)}setValue(l,u){return l=(0,P.$Se)(l),u=(0,P.$Se)(u),this.a[l]===u?!1:(this.a[l]=u,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,u){l=(0,P.$Se)(l),u=(0,P.$Se)(u);const c=this.a,p=this.b;if(l>=c.length)return!1;const b=c.length-l;return u>=b&&(u=b),u===0?!1:(this.a=new Uint32Array(c.length-u),this.a.set(c.subarray(0,l),0),this.a.set(c.subarray(l+u),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(p.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,P.$Se)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),l>=this.a.length&&(l=this.a.length-1);for(let c=u;c<=l;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let u=0,c=this.a.length-1,p=0,b=0,m=0;for(;u<=c;)if(p=u+(c-u)/2|0,b=this.b[p],m=b-this.a[p],l<m)c=p-1;else if(l>=b)u=p+1;else break;return new v(p,l-m)}}t.$Av=y;class o{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const u=this.e[l],c=u>0?this.d[u-1]:0;return new v(u,l-c)}removeValues(l,u){this.a.splice(l,u),this.f(l)}insertValues(l,u){this.a=(0,i.$Wb)(this.a,l,u),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,u=this.a.length;l<u;l++){const c=this.a[l],p=l>0?this.d[l-1]:0;this.d[l]=p+c;for(let b=0;b<c;b++)this.e[p+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,u){this.a[l]!==u&&(this.a[l]=u,this.f(l))}}t.$Bv=o;class v{constructor(l,u){this.index=l,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=u}}t.$Cv=v}),re(ie[58],se([0,1,7,5,57]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dv=void 0;class o{constructor(h,l,u,c){this.d=h,this.f=l,this.g=u,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const l=h.changes;for(const u of l)this.o(u.range),this.p(new P.$0s(u.range.startLineNumber,u.range.startColumn),u.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,l=this.f.length,u=new Uint32Array(l);for(let c=0;c<l;c++)u[c]=this.f[c].length+h;this.j=new y.$Av(u)}}n(h,l){this.f[h]=l,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,l){if(l.length===0)return;const u=(0,i.$0e)(l);if(u.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+u[0]+this.f[h.lineNumber-1].substring(h.column-1));return}u[u.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+u[0]);const c=new Uint32Array(u.length-1);for(let p=1;p<u.length;p++)this.f.splice(h.lineNumber+p-1,0,u[p]),c[p-1]=u[p].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,c)}}t.$Dv=o}),re(ie[59],se([0,1,7,46,5,2,56]),function(V,t,i,P,y,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oC=t.$mC=t.$jC=void 0,t.$kC=u,t.$lC=c,t.$nC=N;const h=999;class l{constructor($,d,a,f){this.searchString=$,this.isRegex=d,this.matchCase=a,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let d=null;try{d=i.$8e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!d)return null;let a=!this.isRegex&&!$;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new v.$vv(d,this.wordSeparators?(0,P.$yt)(this.wordSeparators):null,a?this.searchString:null)}}t.$jC=l;function u(L){if(!L||L.length===0)return!1;for(let $=0,d=L.length;$<d;$++){const a=L.charCodeAt($);if(a===10)return!0;if(a===92){if($++,$>=d)break;const f=L.charCodeAt($);if(f===110||f===114||f===87)return!0}}return!1}function c(L,$,d){if(!d)return new v.$sv(L,null);const a=[];for(let f=0,n=$.length;f<n;f++)a[f]=$[f];return new v.$sv(L,a)}class p{constructor($){const d=[];let a=0;for(let f=0,n=$.length;f<n;f++)$.charCodeAt(f)===10&&(d[a++]=f);this.a=d}findLineFeedCountBeforeOffset($){const d=this.a;let a=0,f=d.length-1;if(f===-1||$<=d[0])return 0;for(;a<f;){const n=a+((f-a)/2>>0);d[n]>=$?f=n-1:d[n+1]>=$?(a=n,f=n):a=n+1}return a+1}}class b{static findMatches($,d,a,f,n){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b($,a,new j(s.wordSeparators,s.regex),f,n):this.c($,a,s,f,n):[]}static a($,d,a,f,n,s){let w,g=0;f?(g=f.findLineFeedCountBeforeOffset(n),w=d+n+g):w=d+n;let A;if(f){const k=f.findLineFeedCountBeforeOffset(n+s.length)-g;A=w+s.length+k}else A=w+s.length;const E=$.getPositionAt(w),R=$.getPositionAt(A);return new o.$$s(E.lineNumber,E.column,R.lineNumber,R.column)}static b($,d,a,f,n){const s=$.getOffsetAt(d.getStartPosition()),w=$.getValueInRange(d,1),g=$.getEOL()===`\r
`?new p(w):null,A=[];let E=0,R;for(a.reset(0);R=a.next(w);)if(A[E++]=c(this.a($,s,w,g,R.index,R[0]),R,f),E>=n)return A;return A}static c($,d,a,f,n){const s=[];let w=0;if(d.startLineNumber===d.endLineNumber){const A=$.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return w=this.d(a,A,d.startLineNumber,d.startColumn-1,w,s,f,n),s}const g=$.getLineContent(d.startLineNumber).substring(d.startColumn-1);w=this.d(a,g,d.startLineNumber,d.startColumn-1,w,s,f,n);for(let A=d.startLineNumber+1;A<d.endLineNumber&&w<n;A++)w=this.d(a,$.getLineContent(A),A,0,w,s,f,n);if(w<n){const A=$.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);w=this.d(a,A,d.endLineNumber,0,w,s,f,n)}return s}static d($,d,a,f,n,s,w,g){const A=$.wordSeparators;if(!w&&$.simpleSearch){const F=$.simpleSearch,k=F.length,M=d.length;let S=-k;for(;(S=d.indexOf(F,S+k))!==-1;)if((!A||N(A,d,M,S,k))&&(s[n++]=new v.$sv(new o.$$s(a,S+1+f,a,S+1+k+f),null),n>=g))return n;return n}const E=new j($.wordSeparators,$.regex);let R;E.reset(0);do if(R=E.next(d),R&&(s[n++]=c(new o.$$s(a,R.index+1+f,a,R.index+1+R[0].length+f),R,w),n>=g))return n;while(R);return n}static findNextMatch($,d,a,f){const n=d.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,a,s,f):this.f($,a,s,f)}static e($,d,a,f){const n=new y.$0s(d.lineNumber,1),s=$.getOffsetAt(n),w=$.getLineCount(),g=$.getValueInRange(new o.$$s(n.lineNumber,n.column,w,$.getLineMaxColumn(w)),1),A=$.getEOL()===`\r
`?new p(g):null;a.reset(d.column-1);const E=a.next(g);return E?c(this.a($,s,g,A,E.index,E[0]),E,f):d.lineNumber!==1||d.column!==1?this.e($,new y.$0s(1,1),a,f):null}static f($,d,a,f){const n=$.getLineCount(),s=d.lineNumber,w=$.getLineContent(s),g=this.g(a,w,s,d.column,f);if(g)return g;for(let A=1;A<=n;A++){const E=(s+A-1)%n,R=$.getLineContent(E+1),F=this.g(a,R,E+1,1,f);if(F)return F}return null}static g($,d,a,f,n){$.reset(f-1);const s=$.next(d);return s?c(new o.$$s(a,s.index+1,a,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,d,a,f){const n=d.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,a,s,f):this.j($,a,s,f)}static h($,d,a,f){const n=this.b($,new o.$$s(1,1,d.lineNumber,d.column),a,f,10*h);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return d.lineNumber!==s||d.column!==$.getLineMaxColumn(s)?this.h($,new y.$0s(s,$.getLineMaxColumn(s)),a,f):null}static j($,d,a,f){const n=$.getLineCount(),s=d.lineNumber,w=$.getLineContent(s).substring(0,d.column-1),g=this.k(a,w,s,f);if(g)return g;for(let A=1;A<=n;A++){const E=(n+s-A-1)%n,R=$.getLineContent(E+1),F=this.k(a,R,E+1,f);if(F)return F}return null}static k($,d,a,f){let n=null,s;for($.reset(0);s=$.next(d);)n=c(new o.$$s(a,s.index+1,a,s.index+1+s[0].length),s,f);return n}}t.$mC=b;function m(L,$,d,a,f){if(a===0)return!0;const n=$.charCodeAt(a-1);if(L.get(n)!==0||n===13||n===10)return!0;if(f>0){const s=$.charCodeAt(a);if(L.get(s)!==0)return!0}return!1}function e(L,$,d,a,f){if(a+f===d)return!0;const n=$.charCodeAt(a+f);if(L.get(n)!==0||n===13||n===10)return!0;if(f>0){const s=$.charCodeAt(a+f-1);if(L.get(s)!==0)return!0}return!1}function N(L,$,d,a,f){return m(L,$,d,a,f)&&e(L,$,d,a,f)}class j{constructor($,d){this._wordSeparators=$,this.a=d,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const d=$.length;let a;do{if(this.b+this.c===d||(a=this.a.exec($),!a))return null;const f=a.index,n=a[0].length;if(f===this.b&&n===this.c){if(n===0){i.$rf($,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=f,this.c=n,!this._wordSeparators||N(this._wordSeparators,$,d,f,n))return a}while(a);return null}}t.$oC=j}),re(ie[60],se([0,1,2,59,7,13,30]),function(V,t,i,P,y,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$g2=void 0;class h{static computeUnicodeHighlights(e,N,j){const L=j?j.startLineNumber:1,$=j?j.endLineNumber:e.getLineCount(),d=new c(N),a=d.getCandidateCodePoints();let f;a==="allNonBasicAscii"?f=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):f=new RegExp(`${l(Array.from(a))}`,"g");const n=new P.$oC(null,f),s=[];let w=!1,g,A=0,E=0,R=0;e:for(let F=L,k=$;F<=k;F++){const M=e.getLineContent(F),S=M.length;n.reset(0);do if(g=n.next(M),g){let D=g.index,I=g.index+g[0].length;if(D>0){const Z=M.charCodeAt(D-1);y.$of(Z)&&D--}if(I+1<S){const Z=M.charCodeAt(I-1);y.$of(Z)&&I++}const O=M.substring(D,I);let G=(0,v.$Ns)(D+1,v.$Ks,M,0);G&&G.endColumn<=D+1&&(G=null);const ne=d.shouldHighlightNonBasicASCII(O,G?G.word:null);if(ne!==0){if(ne===3?A++:ne===2?E++:ne===1?R++:(0,o.$9c)(ne),s.length>=1e3){w=!0;break e}s.push(new i.$$s(F,D+1,F,I+1))}}while(g)}return{ranges:s,hasMore:w,ambiguousCharacterCount:A,invisibleCharacterCount:E,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,N){const j=new c(N);switch(j.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),d=j.ambiguousCharacters.getPrimaryConfusable($),a=y.$Rf.getLocales().filter(f=>!y.$Rf.getInstance(new Set([...N.allowedLocales,f])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}t.$g2=h;function l(m,e){return`[${y.$Ye(m.map(j=>String.fromCodePoint(j)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=y.$Rf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of y.$Sf.codePoints)p(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const j=e.codePointAt(0);if(this.a.has(j))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(N)for(const d of N){const a=d.codePointAt(0),f=y.$zf(d);L=L||f,!f&&!this.ambiguousCharacters.isAmbiguous(a)&&!y.$Sf.isInvisibleCharacter(a)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!p(e)&&y.$Sf.isInvisibleCharacter(j)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(j)?3:0}}function p(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),re(ie[61],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var P;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var y;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(y||(t.CompletionItemInsertTextRule=y={}));var o;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var v;(function(r){r[r.Deprecated=1]="Deprecated"})(v||(t.CompletionItemTag=v={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var p;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(p||(t.DocumentHighlightKind=p={}));var b;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSeparators=130]="wordSeparators",r[r.wordWrap=131]="wordWrap",r[r.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=134]="wordWrapColumn",r[r.wordWrapOverride1=135]="wordWrapOverride1",r[r.wordWrapOverride2=136]="wordWrapOverride2",r[r.wrappingIndent=137]="wrappingIndent",r[r.wrappingStrategy=138]="wrappingStrategy",r[r.showDeprecated=139]="showDeprecated",r[r.inlayHints=140]="inlayHints",r[r.editorClassName=141]="editorClassName",r[r.pixelRatio=142]="pixelRatio",r[r.tabFocusMode=143]="tabFocusMode",r[r.layoutInfo=144]="layoutInfo",r[r.wrappingInfo=145]="wrappingInfo",r[r.defaultColorDecorators=146]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var j;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(j||(t.GlyphMarginLane=j={}));var L;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var $;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var d;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(d||(t.InlayHintKind=d={}));var a;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(a||(t.InlineCompletionTriggerKind=a={}));var f;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(f||(t.InlineEditTriggerKind=f={}));var n;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s||(t.MarkerSeverity=s={}));var w;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(w||(t.MarkerTag=w={}));var g;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(g||(t.MinimapPosition=g={}));var A;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(A||(t.MouseTargetType=A={}));var E;(function(r){r[r.AIGenerated=1]="AIGenerated"})(E||(t.NewSymbolNameTag=E={}));var R;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(R||(t.OverlayWidgetPositionPreference=R={}));var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var k;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(k||(t.PartialAcceptTriggerKind=k={}));var M;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(M||(t.PositionAffinity=M={}));var S;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(S||(t.RenderLineNumbersType=S={}));var D;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(D||(t.RenderMinimap=D={}));var I;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(I||(t.ScrollType=I={}));var O;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(O||(t.ScrollbarVisibility=O={}));var G;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(G||(t.SelectionDirection=G={}));var ne;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(ne||(t.ShowLightbulbIconMode=ne={}));var Z;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(Z||(t.SignatureHelpTriggerKind=Z={}));var Y;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(Y||(t.SymbolKind=Y={}));var T;(function(r){r[r.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var W;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(W||(t.TextEditorCursorBlinkingStyle=W={}));var te;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(te||(t.TextEditorCursorStyle=te={}));var K;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(K||(t.TrackedRangeStickiness=K={}));var he;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(he||(t.WrappingIndent=he={}))}),re(ie[62],se([0,1,11,10]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jt=void 0;class y{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$6d,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this.a.set(h,l),this.handleChange([h]),(0,P.$Rc)(()=>{this.a.get(h)===l&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,l){this.b.get(h)?.dispose();const u=new o(this,h,l);return this.b.set(h,u),(0,P.$Rc)(()=>{const c=this.b.get(h);!c||c!==u||(this.b.delete(h),c.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const u=this.b.get(h);return!u||u.isResolved?null:(await u.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const u=this.b.get(h);return!!(!u||u.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Jt=y;class o extends P.$Tc{get isResolved(){return this.c}constructor(h,l,u){super(),this.f=h,this.g=l,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),re(ie[63],se([64,65]),function(V,t){return V.create("vs/base/common/platform",t)}),re(ie[17],se([0,1,63]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=F,t.$J=k,t.$g="en";let P=!1,y=!1,o=!1,v=!1,h=!1,l=!1,u=!1,c=!1,p=!1,b=!1,m,e=t.$g,N=t.$g,j,L;const $=globalThis;let d;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?d=$.vscode.process:typeof process<"u"&&(d=process);const a=typeof d?.versions?.electron=="string",f=a&&d?.type==="renderer";if(typeof d=="object"){P=d.platform==="win32",y=d.platform==="darwin",o=d.platform==="linux",v=o&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,u=a,p=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const M=d.env.VSCODE_NLS_CONFIG;if(M)try{const S=JSON.parse(M),D=S.availableLanguages["*"];m=S.locale,N=S.osLocale,e=D||t.$g,j=S._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!f?(L=navigator.userAgent,P=L.indexOf("Windows")>=0,y=L.indexOf("Macintosh")>=0,c=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=L.indexOf("Linux")>=0,b=L?.indexOf("Mobi")>=0,l=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,N=navigator.language):console.error("Unable to resolve platform.");var n;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let w=0;y?w=1:P?w=3:o&&(w=2),t.$i=P,t.$j=y,t.$k=o,t.$l=v,t.$m=h,t.$n=u,t.$o=l,t.$p=l&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=c,t.$s=b,t.$t=p,t.$u=w,t.$v=L,t.$w=e;var g;(function(M){function S(){return t.$w}M.value=S;function D(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}M.isDefaultVariant=D;function I(){return t.$w==="en"}M.isDefault=I})(g||(t.Language=g={})),t.$x=m,t.$y=N,t.$z=j,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const M=[];$.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let I=0,O=M.length;I<O;I++){const G=M[I];if(G.id===D.data.vscodeScheduleAsyncWork){M.splice(I,1),G.callback();return}}});let S=0;return D=>{const I=++S;M.push({id:I,callback:D}),$.postMessage({vscodeScheduleAsyncWork:I},"*")}}return M=>setTimeout(M)})();var A;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(A||(t.OperatingSystem=A={})),t.OS=y||c?2:P?1:3;let E=!0,R=!1;function F(){if(!R){R=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,E=new Uint16Array(M.buffer)[0]===513}return E}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function k(M){return parseFloat(M)>=20}}),re(ie[66],se([0,1,17]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const o=y.process;P={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),re(ie[67],se([0,1,66]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,y=97,o=90,v=122,h=46,l=47,u=92,c=58,p=63;class b extends Error{constructor(s,w,g){let A;typeof w=="string"&&w.indexOf("not ")===0?(A="must not be",w=w.replace(/^not /,"")):A="must be";const E=s.indexOf(".")!==-1?"property":"argument";let R=`The "${s}" ${E} ${A} of type ${w}`;R+=`. Received type ${typeof g}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new b(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new b(s,"string",n)}const N=i.$dc==="win32";function j(n){return n===l||n===u}function L(n){return n===l}function $(n){return n>=P&&n<=o||n>=y&&n<=v}function d(n,s,w,g){let A="",E=0,R=-1,F=0,k=0;for(let M=0;M<=n.length;++M){if(M<n.length)k=n.charCodeAt(M);else{if(g(k))break;k=l}if(g(k)){if(!(R===M-1||F===1))if(F===2){if(A.length<2||E!==2||A.charCodeAt(A.length-1)!==h||A.charCodeAt(A.length-2)!==h){if(A.length>2){const S=A.lastIndexOf(w);S===-1?(A="",E=0):(A=A.slice(0,S),E=A.length-1-A.lastIndexOf(w)),R=M,F=0;continue}else if(A.length!==0){A="",E=0,R=M,F=0;continue}}s&&(A+=A.length>0?`${w}..`:"..",E=2)}else A.length>0?A+=`${w}${n.slice(R+1,M)}`:A=n.slice(R+1,M),E=M-R-1;R=M,F=0}else k===h&&F!==-1?++F:F=-1}return A}function a(n,s){m(s,"pathObject");const w=s.dir||s.root,g=s.base||`${s.name||""}${s.ext||""}`;return w?w===s.root?`${w}${g}`:`${w}${n}${g}`:g}t.$fc={resolve(...n){let s="",w="",g=!1;for(let A=n.length-1;A>=-1;A--){let E;if(A>=0){if(E=n[A],e(E,"path"),E.length===0)continue}else s.length===0?E=i.cwd():(E=i.env[`=${s}`]||i.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==s.toLowerCase()&&E.charCodeAt(2)===u)&&(E=`${s}\\`));const R=E.length;let F=0,k="",M=!1;const S=E.charCodeAt(0);if(R===1)j(S)&&(F=1,M=!0);else if(j(S))if(M=!0,j(E.charCodeAt(1))){let D=2,I=D;for(;D<R&&!j(E.charCodeAt(D));)D++;if(D<R&&D!==I){const O=E.slice(I,D);for(I=D;D<R&&j(E.charCodeAt(D));)D++;if(D<R&&D!==I){for(I=D;D<R&&!j(E.charCodeAt(D));)D++;(D===R||D!==I)&&(k=`\\\\${O}\\${E.slice(I,D)}`,F=D)}}}else F=1;else $(S)&&E.charCodeAt(1)===c&&(k=E.slice(0,2),F=2,R>2&&j(E.charCodeAt(2))&&(M=!0,F=3));if(k.length>0)if(s.length>0){if(k.toLowerCase()!==s.toLowerCase())continue}else s=k;if(g){if(s.length>0)break}else if(w=`${E.slice(F)}\\${w}`,g=M,M&&s.length>0)break}return w=d(w,!g,"\\",j),g?`${s}\\${w}`:`${s}${w}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let w=0,g,A=!1;const E=n.charCodeAt(0);if(s===1)return L(E)?"\\":n;if(j(E))if(A=!0,j(n.charCodeAt(1))){let F=2,k=F;for(;F<s&&!j(n.charCodeAt(F));)F++;if(F<s&&F!==k){const M=n.slice(k,F);for(k=F;F<s&&j(n.charCodeAt(F));)F++;if(F<s&&F!==k){for(k=F;F<s&&!j(n.charCodeAt(F));)F++;if(F===s)return`\\\\${M}\\${n.slice(k)}\\`;F!==k&&(g=`\\\\${M}\\${n.slice(k,F)}`,w=F)}}}else w=1;else $(E)&&n.charCodeAt(1)===c&&(g=n.slice(0,2),w=2,s>2&&j(n.charCodeAt(2))&&(A=!0,w=3));let R=w<s?d(n.slice(w),!A,"\\",j):"";return R.length===0&&!A&&(R="."),R.length>0&&j(n.charCodeAt(s-1))&&(R+="\\"),g===void 0?A?`\\${R}`:R:A?`${g}\\${R}`:`${g}${R}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const w=n.charCodeAt(0);return j(w)||s>2&&$(w)&&n.charCodeAt(1)===c&&j(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,w;for(let E=0;E<n.length;++E){const R=n[E];e(R,"path"),R.length>0&&(s===void 0?s=w=R:s+=`\\${R}`)}if(s===void 0)return".";let g=!0,A=0;if(typeof w=="string"&&j(w.charCodeAt(0))){++A;const E=w.length;E>1&&j(w.charCodeAt(1))&&(++A,E>2&&(j(w.charCodeAt(2))?++A:g=!1))}if(g){for(;A<s.length&&j(s.charCodeAt(A));)A++;A>=2&&(s=`\\${s.slice(A)}`)}return t.$fc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const w=t.$fc.resolve(n),g=t.$fc.resolve(s);if(w===g||(n=w.toLowerCase(),s=g.toLowerCase(),n===s))return"";let A=0;for(;A<n.length&&n.charCodeAt(A)===u;)A++;let E=n.length;for(;E-1>A&&n.charCodeAt(E-1)===u;)E--;const R=E-A;let F=0;for(;F<s.length&&s.charCodeAt(F)===u;)F++;let k=s.length;for(;k-1>F&&s.charCodeAt(k-1)===u;)k--;const M=k-F,S=R<M?R:M;let D=-1,I=0;for(;I<S;I++){const G=n.charCodeAt(A+I);if(G!==s.charCodeAt(F+I))break;G===u&&(D=I)}if(I!==S){if(D===-1)return g}else{if(M>S){if(s.charCodeAt(F+I)===u)return g.slice(F+I+1);if(I===2)return g.slice(F+I)}R>S&&(n.charCodeAt(A+I)===u?D=I:I===2&&(D=3)),D===-1&&(D=0)}let O="";for(I=A+D+1;I<=E;++I)(I===E||n.charCodeAt(I)===u)&&(O+=O.length===0?"..":"\\..");return F+=D,O.length>0?`${O}${g.slice(F,k)}`:(g.charCodeAt(F)===u&&++F,g.slice(F,k))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const w=s.charCodeAt(2);if(w!==p&&w!==h)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===c&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let w=-1,g=0;const A=n.charCodeAt(0);if(s===1)return j(A)?n:".";if(j(A)){if(w=g=1,j(n.charCodeAt(1))){let F=2,k=F;for(;F<s&&!j(n.charCodeAt(F));)F++;if(F<s&&F!==k){for(k=F;F<s&&j(n.charCodeAt(F));)F++;if(F<s&&F!==k){for(k=F;F<s&&!j(n.charCodeAt(F));)F++;if(F===s)return n;F!==k&&(w=g=F+1)}}}}else $(A)&&n.charCodeAt(1)===c&&(w=s>2&&j(n.charCodeAt(2))?3:2,g=w);let E=-1,R=!0;for(let F=s-1;F>=g;--F)if(j(n.charCodeAt(F))){if(!R){E=F;break}}else R=!1;if(E===-1){if(w===-1)return".";E=w}return n.slice(0,E)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let w=0,g=-1,A=!0,E;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===c&&(w=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,F=-1;for(E=n.length-1;E>=w;--E){const k=n.charCodeAt(E);if(j(k)){if(!A){w=E+1;break}}else F===-1&&(A=!1,F=E+1),R>=0&&(k===s.charCodeAt(R)?--R===-1&&(g=E):(R=-1,g=F))}return w===g?g=F:g===-1&&(g=n.length),n.slice(w,g)}for(E=n.length-1;E>=w;--E)if(j(n.charCodeAt(E))){if(!A){w=E+1;break}}else g===-1&&(A=!1,g=E+1);return g===-1?"":n.slice(w,g)},extname(n){e(n,"path");let s=0,w=-1,g=0,A=-1,E=!0,R=0;n.length>=2&&n.charCodeAt(1)===c&&$(n.charCodeAt(0))&&(s=g=2);for(let F=n.length-1;F>=s;--F){const k=n.charCodeAt(F);if(j(k)){if(!E){g=F+1;break}continue}A===-1&&(E=!1,A=F+1),k===h?w===-1?w=F:R!==1&&(R=1):w!==-1&&(R=-1)}return w===-1||A===-1||R===0||R===1&&w===A-1&&w===g+1?"":n.slice(w,A)},format:a.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const w=n.length;let g=0,A=n.charCodeAt(0);if(w===1)return j(A)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(j(A)){if(g=1,j(n.charCodeAt(1))){let D=2,I=D;for(;D<w&&!j(n.charCodeAt(D));)D++;if(D<w&&D!==I){for(I=D;D<w&&j(n.charCodeAt(D));)D++;if(D<w&&D!==I){for(I=D;D<w&&!j(n.charCodeAt(D));)D++;D===w?g=D:D!==I&&(g=D+1)}}}}else if($(A)&&n.charCodeAt(1)===c){if(w<=2)return s.root=s.dir=n,s;if(g=2,j(n.charCodeAt(2))){if(w===3)return s.root=s.dir=n,s;g=3}}g>0&&(s.root=n.slice(0,g));let E=-1,R=g,F=-1,k=!0,M=n.length-1,S=0;for(;M>=g;--M){if(A=n.charCodeAt(M),j(A)){if(!k){R=M+1;break}continue}F===-1&&(k=!1,F=M+1),A===h?E===-1?E=M:S!==1&&(S=1):E!==-1&&(S=-1)}return F!==-1&&(E===-1||S===0||S===1&&E===F-1&&E===R+1?s.base=s.name=n.slice(R,F):(s.name=n.slice(R,E),s.base=n.slice(R,F),s.ext=n.slice(E,F))),R>0&&R!==g?s.dir=n.slice(0,R-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(N){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...n){let s="",w=!1;for(let g=n.length-1;g>=-1&&!w;g--){const A=g>=0?n[g]:f();e(A,"path"),A.length!==0&&(s=`${A}/${s}`,w=A.charCodeAt(0)===l)}return s=d(s,!w,"/",L),w?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l,w=n.charCodeAt(n.length-1)===l;return n=d(n,!s,"/",L),n.length===0?s?"/":w?"./":".":(w&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===l},join(...n){if(n.length===0)return".";let s;for(let w=0;w<n.length;++w){const g=n[w];e(g,"path"),g.length>0&&(s===void 0?s=g:s+=`/${g}`)}return s===void 0?".":t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$gc.resolve(n),s=t.$gc.resolve(s),n===s))return"";const w=1,g=n.length,A=g-w,E=1,R=s.length-E,F=A<R?A:R;let k=-1,M=0;for(;M<F;M++){const D=n.charCodeAt(w+M);if(D!==s.charCodeAt(E+M))break;D===l&&(k=M)}if(M===F)if(R>F){if(s.charCodeAt(E+M)===l)return s.slice(E+M+1);if(M===0)return s.slice(E+M)}else A>F&&(n.charCodeAt(w+M)===l?k=M:M===0&&(k=0));let S="";for(M=w+k+1;M<=g;++M)(M===g||n.charCodeAt(M)===l)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(E+k)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l;let w=-1,g=!0;for(let A=n.length-1;A>=1;--A)if(n.charCodeAt(A)===l){if(!g){w=A;break}}else g=!1;return w===-1?s?"/":".":s&&w===1?"//":n.slice(0,w)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let w=0,g=-1,A=!0,E;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,F=-1;for(E=n.length-1;E>=0;--E){const k=n.charCodeAt(E);if(k===l){if(!A){w=E+1;break}}else F===-1&&(A=!1,F=E+1),R>=0&&(k===s.charCodeAt(R)?--R===-1&&(g=E):(R=-1,g=F))}return w===g?g=F:g===-1&&(g=n.length),n.slice(w,g)}for(E=n.length-1;E>=0;--E)if(n.charCodeAt(E)===l){if(!A){w=E+1;break}}else g===-1&&(A=!1,g=E+1);return g===-1?"":n.slice(w,g)},extname(n){e(n,"path");let s=-1,w=0,g=-1,A=!0,E=0;for(let R=n.length-1;R>=0;--R){const F=n.charCodeAt(R);if(F===l){if(!A){w=R+1;break}continue}g===-1&&(A=!1,g=R+1),F===h?s===-1?s=R:E!==1&&(E=1):s!==-1&&(E=-1)}return s===-1||g===-1||E===0||E===1&&s===g-1&&s===w+1?"":n.slice(s,g)},format:a.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const w=n.charCodeAt(0)===l;let g;w?(s.root="/",g=1):g=0;let A=-1,E=0,R=-1,F=!0,k=n.length-1,M=0;for(;k>=g;--k){const S=n.charCodeAt(k);if(S===l){if(!F){E=k+1;break}continue}R===-1&&(F=!1,R=k+1),S===h?A===-1?A=k:M!==1&&(M=1):A!==-1&&(M=-1)}if(R!==-1){const S=E===0&&w?1:E;A===-1||M===0||M===1&&A===R-1&&A===E+1?s.base=s.name=n.slice(S,R):(s.name=n.slice(S,A),s.base=n.slice(S,R),s.ext=n.slice(A,R))}return E>0?s.dir=n.slice(0,E-1):w&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=N?t.$fc.normalize:t.$gc.normalize,t.$ic=N?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=N?t.$fc.join:t.$gc.join,t.$kc=N?t.$fc.resolve:t.$gc.resolve,t.$lc=N?t.$fc.relative:t.$gc.relative,t.$mc=N?t.$fc.dirname:t.$gc.dirname,t.$nc=N?t.$fc.basename:t.$gc.basename,t.$oc=N?t.$fc.extname:t.$gc.extname,t.$pc=N?t.$fc.format:t.$gc.format,t.$qc=N?t.$fc.parse:t.$gc.parse,t.$rc=N?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=N?t.$fc.sep:t.$gc.sep,t.$tc=N?t.$fc.delimiter:t.$gc.delimiter}),re(ie[18],se([0,1,67,17]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$vc=e,t.$wc=a;const y=/^\w[\w\d+.-]*$/,o=/^\//,v=/^\/\//;function h(g,A){if(!g.scheme&&A)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!y.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!o.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(g,A){return!g&&!A?"file":g}function u(g,A){switch(g){case"https":case"http":case"file":A?A[0]!==p&&(A=p+A):A=p;break}return A}const c="",p="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(A){return A instanceof m?!0:A?typeof A.authority=="string"&&typeof A.fragment=="string"&&typeof A.path=="string"&&typeof A.query=="string"&&typeof A.scheme=="string"&&typeof A.fsPath=="string"&&typeof A.with=="function"&&typeof A.toString=="function":!1}constructor(A,E,R,F,k,M=!1){typeof A=="object"?(this.scheme=A.scheme||c,this.authority=A.authority||c,this.path=A.path||c,this.query=A.query||c,this.fragment=A.fragment||c):(this.scheme=l(A,M),this.authority=E||c,this.path=u(this.scheme,R||c),this.query=F||c,this.fragment=k||c,h(this,M))}get fsPath(){return a(this,!1)}with(A){if(!A)return this;let{scheme:E,authority:R,path:F,query:k,fragment:M}=A;return E===void 0?E=this.scheme:E===null&&(E=c),R===void 0?R=this.authority:R===null&&(R=c),F===void 0?F=this.path:F===null&&(F=c),k===void 0?k=this.query:k===null&&(k=c),M===void 0?M=this.fragment:M===null&&(M=c),E===this.scheme&&R===this.authority&&F===this.path&&k===this.query&&M===this.fragment?this:new j(E,R,F,k,M)}static parse(A,E=!1){const R=b.exec(A);return R?new j(R[2]||c,w(R[4]||c),w(R[5]||c),w(R[7]||c),w(R[9]||c),E):new j(c,c,c,c,c)}static file(A){let E=c;if(P.$i&&(A=A.replace(/\\/g,p)),A[0]===p&&A[1]===p){const R=A.indexOf(p,2);R===-1?(E=A.substring(2),A=p):(E=A.substring(2,R),A=A.substring(R)||p)}return new j("file",E,A,c,c)}static from(A,E){return new j(A.scheme,A.authority,A.path,A.query,A.fragment,E)}static joinPath(A,...E){if(!A.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return P.$i&&A.scheme==="file"?R=m.file(i.$fc.join(a(A,!0),...E)).path:R=i.$gc.join(A.path,...E),A.with({path:R})}toString(A=!1){return f(this,A)}toJSON(){return this}static revive(A){if(A){if(A instanceof m)return A;{const E=new j(A);return E._formatted=A.external??null,E._fsPath=A._sep===N?A.fsPath??null:null,E}}else return A}}t.URI=m;function e(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}const N=P.$i?1:void 0;class j extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(A=!1){return A?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const A={$mid:1};return this._fsPath&&(A.fsPath=this._fsPath,A._sep=N),this._formatted&&(A.external=this._formatted),this.path&&(A.path=this.path),this.scheme&&(A.scheme=this.scheme),this.authority&&(A.authority=this.authority),this.query&&(A.query=this.query),this.fragment&&(A.fragment=this.fragment),A}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(g,A,E){let R,F=-1;for(let k=0;k<g.length;k++){const M=g.charCodeAt(k);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||A&&M===47||E&&M===91||E&&M===93||E&&M===58)F!==-1&&(R+=encodeURIComponent(g.substring(F,k)),F=-1),R!==void 0&&(R+=g.charAt(k));else{R===void 0&&(R=g.substr(0,k));const S=L[M];S!==void 0?(F!==-1&&(R+=encodeURIComponent(g.substring(F,k)),F=-1),R+=S):F===-1&&(F=k)}}return F!==-1&&(R+=encodeURIComponent(g.substring(F))),R!==void 0?R:g}function d(g){let A;for(let E=0;E<g.length;E++){const R=g.charCodeAt(E);R===35||R===63?(A===void 0&&(A=g.substr(0,E)),A+=L[R]):A!==void 0&&(A+=g[E])}return A!==void 0?A:g}function a(g,A){let E;return g.authority&&g.path.length>1&&g.scheme==="file"?E=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?A?E=g.path.substr(1):E=g.path[1].toLowerCase()+g.path.substr(2):E=g.path,P.$i&&(E=E.replace(/\//g,"\\")),E}function f(g,A){const E=A?d:$;let R="",{scheme:F,authority:k,path:M,query:S,fragment:D}=g;if(F&&(R+=F,R+=":"),(k||F==="file")&&(R+=p,R+=p),k){let I=k.indexOf("@");if(I!==-1){const O=k.substr(0,I);k=k.substr(I+1),I=O.lastIndexOf(":"),I===-1?R+=E(O,!1,!1):(R+=E(O.substr(0,I),!1,!1),R+=":",R+=E(O.substr(I+1),!1,!0)),R+="@"}k=k.toLowerCase(),I=k.lastIndexOf(":"),I===-1?R+=E(k,!1,!0):(R+=E(k.substr(0,I),!1,!0),R+=k.substr(I))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const I=M.charCodeAt(1);I>=65&&I<=90&&(M=`/${String.fromCharCode(I+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const I=M.charCodeAt(0);I>=65&&I<=90&&(M=`${String.fromCharCode(I+32)}:${M.substr(2)}`)}R+=E(M,!0,!1)}return S&&(R+="?",R+=E(S,!1,!1)),D&&(R+="#",R+=A?D:$(D,!1,!1)),R}function n(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+n(g.substr(3)):g}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(g){return g.match(s)?g.replace(s,A=>n(A)):g}}),re(ie[72],se([0,1,3,11,10,14,17,7]),function(V,t,i,P,y,o,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=s;const l="$initialize";let u=!1;function c(w){v.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(w.message))}var p;(function(w){w[w.Request=0]="Request",w[w.Reply=1]="Reply",w[w.SubscribeEvent=2]="SubscribeEvent",w[w.Event=3]="Event",w[w.UnsubscribeEvent=4]="UnsubscribeEvent"})(p||(p={}));class b{constructor(g,A,E,R){this.vsWorker=g,this.req=A,this.method=E,this.args=R,this.type=0}}class m{constructor(g,A,E,R){this.vsWorker=g,this.seq=A,this.res=E,this.err=R,this.type=1}}class e{constructor(g,A,E,R){this.vsWorker=g,this.req=A,this.eventName=E,this.arg=R,this.type=2}}class N{constructor(g,A,E){this.vsWorker=g,this.req=A,this.event=E,this.type=3}}class j{constructor(g,A){this.vsWorker=g,this.req=A,this.type=4}}class L{constructor(g){this.a=-1,this.g=g,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(g){this.a=g}sendMessage(g,A){const E=String(++this.b);return new Promise((R,F)=>{this.c[E]={resolve:R,reject:F},this.o(new b(this.a,E,g,A))})}listen(g,A){let E=null;const R=new P.$6d({onWillAddFirstListener:()=>{E=String(++this.b),this.d.set(E,R),this.o(new e(this.a,E,g,A))},onDidRemoveLastListener:()=>{this.d.delete(E),this.o(new j(this.a,E)),E=null}});return R.event}handleMessage(g){!g||!g.vsWorker||this.a!==-1&&g.vsWorker!==this.a||this.h(g)}h(g){switch(g.type){case 1:return this.j(g);case 0:return this.k(g);case 2:return this.l(g);case 3:return this.m(g);case 4:return this.n(g)}}j(g){if(!this.c[g.seq]){console.warn("Got reply to unknown seq");return}const A=this.c[g.seq];if(delete this.c[g.seq],g.err){let E=g.err;g.err.$isError&&(E=new Error,E.name=g.err.name,E.message=g.err.message,E.stack=g.err.stack),A.reject(E);return}A.resolve(g.res)}k(g){const A=g.req;this.g.handleMessage(g.method,g.args).then(R=>{this.o(new m(this.a,A,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,i.$3)(R.detail)),this.o(new m(this.a,A,void 0,(0,i.$3)(R)))})}l(g){const A=g.req,E=this.g.handleEvent(g.eventName,g.arg)(R=>{this.o(new N(this.a,A,R))});this.f.set(A,E)}m(g){if(!this.d.has(g.req)){console.warn("Got event for unknown req");return}this.d.get(g.req).fire(g.event)}n(g){if(!this.f.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(g.req).dispose(),this.f.delete(g.req)}o(g){const A=[];if(g.type===0)for(let E=0;E<g.args.length;E++)g.args[E]instanceof ArrayBuffer&&A.push(g.args[E]);else g.type===1&&g.res instanceof ArrayBuffer&&A.push(g.res);this.g.sendMessage(g,A)}}class $ extends y.$Tc{constructor(g,A,E){super();let R=null;this.a=this.B(g.create("vs/base/common/worker/simpleWorker",I=>{this.c.handleMessage(I)},I=>{R?.(I)})),this.c=new L({sendMessage:(I,O)=>{this.a.postMessage(I,O)},handleMessage:(I,O)=>{if(typeof E[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(E[I].apply(E,O))}catch(G){return Promise.reject(G)}},handleEvent:(I,O)=>{if(a(I)){const G=E[I].call(E,O);if(typeof G!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return G}if(d(I)){const G=E[I];if(typeof G!="function")throw new Error(`Missing event ${I} on main thread host.`);return G}throw new Error(`Malformed event name ${I}`)}}),this.c.setWorkerId(this.a.getId());let F=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?F=k.getConfig():typeof globalThis.requirejs<"u"&&(F=globalThis.requirejs.s.contexts._.config);const M=(0,o.$Wn)(E);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(F)),A,M]);const S=(I,O)=>this.g(I,O),D=(I,O)=>this.c.listen(I,O);this.f=new Promise((I,O)=>{R=O,this.b.then(G=>{I(f(G,S,D))},G=>{O(G),this.h("Worker failed to load "+A,G)})})}getProxyObject(){return this.f}g(g,A){return new Promise((E,R)=>{this.b.then(()=>{this.c.sendMessage(g,A).then(E,R)},R)})}h(g,A){console.error(g),console.info(A)}}t.SimpleWorkerClient=$;function d(w){return w[0]==="o"&&w[1]==="n"&&h.$jf(w.charCodeAt(2))}function a(w){return/^onDynamic/.test(w)&&h.$jf(w.charCodeAt(9))}function f(w,g,A){const E=k=>function(){const M=Array.prototype.slice.call(arguments,0);return g(k,M)},R=k=>function(M){return A(k,M)},F={};for(const k of w){if(a(k)){F[k]=R(k);continue}if(d(k)){F[k]=A(k,void 0);continue}F[k]=E(k)}return F}class n{constructor(g,A){this.a=A,this.b=null,this.c=new L({sendMessage:(E,R)=>{g(E,R)},handleMessage:(E,R)=>this.d(E,R),handleEvent:(E,R)=>this.f(E,R)})}onmessage(g){this.c.handleMessage(g)}d(g,A){if(g===l)return this.g(A[0],A[1],A[2],A[3]);if(!this.b||typeof this.b[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this.b[g].apply(this.b,A))}catch(E){return Promise.reject(E)}}f(g,A){if(!this.b)throw new Error("Missing requestHandler");if(a(g)){const E=this.b[g].call(this.b,A);if(typeof E!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return E}if(d(g)){const E=this.b[g];if(typeof E!="function")throw new Error(`Missing event ${g} on request handler.`);return E}throw new Error(`Malformed event name ${g}`)}g(g,A,E,R){this.c.setWorkerId(g);const M=f(R,(S,D)=>this.c.sendMessage(S,D),(S,D)=>this.c.listen(S,D));return this.a?(this.b=this.a(M),Promise.resolve((0,o.$Wn)(this.b))):(A&&(typeof A.baseUrl<"u"&&delete A.baseUrl,typeof A.paths<"u"&&typeof A.paths.vs<"u"&&delete A.paths.vs,typeof A.trustedTypesPolicy<"u"&&delete A.trustedTypesPolicy,A.catchError=!0,globalThis.require.config(A)),new Promise((S,D)=>{(globalThis.require||V)([E],O=>{if(this.b=O.create(M),!this.b){D(new Error("No RequestHandler!"));return}S((0,o.$Wn)(this.b))},D)}))}}t.SimpleWorkerServer=n;function s(w){return new n(w,null)}}),re(ie[68],se([64,65]),function(V,t){return V.create("vs/editor/common/languages",t)}),re(ie[69],se([0,1,43,18,44,2,62,68]),function(V,t,i,P,y,o,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$5t=t.$4t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$3t=t.$2t=t.SymbolKinds=t.SymbolTag=t.$Zt=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$Xt=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Wt=t.$Vt=t.$Ut=void 0,t.$Yt=s,t.$1t=g;class l{constructor(W,te,K){this.offset=W,this.type=te,this.language=K,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Ut=l;class u{constructor(W,te){this.tokens=W,this.endState=te,this._tokenizationResultBrand=void 0}}t.$Vt=u;class c{constructor(W,te){this.tokens=W,this.endState=te,this._encodedTokenizationResultBrand=void 0}}t.$Wt=c;var p;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(p||(t.CompletionItemKind=p={}));var b;(function(T){const W=new Map;W.set(0,i.$Fj.symbolMethod),W.set(1,i.$Fj.symbolFunction),W.set(2,i.$Fj.symbolConstructor),W.set(3,i.$Fj.symbolField),W.set(4,i.$Fj.symbolVariable),W.set(5,i.$Fj.symbolClass),W.set(6,i.$Fj.symbolStruct),W.set(7,i.$Fj.symbolInterface),W.set(8,i.$Fj.symbolModule),W.set(9,i.$Fj.symbolProperty),W.set(10,i.$Fj.symbolEvent),W.set(11,i.$Fj.symbolOperator),W.set(12,i.$Fj.symbolUnit),W.set(13,i.$Fj.symbolValue),W.set(15,i.$Fj.symbolEnum),W.set(14,i.$Fj.symbolConstant),W.set(15,i.$Fj.symbolEnum),W.set(16,i.$Fj.symbolEnumMember),W.set(17,i.$Fj.symbolKeyword),W.set(27,i.$Fj.symbolSnippet),W.set(18,i.$Fj.symbolText),W.set(19,i.$Fj.symbolColor),W.set(20,i.$Fj.symbolFile),W.set(21,i.$Fj.symbolReference),W.set(22,i.$Fj.symbolCustomColor),W.set(23,i.$Fj.symbolFolder),W.set(24,i.$Fj.symbolTypeParameter),W.set(25,i.$Fj.account),W.set(26,i.$Fj.issues);function te(r){let de=W.get(r);return de||(console.info("No codicon found for CompletionItemKind "+r),de=i.$Fj.symbolProperty),de}T.toIcon=te;const K=new Map;K.set("method",0),K.set("function",1),K.set("constructor",2),K.set("field",3),K.set("variable",4),K.set("class",5),K.set("struct",6),K.set("interface",7),K.set("module",8),K.set("property",9),K.set("event",10),K.set("operator",11),K.set("unit",12),K.set("value",13),K.set("constant",14),K.set("enum",15),K.set("enum-member",16),K.set("enumMember",16),K.set("keyword",17),K.set("snippet",27),K.set("text",18),K.set("color",19),K.set("file",20),K.set("reference",21),K.set("customcolor",22),K.set("folder",23),K.set("type-parameter",24),K.set("typeParameter",24),K.set("account",25),K.set("issue",26);function he(r,de){let we=K.get(r);return typeof we>"u"&&!de&&(we=9),we}T.fromString=he})(b||(t.CompletionItemKinds=b={}));var m;(function(T){T[T.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var N;(function(T){T[T.Word=0]="Word",T[T.Line=1]="Line",T[T.Suggest=2]="Suggest"})(N||(t.PartialAcceptTriggerKind=N={}));var j;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j||(t.CompletionTriggerKind=j={}));var L;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(L||(t.InlineCompletionTriggerKind=L={}));class ${constructor(W,te,K,he){this.range=W,this.text=te,this.completionKind=K,this.isSnippetText=he}equals(W){return o.$$s.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}t.$Xt=$;var d;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(d||(t.CodeActionTriggerType=d={}));var a;(function(T){T[T.Automatic=0]="Automatic",T[T.PasteAs=1]="PasteAs"})(a||(t.DocumentPasteTriggerKind=a={}));var f;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(f||(t.SignatureHelpTriggerKind=f={}));var n;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(n||(t.DocumentHighlightKind=n={}));function s(T){return T&&P.URI.isUri(T.uri)&&o.$$s.isIRange(T.range)&&(o.$$s.isIRange(T.originSelectionRange)||o.$$s.isIRange(T.targetSelectionRange))}var w;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(w||(t.SymbolKind=w={})),t.$Zt={17:(0,h.localize)(0,null),16:(0,h.localize)(1,null),4:(0,h.localize)(2,null),13:(0,h.localize)(3,null),8:(0,h.localize)(4,null),9:(0,h.localize)(5,null),21:(0,h.localize)(6,null),23:(0,h.localize)(7,null),7:(0,h.localize)(8,null),0:(0,h.localize)(9,null),11:(0,h.localize)(10,null),10:(0,h.localize)(11,null),19:(0,h.localize)(12,null),5:(0,h.localize)(13,null),1:(0,h.localize)(14,null),2:(0,h.localize)(15,null),20:(0,h.localize)(16,null),15:(0,h.localize)(17,null),18:(0,h.localize)(18,null),24:(0,h.localize)(19,null),3:(0,h.localize)(20,null),6:(0,h.localize)(21,null),14:(0,h.localize)(22,null),22:(0,h.localize)(23,null),25:(0,h.localize)(24,null),12:(0,h.localize)(25,null)};function g(T,W){return(0,h.localize)(26,null,T,t.$Zt[W])}var A;(function(T){T[T.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var E;(function(T){const W=new Map;W.set(0,i.$Fj.symbolFile),W.set(1,i.$Fj.symbolModule),W.set(2,i.$Fj.symbolNamespace),W.set(3,i.$Fj.symbolPackage),W.set(4,i.$Fj.symbolClass),W.set(5,i.$Fj.symbolMethod),W.set(6,i.$Fj.symbolProperty),W.set(7,i.$Fj.symbolField),W.set(8,i.$Fj.symbolConstructor),W.set(9,i.$Fj.symbolEnum),W.set(10,i.$Fj.symbolInterface),W.set(11,i.$Fj.symbolFunction),W.set(12,i.$Fj.symbolVariable),W.set(13,i.$Fj.symbolConstant),W.set(14,i.$Fj.symbolString),W.set(15,i.$Fj.symbolNumber),W.set(16,i.$Fj.symbolBoolean),W.set(17,i.$Fj.symbolArray),W.set(18,i.$Fj.symbolObject),W.set(19,i.$Fj.symbolKey),W.set(20,i.$Fj.symbolNull),W.set(21,i.$Fj.symbolEnumMember),W.set(22,i.$Fj.symbolStruct),W.set(23,i.$Fj.symbolEvent),W.set(24,i.$Fj.symbolOperator),W.set(25,i.$Fj.symbolTypeParameter);function te(K){let he=W.get(K);return he||(console.info("No codicon found for SymbolKind "+K),he=i.$Fj.symbolProperty),he}T.toIcon=te})(E||(t.SymbolKinds=E={}));class R{static asEditOperation(W){return y.$_s.replace(o.$$s.lift(W.range),W.text)}}t.$2t=R;class F{static{this.Comment=new F("comment")}static{this.Imports=new F("imports")}static{this.Region=new F("region")}static fromValue(W){switch(W){case"comment":return F.Comment;case"imports":return F.Imports;case"region":return F.Region}return new F(W)}constructor(W){this.value=W}}t.$3t=F;var k;(function(T){T[T.AIGenerated=1]="AIGenerated"})(k||(t.NewSymbolNameTag=k={}));var M;(function(T){function W(te){return!te||typeof te!="object"?!1:typeof te.id=="string"&&typeof te.title=="string"}T.is=W})(M||(t.Command=M={}));var S;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(S||(t.CommentThreadCollapsibleState=S={}));var D;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(D||(t.CommentThreadState=D={}));var I;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(I||(t.CommentMode=I={}));var O;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(O||(t.CommentState=O={}));var G;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(G||(t.InlayHintKind=G={}));class ne{constructor(W){this.b=W,this.a=null}dispose(){this.a&&this.a.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$4t=ne,t.$5t=new v.$Jt;var Z;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(Z||(t.ExternalUriOpenerPriority=Z={}));var Y;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(Y||(t.InlineEditTriggerKind=Y={}))}),re(ie[70],se([0,1,24,11,38,18,5,2,45,69,61]),function(V,t,i,P,y,o,v,h,l,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$l2=void 0,t.$m2=b;class p{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,N){return(0,y.$kr)(e,N)}}t.$l2=p;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$de,Emitter:P.$6d,KeyCode:c.KeyCode,KeyMod:p,Position:v.$0s,Range:h.$$s,Selection:l.$at,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:o.URI,Token:u.$Ut}}}),re(ie[73],se([0,1,25,18,5,2,58,30,54,55,70,23,60,34,52,14,3,53]),function(V,t,i,P,y,o,v,h,l,u,c,p,b,m,e,N,j,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=a;class $ extends v.$Dv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const s=[];for(let w=0;w<this.f.length;w++){const g=this.f[w],A=this.offsetAt(new y.$0s(w+1,1)),E=g.matchAll(n);for(const R of E)(R.index||R.index===0)&&(R.index=R.index+A),s.push(R)}return s}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,s){const w=(0,h.$Ns)(n.column,(0,h.$Ls)(s),this.f[n.lineNumber-1],0);return w?new o.$$s(n.lineNumber,w.startColumn,n.lineNumber,w.endColumn):null}getWordUntilPosition(n,s){const w=this.getWordAtPosition(n,s);return w?{word:this.f[n.lineNumber-1].substring(w.startColumn-1,n.column-1),startColumn:w.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const s=this.f,w=this.q.bind(this);let g=0,A="",E=0,R=[];return{*[Symbol.iterator](){for(;;)if(E<R.length){const F=A.substring(R[E].start,R[E].end);E+=1,yield F}else if(g<s.length)A=s[g],R=w(A,n),E=0,g+=1;else break}}}getLineWords(n,s){const w=this.f[n-1],g=this.q(w,s),A=[];for(const E of g)A.push({word:w.substring(E.start,E.end),startColumn:E.start+1,endColumn:E.end+1});return A}q(n,s){const w=[];let g;for(s.lastIndex=0;(g=s.exec(n))&&g[0].length!==0;)w.push({start:g.index,end:g.index+g[0].length});return w}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const s=this.g,w=n.startLineNumber-1,g=n.endLineNumber-1,A=[];A.push(this.f[w].substring(n.startColumn-1));for(let E=w+1;E<g;E++)A.push(this.f[E]);return A.push(this.f[g].substring(0,n.endColumn-1)),A.join(s)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),w=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,w)}}r(n){const s=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),w=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return s.lineNumber!==n.startLineNumber||s.column!==n.startColumn||w.lineNumber!==n.endLineNumber||w.column!==n.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:w.lineNumber,endColumn:w.column}:n}s(n){if(!y.$0s.isIPosition(n))throw new Error("bad position");let{lineNumber:s,column:w}=n,g=!1;if(s<1)s=1,w=1,g=!0;else if(s>this.f.length)s=this.f.length,w=this.f[s-1].length+1,g=!0;else{const A=this.f[s-1].length+1;w<1?(w=1,g=!0):w>A&&(w=A,g=!0)}return g?{lineNumber:s,column:w}:n}}class d{constructor(n,s){this.d=n,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(s=>n.push(this.f[s])),n}acceptNewModel(n){this.f[n.url]=new $(P.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,s){if(!this.f[n])return;this.f[n].onEvents(s)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,s,w){const g=this.j(n);return g?b.$g2.computeUnicodeHighlights(g,s,w):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,s,w,g){const A=this.j(n),E=this.j(s);return!A||!E?null:d.l(A,E,w,g)}static l(n,s,w,g){const A=g==="advanced"?e.$I2.getDefault():e.$I2.getLegacy(),E=n.getLinesContent(),R=s.getLinesContent(),F=A.computeDiff(E,R,w),k=F.changes.length>0?!1:this.n(n,s);function M(S){return S.map(D=>[D.original.startLineNumber,D.original.endLineNumberExclusive,D.modified.startLineNumber,D.modified.endLineNumberExclusive,D.innerChanges?.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])])}return{identical:k,quitEarly:F.hitTimeout,changes:M(F.changes),moves:F.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,M(S.changes)])}}static n(n,s){const w=n.getLineCount(),g=s.getLineCount();if(w!==g)return!1;for(let A=1;A<=w;A++){const E=n.getLineContent(A),R=s.getLineContent(A);if(E!==R)return!1}return!0}async computeDirtyDiff(n,s,w){const g=this.j(n),A=this.j(s);if(!g||!A)return null;const E=g.getLinesContent(),R=A.getLinesContent();return new m.$pt(E,R,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:w,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(n,s,w){const g=this.j(n);if(!g)return s;const A=[];let E;s=s.slice(0).sort((F,k)=>{if(F.range&&k.range)return o.$$s.compareRangesUsingStarts(F.range,k.range);const M=F.range?0:1,S=k.range?0:1;return M-S});let R=0;for(let F=1;F<s.length;F++)o.$$s.getEndPosition(s[R].range).equals(o.$$s.getStartPosition(s[F].range))?(s[R].range=o.$$s.fromPositions(o.$$s.getStartPosition(s[R].range),o.$$s.getEndPosition(s[F].range)),s[R].text+=s[F].text):(R++,s[R]=s[F]);s.length=R+1;for(let{range:F,text:k,eol:M}of s){if(typeof M=="number"&&(E=M),o.$$s.isEmpty(F)&&!k)continue;const S=g.getValueInRange(F);if(k=k.replace(/\r\n|\n|\r/g,g.eol),S===k)continue;if(Math.max(k.length,S.length)>d.o){A.push({range:F,text:k});continue}const D=(0,i.$dt)(S,k,w),I=g.offsetAt(o.$$s.lift(F).getStartPosition());for(const O of D){const G=g.positionAt(I+O.originalStart),ne=g.positionAt(I+O.originalStart+O.originalLength),Z={text:k.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:G.lineNumber,startColumn:G.column,endLineNumber:ne.lineNumber,endColumn:ne.column}};g.getValueInRange(Z.range)!==Z.text&&A.push(Z)}}return typeof E=="number"&&A.push({eol:E,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}computeHumanReadableDiff(n,s,w){const g=this.j(n);if(!g)return s;const A=[];let E;s=s.slice(0).sort((R,F)=>{if(R.range&&F.range)return o.$$s.compareRangesUsingStarts(R.range,F.range);const k=R.range?0:1,M=F.range?0:1;return k-M});for(let{range:R,text:F,eol:k}of s){let G=function(Z,Y){return new y.$0s(Z.lineNumber+Y.lineNumber-1,Y.lineNumber===1?Z.column+Y.column-1:Y.column)},ne=function(Z,Y){const T=[];for(let W=Y.startLineNumber;W<=Y.endLineNumber;W++){const te=Z[W-1];W===Y.startLineNumber&&W===Y.endLineNumber?T.push(te.substring(Y.startColumn-1,Y.endColumn-1)):W===Y.startLineNumber?T.push(te.substring(Y.startColumn-1)):W===Y.endLineNumber?T.push(te.substring(0,Y.endColumn-1)):T.push(te)}return T};if(typeof k=="number"&&(E=k),o.$$s.isEmpty(R)&&!F)continue;const M=g.getValueInRange(R);if(F=F.replace(/\r\n|\n|\r/g,g.eol),M===F)continue;if(Math.max(F.length,M.length)>d.o){A.push({range:R,text:F});continue}const S=M.split(/\r\n|\n|\r/),D=F.split(/\r\n|\n|\r/),I=e.$I2.getDefault().computeDiff(S,D,w),O=o.$$s.lift(R).getStartPosition();for(const Z of I.changes)if(Z.innerChanges)for(const Y of Z.innerChanges)A.push({range:o.$$s.fromPositions(G(O,Y.originalRange.getStartPosition()),G(O,Y.originalRange.getEndPosition())),text:ne(D,Y.modifiedRange).join(g.eol)});else throw new j.$cb("The experimental diff algorithm always produces inner changes")}return typeof E=="number"&&A.push({eol:E,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}async computeLinks(n){const s=this.j(n);return s?(0,l.$j2)(s):null}async computeDefaultDocumentColors(n){const s=this.j(n);return s?(0,L.$J2)(s):null}static{this.p=1e4}async textualSuggest(n,s,w,g){const A=new p.$2d,E=new RegExp(w,g),R=new Set;e:for(const F of n){const k=this.j(F);if(k){for(const M of k.words(E))if(!(M===s||!isNaN(Number(M)))&&(R.add(M),R.size>d.p))break e}}return{words:Array.from(R),duration:A.elapsed()}}async computeWordRanges(n,s,w,g){const A=this.j(n);if(!A)return Object.create(null);const E=new RegExp(w,g),R=Object.create(null);for(let F=s.startLineNumber;F<s.endLineNumber;F++){const k=A.getLineWords(F,E);for(const M of k){if(!isNaN(Number(M.word)))continue;let S=R[M.word];S||(S=[],R[M.word]=S),S.push({startLineNumber:F,startColumn:M.startColumn,endLineNumber:F,endColumn:M.endColumn})}}return R}async navigateValueSet(n,s,w,g,A){const E=this.j(n);if(!E)return null;const R=new RegExp(g,A);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const F=E.getValueInRange(s),k=E.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},R);if(!k)return null;const M=E.getValueInRange(k);return u.$k2.INSTANCE.navigateValueSet(s,F,k,M,w)}loadForeignModule(n,s,w){const g=(R,F)=>this.d.fhr(R,F),E={host:(0,N.$Xn)(w,g),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(E,s),Promise.resolve((0,N.$Wn)(this.h))):new Promise((R,F)=>{V([n],k=>{this.h=k.create(E,s),R((0,N.$Wn)(this.h))},F)})}fmr(n,s){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,s))}catch(w){return Promise.reject(w)}}}t.EditorSimpleWorker=d;function a(f){return new d(f,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$m2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/base/worker/workerMain.js.map
