/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(J){for(var e=[],n=0,R=J.length;n<R;n++)e[n]=ae[J[n]];return e};define(ae[136],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=R,e.$hb=P,e.$ib=O,e.$jb=A,e.$kb=E,e.$lb=h,e.$nb=b,e.$ob=y,e.$pb=k,e.$qb=d,e.$rb=m;function n(v,w,$){const f=R(v,w);if(f!==-1)return v[f]}function R(v,w,$=v.length-1){for(let f=$;f>=0;f--){const u=v[f];if(w(u))return f}return-1}function P(v,w){const $=O(v,w);return $===-1?void 0:v[$]}function O(v,w,$=0,f=v.length){let u=$,g=f;for(;u<g;){const a=Math.floor((u+g)/2);w(v[a])?u=a+1:g=a}return u-1}function A(v,w){const $=E(v,w);return $===v.length?void 0:v[$]}function E(v,w,$=0,f=v.length){let u=$,g=f;for(;u<g;){const a=Math.floor((u+g)/2);w(v[a])?g=a:u=a+1}return u}function h(v,w,$=0,f=v.length){const u=E(v,w,$,f);return u===v.length?-1:u}class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const $=O(this.e,w,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=c;function b(v,w){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const u=v[f];w(u,$)>0&&($=u)}return $}function y(v,w){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const u=v[f];w(u,$)>=0&&($=u)}return $}function k(v,w){return b(v,($,f)=>-w($,f))}function d(v,w){if(v.length===0)return-1;let $=0;for(let f=1;f<v.length;f++){const u=v[f];w(u,v[$])>0&&($=f)}return $}function m(v,w){for(const $ of v){const f=w($);if(f!==void 0)return f}}}),define(ae[137],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=R,e.$M=P,e.$N=O;function n(A,E){const h=Object.create(null);for(const c of A){const b=E(c);let y=h[b];y||(y=h[b]=[]),y.push(c)}return h}function R(A,E){const h=[],c=[];for(const b of A)E.has(b)||h.push(b);for(const b of E)A.has(b)||c.push(b);return{removed:h,added:c}}function P(A,E){const h=[],c=[];for(const[b,y]of A)E.has(b)||h.push(y);for(const[b,y]of E)A.has(b)||c.push(y);return{removed:h,added:c}}function O(A,E){const h=new Set;for(const c of E)A.has(c)&&h.add(c);return h}}),define(ae[138],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=e.$At=e.$zt=void 0;function n(E,h){const c=Math.pow(10,h);return Math.round(E*c)/c}class R{constructor(h,c,b,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.$zt=R;class P{constructor(h,c,b,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,b),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,b=h.g/255,y=h.b/255,k=h.a,d=Math.max(c,b,y),m=Math.min(c,b,y);let v=0,w=0;const $=(m+d)/2,f=d-m;if(f>0){switch(w=Math.min($<=.5?f/(2*$):f/(2-2*$),1),d){case c:v=(b-y)/f+(b<y?6:0);break;case b:v=(y-c)/f+2;break;case y:v=(c-b)/f+4;break}v*=60,v=Math.round(v)}return new P(v,w,$,k)}static i(h,c,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?h+(c-h)*6*b:b<1/2?c:b<2/3?h+(c-h)*(2/3-b)*6:h}static toRGBA(h){const c=h.h/360,{s:b,l:y,a:k}=h;let d,m,v;if(b===0)d=m=v=y;else{const w=y<.5?y*(1+b):y+b-y*b,$=2*y-w;d=P.i($,w,c+1/3),m=P.i($,w,c),v=P.i($,w,c-1/3)}return new R(Math.round(d*255),Math.round(m*255),Math.round(v*255),k)}}e.$At=P;class O{constructor(h,c,b,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,b),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,b=h.g/255,y=h.b/255,k=Math.max(c,b,y),d=Math.min(c,b,y),m=k-d,v=k===0?0:m/k;let w;return m===0?w=0:k===c?w=((b-y)/m%6+6)%6:k===b?w=(y-c)/m+2:w=(c-b)/m+4,new O(Math.round(w*60),v,k,h.a)}static toRGBA(h){const{h:c,s:b,v:y,a:k}=h,d=y*b,m=d*(1-Math.abs(c/60%2-1)),v=y-d;let[w,$,f]=[0,0,0];return c<60?(w=d,$=m):c<120?(w=m,$=d):c<180?($=d,f=m):c<240?($=m,f=d):c<300?(w=m,f=d):c<=360&&(w=d,f=m),w=Math.round((w+v)*255),$=Math.round(($+v)*255),f=Math.round((f+v)*255),new R(w,$,f,k)}}e.$Bt=O;class A{static fromHex(h){return A.Format.CSS.parseHex(h)||A.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof R)this.rgba=h;else if(h instanceof P)this.i=h,this.rgba=P.toRGBA(h);else if(h instanceof O)this.j=h,this.rgba=O.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&R.equals(this.rgba,h.rgba)&&P.equals(this.hsla,h.hsla)&&O.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=A.k(this.rgba.r),c=A.k(this.rgba.g),b=A.k(this.rgba.b),y=.2126*h+.7152*c+.0722*b;return n(y,4)}static k(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),b=h.getRelativeLuminance();return c>b?(c+.05)/(b+.05):(b+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),b=h.getRelativeLuminance();return c>b}isDarkerThan(h){const c=this.getRelativeLuminance(),b=h.getRelativeLuminance();return c<b}lighten(h){return new A(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new A(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:b,b:y,a:k}=this.rgba;return new A(new R(c,b,y,k*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,b=this.rgba.a,y=c.a,k=b+y*(1-b);if(k<1e-6)return A.transparent;const d=this.rgba.r*b/k+c.r*y*(1-b)/k,m=this.rgba.g*b/k+c.g*y*(1-b)/k,v=this.rgba.b*b/k+c.b*y*(1-b)/k;return new A(new R(d,m,v,k))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:b,b:y,a:k}=this.rgba;return new A(new R(h.rgba.r-k*(h.rgba.r-c),h.rgba.g-k*(h.rgba.g-b),h.rgba.b-k*(h.rgba.b-y),1))}flatten(...h){const c=h.reduceRight((b,y)=>A.o(y,b));return A.o(this,c)}static o(h,c){const b=1-h.rgba.a;return new A(new R(b*c.rgba.r+h.rgba.a*h.rgba.r,b*c.rgba.g+h.rgba.a*h.rgba.g,b*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(h,c,b){if(h.isLighterThan(c))return h;b=b||.5;const y=h.getRelativeLuminance(),k=c.getRelativeLuminance();return b=b*(k-y)/k,h.lighten(b)}static getDarkerColor(h,c,b){if(h.isDarkerThan(c))return h;b=b||.5;const y=h.getRelativeLuminance(),k=c.getRelativeLuminance();return b=b*(y-k)/y,h.darken(b)}static{this.white=new A(new R(255,255,255,1))}static{this.black=new A(new R(0,0,0,1))}static{this.red=new A(new R(255,0,0,1))}static{this.blue=new A(new R(0,0,255,1))}static{this.green=new A(new R(0,255,0,1))}static{this.cyan=new A(new R(0,255,255,1))}static{this.lightgrey=new A(new R(211,211,211,1))}static{this.transparent=new A(new R(0,0,0,0))}}e.$Ct=A,function(E){let h;(function(c){let b;(function(y){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}y.formatRGB=k;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=d;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}y.formatHSL=m;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function w(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}y.formatHex=$;function f(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function u(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}y.format=u;function g(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new R(r,i,s,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new R(r,i,s,l/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3));return new E(new R(16*r+r,16*i+i,16*s+s))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new E(new R(16*r+r,16*i+i,16*s+s,(16*l+l)/255))}return null}y.parseHex=g;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=c.CSS||(c.CSS={}))})(h=E.Format||(E.Format={}))}(A||(e.$Ct=A={}))}),define(ae[50],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=R,e.$Lh=P,e.$Mh=O;function n(A){return(E,h,c)=>{let b=null,y=null;if(typeof c.value=="function"?(b="value",y=c.value):typeof c.get=="function"&&(b="get",y=c.get),!y)throw new Error("not supported");c[b]=A(y,h)}}function R(A,E,h){let c=null,b=null;if(typeof h.value=="function"?(c="value",b=h.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",b=h.get),!b)throw new Error("not supported");const y=`$memoize$${E}`;h[c]=function(...k){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,k)}),this[y]}}function P(A,E,h){return n((c,b)=>{const y=`$debounce$${b}`,k=`$debounce$result$${b}`;return function(...d){this[k]||(this[k]=h?h():void 0),clearTimeout(this[y]),E&&(this[k]=E(this[k],...d),d=[this[k]]),this[y]=setTimeout(()=>{c.apply(this,d),this[k]=h?h():void 0},A)}})}function O(A,E,h){return n((c,b)=>{const y=`$throttle$timer$${b}`,k=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...v){if(this[k]||(this[k]=h?h():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...v)),this[m])return;const w=this[d]+A;w<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[k]]),this[k]=h?h():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),c.apply(this,[this[k]]),this[k]=h?h():void 0},w-Date.now()))}})}}),define(ae[15],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=R,e.$Z=P,e.$1=O,e.$2=A,e.$3=E,e.$4=c,e.$6=y,e.$7=k,e.$8=d,e.$0=v;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?u.isErrorNoTelemetry(t)?new u(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function R(a){e.$X.setUnexpectedErrorHandler(a)}function P(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(a){c(a)||e.$X.onUnexpectedError(a)}function A(a){c(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:u.isErrorNoTelemetry(a)}}return a}const h="Canceled";function c(a){return a instanceof b?!0:a instanceof Error&&a.name===h&&a.message===h}class b extends Error{constructor(){super(h),this.name=this.message}}e.$5=b;function y(){const a=new Error(h);return a.name=a.message,a}function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class u extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof u)return t;const o=new u;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=u;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$cb=g}),define(ae[22],ce([0,1,15,136]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=P,e.$tb=O,e.$ub=A,e.$vb=E,e.$wb=h,e.$xb=c,e.$yb=b,e.$zb=y,e.$Ab=k,e.$Bb=d,e.$Cb=m,e.$Db=v,e.$Eb=w,e.top=$,e.$Gb=f,e.$Hb=g,e.$Ib=a,e.$Jb=t,e.$Kb=o,e.$Lb=r,e.$Mb=i,e.$Nb=s,e.$Ob=l,e.$Pb=p,e.$Qb=I,e.$Rb=j,e.$Sb=S,e.$Tb=D,e.$Ub=M,e.$Vb=W,e.$Wb=F,e.$Xb=H,e.$Yb=x,e.$Zb=le,e.$1b=re,e.$2b=ue,e.$3b=Q,e.$4b=Y,e.$5b=U,e.$6b=L,e.$7b=q,e.$8b=oe,e.$$b=C;function P(z,X=0){return z[z.length-(1+X)]}function O(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function A(z,X,V=(_,B)=>_===B){if(z===X)return!0;if(!z||!X||z.length!==X.length)return!1;for(let _=0,B=z.length;_<B;_++)if(!V(z[_],X[_]))return!1;return!0}function E(z,X){const V=z.length-1;X<V&&(z[X]=z[V]),z.pop()}function h(z,X,V){return c(z.length,_=>V(z[_],X))}function c(z,X){let V=0,_=z-1;for(;V<=_;){const B=(V+_)/2|0,te=X(B);if(te<0)V=B+1;else if(te>0)_=B-1;else return B}return-(V+1)}function b(z,X,V){if(z=z|0,z>=X.length)throw new TypeError("invalid index");const _=X[Math.floor(X.length*Math.random())],B=[],te=[],ie=[];for(const de of X){const me=V(de,_);me<0?B.push(de):me>0?te.push(de):ie.push(de)}return z<B.length?b(z,B,V):z<B.length+ie.length?ie[0]:b(z-(B.length+ie.length),te,V)}function y(z,X){const V=[];let _;for(const B of z.slice(0).sort(X))!_||X(_[0],B)!==0?(_=[B],V.push(_)):_.push(B);return V}function*k(z,X){let V,_;for(const B of z)_!==void 0&&X(_,B)?V.push(B):(V&&(yield V),V=[B]),_=B;V&&(yield V)}function d(z,X){for(let V=0;V<=z.length;V++)X(V===0?void 0:z[V-1],V===z.length?void 0:z[V])}function m(z,X){for(let V=0;V<z.length;V++)X(V===0?void 0:z[V-1],z[V],V+1===z.length?void 0:z[V+1])}function v(z,X,V){const _=[];function B(de,me,ke){if(me===0&&ke.length===0)return;const Se=_[_.length-1];Se&&Se.start+Se.deleteCount===de?(Se.deleteCount+=me,Se.toInsert.push(...ke)):_.push({start:de,deleteCount:me,toInsert:ke})}let te=0,ie=0;for(;;){if(te===z.length){B(te,0,X.slice(ie));break}if(ie===X.length){B(te,z.length-te,[]);break}const de=z[te],me=X[ie],ke=V(de,me);ke===0?(te+=1,ie+=1):ke<0?(B(te,1,[]),te+=1):ke>0&&(B(te,0,[me]),ie+=1)}return _}function w(z,X,V){const _=v(z,X,V),B=[],te=[];for(const ie of _)B.push(...z.slice(ie.start,ie.start+ie.deleteCount)),te.push(...ie.toInsert);return{removed:B,added:te}}function $(z,X,V){if(V===0)return[];const _=z.slice(0,V).sort(X);return u(z,X,_,V,z.length),_}function f(z,X,V,_,B){return V===0?Promise.resolve([]):new Promise((te,ie)=>{(async()=>{const de=z.length,me=z.slice(0,V).sort(X);for(let ke=V,Se=Math.min(V+_,de);ke<de;ke=Se,Se=Math.min(Se+_,de)){if(ke>V&&await new Promise(Oe=>setTimeout(Oe)),B&&B.isCancellationRequested)throw new n.$5;u(z,X,me,ke,Se)}return me})().then(te,ie)})}function u(z,X,V,_,B){for(const te=V.length;_<B;_++){const ie=z[_];if(X(ie,V[te-1])<0){V.pop();const de=(0,R.$kb)(V,me=>X(ie,me)<0);V.splice(de,0,ie)}}}function g(z){return z.filter(X=>!!X)}function a(z){let X=0;for(let V=0;V<z.length;V++)z[V]&&(z[X]=z[V],X+=1);z.length=X}function t(z,X,V){z.splice(V,0,z.splice(X,1)[0])}function o(z){return!Array.isArray(z)||z.length===0}function r(z){return Array.isArray(z)&&z.length>0}function i(z,X=V=>V){const V=new Set;return z.filter(_=>{const B=X(_);return V.has(B)?!1:(V.add(B),!0)})}function s(z){const X=new Set;return V=>{const _=z(V);return X.has(_)?!1:(X.add(_),!0)}}function l(z,X){return z.length>0?z[0]:X}function p(z,X){return z.length>0?z[z.length-1]:X}function I(z,X,V=(_,B)=>_===B){let _=0;for(let B=0,te=Math.min(z.length,X.length);B<te&&V(z[B],X[B]);B++)_++;return _}function j(z){return[].concat(...z)}function S(z,X){let V=typeof X=="number"?z:0;typeof X=="number"?V=z:(V=0,X=z);const _=[];if(V<=X)for(let B=V;B<X;B++)_.push(B);else for(let B=V;B>X;B--)_.push(B);return _}function D(z,X,V){return z.reduce((_,B)=>(_[X(B)]=V?V(B):B,_),Object.create(null))}function M(z,X){return z.push(X),()=>W(z,X)}function W(z,X){const V=z.indexOf(X);if(V>-1)return z.splice(V,1),X}function F(z,X,V){const _=z.slice(0,X),B=z.slice(X);return _.concat(V,B)}function H(z,X){let V;if(typeof X=="number"){let _=X;V=()=>{const B=Math.sin(_++)*179426549;return B-Math.floor(B)}}else V=Math.random;for(let _=z.length-1;_>0;_-=1){const B=Math.floor(V()*(_+1)),te=z[_];z[_]=z[B],z[B]=te}}function x(z,X){const V=z.indexOf(X);V>-1&&(z.splice(V,1),z.unshift(X))}function le(z,X){const V=z.indexOf(X);V>-1&&(z.splice(V,1),z.push(X))}function re(z,X){for(const V of X)z.push(V)}function ue(z,X){return Array.isArray(z)?z.map(X):X(z)}function Q(z){return Array.isArray(z)?z:[z]}function Y(z){return z[Math.floor(Math.random()*z.length)]}function U(z,X,V){const _=N(z,X),B=z.length,te=V.length;z.length=B+te;for(let ie=B-1;ie>=_;ie--)z[ie+te]=z[ie];for(let ie=0;ie<te;ie++)z[ie+_]=V[ie]}function L(z,X,V,_){const B=N(z,X);let te=z.splice(B,V);return te===void 0&&(te=[]),U(z,B,_),te}function N(z,X){return X<0?Math.max(X+z.length,0):Math.min(X,z.length)}var G;(function(z){function X(te){return te<0}z.isLessThan=X;function V(te){return te<=0}z.isLessThanOrEqual=V;function _(te){return te>0}z.isGreaterThan=_;function B(te){return te===0}z.isNeitherLessOrGreaterThan=B,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function q(z,X){return(V,_)=>X(z(V),z(_))}function oe(...z){return(X,V)=>{for(const _ of z){const B=_(X,V);if(!G.isNeitherLessOrGreaterThan(B))return B}return G.neitherLessOrGreaterThan}}const he=(z,X)=>z-X;e.$9b=he;const K=(z,X)=>(0,e.$9b)(z?1:0,X?1:0);e.$0b=K;function C(z){return(X,V)=>-z(X,V)}class T{constructor(X){this.g=X,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(X){let V=this.c;for(;V<this.g.length&&X(this.g[V]);)V++;const _=V===this.c?null:this.g.slice(this.c,V);return this.c=V,_}takeFromEndWhile(X){let V=this.d;for(;V>=0&&X(this.g[V]);)V--;const _=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const X=this.g[this.c];return this.c++,X}removeLast(){const X=this.g[this.d];return this.d--,X}takeCount(X){const V=this.g.slice(this.c,this.c+X);return this.c+=X,V}}e.$_b=T;class Z{static{this.empty=new Z(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(V=>(X(V),!0))}toArray(){const X=[];return this.iterate(V=>(X.push(V),!0)),X}filter(X){return new Z(V=>this.iterate(_=>X(_)?V(_):!0))}map(X){return new Z(V=>this.iterate(_=>V(X(_))))}some(X){let V=!1;return this.iterate(_=>(V=X(_),!V)),V}findFirst(X){let V;return this.iterate(_=>X(_)?(V=_,!1):!0),V}findLast(X){let V;return this.iterate(_=>(X(_)&&(V=_),!0)),V}findLastMaxBy(X){let V,_=!0;return this.iterate(B=>((_||G.isGreaterThan(X(B,V)))&&(_=!1,V=B),!0)),V}}e.$ac=Z}),define(ae[139],ce([0,1,15]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.$9c=P,e.$0c=O,e.$$c=A,e.$_c=E,e.$ad=h;function R(c,b){if(!c)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function P(c,b="Unreachable"){throw new Error(b)}function O(c){if(!c)throw new n.$cb("Assertion Failed")}function A(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function h(c,b){let y=0;for(;y<c.length-1;){const k=c[y],d=c[y+1];if(!b(k,d))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(R,P){const O=this;let A=!1,E;return function(){if(A)return E;if(A=!0,P)try{E=R.apply(O,arguments)}finally{P()}else E=R.apply(O,arguments);return E}}}),define(ae[71],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(R){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=P;const O=Object.freeze([]);function A(){return O}R.empty=A;function*E(t){yield t}R.single=E;function h(t){return P(t)?t:E(t)}R.wrap=h;function c(t){return t||O}R.from=c;function*b(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=b;function y(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=y;function k(t){return t[Symbol.iterator]().next().value}R.first=k;function d(t,o){for(const r of t)if(o(r))return!0;return!1}R.some=d;function m(t,o){for(const r of t)if(o(r))return r}R.find=m;function*v(t,o){for(const r of t)o(r)&&(yield r)}R.filter=v;function*w(t,o){let r=0;for(const i of t)yield o(i,r++)}R.map=w;function*$(...t){for(const o of t)yield*o}R.concat=$;function f(t,o,r){let i=r;for(const s of t)i=o(i,s);return i}R.reduce=f;function*u(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}R.slice=u;function g(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let s=0;s<o;s++){const l=i.next();if(l.done)return[r,R.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=g;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}R.asyncToArray=a})(n||(e.Iterable=n={}))}),define(ae[42],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$rn=A,e.$sn=y,e.$tn=k,e.$un=d,e.$vn=m,e.$wn=v,e.$xn=w,e.$yn=$,e.$zn=f,e.$An=u,e.$Bn=g,e.$Cn=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,o=!1){let r=0;const i=t.length;let s="",l=0,p=16,I=0;function j(x){let le=0,re=0;for(;le<x;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,le++}return le<x&&(re=-1),re}function S(x){r=x,s="",l=0,p=16,I=0}function D(){const x=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return I=3,t.substring(x,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;le=r}else I=3;return t.substring(x,le)}function M(){let x="",le=r;for(;;){if(r>=i){x+=t.substring(le,r),I=2;break}const re=t.charCodeAt(r);if(re===34){x+=t.substring(le,r),r++;break}if(re===92){if(x+=t.substring(le,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Q=j(4);Q>=0?x+=String.fromCharCode(Q):I=4;break}default:I=5}le=r;continue}if(re>=0&&re<=31)if(h(re)){x+=t.substring(le,r),I=2;break}else I=6;r++}return x}function W(){if(s="",I=0,l=r,r>=i)return l=i,p=17;let x=t.charCodeAt(r);if(E(x)){do r++,s+=String.fromCharCode(x),x=t.charCodeAt(r);while(E(x));return p=15}if(h(x))return r++,s+=String.fromCharCode(x),x===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),p=14;switch(x){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,s=M(),p=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return s=t.substring(le,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,I=1),s=t.substring(le,r),p=13}return s+=String.fromCharCode(x),r++,p=16}case 45:if(s+=String.fromCharCode(x),r++,r===i||!c(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=D(),p=11;default:for(;r<i&&F(x);)r++,x=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return s+=String.fromCharCode(x),r++,p=16}}function F(x){if(E(x)||h(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let x;do x=W();while(x>=12&&x<=15);return x}return{setPosition:S,getPosition:()=>r,scan:o?H:W,getToken:()=>p,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>I}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function y(t,o){const r=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function I(j,S,D,M){l.value=j,l.offset=S,l.length=D,l.type=M,l.colonOffset=void 0,s=l}try{u(t,{onObjectBegin:(j,S)=>{if(o<=j)throw i;s=void 0,p=o>j,r.push("")},onObjectProperty:(j,S,D)=>{if(o<S||(I(j,S,D,"property"),r[r.length-1]=j,o<=S+D))throw i},onObjectEnd:(j,S)=>{if(o<=j)throw i;s=void 0,r.pop()},onArrayBegin:(j,S)=>{if(o<=j)throw i;s=void 0,r.push(0)},onArrayEnd:(j,S)=>{if(o<=j)throw i;s=void 0,r.pop()},onLiteralValue:(j,S,D)=>{if(o<S||(I(j,S,D,a(j)),o<=S+D))throw i},onSeparator:(j,S,D)=>{if(o<=S)throw i;if(j===":"&&s&&s.type==="property")s.colonOffset=S,p=!1,s=void 0;else if(j===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(p=!0,r[r.length-1]=""),s=void 0}}})}catch(j){if(j!==i)throw j}return{path:r,previousNode:s,isAtPropertyKey:p,matches:j=>{let S=0;for(let D=0;S<j.length&&D<r.length;D++)if(j[S]===r[D]||j[S]==="*")S++;else if(j[S]!=="**")return!1;return S===j.length}}}function k(t,o=[],r=O.DEFAULT){let i=null,s=[];const l=[];function p(j){Array.isArray(s)?s.push(j):i!==null&&(s[i]=j)}return u(t,{onObjectBegin:()=>{const j={};p(j),l.push(s),s=j,i=null},onObjectProperty:j=>{i=j},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const j=[];p(j),l.push(s),s=j,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:p,onError:(j,S,D)=>{o.push({error:j,offset:S,length:D})}},r),s[0]}function d(t,o=[],r=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(j){i.type==="property"&&(i.length=j-i.offset,i=i.parent)}function l(j){return i.children.push(j),j}u(t,{onObjectBegin:j=>{i=l({type:"object",offset:j,length:-1,parent:i,children:[]})},onObjectProperty:(j,S,D)=>{i=l({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:j,offset:S,length:D,parent:i})},onObjectEnd:(j,S)=>{i.length=j+S-i.offset,i=i.parent,s(j+S)},onArrayBegin:(j,S)=>{i=l({type:"array",offset:j,length:-1,parent:i,children:[]})},onArrayEnd:(j,S)=>{i.length=j+S-i.offset,i=i.parent,s(j+S)},onLiteralValue:(j,S,D)=>{l({type:a(j),offset:S,length:D,parent:i,value:j}),s(S+D)},onSeparator:(j,S,D)=>{i.type==="property"&&(j===":"?i.colonOffset=S:j===","&&s(S))},onError:(j,S,D)=>{o.push({error:j,offset:S,length:D})}},r);const I=i.children[0];return I&&delete I.parent,I}function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}function f(t,o,r=!1){if($(t,o,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const l=f(i[s],o,r);if(l)return l}return t}}function u(t,o,r=O.DEFAULT){const i=A(t,!1);function s(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(q){return q?oe=>q(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=s(o.onObjectBegin),I=l(o.onObjectProperty),j=s(o.onObjectEnd),S=s(o.onArrayBegin),D=s(o.onArrayEnd),M=l(o.onLiteralValue),W=l(o.onSeparator),F=s(o.onComment),H=l(o.onError),x=r&&r.disallowComments,le=r&&r.allowTrailingComma;function re(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:x||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:x?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,oe=[],he=[]){if(H(q),oe.length+he.length>0){let K=i.getToken();for(;K!==17;){if(oe.indexOf(K)!==-1){re();break}else if(he.indexOf(K)!==-1)break;K=re()}}}function Q(q){const oe=i.getTokenValue();return q?M(oe):I(oe),re(),!0}function Y(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}M(q);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return re(),!0}function U(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(W(":"),re(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){p(),re();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),W(","),re(),i.getToken()===2&&le)break}else q&&ue(6,[],[]);U()||ue(4,[],[2,5]),q=!0}return j(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function N(){S(),re();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),W(","),re(),i.getToken()===4&&le)break}else q&&ue(6,[],[]);G()||ue(4,[],[4,5]),q=!0}return D(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return L();case 10:return Q(!0);default:return Y()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}function g(t,o){const r=A(t),i=[];let s,l=0,p;do switch(p=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==p&&i.push(t.substring(l,p)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(s!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[140],ce([0,1,42]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=R,e.$En=P,e.$Fn=E,e.$Gn=h;function R(c,b,y){let k,d,m,v,w;if(b){for(v=b.offset,w=v+b.length,m=v;m>0&&!h(c,m-1);)m--;let p=w;for(;p<c.length&&!h(c,p);)p++;d=c.substring(m,p),k=A(d,y)}else d=c,k=0,m=0,v=0,w=c.length;const $=E(y,c);let f=!1,u=0,g;y.insertSpaces?g=O(" ",y.tabSize||4):g="	";const a=(0,n.$rn)(d,!1);let t=!1;function o(){return $+O(g,k+u)}function r(){let p=a.scan();for(f=!1;p===15||p===14;)f=f||p===14,p=a.scan();return t=p===16||a.getTokenError()!==0,p}const i=[];function s(p,I,j){!t&&I<w&&j>v&&c.substring(I,j)!==p&&i.push({offset:I,length:j-I,content:p})}let l=r();if(l!==17){const p=a.getTokenOffset()+m,I=O(g,k);s(I,m,p)}for(;l!==17;){let p=a.getTokenOffset()+a.getTokenLength()+m,I=r(),j="";for(;!f&&(I===12||I===13);){const D=a.getTokenOffset()+m;s(" ",p,D),p=a.getTokenOffset()+a.getTokenLength()+m,j=I===12?o():"",I=r()}if(I===2)l!==1&&(u--,j=o());else if(I===4)l!==3&&(u--,j=o());else{switch(l){case 3:case 1:u++,j=o();break;case 5:case 12:j=o();break;case 13:f?j=o():j=" ";break;case 6:j=" ";break;case 10:if(I===6){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?j=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}f&&(I===12||I===13)&&(j=o())}const S=a.getTokenOffset()+m;s(j,p,S),l=I}return i}function P(c,b){const y=JSON.stringify(c,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?y.replace(/\r\n|\r|\n/g,b.eol):y}function O(c,b){let y="";for(let k=0;k<b;k++)y+=c;return y}function A(c,b){let y=0,k=0;const d=b.tabSize||4;for(;y<c.length;){const m=c.charAt(y);if(m===" ")k++;else if(m==="	")k+=d;else break;y++}return Math.floor(k/d)}function E(c,b){for(let y=0;y<b.length;y++){const k=b.charAt(y);if(k==="\r")return y+1<b.length&&b.charAt(y+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return c&&c.eol||`
`}function h(c,b){return`\r
`.indexOf(c.charAt(b))!==-1}}),define(ae[103],ce([0,1,42,140]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=P,e.$In=O,e.$Jn=A,e.$Kn=E,e.$Ln=h;function P(c,b,y){return O(c,b,void 0,y)}function O(c,b,y,k,d){const m=b.slice(),v=[],w=(0,n.$un)(c,v);let $,f;for(;m.length>0&&(f=m.pop(),$=(0,n.$vn)(w,m),$===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if($)if($.type==="object"&&typeof f=="string"&&Array.isArray($.children)){const u=(0,n.$vn)($,[f]);if(u!==void 0)if(y===void 0){if(!u.parent)throw new Error("Malformed AST");const g=$.children.indexOf(u.parent);let a,t=u.parent.offset+u.parent.length;if(g>0){const o=$.children[g-1];a=o.offset+o.length}else a=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return A(c,{offset:a,length:t-a,content:""},k)}else return A(c,{offset:u.offset,length:u.length,content:JSON.stringify(y)},k);else{if(y===void 0)return[];const g=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=d?d($.children.map(o=>o.children[0].value)):$.children.length;let t;if(a>0){const o=$.children[a-1];t={offset:o.offset+o.length,length:0,content:","+g}}else $.children.length===0?t={offset:$.offset+1,length:0,content:g}:t={offset:$.offset+1,length:0,content:g+","};return A(c,t,k)}}else if($.type==="array"&&typeof f=="number"&&Array.isArray($.children))if(y!==void 0){const u=`${JSON.stringify(y)}`;let g;if($.children.length===0||f===0)g={offset:$.offset+1,length:0,content:$.children.length===0?u:u+","};else{const a=f===-1||f>$.children.length?$.children.length:f,t=$.children[a-1];g={offset:t.offset+t.length,length:0,content:","+u}}return A(c,g,k)}else{const u=f,g=$.children[u];let a;if($.children.length===1)a={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===u){const t=$.children[u-1],o=t.offset+t.length,r=$.offset+$.length;a={offset:o,length:r-2-o,content:""}}else a={offset:g.offset,length:$.children[u+1].offset-g.offset,content:""};return A(c,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${$.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},k)}}function A(c,b,y){let k=E(c,b),d=b.offset,m=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;d>0&&!(0,R.$Gn)(k,d-1);)d--;for(;m<k.length&&!(0,R.$Gn)(k,m);)m++}const v=(0,R.$Dn)(k,{offset:d,length:m-d},y);for(let $=v.length-1;$>=0;$--){const f=v[$];k=E(k,f),d=Math.min(d,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const w=c.length-(k.length-m)-d;return[{offset:d,length:w,content:k.substring(d,m)}]}function E(c,b){return c.substring(0,b.offset)+b.content+c.substring(b.offset+b.length)}function h(c,b){const y=b.slice(0).sort((d,m)=>{const v=d.offset-m.offset;return v===0?d.length-m.length:v});let k=c.length;for(let d=y.length-1;d>=0;d--){const m=y[d];if(m.offset+m.length<=k)c=E(c,m);else throw new Error("Overlapping edit");k=m.offset}return c}}),define(ae[61],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(ae[104],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(O){this.element=O,this.next=n.Undefined,this.prev=n.Undefined}}class R{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let O=this.a;for(;O!==n.Undefined;){const A=O.next;O.prev=n.Undefined,O.next=n.Undefined,O=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,A){const E=new n(O);if(this.a===n.Undefined)this.a=E,this.b=E;else if(A){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==n.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==n.Undefined&&O.next!==n.Undefined){const A=O.prev;A.next=O.next,O.next.prev=A}else O.prev===n.Undefined&&O.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):O.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):O.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==n.Undefined;)yield O.element,O=O.next}}e.$4c=R}),define(ae[31],ce([0,1]),function(J,e){"use strict";var n,R,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=O,e.$yc=A,e.$zc=E,e.$Hc=f;function O(u,g,a){let t=u.get(g);return t===void 0&&(t=a,u.set(g,t)),t}function A(u){const g=[];return u.forEach((a,t)=>{g.push(`${t} => ${a}`)}),`Map(${u.size}) {${g.join(", ")}}`}function E(u){const g=[];return u.forEach(a=>{g.push(a)}),`Set(${u.size}) {${g.join(", ")}}`}class h{constructor(g,a){this.uri=g,this.value=a}}function c(u){return Array.isArray(u)}class b{static{this.c=g=>g.toString()}constructor(g,a){if(this[n]="ResourceMap",g instanceof b)this.d=new Map(g.d),this.e=a??b.c;else if(c(g)){this.d=new Map,this.e=a??b.c;for(const[t,o]of g)this.set(t,o)}else this.d=new Map,this.e=g??b.c}set(g,a){return this.d.set(this.e(g),new h(g,a)),this}get(g){return this.d.get(this.e(g))?.value}has(g){return this.d.has(this.e(g))}get size(){return this.d.size}clear(){this.d.clear()}delete(g){return this.d.delete(this.e(g))}forEach(g,a){typeof a<"u"&&(g=g.bind(a));for(const[t,o]of this.d)g(o.value,o.uri,this)}*values(){for(const g of this.d.values())yield g.value}*keys(){for(const g of this.d.values())yield g.uri}*entries(){for(const g of this.d.values())yield[g.uri,g.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.d)yield[g.uri,g.value]}}e.$Ac=b;class y{constructor(g,a){this[R]="ResourceSet",!g||typeof g=="function"?this.c=new b(g):(this.c=new b(a),g.forEach(this.add,this))}get size(){return this.c.size}add(g){return this.c.set(g,g),this}clear(){this.c.clear()}delete(g){return this.c.delete(g)}forEach(g,a){this.c.forEach((t,o)=>g.call(a,o,o,this))}has(g){return this.c.has(g)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=y;var k;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class d{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(g){return this.c.has(g)}get(g,a=0){const t=this.c.get(g);if(t)return a!==0&&this.l(t,a),t.value}set(g,a,t=0){let o=this.c.get(g);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:g,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(g,o),this.f++}return this}delete(g){return!!this.remove(g)}remove(g){const a=this.c.get(g);if(a)return this.c.delete(g),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const g=this.d;return this.c.delete(g.key),this.k(g),this.f--,g.value}forEach(g,a){const t=this.g;let o=this.d;for(;o;){if(a?g.bind(a)(o.value,o.key,this):g(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const g=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(g.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const g=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(g.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const g=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(g.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(g){if(g>=this.size)return;if(g===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>g;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(g){if(!this.d&&!this.e)this.e=g;else if(this.d)g.next=this.d,this.d.previous=g;else throw new Error("Invalid list");this.d=g,this.g++}j(g){if(!this.d&&!this.e)this.d=g;else if(this.e)g.previous=this.e,this.e.next=g;else throw new Error("Invalid list");this.e=g,this.g++}k(g){if(g===this.d&&g===this.e)this.d=void 0,this.e=void 0;else if(g===this.d){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.d=g.next}else if(g===this.e){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.e=g.previous}else{const a=g.next,t=g.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}g.next=void 0,g.previous=void 0,this.g++}l(g,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(g===this.d)return;const t=g.next,o=g.previous;g===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),g.previous=void 0,g.next=this.d,this.d.previous=g,this.d=g,this.g++}else if(a===2){if(g===this.e)return;const t=g.next,o=g.previous;g===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),g.next=void 0,g.previous=this.e,this.e.next=g,this.e=g,this.g++}}}toJSON(){const g=[];return this.forEach((a,t)=>{g.push([t,a])}),g}fromJSON(g){this.clear();for(const[a,t]of g)this.set(a,t)}}e.$Cc=d;class m extends d{constructor(g,a=1){super(),this.m=g,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(g){this.m=g,this.o()}get ratio(){return this.n}set ratio(g){this.n=Math.min(Math.max(0,g),1),this.o()}get(g,a=2){return super.get(g,a)}peek(g){return super.get(g,0)}set(g,a){return super.set(g,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=m;class v{constructor(){this.c=new Map}add(g){return this.c.set(g,(this.c.get(g)||0)+1),this}delete(g){let a=this.c.get(g)||0;return a===0?!1:(a--,a===0?this.c.delete(g):this.c.set(g,a),!0)}has(g){return this.c.has(g)}}e.$Ec=v;class w{constructor(g){if(this.c=new Map,this.d=new Map,g)for(const[a,t]of g)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(g,a){this.c.set(g,a),this.d.set(a,g)}get(g){return this.c.get(g)}getKey(g){return this.d.get(g)}delete(g){const a=this.c.get(g);return a===void 0?!1:(this.c.delete(g),this.d.delete(a),!0)}forEach(g,a){this.c.forEach((t,o)=>{g.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class ${constructor(){this.c=new Map}add(g,a){let t=this.c.get(g);t||(t=new Set,this.c.set(g,t)),t.add(a)}delete(g,a){const t=this.c.get(g);t&&(t.delete(a),t.size===0&&this.c.delete(g))}forEach(g,a){const t=this.c.get(g);t&&t.forEach(a)}get(g){const a=this.c.get(g);return a||new Set}}e.$Gc=$;function f(u,g){if(u===g)return!0;if(u.size!==g.size)return!1;for(const[a,t]of u)if(!g.has(a)||g.get(a)!==t)return!1;for(const[a]of g)if(!u.has(a))return!1;return!0}}),define(ae[2],ce([0,1,22,137,31,85,71]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=b,e.$Kc=y,e.$Lc=k,e.$Mc=v,e.$Nc=w,e.$Oc=$,e.$Pc=f,e.$Qc=u,e.$Rc=g,e.$2c=j;const E=!1;let h=null;class c{constructor(){this.b=new Map}static{this.a=0}c(M){let W=this.b.get(M);return W||(W={parent:null,source:null,isSingleton:!1,value:M,idx:c.a++},this.b.set(M,W)),W}trackDisposable(M){const W=this.c(M);W.source||(W.source=new Error().stack)}setParent(M,W){const F=this.c(M);F.parent=W}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,W){const F=W.get(M);if(F)return F;const H=M.parent?this.f(this.c(M.parent),W):M;return W.set(M,H),H}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,M).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(M=10,W){let F;if(W)F=W;else{const ue=new Map,Q=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,ue).isSingleton);if(Q.length===0)return;const Y=new Set(Q.map(U=>U.value));if(F=Q.filter(U=>!(U.parent&&Y.has(U.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function H(ue){function Q(U,L){for(;U.length>0&&L.some(N=>typeof N=="string"?N===U[0]:U[0].match(N));)U.shift()}const Y=ue.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return Q(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const x=new P.$Gc;for(const ue of F){const Q=H(ue);for(let Y=0;Y<=Q.length;Y++)x.add(Q.slice(0,Y).join(`
`),ue)}F.sort((0,n.$7b)(ue=>ue.idx,n.$9b));let le="",re=0;for(const ue of F.slice(0,M)){re++;const Q=H(ue),Y=[];for(let U=0;U<Q.length;U++){let L=Q[U];L=`(shared with ${x.get(Q.slice(0,U+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const G=x.get(Q.slice(0,U).join(`
`)),q=(0,R.$K)([...G].map(oe=>H(oe)[U]),oe=>oe);delete q[Q[U]];for(const[oe,he]of Object.entries(q))Y.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);Y.unshift(L)}le+=`


==================== Leaking disposable ${re}/${F.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return F.length>M&&(le+=`


... and ${F.length-M} more leaking disposables

`),{leaks:F,details:le}}}e.$Ic=c;function b(D){h=D}if(E){const D="__is_disposable_tracked__";b(new class{trackDisposable(M){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[D]||console.log(W)},3e3)}setParent(M,W){if(M&&M!==t.None)try{M[D]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[D]=!0}catch{}}markAsSingleton(M){}})}function y(D){return h?.trackDisposable(D),D}function k(D){h?.markAsDisposed(D)}function d(D,M){h?.setParent(D,M)}function m(D,M){if(h)for(const W of D)h.setParent(W,M)}function v(D){return h?.markAsSingleton(D),D}function w(D){return typeof D.dispose=="function"&&D.dispose.length===0}function $(D){if(A.Iterable.is(D)){const M=[];for(const W of D)if(W)try{W.dispose()}catch(F){M.push(F)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function f(D){for(const M of D)w(M)&&M.dispose();return[]}function u(...D){const M=g(()=>$(D));return m(D,M),M}function g(D){const M=y({dispose:(0,O.$db)(()=>{k(M),D()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return d(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),d(M,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),d(this.q,this)}dispose(){k(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Tc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&d(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&d(M,null),M}}e.$Uc=o;class r{constructor(M){this.a=new o,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(M){let W=M;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,k(this))},this}}e.$Xc=s;class l{constructor(){this.a=new Map}acquire(M,...W){let F=this.a.get(M);F||(F={counter:0,object:this.b(M,...W)},this.a.set(M,F));const{object:H}=F,x=(0,O.$db)(()=>{--F.counter===0&&(this.c(M,F.object),this.a.delete(M))});return F.counter++,{object:H,dispose:x}}}e.$Yc=l;class p{constructor(M){this.a=M}async acquire(M,...W){const F=this.a.acquire(M,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(H){throw F.dispose(),H}}}e.$Zc=p;class I{constructor(M){this.object=M}dispose(){}}e.$1c=I;function j(D){const M=new a;try{D(M)}finally{M.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(M)?.dispose(),this.a.set(M,W)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=S}),define(ae[86],ce([0,1,31]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=void 0,e.$Xl=P,e.$Yl=A;const R=new n.$Dc(1e4);function P(c){return h(c,"NFC",R)}const O=new n.$Dc(1e4);function A(c){return h(c,"NFD",O)}const E=/[^\u0000-\u0080]/;function h(c,b,y){if(!c)return c;const k=y.get(c);if(k)return k;let d;return E.test(c)?d=c.normalize(b):d=c,y.set(c,d),d}e.$Zl=function(){const c=/[\u0300-\u036f]/g;return function(b){return A(b).replace(c,"")}}()}),define(ae[141],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0,e.$lm=n,e.rot=R;function n(E,h,c){return Math.min(Math.max(E,h),c)}function R(E,h){return(h+E%h)%h}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$nm=P;class O{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$om=O;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$pm=A}),function(){function J(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A(h){O.push(h,Date.now())}function E(){const h=[];for(let c=0;c<O.length;c+=2)h.push({name:O[c],startTime:O[c+1]});return h}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=n(R))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var R in n)(typeof exports=="object"?exports:J)[R]=n[R]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function n(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return J[R].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=J,n.c=e,n.d=function(R,P,O){n.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},n.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},n.t=function(R,P){if(1&P&&(R=n(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(n.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var A in R)n.d(O,A,function(E){return R[E]}.bind(null,A));return O},n.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return n.d(P,"a",P),P},n.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},n.p="",n(n.s=0)}([function(J,e,n){(function(R){var P;e=J.exports=he,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],c=0,b=c++;h[b]="0|[1-9]\\d*";var y=c++;h[y]="[0-9]+";var k=c++;h[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;h[d]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var m=c++;h[m]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var v=c++;h[v]="(?:"+h[b]+"|"+h[k]+")";var w=c++;h[w]="(?:"+h[y]+"|"+h[k]+")";var $=c++;h[$]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var f=c++;h[f]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var u=c++;h[u]="[0-9A-Za-z-]+";var g=c++;h[g]="(?:\\+("+h[u]+"(?:\\."+h[u]+")*))";var a=c++,t="v?"+h[d]+h[$]+"?"+h[g]+"?";h[a]="^"+t+"$";var o="[v=\\s]*"+h[m]+h[f]+"?"+h[g]+"?",r=c++;h[r]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var s=c++;h[s]=h[y]+"|x|X|\\*";var l=c++;h[l]=h[b]+"|x|X|\\*";var p=c++;h[p]="[v=\\s]*("+h[l]+")(?:\\.("+h[l]+")(?:\\.("+h[l]+")(?:"+h[$]+")?"+h[g]+"?)?)?";var I=c++;h[I]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[f]+")?"+h[g]+"?)?)?";var j=c++;h[j]="^"+h[i]+"\\s*"+h[p]+"$";var S=c++;h[S]="^"+h[i]+"\\s*"+h[I]+"$";var D=c++;h[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=c++;h[M]="(?:~>?)";var W=c++;h[W]="(\\s*)"+h[M]+"\\s+",E[W]=new RegExp(h[W],"g");var F=c++;h[F]="^"+h[M]+h[p]+"$";var H=c++;h[H]="^"+h[M]+h[I]+"$";var x=c++;h[x]="(?:\\^)";var le=c++;h[le]="(\\s*)"+h[x]+"\\s+",E[le]=new RegExp(h[le],"g");var re=c++;h[re]="^"+h[x]+h[p]+"$";var ue=c++;h[ue]="^"+h[x]+h[I]+"$";var Q=c++;h[Q]="^"+h[i]+"\\s*("+o+")$|^$";var Y=c++;h[Y]="^"+h[i]+"\\s*("+t+")$|^$";var U=c++;h[U]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[p]+")",E[U]=new RegExp(h[U],"g");var L=c++;h[L]="^\\s*("+h[p]+")\\s+-\\s+("+h[p]+")\\s*$";var N=c++;h[N]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)P(q,h[q]),E[q]||(E[q]=new RegExp(h[q]));function oe(ee,fe){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>O||!(fe?E[r]:E[a]).test(ee))return null;try{return new he(ee,fe)}catch{return null}}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof he))return new he(ee,fe);P("SemVer",ee,fe),this.loose=fe;var $e=ee.trim().match(fe?E[r]:E[a]);if(!$e)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<A)return Re}return Pe}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ee,fe){var $e=oe(ee,fe);return $e?$e.version:null},e.clean=function(ee,fe){var $e=oe(ee.trim().replace(/^[=v]+/,""),fe);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),C(this.major,ee.major)||C(this.minor,ee.minor)||C(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var $e=this.prerelease[fe],Pe=ee.prerelease[fe];if(P("prerelease compare",fe,$e,Pe),$e===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if($e===void 0)return-1;if($e!==Pe)return C($e,Pe)}while(++fe)},he.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,$e,Pe){typeof $e=="string"&&(Pe=$e,$e=void 0);try{return new he(ee,$e).inc(fe,Pe).version}catch{return null}},e.diff=function(ee,fe){if(X(ee,fe))return null;var $e=oe(ee),Pe=oe(fe);if($e.prerelease.length||Pe.prerelease.length){for(var Re in $e)if((Re==="major"||Re==="minor"||Re==="patch")&&$e[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in $e)if((Re==="major"||Re==="minor"||Re==="patch")&&$e[Re]!==Pe[Re])return Re},e.compareIdentifiers=C;var K=/^[0-9]+$/;function C(ee,fe){var $e=K.test(ee),Pe=K.test(fe);return $e&&Pe&&(ee=+ee,fe=+fe),$e&&!Pe?-1:Pe&&!$e?1:ee<fe?-1:ee>fe?1:0}function T(ee,fe,$e){return new he(ee,$e).compare(new he(fe,$e))}function Z(ee,fe,$e){return T(ee,fe,$e)>0}function z(ee,fe,$e){return T(ee,fe,$e)<0}function X(ee,fe,$e){return T(ee,fe,$e)===0}function V(ee,fe,$e){return T(ee,fe,$e)!==0}function _(ee,fe,$e){return T(ee,fe,$e)>=0}function B(ee,fe,$e){return T(ee,fe,$e)<=0}function te(ee,fe,$e,Pe){var Re;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof $e=="object"&&($e=$e.version),Re=ee===$e;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof $e=="object"&&($e=$e.version),Re=ee!==$e;break;case"":case"=":case"==":Re=X(ee,$e,Pe);break;case"!=":Re=V(ee,$e,Pe);break;case">":Re=Z(ee,$e,Pe);break;case">=":Re=_(ee,$e,Pe);break;case"<":Re=z(ee,$e,Pe);break;case"<=":Re=B(ee,$e,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return Re}function ie(ee,fe){if(ee instanceof ie){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof ie))return new ie(ee,fe);P("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,fe){return C(fe,ee)},e.major=function(ee,fe){return new he(ee,fe).major},e.minor=function(ee,fe){return new he(ee,fe).minor},e.patch=function(ee,fe){return new he(ee,fe).patch},e.compare=T,e.compareLoose=function(ee,fe){return T(ee,fe,!0)},e.rcompare=function(ee,fe,$e){return T(fe,ee,$e)},e.sort=function(ee,fe){return ee.sort(function($e,Pe){return e.compare($e,Pe,fe)})},e.rsort=function(ee,fe){return ee.sort(function($e,Pe){return e.rcompare($e,Pe,fe)})},e.gt=Z,e.lt=z,e.eq=X,e.neq=V,e.gte=_,e.lte=B,e.cmp=te,e.Comparator=ie;var de={};function me(ee,fe){if(ee instanceof me)return ee.loose===fe?ee:new me(ee.raw,fe);if(ee instanceof ie)return new me(ee.value,fe);if(!(this instanceof me))return new me(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Se(ee,fe,$e,Pe,Re,qe,Me,We,Ue,xe,Je,Te,ne){return((fe=ke($e)?"":ke(Pe)?">="+$e+".0.0":ke(Re)?">="+$e+"."+Pe+".0":">="+fe)+" "+(We=ke(Ue)?"":ke(xe)?"<"+(+Ue+1)+".0.0":ke(Je)?"<"+Ue+"."+(+xe+1)+".0":Te?"<="+Ue+"."+xe+"."+Je+"-"+Te:"<="+We)).trim()}function Oe(ee,fe){for(var $e=0;$e<ee.length;$e++)if(!ee[$e].test(fe))return!1;if(fe.prerelease.length){for($e=0;$e<ee.length;$e++)if(P(ee[$e].semver),ee[$e].semver!==de&&ee[$e].semver.prerelease.length>0){var Pe=ee[$e].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function He(ee,fe,$e){try{fe=new me(fe,$e)}catch{return!1}return fe.test(ee)}function ye(ee,fe,$e,Pe){var Re,qe,Me,We,Ue;switch(ee=new he(ee,Pe),fe=new me(fe,Pe),$e){case">":Re=Z,qe=B,Me=z,We=">",Ue=">=";break;case"<":Re=z,qe=_,Me=Z,We="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(ee,fe,Pe))return!1;for(var xe=0;xe<fe.set.length;++xe){var Je=fe.set[xe],Te=null,ne=null;if(Je.forEach(function(ge){ge.semver===de&&(ge=new ie(">=0.0.0")),Te=Te||ge,ne=ne||ge,Re(ge.semver,Te.semver,Pe)?Te=ge:Me(ge.semver,ne.semver,Pe)&&(ne=ge)}),Te.operator===We||Te.operator===Ue||(!ne.operator||ne.operator===We)&&qe(ee,ne.semver)||ne.operator===Ue&&Me(ee,ne.semver))return!1}return!0}ie.prototype.parse=function(ee){var fe=this.loose?E[Q]:E[Y],$e=ee.match(fe);if(!$e)throw new TypeError("Invalid comparator: "+ee);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=de},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===de||(typeof ee=="string"&&(ee=new he(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(ee,fe){if(!(ee instanceof ie))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(ee.value,fe),He(this.value,$e,fe);if(ee.operator==="")return $e=new me(this.value,fe),He(ee.semver,$e,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),qe=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),We=te(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ue=te(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Pe||Re||qe&&Me||We||Ue},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),P("range",ee,fe);var $e=fe?E[N]:E[L];ee=ee.replace($e,Se),P("hyphen replace",ee),ee=ee.replace(E[U],"$1$2$3"),P("comparator trim",ee,E[U]),ee=(ee=(ee=ee.replace(E[W],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var Pe=fe?E[Q]:E[Y],Re=ee.split(" ").map(function(qe){return function(Me,We){return P("comp",Me),Me=function(Ue,xe){return Ue.trim().split(/\s+/).map(function(Je){return function(Te,ne){P("caret",Te,ne);var ge=ne?E[ue]:E[re];return Te.replace(ge,function(pe,be,Ee,Ce,Ne){var Ke;return P("caret",Te,pe,be,Ee,Ce,Ne),ke(be)?Ke="":ke(Ee)?Ke=">="+be+".0.0 <"+(+be+1)+".0.0":ke(Ce)?Ke=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Ce+Ne+" <"+be+"."+Ee+"."+(+Ce+1):">="+be+"."+Ee+"."+Ce+Ne+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Ce+Ne+" <"+(+be+1)+".0.0"):(P("no pr"),Ke=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Ce+" <"+be+"."+Ee+"."+(+Ce+1):">="+be+"."+Ee+"."+Ce+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Ce+" <"+(+be+1)+".0.0"),P("caret return",Ke),Ke})}(Je,xe)}).join(" ")}(Me,We),P("caret",Me),Me=function(Ue,xe){return Ue.trim().split(/\s+/).map(function(Je){return function(Te,ne){var ge=ne?E[H]:E[F];return Te.replace(ge,function(pe,be,Ee,Ce,Ne){var Ke;return P("tilde",Te,pe,be,Ee,Ce,Ne),ke(be)?Ke="":ke(Ee)?Ke=">="+be+".0.0 <"+(+be+1)+".0.0":ke(Ce)?Ke=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=">="+be+"."+Ee+"."+Ce+Ne+" <"+be+"."+(+Ee+1)+".0"):Ke=">="+be+"."+Ee+"."+Ce+" <"+be+"."+(+Ee+1)+".0",P("tilde return",Ke),Ke})}(Je,xe)}).join(" ")}(Me,We),P("tildes",Me),Me=function(Ue,xe){return P("replaceXRanges",Ue,xe),Ue.split(/\s+/).map(function(Je){return function(Te,ne){Te=Te.trim();var ge=ne?E[S]:E[j];return Te.replace(ge,function(pe,be,Ee,Ce,Ne,Ke){P("xRange",Te,pe,be,Ee,Ce,Ne,Ke);var Ze=ke(Ee),Xe=Ze||ke(Ce),Qe=Xe||ke(Ne);return be==="="&&Qe&&(be=""),Ze?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Qe?(Xe&&(Ce=0),Qe&&(Ne=0),be===">"?(be=">=",Xe?(Ee=+Ee+1,Ce=0,Ne=0):Qe&&(Ce=+Ce+1,Ne=0)):be==="<="&&(be="<",Xe?Ee=+Ee+1:Ce=+Ce+1),pe=be+Ee+"."+Ce+"."+Ne):Xe?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Qe&&(pe=">="+Ee+"."+Ce+".0 <"+Ee+"."+(+Ce+1)+".0"),P("xRange return",pe),pe})}(Je,xe)}).join(" ")}(Me,We),P("xrange",Me),Me=function(Ue,xe){return P("replaceStars",Ue,xe),Ue.trim().replace(E[G],"")}(Me,We),P("stars",Me),Me}(qe,fe)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(qe){return!!qe.match(Pe)})),Re=Re.map(function(qe){return new ie(qe,fe)})},me.prototype.intersects=function(ee,fe){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Pe){return ee.set.some(function(Re){return Re.every(function(qe){return Pe.intersects(qe,fe)})})})})},e.toComparators=function(ee,fe){return new me(ee,fe).set.map(function($e){return $e.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Oe(this.set[fe],ee))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(ee,fe,$e){var Pe=null,Re=null;try{var qe=new me(fe,$e)}catch{return null}return ee.forEach(function(Me){qe.test(Me)&&(Pe&&Re.compare(Me)!==-1||(Re=new he(Pe=Me,$e)))}),Pe},e.minSatisfying=function(ee,fe,$e){var Pe=null,Re=null;try{var qe=new me(fe,$e)}catch{return null}return ee.forEach(function(Me){qe.test(Me)&&(Pe&&Re.compare(Me)!==1||(Re=new he(Pe=Me,$e)))}),Pe},e.validRange=function(ee,fe){try{return new me(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,$e){return ye(ee,fe,"<",$e)},e.gtr=function(ee,fe,$e){return ye(ee,fe,">",$e)},e.outside=ye,e.prerelease=function(ee,fe){var $e=oe(ee,fe);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(ee,fe,$e){return ee=new me(ee,$e),fe=new me(fe,$e),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var fe=ee.match(E[D]);return fe==null?null:oe((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(J,e){var n,R,P=J.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(w){if(n===setTimeout)return setTimeout(w,0);if((n===O||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:O}catch{n=O}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var h,c=[],b=!1,y=-1;function k(){b&&h&&(b=!1,h.length?c=h.concat(c):y=-1,c.length&&d())}function d(){if(!b){var w=E(k);b=!0;for(var $=c.length;$;){for(h=c,c=[];++y<$;)h&&h[y].run();y=-1,$=c.length}h=null,b=!1,function(f){if(R===clearTimeout)return clearTimeout(f);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(f);try{R(f)}catch{try{return R.call(null,f)}catch{return R.call(this,f)}}}(w)}}function m(w,$){this.fun=w,this.array=$}function v(){}P.nextTick=function(w){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new m(w,$)),c.length!==1||b||E(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(w){return[]},P.binding=function(w){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(w){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ae[142],ce([0,1]),function(J,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class R{constructor(E,h,c){this.level=E,this.key=h,this.value=c,this.forward=[]}}const P=void 0;class O{constructor(E,h=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new R(this.c,P,P)}get size(){return this.f}clear(){this.e=new R(this.c,P,P),this.f=0}has(E){return!!O.g(this,E,this.comparator)}get(E){return O.g(this,E,this.comparator)?.value}set(E,h){return O.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=O.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let c=this.e.forward[0];for(;c;)E.call(h,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,c){let b=E.e;for(let y=E.d-1;y>=0;y--)for(;b.forward[y]&&c(b.forward[y].key,h)<0;)b=b.forward[y];if(b=b.forward[0],b&&c(b.key,h)===0)return b}static h(E,h,c,b){const y=[];let k=E.e;for(let d=E.d-1;d>=0;d--){for(;k.forward[d]&&b(k.forward[d].key,h)<0;)k=k.forward[d];y[d]=k}if(k=k.forward[0],k&&b(k.key,h)===0)return k.value=c,!1;{const d=O.j(E);if(d>E.d){for(let m=E.d;m<d;m++)y[m]=E.e;E.d=d}k=new R(d,h,c);for(let m=0;m<d;m++)k.forward[m]=y[m].forward[m],y[m].forward[m]=k;return!0}}static j(E,h=.5){let c=1;for(;Math.random()<h&&c<E.c;)c+=1;return c}static k(E,h,c){const b=[];let y=E.e;for(let k=E.d-1;k>=0;k--){for(;y.forward[k]&&c(y.forward[k].key,h)<0;)y=y.forward[k];b[k]=y}if(y=y.forward[0],!y||c(y.key,h)!==0)return!1;for(let k=0;k<E.d&&b[k].forward[k]===y;k++)b[k].forward[k]=y.forward[k];for(;E.d>0&&E.e.forward[E.d-1]===P;)E.d-=1;return!0}}e.$es=O}),define(ae[72],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(O){return new R(O)}constructor(O){this.c=n&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=R}),define(ae[3],ce([0,1,15,85,2,104,72]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$4d=e.Event=void 0,e.$5d=k;const E=!1,h=!1;var c;(function(j){j.None=()=>P.$Tc.None;function S(B){if(h){const{onDidAddListener:te}=B,ie=m.create();let de=0;B.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),te?.()}}}function D(B,te){return Y(B,()=>{},0,void 0,!0,void 0,te)}j.defer=D;function M(B){return(te,ie=null,de)=>{let me=!1,ke;return ke=B(Se=>{if(!me)return ke?ke.dispose():me=!0,te.call(ie,Se)},null,de),me&&ke.dispose(),ke}}j.once=M;function W(B,te,ie){return ue((de,me=null,ke)=>B(Se=>de.call(me,te(Se)),null,ke),ie)}j.map=W;function F(B,te,ie){return ue((de,me=null,ke)=>B(Se=>{te(Se),de.call(me,Se)},null,ke),ie)}j.forEach=F;function H(B,te,ie){return ue((de,me=null,ke)=>B(Se=>te(Se)&&de.call(me,Se),null,ke),ie)}j.filter=H;function x(B){return B}j.signal=x;function le(...B){return(te,ie=null,de)=>{const me=(0,P.$Qc)(...B.map(ke=>ke(Se=>te.call(ie,Se))));return Q(me,de)}}j.any=le;function re(B,te,ie,de){let me=ie;return W(B,ke=>(me=te(me,ke),me),de)}j.reduce=re;function ue(B,te){let ie;const de={onWillAddFirstListener(){ie=B(me.fire,me)},onDidRemoveLastListener(){ie?.dispose()}};te||S(de);const me=new u(de);return te?.add(me),me.event}function Q(B,te){return te instanceof Array?te.push(B):te&&te.add(B),B}function Y(B,te,ie=100,de=!1,me=!1,ke,Se){let Oe,He,ye,ee=0,fe;const $e={leakWarningThreshold:ke,onWillAddFirstListener(){Oe=B(Re=>{ee++,He=te(He,Re),de&&!ye&&(Pe.fire(He),He=void 0),fe=()=>{const qe=He;He=void 0,ye=void 0,(!de||ee>1)&&Pe.fire(qe),ee=0},typeof ie=="number"?(clearTimeout(ye),ye=setTimeout(fe,ie)):ye===void 0&&(ye=0,queueMicrotask(fe))})},onWillRemoveListener(){me&&ee>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Oe.dispose()}};Se||S($e);const Pe=new u($e);return Se?.add(Pe),Pe.event}j.debounce=Y;function U(B,te=0,ie){return j.debounce(B,(de,me)=>de?(de.push(me),de):[me],te,void 0,!0,void 0,ie)}j.accumulate=U;function L(B,te=(de,me)=>de===me,ie){let de=!0,me;return H(B,ke=>{const Se=de||!te(ke,me);return de=!1,me=ke,Se},ie)}j.latch=L;function N(B,te,ie){return[j.filter(B,te,ie),j.filter(B,de=>!te(de),ie)]}j.split=N;function G(B,te=!1,ie=[],de){let me=ie.slice(),ke=B(He=>{me?me.push(He):Oe.fire(He)});de&&de.add(ke);const Se=()=>{me?.forEach(He=>Oe.fire(He)),me=null},Oe=new u({onWillAddFirstListener(){ke||(ke=B(He=>Oe.fire(He)),de&&de.add(ke))},onDidAddFirstListener(){me&&(te?setTimeout(Se):Se())},onDidRemoveLastListener(){ke&&ke.dispose(),ke=null}});return de&&de.add(Oe),Oe.event}j.buffer=G;function q(B,te){return(de,me,ke)=>{const Se=te(new he);return B(function(Oe){const He=Se.evaluate(Oe);He!==oe&&de.call(me,He)},void 0,ke)}}j.chain=q;const oe=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ie=>(te(ie),ie)),this}filter(te){return this.f.push(ie=>te(ie)?ie:oe),this}reduce(te,ie){let de=ie;return this.f.push(me=>(de=te(de,me),de)),this}latch(te=(ie,de)=>ie===de){let ie=!0,de;return this.f.push(me=>{const ke=ie||!te(me,de);return ie=!1,de=me,ke?me:oe}),this}evaluate(te){for(const ie of this.f)if(te=ie(te),te===oe)break;return te}}function K(B,te,ie=de=>de){const de=(...Oe)=>Se.fire(ie(...Oe)),me=()=>B.on(te,de),ke=()=>B.removeListener(te,de),Se=new u({onWillAddFirstListener:me,onDidRemoveLastListener:ke});return Se.event}j.fromNodeEventEmitter=K;function C(B,te,ie=de=>de){const de=(...Oe)=>Se.fire(ie(...Oe)),me=()=>B.addEventListener(te,de),ke=()=>B.removeEventListener(te,de),Se=new u({onWillAddFirstListener:me,onDidRemoveLastListener:ke});return Se.event}j.fromDOMEventEmitter=C;function T(B){return new Promise(te=>M(B)(te))}j.toPromise=T;function Z(B){const te=new u;return B.then(ie=>{te.fire(ie)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}j.fromPromise=Z;function z(B,te,ie){return te(ie),B(de=>te(de))}j.runAndSubscribe=z;class X{constructor(te,ie){this._observable=te,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ie||S(de),this.emitter=new u(de),ie&&ie.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ie){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function V(B,te){return new X(B,te).emitter.event}j.fromObservable=V;function _(B){return(te,ie,de)=>{let me=0,ke=!1;const Se={beginUpdate(){me++},endUpdate(){me--,me===0&&(B.reportChanges(),ke&&(ke=!1,te.call(ie)))},handlePossibleChange(){},handleChange(){ke=!0}};B.addObserver(Se),B.reportChanges();const Oe={dispose(){B.removeObserver(Se)}};return de instanceof P.$Sc?de.add(Oe):Array.isArray(de)&&de.push(Oe),Oe}}j.fromObservableLight=_})(c||(e.Event=c={}));class b{static{this.all=new Set}static{this.f=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${b.f++}`,b.all.add(this)}start(S){this.g=new A.$2d,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}e.$4d=b;let y=-1;function k(j){const S=y;return y=j,{dispose(){y=S}}}class d{constructor(S,D=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=D,this.g=0}dispose(){this.f?.clear()}check(S,D){const M=this.threshold;if(M<=0||D<M)return;this.f||(this.f=new Map);const W=this.f.get(S.value)||0;if(this.f.set(S.value,W+1),this.g-=1,this.g<=0){this.g=M*.5;let F,H=0;for(const[x,le]of this.f)(!F||H<le)&&(F=x,H=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${H}):`),console.warn(F)}return()=>{const F=this.f.get(S.value)||0;this.f.set(S.value,F-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class w{constructor(S){this.value=S,this.id=v++}}const $=2,f=(j,S)=>{if(j instanceof w)S(j);else for(let D=0;D<j.length;D++){const M=j[D];M&&S(M)}};class u{constructor(S){this.w=0,this.f=S,this.g=y>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??y):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const S=this.t;queueMicrotask(()=>{f(S,D=>D.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(S,D,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Tc.None;if(this.m)return P.$Tc.None;D&&(S=S.bind(D));const W=new w(S);let F,H;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(W.stack=m.create(),F=this.g.check(W.stack,this.w+1)),E&&(W.stack=H??m.create()),this.t?this.t instanceof w?(this.u??=new a,this.t=[this.t,W]):this.t.push(W):(this.f?.onWillAddFirstListener?.(this),this.t=W,this.f?.onDidAddFirstListener?.(this)),this.w++;const x=(0,P.$Rc)(()=>{F?.(),this.x(W)});return M instanceof P.$Sc?M.add(x):Array.isArray(M)&&M.push(x),x},this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const D=this.t,M=D.indexOf(S);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,D[M]=void 0;const W=this.u.current===this;if(this.w*$<=D.length){let F=0;for(let H=0;H<D.length;H++)D[H]?D[F++]=D[H]:W&&(this.u.end--,F<this.u.i&&this.u.i--);D.length=F}}y(S,D){if(!S)return;const M=this.f?.onListenerError||n.$1;if(!M){S.value(D);return}try{S.value(D)}catch(W){M(W)}}z(S){const D=S.current.t;for(;S.i<S.end;)this.y(D[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,S);else{const D=this.u;D.enqueue(this,S,this.t.length),this.z(D)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=u;const g=()=>new a;e.$7d=g;class a{constructor(){this.i=-1,this.end=0}enqueue(S,D,M){this.i=0,this.end=M,this.current=S,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends u{async fireAsync(S,D,M){if(this.t)for(this.h||(this.h=new O.$4c),f(this.t,W=>this.h.push([W.value,S]));this.h.size>0&&!D.isCancellationRequested;){const[W,F]=this.h.shift(),H=[],x={...F,token:D,waitUntil:le=>{if(Object.isFrozen(H))throw new Error("waitUntil can NOT be called asynchronous");M&&(le=M(le,W)),H.push(le)}};try{W(x)}catch(le){(0,n.$1)(le);continue}Object.freeze(H),await Promise.allSettled(H).then(le=>{for(const re of le)re.status==="rejected"&&(0,n.$1)(re.reason)})}}}e.$8d=t;class o extends u{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new O.$4c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}e.$9d=o;class r extends o{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}e.$0d=r;class i extends u{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(D=>super.fire(D)),this.h=[]}))}}e.$$d=i;class s{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const D={event:S,listener:null};this.h.push(D),this.g&&this.m(D);const M=()=>{this.g&&this.o(D);const W=this.h.indexOf(D);this.h.splice(W,1)};return(0,P.$Rc)((0,R.$db)(M))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(D=>this.f.fire(D))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}e.$_d=s;class l{constructor(S,D,M,W){this.f=new P.$Sc;const F=this.f.add(new s),H=this.f.add(new P.$3c);function x(le){H.set(le,F.add(W(le)))}for(const le of S)x(le);this.f.add(D(le=>{x(le)})),this.f.add(M(le=>{H.deleteAndDispose(le)})),this.event=F.event}dispose(){this.f.dispose()}}e.$ae=l;class p{constructor(){this.f=[]}wrapEvent(S){return(D,M,W)=>S(F=>{const H=this.f[this.f.length-1];H?H.push(()=>D.call(M,F)):D.call(M,F)},void 0,W)}bufferEvents(S){const D=[];this.f.push(D);const M=S();return this.f.pop(),D.forEach(W=>W()),M}}e.$be=p;class I{constructor(){this.f=!1,this.g=c.None,this.h=P.$Tc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=I}),define(ae[23],ce([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const R=Object.freeze(function(E,h){const c=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(c)}}});var P;(function(E){function h(c){return c===E.None||c===E.Cancelled||c instanceof O?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(P||(e.CancellationToken=P={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new n.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=P.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=P.None}}e.$de=A}),define(ae[143],ce([0,1,23]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class R{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new n.$de,h=this.b(E.token);return this.a={promise:h,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Oe=R;class P{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const h=JSON.stringify(E);return this.b!==h&&(this.b=h,this.a=this.c(E)),this.a}}e.$Pe=P;class O{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const h=this.b(E);return this.a.set(E,h),h}}e.$Qe=O}),define(ae[62],ce([0,1,15,2]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=P,e.$fe=O,e.$ge=A,e.$he=E,e.$ie=c,e.$je=b,e.$ke=y,e.$le=k,e.$me=d,e.$ne=m,e.$oe=v,e.$pe=w,e.$qe=$,e.$re=f,e.$se=u;function P(g){const a=g;return a?typeof a.read=="function":!1}function O(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function A(g){const a=g;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(g,a){return new h(g,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,a){const t=[];let o;for(;(o=g.read())!==null;)t.push(o);return a(t)}function b(g,a,t){const o=[];let r;for(;(r=g.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return g.read()}}}function y(g,a){return new Promise((t,o)=>{const r=[];k(g,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}function k(g,a,t){g.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),g.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),g.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function d(g,a){return new Promise((t,o)=>{const r=new R.$Sc,i=[],s=I=>{if(i.push(I),i.length>a)return r.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},l=I=>(r.dispose(),o(I)),p=()=>(r.dispose(),t({stream:g,buffer:i,ended:!0}));r.add((0,R.$Rc)(()=>g.removeListener("error",l))),g.on("error",l),r.add((0,R.$Rc)(()=>g.removeListener("end",p))),g.on("end",p),r.add((0,R.$Rc)(()=>g.removeListener("data",s))),g.on("data",s)})}function m(g,a){const t=E(a);return t.end(g),t}function v(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}function w(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}function $(g,a,t){const o=E(t);return k(g,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}function f(g,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([g,r]):g)}}}function u(g,a,t){let o=!1;const r=E(t);return k(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([g,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(g)),r.end()}}),r}}),define(ae[17],ce([0,1,61,62]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=void 0,e.$ue=c,e.$ve=b,e.$we=y,e.$xe=k,e.$ye=d,e.$ze=m,e.$Ae=v,e.$Be=w,e.$Ce=$,e.$De=f,e.$Ee=u,e.$Fe=g,e.$Ge=a,e.$He=t,e.$Ie=o,e.$Je=r,e.$Ke=i,e.$Le=s,e.$Me=l,e.$Ne=j;const P=typeof Buffer<"u",O=new n.$V(()=>new Uint8Array(256));let A,E;class h{static alloc(D){return P?new h(Buffer.allocUnsafe(D)):new h(new Uint8Array(D))}static wrap(D){return P&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new h(D)}static fromString(D,M){return!(M?.dontUseNodeBuffer||!1)&&P?new h(Buffer.from(D)):(A||(A=new TextEncoder),new h(A.encode(D)))}static fromByteArray(D){const M=h.alloc(D.length);for(let W=0,F=D.length;W<F;W++)M.buffer[W]=D[W];return M}static concat(D,M){if(typeof M>"u"){M=0;for(let H=0,x=D.length;H<x;H++)M+=D[H].byteLength}const W=h.alloc(M);let F=0;for(let H=0,x=D.length;H<x;H++){const le=D[H];W.set(le,F),F+=le.byteLength}return W}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=h.alloc(this.byteLength);return D.set(this),D}toString(){return P?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(D,M){return new h(this.buffer.subarray(D,M))}set(D,M){if(D instanceof h)this.buffer.set(D.buffer,M);else if(D instanceof Uint8Array)this.buffer.set(D,M);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),M);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return k(this.buffer,D)}writeUInt32BE(D,M){d(this.buffer,D,M)}readUInt32LE(D){return m(this.buffer,D)}writeUInt32LE(D,M){v(this.buffer,D,M)}readUInt8(D){return w(this.buffer,D)}writeUInt8(D,M){$(this.buffer,D,M)}indexOf(D,M=0){return c(this.buffer,D instanceof h?D.buffer:D,M)}}e.$te=h;function c(S,D,M=0){const W=D.byteLength,F=S.byteLength;if(W===0)return 0;if(W===1)return S.indexOf(D[0]);if(W>F-M)return-1;const H=O.value;H.fill(D.length);for(let ue=0;ue<D.length;ue++)H[D[ue]]=D.length-ue-1;let x=M+D.length-1,le=x,re=-1;for(;x<F;)if(S[x]===D[le]){if(le===0){re=x;break}x--,le--}else x+=Math.max(D.length-le,H[S[x]]),le=D.length-1;return re}function b(S,D){return S[D+0]<<0>>>0|S[D+1]<<8>>>0}function y(S,D,M){S[M+0]=D&255,D=D>>>8,S[M+1]=D&255}function k(S,D){return S[D]*2**24+S[D+1]*2**16+S[D+2]*2**8+S[D+3]}function d(S,D,M){S[M+3]=D,D=D>>>8,S[M+2]=D,D=D>>>8,S[M+1]=D,D=D>>>8,S[M]=D}function m(S,D){return S[D+0]<<0>>>0|S[D+1]<<8>>>0|S[D+2]<<16>>>0|S[D+3]<<24>>>0}function v(S,D,M){S[M+0]=D&255,D=D>>>8,S[M+1]=D&255,D=D>>>8,S[M+2]=D&255,D=D>>>8,S[M+3]=D&255}function w(S,D){return S[D]}function $(S,D,M){S[M]=D}function f(S){return R.$ie(S,D=>h.concat(D))}function u(S){return R.$pe(S)}function g(S){return R.$ke(S,D=>h.concat(D))}async function a(S){return S.ended?h.concat(S.buffer):h.concat([...S.buffer,await g(S.stream)])}function t(S){return R.$ne(S,D=>h.concat(D))}function o(S){return R.$qe(S,{data:D=>typeof D=="string"?h.fromString(D):h.wrap(D)},D=>h.concat(D))}function r(S){return R.$he(D=>h.concat(D),S)}function i(S,D){return R.$re(S,D,M=>h.concat(M))}function s(S,D){return R.$se(S,D,M=>h.concat(M))}function l(S){let D=0,M=0,W=0;const F=new Uint8Array(Math.floor(S.length/4*3)),H=le=>{switch(M){case 3:F[W++]=D|le,M=0;break;case 2:F[W++]=D|le>>>2,D=le<<6,M=3;break;case 1:F[W++]=D|le>>>4,D=le<<4,M=2;break;default:D=le<<2,M=1}};for(let le=0;le<S.length;le++){const re=S.charCodeAt(le);if(re>=65&&re<=90)H(re-65);else if(re>=97&&re<=122)H(re-97+26);else if(re>=48&&re<=57)H(re-48+52);else if(re===43||re===45)H(62);else if(re===47||re===95)H(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${S[le]}`)}}const x=W;for(;M>0;)H(0);return h.wrap(F).slice(0,x)}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:S},D=!0,M=!1){const W=M?I:p;let F="";const H=S.byteLength%3;let x=0;for(;x<S.byteLength-H;x+=3){const le=S[x+0],re=S[x+1],ue=S[x+2];F+=W[le>>>2],F+=W[(le<<4|re>>>4)&63],F+=W[(re<<2|ue>>>6)&63],F+=W[ue&63]}if(H===1){const le=S[x+0];F+=W[le>>>2],F+=W[le<<4&63],D&&(F+="==")}else if(H===2){const le=S[x+0],re=S[x+1];F+=W[le>>>2],F+=W[(le<<4|re>>>4)&63],F+=W[re<<2&63],D&&(F+="=")}return F}}),define(ae[25],ce([0,1,143,61]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.GraphemeBreakType=e.$Gf=e.$Af=e.$tf=e.$sf=void 0,e.$Te=P,e.$Ue=A,e.$Ve=h,e.$We=c,e.$Xe=b,e.$Ye=y,e.$Ze=k,e.$1e=d,e.$2e=m,e.$3e=v,e.$4e=w,e.$5e=$,e.$6e=f,e.$7e=u,e.$8e=g,e.$9e=a,e.$0e=t,e.$$e=o,e.$_e=r,e.$af=i,e.$bf=s,e.$cf=l,e.$df=p,e.$ef=I,e.$ff=j,e.$gf=S,e.$hf=D,e.$if=M,e.$jf=W,e.$kf=F,e.$lf=H,e.$mf=x,e.$nf=le,e.$of=re,e.$pf=ue,e.$qf=Q,e.$rf=Y,e.$uf=G,e.$vf=q,e.$wf=oe,e.$xf=he,e.$yf=T,e.$zf=z,e.$Bf=X,e.$Cf=V,e.$Df=_,e.$Ef=B,e.$Ff=de,e.$Hf=me,e.$If=ke,e.$Jf=Se,e.$Kf=Oe,e.$Lf=He,e.$Mf=ye,e.$Nf=ee,e.$Of=fe,e.$Pf=Me;function P(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const O=/{(\d+)}/g;function A(ne,...ge){return ge.length===0?ne:ne.replace(O,function(pe,be){const Ee=parseInt(be,10);return isNaN(Ee)||Ee<0||Ee>=ge.length?pe:ge[Ee]})}const E=/{([^}]+)}/g;function h(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(E,(pe,be)=>ge[be]??pe)}function c(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function b(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(ne,ge){let pe=0;const be=ge.charCodeAt(0);for(let Ee=ne.length-1;Ee>=0;Ee--)ne.charCodeAt(Ee)===be&&pe++;return pe}function d(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}function m(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const be=Math.ceil(ge/2)-pe.length/2,Ee=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,be)}${pe}${ne.substr(ne.length-Ee)}`}function v(ne,ge=" "){const pe=w(ne,ge);return $(pe,ge)}function w(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let be=0;for(;ne.indexOf(ge,be)===be;)be=be+pe;return ne.substring(be)}function $(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,be=ne.length;if(pe===0||be===0)return ne;let Ee=be,Ce=-1;for(;Ce=ne.lastIndexOf(ge,Ee-1),!(Ce===-1||Ce+pe!==Ee);){if(Ce===0)return"";Ee=Ce}return ne.substring(0,Ee)}function f(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(ne){return ne.replace(/\*/g,"")}function g(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=y(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(ne,be)}function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function t(ne){return ne.split(/\r\n|\r|\n/)}function o(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)ge.push(pe[2*be]+(pe[2*be+1]??""));return ge}function r(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const be=ne.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}function i(ne,ge=0,pe=ne.length){for(let be=ge;be<pe;be++){const Ee=ne.charCodeAt(be);if(Ee!==32&&Ee!==9)return ne.substring(ge,be)}return ne.substring(ge,pe)}function s(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const be=ne.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function l(ne,ge,pe){const be=[];let Ee=0;for(const Ce of ne.matchAll(ge)){if(be.push(ne.slice(Ee,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Ee=Ce.index+Ce[0].length,be.push(pe(Ce[0],...Ce.slice(1),Ce.index,ne,Ce.groups))}return be.push(ne.slice(Ee)),Promise.all(be).then(Ce=>Ce.join(""))}function p(ne,ge){return ne<ge?-1:ne>ge?1:0}function I(ne,ge,pe=0,be=ne.length,Ee=0,Ce=ge.length){for(;pe<be&&Ee<Ce;pe++,Ee++){const Ze=ne.charCodeAt(pe),Xe=ge.charCodeAt(Ee);if(Ze<Xe)return-1;if(Ze>Xe)return 1}const Ne=be-pe,Ke=Ce-Ee;return Ne<Ke?-1:Ne>Ke?1:0}function j(ne,ge){return S(ne,ge,0,ne.length,0,ge.length)}function S(ne,ge,pe=0,be=ne.length,Ee=0,Ce=ge.length){for(;pe<be&&Ee<Ce;pe++,Ee++){let Ze=ne.charCodeAt(pe),Xe=ge.charCodeAt(Ee);if(Ze===Xe)continue;if(Ze>=128||Xe>=128)return I(ne.toLowerCase(),ge.toLowerCase(),pe,be,Ee,Ce);M(Ze)&&(Ze-=32),M(Xe)&&(Xe-=32);const Qe=Ze-Xe;if(Qe!==0)return Qe}const Ne=be-pe,Ke=Ce-Ee;return Ne<Ke?-1:Ne>Ke?1:0}function D(ne){return ne>=48&&ne<=57}function M(ne){return ne>=97&&ne<=122}function W(ne){return ne>=65&&ne<=90}function F(ne,ge){return ne.length===ge.length&&S(ne,ge)===0}function H(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:S(ne,ge,0,pe)===0}function x(ne,ge){const pe=Math.min(ne.length,ge.length);let be;for(be=0;be<pe;be++)if(ne.charCodeAt(be)!==ge.charCodeAt(be))return be;return pe}function le(ne,ge){const pe=Math.min(ne.length,ge.length);let be;const Ee=ne.length-1,Ce=ge.length-1;for(be=0;be<pe;be++)if(ne.charCodeAt(Ee-be)!==ge.charCodeAt(Ce-be))return be;return pe}function re(ne){return 55296<=ne&&ne<=56319}function ue(ne){return 56320<=ne&&ne<=57343}function Q(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function Y(ne,ge,pe){const be=ne.charCodeAt(pe);if(re(be)&&pe+1<ge){const Ee=ne.charCodeAt(pe+1);if(ue(Ee))return Q(be,Ee)}return be}function U(ne,ge){const pe=ne.charCodeAt(ge-1);if(ue(pe)&&ge>1){const be=ne.charCodeAt(ge-2);if(re(be))return Q(be,pe)}return pe}class L{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=U(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Y(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$sf=L;class N{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new L(ge,pe)}nextGraphemeLength(){const ge=Re.getInstance(),pe=this.c,be=pe.offset;let Ee=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ce=pe.offset,Ne=ge.getGraphemeBreakType(pe.nextCodePoint());if($e(Ee,Ne)){pe.setOffset(Ce);break}Ee=Ne}return pe.offset-be}prevGraphemeLength(){const ge=Re.getInstance(),pe=this.c,be=pe.offset;let Ee=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ce=pe.offset,Ne=ge.getGraphemeBreakType(pe.prevCodePoint());if($e(Ne,Ee)){pe.setOffset(Ce);break}Ee=Ne}return be-pe.offset}eol(){return this.c.eol()}}e.$tf=N;function G(ne,ge){return new N(ne,ge).nextGraphemeLength()}function q(ne,ge){return new N(ne,ge).prevGraphemeLength()}function oe(ne,ge){ge>0&&ue(ne.charCodeAt(ge))&&ge--;const pe=ge+G(ne,ge);return[pe-q(ne,pe),pe]}function he(ne){const ge=new N(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let K;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(ne){return K||(K=C()),K.test(ne)}const Z=/^[\t\n\r\x20-\x7E]*$/;function z(ne){return Z.test(ne)}e.$Af=/[\u2028\u2029]/;function X(ne){return e.$Af.test(ne)}function V(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function _(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function B(ne,ge,pe=""){const be=ne.trimStart();if(be.length<ge)return be;const Ee=/\b/g;let Ce=0;for(;Ee.test(be)&&!(be.length-Ee.lastIndex<ge);)Ce=Ee.lastIndex,Ee.lastIndex+=1;return Ce===0?be:pe+be.substring(Ce).trimStart()}const te=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function de(ne){return ne&&(ne=ne.replace(te,"").replace(ie,"")),ne}e.$Gf="\uFEFF";function me(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}function ke(ne){return me(ne)?ne.substr(1):ne}function Se(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,be=ne.toLowerCase();let Ee=0,Ce=-1;for(;Ee<pe;){const Ne=be.indexOf(ge[Ee],Ce+1);if(Ne<0)return!1;Ce=Ne,Ee++}return!0}function Oe(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function He(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function ye(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}function ee(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}function fe(ne){return Re.getInstance().getGraphemeBreakType(ne)}function $e(ne,ge){return ne===0?ge!==5&&ge!==7:ne===2&&ge===3?!1:ne===4||ne===2||ne===3||ge===4||ge===2||ge===3?!0:!(ne===8&&(ge===8||ge===9||ge===11||ge===12)||(ne===11||ne===9)&&(ge===9||ge===10)||(ne===12||ne===10)&&ge===10||ge===5||ge===13||ge===7||ne===1||ne===13&&ge===14||ne===6&&ge===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=qe()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const pe=this.d,be=pe.length/3;let Ee=1;for(;Ee<=be;)if(ge<pe[3*Ee])Ee=2*Ee;else if(ge>pe[3*Ee+1])Ee=2*Ee+1;else return pe[3*Ee+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(ne,ge){if(ne===0)return 0;const pe=We(ne,ge);if(pe!==void 0)return pe;const be=new L(ge,ne);return be.prevCodePoint(),be.offset}function We(ne,ge){const pe=new L(ge,ne);let be=pe.prevCodePoint();for(;Ue(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let Ee=pe.offset;return Ee>0&&pe.prevCodePoint()===8205&&(Ee=pe.offset),Ee}function Ue(ne){return 127995<=ne&&ne<=127999}var xe;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.$Qf="\xA0";class Je{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Pe(ge=>{function pe(Qe){const st=new Map;for(let tt=0;tt<Qe.length;tt+=2)st.set(Qe[tt],Qe[tt+1]);return st}function be(Qe,st){const tt=new Map(Qe);for(const[ot,at]of st)tt.set(ot,at);return tt}function Ee(Qe,st){if(!Qe)return st;const tt=new Map;for(const[ot,at]of Qe)st.has(ot)&&tt.set(ot,at);return tt}const Ce=this.c.value;let Ne=ge.filter(Qe=>!Qe.startsWith("_")&&Qe in Ce);Ne.length===0&&(Ne=["_default"]);let Ke;for(const Qe of Ne){const st=pe(Ce[Qe]);Ke=Ee(Ke,st)}const Ze=pe(Ce._common),Xe=be(Ze,Ke);return new Je(Xe)})}static getInstance(ge){return Je.d.get(Array.from(ge))}static{this.e=new R.$V(()=>Object.keys(Je.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Je.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=Je;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(ge){return Te.e().has(ge)}static get codePoints(){return Te.e()}}e.$Sf=Te}),define(ae[45],ce([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$$i=void 0,e.$7i=R,e.$8i=P,e.$9i=O,e.$0i=E,e.$_i=v;function R($){return P($,0)}function P($,f){switch(typeof $){case"object":return $===null?O(349,f):Array.isArray($)?h($,f):c($,f);case"string":return E($,f);case"boolean":return A($,f);case"number":return O($,f);case"undefined":return O(937,f);default:return O(617,f)}}function O($,f){return(f<<5)-f+$|0}function A($,f){return O($?433:863,f)}function E($,f){f=O(149417,f);for(let u=0,g=$.length;u<g;u++)f=O($.charCodeAt(u),f);return f}function h($,f){return f=O(104579,f),$.reduce((u,g)=>P(g,u),f)}function c($,f){return f=O(181387,f),Object.keys($).sort().reduce((u,g)=>(u=E(g,u),P($[g],u)),f)}class b{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=P(f,this.g),this.g}}e.$$i=b;var y;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function k($,f,u=32){const g=u-f,a=~((1<<g)-1);return($<<f|(a&$)>>>g)>>>0}function d($,f=0,u=$.byteLength,g=0){for(let a=0;a<u;a++)$[f+a]=g}function m($,f,u="0"){for(;$.length<f;)$=u+$;return $}function v($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(u=>u.toString(16).padStart(2,"0")).join(""):m(($>>>0).toString(16),f/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const u=f.length;if(u===0)return;const g=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(n.$of(o))if(r+1<u){const s=f.charCodeAt(r+1);n.$pf(s)?(r++,i=n.$qf(o,s)):i=65533}else{t=o;break}else n.$pf(o)&&(i=65533);if(a=this.w(g,a,i),r++,r<u)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,u,g){return g<128?f[u++]=g:g<2048?(f[u++]=192|(g&1984)>>>6,f[u++]=128|(g&63)>>>0):g<65536?(f[u++]=224|(g&61440)>>>12,f[u++]=128|(g&4032)>>>6,f[u++]=128|(g&63)>>>0):(f[u++]=240|(g&1835008)>>>18,f[u++]=128|(g&258048)>>>12,f[u++]=128|(g&4032)>>>6,f[u++]=128|(g&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,u=this.q;for(let p=0;p<64;p+=4)f.setUint32(p,u.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)f.setUint32(p,k(f.getUint32(p-12,!1)^f.getUint32(p-32,!1)^f.getUint32(p-56,!1)^f.getUint32(p-64,!1),1),!1);let g=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,s,l;for(let p=0;p<80;p++)p<20?(i=a&t|~a&o,s=1518500249):p<40?(i=a^t^o,s=1859775393):p<60?(i=a&t|a&o|t&o,s=2400959708):(i=a^t^o,s=3395469782),l=k(g,5)+i+r+s+f.getUint32(p*4,!1)&4294967295,r=o,o=t,t=k(a,30),a=g,g=l;this.h=this.h+g&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$aj=w}),define(ae[73],ce([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",A="warning",E="warn",h="info",c="ignore";function b(k){return k?n.$kf(O,k)?P.Error:n.$kf(A,k)||n.$kf(E,k)?P.Warning:n.$kf(h,k)?P.Info:P.Ignore:P.Ignore}P.fromValue=b;function y(k){switch(k){case P.Error:return O;case P.Warning:return A;case P.Info:return h;default:return c}}P.toString=y}(R||(R={})),e.default=R}),define(ae[144],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class P{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const m=d.charCodeAt(0),v=this.b.charCodeAt(this.c);return m-v}value(){return this.b[this.c]}}e.$ii=P;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,R.$ef)(d,this.b,0,d.length,this.c,this.d):(0,R.$gf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=O;class A{constructor(d=!0,m=!0){this.f=d,this.g=m}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let m=d.length-1;m>=0;m--,this.c--){const v=this.b.charCodeAt(m);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,R.$ef)(d,this.b,0,d.length,this.d,this.e):(0,R.$gf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=A;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(d,m){this.f=d,this.g=m,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,R.$ff)(d,this.c.scheme);if(this.d[this.e]===2)return(0,R.$ff)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,R.$df)(d,this.c.query);if(this.d[this.e]===5)return(0,R.$df)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(b||(b={}));class y{static forUris(d=()=>!1,m=()=>!1){return new y(new h(d,m))}static forPaths(d=!1){return new y(new A(void 0,!d))}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,m){if(m){const v=m.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w,d)}else{const v=d.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w[0],w[1])}}set(d,m){const v=this.b.reset(d);let w;this.c||(this.c=new c,this.c.segment=v.value());const $=[];for(w=this.c;;){const u=v.cmp(w.segment);if(u>0)w.left||(w.left=new c,w.left.segment=v.value()),$.push([-1,w]),w=w.left;else if(u<0)w.right||(w.right=new c,w.right.segment=v.value()),$.push([1,w]),w=w.right;else if(v.hasNext())v.next(),w.mid||(w.mid=new c,w.mid.segment=v.value()),$.push([0,w]),w=w.mid;else break}const f=w.value;w.value=m,w.key=d;for(let u=$.length-1;u>=0;u--){const g=$[u][1];g.updateHeight();const a=g.balanceFactor();if(a<-1||a>1){const t=$[u][0],o=$[u+1][0];if(t===1&&o===1)$[u][1]=g.rotateLeft();else if(t===-1&&o===-1)$[u][1]=g.rotateRight();else if(t===1&&o===-1)g.right=$[u+1][1]=$[u+1][1].rotateRight(),$[u][1]=g.rotateLeft();else if(t===-1&&o===1)g.left=$[u+1][1]=$[u+1][1].rotateLeft(),$[u][1]=g.rotateRight();else throw new Error;if(u>0)switch($[u-1][0]){case-1:$[u-1][1].left=$[u][1];break;case 1:$[u-1][1].right=$[u][1];break;case 0:$[u-1][1].mid=$[u][1];break}else this.c=$[0][1]}}return f}get(d){return this.d(d)?.value}d(d){const m=this.b.reset(d);let v=this.c;for(;v;){const w=m.cmp(v.segment);if(w>0)v=v.left;else if(w<0)v=v.right;else if(m.hasNext())m.next(),v=v.mid;else break}return v}has(d){const m=this.d(d);return!(m?.value===void 0&&m?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,m){const v=this.b.reset(d),w=[];let $=this.c;for(;$;){const f=v.cmp($.segment);if(f>0)w.push([-1,$]),$=$.left;else if(f<0)w.push([1,$]),$=$.right;else if(v.hasNext())v.next(),w.push([0,$]),$=$.mid;else break}if($){if(m?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const f=this.f($.right);if(f.key){const{key:u,value:g,segment:a}=f;this.e(f.key,!1),$.key=u,$.value=g,$.segment=a}}else{const f=$.left??$.right;if(w.length>0){const[u,g]=w[w.length-1];switch(u){case-1:g.left=f;break;case 0:g.mid=f;break;case 1:g.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const u=w[f][1];u.updateHeight();const g=u.balanceFactor();if(g>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),w[f][1]=u.rotateLeft()):g<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),w[f][1]=u.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const m=this.b.reset(d);let v=this.c,w;for(;v;){const $=m.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(m.hasNext())m.next(),w=v.value||w,v=v.mid;else break}return v&&v.value||w}findSuperstr(d){return this.g(d,!1)}g(d,m){const v=this.b.reset(d);let w=this.c;for(;w;){const $=v.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(v.hasNext())v.next(),w=w.mid;else return w.mid?this.h(w.mid):m?w.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[m,v]of this)d(v,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const m=[];return this.j(d,m),m[Symbol.iterator]()}j(d,m){d&&(d.left&&this.j(d.left,m),d.value&&m.push([d.key,d.value]),d.mid&&this.j(d.mid,m),d.right&&this.j(d.right,m))}_isBalanced(){const d=m=>{if(!m)return!0;const v=m.balanceFactor();return v<-1||v>1?!1:d(m.left)&&d(m.right)};return d(this.c)}}e.$mi=y}),define(ae[12],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=n,e.$Uf=R,e.$Vf=P,e.$Wf=O,e.$Xf=A,e.$Yf=E,e.$Zf=h,e.$1f=c,e.$2f=b,e.$3f=y,e.$4f=k,e.$5f=d,e.$6f=m,e.$7f=w,e.$8f=$,e.$9f=f,e.$0f=u,e.$$f=g;function n(a){return typeof a=="string"}function R(a){return Array.isArray(a)&&a.every(t=>n(t))}function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function O(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function A(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function b(a){return!y(a)}function y(a){return c(a)||a===null}function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function d(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(y(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const v=Object.prototype.hasOwnProperty;function w(a){if(!P(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function $(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every($)}function u(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)g(a[r],t[r])}function g(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[105],ce([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=P,e.$Bj=O;const R=Object.create(null);function P(A,E){if((0,n.$Tf)(E)){const h=R[E];if(h===void 0)throw new Error(`${A} references an unknown codicon: ${E}`);E=h}return R[A]=E,{id:A}}function O(){return R}}),define(ae[145],ce([0,1,105]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=void 0,e.$Cj={add:(0,n.$Aj)("add",6e4),plus:(0,n.$Aj)("plus",6e4),gistNew:(0,n.$Aj)("gist-new",6e4),repoCreate:(0,n.$Aj)("repo-create",6e4),lightbulb:(0,n.$Aj)("lightbulb",60001),lightBulb:(0,n.$Aj)("light-bulb",60001),repo:(0,n.$Aj)("repo",60002),repoDelete:(0,n.$Aj)("repo-delete",60002),gistFork:(0,n.$Aj)("gist-fork",60003),repoForked:(0,n.$Aj)("repo-forked",60003),gitPullRequest:(0,n.$Aj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Aj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Aj)("record-keys",60005),keyboard:(0,n.$Aj)("keyboard",60005),tag:(0,n.$Aj)("tag",60006),gitPullRequestLabel:(0,n.$Aj)("git-pull-request-label",60006),tagAdd:(0,n.$Aj)("tag-add",60006),tagRemove:(0,n.$Aj)("tag-remove",60006),person:(0,n.$Aj)("person",60007),personFollow:(0,n.$Aj)("person-follow",60007),personOutline:(0,n.$Aj)("person-outline",60007),personFilled:(0,n.$Aj)("person-filled",60007),gitBranch:(0,n.$Aj)("git-branch",60008),gitBranchCreate:(0,n.$Aj)("git-branch-create",60008),gitBranchDelete:(0,n.$Aj)("git-branch-delete",60008),sourceControl:(0,n.$Aj)("source-control",60008),mirror:(0,n.$Aj)("mirror",60009),mirrorPublic:(0,n.$Aj)("mirror-public",60009),star:(0,n.$Aj)("star",60010),starAdd:(0,n.$Aj)("star-add",60010),starDelete:(0,n.$Aj)("star-delete",60010),starEmpty:(0,n.$Aj)("star-empty",60010),comment:(0,n.$Aj)("comment",60011),commentAdd:(0,n.$Aj)("comment-add",60011),alert:(0,n.$Aj)("alert",60012),warning:(0,n.$Aj)("warning",60012),search:(0,n.$Aj)("search",60013),searchSave:(0,n.$Aj)("search-save",60013),logOut:(0,n.$Aj)("log-out",60014),signOut:(0,n.$Aj)("sign-out",60014),logIn:(0,n.$Aj)("log-in",60015),signIn:(0,n.$Aj)("sign-in",60015),eye:(0,n.$Aj)("eye",60016),eyeUnwatch:(0,n.$Aj)("eye-unwatch",60016),eyeWatch:(0,n.$Aj)("eye-watch",60016),circleFilled:(0,n.$Aj)("circle-filled",60017),primitiveDot:(0,n.$Aj)("primitive-dot",60017),closeDirty:(0,n.$Aj)("close-dirty",60017),debugBreakpoint:(0,n.$Aj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Aj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Aj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Aj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Aj)("primitive-square",60018),edit:(0,n.$Aj)("edit",60019),pencil:(0,n.$Aj)("pencil",60019),info:(0,n.$Aj)("info",60020),issueOpened:(0,n.$Aj)("issue-opened",60020),gistPrivate:(0,n.$Aj)("gist-private",60021),gitForkPrivate:(0,n.$Aj)("git-fork-private",60021),lock:(0,n.$Aj)("lock",60021),mirrorPrivate:(0,n.$Aj)("mirror-private",60021),close:(0,n.$Aj)("close",60022),removeClose:(0,n.$Aj)("remove-close",60022),x:(0,n.$Aj)("x",60022),repoSync:(0,n.$Aj)("repo-sync",60023),sync:(0,n.$Aj)("sync",60023),clone:(0,n.$Aj)("clone",60024),desktopDownload:(0,n.$Aj)("desktop-download",60024),beaker:(0,n.$Aj)("beaker",60025),microscope:(0,n.$Aj)("microscope",60025),vm:(0,n.$Aj)("vm",60026),deviceDesktop:(0,n.$Aj)("device-desktop",60026),file:(0,n.$Aj)("file",60027),fileText:(0,n.$Aj)("file-text",60027),more:(0,n.$Aj)("more",60028),ellipsis:(0,n.$Aj)("ellipsis",60028),kebabHorizontal:(0,n.$Aj)("kebab-horizontal",60028),mailReply:(0,n.$Aj)("mail-reply",60029),reply:(0,n.$Aj)("reply",60029),organization:(0,n.$Aj)("organization",60030),organizationFilled:(0,n.$Aj)("organization-filled",60030),organizationOutline:(0,n.$Aj)("organization-outline",60030),newFile:(0,n.$Aj)("new-file",60031),fileAdd:(0,n.$Aj)("file-add",60031),newFolder:(0,n.$Aj)("new-folder",60032),fileDirectoryCreate:(0,n.$Aj)("file-directory-create",60032),trash:(0,n.$Aj)("trash",60033),trashcan:(0,n.$Aj)("trashcan",60033),history:(0,n.$Aj)("history",60034),clock:(0,n.$Aj)("clock",60034),folder:(0,n.$Aj)("folder",60035),fileDirectory:(0,n.$Aj)("file-directory",60035),symbolFolder:(0,n.$Aj)("symbol-folder",60035),logoGithub:(0,n.$Aj)("logo-github",60036),markGithub:(0,n.$Aj)("mark-github",60036),github:(0,n.$Aj)("github",60036),terminal:(0,n.$Aj)("terminal",60037),console:(0,n.$Aj)("console",60037),repl:(0,n.$Aj)("repl",60037),zap:(0,n.$Aj)("zap",60038),symbolEvent:(0,n.$Aj)("symbol-event",60038),error:(0,n.$Aj)("error",60039),stop:(0,n.$Aj)("stop",60039),variable:(0,n.$Aj)("variable",60040),symbolVariable:(0,n.$Aj)("symbol-variable",60040),array:(0,n.$Aj)("array",60042),symbolArray:(0,n.$Aj)("symbol-array",60042),symbolModule:(0,n.$Aj)("symbol-module",60043),symbolPackage:(0,n.$Aj)("symbol-package",60043),symbolNamespace:(0,n.$Aj)("symbol-namespace",60043),symbolObject:(0,n.$Aj)("symbol-object",60043),symbolMethod:(0,n.$Aj)("symbol-method",60044),symbolFunction:(0,n.$Aj)("symbol-function",60044),symbolConstructor:(0,n.$Aj)("symbol-constructor",60044),symbolBoolean:(0,n.$Aj)("symbol-boolean",60047),symbolNull:(0,n.$Aj)("symbol-null",60047),symbolNumeric:(0,n.$Aj)("symbol-numeric",60048),symbolNumber:(0,n.$Aj)("symbol-number",60048),symbolStructure:(0,n.$Aj)("symbol-structure",60049),symbolStruct:(0,n.$Aj)("symbol-struct",60049),symbolParameter:(0,n.$Aj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Aj)("symbol-type-parameter",60050),symbolKey:(0,n.$Aj)("symbol-key",60051),symbolText:(0,n.$Aj)("symbol-text",60051),symbolReference:(0,n.$Aj)("symbol-reference",60052),goToFile:(0,n.$Aj)("go-to-file",60052),symbolEnum:(0,n.$Aj)("symbol-enum",60053),symbolValue:(0,n.$Aj)("symbol-value",60053),symbolRuler:(0,n.$Aj)("symbol-ruler",60054),symbolUnit:(0,n.$Aj)("symbol-unit",60054),activateBreakpoints:(0,n.$Aj)("activate-breakpoints",60055),archive:(0,n.$Aj)("archive",60056),arrowBoth:(0,n.$Aj)("arrow-both",60057),arrowDown:(0,n.$Aj)("arrow-down",60058),arrowLeft:(0,n.$Aj)("arrow-left",60059),arrowRight:(0,n.$Aj)("arrow-right",60060),arrowSmallDown:(0,n.$Aj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Aj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Aj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Aj)("arrow-small-up",60064),arrowUp:(0,n.$Aj)("arrow-up",60065),bell:(0,n.$Aj)("bell",60066),bold:(0,n.$Aj)("bold",60067),book:(0,n.$Aj)("book",60068),bookmark:(0,n.$Aj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Aj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Aj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Aj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Aj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Aj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Aj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Aj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Aj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Aj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Aj)("briefcase",60076),broadcast:(0,n.$Aj)("broadcast",60077),browser:(0,n.$Aj)("browser",60078),bug:(0,n.$Aj)("bug",60079),calendar:(0,n.$Aj)("calendar",60080),caseSensitive:(0,n.$Aj)("case-sensitive",60081),check:(0,n.$Aj)("check",60082),checklist:(0,n.$Aj)("checklist",60083),chevronDown:(0,n.$Aj)("chevron-down",60084),chevronLeft:(0,n.$Aj)("chevron-left",60085),chevronRight:(0,n.$Aj)("chevron-right",60086),chevronUp:(0,n.$Aj)("chevron-up",60087),chromeClose:(0,n.$Aj)("chrome-close",60088),chromeMaximize:(0,n.$Aj)("chrome-maximize",60089),chromeMinimize:(0,n.$Aj)("chrome-minimize",60090),chromeRestore:(0,n.$Aj)("chrome-restore",60091),circleOutline:(0,n.$Aj)("circle-outline",60092),circle:(0,n.$Aj)("circle",60092),debugBreakpointUnverified:(0,n.$Aj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Aj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Aj)("circle-slash",60093),circuitBoard:(0,n.$Aj)("circuit-board",60094),clearAll:(0,n.$Aj)("clear-all",60095),clippy:(0,n.$Aj)("clippy",60096),closeAll:(0,n.$Aj)("close-all",60097),cloudDownload:(0,n.$Aj)("cloud-download",60098),cloudUpload:(0,n.$Aj)("cloud-upload",60099),code:(0,n.$Aj)("code",60100),collapseAll:(0,n.$Aj)("collapse-all",60101),colorMode:(0,n.$Aj)("color-mode",60102),commentDiscussion:(0,n.$Aj)("comment-discussion",60103),creditCard:(0,n.$Aj)("credit-card",60105),dash:(0,n.$Aj)("dash",60108),dashboard:(0,n.$Aj)("dashboard",60109),database:(0,n.$Aj)("database",60110),debugContinue:(0,n.$Aj)("debug-continue",60111),debugDisconnect:(0,n.$Aj)("debug-disconnect",60112),debugPause:(0,n.$Aj)("debug-pause",60113),debugRestart:(0,n.$Aj)("debug-restart",60114),debugStart:(0,n.$Aj)("debug-start",60115),debugStepInto:(0,n.$Aj)("debug-step-into",60116),debugStepOut:(0,n.$Aj)("debug-step-out",60117),debugStepOver:(0,n.$Aj)("debug-step-over",60118),debugStop:(0,n.$Aj)("debug-stop",60119),debug:(0,n.$Aj)("debug",60120),deviceCameraVideo:(0,n.$Aj)("device-camera-video",60121),deviceCamera:(0,n.$Aj)("device-camera",60122),deviceMobile:(0,n.$Aj)("device-mobile",60123),diffAdded:(0,n.$Aj)("diff-added",60124),diffIgnored:(0,n.$Aj)("diff-ignored",60125),diffModified:(0,n.$Aj)("diff-modified",60126),diffRemoved:(0,n.$Aj)("diff-removed",60127),diffRenamed:(0,n.$Aj)("diff-renamed",60128),diff:(0,n.$Aj)("diff",60129),diffSidebyside:(0,n.$Aj)("diff-sidebyside",60129),discard:(0,n.$Aj)("discard",60130),editorLayout:(0,n.$Aj)("editor-layout",60131),emptyWindow:(0,n.$Aj)("empty-window",60132),exclude:(0,n.$Aj)("exclude",60133),extensions:(0,n.$Aj)("extensions",60134),eyeClosed:(0,n.$Aj)("eye-closed",60135),fileBinary:(0,n.$Aj)("file-binary",60136),fileCode:(0,n.$Aj)("file-code",60137),fileMedia:(0,n.$Aj)("file-media",60138),filePdf:(0,n.$Aj)("file-pdf",60139),fileSubmodule:(0,n.$Aj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Aj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Aj)("file-symlink-file",60142),fileZip:(0,n.$Aj)("file-zip",60143),files:(0,n.$Aj)("files",60144),filter:(0,n.$Aj)("filter",60145),flame:(0,n.$Aj)("flame",60146),foldDown:(0,n.$Aj)("fold-down",60147),foldUp:(0,n.$Aj)("fold-up",60148),fold:(0,n.$Aj)("fold",60149),folderActive:(0,n.$Aj)("folder-active",60150),folderOpened:(0,n.$Aj)("folder-opened",60151),gear:(0,n.$Aj)("gear",60152),gift:(0,n.$Aj)("gift",60153),gistSecret:(0,n.$Aj)("gist-secret",60154),gist:(0,n.$Aj)("gist",60155),gitCommit:(0,n.$Aj)("git-commit",60156),gitCompare:(0,n.$Aj)("git-compare",60157),compareChanges:(0,n.$Aj)("compare-changes",60157),gitMerge:(0,n.$Aj)("git-merge",60158),githubAction:(0,n.$Aj)("github-action",60159),githubAlt:(0,n.$Aj)("github-alt",60160),globe:(0,n.$Aj)("globe",60161),grabber:(0,n.$Aj)("grabber",60162),graph:(0,n.$Aj)("graph",60163),gripper:(0,n.$Aj)("gripper",60164),heart:(0,n.$Aj)("heart",60165),home:(0,n.$Aj)("home",60166),horizontalRule:(0,n.$Aj)("horizontal-rule",60167),hubot:(0,n.$Aj)("hubot",60168),inbox:(0,n.$Aj)("inbox",60169),issueReopened:(0,n.$Aj)("issue-reopened",60171),issues:(0,n.$Aj)("issues",60172),italic:(0,n.$Aj)("italic",60173),jersey:(0,n.$Aj)("jersey",60174),json:(0,n.$Aj)("json",60175),kebabVertical:(0,n.$Aj)("kebab-vertical",60176),key:(0,n.$Aj)("key",60177),law:(0,n.$Aj)("law",60178),lightbulbAutofix:(0,n.$Aj)("lightbulb-autofix",60179),linkExternal:(0,n.$Aj)("link-external",60180),link:(0,n.$Aj)("link",60181),listOrdered:(0,n.$Aj)("list-ordered",60182),listUnordered:(0,n.$Aj)("list-unordered",60183),liveShare:(0,n.$Aj)("live-share",60184),loading:(0,n.$Aj)("loading",60185),location:(0,n.$Aj)("location",60186),mailRead:(0,n.$Aj)("mail-read",60187),mail:(0,n.$Aj)("mail",60188),markdown:(0,n.$Aj)("markdown",60189),megaphone:(0,n.$Aj)("megaphone",60190),mention:(0,n.$Aj)("mention",60191),milestone:(0,n.$Aj)("milestone",60192),gitPullRequestMilestone:(0,n.$Aj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Aj)("mortar-board",60193),move:(0,n.$Aj)("move",60194),multipleWindows:(0,n.$Aj)("multiple-windows",60195),mute:(0,n.$Aj)("mute",60196),noNewline:(0,n.$Aj)("no-newline",60197),note:(0,n.$Aj)("note",60198),octoface:(0,n.$Aj)("octoface",60199),openPreview:(0,n.$Aj)("open-preview",60200),package:(0,n.$Aj)("package",60201),paintcan:(0,n.$Aj)("paintcan",60202),pin:(0,n.$Aj)("pin",60203),play:(0,n.$Aj)("play",60204),run:(0,n.$Aj)("run",60204),plug:(0,n.$Aj)("plug",60205),preserveCase:(0,n.$Aj)("preserve-case",60206),preview:(0,n.$Aj)("preview",60207),project:(0,n.$Aj)("project",60208),pulse:(0,n.$Aj)("pulse",60209),question:(0,n.$Aj)("question",60210),quote:(0,n.$Aj)("quote",60211),radioTower:(0,n.$Aj)("radio-tower",60212),reactions:(0,n.$Aj)("reactions",60213),references:(0,n.$Aj)("references",60214),refresh:(0,n.$Aj)("refresh",60215),regex:(0,n.$Aj)("regex",60216),remoteExplorer:(0,n.$Aj)("remote-explorer",60217),remote:(0,n.$Aj)("remote",60218),remove:(0,n.$Aj)("remove",60219),replaceAll:(0,n.$Aj)("replace-all",60220),replace:(0,n.$Aj)("replace",60221),repoClone:(0,n.$Aj)("repo-clone",60222),repoForcePush:(0,n.$Aj)("repo-force-push",60223),repoPull:(0,n.$Aj)("repo-pull",60224),repoPush:(0,n.$Aj)("repo-push",60225),report:(0,n.$Aj)("report",60226),requestChanges:(0,n.$Aj)("request-changes",60227),rocket:(0,n.$Aj)("rocket",60228),rootFolderOpened:(0,n.$Aj)("root-folder-opened",60229),rootFolder:(0,n.$Aj)("root-folder",60230),rss:(0,n.$Aj)("rss",60231),ruby:(0,n.$Aj)("ruby",60232),saveAll:(0,n.$Aj)("save-all",60233),saveAs:(0,n.$Aj)("save-as",60234),save:(0,n.$Aj)("save",60235),screenFull:(0,n.$Aj)("screen-full",60236),screenNormal:(0,n.$Aj)("screen-normal",60237),searchStop:(0,n.$Aj)("search-stop",60238),server:(0,n.$Aj)("server",60240),settingsGear:(0,n.$Aj)("settings-gear",60241),settings:(0,n.$Aj)("settings",60242),shield:(0,n.$Aj)("shield",60243),smiley:(0,n.$Aj)("smiley",60244),sortPrecedence:(0,n.$Aj)("sort-precedence",60245),splitHorizontal:(0,n.$Aj)("split-horizontal",60246),splitVertical:(0,n.$Aj)("split-vertical",60247),squirrel:(0,n.$Aj)("squirrel",60248),starFull:(0,n.$Aj)("star-full",60249),starHalf:(0,n.$Aj)("star-half",60250),symbolClass:(0,n.$Aj)("symbol-class",60251),symbolColor:(0,n.$Aj)("symbol-color",60252),symbolConstant:(0,n.$Aj)("symbol-constant",60253),symbolEnumMember:(0,n.$Aj)("symbol-enum-member",60254),symbolField:(0,n.$Aj)("symbol-field",60255),symbolFile:(0,n.$Aj)("symbol-file",60256),symbolInterface:(0,n.$Aj)("symbol-interface",60257),symbolKeyword:(0,n.$Aj)("symbol-keyword",60258),symbolMisc:(0,n.$Aj)("symbol-misc",60259),symbolOperator:(0,n.$Aj)("symbol-operator",60260),symbolProperty:(0,n.$Aj)("symbol-property",60261),wrench:(0,n.$Aj)("wrench",60261),wrenchSubaction:(0,n.$Aj)("wrench-subaction",60261),symbolSnippet:(0,n.$Aj)("symbol-snippet",60262),tasklist:(0,n.$Aj)("tasklist",60263),telescope:(0,n.$Aj)("telescope",60264),textSize:(0,n.$Aj)("text-size",60265),threeBars:(0,n.$Aj)("three-bars",60266),thumbsdown:(0,n.$Aj)("thumbsdown",60267),thumbsup:(0,n.$Aj)("thumbsup",60268),tools:(0,n.$Aj)("tools",60269),triangleDown:(0,n.$Aj)("triangle-down",60270),triangleLeft:(0,n.$Aj)("triangle-left",60271),triangleRight:(0,n.$Aj)("triangle-right",60272),triangleUp:(0,n.$Aj)("triangle-up",60273),twitter:(0,n.$Aj)("twitter",60274),unfold:(0,n.$Aj)("unfold",60275),unlock:(0,n.$Aj)("unlock",60276),unmute:(0,n.$Aj)("unmute",60277),unverified:(0,n.$Aj)("unverified",60278),verified:(0,n.$Aj)("verified",60279),versions:(0,n.$Aj)("versions",60280),vmActive:(0,n.$Aj)("vm-active",60281),vmOutline:(0,n.$Aj)("vm-outline",60282),vmRunning:(0,n.$Aj)("vm-running",60283),watch:(0,n.$Aj)("watch",60284),whitespace:(0,n.$Aj)("whitespace",60285),wholeWord:(0,n.$Aj)("whole-word",60286),window:(0,n.$Aj)("window",60287),wordWrap:(0,n.$Aj)("word-wrap",60288),zoomIn:(0,n.$Aj)("zoom-in",60289),zoomOut:(0,n.$Aj)("zoom-out",60290),listFilter:(0,n.$Aj)("list-filter",60291),listFlat:(0,n.$Aj)("list-flat",60292),listSelection:(0,n.$Aj)("list-selection",60293),selection:(0,n.$Aj)("selection",60293),listTree:(0,n.$Aj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Aj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Aj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Aj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Aj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Aj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Aj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Aj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Aj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Aj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Aj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Aj)("symbol-string",60301),debugReverseContinue:(0,n.$Aj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Aj)("debug-step-back",60303),debugRestartFrame:(0,n.$Aj)("debug-restart-frame",60304),debugAlt:(0,n.$Aj)("debug-alt",60305),callIncoming:(0,n.$Aj)("call-incoming",60306),callOutgoing:(0,n.$Aj)("call-outgoing",60307),menu:(0,n.$Aj)("menu",60308),expandAll:(0,n.$Aj)("expand-all",60309),feedback:(0,n.$Aj)("feedback",60310),gitPullRequestReviewer:(0,n.$Aj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Aj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Aj)("ungroup-by-ref-type",60312),account:(0,n.$Aj)("account",60313),gitPullRequestAssignee:(0,n.$Aj)("git-pull-request-assignee",60313),bellDot:(0,n.$Aj)("bell-dot",60314),debugConsole:(0,n.$Aj)("debug-console",60315),library:(0,n.$Aj)("library",60316),output:(0,n.$Aj)("output",60317),runAll:(0,n.$Aj)("run-all",60318),syncIgnored:(0,n.$Aj)("sync-ignored",60319),pinned:(0,n.$Aj)("pinned",60320),githubInverted:(0,n.$Aj)("github-inverted",60321),serverProcess:(0,n.$Aj)("server-process",60322),serverEnvironment:(0,n.$Aj)("server-environment",60323),pass:(0,n.$Aj)("pass",60324),issueClosed:(0,n.$Aj)("issue-closed",60324),stopCircle:(0,n.$Aj)("stop-circle",60325),playCircle:(0,n.$Aj)("play-circle",60326),record:(0,n.$Aj)("record",60327),debugAltSmall:(0,n.$Aj)("debug-alt-small",60328),vmConnect:(0,n.$Aj)("vm-connect",60329),cloud:(0,n.$Aj)("cloud",60330),merge:(0,n.$Aj)("merge",60331),export:(0,n.$Aj)("export",60332),graphLeft:(0,n.$Aj)("graph-left",60333),magnet:(0,n.$Aj)("magnet",60334),notebook:(0,n.$Aj)("notebook",60335),redo:(0,n.$Aj)("redo",60336),checkAll:(0,n.$Aj)("check-all",60337),pinnedDirty:(0,n.$Aj)("pinned-dirty",60338),passFilled:(0,n.$Aj)("pass-filled",60339),circleLargeFilled:(0,n.$Aj)("circle-large-filled",60340),circleLarge:(0,n.$Aj)("circle-large",60341),circleLargeOutline:(0,n.$Aj)("circle-large-outline",60341),combine:(0,n.$Aj)("combine",60342),gather:(0,n.$Aj)("gather",60342),table:(0,n.$Aj)("table",60343),variableGroup:(0,n.$Aj)("variable-group",60344),typeHierarchy:(0,n.$Aj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Aj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Aj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Aj)("git-pull-request-create",60348),runAbove:(0,n.$Aj)("run-above",60349),runBelow:(0,n.$Aj)("run-below",60350),notebookTemplate:(0,n.$Aj)("notebook-template",60351),debugRerun:(0,n.$Aj)("debug-rerun",60352),workspaceTrusted:(0,n.$Aj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Aj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Aj)("workspace-unknown",60355),terminalCmd:(0,n.$Aj)("terminal-cmd",60356),terminalDebian:(0,n.$Aj)("terminal-debian",60357),terminalLinux:(0,n.$Aj)("terminal-linux",60358),terminalPowershell:(0,n.$Aj)("terminal-powershell",60359),terminalTmux:(0,n.$Aj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Aj)("terminal-ubuntu",60361),terminalBash:(0,n.$Aj)("terminal-bash",60362),arrowSwap:(0,n.$Aj)("arrow-swap",60363),copy:(0,n.$Aj)("copy",60364),personAdd:(0,n.$Aj)("person-add",60365),filterFilled:(0,n.$Aj)("filter-filled",60366),wand:(0,n.$Aj)("wand",60367),debugLineByLine:(0,n.$Aj)("debug-line-by-line",60368),inspect:(0,n.$Aj)("inspect",60369),layers:(0,n.$Aj)("layers",60370),layersDot:(0,n.$Aj)("layers-dot",60371),layersActive:(0,n.$Aj)("layers-active",60372),compass:(0,n.$Aj)("compass",60373),compassDot:(0,n.$Aj)("compass-dot",60374),compassActive:(0,n.$Aj)("compass-active",60375),azure:(0,n.$Aj)("azure",60376),issueDraft:(0,n.$Aj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Aj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Aj)("git-pull-request-draft",60379),debugAll:(0,n.$Aj)("debug-all",60380),debugCoverage:(0,n.$Aj)("debug-coverage",60381),runErrors:(0,n.$Aj)("run-errors",60382),folderLibrary:(0,n.$Aj)("folder-library",60383),debugContinueSmall:(0,n.$Aj)("debug-continue-small",60384),beakerStop:(0,n.$Aj)("beaker-stop",60385),graphLine:(0,n.$Aj)("graph-line",60386),graphScatter:(0,n.$Aj)("graph-scatter",60387),pieChart:(0,n.$Aj)("pie-chart",60388),bracket:(0,n.$Aj)("bracket",60175),bracketDot:(0,n.$Aj)("bracket-dot",60389),bracketError:(0,n.$Aj)("bracket-error",60390),lockSmall:(0,n.$Aj)("lock-small",60391),azureDevops:(0,n.$Aj)("azure-devops",60392),verifiedFilled:(0,n.$Aj)("verified-filled",60393),newline:(0,n.$Aj)("newline",60394),layout:(0,n.$Aj)("layout",60395),layoutActivitybarLeft:(0,n.$Aj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Aj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Aj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Aj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Aj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Aj)("layout-panel-right",60401),layoutPanel:(0,n.$Aj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Aj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Aj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Aj)("layout-statusbar",60405),layoutMenubar:(0,n.$Aj)("layout-menubar",60406),layoutCentered:(0,n.$Aj)("layout-centered",60407),target:(0,n.$Aj)("target",60408),indent:(0,n.$Aj)("indent",60409),recordSmall:(0,n.$Aj)("record-small",60410),errorSmall:(0,n.$Aj)("error-small",60411),terminalDecorationError:(0,n.$Aj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Aj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Aj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Aj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Aj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Aj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Aj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Aj)("layout-sidebar-left-off",60418),blank:(0,n.$Aj)("blank",60419),heartFilled:(0,n.$Aj)("heart-filled",60420),map:(0,n.$Aj)("map",60421),mapFilled:(0,n.$Aj)("map-filled",60422),circleSmall:(0,n.$Aj)("circle-small",60423),bellSlash:(0,n.$Aj)("bell-slash",60424),bellSlashDot:(0,n.$Aj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Aj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Aj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Aj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Aj)("search-fuzzy",60429),commentDraft:(0,n.$Aj)("comment-draft",60430),send:(0,n.$Aj)("send",60431),sparkle:(0,n.$Aj)("sparkle",60432),insert:(0,n.$Aj)("insert",60433),mic:(0,n.$Aj)("mic",60434),thumbsdownFilled:(0,n.$Aj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Aj)("thumbsup-filled",60436),coffee:(0,n.$Aj)("coffee",60437),snake:(0,n.$Aj)("snake",60438),game:(0,n.$Aj)("game",60439),vr:(0,n.$Aj)("vr",60440),chip:(0,n.$Aj)("chip",60441),piano:(0,n.$Aj)("piano",60442),music:(0,n.$Aj)("music",60443),micFilled:(0,n.$Aj)("mic-filled",60444),repoFetch:(0,n.$Aj)("repo-fetch",60445),copilot:(0,n.$Aj)("copilot",60446),lightbulbSparkle:(0,n.$Aj)("lightbulb-sparkle",60447),robot:(0,n.$Aj)("robot",60448),sparkleFilled:(0,n.$Aj)("sparkle-filled",60449),diffSingle:(0,n.$Aj)("diff-single",60450),diffMultiple:(0,n.$Aj)("diff-multiple",60451),surroundWith:(0,n.$Aj)("surround-with",60452),share:(0,n.$Aj)("share",60453),gitStash:(0,n.$Aj)("git-stash",60454),gitStashApply:(0,n.$Aj)("git-stash-apply",60455),gitStashPop:(0,n.$Aj)("git-stash-pop",60456),vscode:(0,n.$Aj)("vscode",60457),vscodeInsiders:(0,n.$Aj)("vscode-insiders",60458),codeOss:(0,n.$Aj)("code-oss",60459),runCoverage:(0,n.$Aj)("run-coverage",60460),runAllCoverage:(0,n.$Aj)("run-all-coverage",60461),coverage:(0,n.$Aj)("coverage",60462),githubProject:(0,n.$Aj)("github-project",60463)}}),define(ae[74],ce([0,1,105,145]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Dj=P;function P(){return Object.values(e.$Fj)}e.$Ej={dialogError:(0,n.$Aj)("dialog-error","error"),dialogWarning:(0,n.$Aj)("dialog-warning","warning"),dialogInfo:(0,n.$Aj)("dialog-info","info"),dialogClose:(0,n.$Aj)("dialog-close","close"),treeItemExpanded:(0,n.$Aj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Aj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Aj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Aj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Aj)("tree-item-loading","loading"),menuSelection:(0,n.$Aj)("menu-selection","check"),menuSubmenu:(0,n.$Aj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Aj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Aj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Aj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Aj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Aj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Aj)("toolbar-more","more"),quickInputBack:(0,n.$Aj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Aj)("drop-down-button",60084),symbolCustomColor:(0,n.$Aj)("symbol-customcolor",60252),exportIcon:(0,n.$Aj)("export",60332),workspaceUnspecified:(0,n.$Aj)("workspace-unspecified",60355),newLine:(0,n.$Aj)("newline",60394),thumbsDownFilled:(0,n.$Aj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Aj)("thumbsup-filled",60436),gitFetch:(0,n.$Aj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Aj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Aj)("debug-breakpoint-pending",60377)},e.$Fj={...R.$Cj,...e.$Ej}}),define(ae[35],ce([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=R,e.$Nn=P,e.$On=A,e.$Pn=h,e.$Qn=c,e.$Rn=b,e.$Sn=y,e.$Tn=k,e.$Un=d,e.$Vn=m,e.$Wn=v,e.$Xn=w;function R($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const f=Array.isArray($)?[]:{};return Object.entries($).forEach(([u,g])=>{f[u]=g&&typeof g=="object"?R(g):g}),f}function P($){if(!$||typeof $!="object")return $;const f=[$];for(;f.length>0;){const u=f.shift();Object.freeze(u);for(const g in u)if(O.call(u,g)){const a=u[g];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$Wf)(a)&&f.push(a)}}return $}const O=Object.prototype.hasOwnProperty;function A($,f){return E($,f,new Set)}function E($,f,u){if((0,n.$3f)($))return $;const g=f($);if(typeof g<"u")return g;if(Array.isArray($)){const a=[];for(const t of $)a.push(E(t,f,u));return a}if((0,n.$Vf)($)){if(u.has($))throw new Error("Cannot clone recursive data-structure");u.add($);const a={};for(const t in $)O.call($,t)&&(a[t]=E($[t],f,u));return u.delete($),a}return $}function h($,f,u=!0){return(0,n.$Vf)($)?((0,n.$Vf)(f)&&Object.keys(f).forEach(g=>{g in $?u&&((0,n.$Vf)($[g])&&(0,n.$Vf)(f[g])?h($[g],f[g],u):$[g]=f[g]):$[g]=f[g]}),$):f}function c($,f){if($===f)return!0;if($==null||f===null||f===void 0||typeof $!=typeof f||typeof $!="object"||Array.isArray($)!==Array.isArray(f))return!1;let u,g;if(Array.isArray($)){if($.length!==f.length)return!1;for(u=0;u<$.length;u++)if(!c($[u],f[u]))return!1}else{const a=[];for(g in $)a.push(g);a.sort();const t=[];for(g in f)t.push(g);if(t.sort(),!c(a,t))return!1;for(u=0;u<a.length;u++)if(!c($[a[u]],f[a[u]]))return!1}return!0}function b($){const f=new Set;return JSON.stringify($,(u,g)=>{if((0,n.$Vf)(g)||Array.isArray(g)){if(f.has(g))return"[Circular]";f.add(g)}return g})}function y($,f){const u=Object.create(null);return!$||!f||Object.keys(f).forEach(a=>{const t=$[a],o=f[a];c(t,o)||(u[a]=o)}),u}function k($,f){const u=f.toLowerCase(),g=Object.keys($).find(a=>a.toLowerCase()===u);return g?$[g]:$[f]}function d($,f){const u=Object.create(null);for(const[g,a]of Object.entries($))f(g,a)&&(u[g]=a);return u}function m($){let f=[];for(;Object.prototype!==$;)f=f.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return f}function v($){const f=[];for(const u of m($))typeof $[u]=="function"&&f.push(u);return f}function w($,f){const u=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},g={};for(const a of $)g[a]=u(a);return g}}),define(ae[106],ce([0,1,74]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Gj=P;var R;(function(A){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}A.isThemeColor=E})(R||(e.ThemeColor=R={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function h(f){const u=E.exec(f.id);if(!u)return h(n.$Fj.error);const[,g,a]=u,t=["codicon","codicon-"+g];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=h;function c(f){return h(f).join(" ")}A.asClassName=c;function b(f){return"."+h(f).join(".")}A.asCSSSelector=b;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||R.isThemeColor(f.color))}A.isThemeIcon=y;const k=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function d(f){const u=k.exec(f);if(!u)return;const[,g]=u;return{id:g}}A.fromString=d;function m(f){return{id:f}}A.fromId=m;function v(f,u){let g=f.id;const a=g.lastIndexOf("~");return a!==-1&&(g=g.substring(0,a)),u&&(g=`${g}~${u}`),{id:g}}A.modify=v;function w(f){const u=f.id.lastIndexOf("~");if(u!==-1)return f.id.substring(u+1)}A.getModifier=w;function $(f,u){return f.id===u.id&&f.color?.id===u.color?.id}A.isEqual=$})(O||(e.ThemeIcon=O={}))}),define(ae[32],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=void 0,e.$Bg=R;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return n.test(P)}e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const O=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let h=0,c="";return c+=A[O[h++]],c+=A[O[h++]],c+=A[O[h++]],c+=A[O[h++]],c+="-",c+=A[O[h++]],c+=A[O[h++]],c+="-",c+=A[O[h++]],c+=A[O[h++]],c+="-",c+=A[O[h++]],c+=A[O[h++]],c+="-",c+=A[O[h++]],c+=A[O[h++]],c+=A[O[h++]],c+=A[O[h++]],c+=A[O[h++]],c+=A[O[h++]],c}}()}),define(ae[146],ce([0,1,87,46,85]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RV=O;async function O(A,E){if(await new Promise((b,y)=>{const k=R.createReadStream(A),d=n.createHash("sha256");k.pipe(d);const m=(0,P.$db)((v,w)=>{k.removeAllListeners(),d.removeAllListeners(),v?y(v):b(w)});k.once("error",m),k.once("end",m),d.once("error",m),d.once("data",v=>m(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(ae[147],ce([0,1,26]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=O;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(A){const E=A.replace(/\-/g,":").toLowerCase();return!R.has(E)}function O(){const A=(0,n.networkInterfaces)();for(const E in A){const h=A[E];if(h){for(const{mac:c}of h)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[107],ce([0,1,88]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=void 0,e.$Eg=R,e.$Gg=O;function R(E,h,c,b=1){let y=!1;return new Promise(k=>{const d=setTimeout(()=>{if(!y)return y=!0,k(0)},c);P(E,h,b,m=>{if(!y)return y=!0,clearTimeout(d),k(m)})})}function P(E,h,c,b){if(h===0)return b(0);const y=new n.Socket;y.once("connect",()=>(A(y),P(E+c,h-1,c,b))),y.once("data",()=>{}),y.once("error",k=>(A(y),k.code!=="ECONNREFUSED"?P(E+c,h-1,c,b):b(E))),y.connect(E,"127.0.0.1")}e.$Fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(E,h,c,b="127.0.0.1"){let y=!1,k,d=1;const m=n.createServer({pauseOnConnect:!0});function v(w,$){y||(y=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),$(w))}return new Promise(w=>{k=setTimeout(()=>{v(0,w)},c),m.on("listening",()=>{v(E,w)}),m.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&d<h?(E++,d++,m.listen(E,b)):v(0,w)}),m.on("close",()=>{v(0,w)}),m.listen(E,b)})}function A(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function n(h){const c=new Set;if(Array.isArray(h))for(const b of h)typeof b=="string"&&c.add(b);return Array.from(c)}function R(){const h=e();return h?Array.from(h):[]}function P(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const b of n(h))P(b)}function O(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const y of c){if(h.indexOf(y)!==0)continue;const d=h.indexOf("\\",y.length);if(d===-1)continue;const m=h.substring(y.length,d);if(m){b=m;break}}return b}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:P,getUNCHost:O,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[148],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VV=e.$UV=void 0,e.$UV="vscode:contextmenu",e.$VV="vscode:onCloseContextMenu"}),define(ae[149],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3V=void 0;class n{constructor(P,O){this.a=P,this.onMessage=O}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$3V=n}),define(ae[150],ce([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ae[151],ce([0,1,150]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=c,e.$Mm=b,e.$Nm=y;const R=60,P=R*60,O=P*24,A=O*7,E=O*30,h=O*365;function c(k,d,m,v){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,n.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!v&&w<30)return(0,n.localize)(1,null);let $;return w<R?($=w,d?$===1?m?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):m?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?m?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):m?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):w<P?($=Math.floor(w/R),d?$===1?m?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):m?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?m?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):m?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):w<O?($=Math.floor(w/P),d?$===1?m?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):m?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?m?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):m?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):w<A?($=Math.floor(w/O),d?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):w<E?($=Math.floor(w/A),d?$===1?m?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):m?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?m?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):m?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):w<h?($=Math.floor(w/E),d?$===1?m?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):m?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?m?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):m?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(w/h),d?$===1?m?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):m?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?m?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):m?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function b(k,d){const m=Math.abs(k/1e3);return m<1?d?(0,n.localize)(54,null,k):(0,n.localize)(55,null,k):m<R?d?(0,n.localize)(56,null,Math.round(k)/1e3):(0,n.localize)(57,null,Math.round(k)/1e3):m<P?d?(0,n.localize)(58,null,Math.round(k/(1e3*R))):(0,n.localize)(59,null,Math.round(k/(1e3*R))):m<O?d?(0,n.localize)(60,null,Math.round(k/(1e3*P))):(0,n.localize)(61,null,Math.round(k/(1e3*P))):(0,n.localize)(62,null,Math.round(k/(1e3*O)))}function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[152],ce([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,152]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=h,e.$5i=c,e.$6i=b;function O(y,k){return k&&(y.stack||y.stacktrace)?P.localize(0,null,E(y),A(y.stack)||A(y.stacktrace)):E(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(1,null,y.message):y.message||P.localize(2,null)}function h(y=null,k=!1){if(!y)return P.localize(3,null);if(Array.isArray(y)){const d=n.$Hb(y),m=h(d[0],k);return d.length>1?P.localize(4,null,m,d.length):m}if(R.$Tf(y))return y;if(y.detail){const d=y.detail;if(d.error)return O(d.error,k);if(d.exception)return O(d.exception,k)}return y.stack?O(y,k):y.message?y.message:P.localize(5,null)}function c(y){const k=y;return k instanceof Error&&Array.isArray(k.actions)}function b(y,k){let d;return typeof y=="string"?d=new Error(y):d=y,d.actions=k,d}}),define(ae[153],ce([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ae[154],ce([0,1,153]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=R;function R(P){switch(P){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(ae[155],ce([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,155]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=I,e.$J=j,e.$g="en";let R=!1,P=!1,O=!1,A=!1,E=!1,h=!1,c=!1,b=!1,y=!1,k=!1,d,m=e.$g,v=e.$g,w,$;const f=globalThis;let u;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?u=f.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",a=g&&u?.type==="renderer";if(typeof u=="object"){R=u.platform==="win32",P=u.platform==="darwin",O=u.platform==="linux",A=O&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,c=g,y=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,m=e.$g;const S=u.env.VSCODE_NLS_CONFIG;if(S)try{const D=JSON.parse(S),M=D.availableLanguages["*"];d=D.locale,v=D.osLocale,m=M||e.$g,w=D._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?($=navigator.userAgent,R=$.indexOf("Windows")>=0,P=$.indexOf("Macintosh")>=0,b=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=$.indexOf("Linux")>=0,k=$?.indexOf("Mobi")>=0,h=!0,d=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,m=d,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;P?r=1:R?r=3:O&&(r=2),e.$i=R,e.$j=P,e.$k=O,e.$l=A,e.$m=E,e.$n=c,e.$o=h,e.$p=h&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=b,e.$s=k,e.$t=y,e.$u=r,e.$v=$,e.$w=m;var i;(function(S){function D(){return e.$w}S.value=D;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=M;function W(){return e.$w==="en"}S.isDefault=W})(i||(e.Language=i={})),e.$x=d,e.$y=v,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const S=[];f.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let W=0,F=S.length;W<F;W++){const H=S[W];if(H.id===M.data.vscodeScheduleAsyncWork){S.splice(W,1),H.callback();return}}});let D=0;return M=>{const W=++D;S.push({id:W,callback:M}),f.postMessage({vscodeScheduleAsyncWork:W},"*")}}return S=>setTimeout(S)})();var s;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=P||b?2:R?1:3;let l=!0,p=!1;function I(){if(!p){p=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,l=new Uint16Array(S.buffer)[0]===513}return l}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function j(S){return parseFloat(S)>=20}}),define(ae[36],ce([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const O=P.process;R={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(ae[9],ce([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,P=97,O=90,A=122,E=46,h=47,c=92,b=58,y=63;class k extends Error{constructor(o,r,i){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const l=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${l} ${s} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const v=n.$dc==="win32";function w(t){return t===h||t===c}function $(t){return t===h}function f(t){return t>=R&&t<=O||t>=P&&t<=A}function u(t,o,r,i){let s="",l=0,p=-1,I=0,j=0;for(let S=0;S<=t.length;++S){if(S<t.length)j=t.charCodeAt(S);else{if(i(j))break;j=h}if(i(j)){if(!(p===S-1||I===1))if(I===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==E||s.charCodeAt(s.length-2)!==E){if(s.length>2){const D=s.lastIndexOf(r);D===-1?(s="",l=0):(s=s.slice(0,D),l=s.length-1-s.lastIndexOf(r)),p=S,I=0;continue}else if(s.length!==0){s="",l=0,p=S,I=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",l=2)}else s.length>0?s+=`${r}${t.slice(p+1,S)}`:s=t.slice(p+1,S),l=S-p-1;p=S,I=0}else j===E&&I!==-1?++I:I=-1}return s}function g(t,o){d(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let s=t.length-1;s>=-1;s--){let l;if(s>=0){if(l=t[s],m(l,"path"),l.length===0)continue}else o.length===0?l=n.cwd():(l=n.env[`=${o}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${o}\\`));const p=l.length;let I=0,j="",S=!1;const D=l.charCodeAt(0);if(p===1)w(D)&&(I=1,S=!0);else if(w(D))if(S=!0,w(l.charCodeAt(1))){let M=2,W=M;for(;M<p&&!w(l.charCodeAt(M));)M++;if(M<p&&M!==W){const F=l.slice(W,M);for(W=M;M<p&&w(l.charCodeAt(M));)M++;if(M<p&&M!==W){for(W=M;M<p&&!w(l.charCodeAt(M));)M++;(M===p||M!==W)&&(j=`\\\\${F}\\${l.slice(W,M)}`,I=M)}}}else I=1;else f(D)&&l.charCodeAt(1)===b&&(j=l.slice(0,2),I=2,p>2&&w(l.charCodeAt(2))&&(S=!0,I=3));if(j.length>0)if(o.length>0){if(j.toLowerCase()!==o.toLowerCase())continue}else o=j;if(i){if(o.length>0)break}else if(r=`${l.slice(I)}\\${r}`,i=S,S&&o.length>0)break}return r=u(r,!i,"\\",w),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,s=!1;const l=t.charCodeAt(0);if(o===1)return $(l)?"\\":t;if(w(l))if(s=!0,w(t.charCodeAt(1))){let I=2,j=I;for(;I<o&&!w(t.charCodeAt(I));)I++;if(I<o&&I!==j){const S=t.slice(j,I);for(j=I;I<o&&w(t.charCodeAt(I));)I++;if(I<o&&I!==j){for(j=I;I<o&&!w(t.charCodeAt(I));)I++;if(I===o)return`\\\\${S}\\${t.slice(j)}\\`;I!==j&&(i=`\\\\${S}\\${t.slice(j,I)}`,r=I)}}}else r=1;else f(l)&&t.charCodeAt(1)===b&&(i=t.slice(0,2),r=2,o>2&&w(t.charCodeAt(2))&&(s=!0,r=3));let p=r<o?u(t.slice(r),!s,"\\",w):"";return p.length===0&&!s&&(p="."),p.length>0&&w(t.charCodeAt(o-1))&&(p+="\\"),i===void 0?s?`\\${p}`:p:s?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return w(r)||o>2&&f(r)&&t.charCodeAt(1)===b&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let l=0;l<t.length;++l){const p=t[l];m(p,"path"),p.length>0&&(o===void 0?o=r=p:o+=`\\${p}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++s;const l=r.length;l>1&&w(r.charCodeAt(1))&&(++s,l>2&&(w(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&w(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.$fc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===c;)s++;let l=t.length;for(;l-1>s&&t.charCodeAt(l-1)===c;)l--;const p=l-s;let I=0;for(;I<o.length&&o.charCodeAt(I)===c;)I++;let j=o.length;for(;j-1>I&&o.charCodeAt(j-1)===c;)j--;const S=j-I,D=p<S?p:S;let M=-1,W=0;for(;W<D;W++){const H=t.charCodeAt(s+W);if(H!==o.charCodeAt(I+W))break;H===c&&(M=W)}if(W!==D){if(M===-1)return i}else{if(S>D){if(o.charCodeAt(I+W)===c)return i.slice(I+W+1);if(W===2)return i.slice(I+W)}p>D&&(t.charCodeAt(s+W)===c?M=W:W===2&&(M=3)),M===-1&&(M=0)}let F="";for(W=s+M+1;W<=l;++W)(W===l||t.charCodeAt(W)===c)&&(F+=F.length===0?"..":"\\..");return I+=M,F.length>0?`${F}${i.slice(I,j)}`:(i.charCodeAt(I)===c&&++I,i.slice(I,j))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==y&&r!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===b&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const s=t.charCodeAt(0);if(o===1)return w(s)?t:".";if(w(s)){if(r=i=1,w(t.charCodeAt(1))){let I=2,j=I;for(;I<o&&!w(t.charCodeAt(I));)I++;if(I<o&&I!==j){for(j=I;I<o&&w(t.charCodeAt(I));)I++;if(I<o&&I!==j){for(j=I;I<o&&!w(t.charCodeAt(I));)I++;if(I===o)return t;I!==j&&(r=i=I+1)}}}}else f(s)&&t.charCodeAt(1)===b&&(r=o>2&&w(t.charCodeAt(2))?3:2,i=r);let l=-1,p=!0;for(let I=o-1;I>=i;--I)if(w(t.charCodeAt(I))){if(!p){l=I;break}}else p=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,I=-1;for(l=t.length-1;l>=r;--l){const j=t.charCodeAt(l);if(w(j)){if(!s){r=l+1;break}}else I===-1&&(s=!1,I=l+1),p>=0&&(j===o.charCodeAt(p)?--p===-1&&(i=l):(p=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(w(t.charCodeAt(l))){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,s=-1,l=!0,p=0;t.length>=2&&t.charCodeAt(1)===b&&f(t.charCodeAt(0))&&(o=i=2);for(let I=t.length-1;I>=o;--I){const j=t.charCodeAt(I);if(w(j)){if(!l){i=I+1;break}continue}s===-1&&(l=!1,s=I+1),j===E?r===-1?r=I:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||s===-1||p===0||p===1&&r===s-1&&r===i+1?"":t.slice(r,s)},format:g.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,s=t.charCodeAt(0);if(r===1)return w(s)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(w(s)){if(i=1,w(t.charCodeAt(1))){let M=2,W=M;for(;M<r&&!w(t.charCodeAt(M));)M++;if(M<r&&M!==W){for(W=M;M<r&&w(t.charCodeAt(M));)M++;if(M<r&&M!==W){for(W=M;M<r&&!w(t.charCodeAt(M));)M++;M===r?i=M:M!==W&&(i=M+1)}}}}else if(f(s)&&t.charCodeAt(1)===b){if(r<=2)return o.root=o.dir=t,o;if(i=2,w(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let l=-1,p=i,I=-1,j=!0,S=t.length-1,D=0;for(;S>=i;--S){if(s=t.charCodeAt(S),w(s)){if(!j){p=S+1;break}continue}I===-1&&(j=!1,I=S+1),s===E?l===-1?l=S:D!==1&&(D=1):l!==-1&&(D=-1)}return I!==-1&&(l===-1||D===0||D===1&&l===I-1&&l===p+1?o.base=o.name=t.slice(p,I):(o.name=t.slice(p,l),o.base=t.slice(p,I),o.ext=t.slice(l,I))),p>0&&p!==i?o.dir=t.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const s=i>=0?t[i]:a();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===h)}return o=u(o,!r,"/",$),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=u(t,!o,"/",$),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,s=i-r,l=1,p=o.length-l,I=s<p?s:p;let j=-1,S=0;for(;S<I;S++){const M=t.charCodeAt(r+S);if(M!==o.charCodeAt(l+S))break;M===h&&(j=S)}if(S===I)if(p>I){if(o.charCodeAt(l+S)===h)return o.slice(l+S+1);if(S===0)return o.slice(l+S)}else s>I&&(t.charCodeAt(r+S)===h?j=S:S===0&&(j=0));let D="";for(S=r+j+1;S<=i;++S)(S===i||t.charCodeAt(S)===h)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(l+j)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let r=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===h){if(!i){r=s;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,I=-1;for(l=t.length-1;l>=0;--l){const j=t.charCodeAt(l);if(j===h){if(!s){r=l+1;break}}else I===-1&&(s=!1,I=l+1),p>=0&&(j===o.charCodeAt(p)?--p===-1&&(i=l):(p=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===h){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,s=!0,l=0;for(let p=t.length-1;p>=0;--p){const I=t.charCodeAt(p);if(I===h){if(!s){r=p+1;break}continue}i===-1&&(s=!1,i=p+1),I===E?o===-1?o=p:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:g.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===h;let i;r?(o.root="/",i=1):i=0;let s=-1,l=0,p=-1,I=!0,j=t.length-1,S=0;for(;j>=i;--j){const D=t.charCodeAt(j);if(D===h){if(!I){l=j+1;break}continue}p===-1&&(I=!1,p=j+1),D===E?s===-1?s=j:S!==1&&(S=1):s!==-1&&(S=-1)}if(p!==-1){const D=l===0&&r?1:l;s===-1||S===0||S===1&&s===p-1&&s===l+1?o.base=o.name=t.slice(D,p):(o.name=t.slice(D,s),o.base=t.slice(D,p),o.ext=t.slice(s,p))}return l>0?o.dir=t.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=v?e.$fc.normalize:e.$gc.normalize,e.$ic=v?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=v?e.$fc.join:e.$gc.join,e.$kc=v?e.$fc.resolve:e.$gc.resolve,e.$lc=v?e.$fc.relative:e.$gc.relative,e.$mc=v?e.$fc.dirname:e.$gc.dirname,e.$nc=v?e.$fc.basename:e.$gc.basename,e.$oc=v?e.$fc.extname:e.$gc.extname,e.$pc=v?e.$fc.format:e.$gc.format,e.$qc=v?e.$fc.parse:e.$gc.parse,e.$rc=v?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=v?e.$fc.sep:e.$gc.sep,e.$tc=v?e.$fc.delimiter:e.$gc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=A,e.$ag=E,e.$bg=h,e.$cg=c,e.$dg=b,e.$eg=m,e.$fg=v,e.$gg=w,e.$hg=$,e.$ig=f,e.$jg=u,e.$kg=g,e.$lg=a,e.$mg=t,e.$ng=o,e.$og=s;function A(l){return l===47||l===92}function E(l){return l.replace(/[\\/]/g,n.$gc.sep)}function h(l){return l.indexOf("/")===-1&&(l=E(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function c(l,p=n.$gc.sep){if(!l)return"";const I=l.length,j=l.charCodeAt(0);if(A(j)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let D=3;const M=D;for(;D<I&&!A(l.charCodeAt(D));D++);if(M!==D&&!A(l.charCodeAt(D+1))){for(D+=1;D<I;D++)if(A(l.charCodeAt(D)))return l.slice(0,D+1).replace(/[\\/]/g,p)}}return p}else if($(j)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+p:l.slice(0,2);let S=l.indexOf("://");if(S!==-1){for(S+=3;S<I;S++)if(A(l.charCodeAt(S)))return l.slice(0,S+1)}return""}function b(l){if(!R.$i||!l||l.length<5)return!1;let p=l.charCodeAt(0);if(p!==92||(p=l.charCodeAt(1),p!==92))return!1;let I=2;const j=I;for(;I<l.length&&(p=l.charCodeAt(I),p!==92);I++);return!(j===I||(p=l.charCodeAt(I+1),isNaN(p)||p===92))}const y=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,p=R.$i){const I=p?y:k;return!(!l||l.length===0||/^\s+$/.test(l)||(I.lastIndex=0,I.test(l))||p&&d.test(l)||l==="."||l===".."||p&&l[l.length-1]==="."||p&&l.length!==l.trim().length||l.length>255)}function v(l,p,I){const j=l===p;return!I||j?j:!l||!p?!1:(0,P.$kf)(l,p)}function w(l,p,I,j=n.sep){if(l===p)return!0;if(!l||!p||p.length>l.length)return!1;if(I){if(!(0,P.$lf)(l,p))return!1;if(p.length===l.length)return!0;let D=p.length;return p.charAt(p.length-1)===j&&D--,l.charAt(D)===j}return p.charAt(p.length-1)!==j&&(p+=j),l.indexOf(p)===0}function $(l){return l>=65&&l<=90||l>=97&&l<=122}function f(l,p){return R.$i&&l.endsWith(":")&&(l+=n.sep),(0,n.$ic)(l)||(l=(0,n.$jc)(p,l)),l=(0,n.$hc)(l),R.$i?(l=(0,P.$5e)(l,n.sep),l.endsWith(":")&&(l+=n.sep)):(l=(0,P.$5e)(l,n.sep),l||(l=n.sep)),l}function u(l){const p=(0,n.$hc)(l);return R.$i?l.length>3?!1:g(p)&&(l.length===2||p.charCodeAt(2)===92):p===n.$gc.sep}function g(l,p=R.$i){return p?$(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}function a(l,p=R.$i){return g(l,p)?l[0]:void 0}function t(l,p,I){return p.length>l.length?-1:l===p?0:(I&&(l=l.toLowerCase(),p=p.toLowerCase()),l.indexOf(p))}function o(l){const p=l.split(":");let I,j,S;for(const D of p){const M=Number(D);(0,O.$Xf)(M)?j===void 0?j=M:S===void 0&&(S=M):I=I?[I,D].join(":"):D}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:j!==void 0?j:void 0,column:S!==void 0?S:j!==void 0?1:void 0}}const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(l,p,I=8){let j="";for(let D=0;D<I;D++){let M;D===0&&R.$i&&!p&&(I===3||I===4)?M=i:M=r,j+=M.charAt(Math.floor(Math.random()*M.length))}let S;return p?S=`${p}-${j}`:S=j,l?(0,n.$jc)(l,S):S}}),define(ae[75],ce([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$9l=O,e.$0l=A;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var P;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function O(E,...h){const c=h.reduce((k,d)=>(k[d]=!0,k),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!c[k]).forEach(k=>{for(let d=0;d<b.length;d++)if(k.search(b[d])!==-1){delete E[k];break}})}function A(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(ae[7],ce([0,1,9,4]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=m,e.$wc=g;const P=/^\w[\w\d+.-]*$/,O=/^\//,A=/^\/\//;function E(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const b="",y="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,l,p,I,j,S=!1){typeof s=="object"?(this.scheme=s.scheme||b,this.authority=s.authority||b,this.path=s.path||b,this.query=s.query||b,this.fragment=s.fragment||b):(this.scheme=h(s,S),this.authority=l||b,this.path=c(this.scheme,p||b),this.query=I||b,this.fragment=j||b,E(this,S))}get fsPath(){return g(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:p,path:I,query:j,fragment:S}=s;return l===void 0?l=this.scheme:l===null&&(l=b),p===void 0?p=this.authority:p===null&&(p=b),I===void 0?I=this.path:I===null&&(I=b),j===void 0?j=this.query:j===null&&(j=b),S===void 0?S=this.fragment:S===null&&(S=b),l===this.scheme&&p===this.authority&&I===this.path&&j===this.query&&S===this.fragment?this:new w(l,p,I,j,S)}static parse(s,l=!1){const p=k.exec(s);return p?new w(p[2]||b,r(p[4]||b),r(p[5]||b),r(p[7]||b),r(p[9]||b),l):new w(b,b,b,b,b)}static file(s){let l=b;if(R.$i&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const p=s.indexOf(y,2);p===-1?(l=s.substring(2),s=y):(l=s.substring(2,p),s=s.substring(p)||y)}return new w("file",l,s,b,b)}static from(s,l){return new w(s.scheme,s.authority,s.path,s.query,s.fragment,l)}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.$i&&s.scheme==="file"?p=d.file(n.$fc.join(g(s,!0),...l)).path:p=n.$gc.join(s.path,...l),s.with({path:p})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const l=new w(s);return l._formatted=s.external??null,l._fsPath=s._sep===v?s.fsPath??null:null,l}}else return s}}e.URI=d;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const v=R.$i?1:void 0;class w extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=v),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const $={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,s,l){let p,I=-1;for(let j=0;j<i.length;j++){const S=i.charCodeAt(j);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||s&&S===47||l&&S===91||l&&S===93||l&&S===58)I!==-1&&(p+=encodeURIComponent(i.substring(I,j)),I=-1),p!==void 0&&(p+=i.charAt(j));else{p===void 0&&(p=i.substr(0,j));const D=$[S];D!==void 0?(I!==-1&&(p+=encodeURIComponent(i.substring(I,j)),I=-1),p+=D):I===-1&&(I=j)}}return I!==-1&&(p+=encodeURIComponent(i.substring(I))),p!==void 0?p:i}function u(i){let s;for(let l=0;l<i.length;l++){const p=i.charCodeAt(l);p===35||p===63?(s===void 0&&(s=i.substr(0,l)),s+=$[p]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function g(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,R.$i&&(l=l.replace(/\//g,"\\")),l}function a(i,s){const l=s?u:f;let p="",{scheme:I,authority:j,path:S,query:D,fragment:M}=i;if(I&&(p+=I,p+=":"),(j||I==="file")&&(p+=y,p+=y),j){let W=j.indexOf("@");if(W!==-1){const F=j.substr(0,W);j=j.substr(W+1),W=F.lastIndexOf(":"),W===-1?p+=l(F,!1,!1):(p+=l(F.substr(0,W),!1,!1),p+=":",p+=l(F.substr(W+1),!1,!0)),p+="@"}j=j.toLowerCase(),W=j.lastIndexOf(":"),W===-1?p+=l(j,!1,!0):(p+=l(j.substr(0,W),!1,!0),p+=j.substr(W))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const W=S.charCodeAt(1);W>=65&&W<=90&&(S=`/${String.fromCharCode(W+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const W=S.charCodeAt(0);W>=65&&W<=90&&(S=`${String.fromCharCode(W+32)}:${S.substr(2)}`)}p+=l(S,!0,!1)}return D&&(p+="?",p+=l(D,!1,!1)),M&&(p+="#",p+=s?M:f(M,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,s=>t(s)):i}}),define(ae[156],ce([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=R,e.$Dq=P,e.$Eq=O,e.log=E;function R(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}function P(c){const b=[];let y;try{const k=JSON.parse(c.arguments),d=k[k.length-1];d&&d.__$stack&&(k.pop(),y=d.__$stack),b.push(...k)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:y}}function O(c){if(typeof c!="string")return O(P(c).stack);const b=c;if(b){const y=A(b),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(k&&k.length===4)return{uri:n.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function A(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function E(c,b){const{args:y,stack:k}=P(c),d=typeof y[0]=="string"&&y.length===1;let m=A(k);m&&(m=`(${m.trim()})`);let v=[];if(typeof y[0]=="string"?m&&d?v=[`%c[${b}] %c${y[0]} %c${m}`,h("blue"),h(""),h("grey")]:v=[`%c[${b}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:v=[`%c[${b}]%`,h("blue"),...y],m&&!d&&v.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}function h(c){return`color: ${c}`}}),define(ae[76],ce([0,1,17,7]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=P,e.$Oh=O,e.$Ph=E;function P(h){return JSON.stringify(h,A)}function O(h){let c=JSON.parse(h);return c=E(c),c}function A(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return R.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.$te||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let b=0;b<h.length;++b)h[b]=E(h[b],c+1);else for(const b in h)Object.hasOwnProperty.call(h,b)&&(h[b]=E(h[b],c+1))}return h}}),define(ae[13],ce([0,1,15,4,25,7,9]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$tg=e.$sg=e.$rg=e.Schemas=void 0,e.$pg=h,e.$qg=c,e.$ug=y;var E;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(m,v){return O.URI.isUri(m)?(0,P.$kf)(m.scheme,v):(0,P.$lf)(m,v+":")}function c(m,...v){return v.some(w=>h(m,w))}e.$rg="vscode-tkn",e.$sg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,w){this.f=y(v,w)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,E.vscodeRemoteResource)}set(v,w,$){this.a[v]=w,this.b[v]=$}setConnectionToken(v,w){this.c[v]=w}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return n.$1(a),v}const w=v.authority;let $=this.a[w];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[w],u=this.c[w];let g=`path=${encodeURIComponent(v.path)}`;return typeof u=="string"&&(g+=`&${e.$sg}=${encodeURIComponent(u)}`),O.URI.from({scheme:R.$o?this.d:E.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:g})}}e.$tg=new b;function y(m,v){return A.$gc.join(v??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class k{static{this.a=e.$zg}asBrowserUri(v){const w=this.b(v,J);return this.uriToBrowserUri(w)}uriToBrowserUri(v){return v.scheme===E.vscodeRemote?e.$tg.rewrite(v):v.scheme===E.file&&(R.$m||R.$q===`${E.vscodeFileResource}://${k.a}`)?v.with({scheme:E.vscodeFileResource,authority:v.authority||k.a,query:null,fragment:null}):v}asFileUri(v){const w=this.b(v,J);return this.uriToFileUri(w)}uriToFileUri(v){return v.scheme===E.vscodeFileResource?v.with({scheme:E.file,authority:v.authority!==k.a?v.authority:null,query:null,fragment:null}):v}b(v,w){return O.URI.isUri(v)?v:O.URI.parse(w.toUrl(v))}}e.$Ag=new k;var d;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const w="vscode-coi";function $(u){let g;typeof u=="string"?g=new URL(u).searchParams:u instanceof URL?g=u.searchParams:O.URI.isUri(u)&&(g=new URL(u.toString(!0)).searchParams);const a=g?.get(w);if(a)return v.get(a)}m.getHeadersFromQuery=$;function f(u,g,a){if(!globalThis.crossOriginIsolated)return;const t=g&&a?"3":a?"2":"1";u instanceof URLSearchParams?u.set(w,t):u[w]=t}m.addSearchParam=f})(d||(e.COI=d={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=void 0,e.$Hg=h,e.$3g=b,e.$4g=k;function h(d){return(0,E.$wc)(d,!0)}class c{constructor(m){this.a=m}compare(m,v,w=!1){return m===v?0:(0,A.$df)(this.getComparisonKey(m,w),this.getComparisonKey(v,w))}isEqual(m,v,w=!1){return m===v?!0:!m||!v?!1:this.getComparisonKey(m,w)===this.getComparisonKey(v,w)}getComparisonKey(m,v=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,v,w=!1){if(m.scheme===v.scheme){if(m.scheme===R.Schemas.file)return n.$gg(h(m),h(v),this.a(m))&&m.query===v.query&&(w||m.fragment===v.fragment);if((0,e.$Yg)(m.authority,v.authority))return n.$gg(m.path,v.path,this.a(m),"/")&&m.query===v.query&&(w||m.fragment===v.fragment)}return!1}joinPath(m,...v){return E.URI.joinPath(m,...v)}basenameOrAuthority(m){return(0,e.$Qg)(m)||m.authority}basename(m){return P.$gc.basename(m.path)}extname(m){return P.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let v;return m.scheme===R.Schemas.file?v=E.URI.file(P.$mc(h(m))).path:(v=P.$gc.dirname(m.path),m.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),v="/")),m.with({path:v})}normalizePath(m){if(!m.path.length)return m;let v;return m.scheme===R.Schemas.file?v=E.URI.file(P.$hc(h(m))).path:v=P.$gc.normalize(m.path),m.with({path:v})}relativePath(m,v){if(m.scheme!==v.scheme||!(0,e.$Yg)(m.authority,v.authority))return;if(m.scheme===R.Schemas.file){const f=P.$lc(h(m),h(v));return O.$i?n.$ag(f):f}let w=m.path||"/";const $=v.path||"/";if(this.a(m)){let f=0;for(const u=Math.min(w.length,$.length);f<u&&!(w.charCodeAt(f)!==$.charCodeAt(f)&&w.charAt(f).toLowerCase()!==$.charAt(f).toLowerCase());f++);w=$.substr(0,f)+w.substr(f)}return P.$gc.relative(w,$)}resolvePath(m,v){if(m.scheme===R.Schemas.file){const w=E.URI.file(P.$kc(h(m),v));return m.with({authority:w.authority,path:w.path})}return v=n.$bg(v),m.with({path:P.$gc.resolve(m.path,v)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,v){return m===v||m!==void 0&&v!==void 0&&(0,A.$kf)(m,v)}hasTrailingPathSeparator(m,v=P.sep){if(m.scheme===R.Schemas.file){const w=h(m);return w.length>n.$cg(w).length&&w[w.length-1]===v}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,v=P.sep){return(0,e.$Zg)(m,v)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,v=P.sep){let w=!1;if(m.scheme===R.Schemas.file){const $=h(m);w=$!==void 0&&$.length===n.$cg($).length&&$[$.length-1]===v}else{v="/";const $=m.path;w=$.length===1&&$.charCodeAt($.length-1)===47}return!w&&!(0,e.$Zg)(m,v)?m.with({path:m.path+"/"}):m}}e.$Ig=c,e.$Jg=new c(()=>!1),e.$Kg=new c(d=>d.scheme===R.Schemas.file?!O.$k:!0),e.$Lg=new c(d=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function b(d,m){const v=[];for(let w=0;w<d.length;w++){const $=m(d[w]);d.some((f,u)=>u===w?!1:(0,e.$Ng)($,m(f)))||v.push(d[w])}return v}var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(u=>{const[g,a]=u.split(":");g&&a&&w.set(g,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&w.set(d.META_DATA_MIME,f),w}d.parseMetaData=m})(y||(e.DataUri=y={}));function k(d,m,v){if(m){let w=d.path;return w&&w[0]!==P.$gc.sep&&(w=P.$gc.sep+w),d.with({scheme:v,authority:m,path:w})}return d.with({scheme:v})}}),define(ae[8],ce([0,1,23,15,3,2,19,4,144,61]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$5g=b,e.$6g=y,e.$7g=k,e.$8g=d,e.$9g=m,e.$0g=v,e.$$g=w,e.$_g=$,e.$hh=l,e.$ih=p,e.$jh=I,e.$kh=j,e.$lh=S,e.$Ah=L,e.$Ih=X;function b(_){return!!_&&typeof _.then=="function"}function y(_){const B=new n.$de,te=_(B.token),ie=new Promise((de,me)=>{const ke=B.token.onCancellationRequested(()=>{ke.dispose(),me(new R.$5)});Promise.resolve(te).then(Se=>{ke.dispose(),B.dispose(),de(Se)},Se=>{ke.dispose(),B.dispose(),me(Se)})});return new class{cancel(){B.cancel(),B.dispose()}then(de,me){return ie.then(de,me)}catch(de){return this.then(void 0,de)}finally(de){return ie.finally(de)}}}function k(_,B,te){return new Promise((ie,de)=>{const me=B.onCancellationRequested(()=>{me.dispose(),ie(te)});_.then(ie,de).finally(()=>me.dispose())})}function d(_,B){return new Promise((te,ie)=>{const de=B.onCancellationRequested(()=>{de.dispose(),ie(new R.$5)});_.then(te,ie).finally(()=>de.dispose())})}async function m(_){let B=-1;const te=_.map((ie,de)=>ie.then(me=>(B=de,me)));try{return await Promise.race(te)}finally{_.forEach((ie,de)=>{de!==B&&ie.cancel()})}}function v(_,B,te){let ie;const de=setTimeout(()=>{ie?.(void 0),te?.()},B);return Promise.race([_.finally(()=>clearTimeout(de)),new Promise(me=>ie=me)])}function w(_){return new Promise((B,te)=>{const ie=_();b(ie)?ie.then(B,te):B(ie)})}function $(){let _,B;return{promise:new Promise((ie,de)=>{_=ie,B=de}),resolve:_,reject:B}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const te=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(te,te).then(ie)})}return new Promise((te,ie)=>{this.b.then(te,ie)})}return this.a=B(),new Promise((te,ie)=>{this.a.then(de=>{this.a=null,te(de)},de=>{this.a=null,ie(de)})})}dispose(){this.f=!0}}e.$ah=f;class u{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$bh=u;class g{constructor(){this.a=new Map}queue(B,te){const de=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(B)===de&&this.a.delete(B)});return this.a.set(B,de),de}}e.$ch=g;const a=(_,B)=>{let te=!0;const ie=setTimeout(()=>{te=!1,B()},_);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ie),te=!1}}},t=_=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,_())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class o{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,te=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((de,me)=>{this.d=de,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=te===h.$3d?t(ie):a(te,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=o;class r{constructor(B){this.a=new o(B),this.b=new f}trigger(B,te){return this.a.trigger(()=>this.b.queue(B),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=r;class i{constructor(){this.a=!1,this.b=new Promise((B,te)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=i;class s extends i{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$gh=s;function l(_,B){return B?new Promise((te,ie)=>{const de=setTimeout(()=>{me.dispose(),te()},_),me=B.onCancellationRequested(()=>{clearTimeout(de),me.dispose(),ie(new R.$5)})}):y(te=>l(_,te))}function p(_,B=0,te){const ie=setTimeout(()=>{_(),te&&de.dispose()},B),de=(0,O.$Rc)(()=>{clearTimeout(ie),te?.deleteAndLeak(de)});return te?.add(de),de}function I(_){const B=[];let te=0;const ie=_.length;function de(){return te<ie?_[te++]():null}function me(ke){ke!=null&&B.push(ke);const Se=de();return Se?Se.then(me):Promise.resolve(B)}return Promise.resolve(null).then(me)}function j(_,B=ie=>!!ie,te=null){let ie=0;const de=_.length,me=()=>{if(ie>=de)return Promise.resolve(te);const ke=_[ie++];return Promise.resolve(ke()).then(Oe=>B(Oe)?Promise.resolve(Oe):me())};return me()}function S(_,B=ie=>!!ie,te=null){if(_.length===0)return Promise.resolve(te);let ie=_.length;const de=()=>{ie=-1;for(const me of _)me.cancel?.()};return new Promise((me,ke)=>{for(const Se of _)Se.then(Oe=>{--ie>=0&&B(Oe)?(de(),me(Oe)):ie===0&&me(te)}).catch(Oe=>{--ie>=0&&(de(),ke(Oe))})})}class D{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new P.$6d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ie)=>{this.g.push({factory:B,c:te,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const te=B.factory();te.then(B.c,B.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=D;class M extends D{constructor(){super(1)}}e.$nh=M;class W{constructor(){this.a=new N,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$oh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new oe;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,te=A.$Jg){const ie=te.getComparisonKey(B);return this.a.get(ie)?.size??0}queueFor(B,te,ie=A.$Jg){const de=ie.getComparisonKey(B);let me=this.a.get(de);if(!me){me=new M;const ke=this.f++,Se=P.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(ke),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(ke,Se),this.a.set(de,me)}return me.queue(te)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=F;class H{constructor(B,te){this.a=-1,typeof B=="function"&&typeof te=="number"&&this.setIfNotSet(B,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},te)}setIfNotSet(B,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},te))}}e.$qh=H;class x{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,te,ie=globalThis){this.cancel();const de=ie.setInterval(()=>{B()},te);this.d=(0,O.$Rc)(()=>{ie.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$rh=x;class le{constructor(B,te){this.b=-1,this.a=B,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=le;class re{constructor(B,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=B,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=re;class ue extends le{constructor(B,te){super(B,te),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$uh=ue;class Q extends O.$Tc{constructor(B,te){super(),this.g=B,this.h=te,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of B)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(_,B)=>{(0,E.$B)(()=>{if(te)return;const ie=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$xh=(_,B,te)=>{const ie=_.requestIdleCallback(B,typeof te=="number"?{timeout:te}:void 0);let de=!1;return{dispose(){de||(de=!0,_.cancelIdleCallback(ie))}}},e.$wh=_=>(0,e.$xh)(globalThis,_)}();class Y{constructor(B,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$xh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=Y;class U extends Y{constructor(B){super(globalThis,B)}}e.$zh=U;async function L(_,B,te){let ie;for(let de=0;de<te;de++)try{return await _()}catch(me){ie=me,await l(B)}throw ie}class N{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,te,ie){return this.a={taskId:B,cancel:()=>ie?.(),promise:te},te.then(()=>this.d(B),()=>this.d(B)),te}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{const{promise:te,resolve:ie,reject:de}=$();this.b={run:B,promise:te,promiseResolve:ie,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=N;class G{constructor(B,te=()=>Date.now()){this.d=B,this.f=te,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$Ch=G;var q;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(q||(q={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,te)=>{this.a=B,this.b=te})}complete(B){return new Promise(te=>{this.a(B),this.d={outcome:0,value:B},te()})}error(B){return new Promise(te=>{this.b(B),this.d={outcome:1,value:B},te()})}cancel(){return this.error(new R.$5)}}e.$Dh=oe;var he;(function(_){async function B(ie){let de;const me=await Promise.all(ie.map(ke=>ke.then(Se=>Se,Se=>{de||(de=Se)})));if(typeof de<"u")throw de;return me}_.settled=B;function te(ie){return new Promise(async(de,me)=>{try{await ie(de,me)}catch(ke){me(ke)}})}_.withAsyncBody=te})(he||(e.Promises=he={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=K;class C{constructor(B){this.b=B,this.a=new c.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=C;var T;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(T||(T={}));class Z{static fromArray(B){return new Z(te=>{te.emitMany(B)})}static fromPromise(B){return new Z(async te=>{te.emitMany(await B)})}static fromPromises(B){return new Z(async te=>{await Promise.all(B.map(async ie=>te.emitOne(await ie)))})}static merge(B){return new Z(async te=>{await Promise.all(B.map(async ie=>{for await(const de of ie)te.emitOne(de)}))})}static{this.EMPTY=Z.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new P.$6d,queueMicrotask(async()=>{const te={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(B(te)),this.j()}catch(ie){this.k(ie)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(B,te){return new Z(async ie=>{for await(const de of B)ie.emitOne(te(de))})}map(B){return Z.map(this,B)}static filter(B,te){return new Z(async ie=>{for await(const de of B)te(de)&&ie.emitOne(de)})}filter(B){return Z.filter(this,B)}static coalesce(B){return Z.filter(B,te=>!!te)}coalesce(){return Z.coalesce(this)}static async toPromise(B){const te=[];for await(const ie of B)te.push(ie);return te}toPromise(){return Z.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$Gh=Z;class z extends Z{constructor(B,te){super(te),this.l=B}cancel(){this.l.cancel()}}e.$Hh=z;function X(_){const B=new n.$de,te=_(B.token);return new z(B,async ie=>{const de=B.token.onCancellationRequested(()=>{de.dispose(),B.dispose(),ie.reject(new R.$5)});try{for await(const me of te){if(B.token.isCancellationRequested)return;ie.emitOne(me)}de.dispose(),B.dispose()}catch(me){de.dispose(),B.dispose(),ie.reject(me)}})}class V{constructor(){this.a=new oe,this.b=new Z(ie=>{if(B){ie.reject(B);return}return te&&ie.emitMany(te),this.d=de=>ie.reject(de),this.f=de=>ie.emitOne(de),this.a.p});let B,te;this.f=ie=>{te||(te=[]),te.push(ie)},this.d=ie=>{B||(B=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$Jh=V}),define(ae[108],ce([0,1,22,8,33,31,9,4,25]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=c,e.$$j=m,e.$_j=M,e.$ak=W,e.$bk=F,e.$ck=H,e.$dk=x,e.$ek=Q;function c(){return Object.create(null)}e.$9j="**",e.$0j="/";const b="[/\\\\]",y="[^/\\\\]",k=/\//g;function d(Y,U){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${b}|${y}+${b}${U?`|${b}${y}+`:""})*?`}}function m(Y,U){if(!Y)return[];const L=[];let N=!1,G=!1,q="";for(const oe of Y){switch(oe){case U:if(!N&&!G){L.push(q),q="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}q+=oe}return q&&L.push(q),L}function v(Y){if(!Y)return"";let U="";const L=m(Y,e.$0j);if(L.every(N=>N===e.$9j))U=".*";else{let N=!1;L.forEach((G,q)=>{if(G===e.$9j){if(N)return;U+=d(2,q===L.length-1)}else{let oe=!1,he="",K=!1,C="";for(const T of G){if(T!=="}"&&oe){he+=T;continue}if(K&&(T!=="]"||!C)){let Z;T==="-"?Z=T:(T==="^"||T==="!")&&!C?Z="^":T===e.$0j?Z="":Z=(0,h.$Ye)(T),C+=Z;continue}switch(T){case"{":oe=!0;continue;case"[":K=!0;continue;case"}":{const z=`(?:${m(he,",").map(X=>v(X)).join("|")})`;U+=z,oe=!1,he="";break}case"]":{U+="["+C+"]",K=!1,C="";break}case"?":U+=y;continue;case"*":U+=d(1);continue;default:U+=(0,h.$Ye)(T)}}q<L.length-1&&(L[q+1]!==e.$9j||q+2<L.length)&&(U+=b)}N=G===e.$9j})}return U}const w=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(Y,U){if(!Y)return r;let L;typeof Y!="string"?L=Y.pattern:L=Y,L=L.trim();const N=`${L}_${!!U.trimForExclusions}`;let G=t.get(N);if(G)return s(G,Y);let q;return w.test(L)?G=p(L.substr(4),L):(q=$.exec(l(L,U)))?G=I(q[1],L):(U.trimForExclusions?u:f).test(L)?G=j(L,U):(q=g.exec(l(L,U)))?G=S(q[1].substr(1),L,!0):(q=a.exec(l(L,U)))?G=S(q[1],L,!1):G=D(L),t.set(N,G),s(G,Y)}function s(Y,U){if(typeof U=="string")return Y;const L=function(N,G){return(0,P.$gg)(N,U.base,!E.$k)?Y((0,h.$4e)(N.substr(U.base.length),A.sep),G):null};return L.allBasenames=Y.allBasenames,L.allPaths=Y.allPaths,L.basenames=Y.basenames,L.patterns=Y.patterns,L}function l(Y,U){return U.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,U){return function(L,N){return typeof L=="string"&&L.endsWith(Y)?U:null}}function I(Y,U){const L=`/${Y}`,N=`\\${Y}`,G=function(oe,he){return typeof oe!="string"?null:he?he===Y?U:null:oe===Y||oe.endsWith(L)||oe.endsWith(N)?U:null},q=[Y];return G.basenames=q,G.patterns=[U],G.allBasenames=q,G}function j(Y,U){const L=ue(Y.slice(1,-1).split(",").map(he=>i(he,U)).filter(he=>he!==r),Y),N=L.length;if(!N)return r;if(N===1)return L[0];const G=function(he,K){for(let C=0,T=L.length;C<T;C++)if(L[C](he,K))return Y;return null},q=L.find(he=>!!he.allBasenames);q&&(G.allBasenames=q.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function S(Y,U,L){const N=A.sep===A.$gc.sep,G=N?Y:Y.replace(k,A.sep),q=A.sep+G,oe=A.$gc.sep+Y;let he;return L?he=function(K,C){return typeof K=="string"&&(K===G||K.endsWith(q)||!N&&(K===Y||K.endsWith(oe)))?U:null}:he=function(K,C){return typeof K=="string"&&(K===G||!N&&K===Y)?U:null},he.allPaths=[(L?"*/":"./")+Y],he}function D(Y){try{const U=new RegExp(`^${v(Y)}$`);return function(L){return U.lastIndex=0,typeof L=="string"&&U.test(L)?Y:null}}catch{return r}}function M(Y,U,L){return!Y||typeof U!="string"?!1:W(Y)(U,void 0,L)}function W(Y,U={}){if(!Y)return o;if(typeof Y=="string"||F(Y)){const L=i(Y,U);if(L===r)return o;const N=function(G,q){return!!L(G,q)};return L.allBasenames&&(N.allBasenames=L.allBasenames),L.allPaths&&(N.allPaths=L.allPaths),N}return le(Y,U)}function F(Y){const U=Y;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}function H(Y){return Y.allBasenames||[]}function x(Y){return Y.allPaths||[]}function le(Y,U){const L=ue(Object.getOwnPropertyNames(Y).map(he=>re(he,Y[he],U)).filter(he=>he!==r)),N=L.length;if(!N)return r;if(!L.some(he=>!!he.requiresSiblings)){if(N===1)return L[0];const he=function(T,Z){let z;for(let X=0,V=L.length;X<V;X++){const _=L[X](T,Z);if(typeof _=="string")return _;(0,R.$5g)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const X of z){const V=await X;if(typeof V=="string")return V}return null})():null},K=L.find(T=>!!T.allBasenames);K&&(he.allBasenames=K.allBasenames);const C=L.reduce((T,Z)=>Z.allPaths?T.concat(Z.allPaths):T,[]);return C.length&&(he.allPaths=C),he}const G=function(he,K,C){let T,Z;for(let z=0,X=L.length;z<X;z++){const V=L[z];V.requiresSiblings&&C&&(K||(K=(0,A.$nc)(he)),T||(T=K.substr(0,K.length-(0,A.$oc)(he).length)));const _=V(he,K,T,C);if(typeof _=="string")return _;(0,R.$5g)(_)&&(Z||(Z=[]),Z.push(_))}return Z?(async()=>{for(const z of Z){const X=await z;if(typeof X=="string")return X}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(G.allBasenames=q.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function re(Y,U,L){if(U===!1)return r;const N=i(Y,L);if(N===r)return r;if(typeof U=="boolean")return N;if(U){const G=U.when;if(typeof G=="string"){const q=(oe,he,K,C)=>{if(!C||!N(oe,he))return null;const T=G.replace("$(basename)",()=>K),Z=C(T);return(0,R.$5g)(Z)?Z.then(z=>z?Y:null):Z?Y:null};return q.requiresSiblings=!0,q}}return N}function ue(Y,U){const L=Y.filter(he=>!!he.basenames);if(L.length<2)return Y;const N=L.reduce((he,K)=>{const C=K.basenames;return C?he.concat(C):he},[]);let G;if(U){G=[];for(let he=0,K=N.length;he<K;he++)G.push(U)}else G=L.reduce((he,K)=>{const C=K.patterns;return C?he.concat(C):he},[]);const q=function(he,K){if(typeof he!="string")return null;if(!K){let T;for(T=he.length;T>0;T--){const Z=he.charCodeAt(T-1);if(Z===47||Z===92)break}K=he.substr(T)}const C=N.indexOf(K);return C!==-1?G[C]:null};q.basenames=N,q.patterns=G,q.allBasenames=N;const oe=Y.filter(he=>!he.basenames);return oe.push(q),oe}function Q(Y,U){return(0,n.$ub)(Y,U,(L,N)=>typeof L=="string"&&typeof N=="string"?L===N:typeof L!="string"&&typeof N!="string"?L.base===N.base&&L.pattern===N.pattern:!1)}}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=h,e.$dw=b,e.$ew=k,e.$fw=d,e.$gw=$,e.$hw=u,e.$iw=g,e.$jw=a,e.$kw=t,e.$lw=o;function h(i,s){const{os:l,tildify:p,relative:I}=s;if(I){const D=c(i,I,l);if(typeof D=="string")return D}let j=i.fsPath;if(l===1&&!O.$i?j=j.replace(/\//g,"\\"):l!==1&&O.$i&&(j=j.replace(/\\/g,"/")),l!==1&&p?.userHome){const D=p.userHome.fsPath;let M;i.scheme!==p.userHome.scheme&&i.path[0]===P.$gc.sep&&i.path[1]!==P.$gc.sep?M=p.userHome.with({path:i.path}).fsPath:M=j,j=k(M,D,l)}return(l===1?P.$fc:P.$gc).normalize(b(j,l===1))}function c(i,s,l){const p=l===1?P.$fc:P.$gc,I=l===3?A.$Jg:A.$Lg,j=s.getWorkspace(),S=(0,n.$Ob)(j.folders);if(!S)return;i.scheme!==S.uri.scheme&&i.path[0]===P.$gc.sep&&i.path[1]!==P.$gc.sep&&(i=S.uri.with({path:i.path}));const D=s.getWorkspaceFolder(i);if(!D)return;let M;if(I.isEqual(D.uri,i)?M="":M=I.relativePath(D.uri,i)??"",M&&(M=p.normalize(M)),j.folders.length>1&&!s.noPrefix){const W=D.name?D.name:I.basenameOrAuthority(D.uri);M=M?`${W} \u2022 ${M}`:W}return M}function b(i,s=O.$i){return(0,R.$kg)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function k(i,s,l=O.OS){if(l===1||!i||!s)return i;let p=y.original===s?y.normalized:void 0;p||(p=s,O.$i&&(p=(0,R.$ag)(p)),p=`${(0,E.$5e)(p,P.$gc.sep)}${P.$gc.sep}`,y={original:s,normalized:p});let I=i;return O.$i&&(I=(0,R.$ag)(I)),(l===3?I.startsWith(p):(0,E.$lf)(I,p))?`~/${I.substr(p.length)}`:i}function d(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}const m="\u2026",v="\\\\",w="~";function $(i,s=P.sep){const l=new Array(i.length);let p=!1;for(let I=0;I<i.length;I++){const j=i[I];if(j===""){l[I]=`.${s}`;continue}if(!j){l[I]=j;continue}p=!0;let S="",D=j;D.indexOf(v)===0?(S=D.substr(0,D.indexOf(v)+v.length),D=D.substr(D.indexOf(v)+v.length)):D.indexOf(s)===0?(S=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(w)===0&&(S=D.substr(0,D.indexOf(w)+w.length),D=D.substr(D.indexOf(w)+w.length));const M=D.split(s);for(let W=1;p&&W<=M.length;W++)for(let F=M.length-W;p&&F>=0;F--){p=!1;let H=M.slice(F,F+W).join(s);for(let x=0;!p&&x<i.length;x++)if(x!==I&&i[x]&&i[x].indexOf(H)>-1){const le=F+W===M.length,re=F>0&&i[x].indexOf(s)>-1?s+H:H,ue=i[x].endsWith(re);p=!le||ue}if(!p){let x="";(M[0].endsWith(":")||S!=="")&&(F===1&&(F=0,W++,H=M[0]+s+H),F>0&&(x=M[0]+s),x=S+x),F>0&&(x=x+m+s),x=x+H,F+W<M.length&&(x=x+s+m),l[I]=x}}p&&(l[I]=j)}return l}var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function u(i,s=Object.create(null)){const l=[];let p=!1,I="";for(const j of i)if(j==="$"||p&&j==="{")I&&l.push({value:I,type:f.TEXT}),I="",p=!0;else if(j==="}"&&p){const S=s[I];if(typeof S=="string")S.length&&l.push({value:S,type:f.VARIABLE});else if(S){const D=l[l.length-1];(!D||D.type!==f.SEPARATOR)&&l.push({value:S.label,type:f.SEPARATOR})}I="",p=!1}else I+=j;return I&&!p&&l.push({value:I,type:f.TEXT}),l.filter((j,S)=>{if(j.type===f.SEPARATOR){const D=l[S-1],M=l[S+1];return[D,M].every(W=>W&&(W.type===f.VARIABLE||W.type===f.TEXT)&&W.value.length>0)}return!0}).map(j=>j.value).join("")}function g(i,s){return O.$j||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function a(i,s){return O.$j||s?i.replace(/\(&&\w\)|&&/g,""):O.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const l=r(i.substring(0,s)),p=i.substring(s);return{name:l.name+p,parentPath:l.parentPath}}}return r(i)}function r(i){const s=i.indexOf("/")!==-1?P.$gc:P.$fc,l=s.basename(i),p=s.dirname(i);return l.length?{name:l,parentPath:p}:{name:p,parentPath:""}}}),define(ae[157],ce([0,1,17,7]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$kn=E,e.$ln=c,e.$mn=b;function P(y){return y.toJSON()}class O{constructor(k){this.a=k}transformIncoming(k){const d=this.a.transformIncoming(k);return d===k?k:P(R.URI.from(d))}transformOutgoing(k){const d=this.a.transformOutgoing(k);return d===k?k:P(R.URI.from(d))}transformOutgoingURI(k){const d=this.a.transformOutgoing(k);return d===k?k:R.URI.from(d)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$in=O,e.$jn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function A(y,k,d){if(!y||d>200)return null;if(typeof y=="object"){if(y instanceof R.URI)return k.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const v=A(y[m],k,d+1);v!==null&&(y[m]=v)}}return null}function E(y,k){const d=A(y,k,0);return d===null?y:d}function h(y,k,d,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return d?R.URI.revive(k.transformIncoming(y)):k.transformIncoming(y);if(y instanceof n.$te)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const w=h(y[v],k,d,m+1);w!==null&&(y[v]=w)}}return null}function c(y,k){const d=h(y,k,!1,0);return d===null?y:d}function b(y,k){const d=h(y,k,!0,0);return d===null?y:d}}),define(ae[89],ce([0,1,26,59,32,147,4]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=void 0,e.$pn=h,e.$qn=y,e.$on=new class{c(k){return this.a||(this.a=R.$mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,d=0;const m=(0,n.networkInterfaces)();for(const v in m){const w=m[v];if(w)for(const{mac:$,internal:f}of w)f||(d+=1,this.c($.toUpperCase())&&(k+=1))}this.b=d>0?k/d:0}return this.b}};let E;async function h(k){return E||(E=(async()=>await c(k)||P.$Cg())()),E}async function c(k){try{const d=await new Promise((v,w)=>{J(["crypto"],v,w)}),m=(0,O.$nn)();return d.createHash("sha256").update(m,"utf8").digest("hex")}catch(d){k(d);return}}const b="Software\\Microsoft\\SQMClient";async function y(k){if(A.$i){const d=await new Promise((m,v)=>{J(["@vscode/windows-registry"],m,v)});try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(m){return k(m),""}}return""}}),define(ae[21],ce([0,1,46,26,158,8,33,86,9,4,19,7]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=u,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=I;var k;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function d(re,ue=k.UNLINK,Q){if((0,A.$jg)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===k.UNLINK?v(re):m(re,Q)}async function m(re,ue=(0,A.$og)((0,R.tmpdir)())){try{try{await n.promises.rename(re,ue)}catch(Q){return Q.code==="ENOENT"?void 0:v(re)}v(ue).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function v(re){return(0,P.promisify)(n.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function w(re){if((0,A.$jg)(re))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}async function $(re,ue){return g(await(ue?f(re):(0,P.promisify)(n.readdir)(re)))}async function f(re){try{return await(0,P.promisify)(n.readdir)(re,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],Q=await $(re);for(const Y of Q){let U=!1,L=!1,N=!1;try{const G=await e.Promises.lstat((0,h.$jc)(re,Y));U=G.isFile(),L=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Y,isFile:()=>U,isDirectory:()=>L,isSymbolicLink:()=>N})}return ue}function u(re){return g(n.readdirSync(re))}function g(re){return re.map(ue=>typeof ue=="string"?c.$j?(0,E.$Xl)(ue):ue:(ue.name=c.$j?(0,E.$Xl)(ue.name):ue.name,ue))}async function a(re){const ue=await $(re),Q=[];for(const Y of ue)await o.existsDirectory((0,h.$jc)(re,Y))&&Q.push(Y);return Q}function t(re,ue=1e3){return new Promise(Q=>{let Y=!1;const U=setInterval(()=>{Y||(Y=!0,n.access(re,L=>{Y=!1,L&&(clearInterval(U),Q(void 0))}))},ue)})}var o;(function(re){async function ue(U){let L;try{if(L=await e.Promises.lstat(U),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw N}}re.stat=ue;async function Q(U){try{const{stat:L,symbolicLink:N}=await re.stat(U);return L.isFile()&&N?.dangling!==!0}catch{}return!1}re.existsFile=Q;async function Y(U){try{const{stat:L,symbolicLink:N}=await re.stat(U);return L.isDirectory()&&N?.dangling!==!0}catch{}return!1}re.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new O.$ph;function i(re,ue,Q){return r.queueFor(y.URI.file(re),()=>{const Y=j(Q);return new Promise((U,L)=>p(re,ue,Y,N=>N?L(N):U()))},b.$Kg)}let s=!0;function l(re){s=re}function p(re,ue,Q,Y){if(!s)return n.writeFile(re,ue,{mode:Q.mode,flag:Q.flag},Y);n.open(re,Q.flag,Q.mode,(U,L)=>{if(U)return Y(U);n.writeFile(L,ue,N=>{if(N)return n.close(L,()=>Y(N));n.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),l(!1)),n.close(L,q=>Y(q))))})})}function I(re,ue,Q){const Y=j(Q);if(!s)return n.writeFileSync(re,ue,{mode:Y.mode,flag:Y.flag});const U=n.openSync(re,Y.flag,Y.mode);try{n.writeFileSync(U,ue);try{n.fdatasyncSync(U)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),l(!1)}}finally{n.closeSync(U)}}function j(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function S(re,ue,Q=6e4){if(re!==ue)try{c.$i&&typeof Q=="number"?await D(re,ue,Date.now(),Q):await(0,P.promisify)(n.rename)(re,ue)}catch(Y){if(re.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||re.endsWith("."))await M(re,ue,{preserveSymlinks:!1}),await d(re,k.MOVE);else throw Y}}async function D(re,ue,Q,Y,U=0){try{return await(0,P.promisify)(n.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Q>=Y)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${L}`),L;if(U===0){let N=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(N=!0)}catch{}if(N)throw L}return await(0,O.$hh)(Math.min(100,U*10)),D(re,ue,Q,Y,U+1)}}async function M(re,ue,Q){return F(re,ue,{root:{source:re,target:ue},options:Q,handledSourcePaths:new Set})}const W=511;async function F(re,ue,Q){if(Q.handledSourcePaths.has(re))return;Q.handledSourcePaths.add(re);const{stat:Y,symbolicLink:U}=await o.stat(re);if(U){if(Q.options.preserveSymlinks)try{return await le(re,ue,Q)}catch{}if(U.dangling)return}return Y.isDirectory()?H(re,ue,Y.mode&W,Q):x(re,ue,Y.mode&W)}async function H(re,ue,Q,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:Q});const U=await $(re);for(const L of U)await F((0,h.$jc)(re,L),(0,h.$jc)(ue,L),Y)}async function x(re,ue,Q){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Q)}async function le(re,ue,Q){let Y=await e.Promises.readlink(re);(0,A.$gg)(Y,Q.root.source,!c.$k)&&(Y=(0,h.$jc)(Q.root.target,Y.substr(Q.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,P.promisify)(n.access)}get stat(){return(0,P.promisify)(n.stat)}get lstat(){return(0,P.promisify)(n.lstat)}get utimes(){return(0,P.promisify)(n.utimes)}get read(){return(re,ue,Q,Y,U)=>new Promise((L,N)=>{n.read(re,ue,Q,Y,U,(G,q,oe)=>G?N(G):L({bytesRead:q,buffer:oe}))})}get readFile(){return(0,P.promisify)(n.readFile)}get write(){return(re,ue,Q,Y,U)=>new Promise((L,N)=>{n.write(re,ue,Q,Y,U,(G,q,oe)=>G?N(G):L({bytesWritten:q,buffer:oe}))})}get appendFile(){return(0,P.promisify)(n.appendFile)}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return(0,P.promisify)(n.truncate)}get copyFile(){return(0,P.promisify)(n.copyFile)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return(0,P.promisify)(n.symlink)}get readlink(){return(0,P.promisify)(n.readlink)}get chmod(){return(0,P.promisify)(n.chmod)}get mkdir(){return(0,P.promisify)(n.mkdir)}get unlink(){return(0,P.promisify)(n.unlink)}get rmdir(){return(0,P.promisify)(n.rmdir)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return d}get rename(){return S}get copy(){return M}}}),define(ae[109],ce([0,1,46,9,4,25,21]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=E,e.$Kq=h,e.$Lq=c,e.$Mq=b;function E(k){if(P.$k)return k;const d=(0,R.$mc)(k);if(k===d)return k;const m=((0,R.$nc)(k)||k).toLowerCase();try{const w=(0,A.readdirSync)(d).filter($=>$.toLowerCase()===m);if(w.length===1){const $=E(d);if($)return(0,R.$jc)($,w[0])}else if(w.length>1){const $=w.indexOf(m);if($>=0){const f=E(d);if(f)return(0,R.$jc)(f,w[$])}}}catch{}return null}async function h(k){if(P.$k)return k;const d=(0,R.$mc)(k);if(k===d)return k;const m=((0,R.$nc)(k)||k).toLowerCase();try{const w=(await A.Promises.readdir(d)).filter($=>$.toLowerCase()===m);if(w.length===1){const $=await h(d);if($)return(0,R.$jc)($,w[0])}else if(w.length>1){const $=w.indexOf(m);if($>=0){const f=await h(d);if(f)return(0,R.$jc)(f,w[$])}}}catch{}return null}async function c(k){try{return await A.Promises.realpath(k)}catch{const m=y(k);return await A.Promises.access(m,n.constants.R_OK),m}}function b(k){try{return n.realpathSync(k)}catch{const m=y(k);return n.accessSync(m,n.constants.R_OK),m}}function y(k){return(0,O.$5e)((0,R.$hc)(k),R.sep)}}),define(ae[110],ce([0,1,26,9,21]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=f,e.$8l=u;const O=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:g=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:g});if(!t)return null;const o=R.$jc(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const p of await P.Promises.readdir(o)){let I=-1;if(a){const S=p.indexOf("-");if(S<0)continue;const D=p.substring(0,S);if(!O.test(D)||p.substring(S+1)!=="preview")continue;I=parseInt(D,10)}else{if(!O.test(p))continue;I=parseInt(p,10)}if(I<=r)continue;const j=R.$jc(o,p,"pwsh.exe");await P.SymlinkSupport.existsFile(j)&&(i=j,r=I)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new y(i,`PowerShell${l}${s}`,!0)}async function m({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(a))if(t.test(r)){const i=R.$jc(a,r,"pwsh.exe");return new y(i,o)}return null}function v(){const g=R.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new y(g,".NET Core PowerShell Global Tool")}function w(){const g=R.$jc(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(g,"Windows PowerShell",!0)}async function*$(){let g=await d();g&&(yield g),g=await d({useAlternateBitness:!0}),g&&(yield g),g=await m(),g&&(yield g),g=v(),g&&(yield g),g=await d({findPreview:!0}),g&&(yield g),g=await m({findPreview:!0}),g&&(yield g),g=await d({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=w(),g&&(yield g)}async function*f(){for await(const g of $())await g.exists()&&(yield g)}async function u(){for await(const g of f())return g;return null}}),define(ae[90],ce([0,1,9,4,36,75,12,21]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$$l=h,e.$_l=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function h(y=P.env){return y.comspec||"cmd.exe"}function c(y){let k=[],d=!1;const m=function(v){if(d){k.push(v);return}(!y.send(v,$=>{if($&&console.error($),d=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(u=>m(u))}})||R.$i)&&(d=!0)};return{send:m}}var b;(function(y){async function k(d,m,v){if(n.$ic(d))return d;if(m===void 0&&(m=P.cwd()),n.$mc(d)!=="."||(v===void 0&&A.$Tf(P.env.PATH)&&(v=P.env.PATH.split(n.$tc)),v===void 0||v.length===0))return n.$jc(m,d);async function $(f){if(await E.Promises.exists(f)){let u;try{u=await E.Promises.stat(f)}catch(g){g.message.startsWith("EACCES")&&(u=await E.Promises.lstat(f))}return u?!u.isDirectory():!1}return!1}for(const f of v){let u;if(n.$ic(f)?u=n.$jc(f,d):u=n.$jc(m,f,d),await $(u))return u;let g=u+".com";if(await $(g)||(g=u+".exe",await $(g)))return g}return n.$jc(m,d)}y.findExecutable=k})(b||(e.win32=b={}))}),define(ae[111],ce([0,1,48,13]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=P;function P(A){return new Promise((E,h)=>{let c;const b=new Map;function y(d,m,v,w,$){const f=b.get(m);if(d===A||f){const u={name:k(v),cmd:v,pid:d,ppid:m,load:w,mem:$};b.set(d,u),d===A&&(c=u),f&&(f.children||(f.children=[]),f.children.push(u),f.children.length>1&&(f.children=f.children.sort((g,a)=>g.pid-a.pid)))}}function k(d){const m=/--utility-sub-type=network/i,v=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec(d))return"electron-crash-reporter";if(w.exec(d))return"winpty-agent";if($.exec(d))return"conpty-agent";let u=f.exec(d);if(u&&u.length===2)return u[1]==="renderer"?"window":u[1]==="utility"?m.exec(d)?"utility-network-service":"utility-process":u[1]==="extensionHost"?"extension-host":u[1];const g=/[a-zA-Z-]+\.js/g;let a="";do u=g.exec(d),u&&(a+=u+" ");while(u);return a&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${a})`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,v)=>{J(["@vscode/windows-process-tree"],m,v)}).then(m=>{m.getProcessList(A,v=>{if(!v){h(new Error(`Root process ${A} not found`));return}m.getProcessCpuUsage(v,w=>{const $=new Map;w.forEach(f=>{const u=d(f.commandLine||"");$.set(f.pid,{name:k(u),cmd:u,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=$.get(A),c?($.forEach(f=>{const u=$.get(f.ppid);u&&(u.children||(u.children=[]),u.children.push(f))}),$.forEach(f=>{f.children&&(f.children=f.children.sort((u,g)=>u.pid-g.pid))}),E(c)):h(new Error(`Root process ${A} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[c];const v=[];for(;m.length;){const $=m.shift();$&&(v.push($.pid),$.children&&(m=m.concat($.children)))}let w=JSON.stringify(R.$Ag.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+v.join(" "),(0,n.exec)(w,{},($,f,u)=>{if($||u)h($||new Error(u.toString()));else{const g=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=b.get(v[a]);t.load=parseFloat(g[a])}if(!c){h(new Error(`Root process ${A} not found`));return}E(c)}})};(0,n.exec)("which ps",{},(m,v,w)=>{if(m||w)if(process.platform!=="linux")h(m||new Error(w.toString()));else{const $=JSON.stringify(R.$Ag.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(f,u,g)=>{f||g?h(f||new Error(g.toString())):(O(u,y),d())})}else{const $=v.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,g,a)=>{u||a&&!a.includes("screen size is bogus")?h(u||new Error(a.toString())):(O(g,y),process.platform==="linux"?d():c?E(c):h(new Error(`Root process ${A} not found`)))})}})}})}function O(A,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=A.toString().split(`
`);for(const b of c){const y=h.exec(b.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ae[112],ce([0,1,26,4,110,90]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=A;async function A(y,k){return y===1?R.$i?b():O.$$l(k):h(y,k)}let E=null;function h(y,k){if(R.$k&&y===2||R.$j&&y===3)return"/bin/bash";if(!E){let d;if(R.$i)d="/bin/bash";else{if(d=k.SHELL,!d)try{d=(0,n.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}E=d}return E}let c=null;async function b(){return c||(c=(await(0,P.$8l)()).exePath),c}});var ve=this&&this.__decorate||function(J,e,n,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,n):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(J,e,n,R);else for(var E=J.length-1;E>=0;E--)(A=J[E])&&(O=(P<3?A(O):P>3?A(e,n,O):A(e,n))||O);return P>3&&O&&Object.defineProperty(e,n,O),O};define(ae[43],ce([0,1,22,8,17,23,50,15,3,2,76,25,12]),function(J,e,n,R,P,O,A,E,h,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Rh=e.$Qh=void 0,e.$Sh=l,e.$Th=p,e.$Yh=W,e.$Zh=F;var d;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(d||(d={}));function m(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(v||(v={}));function w(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})($||($={}));function f(U){let L=0;for(let N=0;;N+=7){const G=U.read(1);if(L|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return L}}const u=r(0);function g(U,L){if(L===0){U.write(u);return}let N=0;for(let q=L;q!==0;q=q>>>7)N++;const G=P.$te.alloc(N);for(let q=0;L!==0;q++)G.buffer[q]=L&127,L=L>>>7,L>0&&(G.buffer[q]|=128);U.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const N=this.b.slice(this.a,this.a+L);return this.a+=N.byteLength,N}}e.$Qh=a;class t{constructor(){this.a=[]}get buffer(){return P.$te.concat(this.a)}write(L){this.a.push(L)}}e.$Rh=t;var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(o||(o={}));function r(U){const L=P.$te.alloc(1);return L.writeUInt8(U,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function l(U,L){if(typeof L>"u")U.write(i.Undefined);else if(typeof L=="string"){const N=P.$te.fromString(L);U.write(i.String),g(U,N.byteLength),U.write(N)}else if(s&&Buffer.isBuffer(L)){const N=P.$te.wrap(L);U.write(i.Buffer),g(U,N.byteLength),U.write(N)}else if(L instanceof P.$te)U.write(i.VSBuffer),g(U,L.byteLength),U.write(L);else if(Array.isArray(L)){U.write(i.Array),g(U,L.length);for(const N of L)l(U,N)}else if(typeof L=="number"&&(L|0)===L)U.write(i.Uint),g(U,L);else{const N=P.$te.fromString(JSON.stringify(L));U.write(i.Object),g(U,N.byteLength),U.write(N)}}function p(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(f(U)).toString();case o.Buffer:return U.read(f(U)).buffer;case o.VSBuffer:return U.read(f(U));case o.Array:{const N=f(U),G=[];for(let q=0;q<N;q++)G.push(p(U));return G}case o.Object:return JSON.parse(U.read(f(U)).toString());case o.Int:return f(U)}}class I{constructor(L,N,G=null,q=1e3){this.h=L,this.j=N,this.k=G,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(L,N){this.b.set(L,N),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const N=this.o([L.type]);this.k?.logOutgoing(N,0,1,w(L.type));return}case 201:case 202:case 204:case 203:{const N=this.o([L.type,L.id],L.data);this.k?.logOutgoing(N,L.id,1,w(L.type),L.data);return}}}o(L,N=void 0){const G=new t;return l(G,L),l(G,N),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const N=new a(L),G=p(N),q=p(N),oe=G[0];switch(oe){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,q),this.s({type:oe,id:G[1],channelName:G[2],name:G[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,q),this.t({type:oe,id:G[1],channelName:G[2],name:G[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]})}}s(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=new O.$de;let q;try{q=N.call(this.j,L.name,L.arg,G.token)}catch(K){q=Promise.reject(K)}const oe=L.id;q.then(K=>{this.m({id:oe,data:K,type:201})},K=>{K instanceof Error?this.m({id:oe,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:oe,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,c.$Rc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=L.id,oe=N.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,oe)}u(L){const N=this.d.get(L.id);N&&(N.dispose(),this.d.delete(L.id))}v(L){let N=this.g.get(L.channelName);N||(N=[],this.g.set(L.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:L,timeoutTimer:G})}w(L){const N=this.g.get(L);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=I;var j;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class S{constructor(L,N=null){this.l=L,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(L){const N=this;return{call(G,q,oe){return N.a?Promise.reject(new E.$5):N.m(L,G,q,oe)},listen(G,q){return N.a?h.Event.None:N.o(L,G,q)}}}m(L,N,G,q=O.CancellationToken.None){const oe=this.g++,K={id:oe,type:100,channelName:L,name:N,arg:G};if(q.isCancellationRequested)return Promise.reject(new E.$5);let C;return new Promise((Z,z)=>{if(q.isCancellationRequested)return z(new E.$5);const X=()=>{const te=ie=>{switch(ie.type){case 201:this.f.delete(oe),Z(ie.data);break;case 202:{this.f.delete(oe);const de=new Error(ie.data.message);de.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,de.name=ie.data.name,z(de);break}case 203:this.f.delete(oe),z(ie.data);break}};this.f.set(oe,te),this.p(K)};let V=null;this.b===$.Idle?X():(V=(0,R.$6g)(te=>this.u()),V.then(()=>{V=null,X()}));const _=()=>{V?(V.cancel(),V=null):this.p({id:oe,type:101}),z(new E.$5)},B=q.onCancellationRequested(_);C=(0,c.$Qc)((0,c.$Rc)(_),B),this.d.add(C)}).finally(()=>{C.dispose(),this.d.delete(C)})}o(L,N,G){const q=this.g++,he={id:q,type:102,channelName:L,name:N,arg:G};let K=null;const C=new h.$6d({onWillAddFirstListener:()=>{K=(0,R.$6g)(Z=>this.u()),K.then(()=>{K=null,this.d.add(C),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(C),this.p({id:q,type:103}))}}),T=Z=>C.fire(Z.data);return this.f.set(q,T),C.event}p(L){switch(L.type){case 100:case 102:{const N=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(N,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const N=this.q([L.type,L.id]);this.j?.logOutgoing(N,L.id,0,m(L.type));return}}}q(L,N=void 0){const G=new t;return l(G,L),l(G,N),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const N=new a(L),G=p(N),q=p(N),oe=G[0];switch(oe){case 200:return this.j?.logIncoming(L.byteLength,0,0,w(oe)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,w(oe),q),this.t({type:G[0],id:G[1],data:q})}}t(L){if(L.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=S,ve([A.$Kh],S.prototype,"onDidInitializePromise",null);class D{get connections(){const L=[];return this.f.forEach(N=>L.push(N)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new h.$6d,this.onDidAddConnection=this.g.event,this.h=new h.$6d,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(L(({protocol:N,onDidClientDisconnect:G})=>{const q=h.Event.once(N.onMessage);this.j.add(q(oe=>{const he=new a(oe),K=p(he),C=new I(N,K),T=new S(N);this.a.forEach((z,X)=>C.registerChannel(X,z));const Z={channelServer:C,channelClient:T,ctx:K};this.f.add(Z),this.g.fire(Z),this.j.add(G(()=>{C.dispose(),T.dispose(),this.f.delete(Z),this.h.fire(Z)}))}))}))}getChannel(L,N){const G=this;return{call(q,oe,he){let K;if((0,k.$8f)(N)){const T=(0,n.$4b)(G.connections.filter(N));K=T?Promise.resolve(T):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,N))}else K=N.routeCall(G,q,oe);const C=K.then(T=>T.channelClient.getChannel(L));return W(C).call(q,oe,he)},listen(q,oe){if((0,k.$8f)(N))return G.k(L,N,q,oe);const he=N.routeEvent(G,q,oe).then(K=>K.channelClient.getChannel(L));return W(he).listen(q,oe)}}}k(L,N,G,q){const oe=this;let he;const K=new h.$6d({onWillAddFirstListener:()=>{he=new c.$Sc;const C=new h.$_d,T=new Map,Z=X=>{const _=X.channelClient.getChannel(L).listen(G,q),B=C.add(_);T.set(X,B)},z=X=>{const V=T.get(X);V&&(V.dispose(),T.delete(X))};oe.connections.filter(N).forEach(Z),h.Event.filter(oe.onDidAddConnection,N)(Z,void 0,he),oe.onDidRemoveConnection(z,void 0,he),C.event(K.fire,K,he),he.add(C)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,N){this.a.set(L,N);for(const G of this.f)G.channelServer.registerChannel(L,N)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=D;class M{constructor(L,N,G=null){const q=new t;l(q,N),L.send(q.buffer),this.a=new S(L,G),this.d=new I(L,N,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,N){this.d.registerChannel(L,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=M;function W(U){return{call(L,N,G){return U.then(q=>q.call(L,N,G))},listen(L,N){const G=new h.$ce;return U.then(q=>G.input=q.listen(L,N)),G.event}}}function F(U){let L=!1;return{call(N,G,q){return L?U.call(N,G,q):(0,R.$hh)(0).then(()=>L=!0).then(()=>U.call(N,G,q))},listen(N,G){if(L)return U.listen(N,G);const q=new h.$ce;return(0,R.$hh)(0).then(()=>L=!0).then(()=>q.input=U.listen(N,G)),q.event}}}class H{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const N of L.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await h.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$1h=H;var x;(function(U){function L(oe,he,K){const C=oe,T=K&&K.disableMarshalling,Z=new Map;for(const z in C)G(z)&&Z.set(z,h.Event.buffer(C[z],!0,void 0,he));return new class{listen(z,X,V){const _=Z.get(X);if(_)return _;const B=C[X];if(typeof B=="function"){if(q(X))return B.call(C,V);if(G(X))return Z.set(X,h.Event.buffer(C[X],!0,void 0,he)),Z.get(X)}throw new E.$bb(`Event not found: ${X}`)}call(z,X,V){const _=C[X];if(typeof _=="function"){if(!T&&Array.isArray(V))for(let te=0;te<V.length;te++)V[te]=(0,b.$Ph)(V[te]);let B=_.apply(C,V);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new E.$bb(`Method not found: ${X}`)}}}U.fromService=L;function N(oe,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(C,T){if(typeof T=="string")return he?.properties?.has(T)?he.properties.get(T):q(T)?function(Z){return oe.listen(T,Z)}:G(T)?oe.listen(T):async function(...Z){let z;he&&!(0,k.$3f)(he.context)?z=[he.context,...Z]:z=Z;const X=await oe.call(T,z);return K?X:(0,b.$Ph)(X)};throw new E.$bb(`Property not found: ${String(T)}`)}})}U.toService=N;function G(oe){return oe[0]==="o"&&oe[1]==="n"&&y.$jf(oe.charCodeAt(2))}function q(oe){return/^onDynamic/.test(oe)&&y.$jf(oe.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const L=U.toString();if(L!=="[object Object]")return L}return U}function ue(U){return Array.isArray(U)?U.map(re):re(U)}function Q(U,L,N,G,q,oe,he){he=ue(he);const K=le[q],C=K[G%K.length];let T=[`%c[${U}]%c[${String(L).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(oe)?(T=T.concat(he),T.push(")")):T.push(he),console.log.apply(console,T)}class Y{constructor(L,N){this.d=L,this.f=N,this.a=0,this.b=0}logOutgoing(L,N,G,q,oe){this.b+=L,Q(this.d,this.b,L,N,G,q,oe)}logIncoming(L,N,G,q,oe){this.a+=L,Q(this.f,this.a,L,N,G,q,oe)}}e.$2h=Y}),define(ae[159],ce([0,1,17,3,43]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1V=e.$ZV=void 0;class O{constructor(h){this.a=h,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$te.wrap(c.data):n.$te.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$ZV=O;class A extends P.$Xh{constructor(h,c){const b=new O(h);super(b,c),this.b=b}dispose(){this.b.disconnect(),super.dispose()}}e.$1V=A}),define(ae[113],ce([0,1,17,3,2,43]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.ProtocolConstants=e.$3h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let l=0;function p(j,S){if(!s.has(j)){const D=String(++l);s.set(j,D)}return s.get(j)}function I(j,S,D,M){if(!i.enableDiagnostics)return;const W=p(j,S);if(M instanceof n.$te||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const F=n.$te.alloc(M.byteLength);F.set(M),i.records.push({timestamp:Date.now(),id:W,label:S,type:D,buff:F})}else i.records.push({timestamp:Date.now(),id:W,label:S,type:D,data:M})}i.traceSocketEvent=I})(E||(e.SocketDiagnostics=E={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function b(){return c||(c=n.$te.alloc(0)),c}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return b();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const S=this.a[0];return l&&(this.a.shift(),this.b-=s),S}if(this.a[0].byteLength>s){const S=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),S}const p=n.$te.alloc(s);let I=0,j=0;for(;s>0;){const S=this.a[j];if(S.byteLength>s){const D=S.slice(0,s);p.set(D,I),I+=s,l&&(this.a[j]=S.slice(s),this.b-=s),s-=s}else p.set(S,I),I+=S.byteLength,l?(this.a.shift(),this.b-=S.byteLength):j++,s-=S.byteLength}return p}}e.$3h=y;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(k||(k={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class v{constructor(s,l,p,I){this.type=s,this.id=l,this.ack=p,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends P.$Tc{constructor(s){super(),this.f=this.B(new R.$6d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new y,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,I=this.g.id,j=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new v(p,I,j,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$te.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const p=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,p}h(){const s=n.$te.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class f extends P.$Tc{constructor(s){super(),this.f=new R.$6d,this.onMessage=this.f.event,this.g=new R.$6d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new $(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new v(1,0,0,s))}}e.$4h=f;class u extends O.$Xh{static fromSocket(s,l){return new u(new f(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,p=null){super(s,l,p),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$5h=u;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$6d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$6h=g;class a{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,p=this.a;for(;p;)s[l++]=p.data,p=p.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new a(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<o.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+o.a)*1e3;let p=0;for(let I=0;I<o.a;I++)s-this.c[I]<=l&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??o.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Sc,this.o=s.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new v(5,0,0,b());this.p.write(s),this.p.flush()}sendPause(){const s=new v(7,0,0,b());this.p.write(s)}sendResume(){const s=new v(8,0,0,b());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r.dispose(),this.r=new P.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new v(3,0,this.h,b());this.p.write(s);const l=this.b.toArray();for(let p=0,I=l.length;p<I;p++)this.p.write(l[p]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new v(6,0,0,b())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let p=0,I=l.length;p<I;p++)this.p.write(l[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const p=new v(1,l,this.h,s);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(s){const l=new v(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,p=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(l>=2e4&&p>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:p});return}const j=Math.max(2e4-l,2e4-p,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},j)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new v(3,0,this.h,b());this.p.write(s)}D(){this.h=this.g;const s=new v(9,0,this.h,b());this.p.write(s)}}e.$7h=r}),define(ae[37],ce([0,1,14,15,13]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WV=void 0;class O{constructor(){this.a=new WeakMap}on(E,h){const c=(b,...y)=>{this.b(E,b)&&h(b,...y)};return this.a.set(h,c),n.ipcMain.on(E,c),this}once(E,h){return n.ipcMain.once(E,(c,...b)=>{this.b(E,c)&&h(c,...b)}),this}handle(E,h){return n.ipcMain.handle(E,(c,...b)=>this.b(E,c)?h(c,...b):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,h){const c=this.a.get(h);return c&&(n.ipcMain.removeListener(E,c),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const c=h.senderFrame,b=c.url;if(!b||b==="about:blank")return!0;let y="unknown";try{y=new URL(b).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${b}'.`),!1}return y!==P.$zg?((0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${y}'.`),!1):c.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$WV=new O}),define(ae[160],ce([0,1,14,37,148]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XV=O;function O(){R.$WV.on(P.$UV,(E,h,c,b,y)=>{const k=A(E,b,c);k.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{k&&E.sender.send(P.$VV,h)}})})}function A(E,h,c){const b=new n.Menu;return c.forEach(y=>{let k;y.type==="separator"?k=new n.MenuItem({type:y.type}):Array.isArray(y.submenu)?k=new n.MenuItem({submenu:A(E,h,y.submenu),label:y.label}):k=new n.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,m,v)=>E.sender.send(h,y.id,v)}),b.append(k)}),b}}),define(ae[161],ce([0,1,37,17,3,2,43,149]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4V=void 0;function h(b,y){const k=P.Event.fromNodeEventEmitter(n.$WV,y,(m,v)=>({event:m,message:v})),d=P.Event.filter(k,({event:m})=>m.sender.id===b);return P.Event.map(d,({message:m})=>m&&R.$te.wrap(m))}class c extends A.$Wh{static{this.b=new Map}static d(){const y=P.Event.fromNodeEventEmitter(n.$WV,"vscode:hello",({sender:k})=>k);return P.Event.map(y,k=>{const d=k.id;c.b.get(d)?.dispose();const v=new P.$6d;c.b.set(d,(0,O.$Rc)(()=>v.fire()));const w=h(d,"vscode:message"),$=P.Event.any(P.Event.signal(h(d,"vscode:disconnect")),v.event);return{protocol:new E.$3V(k,w),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$4V=c}),define(ae[114],ce([0,1,37,3,32,159]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5V=void 0,e.$6V=E;class A extends O.$1V{constructor(c,b){super({addEventListener:(y,k)=>c.addListener(y,k),removeEventListener:(y,k)=>c.removeListener(y,k),postMessage:y=>c.postMessage(y),start:()=>c.start(),close:()=>c.close()},b)}}e.$5V=A;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Cg)();h.webContents.send("vscode:createMessageChannel",c);const b=R.Event.fromNodeEventEmitter(n.$WV,"vscode:createMessageChannelResult",(k,d)=>({nonce:d,port:k.ports[0]})),{port:y}=await R.Event.toPromise(R.Event.once(R.Event.filter(b,k=>k.nonce===c)));return y}}),define(ae[162],ce([0,1,48,8,17,23,156,15,3,2,35,90,75,43]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;class m extends d.$Uh{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>P.$te.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Gq=m;class v{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new h.$6d,this.onDidProcessExit=this.h.event;const u=f&&f.timeout?f.timeout:6e4;this.b=new R.$dh(u),this.d=null,this.f=null}getChannel($){const f=this;return{call(u,g,a){return f.k($,u,g,a)},listen(u,g){return f.l($,u,g)}}}k($,f,u,g=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n($),t=(0,R.$6g)(i=>a.call(f,u,i)),o=g.onCancellationRequested(()=>t.cancel()),r=(0,c.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,f,u){if(!this.b)return h.Event.None;this.b.cancel();let g;const a=new h.$6d({onWillAddFirstListener:()=>{g=this.n($).listen(f,u)(a.fire,a),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,b.$Mn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,k.$0l)(f.env),this.d=(0,n.fork)(this.i,$,f);const u=new h.$6d;h.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$Cq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}u.fire(P.$te.wrap(Buffer.from(s,"base64")))});const a=this.j.useQueue?(0,y.$_l)(this.d):this.d,t=s=>this.d&&this.d.connected&&a.send(s.buffer.toString("base64")),o=u.event,r={send:t,onMessage:o};this.f=new d.$Vh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",i),this.c.forEach(p=>(0,c.$Oc)(p)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hq=v}),define(ae[115],ce([0,1,8,3,2,76,12]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.StorageState=e.StorageHint=void 0,e.$Fp=h;var E;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(k){const d=k;return d?.changed instanceof Map||d?.deleted instanceof Set}var c;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(c||(e.StorageState=c={}));class b extends P.$Tc{static{this.a=100}constructor(d,m=Object.create(null)){super(),this.r=d,this.s=m,this.b=this.B(new R.$9d),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$eh(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((m,v)=>this.w(v,m)),d.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(d,m){if(this.c===c.Closed)return;let v=!1;(0,A.$3f)(m)?v=this.f.delete(d):this.f.get(d)!==m&&(this.f.set(d,m),v=!0),v&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,m){const v=this.f.get(d);return(0,A.$3f)(v)?m:v}getBoolean(d,m){const v=this.get(d);return(0,A.$3f)(v)?m:v==="true"}getNumber(d,m){const v=this.get(d);return(0,A.$3f)(v)?m:parseInt(v,10)}getObject(d,m){const v=this.get(d);return(0,A.$3f)(v)?m:(0,O.$Oh)(v)}async set(d,m,v=!1){if(this.c===c.Closed)return;if((0,A.$3f)(m))return this.delete(d,v);const w=(0,A.$Vf)(m)||Array.isArray(m)?(0,O.$Nh)(m):String(m);if(this.f.get(d)!==w)return this.f.set(d,w),this.j.set(d,w),this.h.delete(d),this.b.fire({key:d,external:v}),this.D()}async delete(d,m=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Gp=b;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((m,v)=>this.a.set(v,m)),d.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Hp=y}),define(ae[163],ce([0,1,8,3,31,9,21]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,y=Object.create(null)){this.g=b,this.h=y,this.c=(0,O.$nc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,y=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(d=>y.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(b){const y=await this.f;return this.j(y,b)}j(b,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,P.$yc)(y.insert):"0"}), delete(${y.delete?(0,P.$zc)(y.delete):"0"})`),this.t(b,()=>{const k=y.insert,d=y.delete;if(k&&k.size>0){const m=[];m.push([]);let v=0;k.forEach((w,$)=>{let f=m[v];f.length>E.b&&(v++,f=[],m.push(f)),f.push($,w)}),m.forEach(w=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,$=>$.run(w),()=>{const $=[];let f=0;return k.forEach((u,g)=>{$.push(g),f+=u.length}),`Keys: ${$.join(", ")} Length: ${f}`})})}if(d&&d.size){const m=[];m.push([]);let v=0;d.forEach(w=>{let $=m[v];$.length>E.b&&(v++,$=[],m.push($)),$.push(w)}),m.forEach(w=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,$=>$.run(w),()=>{const $=[];return d.forEach(f=>{$.push(f)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,b)}k(b,y){return new Promise((k,d)=>{b.db.close(m=>(m&&this.o(b,`[storage ${this.c}] close(): ${m}`),this.g===E.IN_MEMORY_PATH?k():!b.isErroneous&&!b.isInMemory?this.l().then(k,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),k())):typeof y=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const w=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>w(),$=>(w(),Promise.reject($)))})).then(k,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return A.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const y=await this.f,k=await this.r(y,b?"PRAGMA integrity_check":"PRAGMA quick_check"),d=b?k.integrity_check:k.quick_check;return y.isErroneous?`${d} (last error: ${y.lastError})`:y.isInMemory?`${d} (in-memory!)`:d}async n(b,y=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${y})`);try{return await this.p(b)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&y)return await(0,n.$hh)(E.a),this.n(b,!1);try{await A.Promises.unlink(b);try{await A.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(E.IN_MEMORY_PATH)}}}o(b,y){b.isErroneous=!0,b.lastError=y,this.d.error(y)}p(b){return new Promise((y,k)=>{new Promise((d,m)=>{J(["@vscode/sqlite3"],d,m)}).then(d=>{const m={db:new(this.d.isTracing?d.verbose().Database:d.Database)(b,v=>v?m.db&&v.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(v)):k(v):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(m),w=>m.db.close(()=>k(w)))),isInMemory:b===E.IN_MEMORY_PATH};m.db.on("error",v=>this.o(m,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&m.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},k)})}q(b,y){return new Promise((k,d)=>{b.db.exec(y,m=>m?(this.o(b,`[storage ${this.c}] exec(): ${m}`),d(m)):k())})}r(b,y){return new Promise((k,d)=>{b.db.get(y,(m,v)=>m?(this.o(b,`[storage ${this.c}] get(): ${m}`),d(m)):k(v))})}s(b,y){return new Promise((k,d)=>{b.db.all(y,(m,v)=>m?(this.o(b,`[storage ${this.c}] all(): ${m}`),d(m)):k(v))})}t(b,y){return new Promise((k,d)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),y(),b.db.run("END TRANSACTION",m=>m?(this.o(b,`[storage ${this.c}] transaction(): ${m}`),d(m)):k())})})}u(b,y,k,d){const m=b.db.prepare(y),v=w=>{this.o(b,`[storage ${this.c}] prepare(): ${w} (${y}). Details: ${d()}`)};m.on("error",v),k(m),m.finalize(w=>{w&&v(w),m.removeListener("error",v)})}}e.$pW=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[h.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(ae[164],ce([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(ae[165],ce([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[166],ce([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[167],ce([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ae[168],ce([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[169],ce([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[170],ce([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ae[171],ce([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ae[172],ce([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[173],ce([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[174],ce([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[175],ce([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[176],ce([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[177],ce([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ae[178],ce([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ae[179],ce([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ae[180],ce([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[181],ce([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[182],ce([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[183],ce([11,10]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(ae[184],ce([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[185],ce([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[186],ce([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ae[187],ce([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ae[188],ce([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[189],ce([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[190],ce([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[191],ce([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[192],ce([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[193],ce([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[194],ce([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[195],ce([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ae[196],ce([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[197],ce([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[198],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oeb=n,e.$peb=R;function n(P){return P&&P.hasOwnProperty("folderUri")}function R(P){return P&&P.hasOwnProperty("workspace")}}),define(ae[199],ce([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=R,e.$g_b=P,e.$h_b=O;function R(A){return typeof A?.backupFolder=="string"}function P(A){let E=[];try{Array.isArray(A.workspaces)&&(E=A.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function O(A){let E=[];try{Array.isArray(A.folders)&&(E=A.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(ae[200],ce([0,1,15,167]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var P;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(P||(e.TokenType=P={}));function O(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const A=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const y=this.d,k=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:k};this.g.push({offset:y,lexeme:k,additionalInfo:b}),this.f.push(d)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const y=this.c.substring(this.d,this.e),k=h.b.get(y);k?this.k(k):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,y=!1,k=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(E);return}const m=this.c.charCodeAt(b);if(y)y=!1;else if(m===47&&!k){b++;break}else m===91?k=!0:m===92?y=!0:m===93&&(k=!1);b++}for(;b<this.c.length&&h.a.has(this.c.charCodeAt(b));)b++;this.e=b;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=h}),define(ae[201],ce([0,1,3,2]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=void 0;class P{constructor(){this.a=new n.$6d,this.b=new n.$6d,this.c=new n.$6d,this.d=new n.$6d}static{this.ChannelName="extensionhostdebugservice"}call(E,h,c){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,h,c){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$so=P;class O extends R.$Tc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,c){this.b.call("attach",[E,h,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$to=O}),define(ae[202],ce([0,1,151,50,13,9,36,19,7]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Qm=b,e.$Rm=y,e.$Om=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,O.$mc)(P.$Ag.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,O.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,n.$Nm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$jc)(this.userDataPath,"logs",d)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Tg)(h.URI.file((0,O.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?h.URI.file((0,O.$jc)(d,"argv.json")):(0,E.$Tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,O.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,O.$kc)(d):(0,O.$hc)((0,O.$jc)(P.$Ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?h.URI.file((0,O.$kc)(d)):h.URI.file((0,O.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,O.$kc)(d);const m=A.env.VSCODE_EXTENSIONS;if(m)return m;const v=A.env.VSCODE_PORTABLE;return v?(0,O.$jc)(v,"extensions"):(0,E.$Tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,O.$hc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?h.URI.parse(d):h.URI.file((0,O.$hc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$Om.test(d))}get extensionLogLevel(){const d=[];for(const m of this.args.log||[]){const v=e.$Om.exec(m);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,E.$Tg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?h.URI.file((0,O.$jc)(d,"policy.json")):(0,E.$Tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,m,v){this.a=d,this.b=m,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Pm=c,ve([R.$Kh],c.prototype,"appRoot",null),ve([R.$Kh],c.prototype,"userHome",null),ve([R.$Kh],c.prototype,"userDataPath",null),ve([R.$Kh],c.prototype,"appSettingsHome",null),ve([R.$Kh],c.prototype,"tmpDir",null),ve([R.$Kh],c.prototype,"cacheHome",null),ve([R.$Kh],c.prototype,"stateResource",null),ve([R.$Kh],c.prototype,"userRoamingDataHome",null),ve([R.$Kh],c.prototype,"userDataSyncHome",null),ve([R.$Kh],c.prototype,"sync",null),ve([R.$Kh],c.prototype,"machineSettingsResource",null),ve([R.$Kh],c.prototype,"workspaceStorageHome",null),ve([R.$Kh],c.prototype,"localHistoryHome",null),ve([R.$Kh],c.prototype,"keyboardLayoutResource",null),ve([R.$Kh],c.prototype,"argvResource",null),ve([R.$Kh],c.prototype,"isExtensionDevelopment",null),ve([R.$Kh],c.prototype,"untitledWorkspacesHome",null),ve([R.$Kh],c.prototype,"builtinExtensionsPath",null),ve([R.$Kh],c.prototype,"extensionsPath",null),ve([R.$Kh],c.prototype,"extensionDevelopmentLocationURI",null),ve([R.$Kh],c.prototype,"extensionDevelopmentKind",null),ve([R.$Kh],c.prototype,"extensionTestsLocationURI",null),ve([R.$Kh],c.prototype,"debugExtensionHost",null),ve([R.$Kh],c.prototype,"logLevel",null),ve([R.$Kh],c.prototype,"extensionLogLevel",null),ve([R.$Kh],c.prototype,"serviceMachineIdResource",null),ve([R.$Kh],c.prototype,"disableTelemetry",null),ve([R.$Kh],c.prototype,"disableWorkspaceTrust",null),ve([R.$Kh],c.prototype,"useInMemorySecretStorage",null),ve([R.$Kh],c.prototype,"policyFile",null);function b(k,d){return y(k["inspect-extensions"],k["inspect-brk-extensions"],5870,d,k.debugId,k.extensionEnvironment)}function y(k,d,m,v,w,$){const u=Number(d||k)||(v?null:m),g=u?!!d:!1;let a;if($)try{a=JSON.parse($)}catch{}return{port:u,break:g,debugId:w,env:a}}}),define(ae[116],ce([0,1,312,4,170]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=void 0,e.$dm=E,e.$em=c,e.$fm=d,e.$gm=m;const O={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$bm=["tunnel","serve-web"],e.$cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,w,$=A){const f=v.find(l=>l.length>0&&l[0]!=="-"),u={},g=["_"],a=[],t={};let o;for(const l in w){const p=w[l];p.type==="subcommand"?l===f&&(o=p):(p.alias&&(u[l]=p.alias),p.type==="string"||p.type==="string[]"?(g.push(l),p.deprecates&&g.push(...p.deprecates)):p.type==="boolean"&&(a.push(l),p.deprecates&&a.push(...p.deprecates)),p.global&&(t[l]=p))}if(o&&f){const l=t;for(const S in o.options)l[S]=o.options[S];const p=v.filter(S=>S!==f),I=$.getSubcommandReporter?$.getSubcommandReporter(f):void 0,j=E(p,l,I);return{[f]:j,_:[]}}const r=n(v,{string:g,boolean:a,alias:u}),i={},s=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in w){const p=w[l];if(p.type==="subcommand")continue;p.alias&&delete s[p.alias];let I=s[l];if(p.deprecates)for(const j of p.deprecates)s.hasOwnProperty(j)&&(I||(I=s[j],I&&$.onDeprecatedOption(j,p.deprecationMessage||(0,P.localize)(38,null,l))),delete s[j]);if(typeof I<"u"){if(p.type==="string[]"){if(Array.isArray(I)||(I=[I]),!p.allowEmptyValue){const j=I.filter(S=>S.length>0);j.length!==I.length&&($.onEmptyValue(l),I=j.length>0?j:void 0)}}else p.type==="string"&&(Array.isArray(I)?(I=I.pop(),$.onMultipleValues(l,I)):!I&&!p.allowEmptyValue&&($.onEmptyValue(l),I=void 0));i[l]=I,p.deprecationMessage&&$.onDeprecatedOption(l,p.deprecationMessage)}delete s[l]}for(const l in s)$.onUnknownOption(l);return i}function h(v,w){let $="";return w.args&&(Array.isArray(w.args)?$=` <${w.args.join("> <")}>`:$=` <${w.args}>`),w.alias?`-${w.alias} --${v}${$}`:`--${v}${$}`}function c(v,w){const $=[];for(const f in v){const u=v[f],g=h(f,u);$.push([g,u.description])}return b($,w)}function b(v,w){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const u=w-f-1,g=[];for(const a of v){const t=a[0],o=k(a[1],u),r=y(f-t.length-2);g.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)g.push(y(f)+o[i])}return g}function y(v){return" ".repeat(v)}function k(v,w){const $=[];for(;v.length;){const f=v.length<w?v.length:v.lastIndexOf(" ",w),u=v.slice(0,f).trim();v=v.slice(f),$.push(u)}return $}function d(v,w,$,f,u){const g=process.stdout.isTTY&&process.stdout.columns||80,a=u?.noInputFiles!==!0?`[${(0,P.localize)(39,null)}...]`:"",t=[`${v} ${$}`];t.push(""),t.push(`${(0,P.localize)(40,null)}: ${w} [${(0,P.localize)(41,null)}]${a}`),t.push(""),u?.noPipe!==!0&&(R.$i?t.push((0,P.localize)(42,null,w)):t.push((0,P.localize)(43,null,w)),t.push(""));const o={},r=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&r.push({command:i,description:s.description});else if(s.description&&s.cat){let l=o[s.cat];l||(o[s.cat]=l={}),l[i]=s}}for(const i in o){const s=i,l=o[s];l&&(t.push(O[s]),t.push(...c(l,g)),t.push(""))}return r.length&&(t.push((0,P.localize)(44,null)),t.push(...b(r.map(i=>[i.command,i.description]),g)),t.push("")),t.join(`
`)}function m(v,w){return`${v||(0,P.localize)(45,null)}
${w||(0,P.localize)(46,null)}
${process.arch}`}}),define(ae[203],ce([0,1,88,201,116]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;class O extends R.$so{constructor(E){super(),this.f=E}call(E,h,c){return h==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,h,c)}async g(E,h){const c=(0,P.$dm)(E,P.$cm);c.debugRenderer=h;const b=c.extensionDevelopmentPath;if(!b)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const k=y.win;if(!k)return{success:!0};const d=k.webContents.debugger;let m=d.isAttached()?1/0:0;const v=(0,n.createServer)(w=>{m++===0&&d.attach();let $=!1;const f=a=>{$||w.write(JSON.stringify(a)+"\0")},u=(a,t,o,r)=>f({method:t,params:o,sessionId:r});k.on("close",()=>{d.removeListener("message",u),w.end(),$=!0}),d.addListener("message",u);let g=Buffer.alloc(0);w.on("data",a=>{g=Buffer.concat([g,a]);for(let t=g.indexOf(0);t!==-1;t=g.indexOf(0)){let o;try{const r=g.slice(0,t).toString("utf8");g=g.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{$=!0,--m===0&&d.detach()})});return await new Promise(w=>v.listen(0,w)),k.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$T_b=O}),define(ae[63],ce([0,1,313,171,116]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=E,e.$im=h,e.$jm=c,e.$km=b;function O(y,k){const d=(u,g)=>{console.warn((0,R.localize)(0,null,u,g))},m=u=>{console.warn((0,R.localize)(1,null,u))},v=(u,g)=>{console.warn((0,R.localize)(2,null,u,g))},w=u=>({onUnknownOption:g=>{P.$bm.includes(u)||console.warn((0,R.localize)(3,null,g,u))},onMultipleValues:d,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:P.$bm.includes(u)?w:void 0}),$={onUnknownOption:u=>{console.warn((0,R.localize)(4,null,u))},onMultipleValues:d,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:w},f=(0,P.$dm)(y,P.$cm,k?$:void 0);return f.goto&&f._.forEach(u=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(u),(0,R.localize)(5,null))),f}function A(y){const k=y.findIndex(d=>!/^-/.test(d));if(k>-1)return[...y.slice(0,k),...y.slice(k+1)]}function E(y){let[,...k]=y;process.env.VSCODE_DEV&&(k=A(k)||[]);const d=!b(process.env);return O(k,d)}function h(y){let[,,...k]=y;return process.env.VSCODE_DEV&&(k=A(k)||[]),O(k,!0)}function c(y,...k){const d=y.indexOf("--");return d===-1?y.push(...k):y.splice(d,0,...k),y}function b(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function J(e,n,R){function P(A,E){const h=O(A,E),c=[h];return e.isAbsolute(h)||c.unshift(R),e.resolve(...c)}function O(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const b=A["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(y,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:P}}if(typeof define=="function")define(ae[204],ce([117,26,36]),function(e,n,R){return J(e,n,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=J(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[91],ce([0,1,26,202,204]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Tm=A,e.$Um=E;class O extends R.$Pm{constructor(c,b){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,b.nameShort)},b)}}e.$Sm=O;function A(h,c){return(0,R.$Rm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}function E(h,c){return(0,R.$Rm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}}),define(ae[205],ce([0,1,46,26,33]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=O;function O(A){const E=(0,P.$og)((0,R.tmpdir)());try{return(0,n.writeFileSync)(E,""),A&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){A&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(ae[206],ce([0,1,12,173]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=P;function P(A,E,h,c){try{O(A,E,h,c)}catch(b){A.error(b?.message??b)}return E}function O(A,E,h,c){const b=(y,k,d)=>{const m=y[k];if((0,n.$Tf)(m)){const v=m,w=v.length;if(w>1&&v[0]==="%"&&v[w-1]==="%"){const $=v.substr(1,w-2);let f=h[$];f===void 0&&c&&(f=c[$]);const u=typeof f=="string"?f:f?.message,g=c?.[$],a=typeof g=="string"?g:g?.message;if(!u){a||A.warn(`[${E.name}]: ${(0,R.localize)(0,null,$)}`);return}if(d&&(k==="title"||k==="category")&&a&&a!==u){const t={value:u,original:a};y[k]=t}else y[k]=u}}else if((0,n.$Vf)(m))for(const v in m)m.hasOwnProperty(v)&&(v==="commands"?b(m,v,!0):b(m,v,d));else if(Array.isArray(m))for(let v=0;v<m.length;v++)b(m,v,d)};for(const y in E)E.hasOwnProperty(y)&&b(E,y)}}),define(ae[207],ce([0,1,19,73,175,208]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=h,e.$rp=c,e.$sp=b,e.$tp=y,e.$up=k,e.$vp=d,e.$wp=m;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h($){return $=$.trim(),$==="*"||A.test($)}function c($){if(!h($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=$.match(A);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function b($){if(!$)return null;const f=$.majorBase,u=$.majorMustEqual,g=$.minorBase;let a=$.minorMustEqual;const t=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if($.preRelease){const i=E.exec($.preRelease);if(i){const[,s,l,p]=i;r=Date.UTC(Number(s),Number(l)-1,Number(p))}}return{majorBase:f,majorMustEqual:u,minorBase:g,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:r}}function y($,f,u){let g;typeof $=="string"?g=b(c($)):g=$;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof u=="string"?t=b(c(u)):t=u,!g||!t)return!1;const o=g.majorBase,r=g.minorBase,i=g.patchBase;let s=t.majorBase,l=t.minorBase,p=t.patchBase;const I=t.notBefore;let j=t.majorMustEqual,S=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:r>l?!0:r<l||a&&a<I?!1:i>=p:(o===1&&s===0&&(!j||!S||!D)&&(s=1,l=0,p=0,j=!0,S=!1,D=!1),o<s?!1:o>s?!j:r<l?!1:r>l?!S:i<p?!1:i>p?!D:!(a&&a<I))}function k($,f,u,g,a){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([R.default.Error,P.localize(0,null)]),t;if(typeof g.name!="string")return t.push([R.default.Error,P.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([R.default.Error,P.localize(2,null,"version")]),t;if(!g.engines)return t.push([R.default.Error,P.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([R.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!w(g.extensionDependencies))return t.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!w(g.activationEvents))return t.push([R.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([R.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([R.default.Error,P.localize(9,null,"main")]),t;{const i=(0,n.$Tg)(u,g.main);(0,n.$Ng)(i,u)||t.push([R.default.Warning,P.localize(10,null,i.path,u.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([R.default.Error,P.localize(11,null,"browser")]),t;{const i=(0,n.$Tg)(u,g.browser);(0,n.$Ng)(i,u)||t.push([R.default.Warning,P.localize(12,null,i.path,u.path)])}}if(!O.valid(g.version))return t.push([R.default.Error,P.localize(13,null)]),t;const o=[];if(!d($,f,g,a,o))for(const i of o)t.push([R.default.Error,i]);return t}function d($,f,u,g,a){return g||typeof u.main>"u"&&typeof u.browser>"u"?!0:v($,f,u.engines.vscode,a)}function m($,f,u){return $==="*"||v(f,u,$)}function v($,f,u,g=[]){const a=b(c(u));if(!a)return g.push(P.localize(14,null,u)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(P.localize(15,null,u)),!1}else if(!a.majorMustEqual)return g.push(P.localize(16,null,u)),!1;return y($,f,a)?!0:(g.push(P.localize(17,null,$,u)),!1)}function w($){if(!Array.isArray($))return!1;for(let f=0,u=$.length;f<u;f++)if(typeof $[f]!="string")return!1;return!0}}),define(ae[209],ce([0,1,17,32]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=P;async function P(O,A,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const b=(await A.readFile(O.serviceMachineIdResource)).value.toString();h=(0,R.$Bg)(b)?b:null}catch{h=null}if(!h){h=(0,R.$Cg)();try{await A.writeFile(O.serviceMachineIdResource,n.$te.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(ae[77],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class n{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$di=n}),define(ae[210],ce([0,1,77]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$cs=O,e.$ds=A;const R=[];var P;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(E,h,c){h instanceof n.$di||(h=new n.$di(h,[],!!c)),R.push([E,h])}function A(){return R}}),define(ae[211],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class n{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Sq=n;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const E=this.lookupOrInsertNode(O),h=this.lookupOrInsertNode(A);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const E of this.a.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let E=this.a.get(A);return E||(E=new n(A,O),this.a.set(A,E)),E}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,E]of this.a)O.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const E=new Set([O]),h=this.c(A,E);if(h)return h}}c(O,A){for(const[E,h]of O.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const c=this.c(h,A);if(c)return c;A.delete(E)}}}e.$Tq=R}),define(ae[6],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e._util=void 0,e.$gi=P,e.$hi=O;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=E})(n||(e._util=n={})),e.$fi=P("instantiationService");function R(A,E,h){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:A,index:h}):(E[n.DI_DEPENDENCIES]=[{id:A,index:h}],E[n.DI_TARGET]=E)}function P(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const E=function(h,c,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,h,b)};return E.toString=()=>A,n.serviceIds.set(A,E),E}function O(A){return A}}),define(ae[78],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0,e.$__b=(0,n.$gi)("auxiliaryWindowsMainService")}),define(ae[64],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=void 0,e.$i_b=(0,n.$gi)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Mi=void 0,e.$Ni=O,e.$Oi=A,e.$Pi=h,e.$Qi=c,e.$Ri=b,e.$Si=y,e.$Ti=k,e.$Ui=m,e.$Vi=v,e.$Wi=w,e.$Mi=(0,P.$gi)("configurationService");function O($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof R.URI)}function A($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof R.URI)}var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function b($,f){const u=Object.create(null);for(const g in $)y(u,g,$[g],f);return u}function y($,f,u,g){const a=f.split("."),t=a.pop();let o=$;for(let r=0;r<a.length;r++){const i=a[r];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=u}catch{g(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}function k($,f){const u=f.split(".");d($,u)}function d($,f){const u=f.shift();if(f.length===0){delete $[u];return}if(Object.keys($).indexOf(u)!==-1){const g=$[u];typeof g=="object"&&!Array.isArray(g)&&(d(g,f),Object.keys(g).length===0&&delete $[u])}}function m($,f,u){function g(o,r){let i=o;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const a=f.split("."),t=g($,a);return typeof t>"u"?u:t}function v($,f,u){Object.keys(f).forEach(g=>{g!=="__proto__"&&(g in $?n.$Vf($[g])&&n.$Vf(f[g])?v($[g],f[g],u):u&&($[g]=f[g]):$[g]=f[g])})}function w($){return $.replace(/[\[\]]/g,"")}}),define(ae[118],ce([0,1,4,25,200,6,166,15]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$ej=e.$dj=e.ContextKeyExprType=void 0,e.$cj=c,e.$fj=o,e.$gj=r,e.$zj=q;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.$j),h.set("isLinux",n.$k),h.set("isWindows",n.$i),h.set("isWeb",n.$o),h.set("isMacNative",n.$j&&!n.$o),h.set("isEdge",n.$H),h.set("isFirefox",n.$F),h.set("isChrome",n.$E),h.set("isSafari",n.$G);function c(K,C){if(h.get(K)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(K,C)}const b=Object.prototype.hasOwnProperty;var y;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const k={regexParsingWithErrorRecovery:!0},d=(0,A.localize)(0,null),m=(0,A.localize)(1,null),v=(0,A.localize)(2,null),w=(0,A.localize)(3,null),$=(0,A.localize)(4,null),f=(0,A.localize)(5,null),u=(0,A.localize)(6,null),g=(0,A.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=k){this.k=C,this.d=new P.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const Z=this.D(),z=Z.type===17?f:void 0;throw this.h.push({message:$,offset:Z.offset,lexeme:P.$bj.getLexeme(Z),additionalInfo:z}),a.c}return T}catch(T){if(T!==a.c)throw T;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const T=this.o();C.push(T)}return C.length===1?C[0]:t.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const T=this.s();C.push(T)}return C.length===1?C[0]:t.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,w),T?.negate()}case 17:return this.z(),M.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const T=this.l();return this.A(1,w),T}case 17:{const T=C.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const X=z.lexeme,V=X.lastIndexOf("/"),_=V===X.length-1?void 0:this.w(X.substring(V+1));let B;try{B=new RegExp(X.substring(1,V),_)}catch{throw this.B("REGEX",z)}return re.create(T,B)}switch(z.type){case 10:case 19:{const X=[z.lexeme];this.z();let V=this.D(),_=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?_++:z.lexeme.charCodeAt(me)===41&&_--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?_++:z.lexeme.charCodeAt(me)===41&&_--}if(_<0)break;X.push(P.$bj.getLexeme(V)),this.z(),V=this.D()}const B=X.join(""),te=B.lastIndexOf("/"),ie=te===B.length-1?void 0:this.w(B.substring(te+1));let de;try{de=new RegExp(B.substring(1,te),ie)}catch{throw this.B("REGEX",z)}return t.regex(T,de)}case 18:{const X=z.lexeme;this.z();let V=null;if(!(0,R.$Te)(X)){const _=X.indexOf("/"),B=X.lastIndexOf("/");if(_!==B&&_>=0){const te=X.slice(_+1,B),ie=X[B+1]==="i"?"i":"";try{V=new RegExp(te,ie)}catch{throw this.B("REGEX",z)}}}if(V===null)throw this.B("REGEX",z);return re.create(T,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const z=this.u();return t.notIn(T,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(T,z);switch(z){case"true":return t.has(T);case"false":return t.not(T);default:return t.equals(T,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(T,z);switch(z){case"true":return t.not(T);case"false":return t.has(T);default:return t.notEquals(T,z)}}case 5:return this.z(),x.create(T,this.u());case 6:return this.z(),le.create(T,this.u());case 7:return this.z(),F.create(T,this.u());case 8:return this.z(),H.create(T,this.u());case 13:return this.z(),t.in(T,this.u());default:return t.has(T)}}case 20:throw this.h.push({message:u,offset:C.offset,lexeme:"",additionalInfo:g}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,T){if(this.C(C))return this.z();throw this.B(T,this.D())}B(C,T,Z){const z=(0,A.localize)(8,null,C,P.$bj.getLexeme(T)),X=T.offset,V=P.$bj.getLexeme(T);return this.h.push({message:z,offset:X,lexeme:V,additionalInfo:Z}),a.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=a;class t{static false(){return s.INSTANCE}static true(){return l.INSTANCE}static has(C){return p.create(C)}static equals(C,T){return I.create(C,T)}static notEquals(C,T){return D.create(C,T)}static regex(C,T){return re.create(C,T)}static in(C,T){return j.create(C,T)}static notIn(C,T){return S.create(C,T)}static not(C){return M.create(C)}static and(...C){return Y.create(C,null,!0)}static or(...C){return U.create(C,null,!0)}static greater(C,T){return F.create(C,T)}static greaterEquals(C,T){return H.create(C,T)}static smaller(C,T){return x.create(C,T)}static smallerEquals(C,T){return le.create(C,T)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.$ej=t;function o(K){const C=new a({regexParsingWithErrorRecovery:!1});return K.map(T=>(C.parse(T),C.lexingErrors.length>0?C.lexingErrors.map(Z=>({errorMessage:Z.additionalInfo?(0,A.localize)(9,null,Z.additionalInfo):(0,A.localize)(10,null),offset:Z.offset,length:Z.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(Z=>({errorMessage:Z.additionalInfo?`${Z.message}. ${Z.additionalInfo}`:Z.message,offset:Z.offset,length:Z.lexeme.length})):[]))}function r(K,C){const T=K?K.substituteConstants():void 0,Z=C?C.substituteConstants():void 0;return!T&&!Z?!0:!T||!Z?!1:T.equals(Z)}function i(K,C){return K.cmp(C)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return l.INSTANCE}}e.$hj=s;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return s.INSTANCE}}e.$ij=l;class p{static create(C,T=null){const Z=h.get(C);return typeof Z=="boolean"?Z?l.INSTANCE:s.INSTANCE:new p(C,T)}constructor(C,T){this.key=C,this.c=T,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:N(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=h.get(this.key);return typeof C=="boolean"?C?l.INSTANCE:s.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$jj=p;class I{static create(C,T,Z=null){if(typeof T=="boolean")return T?p.create(C,Z):M.create(C,Z);const z=h.get(C);return typeof z=="boolean"?T===(z?"true":"false")?l.INSTANCE:s.INSTANCE:new I(C,T,Z)}constructor(C,T,Z){this.c=C,this.d=T,this.f=Z,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:G(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=h.get(this.c);if(typeof C=="boolean"){const T=C?"true":"false";return this.d===T?l.INSTANCE:s.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$kj=I;class j{static create(C,T){return new j(C,T)}constructor(C,T){this.d=C,this.f=T,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:G(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const T=C.getValue(this.f),Z=C.getValue(this.d);return Array.isArray(T)?T.includes(Z):typeof Z=="string"&&typeof T=="object"&&T!==null?b.call(T,Z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$lj=j;class S{static create(C,T){return new S(C,T)}constructor(C,T){this.d=C,this.f=T,this.type=11,this.c=j.create(C,T)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=S;class D{static create(C,T,Z=null){if(typeof T=="boolean")return T?M.create(C,Z):p.create(C,Z);const z=h.get(C);return typeof z=="boolean"?T===(z?"true":"false")?s.INSTANCE:l.INSTANCE:new D(C,T,Z)}constructor(C,T,Z){this.c=C,this.d=T,this.f=Z,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:G(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=h.get(this.c);if(typeof C=="boolean"){const T=C?"true":"false";return this.d===T?s.INSTANCE:l.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$nj=D;class M{static create(C,T=null){const Z=h.get(C);return typeof Z=="boolean"?Z?s.INSTANCE:l.INSTANCE:new M(C,T)}constructor(C,T){this.c=C,this.d=T,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:N(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=h.get(this.c);return typeof C=="boolean"?C?s.INSTANCE:l.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$oj=M;function W(K,C){if(typeof K=="string"){const T=parseFloat(K);isNaN(T)||(K=T)}return typeof K=="string"||typeof K=="number"?C(K):s.INSTANCE}class F{static create(C,T,Z=null){return W(T,z=>new F(C,z,Z))}constructor(C,T,Z){this.c=C,this.d=T,this.f=Z,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:G(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$pj=F;class H{static create(C,T,Z=null){return W(T,z=>new H(C,z,Z))}constructor(C,T,Z){this.c=C,this.d=T,this.f=Z,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:G(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$qj=H;class x{static create(C,T,Z=null){return W(T,z=>new x(C,z,Z))}constructor(C,T,Z){this.c=C,this.d=T,this.f=Z,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:G(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$rj=x;class le{static create(C,T,Z=null){return W(T,z=>new le(C,z,Z))}constructor(C,T,Z){this.c=C,this.d=T,this.f=Z,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:G(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$sj=le;class re{static create(C,T){return new re(C,T)}constructor(C,T){this.d=C,this.f=T,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const T=this.f?this.f.source:"",Z=C.f?C.f.source:"";return T<Z?-1:T>Z?1:0}equals(C){if(C.type===this.type){const T=this.f?this.f.source:"",Z=C.f?C.f.source:"";return this.d===C.d&&T===Z}return!1}substituteConstants(){return this}evaluate(C){const T=C.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$tj=re;class ue{static create(C){return new ue(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new ue(this.c.map(C))}negate(){return this.c}}e.$uj=ue;function Q(K){let C=null;for(let T=0,Z=K.length;T<Z;T++){const z=K[T].substituteConstants();if(K[T]!==z&&C===null){C=[];for(let X=0;X<T;X++)C[X]=K[X]}C!==null&&(C[T]=z)}return C===null?K:C}class Y{static create(C,T,Z){return Y.d(C,T,Z)}constructor(C,T){this.expr=C,this.c=T,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let T=0,Z=this.expr.length;T<Z;T++){const z=i(this.expr[T],C.expr[T]);if(z!==0)return z}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let T=0,Z=this.expr.length;T<Z;T++)if(!this.expr[T].equals(C.expr[T]))return!1;return!0}return!1}substituteConstants(){const C=Q(this.expr);return C===this.expr?this:Y.create(C,this.c,!1)}evaluate(C){for(let T=0,Z=this.expr.length;T<Z;T++)if(!this.expr[T].evaluate(C))return!1;return!0}static d(C,T,Z){const z=[];let X=!1;for(const V of C)if(V){if(V.type===1){X=!0;continue}if(V.type===0)return s.INSTANCE;if(V.type===6){z.push(...V.expr);continue}z.push(V)}if(z.length===0&&X)return l.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];for(;z.length>1;){const V=z[z.length-1];if(V.type!==9)break;z.pop();const _=z.pop(),B=z.length===0,te=U.create(V.expr.map(ie=>Y.create([ie,_],null,Z)),null,B);te&&(z.push(te),z.sort(i))}if(z.length===1)return z[0];if(Z){for(let V=0;V<z.length;V++)for(let _=V+1;_<z.length;_++)if(z[V].negate().equals(z[_]))return s.INSTANCE;if(z.length===1)return z[0]}return new Y(z,T)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const T of this.expr)C.push(...T.keys());return C}map(C){return new Y(this.expr.map(T=>T.map(C)),null)}negate(){if(!this.c){const C=[];for(const T of this.expr)C.push(T.negate());this.c=U.create(C,this,!0)}return this.c}}e.$vj=Y;class U{static create(C,T,Z){return U.d(C,T,Z)}constructor(C,T){this.expr=C,this.c=T,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let T=0,Z=this.expr.length;T<Z;T++){const z=i(this.expr[T],C.expr[T]);if(z!==0)return z}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let T=0,Z=this.expr.length;T<Z;T++)if(!this.expr[T].equals(C.expr[T]))return!1;return!0}return!1}substituteConstants(){const C=Q(this.expr);return C===this.expr?this:U.create(C,this.c,!1)}evaluate(C){for(let T=0,Z=this.expr.length;T<Z;T++)if(this.expr[T].evaluate(C))return!0;return!1}static d(C,T,Z){let z=[],X=!1;if(C){for(let V=0,_=C.length;V<_;V++){const B=C[V];if(B){if(B.type===0){X=!0;continue}if(B.type===1)return l.INSTANCE;if(B.type===9){z=z.concat(B.expr);continue}z.push(B)}}if(z.length===0&&X)return s.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];if(Z){for(let V=0;V<z.length;V++)for(let _=V+1;_<z.length;_++)if(z[V].negate().equals(z[_]))return l.INSTANCE;if(z.length===1)return z[0]}return new U(z,T)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const T of this.expr)C.push(...T.keys());return C}map(C){return new U(this.expr.map(T=>T.map(C)),null)}negate(){if(!this.c){const C=[];for(const T of this.expr)C.push(T.negate());for(;C.length>1;){const T=C.shift(),Z=C.shift(),z=[];for(const X of he(T))for(const V of he(Z))z.push(Y.create([X,V],null,!1));C.unshift(U.create(z,null,!1))}this.c=U.create(C,this,!0)}return this.c}}e.$wj=U;class L extends p{static{this.d=[]}static all(){return L.d.values()}constructor(C,T,Z){super(C,null),this.f=T,typeof Z=="object"?L.d.push({...Z,key:C}):Z!==!0&&L.d.push({key:C,description:Z,type:T!=null?typeof T:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return I.create(this.key,C)}notEqualsTo(C){return D.create(this.key,C)}}e.$xj=L,e.$yj=(0,O.$gi)("contextKeyService");function N(K,C){return K<C?-1:K>C?1:0}function G(K,C,T,Z){return K<T?-1:K>T?1:C<Z?-1:C>Z?1:0}function q(K,C){if(K.type===0||C.type===1)return!0;if(K.type===9)return C.type===9?oe(K.expr,C.expr):!1;if(C.type===9){for(const T of C.expr)if(q(K,T))return!0;return!1}if(K.type===6){if(C.type===6)return oe(C.expr,K.expr);for(const T of K.expr)if(q(T,C))return!0;return!1}return K.equals(C)}function oe(K,C){let T=0,Z=0;for(;T<K.length&&Z<C.length;){const z=K[T].cmp(C[Z]);if(z<0)return!1;z===0&&T++,Z++}return T===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(ae[92],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$Zm=e.ID=void 0,e.$1m=R,e.ID="diagnosticsService",e.$Zm=(0,n.$gi)(e.ID);function R(O){return!!O.hostName&&!!O.errorMessage}class P{async getPerformanceInfo(A,E){return{}}async getSystemInfo(A,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,E){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$2m=P}),define(ae[119],ce([0,1,19,73,168,6,47,4,35]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$ow=e.$nw=e.$mw=void 0,e.$pw=d,e.$qw=m,e.$mw=(0,O.$gi)("dialogService");var c;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(c||(c={}));class b{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,$){const f=[];switch($){case c.Confirmation:{const u=w;u.primaryButton?f.push(u.primaryButton):f.push((0,P.localize)(0,null)),u.cancelButton?f.push(u.cancelButton):f.push((0,P.localize)(1,null));break}case c.Prompt:{const u=w;Array.isArray(u.buttons)&&u.buttons.length>0&&f.push(...u.buttons.map(g=>g.label)),u.cancelButton&&(u.cancelButton===!0?f.push((0,P.localize)(2,null)):typeof u.cancelButton=="string"?f.push(u.cancelButton):u.cancelButton.label?f.push(u.cancelButton.label):f.push((0,P.localize)(3,null))),f.length===0&&f.push((0,P.localize)(4,null));break}case c.Input:{const u=w;u.primaryButton?f.push(u.primaryButton):f.push((0,P.localize)(5,null)),u.cancelButton?f.push(u.cancelButton):f.push((0,P.localize)(6,null));break}}return f}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===R.default.Info?"info":w===R.default.Error?"error":w===R.default.Warning?"warning":"none"}f(w,$,f){const u=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&u.push(w.cancelButton);let g=u[$]?.run({checkboxChecked:f});return g instanceof Promise||(g=Promise.resolve(g)),{result:g,checkboxChecked:f}}}e.$nw=b,e.$ow=(0,O.$gi)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const k=10;function d(v){const w=[];return w.push(...v.slice(0,k).map($=>typeof $=="string"?$:(0,n.$Qg)($))),v.length>k&&(v.length-k===1?w.push((0,P.localize)(7,null)):w.push((0,P.localize)(8,null,v.length-k))),w.push(""),w.join(`
`)}function m(v,w){const $=(0,h.$Mn)(v);let f=($.buttons??[]).map(t=>(0,A.$jw)(t)),u=(v.buttons||[]).map((t,o)=>o),g=0,a=$.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=u[a];u.splice(a,1),u.splice(1,0,o),a=1}E.$k&&f.length>1&&(f=f.reverse(),u=u.reverse(),g=f.length-1,typeof t=="string"&&(a=g-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=u[a];u.splice(a,1),u.push(o),a=f.length-1}}return $.buttons=f,$.defaultId=g,$.cancelId=a,$.noLink=!0,$.title=$.title||w.nameLong,{options:$,buttonIndeces:u}}}),define(ae[120],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$FW=e.$EW=void 0,e.$GW=O,e.$HW=A,e.$EW=(0,n.$gi)("encryptionService"),e.$FW=(0,n.$gi)("encryptionMainService");var R;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var P;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function O(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function A(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(ae[38],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,n.$gi)("environmentService"),e.$oi=(0,n.$hi)(e.$ni)}),define(ae[121],ce([0,1,172,6]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.ExtensionGalleryErrorCode=e.$Qo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Po=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0,e.$Jo=P,e.$Ko=O,e.$Lo=A,e.$Mo=E,e.$No=h,e.$Oo=c,e.$Do="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Eo=new RegExp(e.$Do),e.$Fo="__web_extension",e.$Go="skipWalkthrough",e.$Ho="extensionsSync",e.$Io="dependecyOrPackExtensionInstall";function P(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(u,g){return g==="web"&&!u.includes("web")}function h(u,g,a){return E(g,a)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===a}function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var k;(function(u){u.Install="install",u.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Po=(0,R.$gi)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Unknown="Unknown",u.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var v;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class w extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.$Qo=w;var $;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.$Ro=f,e.$So=(0,R.$gi)("extensionManagementService"),e.$To="extensionsIdentifiers/disabled",e.$Uo="extensionsIdentifiers/enabled",e.$Vo=(0,R.$gi)("IGlobalExtensionEnablementService"),e.$Wo=(0,R.$gi)("IExtensionTipsService"),e.$Xo=(0,n.localize2)(0,"Extensions"),e.$Yo=(0,n.localize2)(1,"Preferences")}),define(ae[212],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2_b=e.$1_b=void 0,e.$1_b=(0,n.$gi)("extensionHostStarter"),e.$2_b="extensionHostStarter"}),define(ae[213],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=e.$44b=void 0,e.$44b=(0,n.$gi)("externalTerminal"),e.$54b="Terminal.app"}),define(ae[214],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=void 0,e.$4_b=(0,n.$gi)("externalTerminal")}),define(ae[215],ce([0,1,48,50,13,9,4,75,21,90,176,213]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=e.$5_b=void 0;const k=b.localize(0,null);class d{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends d{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$$l(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=O.$nc(i,".exe").toLowerCase();if(s==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),s==="wt"&&l.push("-d ."),new Promise((p,I)=>{const j=$(process),S=a.spawn(o,l,{cwd:r,env:j,detached:!0});S.on("error",I),S.on("exit",()=>p())})}async runInTerminal(a,t,o,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),l=await m.f();return new Promise((p,I)=>{const j=`"${t} - ${k}"`,S=`"${o.join('" "')}" & pause`,D=Object.assign({},$(process),r);Object.keys(D).filter(x=>D[x]===null).forEach(x=>delete D[x]);const M={cwd:t,env:D,windowsVerbatimArguments:!0};let W,F;O.$nc(s,".exe")==="wt"?(W=s,F=["-d",".",m.b,"/c",S]):l?(W=l,F=["-d",".",s,"/c",S]):(W=m.b,F=["/c","start",j,"/wait",s,"/c",`"${S}"`]),n.spawn(W,F,M).on("error",x=>{I(f(x))}),p(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$5_b=m,ve([R.$Kh],m,"f",null);class v extends d{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.osxExec||y.$54b;return new Promise((l,p)=>{if(s===y.$54b||s==="iTerm.app"){const I=s===y.$54b?"TerminalHelper":"iTermHelper",S=[P.$Ag.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",a||k,"-w",t];for(const W of o)S.push("-a"),S.push(W);if(r){const W=Object.assign({},$(process),r);for(const F in W){const H=W[F];H===null?(S.push("-u"),S.push(F)):(S.push("-e"),S.push(`${F}=${H}`))}}let D="";const M=n.spawn(v.b,S);M.on("error",W=>{p(f(W))}),M.stderr.on("data",W=>{D+=W.toString()}),M.on("exit",W=>{if(W===0)l(void 0);else if(D){const F=D.split(`
`,1);p(new Error(F[0]))}else p(new Error(b.localize(1,null,I,W)))})}else p(new Error(b.localize(2,null,s)))})}spawnTerminal(a,t,o){const r=t.osxExec||y.$54b;return new Promise((i,s)=>{const l=["-a",r];o&&l.push(o);const p=$(process),I=a.spawn("/usr/bin/open",l,{cwd:o,env:p});I.on("error",s),I.on("exit",()=>i())})}}e.$6_b=v;class w extends d{static{this.b=b.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,p)=>{const I=[];s.then(j=>{j.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const S=`${u(o)}; echo; read -p "${w.b}" -n1;`;I.push(`''${S}''`);const D=Object.assign({},$(process),r);Object.keys(D).filter(H=>D[H]===null).forEach(H=>delete D[H]);const M={cwd:t,env:D};let W="";const F=n.spawn(j,I,M);F.on("error",H=>{p(f(H))}),F.stderr.on("data",H=>{W+=H.toString()}),F.on("exit",H=>{if(H===0)l(void 0);else if(W){const x=W.split(`
`,1);p(new Error(x[0]))}else p(new Error(b.localize(4,null,j,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!A.$k)w.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(l=>{const p=$(process),I=a.spawn(l,[],{cwd:o,env:p});I.on("error",s),I.on("exit",()=>i())})})}}e.$7_b=w;function $(g){const a={...g.env};return(0,E.$9l)(a),a}function f(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(b.localize(5,null,g.path)):g}function u(g){let a="";for(const t of g)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,178,6,4,13,61]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$fl=e.FileKind=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileOperationResult=e.$0k=e.$9k=e.$8k=e.$6k=e.FileChangeType=e.$5k=e.FileOperation=e.$Yk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Mk=void 0,e.$Nk=k,e.$Ok=v,e.$Pk=$,e.$Qk=f,e.$Rk=u,e.$Sk=g,e.$Tk=a,e.$Uk=t,e.$Vk=o,e.$Wk=r,e.$Xk=i,e.$Zk=p,e.$1k=I,e.$2k=j,e.$3k=S,e.$4k=D,e.$7k=x,e.$gl=U,e.$hl=L,e.$jl=G,e.$Mk=(0,h.$gi)("fileService");function k(q){return q.create===!0}var d;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var m;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function v(q){const oe=q;return!!oe&&typeof oe.onDidChange=="function"}var w;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function $(q){return!!(q.capabilities&2)}function f(q){return!!(q.capabilities&8)}function u(q){return!!(q.capabilities&131072)}function g(q){return!!(q.capabilities&4)}function a(q){return!!(q.capabilities&16)}function t(q){return $(q)?!!(q.capabilities&16384):!1}function o(q){return $(q)?!!(q.capabilities&32768):!1}function r(q){return!!(q.capabilities&65536)}function i(q){return!!(q.capabilities&2048)}var s;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class l extends Error{static create(oe,he){const K=new l(oe.toString(),he);return j(K,he),K}constructor(oe,he){super(oe),this.code=he}}e.$Yk=l;function p(q,oe){return l.create(q,oe)}function I(q){return q||p((0,E.localize)(0,null),s.Unknown)}function j(q,oe){return q.name=oe?`${oe} (FileSystemError)`:"FileSystemError",q}function S(q){if(!q)return s.Unknown;if(q instanceof l)return q.code;const oe=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!oe)return s.Unknown;switch(oe[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function D(q){if(q instanceof le)return q.fileOperationResult;switch(S(q)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var M;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class W{constructor(oe,he,K){this.resource=oe,this.operation=he,this.target=K}isOperation(oe){return this.operation===oe}}e.$5k=W;var F;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class H{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new y.$V(()=>{const K=n.$mi.forUris(()=>this.c);return K.fill(this.rawAdded.map(C=>[C,!0])),K}),this.f=new y.$V(()=>{const K=n.$mi.forUris(()=>this.c);return K.fill(this.rawUpdated.map(C=>[C,!0])),K}),this.g=new y.$V(()=>{const K=n.$mi.forUris(()=>this.c);return K.fill(this.rawDeleted.map(C=>[C,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of oe){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==H.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=H.a):this.b!==void 0&&(this.b=H.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...K){if(!oe)return!1;const C=K.length>0;return!!((!C||K.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!C||K.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!C||K.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$6k=H;function x(q,oe,he){return!q||!oe||q===oe||oe.length>q.length?!1:(oe.charAt(oe.length-1)!==R.sep&&(oe+=R.sep),he?(0,P.$lf)(q,oe):q.indexOf(oe)===0)}class le extends Error{constructor(oe,he,K){super(oe),this.fileOperationResult=he,this.options=K}}e.$8k=le;class re extends le{constructor(oe,he,K,C){super(oe,he,C),this.fileOperationResult=he,this.size=K}}e.$9k=re;class ue extends le{constructor(oe,he,K){super(oe,2,K),this.stat=he}}e.$0k=ue;var Q;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$$k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$_k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$al="files.associations",e.$bl="files.exclude",e.$cl="files.readonlyInclude",e.$dl="files.readonlyExclude",e.$el="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$fl="";function U(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function L(q,oe){if(!oe.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(he=>{const K=oe.onDidChangeFileSystemProviderRegistrations(C=>{C.scheme===q.scheme&&C.added&&(K.dispose(),he())})})}class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(oe){return(0,O.$Xf)(oe)||(oe=0),oe<N.KB?(0,E.localize)(1,null,oe.toFixed(0)):oe<N.MB?(0,E.localize)(2,null,(oe/N.KB).toFixed(2)):oe<N.GB?(0,E.localize)(3,null,(oe/N.MB).toFixed(2)):oe<N.TB?(0,E.localize)(4,null,(oe/N.GB).toFixed(2)):(0,E.localize)(5,null,(oe/N.TB).toFixed(2))}}e.$il=N;function G(q){const oe=typeof q=="string"||q?.scheme===b.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===b.Schemas.file?1024*N.MB:oe?10*N.MB:c.$o?50*N.MB:1024*N.MB}}),define(ae[122],ce([0,1,17,15,179,16]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=A;async function A(b,y,k,d,m,v){let w;try{await E(b,y,k,d,m,v)}catch($){w=$}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&k.error(w),k.end()}}async function E(b,y,k,d,m,v){h(v);const w=await b.open(y,{create:!1});try{h(v);let $=0,f=0,u=m&&typeof m.length=="number"?m.length:void 0,g=n.$te.alloc(Math.min(m.bufferSize,typeof u=="number"?u:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await b.read(w,a,g.buffer,t,g.byteLength-t),a+=f,t+=f,$+=f,typeof u=="number"&&(u-=f),t===g.byteLength&&(await k.write(d(g)),g=n.$te.alloc(Math.min(m.bufferSize,typeof u=="number"?u:m.bufferSize)),t=0);while(f>0&&(typeof u!="number"||u>0)&&h(v)&&c($,m));if(t>0){let o=t;typeof u=="number"&&(o=Math.min(t,u)),k.write(d(g.slice(0,o)))}}catch($){throw(0,O.$1k)($)}finally{await b.close(w)}}function h(b){if(b.isCancellationRequested)throw(0,R.$6)();return!0}function c(b,y){if(typeof y?.limits?.size=="number"&&b>y.limits.size)throw(0,O.$Zk)((0,P.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[65],ce([0,1,108,2,9,4,7,16]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0,e.$tq=h,e.$xq=k,e.$yq=d,e.$zq=m,e.$Aq=v;function h($){return $.recursive===!0}class c extends R.$Tc{static{this.a=5}constructor(f,u,g,a){super(),this.h=f,this.j=u,this.m=g,this.n=a,this.c=this.B(new R.$Uc),this.f=void 0,this.g=0}s(){const f=new R.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(u=>this.h(u))),f.add(this.b.onDidLogMessage(u=>this.j(u))),f.add(this.b.onDidError(u=>this.t(u)))}t(f){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$uq=c;class b extends c{constructor(f,u,g){super(f,u,g,{type:"node.js",restartOnError:!1})}}e.$vq=b;class y extends c{constructor(f,u,g){super(f,u,g,{type:"universal",restartOnError:!0})}}e.$wq=y;function k($){return $.map(f=>({type:f.type,resource:A.URI.revive(f.resource),cId:f.cId}))}function d($){const f=new w;for(const u of $)f.processEvent(u);return f.coalesce()}function m($,f){return typeof f=="string"&&!f.startsWith(n.$9j)&&!(0,P.$ic)(f)?{base:$,pattern:f}:f}function v($,f){const u=[];for(const g of f)u.push((0,n.$ak)(m($,g)));return u}class w{constructor(){this.a=new Set,this.b=new Map}c(f){return O.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const u=this.b.get(this.c(f));let g=!1;if(u){const a=u.type,t=f.type;u.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?g=!0:a===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(u)):a===2&&t===1?u.type=0:a===1&&t===0||(u.type=t)}else g=!0;g&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],u=[];return Array.from(this.a).filter(g=>g.type!==2?(f.push(g),!1):!0).sort((g,a)=>g.resource.fsPath.length-a.resource.fsPath.length).filter(g=>u.some(a=>(0,E.$7k)(g.resource.fsPath,a,!O.$k))?!1:(u.push(g.resource.fsPath),!0)).concat(f)}}}),define(ae[216],ce([0,1,17,51,15,3,2,62,32,16,65]),function(J,e,n,R,P,O,A,E,h,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=e.$DP=void 0,e.$DP="localFilesystem";class y extends A.$Tc{constructor(d,m){super(),this.a=d,this.b=m,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$6d),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$6d),this.onDidWatchError=this.g.event,this.h=(0,h.$Cg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,m){const{buffer:v}=await this.a.call("readFile",[d,m]);return v}readFileStream(d,m,v){const w=(0,E.$he)(f=>n.$te.concat(f.map(u=>n.$te.wrap(u))).buffer),$=new A.$Sc;return $.add(this.a.listen("readFileStream",[d,m])(f=>{if(f instanceof n.$te)w.write(f.buffer);else{if(f==="end")w.end();else{let u;if(f instanceof Error)u=f;else{const g=f;u=(0,c.$Zk)(g.message??(0,R.$4i)(g),g.code??c.FileSystemProviderErrorCode.Unknown)}w.error(u),w.end()}$.dispose()}})),$.add(v.onCancellationRequested(()=>{w.error((0,P.$6)()),w.end(),$.dispose()})),w}writeFile(d,m,v){return this.a.call("writeFile",[d,n.$te.wrap(m),v])}open(d,m){return this.a.call("open",[d,m])}close(d){return this.a.call("close",[d])}async read(d,m,v,w,$){const[f,u]=await this.a.call("read",[d,m,$]);return v.set(f.buffer.slice(0,u),w),u}write(d,m,v,w,$){return this.a.call("write",[d,m,n.$te.wrap(v),w,$])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,m){return this.a.call("delete",[d,m])}rename(d,m,v){return this.a.call("rename",[d,m,v])}copy(d,m,v){return this.a.call("copy",[d,m,v])}cloneFile(d,m){return this.a.call("cloneFile",[d,m])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const m=d;this.f.fire((0,b.$xq)(m))}else{const m=d;this.g.fire(m)}}))}watch(d,m){const v=(0,h.$Cg)();return this.a.call("watch",[this.h,v,d,m]),(0,A.$Rc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$EP=y}),define(ae[217],ce([0,1,46,8,23,33,2,86,9,4,19,7,109,21,65]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,e.$Oq=w;class v extends A.$Tc{static{this.a=100}static{this.b=75}constructor(f,u,g,a){super(),this.m=f,this.n=u,this.r=g,this.s=a,this.c=this.B(new R.$vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new R.$uh(t=>this.z(t),v.b)),this.g=(0,m.$Aq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$Aq)(this.m.path,this.m.includes):void 0,this.j=new P.$de,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const u=await d.Promises.stat(f);this.B(await this.w(f,u.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let u=f.path;try{u=await d.Promises.realpath(f.path),f.path===u&&(u=await(0,k.$Kq)(f.path)??f.path),f.path!==u&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${u})`)}catch{}return u}async w(f,u){if(c.$j&&(0,O.$gg)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const g=new P.$de(this.j.token),a=new A.$Sc;try{const t=y.URI.file(this.m.path),o=(0,h.$nc)(f),r=(0,n.watch)(f);a.add((0,A.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(u)try{for(const l of await d.Promises.readdir(f))i.add(l)}catch(l){this.D(l)}const s=new Map;a.add((0,A.$Rc)(()=>{for(const[,l]of s)l.dispose();s.clear()})),r.on("error",(l,p)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${l}, ${p})`),this.dispose()}),r.on("change",(l,p)=>{if(g.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${p}`);let I="";if(p&&(I=p.toString(),c.$j&&(I=(0,E.$Xl)(I))),!(!I||l!=="change"&&l!=="rename"))if(u)if(l==="rename"){s.get(I)?.dispose();const j=setTimeout(async()=>{if(s.delete(I),I===o&&!await d.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const S=await this.C((0,h.$jc)(f,I));if(g.token.isCancellationRequested)return;let D;S?i.has(I)?D=0:(D=1,i.add(I)):(i.delete(I),D=2),this.y({resource:(0,b.$Tg)(t,I),type:D,cId:this.m.correlationId})},v.a);s.set(I,(0,A.$Rc)(()=>clearTimeout(j)))}else{let j;i.has(I)?j=0:(j=1,i.add(I)),this.y({resource:(0,b.$Tg)(t,I),type:j,cId:this.m.correlationId})}else if(l==="rename"||I!==o){const j=setTimeout(async()=>{const S=await d.Promises.exists(f);g.token.isCancellationRequested||(S?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(f,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},v.a);a.clear(),a.add((0,A.$Rc)(()=>clearTimeout(j)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await d.Promises.exists(f)&&!g.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{g.dispose(!0),a.dispose()})}y(f,u=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!u&&this.g.some(g=>g(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const u=(0,m.$yq)(f);if(u.length>0){if(this.s)for(const a of u)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(c.$k)return d.Promises.exists(f);try{const u=(0,h.$nc)(f);return(await d.Promises.readdir((0,h.$mc)(f))).some(a=>a===u)}catch(u){return this.G(u),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Nq=v;async function w($,f,u,g,a=512){const t=await d.Promises.open($,"r"),o=Buffer.allocUnsafe(a),r=new P.$de(g);let i,s=!1;const l={path:$,excludes:[],recursive:!1},p=new v(l,I=>{(async()=>{for(const{type:j}of I)if(j===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:S}=await d.Promises.read(t,o,0,a,null);if(!S||r.token.isCancellationRequested)break;f(o.slice(0,S))}}catch(S){i=new Error(S),r.dispose(!0)}finally{s=!1}}})()});return await p.ready,u(),new Promise((I,j)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await d.Promises.close(t)}catch(S){i=new Error(S)}i?j(i):I()})})}}),define(ae[218],ce([0,1,3,108,2,4,217]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class E extends P.$Tc{constructor(){super(...arguments),this.a=this.B(new n.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new n.$6d),this.onDidLogMessage=this.b.event,this.onDidError=n.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.j(c),y=b.filter(d=>{const m=this.c.get(d.path);return m?!(0,R.$ek)(m.request.excludes,d.excludes)||!(0,R.$ek)(m.request.includes,d.includes):!0}),k=Array.from(this.c.values()).filter(({request:d})=>!b.find(m=>m.path===d.path&&(0,R.$ek)(m.excludes,d.excludes)&&(0,R.$ek)(m.includes,d.includes))).map(({request:d})=>d.path);y.length&&this.m(`Request to start watching: ${y.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),k.length&&this.m(`Request to stop watching: ${k.join(",")}`);for(const d of k)this.h(d);for(const d of y)this.g(d)}g(c){const b=new A.$Nq(c,k=>this.a.fire(k),k=>this.b.fire(k),this.f),y={request:c,instance:b};this.c.set(c.path,y)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}j(c){const b=new Map;for(const y of c){const k=O.$k?y.path:y.path.toLowerCase();let d=b.get(y.correlationId);d||(d=new Map,b.set(y.correlationId,d)),d.set(k,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$Pq=E}),define(ae[219],ce([0,1,65,218]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class P extends n.$vq{constructor(A,E,h){super(A,E,h),this.s()}r(A){return A.add(new R.$Pq)}}e.$Qq=P}),define(ae[220],ce([0,1,13,43,162,65]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class A extends O.$wq{constructor(h,c,b){super(h,c,b),this.s()}r(h){const c=h.add(new P.$Hq(n.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:b,signal:y})=>this.t(`terminated by itself with code ${b}, signal: ${y}`))),R.ProxyChannel.toService((0,R.$Zh)(c.getChannel("watcher")))}}e.$Iq=A}),define(ae[93],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class n{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$ei=n}),define(ae[221],ce([0,1,8,15,2,77,211,6,93,104]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;const b=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class k{constructor(w=new h.$ei,$=!1,f,u=b){this.f=w,this.g=$,this.h=f,this.i=u,this.o=new Set,this.f.set(E.$fi,this),this._globalGraph=u?f?._globalGraph??new A.$Tq(g=>g):void 0}createChild(w){return new k(w,this.g,this,this.i)}invokeFunction(w,...$){const f=m.traceInvocation(this.i,w);let u=!1;try{return w({get:a=>{if(u)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...$)}finally{u=!0,f.stop()}}createInstance(w,...$){let f,u;return w instanceof O.$di?(f=m.traceCreation(this.i,w.ctor),u=this.j(w.ctor,w.staticArguments.concat($),f)):(f=m.traceCreation(this.i,w),u=this.j(w,$,f)),f.stop(),u}j(w,$=[],f){const u=E._util.getServiceDependencies(w).sort((t,o)=>t.index-o.index),g=[];for(const t of u){const o=this.m(t.id,f);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(o)}const a=u.length>0?u[0].index:$.length;if($.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${$.length} static arguments`);const t=a-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,a)}return Reflect.construct(w,$.concat(g))}k(w,$){if(this.f.get(w)instanceof O.$di)this.f.set(w,$);else if(this.h)this.h.k(w,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const $=this.f.get(w);return!$&&this.h?this.h.l(w):$}m(w,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.l(w);return f instanceof O.$di?this.q(w,f,$.branch(w,!0)):($.branch(w,!1),f)}q(w,$,f){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,$,f)}finally{this.o.delete(w)}}r(w,$,f){const u=new A.$Tq(t=>t.id.toString());let g=0;const a=[{id:w,desc:$,_trace:f}];for(;a.length;){const t=a.pop();if(u.lookupOrInsertNode(t),g++>1e3)throw new y(u);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof O.$di){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};u.insertEdge(t,i),a.push(i)}}}for(;;){const t=u.roots();if(t.length===0){if(!u.isEmpty())throw new y(u);break}for(const{data:o}of t){if(this.l(o.id)instanceof O.$di){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}u.removeNode(o)}}return this.l(w)}s(w,$,f=[],u,g){if(this.f.get(w)instanceof O.$di)return this.t(w,$,f,u,g);if(this.h)return this.h.s(w,$,f,u,g);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(w,$,f=[],u,g){if(u){const a=new k(void 0,this.g,this,this.i);a.c=String(w);const t=new Map,o=new n.$zh(()=>{const r=a.j($,f,g);for(const[i,s]of t){const l=r[i];if(typeof l=="function")for(const p of s)p.disposable=l.apply(r,p.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let p=t.get(i);return p||(p=new c.$4c,t.set(i,p)),(j,S,D)=>{if(o.isInitialized)return o.value[i](j,S,D);{const M={listener:[j,S,D],disposable:void 0},W=p.push(M);return(0,P.$Rc)(()=>{W(),M.disposable?.dispose()})}}}if(i in r)return r[i];const s=o.value;let l=s[i];return typeof l!="function"||(l=l.bind(s),r[i]=l),l},set(r,i,s){return o.value[i]=s,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,f,g)}u(w,$){if($&&console.warn(w),this.g)throw new Error(w)}}e.$Uq=k;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,$){return w?new m(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(w,$){return w?new m(1,$.name):m.c}static{this.f=0}constructor(w,$){this.type=w,this.name=$,this.g=Date.now(),this.h=[]}branch(w,$){const f=new m(3,w.toString());return this.h.push([w,$,f]),f}stop(){const w=Date.now()-this.g;m.f+=w;let $=!1;function f(g,a){const t=[],o=new Array(g+1).join("	");for(const[r,i,s]of a.h)if(i&&s){$=!0,t.push(`${o}CREATES -> ${r}`);const l=f(g+1,s);l&&t.push(l)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(w>2||$)&&m.all.add(u.join(`
`))}}e.$Vq=m}),define(ae[222],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UBb=e.IssueSource=e.IssueType=void 0;var R;(function(O){O[O.Bug=0]="Bug",O[O.PerformanceIssue=1]="PerformanceIssue",O[O.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={}));var P;(function(O){O.VSCode="vscode",O.Extension="extension",O.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$UBb=(0,n.$gi)("issueService")}),define(ae[5],ce([0,1,183,51,3,45,2,31,4,19,12,7,118,6]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Pj=e.LogLevel=e.$Nj=e.$Mj=void 0,e.$Oj=v,e.log=$,e.$1j=p,e.$2j=I,e.$3j=j,e.$4j=S,e.$Mj=(0,d.$gi)("logService"),e.$Nj=(0,d.$gi)("loggerService");function m(){return new Date().toISOString()}function v(D){return(0,b.$Xf)(D)}var w;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Pj=w.Info;function $(D,M,W){switch(M){case w.Trace:D.trace(W);break;case w.Debug:D.debug(W);break;case w.Info:D.info(W);break;case w.Warning:D.warn(W);break;case w.Error:D.error(W);break;case w.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function f(D,M=!1){let W="";for(let F=0;F<D.length;F++){let H=D[F];if(H instanceof Error&&(H=(0,R.$4i)(H,M)),typeof H=="object")try{H=JSON.stringify(H)}catch{}W+=(F>0?" ":"")+H}return W}class u extends A.$Tc{constructor(){super(...arguments),this.b=e.$Pj,this.c=this.B(new P.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==w.Off&&this.b<=M}}e.$Rj=u;class g extends u{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...W){this.f(w.Trace)&&this.g(w.Trace,f([M,...W],!0))}debug(M,...W){this.f(w.Debug)&&this.g(w.Debug,f([M,...W]))}info(M,...W){this.f(w.Info)&&this.g(w.Info,f([M,...W]))}warn(M,...W){this.f(w.Warning)&&this.g(w.Warning,f([M,...W]))}error(M,...W){if(this.f(w.Error))if(M instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=M.stack,this.g(w.Error,f(F))}else this.g(w.Error,f([M,...W]))}flush(){}}e.$Sj=g;class a extends u{constructor(M=e.$Pj){super(),this.setLevel(M),this.g=!h.$i}trace(M,...W){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,M,...W):console.log(`[main ${m()}]`,M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,M,...W):console.log(`[main ${m()}]`,M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,M,...W):console.log(`[main ${m()}]`,M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,M,...W):console.warn(`[main ${m()}]`,M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,M,...W):console.error(`[main ${m()}]`,M,...W))}flush(){}}e.$Tj=a;class t extends u{constructor(M=e.$Pj,W=!0){super(),this.g=W,this.setLevel(M)}trace(M,...W){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...W):console.log(M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...W):console.log(M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...W):console.log(M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...W):console.log(M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...W):console.error(M,...W))}flush(){}}e.$Uj=t;class o extends u{constructor(M,W=e.$Pj){super(),this.g=M,this.setLevel(W)}trace(M,...W){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(M),...W])}debug(M,...W){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(M),...W])}info(M,...W){this.f(w.Info)&&this.g.log(w.Info,[this.h(M),...W])}warn(M,...W){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(M),...W])}error(M,...W){this.f(w.Error)&&this.g.log(w.Error,[this.h(M),...W])}h(M){return typeof M=="string"?M:(0,R.$4i)(M,this.f(w.Trace))}flush(){}}e.$Vj=o;class r extends u{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const W of this.g)W.setLevel(M);super.setLevel(M)}trace(M,...W){for(const F of this.g)F.trace(M,...W)}debug(M,...W){for(const F of this.g)F.debug(M,...W)}info(M,...W){for(const F of this.g)F.info(M,...W)}warn(M,...W){for(const F of this.g)F.warn(M,...W)}error(M,...W){for(const F of this.g)F.error(M,...W)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$Wj=r;class i extends A.$Tc{constructor(M,W,F){if(super(),this.h=M,this.j=W,this.b=new E.$Ac,this.c=this.B(new P.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$6d),this.onDidChangeVisibility=this.g.event,F)for(const H of F)this.b.set(H.resource,{logger:void 0,info:H})}m(M){return(0,b.$Tf)(M)?[...this.b.values()].find(W=>W.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,W){const F=this.n(M),H=(0,b.$Tf)(M)?M:W?.id??(0,O.$7i)(F.toString()).toString(16);let x=this.b.get(F)?.logger;const le=W?.logLevel==="always"?w.Trace:W?.logLevel;x||(x=this.s(F,le??this.getLogLevel(F)??this.h,{...W,id:H}));const re={logger:x,info:{resource:F,id:H,logLevel:le,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(re.info),this.b.set(F,re),x}n(M){return(0,b.$Tf)(M)?(0,c.$Tg)(this.j,`${M}.log`):M}setLogLevel(M,W){if(y.URI.isUri(M)){const F=M,H=W,x=this.b.get(F);x&&H!==x.info.logLevel&&(x.info.logLevel=H===this.h?void 0:H,x.logger?.setLevel(H),this.b.set(x.info.resource,x),this.f.fire([F,H]))}else{this.h=M;for(const[F,H]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,W){const F=this.m(M);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(M){let W;return M&&(W=this.b.get(M)?.info.logLevel),W??this.h}registerLogger(M){const W=this.b.get(M.resource);W?W.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const W=this.b.get(M);W&&(W.logger&&W.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Xj=i;class s{constructor(){this.onDidChangeLogLevel=new P.$6d().event}setLevel(M){}getLevel(){return w.Info}trace(M,...W){}debug(M,...W){}info(M,...W){}warn(M,...W){}error(M,...W){}critical(M,...W){}dispose(){}flush(){}}e.$Yj=s;class l extends s{}e.$Zj=l;function p(D){if(D.verbose)return w.Trace;if(typeof D.logLevel=="string"){const M=S(D.logLevel.toLowerCase());if(M!==void 0)return M}return e.$Pj}function I(D){switch(D){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function j(D){switch(D){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function S(D){switch(D){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$5j=new k.$xj("logLevel",I(w.Info))});var se=this&&this.__param||function(J,e){return function(n,R){e(n,R,J)}};define(ae[223],ce([0,1,14,4,5]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;const O=n.safeStorage;let A=class{constructor(h){this.a=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(O.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const b=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=O.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const h=O.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$Z_b=A,e.$Z_b=A=ve([se(0,P.$Mj)],A)}),define(ae[224],ce([0,1,22,8,15,3,2,9,65,5]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class b extends A.$Tc{constructor(k,d){super(),this.a=k,this.b=d,this.c=this.B(new O.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$eh(0)),this.w=[],this.y=this.B(new R.$eh(0))}watch(k,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(k,d):this.z(k,d)}n(k,d){const m={path:this.H(k),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},v=(0,n.$Ub)(this.j,m);return this.r(),(0,A.$Rc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$1)(k))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,h.$xq)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const d of this.j)(0,h.$tq)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const d of this.j)(0,h.$tq)(d)&&k.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,d){const m={path:this.H(k),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},v=(0,n.$Ub)(this.w,m);return this.C(),(0,A.$Rc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,h.$xq)(k)),k=>this.G(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.a[k.type](k.message)}H(k){return(0,E.$hc)(k.fsPath)}}e.$Bq=b}),define(ae[225],ce([0,1,22,8,17,23,3,45,71,2,59,13,66,19,62,177,16,122,5,15]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;let a=class extends c.$Tc{static{g=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$6d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$6d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$6d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$6d),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$6d),this.Y=this.B(new A.$6d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$6d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$ph)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const i=new c.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(s=>{const l=new w.$6k(s,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return h.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,d.$Xg)(o))throw new w.$8k((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new u.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,w.$Sk)(r)||(0,w.$Pk)(r)||(0,w.$Tk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,w.$Sk)(r)||(0,w.$Pk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,w.$3k)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$8k((0,v.localize)(2,null,this.sb(o)),1):(0,w.$1k)(i)}}async s(o,r){const i=await this.j(o),s=this.S(i),l=r?.resolveTo,p=r?.resolveSingleChildDescendants,I=r?.resolveMetadata,j=await i.stat(o);let S;return this.t(i,o,j,void 0,!!I,(D,M)=>(S||(S=b.$mi.forUris(()=>!s),S.set(o,!0),l&&S.fill(!0,l)),S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&p?M===1:!1))}async t(o,r,i,s,l,p){const{providerExtUri:I}=this.R(o),j={resource:r,name:I.basename(r),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$gl)({mtime:i.mtime,size:i.size}),children:void 0};if(j.isDirectory&&p(j,s)){try{const S=await o.readdir(r),D=await R.Promises.settled(S.map(async([M,W])=>{try{const F=I.joinPath(r,M),H=l?await o.stat(F):{type:W};return await this.t(o,F,H,S.length,l,p)}catch(F){return this.b.trace(F),null}}));j.children=(0,n.$Hb)(D)}catch(S){this.b.trace(S),j.children=[]}return j}return j}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new w.$8k((0,v.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=P.$te.fromString(""),i){await this.u(o,i);const s=await this.writeFile(o,r);return this.r.fire(new w.$5k(o,0,s)),s}async writeFile(o,r,i){const s=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(s);let p=i;if((0,w.$Vk)(s)&&!p?.atomic){const I=s.enforceAtomicWriteFile?.(o);I&&(p={...i,atomic:I})}try{await this.w(s,o,p)||await this.U(s,l.dirname(o));let j;if((0,w.$Pk)(s)&&!(r instanceof P.$te))if((0,m.$fe)(r)){const S=await(0,m.$me)(r,3);S.ended?j=P.$te.concat(S.buffer):j=S}else j=(0,m.$je)(r,S=>P.$te.concat(S),3);else j=r;!(0,w.$Sk)(s)||(0,w.$Pk)(s)&&j instanceof P.$te||(0,w.$Pk)(s)&&(0,w.$Vk)(s)&&p?.atomic?await this.hb(s,o,p,j):await this.db(s,o,p,j instanceof P.$te?(0,P.$Ee)(j):j),this.r.fire(new w.$5k(o,4))}catch(I){throw new w.$8k((0,v.localize)(4,null,this.sb(o),(0,w.$1k)(I).toString()),(0,w.$4k)(I),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const s=!!i?.unlock;if(s&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(r)));if(s)throw new Error((0,v.localize)(8,null,this.sb(r)))}let p;try{p=await o.stat(r)}catch{return}if(p.type&w.FileType.Directory)throw new w.$8k((0,v.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,p),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$fl&&typeof p.mtime=="number"&&typeof p.size=="number"&&i.mtime<p.mtime&&i.etag!==(0,w.$gl)({mtime:i.mtime,size:p.size}))throw new w.$8k((0,v.localize)(10,null),3,i);return p}async readFile(o,r,i){const s=await this.m(o);return r?.atomic?this.z(s,o,r,i):this.C(s,o,r,i)}async z(o,r,i,s){return new Promise((l,p)=>{this.cb.queueFor(r,async()=>{try{const I=await this.C(o,r,i,s);l(I)}catch(I){p(I)}},this.R(o).providerExtUri)})}async C(o,r,i,s){const l=await this.D(o,r,{...i,preferUnbuffered:!0},s);return{...l,value:await(0,P.$Fe)(l.value)}}async readFileStream(o,r,i){const s=await this.m(o);return this.D(s,o,r,i)}async D(o,r,i,s){const l=new O.$de(s);let p=i;(0,w.$Uk)(o)&&o.enforceAtomicReadFile?.(r)&&(p={...i,atomic:!0});const I=this.J(r,p).then(S=>S,S=>{throw l.dispose(!0),S});let j;try{return typeof p?.etag=="string"&&p.etag!==w.$fl&&await I,p?.atomic&&(0,w.$Uk)(o)||!((0,w.$Sk)(o)||(0,w.$Tk)(o))||(0,w.$Pk)(o)&&p?.preferUnbuffered?j=this.I(o,r,p):(0,w.$Tk)(o)?j=this.G(o,r,l.token,p):j=this.H(o,r,l.token,p),j.on("end",()=>l.dispose()),j.on("error",()=>l.dispose()),{...await I,value:j}}catch(S){throw j&&await(0,m.$ke)(j),this.F(S,r,p)}}F(o,r,i){const s=(0,v.localize)(11,null,this.sb(r),(0,w.$1k)(o).toString());return o instanceof w.$0k?new w.$0k(s,o.stat,i):o instanceof w.$9k?new w.$9k(s,o.fileOperationResult,o.size,o.options):new w.$8k(s,(0,w.$4k)(o),i)}G(o,r,i,s=Object.create(null)){const l=o.readFileStream(r,s,i);return(0,m.$qe)(l,{data:p=>p instanceof P.$te?p:P.$te.wrap(p),error:p=>this.F(p,r,s)},p=>P.$te.concat(p))}H(o,r,i,s=Object.create(null)){const l=(0,P.$Je)();return(0,$.$rq)(o,r,l,p=>p,{...s,bufferSize:this.a,errorTransformer:p=>this.F(p,r,s)},i),l}I(o,r,i){const s=(0,m.$he)(l=>P.$te.concat(l));return(async()=>{try{let l;i?.atomic&&(0,w.$Uk)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(r,l.byteLength,i),s.end(P.$te.wrap(l))}catch(l){s.error(l),s.end()}})(),s}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.$8k((0,v.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$fl&&r.etag===i.etag)throw new w.$0k((0,v.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new w.$9k((0,v.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,s){if(o.toString()!==r.toString())try{const l=i==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(r),r);await this.Q(l,o,p,r,i,s)}catch(l){return l}return!0}async move(o,r,i){const s=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),p=await this.N(s,o,l,r,"move",!!i),I=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$5k(o,p==="move"?2:3,I)),I}async copy(o,r,i){const s=await this.m(o),l=this.qb(await this.n(r),r),p=await this.N(s,o,l,r,"copy",!!i),I=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$5k(o,p==="copy"?3:2,I)),I}async N(o,r,i,s,l,p){if(r.toString()===s.toString())return l;const{exists:I,isSameResourceWithDifferentPathCase:j}=await this.Q(o,r,i,s,l,p);if(I&&!j&&p&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),l==="copy"){if(o===i&&(0,w.$Qk)(o))await o.copy(r,s,{overwrite:p});else{const S=await this.resolve(r);S.isDirectory?await this.P(o,S,i,s):await this.O(o,r,i,s)}return l}else return o===i?(await o.rename(r,s,{overwrite:p}),l):(await this.N(o,r,i,s,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,s){if((0,w.$Sk)(o)&&(0,w.$Sk)(i))return this.jb(o,r,i,s);if((0,w.$Sk)(o)&&(0,w.$Pk)(i))return this.pb(o,r,i,s);if((0,w.$Pk)(o)&&(0,w.$Sk)(i))return this.nb(o,r,i,s);if((0,w.$Pk)(o)&&(0,w.$Pk)(i))return this.lb(o,r,i,s)}async P(o,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async l=>{const p=this.R(i).providerExtUri.joinPath(s,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),i,p):this.O(o,l.resource,i,p)}))}async Q(o,r,i,s,l,p){let I=!1;if(o===i){const{providerExtUri:S,isPathCaseSensitive:D}=this.R(o);if(D||(I=S.isEqual(r,s)),I&&l==="copy")throw new Error((0,v.localize)(15,null,this.sb(r),this.sb(s)));if(!I&&S.isEqualOrParent(s,r))throw new Error((0,v.localize)(16,null,this.sb(r),this.sb(s)))}const j=await this.exists(s);if(j&&!I){if(!p)throw new w.$8k((0,v.localize)(17,null,this.sb(r),this.sb(s)),4);if(o===i){const{providerExtUri:S}=this.R(o);if(S.isEqualOrParent(r,s))throw new Error((0,v.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:j,isSameResourceWithDifferentPathCase:I}}R(o){const r=this.S(o);return{providerExtUri:r?d.$Jg:d.$Lg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$5k(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:s}=this.R(o);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&w.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(r)));break}catch(l){if((0,w.$3k)(l)!==w.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(s.basename(r)),r=s.dirname(r)}for(let l=i.length-1;l>=0;l--){r=s.joinPath(r,i[l]);try{await o.mkdir(r)}catch(p){if((0,w.$3k)(p)!==w.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),s=!!r?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(s&&l)throw new Error((0,v.localize)(22,null,this.sb(o)));let p;try{p=await i.stat(o)}catch{}if(p)this.rb(o,p);else throw new w.$8k((0,v.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const j=await this.resolve(o);if(j.isDirectory&&Array.isArray(j.children)&&j.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let s=r;if((0,w.$Wk)(i)&&!s?.atomic){const j=i.enforceAtomicDelete?.(o);j&&(s={...r,atomic:j})}const l=!!s?.useTrash,p=!!s?.recursive,I=s?.atomic??!1;await i.delete(o,{recursive:p,useTrash:l,atomic:I}),this.r.fire(new w.$5k(o,1))}async cloneFile(o,r){const i=await this.j(o),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(o,r)))return i===s&&(0,w.$Rk)(i)?i.cloneFile(o,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,w.$Qk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:g.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new c.$Sc;let s=!1,l=()=>{s=!0};i.add((0,c.$Rc)(()=>l())),(async()=>{try{const I=await this.bb(o,r);s?(0,c.$Oc)(I):l=()=>(0,c.$Oc)(I)}catch(I){this.b.error(I)}})();const p=r.correlationId;if(typeof p=="number"){const I=i.add(new A.$6d);return i.add(this.X.event(S=>{S.correlates(p)&&I.fire(S)})),{onDidChange:I.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),s=(0,E.$7i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(s);return l||(l={count:0,disposable:i.watch(o,r)},this.$.set(s,l)),l.count+=1,(0,c.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Oc)(l.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,s){return this.cb.queueFor(r,async()=>{const l=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$fe)(s)||(0,m.$ge)(s)?await this.eb(o,l,s):await this.fb(o,l,s)}catch(p){throw(0,w.$1k)(p)}finally{await o.close(l)}},this.R(o).providerExtUri)}async eb(o,r,i){let s=0,l;if((0,m.$ge)(i)){if(i.buffer.length>0){const p=P.$te.concat(i.buffer);await this.gb(o,r,p,p.byteLength,s,0),s+=p.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((p,I)=>{(0,m.$le)(l,{onData:async j=>{l.pause();try{await this.gb(o,r,j,j.byteLength,s,0)}catch(S){return I(S)}s+=j.byteLength,setTimeout(()=>l.resume())},onError:j=>I(j),onEnd:()=>p()})})}async fb(o,r,i){let s=0,l;for(;(l=i.read())!==null;)await this.gb(o,r,l,l.byteLength,s,0),s+=l.byteLength}async gb(o,r,i,s,l,p){let I=0;for(;I<s;){const j=await o.write(r,l+I,i.buffer,p+I,s-I);I+=j}}async hb(o,r,i,s){return this.cb.queueFor(r,()=>this.ib(o,r,i,s),this.R(o).providerExtUri)}async ib(o,r,i,s){let l;s instanceof P.$te?l=s:(0,m.$fe)(s)?l=await(0,P.$Fe)(s):(0,m.$ge)(s)?l=await(0,P.$Ge)(s):l=(0,P.$De)(s),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,s){return this.cb.queueFor(s,()=>this.kb(o,r,i,s),this.R(i).providerExtUri)}async kb(o,r,i,s){let l,p;try{l=await o.open(r,{create:!1}),p=await i.open(s,{create:!0,unlock:!1});const I=P.$te.alloc(this.a);let j=0,S=0,D=0;do D=await o.read(l,j,I.buffer,S,I.byteLength-S),await this.gb(i,p,I,D,j,S),j+=D,S+=D,S===I.byteLength&&(S=0);while(D>0)}catch(I){throw(0,w.$1k)(I)}finally{await R.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof p=="number"?i.close(p):Promise.resolve()])}}async lb(o,r,i,s){return this.cb.queueFor(s,()=>this.mb(o,r,i,s),this.R(i).providerExtUri)}async mb(o,r,i,s){return i.writeFile(s,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,s){return this.cb.queueFor(s,()=>this.ob(o,r,i,s),this.R(i).providerExtUri)}async ob(o,r,i,s){const l=await i.open(s,{create:!0,unlock:!1});try{const p=await o.readFile(r);await this.gb(i,l,P.$te.wrap(p),p.byteLength,0,0)}catch(p){throw(0,w.$1k)(p)}finally{await i.close(l)}}async pb(o,r,i,s){const l=await(0,P.$Fe)(this.H(o,r,O.CancellationToken.None));await this.hb(i,s,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new w.$8k((0,v.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$8k((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$sq=a,e.$sq=a=g=ve([se(0,f.$Mj)],a)}),define(ae[94],ce([0,1,46,314,8,31,17,3,33,2,9,4,19,62,21,181,16,122,224,51,220,219]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,(()=>{try{(0,R.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,u.$4i)(o)}`)}})();class t extends f.$Bq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.N=new O.$Ac(s=>k.$Kg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async l=>{try{let p;l.isSymbolicLink()?p=(await this.stat((0,k.$Tg)(r,l.name))).type:p=this.M(l),s.push([l.name,p])}catch(p){this.a.trace(p)}})),s}catch(i){throw this.fb(i)}}M(r,i){let s;return i?.dangling?s=w.FileType.Unknown:r.isFile()?s=w.FileType.File:r.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,i&&(s|=w.FileType.SymbolicLink),s}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const l=new P.$fh;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),s=await this.O(r));const l=this.H(r);return await m.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{s?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,s){const l=(0,d.$he)(p=>A.$te.concat(p.map(I=>A.$te.wrap(I))).buffer);return(0,$.$rq)(this,r,l,p=>p.buffer,{...i,bufferSize:256*1024},s),l}async writeFile(r,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,k.$Tg)((0,k.$Sg)(r),`${(0,k.$Qg)(r)}${s.atomic.postfix}`),i,s):this.S(r,i,s)}async Q(r){try{const i=this.H(r),{symbolicLink:s}=await m.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(r,i,s,l){const p=new c.$Sc;try{p.add(await this.O(r)),p.add(await this.O(i)),await this.S(i,s,l,!0);try{await this.rename(i,r,{overwrite:!0})}catch(I){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{p.dispose()}}async S(r,i,s,l){let p;try{const I=this.H(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(I)){if(!s.overwrite)throw(0,w.$Zk)((0,v.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.$Zk)((0,v.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:s.unlock},l),await this.write(p,0,i,0,i.byteLength)}catch(I){throw await this.gb(r,I)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,s){const l=this.H(r);let p;(0,w.$Nk)(i)&&!s&&(p=await this.O(r));let I;try{if((0,w.$Nk)(i)&&i.unlock)try{const{stat:S}=await m.SymlinkSupport.stat(l);S.mode&128||await m.Promises.chmod(l,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let j;if((0,w.$Nk)(i)){if(y.$i)try{await m.Promises.truncate(l,0),j="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}j||(j="w")}else j="r";I=await m.Promises.open(l,j)}catch(j){throw p?.dispose(),(0,w.$Nk)(i)?await this.gb(r,j):this.fb(j)}if(this.U.set(I,0),(0,w.$Nk)(i)&&this.X.set(I,r),p){const j=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${l})`),this.W.set(I,p),j&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${l})`),j.dispose())}return I}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,l,p){const I=this.Z(r,i);let j=null;try{j=(await m.Promises.read(r,s,l,p,I)).bytesRead}catch(S){throw this.fb(S)}finally{this.$(r,I,j)}return j}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,s){const l=this.U.get(r);typeof l=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(r,l+s):this.U.delete(r)))}async write(r,i,s,l,p){return(0,P.$Ah)(()=>this.ab(r,i,s,l,p),100,3)}async ab(r,i,s,l,p){const I=this.Z(r,i);let j=null;try{j=(await m.Promises.write(r,s,l,p,I)).bytesWritten}catch(S){throw await this.gb(this.X.get(r),S)}finally{this.$(r,I,j)}return j}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const s=this.H(r);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,b.$jc)((0,b.$mc)(s),`${(0,b.$nc)(s)}${i.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,l)}else try{await m.Promises.unlink(s)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let p=!1;try{const{stat:I,symbolicLink:j}=await m.SymlinkSupport.stat(s);p=I.isDirectory()&&!j}catch{}if(p)await m.Promises.rmdir(s);else throw l}else throw l}}catch(s){throw this.fb(s)}}async rename(r,i,s){const l=this.H(r),p=this.H(i);if(l!==p)try{await this.bb(r,i,"move",s.overwrite),await m.Promises.rename(l,p)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(2,null,(0,b.$nc)(l),(0,b.$nc)((0,b.$mc)(p)),I.toString()))),this.fb(I)}}async copy(r,i,s){const l=this.H(r),p=this.H(i);if(l!==p)try{await this.bb(r,i,"copy",s.overwrite),await m.Promises.copy(l,p,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(3,null,(0,b.$nc)(l),(0,b.$nc)((0,b.$mc)(p)),I.toString()))),this.fb(I)}}async bb(r,i,s,l){const p=this.H(r),I=this.H(i);let j=!1;if(!!(this.capabilities&1024)||(j=(0,h.$fg)(p,I,!0)),j){if(s==="copy")throw(0,w.$Zk)((0,v.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.L(r);if(!D)throw(0,w.$Zk)((0,v.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(i);if(M){if(!l)throw(0,w.$Zk)((0,v.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);D.type&w.FileType.File&&M.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,s){const l=this.H(r),p=this.H(i),I=!!(this.capabilities&1024);if((0,h.$fg)(l,p,!I))return;const j=new c.$Sc;try{j.add(await this.O(r)),j.add(await this.O(i)),s&&await m.Promises.mkdir((0,b.$mc)(p),{recursive:!0}),await m.Promises.copyFile(l,p)}catch(S){if(S.code==="ENOENT"&&!s)return this.cb(r,i,!0);throw this.fb(S)}finally{j.dispose()}}t(r,i,s){return new g.$Iq(l=>r(l),l=>i(l),s)}F(r,i,s){return new a.$Qq(l=>r(l),l=>i(l),s)}fb(r){if(r instanceof w.$Yk)return r;let i=r,s;switch(r.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=w.FileSystemProviderErrorCode.Unknown;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.$Zk)(i,s)}async gb(r,i){let s=this.fb(i);if(r&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.H(r));l.mode&128||(s=(0,w.$Zk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.$Rq=t}),define(ae[226],ce([0,1,3,94,2,17,62,23]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=void 0;class h extends P.$Tc{constructor(y,k){super(),this.a=y,this.b=k,this.F=new Map,this.G=new Map}call(y,k,d){const m=this.c(y);switch(k){case"stat":return this.g(m,d[0]);case"readdir":return this.h(m,d[0]);case"open":return this.r(m,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(m,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(m,d[0],d[1],d[2]);case"rename":return this.z(m,d[0],d[1],d[2]);case"copy":return this.C(m,d[0],d[1],d[2]);case"cloneFile":return this.D(m,d[0],d[1]);case"mkdir":return this.w(m,d[0]);case"delete":return this.y(m,d[0],d[1]);case"watch":return this.I(m,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${k} not found`)}listen(y,k,d){const m=this.c(y);switch(k){case"fileChange":return this.H(m,d[0]);case"readFileStream":return this.m(m,d[0],d[1])}throw new Error(`Unknown event ${k}`)}g(y,k){const d=this.f(y,k,!0);return this.a.stat(d)}h(y,k){const d=this.f(y,k);return this.a.readdir(d)}async j(y,k,d){const m=this.f(y,k,!0),v=await this.a.readFile(m,d);return O.$te.wrap(v)}m(y,k,d){const m=this.f(y,k,!0),v=new E.$de,w=new n.$6d({onDidRemoveLastListener:()=>{v.cancel()}}),$=this.a.readFileStream(m,d,v.token);return(0,A.$le)($,{onData:f=>w.fire(O.$te.wrap(f)),onError:f=>w.fire(f),onEnd:()=>{w.fire("end"),w.dispose(),v.dispose()}}),w.event}n(y,k,d,m){const v=this.f(y,k);return this.a.writeFile(v,d.buffer,m)}r(y,k,d){const m=this.f(y,k,!0);return this.a.open(m,d)}s(y){return this.a.close(y)}async t(y,k,d){const m=O.$te.alloc(d),w=await this.a.read(y,k,m.buffer,0,d);return[m,w]}u(y,k,d,m,v){return this.a.write(y,k,d.buffer,m,v)}w(y,k){const d=this.f(y,k);return this.a.mkdir(d)}y(y,k,d){const m=this.f(y,k);return this.a.delete(m,d)}z(y,k,d,m){const v=this.f(y,k),w=this.f(y,d);return this.a.rename(v,w,m)}C(y,k,d,m){const v=this.f(y,k),w=this.f(y,d);return this.a.copy(v,w,m)}D(y,k,d){const m=this.f(y,k),v=this.f(y,d);return this.a.cloneFile(m,v)}H(y,k){const d=new n.$6d({onWillAddFirstListener:()=>{this.F.set(k,this.L(y,d))},onDidRemoveLastListener:()=>{(0,P.$Oc)(this.F.get(k)),this.F.delete(k)}});return d.event}async I(y,k,d,m,v){const w=this.F.get(k);if(w){const $=this.f(y,m),f=w.watch(d,$,v);this.G.set(k+d,f)}}async J(y,k){const d=y+k,m=this.G.get(d);m&&((0,P.$Oc)(m),this.G.delete(d))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$os=h;class c extends P.$Tc{constructor(y,k,d,m){super(),this.c=y,this.f=d,this.g=m,this.a=new Map,this.b=this.B(new R.$Rq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(y){const k=this.B(new n.$6d);this.B(k.event(d=>{y.fire(d.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(d=>k.fire(d))),this.B(this.b.onDidWatchError(d=>y.fire(d)))}j(y){}m(y){}watch(y,k,d){const m=this.m(this.g);return Array.isArray(m)&&(d.excludes=[...d.excludes,...m]),this.a.set(y,this.b.watch(k,d)),(0,P.$Rc)(()=>{(0,P.$Oc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$ps=c}),define(ae[227],ce([0,1,14,180,4,7,16,9,226,157]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=void 0;class b extends h.$os{constructor(d,m,v){super(d,m),this.M=v}c(d){return c.$jn}f(d,m){return O.URI.revive(m)}async y(d,m,v){if(!v.useTrash)return super.y(d,m,v);const w=this.f(d,m),$=(0,E.$hc)(w.fsPath);try{await n.shell.trashItem($)}catch{throw(0,A.$Zk)(P.$i?(0,R.localize)(0,null,(0,E.$nc)($)):(0,R.localize)(1,null,(0,E.$nc)($)),A.FileSystemProviderErrorCode.Unknown)}}L(d,m){return new y(d,m,this.b,this.M)}}e.$8_b=b;class y extends h.$ps{watch(d,m,v){if(v.recursive)throw(0,A.$Zk)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(d,m,v)}}}),define(ae[228],ce([0,1,5]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=void 0;class R extends n.$Sj{constructor(O=n.$Pj){super(),this.m=[],this.n=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(A=>{this.n?.setLevel(A)}))}set logger(O){this.n=O;for(const{level:A,message:E}of this.m)(0,n.log)(O,A,E);this.m=[]}g(O,A){this.n?(0,n.log)(this.n,O,A):this.getLevel()<=O&&this.m.push({level:O,message:A})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$X9b=R}),define(ae[229],ce([0,1,7,3,5,2]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=void 0;class A extends P.$Xj{constructor(y,k,d,m,v){super(k,d,m),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(w=>{(0,P.$Oj)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(v.listen("onDidChangeVisibility",y)(([w,$])=>super.setVisibility(n.URI.revive(w),$))),this.B(v.listen("onDidChangeLoggers",y)(({added:w,removed:$})=>{for(const f of w)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of $)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new P.$Vj({log:(y,k)=>{this.t.call("consoleLog",[y,k])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,k){super.setLogLevel(y,k),this.t.call("setLogLevel",[y,k])}setVisibility(y,k){super.setVisibility(y,k),this.t.call("setVisibility",[this.n(y),k])}s(y,k,d){return new E(this.t,y,k,d,this.r)}static setLogLevel(y,k,d){return y.call("setLogLevel",[k,d])}}e.$Qr=A;class E extends P.$Sj{constructor(y,k,d,m,v){super(m?.logLevel==="always"),this.r=y,this.s=k,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[k,m,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,k){const d=[[y,k]];this.m?this.u(d):this.n.push(...d)}u(y){this.r.call("log",[this.s,y])}}class h{constructor(y,k){this.a=y,this.b=k}listen(y,k){const d=this.b(y);switch(k){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(v=>this.c(v,d)),removed:[...m.removed].map(v=>this.c(v,d))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,m=>[d.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,m=>(0,P.$Oj)(m)?m:[d.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(y,k,d){const m=this.b(y);switch(k){case"setLogLevel":return(0,P.$Oj)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(n.URI.revive(m.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,m)))}throw new Error(`Call not found: ${k}`)}c(y,k){return{...y,resource:k.transformOutgoingURI(y.resource)}}}e.$Rr=h;class c extends O.$Tc{constructor(y,k){super(),k.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(d=>k.call("setLogLevel",[d]))),k.call("getRegisteredLoggers").then(d=>{for(const m of d)y.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([d,m])=>y.setVisibility(n.URI.revive(d),m))),this.B(k.listen("onDidChangeLoggers")(({added:d,removed:m})=>{for(const v of d)y.registerLogger({...v,resource:n.URI.revive(v.resource)});for(const v of m)y.deregisterLogger(v.resource)}))}}e.$Sr=c}),define(ae[230],ce([0,1,2,5]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class P extends n.$Tc{constructor(A,E=[]){super(),this.a=new R.$Wj([A,...E]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...E){this.a.trace(A,...E)}debug(A,...E){this.a.debug(A,...E)}info(A,...E){this.a.info(A,...E)}warn(A,...E){this.a.warn(A,...E)}error(A,...E){this.a.error(A,...E)}flush(){this.a.flush()}}e.$VP=P}),define(ae[231],ce([0,1,31,7,5]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;class O{constructor(E){this.b=E,this.a=new n.$Ac}listen(E,h,c){switch(h){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,c){switch(h){case"createLogger":this.c(R.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(R.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$Oj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(R.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:R.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,c){this.a.set(E,this.b.createLogger(E,h,c))}d(E,h){let c=console.log;switch(E){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...h)}e(E,h){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[b,y]of h)(0,P.log)(c,b,y)}}e.$3ac=O}),define(ae[232],ce([0,1,16,5]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function O(c,b,y,k,d){try{const m=await new Promise((w,$)=>{J(["@vscode/spdlog"],w,$)});m.setFlushOn(P.Trace);const v=await m.createAsyncRotatingLogger(c,b,y,k);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(m){console.error(m)}return null}function A(c,b,y){switch(b){case R.LogLevel.Trace:c.trace(y);break;case R.LogLevel.Debug:c.debug(y);break;case R.LogLevel.Info:c.info(y);break;case R.LogLevel.Warning:c.warn(y);break;case R.LogLevel.Error:c.error(y);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function E(c,b){switch(b){case R.LogLevel.Trace:c.setLevel(P.Trace);break;case R.LogLevel.Debug:c.setLevel(P.Debug);break;case R.LogLevel.Info:c.setLevel(P.Info);break;case R.LogLevel.Warning:c.setLevel(P.Warning);break;case R.LogLevel.Error:c.setLevel(P.Error);break;case R.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class h extends R.$Sj{constructor(b,y,k,d,m){super(),this.m=[],this.setLevel(m),this.n=this.s(b,y,k,d),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(b,y,k,d){const m=k?6:1,v=30/m*n.$il.MB,w=await O(b,y,v,m,d);if(w){this.r=w,E(this.r,this.getLevel());for(const{level:$,message:f}of this.m)A(this.r,$,f);this.m=[]}}g(b,y){this.r?A(this.r,b,y):this.getLevel()<=b&&this.m.push({level:b,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$KP=h}),define(ae[233],ce([0,1,32,5,232]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=void 0;class O extends R.$Xj{s(E,h,c){return new P.$KP((0,n.$Cg)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$LP=O}),define(ae[67],ce([0,1,31,3,6,5,233]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=e.$C_b=void 0,e.$C_b=(0,P.$hi)(O.$Nj);class E extends A.$LP{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,b,y){y!==void 0&&this.u.set(this.n(c),y);try{return super.createLogger(c,b)}catch(k){throw this.u.delete(this.n(c)),k}}registerLogger(c,b){b!==void 0&&this.u.set(c.resource,b),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const b=[];for(const y of super.getRegisteredLoggers())c===this.u.get(y.resource)&&b.push(y);return b}getOnDidChangeLogLevelEvent(c){return R.Event.filter(this.onDidChangeLogLevel,b=>(0,O.$Oj)(b)||this.w(b[0],c))}getOnDidChangeVisibilityEvent(c){return R.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,c))}getOnDidChangeLoggersEvent(c){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(k=>this.w(k.resource,c)),removed:[...b.removed].filter(k=>this.w(k.resource,c))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(c){for(const[b,y]of this.u)y===c&&this.deregisterLogger(b)}w(c,b){const y=this.u.get(c);return y===void 0||y===b}dispose(){super.dispose(),this.u.clear()}}e.$D_b=E}),define(ae[234],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=n,e.$jac=R,e.$kac=P,e.$lac=O;function n(A){return A.submenu!==void 0}function R(A){return A.id==="vscode.menubar.separator"}function P(A){return A.uri!==void 0}function O(A){return!n(A)&&!R(A)&&!P(A)}}),define(ae[39],ce([0,1,3,71,2,6]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=e.$1n=void 0,e.$1n=(0,O.$gi)("policy");class A extends P.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$6d),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(y,[k,d])=>({...y,[k]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[b,y])=>({...c,[b]:{definition:y,value:this.g.get(b)}}),{})}}e.$2n=A;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$3n=E}),define(ae[235],ce([0,1,8,3,71,12,16,5,39]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;function c(y,k){const d=[];for(const m of new Set(P.Iterable.concat(y.keys(),k.keys())))y.get(m)!==k.get(m)&&d.push(m);return d}let b=class extends h.$2n{constructor(k,d,m){super(),this.m=k,this.n=d,this.s=m,this.c=this.B(new n.$eh(500));const v=R.Event.filter(d.onDidFilesChange,w=>w.affects(k));this.B(d.watch(k)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const d=await this.n.readFile(this.m),m=JSON.parse(d.value.toString());if(!(0,O.$Vf)(m))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(m))this.f[v]&&k.set(v,m[v])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return k}async w(){const k=await this.u(),d=c(this.g,k);this.g=k,d.length>0&&this.h.fire(d)}};e.$jbc=b,e.$jbc=b=ve([se(1,A.$Mk),se(2,E.$Mj)],b)}),define(ae[236],ce([0,1,3,2,39]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=e.$Tac=void 0;class O{constructor(h){this.b=h,this.a=new R.$Sc}listen(h,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,b=>b.reduce((y,k)=>({...y,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(h,c,b){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$Tac=O;class A extends P.$2n{constructor(h,c){super(),this.a=c;for(const b in h){const{definition:y,value:k}=h[b];this.f[b]=y,k!==void 0&&this.g.set(b,k)}this.a.listen("onDidChange")(b=>{for(const y in b){const k=b[y];k===null?this.g.delete(y):this.g.set(y,k)}this.h.fire(Object.keys(b))})}async j(h){const c=await this.a.call("updatePolicyDefinitions",h);for(const b in c)this.g.set(b,c[b])}}e.$Uac=A}),define(ae[237],ce([0,1,39,8,2,5]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;let A=class extends n.$2n{constructor(h,c){super(),this.m=h,this.n=c,this.a=new R.$ah,this.b=this.B(new P.$Uc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((b,y)=>{J(["@vscode/policy-watcher"],b,y)});await this.a.queue(()=>new Promise((b,y)=>{try{this.b.value=c(this.n,h,k=>{this.t(k),b()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),y(k)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const b=h[c];b===void 0?this.g.delete(c):this.g.set(c,b)}this.h.fire(Object.keys(h))}};e.$ibc=A,e.$ibc=A=ve([se(0,O.$Mj)],A)}),define(ae[79],ce([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const O=P.context.configuration();if(O)R=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:O.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(ae[27],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=void 0,e.$6j=(0,n.$gi)("productService"),e.$7j="vscode://schemas/vscode-product"}),define(ae[238],ce([0,1,8,5]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=void 0;let P=class{constructor(A,E,h){this.a=A,this.b=E,this.c=h}async inspect(A){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$hh)(A);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$$_b=P,e.$$_b=P=ve([se(2,R.$Mj)],P)}),define(ae[80],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=void 0,e.$l_b=(0,n.$gi)("protocolMainService")}),define(ae[44],ce([0,1,139,12]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0;class P{constructor(){this.a=new Map}add(A,E){n.ok(R.$Tf(A)),n.ok(R.$Vf(E)),n.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Yn=new P}),define(ae[239],ce([0,1,3,44]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0,e.$Zn={JSONContribution:"base.contributions.json"};function P(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class O{constructor(){this.b=new n.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[P(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;R.$Yn.add(e.$Zn.JSONContribution,A)}),define(ae[52],ce([0,1,22,3,12,165,18,239,44]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.ConfigurationScope=e.$4n=e.EditPresentationTypes=void 0,e.$co=v,e.$do=w,e.$eo=$,e.$fo=u,e.$go=g;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$4n={Configuration:"base.contributions.configuration"};var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n="vscode://schemas/settings/resourceLanguage",e.$_n="vscode://schemas/settings/configurationDefaults";const y=h.$Yn.as(E.$Zn.JSONContribution);class k{constructor(){this.h=new Set,this.i=new R.$6d,this.onDidSchemaChange=this.i.event,this.j=new R.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$$n,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),y.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),y.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:s}of t)for(const l in i)if(o.add(l),e.$bo.test(l)){const p=this.a.get(l),I=p?.valuesSources??new Map;if(s)for(const M of Object.keys(i[l]))I.set(M,s);const j={...p?.value||{},...i[l]};this.a.set(l,{source:s,value:j,valuesSources:I});const S=(0,A.$Wi)(l),D={type:"object",default:j,description:O.localize(1,null,S),$ref:e.$$n,defaultDefaultValue:j,source:P.$Tf(s)?void 0:s,defaultValueSource:s};r.push(...v(l)),this.d[l]=D,this.b.properties[l]=D}else{this.a.set(l,{value:i[l],source:s});const p=this.d[l];p&&(this.w(l,p),this.r(l,p))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const s in r){const l=this.a.get(s),p=P.$Tf(i)?i:i?.id,I=P.$Tf(l?.source)?l?.source:l?.source?.id;if(p===I)if(o.add(s),this.a.delete(s),e.$bo.test(s))delete this.d[s],delete this.b.properties[s];else{const j=this.d[s];j&&(this.w(s,j),this.r(s,j))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const s in i.properties){o.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of t){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,r,i,s=3,l){s=P.$3f(t.scope)?s:t.scope;const p=t.properties;if(p)for(const j in p){const S=p[j];if(o&&u(j,S)){delete p[j];continue}if(S.source=r,S.defaultDefaultValue=p[j].default,this.w(j,S),e.$bo.test(j)?S.scope=void 0:(S.scope=P.$3f(S.scope)?s:S.scope,S.restricted=P.$3f(S.restricted)?!!i?.includes(j):S.restricted),p[j].hasOwnProperty("included")&&!p[j].included){this.f[j]=p[j],delete p[j];continue}else this.d[j]=p[j],p[j].policy?.name&&this.e.set(p[j].policy.name,j);!p[j].deprecationMessage&&p[j].markdownDeprecationMessage&&(p[j].deprecationMessage=p[j].markdownDeprecationMessage),l.add(j)}const I=t.allOf;if(I)for(const j of I)this.p(j,o,r,i,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$5n.properties[t]=o,o.scope){case 1:e.$6n.properties[t]=o;break;case 2:e.$7n.properties[t]=o;break;case 6:e.$8n.properties[t]=o;break;case 3:e.$9n.properties[t]=o;break;case 4:e.$0n.properties[t]=o;break;case 5:e.$0n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$5n.properties[t],o.scope){case 1:delete e.$6n.properties[t];break;case 2:delete e.$7n.properties[t];break;case 6:delete e.$8n.properties[t];break;case 3:delete e.$9n.properties[t];break;case 4:case 5:delete e.$0n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$$n};this.w(o,r),e.$5n.properties[o]=r,e.$6n.properties[o]=r,e.$7n.properties[o]=r,e.$8n.properties[o]=r,e.$9n.properties[o]=r,e.$0n.properties[o]=r}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$$n};e.$5n.patternProperties[e.$ao]=t,e.$6n.patternProperties[e.$ao]=t,e.$7n.patternProperties[e.$ao]=t,e.$8n.patternProperties[e.$ao]=t,e.$9n.patternProperties[e.$ao]=t,e.$0n.patternProperties[e.$ao]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,s=r?.source;P.$1f(i)&&(i=o.defaultDefaultValue,s=void 0),P.$1f(i)&&(i=$(o.type)),o.default=i,o.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.$ao=`^(${d})+$`,e.$bo=new RegExp(e.$ao);function v(a){const t=[];if(e.$bo.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function $(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new k;h.$Yn.add(e.$4n.Configuration,f);function u(a,t){return a.trim()?e.$bo.test(a)?O.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?O.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function g(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(ae[123],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(J,e,n,R,P,O,A,E,h,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$ko=e.$jo=e.$io=e.$ho=void 0,e.$lo=u;function d(o){return Object.isFrozen(o)?o:E.$Nn(o)}class m{constructor(r={},i=[],s=[],l){this.b=r,this.c=i,this.d=s,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const s=new v("");return s.parseRaw(i),s.configurationModel});this.f=r.reduce((i,s)=>s===i?s:i.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$Ui)(this.contents,r):this.contents}inspect(r,i){const s=this;return{get value(){return d(s.rawConfiguration.getValue(r))},get override(){return i?d(s.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return d(i?s.rawConfiguration.override(i).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const l=[];for(const{contents:p,identifiers:I,keys:j}of s.rawConfiguration.overrides){const S=new m(p,j).getValue(r);S!==void 0&&l.push({identifiers:I,value:S})}return l.length?d(l):void 0}}}getOverrideValue(r,i){const s=this.i(i);return s?r?(0,b.$Ui)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$Mn(this.contents),s=E.$Mn(this.overrides),l=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const I of r)if(p.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const j of I.overrides){const[S]=s.filter(D=>n.$ub(D.identifiers,j.identifiers));S?(this.h(S.contents,j.contents),S.keys.push(...j.keys),S.keys=n.$Mb(S.keys)):s.push(E.$Mn(j))}for(const j of I.keys)l.indexOf(j)===-1&&l.push(j)}return new m(i,l,s,p.every(I=>I instanceof m)?void 0:p)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const l of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[l];const I=i[l];I&&(typeof p=="object"&&typeof I=="object"?(p=E.$Mn(p),this.h(p,I)):p=I),s[l]=p}return new m(s,this.keys,this.overrides)}h(r,i){for(const s of Object.keys(i)){if(s in r&&h.$Vf(r[s])&&h.$Vf(i[s])){this.h(r[s],i[s]);continue}r[s]=E.$Mn(i[s])}}i(r){let i=null,s=null;const l=p=>{p&&(s?this.h(s,p):s=E.$Mn(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?i=p.contents:p.identifiers.includes(r)&&l(p.contents);return l(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,b.$Ti)(this.contents,r),y.$bo.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,y.$co)(r))),1))}j(r,i,s){(0,b.$Si)(this.contents,r,i,l=>console.error(l)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),y.$bo.test(r)&&this.overrides.push({identifiers:(0,y.$co)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$Ri)(this.contents[r],l=>console.error(l))})}}e.$ho=m;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.$3f(r)){const s=this.g(r);this.parseRaw(s,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:s,keys:l,overrides:p,restricted:I,hasExcludedProperties:j}=this.h(r,i);this.b=new m(s,l,p,j?[r]:void 0),this.c=I||[]}g(r){let i={},s=null,l=[];const p=[],I=[];function j(D){Array.isArray(l)?l.push(D):s!==null&&(l[s]=D)}const S={onObjectBegin:()=>{const D={};j(D),p.push(l),l=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const D=[];j(D),p.push(l),l=D,s=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:j,onError:(D,M,W)=>{I.push({error:D,offset:M,length:W})}};if(r)try{P.$An(r,S),i=l[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return i}h(r,i){const s=k.$Yn.as(y.$4n.Configuration).getConfigurationProperties(),l=this.i(r,s,!0,i);r=l.raw;const p=(0,b.$Ri)(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),I=Object.keys(r),j=this.j(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:p,keys:I,overrides:j,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,i,s,l){let p=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const I={},j=[];for(const S in r)if(y.$bo.test(S)&&s){const D=this.i(r[S],i,!1,l);I[S]=D.raw,p=p||D.hasExcludedProperties,j.push(...D.restricted)}else{const D=i[S],M=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&j.push(S),!l.exclude?.includes(S)&&(l.include?.includes(S)||(M===void 0||l.scopes===void 0||l.scopes.includes(M))&&!(l.skipRestricted&&D?.restricted))?I[S]=r[S]:p=!0}return{raw:I,restricted:j,hasExcludedProperties:p}}j(r,i){const s=[];for(const l of Object.keys(r))if(y.$bo.test(l)){const p={};for(const I in r[l])p[I]=r[l][I];s.push({identifiers:(0,y.$co)(l),keys:Object.keys(p),contents:(0,b.$Ri)(p,i)})}return s}}e.$io=v;class w extends O.$Tc{constructor(r,i,s,l){super(),this.c=r,this.f=i,this.g=l,this.b=this.B(new R.$6d),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&s.isEqual(p.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$jo=w;class ${constructor(r,i,s,l,p,I,j,S,D,M,W,F,H){this.a=r,this.b=i,this.c=s,this.overrideIdentifiers=l,this.d=p,this.f=I,this.g=j,this.h=S,this.i=D,this.j=M,this.k=W,this.l=F,this.m=H}get value(){return d(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,s,l,p=new m,I=new m,j=new A.$Ac,S=new m,D=new A.$Ac){this.c=r,this.d=i,this.f=s,this.g=l,this.h=p,this.i=I,this.j=j,this.l=S,this.m=D,this.a=null,this.b=new A.$Ac,this.n=null}getValue(r,i,s){return this.p(r,i,s).getValue(r)}updateValue(r,i,s={}){let l;s.resource?(l=this.m.get(s.resource),l||(l=new m,this.m.set(s.resource,l))):l=this.l,i===void 0?l.removeValue(r):l.setValue(r,i),s.resource||(this.a=null)}inspect(r,i,s){const l=this.p(r,i,s),p=this.t(i.resource,s),I=i.resource?this.m.get(i.resource)||this.l:this.l,j=new Set;for(const S of l.overrides)for(const D of S.identifiers)l.getOverrideValue(r,D)!==void 0&&j.add(D);return new $(r,i,l.getValue(r),j.size?[...j]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,p||void 0,I)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:l,updated:p,removed:I}=a(this.c,r);i=[...l,...p,...I]}for(const l of i)for(const p of(0,y.$co)(l)){const I=this.c.getKeysForOverrideIdentifier(p),j=r.getKeysForOverrideIdentifier(p),S=[...j.filter(D=>I.indexOf(D)===-1),...I.filter(D=>j.indexOf(D)===-1),...I.filter(D=>!E.$Qn(this.c.override(p).getValue(D),r.override(p).getValue(D)))];s.push([p,S])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:l}=a(this.d,r),p=[...i,...s,...l];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.applicationConfiguration,r),I=[...i,...s,...l];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.localUserConfiguration,r),I=[...i,...s,...l];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.remoteUserConfiguration,r),I=[...i,...s,...l];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.workspaceConfiguration,r),I=[...i,...s,...l];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:l,updated:p,removed:I,overrides:j}=a(s,i),S=[...l,...p,...I];return(S.length||!s)&&this.updateFolderConfiguration(r,i),{keys:S,overrides:j}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:l,removed:p,overrides:I}=a(i,void 0);return{keys:[...s,...l,...p],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,s){let l=this.q(i,s);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},i){let s=this.r();if(i&&r){const l=i.getFolder(r);l&&(s=this.s(l.uri)||s);const p=this.m.get(r);p&&(s=s.merge(p))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const s=this.r(),l=this.j.get(r);l?(i=s.merge(l),this.b.set(r,i)):i=s}return i}t(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:s,overrides:l,keys:p}=this.j.get(i);return r.push([i,{contents:s,overrides:l,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(s=>r.add(s))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r){const i=this.w(r.defaults),s=this.w(r.policy),l=this.w(r.application),p=this.w(r.user),I=this.w(r.workspace),j=r.folders.reduce((S,D)=>(S.set(c.URI.revive(D[0]),this.w(D[1])),S),new A.$Ac);return new f(i,s,l,p,new m,I,j,new m,new A.$Ac)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$ko=f;function u(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const l of o)l.keys.forEach(p=>r.add(p)),l.overrides.forEach(([p,I])=>{const j=(0,A.$xc)(i,p,new Set);I.forEach(S=>j.add(S))});const s=[];return i.forEach((l,p)=>s.push([p,[...l.values()]])),{keys:[...r.values()],overrides:s}}class g{constructor(r,i,s,l){this.change=r,this.f=i,this.g=s,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const I of p)this.affectedKeys.add(I);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const s=this.a+r,l=this.d.indexOf(s);if(l<0)return!1;const p=l+s.length;if(p>=this.d.length)return!1;const I=this.d.charCodeAt(p);if(I!==this.b&&I!==this.c)return!1;if(i){const j=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,S=this.g.getValue(r,i,this.h);return!E.$Qn(j,S)}return!0}}e.$mo=g;function a(o,r){const{added:i,removed:s,updated:l}=t(r?.rawConfiguration,o?.rawConfiguration),p=[],I=o?.getAllOverrideIdentifiers()||[],j=r?.getAllOverrideIdentifiers()||[];if(r){const S=j.filter(D=>!I.includes(D));for(const D of S)p.push([D,r.getKeysForOverrideIdentifier(D)])}if(o){const S=I.filter(D=>!j.includes(D));for(const D of S)p.push([D,o.getKeysForOverrideIdentifier(D)])}if(r&&o){for(const S of I)if(j.includes(S)){const D=t({contents:o.getOverrideValue(void 0,S)||{},keys:o.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});p.push([S,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:s,updated:l,overrides:p}}function t(o,r){const i=o?r?o.keys.filter(p=>r.keys.indexOf(p)===-1):[...o.keys]:[],s=r?o?r.keys.filter(p=>o.keys.indexOf(p)===-1):[...r.keys]:[],l=[];if(o&&r){for(const p of r.keys)if(o.keys.indexOf(p)!==-1){const I=(0,b.$Ui)(r.contents,p),j=(0,b.$Ui)(o.contents,p);E.$Qn(I,j)||l.push(p)}}return{added:i,removed:s,updated:l}}}),define(ae[240],ce([0,1,22,3,2,35,12,123,52,5,39,44]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=void 0;class k extends P.$Tc{constructor(){super(...arguments),this.a=this.B(new R.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$ho}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$Yn.as(h.$4n.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:$})=>this.c(Array.from(w),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,$){this.h(w,y.$Yn.as(h.$4n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new E.$ho;const w=y.$Yn.as(h.$4n.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,$){const f=this.f();for(const u of w){const g=f[u],a=$[u];g!==void 0?this.b.addValue(u,g):a?this.b.addValue(u,a.default):this.b.removeValue(u)}}}e.$no=k;class d{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new E.$ho}async initialize(){return this.configurationModel}}e.$oo=d;let m=class extends P.$Tc{get configurationModel(){return this.b}constructor(w,$,f){super(),this.c=w,this.f=$,this.g=f,this.a=this.B(new R.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$ho}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const $={},f=[],u=y.$Yn.as(h.$4n.Configuration).getConfigurationProperties();for(const g of w){const a=u[g];if(!a){f.push(g);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(g),$[a.policy.name]={type:a.type}}}return(0,A.$7f)($)||await this.f.updatePolicyDefinitions($),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const $=y.$Yn.as(h.$4n.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(w.map(u=>$.get(u)));this.m(f,!0)}m(w,$){this.g.trace("PolicyConfiguration#update",w);const f=y.$Yn.as(h.$4n.Configuration).getConfigurationProperties(),u=[],g=this.b.isEmpty();for(const a of w){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(g?o!==void 0:!(0,O.$Qn)(this.b.getValue(a),o))&&u.push([a,o])}else this.b.getValue(a)!==void 0&&u.push([a,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const a=this.b;this.b=new E.$ho;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of u)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);$&&this.a.fire(this.b)}}};e.$po=m,e.$po=m=ve([se(1,b.$1n),se(2,c.$Mj)],m)}),define(ae[241],ce([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,240,39]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0;class $ extends h.$Tc{constructor(g,a,t,o){super(),this.m=g,this.h=this.B(new O.$6d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$no),this.c=t instanceof w.$3n?new v.$oo:this.B(new v.$po(this.b,t,o)),this.f=this.B(new d.$jo(this.m,{},y.$Kg,a)),this.a=new d.$ko(this.b.configurationModel,this.c.configurationModel,new d.$ho,new d.$ho),this.j=new f(g,a,this),this.g=this.B(new R.$sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new d.$ko(g,a,new d.$ho,t)}getConfigurationData(){return this.a.toData()}getValue(g,a){const t=typeof g=="string"?g:void 0,o=(0,k.$Ni)(g)?g:(0,k.$Ni)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue(g,a,t,o,r){const i=(0,k.$Oi)(t)?t:(0,k.$Ni)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=i?o:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${g} to target ${s}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const l=this.inspect(g,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(l.policyValue!==void 0)throw new Error(`Unable to write ${g} because it is configured in system policy.`);if((0,c.$Qn)(a,l.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const I=i.overrideIdentifiers.sort(),j=this.a.localUserConfiguration.overrides.find(S=>(0,n.$ub)([...S.identifiers].sort(),I));j&&(i.overrideIdentifiers=j.identifiers)}const p=i?.overrideIdentifiers?.length?[(0,m.$do)(i.overrideIdentifiers),g]:[g];await this.j.write(p,a),await this.reloadConfiguration()}inspect(g,a={}){return this.a.inspect(g,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.n(g)}n(g){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(g);this.t(t,a,2)}r(g,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(g,a);this.t(o,t,7)}s(g){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(g);this.t(t,a,7)}t(g,a,t){const o=new d.$mo(g,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$qo=$;class f{constructor(g,a,t){this.b=g,this.c=a,this.d=t,this.a=new R.$nh}write(g,a){return this.a.queue(()=>this.e(g,a))}async e(g,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,A.$tn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,g,a);t=(0,E.$Ln)(t,r),await this.c.writeFile(this.b,P.$te.fromString(t))}f(g,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const s=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$In)(g,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let g=b.OS===3||b.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(g=a),this.g={eol:g,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[242],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=e.$8ac=void 0,e.$8ac="request",e.$9ac="remoteResourceHandler";class n{async routeCall(P,O,A){if(O!==e.$8ac)throw new Error(`Call not found: ${O}`);const E=A[0];if(E?.authority){const h=P.connections.find(c=>c.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(P,O){throw new Error(`Event not found: ${O}`)}}e.$0ac=n}),define(ae[243],ce([0,1,15,6]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.RemoteAuthorityResolverErrorCode=e.$tl=e.$sl=e.RemoteConnectionType=e.$rl=void 0,e.$vl=c,e.$rl=(0,R.$gi)("remoteAuthorityResolverService");var P;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$sl=O;class A{constructor(y,k){this.host=y,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$tl=A;var E;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends n.$bb{static isNotAvailable(y){return y instanceof h&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof h&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof h&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof h&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof h&&y.isHandled}constructor(y,k=E.Unknown,d){super(y),this._message=y,this._code=k,this._detail=d,this.isHandled=k===E.NotAvailable&&d===!0,Object.setPrototypeOf(this,h.prototype)}}e.$ul=h;function c(b){const y=b.indexOf("+");return y===-1?b:b.substring(0,y)}}),define(ae[244],ce([0,1,8,17,23,15,3,2,13,66,72,32,113,243]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Al=I,e.$Bl=j,e.$Cl=D;const m=30*1e3;var v;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function w(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(K){const C=new P.$de;return setTimeout(()=>C.cancel(),K),C.token}function f(K,C){if(K.isCancellationRequested||C.isCancellationRequested)return P.CancellationToken.Cancelled;const T=new P.$de;return K.onCancellationRequested(()=>T.cancel()),C.onCancellationRequested(()=>T.cancel()),T.token}class u{get didTimeout(){return this.c==="timedout"}constructor(C){this.c="pending",this.d=new E.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$_g)(),C.isCancellationRequested?this.h():this.d.add(C.onCancellationRequested(()=>this.h()))}registerDisposable(C){this.c==="pending"?this.d.add(C):C.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(C))}reject(C){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(C))}}function g(K,C){const T=new u(C);return T.registerDisposable(K.onControlMessage(Z=>{const z=JSON.parse(Z.toString()),X=L(z);X?T.reject(X):T.resolve(z)})),T.promise}function a(K,C,T,Z,z,X,V,_){const B=new u(_),te=b.$2d.create(!1);return K.info(`Creating a socket (${V})...`),c.mark(`code/willCreateSocket/${X}`),C.connect(T,Z,z,V).then(ie=>{B.didTimeout?(c.mark(`code/didCreateSocketError/${X}`),K.info(`Creating a socket (${V}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(c.mark(`code/didCreateSocketOK/${X}`),K.info(`Creating a socket (${V}) was successful after ${te.elapsed()} ms.`),B.resolve(ie))},ie=>{c.mark(`code/didCreateSocketError/${X}`),K.info(`Creating a socket (${V}) returned an error after ${te.elapsed()} ms.`),K.error(ie),B.reject(ie)}),B.promise}function t(K,C){const T=new u(C);return K.then(Z=>{T.didTimeout||T.resolve(Z)},Z=>{T.didTimeout||T.reject(Z)}),T.promise}async function o(K,C,T,Z){const z=oe(K,C);K.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let X;try{X=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,h.$tg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,w(C),`renderer-${w(C)}-${K.reconnectionToken}`,Z)}catch(ie){throw K.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ie),ie}K.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let V,_;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(X,null),V=K.reconnectionProtocol,_=!1):(V=new k.$7h({socket:X}),_=!0),K.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const B=await t(K.signService.createNewMessage((0,y.$Cg)()),Z),te={type:"auth",auth:K.connectionToken||"00000000000000000000",data:B.data};V.sendControl(R.$te.fromString(JSON.stringify(te)));try{const ie=await g(V,f(Z,$(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(K.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(K.signService.validate(B,ie.signedData),Z)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const me=await t(K.signService.sign(ie.data),Z),ke={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:C};return T&&(ke.args=T),K.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(R.$te.fromString(JSON.stringify(ke))),{protocol:V,ownsProtocol:_}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(K.logService.error(`${z} the handshake timed out. Error:`),K.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${z} received error control message when negotiating connection. Error:`),K.logService.error(ie)),_&&U(V),ie}}async function r(K,C,T,Z){const z=Date.now(),X=oe(K,C),{protocol:V,ownsProtocol:_}=await o(K,C,T,Z),B=new u(Z);return B.registerDisposable(V.onControlMessage(te=>{const ie=JSON.parse(te.toString()),de=L(ie);de?(K.logService.error(`${X} received error control message when negotiating connection. Error:`),K.logService.error(de),_&&U(V),B.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${he(z)}!`),B.resolve({protocol:V,firstMessage:ie}))})),B.promise}async function i(K,C){const{protocol:T}=await r(K,1,void 0,C);return{protocol:T}}async function s(K,C,T){const{protocol:Z,firstMessage:z}=await r(K,2,C,T),X=z&&z.debugPort;return{protocol:Z,debugPort:X}}async function l(K,C,T){const Z=Date.now(),z=oe(K,3),{protocol:X}=await o(K,3,C,T);return K.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(Z)}!`),X}async function p(K,C,T){const{connectTo:Z,connectionToken:z}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:Z,connectionToken:z,reconnectionToken:C,reconnectionProtocol:T,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,C,T){return S(K,async Z=>{const{protocol:z}=await i(Z,P.CancellationToken.None);return new Q(K,C,T,Z.reconnectionToken,z)})}async function j(K,C){return S(K,async T=>{const{protocol:Z,debugPort:z}=await s(T,C,P.CancellationToken.None);return new Y(K,C,T.reconnectionToken,Z,z)})}async function S(K,C){for(let Z=1;;Z++)try{const z=(0,y.$Cg)(),X=await p(K,z,null);return await C(X)}catch(z){if(Z<5)K.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(z);else throw K.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(z),ue.triggerPermanentFailure(0,0,d.$ul.isHandled(z)),z}}async function D(K,C,T){const Z=await p(K,(0,y.$Cg)(),null);return await l(Z,{host:C,port:T},P.CancellationToken.None)}function M(K){return(0,n.$6g)(C=>new Promise((T,Z)=>{const z=setTimeout(T,K*1e3);C.onCancellationRequested(()=>{clearTimeout(z),T()})}))}var W;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(C,T){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.type=0}}e.$Dl=F;class H{constructor(C,T,Z,z){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.durationSeconds=Z,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$El=H;class x{constructor(C,T,Z){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.attempt=Z,this.type=2}}e.$Fl=x;class le{constructor(C,T,Z){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.attempt=Z,this.type=4}}e.$Gl=le;class re{constructor(C,T,Z,z){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.attempt=Z,this.handled=z,this.type=3}}e.$Hl=re;class ue extends E.$Tc{static triggerPermanentFailure(C,T,Z){this._permanentFailure=!0,this.f=C,this.g=T,this.h=Z,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(C=>C.y())}static debugPauseSocketWriting(){this.j.forEach(C=>C.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(C,T,Z,z,X){super(),this.t=C,this.u=T,this.reconnectionToken=Z,this.protocol=z,this.w=X,this.m=this.B(new A.$6d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(V=>{const _=q(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(V=>{const _=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,E.$Rc)(()=>{const V=ue.j.indexOf(this);V>=0&&ue.j.splice(V,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const C=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const z=Z<T.length?T[Z]:T[T.length-1];try{if(z>0){const V=M(z);this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,V)),this.u.logService.info(`${C} waiting for ${z} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this.u.logService.info(`${C} resolving connection...`);const X=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${C} connecting to ${X.connectTo}...`),await this.G(X,$(m)),this.u.logService.info(`${C} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this.u.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(d.$ul.isTemporarilyNotAvailable(X)){this.u.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.u.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((0,O.$4)(X)){this.u.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if(X instanceof d.$ul){this.u.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,d.$ul.isHandled(X));break}this.u.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this.n&&!this.s)}C(C,T,Z){this.w?ue.triggerPermanentFailure(C,T,Z):this.D(C,T,Z)}D(C,T,Z){this.m.fire(new re(this.reconnectionToken,C,T,Z)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Il=ue;class Q extends ue{constructor(C,T,Z,z,X){super(1,C,z,X,!0),this.client=this.B(new k.$5h(X,{remoteAuthority:T,clientId:Z},C.ipcLogger))}async G(C,T){await i(C,T)}}e.$Jl=Q;class Y extends ue{constructor(C,T,Z,z,X){super(2,C,Z,z,!1),this.H=T,this.debugPort=X}async G(C,T){await s(C,this.H,T)}}e.$Kl=Y;function U(K){try{K.acceptDisconnect();const C=K.getSocket();K.dispose(),C.dispose()}catch(C){(0,O.$1)(C)}}function L(K){if(K&&K.type==="error"){const C=new Error(`Connection error: ${K.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function N(K,C){for(;K.length<C;)K+=" ";return K}function G(K,C){return`[remote-connection][${N(w(K),13)}][${C.substr(0,5)}\u2026]`}function q(K,C,T){return`${G(K,C)}[${T?"reconnect":"initial"}]`}function oe(K,C){return`${q(C,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(ae[68],ce([0,1,13]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=R,e.$sm=P,e.$tm=O,e.$um=A;function R(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function P(h){if(!h)return;const c=h.indexOf("+");return c<0?h:h.substr(0,c)}function O(h){const{host:c,port:b}=E(h);if(typeof b>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:b}}function A(h,c){let{host:b,port:y}=E(h);return typeof y>"u"&&(y=c),{host:b,port:y}}function E(h){const c=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const b=h.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(ae[124],ce([0,1,25,6,68]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Dm=e.$Cm=e.$Bm=e.TargetPlatform=e.ExtensionType=e.$Am=e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$zm=O,e.$Em=y,e.$Fm=k,e.$Gm=d,e.$Hm=m,e.$vm="extensions.user.cache",e.$wm="extensions.builtin.cache",e.$xm="undefined_publisher",e.$ym=["ui","workspace","web"];function O(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,$){if(typeof w>"u"||w===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof w=="string"||typeof $=="string"){const f=typeof w=="string"?w:w.value,u=typeof $=="string"?$:$.value;return n.$kf(f,u)}return w._lower===$._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Bm=h;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const $ of w)this.add($)}add(w){this.c.add(h.toKey(w))}delete(w){return this.c.delete(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}}e.$Cm=c;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(h.toKey(w))}get(w){return this.c.get(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}set(w,$){this.c.set(h.toKey(w),$)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Dm=b;function y(v){return k(v)}function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function m(v,w){if(w){const $=`onResolveRemoteAuthority:${(0,P.$sm)(w)}`;return!!v.activationEvents?.includes($)}return!1}e.$Im=(0,R.$gi)("IBuiltinExtensionsScannerService")}),define(ae[245],ce([0,1,2,6]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=void 0,e.$wl=(0,R.$gi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(A,E){return this.a[A]??=[],this.a[A].push(E),(0,n.$Rc)(()=>{const h=this.a[A]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[A]?.splice(h,1)})}b(A){return(this.a[A.type]||[]).find(h=>h.supports(A))}connect(A,E,h,c){const b=this.b(A);if(!b)throw new Error(`No socket factory found for ${A}`);return b.connect(A,E,h,c)}}e.$xl=P}),define(ae[246],ce([0,1,26,48,21,117]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=E;let A;async function E(d=!1){return(A===void 0||d)&&(A=h()),A}async function h(){const d=c();if(d===void 0)return!1;if(d>=22e3){const m=y();if(m)return new Promise(v=>{R.execFile(m,["--status"],w=>v(!w))})}else{const m=k();if(m)try{if((await P.Promises.stat(m)).isFile())return!0}catch{}}return!1}function c(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(d)return parseInt(d[3])}function b(d){const m=process.env.SystemRoot;if(m){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(m,v?"Sysnative":"System32",d)}}function y(){return b("wsl.exe")}function k(){return b("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,15,2,186,52,6,5,44]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=void 0,e.$zp=k,e.$Ap=d,e.$Bp=m,e.$Cp=v,e.$Dp=w,e.$Ep=$,e.$xp=(0,E.$gi)("requestService");class b{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends P.$Tc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,O.localize)(0,null),when:h.$5j.isEqualTo((0,h.$2j)(h.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new b(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$0)(i)),i}}}e.$yp=y;function k(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function d(g){return g.res.statusCode===204}async function m(g){return d(g)?null:(await(0,n.$Fe)(g.stream)).toString()}async function v(g){if(!k(g))throw new Error("Server returned "+g.res.statusCode);return m(g)}async function w(g){if(!k(g))throw new Error("Server returned "+g.res.statusCode);if(d(g))return null;const t=(await(0,n.$Fe)(g.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function $(g){u(g)}let f;function u(g){const a=c.$Yn.as(A.$4n.Configuration),t=f;f={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}u(1)}),define(ae[247],ce([0,1,17,23]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class P{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,c,b=R.CancellationToken.None){switch(h){case"request":return this.a.request(c[0],b).then(async({res:y,stream:k})=>{const d=await(0,n.$Fe)(k);return[{statusCode:y.statusCode,headers:y.headers},d]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Ar=P;class O{constructor(E){this.a=E}async request(E,h){const[c,b]=await this.a.call("request",[E],h);return{res:c,stream:(0,n.$He)(b)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Br=O}),define(ae[248],ce([0,1,249,12]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=O;function P(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function O(A,E,h={}){const c=(0,n.parse)(A),b=h.proxyUrl||P(c,E);if(!b)return null;const y=(0,n.parse)(b);if(!/^https?:$/.test(y.protocol||""))return null;const k={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,R.$Zf)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,m)=>{J(["http-proxy-agent"],d,m)})).HttpProxyAgent(b,k):new(await new Promise((d,m)=>{J(["https-proxy-agent"],d,m)})).HttpsProxyAgent(b,k)}}),define(ae[250],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.$sac=e.$rac=void 0,e.$rac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$sac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$tac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[95],ce([0,1,48,9,187,23,51,15,4,32,112,63,8,141]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=v;let m;async function v($,f,u,g){return u["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$km)(g)&&!u["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$km)(g)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new O.$de;let r=1e4;const i=$.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.$lm)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,P.localize)(0,null)))},r);try{a(await w(f,o.token))}catch(l){!(0,E.$4)(l)&&!o.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,A.$4i)(l)))):a({})}finally{clearTimeout(s),o.dispose()}})),m)}async function w($,f){const u=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",u);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",g);const a=(0,c.$Cg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const r=await(0,b.$am)(h.OS,o);return $.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new E.$5);const l=(0,R.$nc)(r);let p,I;const j="";/^pwsh(-preview)?$/.test(l)?(p=`& '${process.execPath}' ${j} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,I=["-Login","-Command"]):l==="nu"?(p=`^'${process.execPath}' ${j} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,I=["-i","-l","-c"]):l==="xonsh"?(p=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,I=["-i","-l","-c"]):(p=`'${process.execPath}' ${j} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?I=["-ic"]:I=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),p);const S=(0,n.spawn)(r,[...I,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(S.kill(),s(new E.$5))),S.on("error",W=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,A.$4i)(W)),s(W)});const D=[];S.stdout.on("data",W=>D.push(W));const M=[];S.stderr.on("data",W=>M.push(W)),S.on("close",(W,F)=>{const H=Buffer.concat(D).toString("utf8");$.trace("getUnixShellEnvironment#raw",H);const x=Buffer.concat(M).toString("utf8");if(x.trim()&&$.trace("getUnixShellEnvironment#stderr",x),W||F)return s(new Error((0,P.localize)(2,null,W,F)));const le=t.exec(H),re=le?le[1]:"{}";try{const ue=JSON.parse(re);u?ue.ELECTRON_RUN_AS_NODE=u:delete ue.ELECTRON_RUN_AS_NODE,g?ue.ELECTRON_NO_ATTACH_CONSOLE=g:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){$.error("getUnixShellEnvironment#errorCaught",(0,A.$4i)(ue)),s(ue)}})})}}),define(ae[251],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n9b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const O=await this.c();if(O){const A=String(n.a++);return this.b.set(A,O),{id:A,data:O.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,O){if(!P.id)return!0;const A=this.b.get(P.id);if(!A)return!1;this.b.delete(P.id);try{return A.validate(O)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$n9b=n}),define(ae[96],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl="signService",e.$zl=(0,n.$gi)(e.$yl)}),define(ae[252],ce([0,1,251]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;class R extends n.$n9b{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(A=>new A.signer().sign(O))}h(){return new Promise((O,A)=>J(["vsda"],O,A))}}e.$hbc=R}),define(ae[34],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.$MP=void 0,e.$MP=(0,n.$gi)("stateReadService"),e.$NP=(0,n.$gi)("stateService")}),define(ae[125],ce([0,1,8,17,2,12,38,16,5]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=e.$OP=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class b extends P.$Tc{constructor(m,v,w,$){super(),this.h=m,this.j=v,this.m=w,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$eh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,v){const w=this.a[m];return(0,O.$3f)(w)?v:w}setItem(m,v){this.setItems([{key:m,data:v}])}setItems(m){let v=!1;for(const{key:w,data:$}of m)this.a[w]!==$&&((0,O.$3f)($)?(0,O.$1f)(this.a[w])||(this.a[w]=void 0,v=!0):(this.a[w]=$,v=!0));v&&this.s()}removeItem(m){(0,O.$1f)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,R.$te.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$OP=b;let y=class extends P.$Tc{constructor(m,v,w,$){super(),this.a=this.B(new b(v.stateResource,m,w,$))}async init(){await this.a.init()}getItem(m,v){return this.a.getItem(m,v)}};e.$PP=y,e.$PP=y=ve([se(1,A.$ni),se(2,h.$Mj),se(3,E.$Mk)],y);class k extends y{setItem(m,v){this.a.setItem(m,v)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$QP=k}),define(ae[126],ce([0,1,4,36,32]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=A,e.$1o=E;function O(h){if(n.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,c,b,y,k,d,m,v,w){const $=Object.create(null);$["common.machineId"]=d,$["common.sqmId"]=m,$.sessionID=(0,P.$Cg)()+Date.now(),$.commitHash=y,$.version=k,$["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$h)(n.$u),$["common.nodePlatform"]=R.$dc,$["common.nodeArch"]=b,$["common.product"]=w||"desktop",v&&($["common.msftInternal"]=v);let f=0;const u=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&($["common.snap"]="true");const g=O(c);return g&&($["common.platformDetail"]=g),$}function E(h){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const b=c.toLowerCase();return h.some(y=>b===y)}}),define(ae[28],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0,e.$Ll=(0,n.$gi)("telemetryService"),e.$Ml=(0,n.$gi)("customEndpointTelemetryService"),e.$Nl="telemetry.currentSessionDate",e.$Ol="telemetry.firstSessionDate",e.$Pl="telemetry.lastSessionDate",e.$Ql="telemetry.machineId",e.$Rl="telemetry.sqmId",e.$Sl="telemetry",e.$Tl="telemetry.telemetryLevel",e.$Ul="telemetry.enableCrashReporter",e.$Vl="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ae[253],ce([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0,e.$js=$,e.$ks=u,e.$ls=g;const w=new Map;async function $(t,o){const r=`${t}::${o.join(":")}`,i=w.get(r);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,p=new Map,I=2e4;function j(D,M,W,F){const H=M.substring(D.length+1);return R.Promises.withAsyncBody(async x=>{let le;try{le=await b.Promises.readdir(M,{withFileTypes:!0})}catch{x();return}if(F.count>=I){F.count+=le.length,F.maxReached=!0,x();return}let re=le.length;if(re===0){x();return}let ue=le;F.count+le.length>I&&(F.maxReached=!0,re=I-F.count,ue=le.slice(0,re)),F.count+=le.length;for(const Q of ue)if(Q.isDirectory()){if(W.includes(Q.name)||await j(D,(0,A.$jc)(M,Q.name),W,F),--re===0){x();return}}else{const Y=Q.name.lastIndexOf(".");if(Y>=0){const U=Q.name.substring(Y+1);U&&l.set(U,(l.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(H)!==!1&&U.filePattern.test(Q.name)&&p.set(U.tag,(p.get(U.tag)??0)+1);if(--re===0){x();return}}})}const S=R.Promises.withAsyncBody(async D=>{const M={count:0,maxReached:!1};await j(t,t,o,M);const W=await g(t);D({configFiles:f(p),fileTypes:f(l),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:W})});return w.set(r,S),S}function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function u(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/d.$il.GB).toFixed(2)}GB (${(n.freemem()/d.$il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$on.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function g(t){try{const o=new Map,r=(0,A.$jc)(t,".vscode","launch.json"),i=await b.Promises.readFile(r),s=[],l=(0,P.$tn)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,P.$Cn)(l)==="object"&&l.configurations)for(const p of l.configurations){const I=p.type;I&&(o.has(I)?o.set(I,o.get(I)+1):o.set(I,1))}return f(o)}catch{return[]}}let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/d.$il.GB).toFixed(2)}GB (${(n.freemem()/d.$il.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(c.$on.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,y.$is)(o.mainPID),this.k(o)]).then(async i=>{let[s,l]=i,p=this.m(o,s);return r.forEach(I=>{if((0,k.$1m)(I))p+=`
${I.errorMessage}`,l+=`
${I.errorMessage}`;else if(p+=`

Remote: ${I.hostName}`,I.processes&&(p+=`
${this.m(o,I.processes)}`),I.workspaceMetadata){l+=`
|  Remote: ${I.hostName}`;for(const j of Object.keys(I.workspaceMetadata)){const S=I.workspaceMetadata[j];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),l+=`|    Folder (${j}): ${D}`,l+=this.h(S)}}}),{processInfo:p,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:i,vmHint:s,os:l,cpus:p}=u(),I={os:l,memory:i,cpus:p,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(I.load=`${n.loadavg().map(j=>Math.round(j)).join(", ")}`),E.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(o,r){const i=[];return(0,y.$is)(o.mainPID).then(async s=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,s)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(l=>{if((0,k.$1m)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(o,l.processes)),l.workspaceMetadata)for(const p of Object.keys(l.workspaceMetadata)){const I=l.workspaceMetadata[p];let j=`${I.fileCount} files`;I.maxFilesReached&&(j=`more than ${j}`),i.push(`Folder (${p}): ${j}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let s=0;const l=(S,D)=>{const M=` ${S}(${D})`;s+M.length>60?(r.push(p),p="|                 ",s=p.length):s+=M.length,p+=M};let p="|      File types:";const I=10,j=o.fileTypes.length>I?I:o.fileTypes.length;for(let S=0;S<j;S++){const D=o.fileTypes[S];l(D.name,D.count)}if(r.push(p),o.configFiles.length>=0&&(p="|      Conf files:",s=0,o.configFiles.forEach(S=>{l(S.name,S.count)}),r.push(p)),o.launchConfigFiles.length>0){let S="|      Launch Configs:";o.launchConfigFiles.forEach(D=>{const M=D.count>1?` ${D.name}(${D.count})`:` ${D.name}`;S+=M}),r.push(S)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const p=h.URI.revive(l);if(p.scheme===O.Schemas.file){const I=p.fsPath;i.push($(I,["node_modules",".git"]).then(j=>{let S=`${j.fileCount} files`;j.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,A.$nc)(I)}): ${S}`),r.push(this.h(j))}).catch(j=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${j.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,r){const i=new Map;o.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:p})=>i.set(l,p));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,s,r,0),s.join(`
`)}n(o,r,i,s,l){const p=l===0;let I;p?I=s.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?I=r.get(s.pid):I=`${"  ".repeat(l)} ${s.name}`;const j=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(j/d.$il.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(s.children)&&s.children.forEach(S=>this.n(o,r,i,S,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const s=h.URI.revive(i);if(s.scheme!==O.Schemas.file)continue;const l=s.fsPath;try{(await $(l,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=h.URI.revive(r);if(i.scheme!==O.Schemas.file)continue;const s=i.fsPath;try{const l=await $(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$ms=a,e.$ms=a=ve([se(0,v.$Ll),se(1,m.$6j)],a)}),define(ae[254],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=void 0;class n{constructor(O){this.b=O}listen(O,A){throw new Error(`Event not found: ${A}`)}call(O,A,{eventName:E,data:h}){return this.b.forEach(c=>c.log(E,h)),Promise.resolve(null)}}e.$wac=n;class R{constructor(O){this.b=O}log(O,A){return this.b.call("log",{eventName:O,data:A}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$xac=R}),define(ae[54],ce([0,1,35,12,68,126,28]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=b,e.$0o=y,e.$$o=k,e.$_o=d,e.$ap=v,e.$bp=$,e.$cp=f,e.$dp=a;class E{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$2o=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3o=h,e.$4o=new h;class c{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$5o=c,e.$6o="telemetry",e.$7o="extensionTelemetryLog",e.$8o={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function k(t){const o=t.getValue(A.$Tl),r=t.getValue(A.$Ul);if(t.getValue(A.$Vl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function d(t){const o={},r={},i={};w(t,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const l=i[s];typeof l=="number"?r[s]=l:typeof l=="boolean"?r[s]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${l.length}`),o[s]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(o[s]=l)}return{properties:o,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,P.$sm)(t);return m.has(o)?o:"other"}function w(t,o,r=0,i){if(t)for(const s of Object.getOwnPropertyNames(t)){const l=t[s],p=i?i+s:s;Array.isArray(l)?o[p]=(0,n.$Rn)(l):l instanceof Date?o[p]=l.toISOString():(0,R.$Vf)(l)?r<2?w(l,o,r+1,p+"."):o[p]=(0,n.$Rn)(l):o[p]=l}}function $(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,O.$1o)(r)||i}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function u(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const I of o)for(;;){const j=I.exec(t);if(!j)break;i.push([j.index,I.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const I=l.exec(t);if(!I)break;const j=i.some(([S,D])=>I.index<D&&S<l.lastIndex);!s.test(I[0])&&!j&&(r+=t.substring(p,I.index)+"<REDACTED: user-file-path>",p=l.lastIndex)}return p<t.length&&(r+=t.substr(p)),r}function g(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,n.$On)(t,r=>{if(r instanceof E||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=u(i,o);for(const s of o)i=i.replace(s,"");return i=g(i),i}})}}),define(ae[127],ce([0,1,25,121,124,4,7,15,36,54]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$fp=void 0,e.$ep=b,e.$gp=m,e.$hp=v,e.$ip=w,e.$jp=$,e.$kp=f,e.$lp=u,e.$mp=g,e.$op=a,e.$pp=o;function b(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.$ff)(r.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const s=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,s,l)}static parse(i){const s=y.exec(i);return s&&s[1]&&s[2]?new k({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$fp=k;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=d.exec(r);return i&&i[1]?[w(i[1]),i[2]]:[w(r),void 0]}function v(r,i){return`${r}.${i}`}function w(r){return r.toLowerCase()}function $(r,i){return w(v(r??P.$xm,i))}function f(r,i){const s=[],l=p=>{for(const I of s)if(I.some(j=>b(i(j),i(p))))return I;return null};for(const p of r){const I=l(p);I?I.push(p):s.push([p])}return s}function u(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function g(r){return{id:new c.$2o(r.identifier.id),name:new c.$2o(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$np=new P.$Bm("pprice.better-merge");function a(r,i){const s=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const p=l.shift();if(p&&s.every(I=>!b(I.identifier,{id:p}))){const I=r.filter(j=>b(j.identifier,{id:p}));I.length===1&&(s.push(I[0]),l.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,i){if(!O.$k)return!1;let s;try{s=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,E.$0)(p))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const s=await t(r,i),l=(0,R.$Lo)(s?"alpine":O.$u,h.$ec);return i.debug("ComputeTargetPlatform:",l),l}}),define(ae[255],ce([0,1,209,54]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=P;async function P(O,A,E,h,c,b,y){const k={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${A.nameShort})`};if((0,R.$9o)(A,E)&&(0,R.$$o)(h)===3){const d=await(0,n.$Qp)(E,c,b);k["X-Market-User-Id"]=d,k["VSCode-SessionId"]=y.machineId||d}return k}}),define(ae[256],ce([0,1,2,35,4,25,188,18,52,79,27,44,28,54]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,f,u){this.k=f,this.l=u,this.d={},this.i=new n.$Sc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,O.$Ye)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$Ye)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(k.$Tl)||g.affectsConfiguration(k.$Vl)||g.affectsConfiguration(k.$Ul))&&this.m()}))}setExperimentProperty($,f){this.d[$]=f}m(){let $=(0,d.$$o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;$=Math.min($,u)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,f,u){this.g<f||(u=(0,R.$Pn)(u,this.d),u=(0,d.$dp)(u,this.j),u=(0,R.$Pn)(u,this.c),this.b.forEach(g=>g.log($,u)))}publicLog($,f){this.n($,3,f)}publicLog2($,f){this.publicLog($,f)}publicLogError($,f){this.h&&this.n($,2,f)}publicLogError2($,f){this.publicLogError($,f)}};e.$Fr=m,e.$Fr=m=ve([se(1,E.$Mi),se(2,b.$6j)],m);function v(){const w=(0,A.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=P.$o?"":(0,A.localize)(3,null),u=(0,A.localize)(4,null),g=(0,A.localize)(5,null),a=(0,A.localize)(6,null),t=(0,A.localize)(7,null),o=`
|       | ${u} | ${g} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${w} ${$} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}y.$Yn.as(h.$4n.Configuration).registerConfiguration({id:k.$Sl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[k.$Tl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$Yn.as(h.$4n.Configuration).registerConfiguration({id:k.$Sl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[k.$Vl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${k.$Tl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[257],ce([0,1,4,89,28]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=O,e.$Zac=A;async function O(E,h){let c=E.getItem(P.$Ql);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,R.$pn)(h.error.bind(h))),c}async function A(E,h){let c=E.getItem(P.$Rl);return typeof c!="string"&&(c=await(0,R.$qn)(h.error.bind(h))),c}}),define(ae[258],ce([0,1,28,257]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=P,e.$2ac=O;async function P(A,E){const h=await(0,R.$Yac)(A,E);return A.setItem(n.$Ql,h),h}async function O(A,E){const h=await(0,R.$Zac)(A,E);return A.setItem(n.$Rl,h),h}}),define(ae[128],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ae[259],ce([0,1,4,128]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;const P=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach((y,k)=>{this.d(y,k);const d=y.map.entries();let m=d.next();for(;!m.done;){const v=m.value[1],w=m.value[0];let $=this.a.get(w);if($||($=[],this.a.set(w,$)),$.length>0&&$[0].type===R.EnvironmentVariableMutatorType.Replace){m=d.next();continue}const f={extensionIdentifier:k,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,$.unshift(f),m=d.next()}})}async applyToProcessEnvironment(b,y,k){let d;n.$i&&(d={},Object.keys(b).forEach(m=>d[m.toLowerCase()]=m));for(const[m,v]of this.getVariableMap(y)){const w=n.$i&&d[m.toLowerCase()]||m;for(const $ of v){const f=k?await k($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case R.EnvironmentVariableMutatorType.Append:b[w]=(b[w]||"")+f;break;case R.EnvironmentVariableMutatorType.Prepend:b[w]=f+(b[w]||"");break;case R.EnvironmentVariableMutatorType.Replace:b[w]=f;break}if($.options?.applyAtShellIntegration??!1){const u=`VSCODE_ENV_${P.get($.type)}`;b[u]=(b[u]?b[u]+":":"")+m+"="+this.c(f)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,y){const k=new Map,d=new Map,m=new Map;if(b.getVariableMap(y).forEach((v,w)=>{const $=this.getVariableMap(y).get(w),f=E(v,$);f&&k.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const $=b.getVariableMap(y).get(w),f=E(v,$);f&&m.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const $=b.getVariableMap(y).get(w),f=h(v,$);f&&d.set(w,f)}),!(k.size===0&&d.size===0&&m.size===0))return{added:k,changed:d,removed:m}}getVariableMap(b){const y=new Map;for(const k of this.a.values()){const d=k.filter(m=>A(m,b));d.length>0&&y.set(d[0].variable,d)}return y}getDescriptionMap(b){const y=new Map;for(const k of this.b.values()){const d=k.filter(m=>A(m,b,!0));for(const m of d)y.set(m.extensionIdentifier,m.description)}return y}d(b,y){if(!b.descriptionMap)return;const k=b.descriptionMap.entries();let d=k.next();for(;!d.done;){const m=d.value[1],v=d.value[0];let w=this.b.get(v);w||(w=[],this.b.set(v,w));const $={extensionIdentifier:y,scope:m.scope,description:m.description};$.scope||delete $.scope,w.push($),d=k.next()}}}e.$9r=O;function A(c,b,y=!1){return c.scope?!!(c.scope.workspaceFolder&&b?.workspaceFolder&&c.scope.workspaceFolder.index===b.workspaceFolder.index):y?b===c.scope:!0}function E(c,b){if(!b)return c;const y=new Set;b.forEach(d=>y.add(d.extensionIdentifier));const k=[];return c.forEach(d=>{y.has(d.extensionIdentifier)||k.push(d)}),k.length===0?void 0:k}function h(c,b){if(!b)return;const y=new Map;b.forEach(d=>y.set(d.extensionIdentifier,d));const k=[];return c.forEach(d=>{const m=y.get(d.extensionIdentifier);m&&(d.type!==m.type||d.value!==m.value||d.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(ae[260],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=n,e.$4r=R,e.$5r=P,e.$6r=O,e.$7r=A,e.$8r=E;function n(h){return[...h.entries()]}function R(h){return h?[...h.entries()]:[]}function P(h){return new Map(h)}function O(h){return new Map(h??[])}function A(h){return Array.from(h.entries()).map(c=>[c[0],n(c[1].map),R(c[1].descriptionMap)])}function E(h){return new Map(h.map(c=>[c[0],{map:P(c[1]),descriptionMap:O(c[2])}]))}}),define(ae[261],ce([0,1,8,23,3,2,5]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;let E=class extends O.$Tc{constructor(c,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$6d),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,O.$Rc)(()=>{for(const y of this.f.values())(0,O.$Oc)(y)}))}createRequest(c){return new Promise((b,y)=>{const k=++this.a;this.c.set(k,b),this.g.fire({requestId:k,...c});const d=new R.$de;(0,n.$hh)(this.b,d.token).then(()=>y(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,O.$Rc)(()=>d.cancel())])})}acceptReply(c,b){const y=this.c.get(c);y?(this.c.delete(c),(0,O.$Oc)(this.f.get(c)||[]),this.f.delete(c),y(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$Tr=E,e.$Tr=E=ve([se(1,A.$Mj)],E)}),define(ae[129],ce([0,1,6,118,44]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=e.$Nr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Mr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Lr=void 0,e.$Lr=new R.$xj("terminalTabFocusMode",!1,!0);var O;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.ExperimentalInlineChat="workbench.action.terminal.experimentalInlineChat",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var b;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Mr=(0,n.$gi)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var d;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var $;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var u;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(u||(e.TerminalExitReason=u={})),e.$Nr={Backend:"workbench.contributions.terminal.processBackend"};class g{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$Yn.add(e.$Nr.Backend,new g),e.$Or=(0,n.$gi)("localPtyService"),e.$Pr=(0,n.$gi)("terminalLogService")}),define(ae[262],ce([0,1,74,7,190,106]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=A,e.$Vr=c,e.$Wr=b,e.$Xr=y;function A(k,d){const m=[{name:null,description:(0,P.localize)(0,null)}];return m.push(...k.map(v=>({name:v.profileName,description:E(v)}))),d&&m.push(...d.map(v=>({name:v.title,description:h(v)}))),{values:m.map(v=>v.name),markdownDescriptions:m.map(v=>v.description)}}function E(k){let d=`$(${O.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Fj.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?d+=`
- args: "${k.args}"`:d+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&(d+=`
- overrideName: ${k.overrideName}`),k.color&&(d+=`
- color: ${k.color}`),k.env&&(d+=`
- env: ${JSON.stringify(k.env)}`),d}function h(k){return`$(${O.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Fj.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function c(k,d){if(!k&&!d)return!0;if(typeof k=="string"&&typeof d=="string")return k===d;if(Array.isArray(k)&&Array.isArray(d)){if(k.length!==d.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==d[m])return!1;return!0}return!1}function b(k,d){if(!k&&!d)return!0;if(!k||!d)return!1;if(O.ThemeIcon.isThemeIcon(k)&&O.ThemeIcon.isThemeIcon(d))return k.id===d.id&&k.color===d.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof d=="object"&&"light"in d&&"dark"in d){const m=k,v=d;if((R.URI.isUri(m.light)||y(m.light))&&(R.URI.isUri(m.dark)||y(m.dark))&&(R.URI.isUri(v.light)||y(v.light))&&(R.URI.isUri(v.dark)||y(v.dark)))return m.light.path===v.light.path&&m.dark.path===v.dark.path}if(R.URI.isUri(k)&&R.URI.isUri(d)||y(k)||y(d)){const m=k,v=d;return m.path===v.path&&m.scheme===v.scheme}return!1}function y(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}}),define(ae[263],ce([0,1,74,4,189,52,44,262]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=void 0,e.$1r=d,e.$2r=v,e.$Yr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Zr={type:"string",enum:Array.from((0,n.$Dj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Dj)(),w=>`$(${w.id})`)};const h={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$Zr},color:{description:(0,P.localize)(3,null),...e.$Yr},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},b={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function y(w){const $=w===2?"linux":w===1?"osx":"windows";return(0,P.localize)(7,null,(0,R.$h)(w),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,P.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,P.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,P.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){A.$Yn.as(O.$4n.Configuration).registerConfiguration(k),v()}let m;function v(w,$){const f=A.$Yn.as(O.$4n.Configuration);let u;w&&(u=(0,E.$Ur)(w?.profiles,$));const g=m;m={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?u?.values:void 0,markdownEnumDescriptions:w?.os===3?u?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?u?.values:void 0,markdownEnumDescriptions:w?.os===2?u?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?u?.values:void 0,markdownEnumDescriptions:w?.os===1?u?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:g?[g]:[]})}}),define(ae[264],ce([0,1,26,13,35,9,4,36,25,12,21,128,260,259]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=m,e.$$r=v,e.$_r=w;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}async function v(i,s,l,p=E.env,I=b.Promises.exists){if(O.$ic(i))return await I(i)?i:void 0;if(s===void 0&&(s=E.cwd()),O.$mc(i)!=="."){const M=O.$jc(s,i);return await I(M)?M:void 0}const S=(0,P.$Tn)(p,"PATH");if(l===void 0&&(0,c.$Tf)(S)&&(l=S.split(O.$tc)),l===void 0||l.length===0){const M=O.$jc(s,i);return await I(M)?M:void 0}for(const M of l){let W;if(O.$ic(M)?W=O.$jc(M,i):W=O.$jc(s,M,i),await I(W))return W;if(A.$i){let F=W+".com";if(await I(F)||(F=W+".exe",await I(F)))return F}}const D=O.$jc(s,i);return await I(D)?D:void 0}function w(i,s,l,p,I){const j=A.$i&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.hideFromUser||i.ignoreShellIntegration||j)return;const S=i.args,D=E.$dc==="win32"?O.$nc(i.executable).toLowerCase():O.$nc(i.executable),M=O.$mc(R.$Ag.asFileUri("").fsPath);let W;const F={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(F.VSCODE_NONCE=s.shellIntegration.nonce),A.$i){if(D==="pwsh.exe"||D==="powershell.exe")return!S||o(S)?W=u.get(f.WindowsPwsh):t(S)&&(W=u.get(f.WindowsPwshLogin)),W?(W=[...W],W[W.length-1]=(0,h.$Ue)(W[W.length-1],M,""),s.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:W,envMixin:F}):void 0;p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(D){case"bash":return!S||S.length===0?W=u.get(f.Bash):r(S)&&(F.VSCODE_SHELL_LOGIN="1",$(s,F),W=u.get(f.Bash)),W?(W=[...W],W[W.length-1]=(0,h.$Ue)(W[W.length-1],M),{newArgs:W,envMixin:F}):void 0;case"fish":{const H=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${H}:${x}`,$(s,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!S||o(S)?W=u.get(f.Pwsh):t(S)&&(W=u.get(f.PwshLogin)),W?(s.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),W=[...W],W[W.length-1]=(0,h.$Ue)(W[W.length-1],M,""),{newArgs:W,envMixin:F}):void 0;case"zsh":{if(!S||S.length===0?W=u.get(f.Zsh):r(S)?(W=u.get(f.ZshLogin),$(s,F)):(S===u.get(f.Zsh)||S===u.get(f.ZshLogin))&&(W=S),!W)return;W=[...W],W[W.length-1]=(0,h.$Ue)(W[W.length-1],M);let H;try{H=n.userInfo().username}catch{H="unknown"}const x=O.$jc(n.tmpdir(),`${H}-${I.applicationName}-zsh`);F.ZDOTDIR=x;const le=l?.ZDOTDIR??n.homedir()??"~";F.USER_ZDOTDIR=le;const re=[];return re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$jc(x,".zshrc")}),re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$jc(x,".zprofile")}),re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$jc(x,".zshenv")}),re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$jc(x,".zlogin")}),{newArgs:W,envMixin:F,filesToCopy:re}}}p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}function $(i,s){if(A.$j&&i.environmentVariableCollections){const l=(0,k.$8r)(i.environmentVariableCollections),I=new d.$9r(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),j=[];if(I)for(const S of I)S.type===y.EnvironmentVariableMutatorType.Prepend&&j.push(S.value);j.length>0&&(s.VSCODE_PATH_PREFIX=j.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const u=new Map;u.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),u.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),u.set(f.Zsh,["-i"]),u.set(f.ZshLogin,["-il"]),u.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?g.includes(i.toLowerCase()):i.length===1&&g.includes(i[0].toLowerCase())||i.length===2&&(g.includes(i[0].toLowerCase())||g.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&g.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&g.includes(i[0].toLowerCase())}}),define(ae[265],ce([0,1,48,74,9,4,12,21,110,264,117]),function(J,e,n,R,P,O,A,E,h,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=m;var y;(function(l){l.UnixShellsPath="/etc/shells"})(y||(y={}));let k,d=!0;function m(l,p,I,j,S=process.env,D,M,W,F){return D=D||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},O.$i?v(I,D,S,M,j.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:j.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:j.getValue("terminal.integrated.defaultProfile.windows"),F,W):r(D,M,I,l&&typeof l=="object"?{...l}:j.getValue(O.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:j.getValue(O.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,S)}async function v(l,p,I,j,S,D,M,W,F){const H=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${H?"Sysnative":"System32"}`;let le=!1;(0,c.$0r)()>=16299&&(le=!0),await u(W);const re=new Map;if(l){re.set("PowerShell",{source:"PowerShell",icon:R.$Fj.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Fj.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:R.$Fj.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:R.$Fj.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}i(D,re);const ue=await w(re.entries(),M,p,I,j,F);if(l&&S)try{const Q=await t(`${x}\\${le?"wsl":"bash"}.exe`,M);for(const Y of Q)(!D||!(Y.profileName in D))&&ue.push(Y)}catch{d&&(j?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return ue}async function w(l,p,I,j=process.env,S,D){const M=[];for(const[W,F]of l)M.push($(W,F,p,I,j,S,D));return(await Promise.all(M)).filter(W=>!!W)}async function $(l,p,I,j,S=process.env,D,M){if(p===null)return;let W,F,H;if("source"in p&&!("path"in p)){const ue=k?.get(p.source);if(!ue)return;W=ue.paths,F=p.args||ue.args,p.icon?H=f(p.icon):ue.icon&&(H=ue.icon)}else W=Array.isArray(p.path)?p.path:[p.path],F=O.$i||Array.isArray(p.args)?p.args:void 0,H=f(p.icon);let x;if(M){const ue=W.map(Y=>typeof Y=="string"?Y:Y.path),Q=await M(ue);x=new Array(W.length);for(let Y=0;Y<W.length;Y++)typeof W[Y]=="string"?x[Y]=Q[Y]:x[Y]={path:Q[Y],isUnsafe:!0}}else x=W.slice();let le;if(p.requiresPath){let ue;if((0,A.$Tf)(p.requiresPath)?ue=p.requiresPath:(ue=p.requiresPath.path,p.requiresPath.isUnsafe&&(le=ue)),!await j.existsFile(ue))return}const re=await s(l,I,x,j,S,F,p.env,p.overrideName,p.isAutoDetected,le);if(!re){D?.debug("Terminal profile not validated",l,W);return}return re.isAutoDetected=p.isAutoDetected,re.icon=H,re.color=p.color,re}function f(l){return typeof l=="string"?{id:l}:l}async function u(l){if(k&&!l)return;const[p,I]=await Promise.all([g(),l||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:I,icon:R.$Fj.terminalPowershell})}async function g(){const l=new Set,p=await(0,c.$$r)("git.exe");if(p){const S=(0,b.dirname)(p);l.add((0,b.resolve)(S,"../.."))}function I(S,D){D&&S.add(D)}I(l,process.env.ProgramW6432),I(l,process.env.ProgramFiles),I(l,process.env["ProgramFiles(X86)"]),I(l,`${process.env.LocalAppData}\\Program`);const j=[];for(const S of l)j.push(`${S}\\Git\\bin\\bash.exe`,`${S}\\Git\\usr\\bin\\bash.exe`,`${S}\\usr\\bin\\bash.exe`);return j.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),j.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),j}async function a(){const l=[];for await(const p of(0,h.$7l)())l.push(p.exePath);return l}async function t(l,p){const I=[],j=await new Promise((M,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,H)=>{if(F)return W("Problem occurred when getting wsl distros");M(H)})});if(!j)return[];const S=new RegExp(/[\r?\n]/),D=j.split(S).filter(M=>M.trim().length>0&&M!=="");for(const M of D){if(M===""||M.startsWith("docker-desktop"))continue;const W=`${M} (WSL)`,F={profileName:W,path:l,args:["-d",`${M}`],isDefault:W===p,icon:o(M),isAutoDetected:!1};I.push(F)}return I}function o(l){return l.includes("Ubuntu")?R.$Fj.terminalUbuntu:l.includes("Debian")?R.$Fj.terminalDebian:R.$Fj.terminalLinux}async function r(l,p,I,j,S,D,M,W){const F=new Map;if(I&&await l.existsFile("/etc/shells")){const H=(await l.readFile("/etc/shells")).toString(),x=(D||H.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),le=new Map;for(const re of x){let ue=(0,P.$nc)(re),Q=le.get(ue)||0;Q++,Q>1&&(ue=`${ue} (${Q})`),le.set(ue,Q),F.set(ue,{path:re,isAutoDetected:!0})}}return i(j,F),await w(F.entries(),S,l,W,p,M)}function i(l,p){if(l)for(const[I,j]of Object.entries(l))j===null||typeof j!="object"||!("path"in j)&&!("source"in j)?p.delete(I):(j.icon=j.icon||p.get(I)?.icon,p.set(I,j))}async function s(l,p,I,j,S,D,M,W,F,H){if(I.length===0)return Promise.resolve(void 0);const x=I.shift();if(x==="")return s(l,p,I,j,S,D,M,W,F);const le=typeof x!="string"&&x.isUnsafe,re=typeof x=="string"?x:x.path,ue={profileName:l,path:re,args:D,env:M,overrideName:W,isAutoDetected:F,isDefault:l===p,isUnsafePath:le,requiresUnsafePath:H};if((0,P.$nc)(re)===re){const Y=S.PATH?S.PATH.split(P.$tc):void 0,U=await(0,c.$$r)(re,void 0,Y,void 0,j.existsFile);return U?(ue.path=U,ue.isFromPath=!0,ue):s(l,p,I,j,S,D)}return await j.existsFile((0,P.$hc)(re))?ue:s(l,p,I,j,S,D,M,W,F)}}),define(ae[266],ce([0,1,3,2,4,43,18,5,229,95,261,129,263,265,112,72]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;var w;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let $=class extends R.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(u,g,a,t){super(),this.M=u,this.N=g,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$6d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$6d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$6d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$6d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$6d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$6d),this.onProcessData=this.D.event,this.F=this.B(new n.$6d),this.onProcessReady=this.F.event,this.G=this.B(new n.$6d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$6d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$6d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$6d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$6d),this.onProcessExit=this.L.event,(0,k.$1r)(),this.B(this.M),this.B((0,R.$Rc)(()=>this.W())),this.j=this.B(new b.$Tr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$i)return process.env;try{return await(0,c.$qm)(this.N,this.O,{_:[]},process.env)}catch(u){return this.O.error("ptyHost was unable to resolve shell environment",u),{}}}U(){const u=this.M.start(),g=u.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(g.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(u.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=O.ProxyChannel.toService(g.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new h.$Sr(this.P,g.getChannel(y.TerminalIpcChannels.Logger))),this.a=u,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[u,t]}async createProcess(u,g,a,t,o,r,i,s,l,p,I){const j=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),S=await this.f.createProcess(u,g,a,t,o,r,i,s,l,p,I);return clearTimeout(j),S}updateTitle(u,g,a){return this.f.updateTitle(u,g,a)}updateIcon(u,g,a,t){return this.f.updateIcon(u,g,a,t)}attachToProcess(u){return this.f.attachToProcess(u)}detachFromProcess(u,g){return this.f.detachFromProcess(u,g)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(u){return this.f.start(u)}shutdown(u,g){return this.f.shutdown(u,g)}input(u,g){return this.f.input(u,g)}processBinary(u,g){return this.f.processBinary(u,g)}resize(u,g,a){return this.f.resize(u,g,a)}clearBuffer(u){return this.f.clearBuffer(u)}acknowledgeDataEvent(u,g){return this.f.acknowledgeDataEvent(u,g)}setUnicodeVersion(u,g){return this.f.setUnicodeVersion(u,g)}getInitialCwd(u){return this.f.getInitialCwd(u)}getCwd(u){return this.f.getCwd(u)}async getLatency(){const u=new v.$2d,g=await this.f.getLatency();return u.stop(),[{label:"ptyhostservice<->ptyhost",latency:u.elapsed()},...g]}orphanQuestionReply(u){return this.f.orphanQuestionReply(u)}installAutoReply(u,g){return this.f.installAutoReply(u,g)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(u){return this.f.uninstallAutoReply(u)}getDefaultSystemShell(u){return this.g?.getDefaultSystemShell(u)??(0,m.$am)(u??P.OS,process.env)}async getProfiles(u,g,a,t=!1){const o=await this.S();return(0,d.$as)(g,a,t,this.N,o,void 0,this.O,this.bb.bind(this,u))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(u,g){return this.f.getWslPath(u,g)}getRevivedPtyNewId(u,g){return this.f.getRevivedPtyNewId(u,g)}setTerminalLayoutInfo(u){return this.f.setTerminalLayoutInfo(u)}async getTerminalLayoutInfo(u){return this.g?.getTerminalLayoutInfo(u)}async requestDetachInstance(u,g){return this.f.requestDetachInstance(u,g)}async acceptDetachInstanceReply(u,g){return this.f.acceptDetachInstanceReply(u,g)}async freePortKillProcess(u){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(u)}async serializeTerminalState(u){return this.f.serializeTerminalState(u)}async reviveTerminalProcesses(u,g,a){return this.f.reviveTerminalProcesses(u,g,a)}async refreshProperty(u,g){return this.f.refreshProperty(u,g)}async updateProperty(u,g,a){return this.f.updateProperty(u,g,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(u){this.ab(),this.s=setTimeout(()=>this.Y(),u?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(u,g){return this.j.createRequest({workspaceId:u,originalText:g})}async acceptPtyHostResolvedVariables(u,g){this.j.acceptReply(u,g)}};e.$bs=$,e.$bs=$=ve([se(1,A.$Mi),se(2,E.$Mj),se(3,E.$Nj)],$)}),define(ae[69],ce([0,1,14,3,2,4,18,6,34]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_b=e.$m_b=void 0;const c="#FFFFFF",b="#1E1E1E",y="#000000",k="#FFFFFF",d="theme",m="themeBackground",v="windowSplash";e.$m_b=(0,E.$gi)("themeMainService");let w=class extends P.$Tc{constructor(f,u){super(),this.b=f,this.c=u,this.a=this.B(new R.$6d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(g=>{g.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(O.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:k;let u=this.b.getItem(m,null);if(!u)switch(this.g()){case"vs":u=c;break;case"hc-black":u=y;break;case"hc-light":u=k;break;default:u=b}return O.$j&&u.toUpperCase()===b&&(u="#171717"),u}g(){switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,u){this.b.setItems([{key:d,data:u.baseTheme},{key:m,data:u.colorInfo.background},{key:v,data:u}]),typeof f=="number"&&this.h(f,u),this.f()}h(f,u){for(const g of n.BrowserWindow.getAllWindows())if(g.id===f){g.setBackgroundColor(u.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$n_b=w,e.$n_b=w=ve([se(0,h.$NP),se(1,A.$Mi)],w)}),define(ae[130],ce([0,1,3,7,18,6,5]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$Zv=e.$Xv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tv=e.$Sv=void 0,e.$Uv=c,e.$Vv=y,e.$Wv=k,e.$Yv=d,e.$1v=m,e.$2v=v,e.$Sv=(0,O.$gi)("tunnelService"),e.$Tv=(0,O.$gi)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(h||(e.TunnelPrivacyId=h={}));function c(f){return!!f.forwardPort}var b;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(u)return{address:u[1],port:+u[2]}}function k(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const u=f.query.split("&");for(const g of u){const a=g.split("=")[1];if(/^https?:/.exec(a)){const t=y(R.URI.parse(a));if(t)return t}}}e.$Xv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(f){return e.$Xv.indexOf(f)>=0}e.$Zv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$Zv.indexOf(f)>=0}function v(f,u,g,a){if(g===1)return!1;if(g===2&&m(u)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class w{constructor(u,g,a){this.remoteAddress=u,this.localAddress=g,this.b=a,this.a=new n.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3v=w;let $=class{constructor(u,g){this.k=u,this.l=g,this.a=new n.$6d,this.onTunnelOpened=this.a.event,this.b=new n.$6d,this.onTunnelClosed=this.b.event,this.c=new n.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],g=Array.from(this.e.values());for(const a of g){const t=Array.from(a.values());for(const o of t){const r=await o.value;r&&typeof r!="string"&&u.push(r)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:g}of u.values())await g.then(a=>typeof a!="string"?a?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,g,a,t,o){this.q(u,g,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:g,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,g){(m(u)||d(u))&&(u=e.$Xv[0]);const a=this.s(u,g);if(a)return++a.refcount,a.value}openTunnel(u,g,a,t,o,r=!1,i,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${a} on local port ${o}.`);const l=this.f??u;if(!l)return;if(g||(g="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.t(l,g,a,t,o,r,i,s);return p?p.then(I=>{if(I){if(typeof I=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(g,a),I}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(g,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const j=this.o(I);return(I.tunnelRemoteHost!==g||I.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&I.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(j),j}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const g=this.e.get(u.tunnelRemoteHost);if(g){const a=g.get(u.tunnelRemotePort);a&&(a.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,a))}}}}async p(u,g,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${g}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(g),t}}async closeTunnel(u,g){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${g} `);const a=this.e.get(u);if(a&&a.has(g)){const t=a.get(g);t.refcount=0,await this.p(u,g,t)}}q(u,g,a){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(g,{refcount:1,value:a})}async r(u,g){const a=this.e.get(u);if(a){const t=a.get(g),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete(g),a.size===0&&this.e.delete(u)}}s(u,g){const a=[u];d(u)?(a.push(...e.$Xv),a.push(...e.$Zv)):m(u)&&a.push(...e.$Zv);const t=a.map(o=>this.e.get(o));for(const o of t){const r=o?.get(g);if(r)return r}}canTunnel(u){return!!y(u)}u(u,g,a,t,o,r,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${a} on local port ${t}.`);const s=a;this.j.add(s);const l=t===void 0?a:t,p={elevationRequired:o?this.isPortPrivileged(l):!1},I={remoteAddress:{host:g,port:a},localAddressPort:t,privacy:r,public:r?r!==h.Private:void 0,protocol:i},j=u.forwardPort(I,p);return j?(this.q(g,a,j),j.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),j}};e.$4v=$,e.$4v=$=ve([se(0,A.$Mj),se(1,P.$Mi)],$)}),define(ae[49],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VW=e.$UW=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(R||(e.StateType=R={}));var P;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var O;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.$UW={Uninitialized:{type:"uninitialized"},Disabled:A=>({type:"disabled",reason:A}),Idle:(A,E)=>({type:"idle",updateType:A,error:E}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:{type:"downloading"},Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.$VW=(0,n.$gi)("updateService")}),define(ae[267],ce([0,1,4,191,52,44]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$Yn.as(P.$4n.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[268],ce([0,1,3,49]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=void 0;class P{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.$yac=P;class O{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$6d,this.onStateChange=this.a.event,this.b=R.$UW.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$zac=O}),define(ae[40],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=void 0,e.$kl=(0,n.$gi)("IUriIdentityService")}),define(ae[269],ce([0,1,40,210,16,19,142,3,2]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;class c{static{this._clock=0}constructor(k){this.uri=k,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let b=class{constructor(k){this.g=k,this.c=new h.$Sc,this.f=2**16;const d=new Map,m=v=>{let w=d.get(v.scheme);return w===void 0&&(w=k.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,w)),w};this.c.add(E.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new O.$Ig(m),this.d=new A.$es((v,w)=>this.extUri.compare(v,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,O.$Ug)(k));const d=this.d.get(k);return d?d.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new c(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,v)=>m[1].time<v[1].time?1:m[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let m=0;m<d;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$fs=b,e.$fs=b=ve([se(0,P.$Mk)],b),(0,R.$cs)(n.$kl,b,1)}),define(ae[131],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LW=void 0,e.$LW=(0,n.$gi)("urlService")}),define(ae[270],ce([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=e.$Hac=e.$Gac=void 0;class R{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.$Gac=R;class P{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$Hac=P;class O{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,c,b){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const y=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const k=/\bwindowId=(\d+)/.exec(y.query);if(k){const d=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,y.toString(!0));const m=new RegExp(`window:${d}`),v=E.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),m.test(w.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,c,b)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$Iac=O}),define(ae[271],ce([0,1,8,2,7,27]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NW=e.$MW=void 0;class A extends R.$Tc{constructor(){super(...arguments),this.a=new Set}open(c,b){const y=[...this.a.values()];return(0,n.$kh)(y.map(k=>()=>k.handleURL(c,b)),void 0,!1).then(k=>k||!1)}registerHandler(c){return this.a.add(c),(0,R.$Rc)(()=>this.a.delete(c))}}e.$MW=A;let E=class extends A{constructor(c){super(),this.b=c}create(c){let{authority:b,path:y,query:k,fragment:d}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&y&&y.indexOf("/")!==0&&(y=`/${y}`),P.URI.from({scheme:this.b.urlProtocol,authority:b,path:y,query:k,fragment:d})}};e.$NW=E,e.$NW=E=ve([se(0,O.$6j)],E)}),define(ae[272],ce([0,1,14,8,3,2,4,7]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class h extends O.$Tc{constructor(b,y,k,d,m,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,b&&(v.trace("ElectronURLListener initialUrisToHandle:",b.map(f=>f.originalUrl)),this.a=b),A.$i){const f=d.isBuilt?[]:[`"${d.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const w=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",(f,u)=>({event:f,url:u})),({event:f,url:u})=>(f.preventDefault(),u));this.B(w(f=>{const u=this.g(f);u&&this.c.open(u,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(b){try{return E.URI.parse(b)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),b.push(y));b.length!==0&&(this.a=b,(0,R.$ih)(()=>this.h(),500,this.q))}}e.$Jac=h}),define(ae[273],ce([0,1,3,2,16,59,31]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class E extends R.$Tc{constructor(c,b,y,k,d,m){super(),this.f=c,this.g=b,this.h=y,this.j=k,this.m=d,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$6d),this.onDidChangeFile=this.a.event,this.b=O.$mi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,b){return this.g.open(this.t(c),b)}close(c){return this.g.close(c)}read(c,b,y,k,d){return this.g.read(c,b,y,k,d)}write(c,b,y,k,d){return this.g.write(c,b,y,k,d)}watch(c,b){this.b.set(c,c);const y=this.g.watch(this.t(c),b);return(0,R.$Rc)(()=>{this.b.delete(c),y.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,b,y){return this.g.rename(this.t(c),this.t(b),y)}readFile(c,b){return this.g.readFile(this.t(c),b)}readFileStream(c,b,y){return this.g.readFileStream(this.t(c),b,y)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,b,y){return this.g.writeFile(this.t(c),b,y)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,b){return this.g.delete(this.t(c),b)}copy(c,b,y){if((0,P.$Qk)(this.g))return this.g.copy(this.t(c),this.t(b),y);throw new Error("copy not supported")}cloneFile(c,b){if((0,P.$Rk)(this.g))return this.g.cloneFile(this.t(c),this.t(b));throw new Error("clone not supported")}s(c){const b=[];for(const y of c){if(y.resource.scheme!==this.f)continue;const k=this.u(y.resource);this.b.findSubstr(k)&&b.push({resource:k,type:y.type,cId:y.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$kbc=E}),define(ae[274],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0,e.$4ac="utilityProcessWorker"}),define(ae[275],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0,e.$Kac=(0,n.$gi)("webviewManagerService")}),define(ae[276],ce([0,1,14,2,13,7]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class A extends R.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,h)}b(h,c){try{const b=O.URI.parse(h.url),y=A.a.get(b.path);if(typeof y=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${y}`,d=P.$Ag.asFileUri(k);return c({path:d.fsPath,headers:{...P.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$Lac=A}),define(ae[55],ce([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$7C=void 0,e.$8C=R,e.$9C=P,e.$0C=O,e.$$C=A,e.$_C=E,e.$aD=y,e.$bD=k,e.$cD=d,e.$dD=m,e.$eD=v,e.$fD=w,e.$7C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R($){return typeof $.parentId=="number"}function P($){return!!$.workspaceUri}function O($){return!!$.folderUri}function A($){return!!$.fileUri}function E($){const f=k($),u=$.getValue("window.menuBarVisibility");return u==="default"||f&&u==="compact"||n.$j&&n.$m?"classic":u}var h;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var c;(function($){$.NATIVE="native",$.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var b;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(b||(e.CustomTitleBarVisibility=b={}));function y($,f){return!0}function k($,f){return f||(f=d($)),f==="native"}function d($){if(n.$o)return"custom";const f=$.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}function m($){return!(!n.$i||n.$o||k($))}function v($){const f=$.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function w($=0){return Math.pow(1.2,$)}}),define(ae[81],ce([0,1,14]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$c_b=e.$b_b=e.UnloadReason=e.LoadReason=void 0;var R;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(R||(e.LoadReason=R={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const O=function(c=1){return{width:1024,height:768,mode:c}};e.$b_b=O;const A=function(){const y=n.screen.getPrimaryDisplay().workArea,k=Math.max(y.x+y.width/2-800/2,0),d=Math.max(y.y+y.height/2-600/2,0);return{x:k,y:d,width:800,height:600,mode:1}};e.$c_b=A;var E;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(ae[277],ce([0,1,8,3,2]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;class O extends P.$Tc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:c}){super(),this.a=this.B(new P.$Sc),R.Event.latch(R.Event.any(E,h))(this.f,this,this.a),this.b=(0,n.$6g)(()=>c()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Rac=O}),define(ae[30],ce([0,1,195,9,59,19,7,6,13]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Ai=e.$zi=e.WorkbenchState=e.$ti=e.$si=e.$pi=void 0,e.$qi=c,e.$ri=b,e.$ui=y,e.$vi=k,e.$wi=d,e.$xi=v,e.$yi=w,e.$Bi=u,e.$Gi=g,e.$Hi=a,e.$Ji=t,e.$Ki=o,e.$Li=r,e.$pi=(0,E.$gi)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function b(i){return typeof i?.id=="string"&&!c(i)&&!k(i)}e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function y(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:s?e.$si:e.$ti;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function k(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function d(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function w(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class ${constructor(s,l,p,I,j){this.h=s,this.j=p,this.k=I,this.l=j,this.c=P.$mi.forUris(this.l,()=>!0),this.folders=l}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=$;class f{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.$Tg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=f;function u(i){return new f({uri:i,index:0,name:(0,O.$Pg)(i)},{uri:i.toString()})}e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,n.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function g(i,s){return O.$Kg.isEqualOrParent(i,s.untitledWorkspacesHome)}function a(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===h.Schemas.tmp}e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Ii}function o(i,s){return!g(i,s)&&!a(i)}function r(i){return(typeof i=="string"?(0,R.$oc)(i):(0,O.$Rg)(i))===e.$Di}}),define(ae[56],ce([0,1,14,8,45,47,2,86,4,21,169,119,6,5,27,30]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=e.$j_b=void 0,e.$j_b=(0,k.$gi)("dialogMainService");let w=class{constructor(f,u){this.d=f,this.e=u,this.a=new Map,this.b=new Map,this.c=new R.$nh}pickFileFolder(f,u){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},u)}pickFolder(f,u){return this.f({...f,pickFolders:!0,title:(0,b.localize)(1,null)},u)}pickFile(f,u){return this.f({...f,pickFiles:!0,title:(0,b.localize)(2,null)},u)}pickWorkspace(f,u){const g=(0,b.localize)(3,null),a=(0,O.$jw)((0,b.localize)(4,null)),t=v.$Ei;return this.f({...f,pickFiles:!0,title:g,filters:t,buttonLabel:a},u)}async f(f,u){const g={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(g.properties=void 0,f.pickFiles&&f.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&g.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(g,(u||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let u=this.b.get(f.id);return u||(u=new R.$nh,this.b.set(f.id,u)),u}else return this.c}showMessageBox(f,u){return this.g(u).queue(async()=>{const{options:g,buttonIndeces:a}=(0,y.$qw)(f,this.e);let t;return u?t=await n.dialog.showMessageBox(u,g):t=await n.dialog.showMessageBox(g),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,u){const g=this.j(f,u);if(!g)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(u).queue(async()=>{let a;return u?a=await n.dialog.showSaveDialog(u,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,A.$Oc)(g)}}h(f){return f&&h.$j&&(f=(0,E.$Xl)(f)),f}i(f){return f.map(u=>this.h(u))}async showOpenDialog(f,u){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const g=this.j(f,u);if(!g)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(u).queue(async()=>{let a;return u?a=await n.dialog.showOpenDialog(u,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,A.$Oc)(g)}}j(f,u){if(!u)return A.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let g=this.a.get(u.id);g||(g=new Set,this.a.set(u.id,g));const a=(0,P.$7i)(f);if(!g.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),g.add(a),(0,A.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),g?.delete(a),g?.size===0&&this.a.delete(u.id)})}};e.$k_b=w,e.$k_b=w=ve([se(0,d.$Mj),se(1,m.$6j)],w)}),define(ae[278],ce([0,1,3,2,76,30]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;class A extends R.$Tc{static{this.a=100}constructor(h,c){super(),this.f=h,this.g=c,this.b=this.B(new n.$6d),this.c=new Map,this.h(c.applicationStorage,this.b)}h(h,c){this.B(n.Event.debounce(h.onDidChangeStorage,(b,y)=>(b?b.push(y):b=[y],b),A.a)(b=>{b.length&&c.fire(this.j(b,h))}))}j(h,c){const b=new Map,y=new Set;return h.forEach(k=>{const d=c.get(k.key);typeof d=="string"?b.set(k.key,d):y.add(k.key)}),{changed:Array.from(b.entries()),deleted:Array.from(y.values())}}listen(h,c,b){switch(c){case"onDidChangeStorage":{const y=b.profile?(0,P.$Ph)(b.profile):void 0;if(!y)return this.b.event;let k=this.c.get(y.id);return k||(k=this.B(new n.$6d),this.h(this.g.profileStorage(y),k),this.c.set(y.id,k)),k.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,b){const y=b.profile?(0,P.$Ph)(b.profile):void 0,k=(0,O.$wi)(b.workspace),d=await this.m(y,k);switch(c){case"getItems":return Array.from(d.items.entries());case"updateItems":{const m=b;if(m.insert)for(const[v,w]of m.insert)d.set(v,w);m.delete?.forEach(v=>d.delete(v));break}case"optimize":return d.optimize();case"isUsed":{const m=b.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${c}`)}}async m(h,c){let b;c?b=this.g.workspaceStorage(c):h?b=this.g.profileStorage(h):b=this.g.applicationStorage;try{await b.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${y}`)}return b}}e.$vac=A}),define(ae[41],ce([0,1,45,3,2,19,7,192,38,16,6,5,30,31,40,8,32,25,12]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ml=e.ProfileResourceType=void 0,e.$ll=g,e.$nl=a,e.$ol=t;var u;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function g(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$ml=(0,b.$gi)("IUserDataProfilesService");function a(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,s,l,p,I,j){return{id:i,name:s,location:l,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:j&&I?.useDefaultFlags?.globalState?j.globalStorageHome:(0,O.$Tg)(l,"globalStorage"),settingsResource:j&&I?.useDefaultFlags?.settings?j.settingsResource:(0,O.$Tg)(l,"settings.json"),keybindingsResource:j&&I?.useDefaultFlags?.keybindings?j.keybindingsResource:(0,O.$Tg)(l,"keybindings.json"),tasksResource:j&&I?.useDefaultFlags?.tasks?j.tasksResource:(0,O.$Tg)(l,"tasks.json"),snippetsHome:j&&I?.useDefaultFlags?.snippets?j.snippetsHome:(0,O.$Tg)(l,"snippets"),extensionsResource:j&&I?.useDefaultFlags?.extensions?j.extensionsResource:(0,O.$Tg)(l,"extensions.json"),cacheHome:(0,O.$Tg)(p,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let o=class extends P.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,l,p,I){super(),this.t=s,this.u=l,this.w=p,this.y=I,this.f=!0,this.h=this.B(new R.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),l=[s];if(this.f)try{for(const j of this.O()){if(!j.name||!(0,f.$Tf)(j.name)||!j.location){this.y.warn("Skipping the invalid stored profile",j.location||j.name);continue}l.push(t((0,O.$Qg)(j.location),j.name,j.location,this.g,{shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags},s))}}catch(j){this.y.error(j)}const p=new d.$Ac,I=new Map;if(l.length)try{const j=this.Q();if(j.workspaces)for(const[S,D]of Object.entries(j.workspaces)){const M=A.URI.parse(S),W=l.find(F=>F.id===D);W&&p.set(M,W)}if(j.emptyWindows)for(const[S,D]of Object.entries(j.emptyWindows)){const M=l.find(W=>W.id===D);M&&I.set(S,M)}}catch(j){this.y.error(j)}this.z={profiles:l,workspaces:p,emptyWindows:I}}return this.z}D(){const s=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const l="Temp",p=new RegExp(`${(0,$.$Ye)(l)}\\s(\\d+)`);let I=0;for(const S of this.profiles){const D=p.exec(S.name),M=D?parseInt(D[1]):0;I=M>I?M:I}const j=`${l} ${I+1}`;return this.createProfile((0,n.$7i)((0,w.$Cg)()).toString(16),j,{transient:!0},s)}async createNamedProfile(s,l,p){return this.createProfile((0,n.$7i)((0,w.$Cg)()).toString(16),s,l,p)}async createProfile(s,l,p,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const j=await this.F(s,l,p);return I&&await this.setProfileForWorkspace(I,j),j}async F(s,l,p){if(!(0,f.$Tf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(l);return I||(I=(async()=>{try{const j=this.profiles.find(M=>M.name===l||M.id===s);if(j)return j;const S=t(s,l,(0,O.$Tg)(this.profilesHome,s),this.g,p,this.defaultProfile);await this.u.createFolder(S.location);const D=[];return this.j.fire({profile:S,join(M){D.push(M)}}),await v.Promises.settled(D),this.I([S],[],[]),S}finally{this.r.delete(l)}})(),this.r.set(l,I)),I}async updateProfile(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(I=>I.id===s.id);if(!p)throw new Error(`Profile '${s.name}' does not exist`);return p=t(p.id,l.name??p.name,p.location,this.g,{shortName:l.shortName??p.shortName,icon:l.icon===null?void 0:l.icon??p.icon,transient:l.transient??p.isTransient,useDefaultFlags:l.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(I=>I.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);const p=[];this.m.fire({profile:l,join(I){p.push(I)}});try{await Promise.allSettled(p)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(I){(0,c.$4k)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(I=>I.id===l.id);if(!p)throw new Error(`Profile '${l.name}' does not exist`);this.L(s,p)}unsetWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(l=>l.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(s.map(l=>this.removeProfile(l)))}getProfileForWorkspace(s){const l=this.G(s);return A.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(s){return(0,k.$qi)(s)?s.uri:(0,k.$vi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location)))}I(s,l,p){const I=[...this.profiles,...s],j=[];this.s.profiles=[];for(let S of I)S.isDefault||l.some(D=>S.id===D.id)||(S=p.find(D=>S.id===D.id)??S,S.isTransient?this.s.profiles.push(S):j.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags}));this.P(j),this.z=void 0,this.J(s,l,p)}J(s,l,p){this.h.fire({added:s,removed:l,updated:p,all:this.profiles})}L(s,l,p){p=l?.isTransient?!0:p,p||this.L(s,void 0,!0);const I=this.G(s),j=p?this.s:this.C;A.URI.isUri(I)?(j.workspaces.delete(I),l&&j.workspaces.set(I,l)):(j.emptyWindows.delete(I),l&&j.emptyWindows.set(I,l)),p||this.M()}M(){const s={};for(const[p,I]of this.C.workspaces.entries())s[p.toString()]=I.id;const l={};for(const[p,I]of this.C.emptyWindows.entries())l[p.toString()]=I.id;this.R({workspaces:s,emptyWindows:l}),this.z=void 0}N(s){const l={},p=this.D();if(s.workspaces)for(const[j,S]of Object.entries(s.workspaces)){const D=A.URI.parse(S);l[j]=this.w.extUri.isEqual(D,p.location)?p.id:this.w.extUri.basename(D)}const I={};if(s.emptyWindows)for(const[j,S]of Object.entries(s.emptyWindows)){const D=A.URI.parse(S);I[j]=this.w.extUri.isEqual(D,p.location)?p.id:this.w.extUri.basename(D)}return{workspaces:l,emptyWindows:I}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$pl=o,e.$pl=o=ve([se(0,h.$ni),se(1,c.$Mk),se(2,m.$kl),se(3,y.$Mj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$ql=r}),define(ae[82],ce([0,1,8,17,2,3,31,7,121,127,16,6,5,41,40,12,15,28]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class u extends Error{constructor(r,i){super(r),this.code=i}}e.$$p=u,e.$_p=(0,y.$gi)("IExtensionsProfileScannerService");let g=class extends P.$Tc{constructor(r,i,s,l,p,I){super(),this.j=r,this.m=i,this.n=s,this.r=l,this.s=p,this.t=I,this.b=this.B(new O.$6d),this.onAddExtensions=this.b.event,this.c=this.B(new O.$6d),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$6d),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$6d),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const l=[],p=[];try{return await this.u(i,I=>{const j=[];if(s)j.push(...I);else for(const S of I)r.some(([D])=>(0,c.$ep)(D.identifier,S.identifier)&&D.manifest.version!==S.version)?l.push(S):j.push(S);for(const[S,D]of r){const M=j.findIndex(F=>(0,c.$ep)(F.identifier,S.identifier)&&F.version===S.manifest.version),W={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:D};M===-1?(p.push(W),j.push(W)):j.splice(M,1,W)}return p.length&&this.b.fire({extensions:p,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),j}),p.length&&this.c.fire({extensions:p,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),p}catch(I){throw p.length&&this.c.fire({extensions:p,error:I,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:I,profileLocation:i}),I}}async updateMetadata(r,i){const s=[];return await this.u(i,l=>{const p=[];for(const I of l){const j=r.find(([S])=>(0,c.$ep)(S.identifier,I.identifier)&&S.manifest.version===I.version);j&&(I.metadata={...I.metadata,...j[1]},s.push(I)),p.push(I)}return p}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,l=>{const p=[];for(const I of l)(0,c.$ep)(I.identifier,r.identifier)?s.push(I):p.push(I);return s.length&&this.f.fire({extensions:s,profileLocation:i}),p}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(l){throw s.length&&this.g.fire({extensions:s,error:l,profileLocation:i}),l}}async u(r,i,s){return this.F(r).queue(async()=>{let l=[],p;try{const I=await this.m.readFile(r);p=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,b.$4k)(I)!==1)throw I;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&s?.bailOutWhenFileNotFound)throw new u((0,w.$0)(I),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let I=!1;for(const j of p){a(j)||this.w(r);let S;if((0,v.$Tf)(j.relativeLocation)&&j.relativeLocation)S=this.z(j.relativeLocation);else if((0,v.$Tf)(j.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${j.location}`);continue}else{S=E.URI.revive(j.location);const D=this.y(S);D&&(I=!0,j.relativeLocation=D)}(0,v.$1f)(j.metadata?.hasPreReleaseVersion)&&j.metadata?.preRelease&&(I=!0,j.metadata.hasPreReleaseVersion=!0),l.push({identifier:j.identifier,location:S,version:j.version,metadata:j.metadata})}I&&await this.m.writeFile(r,R.$te.fromString(JSON.stringify(p)))}if(i){l=i(l);const I=l.map(j=>({identifier:j.identifier,version:j.version,location:j.location.toJSON(),relativeLocation:this.y(j.location),metadata:j.metadata}));await this.m.writeFile(r,R.$te.fromString(JSON.stringify(I)))}return l})}w(r){const i=new u(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(p){if((0,b.$4k)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const p=JSON.parse(s);Array.isArray(p)&&p.every(I=>a(I))?l=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$te.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,b.$4k)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,b.$4k)(p)!==1&&this.t.error(p)}try{await this.m.del(i)}catch(p){(0,b.$4k)(p)!==1&&this.t.error(p)}return l})()),this.C}F(r){let i=this.h.get(r);return i||(i=new n.$nh,this.h.set(r,i)),i}};e.$aq=g,e.$aq=g=ve([se(1,b.$Mk),se(2,d.$ml),se(3,m.$kl),se(4,$.$Ll),se(5,k.$Mj)],g);function a(o){return(0,v.$Vf)(o)&&(0,h.$Oo)(o.identifier)&&(t(o.location)||(0,v.$Tf)(o.location)&&o.location)&&((0,v.$1f)(o.relativeLocation)||(0,v.$Tf)(o.relativeLocation))&&o.version&&(0,v.$Tf)(o.version)}function t(o){return o?(0,v.$Tf)(o.path)&&(0,v.$Tf)(o.scheme):!1}}),define(ae[132],ce([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,73,12,7,174,38,127,124,207,16,6,5,27,3,76,82,41,40,206]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s,l,p,I,j,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$fq=e.$eq=e.$dq=e.Translations=void 0,e.$gq=le;var M;(function(ue){function Q(Y,U){if(Y===U)return!0;const L=Object.keys(Y),N=new Set;for(const G of Object.keys(U))N.add(G);if(L.length!==N.size)return!1;for(const G of L){if(Y[G]!==U[G])return!1;N.delete(G)}return N.size===0}ue.equals=Q})(M||(e.Translations=M={})),e.$dq=(0,r.$gi)("IExtensionsScannerService");let W=class extends c.$Tc{constructor(Q,Y,U,L,N,G,q,oe,he,K,C,T){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=Y,this.r=U,this.s=L,this.t=N,this.u=G,this.w=q,this.y=oe,this.z=he,this.C=K,this.D=C,this.F=T,this.g=this.B(new l.$6d),this.onDidChangeCache=this.g.event,this.h=(0,d.$Tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(H,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$pp)(this.w,this.y)),this.G}async scanAllExtensions(Q,Y,U){const[L,N]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(Y)]),G=U?await this.scanExtensionsUnderDevelopment(Q,[...L,...N]):[];return this.L(L,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const Y=[];Y.push(this.M(!!Q.useCache,Q.language)),Y.push(this.N(Q.language,!!Q.checkControlFile));const[U,L]=await Promise.all(Y);return this.J([...U,...L],0,Q,!1)}async scanUserExtensions(Q){const Y=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const U=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Y,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,U,Q.productVersion??this.R()),N=Q.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(L)}catch(q){if(q instanceof I.$$p&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(L);else throw q}return G=await this.J(G,1,Q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Q,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const U=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===b.Schemas.file).map(async L=>{const N=await this.P(L,!1,1,!0,Q.language,!1,void 0,Q.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(N)).map(q=>(q.type=Y.find(oe=>(0,g.$ep)(oe.identifier,q.identifier))?.type??q.type,this.n.validate(q,N)))}))).flat();return this.J(U,"development",Q,!0)}return[]}async scanExistingExtension(Q,Y,U){const L=await this.P(Q,!1,Y,!0,U.language,!0,void 0,U.productVersion??this.R()),N=await this.n.scanExtension(L);return!N||!U.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Q,Y,U){const L=await this.P(Q,!1,Y,!0,U.language,!0,void 0,U.productVersion??this.R()),N=await this.n.scanOneOrMultipleExtensions(L);return this.J(N,Y,U,!0)}async scanMetadata(Q){const Y=(0,d.$Tg)(Q,"package.json"),U=(await this.w.readFile(Y)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(Q,Y){const U=(0,d.$Tg)(Q,"package.json"),L=(await this.w.readFile(U)).value.toString(),N=JSON.parse(L);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,N.__metadata={...N.__metadata,...Y},await this.w.writeFile((0,d.$Tg)(Q,"package.json"),O.$te.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof I.$$p&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$te.fromString(JSON.stringify([])))}catch(Y){(0,o.$4k)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,Y,U,L){return U.includeAllVersions||(Q=this.L(Y===0?Q:void 0,Y===1?Q:void 0,Y==="development"?Q:void 0,await this.getTargetPlatform(),L)),U.includeInvalid||(Q=Q.filter(N=>N.isValid)),Q.sort((N,G)=>{const q=y.$nc(N.location.fsPath),oe=y.$nc(G.location.fsPath);return q<oe?-1:q>oe?1:0})}L(Q,Y,U,L,N){const G=(oe,he,K)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(N&&m.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(m.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},q=new a.$Dm;return Q?.forEach(oe=>{const he=q.get(oe.identifier.id);(!he||G(he,oe,!1))&&q.set(oe.identifier.id,oe)}),Y?.forEach(oe=>{const he=q.get(oe.identifier.id);if(!he&&Q&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||G(he,oe,!1))&&q.set(oe.identifier.id,oe)}),U?.forEach(oe=>{const he=q.get(oe.identifier.id);(!he||G(he,oe,!0))&&q.set(oe.identifier.id,oe),q.set(oe.identifier.id,oe)}),[...q.values()]}async M(Q,Y){this.y.trace("Started scanning system extensions");const U=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0,this.R()),N=await(Q&&!U.devMode?this.j:this.n).scanExtensions(U);return this.y.trace("Scanned system extensions:",N.length),N}async N(Q,Y){const U=this.z.isBuilt?[]:this.C.builtInExtensions;if(!U?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Y?await this.O():{},N=[],G=$.URI.file(y.$hc(y.$jc(b.$Ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of U){const he=L[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,d.$Tg)(G,oe.name));break;default:N.push($.URI.file(he));break}}const q=await Promise.all(N.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Q,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",q.length),(0,n.$Hb)(q)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,Y,U,L,N,G,q,oe){const he=await this.f(N??k.$w),K=await this.Q(Q),C=Y&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,T=C?await this.Q(C):void 0;return new F(Q,K,C,T,Y,q,U,L,G,oe.version,oe.date,this.C.commit,!this.z.isBuilt,N,he)}async Q(Q){try{const Y=await this.w.stat(Q);if(typeof Y.mtime=="number")return Y.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$eq=W,e.$eq=W=ve([se(4,j.$ml),se(5,I.$_p),se(6,o.$Mk),se(7,i.$Mj),se(8,u.$ni),se(9,s.$6j),se(10,S.$kl),se(11,r.$fi)],W);class F{constructor(Q,Y,U,L,N,G,q,oe,he,K,C,T,Z,z,X){this.location=Q,this.mtime=Y,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=L,this.profile=N,this.profileScanOptions=G,this.type=q,this.excludeObsolete=oe,this.validate=he,this.productVersion=K,this.productDate=C,this.productCommit=T,this.devMode=Z,this.language=z,this.translations=X}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,Y){return(0,d.$Mg)(Q.location,Y.location)&&Q.mtime===Y.mtime&&(0,d.$Mg)(Q.applicationExtensionslocation,Y.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&Q.profile===Y.profile&&P.$Qn(Q.profileScanOptions,Y.profileScanOptions)&&Q.type===Y.type&&Q.excludeObsolete===Y.excludeObsolete&&Q.validate===Y.validate&&Q.productVersion===Y.productVersion&&Q.productDate===Y.productDate&&Q.productCommit===Y.productCommit&&Q.devMode===Y.devMode&&Q.language===Y.language&&M.equals(Q.translations,Y.translations)}}e.$fq=F;let H=class extends c.$Tc{constructor(Q,Y,U,L,N){super(),this.f=Q,this.g=Y,this.h=U,this.j=L,this.m=N}async scanExtensions(Q){const Y=Q.profile?await this.r(Q):await this.n(Q);let U={};if(Q.excludeObsolete&&Q.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();U=JSON.parse(L)}catch{}return(0,w.$7f)(U)?Y:Y.filter(L=>!U[g.$fp.create(L).toString()])}async n(Q){const Y=await this.j.resolve(Q.location);if(!Y.children?.length)return[];const U=await Promise.all(Y.children.map(async L=>{if(!L.isDirectory||Q.type===1&&(0,d.$Qg)(L.resource).indexOf(".")===0)return null;const N=new F(L.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(N)}));return(0,n.$Hb)(U).sort((L,N)=>L.location.path<N.location.path?-1:1)}async r(Q){let Y=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){Y=Y.filter(L=>!L.metadata?.isApplicationScoped);const U=await this.s(Q.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Q);Y.push(...U)}return Y}async s(Q,Y,U){const L=await this.g.scanProfileExtensions(Q,U.profileScanOptions);if(!L.length)return[];const N=await Promise.all(L.map(async G=>{if(Y(G)){const q=new F(G.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(q,G.metadata)}return null}));return(0,n.$Hb)(N)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,d.$Tg)(Q.location,"package.json"))){const Y=await this.scanExtension(Q);return Y?[Y]:[]}else return await this.scanExtensions(Q)}catch(Y){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,A.$0)(Y)),[]}}async scanExtension(Q,Y){try{let U=await this.scanExtensionManifest(Q.location);if(U){U.publisher||(U.publisher=a.$xm),Y=Y??U.__metadata,delete U.__metadata;const L=(0,g.$jp)(U.publisher,U.name),N=Y?.id?{id:L,uuid:Y.id}:{id:L},G=Y?.isSystem?0:Q.type,q=G===0||!!Y?.isBuiltin;U=await this.t(Q.location,U,F.createNlsConfiguration(Q));const oe={type:G,identifier:N,manifest:U,location:Q.location,isBuiltin:q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return Q.validate?this.validate(oe,Q):oe}}catch(U){Q.type!==0&&this.m.error(U)}return null}validate(Q,Y){let U=!0;const L=(0,t.$up)(Y.productVersion,Y.productDate,Y.location,Q.manifest,Q.isBuiltin);for(const[N,G]of L)N===v.default.Error&&(U=!1,this.m.error(this.z(Y.location,G)));return Q.isValid=U,Q.validations=L,Q}async scanExtensionManifest(Q){const Y=(0,d.$Tg)(Q,"package.json");let U;try{U=(await this.j.readFile(Y)).value.toString()}catch(N){return(0,o.$4k)(N)!==1&&this.m.error(this.z(Q,(0,f.localize)(0,null,Y.path,N.message))),null}let L;try{L=JSON.parse(U)}catch{const G=[];(0,E.$tn)(U,G);for(const q of G)this.m.error(this.z(Q,(0,f.localize)(1,null,Y.path,q.offset,q.length,(0,h.$bq)(q.error))));return null}return(0,E.$Cn)(L)!=="object"?(this.m.error(this.z(Q,(0,f.localize)(2,null,Y.path))),null):L}async t(Q,Y,U){const L=await this.u(Q,Y,U);if(L)try{const N=[],G=await this.w(L.default,N);if(N.length>0)return N.forEach(oe=>{this.m.error(this.z(Q,(0,f.localize)(3,null,L.default?.path,(0,h.$bq)(oe.error))))}),Y;if((0,E.$Cn)(L)!=="object")return this.m.error(this.z(Q,(0,f.localize)(4,null,L.default?.path))),Y;const q=L.values||Object.create(null);return(0,D.$cq)(this.m,Y,q,G)}catch{}return Y}async u(Q,Y,U){const L=(0,d.$Tg)(Q,"package.nls.json"),N=(he,K)=>{K.forEach(C=>{this.m.error(this.z(Q,(0,f.localize)(5,null,he?.path,(0,h.$bq)(C.error))))})},G=he=>{this.m.error(this.z(Q,(0,f.localize)(6,null,he?.path)))},q=`${Y.publisher}.${Y.name}`,oe=U.translations[q];if(oe)try{const he=$.URI.file(oe),K=(await this.j.readFile(he)).value.toString(),C=[],T=(0,E.$tn)(K,C);return C.length>0?(N(he,C),{values:void 0,default:L}):(0,E.$Cn)(T)!=="object"?(G(he),{values:void 0,default:L}):{values:T.contents?T.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Q,U)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const C=(await this.j.readFile(K.localized)).value.toString(),T=[],Z=(0,E.$tn)(C,T);return T.length>0?(N(K.localized,T),{values:void 0,default:K.original}):(0,E.$Cn)(Z)!=="object"?(G(K.localized),{values:void 0,default:K.original}):{values:Z,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Q,Y){if(Q)try{const U=(await this.j.readFile(Q)).value.toString();return(0,E.$tn)(U,Y)}catch{}}y(Q,Y){return new Promise((U,L)=>{const N=G=>{const q=(0,d.$Tg)(Q,`package.nls.${G}.json`);this.j.exists(q).then(oe=>{oe&&U({localized:q,original:(0,d.$Tg)(Q,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?U({localized:(0,d.$Tg)(Q,"package.nls.json"),original:null}):(G=G.substring(0,he),N(G))})};if(Y.devMode||Y.pseudo||!Y.language)return U({localized:(0,d.$Tg)(Q,"package.nls.json"),original:null});N(Y.language)})}z(Q,Y){return`[${Q.path}]: ${Y}`}};H=ve([se(1,I.$_p),se(2,S.$kl),se(3,o.$Mk),se(4,i.$Mj)],H);let x=class extends H{constructor(Q,Y,U,L,N,G,q){super(Y,L,N,G,q),this.G=Q,this.H=U,this.D=this.B(new R.$eh(3e3)),this.F=this.B(new l.$6d),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const Y=this.M(Q),U=await this.I(Y);if(this.C=Q,U&&U.input&&F.equals(U.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),U.result.map(N=>(N.location=$.URI.revive(N.location),N));const L=await super.scanExtensions(Q);return await this.J(Y,{input:Q,result:L}),L}async I(Q){try{const Y=await this.j.readFile(Q),U=JSON.parse(Y.value.toString());return{result:U.result,input:(0,p.$Ph)(U.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",Q.path,(0,A.$0)(Y))}return null}async J(Q,Y){try{await this.j.writeFile(Q,O.$te.fromString(JSON.stringify(Y)))}catch(U){this.m.debug("Error while writing the extension cache file:",Q.path,(0,A.$0)(U))}}async L(){if(!this.C)return;const Q=this.M(this.C),Y=await this.I(Q);if(!Y)return;const U=Y.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$Qn(L,U))try{this.m.info("Invalidating Cache",U,L),await this.j.del(Q),this.F.fire()}catch(N){this.m.error(N)}}M(Q){const Y=this.N(Q);return this.h.extUri.joinPath(Y.cacheHome,Q.type===0?a.$wm:a.$vm)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(Q.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};x=ve([se(2,j.$ml),se(3,I.$_p),se(4,S.$kl),se(5,o.$Mk),se(6,i.$Mj)],x);function le(ue,Q){const Y=(0,g.$hp)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new a.$Bm(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Q,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}class re extends W{constructor(Q,Y,U,L,N,G,q,oe,he,K,C,T){super(Q,Y,(0,d.$Tg)(U,".vscode-oss-dev","extensions","control.json"),L,N,G,q,oe,he,K,C,T),this.S=(async()=>{if(k.$z)try{const Z=await this.w.readFile($.URI.file(k.$z));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.S}}e.$hq=re}),define(ae[279],ce([0,1,5,41,40,28,82,16,38,7]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=void 0;let b=class extends A.$aq{constructor(k,d,m,v,w,$){super(c.URI.file(k.extensionsPath),d,m,v,w,$)}};e.$UP=b,e.$UP=b=ve([se(0,h.$oi),se(1,E.$Mk),se(2,R.$ml),se(3,P.$kl),se(4,O.$Ll),se(5,n.$Mj)],b)}),define(ae[280],ce([0,1,7,38,82,132,16,6,5,27,40,41]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;let k=class extends O.$hq{constructor(m,v,w,$,f,u,g,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,v,w,$,f,u,g,a)}};e.$Vac=k,e.$Vac=k=ve([se(0,y.$ml),se(1,P.$_p),se(2,A.$Mk),se(3,h.$Mj),se(4,R.$oi),se(5,c.$6j),se(6,b.$kl),se(7,E.$fi)],k)}),define(ae[281],ce([0,1,14,2,13,9,4,59,7,32,37,38,5,41]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0;let m=class extends R.$Tc{constructor(w,$,f){super(),this.c=w,this.f=f,this.a=E.$mi.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,($,f)=>this.j($,f)),w.protocol.interceptFileProtocol(P.Schemas.file,($,f)=>this.h($,f)),this.B((0,R.$Rc)(()=>{w.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(w){const $=(0,O.$hc)(w);return this.a.get($)?R.$Tc.None:(this.a.set($,!0),(0,R.$Rc)(()=>this.a.delete($)))}h(w,$){const f=h.URI.parse(w.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${P.Schemas.file}: protocol (original URL: ${w.url})`),$({error:-3})}j(w,$){const f=this.m(w);let u;return this.c.crossOriginIsolated&&((0,O.$nc)(f)==="workbench.html"||(0,O.$nc)(f)==="workbench-dev.html"?u=P.COI.CoopAndCoep:u=P.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(f)?$({path:f,headers:u}):this.b.has((0,O.$oc)(f).toLowerCase())?$({path:f}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),$({error:-3}))}m(w){const $=h.URI.parse(w.url),f=P.$Ag.uriToFileUri($);return(0,O.$hc)(f.fsPath)}createIPCObjectUrl(){let w;const $=h.URI.from({scheme:"vscode",path:(0,c.$Cg)()}),f=$.toString(),u=async()=>w;return b.$WV.handle(f,u),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:$,update:g=>w=g,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),b.$WV.removeHandler(f)}}}};e.$bbc=m,e.$bbc=m=ve([se(0,y.$oi),se(1,d.$ml),se(2,k.$Mj)],m)}),define(ae[97],ce([0,1,8,3,2,66,12,115,6,41]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Mp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Kp=e.$Jp=e.$Ip=void 0,e.$Lp=d,e.$Np=v,e.$Pp=$,e.$Ip="__$__isNewStorageMarker",e.$Jp="__$__targetStorageMarker",e.$Kp=(0,h.$gi)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function d(f){const u=f.get(e.$Jp);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}class m extends P.$Tc{static{this.a=60*1e3}constructor(u={flushInterval:m.a}){super(),this.m=u,this.b=this.B(new R.$9d),this.c=this.B(new R.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,g,a){return R.Event.filter(this.b.event,t=>t.scope===u&&(g===void 0||t.key===g),a)}n(){this.j.value=(0,n.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,g){const{key:a,external:t}=g;if(a===e.$Jp){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:a,target:this.J(u)[a],external:t})}w(u){this.f.fire({reason:u})}get(u,g,a){return this.P(g)?.get(u,a)}getBoolean(u,g,a){return this.P(g)?.getBoolean(u,a)}getNumber(u,g,a){return this.P(g)?.getNumber(u,a)}getObject(u,g,a){return this.P(g)?.getObject(u,a)}storeAll(u,g){this.y(()=>{for(const a of u)this.store(a.key,a.value,a.scope,a.target,g)})}store(u,g,a,t,o=!1){if((0,A.$3f)(g)){this.remove(u,a,o);return}this.y(()=>{this.z(u,a,t),this.P(a)?.set(u,g,o)})}remove(u,g,a=!1){this.y(()=>{this.z(u,g,void 0),this.P(g)?.delete(u,a)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,g){const a=[],t=this.J(u);for(const o of Object.keys(t))t[o]===g&&a.push(o);return a}z(u,g,a,t=!1){const o=this.J(g);typeof a=="number"?o[u]!==a&&(o[u]=a,this.P(g)?.set(e.$Jp,JSON.stringify(o),t)):typeof o[u]=="number"&&(delete o[u],this.P(g)?.set(e.$Jp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const g=this.P(u);return g?d(g):Object.create(null)}isNew(u){return this.getBoolean(e.$Ip,u)===!0}async flush(u=b.NONE){this.f.fire({reason:u});const g=this.P(-1),a=this.P(0),t=this.P(1);switch(u){case b.NONE:await n.Promises.settled([g?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await n.Promises.settled([g?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return $(u,g,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,g){return this.w(b.NONE),(0,c.$ll)(u)?this.R(u,g):this.S(u,g)}M(u,g){return!(u.id===g.id||v(g)&&v(u))}N(u,g,a){this.y(()=>{const t=new Set;for(const[o,r]of u)t.add(o),g.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of g.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Mp=m;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class w extends m{constructor(){super(),this.U=this.B(new E.$Gp(new E.$Hp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Gp(new E.$Hp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Gp(new E.$Hp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$Op=w;async function $(f,u,g,a,t,o){const r=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,s=new Map;f.forEach((M,W)=>{i.set(W,M),s.set(W,r(M))});const l=new Map,p=new Map;u.forEach((M,W)=>{l.set(W,M),p.set(W,r(M))});const I=new Map,j=new Map;g.forEach((M,W)=>{I.set(W,M),j.set(W,r(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const S=[];if(i.forEach((M,W)=>{S.push({key:W,value:M})}),console.table(S),console.groupEnd(),console.log(s),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];l.forEach((W,F)=>{M.push({key:F,value:W})}),console.table(M),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const D=[];I.forEach((M,W)=>{D.push({key:W,value:M})}),console.table(D),console.groupEnd(),console.log(j)}}),define(ae[282],ce([0,1,22,8,3,2,9,72,7,21,115,163,5,97,28,30,13]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=e.$L_b=e.$K_b=e.$J_b=void 0;class $ extends O.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new P.$6d),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.$6d),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$Gp(new b.$Hp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$Dh,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(s=>this.b.fire(s))),await this.s(r);const i=r.getBoolean(d.$Ip);i===void 0?r.set(d.$Ip,!0):i&&r.set(d.$Ip,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new E.$2d(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([l,p])=>({key:l,length:p.length})),(l,p)=>p.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),s=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class f extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,A.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,f.y)}constructor(r,i,s,l){super(s,l),this.z=r,this.C=i}async t(){return new b.$Gp(new y.$pW(this.path??y.$pW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class u extends f{constructor(r,i,s,l){super(r,i,s,l)}}e.$J_b=u;class g extends f{constructor(r,i,s,l){super(i.defaultProfile,r,s,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Ol,void 0)===void 0&&r.set(m.$Ol,new Date().toUTCString());const s=r.get(m.$Nl,void 0),l=new Date().toUTCString();r.set(m.$Pl,typeof s>"u"?null:s),r.set(m.$Nl,l)}}e.$K_b=g;class a extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,A.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,s,l,p){super(s,p),this.C=r,this.D=i,this.F=l}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new b.$Gp(new y.$pW(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$pW.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,A.$jc)(r,a.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,v.$qi)(this.C)?i={folder:this.C.uri.toString()}:(0,v.$vi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const s=(0,A.$jc)(r,a.z);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.$L_b=a;class t extends ${get path(){}async t(){return new b.$Gp(new b.$Hp,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$M_b=t}),define(ae[283],ce([0,1,3,2,97]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;class O extends R.$Tc{constructor(E,h,c){super(),this.b=E,this.c=h,this.f=c;const b=this.B(new R.$Uc);this.a=this.B(new n.$6d({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new R.$Sc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.h(h))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let b=h.get(c.profile.id);return b||h.set(c.profile.id,b={profile:c.profile,keys:[],storage:c.storage}),b.keys.push(c.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(P.$Jp)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(b=>b!==P.$Jp),E.length){const b=(0,P.$Lp)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:b[y]}))})}this.m(h,c)}j(E){const h=[],c=new Map;for(const[b,y]of E.entries()){y.keys.includes(P.$Jp)&&h.push(y.profile);const k=y.keys.filter(d=>d!==P.$Jp);if(k.length){const d=(0,P.$Lp)(y.storage.storage);c.set(b,{profile:y.profile,changes:k.map(m=>({key:m,scope:0,target:d[m]}))})}}this.m(h,[...c.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,c){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$Xac=O}),define(ae[284],ce([0,1,7,38,16,5,34,40,41,12,125]),function(J,e,n,R,P,O,A,E,h,c,b){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=e.$RP=void 0;let d=class extends h.$pl{static{y=this}static{this.a="profileAssociationsMigration"}constructor($,f,u,g,a){super(u,g,f,a),this.U=$,this.W=u}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,c.$Tf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const $=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$RP=d,e.$RP=d=y=ve([se(0,A.$MP),se(1,E.$kl),se(2,R.$oi),se(3,P.$Mk),se(4,O.$Mj)],d);let m=k=class extends d{constructor($,f,u,g,a){super($,f,u,g,a),this.$=$}P($){$.length?this.$.setItem(k.b,$.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(k.c,$):this.$.removeItem(k.c)}Q(){const $="workspaceAndProfileInfo",f=this.$.getItem($,void 0);if(f){this.$.removeItem($);const g=f.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:g})}const u=super.Q();return this.$.getItem(k.a,!1)||(this.R(u),this.$.setItem(k.a,!0)),u}};e.$SP=m,e.$SP=m=k=ve([se(0,A.$NP),se(1,E.$kl),se(2,R.$oi),se(3,P.$Mk),se(4,O.$Mj)],m);let v=class extends m{constructor($,f,u,g){super(new b.$QP(0,f,g,u),$,f,u,g)}async init(){return await this.$.init(),super.init()}};e.$TP=v,e.$TP=v=ve([se(0,E.$kl),se(1,R.$oi),se(2,P.$Mk),se(3,O.$Mj)],v)}),define(ae[57],ce([0,1,38,16,6,5,40,41,284,34]),function(J,e,n,R,P,O,A,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=e.$r_b=void 0,e.$r_b=(0,P.$hi)(E.$ml);let b=class extends h.$SP{constructor(k,d,m,v,w){super(k,d,m,v,w)}getAssociatedEmptyWindows(){const k=[];for(const d of this.C.emptyWindows.keys())k.push({id:d});return k}};e.$s_b=b,e.$s_b=b=ve([se(0,c.$NP),se(1,A.$kl),se(2,n.$oi),se(3,R.$Mk),se(4,O.$Mj)],b)}),define(ae[133],ce([0,1,19,7,30]),function(J,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=O,e.$u_b=A,e.$v_b=E;async function O(h,c,b){for(const k of h){const d=k.openedWorkspace;if((0,P.$vi)(d)){const m=await b(d);if(m){if(m.folders.some(v=>n.$Kg.isEqualOrParent(c,v.uri)))return k}else if(n.$Kg.isEqualOrParent(c,d.configPath))return k}}const y=h.filter(k=>(0,P.$qi)(k.openedWorkspace)&&n.$Kg.isEqualOrParent(c,k.openedWorkspace.uri));if(y.length)return y.sort((k,d)=>-(k.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}function A(h,c){for(const b of h)if((0,P.$vi)(b.openedWorkspace)&&n.$Kg.isEqual(b.openedWorkspace.configPath,c)||(0,P.$qi)(b.openedWorkspace)&&n.$Kg.isEqual(b.openedWorkspace.uri,c))return b}function E(h,c){const b=y=>c.some(k=>n.$Kg.isEqual(R.URI.file(k),R.URI.file(y)));for(const y of h)if(y.config?.extensionDevelopmentPath?.some(k=>b(k)))return y}}),define(ae[98],ce([0,1,33,42,103,47,13,9,4,19,7,6,68,30]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qeb=void 0,e.$reb=m,e.$seb=v,e.$teb=w,e.$ueb=$,e.$veb=g,e.$web=t,e.$xeb=o,e.$yeb=p,e.$zeb=I,e.$qeb=(0,y.$gi)("workspacesService");function m(j){return j.hasOwnProperty("workspace")}function v(j){return j.hasOwnProperty("folderUri")}function w(j){return j.hasOwnProperty("fileUri")}function $(j){return f(j)||u(j)}function f(j){const S=j;return typeof S?.path=="string"&&(!S.name||typeof S.name=="string")}function u(j){const S=j;return typeof S?.uri=="string"&&(!S.name||typeof S.name=="string")}function g(j,S,D,M,W){if(j.scheme!==M.scheme)return{name:D,uri:j.toString(!0)};let F=S?void 0:W.relativePath(M,j);if(F!==void 0)F.length===0?F=".":h.$i&&(F=a(F));else if(j.scheme===A.Schemas.file)F=j.fsPath,h.$i&&(F=a(F));else if(W.isEqualAuthority(j.authority,M.authority))F=j.path;else return{name:D,uri:j.toString(!0)};return{name:D,path:F}}function a(j){return j=(0,O.$dw)(j),(0,n.$dg)(j)||(j=(0,n.$ag)(j)),j}function t(j,S,D){const M=[],W=new Set,F=D.dirname(S);for(const H of j){let x;if(f(H))H.path&&(x=D.resolvePath(F,H.path));else if(u(H))try{x=b.URI.parse(H.uri),x.path[0]!==E.$gc.sep&&(x=x.with({path:E.$gc.sep+x.path}))}catch(le){console.warn(le)}if(x){const le=D.getComparisonKey(x);if(!W.has(le)){W.add(le);const re=H.name||D.basenameOrAuthority(x);M.push(new d.$Ai({uri:x,name:re,index:M.length},H))}}}return M}function o(j,S,D,M,W){const F=r(S,j),H=W.dirname(S),x=W.dirname(M),le=[];for(const Y of F.folders){const U=f(Y)?W.resolvePath(H,Y.path):b.URI.parse(Y.uri);let L;D?L=!1:L=!f(Y)||(0,E.$ic)(Y.path),le.push(g(U,L,Y.name,x,W))}const re={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ue=P.$In(j,["folders"],le,re);let Q=P.$Ln(j,ue);return(0,c.$Yg)(F.remoteAuthority,(0,k.$rm)(M))&&(Q=P.$Ln(Q,P.$Hn(Q,["remoteAuthority"],re))),Q}function r(j,S){const D=R.$tn(S);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(M=>$(M));else throw new Error(`${j} looks like an invalid workspace file.`);return D}function i(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function s(j){return typeof j.folderUri=="string"}function l(j){return typeof j.fileUri=="string"}function p(j,S){const D={workspaces:[],files:[]};if(j){const M=function(F,H){for(let x=0;x<F.length;x++)try{H(F[x],x)}catch(le){S.warn(`Error restoring recent entry ${JSON.stringify(F[x])}: ${le.toString()}. Skip entry.`)}},W=j;Array.isArray(W.entries)&&M(W.entries,F=>{const H=F.label,x=F.remoteAuthority;i(F)?D.workspaces.push({label:H,remoteAuthority:x,workspace:{id:F.workspace.id,configPath:b.URI.parse(F.workspace.configPath)}}):s(F)?D.workspaces.push({label:H,remoteAuthority:x,folderUri:b.URI.parse(F.folderUri)}):l(F)&&D.files.push({label:H,remoteAuthority:x,fileUri:b.URI.parse(F.fileUri)})})}return D}function I(j){const S={entries:[]};for(const D of j.workspaces)v(D)?S.entries.push({folderUri:D.folderUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority}):S.entries.push({workspace:{id:D.workspace.id,configPath:D.workspace.configPath.toString()},label:D.label,remoteAuthority:D.remoteAuthority});for(const D of j.files)S.entries.push({fileUri:D.fileUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority});return S}}),define(ae[99],ce([0,1,87,13,4,19]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0,e.$x_b=A,e.$y_b=E,e.$z_b=h,e.$w_b=128/4;function A(c){function b(){let y=c.scheme===R.Schemas.file?(0,O.$Hg)(c):c.toString();return P.$k||(y=y.toLowerCase()),(0,n.createHash)("md5").update(y).digest("hex")}return{id:b(),configPath:c}}function E(c,b){function y(){if(c.scheme!==R.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!b)return;let d;return P.$k?d=b.ino:P.$j?d=b.birthtime.getTime():P.$i&&(typeof b.birthtimeMs=="number"?d=Math.floor(b.birthtimeMs):d=b.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(d?String(d):"").digest("hex")}const k=y();if(typeof k=="string")return{id:k,uri:c}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[100],ce([0,1,87,88,26,285,17,15,3,2,9,4,32,43,113]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$0h=e.$9h=e.$8h=void 0,e.$$h=r,e.$_h=i,e.$bi=p,e.$ci=I;class v{traceSocketEvent(S,D){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,D)}constructor(S,D=""){this.f=!0,this.debugLabel=D,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,E.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const D=M=>{this.traceSocketEvent("read",M),S(A.$te.wrap(M))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=M=>{S({type:0,hadError:M,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){const D=()=>{S()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,E.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,E.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$8h=v;var w;(function(j){j[j.MinHeaderByteSize=2]="MinHeaderByteSize",j[j.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var $;(function(j){j[j.PeekHeader=1]="PeekHeader",j[j.ReadHeader=2]="ReadHeader",j[j.ReadBody=3]="ReadBody",j[j.Fin=4]="Fin"})($||($={}));class f extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,D){this.socket.traceSocketEvent(S,D)}constructor(S,D,M,W){super(),this.f=this.B(new h.$6d),this.g=this.B(new h.$6d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:M?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new u(this,D,M,W,this.f,(F,H)=>this.m(F,H))),this.B(this.a.onError(F=>{console.error(F),(0,E.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new m.$3h,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let D=0;for(;D<S.byteLength;)this.a.writeMessage(S.slice(D,Math.min(D+262144,S.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(S,{compressed:D,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let W=2;S.byteLength<126?W+=0:S.byteLength<2**16?W+=2:W+=8;const F=A.$te.alloc(W),H=D?64:0,x=M&15;if(F.writeUInt8(128|H|x,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(S.byteLength>>>8&255,++le),F.writeUInt8(S.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(S.byteLength>>>24&255,++le),F.writeUInt8(S.byteLength>>>16&255,++le),F.writeUInt8(S.byteLength>>>8&255,++le),F.writeUInt8(S.byteLength>>>0&255,++le)}this.socket.write(A.$te.concat([F,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),M=D.readUInt8(0),W=(M&128)>>>7,F=(M&64)>>>6,H=M&15,x=D.readUInt8(1),le=(x&128)>>>7,re=x&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),M=D.readUInt8(1),W=(M&128)>>>7;let F=M&127,H=1;F===126?F=D.readUInt8(++H)*2**8+D.readUInt8(++H):F===127&&(F=D.readUInt8(++H)*0+D.readUInt8(++H)*0+D.readUInt8(++H)*0+D.readUInt8(++H)*0+D.readUInt8(++H)*2**24+D.readUInt8(++H)*2**16+D.readUInt8(++H)*2**8+D.readUInt8(++H));let x=0;W&&(x=D.readUInt8(++H)*2**24+D.readUInt8(++H)*2**16+D.readUInt8(++H)*2**8+D.readUInt8(++H)),this.j.state=3,this.j.readLen=F,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$9h=f;class u extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$te.alloc(0)}constructor(S,D,M,W,F,H){super(),this.n=S,this.r=F,this.s=H,this.a=this.B(new h.$6d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$6d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$6d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new g(this.n,W,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(S,D){this.g.push({data:S,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:D}=this.g.shift();if(this.f&&D.compressed){const M=await this.w(this.f,S);this.s(M,D)}else this.s(S,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,D){return new Promise((M,W)=>{S.write(D),S.flush(F=>M(F))})}acceptFrame(S,D,M){this.h.push({data:S,isCompressed:D,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const D=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,D,M){return new Promise((W,F)=>{S.write(D),M&&S.write(A.$te.fromByteArray([0,0,255,255])),S.flush(H=>W(H))})}}class g extends c.$Tc{get recordedInflateBytes(){return this.j?A.$te.concat(this.f):A.$te.alloc(0)}constructor(S,D,M,W){super(),this.h=S,this.j=D,this.a=this.B(new h.$6d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(A.$te.wrap(F))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=A.$te.concat(this.g);this.g.length=0,S(D)})}}class a extends c.$Tc{constructor(S,D){super(),this.g=S,this.a=this.B(new h.$6d),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(A.$te.wrap(M))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=A.$te.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),S(D)})}}function t(j,S){if(S===0)return;const D=j.byteLength>>>2;for(let le=0;le<D;le++){const re=j.readUInt32BE(le*4);j.writeUInt32BE(re^S,le*4)}const M=D*4,W=j.byteLength-M,F=S>>>24&255,H=S>>>16&255,x=S>>>8&255;W>=1&&j.writeUInt8(j.readUInt8(M)^F,M),W>=2&&j.writeUInt8(j.readUInt8(M+1)^H,M+1),W>=3&&j.writeUInt8(j.readUInt8(M+2)^x,M+2)}e.$0h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const j=(0,k.$Cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${j}-sock`;const S=process.platform!=="darwin"&&e.$0h?e.$0h:(0,P.tmpdir)(),D=(0,b.$jc)(S,`vscode-ipc-${j}.sock`);return s(D),D}function i(j,S,D){const W=(0,n.createHash)("sha256").update(j).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${D}-${S}-sock`;const F=D.substr(0,4),H=S.substr(0,6);let x;return process.platform!=="darwin"&&e.$0h&&!process.env.VSCODE_PORTABLE?x=(0,b.$jc)(e.$0h,`vscode-${W}-${F}-${H}.sock`):x=(0,b.$jc)(j,`${F}-${H}.sock`),s(x),x}function s(j){const S=o[y.$u];typeof S=="number"&&j.length>=S&&console.warn(`WARNING: IPC handle "${j}" is longer than ${S} chars, try a shorter --user-data-dir`)}class l extends d.$Wh{static b(S){const D=h.Event.fromNodeEventEmitter(S,"connection");return h.Event.map(D,M=>({protocol:new m.$4h(new v(M,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(M,"close"))}))}constructor(S){super(l.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ai=l;function p(j){return new Promise((S,D)=>{const M=(0,R.createServer)();M.on("error",D),M.listen(j,()=>{M.removeListener("error",D),S(new l(M))})})}function I(j,S){return new Promise((D,M)=>{const W=(0,R.createConnection)(j,()=>{W.removeListener("error",M),D(m.$5h.fromSocket(new v(W,`ipc-client${S}`),S))});W.once("error",M)})}}),define(ae[24],ce([0,1,50,9,4,100,38,91,6]),function(J,e,n,R,P,O,A,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=void 0,e.$d_b=(0,h.$hi)(A.$ni);class c extends E.$Sm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$_h)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const k=y.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[y]?process.env[k]=process.env[y]:delete process.env[k]}}}restoreSnapExportedVariables(){if(P.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$e_b=c,ve([n.$Kh],c.prototype,"cachedLanguagesPath",null),ve([n.$Kh],c.prototype,"backupHome",null),ve([n.$Kh],c.prototype,"mainIPCHandle",null),ve([n.$Kh],c.prototype,"mainLockfile",null),ve([n.$Kh],c.prototype,"disableUpdates",null),ve([n.$Kh],c.prototype,"crossOriginIsolated",null),ve([n.$Kh],c.prototype,"codeCachePath",null),ve([n.$Kh],c.prototype,"useCodeCache",null)}),define(ae[286],ce([0,1,87,33,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=void 0;let u=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Kg,this.i={isEqual:(i,s)=>(0,R.$fg)(i,s,!A.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$g_b)(a)),this.e=await this.v((0,c.$h_b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$_k.OFF}q(){return this.s()===d.$_k.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$_k.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,O.$jc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,O.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,O.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,w.$vi)(i))return[];if(!t.has(i.id)){t.add(i.id);const s=(0,O.$jc)(this.c,i.id);await this.B(s)?i.configPath.scheme!==P.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(s):await this.x(s)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,s=this.h.getComparisonKey(i);if(!o.has(s)){o.add(s);const l=(0,O.$jc)(this.c,this.D(r));await this.B(l)?i.scheme!==P.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.z(l):await this.x(l)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const s=(0,O.$jc)(this.c,i);await this.B(s)?t.push(r):await this.x(s)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,$.$z_b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,$.$z_b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,O.$jc)(this.c,t.backupFolder);try{await h.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$f_b)(a)?t=(0,O.$jc)(this.c,a.backupFolder):(0,v.$oeb)(a)?t=(0,O.$jc)(this.c,this.D(a)):t=(0,O.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const o of t)try{if((await h.Promises.readdir((0,O.$jc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===P.Schemas.file?o=A.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.$S_b=u,e.$S_b=u=f=ve([se(0,y.$d_b),se(1,b.$Mi),se(2,m.$Mj),se(3,k.$NP)],u)}),define(ae[20],ce([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=e.LifecycleMainPhase=e.ShutdownReason=e.$H_b=void 0,e.$H_b=(0,b.$gi)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let $=class extends A.$Tc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(u,g,a){super(),this.F=u,this.G=g,this.H=a,this.c=this.B(new O.$6d),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$6d),this.onWillShutdown=this.f.event,this.g=this.B(new O.$6d),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$6d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const u=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",u);const g=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",g),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",u),n.app.removeListener("window-all-closed",g),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(u){if(this.y)return this.y;const g=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:u,join(t,o){g.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{g.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(u){if(u<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===u)return;this.S(`lifecycle (main): phase changed (value: ${u})`),this.n=u;const g=this.C.get(this.n);g&&(g.open(),this.C.delete(this.n))}async when(u){if(u<=this.n)return;let g=this.C.get(u);g||(g=new P.$fh,this.C.set(u,g)),await g.wait()}registerWindow(u){const g=new A.$Sc;this.t++,g.add(u.onWillLoad(t=>this.g.fire({window:u,workspace:t.workspace,reason:t.reason})));const a=(0,c.$5f)(u.win);a.on("close",t=>{const o=u.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${u.id}`),t.preventDefault(),this.unload(u,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(u),u.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${u.id}`),this.t--,g.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}registerAuxWindow(u){const g=(0,c.$5f)(u.win);g.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${u.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),g.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${u.id}`)})}async reload(u,g){await this.unload(u,3)||u.reload(g)}unload(u,g){const a=this.z.get(u.id);if(a)return a;const t=this.M(u,g).finally(()=>{this.z.delete(u.id)});return this.z.set(u.id,t),t}async M(u,g){if(!u.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${u.id}`);const a=this.j?2:g,t=await this.P(u,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${u.id})`),this.N(t)):(await this.Q(u,a),!1)}N(u){return u?(this.O(!0),this.j=!1,!0):!1}O(u){this.w&&(this.w(u),this.w=void 0,this.u=void 0)}P(u,g){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$WV.once(o,()=>{a(!1)}),R.$WV.once(r,()=>{a(!0)}),u.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:g})})}Q(u,g){return new Promise(a=>{const o=`vscode:reply${this.s++}`;R.$WV.once(o,()=>a()),u.send("vscode:onWillUnload",{replyChannel:o,reason:g})})}quit(u){return this.R(u).then(g=>{if(!g&&u)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return g})}R(u){return this.S(`Lifecycle#quit() - begin (willRestart: ${u})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(u&&this.G.setItem(m.b,!0),this.u=new Promise(g=>{this.w=g,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(u){this.H.args["enable-smoke-test-driver"]?this.F.info(u):this.F.trace(u)}setRelaunchHandler(u){this.D=u}async relaunch(u){this.S("Lifecycle#relaunch()");const g=process.argv.slice(1);if(u?.addArgs&&g.push(...u.addArgs),u?.removeArgs)for(const o of u.removeArgs){const r=g.indexOf(o);r>=0&&g.splice(r,1)}const a=()=>{this.D?.handleRelaunch(u)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:g}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(u){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,P.$hh)(1e3),(async()=>{for(const g of n.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let a;g.webContents&&!g.webContents.isDestroyed()?a=new Promise(t=>g.once("closed",t)):a=Promise.resolve(),g.destroy(),await a}})()]),n.app.exit(u)}};e.$I_b=$,e.$I_b=$=m=ve([se(0,y.$Mj),se(1,k.$NP),se(2,d.$d_b)],$)}),define(ae[287],ce([0,1,4,3,2,6,20]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=e.$dac=void 0,e.$dac=(0,O.$gi)("keyboardLayoutMainService");let E=class extends P.$Tc{constructor(b){super(),this.a=this.B(new R.$6d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((y,k)=>{J(["native-keymap"],y,k)});this.c=h(b),n.$t||b.onDidChangeKeyboardLayout(()=>{this.c=h(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$eac=E,e.$eac=E=ve([se(0,A.$H_b)],E);function h(c){const b=c.getKeyMap(),y=c.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:y}}}),define(ae[288],ce([0,1,249,8,17,15,12,18,38,95,5,53,248,285]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0,e.$Er=w;let m=class extends y.$yp{constructor(f,u,g,a){super(a),this.m=f,this.n=u,this.r=g,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,u){const{f:g,g:a}=this;let t;try{t=await(0,c.$qm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,k.$Cr)(f.url||"",o,{proxyUrl:g,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>w(f,u))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((u,g)=>{J(["@vscode/proxy-agent"],u,g)})).loadSystemCertificates({log:this.r})}};e.$Dr=m,e.$Dr=m=ve([se(0,E.$Mi),se(1,h.$oi),se(2,b.$Mj),se(3,b.$Nj)],m);async function v($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((g,a)=>{J(["https"],g,a)}):await new Promise((g,a)=>{J(["http"],g,a)})).request}async function w($,f){return R.Promises.withAsyncBody(async(u,g)=>{const a=(0,n.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await v($),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,A.$Zf)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const r=t(o,i=>{const s=(0,A.$Xf)($.followRedirects)?$.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)w({...$,url:i.headers.location,followRedirects:s-1},f).then(u,g);else{let l=i;!$.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,d.createGunzip)())),u({res:i,stream:(0,P.$Ie)(l)})}});r.on("error",g),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),f.onCancellationRequested(()=>{r.abort(),g(new O.$5)})})}}),define(ae[289],ce([0,1,14,288]),function(J,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=void 0;function P(A){return n.net.request}class O extends R.$Dr{request(E,h){return super.request({...E||{},getRawRequest:P,isChromiumNetwork:!0},h)}}e.$gbc=O}),define(ae[83],ce([0,1,7,3,2,38,16,6,20,5,97,282,41,57,40,13]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=e.$P_b=e.$O_b=e.$N_b=void 0,e.$N_b=(0,E.$gi)("storageMainService");let w=class extends P.$Tc{constructor(u,g,a,t,o,r){super(),this.c=u,this.f=g,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$6d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(u=>{u.window.profile&&this.profileStorage(u.window.profile).init(),u.workspace&&this.workspaceStorage(u.workspace).init()})),this.B(this.h.onWillShutdown(u=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=u.reason,u.join("applicationStorage",this.applicationStorage.close());for(const[,g]of this.t)u.join("profileStorage",g.close());for(const[,g]of this.w)u.join("workspaceStorage",g.close())})),this.B(this.g.onWillCreateProfile(u=>{u.join((async()=>{await this.j.exists(u.profile.globalStorageHome)||await this.j.createFolder(u.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(u=>{const g=this.t.get(u.profile.id);g&&u.join(g.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const u=new y.$K_b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(u.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),u}profileStorage(u){if((0,b.$Np)(u))return this.applicationStorage;let g=this.t.get(u.id);if(!g){this.c.trace(`StorageMainService: creating profile storage (${u.name})`),g=this.B(this.u(u)),this.t.set(u.id,g);const a=this.B(g.onDidChangeStorage(t=>this.b.fire({...t,storage:g,profile:u})));this.B(R.Event.once(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${u.name})`),this.t.delete(u.id),a.dispose()}))}return g}u(u){return this.a===2?new y.$M_b(this.c,this.j):new y.$J_b(u,this.n(),this.c,this.j)}workspaceStorage(u){let g=this.w.get(u.id);return g||(this.c.trace(`StorageMainService: creating workspace storage (${u.id})`),g=this.B(this.y(u)),this.w.set(u.id,g),this.B(R.Event.once(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${u.id})`),this.w.delete(u.id)}))),g}y(u){return this.a===2?new y.$M_b(this.c,this.j):new y.$L_b(u,this.n(),this.c,this.f,this.j)}isUsed(u){const g=n.URI.file(u);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),g))return!0;return!1}};e.$O_b=w,e.$O_b=w=ve([se(0,c.$Mj),se(1,O.$ni),se(2,d.$r_b),se(3,h.$H_b),se(4,A.$Mk),se(5,m.$kl)],w),e.$P_b=(0,E.$gi)("applicationStorageMainService");let $=class extends b.$Mp{constructor(u,g){super(),this.s=u,this.U=g,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(u){if(u===-1)return this.U.applicationStorage.storage}Q(u){if(u===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Q_b=$,e.$Q_b=$=ve([se(0,k.$ml),se(1,e.$N_b)],$)}),define(ae[290],ce([0,1,88,26,107,100,8,2,4,18,5,27,244,245,96,130,17]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=e.$ebc=e.$dbc=e.$cbc=void 0;async function $(t,o,r,i,s){let l;for(let p=3;p&&(l?.dispose(),l=await new f(t,o,r,i,s).waitForReady(),!(s&&P.$Fg[s]||!P.$Fg[l.tunnelLocalPort]));p--);return l}class f extends E.$Tc{constructor(o,r,i,s,l){super(),this.m=r,this.n=l,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=n.createServer(),this.c=new A.$fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,v.$1v)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,P.$Gg)(o,2,1e3,r),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(o){o.pause();const r=(0,v.$Yv)(this.tunnelRemoteHost)||(0,v.$1v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,k.$Cl)(this.a,r,this.tunnelRemotePort),s=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),s.end()}),o.on("close",()=>s.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),s instanceof O.$8h?s.socket.destroy():s.end()}),s instanceof O.$8h?this.t(o,s):this.s(o,s),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),s.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(w.$te.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$cbc=f;let u=class extends v.$4v{constructor(o,r,i,s,l){super(r,l),this.v=o,this.w=i,this.y=s}isPortPrivileged(o){return(0,v.$2v)(o,this.m,h.OS,R.release())}t(o,r,i,s,l,p,I,j){const S=this.s(r,i);if(S)return++S.refcount,S.value;if((0,v.$Uv)(o))return this.u(o,r,i,l,p,I,j);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${l}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=$(D,s,r,i,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,M),M}}};e.$dbc=u,e.$dbc=u=ve([se(0,d.$wl),se(1,b.$Mj),se(2,m.$zl),se(3,y.$6j),se(4,c.$Mi)],u);let g=class extends u{constructor(o,r,i,s,l){super(o,r,i,s,l)}};e.$ebc=g,e.$ebc=g=ve([se(0,d.$wl),se(1,b.$Mj),se(2,m.$zl),se(3,y.$6j),se(4,c.$Mi)],g);let a=class extends E.$Tc{constructor(o,r,i,s,l){super(),this.b=o,this.c=r,this.f=i,this.g=s,this.h=l,this.a=new Map}async openTunnel(o,r,i,s,l,p,I,j,S){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${p}.`),!this.a.has(o)){const D=new g(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(o,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,s,l,p,I,j,S)}};e.$fbc=a,e.$fbc=a=ve([se(0,d.$wl),se(1,b.$Mj),se(2,y.$6j),se(3,m.$zl),se(4,c.$Mi)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0,e.$Aac=k;function k(m,v,w){return`${w.updateUrl}/api/update/${m}/${v}/${w.commit}`}let d=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,w,$,f,u,g){this.f=v,this.g=w,this.h=$,this.i=f,this.j=u,this.k=g,this.b=y.$UW.Uninitialized,this.c=new P.$6d,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$UW.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$UW.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$UW.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),w=this.m(v);if(!w){this.d(y.$UW.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(y.$UW.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(y.$UW.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,n.$hh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$Bac=d,e.$Bac=d=ve([se(0,E.$H_b),se(1,O.$Mi),se(2,A.$d_b),se(3,b.$xp),se(4,h.$Mj),se(5,c.$6j)],d)}),define(ae[291],ce([0,1,14,50,3,45,2,18,24,20,5,27,53,28,49,101]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;let w=class extends v.$Bac{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,u)=>u)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,u,g,a)=>({version:g,productVersion:g,timestamp:a}))}constructor(f,u,g,a,t,o,r){super(f,u,a,t,o,r),this.z=g,this.u=new A.$Sc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,O.$7i)(String(f)))}),this.j.error("UpdateService error:",f);const u=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$UW.Idle(1,u))}s(f){let u;this.k.darwinUniversalAssetId?u=this.k.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,v.$Aac)(u,f,this.k);try{n.autoUpdater.setFeedURL({url:g})}catch(a){this.j.error("Failed to set update feed URL",a);return}return g}t(f){this.d(m.$UW.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(m.$UW.Downloading)}F(f){this.state.type==="downloading"&&(this.d(m.$UW.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$UW.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$UW.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Cac=w,ve([R.$Kh],w.prototype,"v",null),ve([R.$Kh],w.prototype,"w",null),ve([R.$Kh],w.prototype,"x",null),ve([R.$Kh],w.prototype,"y",null),e.$Cac=w=ve([se(0,c.$H_b),se(1,E.$Mi),se(2,d.$Ll),se(3,h.$d_b),se(4,k.$xp),se(5,b.$Mj),se(6,y.$6j)],w)}),define(ae[292],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;let k=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,w,$){if(this.f=v,this.g=$,this.a=y.$UW.Uninitialized,this.b=new O.$6d,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$UW.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,P.$hh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};k=ve([se(0,h.$H_b),se(1,E.$d_b),se(2,c.$Mj)],k);let d=class extends k{constructor(v,w,$,f,u,g){super($,f,u),this.o=v,this.p=w,this.q=g;const a=(0,R.watch)(A.$mc(this.o)),t=O.Event.fromNodeEventEmitter(a,"change",(s,l)=>l),o=O.Event.filter(t,s=>s==="current"),i=O.Event.debounce(o,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(y.$UW.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$UW.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$UW.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$UW.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+A.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise(($,f)=>(0,R.realpath)(`${A.$mc(this.o)}/current`,(u,g)=>u?f(u):$(g))),w=A.$nc(v);return this.p!==w}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Eac=d,e.$Eac=d=ve([se(2,h.$H_b),se(3,E.$d_b),se(4,c.$Mj),se(5,b.$Ll)],d)}),define(ae[29],ce([0,1,14,4,6,81,55,69,27,18,24,9,138]),function(J,e,n,R,P,O,A,E,h,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$o_b=void 0,e.$p_b=m,e.$q_b=v,e.$o_b=(0,P.$gi)("windowsMainService");var d;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(d||(e.OpenContext=d={}));function m($,f,u){const g=$.get(E.$m_b),a=$.get(h.$6j),t=$.get(c.$Mi),o=$.get(b.$d_b),r=t.getValue("window"),i={backgroundColor:g.getBackgroundColor(),minWidth:A.$7C.WIDTH,minHeight:A.$7C.HEIGHT,title:a.nameLong,...u,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,A.$fD)(f.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...u?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(R.$k?i.icon=(0,y.$jc)(o.appRoot,"resources/linux/code.png"):R.$i&&!o.isBuilt&&(i.icon=(0,y.$jc)(o.appRoot,"resources/win32/code_150x150.png")),R.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),R.$j&&!(0,A.$eD)(t)&&(i.fullscreenable=!1),R.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,A.$bD)(t)&&(i.titleBarStyle="hidden",R.$j||(i.frame=!1),(0,A.$dD)(t))){const p=g.getWindowSplash()?.colorInfo.titleBarBackground??g.getBackgroundColor(),I=k.$Ct.fromHex(p).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:p,symbolColor:I}}return i}function v($){let f,u=Number.MIN_VALUE;for(const g of $)g.lastFocusTime>u&&(u=g.lastFocusTime,f=g);return f}var w;(function($){function f(g,a,t=n.screen.getAllDisplays()){if(g.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){g.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){g.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=u(t[0]);if(g.trace("window#validateWindowState: single monitor working area",i),i){let s=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};s(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),s()}return a}if(a.display&&a.mode===3){const i=t.find(s=>s.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){g.trace("window#validateWindowState: restoring fullscreen to previous display");const s=(0,O.$b_b)(3);return s.x=i.bounds.x,s.y=i.bounds.y,s}}let o,r;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=u(o),g.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){g.error("window#validateWindowState: error finding display for window state",i)}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;g.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=f;function u(g){if(g.workArea.width>0&&g.workArea.height>0)return g.workArea;if(g.bounds.width>0&&g.bounds.height>0)return g.bounds}})(w||(e.WindowStateValidator=w={}))}),define(ae[293],ce([0,1,14,23,3,45,2,32,120,5,83,29]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let d=class extends A.$Tc{constructor(v,w,$,f){super(),this.g=v,this.h=w,this.j=$,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const v=P.Event.fromNodeEventEmitter(n.app,"login",(w,$,f,u,g)=>({event:w,webContents:$,req:f,authInfo:u,callback:g}));this.B(v(this.r,this))}async r({event:v,authInfo:w,req:$,callback:f}){if(!w.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let u;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{u=await this.b}finally{this.b=void 0}}f(u?.username,u?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(v);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const w=String((0,O.$7i)({scheme:v.scheme,host:v.host,port:v.port}));let $,f;try{const t=this.m.get(this.a+w,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));$=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof $=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:$,password:f};const u=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!u){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const g={authInfo:v,username:this.f?.username??$,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Cg)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,g),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,s)=>{if(i===g.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",o),s){const l={username:s.username,password:s.password};try{if(s.remember){const p=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+w,p,-1,1)}else this.m.remove(this.a+w,-1)}catch(p){this.g.error(p)}t({username:l.username,password:l.password})}else t(void 0)};u.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$R_b=d,e.$R_b=d=ve([se(0,c.$Mj),se(1,y.$o_b),se(2,h.$FW),se(3,b.$P_b)],d)}),define(ae[294],ce([0,1,14,22,4,7,21,18,63,6,5,131,29]),function(J,e,n,R,P,O,A,E,h,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=e.$gac=e.ID=void 0,e.ID="launchMainService",e.$gac=(0,c.$gi)(e.ID);let d=class{constructor(v,w,$,f){this.a=v,this.b=w,this.c=$,this.d=f}async start(v,w){this.a.trace("Received data from other instance: ",v,w),P.$j&&n.app.focus({steal:!0});const $=this.e(v);if($.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const u=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));u&&(f=u.ready())}f.then(()=>{for(const{uri:u,originalUrl:g}of $)this.c.open(u,{originalUrl:g})})}else return this.f(v,w)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,R.$Hb)(v._urls.map(w=>{try{return{uri:O.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(v,w){const $=(0,h.$km)(w)?0:4;let f=[];const u=v.wait&&v.waitMarkerFilePath?O.URI.file(v.waitMarkerFilePath):void 0,g=v.remote||void 0,a={context:$,cli:v,userEnv:v["preserve-env"]||$===0?w:void 0,waitMarkerFileURI:u,remoteAuthority:g,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!P.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(u&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,A.whenDeleted)(u.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$hac=d,e.$hac=d=ve([se(0,b.$Mj),se(1,k.$o_b),se(2,y.$LW),se(3,E.$Mi)],d)}),define(ae[295],ce([0,1,2,20,57,30,8,29]),function(J,e,n,R,P,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=void 0;let h=class extends n.$Tc{constructor(b,y,k){super(),this.a=y,this.b=k,this.B(b.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(b.onBeforeCloseWindow(d=>this.c(d))),this.B(new A.$sh(()=>this.g(),30*1e3)).schedule()}async c(b){const y=this.f(b),k=this.a.getProfileForWorkspace(y);k?.isTransient&&(this.a.unsetWorkspace(y,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,O.$ui)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const y=this.b.getWindows().map(k=>this.f(k));for(const k of b)y.some(d=>d.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$Wac=h,e.$Wac=h=ve([se(0,R.$H_b),se(1,P.$r_b),se(2,E.$o_b)],h)}),define(ae[60],ce([0,1,14,2,3,5,315,8,13,29,73,28,20,75,35,4,102]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0;function f(a){return typeof a.responseWindowId=="number"}let u=class extends R.$Tc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++$.a),this.f=this.B(new P.$6d),this.onStdout=this.f.event,this.g=this.B(new P.$6d),this.onStderr=this.g.event,this.h=this.B(new P.$6d),this.onMessage=this.h.event,this.j=this.B(new P.$6d),this.onSpawn=this.j.event,this.m=this.B(new P.$6d),this.onExit=this.m.event,this.n=this.B(new P.$6d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case b.default.Error:this.u.error(r);break;case b.default.Warning:this.u.warn(r);break;case b.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",b.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=h.$Ag.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],s=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,p=this.t.forceAllocationsToV8Sandbox,I="pipe",j=this.F(t);return this.z("creating new...",b.default.Info),this.r=n.utilityProcess.fork(r,i,{serviceName:o,env:j,execArgv:s,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:p,stdio:I}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Mn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,d.$0l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new A.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stdout,"data")(s=>this.f.fire(typeof s=="string"?s:i.write(s))))}if(t.stderr){const i=new A.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stderr,"data")(s=>this.g.fire(typeof s=="string"?s:i.write(s))))}this.B(P.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(P.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",b.default.Info),this.j.fire(t.pid)})),this.B(P.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,b.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,s)=>({event:i,details:s}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,b.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",b.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",b.default.Info),this.r.kill()?(this.z("successfully killed the process",b.default.Info),this.H()):this.z("unable to kill the process",b.default.Warning)}H(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",b.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,E.$hh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$U_b=u,e.$U_b=u=$=ve([se(0,O.$Mj),se(1,y.$Ll),se(2,k.$H_b)],u);let g=class extends u{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(P.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$V_b=g,e.$V_b=g=ve([se(0,O.$Mj),se(1,c.$o_b),se(2,y.$Ll),se(3,k.$H_b)],g)}),define(ae[296],ce([0,1,15,3,5,20,8,60,29,28]),function(J,e,n,R,P,O,A,E,h,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=void 0;let y=class{static{b=this}static{this.a=0}constructor(d,m,v,w){this.d=d,this.f=m,this.g=v,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(d){const m=this.b.get(d);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(d){return this.i(d).onStdout}onDynamicStderr(d){return this.i(d).onStderr}onDynamicMessage(d){return this.i(d).onMessage}onDynamicExit(d){return this.i(d).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const d=String(++b.a),m=new E.$V_b(this.d,this.g,this.h,this.f);return this.b.set(d,m),m.onExit(({pid:v,code:w,signal:$})=>{this.d.info(`Extension host with pid ${v} exited with code: ${w}, signal: ${$}.`),setTimeout(()=>{m.dispose(),this.b.delete(d)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:d}}async start(d,m){if(this.c)throw(0,n.$6)();const v=this.i(d);return v.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:d}),{pid:await R.Event.toPromise(v.onSpawn)}}async enableInspectPort(d){if(this.c)throw(0,n.$6)();const m=this.b.get(d);return m?m.enableInspectPort():!1}async kill(d){if(this.c)throw(0,n.$6)();const m=this.b.get(d);m&&m.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const m=[];for(const[,v]of this.b)m.push(v.waitForExit(d));return A.Promises.settled(m).then(()=>{})}};e.$3_b=y,e.$3_b=y=b=ve([se(0,P.$Mj),se(1,O.$H_b),se(2,h.$o_b),se(3,c.$Ll)],y)}),define(ae[297],ce([0,1,37,8,2,24,20,5,41,39,67,60,54,91,12,250]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;let w=class extends P.$Tc{constructor(f,u,g,a,t,o,r,i){super(),this.f=f,this.g=u,this.h=g,this.j=a,this.m=t,this.n=o,this.r=r,this.s=i,this.a=new R.$fh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$WV.on(v.$sac.request,(f,u)=>this.u(f,u,v.$sac.response)),n.$WV.on(v.$tac.request,(f,u)=>this.u(f,u,v.$tac.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,u,g){this.n.trace(`[SharedProcess] onWindowConnection for: ${g}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(g);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(g,u,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$rac.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new R.$Dh;this.b?.once(v.$rac.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new R.$Dh;this.b?.once(v.$rac.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$U_b(this.n,k.$4o,this.m)),this.c=this.b.onMessage(g=>{typeof g.warning=="string"?this.n.warn(g.warning):typeof g.error=="string"&&this.n.error(g.error)});const f=(0,d.$Um)(this.h.args,this.h.isBuilt);let u;f.port&&(u=["--nolazy"],f.break?u.push(`--inspect-brk=${f.port}`):u.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:u})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,m.$5f)(this.b).connect(f)}};e.$uac=w,e.$uac=w=ve([se(2,O.$d_b),se(3,h.$ml),se(4,A.$H_b),se(5,E.$Mj),se(6,b.$C_b),se(7,c.$1n)],w)}),define(ae[298],ce([0,1,24,91,20,5,54,60,114,37,2,3,35,18,13]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;let v=class extends b.$Tc{constructor($,f,u,g,a){super(),this.f=$,this.g=f,this.h=u,this.j=g,this.m=a,this.a=void 0,this.b=new y.$6d,this.onRequestConnection=this.b.event,this.c=new y.$6d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$WV.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,b.$Rc)(()=>{c.$WV.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$U_b(this.m,A.$4o,this.j);const $=(0,R.$Tm)(this.h.args,this.h.isBuilt),f=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const u=this.a.connect(),g=new h.$5V(u,"ptyHost"),a=new b.$Sc;return a.add(g),a.add((0,b.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:g,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,k.$Mn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&($.VSCODE_LATENCY=String(f));const u=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return u&&typeof u=="number"&&($.VSCODE_STARTUP_DELAY=String(u)),this.h.restoreSnapExportedVariables(),$}r($,f){this.b.fire();const u=this.a.connect();if($.sender.isDestroyed()){u.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[u])}};e.$7ac=v,e.$7ac=v=ve([se(1,d.$Mi),se(2,n.$d_b),se(3,P.$H_b),se(4,O.$Mj)],v)}),define(ae[299],ce([0,1,2,6,5,29,60,28,45,3,8,20]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=e.$5ac=void 0,e.$5ac=(0,R.$gi)("utilityProcessWorker");let k=class extends n.$Tc{constructor(v,w,$,f){super(),this.b=v,this.c=w,this.f=$,this.g=f,this.a=new Map}async createWorker(v){const w=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const $=this.h(v);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(v));const f=new d(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,f);const u=new b.$Dh;return c.Event.once(f.onDidTerminate)(g=>{g.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${g.code}, signal: ${g.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${g.code}, signal: ${g.signal}`),this.a.delete($),u.complete({reason:g})}),u.p}h(v){return(0,h.$7i)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const w=this.h(v),$=this.a.get(w);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),$.kill(),this.a.delete(w))}};e.$6ac=k,e.$6ac=k=ve([se(0,P.$Mj),se(1,O.$o_b),se(2,E.$Ll),se(3,y.$H_b)],k);let d=class extends n.$Tc{constructor(v,w,$,f,u){super(),this.c=v,this.f=w,this.g=$,this.h=f,this.j=u,this.a=this.B(new c.$6d),this.onDidTerminate=this.a.event,this.b=new A.$V_b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=ve([se(0,P.$Mj),se(1,O.$o_b),se(2,E.$Ll),se(3,y.$H_b)],d)}),define(ae[300],ce([0,1,14,3,2,276,29]),function(J,e,n,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;let E=class extends P.$Tc{constructor(c){super(),this.b=c,this.a=this.B(new R.$6d),this.onFoundInFrame=this.a.event,this.B(new O.$Lac)}async setIgnoreMenuShortcuts(c,b){let y;if(typeof c.windowId=="number"){const{windowId:k}=c,d=this.b.getWindowById(k);if(!d?.win)throw new Error(`Invalid windowId: ${k}`);y=d.win.webContents}else{const{webContentsId:k}=c;if(y=n.webContents.fromId(k),!y)throw new Error(`Invalid webContentsId: ${k}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(b)}async findInFrame(c,b,y,k){const m=this.c(c,b);if(typeof m.findInFrame=="function"){m.findInFrame(y,{findNext:k.findNext,forward:k.forward});const v=(w,$)=>{$.finalUpdate&&(this.a.fire($),m.removeListener("found-in-frame",v))};m.on("found-in-frame",v)}}async stopFindInFrame(c,b,y){const d=this.c(c,b);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(c,b){const y=this.b.getWindowById(c.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${c}`);const k=y.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===b);if(!k)throw new Error(`Unknown frame: ${b}`);return k}};e.$Mac=E,e.$Mac=E=ve([se(0,A.$o_b)],E)}),define(ae[301],ce([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0,e.$Oac=w,e.$Pac=f;let v=class extends R.$Tc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=w(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?P.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.w(i);return s.uiState.mode===3&&(a.has(s.uiState.display)?P.$j&&s.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):a.add(s.uiState.display)),s}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,d.$vi)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,d.$qi)(a.openedWorkspace)&&o.folderUri&&O.$Kg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,d.$vi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,d.$qi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=a.workspace;if((0,d.$vi)(p)){const j=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===p.id).map(S=>S.uiState);if(j.length)return j[0]}if((0,d.$qi)(p)){const j=this.state.openedWindows.filter(S=>S.folderUri&&O.$Kg.isEqual(S.folderUri,p.uri)).map(S=>S.uiState);if(j.length)return j[0]}else if(a.backupPath){const j=this.state.openedWindows.filter(S=>S.backupPath===a.backupPath).map(S=>S.uiState);if(j.length)return j[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let o;const r=n.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(P.$j){const p=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(p)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||r[0])}let i=(0,k.$b_b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const s=this.n.getValue("window");let l=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&t){const p=t.serializeWindowState();p.mode===3?i.mode=3:i={...p,zoomLevel:void 0},l=i.mode!==3&&s.newWindowDimensions==="offset"}}return l&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$Nac=v,e.$Nac=v=m=ve([se(0,y.$o_b),se(1,b.$NP),se(2,h.$H_b),se(3,c.$Mj),se(4,E.$Mi)],v);function w(g){const a={openedWindows:[]},t=g||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>$(o))),a}function $(g){const a={uiState:g.uiState};return g.backupPath&&(a.backupPath=g.backupPath),g.remoteAuthority&&(a.remoteAuthority=g.remoteAuthority),g.folder&&(a.folderUri=A.URI.parse(g.folder)),g.workspaceIdentifier&&(a.workspace={id:g.workspaceIdentifier.id,configPath:A.URI.parse(g.workspaceIdentifier.configURIPath)}),a}function f(g){return{lastActiveWindow:g.lastActiveWindow&&u(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&u(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(a=>u(a))}}function u(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(ae[58],ce([0,1,14,3,42,2,13,9,19,21,197,64,56,24,6,5,57,133,30,98,99]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=e.$A_b=void 0,e.$A_b=(0,m.$gi)("workspacesManagementMainService");let a=class extends O.$Tc{constructor(o,r,i,s,l){super(),this.g=o,this.h=r,this.j=i,this.m=s,this.n=l,this.a=this.B(new R.$6d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$6d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(r=>(0,h.$Tg)(this.c,r,f.$Fi));for(const r of o){const i=(0,g.$x_b)(r),s=await this.resolveLocalWorkspace(r);s?this.f.push({workspace:i,remoteAuthority:s.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===A.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(s=>this.t(o,s),s=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Gi)(o,this.g)||(0,f.$Li)(o)}t(o,r){try{const i=this.u(o,r),s=(0,g.$x_b)(o);return{id:s.id,configPath:s.configPath,folders:(0,u.$web)(i.folders,s.configPath,h.$Kg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,P.$tn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(s=>(0,u.$ueb)(s));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:s}=this.w(o,r),l=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$mc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(s,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),s=(0,h.$Tg)(this.c,i),l=(0,h.$Tg)(s,f.$Fi),p=[];for(const I of o)p.push((0,u.$veb)(I.uri,!0,I.name,s,h.$Kg));return{workspace:(0,g.$x_b)(l),storedWorkspace:{folders:p,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,g.$x_b)(o)}isUntitledWorkspace(o){return(0,f.$Gi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,h.$Hg)(o.configPath);try{await c.Promises.rm((0,E.$mc)(r));const i=(0,E.$jc)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$jc)(i,"obsolete"),""),this.f=this.f.filter(s=>s.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const l=await this.C(o,(0,g.$x_b)(i));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,i){return i?(0,f.$vi)(o.openedWorkspace)&&h.$Kg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,$.$u_b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,h.$Qg)(i)),detail:(0,b.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$vi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$B_b=a,e.$B_b=a=ve([se(0,d.$d_b),se(1,v.$Mj),se(2,w.$r_b),se(3,y.$i_b),se(4,k.$j_b)],a)}),define(ae[134],ce([0,1,14,37,23,6,29,30,58,12,5,60]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.$X_b=e.ID=void 0,e.ID="diagnosticsMainService",e.$X_b=(0,O.$gi)(e.ID);let k=class{constructor(m,v,w){this.a=m,this.b=v,this.c=w}async getRemoteDiagnostics(m){const v=this.a.getWindows();return(await Promise.all(v.map(async $=>{const f=$.remoteAuthority;if(!f)return;const u=`vscode:getDiagnosticInfoResponse${$.id}`,g={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(a=>{$.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:u,args:g}),R.$WV.once(u,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const w of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(w.id);$?m.push(await this.d($)):m.push(this.e(w))}const v=[];for(const{pid:w,name:$}of y.$U_b.getAll())v.push({pid:w,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:v,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(m){const v=await this.f(m),w=(0,c.$5f)(m.win);return this.e(w,v,m.remoteAuthority)}e(m,v=[],w){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:v,remoteAuthority:w}}async f(m){const v=[],w=m.openedWorkspace;if((0,E.$qi)(w))v.push(w.uri);else if((0,E.$vi)(w)){const $=await this.b.resolveLocalWorkspace(w.configPath);$&&$.folders.forEach(u=>{v.push(u.uri)})}return v}};e.$Y_b=k,e.$Y_b=k=ve([se(0,A.$o_b),se(1,h.$A_b),se(2,b.$Mj)],k)}),define(ae[70],ce([0,1,48,14,26,158,50,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,246,238,78,15]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s,l,p,I,j,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bac=e.$aac=void 0,e.$aac=(0,g.$gi)("nativeHostMainService");let M=class extends h.$Tc{constructor(F,H,x,le,re,ue,Q,Y,U){super(),this.a=F,this.b=H,this.c=x,this.f=le,this.g=re,this.h=ue,this.j=Q,this.m=Y,this.n=U,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.b.getWindowById(L))),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$6d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(L,N,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(R.screen,"display-added"),E.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,H){const x=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,s.$ui)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),le=[];return H.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...x,...le]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const H=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(H)return H.id}openWindow(F,H,x){return Array.isArray(H)?this.s(F,H,x):this.t(F,H)}async s(F,H,x=Object.create(null)){H.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:H,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async t(F,H){await this.a.openEmptyWindow({context:5,contextWindowId:F},H)}async toggleFullScreen(F,H){this.C(H?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,H){this.C(H?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const H=R.screen.getCursorScreenPoint(),x=R.screen.getDisplayNearestPoint(H);return{point:H,display:x.bounds}}async isMaximized(F,H){return this.C(H?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,H){this.C(H?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,H){this.C(H?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,H){this.C(H?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,H){this.C(H?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,H,x){const le=this.C(x?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const re=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await re}le.win.setBounds(H)}}async updateWindowControls(F,H){this.C(H?.targetWindowId,F)?.updateWindowControls(H)}async focusWindow(F,H){this.C(H?.targetWindowId,F)?.focus({force:H?.force??!1})}async setMinimumSize(F,H,x){const le=this.D(F);if(le?.win){const[re,ue]=le.win.getSize(),[Q,Y]=le.win.getMinimumSize(),[U,L]=[H??Q,x??Y],[N,G]=[Math.max(re,U),Math.max(ue,L)];(Q!==U||Y!==L)&&le.win.setMinimumSize(U,L),(re!==N||ue!==G)&&le.win.setSize(N,G)}}async saveWindowSplash(F,H){this.m.saveWindowSplash(F,H)}async installShellCommand(F){const{source:H,target:x}=await this.u();try{const{symbolicLink:le}=await v.SymlinkSupport.stat(H);if(le&&!le.dangling){const re=await(0,d.$Lq)(H);if(x===re)return}await v.Promises.unlink(H)}catch(le){if(le.code!=="ENOENT")throw le}try{await v.Promises.symlink(x,H)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:re}=await this.showMessageBox(F,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(re===1)throw new D.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${H}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(ue)}catch{throw new Error((0,$.localize)(3,null,H))}}}async uninstallShellCommand(F){const{source:H}=await this.u();try{await v.Promises.unlink(H)}catch(x){switch(x.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(le===1)throw new D.$5;try{const re=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(re)}catch{throw new Error((0,$.localize)(7,null,H))}break}case"ENOENT":break;default:throw x}}}async u(){const F=(0,b.$kc)(this.g.appRoot,"bin","code"),H=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(F))throw new Error((0,$.localize)(8,null,F));return{source:H,target:F}}async showMessageBox(F,H){const x=this.C(H?.targetWindowId,F);return this.c.showMessageBox(H,x?.win??void 0)}async showSaveDialog(F,H){const x=this.C(H?.targetWindowId,F);return this.c.showSaveDialog(H,x?.win??void 0)}async showOpenDialog(F,H){const x=this.C(H?.targetWindowId,F);return this.c.showOpenDialog(H,x?.win??void 0)}async pickFileFolderAndOpen(F,H){const x=await this.c.pickFileFolder(H);x&&await this.w(await Promise.all(x.map(async le=>await v.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),H,F)}async pickFolderAndOpen(F,H){const x=await this.c.pickFolder(H);x&&await this.w(x.map(le=>({folderUri:k.URI.file(le)})),H,F)}async pickFileAndOpen(F,H){const x=await this.c.pickFile(H);x&&await this.w(x.map(le=>({fileUri:k.URI.file(le)})),H,F)}async pickWorkspaceAndOpen(F,H){const x=await this.c.pickWorkspace(H);x&&await this.w(x.map(le=>({workspaceUri:k.URI.file(le)})),H,F)}async w(F,H,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:F,forceNewWindow:H.forceNewWindow})}async showItemInFolder(F,H){R.shell.showItemInFolder(H)}async setRepresentedFilename(F,H,x){this.C(x?.targetWindowId,F)?.setRepresentedFilename(H)}async setDocumentEdited(F,H,x){this.C(x?.targetWindowId,F)?.setDocumentEdited(H)}async openExternal(F,H){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(H),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,H){return R.shell.trashItem(H)}async isAdmin(){let F;return y.$i?F=(await new Promise((H,x)=>{J(["native-is-elevated"],H,x)}))():F=process.getuid?.()===0,F}async writeElevated(F,H,x,le){const re=await new Promise((ue,Q)=>{J(["@vscode/sudo-prompt"],ue,Q)});return new Promise((ue,Q)=>{const Y=[`"${this.z}"`];le?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${H.fsPath}"`,`"${x.fsPath}"`);const U={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,b.$jc)((0,b.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(Y.join(" "),U,(L,N,G)=>{N&&this.h.trace(`[sudo-prompt] received stdout: ${N}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Q(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:R.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,b.$jc)((0,b.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,b.$jc)((0,b.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.$jc)(this.g.appRoot,"bin","code"):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return m.$on.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,I.$0_b)()}async killProcess(F,H,x){process.kill(H,x)}async readClipboardText(F,H){return R.clipboard.readText(H)}async writeClipboardText(F,H,x){return R.clipboard.writeText(H,x)}async readClipboardFindText(F){return R.clipboard.readFindText()}async writeClipboardFindText(F,H){return R.clipboard.writeFindText(H)}async writeClipboardBuffer(F,H,x,le){return R.clipboard.writeBuffer(H,Buffer.from(x.buffer),le)}async readClipboardBuffer(F,H){return p.$te.wrap(R.clipboard.readBuffer(H))}async hasClipboard(F,H,x){return R.clipboard.has(H,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,H){this.D(F)?.updateTouchBar(H)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,H){return this.f.relaunch(H)}async reload(F,H){const x=this.D(F);if(x){if((0,s.$vi)(x.openedWorkspace)){const le=x.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(F,H){return this.C(H?.targetWindowId,F)?.win?.close()}async quit(F){const H=this.a.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&H.win?H.win.close():this.f.quit()}async exit(F,H){await this.f.kill(H)}async resolveProxy(F,H){return this.D(F)?.win?.webContents?.session?.resolveProxy(H)}async loadCertificates(F){return(await new Promise((x,le)=>{J(["@vscode/proxy-agent"],x,le)})).loadSystemCertificates({log:this.h})}findFreePort(F,H,x,le,re=1){return(0,w.$Eg)(H,x,le,re)}async openDevTools(F,H){this.C(H?.targetWindowId,F)?.win?.webContents.openDevTools(H?.mode?{mode:H.mode,activate:H.activate}:void 0)}async toggleDevTools(F,H){this.C(H?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,H,x){const le=this.D(F);if(!le||!le.win)throw new Error;return await new j.$$_b(le.win,H,this.h).inspect(x)}async windowsGetStringRegKey(F,H,x,le){if(!y.$i)return;const re=await new Promise((ue,Q)=>{J(["@vscode/windows-registry"],ue,Q)});try{return re.GetStringRegKey(H,x,le)}catch{return}}C(F,H){return this.D(F)??this.F(F)??this.D(H)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F=="number")return this.b.getWindowById(F)}};e.$bac=M,ve([A.$Kh],M.prototype,"z",null),e.$bac=M=ve([se(0,i.$o_b),se(1,S.$__b),se(2,f.$j_b),se(3,a.$H_b),se(4,u.$d_b),se(5,t.$Mj),se(6,o.$6j),se(7,r.$m_b),se(8,l.$A_b)],M)}),define(ae[302],ce([0,1,14,26,8,23,33,2,13,4,7,111,37,182,92,134,56,24,5,70,79,27,80,34,60,55,29]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=void 0;const p="issue.processExplorerWindowState";let I=class{static{l=this}static{this.a="#1E1E1E"}constructor(D,M,W,F,H,x,le,re,ue,Q,Y){this.g=D,this.h=M,this.i=W,this.j=F,this.k=H,this.l=x,this.m=le,this.n=re,this.o=ue,this.p=Q,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){k.$WV.on("vscode:listProcesses",async D=>{const M=[];try{M.push({name:(0,d.localize)(0,null),rootProcess:await(0,y.$is)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,m.$1m)(F)?M.push({name:F.hostName,rootProcess:F}):F.processes&&M.push({name:F.hostName,rootProcess:F.processes})})}catch(W){this.i.error(`Listing processes failed: ${W}`)}this.t(D,"vscode:listProcessesResponse",M)}),k.$WV.on("vscode:workbenchCommand",(D,M)=>{const{id:W,from:F,args:H}=M;let x;switch(F){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}x?.webContents.send("vscode:runAction",{id:W,from:F,args:H})}),k.$WV.on("vscode:closeProcessExplorer",D=>{this.d?.close()}),k.$WV.on("vscode:pidToNameRequest",async D=>{const M=await this.k.getMainDiagnostics(),W=[];for(const F of M.windows)W.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:H}of r.$U_b.getAll())W.push([F,H]);this.t(D,"vscode:pidToNameResponse",W)})}async openReporter(D){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const M=new E.$Sc,W=M.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,W,{backgroundColor:D.styles.backgroundColor,title:(0,d.localize)(1,null),zoomLevel:D.zoomLevel,alwaysOnTop:!1},"issue-reporter"),W.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:D,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:g.default}),this.b.loadURL(h.$Ag.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}}async openProcessExplorer(D){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const M=new E.$Sc,W=M.add(this.n.createIPCObjectUrl()),F=this.p.getItem(p,void 0),H=j(F)?F:this.v(this.f,800,500);this.d=this.u(H,W,{backgroundColor:D.styles.backgroundColor,title:(0,d.localize)(2,null),zoomLevel:D.zoomLevel,alwaysOnTop:!0},"process-explorer"),W.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:D,product:g.default}),this.d.loadURL(h.$Ag.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const x=()=>{if(!this.d)return;const le=this.d.getSize(),re=this.d.getPosition();if(!le||!re)return;const ue={width:le[0],height:le[1],x:re[0],y:re[1]};this.p.setItem(p,ue)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const D=await n.contentTracing.stopRecording(`${(0,A.$og)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null,D),buttons:[(0,d.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,D)}async getSystemStatus(){const[D,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(D,M)}async $getSystemInfo(){const[D,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(D,M)}async $getPerformanceInfo(){try{const[D,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(D,M)}catch(D){throw this.i.warn("issueService#getPerformanceInfo ",D.message),D}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(D){this.i.error(D)}}async $showConfirmCloseDialog(){if(this.b){const{response:D}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(6,null),buttons:[(0,d.localize)(7,null),(0,d.localize)(8,null)]},this.b);D===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:D}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(9,null),buttons:[(0,d.localize)(10,null),(0,d.localize)(11,null)]},this.b);return D===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const D=this.q.getWindowById(this.c.id);if(!D)throw new Error("Window not found");return D}async $getIssueReporterUri(D){const M=this.issueReporterWindowCheck(),W=`vscode:triggerIssueUriRequestHandlerResponse${M.id}`;return P.Promises.withAsyncBody(async(F,H)=>{const x=new O.$de;M.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:W,extensionId:D}),k.$WV.once(W,(le,re)=>{F(b.URI.parse(re))});try{await(0,P.$hh)(5e3),x.cancel(),H(new Error("Timed out waiting for issue reporter URI"))}finally{k.$WV.removeHandler(W)}})}async $getIssueReporterData(D){const M=this.issueReporterWindowCheck(),W=`vscode:triggerIssueDataProviderResponse${M.id}`;return P.Promises.withAsyncBody(async F=>{const H=new O.$de;M.sendWhenReady("vscode:triggerIssueDataProvider",H.token,{replyChannel:W,extensionId:D}),k.$WV.once(W,(x,le)=>{F(le)});try{await(0,P.$hh)(5e3),H.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{k.$WV.removeHandler(W)}})}async $getIssueReporterTemplate(D){const M=this.issueReporterWindowCheck(),W=`vscode:triggerIssueDataTemplateResponse${M.id}`;return P.Promises.withAsyncBody(async F=>{const H=new O.$de;M.sendWhenReady("vscode:triggerIssueDataTemplate",H.token,{replyChannel:W,extensionId:D}),k.$WV.once(W,(x,le)=>{F(le)});try{await(0,P.$hh)(5e3),H.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{k.$WV.removeHandler(W)}})}async $getReporterStatus(D,M){const W=[!1,!1],F=this.issueReporterWindowCheck(),H="vscode:triggerReporterStatus",x=new O.$de;return F.sendWhenReady(H,x.token,{replyChannel:H,extensionId:D,extensionName:M}),await(0,P.$0g)(new Promise(re=>k.$WV.once("vscode:triggerReporterStatusResponse",(ue,Q)=>re(Q))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),x.cancel()})??W}async $sendReporterMenu(D,M){const W=this.issueReporterWindowCheck(),F="vscode:triggerReporterMenu",H=new O.$de;return W.sendWhenReady(F,H.token,{replyChannel:F,extensionId:D,extensionName:M}),await(0,P.$0g)(new Promise(le=>k.$WV.once(`vscode:triggerReporterMenuResponse:${D}`,(re,ue)=>le(ue))),5e3,()=>{this.i.error(`Error: Extension ${D} timed out waiting for menu response`),H.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(D){D.isMinimized()&&D.restore(),D.focus()}t(D,M,...W){D.sender.isDestroyed()||D.sender.send(M,...W)}u(D,M,W,F){const H=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:D.width,height:D.height,minWidth:300,minHeight:200,x:D.x,y:D.y,title:W.title,backgroundColor:W.backgroundColor||l.a,webPreferences:{preload:h.$Ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$fD)(W.zoomLevel),sandbox:!0},alwaysOnTop:W.alwaysOnTop,experimentalDarkMode:!0});return H.setMenuBarVisibility(!1),H}v(D,M,W){let F;const H=n.screen.getAllDisplays();if(H.length===1)F=H[0];else{if(c.$j){const re=n.screen.getCursorScreenPoint();F=n.screen.getDisplayNearestPoint(re)}!F&&D&&(F=n.screen.getDisplayMatching(D.getBounds())),F||(F=n.screen.getPrimaryDisplay()||H[0])}const x=F.bounds,le={width:M,height:W,x:x.x+x.width/2-M/2,y:x.y+x.height/2-W/2};return x.width>0&&x.height>0&&(le.x<x.x&&(le.x=x.x),le.y<x.y&&(le.y=x.y),le.x>x.x+x.width&&(le.x=x.x),le.y>x.y+x.height&&(le.y=x.y),le.width>x.width&&(le.width=x.width),le.height>x.height&&(le.height=x.height)),le}};e.$cac=I,e.$cac=I=l=ve([se(1,$.$d_b),se(2,f.$Mj),se(3,m.$Zm),se(4,v.$X_b),se(5,w.$j_b),se(6,u.$aac),se(7,t.$l_b),se(8,a.$6j),se(9,o.$NP),se(10,s.$o_b)],I);function j(S){return typeof S!="object"||S===null?!1:"x"in S&&"y"in S&&"width"in S&&"height"in S}}),define(ae[303],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(J,e,n,R,P,O,A,E,h,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;let d=class extends k.$Bac{constructor(v,w,$,f,u,g,a,t){super(v,w,f,u,g,t),this.e=$,this.u=a}s(v){return(0,k.$Aac)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$UW.CheckingForUpdates(v)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Dp).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$UW.Idle(1))):this.d(y.$UW.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const $=v?w.message||w:void 0;this.d(y.$UW.Idle(1,$))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$UW.Idle(1))}};e.$Dac=d,e.$Dac=d=ve([se(0,O.$H_b),se(1,R.$Mi),se(2,b.$Ll),se(3,P.$d_b),se(4,c.$xp),se(5,A.$Mj),se(6,E.$aac),se(7,h.$6j)],d)}),define(ae[304],ce([0,1,48,46,26,8,23,50,45,9,7,146,21,18,24,16,20,5,70,27,53,28,49,101]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;async function r(p,I=1e3){for(;!p();)await(0,O.$hh)(I)}let i;function s(){return typeof i>"u"&&(i=R.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?0:1),i}let l=class extends o.$Bac{get cachePath(){const I=c.$jc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(I,{recursive:!0}).then(()=>I)}constructor(I,j,S,D,M,W,F,H,x){super(I,j,D,M,W,x),this.u=S,this.v=F,this.w=H,I.setRelaunchHandler(this)}handleRelaunch(I){return I?.addArgs||I?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$UW.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(I){let j=`win32-${process.arch}`;return s()===1?j+="-archive":this.k.target==="user"&&(j+="-user"),(0,o.$Aac)(j,I,this.k)}t(I){this.a&&(this.d(t.$UW.CheckingForUpdates(I)),this.i.request({url:this.a},A.CancellationToken.None).then(g.$Dp).then(j=>{const S=s();return!j||!j.url||!j.version||!j.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!I}),this.d(t.$UW.Idle(S)),Promise.resolve(null)):S===1?(this.d(t.$UW.AvailableForDownload(j)),Promise.resolve(null)):(this.d(t.$UW.Downloading),this.C(j.version).then(()=>this.B(j.version).then(D=>k.Promises.exists(D).then(M=>{if(M)return Promise.resolve(D);const W=`${D}.tmp`;return this.i.request({url:j.url},A.CancellationToken.None).then(F=>this.v.writeFile(b.URI.file(W),F.stream)).then(j.sha256hash?()=>(0,y.$RV)(W,j.sha256hash):()=>{}).then(()=>k.Promises.rename(W,D,!1)).then(()=>D)})).then(D=>{this.e={packagePath:D},this.d(t.$UW.Downloaded(j)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$UW.Ready(j))})))}).then(void 0,j=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$7i)(String(j)))}),this.j.error(j);const S=I?j.message||j:void 0;this.d(t.$UW.Idle(s(),S))}))}async o(I){I.update.url&&this.w.openExternal(void 0,I.update.url),this.d(t.$UW.Idle(s()))}async B(I){const j=await this.cachePath;return c.$jc(j,`CodeSetup-${this.k.quality}-${I}.exe`)}async C(I=null){const j=I?W=>!new RegExp(`${this.k.quality}-${I}\\.exe$`).test(W):()=>!0,S=await this.cachePath,M=(await k.Promises.readdir(S)).filter(j).map(async W=>{try{await k.Promises.unlink(c.$jc(S,W))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const I=this.state.update;this.d(t.$UW.Updating(I));const j=await this.cachePath;this.e.updateFilePath=c.$jc(j,`CodeSetup-${this.k.quality}-${I.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$UW.Idle(s()))});const D=`${this.k.win32MutexName}-ready`,M=await new Promise((W,F)=>{J(["@vscode/windows-mutex"],W,F)});r(()=>M.isActive(D)).then(()=>this.d(t.$UW.Ready(I)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(I){if(this.state.type!=="idle")return;const j=this.g.getValue("update.enableWindowsBackgroundUpdates"),S={version:"unknown",productVersion:"unknown"};this.d(t.$UW.Downloading),this.e={packagePath:I},this.d(t.$UW.Downloaded(S)),j?this.k.target==="user"&&this.p():this.d(t.$UW.Ready(S))}};e.$Fac=l,ve([E.$Kh],l.prototype,"cachePath",null),e.$Fac=l=ve([se(0,w.$H_b),se(1,d.$Mi),se(2,a.$Ll),se(3,m.$d_b),se(4,g.$xp),se(5,$.$Mj),se(6,v.$Mk),se(7,f.$aac),se(8,u.$6j)],l)}),define(ae[135],ce([0,1,14,8,23,51,3,2,13,66,4,7,193,26,64,18,56,24,63,16,20,5,27,80,255,83,28,106,69,55,29,30,58,81,39,34,57,67,22,6]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s,l,p,I,j,S,D,M,W,F,H,x,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=e.$E_b=void 0;var ue;(function(U){U[U.NONE=0]="NONE",U[U.NAVIGATING=1]="NAVIGATING",U[U.READY=2]="READY"})(ue||(ue={}));class Q extends E.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(A.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(A.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(A.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(A.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(A.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(A.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,I.$bD)(this.r);if(b.$j&&N&&L.setSheetOffset((0,b.$J)((0,d.release)())?28:22),N&&(b.$i&&(0,I.$dD)(this.r)||b.$j)){const G=this.s.getItem(Q.C);G&&this.updateWindowControls({height:G})}b.$i&&N&&L.hookWindowMessage(278,()=>{const[q,oe]=L.getPosition(),he=n.screen.getCursorScreenPoint(),K=he.x-q,C=he.y-oe;return!(K>30&&C>=0&&C<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:C})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),b.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,N,G,q){super(),this.r=L,this.s=N,this.t=G,this.u=q,this.a=this.B(new A.$6d),this.onDidClose=this.a.event,this.b=this.B(new A.$6d),this.onDidMaximize=this.b.event,this.c=this.B(new A.$6d),this.onDidUnmaximize=this.c.event,this.f=this.B(new A.$6d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$6d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new A.$6d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,I.$dD)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){b.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return b.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){b.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return b.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){b.$j&&L?.force&&n.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(b.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const N=this.win;if(N){if(L.height&&this.s.setItem(Y.C,L.height),b.$i&&this.D)N.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(b.$j&&L.height!==void 0){const G=(L.height-15)/2;G?N.setWindowButtonPosition({x:G,y:G}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,N){(0,I.$eD)(this.r)?this.I(L,N):this.L(L)}get isFullScreen(){if(b.$j&&typeof this.F=="boolean")return this.F;const L=this.win,N=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(N||G)}I(L,N){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,N)}J(L,N){if(b.$j){this.F=L;const q=this.G=new R.$Dh;(async()=>{const oe=await Promise.race([q.p,(0,R.$hh)(1e4).then(()=>!1)]);this.G===q&&(this.F=void 0,this.G=void 0,!oe&&L&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const N=this.win;N?.isFullScreen()&&this.J(!1,!1),N?.setSimpleFullScreen(L),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$E_b=Q;let Y=class extends Q{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,S.$ui)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,N,G,q,oe,he,K,C,T,Z,z,X,V,_,B,te,ie,de,me,ke,Se){super(Z,ke,q,N),this.eb=G,this.fb=oe,this.gb=he,this.hb=K,this.ib=C,this.jb=T,this.kb=z,this.lb=X,this.mb=V,this.nb=_,this.ob=B,this.pb=te,this.qb=ie,this.rb=de,this.sb=me,this.M=this.B(new A.$6d),this.onWillLoad=this.M.event,this.N=this.B(new A.$6d),this.onDidSignalReady=this.N.event,this.O=this.B(new A.$6d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Oe,He]=this.Db(L.state);this.S=Oe,this.u.trace("window#ctor: using window state",Oe);const ye=this.S.mode===0||this.S.mode===3,ee=Se.invokeFunction(j.$p_b,this.S,{show:!ye,webPreferences:{preload:h.$Ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(ee),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),$e=b.$j&&fe?.nativeTabs===!0;(b.$j||b.$i)&&He&&(!$e||n.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function N(){G.dispose(),q.dispose(),L()}const G=this.onDidClose(()=>N()),q=this.onWillLoad(()=>N())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,q)=>this.xb(3,{reason:q,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Ab(N))),this.B(this.lb.onDidDeleteUntitledWorkspace(N=>this.zb(N)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(N,G)=>{const q=await this.wb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,q)})})}wb(){return this.vb||(this.vb=(0,r.$Rp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,N){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:N?.reason,code:N?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:q}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const oe=G===0;await this.yb(oe,q)}}else if(L===2){let G;N?G=(0,k.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:q,checkboxChecked:oe}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=q===0;await this.yb(he,oe)}break}}async yb(L,N){const G=this.R?.workspace;if(N&&G)try{const q=this.jb.workspaceStorage(G);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.u.error(q)}this.O.fire();try{if(L&&this.R){let q,oe;(0,S.$qi)(G)?q={folderUri:G.uri}:(0,S.$vi)(G)?q={workspaceUri:G.configPath}:oe=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const N=this.Fb();N!==this.U&&(this.U=N,this.Gb(N))}if(!L||L.affectsConfiguration("http.proxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Y||G!==this.Z)){this.Y=N,this.Z=G;const q=N||"",oe=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${q}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:q,proxyBypassRules:oe,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:q,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(L){b.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!N.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,N),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(h.$Ag.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new R.$sh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:N.isReload?3:G?2:1})}Bb(L,N){const G=(this.R??this.bb)?.userEnv;if(G){const q=(0,f.$km)(G)&&!(0,f.$km)(L.userEnv),oe=this.isExtensionDevelopmentHost;(q||oe)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(L["disable-extensions"]=N.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.ab.update(L)}async reload(L){const N=Object.assign({},this.R);N.workspace=await this.Cb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&L&&(N.verbose=L.verbose,N.debugId=L.debugId,N.extensionEnvironment=L.extensionEnvironment,N["inspect-extensions"]=L["inspect-extensions"],N["inspect-brk-extensions"]=L["inspect-brk-extensions"],N["extensions-dir"]=L["extensions-dir"]),N.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.fb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},N.logLevel=this.eb.getLogLevel(),N.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,S.$vi)(L.workspace)){const N=L.workspace.configPath;if(N.scheme===h.Schemas.file&&!await this.hb.exists(N))return}else if((0,S.$qi)(L.workspace)){const N=L.workspace.uri;if(N.scheme===h.Schemas.file&&!await this.hb.exists(N))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$b_b)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,M.$b_b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||q.width,height:this.S.height||q.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let N;if(!b.$j&&this.m.isMaximized()?N=0:N=1,N===0?L.mode=0:L.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(L){this.$=L.zoomLevel;try{const G=n.screen.getAllDisplays();N=G.length>1,L=j.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$b_b)(),N]}getBounds(){const[L,N]=this.m.getPosition(),[G,q]=this.m.getSize();return{x:L,y:N,width:G,height:q}}H(L,N){super.H(L,N),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,I.$_C)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,N=!0){b.$j||(L==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const N=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,N,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(L,...G)})}send(L,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...N)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,O.$4i)(G)}`)}}}updateTouchBar(L){b.$j&&this.X.forEach((N,G)=>{const q=L[G];N.segments=this.Lb(q)})}Jb(){if(b.$j){for(let L=0;L<10;L++){const N=this.Kb();this.X.push(N)}this.m.setTouchBar(new n.TouchBar({items:this.X}))}}Kb(L=[]){const N=this.Lb(L),G=new n.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:G.segments[q].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let q;G.icon&&!l.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===h.Schemas.file&&(q=n.nativeImage.createFromPath(y.URI.revive(G.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let oe;return typeof G.title=="string"?oe=G.title:oe=G.title.value,{id:G.id,label:q?void 0:oe,icon:q}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$F_b=Y,e.$F_b=Y=ve([se(1,a.$Mj),se(2,x.$C_b),se(3,$.$d_b),se(4,W.$1n),se(5,H.$r_b),se(6,u.$Mk),se(7,i.$P_b),se(8,i.$N_b),se(9,v.$Mi),se(10,p.$m_b),se(11,D.$A_b),se(12,m.$i_b),se(13,s.$Ll),se(14,w.$j_b),se(15,g.$H_b),se(16,t.$6j),se(17,o.$l_b),se(18,j.$o_b),se(19,F.$NP),se(20,re.$fi)],Y)}),define(ae[305],ce([0,1,14,4,18,24,20,5,34,55,135]),function(J,e,n,R,P,O,A,E,h,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0;let y=class extends b.$E_b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(d,m,v,w,$,f){super(w,$,m,v),this.M=d,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const d=n.BrowserWindow.fromWebContents(this.M);d&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(d),d.setMenu(null),(R.$i||R.$k)&&(0,c.$bD)(this.r)&&d.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$G_b=y,e.$G_b=y=ve([se(1,O.$d_b),se(2,E.$Mj),se(3,P.$Mi),se(4,h.$NP),se(5,A.$H_b)],y)}),define(ae[306],ce([0,1,14,3,2,13,37,305,6,5,81,29]),function(J,e,n,R,P,O,A,E,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;let k=class extends P.$Tc{constructor(m,v){super(),this.h=m,this.j=v,this.a=this.B(new R.$6d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$6d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$6d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new R.$6d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(m,v)=>{const w=this.getWindowById(v.id);w&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),A.$WV.handle("vscode:registerAuxiliaryWindow",async(m,v)=>{const w=this.getWindowById(m.sender.id);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=v),m.sender.id})}createWindow(m){return this.h.invokeFunction(y.$p_b,this.n(m),{webPreferences:{preload:O.$Ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const v={},w=m.features.split(",");for(const f of w){const[u,g]=f.split("=");switch(u){case"width":v.width=parseInt(g,10);break;case"height":v.height=parseInt(g,10);break;case"left":v.x=parseInt(g,10);break;case"top":v.y=parseInt(g,10);break}}const $=y.WindowStateValidator.validateWindowState(this.j,v)??(0,b.$c_b)();return this.j.trace("[aux window] using window state",$),$}registerWindow(m){const v=new P.$Sc,w=this.h.createInstance(E.$G_b,m);this.g.set(w.id,w),v.add((0,P.$Rc)(()=>this.g.delete(w.id))),v.add(w.onDidMaximize(()=>this.a.fire(w))),v.add(w.onDidUnmaximize(()=>this.b.fire(w))),v.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),v.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),v.add(w.onDidTriggerSystemContextMenu(({x:$,y:f})=>this.f.fire({window:w,x:$,y:f}))),R.Event.once(w.onDidClose)(()=>v.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,y.$q_b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$$ac=k,e.$$ac=k=ve([se(0,h.$fi),se(1,c.$Mj)],k)}),define(ae[84],ce([0,1,14,22,8,3,47,2,13,4,19,7,21,196,6,20,5,83,98,30,58,31,56]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=e.$mac=void 0,e.$mac=(0,m.$gi)("workspacesHistoryMainService");let r=class extends E.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,l,p,I,j){super(),this.f=s,this.g=l,this.h=p,this.j=I,this.m=j,this.c=this.B(new O.$6d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$eh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let l=[],p=[];for(const j of s)if((0,f.$reb)(j))!this.g.isUntitledWorkspace(j.workspace)&&!this.w(l,j.workspace)&&l.push(j);else if((0,f.$seb)(j))this.y(l,j.folderUri)||l.push(j);else{const S=this.z(p,j.fileUri),D=j.fileUri.scheme===h.Schemas.file&&o.G.indexOf((0,b.$Qg)(j.fileUri))>=0;!S&&!D&&(p.push(j),c.$i&&j.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(j.fileUri.fsPath))}const I=await this.r({workspaces:l,files:p});l=I.workspaces,p=I.files,l.length>o.a&&(l.length=o.a),p.length>o.a&&(p.length=o.a),await this.t({workspaces:l,files:p}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(s){const l=S=>{const D=this.u(S);for(const M of s)if(b.$Kg.isEqual(M,D))return!1;return!0},p=await this.getRecentlyOpened(),I=p.workspaces.filter(l),j=p.files.filter(l);(I.length!==p.workspaces.length||j.length!==p.files.length)&&(await this.t({files:j,workspaces:I}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(s){if(s?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null)],message:(0,d.localize)(2,null),detail:(0,d.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(s){const l=new a.$Ac(j=>b.$Kg.getComparisonKey(j));if(s?.workspaces)for(const j of s.workspaces)l.set(this.u(j),j);const p=new a.$Ac(j=>b.$Kg.getComparisonKey(j));if(s?.files)for(const j of s.files)p.set(this.u(j),j);const I=await this.s();for(const j of I.workspaces){const S=l.get(this.u(j));S?S.label=S.label??j.label:l.set(this.u(j),j)}for(const j of I.files){const S=p.get(this.u(j));S?S.label=S.label??j.label:p.set(this.u(j),j)}return{workspaces:[...l.values()],files:[...p.values()]}}async s(){await this.j.whenReady;let s;const l=this.j.get(o.b,-1);if(typeof l=="string")try{s=JSON.parse(l)}catch(p){this.f.error("Unexpected error parsing opened paths list",p)}return(0,f.$yeb)(s,this.f)}async t(s){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$zeb)(s)),-1,1)}u(s){return(0,f.$seb)(s)?s.folderUri:(0,f.$teb)(s)?s.fileUri:s.workspace.configPath}w(s,l){return!!s.find(p=>(0,f.$reb)(p)&&p.workspace.id===l.id)}y(s,l){return!!s.find(p=>(0,f.$seb)(p)&&b.$Kg.isEqual(p.folderUri,l))}z(s,l){return!!s.find(p=>b.$Kg.isEqual(p.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(4,null),description:(0,d.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const j of n.app.getJumpListSettings().removedItems){const S=j.args;if(S){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(S);D&&l.push(y.URI.parse(D[2]))}}await this.removeRecentlyOpened(l);let p=!1;const I=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(j=>{const S=(0,f.$reb)(j)?j.workspace:j.folderUri,{title:D,description:M}=this.L(S,j.label);let W;return y.URI.isUri(S)?W=`--folder-uri "${S.toString()}"`:(p=!0,W=`--file-uri "${S.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:M.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));I.length>0&&s.push({type:"custom",name:p?(0,d.localize)(6,null):(0,d.localize)(7,null),items:I})}s.push({type:"recent"});try{const l=n.app.setJumpList(s);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(s,l){if(l)return{title:(0,A.$lw)(l).name,description:l};if(y.URI.isUri(s))return{title:(0,b.$Qg)(s),description:this.M(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,d.localize)(8,null),description:""};let p=(0,b.$Qg)(s.configPath);return p.endsWith(u.$Ci)&&(p=p.substr(0,p.length-u.$Ci.length-1)),{title:(0,d.localize)(9,null,p),description:this.M(s.configPath)}}M(s){return s.scheme==="file"?(0,A.$dw)(s.fsPath):s.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),l=[];let p=0;for(let j=0;j<s.workspaces.length&&p<o.C;j++){const S=this.u(s.workspaces[j]);if(S.scheme===h.Schemas.file){const D=(0,b.$Hg)(S);await k.Promises.exists(D)&&(l.push(D),p++)}}const I=[];for(let j=0;j<s.files.length&&p<o.D;j++){const S=this.u(s.files[j]);if(S.scheme===h.Schemas.file){const D=(0,b.$Hg)(S);if(o.G.includes((0,b.$Qg)(S))||l.includes(D))continue;await k.Promises.exists(D)&&(I.push(D),p++)}}I.reverse().forEach(j=>n.app.addRecentDocument(j)),l.reverse().forEach(j=>n.app.addRecentDocument(j))}};e.$nac=r,e.$nac=r=o=ve([se(0,w.$Mj),se(1,g.$A_b),se(2,v.$H_b),se(3,$.$P_b),se(4,t.$j_b)],r)}),define(ae[307],ce([0,1,14,8,23,47,4,7,184,78,18,24,20,5,234,70,27,34,28,49,55,29,84]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(p,I,j,S,D,M,W,F,H,x,le,re){this.n=p,this.o=I,this.p=j,this.q=S,this.r=D,this.s=M,this.t=W,this.u=F,this.v=H,this.w=x,this.x=le,this.y=re,this.m=Object.create(null),this.g=new R.$sh(()=>this.F(),0),this.h=new R.$sh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.$j||(0,g.$bD)(I))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const p=this.t.getItem(o.a);p&&(p.menus&&(this.k=p.menus),p.keybindings&&(this.l=p.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(M,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(M,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(M,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(M,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const p=this.x.youTubeUrl;p&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(p,"openYouTubeUrl"));const I=this.x.requestFeatureUrl;I&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(I,"openUserVoiceUrl"));const j=this.x.reportIssueUrl;j&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(j,"openReportIssues"));const S=this.x.licenseUrl;S&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.$w){const M=S.indexOf("?")>0?"&":"?";this.ab(`${S}${M}lang=${A.$w}`,"openLicenseUrl")}else this.ab(S,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&S&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(D,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(p=>this.G(p)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const p=this.o.getValue("window.enableMenuBarMnemonics");return typeof p!="boolean"?!0:p}get D(){if(!A.$j)return!1;const p=this.o.getValue("window.nativeTabs");return typeof p!="boolean"?!1:p}updateMenu(p,I){this.k=p.menus,this.l=p.keybindings,this.t.setItem(o.a,p),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(p){A.$j&&(p.oldCount===0&&p.newCount>0||p.oldCount>0&&p.newCount===0)&&(this.d=p.newCount===0,this.E())}H(){if(!A.$j)return;const p=n.BrowserWindow.getFocusedWindow();this.f=!p||!!this.y.getWindowById(p.id),this.E()}I(){const p=n.Menu.getApplicationMenu();if(p&&this.j.push(p),Object.keys(this.k).length===0){this.J(A.$j?new n.Menu:null);return}const I=new n.Menu;let j;if(A.$j){const D=new n.Menu;j=new n.MenuItem({label:this.x.nameShort,submenu:D}),this.K(D),I.append(j)}if(A.$j&&!this.c){this.c=!0;const D=new n.Menu;D.append(new n.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(D)}if(this.M("File")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(1,null)),submenu:D});this.O(D,"File"),I.append(M)}if(this.M("Edit")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(2,null)),submenu:D});this.O(D,"Edit"),I.append(M)}if(this.M("Selection")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(3,null)),submenu:D});this.O(D,"Selection"),I.append(M)}if(this.M("View")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(4,null)),submenu:D});this.O(D,"View"),I.append(M)}if(this.M("Go")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(5,null)),submenu:D});this.O(D,"Go"),I.append(M)}if(this.M("Run")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(6,null)),submenu:D});this.O(D,"Run"),I.append(M)}if(this.M("Terminal")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(7,null)),submenu:D});this.O(D,"Terminal"),I.append(M)}let S;if(this.M("Window")){const D=new n.Menu;S=new n.MenuItem({label:this.cb(h.localize(8,null)),submenu:D,role:"window"}),this.U(D)}if(S&&I.append(S),this.M("Help")){const D=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(9,null)),submenu:D,role:"help"});this.O(D,"Help"),I.append(M)}I.items&&I.items.length>0?this.J(I):this.J(null),this.h.schedule()}J(p){if(n.Menu.setApplicationMenu(p),p)for(const I of this.y.getWindows())I.win?.setMenu(null)}K(p){const I=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),j=this.V();let S;if(this.M("Preferences")){const re=new n.Menu;this.O(re,"Preferences"),S=new n.MenuItem({label:this.cb(h.localize(11,null)),submenu:re})}const D=new n.Menu,M=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:D}),W=new n.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),H=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),x=new n.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(re,ue,Q)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.L(Q)&&this.w.quit(void 0)}})),le=[I];le.push(...j),S&&le.push(s(),S),le.push(s(),M,s(),W,F,H,s(),x),le.forEach(re=>p.append(re))}async L(p){if(this.p.getWindowCount()===0)return!0;const I=this.o.getValue("window.confirmBeforeClose");if(I==="always"||I==="keyboardOnly"&&this.S(p)){const{response:j}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return j===0}return!0}M(p){if(!A.$j&&!(0,g.$bD)(this.o))return!1;switch(p){case"File":case"Help":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[p];case"Window":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[p]}}N(p,I){I.forEach(j=>{if((0,m.$jac)(j))p.append(s());else if((0,m.$iac)(j)){const S=new n.Menu,D=new n.MenuItem({label:this.cb(j.label),submenu:S});this.N(S,j.submenu.items),p.append(D)}else(0,m.$kac)(j)?p.append(this.Q(j)):(0,m.$lac)(j)&&(j.id==="workbench.action.showAboutDialog"&&this.P(p),A.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[j.id]?p.append(new n.MenuItem(this.$(j.id,{label:this.cb(j.label),click:this.m[j.id]}))):p.append(this.W(j.label,j.id,!1,j.checked)):p.append(this.W(j.label,j.id,j.enabled!==!1,!!j.checked)):p.append(this.W(j.label,j.id,j.enabled!==!1,!!j.checked)))})}O(p,I){this.k&&this.k[I]&&this.N(p,this.k[I].items)}P(p){const I=this.V();I.length&&(I.forEach(j=>p.append(j)),p.append(s()))}Q(p){const I=E.URI.revive(p.uri),j=p.id,S=j==="openRecentFile"?{fileUri:I}:j==="openRecentWorkspace"?{workspaceUri:I}:{folderUri:I};return new n.MenuItem(this.$(j,{label:p.label,click:async(D,M,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[S],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:p.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([I])}},!1))}R(p){return!!(p&&(!A.$j&&(p.ctrlKey||p.shiftKey)||A.$j&&(p.metaKey||p.altKey)))}S(p){return!!(p.triggeredByAccelerator||p.altKey||p.ctrlKey||p.metaKey||p.shiftKey)}T(p,I,j){const S={label:this.cb(p),role:j,enabled:!0};return new n.MenuItem(this.Z(I,S))}U(p){const I=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),j=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),S=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.W(h.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(s()),M.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[I,j,s(),D,...M,s(),S].forEach(W=>p.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return A.$j?[]:[new n.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(p,I,j,S){const D=this.cb(p),M=typeof I=="function"?I:(le,re,ue)=>{const Q=le?le.userSettingsLabel:null;let Y=I;Array.isArray(I)&&(Y=this.R(ue)?I[1]:I[0]),Q&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Q}):this.Y({type:"commandId",commandId:Y})},W=typeof j=="boolean"?j:this.p.getWindowCount()>0,F=typeof S=="boolean"?S:!1,H={label:D,click:M,enabled:W};F&&(H.type="checkbox",H.checked=F);let x;return typeof I=="string"?x=I:Array.isArray(I)&&(x=I[0]),A.$j&&(x==="editor.action.clipboardCutAction"?H.role="cut":x==="editor.action.clipboardCopyAction"?H.role="copy":x==="editor.action.clipboardPasteAction"&&(H.role="paste"),x==="undo"?H.click=this.X(M,{inDevTools:le=>le.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?H.click=this.X(M,{inDevTools:le=>le.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(H.click=this.X(M,{inDevTools:le=>le.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(x,H))}X(p,I){return(j,S,D)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return I.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return I.inDevTools(M.webContents.devToolsWebContents);p(j,S||M,D)}}Y(p){let I=n.BrowserWindow.getFocusedWindow();if(I){const S=this.y.getWindowById(I.id);S&&(I=this.p.getWindowById(S.parentId)?.win??null)}if(!I){const S=this.p.getLastActiveWindow();S?.win?.isMinimized()&&(I=S.win)}const j=I?this.p.getWindowById(I.id):void 0;if(j){if(this.v.trace("menubar#runActionInRenderer",p),A.$j&&!this.q.isBuilt&&!j.isReady&&(p.type==="commandId"&&p.commandId==="workbench.action.toggleDevTools"||p.type!=="commandId"&&p.userSettingsLabel==="alt+cmd+i"))return!1;if(p.type==="commandId"){const S={id:p.commandId,from:"menu"};j.sendWhenReady("vscode:runAction",P.CancellationToken.None,S)}else{const S={userSettingsLabel:p.userSettingsLabel};j.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,S)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",p),!1}Z(p,I){const j=typeof p=="string"?this.l[p]:void 0;if(j?.label){if(j.isNative!==!1)I.accelerator=j.label,I.userSettingsLabel=j.userSettingsLabel;else if(typeof I.label=="string"){const S=I.label.indexOf("[");S>=0?I.label=`${I.label.substr(0,S)} [${j.label}]`:I.label=`${I.label} [${j.label}]`}}else I.accelerator=void 0;return I}$(p,I,j=!I.accelerator){j&&(I=this.Z(p,I));const S=I.click;return I.click=(D,M,W)=>{this.bb(p),S?.(D,M,W)},I}ab(p,I){this.w.openExternal(void 0,p),this.bb(I)}bb(p){this.r.publicLog2("workbenchActionExecuted",{id:p,from:r})}cb(p){return(0,O.$iw)(p,!this.C)}};e.$oac=i,e.$oac=i=o=ve([se(0,u.$VW),se(1,b.$Mi),se(2,a.$o_b),se(3,y.$d_b),se(4,f.$Ll),se(5,t.$mac),se(6,$.$NP),se(7,k.$H_b),se(8,d.$Mj),se(9,v.$aac),se(10,w.$6j),se(11,c.$__b)],i);function s(){return new n.MenuItem({type:"separator"})}}),define(ae[308],ce([0,1,6,20,5,307]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=e.$pac=void 0,e.$pac=(0,n.$gi)("menubarMainService");let A=class{constructor(h,c,b){this.b=h,this.c=c,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$oac)}async updateMenubar(h,c){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(c,h)}};e.$qac=A,e.$qac=A=ve([se(0,n.$fi),se(1,R.$H_b),se(2,P.$Mj)],A)}),define(ae[309],ce([0,1,14,21,102,26,22,23,3,33,47,2,13,9,66,4,36,19,12,7,194,64,18,56,24,16,6,20,5,79,80,68,34,55,135,29,133,301,30,99,84,58,69,39,57,67,78]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s,l,p,I,j,S,D,M,W,F,H,x,le,re,ue,Q,Y,U,L,N,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;function q(K){return(0,le.$vi)(K?.workspace)}function oe(K){return(0,le.$qi)(K?.workspace)}let he=class extends y.$Tc{constructor(C,T,Z,z,X,V,_,B,te,ie,de,me,ke,Se,Oe,He,ye,ee,fe,$e){super(),this.s=C,this.t=T,this.u=Z,this.w=z,this.z=X,this.C=V,this.D=_,this.F=B,this.G=te,this.H=ie,this.I=de,this.J=me,this.L=ke,this.M=Se,this.N=Oe,this.O=He,this.P=ye,this.Q=ee,this.R=fe,this.S=$e,this.a=this.B(new h.$6d),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$6d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$6d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$6d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$6d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$6d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$6d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$6d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new x.$Nac(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(C=>this.b.fire(C.window))),this.B(this.onDidSignalReadyWindow(C=>{if(C.config?.extensionDevelopmentPath||C.config?.extensionTestsPath){const T=new y.$Sc;if(T.add(h.Event.any(C.onDidClose,C.onDidDestroy)(()=>T.dispose())),C.config.extensionDevelopmentPath)for(const Z of C.config.extensionDevelopmentPath)T.add(this.Q.addValidFileRoot(Z));C.config.extensionTestsPath&&T.add(this.Q.addValidFileRoot(C.config.extensionTestsPath))}}))}openEmptyWindow(C,T){const Z=this.F.args,z=T?.remoteAuthority||void 0,X=!0,V=T?.forceReuseWindow,_=!V;return this.open({...C,cli:Z,forceEmpty:X,forceNewWindow:_,forceReuseWindow:V,remoteAuthority:z})}openExistingWindow(C,T){C.focus(),this.W(T,[C])}async open(C){this.w.trace("windowsManager#open"),C.addMode&&(C.initialStartup||!this.getLastActiveWindow())&&(C.addMode=!1);const T=[],Z=[],z=[],X=[],V=[];let _,B=0;const te=await this.cb(C);this.w.trace("windowsManager#open pathsToOpen",te);for(const Se of te)oe(Se)?C.addMode?T.push(Se):Z.push(Se):q(Se)?z.push(Se):Se.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),_.filesToOpenOrCreate.push(Se)):Se.backupPath?V.push({backupFolder:(0,d.$nc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):B++;C.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),C.mergeMode&&_&&_.filesToOpenOrCreate.length===4&&(_.filesToMerge=_.filesToOpenOrCreate.slice(0,4),_.filesToOpenOrCreate=[],_.filesToDiff=[]),_&&C.waitMarkerFileURI&&(_.filesToWait={paths:(0,A.$Hb)([..._.filesToDiff,_.filesToMerge[3],..._.filesToOpenOrCreate]),waitMarkerFileUri:C.waitMarkerFileURI}),C.initialStartup?(X.push(...this.M.getUntitledWorkspaces()),z.push(...X),V.push(...this.I.getEmptyWindowBackups())):V.length=0;const{windows:ie,filesOpenedInWindow:de}=await this.X(C,z,Z,V,B,_,T);if(this.w.trace(`windowsManager#open used window count ${ie.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${Z.length}, emptyToRestore: ${V.length}, emptyToOpen: ${B})`),ie.length>1)if(de)de.focus();else{const Se=this.r.state.lastActiveWindow&&!C.forceEmpty&&!C.cli._.length&&!C.cli["file-uri"]&&!C.cli["folder-uri"]&&!(C.urisToOpen&&C.urisToOpen.length);let Oe=!0,He=!0;if(Se){const ye=ie.filter(ee=>this.r.state.lastActiveWindow&&ee.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Oe=!1,He=!1)}if(Oe)for(let ye=ie.length-1;ye>=0;ye--){const ee=ie[ye];if(!(ee.openedWorkspace&&X.some(fe=>ee.openedWorkspace&&fe.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&V.some(fe=>ee.backupPath&&fe.backupFolder===(0,d.$nc)(ee.backupPath)))){ee.focus(),He=!1;break}}He&&ie[ie.length-1].focus()}const me=_&&_.filesToDiff.length>0,ke=_&&_.filesToMerge.length>0;if(!ie.some(Se=>Se.isExtensionDevelopmentHost)&&!me&&!ke&&!C.noRecentEntry){const Se=[];for(const Oe of te)q(Oe)&&!Oe.transient?Se.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):oe(Oe)?Se.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Se.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.L.addRecentlyOpened(Se)}return this.W(C,ie),ie}W(C,T){const Z=C.waitMarkerFileURI;C.context===0&&Z&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.P.del(Z)}catch{}})()}async X(C,T,Z,z,X,V,_){const B=[];let te;function ie(ye,ee){B.push(ye),ee&&(te=ye,V=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.ob(C);if(!C.initialStartup&&_.length>0){const ye=_[0].remoteAuthority,ee=this.ub(ye);ee&&ie(this.$(ee,_.map(fe=>fe.workspace.uri)))}const ke=Z.length+T.length+z.length;if(V&&ke===0){const ye=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],ee=this.getWindows().filter($e=>V&&(0,$.$Yg)($e.remoteAuthority,V.remoteAuthority));let fe;ye?.fileUri&&!me&&((C.context===4||C.context===0||C.context===1)&&(fe=await(0,H.$t_b)(ee,ye.fileUri,async $e=>$e.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),fe||(fe=this.vb(ee))),fe?(0,le.$vi)(fe.openedWorkspace)?T.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$qi)(fe.openedWorkspace)?Z.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ie(this.Y(C,fe,V),!0):ie(await this.pb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:C.forceNewTabbedWindow,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile}),!0)}const Se=(0,A.$Mb)(T,ye=>ye.workspace.id);if(Se.length>0){const ye=(0,A.$Hb)(Se.map(ee=>(0,H.$u_b)(this.getWindows(),ee.workspace.configPath)));if(ye.length>0){const ee=ye[0],fe=(0,$.$Yg)(V?.remoteAuthority,ee.remoteAuthority)?V:void 0;ie(this.Y(C,ee,fe),!!fe),de=!0}for(const ee of Se){if(ye.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===ee.workspace.id))continue;const fe=ee.remoteAuthority,$e=(0,$.$Yg)(V?.remoteAuthority,fe)?V:void 0;ie(await this.bb(C,ee,de,$e),!!$e),de=!0}}const Oe=(0,A.$Mb)(Z,ye=>$.$Kg.getComparisonKey(ye.workspace.uri));if(Oe.length>0){const ye=(0,A.$Hb)(Oe.map(ee=>(0,H.$u_b)(this.getWindows(),ee.workspace.uri)));if(ye.length>0){const ee=ye[0],fe=(0,$.$Yg)(V?.remoteAuthority,ee.remoteAuthority)?V:void 0;ie(this.Y(C,ee,fe),!!fe),de=!0}for(const ee of Oe){if(ye.some(Pe=>(0,le.$qi)(Pe.openedWorkspace)&&$.$Kg.isEqual(Pe.openedWorkspace.uri,ee.workspace.uri)))continue;const fe=ee.remoteAuthority,$e=(0,$.$Yg)(V?.remoteAuthority,fe)?V:void 0;ie(await this.bb(C,ee,de,$e),!!$e),de=!0}}const He=(0,A.$Mb)(z,ye=>ye.backupFolder);if(He.length>0)for(const ye of He){const ee=ye.remoteAuthority,fe=(0,$.$Yg)(V?.remoteAuthority,ee)?V:void 0;ie(await this.ab(C,!0,ee,fe,ye),!!fe),de=!0}if(B.length===0||V){V&&!X&&X++;const ye=V?V.remoteAuthority:C.remoteAuthority;for(let ee=0;ee<X;ee++)ie(await this.ab(C,de,ye,V),!!V),de=!0}return{windows:(0,A.$Mb)(B),filesOpenedInWindow:te}}Y(C,T,Z){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:Z}),this.Z(T);const z={filesToOpenOrCreate:Z?.filesToOpenOrCreate,filesToDiff:Z?.filesToDiff,filesToMerge:Z?.filesToMerge,filesToWait:Z?.filesToWait,termProgram:C?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",E.CancellationToken.None,z),T}Z(C){let T=C;const Z=n.BrowserWindow.getFocusedWindow();if(Z&&Z.id!==C.id){const z=this.S.getWindowById(Z.id);z&&z.parentId===C.id&&(T=z)}T.focus()}$(C,T){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),C.focus();const Z={foldersToAdd:T};return C.sendWhenReady("vscode:addFolders",E.CancellationToken.None,Z),C}ab(C,T,Z,z,X){this.w.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:Z,filesToOpen:z,forceNewWindow:T});let V;return!T&&typeof C.contextWindowId=="number"&&(V=this.getWindowById(C.contextWindowId)),this.pb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:Z,forceNewWindow:T,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:z,windowToUse:V,emptyWindowBackupInfo:X,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}bb(C,T,Z,z,X){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:z}),!Z&&!X&&typeof C.contextWindowId=="number"&&(X=this.getWindowById(C.contextWindowId)),this.pb({workspace:T.workspace,userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:Z,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:z,windowToUse:X,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}async cb(C){let T,Z=!1,z=!1;if(C.urisToOpen&&C.urisToOpen.length>0?(T=await this.db(C),Z=!0):C.forceEmpty?T=[Object.create(null)]:C.cli._.length||C.cli["folder-uri"]||C.cli["file-uri"]?(T=await this.eb(C.cli),T.length===0&&T.push(Object.create(null)),Z=!0):(T=await this.gb(),T.length===0&&T.push(Object.create(null)),z=!0),!C.addMode&&Z){const X=T.filter(V=>oe(V));if(X.length>1){const V=X[0].remoteAuthority;if(X.every(_=>(0,$.$Yg)(_.remoteAuthority,V))){const _=await this.M.createUntitledWorkspace(X.map(B=>({uri:B.workspace.uri})));T.push({workspace:_,remoteAuthority:V}),T=T.filter(B=>!oe(B))}}}if(C.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const X=await this.gb();T.unshift(...X.filter(V=>q(V)||oe(V)||V.backupPath))}return T}async db(C){const T={gotoLineMode:C.gotoLineMode,remoteAuthority:C.remoteAuthority},Z=await Promise.all((0,A.$Hb)(C.urisToOpen||[]).map(async z=>{const X=await this.ib(z,T);if(X)return X.label=z.label,X;const V=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:V.scheme===k.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:V.scheme===k.Schemas.file?(0,g.localize)(3,null,(0,b.$cw)(V,{os:v.OS,tildify:this.F})):(0,g.localize)(4,null,V.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Hb)(Z)}async eb(C){const T=[],Z={ignoreFileNotFound:!0,gotoLineMode:C.goto,remoteAuthority:C.remote||void 0,forceOpenWorkspaceAsFile:C.diff&&C._.length===2||C.merge&&C._.length===4},z=C["folder-uri"];if(z){const _=await Promise.all(z.map(B=>{const te=this.fb(B);if(te)return this.ib({folderUri:te},Z)}));T.push(...(0,A.$Hb)(_))}const X=C["file-uri"];if(X){const _=await Promise.all(X.map(B=>{const te=this.fb(B);if(te)return this.ib((0,le.$Li)(B)?{workspaceUri:te}:{fileUri:te},Z)}));T.push(...(0,A.$Hb)(_))}const V=await Promise.all(C._.map(_=>Z.remoteAuthority?this.nb(_,Z):this.lb(_,Z)));return T.push(...(0,A.$Hb)(V)),T}fb(C){try{const T=u.URI.parse(C);if(!T.scheme){this.w.error(`Invalid URI input string, scheme missing: ${C}`);return}return T.path?T:T.with({path:"/"})}catch(T){this.w.error(`Invalid URI input string: ${C}, ${T.message}`)}}async gb(){const C=this.hb();switch(C){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];C!=="one"&&T.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&T.push(this.r.state.lastActiveWindow);const Z=await Promise.all(T.map(async z=>{if(z.workspace){const X=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(X))return X}else if(z.folderUri){const X=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(oe(X))return X}else if(C!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,A.$Hb)(Z)}}}hb(){let C;return this.H.wasRestarted?C="all":(C=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(C)||(C="all")),C}async ib(C,T=Object.create(null)){const Z=this.kb(C);return Z.scheme===k.Schemas.file?((0,M.$$C)(C)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.lb(Z.fsPath,T)):this.jb(C,T)}jb(C,T){let Z=this.kb(C);const z=(0,S.$rm)(Z)||T.remoteAuthority;if(Z=(0,$.$1g)((0,$.$Ug)(Z)),(0,M.$$C)(C)){if(T.gotoLineMode){const{path:X,line:V,column:_}=(0,c.$ng)(Z.path);return{fileUri:Z.with({path:X}),options:{selection:V?{startLineNumber:V,startColumn:_||1}:void 0},remoteAuthority:z}}return{fileUri:Z,remoteAuthority:z}}else if((0,M.$9C)(C))return{workspace:(0,re.$x_b)(Z),remoteAuthority:z};return{workspace:(0,re.$y_b)(Z),remoteAuthority:z}}kb(C){return(0,M.$9C)(C)?C.workspaceUri:(0,M.$0C)(C)?C.folderUri:C.fileUri}async lb(C,T,Z){let z,X;T.gotoLineMode&&({path:C,line:z,column:X}=(0,c.$ng)(C)),C=(0,c.$ig)((0,d.$hc)(C),(0,w.cwd)());try{const V=await R.Promises.stat(C);if(V.isFile()){if(!T.forceOpenWorkspaceAsFile){const _=await this.M.resolveLocalWorkspace(u.URI.file(C));if(_)return _.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:u.URI.file(C),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:X||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,re.$y_b)(u.URI.file(C),V),type:i.FileType.Directory,exists:!0};if(!v.$i&&C==="/dev/null")return{fileUri:u.URI.file(C),type:i.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!Z)return this.mb(C,T);const _=u.URI.file(C);if(this.L.removeRecentlyOpened([_]),T.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}async mb(C,T){const Z=u.URI.file(C),{response:z,checkboxChecked:X}=await this.O.showMessageBox({type:"warning",buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null),(0,g.localize)(7,null)],message:(0,g.localize)(8,null,Z.authority),detail:(0,g.localize)(9,null,(0,b.$cw)(Z,{os:v.OS,tildify:this.F})),checkboxLabel:(0,g.localize)(10,null,Z.authority),cancelId:1});if(z===0){if((0,P.addUNCHostToAllowlist)(Z.authority),X){const V={channel:"vscode:configureAllowedUNCHost",args:Z.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.lb(C,T,!0)}if(z===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(C,T)}nb(C,T){const Z=C.charCodeAt(0),z=T.remoteAuthority;let X,V;T.gotoLineMode&&({path:C,line:X,column:V}=(0,c.$ng)(C)),Z!==47&&((0,c.$hg)(Z)&&C.charCodeAt(C.charCodeAt(1))===58&&(C=(0,c.$ag)(C)),C=`/${C}`);const _=u.URI.from({scheme:k.Schemas.vscodeRemote,authority:z,path:C});if(C.charCodeAt(C.length-1)!==47){if((0,le.$Li)(C))return T.forceOpenWorkspaceAsFile?{fileUri:_,options:{selection:X?{startLineNumber:X,startColumn:V||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,re.$x_b)(_),remoteAuthority:z};if(T.gotoLineMode||d.$gc.basename(C).indexOf(".")!==-1)return{fileUri:_,options:{selection:X?{startLineNumber:X,startColumn:V||1}:void 0},remoteAuthority:z}}return{workspace:(0,re.$y_b)(_),remoteAuthority:z}}ob(C){const T=this.J.getValue("window"),Z=T?.openFoldersInNewWindow||"default",z=T?.openFilesInNewWindow||"off";let X=(C.preferNewWindow||C.forceNewWindow)&&!C.forceReuseWindow;!C.forceNewWindow&&!C.forceReuseWindow&&(Z==="on"||Z==="off")&&(X=Z==="on");let V=!1;return C.forceNewWindow||C.forceReuseWindow?V=!!C.forceNewWindow&&!C.forceReuseWindow:(v.$j?C.context===1&&(V=!0):C.context!==3&&C.context!==2&&!(C.userEnv&&C.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!C.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(V=z==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(C,T){const Z=(0,H.$v_b)(this.getWindows(),C);if(Z)return this.H.reload(Z,T.cli),Z.focus(),[Z];let z=T.cli["folder-uri"]||[],X=T.cli["file-uri"]||[],V=T.cli._;if(!V.length&&!z.length&&!X.length&&!T.cli.extensionTestsPath){const te=this.r.state.lastPluginDevelopmentHostWindow,ie=te?.workspace??te?.folderUri;ie&&(u.URI.isUri(ie)?ie.scheme===k.Schemas.file?V=[ie.fsPath]:z=[ie.toString()]:ie.configPath.scheme===k.Schemas.file?V=[(0,$.$Hg)(ie.configPath)]:X=[ie.configPath.toString()])}let _=T.remoteAuthority;for(const te of C)if(te.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=u.URI.parse(te),de=(0,S.$rm)(ie);de&&(_?(0,$.$Yg)(de,_)||this.w.error("more than one extension development path authority"):_=de)}V=V.filter(te=>{const ie=u.URI.file(te);return(0,H.$u_b)(this.getWindows(),ie)?!1:(0,$.$Yg)((0,S.$rm)(ie),_)}),z=z.filter(te=>{const ie=this.fb(te);return ie&&(0,H.$u_b)(this.getWindows(),ie)?!1:ie?(0,$.$Yg)((0,S.$rm)(ie),_):!1}),X=X.filter(te=>{const ie=this.fb(te);return ie&&(0,H.$u_b)(this.getWindows(),ie)?!1:ie?(0,$.$Yg)((0,S.$rm)(ie),_):!1}),T.cli._=V,T.cli["folder-uri"]=z,T.cli["file-uri"]=X;const B={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!V.length&&!z.length&&!X.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:_,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(B)}async pb(C){const T=this.J.getValue("window"),Z=this.getLastActiveWindow(),z=Z?.profile??this.G.defaultProfile;let X;!C.forceNewWindow&&!C.forceNewTabbedWindow&&(X=C.windowToUse||Z,X&&X.focus());const V={...this.F.args,...C.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:C.emptyWindowBackupInfo?(0,d.$jc)(this.F.backupHome,C.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:C.remoteAuthority,workspace:C.workspace,userEnv:{...this.u,...C.userEnv},filesToOpenOrCreate:C.filesToOpen?.filesToOpenOrCreate,filesToDiff:C.filesToOpen?.filesToDiff,filesToMerge:C.filesToOpen?.filesToMerge,filesToWait:C.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:I.default,isInitialStartup:C.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(X){const _=X.config;!V.extensionDevelopmentPath&&_?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=_.extensionDevelopmentPath,V.extensionDevelopmentKind=_.extensionDevelopmentKind,V["enable-proposed-api"]=_["enable-proposed-api"],V.verbose=_.verbose,V["inspect-extensions"]=_["inspect-extensions"],V["inspect-brk-extensions"]=_["inspect-brk-extensions"],V.debugId=_.debugId,V.extensionEnvironment=_.extensionEnvironment,V["extensions-dir"]=_["extensions-dir"],V["disable-extensions"]=_["disable-extensions"]),V.loggers={global:V.loggers.global,window:_?.loggers.window??V.loggers.window}}else{const _=this.r.getNewWindowState(V);(0,m.mark)("code/willCreateCodeWindow");const B=X=this.N.createInstance(W.$F_b,{state:_,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),C.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(B),this.n.set(B.id,B),this.a.fire(B),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const te=new y.$Sc;te.add(B.onDidSignalReady(()=>this.b.fire(B))),te.add(h.Event.once(B.onDidClose)(()=>this.sb(B,te))),te.add(h.Event.once(B.onDidDestroy)(()=>this.tb(B))),te.add(B.onDidMaximize(()=>this.g.fire(B))),te.add(B.onDidUnmaximize(()=>this.h.fire(B))),te.add(B.onDidEnterFullScreen(()=>this.j.fire({window:B,fullscreen:!0}))),te.add(B.onDidLeaveFullScreen(()=>this.j.fire({window:B,fullscreen:!1}))),te.add(B.onDidTriggerSystemContextMenu(({x:de,y:me})=>this.m.fire({window:B,x:de,y:me})));const ie=(0,f.$5f)(B.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.H.reload(B)),this.H.registerWindow(B)}return V.windowId=X.id,X.isReady?this.H.unload(X,4).then(async _=>{_||await this.qb(X,V,C,z)}):await this.qb(X,V,C,z),X}async qb(C,T,Z,z){if(T.extensionDevelopmentPath||((0,le.$vi)(T.workspace)?T.backupPath=this.I.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,le.$qi)(T.workspace)?T.backupPath=this.I.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.I.registerEmptyWindowBackup({backupFolder:Z.emptyWindowBackupInfo?.backupFolder??(0,re.$z_b)().id,remoteAuthority:T.remoteAuthority})),this.G.isEnabled()){const X=T.workspace??(0,le.$ui)(T.backupPath,!1),V=this.rb(Z,X,z),_=V instanceof Promise?await V:V;T.profiles.profile=_,T.extensionDevelopmentPath||await this.G.setProfileForWorkspace(X,_)}C.load(T)}rb(C,T,Z){return C.forceProfile?this.G.profiles.find(z=>z.name===C.forceProfile)??this.G.createNamedProfile(C.forceProfile):C.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(T)??Z}sb(C,T){this.n.delete(C.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),T.dispose()}tb(C){this.n.delete(C.id),this.c.fire(C)}getFocusedWindow(){const C=n.BrowserWindow.getFocusedWindow();if(C)return this.getWindowById(C.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(C){return this.vb(this.getWindows().filter(T=>(0,$.$Yg)(T.remoteAuthority,C)))}vb(C){return(0,F.$q_b)(C)}sendToFocused(C,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(C,E.CancellationToken.None,...T)}sendToOpeningWindow(C,...T){this.B(h.Event.once(this.onDidSignalReadyWindow)(Z=>{Z.sendWhenReady(C,E.CancellationToken.None,...T)}))}sendToAll(C,T,Z){for(const z of this.getWindows())Z&&Z.indexOf(z.id)>=0||z.sendWhenReady(C,E.CancellationToken.None,T)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(C){return this.n.get(C)}getWindowByWebContents(C){const T=n.BrowserWindow.fromWebContents(C);if(T)return this.getWindowById(T.id)}};e.$Qac=he,e.$Qac=he=ve([se(3,p.$Mj),se(4,N.$C_b),se(5,D.$NP),se(6,U.$1n),se(7,r.$d_b),se(8,L.$r_b),se(9,l.$H_b),se(10,a.$i_b),se(11,t.$Mi),se(12,ue.$mac),se(13,Q.$A_b),se(14,s.$fi),se(15,o.$j_b),se(16,i.$Mk),se(17,j.$l_b),se(18,Y.$m_b),se(19,G.$__b)],he)}),define(ae[310],ce([0,1,64,29,84,58]),function(J,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let A=class{constructor(h,c,b,y){this.a=h,this.b=c,this.c=b,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const b=this.b.getWindowById(h);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),c)}createUntitledWorkspace(h,c,b){return this.a.createUntitledWorkspace(c,b)}deleteUntitledWorkspace(h,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Sac=A,e.$Sac=A=ve([se(0,O.$A_b),se(1,R.$o_b),se(2,P.$mac),se(3,n.$i_b)],A)}),define(ae[311],ce([0,1,14,102,37,26,17,51,15,33,3,42,47,2,13,9,4,12,7,32,160,43,161,114,293,164,64,286,18,203,92,134,56,120,223,24,63,95,212,296,214,215,216,16,227,94,77,6,93,222,302,287,294,20,5,308,70,27,68,297,96,34,278,83,126,28,254,256,54,49,268,291,303,292,304,131,270,271,272,275,300,55,29,309,277,30,98,84,310,58,39,236,57,247,53,82,132,280,295,283,8,258,279,231,67,299,274,22,129,298,266,242,61,78,306]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s,l,p,I,j,S,D,M,W,F,H,x,le,re,ue,Q,Y,U,L,N,G,q,oe,he,K,C,T,Z,z,X,V,_,B,te,ie,de,me,ke,Se,Oe,He,ye,ee,fe,$e,Pe,Re,qe,Me,We,Ue,xe,Je,Te,ne,ge,pe,be,Ee,Ce,Ne,Ke,Ze,Xe,Qe,st,tt,ot,at,yt,vt,kt,Et,Pt,ct,gt,St,At,jt,lt,It,$t,ut,Dt,Rt,ht,Ct,mt,Ot){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;let dt=class extends d.$Tc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ae,je,De,we,Ie,ze,Be,Ge,Le,Fe,Ve,Ye){super(),this.g=Ae,this.h=je,this.j=De,this.m=we,this.n=Ie,this.s=ze,this.t=Be,this.u=Ge,this.w=Le,this.y=Fe,this.z=Ve,this.C=Ye,this.D(),this.F()}D(){const Ae=Le=>Le?.startsWith(`${m.Schemas.vscodeWebview}://`),je=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Le,Fe,Ve,Ye)=>Ae(Ye.requestingUrl)?Ve(je.has(Fe)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((Le,Fe,Ve,Ye)=>Ae(Ye.requestingUrl)?je.has(Fe):!1);const De=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Le=>{for(let Fe=Le;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Ie=Le=>Le.resourceType==="xhr"||we(Le.frame),ze=Le=>{const Fe=Le.frame;if(!Fe||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Ye of Ve)if(Fe.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Be=(Le,Fe)=>{if(Le.path!=="/index.html")return!0;const Ve=Fe.frame;if(!Ve||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ve.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Le,Fe)=>{const Ve=f.URI.parse(Le.url);return Ve.scheme===m.Schemas.vscodeWebview&&!Be(Ve,Le)?(this.m.error("Blocked vscode-webview request",Le.url),Fe({cancel:!0})):Ve.scheme===m.Schemas.vscodeFileResource&&!ze(Le)?(this.m.error("Blocked vscode-file request",Le.url),Fe({cancel:!0})):Ve.path.endsWith(".svg")&&!De.has(Ve.scheme)?Fe({cancel:!Ie(Le)}):Fe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Le,Fe)=>{const Ve=Le.responseHeaders,Ye=Ve["content-type"]||Ve["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=f.URI.parse(Le.url);if(_e.path.endsWith(".svg")&&De.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Ye.some(it=>it.toLowerCase().includes("image/svg")))return Fe({cancel:!Ie(Le)})}return Fe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Le,Fe)=>{if(Le.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=Le.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:Ve})}return Fe({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,v.$jc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(De=>this.H(De)),process.on("uncaughtException",De=>{(0,h.$Z)(De)||(0,h.$1)(De)}),process.on("unhandledRejection",De=>(0,h.$1)(De)),this.t.onWillShutdown(()=>this.dispose()),(0,g.$XV)(),n.app.on("accessibility-support-changed",(De,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),n.app.on("activate",async(De,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(De,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$zg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Ie=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),we.setWindowOpenHandler(Ie=>Ie.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ie)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ie.url}}`),this.f?.openExternal(void 0,Ie.url),{action:"deny"}))});let Ae=[],je;n.app.on("open-file",(De,we)=>{this.m.trace("app#open-file: ",we),De.preventDefault(),Ae.push((0,Ce.$Li)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),je!==void 0&&(clearTimeout(je),je=void 0),je=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],je=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),P.$WV.handle("vscode:fetchShellEnv",De=>{const we=this.b?.getWindowByWebContents(De.sender);let Ie,ze;return we?.config?(Ie=we.config,ze={...process.env,...we.config.userEnv}):(Ie=this.s.args,ze=process.env),this.X(Ie,ze,!1)}),P.$WV.handle("vscode:writeNlsFile",(De,we,Ie)=>{const ze=this.G([we]);if(!ze||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,A.$te.fromString(Ie))}),P.$WV.handle("vscode:readNlsFile",async(De,...we)=>{const Ie=this.G(we);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ie)).value.toString()}),P.$WV.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),P.$WV.on("vscode:openDevTools",De=>De.sender.openDevTools()),P.$WV.on("vscode:reloadWindow",De=>De.sender.reload()),P.$WV.handle("vscode:notifyZoomLevel",async(De,we)=>{const Ie=this.b?.getWindowById(De.sender.id);Ie&&Ie.notifyZoomLevel(we)})}G(Ae){let je;for(const De of Ae)typeof De=="string"&&(typeof je!="string"?je=De:je=(0,v.$jc)(je,De));if(!(typeof je!="string"||!(0,v.$ic)(je)||!(0,c.$gg)(je,this.s.cachedLanguagesPath,!w.$k)))return f.URI.file(je)}H(Ae){if(Ae){const je={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(je))}this.m.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.m.error(Ae.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ae=this.z.win32AppUserModelId;w.$i&&Ae&&n.app.setAppUserModelId(Ae);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.m.error(Fe)}const je=new t.$4V;this.t.onWillShutdown(Fe=>{Fe.reason===2&&je.dispose()}),this.m.trace("Resolving machine identifier...");const[De,we]=await Promise.all([(0,gt.$1ac)(this.w,this.m),(0,gt.$2ac)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${De}`);const{sharedProcessReady:Ie,sharedProcessClient:ze}=this.P(De,we),Be=await this.Q(De,we,Ie);this.B(Be.createInstance(r.$R_b)),this.B(Be.createInstance(Et.$Wac)),Be.invokeFunction(Fe=>this.R(Fe,je,ze));const Ge=await Be.invokeFunction(Fe=>this.I(Fe,je));this.J(je),this.t.phase=2,await Be.invokeFunction(Fe=>this.S(Fe,Ge)),this.t.phase=3,this.U(),this.B(new ct.$sh(()=>{this.B((0,ct.$wh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ae,je){const De=this.b=Ae.get(pe.$o_b),we=Ae.get(We.$LW),Ie=this.f=Ae.get(V.$aac),ze=Ae.get(D.$j_b),Be=this;we.registerHandler({async handleURL(_e,it){return Be.O(De,ze,we,_e,it)}});const Ge=this.B(new Ee.$Rac({onDidOpenMainWindow:Ie.onDidOpenMainWindow,onDidFocusMainWindow:Ie.onDidFocusMainWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),Le=new a.$1h(_e=>Ge.getActiveClientId().then(it=>_e===it)),Fe=new Ue.$Iac(Le,this.m),Ve=je.getChannel("urlHandler",Fe);we.registerHandler(new Ue.$Hac(Ve));const Ye=await this.L(De,ze);return this.B(new Je.$Jac(Ye?.urls,we,De,this.s,this.z,this.m)),Ye}J(Ae){const je=()=>({statusCode:404,data:"Not found"}),De=new Ct.$V(()=>Ae.getChannel(ht.$9ac,new ht.$0ac));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,Ie)=>{const ze=f.URI.parse(we.url);if(!ze.authority.startsWith("window:"))return Ie(je());De.value.call(ht.$8ac,[ze]).then(Be=>Ie({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),Ie({statusCode:500,data:String(Be)})})})}async L(Ae,je){const De=this.s.args["open-url"]?this.s.args._urls||[]:[];De.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),De.length+we.length===0)return;const Ie=[...De,...we].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),ze=[],Be=[];for(const Ge of Ie){if(!Ge)continue;const Le=this.N(Ge.uri);if(Le)if(await this.M(Le,Ae,je)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Le),ze.push(Le);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Be.push(Ge)}return{urls:Be,openables:ze}}async M(Ae,je,De){let we,Ie;if((0,ge.$9C)(Ae)?(we=Ae.workspaceUri,Ie=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,k.$cw)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,ge.$0C)(Ae)?(we=Ae.folderUri,Ie=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,k.$cw)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ae.fileUri,Ie=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,k.$cw)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:Be,checkboxChecked:Ge}=await De.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ie,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Be!==0)return!0;if(Ge){const Le={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};je.sendToFocused(Le.channel,Le.args),je.sendToOpeningWindow(Le.channel,Le.args)}return!1}N(Ae){if(Ae.path){if(Ae.authority===m.Schemas.file){const je=f.URI.file(Ae.fsPath);return(0,Ce.$Li)(je)?{workspaceUri:je}:{fileUri:je}}else if(Ae.authority===m.Schemas.vscodeRemote){const je=Ae.path.indexOf(v.$gc.sep,1);if(je!==-1){const De=Ae.path.substring(1,je),we=Ae.path.substring(je);let Ie=Ae.query;const ze=new URLSearchParams(Ae.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ie=ze.toString());const Be=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:De,path:we,query:Ie,fragment:Ae.fragment});return(0,Ce.$Li)(we)?{workspaceUri:Be}:/:[\d]+$/.test(we)?{fileUri:Be}:{folderUri:Be}}}}}async O(Ae,je,De,we,Ie){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Ie),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let ze=!1;const Be=new URLSearchParams(we.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Be.delete("windowId"),we=we.with({query:Be.toString()}),ze=!0):w.$j&&Ae.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze=!0);const Ge=Be.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Be.delete("continueOn"),we=we.with({query:Be.toString()}),this.s.continueOn=Ge??void 0);const Le=this.N(we);return Le?await this.M(Le,Ae,je)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Le,we.toString(!0)),(0,$t.$Ob)(await Ae.open({context:5,cli:{...this.s.args},urisToOpen:[Le],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ae.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,B.$rm)(we)}))?.ready(),De.open(we,Ie)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Ie),!1)}P(Ae,je){const De=this.B(this.j.createInstance(te.$uac,Ae,je)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await De.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$5V(ze,"main")})();return{sharedProcessReady:(async()=>(await De.whenReady(),we))(),sharedProcessClient:we}}async Q(Ae,je,De){const we=new oe.$ei;switch(process.platform){case"win32":we.set(fe.$VW,new G.$di(Me.$Fac));break;case"linux":w.$l?we.set(fe.$VW,new G.$di(qe.$Eac,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$VW,new G.$di(Re.$Dac));break;case"darwin":we.set(fe.$VW,new G.$di(Pe.$Cac));break}we.set(pe.$o_b,new G.$di(be.$Qac,[Ae,je,this.h],!1)),we.set(mt.$__b,new G.$di(Ot.$$ac,void 0,!1));const Ie=new D.$k_b(this.m,this.z);we.set(D.$j_b,Ie),we.set(T.$gac,new G.$di(T.$hac,void 0,!1)),we.set(S.$X_b,new G.$di(S.$Y_b,void 0,!1)),we.set(j.$Zm,a.ProxyChannel.toService((0,a.$Yh)(De.then(Fe=>Fe.getChannel("diagnostics"))))),we.set(he.$UBb,new G.$di(K.$cac,[this.h])),we.set(M.$FW,new G.$di(W.$Z_b)),we.set(C.$dac,new G.$di(C.$eac)),we.set(V.$aac,new G.$di(V.$bac,void 0,!1)),we.set(Te.$Kac,new G.$di(ne.$Mac)),we.set(X.$pac,new G.$di(X.$qac)),we.set(le.$1_b,new G.$di(re.$3_b)),we.set(ke.$N_b,new G.$di(ke.$O_b)),we.set(ke.$P_b,new G.$di(ke.$Q_b));const ze=new Dt.$7ac({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Rt.$bs(ze,this.u,this.m,this.n);we.set(ut.$Or,Be),w.$i?we.set(ue.$4_b,new G.$di(Q.$5_b)):w.$j?we.set(ue.$4_b,new G.$di(Q.$6_b)):w.$k&&we.set(ue.$4_b,new G.$di(Q.$7_b));const Ge=new l.$S_b(this.s,this.u,this.m,this.w);we.set(s.$i_b,Ge);const Le=new Xe.$B_b(this.s,this.m,this.C,Ge,Ie);if(we.set(Xe.$A_b,Le),we.set(Ne.$qeb,new G.$di(Ze.$Sac,void 0,!1)),we.set(Ke.$mac,new G.$di(Ke.$nac,void 0,!1)),we.set(We.$LW,new G.$di(xe.$NW,void 0,!1)),(0,ee.$9o)(this.z,this.s)){const Fe=(0,ee.$bp)(this.z,this.u),Ve=(0,a.$Yh)(De.then(rt=>rt.getChannel("telemetryAppender"))),Ye=new He.$xac(Ve),_e=(0,Se.$Zo)((0,O.release)(),(0,O.hostname)(),process.arch,this.z.commit,this.z.version,Ae,je,Fe),it=(0,ee.$cp)(this.s),nt={appenders:[Ye],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};we.set(Oe.$Ll,new G.$di(ye.$Fr,[nt],!1))}else we.set(Oe.$Ll,ee.$4o);return we.set(yt.$_p,new G.$di(St.$UP,void 0,!0)),we.set(vt.$dq,new G.$di(kt.$Vac,void 0,!0)),we.set(lt.$5ac,new G.$di(lt.$6ac,void 0,!0)),await ct.Promises.settled([Ge.initialize(),Le.initialize()]),this.j.createChild(we)}R(Ae,je,De){const we=this.B(new d.$Sc),Ie=a.ProxyChannel.fromService(Ae.get(T.$gac),we,{disableMarshalling:!0});this.g.registerChannel("launch",Ie);const ze=a.ProxyChannel.fromService(Ae.get(S.$X_b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Be=new st.$Tac(Ae.get(Qe.$1n));je.registerChannel("policy",Be),De.then(et=>et.registerChannel("policy",Be));const Ge=this.y.getProvider(m.Schemas.file);(0,$.$4f)(Ge instanceof N.$Rq);const Le=new L.$8_b(Ge,this.m,this.s);je.registerChannel(Y.$DP,Le),De.then(et=>et.registerChannel(Y.$DP,Le));const Fe=a.ProxyChannel.fromService(Ae.get(tt.$r_b),we);je.registerChannel("userDataProfiles",Fe),De.then(et=>et.registerChannel("userDataProfiles",Fe));const Ve=new ot.$Ar(Ae.get(at.$xp));De.then(et=>et.registerChannel("request",Ve));const Ye=new $e.$yac(Ae.get(fe.$VW));je.registerChannel("update",Ye);const _e=a.ProxyChannel.fromService(Ae.get(he.$UBb),we);je.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(Ae.get(M.$FW),we);je.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(Ae.get(ie.$zl),we);je.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(Ae.get(C.$dac),we);je.registerChannel("keyboardLayout",rt),this.f=Ae.get(V.$aac);const wt=a.ProxyChannel.fromService(this.f,we);je.registerChannel("nativeHost",wt),De.then(et=>et.registerChannel("nativeHost",wt));const Mt=a.ProxyChannel.fromService(Ae.get(Ne.$qeb),we);je.registerChannel("workspaces",Mt);const Lt=a.ProxyChannel.fromService(Ae.get(X.$pac),we);je.registerChannel("menubar",Lt);const Wt=a.ProxyChannel.fromService(Ae.get(We.$LW),we);je.registerChannel("url",Wt);const Ft=a.ProxyChannel.fromService(Ae.get(Te.$Kac),we);je.registerChannel("webview",Ft);const pt=this.B(new me.$vac(this.m,Ae.get(ke.$N_b)));je.registerChannel("storage",pt),De.then(et=>et.registerChannel("storage",pt));const Tt=this.B(new Pt.$Xac(Ae.get(ke.$N_b),Ae.get(tt.$r_b),this.m));De.then(et=>et.registerChannel("profileStorageListener",Tt));const Nt=a.ProxyChannel.fromService(Ae.get(ut.$Or),we);je.registerChannel(ut.TerminalIpcChannels.LocalPty,Nt);const zt=a.ProxyChannel.fromService(Ae.get(ue.$4_b),we);je.registerChannel("externalTerminal",zt);const bt=new At.$3ac(Ae.get(jt.$C_b));je.registerChannel("logger",bt),De.then(et=>et.registerChannel("logger",bt));const Bt=new I.$T_b(Ae.get(pe.$o_b));je.registerChannel("extensionhostdebugservice",Bt);const qt=a.ProxyChannel.fromService(Ae.get(le.$1_b),we);je.registerChannel(le.$2_b,qt);const Ut=a.ProxyChannel.fromService(Ae.get(lt.$5ac),we);je.registerChannel(It.$4ac,Ut)}async S(Ae,je){const De=this.b=Ae.get(pe.$o_b);this.c=Ae.get(mt.$__b);const we=(0,H.$km)(process.env)?0:4,Ie=this.s.args;if(je){if(je.openables.length>0)return De.open({context:we,cli:Ie,urisToOpen:je.openables,gotoLineMode:!0,initialStartup:!0});if(je.urls.length>0)for(const nt of je.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),De.open({context:we,cli:Ie,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Be=Ie._.length,Ge=!!Ie["folder-uri"],Le=!!Ie["file-uri"],Fe=Ie["skip-add-to-recently-opened"]===!0,Ve=Ie.wait&&Ie.waitMarkerFilePath?f.URI.file(Ie.waitMarkerFilePath):void 0,Ye=Ie.remote||void 0,_e=Ie.profile,it=Ie["profile-temp"];if(!Be&&!Ge&&!Le){if(Ie["new-window"]||_e||it)return De.open({context:we,cli:Ie,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:it});if(ze.length)return De.open({context:1,cli:Ie,urisToOpen:ze.map(nt=>(0,Ce.$Li)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:Fe,waitMarkerFileURI:Ve,initialStartup:!0})}return De.open({context:we,cli:Ie,forceNewWindow:Ie["new-window"]||!Be&&Ie["unity-launch"],diffMode:Ie.diff,mergeMode:Ie.merge,noRecentEntry:Fe,waitMarkerFileURI:Ve,gotoLineMode:Ie.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:it})}U(){this.W(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Ae,je)=>{je({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ae=this.z.win32MutexName;if(w.$i&&Ae)try{const je=await new Promise((we,Ie)=>{J(["@vscode/windows-mutex"],we,Ie)}),De=new je.Mutex(Ae);b.Event.once(this.t.onWillShutdown)(()=>De.release())}catch(je){this.m.error(je)}}async X(Ae,je,De){try{return await(0,x.$qm)(this.u,this.m,Ae,je)}catch(we){const Ie=(0,E.$4i)(we);De?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ie):this.m.error(Ie)}return{}}async Y(){try{const je=(await this.y.readFile(this.s.argvResource)).value.toString(),De=JSON.parse((0,y.$Bn)(je)),Ie=(0,ee.$$o)(this.u)>=1;if(De["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ie},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.$Cg)()}"`,"}"],Be=je.substring(0,je.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,A.$te.fromString(Be))}else{const ze=je.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ie},`);ze!==je&&await this.y.writeFile(this.s.argvResource,A.$te.fromString(ze))}}catch(Ae){this.m.error(Ae)}}};e.$_ac=dt,e.$_ac=dt=ft=ve([se(2,q.$fi),se(3,z.$Mj),se(4,z.$Nj),se(5,F.$d_b),se(6,Z.$H_b),se(7,p.$Mi),se(8,de.$NP),se(9,U.$Mk),se(10,_.$6j),se(11,tt.$r_b)],dt)}),define(ae[316],ce([0,1,14,46,7,22,8,51,15,33,3,47,13,9,66,4,36,25,21,43,100,311,10,18,241,253,24,63,205,16,225,94,77,221,93,20,228,5,79,27,80,281,130,290,53,289,96,252,34,54,69,57,39,237,235,2,40,269,67,230,119,125,273,102,267]),function(J,e,n,R,P,O,A,E,h,c,b,y,k,d,m,v,w,$,f,u,g,a,t,o,r,i,s,l,p,I,j,S,D,M,W,F,H,x,le,re,ue,Q,Y,U,L,N,G,q,oe,he,K,C,T,Z,z,X,V,_,B,te,ie,de,me,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ye){console.error(ye.message),n.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(We=>console.error(We));const[ye,ee,fe,$e,Pe,Re,qe,Me]=this.b();try{try{await this.d(fe,Me,$e,Pe,qe)}catch(We){throw this.g(fe,qe,We),We}await ye.invokeFunction(async We=>{const Ue=We.get(x.$Mj),xe=We.get(F.$H_b),Je=We.get(I.$Mk),Te=We.get(x.$Nj),ne=await this.f(Ue,fe,xe,ye,qe,!0);return f.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(ge=>{Ue.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Re.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),b.Event.once(xe.onWillShutdown)(ge=>{Je.dispose(),$e.dispose(),ge.join("instanceLockfile",f.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),ye.createInstance(a.$_ac,ne,ee).startup()})}catch(We){ye.invokeFunction(this.j,We)}}b(){const ye=new W.$ei,ee=new X.$Sc;process.once("exit",()=>ee.dispose());const fe={_serviceBrand:void 0,...le.default};ye.set(re.$6j,fe);const $e=new s.$e_b(this.k(),fe),Pe=this.c($e);ye.set(s.$d_b,$e);const Re=new B.$D_b((0,x.$1j)($e),$e.logsHome);ye.set(B.$C_b,Re);const qe=new H.$X9b(Re.getLogLevel()),Me=ee.add(new te.$VP(qe,[new x.$Tj(Re.getLogLevel())]));ye.set(x.$Mj,Me);const We=new j.$sq(Me);ye.set(I.$Mk,We);const Ue=new S.$Rq(Me);We.registerProvider(k.Schemas.file,Ue);const xe=new _.$fs(We);ye.set(V.$kl,xe);const Je=new de.$QP(1,$e,Me,We);ye.set(oe.$MP,Je),ye.set(oe.$NP,Je);const Te=new C.$s_b(Je,xe,$e,We,Me);ye.set(C.$r_b,Te),We.registerProvider(k.Schemas.vscodeUserData,new me.$kbc(k.Schemas.file,Ue,k.Schemas.vscodeUserData,Te,xe,Me));const ne=v.$i&&fe.win32RegValueName?ee.add(new Z.$ibc(Me,fe.win32RegValueName)):$e.policyFile?ee.add(new z.$jbc($e.policyFile,We,Me)):new T.$3n;ye.set(T.$1n,ne);const ge=new r.$qo(Te.defaultProfile.settingsResource,We,ne,Me);return ye.set(o.$Mi,ge),ye.set(F.$H_b,new D.$di(F.$I_b,void 0,!1)),ye.set(L.$xp,new D.$di(N.$gbc,void 0,!0)),ye.set(K.$m_b,new D.$di(K.$n_b)),ye.set(G.$zl,new D.$di(q.$hbc,void 0,!1)),ye.set(Y.$Sv,new D.$di(U.$ebc)),ye.set(ue.$l_b,new Q.$bbc($e,Te,Me)),[new M.$Uq(ye,!0),Pe,$e,ge,Je,qe,fe,Te]}c(ye){const ee={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const $e=process.env[fe];typeof $e=="string"&&(ee[fe]=$e)}),Object.assign(process.env,ee),ee}async d(ye,ee,fe,$e,Pe){await A.Promises.settled([Promise.all([this.e(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:k.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ye.backupHome].map(Re=>Re?f.Promises.mkdir(Re,{recursive:!0}):void 0)),$e.init(),fe.initialize()]),ee.init()}e(ye){if(v.$i){const ee=(0,ke.getUNCHost)(ye);ee&&(0,ke.addUNCHostToAllowlist)(ee)}return ye}async f(ye,ee,fe,$e,Pe,Re){let qe;try{(0,m.mark)("code/willStartMainServer"),qe=await(0,g.$bi)(ee.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),b.Event.once(fe.onWillShutdown)(()=>qe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(ee,Pe,Me),Me;let We;try{We=await(0,g.$ci)(ee.mainIPCHandle,"main")}catch(Te){if(!Re||v.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,Pe.nameShort),(0,t.localize)(2,null),Pe),Te;try{(0,R.unlinkSync)(ee.mainIPCHandle)}catch(ne){throw ye.warn("Could not delete obsolete instance handle",ne),ne}return this.f(ye,ee,fe,$e,Pe,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${Pe.nameShort} is running.`;throw ye.error(Te),We.dispose(),new Error(Te)}let Ue;!ee.args.wait&&!ee.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,Pe.nameShort),(0,t.localize)(4,null),Pe)},1e4));const xe=u.ProxyChannel.toService(We.getChannel("launch"),{disableMarshalling:!0}),Je=u.ProxyChannel.toService(We.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return $e.invokeFunction(async()=>{const Te=new i.$ms(he.$4o,Pe),ne=await Je.getMainDiagnostics(),ge=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Te.getDiagnostics(ne,ge);throw console.log(pe),new h.$ab});throw v.$i&&await this.i(xe,ye),ye.trace("Sending env to running instance..."),await xe.start(ee.args,process.env),We.dispose(),Ue&&clearTimeout(Ue),new h.$ab("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,t.localize)(5,null,Pe.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),qe}g(ye,ee,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const $e=(0,O.$Hb)([ye.userDataPath,ye.extensionsPath,g.$0h]).map(Pe=>(0,y.$cw)(P.URI.file(Pe),{os:v.OS,tildify:ye}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$4i)(fe),$e.join(`
`)),ee)}}h(ye,ee,fe){n.dialog.showMessageBoxSync((0,ie.$qw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:ee},fe).options)}async i(ye,ee){if(v.$i){const fe=await ye.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise(($e,Pe)=>{J(["windows-foreground-love"],$e,Pe)})).allowSetForegroundWindow(fe)}catch($e){ee.error($e)}}}j(ye,ee){const fe=ye.get(x.$Mj),$e=ye.get(F.$H_b);let Pe=0;ee&&(ee.isExpected?ee.message&&fe.trace(ee.message):(Pe=1,ee.stack?fe.error(ee.stack):fe.error(`Startup error: ${ee.toString()}`))),$e.kill(Pe)}k(){const ye=this.l((0,l.$hm)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const ee=(0,p.$abc)(ye.verbose);ee&&((0,l.$jm)(process.argv,"--waitMarkerFilePath",ee),ye.waitMarkerFilePath=ee)}return ye}l(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const ee=this.m(ye._,ye.goto);ye._=ee}return ye}m(ye,ee){const fe=(0,w.cwd)(),$e=ye.map(qe=>{let Me=String(qe),We;ee&&(We=(0,c.$ng)(Me),Me=We.path),Me&&(Me=this.n(fe,Me));const Ue=(0,c.$ig)(Me,fe),xe=(0,d.$nc)(Ue);return xe&&!(0,c.$eg)(xe)?null:ee&&We?(We.path=Ue,this.o(We)):Ue}),Pe=v.$i||v.$j,Re=(0,O.$Mb)($e,qe=>qe&&Pe?qe.toLowerCase():qe||"");return(0,O.$Hb)(Re)}n(ye,ee){return v.$i&&(ee=(0,$.$5e)(ee,'"')),ee=(0,$.$3e)((0,$.$3e)(ee," "),"	"),v.$i&&(ee=(0,d.$kc)(ye,ee),ee=(0,$.$5e)(ee,".")),ee}o(ye){const ee=[ye.path];return typeof ye.line=="number"&&ee.push(String(ye.line)),typeof ye.column=="number"&&ee.push(String(ye.column)),ee.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/code/electron-main/main.js.map
