/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/hover/updatableHoverWidget","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(re){for(var t=[],i=0,C=re.length;i<C;i++)t[i]=me[re[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ct,construct:Rt}=typeof Reflect<"u"&&Reflect;Ct||(Ct=function(t,i,C){return t.apply(i,C)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Rt||(Rt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),At=ct(String.prototype.toLowerCase),Lt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(re){return function(t){for(var i=arguments.length,C=new Array(i>1?i-1:0),z=1;z<i;z++)C[z-1]=arguments[z];return Ct(re,t,C)}}function ui(re){return function(){for(var t=arguments.length,i=new Array(t),C=0;C<t;C++)i[C]=arguments[C];return Rt(re,i)}}function He(re,t,i){var C;i=(C=i)!==null&&C!==void 0?C:At,xt&&xt(re,null);let z=t.length;for(;z--;){let H=t[z];if(typeof H=="string"){const A=i(H);A!==H&&(ii(t)||(t[z]=A),H=A)}re[H]=!0}return re}function bt(re){const t=ri(null);for(const[i,C]of Bt(re))t[i]=C;return t}function yt(re,t){for(;re!==null;){const C=si(re,t);if(C){if(C.get)return ct(C.get);if(typeof C.value=="function")return ct(C.value)}re=ni(re)}function i(C){return console.warn("fallback value for",C),null}return i}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),It=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Et=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,Di=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const z="data-tt-policy-suffix";i&&i.hasAttribute(z)&&(C=i.getAttribute(z));const H="dompurify"+(C?"#"+C:"");try{return t.createPolicy(H,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Yt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Yt(Be);if(t.version="3.0.5",t.removed=[],!re||!re.document||re.document.nodeType!==9)return t.isSupported=!1,t;const i=re.document,C=i.currentScript;let{document:z}=re;const{DocumentFragment:H,HTMLTemplateElement:A,Node:y,Element:b,NodeFilter:$,NamedNodeMap:w=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:P,DOMParser:c,trustedTypes:d}=re,e=b.prototype,s=yt(e,"cloneNode"),a=yt(e,"nextSibling"),m=yt(e,"childNodes"),p=yt(e,"parentNode");if(typeof A=="function"){const Be=z.createElement("template");Be.content&&Be.content.ownerDocument&&(z=Be.content.ownerDocument)}let v,o="";const{implementation:g,createNodeIterator:r,createDocumentFragment:E,getElementsByTagName:R}=z,{importNode:M}=i;let j={};t.isSupported=typeof Bt=="function"&&typeof p=="function"&&g&&g.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:B,ERB_EXPR:D,TMPLIT_EXPR:x,DATA_ATTR:W,ARIA_ATTR:T,IS_SCRIPT_OR_DATA:L,ATTR_WHITESPACE:I}=Gt;let{IS_ALLOWED_URI:X}=Gt,U=null;const de=He({},[...Ht,...It,...Mt,...jt,...Wt]);let he=null;const ne=He({},[...Vt,...Ot,...qt,...Et]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ne=null,Ce=null,Pe=!0,le=!0,_=!1,ae=!0,oe=!1,J=!1,G=!1,ie=!1,ce=!1,Ae=!1,Fe=!1,ye=!0,K=!1;const f="user-content-";let k=!0,F=!1,l={},u=null;const n=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let h=null;const N=He({},["audio","video","img","source","image","track"]);let S=null;const O=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),V="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",ee="http://www.w3.org/1999/xhtml";let $e=ee,ve=!1,we=null;const je=He({},[V,Z,ee],Lt);let Se;const Ee=["application/xhtml+xml","text/html"],Re="text/html";let Le,Ye=null;const nt=z.createElement("form"),Ge=function(ue){return ue instanceof RegExp||ue instanceof Function},Ue=function(ue){if(!(Ye&&Ye===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),Se=Ee.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Se=Re:Se=ue.PARSER_MEDIA_TYPE,Le=Se==="application/xhtml+xml"?Lt:At,U="ALLOWED_TAGS"in ue?He({},ue.ALLOWED_TAGS,Le):de,he="ALLOWED_ATTR"in ue?He({},ue.ALLOWED_ATTR,Le):ne,we="ALLOWED_NAMESPACES"in ue?He({},ue.ALLOWED_NAMESPACES,Lt):je,S="ADD_URI_SAFE_ATTR"in ue?He(bt(O),ue.ADD_URI_SAFE_ATTR,Le):O,h="ADD_DATA_URI_TAGS"in ue?He(bt(N),ue.ADD_DATA_URI_TAGS,Le):N,u="FORBID_CONTENTS"in ue?He({},ue.FORBID_CONTENTS,Le):n,Ne="FORBID_TAGS"in ue?He({},ue.FORBID_TAGS,Le):{},Ce="FORBID_ATTR"in ue?He({},ue.FORBID_ATTR,Le):{},l="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Pe=ue.ALLOW_ARIA_ATTR!==!1,le=ue.ALLOW_DATA_ATTR!==!1,_=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,oe=ue.SAFE_FOR_TEMPLATES||!1,J=ue.WHOLE_DOCUMENT||!1,ce=ue.RETURN_DOM||!1,Ae=ue.RETURN_DOM_FRAGMENT||!1,Fe=ue.RETURN_TRUSTED_TYPE||!1,ie=ue.FORCE_BODY||!1,ye=ue.SANITIZE_DOM!==!1,K=ue.SANITIZE_NAMED_PROPS||!1,k=ue.KEEP_CONTENT!==!1,F=ue.IN_PLACE||!1,X=ue.ALLOWED_URI_REGEXP||Kt,$e=ue.NAMESPACE||ee,ge=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&Ge(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&Ge(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),oe&&(le=!1),Ae&&(ce=!0),l&&(U=He({},[...Wt]),he=[],l.html===!0&&(He(U,Ht),He(he,Vt)),l.svg===!0&&(He(U,It),He(he,Ot),He(he,Et)),l.svgFilters===!0&&(He(U,Mt),He(he,Ot),He(he,Et)),l.mathMl===!0&&(He(U,jt),He(he,qt),He(he,Et))),ue.ADD_TAGS&&(U===de&&(U=bt(U)),He(U,ue.ADD_TAGS,Le)),ue.ADD_ATTR&&(he===ne&&(he=bt(he)),He(he,ue.ADD_ATTR,Le)),ue.ADD_URI_SAFE_ATTR&&He(S,ue.ADD_URI_SAFE_ATTR,Le),ue.FORBID_CONTENTS&&(u===n&&(u=bt(u)),He(u,ue.FORBID_CONTENTS,Le)),k&&(U["#text"]=!0),J&&He(U,["html","head","body"]),U.table&&(He(U,["tbody"]),delete Ne.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=ue.TRUSTED_TYPES_POLICY,o=v.createHTML("")}else v===void 0&&(v=Di(d,C)),v!==null&&typeof o=="string"&&(o=v.createHTML(""));ot&&ot(ue),Ye=ue}},Y=He({},["mi","mo","mn","ms","mtext"]),se=He({},["foreignobject","desc","title","annotation-xml"]),pe=He({},["title","style","font","a","script"]),De=He({},It);He(De,Mt),He(De,ci);const Ie=He({},jt);He(Ie,fi);const ze=function(ue){let Te=p(ue);(!Te||!Te.tagName)&&(Te={namespaceURI:$e,tagName:"template"});const Me=At(ue.tagName),Ke=At(Te.tagName);return we[ue.namespaceURI]?ue.namespaceURI===Z?Te.namespaceURI===ee?Me==="svg":Te.namespaceURI===V?Me==="svg"&&(Ke==="annotation-xml"||Y[Ke]):!!De[Me]:ue.namespaceURI===V?Te.namespaceURI===ee?Me==="math":Te.namespaceURI===Z?Me==="math"&&se[Ke]:!!Ie[Me]:ue.namespaceURI===ee?Te.namespaceURI===Z&&!se[Ke]||Te.namespaceURI===V&&!Y[Ke]?!1:!Ie[Me]&&(pe[Me]||!De[Me]):!!(Se==="application/xhtml+xml"&&we[ue.namespaceURI]):!1},Ve=function(ue){wt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},_e=function(ue,Te){try{wt(t.removed,{attribute:Te.getAttributeNode(ue),from:Te})}catch{wt(t.removed,{attribute:null,from:Te})}if(Te.removeAttribute(ue),ue==="is"&&!he[ue])if(ce||Ae)try{Ve(Te)}catch{}else try{Te.setAttribute(ue,"")}catch{}},tt=function(ue){let Te,Me;if(ie)ue="<remove></remove>"+ue;else{const at=li(ue,/^[\r\n\t ]+/);Me=at&&at[0]}Se==="application/xhtml+xml"&&$e===ee&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Ke=v?v.createHTML(ue):ue;if($e===ee)try{Te=new c().parseFromString(Ke,Se)}catch{}if(!Te||!Te.documentElement){Te=g.createDocument($e,"template",null);try{Te.documentElement.innerHTML=ve?o:Ke}catch{}}const it=Te.body||Te.documentElement;return ue&&Me&&it.insertBefore(z.createTextNode(Me),it.childNodes[0]||null),$e===ee?R.call(Te,J?"html":"body")[0]:J?Te.documentElement:it},st=function(ue){return r.call(ue.ownerDocument||ue,ue,$.SHOW_ELEMENT|$.SHOW_COMMENT|$.SHOW_TEXT,null,!1)},Ze=function(ue){return ue instanceof P&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof w)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof y=="object"?ue instanceof y:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},et=function(ue,Te,Me){j[ue]&&oi(j[ue],Ke=>{Ke.call(t,Te,Me,Ye)})},mt=function(ue){let Te;if(et("beforeSanitizeElements",ue,null),Ze(ue))return Ve(ue),!0;const Me=Le(ue.nodeName);if(et("uponSanitizeElement",ue,{tagName:Me,allowedTags:U}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ht(/<[/\w]/g,ue.innerHTML)&&ht(/<[/\w]/g,ue.textContent))return Ve(ue),!0;if(!U[Me]||Ne[Me]){if(!Ne[Me]&&kt(Me)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me)))return!1;if(k&&!u[Me]){const Ke=p(ue)||ue.parentNode,it=m(ue)||ue.childNodes;if(it&&Ke){const at=it.length;for(let Xe=at-1;Xe>=0;--Xe)Ke.insertBefore(s(it[Xe],!0),a(ue))}}return Ve(ue),!0}return ue instanceof b&&!ze(ue)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&ht(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ve(ue),!0):(oe&&ue.nodeType===3&&(Te=ue.textContent,Te=dt(Te,B," "),Te=dt(Te,D," "),Te=dt(Te,x," "),ue.textContent!==Te&&(wt(t.removed,{element:ue.cloneNode()}),ue.textContent=Te)),et("afterSanitizeElements",ue,null),!1)},gt=function(ue,Te,Me){if(ye&&(Te==="id"||Te==="name")&&(Me in z||Me in nt))return!1;if(!(le&&!Ce[Te]&&ht(W,Te))){if(!(Pe&&ht(T,Te))){if(!he[Te]||Ce[Te]){if(!(kt(ue)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,ue)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ue))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Te)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Te))||Te==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me))))return!1}else if(!S[Te]){if(!ht(X,dt(Me,I,""))){if(!((Te==="src"||Te==="xlink:href"||Te==="href")&&ue!=="script"&&ai(Me,"data:")===0&&h[ue])){if(!(_&&!ht(L,dt(Me,I,"")))){if(Me)return!1}}}}}}return!0},kt=function(ue){return ue.indexOf("-")>0},St=function(ue){let Te,Me,Ke,it;et("beforeSanitizeAttributes",ue,null);const{attributes:at}=ue;if(!at)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:he};for(it=at.length;it--;){Te=at[it];const{name:ut,namespaceURI:$t}=Te;if(Me=ut==="value"?Te.value:hi(Te.value),Ke=Le(ut),Xe.attrName=Ke,Xe.attrValue=Me,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,et("uponSanitizeAttribute",ue,Xe),Me=Xe.attrValue,Xe.forceKeepAttr||(_e(ut,ue),!Xe.keepAttr))continue;if(!ae&&ht(/\/>/i,Me)){_e(ut,ue);continue}oe&&(Me=dt(Me,B," "),Me=dt(Me,D," "),Me=dt(Me,x," "));const Ft=Le(ue.nodeName);if(gt(Ft,Ke,Me)){if(K&&(Ke==="id"||Ke==="name")&&(_e(ut,ue),Me=f+Me),v&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!$t)switch(d.getAttributeType(Ft,Ke)){case"TrustedHTML":{Me=v.createHTML(Me);break}case"TrustedScriptURL":{Me=v.createScriptURL(Me);break}}try{$t?ue.setAttributeNS($t,ut,Me):ue.setAttribute(ut,Me),zt(t.removed)}catch{}}}et("afterSanitizeAttributes",ue,null)},Tt=function Be(ue){let Te;const Me=st(ue);for(et("beforeSanitizeShadowDOM",ue,null);Te=Me.nextNode();)et("uponSanitizeShadowNode",Te,null),!mt(Te)&&(Te.content instanceof H&&Be(Te.content),St(Te));et("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Be){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Te,Me,Ke,it;if(ve=!Be,ve&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(G||Ue(ue),t.removed=[],typeof Be=="string"&&(F=!1),F){if(Be.nodeName){const ut=Le(Be.nodeName);if(!U[ut]||Ne[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof y)Te=tt("<!---->"),Me=Te.ownerDocument.importNode(Be,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Te=Me:Te.appendChild(Me);else{if(!ce&&!oe&&!J&&Be.indexOf("<")===-1)return v&&Fe?v.createHTML(Be):Be;if(Te=tt(Be),!Te)return ce?null:Fe?o:""}Te&&ie&&Ve(Te.firstChild);const at=st(F?Be:Te);for(;Ke=at.nextNode();)mt(Ke)||(Ke.content instanceof H&&Tt(Ke.content),St(Ke));if(F)return Be;if(ce){if(Ae)for(it=E.call(Te.ownerDocument);Te.firstChild;)it.appendChild(Te.firstChild);else it=Te;return(he.shadowroot||he.shadowrootmode)&&(it=M.call(i,it,!0)),it}let Xe=J?Te.outerHTML:Te.innerHTML;return J&&U["!doctype"]&&Te.ownerDocument&&Te.ownerDocument.doctype&&Te.ownerDocument.doctype.name&&ht(Qt,Te.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Te.ownerDocument.doctype.name+`>
`+Xe),oe&&(Xe=dt(Xe,B," "),Xe=dt(Xe,D," "),Xe=dt(Xe,x," ")),v&&Fe?v.createHTML(Xe):Xe},t.setConfig=function(Be){Ue(Be),G=!0},t.clearConfig=function(){Ye=null,G=!1},t.isValidAttribute=function(Be,ue,Te){Ye||Ue({});const Me=Le(Be),Ke=Le(ue);return gt(Me,Ke,Te)},t.addHook=function(Be,ue){typeof ue=="function"&&(j[Be]=j[Be]||[],wt(j[Be],ue))},t.removeHook=function(Be){if(j[Be])return zt(j[Be])},t.removeHooks=function(Be){j[Be]&&(j[Be]=[])},t.removeAllHooks=function(){j={}},t}var Ai=Yt();define("vs/base/browser/dompurify/dompurify",function(){return Ai}),define(me[45],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zS=void 0,t.$AS=z;class i{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const y=C(A);this.a!==y&&(this.a=y,this.domNode.style.maxWidth=this.a)}setWidth(A){const y=C(A);this.b!==y&&(this.b=y,this.domNode.style.width=this.b)}setHeight(A){const y=C(A);this.c!==y&&(this.c=y,this.domNode.style.height=this.c)}setTop(A){const y=C(A);this.d!==y&&(this.d=y,this.domNode.style.top=this.d)}setLeft(A){const y=C(A);this.e!==y&&(this.e=y,this.domNode.style.left=this.e)}setBottom(A){const y=C(A);this.f!==y&&(this.f=y,this.domNode.style.bottom=this.f)}setRight(A){const y=C(A);this.g!==y&&(this.g=y,this.domNode.style.right=this.g)}setPaddingTop(A){const y=C(A);this.h!==y&&(this.h=y,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const y=C(A);this.i!==y&&(this.i=y,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const y=C(A);this.j!==y&&(this.j=y,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const y=C(A);this.k!==y&&(this.k=y,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const y=C(A);this.n!==y&&(this.n=y,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const y=C(A);this.s!==y&&(this.s=y,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const y=C(A);this.t!==y&&(this.t=y,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,y){this.domNode.classList.toggle(A,y),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,y){this.domNode.setAttribute(A,y)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$zS=i;function C(H){return typeof H=="number"?`${H}px`:H}function z(H){return new i(H)}}),define(me[72],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=void 0,t.$SQ=H;const i=new WeakMap;function C(y){if(!y.parent||y.parent===y)return null;try{const b=y.location,$=y.parent.location;if(b.origin!=="null"&&$.origin!=="null"&&b.origin!==$.origin)return null}catch{return null}return y.parent}class z{static a(b){let $=i.get(b);if(!$){$=[],i.set(b,$);let w=b,P;do P=C(w),P?$.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):$.push({window:new WeakRef(w),iframeElement:null}),w=P;while(w)}return $.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,$){if(!$||b===$)return{top:0,left:0};let w=0,P=0;const c=this.a(b);for(const d of c){const e=d.window.deref();if(w+=e?.scrollY??0,P+=e?.scrollX??0,e===$||!d.iframeElement)break;const s=d.iframeElement.getBoundingClientRect();w+=s.top,P+=s.left}return{top:w,left:P}}}t.$RQ=z;async function H(y,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const $=JSON.stringify({parentOrigin:y,salt:b}),P=new TextEncoder().encode($),c=await crypto.subtle.digest("sha-256",P);return A(c)}function A(y){const $=Array.from(new Uint8Array(y)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${$}`).toString(32).padStart(52,"0")}}),define(me[73],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.$iT=t.$hT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var C;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(C||(t.ListDragOverEffectPosition=C={})),t.$hT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class z extends Error{constructor(y,b){super(`ListError [${y}] ${b}`)}}t.$iT=z;class H{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,b){b>0&&this.c.set(y,b)}}t.$jT=H}),define(me[74],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0S=void 0;class i{constructor(z){this.a=z}splice(z,H,A){this.a.forEach(y=>y.splice(z,H,A))}}t.$0S=i}),define(me[46],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FS=void 0;const i=20;class C{constructor(H,A,y,b,$,w){this.a=Math.round(A),this.b=Math.round(y),this.c=Math.round(H),this.d=b,this.e=$,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const A=Math.round(H);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(H){const A=Math.round(H);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(H){const A=Math.round(H);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,A,y,b,$){const w=Math.max(0,y-H),P=Math.max(0,w-2*A),c=b>0&&b>y;if(!c)return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(i,Math.floor(y*P/b))),e=(P-d)/(b-y),s=$*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(d),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=C.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const A=H-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const A=H-this.c;let y=this.f;return A<this.k?y-=this.d:y+=this.d,y}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const A=this.k+H;return Math.round(A/this.j)}}t.$FS=C}),define(me[27],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bV=t.$aV=t.$_U=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var C;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var z;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(z||(t.TreeMouseEventTarget=z={}));var H;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$_U={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class A extends Error{constructor($,w){super(`TreeError [${$}] ${w}`)}}t.$aV=A;class y{constructor($){this.a=$,this.b=new WeakMap}map($){let w=this.b.get($);return w||(w=this.a($),this.b.set($,w)),w}}t.$bV=y}),define(me[22],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$window=t.$uQ=void 0,t.$tQ=i,t.$wQ=C;function i(z,H){const A=z;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>H})}t.$uQ=window,t.$window=t.$uQ;function C(z){return z===t.$uQ?!1:typeof z?.vscodeWindowId=="number"}}),define(me[75],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=C,t.$hb=z,t.$ib=H,t.$jb=A,t.$kb=y,t.$lb=b,t.$nb=w,t.$ob=P,t.$pb=c,t.$qb=d,t.$rb=e;function i(s,a,m){const p=C(s,a);if(p!==-1)return s[p]}function C(s,a,m=s.length-1){for(let p=m;p>=0;p--){const v=s[p];if(a(v))return p}return-1}function z(s,a){const m=H(s,a);return m===-1?void 0:s[m]}function H(s,a,m=0,p=s.length){let v=m,o=p;for(;v<o;){const g=Math.floor((v+o)/2);a(s[g])?v=g+1:o=g}return v-1}function A(s,a){const m=y(s,a);return m===s.length?void 0:s[m]}function y(s,a,m=0,p=s.length){let v=m,o=p;for(;v<o;){const g=Math.floor((v+o)/2);a(s[g])?o=g:v=g+1}return v}function b(s,a,m=0,p=s.length){const v=y(s,a,m,p);return v===s.length?-1:v}class ${static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if($.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!a(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const m=H(this.e,a,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$mb=$;function w(s,a){if(s.length===0)return;let m=s[0];for(let p=1;p<s.length;p++){const v=s[p];a(v,m)>0&&(m=v)}return m}function P(s,a){if(s.length===0)return;let m=s[0];for(let p=1;p<s.length;p++){const v=s[p];a(v,m)>=0&&(m=v)}return m}function c(s,a){return w(s,(m,p)=>-a(m,p))}function d(s,a){if(s.length===0)return-1;let m=0;for(let p=1;p<s.length;p++){const v=s[p];a(v,s[m])>0&&(m=p)}return m}function e(s,a){for(const m of s){const p=a(m);if(p!==void 0)return p}}}),define(me[76],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=C,t.$M=z,t.$N=H;function i(A,y){const b=Object.create(null);for(const $ of A){const w=y($);let P=b[w];P||(P=b[w]=[]),P.push($)}return b}function C(A,y){const b=[],$=[];for(const w of A)y.has(w)||b.push(w);for(const w of y)A.has(w)||$.push(w);return{removed:b,added:$}}function z(A,y){const b=[],$=[];for(const[w,P]of A)y.has(w)||b.push(P);for(const[w,P]of y)A.has(w)||$.push(P);return{removed:b,added:$}}function H(A,y){const b=new Set;for(const $ of y)A.has($)&&b.add($);return b}}),define(me[77],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ct=t.$Bt=t.$At=t.$zt=void 0;function i(y,b){const $=Math.pow(10,b);return Math.round(y*$)/$}class C{constructor(b,$,w,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,$))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.r===$.r&&b.g===$.g&&b.b===$.b&&b.a===$.a}}t.$zt=C;class z{constructor(b,$,w,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=i(Math.max(Math.min(1,$),0),3),this.l=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.l===$.l&&b.a===$.a}static fromRGBA(b){const $=b.r/255,w=b.g/255,P=b.b/255,c=b.a,d=Math.max($,w,P),e=Math.min($,w,P);let s=0,a=0;const m=(e+d)/2,p=d-e;if(p>0){switch(a=Math.min(m<=.5?p/(2*m):p/(2-2*m),1),d){case $:s=(w-P)/p+(w<P?6:0);break;case w:s=(P-$)/p+2;break;case P:s=($-w)/p+4;break}s*=60,s=Math.round(s)}return new z(s,a,m,c)}static i(b,$,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?b+($-b)*6*w:w<1/2?$:w<2/3?b+($-b)*(2/3-w)*6:b}static toRGBA(b){const $=b.h/360,{s:w,l:P,a:c}=b;let d,e,s;if(w===0)d=e=s=P;else{const a=P<.5?P*(1+w):P+w-P*w,m=2*P-a;d=z.i(m,a,$+1/3),e=z.i(m,a,$),s=z.i(m,a,$-1/3)}return new C(Math.round(d*255),Math.round(e*255),Math.round(s*255),c)}}t.$At=z;class H{constructor(b,$,w,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=i(Math.max(Math.min(1,$),0),3),this.v=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.v===$.v&&b.a===$.a}static fromRGBA(b){const $=b.r/255,w=b.g/255,P=b.b/255,c=Math.max($,w,P),d=Math.min($,w,P),e=c-d,s=c===0?0:e/c;let a;return e===0?a=0:c===$?a=((w-P)/e%6+6)%6:c===w?a=(P-$)/e+2:a=($-w)/e+4,new H(Math.round(a*60),s,c,b.a)}static toRGBA(b){const{h:$,s:w,v:P,a:c}=b,d=P*w,e=d*(1-Math.abs($/60%2-1)),s=P-d;let[a,m,p]=[0,0,0];return $<60?(a=d,m=e):$<120?(a=e,m=d):$<180?(m=d,p=e):$<240?(m=e,p=d):$<300?(a=e,p=d):$<=360&&(a=d,p=e),a=Math.round((a+s)*255),m=Math.round((m+s)*255),p=Math.round((p+s)*255),new C(a,m,p,c)}}t.$Bt=H;class A{static fromHex(b){return A.Format.CSS.parseHex(b)||A.red}static equals(b,$){return!b&&!$?!0:!b||!$?!1:b.equals($)}get hsla(){return this.i?this.i:z.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof C)this.rgba=b;else if(b instanceof z)this.i=b,this.rgba=z.toRGBA(b);else if(b instanceof H)this.j=b,this.rgba=H.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&C.equals(this.rgba,b.rgba)&&z.equals(this.hsla,b.hsla)&&H.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=A.k(this.rgba.r),$=A.k(this.rgba.g),w=A.k(this.rgba.b),P=.2126*b+.7152*$+.0722*w;return i(P,4)}static k(b){const $=b/255;return $<=.03928?$/12.92:Math.pow(($+.055)/1.055,2.4)}getContrastRatio(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $>w?($+.05)/(w+.05):(w+.05)/($+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $>w}isDarkerThan(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $<w}lighten(b){return new A(new z(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new A(new z(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:$,g:w,b:P,a:c}=this.rgba;return new A(new C($,w,P,c*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const $=b.rgba,w=this.rgba.a,P=$.a,c=w+P*(1-w);if(c<1e-6)return A.transparent;const d=this.rgba.r*w/c+$.r*P*(1-w)/c,e=this.rgba.g*w/c+$.g*P*(1-w)/c,s=this.rgba.b*w/c+$.b*P*(1-w)/c;return new A(new C(d,e,s,c))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:$,g:w,b:P,a:c}=this.rgba;return new A(new C(b.rgba.r-c*(b.rgba.r-$),b.rgba.g-c*(b.rgba.g-w),b.rgba.b-c*(b.rgba.b-P),1))}flatten(...b){const $=b.reduceRight((w,P)=>A.o(P,w));return A.o(this,$)}static o(b,$){const w=1-b.rgba.a;return new A(new C(w*$.rgba.r+b.rgba.a*b.rgba.r,w*$.rgba.g+b.rgba.a*b.rgba.g,w*$.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(b,$,w){if(b.isLighterThan($))return b;w=w||.5;const P=b.getRelativeLuminance(),c=$.getRelativeLuminance();return w=w*(c-P)/c,b.lighten(w)}static getDarkerColor(b,$,w){if(b.isDarkerThan($))return b;w=w||.5;const P=b.getRelativeLuminance(),c=$.getRelativeLuminance();return w=w*(P-c)/P,b.darken(w)}static{this.white=new A(new C(255,255,255,1))}static{this.black=new A(new C(0,0,0,1))}static{this.red=new A(new C(255,0,0,1))}static{this.blue=new A(new C(0,0,255,1))}static{this.green=new A(new C(0,255,0,1))}static{this.cyan=new A(new C(0,255,255,1))}static{this.lightgrey=new A(new C(211,211,211,1))}static{this.transparent=new A(new C(0,0,0,0))}}t.$Ct=A,function(y){let b;(function($){let w;(function(P){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:y.Format.CSS.formatRGBA(r)}P.formatRGB=c;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}P.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(r)}P.formatHSL=e;function s(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}P.formatHSLA=s;function a(r){const E=r.toString(16);return E.length!==2?"0"+E:E}function m(r){return`#${a(r.rgba.r)}${a(r.rgba.g)}${a(r.rgba.b)}`}P.formatHex=m;function p(r,E=!1){return E&&r.rgba.a===1?y.Format.CSS.formatHex(r):`#${a(r.rgba.r)}${a(r.rgba.g)}${a(r.rgba.b)}${a(Math.round(r.rgba.a*255))}`}P.formatHexA=p;function v(r){return r.isOpaque()?y.Format.CSS.formatHex(r):y.Format.CSS.formatRGBA(r)}P.format=v;function o(r){const E=r.length;if(E===0||r.charCodeAt(0)!==35)return null;if(E===7){const R=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),M=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),j=16*g(r.charCodeAt(5))+g(r.charCodeAt(6));return new y(new C(R,M,j,1))}if(E===9){const R=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),M=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),j=16*g(r.charCodeAt(5))+g(r.charCodeAt(6)),B=16*g(r.charCodeAt(7))+g(r.charCodeAt(8));return new y(new C(R,M,j,B/255))}if(E===4){const R=g(r.charCodeAt(1)),M=g(r.charCodeAt(2)),j=g(r.charCodeAt(3));return new y(new C(16*R+R,16*M+M,16*j+j))}if(E===5){const R=g(r.charCodeAt(1)),M=g(r.charCodeAt(2)),j=g(r.charCodeAt(3)),B=g(r.charCodeAt(4));return new y(new C(16*R+R,16*M+M,16*j+j,(16*B+B)/255))}return null}P.parseHex=o;function g(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=$.CSS||($.CSS={}))})(b=y.Format||(y.Format={}))}(A||(t.$Ct=A={}))}),define(me[28],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kh=C,t.$Lh=z,t.$Mh=H;function i(A){return(y,b,$)=>{let w=null,P=null;if(typeof $.value=="function"?(w="value",P=$.value):typeof $.get=="function"&&(w="get",P=$.get),!P)throw new Error("not supported");$[w]=A(P,b)}}function C(A,y,b){let $=null,w=null;if(typeof b.value=="function"?($="value",w=b.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",w=b.get),!w)throw new Error("not supported");const P=`$memoize$${y}`;b[$]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,c)}),this[P]}}function z(A,y,b){return i(($,w)=>{const P=`$debounce$${w}`,c=`$debounce$result$${w}`;return function(...d){this[c]||(this[c]=b?b():void 0),clearTimeout(this[P]),y&&(this[c]=y(this[c],...d),d=[this[c]]),this[P]=setTimeout(()=>{$.apply(this,d),this[c]=b?b():void 0},A)}})}function H(A,y,b){return i(($,w)=>{const P=`$throttle$timer$${w}`,c=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...s){if(this[c]||(this[c]=b?b():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[c]=y(this[c],...s)),this[e])return;const a=this[d]+A;a<=Date.now()?(this[d]=Date.now(),$.apply(this,[this[c]]),this[c]=b?b():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[d]=Date.now(),$.apply(this,[this[c]]),this[c]=b?b():void 0},a-Date.now()))}})}}),define(me[78],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=void 0;class i{constructor(z,H,A,y){this.originalStart=z,this.originalLength=H,this.modifiedStart=A,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$bt=i}),define(me[6],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=C,t.$Z=z,t.$1=H,t.$2=A,t.$3=y,t.$4=$,t.$6=P,t.$7=c,t.$8=d,t.$0=s;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(E=>{E(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function C(g){t.$X.setUnexpectedErrorHandler(g)}function z(g){if(!g||typeof g!="object")return!1;const r=g;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function H(g){$(g)||t.$X.onUnexpectedError(g)}function A(g){$(g)||t.$X.onUnexpectedExternalError(g)}function y(g){if(g instanceof Error){const{name:r,message:E}=g,R=g.stacktrace||g.stack;return{$isError:!0,name:r,message:E,stack:R,noTelemetry:v.isErrorNoTelemetry(g)}}return g}const b="Canceled";function $(g){return g instanceof w?!0:g instanceof Error&&g.name===b&&g.message===b}class w extends Error{constructor(){super(b),this.name=this.message}}t.$5=w;function P(){const g=new Error(b);return g.name=g.message,g}function c(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}function d(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}class a extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=a;class m extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=p;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const E=new v;return E.message=r.message,E.stack=r.stack,E}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=v;class o extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),define(me[12],be([1,0,6,75]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=z,t.$tb=H,t.$ub=A,t.$vb=y,t.$wb=b,t.$xb=$,t.$yb=w,t.$zb=P,t.$Ab=c,t.$Bb=d,t.$Cb=e,t.$Db=s,t.$Eb=a,t.top=m,t.$Gb=p,t.$Hb=o,t.$Ib=g,t.$Jb=r,t.$Kb=E,t.$Lb=R,t.$Mb=M,t.$Nb=j,t.$Ob=B,t.$Pb=D,t.$Qb=x,t.$Rb=W,t.$Sb=T,t.$Tb=L,t.$Ub=I,t.$Vb=X,t.$Wb=U,t.$Xb=de,t.$Yb=he,t.$Zb=ne,t.$1b=ge,t.$2b=Ne,t.$3b=Ce,t.$4b=Pe,t.$5b=le,t.$6b=_,t.$7b=J,t.$8b=G,t.$$b=Ae;function z(K,f=0){return K[K.length-(1+f)]}function H(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function A(K,f,k=(F,l)=>F===l){if(K===f)return!0;if(!K||!f||K.length!==f.length)return!1;for(let F=0,l=K.length;F<l;F++)if(!k(K[F],f[F]))return!1;return!0}function y(K,f){const k=K.length-1;f<k&&(K[f]=K[k]),K.pop()}function b(K,f,k){return $(K.length,F=>k(K[F],f))}function $(K,f){let k=0,F=K-1;for(;k<=F;){const l=(k+F)/2|0,u=f(l);if(u<0)k=l+1;else if(u>0)F=l-1;else return l}return-(k+1)}function w(K,f,k){if(K=K|0,K>=f.length)throw new TypeError("invalid index");const F=f[Math.floor(f.length*Math.random())],l=[],u=[],n=[];for(const h of f){const N=k(h,F);N<0?l.push(h):N>0?u.push(h):n.push(h)}return K<l.length?w(K,l,k):K<l.length+n.length?n[0]:w(K-(l.length+n.length),u,k)}function P(K,f){const k=[];let F;for(const l of K.slice(0).sort(f))!F||f(F[0],l)!==0?(F=[l],k.push(F)):F.push(l);return k}function*c(K,f){let k,F;for(const l of K)F!==void 0&&f(F,l)?k.push(l):(k&&(yield k),k=[l]),F=l;k&&(yield k)}function d(K,f){for(let k=0;k<=K.length;k++)f(k===0?void 0:K[k-1],k===K.length?void 0:K[k])}function e(K,f){for(let k=0;k<K.length;k++)f(k===0?void 0:K[k-1],K[k],k+1===K.length?void 0:K[k+1])}function s(K,f,k){const F=[];function l(h,N,S){if(N===0&&S.length===0)return;const O=F[F.length-1];O&&O.start+O.deleteCount===h?(O.deleteCount+=N,O.toInsert.push(...S)):F.push({start:h,deleteCount:N,toInsert:S})}let u=0,n=0;for(;;){if(u===K.length){l(u,0,f.slice(n));break}if(n===f.length){l(u,K.length-u,[]);break}const h=K[u],N=f[n],S=k(h,N);S===0?(u+=1,n+=1):S<0?(l(u,1,[]),u+=1):S>0&&(l(u,0,[N]),n+=1)}return F}function a(K,f,k){const F=s(K,f,k),l=[],u=[];for(const n of F)l.push(...K.slice(n.start,n.start+n.deleteCount)),u.push(...n.toInsert);return{removed:l,added:u}}function m(K,f,k){if(k===0)return[];const F=K.slice(0,k).sort(f);return v(K,f,F,k,K.length),F}function p(K,f,k,F,l){return k===0?Promise.resolve([]):new Promise((u,n)=>{(async()=>{const h=K.length,N=K.slice(0,k).sort(f);for(let S=k,O=Math.min(k+F,h);S<h;S=O,O=Math.min(O+F,h)){if(S>k&&await new Promise(V=>setTimeout(V)),l&&l.isCancellationRequested)throw new i.$5;v(K,f,N,S,O)}return N})().then(u,n)})}function v(K,f,k,F,l){for(const u=k.length;F<l;F++){const n=K[F];if(f(n,k[u-1])<0){k.pop();const h=(0,C.$kb)(k,N=>f(n,N)<0);k.splice(h,0,n)}}}function o(K){return K.filter(f=>!!f)}function g(K){let f=0;for(let k=0;k<K.length;k++)K[k]&&(K[f]=K[k],f+=1);K.length=f}function r(K,f,k){K.splice(k,0,K.splice(f,1)[0])}function E(K){return!Array.isArray(K)||K.length===0}function R(K){return Array.isArray(K)&&K.length>0}function M(K,f=k=>k){const k=new Set;return K.filter(F=>{const l=f(F);return k.has(l)?!1:(k.add(l),!0)})}function j(K){const f=new Set;return k=>{const F=K(k);return f.has(F)?!1:(f.add(F),!0)}}function B(K,f){return K.length>0?K[0]:f}function D(K,f){return K.length>0?K[K.length-1]:f}function x(K,f,k=(F,l)=>F===l){let F=0;for(let l=0,u=Math.min(K.length,f.length);l<u&&k(K[l],f[l]);l++)F++;return F}function W(K){return[].concat(...K)}function T(K,f){let k=typeof f=="number"?K:0;typeof f=="number"?k=K:(k=0,f=K);const F=[];if(k<=f)for(let l=k;l<f;l++)F.push(l);else for(let l=k;l>f;l--)F.push(l);return F}function L(K,f,k){return K.reduce((F,l)=>(F[f(l)]=k?k(l):l,F),Object.create(null))}function I(K,f){return K.push(f),()=>X(K,f)}function X(K,f){const k=K.indexOf(f);if(k>-1)return K.splice(k,1),f}function U(K,f,k){const F=K.slice(0,f),l=K.slice(f);return F.concat(k,l)}function de(K,f){let k;if(typeof f=="number"){let F=f;k=()=>{const l=Math.sin(F++)*179426549;return l-Math.floor(l)}}else k=Math.random;for(let F=K.length-1;F>0;F-=1){const l=Math.floor(k()*(F+1)),u=K[F];K[F]=K[l],K[l]=u}}function he(K,f){const k=K.indexOf(f);k>-1&&(K.splice(k,1),K.unshift(f))}function ne(K,f){const k=K.indexOf(f);k>-1&&(K.splice(k,1),K.push(f))}function ge(K,f){for(const k of f)K.push(k)}function Ne(K,f){return Array.isArray(K)?K.map(f):f(K)}function Ce(K){return Array.isArray(K)?K:[K]}function Pe(K){return K[Math.floor(Math.random()*K.length)]}function le(K,f,k){const F=ae(K,f),l=K.length,u=k.length;K.length=l+u;for(let n=l-1;n>=F;n--)K[n+u]=K[n];for(let n=0;n<u;n++)K[n+F]=k[n]}function _(K,f,k,F){const l=ae(K,f);let u=K.splice(l,k);return u===void 0&&(u=[]),le(K,l,F),u}function ae(K,f){return f<0?Math.max(f+K.length,0):Math.min(f,K.length)}var oe;(function(K){function f(u){return u<0}K.isLessThan=f;function k(u){return u<=0}K.isLessThanOrEqual=k;function F(u){return u>0}K.isGreaterThan=F;function l(u){return u===0}K.isNeitherLessOrGreaterThan=l,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(oe||(t.CompareResult=oe={}));function J(K,f){return(k,F)=>f(K(k),K(F))}function G(...K){return(f,k)=>{for(const F of K){const l=F(f,k);if(!oe.isNeitherLessOrGreaterThan(l))return l}return oe.neitherLessOrGreaterThan}}const ie=(K,f)=>K-f;t.$9b=ie;const ce=(K,f)=>(0,t.$9b)(K?1:0,f?1:0);t.$0b=ce;function Ae(K){return(f,k)=>-K(f,k)}class Fe{constructor(f){this.g=f,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(f){let k=this.c;for(;k<this.g.length&&f(this.g[k]);)k++;const F=k===this.c?null:this.g.slice(this.c,k);return this.c=k,F}takeFromEndWhile(f){let k=this.d;for(;k>=0&&f(this.g[k]);)k--;const F=k===this.d?null:this.g.slice(k+1,this.d+1);return this.d=k,F}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const f=this.g[this.c];return this.c++,f}removeLast(){const f=this.g[this.d];return this.d--,f}takeCount(f){const k=this.g.slice(this.c,this.c+f);return this.c+=f,k}}t.$_b=Fe;class ye{static{this.empty=new ye(f=>{})}constructor(f){this.iterate=f}forEach(f){this.iterate(k=>(f(k),!0))}toArray(){const f=[];return this.iterate(k=>(f.push(k),!0)),f}filter(f){return new ye(k=>this.iterate(F=>f(F)?k(F):!0))}map(f){return new ye(k=>this.iterate(F=>k(f(F))))}some(f){let k=!1;return this.iterate(F=>(k=f(F),!k)),k}findFirst(f){let k;return this.iterate(F=>f(F)?(k=F,!1):!0),k}findLast(f){let k;return this.iterate(F=>(f(F)&&(k=F),!0)),k}findLastMaxBy(f){let k,F=!0;return this.iterate(l=>((F||oe.isGreaterThan(f(l,k)))&&(F=!1,k=l),!0)),k}}t.$ac=ye}),define(me[79],be([1,0,6]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=C,t.$9c=z,t.$0c=H,t.$$c=A,t.$_c=y,t.$ad=b;function C($,w){if(!$)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function z($,w="Unreachable"){throw new Error(w)}function H($){if(!$)throw new i.$cb("Assertion Failed")}function A($){$||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function y($){if(!$()){debugger;$(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function b($,w){let P=0;for(;P<$.length-1;){const c=$[P],d=$[P+1];if(!w(c,d))return!1;P++}return!0}}),define(me[47],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(C,z){const H=this;let A=!1,y;return function(){if(A)return y;if(A=!0,z)try{y=C.apply(H,arguments)}finally{z()}else y=C.apply(H,arguments);return y}}}),define(me[80],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DO=t.$CO=void 0;class i{constructor(z){this.a=z,this.b=0}nextId(){return this.a+ ++this.b}}t.$CO=i,t.$DO=new i("id#")}),define(me[29],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(C){function z(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}C.is=z;const H=Object.freeze([]);function A(){return H}C.empty=A;function*y(r){yield r}C.single=y;function b(r){return z(r)?r:y(r)}C.wrap=b;function $(r){return r||H}C.from=$;function*w(r){for(let E=r.length-1;E>=0;E--)yield r[E]}C.reverse=w;function P(r){return!r||r[Symbol.iterator]().next().done===!0}C.isEmpty=P;function c(r){return r[Symbol.iterator]().next().value}C.first=c;function d(r,E){for(const R of r)if(E(R))return!0;return!1}C.some=d;function e(r,E){for(const R of r)if(E(R))return R}C.find=e;function*s(r,E){for(const R of r)E(R)&&(yield R)}C.filter=s;function*a(r,E){let R=0;for(const M of r)yield E(M,R++)}C.map=a;function*m(...r){for(const E of r)yield*E}C.concat=m;function p(r,E,R){let M=R;for(const j of r)M=E(M,j);return M}C.reduce=p;function*v(r,E,R=r.length){for(E<0&&(E+=r.length),R<0?R+=r.length:R>r.length&&(R=r.length);E<R;E++)yield r[E]}C.slice=v;function o(r,E=Number.POSITIVE_INFINITY){const R=[];if(E===0)return[R,r];const M=r[Symbol.iterator]();for(let j=0;j<E;j++){const B=M.next();if(B.done)return[R,C.empty()];R.push(B.value)}return[R,{[Symbol.iterator](){return M}}]}C.consume=o;async function g(r){const E=[];for await(const R of r)E.push(R);return Promise.resolve(E)}C.asyncToArray=g})(i||(t.Iterable=i={}))}),define(me[48],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$jr=t.$ir=t.$hr=t.$gr=t.$fr=t.ScanCode=t.KeyCode=void 0,t.$kr=d;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class z{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,a){this._keyCodeToStr[s]=a,this._strToKeyCode[a.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new z,A=new z,y=new z;t.$fr=new Array(230),t.$gr={};const b=[],$=Object.create(null),w=Object.create(null);t.$hr={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>$[e]||0,toString:e=>b[e]||"None"},t.$ir=[],t.$jr=[];for(let e=0;e<=193;e++)t.$ir[e]=-1;for(let e=0;e<=132;e++)t.$jr[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],a=[],m=[];for(const p of s){const[v,o,g,r,E,R,M,j,B]=p;if(m[o]||(m[o]=!0,b[o]=g,$[g]=o,w[g.toLowerCase()]=o,v&&(t.$ir[o]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$jr[r]=o))),!a[r]){if(a[r]=!0,!E)throw new Error(`String representation missing for key code ${r} around scan code ${g}`);H.define(r,E),A.define(r,j||E),y.define(r,B||j||E)}R&&(t.$fr[R]=r),M&&(t.$gr[M]=r)}t.$jr[3]=46})();var P;(function(e){function s(g){return H.keyCodeToStr(g)}e.toString=s;function a(g){return H.strToKeyCode(g)}e.fromString=a;function m(g){return A.keyCodeToStr(g)}e.toUserSettingsUS=m;function p(g){return y.keyCodeToStr(g)}e.toUserSettingsGeneral=p;function v(g){return A.strToKeyCode(g)||y.strToKeyCode(g)}e.fromUserSettings=v;function o(g){if(g>=98&&g<=113)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(g)}e.toElectronAccelerator=o})(P||(t.KeyCodeUtils=P={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function d(e,s){const a=(s&65535)<<16>>>0;return(e|a)>>>0}}),define(me[81],be([1,0,6]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rr=t.$qr=t.$pr=t.$or=t.$nr=void 0,t.$lr=z,t.$mr=H;var C;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(C||(C={}));function z(P,c){if(typeof P=="number"){if(P===0)return null;const d=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new b([H(d,c),H(e,c)]):new b([H(d,c)])}else{const d=[];for(let e=0;e<P.length;e++)d.push(H(P[e],c));return new b(d)}}function H(P,c){const d=!!(P&2048),e=!!(P&256),s=c===2?e:d,a=!!(P&1024),m=!!(P&512),p=c===2?d:e,v=P&255;return new A(s,a,m,p,v)}class A{constructor(c,d,e,s,a){this.ctrlKey=c,this.shiftKey=d,this.altKey=e,this.metaKey=s,this.keyCode=a}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${c}${d}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$nr=A;class y{constructor(c,d,e,s,a){this.ctrlKey=c,this.shiftKey=d,this.altKey=e,this.metaKey=s,this.scanCode=a}equals(c){return c instanceof y&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${c}${d}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$or=y;class b{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let d=0,e=this.chords.length;d<e;d++)d!==0&&(c+=";"),c+=this.chords[d].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let d=0;d<this.chords.length;d++)if(!this.chords[d].equals(c.chords[d]))return!1;return!0}}t.$pr=b;class ${constructor(c,d,e,s,a,m){this.ctrlKey=c,this.shiftKey=d,this.altKey=e,this.metaKey=s,this.keyLabel=a,this.keyAriaLabel=m}}t.$qr=$;class w{}t.$rr=w}),define(me[23],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(z){this.d=z,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(z){this.c=z}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(me[14],be([1,0,23]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=y,t.$VS=b,t.$WS=$;let z=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const H=new i.$V(()=>z("mouse",!1)),A=new i.$V(()=>z("element",!1));function y(w){z=w}function b(w){return w==="element"?A.value:H.value}function $(){return z("element",!0)}}),define(me[49],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(H){this.element=H,this.next=i.Undefined,this.prev=i.Undefined}}class C{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let H=this.a;for(;H!==i.Undefined;){const A=H.next;H.prev=i.Undefined,H.next=i.Undefined,H=A}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,A){const y=new i(H);if(this.a===i.Undefined)this.a=y,this.b=y;else if(A){const $=this.b;this.b=y,y.prev=$,$.next=y}else{const $=this.a;this.a=y,y.next=$,$.prev=y}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(y))}}shift(){if(this.a!==i.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==i.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==i.Undefined&&H.next!==i.Undefined){const A=H.prev;A.next=H.next,H.next.prev=A}else H.prev===i.Undefined&&H.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):H.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):H.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==i.Undefined;)yield H.element,H=H.next}}t.$4c=C}),define(me[34],be([1,0]),function(re,t){"use strict";var i,C,z;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=void 0,t.$xc=H,t.$yc=A,t.$zc=y,t.$Hc=p;function H(v,o,g){let r=v.get(o);return r===void 0&&(r=g,v.set(o,r)),r}function A(v){const o=[];return v.forEach((g,r)=>{o.push(`${r} => ${g}`)}),`Map(${v.size}) {${o.join(", ")}}`}function y(v){const o=[];return v.forEach(g=>{o.push(g)}),`Set(${v.size}) {${o.join(", ")}}`}class b{constructor(o,g){this.uri=o,this.value=g}}function $(v){return Array.isArray(v)}class w{static{this.c=o=>o.toString()}constructor(o,g){if(this[i]="ResourceMap",o instanceof w)this.d=new Map(o.d),this.e=g??w.c;else if($(o)){this.d=new Map,this.e=g??w.c;for(const[r,E]of o)this.set(r,E)}else this.d=new Map,this.e=o??w.c}set(o,g){return this.d.set(this.e(o),new b(o,g)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[r,E]of this.d)o(E.value,E.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Ac=w;class P{constructor(o,g){this[C]="ResourceSet",!o||typeof o=="function"?this.c=new w(o):(this.c=new w(g),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,g){this.c.forEach((r,E)=>o.call(g,E,E,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=P;var c;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class d{constructor(){this[z]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,g=0){const r=this.c.get(o);if(r)return g!==0&&this.l(r,g),r.value}set(o,g,r=0){let E=this.c.get(o);if(E)E.value=g,r!==0&&this.l(E,r);else{switch(E={key:o,value:g,next:void 0,previous:void 0},r){case 0:this.j(E);break;case 1:this.i(E);break;case 2:this.j(E);break;default:this.j(E);break}this.c.set(o,E),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.c.get(o);if(g)return this.c.delete(o),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,g){const r=this.g;let E=this.d;for(;E;){if(g?o.bind(g)(E.value,E.key,this):o(E.value,E.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const o=this,g=this.g;let r=this.d;const E={[Symbol.iterator](){return E},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const R={value:r.key,done:!1};return r=r.next,R}else return{value:void 0,done:!0}}};return E}values(){const o=this,g=this.g;let r=this.d;const E={[Symbol.iterator](){return E},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const R={value:r.value,done:!1};return r=r.next,R}else return{value:void 0,done:!0}}};return E}entries(){const o=this,g=this.g;let r=this.d;const E={[Symbol.iterator](){return E},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const R={value:[r.key,r.value],done:!1};return r=r.next,R}else return{value:void 0,done:!0}}};return E}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.d,r=this.size;for(;g&&r>o;)this.c.delete(g.key),g=g.next,r--;this.d=g,this.f=r,g&&(g.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const g=o.next,r=o.previous;if(!g||!r)throw new Error("Invalid list");g.previous=r,r.next=g}o.next=void 0,o.previous=void 0,this.g++}l(o,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.d)return;const r=o.next,E=o.previous;o===this.e?(E.next=void 0,this.e=E):(r.previous=E,E.next=r),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(g===2){if(o===this.e)return;const r=o.next,E=o.previous;o===this.d?(r.previous=void 0,this.d=r):(r.previous=E,E.next=r),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((g,r)=>{o.push([r,g])}),o}fromJSON(o){this.clear();for(const[g,r]of o)this.set(g,r)}}t.$Cc=d;class e extends d{constructor(o,g=1){super(),this.m=o,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class s{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let g=this.c.get(o)||0;return g===0?!1:(g--,g===0?this.c.delete(o):this.c.set(o,g),!0)}has(o){return this.c.has(o)}}t.$Ec=s;class a{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[g,r]of o)this.set(g,r)}clear(){this.c.clear(),this.d.clear()}set(o,g){this.c.set(o,g),this.d.set(g,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const g=this.c.get(o);return g===void 0?!1:(this.c.delete(o),this.d.delete(g),!0)}forEach(o,g){this.c.forEach((r,E)=>{o.call(g,r,E,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=a;class m{constructor(){this.c=new Map}add(o,g){let r=this.c.get(o);r||(r=new Set,this.c.set(o,r)),r.add(g)}delete(o,g){const r=this.c.get(o);r&&(r.delete(g),r.size===0&&this.c.delete(o))}forEach(o,g){const r=this.c.get(o);r&&r.forEach(g)}get(o){const g=this.c.get(o);return g||new Set}}t.$Gc=m;function p(v,o){if(v===o)return!0;if(v.size!==o.size)return!1;for(const[g,r]of v)if(!o.has(g)||o.get(g)!==r)return!1;for(const[g]of o)if(!v.has(g))return!1;return!0}}),define(me[3],be([1,0,12,76,34,47,29]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Ic=void 0,t.$Jc=w,t.$Kc=P,t.$Lc=c,t.$Mc=s,t.$Nc=a,t.$Oc=m,t.$Pc=p,t.$Qc=v,t.$Rc=o,t.$2c=W;const y=!1;let b=null;class ${constructor(){this.b=new Map}static{this.a=0}c(I){let X=this.b.get(I);return X||(X={parent:null,source:null,isSingleton:!1,value:I,idx:$.a++},this.b.set(I,X)),X}trackDisposable(I){const X=this.c(I);X.source||(X.source=new Error().stack)}setParent(I,X){const U=this.c(I);U.parent=X}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,X){const U=X.get(I);if(U)return U;const de=I.parent?this.f(this.c(I.parent),X):I;return X.set(I,de),de}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,X){let U;if(X)U=X;else{const Ne=new Map,Ce=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Ne).isSingleton);if(Ce.length===0)return;const Pe=new Set(Ce.map(le=>le.value));if(U=Ce.filter(le=>!(le.parent&&Pe.has(le.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function de(Ne){function Ce(le,_){for(;le.length>0&&_.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Pe=Ne.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ce(Pe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Pe.reverse()}const he=new z.$Gc;for(const Ne of U){const Ce=de(Ne);for(let Pe=0;Pe<=Ce.length;Pe++)he.add(Ce.slice(0,Pe).join(`
`),Ne)}U.sort((0,i.$7b)(Ne=>Ne.idx,i.$9b));let ne="",ge=0;for(const Ne of U.slice(0,I)){ge++;const Ce=de(Ne),Pe=[];for(let le=0;le<Ce.length;le++){let _=Ce[le];_=`(shared with ${he.get(Ce.slice(0,le+1).join(`
`)).size}/${U.length} leaks) at ${_}`;const oe=he.get(Ce.slice(0,le).join(`
`)),J=(0,C.$K)([...oe].map(G=>de(G)[le]),G=>G);delete J[Ce[le]];for(const[G,ie]of Object.entries(J))Pe.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${G}`);Pe.unshift(_)}ne+=`


==================== Leaking disposable ${ge}/${U.length}: ${Ne.value.constructor.name} ====================
${Pe.join(`
`)}
============================================================

`}return U.length>I&&(ne+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:ne}}}t.$Ic=$;function w(L){b=L}if(y){const L="__is_disposable_tracked__";w(new class{trackDisposable(I){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[L]||console.log(X)},3e3)}setParent(I,X){if(I&&I!==r.None)try{I[L]=!0}catch{}}markAsDisposed(I){if(I&&I!==r.None)try{I[L]=!0}catch{}}markAsSingleton(I){}})}function P(L){return b?.trackDisposable(L),L}function c(L){b?.markAsDisposed(L)}function d(L,I){b?.setParent(L,I)}function e(L,I){if(b)for(const X of L)b.setParent(X,I)}function s(L){return b?.markAsSingleton(L),L}function a(L){return typeof L.dispose=="function"&&L.dispose.length===0}function m(L){if(A.Iterable.is(L)){const I=[];for(const X of L)if(X)try{X.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function p(L){for(const I of L)a(I)&&I.dispose();return[]}function v(...L){const I=o(()=>m(L));return e(L,I),I}function o(L){const I=P({dispose:(0,H.$db)(()=>{c(I),L()})});return I}class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}t.$Sc=g;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,P(this),d(this.q,this)}dispose(){c(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}t.$Tc=r;class E{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}t.$Uc=E;class R{constructor(I){this.a=new E,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=R;class M{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=M;class j{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(I){let X=I;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,c(this))},this}}t.$Xc=j;class B{constructor(){this.a=new Map}acquire(I,...X){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...X)},this.a.set(I,U));const{object:de}=U,he=(0,H.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:de,dispose:he}}}t.$Yc=B;class D{constructor(I){this.a=I}async acquire(I,...X){const U=this.a.acquire(I,...X);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(de){throw U.dispose(),de}}}t.$Zc=D;class x{constructor(I){this.object=I}dispose(){}}t.$1c=x;function W(L){const I=new g;try{L(I)}finally{I.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,X,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,X)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=T}),function(re,t){typeof define=="function"&&define.amd?define(me[82],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(re=typeof globalThis<"u"?globalThis:re||self,t(re.marked={}))}(this,function(re){"use strict";function t(f,k){for(var F=0;F<k.length;F++){var l=k[F];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(f,l.key,l)}}function i(f,k,F){return k&&t(f.prototype,k),F&&t(f,F),Object.defineProperty(f,"prototype",{writable:!1}),f}function C(f,k){if(f){if(typeof f=="string")return z(f,k);var F=Object.prototype.toString.call(f).slice(8,-1);if(F==="Object"&&f.constructor&&(F=f.constructor.name),F==="Map"||F==="Set")return Array.from(f);if(F==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(F))return z(f,k)}}function z(f,k){(k==null||k>f.length)&&(k=f.length);for(var F=0,l=new Array(k);F<k;F++)l[F]=f[F];return l}function H(f,k){var F=typeof Symbol<"u"&&f[Symbol.iterator]||f["@@iterator"];if(F)return(F=F.call(f)).next.bind(F);if(Array.isArray(f)||(F=C(f))||k&&f&&typeof f.length=="number"){F&&(f=F);var l=0;return function(){return l>=f.length?{done:!0}:{done:!1,value:f[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=A();function y(f){re.defaults=f}var b=/[&<>"']/,$=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(k){return c[k]};function e(f,k){if(k){if(b.test(f))return f.replace($,d)}else if(w.test(f))return f.replace(P,d);return f}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(f){return f.replace(s,function(k,F){return F=F.toLowerCase(),F==="colon"?":":F.charAt(0)==="#"?F.charAt(1)==="x"?String.fromCharCode(parseInt(F.substring(2),16)):String.fromCharCode(+F.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(f,k){f=typeof f=="string"?f:f.source,k=k||"";var F={replace:function(u,n){return n=n.source||n,n=n.replace(m,"$1"),f=f.replace(u,n),F},getRegex:function(){return new RegExp(f,k)}};return F}var v=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(f,k,F){if(f){var l;try{l=decodeURIComponent(a(F)).replace(v,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}k&&!o.test(F)&&(F=j(k,F));try{F=encodeURI(F).replace(/%25/g,"%")}catch{return null}return F}var r={},E=/^[^:]+:\/*[^/]*$/,R=/^([^:]+:)[\s\S]*$/,M=/^([^:]+:\/*[^/]*)[\s\S]*$/;function j(f,k){r[" "+f]||(E.test(f)?r[" "+f]=f+"/":r[" "+f]=W(f,"/",!0)),f=r[" "+f];var F=f.indexOf(":")===-1;return k.substring(0,2)==="//"?F?k:f.replace(R,"$1")+k:k.charAt(0)==="/"?F?k:f.replace(M,"$1")+k:f+k}var B={exec:function(){}};function D(f){for(var k=1,F,l;k<arguments.length;k++){F=arguments[k];for(l in F)Object.prototype.hasOwnProperty.call(F,l)&&(f[l]=F[l])}return f}function x(f,k){var F=f.replace(/\|/g,function(n,h,N){for(var S=!1,O=h;--O>=0&&N[O]==="\\";)S=!S;return S?"|":" |"}),l=F.split(/ \|/),u=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>k)l.splice(k);else for(;l.length<k;)l.push("");for(;u<l.length;u++)l[u]=l[u].trim().replace(/\\\|/g,"|");return l}function W(f,k,F){var l=f.length;if(l===0)return"";for(var u=0;u<l;){var n=f.charAt(l-u-1);if(n===k&&!F)u++;else if(n!==k&&F)u++;else break}return f.slice(0,l-u)}function T(f,k){if(f.indexOf(k[1])===-1)return-1;for(var F=f.length,l=0,u=0;u<F;u++)if(f[u]==="\\")u++;else if(f[u]===k[0])l++;else if(f[u]===k[1]&&(l--,l<0))return u;return-1}function L(f){f&&f.sanitize&&!f.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(f,k){if(k<1)return"";for(var F="";k>1;)k&1&&(F+=f),k>>=1,f+=f;return F+f}function X(f,k,F,l){var u=k.href,n=k.title?e(k.title):null,h=f[1].replace(/\\([\[\]])/g,"$1");if(f[0].charAt(0)!=="!"){l.state.inLink=!0;var N={type:"link",raw:F,href:u,title:n,text:h,tokens:l.inlineTokens(h)};return l.state.inLink=!1,N}return{type:"image",raw:F,href:u,title:n,text:e(h)}}function U(f,k){var F=f.match(/^(\s+)(?:```)/);if(F===null)return k;var l=F[1];return k.split(`
`).map(function(u){var n=u.match(/^\s+/);if(n===null)return u;var h=n[0];return h.length>=l.length?u.slice(l.length):u}).join(`
`)}var de=function(){function f(F){this.options=F||re.defaults}var k=f.prototype;return k.space=function(l){var u=this.rules.block.newline.exec(l);if(u&&u[0].length>0)return{type:"space",raw:u[0]}},k.code=function(l){var u=this.rules.block.code.exec(l);if(u){var n=u[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:u[0],codeBlockStyle:"indented",text:this.options.pedantic?n:W(n,`
`)}}},k.fences=function(l){var u=this.rules.block.fences.exec(l);if(u){var n=u[0],h=U(n,u[3]||"");return{type:"code",raw:n,lang:u[2]?u[2].trim():u[2],text:h}}},k.heading=function(l){var u=this.rules.block.heading.exec(l);if(u){var n=u[2].trim();if(/#$/.test(n)){var h=W(n,"#");(this.options.pedantic||!h||/ $/.test(h))&&(n=h.trim())}return{type:"heading",raw:u[0],depth:u[1].length,text:n,tokens:this.lexer.inline(n)}}},k.hr=function(l){var u=this.rules.block.hr.exec(l);if(u)return{type:"hr",raw:u[0]}},k.blockquote=function(l){var u=this.rules.block.blockquote.exec(l);if(u){var n=u[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:u[0],tokens:this.lexer.blockTokens(n,[]),text:n}}},k.list=function(l){var u=this.rules.block.list.exec(l);if(u){var n,h,N,S,O,V,Z,ee,$e,ve,we,je,Se=u[1].trim(),Ee=Se.length>1,Re={type:"list",raw:"",ordered:Ee,start:Ee?+Se.slice(0,-1):"",loose:!1,items:[]};Se=Ee?"\\d{1,9}\\"+Se.slice(-1):"\\"+Se,this.options.pedantic&&(Se=Ee?Se:"[*+-]");for(var Le=new RegExp("^( {0,3}"+Se+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(je=!1,!(!(u=Le.exec(l))||this.rules.block.hr.test(l)));){if(n=u[0],l=l.substring(n.length),ee=u[2].split(`
`,1)[0],$e=l.split(`
`,1)[0],this.options.pedantic?(S=2,we=ee.trimLeft()):(S=u[2].search(/[^ ]/),S=S>4?1:S,we=ee.slice(S),S+=u[1].length),V=!1,!ee&&/^ *$/.test($e)&&(n+=$e+`
`,l=l.substring($e.length+1),je=!0),!je)for(var Ye=new RegExp("^ {0,"+Math.min(3,S-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,S-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,S-1)+"}(?:```|~~~)"),Ue=new RegExp("^ {0,"+Math.min(3,S-1)+"}#");l&&(ve=l.split(`
`,1)[0],ee=ve,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(ee)||Ue.test(ee)||Ye.test(ee)||nt.test(l)));){if(ee.search(/[^ ]/)>=S||!ee.trim())we+=`
`+ee.slice(S);else if(!V)we+=`
`+ee;else break;!V&&!ee.trim()&&(V=!0),n+=ve+`
`,l=l.substring(ve.length+1)}Re.loose||(Z?Re.loose=!0:/\n *\n *$/.test(n)&&(Z=!0)),this.options.gfm&&(h=/^\[[ xX]\] /.exec(we),h&&(N=h[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Re.items.push({type:"list_item",raw:n,task:!!h,checked:N,loose:!1,text:we}),Re.raw+=n}Re.items[Re.items.length-1].raw=n.trimRight(),Re.items[Re.items.length-1].text=we.trimRight(),Re.raw=Re.raw.trimRight();var Y=Re.items.length;for(O=0;O<Y;O++){this.lexer.state.top=!1,Re.items[O].tokens=this.lexer.blockTokens(Re.items[O].text,[]);var se=Re.items[O].tokens.filter(function(De){return De.type==="space"}),pe=se.every(function(De){for(var Ie=De.raw.split(""),ze=0,Ve=H(Ie),_e;!(_e=Ve()).done;){var tt=_e.value;if(tt===`
`&&(ze+=1),ze>1)return!0}return!1});!Re.loose&&se.length&&pe&&(Re.loose=!0,Re.items[O].loose=!0)}return Re}},k.html=function(l){var u=this.rules.block.html.exec(l);if(u){var n={type:"html",raw:u[0],pre:!this.options.sanitizer&&(u[1]==="pre"||u[1]==="script"||u[1]==="style"),text:u[0]};if(this.options.sanitize){var h=this.options.sanitizer?this.options.sanitizer(u[0]):e(u[0]);n.type="paragraph",n.text=h,n.tokens=this.lexer.inline(h)}return n}},k.def=function(l){var u=this.rules.block.def.exec(l);if(u){u[3]&&(u[3]=u[3].substring(1,u[3].length-1));var n=u[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:n,raw:u[0],href:u[2],title:u[3]}}},k.table=function(l){var u=this.rules.block.table.exec(l);if(u){var n={type:"table",header:x(u[1]).map(function(Z){return{text:Z}}),align:u[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:u[3]&&u[3].trim()?u[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(n.header.length===n.align.length){n.raw=u[0];var h=n.align.length,N,S,O,V;for(N=0;N<h;N++)/^ *-+: *$/.test(n.align[N])?n.align[N]="right":/^ *:-+: *$/.test(n.align[N])?n.align[N]="center":/^ *:-+ *$/.test(n.align[N])?n.align[N]="left":n.align[N]=null;for(h=n.rows.length,N=0;N<h;N++)n.rows[N]=x(n.rows[N],n.header.length).map(function(Z){return{text:Z}});for(h=n.header.length,S=0;S<h;S++)n.header[S].tokens=this.lexer.inline(n.header[S].text);for(h=n.rows.length,S=0;S<h;S++)for(V=n.rows[S],O=0;O<V.length;O++)V[O].tokens=this.lexer.inline(V[O].text);return n}}},k.lheading=function(l){var u=this.rules.block.lheading.exec(l);if(u)return{type:"heading",raw:u[0],depth:u[2].charAt(0)==="="?1:2,text:u[1],tokens:this.lexer.inline(u[1])}},k.paragraph=function(l){var u=this.rules.block.paragraph.exec(l);if(u){var n=u[1].charAt(u[1].length-1)===`
`?u[1].slice(0,-1):u[1];return{type:"paragraph",raw:u[0],text:n,tokens:this.lexer.inline(n)}}},k.text=function(l){var u=this.rules.block.text.exec(l);if(u)return{type:"text",raw:u[0],text:u[0],tokens:this.lexer.inline(u[0])}},k.escape=function(l){var u=this.rules.inline.escape.exec(l);if(u)return{type:"escape",raw:u[0],text:e(u[1])}},k.tag=function(l){var u=this.rules.inline.tag.exec(l);if(u)return!this.lexer.state.inLink&&/^<a /i.test(u[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(u[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(u[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(u[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:u[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(u[0]):e(u[0]):u[0]}},k.link=function(l){var u=this.rules.inline.link.exec(l);if(u){var n=u[2].trim();if(!this.options.pedantic&&/^</.test(n)){if(!/>$/.test(n))return;var h=W(n.slice(0,-1),"\\");if((n.length-h.length)%2===0)return}else{var N=T(u[2],"()");if(N>-1){var S=u[0].indexOf("!")===0?5:4,O=S+u[1].length+N;u[2]=u[2].substring(0,N),u[0]=u[0].substring(0,O).trim(),u[3]=""}}var V=u[2],Z="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);ee&&(V=ee[1],Z=ee[3])}else Z=u[3]?u[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(n)?V=V.slice(1):V=V.slice(1,-1)),X(u,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},u[0],this.lexer)}},k.reflink=function(l,u){var n;if((n=this.rules.inline.reflink.exec(l))||(n=this.rules.inline.nolink.exec(l))){var h=(n[2]||n[1]).replace(/\s+/g," ");if(h=u[h.toLowerCase()],!h||!h.href){var N=n[0].charAt(0);return{type:"text",raw:N,text:N}}return X(n,h,n[0],this.lexer)}},k.emStrong=function(l,u,n){n===void 0&&(n="");var h=this.rules.inline.emStrong.lDelim.exec(l);if(h&&!(h[3]&&n.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=h[1]||h[2]||"";if(!N||N&&(n===""||this.rules.inline.punctuation.exec(n))){var S=h[0].length-1,O,V,Z=S,ee=0,$e=h[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,u=u.slice(-1*l.length+S);(h=$e.exec(u))!=null;)if(O=h[1]||h[2]||h[3]||h[4]||h[5]||h[6],!!O){if(V=O.length,h[3]||h[4]){Z+=V;continue}else if((h[5]||h[6])&&S%3&&!((S+V)%3)){ee+=V;continue}if(Z-=V,!(Z>0)){if(V=Math.min(V,V+Z+ee),Math.min(S,V)%2){var ve=l.slice(1,S+h.index+V);return{type:"em",raw:l.slice(0,S+h.index+V+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var we=l.slice(2,S+h.index+V-1);return{type:"strong",raw:l.slice(0,S+h.index+V+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},k.codespan=function(l){var u=this.rules.inline.code.exec(l);if(u){var n=u[2].replace(/\n/g," "),h=/[^ ]/.test(n),N=/^ /.test(n)&&/ $/.test(n);return h&&N&&(n=n.substring(1,n.length-1)),n=e(n,!0),{type:"codespan",raw:u[0],text:n}}},k.br=function(l){var u=this.rules.inline.br.exec(l);if(u)return{type:"br",raw:u[0]}},k.del=function(l){var u=this.rules.inline.del.exec(l);if(u)return{type:"del",raw:u[0],text:u[2],tokens:this.lexer.inlineTokens(u[2])}},k.autolink=function(l,u){var n=this.rules.inline.autolink.exec(l);if(n){var h,N;return n[2]==="@"?(h=e(this.options.mangle?u(n[1]):n[1]),N="mailto:"+h):(h=e(n[1]),N=h),{type:"link",raw:n[0],text:h,href:N,tokens:[{type:"text",raw:h,text:h}]}}},k.url=function(l,u){var n;if(n=this.rules.inline.url.exec(l)){var h,N;if(n[2]==="@")h=e(this.options.mangle?u(n[0]):n[0]),N="mailto:"+h;else{var S;do S=n[0],n[0]=this.rules.inline._backpedal.exec(n[0])[0];while(S!==n[0]);h=e(n[0]),n[1]==="www."?N="http://"+h:N=h}return{type:"link",raw:n[0],text:h,href:N,tokens:[{type:"text",raw:h,text:h}]}}},k.inlineText=function(l,u){var n=this.rules.inline.text.exec(l);if(n){var h;return this.lexer.state.inRawBlock?h=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(n[0]):e(n[0]):n[0]:h=e(this.options.smartypants?u(n[0]):n[0]),{type:"text",raw:n[0],text:h}}},f}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=p(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=p(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=p(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=p(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=p(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=p(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=D({},he),he.gfm=D({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=p(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=p(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=D({},he.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:p(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=p(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=p(he._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=p(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=p(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=p(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=p(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=p(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=p(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=p(ne.reflink).replace("label",ne._label).replace("ref",he._label).getRegex(),ne.nolink=p(ne.nolink).replace("ref",he._label).getRegex(),ne.reflinkSearch=p(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=D({},ne),ne.pedantic=D({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=D({},ne.normal,{escape:p(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ne.gfm.url=p(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=D({},ne.gfm,{br:p(ne.br).replace("{2,}","*").getRegex(),text:p(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(f){return f.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ne(f){var k="",F,l,u=f.length;for(F=0;F<u;F++)l=f.charCodeAt(F),Math.random()>.5&&(l="x"+l.toString(16)),k+="&#"+l+";";return k}var Ce=function(){function f(F){this.tokens=[],this.tokens.links=Object.create(null),this.options=F||re.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:he.normal,inline:ne.normal};this.options.pedantic?(l.block=he.pedantic,l.inline=ne.pedantic):this.options.gfm&&(l.block=he.gfm,this.options.breaks?l.inline=ne.breaks:l.inline=ne.gfm),this.tokenizer.rules=l}f.lex=function(l,u){var n=new f(u);return n.lex(l)},f.lexInline=function(l,u){var n=new f(u);return n.inlineTokens(l)};var k=f.prototype;return k.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var u;u=this.inlineQueue.shift();)this.inlineTokens(u.src,u.tokens);return this.tokens},k.blockTokens=function(l,u){var n=this;u===void 0&&(u=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(Z,ee,$e){return ee+"    ".repeat($e.length)});for(var h,N,S,O;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(h=Z.call({lexer:n},l,u))?(l=l.substring(h.raw.length),u.push(h),!0):!1}))){if(h=this.tokenizer.space(l)){l=l.substring(h.raw.length),h.raw.length===1&&u.length>0?u[u.length-1].raw+=`
`:u.push(h);continue}if(h=this.tokenizer.code(l)){l=l.substring(h.raw.length),N=u[u.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+h.raw,N.text+=`
`+h.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):u.push(h);continue}if(h=this.tokenizer.fences(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.heading(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.hr(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.blockquote(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.list(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.html(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.def(l)){l=l.substring(h.raw.length),N=u[u.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+h.raw,N.text+=`
`+h.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[h.tag]||(this.tokens.links[h.tag]={href:h.href,title:h.title});continue}if(h=this.tokenizer.table(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.lheading(l)){l=l.substring(h.raw.length),u.push(h);continue}if(S=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,ee=l.slice(1),$e=void 0;n.options.extensions.startBlock.forEach(function(ve){$e=ve.call({lexer:this},ee),typeof $e=="number"&&$e>=0&&(Z=Math.min(Z,$e))}),Z<1/0&&Z>=0&&(S=l.substring(0,Z+1))}(),this.state.top&&(h=this.tokenizer.paragraph(S))){N=u[u.length-1],O&&N.type==="paragraph"?(N.raw+=`
`+h.raw,N.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):u.push(h),O=S.length!==l.length,l=l.substring(h.raw.length);continue}if(h=this.tokenizer.text(l)){l=l.substring(h.raw.length),N=u[u.length-1],N&&N.type==="text"?(N.raw+=`
`+h.raw,N.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):u.push(h);continue}if(l){var V="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,u},k.inline=function(l,u){return u===void 0&&(u=[]),this.inlineQueue.push({src:l,tokens:u}),u},k.inlineTokens=function(l,u){var n=this;u===void 0&&(u=[]);var h,N,S,O=l,V,Z,ee;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)$e.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,V.index)+"["+I("a",V[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,V.index)+"["+I("a",V[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,V.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(Z||(ee=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(h=we.call({lexer:n},l,u))?(l=l.substring(h.raw.length),u.push(h),!0):!1}))){if(h=this.tokenizer.escape(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.tag(l)){l=l.substring(h.raw.length),N=u[u.length-1],N&&h.type==="text"&&N.type==="text"?(N.raw+=h.raw,N.text+=h.text):u.push(h);continue}if(h=this.tokenizer.link(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(h.raw.length),N=u[u.length-1],N&&h.type==="text"&&N.type==="text"?(N.raw+=h.raw,N.text+=h.text):u.push(h);continue}if(h=this.tokenizer.emStrong(l,O,ee)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.codespan(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.br(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.del(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.autolink(l,Ne)){l=l.substring(h.raw.length),u.push(h);continue}if(!this.state.inLink&&(h=this.tokenizer.url(l,Ne))){l=l.substring(h.raw.length),u.push(h);continue}if(S=l,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,je=l.slice(1),Se=void 0;n.options.extensions.startInline.forEach(function(Ee){Se=Ee.call({lexer:this},je),typeof Se=="number"&&Se>=0&&(we=Math.min(we,Se))}),we<1/0&&we>=0&&(S=l.substring(0,we+1))}(),h=this.tokenizer.inlineText(S,ge)){l=l.substring(h.raw.length),h.raw.slice(-1)!=="_"&&(ee=h.raw.slice(-1)),Z=!0,N=u[u.length-1],N&&N.type==="text"?(N.raw+=h.raw,N.text+=h.text):u.push(h);continue}if(l){var ve="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return u},i(f,null,[{key:"rules",get:function(){return{block:he,inline:ne}}}]),f}(),Pe=function(){function f(F){this.options=F||re.defaults}var k=f.prototype;return k.code=function(l,u,n){var h=(u||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(l,h);N!=null&&N!==l&&(n=!0,l=N)}return l=l.replace(/\n$/,"")+`
`,h?'<pre><code class="'+this.options.langPrefix+e(h,!0)+'">'+(n?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(n?l:e(l,!0))+`</code></pre>
`},k.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},k.html=function(l){return l},k.heading=function(l,u,n,h){if(this.options.headerIds){var N=this.options.headerPrefix+h.slug(n);return"<h"+u+' id="'+N+'">'+l+"</h"+u+`>
`}return"<h"+u+">"+l+"</h"+u+`>
`},k.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},k.list=function(l,u,n){var h=u?"ol":"ul",N=u&&n!==1?' start="'+n+'"':"";return"<"+h+N+`>
`+l+"</"+h+`>
`},k.listitem=function(l){return"<li>"+l+`</li>
`},k.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},k.paragraph=function(l){return"<p>"+l+`</p>
`},k.table=function(l,u){return u&&(u="<tbody>"+u+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+u+`</table>
`},k.tablerow=function(l){return`<tr>
`+l+`</tr>
`},k.tablecell=function(l,u){var n=u.header?"th":"td",h=u.align?"<"+n+' align="'+u.align+'">':"<"+n+">";return h+l+("</"+n+`>
`)},k.strong=function(l){return"<strong>"+l+"</strong>"},k.em=function(l){return"<em>"+l+"</em>"},k.codespan=function(l){return"<code>"+l+"</code>"},k.br=function(){return this.options.xhtml?"<br/>":"<br>"},k.del=function(l){return"<del>"+l+"</del>"},k.link=function(l,u,n){if(l=g(this.options.sanitize,this.options.baseUrl,l),l===null)return n;var h='<a href="'+e(l)+'"';return u&&(h+=' title="'+u+'"'),h+=">"+n+"</a>",h},k.image=function(l,u,n){if(l=g(this.options.sanitize,this.options.baseUrl,l),l===null)return n;var h='<img src="'+l+'" alt="'+n+'"';return u&&(h+=' title="'+u+'"'),h+=this.options.xhtml?"/>":">",h},k.text=function(l){return l},f}(),le=function(){function f(){}var k=f.prototype;return k.strong=function(l){return l},k.em=function(l){return l},k.codespan=function(l){return l},k.del=function(l){return l},k.html=function(l){return l},k.text=function(l){return l},k.link=function(l,u,n){return""+n},k.image=function(l,u,n){return""+n},k.br=function(){return""},f}(),_=function(){function f(){this.seen={}}var k=f.prototype;return k.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},k.getNextSafeSlug=function(l,u){var n=l,h=0;if(this.seen.hasOwnProperty(n)){h=this.seen[l];do h++,n=l+"-"+h;while(this.seen.hasOwnProperty(n))}return u||(this.seen[l]=h,this.seen[n]=0),n},k.slug=function(l,u){u===void 0&&(u={});var n=this.serialize(l);return this.getNextSafeSlug(n,u.dryrun)},f}(),ae=function(){function f(F){this.options=F||re.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}f.parse=function(l,u){var n=new f(u);return n.parse(l)},f.parseInline=function(l,u){var n=new f(u);return n.parseInline(l)};var k=f.prototype;return k.parse=function(l,u){u===void 0&&(u=!0);var n="",h,N,S,O,V,Z,ee,$e,ve,we,je,Se,Ee,Re,Le,Ye,nt,Ge,Ue,Y=l.length;for(h=0;h<Y;h++){if(we=l[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Ue=this.options.extensions.renderers[we.type].call({parser:this},we),Ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){n+=Ue||"";continue}switch(we.type){case"space":continue;case"hr":{n+=this.renderer.hr();continue}case"heading":{n+=this.renderer.heading(this.parseInline(we.tokens),we.depth,a(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{n+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for($e="",ee="",O=we.header.length,N=0;N<O;N++)ee+=this.renderer.tablecell(this.parseInline(we.header[N].tokens),{header:!0,align:we.align[N]});for($e+=this.renderer.tablerow(ee),ve="",O=we.rows.length,N=0;N<O;N++){for(Z=we.rows[N],ee="",V=Z.length,S=0;S<V;S++)ee+=this.renderer.tablecell(this.parseInline(Z[S].tokens),{header:!1,align:we.align[S]});ve+=this.renderer.tablerow(ee)}n+=this.renderer.table($e,ve);continue}case"blockquote":{ve=this.parse(we.tokens),n+=this.renderer.blockquote(ve);continue}case"list":{for(je=we.ordered,Se=we.start,Ee=we.loose,O=we.items.length,ve="",N=0;N<O;N++)Le=we.items[N],Ye=Le.checked,nt=Le.task,Re="",Le.task&&(Ge=this.renderer.checkbox(Ye),Ee?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=Ge+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=Ge+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:Ge}):Re+=Ge),Re+=this.parse(Le.tokens,Ee),ve+=this.renderer.listitem(Re,nt,Ye);n+=this.renderer.list(ve,je,Se);continue}case"html":{n+=this.renderer.html(we.text);continue}case"paragraph":{n+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(ve=we.tokens?this.parseInline(we.tokens):we.text;h+1<Y&&l[h+1].type==="text";)we=l[++h],ve+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);n+=u?this.renderer.paragraph(ve):ve;continue}default:{var se='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return n},k.parseInline=function(l,u){u=u||this.renderer;var n="",h,N,S,O=l.length;for(h=0;h<O;h++){if(N=l[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(S=this.options.extensions.renderers[N.type].call({parser:this},N),S!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){n+=S||"";continue}switch(N.type){case"escape":{n+=u.text(N.text);break}case"html":{n+=u.html(N.text);break}case"link":{n+=u.link(N.href,N.title,this.parseInline(N.tokens,u));break}case"image":{n+=u.image(N.href,N.title,N.text);break}case"strong":{n+=u.strong(this.parseInline(N.tokens,u));break}case"em":{n+=u.em(this.parseInline(N.tokens,u));break}case"codespan":{n+=u.codespan(N.text);break}case"br":{n+=u.br();break}case"del":{n+=u.del(this.parseInline(N.tokens,u));break}case"text":{n+=u.text(N.text);break}default:{var V='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return n},f}();function oe(f,k,F){if(typeof f>"u"||f===null)throw new Error("marked(): input parameter is undefined or null");if(typeof f!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(f)+", string expected");if(typeof k=="function"&&(F=k,k=null),k=D({},oe.defaults,k||{}),L(k),F){var l=k.highlight,u;try{u=Ce.lex(f,k)}catch(O){return F(O)}var n=function(V){var Z;if(!V)try{k.walkTokens&&oe.walkTokens(u,k.walkTokens),Z=ae.parse(u,k)}catch(ee){V=ee}return k.highlight=l,V?F(V):F(null,Z)};if(!l||l.length<3||(delete k.highlight,!u.length))return n();var h=0;oe.walkTokens(u,function(O){O.type==="code"&&(h++,setTimeout(function(){l(O.text,O.lang,function(V,Z){if(V)return n(V);Z!=null&&Z!==O.text&&(O.text=Z,O.escaped=!0),h--,h===0&&n()})},0))}),h===0&&n();return}function N(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(O.message+"",!0)+"</pre>";throw O}try{var S=Ce.lex(f,k);if(k.walkTokens){if(k.async)return Promise.all(oe.walkTokens(S,k.walkTokens)).then(function(){return ae.parse(S,k)}).catch(N);oe.walkTokens(S,k.walkTokens)}return ae.parse(S,k)}catch(O){N(O)}}oe.options=oe.setOptions=function(f){return D(oe.defaults,f),y(oe.defaults),oe},oe.getDefaults=A,oe.defaults=re.defaults,oe.use=function(){for(var f=arguments.length,k=new Array(f),F=0;F<f;F++)k[F]=arguments[F];var l=D.apply(void 0,[{}].concat(k)),u=oe.defaults.extensions||{renderers:{},childTokens:{}},n;k.forEach(function(h){if(h.extensions&&(n=!0,h.extensions.forEach(function(S){if(!S.name)throw new Error("extension name required");if(S.renderer){var O=u.renderers?u.renderers[S.name]:null;O?u.renderers[S.name]=function(){for(var V=arguments.length,Z=new Array(V),ee=0;ee<V;ee++)Z[ee]=arguments[ee];var $e=S.renderer.apply(this,Z);return $e===!1&&($e=O.apply(this,Z)),$e}:u.renderers[S.name]=S.renderer}if(S.tokenizer){if(!S.level||S.level!=="block"&&S.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");u[S.level]?u[S.level].unshift(S.tokenizer):u[S.level]=[S.tokenizer],S.start&&(S.level==="block"?u.startBlock?u.startBlock.push(S.start):u.startBlock=[S.start]:S.level==="inline"&&(u.startInline?u.startInline.push(S.start):u.startInline=[S.start]))}S.childTokens&&(u.childTokens[S.name]=S.childTokens)})),h.renderer&&function(){var S=oe.defaults.renderer||new Pe,O=function(ee){var $e=S[ee];S[ee]=function(){for(var ve=arguments.length,we=new Array(ve),je=0;je<ve;je++)we[je]=arguments[je];var Se=h.renderer[ee].apply(S,we);return Se===!1&&(Se=$e.apply(S,we)),Se}};for(var V in h.renderer)O(V);l.renderer=S}(),h.tokenizer&&function(){var S=oe.defaults.tokenizer||new de,O=function(ee){var $e=S[ee];S[ee]=function(){for(var ve=arguments.length,we=new Array(ve),je=0;je<ve;je++)we[je]=arguments[je];var Se=h.tokenizer[ee].apply(S,we);return Se===!1&&(Se=$e.apply(S,we)),Se}};for(var V in h.tokenizer)O(V);l.tokenizer=S}(),h.walkTokens){var N=oe.defaults.walkTokens;l.walkTokens=function(S){var O=[];return O.push(h.walkTokens.call(this,S)),N&&(O=O.concat(N.call(this,S))),O}}n&&(l.extensions=u),oe.setOptions(l)})},oe.walkTokens=function(f,k){for(var F=[],l=function(){var N=n.value;switch(F=F.concat(k.call(oe,N)),N.type){case"table":{for(var S=H(N.header),O;!(O=S()).done;){var V=O.value;F=F.concat(oe.walkTokens(V.tokens,k))}for(var Z=H(N.rows),ee;!(ee=Z()).done;)for(var $e=ee.value,ve=H($e),we;!(we=ve()).done;){var je=we.value;F=F.concat(oe.walkTokens(je.tokens,k))}break}case"list":{F=F.concat(oe.walkTokens(N.items,k));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[N.type]?oe.defaults.extensions.childTokens[N.type].forEach(function(Se){F=F.concat(oe.walkTokens(N[Se],k))}):N.tokens&&(F=F.concat(oe.walkTokens(N.tokens,k)))}},u=H(f),n;!(n=u()).done;)l();return F},oe.parseInline=function(f,k){if(typeof f>"u"||f===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof f!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(f)+", string expected");k=D({},oe.defaults,k||{}),L(k);try{var F=Ce.lexInline(f,k);return k.walkTokens&&oe.walkTokens(F,k.walkTokens),ae.parseInline(F,k)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},oe.Parser=ae,oe.parser=ae.parse,oe.Renderer=Pe,oe.TextRenderer=le,oe.Lexer=Ce,oe.lexer=Ce.lex,oe.Tokenizer=de,oe.Slugger=_,oe.parse=oe;var J=oe.options,G=oe.setOptions,ie=oe.use,ce=oe.walkTokens,Ae=oe.parseInline,Fe=oe,ye=ae.parse,K=Ce.lex;re.Lexer=Ce,re.Parser=ae,re.Renderer=Pe,re.Slugger=_,re.TextRenderer=le,re.Tokenizer=de,re.getDefaults=A,re.lexer=K,re.marked=oe,re.options=J,re.parse=Fe,re.parseInline=Ae,re.parser=ye,re.setOptions=G,re.use=ie,re.walkTokens=ce,Object.defineProperty(re,"__esModule",{value:!0})}),define(me[83],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fk=i;function i(s){const a=H(s);if(a&&a.length>0)return new Uint32Array(a)}let C=0;const z=new Uint32Array(10);function H(s){if(C=0,A(s,P,4352),C>0||(A(s,c,4449),C>0)||(A(s,d,4520),C>0)||(A(s,e,12593),C))return z.subarray(0,C);if(s>=44032&&s<=55203){const a=s-44032,m=a%588,p=Math.floor(a/588),v=Math.floor(m/28),o=m%28-1;if(p<P.length?A(p,P,0):4352+p-12593<e.length&&A(4352+p,e,12593),v<c.length?A(v,c,0):4449+v-12593<e.length&&A(4449+v-12593,e,12593),o>=0&&(o<d.length?A(o,d,0):4520+o-12593<e.length&&A(4520+o-12593,e,12593)),C>0)return z.subarray(0,C)}}function A(s,a,m){s>=m&&s<m+a.length&&y(a[s-m])}function y(s){s!==0&&(z[C++]=s&255,s>>8&&(z[C++]=s>>8&255),s>>16&&(z[C++]=s>>16&255))}var b;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var $;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})($||($={}));var w;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(w||(w={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),d=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[84],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sU=void 0;class i{constructor(z,H=0,A=z.length,y=H-1){this.a=z,this.b=H,this.c=A,this.d=y}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$sU=i}),define(me[85],be([1,0,84]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=t.$tU=void 0;class C{constructor(A=[],y=10){this.h(A),this.b=y,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new i.$sU(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const y of A)this.a.add(y)}get j(){const A=[];return this.a.forEach(y=>A.push(y)),A}}t.$tU=C;class z{get size(){return this.f}constructor(A,y=10){if(this.g=y,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let b=1;b<A.length;b++)this.add(A[b])}add(A){const y={value:A,previous:this.c,next:void 0};for(this.c.next=y,this.c=y,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const y=this.c.value;return this.a.delete(y),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),y}prepend(A){if(this.f===this.g||this.a.has(A))return;const y={value:A,previous:void 0,next:this.b};this.b.previous=y,this.b=y,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let y=this.b;for(;y!==this.c;)y.value===A&&(y===this.b?(this.b=this.b.next,this.b.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.f--),y=y.next}}t.$uU=z}),define(me[35],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pm=t.$om=t.$nm=void 0,t.$lm=i,t.rot=C;function i(y,b,$){return Math.min(Math.max(y,b),$)}function C(y,b){return(b+y%b)%b}class z{constructor(){this.a=0}getNext(){return this.a++}}t.$nm=z;class H{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$om=H;class A{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$pm=A}),define(me[50],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(C){function z(b,$){if(b.start>=$.end||$.start>=b.end)return{start:0,end:0};const w=Math.max(b.start,$.start),P=Math.min(b.end,$.end);return P-w<=0?{start:0,end:0}:{start:w,end:P}}C.intersect=z;function H(b){return b.end-b.start<=0}C.isEmpty=H;function A(b,$){return!H(z(b,$))}C.intersects=A;function y(b,$){const w=[],P={start:b.start,end:Math.min($.start,b.end)},c={start:Math.max($.end,b.start),end:b.end};return H(P)||w.push(P),H(c)||w.push(c),w}C.relativeComplement=y})(i||(t.Range=i={}))}),define(me[86],be([1,0,50]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bT=void 0,t.$$S=C,t.$_S=z,t.$aT=H;function C(b,$){const w=[];for(const P of $){if(b.start>=P.range.end)continue;if(b.end<P.range.start)break;const c=i.Range.intersect(b,P.range);i.Range.isEmpty(c)||w.push({range:c,size:P.size})}return w}function z({start:b,end:$},w){return{start:b+w,end:$+w}}function H(b){const $=[];let w=null;for(const P of b){const c=P.range.start,d=P.range.end,e=P.size;if(w&&e===w.size){w.range.end=d;continue}w={range:{start:c,end:d},size:e},$.push(w)}return $}function A(...b){return H(b.reduce(($,w)=>$.concat(w),[]))}class y{get paddingTop(){return this.c}set paddingTop($){this.b=this.b+$-this.c,this.c=$}constructor($){this.a=[],this.b=0,this.c=0,this.c=$??0,this.b=this.c}splice($,w,P=[]){const c=P.length-w,d=C({start:0,end:$},this.a),e=C({start:$+w,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:z(a.range,c),size:a.size})),s=P.map((a,m)=>({range:{start:$+m,end:$+m+1},size:a.size}));this.a=A(d,s,e),this.b=this.c+this.a.reduce((a,m)=>a+m.size*(m.range.end-m.range.start),0)}get count(){const $=this.a.length;return $?this.a[$-1].range.end:0}get size(){return this.b}indexAt($){if($<0)return-1;if($<this.c)return 0;let w=0,P=this.c;for(const c of this.a){const d=c.range.end-c.range.start,e=P+d*c.size;if($<e)return w+Math.floor(($-P)/c.size);w+=d,P=e}return w}indexAfter($){return Math.min(this.indexAt($)+1,this.count)}positionAt($){if($<0)return-1;let w=0,P=0;for(const c of this.a){const d=c.range.end-c.range.start,e=P+d;if($<e)return this.c+w+($-P)*c.size;w+=d*c.size,P=e}return-1}}t.$bT=y}),define(me[87],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(H){return new C(H)}constructor(H){this.c=i&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$2d=C}),define(me[4],be([1,0,6,47,3,49,87]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$4d=t.Event=void 0,t.$5d=c;const y=!1,b=!1;var $;(function(W){W.None=()=>z.$Tc.None;function T(l){if(b){const{onDidAddListener:u}=l,n=e.create();let h=0;l.onDidAddListener=()=>{++h===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),n.print()),u?.()}}}function L(l,u){return Pe(l,()=>{},0,void 0,!0,void 0,u)}W.defer=L;function I(l){return(u,n=null,h)=>{let N=!1,S;return S=l(O=>{if(!N)return S?S.dispose():N=!0,u.call(n,O)},null,h),N&&S.dispose(),S}}W.once=I;function X(l,u,n){return Ne((h,N=null,S)=>l(O=>h.call(N,u(O)),null,S),n)}W.map=X;function U(l,u,n){return Ne((h,N=null,S)=>l(O=>{u(O),h.call(N,O)},null,S),n)}W.forEach=U;function de(l,u,n){return Ne((h,N=null,S)=>l(O=>u(O)&&h.call(N,O),null,S),n)}W.filter=de;function he(l){return l}W.signal=he;function ne(...l){return(u,n=null,h)=>{const N=(0,z.$Qc)(...l.map(S=>S(O=>u.call(n,O))));return Ce(N,h)}}W.any=ne;function ge(l,u,n,h){let N=n;return X(l,S=>(N=u(N,S),N),h)}W.reduce=ge;function Ne(l,u){let n;const h={onWillAddFirstListener(){n=l(N.fire,N)},onDidRemoveLastListener(){n?.dispose()}};u||T(h);const N=new v(h);return u?.add(N),N.event}function Ce(l,u){return u instanceof Array?u.push(l):u&&u.add(l),l}function Pe(l,u,n=100,h=!1,N=!1,S,O){let V,Z,ee,$e=0,ve;const we={leakWarningThreshold:S,onWillAddFirstListener(){V=l(Se=>{$e++,Z=u(Z,Se),h&&!ee&&(je.fire(Z),Z=void 0),ve=()=>{const Ee=Z;Z=void 0,ee=void 0,(!h||$e>1)&&je.fire(Ee),$e=0},typeof n=="number"?(clearTimeout(ee),ee=setTimeout(ve,n)):ee===void 0&&(ee=0,queueMicrotask(ve))})},onWillRemoveListener(){N&&$e>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,V.dispose()}};O||T(we);const je=new v(we);return O?.add(je),je.event}W.debounce=Pe;function le(l,u=0,n){return W.debounce(l,(h,N)=>h?(h.push(N),h):[N],u,void 0,!0,void 0,n)}W.accumulate=le;function _(l,u=(h,N)=>h===N,n){let h=!0,N;return de(l,S=>{const O=h||!u(S,N);return h=!1,N=S,O},n)}W.latch=_;function ae(l,u,n){return[W.filter(l,u,n),W.filter(l,h=>!u(h),n)]}W.split=ae;function oe(l,u=!1,n=[],h){let N=n.slice(),S=l(Z=>{N?N.push(Z):V.fire(Z)});h&&h.add(S);const O=()=>{N?.forEach(Z=>V.fire(Z)),N=null},V=new v({onWillAddFirstListener(){S||(S=l(Z=>V.fire(Z)),h&&h.add(S))},onDidAddFirstListener(){N&&(u?setTimeout(O):O())},onDidRemoveLastListener(){S&&S.dispose(),S=null}});return h&&h.add(V),V.event}W.buffer=oe;function J(l,u){return(h,N,S)=>{const O=u(new ie);return l(function(V){const Z=O.evaluate(V);Z!==G&&h.call(N,Z)},void 0,S)}}W.chain=J;const G=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(u){return this.f.push(u),this}forEach(u){return this.f.push(n=>(u(n),n)),this}filter(u){return this.f.push(n=>u(n)?n:G),this}reduce(u,n){let h=n;return this.f.push(N=>(h=u(h,N),h)),this}latch(u=(n,h)=>n===h){let n=!0,h;return this.f.push(N=>{const S=n||!u(N,h);return n=!1,h=N,S?N:G}),this}evaluate(u){for(const n of this.f)if(u=n(u),u===G)break;return u}}function ce(l,u,n=h=>h){const h=(...V)=>O.fire(n(...V)),N=()=>l.on(u,h),S=()=>l.removeListener(u,h),O=new v({onWillAddFirstListener:N,onDidRemoveLastListener:S});return O.event}W.fromNodeEventEmitter=ce;function Ae(l,u,n=h=>h){const h=(...V)=>O.fire(n(...V)),N=()=>l.addEventListener(u,h),S=()=>l.removeEventListener(u,h),O=new v({onWillAddFirstListener:N,onDidRemoveLastListener:S});return O.event}W.fromDOMEventEmitter=Ae;function Fe(l){return new Promise(u=>I(l)(u))}W.toPromise=Fe;function ye(l){const u=new v;return l.then(n=>{u.fire(n)},()=>{u.fire(void 0)}).finally(()=>{u.dispose()}),u.event}W.fromPromise=ye;function K(l,u,n){return u(n),l(h=>u(h))}W.runAndSubscribe=K;class f{constructor(u,n){this._observable=u,this.f=0,this.g=!1;const h={onWillAddFirstListener:()=>{u.addObserver(this)},onDidRemoveLastListener:()=>{u.removeObserver(this)}};n||T(h),this.emitter=new v(h),n&&n.add(this.emitter)}beginUpdate(u){this.f++}handlePossibleChange(u){}handleChange(u,n){this.g=!0}endUpdate(u){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function k(l,u){return new f(l,u).emitter.event}W.fromObservable=k;function F(l){return(u,n,h)=>{let N=0,S=!1;const O={beginUpdate(){N++},endUpdate(){N--,N===0&&(l.reportChanges(),S&&(S=!1,u.call(n)))},handlePossibleChange(){},handleChange(){S=!0}};l.addObserver(O),l.reportChanges();const V={dispose(){l.removeObserver(O)}};return h instanceof z.$Sc?h.add(V):Array.isArray(h)&&h.push(V),V}}W.fromObservableLight=F})($||(t.Event=$={}));class w{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${w.f++}`,w.all.add(this)}start(T){this.g=new A.$2d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}t.$4d=w;let P=-1;function c(W){const T=P;return P=W,{dispose(){P=T}}}class d{constructor(T,L=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=L,this.g=0}dispose(){this.f?.clear()}check(T,L){const I=this.threshold;if(I<=0||L<I)return;this.f||(this.f=new Map);const X=this.f.get(T.value)||0;if(this.f.set(T.value,X+1),this.g-=1,this.g<=0){this.g=I*.5;let U,de=0;for(const[he,ne]of this.f)(!U||de<ne)&&(U=he,de=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${de}):`),console.warn(U)}return()=>{const U=this.f.get(T.value)||0;this.f.set(T.value,U-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class a{constructor(T){this.value=T,this.id=s++}}const m=2,p=(W,T)=>{if(W instanceof a)T(W);else for(let L=0;L<W.length;L++){const I=W[L];I&&T(I)}};class v{constructor(T){this.w=0,this.f=T,this.g=P>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(y){const T=this.t;queueMicrotask(()=>{p(T,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,L,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),z.$Tc.None;if(this.m)return z.$Tc.None;L&&(T=T.bind(L));const X=new a(T);let U,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),U=this.g.check(X.stack,this.w+1)),y&&(X.stack=de??e.create()),this.t?this.t instanceof a?(this.u??=new g,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const he=(0,z.$Rc)(()=>{U?.(),this.x(X)});return I instanceof z.$Sc?I.add(he):Array.isArray(I)&&I.push(he),he},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,I=L.indexOf(T);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[I]=void 0;const X=this.u.current===this;if(this.w*m<=L.length){let U=0;for(let de=0;de<L.length;de++)L[de]?L[U++]=L[de]:X&&(this.u.end--,U<this.u.i&&this.u.i--);L.length=U}}y(T,L){if(!T)return;const I=this.f?.onListenerError||i.$1;if(!I){T.value(L);return}try{T.value(L)}catch(X){I(X)}}z(T){const L=T.current.t;for(;T.i<T.end;)this.y(L[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,T);else{const L=this.u;L.enqueue(this,T,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}t.$6d=v;const o=()=>new g;t.$7d=o;class g{constructor(){this.i=-1,this.end=0}enqueue(T,L,I){this.i=0,this.end=I,this.current=T,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends v{async fireAsync(T,L,I){if(this.t)for(this.h||(this.h=new H.$4c),p(this.t,X=>this.h.push([X.value,T]));this.h.size>0&&!L.isCancellationRequested;){const[X,U]=this.h.shift(),de=[],he={...U,token:L,waitUntil:ne=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");I&&(ne=I(ne,X)),de.push(ne)}};try{X(he)}catch(ne){(0,i.$1)(ne);continue}Object.freeze(de),await Promise.allSettled(de).then(ne=>{for(const ge of ne)ge.status==="rejected"&&(0,i.$1)(ge.reason)})}}}t.$8d=r;class E extends v{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new H.$4c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}t.$9d=E;class R extends E{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}t.$0d=R;class M extends v{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}t.$$d=M;class j{constructor(){this.g=!1,this.h=[],this.f=new v({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const L={event:T,listener:null};this.h.push(L),this.g&&this.m(L);const I=()=>{this.g&&this.o(L);const X=this.h.indexOf(L);this.h.splice(X,1)};return(0,z.$Rc)((0,C.$db)(I))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(L=>this.f.fire(L))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}t.$_d=j;class B{constructor(T,L,I,X){this.f=new z.$Sc;const U=this.f.add(new j),de=this.f.add(new z.$3c);function he(ne){de.set(ne,U.add(X(ne)))}for(const ne of T)he(ne);this.f.add(L(ne=>{he(ne)})),this.f.add(I(ne=>{de.deleteAndDispose(ne)})),this.event=U.event}dispose(){this.f.dispose()}}t.$ae=B;class D{constructor(){this.f=[]}wrapEvent(T){return(L,I,X)=>T(U=>{const de=this.f[this.f.length-1];de?de.push(()=>L.call(I,U)):L.call(I,U)},void 0,X)}bufferEvents(T){const L=[];this.f.push(L);const I=T();return this.f.pop(),L.forEach(X=>X()),I}}t.$be=D;class x{constructor(){this.f=!1,this.g=$.None,this.h=z.$Tc.None,this.j=new v({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ce=x}),define(me[17],be([1,0,22,4]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$BQ=void 0,t.$yQ=H,t.$zQ=A,t.$AQ=y,t.$CQ=b,t.$DQ=$,t.$EQ=w,t.$FQ=P,t.$OQ=e,t.$PQ=s;class z{constructor(){this.a=new Map,this.b=new C.$6d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$6d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new z}getZoomLevel(m){return this.a.get(this.f(m))??0}setZoomLevel(m,p){if(this.getZoomLevel(p)===m)return;const v=this.f(p);this.a.set(v,m),this.b.fire(v)}getZoomFactor(m){return this.c.get(this.f(m))??1}setZoomFactor(m,p){this.c.set(this.f(p),m)}setFullscreen(m,p){if(this.isFullscreen(p)===m)return;const v=this.f(p);this.e.set(v,m),this.d.fire(v)}isFullscreen(m){return!!this.e.get(this.f(m))}f(m){return m.vscodeWindowId}}function H(a,m,p){typeof m=="string"&&(m=a.matchMedia(m)),m.addEventListener("change",p)}function A(a,m){z.INSTANCE.setZoomLevel(a,m)}function y(a){return z.INSTANCE.getZoomLevel(a)}t.$BQ=z.INSTANCE.onDidChangeZoomLevel;function b(a){return z.INSTANCE.getZoomFactor(a)}function $(a,m){z.INSTANCE.setZoomFactor(a,m)}function w(a,m){z.INSTANCE.setFullscreen(a,m)}function P(a){return z.INSTANCE.isFullscreen(a)}t.$GQ=z.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$HQ=c.indexOf("Firefox")>=0,t.$IQ=c.indexOf("AppleWebKit")>=0,t.$JQ=c.indexOf("Chrome")>=0,t.$KQ=!t.$JQ&&c.indexOf("Safari")>=0,t.$LQ=!t.$JQ&&!t.$KQ&&t.$IQ,t.$MQ=c.indexOf("Electron/")>=0,t.$NQ=c.indexOf("Android")>=0;let d=!1;if(typeof i.$uQ.matchMedia=="function"){const a=i.$uQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),m=i.$uQ.matchMedia("(display-mode: fullscreen)");d=a.matches,H(i.$uQ,a,({matches:p})=>{d&&m.matches||(d=p)})}function e(){return d}function s(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],be([1,0,4]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=void 0;class C{get event(){return this.a.event}constructor(H,A,y){const b=$=>this.a.fire($);this.a=new i.$6d({onWillAddFirstListener:()=>H.addEventListener(A,b,y),onDidRemoveLastListener:()=>H.removeEventListener(A,b,y)})}dispose(){this.a.dispose()}}t.$6S=C}),define(me[30],be([1,0,4]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.CancellationToken=void 0;const C=Object.freeze(function(y,b){const $=setTimeout(y.bind(b),0);return{dispose(){clearTimeout($)}}});var z;(function(y){function b($){return $===y.None||$===y.Cancelled||$ instanceof H?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}y.isCancellationToken=b,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(z||(t.CancellationToken=z={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new i.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=z.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=z.None}}t.$de=A}),define(me[88],be([1,0,30]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qe=t.$Pe=t.$Oe=void 0;class C{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$de,b=this.b(y.token);return this.a={promise:b,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}t.$Oe=C;class z{constructor(y){this.c=y,this.a=void 0,this.b=void 0}get(y){const b=JSON.stringify(y);return this.b!==b&&(this.b=b,this.a=this.c(y)),this.a}}t.$Pe=z;class H{get cachedValues(){return this.a}constructor(y){this.b=y,this.a=new Map}get(y){if(this.a.has(y))return this.a.get(y);const b=this.b(y);return this.a.set(y,b),b}}t.$Qe=H}),define(me[51],be([1,0,4,3]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ds=t.$Cs=t.$Bs=t.$As=t.ScrollbarVisibility=void 0;var z;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(z||(t.ScrollbarVisibility=z={}));class H{constructor(e,s,a,m,p,v,o){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,a=a|0,m=m|0,p=p|0,v=v|0,o=o|0),this.rawScrollLeft=m,this.rawScrollTop=o,s<0&&(s=0),m+s>a&&(m=a-s),m<0&&(m=0),p<0&&(p=0),o+p>v&&(o=v-p),o<0&&(o=0),this.width=s,this.scrollWidth=a,this.scrollLeft=m,this.height=p,this.scrollHeight=v,this.scrollTop=o}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const a=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,p=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,o=this.scrollHeight!==e.scrollHeight,g=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:m,scrollLeftChanged:p,heightChanged:v,scrollHeightChanged:o,scrollTopChanged:g}}}t.$As=H;class A extends C.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$6d),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const a=this.g.withScrollDimensions(e,s);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const a=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let m;s?m=new w(this.h.from,a,this.h.startTime,this.h.duration):m=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=m}else{const a=this.g.withScrollPosition(e);this.h=w.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const a=this.g;a.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(a,s)))}}t.$Bs=A;class y{constructor(e,s,a){this.scrollLeft=e,this.scrollTop=s,this.isDone=a}}t.$Cs=y;function b(d,e){const s=e-d;return function(a){return d+s*c(a)}}function $(d,e,s){return function(a){return a<s?d(a/s):e((a-s)/(1-s))}}class w{constructor(e,s,a,m){this.from=e,this.to=s,this.duration=m,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,a){if(Math.abs(e-s)>2.5*a){let p,v;return e<s?(p=e+.75*a,v=s-.75*a):(p=e-.75*a,v=s+.75*a),$(b(e,p),b(v,s),.33)}return b(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const a=this.c(s),m=this.d(s);return new y(a,m,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,a){return w.start(e,s,a)}static start(e,s,a){a=a+10;const m=Date.now()-10;return new w(e,s,m,a)}}t.$Ds=w;function P(d){return Math.pow(d,3)}function c(d){return 1-P(1-d)}}),define(me[89],be([1,0,6,3]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=z,t.$fe=H,t.$ge=A,t.$he=y,t.$ie=$,t.$je=w,t.$ke=P,t.$le=c,t.$me=d,t.$ne=e,t.$oe=s,t.$pe=a,t.$qe=m,t.$re=p,t.$se=v;function z(o){const g=o;return g?typeof g.read=="function":!1}function H(o){const g=o;return g?[g.on,g.pause,g.resume,g.destroy].every(r=>typeof r=="function"):!1}function A(o){const g=o;return g?H(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function y(o,g){return new b(o,g)}class b{constructor(g,r){this.e=g,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(r=>r(g))}h(g){this.c.error.length===0?(0,i.$1)(g):this.c.error.slice(0).forEach(r=>r(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,r){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(g,r){if(this.a.destroyed)return;let E;switch(g){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const R=E.indexOf(r);R>=0&&E.splice(R,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(o,g){const r=[];let E;for(;(E=o.read())!==null;)r.push(E);return g(r)}function w(o,g,r){const E=[];let R;for(;(R=o.read())!==null&&E.length<r;)E.push(R);return R===null&&E.length>0?g(E):{read:()=>{if(E.length>0)return E.shift();if(typeof R<"u"){const M=R;return R=void 0,M}return o.read()}}}function P(o,g){return new Promise((r,E)=>{const R=[];c(o,{onData:M=>{g&&R.push(M)},onError:M=>{g?E(M):r(void 0)},onEnd:()=>{r(g?g(R):void 0)}})})}function c(o,g,r){o.on("error",E=>{r?.isCancellationRequested||g.onError(E)}),o.on("end",()=>{r?.isCancellationRequested||g.onEnd()}),o.on("data",E=>{r?.isCancellationRequested||g.onData(E)})}function d(o,g){return new Promise((r,E)=>{const R=new C.$Sc,M=[],j=x=>{if(M.push(x),M.length>g)return R.dispose(),o.pause(),r({stream:o,buffer:M,ended:!1})},B=x=>(R.dispose(),E(x)),D=()=>(R.dispose(),r({stream:o,buffer:M,ended:!0}));R.add((0,C.$Rc)(()=>o.removeListener("error",B))),o.on("error",B),R.add((0,C.$Rc)(()=>o.removeListener("end",D))),o.on("end",D),R.add((0,C.$Rc)(()=>o.removeListener("data",j))),o.on("data",j)})}function e(o,g){const r=y(g);return r.end(o),r}function s(){const o=y(()=>{throw new Error("not supported")});return o.end(),o}function a(o){let g=!1;return{read:()=>g?null:(g=!0,o)}}function m(o,g,r){const E=y(r);return c(o,{onData:R=>E.write(g.data(R)),onError:R=>E.error(g.error?g.error(R):R),onEnd:()=>E.end()}),E}function p(o,g,r){let E=!1;return{read:()=>{const R=g.read();return E?R:(E=!0,R!==null?r([o,R]):o)}}}function v(o,g,r){let E=!1;const R=y(r);return c(g,{onData:M=>E?R.write(M):(E=!0,R.write(r([o,M]))),onError:M=>R.error(M),onEnd:()=>{E||(E=!0,R.write(o)),R.end()}}),R}}),define(me[36],be([1,0,23,89]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$te=void 0,t.$ue=$,t.$ve=w,t.$we=P,t.$xe=c,t.$ye=d,t.$ze=e,t.$Ae=s,t.$Be=a,t.$Ce=m,t.$De=p,t.$Ee=v,t.$Fe=o,t.$Ge=g,t.$He=r,t.$Ie=E,t.$Je=R,t.$Ke=M,t.$Le=j,t.$Me=B,t.$Ne=W;const z=typeof Buffer<"u",H=new i.$V(()=>new Uint8Array(256));let A,y;class b{static alloc(L){return z?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return z&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,I){return!(I?.dontUseNodeBuffer||!1)&&z?new b(Buffer.from(L)):(A||(A=new TextEncoder),new b(A.encode(L)))}static fromByteArray(L){const I=b.alloc(L.length);for(let X=0,U=L.length;X<U;X++)I.buffer[X]=L[X];return I}static concat(L,I){if(typeof I>"u"){I=0;for(let de=0,he=L.length;de<he;de++)I+=L[de].byteLength}const X=b.alloc(I);let U=0;for(let de=0,he=L.length;de<he;de++){const ne=L[de];X.set(ne,U),U+=ne.byteLength}return X}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return z?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(L,I){return new b(this.buffer.subarray(L,I))}set(L,I){if(L instanceof b)this.buffer.set(L.buffer,I);else if(L instanceof Uint8Array)this.buffer.set(L,I);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),I);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return c(this.buffer,L)}writeUInt32BE(L,I){d(this.buffer,L,I)}readUInt32LE(L){return e(this.buffer,L)}writeUInt32LE(L,I){s(this.buffer,L,I)}readUInt8(L){return a(this.buffer,L)}writeUInt8(L,I){m(this.buffer,L,I)}indexOf(L,I=0){return $(this.buffer,L instanceof b?L.buffer:L,I)}}t.$te=b;function $(T,L,I=0){const X=L.byteLength,U=T.byteLength;if(X===0)return 0;if(X===1)return T.indexOf(L[0]);if(X>U-I)return-1;const de=H.value;de.fill(L.length);for(let Ne=0;Ne<L.length;Ne++)de[L[Ne]]=L.length-Ne-1;let he=I+L.length-1,ne=he,ge=-1;for(;he<U;)if(T[he]===L[ne]){if(ne===0){ge=he;break}he--,ne--}else he+=Math.max(L.length-ne,de[T[he]]),ne=L.length-1;return ge}function w(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}function P(T,L,I){T[I+0]=L&255,L=L>>>8,T[I+1]=L&255}function c(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}function d(T,L,I){T[I+3]=L,L=L>>>8,T[I+2]=L,L=L>>>8,T[I+1]=L,L=L>>>8,T[I]=L}function e(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}function s(T,L,I){T[I+0]=L&255,L=L>>>8,T[I+1]=L&255,L=L>>>8,T[I+2]=L&255,L=L>>>8,T[I+3]=L&255}function a(T,L){return T[L]}function m(T,L,I){T[I]=L}function p(T){return C.$ie(T,L=>b.concat(L))}function v(T){return C.$pe(T)}function o(T){return C.$ke(T,L=>b.concat(L))}async function g(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await o(T.stream)])}function r(T){return C.$ne(T,L=>b.concat(L))}function E(T){return C.$qe(T,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}function R(T){return C.$he(L=>b.concat(L),T)}function M(T,L){return C.$re(T,L,I=>b.concat(I))}function j(T,L){return C.$se(T,L,I=>b.concat(I))}function B(T){let L=0,I=0,X=0;const U=new Uint8Array(Math.floor(T.length/4*3)),de=ne=>{switch(I){case 3:U[X++]=L|ne,I=0;break;case 2:U[X++]=L|ne>>>2,L=ne<<6,I=3;break;case 1:U[X++]=L|ne>>>4,L=ne<<4,I=2;break;default:L=ne<<2,I=1}};for(let ne=0;ne<T.length;ne++){const ge=T.charCodeAt(ne);if(ge>=65&&ge<=90)de(ge-65);else if(ge>=97&&ge<=122)de(ge-97+26);else if(ge>=48&&ge<=57)de(ge-48+52);else if(ge===43||ge===45)de(62);else if(ge===47||ge===95)de(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ne]}`)}}const he=X;for(;I>0;)de(0);return b.wrap(U).slice(0,he)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:T},L=!0,I=!1){const X=I?x:D;let U="";const de=T.byteLength%3;let he=0;for(;he<T.byteLength-de;he+=3){const ne=T[he+0],ge=T[he+1],Ne=T[he+2];U+=X[ne>>>2],U+=X[(ne<<4|ge>>>4)&63],U+=X[(ge<<2|Ne>>>6)&63],U+=X[Ne&63]}if(de===1){const ne=T[he+0];U+=X[ne>>>2],U+=X[ne<<4&63],L&&(U+="==")}else if(de===2){const ne=T[he+0],ge=T[he+1];U+=X[ne>>>2],U+=X[(ne<<4|ge>>>4)&63],U+=X[ge<<2&63],L&&(U+="=")}return U}}),define(me[10],be([1,0,88,23]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.$Qf=t.GraphemeBreakType=t.$Gf=t.$Af=t.$tf=t.$sf=void 0,t.$Te=z,t.$Ue=A,t.$Ve=b,t.$We=$,t.$Xe=w,t.$Ye=P,t.$Ze=c,t.$1e=d,t.$2e=e,t.$3e=s,t.$4e=a,t.$5e=m,t.$6e=p,t.$7e=v,t.$8e=o,t.$9e=g,t.$0e=r,t.$$e=E,t.$_e=R,t.$af=M,t.$bf=j,t.$cf=B,t.$df=D,t.$ef=x,t.$ff=W,t.$gf=T,t.$hf=L,t.$if=I,t.$jf=X,t.$kf=U,t.$lf=de,t.$mf=he,t.$nf=ne,t.$of=ge,t.$pf=Ne,t.$qf=Ce,t.$rf=Pe,t.$uf=oe,t.$vf=J,t.$wf=G,t.$xf=ie,t.$yf=Fe,t.$zf=K,t.$Bf=f,t.$Cf=k,t.$Df=F,t.$Ef=l,t.$Ff=h,t.$Hf=N,t.$If=S,t.$Jf=O,t.$Kf=V,t.$Lf=Z,t.$Mf=ee,t.$Nf=$e,t.$Of=ve,t.$Pf=Re;function z(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}const H=/{(\d+)}/g;function A(Y,...se){return se.length===0?Y:Y.replace(H,function(pe,De){const Ie=parseInt(De,10);return isNaN(Ie)||Ie<0||Ie>=se.length?pe:se[Ie]})}const y=/{([^}]+)}/g;function b(Y,se){return Object.keys(se).length===0?Y:Y.replace(y,(pe,De)=>se[De]??pe)}function $(Y){return Y.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}function w(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}function P(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(Y,se){let pe=0;const De=se.charCodeAt(0);for(let Ie=Y.length-1;Ie>=0;Ie--)Y.charCodeAt(Ie)===De&&pe++;return pe}function d(Y,se,pe="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${pe}`}function e(Y,se,pe="\u2026"){if(Y.length<=se)return Y;const De=Math.ceil(se/2)-pe.length/2,Ie=Math.floor(se/2)-pe.length/2;return`${Y.substr(0,De)}${pe}${Y.substr(Y.length-Ie)}`}function s(Y,se=" "){const pe=a(Y,se);return m(pe,se)}function a(Y,se){if(!Y||!se)return Y;const pe=se.length;if(pe===0||Y.length===0)return Y;let De=0;for(;Y.indexOf(se,De)===De;)De=De+pe;return Y.substring(De)}function m(Y,se){if(!Y||!se)return Y;const pe=se.length,De=Y.length;if(pe===0||De===0)return Y;let Ie=De,ze=-1;for(;ze=Y.lastIndexOf(se,Ie-1),!(ze===-1||ze+pe!==Ie);){if(ze===0)return"";Ie=ze}return Y.substring(0,Ie)}function p(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(Y){return Y.replace(/\*/g,"")}function o(Y,se,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=P(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Y,De)}function g(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}function r(Y){return Y.split(/\r\n|\r|\n/)}function E(Y){const se=[],pe=Y.split(/(\r\n|\r|\n)/);for(let De=0;De<Math.ceil(pe.length/2);De++)se.push(pe[2*De]+(pe[2*De+1]??""));return se}function R(Y){for(let se=0,pe=Y.length;se<pe;se++){const De=Y.charCodeAt(se);if(De!==32&&De!==9)return se}return-1}function M(Y,se=0,pe=Y.length){for(let De=se;De<pe;De++){const Ie=Y.charCodeAt(De);if(Ie!==32&&Ie!==9)return Y.substring(se,De)}return Y.substring(se,pe)}function j(Y,se=Y.length-1){for(let pe=se;pe>=0;pe--){const De=Y.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}function B(Y,se,pe){const De=[];let Ie=0;for(const ze of Y.matchAll(se)){if(De.push(Y.slice(Ie,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Ie=ze.index+ze[0].length,De.push(pe(ze[0],...ze.slice(1),ze.index,Y,ze.groups))}return De.push(Y.slice(Ie)),Promise.all(De).then(ze=>ze.join(""))}function D(Y,se){return Y<se?-1:Y>se?1:0}function x(Y,se,pe=0,De=Y.length,Ie=0,ze=se.length){for(;pe<De&&Ie<ze;pe++,Ie++){const tt=Y.charCodeAt(pe),st=se.charCodeAt(Ie);if(tt<st)return-1;if(tt>st)return 1}const Ve=De-pe,_e=ze-Ie;return Ve<_e?-1:Ve>_e?1:0}function W(Y,se){return T(Y,se,0,Y.length,0,se.length)}function T(Y,se,pe=0,De=Y.length,Ie=0,ze=se.length){for(;pe<De&&Ie<ze;pe++,Ie++){let tt=Y.charCodeAt(pe),st=se.charCodeAt(Ie);if(tt===st)continue;if(tt>=128||st>=128)return x(Y.toLowerCase(),se.toLowerCase(),pe,De,Ie,ze);I(tt)&&(tt-=32),I(st)&&(st-=32);const Ze=tt-st;if(Ze!==0)return Ze}const Ve=De-pe,_e=ze-Ie;return Ve<_e?-1:Ve>_e?1:0}function L(Y){return Y>=48&&Y<=57}function I(Y){return Y>=97&&Y<=122}function X(Y){return Y>=65&&Y<=90}function U(Y,se){return Y.length===se.length&&T(Y,se)===0}function de(Y,se){const pe=se.length;return se.length>Y.length?!1:T(Y,se,0,pe)===0}function he(Y,se){const pe=Math.min(Y.length,se.length);let De;for(De=0;De<pe;De++)if(Y.charCodeAt(De)!==se.charCodeAt(De))return De;return pe}function ne(Y,se){const pe=Math.min(Y.length,se.length);let De;const Ie=Y.length-1,ze=se.length-1;for(De=0;De<pe;De++)if(Y.charCodeAt(Ie-De)!==se.charCodeAt(ze-De))return De;return pe}function ge(Y){return 55296<=Y&&Y<=56319}function Ne(Y){return 56320<=Y&&Y<=57343}function Ce(Y,se){return(Y-55296<<10)+(se-56320)+65536}function Pe(Y,se,pe){const De=Y.charCodeAt(pe);if(ge(De)&&pe+1<se){const Ie=Y.charCodeAt(pe+1);if(Ne(Ie))return Ce(De,Ie)}return De}function le(Y,se){const pe=Y.charCodeAt(se-1);if(Ne(pe)&&se>1){const De=Y.charCodeAt(se-2);if(ge(De))return Ce(De,pe)}return pe}class _{get offset(){return this.e}constructor(se,pe=0){this.c=se,this.d=se.length,this.e=pe}setOffset(se){this.e=se}prevCodePoint(){const se=le(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=Pe(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}t.$sf=_;class ae{get offset(){return this.c.offset}constructor(se,pe=0){this.c=new _(se,pe)}nextGraphemeLength(){const se=Se.getInstance(),pe=this.c,De=pe.offset;let Ie=se.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ze=pe.offset,Ve=se.getGraphemeBreakType(pe.nextCodePoint());if(we(Ie,Ve)){pe.setOffset(ze);break}Ie=Ve}return pe.offset-De}prevGraphemeLength(){const se=Se.getInstance(),pe=this.c,De=pe.offset;let Ie=se.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ze=pe.offset,Ve=se.getGraphemeBreakType(pe.prevCodePoint());if(we(Ve,Ie)){pe.setOffset(ze);break}Ie=Ve}return De-pe.offset}eol(){return this.c.eol()}}t.$tf=ae;function oe(Y,se){return new ae(Y,se).nextGraphemeLength()}function J(Y,se){return new ae(Y,se).prevGraphemeLength()}function G(Y,se){se>0&&Ne(Y.charCodeAt(se))&&se--;const pe=se+oe(Y,se);return[pe-J(Y,pe),pe]}function ie(Y){const se=new ae(Y);let pe=0;for(;!se.eol();)pe++,se.nextGraphemeLength();return pe}let ce;function Ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(Y){return ce||(ce=Ae()),ce.test(Y)}const ye=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return ye.test(Y)}t.$Af=/[\u2028\u2029]/;function f(Y){return t.$Af.test(Y)}function k(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}function F(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}function l(Y,se,pe=""){const De=Y.trimStart();if(De.length<se)return De;const Ie=/\b/g;let ze=0;for(;Ie.test(De)&&!(De.length-Ie.lastIndex<se);)ze=Ie.lastIndex,Ie.lastIndex+=1;return ze===0?De:pe+De.substring(ze).trimStart()}const u=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,n=/\x1b\].*?\x07/g;function h(Y){return Y&&(Y=Y.replace(u,"").replace(n,"")),Y}t.$Gf="\uFEFF";function N(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}function S(Y){return N(Y)?Y.substr(1):Y}function O(Y,se){if(!Y||!se||Y.length<se.length)return!1;const pe=se.length,De=Y.toLowerCase();let Ie=0,ze=-1;for(;Ie<pe;){const Ve=De.indexOf(se[Ie],ze+1);if(Ve<0)return!1;ze=Ve,Ie++}return!0}function V(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}function Z(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}function ee(Y,se=1){if(se===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),se--;while(se>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}function $e(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}function ve(Y){return Se.getInstance().getGraphemeBreakType(Y)}function we(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}var je;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(je||(t.GraphemeBreakType=je={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Ee()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const pe=this.d,De=pe.length/3;let Ie=1;for(;Ie<=De;)if(se<pe[3*Ie])Ie=2*Ie;else if(se>pe[3*Ie+1])Ie=2*Ie+1;else return pe[3*Ie+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(Y,se){if(Y===0)return 0;const pe=Le(Y,se);if(pe!==void 0)return pe;const De=new _(se,Y);return De.prevCodePoint(),De.offset}function Le(Y,se){const pe=new _(se,Y);let De=pe.prevCodePoint();for(;Ye(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!F(De))return;let Ie=pe.offset;return Ie>0&&pe.prevCodePoint()===8205&&(Ie=pe.offset),Ie}function Ye(Y){return 127995<=Y&&Y<=127999}var nt;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),t.$Qf="\xA0";class Ge{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Pe(se=>{function pe(Ze){const rt=new Map;for(let et=0;et<Ze.length;et+=2)rt.set(Ze[et],Ze[et+1]);return rt}function De(Ze,rt){const et=new Map(Ze);for(const[mt,gt]of rt)et.set(mt,gt);return et}function Ie(Ze,rt){if(!Ze)return rt;const et=new Map;for(const[mt,gt]of Ze)rt.has(mt)&&et.set(mt,gt);return et}const ze=this.c.value;let Ve=se.filter(Ze=>!Ze.startsWith("_")&&Ze in ze);Ve.length===0&&(Ve=["_default"]);let _e;for(const Ze of Ve){const rt=pe(ze[Ze]);_e=Ie(_e,rt)}const tt=pe(ze._common),st=De(tt,_e);return new Ge(st)})}static getInstance(se){return Ge.d.get(Array.from(se))}static{this.e=new C.$V(()=>Object.keys(Ge.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Rf=Ge;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(se){return Ue.e().has(se)}static get codePoints(){return Ue.e()}}t.$Sf=Ue}),define(me[37],be([1,0,34,83,10]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tk=t.FuzzyScore=t.$ik=t.$hk=void 0,t.or=H,t.$jk=y,t.$kk=b,t.$lk=P,t.$mk=B,t.$nk=D,t.$ok=X,t.$pk=U,t.$qk=de,t.$rk=he,t.$sk=Fe,t.$uk=k,t.$vk=u,t.$wk=n;function H(...S){return function(O,V){for(let Z=0,ee=S.length;Z<ee;Z++){const $e=S[Z](O,V);if($e)return $e}return null}}t.$hk=A.bind(void 0,!1),t.$ik=A.bind(void 0,!0);function A(S,O,V){if(!V||V.length<O.length)return null;let Z;return S?Z=z.$lf(V,O):Z=V.indexOf(O)===0,Z?O.length>0?[{start:0,end:O.length}]:[]:null}function y(S,O){const V=O.toLowerCase().indexOf(S.toLowerCase());return V===-1?null:[{start:V,end:V+S.length}]}function b(S,O){return $(S.toLowerCase(),O.toLowerCase(),0,0)}function $(S,O,V,Z){if(V===S.length)return[];if(Z===O.length)return null;if(S[V]===O[Z]){let ee=null;return(ee=$(S,O,V+1,Z+1))?o({start:Z,end:Z+1},ee):null}return $(S,O,V,Z+1)}function w(S){return 97<=S&&S<=122}function P(S){return 65<=S&&S<=90}function c(S){return 48<=S&&S<=57}function d(S){return S===32||S===9||S===10||S===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>e.add(S.charCodeAt(0)));function s(S){return d(S)||e.has(S)}function a(S,O){return S===O||s(S)&&s(O)}const m=new Map;function p(S){if(m.has(S))return m.get(S);let O;const V=(0,C.$fk)(S);return V&&(O=V),m.set(S,O),O}function v(S){return w(S)||P(S)||c(S)}function o(S,O){return O.length===0?O=[S]:S.end===O[0].start?O[0].start=S.start:O.unshift(S),O}function g(S,O){for(let V=O;V<S.length;V++){const Z=S.charCodeAt(V);if(P(Z)||c(Z)||V>0&&!v(S.charCodeAt(V-1)))return V}return S.length}function r(S,O,V,Z){if(V===S.length)return[];if(Z===O.length)return null;if(S[V]!==O[Z].toLowerCase())return null;{let ee=null,$e=Z+1;for(ee=r(S,O,V+1,Z+1);!ee&&($e=g(O,$e))<O.length;)ee=r(S,O,V+1,$e),$e++;return ee===null?null:o({start:Z,end:Z+1},ee)}}function E(S){let O=0,V=0,Z=0,ee=0,$e=0;for(let Ee=0;Ee<S.length;Ee++)$e=S.charCodeAt(Ee),P($e)&&O++,w($e)&&V++,v($e)&&Z++,c($e)&&ee++;const ve=O/S.length,we=V/S.length,je=Z/S.length,Se=ee/S.length;return{upperPercent:ve,lowerPercent:we,alphaPercent:je,numericPercent:Se}}function R(S){const{upperPercent:O,lowerPercent:V}=S;return V===0&&O>.6}function M(S){const{upperPercent:O,lowerPercent:V,alphaPercent:Z,numericPercent:ee}=S;return V>.2&&O<.8&&Z>.6&&ee<.2}function j(S){let O=0,V=0,Z=0,ee=0;for(let $e=0;$e<S.length;$e++)Z=S.charCodeAt($e),P(Z)&&O++,w(Z)&&V++,d(Z)&&ee++;return(O===0||V===0)&&ee===0?S.length<=30:O<=5}function B(S,O){if(!O||(O=O.trim(),O.length===0)||!j(S))return null;O.length>60&&(O=O.substring(0,60));const V=E(O);if(!M(V)){if(!R(V))return null;O=O.toLowerCase()}let Z=null,ee=0;for(S=S.toLowerCase();ee<O.length&&(Z=r(S,O,0,ee))===null;)ee=g(O,ee+1);return Z}function D(S,O,V=!1){if(!O||O.length===0)return null;let Z=null,ee=0;for(S=S.toLowerCase(),O=O.toLowerCase();ee<O.length&&(Z=x(S,O,0,ee,V),Z===null);)ee=W(O,ee+1);return Z}function x(S,O,V,Z,ee){let $e=0;if(V===S.length)return[];if(Z===O.length)return null;if(!a(S.charCodeAt(V),O.charCodeAt(Z))){const je=p(S.charCodeAt(V));if(!je)return null;for(let Se=0;Se<je.length;Se++)if(!a(je[Se],O.charCodeAt(Z+Se)))return null;$e+=je.length-1}let ve=null,we=Z+$e+1;if(ve=x(S,O,V+1,we,ee),!ee)for(;!ve&&(we=W(O,we))<O.length;)ve=x(S,O,V+1,we,ee),we++;if(!ve)return null;if(S.charCodeAt(V)!==O.charCodeAt(Z)){const je=p(S.charCodeAt(V));if(!je)return ve;for(let Se=0;Se<je.length;Se++)if(je[Se]!==O.charCodeAt(Z+Se))return ve}return o({start:Z,end:Z+$e+1},ve)}function W(S,O){for(let V=O;V<S.length;V++)if(s(S.charCodeAt(V))||V>0&&s(S.charCodeAt(V-1)))return V;return S.length}const T=H(t.$ik,B,y),L=H(t.$ik,B,b),I=new i.$Dc(1e4);function X(S,O,V=!1){if(typeof S!="string"||typeof O!="string")return null;let Z=I.get(S);Z||(Z=new RegExp(z.$6e(S),"i"),I.set(S,Z));const ee=Z.exec(O);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:V?L(S,O):T(S,O)}function U(S,O){const V=k(S,S.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?he(V):null}function de(S,O,V,Z,ee,$e){const ve=Math.min(13,S.length);for(;V<ve;V++){const we=k(S,O,V,Z,ee,$e,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,$e]}function he(S){if(typeof S>"u")return[];const O=[],V=S[1];for(let Z=S.length-1;Z>1;Z--){const ee=S[Z]+V,$e=O[O.length-1];$e&&$e.end===ee?$e.end=ee+1:O.push({start:ee,end:ee+1})}return O}const ne=128;function ge(){const S=[],O=[];for(let V=0;V<=ne;V++)O[V]=0;for(let V=0;V<=ne;V++)S.push(O.slice(0));return S}function Ne(S){const O=[];for(let V=0;V<=S;V++)O[V]=0;return O}const Ce=Ne(2*ne),Pe=Ne(2*ne),le=ge(),_=ge(),ae=ge(),oe=!1;function J(S,O,V,Z,ee){function $e(we,je,Se=" "){for(;we.length<je;)we=Se+we;return we}let ve=` |   |${Z.split("").map(we=>$e(we,3)).join("|")}
`;for(let we=0;we<=V;we++)we===0?ve+=" |":ve+=`${O[we-1]}|`,ve+=S[we].slice(0,ee+1).map(je=>$e(je.toString(),3)).join("|")+`
`;return ve}function G(S,O,V,Z){S=S.substr(O),V=V.substr(Z),console.log(J(_,S,S.length,V,V.length)),console.log(J(ae,S,S.length,V,V.length)),console.log(J(le,S,S.length,V,V.length))}function ie(S,O){if(O<0||O>=S.length)return!1;const V=S.codePointAt(O);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!z.$Df(V)}}function ce(S,O){if(O<0||O>=S.length)return!1;switch(S.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function Ae(S,O,V){return O[S]!==V[S]}function Fe(S,O,V,Z,ee,$e,ve=!1){for(;O<V&&ee<$e;)S[O]===Z[ee]&&(ve&&(Ce[O]=ee),O+=1),ee+=1;return O===V}var ye;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var K;(function(S){S.Default=[-100,0];function O(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}S.isDefault=O})(K||(t.FuzzyScore=K={}));class f{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(O,V){this.firstMatchCanBeWeak=O,this.boostFullMatch=V}}t.$tk=f;function k(S,O,V,Z,ee,$e,ve=f.default){const we=S.length>ne?ne:S.length,je=Z.length>ne?ne:Z.length;if(V>=we||$e>=je||we-V>je-$e||!Fe(O,V,we,ee,$e,je,!0))return;F(we,je,V,$e,O,ee);let Se=1,Ee=1,Re=V,Le=$e;const Ye=[!1];for(Se=1,Re=V;Re<we;Se++,Re++){const se=Ce[Re],pe=Pe[Re],De=Re+1<we?Pe[Re+1]:je;for(Ee=se-$e+1,Le=se;Le<De;Ee++,Le++){let Ie=Number.MIN_SAFE_INTEGER,ze=!1;Le<=pe&&(Ie=l(S,O,Re,V,Z,ee,Le,je,$e,le[Se-1][Ee-1]===0,Ye));let Ve=0;Ie!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ve=Ie+_[Se-1][Ee-1]);const _e=Le>se,tt=_e?_[Se][Ee-1]+(le[Se][Ee-1]>0?-5:0):0,st=Le>se+1&&le[Se][Ee-1]>0,Ze=st?_[Se][Ee-2]+(le[Se][Ee-2]>0?-5:0):0;if(st&&(!_e||Ze>=tt)&&(!ze||Ze>=Ve))_[Se][Ee]=Ze,ae[Se][Ee]=3,le[Se][Ee]=0;else if(_e&&(!ze||tt>=Ve))_[Se][Ee]=tt,ae[Se][Ee]=2,le[Se][Ee]=0;else if(ze)_[Se][Ee]=Ve,ae[Se][Ee]=1,le[Se][Ee]=le[Se-1][Ee-1]+1;else throw new Error("not possible")}}if(oe&&G(S,V,Z,$e),!Ye[0]&&!ve.firstMatchCanBeWeak)return;Se--,Ee--;const nt=[_[Se][Ee],$e];let Ge=0,Ue=0;for(;Se>=1;){let se=Ee;do{const pe=ae[Se][se];if(pe===3)se=se-2;else if(pe===2)se=se-1;else break}while(se>=1);Ge>1&&O[V+Se-1]===ee[$e+Ee-1]&&!Ae(se+$e-1,Z,ee)&&Ge+1>le[Se][se]&&(se=Ee),se===Ee?Ge++:Ge=1,Ue||(Ue=se),Se--,Ee=se-1,nt.push(Ee)}je===we&&ve.boostFullMatch&&(nt[0]+=2);const Y=Ue-we;return nt[0]-=Y,nt}function F(S,O,V,Z,ee,$e){let ve=S-1,we=O-1;for(;ve>=V&&we>=Z;)ee[ve]===$e[we]&&(Pe[ve]=we,ve--),we--}function l(S,O,V,Z,ee,$e,ve,we,je,Se,Ee){if(O[V]!==$e[ve])return Number.MIN_SAFE_INTEGER;let Re=1,Le=!1;return ve===V-Z?Re=S[V]===ee[ve]?7:5:Ae(ve,ee,$e)&&(ve===0||!Ae(ve-1,ee,$e))?(Re=S[V]===ee[ve]?7:5,Le=!0):ie($e,ve)&&(ve===0||!ie($e,ve-1))?Re=5:(ie($e,ve-1)||ce($e,ve-1))&&(Re=5,Le=!0),Re>1&&V===Z&&(Ee[0]=!0),Le||(Le=Ae(ve,ee,$e)||ie($e,ve-1)||ce($e,ve-1)),V===Z?ve>je&&(Re-=Le?3:5):Se?Re+=Le?2:0:Re+=Le?0:1,ve+1===we&&(Re-=Le?3:5),Re}function u(S,O,V,Z,ee,$e,ve){return h(S,O,V,Z,ee,$e,!0,ve)}function n(S,O,V,Z,ee,$e,ve){return h(S,O,V,Z,ee,$e,!1,ve)}function h(S,O,V,Z,ee,$e,ve,we){let je=k(S,O,V,Z,ee,$e,we);if(je&&!ve)return je;if(S.length>=3){const Se=Math.min(7,S.length-1);for(let Ee=V+1;Ee<Se;Ee++){const Re=N(S,Ee);if(Re){const Le=k(Re,Re.toLowerCase(),V,Z,ee,$e,we);Le&&(Le[0]-=3,(!je||Le[0]>je[0])&&(je=Le))}}}return je}function N(S,O){if(O+1>=S.length)return;const V=S[O],Z=S[O+1];if(V!==Z)return S.slice(0,O)+Z+V+S.slice(O+2)}}),define(me[52],be([1,0,10]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aj=t.$$i=void 0,t.$7i=C,t.$8i=z,t.$9i=H,t.$0i=y,t.$_i=s;function C(m){return z(m,0)}function z(m,p){switch(typeof m){case"object":return m===null?H(349,p):Array.isArray(m)?b(m,p):$(m,p);case"string":return y(m,p);case"boolean":return A(m,p);case"number":return H(m,p);case"undefined":return H(937,p);default:return H(617,p)}}function H(m,p){return(p<<5)-p+m|0}function A(m,p){return H(m?433:863,p)}function y(m,p){p=H(149417,p);for(let v=0,o=m.length;v<o;v++)p=H(m.charCodeAt(v),p);return p}function b(m,p){return p=H(104579,p),m.reduce((v,o)=>z(o,v),p)}function $(m,p){return p=H(181387,p),Object.keys(m).sort().reduce((v,o)=>(v=y(o,v),z(m[o],v)),p)}class w{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=z(p,this.g),this.g}}t.$$i=w;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(m,p,v=32){const o=v-p,g=~((1<<o)-1);return(m<<p|(g&m)>>>o)>>>0}function d(m,p=0,v=m.byteLength,o=0){for(let g=0;g<v;g++)m[p+g]=o}function e(m,p,v="0"){for(;m.length<p;)m=v+m;return m}function s(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),p/4)}class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const v=p.length;if(v===0)return;const o=this.p;let g=this.r,r=this.u,E,R;for(r!==0?(E=r,R=-1,r=0):(E=p.charCodeAt(0),R=0);;){let M=E;if(i.$of(E))if(R+1<v){const j=p.charCodeAt(R+1);i.$pf(j)?(R++,M=i.$qf(E,j)):M=65533}else{r=E;break}else i.$pf(E)&&(M=65533);if(g=this.w(o,g,M),R++,R<v)E=p.charCodeAt(R);else break}this.r=g,this.u=r}w(p,v,o){return o<128?p[v++]=o:o<2048?(p[v++]=192|(o&1984)>>>6,p[v++]=128|(o&63)>>>0):o<65536?(p[v++]=224|(o&61440)>>>12,p[v++]=128|(o&4032)>>>6,p[v++]=128|(o&63)>>>0):(p[v++]=240|(o&1835008)>>>18,p[v++]=128|(o&258048)>>>12,p[v++]=128|(o&4032)>>>6,p[v++]=128|(o&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=a.g,v=this.q;for(let D=0;D<64;D+=4)p.setUint32(D,v.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)p.setUint32(D,c(p.getUint32(D-12,!1)^p.getUint32(D-32,!1)^p.getUint32(D-56,!1)^p.getUint32(D-64,!1),1),!1);let o=this.h,g=this.l,r=this.m,E=this.n,R=this.o,M,j,B;for(let D=0;D<80;D++)D<20?(M=g&r|~g&E,j=1518500249):D<40?(M=g^r^E,j=1859775393):D<60?(M=g&r|g&E|r&E,j=2400959708):(M=g^r^E,j=3395469782),B=c(o,5)+M+R+j+p.getUint32(D*4,!1)&4294967295,R=E,E=r,r=c(g,30),g=o,o=B;this.h=this.h+o&4294967295,this.l=this.l+g&4294967295,this.m=this.m+r&4294967295,this.n=this.n+E&4294967295,this.o=this.o+R&4294967295}}t.$aj=a}),define(me[90],be([1,0,78,52]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.$ct=void 0,t.$dt=H;class z{constructor(c){this.a=c}getElements(){const c=this.a,d=new Int32Array(c.length);for(let e=0,s=c.length;e<s;e++)d[e]=c.charCodeAt(e);return d}}t.$ct=z;function H(P,c,d){return new w(new z(P),new z(c)).ComputeDiff(d).changes}class A{static Assert(c,d){if(!c)throw new Error(d)}}class y{static Copy(c,d,e,s,a){for(let m=0;m<a;m++)e[s+m]=c[d+m]}static Copy2(c,d,e,s,a){for(let m=0;m<a;m++)e[s+m]=c[d+m]}}var b;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class ${constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$bt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,d){this.b=Math.min(this.b,c),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(c,d){this.b=Math.min(this.b,c),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(c,d,e=null){this.a=e,this.b=c,this.c=d;const[s,a,m]=w.o(c),[p,v,o]=w.o(d);this.d=m&&o,this.e=s,this.f=a,this.g=p,this.h=v,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const d=c.getElements();if(w.n(d)){const e=new Int32Array(d.length);for(let s=0,a=d.length;s<a;s++)e[s]=(0,C.$0i)(d[s],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(c,d){return this.f[c]!==this.h[d]?!1:this.d?this.e[c]===this.g[d]:!0}q(c,d){if(!this.p(c,d))return!1;const e=w.r(this.b,c),s=w.r(this.c,d);return e===s}static r(c,d){return typeof c.getStrictElement=="function"?c.getStrictElement(d):null}s(c,d){return this.f[c]!==this.f[d]?!1:this.d?this.e[c]===this.e[d]:!0}u(c,d){return this.h[c]!==this.h[d]?!1:this.d?this.g[c]===this.g[d]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,d,e,s,a){const m=[!1];let p=this.w(c,d,e,s,m);return a&&(p=this.z(p)),{quitEarly:m[0],changes:p}}w(c,d,e,s,a){for(a[0]=!1;c<=d&&e<=s&&this.p(c,e);)c++,e++;for(;d>=c&&s>=e&&this.p(d,s);)d--,s--;if(c>d||e>s){let r;return e<=s?(A.Assert(c===d+1,"originalStart should only be one more than originalEnd"),r=[new i.$bt(c,0,e,s-e+1)]):c<=d?(A.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$bt(c,d-c+1,e,0)]):(A.Assert(c===d+1,"originalStart should only be one more than originalEnd"),A.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const m=[0],p=[0],v=this.y(c,d,e,s,m,p,a),o=m[0],g=p[0];if(v!==null)return v;if(!a[0]){const r=this.w(c,o,e,g,a);let E=[];return a[0]?E=[new i.$bt(o+1,d-(o+1)+1,g+1,s-(g+1)+1)]:E=this.w(o+1,d,g+1,s,a),this.H(r,E)}return[new i.$bt(c,d-c+1,e,s-e+1)]}x(c,d,e,s,a,m,p,v,o,g,r,E,R,M,j,B,D,x){let W=null,T=null,L=new $,I=d,X=e,U=R[0]-B[0]-s,de=-1073741824,he=this.k.length-1;do{const ne=U+c;ne===I||ne<X&&o[ne-1]<o[ne+1]?(r=o[ne+1],M=r-U-s,r<de&&L.MarkNextChange(),de=r,L.AddModifiedElement(r+1,M),U=ne+1-c):(r=o[ne-1]+1,M=r-U-s,r<de&&L.MarkNextChange(),de=r-1,L.AddOriginalElement(r,M+1),U=ne-1-c),he>=0&&(o=this.k[he],c=o[0],I=1,X=o.length-1)}while(--he>=-1);if(W=L.getReverseChanges(),x[0]){let ne=R[0]+1,ge=B[0]+1;if(W!==null&&W.length>0){const Ne=W[W.length-1];ne=Math.max(ne,Ne.getOriginalEnd()),ge=Math.max(ge,Ne.getModifiedEnd())}T=[new i.$bt(ne,E-ne+1,ge,j-ge+1)]}else{L=new $,I=m,X=p,U=R[0]-B[0]-v,de=1073741824,he=D?this.m.length-1:this.m.length-2;do{const ne=U+a;ne===I||ne<X&&g[ne-1]>=g[ne+1]?(r=g[ne+1]-1,M=r-U-v,r>de&&L.MarkNextChange(),de=r+1,L.AddOriginalElement(r+1,M+1),U=ne+1-a):(r=g[ne-1],M=r-U-v,r>de&&L.MarkNextChange(),de=r,L.AddModifiedElement(r+1,M+1),U=ne-1-a),he>=0&&(g=this.m[he],a=g[0],I=1,X=g.length-1)}while(--he>=-1);T=L.getChanges()}return this.H(W,T)}y(c,d,e,s,a,m,p){let v=0,o=0,g=0,r=0,E=0,R=0;c--,e--,a[0]=0,m[0]=0,this.k=[],this.m=[];const M=d-c+(s-e),j=M+1,B=new Int32Array(j),D=new Int32Array(j),x=s-e,W=d-c,T=c-e,L=d-s,X=(W-x)%2===0;B[x]=c,D[W]=d,p[0]=!1;for(let U=1;U<=M/2+1;U++){let de=0,he=0;g=this.J(x-U,U,x,j),r=this.J(x+U,U,x,j);for(let ge=g;ge<=r;ge+=2){ge===g||ge<r&&B[ge-1]<B[ge+1]?v=B[ge+1]:v=B[ge-1]+1,o=v-(ge-x)-T;const Ne=v;for(;v<d&&o<s&&this.p(v+1,o+1);)v++,o++;if(B[ge]=v,v+o>de+he&&(de=v,he=o),!X&&Math.abs(ge-W)<=U-1&&v>=D[ge])return a[0]=v,m[0]=o,Ne<=D[ge]&&1447>0&&U<=1448?this.x(x,g,r,T,W,E,R,L,B,D,v,d,a,o,s,m,X,p):null}const ne=(de-c+(he-e)-U)/2;if(this.a!==null&&!this.a(de,ne))return p[0]=!0,a[0]=de,m[0]=he,ne>0&&1447>0&&U<=1448?this.x(x,g,r,T,W,E,R,L,B,D,v,d,a,o,s,m,X,p):(c++,e++,[new i.$bt(c,d-c+1,e,s-e+1)]);E=this.J(W-U,U,W,j),R=this.J(W+U,U,W,j);for(let ge=E;ge<=R;ge+=2){ge===E||ge<R&&D[ge-1]>=D[ge+1]?v=D[ge+1]-1:v=D[ge-1],o=v-(ge-W)-L;const Ne=v;for(;v>c&&o>e&&this.p(v,o);)v--,o--;if(D[ge]=v,X&&Math.abs(ge-x)<=U&&v<=B[ge])return a[0]=v,m[0]=o,Ne>=B[ge]&&1447>0&&U<=1448?this.x(x,g,r,T,W,E,R,L,B,D,v,d,a,o,s,m,X,p):null}if(U<=1447){let ge=new Int32Array(r-g+2);ge[0]=x-g+1,y.Copy2(B,g,ge,1,r-g+1),this.k.push(ge),ge=new Int32Array(R-E+2),ge[0]=W-E+1,y.Copy2(D,E,ge,1,R-E+1),this.m.push(ge)}}return this.x(x,g,r,T,W,E,R,L,B,D,v,d,a,o,s,m,X,p)}z(c){for(let d=0;d<c.length;d++){const e=c[d],s=d<c.length-1?c[d+1].originalStart:this.f.length,a=d<c.length-1?c[d+1].modifiedStart:this.h.length,m=e.originalLength>0,p=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<a&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!p||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const v=[null];if(d<c.length-1&&this.I(c[d],c[d+1],v)){c[d]=v[0],c.splice(d+1,1),d--;continue}}for(let d=c.length-1;d>=0;d--){const e=c[d];let s=0,a=0;if(d>0){const r=c[d-1];s=r.originalStart+r.originalLength,a=r.modifiedStart+r.modifiedLength}const m=e.originalLength>0,p=e.modifiedLength>0;let v=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const E=e.originalStart-r,R=e.modifiedStart-r;if(E<s||R<a||m&&!this.s(E,E+e.originalLength)||p&&!this.u(R,R+e.modifiedLength))break;const j=(E===s&&R===a?5:0)+this.G(E,e.originalLength,R,e.modifiedLength);j>o&&(o=j,v=r)}e.originalStart-=v,e.modifiedStart-=v;const g=[null];if(d>0&&this.I(c[d-1],c[d],g)){c[d-1]=g[0],c.splice(d,1),d++;continue}}if(this.d)for(let d=1,e=c.length;d<e;d++){const s=c[d-1],a=c[d],m=a.originalStart-s.originalStart-s.originalLength,p=s.originalStart,v=a.originalStart+a.originalLength,o=v-p,g=s.modifiedStart,r=a.modifiedStart+a.modifiedLength,E=r-g;if(m<5&&o<20&&E<20){const R=this.A(p,o,g,E,m);if(R){const[M,j]=R;(M!==s.originalStart+s.originalLength||j!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=M-s.originalStart,s.modifiedLength=j-s.modifiedStart,a.originalStart=M+m,a.modifiedStart=j+m,a.originalLength=v-a.originalStart,a.modifiedLength=r-a.modifiedStart)}}}return c}A(c,d,e,s,a){if(d<a||s<a)return null;const m=c+d-a+1,p=e+s-a+1;let v=0,o=0,g=0;for(let r=c;r<m;r++)for(let E=e;E<p;E++){const R=this.B(r,E,a);R>0&&R>v&&(v=R,o=r,g=E)}return v>0?[o,g]:null}B(c,d,e){let s=0;for(let a=0;a<e;a++){if(!this.p(c+a,d+a))return 0;s+=this.e[c+a].length}return s}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,d){if(this.C(c)||this.C(c-1))return!0;if(d>0){const e=c+d;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,d){if(this.E(c)||this.E(c-1))return!0;if(d>0){const e=c+d;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,d,e,s){const a=this.D(c,d)?1:0,m=this.F(e,s)?1:0;return a+m}H(c,d){const e=[];if(c.length===0||d.length===0)return d.length>0?d:c;if(this.I(c[c.length-1],d[0],e)){const s=new Array(c.length+d.length-1);return y.Copy(c,0,s,0,c.length-1),s[c.length-1]=e[0],y.Copy(d,1,s,c.length,d.length-1),s}else{const s=new Array(c.length+d.length);return y.Copy(c,0,s,0,c.length),y.Copy(d,0,s,c.length,d.length),s}}I(c,d,e){if(A.Assert(c.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),A.Assert(c.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=d.originalStart||c.modifiedStart+c.modifiedLength>=d.modifiedStart){const s=c.originalStart;let a=c.originalLength;const m=c.modifiedStart;let p=c.modifiedLength;return c.originalStart+c.originalLength>=d.originalStart&&(a=d.originalStart+d.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=d.modifiedStart&&(p=d.modifiedStart+d.modifiedLength-c.modifiedStart),e[0]=new i.$bt(s,a,m,p),!0}else return e[0]=null,!1}J(c,d,e,s){if(c>=0&&c<s)return c;const a=e,m=s-e-1,p=d%2===0;if(c<0){const v=a%2===0;return p===v?0:1}else{const v=m%2===0;return p===v?s-1:s-2}}}t.$et=w}),define(me[53],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0,t.$3d=Symbol("MicrotaskDelay")}),define(me[91],be([1,0,12,10]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mi=t.$li=t.$ki=t.$ji=t.$ii=void 0;class z{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const e=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$ii=z;class H{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,C.$ef)(d,this.b,0,d.length,this.c,this.d):(0,C.$gf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$ji=H;class A{constructor(d=!0,e=!0){this.f=d,this.g=e}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let e=d.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,C.$ef)(d,this.b,0,d.length,this.d,this.e):(0,C.$gf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$ki=A;var y;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(y||(y={}));class b{constructor(d,e){this.f=d,this.g=e,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,C.$ff)(d,this.c.scheme);if(this.d[this.e]===2)return(0,C.$ff)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,C.$df)(d,this.c.query);if(this.d[this.e]===5)return(0,C.$df)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$li=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(w||(w={}));class P{static forUris(d=()=>!1,e=()=>!1){return new P(new b(d,e))}static forPaths(d=!1){return new P(new A(void 0,!d))}static forStrings(){return new P(new z)}static forConfigKeys(){return new P(new H)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,e){if(e){const s=e.slice(0);(0,i.$Xb)(s);for(const a of s)this.set(a,d)}else{const s=d.slice(0);(0,i.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(d,e){const s=this.b.reset(d);let a;this.c||(this.c=new $,this.c.segment=s.value());const m=[];for(a=this.c;;){const v=s.cmp(a.segment);if(v>0)a.left||(a.left=new $,a.left.segment=s.value()),m.push([-1,a]),a=a.left;else if(v<0)a.right||(a.right=new $,a.right.segment=s.value()),m.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new $,a.mid.segment=s.value()),m.push([0,a]),a=a.mid;else break}const p=a.value;a.value=e,a.key=d;for(let v=m.length-1;v>=0;v--){const o=m[v][1];o.updateHeight();const g=o.balanceFactor();if(g<-1||g>1){const r=m[v][0],E=m[v+1][0];if(r===1&&E===1)m[v][1]=o.rotateLeft();else if(r===-1&&E===-1)m[v][1]=o.rotateRight();else if(r===1&&E===-1)o.right=m[v+1][1]=m[v+1][1].rotateRight(),m[v][1]=o.rotateLeft();else if(r===-1&&E===1)o.left=m[v+1][1]=m[v+1][1].rotateLeft(),m[v][1]=o.rotateRight();else throw new Error;if(v>0)switch(m[v-1][0]){case-1:m[v-1][1].left=m[v][1];break;case 1:m[v-1][1].right=m[v][1];break;case 0:m[v-1][1].mid=m[v][1];break}else this.c=m[0][1]}}return p}get(d){return this.d(d)?.value}d(d){const e=this.b.reset(d);let s=this.c;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(d){const e=this.d(d);return!(e?.value===void 0&&e?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,e){const s=this.b.reset(d),a=[];let m=this.c;for(;m;){const p=s.cmp(m.segment);if(p>0)a.push([-1,m]),m=m.left;else if(p<0)a.push([1,m]),m=m.right;else if(s.hasNext())s.next(),a.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this.f(m.right);if(p.key){const{key:v,value:o,segment:g}=p;this.e(p.key,!1),m.key=v,m.value=o,m.segment=g}}else{const p=m.left??m.right;if(a.length>0){const[v,o]=a[a.length-1];switch(v){case-1:o.left=p;break;case 0:o.mid=p;break;case 1:o.right=p;break}}else this.c=p}for(let p=a.length-1;p>=0;p--){const v=a[p][1];v.updateHeight();const o=v.balanceFactor();if(o>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),a[p][1]=v.rotateLeft()):o<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),a[p][1]=v.rotateRight()),p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const e=this.b.reset(d);let s=this.c,a;for(;s;){const m=e.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(e.hasNext())e.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(d){return this.g(d,!1)}g(d,e){const s=this.b.reset(d);let a=this.c;for(;a;){const m=s.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):e?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[e,s]of this)d(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const e=[];return this.j(d,e),e[Symbol.iterator]()}j(d,e){d&&(d.left&&this.j(d.left,e),d.value&&e.push([d.key,d.value]),d.mid&&this.j(d.mid,e),d.right&&this.j(d.right,e))}_isBalanced(){const d=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:d(e.left)&&d(e.right)};return d(this.c)}}t.$mi=P}),define(me[7],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=i,t.$Uf=C,t.$Vf=z,t.$Wf=H,t.$Xf=A,t.$Yf=y,t.$Zf=b,t.$1f=$,t.$2f=w,t.$3f=P,t.$4f=c,t.$5f=d,t.$6f=e,t.$7f=a,t.$8f=m,t.$9f=p,t.$0f=v,t.$$f=o;function i(g){return typeof g=="string"}function C(g){return Array.isArray(g)&&g.every(r=>i(r))}function z(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}function H(g){const r=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof r}function A(g){return typeof g=="number"&&!isNaN(g)}function y(g){return!!g&&typeof g[Symbol.iterator]=="function"}function b(g){return g===!0||g===!1}function $(g){return typeof g>"u"}function w(g){return!P(g)}function P(g){return $(g)||g===null}function c(g,r){if(!g)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function d(g){if(P(g))throw new Error("Assertion Failed: argument is undefined or null");return g}function e(...g){const r=[];for(let E=0;E<g.length;E++){const R=g[E];if(P(R))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);r.push(R)}return r}const s=Object.prototype.hasOwnProperty;function a(g){if(!z(g))return!1;for(const r in g)if(s.call(g,r))return!1;return!0}function m(g){return typeof g=="function"}function p(...g){return g.length>0&&g.every(m)}function v(g,r){const E=Math.min(g.length,r.length);for(let R=0;R<E;R++)o(g[R],r[R])}function o(g,r){if(i(r)){if(typeof g!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(m(r)){try{if(g instanceof r)return}catch{}if(!P(g)&&g.constructor===r||r.length===1&&r.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[38],be([1,0,7]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=z,t.$Bj=H;const C=Object.create(null);function z(A,y){if((0,i.$Tf)(y)){const b=C[y];if(b===void 0)throw new Error(`${A} references an unknown codicon: ${y}`);y=b}return C[A]=y,{id:A}}function H(){return C}}),define(me[92],be([1,0,38]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=void 0,t.$Cj={add:(0,i.$Aj)("add",6e4),plus:(0,i.$Aj)("plus",6e4),gistNew:(0,i.$Aj)("gist-new",6e4),repoCreate:(0,i.$Aj)("repo-create",6e4),lightbulb:(0,i.$Aj)("lightbulb",60001),lightBulb:(0,i.$Aj)("light-bulb",60001),repo:(0,i.$Aj)("repo",60002),repoDelete:(0,i.$Aj)("repo-delete",60002),gistFork:(0,i.$Aj)("gist-fork",60003),repoForked:(0,i.$Aj)("repo-forked",60003),gitPullRequest:(0,i.$Aj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Aj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Aj)("record-keys",60005),keyboard:(0,i.$Aj)("keyboard",60005),tag:(0,i.$Aj)("tag",60006),gitPullRequestLabel:(0,i.$Aj)("git-pull-request-label",60006),tagAdd:(0,i.$Aj)("tag-add",60006),tagRemove:(0,i.$Aj)("tag-remove",60006),person:(0,i.$Aj)("person",60007),personFollow:(0,i.$Aj)("person-follow",60007),personOutline:(0,i.$Aj)("person-outline",60007),personFilled:(0,i.$Aj)("person-filled",60007),gitBranch:(0,i.$Aj)("git-branch",60008),gitBranchCreate:(0,i.$Aj)("git-branch-create",60008),gitBranchDelete:(0,i.$Aj)("git-branch-delete",60008),sourceControl:(0,i.$Aj)("source-control",60008),mirror:(0,i.$Aj)("mirror",60009),mirrorPublic:(0,i.$Aj)("mirror-public",60009),star:(0,i.$Aj)("star",60010),starAdd:(0,i.$Aj)("star-add",60010),starDelete:(0,i.$Aj)("star-delete",60010),starEmpty:(0,i.$Aj)("star-empty",60010),comment:(0,i.$Aj)("comment",60011),commentAdd:(0,i.$Aj)("comment-add",60011),alert:(0,i.$Aj)("alert",60012),warning:(0,i.$Aj)("warning",60012),search:(0,i.$Aj)("search",60013),searchSave:(0,i.$Aj)("search-save",60013),logOut:(0,i.$Aj)("log-out",60014),signOut:(0,i.$Aj)("sign-out",60014),logIn:(0,i.$Aj)("log-in",60015),signIn:(0,i.$Aj)("sign-in",60015),eye:(0,i.$Aj)("eye",60016),eyeUnwatch:(0,i.$Aj)("eye-unwatch",60016),eyeWatch:(0,i.$Aj)("eye-watch",60016),circleFilled:(0,i.$Aj)("circle-filled",60017),primitiveDot:(0,i.$Aj)("primitive-dot",60017),closeDirty:(0,i.$Aj)("close-dirty",60017),debugBreakpoint:(0,i.$Aj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Aj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Aj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Aj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Aj)("primitive-square",60018),edit:(0,i.$Aj)("edit",60019),pencil:(0,i.$Aj)("pencil",60019),info:(0,i.$Aj)("info",60020),issueOpened:(0,i.$Aj)("issue-opened",60020),gistPrivate:(0,i.$Aj)("gist-private",60021),gitForkPrivate:(0,i.$Aj)("git-fork-private",60021),lock:(0,i.$Aj)("lock",60021),mirrorPrivate:(0,i.$Aj)("mirror-private",60021),close:(0,i.$Aj)("close",60022),removeClose:(0,i.$Aj)("remove-close",60022),x:(0,i.$Aj)("x",60022),repoSync:(0,i.$Aj)("repo-sync",60023),sync:(0,i.$Aj)("sync",60023),clone:(0,i.$Aj)("clone",60024),desktopDownload:(0,i.$Aj)("desktop-download",60024),beaker:(0,i.$Aj)("beaker",60025),microscope:(0,i.$Aj)("microscope",60025),vm:(0,i.$Aj)("vm",60026),deviceDesktop:(0,i.$Aj)("device-desktop",60026),file:(0,i.$Aj)("file",60027),fileText:(0,i.$Aj)("file-text",60027),more:(0,i.$Aj)("more",60028),ellipsis:(0,i.$Aj)("ellipsis",60028),kebabHorizontal:(0,i.$Aj)("kebab-horizontal",60028),mailReply:(0,i.$Aj)("mail-reply",60029),reply:(0,i.$Aj)("reply",60029),organization:(0,i.$Aj)("organization",60030),organizationFilled:(0,i.$Aj)("organization-filled",60030),organizationOutline:(0,i.$Aj)("organization-outline",60030),newFile:(0,i.$Aj)("new-file",60031),fileAdd:(0,i.$Aj)("file-add",60031),newFolder:(0,i.$Aj)("new-folder",60032),fileDirectoryCreate:(0,i.$Aj)("file-directory-create",60032),trash:(0,i.$Aj)("trash",60033),trashcan:(0,i.$Aj)("trashcan",60033),history:(0,i.$Aj)("history",60034),clock:(0,i.$Aj)("clock",60034),folder:(0,i.$Aj)("folder",60035),fileDirectory:(0,i.$Aj)("file-directory",60035),symbolFolder:(0,i.$Aj)("symbol-folder",60035),logoGithub:(0,i.$Aj)("logo-github",60036),markGithub:(0,i.$Aj)("mark-github",60036),github:(0,i.$Aj)("github",60036),terminal:(0,i.$Aj)("terminal",60037),console:(0,i.$Aj)("console",60037),repl:(0,i.$Aj)("repl",60037),zap:(0,i.$Aj)("zap",60038),symbolEvent:(0,i.$Aj)("symbol-event",60038),error:(0,i.$Aj)("error",60039),stop:(0,i.$Aj)("stop",60039),variable:(0,i.$Aj)("variable",60040),symbolVariable:(0,i.$Aj)("symbol-variable",60040),array:(0,i.$Aj)("array",60042),symbolArray:(0,i.$Aj)("symbol-array",60042),symbolModule:(0,i.$Aj)("symbol-module",60043),symbolPackage:(0,i.$Aj)("symbol-package",60043),symbolNamespace:(0,i.$Aj)("symbol-namespace",60043),symbolObject:(0,i.$Aj)("symbol-object",60043),symbolMethod:(0,i.$Aj)("symbol-method",60044),symbolFunction:(0,i.$Aj)("symbol-function",60044),symbolConstructor:(0,i.$Aj)("symbol-constructor",60044),symbolBoolean:(0,i.$Aj)("symbol-boolean",60047),symbolNull:(0,i.$Aj)("symbol-null",60047),symbolNumeric:(0,i.$Aj)("symbol-numeric",60048),symbolNumber:(0,i.$Aj)("symbol-number",60048),symbolStructure:(0,i.$Aj)("symbol-structure",60049),symbolStruct:(0,i.$Aj)("symbol-struct",60049),symbolParameter:(0,i.$Aj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Aj)("symbol-type-parameter",60050),symbolKey:(0,i.$Aj)("symbol-key",60051),symbolText:(0,i.$Aj)("symbol-text",60051),symbolReference:(0,i.$Aj)("symbol-reference",60052),goToFile:(0,i.$Aj)("go-to-file",60052),symbolEnum:(0,i.$Aj)("symbol-enum",60053),symbolValue:(0,i.$Aj)("symbol-value",60053),symbolRuler:(0,i.$Aj)("symbol-ruler",60054),symbolUnit:(0,i.$Aj)("symbol-unit",60054),activateBreakpoints:(0,i.$Aj)("activate-breakpoints",60055),archive:(0,i.$Aj)("archive",60056),arrowBoth:(0,i.$Aj)("arrow-both",60057),arrowDown:(0,i.$Aj)("arrow-down",60058),arrowLeft:(0,i.$Aj)("arrow-left",60059),arrowRight:(0,i.$Aj)("arrow-right",60060),arrowSmallDown:(0,i.$Aj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Aj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Aj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Aj)("arrow-small-up",60064),arrowUp:(0,i.$Aj)("arrow-up",60065),bell:(0,i.$Aj)("bell",60066),bold:(0,i.$Aj)("bold",60067),book:(0,i.$Aj)("book",60068),bookmark:(0,i.$Aj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Aj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Aj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Aj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Aj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Aj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Aj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Aj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Aj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Aj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Aj)("briefcase",60076),broadcast:(0,i.$Aj)("broadcast",60077),browser:(0,i.$Aj)("browser",60078),bug:(0,i.$Aj)("bug",60079),calendar:(0,i.$Aj)("calendar",60080),caseSensitive:(0,i.$Aj)("case-sensitive",60081),check:(0,i.$Aj)("check",60082),checklist:(0,i.$Aj)("checklist",60083),chevronDown:(0,i.$Aj)("chevron-down",60084),chevronLeft:(0,i.$Aj)("chevron-left",60085),chevronRight:(0,i.$Aj)("chevron-right",60086),chevronUp:(0,i.$Aj)("chevron-up",60087),chromeClose:(0,i.$Aj)("chrome-close",60088),chromeMaximize:(0,i.$Aj)("chrome-maximize",60089),chromeMinimize:(0,i.$Aj)("chrome-minimize",60090),chromeRestore:(0,i.$Aj)("chrome-restore",60091),circleOutline:(0,i.$Aj)("circle-outline",60092),circle:(0,i.$Aj)("circle",60092),debugBreakpointUnverified:(0,i.$Aj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Aj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Aj)("circle-slash",60093),circuitBoard:(0,i.$Aj)("circuit-board",60094),clearAll:(0,i.$Aj)("clear-all",60095),clippy:(0,i.$Aj)("clippy",60096),closeAll:(0,i.$Aj)("close-all",60097),cloudDownload:(0,i.$Aj)("cloud-download",60098),cloudUpload:(0,i.$Aj)("cloud-upload",60099),code:(0,i.$Aj)("code",60100),collapseAll:(0,i.$Aj)("collapse-all",60101),colorMode:(0,i.$Aj)("color-mode",60102),commentDiscussion:(0,i.$Aj)("comment-discussion",60103),creditCard:(0,i.$Aj)("credit-card",60105),dash:(0,i.$Aj)("dash",60108),dashboard:(0,i.$Aj)("dashboard",60109),database:(0,i.$Aj)("database",60110),debugContinue:(0,i.$Aj)("debug-continue",60111),debugDisconnect:(0,i.$Aj)("debug-disconnect",60112),debugPause:(0,i.$Aj)("debug-pause",60113),debugRestart:(0,i.$Aj)("debug-restart",60114),debugStart:(0,i.$Aj)("debug-start",60115),debugStepInto:(0,i.$Aj)("debug-step-into",60116),debugStepOut:(0,i.$Aj)("debug-step-out",60117),debugStepOver:(0,i.$Aj)("debug-step-over",60118),debugStop:(0,i.$Aj)("debug-stop",60119),debug:(0,i.$Aj)("debug",60120),deviceCameraVideo:(0,i.$Aj)("device-camera-video",60121),deviceCamera:(0,i.$Aj)("device-camera",60122),deviceMobile:(0,i.$Aj)("device-mobile",60123),diffAdded:(0,i.$Aj)("diff-added",60124),diffIgnored:(0,i.$Aj)("diff-ignored",60125),diffModified:(0,i.$Aj)("diff-modified",60126),diffRemoved:(0,i.$Aj)("diff-removed",60127),diffRenamed:(0,i.$Aj)("diff-renamed",60128),diff:(0,i.$Aj)("diff",60129),diffSidebyside:(0,i.$Aj)("diff-sidebyside",60129),discard:(0,i.$Aj)("discard",60130),editorLayout:(0,i.$Aj)("editor-layout",60131),emptyWindow:(0,i.$Aj)("empty-window",60132),exclude:(0,i.$Aj)("exclude",60133),extensions:(0,i.$Aj)("extensions",60134),eyeClosed:(0,i.$Aj)("eye-closed",60135),fileBinary:(0,i.$Aj)("file-binary",60136),fileCode:(0,i.$Aj)("file-code",60137),fileMedia:(0,i.$Aj)("file-media",60138),filePdf:(0,i.$Aj)("file-pdf",60139),fileSubmodule:(0,i.$Aj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Aj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Aj)("file-symlink-file",60142),fileZip:(0,i.$Aj)("file-zip",60143),files:(0,i.$Aj)("files",60144),filter:(0,i.$Aj)("filter",60145),flame:(0,i.$Aj)("flame",60146),foldDown:(0,i.$Aj)("fold-down",60147),foldUp:(0,i.$Aj)("fold-up",60148),fold:(0,i.$Aj)("fold",60149),folderActive:(0,i.$Aj)("folder-active",60150),folderOpened:(0,i.$Aj)("folder-opened",60151),gear:(0,i.$Aj)("gear",60152),gift:(0,i.$Aj)("gift",60153),gistSecret:(0,i.$Aj)("gist-secret",60154),gist:(0,i.$Aj)("gist",60155),gitCommit:(0,i.$Aj)("git-commit",60156),gitCompare:(0,i.$Aj)("git-compare",60157),compareChanges:(0,i.$Aj)("compare-changes",60157),gitMerge:(0,i.$Aj)("git-merge",60158),githubAction:(0,i.$Aj)("github-action",60159),githubAlt:(0,i.$Aj)("github-alt",60160),globe:(0,i.$Aj)("globe",60161),grabber:(0,i.$Aj)("grabber",60162),graph:(0,i.$Aj)("graph",60163),gripper:(0,i.$Aj)("gripper",60164),heart:(0,i.$Aj)("heart",60165),home:(0,i.$Aj)("home",60166),horizontalRule:(0,i.$Aj)("horizontal-rule",60167),hubot:(0,i.$Aj)("hubot",60168),inbox:(0,i.$Aj)("inbox",60169),issueReopened:(0,i.$Aj)("issue-reopened",60171),issues:(0,i.$Aj)("issues",60172),italic:(0,i.$Aj)("italic",60173),jersey:(0,i.$Aj)("jersey",60174),json:(0,i.$Aj)("json",60175),kebabVertical:(0,i.$Aj)("kebab-vertical",60176),key:(0,i.$Aj)("key",60177),law:(0,i.$Aj)("law",60178),lightbulbAutofix:(0,i.$Aj)("lightbulb-autofix",60179),linkExternal:(0,i.$Aj)("link-external",60180),link:(0,i.$Aj)("link",60181),listOrdered:(0,i.$Aj)("list-ordered",60182),listUnordered:(0,i.$Aj)("list-unordered",60183),liveShare:(0,i.$Aj)("live-share",60184),loading:(0,i.$Aj)("loading",60185),location:(0,i.$Aj)("location",60186),mailRead:(0,i.$Aj)("mail-read",60187),mail:(0,i.$Aj)("mail",60188),markdown:(0,i.$Aj)("markdown",60189),megaphone:(0,i.$Aj)("megaphone",60190),mention:(0,i.$Aj)("mention",60191),milestone:(0,i.$Aj)("milestone",60192),gitPullRequestMilestone:(0,i.$Aj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Aj)("mortar-board",60193),move:(0,i.$Aj)("move",60194),multipleWindows:(0,i.$Aj)("multiple-windows",60195),mute:(0,i.$Aj)("mute",60196),noNewline:(0,i.$Aj)("no-newline",60197),note:(0,i.$Aj)("note",60198),octoface:(0,i.$Aj)("octoface",60199),openPreview:(0,i.$Aj)("open-preview",60200),package:(0,i.$Aj)("package",60201),paintcan:(0,i.$Aj)("paintcan",60202),pin:(0,i.$Aj)("pin",60203),play:(0,i.$Aj)("play",60204),run:(0,i.$Aj)("run",60204),plug:(0,i.$Aj)("plug",60205),preserveCase:(0,i.$Aj)("preserve-case",60206),preview:(0,i.$Aj)("preview",60207),project:(0,i.$Aj)("project",60208),pulse:(0,i.$Aj)("pulse",60209),question:(0,i.$Aj)("question",60210),quote:(0,i.$Aj)("quote",60211),radioTower:(0,i.$Aj)("radio-tower",60212),reactions:(0,i.$Aj)("reactions",60213),references:(0,i.$Aj)("references",60214),refresh:(0,i.$Aj)("refresh",60215),regex:(0,i.$Aj)("regex",60216),remoteExplorer:(0,i.$Aj)("remote-explorer",60217),remote:(0,i.$Aj)("remote",60218),remove:(0,i.$Aj)("remove",60219),replaceAll:(0,i.$Aj)("replace-all",60220),replace:(0,i.$Aj)("replace",60221),repoClone:(0,i.$Aj)("repo-clone",60222),repoForcePush:(0,i.$Aj)("repo-force-push",60223),repoPull:(0,i.$Aj)("repo-pull",60224),repoPush:(0,i.$Aj)("repo-push",60225),report:(0,i.$Aj)("report",60226),requestChanges:(0,i.$Aj)("request-changes",60227),rocket:(0,i.$Aj)("rocket",60228),rootFolderOpened:(0,i.$Aj)("root-folder-opened",60229),rootFolder:(0,i.$Aj)("root-folder",60230),rss:(0,i.$Aj)("rss",60231),ruby:(0,i.$Aj)("ruby",60232),saveAll:(0,i.$Aj)("save-all",60233),saveAs:(0,i.$Aj)("save-as",60234),save:(0,i.$Aj)("save",60235),screenFull:(0,i.$Aj)("screen-full",60236),screenNormal:(0,i.$Aj)("screen-normal",60237),searchStop:(0,i.$Aj)("search-stop",60238),server:(0,i.$Aj)("server",60240),settingsGear:(0,i.$Aj)("settings-gear",60241),settings:(0,i.$Aj)("settings",60242),shield:(0,i.$Aj)("shield",60243),smiley:(0,i.$Aj)("smiley",60244),sortPrecedence:(0,i.$Aj)("sort-precedence",60245),splitHorizontal:(0,i.$Aj)("split-horizontal",60246),splitVertical:(0,i.$Aj)("split-vertical",60247),squirrel:(0,i.$Aj)("squirrel",60248),starFull:(0,i.$Aj)("star-full",60249),starHalf:(0,i.$Aj)("star-half",60250),symbolClass:(0,i.$Aj)("symbol-class",60251),symbolColor:(0,i.$Aj)("symbol-color",60252),symbolConstant:(0,i.$Aj)("symbol-constant",60253),symbolEnumMember:(0,i.$Aj)("symbol-enum-member",60254),symbolField:(0,i.$Aj)("symbol-field",60255),symbolFile:(0,i.$Aj)("symbol-file",60256),symbolInterface:(0,i.$Aj)("symbol-interface",60257),symbolKeyword:(0,i.$Aj)("symbol-keyword",60258),symbolMisc:(0,i.$Aj)("symbol-misc",60259),symbolOperator:(0,i.$Aj)("symbol-operator",60260),symbolProperty:(0,i.$Aj)("symbol-property",60261),wrench:(0,i.$Aj)("wrench",60261),wrenchSubaction:(0,i.$Aj)("wrench-subaction",60261),symbolSnippet:(0,i.$Aj)("symbol-snippet",60262),tasklist:(0,i.$Aj)("tasklist",60263),telescope:(0,i.$Aj)("telescope",60264),textSize:(0,i.$Aj)("text-size",60265),threeBars:(0,i.$Aj)("three-bars",60266),thumbsdown:(0,i.$Aj)("thumbsdown",60267),thumbsup:(0,i.$Aj)("thumbsup",60268),tools:(0,i.$Aj)("tools",60269),triangleDown:(0,i.$Aj)("triangle-down",60270),triangleLeft:(0,i.$Aj)("triangle-left",60271),triangleRight:(0,i.$Aj)("triangle-right",60272),triangleUp:(0,i.$Aj)("triangle-up",60273),twitter:(0,i.$Aj)("twitter",60274),unfold:(0,i.$Aj)("unfold",60275),unlock:(0,i.$Aj)("unlock",60276),unmute:(0,i.$Aj)("unmute",60277),unverified:(0,i.$Aj)("unverified",60278),verified:(0,i.$Aj)("verified",60279),versions:(0,i.$Aj)("versions",60280),vmActive:(0,i.$Aj)("vm-active",60281),vmOutline:(0,i.$Aj)("vm-outline",60282),vmRunning:(0,i.$Aj)("vm-running",60283),watch:(0,i.$Aj)("watch",60284),whitespace:(0,i.$Aj)("whitespace",60285),wholeWord:(0,i.$Aj)("whole-word",60286),window:(0,i.$Aj)("window",60287),wordWrap:(0,i.$Aj)("word-wrap",60288),zoomIn:(0,i.$Aj)("zoom-in",60289),zoomOut:(0,i.$Aj)("zoom-out",60290),listFilter:(0,i.$Aj)("list-filter",60291),listFlat:(0,i.$Aj)("list-flat",60292),listSelection:(0,i.$Aj)("list-selection",60293),selection:(0,i.$Aj)("selection",60293),listTree:(0,i.$Aj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Aj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Aj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Aj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Aj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Aj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Aj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Aj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Aj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Aj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Aj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Aj)("symbol-string",60301),debugReverseContinue:(0,i.$Aj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Aj)("debug-step-back",60303),debugRestartFrame:(0,i.$Aj)("debug-restart-frame",60304),debugAlt:(0,i.$Aj)("debug-alt",60305),callIncoming:(0,i.$Aj)("call-incoming",60306),callOutgoing:(0,i.$Aj)("call-outgoing",60307),menu:(0,i.$Aj)("menu",60308),expandAll:(0,i.$Aj)("expand-all",60309),feedback:(0,i.$Aj)("feedback",60310),gitPullRequestReviewer:(0,i.$Aj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Aj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Aj)("ungroup-by-ref-type",60312),account:(0,i.$Aj)("account",60313),gitPullRequestAssignee:(0,i.$Aj)("git-pull-request-assignee",60313),bellDot:(0,i.$Aj)("bell-dot",60314),debugConsole:(0,i.$Aj)("debug-console",60315),library:(0,i.$Aj)("library",60316),output:(0,i.$Aj)("output",60317),runAll:(0,i.$Aj)("run-all",60318),syncIgnored:(0,i.$Aj)("sync-ignored",60319),pinned:(0,i.$Aj)("pinned",60320),githubInverted:(0,i.$Aj)("github-inverted",60321),serverProcess:(0,i.$Aj)("server-process",60322),serverEnvironment:(0,i.$Aj)("server-environment",60323),pass:(0,i.$Aj)("pass",60324),issueClosed:(0,i.$Aj)("issue-closed",60324),stopCircle:(0,i.$Aj)("stop-circle",60325),playCircle:(0,i.$Aj)("play-circle",60326),record:(0,i.$Aj)("record",60327),debugAltSmall:(0,i.$Aj)("debug-alt-small",60328),vmConnect:(0,i.$Aj)("vm-connect",60329),cloud:(0,i.$Aj)("cloud",60330),merge:(0,i.$Aj)("merge",60331),export:(0,i.$Aj)("export",60332),graphLeft:(0,i.$Aj)("graph-left",60333),magnet:(0,i.$Aj)("magnet",60334),notebook:(0,i.$Aj)("notebook",60335),redo:(0,i.$Aj)("redo",60336),checkAll:(0,i.$Aj)("check-all",60337),pinnedDirty:(0,i.$Aj)("pinned-dirty",60338),passFilled:(0,i.$Aj)("pass-filled",60339),circleLargeFilled:(0,i.$Aj)("circle-large-filled",60340),circleLarge:(0,i.$Aj)("circle-large",60341),circleLargeOutline:(0,i.$Aj)("circle-large-outline",60341),combine:(0,i.$Aj)("combine",60342),gather:(0,i.$Aj)("gather",60342),table:(0,i.$Aj)("table",60343),variableGroup:(0,i.$Aj)("variable-group",60344),typeHierarchy:(0,i.$Aj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Aj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Aj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Aj)("git-pull-request-create",60348),runAbove:(0,i.$Aj)("run-above",60349),runBelow:(0,i.$Aj)("run-below",60350),notebookTemplate:(0,i.$Aj)("notebook-template",60351),debugRerun:(0,i.$Aj)("debug-rerun",60352),workspaceTrusted:(0,i.$Aj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Aj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Aj)("workspace-unknown",60355),terminalCmd:(0,i.$Aj)("terminal-cmd",60356),terminalDebian:(0,i.$Aj)("terminal-debian",60357),terminalLinux:(0,i.$Aj)("terminal-linux",60358),terminalPowershell:(0,i.$Aj)("terminal-powershell",60359),terminalTmux:(0,i.$Aj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Aj)("terminal-ubuntu",60361),terminalBash:(0,i.$Aj)("terminal-bash",60362),arrowSwap:(0,i.$Aj)("arrow-swap",60363),copy:(0,i.$Aj)("copy",60364),personAdd:(0,i.$Aj)("person-add",60365),filterFilled:(0,i.$Aj)("filter-filled",60366),wand:(0,i.$Aj)("wand",60367),debugLineByLine:(0,i.$Aj)("debug-line-by-line",60368),inspect:(0,i.$Aj)("inspect",60369),layers:(0,i.$Aj)("layers",60370),layersDot:(0,i.$Aj)("layers-dot",60371),layersActive:(0,i.$Aj)("layers-active",60372),compass:(0,i.$Aj)("compass",60373),compassDot:(0,i.$Aj)("compass-dot",60374),compassActive:(0,i.$Aj)("compass-active",60375),azure:(0,i.$Aj)("azure",60376),issueDraft:(0,i.$Aj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Aj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Aj)("git-pull-request-draft",60379),debugAll:(0,i.$Aj)("debug-all",60380),debugCoverage:(0,i.$Aj)("debug-coverage",60381),runErrors:(0,i.$Aj)("run-errors",60382),folderLibrary:(0,i.$Aj)("folder-library",60383),debugContinueSmall:(0,i.$Aj)("debug-continue-small",60384),beakerStop:(0,i.$Aj)("beaker-stop",60385),graphLine:(0,i.$Aj)("graph-line",60386),graphScatter:(0,i.$Aj)("graph-scatter",60387),pieChart:(0,i.$Aj)("pie-chart",60388),bracket:(0,i.$Aj)("bracket",60175),bracketDot:(0,i.$Aj)("bracket-dot",60389),bracketError:(0,i.$Aj)("bracket-error",60390),lockSmall:(0,i.$Aj)("lock-small",60391),azureDevops:(0,i.$Aj)("azure-devops",60392),verifiedFilled:(0,i.$Aj)("verified-filled",60393),newline:(0,i.$Aj)("newline",60394),layout:(0,i.$Aj)("layout",60395),layoutActivitybarLeft:(0,i.$Aj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Aj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Aj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Aj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Aj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Aj)("layout-panel-right",60401),layoutPanel:(0,i.$Aj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Aj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Aj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Aj)("layout-statusbar",60405),layoutMenubar:(0,i.$Aj)("layout-menubar",60406),layoutCentered:(0,i.$Aj)("layout-centered",60407),target:(0,i.$Aj)("target",60408),indent:(0,i.$Aj)("indent",60409),recordSmall:(0,i.$Aj)("record-small",60410),errorSmall:(0,i.$Aj)("error-small",60411),terminalDecorationError:(0,i.$Aj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Aj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Aj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Aj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Aj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Aj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Aj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Aj)("layout-sidebar-left-off",60418),blank:(0,i.$Aj)("blank",60419),heartFilled:(0,i.$Aj)("heart-filled",60420),map:(0,i.$Aj)("map",60421),mapFilled:(0,i.$Aj)("map-filled",60422),circleSmall:(0,i.$Aj)("circle-small",60423),bellSlash:(0,i.$Aj)("bell-slash",60424),bellSlashDot:(0,i.$Aj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Aj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Aj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Aj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Aj)("search-fuzzy",60429),commentDraft:(0,i.$Aj)("comment-draft",60430),send:(0,i.$Aj)("send",60431),sparkle:(0,i.$Aj)("sparkle",60432),insert:(0,i.$Aj)("insert",60433),mic:(0,i.$Aj)("mic",60434),thumbsdownFilled:(0,i.$Aj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Aj)("thumbsup-filled",60436),coffee:(0,i.$Aj)("coffee",60437),snake:(0,i.$Aj)("snake",60438),game:(0,i.$Aj)("game",60439),vr:(0,i.$Aj)("vr",60440),chip:(0,i.$Aj)("chip",60441),piano:(0,i.$Aj)("piano",60442),music:(0,i.$Aj)("music",60443),micFilled:(0,i.$Aj)("mic-filled",60444),repoFetch:(0,i.$Aj)("repo-fetch",60445),copilot:(0,i.$Aj)("copilot",60446),lightbulbSparkle:(0,i.$Aj)("lightbulb-sparkle",60447),robot:(0,i.$Aj)("robot",60448),sparkleFilled:(0,i.$Aj)("sparkle-filled",60449),diffSingle:(0,i.$Aj)("diff-single",60450),diffMultiple:(0,i.$Aj)("diff-multiple",60451),surroundWith:(0,i.$Aj)("surround-with",60452),share:(0,i.$Aj)("share",60453),gitStash:(0,i.$Aj)("git-stash",60454),gitStashApply:(0,i.$Aj)("git-stash-apply",60455),gitStashPop:(0,i.$Aj)("git-stash-pop",60456),vscode:(0,i.$Aj)("vscode",60457),vscodeInsiders:(0,i.$Aj)("vscode-insiders",60458),codeOss:(0,i.$Aj)("code-oss",60459),runCoverage:(0,i.$Aj)("run-coverage",60460),runAllCoverage:(0,i.$Aj)("run-all-coverage",60461),coverage:(0,i.$Aj)("coverage",60462),githubProject:(0,i.$Aj)("github-project",60463)}}),define(me[18],be([1,0,38,92]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fj=t.$Ej=void 0,t.$Dj=z;function z(){return Object.values(t.$Fj)}t.$Ej={dialogError:(0,i.$Aj)("dialog-error","error"),dialogWarning:(0,i.$Aj)("dialog-warning","warning"),dialogInfo:(0,i.$Aj)("dialog-info","info"),dialogClose:(0,i.$Aj)("dialog-close","close"),treeItemExpanded:(0,i.$Aj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Aj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Aj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Aj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Aj)("tree-item-loading","loading"),menuSelection:(0,i.$Aj)("menu-selection","check"),menuSubmenu:(0,i.$Aj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Aj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Aj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Aj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Aj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Aj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Aj)("toolbar-more","more"),quickInputBack:(0,i.$Aj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Aj)("drop-down-button",60084),symbolCustomColor:(0,i.$Aj)("symbol-customcolor",60252),exportIcon:(0,i.$Aj)("export",60332),workspaceUnspecified:(0,i.$Aj)("workspace-unspecified",60355),newLine:(0,i.$Aj)("newline",60394),thumbsDownFilled:(0,i.$Aj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Aj)("thumbsup-filled",60436),gitFetch:(0,i.$Aj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Aj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Aj)("debug-breakpoint-pending",60377)},t.$Fj={...C.$Cj,...t.$Ej}}),define(me[54],be([1,0,7]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mn=C,t.$Nn=z,t.$On=A,t.$Pn=b,t.$Qn=$,t.$Rn=w,t.$Sn=P,t.$Tn=c,t.$Un=d,t.$Vn=e,t.$Wn=s,t.$Xn=a;function C(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([v,o])=>{p[v]=o&&typeof o=="object"?C(o):o}),p}function z(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const o in v)if(H.call(v,o)){const g=v[o];typeof g=="object"&&!Object.isFrozen(g)&&!(0,i.$Wf)(g)&&p.push(g)}}return m}const H=Object.prototype.hasOwnProperty;function A(m,p){return y(m,p,new Set)}function y(m,p,v){if((0,i.$3f)(m))return m;const o=p(m);if(typeof o<"u")return o;if(Array.isArray(m)){const g=[];for(const r of m)g.push(y(r,p,v));return g}if((0,i.$Vf)(m)){if(v.has(m))throw new Error("Cannot clone recursive data-structure");v.add(m);const g={};for(const r in m)H.call(m,r)&&(g[r]=y(m[r],p,v));return v.delete(m),g}return m}function b(m,p,v=!0){return(0,i.$Vf)(m)?((0,i.$Vf)(p)&&Object.keys(p).forEach(o=>{o in m?v&&((0,i.$Vf)(m[o])&&(0,i.$Vf)(p[o])?b(m[o],p[o],v):m[o]=p[o]):m[o]=p[o]}),m):p}function $(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let v,o;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(v=0;v<m.length;v++)if(!$(m[v],p[v]))return!1}else{const g=[];for(o in m)g.push(o);g.sort();const r=[];for(o in p)r.push(o);if(r.sort(),!$(g,r))return!1;for(v=0;v<g.length;v++)if(!$(m[g[v]],p[g[v]]))return!1}return!0}function w(m){const p=new Set;return JSON.stringify(m,(v,o)=>{if((0,i.$Vf)(o)||Array.isArray(o)){if(p.has(o))return"[Circular]";p.add(o)}return o})}function P(m,p){const v=Object.create(null);return!m||!p||Object.keys(p).forEach(g=>{const r=m[g],E=p[g];$(r,E)||(v[g]=E)}),v}function c(m,p){const v=p.toLowerCase(),o=Object.keys(m).find(g=>g.toLowerCase()===v);return o?m[o]:m[p]}function d(m,p){const v=Object.create(null);for(const[o,g]of Object.entries(m))p(o,g)&&(v[o]=g);return v}function e(m){let p=[];for(;Object.prototype!==m;)p=p.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return p}function s(m){const p=[];for(const v of e(m))typeof m[v]=="function"&&p.push(v);return p}function a(m,p){const v=g=>function(){const r=Array.prototype.slice.call(arguments,0);return p(g,r)},o={};for(const g of m)o[g]=v(g);return o}}),define(me[19],be([1,0,18]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Gj=z;var C;(function(A){function y(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=y})(C||(t.ThemeColor=C={}));function z(A){return{id:A}}var H;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(p){const v=y.exec(p.id);if(!v)return b(i.$Fj.error);const[,o,g]=v,r=["codicon","codicon-"+o];return g&&r.push("codicon-modifier-"+g.substring(1)),r}A.asClassNameArray=b;function $(p){return b(p).join(" ")}A.asClassName=$;function w(p){return"."+b(p).join(".")}A.asCSSSelector=w;function P(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||C.isThemeColor(p.color))}A.isThemeIcon=P;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function d(p){const v=c.exec(p);if(!v)return;const[,o]=v;return{id:o}}A.fromString=d;function e(p){return{id:p}}A.fromId=e;function s(p,v){let o=p.id;const g=o.lastIndexOf("~");return g!==-1&&(o=o.substring(0,g)),v&&(o=`${o}~${v}`),{id:o}}A.modify=s;function a(p){const v=p.id.lastIndexOf("~");if(v!==-1)return p.id.substring(v+1)}A.getModifier=a;function m(p,v){return p.id===v.id&&p.color?.id===v.color?.id}A.isEqual=m})(H||(t.ThemeIcon=H={}))}),define(me[39],be([1,0,37,10,19]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xk=b,t.$yk=w,t.$zk=c,t.$Ak=d,t.$Bk=s,t.$Ck=a;const H="$(",A=new RegExp(`\\$\\(${z.ThemeIcon.iconNameExpression}(?:${z.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function b(m){return m.replace(y,(p,v)=>v?p:`\\${p}`)}const $=new RegExp(`\\\\${A.source}`,"g");function w(m){return m.replace($,p=>`\\${p}`)}const P=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(m){return m.indexOf(H)===-1?m:m.replace(P,(p,v,o,g)=>o?p:v||g||"")}function d(m){return m?m.replace(/\$\((.*?)\)/g,(p,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${z.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(m){e.lastIndex=0;let p="";const v=[];let o=0;for(;;){const g=e.lastIndex,r=e.exec(m),E=m.substring(g,r?.index);if(E.length>0){p+=E;for(let R=0;R<E.length;R++)v.push(o)}if(!r)break;o+=r[0].length}return{text:p,iconOffsets:v}}function a(m,p,v=!1){const{text:o,iconOffsets:g}=p;if(!g||g.length===0)return(0,i.$ok)(m,o,v);const r=(0,C.$4e)(o," "),E=o.length-r.length,R=(0,i.$ok)(m,r,v);if(R)for(const M of R){const j=g[M.start+E]+E;M.start+=j,M.end+=j}return R}}),define(me[93],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VV=t.$UV=void 0,t.$UV="vscode:contextmenu",t.$VV="vscode:onCloseContextMenu"}),define(me[94],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3V=void 0;class i{constructor(z,H){this.a=z,this.onMessage=H}send(z){try{this.a.send("vscode:message",z.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$3V=i}),define(me[31],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(me[95],be([1,0,93,31]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YV=H;let z=0;function H(y,b,$){const w=[],P=z++,c=`vscode:onContextMenu${P}`,d=(e,s,a)=>{w[s].click?.(a)};C.$O.once(c,d),C.$O.once(i.$VV,(e,s)=>{s===P&&(C.$O.removeListener(c,d),$?.())}),C.$O.send(i.$UV,P,y.map(e=>A(e,w)),c,b)}function A(y,b){const $={id:b.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return b.push(y),Array.isArray(y.submenu)&&($.submenu=y.submenu.map(w=>A(w,b))),$}}),define(me[55],be([8]),{}),define(me[96],be([8]),{}),define(me[97],be([8]),{}),define(me[98],be([8]),{}),define(me[99],be([1,0,97,98]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[100],be([8]),{}),define(me[101],be([8]),{}),define(me[102],be([8]),{}),define(me[103],be([8]),{}),define(me[104],be([8]),{}),define(me[105],be([8]),{}),define(me[106],be([8]),{}),define(me[107],be([8]),{}),define(me[108],be([8]),{}),define(me[109],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[110],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[111],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[112],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/hover/updatableHoverWidget",t)}),define(me[113],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[114],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[115],be([13,11]),function(re,t){return re.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[116],be([13,11]),function(re,t){return re.create("vs/base/common/actions",t)}),define(me[40],be([1,0,4,3,116]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2i=t.$1i=t.$Zi=t.$Yi=t.$Xi=void 0,t.$3i=w;class H extends C.$Tc{constructor(c,d="",e="",s=!0,a){super(),this.h=this.B(new i.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=d,this.u=e,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,d){this.C&&await this.C(c)}}t.$Xi=H;class A extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new i.$6d),this.onWillRun=this.f.event,this.m=this.B(new i.$6d),this.onDidRun=this.m.event}async run(c,d){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,d)}catch(s){e=s}this.m.fire({action:c,error:e})}async u(c,d){await c.run(d)}}t.$Yi=A;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let d=[];for(const e of c)e.length&&(d.length?d=[...d,new y,...e]:d=e);return d}static{this.ID="vs.actions.separator"}async run(){}}t.$Zi=y;class b{get actions(){return this.a}constructor(c,d,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=d,this.class=s,this.a=e}async run(){}}t.$1i=b;class $ extends H{static{this.ID="vs.actions.empty"}constructor(){super($.ID,z.localize(0,null),void 0,!1)}}t.$2i=$;function w(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...c)=>P.run(...c),tooltip:P.label}}}),define(me[117],be([13,11]),function(re,t){return re.create("vs/base/common/platform",t)}),define(me[5],be([1,0,117]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=E,t.$D=x,t.$J=W,t.$g="en";let C=!1,z=!1,H=!1,A=!1,y=!1,b=!1,$=!1,w=!1,P=!1,c=!1,d,e=t.$g,s=t.$g,a,m;const p=globalThis;let v;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?v=p.vscode.process:typeof process<"u"&&(v=process);const o=typeof v?.versions?.electron=="string",g=o&&v?.type==="renderer";if(typeof v=="object"){C=v.platform==="win32",z=v.platform==="darwin",H=v.platform==="linux",A=H&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,$=o,P=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.$g,e=t.$g;const T=v.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),I=L.availableLanguages["*"];d=L.locale,s=L.osLocale,e=I||t.$g,a=L._translationsConfigFile}catch{}y=!0}else typeof navigator=="object"&&!g?(m=navigator.userAgent,C=m.indexOf("Windows")>=0,z=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=m.indexOf("Linux")>=0,c=m?.indexOf("Mobi")>=0,b=!0,d=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=d,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(r||(t.Platform=r={}));function E(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let R=0;z?R=1:C?R=3:H&&(R=2),t.$i=C,t.$j=z,t.$k=H,t.$l=A,t.$m=y,t.$n=$,t.$o=b,t.$p=b&&typeof p.importScripts=="function",t.$q=t.$p?p.origin:void 0,t.$r=w,t.$s=c,t.$t=P,t.$u=R,t.$v=m,t.$w=e;var M;(function(T){function L(){return t.$w}T.value=L;function I(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}T.isDefaultVariant=I;function X(){return t.$w==="en"}T.isDefault=X})(M||(t.Language=M={})),t.$x=d,t.$y=s,t.$z=a,t.$A=typeof p.postMessage=="function"&&!p.importScripts,t.$B=(()=>{if(t.$A){const T=[];p.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let X=0,U=T.length;X<U;X++){const de=T[X];if(de.id===I.data.vscodeScheduleAsyncWork){T.splice(X,1),de.callback();return}}});let L=0;return I=>{const X=++L;T.push({id:X,callback:I}),p.postMessage({vscodeScheduleAsyncWork:X},"*")}}return T=>setTimeout(T)})();var j;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(j||(t.OperatingSystem=j={})),t.OS=z||w?2:C?1:3;let B=!0,D=!1;function x(){if(!D){D=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,B=new Uint16Array(T.buffer)[0]===513}return B}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function W(T){return parseFloat(T)>=20}}),define(me[118],be([1,0,17,22,5]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=t.KeyboardSupport=void 0;var H;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$QQ={clipboard:{writeText:z.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:z.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:z.$m||i.$OQ()?0:navigator.keyboard||i.$KQ?1:2,touch:"ontouchstart"in C.$uQ||navigator.maxTouchPoints>0,pointerEvents:C.$uQ.PointerEvent&&("ontouchstart"in C.$uQ||navigator.maxTouchPoints>0)}}),define(me[15],be([1,0,17,48,81,5]),function(re,t,i,C,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=void 0,t.$WQ=P,t.$XQ=c;function A(e){if(e.charCode){const a=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(a)}const s=e.keyCode;if(s===3)return 7;if(i.$HQ)switch(s){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(i.$IQ){if(H.$j&&s===93)return 57;if(!H.$j&&s===92)return 57}return C.$fr[s]||0}const y=H.$j?256:2048,b=512,$=1024,w=H.$j?2048:256;function P(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}class d{constructor(s){this._standardKeyboardEventBrand=!0;const a=s;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.altGraphKey=a.getModifierState("AltGraph"),this.keyCode=A(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let a=0;return this.ctrlKey&&(a|=y),this.altKey&&(a|=b),this.shiftKey&&(a|=$),this.metaKey&&(a|=w),a|=s,a}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new z.$nr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$YQ=d}),define(me[20],be([1,0,17,72,5]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VQ=t.$UQ=t.$TQ=void 0;class H{constructor($,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const P=C.$RQ.getPositionOfChildWindowRelativeToAncestorWindow($,w.view);this.posx-=P.left,this.posy-=P.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$TQ=H;class A extends H{constructor($,w){super($,w),this.dataTransfer=w.dataTransfer}}t.$UQ=A;class y{constructor($,w=0,P=0){this.browserEvent=$||null,this.target=$?$.target||$.targetNode||$.srcElement:null,this.deltaY=P,this.deltaX=w;let c=!1;if(i.$JQ){const d=navigator.userAgent.match(/Chrome\/(\d+)/);c=(d?parseInt(d[1]):123)<=122}if($){const d=$,e=$,s=$.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")c?this.deltaY=d.wheelDeltaY/(120*s):this.deltaY=d.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if($.type==="wheel"){const a=$;a.deltaMode===a.DOM_DELTA_LINE?i.$HQ&&!z.$j?this.deltaY=-$.deltaY/3:this.deltaY=-$.deltaY:this.deltaY=-$.deltaY/40}if(typeof d.wheelDeltaX<"u")i.$KQ&&z.$i?this.deltaX=-(d.wheelDeltaX/120):c?this.deltaX=d.wheelDeltaX/(120*s):this.deltaX=d.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-$.detail/3;else if($.type==="wheel"){const a=$;a.deltaMode===a.DOM_DELTA_LINE?i.$HQ&&!z.$j?this.deltaX=-$.deltaX/3:this.deltaX=-$.deltaX:this.deltaX=-$.deltaX/40}this.deltaY===0&&this.deltaX===0&&$.wheelDelta&&(c?this.deltaY=$.wheelDelta/(120*s):this.deltaY=$.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$VQ=y}),define(me[119],be([1,0,5]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let C;const z=globalThis.vscode;if(typeof z<"u"&&typeof z.process<"u"){const H=z.process;C={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$dc=C.platform,t.$ec=C.arch}),define(me[25],be([1,0,119]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const C=65,z=97,H=90,A=122,y=46,b=47,$=92,w=58,P=63;class c extends Error{constructor(E,R,M){let j;typeof R=="string"&&R.indexOf("not ")===0?(j="must not be",R=R.replace(/^not /,"")):j="must be";const B=E.indexOf(".")!==-1?"property":"argument";let D=`The "${E}" ${B} ${j} of type ${R}`;D+=`. Received type ${typeof M}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,E){if(r===null||typeof r!="object")throw new c(E,"Object",r)}function e(r,E){if(typeof r!="string")throw new c(E,"string",r)}const s=i.$dc==="win32";function a(r){return r===b||r===$}function m(r){return r===b}function p(r){return r>=C&&r<=H||r>=z&&r<=A}function v(r,E,R,M){let j="",B=0,D=-1,x=0,W=0;for(let T=0;T<=r.length;++T){if(T<r.length)W=r.charCodeAt(T);else{if(M(W))break;W=b}if(M(W)){if(!(D===T-1||x===1))if(x===2){if(j.length<2||B!==2||j.charCodeAt(j.length-1)!==y||j.charCodeAt(j.length-2)!==y){if(j.length>2){const L=j.lastIndexOf(R);L===-1?(j="",B=0):(j=j.slice(0,L),B=j.length-1-j.lastIndexOf(R)),D=T,x=0;continue}else if(j.length!==0){j="",B=0,D=T,x=0;continue}}E&&(j+=j.length>0?`${R}..`:"..",B=2)}else j.length>0?j+=`${R}${r.slice(D+1,T)}`:j=r.slice(D+1,T),B=T-D-1;D=T,x=0}else W===y&&x!==-1?++x:x=-1}return j}function o(r,E){d(E,"pathObject");const R=E.dir||E.root,M=E.base||`${E.name||""}${E.ext||""}`;return R?R===E.root?`${R}${M}`:`${R}${r}${M}`:M}t.$fc={resolve(...r){let E="",R="",M=!1;for(let j=r.length-1;j>=-1;j--){let B;if(j>=0){if(B=r[j],e(B,"path"),B.length===0)continue}else E.length===0?B=i.cwd():(B=i.env[`=${E}`]||i.cwd(),(B===void 0||B.slice(0,2).toLowerCase()!==E.toLowerCase()&&B.charCodeAt(2)===$)&&(B=`${E}\\`));const D=B.length;let x=0,W="",T=!1;const L=B.charCodeAt(0);if(D===1)a(L)&&(x=1,T=!0);else if(a(L))if(T=!0,a(B.charCodeAt(1))){let I=2,X=I;for(;I<D&&!a(B.charCodeAt(I));)I++;if(I<D&&I!==X){const U=B.slice(X,I);for(X=I;I<D&&a(B.charCodeAt(I));)I++;if(I<D&&I!==X){for(X=I;I<D&&!a(B.charCodeAt(I));)I++;(I===D||I!==X)&&(W=`\\\\${U}\\${B.slice(X,I)}`,x=I)}}}else x=1;else p(L)&&B.charCodeAt(1)===w&&(W=B.slice(0,2),x=2,D>2&&a(B.charCodeAt(2))&&(T=!0,x=3));if(W.length>0)if(E.length>0){if(W.toLowerCase()!==E.toLowerCase())continue}else E=W;if(M){if(E.length>0)break}else if(R=`${B.slice(x)}\\${R}`,M=T,T&&E.length>0)break}return R=v(R,!M,"\\",a),M?`${E}\\${R}`:`${E}${R}`||"."},normalize(r){e(r,"path");const E=r.length;if(E===0)return".";let R=0,M,j=!1;const B=r.charCodeAt(0);if(E===1)return m(B)?"\\":r;if(a(B))if(j=!0,a(r.charCodeAt(1))){let x=2,W=x;for(;x<E&&!a(r.charCodeAt(x));)x++;if(x<E&&x!==W){const T=r.slice(W,x);for(W=x;x<E&&a(r.charCodeAt(x));)x++;if(x<E&&x!==W){for(W=x;x<E&&!a(r.charCodeAt(x));)x++;if(x===E)return`\\\\${T}\\${r.slice(W)}\\`;x!==W&&(M=`\\\\${T}\\${r.slice(W,x)}`,R=x)}}}else R=1;else p(B)&&r.charCodeAt(1)===w&&(M=r.slice(0,2),R=2,E>2&&a(r.charCodeAt(2))&&(j=!0,R=3));let D=R<E?v(r.slice(R),!j,"\\",a):"";return D.length===0&&!j&&(D="."),D.length>0&&a(r.charCodeAt(E-1))&&(D+="\\"),M===void 0?j?`\\${D}`:D:j?`${M}\\${D}`:`${M}${D}`},isAbsolute(r){e(r,"path");const E=r.length;if(E===0)return!1;const R=r.charCodeAt(0);return a(R)||E>2&&p(R)&&r.charCodeAt(1)===w&&a(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let E,R;for(let B=0;B<r.length;++B){const D=r[B];e(D,"path"),D.length>0&&(E===void 0?E=R=D:E+=`\\${D}`)}if(E===void 0)return".";let M=!0,j=0;if(typeof R=="string"&&a(R.charCodeAt(0))){++j;const B=R.length;B>1&&a(R.charCodeAt(1))&&(++j,B>2&&(a(R.charCodeAt(2))?++j:M=!1))}if(M){for(;j<E.length&&a(E.charCodeAt(j));)j++;j>=2&&(E=`\\${E.slice(j)}`)}return t.$fc.normalize(E)},relative(r,E){if(e(r,"from"),e(E,"to"),r===E)return"";const R=t.$fc.resolve(r),M=t.$fc.resolve(E);if(R===M||(r=R.toLowerCase(),E=M.toLowerCase(),r===E))return"";let j=0;for(;j<r.length&&r.charCodeAt(j)===$;)j++;let B=r.length;for(;B-1>j&&r.charCodeAt(B-1)===$;)B--;const D=B-j;let x=0;for(;x<E.length&&E.charCodeAt(x)===$;)x++;let W=E.length;for(;W-1>x&&E.charCodeAt(W-1)===$;)W--;const T=W-x,L=D<T?D:T;let I=-1,X=0;for(;X<L;X++){const de=r.charCodeAt(j+X);if(de!==E.charCodeAt(x+X))break;de===$&&(I=X)}if(X!==L){if(I===-1)return M}else{if(T>L){if(E.charCodeAt(x+X)===$)return M.slice(x+X+1);if(X===2)return M.slice(x+X)}D>L&&(r.charCodeAt(j+X)===$?I=X:X===2&&(I=3)),I===-1&&(I=0)}let U="";for(X=j+I+1;X<=B;++X)(X===B||r.charCodeAt(X)===$)&&(U+=U.length===0?"..":"\\..");return x+=I,U.length>0?`${U}${M.slice(x,W)}`:(M.charCodeAt(x)===$&&++x,M.slice(x,W))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const E=t.$fc.resolve(r);if(E.length<=2)return r;if(E.charCodeAt(0)===$){if(E.charCodeAt(1)===$){const R=E.charCodeAt(2);if(R!==P&&R!==y)return`\\\\?\\UNC\\${E.slice(2)}`}}else if(p(E.charCodeAt(0))&&E.charCodeAt(1)===w&&E.charCodeAt(2)===$)return`\\\\?\\${E}`;return r},dirname(r){e(r,"path");const E=r.length;if(E===0)return".";let R=-1,M=0;const j=r.charCodeAt(0);if(E===1)return a(j)?r:".";if(a(j)){if(R=M=1,a(r.charCodeAt(1))){let x=2,W=x;for(;x<E&&!a(r.charCodeAt(x));)x++;if(x<E&&x!==W){for(W=x;x<E&&a(r.charCodeAt(x));)x++;if(x<E&&x!==W){for(W=x;x<E&&!a(r.charCodeAt(x));)x++;if(x===E)return r;x!==W&&(R=M=x+1)}}}}else p(j)&&r.charCodeAt(1)===w&&(R=E>2&&a(r.charCodeAt(2))?3:2,M=R);let B=-1,D=!0;for(let x=E-1;x>=M;--x)if(a(r.charCodeAt(x))){if(!D){B=x;break}}else D=!1;if(B===-1){if(R===-1)return".";B=R}return r.slice(0,B)},basename(r,E){E!==void 0&&e(E,"ext"),e(r,"path");let R=0,M=-1,j=!0,B;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(R=2),E!==void 0&&E.length>0&&E.length<=r.length){if(E===r)return"";let D=E.length-1,x=-1;for(B=r.length-1;B>=R;--B){const W=r.charCodeAt(B);if(a(W)){if(!j){R=B+1;break}}else x===-1&&(j=!1,x=B+1),D>=0&&(W===E.charCodeAt(D)?--D===-1&&(M=B):(D=-1,M=x))}return R===M?M=x:M===-1&&(M=r.length),r.slice(R,M)}for(B=r.length-1;B>=R;--B)if(a(r.charCodeAt(B))){if(!j){R=B+1;break}}else M===-1&&(j=!1,M=B+1);return M===-1?"":r.slice(R,M)},extname(r){e(r,"path");let E=0,R=-1,M=0,j=-1,B=!0,D=0;r.length>=2&&r.charCodeAt(1)===w&&p(r.charCodeAt(0))&&(E=M=2);for(let x=r.length-1;x>=E;--x){const W=r.charCodeAt(x);if(a(W)){if(!B){M=x+1;break}continue}j===-1&&(B=!1,j=x+1),W===y?R===-1?R=x:D!==1&&(D=1):R!==-1&&(D=-1)}return R===-1||j===-1||D===0||D===1&&R===j-1&&R===M+1?"":r.slice(R,j)},format:o.bind(null,"\\"),parse(r){e(r,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return E;const R=r.length;let M=0,j=r.charCodeAt(0);if(R===1)return a(j)?(E.root=E.dir=r,E):(E.base=E.name=r,E);if(a(j)){if(M=1,a(r.charCodeAt(1))){let I=2,X=I;for(;I<R&&!a(r.charCodeAt(I));)I++;if(I<R&&I!==X){for(X=I;I<R&&a(r.charCodeAt(I));)I++;if(I<R&&I!==X){for(X=I;I<R&&!a(r.charCodeAt(I));)I++;I===R?M=I:I!==X&&(M=I+1)}}}}else if(p(j)&&r.charCodeAt(1)===w){if(R<=2)return E.root=E.dir=r,E;if(M=2,a(r.charCodeAt(2))){if(R===3)return E.root=E.dir=r,E;M=3}}M>0&&(E.root=r.slice(0,M));let B=-1,D=M,x=-1,W=!0,T=r.length-1,L=0;for(;T>=M;--T){if(j=r.charCodeAt(T),a(j)){if(!W){D=T+1;break}continue}x===-1&&(W=!1,x=T+1),j===y?B===-1?B=T:L!==1&&(L=1):B!==-1&&(L=-1)}return x!==-1&&(B===-1||L===0||L===1&&B===x-1&&B===D+1?E.base=E.name=r.slice(D,x):(E.name=r.slice(D,B),E.base=r.slice(D,x),E.ext=r.slice(B,x))),D>0&&D!==M?E.dir=r.slice(0,D-1):E.dir=E.root,E},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(s){const r=/\\/g;return()=>{const E=i.cwd().replace(r,"/");return E.slice(E.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...r){let E="",R=!1;for(let M=r.length-1;M>=-1&&!R;M--){const j=M>=0?r[M]:g();e(j,"path"),j.length!==0&&(E=`${j}/${E}`,R=j.charCodeAt(0)===b)}return E=v(E,!R,"/",m),R?`/${E}`:E.length>0?E:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const E=r.charCodeAt(0)===b,R=r.charCodeAt(r.length-1)===b;return r=v(r,!E,"/",m),r.length===0?E?"/":R?"./":".":(R&&(r+="/"),E?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===b},join(...r){if(r.length===0)return".";let E;for(let R=0;R<r.length;++R){const M=r[R];e(M,"path"),M.length>0&&(E===void 0?E=M:E+=`/${M}`)}return E===void 0?".":t.$gc.normalize(E)},relative(r,E){if(e(r,"from"),e(E,"to"),r===E||(r=t.$gc.resolve(r),E=t.$gc.resolve(E),r===E))return"";const R=1,M=r.length,j=M-R,B=1,D=E.length-B,x=j<D?j:D;let W=-1,T=0;for(;T<x;T++){const I=r.charCodeAt(R+T);if(I!==E.charCodeAt(B+T))break;I===b&&(W=T)}if(T===x)if(D>x){if(E.charCodeAt(B+T)===b)return E.slice(B+T+1);if(T===0)return E.slice(B+T)}else j>x&&(r.charCodeAt(R+T)===b?W=T:T===0&&(W=0));let L="";for(T=R+W+1;T<=M;++T)(T===M||r.charCodeAt(T)===b)&&(L+=L.length===0?"..":"/..");return`${L}${E.slice(B+W)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const E=r.charCodeAt(0)===b;let R=-1,M=!0;for(let j=r.length-1;j>=1;--j)if(r.charCodeAt(j)===b){if(!M){R=j;break}}else M=!1;return R===-1?E?"/":".":E&&R===1?"//":r.slice(0,R)},basename(r,E){E!==void 0&&e(E,"ext"),e(r,"path");let R=0,M=-1,j=!0,B;if(E!==void 0&&E.length>0&&E.length<=r.length){if(E===r)return"";let D=E.length-1,x=-1;for(B=r.length-1;B>=0;--B){const W=r.charCodeAt(B);if(W===b){if(!j){R=B+1;break}}else x===-1&&(j=!1,x=B+1),D>=0&&(W===E.charCodeAt(D)?--D===-1&&(M=B):(D=-1,M=x))}return R===M?M=x:M===-1&&(M=r.length),r.slice(R,M)}for(B=r.length-1;B>=0;--B)if(r.charCodeAt(B)===b){if(!j){R=B+1;break}}else M===-1&&(j=!1,M=B+1);return M===-1?"":r.slice(R,M)},extname(r){e(r,"path");let E=-1,R=0,M=-1,j=!0,B=0;for(let D=r.length-1;D>=0;--D){const x=r.charCodeAt(D);if(x===b){if(!j){R=D+1;break}continue}M===-1&&(j=!1,M=D+1),x===y?E===-1?E=D:B!==1&&(B=1):E!==-1&&(B=-1)}return E===-1||M===-1||B===0||B===1&&E===M-1&&E===R+1?"":r.slice(E,M)},format:o.bind(null,"/"),parse(r){e(r,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return E;const R=r.charCodeAt(0)===b;let M;R?(E.root="/",M=1):M=0;let j=-1,B=0,D=-1,x=!0,W=r.length-1,T=0;for(;W>=M;--W){const L=r.charCodeAt(W);if(L===b){if(!x){B=W+1;break}continue}D===-1&&(x=!1,D=W+1),L===y?j===-1?j=W:T!==1&&(T=1):j!==-1&&(T=-1)}if(D!==-1){const L=B===0&&R?1:B;j===-1||T===0||T===1&&j===D-1&&j===B+1?E.base=E.name=r.slice(L,D):(E.name=r.slice(L,j),E.base=r.slice(L,D),E.ext=r.slice(j,D))}return B>0?E.dir=r.slice(0,B-1):R&&(E.dir="/"),E},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(me[120],be([1,0,25,5,10,7]),function(re,t,i,C,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_f=A,t.$ag=y,t.$bg=b,t.$cg=$,t.$dg=w,t.$eg=e,t.$fg=s,t.$gg=a,t.$hg=m,t.$ig=p,t.$jg=v,t.$kg=o,t.$lg=g,t.$mg=r,t.$ng=E,t.$og=j;function A(B){return B===47||B===92}function y(B){return B.replace(/[\\/]/g,i.$gc.sep)}function b(B){return B.indexOf("/")===-1&&(B=y(B)),/^[a-zA-Z]:(\/|$)/.test(B)&&(B="/"+B),B}function $(B,D=i.$gc.sep){if(!B)return"";const x=B.length,W=B.charCodeAt(0);if(A(W)){if(A(B.charCodeAt(1))&&!A(B.charCodeAt(2))){let L=3;const I=L;for(;L<x&&!A(B.charCodeAt(L));L++);if(I!==L&&!A(B.charCodeAt(L+1))){for(L+=1;L<x;L++)if(A(B.charCodeAt(L)))return B.slice(0,L+1).replace(/[\\/]/g,D)}}return D}else if(m(W)&&B.charCodeAt(1)===58)return A(B.charCodeAt(2))?B.slice(0,2)+D:B.slice(0,2);let T=B.indexOf("://");if(T!==-1){for(T+=3;T<x;T++)if(A(B.charCodeAt(T)))return B.slice(0,T+1)}return""}function w(B){if(!C.$i||!B||B.length<5)return!1;let D=B.charCodeAt(0);if(D!==92||(D=B.charCodeAt(1),D!==92))return!1;let x=2;const W=x;for(;x<B.length&&(D=B.charCodeAt(x),D!==92);x++);return!(W===x||(D=B.charCodeAt(x+1),isNaN(D)||D===92))}const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(B,D=C.$i){const x=D?P:c;return!(!B||B.length===0||/^\s+$/.test(B)||(x.lastIndex=0,x.test(B))||D&&d.test(B)||B==="."||B===".."||D&&B[B.length-1]==="."||D&&B.length!==B.trim().length||B.length>255)}function s(B,D,x){const W=B===D;return!x||W?W:!B||!D?!1:(0,z.$kf)(B,D)}function a(B,D,x,W=i.sep){if(B===D)return!0;if(!B||!D||D.length>B.length)return!1;if(x){if(!(0,z.$lf)(B,D))return!1;if(D.length===B.length)return!0;let L=D.length;return D.charAt(D.length-1)===W&&L--,B.charAt(L)===W}return D.charAt(D.length-1)!==W&&(D+=W),B.indexOf(D)===0}function m(B){return B>=65&&B<=90||B>=97&&B<=122}function p(B,D){return C.$i&&B.endsWith(":")&&(B+=i.sep),(0,i.$ic)(B)||(B=(0,i.$jc)(D,B)),B=(0,i.$hc)(B),C.$i?(B=(0,z.$5e)(B,i.sep),B.endsWith(":")&&(B+=i.sep)):(B=(0,z.$5e)(B,i.sep),B||(B=i.sep)),B}function v(B){const D=(0,i.$hc)(B);return C.$i?B.length>3?!1:o(D)&&(B.length===2||D.charCodeAt(2)===92):D===i.$gc.sep}function o(B,D=C.$i){return D?m(B.charCodeAt(0))&&B.charCodeAt(1)===58:!1}function g(B,D=C.$i){return o(B,D)?B[0]:void 0}function r(B,D,x){return D.length>B.length?-1:B===D?0:(x&&(B=B.toLowerCase(),D=D.toLowerCase()),B.indexOf(D))}function E(B){const D=B.split(":");let x,W,T;for(const L of D){const I=Number(L);(0,H.$Xf)(I)?W===void 0?W=I:T===void 0&&(T=I):x=x?[x,L].join(":"):L}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:W!==void 0?W:void 0,column:T!==void 0?T:W!==void 0?1:void 0}}const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function j(B,D,x=8){let W="";for(let L=0;L<x;L++){let I;L===0&&C.$i&&!D&&(x===3||x===4)?I=M:I=R,W+=I.charAt(Math.floor(Math.random()*I.length))}let T;return D?T=`${D}-${W}`:T=W,B?(0,i.$jc)(B,T):T}}),define(me[121],be([1,0,25]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vs=void 0,t.$ws=H,t.$xs=A,t.$ys=y,t.$zs=$,t.$vs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},z={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(w){const P=(0,i.$oc)(w),c=C[P.toLowerCase()];return c!==void 0?c:A(w)}function A(w){const P=(0,i.$oc)(w);return z[P.toLowerCase()]}function y(w){for(const P in z)if(z[P]===w)return P}const b=/^(.+)\/(.+?)(;.+)?$/;function $(w,P){const c=b.exec(w);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:P?void 0:w}}),define(me[16],be([1,0,25,5]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$vc=e,t.$wc=o;const z=/^\w[\w\d+.-]*$/,H=/^\//,A=/^\/\//;function y(M,j){if(!M.scheme&&j)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${M.authority}", path: "${M.path}", query: "${M.query}", fragment: "${M.fragment}"}`);if(M.scheme&&!z.test(M.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(M.path){if(M.authority){if(!H.test(M.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(M.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(M,j){return!M&&!j?"file":M}function $(M,j){switch(M){case"https":case"http":case"file":j?j[0]!==P&&(j=P+j):j=P;break}return j}const w="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(j){return j instanceof d?!0:j?typeof j.authority=="string"&&typeof j.fragment=="string"&&typeof j.path=="string"&&typeof j.query=="string"&&typeof j.scheme=="string"&&typeof j.fsPath=="string"&&typeof j.with=="function"&&typeof j.toString=="function":!1}constructor(j,B,D,x,W,T=!1){typeof j=="object"?(this.scheme=j.scheme||w,this.authority=j.authority||w,this.path=j.path||w,this.query=j.query||w,this.fragment=j.fragment||w):(this.scheme=b(j,T),this.authority=B||w,this.path=$(this.scheme,D||w),this.query=x||w,this.fragment=W||w,y(this,T))}get fsPath(){return o(this,!1)}with(j){if(!j)return this;let{scheme:B,authority:D,path:x,query:W,fragment:T}=j;return B===void 0?B=this.scheme:B===null&&(B=w),D===void 0?D=this.authority:D===null&&(D=w),x===void 0?x=this.path:x===null&&(x=w),W===void 0?W=this.query:W===null&&(W=w),T===void 0?T=this.fragment:T===null&&(T=w),B===this.scheme&&D===this.authority&&x===this.path&&W===this.query&&T===this.fragment?this:new a(B,D,x,W,T)}static parse(j,B=!1){const D=c.exec(j);return D?new a(D[2]||w,R(D[4]||w),R(D[5]||w),R(D[7]||w),R(D[9]||w),B):new a(w,w,w,w,w)}static file(j){let B=w;if(C.$i&&(j=j.replace(/\\/g,P)),j[0]===P&&j[1]===P){const D=j.indexOf(P,2);D===-1?(B=j.substring(2),j=P):(B=j.substring(2,D),j=j.substring(D)||P)}return new a("file",B,j,w,w)}static from(j,B){return new a(j.scheme,j.authority,j.path,j.query,j.fragment,B)}static joinPath(j,...B){if(!j.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return C.$i&&j.scheme==="file"?D=d.file(i.$fc.join(o(j,!0),...B)).path:D=i.$gc.join(j.path,...B),j.with({path:D})}toString(j=!1){return g(this,j)}toJSON(){return this}static revive(j){if(j){if(j instanceof d)return j;{const B=new a(j);return B._formatted=j.external??null,B._fsPath=j._sep===s?j.fsPath??null:null,B}}else return j}}t.URI=d;function e(M){return!M||typeof M!="object"?!1:typeof M.scheme=="string"&&(typeof M.authority=="string"||typeof M.authority>"u")&&(typeof M.path=="string"||typeof M.path>"u")&&(typeof M.query=="string"||typeof M.query>"u")&&(typeof M.fragment=="string"||typeof M.fragment>"u")}const s=C.$i?1:void 0;class a extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(j=!1){return j?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const j={$mid:1};return this._fsPath&&(j.fsPath=this._fsPath,j._sep=s),this._formatted&&(j.external=this._formatted),this.path&&(j.path=this.path),this.scheme&&(j.scheme=this.scheme),this.authority&&(j.authority=this.authority),this.query&&(j.query=this.query),this.fragment&&(j.fragment=this.fragment),j}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(M,j,B){let D,x=-1;for(let W=0;W<M.length;W++){const T=M.charCodeAt(W);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||j&&T===47||B&&T===91||B&&T===93||B&&T===58)x!==-1&&(D+=encodeURIComponent(M.substring(x,W)),x=-1),D!==void 0&&(D+=M.charAt(W));else{D===void 0&&(D=M.substr(0,W));const L=m[T];L!==void 0?(x!==-1&&(D+=encodeURIComponent(M.substring(x,W)),x=-1),D+=L):x===-1&&(x=W)}}return x!==-1&&(D+=encodeURIComponent(M.substring(x))),D!==void 0?D:M}function v(M){let j;for(let B=0;B<M.length;B++){const D=M.charCodeAt(B);D===35||D===63?(j===void 0&&(j=M.substr(0,B)),j+=m[D]):j!==void 0&&(j+=M[B])}return j!==void 0?j:M}function o(M,j){let B;return M.authority&&M.path.length>1&&M.scheme==="file"?B=`//${M.authority}${M.path}`:M.path.charCodeAt(0)===47&&(M.path.charCodeAt(1)>=65&&M.path.charCodeAt(1)<=90||M.path.charCodeAt(1)>=97&&M.path.charCodeAt(1)<=122)&&M.path.charCodeAt(2)===58?j?B=M.path.substr(1):B=M.path[1].toLowerCase()+M.path.substr(2):B=M.path,C.$i&&(B=B.replace(/\//g,"\\")),B}function g(M,j){const B=j?v:p;let D="",{scheme:x,authority:W,path:T,query:L,fragment:I}=M;if(x&&(D+=x,D+=":"),(W||x==="file")&&(D+=P,D+=P),W){let X=W.indexOf("@");if(X!==-1){const U=W.substr(0,X);W=W.substr(X+1),X=U.lastIndexOf(":"),X===-1?D+=B(U,!1,!1):(D+=B(U.substr(0,X),!1,!1),D+=":",D+=B(U.substr(X+1),!1,!0)),D+="@"}W=W.toLowerCase(),X=W.lastIndexOf(":"),X===-1?D+=B(W,!1,!0):(D+=B(W.substr(0,X),!1,!0),D+=W.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}D+=B(T,!0,!1)}return L&&(D+="?",D+=B(L,!1,!1)),I&&(D+="#",D+=j?I:p(I,!1,!1)),D}function r(M){try{return decodeURIComponent(M)}catch{return M.length>3?M.substr(0,3)+r(M.substr(3)):M}}const E=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(M){return M.match(E)?M.replace(E,j=>r(j)):M}}),define(me[56],be([1,0,36,16]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nh=z,t.$Oh=H,t.$Ph=y;function z(b){return JSON.stringify(b,A)}function H(b){let $=JSON.parse(b);return $=y($),$}function A(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function y(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return C.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof i.$te||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let w=0;w<b.length;++w)b[w]=y(b[w],$+1);else for(const w in b)Object.hasOwnProperty.call(b,w)&&(b[w]=y(b[w],$+1))}return b}}),define(me[32],be([1,0,6,5,10,16,25]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$tg=t.$sg=t.$rg=t.Schemas=void 0,t.$pg=b,t.$qg=$,t.$ug=P;var y;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.codeSetting="code-setting"})(y||(t.Schemas=y={}));function b(e,s){return H.URI.isUri(e)?(0,z.$kf)(e.scheme,s):(0,z.$lf)(e,s+":")}function $(e,...s){return s.some(a=>b(e,a))}t.$rg="vscode-tkn",t.$sg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,a){this.f=P(s,a)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,y.vscodeRemoteResource)}set(s,a,m){this.a[s]=a,this.b[s]=m}setConnectionToken(s,a){this.c[s]=a}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(g){return i.$1(g),s}const a=s.authority;let m=this.a[a];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[a],v=this.c[a];let o=`path=${encodeURIComponent(s.path)}`;return typeof v=="string"&&(o+=`&${t.$sg}=${encodeURIComponent(v)}`),H.URI.from({scheme:C.$o?this.d:y.vscodeRemoteResource,authority:`${m}:${p}`,path:this.g,query:o})}}t.$tg=new w;function P(e,s){return A.$gc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$vg="vs/../../extensions",t.$wg="vs/../../node_modules",t.$xg="vs/../../node_modules.asar",t.$yg="vs/../../node_modules.asar.unpacked",t.$zg="vscode-app";class c{static{this.a=t.$zg}asBrowserUri(s){const a=this.b(s,re);return this.uriToBrowserUri(a)}uriToBrowserUri(s){return s.scheme===y.vscodeRemote?t.$tg.rewrite(s):s.scheme===y.file&&(C.$m||C.$q===`${y.vscodeFileResource}://${c.a}`)?s.with({scheme:y.vscodeFileResource,authority:s.authority||c.a,query:null,fragment:null}):s}asFileUri(s){const a=this.b(s,re);return this.uriToFileUri(a)}uriToFileUri(s){return s.scheme===y.vscodeFileResource?s.with({scheme:y.file,authority:s.authority!==c.a?s.authority:null,query:null,fragment:null}):s}b(s,a){return H.URI.isUri(s)?s:H.URI.parse(a.toUrl(s))}}t.$Ag=new c;var d;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const a="vscode-coi";function m(v){let o;typeof v=="string"?o=new URL(v).searchParams:v instanceof URL?o=v.searchParams:H.URI.isUri(v)&&(o=new URL(v.toString(!0)).searchParams);const g=o?.get(a);if(g)return s.get(g)}e.getHeadersFromQuery=m;function p(v,o,g){if(!globalThis.crossOriginIsolated)return;const r=o&&g?"3":g?"2":"1";v instanceof URLSearchParams?v.set(a,r):v[a]=r}e.addSearchParam=p})(d||(t.COI=d={}))}),define(me[41],be([1,0,120,32,25,5,10,16]),function(re,t,i,C,z,H,A,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=void 0,t.$Hg=b,t.$3g=w,t.$4g=c;function b(d){return(0,y.$wc)(d,!0)}class ${constructor(e){this.a=e}compare(e,s,a=!1){return e===s?0:(0,A.$df)(this.getComparisonKey(e,a),this.getComparisonKey(s,a))}isEqual(e,s,a=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,a)===this.getComparisonKey(s,a)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,a=!1){if(e.scheme===s.scheme){if(e.scheme===C.Schemas.file)return i.$gg(b(e),b(s),this.a(e))&&e.query===s.query&&(a||e.fragment===s.fragment);if((0,t.$Yg)(e.authority,s.authority))return i.$gg(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(a||e.fragment===s.fragment)}return!1}joinPath(e,...s){return y.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Qg)(e)||e.authority}basename(e){return z.$gc.basename(e.path)}extname(e){return z.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===C.Schemas.file?s=y.URI.file(z.$mc(b(e))).path:(s=z.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===C.Schemas.file?s=y.URI.file(z.$hc(b(e))).path:s=z.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Yg)(e.authority,s.authority))return;if(e.scheme===C.Schemas.file){const p=z.$lc(b(e),b(s));return H.$i?i.$ag(p):p}let a=e.path||"/";const m=s.path||"/";if(this.a(e)){let p=0;for(const v=Math.min(a.length,m.length);p<v&&!(a.charCodeAt(p)!==m.charCodeAt(p)&&a.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);a=m.substr(0,p)+a.substr(p)}return z.$gc.relative(a,m)}resolvePath(e,s){if(e.scheme===C.Schemas.file){const a=y.URI.file(z.$kc(b(e),s));return e.with({authority:a.authority,path:a.path})}return s=i.$bg(s),e.with({path:z.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,A.$kf)(e,s)}hasTrailingPathSeparator(e,s=z.sep){if(e.scheme===C.Schemas.file){const a=b(e);return a.length>i.$cg(a).length&&a[a.length-1]===s}else{const a=e.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=z.sep){return(0,t.$Zg)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=z.sep){let a=!1;if(e.scheme===C.Schemas.file){const m=b(e);a=m!==void 0&&m.length===i.$cg(m).length&&m[m.length-1]===s}else{s="/";const m=e.path;a=m.length===1&&m.charCodeAt(m.length-1)===47}return!a&&!(0,t.$Zg)(e,s)?e.with({path:e.path+"/"}):e}}t.$Ig=$,t.$Jg=new $(()=>!1),t.$Kg=new $(d=>d.scheme===C.Schemas.file?!H.$k:!0),t.$Lg=new $(d=>!0),t.$Mg=t.$Jg.isEqual.bind(t.$Jg),t.$Ng=t.$Jg.isEqualOrParent.bind(t.$Jg),t.$Og=t.$Jg.getComparisonKey.bind(t.$Jg),t.$Pg=t.$Jg.basenameOrAuthority.bind(t.$Jg),t.$Qg=t.$Jg.basename.bind(t.$Jg),t.$Rg=t.$Jg.extname.bind(t.$Jg),t.$Sg=t.$Jg.dirname.bind(t.$Jg),t.$Tg=t.$Jg.joinPath.bind(t.$Jg),t.$Ug=t.$Jg.normalizePath.bind(t.$Jg),t.$Vg=t.$Jg.relativePath.bind(t.$Jg),t.$Wg=t.$Jg.resolvePath.bind(t.$Jg),t.$Xg=t.$Jg.isAbsolutePath.bind(t.$Jg),t.$Yg=t.$Jg.isEqualAuthority.bind(t.$Jg),t.$Zg=t.$Jg.hasTrailingPathSeparator.bind(t.$Jg),t.$1g=t.$Jg.removeTrailingPathSeparator.bind(t.$Jg),t.$2g=t.$Jg.addTrailingPathSeparator.bind(t.$Jg);function w(d,e){const s=[];for(let a=0;a<d.length;a++){const m=e(d[a]);d.some((p,v)=>v===a?!1:(0,t.$Ng)(m,e(p)))||s.push(d[a])}return s}var P;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function e(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,g]=v.split(":");o&&g&&a.set(o,g)});const p=s.path.substring(0,s.path.indexOf(";"));return p&&a.set(d.META_DATA_MIME,p),a}d.parseMetaData=e})(P||(t.DataUri=P={}));function c(d,e,s){if(e){let a=d.path;return a&&a[0]!==z.$gc.sep&&(a=z.$gc.sep+a),d.with({scheme:s,authority:e,path:a})}return d.with({scheme:s})}}),define(me[9],be([1,0,30,6,4,3,41,5,53,23]),function(re,t,i,C,z,H,A,y,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jh=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.Promises=t.$Dh=t.$Ch=t.$Bh=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=void 0,t.$5g=w,t.$6g=P,t.$7g=c,t.$8g=d,t.$9g=e,t.$0g=s,t.$$g=a,t.$_g=m,t.$hh=B,t.$ih=D,t.$jh=x,t.$kh=W,t.$lh=T,t.$Ah=_,t.$Ih=f;function w(F){return!!F&&typeof F.then=="function"}function P(F){const l=new i.$de,u=F(l.token),n=new Promise((h,N)=>{const S=l.token.onCancellationRequested(()=>{S.dispose(),N(new C.$5)});Promise.resolve(u).then(O=>{S.dispose(),l.dispose(),h(O)},O=>{S.dispose(),l.dispose(),N(O)})});return new class{cancel(){l.cancel(),l.dispose()}then(h,N){return n.then(h,N)}catch(h){return this.then(void 0,h)}finally(h){return n.finally(h)}}}function c(F,l,u){return new Promise((n,h)=>{const N=l.onCancellationRequested(()=>{N.dispose(),n(u)});F.then(n,h).finally(()=>N.dispose())})}function d(F,l){return new Promise((u,n)=>{const h=l.onCancellationRequested(()=>{h.dispose(),n(new C.$5)});F.then(u,n).finally(()=>h.dispose())})}async function e(F){let l=-1;const u=F.map((n,h)=>n.then(N=>(l=h,N)));try{return await Promise.race(u)}finally{F.forEach((n,h)=>{h!==l&&n.cancel()})}}function s(F,l,u){let n;const h=setTimeout(()=>{n?.(void 0),u?.()},l);return Promise.race([F.finally(()=>clearTimeout(h)),new Promise(N=>n=N)])}function a(F){return new Promise((l,u)=>{const n=F();w(n)?n.then(l,u):l(n)})}function m(){let F,l;return{promise:new Promise((n,h)=>{F=n,l=h}),resolve:F,reject:l}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const u=()=>{if(this.b=null,this.f)return;const n=this.queue(this.d);return this.d=null,n};this.b=new Promise(n=>{this.a.then(u,u).then(n)})}return new Promise((u,n)=>{this.b.then(u,n)})}return this.a=l(),new Promise((u,n)=>{this.a.then(h=>{this.a=null,u(h)},h=>{this.a=null,n(h)})})}dispose(){this.f=!0}}t.$ah=p;class v{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$bh=v;class o{constructor(){this.a=new Map}queue(l,u){const h=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(u).finally(()=>{this.a.get(l)===h&&this.a.delete(l)});return this.a.set(l,h),h}}t.$ch=o;const g=(F,l)=>{let u=!0;const n=setTimeout(()=>{u=!1,l()},F);return{isTriggered:()=>u,dispose:()=>{clearTimeout(n),u=!1}}},r=F=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,F())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class E{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,u=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((h,N)=>{this.d=h,this.f=N}).then(()=>{if(this.b=null,this.d=null,this.g){const h=this.g;return this.g=null,h()}}));const n=()=>{this.a=null,this.d?.(null)};return this.a=u===b.$3d?r(n):g(u,n),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$dh=E;class R{constructor(l){this.a=new E(l),this.b=new p}trigger(l,u){return this.a.trigger(()=>this.b.queue(l),u)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$eh=R;class M{constructor(){this.a=!1,this.b=new Promise((l,u)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$fh=M;class j extends M{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$gh=j;function B(F,l){return l?new Promise((u,n)=>{const h=setTimeout(()=>{N.dispose(),u()},F),N=l.onCancellationRequested(()=>{clearTimeout(h),N.dispose(),n(new C.$5)})}):P(u=>B(F,u))}function D(F,l=0,u){const n=setTimeout(()=>{F(),u&&h.dispose()},l),h=(0,H.$Rc)(()=>{clearTimeout(n),u?.deleteAndLeak(h)});return u?.add(h),h}function x(F){const l=[];let u=0;const n=F.length;function h(){return u<n?F[u++]():null}function N(S){S!=null&&l.push(S);const O=h();return O?O.then(N):Promise.resolve(l)}return Promise.resolve(null).then(N)}function W(F,l=n=>!!n,u=null){let n=0;const h=F.length,N=()=>{if(n>=h)return Promise.resolve(u);const S=F[n++];return Promise.resolve(S()).then(V=>l(V)?Promise.resolve(V):N())};return N()}function T(F,l=n=>!!n,u=null){if(F.length===0)return Promise.resolve(u);let n=F.length;const h=()=>{n=-1;for(const N of F)N.cancel?.()};return new Promise((N,S)=>{for(const O of F)O.then(V=>{--n>=0&&l(V)?(h(),N(V)):n===0&&N(u)}).catch(V=>{--n>=0&&(h(),S(V))})})}class L{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new z.$6d}whenIdle(){return this.size>0?z.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((u,n)=>{this.g.push({factory:l,c:u,e:n}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const u=l.factory();u.then(l.c,l.e),u.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$mh=L;class I extends L{constructor(){super(1)}}t.$nh=I;class X{constructor(){this.a=new ae,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$oh=X;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new G;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,u=A.$Jg){const n=u.getComparisonKey(l);return this.a.get(n)?.size??0}queueFor(l,u,n=A.$Jg){const h=n.getComparisonKey(l);let N=this.a.get(h);if(!N){N=new I;const S=this.f++,O=z.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(h),this.h(),this.d?.deleteAndDispose(S),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$3c),this.d.set(S,O),this.a.set(h,N)}return N.queue(u)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$ph=U;class de{constructor(l,u){this.a=-1,typeof l=="function"&&typeof u=="number"&&this.setIfNotSet(l,u)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,u){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},u)}setIfNotSet(l,u){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},u))}}t.$qh=de;class he{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,u,n=globalThis){this.cancel();const h=n.setInterval(()=>{l()},u);this.d=(0,H.$Rc)(()=>{n.clearInterval(h),this.d=void 0})}dispose(){this.cancel()}}t.$rh=he;class ne{constructor(l,u){this.b=-1,this.a=l,this.d=u,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$sh=ne;class ge{constructor(l,u){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.a=l,this.b=u,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$th=ge;class Ne extends ne{constructor(l,u){super(l,u),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$uh=Ne;class Ce extends H.$Tc{constructor(l,u){super(),this.g=l,this.h=u,this.a=[],this.b=this.B(new H.$Uc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const u of l)this.a.push(u);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$vh=Ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$xh=(F,l)=>{(0,y.$B)(()=>{if(u)return;const n=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,n-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:t.$xh=(F,l,u)=>{const n=F.requestIdleCallback(l,typeof u=="number"?{timeout:u}:void 0);let h=!1;return{dispose(){h||(h=!0,F.cancelIdleCallback(n))}}},t.$wh=F=>(0,t.$xh)(globalThis,F)}();class Pe{constructor(l,u){this.g=!1,this.d=()=>{try{this.j=u()}catch(n){this.l=n}finally{this.g=!0}},this.f=(0,t.$xh)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$yh=Pe;class le extends Pe{constructor(l){super(globalThis,l)}}t.$zh=le;async function _(F,l,u){let n;for(let h=0;h<u;h++)try{return await F()}catch(N){n=N,await B(l)}throw n}class ae{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,u,n){return this.a={taskId:l,cancel:()=>n?.(),promise:u},u.then(()=>this.d(l),()=>this.d(l)),u}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:u,resolve:n,reject:h}=m();this.b={run:l,promise:u,promiseResolve:n,promiseReject:h}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Bh=ae;class oe{constructor(l,u=()=>Date.now()){this.d=l,this.f=u,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$Ch=oe;var J;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(J||(J={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,u)=>{this.a=l,this.b=u})}complete(l){return new Promise(u=>{this.a(l),this.d={outcome:0,value:l},u()})}error(l){return new Promise(u=>{this.b(l),this.d={outcome:1,value:l},u()})}cancel(){return this.error(new C.$5)}}t.$Dh=G;var ie;(function(F){async function l(n){let h;const N=await Promise.all(n.map(S=>S.then(O=>O,O=>{h||(h=O)})));if(typeof h<"u")throw h;return N}F.settled=l;function u(n){return new Promise(async(h,N)=>{try{await n(h,N)}catch(S){N(S)}})}F.withAsyncBody=u})(ie||(t.Promises=ie={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(u=>(this.a=u,this.d=!0,u),u=>{throw this.b=u,this.d=!0,u})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Eh=ce;class Ae{constructor(l){this.b=l,this.a=new $.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Fh=Ae;var Fe;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(Fe||(Fe={}));class ye{static fromArray(l){return new ye(u=>{u.emitMany(l)})}static fromPromise(l){return new ye(async u=>{u.emitMany(await l)})}static fromPromises(l){return new ye(async u=>{await Promise.all(l.map(async n=>u.emitOne(await n)))})}static merge(l){return new ye(async u=>{await Promise.all(l.map(async n=>{for await(const h of n)u.emitOne(h)}))})}static{this.EMPTY=ye.fromArray([])}constructor(l){this.a=0,this.b=[],this.d=null,this.f=new z.$6d,queueMicrotask(async()=>{const u={emitOne:n=>this.g(n),emitMany:n=>this.h(n),reject:n=>this.k(n)};try{await Promise.resolve(l(u)),this.j()}catch(n){this.k(n)}finally{u.emitOne=void 0,u.emitMany=void 0,u.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await z.Event.toPromise(this.f.event)}while(!0)}}}static map(l,u){return new ye(async n=>{for await(const h of l)n.emitOne(u(h))})}map(l){return ye.map(this,l)}static filter(l,u){return new ye(async n=>{for await(const h of l)u(h)&&n.emitOne(h)})}filter(l){return ye.filter(this,l)}static coalesce(l){return ye.filter(l,u=>!!u)}coalesce(){return ye.coalesce(this)}static async toPromise(l){const u=[];for await(const n of l)u.push(n);return u}toPromise(){return ye.toPromise(this)}g(l){this.a===0&&(this.b.push(l),this.f.fire())}h(l){this.a===0&&(this.b=this.b.concat(l),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(l){this.a===0&&(this.a=2,this.d=l,this.f.fire())}}t.$Gh=ye;class K extends ye{constructor(l,u){super(u),this.l=l}cancel(){this.l.cancel()}}t.$Hh=K;function f(F){const l=new i.$de,u=F(l.token);return new K(l,async n=>{const h=l.token.onCancellationRequested(()=>{h.dispose(),l.dispose(),n.reject(new C.$5)});try{for await(const N of u){if(l.token.isCancellationRequested)return;n.emitOne(N)}h.dispose(),l.dispose()}catch(N){h.dispose(),l.dispose(),n.reject(N)}})}class k{constructor(){this.a=new G,this.b=new ye(n=>{if(l){n.reject(l);return}return u&&n.emitMany(u),this.d=h=>n.reject(h),this.f=h=>n.emitOne(h),this.a.p});let l,u;this.f=n=>{u||(u=[]),u.push(n)},this.d=n=>{l||(l=n)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$Jh=k}),define(me[2],be([1,0,17,118,15,20,9,6,4,122,3,32,5,16,52,22]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e,s){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$rS=t.$pS=t.$mS=t.DetectedFullscreenMode=t.Namespace=t.$WR=t.$UR=t.$LR=t.$hR=t.$bR=t.$_Q=t.$$Q=t.$0Q=t.$5Q=t.$4Q=t.$3Q=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$1Q=m,t.$2Q=v,t.$6Q=M,t.$7Q=j,t.$8Q=B,t.$9Q=D,t.$aR=W,t.$cR=I,t.$dR=X,t.$eR=ne,t.$fR=ge,t.$gR=Ne,t.$iR=le,t.$jR=_,t.$kR=ae,t.$lR=oe,t.$mR=J,t.$nR=G,t.$oR=ie,t.$pR=ce,t.$qR=Ae,t.$rR=Fe,t.$sR=K,t.$tR=f,t.$uR=F,t.$vR=u,t.$wR=n,t.$xR=h,t.$yR=N,t.$zR=S,t.$AR=O,t.$BR=V,t.$CR=Z,t.$DR=ee,t.$ER=$e,t.$FR=ve,t.$GR=we,t.$HR=Se,t.$IR=Ee,t.$JR=Le,t.$KR=Ye,t.$MR=Ge,t.$NR=Ue,t.$OR=Ie,t.$PR=ze,t.$QR=_e,t.$RR=tt,t.$SR=st,t.$TR=Ze,t.$VR=rt,t.$XR=et,t.$YR=mt,t.$ZR=kt,t.$1R=St,t.$2R=Tt,t.$3R=Be,t.$4R=ue,t.$=it,t.$6R=at,t.$7R=Xe,t.$8R=ut,t.$9R=$t,t.$0R=Xt,t.$$R=Ei,t.$_R=ki,t.$aS=Si,t.$bS=Ti,t.$cS=Fi,t.$dS=Ni,t.$eS=Ci,t.$fS=Ri,t.$gS=Li,t.$hS=Ut,t.$iS=Ii,t.$jS=Mi,t.$kS=ji,t.$lS=_t,t.$nS=Bi,t.$oS=zi,t.$qS=Hi,t.h=qi,t.$tS=ti,t.$uS=Qi,a=function(){const q=new Map;(0,s.$tQ)(s.$uQ,1);const Q={window:s.$uQ,disposables:new w.$Sc};q.set(s.$uQ.vscodeWindowId,Q);const te=new b.$6d,fe=new b.$6d,ke=new b.$6d;function xe(Oe,We){return(typeof Oe=="number"?q.get(Oe):void 0)??(We?Q:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:ke.event,onDidUnregisterWindow:fe.event,registerWindow(Oe){if(q.has(Oe.vscodeWindowId))return w.$Tc.None;const We=new w.$Sc,qe={window:Oe,disposables:We.add(new w.$Sc)};return q.set(Oe.vscodeWindowId,qe),We.add((0,w.$Rc)(()=>{q.delete(Oe.vscodeWindowId),fe.fire(Oe)})),We.add(v(Oe,t.$UR.BEFORE_UNLOAD,()=>{ke.fire(Oe)})),te.fire(qe),We},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return q.has(Oe)},getWindowById:xe,getWindow(Oe){const We=Oe;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const qe=Oe;return qe?.view?qe.view.window:s.$uQ},getDocument(Oe){const We=Oe;return(0,t.getWindow)(We).document}}}(),t.registerWindow=a.registerWindow,t.getWindow=a.getWindow,t.getDocument=a.getDocument,t.getWindows=a.getWindows,t.getWindowsCount=a.getWindowsCount,t.getWindowId=a.getWindowId,t.getWindowById=a.getWindowById,t.hasWindow=a.hasWindow,t.onDidRegisterWindow=a.onDidRegisterWindow,t.onWillUnregisterWindow=a.onWillUnregisterWindow,t.onDidUnregisterWindow=a.onDidUnregisterWindow;function m(q){for(;q.firstChild;)q.firstChild.remove()}class p{constructor(Q,te,fe,ke){this.f=Q,this.g=te,this.d=fe,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function v(q,Q,te,fe){return new p(q,Q,te,fe)}function o(q,Q){return function(te){return Q(new H.$TQ(q,te))}}function g(q){return function(Q){return q(new z.$YQ(Q))}}const r=function(Q,te,fe,ke){let xe=fe;return te==="click"||te==="mousedown"?xe=o((0,t.getWindow)(Q),fe):(te==="keydown"||te==="keypress"||te==="keyup")&&(xe=g(fe)),v(Q,te,xe,ke)};t.$3Q=r;const E=function(Q,te,fe){const ke=o((0,t.getWindow)(Q),te);return M(Q,ke,fe)};t.$4Q=E;const R=function(Q,te,fe){const ke=o((0,t.getWindow)(Q),te);return B(Q,ke,fe)};t.$5Q=R;function M(q,Q,te){return v(q,c.$r&&C.$QQ.pointerEvents?t.$UR.POINTER_DOWN:t.$UR.MOUSE_DOWN,Q,te)}function j(q,Q,te){return v(q,c.$r&&C.$QQ.pointerEvents?t.$UR.POINTER_MOVE:t.$UR.MOUSE_MOVE,Q,te)}function B(q,Q,te){return v(q,c.$r&&C.$QQ.pointerEvents?t.$UR.POINTER_UP:t.$UR.MOUSE_UP,Q,te)}function D(q,Q,te){return(0,A.$xh)(q,Q,te)}class x extends A.$yh{constructor(Q,te){super(Q,te)}}t.$0Q=x;function W(q,Q,te,fe){let ke=0;const xe=q.setInterval(()=>{ke++,(typeof fe=="number"&&ke>=fe||Q()===!0)&&Oe.dispose()},te),Oe=(0,w.$Rc)(()=>{q.clearInterval(xe)});return Oe}class T extends A.$rh{constructor(Q){super(),this.f=Q&&(0,t.getWindow)(Q)}cancelAndSet(Q,te,fe){return super.cancelAndSet(Q,te,fe??this.f)}}t.$bR=T;class L{constructor(Q,te=0){this.d=Q,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,y.$1)(Q)}}static sort(Q,te){return te.priority-Q.priority}}(function(){const q=new Map,Q=new Map,te=new Map,fe=new Map,ke=xe=>{te.set(xe,!1);const Oe=q.get(xe)??[];for(Q.set(xe,Oe),q.set(xe,[]),fe.set(xe,!0);Oe.length>0;)Oe.sort(L.sort),Oe.shift().execute();fe.set(xe,!1)};t.$_Q=(xe,Oe,We=0)=>{const qe=(0,t.getWindowId)(xe),Qe=new L(Oe,We);let lt=q.get(qe);return lt||(lt=[],q.set(qe,lt)),lt.push(Qe),te.get(qe)||(te.set(qe,!0),xe.requestAnimationFrame(()=>ke(qe))),Qe},t.$$Q=(xe,Oe,We)=>{const qe=(0,t.getWindowId)(xe);if(fe.get(qe)){const Qe=new L(Oe,We);let lt=Q.get(qe);return lt||(lt=[],Q.set(qe,lt)),lt.push(Qe),Qe}else return(0,t.$_Q)(xe,Oe,We)}})();function I(q,Q){return(0,t.$_Q)(q,Q,1e4)}function X(q,Q){return(0,t.$_Q)(q,Q,-1e4)}const U=8,de=function(q,Q){return Q};class he extends w.$Tc{constructor(Q,te,fe,ke=de,xe=U){super();let Oe=null,We=0;const qe=this.B(new A.$qh),Qe=()=>{We=new Date().getTime(),fe(Oe),Oe=null};this.B(v(Q,te,lt=>{Oe=ke(Oe,lt);const Nt=new Date().getTime()-We;Nt>=xe?(qe.cancel(),Qe()):qe.setIfNotSet(Qe,xe-Nt)}))}}function ne(q,Q,te,fe,ke){return new he(q,Q,te,fe,ke)}function ge(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}function Ne(q,Q){const te=(0,t.getWindow)(q),fe=te.document;if(q!==fe.body)return new Pe(q.clientWidth,q.clientHeight);if(c.$r&&te?.visualViewport)return new Pe(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Pe(te.innerWidth,te.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Pe(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Pe(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(Q)return Ne(Q);throw new Error("Unable to figure out browser width and height")}class Ce{static d(Q,te){return parseFloat(te)||0}static f(Q,te,fe){const ke=ge(Q),xe=ke?ke.getPropertyValue(te):"0";return Ce.d(Q,xe)}static getBorderLeftWidth(Q){return Ce.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Ce.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Ce.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Ce.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Ce.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Ce.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Ce.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Ce.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Ce.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Ce.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Ce.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Ce.f(Q,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(Q,te){this.width=Q,this.height=te}with(Q=this.width,te=this.height){return Q!==this.width||te!==this.height?new Pe(Q,te):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Pe?Q:new Pe(Q.width,Q.height)}static equals(Q,te){return Q===te?!0:!Q||!te?!1:Q.width===te.width&&Q.height===te.height}}t.$hR=Pe;function le(q){let Q=q.offsetParent,te=q.offsetTop,fe=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){te-=q.scrollTop;const ke=N(q)?null:ge(q);ke&&(fe-=ke.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===Q&&(fe+=Ce.getBorderLeftWidth(q),te+=Ce.getBorderTopWidth(q),te+=q.offsetTop,fe+=q.offsetLeft,Q=q.offsetParent)}return{left:fe,top:te}}function _(q,Q,te){typeof Q=="number"&&(q.style.width=`${Q}px`),typeof te=="number"&&(q.style.height=`${te}px`)}function ae(q,Q,te,fe,ke,xe="absolute"){typeof Q=="number"&&(q.style.top=`${Q}px`),typeof te=="number"&&(q.style.right=`${te}px`),typeof fe=="number"&&(q.style.bottom=`${fe}px`),typeof ke=="number"&&(q.style.left=`${ke}px`),q.style.position=xe}function oe(q){const Q=q.getBoundingClientRect(),te=(0,t.getWindow)(q);return{left:Q.left+te.scrollX,top:Q.top+te.scrollY,width:Q.width,height:Q.height}}function J(q){let Q=q,te=1;do{const fe=ge(Q).zoom;fe!=null&&fe!=="1"&&(te*=fe),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return te}function G(q){const Q=Ce.getMarginLeft(q)+Ce.getMarginRight(q);return q.offsetWidth+Q}function ie(q){const Q=Ce.getBorderLeftWidth(q)+Ce.getBorderRightWidth(q),te=Ce.getPaddingLeft(q)+Ce.getPaddingRight(q);return q.offsetWidth-Q-te}function ce(q){const Q=Ce.getMarginLeft(q)+Ce.getMarginRight(q);return q.scrollWidth+Q}function Ae(q){const Q=Ce.getBorderTopWidth(q)+Ce.getBorderBottomWidth(q),te=Ce.getPaddingTop(q)+Ce.getPaddingBottom(q);return q.offsetHeight-Q-te}function Fe(q){const Q=Ce.getMarginTop(q)+Ce.getMarginBottom(q);return q.offsetHeight+Q}function ye(q,Q){if(q===null)return 0;const te=le(q),fe=le(Q);return te.left-fe.left}function K(q,Q){const te=Q.map(ke=>Math.max(ce(ke),G(ke))+ye(ke,q)||0);return Math.max(...te)}function f(q,Q){return!!Q?.contains(q)}const k="parentFlowToElementId";function F(q,Q){q.dataset[k]=Q.id}function l(q){const Q=q.dataset[k];return typeof Q=="string"?q.ownerDocument.getElementById(Q):null}function u(q,Q){let te=q;for(;te;){if(te===Q)return!0;if(te instanceof HTMLElement){const fe=l(te);if(fe){te=fe;continue}}te=te.parentNode}return!1}function n(q,Q,te){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(Q))return q;if(te){if(typeof te=="string"){if(q.classList.contains(te))return null}else if(q===te)return null}q=q.parentNode}return null}function h(q,Q,te){return!!n(q,Q,te)}function N(q){return q&&!!q.host&&!!q.mode}function S(q){return!!O(q)}function O(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return N(q)?q:null}function V(){let q=ve().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}function Z(q){return V()===q}function ee(q){return f(V(),q)}function $e(q){return q.ownerDocument===ve()}function ve(){return(0,t.getWindowsCount)()<=1?s.$uQ.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??s.$uQ.document}function we(){return ve().defaultView?.window??s.$uQ}const je=new Map;function Se(q){return je.has(q)}function Ee(){return new Re}class Re{constructor(){this.d="",this.f=void 0}setStyle(Q){Q!==this.d&&(this.d=Q,this.f?this.f.innerText=Q:this.f=Le(s.$uQ.document.head,te=>te.innerText=Q))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Le(q=s.$uQ.document.head,Q,te){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",Q?.(fe),q.appendChild(fe),te&&te.add((0,w.$Rc)(()=>q.removeChild(fe))),q===s.$uQ.document.head){const ke=new Set;je.set(fe,ke);for(const{window:xe,disposables:Oe}of(0,t.getWindows)()){if(xe===s.$uQ)continue;const We=Oe.add(nt(fe,ke,xe));te?.add(We)}}return fe}function Ye(q){const Q=new w.$Sc;for(const[te,fe]of je)Q.add(nt(te,fe,q));return Q}function nt(q,Q,te){const fe=new w.$Sc,ke=q.cloneNode(!0);te.document.head.appendChild(ke),fe.add((0,w.$Rc)(()=>te.document.head.removeChild(ke)));for(const xe of De(q))ke.sheet?.insertRule(xe.cssText,ke.sheet?.cssRules.length);return fe.add(t.$LR.observe(q,fe,{childList:!0})(()=>{ke.textContent=q.textContent})),Q.add(ke),fe.add((0,w.$Rc)(()=>Q.delete(ke))),fe}t.$LR=new class{constructor(){this.mutationObservers=new Map}observe(q,Q,te){let fe=this.mutationObservers.get(q);fe||(fe=new Map,this.mutationObservers.set(q,fe));const ke=(0,e.$7i)(te);let xe=fe.get(ke);if(xe)xe.users+=1;else{const Oe=new b.$6d,We=new MutationObserver(Qe=>Oe.fire(Qe));We.observe(q,te);const qe=xe={users:1,observer:We,onDidMutate:Oe.event};Q.add((0,w.$Rc)(()=>{qe.users-=1,qe.users===0&&(Oe.dispose(),We.disconnect(),fe?.delete(ke),fe?.size===0&&this.mutationObservers.delete(q))})),fe.set(ke,xe)}return xe.onDidMutate}};function Ge(q=s.$uQ.document.head){return Y("meta",q)}function Ue(q=s.$uQ.document.head){return Y("link",q)}function Y(q,Q=s.$uQ.document.head){const te=document.createElement(q);return Q.appendChild(te),te}let se=null;function pe(){return se||(se=Le()),se}function De(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Ie(q,Q,te=pe()){if(!(!te||!Q)){te.sheet?.insertRule(`${q} {${Q}}`,0);for(const fe of je.get(te)??[])Ie(q,Q,fe)}}function ze(q,Q=pe()){if(!Q)return;const te=De(Q),fe=[];for(let ke=0;ke<te.length;ke++){const xe=te[ke];Ve(xe)&&xe.selectorText.indexOf(q)!==-1&&fe.push(ke)}for(let ke=fe.length-1;ke>=0;ke--)Q.sheet?.deleteRule(fe[ke]);for(const ke of je.get(Q)??[])ze(q,ke)}function Ve(q){return typeof q.selectorText=="string"}function _e(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}function tt(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}function st(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}function Ze(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$UR={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$IQ?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$IQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$IQ?"webkitAnimationIteration":"animationiteration"};function rt(q){const Q=q;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$WR={stop:(q,Q)=>(q.preventDefault(),Q&&q.stopPropagation(),q)};function et(q){const Q=[];for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)Q[te]=q.scrollTop,q=q.parentNode;return Q}function mt(q,Q){for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)q.scrollTop!==Q[te]&&(q.scrollTop=Q[te]),q=q.parentNode}class gt extends w.$Tc{static m(Q){if(Q instanceof HTMLElement){const te=O(Q),fe=te?te.activeElement:Q.ownerDocument.activeElement;return f(fe,Q)}else{const te=Q;return f(te.document.activeElement,te.document)}}constructor(Q){super(),this.f=this.B(new b.$6d),this.onDidFocus=this.f.event,this.g=this.B(new b.$6d),this.onDidBlur=this.g.event;let te=gt.m(Q),fe=!1;const ke=()=>{fe=!1,te||(te=!0,this.f.fire())},xe=()=>{te&&(fe=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{fe&&(fe=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(Q)!==te&&(te?xe():ke())},this.B(v(Q,t.$UR.FOCUS,ke,!0)),this.B(v(Q,t.$UR.BLUR,xe,!0)),Q instanceof HTMLElement&&(this.B(v(Q,t.$UR.FOCUS_IN,()=>this.j())),this.B(v(Q,t.$UR.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(q){return new gt(q)}function St(q,Q){return q.after(Q),Q}function Tt(q,...Q){if(q.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}function Be(q,Q){return q.insertBefore(Q,q.firstChild),Q}function ue(q,...Q){q.innerText="",Tt(q,...Q)}const Te=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Me;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(Me||(t.Namespace=Me={}));function Ke(q,Q,te,...fe){const ke=Te.exec(Q);if(!ke)throw new Error("Bad use of emmet");const xe=ke[1]||"div";let Oe;return q!==Me.HTML?Oe=document.createElementNS(q,xe):Oe=document.createElement(xe),ke[3]&&(Oe.id=ke[3]),ke[4]&&(Oe.className=ke[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([We,qe])=>{typeof qe>"u"||(/^on\w+$/.test(We)?Oe[We]=qe:We==="selected"?qe&&Oe.setAttribute(We,"true"):Oe.setAttribute(We,qe))}),Oe.append(...fe),Oe}function it(q,Q,...te){return Ke(Me.HTML,q,Q,...te)}it.SVG=function(q,Q,...te){return Ke(Me.SVG,q,Q,...te)};function at(q,Q){const te=[];return q.forEach((fe,ke)=>{ke>0&&(Q instanceof Node?te.push(Q.cloneNode()):te.push(document.createTextNode(Q))),te.push(fe)}),te}function Xe(q,...Q){q?ut(...Q):$t(...Q)}function ut(...q){for(const Q of q)Q.style.display="",Q.removeAttribute("aria-hidden")}function $t(...q){for(const Q of q)Q.style.display="none",Q.setAttribute("aria-hidden","true")}function Ft(q,Q){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(Q))return q;q=q.parentNode}return null}function Xt(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Ft(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}function Ei(q){return Q=>{Q.preventDefault(),Q.stopPropagation(),q(Q)}}function ki(q){return new Promise(Q=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)Q(void 0);else{const fe=()=>{q.window.removeEventListener("DOMContentLoaded",fe,!1),Q()};q.window.addEventListener("DOMContentLoaded",fe,!1)}})}function Si(q,Q){const te=q.devicePixelRatio*Q;return Math.max(1,Math.floor(te))/q.devicePixelRatio}function Ti(q){s.$uQ.open(q,"_blank","noopener")}const Jt=780,Zt=640;function Fi(q){const Q=Math.floor(s.$uQ.screenLeft+s.$uQ.innerWidth/2-Jt/2),te=Math.floor(s.$uQ.screenTop+s.$uQ.innerHeight/2-Zt/2);s.$uQ.open(q,"_blank",`width=${Jt},height=${Zt},top=${te},left=${Q}`)}function Ni(q,Q=!0){const te=s.$uQ.open();return te?(Q&&(te.opener=null),te.location.href=q,!0):!1}function Ci(q,Q){const te=()=>{Q(),fe=(0,t.$_Q)(q,te)};let fe=(0,t.$_Q)(q,te);return(0,w.$Rc)(()=>fe.dispose())}P.$tg.setPreferredWebSchema(/^https:/.test(s.$uQ.location.href)?"https":"http");function Ri(q){return q?`url('${P.$Ag.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Li(q){return`'${q.replace(/'/g,"%27")}'`}function Ut(q,Q){if(q!==void 0){const te=q.match(/^\s*var\((.+)\)$/);if(te){const fe=te[1].split(",",2);return fe.length===2&&(Q=Ut(fe[1].trim(),Q)),`var(${fe[0]}, ${Q})`}return q}return Q}function Ii(q,Q){let te;if(d.URI.isUri(q))te=q.toString(!0);else{const xe=new Blob([q]);te=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(te))}const fe=we(),ke=document.createElement("a");fe.document.body.appendChild(ke),ke.download=Q,ke.href=te,ke.click(),setTimeout(()=>fe.document.body.removeChild(ke))}function Mi(){return new Promise(q=>{const Q=we(),te=document.createElement("input");Q.document.body.appendChild(te),te.type="file",te.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(te,"input"))(()=>{q(te.files??void 0)}),te.click(),setTimeout(()=>Q.document.body.removeChild(te))})}var Dt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function ji(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:Dt.BROWSER,guess:!1}:(c.$j||c.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}function _t(q,Q=!1){const te=document.createElement("a");return $.addHook("afterSanitizeAttributes",fe=>{for(const ke of["href","src"])if(fe.hasAttribute(ke)){const xe=fe.getAttribute(ke);if(ke==="href"&&xe.startsWith("#"))continue;if(te.href=xe,!q.includes(te.protocol.replace(/:$/,""))){if(Q&&ke==="src"&&te.href.startsWith("data:"))continue;fe.removeAttribute(ke)}}}),(0,w.$Rc)(()=>{$.removeHook("afterSanitizeAttributes")})}const Oi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$mS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(q,Q){const te=_t(Oi);try{const fe=$.sanitize(Q,Pi);q.innerHTML=fe}finally{te.dispose()}}function xi(q){const Q=new Uint16Array(q.length);for(let ke=0;ke<Q.length;ke++)Q[ke]=q.charCodeAt(ke);let te="";const fe=new Uint8Array(Q.buffer);for(let ke=0;ke<fe.length;ke++)te+=String.fromCharCode(fe[ke]);return te}function zi(q){return btoa(xi(q))}class pt extends b.$6d{constructor(){super(),this.o=new w.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:te})=>this.C(Q,te),{window:s.$uQ,disposables:this.o}))}C(Q,te){te.add(v(Q,"keydown",fe=>{if(fe.defaultPrevented)return;const ke=new z.$YQ(fe);if(!(ke.keyCode===6&&fe.repeat)){if(fe.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(fe.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(fe.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(fe.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(ke.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=fe.altKey,this.A.ctrlKey=fe.ctrlKey,this.A.metaKey=fe.metaKey,this.A.shiftKey=fe.shiftKey,this.A.lastKeyPressed&&(this.A.event=fe,this.fire(this.A))}},!0)),te.add(v(Q,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!fe.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!fe.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!fe.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=fe.altKey,this.A.ctrlKey=fe.ctrlKey,this.A.metaKey=fe.metaKey,this.A.shiftKey=fe.shiftKey,this.A.lastKeyReleased&&(this.A.event=fe,this.fire(this.A)))},!0)),te.add(v(Q.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(v(Q.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(v(Q.document.body,"mousemove",fe=>{fe.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(v(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$pS=pt;function Hi(q){const Q=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}class Wi extends w.$Tc{constructor(Q,te){super(),this.j=Q,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(v(this.j,t.$UR.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B(v(this.j,t.$UR.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B(v(this.j,t.$UR.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B(v(this.j,t.$UR.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(v(this.j,t.$UR.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B(v(this.j,t.$UR.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B(v(this.j,t.$UR.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$rS=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(q,...Q){let te,fe;Array.isArray(Q[0])?(te={},fe=Q[0]):(te=Q[0]||{},fe=Q[1]);const ke=Vi.exec(q);if(!ke||!ke.groups)throw new Error("Bad use of h");const xe=ke.groups.tag||"div",Oe=document.createElement(xe);ke.groups.id&&(Oe.id=ke.groups.id);const We=[];if(ke.groups.class)for(const Qe of ke.groups.class.split("."))Qe!==""&&We.push(Qe);if(te.className!==void 0)for(const Qe of te.className.split("."))Qe!==""&&We.push(Qe);We.length>0&&(Oe.className=We.join(" "));const qe={};if(ke.groups.name&&(qe[ke.groups.name]=Oe),fe)for(const Qe of fe)Qe instanceof HTMLElement?Oe.appendChild(Qe):typeof Qe=="string"?Oe.append(Qe):"root"in Qe&&(Object.assign(qe,Qe),Oe.appendChild(Qe.root));for(const[Qe,lt]of Object.entries(te))if(Qe!=="className")if(Qe==="style")for(const[Nt,Pt]of Object.entries(lt))Oe.style.setProperty(ei(Nt),typeof Pt=="number"?Pt+"px":""+Pt);else Qe==="tabIndex"?Oe.tabIndex=lt:Oe.setAttribute(ei(Qe),lt.toString());return qe.root=Oe,qe}function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,Q,te){for(const{name:fe,value:ke}of q.attributes)(!te||te.includes(fe))&&Q.setAttribute(fe,ke)}function Ki(q,Q,te){const fe=q.getAttribute(te);fe?Q.setAttribute(te,fe):Q.removeAttribute(te)}function Qi(q,Q,te){ti(q,Q,te);const fe=new w.$Sc;return fe.add(t.$LR.observe(q,fe,{attributes:!0,attributeFilter:te})(ke=>{for(const xe of ke)xe.type==="attributes"&&xe.attributeName&&Ki(q,Q,xe.attributeName)})),fe}}),define(me[57],be([1,0,2,3,121]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wS=t.$vS=void 0,t.$xS=A;class H extends C.$Tc{constructor(b,$){super(),this.B((0,i.$2Q)(b,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{$(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$2Q)(b,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$vS=H,t.$wS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:z.$vs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(y,b,$,w,P){const c=document.createElement("div");if(c.className=$,c.textContent=b,P&&(c.style.color=P),w&&(c.style.background=w),y.dataTransfer){const d=(0,i.getWindow)(y).document;d.body.appendChild(c),y.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>d.body.removeChild(c),0)}}}),define(me[58],be([1,0,2]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=C,t.$4S=z,t.$5S=H;function C(c,d={}){const e=H(d);return e.textContent=c,e}function z(c,d={}){const e=H(d);return b(e,$(c,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),e}function H(c){const d=c.inline?"span":"div",e=document.createElement(d);return c.className&&(e.className=c.className),e}class A{constructor(d){this.b=d,this.c=0}eos(){return this.c>=this.b.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.b[this.c]}advance(){this.c++}}var y;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(y||(y={}));function b(c,d,e,s){let a;if(d.type===2)a=document.createTextNode(d.content||"");else if(d.type===3)a=document.createElement("b");else if(d.type===4)a=document.createElement("i");else if(d.type===7&&s)a=document.createElement("code");else if(d.type===5&&e){const m=document.createElement("a");e.disposables.add(i.$3Q(m,"click",p=>{e.callback(String(d.index),p)})),a=m}else d.type===8?a=document.createElement("br"):d.type===1&&(a=c);a&&c!==a&&c.appendChild(a),a&&Array.isArray(d.children)&&d.children.forEach(m=>{b(a,m,e,s)})}function $(c,d){const e={type:1,children:[]};let s=0,a=e;const m=[],p=new A(c);for(;!p.eos();){let v=p.next();const o=v==="\\"&&P(p.peek(),d)!==0;if(o&&(v=p.next()),!o&&w(v,d)&&v===p.peek()){p.advance(),a.type===2&&(a=m.pop());const g=P(v,d);if(a.type===g||a.type===5&&g===6)a=m.pop();else{const r={type:g,children:[]};g===5&&(r.index=s,s++),a.children.push(r),m.push(a),a=r}}else if(v===`
`)a.type===2&&(a=m.pop()),a.children.push({type:8});else if(a.type!==2){const g={type:2,content:v};a.children.push(g),m.push(a),a=g}else a.content+=v}return a.type===2&&(a=m.pop()),m.length,e}function w(c,d){return P(c,d)!==0}function P(c,d){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return d?7:0;default:return 0}}}),define(me[59],be([1,0,2,3]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=void 0;class z{constructor(){this.a=new C.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,y){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,A&&b&&b(y)}isMonitoring(){return!!this.b}startMonitoring(A,y,b,$,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=$,this.c=w;let P=A;try{A.setPointerCapture(y),this.a.add((0,C.$Rc)(()=>{try{A.releasePointerCapture(y)}catch{}}))}catch{P=i.getWindow(A)}this.a.add(i.$2Q(P,i.$UR.POINTER_MOVE,c=>{if(c.buttons!==b){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$2Q(P,i.$UR.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$BS=z});var Je=this&&this.__decorate||function(re,t,i,C){var z=arguments.length,H=z<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,i):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(re,t,i,C);else for(var y=re.length-1;y>=0;y--)(A=re[y])&&(H=(z<3?A(H):z>3?A(t,i,H):A(t,i))||H);return z>3&&H&&Object.defineProperty(t,i,H),H};define(me[26],be([1,0,2,22,12,28,4,3,49]),function(re,t,i,C,z,H,A,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yS=t.EventType=void 0;var $;(function(P){P.Tap="-monaco-gesturetap",P.Change="-monaco-gesturechange",P.Start="-monaco-gesturestart",P.End="-monaco-gesturesend",P.Contextmenu="-monaco-gesturecontextmenu"})($||(t.EventType=$={}));class w extends y.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$4c,this.h=new b.$4c,this.m={},this.j=null,this.n=0,this.B(A.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:d})=>{d.add(i.$2Q(c.document,"touchstart",e=>this.s(e),{passive:!1})),d.add(i.$2Q(c.document,"touchend",e=>this.u(c,e))),d.add(i.$2Q(c.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:C.$uQ,disposables:this.q}))}static addTarget(c){if(!w.isTouchDevice())return y.$Tc.None;w.b||(w.b=(0,y.$Mc)(new w));const d=w.b.g.push(c);return(0,y.$Rc)(d)}static ignoreTarget(c){if(!w.isTouchDevice())return y.$Tc.None;w.b||(w.b=(0,y.$Mc)(new w));const d=w.b.h.push(c);return(0,y.$Rc)(d)}static isTouchDevice(){return"ontouchstart"in C.$uQ||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(c){const d=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=c.targetTouches.length;e<s;e++){const a=c.targetTouches.item(e);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:d,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[d],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const m=this.w($.Start,a.target);m.pageX=a.pageX,m.pageY=a.pageY,this.z(m)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}u(c,d){const e=Date.now(),s=Object.keys(this.m).length;for(let a=0,m=d.changedTouches.length;a<m;a++){const p=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(p.identifier))){console.warn("move of an UNKNOWN touch",p);continue}const v=this.m[p.identifier],o=Date.now()-v.initialTimeStamp;if(o<w.c&&Math.abs(v.initialPageX-z.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-z.$sb(v.rollingPageY))<30){const g=this.w($.Tap,v.initialTarget);g.pageX=z.$sb(v.rollingPageX),g.pageY=z.$sb(v.rollingPageY),this.z(g)}else if(o>=w.c&&Math.abs(v.initialPageX-z.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-z.$sb(v.rollingPageY))<30){const g=this.w($.Contextmenu,v.initialTarget);g.pageX=z.$sb(v.rollingPageX),g.pageY=z.$sb(v.rollingPageY),this.z(g)}else if(s===1){const g=z.$sb(v.rollingPageX),r=z.$sb(v.rollingPageY),E=z.$sb(v.rollingTimestamps)-v.rollingTimestamps[0],R=g-v.rollingPageX[0],M=r-v.rollingPageY[0],j=[...this.g].filter(B=>v.initialTarget instanceof Node&&B.contains(v.initialTarget));this.C(c,j,e,Math.abs(R)/E,R>0?1:-1,g,Math.abs(M)/E,M>0?1:-1,r)}this.z(this.w($.End,v.initialTarget)),delete this.m[p.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(c,d){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=d,e.tapCount=0,e}z(c){if(c.type===$.Tap){const d=new Date().getTime();let e=0;d-this.n>w.r?e=1:e=2,this.n=d,c.tapCount=e}else(c.type===$.Change||c.type===$.Contextmenu)&&(this.n=0);if(c.initialTarget instanceof Node){for(const d of this.h)if(d.contains(c.initialTarget))return;for(const d of this.g)d.contains(c.initialTarget)&&(d.dispatchEvent(c),this.f=!0)}}C(c,d,e,s,a,m,p,v,o){this.j=i.$_Q(c,()=>{const g=Date.now(),r=g-e;let E=0,R=0,M=!0;s+=w.a*r,p+=w.a*r,s>0&&(M=!1,E=a*s*r),p>0&&(M=!1,R=v*p*r);const j=this.w($.Change);j.translationX=E,j.translationY=R,d.forEach(B=>B.dispatchEvent(j)),M||this.C(c,d,g,s,a,m+E,p,v,o+R)})}D(c){const d=Date.now();for(let e=0,s=c.changedTouches.length;e<s;e++){const a=c.changedTouches.item(e);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const m=this.m[a.identifier],p=this.w($.Change,m.initialTarget);p.translationX=a.pageX-z.$sb(m.rollingPageX),p.translationY=a.pageY-z.$sb(m.rollingPageY),p.pageX=a.pageX,p.pageY=a.pageY,this.z(p),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(a.pageX),m.rollingPageY.push(a.pageY),m.rollingTimestamps.push(d)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}t.$yS=w,Je([H.$Kh],w,"isTouchDevice",null)}),define(me[60],be([1,0,2,96]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7S=$,t.$8S=w,t.$9S=P;const C=2e4;let z,H,A,y,b;function $(d){z=document.createElement("div"),z.className="monaco-aria-container";const e=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),z.appendChild(a),a};H=e(),A=e();const s=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),z.appendChild(a),a};y=s(),b=s(),d.appendChild(z)}function w(d){z&&(H.textContent!==d?(i.$1Q(A),c(H,d)):(i.$1Q(H),c(A,d)))}function P(d){z&&(y.textContent!==d?(i.$1Q(b),c(y,d)):(i.$1Q(y),c(b,d)))}function c(d,e){i.$1Q(d),e.length>C&&(e=e.substr(0,C)),d.textContent=e,d.style.visibility="hidden",d.style.visibility="visible"}}),define(me[123],be([1,0,2,19]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zT=H,t.$AT=A;const z=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(y){const b=new Array;let $,w=0,P=0;for(;($=z.exec(y))!==null;){P=$.index||0,w<P&&b.push(y.substring(w,P)),w=($.index||0)+$[0].length;const[,c,d]=$;b.push(c?`$(${d})`:A({id:d}))}return w<y.length&&b.push(y.substring(w)),b}function A(y){const b=i.$("span");return b.classList.add(...C.ThemeIcon.asClassNameArray(y)),b}}),define(me[124],be([1,0,2]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cT=void 0;function C(H){try{H.parentElement?.removeChild(H)}catch{}}class z{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let y=this.h(A).pop(),b=!1;if(y)b=this.b.has(y.domNode),b&&this.b.delete(y.domNode);else{const $=(0,i.$)(".monaco-list-row"),P=this.i(A).renderTemplate($);y={domNode:$,templateId:A,templateData:P}}return{row:y,isReusingConnectedDomNode:b}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const y of this.b)this.g(y);this.b.clear(),this.c=!1}}f(A){const{domNode:y,templateId:b}=A;y&&(this.c?this.b.add(y):this.g(y)),this.h(b).push(A)}g(A){A.classList.remove("scrolling"),C(A)}h(A){let y=this.a.get(A);return y||(y=[],this.a.set(A,y)),y}dispose(){this.a.forEach((A,y)=>{for(const b of A)this.i(y).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(A){const y=this.d.get(A);if(!y)throw new Error(`No renderer found for ${A}`);return y}}t.$cT=z}),define(me[125],be([1,0,9,3]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GS=void 0;class z extends C.$Tc{constructor(A,y,b){super(),this.a=A,this.b=y,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$qh)}setVisibility(A){this.a!==A&&(this.a=A,this.s())}setShouldBeVisible(A){this.g=A,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const A=this.r();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.j!==A&&(this.j=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(A){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$GS=z}),define(me[126],be([1,0,2,26,12,4,3,5]),function(re,t,i,C,z,H,A,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HT=void 0;class b extends A.$Tc{constructor(w,P,c,d){super(),this.f=0,this.b=d||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$6d),this.h=c,this.j(),this.setOptions(w,P)}j(){this.B(C.$yS.addTarget(this.a)),[C.EventType.Tap].forEach(w=>{this.B(i.$2Q(this.a,w,P=>{this.a.focus()}))}),this.B(i.$3Q(this.a,"click",w=>{i.$WR.stop(w,!0)})),this.B(i.$3Q(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(i.$3Q(this.a,"keydown",w=>{let P=!1;y.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(P=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(P=!0),P&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,P){(!this.c||!z.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((c,d)=>{this.a.add(this.m(c.text,d,c.isDisabled))})),P!==void 0&&this.select(P)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,P,c){const d=document.createElement("option");return d.value=w,d.text=w,d.disabled=!!c,d}}t.$HT=b}),define(me[61],be([1,0,27,12,9,53,90,4,29]),function(re,t,i,C,z,H,A,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eV=void 0,t.$cV=$,t.$dV=w;function $(d){return typeof d=="object"&&"visibility"in d&&"data"in d}function w(d){switch(d){case!0:return 1;case!1:return 0;default:return d}}function P(d){return typeof d.collapsible=="boolean"}class c{constructor(e,s,a,m={}){this.o=e,this.p=s,this.rootRef=[],this.d=new y.$be,this.f=new y.$6d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.$6d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.$6d,this.onDidSplice=this.l.event,this.m=new z.$dh(H.$3d),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:a,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,a=b.Iterable.empty(),m={}){if(e.length===0)throw new i.$aV(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,s,a,m):this.s(e,s,a,m)}q(e,s,a,m=b.Iterable.empty(),p,v=p.diffDepth??0){const{parentNode:o}=this.G(s);if(!o.lastDiffIds)return this.s(s,a,m,p);const g=[...m],r=s[s.length-1],E=new A.$et({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,r),...g,...o.children.slice(r+a)].map(D=>e.getId(D.element).toString())}).ComputeDiff(!1);if(E.quitEarly)return o.lastDiffIds=void 0,this.s(s,a,g,p);const R=s.slice(0,-1),M=(D,x,W)=>{if(v>0)for(let T=0;T<W;T++)D--,x--,this.q(e,[...R,D,0],Number.MAX_SAFE_INTEGER,g[x].children,p,v-1)};let j=Math.min(o.children.length,r+a),B=g.length;for(const D of E.changes.sort((x,W)=>W.originalStart-x.originalStart))M(j,B,j-(D.originalStart+D.originalLength)),j=D.originalStart,B=D.modifiedStart-r,this.s([...R,j],D.originalLength,b.Iterable.slice(g,B,B+D.modifiedLength),p);M(j,B,j)}s(e,s,a=b.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:p,diffIdentityProvider:v}){const{parentNode:o,listIndex:g,revealed:r,visible:E}=this.G(e),R=[],M=b.Iterable.map(a,X=>this.w(X,o,o.visible?1:0,r,R,m)),j=e[e.length-1];let B=0;for(let X=j;X>=0&&X<o.children.length;X--){const U=o.children[X];if(U.visible){B=U.visibleChildIndex;break}}const D=[];let x=0,W=0;for(const X of M)D.push(X),W+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=B+x++);const T=(0,C.$6b)(o.children,j,s,D);v?o.lastDiffIds?(0,C.$6b)(o.lastDiffIds,j,s,D.map(X=>v.getId(X.element).toString())):o.lastDiffIds=o.children.map(X=>v.getId(X.element).toString()):o.lastDiffIds=void 0;let L=0;for(const X of T)X.visible&&L++;if(L!==0)for(let X=j+D.length;X<o.children.length;X++){const U=o.children[X];U.visible&&(U.visibleChildIndex-=L)}if(o.visibleChildrenCount+=x-L,r&&E){const X=T.reduce((U,de)=>U+(de.visible?de.renderNodeCount:0),0);this.B(o,W-X),this.p.splice(g,X,R)}if(T.length>0&&p){const X=U=>{p(U),U.children.forEach(X)};T.forEach(X)}this.l.fire({insertedNodes:D,deletedNodes:T});let I=o;for(;I;){if(I.visibility===2){this.m.trigger(()=>this.refilter());break}I=I.parent}}rerender(e){if(e.length===0)throw new i.$aV(this.o,"Invalid tree location");const{node:s,listIndex:a,revealed:m}=this.F(e);s.visible&&m&&this.p.splice(a,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$aV(this.o,"Invalid tree location");const{listIndex:a}=this.F(e);this.p.updateElementHeight(a,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:a,revealed:m}=this.F(e);return a&&m?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const a=this.E(e);typeof s>"u"&&(s=!a.collapsible);const m={collapsible:s};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,a){const m=this.E(e);typeof s>"u"&&(s=!m.collapsed);const p={collapsed:s,recursive:a||!1};return this.d.bufferEvents(()=>this.t(e,p))}t(e,s){const{node:a,listIndex:m,revealed:p}=this.F(e),v=this.u(a,m,p,s);if(a!==this.c&&this.k&&v&&!P(s)&&a.collapsible&&!a.collapsed&&!s.recursive){let o=-1;for(let g=0;g<a.children.length;g++)if(a.children[g].visible)if(o>-1){o=-1;break}else o=g;o>-1&&this.t([...e,o],s)}return v}u(e,s,a,m){const p=this.v(e,m,!1);if(!a||!e.visible||!p)return p;const v=e.renderNodeCount,o=this.x(e),g=v-(s===-1?0:1);return this.p.splice(s+1,g,o.slice(1)),p}v(e,s,a){let m;if(e===this.c?m=!1:(P(s)?(m=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(m=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):m=!1,m&&this.f.fire({node:e,deep:a})),!P(s)&&s.recursive)for(const p of e.children)m=this.v(p,s,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,a,m,p,v){const o={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},g=this.C(o,a);o.visibility=g,m&&p.push(o);const r=e.children||b.Iterable.empty(),E=m&&g!==0&&!o.collapsed;let R=0,M=1;for(const j of r){const B=this.w(j,o,g,E,p,v);o.children.push(B),M+=B.renderNodeCount,B.visible&&(B.visibleChildIndex=R++)}return o.collapsible=o.collapsible||o.children.length>0,o.visibleChildrenCount=R,o.visible=g===2?R>0:g===1,o.visible?o.collapsed||(o.renderNodeCount=M):(o.renderNodeCount=0,m&&p.pop()),v?.(o),o}x(e){const s=e.renderNodeCount,a=[];return this.y(e,a),this.B(e.parent,a.length-s),a}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const a of e.children)e.renderNodeCount+=this.y(a,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,a=[];return this.A(e,e.visible?1:0,a),this.B(e.parent,a.length-s),a}A(e,s,a,m=!0){let p;if(e!==this.c){if(p=this.C(e,s),p===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&a.push(e)}const v=a.length;e.renderNodeCount=e===this.c?0:1;let o=!1;if(!e.collapsed||p!==0){let g=0;for(const r of e.children)o=this.A(r,p,a,m&&!e.collapsed)||o,r.visible&&(r.visibleChildIndex=g++);e.visibleChildrenCount=g}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=p===2?o:p===1,e.visibility=p),e.visible?e.collapsed||(e.renderNodeCount+=a.length-v):(e.renderNodeCount=0,m&&a.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const a=this.j?this.j.filter(e.element,s):1;return typeof a=="boolean"?(e.filterData=void 0,a?1:0):$(a)?(e.filterData=a.data,w(a.visibility)):(e.filterData=void 0,w(a))}D(e,s=this.c){if(!e||e.length===0)return!0;const[a,...m]=e;return a<0||a>s.children.length?!1:this.D(m,s.children[a])}E(e,s=this.c){if(!e||e.length===0)return s;const[a,...m]=e;if(a<0||a>s.children.length)throw new i.$aV(this.o,"Invalid tree location");return this.E(m,s.children[a])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:a,revealed:m,visible:p}=this.G(e),v=e[e.length-1];if(v<0||v>s.children.length)throw new i.$aV(this.o,"Invalid tree location");const o=s.children[v];return{node:o,listIndex:a,revealed:m,visible:p&&o.visible}}G(e,s=this.c,a=0,m=!0,p=!0){const[v,...o]=e;if(v<0||v>s.children.length)throw new i.$aV(this.o,"Invalid tree location");for(let g=0;g<v;g++)a+=s.children[g].renderNodeCount;return m=m&&!s.collapsed,p=p&&s.visible,o.length===0?{parentNode:s,listIndex:a,revealed:m,visible:p}:this.G(o,s.children[v],a+1,m,p)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let a=e;for(;a.parent;)s.push(a.parent.children.indexOf(a)),a=a.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$eV=c}),define(me[127],be([1,0,61,27,29]),function(re,t,i,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lV=void 0;class H{get size(){return this.d.size}constructor(y,b,$={}){this.k=y,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$eV(y,b,null,$),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,$.sorter&&(this.j={compare(w,P){return $.sorter.compare(w.element,P.element)}}),this.h=$.identityProvider}setChildren(y,b=z.Iterable.empty(),$={}){const w=this.o(y);this.l(w,this.m(b),$)}l(y,b=z.Iterable.empty(),$){const w=new Set,P=new Set,c=e=>{if(e.element===null)return;const s=e;if(w.add(s.element),this.d.set(s.element,s),this.h){const a=this.h.getId(s.element).toString();P.add(a),this.f.set(a,s)}$.onDidCreateNode?.(s)},d=e=>{if(e.element===null)return;const s=e;if(w.has(s.element)||this.d.delete(s.element),this.h){const a=this.h.getId(s.element).toString();P.has(a)||this.f.delete(a)}$.onDidDeleteNode?.(s)};this.c.splice([...y,0],Number.MAX_VALUE,b,{...$,onDidCreateNode:c,onDidDeleteNode:d})}m(y=z.Iterable.empty()){return this.j&&(y=[...y].sort(this.j.compare.bind(this.j))),z.Iterable.map(y,b=>{let $=this.d.get(b.element);if(!$&&this.h){const c=this.h.getId(b.element).toString();$=this.f.get(c)}if(!$){let c;return typeof b.collapsed>"u"?c=void 0:b.collapsed===C.ObjectTreeElementCollapseState.Collapsed||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:b.collapsed===C.ObjectTreeElementCollapseState.Expanded||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!b.collapsed,{...b,children:this.m(b.children),collapsed:c}}const w=typeof b.collapsible=="boolean"?b.collapsible:$.collapsible;let P;return typeof b.collapsed>"u"||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?P=$.collapsed:b.collapsed===C.ObjectTreeElementCollapseState.Collapsed?P=!0:b.collapsed===C.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!b.collapsed,{...b,collapsible:w,collapsed:P,children:this.m(b.children)}})}rerender(y){const b=this.o(y);this.c.rerender(b)}updateElementHeight(y,b){const $=this.o(y);this.c.updateElementHeight($,b)}resort(y=null,b=!0){if(!this.j)return;const $=this.o(y),w=this.c.getNode($);this.l($,this.n(w,b),{})}n(y,b,$=!0){let w=[...y.children];return(b||$)&&(w=w.sort(this.j.compare.bind(this.j))),z.Iterable.map(w,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,b,!1)}))}getFirstElementChild(y=null){const b=this.o(y);return this.c.getFirstElementChild(b)}getLastElementAncestor(y=null){const b=this.o(y);return this.c.getLastElementAncestor(b)}has(y){return this.d.has(y)}getListIndex(y){const b=this.o(y);return this.c.getListIndex(b)}getListRenderCount(y){const b=this.o(y);return this.c.getListRenderCount(b)}isCollapsible(y){const b=this.o(y);return this.c.isCollapsible(b)}setCollapsible(y,b){const $=this.o(y);return this.c.setCollapsible($,b)}isCollapsed(y){const b=this.o(y);return this.c.isCollapsed(b)}setCollapsed(y,b,$){const w=this.o(y);return this.c.setCollapsed(w,b,$)}expandTo(y){const b=this.o(y);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(y=null){if(y===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(y);if(!b)throw new C.$aV(this.k,`Tree element not found: ${y}`);return b}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new C.$aV(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(y);if(!b)throw new C.$aV(this.k,`Tree element not found: ${y}`);const $=this.c.getNodeLocation(b),w=this.c.getParentNodeLocation($);return this.c.getNode(w).element}o(y){if(y===null)return[];const b=this.d.get(y);if(!b)throw new C.$aV(this.k,`Tree element not found: ${y}`);return this.c.getNodeLocation(b)}}t.$lV=H}),define(me[21],be([1,0,2,15,20,26,3]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0;class y extends A.$Tc{f($,w){this.B(i.$2Q($,i.$UR.CLICK,P=>w(new z.$TQ(i.getWindow($),P))))}j($,w){this.B(i.$2Q($,i.$UR.MOUSE_DOWN,P=>w(new z.$TQ(i.getWindow($),P))))}m($,w){this.B(i.$2Q($,i.$UR.MOUSE_OVER,P=>w(new z.$TQ(i.getWindow($),P))))}u($,w){this.B(i.$2Q($,i.$UR.MOUSE_LEAVE,P=>w(new z.$TQ(i.getWindow($),P))))}z($,w){this.B(i.$2Q($,i.$UR.KEY_DOWN,P=>w(new C.$YQ(P))))}C($,w){this.B(i.$2Q($,i.$UR.KEY_UP,P=>w(new C.$YQ(P))))}D($,w){this.B(i.$2Q($,i.$UR.INPUT,w))}F($,w){this.B(i.$2Q($,i.$UR.BLUR,w))}G($,w){this.B(i.$2Q($,i.$UR.FOCUS,w))}H($,w){this.B(i.$2Q($,i.$UR.CHANGE,w))}I($){return H.$yS.ignoreTarget($)}}t.$CS=y}),define(me[42],be([1,0,59,21,9,19,2]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ES=t.$DS=void 0,t.$DS=11;class y extends C.$CS{constructor($){super(),this.a=$.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=$.bgWidth+"px",this.bgDomNode.style.height=$.bgHeight+"px",typeof $.top<"u"&&(this.bgDomNode.style.top="0px"),typeof $.left<"u"&&(this.bgDomNode.style.left="0px"),typeof $.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof $.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=$.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray($.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$DS+"px",this.domNode.style.height=t.$DS+"px",typeof $.top<"u"&&(this.domNode.style.top=$.top+"px"),typeof $.left<"u"&&(this.domNode.style.left=$.left+"px"),typeof $.bottom<"u"&&(this.domNode.style.bottom=$.bottom+"px"),typeof $.right<"u"&&(this.domNode.style.right=$.right+"px"),this.g=this.B(new i.$BS),this.B(A.$3Q(this.bgDomNode,A.$UR.POINTER_DOWN,w=>this.h(w))),this.B(A.$3Q(this.domNode,A.$UR.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new A.$bR),this.c=this.B(new z.$qh)}h($){if(!$.target||!($.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow($))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring($.target,$.pointerId,$.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),$.preventDefault()}}t.$ES=y}),define(me[62],be([1,0,2,45,59,42,125,21,5]),function(re,t,i,C,z,H,A,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=void 0;const $=140;class w extends y.$CS{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new A.$GS(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new z.$BS),this.s=!0,this.domNode=(0,C.$AS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$2Q(this.domNode.domNode,i.$UR.POINTER_DOWN,d=>this.M(d)))}t(c){const d=this.B(new H.$ES(c));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}w(c,d,e,s){this.slider=(0,C.$AS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(d),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$2Q(this.slider.domNode,i.$UR.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.O(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const d=this.domNode.domNode.getClientRects()[0].top,e=d+this.h.getSliderPosition(),s=d+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.U(c);e<=a&&a<=s?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let d,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")d=c.offsetX,e=c.offsetY;else{const a=i.$lR(this.domNode.domNode);d=c.pageX-a.left,e=c.pageY-a.top}const s=this.S(d,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const d=this.U(c),e=this.W(c),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,a=>{const m=this.W(a),p=Math.abs(m-e);if(b.$i&&p>$){this.P(s.getScrollPosition());return}const o=this.U(a)-d;this.P(s.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const d={};this.writeScrollPosition(d,c),this.b.setScrollPositionNow(d)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$HS=w}),define(me[128],be([1,0,20,62,42,46,18]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IS=void 0;class y extends C.$HS{constructor($,w,P){const c=$.getScrollDimensions(),d=$.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$FS(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,c.width,c.scrollWidth,d.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:$,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-z.$DS)/2,s=(w.horizontalScrollbarSize-z.$DS)/2;this.t({className:"scra",icon:A.$Fj.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$VQ(null,1,0))}),this.t({className:"scra",icon:A.$Fj.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$VQ(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R($,w){this.slider.setWidth($),this.slider.setLeft(w)}Q($,w){this.domNode.setWidth($),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll($){return this.s=this.J($.scrollWidth)||this.s,this.s=this.L($.scrollLeft)||this.s,this.s=this.y($.width)||this.s,this.s}S($,w){return $}U($){return $.pageX}W($){return $.pageY}X($){this.slider.setHeight($)}writeScrollPosition($,w){$.scrollLeft=w}updateOptions($){this.updateScrollbarSize($.horizontal===2?0:$.horizontalScrollbarSize),this.h.setOppositeScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.n.setVisibility($.horizontal),this.c=$.scrollByPage}}t.$IS=y}),define(me[129],be([1,0,20,62,42,46,18]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JS=void 0;class y extends C.$HS{constructor($,w,P){const c=$.getScrollDimensions(),d=$.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$FS(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,c.height,c.scrollHeight,d.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:$,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-z.$DS)/2,s=(w.verticalScrollbarSize-z.$DS)/2;this.t({className:"scra",icon:A.$Fj.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$VQ(null,0,1))}),this.t({className:"scra",icon:A.$Fj.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$VQ(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R($,w){this.slider.setHeight($),this.slider.setTop(w)}Q($,w){this.domNode.setWidth(w),this.domNode.setHeight($),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll($){return this.s=this.J($.scrollHeight)||this.s,this.s=this.L($.scrollTop)||this.s,this.s=this.y($.height)||this.s,this.s}S($,w){return w}U($){return $.pageY}W($){return $.pageX}X($){this.slider.setWidth($)}writeScrollPosition($,w){$.scrollTop=w}updateOptions($){this.updateScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility($.vertical),this.c=$.scrollByPage}}t.$JS=y}),define(me[63],be([1,0,17,2,45,20,128,129,21,9,4,3,5,51,103]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=t.$NS=t.$MS=t.$LS=t.$KS=void 0;const e=500,s=50,a=!0;class m{constructor(M,j,B){this.timestamp=M,this.deltaX=j,this.deltaY=B,this.score=0}}class p{static{this.INSTANCE=new p}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let M=1,j=0,B=1,D=this.d;do{const x=D===this.c?M:Math.pow(2,-B);if(M-=x,j+=this.b[D].score*x,D===this.c)break;D=(this.a+D-1)%this.a,B++}while(!0);return j<=.5}acceptStandardWheelEvent(M){if(i.$JQ){const j=C.getWindow(M.browserEvent),B=(0,i.$CQ)(j);this.accept(Date.now(),M.deltaX*B,M.deltaY*B)}else this.accept(Date.now(),M.deltaX,M.deltaY)}accept(M,j,B){const D=new m(M,j,B);D.score=this.f(D),this.c===-1&&this.d===-1?(this.b[0]=D,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=D)}f(M){if(Math.abs(M.deltaX)>0&&Math.abs(M.deltaY)>0)return 1;let j=.5;const B=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(M.deltaX)||!this.g(M.deltaY))&&(j+=.25),Math.min(Math.max(j,0),1)}g(M){return Math.abs(Math.round(M)-M)<.01}}t.$KS=p;class v extends b.$CS{get options(){return this.a}constructor(M,j,B){super(),this.O=this.B(new w.$6d),this.onScroll=this.O.event,this.P=this.B(new w.$6d),this.onWillScroll=this.P.event,M.style.overflow="hidden",this.a=E(j),this.b=B,this.B(this.b.onScroll(x=>{this.P.fire(x),this.S(x),this.O.fire(x)}));const D={onMouseWheel:x=>this.R(x),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new y.$JS(this.b,this.a,D)),this.g=this.B(new A.$IS(this.b,this.a,D)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(M),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,z.$AS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,z.$AS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,z.$AS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,x=>this.Z(x)),this.u(this.t,x=>this.Y(x)),this.L=this.B(new $.$qh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(M){this.c.delegatePointerDown(M)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(M){this.b.setScrollDimensions(M,!1)}updateClassName(M){this.a.className=M,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(M){typeof M.handleMouseWheel<"u"&&(this.a.handleMouseWheel=M.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof M.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=M.mouseWheelScrollSensitivity),typeof M.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=M.fastScrollSensitivity),typeof M.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=M.scrollPredominantAxis),typeof M.horizontal<"u"&&(this.a.horizontal=M.horizontal),typeof M.vertical<"u"&&(this.a.vertical=M.vertical),typeof M.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=M.horizontalScrollbarSize),typeof M.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=M.verticalScrollbarSize),typeof M.scrollByPage<"u"&&(this.a.scrollByPage=M.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(M){this.N=M}delegateScrollFromMouseWheelEvent(M){this.R(new H.$VQ(M))}Q(M){if(this.w.length>0!==M&&(this.w=(0,P.$Oc)(this.w),M)){const B=D=>{this.R(new H.$VQ(D))};this.w.push(C.$2Q(this.t,C.$UR.MOUSE_WHEEL,B,{passive:!1}))}}R(M){if(M.browserEvent?.defaultPrevented)return;const j=p.INSTANCE;a&&j.acceptStandardWheelEvent(M);let B=!1;if(M.deltaY||M.deltaX){let x=M.deltaY*this.a.mouseWheelScrollSensitivity,W=M.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+x===0?W=x=0:Math.abs(x)>=Math.abs(W)?W=0:x=0),this.a.flipAxes&&([x,W]=[W,x]);const T=!c.$j&&M.browserEvent&&M.browserEvent.shiftKey;(this.a.scrollYToX||T)&&!W&&(W=x,x=0),M.browserEvent&&M.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,x=x*this.a.fastScrollSensitivity);const L=this.b.getFutureScrollPosition();let I={};if(x){const X=s*x,U=L.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(I,U)}if(W){const X=s*W,U=L.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(I,U)}I=this.b.validateScrollPosition(I),(L.scrollLeft!==I.scrollLeft||L.scrollTop!==I.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&j.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(I):this.b.setScrollPositionNow(I),B=!0)}let D=B;!D&&this.a.alwaysConsumeMouseWheel&&(D=!0),!D&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(D=!0),D&&(M.preventDefault(),M.stopPropagation())}S(M){this.M=this.g.onDidScroll(M)||this.M,this.M=this.c.onDidScroll(M)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const M=this.b.getCurrentScrollPosition(),j=M.scrollTop>0,B=M.scrollLeft>0,D=B?" left":"",x=j?" top":"",W=B||j?" top-left-corner":"";this.n.setClassName(`shadow${D}`),this.r.setClassName(`shadow${x}`),this.s.setClassName(`shadow${W}${x}${D}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(M){this.J=!1,this.ab()}Z(M){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$LS=v;class o extends v{constructor(M,j){j=j||{},j.mouseWheelSmoothScroll=!1;const B=new d.$Bs({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:D=>C.$_Q(C.getWindow(M),D)});super(M,j,B),this.B(B)}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$MS=o;class g extends v{constructor(M,j,B){super(M,j,B)}setScrollPosition(M){M.reuseAnimation?this.b.setScrollPositionSmooth(M,M.reuseAnimation):this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$NS=g;class r extends v{constructor(M,j){j=j||{},j.mouseWheelSmoothScroll=!1;const B=new d.$Bs({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:D=>C.$_Q(C.getWindow(M),D)});super(M,j,B),this.B(B),this.cb=M,this.B(this.onScroll(D=>{D.scrollTopChanged&&(this.cb.scrollTop=D.scrollTop),D.scrollLeftChanged&&(this.cb.scrollLeft=D.scrollLeft)})),this.scanDomNode()}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$OS=r;function E(R){const M={lazyRender:typeof R.lazyRender<"u"?R.lazyRender:!1,className:typeof R.className<"u"?R.className:"",useShadows:typeof R.useShadows<"u"?R.useShadows:!0,handleMouseWheel:typeof R.handleMouseWheel<"u"?R.handleMouseWheel:!0,flipAxes:typeof R.flipAxes<"u"?R.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof R.consumeMouseWheelIfScrollbarIsNeeded<"u"?R.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof R.alwaysConsumeMouseWheel<"u"?R.alwaysConsumeMouseWheel:!1,scrollYToX:typeof R.scrollYToX<"u"?R.scrollYToX:!1,mouseWheelScrollSensitivity:typeof R.mouseWheelScrollSensitivity<"u"?R.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof R.fastScrollSensitivity<"u"?R.fastScrollSensitivity:5,scrollPredominantAxis:typeof R.scrollPredominantAxis<"u"?R.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof R.mouseWheelSmoothScroll<"u"?R.mouseWheelSmoothScroll:!0,arrowSize:typeof R.arrowSize<"u"?R.arrowSize:11,listenOnDomNode:typeof R.listenOnDomNode<"u"?R.listenOnDomNode:null,horizontal:typeof R.horizontal<"u"?R.horizontal:1,horizontalScrollbarSize:typeof R.horizontalScrollbarSize<"u"?R.horizontalScrollbarSize:10,horizontalSliderSize:typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:0,horizontalHasArrows:typeof R.horizontalHasArrows<"u"?R.horizontalHasArrows:!1,vertical:typeof R.vertical<"u"?R.vertical:1,verticalScrollbarSize:typeof R.verticalScrollbarSize<"u"?R.verticalScrollbarSize:10,verticalHasArrows:typeof R.verticalHasArrows<"u"?R.verticalHasArrows:!1,verticalSliderSize:typeof R.verticalSliderSize<"u"?R.verticalSliderSize:0,scrollByPage:typeof R.scrollByPage<"u"?R.scrollByPage:!1};return M.horizontalSliderSize=typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:M.horizontalScrollbarSize,M.verticalSliderSize=typeof R.verticalSliderSize<"u"?R.verticalSliderSize:M.verticalScrollbarSize,c.$j&&(M.className+=" mac"),M}}),define(me[64],be([1,0,57,2,24,26,63,12,9,28,4,3,50,51,86,124,6,35]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e,s,a,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=t.$fT=t.$eT=t.$dT=t.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var v;(function(B){B[B.TOP=0]="TOP",B[B.CENTER_TOP=1]="CENTER_TOP",B[B.CENTER_BOTTOM=2]="CENTER_BOTTOM",B[B.BOTTOM=3]="BOTTOM"})(v||(t.ListViewTargetSector=v={}));const o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(B){return[B]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class g{get context(){return this.d}set context(D){this.d=D}constructor(D){this.elements=D}update(){}getData(){return this.elements}}t.$dT=g;class r{constructor(D){this.elements=D}update(){}getData(){return this.elements}}t.$eT=r;class E{constructor(){this.types=[],this.files=[]}update(D){if(D.types&&this.types.splice(0,this.types.length,...D.types),D.files){this.files.splice(0,this.files.length);for(let x=0;x<D.files.length;x++){const W=D.files.item(x);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$fT=E;function R(B,D){return Array.isArray(B)&&Array.isArray(D)?(0,y.$ub)(B,D):B===D}class M{constructor(D){D?.getSetSize?this.getSetSize=D.getSetSize.bind(D):this.getSetSize=(x,W,T)=>T,D?.getPosInSet?this.getPosInSet=D.getPosInSet.bind(D):this.getPosInSet=(x,W)=>W+1,D?.getRole?this.getRole=D.getRole.bind(D):this.getRole=x=>"listitem",D?.isChecked?this.isChecked=D.isChecked.bind(D):this.isChecked=x=>{}}}class j{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(D){if(D!==this.P){if(D&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=D,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const x of this.d)this.ab(x);this.X(),this.q.setScrollDimensions({width:(0,C.$oR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(D,x,W,T=o){if(this.R=x,this.domId=`list_id_${++j.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$dh(50),this.v=!1,this.x=P.$Tc.None,this.y=0,this.G=!1,this.K=P.$Tc.None,this.L=P.$Tc.None,this.M=new P.$Sc,this.N=new w.$6d,this.O=new w.$6d,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,T.horizontalScrolling&&T.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(T.paddingTop??0);for(const I of W)this.j.set(I.templateId,I);this.h=this.M.add(new s.$cT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof T.mouseSupport=="boolean"?T.mouseSupport:!0),this.P=T.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof T.paddingBottom>"u"?0:T.paddingBottom,this.D=new M(T.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(T.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$yS.addTarget(this.o)),this.p=this.M.add(new d.$Bs({forceIntegerValues:!0,smoothScrollDuration:T.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,C.$_Q)((0,C.getWindow)(this.domNode),I)})),this.q=this.M.add(new A.$NS(this.o,{alwaysConsumeMouseWheel:T.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:T.verticalScrollMode??o.verticalScrollMode,useShadows:T.useShadows??o.useShadows,mouseWheelScrollSensitivity:T.mouseWheelScrollSensitivity,fastScrollSensitivity:T.fastScrollSensitivity,scrollByPage:T.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),D.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$2Q)(this.o,H.EventType.Change,I=>this.jb(I))),this.M.add((0,C.$2Q)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.M.add((0,C.$2Q)(this.domNode,"dragover",I=>this.lb(this.hb(I)))),this.M.add((0,C.$2Q)(this.domNode,"drop",I=>this.nb(this.hb(I)))),this.M.add((0,C.$2Q)(this.domNode,"dragleave",I=>this.mb(this.hb(I)))),this.M.add((0,C.$2Q)(this.domNode,"dragend",I=>this.ob(I))),this.z=T.setRowLineHeight??o.setRowLineHeight,this.A=T.setRowHeight??o.setRowHeight,this.B=T.supportDynamicHeights??o.supportDynamicHeights,this.F=T.dnd??this.M.add(o.dnd),this.layout(T.initialSize?.height,T.initialSize?.width)}updateOptions(D){D.paddingBottom!==void 0&&(this.C=D.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),D.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(D.smoothScrolling?125:0),D.horizontalScrolling!==void 0&&(this.Q=D.horizontalScrolling);let x;if(D.scrollByPage!==void 0&&(x={...x??{},scrollByPage:D.scrollByPage}),D.mouseWheelScrollSensitivity!==void 0&&(x={...x??{},mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity}),D.fastScrollSensitivity!==void 0&&(x={...x??{},fastScrollSensitivity:D.fastScrollSensitivity}),x&&this.q.updateOptions(x),D.paddingTop!==void 0&&D.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),T=D.paddingTop-this.g.paddingTop;this.g.paddingTop=D.paddingTop,this.Y(W,Math.max(0,this.k+T),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(D){this.q.delegateScrollFromMouseWheelEvent(D)}delegateVerticalScrollbarPointerDown(D){this.q.delegateVerticalScrollbarPointerDown(D)}updateElementHeight(D,x,W){if(D<0||D>=this.d.length)return;const T=this.d[D].size;if(typeof x>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[D].lastDynamicHeightWidth=void 0,x=T+this.xb(D)}if(T===x)return;const L=this.vb(this.k,this.m);let I=0;D<L.start||W!==null&&W>D&&W<L.end?I=x-T:I=0,this.g.splice(D,1,[{size:x}]),this.d[D].size=x,this.Y(L,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(D){return new e.$bT(D)}splice(D,x,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(D,x,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(D,x,W=[]){const T=this.vb(this.k,this.m),L={start:D,end:D+x},I=c.Range.intersect(T,L),X=new Map;for(let G=I.end-1;G>=I.start;G--){const ie=this.d[G];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let ce=X.get(ie.templateId);ce||(ce=[],X.set(ie.templateId,ce));const Ae=this.j.get(ie.templateId);Ae&&Ae.disposeElement&&Ae.disposeElement(ie.element,G,ie.row.templateData,ie.size),ce.push(ie.row)}ie.row=null,ie.stale=!0}const U={start:D+x,end:this.d.length},de=c.Range.intersect(U,T),he=c.Range.relativeComplement(U,T),ne=W.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$Tc.None,checkedDisposable:P.$Tc.None,stale:!1}));let ge;D===0&&x>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ne),ge=this.d,this.d=ne):(this.g.splice(D,x,ne),ge=this.d.splice(D,x,...ne));const Ne=W.length-x,Ce=this.vb(this.k,this.m),Pe=(0,e.$_S)(de,Ne),le=c.Range.intersect(Ce,Pe);for(let G=le.start;G<le.end;G++)this.bb(this.d[G],G);const _=c.Range.relativeComplement(Pe,Ce);for(const G of _)for(let ie=G.start;ie<G.end;ie++)this.db(ie);const ae=he.map(G=>(0,e.$_S)(G,Ne)),J=[{start:D,end:D+W.length},...ae].map(G=>c.Range.intersect(Ce,G)).reverse();for(const G of J)for(let ie=G.end-1;ie>=G.start;ie--){const ce=this.d[ie],Fe=X.get(ce.templateId)?.pop();this.Z(ie,Fe)}for(const G of X.values())for(const ie of G)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(G=>G.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$_Q)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let D=0;for(const x of this.d)typeof x.width<"u"&&(D=Math.max(D,x.width));this.E=D,this.q.setScrollDimensions({scrollWidth:D===0?0:D+10}),this.O.fire(this.E)}updateWidth(D){if(!this.Q||typeof this.E>"u")return;const x=this.d[D];this.ab(x),typeof x.width<"u"&&x.width>this.E&&(this.E=x.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const D of this.d)D.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const D=this.firstVisibleIndex,x=this.g.positionAt(D),W=this.g.positionAt(D+1);return W!==-1&&(W-x)/2+x<this.scrollTop?D+1:D}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(D){return this.d[D].element}indexOf(D){return this.d.findIndex(x=>x.element===D)}domElement(D){const x=this.d[D].row;return x&&x.domNode}elementHeight(D){return this.d[D].size}elementTop(D){return this.g.positionAt(D)}indexAt(D){return this.g.indexAt(D)}indexAfter(D){return this.g.indexAfter(D)}layout(D,x){const W={height:typeof D=="number"?D:(0,C.$qR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof x<"u"&&(this.n=x,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof x=="number"?x:(0,C.$oR)(this.domNode)})}Y(D,x,W,T,L,I=!1){const X=this.vb(x,W),U=c.Range.relativeComplement(X,D).reverse(),de=c.Range.relativeComplement(D,X);if(I){const he=c.Range.intersect(D,X);for(let ne=he.start;ne<he.end;ne++)this.bb(this.d[ne],ne)}this.h.transact(()=>{for(const he of de)for(let ne=he.start;ne<he.end;ne++)this.db(ne);for(const he of U)for(let ne=he.end-1;ne>=he.start;ne--)this.Z(ne)}),T!==void 0&&(this.o.style.left=`-${T}px`),this.o.style.top=`-${x}px`,this.Q&&L!==void 0&&(this.o.style.width=`${Math.max(L,this.n)}px`),this.k=x,this.m=W}Z(D,x){const W=this.d[D];if(!W.row)if(x)W.row=x,W.stale=!0;else{const U=this.h.alloc(W.templateId);W.row=U.row,W.stale||=U.isReusingConnectedDomNode}const T=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",T);const L=this.D.isChecked(W.element);if(typeof L=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!L));else if(L){const U=de=>W.row.domNode.setAttribute("aria-checked",String(!!de));U(L.value),W.checkedDisposable=L.onDidChange(U)}if(W.stale||!W.row.domNode.parentElement){const U=this.d.at(D+1)?.row?.domNode??null;this.o.insertBefore(W.row.domNode,U),W.stale=!1}this.bb(W,D);const I=this.j.get(W.templateId);if(!I)throw new Error(`No renderer found for template id ${W.templateId}`);I?.renderElement(W.element,D,W.row.templateData,W.size);const X=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!X,X&&(W.dragStartDisposable=(0,C.$2Q)(W.row.domNode,"dragstart",U=>this.kb(W.element,X,U))),this.Q&&(this.ab(W),this.W())}ab(D){if(!D.row||!D.row.domNode)return;D.row.domNode.style.width="fit-content",D.width=(0,C.$oR)(D.row.domNode);const x=(0,C.getWindow)(D.row.domNode).getComputedStyle(D.row.domNode);x.paddingLeft&&(D.width+=parseFloat(x.paddingLeft)),x.paddingRight&&(D.width+=parseFloat(x.paddingRight)),D.row.domNode.style.width=""}bb(D,x){D.row.domNode.style.top=`${this.elementTop(x)}px`,this.A&&(D.row.domNode.style.height=`${D.size}px`),this.z&&(D.row.domNode.style.lineHeight=`${D.size}px`),D.row.domNode.setAttribute("data-index",`${x}`),D.row.domNode.setAttribute("data-last-element",x===this.length-1?"true":"false"),D.row.domNode.setAttribute("data-parity",x%2===0?"even":"odd"),D.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(D.element,x,this.length))),D.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(D.element,x))),D.row.domNode.setAttribute("id",this.getElementDomId(x)),D.row.domNode.classList.toggle("drop-target",D.dropTarget)}db(D){const x=this.d[D];if(x.dragStartDisposable.dispose(),x.checkedDisposable.dispose(),x.row){const W=this.j.get(x.templateId);W&&W.disposeElement&&W.disposeElement(x.element,D,x.row.templateData,x.size),this.h.release(x.row),x.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(D,x){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:D,reuseAnimation:x})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(D){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:D})}get scrollTop(){return this.getScrollTop()}set scrollTop(D){this.setScrollTop(D)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"click")).event,D=>this.eb(D),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"dblclick")).event,D=>this.eb(D),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new z.$6S(this.domNode,"auxclick")).event,D=>this.eb(D),this.M),D=>D.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"mouseup")).event,D=>this.eb(D),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"mousedown")).event,D=>this.eb(D),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"mouseover")).event,D=>this.eb(D),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"mousemove")).event,D=>this.eb(D),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"mouseout")).event,D=>this.eb(D),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new z.$6S(this.domNode,"contextmenu")).event,D=>this.eb(D),this.M),w.Event.map(this.M.add(new z.$6S(this.domNode,H.EventType.Contextmenu)).event,D=>this.gb(D),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new z.$6S(this.domNode,"touchstart")).event,D=>this.fb(D),this.M)}get onTap(){return w.Event.map(this.M.add(new z.$6S(this.o,H.EventType.Tap)).event,D=>this.gb(D),this.M)}eb(D){const x=this.ub(D.target||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element;return{browserEvent:D,index:x,element:T}}fb(D){const x=this.ub(D.target||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element;return{browserEvent:D,index:x,element:T}}gb(D){const x=this.ub(D.initialTarget||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element;return{browserEvent:D,index:x,element:T}}hb(D){const x=this.ub(D.target||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element,L=this.tb(D,x);return{browserEvent:D,index:x,element:T,sector:L}}ib(D){try{const x=this.vb(this.k,this.m);this.Y(x,D.scrollTop,D.height,D.scrollLeft,D.scrollWidth),this.B&&this.wb(D.scrollTop,D.height,D.inSmoothScrolling)}catch(x){throw console.error("Got bad scroll event:",D),x}}jb(D){D.preventDefault(),D.stopPropagation(),this.scrollTop-=D.translationY}kb(D,x,W){if(!W.dataTransfer)return;const T=this.F.getDragElements(D);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.$wS.TEXT,x),W.dataTransfer.setDragImage){let L;this.F.getDragLabel&&(L=this.F.getDragLabel(T,W)),typeof L>"u"&&(L=String(T.length));const I=(0,C.$)(".monaco-drag-image");I.textContent=L;const U=(de=>{for(;de&&!de.classList.contains("monaco-workbench");)de=de.parentElement;return de||this.domNode.ownerDocument})(this.domNode);U.appendChild(I),W.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>U.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new g(T),p.CurrentDragAndDropData=new r(T),this.F.onDragStart?.(this.H,W)}lb(D){if(D.browserEvent.preventDefault(),this.L.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(D.browserEvent),!D.browserEvent.dataTransfer))return!1;if(!this.H)if(p.CurrentDragAndDropData)this.H=p.CurrentDragAndDropData;else{if(!D.browserEvent.dataTransfer.types)return!1;this.H=new E}const x=this.F.onDragOver(this.H,D.element,D.index,D.sector,D.browserEvent);if(this.G=typeof x=="boolean"?x:x.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;D.browserEvent.dataTransfer.dropEffect=typeof x!="boolean"&&x.effect?.type===0?"copy":"move";let W;typeof x!="boolean"&&x.feedback?W=x.feedback:typeof D.index>"u"?W=[-1]:W=[D.index],W=(0,y.$Mb)(W).filter(L=>L>=-1&&L<this.length).sort((L,I)=>L-I),W=W[0]===-1?[-1]:W;let T=typeof x!="boolean"&&x.effect&&x.effect.position?x.effect.position:"drop-target";if(R(this.I,W)&&this.J===T)return!0;if(this.I=W,this.J=T,this.K.dispose(),W[0]===-1)this.domNode.classList.add(T),this.o.classList.add(T),this.K=(0,P.$Rc)(()=>{this.domNode.classList.remove(T),this.o.classList.remove(T)});else{if(W.length>1&&T!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");T==="drop-target-after"&&W[0]<this.length-1&&(W[0]+=1,T="drop-target-before");for(const L of W){const I=this.d[L];I.dropTarget=!0,I.row?.domNode.classList.add(T)}this.K=(0,P.$Rc)(()=>{for(const L of W){const I=this.d[L];I.dropTarget=!1,I.row?.domNode.classList.remove(T)}})}return!0}mb(D){this.L.dispose(),this.L=(0,b.$ih)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,D.element,D.index,D.browserEvent)}nb(D){if(!this.G)return;const x=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,!(!x||!D.browserEvent.dataTransfer)&&(D.browserEvent.preventDefault(),x.update(D.browserEvent.dataTransfer),this.F.drop(x,D.element,D.index,D.sector,D.browserEvent))}ob(D){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(D)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=P.$Tc.None}qb(D){if(!this.w){const x=(0,C.$iR)(this.domNode).top;this.w=(0,C.$eS)((0,C.getWindow)(this.domNode),this.rb.bind(this,x))}this.x.dispose(),this.x=(0,b.$ih)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=D.pageY}rb(D){if(this.y===void 0)return;const x=this.y-D,W=this.renderHeight-35;x<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(x-35))):x>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(x-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(D,x){if(x===void 0)return;const W=D.offsetY/this.d[x].size,T=Math.floor(W/.25);return(0,m.$lm)(T,0,3)}ub(D){const x=this.q.getDomNode();let W=D;for(;W instanceof HTMLElement&&W!==this.o&&x.contains(W);){const T=W.getAttribute("data-index");if(T){const L=Number(T);if(!isNaN(L))return L}W=W.parentElement}}vb(D,x){return{start:this.g.indexAt(D),end:this.g.indexAfter(D+x-1)}}wb(D,x,W){const T=this.vb(D,x);let L,I;D===this.elementTop(T.start)?(L=T.start,I=0):T.end-T.start>1&&(L=T.start+1,I=this.elementTop(L)-D);let X=0;for(;;){const U=this.vb(D,x);let de=!1;for(let he=U.start;he<U.end;he++){const ne=this.xb(he);ne!==0&&this.g.splice(he,1,[this.d[he]]),X+=ne,de=de||ne!==0}if(!de){X!==0&&this.V();const he=c.Range.relativeComplement(T,U);for(const ge of he)for(let Ne=ge.start;Ne<ge.end;Ne++)this.d[Ne].row&&this.db(Ne);const ne=c.Range.relativeComplement(U,T).reverse();for(const ge of ne)for(let Ne=ge.end-1;Ne>=ge.start;Ne--)this.Z(Ne);for(let ge=U.start;ge<U.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof L=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-D,Ne=this.elementTop(L)-I+ge;this.setScrollTop(Ne,W)}this.N.fire(this.contentHeight);return}}}xb(D){const x=this.d[D];if(this.R.getDynamicHeight){const I=this.R.getDynamicHeight(x.element);if(I!==null){const X=x.size;return x.size=I,x.lastDynamicHeightWidth=this.n,I-X}}if(!x.hasDynamicHeight||x.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(x.element))return 0;const W=x.size;if(x.row)return x.row.domNode.style.height="",x.size=x.row.domNode.offsetHeight,x.lastDynamicHeightWidth=this.n,x.size-W;const{row:T}=this.h.alloc(x.templateId);T.domNode.style.height="",this.o.appendChild(T.domNode);const L=this.j.get(x.templateId);if(!L)throw new a.$cb("Missing renderer for templateId: "+x.templateId);return L.renderElement(x.element,D,T.templateData,void 0),x.size=T.domNode.offsetHeight,L.disposeElement?.(x.element,D,T.templateData,void 0),this.R.setDynamicHeight?.(x.element,x.size),x.lastDynamicHeightWidth=this.n,this.o.removeChild(T.domNode),this.h.release(T),x.size-W}getElementDomId(D){return`${this.domId}_${D}`}dispose(){for(const D of this.d)if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const x=this.j.get(D.row.templateId);x&&(x.disposeElement?.(D.element,-1,D.row.templateData,void 0),x.disposeTemplate(D.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$gT=j,Je([$.$Kh],j.prototype,"onMouseClick",null),Je([$.$Kh],j.prototype,"onMouseDblClick",null),Je([$.$Kh],j.prototype,"onMouseMiddleClick",null),Je([$.$Kh],j.prototype,"onMouseUp",null),Je([$.$Kh],j.prototype,"onMouseDown",null),Je([$.$Kh],j.prototype,"onMouseOver",null),Je([$.$Kh],j.prototype,"onMouseMove",null),Je([$.$Kh],j.prototype,"onMouseOut",null),Je([$.$Kh],j.prototype,"onContextMenu",null),Je([$.$Kh],j.prototype,"onTouchStart",null),Je([$.$Kh],j.prototype,"onTap",null)}),define(me[43],be([1,0,2,24,15,26,60,74,12,9,77,28,4,37,3,35,5,7,73,64,20,102]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e,s,a,m,p,v,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yT=t.$xT=t.$wT=t.$vT=t.$sT=t.TypeNavigationMode=void 0,t.$kT=M,t.$lT=B,t.$mT=D,t.$nT=x,t.$oT=W,t.$pT=T,t.$qT=L,t.$rT=I,t.$tT=ge,t.$uT=Ne;class g{constructor(f){this.d=f,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(f){return f}renderElement(f,k,F){const l=this.c.findIndex(u=>u.templateData===F);if(l>=0){const u=this.c[l];this.d.unrender(F),u.index=k}else{const u={index:k,templateData:F};this.c.push(u)}this.d.renderIndex(k,F)}splice(f,k,F){const l=[];for(const u of this.c)u.index<f?l.push(u):u.index>=f+k&&l.push({index:u.index+F-k,templateData:u.templateData});this.c=l}renderIndexes(f){for(const{index:k,templateData:F}of this.c)f.indexOf(k)>-1&&this.d.renderIndex(k,F)}disposeTemplate(f){const k=this.c.findIndex(F=>F.templateData===f);k<0||this.c.splice(k,1)}}class r{get name(){return this.g}get renderer(){return new g(this)}constructor(f){this.g=f,this.c=[],this.d=[],this.f=new c.$6d,this.onChange=this.f.event}splice(f,k,F){const l=F.length-k,u=f+k,n=[];let h=0;for(;h<this.d.length&&this.d[h]<f;)n.push(this.d[h++]);for(let N=0;N<F.length;N++)F[N]&&n.push(N+f);for(;h<this.d.length&&this.d[h]>=u;)n.push(this.d[h++]+l);this.renderer.splice(f,k,F.length),this.h(n,n)}renderIndex(f,k){k.classList.toggle(this.g,this.contains(f))}unrender(f){f.classList.remove(this.g)}set(f,k){return this.h(f,[...f].sort(ie),k)}h(f,k,F){const l=this.c,u=this.d;this.c=f,this.d=k;const n=J(u,f);return this.renderer.renderIndexes(n),this.f.fire({indexes:f,browserEvent:F}),l}get(){return this.c}contains(f){return(0,b.$wb)(this.d,f,ie)>=0}dispose(){(0,e.$Oc)(this.f)}}Je([P.$Kh],r.prototype,"renderer",null);class E extends r{constructor(f){super("selected"),this.k=f}renderIndex(f,k){super.renderIndex(f,k),this.k&&(this.contains(f)?k.setAttribute("aria-selected","true"):k.setAttribute("aria-selected","false"))}}class R{constructor(f,k,F){this.c=f,this.d=k,this.f=F}splice(f,k,F){if(!this.f)return this.c.splice(f,k,new Array(F.length).fill(!1));const l=this.c.get().map(h=>this.f.getId(this.d.element(h)).toString());if(l.length===0)return this.c.splice(f,k,new Array(F.length).fill(!1));const u=new Set(l),n=F.map(h=>u.has(this.f.getId(h).toString()));this.c.splice(f,k,n)}}function M(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}function j(K,f){return K.classList.contains(f)?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:j(K.parentElement,f)}function B(K){return j(K,"monaco-editor")}function D(K){return j(K,"monaco-custom-toggle")}function x(K){return j(K,"action-item")}function W(K){return j(K,"monaco-tl-twistie")}function T(K){return j(K,"monaco-tree-sticky-row")}function L(K){return K.classList.contains("monaco-tree-sticky-container")}function I(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:I(K.parentElement)}class X{get g(){return c.Event.chain(this.c.add(new C.$6S(this.k.domNode,"keydown")).event,f=>f.filter(k=>!M(k.target)).map(k=>new z.$YQ(k)))}constructor(f,k,F){this.h=f,this.k=k,this.c=new e.$Sc,this.d=new e.$Sc,this.f=F.multipleSelectionSupport,this.c.add(this.g(l=>{switch(l.keyCode){case 3:return this.l(l);case 16:return this.o(l);case 18:return this.p(l);case 11:return this.q(l);case 12:return this.s(l);case 9:return this.u(l);case 31:this.f&&(a.$j?l.metaKey:l.ctrlKey)&&this.t(l)}}))}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.f=f.multipleSelectionSupport)}l(f){f.preventDefault(),f.stopPropagation(),this.h.setSelection(this.h.getFocus(),f.browserEvent)}o(f){f.preventDefault(),f.stopPropagation(),this.h.focusPrevious(1,!1,f.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}p(f){f.preventDefault(),f.stopPropagation(),this.h.focusNext(1,!1,f.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}q(f){f.preventDefault(),f.stopPropagation(),this.h.focusPreviousPage(f.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}s(f){f.preventDefault(),f.stopPropagation(),this.h.focusNextPage(f.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}t(f){f.preventDefault(),f.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),f.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(f){this.h.getSelection().length&&(f.preventDefault(),f.stopPropagation(),this.h.setSelection([],f.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([P.$Kh],X.prototype,"g",null);var U;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(U||(t.TypeNavigationMode=U={}));var de;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(de||(de={})),t.$sT=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class he{constructor(f,k,F,l,u){this.o=f,this.p=k,this.q=F,this.s=l,this.t=u,this.c=!1,this.d=de.Idle,this.f=U.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(f.options)}updateOptions(f){f.typeNavigationEnabled??!0?this.u():this.v(),this.f=f.typeNavigationMode??U.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let f=!1;const k=c.Event.chain(this.k.add(new C.$6S(this.p.domNode,"keydown")).event,u=>u.filter(n=>!M(n.target)).filter(()=>this.f===U.Automatic||this.g).map(n=>new z.$YQ(n)).filter(n=>f||this.s(n)).filter(n=>this.t.mightProducePrintableCharacter(n)).forEach(n=>i.$WR.stop(n,!0)).map(n=>n.browserEvent.key)),F=c.Event.debounce(k,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(k,F),(u,n)=>n===null?null:(u||"")+n,void 0,this.k)(this.x,this,this.k),F(this.w,this,this.k),k(()=>f=!0,void 0,this.k),F(()=>f=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const f=this.o.getFocus();if(f.length>0&&f[0]===this.h){const k=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(f[0]));k&&(0,A.$8S)(k)}this.h=-1}x(f){if(!f){this.d=de.Idle,this.g=!1;return}const k=this.o.getFocus(),F=k.length>0?k[0]:0,l=this.d===de.Idle?1:0;this.d=de.Typing;for(let u=0;u<this.o.length;u++){const n=(F+u+l)%this.o.length,h=this.q.getKeyboardNavigationLabel(this.p.element(n)),N=h&&h.toString();if(this.o.options.typeNavigationEnabled){if(typeof N<"u"){if((0,d.$ik)(f,N)){this.h=F,this.o.setFocus([n]),this.o.reveal(n);return}const S=(0,d.$pk)(f,N);if(S&&S[0].end-S[0].start>1&&S.length===1){this.h=F,this.o.setFocus([n]),this.o.reveal(n);return}}}else if(typeof N>"u"||(0,d.$ik)(f,N)){this.h=F,this.o.setFocus([n]),this.o.reveal(n);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ne{constructor(f,k){this.d=f,this.f=k,this.c=new e.$Sc;const F=c.Event.chain(this.c.add(new C.$6S(k.domNode,"keydown")).event,u=>u.filter(n=>!M(n.target)).map(n=>new z.$YQ(n)));c.Event.chain(F,u=>u.filter(n=>n.keyCode===2&&!n.ctrlKey&&!n.metaKey&&!n.shiftKey&&!n.altKey))(this.g,this,this.c)}g(f){if(f.target!==this.f.domNode)return;const k=this.d.getFocus();if(k.length===0)return;const F=this.f.domElement(k[0]);if(!F)return;const l=F.querySelector("[tabIndex]");if(!l||!(l instanceof HTMLElement)||l.tabIndex===-1)return;const u=(0,i.getWindow)(l).getComputedStyle(l);u.visibility==="hidden"||u.display==="none"||(f.preventDefault(),f.stopPropagation(),l.focus())}dispose(){this.c.dispose()}}function ge(K){return a.$j?K.browserEvent.metaKey:K.browserEvent.ctrlKey}function Ne(K){return K.browserEvent.shiftKey}function Ce(K){return(0,i.$QR)(K)&&K.button===2}const Pe={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Ne};class le{constructor(f){this.k=f,this.f=new e.$Sc,this.g=new c.$6d,this.onPointer=this.g.event,f.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Pe),this.d=typeof f.options.mouseSupport>"u"||!!f.options.mouseSupport,this.d&&(f.onMouseDown(this.s,this,this.f),f.onContextMenu(this.t,this,this.f),f.onMouseDblClick(this.v,this,this.f),f.onTouchStart(this.s,this,this.f),this.f.add(H.$yS.addTarget(f.getHTMLElement()))),c.Event.any(f.onMouseClick,f.onMouseMiddleClick,f.onTap)(this.u,this,this.f)}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.c=void 0,f.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Pe))}o(f){return this.c?this.c.isSelectionSingleChangeEvent(f):!1}p(f){return this.c?this.c.isSelectionRangeChangeEvent(f):!1}q(f){return this.o(f)||this.p(f)}s(f){B(f.browserEvent.target)||(0,i.$BR)()!==f.browserEvent.target&&this.k.domFocus()}t(f){if(M(f.browserEvent.target)||B(f.browserEvent.target))return;const k=typeof f.index>"u"?[]:[f.index];this.k.setFocus(k,f.browserEvent)}u(f){if(!this.d||M(f.browserEvent.target)||B(f.browserEvent.target)||f.browserEvent.isHandledByList)return;f.browserEvent.isHandledByList=!0;const k=f.index;if(typeof k>"u"){this.k.setFocus([],f.browserEvent),this.k.setSelection([],f.browserEvent),this.k.setAnchor(void 0);return}if(this.q(f))return this.w(f);this.k.setFocus([k],f.browserEvent),this.k.setAnchor(k),Ce(f.browserEvent)||this.k.setSelection([k],f.browserEvent),this.g.fire(f)}v(f){if(M(f.browserEvent.target)||B(f.browserEvent.target)||this.q(f)||f.browserEvent.isHandledByList)return;f.browserEvent.isHandledByList=!0;const k=this.k.getFocus();this.k.setSelection(k,f.browserEvent)}w(f){const k=f.index;let F=this.k.getAnchor();if(this.p(f)){typeof F>"u"&&(F=this.k.getFocus()[0]??k,this.k.setAnchor(F));const l=Math.min(F,k),u=Math.max(F,k),n=(0,b.$Sb)(l,u+1),h=this.k.getSelection(),N=oe(J(h,[F]),F);if(N.length===0)return;const S=J(n,G(h,N));this.k.setSelection(S,f.browserEvent),this.k.setFocus([k],f.browserEvent)}else if(this.o(f)){const l=this.k.getSelection(),u=l.filter(n=>n!==k);this.k.setFocus([k]),this.k.setAnchor(k),l.length===u.length?this.k.setSelection([...u,k],f.browserEvent):this.k.setSelection(u,f.browserEvent)}}dispose(){this.f.dispose()}}t.$vT=le;class _{constructor(f,k){this.c=f,this.d=k}style(f){const k=this.d&&`.${this.d}`,F=[];f.listBackground&&F.push(`.monaco-list${k} .monaco-list-rows { background: ${f.listBackground}; }`),f.listFocusBackground&&(F.push(`.monaco-list${k}:focus .monaco-list-row.focused { background-color: ${f.listFocusBackground}; }`),F.push(`.monaco-list${k}:focus .monaco-list-row.focused:hover { background-color: ${f.listFocusBackground}; }`)),f.listFocusForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.focused { color: ${f.listFocusForeground}; }`),f.listActiveSelectionBackground&&(F.push(`.monaco-list${k}:focus .monaco-list-row.selected { background-color: ${f.listActiveSelectionBackground}; }`),F.push(`.monaco-list${k}:focus .monaco-list-row.selected:hover { background-color: ${f.listActiveSelectionBackground}; }`)),f.listActiveSelectionForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.selected { color: ${f.listActiveSelectionForeground}; }`),f.listActiveSelectionIconForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.selected .codicon { color: ${f.listActiveSelectionIconForeground}; }`),f.listFocusAndSelectionBackground&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { background-color: ${f.listFocusAndSelectionBackground}; }
			`),f.listFocusAndSelectionForeground&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { color: ${f.listFocusAndSelectionForeground}; }
			`),f.listInactiveFocusForeground&&(F.push(`.monaco-list${k} .monaco-list-row.focused { color:  ${f.listInactiveFocusForeground}; }`),F.push(`.monaco-list${k} .monaco-list-row.focused:hover { color:  ${f.listInactiveFocusForeground}; }`)),f.listInactiveSelectionIconForeground&&F.push(`.monaco-list${k} .monaco-list-row.focused .codicon { color:  ${f.listInactiveSelectionIconForeground}; }`),f.listInactiveFocusBackground&&(F.push(`.monaco-list${k} .monaco-list-row.focused { background-color:  ${f.listInactiveFocusBackground}; }`),F.push(`.monaco-list${k} .monaco-list-row.focused:hover { background-color:  ${f.listInactiveFocusBackground}; }`)),f.listInactiveSelectionBackground&&(F.push(`.monaco-list${k} .monaco-list-row.selected { background-color:  ${f.listInactiveSelectionBackground}; }`),F.push(`.monaco-list${k} .monaco-list-row.selected:hover { background-color:  ${f.listInactiveSelectionBackground}; }`)),f.listInactiveSelectionForeground&&F.push(`.monaco-list${k} .monaco-list-row.selected { color: ${f.listInactiveSelectionForeground}; }`),f.listHoverBackground&&F.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${f.listHoverBackground}; }`),f.listHoverForeground&&F.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${f.listHoverForeground}; }`);const l=(0,i.$hS)(f.listFocusAndSelectionOutline,(0,i.$hS)(f.listSelectionOutline,f.listFocusOutline??""));l&&F.push(`.monaco-list${k}:focus .monaco-list-row.focused.selected { outline: 1px solid ${l}; outline-offset: -1px;}`),f.listFocusOutline&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
			`);const u=(0,i.$hS)(f.listSelectionOutline,f.listInactiveFocusOutline??"");u&&F.push(`.monaco-list${k} .monaco-list-row.focused.selected { outline: 1px dotted ${u}; outline-offset: -1px; }`),f.listSelectionOutline&&F.push(`.monaco-list${k} .monaco-list-row.selected { outline: 1px dotted ${f.listSelectionOutline}; outline-offset: -1px; }`),f.listInactiveFocusOutline&&F.push(`.monaco-list${k} .monaco-list-row.focused { outline: 1px dotted ${f.listInactiveFocusOutline}; outline-offset: -1px; }`),f.listHoverOutline&&F.push(`.monaco-list${k} .monaco-list-row:hover { outline: 1px dashed ${f.listHoverOutline}; outline-offset: -1px; }`),f.listDropOverBackground&&F.push(`
				.monaco-list${k}.drop-target,
				.monaco-list${k} .monaco-list-rows.drop-target,
				.monaco-list${k} .monaco-list-row.drop-target { background-color: ${f.listDropOverBackground} !important; color: inherit !important; }
			`),f.listDropBetweenBackground&&(F.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${k} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${f.listDropBetweenBackground};
			}`),F.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${k} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${f.listDropBetweenBackground};
			}`)),f.tableColumnsBorder&&F.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${f.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),f.tableOddRowsBackgroundColor&&F.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${f.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=F.join(`
`)}}t.$wT=_,t.$xT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Ct.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Ct.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Ct.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function oe(K,f){const k=K.indexOf(f);if(k===-1)return[];const F=[];let l=k-1;for(;l>=0&&K[l]===f-(k-l);)F.push(K[l--]);for(F.reverse(),l=k;l<K.length&&K[l]===f+(l-k);)F.push(K[l++]);return F}function J(K,f){const k=[];let F=0,l=0;for(;F<K.length||l<f.length;)if(F>=K.length)k.push(f[l++]);else if(l>=f.length)k.push(K[F++]);else if(K[F]===f[l]){k.push(K[F]),F++,l++;continue}else K[F]<f[l]?k.push(K[F++]):k.push(f[l++]);return k}function G(K,f){const k=[];let F=0,l=0;for(;F<K.length||l<f.length;)if(F>=K.length)k.push(f[l++]);else if(l>=f.length)k.push(K[F++]);else if(K[F]===f[l]){F++,l++;continue}else K[F]<f[l]?k.push(K[F++]):l++;return k}const ie=(K,f)=>K-f;class ce{constructor(f,k){this.c=f,this.d=k}get templateId(){return this.c}renderTemplate(f){return this.d.map(k=>k.renderTemplate(f))}renderElement(f,k,F,l){let u=0;for(const n of this.d)n.renderElement(f,k,F[u++],l)}disposeElement(f,k,F,l){let u=0;for(const n of this.d)n.disposeElement?.(f,k,F[u],l),u+=1}disposeTemplate(f){let k=0;for(const F of this.d)F.disposeTemplate(f[k++])}}class Ae{constructor(f){this.c=f,this.templateId="a18n"}renderTemplate(f){return f}renderElement(f,k,F){const l=this.c.getAriaLabel(f);l?F.setAttribute("aria-label",l):F.removeAttribute("aria-label");const u=this.c.getAriaLevel&&this.c.getAriaLevel(f);typeof u=="number"?F.setAttribute("aria-level",`${u}`):F.removeAttribute("aria-level")}disposeTemplate(f){}}class Fe{constructor(f,k){this.c=f,this.d=k}getDragElements(f){const k=this.c.getSelectedElements();return k.indexOf(f)>-1?k:[f]}getDragURI(f){return this.d.getDragURI(f)}getDragLabel(f,k){if(this.d.getDragLabel)return this.d.getDragLabel(f,k)}onDragStart(f,k){this.d.onDragStart?.(f,k)}onDragOver(f,k,F,l,u){return this.d.onDragOver(f,k,F,l,u)}onDragLeave(f,k,F,l){this.d.onDragLeave?.(f,k,F,l)}onDragEnd(f){this.d.onDragEnd?.(f)}drop(f,k,F,l,u){this.d.drop(f,k,F,l,u)}dispose(){this.d.dispose()}}class ye{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),f=>this.G(f),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),f=>this.G(f),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let f=!1;const k=c.Event.chain(this.y.add(new C.$6S(this.k.domNode,"keydown")).event,u=>u.map(n=>new z.$YQ(n)).filter(n=>f=n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$WR.stop(n,!0)).filter(()=>!1)),F=c.Event.chain(this.y.add(new C.$6S(this.k.domNode,"keyup")).event,u=>u.forEach(()=>f=!1).map(n=>new z.$YQ(n)).filter(n=>n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$WR.stop(n,!0)).map(({browserEvent:n})=>{const h=this.getFocus(),N=h.length?h[0]:void 0,S=typeof N<"u"?this.k.element(N):void 0,O=typeof N<"u"?this.k.domElement(N):this.k.domNode;return{index:N,element:S,anchor:O,browserEvent:n}})),l=c.Event.chain(this.k.onContextMenu,u=>u.filter(n=>!f).map(({element:n,index:h,browserEvent:N})=>({element:n,index:h,anchor:new o.$TQ((0,i.getWindow)(this.k.domNode),N),browserEvent:N})));return c.Event.any(k,F,l)}get onKeyDown(){return this.y.add(new C.$6S(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$6S(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$6S(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new C.$6S(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new C.$6S(this.k.domNode,"blur",!0)).event)}constructor(f,k,F,l,u=ae){this.A=f,this.B=u,this.c=new r("focused"),this.f=new r("anchor"),this.g=new c.$be,this.x="",this.y=new e.$Sc,this.z=new c.$6d,this.onDidDispose=this.z.event;const n=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new E(n!=="listbox");const h=[this.c.renderer,this.d.renderer];this.u=u.accessibilityProvider,this.u&&(h.push(new Ae(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),l=l.map(S=>new ce(S.templateId,[...h,S]));const N={...u,dnd:u.dnd&&new Fe(this,u.dnd)};if(this.k=this.C(k,F,l,N),this.k.domNode.setAttribute("role",n),u.styleController)this.q=u.styleController(this.k.domId);else{const S=(0,i.$JR)(this.k.domNode);this.q=new _(S,this.k.domId)}if(this.o=new y.$0S([new R(this.c,this.k,u.identityProvider),new R(this.d,this.k,u.identityProvider),new R(this.f,this.k,u.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ne(this,this.k)),(typeof u.keyboardSupport!="boolean"||u.keyboardSupport)&&(this.v=new X(this,this.k,u),this.y.add(this.v)),u.keyboardNavigationLabelProvider){const S=u.keyboardNavigationDelegate||t.$sT;this.t=new he(this,this.k,u.keyboardNavigationLabelProvider,u.keyboardNavigationEventFilter??(()=>!0),S),this.y.add(this.t)}this.w=this.D(u),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(f,k,F,l){return new v.$gT(f,k,F,l)}D(f){return new le(this)}updateOptions(f={}){this.B={...this.B,...f},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(f),this.v?.updateOptions(f),this.k.updateOptions(f)}get options(){return this.B}splice(f,k,F=[]){if(f<0||f>this.k.length)throw new p.$iT(this.A,`Invalid start index: ${f}`);if(k<0)throw new p.$iT(this.A,`Invalid delete count: ${k}`);k===0&&F.length===0||this.g.bufferEvents(()=>this.o.splice(f,k,F))}updateWidth(f){this.k.updateWidth(f)}updateElementHeight(f,k){this.k.updateElementHeight(f,k,null)}rerender(){this.k.rerender()}element(f){return this.k.element(f)}indexOf(f){return this.k.indexOf(f)}indexAt(f){return this.k.indexAt(f)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(f){this.k.setScrollTop(f)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(f){this.k.setScrollLeft(f)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(f){this.x=f,this.k.domNode.setAttribute("aria-label",f)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(f,k){this.k.layout(f,k)}triggerTypeNavigation(){this.t?.trigger()}setSelection(f,k){for(const F of f)if(F<0||F>=this.length)throw new p.$iT(this.A,`Invalid index ${F}`);this.d.set(f,k)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(f=>this.k.element(f))}setAnchor(f){if(typeof f>"u"){this.f.set([]);return}if(f<0||f>=this.length)throw new p.$iT(this.A,`Invalid index ${f}`);this.f.set([f])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const f=this.getAnchor();return typeof f>"u"?void 0:this.element(f)}setFocus(f,k){for(const F of f)if(F<0||F>=this.length)throw new p.$iT(this.A,`Invalid index ${F}`);this.c.set(f,k)}focusNext(f=1,k=!1,F,l){if(this.length===0)return;const u=this.c.get(),n=this.E(u.length>0?u[0]+f:0,k,l);n>-1&&this.setFocus([n],F)}focusPrevious(f=1,k=!1,F,l){if(this.length===0)return;const u=this.c.get(),n=this.F(u.length>0?u[0]-f:0,k,l);n>-1&&this.setFocus([n],F)}async focusNextPage(f,k){let F=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);F=F===0?0:F-1;const l=this.getFocus()[0];if(l!==F&&(l===void 0||F>l)){const u=this.F(F,!1,k);u>-1&&l!==u?this.setFocus([u],f):this.setFocus([F],f)}else{const u=this.k.getScrollTop();let n=u+this.k.renderHeight;F>l&&(n-=this.k.elementHeight(F)),this.k.setScrollTop(n),this.k.getScrollTop()!==u&&(this.setFocus([]),await(0,$.$hh)(0),await this.focusNextPage(f,k))}}async focusPreviousPage(f,k,F=()=>0){let l;const u=F(),n=this.k.getScrollTop()+u;n===0?l=this.k.indexAt(n):l=this.k.indexAfter(n-1);const h=this.getFocus()[0];if(h!==l&&(h===void 0||h>=l)){const N=this.E(l,!1,k);N>-1&&h!==N?this.setFocus([N],f):this.setFocus([l],f)}else{const N=n;this.k.setScrollTop(n-this.k.renderHeight-u),this.k.getScrollTop()+F()!==N&&(this.setFocus([]),await(0,$.$hh)(0),await this.focusPreviousPage(f,k,F))}}focusLast(f,k){if(this.length===0)return;const F=this.F(this.length-1,!1,k);F>-1&&this.setFocus([F],f)}focusFirst(f,k){this.focusNth(0,f,k)}focusNth(f,k,F){if(this.length===0)return;const l=this.E(f,!1,F);l>-1&&this.setFocus([l],k)}E(f,k=!1,F){for(let l=0;l<this.length;l++){if(f>=this.length&&!k)return-1;if(f=f%this.length,!F||F(this.element(f)))return f;f++}return-1}F(f,k=!1,F){for(let l=0;l<this.length;l++){if(f<0&&!k)return-1;if(f=(this.length+f%this.length)%this.length,!F||F(this.element(f)))return f;f--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(f=>this.k.element(f))}reveal(f,k,F=0){if(f<0||f>=this.length)throw new p.$iT(this.A,`Invalid index ${f}`);const l=this.k.getScrollTop(),u=this.k.elementTop(f),n=this.k.elementHeight(f);if((0,m.$Xf)(k)){const h=n-this.k.renderHeight+F;this.k.setScrollTop(h*(0,s.$lm)(k,0,1)+u-F)}else{const h=u+n,N=l+this.k.renderHeight;u<l+F&&h>=N||(u<l+F||h>=N&&n>=this.k.renderHeight?this.k.setScrollTop(u-F):h>=N&&this.k.setScrollTop(h-this.k.renderHeight))}}getRelativeTop(f,k=0){if(f<0||f>=this.length)throw new p.$iT(this.A,`Invalid index ${f}`);const F=this.k.getScrollTop(),l=this.k.elementTop(f),u=this.k.elementHeight(f);if(l<F+k||l+u>F+this.k.renderHeight)return null;const n=u-this.k.renderHeight+k;return Math.abs((F+k-l)/n)}isDOMFocused(){return(0,i.$CR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(f){return this.k.getElementDomId(f)}getElementTop(f){return this.k.elementTop(f)}style(f){this.q.style(f)}G({indexes:f,browserEvent:k}){return{indexes:f,elements:f.map(F=>this.k.element(F)),browserEvent:k}}H(){const f=this.c.get();this.k.domNode.classList.toggle("element-focused",f.length>0),this.I()}I(){const f=this.c.get();if(f.length>0){let k;this.u?.getActiveDescendantId&&(k=this.u.getActiveDescendantId(this.k.element(f[0]))),this.k.domNode.setAttribute("aria-activedescendant",k||this.k.getElementDomId(f[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const f=this.d.get();this.k.domNode.classList.toggle("selection-none",f.length===0),this.k.domNode.classList.toggle("selection-single",f.length===1),this.k.domNode.classList.toggle("selection-multiple",f.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$yT=ye,Je([P.$Kh],ye.prototype,"onDidChangeFocus",null),Je([P.$Kh],ye.prototype,"onDidChangeSelection",null),Je([P.$Kh],ye.prototype,"onContextMenu",null),Je([P.$Kh],ye.prototype,"onKeyDown",null),Je([P.$Kh],ye.prototype,"onKeyUp",null),Je([P.$Kh],ye.prototype,"onKeyPress",null),Je([P.$Kh],ye.prototype,"onDidFocus",null),Je([P.$Kh],ye.prototype,"onDidBlur",null)}),define(me[65],be([1,0,6,39,41,10,16]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dk=t.MarkdownStringTextNewlineStyle=void 0,t.$Ek=$,t.$Fk=w,t.$Gk=P,t.$Hk=c,t.$Ik=d,t.$Jk=e,t.$Kk=s,t.$Lk=a;var y;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(y||(t.MarkdownStringTextNewlineStyle=y={}));class b{constructor(p="",v=!1){if(this.value=p,typeof this.value!="string")throw(0,i.$7)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(p,v=0){return this.value+=c(this.supportThemeIcons?(0,C.$xk)(p):p).replace(/([ \t]+)/g,(o,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,v){return this.value+=`
${d(v,p)}
`,this}appendLink(p,v,o){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(p),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(p,v){const o=new RegExp((0,H.$Ye)(v),"g");return p.replace(o,(g,r)=>p.charAt(r-1)!=="\\"?`\\${g}`:g)}}t.$Dk=b;function $(m){return w(m)?!m.value:Array.isArray(m)?m.every($):!0}function w(m){return m instanceof b?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}function P(m,p){return m===p?!0:!m||!p?!1:m.value===p.value&&m.isTrusted===p.isTrusted&&m.supportThemeIcons===p.supportThemeIcons&&m.supportHtml===p.supportHtml&&(m.baseUri===p.baseUri||!!m.baseUri&&!!p.baseUri&&(0,z.$Mg)(A.URI.from(m.baseUri),A.URI.from(p.baseUri)))}function c(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function d(m,p){const v=m.match(/^`+/gm)?.reduce((g,r)=>g.length>r.length?g:r).length??0,o=v>=3?v+1:3;return[`${"`".repeat(o)}${p}`,m,`${"`".repeat(o)}`].join(`
`)}function e(m){return m.replace(/"/g,"&quot;")}function s(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(m){const p=[],v=m.split("|").map(g=>g.trim());m=v[0];const o=v[1];if(o){const g=/height=(\d+)/.exec(o),r=/width=(\d+)/.exec(o),E=g?g[1]:"",R=r?r[1]:"",M=isFinite(parseInt(R)),j=isFinite(parseInt(E));M&&p.push(`width="${R}"`),j&&p.push(`height="${E}"`)}return{href:m,dimensions:p}}}),define(me[130],be([1,0,2,122,24,58,15,20,123,6,4,65,39,80,23,3,82,56,32,54,41,10,16]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e,s,a,m,p,v,o,g,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CT=void 0,t.$BT=R,t.$DT=x,t.$ET=W,t.$FT=de;const E=Object.freeze({image:(G,ie,ce)=>{let Ae=[],Fe=[];return G&&({href:G,dimensions:Ae}=(0,P.$Lk)(G),Fe.push(`src="${(0,P.$Jk)(G)}"`)),ce&&Fe.push(`alt="${(0,P.$Jk)(ce)}"`),ie&&Fe.push(`title="${(0,P.$Jk)(ie)}"`),Ae.length&&(Fe=Fe.concat(Ae)),"<img "+Fe.join(" ")+">"},paragraph:G=>`<p>${G}</p>`,link:(G,ie,ce)=>typeof G!="string"?"":(G===ce&&(ce=(0,P.$Kk)(ce)),ie=typeof ie=="string"?(0,P.$Jk)((0,P.$Kk)(ie)):"",G=(0,P.$Kk)(G),G=G.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${G}" title="${ie||G}" draggable="false">${ce}</a>`)});function R(G,ie={},ce={}){const Ae=new s.$Sc;let Fe=!1;const ye=(0,H.$5S)(ie),K=function(S){let O;try{O=(0,m.$Oh)(decodeURIComponent(S))}catch{}return O?(O=(0,v.$On)(O,V=>{if(G.uris&&G.uris[V])return r.URI.revive(G.uris[V])}),encodeURIComponent(JSON.stringify(O))):S},f=function(S,O){const V=G.uris&&G.uris[S];let Z=r.URI.revive(V);return O?S.startsWith(p.Schemas.data+":")?S:(Z||(Z=r.URI.parse(S)),p.$Ag.uriToBrowserUri(Z).toString(!0)):!Z||r.URI.parse(S).toString()===Z.toString()?S:(Z.query&&(Z=Z.with({query:K(Z.query)})),Z.toString())},k=new a.marked.Renderer;k.image=E.image,k.link=E.link,k.paragraph=E.paragraph;const F=[],l=[];if(ie.codeBlockRendererSync?k.code=(S,O)=>{const V=d.$DO.nextId(),Z=ie.codeBlockRendererSync(M(O),S);return l.push([V,Z]),`<div class="code" data-code="${V}">${(0,g.$Xe)(S)}</div>`}:ie.codeBlockRenderer&&(k.code=(S,O)=>{const V=d.$DO.nextId(),Z=ie.codeBlockRenderer(M(O),S);return F.push(Z.then(ee=>[V,ee])),`<div class="code" data-code="${V}">${(0,g.$Xe)(S)}</div>`}),ie.actionHandler){const S=function(Z){let ee=Z.target;if(!(ee.tagName!=="A"&&(ee=ee.parentElement,!ee||ee.tagName!=="A")))try{let $e=ee.dataset.href;$e&&(G.baseUri&&($e=j(r.URI.from(G.baseUri),$e)),ie.actionHandler.callback($e,Z))}catch($e){(0,$.$1)($e)}finally{Z.preventDefault()}},O=ie.actionHandler.disposables.add(new z.$6S(ye,"click")),V=ie.actionHandler.disposables.add(new z.$6S(ye,"auxclick"));ie.actionHandler.disposables.add(w.Event.any(O.event,V.event)(Z=>{const ee=new y.$TQ(i.getWindow(ye),Z);!ee.leftButton&&!ee.middleButton||S(ee)})),ie.actionHandler.disposables.add(i.$2Q(ye,"keydown",Z=>{const ee=new A.$YQ(Z);!ee.equals(10)&&!ee.equals(3)||S(ee)}))}G.supportHtml||(ce.sanitizer=S=>(G.isTrusted?S.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?S:"",ce.sanitize=!0,ce.silent=!0),ce.renderer=k;let u=G.value??"";u.length>1e5&&(u=`${u.substr(0,1e5)}\u2026`),G.supportThemeIcons&&(u=(0,c.$yk)(u));let n;if(ie.fillInIncompleteTokens){const S={...a.marked.defaults,...ce},O=a.marked.lexer(u,S),V=de(O);n=a.marked.parser(V,S)}else n=a.marked.parse(u,ce);G.supportThemeIcons&&(n=(0,b.$zT)(n).map(O=>typeof O=="string"?O:O.outerHTML).join(""));const N=new DOMParser().parseFromString(B(G,n),"text/html");if(N.body.querySelectorAll("img").forEach(S=>{const O=S.getAttribute("src");if(O){let V=O;try{G.baseUri&&(V=j(r.URI.from(G.baseUri),V))}catch{}S.src=f(V,!0)}}),N.body.querySelectorAll("a").forEach(S=>{const O=S.getAttribute("href");if(S.setAttribute("href",""),!O||/^data:|javascript:/i.test(O)||/^command:/i.test(O)&&!G.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(O))S.replaceWith(...S.childNodes);else{let V=f(O,!1);G.baseUri&&(V=j(r.URI.from(G.baseUri),O)),S.dataset.href=V}}),ye.innerHTML=B(G,N.body.innerHTML),F.length>0)Promise.all(F).then(S=>{if(Fe)return;const O=new Map(S),V=ye.querySelectorAll("div[data-code]");for(const Z of V){const ee=O.get(Z.dataset.code??"");ee&&i.$4R(Z,ee)}ie.asyncRenderCallback?.()});else if(l.length>0){const S=new Map(l),O=ye.querySelectorAll("div[data-code]");for(const V of O){const Z=S.get(V.dataset.code??"");Z&&i.$4R(V,Z)}}if(ie.asyncRenderCallback)for(const S of ye.getElementsByTagName("img")){const O=Ae.add(i.$2Q(S,"load",()=>{O.dispose(),ie.asyncRenderCallback()}))}return{element:ye,dispose:()=>{Fe=!0,Ae.dispose()}}}function M(G){if(!G)return"";const ie=G.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:G}function j(G,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:G.path.endsWith("/")?(0,o.$Wg)(G,ie).toString():(0,o.$Wg)((0,o.$Sg)(G),ie).toString()}function B(G,ie){const{config:ce,allowedSchemes:Ae}=D(G);C.addHook("uponSanitizeAttribute",(ye,K)=>{if(K.attrName==="style"||K.attrName==="class"){if(ye.tagName==="SPAN"){if(K.attrName==="style"){K.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(K.attrValue);return}else if(K.attrName==="class"){K.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(K.attrValue);return}}K.keepAttr=!1;return}else if(ye.tagName==="INPUT"&&ye.attributes.getNamedItem("type")?.value==="checkbox"){if(K.attrName==="type"&&K.attrValue==="checkbox"||K.attrName==="disabled"||K.attrName==="checked"){K.keepAttr=!0;return}K.keepAttr=!1}}),C.addHook("uponSanitizeElement",(ye,K)=>{K.tagName==="input"&&(ye.attributes.getNamedItem("type")?.value==="checkbox"?ye.setAttribute("disabled",""):ye.parentElement?.removeChild(ye))});const Fe=i.$lS(Ae);try{return C.sanitize(ie,{...ce,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),Fe.dispose()}}t.$CT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function D(G){const ie=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return G.isTrusted&&ie.push(p.Schemas.command),{config:{ALLOWED_TAGS:[...i.$mS],ALLOWED_ATTR:t.$CT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function x(G){return typeof G=="string"?G:W(G)}function W(G){let ie=G.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const ce=a.marked.parse(ie,{renderer:L.value}).replace(/&(#\d+|[a-zA-Z]+);/g,Ae=>T.get(Ae)??Ae);return B({isTrusted:!1},ce).toString()}const T=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),L=new e.$V(()=>{const G=new a.marked.Renderer;return G.code=ie=>ie,G.blockquote=ie=>ie,G.html=ie=>"",G.heading=(ie,ce,Ae)=>ie+`
`,G.hr=()=>"",G.list=(ie,ce)=>ie,G.listitem=ie=>ie+`
`,G.paragraph=ie=>ie+`
`,G.table=(ie,ce)=>ie+ce+`
`,G.tablerow=ie=>ie,G.tablecell=(ie,ce)=>ie+" ",G.strong=ie=>ie,G.em=ie=>ie,G.codespan=ie=>ie,G.br=()=>`
`,G.del=ie=>ie,G.image=(ie,ce,Ae)=>"",G.text=ie=>ie,G.link=(ie,ce,Ae)=>Ae,G});function I(G){let ie="";return G.forEach(ce=>{ie+=ce.raw}),ie}function X(G){for(let ie=0;ie<G.tokens.length;ie++){const ce=G.tokens[ie];if(ce.type==="text"){const Ae=ce.raw.split(`
`),Fe=Ae[Ae.length-1];if(Fe.includes("`"))return ne(G);if(Fe.includes("**"))return _(G);if(Fe.match(/\*\w/))return ge(G);if(Fe.match(/(^|\s)__\w/))return ae(G);if(Fe.match(/(^|\s)_\w/))return Ne(G);if(Fe.match(/(^|\s)\[.*\]\(\w*/)){const ye=G.tokens.slice(ie+1);return ye[0]?.type==="link"&&ye[1]?.type==="text"&&ye[1].raw.match(/^ *"[^"]*$/)?Pe(G):Ce(G)}else{if(U(Fe))return Ce(G);if(Fe.match(/(^|\s)\[\w/)&&!G.tokens.slice(ie+1).some(ye=>U(ye.raw)))return le(G)}}}}function U(G){return!!G.match(/^[^\[]*\]\([^\)]*$/)}function de(G){let ie,ce;for(ie=0;ie<G.length;ie++){const Ae=G[ie];let Fe;if(Ae.type==="paragraph"&&(Fe=Ae.raw.match(/(\n|^)(````*)/))){const ye=Fe[2];ce=he(G.slice(ie),ye);break}if(Ae.type==="paragraph"&&Ae.raw.match(/(\n|^)\|/)){ce=J(G.slice(ie));break}if(ie===G.length-1&&Ae.type==="paragraph"){const ye=X(Ae);if(ye){ce=[ye];break}}}if(ce){const Ae=[...G.slice(0,ie),...ce];return Ae.links=G.links,Ae}return G}function he(G,ie){const ce=I(G);return a.marked.lexer(ce+`
${ie}`)}function ne(G){return oe(G,"`")}function ge(G){return oe(G,"*")}function Ne(G){return oe(G,"_")}function Ce(G){return oe(G,")")}function Pe(G){return oe(G,'")')}function le(G){return oe(G,"](about:blank)")}function _(G){return oe(G,"**")}function ae(G){return oe(G,"__")}function oe(G,ie){const ce=I(Array.isArray(G)?G:[G]);return a.marked.lexer(ce+ie)[0]}function J(G){const ie=I(G),ce=ie.split(`
`);let Ae,Fe=!1;for(let ye=0;ye<ce.length;ye++){const K=ce[ye].trim();if(typeof Ae>"u"&&K.match(/^\s*\|/)){const f=K.match(/(\|[^\|]+)(?=\||$)/g);f&&(Ae=f.length)}else if(typeof Ae=="number")if(K.match(/^\s*\|/)){if(ye!==ce.length-1)return;Fe=!0}else return}if(typeof Ae=="number"&&Ae>0){const ye=Fe?ce.slice(0,-1).join(`
`):ie,K=!!ye.match(/\|\s*$/),f=ye+(K?"":"|")+`
|${" --- |".repeat(Ae)}`;return a.marked.lexer(f)}}}),define(me[33],be([1,0,2,9,30,65,39,3,7,112]),function(re,t,i,C,z,H,A,y,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SS=w,t.$TS=d;function w(e,s){(0,b.$Tf)(s)?e.title=(0,A.$zk)(s):s?.markdownNotSupportedFallback?e.title=s.markdownNotSupportedFallback:e.removeAttribute("title")}class P{constructor(s,a,m){this.c=s,this.d=a,this.f=m}async update(s,a,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let p;if(s===void 0||(0,b.$Tf)(s)||s instanceof HTMLElement)p=s;else if(!(0,b.$8f)(s.markdown))p=s.markdown??s.markdownNotSupportedFallback;else{this.a||this.g((0,$.localize)(0,null),a),this.b=new z.$de;const v=this.b.token;if(p=await s.markdown(v),p===void 0&&(p=s.markdownNotSupportedFallback),this.isDisposed||v.isCancellationRequested)return}this.g(p,a,m)}g(s,a,m){const p=this.a;if(this.h(s)){const v={content:s,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!p},position:{hoverPosition:2},...m};this.a=this.c.showHover(v,a)}p?.dispose()}h(s){return s?(0,H.$Fk)(s)?!!s.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function c(e,s){for(s=s??i.getWindow(e).document.body;!e.hasAttribute("custom-hover")&&e!==s;)e=e.parentElement;return e}function d(e,s,a,m){s.setAttribute("custom-hover","true"),s.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",s.title),s.title="");let p,v;const o=(L,I)=>{const X=v!==void 0;L&&(v?.dispose(),v=void 0),I&&(p?.dispose(),p=void 0),X&&(e.onDidHideHover?.(),v=void 0)},g=(L,I,X)=>new C.$qh(async()=>{(!v||v.isDisposed)&&(v=new P(e,X||s,L>0),await v.update(typeof a=="function"?a():a,I,m))},L);let r=!1;const E=i.$2Q(s,i.$UR.MOUSE_DOWN,()=>{r=!0,o(!0,!0)},!0),R=i.$2Q(s,i.$UR.MOUSE_UP,()=>{r=!1},!0),M=i.$2Q(s,i.$UR.MOUSE_LEAVE,L=>{r=!1,o(!1,L.fromElement===s)},!0),j=L=>{if(p)return;const I=new y.$Sc,X={targetElements:[s],dispose:()=>{}};if(e.placement===void 0||e.placement==="mouse"){const U=de=>{X.x=de.x+10,de.target instanceof HTMLElement&&c(de.target,s)!==s&&o(!0,!0)};I.add(i.$2Q(s,i.$UR.MOUSE_MOVE,U,!0))}p=I,!(L.target instanceof HTMLElement&&c(L.target,s)!==s)&&I.add(g(e.delay,!1,X))},B=i.$2Q(s,i.$UR.MOUSE_OVER,j,!0),D=()=>{if(r||p)return;const L={targetElements:[s],dispose:()=>{}},I=new y.$Sc,X=()=>o(!0,!0);I.add(i.$2Q(s,i.$UR.BLUR,X,!0)),I.add(g(e.delay,!1,L)),p=I};let x;const W=s.tagName.toLowerCase();return W!=="input"&&W!=="textarea"&&(x=i.$2Q(s,i.$UR.FOCUS,D,!0)),{show:L=>{o(!1,!0),g(0,L)},hide:()=>{o(!0,!0)},update:async(L,I)=>{a=L,await v?.update(a,void 0,I)},dispose:()=>{B.dispose(),M.dispose(),E.dispose(),R.dispose(),x?.dispose(),o(!0,!0)}}}}),define(me[131],be([1,0,2,24,15,130,14,33,43,12,4,48,3,5,114,105]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GT=void 0;const s=i.$,a="selectOption.entry.template";class m{get templateId(){return a}renderTemplate(o){const g=Object.create(null);return g.root=o,g.text=i.$2R(o,s(".option-text")),g.detail=i.$2R(o,s(".option-detail")),g.decoratorRight=i.$2R(o,s(".option-decorator-right")),g}renderElement(o,g,r){const E=r,R=o.text,M=o.detail,j=o.decoratorRight,B=o.isDisabled;E.text.textContent=R,E.detail.textContent=M||"",E.decoratorRight.innerText=j||"",B?E.root.classList.add("option-disabled"):E.root.classList.remove("option-disabled")}disposeTemplate(o){}}class p extends c.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,g,r,E,R){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=E,this.g=R||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=p.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$6d,this.B(this.r),this.Q(),this.P(r),this.n=g||0,o&&this.setOptions(o,g),this.S()}O(o){!this.M&&o?this.M=this.B((0,y.$TS)((0,A.$VS)("mouse"),this.h,o)):this.M&&this.M.update(o)}getHeight(){return 22}getTemplateId(){return a}P(o){this.u=o,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$2R(this.w,s(".select-box-details-pane"));const g=i.$2R(this.w,s(".select-box-dropdown-container-width-control")),r=i.$2R(g,s(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$2R(r,this.D),this.G=0,this.y=i.$JR(this.w),this.w.setAttribute("draggable","true"),this.B(i.$2Q(this.w,i.$UR.DRAG_START,E=>{i.$WR.stop(E,!0)}))}Q(){this.B(i.$3Q(this.h,"change",g=>{this.n=g.target.selectedIndex,this.r.fire({index:g.target.selectedIndex,selected:g.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$2Q(this.h,i.$UR.CLICK,g=>{i.$WR.stop(g),this.f?this.Z(!0):this.Y()})),this.B(i.$2Q(this.h,i.$UR.MOUSE_DOWN,g=>{i.$WR.stop(g)}));let o;this.B(i.$2Q(this.h,"touchstart",g=>{o=this.f})),this.B(i.$2Q(this.h,"touchend",g=>{i.$WR.stop(g),o?this.Z(!0):this.Y()})),this.B(i.$2Q(this.h,i.$UR.KEY_DOWN,g=>{const r=new z.$YQ(g);let E=!1;d.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(E=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(E=!0),E&&(this.Y(),i.$WR.stop(g,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,g){$.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,E)=>{this.h.add(this.X(r.text,E,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),g!==void 0&&(this.select(g),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.U()}S(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}U(){const o=this.s.selectBackground??"",g=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=g,this.h.style.borderColor=r}W(){const o=this.s.selectBackground??"",g=i.$hS(this.s.selectListBackground,o);this.C.style.backgroundColor=g,this.I.style.backgroundColor=g;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(o,g,r){const E=document.createElement("option");return E.value=o,E.text=o,E.disabled=!!r,E}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}ab(o,g){return o.appendChild(this.w),this.cb(g),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}bb(){let o=0;return this.m.forEach((g,r)=>{this.jb(r),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}cb(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const g=i.getWindow(this.h),r=i.$lR(this.h),E=i.getWindow(this.h).getComputedStyle(this.h),R=parseFloat(E.getPropertyValue("--dropdown-padding-top"))+parseFloat(E.getPropertyValue("--dropdown-padding-bottom")),M=g.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),j=r.top-p.b,B=this.h.offsetWidth,D=this.db(this.D),x=Math.max(D,Math.round(B)).toString()+"px";this.w.style.width=x,this.z.getHTMLElement().style.height="",this.z.layout();let W=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const T=this.H?this.L:0,L=W+R+T,I=Math.floor((M-R-T)/this.getHeight()),X=Math.floor((j-R-T)/this.getHeight());if(o)return r.top+r.height>g.innerHeight-22||r.top<p.b||I<1&&X<1?!1:(I<p.c&&X>I&&this.m.length>I?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>g.innerHeight-22||r.top<p.b||this.G===0&&I<1||this.G===1&&X<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&I+X<1)return this.Z(!0),!1;L>M&&(W=I*this.getHeight())}else L>j&&(W=X*this.getHeight());return this.z.layout(W),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=W+R+"px",this.w.style.height=""):this.w.style.height=W+R+"px",this.jb(this.n),this.w.style.width=x,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(o){let g=0;if(o){let r=0,E=0;this.m.forEach((R,M)=>{const j=R.detail?R.detail.length:0,B=R.decoratorRight?R.decoratorRight.length:0,D=R.text.length+j+B;D>E&&(r=M,E=D)}),o.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),g=i.$nR(o)}return g}eb(o){if(this.z)return;this.C=i.$2R(o,s(".select-box-dropdown-list-container")),this.t=new m,this.z=new b.$yT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:E=>{let R=E.text;return E.detail&&(R+=`. ${E.detail}`),E.decoratorRight&&(R+=`. ${E.decoratorRight}`),E.description&&(R+=`. ${E.description}`),R},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>d.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const g=this.B(new C.$6S(this.C,"keydown")),r=w.Event.chain(g.event,E=>E.filter(()=>this.z.length>0).map(R=>new z.$YQ(R)));this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===3))(this.lb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===2))(this.lb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===9))(this.kb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===16))(this.nb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===18))(this.mb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===12))(this.pb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===11))(this.ob,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===14))(this.qb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode===13))(this.rb,this)),this.B(w.Event.chain(r,E=>E.filter(R=>R.keyCode>=21&&R.keyCode<=56||R.keyCode>=85&&R.keyCode<=113))(this.sb,this)),this.B(i.$2Q(this.z.getHTMLElement(),i.$UR.POINTER_UP,E=>this.fb(E))),this.B(this.z.onMouseOver(E=>typeof E.index<"u"&&this.z.setFocus([E.index]))),this.B(this.z.onDidChangeFocus(E=>this.ib(E))),this.B(i.$2Q(this.w,i.$UR.FOCUS_OUT,E=>{!this.f||i.$tR(E.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(o){if(!this.z.length)return;i.$WR.stop(o);const g=o.target;if(!g||g.classList.contains("slider"))return;const r=g.closest(".monaco-list-row");if(!r)return;const E=Number(r.getAttribute("data-index")),R=r.classList.contains("option-disabled");E>=0&&E<this.m.length&&!R&&(this.n=E,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(o,g){const r=R=>{for(let M=0;M<R.childNodes.length;M++){const j=R.childNodes.item(M);(j.tagName&&j.tagName.toLowerCase())==="img"?R.removeChild(j):r(j)}},E=(0,H.$BT)({value:o,supportThemeIcons:!0},{actionHandler:g});return E.element.classList.add("select-box-description-markdown"),r(E.element),E.element}ib(o){!this.f||!this.H||this.jb(o.indexes[0])}jb(o){this.I.innerText="";const g=this.m[o],r=g?.description??"",E=g?.descriptionIsMarkdown??!1;if(r){if(E){const R=g.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,R))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(o){i.$WR.stop(o),this.select(this.F),this.Z(!0)}lb(o){i.$WR.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(o){if(this.n<this.m.length-1){i.$WR.stop(o,!0);const g=this.m[this.n+1].isDisabled;if(g&&this.m.length>this.n+2)this.n+=2;else{if(g)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(o){this.n>0&&(i.$WR.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(o){i.$WR.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(o){i.$WR.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(o){i.$WR.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(o){i.$WR.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(o){const g=P.KeyCodeUtils.toString(o.keyCode);let r=-1;for(let E=0;E<this.m.length-1;E++)if(r=(E+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===g&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$WR.stop(o);break}}dispose(){this.Z(!1),super.dispose()}}t.$GT=p}),define(me[132],be([1,0,43,131,126,21,5,104]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=t.$IT=void 0,t.$IT={...i.$xT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends H.$CS{constructor($,w,P,c,d){super(),A.$j&&!d?.useCustomDrawn?this.a=new z.$HT($,w,c,d):this.a=new C.$GT($,w,P,c,d),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions($,w){this.a.setOptions($,w)}select($){this.a.select($)}setAriaLabel($){this.a.setAriaLabel($)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable($){this.a.setFocusable($)}render($){this.a.render($)}}t.$JT=y}),define(me[66],be([1,0,17,57,2,26,14,33,132,40,3,5,7,109,55]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=t.$QT=t.$PT=void 0;class e extends w.$Tc{get action(){return this._action}constructor(p,v,o={}){super(),this.m=o,this._context=p||this,this._action=v,v instanceof $.$Xi&&this.B(v.onDidChange(g=>{this.element&&this.t(g)}))}t(p){p.enabled!==void 0&&this.u(),p.checked!==void 0&&this.H(),p.class!==void 0&&this.G(),p.label!==void 0&&(this.w(),this.D()),p.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new $.$Yi)),this.j}set actionRunner(p){this.j=p}isEnabled(){return this._action.enabled}setActionContext(p){this._context=p}render(p){const v=this.element=p;this.B(H.$yS.addTarget(p));const o=this.m&&this.m.draggable;o&&(p.draggable=!0,i.$HQ&&this.B((0,z.$2Q)(p,z.$UR.DRAG_START,g=>g.dataTransfer?.setData(C.$wS.TEXT,this._action.label)))),this.B((0,z.$2Q)(v,H.EventType.Tap,g=>this.onClick(g,!0))),this.B((0,z.$2Q)(v,z.$UR.MOUSE_DOWN,g=>{o||z.$WR.stop(g,!0),this._action.enabled&&g.button===0&&v.classList.add("active")})),P.$j&&this.B((0,z.$2Q)(v,z.$UR.CONTEXT_MENU,g=>{g.button===0&&g.ctrlKey===!0&&this.onClick(g)})),this.B((0,z.$2Q)(v,z.$UR.CLICK,g=>{z.$WR.stop(g,!0),this.m&&this.m.isMenu||this.onClick(g)})),this.B((0,z.$2Q)(v,z.$UR.DBLCLICK,g=>{z.$WR.stop(g,!0)})),[z.$UR.MOUSE_UP,z.$UR.MOUSE_OUT].forEach(g=>{this.B((0,z.$2Q)(v,g,r=>{z.$WR.stop(r),v.classList.remove("active")}))})}onClick(p,v=!1){z.$WR.stop(p,!0);const o=c.$3f(this._context)?this.m?.useEventAsContext?p:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(p){this.element&&(this.element.tabIndex=p?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const p=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=p;else if(!this.f&&p!==""){const v=this.m.hoverDelegate??(0,A.$VS)("element");this.f=this.q.add((0,y.$TS)(v,this.element,p))}else this.f&&this.f.update(p)}F(){if(this.element){const p=this.C()??"";this.element.setAttribute("aria-label",p)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$PT=e;class s extends e{constructor(p,v,o){super(p,v,o),this.m=o,this.m.icon=o.icon!==void 0?o.icon:!1,this.m.label=o.label!==void 0?o.label:!0,this.L=""}render(p){super.render(p),c.$4f(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.M()),this.I=v,this.element.appendChild(v),this.m.label&&this.m.keybinding){const o=document.createElement("span");o.classList.add("keybinding"),o.textContent=this.m.keybinding,this.element.appendChild(o)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===$.$Zi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(p){this.I&&(this.I.tabIndex=p?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let p=null;return this.action.tooltip?p=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(p=this.action.label,this.m.keybinding&&(p=d.localize(0,null,p,this.m.keybinding))),p??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const p=this.C()??"";this.I.setAttribute("aria-label",p)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$QT=s;class a extends e{constructor(p,v,o,g,r,E,R){super(p,v),this.b=new b.$JT(o,g,r,E,R),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(p,v){this.b.setOptions(p,v)}select(p){this.b.select(p)}g(){this.B(this.b.onDidSelect(p=>this.n(p.selected,p.index)))}n(p,v){this.actionRunner.run(this._action,this.r(p,v))}r(p,v){return p}setFocusable(p){this.b.setFocusable(p)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(p){this.b.render(p)}}t.$RT=a}),define(me[67],be([1,0,2,15,66,14,40,4,3,7,55]),function(re,t,i,C,z,H,A,y,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XS=t.ActionsOrientation=void 0,t.$YS=c;var w;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class P extends b.$Tc{constructor(e,s={}){super(),this.j=this.B(new b.$Sc),this.s=this.B(new b.$3c),this.y=!1,this.z=!0,this.D=this.B(new y.$6d),this.onDidBlur=this.D.event,this.F=this.B(new y.$6d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new y.$6d),this.onDidRun=this.H.event,this.I=this.B(new y.$6d),this.onWillRun=this.I.event,this.b=s,this.m=s.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=s.hoverDelegate??this.B((0,H.$WS)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new A.$Yi,this.j.add(this.g)),this.j.add(this.g.onDidRun(p=>this.H.fire(p))),this.j.add(this.g.onWillRun(p=>this.I.fire(p))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let a,m;switch(this.n){case 0:a=[15],m=[17];break;case 1:a=[16],m=[18],this.domNode.className+=" vertical";break}this.B(i.$2Q(this.domNode,i.$UR.KEY_DOWN,p=>{const v=new C.$YQ(p);let o=!0;const g=typeof this.u=="number"?this.viewItems[this.u]:void 0;a&&(v.equals(a[0])||v.equals(a[1]))?o=this.Q():m&&(v.equals(m[0])||v.equals(m[1]))?o=this.P():v.equals(9)&&this.G?this.F.fire():v.equals(14)?o=this.N():v.equals(13)?o=this.O():v.equals(2)&&g instanceof z.$PT&&g.trapsArrowNavigation?o=this.P():this.L(v)?this.r.keyDown?this.S(v):this.y=!0:o=!1,o&&(v.preventDefault(),v.stopPropagation())})),this.B(i.$2Q(this.domNode,i.$UR.KEY_UP,p=>{const v=new C.$YQ(p);this.L(v)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(v)),v.preventDefault(),v.stopPropagation()):(v.equals(2)||v.equals(1026)||v.equals(16)||v.equals(18)||v.equals(15)||v.equals(17))&&this.M()})),this.w=this.B(i.$ZR(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$BR()===this.domNode||!i.$tR(i.$BR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const s=this.viewItems.find(a=>a instanceof z.$PT&&a.isEnabled());s instanceof z.$PT&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof z.$PT&&s.setFocusable(!1)})}L(e){let s=!1;return this.r.keys.forEach(a=>{s=s||e.equals(a)}),s}M(){for(let e=0;e<this.C.children.length;e++){const s=this.C.children[e];if(i.$tR(i.$BR(),s)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(s=>s.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(s=>this.H.fire(s))),this.j.add(this.g.onWillRun(s=>this.I.fire(s))),this.viewItems.forEach(s=>s.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(s=>s.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let s=0;s<this.C.childNodes.length;s++)if(this.C.childNodes[s]===e)return this.viewItems[s].action}}push(e,s={}){const a=Array.isArray(e)?e:[e];let m=$.$Xf(s.index)?s.index:null;a.forEach(p=>{const v=document.createElement("li");v.className="action-item",v.setAttribute("role","presentation");let o;const g={hoverDelegate:this.f,...s};this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(p,g)),o||(o=new z.$QT(this.context,p,g)),this.b.allowContextMenu||this.s.set(o,i.$2Q(v,i.$UR.CONTEXT_MENU,r=>{i.$WR.stop(r,!0)})),o.actionRunner=this.g,o.setActionContext(this.context),o.render(v),this.z&&o instanceof z.$PT&&this.viewItems.length===0&&o.setFocusable(!0),m===null||m<0||m>=this.C.children.length?(this.C.appendChild(v),this.viewItems.push(o)):(this.C.insertBefore(v,this.C.children[m]),this.viewItems.splice(m,0,o),m++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const s=this.C.children.item(e);if(s)return s.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const s=this.C.children.item(e);if(s)return s.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,b.$Oc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,b.$Oc)(this.viewItems),this.s.clearAndDisposeAll(),i.$1Q(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let s=!1,a;if(e===void 0?s=!0:typeof e=="number"?a=e:typeof e=="boolean"&&(s=e),s&&typeof this.u>"u"){const m=this.viewItems.findIndex(p=>p.isEnabled());this.u=m===-1?void 0:m,this.R(void 0,void 0,!0)}else a!==void 0&&(this.u=a),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.u;let a;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=s,!1;this.u=(this.u+1)%this.viewItems.length,a=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===A.$Zi.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const s=this.u;let a;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=s,!1;this.u=this.viewItems.length-1}a=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===A.$Zi.ID));return this.R(!0),!0}R(e,s,a=!1){typeof this.u>"u"&&this.C.focus({preventScroll:s}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const m=this.u!==void 0?this.viewItems[this.u]:void 0;if(m){let p=!0;$.$8f(m.focus)||(p=!1),this.b.focusOnlyEnabledItems&&$.$8f(m.isEnabled)&&!m.isEnabled()&&(p=!1),m.action.id===A.$Zi.ID&&(p=!1),p?(a||this.t!==this.u)&&(m.focus(e),this.t=this.u):(this.C.focus({preventScroll:s}),this.t=void 0),p&&m.showHover?.()}}S(e){if(typeof this.u>"u")return;const s=this.viewItems[this.u];if(s instanceof z.$PT){const a=s._context===null||s._context===void 0?e:s._context;this.run(s._action,a)}}async run(e,s){await this.g.run(e,s)}dispose(){this.m=void 0,this.viewItems=(0,b.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$XS=P;function c(d){if(!d.length)return d;let e=-1;for(let a=0;a<d.length;a++)if(d[a].id!==A.$Zi.ID){e=a;break}if(e===-1)return[];d=d.slice(e);for(let a=d.length-1;a>=0&&d[a].id===A.$Zi.ID;a--)d.splice(a,1);let s=!1;for(let a=d.length-1;a>=0;a--){const m=d[a].id===A.$Zi.ID;m&&!s?d.splice(a,1):m?m&&(s=!1):s=!0}return d}}),define(me[68],be([1,0,2,24,58,67,60,14,33,63,21,4,85,54,113,101]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.$wU=t.$vU=t.MessageType=void 0;const s=i.$;var a;(function(v){v[v.INFO=1]="INFO",v[v.WARNING=2]="WARNING",v[v.ERROR=3]="ERROR"})(a||(t.MessageType=a={})),t.$vU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class m extends w.$CS{constructor(o,g,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new P.$6d),this.onDidChange=this.P.event,this.Q=this.B(new P.$6d),this.onDidHeightChange=this.Q.event,this.a=g,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$2R(o,s(".monaco-inputbox.idle"));const E=this.g.flexibleHeight?"textarea":"input",R=i.$2R(this.element,s(".ibwrapper"));if(this.b=i.$2R(R,s(E+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$2R(R,s("div.mirror")),this.y.innerText="\xA0",this.N=new $.$MS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$2R(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(B=>this.b.scrollTop=B.scrollTop));const M=this.B(new C.$6S(o.ownerDocument,"selectionchange")),j=P.Event.filter(M.event,()=>o.ownerDocument.getSelection()?.anchorNode===R);this.B(j(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new H.$XS(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.O?this.O.update(o):this.O=this.B((0,b.$TS)((0,y.$VS)("mouse"),this.b,o))}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Z())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:i.$rR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$CR(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(o){o?this.enable():this.disable()}get width(){return i.$nR(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,E=parseFloat(this.y.style.paddingRight||"")||0;g=r+E}this.b.style.width=o-g+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,g=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:g}),this.N.setScrollPosition({scrollTop:r})}showMessage(o,g){if(this.w==="open"&&(0,d.$Qn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(o.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$hS(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||g)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const g=this.g.inputBoxStyles;switch(o){case 1:return{border:g.inputValidationInfoBorder,background:g.inputValidationInfoBackground,foreground:g.inputValidationInfoForeground};case 2:return{border:g.inputValidationWarningBorder,background:g.inputValidationWarningBackground,foreground:g.inputValidationWarningForeground};default:return{border:g.inputValidationErrorBorder,background:g.inputValidationErrorBackground,foreground:g.inputValidationErrorForeground}}}W(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let o;const g=()=>o.style.width=i.$nR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:E=>{if(!this.h)return null;o=i.$2R(E,s(".monaco-inputbox-container")),g();const R={inline:!0,className:"monaco-inputbox-message"},M=this.h.formatContent?(0,z.$4S)(this.h.content,R):(0,z.$3S)(this.h.content,R);M.classList.add(this.W(this.h.type));const j=this.stylesForType(this.h.type);return M.style.backgroundColor=j.background??"",M.style.color=j.foreground??"",M.style.border=j.border?`1px solid ${j.border}`:"",i.$2R(o,M),null},onHide:()=>{this.w="closed"},layout:g});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),A.$8S(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const o=this.value,r=o.charCodeAt(o.length-1)===10?" ":"";(o+r).replace(/\u000c/g,"")?this.y.textContent=o+r:this.y.innerText="\xA0",this.layout()}bb(){const o=this.g.inputBoxStyles,g=o.inputBackground??"",r=o.inputForeground??"",E=o.inputBorder??"";this.element.style.backgroundColor=g,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$hS(E,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=i.$rR(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(o){const g=this.inputElement,r=g.selectionStart,E=g.selectionEnd,R=g.value;r!==null&&E!==null&&(this.value=R.substr(0,r)+o+R.substr(E),g.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$wU=m;class p extends m{constructor(o,g,r){const E=e.localize(3,null,"\u21C5"),R=e.localize(4,null,"\u21C5");super(o,g,r),this.eb=this.B(new P.$6d),this.onDidFocus=this.eb.event,this.fb=this.B(new P.$6d),this.onDidBlur=this.fb.event,this.cb=new c.$tU(r.history,100);const M=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(E)&&!this.n.endsWith(R)&&this.cb.getHistory().length){const j=this.n.endsWith(")")?E:R,B=this.n+j;r.showPlaceholderOnFocus&&!i.$CR(this.b)?this.n=B:this.setPlaceHolder(B)}};this.db=new MutationObserver((j,B)=>{j.forEach(D=>{D.target.textContent||M()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>M()),this.F(this.b,()=>{const j=B=>{if(this.n.endsWith(B)){const D=this.n.slice(0,this.n.length-B.length);return r.showPlaceholderOnFocus?this.n=D:this.setPlaceHolder(D),!0}else return!1};j(R)||j(E)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(o){this.value&&(o||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(o){const g=this.getHistory();this.clearHistory(),o.forEach(r=>{this.cb.add(r)}),g.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let o=this.kb();o&&(o=o===this.value?this.kb():o),this.value=o??"",A.$9S(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),o&&(this.value=o,A.$9S(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let o=this.cb.current();return o||(o=this.cb.last(),this.cb.next()),o}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$xU=p}),define(me[69],be([1,0,66,21,18,19,4,2,33,14,106]),function(re,t,i,C,z,H,A,y,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OT=t.$NT=t.$MT=t.$LT=t.$KT=void 0,t.$KT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends i.$PT{constructor(s,a,m){super(s,a,m),this.a=this.B(new P({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:m.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:m.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:m.toggleStyles?.inputActiveOptionForeground,hoverDelegate:m.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$LT=w;class P extends C.$CS{constructor(s){super(),this.a=this.B(new A.$6d),this.onChange=this.a.event,this.b=this.B(new A.$6d),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$TS)(s.hoverDelegate??(0,$.$VS)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,m=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),m.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,m=>{if(m.keyCode===10||m.keyCode===3){this.checked=!this.s,this.a.fire(!0),m.preventDefault(),m.stopPropagation();return}this.b.fire(m)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(s){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.t.update(s),this.domNode.setAttribute("aria-label",s)}}t.$MT=P;class c extends C.$CS{constructor(s,a,m){super(),this.g=s,this.h=a,this.a=this.B(new A.$6d),this.onChange=this.a.event,this.b=new P({title:this.g,isChecked:this.h,icon:z.$Fj.check,actionClassName:"monaco-checkbox",...t.$KT}),this.domNode=this.b.domNode,this.c=m,this.n(),this.B(this.b.onChange(p=>{this.n(),this.a.fire(p)}))}get checked(){return this.b.checked}set checked(s){this.b.checked=s,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,y.$CR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$NT=c;class d extends i.$PT{constructor(s,a,m){super(s,a,m),this.a=this.B(new c(this._action.label,!!this._action.checked,m.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const a=this.element.appendChild((0,y.$)("span.checkbox-label",void 0,this._action.label));this.B((0,y.$2Q)(a,y.$UR.CLICK,m=>{this.a.checked=!this.a.checked,m.stopPropagation(),m.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$OT=d}),define(me[133],be([1,0,14,69,18,111]),function(re,t,i,C,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KU=t.$JU=t.$IU=void 0;const A=H.localize(0,null),y=H.localize(1,null),b=H.localize(2,null);class $ extends C.$MT{constructor(d){super({icon:z.$Fj.caseSensitive,title:A+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$VS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$IU=$;class w extends C.$MT{constructor(d){super({icon:z.$Fj.wholeWord,title:y+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$VS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$JU=w;class P extends C.$MT{constructor(d){super({icon:z.$Fj.regex,title:b+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$VS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$KU=P}),define(me[134],be([1,0,2,133,68,21,4,110,3,14,100]),function(re,t,i,C,z,H,A,y,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LU=void 0;const w=y.localize(0,null);class P extends H.$CS{static{this.OPTION_CHANGE="optionChange"}constructor(d,e,s){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Uc),this.N=[],this.O=this.B(new A.$6d),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$6d),this.onKeyDown=this.P.event,this.Q=this.B(new A.$6d),this.onMouseDown=this.Q.event,this.R=this.B(new A.$6d),this.onInput=this.R.event,this.S=this.B(new A.$6d),this.onKeyUp=this.S.event,this.U=this.B(new A.$6d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$6d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=s.placeholder||"",this.b=s.validation,this.c=s.label||w,this.h=!!s.showCommonFindToggles;const a=s.appendCaseSensitiveLabel||"",m=s.appendWholeWordsLabel||"",p=s.appendRegexLabel||"",v=s.history||[],o=!!s.flexibleHeight,g=!!s.flexibleWidth,r=s.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new z.$xU(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:v,showHistoryHint:s.showHistoryHint,flexibleHeight:o,flexibleWidth:g,flexibleMaxHeight:r,inputBoxStyles:s.inputBoxStyles}));const E=this.B((0,$.$WS)());if(this.h){this.J=this.B(new C.$KU({appendTitle:p,isChecked:!1,hoverDelegate:E,...s.toggleStyles})),this.B(this.J.onChange(M=>{this.O.fire(M),!M&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(M=>{this.W.fire(M)})),this.L=this.B(new C.$JU({appendTitle:m,isChecked:!1,hoverDelegate:E,...s.toggleStyles})),this.B(this.L.onChange(M=>{this.O.fire(M),!M&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$IU({appendTitle:a,isChecked:!1,hoverDelegate:E,...s.toggleStyles})),this.B(this.M.onChange(M=>{this.O.fire(M),!M&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(M=>{this.U.fire(M)}));const R=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,M=>{if(M.equals(15)||M.equals(17)||M.equals(9)){const j=R.indexOf(this.domNode.ownerDocument.activeElement);if(j>=0){let B=-1;M.equals(17)?B=(j+1)%R.length:M.equals(15)&&(j===0?B=R.length-1:B=j-1),M.equals(9)?(R[j].blur(),this.inputBox.focus()):B>=0&&R[B].focus(),i.$WR.stop(M,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(s?.additionalToggles),this.y&&this.domNode.appendChild(this.y),d?.appendChild(this.domNode),this.B(i.$2Q(this.inputBox.inputElement,"compositionstart",R=>{this.s=!0})),this.B(i.$2Q(this.inputBox.inputElement,"compositionend",R=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,R=>this.P.fire(R)),this.C(this.inputBox.inputElement,R=>this.S.fire(R)),this.D(this.inputBox.inputElement,R=>this.R.fire()),this.j(this.inputBox.inputElement,R=>this.Q.fire(R))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(d){this.inputBox.layout(),this.X(d.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const d of this.N)d.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const d of this.N)d.disable()}setFocusInputOnOptionClick(d){this.n=d}setEnabled(d){d?this.enable():this.disable()}setAdditionalToggles(d){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new b.$Sc;for(const e of d??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(s=>{this.O.fire(s),!s&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(d=!1){d?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,s)=>e+s.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(d){this.inputBox.value!==d&&(this.inputBox.value=d)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(d){this.M&&(this.M.checked=d)}getWholeWords(){return this.L?.checked??!1}setWholeWords(d){this.L&&(this.L.checked=d)}getRegex(){return this.J?.checked??!1}setRegex(d){this.J&&(this.J.checked=d,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(d){this.inputBox.showMessage(d)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$LU=P}),define(me[135],be([1,0,2,24,15,67,134,68,64,43,69,61,27,40,12,9,18,19,34,4,37,3,35,7,115,14,107]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e,s,a,m,p,v,o,g,r,E,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$jV=t.$iV=t.$hV=t.RenderIndentGuides=t.$gV=t.$fV=void 0;class j extends b.$dT{set context(n){this.c.context=n}get context(){return this.c.context}constructor(n){super(n.elements.map(h=>h.element)),this.c=n}}function B(u){return u instanceof b.$dT?new j(u):u}class D{constructor(n,h){this.d=n,this.f=h,this.b=g.$Tc.None,this.c=new g.$Sc}getDragURI(n){return this.f.getDragURI(n.element)}getDragLabel(n,h){if(this.f.getDragLabel)return this.f.getDragLabel(n.map(N=>N.element),h)}onDragStart(n,h){this.f.onDragStart?.(B(n),h)}onDragOver(n,h,N,S,O,V=!0){const Z=this.f.onDragOver(B(n),h&&h.element,N,S,O),ee=this.a!==h;if(ee&&(this.b.dispose(),this.a=h),typeof h>"u")return Z;if(ee&&typeof Z!="boolean"&&Z.autoExpand&&(this.b=(0,s.$ih)(()=>{const Se=this.d(),Ee=Se.getNodeLocation(h);Se.isCollapsed(Ee)&&Se.setCollapsed(Ee,!1),this.a=void 0},500,this.c)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!V){const Se=typeof Z=="boolean"?Z:Z.accept,Ee=typeof Z=="boolean"?void 0:Z.effect;return{accept:Se,effect:Ee,feedback:[N]}}return Z}if(Z.bubble===1){const Se=this.d(),Ee=Se.getNodeLocation(h),Re=Se.getParentNodeLocation(Ee),Le=Se.getNode(Re),Ye=Re&&Se.getListIndex(Re);return this.onDragOver(n,Le,Ye,S,O,!1)}const $e=this.d(),ve=$e.getNodeLocation(h),we=$e.getListIndex(ve),je=$e.getListRenderCount(ve);return{...Z,feedback:(0,e.$Sb)(we,we+je)}}drop(n,h,N,S,O){this.b.dispose(),this.a=void 0,this.f.drop(B(n),h&&h.element,N,S,O)}onDragEnd(n){this.f.onDragEnd?.(n)}dispose(){this.c.dispose(),this.f.dispose()}}function x(u,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(h){return n.identityProvider.getId(h.element)}},dnd:n.dnd&&new D(u,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(h){return n.multipleSelectionController.isSelectionSingleChangeEvent({...h,element:h.element})},isSelectionRangeChangeEvent(h){return n.multipleSelectionController.isSelectionRangeChangeEvent({...h,element:h.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(h){const N=u(),S=N.getNodeLocation(h),O=N.getParentNodeLocation(S);return N.getNode(O).visibleChildrenCount},getPosInSet(h){return h.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?h=>n.accessibilityProvider.isChecked(h.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?h=>n.accessibilityProvider.getRole(h.element):()=>"treeitem",getAriaLabel(h){return n.accessibilityProvider.getAriaLabel(h.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?h=>n.accessibilityProvider.getAriaLevel(h.element):h=>h.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(h=>n.accessibilityProvider.getActiveDescendantId(h.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(h){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(h.element)}}}}class W{constructor(n){this.a=n}getHeight(n){return this.a.getHeight(n.element)}getTemplateId(n){return this.a.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(n.element)}setDynamicHeight(n,h){this.a.setDynamicHeight?.(n.element,h)}}t.$fV=W;class T{static lift(n){return n instanceof T?n:new T(n)}static empty(n=0){return new T({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const h of n.expanded)this.expanded[h]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$gV=T;var L;(function(u){u.None="none",u.OnHover="onHover",u.Always="always"})(L||(t.RenderIndentGuides=L={}));class I{get elements(){return this.b}constructor(n,h=[]){this.b=h,this.a=new g.$Sc,this.onDidChange=v.Event.forEach(n,N=>this.b=N,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(n,h,N,S,O,V={}){this.o=n,this.p=h,this.q=S,this.s=O,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=g.$Tc.None,this.m=new g.$Sc,this.templateId=n.templateId,this.updateOptions(V),v.Event.map(N,Z=>Z.node)(this.u,this,this.m),n.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(n={}){if(typeof n.indent<"u"){const h=(0,r.$lm)(n.indent,0,40);if(h!==this.d){this.d=h;for(const[N,S]of this.c)this.v(N,S)}}if(typeof n.renderIndentGuides<"u"){const h=n.renderIndentGuides!==L.None;if(h!==this.g){this.g=h;for(const[N,S]of this.c)this.w(N,S);if(this.k.dispose(),h){const N=new g.$Sc;this.q.onDidChange(this.x,this,N),this.k=N,this.x(this.q.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.f=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const h=(0,i.$2R)(n,(0,i.$)(".monaco-tl-row")),N=(0,i.$2R)(h,(0,i.$)(".monaco-tl-indent")),S=(0,i.$2R)(h,(0,i.$)(".monaco-tl-twistie")),O=(0,i.$2R)(h,(0,i.$)(".monaco-tl-contents")),V=this.o.renderTemplate(O);return{container:n,indent:N,twistie:S,indentGuidesDisposable:g.$Tc.None,templateData:V}}renderElement(n,h,N,S){this.c.set(n,N),this.b.set(n.element,n),this.v(n,N),this.o.renderElement(n,h,N.templateData,S)}disposeElement(n,h,N,S){N.indentGuidesDisposable.dispose(),this.o.disposeElement?.(n,h,N.templateData,S),typeof S=="number"&&(this.c.delete(n),this.b.delete(n.element))}disposeTemplate(n){this.o.disposeTemplate(n.templateData)}t(n){const h=this.b.get(n);h&&this.u(h)}u(n){const h=this.c.get(n);h&&(this.x(this.q.elements),this.v(n,h))}v(n,h){const N=X.a+(n.depth-1)*this.d;h.twistie.style.paddingLeft=`${N}px`,h.indent.style.width=`${N+this.d-16}px`,n.collapsible?h.container.setAttribute("aria-expanded",String(!n.collapsed)):h.container.removeAttribute("aria-expanded"),h.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(a.$Fj.treeItemExpanded));let S=!1;this.o.renderTwistie&&(S=this.o.renderTwistie(n.element,h.twistie)),n.collapsible&&(!this.f||n.visibleChildrenCount>0)?(S||h.twistie.classList.add(...m.ThemeIcon.asClassNameArray(a.$Fj.treeItemExpanded)),h.twistie.classList.add("collapsible"),h.twistie.classList.toggle("collapsed",n.collapsed)):h.twistie.classList.remove("collapsible","collapsed"),this.w(n,h)}w(n,h){if((0,i.$1Q)(h.indent),h.indentGuidesDisposable.dispose(),!this.g)return;const N=new g.$Sc,S=this.p();for(;;){const O=S.getNodeLocation(n),V=S.getParentNodeLocation(O);if(!V)break;const Z=S.getNode(V),ee=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&ee.classList.add("active"),h.indent.childElementCount===0?h.indent.appendChild(ee):h.indent.insertBefore(ee,h.indent.firstElementChild),this.s.add(Z,ee),N.add((0,g.$Rc)(()=>this.s.delete(Z,ee))),n=Z}h.indentGuidesDisposable=N}x(n){if(!this.g)return;const h=new Set,N=this.p();n.forEach(S=>{const O=N.getNodeLocation(S);try{const V=N.getParentNodeLocation(O);S.collapsible&&S.children.length>0&&!S.collapsed?h.add(S):V&&h.add(N.getNode(V))}catch{}}),this.j.forEach(S=>{h.has(S)||this.s.forEach(S,O=>O.classList.remove("active"))}),h.forEach(S=>{this.j.has(S)||this.s.forEach(S,O=>O.classList.add("active"))}),this.j=h}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,g.$Oc)(this.m)}}t.$hV=X;class U{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(n){this.c=n,this.d=n.toLowerCase()}constructor(n,h,N){this.g=n,this.j=h,this.k=N,this.a=0,this.b=0,this.c="",this.d="",this.f=new g.$Sc,n.onWillRefilter(this.m,this,this.f)}filter(n,h){let N=1;if(this.k){const V=this.k.filter(n,h);if(typeof V=="boolean"?N=V?1:0:(0,P.$cV)(V)?N=(0,P.$dV)(V.visibility):N=V,N===0)return!1}if(this.a++,!this.c)return this.b++,{data:o.FuzzyScore.Default,visibility:N};const S=this.j.getKeyboardNavigationLabel(n),O=Array.isArray(S)?S:[S];for(const V of O){const Z=V&&V.toString();if(typeof Z>"u")return{data:o.FuzzyScore.Default,visibility:N};let ee;if(this.g.findMatchType===Ne.Contiguous){const $e=Z.toLowerCase().indexOf(this.d);if($e>-1){ee=[Number.MAX_SAFE_INTEGER,0];for(let ve=this.d.length;ve>0;ve--)ee.push($e+ve-1)}}else ee=(0,o.$uk)(this.c,this.d,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ee)return this.b++,O.length===1?{data:ee,visibility:N}:{data:{label:Z,score:ee},visibility:N}}return this.g.findMode===ge.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(n):2:{data:o.FuzzyScore.Default,visibility:N}}m(){this.a=0,this.b=0}dispose(){(0,g.$Oc)(this.f)}}class de extends w.$MT{constructor(n){super({icon:a.$Fj.listFilter,title:(0,R.localize)(0,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,M.$VS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$iV=de;class he extends w.$MT{constructor(n){super({icon:a.$Fj.searchFuzzy,title:(0,R.localize)(1,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,M.$VS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$jV=he;const ne={inputBoxStyles:y.$vU,toggleStyles:w.$KT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ge;(function(u){u[u.Highlight=0]="Highlight",u[u.Filter=1]="Filter"})(ge||(t.TreeFindMode=ge={}));var Ne;(function(u){u[u.Fuzzy=0]="Fuzzy",u[u.Contiguous=1]="Contiguous"})(Ne||(t.TreeFindMatchType=Ne={}));class Ce extends g.$Tc{set mode(n){this.b.checked=n===ge.Filter,this.f.inputBox.setPlaceHolder(n===ge.Filter?(0,R.localize)(2,null):(0,R.localize)(3,null))}set matchType(n){this.c.checked=n===Ne.Fuzzy}get value(){return this.f.inputBox.value}set value(n){this.f.inputBox.value=n}constructor(n,h,N,S,O,V){super(),this.t=h,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new v.$6d,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.a.root),this.B((0,g.$Rc)(()=>n.removeChild(this.a.root)));const Z=V?.styles??ne;Z.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const ee=this.B((0,M.$WS)());this.b=this.B(new de({...Z.toggleStyles,isChecked:S===ge.Filter,hoverDelegate:ee})),this.c=this.B(new he({...Z.toggleStyles,isChecked:O===Ne.Fuzzy,hoverDelegate:ee})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?ge.Filter:ge.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?Ne.Fuzzy:Ne.Contiguous,this.q),this.f=this.B(new A.$LU(this.a.findInput,N,{label:(0,R.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:V?.history})),this.g=this.B(new H.$XS(this.a.actionbar)),this.mode=S;const $e=this.B(new C.$6S(this.f.inputBox.inputElement,"keydown")),ve=v.Event.chain($e.event,Ee=>Ee.map(Re=>new z.$YQ(Re)));this.B(ve(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const we=this.B(new d.$Xi("close",(0,R.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(we,{icon:!0,label:!1});const je=this.B(new C.$6S(this.a.grab,"mousedown"));this.B(je.event(Ee=>{const Re=new g.$Sc,Le=Re.add(new C.$6S((0,i.getWindow)(Ee),"mousemove")),Ye=Re.add(new C.$6S((0,i.getWindow)(Ee),"mouseup")),nt=this.m,Ge=Ee.pageX,Ue=this.s,Y=Ee.pageY;this.a.grab.classList.add("grabbing");const se=this.a.root.style.transition;this.a.root.style.transition="unset";const pe=De=>{const Ie=De.pageX-Ge;this.m=nt-Ie;const ze=De.pageY-Y;this.s=Ue+ze,this.layout()};Re.add(Le.event(pe)),Re.add(Ye.event(De=>{pe(De),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=se,Re.dispose()}))}));const Se=v.Event.chain(this.B(new C.$6S(this.a.grab,"keydown")).event,Ee=>Ee.map(Re=>new z.$YQ(Re)));this.B(Se(Ee=>{let Re,Le;if(Ee.keyCode===15?Re=Number.POSITIVE_INFINITY:Ee.keyCode===17?Re=0:Ee.keyCode===10&&(Re=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Le=0:Ee.keyCode===18&&(Le=Number.POSITIVE_INFINITY),Re!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=Re,this.layout()),Le!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Le;const Ye=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(n=this.j){this.j=n,this.m=(0,r.$lm)(this.m,0,Math.max(0,n-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$lm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(n){this.f.showMessage(n)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$hh)(300),super.dispose()}}class Pe{get pattern(){return this.b}get mode(){return this.d}set mode(n){n!==this.d&&(this.d=n,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(n))}get matchType(){return this.f}set matchType(n){n!==this.f&&(this.f=n,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(n))}constructor(n,h,N,S,O,V={}){this.t=n,this.u=N,this.v=S,this.w=O,this.x=V,this.b="",this.c="",this.j=0,this.k=new v.$6d,this.onDidChangeMode=this.k.event,this.m=new v.$6d,this.onDidChangeMatchType=this.m.event,this.o=new v.$6d,this.onDidChangePattern=this.o.event,this.p=new v.$6d,this.onDidChangeOpenState=this.p.event,this.q=new g.$Sc,this.s=new g.$Sc,this.d=n.options.defaultFindMode??ge.Highlight,this.f=n.options.defaultFindMatchType??Ne.Fuzzy,h.onDidSplice(this.z,this,this.s)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ce(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(n=>this.mode=n,void 0,this.q),this.g.onDidChangeMatchType(n=>this.matchType=n,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(n){this.b=n,this.o.fire(n),this.v.pattern=n,this.t.refilter(),n&&this.t.focusNext(0,!0,void 0,N=>!o.FuzzyScore.isDefault(N.filterData));const h=this.t.getFocus();if(h.length>0){const N=h[0];this.t.getRelativeTop(N)===null&&this.t.reveal(N,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const n=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&n?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,R.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(n){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!o.FuzzyScore.isDefault(n.filterData)}layout(n){this.j=n,this.g?.layout(n)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function le(u,n){return u.position===n.position&&_(u,n)}function _(u,n){return u.node.element===n.node.element&&u.startIndex===n.startIndex&&u.height===n.height&&u.endIndex===n.endIndex}class ae{constructor(n=[]){this.stickyNodes=n}get count(){return this.stickyNodes.length}equal(n){return(0,e.$ub)(this.stickyNodes,n.stickyNodes,le)}lastNodePartiallyVisible(){if(this.count===0)return!1;const n=this.stickyNodes[this.count-1];if(this.count===1)return n.position!==0;const h=this.stickyNodes[this.count-2];return h.position+h.height!==n.position}animationStateChanged(n){if(!(0,e.$ub)(this.stickyNodes,n.stickyNodes,_)||this.count===0)return!1;const h=this.stickyNodes[this.count-1],N=n.stickyNodes[n.count-1];return h.position!==N.position}}class oe{constrainStickyScrollNodes(n,h,N){for(let S=0;S<n.length;S++){const O=n[S];if(O.position+O.height>N||S>=h)return n.slice(0,S)}return n}}class J extends g.$Tc{constructor(n,h,N,S,O,V={}){super(),this.g=n,this.j=h,this.m=N,this.s=O,this.c=.4;const Z=this.validateStickySettings(V);this.b=Z.stickyScrollMaxItemCount,this.a=V.stickyScrollDelegate??new oe,this.f=this.B(new G(N.getScrollableElement(),N,n,S,O,V.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(N.onDidScroll(()=>this.u())),this.B(N.onDidChangeContentHeight(()=>this.u())),this.B(n.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(n){return this.f.getNode(n)}t(n){let h;if(n===0?h=this.m.firstVisibleIndex:h=this.m.indexAt(n+this.m.scrollTop),!(h<0||h>=this.m.length))return this.m.element(h)}u(){const n=this.t(0);if(!n||this.g.scrollTop===0){this.f.setState(void 0);return}const h=this.w(n);this.f.setState(h)}w(n){const h=[];let N=n,S=0,O=this.z(N,void 0,S);for(;O&&(h.push(O),S+=O.height,!(h.length<=this.b&&(N=this.y(O),!N)));)O=this.z(N,O.node,S);const V=this.H(h);return V.length?new ae(V):void 0}y(n){return this.t(n.position+n.height)}z(n,h,N){const S=this.F(n,h);if(S&&!(S===n&&(!this.J(n)||this.C(n,N))))return this.D(S,N)}C(n,h){const N=this.L(n),S=this.m.getElementTop(N),O=h;return this.m.scrollTop===S-O}D(n,h){const N=this.s.getHeight(n),{startIndex:S,endIndex:O}=this.M(n),V=this.G(O,h,N);return{node:n,position:V,height:N,startIndex:S,endIndex:O}}F(n,h=void 0){let N=n,S=this.I(N);for(;S;){if(S===h)return N;N=S,S=this.I(N)}if(h===void 0)return N}G(n,h,N){let S=this.m.getRelativeTop(n);if(S===null&&this.m.firstVisibleIndex===n&&n+1<this.m.length){const $e=this.s.getHeight(this.m.element(n)),ve=this.m.getRelativeTop(n+1);S=ve?ve-$e/this.m.renderHeight:null}if(S===null)return h;const O=this.m.element(n),V=this.s.getHeight(O),ee=S*this.m.renderHeight+V;return h+N>ee&&h<=ee?ee-N:h}H(n){if(n.length===0)return[];const h=this.m.renderHeight*this.c,N=n[n.length-1];if(n.length<=this.b&&N.position+N.height<=h)return n;const S=this.a.constrainStickyScrollNodes(n,this.b,h);if(!S.length)return[];const O=S[S.length-1];if(S.length>this.b||O.position+O.height>h)throw new Error("stickyScrollDelegate violates constraints");return S}I(n){const h=this.j.getNodeLocation(n),N=this.j.getParentNodeLocation(h);return N?this.j.getNode(N):void 0}J(n){const h=this.j.getNodeLocation(n);return this.j.getListRenderCount(h)>1}L(n){const h=this.j.getNodeLocation(n);return this.j.getListIndex(h)}M(n){const h=this.j.getNodeLocation(n),N=this.j.getListIndex(h);if(N<0)throw new Error("Node not found in tree");const S=this.j.getListRenderCount(h),O=N+S-1;return{startIndex:N,endIndex:O}}nodePositionTopBelowWidget(n){const h=[];let N=this.I(n);for(;N;)h.push(N),N=this.I(N);let S=0;for(let O=0;O<h.length&&O<this.b;O++)S+=this.s.getHeight(h[O]);return S}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(n={}){if(!n.stickyScrollMaxItemCount)return;const h=this.validateStickySettings(n);this.b!==h.stickyScrollMaxItemCount&&(this.b=h.stickyScrollMaxItemCount,this.u())}validateStickySettings(n){let h=7;return typeof n.stickyScrollMaxItemCount=="number"&&(h=Math.max(n.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:h}}}class G{constructor(n,h,N,S,O,V){this.g=h,this.j=N,this.k=S,this.m=O,this.o=V,this.c=[],this.d=new g.$Sc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),n.appendChild(this.a);const Z=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(Z),this.f=new ie(this.a,h),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const n=this.b.stickyNodes[this.b.count-1];return n.position+n.height}get count(){return this.b?.count??0}getNode(n){return this.b?.stickyNodes.find(h=>h.node===n)}setState(n){const h=!!this.b&&this.b.count>0,N=!!n&&n.count>0;if(!h&&!N||h&&N&&this.b.equal(n))return;if(h!==N&&this.s(N),!N){this.b=void 0,this.c=[],this.d.clear();return}const S=n.stickyNodes[n.count-1];if(this.b&&n.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${S.position}px`;else{this.d.clear();const O=Array(n.count);for(let V=n.count-1;V>=0;V--){const Z=n.stickyNodes[V],{element:ee,disposable:$e}=this.p(Z,V,n.count);O[V]=ee,this.a.appendChild(ee),this.d.add($e)}this.f.updateElements(O,n),this.c=O}this.b=n,this.a.style.height=`${S.position+S.height}px`}p(n,h,N){const S=n.startIndex,O=document.createElement("div");O.style.top=`${n.position}px`,O.style.height=`${n.height}px`,O.style.lineHeight=`${n.height}px`,O.classList.add("monaco-tree-sticky-row"),O.classList.add("monaco-list-row"),O.setAttribute("data-index",`${S}`),O.setAttribute("data-parity",S%2===0?"even":"odd"),O.setAttribute("id",this.g.getElementID(S)),this.q(O,n.node.element,h,N);const V=this.m.getTemplateId(n.node),Z=this.k.find(we=>we.templateId===V);if(!Z)throw new Error(`No renderer found for template id ${V}`);let ee=n.node;ee===this.j.getNode(this.j.getNodeLocation(n.node))&&(ee=new Proxy(n.node,{}));const $e=Z.renderTemplate(O);Z.renderElement(ee,n.startIndex,$e,n.height);const ve=(0,g.$Rc)(()=>{Z.disposeElement(ee,n.startIndex,$e,n.height),Z.disposeTemplate($e),O.remove()});return{element:O,disposable:ve}}q(n,h,N,S){if(!this.o)return;this.o.getSetSize&&n.setAttribute("aria-setsize",String(this.o.getSetSize(h,N,S))),this.o.getPosInSet&&n.setAttribute("aria-posinset",String(this.o.getPosInSet(h,N))),this.o.getRole&&n.setAttribute("role",this.o.getRole(h)??"treeitem");const O=this.o.getAriaLabel(h);O&&n.setAttribute("aria-label",O);const V=this.o.getAriaLevel&&this.o.getAriaLevel(h);typeof V=="number"&&n.setAttribute("aria-level",`${V}`),n.setAttribute("aria-selected",String(!1))}s(n){this.a.classList.toggle("empty",!n),n||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ie extends g.$Tc{get m(){return this.j}set m(n){n!==this.j&&(this.f.fire(n),this.j=n)}constructor(n,h){super(),this.s=n,this.t=h,this.a=-1,this.b=[],this.f=new v.$6d,this.onDidChangeHasFocus=this.f.event,this.g=new v.$6d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(N=>this.w(N))),this.B(this.t.onMouseDown(N=>this.y(N))),this.B(this.t.onContextMenu(N=>this.u(N)))}u(n){const h=n.browserEvent.target;if(!(0,$.$qT)(h)&&!(0,$.$pT)(h)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$RR)(n.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const V=this.c.stickyNodes.findIndex(Z=>Z.node.element===n.element?.element);if(V===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(V);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const S=this.c.stickyNodes[this.a].node.element,O=this.b[this.a];this.g.fire({element:S,anchor:O,browserEvent:n.browserEvent,isStickyScroll:!0})}w(n){if(this.m&&this.c){if(n.key==="ArrowUp")this.z(Math.max(0,this.a-1)),n.preventDefault(),n.stopPropagation();else if(n.key==="ArrowDown"||n.key==="ArrowRight"){if(this.a>=this.c.count-1){const h=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([h]),this.C(h,this.c)}else this.z(this.a+1);n.preventDefault(),n.stopPropagation()}}}y(n){const h=n.browserEvent.target;!(0,$.$qT)(h)&&!(0,$.$pT)(h)||(n.browserEvent.preventDefault(),n.browserEvent.stopPropagation())}updateElements(n,h){if(h&&h.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(h&&h.count!==n.length)throw new Error("Sticky scroll focus received illigel state");const N=this.a;if(this.D(),this.b=n,this.c=h,h){const S=(0,r.$lm)(N,0,h.count-1);this.F(S)}else this.m&&this.t.domFocus();this.s.tabIndex=h?0:-1}z(n){const h=this.c;if(!h)throw new Error("Cannot set focus when state is undefined");if(this.F(n),!(n<h.count-1)&&h.lastNodePartiallyVisible()){const N=h.stickyNodes[n];this.C(N.endIndex+1,h)}}C(n,h){const N=h.stickyNodes[h.count-1],S=h.count>1?h.stickyNodes[h.count-2]:void 0,O=this.t.getElementTop(n),V=S?S.position+S.height+N.height:N.height;this.t.scrollTop=O-V}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(n){if(0>n)throw new Error("addFocus() can not remove focus");if(!this.c&&n>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&n>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const h=this.a;h>=0&&this.G(this.b[h],!1),n>=0&&this.G(this.b[n],!0),this.a=n}G(n,h){n.classList.toggle("focused",h)}H(n){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",n)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ce(u){let n=c.TreeMouseEventTarget.Unknown;return(0,i.$xR)(u.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=c.TreeMouseEventTarget.Twistie:(0,i.$xR)(u.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=c.TreeMouseEventTarget.Element:(0,i.$xR)(u.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=c.TreeMouseEventTarget.Filter),{browserEvent:u.browserEvent,element:u.element?u.element.element:null,target:n}}function Ae(u){const n=(0,$.$qT)(u.browserEvent.target);return{element:u.element?u.element.element:null,browserEvent:u.browserEvent,anchor:u.anchor,isStickyScroll:n}}function Fe(u,n){n(u),u.children.forEach(h=>Fe(h,n))}class ye{get f(){return this.d||(this.d=this.m()),this.d}constructor(n,h){this.g=n,this.j=h,this.a=[],this.c=new v.$6d,this.onDidChange=this.c.event}set(n,h){!h?.__forceEvent&&(0,e.$ub)(this.a,n)||this.k(n,!1,h)}k(n,h,N){if(this.a=[...n],this.b=void 0,this.d=void 0,!h){const S=this;this.c.fire({get elements(){return S.get()},browserEvent:N})}}get(){return this.b||(this.b=this.a.map(n=>n.element)),[...this.b]}getNodes(){return this.a}has(n){return this.f.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:h}){if(!this.j){const ee=this.m(),$e=ve=>ee.delete(ve);h.forEach(ve=>Fe(ve,$e)),this.set([...ee.values()]);return}const N=new Set,S=ee=>N.add(this.j.getId(ee.element).toString());h.forEach(ee=>Fe(ee,S));const O=new Map,V=ee=>O.set(this.j.getId(ee.element).toString(),ee);n.forEach(ee=>Fe(ee,V));const Z=[];for(const ee of this.a){const $e=this.j.getId(ee.element).toString();if(!N.has($e))Z.push(ee);else{const we=O.get($e);we&&we.visible&&Z.push(we)}}if(this.a.length>0&&Z.length===0){const ee=this.g();ee&&Z.push(ee)}this.k(Z,!0)}m(){const n=new Set;for(const h of this.a)n.add(h);return n}}class K extends $.$vT{constructor(n,h,N){super(n),this.x=h,this.y=N}u(n){if((0,$.$rT)(n.browserEvent.target)||(0,$.$kT)(n.browserEvent.target)||(0,$.$lT)(n.browserEvent.target)||n.browserEvent.isHandledByList)return;const h=n.element;if(!h)return super.u(n);if(this.p(n)||this.o(n))return super.u(n);const N=n.browserEvent.target,S=N.classList.contains("monaco-tl-twistie")||N.classList.contains("monaco-icon-label")&&N.classList.contains("folder-icon")&&n.browserEvent.offsetX<16,O=(0,$.$pT)(n.browserEvent.target);let V=!1;if(O?V=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?V=this.x.expandOnlyOnTwistieClick(h.element):V=!!this.x.expandOnlyOnTwistieClick,O)this.A(n,h);else{if(V&&!S&&n.browserEvent.detail!==2)return super.u(n);if(!this.x.expandOnDoubleClick&&n.browserEvent.detail===2)return super.u(n)}if(h.collapsible&&(!O||S)){const Z=this.x.getNodeLocation(h),ee=n.browserEvent.altKey;if(this.x.setFocus([Z]),this.x.toggleCollapsed(Z,ee),V&&S){n.browserEvent.isHandledByList=!0;return}}O||super.u(n)}A(n,h){if((0,$.$mT)(n.browserEvent.target)||(0,$.$nT)(n.browserEvent.target))return;const N=this.y();if(!N)throw new Error("Sticky scroll controller not found");const S=this.k.indexOf(h),O=this.k.getElementTop(S),V=N.nodePositionTopBelowWidget(h);this.x.scrollTop=O-V,this.k.domFocus(),this.k.setFocus([S]),this.k.setSelection([S])}v(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||n.browserEvent.isHandledByList||super.v(n)}s(n){const h=n.browserEvent.target;if(!(0,$.$qT)(h)&&!(0,$.$pT)(h)){super.s(n);return}}t(n){const h=n.browserEvent.target;if(!(0,$.$qT)(h)&&!(0,$.$pT)(h)){super.t(n);return}}}class f extends $.$yT{constructor(n,h,N,S,O,V,Z,ee){super(n,h,N,S,ee),this.p=O,this.s=V,this.K=Z}D(n){return new K(this,n.tree,n.stickyScrollProvider)}splice(n,h,N=[]){if(super.splice(n,h,N),N.length===0)return;const S=[],O=[];let V;N.forEach((Z,ee)=>{this.p.has(Z)&&S.push(n+ee),this.s.has(Z)&&O.push(n+ee),this.K.has(Z)&&(V=n+ee)}),S.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...S])),O.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...O])),typeof V=="number"&&super.setAnchor(V)}setFocus(n,h,N=!1){super.setFocus(n,h),N||this.p.set(n.map(S=>this.element(S)),h)}setSelection(n,h,N=!1){super.setSelection(n,h),N||this.s.set(n.map(S=>this.element(S)),h)}setAnchor(n,h=!1){super.setAnchor(n),h||(typeof n>"u"?this.K.set([]):this.K.set([this.element(n)]))}}var k;(function(u){u[u.Tree=0]="Tree",u[u.StickyScroll=1]="StickyScroll"})(k||(t.AbstractTreePart=k={}));class F{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,ce)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,ce),n=>n.target!==c.TreeMouseEventTarget.Filter)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.j.onContextMenu,Ae),n=>!n.isStickyScroll),this.B?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.j.onTap,ce)}get onPointer(){return v.Event.map(this.j.onPointer,ce)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ge.Highlight}set findMode(n){this.z&&(this.z.mode=n)}get findMatchType(){return this.z?.matchType??Ne.Fuzzy}set findMatchType(n){this.z&&(this.z.matchType=n)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(n,h,N,S,O={}){this.G=n,this.H=O,this.y=new v.$be,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.D=new g.$Sc,this.E=new v.$6d,this.onWillRefilter=this.E.event,this.F=new v.$6d,this.onDidUpdateOptions=this.F.event,this.p=new W(N);const V=new v.$ce,Z=new v.$ce,ee=this.D.add(new I(Z.event)),$e=new p.$Gc;this.k=S.map(Ee=>new X(Ee,()=>this.o,V.event,ee,$e,O));for(const Ee of this.k)this.D.add(Ee);let ve;O.keyboardNavigationLabelProvider&&(ve=new U(this,O.keyboardNavigationLabelProvider,O.filter),O={...O,filter:ve},this.D.add(ve)),this.q=new ye(()=>this.j.getFocusedElements()[0],O.identityProvider),this.w=new ye(()=>this.j.getSelectedElements()[0],O.identityProvider),this.x=new ye(()=>this.j.getAnchorElement(),O.identityProvider),this.j=new f(n,h,this.p,this.k,this.q,this.w,this.x,{...x(()=>this.o,O),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(n,this.j,O),V.input=this.o.onDidChangeCollapseState;const we=v.Event.forEach(this.o.onDidSplice,Ee=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ee),this.w.onDidModelSplice(Ee)})},this.D);we(()=>null,null,this.D);const je=this.D.add(new v.$6d),Se=this.D.add(new s.$dh(0));if(this.D.add(v.Event.any(we,this.q.onDidChange,this.w.onDidChange)(()=>{Se.trigger(()=>{const Ee=new Set;for(const Re of this.q.getNodes())Ee.add(Re);for(const Re of this.w.getNodes())Ee.add(Re);je.fire([...Ee.values()])})})),Z.input=je.event,O.keyboardSupport!==!1){const Ee=v.Event.chain(this.j.onKeyDown,Re=>Re.filter(Le=>!(0,$.$kT)(Le.target)).map(Le=>new z.$YQ(Le)));v.Event.chain(Ee,Re=>Re.filter(Le=>Le.keyCode===15))(this.J,this,this.D),v.Event.chain(Ee,Re=>Re.filter(Le=>Le.keyCode===17))(this.K,this,this.D),v.Event.chain(Ee,Re=>Re.filter(Le=>Le.keyCode===10))(this.L,this,this.D)}if((O.findWidgetEnabled??!0)&&O.keyboardNavigationLabelProvider&&O.contextViewProvider){const Ee=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Pe(this,this.o,this.j,ve,O.contextViewProvider,Ee),this.A=Re=>this.z.shouldAllowFocus(Re),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;O.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,O),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$JR)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===L.Always)}updateOptions(n={}){this.H={...this.H,...n};for(const h of this.k)h.updateOptions(n);this.j.updateOptions(this.H),this.z?.updateOptions(n),this.I(n),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===L.Always)}get options(){return this.H}I(n){!this.B&&this.H.enableStickyScroll?(this.B=new J(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(n)}updateWidth(n){const h=this.o.getListIndex(n);h!==-1&&this.j.updateWidth(h)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(n){this.j.scrollTop=n}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(n){this.j.scrollLeft=n}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let n=this.j.firstVisibleIndex;return this.B&&(n+=this.B.count),n<0||n>=this.j.length?void 0:this.j.element(n).element}get lastVisibleElement(){const n=this.j.lastVisibleIndex;return this.j.element(n).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(n){this.j.ariaLabel=n}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$CR)(this.getHTMLElement())}layout(n,h){this.j.layout(n,h),(0,E.$Xf)(h)&&this.z?.layout(h)}style(n){const h=`.${this.j.domId}`,N=[];n.treeIndentGuidesStroke&&(N.push(`.monaco-list${h}:hover .monaco-tl-indent > .indent-guide, .monaco-list${h}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeInactiveIndentGuidesStroke}; }`),N.push(`.monaco-list${h} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`)),n.listBackground&&(N.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${n.listBackground}; }`),N.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${n.listBackground}; }`)),n.listFocusForeground&&(N.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),N.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const S=(0,i.$hS)(n.listFocusAndSelectionOutline,(0,i.$hS)(n.listSelectionOutline,n.listFocusOutline??""));S&&(N.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${S}; outline-offset: -1px;}`),N.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),n.listFocusOutline&&(N.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),N.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),N.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),N.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=N.join(`
`),this.j.style(n)}getParentElement(n){const h=this.o.getParentNodeLocation(n);return this.o.getNode(h).element}getFirstElementChild(n){return this.o.getFirstElementChild(n)}getNode(n){return this.o.getNode(n)}getNodeLocation(n){return this.o.getNodeLocation(n)}collapse(n,h=!1){return this.o.setCollapsed(n,!0,h)}expand(n,h=!1){return this.o.setCollapsed(n,!1,h)}toggleCollapsed(n,h=!1){return this.o.setCollapsed(n,void 0,h)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(n){return this.o.isCollapsible(n)}setCollapsible(n,h){return this.o.setCollapsible(n,h)}isCollapsed(n){return this.o.isCollapsed(n)}expandTo(n){this.o.expandTo(n)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(n){if(typeof n>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const h=this.o.getNode(n);this.x.set([h]);const N=this.o.getListIndex(n);N>-1&&this.j.setAnchor(N,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(n,h){this.y.bufferEvents(()=>{const N=n.map(O=>this.o.getNode(O));this.w.set(N,h);const S=n.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setSelection(S,h,!0)})}getSelection(){return this.w.get()}setFocus(n,h){this.y.bufferEvents(()=>{const N=n.map(O=>this.o.getNode(O));this.q.set(N,h);const S=n.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setFocus(S,h,!0)})}focusNext(n=1,h=!1,N,S=(0,i.$RR)(N)&&N.altKey?void 0:this.A){this.j.focusNext(n,h,N,S)}focusPrevious(n=1,h=!1,N,S=(0,i.$RR)(N)&&N.altKey?void 0:this.A){this.j.focusPrevious(n,h,N,S)}focusNextPage(n,h=(0,i.$RR)(n)&&n.altKey?void 0:this.A){return this.j.focusNextPage(n,h)}focusPreviousPage(n,h=(0,i.$RR)(n)&&n.altKey?void 0:this.A){return this.j.focusPreviousPage(n,h,()=>this.B?.height??0)}focusLast(n,h=(0,i.$RR)(n)&&n.altKey?void 0:this.A){this.j.focusLast(n,h)}focusFirst(n,h=(0,i.$RR)(n)&&n.altKey?void 0:this.A){this.j.focusFirst(n,h)}getFocus(){return this.q.get()}getStickyScrollFocus(){const n=this.B?.getFocus();return n!==void 0?[n]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(n,h){this.o.expandTo(n);const N=this.o.getListIndex(n);if(N!==-1)if(!this.B)this.j.reveal(N,h);else{const S=this.B.nodePositionTopBelowWidget(this.getNode(n));this.j.reveal(N,h,S)}}getRelativeTop(n){const h=this.o.getListIndex(n);if(h===-1)return null;const N=this.B?.getNode(this.getNode(n));return this.j.getRelativeTop(h,N?.position??this.B?.height)}getViewState(n=this.options.identityProvider){if(!n)throw new c.$aV(this.G,"Can't get tree view state without an identity provider");const h=V=>n.getId(V).toString(),N=T.empty(this.scrollTop);for(const V of this.getFocus())N.focus.add(h(V));for(const V of this.getSelection())N.selection.add(h(V));const S=this.o.getNode(),O=[S];for(;O.length>0;){const V=O.shift();V!==S&&V.collapsible&&(N.expanded[h(V.element)]=V.collapsed?0:1),O.push(...V.children)}return N}J(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const N=h[0],S=this.o.getNodeLocation(N);if(!this.o.setCollapsed(S,!0)){const V=this.o.getParentNodeLocation(S);if(!V)return;const Z=this.o.getListIndex(V);this.j.reveal(Z),this.j.setFocus([Z])}}K(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const N=h[0],S=this.o.getNodeLocation(N);if(!this.o.setCollapsed(S,!1)){if(!N.children.some(ee=>ee.visible))return;const[V]=this.j.getFocus(),Z=V+1;this.j.reveal(Z),this.j.setFocus([Z])}}L(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const N=h[0],S=this.o.getNodeLocation(N),O=n.browserEvent.altKey;this.o.setCollapsed(S,void 0,O)}navigate(n){return new l(this.j,this.o,n)}dispose(){(0,g.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$kV=F;class l{constructor(n,h,N){this.b=n,this.c=h,N?this.a=this.c.getListIndex(N):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[136],be([1,0,135,127,27,29]),function(re,t,i,C,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vV=void 0;class A extends i.$kV{constructor(b,$,w,P,c,d={}){super(b,$,w,P,d),this.f=b,this.g=c,this.d=new Map,this.c=d.identityProvider}getInput(){return this.b}setInput(b,$){if($&&!this.c)throw new z.$aV(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!$){this.m(b);return}const w=[],P=[],c=e=>{const s=this.c.getId(e).toString();return!$.expanded[s]},d=e=>{const s=this.c.getId(e.element).toString();$.focus.has(s)&&w.push(e.element),$.selection.has(s)&&P.push(e.element)};this.m(b,c,d),this.setFocus(w),this.setSelection(P),$&&typeof $.scrollTop=="number"&&(this.scrollTop=$.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new z.$aV(this.f,"Tree input not set");let $;this.c&&($=w=>{const P=this.c.getId(w).toString(),c=this.d.get(P);if(c)return c.collapsed}),this.m(b,$)}resort(b=this.b,$=!0){this.o.resort(b===this.b?null:b,$)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,$,w){let P;if(this.c){const c=new Set,d=w;w=e=>{const s=this.c.getId(e.element).toString();c.add(s),this.d.set(s,e),d?.(e)},P=e=>{const s=this.c.getId(e.element).toString();c.has(s)||this.d.delete(s)}}this.o.setChildren(b===this.b?null:b,this.s(b,$).elements,{onDidCreateNode:w,onDidDeleteNode:P})}s(b,$){const w=[...this.g.getChildren(b)];return{elements:H.Iterable.map(w,c=>{const{elements:d,size:e}=this.s(c,$),s=this.g.hasChildren?this.g.hasChildren(c):void 0,a=e===0?void 0:$&&$(c);return{element:c,children:d,collapsible:s,collapsed:a}}),size:w.length}}M(b,$,w){return new C.$lV(b,$,w)}}t.$vV=A}),define(me[70],be([1,0,12,9,36,30,28,6,4,3,56,10,7]),function(re,t,i,C,z,H,A,y,b,$,w,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2h=t.ProxyChannel=t.$1h=t.$Xh=t.$Wh=t.$Vh=t.RequestInitiator=t.$Uh=t.$Rh=t.$Qh=void 0,t.$Sh=B,t.$Th=D,t.$Yh=X,t.$Zh=U;var d;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(d||(d={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function a(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(m||(m={}));function p(le){let _=0;for(let ae=0;;ae+=7){const oe=le.read(1);if(_|=(oe.buffer[0]&127)<<ae,!(oe.buffer[0]&128))return _}}const v=R(0);function o(le,_){if(_===0){le.write(v);return}let ae=0;for(let J=_;J!==0;J=J>>>7)ae++;const oe=z.$te.alloc(ae);for(let J=0;_!==0;J++)oe.buffer[J]=_&127,_=_>>>7,_>0&&(oe.buffer[J]|=128);le.write(oe)}class g{constructor(_){this.b=_,this.a=0}read(_){const ae=this.b.slice(this.a,this.a+_);return this.a+=ae.byteLength,ae}}t.$Qh=g;class r{constructor(){this.a=[]}get buffer(){return z.$te.concat(this.a)}write(_){this.a.push(_)}}t.$Rh=r;var E;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(E||(E={}));function R(le){const _=z.$te.alloc(1);return _.writeUInt8(le,0),_}const M={Undefined:R(E.Undefined),String:R(E.String),Buffer:R(E.Buffer),VSBuffer:R(E.VSBuffer),Array:R(E.Array),Object:R(E.Object),Uint:R(E.Int)},j=typeof Buffer<"u";function B(le,_){if(typeof _>"u")le.write(M.Undefined);else if(typeof _=="string"){const ae=z.$te.fromString(_);le.write(M.String),o(le,ae.byteLength),le.write(ae)}else if(j&&Buffer.isBuffer(_)){const ae=z.$te.wrap(_);le.write(M.Buffer),o(le,ae.byteLength),le.write(ae)}else if(_ instanceof z.$te)le.write(M.VSBuffer),o(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(M.Array),o(le,_.length);for(const ae of _)B(le,ae)}else if(typeof _=="number"&&(_|0)===_)le.write(M.Uint),o(le,_);else{const ae=z.$te.fromString(JSON.stringify(_));le.write(M.Object),o(le,ae.byteLength),le.write(ae)}}function D(le){switch(le.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return le.read(p(le)).toString();case E.Buffer:return le.read(p(le)).buffer;case E.VSBuffer:return le.read(p(le));case E.Array:{const ae=p(le),oe=[];for(let J=0;J<ae;J++)oe.push(D(le));return oe}case E.Object:return JSON.parse(le.read(p(le)).toString());case E.Int:return p(le)}}class x{constructor(_,ae,oe=null,J=1e3){this.h=_,this.j=ae,this.k=oe,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(_,ae){this.b.set(_,ae),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ae=this.o([_.type]);this.k?.logOutgoing(ae,0,1,a(_.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ae,_.id,1,a(_.type),_.data);return}}}o(_,ae=void 0){const oe=new r;return B(oe,_),B(oe,ae),this.p(oe.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ae=new g(_),oe=D(ae),J=D(ae),G=oe[0];switch(G){case 100:return this.k?.logIncoming(_.byteLength,oe[1],1,`${e(G)}: ${oe[2]}.${oe[3]}`,J),this.s({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:J});case 102:return this.k?.logIncoming(_.byteLength,oe[1],1,`${e(G)}: ${oe[2]}.${oe[3]}`,J),this.t({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:J});case 101:return this.k?.logIncoming(_.byteLength,oe[1],1,`${e(G)}`),this.u({type:G,id:oe[1]});case 103:return this.k?.logIncoming(_.byteLength,oe[1],1,`${e(G)}`),this.u({type:G,id:oe[1]})}}s(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const oe=new H.$de;let J;try{J=ae.call(this.j,_.name,_.arg,oe.token)}catch(ce){J=Promise.reject(ce)}const G=_.id;J.then(ce=>{this.m({id:G,data:ce,type:201})},ce=>{ce instanceof Error?this.m({id:G,data:{message:ce.message,name:ce.name,stack:ce.stack?ce.stack.split?ce.stack.split(`
`):ce.stack:void 0},type:202}):this.m({id:G,data:ce,type:203})}).finally(()=>{ie.dispose(),this.d.delete(_.id)});const ie=(0,$.$Rc)(()=>oe.cancel());this.d.set(_.id,ie)}t(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const oe=_.id,G=ae.listen(this.j,_.name,_.arg)(ie=>this.m({id:oe,data:ie,type:204}));this.d.set(_.id,G)}u(_){const ae=this.d.get(_.id);ae&&(ae.dispose(),this.d.delete(_.id))}v(_){let ae=this.g.get(_.channelName);ae||(ae=[],this.g.set(_.channelName,ae));const oe=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:_,timeoutTimer:oe})}w(_){const ae=this.g.get(_);if(ae){for(const oe of ae)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Oc)(this.d.values()),this.d.clear()}}t.$Uh=x;var W;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class T{constructor(_,ae=null){this.l=_,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ae}getChannel(_){const ae=this;return{call(oe,J,G){return ae.a?Promise.reject(new y.$5):ae.m(_,oe,J,G)},listen(oe,J){return ae.a?b.Event.None:ae.o(_,oe,J)}}}m(_,ae,oe,J=H.CancellationToken.None){const G=this.g++,ce={id:G,type:100,channelName:_,name:ae,arg:oe};if(J.isCancellationRequested)return Promise.reject(new y.$5);let Ae;return new Promise((ye,K)=>{if(J.isCancellationRequested)return K(new y.$5);const f=()=>{const u=n=>{switch(n.type){case 201:this.f.delete(G),ye(n.data);break;case 202:{this.f.delete(G);const h=new Error(n.data.message);h.stack=Array.isArray(n.data.stack)?n.data.stack.join(`
`):n.data.stack,h.name=n.data.name,K(h);break}case 203:this.f.delete(G),K(n.data);break}};this.f.set(G,u),this.p(ce)};let k=null;this.b===m.Idle?f():(k=(0,C.$6g)(u=>this.u()),k.then(()=>{k=null,f()}));const F=()=>{k?(k.cancel(),k=null):this.p({id:G,type:101}),K(new y.$5)},l=J.onCancellationRequested(F);Ae=(0,$.$Qc)((0,$.$Rc)(F),l),this.d.add(Ae)}).finally(()=>{Ae.dispose(),this.d.delete(Ae)})}o(_,ae,oe){const J=this.g++,ie={id:J,type:102,channelName:_,name:ae,arg:oe};let ce=null;const Ae=new b.$6d({onWillAddFirstListener:()=>{ce=(0,C.$6g)(ye=>this.u()),ce.then(()=>{ce=null,this.d.add(Ae),this.p(ie)})},onDidRemoveLastListener:()=>{ce?(ce.cancel(),ce=null):(this.d.delete(Ae),this.p({id:J,type:103}))}}),Fe=ye=>Ae.fire(ye.data);return this.f.set(J,Fe),Ae.event}p(_){switch(_.type){case 100:case 102:{const ae=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ae,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ae=this.q([_.type,_.id]);this.j?.logOutgoing(ae,_.id,0,e(_.type));return}}}q(_,ae=void 0){const oe=new r;return B(oe,_),B(oe,ae),this.r(oe.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ae=new g(_),oe=D(ae),J=D(ae),G=oe[0];switch(G){case 200:return this.j?.logIncoming(_.byteLength,0,0,a(G)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,oe[1],0,a(G),J),this.t({type:oe[0],id:oe[1],data:J})}}t(_){if(_.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Oc)(this.d.values()),this.d.clear()}}t.$Vh=T,Je([A.$Kh],T.prototype,"onDidInitializePromise",null);class L{get connections(){const _=[];return this.f.forEach(ae=>_.push(ae)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new b.$6d,this.onDidAddConnection=this.g.event,this.h=new b.$6d,this.onDidRemoveConnection=this.h.event,this.j=new $.$Sc,this.j.add(_(({protocol:ae,onDidClientDisconnect:oe})=>{const J=b.Event.once(ae.onMessage);this.j.add(J(G=>{const ie=new g(G),ce=D(ie),Ae=new x(ae,ce),Fe=new T(ae);this.a.forEach((K,f)=>Ae.registerChannel(f,K));const ye={channelServer:Ae,channelClient:Fe,ctx:ce};this.f.add(ye),this.g.fire(ye),this.j.add(oe(()=>{Ae.dispose(),Fe.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(_,ae){const oe=this;return{call(J,G,ie){let ce;if((0,c.$8f)(ae)){const Fe=(0,i.$4b)(oe.connections.filter(ae));ce=Fe?Promise.resolve(Fe):b.Event.toPromise(b.Event.filter(oe.onDidAddConnection,ae))}else ce=ae.routeCall(oe,J,G);const Ae=ce.then(Fe=>Fe.channelClient.getChannel(_));return X(Ae).call(J,G,ie)},listen(J,G){if((0,c.$8f)(ae))return oe.k(_,ae,J,G);const ie=ae.routeEvent(oe,J,G).then(ce=>ce.channelClient.getChannel(_));return X(ie).listen(J,G)}}}k(_,ae,oe,J){const G=this;let ie;const ce=new b.$6d({onWillAddFirstListener:()=>{ie=new $.$Sc;const Ae=new b.$_d,Fe=new Map,ye=f=>{const F=f.channelClient.getChannel(_).listen(oe,J),l=Ae.add(F);Fe.set(f,l)},K=f=>{const k=Fe.get(f);k&&(k.dispose(),Fe.delete(f))};G.connections.filter(ae).forEach(ye),b.Event.filter(G.onDidAddConnection,ae)(ye,void 0,ie),G.onDidRemoveConnection(K,void 0,ie),Ae.event(ce.fire,ce,ie),ie.add(Ae)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return ce.event}registerChannel(_,ae){this.a.set(_,ae);for(const oe of this.f)oe.channelServer.registerChannel(_,ae)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Wh=L;class I{constructor(_,ae,oe=null){const J=new r;B(J,ae),_.send(J.buffer),this.a=new T(_,oe),this.d=new x(_,ae,oe)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ae){this.d.registerChannel(_,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Xh=I;function X(le){return{call(_,ae,oe){return le.then(J=>J.call(_,ae,oe))},listen(_,ae){const oe=new b.$ce;return le.then(J=>oe.input=J.listen(_,ae)),oe.event}}}function U(le){let _=!1;return{call(ae,oe,J){return _?le.call(ae,oe,J):(0,C.$hh)(0).then(()=>_=!0).then(()=>le.call(ae,oe,J))},listen(ae,oe){if(_)return le.listen(ae,oe);const J=new b.$ce;return(0,C.$hh)(0).then(()=>_=!0).then(()=>J.input=le.listen(ae,oe)),J.event}}}class de{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ae of _.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await b.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$1h=de;var he;(function(le){function _(G,ie,ce){const Ae=G,Fe=ce&&ce.disableMarshalling,ye=new Map;for(const K in Ae)oe(K)&&ye.set(K,b.Event.buffer(Ae[K],!0,void 0,ie));return new class{listen(K,f,k){const F=ye.get(f);if(F)return F;const l=Ae[f];if(typeof l=="function"){if(J(f))return l.call(Ae,k);if(oe(f))return ye.set(f,b.Event.buffer(Ae[f],!0,void 0,ie)),ye.get(f)}throw new y.$bb(`Event not found: ${f}`)}call(K,f,k){const F=Ae[f];if(typeof F=="function"){if(!Fe&&Array.isArray(k))for(let u=0;u<k.length;u++)k[u]=(0,w.$Ph)(k[u]);let l=F.apply(Ae,k);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new y.$bb(`Method not found: ${f}`)}}}le.fromService=_;function ae(G,ie){const ce=ie&&ie.disableMarshalling;return new Proxy({},{get(Ae,Fe){if(typeof Fe=="string")return ie?.properties?.has(Fe)?ie.properties.get(Fe):J(Fe)?function(ye){return G.listen(Fe,ye)}:oe(Fe)?G.listen(Fe):async function(...ye){let K;ie&&!(0,c.$3f)(ie.context)?K=[ie.context,...ye]:K=ye;const f=await G.call(Fe,K);return ce?f:(0,w.$Ph)(f)};throw new y.$bb(`Property not found: ${String(Fe)}`)}})}le.toService=ae;function oe(G){return G[0]==="o"&&G[1]==="n"&&P.$jf(G.charCodeAt(2))}function J(G){return/^onDynamic/.test(G)&&P.$jf(G.charCodeAt(9))}})(he||(t.ProxyChannel=he={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function Ne(le){return Array.isArray(le)?le.map(ge):ge(le)}function Ce(le,_,ae,oe,J,G,ie){ie=Ne(ie);const ce=ne[J],Ae=ce[oe%ce.length];let Fe=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(G)?(Fe=Fe.concat(ie),Fe.push(")")):Fe.push(ie),console.log.apply(console,Fe)}class Pe{constructor(_,ae){this.d=_,this.f=ae,this.a=0,this.b=0}logOutgoing(_,ae,oe,J,G){this.b+=_,Ce(this.d,this.b,_,ae,oe,J,G)}logIncoming(_,ae,oe,J,G){this.a+=_,Ce(this.f,this.a,_,ae,oe,J,G)}}t.$2h=Pe}),define(me[137],be([1,0,36,4,70,94,31]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7V=void 0;class y extends z.$Xh{static f(){const $=C.Event.fromNodeEventEmitter(A.$O,"vscode:message",(w,P)=>i.$te.wrap(P));return A.$O.send("vscode:hello"),new H.$3V(A.$O,$)}constructor($){const w=y.f();super(w,$),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$7V=y}),define(me[138],be([13,11]),function(re,t){return re.create("vs/platform/files/common/files",t)}),define(me[139],be([13,11]),function(re,t){return re.create("vs/platform/theme/common/iconRegistry",t)}),define(me[44],be([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fi=t._util=void 0,t.$gi=z,t.$hi=H;var i;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function y(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=y})(i||(t._util=i={})),t.$fi=z("instantiationService");function C(A,y,b){y[i.DI_TARGET]===y?y[i.DI_DEPENDENCIES].push({id:A,index:b}):(y[i.DI_DEPENDENCIES]=[{id:A,index:b}],y[i.DI_TARGET]=y)}function z(A){if(i.serviceIds.has(A))return i.serviceIds.get(A);const y=function(b,$,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(y,b,w)};return y.toString=()=>A,i.serviceIds.set(A,y),y}function H(A){return A}}),define(me[140],be([1,0,44]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2m=t.$Zm=t.ID=void 0,t.$1m=C,t.ID="diagnosticsService",t.$Zm=(0,i.$gi)(t.ID);function C(H){return!!H.hostName&&!!H.errorMessage}class z{async getPerformanceInfo(A,y){return{}}async getSystemInfo(A,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,y){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$2m=z}),define(me[141],be([1,0,91,25,10,7,16,138,44,5,32,23]),function(re,t,i,C,z,H,A,y,b,$,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$il=t.$fl=t.FileKind=t.$el=t.$dl=t.$cl=t.$bl=t.$al=t.$_k=t.$$k=t.FileOperationResult=t.$0k=t.$9k=t.$8k=t.$6k=t.FileChangeType=t.$5k=t.FileOperation=t.$Yk=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Mk=void 0,t.$Nk=c,t.$Ok=s,t.$Pk=m,t.$Qk=p,t.$Rk=v,t.$Sk=o,t.$Tk=g,t.$Uk=r,t.$Vk=E,t.$Wk=R,t.$Xk=M,t.$Zk=D,t.$1k=x,t.$2k=W,t.$3k=T,t.$4k=L,t.$7k=he,t.$gl=le,t.$hl=_,t.$jl=oe,t.$Mk=(0,b.$gi)("fileService");function c(J){return J.create===!0}var d;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(d||(t.FileType=d={}));var e;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(J){const G=J;return!!G&&typeof G.onDidChange=="function"}var a;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(a||(t.FileSystemProviderCapabilities=a={}));function m(J){return!!(J.capabilities&2)}function p(J){return!!(J.capabilities&8)}function v(J){return!!(J.capabilities&131072)}function o(J){return!!(J.capabilities&4)}function g(J){return!!(J.capabilities&16)}function r(J){return m(J)?!!(J.capabilities&16384):!1}function E(J){return m(J)?!!(J.capabilities&32768):!1}function R(J){return!!(J.capabilities&65536)}function M(J){return!!(J.capabilities&2048)}var j;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(j||(t.FileSystemProviderErrorCode=j={}));class B extends Error{static create(G,ie){const ce=new B(G.toString(),ie);return W(ce,ie),ce}constructor(G,ie){super(G),this.code=ie}}t.$Yk=B;function D(J,G){return B.create(J,G)}function x(J){return J||D((0,y.localize)(0,null),j.Unknown)}function W(J,G){return J.name=G?`${G} (FileSystemError)`:"FileSystemError",J}function T(J){if(!J)return j.Unknown;if(J instanceof B)return J.code;const G=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!G)return j.Unknown;switch(G[1]){case j.FileExists:return j.FileExists;case j.FileIsADirectory:return j.FileIsADirectory;case j.FileNotADirectory:return j.FileNotADirectory;case j.FileNotFound:return j.FileNotFound;case j.FileTooLarge:return j.FileTooLarge;case j.FileWriteLocked:return j.FileWriteLocked;case j.NoPermissions:return j.NoPermissions;case j.Unavailable:return j.Unavailable}return j.Unknown}function L(J){if(J instanceof ne)return J.fileOperationResult;switch(T(J)){case j.FileNotFound:return 1;case j.FileIsADirectory:return 0;case j.FileNotADirectory:return 9;case j.FileWriteLocked:return 5;case j.NoPermissions:return 6;case j.FileExists:return 4;case j.FileTooLarge:return 7;default:return 10}}var I;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(I||(t.FileOperation=I={}));class X{constructor(G,ie,ce){this.resource=G,this.operation=ie,this.target=ce}isOperation(G){return this.operation===G}}t.$5k=X;var U;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(U||(t.FileChangeType=U={}));class de{static{this.a=null}constructor(G,ie){this.c=ie,this.b=void 0,this.d=new P.$V(()=>{const ce=i.$mi.forUris(()=>this.c);return ce.fill(this.rawAdded.map(Ae=>[Ae,!0])),ce}),this.f=new P.$V(()=>{const ce=i.$mi.forUris(()=>this.c);return ce.fill(this.rawUpdated.map(Ae=>[Ae,!0])),ce}),this.g=new P.$V(()=>{const ce=i.$mi.forUris(()=>this.c);return ce.fill(this.rawDeleted.map(Ae=>[Ae,!0])),ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ce of G){switch(ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}this.b!==de.a&&(typeof ce.cId=="number"?this.b===void 0?this.b=ce.cId:this.b!==ce.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(G,...ie){return this.h(G,{includeChildren:!1},...ie)}affects(G,...ie){return this.h(G,{includeChildren:!0},...ie)}h(G,ie,...ce){if(!G)return!1;const Ae=ce.length>0;return!!((!Ae||ce.includes(1))&&(this.d.value.get(G)||ie.includeChildren&&this.d.value.findSuperstr(G))||(!Ae||ce.includes(0))&&(this.f.value.get(G)||ie.includeChildren&&this.f.value.findSuperstr(G))||(!Ae||ce.includes(2))&&(this.g.value.findSubstr(G)||ie.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$6k=de;function he(J,G,ie){return!J||!G||J===G||G.length>J.length?!1:(G.charAt(G.length-1)!==C.sep&&(G+=C.sep),ie?(0,z.$lf)(J,G):J.indexOf(G)===0)}class ne extends Error{constructor(G,ie,ce){super(G),this.fileOperationResult=ie,this.options=ce}}t.$8k=ne;class ge extends ne{constructor(G,ie,ce,Ae){super(G,ie,Ae),this.fileOperationResult=ie,this.size=ce}}t.$9k=ge;class Ne extends ne{constructor(G,ie,ce){super(G,2,ce),this.stat=ie}}t.$0k=Ne;var Ce;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ce||(t.FileOperationResult=Ce={})),t.$$k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$_k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$al="files.associations",t.$bl="files.exclude",t.$cl="files.readonlyInclude",t.$dl="files.readonlyExclude",t.$el="files.readonlyFromPermissions";var Pe;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$fl="";function le(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}async function _(J,G){if(!G.hasProvider(A.URI.from({scheme:J.scheme})))return new Promise(ie=>{const ce=G.onDidChangeFileSystemProviderRegistrations(Ae=>{Ae.scheme===J.scheme&&Ae.added&&(ce.dispose(),ie())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(G){return(0,H.$Xf)(G)||(G=0),G<ae.KB?(0,y.localize)(1,null,G.toFixed(0)):G<ae.MB?(0,y.localize)(2,null,(G/ae.KB).toFixed(2)):G<ae.GB?(0,y.localize)(3,null,(G/ae.MB).toFixed(2)):G<ae.TB?(0,y.localize)(4,null,(G/ae.GB).toFixed(2)):(0,y.localize)(5,null,(G/ae.TB).toFixed(2))}}t.$il=ae;function oe(J){const G=typeof J=="string"||J?.scheme===w.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===w.Schemas.file?1024*ae.MB:G?10*ae.MB:$.$o?50*ae.MB:1024*ae.MB}}),define(me[142],be([1,0,44]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mbc=t.$lbc=void 0,t.$lbc=(0,i.$gi)("mainProcessService");class C{constructor(H,A){this.a=H,this.b=A}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,A){this.a.registerChannel(H,A)}}t.$mbc=C}),define(me[143],be([1,0,3,137]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nbc=void 0;class z extends i.$Tc{constructor(A){super(),this.a=this.B(new C.$7V(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,y){this.a.registerChannel(A,y)}}t.$nbc=z});var yi=this&&this.__param||function(re,t){return function(i,C){t(i,C,re)}};define(me[144],be([1,0,70,142]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rbc=void 0;let z=class{constructor(A,y){return this.windowId=A,i.ProxyChannel.toService(y.getChannel("nativeHost"),{context:A,properties:(()=>{const b=new Map;return b.set("windowId",A),b})()})}};t.$rbc=z,t.$rbc=z=Je([yi(1,C.$lbc)],z)}),define(me[71],be([1,0,79,7]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yn=void 0;class z{constructor(){this.a=new Map}add(A,y){i.ok(C.$Tf(A)),i.ok(C.$Vf(y)),i.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,y)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$Yn=new z}),define(me[145],be([1,0,4,71]),function(re,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zn=void 0,t.$Zn={JSONContribution:"base.contributions.json"};function z(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class H{constructor(){this.b=new i.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[z(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const A=new H;C.$Yn.add(t.$Zn.JSONContribution,A)}),define(me[146],be([1,0,9,18,38,19,4,7,16,139,145,71]),function(re,t,i,C,z,H,A,y,b,$,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xw=t.$Ww=t.$Vw=t.$Uw=t.$Tw=t.$Sw=t.IconFontDefinition=t.IconContribution=t.$Pw=void 0,t.$Qw=a,t.$Rw=m,t.$Pw={IconContribution:"base.contributions.icons"};var c;(function(g){function r(E,R){let M=E.defaults;for(;H.ThemeIcon.isThemeIcon(M);){const j=s.getIcon(M.id);if(!j)return;M=j.defaults}return M}g.getDefinition=r})(c||(t.IconContribution=c={}));var d;(function(g){function r(R){return{weight:R.weight,style:R.style,src:R.src.map(M=>({format:M.format,location:M.location.toString()}))}}g.toJSONObject=r;function E(R){const M=j=>(0,y.$Tf)(j)?j:void 0;if(R&&Array.isArray(R.src)&&R.src.every(j=>(0,y.$Tf)(j.format)&&(0,y.$Tf)(j.location)))return{weight:M(R.weight),style:M(R.style),src:R.src.map(j=>({format:j.format,location:b.URI.parse(j.location)}))}}g.fromJSONObject=E})(d||(t.IconFontDefinition=d={}));class e{constructor(){this.a=new A.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${H.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,E,R,M){const j=this.b[r];if(j){if(R&&!j.description){j.description=R,this.d.properties[r].markdownDescription=`${R} $(${r})`;const x=this.e.enum.indexOf(r);x!==-1&&(this.e.enumDescriptions[x]=R),this.a.fire()}return j}const B={id:r,description:R,defaults:E,deprecationMessage:M};this.b[r]=B;const D={$ref:"#/definitions/icons"};return M&&(D.deprecationMessage=M),R&&(D.markdownDescription=`${R}: $(${r})`),this.d.properties[r]=D,this.e.enum.push(r),this.e.enumDescriptions.push(R||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const E=this.e.enum.indexOf(r);E!==-1&&(this.e.enum.splice(E,1),this.e.enumDescriptions.splice(E,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,E){const R=this.f[r];return R||(this.f[r]=E,this.a.fire(),E)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(j,B)=>j.id.localeCompare(B.id),E=j=>{for(;H.ThemeIcon.isThemeIcon(j.defaults);)j=this.b[j.defaults.id];return`codicon codicon-${j?j.id:""}`},R=[];R.push("| preview     | identifier                        | default codicon ID                | description"),R.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const M=Object.keys(this.b).map(j=>this.b[j]);for(const j of M.filter(B=>!!B.description).sort(r))R.push(`|<i class="${E(j)}"></i>|${j.id}|${H.ThemeIcon.isThemeIcon(j.defaults)?j.defaults.id:j.id}|${j.description||""}|`);R.push("| preview     | identifier                        "),R.push("| ----------- | --------------------------------- |");for(const j of M.filter(B=>!H.ThemeIcon.isThemeIcon(B.defaults)).sort(r))R.push(`|<i class="${E(j)}"></i>|${j.id}|`);return R.join(`
`)}}const s=new e;P.$Yn.add(t.$Pw.IconContribution,s);function a(g,r,E,R){return s.registerIcon(g,r,E,R)}function m(){return s}function p(){const g=(0,z.$Bj)();for(const r in g){const E="\\"+g[r].toString(16);s.registerIcon(r,{fontCharacter:E})}}p(),t.$Sw="vscode://schemas/icons";const v=P.$Yn.as(w.$Zn.JSONContribution);v.registerSchema(t.$Sw,s.getIconSchema());const o=new i.$sh(()=>v.notifySchemaChanged(t.$Sw),200);s.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.$Tw=a("widget-close",C.$Fj.close,(0,$.localize)(2,null)),t.$Uw=a("goto-previous-location",C.$Fj.arrowUp,(0,$.localize)(3,null)),t.$Vw=a("goto-next-location",C.$Fj.arrowDown,(0,$.localize)(4,null)),t.$Ww=H.ThemeIcon.modify(C.$Fj.sync,"spin"),t.$Xw=H.ThemeIcon.modify(C.$Fj.loading,"spin")}),define(me[147],be([1,0,2,4,3,19,146]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oHb=void 0,t.$nHb=y;function y($){const w=new z.$Sc,P=w.add(new C.$6d),c=(0,A.$Rw)();return w.add(c.onDidChange(()=>P.fire())),$&&w.add($.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>w.dispose(),onDidChange:P.event,getCSS(){const d=$?$.getProductIconTheme():new b,e={},s=m=>{const p=d.getIcon(m);if(!p)return;const v=p.font;return v?(e[v.id]=v.definition,`.codicon-${m.id}:before { content: '${p.fontCharacter}'; font-family: ${(0,i.$gS)(v.id)}; }`):`.codicon-${m.id}:before { content: '${p.fontCharacter}'; }`},a=[];for(const m of c.getIcons()){const p=s(m);p&&a.push(p)}for(const m in e){const p=e[m],v=p.weight?`font-weight: ${p.weight};`:"",o=p.style?`font-style: ${p.style};`:"",g=p.src.map(r=>`${(0,i.$fS)(r.location)} format('${r.format}')`).join(", ");a.push(`@font-face { src: ${g}; font-family: ${(0,i.$gS)(m)};${v}${o} font-display: block; }`)}return a.join(`
`)}}}class b{getIcon(w){const P=(0,A.$Rw)();let c=w.defaults;for(;H.ThemeIcon.isThemeIcon(c);){const d=P.getIcon(c.id);if(!d)return;c=d.defaults}return c}}t.$oHb=b}),define(me[148],be([1,0,5]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$7C=void 0,t.$8C=C,t.$9C=z,t.$0C=H,t.$$C=A,t.$_C=y,t.$aD=P,t.$bD=c,t.$cD=d,t.$dD=e,t.$eD=s,t.$fD=a,t.$7C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(m){return typeof m.parentId=="number"}function z(m){return!!m.workspaceUri}function H(m){return!!m.folderUri}function A(m){return!!m.fileUri}function y(m){const p=c(m),v=m.getValue("window.menuBarVisibility");return v==="default"||p&&v==="compact"||i.$j&&i.$m?"classic":v}var b;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(t.TitleBarSetting=b={}));var $;(function(m){m.NATIVE="native",m.CUSTOM="custom"})($||(t.TitlebarStyle=$={}));var w;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function P(m,p){return!0}function c(m,p){return p||(p=d(m)),p==="native"}function d(m){if(i.$o)return"custom";const p=m.getValue("window");if(p){if(i.$j&&p.nativeTabs===!0||i.$j&&p.nativeFullScreen===!1)return"native";const g=p.titleBarStyle;if(g==="native"||g==="custom")return g}return i.$k?"native":"custom"}function e(m){return!(!i.$i||i.$o||c(m))}function s(m){const p=m.getValue("window");return!p||typeof p.nativeFullScreen!="boolean"||p.nativeTabs?!0:p.nativeFullScreen!==!1}function a(m=0){return Math.pow(1.2,m)}}),define(me[149],be([1,0,17,2,22,31,148]),function(re,t,i,C,z,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ubc=t.$tbc=t.ApplyZoomTarget=void 0,t.$vbc=b,t.$wbc=w,t.$xbc=P;var y;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(y||(t.ApplyZoomTarget=y={})),t.$tbc=8,t.$ubc=-8;function b(c,d){c=Math.min(Math.max(c,t.$ubc),t.$tbc);const e=[];d===y.ACTIVE_WINDOW?e.push((0,C.$GR)()):d===y.ALL_WINDOWS?e.push(...Array.from((0,C.getWindows)()).map(({window:s})=>s)):e.push(d);for(const s of e)$(s)?.webFrame?.setZoomLevel(c),(0,i.$DQ)((0,A.$fD)(c),s),(0,i.$zQ)(c,s)}function $(c){if(c===z.$uQ)return{ipcRenderer:H.$O,webFrame:H.$Q};{const d=c;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function w(c){b((0,i.$AQ)(typeof c=="number"?(0,C.$GR)():c)+1,c)}function P(c){b((0,i.$AQ)(typeof c=="number"?(0,C.$GR)():c)-1,c)}}),define(me[150],be([1,0,11,2,136,9,95,31,140,141,143,144,147,149,15,22,108,99]),function(re,t,i,C,z,H,A,y,b,$,w,P,c,d,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=x;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(T){return 22}getTemplateId(T){return j(T)?"process":R(T)?"machine":(0,b.$1m)(T)?"error":M(T)?"header":""}}class v{hasChildren(T){return(0,b.$1m)(T)?!1:j(T)?!!T.children?.length:!0}getChildren(T){return j(T)?T.children?T.children:[]:(0,b.$1m)(T)?[]:M(T)?T.processRoots.length>1?T.processRoots:[T.processRoots[0].rootProcess]:R(T)?[T.rootProcess]:[T.processes]}}class o{constructor(){this.templateId="header"}renderTemplate(T){const L=(0,C.$2R)(T,(0,C.$)(".row")),I=(0,C.$2R)(L,(0,C.$)(".nameLabel")),X=(0,C.$2R)(L,(0,C.$)(".cpu")),U=(0,C.$2R)(L,(0,C.$)(".memory")),de=(0,C.$2R)(L,(0,C.$)(".pid"));return{name:I,CPU:X,memory:U,PID:de}}renderElement(T,L,I,X){I.name.textContent=(0,i.localize)(0,null),I.CPU.textContent=(0,i.localize)(1,null),I.PID.textContent=(0,i.localize)(2,null),I.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(T){}}class g{constructor(){this.templateId="machine"}renderTemplate(T){const L=Object.create(null),I=(0,C.$2R)(T,(0,C.$)(".row"));return L.name=(0,C.$2R)(I,(0,C.$)(".nameLabel")),L}renderElement(T,L,I,X){I.name.textContent=T.element.name}disposeTemplate(T){}}class r{constructor(){this.templateId="error"}renderTemplate(T){const L=Object.create(null),I=(0,C.$2R)(T,(0,C.$)(".row"));return L.name=(0,C.$2R)(I,(0,C.$)(".nameLabel")),L}renderElement(T,L,I,X){I.name.textContent=T.element.errorMessage}disposeTemplate(T){}}class E{constructor(T,L,I){this.a=T,this.b=L,this.c=I,this.templateId="process"}renderTemplate(T){const L=(0,C.$2R)(T,(0,C.$)(".row")),I=(0,C.$2R)(L,(0,C.$)(".nameLabel")),X=(0,C.$2R)(L,(0,C.$)(".cpu")),U=(0,C.$2R)(L,(0,C.$)(".memory")),de=(0,C.$2R)(L,(0,C.$)(".pid"));return{name:I,CPU:X,PID:de,memory:U}}renderElement(T,L,I,X){const{element:U}=T,de=U.pid.toFixed(0);let he=U.name;this.c.has(U.pid)&&(he=this.c.get(U.pid)),I.name.textContent=he,I.name.title=U.cmd,I.CPU.textContent=U.load.toFixed(0),I.PID.textContent=de,I.PID.parentElement.id=`pid-${de}`;const ne=this.a==="win32"?U.mem:this.b*(U.mem/100);I.memory.textContent=(ne/$.$il.MB).toFixed(0)}disposeTemplate(T){}}function R(W){return!!W.name&&!!W.rootProcess}function M(W){return!!W.processRoots}function j(W){return!!W.pid}class B{constructor(T,L){this.f=L,this.b=new Map;const I=new w.$nbc(T);this.c=new P.$rbc(T,I),this.k(L.styles),this.g(L),y.$O.on("vscode:pidToNameResponse",(X,U)=>{this.b.clear();for(const[de,he]of U)this.b.set(de,he)}),y.$O.on("vscode:listProcessesResponse",async(X,U)=>{U.forEach((de,he)=>{j(de.rootProcess)&&(de.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:U}}),this.d.layout(s.$uQ.innerHeight,s.$uQ.innerWidth)):await this.h(U),this.m(0)}),this.a=Date.now(),y.$O.send("vscode:pidToNameRequest"),y.$O.send("vscode:listProcesses")}g(T){s.$uQ.document.onkeydown=L=>{const I=T.platform==="darwin"?L.metaKey:L.ctrlKey;I&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),y.$O.send("vscode:closeProcessExplorer")),I&&L.keyCode===187&&(0,d.$wbc)(s.$uQ),I&&L.keyCode===189&&(0,d.$xbc)(s.$uQ)}}async h(T){const L=s.$uQ.document.getElementById("process-list");if(!L)return;const{totalmem:I}=await this.c.getOSStatistics(),X=[new E(this.f.platform,I,this.b),new o,new g,new r];this.d=new z.$vV("processExplorer",L,new p,X,new v,{identityProvider:{getId:U=>j(U)?U.pid.toString():(0,b.$1m)(U)?U.hostName:M(U)?"processes":R(U)?U.name:"header"}}),this.d.setInput({processes:{processRoots:T}}),this.d.layout(s.$uQ.innerHeight,s.$uQ.innerWidth),this.d.onKeyDown(U=>{const de=new e.$YQ(U);if(de.keyCode===35&&de.altKey){const he=this.n();Promise.all(he.map(ne=>this.c.killProcess(ne,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(U=>{j(U.element)&&this.l(U.element,!0)}),L.style.height=`${s.$uQ.innerHeight}px`,s.$uQ.addEventListener("resize",()=>{L.style.height=`${s.$uQ.innerHeight}px`,this.d?.layout(s.$uQ.innerHeight,s.$uQ.innerWidth)})}i(T){const L=a.exec(T);return L&&L.groups.port!=="0"||T.indexOf("node ")>=0||T.indexOf("node.exe")>=0}j(T){const L={type:"node",request:"attach",name:`process ${T.pid}`};let I=a.exec(T.cmd);I?L.port=Number(I.groups.port):L.processId=String(T.pid),I=m.exec(T.cmd),I&&(L.port=Number(I.groups.port)),y.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(T){const L=(0,C.$JR)(),I=[];T.listFocusBackground&&(I.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&I.push(`.monaco-list:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(I.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&I.push(`.monaco-list:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listHoverBackground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${T.listHoverForeground}; }`),T.listFocusOutline&&I.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&I.push(`.monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.scrollbarShadowColor&&I.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${T.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),T.scrollbarSliderBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${T.scrollbarSliderBackgroundColor};
				}
			`),T.scrollbarSliderHoverBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${T.scrollbarSliderHoverBackgroundColor};
				}
			`),T.scrollbarSliderActiveBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${T.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=I.join(`
`),T.color&&(s.$uQ.document.body.style.color=T.color)}l(T,L){const I=[],X=Number(T.pid);L&&(I.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),I.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),I.push({type:"separator"})),I.push({label:(0,i.localize)(6,null),click:()=>{const U=this.n();U?.includes(X)||(U.length=0,U.push(X));const de=U?.map(he=>s.$uQ.document.getElementById(`pid-${he}`)).filter(he=>!!he);if(de){const he=de.map(ne=>ne.innerText).filter(ne=>!!ne);this.c.writeClipboardText(he.join(`
`))}}}),I.push({label:(0,i.localize)(7,null),click:()=>{const U=s.$uQ.document.getElementById("process-list");U&&this.c.writeClipboardText(U.innerText)}}),T&&L&&this.i(T.cmd)&&(I.push({type:"separator"}),I.push({label:(0,i.localize)(8,null),click:()=>{this.j(T)}})),(0,A.$YV)(I)}m(T){setTimeout(()=>{const L=Date.now(),I=T+L-this.a;this.a=L,I>1e3?(y.$O.send("vscode:pidToNameRequest"),y.$O.send("vscode:listProcesses")):this.m(I)},200)}n(){return this.d?.getSelection()?.map(T=>{if(!(!T||!("pid"in T)))return T.pid}).filter(T=>!!T)}}function D(){const W=(0,C.$JR)();W.id="codiconStyles";const T=(0,c.$nHb)(void 0);function L(){W.textContent=T.getCSS()}const I=new H.$sh(L,0);T.onDidChange(()=>I.schedule()),I.schedule()}function x(W){const T=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";s.$uQ.document.body.classList.add(T),D(),(0,d.$vbc)(W.data.zoomLevel,s.$uQ),new B(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
