/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/event","vs/base/common/errors","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(J){for(var e=[],O=0,j=J.length;O<j;O++)e[O]=se[J[O]];return e};define(se[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const k=new Map,A=new Map,D=new Map,E=new Map;function u(p,y){p.has(y.detail)||p.set(y.detail,-y.timestamp)}function a(p,y){const R=p.get(y.detail);R&&(R>=0||p.set(y.detail,R+y.timestamp))}let b=[];typeof J=="function"&&typeof J.getStats=="function"&&(b=J.getStats().slice(0).sort((p,y)=>p.timestamp-y.timestamp));for(const p of b)switch(p.type){case 10:u(k,p);break;case 11:case 12:a(k,p);break;case 21:u(A,p);break;case 22:a(A,p);break;case 33:u(D,p);break;case 34:a(D,p);break;case 31:u(E,p);break;case 32:a(E,p);break}let v=0;D.forEach(p=>v+=p);function d(p){const y=[];return p.forEach((R,m)=>y.push([m,R])),y}return{amdLoad:d(k),amdInvoke:d(A),nodeRequire:d(D),nodeEval:d(E),nodeRequireTotal:v}}static toMarkdownTable(k,A){let D="";const E=[];return k.forEach((u,a)=>{E[a]=u.length}),A.forEach(u=>{u.forEach((a,b)=>{typeof a>"u"&&(a=u[b]="-");const v=a.toString().length;E[b]=Math.max(v,E[b])})}),k.forEach((u,a)=>{D+=`| ${u+" ".repeat(E[a]-u.toString().length)} `}),D+=`|
`,k.forEach((u,a)=>{D+=`| ${"-".repeat(E[a])} `}),D+=`|
`,A.forEach(u=>{u.forEach((a,b)=>{typeof a<"u"&&(D+=`| ${a+" ".repeat(E[b]-a.toString().length)} `)}),D+=`|
`}),D}}e.$U=O}),define(se[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=j,e.$Lh=k,e.$Mh=A;function O(D){return(E,u,a)=>{let b=null,v=null;if(typeof a.value=="function"?(b="value",v=a.value):typeof a.get=="function"&&(b="get",v=a.get),!v)throw new Error("not supported");a[b]=D(v,u)}}function j(D,E,u){let a=null,b=null;if(typeof u.value=="function"?(a="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",b=u.get),!b)throw new Error("not supported");const v=`$memoize$${E}`;u[a]=function(...d){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,d)}),this[v]}}function k(D,E,u){return O((a,b)=>{const v=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...p){this[d]||(this[d]=u?u():void 0),clearTimeout(this[v]),E&&(this[d]=E(this[d],...p),p=[this[d]]),this[v]=setTimeout(()=>{a.apply(this,p),this[d]=u?u():void 0},D)}})}function A(D,E,u){return O((a,b)=>{const v=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,p=`$throttle$lastRun$${b}`,y=`$throttle$pending$${b}`;return function(...R){if(this[d]||(this[d]=u?u():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),E&&(this[d]=E(this[d],...R)),this[y])return;const m=this[p]+D;m<=Date.now()?(this[p]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[p]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},m-Date.now()))}})}}),define(se[71],re([0,1,8]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$9c=k,e.$0c=A,e.$$c=D,e.$_c=E,e.$ad=u;function j(a,b){if(!a)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function k(a,b="Unreachable"){throw new Error(b)}function A(a){if(!a)throw new O.$cb("Assertion Failed")}function D(a){a||(0,O.$1)(new O.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,O.$1)(new O.$cb("Assertion Failed"))}}function u(a,b){let v=0;for(;v<a.length-1;){const d=a[v],p=a[v+1];if(!b(d,p))return!1;v++}return!0}}),define(se[38],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$rn=D,e.$sn=v,e.$tn=d,e.$un=p,e.$vn=y,e.$wn=R,e.$xn=m,e.$yn=c,e.$zn=w,e.$An=$,e.$Bn=h,e.$Cn=g;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var j;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function D(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,S=0;function I(te){let ue=0,fe=0;for(;ue<te;){const ce=i.charCodeAt(t);if(ce>=48&&ce<=57)fe=fe*16+ce-48;else if(ce>=65&&ce<=70)fe=fe*16+ce-65+10;else if(ce>=97&&ce<=102)fe=fe*16+ce-97+10;else break;t++,ue++}return ue<te&&(fe=-1),fe}function L(te){t=te,s="",o=0,l=16,S=0}function T(){const te=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return S=3,i.substring(te,t);let ue=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;ue=t}else S=3;return i.substring(te,ue)}function z(){let te="",ue=t;for(;;){if(t>=n){te+=i.substring(ue,t),S=2;break}const fe=i.charCodeAt(t);if(fe===34){te+=i.substring(ue,t),t++;break}if(fe===92){if(te+=i.substring(ue,t),t++,t>=n){S=2;break}switch(i.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const B=I(4);B>=0?te+=String.fromCharCode(B):S=4;break}default:S=5}ue=t;continue}if(fe>=0&&fe<=31)if(u(fe)){te+=i.substring(ue,t),S=2;break}else S=6;t++}return te}function V(){if(s="",S=0,o=t,t>=n)return o=n,l=17;let te=i.charCodeAt(t);if(E(te)){do t++,s+=String.fromCharCode(te),te=i.charCodeAt(t);while(E(te));return l=15}if(u(te))return t++,s+=String.fromCharCode(te),te===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(te){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=z(),l=10;case 47:{const ue=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(ue,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const fe=n-1;let ce=!1;for(;t<fe;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,S=1),s=i.substring(ue,t),l=13}return s+=String.fromCharCode(te),t++,l=16}case 45:if(s+=String.fromCharCode(te),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),l=11;default:for(;t<n&&Q(te);)t++,te=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(te),t++,l=16}}function Q(te){if(E(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let te;do te=V();while(te>=12&&te<=15);return te}return{setPosition:L,getPosition:()=>t,scan:r?ne:V,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>S}}function E(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function v(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(I,L,T,z){o.value=I,o.offset=L,o.length=T,o.type=z,o.colonOffset=void 0,s=o}try{$(i,{onObjectBegin:(I,L)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,L,T)=>{if(r<L||(S(I,L,T,"property"),t[t.length-1]=I,r<=L+T))throw n},onObjectEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,L)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,L,T)=>{if(r<L||(S(I,L,T,g(I)),r<=L+T))throw n},onSeparator:(I,L,T)=>{if(r<=L)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=L,l=!1,s=void 0;else if(I===","){const z=t[t.length-1];typeof z=="number"?t[t.length-1]=z+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let L=0;for(let T=0;L<I.length&&T<t.length;T++)if(I[L]===t[T]||I[L]==="*")L++;else if(I[L]!=="**")return!1;return L===I.length}}}function d(i,r=[],t=A.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return $(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,L,T)=>{r.push({error:I,offset:L,length:T})}},t),s[0]}function p(i,r=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}$(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,L,T)=>{n=o({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:L,length:T,parent:n})},onObjectEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onArrayBegin:(I,L)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onLiteralValue:(I,L,T)=>{o({type:g(I),offset:L,length:T,parent:n,value:I}),s(L+T)},onSeparator:(I,L,T)=>{n.type==="property"&&(I===":"?n.colonOffset=L:I===","&&s(L))},onError:(I,L,T)=>{r.push({error:I,offset:L,length:T})}},t);const S=n.children[0];return S&&delete S.parent,S}function y(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function R(i){if(!i.parent||!i.parent.children)return[];const r=R(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=m(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}function w(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=w(n[s],r,t);if(o)return o}return i}}function $(i,r,t=A.DEFAULT){const n=D(i,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(K){return K?_=>K(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),S=o(r.onObjectProperty),I=s(r.onObjectEnd),L=s(r.onArrayBegin),T=s(r.onArrayEnd),z=o(r.onLiteralValue),V=o(r.onSeparator),Q=s(r.onComment),ne=o(r.onError),te=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function fe(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:te||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(K){case 12:case 13:te?ce(10):Q();break;case 16:ce(1);break;case 15:case 14:break;default:return K}}}function ce(K,_=[],U=[]){if(ne(K),_.length+U.length>0){let M=n.getToken();for(;M!==17;){if(_.indexOf(M)!==-1){fe();break}else if(U.indexOf(M)!==-1)break;M=fe()}}}function B(K){const _=n.getTokenValue();return K?z(_):S(_),fe(),!0}function X(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(ce(2),K=0)}catch{ce(2)}z(K);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return fe(),!0}function q(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(V(":"),fe(),Z()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function F(){l(),fe();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||ce(4,[],[]),V(","),fe(),n.getToken()===2&&ue)break}else K&&ce(6,[],[]);q()||ce(4,[],[2,5]),K=!0}return I(),n.getToken()!==2?ce(7,[2],[]):fe(),!0}function H(){L(),fe();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||ce(4,[],[]),V(","),fe(),n.getToken()===4&&ue)break}else K&&ce(6,[],[]);Z()||ce(4,[],[4,5]),K=!0}return T(),n.getToken()!==4?ce(8,[4],[]):fe(),!0}function Z(){switch(n.getToken()){case 3:return H();case 1:return F();case 10:return B(!0);default:return X()}}return fe(),n.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Z()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function h(i,r){const t=D(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[72],re([0,1,38]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=j,e.$En=k,e.$Fn=E,e.$Gn=u;function j(a,b,v){let d,p,y,R,m;if(b){for(R=b.offset,m=R+b.length,y=R;y>0&&!u(a,y-1);)y--;let l=m;for(;l<a.length&&!u(a,l);)l++;p=a.substring(y,l),d=D(p,v)}else p=a,d=0,y=0,R=0,m=a.length;const c=E(v,a);let w=!1,$=0,h;v.insertSpaces?h=A(" ",v.tabSize||4):h="	";const g=(0,O.$rn)(p,!1);let i=!1;function r(){return c+A(h,d+$)}function t(){let l=g.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,S,I){!i&&S<m&&I>R&&a.substring(S,I)!==l&&n.push({offset:S,length:I-S,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+y,S=A(h,d);s(S,y,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+y,S=t(),I="";for(;!w&&(S===12||S===13);){const T=g.getTokenOffset()+y;s(" ",l,T),l=g.getTokenOffset()+g.getTokenLength()+y,I=S===12?r():"",S=t()}if(S===2)o!==1&&($--,I=r());else if(S===4)o!==3&&($--,I=r());else{switch(o){case 3:case 1:$++,I=r();break;case 5:case 12:I=r();break;case 13:w?I=r():I=" ";break;case 6:I=" ";break;case 10:if(S===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?I=" ":S!==5&&S!==17&&(i=!0);break;case 16:i=!0;break}w&&(S===12||S===13)&&(I=r())}const L=g.getTokenOffset()+y;s(I,l,L),o=S}return n}function k(a,b){const v=JSON.stringify(a,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}function A(a,b){let v="";for(let d=0;d<b;d++)v+=a;return v}function D(a,b){let v=0,d=0;const p=b.tabSize||4;for(;v<a.length;){const y=a.charAt(v);if(y===" ")d++;else if(y==="	")d+=p;else break;v++}return Math.floor(d/p)}function E(a,b){for(let v=0;v<b.length;v++){const d=b.charAt(v);if(d==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function u(a,b){return`\r
`.indexOf(a.charAt(b))!==-1}}),define(se[73],re([0,1,38,72]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=k,e.$In=A,e.$Jn=D,e.$Kn=E,e.$Ln=u;function k(a,b,v){return A(a,b,void 0,v)}function A(a,b,v,d,p){const y=b.slice(),R=[],m=(0,O.$un)(a,R);let c,w;for(;y.length>0&&(w=y.pop(),c=(0,O.$vn)(m,y),c===void 0&&v!==void 0);)typeof w=="string"?v={[w]:v}:v=[v];if(c)if(c.type==="object"&&typeof w=="string"&&Array.isArray(c.children)){const $=(0,O.$vn)(c,[w]);if($!==void 0)if(v===void 0){if(!$.parent)throw new Error("Malformed AST");const h=c.children.indexOf($.parent);let g,i=$.parent.offset+$.parent.length;if(h>0){const r=c.children[h-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return D(a,{offset:g,length:i-g,content:""},d)}else return D(a,{offset:$.offset,length:$.length,content:JSON.stringify(v)},d);else{if(v===void 0)return[];const h=`${JSON.stringify(w)}: ${JSON.stringify(v)}`,g=p?p(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return D(a,i,d)}}else if(c.type==="array"&&typeof w=="number"&&Array.isArray(c.children))if(v!==void 0){const $=`${JSON.stringify(v)}`;let h;if(c.children.length===0||w===0)h={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const g=w===-1||w>c.children.length?c.children.length:w,i=c.children[g-1];h={offset:i.offset+i.length,length:0,content:","+$}}return D(a,h,d)}else{const $=w,h=c.children[$];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const i=c.children[$-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:h.offset,length:c.children[$+1].offset-h.offset,content:""};return D(a,g,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${c.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(a,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},d)}}function D(a,b,v){let d=E(a,b),p=b.offset,y=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;p>0&&!(0,j.$Gn)(d,p-1);)p--;for(;y<d.length&&!(0,j.$Gn)(d,y);)y++}const R=(0,j.$Dn)(d,{offset:p,length:y-p},v);for(let c=R.length-1;c>=0;c--){const w=R[c];d=E(d,w),p=Math.min(p,w.offset),y=Math.max(y,w.offset+w.length),y+=w.content.length-w.length}const m=a.length-(d.length-y)-p;return[{offset:p,length:m,content:d.substring(p,y)}]}function E(a,b){return a.substring(0,b.offset)+b.content+a.substring(b.offset+b.length)}function u(a,b){const v=b.slice(0).sort((p,y)=>{const R=p.offset-y.offset;return R===0?p.length-y.length:R});let d=a.length;for(let p=v.length-1;p>=0;p--){const y=v[p];if(y.offset+y.length<=d)a=E(a,y);else throw new Error("Overlapping edit");d=y.offset}return a}}),define(se[74],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0,e.$lm=O,e.rot=j;function O(E,u,a){return Math.min(Math.max(E,u),a)}function j(E,u){return(u+E%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$nm=k;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$om=A;class D{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$pm=D}),function(){function J(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function D(u){A.push(u,Date.now())}function E(){const u=[];for(let a=0;a<A.length;a+=2)u.push({name:A[a],startTime:A[a+1]});return u}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(k+D.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function O(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=O(j))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var j in O)(typeof exports=="object"?exports:J)[j]=O[j]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function O(j){if(e[j])return e[j].exports;var k=e[j]={i:j,l:!1,exports:{}};return J[j].call(k.exports,k,k.exports,O),k.l=!0,k.exports}return O.m=J,O.c=e,O.d=function(j,k,A){O.o(j,k)||Object.defineProperty(j,k,{enumerable:!0,get:A})},O.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},O.t=function(j,k){if(1&k&&(j=O(j)),8&k||4&k&&typeof j=="object"&&j&&j.__esModule)return j;var A=Object.create(null);if(O.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:j}),2&k&&typeof j!="string")for(var D in j)O.d(A,D,function(E){return j[E]}.bind(null,D));return A},O.n=function(j){var k=j&&j.__esModule?function(){return j.default}:function(){return j};return O.d(k,"a",k),k},O.o=function(j,k){return Object.prototype.hasOwnProperty.call(j,k)},O.p="",O(O.s=0)}([function(J,e,O){(function(j){var k;e=J.exports=U,k=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],a=0,b=a++;u[b]="0|[1-9]\\d*";var v=a++;u[v]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;u[p]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var y=a++;u[y]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var R=a++;u[R]="(?:"+u[b]+"|"+u[d]+")";var m=a++;u[m]="(?:"+u[v]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[R]+"(?:\\."+u[R]+")*))";var w=a++;u[w]="(?:-?("+u[m]+"(?:\\."+u[m]+")*))";var $=a++;u[$]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[$]+"(?:\\."+u[$]+")*))";var g=a++,i="v?"+u[p]+u[c]+"?"+u[h]+"?";u[g]="^"+i+"$";var r="[v=\\s]*"+u[y]+u[w]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[v]+"|x|X|\\*";var o=a++;u[o]=u[b]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var S=a++;u[S]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[w]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var L=a++;u[L]="^"+u[n]+"\\s*"+u[S]+"$";var T=a++;u[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=a++;u[z]="(?:~>?)";var V=a++;u[V]="(\\s*)"+u[z]+"\\s+",E[V]=new RegExp(u[V],"g");var Q=a++;u[Q]="^"+u[z]+u[l]+"$";var ne=a++;u[ne]="^"+u[z]+u[S]+"$";var te=a++;u[te]="(?:\\^)";var ue=a++;u[ue]="(\\s*)"+u[te]+"\\s+",E[ue]=new RegExp(u[ue],"g");var fe=a++;u[fe]="^"+u[te]+u[l]+"$";var ce=a++;u[ce]="^"+u[te]+u[S]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var X=a++;u[X]="^"+u[n]+"\\s*("+i+")$|^$";var q=a++;u[q]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",E[q]=new RegExp(u[q],"g");var F=a++;u[F]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var H=a++;u[H]="^\\s*("+u[S]+")\\s+-\\s+("+u[S]+")\\s*$";var Z=a++;u[Z]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)k(K,u[K]),E[K]||(E[K]=new RegExp(u[K]));function _(x,Y){if(x instanceof U)return x;if(typeof x!="string"||x.length>A||!(Y?E[t]:E[g]).test(x))return null;try{return new U(x,Y)}catch{return null}}function U(x,Y){if(x instanceof U){if(x.loose===Y)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(x,Y);k("SemVer",x,Y),this.loose=Y;var ee=x.trim().match(Y?E[t]:E[g]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<D)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,Y){var ee=_(x,Y);return ee?ee.version:null},e.clean=function(x,Y){var ee=_(x.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof U||(x=new U(x,this.loose)),this.compareMain(x)||this.comparePre(x)},U.prototype.compareMain=function(x){return x instanceof U||(x=new U(x,this.loose)),f(this.major,x.major)||f(this.minor,x.minor)||f(this.patch,x.patch)},U.prototype.comparePre=function(x){if(x instanceof U||(x=new U(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],ge=x.prerelease[Y];if(k("prerelease compare",Y,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++Y)},U.prototype.inc=function(x,Y){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,Y,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(x,ee).inc(Y,ge).version}catch{return null}},e.diff=function(x,Y){if(W(x,Y))return null;var ee=_(x),ge=_(Y);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=f;var M=/^[0-9]+$/;function f(x,Y){var ee=M.test(x),ge=M.test(Y);return ee&&ge&&(x=+x,Y=+Y),ee&&!ge?-1:ge&&!ee?1:x<Y?-1:x>Y?1:0}function P(x,Y,ee){return new U(x,ee).compare(new U(Y,ee))}function N(x,Y,ee){return P(x,Y,ee)>0}function C(x,Y,ee){return P(x,Y,ee)<0}function W(x,Y,ee){return P(x,Y,ee)===0}function G(x,Y,ee){return P(x,Y,ee)!==0}function ie(x,Y,ee){return P(x,Y,ee)>=0}function ae(x,Y,ee){return P(x,Y,ee)<=0}function le(x,Y,ee,ge){var ve;switch(Y){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x!==ee;break;case"":case"=":case"==":ve=W(x,ee,ge);break;case"!=":ve=G(x,ee,ge);break;case">":ve=N(x,ee,ge);break;case">=":ve=ie(x,ee,ge);break;case"<":ve=C(x,ee,ge);break;case"<=":ve=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+Y)}return ve}function pe(x,Y){if(x instanceof pe){if(x.loose===Y)return x;x=x.value}if(!(this instanceof pe))return new pe(x,Y);k("comparator",x,Y),this.loose=Y,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,Y){return f(Y,x)},e.major=function(x,Y){return new U(x,Y).major},e.minor=function(x,Y){return new U(x,Y).minor},e.patch=function(x,Y){return new U(x,Y).patch},e.compare=P,e.compareLoose=function(x,Y){return P(x,Y,!0)},e.rcompare=function(x,Y,ee){return P(Y,x,ee)},e.sort=function(x,Y){return x.sort(function(ee,ge){return e.compare(ee,ge,Y)})},e.rsort=function(x,Y){return x.sort(function(ee,ge){return e.rcompare(ee,ge,Y)})},e.gt=N,e.lt=C,e.eq=W,e.neq=G,e.gte=ie,e.lte=ae,e.cmp=le,e.Comparator=pe;var ye={};function he(x,Y){if(x instanceof he)return x.loose===Y?x:new he(x.raw,Y);if(x instanceof pe)return new he(x.value,Y);if(!(this instanceof he))return new he(x,Y);if(this.loose=Y,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,Y,ee,ge,ve,De,Se,Le,Re,Ae,Ue,je,Ne){return((Y=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+Y)+" "+(Le=me(Re)?"":me(Ae)?"<"+(+Re+1)+".0.0":me(Ue)?"<"+Re+"."+(+Ae+1)+".0":je?"<="+Re+"."+Ae+"."+Ue+"-"+je:"<="+Le)).trim()}function we(x,Y){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<x.length;ee++)if(k(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===Y.major&&ge.minor===Y.minor&&ge.patch===Y.patch)return!0}return!1}return!0}function Ee(x,Y,ee){try{Y=new he(Y,ee)}catch{return!1}return Y.test(x)}function ke(x,Y,ee,ge){var ve,De,Se,Le,Re;switch(x=new U(x,ge),Y=new he(Y,ge),ee){case">":ve=N,De=ae,Se=C,Le=">",Re=">=";break;case"<":ve=C,De=ie,Se=N,Le="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,Y,ge))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var Ue=Y.set[Ae],je=null,Ne=null;if(Ue.forEach(function(Te){Te.semver===ye&&(Te=new pe(">=0.0.0")),je=je||Te,Ne=Ne||Te,ve(Te.semver,je.semver,ge)?je=Te:Se(Te.semver,Ne.semver,ge)&&(Ne=Te)}),je.operator===Le||je.operator===Re||(!Ne.operator||Ne.operator===Le)&&De(x,Ne.semver)||Ne.operator===Re&&Se(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var Y=this.loose?E[B]:E[X],ee=x.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new U(x,this.loose)),le(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,Y){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he(x.value,Y),Ee(this.value,ee,Y);if(x.operator==="")return ee=new he(this.value,Y),Ee(x.semver,ee,Y);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=le(this.semver,"<",x.semver,Y)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Re=le(this.semver,">",x.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||ve||De&&Se||Le||Re},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(x){var Y=this.loose;x=x.trim(),k("range",x,Y);var ee=Y?E[H]:E[F];x=x.replace(ee,de),k("hyphen replace",x),x=x.replace(E[q],"$1$2$3"),k("comparator trim",x,E[q]),x=(x=(x=x.replace(E[V],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var ge=Y?E[B]:E[X],ve=x.split(" ").map(function(De){return function(Se,Le){return k("comp",Se),Se=function(Re,Ae){return Re.trim().split(/\s+/).map(function(Ue){return function(je,Ne){k("caret",je,Ne);var Te=Ne?E[ce]:E[fe];return je.replace(Te,function(Me,be,Pe,Ie,Oe){var ze;return k("caret",je,Me,be,Pe,Ie,Oe),me(be)?ze="":me(Pe)?ze=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?ze=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Oe?(k("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+Oe+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+Oe+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+Oe+" <"+(+be+1)+".0.0"):(k("no pr"),ze=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",ze),ze})}(Ue,Ae)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Re,Ae){return Re.trim().split(/\s+/).map(function(Ue){return function(je,Ne){var Te=Ne?E[ne]:E[Q];return je.replace(Te,function(Me,be,Pe,Ie,Oe){var ze;return k("tilde",je,Me,be,Pe,Ie,Oe),me(be)?ze="":me(Pe)?ze=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?ze=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Oe?(k("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=">="+be+"."+Pe+"."+Ie+Oe+" <"+be+"."+(+Pe+1)+".0"):ze=">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0",k("tilde return",ze),ze})}(Ue,Ae)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Re,Ae){return k("replaceXRanges",Re,Ae),Re.split(/\s+/).map(function(Ue){return function(je,Ne){je=je.trim();var Te=Ne?E[L]:E[I];return je.replace(Te,function(Me,be,Pe,Ie,Oe,ze){k("xRange",je,Me,be,Pe,Ie,Oe,ze);var qe=me(Pe),Ce=qe||me(Ie),Fe=Ce||me(Oe);return be==="="&&Fe&&(be=""),qe?Me=be===">"||be==="<"?"<0.0.0":"*":be&&Fe?(Ce&&(Ie=0),Fe&&(Oe=0),be===">"?(be=">=",Ce?(Pe=+Pe+1,Ie=0,Oe=0):Fe&&(Ie=+Ie+1,Oe=0)):be==="<="&&(be="<",Ce?Pe=+Pe+1:Ie=+Ie+1),Me=be+Pe+"."+Ie+"."+Oe):Ce?Me=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Fe&&(Me=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0"),k("xRange return",Me),Me})}(Ue,Ae)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Re,Ae){return k("replaceStars",Re,Ae),Re.trim().replace(E[Z],"")}(Se,Le),k("stars",Se),Se}(De,Y)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ge)})),ve=ve.map(function(De){return new pe(De,Y)})},he.prototype.intersects=function(x,Y){if(!(x instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(ve){return ve.every(function(De){return ge.intersects(De,Y)})})})})},e.toComparators=function(x,Y){return new he(x,Y).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},he.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new U(x,this.loose));for(var Y=0;Y<this.set.length;Y++)if(we(this.set[Y],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,Y,ee){var ge=null,ve=null;try{var De=new he(Y,ee)}catch{return null}return x.forEach(function(Se){De.test(Se)&&(ge&&ve.compare(Se)!==-1||(ve=new U(ge=Se,ee)))}),ge},e.minSatisfying=function(x,Y,ee){var ge=null,ve=null;try{var De=new he(Y,ee)}catch{return null}return x.forEach(function(Se){De.test(Se)&&(ge&&ve.compare(Se)!==1||(ve=new U(ge=Se,ee)))}),ge},e.validRange=function(x,Y){try{return new he(x,Y).range||"*"}catch{return null}},e.ltr=function(x,Y,ee){return ke(x,Y,"<",ee)},e.gtr=function(x,Y,ee){return ke(x,Y,">",ee)},e.outside=ke,e.prerelease=function(x,Y){var ee=_(x,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,Y,ee){return x=new he(x,ee),Y=new he(Y,ee),x.intersects(Y)},e.coerce=function(x){if(x instanceof U)return x;if(typeof x!="string")return null;var Y=x.match(E[T]);return Y==null?null:_((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,O(1))},function(J,e){var O,j,k=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(m){if(O===setTimeout)return setTimeout(m,0);if((O===A||!O)&&setTimeout)return O=setTimeout,setTimeout(m,0);try{return O(m,0)}catch{try{return O.call(null,m,0)}catch{return O.call(this,m,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:A}catch{O=A}try{j=typeof clearTimeout=="function"?clearTimeout:D}catch{j=D}})();var u,a=[],b=!1,v=-1;function d(){b&&u&&(b=!1,u.length?a=u.concat(a):v=-1,a.length&&p())}function p(){if(!b){var m=E(d);b=!0;for(var c=a.length;c;){for(u=a,a=[];++v<c;)u&&u[v].run();v=-1,c=a.length}u=null,b=!1,function(w){if(j===clearTimeout)return clearTimeout(w);if((j===D||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(w);try{j(w)}catch{try{return j.call(null,w)}catch{return j.call(this,w)}}}(m)}}function y(m,c){this.fun=m,this.array=c}function R(){}k.nextTick=function(m){var c=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)c[w-1]=arguments[w];a.push(new y(m,c)),a.length!==1||b||E(p)},y.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=R,k.addListener=R,k.once=R,k.off=R,k.removeListener=R,k.removeAllListeners=R,k.emit=R,k.prependListener=R,k.prependOnceListener=R,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(se[75],re([0,1]),function(J,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class j{constructor(E,u,a){this.level=E,this.key=u,this.value=a,this.forward=[]}}const k=void 0;class A{constructor(E,u=2**16){this.comparator=E,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new j(this.c,k,k)}get size(){return this.f}clear(){this.e=new j(this.c,k,k),this.f=0}has(E){return!!A.g(this,E,this.comparator)}get(E){return A.g(this,E,this.comparator)?.value}set(E,u){return A.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=A.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let a=this.e.forward[0];for(;a;)E.call(u,a.value,a.key,this),a=a.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,a){let b=E.e;for(let v=E.d-1;v>=0;v--)for(;b.forward[v]&&a(b.forward[v].key,u)<0;)b=b.forward[v];if(b=b.forward[0],b&&a(b.key,u)===0)return b}static h(E,u,a,b){const v=[];let d=E.e;for(let p=E.d-1;p>=0;p--){for(;d.forward[p]&&b(d.forward[p].key,u)<0;)d=d.forward[p];v[p]=d}if(d=d.forward[0],d&&b(d.key,u)===0)return d.value=a,!1;{const p=A.j(E);if(p>E.d){for(let y=E.d;y<p;y++)v[y]=E.e;E.d=p}d=new j(p,u,a);for(let y=0;y<p;y++)d.forward[y]=v[y].forward[y],v[y].forward[y]=d;return!0}}static j(E,u=.5){let a=1;for(;Math.random()<u&&a<E.c;)a+=1;return a}static k(E,u,a){const b=[];let v=E.e;for(let d=E.d-1;d>=0;d--){for(;v.forward[d]&&a(v.forward[d].key,u)<0;)v=v.forward[d];b[d]=v}if(v=v.forward[0],!v||a(v.key,u)!==0)return!1;for(let d=0;d<E.d&&b[d].forward[d]===v;d++)b[d].forward[d]=v.forward[d];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$es=A}),define(se[46],re([0,1,8,2]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=k,e.$fe=A,e.$ge=D,e.$he=E,e.$ie=a,e.$je=b,e.$ke=v,e.$le=d,e.$me=p,e.$ne=y,e.$oe=R,e.$pe=m,e.$qe=c,e.$re=w,e.$se=$;function k(h){const g=h;return g?typeof g.read=="function":!1}function A(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}function D(h){const g=h;return g?A(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function E(h,g){return new u(h,g)}class u{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,O.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,g){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return g(i)}function b(h,g,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}function v(h,g){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}function d(h,g,i){h.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}function p(h,g){return new Promise((i,r)=>{const t=new j.$Sc,n=[],s=S=>{if(n.push(S),n.length>g)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=S=>(t.dispose(),r(S)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,j.$Rc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,j.$Rc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,j.$Rc)(()=>h.removeListener("data",s))),h.on("data",s)})}function y(h,g){const i=E(g);return i.end(h),i}function R(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}function m(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}function c(h,g,i){const r=E(i);return d(h,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}function w(h,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}function $(h,g,i){let r=!1;const t=E(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}}),define(se[14],re([0,1,167,46]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=void 0,e.$ue=a,e.$ve=b,e.$we=v,e.$xe=d,e.$ye=p,e.$ze=y,e.$Ae=R,e.$Be=m,e.$Ce=c,e.$De=w,e.$Ee=$,e.$Fe=h,e.$Ge=g,e.$He=i,e.$Ie=r,e.$Je=t,e.$Ke=n,e.$Le=s,e.$Me=o,e.$Ne=I;const k=typeof Buffer<"u",A=new O.$V(()=>new Uint8Array(256));let D,E;class u{static alloc(T){return k?new u(Buffer.allocUnsafe(T)):new u(new Uint8Array(T))}static wrap(T){return k&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new u(T)}static fromString(T,z){return!(z?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(T)):(D||(D=new TextEncoder),new u(D.encode(T)))}static fromByteArray(T){const z=u.alloc(T.length);for(let V=0,Q=T.length;V<Q;V++)z.buffer[V]=T[V];return z}static concat(T,z){if(typeof z>"u"){z=0;for(let ne=0,te=T.length;ne<te;ne++)z+=T[ne].byteLength}const V=u.alloc(z);let Q=0;for(let ne=0,te=T.length;ne<te;ne++){const ue=T[ne];V.set(ue,Q),Q+=ue.byteLength}return V}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=u.alloc(this.byteLength);return T.set(this),T}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(T,z){return new u(this.buffer.subarray(T,z))}set(T,z){if(T instanceof u)this.buffer.set(T.buffer,z);else if(T instanceof Uint8Array)this.buffer.set(T,z);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),z);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return d(this.buffer,T)}writeUInt32BE(T,z){p(this.buffer,T,z)}readUInt32LE(T){return y(this.buffer,T)}writeUInt32LE(T,z){R(this.buffer,T,z)}readUInt8(T){return m(this.buffer,T)}writeUInt8(T,z){c(this.buffer,T,z)}indexOf(T,z=0){return a(this.buffer,T instanceof u?T.buffer:T,z)}}e.$te=u;function a(L,T,z=0){const V=T.byteLength,Q=L.byteLength;if(V===0)return 0;if(V===1)return L.indexOf(T[0]);if(V>Q-z)return-1;const ne=A.value;ne.fill(T.length);for(let ce=0;ce<T.length;ce++)ne[T[ce]]=T.length-ce-1;let te=z+T.length-1,ue=te,fe=-1;for(;te<Q;)if(L[te]===T[ue]){if(ue===0){fe=te;break}te--,ue--}else te+=Math.max(T.length-ue,ne[L[te]]),ue=T.length-1;return fe}function b(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0}function v(L,T,z){L[z+0]=T&255,T=T>>>8,L[z+1]=T&255}function d(L,T){return L[T]*2**24+L[T+1]*2**16+L[T+2]*2**8+L[T+3]}function p(L,T,z){L[z+3]=T,T=T>>>8,L[z+2]=T,T=T>>>8,L[z+1]=T,T=T>>>8,L[z]=T}function y(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0|L[T+2]<<16>>>0|L[T+3]<<24>>>0}function R(L,T,z){L[z+0]=T&255,T=T>>>8,L[z+1]=T&255,T=T>>>8,L[z+2]=T&255,T=T>>>8,L[z+3]=T&255}function m(L,T){return L[T]}function c(L,T,z){L[z]=T}function w(L){return j.$ie(L,T=>u.concat(T))}function $(L){return j.$pe(L)}function h(L){return j.$ke(L,T=>u.concat(T))}async function g(L){return L.ended?u.concat(L.buffer):u.concat([...L.buffer,await h(L.stream)])}function i(L){return j.$ne(L,T=>u.concat(T))}function r(L){return j.$qe(L,{data:T=>typeof T=="string"?u.fromString(T):u.wrap(T)},T=>u.concat(T))}function t(L){return j.$he(T=>u.concat(T),L)}function n(L,T){return j.$re(L,T,z=>u.concat(z))}function s(L,T){return j.$se(L,T,z=>u.concat(z))}function o(L){let T=0,z=0,V=0;const Q=new Uint8Array(Math.floor(L.length/4*3)),ne=ue=>{switch(z){case 3:Q[V++]=T|ue,z=0;break;case 2:Q[V++]=T|ue>>>2,T=ue<<6,z=3;break;case 1:Q[V++]=T|ue>>>4,T=ue<<4,z=2;break;default:T=ue<<2,z=1}};for(let ue=0;ue<L.length;ue++){const fe=L.charCodeAt(ue);if(fe>=65&&fe<=90)ne(fe-65);else if(fe>=97&&fe<=122)ne(fe-97+26);else if(fe>=48&&fe<=57)ne(fe-48+52);else if(fe===43||fe===45)ne(62);else if(fe===47||fe===95)ne(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ue]}`)}}const te=V;for(;z>0;)ne(0);return u.wrap(Q).slice(0,te)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:L},T=!0,z=!1){const V=z?S:l;let Q="";const ne=L.byteLength%3;let te=0;for(;te<L.byteLength-ne;te+=3){const ue=L[te+0],fe=L[te+1],ce=L[te+2];Q+=V[ue>>>2],Q+=V[(ue<<4|fe>>>4)&63],Q+=V[(fe<<2|ce>>>6)&63],Q+=V[ce&63]}if(ne===1){const ue=L[te+0];Q+=V[ue>>>2],Q+=V[ue<<4&63],T&&(Q+="==")}else if(ne===2){const ue=L[te+0],fe=L[te+1];Q+=V[ue>>>2],Q+=V[(ue<<4|fe>>>4)&63],Q+=V[fe<<2&63],T&&(Q+="=")}return Q}}),define(se[43],re([0,1,30]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$$i=void 0,e.$7i=j,e.$8i=k,e.$9i=A,e.$0i=E,e.$_i=R;function j(c){return k(c,0)}function k(c,w){switch(typeof c){case"object":return c===null?A(349,w):Array.isArray(c)?u(c,w):a(c,w);case"string":return E(c,w);case"boolean":return D(c,w);case"number":return A(c,w);case"undefined":return A(937,w);default:return A(617,w)}}function A(c,w){return(w<<5)-w+c|0}function D(c,w){return A(c?433:863,w)}function E(c,w){w=A(149417,w);for(let $=0,h=c.length;$<h;$++)w=A(c.charCodeAt($),w);return w}function u(c,w){return w=A(104579,w),c.reduce(($,h)=>k(h,$),w)}function a(c,w){return w=A(181387,w),Object.keys(c).sort().reduce(($,h)=>($=E(h,$),k(c[h],$)),w)}class b{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=k(w,this.g),this.g}}e.$$i=b;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function d(c,w,$=32){const h=$-w,g=~((1<<h)-1);return(c<<w|(g&c)>>>h)>>>0}function p(c,w=0,$=c.byteLength,h=0){for(let g=0;g<$;g++)c[w+g]=h}function y(c,w,$="0"){for(;c.length<w;)c=$+c;return c}function R(c,w=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),w/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const $=w.length;if($===0)return;const h=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=w.charCodeAt(0),t=0);;){let n=r;if(O.$of(r))if(t+1<$){const s=w.charCodeAt(t+1);O.$pf(s)?(t++,n=O.$qf(r,s)):n=65533}else{i=r;break}else O.$pf(r)&&(n=65533);if(g=this.w(h,g,n),t++,t<$)r=w.charCodeAt(t);else break}this.r=g,this.u=i}w(w,$,h){return h<128?w[$++]=h:h<2048?(w[$++]=192|(h&1984)>>>6,w[$++]=128|(h&63)>>>0):h<65536?(w[$++]=224|(h&61440)>>>12,w[$++]=128|(h&4032)>>>6,w[$++]=128|(h&63)>>>0):(w[$++]=240|(h&1835008)>>>18,w[$++]=128|(h&258048)>>>12,w[$++]=128|(h&4032)>>>6,w[$++]=128|(h&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,w[0]=w[64],w[1]=w[65],w[2]=w[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=m.g,$=this.q;for(let l=0;l<64;l+=4)w.setUint32(l,$.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)w.setUint32(l,d(w.getUint32(l-12,!1)^w.getUint32(l-32,!1)^w.getUint32(l-56,!1)^w.getUint32(l-64,!1),1),!1);let h=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(h,5)+n+t+s+w.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$aj=m}),define(se[54],re([0,1,30]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(j||(j={})),function(k){const A="error",D="warning",E="warn",u="info",a="ignore";function b(d){return d?O.$kf(A,d)?k.Error:O.$kf(D,d)||O.$kf(E,d)?k.Warning:O.$kf(u,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function v(d){switch(d){case k.Error:return A;case k.Warning:return D;case k.Info:return u;default:return a}}k.toString=v}(j||(j={})),e.default=j}),define(se[27],re([0,1,3]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=j,e.$Nn=k,e.$On=D,e.$Pn=u,e.$Qn=a,e.$Rn=b,e.$Sn=v,e.$Tn=d,e.$Un=p,e.$Vn=y,e.$Wn=R,e.$Xn=m;function j(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const w=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,h])=>{w[$]=h&&typeof h=="object"?j(h):h}),w}function k(c){if(!c||typeof c!="object")return c;const w=[c];for(;w.length>0;){const $=w.shift();Object.freeze($);for(const h in $)if(A.call($,h)){const g=$[h];typeof g=="object"&&!Object.isFrozen(g)&&!(0,O.$Wf)(g)&&w.push(g)}}return c}const A=Object.prototype.hasOwnProperty;function D(c,w){return E(c,w,new Set)}function E(c,w,$){if((0,O.$3f)(c))return c;const h=w(c);if(typeof h<"u")return h;if(Array.isArray(c)){const g=[];for(const i of c)g.push(E(i,w,$));return g}if((0,O.$Vf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const g={};for(const i in c)A.call(c,i)&&(g[i]=E(c[i],w,$));return $.delete(c),g}return c}function u(c,w,$=!0){return(0,O.$Vf)(c)?((0,O.$Vf)(w)&&Object.keys(w).forEach(h=>{h in c?$&&((0,O.$Vf)(c[h])&&(0,O.$Vf)(w[h])?u(c[h],w[h],$):c[h]=w[h]):c[h]=w[h]}),c):w}function a(c,w){if(c===w)return!0;if(c==null||w===null||w===void 0||typeof c!=typeof w||typeof c!="object"||Array.isArray(c)!==Array.isArray(w))return!1;let $,h;if(Array.isArray(c)){if(c.length!==w.length)return!1;for($=0;$<c.length;$++)if(!a(c[$],w[$]))return!1}else{const g=[];for(h in c)g.push(h);g.sort();const i=[];for(h in w)i.push(h);if(i.sort(),!a(g,i))return!1;for($=0;$<g.length;$++)if(!a(c[g[$]],w[g[$]]))return!1}return!0}function b(c){const w=new Set;return JSON.stringify(c,($,h)=>{if((0,O.$Vf)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}function v(c,w){const $=Object.create(null);return!c||!w||Object.keys(w).forEach(g=>{const i=c[g],r=w[g];a(i,r)||($[g]=r)}),$}function d(c,w){const $=w.toLowerCase(),h=Object.keys(c).find(g=>g.toLowerCase()===$);return h?c[h]:c[w]}function p(c,w){const $=Object.create(null);for(const[h,g]of Object.entries(c))w(h,g)&&($[h]=g);return $}function y(c){let w=[];for(;Object.prototype!==c;)w=w.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return w}function R(c){const w=[];for(const $ of y(c))typeof c[$]=="function"&&w.push($);return w}function m(c,w){const $=g=>function(){const i=Array.prototype.slice.call(arguments,0);return w(g,i)},h={};for(const g of c)h[g]=$(g);return h}}),define(se[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=void 0,e.$Bg=j;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(k){return O.test(k)}e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,a="";return a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a}}()}),define(se[76],re([0,1,33]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=A;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const E=D.replace(/\-/g,":").toLowerCase();return!j.has(E)}function A(){const D=(0,O.networkInterfaces)();for(const E in D){const u=D[E];if(u){for(const{mac:a}of u)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[77],re([6,4]),function(J,e){return J.create("vs/base/common/date",e)}),define(se[78],re([0,1,77]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=a,e.$Mm=b,e.$Nm=v;const j=60,k=j*60,A=k*24,D=A*7,E=A*30,u=A*365;function a(d,p,y,R){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return(0,O.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!R&&m<30)return(0,O.localize)(1,null);let c;return m<j?(c=m,p?c===1?y?(0,O.localize)(2,null,c):(0,O.localize)(3,null,c):y?(0,O.localize)(4,null,c):(0,O.localize)(5,null,c):c===1?y?(0,O.localize)(6,null,c):(0,O.localize)(7,null,c):y?(0,O.localize)(8,null,c):(0,O.localize)(9,null,c)):m<k?(c=Math.floor(m/j),p?c===1?y?(0,O.localize)(10,null,c):(0,O.localize)(11,null,c):y?(0,O.localize)(12,null,c):(0,O.localize)(13,null,c):c===1?y?(0,O.localize)(14,null,c):(0,O.localize)(15,null,c):y?(0,O.localize)(16,null,c):(0,O.localize)(17,null,c)):m<A?(c=Math.floor(m/k),p?c===1?y?(0,O.localize)(18,null,c):(0,O.localize)(19,null,c):y?(0,O.localize)(20,null,c):(0,O.localize)(21,null,c):c===1?y?(0,O.localize)(22,null,c):(0,O.localize)(23,null,c):y?(0,O.localize)(24,null,c):(0,O.localize)(25,null,c)):m<D?(c=Math.floor(m/A),p?c===1?(0,O.localize)(26,null,c):(0,O.localize)(27,null,c):c===1?(0,O.localize)(28,null,c):(0,O.localize)(29,null,c)):m<E?(c=Math.floor(m/D),p?c===1?y?(0,O.localize)(30,null,c):(0,O.localize)(31,null,c):y?(0,O.localize)(32,null,c):(0,O.localize)(33,null,c):c===1?y?(0,O.localize)(34,null,c):(0,O.localize)(35,null,c):y?(0,O.localize)(36,null,c):(0,O.localize)(37,null,c)):m<u?(c=Math.floor(m/E),p?c===1?y?(0,O.localize)(38,null,c):(0,O.localize)(39,null,c):y?(0,O.localize)(40,null,c):(0,O.localize)(41,null,c):c===1?y?(0,O.localize)(42,null,c):(0,O.localize)(43,null,c):y?(0,O.localize)(44,null,c):(0,O.localize)(45,null,c)):(c=Math.floor(m/u),p?c===1?y?(0,O.localize)(46,null,c):(0,O.localize)(47,null,c):y?(0,O.localize)(48,null,c):(0,O.localize)(49,null,c):c===1?y?(0,O.localize)(50,null,c):(0,O.localize)(51,null,c):y?(0,O.localize)(52,null,c):(0,O.localize)(53,null,c))}function b(d,p){const y=Math.abs(d/1e3);return y<1?p?(0,O.localize)(54,null,d):(0,O.localize)(55,null,d):y<j?p?(0,O.localize)(56,null,Math.round(d)/1e3):(0,O.localize)(57,null,Math.round(d)/1e3):y<k?p?(0,O.localize)(58,null,Math.round(d/(1e3*j))):(0,O.localize)(59,null,Math.round(d/(1e3*j))):y<A?p?(0,O.localize)(60,null,Math.round(d/(1e3*k))):(0,O.localize)(61,null,Math.round(d/(1e3*k))):(0,O.localize)(62,null,Math.round(d/(1e3*A)))}function v(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[79],re([6,4]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(se[34],re([0,1,19,3,79]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=u,e.$5i=a,e.$6i=b;function A(v,d){return d&&(v.stack||v.stacktrace)?k.localize(0,null,E(v),D(v.stack)||D(v.stacktrace)):E(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function E(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function u(v=null,d=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const p=O.$Hb(v),y=u(p[0],d);return p.length>1?k.localize(4,null,y,p.length):y}if(j.$Tf(v))return v;if(v.detail){const p=v.detail;if(p.error)return A(p.error,d);if(p.exception)return A(p.exception,d)}return v.stack?A(v,d):v.message?v.message:k.localize(5,null)}function a(v){const d=v;return d instanceof Error&&Array.isArray(d.actions)}function b(v,d){let p;return typeof v=="string"?p=new Error(v):p=v,p.actions=d,p}}),define(se[80],re([6,4]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(se[81],re([0,1,80]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=j;function j(k){switch(k){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}}),define(se[55],re([0,1,12]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$9l=A,e.$0l=D;var j;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(j||(e.Source=j={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(E,...u){const a=u.reduce((d,p)=>(d[p]=!0,d),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(d=>!a[d]).forEach(d=>{for(let p=0;p<b.length;p++)if(d.search(b[p])!==-1){delete E[d];break}})}function D(E){E&&(delete E.DEBUG,O.$j&&delete E.DYLD_LIBRARY_PATH,O.$k&&delete E.LD_PRELOAD)}}),define(se[82],re([0,1,11]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=j,e.$Dq=k,e.$Eq=A,e.log=E;function j(a){const b=a;return b&&typeof b.type=="string"&&typeof b.severity=="string"}function k(a){const b=[];let v;try{const d=JSON.parse(a.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),v=p.__$stack),b.push(...d)}catch{b.push("Unable to log remote console arguments",a.arguments)}return{args:b,stack:v}}function A(a){if(typeof a!="string")return A(k(a).stack);const b=a;if(b){const v=D(b),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function D(a){if(!a)return a;const b=a.indexOf(`
`);return b===-1?a:a.substring(0,b)}function E(a,b){const{args:v,stack:d}=k(a),p=typeof v[0]=="string"&&v.length===1;let y=D(d);y&&(y=`(${y.trim()})`);let R=[];if(typeof v[0]=="string"?y&&p?R=[`%c[${b}] %c${v[0]} %c${y}`,u("blue"),u(""),u("grey")]:R=[`%c[${b}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:R=[`%c[${b}]%`,u("blue"),...v],y&&!p&&R.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function u(a){return`color: ${a}`}}),define(se[47],re([0,1,14,11]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=k,e.$Oh=A,e.$Ph=E;function k(u){return JSON.stringify(u,D)}function A(u){let a=JSON.parse(u);return a=E(a),a}function D(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return j.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof O.$te||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=E(u[b],a+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=E(u[b],a+1))}return u}}),define(se[83],re([0,1,70,15,12,11]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=b;class D{constructor(d,p,y){this.id=d,this.dependencies=p,this.callback=y}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,p,y)=>{typeof d!="string"&&(y=p,p=d,d=null),(typeof p!="object"||!Array.isArray(p))&&(y=p,p=null),this.c.push(new D(d,p,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const p=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!p)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(d){return new Promise((p,y)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const m=()=>{R.removeEventListener("load",c),R.removeEventListener("error",w)},c=$=>{m(),p(this.c.pop())},w=$=>{m(),y($)};R.addEventListener("load",c),R.addEventListener("error",w),this.f&&(d=this.f.createScriptURL(d)),R.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(d){return new Promise((p,y)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),p(this.c.pop())}catch(R){y(R)}})}async j(d){try{const p=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,c=p.readFileSync(m).toString(),w=R.wrap(c.replace(/^#!.*/,""));return new y.Script(w).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function b(v,d,p){if(O.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const y=`${v}/${d}`;if(u.has(y))return u.get(y);let R;if(/^\w[\w\d+.-]*:\/\//.test(y))R=y;else{const $=`${p&&!k.$o?j.$xg:j.$wg}/${y}`;R=j.$Ag.asBrowserUri($).toString(!0)}const m=E.INSTANCE.load(R);return u.set(y,m),m}else return await new Promise((y,R)=>{J([v],y,R)})}}),define(se[84],re([0,1,33,48,28,76,12]),function(J,e,O,j,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=void 0,e.$pn=u,e.$qn=v,e.$on=new class{c(d){return this.a||(this.a=j.$mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,p=0;const y=(0,O.networkInterfaces)();for(const R in y){const m=y[R];if(m)for(const{mac:c,internal:w}of m)w||(p+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=p>0?d/p:0}return this.b}};let E;async function u(d){return E||(E=(async()=>await a(d)||k.$Cg())()),E}async function a(d){try{const p=await new Promise((R,m)=>{J(["crypto"],R,m)}),y=(0,A.$nn)();return p.createHash("sha256").update(y,"utf8").digest("hex")}catch(p){d(p);return}}const b="Software\\Microsoft\\SQMClient";async function v(d){if(D.$i){const p=await new Promise((y,R)=>{J(["@vscode/windows-registry"],y,R)});try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(y){return d(y),""}}return""}}),define(se[85],re([0,1,33,16,24]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=w,e.$8l=$;const A=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:h=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=j.$jc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await k.Promises.readdir(r)){let S=-1;if(g){const L=l.indexOf("-");if(L<0)continue;const T=l.substring(0,L);if(!A.test(T)||l.substring(L+1)!=="preview")continue;S=parseInt(T,10)}else{if(!A.test(l))continue;S=parseInt(l,10)}if(S<=t)continue;const I=j.$jc(r,l,"pwsh.exe");await k.SymlinkSupport.existsFile(I)&&(n=I,t=S)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new v(n,`PowerShell${o}${s}`,!0)}async function y({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const g=j.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(g))if(i.test(t)){const n=j.$jc(g,t,"pwsh.exe");return new v(n,r)}return null}function R(){const h=j.$jc(O.homedir(),".dotnet","tools","pwsh.exe");return new v(h,".NET Core PowerShell Global Tool")}function m(){const h=j.$jc(process.env.windir,a===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(h,"Windows PowerShell",!0)}async function*c(){let h=await p();h&&(yield h),h=await p({useAlternateBitness:!0}),h&&(yield h),h=await y(),h&&(yield h),h=R(),h&&(yield h),h=await p({findPreview:!0}),h&&(yield h),h=await y({findPreview:!0}),h&&(yield h),h=await p({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*w(){for await(const h of c())await h.exists()&&(yield h)}async function $(){for await(const h of w())return h;return null}}),define(se[56],re([0,1,16,12,35,55,3,24]),function(J,e,O,j,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$$l=u,e.$_l=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(v=k.env){return v.comspec||"cmd.exe"}function a(v){let d=[],p=!1;const y=function(R){if(p){d.push(R);return}(!v.send(R,c=>{if(c&&console.error(c),p=!1,d.length>0){const w=d.slice(0);d=[],w.forEach($=>y($))}})||j.$i)&&(p=!0)};return{send:y}}var b;(function(v){async function d(p,y,R){if(O.$ic(p))return p;if(y===void 0&&(y=k.cwd()),O.$mc(p)!=="."||(R===void 0&&D.$Tf(k.env.PATH)&&(R=k.env.PATH.split(O.$tc)),R===void 0||R.length===0))return O.$jc(y,p);async function c(w){if(await E.Promises.exists(w)){let $;try{$=await E.Promises.stat(w)}catch(h){h.message.startsWith("EACCES")&&($=await E.Promises.lstat(w))}return $?!$.isDirectory():!1}return!1}for(const w of R){let $;if(O.$ic(w)?$=O.$jc(w,p):$=O.$jc(y,w,p),await c($))return $;let h=$+".com";if(await c(h)||(h=$+".exe",await c(h)))return h}return O.$jc(y,p)}v.findExecutable=d})(b||(e.win32=b={}))}),define(se[86],re([0,1,33,12,85,56]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=D;async function D(v,d){return v===1?j.$i?b():A.$$l(d):u(v,d)}let E=null;function u(v,d){if(j.$k&&v===2||j.$j&&v===3)return"/bin/bash";if(!E){let p;if(j.$i)p="/bin/bash";else{if(p=d.SHELL,!p)try{p=(0,O.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}E=p}return E}let a=null;async function b(){return a||(a=(await(0,k.$8l)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,O,j){var k=arguments.length,A=k<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,O):j,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,O,j);else for(var E=J.length-1;E>=0;E--)(D=J[E])&&(A=(k<3?D(A):k>3?D(e,O,A):D(e,O))||A);return k>3&&A&&Object.defineProperty(e,O,A),A};define(se[57],re([0,1,19,9,14,20,53,8,7,2,47,30,3]),function(J,e,O,j,k,A,D,E,u,a,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Rh=e.$Qh=void 0,e.$Sh=o,e.$Th=l,e.$Yh=V,e.$Zh=Q;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p||(p={}));function y(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(R||(R={}));function m(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(c||(c={}));function w(q){let F=0;for(let H=0;;H+=7){const Z=q.read(1);if(F|=(Z.buffer[0]&127)<<H,!(Z.buffer[0]&128))return F}}const $=t(0);function h(q,F){if(F===0){q.write($);return}let H=0;for(let K=F;K!==0;K=K>>>7)H++;const Z=k.$te.alloc(H);for(let K=0;F!==0;K++)Z.buffer[K]=F&127,F=F>>>7,F>0&&(Z.buffer[K]|=128);q.write(Z)}class g{constructor(F){this.b=F,this.a=0}read(F){const H=this.b.slice(this.a,this.a+F);return this.a+=H.byteLength,H}}e.$Qh=g;class i{constructor(){this.a=[]}get buffer(){return k.$te.concat(this.a)}write(F){this.a.push(F)}}e.$Rh=i;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const F=k.$te.alloc(1);return F.writeUInt8(q,0),F}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(q,F){if(typeof F>"u")q.write(n.Undefined);else if(typeof F=="string"){const H=k.$te.fromString(F);q.write(n.String),h(q,H.byteLength),q.write(H)}else if(s&&Buffer.isBuffer(F)){const H=k.$te.wrap(F);q.write(n.Buffer),h(q,H.byteLength),q.write(H)}else if(F instanceof k.$te)q.write(n.VSBuffer),h(q,F.byteLength),q.write(F);else if(Array.isArray(F)){q.write(n.Array),h(q,F.length);for(const H of F)o(q,H)}else if(typeof F=="number"&&(F|0)===F)q.write(n.Uint),h(q,F);else{const H=k.$te.fromString(JSON.stringify(F));q.write(n.Object),h(q,H.byteLength),q.write(H)}}function l(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(w(q)).toString();case r.Buffer:return q.read(w(q)).buffer;case r.VSBuffer:return q.read(w(q));case r.Array:{const H=w(q),Z=[];for(let K=0;K<H;K++)Z.push(l(q));return Z}case r.Object:return JSON.parse(q.read(w(q)).toString());case r.Int:return w(q)}}class S{constructor(F,H,Z=null,K=1e3){this.h=F,this.j=H,this.k=Z,this.l=K,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(F,H){this.b.set(F,H),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const H=this.o([F.type]);this.k?.logOutgoing(H,0,1,m(F.type));return}case 201:case 202:case 204:case 203:{const H=this.o([F.type,F.id],F.data);this.k?.logOutgoing(H,F.id,1,m(F.type),F.data);return}}}o(F,H=void 0){const Z=new i;return o(Z,F),o(Z,H),this.p(Z.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const H=new g(F),Z=l(H),K=l(H),_=Z[0];switch(_){case 100:return this.k?.logIncoming(F.byteLength,Z[1],1,`${y(_)}: ${Z[2]}.${Z[3]}`,K),this.s({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:K});case 102:return this.k?.logIncoming(F.byteLength,Z[1],1,`${y(_)}: ${Z[2]}.${Z[3]}`,K),this.t({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:K});case 101:return this.k?.logIncoming(F.byteLength,Z[1],1,`${y(_)}`),this.u({type:_,id:Z[1]});case 103:return this.k?.logIncoming(F.byteLength,Z[1],1,`${y(_)}`),this.u({type:_,id:Z[1]})}}s(F){const H=this.b.get(F.channelName);if(!H){this.v(F);return}const Z=new A.$de;let K;try{K=H.call(this.j,F.name,F.arg,Z.token)}catch(M){K=Promise.reject(M)}const _=F.id;K.then(M=>{this.m({id:_,data:M,type:201})},M=>{M instanceof Error?this.m({id:_,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:_,data:M,type:203})}).finally(()=>{U.dispose(),this.d.delete(F.id)});const U=(0,a.$Rc)(()=>Z.cancel());this.d.set(F.id,U)}t(F){const H=this.b.get(F.channelName);if(!H){this.v(F);return}const Z=F.id,_=H.listen(this.j,F.name,F.arg)(U=>this.m({id:Z,data:U,type:204}));this.d.set(F.id,_)}u(F){const H=this.d.get(F.id);H&&(H.dispose(),this.d.delete(F.id))}v(F){let H=this.g.get(F.channelName);H||(H=[],this.g.set(F.channelName,H));const Z=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:F,timeoutTimer:Z})}w(F){const H=this.g.get(F);if(H){for(const Z of H)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=S;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class L{constructor(F,H=null){this.l=F,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=H}getChannel(F){const H=this;return{call(Z,K,_){return H.a?Promise.reject(new E.$5):H.m(F,Z,K,_)},listen(Z,K){return H.a?u.Event.None:H.o(F,Z,K)}}}m(F,H,Z,K=A.CancellationToken.None){const _=this.g++,M={id:_,type:100,channelName:F,name:H,arg:Z};if(K.isCancellationRequested)return Promise.reject(new E.$5);let f;return new Promise((N,C)=>{if(K.isCancellationRequested)return C(new E.$5);const W=()=>{const le=pe=>{switch(pe.type){case 201:this.f.delete(_),N(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,C(ye);break}case 203:this.f.delete(_),C(pe.data);break}};this.f.set(_,le),this.p(M)};let G=null;this.b===c.Idle?W():(G=(0,j.$6g)(le=>this.u()),G.then(()=>{G=null,W()}));const ie=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),C(new E.$5)},ae=K.onCancellationRequested(ie);f=(0,a.$Qc)((0,a.$Rc)(ie),ae),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(F,H,Z){const K=this.g++,U={id:K,type:102,channelName:F,name:H,arg:Z};let M=null;const f=new u.$6d({onWillAddFirstListener:()=>{M=(0,j.$6g)(N=>this.u()),M.then(()=>{M=null,this.d.add(f),this.p(U)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(f),this.p({id:K,type:103}))}}),P=N=>f.fire(N.data);return this.f.set(K,P),f.event}p(F){switch(F.type){case 100:case 102:{const H=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(H,F.id,0,`${y(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const H=this.q([F.type,F.id]);this.j?.logOutgoing(H,F.id,0,y(F.type));return}}}q(F,H=void 0){const Z=new i;return o(Z,F),o(Z,H),this.r(Z.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const H=new g(F),Z=l(H),K=l(H),_=Z[0];switch(_){case 200:return this.j?.logIncoming(F.byteLength,0,0,m(_)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,Z[1],0,m(_),K),this.t({type:Z[0],id:Z[1],data:K})}}t(F){if(F.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=L,$e([D.$Kh],L.prototype,"onDidInitializePromise",null);class T{get connections(){const F=[];return this.f.forEach(H=>F.push(H)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new u.$6d,this.onDidAddConnection=this.g.event,this.h=new u.$6d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(F(({protocol:H,onDidClientDisconnect:Z})=>{const K=u.Event.once(H.onMessage);this.j.add(K(_=>{const U=new g(_),M=l(U),f=new S(H,M),P=new L(H);this.a.forEach((C,W)=>f.registerChannel(W,C));const N={channelServer:f,channelClient:P,ctx:M};this.f.add(N),this.g.fire(N),this.j.add(Z(()=>{f.dispose(),P.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(F,H){const Z=this;return{call(K,_,U){let M;if((0,d.$8f)(H)){const P=(0,O.$4b)(Z.connections.filter(H));M=P?Promise.resolve(P):u.Event.toPromise(u.Event.filter(Z.onDidAddConnection,H))}else M=H.routeCall(Z,K,_);const f=M.then(P=>P.channelClient.getChannel(F));return V(f).call(K,_,U)},listen(K,_){if((0,d.$8f)(H))return Z.k(F,H,K,_);const U=H.routeEvent(Z,K,_).then(M=>M.channelClient.getChannel(F));return V(U).listen(K,_)}}}k(F,H,Z,K){const _=this;let U;const M=new u.$6d({onWillAddFirstListener:()=>{U=new a.$Sc;const f=new u.$_d,P=new Map,N=W=>{const ie=W.channelClient.getChannel(F).listen(Z,K),ae=f.add(ie);P.set(W,ae)},C=W=>{const G=P.get(W);G&&(G.dispose(),P.delete(W))};_.connections.filter(H).forEach(N),u.Event.filter(_.onDidAddConnection,H)(N,void 0,U),_.onDidRemoveConnection(C,void 0,U),f.event(M.fire,M,U),U.add(f)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return M.event}registerChannel(F,H){this.a.set(F,H);for(const Z of this.f)Z.channelServer.registerChannel(F,H)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=T;class z{constructor(F,H,Z=null){const K=new i;o(K,H),F.send(K.buffer),this.a=new L(F,Z),this.d=new S(F,H,Z)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,H){this.d.registerChannel(F,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=z;function V(q){return{call(F,H,Z){return q.then(K=>K.call(F,H,Z))},listen(F,H){const Z=new u.$ce;return q.then(K=>Z.input=K.listen(F,H)),Z.event}}}function Q(q){let F=!1;return{call(H,Z,K){return F?q.call(H,Z,K):(0,j.$hh)(0).then(()=>F=!0).then(()=>q.call(H,Z,K))},listen(H,Z){if(F)return q.listen(H,Z);const K=new u.$ce;return(0,j.$hh)(0).then(()=>F=!0).then(()=>K.input=q.listen(H,Z)),K.event}}}class ne{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const H of F.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$1h=ne;var te;(function(q){function F(_,U,M){const f=_,P=M&&M.disableMarshalling,N=new Map;for(const C in f)Z(C)&&N.set(C,u.Event.buffer(f[C],!0,void 0,U));return new class{listen(C,W,G){const ie=N.get(W);if(ie)return ie;const ae=f[W];if(typeof ae=="function"){if(K(W))return ae.call(f,G);if(Z(W))return N.set(W,u.Event.buffer(f[W],!0,void 0,U)),N.get(W)}throw new E.$bb(`Event not found: ${W}`)}call(C,W,G){const ie=f[W];if(typeof ie=="function"){if(!P&&Array.isArray(G))for(let le=0;le<G.length;le++)G[le]=(0,b.$Ph)(G[le]);let ae=ie.apply(f,G);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${W}`)}}}q.fromService=F;function H(_,U){const M=U&&U.disableMarshalling;return new Proxy({},{get(f,P){if(typeof P=="string")return U?.properties?.has(P)?U.properties.get(P):K(P)?function(N){return _.listen(P,N)}:Z(P)?_.listen(P):async function(...N){let C;U&&!(0,d.$3f)(U.context)?C=[U.context,...N]:C=N;const W=await _.call(P,C);return M?W:(0,b.$Ph)(W)};throw new E.$bb(`Property not found: ${String(P)}`)}})}q.toService=H;function Z(_){return _[0]==="o"&&_[1]==="n"&&v.$jf(_.charCodeAt(2))}function K(_){return/^onDynamic/.test(_)&&v.$jf(_.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const F=q.toString();if(F!=="[object Object]")return F}return q}function ce(q){return Array.isArray(q)?q.map(fe):fe(q)}function B(q,F,H,Z,K,_,U){U=ce(U);const M=ue[K],f=M[Z%M.length];let P=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(P=P.concat(U),P.push(")")):P.push(U),console.log.apply(console,P)}class X{constructor(F,H){this.d=F,this.f=H,this.a=0,this.b=0}logOutgoing(F,H,Z,K,_){this.b+=F,B(this.d,this.b,F,H,Z,K,_)}logIncoming(F,H,Z,K,_){this.a+=F,B(this.f,this.a,F,H,Z,K,_)}}e.$2h=X}),define(se[87],re([0,1,58,9,14,20,82,8,7,2,27,56,55,57]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;class y extends p.$Uh{constructor(c){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",w=>k.$te.wrap(Buffer.from(w,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Gq=y;class R{constructor(c,w){this.i=c,this.j=w,this.c=new Set,this.g=new Map,this.h=new u.$6d,this.onDidProcessExit=this.h.event;const $=w&&w.timeout?w.timeout:6e4;this.b=new j.$dh($),this.d=null,this.f=null}getChannel(c){const w=this;return{call($,h,g){return w.k(c,$,h,g)},listen($,h){return w.l(c,$,h)}}}k(c,w,$,h=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const g=this.n(c),i=(0,j.$6g)(n=>g.call(w,$,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,w,$){if(!this.b)return u.Event.None;this.b.cancel();let h;const g=new u.$6d({onWillAddFirstListener:()=>{h=this.n(c).listen(w,$)(g.fire,g),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,b.$Mn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$0l)(w.env),this.d=(0,O.fork)(this.i,c,w);const $=new u.$6d;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,D.$Cq)(s)){(0,D.log)(s,`IPC Library: ${this.j.serverName}`);return}$.fire(k.$te.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,v.$_l)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=$.event,t={send:i,onMessage:r};this.f=new p.$Vh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let w=this.g.get(c);return w||(w=this.m.getChannel(c),this.g.set(c,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hq=R}),define(se[88],re([0,1,9,7,2,47,3]),function(J,e,O,j,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.StorageState=e.StorageHint=void 0,e.$Fp=u;var E;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(d){const p=d;return p?.changed instanceof Map||p?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class b extends k.$Tc{static{this.a=100}constructor(p,y=Object.create(null)){super(),this.r=p,this.s=y,this.b=this.B(new j.$9d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new O.$eh(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((y,R)=>this.w(R,y)),p.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(p,y){if(this.c===a.Closed)return;let R=!1;(0,D.$3f)(y)?R=this.f.delete(p):this.f.get(p)!==y&&(this.f.set(p,y),R=!0),R&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,y){const R=this.f.get(p);return(0,D.$3f)(R)?y:R}getBoolean(p,y){const R=this.get(p);return(0,D.$3f)(R)?y:R==="true"}getNumber(p,y){const R=this.get(p);return(0,D.$3f)(R)?y:parseInt(R,10)}getObject(p,y){const R=this.get(p);return(0,D.$3f)(R)?y:(0,A.$Oh)(R)}async set(p,y,R=!1){if(this.c===a.Closed)return;if((0,D.$3f)(y))return this.delete(p,R);const m=(0,D.$Vf)(y)||Array.isArray(y)?(0,A.$Nh)(y):String(y);if(this.f.get(p)!==m)return this.f.set(p,m),this.j.set(p,m),this.h.delete(p),this.b.fire({key:p,external:R}),this.D()}async delete(p,y=!1){if(!(this.c===a.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(this.z)return this.D(p)}async D(p){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Gp=b;class v{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((y,R)=>this.a.set(R,y)),p.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Hp=v}),define(se[89],re([6,4]),function(J,e){return J.create("vs/base/node/zip",e)}),define(se[49],re([0,1,90,9,16,3,24,89]),function(J,e,O,j,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0,e.zip=m,e.$5p=c,e.$6p=$,e.$2p="end of central directory record signature not found";const u=new RegExp(e.$2p);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$3p=a;function b(h){const g=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function v(h){if(h instanceof a)return h;let g;return u.test(h.message)&&(g="CorruptZip"),new a(g,h)}function d(h,g,i,r,t,n){const s=k.$mc(g),o=k.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,g)));const l=k.$jc(r,g);let S;return n.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(D.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,L)=>{if(!n.isCancellationRequested)try{S=(0,O.createWriteStream)(l,{mode:i}),S.once("close",()=>I()),S.once("error",L),h.once("error",L),h.pipe(S)}catch(T){L(T)}}))}function p(h,g,i,r){let t=(0,j.$6g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const S=new j.$bh,I=L=>{L.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(E.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",L=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(L.fileName)){I(r);return}const T=L.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(T)){const Q=k.$jc(g,T);t=(0,j.$6g)(ne=>D.Promises.mkdir(Q,{recursive:!0}).then(()=>I(ne)).then(void 0,l));return}const z=R(h,L),V=b(L);t=(0,j.$6g)(Q=>S.queue(()=>z.then(ne=>d(ne,T,V,g,i,Q).then(()=>I(Q)))).then(null,l))})}).finally(()=>s.dispose())}async function y(h,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(v(n)):r((0,A.$5f)(s))})})}function R(h,g){return new Promise((i,r)=>{h.openReadStream(g,(t,n)=>{t?r(v(t)):i((0,A.$5f)(n))})})}async function m(h,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,O.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}function c(h,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=y(h,!0);return i.overwrite&&(n=n.then(s=>D.Promises.rm(g).then(()=>s))),n.then(s=>p(s,g,{sourcePathRegex:t},r))}function w(h,g){return y(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&R(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(E.localize(2,null,g))))}))}function $(h,g){return w(h,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}}),define(se[91],re([6,4]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[92],re([6,4]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(se[93],re([6,4]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(se[94],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[95],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[96],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(se[97],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[98],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[99],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[100],re([6,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[101],re([6,4]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[102],re([6,4]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(se[103],re([6,4]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(se[104],re([6,4]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[105],re([6,4]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[106],re([6,4]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(se[107],re([6,4]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(se[108],re([6,4]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(se[109],re([6,4]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[110],re([6,4]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[111],re([6,4]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(se[112],re([0,1,8,93]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...a){switch(a.length){case 1:return(0,j.localize)(0,null,a[0]);case 2:return(0,j.localize)(1,null,a[0],a[1]);case 3:return(0,j.localize)(2,null,a[0],a[1],a[2]);default:return}}const D=(0,j.localize)(3,null),E=(0,j.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const v=this.d,d=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:d};this.g.push({offset:v,lexeme:d,additionalInfo:b}),this.f.push(p)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const v=this.c.substring(this.d,this.e),d=u.b.get(v);d?this.k(d):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,v=!1,d=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(E);return}const y=this.c.charCodeAt(b);if(v)v=!1;else if(y===47&&!d){b++;break}else y===91?d=!0:y===92?v=!0:y===93&&(d=!1);b++}for(;b<this.c.length&&u.a.has(this.c.charCodeAt(b));)b++;this.e=b;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=u}),define(se[113],re([0,1,78,53,15,16,35,17,11]),function(J,e,O,j,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Qm=b,e.$Rm=v,e.$Om=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.$mc)(k.$Ag.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,O.$Nm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",p)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Tg)(u.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=D.env.VSCODE_PORTABLE;return p?u.URI.file((0,A.$jc)(p,"argv.json")):(0,E.$Tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,A.$kc)(p):(0,A.$hc)((0,A.$jc)(k.$Ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?u.URI.file((0,A.$kc)(p)):u.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,A.$kc)(p);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const R=D.env.VSCODE_PORTABLE;return R?(0,A.$jc)(R,"extensions"):(0,E.$Tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(y=>/^[^:/?#]+?:\/\//.test(y)?u.URI.parse(y):u.URI.file((0,A.$hc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?u.URI.parse(p):u.URI.file((0,A.$hc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$Om.test(p))}get extensionLogLevel(){const p=[];for(const y of this.args.log||[]){const R=e.$Om.exec(y);R&&R[1]&&R[2]&&p.push([R[1],R[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,E.$Tg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=D.env.VSCODE_PORTABLE;return p?u.URI.file((0,A.$jc)(p,"policy.json")):(0,E.$Tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,y,R){this.a=p,this.b=y,this.c=R,this.editSessionId=this.args.editSessionId}}e.$Pm=a,$e([j.$Kh],a.prototype,"appRoot",null),$e([j.$Kh],a.prototype,"userHome",null),$e([j.$Kh],a.prototype,"userDataPath",null),$e([j.$Kh],a.prototype,"appSettingsHome",null),$e([j.$Kh],a.prototype,"tmpDir",null),$e([j.$Kh],a.prototype,"cacheHome",null),$e([j.$Kh],a.prototype,"stateResource",null),$e([j.$Kh],a.prototype,"userRoamingDataHome",null),$e([j.$Kh],a.prototype,"userDataSyncHome",null),$e([j.$Kh],a.prototype,"sync",null),$e([j.$Kh],a.prototype,"machineSettingsResource",null),$e([j.$Kh],a.prototype,"workspaceStorageHome",null),$e([j.$Kh],a.prototype,"localHistoryHome",null),$e([j.$Kh],a.prototype,"keyboardLayoutResource",null),$e([j.$Kh],a.prototype,"argvResource",null),$e([j.$Kh],a.prototype,"isExtensionDevelopment",null),$e([j.$Kh],a.prototype,"untitledWorkspacesHome",null),$e([j.$Kh],a.prototype,"builtinExtensionsPath",null),$e([j.$Kh],a.prototype,"extensionsPath",null),$e([j.$Kh],a.prototype,"extensionDevelopmentLocationURI",null),$e([j.$Kh],a.prototype,"extensionDevelopmentKind",null),$e([j.$Kh],a.prototype,"extensionTestsLocationURI",null),$e([j.$Kh],a.prototype,"debugExtensionHost",null),$e([j.$Kh],a.prototype,"logLevel",null),$e([j.$Kh],a.prototype,"extensionLogLevel",null),$e([j.$Kh],a.prototype,"serviceMachineIdResource",null),$e([j.$Kh],a.prototype,"disableTelemetry",null),$e([j.$Kh],a.prototype,"disableWorkspaceTrust",null),$e([j.$Kh],a.prototype,"useInMemorySecretStorage",null),$e([j.$Kh],a.prototype,"policyFile",null);function b(d,p){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,p,d.debugId,d.extensionEnvironment)}function v(d,p,y,R,m,c){const $=Number(p||d)||(R?null:y),h=$?!!p:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:$,break:h,debugId:m,env:g}}}),function(){"use strict";function J(e,O,j){function k(D,E){const u=A(D,E),a=[u];return e.isAbsolute(u)||a.unshift(j),e.resolve(...a)}function A(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(O.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:k}}if(typeof define=="function")define(se[114],re([168,33,35]),function(e,O,j){return J(e,O,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=J(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[115],re([0,1,33,113,114]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Tm=D,e.$Um=E;class A extends j.$Pm{constructor(a,b){super(a,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,b.nameShort)},b)}}e.$Sm=A;function D(u,a){return(0,j.$Rm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function E(u,a){return(0,j.$Rm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(se[116],re([0,1,3,97]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=k;function k(D,E,u,a){try{A(D,E,u,a)}catch(b){D.error(b?.message??b)}return E}function A(D,E,u,a){const b=(v,d,p)=>{const y=v[d];if((0,O.$Tf)(y)){const R=y,m=R.length;if(m>1&&R[0]==="%"&&R[m-1]==="%"){const c=R.substr(1,m-2);let w=u[c];w===void 0&&a&&(w=a[c]);const $=typeof w=="string"?w:w?.message,h=a?.[c],g=typeof h=="string"?h:h?.message;if(!$){g||D.warn(`[${E.name}]: ${(0,j.localize)(0,null,c)}`);return}if(p&&(d==="title"||d==="category")&&g&&g!==$){const i={value:$,original:g};v[d]=i}else v[d]=$}}else if((0,O.$Vf)(y))for(const R in y)y.hasOwnProperty(R)&&(R==="commands"?b(y,R,!0):b(y,R,p));else if(Array.isArray(y))for(let R=0;R<y.length;R++)b(y,R,p)};for(const v in E)E.hasOwnProperty(v)&&b(E,v)}}),define(se[117],re([0,1,49,100]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=k;function k(A){return(0,O.$6p)(A,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,j.localize)(0,null))}})}}),define(se[50],re([0,1,17,54,101,44]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=u,e.$rp=a,e.$sp=b,e.$tp=v,e.$up=d,e.$vp=p,e.$wp=y;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||D.test(c)}function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=c.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function b(c){if(!c)return null;const w=c.majorBase,$=c.majorMustEqual,h=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(w===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=E.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:w,majorMustEqual:$,minorBase:h,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,w,$){let h;typeof c=="string"?h=b(a(c)):h=c;let g;w instanceof Date?g=w.getTime():typeof w=="string"&&(g=new Date(w).getTime());let i;if(typeof $=="string"?i=b(a($)):i=$,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const S=i.notBefore;let I=i.majorMustEqual,L=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<S?!1:n>=l:(r===1&&s===0&&(!I||!L||!T)&&(s=1,o=0,l=0,I=!0,L=!1,T=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!L:n<l?!1:n>l?!T:!(g&&g<S))}function d(c,w,$,h,g){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([j.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([j.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([j.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([j.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([j.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!m(h.extensionDependencies))return i.push([j.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!m(h.activationEvents))return i.push([j.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([j.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([j.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([j.default.Error,k.localize(9,null,"main")]),i;{const n=(0,O.$Tg)($,h.main);(0,O.$Ng)(n,$)||i.push([j.default.Warning,k.localize(10,null,n.path,$.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([j.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,O.$Tg)($,h.browser);(0,O.$Ng)(n,$)||i.push([j.default.Warning,k.localize(12,null,n.path,$.path)])}}if(!A.valid(h.version))return i.push([j.default.Error,k.localize(13,null)]),i;const r=[];if(!p(c,w,h,g,r))for(const n of r)i.push([j.default.Error,n]);return i}function p(c,w,$,h,g){return h||typeof $.main>"u"&&typeof $.browser>"u"?!0:R(c,w,$.engines.vscode,g)}function y(c,w,$){return c==="*"||R(w,$,c)}function R(c,w,$,h=[]){const g=b(a($));if(!g)return h.push(k.localize(14,null,$)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(k.localize(15,null,$)),!1}else if(!g.majorMustEqual)return h.push(k.localize(16,null,$)),!1;return v(c,w,g)?!0:(h.push(k.localize(17,null,c,$)),!1)}function m(c){if(!Array.isArray(c))return!1;for(let w=0,$=c.length;w<$;w++)if(typeof c[w]!="string")return!1;return!0}}),define(se[118],re([0,1,14,28]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=k;async function k(A,D,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const b=(await D.readFile(A.serviceMachineIdResource)).value.toString();u=(0,j.$Bg)(b)?b:null}catch{u=null}if(!u){u=(0,j.$Cg)();try{await D.writeFile(A.serviceMachineIdResource,O.$te.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}}),define(se[51],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class O{constructor(k,A=[],D=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.$di=O}),define(se[119],re([0,1,51]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$cs=A,e.$ds=D;const j=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(E,u,a){u instanceof O.$di||(u=new O.$di(u,[],!!a)),j.push([E,u])}function D(){return j}}),define(se[120],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class O{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Sq=O;class j{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const E=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(D);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const E of this.a.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let E=this.a.get(D);return E||(E=new O(D,A),this.a.set(D,E)),E}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,E]of this.a)A.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const E=new Set([A]),u=this.c(D,E);if(u)return u}}c(A,D){for(const[E,u]of A.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const a=this.c(u,D);if(a)return a;D.delete(E)}}}e.$Tq=j}),define(se[29],re([0,1,3,11,10]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Mi=void 0,e.$Ni=A,e.$Oi=D,e.$Pi=u,e.$Qi=a,e.$Ri=b,e.$Si=v,e.$Ti=d,e.$Ui=y,e.$Vi=R,e.$Wi=m,e.$Mi=(0,k.$gi)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof j.URI)}function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof j.URI)}var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function b(c,w){const $=Object.create(null);for(const h in c)v($,h,c[h],w);return $}function v(c,w,$,h){const g=w.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${w} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=$}catch{h(`Ignoring ${w} as ${g.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${w} as ${g.join(".")} is ${JSON.stringify(r)}`)}function d(c,w){const $=w.split(".");p(c,$)}function p(c,w){const $=w.shift();if(w.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const h=c[$];typeof h=="object"&&!Array.isArray(h)&&(p(h,w),Object.keys(h).length===0&&delete c[$])}}function y(c,w,$){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=w.split("."),i=h(c,g);return typeof i>"u"?$:i}function R(c,w,$){Object.keys(w).forEach(h=>{h!=="__proto__"&&(h in c?O.$Vf(c[h])&&O.$Vf(w[h])?R(c[h],w[h],$):$&&(c[h]=w[h]):c[h]=w[h])})}function m(c){return c.replace(/[\[\]]/g,"")}}),define(se[121],re([0,1,12,30,112,10,92,8]),function(J,e,O,j,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$ej=e.$dj=e.ContextKeyExprType=void 0,e.$cj=a,e.$fj=r,e.$gj=t,e.$zj=K;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",O.$j),u.set("isLinux",O.$k),u.set("isWindows",O.$i),u.set("isWeb",O.$o),u.set("isMacNative",O.$j&&!O.$o),u.set("isEdge",O.$H),u.set("isFirefox",O.$F),u.set("isChrome",O.$E),u.set("isSafari",O.$G);function a(M,f){if(u.get(M)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(M,f)}const b=Object.prototype.hasOwnProperty;var v;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const d={regexParsingWithErrorRecovery:!0},p=(0,D.localize)(0,null),y=(0,D.localize)(1,null),R=(0,D.localize)(2,null),m=(0,D.localize)(3,null),c=(0,D.localize)(4,null),w=(0,D.localize)(5,null),$=(0,D.localize)(6,null),h=(0,D.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new k.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const N=this.D(),C=N.type===17?w:void 0;throw this.h.push({message:c,offset:N.offset,lexeme:k.$bj.getLexeme(N),additionalInfo:C}),g.c}return P}catch(P){if(P!==g.c)throw P;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const P=this.o();f.push(P)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const P=this.s();f.push(P)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,m),P?.negate()}case 17:return this.z(),z.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const P=this.l();return this.A(1,m),P}case 17:{const P=f.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const W=C.lexeme,G=W.lastIndexOf("/"),ie=G===W.length-1?void 0:this.w(W.substring(G+1));let ae;try{ae=new RegExp(W.substring(1,G),ie)}catch{throw this.B("REGEX",C)}return fe.create(P,ae)}switch(C.type){case 10:case 19:{const W=[C.lexeme];this.z();let G=this.D(),ie=0;for(let he=0;he<C.lexeme.length;he++)C.lexeme.charCodeAt(he)===40?ie++:C.lexeme.charCodeAt(he)===41&&ie--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let he=0;he<G.lexeme.length;he++)G.lexeme.charCodeAt(he)===40?ie++:C.lexeme.charCodeAt(he)===41&&ie--}if(ie<0)break;W.push(k.$bj.getLexeme(G)),this.z(),G=this.D()}const ae=W.join(""),le=ae.lastIndexOf("/"),pe=le===ae.length-1?void 0:this.w(ae.substring(le+1));let ye;try{ye=new RegExp(ae.substring(1,le),pe)}catch{throw this.B("REGEX",C)}return i.regex(P,ye)}case 18:{const W=C.lexeme;this.z();let G=null;if(!(0,j.$Te)(W)){const ie=W.indexOf("/"),ae=W.lastIndexOf("/");if(ie!==ae&&ie>=0){const le=W.slice(ie+1,ae),pe=W[ae+1]==="i"?"i":"";try{G=new RegExp(le,pe)}catch{throw this.B("REGEX",C)}}}if(G===null)throw this.B("REGEX",C);return fe.create(P,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const C=this.u();return i.notIn(P,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return i.equals(P,C);switch(C){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return i.notEquals(P,C);switch(C){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,C)}}case 5:return this.z(),te.create(P,this.u());case 6:return this.z(),ue.create(P,this.u());case 7:return this.z(),Q.create(P,this.u());case 8:return this.z(),ne.create(P,this.u());case 13:return this.z(),i.in(P,this.u());default:return i.has(P)}}case 20:throw this.h.push({message:$,offset:f.offset,lexeme:"",additionalInfo:h}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,P){if(this.C(f))return this.z();throw this.B(P,this.D())}B(f,P,N){const C=(0,D.localize)(8,null,f,k.$bj.getLexeme(P)),W=P.offset,G=k.$bj.getLexeme(P);return this.h.push({message:C,offset:W,lexeme:G,additionalInfo:N}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,P){return S.create(f,P)}static notEquals(f,P){return T.create(f,P)}static regex(f,P){return fe.create(f,P)}static in(f,P){return I.create(f,P)}static notIn(f,P){return L.create(f,P)}static not(f){return z.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return q.create(f,null,!0)}static greater(f,P){return Q.create(f,P)}static greaterEquals(f,P){return ne.create(f,P)}static smaller(f,P){return te.create(f,P)}static smallerEquals(f,P){return ue.create(f,P)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$ej=i;function r(M){const f=new g({regexParsingWithErrorRecovery:!1});return M.map(P=>(f.parse(P),f.lexingErrors.length>0?f.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,D.localize)(9,null,N.additionalInfo):(0,D.localize)(10,null),offset:N.offset,length:N.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}function t(M,f){const P=M?M.substituteConstants():void 0,N=f?f.substituteConstants():void 0;return!P&&!N?!0:!P||!N?!1:P.equals(N)}function n(M,f){return M.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$hj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$ij=o;class l{static create(f,P=null){const N=u.get(f);return typeof N=="boolean"?N?o.INSTANCE:s.INSTANCE:new l(f,P)}constructor(f,P){this.key=f,this.c=P,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:H(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=z.create(this.key,this)),this.c}}e.$jj=l;class S{static create(f,P,N=null){if(typeof P=="boolean")return P?l.create(f,N):z.create(f,N);const C=u.get(f);return typeof C=="boolean"?P===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new S(f,P,N)}constructor(f,P,N){this.c=f,this.d=P,this.f=N,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$kj=S;class I{static create(f,P){return new I(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.f),N=f.getValue(this.d);return Array.isArray(P)?P.includes(N):typeof N=="string"&&typeof P=="object"&&P!==null?b.call(P,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$lj=I;class L{static create(f,P){return new L(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=11,this.c=I.create(f,P)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=L;class T{static create(f,P,N=null){if(typeof P=="boolean")return P?z.create(f,N):l.create(f,N);const C=u.get(f);return typeof C=="boolean"?P===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new T(f,P,N)}constructor(f,P,N){this.c=f,this.d=P,this.f=N,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$nj=T;class z{static create(f,P=null){const N=u.get(f);return typeof N=="boolean"?N?s.INSTANCE:o.INSTANCE:new z(f,P)}constructor(f,P){this.c=f,this.d=P,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:H(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$oj=z;function V(M,f){if(typeof M=="string"){const P=parseFloat(M);isNaN(P)||(M=P)}return typeof M=="string"||typeof M=="number"?f(M):s.INSTANCE}class Q{static create(f,P,N=null){return V(P,C=>new Q(f,C,N))}constructor(f,P,N){this.c=f,this.d=P,this.f=N,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$pj=Q;class ne{static create(f,P,N=null){return V(P,C=>new ne(f,C,N))}constructor(f,P,N){this.c=f,this.d=P,this.f=N,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$qj=ne;class te{static create(f,P,N=null){return V(P,C=>new te(f,C,N))}constructor(f,P,N){this.c=f,this.d=P,this.f=N,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$rj=te;class ue{static create(f,P,N=null){return V(P,C=>new ue(f,C,N))}constructor(f,P,N){this.c=f,this.d=P,this.f=N,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$sj=ue;class fe{static create(f,P){return new fe(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const P=this.f?this.f.source:"",N=f.f?f.f.source:"";return P<N?-1:P>N?1:0}equals(f){if(f.type===this.type){const P=this.f?this.f.source:"",N=f.f?f.f.source:"";return this.d===f.d&&P===N}return!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$tj=fe;class ce{static create(f){return new ce(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ce(this.c.map(f))}negate(){return this.c}}e.$uj=ce;function B(M){let f=null;for(let P=0,N=M.length;P<N;P++){const C=M[P].substituteConstants();if(M[P]!==C&&f===null){f=[];for(let W=0;W<P;W++)f[W]=M[W]}f!==null&&(f[P]=C)}return f===null?M:f}class X{static create(f,P,N){return X.d(f,P,N)}constructor(f,P){this.expr=f,this.c=P,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,N=this.expr.length;P<N;P++){const C=n(this.expr[P],f.expr[P]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,N=this.expr.length;P<N;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let P=0,N=this.expr.length;P<N;P++)if(!this.expr[P].evaluate(f))return!1;return!0}static d(f,P,N){const C=[];let W=!1;for(const G of f)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){C.push(...G.expr);continue}C.push(G)}if(C.length===0&&W)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];for(;C.length>1;){const G=C[C.length-1];if(G.type!==9)break;C.pop();const ie=C.pop(),ae=C.length===0,le=q.create(G.expr.map(pe=>X.create([pe,ie],null,N)),null,ae);le&&(C.push(le),C.sort(n))}if(C.length===1)return C[0];if(N){for(let G=0;G<C.length;G++)for(let ie=G+1;ie<C.length;ie++)if(C[G].negate().equals(C[ie]))return s.INSTANCE;if(C.length===1)return C[0]}return new X(C,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new X(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());this.c=q.create(f,this,!0)}return this.c}}e.$vj=X;class q{static create(f,P,N){return q.d(f,P,N)}constructor(f,P){this.expr=f,this.c=P,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,N=this.expr.length;P<N;P++){const C=n(this.expr[P],f.expr[P]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,N=this.expr.length;P<N;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:q.create(f,this.c,!1)}evaluate(f){for(let P=0,N=this.expr.length;P<N;P++)if(this.expr[P].evaluate(f))return!0;return!1}static d(f,P,N){let C=[],W=!1;if(f){for(let G=0,ie=f.length;G<ie;G++){const ae=f[G];if(ae){if(ae.type===0){W=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&W)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];if(N){for(let G=0;G<C.length;G++)for(let ie=G+1;ie<C.length;ie++)if(C[G].negate().equals(C[ie]))return o.INSTANCE;if(C.length===1)return C[0]}return new q(C,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new q(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());for(;f.length>1;){const P=f.shift(),N=f.shift(),C=[];for(const W of U(P))for(const G of U(N))C.push(X.create([W,G],null,!1));f.unshift(q.create(C,null,!1))}this.c=q.create(f,this,!0)}return this.c}}e.$wj=q;class F extends l{static{this.d=[]}static all(){return F.d.values()}constructor(f,P,N){super(f,null),this.f=P,typeof N=="object"?F.d.push({...N,key:f}):N!==!0&&F.d.push({key:f,description:N,type:P!=null?typeof P:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return S.create(this.key,f)}notEqualsTo(f){return T.create(this.key,f)}}e.$xj=F,e.$yj=(0,A.$gi)("contextKeyService");function H(M,f){return M<f?-1:M>f?1:0}function Z(M,f,P,N){return M<P?-1:M>P?1:f<N?-1:f>N?1:0}function K(M,f){if(M.type===0||f.type===1)return!0;if(M.type===9)return f.type===9?_(M.expr,f.expr):!1;if(f.type===9){for(const P of f.expr)if(K(M,P))return!0;return!1}if(M.type===6){if(f.type===6)return _(f.expr,M.expr);for(const P of M.expr)if(K(P,f))return!0;return!1}return M.equals(f)}function _(M,f){let P=0,N=0;for(;P<M.length&&N<f.length;){const C=M[P].cmp(f[N]);if(C<0)return!1;C===0&&P++,N++}return P===M.length}function U(M){return M.type===9?M.expr:[M]}}),define(se[59],re([0,1,10]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,e.$uo=(0,O.$gi)("downloadService")}),define(se[18],re([0,1,10]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,O.$gi)("environmentService"),e.$oi=(0,O.$hi)(e.$ni)}),define(se[21],re([0,1,95,10]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.ExtensionGalleryErrorCode=e.$Qo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Po=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0,e.$Jo=k,e.$Ko=A,e.$Lo=D,e.$Mo=E,e.$No=u,e.$Oo=a,e.$Do="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Eo=new RegExp(e.$Do),e.$Fo="__web_extension",e.$Go="skipWalkthrough",e.$Ho="extensionsSync",e.$Io="dependecyOrPackExtensionInstall";function k($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function D($,h){switch($){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E($,h){return h==="web"&&!$.includes("web")}function u($,h,g){return E(h,g)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===g}function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}var b;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var v;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function($){$.Install="install",$.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var p;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Po=(0,j.$gi)("extensionGalleryService");var y;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var R;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(R||(e.ExtensionSignaturetErrorCode=R={}));class m extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Qo=m;var c;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class w extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Ro=w,e.$So=(0,j.$gi)("extensionManagementService"),e.$To="extensionsIdentifiers/disabled",e.$Uo="extensionsIdentifiers/enabled",e.$Vo=(0,j.$gi)("IGlobalExtensionEnablementService"),e.$Wo=(0,j.$gi)("IExtensionTipsService"),e.$Xo=(0,O.localize2)(0,"Extensions"),e.$Yo=(0,O.localize2)(1,"Preferences")}),define(se[60],re([0,1,14,8,103,13]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=D;async function D(b,v,d,p,y,R){let m;try{await E(b,v,d,p,y,R)}catch(c){m=c}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}async function E(b,v,d,p,y,R){u(R);const m=await b.open(v,{create:!1});try{u(R);let c=0,w=0,$=y&&typeof y.length=="number"?y.length:void 0,h=O.$te.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),g=y&&typeof y.position=="number"?y.position:0,i=0;do w=await b.read(m,g,h.buffer,i,h.byteLength-i),g+=w,i+=w,c+=w,typeof $=="number"&&($-=w),i===h.byteLength&&(await d.write(p(h)),h=O.$te.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),i=0);while(w>0&&(typeof $!="number"||$>0)&&u(R)&&a(c,y));if(i>0){let r=i;typeof $=="number"&&(r=Math.min(i,$)),d.write(p(h.slice(0,r)))}}catch(c){throw(0,A.$1k)(c)}finally{await b.close(m)}}function u(b){if(b.isCancellationRequested)throw(0,j.$6)();return!0}function a(b,v){if(typeof v?.limits?.size=="number"&&b>v.limits.size)throw(0,A.$Zk)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[122],re([0,1,7,169,2,12,170]),function(J,e,O,j,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class E extends k.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$6d),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(a){const b=this.j(a),v=b.filter(p=>{const y=this.c.get(p.path);return y?!(0,j.$ek)(y.request.excludes,p.excludes)||!(0,j.$ek)(y.request.includes,p.includes):!0}),d=Array.from(this.c.values()).filter(({request:p})=>!b.find(y=>y.path===p.path&&(0,j.$ek)(y.excludes,p.excludes)&&(0,j.$ek)(y.includes,p.includes))).map(({request:p})=>p.path);v.length&&this.m(`Request to start watching: ${v.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const p of d)this.h(p);for(const p of v)this.g(p)}g(a){const b=new D.$Nq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.f),v={request:a,instance:b};this.c.set(a.path,v)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const b=this.c.get(a);b&&(this.c.delete(a),b.instance.dispose())}j(a){const b=new Map;for(const v of a){const d=A.$k?v.path:v.path.toLowerCase();let p=b.get(v.correlationId);p||(p=new Map,b.set(v.correlationId,p)),p.set(d,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,b]of this.c)b.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,b){return b?`[File Watcher (node.js)] ${a} (path: ${b.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$Pq=E}),define(se[123],re([0,1,61,122]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class k extends O.$vq{constructor(D,E,u){super(D,E,u),this.s()}r(D){return D.add(new j.$Pq)}}e.$Qq=k}),define(se[124],re([0,1,15,57,87,61]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class D extends A.$wq{constructor(u,a,b){super(u,a,b),this.s()}r(u){const a=u.add(new k.$Hq(O.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:b,signal:v})=>this.t(`terminated by itself with code ${b}, signal: ${v}`))),j.ProxyChannel.toService((0,j.$Zh)(a.getChannel("watcher")))}}e.$Iq=D}),define(se[62],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class O{constructor(...k){this.a=new Map;for(const[A,D]of k)this.set(A,D)}set(k,A){const D=this.a.get(k);return this.a.set(k,A),D}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$ei=O}),define(se[125],re([0,1,9,8,2,51,120,10,62,171]),function(J,e,O,j,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;const b=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new u.$ei,c=!1,w,$=b){this.f=m,this.g=c,this.h=w,this.i=$,this.o=new Set,this.f.set(E.$fi,this),this._globalGraph=$?w?._globalGraph??new D.$Tq(h=>h):void 0}createChild(m){return new d(m,this.g,this,this.i)}invokeFunction(m,...c){const w=y.traceInvocation(this.i,m);let $=!1;try{return m({get:g=>{if($)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,w);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{$=!0,w.stop()}}createInstance(m,...c){let w,$;return m instanceof A.$di?(w=y.traceCreation(this.i,m.ctor),$=this.j(m.ctor,m.staticArguments.concat(c),w)):(w=y.traceCreation(this.i,m),$=this.j(m,c,w)),w.stop(),$}j(m,c=[],w){const $=E._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),h=[];for(const i of $){const r=this.m(i.id,w);r||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const g=$.length>0?$[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${m.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(m,c.concat(h))}k(m,c){if(this.f.get(m)instanceof A.$di)this.f.set(m,c);else if(this.h)this.h.k(m,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const c=this.f.get(m);return!c&&this.h?this.h.l(m):c}m(m,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const w=this.l(m);return w instanceof A.$di?this.q(m,w,c.branch(m,!0)):(c.branch(m,!1),w)}q(m,c,w){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,c,w)}finally{this.o.delete(m)}}r(m,c,w){const $=new D.$Tq(i=>i.id.toString());let h=0;const g=[{id:m,desc:c,_trace:w}];for(;g.length;){const i=g.pop();if($.lookupOrInsertNode(i),h++>1e3)throw new v($);for(const r of E._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof A.$di){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};$.insertEdge(i,n),g.push(n)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new v($);break}for(const{data:r}of i){if(this.l(r.id)instanceof A.$di){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}$.removeNode(r)}}return this.l(m)}s(m,c,w=[],$,h){if(this.f.get(m)instanceof A.$di)return this.t(m,c,w,$,h);if(this.h)return this.h.s(m,c,w,$,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(m,c,w=[],$,h){if($){const g=new d(void 0,this.g,this,this.i);g.c=String(m);const i=new Map,r=new O.$zh(()=>{const t=g.j(c,w,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$4c,i.set(n,l)),(I,L,T)=>{if(r.isInitialized)return r.value[n](I,L,T);{const z={listener:[I,L,T],disposable:void 0},V=l.push(z);return(0,k.$Rc)(()=>{V(),z.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,w,h)}u(m,c){if(c&&console.warn(m),this.g)throw new Error(m)}}e.$Uq=d;var p;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(p||(p={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,c){return m?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(m,c){return m?new y(1,c.name):y.c}static{this.f=0}constructor(m,c){this.type=m,this.name=c,this.g=Date.now(),this.h=[]}branch(m,c){const w=new y(3,m.toString());return this.h.push([m,c,w]),w}stop(){const m=Date.now()-this.g;y.f+=m;let c=!1;function w(h,g){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=w(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(m>2||c)&&y.all.add($.join(`
`))}}e.$Vq=y});var oe=this&&this.__param||function(J,e){return function(O,j){e(O,j,J)}};define(se[63],re([0,1,20,2,12,105,21,10]),function(J,e,O,j,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0,e.$wr=u;function u(b){return b.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$xr=(0,E.$gi)("languagePackService");let a=class extends j.$Tc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new O.$de;setTimeout(()=>v.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const y=d.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(m=>m.startsWith("lp-"))).map(R=>{const m=R.properties.localizedLanguages?.[0],c=u(R);return{...this.f(c,m,R),extensionId:R.identifier.id,galleryExtension:R}});return y.push(this.f("en","English")),y}f(v,d,p){const y=d??v;let R;if(y!==v&&(R=`(${v})`),v.toLowerCase()===k.$w.toLowerCase()&&(R??="",R+=(0,A.localize)(0,null)),p?.installCount){R??="";const m=p.installCount;let c;m>1e6?c=`${Math.floor(m/1e5)/10}M`:m>1e3?c=`${Math.floor(m/1e3)}K`:c=String(m),R+=` $(cloud-download) ${c}`}return{id:v,label:y,description:R}}};e.$yr=a,e.$yr=a=$e([oe(0,D.$Po)],a)}),define(se[5],re([0,1,106,34,7,43,2,31,12,17,3,11,121,10]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Pj=e.LogLevel=e.$Nj=e.$Mj=void 0,e.$Oj=R,e.log=c,e.$1j=l,e.$2j=S,e.$3j=I,e.$4j=L,e.$Mj=(0,p.$gi)("logService"),e.$Nj=(0,p.$gi)("loggerService");function y(){return new Date().toISOString()}function R(T){return(0,b.$Xf)(T)}var m;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Pj=m.Info;function c(T,z,V){switch(z){case m.Trace:T.trace(V);break;case m.Debug:T.debug(V);break;case m.Info:T.info(V);break;case m.Warning:T.warn(V);break;case m.Error:T.error(V);break;case m.Off:break;default:throw new Error(`Invalid log level ${z}`)}}function w(T,z=!1){let V="";for(let Q=0;Q<T.length;Q++){let ne=T[Q];if(ne instanceof Error&&(ne=(0,j.$4i)(ne,z)),typeof ne=="object")try{ne=JSON.stringify(ne)}catch{}V+=(Q>0?" ":"")+ne}return V}class $ extends D.$Tc{constructor(){super(...arguments),this.b=e.$Pj,this.c=this.B(new k.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(z){this.b!==z&&(this.b=z,this.c.fire(this.b))}getLevel(){return this.b}f(z){return this.b!==m.Off&&this.b<=z}}e.$Rj=$;class h extends ${constructor(z){super(),this.h=z}f(z){return this.h||super.f(z)}trace(z,...V){this.f(m.Trace)&&this.g(m.Trace,w([z,...V],!0))}debug(z,...V){this.f(m.Debug)&&this.g(m.Debug,w([z,...V]))}info(z,...V){this.f(m.Info)&&this.g(m.Info,w([z,...V]))}warn(z,...V){this.f(m.Warning)&&this.g(m.Warning,w([z,...V]))}error(z,...V){if(this.f(m.Error))if(z instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=z.stack,this.g(m.Error,w(Q))}else this.g(m.Error,w([z,...V]))}flush(){}}e.$Sj=h;class g extends ${constructor(z=e.$Pj){super(),this.setLevel(z),this.g=!u.$i}trace(z,...V){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,z,...V):console.log(`[main ${y()}]`,z,...V))}debug(z,...V){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,z,...V):console.log(`[main ${y()}]`,z,...V))}info(z,...V){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,z,...V):console.log(`[main ${y()}]`,z,...V))}warn(z,...V){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,z,...V):console.warn(`[main ${y()}]`,z,...V))}error(z,...V){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,z,...V):console.error(`[main ${y()}]`,z,...V))}flush(){}}e.$Tj=g;class i extends ${constructor(z=e.$Pj,V=!0){super(),this.g=V,this.setLevel(z)}trace(z,...V){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",z,...V):console.log(z,...V))}debug(z,...V){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",z,...V):console.log(z,...V))}info(z,...V){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",z,...V):console.log(z,...V))}warn(z,...V){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",z,...V):console.log(z,...V))}error(z,...V){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",z,...V):console.error(z,...V))}flush(){}}e.$Uj=i;class r extends ${constructor(z,V=e.$Pj){super(),this.g=z,this.setLevel(V)}trace(z,...V){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(z),...V])}debug(z,...V){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(z),...V])}info(z,...V){this.f(m.Info)&&this.g.log(m.Info,[this.h(z),...V])}warn(z,...V){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(z),...V])}error(z,...V){this.f(m.Error)&&this.g.log(m.Error,[this.h(z),...V])}h(z){return typeof z=="string"?z:(0,j.$4i)(z,this.f(m.Trace))}flush(){}}e.$Vj=r;class t extends ${constructor(z){super(),this.g=z,z.length&&this.setLevel(z[0].getLevel())}setLevel(z){for(const V of this.g)V.setLevel(z);super.setLevel(z)}trace(z,...V){for(const Q of this.g)Q.trace(z,...V)}debug(z,...V){for(const Q of this.g)Q.debug(z,...V)}info(z,...V){for(const Q of this.g)Q.info(z,...V)}warn(z,...V){for(const Q of this.g)Q.warn(z,...V)}error(z,...V){for(const Q of this.g)Q.error(z,...V)}flush(){for(const z of this.g)z.flush()}dispose(){for(const z of this.g)z.dispose();super.dispose()}}e.$Wj=t;class n extends D.$Tc{constructor(z,V,Q){if(super(),this.h=z,this.j=V,this.b=new E.$Ac,this.c=this.B(new k.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$6d),this.onDidChangeVisibility=this.g.event,Q)for(const ne of Q)this.b.set(ne.resource,{logger:void 0,info:ne})}m(z){return(0,b.$Tf)(z)?[...this.b.values()].find(V=>V.info.id===z):this.b.get(z)}getLogger(z){return this.m(z)?.logger}createLogger(z,V){const Q=this.n(z),ne=(0,b.$Tf)(z)?z:V?.id??(0,A.$7i)(Q.toString()).toString(16);let te=this.b.get(Q)?.logger;const ue=V?.logLevel==="always"?m.Trace:V?.logLevel;te||(te=this.s(Q,ue??this.getLogLevel(Q)??this.h,{...V,id:ne}));const fe={logger:te,info:{resource:Q,id:ne,logLevel:ue,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(fe.info),this.b.set(Q,fe),te}n(z){return(0,b.$Tf)(z)?(0,a.$Tg)(this.j,`${z}.log`):z}setLogLevel(z,V){if(v.URI.isUri(z)){const Q=z,ne=V,te=this.b.get(Q);te&&ne!==te.info.logLevel&&(te.info.logLevel=ne===this.h?void 0:ne,te.logger?.setLevel(ne),this.b.set(te.info.resource,te),this.f.fire([Q,ne]))}else{this.h=z;for(const[Q,ne]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&ne.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(z,V){const Q=this.m(z);Q&&V!==!Q.info.hidden&&(Q.info.hidden=!V,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,V]))}getLogLevel(z){let V;return z&&(V=this.b.get(z)?.info.logLevel),V??this.h}registerLogger(z){const V=this.b.get(z.resource);V?V.info.hidden!==z.hidden&&this.setVisibility(z.resource,!z.hidden):(this.b.set(z.resource,{info:z,logger:void 0}),this.c.fire({added:[z],removed:[]}))}deregisterLogger(z){const V=this.b.get(z);V&&(V.logger&&V.logger.dispose(),this.b.delete(z),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const z of this.b.values())yield z.info}getRegisteredLogger(z){return this.b.get(z)?.info}dispose(){this.b.forEach(z=>z.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Xj=n;class s{constructor(){this.onDidChangeLogLevel=new k.$6d().event}setLevel(z){}getLevel(){return m.Info}trace(z,...V){}debug(z,...V){}info(z,...V){}warn(z,...V){}error(z,...V){}critical(z,...V){}dispose(){}flush(){}}e.$Yj=s;class o extends s{}e.$Zj=o;function l(T){if(T.verbose)return m.Trace;if(typeof T.logLevel=="string"){const z=L(T.logLevel.toLowerCase());if(z!==void 0)return z}return e.$Pj}function S(T){switch(T){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function I(T){switch(T){case m.Trace:return{original:"Trace",value:O.localize(0,null)};case m.Debug:return{original:"Debug",value:O.localize(1,null)};case m.Info:return{original:"Info",value:O.localize(2,null)};case m.Warning:return{original:"Warning",value:O.localize(3,null)};case m.Error:return{original:"Error",value:O.localize(4,null)};case m.Off:return{original:"Off",value:O.localize(5,null)}}}function L(T){switch(T){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$5j=new d.$xj("logLevel",S(m.Info))}),define(se[64],re([0,1,8,10,5]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Vp=(0,j.$gi)("IExtensionSignatureVerificationService");let A=class{constructor(E){this.b=E}c(){return this.a||(this.a=new Promise((E,u)=>J(["@vscode/vsce-sign"],async a=>E(a),u))),this.a}async verify(E,u,a){let b;try{b=await this.c()}catch(v){return this.b.error("Could not load vsce-sign module",(0,O.$0)(v)),!1}return b.verify(E,u,a)}};e.$Wp=A,e.$Wp=A=$e([oe(0,k.$Mj)],A)}),define(se[126],re([0,1,19,9,8,7,2,16,61,5]),function(J,e,O,j,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class b extends D.$Tc{constructor(d,p){super(),this.a=d,this.b=p,this.c=this.B(new A.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$eh(0)),this.w=[],this.y=this.B(new j.$eh(0))}watch(d,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(d,p):this.z(d,p)}n(d,p){const y={path:this.H(d),excludes:p.excludes,includes:p.includes,recursive:p.recursive,correlationId:p.correlationId},R=(0,O.$Ub)(this.j,y);return this.r(),(0,D.$Rc)(()=>{R(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,k.$1)(d))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,u.$xq)(p)),p=>this.G(p),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const p of this.j)(0,u.$tq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const p of this.j)(0,u.$tq)(p)&&d.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,p){const y={path:this.H(d),excludes:p.excludes,includes:p.includes,recursive:!1,correlationId:p.correlationId},R=(0,O.$Ub)(this.w,y);return this.C(),(0,D.$Rc)(()=>{R(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,k.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$xq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,E.$hc)(d.fsPath)}}e.$Bq=b}),define(se[127],re([0,1,19,9,14,20,7,43,65,2,48,15,128,17,46,102,13,60,5,8]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;let g=class extends a.$Tc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new D.$6d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$6d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$6d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$6d),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$6d),this.Y=this.B(new D.$6d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$6d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$ph)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new m.$6k(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await j.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,p.$Xg)(r))throw new m.$8k((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new $.$bb;throw n.message=(0,R.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,m.$Sk)(t)||(0,m.$Pk)(t)||(0,m.$Tk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,m.$Sk)(t)||(0,m.$Pk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,m.$3k)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.$8k((0,R.localize)(2,null,this.sb(r)),1):(0,m.$1k)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,I=await n.stat(r);let L;return this.t(n,r,I,void 0,!!S,(T,z)=>(L||(L=b.$mi.forUris(()=>!s),L.set(r,!0),o&&L.fill(!0,o)),L.get(T.resource)||L.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&l?z===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:S}=this.R(r),I={resource:t,name:S.basename(t),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.$gl)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const L=await r.readdir(t),T=await j.Promises.settled(L.map(async([z,V])=>{try{const Q=S.joinPath(t,z),ne=o?await r.stat(Q):{type:V};return await this.t(r,Q,ne,L.length,o,l)}catch(Q){return this.b.trace(Q),null}}));I.children=(0,O.$Hb)(T)}catch(L){this.b.trace(L),I.children=[]}return I}return I}async resolveAll(r){return j.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new m.$8k((0,R.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$te.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new m.$5k(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,m.$Vk)(s)&&!l?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(l={...n,atomic:S})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,m.$Pk)(s)&&!(t instanceof k.$te))if((0,y.$fe)(t)){const L=await(0,y.$me)(t,3);L.ended?I=k.$te.concat(L.buffer):I=L}else I=(0,y.$je)(t,L=>k.$te.concat(L),3);else I=t;!(0,m.$Sk)(s)||(0,m.$Pk)(s)&&I instanceof k.$te||(0,m.$Pk)(s)&&(0,m.$Vk)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof k.$te?(0,k.$Ee)(I):I),this.r.fire(new m.$5k(r,4))}catch(S){throw new m.$8k((0,R.localize)(4,null,this.sb(r),(0,m.$1k)(S).toString()),(0,m.$4k)(S),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(t)));if(s)throw new Error((0,R.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$8k((0,R.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.$fl&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,m.$gl)({mtime:n.mtime,size:l.size}))throw new m.$8k((0,R.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const S=await this.C(r,t,n,s);o(S)}catch(S){l(S)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Fe)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new A.$de(s);let l=n;(0,m.$Uk)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const S=this.J(t,l).then(L=>L,L=>{throw o.dispose(!0),L});let I;try{return typeof l?.etag=="string"&&l.etag!==m.$fl&&await S,l?.atomic&&(0,m.$Uk)(r)||!((0,m.$Sk)(r)||(0,m.$Tk)(r))||(0,m.$Pk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,m.$Tk)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await S,value:I}}catch(L){throw I&&await(0,y.$ke)(I),this.F(L,t,l)}}F(r,t,n){const s=(0,R.localize)(11,null,this.sb(t),(0,m.$1k)(r).toString());return r instanceof m.$0k?new m.$0k(s,r.stat,n):r instanceof m.$9k?new m.$9k(s,r.fileOperationResult,r.size,r.options):new m.$8k(s,(0,m.$4k)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,y.$qe)(o,{data:l=>l instanceof k.$te?l:k.$te.wrap(l),error:l=>this.F(l,t,s)},l=>k.$te.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,k.$Je)();return(0,c.$rq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,y.$he)(o=>k.$te.concat(o));return(async()=>{try{let o;n?.atomic&&(0,m.$Uk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(k.$te.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new m.$8k((0,R.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$fl&&t.etag===n.etag)throw new m.$0k((0,R.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new m.$9k((0,R.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$5k(r,l==="move"?2:3,S)),S}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$5k(r,l==="copy"?3:2,S)),S}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(S&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,m.$Qk)(r))await r.copy(t,s,{overwrite:l});else{const L=await this.resolve(t);L.isDirectory?await this.P(r,L,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,m.$Sk)(r)&&(0,m.$Sk)(n))return this.jb(r,t,n,s);if((0,m.$Sk)(r)&&(0,m.$Pk)(n))return this.pb(r,t,n,s);if((0,m.$Pk)(r)&&(0,m.$Sk)(n))return this.nb(r,t,n,s);if((0,m.$Pk)(r)&&(0,m.$Pk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await j.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let S=!1;if(r===n){const{providerExtUri:L,isPathCaseSensitive:T}=this.R(r);if(T||(S=L.isEqual(t,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(t),this.sb(s)));if(!S&&L.isEqualOrParent(s,t))throw new Error((0,R.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!S){if(!l)throw new m.$8k((0,R.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:L}=this.R(r);if(L.isEqualOrParent(t,s))throw new Error((0,R.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:S}}R(r){const t=this.S(r);return{providerExtUri:t?p.$Jg:p.$Lg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$5k(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&m.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(t)));break}catch(o){if((0,m.$3k)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,m.$3k)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new m.$8k((0,R.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,m.$Wk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,S=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:S}),this.r.fire(new m.$5k(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,m.$Rk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,m.$Qk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const S=await this.bb(r,t);s?(0,a.$Oc)(S):o=()=>(0,a.$Oc)(S)}catch(S){this.b.error(S)}})();const l=t.correlationId;if(typeof l=="number"){const S=n.add(new D.$6d);return n.add(this.X.event(L=>{L.correlates(l)&&S.fire(L)})),{onDidChange:S.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,E.$7i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,y.$fe)(s)||(0,y.$ge)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,m.$1k)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,y.$ge)(n)){if(n.buffer.length>0){const l=k.$te.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,S)=>{(0,y.$le)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(L){return S(L)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>S(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let S=0;for(;S<s;){const I=await r.write(t,o+S,n.buffer,l+S,s-S);S+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof k.$te?o=s:(0,y.$fe)(s)?o=await(0,k.$Fe)(s):(0,y.$ge)(s)?o=await(0,k.$Ge)(s):o=(0,k.$De)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const S=k.$te.alloc(this.a);let I=0,L=0,T=0;do T=await r.read(o,I,S.buffer,L,S.byteLength-L),await this.gb(n,l,S,T,I,L),I+=T,L+=T,L===S.byteLength&&(L=0);while(T>0)}catch(S){throw(0,m.$1k)(S)}finally{await j.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,k.$te.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$1k)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,k.$Fe)(this.H(r,t,A.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new m.$8k((0,R.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$8k((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$sq=g,e.$sq=g=h=$e([oe(0,w.$Mj)],g)}),define(se[129],re([0,1,90,172,9,31,14,7,173,2,16,12,17,46,24,104,13,60,126,34,124,123]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,(()=>{try{(0,j.gracefulify)(O)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$4i)(r)}`)}})();class i extends w.$Bq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=E.Event.None,this.N=new A.$Ac(s=>d.$Kg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await y.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:m.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await y.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Tg)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=m.FileType.Unknown:t.isFile()?s=m.FileType.File:t.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,n&&(s|=m.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new k.$fh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await y.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,p.$he)(l=>D.$te.concat(l.map(S=>D.$te.wrap(S))).buffer);return(0,c.$rq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Tg)((0,d.$Sg)(t),`${(0,d.$Qg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await y.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(S){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const S=this.H(t);if(!s.create||!s.overwrite){if(await y.Promises.exists(S)){if(!s.overwrite)throw(0,m.$Zk)((0,R.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$Zk)((0,R.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(S){throw await this.gb(t,S)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,m.$Nk)(n)&&!s&&(l=await this.O(t));let S;try{if((0,m.$Nk)(n)&&n.unlock)try{const{stat:L}=await y.SymlinkSupport.stat(o);L.mode&128||await y.Promises.chmod(o,L.mode|128)}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}let I;if((0,m.$Nk)(n)){if(v.$i)try{await y.Promises.truncate(o,0),I="r+"}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}I||(I="w")}else I="r";S=await y.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,m.$Nk)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(S,0),(0,m.$Nk)(n)&&this.X.set(S,t),l){const I=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.W.set(S,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),I.dispose())}return S}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await y.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await y.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const S=this.Z(t,n);let I=null;try{I=(await y.Promises.read(t,s,o,l,S)).bytesRead}catch(L){throw this.fb(L)}finally{this.$(t,S,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,k.$Ah)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const S=this.Z(t,n);let I=null;try{I=(await y.Promises.write(t,s,o,l,S)).bytesWritten}catch(L){throw await this.gb(this.X.get(t),L)}finally{this.$(t,S,I)}return I}async mkdir(t){try{await y.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,b.$jc)((0,b.$mc)(s),`${(0,b.$nc)(s)}${n.atomic.postfix}`)),await y.Promises.rm(s,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:S,symbolicLink:I}=await y.SymlinkSupport.stat(s);l=S.isDirectory()&&!I}catch{}if(l)await y.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await y.Promises.rename(o,l)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(2,null,(0,b.$nc)(o),(0,b.$nc)((0,b.$mc)(l)),S.toString()))),this.fb(S)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await y.Promises.copy(o,l,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(3,null,(0,b.$nc)(o),(0,b.$nc)((0,b.$mc)(l)),S.toString()))),this.fb(S)}}async bb(t,n,s,o){const l=this.H(t),S=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$fg)(l,S,!0)),I){if(s==="copy")throw(0,m.$Zk)((0,R.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const T=await this.L(t);if(!T)throw(0,m.$Zk)((0,R.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const z=await this.L(n);if(z){if(!o)throw(0,m.$Zk)((0,R.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);T.type&m.FileType.File&&z.type&m.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),S=!!(this.capabilities&1024);if((0,u.$fg)(o,l,!S))return;const I=new a.$Sc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await y.Promises.mkdir((0,b.$mc)(l),{recursive:!0}),await y.Promises.copyFile(o,l)}catch(L){if(L.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(L)}finally{I.dispose()}}t(t,n,s){return new h.$Iq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Qq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof m.$Yk)return t;let n=t,s;switch(t.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Zk)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,m.$Zk)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Rq=i}),define(se[130],re([0,1,2,5]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class k extends O.$Tc{constructor(D,E=[]){super(),this.a=new j.$Wj([D,...E]),this.B(D.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...E){this.a.trace(D,...E)}debug(D,...E){this.a.debug(D,...E)}info(D,...E){this.a.info(D,...E)}warn(D,...E){this.a.warn(D,...E)}error(D,...E){this.a.error(D,...E)}flush(){this.a.flush()}}e.$VP=k}),define(se[131],re([0,1,13,5]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function A(a,b,v,d,p){try{const y=await new Promise((m,c)=>{J(["@vscode/spdlog"],m,c)});y.setFlushOn(k.Trace);const R=await y.createAsyncRotatingLogger(a,b,v,d);return p?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(y){console.error(y)}return null}function D(a,b,v){switch(b){case j.LogLevel.Trace:a.trace(v);break;case j.LogLevel.Debug:a.debug(v);break;case j.LogLevel.Info:a.info(v);break;case j.LogLevel.Warning:a.warn(v);break;case j.LogLevel.Error:a.error(v);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function E(a,b){switch(b){case j.LogLevel.Trace:a.setLevel(k.Trace);break;case j.LogLevel.Debug:a.setLevel(k.Debug);break;case j.LogLevel.Info:a.setLevel(k.Info);break;case j.LogLevel.Warning:a.setLevel(k.Warning);break;case j.LogLevel.Error:a.setLevel(k.Error);break;case j.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class u extends j.$Sj{constructor(b,v,d,p,y){super(),this.m=[],this.setLevel(y),this.n=this.s(b,v,d,p),this.B(this.onDidChangeLogLevel(R=>{this.r&&E(this.r,R)}))}async s(b,v,d,p){const y=d?6:1,R=30/y*O.$il.MB,m=await A(b,v,R,y,p);if(m){this.r=m,E(this.r,this.getLevel());for(const{level:c,message:w}of this.m)D(this.r,c,w);this.m=[]}}g(b,v){this.r?D(this.r,b,v):this.getLevel()<=b&&this.m.push({level:b,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$KP=u}),define(se[132],re([0,1,28,5,131]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=void 0;class A extends j.$Xj{s(E,u,a){return new k.$KP((0,O.$Cg)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$LP=A}),define(se[39],re([0,1,7,65,2,10]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=e.$1n=void 0,e.$1n=(0,A.$gi)("policy");class D extends k.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$6d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const b=Object.keys(this.f).length;return this.f={...a,...this.f},b!==Object.keys(this.f).length&&await this.j(a),j.Iterable.reduce(this.g.entries(),(v,[d,p])=>({...v,[d]:p}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(a,[b,v])=>({...a,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.$2n=D;class E{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$3n=E}),define(se[133],re([0,1,9,7,65,3,13,5,39]),function(J,e,O,j,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;function a(v,d){const p=[];for(const y of new Set(k.Iterable.concat(v.keys(),d.keys())))v.get(y)!==d.get(y)&&p.push(y);return p}let b=class extends u.$2n{constructor(d,p,y){super(),this.m=d,this.n=p,this.s=y,this.c=this.B(new O.$eh(500));const R=j.Event.filter(p.onDidFilesChange,m=>m.affects(d));this.B(p.watch(d)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const p=await this.n.readFile(this.m),y=JSON.parse(p.value.toString());if(!(0,A.$Vf)(y))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(y))this.f[R]&&d.set(R,y[R])}catch(p){p.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",p)}return d}async w(){const d=await this.u(),p=a(this.g,d);this.g=d,p.length>0&&this.h.fire(p)}};e.$jbc=b,e.$jbc=b=$e([oe(1,D.$Mk),oe(2,E.$Mj)],b)}),define(se[134],re([0,1,39,9,2,5]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;let D=class extends O.$2n{constructor(u,a){super(),this.m=u,this.n=a,this.a=new j.$ah,this.b=this.B(new k.$Uc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((b,v)=>{J(["@vscode/policy-watcher"],b,v)});await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),b()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),v(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const b=u[a];b===void 0?this.g.delete(a):this.g.set(a,b)}this.h.fire(Object.keys(u))}};e.$ibc=D,e.$ibc=D=$e([oe(0,A.$Mj)],D)}),define(se[32],re([0,1,10]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=void 0,e.$6j=(0,O.$gi)("productService"),e.$7j="vscode://schemas/vscode-product"}),define(se[36],re([0,1,71,3]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0;class k{constructor(){this.a=new Map}add(D,E){O.ok(j.$Tf(D)),O.ok(j.$Vf(E)),O.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,E)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Yn=new k}),define(se[135],re([0,1,7,36]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0,e.$Zn={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class A{constructor(){this.b=new O.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[k(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;j.$Yn.add(e.$Zn.JSONContribution,D)}),define(se[40],re([0,1,19,7,3,91,29,135,36]),function(J,e,O,j,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.ConfigurationScope=e.$4n=e.EditPresentationTypes=void 0,e.$co=R,e.$do=m,e.$eo=c,e.$fo=$,e.$go=h;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$4n={Configuration:"base.contributions.configuration"};var b;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n="vscode://schemas/settings/resourceLanguage",e.$_n="vscode://schemas/settings/configurationDefaults";const v=u.$Yn.as(E.$Zn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new j.$6d,this.onDidSchemaChange=this.i.event,this.j=new j.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$$n,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),v.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),v.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),v.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$bo.test(o)){const l=this.a.get(o),S=l?.valuesSources??new Map;if(s)for(const z of Object.keys(n[o]))S.set(z,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:S});const L=(0,D.$Wi)(o),T={type:"object",default:I,description:A.localize(1,null,L),$ref:e.$$n,defaultDefaultValue:I,source:k.$Tf(s)?void 0:s,defaultValueSource:s};t.push(...R(o)),this.d[o]=T,this.b.properties[o]=T}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=k.$Tf(n)?n:n?.id,S=k.$Tf(o?.source)?o?.source:o?.source?.id;if(l===S)if(r.add(s),this.a.delete(s),e.$bo.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=k.$3f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const L=l[I];if(r&&$(I,L)){delete l[I];continue}if(L.source=t,L.defaultDefaultValue=l[I].default,this.w(I,L),e.$bo.test(I)?L.scope=void 0:(L.scope=k.$3f(L.scope)?s:L.scope,L.restricted=k.$3f(L.restricted)?!!n?.includes(I):L.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const S=i.allOf;if(S)for(const I of S)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$5n.properties[i]=r,r.scope){case 1:e.$6n.properties[i]=r;break;case 2:e.$7n.properties[i]=r;break;case 6:e.$8n.properties[i]=r;break;case 3:e.$9n.properties[i]=r;break;case 4:e.$0n.properties[i]=r;break;case 5:e.$0n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$5n.properties[i],r.scope){case 1:delete e.$6n.properties[i];break;case 2:delete e.$7n.properties[i];break;case 6:delete e.$8n.properties[i];break;case 3:delete e.$9n.properties[i];break;case 4:case 5:delete e.$0n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$$n};this.w(r,t),e.$5n.properties[r]=t,e.$6n.properties[r]=t,e.$7n.properties[r]=t,e.$8n.properties[r]=t,e.$9n.properties[r]=t,e.$0n.properties[r]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$$n};e.$5n.patternProperties[e.$ao]=i,e.$6n.patternProperties[e.$ao]=i,e.$7n.patternProperties[e.$ao]=i,e.$8n.patternProperties[e.$ao]=i,e.$9n.patternProperties[e.$ao]=i,e.$0n.patternProperties[e.$ao]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;k.$1f(n)&&(n=r.defaultDefaultValue,s=void 0),k.$1f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",y=new RegExp(p,"g");e.$ao=`^(${p})+$`,e.$bo=new RegExp(e.$ao);function R(g){const i=[];if(e.$bo.test(g)){let r=y.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=y.exec(g)}}return(0,O.$Mb)(i)}function m(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new d;u.$Yn.add(e.$4n.Configuration,w);function $(g,i){return g.trim()?e.$bo.test(g)?A.localize(7,null,g):w.getConfigurationProperties()[g]!==void 0?A.localize(8,null,g):i.policy?.name&&w.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,g,i.policy?.name,w.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function h(){const g=[],i=w.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(se[66],re([0,1,19,7,38,2,31,27,3,11,29,40,36]),function(J,e,O,j,k,A,D,E,u,a,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$ko=e.$jo=e.$io=e.$ho=void 0,e.$lo=$;function p(r){return Object.isFrozen(r)?r:E.$Nn(r)}class y{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof y)return n;const s=new R("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,b.$Ui)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return p(s.rawConfiguration.getValue(t))},get override(){return n?p(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return p(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:S,keys:I}of s.rawConfiguration.overrides){const L=new y(l,I).getValue(t);L!==void 0&&o.push({identifiers:S,value:L})}return o.length?p(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,b.$Ui)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return O.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return O.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=E.$Mn(this.contents),s=E.$Mn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const S of t)if(l.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(n,S.contents);for(const I of S.overrides){const[L]=s.filter(T=>O.$ub(T.identifiers,I.identifiers));L?(this.h(L.contents,I.contents),L.keys.push(...I.keys),L.keys=O.$Mb(L.keys)):s.push(E.$Mn(I))}for(const I of S.keys)o.indexOf(I)===-1&&o.push(I)}return new y(n,o,s,l.every(S=>S instanceof y)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of O.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const S=n[o];S&&(typeof l=="object"&&typeof S=="object"?(l=E.$Mn(l),this.h(l,S)):l=S),s[o]=l}return new y(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$Vf(t[s])&&u.$Vf(n[s])){this.h(t[s],n[s]);continue}t[s]=E.$Mn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=E.$Mn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,b.$Ti)(this.contents,t),v.$bo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>O.$ub(s.identifiers,(0,v.$co)(t))),1))}j(t,n,s){(0,b.$Si)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$bo.test(t)&&this.overrides.push({identifiers:(0,v.$co)(t),keys:Object.keys(this.contents[t]),contents:(0,b.$Ri)(this.contents[t],o=>console.error(o))})}}e.$ho=y;class R{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$3f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:S,hasExcludedProperties:I}=this.h(t,n);this.b=new y(s,o,l,I?[t]:void 0),this.c=S||[]}g(t){let n={},s=null,o=[];const l=[],S=[];function I(T){Array.isArray(o)?o.push(T):s!==null&&(o[s]=T)}const L={onObjectBegin:()=>{const T={};I(T),l.push(o),o=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const T=[];I(T),l.push(o),o=T,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(T,z,V)=>{S.push({error:T,offset:z,length:V})}};if(t)try{k.$An(t,L),n=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return n}h(t,n){const s=d.$Yn.as(v.$4n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,b.$Ri)(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),S=Object.keys(t),I=this.j(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:l,keys:S,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const S={},I=[];for(const L in t)if(v.$bo.test(L)&&s){const T=this.i(t[L],n,!1,o);S[L]=T.raw,l=l||T.hasExcludedProperties,I.push(...T.restricted)}else{const T=n[L],z=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&I.push(L),!o.exclude?.includes(L)&&(o.include?.includes(L)||(z===void 0||o.scopes===void 0||o.scopes.includes(z))&&!(o.skipRestricted&&T?.restricted))?S[L]=t[L]:l=!0}return{raw:S,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(v.$bo.test(o)){const l={};for(const S in t[o])l[S]=t[o][S];s.push({identifiers:(0,v.$co)(o),keys:Object.keys(l),contents:(0,b.$Ri)(l,n)})}return s}}e.$io=R;class m extends A.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new j.$6d),this.onDidChange=this.b.event,this.a=new R(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$jo=m;class c{constructor(t,n,s,o,l,S,I,L,T,z,V,Q,ne){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=S,this.g=I,this.h=L,this.i=T,this.j=z,this.k=V,this.l=Q,this.m=ne}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class w{constructor(t,n,s,o,l=new y,S=new y,I=new D.$Ac,L=new y,T=new D.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=S,this.j=I,this.l=L,this.m=T,this.a=null,this.b=new D.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new y,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),S=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const L of o.overrides)for(const T of L.identifiers)o.getOverrideValue(t,T)!==void 0&&I.add(T);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,S)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:S}=g(this.c,t);n=[...o,...l,...S]}for(const o of n)for(const l of(0,v.$co)(o)){const S=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),L=[...I.filter(T=>S.indexOf(T)===-1),...S.filter(T=>I.indexOf(T)===-1),...S.filter(T=>!E.$Qn(this.c.override(l).getValue(T),t.override(l).getValue(T)))];s.push([l,L])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:S,overrides:I}=g(s,n),L=[...o,...l,...S];return(L.length||!s)&&this.updateFolderConfiguration(t,n),{keys:L,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:S}=g(n,void 0);return{keys:[...s,...o,...l],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),S=this.w(t.workspace),I=t.folders.reduce((L,T)=>(L.set(a.URI.revive(T[0]),this.w(T[1])),L),new D.$Ac);return new w(n,s,o,l,new y,S,I,new y,new D.$Ac)}static w(t){return new y(t.contents,t.keys,t.overrides)}}e.$ko=w;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,S])=>{const I=(0,D.$xc)(n,l,new Set);S.forEach(L=>I.add(L))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const S of l)this.affectedKeys.add(S);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=w.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const S=this.d.charCodeAt(l);if(S!==this.b&&S!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,L=this.g.getValue(t,n,this.h);return!E.$Qn(I,L)}return!0}}e.$mo=h;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],S=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const L=I.filter(T=>!S.includes(T));for(const T of L)l.push([T,t.getKeysForOverrideIdentifier(T)])}if(r){const L=S.filter(T=>!I.includes(T));for(const T of L)l.push([T,r.getKeysForOverrideIdentifier(T)])}if(t&&r){for(const L of S)if(I.includes(L)){const T=i({contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)},{contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)});l.push([L,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const S=(0,b.$Ui)(t.contents,l),I=(0,b.$Ui)(r.contents,l);E.$Qn(S,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(se[136],re([0,1,19,7,2,27,3,66,40,5,39,36]),function(J,e,O,j,k,A,D,E,u,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=void 0;class d extends k.$Tc{constructor(){super(...arguments),this.a=this.B(new j.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$ho}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Yn.as(u.$4n.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.c(Array.from(m),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,c){this.h(m,v.$Yn.as(u.$4n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new E.$ho;const m=v.$Yn.as(u.$4n.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,c){const w=this.f();for(const $ of m){const h=w[$],g=c[$];h!==void 0?this.b.addValue($,h):g?this.b.addValue($,g.default):this.b.removeValue($)}}}e.$no=d;class p{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new E.$ho}async initialize(){return this.configurationModel}}e.$oo=p;let y=class extends k.$Tc{get configurationModel(){return this.b}constructor(m,c,w){super(),this.c=m,this.f=c,this.g=w,this.a=this.B(new j.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$ho}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const c={},w=[],$=v.$Yn.as(u.$4n.Configuration).getConfigurationProperties();for(const h of m){const g=$[h];if(!g){w.push(h);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}w.push(h),c[g.policy.name]={type:g.type}}}return(0,D.$7f)(c)||await this.f.updatePolicyDefinitions(c),w}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const c=v.$Yn.as(u.$4n.Configuration).getPolicyConfigurations(),w=(0,O.$Hb)(m.map($=>c.get($)));this.m(w,!0)}m(m,c){this.g.trace("PolicyConfiguration#update",m);const w=v.$Yn.as(u.$4n.Configuration).getConfigurationProperties(),$=[],h=this.b.isEmpty();for(const g of m){const i=w[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,A.$Qn)(this.b.getValue(g),r))&&$.push([g,r])}else this.b.getValue(g)!==void 0&&$.push([g,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const g=this.b;this.b=new E.$ho;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of $)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$po=y,e.$po=y=$e([oe(1,b.$1n),oe(2,a.$Mj)],y)}),define(se[137],re([0,1,19,9,14,7,38,73,2,27,12,17,29,66,40,136,39]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0;class c extends u.$Tc{constructor(h,g,i,r){super(),this.m=h,this.h=this.B(new A.$6d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new R.$no),this.c=i instanceof m.$3n?new R.$oo:this.B(new R.$po(this.b,i,r)),this.f=this.B(new p.$jo(this.m,{},v.$Kg,g)),this.a=new p.$ko(this.b.configurationModel,this.c.configurationModel,new p.$ho,new p.$ho),this.j=new w(h,g,this),this.g=this.B(new j.$sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$ko(h,g,new p.$ho,i)}getConfigurationData(){return this.a.toData()}getValue(h,g){const i=typeof h=="string"?h:void 0,r=(0,d.$Ni)(h)?h:(0,d.$Ni)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(h,g,i,r,t){const n=(0,d.$Oi)(i)?i:(0,d.$Ni)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,O.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$Qn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const S=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(L=>(0,O.$ub)([...L.identifiers].sort(),S));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,y.$do)(n.overrideIdentifiers),h]:[h];await this.j.write(l,g),await this.reloadConfiguration()}inspect(h,g={}){return this.a.inspect(h,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,g,2)}r(h,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,g);this.t(r,i,7)}s(h){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,g,7)}t(h,g,i){const r=new p.$mo(h,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$qo=c;class w{constructor(h,g,i){this.b=h,this.c=g,this.d=i,this.a=new j.$nh}write(h,g){return this.a.queue(()=>this.e(h,g))}async e(h,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,D.$tn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,g);i=(0,E.$Ln)(i,t),await this.c.writeFile(this.b,k.$te.fromString(i))}f(h,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$In)(h,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=b.OS===3||b.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(h=g),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[67],re([0,1,15]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=j,e.$sm=k,e.$tm=A,e.$um=D;function j(u){return u.scheme===O.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function A(u){const{host:a,port:b}=E(u);if(typeof b>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:b}}function D(u,a){let{host:b,port:v}=E(u);return typeof v>"u"&&(v=a),{host:b,port:v}}function E(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const b=u.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const v=u.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:u,port:void 0}}}),define(se[37],re([0,1,30,10,67]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Dm=e.$Cm=e.$Bm=e.TargetPlatform=e.ExtensionType=e.$Am=e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$zm=A,e.$Em=v,e.$Fm=d,e.$Gm=p,e.$Hm=y,e.$vm="extensions.user.cache",e.$wm="extensions.builtin.cache",e.$xm="undefined_publisher",e.$ym=["ui","workspace","web"];function A(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(D||(e.ExtensionType=D={}));var E;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,c){if(typeof m>"u"||m===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof m=="string"||typeof c=="string"){const w=typeof m=="string"?m:m.value,$=typeof c=="string"?c:c.value;return O.$kf(w,$)}return m._lower===c._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Bm=u;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const c of m)this.add(c)}add(m){this.c.add(u.toKey(m))}delete(m){return this.c.delete(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}}e.$Cm=a;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(u.toKey(m))}get(m){return this.c.get(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}set(m,c){this.c.set(u.toKey(m),c)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Dm=b;function v(R){return d(R)}function d(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function p(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function y(R,m){if(m){const c=`onResolveRemoteAuthority:${(0,k.$sm)(m)}`;return!!R.activationEvents?.includes(c)}return!1}e.$Im=(0,j.$gi)("IBuiltinExtensionsScannerService")}),define(se[138],re([0,1,2,37,13]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class A extends O.$Tc{constructor(E,u,a,b,v){super(),this.a=E,this.b=u,this.c=a,this.f=v,this.B(b.onDidInstallExtensions(d=>this.g(d))),this.B(b.onDidUninstallExtension(d=>this.h(d)))}g(E){for(const u of E)u.local&&this.invalidate(u.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,E)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,j.$vm))}catch(u){(0,k.$4k)(u)!==1&&this.f.error(u)}}}e.$lq=A}),define(se[45],re([0,1,14,8,2,107,40,10,5,36]),function(J,e,O,j,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=void 0,e.$zp=d,e.$Ap=p,e.$Bp=y,e.$Cp=R,e.$Dp=m,e.$Ep=c,e.$xp=(0,E.$gi)("requestService");class b{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class v extends k.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,A.localize)(0,null),when:u.$5j.isEqualTo((0,u.$2j)(u.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new b(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,j.$0)(n)),n}}}e.$yp=v;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function p(h){return h.res.statusCode===204}async function y(h){return p(h)?null:(await(0,O.$Fe)(h.stream)).toString()}async function R(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return y(h)}async function m(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const i=(await(0,O.$Fe)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function c(h){$(h)}let w;function $(h){const g=a.$Yn.as(D.$4n.Configuration),i=w;w={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[w],remove:i?[i]:[]})}$(1)}),define(se[139],re([0,1,20,15,13,45]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=void 0;let D=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,b=O.CancellationToken.None){if(u.scheme===j.Schemas.file||u.scheme===j.Schemas.vscodeRemote){await this.b.copy(u,a);return}const v={type:"GET",url:u.toString(!0)},d=await this.a.request(v,b);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const p=await(0,A.$Cp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};e.$$P=D,e.$$P=D=$e([oe(0,A.$xp),oe(1,k.$Mk)],D)}),define(se[140],re([0,1,141,3]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=A;function k(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function A(D,E,u={}){const a=(0,O.parse)(D),b=u.proxyUrl||k(a,E);if(!b)return null;const v=(0,O.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const d={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,j.$Zf)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((p,y)=>{J(["http-proxy-agent"],p,y)})).HttpProxyAgent(b,d):new(await new Promise((p,y)=>{J(["https-proxy-agent"],p,y)})).HttpsProxyAgent(b,d)}}),define(se[142],re([0,1,58,16,108,20,34,8,12,28,86,174,9,74]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=R;let y;async function R(c,w,$,h){return $["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$km)(h)&&!$["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$km)(h)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=d.Promises.withAsyncBody(async(g,i)=>{const r=new A.$de;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,p.$lm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{g(await m(w,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,D.$4i)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),y)}async function m(c,w){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const g=(0,a.$Cg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,b.$am)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(w.isCancellationRequested)return s(new E.$5);const o=(0,j.$nc)(t);let l,S;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,S=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,S=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,S=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),l);const L=(0,O.spawn)(t,[...S,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(L.kill(),s(new E.$5))),L.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,D.$4i)(V)),s(V)});const T=[];L.stdout.on("data",V=>T.push(V));const z=[];L.stderr.on("data",V=>z.push(V)),L.on("close",(V,Q)=>{const ne=Buffer.concat(T).toString("utf8");c.trace("getUnixShellEnvironment#raw",ne);const te=Buffer.concat(z).toString("utf8");if(te.trim()&&c.trace("getUnixShellEnvironment#stderr",te),V||Q)return s(new Error((0,k.localize)(2,null,V,Q)));const ue=i.exec(ne),fe=ue?ue[1]:"{}";try{const ce=JSON.parse(fe);$?ce.ELECTRON_RUN_AS_NODE=$:delete ce.ELECTRON_RUN_AS_NODE,h?ce.ELECTRON_NO_ATTACH_CONSOLE=h:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,D.$4i)(ce)),s(ce)}})})}}),define(se[143],re([0,1,10]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.$MP=void 0,e.$MP=(0,O.$gi)("stateReadService"),e.$NP=(0,O.$gi)("stateService")}),define(se[68],re([0,1,9,14,2,3,18,13,5]),function(J,e,O,j,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=e.$OP=e.SaveStrategy=void 0;var a;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class b extends k.$Tc{constructor(y,R,m,c){super(),this.h=y,this.j=R,this.m=m,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new O.$eh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,R){const m=this.a[y];return(0,A.$3f)(m)?R:m}setItem(y,R){this.setItems([{key:y,data:R}])}setItems(y){let R=!1;for(const{key:m,data:c}of y)this.a[m]!==c&&((0,A.$3f)(c)?(0,A.$1f)(this.a[m])||(this.a[m]=void 0,R=!0):(this.a[m]=c,R=!0));R&&this.s()}removeItem(y){(0,A.$1f)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,j.$te.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$OP=b;let v=class extends k.$Tc{constructor(y,R,m,c){super(),this.a=this.B(new b(R.stateResource,y,m,c))}async init(){await this.a.init()}getItem(y,R){return this.a.getItem(y,R)}};e.$PP=v,e.$PP=v=$e([oe(1,D.$ni),oe(2,u.$Mj),oe(3,E.$Mk)],v);class d extends v{setItem(y,R){this.a.setItem(y,R)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$QP=d}),define(se[69],re([0,1,12,35,28]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=D,e.$1o=E;function A(u){if(O.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function D(u,a,b,v,d,p,y,R,m){const c=Object.create(null);c["common.machineId"]=p,c["common.sqmId"]=y,c.sessionID=(0,k.$Cg)()+Date.now(),c.commitHash=v,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,O.$h)(O.$u),c["common.nodePlatform"]=j.$dc,c["common.nodeArch"]=b,c["common.product"]=m||"desktop",R&&(c["common.msftInternal"]=R);let w=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),O.$l&&(c["common.snap"]="true");const h=A(a);return h&&(c["common.platformDetail"]=h),c}function E(u){const a=j.env.USERDNSDOMAIN;if(!a)return!1;const b=a.toLowerCase();return u.some(v=>b===v)}}),define(se[25],re([0,1,10]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0,e.$Ll=(0,O.$gi)("telemetryService"),e.$Ml=(0,O.$gi)("customEndpointTelemetryService"),e.$Nl="telemetry.currentSessionDate",e.$Ol="telemetry.firstSessionDate",e.$Pl="telemetry.lastSessionDate",e.$Ql="telemetry.machineId",e.$Rl="telemetry.sqmId",e.$Sl="telemetry",e.$Tl="telemetry.telemetryLevel",e.$Ul="telemetry.enableCrashReporter",e.$Vl="telemetry.enableTelemetry";var j;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(se[41],re([0,1,27,3,67,69,25]),function(J,e,O,j,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=b,e.$0o=v,e.$$o=d,e.$_o=p,e.$ap=R,e.$bp=c,e.$cp=w,e.$dp=g;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$2o=E;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3o=u,e.$4o=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$5o=a,e.$6o="telemetry",e.$7o="extensionTelemetryLog",e.$8o={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function v(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const r=i.getValue(D.$Tl),t=i.getValue(D.$Ul);if(i.getValue(D.$Vl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function p(i){const r={},t={},n={};m(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(i){if(!i)return"none";const r=(0,k.$sm)(i);return y.has(r)?r:"other"}function m(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,O.$Rn)(o):o instanceof Date?r[l]=o.toISOString():(0,j.$Vf)(o)?t<2?m(o,r,t+1,l+"."):r[l]=(0,O.$Rn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.$1o)(t)||n}function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function $(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const S of r)for(;;){const I=S.exec(i);if(!I)break;n.push([I.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const S=o.exec(i);if(!S)break;const I=n.some(([L,T])=>S.index<T&&L<o.lastIndex);!s.test(S[0])&&!I&&(t+=i.substring(l,S.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,O.$On)(i,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=$(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}}),define(se[26],re([0,1,30,21,37,12,11,8,35,41]),function(J,e,O,j,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$fp=void 0,e.$ep=b,e.$gp=y,e.$hp=R,e.$ip=m,e.$jp=c,e.$kp=w,e.$lp=$,e.$mp=h,e.$op=g,e.$pp=r;function b(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,O.$ff)(t.id,n.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=v.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$fp=d;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(t){const n=p.exec(t);return n&&n[1]?[m(n[1]),n[2]]:[m(t),void 0]}function R(t,n){return`${t}.${n}`}function m(t){return t.toLowerCase()}function c(t,n){return m(R(t??k.$xm,n))}function w(t,n){const s=[],o=l=>{for(const S of s)if(S.some(I=>b(n(I),n(l))))return S;return null};for(const l of t){const S=o(l);S?S.push(l):s.push([l])}return s}function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function h(t){return{id:new a.$2o(t.identifier.id),name:new a.$2o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$np=new k.$Bm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(S=>!b(S.identifier,{id:l}))){const S=t.filter(I=>b(I.identifier,{id:l}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function i(t,n){if(!A.$k)return!1;let s;try{s=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,E.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,j.$Lo)(s?"alpine":A.$u,u.$ec);return n.debug("ComputeTargetPlatform:",o),o}}),define(se[144],re([0,1,20,8,15,17,44,11,96,21,26,37]),function(J,e,O,j,k,A,D,E,u,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;const d=R=>(0,u.localize)(0,null,R),p=(0,u.localize)(1,null,"ms-dotnettools.csharp");let y=class{constructor(m,c,w){this.a=m,this.b=c,this.d=w}get f(){}async listExtensions(m,c,w){let $=await this.b.getInstalled(1,w);const h=v.$Am.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),$=$.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of $)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(m?`${g}@${i.manifest.version}`:g))}async installExtensions(m,c,w,$){const h=[];try{m.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...w,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||w.installPreReleaseVersion}})};for(const n of m)if(n instanceof E.URI)g.push({vsix:n,installOptions:w});else{const[s,o]=(0,b.$gp)(n);r(s,o,!1)}for(const n of c)if(n instanceof E.URI)g.push({vsix:n,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,b.$gp)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,w.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,$,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,$);h.push(...n)}}catch(g){throw this.a.error((0,u.localize)(5,null,(0,j.$0)(g))),g}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(m){const c=await this.b.getInstalled(1,m),w=[];for(const i of c)i.identifier.uuid&&w.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,w.length));const $=await this.d.getExtensions(w,{compatible:!0},O.CancellationToken.None),h=[];for(const i of $)for(const r of c)(0,b.$ep)(r.identifier,i.identifier)&&(0,D.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(h);for(const i of g)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,j.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(m,c,w){if(m=m.filter(({id:i,version:r})=>{const t=c.find(n=>(0,b.$ep)(n.identifier,{id:i}));if(t){if(!w&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!m.length)return[];const $=[],h=[],g=await this.j(m);if(await Promise.all(m.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${p}`),$.push(i);return}try{const o=await this.d.getManifest(n,O.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(i);return}const s=c.find(o=>(0,b.$ep)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,j.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(m,c,w,$){const h=await this.b.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.l(h,w,c.profileLocation,$))try{await this.b.install(m,c),this.a.info((0,u.localize)(22,null,(0,A.$Qg)(m)))}catch(i){if((0,j.$4)(i))this.a.info((0,u.localize)(23,null,(0,A.$Qg)(m)));else throw i}}async j(m){const c=new Map,w=m.some(g=>g.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),h=[];for(const g of m)a.$Eo.test(g.id)&&h.push({...g,preRelease:w});if(h.length){const g=await this.d.getExtensions(h,{targetPlatform:$},O.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(m){return!0}async l(m,c,w,$){if(!c){const h={id:(0,b.$jp)(m.publisher,m.name)},g=$.find(i=>(0,b.$ep)(h,i.identifier)&&(0,D.gt)(i.manifest.version,m.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,c,w){const $=async g=>{if(g instanceof E.URI){const i=await this.b.getManifest(g);return(0,b.$hp)(i.publisher,i.name)}return g},h=[];for(const g of m){const i=await $(g),t=(await this.b.getInstalled(void 0,w)).filter(n=>(0,b.$ep)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${p}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:w}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(m){const c=await this.b.getInstalled();m.forEach(w=>{c.forEach($=>{if($.identifier.id===w&&$.location.scheme===k.Schemas.file){this.a.info($.location.fsPath);return}})})}m(m){return this.f?(0,u.localize)(30,null,m,this.f):(0,u.localize)(31,null,m)}};e.$Xp=y,e.$Xp=y=$e([oe(1,a.$So),oe(2,a.$Po)],y)}),define(se[145],re([0,1,9,8,2,15,17,44,3,28,24,49,29,18,21,26,64,13,5]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;let h=class extends k.$Tc{static{$=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,D.$Tg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new y.$Qo(o.message,y.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===w.LogLevel.Trace)}catch(l){const S=l;if(s=S.code,S.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${S.output}`),s===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new y.$Qo(v.$2p,y.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$Zf)(r)?r:!0}async u(i){await this.g;const r=(0,D.$Tg)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new y.$Qo(t.message,y.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const n=(0,D.$Tg)(this.extensionsDownloadDir,`.${(0,a.$Cg)()}`);await this.h.exists(n)||await t(n);try{await b.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,j.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith($.c))n.push(l.resource);else{const S=R.$fp.parse(l.name);S&&t.push([S,l])}const s=(0,R.$kp)(t,([l])=>l),o=[];for(const l of s)l.sort((S,I)=>E.rcompare(S[0].version,I[0].version)),r.push(...l.slice(1).map(S=>S[1].resource)),o.push(l[0][1]);o.sort((l,S)=>l.mtime-S.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await O.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?R.$fp.create(i).toString().toLowerCase():(0,a.$Cg)()}};e.$iq=h,e.$iq=h=$=$e([oe(0,p.$oi),oe(1,c.$Mk),oe(2,y.$Po),oe(3,d.$Mi),oe(4,m.$Vp),oe(5,w.$Mj)],h)}),define(se[146],re([0,1,7,2,31,26,37]),function(J,e,O,j,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class E extends j.$Tc{constructor(a,b,v,d,p,y,R){super(),this.f=a,this.g=b,this.h=v,this.j=d,this.m=p,this.n=y,this.r=R,this.a=this.B(new O.$6d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$3c),this.s().then(null,m=>R.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(b=>(this.c.set(b.id,(0,j.$Qc)(this.n.watch(this.m.extUri.dirname(b.extensionsResource)),this.n.watch(b.extensionsResource))),this.G(b.extensionsResource))))}catch(b){throw this.r.error(b),b}}async w(a){for(const b of a.extensions)this.I(this.L(b.identifier,b.version),a.profileLocation)}async y(a){for(const b of a.extensions){const v=this.L(b.identifier,b.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const b of a.extensions)this.J(this.L(b.identifier,b.version),a.profileLocation)}async C(a){const b=[],v=[];for(const d of a.extensions){const p=this.L(d.identifier,d.version);a.error?this.I(p,a.profileLocation):(this.J(p,a.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),v.push(this.f.scanInstalledExtensionAtLocation(d.location).then(y=>{y?b.push(y):this.r.info("Extension not found at the location",d.location.toString())},y=>this.r.error(y)))))}try{await Promise.all(v),b.length&&await this.H(b)}catch(d){this.r.error(d)}}D(a){for(const b of this.h.profiles)a.contains(b.extensionsResource,0,1)&&this.F(b.extensionsResource)}async F(a){const b=[],v=[],d=await this.j.scanProfileExtensions(a),p=new Set,y=new Set;for(const[R,m]of this.b)m.has(a)&&y.add(R);for(const R of d){const m=this.L(R.identifier,R.version);p.add(m),y.has(m)||(b.push(R.identifier),this.I(m,a))}for(const R of y)if(!p.has(R)){const m=this.M(R);m&&(v.push(m.identifier),this.J(R,a))}(b.length||v.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const b=await this.j.scanProfileExtensions(a);for(const v of b)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,b){let v=this.b.get(a);v||this.b.set(a,v=new k.$Bc(d=>this.m.extUri.getComparisonKey(d))),v.add(b)}J(a,b){const v=this.b.get(a);v&&v.delete(b),v?.size||this.b.delete(a)}L(a,b){return`${D.$Bm.toKey(a.id)}@${b}`}M(a){const[b,v]=(0,A.$gp)(a);return v?{identifier:{id:b},version:v}:void 0}}e.$mq=E}),define(se[147],re([0,1,118,41]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=k;async function k(A,D,E,u,a,b,v){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${D.nameShort})`};if((0,j.$9o)(D,E)&&(0,j.$$o)(u)===3){const p=await(0,O.$Qp)(E,a,b);d["X-Market-User-Id"]=p,d["VSCode-SessionId"]=v.machineId||p}return d}}),define(se[148],re([0,1,175,19,9,2,15,16,24,18,21,26,5,63,11]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;let R=class extends p.$yr{constructor($,h,g,i){super(g),this.h=$,this.j=i,this.g=this.B(new m(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[$];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),h=Object.keys($).map(g=>{const i=$[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((g,i)=>g.label.localeCompare(i.label)),h}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const h=await this.g.getLanguagePacks();Object.keys(h).some(g=>h[g]&&h[g].extensions.some(i=>(0,v.$ep)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(h);return!(0,j.$ub)(Object.keys($),Object.keys(g))}};e.$zr=R,e.$zr=R=$e([oe(0,b.$So),oe(1,a.$oi),oe(2,b.$Po),oe(3,d.$Mj)],R);let m=class extends A.$Tc{constructor($,h){super(),this.j=h,this.c={},this.f=(0,E.$jc)($.userDataPath,"languagepacks.json"),this.g=new k.$nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(h=>{Object.keys(h).forEach(g=>delete h[g]),this.m(h,...$)}).then(()=>this.c)}m($,...h){for(const g of h)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n($,g);Object.keys($).forEach(g=>this.r($[g]))}n($,h){const g=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===D.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const n=t.extensions.filter(s=>(0,v.$ep)(s.extensionIdentifier,g))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:g,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$jc)(h.location.fsPath,s.path)}}r($){if($){const h=(0,O.createHash)("md5");for(const g of $.extensions)h.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);$.hash=h.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(h=$(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,g=>this.j.error(g))})}};m=$e([oe(0,a.$oi),oe(1,d.$Mj)],m);function c(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const $ of w.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(se[149],re([0,1,83,8,27,41]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function u(b,v,d){const p=await(0,O.$AD)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,O.$AD)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new p.AppInsightsCore,m=new y.PostChannel,c={instrumentationKey:b,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){c.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[m.identifier]=w}return R.initialize(c,[]),R.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),R}class a{constructor(v,d,p,y,R){this.e=v,this.f=d,this.g=p,this.h=R,this.c=D,this.d=E,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{v(d)},d=>{(0,j.$1)(d),console.error(d)})}}log(v,d){if(!this.a)return;d=(0,k.$Pn)(d,this.g),d=(0,A.$_o)(d);const p=this.f+"/"+v;try{this.i(y=>{y.pluginVersionString=d?.properties.version??"Unknown",y.track({name:p,baseData:{name:p,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$IP=a}),define(se[150],re([0,1,2,27,12,30,109,29,40,151,32,36,25,41]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,w,$){this.k=w,this.l=$,this.d={},this.i=new O.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,A.$Ye)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ye)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Tl)||h.affectsConfiguration(d.$Vl)||h.affectsConfiguration(d.$Ul))&&this.m()}))}setExperimentProperty(c,w){this.d[c]=w}m(){let c=(0,p.$$o)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const $=w.usage?3:w.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,w,$){this.g<w||($=(0,j.$Pn)($,this.d),$=(0,p.$dp)($,this.j),$=(0,j.$Pn)($,this.c),this.b.forEach(h=>h.log(c,$)))}publicLog(c,w){this.n(c,3,w)}publicLog2(c,w){this.publicLog(c,w)}publicLogError(c,w){this.h&&this.n(c,2,w)}publicLogError2(c,w){this.publicLogError(c,w)}};e.$Fr=y,e.$Fr=y=$e([oe(1,E.$Mi),oe(2,b.$6j)],y);function R(){const m=(0,D.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=k.$o?"":(0,D.localize)(3,null),$=(0,D.localize)(4,null),h=(0,D.localize)(5,null),g=(0,D.localize)(6,null),i=(0,D.localize)(7,null),r=`
|       | ${$} | ${h} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${m} ${c} ${w}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}v.$Yn.as(u.$4n.Configuration).registerConfiguration({id:d.$Sl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[d.$Tl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Yn.as(u.$4n.Configuration).registerConfiguration({id:d.$Sl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[d.$Vl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,D.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,D.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${d.$Tl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[152],re([0,1,14,20,176,149]),function(J,e,O,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=void 0;async function D(b,v){const d=await v.request(b,j.CancellationToken.None),p=(await(0,O.$Fe)(d.stream)).toString(),y=d.res.statusCode??200;return{headers:d.res.headers,statusCode:y,responseData:p}}async function E(b){const v={method:b.type,headers:b.headers};return new Promise((p,y)=>{const R=k.request(b.url??"",v,m=>{m.on("data",function(c){p({headers:m.headers,statusCode:m.statusCode??200,responseData:c.toString()})}),m.on("error",function(c){y(c)})});R.write(b.data,m=>{m&&y(m)}),R.end()})}async function u(b,v,d){const p=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),y={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:p};try{const R=b?await D(y,b):await E(y);d(R.statusCode,R.headers,R.responseData)}catch{d(0,{})}}class a extends A.$IP{constructor(v,d,p,y,R){const m={sendPOST:(c,w)=>{u(v,c,w)}};super(d,p,y,R,m)}}e.$JP=a}),define(se[153],re([0,1,16,24]),function(J,e,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=k;async function k(A,D){const E=Object.create(null),u=(b,v)=>{const d=JSON.parse(b);E[v]=d};if(D){const b=[],v=await j.Promises.readdir(D);for(const p of v)try{(await j.Promises.stat((0,O.$jc)(D,p))).isDirectory()&&b.push(p)}catch{}const d=[];for(const p of b)(await j.Promises.readdir((0,O.$jc)(D,p))).filter(R=>R==="telemetry.json").length===1&&d.push(p);for(const p of d){const y=(await j.Promises.readFile((0,O.$jc)(D,p,"telemetry.json"))).toString();u(y,p)}}let a=(await j.Promises.readFile((0,O.$jc)(A,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await j.Promises.readFile((0,O.$jc)(A,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(se[154],re([0,1,12,84,25]),function(J,e,O,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=A,e.$Zac=D;async function A(E,u){let a=E.getItem(k.$Ql);return(typeof a!="string"||O.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,j.$pn)(u.error.bind(u))),a}async function D(E,u){let a=E.getItem(k.$Rl);return typeof a!="string"&&(a=await(0,j.$qn)(u.error.bind(u))),a}}),define(se[22],re([0,1,10]),function(J,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=void 0,e.$kl=(0,O.$gi)("IUriIdentityService")}),define(se[155],re([0,1,22,119,13,17,75,7,2]),function(J,e,O,j,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let b=class{constructor(d){this.g=d,this.c=new u.$Sc,this.f=2**16;const p=new Map,y=R=>{let m=p.get(R.scheme);return m===void 0&&(m=d.hasProvider(R)&&!this.g.hasCapability(R,1024),p.set(R.scheme,m)),m};this.c.add(E.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(R=>{p.delete(R.scheme)})),this.extUri=new A.$Ig(y),this.d=new D.$es((R,m)=>this.extUri.compare(R,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$Ug)(d));const p=this.d.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((y,R)=>y[1].time<R[1].time?1:y[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const p=this.f*.5;for(let y=0;y<p;y++)this.d.set(d[y][0],d[y][1].touch())}};e.$fs=b,e.$fs=b=$e([oe(0,k.$Mk)],b),(0,j.$cs)(O.$kl,b,1)}),define(se[156],re([0,1,7,2,13,48,31]),function(J,e,O,j,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class E extends j.$Tc{constructor(a,b,v,d,p,y){super(),this.f=a,this.g=b,this.h=v,this.j=d,this.m=p,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$6d),this.onDidChangeFile=this.a.event,this.b=A.$mi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,b){return this.g.open(this.t(a),b)}close(a){return this.g.close(a)}read(a,b,v,d,p){return this.g.read(a,b,v,d,p)}write(a,b,v,d,p){return this.g.write(a,b,v,d,p)}watch(a,b){this.b.set(a,a);const v=this.g.watch(this.t(a),b);return(0,j.$Rc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,b,v){return this.g.rename(this.t(a),this.t(b),v)}readFile(a,b){return this.g.readFile(this.t(a),b)}readFileStream(a,b,v){return this.g.readFileStream(this.t(a),b,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,b,v){return this.g.writeFile(this.t(a),b,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,b){return this.g.delete(this.t(a),b)}copy(a,b,v){if((0,k.$Qk)(this.g))return this.g.copy(this.t(a),this.t(b),v);throw new Error("copy not supported")}cloneFile(a,b){if((0,k.$Rk)(this.g))return this.g.cloneFile(this.t(a),this.t(b));throw new Error("clone not supported")}s(a){const b=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const d=this.u(v.resource);this.b.findSubstr(d)&&b.push({resource:d,type:v.type,cId:v.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$kbc=E}),define(se[157],re([0,1,111,16,48,17,11,10,15]),function(J,e,O,j,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Ai=e.$zi=e.WorkbenchState=e.$ti=e.$si=e.$pi=void 0,e.$qi=a,e.$ri=b,e.$ui=v,e.$vi=d,e.$wi=p,e.$xi=R,e.$yi=m,e.$Bi=$,e.$Gi=h,e.$Hi=g,e.$Ji=i,e.$Ki=r,e.$Li=t,e.$pi=(0,E.$gi)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}function b(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function v(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,j.$nc)(n)}:s?e.$si:e.$ti;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const s=n;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}function p(n){const s=n;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function R(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function m(n){const s=n;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,l,S,I){this.h=s,this.j=l,this.k=S,this.l=I,this.c=k.$mi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=c;class w{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$Tg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=w;function $(n){return new w({uri:n,index:0,name:(0,A.$Pg)(n)},{uri:n.toString()})}e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,O.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function h(n,s){return A.$Kg.isEqualOrParent(n,s.untitledWorkspacesHome)}function g(n){let s;return D.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Ii}function r(n,s){return!h(n,s)&&!g(n)}function t(n){return(typeof n=="string"?(0,j.$oc)(n):(0,A.$Rg)(n))===e.$Di}}),define(se[23],re([0,1,43,7,2,17,11,110,18,13,10,5,157,31,22,9,28,30,3]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ml=e.ProfileResourceType=void 0,e.$ll=h,e.$nl=g,e.$ol=i;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&D.URI.isUri(s.location)&&D.URI.isUri(s.globalStorageHome)&&D.URI.isUri(s.settingsResource)&&D.URI.isUri(s.keybindingsResource)&&D.URI.isUri(s.tasksResource)&&D.URI.isUri(s.snippetsHome)&&D.URI.isUri(s.extensionsResource))}e.$ml=(0,b.$gi)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:D.URI.revive(n.location).with({scheme:s}),globalStorageHome:D.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:D.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:D.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:D.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:D.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:D.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:D.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,s,o,l,S,I){return{id:n,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:I&&S?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$Tg)(o,"globalStorage"),settingsResource:I&&S?.useDefaultFlags?.settings?I.settingsResource:(0,A.$Tg)(o,"settings.json"),keybindingsResource:I&&S?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$Tg)(o,"keybindings.json"),tasksResource:I&&S?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$Tg)(o,"tasks.json"),snippetsHome:I&&S?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$Tg)(o,"snippets"),extensionsResource:I&&S?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$Tg)(o,"extensions.json"),cacheHome:(0,A.$Tg)(l,n),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends k.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,S){super(),this.t=s,this.u=o,this.w=l,this.y=S,this.f=!0,this.h=this.B(new j.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,w.$Tf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,A.$Qg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new p.$Ac,S=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[L,T]of Object.entries(I.workspaces)){const z=D.URI.parse(L),V=o.find(Q=>Q.id===T);V&&l.set(z,V)}if(I.emptyWindows)for(const[L,T]of Object.entries(I.emptyWindows)){const z=o.find(V=>V.id===T);z&&S.set(L,z)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:S}}return this.z}D(){const s=i("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Ye)(o)}\\s(\\d+)`);let S=0;for(const L of this.profiles){const T=l.exec(L.name),z=T?parseInt(T[1]):0;S=z>S?z:S}const I=`${o} ${S+1}`;return this.createProfile((0,O.$7i)((0,m.$Cg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,O.$7i)((0,m.$Cg)()).toString(16),s,o,l)}async createProfile(s,o,l,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return S&&await this.setProfileForWorkspace(S,I),I}async F(s,o,l){if(!(0,w.$Tf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{const I=this.profiles.find(z=>z.name===o||z.id===s);if(I)return I;const L=i(s,o,(0,A.$Tg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(L.location);const T=[];return this.j.fire({profile:L,join(z){T.push(z)}}),await R.Promises.settled(T),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(S=>S.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(S){l.push(S)}});try{await Promise.allSettled(l)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$4k)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(S=>S.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return D.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$qi)(s)?s.uri:(0,d.$vi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const S=[...this.profiles,...s],I=[];this.s.profiles=[];for(let L of S)L.isDefault||o.some(T=>L.id===T.id)||(L=l.find(T=>L.id===T.id)??L,L.isTransient?this.s.profiles.push(L):I.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const S=this.G(s),I=l?this.s:this.C;D.URI.isUri(S)?(I.workspaces.delete(S),o&&I.workspaces.set(S,o)):(I.emptyWindows.delete(S),o&&I.emptyWindows.set(S,o)),l||this.M()}M(){const s={};for(const[l,S]of this.C.workspaces.entries())s[l.toString()]=S.id;const o={};for(const[l,S]of this.C.emptyWindows.entries())o[l.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,L]of Object.entries(s.workspaces)){const T=D.URI.parse(L);o[I]=this.w.extUri.isEqual(T,l.location)?l.id:this.w.extUri.basename(T)}const S={};if(s.emptyWindows)for(const[I,L]of Object.entries(s.emptyWindows)){const T=D.URI.parse(L);S[I]=this.w.extUri.isEqual(T,l.location)?l.id:this.w.extUri.basename(T)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$pl=r,e.$pl=r=$e([oe(0,u.$ni),oe(1,a.$Mk),oe(2,y.$kl),oe(3,v.$Mj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$ql=t}),define(se[158],re([0,1,19,9,20,8,7,2,12,3,11,94,21,26,37,5,32,25,22,23]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$7p=void 0,e.$8p=g,e.$9p=i;let h=class extends E.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,S,I,L){super(),this.z=s,this.C=o,this.D=l,this.F=S,this.G=I,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$6d),this.s=this.B(new D.$6d),this.t=this.B(new D.$6d),this.u=this.B(new D.$6d),this.w=this.B(new D.$6d),this.y=[],this.B((0,E.$Rc)(()=>{this.j.forEach(({task:T})=>T.cancel()),this.m.forEach(T=>T.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$No)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const S=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,p.$ep)(I,s.identifier));if(S?.local)return S?.local;throw S?.error?S.error:new d.$Qo(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Qo(v.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:S,options:I})=>{try{const L=await this.N(S,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});l.push({...L,options:I})}catch(L){o.push({identifier:S.identifier,operation:2,source:S,error:L})}})),l.length&&o.push(...await this.I(l));for(const S of o)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!b.URI.isUri(S.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,p.$mp)(S.source),error:S.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,y.$Em)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const S of this.H.profiles){const I=(await this.getInstalled(1,S.extensionsResource)).find(L=>(0,p.$ep)(L.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:S.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,S=[],I=[],L=(z,V)=>`${p.$fp.create(z).toString()}-${V.toString()}`,T=(z,V,Q)=>{const ne=this.Y(z,V,Q),te=b.URI.isUri(V)?V.path:`${V.identifier.id.toLowerCase()}-${Q.profileLocation.toString()}`;l.set(te,{task:ne,manifest:z}),this.n.fire({identifier:ne.identifier,source:V,profileLocation:Q.profileLocation}),this.F.info("Installing extension:",ne.identifier.id),b.URI.isUri(V)||this.j.set(L(V,Q.profileLocation),{task:ne,waitingTasks:[]})};try{for(const{manifest:z,extension:V,options:Q}of s){const ne=Q.isApplicationScoped||Q.isBuiltin||(0,y.$Em)(z),te={...Q,installOnlyNewlyAddedFromExtensionPack:Q.installOnlyNewlyAddedFromExtensionPack??!b.URI.isUri(V),isApplicationScoped:ne,profileLocation:ne?this.H.defaultProfile.extensionsResource:Q.profileLocation??this.X(),productVersion:Q.productVersion??{version:this.G.version,date:this.G.date}},ue=b.URI.isUri(V)?void 0:this.j.get(L(V,te.profileLocation));ue?(this.F.info("Extension is already requested to install",ue.task.identifier.id),S.push(ue.task.waitUntilTaskIsFinished())):T(z,V,te)}await Promise.all([...l.values()].map(async({task:z,manifest:V})=>{if(z.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const Q=await this.M(z.identifier,V,!!z.options.installOnlyNewlyAddedFromExtensionPack,!!z.options.installPreReleaseVersion,z.options.profileLocation,z.options.productVersion),ne=await this.getInstalled(void 0,z.options.profileLocation,z.options.productVersion),te={...z.options,donotIncludePackAndDependencies:!0,context:{...z.options.context,[d.$Io]:!0}};for(const{gallery:ue,manifest:fe}of(0,O.$Mb)(Q,({gallery:ce})=>ce.identifier.id)){if(l.has(`${ue.identifier.id.toLowerCase()}-${te.profileLocation.toString()}`))continue;const ce=this.j.get(L(ue,te.profileLocation));if(ce){if(this.J(z,ce.task)){const B=ce.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,z.identifier.id),ce.waitingTasks.push(z),S.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,X=>X.some(q=>(0,p.$ep)(q.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,z.identifier.id),!X.find(F=>(0,p.$ep)(F.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else ne.some(({identifier:B})=>(0,p.$ep)(B,ue.identifier))||T(fe,ue,te)}}catch(Q){if(b.URI.isUri(z.source))(0,O.$Lb)(V.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,Q.message),(0,O.$Lb)(V.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,Q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),Q}})),await this.L([...l.values()].map(async({task:z})=>{const V=new Date().getTime();try{const Q=await z.run();if(await this.L(this.y.map(ne=>ne.postInstall(Q,z.source,z.options,k.CancellationToken.None))),!b.URI.isUri(z.source)){const ne=z.operation===3,te=ne?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(r(this.C,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$mp)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:te}),u.$o&&z.operation!==3)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}I.push({local:Q,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw this.F.error("Error while installing the extension",z.identifier.id,(0,A.$0)(Q)),Q}})),S.length&&await this.L(S);for(const z of I)this.F.info("Extension installed successfully:",z.identifier.id),o.push(z);return o}catch(z){I.length&&await Promise.allSettled(I.map(async({local:V,profileLocation:Q})=>{try{await this.Z(V,{versionOnly:!0,profileLocation:Q}).run(),this.F.info("Rollback: Uninstalled extension",V.identifier.id)}catch(ne){this.F.warn("Rollback: Error while uninstalling extension",V.identifier.id,(0,A.$0)(ne))}}));for(const{task:V}of l.values())V.cancel(),o.push({identifier:V.identifier,operation:2,source:V.source,context:V.options.context,profileLocation:V.profileLocation,error:z});throw z}finally{for(const{task:z}of l.values())z.source&&!b.URI.isUri(z.source)&&this.j.delete(L(z.source,z.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:S}]of this.j.entries())if(l===s&&(S.includes(o)||S.some(I=>this.J(I,o)))||l===o&&S[0]&&!this.J(s,S[0]))return!1;return!0}async L(s){const o=[],l=[],S=await Promise.allSettled(s);for(const I of S)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,S,I,L){if(!this.z.isEnabled())return[];const T=await this.getInstalled(void 0,I,L),z=[],V=[],Q=async(ne,te)=>{z.push(ne);const ue=te.extensionDependencies||[],fe=[...ue];if(te.extensionPack){const ce=l?T.find(B=>(0,p.$ep)(B.identifier,ne)):void 0;for(const B of te.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(X=>(0,p.$ep)({id:X},{id:B}))||fe.every(X=>!(0,p.$ep)({id:X},{id:B}))&&fe.push(B)}if(fe.length){const ce=fe.filter(B=>z.every(X=>!(0,p.$ep)(X,{id:B})));if(ce.length){const B=await this.z.getExtensions(ce.map(X=>({id:X,preRelease:S})),k.CancellationToken.None);for(const X of B){if(z.find(H=>(0,p.$ep)(H,X.identifier)))continue;const q=ue.some(H=>(0,p.$ep)({id:H},X.identifier));let F;try{F=await this.N(X,!1,S,L)}catch(H){if(q)throw H;this.F.info("Skipping the packed extension as it cannot be installed",X.identifier.id,(0,A.$0)(H));continue}V.push({gallery:F.extension,manifest:F.manifest}),await Q(F.extension.identifier,F.manifest)}}}};return await Q(s,o),V}async N(s,o,l,S){let I;const L=await this.getExtensionsControlManifest();if(L.malicious.some(V=>(0,p.$ep)(s.identifier,V)))throw new d.$Qo(v.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const T=L.deprecated[s.identifier.id.toLowerCase()];if(T?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${T.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:T.extension.id,preRelease:T.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:S},k.CancellationToken.None))[0],!I)throw new d.$Qo(v.localize(2,null,s.identifier.id,T.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const V=await this.getTargetPlatform();throw new d.$Qo(v.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Jo)(V)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,o,l,S),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],k.CancellationToken.None))[0]?new d.$Qo(v.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Qo(v.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const z=await this.z.getManifest(I,k.CancellationToken.None);if(z===null)throw new d.$Qo(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(z.version!==I.version)throw new d.$Qo(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:z}}async O(s,o,l,S){const I=await this.getTargetPlatform();let L=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(L=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0,productVersion:S},k.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(s,l,I,S)&&(L=s),L||(o?L=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:S},k.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(s,l,I,S)),L}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},S=Q=>`${Q.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(S(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const L=Q=>{const ne=this.Z(Q,l);return this.m.set(S(ne.extension.identifier),ne),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this.t.fire({identifier:Q.identifier,profileLocation:l.profileLocation,applicationScoped:Q.isApplicationScoped}),ne},T=(Q,ne)=>{ne?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,l.profileLocation.toString(),ne.message):this.F.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,ne.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$lp)(Q),error:ne}),this.u.fire({identifier:Q.identifier,error:ne?.code,profileLocation:l.profileLocation,applicationScoped:Q.isApplicationScoped})},z=[],V=[];try{z.push(L(s));const Q=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const ne=this.S(s,Q);for(const te of ne)this.m.has(S(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):z.push(L(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(z.map(ne=>ne.extension),Q,s),await this.L(z.map(async ne=>{try{if(await ne.run(),await this.L(this.y.map(te=>te.postUninstall(ne.extension,l,k.CancellationToken.None))),ne.extension.identifier.uuid)try{await this.z.reportStatistic(ne.extension.manifest.publisher,ne.extension.manifest.name,ne.extension.manifest.version,"uninstall")}catch{}T(ne.extension)}catch(te){const ue=te instanceof d.$Qo?te:new d.$Qo((0,A.$0)(te),d.ExtensionManagementErrorCode.Internal);throw T(ne.extension,ue),ue}finally{V.push(ne)}}))}catch(Q){const ne=Q instanceof d.$Qo?Q:new d.$Qo((0,A.$0)(Q),d.ExtensionManagementErrorCode.Internal);for(const te of z){try{te.cancel()}catch{}V.includes(te)||T(te.extension,ne)}throw ne}finally{for(const Q of z)this.m.delete(S(Q.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}Q(s,o,l){for(const S of s){const I=this.U(S,o);if(I.length){const L=I.filter(T=>!s.some(z=>(0,p.$ep)(z.identifier,T.identifier)));if(L.length)throw new Error(this.R(S,L,l))}}}R(s,o,l){return l===s?o.length===1?v.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?v.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const S=s.manifest.extensionPack?s.manifest.extensionPack:[];if(S.length){const I=o.filter(T=>!T.isBuiltin&&S.some(z=>(0,p.$ep)({id:z},T.identifier))),L=[];for(const T of I)L.push(...this.S(T,o,l));return[...I,...L]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(S=>(0,p.$ep)({id:S},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$7p=h,e.$7p=h=$e([oe(0,d.$Po),oe(1,c.$Ll),oe(2,w.$kl),oe(3,R.$Mj),oe(4,m.$6j),oe(5,$.$ml)],h);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}function i(n){if(n instanceof d.$Qo)return n;if(n instanceof d.$Ro){const o=new d.$Qo(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Qo(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function r(n,s,{extensionData:o,verificationStatus:l,duration:S,error:I,durationSinceUpdate:L}){let T,z;(0,a.$2f)(l)&&(l===!0?l="Verified":(l===!1||(T=d.ExtensionManagementErrorCode.Signature,z=l),l="Unverified")),I&&(I instanceof d.$Qo||I instanceof d.$Ro?(T=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(z=I.message)):T=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:S,errorcode:T,errorcodeDetail:z,durationSinceUpdate:L})}class t{constructor(){this.d=new j.$fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,j.$6g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$6g)(s=>new Promise((o,l)=>{const S=s.onCancellationRequested(()=>{S.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$0p=t}),define(se[42],re([0,1,9,14,2,7,31,11,21,26,13,10,5,23,22,3,8,25]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class $ extends Error{constructor(t,n){super(t),this.code=n}}e.$$p=$,e.$_p=(0,v.$gi)("IExtensionsProfileScannerService");let h=class extends k.$Tc{constructor(t,n,s,o,l,S){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=S,this.b=this.B(new A.$6d),this.onAddExtensions=this.b.event,this.c=this.B(new A.$6d),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$6d),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$6d),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n,s){const o=[],l=[];try{return await this.u(n,S=>{const I=[];if(s)I.push(...S);else for(const L of S)t.some(([T])=>(0,a.$ep)(T.identifier,L.identifier)&&T.manifest.version!==L.version)?o.push(L):I.push(L);for(const[L,T]of t){const z=I.findIndex(Q=>(0,a.$ep)(Q.identifier,L.identifier)&&Q.version===L.manifest.version),V={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:T};z===-1?(l.push(V),I.push(V)):I.splice(z,1,V)}return l.length&&this.b.fire({extensions:l,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),l.length&&this.c.fire({extensions:l,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),l}catch(S){throw l.length&&this.c.fire({extensions:l,error:S,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:n}),S}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const S of o){const I=t.find(([L])=>(0,a.$ep)(L.identifier,S.identifier)&&L.manifest.version===S.version);I&&(S.metadata={...S.metadata,...I[1]},s.push(S)),l.push(S)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const S of o)(0,a.$ep)(S.identifier,t.identifier)?s.push(S):l.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const S=await this.m.readFile(t);l=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,b.$4k)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new $((0,m.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let S=!1;for(const I of l){g(I)||this.w(t);let L;if((0,R.$Tf)(I.relativeLocation)&&I.relativeLocation)L=this.z(I.relativeLocation);else if((0,R.$Tf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{L=E.URI.revive(I.location);const T=this.y(L);T&&(S=!0,I.relativeLocation=T)}(0,R.$1f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(S=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:L,version:I.version,metadata:I.metadata})}S&&await this.m.writeFile(t,j.$te.fromString(JSON.stringify(l)))}if(n){o=n(o);const S=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,j.$te.fromString(JSON.stringify(S)))}return o})}w(t){const n=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,b.$4k)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(S=>g(S))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$te.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.$4k)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,b.$4k)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,b.$4k)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new O.$nh,this.h.set(t,n)),n}};e.$aq=h,e.$aq=h=$e([oe(1,b.$Mk),oe(2,p.$ml),oe(3,y.$kl),oe(4,c.$Ll),oe(5,d.$Mj)],h);function g(r){return(0,R.$Vf)(r)&&(0,u.$Oo)(r.identifier)&&(i(r.location)||(0,R.$Tf)(r.location)&&r.location)&&((0,R.$1f)(r.relativeLocation)||(0,R.$Tf)(r.relativeLocation))&&r.version&&(0,R.$Tf)(r.version)}function i(r){return r?(0,R.$Tf)(r.path)&&(0,R.$Tf)(r.scheme):!1}}),define(se[52],re([0,1,19,9,27,14,8,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,5,32,7,47,42,23,22,116]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$,h,g,i,r,t,n,s,o,l,S,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$fq=e.$eq=e.$dq=e.Translations=void 0,e.$gq=ue;var z;(function(ce){function B(X,q){if(X===q)return!0;const F=Object.keys(X),H=new Set;for(const Z of Object.keys(q))H.add(Z);if(F.length!==H.size)return!1;for(const Z of F){if(X[Z]!==q[Z])return!1;H.delete(Z)}return H.size===0}ce.equals=B})(z||(e.Translations=z={})),e.$dq=(0,t.$gi)("IExtensionsScannerService");let V=class extends a.$Tc{constructor(B,X,q,F,H,Z,K,_,U,M,f,P){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=q,this.s=F,this.t=H,this.u=Z,this.w=K,this.y=_,this.z=U,this.C=M,this.D=f,this.F=P,this.g=this.B(new o.$6d),this.onDidChangeCache=this.g.event,this.h=(0,p.$Tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$pp)(this.w,this.y)),this.G}async scanAllExtensions(B,X,q){const[F,H]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),Z=q?await this.scanExtensionsUnderDevelopment(B,[...F,...H]):[];return this.L(F,H,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[q,F]=await Promise.all(X);return this.J([...q,...F],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const q=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,q,B.productVersion??this.R()),H=B.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let Z;try{Z=await H.scanExtensions(F)}catch(K){if(K instanceof S.$$p&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await H.scanExtensions(F);else throw K}return Z=await this.J(Z,1,B,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===b.Schemas.file).map(async F=>{const H=await this.P(F,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(K=>(K.type=X.find(_=>(0,h.$ep)(_.identifier,K.identifier))?.type??K.type,this.n.validate(K,H)))}))).flat();return this.J(q,"development",B,!0)}return[]}async scanExistingExtension(B,X,q){const F=await this.P(B,!1,X,!0,q.language,!0,void 0,q.productVersion??this.R()),H=await this.n.scanExtension(F);return!H||!q.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(B,X,q){const F=await this.P(B,!1,X,!0,q.language,!0,void 0,q.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(F);return this.J(H,X,q,!0)}async scanMetadata(B){const X=(0,p.$Tg)(B,"package.json"),q=(await this.w.readFile(X)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(B,X){const q=(0,p.$Tg)(B,"package.json"),F=(await this.w.readFile(q)).value.toString(),H=JSON.parse(F);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,p.$Tg)(B,"package.json"),A.$te.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof S.$$p&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$te.fromString(JSON.stringify([])))}catch(X){(0,r.$4k)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,q,F){return q.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),F)),q.includeInvalid||(B=B.filter(H=>H.isValid)),B.sort((H,Z)=>{const K=v.$nc(H.location.fsPath),_=v.$nc(Z.location.fsPath);return K<_?-1:K>_?1:0})}L(B,X,q,F,H){const Z=(_,U,M)=>{if(_.isValid&&!U.isValid)return!1;if(_.isValid===U.isValid){if(H&&y.gt(_.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(y.eq(_.manifest.version,U.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===F)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return M?this.y.warn(`Overwriting user extension ${_.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${U.location.path}.`),!0},K=new g.$Dm;return B?.forEach(_=>{const U=K.get(_.identifier.id);(!U||Z(U,_,!1))&&K.set(_.identifier.id,_)}),X?.forEach(_=>{const U=K.get(_.identifier.id);if(!U&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!U||Z(U,_,!1))&&K.set(_.identifier.id,_)}),q?.forEach(_=>{const U=K.get(_.identifier.id);(!U||Z(U,_,!0))&&K.set(_.identifier.id,_),K.set(_.identifier.id,_)}),[...K.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0,this.R()),H=await(B&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",H.length),H}async N(B,X){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const F=X?await this.O():{},H=[],Z=c.URI.file(v.$hc(v.$jc(b.$Ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of q){const U=F[_.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":H.push((0,p.$Tg)(Z,_.name));break;default:H.push(c.URI.file(U));break}}const K=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",K.length),(0,O.$Hb)(K)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,q,F,H,Z,K,_){const U=await this.f(H??d.$w),M=await this.Q(B),f=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=f?await this.Q(f):void 0;return new Q(B,M,f,P,X,K,q,F,Z,_.version,_.date,this.C.commit,!this.z.isBuilt,H,U)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$eq=V,e.$eq=V=$e([oe(4,I.$ml),oe(5,S.$_p),oe(6,r.$Mk),oe(7,n.$Mj),oe(8,$.$ni),oe(9,s.$6j),oe(10,L.$kl),oe(11,t.$fi)],V);class Q{constructor(B,X,q,F,H,Z,K,_,U,M,f,P,N,C,W){this.location=B,this.mtime=X,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=F,this.profile=H,this.profileScanOptions=Z,this.type=K,this.excludeObsolete=_,this.validate=U,this.productVersion=M,this.productDate=f,this.productCommit=P,this.devMode=N,this.language=C,this.translations=W}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,p.$Mg)(B.location,X.location)&&B.mtime===X.mtime&&(0,p.$Mg)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&k.$Qn(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&z.equals(B.translations,X.translations)}}e.$fq=Q;let ne=class extends a.$Tc{constructor(B,X,q,F,H){super(),this.f=B,this.g=X,this.h=q,this.j=F,this.m=H}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let q={};if(B.excludeObsolete&&B.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(F)}catch{}return(0,m.$7f)(q)?X:X.filter(F=>!q[h.$fp.create(F).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const q=await Promise.all(X.children.map(async F=>{if(!F.isDirectory||B.type===1&&(0,p.$Qg)(F.resource).indexOf(".")===0)return null;const H=new Q(F.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(H)}));return(0,O.$Hb)(q).sort((F,H)=>F.location.path<H.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(F=>!F.metadata?.isApplicationScoped);const q=await this.s(B.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,B);X.push(...q)}return X}async s(B,X,q){const F=await this.g.scanProfileExtensions(B,q.profileScanOptions);if(!F.length)return[];const H=await Promise.all(F.map(async Z=>{if(X(Z)){const K=new Q(Z.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(K,Z.metadata)}return null}));return(0,O.$Hb)(H)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,p.$Tg)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,D.$0)(X)),[]}}async scanExtension(B,X){try{let q=await this.scanExtensionManifest(B.location);if(q){q.publisher||(q.publisher=g.$xm),X=X??q.__metadata,delete q.__metadata;const F=(0,h.$jp)(q.publisher,q.name),H=X?.id?{id:F,uuid:X.id}:{id:F},Z=X?.isSystem?0:B.type,K=Z===0||!!X?.isBuiltin;q=await this.t(B.location,q,Q.createNlsConfiguration(B));const _={type:Z,identifier:H,manifest:q,location:B.location,isBuiltin:K,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(q){B.type!==0&&this.m.error(q)}return null}validate(B,X){let q=!0;const F=(0,i.$up)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[H,Z]of F)H===R.default.Error&&(q=!1,this.m.error(this.z(X.location,Z)));return B.isValid=q,B.validations=F,B}async scanExtensionManifest(B){const X=(0,p.$Tg)(B,"package.json");let q;try{q=(await this.j.readFile(X)).value.toString()}catch(H){return(0,r.$4k)(H)!==1&&this.m.error(this.z(B,(0,w.localize)(0,null,X.path,H.message))),null}let F;try{F=JSON.parse(q)}catch{const Z=[];(0,E.$tn)(q,Z);for(const K of Z)this.m.error(this.z(B,(0,w.localize)(1,null,X.path,K.offset,K.length,(0,u.$bq)(K.error))));return null}return(0,E.$Cn)(F)!=="object"?(this.m.error(this.z(B,(0,w.localize)(2,null,X.path))),null):F}async t(B,X,q){const F=await this.u(B,X,q);if(F)try{const H=[],Z=await this.w(F.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(B,(0,w.localize)(3,null,F.default?.path,(0,u.$bq)(_.error))))}),X;if((0,E.$Cn)(F)!=="object")return this.m.error(this.z(B,(0,w.localize)(4,null,F.default?.path))),X;const K=F.values||Object.create(null);return(0,T.$cq)(this.m,X,K,Z)}catch{}return X}async u(B,X,q){const F=(0,p.$Tg)(B,"package.nls.json"),H=(U,M)=>{M.forEach(f=>{this.m.error(this.z(B,(0,w.localize)(5,null,U?.path,(0,u.$bq)(f.error))))})},Z=U=>{this.m.error(this.z(B,(0,w.localize)(6,null,U?.path)))},K=`${X.publisher}.${X.name}`,_=q.translations[K];if(_)try{const U=c.URI.file(_),M=(await this.j.readFile(U)).value.toString(),f=[],P=(0,E.$tn)(M,f);return f.length>0?(H(U,f),{values:void 0,default:F}):(0,E.$Cn)(P)!=="object"?(Z(U),{values:void 0,default:F}):{values:P.contents?P.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let M;try{M=await this.y(B,q)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const f=(await this.j.readFile(M.localized)).value.toString(),P=[],N=(0,E.$tn)(f,P);return P.length>0?(H(M.localized,P),{values:void 0,default:M.original}):(0,E.$Cn)(N)!=="object"?(Z(M.localized),{values:void 0,default:M.original}):{values:N,default:M.original}}catch{return{values:void 0,default:M.original}}}}async w(B,X){if(B)try{const q=(await this.j.readFile(B)).value.toString();return(0,E.$tn)(q,X)}catch{}}y(B,X){return new Promise((q,F)=>{const H=Z=>{const K=(0,p.$Tg)(B,`package.nls.${Z}.json`);this.j.exists(K).then(_=>{_&&q({localized:K,original:(0,p.$Tg)(B,"package.nls.json")});const U=Z.lastIndexOf("-");U===-1?q({localized:(0,p.$Tg)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,U),H(Z))})};if(X.devMode||X.pseudo||!X.language)return q({localized:(0,p.$Tg)(B,"package.nls.json"),original:null});H(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};ne=$e([oe(1,S.$_p),oe(2,L.$kl),oe(3,r.$Mk),oe(4,n.$Mj)],ne);let te=class extends ne{constructor(B,X,q,F,H,Z,K){super(X,F,H,Z,K),this.G=B,this.H=q,this.D=this.B(new j.$eh(3e3)),this.F=this.B(new o.$6d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),q=await this.I(X);if(this.C=B,q&&q.input&&Q.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),q.result.map(H=>(H.location=c.URI.revive(H.location),H));const F=await super.scanExtensions(B);return await this.J(X,{input:B,result:F}),F}async I(B){try{const X=await this.j.readFile(B),q=JSON.parse(X.value.toString());return{result:q.result,input:(0,l.$Ph)(q.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,D.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,A.$te.fromString(JSON.stringify(X)))}catch(q){this.m.debug("Error while writing the extension cache file:",B.path,(0,D.$0)(q))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const q=X.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$Qn(F,q))try{this.m.info("Invalidating Cache",q,F),await this.j.del(B),this.F.fire()}catch(H){this.m.error(H)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?g.$wm:g.$vm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};te=$e([oe(2,I.$ml),oe(3,S.$_p),oe(4,L.$kl),oe(5,r.$Mk),oe(6,n.$Mj)],te);function ue(ce,B){const X=(0,h.$hp)(ce.manifest.publisher,ce.manifest.name);return{id:X,identifier:new g.$Bm(X),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:B,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}class fe extends V{constructor(B,X,q,F,H,Z,K,_,U,M,f,P){super(B,X,(0,p.$Tg)(q,".vscode-oss-dev","extensions","control.json"),F,H,Z,K,_,U,M,f,P),this.S=(async()=>{if(d.$z)try{const N=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$hq=fe}),define(se[159],re([0,1,58,9,34,7,2,15,16,24,5,23]),function(J,e,O,j,k,A,D,E,u,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;let d=class extends D.$Tc{constructor(y,R){super(),this.b=y,this.f=R,this.a=new j.$mh(5)}async postUninstall(y){const R=this.g(y,"uninstall");R&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(m)}}));try{await a.Promises.rm(this.m(y))}catch(m){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(m)}}g(y,R){const m=`vscode:${R}`;if(y.location.scheme===E.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[m]=="string"){const c=y.manifest.scripts[m].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${m} should be a node script`),null):{script:(0,u.$jc)(y.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(y,R,m,c,w){return new Promise(($,h)=>{const g=this.j(y,R,m,w);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):$(void 0)};g.on("error",t=>{r((0,k.$4i)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${R} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),h("timed out")},5e3))})}j(y,R,m,c){const w={silent:!0,execArgv:void 0},$=(0,O.fork)(y,[`--type=extension-post-${R}`,...m],w);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const h=A.Event.fromNodeEventEmitter($.stdout,"data"),g=A.Event.fromNodeEventEmitter($.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${R}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${R}`,t));const i=A.Event.any(A.Event.map(h,t=>({data:`%c${t}`,format:[""]})),A.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(y){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};e.$jq=d,e.$jq=d=$e([oe(0,v.$ml),oe(1,b.$Mj)],d)}),define(se[160],re([0,1,9,14,20,34,8,7,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,158,21,26,42,52,145,159,117,138,146,50,13,10,5,32,25,22,23]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$,h,g,i,r,t,n,s,o,l,S,I,L,T,z,V,Q,ne,te,ue,fe,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.$nq=void 0,e.$nq=(0,Q.$hi)(t.$So);const B=".vsctmp";let X=class extends r.$7p{constructor(U,M,f,P,N,C,W,G,ie,ae,le,pe){super(U,M,le,f,ae,pe),this.eb=N,this.fb=C,this.gb=W,this.hb=ie,this.db=new Map,this.qb=new b.$Bc;const ye=this.B(G.createInstance(S.$jq));this.ab=this.B(G.createInstance(q,me=>ye.postUninstall(me))),this.bb=this.B(new L.$lq(pe,ie,le,this,this.F)),this.cb=this.B(G.createInstance(l.$iq));const he=this.B(new T.$mq(this,this.eb,pe,C,le,ie,f));this.B(he.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$pp)(this.hb,this.F)),this.ib}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const M=await this.ob(U),f=await(0,$.zip)((0,p.$Tg)(this.cb.extensionsDownloadDir,(0,c.$Cg)()).fsPath,M);return m.URI.file(f)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:M,cleanup:f}=await this.kb(U),P=d.$kc(M.fsPath);try{return await(0,I.$kq)(P)}finally{await f()}}getInstalled(U,M=this.H.defaultProfile.extensionsResource,f={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(U??null,M,f)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,M={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:f,cleanup:P}=await this.kb(U);try{const N=await(0,I.$kq)(d.$kc(f.fsPath)),C=(0,n.$jp)(N.publisher,N.name);if(N.engines&&N.engines.vscode&&!(0,z.$wp)(N.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,C,this.G.version));const G=(await this.I([{manifest:N,extension:f,options:M}])).find(({identifier:ie})=>(0,n.$ep)(ie,{id:C}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$9p)(new Error(`Unknown error while installing extension ${C}`))}finally{await P()}}async installFromLocation(U,M){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const f=await this.ab.scanUserExtensionAtLocation(U);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.tb([[f,void 0]],M),this.F.info("Successfully installed extension",f.identifier.id,M.toString()),f}async installExtensionsFromProfile(U,M,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,M.toString(),f.toString());const P=(await this.getInstalled(1,M)).filter(N=>U.some(C=>(0,n.$ep)(C,N.identifier)));if(P.length){const N=await Promise.all(P.map(C=>this.ab.scanMetadata(C,M)));await this.tb(P.map((C,W)=>[C,N[W]]),f),this.F.info("Successfully installed extensions",P.map(C=>C.identifier.id),f.toString())}return P}async updateMetadata(U,M,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0,M.hasPreReleaseVersion=!0),M.isMachineScoped===!1&&(M.isMachineScoped=void 0),M.isBuiltin===!1&&(M.isBuiltin=void 0),M.pinned===!1&&(M.pinned=void 0),U=await this.ab.updateMetadata(U,M,f),this.bb.invalidate(f),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const M=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:M,compatible:!0},k.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(P){throw new Error(h.localize(3,null,(0,A.$4i)(P)))}return this.installFromGallery(f)}$(U,M,f,P){return this.ab.copyExtension(U,M,f,P)}copyExtensions(U,M){return this.ab.copyExtensions(U,M,{version:this.G.version,date:this.G.date})}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,M,f){const{location:P}=await this.cb.download(U,M,!f);return P}async kb(U){if(U.scheme===v.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const M=(0,p.$Tg)(this.cb.extensionsDownloadDir,(0,c.$Cg)());return await this.gb.download(U,M),this.F.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.hb.del(M)}catch(P){this.F.error(P)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,M,f){if(m.URI.isUri(M))return new Z(U,M,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const P=n.$fp.create(M).toString();let N=this.db.get(P);return N||(this.db.set(P,N=new H(U,M,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),N.waitUntilTaskIsFinished().finally(()=>this.db.delete(P))),N}Z(U,M){return new K(U,M.profileLocation,this.fb)}async ob(U){const M=async P=>{let N=await w.Promises.readdir(P);N=N.map(G=>d.$jc(P,G));const C=await Promise.all(N.map(G=>w.Promises.stat(G)));let W=Promise.resolve([]);return C.forEach((G,ie)=>{const ae=N[ie];G.isFile()&&(W=W.then(le=>[...le,ae])),G.isDirectory()&&(W=W.then(le=>M(ae).then(pe=>[...le,...pe])))}),W};return(await M(U.location.fsPath)).map(P=>({path:`extension/${d.$lc(U.location.fsPath,P)}`,localPath:P}))}async pb({added:U,removed:M}){if(M){const f=U&&this.D.extUri.isEqual(M.profileLocation,U.profileLocation)?M.extensions.filter(P=>U.extensions.every(N=>!(0,n.$ep)(N,P))):M.extensions;for(const P of f)this.F.info("Extensions removed from another source",P.id,M.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:M.profileLocation})}if(U){const P=(await this.getInstalled(1,U.profileLocation)).filter(N=>U.extensions.some(C=>(0,n.$ep)(C,N.identifier)));this.s.fire(P.map(N=>(this.F.info("Extensions added from another source",N.identifier.id,U.profileLocation.toString()),{identifier:N.identifier,local:N,profileLocation:U.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(M=>this.qb.add(M)));const U=await this.hb.resolve(this.eb.userExtensionsLocation);for(const M of U.children??[])M.isDirectory&&this.qb.add(M.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(M=>this.sb(M)))}async sb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const M=[];for(const f of U.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const P=await this.ab.scanUserExtensionAtLocation(f);P&&P.installedTimestamp===void 0&&(this.qb.add(f),M.push(P))}M.length&&(await this.tb(M.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",M.map(f=>f.identifier.id)))}async tb(U,M){const f=U.map(P=>P[0]);await this.ub(f),await this.fb.addExtensionsToProfile(U,M),this.s.fire(f.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:M})))}async ub(U){const M=await this.ab.getUninstalledExtensions();for(const f of U){const P=n.$fp.create(f);M[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.ab.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$oq=X,e.$oq=X=$e([oe(0,t.$Po),oe(1,ue.$Ll),oe(2,ne.$Mj),oe(3,i.$oi),oe(4,o.$dq),oe(5,s.$_p),oe(6,g.$uo),oe(7,Q.$fi),oe(8,V.$Mk),oe(9,te.$6j),oe(10,fe.$kl),oe(11,ce.$ml)],X);let q=class extends a.$Tc{constructor(U,M,f,P,N,C){super(),this.j=U,this.m=M,this.n=f,this.s=P,this.t=N,this.u=C,this.h=this.B(new E.$6d),this.onExtract=this.h.event,this.c=(0,p.$Tg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$nh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,M,f){const P={includeInvalid:!0,profileLocation:M,productVersion:f};let N=[];return U===null||U===0?N.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):U===1&&N.push(...await this.n.scanUserExtensions(P)),N=U!==null?N.filter(C=>C.type===U):N,Promise.all(N.map(C=>this.F(C)))}async scanAllUserExtensions(U){const M=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(M.map(f=>this.F(f)))}async scanUserExtensionAtLocation(U){try{const M=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(M)return await this.F(M)}catch(M){this.u.error(M)}return null}async extractUserExtension(U,M,f,P,N){const C=U.toString(),W=m.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Cg)()}`)),G=m.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,C));let ie=await this.m.exists(G);if(ie&&P){try{await this.y(U.id,G,"removeExisting")}catch{throw new t.$Qo(h.localize(4,null,G.fsPath,U.id),t.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${M} to ${G.fsPath}`),await(0,$.$5p)(M,W.fsPath,{sourcePath:"extension",overwrite:!0},N),this.u.info(`Extracted extension to ${G}:`,U.id)}catch(ae){let le=t.ExtensionManagementErrorCode.Extract;throw ae instanceof $.$3p&&(ae.type==="CorruptZip"?le=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(le=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Qo(ae.message,le)}await this.n.updateMetadata(W,f);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(ae)}. Deleted from extracted location`,W),ae}this.h.fire(G)}catch(ae){try{await this.m.del(W,{recursive:!0})}catch{}throw ae}return this.D(G,1)}async scanMetadata(U,M){return M?(await this.w(U,M))?.metadata:this.n.scanMetadata(U.location)}async w(U,M){return(await this.s.scanProfileExtensions(M)).find(P=>(0,n.$ep)(P.identifier,U.identifier))}async updateMetadata(U,M,f){return f?await this.s.updateMetadata([[U,M]],f):await this.n.updateMetadata(U.location,M),this.D(U.location,U.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const M=U.map(f=>n.$fp.create(f));await this.z(f=>M.forEach(P=>{f[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(U){await this.z(M=>delete M[U.toString()])}async removeExtension(U,M){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,M)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(M=>delete M[n.$fp.create(U).toString()])}async copyExtension(U,M,f,P){const N=await this.w(U,M),C=await this.w(U,f);if(P={...N?.metadata,...P},C)if(this.t.extUri.isEqual(C.location,U.location))await this.s.updateMetadata([[U,{...C.metadata,...P}]],f);else{const W=await this.D(C.location,U.type,f);await this.s.removeExtensionFromProfile(W,f),await this.s.addExtensionsToProfile([[U,{...C.metadata,...P}]],f)}else await this.s.addExtensionsToProfile([[U,P]],f);return this.D(U.location,U.type,f)}async copyExtensions(U,M,f){const P=await this.scanExtensions(1,U,f),N=await Promise.all(P.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,U)]));await this.s.addExtensionsToProfile(N,M)}async y(U,M,f){this.u.trace(`Deleting ${f} extension from disk`,U,M.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(M),`${this.t.extUri.basename(M)}.${(0,u.$7i)((0,c.$Cg)()).toString(16)}${B}`);await this.C(M.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,U,M.fsPath)}async z(U){return this.g.queue(async()=>{let M;try{M=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,V.$4k)(P)!==1)throw P}let f={};if(M)try{f=JSON.parse(M)}catch{}return U&&(U(f),Object.keys(f).length?await this.m.writeFile(this.c,j.$te.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(U,M){try{await w.Promises.rename(U,M,2*60*1e3)}catch(f){throw new t.$Qo(f.message||h.localize(5,null,U,M),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(U,M,f){if(f){const N=(await this.n.scanUserExtensions({profileLocation:f})).find(C=>this.t.extUri.isEqual(C.location,U));if(N)return this.F(N)}else{const P=await this.n.scanExistingExtension(U,M,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(h.localize(6,null,U.path))}async F(U){const M=await this.m.resolve(U.location);let f,P;return M.children&&(f=M.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,P=M.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:f,changelogUrl:P,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const M=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const N of M)U[n.$fp.create(N).toString()]||f.add(N.identifier.id.toLowerCase());try{const N=(0,n.$kp)(M,C=>C.identifier);await O.Promises.settled(N.map(async C=>{const W=C.sort((G,ie)=>y.rcompare(G.manifest.version,ie.manifest.version))[0];f.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(N){this.u.error(N)}const P=M.filter(N=>N.metadata&&U[n.$fp.create(N).toString()]);await Promise.allSettled(P.map(N=>this.removeUninstalledExtension(N)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(M){(0,V.$4k)(M)!==1&&this.u.error(M);return}if(U?.children)try{await Promise.allSettled(U.children.map(async M=>{if(!(!M.isDirectory||!M.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",M.resource.toString());try{await this.m.del(M.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",M.resource.toString())}catch(f){(0,V.$4k)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$pq=q,e.$pq=q=$e([oe(1,V.$Mk),oe(2,o.$dq),oe(3,s.$_p),oe(4,fe.$kl),oe(5,ne.$Mj)],q);class F extends r.$0p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.$1f)(this.options.operation)?this.l:this.options.operation}constructor(U,M,f,P,N,C,W,G,ie){super(),this.identifier=U,this.source=M,this.options=f,this.m=P,this.n=N,this.o=C,this.p=W,this.q=G,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[M,f]=await this.x(U);return this.j=M.isBuiltin||M.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[M,f]],this.j,!M.isValid),M}async u({zipPath:U,key:M,metadata:f},P,N){let C=await this.v(M);return C?C=await this.m.updateMetadata(C,f):(this.s.trace("Extracting extension...",M.id),C=await this.m.extractUserExtension(M,U,f,P,N),this.s.info("Extracting extension completed.",M.id)),C}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$fp.create(P).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class H extends F{constructor(U,M,f,P,N,C,W,G,ie,ae){super(M.identifier,M,f,N,C,W,G,ie,ae),this.y=M,this.z=P}async x(U){let M;try{M=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(W){throw new t.$Qo(W,t.ExtensionManagementErrorCode.Scanning)}const f=M.find(W=>(0,n.$ep)(W.identifier,this.y.identifier));f&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,R.$Zf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,P),P]}catch(W){throw new t.$Qo((0,D.$0)(W),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:N,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(N.fsPath),[await this.u({zipPath:N.fsPath,key:n.$fp.create(this.y),metadata:P},!1,U),P]}catch(W){try{await this.z.delete(N)}catch(G){this.s.warn("Error while deleting the downloaded file",N.toString(),(0,D.$0)(G))}throw W}}async B(U){try{await(0,I.$kq)(U)}catch(M){throw new t.$Qo((0,r.$8p)(M).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$qq=H;class Z extends F{constructor(U,M,f,P,N,C,W,G,ie,ae){super({id:(0,n.$jp)(U.publisher,U.name)},M,f,N,C,W,G,ie,ae),this.y=U,this.z=M,this.A=P}async h(U){const M=await super.h(U);return this.D(M,U),M}async x(U){const M=new n.$fp(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(W=>(0,n.$ep)(this.identifier,W.identifier)),N={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned};if(P)if(this.l=3,M.equals(new n.$fp(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&y.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const W=await this.v(M);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:M,metadata:N},!0,U),N]}async D(U,M){try{let[f]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],M);if(f||([f]=await this.A.getExtensions([{id:U.identifier.id}],M)),f){const P={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,P,this.options.profileLocation)}}catch{}}}class K extends r.$0p{constructor(U,M,f){super(),this.extension=U,this.j=M,this.k=f}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[161],re([0,1,5,23,22,25,42,13,18,11]),function(J,e,O,j,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=void 0;let b=class extends D.$aq{constructor(d,p,y,R,m,c){super(a.URI.file(d.extensionsPath),p,y,R,m,c)}};e.$UP=b,e.$UP=b=$e([oe(0,u.$oi),oe(1,E.$Mk),oe(2,j.$ml),oe(3,k.$kl),oe(4,A.$Ll),oe(5,O.$Mj)],b)}),define(se[162],re([0,1,11,18,42,52,13,10,5,32,22,23]),function(J,e,O,j,k,A,D,E,u,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;let d=class extends A.$hq{constructor(y,R,m,c,w,$,h,g){super(O.URI.file(w.builtinExtensionsPath),O.URI.file(w.extensionsPath),w.userHome,y.defaultProfile,y,R,m,c,w,$,h,g)}};e.$Vac=d,e.$Vac=d=$e([oe(0,v.$ml),oe(1,k.$_p),oe(2,D.$Mk),oe(3,u.$Mj),oe(4,j.$oi),oe(5,a.$6j),oe(6,b.$kl),oe(7,E.$fi)],d)}),define(se[163],re([0,1,9,7,2,128,3,88,10,23]),function(J,e,O,j,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Mp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Kp=e.$Jp=e.$Ip=void 0,e.$Lp=p,e.$Np=R,e.$Pp=c,e.$Ip="__$__isNewStorageMarker",e.$Jp="__$__targetStorageMarker",e.$Kp=(0,u.$gi)("storageService");var b;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var v;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var d;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function p(w){const $=w.get(e.$Jp);if($)try{return JSON.parse($)}catch{}return Object.create(null)}class y extends k.$Tc{static{this.a=60*1e3}constructor($={flushInterval:y.a}){super(),this.m=$,this.b=this.B(new j.$9d),this.c=this.B(new j.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new O.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,h,g){return j.Event.filter(this.b.event,i=>i.scope===$&&(h===void 0||i.key===h),g)}n(){this.j.value=(0,O.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,h){const{key:g,external:i}=h;if(g===e.$Jp){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:g,target:this.J($)[g],external:i})}w($){this.f.fire({reason:$})}get($,h,g){return this.P(h)?.get($,g)}getBoolean($,h,g){return this.P(h)?.getBoolean($,g)}getNumber($,h,g){return this.P(h)?.getNumber($,g)}getObject($,h,g){return this.P(h)?.getObject($,g)}storeAll($,h){this.y(()=>{for(const g of $)this.store(g.key,g.value,g.scope,g.target,h)})}store($,h,g,i,r=!1){if((0,D.$3f)(h)){this.remove($,g,r);return}this.y(()=>{this.z($,g,i),this.P(g)?.set($,h,r)})}remove($,h,g=!1){this.y(()=>{this.z($,h,void 0),this.P(h)?.delete($,g)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,h){const g=[],i=this.J($);for(const r of Object.keys(i))i[r]===h&&g.push(r);return g}z($,h,g,i=!1){const r=this.J(h);typeof g=="number"?r[$]!==g&&(r[$]=g,this.P(h)?.set(e.$Jp,JSON.stringify(r),i)):typeof r[$]=="number"&&(delete r[$],this.P(h)?.set(e.$Jp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const h=this.P($);return h?p(h):Object.create(null)}isNew($){return this.getBoolean(e.$Ip,$)===!0}async flush($=b.NONE){this.f.fire({reason:$});const h=this.P(-1),g=this.P(0),i=this.P(1);switch($){case b.NONE:await O.Promises.settled([h?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await O.Promises.settled([h?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c($,h,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,h){return this.w(b.NONE),(0,a.$ll)($)?this.R($,h):this.S($,h)}M($,h){return!($.id===h.id||R(h)&&R($))}N($,h,g){this.y(()=>{const i=new Set;for(const[r,t]of $)i.add(r),h.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$Mp=y;function R(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class m extends y{constructor(){super(),this.U=this.B(new E.$Gp(new E.$Hp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Gp(new E.$Hp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Gp(new E.$Hp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Op=m;async function c(w,$,h,g,i,r){const t=z=>{try{return JSON.parse(z)}catch{return z}},n=new Map,s=new Map;w.forEach((z,V)=>{n.set(V,z),s.set(V,t(z))});const o=new Map,l=new Map;$.forEach((z,V)=>{o.set(V,z),l.set(V,t(z))});const S=new Map,I=new Map;h.forEach((z,V)=>{S.set(V,z),I.set(V,t(z))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const L=[];if(n.forEach((z,V)=>{L.push({key:V,value:z})}),console.table(L),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const z=[];o.forEach((V,Q)=>{z.push({key:Q,value:V})}),console.table(z),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const T=[];S.forEach((z,V)=>{T.push({key:V,value:z})}),console.table(T),console.groupEnd(),console.log(I)}}),define(se[164],re([0,1,19,20,8,12,35,3,11,29,18,21,26,50,13,5,32,45,147,163,25,177]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Sp=Z;const i=A.$o?"web":(0,v.$Lo)(A.$u,D.$ec),r="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...P){return String(P.reduce((N,C)=>N|C,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class L{constructor(N=I){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,C=this.d.pageSize){return new L({...this.d,pageNumber:N,pageSize:C})}withFilter(N,...C){const W=[...this.d.criteria,...C.length?C.map(G=>({filterType:N,value:G})):[{filterType:N}]];return new L({...this.d,criteria:W})}withSortBy(N){return new L({...this.d,sortBy:N})}withSortOrder(N){return new L({...this.d,sortOrder:N})}withFlags(...N){return new L({...this.d,flags:N.reduce((C,W)=>C|W,0)})}withAssetTypes(...N){return new L({...this.d,assetTypes:N})}withSource(N){return new L({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:C,pageSize:W,sortBy:G,sortOrder:ie,flags:ae,assetTypes:le}=this.d;return{filters:[{criteria:N,pageNumber:C,pageSize:W,sortBy:G,sortOrder:ie}],assetTypes:le,flags:ae}}get searchText(){const N=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function T(P,N){const C=(P||[]).filter(W=>W.statisticName===N)[0];return C?C.value:0}function z(P){const N="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(W=>W.assetType.indexOf(N)===0).reduce((W,G)=>{const ie=ne(P,G.assetType);return ie&&W.push([G.assetType.substring(N.length),ie]),W},[])}function V(P){if(P.properties){const N=P.properties.filter(G=>G.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=N.filter(G=>C.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return ne(P,o.Repository)}function Q(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function ne(P,N){return P.files.filter(W=>W.assetType===N)[0]?{uri:`${P.assetUri}/${N}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${N}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function te(P,N){const C=P.properties?P.properties.filter(G=>G.key===N):[],W=C.length>0&&C[0].value;return W?W.split(",").map(G=>(0,d.$ip)(G)):[]}function ue(P){const N=P.properties?P.properties.filter(C=>C.key===l.Engine):[];return N.length>0&&N[0].value||""}function fe(P){const N=P.properties?P.properties.filter(C=>C.key===l.PreRelease):[];return N.length>0&&N[0].value==="true"}function ce(P){const N=P.properties?P.properties.filter(W=>W.key===l.LocalizedLanguages):[],C=N.length>0&&N[0].value||"";return C?C.split(","):[]}function B(P){return P.properties?.find(N=>N.key===l.SponsorLink)?.value}function X(P){return P.properties?.find(N=>N.key===l.SupportLink)?.value}function q(P){return P.indexOf("preview")!==-1}function F(P){return P.targetPlatform?(0,v.$Ko)(P.targetPlatform):"undefined"}function H(P){const N=(0,O.$Mb)(P.versions.map(F)),C=!!P.tags?.includes(v.$Fo),W=N.indexOf("web");return C?W===-1&&N.push("web"):W!==-1&&N.splice(W,1),N}function Z(P,N){for(let C=0;C<P.length;C++){const W=P[C];if(W.version===P[C-1]?.version){let G=C;if(F(W)===N)for(;G>0&&P[G-1].version===W.version;)G--;G!==C&&(P.splice(C,1),P.splice(G,0,W))}}return P}function K(P,N,C){P.telemetryData={index:N,querySource:C,queryActivityId:P.queryContext?.[r]}}function _(P,N,C,W){const G=P.versions[0],ie={manifest:ne(N,o.Manifest),readme:ne(N,o.Details),changelog:ne(N,o.Changelog),license:ne(N,o.License),repository:V(N),download:Q(N),icon:ne(N,o.Icon),signature:ne(N,o.Signature),coreTranslations:z(N)};return{identifier:{id:(0,d.$jp)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:N.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:P.shortDescription??"",installCount:T(P.statistics,"install"),rating:T(P.statistics,"averagerating"),ratingCount:T(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:C,assets:ie,properties:{dependencies:te(N,l.Dependency),extensionPack:te(N,l.ExtensionPack),engine:ue(N),localizedLanguages:ce(N),targetPlatform:F(N),isPreReleaseVersion:fe(N)},hasPreReleaseVersion:fe(G),hasReleaseVersion:!0,preview:q(P.flags),isSigned:!!ie.signature,queryContext:W,supportLink:X(G)}}let U=class{constructor(N,C,W,G,ie,ae,le,pe){this.k=C,this.l=W,this.n=G,this.o=ie,this.q=ae,this.u=le,this.w=pe;const ye=le.extensionsGallery,he=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=he?ye.servicePPEUrl:ye?.serviceUrl,this.g=he?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,w.$Rp)(le.version,le,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,C,W){const G=j.CancellationToken.isCancellationToken(C)?{}:C,ie=j.CancellationToken.isCancellationToken(C)?C:W,ae=[],le=[],pe=[],ye=[];let he=!0;for(const we of N){we.uuid?le.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),he=he&&!!we.hasPreRelease&&!Ee}if(!le.length&&!ae.length)return[];let me=new L().withPage(1,N.length);le.length&&(me=me.withFilter(s.ExtensionId,...le)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(G.queryAllVersions||he)&&(me=me.withFlags(me.flags,t.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:de}=await this.z(me,{targetPlatform:G.targetPlatform??i,includePreRelease:pe,versions:ye,compatible:!!G.compatible,productVersion:G.productVersion??{version:this.u.version,date:this.u.date}},ie);return G.source&&de.forEach((we,Ee)=>K(we,Ee,G.source)),de}async getCompatibleExtension(N,C,W,G={version:this.u.version,date:this.u.date}){if((0,v.$Mo)(N.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(N,C,W))return N;const ie=new L().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,N.identifier.uuid),{extensions:ae}=await this.z(ie,{targetPlatform:W,compatible:!0,includePreRelease:C,productVersion:G},j.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(N,C,W,G={version:this.u.version,date:this.u.date}){if(!(0,v.$No)(N.properties.targetPlatform,N.allTargetPlatforms,W)||!C&&N.properties.isPreReleaseVersion)return!1;let ie=N.properties.engine;if(!ie){const ae=await this.getManifest(N,j.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return(0,p.$wp)(ie,G.version,G.date)}async y(N,C,W,G,ie,ae={version:this.u.version,date:this.u.date}){if(!(0,v.$No)(F(N),G,ie)||C!=="any"&&fe(N)!==(C==="prerelease"))return!1;if(W)try{const le=await this.E(N);if(!(0,p.$wp)(le,ae.version,ae.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${N.version}.`,(0,k.$0)(le)),!1}return!0}async query(N,C){let W=N.text||"";const G=N.pageSize??50;let ie=new L().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,de)=>(ie=ie.withFilter(s.Category,de||me),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,de)=>(ie=ie.withFilter(s.Tag,de||me),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),ie=ie.withFilter(s.SearchText,W)),ie=ie.withSortBy(0)):N.ids?ie=ie.withFilter(s.ExtensionId,...N.ids):N.names?ie=ie.withFilter(s.ExtensionName,...N.names):ie=ie.withSortBy(4),typeof N.sortBy=="number"&&(ie=ie.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(ie=ie.withSortOrder(N.sortOrder)),N.source&&(ie=ie.withSource(N.source));const ae=async(he,me)=>{const{extensions:de,total:we}=await this.z(he,{targetPlatform:i,compatible:!1,includePreRelease:!!N.includePreRelease,productVersion:N.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>K(Ee,(he.pageNumber-1)*he.pageSize+ke,N.source)),{extensions:de,total:we}},{extensions:le,total:pe}=await ae(ie,C),ye=async(he,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ae(ie.withPage(he+1),me);return de};return{firstPage:le,total:pe,pageSize:ie.pageSize,getPage:ye}}async z(N,C,W){const G=N.flags;N.flags&t.IncludeLatestVersionOnly&&N.flags&t.IncludeVersions&&(N=N.withFlags(N.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(N.flags&t.IncludeLatestVersionOnly)&&!(N.flags&t.IncludeVersions)&&(N=N.withFlags(N.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(N=N.withFlags(N.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),N=N.withFlags(N.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ie,total:ae,context:le}=await this.B(N,W);if(!(N.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of ie){const we=await this.A(de,C,le);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],he=new Map;for(let me=0;me<ie.length;me++){const de=ie[me],we={id:(0,d.$jp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$Zf)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(x=>(0,d.$ep)(x,we))?.includePreRelease;if(C.compatible&&(0,v.$Mo)(H(de),C.targetPlatform))continue;const ke=await this.A(de,C,le);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==C.targetPlatform&&ke.hasPreReleaseVersion?he.set(de.extensionId,me):ye.push([me,ke])}if(he.size){const me=new g.$2d,de=new L().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(s.ExtensionId,...he.keys()),{extensions:we}=await this.z(de,C,W);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:he.size});for(const Ee of we){const ke=he.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(N,C,W){const G={id:(0,d.$jp)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},ie=C.versions?.find(ye=>(0,d.$ep)(ye,G))?.version,ae=(0,E.$Zf)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ye=>(0,d.$ep)(ye,G))?.includePreRelease,le=H(N),pe=Z(N.versions,C.targetPlatform);if(C.compatible&&(0,v.$Mo)(le,C.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const he=pe[ye];if(!(ie&&he.version!==ie)){if(await this.y(he,ae?"any":"release",C.compatible,le,C.targetPlatform,C.productVersion))return _(N,he,le,W);if(ie&&he.version===ie)return null}}return ie||C.compatible?null:_(N,N.versions[0],le)}async B(N,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const W=await this.j,G=JSON.stringify(N.raw),ie={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ae=new g.$2d;let le,pe,ye=0;try{if(le=await this.k.request({type:"POST",url:this.g&&N.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:ie},C),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ye};const he=await(0,c.$Dp)(le);if(he){const me=he.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:le.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(he){const me=(0,k.$4)(he)?v.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(he).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw pe=new v.$Ro((0,k.$0)(he),me),pe}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(G.length),duration:ae.elapsed(),success:!!le&&(0,c.$zp)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(N,C,W,G){if(!this.isEnabled())return;const ie=A.$o?this.x(`/itemName/${N}.${C}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${C}/${W}/stats?statType=${G}`),ae=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:ie,headers:pe},j.CancellationToken.None)}catch{}}async download(N,C,W){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const G=(0,d.$mp)(N),ie=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),le=W===2?"install":W===3?"update":"",pe=le?{uri:`${N.assets.download.uri}${u.URI.parse(N.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${N.assets.download.fallbackUri}${u.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:N.assets.download,ye=N.queryContext?.[r]?{[r]:N.queryContext[r]}:void 0,he=await this.D(pe,ye?{headers:ye}:void 0);await this.q.writeFile(C,he.stream),ae(new Date().getTime()-ie)}async downloadSignatureArchive(N,C){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const W=await this.D(N.assets.signature);await this.q.writeFile(C,W.stream)}async getReadme(N,C){if(N.assets.readme){const W=await this.D(N.assets.readme,{},C);return await(0,c.$Cp)(W)||""}return""}async getManifest(N,C){if(N.assets.manifest){const W=await this.D(N.assets.manifest,{},C),G=await(0,c.$Cp)(W);return G?JSON.parse(G):null}return null}async C(N,C){const W=ne(N,o.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},ie=await this.D(W,{headers:G});return await(0,c.$Dp)(ie)}async getCoreTranslation(N,C){const W=N.assets.coreTranslations.filter(G=>G[0]===C.toUpperCase())[0];if(W){const G=await this.D(W[1]),ie=await(0,c.$Cp)(G);return ie?JSON.parse(ie):null}return null}async getChangelog(N,C){if(N.assets.changelog){const W=await this.D(N.assets.changelog,{},C);return await(0,c.$Cp)(W)||""}return""}async getAllCompatibleVersions(N,C,W){let G=new L().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?G=G.withFilter(s.ExtensionId,N.identifier.uuid):G=G.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:ie}=await this.B(G,j.CancellationToken.None);if(!ie.length)return[];const ae=H(ie[0]);if((0,v.$Mo)(ae,W))return[];const le=[];await Promise.all(ie[0].versions.map(async he=>{try{await this.y(he,C?"any":"release",!0,ae,W)&&le.push(he)}catch{}}));const pe=[],ye=new Set;for(const he of Z(le,W))ye.has(he.version)||(ye.add(he.version),pe.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:fe(he)}));return pe}async D(N,C={},W=j.CancellationToken.None){const G=await this.j,ie={type:"GET"},ae={...G,...C.headers||{}};C={...C,...ie,headers:ae};const le=N.uri,pe=N.fallbackUri,ye={...C,url:le};try{const he=await this.k.request(ye,W);if(he.res.statusCode===200)return he;const me=await(0,c.$Cp)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${me}`)}catch(he){if((0,k.$4)(he))throw he;const me=(0,k.$0)(he);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:me});const de={...C,url:pe};return this.k.request(de,W)}}async E(N){let C=ue(N);if(!C){const W=await this.C(N,j.CancellationToken.None);if(!W)throw new Error("Manifest was not found");C=W.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const N=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Dp)(N),W=[],G={},ie=[];if(C){for(const ae of C.malicious)W.push({id:ae});if(C.migrateToPreRelease)for(const[ae,le]of Object.entries(C.migrateToPreRelease))(!le.engine||(0,p.$wp)(le.engine,this.u.version,this.u.date))&&(G[ae.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[ae,le]of Object.entries(C.deprecated))le&&(G[ae.toLowerCase()]=(0,E.$Zf)(le)?{}:le);if(C.search)for(const ae of C.search)ie.push(ae)}return{malicious:W,deprecated:G,search:ie}}};U=$e([oe(1,c.$xp),oe(2,R.$Mj),oe(3,b.$ni),oe(4,h.$Ll),oe(5,y.$Mk),oe(6,m.$6j),oe(7,a.$Mi)],U);let M=class extends U{constructor(N,C,W,G,ie,ae,le,pe){super(N,C,W,G,ie,ae,le,pe)}};e.$Tp=M,e.$Tp=M=$e([oe(0,$.$Kp),oe(1,c.$xp),oe(2,R.$Mj),oe(3,b.$ni),oe(4,h.$Ll),oe(5,y.$Mk),oe(6,m.$6j),oe(7,a.$Mi)],M);let f=class extends U{constructor(N,C,W,G,ie,ae,le){super(void 0,N,C,W,G,ie,ae,le)}};e.$Up=f,e.$Up=f=$e([oe(0,c.$xp),oe(1,R.$Mj),oe(2,b.$ni),oe(3,h.$Ll),oe(4,y.$Mk),oe(5,m.$6j),oe(6,a.$Mi)],f)}),define(se[165],re([0,1,11,18,13,5,143,22,23,3,68]),function(J,e,O,j,k,A,D,E,u,a,b){"use strict";var v,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=e.$RP=void 0;let p=class extends u.$pl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,w,$,h,g){super($,h,w,g),this.U=c,this.W=$}O(){return this.U.getItem(v.b,[]).map(w=>({...w,location:(0,a.$Tf)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):O.URI.revive(w.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(O.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$RP=p,e.$RP=p=v=$e([oe(0,D.$MP),oe(1,E.$kl),oe(2,j.$oi),oe(3,k.$Mk),oe(4,A.$Mj)],p);let y=d=class extends p{constructor(c,w,$,h,g){super(c,w,$,h,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",w=this.$.getItem(c,void 0);if(w){this.$.removeItem(c);const h=w.reduce((g,{workspace:i,profile:r})=>(g[O.URI.revive(i).toString()]=O.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:h})}const $=super.Q();return this.$.getItem(d.a,!1)||(this.R($),this.$.setItem(d.a,!0)),$}};e.$SP=y,e.$SP=y=d=$e([oe(0,D.$NP),oe(1,E.$kl),oe(2,j.$oi),oe(3,k.$Mk),oe(4,A.$Mj)],y);let R=class extends y{constructor(c,w,$,h){super(new b.$QP(0,w,h,$),c,w,$,h)}async init(){return await this.$.init(),super.init()}};e.$TP=R,e.$TP=R=$e([oe(0,E.$kl),oe(1,j.$oi),oe(2,k.$Mk),oe(3,A.$Mj)],R)}),define(se[166],re([0,1,141,9,14,8,3,29,18,142,5,45,140,178]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0,e.$Er=m;let y=class extends v.$yp{constructor(w,$,h,g){super(g),this.m=w,this.n=$,this.r=h,this.s(),this.B(w.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,$){const{f:h,g}=this;let i;try{i=await(0,a.$qm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const r={...process.env,...i},t=w.agent?w.agent:await(0,d.$Cr)(w.url||"",r,{proxyUrl:h,strictSSL:g});return w.agent=t,w.strictSSL=g,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>m(w,$))}async resolveProxy(w){}async loadCertificates(){return(await new Promise(($,h)=>{J(["@vscode/proxy-agent"],$,h)})).loadSystemCertificates({log:this.r})}};e.$Dr=y,e.$Dr=y=$e([oe(0,E.$Mi),oe(1,u.$oi),oe(2,b.$Mj),oe(3,b.$Nj)],y);async function R(c){return((0,O.parse)(c.url).protocol==="https:"?await new Promise((h,g)=>{J(["https"],h,g)}):await new Promise((h,g)=>{J(["http"],h,g)})).request}async function m(c,w){return j.Promises.withAsyncBody(async($,h)=>{const g=(0,O.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await R(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,D.$Zf)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,D.$Xf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)m({...c,url:n.headers.location,followRedirects:s-1},w).then($,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,p.createGunzip)())),$({res:n,stream:(0,k.$Ie)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),w.onCancellationRequested(()=>{t.abort(),h(new A.$5)})})}}),define(se[179],re([0,1,33,9,34,8,2,15,16,12,35,11,24,29,137,59,139,18,115,164,21,64,144,42,52,160,162,13,127,129,51,125,62,63,148,5,133,39,134,151,32,45,166,68,69,25,150,41,152,153,22,155,23,165,154,161,130,132,4,156,180]),function(J,e,O,j,k,A,D,E,u,a,b,v,d,p,y,R,m,c,w,$,h,g,i,r,t,n,s,o,l,S,I,L,T,z,V,Q,ne,te,ue,fe,ce,B,X,q,F,H,Z,K,_,U,M,f,P,N,C,W,G,ie,ae,le,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=he;class ye extends D.$Tc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(Q.$Mj),x=Ee.get(o.$Mk),Y=Ee.get(c.$oi),ee=Ee.get(P.$ml);ke.info("CLI main",this.b),this.h(ke),await this.j(Y,x,ee,de),await Promise.all(we.map(ge=>{(0,j.$0g)(ge.flush(),1e3)}))})}async f(){const de=new T.$ei,we={_serviceBrand:void 0,...fe.default};de.set(ce.$6j,we);const Ee=new w.$Sm(this.b,we);de.set(c.$oi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?d.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new ie.$LP((0,Q.$1j)(Ee),Ee.logsHome);de.set(Q.$Nj,ke);const x=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),Y=[];ke.getLogLevel()===Q.LogLevel.Trace&&Y.push(new Q.$Uj(ke.getLogLevel()));const ee=this.B(new G.$VP(x,Y));de.set(Q.$Mj,ee);const ge=this.B(new l.$sq(ee));de.set(o.$Mk,ge);const ve=this.B(new S.$Rq(ee));ge.registerProvider(E.Schemas.file,ve);const De=new f.$fs(ge);de.set(M.$kl,De);const Se=new q.$PP(1,Ee,ee,ge),Le=new N.$RP(Se,De,Ee,ge,ee);de.set(P.$ml,Le),ge.registerProvider(E.Schemas.vscodeUserData,new le.$kbc(E.Schemas.file,ve,E.Schemas.vscodeUserData,Le,De,ee));const Re=a.$i&&we.win32RegValueName?this.B(new ue.$ibc(ee,we.win32RegValueName)):Ee.policyFile?this.B(new ne.$jbc(Ee.policyFile,ge,ee)):new te.$3n;de.set(te.$1n,Re);const Ae=this.B(new y.$qo(Le.defaultProfile.settingsResource,ge,Re,ee));de.set(p.$Mi,Ae),await Promise.all([Se.init(),Ae.initialize()]);let Ue;try{Ue=await(0,C.$Yac)(Se,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const je=await(0,C.$Zac)(Se,ee);Le.init(),de.set(M.$kl,new f.$fs(ge));const Ne=new X.$Dr(Ae,Ee,ee,ke);de.set(B.$xp,Ne),de.set(R.$uo,new I.$di(m.$$P,void 0,!0)),de.set(r.$_p,new I.$di(W.$UP,void 0,!0)),de.set(t.$dq,new I.$di(s.$Vac,void 0,!0)),de.set(g.$Vp,new I.$di(g.$Wp,void 0,!0)),de.set(n.$nq,new I.$di(n.$oq,void 0,!0)),de.set(h.$Po,new I.$di($.$Up,void 0,!0)),de.set(z.$xr,new I.$di(V.$zr,void 0,!1));const Te=[],Me=(0,K.$bp)(we,Ae);if((0,K.$9o)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&Te.push(new _.$JP(Ne,Me,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:Te,sendErrorTelemetry:!1,commonProperties:(0,F.$Zo)((0,O.release)(),(0,O.hostname)(),process.arch,we.commit,we.version,Ue,je,Me),piiPaths:(0,K.$cp)(Ee)};de.set(H.$Ll,new I.$di(Z.$Fr,[be],!1))}else de.set(H.$Ll,K.$4o);return[new L.$Uq(de),Te]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,A.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$4i)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async j(de,we,Ee,ke){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const Y=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Xp,new Q.$Uj(Q.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,Y);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Y};return ke.createInstance(i.$Xp,new Q.$Uj(Q.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Xp,new Q.$Uj(Q.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,Y);if(this.b["update-extensions"])return ke.createInstance(i.$Xp,new Q.$Uj(Q.LogLevel.Info,!1)).updateExtensions(Y);if(this.b["locate-extension"])return ke.createInstance(i.$Xp,new Q.$Uj(Q.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$Ibc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,u.$ic)(we)?we:(0,u.$jc)((0,b.cwd)(),we)):we)}}async function he(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/code/node/cliProcessMain.js.map
