/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/buffer","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","fs","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","fs/promises","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],I=0,N=se.length;I<N;I++)e[I]=le[se[I]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const L=new Map,A=new Map,O=new Map,R=new Map;function P(f,u){f.has(u.detail)||f.set(u.detail,-u.timestamp)}function g(f,u){const b=f.get(u.detail);b&&(b>=0||f.set(u.detail,b+u.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((f,u)=>f.timestamp-u.timestamp));for(const f of C)switch(f.type){case 10:P(L,f);break;case 11:case 12:g(L,f);break;case 21:P(A,f);break;case 22:g(A,f);break;case 33:P(O,f);break;case 34:g(O,f);break;case 31:P(R,f);break;case 32:g(R,f);break}let k=0;O.forEach(f=>k+=f);function w(f){const u=[];return f.forEach((b,$)=>u.push([$,b])),u}return{amdLoad:w(L),amdInvoke:w(A),nodeRequire:w(O),nodeEval:w(R),nodeRequireTotal:k}}static toMarkdownTable(L,A){let O="";const R=[];return L.forEach((P,g)=>{R[g]=P.length}),A.forEach(P=>{P.forEach((g,C)=>{typeof g>"u"&&(g=P[C]="-");const k=g.toString().length;R[C]=Math.max(k,R[C])})}),L.forEach((P,g)=>{O+=`| ${P+" ".repeat(R[g]-P.toString().length)} `}),O+=`|
`,L.forEach((P,g)=>{O+=`| ${"-".repeat(R[g])} `}),O+=`|
`,A.forEach(P=>{P.forEach((g,C)=>{typeof g<"u"&&(O+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),O+=`|
`}),O}}e.$U=I}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=I,e.$gb=N,e.$hb=L,e.$ib=A,e.$jb=O,e.$kb=R,e.$lb=P,e.$nb=C,e.$ob=k,e.$pb=w,e.$qb=f,e.$rb=u;function I(b,$,l){const d=N(b,$);if(d!==-1)return b[d]}function N(b,$,l=b.length-1){for(let d=l;d>=0;d--){const h=b[d];if($(h))return d}return-1}function L(b,$){const l=A(b,$);return l===-1?void 0:b[l]}function A(b,$,l=0,d=b.length){let h=l,c=d;for(;h<c;){const m=Math.floor((h+c)/2);$(b[m])?h=m+1:c=m}return h-1}function O(b,$){const l=R(b,$);return l===b.length?void 0:b[l]}function R(b,$,l=0,d=b.length){let h=l,c=d;for(;h<c;){const m=Math.floor((h+c)/2);$(b[m])?c=m:h=m+1}return h}function P(b,$,l=0,d=b.length){const h=R(b,$,l,d);return h===b.length?-1:h}class g{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(g.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!$(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const l=A(this.e,$,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function C(b,$){if(b.length===0)return;let l=b[0];for(let d=1;d<b.length;d++){const h=b[d];$(h,l)>0&&(l=h)}return l}function k(b,$){if(b.length===0)return;let l=b[0];for(let d=1;d<b.length;d++){const h=b[d];$(h,l)>=0&&(l=h)}return l}function w(b,$){return C(b,(l,d)=>-$(l,d))}function f(b,$){if(b.length===0)return-1;let l=0;for(let d=1;d<b.length;d++){const h=b[d];$(h,b[l])>0&&(l=d)}return l}function u(b,$){for(const l of b){const d=$(l);if(d!==void 0)return d}}}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=I,e.$L=N,e.$M=L,e.$N=A;function I(O,R){const P=Object.create(null);for(const g of O){const C=R(g);let k=P[C];k||(k=P[C]=[]),k.push(g)}return P}function N(O,R){const P=[],g=[];for(const C of O)R.has(C)||P.push(C);for(const C of R)O.has(C)||g.push(C);return{removed:P,added:g}}function L(O,R){const P=[],g=[];for(const[C,k]of O)R.has(C)||P.push(k);for(const[C,k]of R)O.has(C)||g.push(k);return{removed:P,added:g}}function A(O,R){const P=new Set;for(const g of R)O.has(g)&&P.add(g);return P}}),define(le[84],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=N,e.$Lh=L,e.$Mh=A;function I(O){return(R,P,g)=>{let C=null,k=null;if(typeof g.value=="function"?(C="value",k=g.value):typeof g.get=="function"&&(C="get",k=g.get),!k)throw new Error("not supported");g[C]=O(k,P)}}function N(O,R,P){let g=null,C=null;if(typeof P.value=="function"?(g="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(g="get",C=P.get),!C)throw new Error("not supported");const k=`$memoize$${R}`;P[g]=function(...w){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[k]}}function L(O,R,P){return I((g,C)=>{const k=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...f){this[w]||(this[w]=P?P():void 0),clearTimeout(this[k]),R&&(this[w]=R(this[w],...f),f=[this[w]]),this[k]=setTimeout(()=>{g.apply(this,f),this[w]=P?P():void 0},O)}})}function A(O,R,P){return I((g,C)=>{const k=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,f=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...b){if(this[w]||(this[w]=P?P():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...b)),this[u])return;const $=this[f]+O;$<=Date.now()?(this[f]=Date.now(),g.apply(this,[this[w]]),this[w]=P?P():void 0):(this[u]=!0,this[k]=setTimeout(()=>{this[u]=!1,this[f]=Date.now(),g.apply(this,[this[w]]),this[w]=P?P():void 0},$-Date.now()))}})}}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=A,e.$2=O,e.$3=R,e.$4=g,e.$6=k,e.$7=w,e.$8=f,e.$0=b;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=I,e.$X=new I;function N(m){e.$X.setUnexpectedErrorHandler(m)}function L(m){if(!m||typeof m!="object")return!1;const i=m;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(m){g(m)||e.$X.onUnexpectedError(m)}function O(m){g(m)||e.$X.onUnexpectedExternalError(m)}function R(m){if(m instanceof Error){const{name:i,message:o}=m,n=m.stacktrace||m.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:h.isErrorNoTelemetry(m)}}return m}const P="Canceled";function g(m){return m instanceof C?!0:m instanceof Error&&m.name===P&&m.message===P}class C extends Error{constructor(){super(P),this.name=this.message}}e.$5=C;function k(){const m=new Error(P);return m.name=m.message,m}function w(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}function f(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}class u extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=u;function b(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=$;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class h extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof h)return i;const o=new h;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=h;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=A,e.$ub=O,e.$vb=R,e.$wb=P,e.$xb=g,e.$yb=C,e.$zb=k,e.$Ab=w,e.$Bb=f,e.$Cb=u,e.$Db=b,e.$Eb=$,e.top=l,e.$Gb=d,e.$Hb=c,e.$Ib=m,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=v,e.$Rb=y,e.$Sb=p,e.$Tb=S,e.$Ub=E,e.$Vb=D,e.$Wb=T,e.$Xb=F,e.$Yb=q,e.$Zb=Z,e.$1b=X,e.$2b=x,e.$3b=W,e.$4b=K,e.$5b=V,e.$6b=H,e.$7b=ee,e.$8b=ae,e.$$b=j;function L(U,Y=0){return U[U.length-(1+Y)]}function A(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function O(U,Y,_=(ne,G)=>ne===G){if(U===Y)return!0;if(!U||!Y||U.length!==Y.length)return!1;for(let ne=0,G=U.length;ne<G;ne++)if(!_(U[ne],Y[ne]))return!1;return!0}function R(U,Y){const _=U.length-1;Y<_&&(U[Y]=U[_]),U.pop()}function P(U,Y,_){return g(U.length,ne=>_(U[ne],Y))}function g(U,Y){let _=0,ne=U-1;for(;_<=ne;){const G=(_+ne)/2|0,ie=Y(G);if(ie<0)_=G+1;else if(ie>0)ne=G-1;else return G}return-(_+1)}function C(U,Y,_){if(U=U|0,U>=Y.length)throw new TypeError("invalid index");const ne=Y[Math.floor(Y.length*Math.random())],G=[],ie=[],ce=[];for(const fe of Y){const de=_(fe,ne);de<0?G.push(fe):de>0?ie.push(fe):ce.push(fe)}return U<G.length?C(U,G,_):U<G.length+ce.length?ce[0]:C(U-(G.length+ce.length),ie,_)}function k(U,Y){const _=[];let ne;for(const G of U.slice(0).sort(Y))!ne||Y(ne[0],G)!==0?(ne=[G],_.push(ne)):ne.push(G);return _}function*w(U,Y){let _,ne;for(const G of U)ne!==void 0&&Y(ne,G)?_.push(G):(_&&(yield _),_=[G]),ne=G;_&&(yield _)}function f(U,Y){for(let _=0;_<=U.length;_++)Y(_===0?void 0:U[_-1],_===U.length?void 0:U[_])}function u(U,Y){for(let _=0;_<U.length;_++)Y(_===0?void 0:U[_-1],U[_],_+1===U.length?void 0:U[_+1])}function b(U,Y,_){const ne=[];function G(fe,de,me){if(de===0&&me.length===0)return;const Ee=ne[ne.length-1];Ee&&Ee.start+Ee.deleteCount===fe?(Ee.deleteCount+=de,Ee.toInsert.push(...me)):ne.push({start:fe,deleteCount:de,toInsert:me})}let ie=0,ce=0;for(;;){if(ie===U.length){G(ie,0,Y.slice(ce));break}if(ce===Y.length){G(ie,U.length-ie,[]);break}const fe=U[ie],de=Y[ce],me=_(fe,de);me===0?(ie+=1,ce+=1):me<0?(G(ie,1,[]),ie+=1):me>0&&(G(ie,0,[de]),ce+=1)}return ne}function $(U,Y,_){const ne=b(U,Y,_),G=[],ie=[];for(const ce of ne)G.push(...U.slice(ce.start,ce.start+ce.deleteCount)),ie.push(...ce.toInsert);return{removed:G,added:ie}}function l(U,Y,_){if(_===0)return[];const ne=U.slice(0,_).sort(Y);return h(U,Y,ne,_,U.length),ne}function d(U,Y,_,ne,G){return _===0?Promise.resolve([]):new Promise((ie,ce)=>{(async()=>{const fe=U.length,de=U.slice(0,_).sort(Y);for(let me=_,Ee=Math.min(_+ne,fe);me<fe;me=Ee,Ee=Math.min(Ee+ne,fe)){if(me>_&&await new Promise(Re=>setTimeout(Re)),G&&G.isCancellationRequested)throw new I.$5;h(U,Y,de,me,Ee)}return de})().then(ie,ce)})}function h(U,Y,_,ne,G){for(const ie=_.length;ne<G;ne++){const ce=U[ne];if(Y(ce,_[ie-1])<0){_.pop();const fe=(0,N.$kb)(_,de=>Y(ce,de)<0);_.splice(fe,0,ce)}}}function c(U){return U.filter(Y=>!!Y)}function m(U){let Y=0;for(let _=0;_<U.length;_++)U[_]&&(U[Y]=U[_],Y+=1);U.length=Y}function i(U,Y,_){U.splice(_,0,U.splice(Y,1)[0])}function o(U){return!Array.isArray(U)||U.length===0}function n(U){return Array.isArray(U)&&U.length>0}function s(U,Y=_=>_){const _=new Set;return U.filter(ne=>{const G=Y(ne);return _.has(G)?!1:(_.add(G),!0)})}function t(U){const Y=new Set;return _=>{const ne=U(_);return Y.has(ne)?!1:(Y.add(ne),!0)}}function r(U,Y){return U.length>0?U[0]:Y}function a(U,Y){return U.length>0?U[U.length-1]:Y}function v(U,Y,_=(ne,G)=>ne===G){let ne=0;for(let G=0,ie=Math.min(U.length,Y.length);G<ie&&_(U[G],Y[G]);G++)ne++;return ne}function y(U){return[].concat(...U)}function p(U,Y){let _=typeof Y=="number"?U:0;typeof Y=="number"?_=U:(_=0,Y=U);const ne=[];if(_<=Y)for(let G=_;G<Y;G++)ne.push(G);else for(let G=_;G>Y;G--)ne.push(G);return ne}function S(U,Y,_){return U.reduce((ne,G)=>(ne[Y(G)]=_?_(G):G,ne),Object.create(null))}function E(U,Y){return U.push(Y),()=>D(U,Y)}function D(U,Y){const _=U.indexOf(Y);if(_>-1)return U.splice(_,1),Y}function T(U,Y,_){const ne=U.slice(0,Y),G=U.slice(Y);return ne.concat(_,G)}function F(U,Y){let _;if(typeof Y=="number"){let ne=Y;_=()=>{const G=Math.sin(ne++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ne=U.length-1;ne>0;ne-=1){const G=Math.floor(_()*(ne+1)),ie=U[ne];U[ne]=U[G],U[G]=ie}}function q(U,Y){const _=U.indexOf(Y);_>-1&&(U.splice(_,1),U.unshift(Y))}function Z(U,Y){const _=U.indexOf(Y);_>-1&&(U.splice(_,1),U.push(Y))}function X(U,Y){for(const _ of Y)U.push(_)}function x(U,Y){return Array.isArray(U)?U.map(Y):Y(U)}function W(U){return Array.isArray(U)?U:[U]}function K(U){return U[Math.floor(Math.random()*U.length)]}function V(U,Y,_){const ne=te(U,Y),G=U.length,ie=_.length;U.length=G+ie;for(let ce=G-1;ce>=ne;ce--)U[ce+ie]=U[ce];for(let ce=0;ce<ie;ce++)U[ce+ne]=_[ce]}function H(U,Y,_,ne){const G=te(U,Y);let ie=U.splice(G,_);return ie===void 0&&(ie=[]),V(U,G,ne),ie}function te(U,Y){return Y<0?Math.max(Y+U.length,0):Math.min(Y,U.length)}var re;(function(U){function Y(ie){return ie<0}U.isLessThan=Y;function _(ie){return ie<=0}U.isLessThanOrEqual=_;function ne(ie){return ie>0}U.isGreaterThan=ne;function G(ie){return ie===0}U.isNeitherLessOrGreaterThan=G,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ee(U,Y){return(_,ne)=>Y(U(_),U(ne))}function ae(...U){return(Y,_)=>{for(const ne of U){const G=ne(Y,_);if(!re.isNeitherLessOrGreaterThan(G))return G}return re.neitherLessOrGreaterThan}}const J=(U,Y)=>U-Y;e.$9b=J;const z=(U,Y)=>(0,e.$9b)(U?1:0,Y?1:0);e.$0b=z;function j(U){return(Y,_)=>-U(Y,_)}class M{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let _=this.c;for(;_<this.g.length&&Y(this.g[_]);)_++;const ne=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ne}takeFromEndWhile(Y){let _=this.d;for(;_>=0&&Y(this.g[_]);)_--;const ne=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ne}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const _=this.g.slice(this.c,this.c+Y);return this.c+=Y,_}}e.$_b=M;class B{static{this.empty=new B(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(_=>(Y(_),!0))}toArray(){const Y=[];return this.iterate(_=>(Y.push(_),!0)),Y}filter(Y){return new B(_=>this.iterate(ne=>Y(ne)?_(ne):!0))}map(Y){return new B(_=>this.iterate(ne=>_(Y(ne))))}some(Y){let _=!1;return this.iterate(ne=>(_=Y(ne),!_)),_}findFirst(Y){let _;return this.iterate(ne=>Y(ne)?(_=ne,!1):!0),_}findLast(Y){let _;return this.iterate(ne=>(Y(ne)&&(_=ne),!0)),_}findLastMaxBy(Y){let _,ne=!0;return this.iterate(G=>((ne||re.isGreaterThan(Y(G,_)))&&(ne=!1,_=G),!0)),_}}e.$ac=B}),define(le[127],he([0,1,7]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$9c=L,e.$0c=A,e.$$c=O,e.$_c=R,e.$ad=P;function N(g,C){if(!g)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function L(g,C="Unreachable"){throw new Error(C)}function A(g){if(!g)throw new I.$cb("Assertion Failed")}function O(g){g||(0,I.$1)(new I.$cb("Soft Assertion Failed"))}function R(g){if(!g()){debugger;g(),(0,I.$1)(new I.$cb("Assertion Failed"))}}function P(g,C){let k=0;for(;k<g.length-1;){const w=g[k],f=g[k+1];if(!C(w,f))return!1;k++}return!0}}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=I;function I(N,L){const A=this;let O=!1,R;return function(){if(O)return R;if(O=!0,L)try{R=N.apply(A,arguments)}finally{L()}else R=N.apply(A,arguments);return R}}}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(N){function L(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}N.is=L;const A=Object.freeze([]);function O(){return A}N.empty=O;function*R(i){yield i}N.single=R;function P(i){return L(i)?i:R(i)}N.wrap=P;function g(i){return i||A}N.from=g;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}N.reverse=C;function k(i){return!i||i[Symbol.iterator]().next().done===!0}N.isEmpty=k;function w(i){return i[Symbol.iterator]().next().value}N.first=w;function f(i,o){for(const n of i)if(o(n))return!0;return!1}N.some=f;function u(i,o){for(const n of i)if(o(n))return n}N.find=u;function*b(i,o){for(const n of i)o(n)&&(yield n)}N.filter=b;function*$(i,o){let n=0;for(const s of i)yield o(s,n++)}N.map=$;function*l(...i){for(const o of i)yield*o}N.concat=l;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}N.reduce=d;function*h(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}N.slice=h;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,N.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=c;async function m(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}N.asyncToArray=m})(I||(e.Iterable=I={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$rn=O,e.$sn=k,e.$tn=w,e.$un=f,e.$vn=u,e.$wn=b,e.$xn=$,e.$yn=l,e.$zn=d,e.$An=h,e.$Bn=c,e.$Cn=m;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,v=0;function y(q){let Z=0,X=0;for(;Z<q;){const x=i.charCodeAt(n);if(x>=48&&x<=57)X=X*16+x-48;else if(x>=65&&x<=70)X=X*16+x-65+10;else if(x>=97&&x<=102)X=X*16+x-97+10;else break;n++,Z++}return Z<q&&(X=-1),X}function p(q){n=q,t="",r=0,a=16,v=0}function S(){const q=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return v=3,i.substring(q,n);let Z=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Z=n}else v=3;return i.substring(q,Z)}function E(){let q="",Z=n;for(;;){if(n>=s){q+=i.substring(Z,n),v=2;break}const X=i.charCodeAt(n);if(X===34){q+=i.substring(Z,n),n++;break}if(X===92){if(q+=i.substring(Z,n),n++,n>=s){v=2;break}switch(i.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const W=y(4);W>=0?q+=String.fromCharCode(W):v=4;break}default:v=5}Z=n;continue}if(X>=0&&X<=31)if(P(X)){q+=i.substring(Z,n),v=2;break}else v=6;n++}return q}function D(){if(t="",v=0,r=n,n>=s)return r=s,a=17;let q=i.charCodeAt(n);if(R(q)){do n++,t+=String.fromCharCode(q),q=i.charCodeAt(n);while(R(q));return a=15}if(P(q))return n++,t+=String.fromCharCode(q),q===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=E(),a=10;case 47:{const Z=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(i.charCodeAt(n));)n++;return t=i.substring(Z,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const X=s-1;let x=!1;for(;n<X;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=i.substring(Z,n),a=13}return t+=String.fromCharCode(q),n++,a=16}case 45:if(t+=String.fromCharCode(q),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=S(),a=11;default:for(;n<s&&T(q);)n++,q=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(q),n++,a=16}}function T(q){if(R(q)||P(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let q;do q=D();while(q>=12&&q<=15);return q}return{setPosition:p,getPosition:()=>n,scan:o?F:D,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function k(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(y,p,S,E){r.value=y,r.offset=p,r.length=S,r.type=E,r.colonOffset=void 0,t=r}try{h(i,{onObjectBegin:(y,p)=>{if(o<=y)throw s;t=void 0,a=o>y,n.push("")},onObjectProperty:(y,p,S)=>{if(o<p||(v(y,p,S,"property"),n[n.length-1]=y,o<=p+S))throw s},onObjectEnd:(y,p)=>{if(o<=y)throw s;t=void 0,n.pop()},onArrayBegin:(y,p)=>{if(o<=y)throw s;t=void 0,n.push(0)},onArrayEnd:(y,p)=>{if(o<=y)throw s;t=void 0,n.pop()},onLiteralValue:(y,p,S)=>{if(o<p||(v(y,p,S,m(y)),o<=p+S))throw s},onSeparator:(y,p,S)=>{if(o<=p)throw s;if(y===":"&&t&&t.type==="property")t.colonOffset=p,a=!1,t=void 0;else if(y===","){const E=n[n.length-1];typeof E=="number"?n[n.length-1]=E+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(y){if(y!==s)throw y}return{path:n,previousNode:t,isAtPropertyKey:a,matches:y=>{let p=0;for(let S=0;p<y.length&&S<n.length;S++)if(y[p]===n[S]||y[p]==="*")p++;else if(y[p]!=="**")return!1;return p===y.length}}}function w(i,o=[],n=A.DEFAULT){let s=null,t=[];const r=[];function a(y){Array.isArray(t)?t.push(y):s!==null&&(t[s]=y)}return h(i,{onObjectBegin:()=>{const y={};a(y),r.push(t),t=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const y=[];a(y),r.push(t),t=y,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(y,p,S)=>{o.push({error:y,offset:p,length:S})}},n),t[0]}function f(i,o=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(y){s.type==="property"&&(s.length=y-s.offset,s=s.parent)}function r(y){return s.children.push(y),y}h(i,{onObjectBegin:y=>{s=r({type:"object",offset:y,length:-1,parent:s,children:[]})},onObjectProperty:(y,p,S)=>{s=r({type:"property",offset:p,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:y,offset:p,length:S,parent:s})},onObjectEnd:(y,p)=>{s.length=y+p-s.offset,s=s.parent,t(y+p)},onArrayBegin:(y,p)=>{s=r({type:"array",offset:y,length:-1,parent:s,children:[]})},onArrayEnd:(y,p)=>{s.length=y+p-s.offset,s=s.parent,t(y+p)},onLiteralValue:(y,p,S)=>{r({type:m(y),offset:p,length:S,parent:s,value:y}),t(p+S)},onSeparator:(y,p,S)=>{s.type==="property"&&(y===":"?s.colonOffset=p:y===","&&t(p))},onError:(y,p,S)=>{o.push({error:y,offset:p,length:S})}},n);const v=s.children[0];return v&&delete v.parent,v}function u(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function $(i){switch(i.type){case"array":return i.children.map($);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=$(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function l(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function d(i,o,n=!1){if(l(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}function h(i,o,n=A.DEFAULT){const s=O(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),y=t(o.onObjectEnd),p=t(o.onArrayBegin),S=t(o.onArrayEnd),E=r(o.onLiteralValue),D=r(o.onSeparator),T=t(o.onComment),F=r(o.onError),q=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function X(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:q?x(10):T();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],J=[]){if(F(ee),ae.length+J.length>0){let z=s.getToken();for(;z!==17;){if(ae.indexOf(z)!==-1){X();break}else if(J.indexOf(z)!==-1)break;z=X()}}}function W(ee){const ae=s.getTokenValue();return ee?E(ae):v(ae),X(),!0}function K(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}E(ee);break}case 7:E(null);break;case 8:E(!0);break;case 9:E(!1);break;default:return!1}return X(),!0}function V(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(D(":"),X(),re()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function H(){a(),X();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),D(","),X(),s.getToken()===2&&Z)break}else ee&&x(6,[],[]);V()||x(4,[],[2,5]),ee=!0}return y(),s.getToken()!==2?x(7,[2],[]):X(),!0}function te(){p(),X();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),D(","),X(),s.getToken()===4&&Z)break}else ee&&x(6,[],[]);re()||x(4,[],[4,5]),ee=!0}return S(),s.getToken()!==4?x(8,[4],[]):X(),!0}function re(){switch(s.getToken()){case 3:return te();case 1:return H();case 10:return W(!0);default:return K()}}return X(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):re()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}function c(i,o){const n=O(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function m(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[42],he([0,1,34]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=N,e.$En=L,e.$Fn=R,e.$Gn=P;function N(g,C,k){let w,f,u,b,$;if(C){for(b=C.offset,$=b+C.length,u=b;u>0&&!P(g,u-1);)u--;let a=$;for(;a<g.length&&!P(g,a);)a++;f=g.substring(u,a),w=O(f,k)}else f=g,w=0,u=0,b=0,$=g.length;const l=R(k,g);let d=!1,h=0,c;k.insertSpaces?c=A(" ",k.tabSize||4):c="	";const m=(0,I.$rn)(f,!1);let i=!1;function o(){return l+A(c,w+h)}function n(){let a=m.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=m.scan();return i=a===16||m.getTokenError()!==0,a}const s=[];function t(a,v,y){!i&&v<$&&y>b&&g.substring(v,y)!==a&&s.push({offset:v,length:y-v,content:a})}let r=n();if(r!==17){const a=m.getTokenOffset()+u,v=A(c,w);t(v,u,a)}for(;r!==17;){let a=m.getTokenOffset()+m.getTokenLength()+u,v=n(),y="";for(;!d&&(v===12||v===13);){const S=m.getTokenOffset()+u;t(" ",a,S),a=m.getTokenOffset()+m.getTokenLength()+u,y=v===12?o():"",v=n()}if(v===2)r!==1&&(h--,y=o());else if(v===4)r!==3&&(h--,y=o());else{switch(r){case 3:case 1:h++,y=o();break;case 5:case 12:y=o();break;case 13:d?y=o():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(i=!0);break;case 16:i=!0;break}d&&(v===12||v===13)&&(y=o())}const p=m.getTokenOffset()+u;t(y,a,p),r=v}return s}function L(g,C){const k=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?k.replace(/\r\n|\r|\n/g,C.eol):k}function A(g,C){let k="";for(let w=0;w<C;w++)k+=g;return k}function O(g,C){let k=0,w=0;const f=C.tabSize||4;for(;k<g.length;){const u=g.charAt(k);if(u===" ")w++;else if(u==="	")w+=f;else break;k++}return Math.floor(w/f)}function R(g,C){for(let k=0;k<C.length;k++){const w=C.charAt(k);if(w==="\r")return k+1<C.length&&C.charAt(k+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return g&&g.eol||`
`}function P(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}}),define(le[62],he([0,1,34,42]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=L,e.$In=A,e.$Jn=O,e.$Kn=R,e.$Ln=P;function L(g,C,k){return A(g,C,void 0,k)}function A(g,C,k,w,f){const u=C.slice(),b=[],$=(0,I.$un)(g,b);let l,d;for(;u.length>0&&(d=u.pop(),l=(0,I.$vn)($,u),l===void 0&&k!==void 0);)typeof d=="string"?k={[d]:k}:k=[k];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const h=(0,I.$vn)(l,[d]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const c=l.children.indexOf(h.parent);let m,i=h.parent.offset+h.parent.length;if(c>0){const o=l.children[c-1];m=o.offset+o.length}else m=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return O(g,{offset:m,length:i-m,content:""},w)}else return O(g,{offset:h.offset,length:h.length,content:JSON.stringify(k)},w);else{if(k===void 0)return[];const c=`${JSON.stringify(d)}: ${JSON.stringify(k)}`,m=f?f(l.children.map(o=>o.children[0].value)):l.children.length;let i;if(m>0){const o=l.children[m-1];i={offset:o.offset+o.length,length:0,content:","+c}}else l.children.length===0?i={offset:l.offset+1,length:0,content:c}:i={offset:l.offset+1,length:0,content:c+","};return O(g,i,w)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let c;if(l.children.length===0||d===0)c={offset:l.offset+1,length:0,content:l.children.length===0?h:h+","};else{const m=d===-1||d>l.children.length?l.children.length:d,i=l.children[m-1];c={offset:i.offset+i.length,length:0,content:","+h}}return O(g,c,w)}else{const h=d,c=l.children[h];let m;if(l.children.length===1)m={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===h){const i=l.children[h-1],o=i.offset+i.length,n=l.offset+l.length;m={offset:o,length:n-2-o,content:""}}else m={offset:c.offset,length:l.children[h+1].offset-c.offset,content:""};return O(g,m,w)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return O(g,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(k)},w)}}function O(g,C,k){let w=R(g,C),f=C.offset,u=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;f>0&&!(0,N.$Gn)(w,f-1);)f--;for(;u<w.length&&!(0,N.$Gn)(w,u);)u++}const b=(0,N.$Dn)(w,{offset:f,length:u-f},k);for(let l=b.length-1;l>=0;l--){const d=b[l];w=R(w,d),f=Math.min(f,d.offset),u=Math.max(u,d.offset+d.length),u+=d.content.length-d.length}const $=g.length-(w.length-u)-f;return[{offset:f,length:$,content:w.substring(f,u)}]}function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}function P(g,C){const k=C.slice(0).sort((f,u)=>{const b=f.offset-u.offset;return b===0?f.length-u.length:b});let w=g.length;for(let f=k.length-1;f>=0;f--){const u=k[f];if(u.offset+u.length<=w)g=R(g,u);else throw new Error("Overlapping edit");w=u.offset}return g}}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class N{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const O=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new I(A);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$4c=N}),define(le[35],he([0,1]),function(se,e){"use strict";var I,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=O,e.$zc=R,e.$Hc=d;function A(h,c,m){let i=h.get(c);return i===void 0&&(i=m,h.set(c,i)),i}function O(h){const c=[];return h.forEach((m,i)=>{c.push(`${i} => ${m}`)}),`Map(${h.size}) {${c.join(", ")}}`}function R(h){const c=[];return h.forEach(m=>{c.push(m)}),`Set(${h.size}) {${c.join(", ")}}`}class P{constructor(c,m){this.uri=c,this.value=m}}function g(h){return Array.isArray(h)}class C{static{this.c=c=>c.toString()}constructor(c,m){if(this[I]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=m??C.c;else if(g(c)){this.d=new Map,this.e=m??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,m){return this.d.set(this.e(c),new P(c,m)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,m){typeof m<"u"&&(c=c.bind(m));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Ac=C;class k{constructor(c,m){this[N]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C(m),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,m){this.c.forEach((i,o)=>c.call(m,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var w;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class f{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,m=0){const i=this.c.get(c);if(i)return m!==0&&this.l(i,m),i.value}set(c,m,i=0){let o=this.c.get(c);if(o)o.value=m,i!==0&&this.l(o,i);else{switch(o={key:c,value:m,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const m=this.c.get(c);if(m)return this.c.delete(c),this.k(m),this.f--,m.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,m){const i=this.g;let o=this.d;for(;o;){if(m?c.bind(m)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,m=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==m)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,m=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==m)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,m=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==m)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let m=this.d,i=this.size;for(;m&&i>c;)this.c.delete(m.key),m=m.next,i--;this.d=m,this.f=i,m&&(m.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const m=c.next,i=c.previous;if(!m||!i)throw new Error("Invalid list");m.previous=i,i.next=m}c.next=void 0,c.previous=void 0,this.g++}l(c,m){if(!this.d||!this.e)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(m===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((m,i)=>{c.push([i,m])}),c}fromJSON(c){this.clear();for(const[m,i]of c)this.set(m,i)}}e.$Cc=f;class u extends f{constructor(c,m=1){super(),this.m=c,this.n=Math.min(Math.max(0,m),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,m=2){return super.get(c,m)}peek(c){return super.get(c,0)}set(c,m){return super.set(c,m,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=u;class b{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let m=this.c.get(c)||0;return m===0?!1:(m--,m===0?this.c.delete(c):this.c.set(c,m),!0)}has(c){return this.c.has(c)}}e.$Ec=b;class ${constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[m,i]of c)this.set(m,i)}clear(){this.c.clear(),this.d.clear()}set(c,m){this.c.set(c,m),this.d.set(m,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const m=this.c.get(c);return m===void 0?!1:(this.c.delete(c),this.d.delete(m),!0)}forEach(c,m){this.c.forEach((i,o)=>{c.call(m,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class l{constructor(){this.c=new Map}add(c,m){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(m)}delete(c,m){const i=this.c.get(c);i&&(i.delete(m),i.size===0&&this.c.delete(c))}forEach(c,m){const i=this.c.get(c);i&&i.forEach(m)}get(c){const m=this.c.get(c);return m||new Set}}e.$Gc=l;function d(h,c){if(h===c)return!0;if(h.size!==c.size)return!1;for(const[m,i]of h)if(!c.has(m)||c.get(m)!==i)return!1;for(const[m]of c)if(!h.has(m))return!1;return!0}}),define(le[2],he([0,1,17,126,35,85,61]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=C,e.$Kc=k,e.$Lc=w,e.$Mc=b,e.$Nc=$,e.$Oc=l,e.$Pc=d,e.$Qc=h,e.$Rc=c,e.$2c=y;const R=!1;let P=null;class g{constructor(){this.b=new Map}static{this.a=0}c(E){let D=this.b.get(E);return D||(D={parent:null,source:null,isSingleton:!1,value:E,idx:g.a++},this.b.set(E,D)),D}trackDisposable(E){const D=this.c(E);D.source||(D.source=new Error().stack)}setParent(E,D){const T=this.c(E);T.parent=D}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,D){const T=D.get(E);if(T)return T;const F=E.parent?this.f(this.c(E.parent),D):E;return D.set(E,F),F}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,E).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(E=10,D){let T;if(D)T=D;else{const x=new Map,W=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,x).isSingleton);if(W.length===0)return;const K=new Set(W.map(V=>V.value));if(T=W.filter(V=>!(V.parent&&K.has(V.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function F(x){function W(V,H){for(;V.length>0&&H.some(te=>typeof te=="string"?te===V[0]:V[0].match(te));)V.shift()}const K=x.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return W(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const q=new L.$Gc;for(const x of T){const W=F(x);for(let K=0;K<=W.length;K++)q.add(W.slice(0,K).join(`
`),x)}T.sort((0,I.$7b)(x=>x.idx,I.$9b));let Z="",X=0;for(const x of T.slice(0,E)){X++;const W=F(x),K=[];for(let V=0;V<W.length;V++){let H=W[V];H=`(shared with ${q.get(W.slice(0,V+1).join(`
`)).size}/${T.length} leaks) at ${H}`;const re=q.get(W.slice(0,V).join(`
`)),ee=(0,N.$K)([...re].map(ae=>F(ae)[V]),ae=>ae);delete ee[W[V]];for(const[ae,J]of Object.entries(ee))K.unshift(`    - stacktraces of ${J.length} other leaks continue with ${ae}`);K.unshift(H)}Z+=`


==================== Leaking disposable ${X}/${T.length}: ${x.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return T.length>E&&(Z+=`


... and ${T.length-E} more leaking disposables

`),{leaks:T,details:Z}}}e.$Ic=g;function C(S){P=S}if(R){const S="__is_disposable_tracked__";C(new class{trackDisposable(E){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[S]||console.log(D)},3e3)}setParent(E,D){if(E&&E!==i.None)try{E[S]=!0}catch{}}markAsDisposed(E){if(E&&E!==i.None)try{E[S]=!0}catch{}}markAsSingleton(E){}})}function k(S){return P?.trackDisposable(S),S}function w(S){P?.markAsDisposed(S)}function f(S,E){P?.setParent(S,E)}function u(S,E){if(P)for(const D of S)P.setParent(D,E)}function b(S){return P?.markAsSingleton(S),S}function $(S){return typeof S.dispose=="function"&&S.dispose.length===0}function l(S){if(O.Iterable.is(S)){const E=[];for(const D of S)if(D)try{D.dispose()}catch(T){E.push(T)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function d(S){for(const E of S)$(E)&&E.dispose();return[]}function h(...S){const E=c(()=>l(S));return u(S,E),E}function c(S){const E=k({dispose:(0,A.$db)(()=>{w(E),S()})});return E}class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return f(E,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),f(E,null))}}e.$Sc=m;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,k(this),f(this.q,this)}dispose(){w(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}e.$Tc=i;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&f(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&f(E,null),E}}e.$Uc=o;class n{constructor(E){this.a=new o,this.b=!1,this.a.value=E}get value(){return this.a.value}set value(E){this.b||E===this.a.value||(this.a.value=E)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(E){let D=E;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,w(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(E,...D){let T=this.a.get(E);T||(T={counter:0,object:this.b(E,...D)},this.a.set(E,T));const{object:F}=T,q=(0,A.$db)(()=>{--T.counter===0&&(this.c(E,T.object),this.a.delete(E))});return T.counter++,{object:F,dispose:q}}}e.$Yc=r;class a{constructor(E){this.a=E}async acquire(E,...D){const T=this.a.acquire(E,...D);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(F){throw T.dispose(),F}}}e.$Zc=a;class v{constructor(E){this.object=E}dispose(){}}e.$1c=v;function y(S){const E=new m;try{S(E)}finally{E.dispose()}}class p{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,D,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(E)?.dispose(),this.a.set(E,D)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=p}),define(le[87],he([0,1,35]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=void 0,e.$Xl=L,e.$Yl=O;const N=new I.$Dc(1e4);function L(g){return P(g,"NFC",N)}const A=new I.$Dc(1e4);function O(g){return P(g,"NFD",A)}const R=/[^\u0000-\u0080]/;function P(g,C,k){if(!g)return g;const w=k.get(g);if(w)return w;let f;return R.test(g)?f=g.normalize(C):f=g,k.set(g,f),f}e.$Zl=function(){const g=/[\u0300-\u036f]/g;return function(C){return O(C).replace(g,"")}}()}),function(){function se(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(P){A.push(P,Date.now())}function R(){const P=[];for(let g=0;g<A.length;g+=2)P.push({name:A[g],startTime:A[g+1]});return P}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function I(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:se)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function I(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return se[N].call(L.exports,L,L.exports,I),L.l=!0,L.exports}return I.m=se,I.c=e,I.d=function(N,L,A){I.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:A})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,L){if(1&L&&(N=I(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)I.d(A,O,function(R){return N[R]}.bind(null,O));return A},I.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(L,"a",L),L},I.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},I.p="",I(I.s=0)}([function(se,e,I){(function(N){var L;e=se.exports=J,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],g=0,C=g++;P[C]="0|[1-9]\\d*";var k=g++;P[k]="[0-9]+";var w=g++;P[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=g++;P[f]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var u=g++;P[u]="("+P[k]+")\\.("+P[k]+")\\.("+P[k]+")";var b=g++;P[b]="(?:"+P[C]+"|"+P[w]+")";var $=g++;P[$]="(?:"+P[k]+"|"+P[w]+")";var l=g++;P[l]="(?:-("+P[b]+"(?:\\."+P[b]+")*))";var d=g++;P[d]="(?:-?("+P[$]+"(?:\\."+P[$]+")*))";var h=g++;P[h]="[0-9A-Za-z-]+";var c=g++;P[c]="(?:\\+("+P[h]+"(?:\\."+P[h]+")*))";var m=g++,i="v?"+P[f]+P[l]+"?"+P[c]+"?";P[m]="^"+i+"$";var o="[v=\\s]*"+P[u]+P[d]+"?"+P[c]+"?",n=g++;P[n]="^"+o+"$";var s=g++;P[s]="((?:<|>)?=?)";var t=g++;P[t]=P[k]+"|x|X|\\*";var r=g++;P[r]=P[C]+"|x|X|\\*";var a=g++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[l]+")?"+P[c]+"?)?)?";var v=g++;P[v]="[v=\\s]*("+P[t]+")(?:\\.("+P[t]+")(?:\\.("+P[t]+")(?:"+P[d]+")?"+P[c]+"?)?)?";var y=g++;P[y]="^"+P[s]+"\\s*"+P[a]+"$";var p=g++;P[p]="^"+P[s]+"\\s*"+P[v]+"$";var S=g++;P[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=g++;P[E]="(?:~>?)";var D=g++;P[D]="(\\s*)"+P[E]+"\\s+",R[D]=new RegExp(P[D],"g");var T=g++;P[T]="^"+P[E]+P[a]+"$";var F=g++;P[F]="^"+P[E]+P[v]+"$";var q=g++;P[q]="(?:\\^)";var Z=g++;P[Z]="(\\s*)"+P[q]+"\\s+",R[Z]=new RegExp(P[Z],"g");var X=g++;P[X]="^"+P[q]+P[a]+"$";var x=g++;P[x]="^"+P[q]+P[v]+"$";var W=g++;P[W]="^"+P[s]+"\\s*("+o+")$|^$";var K=g++;P[K]="^"+P[s]+"\\s*("+i+")$|^$";var V=g++;P[V]="(\\s*)"+P[s]+"\\s*("+o+"|"+P[a]+")",R[V]=new RegExp(P[V],"g");var H=g++;P[H]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var te=g++;P[te]="^\\s*("+P[v]+")\\s+-\\s+("+P[v]+")\\s*$";var re=g++;P[re]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)L(ee,P[ee]),R[ee]||(R[ee]=new RegExp(P[ee]));function ae(ue,$e){if(ue instanceof J)return ue;if(typeof ue!="string"||ue.length>A||!($e?R[n]:R[m]).test(ue))return null;try{return new J(ue,$e)}catch{return null}}function J(ue,$e){if(ue instanceof J){if(ue.loose===$e)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(ue,$e);L("SemVer",ue,$e),this.loose=$e;var we=ue.trim().match($e?R[n]:R[m]);if(!we)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ce=+Pe;if(Ce>=0&&Ce<O)return Ce}return Pe}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,$e){var we=ae(ue,$e);return we?we.version:null},e.clean=function(ue,$e){var we=ae(ue.trim().replace(/^[=v]+/,""),$e);return we?we.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(ue){return L("SemVer.compare",this.version,this.loose,ue),ue instanceof J||(ue=new J(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},J.prototype.compareMain=function(ue){return ue instanceof J||(ue=new J(ue,this.loose)),j(this.major,ue.major)||j(this.minor,ue.minor)||j(this.patch,ue.patch)},J.prototype.comparePre=function(ue){if(ue instanceof J||(ue=new J(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var $e=0;do{var we=this.prerelease[$e],Pe=ue.prerelease[$e];if(L("prerelease compare",$e,we,Pe),we===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(we===void 0)return-1;if(we!==Pe)return j(we,Pe)}while(++$e)},J.prototype.inc=function(ue,$e){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,$e,we,Pe){typeof we=="string"&&(Pe=we,we=void 0);try{return new J(ue,we).inc($e,Pe).version}catch{return null}},e.diff=function(ue,$e){if(Y(ue,$e))return null;var we=ae(ue),Pe=ae($e);if(we.prerelease.length||Pe.prerelease.length){for(var Ce in we)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&we[Ce]!==Pe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in we)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&we[Ce]!==Pe[Ce])return Ce},e.compareIdentifiers=j;var z=/^[0-9]+$/;function j(ue,$e){var we=z.test(ue),Pe=z.test($e);return we&&Pe&&(ue=+ue,$e=+$e),we&&!Pe?-1:Pe&&!we?1:ue<$e?-1:ue>$e?1:0}function M(ue,$e,we){return new J(ue,we).compare(new J($e,we))}function B(ue,$e,we){return M(ue,$e,we)>0}function U(ue,$e,we){return M(ue,$e,we)<0}function Y(ue,$e,we){return M(ue,$e,we)===0}function _(ue,$e,we){return M(ue,$e,we)!==0}function ne(ue,$e,we){return M(ue,$e,we)>=0}function G(ue,$e,we){return M(ue,$e,we)<=0}function ie(ue,$e,we,Pe){var Ce;switch($e){case"===":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),Ce=ue===we;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),Ce=ue!==we;break;case"":case"=":case"==":Ce=Y(ue,we,Pe);break;case"!=":Ce=_(ue,we,Pe);break;case">":Ce=B(ue,we,Pe);break;case">=":Ce=ne(ue,we,Pe);break;case"<":Ce=U(ue,we,Pe);break;case"<=":Ce=G(ue,we,Pe);break;default:throw new TypeError("Invalid operator: "+$e)}return Ce}function ce(ue,$e){if(ue instanceof ce){if(ue.loose===$e)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,$e);L("comparator",ue,$e),this.loose=$e,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ue,$e){return j($e,ue)},e.major=function(ue,$e){return new J(ue,$e).major},e.minor=function(ue,$e){return new J(ue,$e).minor},e.patch=function(ue,$e){return new J(ue,$e).patch},e.compare=M,e.compareLoose=function(ue,$e){return M(ue,$e,!0)},e.rcompare=function(ue,$e,we){return M($e,ue,we)},e.sort=function(ue,$e){return ue.sort(function(we,Pe){return e.compare(we,Pe,$e)})},e.rsort=function(ue,$e){return ue.sort(function(we,Pe){return e.rcompare(we,Pe,$e)})},e.gt=B,e.lt=U,e.eq=Y,e.neq=_,e.gte=ne,e.lte=G,e.cmp=ie,e.Comparator=ce;var fe={};function de(ue,$e){if(ue instanceof de)return ue.loose===$e?ue:new de(ue.raw,$e);if(ue instanceof ce)return new de(ue.value,$e);if(!(this instanceof de))return new de(ue,$e);if(this.loose=$e,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function me(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,$e,we,Pe,Ce,Me,De,ze,Te,Ue,qe,Le,oe){return(($e=me(we)?"":me(Pe)?">="+we+".0.0":me(Ce)?">="+we+"."+Pe+".0":">="+$e)+" "+(ze=me(Te)?"":me(Ue)?"<"+(+Te+1)+".0.0":me(qe)?"<"+Te+"."+(+Ue+1)+".0":Le?"<="+Te+"."+Ue+"."+qe+"-"+Le:"<="+ze)).trim()}function Re(ue,$e){for(var we=0;we<ue.length;we++)if(!ue[we].test($e))return!1;if($e.prerelease.length){for(we=0;we<ue.length;we++)if(L(ue[we].semver),ue[we].semver!==fe&&ue[we].semver.prerelease.length>0){var Pe=ue[we].semver;if(Pe.major===$e.major&&Pe.minor===$e.minor&&Pe.patch===$e.patch)return!0}return!1}return!0}function Oe(ue,$e,we){try{$e=new de($e,we)}catch{return!1}return $e.test(ue)}function Ne(ue,$e,we,Pe){var Ce,Me,De,ze,Te;switch(ue=new J(ue,Pe),$e=new de($e,Pe),we){case">":Ce=B,Me=G,De=U,ze=">",Te=">=";break;case"<":Ce=U,Me=ne,De=B,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,$e,Pe))return!1;for(var Ue=0;Ue<$e.set.length;++Ue){var qe=$e.set[Ue],Le=null,oe=null;if(qe.forEach(function(ge){ge.semver===fe&&(ge=new ce(">=0.0.0")),Le=Le||ge,oe=oe||ge,Ce(ge.semver,Le.semver,Pe)?Le=ge:De(ge.semver,oe.semver,Pe)&&(oe=ge)}),Le.operator===ze||Le.operator===Te||(!oe.operator||oe.operator===ze)&&Me(ue,oe.semver)||oe.operator===Te&&De(ue,oe.semver))return!1}return!0}ce.prototype.parse=function(ue){var $e=this.loose?R[W]:R[K],we=ue.match($e);if(!we)throw new TypeError("Invalid comparator: "+ue);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new J(we[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return L("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new J(ue,this.loose)),ie(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,$e){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new de(ue.value,$e),Oe(this.value,we,$e);if(ue.operator==="")return we=new de(this.value,$e),Oe(ue.semver,we,$e);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Me=this.semver.version===ue.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),ze=ie(this.semver,"<",ue.semver,$e)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=ie(this.semver,">",ue.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Ce||Me&&De||ze||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var $e=this.loose;ue=ue.trim(),L("range",ue,$e);var we=$e?R[te]:R[H];ue=ue.replace(we,Ee),L("hyphen replace",ue),ue=ue.replace(R[V],"$1$2$3"),L("comparator trim",ue,R[V]),ue=(ue=(ue=ue.replace(R[D],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Pe=$e?R[W]:R[K],Ce=ue.split(" ").map(function(Me){return function(De,ze){return L("comp",De),De=function(Te,Ue){return Te.trim().split(/\s+/).map(function(qe){return function(Le,oe){L("caret",Le,oe);var ge=oe?R[x]:R[X];return Le.replace(ge,function(be,pe,ve,ke,Ie){var Ae;return L("caret",Le,be,pe,ve,ke,Ie),me(pe)?Ae="":me(ve)?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":me(ke)?Ae=pe==="0"?">="+pe+"."+ve+".0 <"+pe+"."+(+ve+1)+".0":">="+pe+"."+ve+".0 <"+(+pe+1)+".0.0":Ie?(L("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=pe==="0"?ve==="0"?">="+pe+"."+ve+"."+ke+Ie+" <"+pe+"."+ve+"."+(+ke+1):">="+pe+"."+ve+"."+ke+Ie+" <"+pe+"."+(+ve+1)+".0":">="+pe+"."+ve+"."+ke+Ie+" <"+(+pe+1)+".0.0"):(L("no pr"),Ae=pe==="0"?ve==="0"?">="+pe+"."+ve+"."+ke+" <"+pe+"."+ve+"."+(+ke+1):">="+pe+"."+ve+"."+ke+" <"+pe+"."+(+ve+1)+".0":">="+pe+"."+ve+"."+ke+" <"+(+pe+1)+".0.0"),L("caret return",Ae),Ae})}(qe,Ue)}).join(" ")}(De,ze),L("caret",De),De=function(Te,Ue){return Te.trim().split(/\s+/).map(function(qe){return function(Le,oe){var ge=oe?R[F]:R[T];return Le.replace(ge,function(be,pe,ve,ke,Ie){var Ae;return L("tilde",Le,be,pe,ve,ke,Ie),me(pe)?Ae="":me(ve)?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":me(ke)?Ae=">="+pe+"."+ve+".0 <"+pe+"."+(+ve+1)+".0":Ie?(L("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+pe+"."+ve+"."+ke+Ie+" <"+pe+"."+(+ve+1)+".0"):Ae=">="+pe+"."+ve+"."+ke+" <"+pe+"."+(+ve+1)+".0",L("tilde return",Ae),Ae})}(qe,Ue)}).join(" ")}(De,ze),L("tildes",De),De=function(Te,Ue){return L("replaceXRanges",Te,Ue),Te.split(/\s+/).map(function(qe){return function(Le,oe){Le=Le.trim();var ge=oe?R[p]:R[y];return Le.replace(ge,function(be,pe,ve,ke,Ie,Ae){L("xRange",Le,be,pe,ve,ke,Ie,Ae);var He=me(ve),Be=He||me(ke),Fe=Be||me(Ie);return pe==="="&&Fe&&(pe=""),He?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Fe?(Be&&(ke=0),Fe&&(Ie=0),pe===">"?(pe=">=",Be?(ve=+ve+1,ke=0,Ie=0):Fe&&(ke=+ke+1,Ie=0)):pe==="<="&&(pe="<",Be?ve=+ve+1:ke=+ke+1),be=pe+ve+"."+ke+"."+Ie):Be?be=">="+ve+".0.0 <"+(+ve+1)+".0.0":Fe&&(be=">="+ve+"."+ke+".0 <"+ve+"."+(+ke+1)+".0"),L("xRange return",be),be})}(qe,Ue)}).join(" ")}(De,ze),L("xrange",De),De=function(Te,Ue){return L("replaceStars",Te,Ue),Te.trim().replace(R[re],"")}(De,ze),L("stars",De),De}(Me,$e)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Me){return!!Me.match(Pe)})),Ce=Ce.map(function(Me){return new ce(Me,$e)})},de.prototype.intersects=function(ue,$e){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Pe){return ue.set.some(function(Ce){return Ce.every(function(Me){return Pe.intersects(Me,$e)})})})})},e.toComparators=function(ue,$e){return new de(ue,$e).set.map(function(we){return we.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new J(ue,this.loose));for(var $e=0;$e<this.set.length;$e++)if(Re(this.set[$e],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,$e,we){var Pe=null,Ce=null;try{var Me=new de($e,we)}catch{return null}return ue.forEach(function(De){Me.test(De)&&(Pe&&Ce.compare(De)!==-1||(Ce=new J(Pe=De,we)))}),Pe},e.minSatisfying=function(ue,$e,we){var Pe=null,Ce=null;try{var Me=new de($e,we)}catch{return null}return ue.forEach(function(De){Me.test(De)&&(Pe&&Ce.compare(De)!==1||(Ce=new J(Pe=De,we)))}),Pe},e.validRange=function(ue,$e){try{return new de(ue,$e).range||"*"}catch{return null}},e.ltr=function(ue,$e,we){return Ne(ue,$e,"<",we)},e.gtr=function(ue,$e,we){return Ne(ue,$e,">",we)},e.outside=Ne,e.prerelease=function(ue,$e){var we=ae(ue,$e);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(ue,$e,we){return ue=new de(ue,we),$e=new de($e,we),ue.intersects($e)},e.coerce=function(ue){if(ue instanceof J)return ue;if(typeof ue!="string")return null;var $e=ue.match(R[S]);return $e==null?null:ae(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,I(1))},function(se,e){var I,N,L=se.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R($){if(I===setTimeout)return setTimeout($,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout($,0);try{return I($,0)}catch{try{return I.call(null,$,0)}catch{return I.call(this,$,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var P,g=[],C=!1,k=-1;function w(){C&&P&&(C=!1,P.length?g=P.concat(g):k=-1,g.length&&f())}function f(){if(!C){var $=R(w);C=!0;for(var l=g.length;l;){for(P=g,g=[];++k<l;)P&&P[k].run();k=-1,l=g.length}P=null,C=!1,function(d){if(N===clearTimeout)return clearTimeout(d);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(d);try{N(d)}catch{try{return N.call(null,d)}catch{return N.call(this,d)}}}($)}}function u($,l){this.fun=$,this.array=l}function b(){}L.nextTick=function($){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];g.push(new u($,l)),g.length!==1||C||R(f)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=b,L.addListener=b,L.once=b,L.off=b,L.removeListener=b,L.removeAllListeners=b,L.emit=b,L.prependListener=b,L.prependOnceListener=b,L.listeners=function($){return[]},L.binding=function($){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function($){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class N{constructor(R,P,g){this.level=R,this.key=P,this.value=g,this.forward=[]}}const L=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,P){return A.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=A.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let g=this.e.forward[0];for(;g;)R.call(P,g.value,g.key,this),g=g.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,g){let C=R.e;for(let k=R.d-1;k>=0;k--)for(;C.forward[k]&&g(C.forward[k].key,P)<0;)C=C.forward[k];if(C=C.forward[0],C&&g(C.key,P)===0)return C}static h(R,P,g,C){const k=[];let w=R.e;for(let f=R.d-1;f>=0;f--){for(;w.forward[f]&&C(w.forward[f].key,P)<0;)w=w.forward[f];k[f]=w}if(w=w.forward[0],w&&C(w.key,P)===0)return w.value=g,!1;{const f=A.j(R);if(f>R.d){for(let u=R.d;u<f;u++)k[u]=R.e;R.d=f}w=new N(f,P,g);for(let u=0;u<f;u++)w.forward[u]=k[u].forward[u],k[u].forward[u]=w;return!0}}static j(R,P=.5){let g=1;for(;Math.random()<P&&g<R.c;)g+=1;return g}static k(R,P,g){const C=[];let k=R.e;for(let w=R.d-1;w>=0;w--){for(;k.forward[w]&&g(k.forward[w].key,P)<0;)k=k.forward[w];C[w]=k}if(k=k.forward[0],!k||g(k.key,P)!==0)return!1;for(let w=0;w<R.d&&C[w].forward[w]===k;w++)C[w].forward[w]=k.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===L;)R.d-=1;return!0}}e.$es=A}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=N}),define(le[3],he([0,1,7,85,2,86,63]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$4d=e.Event=void 0,e.$5d=w;const R=!1,P=!1;var g;(function(y){y.None=()=>L.$Tc.None;function p(G){if(P){const{onDidAddListener:ie}=G,ce=u.create();let fe=0;G.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ie?.()}}}function S(G,ie){return K(G,()=>{},0,void 0,!0,void 0,ie)}y.defer=S;function E(G){return(ie,ce=null,fe)=>{let de=!1,me;return me=G(Ee=>{if(!de)return me?me.dispose():de=!0,ie.call(ce,Ee)},null,fe),de&&me.dispose(),me}}y.once=E;function D(G,ie,ce){return x((fe,de=null,me)=>G(Ee=>fe.call(de,ie(Ee)),null,me),ce)}y.map=D;function T(G,ie,ce){return x((fe,de=null,me)=>G(Ee=>{ie(Ee),fe.call(de,Ee)},null,me),ce)}y.forEach=T;function F(G,ie,ce){return x((fe,de=null,me)=>G(Ee=>ie(Ee)&&fe.call(de,Ee),null,me),ce)}y.filter=F;function q(G){return G}y.signal=q;function Z(...G){return(ie,ce=null,fe)=>{const de=(0,L.$Qc)(...G.map(me=>me(Ee=>ie.call(ce,Ee))));return W(de,fe)}}y.any=Z;function X(G,ie,ce,fe){let de=ce;return D(G,me=>(de=ie(de,me),de),fe)}y.reduce=X;function x(G,ie){let ce;const fe={onWillAddFirstListener(){ce=G(de.fire,de)},onDidRemoveLastListener(){ce?.dispose()}};ie||p(fe);const de=new h(fe);return ie?.add(de),de.event}function W(G,ie){return ie instanceof Array?ie.push(G):ie&&ie.add(G),G}function K(G,ie,ce=100,fe=!1,de=!1,me,Ee){let Re,Oe,Ne,ue=0,$e;const we={leakWarningThreshold:me,onWillAddFirstListener(){Re=G(Ce=>{ue++,Oe=ie(Oe,Ce),fe&&!Ne&&(Pe.fire(Oe),Oe=void 0),$e=()=>{const Me=Oe;Oe=void 0,Ne=void 0,(!fe||ue>1)&&Pe.fire(Me),ue=0},typeof ce=="number"?(clearTimeout(Ne),Ne=setTimeout($e,ce)):Ne===void 0&&(Ne=0,queueMicrotask($e))})},onWillRemoveListener(){de&&ue>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,Re.dispose()}};Ee||p(we);const Pe=new h(we);return Ee?.add(Pe),Pe.event}y.debounce=K;function V(G,ie=0,ce){return y.debounce(G,(fe,de)=>fe?(fe.push(de),fe):[de],ie,void 0,!0,void 0,ce)}y.accumulate=V;function H(G,ie=(fe,de)=>fe===de,ce){let fe=!0,de;return F(G,me=>{const Ee=fe||!ie(me,de);return fe=!1,de=me,Ee},ce)}y.latch=H;function te(G,ie,ce){return[y.filter(G,ie,ce),y.filter(G,fe=>!ie(fe),ce)]}y.split=te;function re(G,ie=!1,ce=[],fe){let de=ce.slice(),me=G(Oe=>{de?de.push(Oe):Re.fire(Oe)});fe&&fe.add(me);const Ee=()=>{de?.forEach(Oe=>Re.fire(Oe)),de=null},Re=new h({onWillAddFirstListener(){me||(me=G(Oe=>Re.fire(Oe)),fe&&fe.add(me))},onDidAddFirstListener(){de&&(ie?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return fe&&fe.add(Re),Re.event}y.buffer=re;function ee(G,ie){return(fe,de,me)=>{const Ee=ie(new J);return G(function(Re){const Oe=Ee.evaluate(Re);Oe!==ae&&fe.call(de,Oe)},void 0,me)}}y.chain=ee;const ae=Symbol("HaltChainable");class J{constructor(){this.f=[]}map(ie){return this.f.push(ie),this}forEach(ie){return this.f.push(ce=>(ie(ce),ce)),this}filter(ie){return this.f.push(ce=>ie(ce)?ce:ae),this}reduce(ie,ce){let fe=ce;return this.f.push(de=>(fe=ie(fe,de),fe)),this}latch(ie=(ce,fe)=>ce===fe){let ce=!0,fe;return this.f.push(de=>{const me=ce||!ie(de,fe);return ce=!1,fe=de,me?de:ae}),this}evaluate(ie){for(const ce of this.f)if(ie=ce(ie),ie===ae)break;return ie}}function z(G,ie,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>G.on(ie,fe),me=()=>G.removeListener(ie,fe),Ee=new h({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}y.fromNodeEventEmitter=z;function j(G,ie,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>G.addEventListener(ie,fe),me=()=>G.removeEventListener(ie,fe),Ee=new h({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}y.fromDOMEventEmitter=j;function M(G){return new Promise(ie=>E(G)(ie))}y.toPromise=M;function B(G){const ie=new h;return G.then(ce=>{ie.fire(ce)},()=>{ie.fire(void 0)}).finally(()=>{ie.dispose()}),ie.event}y.fromPromise=B;function U(G,ie,ce){return ie(ce),G(fe=>ie(fe))}y.runAndSubscribe=U;class Y{constructor(ie,ce){this._observable=ie,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{ie.addObserver(this)},onDidRemoveLastListener:()=>{ie.removeObserver(this)}};ce||p(fe),this.emitter=new h(fe),ce&&ce.add(this.emitter)}beginUpdate(ie){this.f++}handlePossibleChange(ie){}handleChange(ie,ce){this.g=!0}endUpdate(ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(G,ie){return new Y(G,ie).emitter.event}y.fromObservable=_;function ne(G){return(ie,ce,fe)=>{let de=0,me=!1;const Ee={beginUpdate(){de++},endUpdate(){de--,de===0&&(G.reportChanges(),me&&(me=!1,ie.call(ce)))},handlePossibleChange(){},handleChange(){me=!0}};G.addObserver(Ee),G.reportChanges();const Re={dispose(){G.removeObserver(Ee)}};return fe instanceof L.$Sc?fe.add(Re):Array.isArray(fe)&&fe.push(Re),Re}}y.fromObservableLight=ne})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${C.f++}`,C.all.add(this)}start(p){this.g=new O.$2d,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$4d=C;let k=-1;function w(y){const p=k;return k=y,{dispose(){k=p}}}class f{constructor(p,S=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=S,this.g=0}dispose(){this.f?.clear()}check(p,S){const E=this.threshold;if(E<=0||S<E)return;this.f||(this.f=new Map);const D=this.f.get(p.value)||0;if(this.f.set(p.value,D+1),this.g-=1,this.g<=0){this.g=E*.5;let T,F=0;for(const[q,Z]of this.f)(!T||F<Z)&&(T=q,F=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${F}):`),console.warn(T)}return()=>{const T=this.f.get(p.value)||0;this.f.set(p.value,T-1)}}}class u{static create(){return new u(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class ${constructor(p){this.value=p,this.id=b++}}const l=2,d=(y,p)=>{if(y instanceof $)p(y);else for(let S=0;S<y.length;S++){const E=y[S];E&&p(E)}};class h{constructor(p){this.w=0,this.f=p,this.g=k>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const p=this.t;queueMicrotask(()=>{d(p,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,S,E)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Tc.None;if(this.m)return L.$Tc.None;S&&(p=p.bind(S));const D=new $(p);let T,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(D.stack=u.create(),T=this.g.check(D.stack,this.w+1)),R&&(D.stack=F??u.create()),this.t?this.t instanceof $?(this.u??=new m,this.t=[this.t,D]):this.t.push(D):(this.f?.onWillAddFirstListener?.(this),this.t=D,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,L.$Rc)(()=>{T?.(),this.x(D)});return E instanceof L.$Sc?E.add(q):Array.isArray(E)&&E.push(q),q},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,E=S.indexOf(p);if(E===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[E]=void 0;const D=this.u.current===this;if(this.w*l<=S.length){let T=0;for(let F=0;F<S.length;F++)S[F]?S[T++]=S[F]:D&&(this.u.end--,T<this.u.i&&this.u.i--);S.length=T}}y(p,S){if(!p)return;const E=this.f?.onListenerError||I.$1;if(!E){p.value(S);return}try{p.value(S)}catch(D){E(D)}}z(p){const S=p.current.t;for(;p.i<p.end;)this.y(S[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,p);else{const S=this.u;S.enqueue(this,p,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=h;const c=()=>new m;e.$7d=c;class m{constructor(){this.i=-1,this.end=0}enqueue(p,S,E){this.i=0,this.end=E,this.current=p,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends h{async fireAsync(p,S,E){if(this.t)for(this.h||(this.h=new A.$4c),d(this.t,D=>this.h.push([D.value,p]));this.h.size>0&&!S.isCancellationRequested;){const[D,T]=this.h.shift(),F=[],q={...T,token:S,waitUntil:Z=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");E&&(Z=E(Z,D)),F.push(Z)}};try{D(q)}catch(Z){(0,I.$1)(Z);continue}Object.freeze(F),await Promise.allSettled(F).then(Z=>{for(const X of Z)X.status==="rejected"&&(0,I.$1)(X.reason)})}}}e.$8d=i;class o extends h{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new A.$4c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$9d=o;class n extends o{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$0d=n;class s extends h{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}e.$$d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const S={event:p,listener:null};this.h.push(S),this.g&&this.m(S);const E=()=>{this.g&&this.o(S);const D=this.h.indexOf(S);this.h.splice(D,1)};return(0,L.$Rc)((0,N.$db)(E))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(S=>this.f.fire(S))}o(p){p.listener?.dispose(),p.listener=null}dispose(){this.f.dispose();for(const p of this.h)p.listener?.dispose();this.h=[]}}e.$_d=t;class r{constructor(p,S,E,D){this.f=new L.$Sc;const T=this.f.add(new t),F=this.f.add(new L.$3c);function q(Z){F.set(Z,T.add(D(Z)))}for(const Z of p)q(Z);this.f.add(S(Z=>{q(Z)})),this.f.add(E(Z=>{F.deleteAndDispose(Z)})),this.event=T.event}dispose(){this.f.dispose()}}e.$ae=r;class a{constructor(){this.f=[]}wrapEvent(p){return(S,E,D)=>p(T=>{const F=this.f[this.f.length-1];F?F.push(()=>S.call(E,T)):S.call(E,T)},void 0,D)}bufferEvents(p){const S=[];this.f.push(S);const E=p();return this.f.pop(),S.forEach(D=>D()),E}}e.$be=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=L.$Tc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=v}),define(le[26],he([0,1,3]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const N=Object.freeze(function(R,P){const g=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(g)}}});var L;(function(R){function P(g){return g===R.None||g===R.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new I.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$de=O}),define(le[129],he([0,1,26]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$de,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Oe=N;class L{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.$Pe=L;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.$Qe=A}),define(le[47],he([0,1,7,2]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=L,e.$fe=A,e.$ge=O,e.$he=R,e.$ie=g,e.$je=C,e.$ke=k,e.$le=w,e.$me=f,e.$ne=u,e.$oe=b,e.$pe=$,e.$qe=l,e.$re=d,e.$se=h;function L(c){const m=c;return m?typeof m.read=="function":!1}function A(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(i=>typeof i=="function"):!1}function O(c){const m=c;return m?A(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}function R(c,m){return new P(c,m)}class P{constructor(m,i){this.e=m,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(i=>i(m))}h(m){this.c.error.length===0?(0,I.$1)(m):this.c.error.slice(0).forEach(i=>i(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,i){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(m,i){if(this.a.destroyed)return;let o;switch(m){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(c,m){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return m(i)}function C(c,m,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?m(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function k(c,m){return new Promise((i,o)=>{const n=[];w(c,{onData:s=>{m&&n.push(s)},onError:s=>{m?o(s):i(void 0)},onEnd:()=>{i(m?m(n):void 0)}})})}function w(c,m,i){c.on("error",o=>{i?.isCancellationRequested||m.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||m.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||m.onData(o)})}function f(c,m){return new Promise((i,o)=>{const n=new N.$Sc,s=[],t=v=>{if(s.push(v),s.length>m)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,N.$Rc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,N.$Rc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,N.$Rc)(()=>c.removeListener("data",t))),c.on("data",t)})}function u(c,m){const i=R(m);return i.end(c),i}function b(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}function $(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}function l(c,m,i){const o=R(i);return w(c,{onData:n=>o.write(m.data(n)),onError:n=>o.error(m.error?m.error(n):n),onEnd:()=>o.end()}),o}function d(c,m,i){let o=!1;return{read:()=>{const n=m.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function h(c,m,i){let o=!1;const n=R(i);return w(m,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(le[14],he([0,1,53,47]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=void 0,e.$ue=g,e.$ve=C,e.$we=k,e.$xe=w,e.$ye=f,e.$ze=u,e.$Ae=b,e.$Be=$,e.$Ce=l,e.$De=d,e.$Ee=h,e.$Fe=c,e.$Ge=m,e.$He=i,e.$Ie=o,e.$Je=n,e.$Ke=s,e.$Le=t,e.$Me=r,e.$Ne=y;const L=typeof Buffer<"u",A=new I.$V(()=>new Uint8Array(256));let O,R;class P{static alloc(S){return L?new P(Buffer.allocUnsafe(S)):new P(new Uint8Array(S))}static wrap(S){return L&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new P(S)}static fromString(S,E){return!(E?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(S)):(O||(O=new TextEncoder),new P(O.encode(S)))}static fromByteArray(S){const E=P.alloc(S.length);for(let D=0,T=S.length;D<T;D++)E.buffer[D]=S[D];return E}static concat(S,E){if(typeof E>"u"){E=0;for(let F=0,q=S.length;F<q;F++)E+=S[F].byteLength}const D=P.alloc(E);let T=0;for(let F=0,q=S.length;F<q;F++){const Z=S[F];D.set(Z,T),T+=Z.byteLength}return D}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=P.alloc(this.byteLength);return S.set(this),S}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(S,E){return new P(this.buffer.subarray(S,E))}set(S,E){if(S instanceof P)this.buffer.set(S.buffer,E);else if(S instanceof Uint8Array)this.buffer.set(S,E);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),E);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return w(this.buffer,S)}writeUInt32BE(S,E){f(this.buffer,S,E)}readUInt32LE(S){return u(this.buffer,S)}writeUInt32LE(S,E){b(this.buffer,S,E)}readUInt8(S){return $(this.buffer,S)}writeUInt8(S,E){l(this.buffer,S,E)}indexOf(S,E=0){return g(this.buffer,S instanceof P?S.buffer:S,E)}}e.$te=P;function g(p,S,E=0){const D=S.byteLength,T=p.byteLength;if(D===0)return 0;if(D===1)return p.indexOf(S[0]);if(D>T-E)return-1;const F=A.value;F.fill(S.length);for(let x=0;x<S.length;x++)F[S[x]]=S.length-x-1;let q=E+S.length-1,Z=q,X=-1;for(;q<T;)if(p[q]===S[Z]){if(Z===0){X=q;break}q--,Z--}else q+=Math.max(S.length-Z,F[p[q]]),Z=S.length-1;return X}function C(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0}function k(p,S,E){p[E+0]=S&255,S=S>>>8,p[E+1]=S&255}function w(p,S){return p[S]*2**24+p[S+1]*2**16+p[S+2]*2**8+p[S+3]}function f(p,S,E){p[E+3]=S,S=S>>>8,p[E+2]=S,S=S>>>8,p[E+1]=S,S=S>>>8,p[E]=S}function u(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0|p[S+2]<<16>>>0|p[S+3]<<24>>>0}function b(p,S,E){p[E+0]=S&255,S=S>>>8,p[E+1]=S&255,S=S>>>8,p[E+2]=S&255,S=S>>>8,p[E+3]=S&255}function $(p,S){return p[S]}function l(p,S,E){p[E]=S}function d(p){return N.$ie(p,S=>P.concat(S))}function h(p){return N.$pe(p)}function c(p){return N.$ke(p,S=>P.concat(S))}async function m(p){return p.ended?P.concat(p.buffer):P.concat([...p.buffer,await c(p.stream)])}function i(p){return N.$ne(p,S=>P.concat(S))}function o(p){return N.$qe(p,{data:S=>typeof S=="string"?P.fromString(S):P.wrap(S)},S=>P.concat(S))}function n(p){return N.$he(S=>P.concat(S),p)}function s(p,S){return N.$re(p,S,E=>P.concat(E))}function t(p,S){return N.$se(p,S,E=>P.concat(E))}function r(p){let S=0,E=0,D=0;const T=new Uint8Array(Math.floor(p.length/4*3)),F=Z=>{switch(E){case 3:T[D++]=S|Z,E=0;break;case 2:T[D++]=S|Z>>>2,S=Z<<6,E=3;break;case 1:T[D++]=S|Z>>>4,S=Z<<4,E=2;break;default:S=Z<<2,E=1}};for(let Z=0;Z<p.length;Z++){const X=p.charCodeAt(Z);if(X>=65&&X<=90)F(X-65);else if(X>=97&&X<=122)F(X-97+26);else if(X>=48&&X<=57)F(X-48+52);else if(X===43||X===45)F(62);else if(X===47||X===95)F(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${p[Z]}`)}}const q=D;for(;E>0;)F(0);return P.wrap(T).slice(0,q)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:p},S=!0,E=!1){const D=E?v:a;let T="";const F=p.byteLength%3;let q=0;for(;q<p.byteLength-F;q+=3){const Z=p[q+0],X=p[q+1],x=p[q+2];T+=D[Z>>>2],T+=D[(Z<<4|X>>>4)&63],T+=D[(X<<2|x>>>6)&63],T+=D[x&63]}if(F===1){const Z=p[q+0];T+=D[Z>>>2],T+=D[Z<<4&63],S&&(T+="==")}else if(F===2){const Z=p[q+0],X=p[q+1];T+=D[Z>>>2],T+=D[(Z<<4|X>>>4)&63],T+=D[X<<2&63],S&&(T+="=")}return T}}),define(le[27],he([0,1,129,53]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.GraphemeBreakType=e.$Gf=e.$Af=e.$tf=e.$sf=void 0,e.$Te=L,e.$Ue=O,e.$Ve=P,e.$We=g,e.$Xe=C,e.$Ye=k,e.$Ze=w,e.$1e=f,e.$2e=u,e.$3e=b,e.$4e=$,e.$5e=l,e.$6e=d,e.$7e=h,e.$8e=c,e.$9e=m,e.$0e=i,e.$$e=o,e.$_e=n,e.$af=s,e.$bf=t,e.$cf=r,e.$df=a,e.$ef=v,e.$ff=y,e.$gf=p,e.$hf=S,e.$if=E,e.$jf=D,e.$kf=T,e.$lf=F,e.$mf=q,e.$nf=Z,e.$of=X,e.$pf=x,e.$qf=W,e.$rf=K,e.$uf=re,e.$vf=ee,e.$wf=ae,e.$xf=J,e.$yf=M,e.$zf=U,e.$Bf=Y,e.$Cf=_,e.$Df=ne,e.$Ef=G,e.$Ff=fe,e.$Hf=de,e.$If=me,e.$Jf=Ee,e.$Kf=Re,e.$Lf=Oe,e.$Mf=Ne,e.$Nf=ue,e.$Of=$e,e.$Pf=De;function L(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const A=/{(\d+)}/g;function O(oe,...ge){return ge.length===0?oe:oe.replace(A,function(be,pe){const ve=parseInt(pe,10);return isNaN(ve)||ve<0||ve>=ge.length?be:ge[ve]})}const R=/{([^}]+)}/g;function P(oe,ge){return Object.keys(ge).length===0?oe:oe.replace(R,(be,pe)=>ge[pe]??be)}function g(oe){return oe.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function C(oe){return oe.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function k(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(oe,ge){let be=0;const pe=ge.charCodeAt(0);for(let ve=oe.length-1;ve>=0;ve--)oe.charCodeAt(ve)===pe&&be++;return be}function f(oe,ge,be="\u2026"){return oe.length<=ge?oe:`${oe.substr(0,ge)}${be}`}function u(oe,ge,be="\u2026"){if(oe.length<=ge)return oe;const pe=Math.ceil(ge/2)-be.length/2,ve=Math.floor(ge/2)-be.length/2;return`${oe.substr(0,pe)}${be}${oe.substr(oe.length-ve)}`}function b(oe,ge=" "){const be=$(oe,ge);return l(be,ge)}function $(oe,ge){if(!oe||!ge)return oe;const be=ge.length;if(be===0||oe.length===0)return oe;let pe=0;for(;oe.indexOf(ge,pe)===pe;)pe=pe+be;return oe.substring(pe)}function l(oe,ge){if(!oe||!ge)return oe;const be=ge.length,pe=oe.length;if(be===0||pe===0)return oe;let ve=pe,ke=-1;for(;ke=oe.lastIndexOf(ge,ve-1),!(ke===-1||ke+be!==ve);){if(ke===0)return"";ve=ke}return oe.substring(0,ve)}function d(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(oe){return oe.replace(/\*/g,"")}function c(oe,ge,be={}){if(!oe)throw new Error("Cannot create regex from empty string");ge||(oe=k(oe)),be.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let pe="";return be.global&&(pe+="g"),be.matchCase||(pe+="i"),be.multiline&&(pe+="m"),be.unicode&&(pe+="u"),new RegExp(oe,pe)}function m(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function i(oe){return oe.split(/\r\n|\r|\n/)}function o(oe){const ge=[],be=oe.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(be.length/2);pe++)ge.push(be[2*pe]+(be[2*pe+1]??""));return ge}function n(oe){for(let ge=0,be=oe.length;ge<be;ge++){const pe=oe.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}function s(oe,ge=0,be=oe.length){for(let pe=ge;pe<be;pe++){const ve=oe.charCodeAt(pe);if(ve!==32&&ve!==9)return oe.substring(ge,pe)}return oe.substring(ge,be)}function t(oe,ge=oe.length-1){for(let be=ge;be>=0;be--){const pe=oe.charCodeAt(be);if(pe!==32&&pe!==9)return be}return-1}function r(oe,ge,be){const pe=[];let ve=0;for(const ke of oe.matchAll(ge)){if(pe.push(oe.slice(ve,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ve=ke.index+ke[0].length,pe.push(be(ke[0],...ke.slice(1),ke.index,oe,ke.groups))}return pe.push(oe.slice(ve)),Promise.all(pe).then(ke=>ke.join(""))}function a(oe,ge){return oe<ge?-1:oe>ge?1:0}function v(oe,ge,be=0,pe=oe.length,ve=0,ke=ge.length){for(;be<pe&&ve<ke;be++,ve++){const He=oe.charCodeAt(be),Be=ge.charCodeAt(ve);if(He<Be)return-1;if(He>Be)return 1}const Ie=pe-be,Ae=ke-ve;return Ie<Ae?-1:Ie>Ae?1:0}function y(oe,ge){return p(oe,ge,0,oe.length,0,ge.length)}function p(oe,ge,be=0,pe=oe.length,ve=0,ke=ge.length){for(;be<pe&&ve<ke;be++,ve++){let He=oe.charCodeAt(be),Be=ge.charCodeAt(ve);if(He===Be)continue;if(He>=128||Be>=128)return v(oe.toLowerCase(),ge.toLowerCase(),be,pe,ve,ke);E(He)&&(He-=32),E(Be)&&(Be-=32);const Fe=He-Be;if(Fe!==0)return Fe}const Ie=pe-be,Ae=ke-ve;return Ie<Ae?-1:Ie>Ae?1:0}function S(oe){return oe>=48&&oe<=57}function E(oe){return oe>=97&&oe<=122}function D(oe){return oe>=65&&oe<=90}function T(oe,ge){return oe.length===ge.length&&p(oe,ge)===0}function F(oe,ge){const be=ge.length;return ge.length>oe.length?!1:p(oe,ge,0,be)===0}function q(oe,ge){const be=Math.min(oe.length,ge.length);let pe;for(pe=0;pe<be;pe++)if(oe.charCodeAt(pe)!==ge.charCodeAt(pe))return pe;return be}function Z(oe,ge){const be=Math.min(oe.length,ge.length);let pe;const ve=oe.length-1,ke=ge.length-1;for(pe=0;pe<be;pe++)if(oe.charCodeAt(ve-pe)!==ge.charCodeAt(ke-pe))return pe;return be}function X(oe){return 55296<=oe&&oe<=56319}function x(oe){return 56320<=oe&&oe<=57343}function W(oe,ge){return(oe-55296<<10)+(ge-56320)+65536}function K(oe,ge,be){const pe=oe.charCodeAt(be);if(X(pe)&&be+1<ge){const ve=oe.charCodeAt(be+1);if(x(ve))return W(pe,ve)}return pe}function V(oe,ge){const be=oe.charCodeAt(ge-1);if(x(be)&&ge>1){const pe=oe.charCodeAt(ge-2);if(X(pe))return W(pe,be)}return be}class H{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=V(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=K(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$sf=H;class te{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new H(ge,be)}nextGraphemeLength(){const ge=Ce.getInstance(),be=this.c,pe=be.offset;let ve=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const ke=be.offset,Ie=ge.getGraphemeBreakType(be.nextCodePoint());if(we(ve,Ie)){be.setOffset(ke);break}ve=Ie}return be.offset-pe}prevGraphemeLength(){const ge=Ce.getInstance(),be=this.c,pe=be.offset;let ve=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const ke=be.offset,Ie=ge.getGraphemeBreakType(be.prevCodePoint());if(we(Ie,ve)){be.setOffset(ke);break}ve=Ie}return pe-be.offset}eol(){return this.c.eol()}}e.$tf=te;function re(oe,ge){return new te(oe,ge).nextGraphemeLength()}function ee(oe,ge){return new te(oe,ge).prevGraphemeLength()}function ae(oe,ge){ge>0&&x(oe.charCodeAt(ge))&&ge--;const be=ge+re(oe,ge);return[be-ee(oe,be),be]}function J(oe){const ge=new te(oe);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}let z;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(oe){return z||(z=j()),z.test(oe)}const B=/^[\t\n\r\x20-\x7E]*$/;function U(oe){return B.test(oe)}e.$Af=/[\u2028\u2029]/;function Y(oe){return e.$Af.test(oe)}function _(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function ne(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function G(oe,ge,be=""){const pe=oe.trimStart();if(pe.length<ge)return pe;const ve=/\b/g;let ke=0;for(;ve.test(pe)&&!(pe.length-ve.lastIndex<ge);)ke=ve.lastIndex,ve.lastIndex+=1;return ke===0?pe:be+pe.substring(ke).trimStart()}const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function fe(oe){return oe&&(oe=oe.replace(ie,"").replace(ce,"")),oe}e.$Gf="\uFEFF";function de(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function me(oe){return de(oe)?oe.substr(1):oe}function Ee(oe,ge){if(!oe||!ge||oe.length<ge.length)return!1;const be=ge.length,pe=oe.toLowerCase();let ve=0,ke=-1;for(;ve<be;){const Ie=pe.indexOf(ge[ve],ke+1);if(Ie<0)return!1;ke=Ie,ve++}return!0}function Re(oe,ge=!1){return oe?(ge&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Oe(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Ne(oe,ge=1){if(ge===0)return"";let be=-1;do be=oe.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?oe:(oe[be-1]==="\r"&&be--,oe.substr(0,be))}function ue(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function $e(oe){return Ce.getInstance().getGraphemeBreakType(oe)}function we(oe,ge){return oe===0?ge!==5&&ge!==7:oe===2&&ge===3?!1:oe===4||oe===2||oe===3||ge===4||ge===2||ge===3?!0:!(oe===8&&(ge===8||ge===9||ge===11||ge===12)||(oe===11||oe===9)&&(ge===9||ge===10)||(oe===12||oe===10)&&ge===10||ge===5||ge===13||ge===7||oe===1||oe===13&&ge===14||oe===6&&ge===6)}var Pe;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this.d,pe=be.length/3;let ve=1;for(;ve<=pe;)if(ge<be[3*ve])ve=2*ve;else if(ge>be[3*ve+1])ve=2*ve+1;else return be[3*ve+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(oe,ge){if(oe===0)return 0;const be=ze(oe,ge);if(be!==void 0)return be;const pe=new H(ge,oe);return pe.prevCodePoint(),pe.offset}function ze(oe,ge){const be=new H(ge,oe);let pe=be.prevCodePoint();for(;Te(pe)||pe===65039||pe===8419;){if(be.offset===0)return;pe=be.prevCodePoint()}if(!ne(pe))return;let ve=be.offset;return ve>0&&be.prevCodePoint()===8205&&(ve=be.offset),ve}function Te(oe){return 127995<=oe&&oe<=127999}var Ue;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.$Qf="\xA0";class qe{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Pe(ge=>{function be(Fe){const Ke=new Map;for(let Ge=0;Ge<Fe.length;Ge+=2)Ke.set(Fe[Ge],Fe[Ge+1]);return Ke}function pe(Fe,Ke){const Ge=new Map(Fe);for(const[_e,tt]of Ke)Ge.set(_e,tt);return Ge}function ve(Fe,Ke){if(!Fe)return Ke;const Ge=new Map;for(const[_e,tt]of Fe)Ke.has(_e)&&Ge.set(_e,tt);return Ge}const ke=this.c.value;let Ie=ge.filter(Fe=>!Fe.startsWith("_")&&Fe in ke);Ie.length===0&&(Ie=["_default"]);let Ae;for(const Fe of Ie){const Ke=be(ke[Fe]);Ae=ve(Ae,Ke)}const He=be(ke._common),Be=pe(He,Ae);return new qe(Be)})}static getInstance(ge){return qe.d.get(Array.from(ge))}static{this.e=new N.$V(()=>Object.keys(qe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return qe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=qe;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(ge){return Le.e().has(ge)}static get codePoints(){return Le.e()}}e.$Sf=Le}),define(le[54],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$$i=void 0,e.$7i=N,e.$8i=L,e.$9i=A,e.$0i=R,e.$_i=b;function N(l){return L(l,0)}function L(l,d){switch(typeof l){case"object":return l===null?A(349,d):Array.isArray(l)?P(l,d):g(l,d);case"string":return R(l,d);case"boolean":return O(l,d);case"number":return A(l,d);case"undefined":return A(937,d);default:return A(617,d)}}function A(l,d){return(d<<5)-d+l|0}function O(l,d){return A(l?433:863,d)}function R(l,d){d=A(149417,d);for(let h=0,c=l.length;h<c;h++)d=A(l.charCodeAt(h),d);return d}function P(l,d){return d=A(104579,d),l.reduce((h,c)=>L(c,h),d)}function g(l,d){return d=A(181387,d),Object.keys(l).sort().reduce((h,c)=>(h=R(c,h),L(l[c],h)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=L(d,this.g),this.g}}e.$$i=C;var k;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function w(l,d,h=32){const c=h-d,m=~((1<<c)-1);return(l<<d|(m&l)>>>c)>>>0}function f(l,d=0,h=l.byteLength,c=0){for(let m=0;m<h;m++)l[d+m]=c}function u(l,d,h="0"){for(;l.length<d;)l=h+l;return l}function b(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(h=>h.toString(16).padStart(2,"0")).join(""):u((l>>>0).toString(16),d/4)}class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const h=d.length;if(h===0)return;const c=this.p;let m=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(I.$of(o))if(n+1<h){const t=d.charCodeAt(n+1);I.$pf(t)?(n++,s=I.$qf(o,t)):s=65533}else{i=o;break}else I.$pf(o)&&(s=65533);if(m=this.w(c,m,s),n++,n<h)o=d.charCodeAt(n);else break}this.r=m,this.u=i}w(d,h,c){return c<128?d[h++]=c:c<2048?(d[h++]=192|(c&1984)>>>6,d[h++]=128|(c&63)>>>0):c<65536?(d[h++]=224|(c&61440)>>>12,d[h++]=128|(c&4032)>>>6,d[h++]=128|(c&63)>>>0):(d[h++]=240|(c&1835008)>>>18,d[h++]=128|(c&258048)>>>12,d[h++]=128|(c&4032)>>>6,d[h++]=128|(c&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=$.g,h=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,w(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this.h,m=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=m&i|~m&o,t=1518500249):a<40?(s=m^i^o,t=1859775393):a<60?(s=m&i|m&o|i&o,t=2400959708):(s=m^i^o,t=3395469782),r=w(c,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=w(m,30),m=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+m&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$aj=$}),define(le[88],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const A="error",O="warning",R="warn",P="info",g="ignore";function C(w){return w?I.$kf(A,w)?L.Error:I.$kf(O,w)||I.$kf(R,w)?L.Warning:I.$kf(P,w)?L.Info:L.Ignore:L.Ignore}L.fromValue=C;function k(w){switch(w){case L.Error:return A;case L.Warning:return O;case L.Info:return P;default:return g}}L.toString=k}(N||(N={})),e.default=N}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class L{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const u=f.charCodeAt(0),b=this.b.charCodeAt(this.c);return u-b}value(){return this.b[this.c]}}e.$ii=L;class A{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,N.$ef)(f,this.b,0,f.length,this.c,this.d):(0,N.$gf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=A;class O{constructor(f=!0,u=!0){this.f=f,this.g=u}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let u=f.length-1;u>=0;u--,this.c--){const b=this.b.charCodeAt(u);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===47||this.f&&u===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,N.$ef)(f,this.b,0,f.length,this.d,this.e):(0,N.$gf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=O;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(f,u){this.f=f,this.g=u,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,N.$ff)(f,this.c.scheme);if(this.d[this.e]===2)return(0,N.$ff)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,N.$df)(f,this.c.query);if(this.d[this.e]===5)return(0,N.$df)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=P;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class k{static forUris(f=()=>!1,u=()=>!1){return new k(new P(f,u))}static forPaths(f=!1){return new k(new O(void 0,!f))}static forStrings(){return new k(new L)}static forConfigKeys(){return new k(new A)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,u){if(u){const b=u.slice(0);(0,I.$Xb)(b);for(const $ of b)this.set($,f)}else{const b=f.slice(0);(0,I.$Xb)(b);for(const $ of b)this.set($[0],$[1])}}set(f,u){const b=this.b.reset(f);let $;this.c||(this.c=new g,this.c.segment=b.value());const l=[];for($=this.c;;){const h=b.cmp($.segment);if(h>0)$.left||($.left=new g,$.left.segment=b.value()),l.push([-1,$]),$=$.left;else if(h<0)$.right||($.right=new g,$.right.segment=b.value()),l.push([1,$]),$=$.right;else if(b.hasNext())b.next(),$.mid||($.mid=new g,$.mid.segment=b.value()),l.push([0,$]),$=$.mid;else break}const d=$.value;$.value=u,$.key=f;for(let h=l.length-1;h>=0;h--){const c=l[h][1];c.updateHeight();const m=c.balanceFactor();if(m<-1||m>1){const i=l[h][0],o=l[h+1][0];if(i===1&&o===1)l[h][1]=c.rotateLeft();else if(i===-1&&o===-1)l[h][1]=c.rotateRight();else if(i===1&&o===-1)c.right=l[h+1][1]=l[h+1][1].rotateRight(),l[h][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=l[h+1][1]=l[h+1][1].rotateLeft(),l[h][1]=c.rotateRight();else throw new Error;if(h>0)switch(l[h-1][0]){case-1:l[h-1][1].left=l[h][1];break;case 1:l[h-1][1].right=l[h][1];break;case 0:l[h-1][1].mid=l[h][1];break}else this.c=l[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const u=this.b.reset(f);let b=this.c;for(;b;){const $=u.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(u.hasNext())u.next(),b=b.mid;else break}return b}has(f){const u=this.d(f);return!(u?.value===void 0&&u?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,u){const b=this.b.reset(f),$=[];let l=this.c;for(;l;){const d=b.cmp(l.segment);if(d>0)$.push([-1,l]),l=l.left;else if(d<0)$.push([1,l]),l=l.right;else if(b.hasNext())b.next(),$.push([0,l]),l=l.mid;else break}if(l){if(u?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:h,value:c,segment:m}=d;this.e(d.key,!1),l.key=h,l.value=c,l.segment=m}}else{const d=l.left??l.right;if($.length>0){const[h,c]=$[$.length-1];switch(h){case-1:c.left=d;break;case 0:c.mid=d;break;case 1:c.right=d;break}}else this.c=d}for(let d=$.length-1;d>=0;d--){const h=$[d][1];h.updateHeight();const c=h.balanceFactor();if(c>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),$[d][1]=h.rotateLeft()):c<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),$[d][1]=h.rotateRight()),d>0)switch($[d-1][0]){case-1:$[d-1][1].left=$[d][1];break;case 1:$[d-1][1].right=$[d][1];break;case 0:$[d-1][1].mid=$[d][1];break}else this.c=$[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const u=this.b.reset(f);let b=this.c,$;for(;b;){const l=u.cmp(b.segment);if(l>0)b=b.left;else if(l<0)b=b.right;else if(u.hasNext())u.next(),$=b.value||$,b=b.mid;else break}return b&&b.value||$}findSuperstr(f){return this.g(f,!1)}g(f,u){const b=this.b.reset(f);let $=this.c;for(;$;){const l=b.cmp($.segment);if(l>0)$=$.left;else if(l<0)$=$.right;else if(b.hasNext())b.next(),$=$.mid;else return $.mid?this.h($.mid):u?$.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[u,b]of this)f(b,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const u=[];return this.j(f,u),u[Symbol.iterator]()}j(f,u){f&&(f.left&&this.j(f.left,u),f.value&&u.push([f.key,f.value]),f.mid&&this.j(f.mid,u),f.right&&this.j(f.right,u))}_isBalanced(){const f=u=>{if(!u)return!0;const b=u.balanceFactor();return b<-1||b>1?!1:f(u.left)&&f(u.right)};return f(this.c)}}e.$mi=k}),define(le[13],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=I,e.$Uf=N,e.$Vf=L,e.$Wf=A,e.$Xf=O,e.$Yf=R,e.$Zf=P,e.$1f=g,e.$2f=C,e.$3f=k,e.$4f=w,e.$5f=f,e.$6f=u,e.$7f=$,e.$8f=l,e.$9f=d,e.$0f=h,e.$$f=c;function I(m){return typeof m=="string"}function N(m){return Array.isArray(m)&&m.every(i=>I(i))}function L(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}function A(m){const i=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof i}function O(m){return typeof m=="number"&&!isNaN(m)}function R(m){return!!m&&typeof m[Symbol.iterator]=="function"}function P(m){return m===!0||m===!1}function g(m){return typeof m>"u"}function C(m){return!k(m)}function k(m){return g(m)||m===null}function w(m,i){if(!m)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f(m){if(k(m))throw new Error("Assertion Failed: argument is undefined or null");return m}function u(...m){const i=[];for(let o=0;o<m.length;o++){const n=m[o];if(k(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const b=Object.prototype.hasOwnProperty;function $(m){if(!L(m))return!1;for(const i in m)if(b.call(m,i))return!1;return!0}function l(m){return typeof m=="function"}function d(...m){return m.length>0&&m.every(l)}function h(m,i){const o=Math.min(m.length,i.length);for(let n=0;n<o;n++)c(m[n],i[n])}function c(m,i){if(I(i)){if(typeof m!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(l(i)){try{if(m instanceof i)return}catch{}if(!k(m)&&m.constructor===i||i.length===1&&i.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=N,e.$Nn=L,e.$On=O,e.$Pn=P,e.$Qn=g,e.$Rn=C,e.$Sn=k,e.$Tn=w,e.$Un=f,e.$Vn=u,e.$Wn=b,e.$Xn=$;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([h,c])=>{d[h]=c&&typeof c=="object"?N(c):c}),d}function L(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const h=d.shift();Object.freeze(h);for(const c in h)if(A.call(h,c)){const m=h[c];typeof m=="object"&&!Object.isFrozen(m)&&!(0,I.$Wf)(m)&&d.push(m)}}return l}const A=Object.prototype.hasOwnProperty;function O(l,d){return R(l,d,new Set)}function R(l,d,h){if((0,I.$3f)(l))return l;const c=d(l);if(typeof c<"u")return c;if(Array.isArray(l)){const m=[];for(const i of l)m.push(R(i,d,h));return m}if((0,I.$Vf)(l)){if(h.has(l))throw new Error("Cannot clone recursive data-structure");h.add(l);const m={};for(const i in l)A.call(l,i)&&(m[i]=R(l[i],d,h));return h.delete(l),m}return l}function P(l,d,h=!0){return(0,I.$Vf)(l)?((0,I.$Vf)(d)&&Object.keys(d).forEach(c=>{c in l?h&&((0,I.$Vf)(l[c])&&(0,I.$Vf)(d[c])?P(l[c],d[c],h):l[c]=d[c]):l[c]=d[c]}),l):d}function g(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let h,c;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(h=0;h<l.length;h++)if(!g(l[h],d[h]))return!1}else{const m=[];for(c in l)m.push(c);m.sort();const i=[];for(c in d)i.push(c);if(i.sort(),!g(m,i))return!1;for(h=0;h<m.length;h++)if(!g(l[m[h]],d[m[h]]))return!1}return!0}function C(l){const d=new Set;return JSON.stringify(l,(h,c)=>{if((0,I.$Vf)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return c})}function k(l,d){const h=Object.create(null);return!l||!d||Object.keys(d).forEach(m=>{const i=l[m],o=d[m];g(i,o)||(h[m]=o)}),h}function w(l,d){const h=d.toLowerCase(),c=Object.keys(l).find(m=>m.toLowerCase()===h);return c?l[c]:l[d]}function f(l,d){const h=Object.create(null);for(const[c,m]of Object.entries(l))d(c,m)&&(h[c]=m);return h}function u(l){let d=[];for(;Object.prototype!==l;)d=d.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return d}function b(l){const d=[];for(const h of u(l))typeof l[h]=="function"&&d.push(h);return d}function $(l,d){const h=m=>function(){const i=Array.prototype.slice.call(arguments,0);return d(m,i)},c={};for(const m of l)c[m]=h(m);return c}}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=void 0,e.$Bg=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return I.test(L)}e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,g="";return g+=O[A[P++]],g+=O[A[P++]],g+=O[A[P++]],g+=O[A[P++]],g+="-",g+=O[A[P++]],g+=O[A[P++]],g+="-",g+=O[A[P++]],g+=O[A[P++]],g+="-",g+=O[A[P++]],g+=O[A[P++]],g+="-",g+=O[A[P++]],g+=O[A[P++]],g+=O[A[P++]],g+=O[A[P++]],g+=O[A[P++]],g+=O[A[P++]],g}}()}),define(le[131],he([0,1,37]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=A;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function A(){const O=(0,I.networkInterfaces)();for(const R in O){const P=O[R];if(P){for(const{mac:g}of P)if(L(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[132],he([0,1,270,14]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SV=void 0;class L extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,P){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,N.$ue)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),P()}_flush(O){this.a&&this.push(this.a),O()}}e.$SV=L}),define(le[133],he([0,1,64]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=void 0,e.$Eg=N,e.$Gg=A;function N(R,P,g,C=1){let k=!1;return new Promise(w=>{const f=setTimeout(()=>{if(!k)return k=!0,w(0)},g);L(R,P,C,u=>{if(!k)return k=!0,clearTimeout(f),w(u)})})}function L(R,P,g,C){if(P===0)return C(0);const k=new I.Socket;k.once("connect",()=>(O(k),L(R+g,P-1,g,C))),k.once("data",()=>{}),k.once("error",w=>(O(k),w.code!=="ECONNREFUSED"?L(R+g,P-1,g,C):C(R))),k.connect(R,"127.0.0.1")}e.$Fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,g,C="127.0.0.1"){let k=!1,w,f=1;const u=I.createServer({pauseOnConnect:!0});function b($,l){k||(k=!0,u.removeAllListeners(),u.close(),w&&clearTimeout(w),l($))}return new Promise($=>{w=setTimeout(()=>{b(0,$)},g),u.on("listening",()=>{b(R,$)}),u.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&f<P?(R++,f++,u.listen(R,C)):b(0,$)}),u.on("close",()=>{b(0,$)}),u.listen(R,C)})}function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9V=I;function I(N){return!!N.parentPort}}),define(le[135],he([11,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=g,e.$Mm=C,e.$Nm=k;const N=60,L=N*60,A=L*24,O=A*7,R=A*30,P=A*365;function g(w,f,u,b){typeof w!="number"&&(w=w.getTime());const $=Math.round((new Date().getTime()-w)/1e3);if($<-30)return(0,I.localize)(0,null,g(new Date().getTime()+$*1e3,!1));if(!b&&$<30)return(0,I.localize)(1,null);let l;return $<N?(l=$,f?l===1?u?(0,I.localize)(2,null,l):(0,I.localize)(3,null,l):u?(0,I.localize)(4,null,l):(0,I.localize)(5,null,l):l===1?u?(0,I.localize)(6,null,l):(0,I.localize)(7,null,l):u?(0,I.localize)(8,null,l):(0,I.localize)(9,null,l)):$<L?(l=Math.floor($/N),f?l===1?u?(0,I.localize)(10,null,l):(0,I.localize)(11,null,l):u?(0,I.localize)(12,null,l):(0,I.localize)(13,null,l):l===1?u?(0,I.localize)(14,null,l):(0,I.localize)(15,null,l):u?(0,I.localize)(16,null,l):(0,I.localize)(17,null,l)):$<A?(l=Math.floor($/L),f?l===1?u?(0,I.localize)(18,null,l):(0,I.localize)(19,null,l):u?(0,I.localize)(20,null,l):(0,I.localize)(21,null,l):l===1?u?(0,I.localize)(22,null,l):(0,I.localize)(23,null,l):u?(0,I.localize)(24,null,l):(0,I.localize)(25,null,l)):$<O?(l=Math.floor($/A),f?l===1?(0,I.localize)(26,null,l):(0,I.localize)(27,null,l):l===1?(0,I.localize)(28,null,l):(0,I.localize)(29,null,l)):$<R?(l=Math.floor($/O),f?l===1?u?(0,I.localize)(30,null,l):(0,I.localize)(31,null,l):u?(0,I.localize)(32,null,l):(0,I.localize)(33,null,l):l===1?u?(0,I.localize)(34,null,l):(0,I.localize)(35,null,l):u?(0,I.localize)(36,null,l):(0,I.localize)(37,null,l)):$<P?(l=Math.floor($/R),f?l===1?u?(0,I.localize)(38,null,l):(0,I.localize)(39,null,l):u?(0,I.localize)(40,null,l):(0,I.localize)(41,null,l):l===1?u?(0,I.localize)(42,null,l):(0,I.localize)(43,null,l):u?(0,I.localize)(44,null,l):(0,I.localize)(45,null,l)):(l=Math.floor($/P),f?l===1?u?(0,I.localize)(46,null,l):(0,I.localize)(47,null,l):u?(0,I.localize)(48,null,l):(0,I.localize)(49,null,l):l===1?u?(0,I.localize)(50,null,l):(0,I.localize)(51,null,l):u?(0,I.localize)(52,null,l):(0,I.localize)(53,null,l))}function C(w,f){const u=Math.abs(w/1e3);return u<1?f?(0,I.localize)(54,null,w):(0,I.localize)(55,null,w):u<N?f?(0,I.localize)(56,null,Math.round(w)/1e3):(0,I.localize)(57,null,Math.round(w)/1e3):u<L?f?(0,I.localize)(58,null,Math.round(w/(1e3*N))):(0,I.localize)(59,null,Math.round(w/(1e3*N))):u<A?f?(0,I.localize)(60,null,Math.round(w/(1e3*L))):(0,I.localize)(61,null,Math.round(w/(1e3*L))):(0,I.localize)(62,null,Math.round(w/(1e3*A)))}function k(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[136],he([11,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,13,136]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=P,e.$5i=g,e.$6i=C;function A(k,w){return w&&(k.stack||k.stacktrace)?L.localize(0,null,R(k),O(k.stack)||O(k.stacktrace)):R(k)}function O(k){return Array.isArray(k)?k.join(`
`):k}function R(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?L.localize(1,null,k.message):k.message||L.localize(2,null)}function P(k=null,w=!1){if(!k)return L.localize(3,null);if(Array.isArray(k)){const f=I.$Hb(k),u=P(f[0],w);return f.length>1?L.localize(4,null,u,f.length):u}if(N.$Tf(k))return k;if(k.detail){const f=k.detail;if(f.error)return A(f.error,w);if(f.exception)return A(f.exception,w)}return k.stack?A(k,w):k.message?k.message:L.localize(5,null)}function g(k){const w=k;return w instanceof Error&&Array.isArray(w.actions)}function C(k,w){let f;return typeof k=="string"?f=new Error(k):f=k,f.actions=w,f}}),define(le[137],he([11,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=N;function N(L){switch(L){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}}),define(le[139],he([11,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=v,e.$J=y,e.$g="en";let N=!1,L=!1,A=!1,O=!1,R=!1,P=!1,g=!1,C=!1,k=!1,w=!1,f,u=e.$g,b=e.$g,$,l;const d=globalThis;let h;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?h=d.vscode.process:typeof process<"u"&&(h=process);const c=typeof h?.versions?.electron=="string",m=c&&h?.type==="renderer";if(typeof h=="object"){N=h.platform==="win32",L=h.platform==="darwin",A=h.platform==="linux",O=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,g=c,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,u=e.$g;const p=h.env.VSCODE_NLS_CONFIG;if(p)try{const S=JSON.parse(p),E=S.availableLanguages["*"];f=S.locale,b=S.osLocale,u=E||e.$g,$=S._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!m?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,P=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,u=f,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;L?n=1:N?n=3:A&&(n=2),e.$i=N,e.$j=L,e.$k=A,e.$l=O,e.$m=R,e.$n=g,e.$o=P,e.$p=P&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=C,e.$s=w,e.$t=k,e.$u=n,e.$v=l,e.$w=u;var s;(function(p){function S(){return e.$w}p.value=S;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}p.isDefaultVariant=E;function D(){return e.$w==="en"}p.isDefault=D})(s||(e.Language=s={})),e.$x=f,e.$y=b,e.$z=$,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const p=[];d.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let D=0,T=p.length;D<T;D++){const F=p[D];if(F.id===E.data.vscodeScheduleAsyncWork){p.splice(D,1),F.callback();return}}});let S=0;return E=>{const D=++S;p.push({id:D,callback:E}),d.postMessage({vscodeScheduleAsyncWork:D},"*")}}return p=>setTimeout(p)})();var t;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||C?2:N?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,r=new Uint16Array(p.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function y(p){return parseFloat(p)>=20}}),define(le[36],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(le[140],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yV=O;var N;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(N||(N={}));const L="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function O(){const R=I.env[L];if(R){const g=R.split(":").map(C=>C.trim()).filter(C=>C.length>0);for(const C of g)switch(C){case"Unity":{const k=I.env.DESKTOP_SESSION;return k&&k.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const k=I.env[A];return k==="5"?N.KDE5:k==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const P=I.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return A in I.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?N.GNOME:"KDE_FULL_SESSION"in I.env?A in I.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(le[15],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,L=97,A=90,O=122,R=46,P=47,g=92,C=58,k=63;class w extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new w(o,"Object",i)}function u(i,o){if(typeof i!="string")throw new w(o,"string",i)}const b=I.$dc==="win32";function $(i){return i===P||i===g}function l(i){return i===P}function d(i){return i>=N&&i<=A||i>=L&&i<=O}function h(i,o,n,s){let t="",r=0,a=-1,v=0,y=0;for(let p=0;p<=i.length;++p){if(p<i.length)y=i.charCodeAt(p);else{if(s(y))break;y=P}if(s(y)){if(!(a===p-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const S=t.lastIndexOf(n);S===-1?(t="",r=0):(t=t.slice(0,S),r=t.length-1-t.lastIndexOf(n)),a=p,v=0;continue}else if(t.length!==0){t="",r=0,a=p,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,p)}`:t=i.slice(a+1,p),r=p-a-1;a=p,v=0}else y===R&&v!==-1?++v:v=-1}return t}function c(i,o){f(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$fc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],u(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,y="",p=!1;const S=r.charCodeAt(0);if(a===1)$(S)&&(v=1,p=!0);else if($(S))if(p=!0,$(r.charCodeAt(1))){let E=2,D=E;for(;E<a&&!$(r.charCodeAt(E));)E++;if(E<a&&E!==D){const T=r.slice(D,E);for(D=E;E<a&&$(r.charCodeAt(E));)E++;if(E<a&&E!==D){for(D=E;E<a&&!$(r.charCodeAt(E));)E++;(E===a||E!==D)&&(y=`\\\\${T}\\${r.slice(D,E)}`,v=E)}}}else v=1;else d(S)&&r.charCodeAt(1)===C&&(y=r.slice(0,2),v=2,a>2&&$(r.charCodeAt(2))&&(p=!0,v=3));if(y.length>0)if(o.length>0){if(y.toLowerCase()!==o.toLowerCase())continue}else o=y;if(s){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,s=p,p&&o.length>0)break}return n=h(n,!s,"\\",$),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){u(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return l(r)?"\\":i;if($(r))if(t=!0,$(i.charCodeAt(1))){let v=2,y=v;for(;v<o&&!$(i.charCodeAt(v));)v++;if(v<o&&v!==y){const p=i.slice(y,v);for(y=v;v<o&&$(i.charCodeAt(v));)v++;if(v<o&&v!==y){for(y=v;v<o&&!$(i.charCodeAt(v));)v++;if(v===o)return`\\\\${p}\\${i.slice(y)}\\`;v!==y&&(s=`\\\\${p}\\${i.slice(y,v)}`,n=v)}}}else n=1;else d(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&$(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?h(i.slice(n),!t,"\\",$):"";return a.length===0&&!t&&(a="."),a.length>0&&$(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){u(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return $(n)||o>2&&d(n)&&i.charCodeAt(1)===C&&$(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];u(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&$(n.charCodeAt(0))){++t;const r=n.length;r>1&&$(n.charCodeAt(1))&&(++t,r>2&&($(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&$(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o)return"";const n=e.$fc.resolve(i),s=e.$fc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let y=o.length;for(;y-1>v&&o.charCodeAt(y-1)===g;)y--;const p=y-v,S=a<p?a:p;let E=-1,D=0;for(;D<S;D++){const F=i.charCodeAt(t+D);if(F!==o.charCodeAt(v+D))break;F===g&&(E=D)}if(D!==S){if(E===-1)return s}else{if(p>S){if(o.charCodeAt(v+D)===g)return s.slice(v+D+1);if(D===2)return s.slice(v+D)}a>S&&(i.charCodeAt(t+D)===g?E=D:D===2&&(E=3)),E===-1&&(E=0)}let T="";for(D=t+E+1;D<=r;++D)(D===r||i.charCodeAt(D)===g)&&(T+=T.length===0?"..":"\\..");return v+=E,T.length>0?`${T}${s.slice(v,y)}`:(s.charCodeAt(v)===g&&++v,s.slice(v,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==k&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){u(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return $(t)?i:".";if($(t)){if(n=s=1,$(i.charCodeAt(1))){let v=2,y=v;for(;v<o&&!$(i.charCodeAt(v));)v++;if(v<o&&v!==y){for(y=v;v<o&&$(i.charCodeAt(v));)v++;if(v<o&&v!==y){for(y=v;v<o&&!$(i.charCodeAt(v));)v++;if(v===o)return i;v!==y&&(n=s=v+1)}}}}else d(t)&&i.charCodeAt(1)===C&&(n=o>2&&$(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let v=o-1;v>=s;--v)if($(i.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=n;--r){const y=i.charCodeAt(r);if($(y)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(y===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if($(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){u(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&d(i.charCodeAt(0))&&(o=s=2);for(let v=i.length-1;v>=o;--v){const y=i.charCodeAt(v);if($(y)){if(!r){s=v+1;break}continue}t===-1&&(r=!1,t=v+1),y===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return $(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if($(t)){if(s=1,$(i.charCodeAt(1))){let E=2,D=E;for(;E<n&&!$(i.charCodeAt(E));)E++;if(E<n&&E!==D){for(D=E;E<n&&$(i.charCodeAt(E));)E++;if(E<n&&E!==D){for(D=E;E<n&&!$(i.charCodeAt(E));)E++;E===n?s=E:E!==D&&(s=E+1)}}}}else if(d(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,$(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,v=-1,y=!0,p=i.length-1,S=0;for(;p>=s;--p){if(t=i.charCodeAt(p),$(t)){if(!y){a=p+1;break}continue}v===-1&&(y=!1,v=p+1),t===R?r===-1?r=p:S!==1&&(S=1):r!==-1&&(S=-1)}return v!==-1&&(r===-1||S===0||S===1&&r===v-1&&r===a+1?o.base=o.name=i.slice(a,v):(o.name=i.slice(a,r),o.base=i.slice(a,v),o.ext=i.slice(r,v))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(b){const i=/\\/g;return()=>{const o=I.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:m();u(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===P)}return o=h(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P,n=i.charCodeAt(i.length-1)===P;return i=h(i,!o,"/",l),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];u(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,v=t<a?t:a;let y=-1,p=0;for(;p<v;p++){const E=i.charCodeAt(n+p);if(E!==o.charCodeAt(r+p))break;E===P&&(y=p)}if(p===v)if(a>v){if(o.charCodeAt(r+p)===P)return o.slice(r+p+1);if(p===0)return o.slice(r+p)}else t>v&&(i.charCodeAt(n+p)===P?y=p:p===0&&(y=0));let S="";for(p=n+y+1;p<=s;++p)(p===s||i.charCodeAt(p)===P)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(r+y)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===P){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=0;--r){const y=i.charCodeAt(r);if(y===P){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(y===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===P){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){u(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const v=i.charCodeAt(a);if(v===P){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===P;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,v=!0,y=i.length-1,p=0;for(;y>=s;--y){const S=i.charCodeAt(y);if(S===P){if(!v){r=y+1;break}continue}a===-1&&(v=!1,a=y+1),S===R?t===-1?t=y:p!==1&&(p=1):t!==-1&&(p=-1)}if(a!==-1){const S=r===0&&n?1:r;t===-1||p===0||p===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(S,a):(o.name=i.slice(S,t),o.base=i.slice(S,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=b?e.$fc.normalize:e.$gc.normalize,e.$ic=b?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=b?e.$fc.join:e.$gc.join,e.$kc=b?e.$fc.resolve:e.$gc.resolve,e.$lc=b?e.$fc.relative:e.$gc.relative,e.$mc=b?e.$fc.dirname:e.$gc.dirname,e.$nc=b?e.$fc.basename:e.$gc.basename,e.$oc=b?e.$fc.extname:e.$gc.extname,e.$pc=b?e.$fc.format:e.$gc.format,e.$qc=b?e.$fc.parse:e.$gc.parse,e.$rc=b?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=b?e.$fc.sep:e.$gc.sep,e.$tc=b?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,15,5,27,13]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=O,e.$ag=R,e.$bg=P,e.$cg=g,e.$dg=C,e.$eg=u,e.$fg=b,e.$gg=$,e.$hg=l,e.$ig=d,e.$jg=h,e.$kg=c,e.$lg=m,e.$mg=i,e.$ng=o,e.$og=t;function O(r){return r===47||r===92}function R(r){return r.replace(/[\\/]/g,I.$gc.sep)}function P(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function g(r,a=I.$gc.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(O(y)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let S=3;const E=S;for(;S<v&&!O(r.charCodeAt(S));S++);if(E!==S&&!O(r.charCodeAt(S+1))){for(S+=1;S<v;S++)if(O(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(l(y)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<v;p++)if(O(r.charCodeAt(p)))return r.slice(0,p+1)}return""}function C(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const y=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(y===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}const k=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,a=N.$i){const v=a?k:w;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&f.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function b(r,a,v){const y=r===a;return!v||y?y:!r||!a?!1:(0,L.$kf)(r,a)}function $(r,a,v,y=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,L.$lf)(r,a))return!1;if(a.length===r.length)return!0;let S=a.length;return a.charAt(a.length-1)===y&&S--,r.charAt(S)===y}return a.charAt(a.length-1)!==y&&(a+=y),r.indexOf(a)===0}function l(r){return r>=65&&r<=90||r>=97&&r<=122}function d(r,a){return N.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$ic)(r)||(r=(0,I.$jc)(a,r)),r=(0,I.$hc)(r),N.$i?(r=(0,L.$5e)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,L.$5e)(r,I.sep),r||(r=I.sep)),r}function h(r){const a=(0,I.$hc)(r);return N.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$gc.sep}function c(r,a=N.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function m(r,a=N.$i){return c(r,a)?r[0]:void 0}function i(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let v,y,p;for(const S of a){const E=Number(S);(0,A.$Xf)(E)?y===void 0?y=E:p===void 0&&(p=E):v=v?[v,S].join(":"):S}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:p!==void 0?p:y!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let y="";for(let S=0;S<v;S++){let E;S===0&&N.$i&&!a&&(v===3||v===4)?E=s:E=n,y+=E.charAt(Math.floor(Math.random()*E.length))}let p;return a?p=`${a}-${y}`:p=y,r?(0,I.$jc)(r,p):p}}),define(le[141],he([0,1,15]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0,e.$ws=A,e.$xs=O,e.$ys=R,e.$zs=g,e.$vs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const k=(0,I.$oc)(C),w=N[k.toLowerCase()];return w!==void 0?w:O(C)}function O(C){const k=(0,I.$oc)(C);return L[k.toLowerCase()]}function R(C){for(const k in L)if(L[k]===C)return k}const P=/^(.+)\/(.+?)(;.+)?$/;function g(C,k){const w=P.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:k?void 0:C}}),define(le[89],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$9l=A,e.$0l=O;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(R,...P){const g=P.reduce((w,f)=>(w[f]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!g[w]).forEach(w=>{for(let f=0;f<C.length;f++)if(w.search(C[f])!==-1){delete R[w];break}})}function O(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}}),define(le[10],he([0,1,15,5]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=u,e.$wc=c;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const C="",k="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,y,p=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=P(t,p),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=y||C,R(this,p))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:y,fragment:p}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),y===void 0?y=this.query:y===null&&(y=C),p===void 0?p=this.fragment:p===null&&(p=C),r===this.scheme&&a===this.authority&&v===this.path&&y===this.query&&p===this.fragment?this:new $(r,a,v,y,p)}static parse(t,r=!1){const a=w.exec(t);return a?new $(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new $(C,C,C,C,C)}static file(t){let r=C;if(N.$i&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const a=t.indexOf(k,2);a===-1?(r=t.substring(2),t=k):(r=t.substring(2,a),t=t.substring(a)||k)}return new $("file",r,t,C,C)}static from(t,r){return new $(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=f.file(I.$fc.join(c(t,!0),...r)).path:a=I.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return m(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const r=new $(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=f;function u(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const b=N.$i?1:void 0;class $ extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(s,t,r){let a,v=-1;for(let y=0;y<s.length;y++){const p=s.charCodeAt(y);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||t&&p===47||r&&p===91||r&&p===93||r&&p===58)v!==-1&&(a+=encodeURIComponent(s.substring(v,y)),v=-1),a!==void 0&&(a+=s.charAt(y));else{a===void 0&&(a=s.substr(0,y));const S=l[p];S!==void 0?(v!==-1&&(a+=encodeURIComponent(s.substring(v,y)),v=-1),a+=S):v===-1&&(v=y)}}return v!==-1&&(a+=encodeURIComponent(s.substring(v))),a!==void 0?a:s}function h(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=l[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}function m(s,t){const r=t?h:d;let a="",{scheme:v,authority:y,path:p,query:S,fragment:E}=s;if(v&&(a+=v,a+=":"),(y||v==="file")&&(a+=k,a+=k),y){let D=y.indexOf("@");if(D!==-1){const T=y.substr(0,D);y=y.substr(D+1),D=T.lastIndexOf(":"),D===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,D),!1,!1),a+=":",a+=r(T.substr(D+1),!1,!0)),a+="@"}y=y.toLowerCase(),D=y.lastIndexOf(":"),D===-1?a+=r(y,!1,!0):(a+=r(y.substr(0,D),!1,!0),a+=y.substr(D))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const D=p.charCodeAt(1);D>=65&&D<=90&&(p=`/${String.fromCharCode(D+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const D=p.charCodeAt(0);D>=65&&D<=90&&(p=`${String.fromCharCode(D+32)}:${p.substr(2)}`)}a+=r(p,!0,!1)}return S&&(a+="?",a+=r(S,!1,!1)),E&&(a+="#",a+=t?E:d(E,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],he([0,1,10]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=N,e.$Dq=L,e.$Eq=A,e.log=R;function N(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function L(g){const C=[];let k;try{const w=JSON.parse(g.arguments),f=w[w.length-1];f&&f.__$stack&&(w.pop(),k=f.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:k}}function A(g){if(typeof g!="string")return A(L(g).stack);const C=g;if(C){const k=O(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(w&&w.length===4)return{uri:I.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function O(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:k,stack:w}=L(g),f=typeof k[0]=="string"&&k.length===1;let u=O(w);u&&(u=`(${u.trim()})`);let b=[];if(typeof k[0]=="string"?u&&f?b=[`%c[${C}] %c${k[0]} %c${u}`,P("blue"),P(""),P("grey")]:b=[`%c[${C}] %c${k[0]}`,P("blue"),P(""),...k.slice(1)]:b=[`%c[${C}]%`,P("blue"),...k],u&&!f&&b.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}function P(g){return`color: ${g}`}}),define(le[66],he([0,1,14,10]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=L,e.$Oh=A,e.$Ph=R;function L(P){return JSON.stringify(P,O)}function A(P){let g=JSON.parse(P);return g=R(g),g}function O(P,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(P,g=0){if(!P||g>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return N.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof I.$te||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=R(P[C],g+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=R(P[C],g+1))}return P}}),define(le[23],he([0,1,7,5,27,10,15]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$tg=e.$sg=e.$rg=e.Schemas=void 0,e.$pg=P,e.$qg=g,e.$ug=k;var R;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.codeSetting="code-setting"})(R||(e.Schemas=R={}));function P(u,b){return A.URI.isUri(u)?(0,L.$kf)(u.scheme,b):(0,L.$lf)(u,b+":")}function g(u,...b){return b.some($=>P(u,$))}e.$rg="vscode-tkn",e.$sg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,$){this.f=k(b,$)}getServerRootPath(){return this.f}get g(){return O.$gc.join(this.f,R.vscodeRemoteResource)}set(b,$,l){this.a[b]=$,this.b[b]=l}setConnectionToken(b,$){this.c[b]=$}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(m){return I.$1(m),b}const $=b.authority;let l=this.a[$];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const d=this.b[$],h=this.c[$];let c=`path=${encodeURIComponent(b.path)}`;return typeof h=="string"&&(c+=`&${e.$sg}=${encodeURIComponent(h)}`),A.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${d}`,path:this.g,query:c})}}e.$tg=new C;function k(u,b){return O.$gc.join(b??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class w{static{this.a=e.$zg}asBrowserUri(b){const $=this.b(b,se);return this.uriToBrowserUri($)}uriToBrowserUri(b){return b.scheme===R.vscodeRemote?e.$tg.rewrite(b):b.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${w.a}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||w.a,query:null,fragment:null}):b}asFileUri(b){const $=this.b(b,se);return this.uriToFileUri($)}uriToFileUri(b){return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==w.a?b.authority:null,query:null,fragment:null}):b}b(b,$){return A.URI.isUri(b)?b:A.URI.parse($.toUrl(b))}}e.$Ag=new w;var f;(function(u){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(b.get("3"));const $="vscode-coi";function l(h){let c;typeof h=="string"?c=new URL(h).searchParams:h instanceof URL?c=h.searchParams:A.URI.isUri(h)&&(c=new URL(h.toString(!0)).searchParams);const m=c?.get($);if(m)return b.get(m)}u.getHeadersFromQuery=l;function d(h,c,m){if(!globalThis.crossOriginIsolated)return;const i=c&&m?"3":m?"2":"1";h instanceof URLSearchParams?h.set($,i):h[$]=i}u.addSearchParam=d})(f||(e.COI=f={}))}),define(le[143],he([0,1,124,23,5,10]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=C;class O{constructor(w,f,u){this.id=w,this.dependencies=f,this.callback=u}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,f,u)=>{typeof w!="string"&&(u=f,f=w,w=null),(typeof f!="object"||!Array.isArray(f))&&(u=f,f=null),this.c.push(new O(w,f,u))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const f=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!f)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(w){return new Promise((f,u)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const $=()=>{b.removeEventListener("load",l),b.removeEventListener("error",d)},l=h=>{$(),f(this.c.pop())},d=h=>{$(),u(h)};b.addEventListener("load",l),b.addEventListener("error",d),this.f&&(w=this.f.createScriptURL(w)),b.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(w){return new Promise((f,u)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),f(this.c.pop())}catch(b){u(b)}})}async j(w){try{const f=globalThis._VSCODE_NODE_MODULES.fs,u=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(w).fsPath,l=f.readFileSync($).toString(),d=b.wrap(l.replace(/^#!.*/,""));return new u.Script(d).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const P=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(k,w,f){if(I.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[k]&&(k=g[k]);const u=`${k}/${w}`;if(P.has(u))return P.get(u);let b;if(/^\w[\w\d+.-]*:\/\//.test(u))b=u;else{const h=`${f&&!L.$o?N.$xg:N.$wg}/${u}`;b=N.$Ag.asBrowserUri(h).toString(!0)}const $=R.INSTANCE.load(b);return P.set(u,$),$}else return await new Promise((u,b)=>{se([k],u,b)})}}),define(le[20],he([0,1,49,23,15,5,27,10]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=void 0,e.$Hg=P,e.$3g=C,e.$4g=w;function P(f){return(0,R.$wc)(f,!0)}class g{constructor(u){this.a=u}compare(u,b,$=!1){return u===b?0:(0,O.$df)(this.getComparisonKey(u,$),this.getComparisonKey(b,$))}isEqual(u,b,$=!1){return u===b?!0:!u||!b?!1:this.getComparisonKey(u,$)===this.getComparisonKey(b,$)}getComparisonKey(u,b=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,b,$=!1){if(u.scheme===b.scheme){if(u.scheme===N.Schemas.file)return I.$gg(P(u),P(b),this.a(u))&&u.query===b.query&&($||u.fragment===b.fragment);if((0,e.$Yg)(u.authority,b.authority))return I.$gg(u.path,b.path,this.a(u),"/")&&u.query===b.query&&($||u.fragment===b.fragment)}return!1}joinPath(u,...b){return R.URI.joinPath(u,...b)}basenameOrAuthority(u){return(0,e.$Qg)(u)||u.authority}basename(u){return L.$gc.basename(u.path)}extname(u){return L.$gc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let b;return u.scheme===N.Schemas.file?b=R.URI.file(L.$mc(P(u))).path:(b=L.$gc.dirname(u.path),u.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),b="/")),u.with({path:b})}normalizePath(u){if(!u.path.length)return u;let b;return u.scheme===N.Schemas.file?b=R.URI.file(L.$hc(P(u))).path:b=L.$gc.normalize(u.path),u.with({path:b})}relativePath(u,b){if(u.scheme!==b.scheme||!(0,e.$Yg)(u.authority,b.authority))return;if(u.scheme===N.Schemas.file){const d=L.$lc(P(u),P(b));return A.$i?I.$ag(d):d}let $=u.path||"/";const l=b.path||"/";if(this.a(u)){let d=0;for(const h=Math.min($.length,l.length);d<h&&!($.charCodeAt(d)!==l.charCodeAt(d)&&$.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);$=l.substr(0,d)+$.substr(d)}return L.$gc.relative($,l)}resolvePath(u,b){if(u.scheme===N.Schemas.file){const $=R.URI.file(L.$kc(P(u),b));return u.with({authority:$.authority,path:$.path})}return b=I.$bg(b),u.with({path:L.$gc.resolve(u.path,b)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,b){return u===b||u!==void 0&&b!==void 0&&(0,O.$kf)(u,b)}hasTrailingPathSeparator(u,b=L.sep){if(u.scheme===N.Schemas.file){const $=P(u);return $.length>I.$cg($).length&&$[$.length-1]===b}else{const $=u.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,b=L.sep){return(0,e.$Zg)(u,b)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,b=L.sep){let $=!1;if(u.scheme===N.Schemas.file){const l=P(u);$=l!==void 0&&l.length===I.$cg(l).length&&l[l.length-1]===b}else{b="/";const l=u.path;$=l.length===1&&l.charCodeAt(l.length-1)===47}return!$&&!(0,e.$Zg)(u,b)?u.with({path:u.path+"/"}):u}}e.$Ig=g,e.$Jg=new g(()=>!1),e.$Kg=new g(f=>f.scheme===N.Schemas.file?!A.$k:!0),e.$Lg=new g(f=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function C(f,u){const b=[];for(let $=0;$<f.length;$++){const l=u(f[$]);f.some((d,h)=>h===$?!1:(0,e.$Ng)(l,u(d)))||b.push(f[$])}return b}var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function u(b){const $=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(h=>{const[c,m]=h.split(":");c&&m&&$.set(c,m)});const d=b.path.substring(0,b.path.indexOf(";"));return d&&$.set(f.META_DATA_MIME,d),$}f.parseMetaData=u})(k||(e.DataUri=k={}));function w(f,u,b){if(u){let $=f.path;return $&&$[0]!==L.$gc.sep&&($=L.$gc.sep+$),f.with({scheme:b,authority:u,path:$})}return f.with({scheme:b})}}),define(le[6],he([0,1,26,7,3,2,20,5,130,53]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$5g=C,e.$6g=k,e.$7g=w,e.$8g=f,e.$9g=u,e.$0g=b,e.$$g=$,e.$_g=l,e.$hh=r,e.$ih=a,e.$jh=v,e.$kh=y,e.$lh=p,e.$Ah=H,e.$Ih=Y;function C(ne){return!!ne&&typeof ne.then=="function"}function k(ne){const G=new I.$de,ie=ne(G.token),ce=new Promise((fe,de)=>{const me=G.token.onCancellationRequested(()=>{me.dispose(),de(new N.$5)});Promise.resolve(ie).then(Ee=>{me.dispose(),G.dispose(),fe(Ee)},Ee=>{me.dispose(),G.dispose(),de(Ee)})});return new class{cancel(){G.cancel(),G.dispose()}then(fe,de){return ce.then(fe,de)}catch(fe){return this.then(void 0,fe)}finally(fe){return ce.finally(fe)}}}function w(ne,G,ie){return new Promise((ce,fe)=>{const de=G.onCancellationRequested(()=>{de.dispose(),ce(ie)});ne.then(ce,fe).finally(()=>de.dispose())})}function f(ne,G){return new Promise((ie,ce)=>{const fe=G.onCancellationRequested(()=>{fe.dispose(),ce(new N.$5)});ne.then(ie,ce).finally(()=>fe.dispose())})}async function u(ne){let G=-1;const ie=ne.map((ce,fe)=>ce.then(de=>(G=fe,de)));try{return await Promise.race(ie)}finally{ne.forEach((ce,fe)=>{fe!==G&&ce.cancel()})}}function b(ne,G,ie){let ce;const fe=setTimeout(()=>{ce?.(void 0),ie?.()},G);return Promise.race([ne.finally(()=>clearTimeout(fe)),new Promise(de=>ce=de)])}function $(ne){return new Promise((G,ie)=>{const ce=ne();C(ce)?ce.then(G,ie):G(ce)})}function l(){let ne,G;return{promise:new Promise((ce,fe)=>{ne=ce,G=fe}),resolve:ne,reject:G}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.b.then(ie,ce)})}return this.a=G(),new Promise((ie,ce)=>{this.a.then(fe=>{this.a=null,ie(fe)},fe=>{this.a=null,ce(fe)})})}dispose(){this.f=!0}}e.$ah=d;class h{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$bh=h;class c{constructor(){this.a=new Map}queue(G,ie){const fe=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(G)===fe&&this.a.delete(G)});return this.a.set(G,fe),fe}}e.$ch=c;const m=(ne,G)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,G()},ne);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},i=ne=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ne())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class o{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ie=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((fe,de)=>{this.d=fe,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ie===P.$3d?i(ce):m(ie,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=o;class n{constructor(G){this.a=new o(G),this.b=new d}trigger(G,ie){return this.a.trigger(()=>this.b.queue(G),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=n;class s{constructor(){this.a=!1,this.b=new Promise((G,ie)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=s;class t extends s{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$gh=t;function r(ne,G){return G?new Promise((ie,ce)=>{const fe=setTimeout(()=>{de.dispose(),ie()},ne),de=G.onCancellationRequested(()=>{clearTimeout(fe),de.dispose(),ce(new N.$5)})}):k(ie=>r(ne,ie))}function a(ne,G=0,ie){const ce=setTimeout(()=>{ne(),ie&&fe.dispose()},G),fe=(0,A.$Rc)(()=>{clearTimeout(ce),ie?.deleteAndLeak(fe)});return ie?.add(fe),fe}function v(ne){const G=[];let ie=0;const ce=ne.length;function fe(){return ie<ce?ne[ie++]():null}function de(me){me!=null&&G.push(me);const Ee=fe();return Ee?Ee.then(de):Promise.resolve(G)}return Promise.resolve(null).then(de)}function y(ne,G=ce=>!!ce,ie=null){let ce=0;const fe=ne.length,de=()=>{if(ce>=fe)return Promise.resolve(ie);const me=ne[ce++];return Promise.resolve(me()).then(Re=>G(Re)?Promise.resolve(Re):de())};return de()}function p(ne,G=ce=>!!ce,ie=null){if(ne.length===0)return Promise.resolve(ie);let ce=ne.length;const fe=()=>{ce=-1;for(const de of ne)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of ne)Ee.then(Re=>{--ce>=0&&G(Re)?(fe(),de(Re)):ce===0&&de(ie)}).catch(Re=>{--ce>=0&&(fe(),me(Re))})})}class S{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new L.$6d}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,ce)=>{this.g.push({factory:G,c:ie,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ie=G.factory();ie.then(G.c,G.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=S;class E extends S{constructor(){super(1)}}e.$nh=E;class D{constructor(){this.a=new te,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$oh=D;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new ae;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ie=O.$Jg){const ce=ie.getComparisonKey(G);return this.a.get(ce)?.size??0}queueFor(G,ie,ce=O.$Jg){const fe=ce.getComparisonKey(G);let de=this.a.get(fe);if(!de){de=new E;const me=this.f++,Ee=L.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(me,Ee),this.a.set(fe,de)}return de.queue(ie)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=T;class F{constructor(G,ie){this.a=-1,typeof G=="function"&&typeof ie=="number"&&this.setIfNotSet(G,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ie)}setIfNotSet(G,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ie))}}e.$qh=F;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ie,ce=globalThis){this.cancel();const fe=ce.setInterval(()=>{G()},ie);this.d=(0,A.$Rc)(()=>{ce.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$rh=q;class Z{constructor(G,ie){this.b=-1,this.a=G,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=Z;class X{constructor(G,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=G,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=X;class x extends Z{constructor(G,ie){super(G,ie),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$uh=x;class W extends A.$Tc{constructor(G,ie){super(),this.g=G,this.h=ie,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of G)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(ne,G)=>{(0,R.$B)(()=>{if(ie)return;const ce=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$xh=(ne,G,ie)=>{const ce=ne.requestIdleCallback(G,typeof ie=="number"?{timeout:ie}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ne.cancelIdleCallback(ce))}}},e.$wh=ne=>(0,e.$xh)(globalThis,ne)}();class K{constructor(G,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$xh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=K;class V extends K{constructor(G){super(globalThis,G)}}e.$zh=V;async function H(ne,G,ie){let ce;for(let fe=0;fe<ie;fe++)try{return await ne()}catch(de){ce=de,await r(G)}throw ce}class te{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ie,ce){return this.a={taskId:G,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.d(G),()=>this.d(G)),ie}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ie,resolve:ce,reject:fe}=l();this.b={run:G,promise:ie,promiseResolve:ce,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=te;class re{constructor(G,ie=()=>Date.now()){this.d=G,this.f=ie,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Ch=re;var ee;(function(ne){ne[ne.Resolved=0]="Resolved",ne[ne.Rejected=1]="Rejected"})(ee||(ee={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ie)=>{this.a=G,this.b=ie})}complete(G){return new Promise(ie=>{this.a(G),this.d={outcome:0,value:G},ie()})}error(G){return new Promise(ie=>{this.b(G),this.d={outcome:1,value:G},ie()})}cancel(){return this.error(new N.$5)}}e.$Dh=ae;var J;(function(ne){async function G(ce){let fe;const de=await Promise.all(ce.map(me=>me.then(Ee=>Ee,Ee=>{fe||(fe=Ee)})));if(typeof fe<"u")throw fe;return de}ne.settled=G;function ie(ce){return new Promise(async(fe,de)=>{try{await ce(fe,de)}catch(me){de(me)}})}ne.withAsyncBody=ie})(J||(e.Promises=J={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=z;class j{constructor(G){this.b=G,this.a=new g.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=j;var M;(function(ne){ne[ne.Initial=0]="Initial",ne[ne.DoneOK=1]="DoneOK",ne[ne.DoneError=2]="DoneError"})(M||(M={}));class B{static fromArray(G){return new B(ie=>{ie.emitMany(G)})}static fromPromise(G){return new B(async ie=>{ie.emitMany(await G)})}static fromPromises(G){return new B(async ie=>{await Promise.all(G.map(async ce=>ie.emitOne(await ce)))})}static merge(G){return new B(async ie=>{await Promise.all(G.map(async ce=>{for await(const fe of ce)ie.emitOne(fe)}))})}static{this.EMPTY=B.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new L.$6d,queueMicrotask(async()=>{const ie={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(G(ie)),this.j()}catch(ce){this.k(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(G,ie){return new B(async ce=>{for await(const fe of G)ce.emitOne(ie(fe))})}map(G){return B.map(this,G)}static filter(G,ie){return new B(async ce=>{for await(const fe of G)ie(fe)&&ce.emitOne(fe)})}filter(G){return B.filter(this,G)}static coalesce(G){return B.filter(G,ie=>!!ie)}coalesce(){return B.coalesce(this)}static async toPromise(G){const ie=[];for await(const ce of G)ie.push(ce);return ie}toPromise(){return B.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$Gh=B;class U extends B{constructor(G,ie){super(ie),this.l=G}cancel(){this.l.cancel()}}e.$Hh=U;function Y(ne){const G=new I.$de,ie=ne(G.token);return new U(G,async ce=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),G.dispose(),ce.reject(new N.$5)});try{for await(const de of ie){if(G.token.isCancellationRequested)return;ce.emitOne(de)}fe.dispose(),G.dispose()}catch(de){fe.dispose(),G.dispose(),ce.reject(de)}})}class _{constructor(){this.a=new ae,this.b=new B(ce=>{if(G){ce.reject(G);return}return ie&&ce.emitMany(ie),this.d=fe=>ce.reject(fe),this.f=fe=>ce.emitOne(fe),this.a.p});let G,ie;this.f=ce=>{ie||(ie=[]),ie.push(ce)},this.d=ce=>{G||(G=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Jh=_}),define(le[90],he([0,1,17,6,49,35,15,5,27]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=g,e.$$j=u,e.$_j=E,e.$ak=D,e.$bk=T,e.$ck=F,e.$dk=q,e.$ek=W;function g(){return Object.create(null)}e.$9j="**",e.$0j="/";const C="[/\\\\]",k="[^/\\\\]",w=/\//g;function f(K,V){switch(K){case 0:return"";case 1:return`${k}*?`;default:return`(?:${C}|${k}+${C}${V?`|${C}${k}+`:""})*?`}}function u(K,V){if(!K)return[];const H=[];let te=!1,re=!1,ee="";for(const ae of K){switch(ae){case V:if(!te&&!re){H.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":re=!0;break;case"]":re=!1;break}ee+=ae}return ee&&H.push(ee),H}function b(K){if(!K)return"";let V="";const H=u(K,e.$0j);if(H.every(te=>te===e.$9j))V=".*";else{let te=!1;H.forEach((re,ee)=>{if(re===e.$9j){if(te)return;V+=f(2,ee===H.length-1)}else{let ae=!1,J="",z=!1,j="";for(const M of re){if(M!=="}"&&ae){J+=M;continue}if(z&&(M!=="]"||!j)){let B;M==="-"?B=M:(M==="^"||M==="!")&&!j?B="^":M===e.$0j?B="":B=(0,P.$Ye)(M),j+=B;continue}switch(M){case"{":ae=!0;continue;case"[":z=!0;continue;case"}":{const U=`(?:${u(J,",").map(Y=>b(Y)).join("|")})`;V+=U,ae=!1,J="";break}case"]":{V+="["+j+"]",z=!1,j="";break}case"?":V+=k;continue;case"*":V+=f(1);continue;default:V+=(0,P.$Ye)(M)}}ee<H.length-1&&(H[ee+1]!==e.$9j||ee+2<H.length)&&(V+=C)}te=re===e.$9j})}return V}const $=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(K,V){if(!K)return n;let H;typeof K!="string"?H=K.pattern:H=K,H=H.trim();const te=`${H}_${!!V.trimForExclusions}`;let re=i.get(te);if(re)return t(re,K);let ee;return $.test(H)?re=a(H.substr(4),H):(ee=l.exec(r(H,V)))?re=v(ee[1],H):(V.trimForExclusions?h:d).test(H)?re=y(H,V):(ee=c.exec(r(H,V)))?re=p(ee[1].substr(1),H,!0):(ee=m.exec(r(H,V)))?re=p(ee[1],H,!1):re=S(H),i.set(te,re),t(re,K)}function t(K,V){if(typeof V=="string")return K;const H=function(te,re){return(0,L.$gg)(te,V.base,!R.$k)?K((0,P.$4e)(te.substr(V.base.length),O.sep),re):null};return H.allBasenames=K.allBasenames,H.allPaths=K.allPaths,H.basenames=K.basenames,H.patterns=K.patterns,H}function r(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,V){return function(H,te){return typeof H=="string"&&H.endsWith(K)?V:null}}function v(K,V){const H=`/${K}`,te=`\\${K}`,re=function(ae,J){return typeof ae!="string"?null:J?J===K?V:null:ae===K||ae.endsWith(H)||ae.endsWith(te)?V:null},ee=[K];return re.basenames=ee,re.patterns=[V],re.allBasenames=ee,re}function y(K,V){const H=x(K.slice(1,-1).split(",").map(J=>s(J,V)).filter(J=>J!==n),K),te=H.length;if(!te)return n;if(te===1)return H[0];const re=function(J,z){for(let j=0,M=H.length;j<M;j++)if(H[j](J,z))return K;return null},ee=H.find(J=>!!J.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=H.reduce((J,z)=>z.allPaths?J.concat(z.allPaths):J,[]);return ae.length&&(re.allPaths=ae),re}function p(K,V,H){const te=O.sep===O.$gc.sep,re=te?K:K.replace(w,O.sep),ee=O.sep+re,ae=O.$gc.sep+K;let J;return H?J=function(z,j){return typeof z=="string"&&(z===re||z.endsWith(ee)||!te&&(z===K||z.endsWith(ae)))?V:null}:J=function(z,j){return typeof z=="string"&&(z===re||!te&&z===K)?V:null},J.allPaths=[(H?"*/":"./")+K],J}function S(K){try{const V=new RegExp(`^${b(K)}$`);return function(H){return V.lastIndex=0,typeof H=="string"&&V.test(H)?K:null}}catch{return n}}function E(K,V,H){return!K||typeof V!="string"?!1:D(K)(V,void 0,H)}function D(K,V={}){if(!K)return o;if(typeof K=="string"||T(K)){const H=s(K,V);if(H===n)return o;const te=function(re,ee){return!!H(re,ee)};return H.allBasenames&&(te.allBasenames=H.allBasenames),H.allPaths&&(te.allPaths=H.allPaths),te}return Z(K,V)}function T(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function F(K){return K.allBasenames||[]}function q(K){return K.allPaths||[]}function Z(K,V){const H=x(Object.getOwnPropertyNames(K).map(J=>X(J,K[J],V)).filter(J=>J!==n)),te=H.length;if(!te)return n;if(!H.some(J=>!!J.requiresSiblings)){if(te===1)return H[0];const J=function(M,B){let U;for(let Y=0,_=H.length;Y<_;Y++){const ne=H[Y](M,B);if(typeof ne=="string")return ne;(0,N.$5g)(ne)&&(U||(U=[]),U.push(ne))}return U?(async()=>{for(const Y of U){const _=await Y;if(typeof _=="string")return _}return null})():null},z=H.find(M=>!!M.allBasenames);z&&(J.allBasenames=z.allBasenames);const j=H.reduce((M,B)=>B.allPaths?M.concat(B.allPaths):M,[]);return j.length&&(J.allPaths=j),J}const re=function(J,z,j){let M,B;for(let U=0,Y=H.length;U<Y;U++){const _=H[U];_.requiresSiblings&&j&&(z||(z=(0,O.$nc)(J)),M||(M=z.substr(0,z.length-(0,O.$oc)(J).length)));const ne=_(J,z,M,j);if(typeof ne=="string")return ne;(0,N.$5g)(ne)&&(B||(B=[]),B.push(ne))}return B?(async()=>{for(const U of B){const Y=await U;if(typeof Y=="string")return Y}return null})():null},ee=H.find(J=>!!J.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=H.reduce((J,z)=>z.allPaths?J.concat(z.allPaths):J,[]);return ae.length&&(re.allPaths=ae),re}function X(K,V,H){if(V===!1)return n;const te=s(K,H);if(te===n)return n;if(typeof V=="boolean")return te;if(V){const re=V.when;if(typeof re=="string"){const ee=(ae,J,z,j)=>{if(!j||!te(ae,J))return null;const M=re.replace("$(basename)",()=>z),B=j(M);return(0,N.$5g)(B)?B.then(U=>U?K:null):B?K:null};return ee.requiresSiblings=!0,ee}}return te}function x(K,V){const H=K.filter(J=>!!J.basenames);if(H.length<2)return K;const te=H.reduce((J,z)=>{const j=z.basenames;return j?J.concat(j):J},[]);let re;if(V){re=[];for(let J=0,z=te.length;J<z;J++)re.push(V)}else re=H.reduce((J,z)=>{const j=z.patterns;return j?J.concat(j):J},[]);const ee=function(J,z){if(typeof J!="string")return null;if(!z){let M;for(M=J.length;M>0;M--){const B=J.charCodeAt(M-1);if(B===47||B===92)break}z=J.substr(M)}const j=te.indexOf(z);return j!==-1?re[j]:null};ee.basenames=te,ee.patterns=re,ee.allBasenames=te;const ae=K.filter(J=>!J.basenames);return ae.push(ee),ae}function W(K,V){return(0,I.$ub)(K,V,(H,te)=>typeof H=="string"&&typeof te=="string"?H===te:typeof H!="string"&&typeof te!="string"?H.base===te.base&&H.pattern===te.pattern:!1)}}),define(le[91],he([0,1,14,10]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$kn=R,e.$ln=g,e.$mn=C;function L(k){return k.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:L(N.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:L(N.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:N.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$in=A,e.$jn=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function O(k,w,f){if(!k||f>200)return null;if(typeof k=="object"){if(k instanceof N.URI)return w.transformOutgoing(k);for(const u in k)if(Object.hasOwnProperty.call(k,u)){const b=O(k[u],w,f+1);b!==null&&(k[u]=b)}}return null}function R(k,w){const f=O(k,w,0);return f===null?k:f}function P(k,w,f,u){if(!k||u>200)return null;if(typeof k=="object"){if(k.$mid===1)return f?N.URI.revive(w.transformIncoming(k)):w.transformIncoming(k);if(k instanceof I.$te)return null;for(const b in k)if(Object.hasOwnProperty.call(k,b)){const $=P(k[b],w,f,u+1);$!==null&&(k[b]=$)}}return null}function g(k,w){const f=P(k,w,!1,0);return f===null?k:f}function C(k,w){const f=P(k,w,!0,0);return f===null?k:f}}),define(le[144],he([0,1,37,48,32,131,5]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=void 0,e.$pn=P,e.$qn=k,e.$on=new class{c(w){return this.a||(this.a=N.$mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const u=(0,I.networkInterfaces)();for(const b in u){const $=u[b];if($)for(const{mac:l,internal:d}of $)d||(f+=1,this.c(l.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let R;async function P(w){return R||(R=(async()=>await g(w)||L.$Cg())()),R}async function g(w){try{const f=await new Promise((b,$)=>{se(["crypto"],b,$)}),u=(0,A.$nn)();return f.createHash("sha256").update(u,"utf8").digest("hex")}catch(f){w(f);return}}const C="Software\\Microsoft\\SQMClient";async function k(w){if(O.$i){const f=await new Promise((u,b)=>{se(["@vscode/windows-registry"],u,b)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(u){return w(u),""}}return""}}),define(le[145],he([0,1,50,271,272,5]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=O;async function O(R){if(A.$j||A.$i)return;let P;for(const g of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,N.open)(g,I.constants.R_OK);break}catch{}if(!P){R("Unable to retrieve release information from known identifier paths.");return}try{const g=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const k of(0,L.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!k.includes("="))continue;const w=k.split("=")[0].toUpperCase().trim();if(g.has(w)){const f=k.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?C.id=f:w==="ID_LIKE"?C.id_like=f:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(C.version_id=f)}}return C}catch(g){R(g)}}}),define(le[31],he([0,1,50,37,273,6,49,87,15,5,20,10]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=h,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=v;var w;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function f(X,x=w.UNLINK,W){if((0,O.$jg)(X))throw new Error("rimraf - will refuse to recursively delete root");return x===w.UNLINK?b(X):u(X,W)}async function u(X,x=(0,O.$og)((0,N.tmpdir)())){try{try{await I.promises.rename(X,x)}catch(W){return W.code==="ENOENT"?void 0:b(X)}b(x).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function b(X){return(0,L.promisify)(I.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function $(X){if((0,O.$jg)(X))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}async function l(X,x){return c(await(x?d(X):(0,L.promisify)(I.readdir)(X)))}async function d(X){try{return await(0,L.promisify)(I.readdir)(X,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const x=[],W=await l(X);for(const K of W){let V=!1,H=!1,te=!1;try{const re=await e.Promises.lstat((0,P.$jc)(X,K));V=re.isFile(),H=re.isDirectory(),te=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}x.push({name:K,isFile:()=>V,isDirectory:()=>H,isSymbolicLink:()=>te})}return x}function h(X){return c(I.readdirSync(X))}function c(X){return X.map(x=>typeof x=="string"?g.$j?(0,R.$Xl)(x):x:(x.name=g.$j?(0,R.$Xl)(x.name):x.name,x))}async function m(X){const x=await l(X),W=[];for(const K of x)await o.existsDirectory((0,P.$jc)(X,K))&&W.push(K);return W}function i(X,x=1e3){return new Promise(W=>{let K=!1;const V=setInterval(()=>{K||(K=!0,I.access(X,H=>{K=!1,H&&(clearInterval(V),W(void 0))}))},x)})}var o;(function(X){async function x(V){let H;try{if(H=await e.Promises.lstat(V),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw re}throw te}}X.stat=x;async function W(V){try{const{stat:H,symbolicLink:te}=await X.stat(V);return H.isFile()&&te?.dangling!==!0}catch{}return!1}X.existsFile=W;async function K(V){try{const{stat:H,symbolicLink:te}=await X.stat(V);return H.isDirectory()&&te?.dangling!==!0}catch{}return!1}X.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const n=new A.$ph;function s(X,x,W){return n.queueFor(k.URI.file(X),()=>{const K=y(W);return new Promise((V,H)=>a(X,x,K,te=>te?H(te):V()))},C.$Kg)}let t=!0;function r(X){t=X}function a(X,x,W,K){if(!t)return I.writeFile(X,x,{mode:W.mode,flag:W.flag},K);I.open(X,W.flag,W.mode,(V,H)=>{if(V)return K(V);I.writeFile(H,x,te=>{if(te)return I.close(H,()=>K(te));I.fdatasync(H,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),I.close(H,ee=>K(ee))))})})}function v(X,x,W){const K=y(W);if(!t)return I.writeFileSync(X,x,{mode:K.mode,flag:K.flag});const V=I.openSync(X,K.flag,K.mode);try{I.writeFileSync(V,x);try{I.fdatasyncSync(V)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),r(!1)}}finally{I.closeSync(V)}}function y(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function p(X,x,W=6e4){if(X!==x)try{g.$i&&typeof W=="number"?await S(X,x,Date.now(),W):await(0,L.promisify)(I.rename)(X,x)}catch(K){if(X.toLowerCase()!==x.toLowerCase()&&K.code==="EXDEV"||X.endsWith("."))await E(X,x,{preserveSymlinks:!1}),await f(X,w.MOVE);else throw K}}async function S(X,x,W,K,V=0){try{return await(0,L.promisify)(I.rename)(X,x)}catch(H){if(H.code!=="EACCES"&&H.code!=="EPERM"&&H.code!=="EBUSY")throw H;if(Date.now()-W>=K)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${H}`),H;if(V===0){let te=!1;try{const{stat:re}=await o.stat(x);re.isFile()||(te=!0)}catch{}if(te)throw H}return await(0,A.$hh)(Math.min(100,V*10)),S(X,x,W,K,V+1)}}async function E(X,x,W){return T(X,x,{root:{source:X,target:x},options:W,handledSourcePaths:new Set})}const D=511;async function T(X,x,W){if(W.handledSourcePaths.has(X))return;W.handledSourcePaths.add(X);const{stat:K,symbolicLink:V}=await o.stat(X);if(V){if(W.options.preserveSymlinks)try{return await Z(X,x,W)}catch{}if(V.dangling)return}return K.isDirectory()?F(X,x,K.mode&D,W):q(X,x,K.mode&D)}async function F(X,x,W,K){await e.Promises.mkdir(x,{recursive:!0,mode:W});const V=await l(X);for(const H of V)await T((0,P.$jc)(X,H),(0,P.$jc)(x,H),K)}async function q(X,x,W){await e.Promises.copyFile(X,x),await e.Promises.chmod(x,W)}async function Z(X,x,W){let K=await e.Promises.readlink(X);(0,O.$gg)(K,W.root.source,!g.$k)&&(K=(0,P.$jc)(W.root.target,K.substr(W.root.source.length+1))),await e.Promises.symlink(K,x)}e.Promises=new class{get access(){return(0,L.promisify)(I.access)}get stat(){return(0,L.promisify)(I.stat)}get lstat(){return(0,L.promisify)(I.lstat)}get utimes(){return(0,L.promisify)(I.utimes)}get read(){return(X,x,W,K,V)=>new Promise((H,te)=>{I.read(X,x,W,K,V,(re,ee,ae)=>re?te(re):H({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,L.promisify)(I.readFile)}get write(){return(X,x,W,K,V)=>new Promise((H,te)=>{I.write(X,x,W,K,V,(re,ee,ae)=>re?te(re):H({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,L.promisify)(I.appendFile)}get fdatasync(){return(0,L.promisify)(I.fdatasync)}get truncate(){return(0,L.promisify)(I.truncate)}get copyFile(){return(0,L.promisify)(I.copyFile)}get open(){return(0,L.promisify)(I.open)}get close(){return(0,L.promisify)(I.close)}get symlink(){return(0,L.promisify)(I.symlink)}get readlink(){return(0,L.promisify)(I.readlink)}get chmod(){return(0,L.promisify)(I.chmod)}get mkdir(){return(0,L.promisify)(I.mkdir)}get unlink(){return(0,L.promisify)(I.unlink)}get rmdir(){return(0,L.promisify)(I.rmdir)}get realpath(){return(0,L.promisify)(I.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return m}get writeFile(){return s}get rm(){return f}get rename(){return p}get copy(){return E}}}),define(le[146],he([0,1,50,15,5,27,31]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=R,e.$Kq=P,e.$Lq=g,e.$Mq=C;function R(w){if(L.$k)return w;const f=(0,N.$mc)(w);if(w===f)return w;const u=((0,N.$nc)(w)||w).toLowerCase();try{const $=(0,O.readdirSync)(f).filter(l=>l.toLowerCase()===u);if($.length===1){const l=R(f);if(l)return(0,N.$jc)(l,$[0])}else if($.length>1){const l=$.indexOf(u);if(l>=0){const d=R(f);if(d)return(0,N.$jc)(d,$[l])}}}catch{}return null}async function P(w){if(L.$k)return w;const f=(0,N.$mc)(w);if(w===f)return w;const u=((0,N.$nc)(w)||w).toLowerCase();try{const $=(await O.Promises.readdir(f)).filter(l=>l.toLowerCase()===u);if($.length===1){const l=await P(f);if(l)return(0,N.$jc)(l,$[0])}else if($.length>1){const l=$.indexOf(u);if(l>=0){const d=await P(f);if(d)return(0,N.$jc)(d,$[l])}}}catch{}return null}async function g(w){try{return await O.Promises.realpath(w)}catch{const u=k(w);return await O.Promises.access(u,I.constants.R_OK),u}}function C(w){try{return I.realpathSync(w)}catch{const u=k(w);return I.accessSync(u,I.constants.R_OK),u}}function k(w){return(0,A.$5e)((0,N.$hc)(w),N.sep)}}),define(le[147],he([0,1,15,5,36,89,13,31]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$$l=P,e.$_l=g,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(k=L.env){return k.comspec||"cmd.exe"}function g(k){let w=[],f=!1;const u=function(b){if(f){w.push(b);return}(!k.send(b,l=>{if(l&&console.error(l),f=!1,w.length>0){const d=w.slice(0);w=[],d.forEach(h=>u(h))}})||N.$i)&&(f=!0)};return{send:u}}var C;(function(k){async function w(f,u,b){if(I.$ic(f))return f;if(u===void 0&&(u=L.cwd()),I.$mc(f)!=="."||(b===void 0&&O.$Tf(L.env.PATH)&&(b=L.env.PATH.split(I.$tc)),b===void 0||b.length===0))return I.$jc(u,f);async function l(d){if(await R.Promises.exists(d)){let h;try{h=await R.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&(h=await R.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(const d of b){let h;if(I.$ic(d)?h=I.$jc(d,f):h=I.$jc(u,d,f),await l(h))return h;let c=h+".com";if(await l(c)||(c=h+".exe",await l(c)))return c}return I.$jc(u,f)}k.findExecutable=w})(C||(e.win32=C={}))}),define(le[148],he([0,1,67,23]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=L;function L(O){return new Promise((R,P)=>{let g;const C=new Map;function k(f,u,b,$,l){const d=C.get(u);if(f===O||d){const h={name:w(b),cmd:b,pid:f,ppid:u,load:$,mem:l};C.set(f,h),f===O&&(g=h),d&&(d.children||(d.children=[]),d.children.push(h),d.children.length>1&&(d.children=d.children.sort((c,m)=>c.pid-m.pid)))}}function w(f){const u=/--utility-sub-type=network/i,b=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(b.exec(f))return"electron-crash-reporter";if($.exec(f))return"winpty-agent";if(l.exec(f))return"conpty-agent";let h=d.exec(f);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?u.exec(f)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const c=/[a-zA-Z-]+\.js/g;let m="";do h=c.exec(f),h&&(m+=h+" ");while(h);return m&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${m})`:f}if(process.platform==="win32"){const f=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,b)=>{se(["@vscode/windows-process-tree"],u,b)}).then(u=>{u.getProcessList(O,b=>{if(!b){P(new Error(`Root process ${O} not found`));return}u.getProcessCpuUsage(b,$=>{const l=new Map;$.forEach(d=>{const h=f(d.commandLine||"");l.set(d.pid,{name:w(h),cmd:h,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),g=l.get(O),g?(l.forEach(d=>{const h=l.get(d.ppid);h&&(h.children||(h.children=[]),h.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((h,c)=>h.pid-c.pid))}),R(g)):P(new Error(`Root process ${O} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let f=function(){let u=[g];const b=[];for(;u.length;){const l=u.shift();l&&(b.push(l.pid),l.children&&(u=u.concat(l.children)))}let $=JSON.stringify(N.$Ag.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+b.join(" "),(0,I.exec)($,{},(l,d,h)=>{if(l||h)P(l||new Error(h.toString()));else{const c=d.toString().split(`
`);for(let m=0;m<b.length;m++){const i=C.get(b[m]);i.load=parseFloat(c[m])}if(!g){P(new Error(`Root process ${O} not found`));return}R(g)}})};(0,I.exec)("which ps",{},(u,b,$)=>{if(u||$)if(process.platform!=="linux")P(u||new Error($.toString()));else{const l=JSON.stringify(N.$Ag.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(l,{},(d,h,c)=>{d||c?P(d||new Error(c.toString())):(A(h,k),f())})}else{const l=b.toString().trim();(0,I.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,c,m)=>{h||m&&!m.includes("screen size is bogus")?P(h||new Error(m.toString())):(A(c,k),process.platform==="linux"?f():g?R(g):P(new Error(`Root process ${O} not found`)))})}})}})}function A(O,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=O.toString().split(`
`);for(const C of g){const k=P.exec(C.trim());k&&k.length===6&&R(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var ye=this&&this.__decorate||function(se,e,I,N){var L=arguments.length,A=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,I,N);else for(var R=se.length-1;R>=0;R--)(O=se[R])&&(A=(L<3?O(A):L>3?O(e,I,A):O(e,I))||A);return L>3&&A&&Object.defineProperty(e,I,A),A};define(le[40],he([0,1,17,6,14,26,84,7,3,2,66,27,13]),function(se,e,I,N,L,A,O,R,P,g,C,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Rh=e.$Qh=void 0,e.$Sh=r,e.$Th=a,e.$Yh=D,e.$Zh=T;var f;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(f||(f={}));function u(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(b||(b={}));function $(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function d(V){let H=0;for(let te=0;;te+=7){const re=V.read(1);if(H|=(re.buffer[0]&127)<<te,!(re.buffer[0]&128))return H}}const h=n(0);function c(V,H){if(H===0){V.write(h);return}let te=0;for(let ee=H;ee!==0;ee=ee>>>7)te++;const re=L.$te.alloc(te);for(let ee=0;H!==0;ee++)re.buffer[ee]=H&127,H=H>>>7,H>0&&(re.buffer[ee]|=128);V.write(re)}class m{constructor(H){this.b=H,this.a=0}read(H){const te=this.b.slice(this.a,this.a+H);return this.a+=te.byteLength,te}}e.$Qh=m;class i{constructor(){this.a=[]}get buffer(){return L.$te.concat(this.a)}write(H){this.a.push(H)}}e.$Rh=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const H=L.$te.alloc(1);return H.writeUInt8(V,0),H}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(V,H){if(typeof H>"u")V.write(s.Undefined);else if(typeof H=="string"){const te=L.$te.fromString(H);V.write(s.String),c(V,te.byteLength),V.write(te)}else if(t&&Buffer.isBuffer(H)){const te=L.$te.wrap(H);V.write(s.Buffer),c(V,te.byteLength),V.write(te)}else if(H instanceof L.$te)V.write(s.VSBuffer),c(V,H.byteLength),V.write(H);else if(Array.isArray(H)){V.write(s.Array),c(V,H.length);for(const te of H)r(V,te)}else if(typeof H=="number"&&(H|0)===H)V.write(s.Uint),c(V,H);else{const te=L.$te.fromString(JSON.stringify(H));V.write(s.Object),c(V,te.byteLength),V.write(te)}}function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(d(V)).toString();case o.Buffer:return V.read(d(V)).buffer;case o.VSBuffer:return V.read(d(V));case o.Array:{const te=d(V),re=[];for(let ee=0;ee<te;ee++)re.push(a(V));return re}case o.Object:return JSON.parse(V.read(d(V)).toString());case o.Int:return d(V)}}class v{constructor(H,te,re=null,ee=1e3){this.h=H,this.j=te,this.k=re,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(H,te){this.b.set(H,te),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case 200:{const te=this.o([H.type]);this.k?.logOutgoing(te,0,1,$(H.type));return}case 201:case 202:case 204:case 203:{const te=this.o([H.type,H.id],H.data);this.k?.logOutgoing(te,H.id,1,$(H.type),H.data);return}}}o(H,te=void 0){const re=new i;return r(re,H),r(re,te),this.p(re.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const te=new m(H),re=a(te),ee=a(te),ae=re[0];switch(ae){case 100:return this.k?.logIncoming(H.byteLength,re[1],1,`${u(ae)}: ${re[2]}.${re[3]}`,ee),this.s({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 102:return this.k?.logIncoming(H.byteLength,re[1],1,`${u(ae)}: ${re[2]}.${re[3]}`,ee),this.t({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 101:return this.k?.logIncoming(H.byteLength,re[1],1,`${u(ae)}`),this.u({type:ae,id:re[1]});case 103:return this.k?.logIncoming(H.byteLength,re[1],1,`${u(ae)}`),this.u({type:ae,id:re[1]})}}s(H){const te=this.b.get(H.channelName);if(!te){this.v(H);return}const re=new A.$de;let ee;try{ee=te.call(this.j,H.name,H.arg,re.token)}catch(z){ee=Promise.reject(z)}const ae=H.id;ee.then(z=>{this.m({id:ae,data:z,type:201})},z=>{z instanceof Error?this.m({id:ae,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:ae,data:z,type:203})}).finally(()=>{J.dispose(),this.d.delete(H.id)});const J=(0,g.$Rc)(()=>re.cancel());this.d.set(H.id,J)}t(H){const te=this.b.get(H.channelName);if(!te){this.v(H);return}const re=H.id,ae=te.listen(this.j,H.name,H.arg)(J=>this.m({id:re,data:J,type:204}));this.d.set(H.id,ae)}u(H){const te=this.d.get(H.id);te&&(te.dispose(),this.d.delete(H.id))}v(H){let te=this.g.get(H.channelName);te||(te=[],this.g.set(H.channelName,te));const re=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:H,timeoutTimer:re})}w(H){const te=this.g.get(H);if(te){for(const re of te)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=v;var y;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class p{constructor(H,te=null){this.l=H,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=te}getChannel(H){const te=this;return{call(re,ee,ae){return te.a?Promise.reject(new R.$5):te.m(H,re,ee,ae)},listen(re,ee){return te.a?P.Event.None:te.o(H,re,ee)}}}m(H,te,re,ee=A.CancellationToken.None){const ae=this.g++,z={id:ae,type:100,channelName:H,name:te,arg:re};if(ee.isCancellationRequested)return Promise.reject(new R.$5);let j;return new Promise((B,U)=>{if(ee.isCancellationRequested)return U(new R.$5);const Y=()=>{const ie=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,U(fe);break}case 203:this.f.delete(ae),U(ce.data);break}};this.f.set(ae,ie),this.p(z)};let _=null;this.b===l.Idle?Y():(_=(0,N.$6g)(ie=>this.u()),_.then(()=>{_=null,Y()}));const ne=()=>{_?(_.cancel(),_=null):this.p({id:ae,type:101}),U(new R.$5)},G=ee.onCancellationRequested(ne);j=(0,g.$Qc)((0,g.$Rc)(ne),G),this.d.add(j)}).finally(()=>{j.dispose(),this.d.delete(j)})}o(H,te,re){const ee=this.g++,J={id:ee,type:102,channelName:H,name:te,arg:re};let z=null;const j=new P.$6d({onWillAddFirstListener:()=>{z=(0,N.$6g)(B=>this.u()),z.then(()=>{z=null,this.d.add(j),this.p(J)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(j),this.p({id:ee,type:103}))}}),M=B=>j.fire(B.data);return this.f.set(ee,M),j.event}p(H){switch(H.type){case 100:case 102:{const te=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(te,H.id,0,`${u(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const te=this.q([H.type,H.id]);this.j?.logOutgoing(te,H.id,0,u(H.type));return}}}q(H,te=void 0){const re=new i;return r(re,H),r(re,te),this.r(re.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const te=new m(H),re=a(te),ee=a(te),ae=re[0];switch(ae){case 200:return this.j?.logIncoming(H.byteLength,0,0,$(ae)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,re[1],0,$(ae),ee),this.t({type:re[0],id:re[1],data:ee})}}t(H){if(H.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=p,ye([O.$Kh],p.prototype,"onDidInitializePromise",null);class S{get connections(){const H=[];return this.f.forEach(te=>H.push(te)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new P.$6d,this.onDidAddConnection=this.g.event,this.h=new P.$6d,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(H(({protocol:te,onDidClientDisconnect:re})=>{const ee=P.Event.once(te.onMessage);this.j.add(ee(ae=>{const J=new m(ae),z=a(J),j=new v(te,z),M=new p(te);this.a.forEach((U,Y)=>j.registerChannel(Y,U));const B={channelServer:j,channelClient:M,ctx:z};this.f.add(B),this.g.fire(B),this.j.add(re(()=>{j.dispose(),M.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(H,te){const re=this;return{call(ee,ae,J){let z;if((0,w.$8f)(te)){const M=(0,I.$4b)(re.connections.filter(te));z=M?Promise.resolve(M):P.Event.toPromise(P.Event.filter(re.onDidAddConnection,te))}else z=te.routeCall(re,ee,ae);const j=z.then(M=>M.channelClient.getChannel(H));return D(j).call(ee,ae,J)},listen(ee,ae){if((0,w.$8f)(te))return re.k(H,te,ee,ae);const J=te.routeEvent(re,ee,ae).then(z=>z.channelClient.getChannel(H));return D(J).listen(ee,ae)}}}k(H,te,re,ee){const ae=this;let J;const z=new P.$6d({onWillAddFirstListener:()=>{J=new g.$Sc;const j=new P.$_d,M=new Map,B=Y=>{const ne=Y.channelClient.getChannel(H).listen(re,ee),G=j.add(ne);M.set(Y,G)},U=Y=>{const _=M.get(Y);_&&(_.dispose(),M.delete(Y))};ae.connections.filter(te).forEach(B),P.Event.filter(ae.onDidAddConnection,te)(B,void 0,J),ae.onDidRemoveConnection(U,void 0,J),j.event(z.fire,z,J),J.add(j)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return z.event}registerChannel(H,te){this.a.set(H,te);for(const re of this.f)re.channelServer.registerChannel(H,te)}dispose(){this.j.dispose();for(const H of this.f)H.channelClient.dispose(),H.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=S;class E{constructor(H,te,re=null){const ee=new i;r(ee,te),H.send(ee.buffer),this.a=new p(H,re),this.d=new v(H,te,re)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,te){this.d.registerChannel(H,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=E;function D(V){return{call(H,te,re){return V.then(ee=>ee.call(H,te,re))},listen(H,te){const re=new P.$ce;return V.then(ee=>re.input=ee.listen(H,te)),re.event}}}function T(V){let H=!1;return{call(te,re,ee){return H?V.call(te,re,ee):(0,N.$hh)(0).then(()=>H=!0).then(()=>V.call(te,re,ee))},listen(te,re){if(H)return V.listen(te,re);const ee=new P.$ce;return(0,N.$hh)(0).then(()=>H=!0).then(()=>ee.input=V.listen(te,re)),ee.event}}}class F{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const te of H.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await P.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.$1h=F;var q;(function(V){function H(ae,J,z){const j=ae,M=z&&z.disableMarshalling,B=new Map;for(const U in j)re(U)&&B.set(U,P.Event.buffer(j[U],!0,void 0,J));return new class{listen(U,Y,_){const ne=B.get(Y);if(ne)return ne;const G=j[Y];if(typeof G=="function"){if(ee(Y))return G.call(j,_);if(re(Y))return B.set(Y,P.Event.buffer(j[Y],!0,void 0,J)),B.get(Y)}throw new R.$bb(`Event not found: ${Y}`)}call(U,Y,_){const ne=j[Y];if(typeof ne=="function"){if(!M&&Array.isArray(_))for(let ie=0;ie<_.length;ie++)_[ie]=(0,C.$Ph)(_[ie]);let G=ne.apply(j,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new R.$bb(`Method not found: ${Y}`)}}}V.fromService=H;function te(ae,J){const z=J&&J.disableMarshalling;return new Proxy({},{get(j,M){if(typeof M=="string")return J?.properties?.has(M)?J.properties.get(M):ee(M)?function(B){return ae.listen(M,B)}:re(M)?ae.listen(M):async function(...B){let U;J&&!(0,w.$3f)(J.context)?U=[J.context,...B]:U=B;const Y=await ae.call(M,U);return z?Y:(0,C.$Ph)(Y)};throw new R.$bb(`Property not found: ${String(M)}`)}})}V.toService=te;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&k.$jf(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&k.$jf(ae.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const H=V.toString();if(H!=="[object Object]")return H}return V}function x(V){return Array.isArray(V)?V.map(X):X(V)}function W(V,H,te,re,ee,ae,J){J=x(J);const z=Z[ee],j=z[re%z.length];let M=[`%c[${V}]%c[${String(H).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(ae)?(M=M.concat(J),M.push(")")):M.push(J),console.log.apply(console,M)}class K{constructor(H,te){this.d=H,this.f=te,this.a=0,this.b=0}logOutgoing(H,te,re,ee,ae){this.b+=H,W(this.d,this.b,H,te,re,ee,ae)}logIncoming(H,te,re,ee,ae){this.a+=H,W(this.f,this.a,H,te,re,ee,ae)}}e.$2h=K}),define(le[68],he([0,1,14,3,2,40]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.ProtocolConstants=e.$3h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(y,p){if(!t.has(y)){const S=String(++r);t.set(y,S)}return t.get(y)}function v(y,p,S,E){if(!s.enableDiagnostics)return;const D=a(y,p);if(E instanceof I.$te||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const T=I.$te.alloc(E.byteLength);T.set(E),s.records.push({timestamp:Date.now(),id:D,label:p,type:S,buff:T})}else s.records.push({timestamp:Date.now(),id:D,label:p,type:S,data:E})}s.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let g=null;function C(){return g||(g=I.$te.alloc(0)),g}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const p=this.a[0];return r&&(this.a.shift(),this.b-=t),p}if(this.a[0].byteLength>t){const p=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),p}const a=I.$te.alloc(t);let v=0,y=0;for(;t>0;){const p=this.a[y];if(p.byteLength>t){const S=p.slice(0,t);a.set(S,v),v+=t,r&&(this.a[y]=p.slice(t),this.b-=t),t-=t}else a.set(p,v),v+=p.byteLength,r?(this.a.shift(),this.b-=p.byteLength):y++,t-=p.byteLength}return a}}e.$3h=k;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function f(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(u||(e.ProtocolConstants=u={}));class b{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends L.$Tc{constructor(t){super(),this.f=this.B(new N.$6d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$te.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=I.$te.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends L.$Tc{constructor(t){super(),this.f=new N.$6d,this.onMessage=this.f.event,this.g=new N.$6d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$4h=d;class h extends A.$Xh{static fromSocket(t,r){return new h(new d(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$5h=h;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$6d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$6h=c;class m{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new m(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Sc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,C());this.p.write(t)}sendResume(){const t=new b(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,C());this.p.write(t)}}e.$7h=n}),define(le[92],he([0,1,67,6,14,26,142,7,3,2,30,147,89,40]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;class u extends f.$Uh{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>L.$te.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Gq=u;class b{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new P.$6d,this.onDidProcessExit=this.h.event;const h=d&&d.timeout?d.timeout:6e4;this.b=new N.$dh(h),this.d=null,this.f=null}getChannel(l){const d=this;return{call(h,c,m){return d.k(l,h,c,m)},listen(h,c){return d.l(l,h,c)}}}k(l,d,h,c=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const m=this.n(l),i=(0,N.$6g)(s=>m.call(d,h,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,g.$Rc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,d,h){if(!this.b)return P.Event.None;this.b.cancel();let c;const m=new P.$6d({onWillAddFirstListener:()=>{c=this.n(l).listen(d,h)(m.fire,m),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.$Mn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,w.$0l)(d.env),this.d=(0,I.fork)(this.i,l,d);const h=new P.$6d;P.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$Cq)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$te.wrap(Buffer.from(t,"base64")))});const m=this.j.useQueue?(0,k.$_l)(this.d):this.d,i=t=>this.d&&this.d.connected&&m.send(t.buffer.toString("base64")),o=h.event,n={send:i,onMessage:o};this.f=new f.$Vh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hq=b}),define(le[149],he([0,1,134,14,40,3,13,17]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0V=void 0,e.$$V=C;class P{constructor(w){this.a=w,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",f=>f.data?N.$te.wrap(f.data):N.$te.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class g extends L.$Wh{static b(w){(0,O.$4f)((0,I.$9V)(process),"Electron Utility Process");const f=new A.$6d;return process.parentPort.on("message",u=>{if(w?.handledClientConnection(u))return;const b=(0,R.$Ob)(u.ports);b&&f.fire(b)}),A.Event.map(f.event,u=>({protocol:new P(u),onDidClientDisconnect:A.Event.fromNodeEventEmitter(u,"close")}))}constructor(w){super(g.b(w))}}e.$0V=g;function C(k,w,f){const u=b=>{b.data===w&&(k.removeListener("message",u),f())};k.on("message",u)}}),define(le[69],he([0,1,6,3,2,66,13]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.StorageState=e.StorageHint=void 0,e.$Fp=P;var R;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function P(w){const f=w;return f?.changed instanceof Map||f?.deleted instanceof Set}var g;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends L.$Tc{static{this.a=100}constructor(f,u=Object.create(null)){super(),this.r=f,this.s=u,this.b=this.B(new N.$9d),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$eh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((u,b)=>this.w(b,u)),f.deleted?.forEach(u=>this.w(u,void 0))}finally{this.b.resume()}}w(f,u){if(this.c===g.Closed)return;let b=!1;(0,O.$3f)(u)?b=this.f.delete(f):this.f.get(f)!==u&&(this.f.set(f,u),b=!0),b&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,u){const b=this.f.get(f);return(0,O.$3f)(b)?u:b}getBoolean(f,u){const b=this.get(f);return(0,O.$3f)(b)?u:b==="true"}getNumber(f,u){const b=this.get(f);return(0,O.$3f)(b)?u:parseInt(b,10)}getObject(f,u){const b=this.get(f);return(0,O.$3f)(b)?u:(0,A.$Oh)(b)}async set(f,u,b=!1){if(this.c===g.Closed)return;if((0,O.$3f)(u))return this.delete(f,b);const $=(0,O.$Vf)(u)||Array.isArray(u)?(0,A.$Nh)(u):String(u);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:b}),this.D()}async delete(f,u=!1){if(!(this.c===g.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:u}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Gp=C;class k{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((u,b)=>this.a.set(b,u)),f.delete?.forEach(u=>this.a.delete(u))}async optimize(){}async close(){}}e.$Hp=k}),define(le[150],he([11,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,50,6,15,13,31,150]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0,e.zip=$,e.$5p=l,e.$6p=h,e.$2p="end of central directory record signature not found";const P=new RegExp(e.$2p);class g extends Error{constructor(m,i){let o=i.message;switch(m){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=m,this.cause=i}}e.$3p=g;function C(c){const m=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>m&i).reduce((i,o)=>i+o,m&61440)}function k(c){if(c instanceof g)return c;let m;return P.test(c.message)&&(m="CorruptZip"),new g(m,c)}function w(c,m,i,o,n,s){const t=L.$mc(m),r=L.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,m)));const a=L.$jc(o,m);let v;return s.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,p)=>{if(!s.isCancellationRequested)try{v=(0,I.createWriteStream)(a,{mode:i}),v.once("close",()=>y()),v.once("error",p),c.once("error",p),c.pipe(v)}catch(S){p(S)}}))}function f(c,m,i,o){let n=(0,N.$6g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const v=new N.$bh,y=p=>{p.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new g("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",p=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(p.fileName)){y(o);return}const S=p.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(S)){const T=L.$jc(m,S);n=(0,N.$6g)(F=>O.Promises.mkdir(T,{recursive:!0}).then(()=>y(F)).then(void 0,a));return}const E=b(c,p),D=C(p);n=(0,N.$6g)(T=>v.queue(()=>E.then(F=>w(F,S,D,m,i,T).then(()=>y(T)))).then(null,a))})}).finally(()=>t.dispose())}async function u(c,m=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,m?{lazyEntries:!0}:void 0,(s,t)=>{s?n(k(s)):o((0,A.$5f)(t))})})}function b(c,m){return new Promise((i,o)=>{c.openReadStream(m,(n,s)=>{n?o(k(n)):i((0,A.$5f)(s))})})}async function $(c,m){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;m.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,I.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function l(c,m,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=u(c,!0);return i.overwrite&&(s=s.then(t=>O.Promises.rm(m).then(()=>t))),s.then(t=>f(t,m,{sourcePathRegex:n},o))}function d(c,m){return u(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===m&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,m))))}))}function h(c,m){return d(c,m).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(le[151],he([11,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[152],he([11,9]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[153],he([11,9]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[154],he([11,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[155],he([11,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[156],he([11,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[157],he([11,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[158],he([11,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[159],he([11,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[160],he([11,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[161],he([11,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[162],he([11,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[163],he([11,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[164],he([11,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[165],he([11,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[166],he([11,9]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[167],he([11,9]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[168],he([11,9]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[169],he([11,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[170],he([11,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[171],he([11,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[172],he([11,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[173],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[174],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[175],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[176],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[177],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[178],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[179],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[180],he([11,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[181],he([11,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[182],he([0,1,7,153]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var L;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...g){switch(g.length){case 1:return(0,N.localize)(0,null,g[0]);case 2:return(0,N.localize)(1,null,g[0],g[1]);case 3:return(0,N.localize)(2,null,g[0],g[1],g[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const k=this.d,w=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:w};this.g.push({offset:k,lexeme:w,additionalInfo:C}),this.f.push(f)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const k=this.c.substring(this.d,this.e),w=P.b.get(k);w?this.k(w):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,k=!1,w=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const u=this.c.charCodeAt(C);if(k)k=!1;else if(u===47&&!w){C++;break}else u===91?w=!0:u===92?k=!0:u===93&&(w=!1);C++}for(;C<this.c.length&&P.a.has(this.c.charCodeAt(C));)C++;this.e=C;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=P}),define(le[183],he([0,1,65,84,23,15,36,20,10]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Qm=C,e.$Rm=k,e.$Om=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,A.$mc)(L.$Ag.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.$Nm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",f)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Tg)(P.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=O.env.VSCODE_PORTABLE;return f?P.URI.file((0,A.$jc)(f,"argv.json")):(0,R.$Tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$kc)(f):(0,A.$hc)((0,A.$jc)(L.$Ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?P.URI.file((0,A.$kc)(f)):P.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$kc)(f);const u=O.env.VSCODE_EXTENSIONS;if(u)return u;const b=O.env.VSCODE_PORTABLE;return b?(0,A.$jc)(b,"extensions"):(0,R.$Tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(u=>/^[^:/?#]+?:\/\//.test(u)?P.URI.parse(u):P.URI.file((0,A.$hc)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,A.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$Om.test(f))}get extensionLogLevel(){const f=[];for(const u of this.args.log||[]){const b=e.$Om.exec(u);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.$Tg)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=O.env.VSCODE_PORTABLE;return f?P.URI.file((0,A.$jc)(f,"policy.json")):(0,R.$Tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,u,b){this.a=f,this.b=u,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Pm=g,ye([N.$Kh],g.prototype,"appRoot",null),ye([N.$Kh],g.prototype,"userHome",null),ye([N.$Kh],g.prototype,"userDataPath",null),ye([N.$Kh],g.prototype,"appSettingsHome",null),ye([N.$Kh],g.prototype,"tmpDir",null),ye([N.$Kh],g.prototype,"cacheHome",null),ye([N.$Kh],g.prototype,"stateResource",null),ye([N.$Kh],g.prototype,"userRoamingDataHome",null),ye([N.$Kh],g.prototype,"userDataSyncHome",null),ye([N.$Kh],g.prototype,"sync",null),ye([N.$Kh],g.prototype,"machineSettingsResource",null),ye([N.$Kh],g.prototype,"workspaceStorageHome",null),ye([N.$Kh],g.prototype,"localHistoryHome",null),ye([N.$Kh],g.prototype,"keyboardLayoutResource",null),ye([N.$Kh],g.prototype,"argvResource",null),ye([N.$Kh],g.prototype,"isExtensionDevelopment",null),ye([N.$Kh],g.prototype,"untitledWorkspacesHome",null),ye([N.$Kh],g.prototype,"builtinExtensionsPath",null),ye([N.$Kh],g.prototype,"extensionsPath",null),ye([N.$Kh],g.prototype,"extensionDevelopmentLocationURI",null),ye([N.$Kh],g.prototype,"extensionDevelopmentKind",null),ye([N.$Kh],g.prototype,"extensionTestsLocationURI",null),ye([N.$Kh],g.prototype,"debugExtensionHost",null),ye([N.$Kh],g.prototype,"logLevel",null),ye([N.$Kh],g.prototype,"extensionLogLevel",null),ye([N.$Kh],g.prototype,"serviceMachineIdResource",null),ye([N.$Kh],g.prototype,"disableTelemetry",null),ye([N.$Kh],g.prototype,"disableWorkspaceTrust",null),ye([N.$Kh],g.prototype,"useInMemorySecretStorage",null),ye([N.$Kh],g.prototype,"policyFile",null);function C(w,f){return k(w["inspect-extensions"],w["inspect-brk-extensions"],5870,f,w.debugId,w.extensionEnvironment)}function k(w,f,u,b,$,l){const h=Number(f||w)||(b?null:u),c=h?!!f:!1;let m;if(l)try{m=JSON.parse(l)}catch{}return{port:h,break:c,debugId:$,env:m}}}),function(){"use strict";function se(e,I,N){function L(O,R){const P=A(O,R),g=[P];return e.isAbsolute(P)||g.unshift(N),e.resolve(...g)}function A(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(k,"AppData","Roaming")}break;case"darwin":g=e.join(I.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:L}}if(typeof define=="function")define(le[184],he([274,37,36]),function(e,I,N){return se(e,I,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=se(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[185],he([0,1,37,183,184]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Tm=O,e.$Um=R;class A extends N.$Pm{constructor(g,C){super(g,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,L.getUserDataPath)(g,C.nameShort)},C)}}e.$Sm=A;function O(P,g){return(0,N.$Rm)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,g,P.extensionEnvironment)}function R(P,g){return(0,N.$Rm)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,g,P.extensionEnvironment)}}),define(le[186],he([0,1,13,156]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=L;function L(O,R,P,g){try{A(O,R,P,g)}catch(C){O.error(C?.message??C)}return R}function A(O,R,P,g){const C=(k,w,f)=>{const u=k[w];if((0,I.$Tf)(u)){const b=u,$=b.length;if($>1&&b[0]==="%"&&b[$-1]==="%"){const l=b.substr(1,$-2);let d=P[l];d===void 0&&g&&(d=g[l]);const h=typeof d=="string"?d:d?.message,c=g?.[l],m=typeof c=="string"?c:c?.message;if(!h){m||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,l)}`);return}if(f&&(w==="title"||w==="category")&&m&&m!==h){const i={value:h,original:m};k[w]=i}else k[w]=h}}else if((0,I.$Vf)(u))for(const b in u)u.hasOwnProperty(b)&&(b==="commands"?C(u,b,!0):C(u,b,f));else if(Array.isArray(u))for(let b=0;b<u.length;b++)C(u,b,f)};for(const k in R)R.hasOwnProperty(k)&&C(R,k)}}),define(le[187],he([0,1,70,159]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=L;function L(A){return(0,I.$6p)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(le[188],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class I{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$dcc=I;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$ecc=N}),define(le[71],he([0,1,20,88,160,55]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=P,e.$rp=g,e.$sp=C,e.$tp=k,e.$up=w,e.$vp=f,e.$wp=u;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||O.test(l)}function g(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function C(l){if(!l)return null;const d=l.majorBase,h=l.majorMustEqual,c=l.minorBase;let m=l.minorMustEqual;const i=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(d===0||(m=!1),o=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:h,minorBase:c,minorMustEqual:m,patchBase:i,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}function k(l,d,h){let c;typeof l=="string"?c=C(g(l)):c=l;let m;d instanceof Date?m=d.getTime():typeof d=="string"&&(m=new Date(d).getTime());let i;if(typeof h=="string"?i=C(g(h)):i=h,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const v=i.notBefore;let y=i.majorMustEqual,p=i.minorMustEqual,S=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||m&&m<v?!1:s>=a:(o===1&&t===0&&(!y||!p||!S)&&(t=1,r=0,a=0,y=!0,p=!1,S=!1),o<t?!1:o>t?!y:n<r?!1:n>r?!p:s<a?!1:s>a?!S:!(m&&m<v))}function w(l,d,h,c,m){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,L.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,L.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,L.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,L.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,L.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!$(c.extensionDependencies))return i.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!$(c.activationEvents))return i.push([N.default.Error,L.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,L.localize(9,null,"main")]),i;{const s=(0,I.$Tg)(h,c.main);(0,I.$Ng)(s,h)||i.push([N.default.Warning,L.localize(10,null,s.path,h.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,L.localize(11,null,"browser")]),i;{const s=(0,I.$Tg)(h,c.browser);(0,I.$Ng)(s,h)||i.push([N.default.Warning,L.localize(12,null,s.path,h.path)])}}if(!A.valid(c.version))return i.push([N.default.Error,L.localize(13,null)]),i;const o=[];if(!f(l,d,c,m,o))for(const s of o)i.push([N.default.Error,s]);return i}function f(l,d,h,c,m){return c||typeof h.main>"u"&&typeof h.browser>"u"?!0:b(l,d,h.engines.vscode,m)}function u(l,d,h){return l==="*"||b(d,h,l)}function b(l,d,h,c=[]){const m=C(g(h));if(!m)return c.push(L.localize(14,null,h)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(L.localize(15,null,h)),!1}else if(!m.majorMustEqual)return c.push(L.localize(16,null,h)),!1;return k(l,d,m)?!0:(c.push(L.localize(17,null,l,h)),!1)}function $(l){if(!Array.isArray(l))return!1;for(let d=0,h=l.length;d<h;d++)if(typeof l[d]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=L;async function L(A,O,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await O.readFile(A.serviceMachineIdResource)).value.toString();P=(0,N.$Bg)(C)?C:null}catch{P=null}if(!P){P=(0,N.$Cg)();try{await O.writeFile(A.serviceMachineIdResource,I.$te.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class I{constructor(L,A=[],O=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$di=I}),define(le[189],he([0,1,72]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$cs=A,e.$ds=O;const N=[];var L;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(R,P,g){P instanceof I.$di||(P=new I.$di(P,[],!!g)),N.push([R,P])}function O(){return N}}),define(le[190],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class I{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Sq=I;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(O);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new I(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),P=this.c(O,R);if(P)return P}}c(A,O){for(const[R,P]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const g=this.c(P,O);if(g)return g;O.delete(R)}}}e.$Tq=N}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e._util=void 0,e.$gi=L,e.$hi=A;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$fi=L("instantiationService");function N(O,R,P){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:P}):(R[I.DI_DEPENDENCIES]=[{id:O,index:P}],R[I.DI_TARGET]=R)}function L(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(P,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,P,C)};return R.toString=()=>O,I.serviceIds.set(O,R),R}function A(O){return O}}),define(le[191],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0,e.$Pbc=(0,I.$gi)("checksumService")}),define(le[21],he([0,1,13,10,4]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Mi=void 0,e.$Ni=A,e.$Oi=O,e.$Pi=P,e.$Qi=g,e.$Ri=C,e.$Si=k,e.$Ti=w,e.$Ui=u,e.$Vi=b,e.$Wi=$,e.$Mi=(0,L.$gi)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function C(l,d){const h=Object.create(null);for(const c in l)k(h,c,l[c],d);return h}function k(l,d,h,c){const m=d.split("."),i=m.pop();let o=l;for(let n=0;n<m.length;n++){const s=m[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${d} as ${m.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=h}catch{c(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(o)}`)}function w(l,d){const h=d.split(".");f(l,h)}function f(l,d){const h=d.shift();if(d.length===0){delete l[h];return}if(Object.keys(l).indexOf(h)!==-1){const c=l[h];typeof c=="object"&&!Array.isArray(c)&&(f(c,d),Object.keys(c).length===0&&delete l[h])}}function u(l,d,h){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const m=d.split("."),i=c(l,m);return typeof i>"u"?h:i}function b(l,d,h){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in l?I.$Vf(l[c])&&I.$Vf(d[c])?b(l[c],d[c],h):h&&(l[c]=d[c]):l[c]=d[c])})}function $(l){return l.replace(/[\[\]]/g,"")}}),define(le[93],he([0,1,5,27,182,4,152,7]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$ej=e.$dj=e.ContextKeyExprType=void 0,e.$cj=g,e.$fj=o,e.$gj=n,e.$zj=ee;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",I.$j),P.set("isLinux",I.$k),P.set("isWindows",I.$i),P.set("isWeb",I.$o),P.set("isMacNative",I.$j&&!I.$o),P.set("isEdge",I.$H),P.set("isFirefox",I.$F),P.set("isChrome",I.$E),P.set("isSafari",I.$G);function g(z,j){if(P.get(z)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(z,j)}const C=Object.prototype.hasOwnProperty;var k;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const w={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(0,null),u=(0,O.localize)(1,null),b=(0,O.localize)(2,null),$=(0,O.localize)(3,null),l=(0,O.localize)(4,null),d=(0,O.localize)(5,null),h=(0,O.localize)(6,null),c=(0,O.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=w){this.k=j,this.d=new L.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:u});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const B=this.D(),U=B.type===17?d:void 0;throw this.h.push({message:l,offset:B.offset,lexeme:L.$bj.getLexeme(B),additionalInfo:U}),m.c}return M}catch(M){if(M!==m.c)throw M;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const M=this.o();j.push(M)}return j.length===1?j[0]:i.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const M=this.s();j.push(M)}return j.length===1?j[0]:i.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,$),M?.negate()}case 17:return this.z(),E.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const M=this.l();return this.A(1,$),M}case 17:{const M=j.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Y=U.lexeme,_=Y.lastIndexOf("/"),ne=_===Y.length-1?void 0:this.w(Y.substring(_+1));let G;try{G=new RegExp(Y.substring(1,_),ne)}catch{throw this.B("REGEX",U)}return X.create(M,G)}switch(U.type){case 10:case 19:{const Y=[U.lexeme];this.z();let _=this.D(),ne=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?ne++:U.lexeme.charCodeAt(de)===41&&ne--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ne++:U.lexeme.charCodeAt(de)===41&&ne--}if(ne<0)break;Y.push(L.$bj.getLexeme(_)),this.z(),_=this.D()}const G=Y.join(""),ie=G.lastIndexOf("/"),ce=ie===G.length-1?void 0:this.w(G.substring(ie+1));let fe;try{fe=new RegExp(G.substring(1,ie),ce)}catch{throw this.B("REGEX",U)}return i.regex(M,fe)}case 18:{const Y=U.lexeme;this.z();let _=null;if(!(0,N.$Te)(Y)){const ne=Y.indexOf("/"),G=Y.lastIndexOf("/");if(ne!==G&&ne>=0){const ie=Y.slice(ne+1,G),ce=Y[G+1]==="i"?"i":"";try{_=new RegExp(ie,ce)}catch{throw this.B("REGEX",U)}}}if(_===null)throw this.B("REGEX",U);return X.create(M,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const U=this.u();return i.notIn(M,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return i.equals(M,U);switch(U){case"true":return i.has(M);case"false":return i.not(M);default:return i.equals(M,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return i.notEquals(M,U);switch(U){case"true":return i.not(M);case"false":return i.has(M);default:return i.notEquals(M,U)}}case 5:return this.z(),q.create(M,this.u());case 6:return this.z(),Z.create(M,this.u());case 7:return this.z(),T.create(M,this.u());case 8:return this.z(),F.create(M,this.u());case 13:return this.z(),i.in(M,this.u());default:return i.has(M)}}case 20:throw this.h.push({message:h,offset:j.offset,lexeme:"",additionalInfo:c}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,M){if(this.C(j))return this.z();throw this.B(M,this.D())}B(j,M,B){const U=(0,O.localize)(8,null,j,L.$bj.getLexeme(M)),Y=M.offset,_=L.$bj.getLexeme(M);return this.h.push({message:U,offset:Y,lexeme:_,additionalInfo:B}),m.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=m;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(j){return a.create(j)}static equals(j,M){return v.create(j,M)}static notEquals(j,M){return S.create(j,M)}static regex(j,M){return X.create(j,M)}static in(j,M){return y.create(j,M)}static notIn(j,M){return p.create(j,M)}static not(j){return E.create(j)}static and(...j){return K.create(j,null,!0)}static or(...j){return V.create(j,null,!0)}static greater(j,M){return T.create(j,M)}static greaterEquals(j,M){return F.create(j,M)}static smaller(j,M){return q.create(j,M)}static smallerEquals(j,M){return Z.create(j,M)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$ej=i;function o(z){const j=new m({regexParsingWithErrorRecovery:!1});return z.map(M=>(j.parse(M),j.lexingErrors.length>0?j.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}function n(z,j){const M=z?z.substituteConstants():void 0,B=j?j.substituteConstants():void 0;return!M&&!B?!0:!M||!B?!1:M.equals(B)}function s(z,j){return z.cmp(j)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return r.INSTANCE}}e.$hj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return t.INSTANCE}}e.$ij=r;class a{static create(j,M=null){const B=P.get(j);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(j,M)}constructor(j,M){this.key=j,this.c=M,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:te(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=P.get(this.key);return typeof j=="boolean"?j?r.INSTANCE:t.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=E.create(this.key,this)),this.c}}e.$jj=a;class v{static create(j,M,B=null){if(typeof M=="boolean")return M?a.create(j,B):E.create(j,B);const U=P.get(j);return typeof U=="boolean"?M===(U?"true":"false")?r.INSTANCE:t.INSTANCE:new v(j,M,B)}constructor(j,M,B){this.c=j,this.d=M,this.f=B,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=P.get(this.c);if(typeof j=="boolean"){const M=j?"true":"false";return this.d===M?r.INSTANCE:t.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$kj=v;class y{static create(j,M){return new y(j,M)}constructor(j,M){this.d=j,this.f=M,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:re(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const M=j.getValue(this.f),B=j.getValue(this.d);return Array.isArray(M)?M.includes(B):typeof B=="string"&&typeof M=="object"&&M!==null?C.call(M,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$lj=y;class p{static create(j,M){return new p(j,M)}constructor(j,M){this.d=j,this.f=M,this.type=11,this.c=y.create(j,M)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=p;class S{static create(j,M,B=null){if(typeof M=="boolean")return M?E.create(j,B):a.create(j,B);const U=P.get(j);return typeof U=="boolean"?M===(U?"true":"false")?t.INSTANCE:r.INSTANCE:new S(j,M,B)}constructor(j,M,B){this.c=j,this.d=M,this.f=B,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=P.get(this.c);if(typeof j=="boolean"){const M=j?"true":"false";return this.d===M?t.INSTANCE:r.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$nj=S;class E{static create(j,M=null){const B=P.get(j);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new E(j,M)}constructor(j,M){this.c=j,this.d=M,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:te(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=P.get(this.c);return typeof j=="boolean"?j?t.INSTANCE:r.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$oj=E;function D(z,j){if(typeof z=="string"){const M=parseFloat(z);isNaN(M)||(z=M)}return typeof z=="string"||typeof z=="number"?j(z):t.INSTANCE}class T{static create(j,M,B=null){return D(M,U=>new T(j,U,B))}constructor(j,M,B){this.c=j,this.d=M,this.f=B,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$pj=T;class F{static create(j,M,B=null){return D(M,U=>new F(j,U,B))}constructor(j,M,B){this.c=j,this.d=M,this.f=B,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$qj=F;class q{static create(j,M,B=null){return D(M,U=>new q(j,U,B))}constructor(j,M,B){this.c=j,this.d=M,this.f=B,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$rj=q;class Z{static create(j,M,B=null){return D(M,U=>new Z(j,U,B))}constructor(j,M,B){this.c=j,this.d=M,this.f=B,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$sj=Z;class X{static create(j,M){return new X(j,M)}constructor(j,M){this.d=j,this.f=M,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const M=this.f?this.f.source:"",B=j.f?j.f.source:"";return M<B?-1:M>B?1:0}equals(j){if(j.type===this.type){const M=this.f?this.f.source:"",B=j.f?j.f.source:"";return this.d===j.d&&M===B}return!1}substituteConstants(){return this}evaluate(j){const M=j.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$tj=X;class x{static create(j){return new x(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new x(this.c.map(j))}negate(){return this.c}}e.$uj=x;function W(z){let j=null;for(let M=0,B=z.length;M<B;M++){const U=z[M].substituteConstants();if(z[M]!==U&&j===null){j=[];for(let Y=0;Y<M;Y++)j[Y]=z[Y]}j!==null&&(j[M]=U)}return j===null?z:j}class K{static create(j,M,B){return K.d(j,M,B)}constructor(j,M){this.expr=j,this.c=M,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let M=0,B=this.expr.length;M<B;M++){const U=s(this.expr[M],j.expr[M]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].equals(j.expr[M]))return!1;return!0}return!1}substituteConstants(){const j=W(this.expr);return j===this.expr?this:K.create(j,this.c,!1)}evaluate(j){for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].evaluate(j))return!1;return!0}static d(j,M,B){const U=[];let Y=!1;for(const _ of j)if(_){if(_.type===1){Y=!0;continue}if(_.type===0)return t.INSTANCE;if(_.type===6){U.push(..._.expr);continue}U.push(_)}if(U.length===0&&Y)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(s);for(let _=1;_<U.length;_++)U[_-1].equals(U[_])&&(U.splice(_,1),_--);if(U.length===1)return U[0];for(;U.length>1;){const _=U[U.length-1];if(_.type!==9)break;U.pop();const ne=U.pop(),G=U.length===0,ie=V.create(_.expr.map(ce=>K.create([ce,ne],null,B)),null,G);ie&&(U.push(ie),U.sort(s))}if(U.length===1)return U[0];if(B){for(let _=0;_<U.length;_++)for(let ne=_+1;ne<U.length;ne++)if(U[_].negate().equals(U[ne]))return t.INSTANCE;if(U.length===1)return U[0]}return new K(U,M)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const M of this.expr)j.push(...M.keys());return j}map(j){return new K(this.expr.map(M=>M.map(j)),null)}negate(){if(!this.c){const j=[];for(const M of this.expr)j.push(M.negate());this.c=V.create(j,this,!0)}return this.c}}e.$vj=K;class V{static create(j,M,B){return V.d(j,M,B)}constructor(j,M){this.expr=j,this.c=M,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let M=0,B=this.expr.length;M<B;M++){const U=s(this.expr[M],j.expr[M]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].equals(j.expr[M]))return!1;return!0}return!1}substituteConstants(){const j=W(this.expr);return j===this.expr?this:V.create(j,this.c,!1)}evaluate(j){for(let M=0,B=this.expr.length;M<B;M++)if(this.expr[M].evaluate(j))return!0;return!1}static d(j,M,B){let U=[],Y=!1;if(j){for(let _=0,ne=j.length;_<ne;_++){const G=j[_];if(G){if(G.type===0){Y=!0;continue}if(G.type===1)return r.INSTANCE;if(G.type===9){U=U.concat(G.expr);continue}U.push(G)}}if(U.length===0&&Y)return t.INSTANCE;U.sort(s)}if(U.length!==0){if(U.length===1)return U[0];for(let _=1;_<U.length;_++)U[_-1].equals(U[_])&&(U.splice(_,1),_--);if(U.length===1)return U[0];if(B){for(let _=0;_<U.length;_++)for(let ne=_+1;ne<U.length;ne++)if(U[_].negate().equals(U[ne]))return r.INSTANCE;if(U.length===1)return U[0]}return new V(U,M)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const M of this.expr)j.push(...M.keys());return j}map(j){return new V(this.expr.map(M=>M.map(j)),null)}negate(){if(!this.c){const j=[];for(const M of this.expr)j.push(M.negate());for(;j.length>1;){const M=j.shift(),B=j.shift(),U=[];for(const Y of J(M))for(const _ of J(B))U.push(K.create([Y,_],null,!1));j.unshift(V.create(U,null,!1))}this.c=V.create(j,this,!0)}return this.c}}e.$wj=V;class H extends a{static{this.d=[]}static all(){return H.d.values()}constructor(j,M,B){super(j,null),this.f=M,typeof B=="object"?H.d.push({...B,key:j}):B!==!0&&H.d.push({key:j,description:B,type:M!=null?typeof M:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return v.create(this.key,j)}notEqualsTo(j){return S.create(this.key,j)}}e.$xj=H,e.$yj=(0,A.$gi)("contextKeyService");function te(z,j){return z<j?-1:z>j?1:0}function re(z,j,M,B){return z<M?-1:z>M?1:j<B?-1:j>B?1:0}function ee(z,j){if(z.type===0||j.type===1)return!0;if(z.type===9)return j.type===9?ae(z.expr,j.expr):!1;if(j.type===9){for(const M of j.expr)if(ee(z,M))return!0;return!1}if(z.type===6){if(j.type===6)return ae(j.expr,z.expr);for(const M of z.expr)if(ee(M,j))return!0;return!1}return z.equals(j)}function ae(z,j){let M=0,B=0;for(;M<z.length&&B<j.length;){const U=z[M].cmp(j[B]);if(U<0)return!1;U===0&&M++,B++}return M===z.length}function J(z){return z.type===9?z.expr:[z]}}),define(le[94],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$Zm=e.ID=void 0,e.$1m=N,e.ID="diagnosticsService",e.$Zm=(0,I.$gi)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}class L{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$2m=L}),define(le[95],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,e.$uo=(0,I.$gi)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,I.$gi)("environmentService"),e.$oi=(0,I.$hi)(e.$ni)}),define(le[29],he([0,1,155,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.ExtensionGalleryErrorCode=e.$Qo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Po=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0,e.$Jo=L,e.$Ko=A,e.$Lo=O,e.$Mo=R,e.$No=P,e.$Oo=g,e.$Do="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Eo=new RegExp(e.$Do),e.$Fo="__web_extension",e.$Go="skipWalkthrough",e.$Ho="extensionsSync",e.$Io="dependecyOrPackExtensionInstall";function L(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(h,c){switch(h){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(h,c){return c==="web"&&!h.includes("web")}function P(h,c,m){return R(c,m)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===m}function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var k;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var w;(function(h){h.Install="install",h.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$Po=(0,N.$gi)("extensionGalleryService");var u;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));var b;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class $ extends Error{constructor(c,m){super(c),this.code=m,this.name=m}}e.$Qo=$;var l;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class d extends Error{constructor(c,m){super(c),this.code=m,this.name=m}}e.$Ro=d,e.$So=(0,N.$gi)("extensionManagementService"),e.$To="extensionsIdentifiers/disabled",e.$Uo="extensionsIdentifiers/enabled",e.$Vo=(0,N.$gi)("IGlobalExtensionEnablementService"),e.$Wo=(0,N.$gi)("IExtensionTipsService"),e.$Xo=(0,I.localize2)(0,"Extensions"),e.$Yo=(0,I.localize2)(1,"Preferences")}),define(le[192],he([0,1,3,2,30,10,91,29]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=void 0;function P($,l){return $?A.URI.revive(l?l.transformIncoming($):$):void 0}function g($,l){return l?l.transformOutgoingURI($):$}function C($,l){l=l||O.$jn;const d=$.manifest;return{...(0,O.$mn)({...$,manifest:void 0},l),manifest:d}}function k($,l){return $?.profileLocation?(0,O.$mn)($,l??O.$jn):$}function w($,l){return l?(0,L.$On)($,d=>d instanceof A.URI?l.transformOutgoingURI(d):void 0):$}class f{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=I.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,d){const h=this.b(l);switch(d){case"onInstallExtension":return I.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,h):c.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,c=>c.map(m=>({...m,local:m.local?w(m.local,h):m.local,profileLocation:m.profileLocation?g(m.profileLocation,h):m.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,h):c.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,h):c.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,c=>w(c,h))}throw new Error("Invalid listen")}async call(l,d,h){const c=this.b(l);switch(d){case"zip":{const m=C(h[0],c),i=await this.a.zip(m);return g(i,c)}case"unzip":return this.a.unzip(P(h[0],c));case"install":return this.a.install(P(h[0],c),k(h[1],c));case"installFromLocation":return this.a.installFromLocation(P(h[0],c),P(h[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],P(h[1],c),P(h[2],c));case"getManifest":return this.a.getManifest(P(h[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],k(h[1],c));case"installGalleryExtensions":{const m=h[0];return this.a.installGalleryExtensions(m.map(({extension:i,options:o})=>({extension:i,options:k(o,c)??{}})))}case"uninstall":return this.a.uninstall(C(h[0],c),k(h[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(h[0],c));case"getInstalled":return(await this.a.getInstalled(h[0],P(h[1],c),h[2])).map(i=>w(i,c));case"toggleAppliationScope":{const m=await this.a.toggleAppliationScope(C(h[0],c),P(h[1],c));return w(m,c)}case"copyExtensions":return this.a.copyExtensions(P(h[0],c),P(h[1],c));case"updateMetadata":{const m=await this.a.updateMetadata(C(h[0],c),h[1],P(h[2],c));return w(m,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Yp=f;class u extends N.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new I.$6d),this.f=this.B(new I.$6d),this.g=this.B(new I.$6d),this.h=this.B(new I.$6d),this.j=this.B(new I.$6d),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?A.URI.revive(d.source):d.source,profileLocation:A.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(C(d,null))))}n(l,d){l.fire(d)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(h=>(0,R.$No)(h,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(d=>A.URI.revive(d)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,d){return Promise.resolve(this.m.call("install",[l,d])).then(h=>C(h,null))}installFromLocation(l,d){return Promise.resolve(this.m.call("installFromLocation",[l,d])).then(h=>C(h,null))}async installExtensionsFromProfile(l,d,h){return(await this.m.call("installExtensionsFromProfile",[l,d,h])).map(m=>C(m,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.m.call("installFromGallery",[l,d])).then(h=>C(h,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))}uninstall(l,d){return Promise.resolve(this.m.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(d=>C(d,null))}getInstalled(l=null,d,h){return Promise.resolve(this.m.call("getInstalled",[l,d,h])).then(c=>c.map(m=>C(m,null)))}updateMetadata(l,d,h){return Promise.resolve(this.m.call("updateMetadata",[l,d,h])).then(c=>C(c,null))}toggleAppliationScope(l,d){return this.m.call("toggleAppliationScope",[l,d]).then(h=>C(h,null))}copyExtensions(l,d){return this.m.call("copyExtensions",[l,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,d,h){const c=await this.m.call("download",[l,d,h]);return A.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Zp=u;class b{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,h){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$1p=b}),define(le[96],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c2b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$b2b=L;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$c2b=(0,I.$gi)("IExtensionRecommendationNotificationService")}),define(le[12],he([0,1,48,15,27,13,10,162,4,5,23,53]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$fl=e.FileKind=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileOperationResult=e.$0k=e.$9k=e.$8k=e.$6k=e.FileChangeType=e.$5k=e.FileOperation=e.$Yk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Mk=void 0,e.$Nk=w,e.$Ok=b,e.$Pk=l,e.$Qk=d,e.$Rk=h,e.$Sk=c,e.$Tk=m,e.$Uk=i,e.$Vk=o,e.$Wk=n,e.$Xk=s,e.$Zk=a,e.$1k=v,e.$2k=y,e.$3k=p,e.$4k=S,e.$7k=q,e.$gl=V,e.$hl=H,e.$jl=re,e.$Mk=(0,P.$gi)("fileService");function w(ee){return ee.create===!0}var f;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var u;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(u||(e.FilePermission=u={}));function b(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}var $;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function l(ee){return!!(ee.capabilities&2)}function d(ee){return!!(ee.capabilities&8)}function h(ee){return!!(ee.capabilities&131072)}function c(ee){return!!(ee.capabilities&4)}function m(ee){return!!(ee.capabilities&16)}function i(ee){return l(ee)?!!(ee.capabilities&16384):!1}function o(ee){return l(ee)?!!(ee.capabilities&32768):!1}function n(ee){return!!(ee.capabilities&65536)}function s(ee){return!!(ee.capabilities&2048)}var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,J){const z=new r(ae.toString(),J);return y(z,J),z}constructor(ae,J){super(ae),this.code=J}}e.$Yk=r;function a(ee,ae){return r.create(ee,ae)}function v(ee){return ee||a((0,R.localize)(0,null),t.Unknown)}function y(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}function p(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function S(ee){if(ee instanceof Z)return ee.fileOperationResult;switch(p(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var E;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class D{constructor(ae,J,z){this.resource=ae,this.operation=J,this.target=z}isOperation(ae){return this.operation===ae}}e.$5k=D;var T;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class F{static{this.a=null}constructor(ae,J){this.c=J,this.b=void 0,this.d=new k.$V(()=>{const z=I.$mi.forUris(()=>this.c);return z.fill(this.rawAdded.map(j=>[j,!0])),z}),this.f=new k.$V(()=>{const z=I.$mi.forUris(()=>this.c);return z.fill(this.rawUpdated.map(j=>[j,!0])),z}),this.g=new k.$V(()=>{const z=I.$mi.forUris(()=>this.c);return z.fill(this.rawDeleted.map(j=>[j,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of ae){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==F.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ae,...J){return this.h(ae,{includeChildren:!1},...J)}affects(ae,...J){return this.h(ae,{includeChildren:!0},...J)}h(ae,J,...z){if(!ae)return!1;const j=z.length>0;return!!((!j||z.includes(1))&&(this.d.value.get(ae)||J.includeChildren&&this.d.value.findSuperstr(ae))||(!j||z.includes(0))&&(this.f.value.get(ae)||J.includeChildren&&this.f.value.findSuperstr(ae))||(!j||z.includes(2))&&(this.g.value.findSubstr(ae)||J.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$6k=F;function q(ee,ae,J){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==N.sep&&(ae+=N.sep),J?(0,L.$lf)(ee,ae):ee.indexOf(ae)===0)}class Z extends Error{constructor(ae,J,z){super(ae),this.fileOperationResult=J,this.options=z}}e.$8k=Z;class X extends Z{constructor(ae,J,z,j){super(ae,J,j),this.fileOperationResult=J,this.size=z}}e.$9k=X;class x extends Z{constructor(ae,J,z){super(ae,2,z),this.stat=J}}e.$0k=x;var W;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$$k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$_k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$al="files.associations",e.$bl="files.exclude",e.$cl="files.readonlyInclude",e.$dl="files.readonlyExclude",e.$el="files.readonlyFromPermissions";var K;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$fl="";function V(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function H(ee,ae){if(!ae.hasProvider(O.URI.from({scheme:ee.scheme})))return new Promise(J=>{const z=ae.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===ee.scheme&&j.added&&(z.dispose(),J())})})}class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,A.$Xf)(ae)||(ae=0),ae<te.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,R.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,R.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,R.localize)(4,null,(ae/te.GB).toFixed(2)):(0,R.localize)(5,null,(ae/te.TB).toFixed(2))}}e.$il=te;function re(ee){const ae=typeof ee=="string"||ee?.scheme===C.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===C.Schemas.file?1024*te.MB:ae?10*te.MB:g.$o?50*te.MB:1024*te.MB}});var Q=this&&this.__param||function(se,e){return function(I,N){e(I,N,se)}};define(le[193],he([0,1,73,47,12]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const k=(0,I.createHash)("sha256");(0,N.$le)(P,{onData:w=>k.update(w.buffer),onError:w=>C(w),onEnd:()=>g(k.digest("base64").replace(/=+$/,""))})})}};e.$Qbc=A,e.$Qbc=A=ye([Q(0,L.$Mk)],A)}),define(le[97],he([0,1,14,7,163,12]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=O;async function O(C,k,w,f,u,b){let $;try{await R(C,k,w,f,u,b)}catch(l){$=l}finally{$&&u.errorTransformer&&($=u.errorTransformer($)),typeof $<"u"&&w.error($),w.end()}}async function R(C,k,w,f,u,b){P(b);const $=await C.open(k,{create:!1});try{P(b);let l=0,d=0,h=u&&typeof u.length=="number"?u.length:void 0,c=I.$te.alloc(Math.min(u.bufferSize,typeof h=="number"?h:u.bufferSize)),m=u&&typeof u.position=="number"?u.position:0,i=0;do d=await C.read($,m,c.buffer,i,c.byteLength-i),m+=d,i+=d,l+=d,typeof h=="number"&&(h-=d),i===c.byteLength&&(await w.write(f(c)),c=I.$te.alloc(Math.min(u.bufferSize,typeof h=="number"?h:u.bufferSize)),i=0);while(d>0&&(typeof h!="number"||h>0)&&P(b)&&g(l,u));if(i>0){let o=i;typeof h=="number"&&(o=Math.min(i,h)),w.write(f(c.slice(0,o)))}}catch(l){throw(0,A.$1k)(l)}finally{await C.close($)}}function P(C){if(C.isCancellationRequested)throw(0,N.$6)();return!0}function g(C,k){if(typeof k?.limits?.size=="number"&&C>k.limits.size)throw(0,A.$Zk)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[51],he([0,1,90,2,15,5,10,12]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0,e.$tq=P,e.$xq=w,e.$yq=f,e.$zq=u,e.$Aq=b;function P(l){return l.recursive===!0}class g extends N.$Tc{static{this.a=5}constructor(d,h,c,m){super(),this.h=d,this.j=h,this.m=c,this.n=m,this.c=this.B(new N.$Uc),this.f=void 0,this.g=0}s(){const d=new N.$Sc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(h=>this.h(h))),d.add(this.b.onDidLogMessage(h=>this.j(h))),d.add(this.b.onDidError(h=>this.t(h)))}t(d){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$uq=g;class C extends g{constructor(d,h,c){super(d,h,c,{type:"node.js",restartOnError:!1})}}e.$vq=C;class k extends g{constructor(d,h,c){super(d,h,c,{type:"universal",restartOnError:!0})}}e.$wq=k;function w(l){return l.map(d=>({type:d.type,resource:O.URI.revive(d.resource),cId:d.cId}))}function f(l){const d=new $;for(const h of l)d.processEvent(h);return d.coalesce()}function u(l,d){return typeof d=="string"&&!d.startsWith(I.$9j)&&!(0,L.$ic)(d)?{base:l,pattern:d}:d}function b(l,d){const h=[];for(const c of d)h.push((0,I.$ak)(u(l,c)));return h}class ${constructor(){this.a=new Set,this.b=new Map}c(d){return A.$k?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const h=this.b.get(this.c(d));let c=!1;if(h){const m=h.type,i=d.type;h.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?c=!0:m===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(h)):m===2&&i===1?h.type=0:m===1&&i===0||(h.type=i)}else c=!0;c&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],h=[];return Array.from(this.a).filter(c=>c.type!==2?(d.push(c),!1):!0).sort((c,m)=>c.resource.fsPath.length-m.resource.fsPath.length).filter(c=>h.some(m=>(0,R.$7k)(c.resource.fsPath,m,!A.$k))?!1:(h.push(c.resource.fsPath),!0)).concat(d)}}}),define(le[194],he([0,1,14,38,7,3,2,47,32,12,51]),function(se,e,I,N,L,A,O,R,P,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=e.$DP=void 0,e.$DP="localFilesystem";class k extends O.$Tc{constructor(f,u){super(),this.a=f,this.b=u,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$6d),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$6d),this.onDidWatchError=this.g.event,this.h=(0,P.$Cg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,u){const{buffer:b}=await this.a.call("readFile",[f,u]);return b}readFileStream(f,u,b){const $=(0,R.$he)(d=>I.$te.concat(d.map(h=>I.$te.wrap(h))).buffer),l=new O.$Sc;return l.add(this.a.listen("readFileStream",[f,u])(d=>{if(d instanceof I.$te)$.write(d.buffer);else{if(d==="end")$.end();else{let h;if(d instanceof Error)h=d;else{const c=d;h=(0,g.$Zk)(c.message??(0,N.$4i)(c),c.code??g.FileSystemProviderErrorCode.Unknown)}$.error(h),$.end()}l.dispose()}})),l.add(b.onCancellationRequested(()=>{$.error((0,L.$6)()),$.end(),l.dispose()})),$}writeFile(f,u,b){return this.a.call("writeFile",[f,I.$te.wrap(u),b])}open(f,u){return this.a.call("open",[f,u])}close(f){return this.a.call("close",[f])}async read(f,u,b,$,l){const[d,h]=await this.a.call("read",[f,u,l]);return b.set(d.buffer.slice(0,h),$),h}write(f,u,b,$,l){return this.a.call("write",[f,u,I.$te.wrap(b),$,l])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,u){return this.a.call("delete",[f,u])}rename(f,u,b){return this.a.call("rename",[f,u,b])}copy(f,u,b){return this.a.call("copy",[f,u,b])}cloneFile(f,u){return this.a.call("cloneFile",[f,u])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const u=f;this.f.fire((0,C.$xq)(u))}else{const u=f;this.g.fire(u)}}))}watch(f,u){const b=(0,P.$Cg)();return this.a.call("watch",[this.h,b,f,u]),(0,O.$Rc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$EP=k}),define(le[195],he([0,1,50,6,26,49,2,87,15,5,20,10,146,31,51]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,e.$Oq=$;class b extends O.$Tc{static{this.a=100}static{this.b=75}constructor(d,h,c,m){super(),this.m=d,this.n=h,this.r=c,this.s=m,this.c=this.B(new N.$vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new N.$uh(i=>this.z(i),b.b)),this.g=(0,u.$Aq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,u.$Aq)(this.m.path,this.m.includes):void 0,this.j=new L.$de,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await f.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await f.Promises.realpath(d.path),d.path===h&&(h=await(0,w.$Kq)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(g.$j&&(0,A.$gg)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Tc.None;const c=new L.$de(this.j.token),m=new O.$Sc;try{const i=k.URI.file(this.m.path),o=(0,P.$nc)(d),n=(0,I.watch)(d);m.add((0,O.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${d}'`);const s=new Set;if(h)try{for(const r of await f.Promises.readdir(d))s.add(r)}catch(r){this.D(r)}const t=new Map;m.add((0,O.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$j&&(v=(0,R.$Xl)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const y=setTimeout(async()=>{if(t.delete(v),v===o&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,P.$jc)(d,v));if(c.token.isCancellationRequested)return;let S;p?s.has(v)?S=0:(S=1,s.add(v)):(s.delete(v),S=2),this.y({resource:(0,C.$Tg)(i,v),type:S,cId:this.m.correlationId})},b.a);t.set(v,(0,O.$Rc)(()=>clearTimeout(y)))}else{let y;s.has(v)?y=0:(y=1,s.add(v)),this.y({resource:(0,C.$Tg)(i,v),type:y,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const y=setTimeout(async()=>{const p=await f.Promises.exists(d);c.token.isCancellationRequested||(p?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),m.add(await this.w(d,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);m.clear(),m.add((0,O.$Rc)(()=>clearTimeout(y)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(d)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,O.$Rc)(()=>{c.dispose(!0),m.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!h&&this.g.some(c=>c(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(c=>c(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const h=(0,u.$yq)(d);if(h.length>0){if(this.s)for(const m of h)this.G(` >> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(g.$k)return f.Promises.exists(d);try{const h=(0,P.$nc)(d);return(await f.Promises.readdir((0,P.$mc)(d))).some(m=>m===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Nq=b;async function $(l,d,h,c,m=512){const i=await f.Promises.open(l,"r"),o=Buffer.allocUnsafe(m),n=new L.$de(c);let s,t=!1;const r={path:l,excludes:[],recursive:!1},a=new b(r,v=>{(async()=>{for(const{type:y}of v)if(y===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:p}=await f.Promises.read(i,o,0,m,null);if(!p||n.token.isCancellationRequested)break;d(o.slice(0,p))}}catch(p){s=new Error(p),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,h(),new Promise((v,y)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await f.Promises.close(i)}catch(p){s=new Error(p)}s?y(s):v()})})}}),define(le[196],he([0,1,3,90,2,5,195]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class R extends L.$Tc{constructor(){super(...arguments),this.a=this.B(new I.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$6d),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),k=C.filter(f=>{const u=this.c.get(f.path);return u?!(0,N.$ek)(u.request.excludes,f.excludes)||!(0,N.$ek)(u.request.includes,f.includes):!0}),w=Array.from(this.c.values()).filter(({request:f})=>!C.find(u=>u.path===f.path&&(0,N.$ek)(u.excludes,f.excludes)&&(0,N.$ek)(u.includes,f.includes))).map(({request:f})=>f.path);k.length&&this.m(`Request to start watching: ${k.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const f of w)this.h(f);for(const f of k)this.g(f)}g(g){const C=new O.$Nq(g,w=>this.a.fire(w),w=>this.b.fire(w),this.f),k={request:g,instance:C};this.c.set(g.path,k)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const k of g){const w=A.$k?k.path:k.path.toLowerCase();let f=C.get(k.correlationId);f||(f=new Map,C.set(k.correlationId,f)),f.set(w,k)}return Array.from(C.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Pq=R}),define(le[197],he([0,1,51,196]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class L extends I.$vq{constructor(O,R,P){super(O,R,P),this.s()}r(O){return O.add(new N.$Pq)}}e.$Qq=L}),define(le[198],he([0,1,23,40,92,51]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class O extends A.$wq{constructor(P,g,C){super(P,g,C),this.s()}r(P){const g=P.add(new L.$Hq(I.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(g.onDidProcessExit(({code:C,signal:k})=>this.t(`terminated by itself with code ${C}, signal: ${k}`))),N.ProxyChannel.toService((0,N.$Zh)(g.getChannel("watcher")))}}e.$Iq=O}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class I{constructor(...L){this.a=new Map;for(const[A,O]of L)this.set(A,O)}set(L,A){const O=this.a.get(L);return this.a.set(L,A),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ei=I}),define(le[199],he([0,1,6,7,2,72,190,4,74,86]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;const C=!1;class k extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class w{constructor($=new P.$ei,l=!1,d,h=C){this.f=$,this.g=l,this.h=d,this.i=h,this.o=new Set,this.f.set(R.$fi,this),this._globalGraph=h?d?._globalGraph??new O.$Tq(c=>c):void 0}createChild($){return new w($,this.g,this,this.i)}invokeFunction($,...l){const d=u.traceInvocation(this.i,$);let h=!1;try{return $({get:m=>{if(h)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(m,d);if(!i)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...l)}finally{h=!0,d.stop()}}createInstance($,...l){let d,h;return $ instanceof A.$di?(d=u.traceCreation(this.i,$.ctor),h=this.j($.ctor,$.staticArguments.concat(l),d)):(d=u.traceCreation(this.i,$),h=this.j($,l,d)),d.stop(),h}j($,l=[],d){const h=R._util.getServiceDependencies($).sort((i,o)=>i.index-o.index),c=[];for(const i of h){const o=this.m(i.id,d);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const m=h.length>0?h[0].index:l.length;if(l.length!==m){console.trace(`[createInstance] First service dependency of ${$.name} at position ${m+1} conflicts with ${l.length} static arguments`);const i=m-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,m)}return Reflect.construct($,l.concat(c))}k($,l){if(this.f.get($)instanceof A.$di)this.f.set($,l);else if(this.h)this.h.k($,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const l=this.f.get($);return!l&&this.h?this.h.l($):l}m($,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const d=this.l($);return d instanceof A.$di?this.q($,d,l.branch($,!0)):(l.branch($,!1),d)}q($,l,d){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,l,d)}finally{this.o.delete($)}}r($,l,d){const h=new O.$Tq(i=>i.id.toString());let c=0;const m=[{id:$,desc:l,_trace:d}];for(;m.length;){const i=m.pop();if(h.lookupOrInsertNode(i),c++>1e3)throw new k(h);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.$di){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};h.insertEdge(i,s),m.push(s)}}}for(;;){const i=h.roots();if(i.length===0){if(!h.isEmpty())throw new k(h);break}for(const{data:o}of i){if(this.l(o.id)instanceof A.$di){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}h.removeNode(o)}}return this.l($)}s($,l,d=[],h,c){if(this.f.get($)instanceof A.$di)return this.t($,l,d,h,c);if(this.h)return this.h.s($,l,d,h,c);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t($,l,d=[],h,c){if(h){const m=new w(void 0,this.g,this,this.i);m.c=String($);const i=new Map,o=new I.$zh(()=>{const n=m.j(l,d,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$4c,i.set(s,a)),(y,p,S)=>{if(o.isInitialized)return o.value[s](y,p,S);{const E={listener:[y,p,S],disposable:void 0},D=a.push(E);return(0,L.$Rc)(()=>{D(),E.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,d,c)}u($,l){if(l&&console.warn($),this.g)throw new Error($)}}e.$Uq=w;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class u{static{this.all=new Set}static{this.c=new class extends u{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,l){return $?new u(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u.c}static traceCreation($,l){return $?new u(1,l.name):u.c}static{this.f=0}constructor($,l){this.type=$,this.name=l,this.g=Date.now(),this.h=[]}branch($,l){const d=new u(3,$.toString());return this.h.push([$,l,d]),d}stop(){const $=Date.now()-this.g;u.f+=$;let l=!1;function d(c,m){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of m.h)if(s&&t){l=!0,i.push(`${o}CREATES -> ${n}`);const r=d(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${u.f.toFixed(2)}ms)`];($>2||l)&&u.all.add(h.join(`
`))}}e.$Vq=u}),define(le[56],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0,e.$lbc=(0,I.$gi)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$mbc=N}),define(le[75],he([0,1,26,2,5,165,29,4]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0,e.$wr=P;function P(C){return C.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$xr=(0,R.$gi)("languagePackService");let g=class extends N.$Tc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new I.$de;setTimeout(()=>k.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const u=w.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some($=>$.startsWith("lp-"))).map(b=>{const $=b.properties.localizedLanguages?.[0],l=P(b);return{...this.f(l,$,b),extensionId:b.identifier.id,galleryExtension:b}});return u.push(this.f("en","English")),u}f(k,w,f){const u=w??k;let b;if(u!==k&&(b=`(${k})`),k.toLowerCase()===L.$w.toLowerCase()&&(b??="",b+=(0,A.localize)(0,null)),f?.installCount){b??="";const $=f.installCount;let l;$>1e6?l=`${Math.floor($/1e5)/10}M`:$>1e3?l=`${Math.floor($/1e3)}K`:l=String($),b+=` $(cloud-download) ${l}`}return{id:k,label:u,description:b}}};e.$yr=g,e.$yr=g=ye([Q(0,O.$Po)],g)}),define(le[200],he([0,1,2,75]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=void 0;let L=class extends I.$Tc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$Mbc=L,e.$Mbc=L=ye([Q(0,N.$xr)],L)}),define(le[8],he([0,1,166,38,3,54,2,35,5,20,13,10,93,4]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Pj=e.LogLevel=e.$Nj=e.$Mj=void 0,e.$Oj=b,e.log=l,e.$1j=a,e.$2j=v,e.$3j=y,e.$4j=p,e.$Mj=(0,f.$gi)("logService"),e.$Nj=(0,f.$gi)("loggerService");function u(){return new Date().toISOString()}function b(S){return(0,C.$Xf)(S)}var $;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})($||(e.LogLevel=$={})),e.$Pj=$.Info;function l(S,E,D){switch(E){case $.Trace:S.trace(D);break;case $.Debug:S.debug(D);break;case $.Info:S.info(D);break;case $.Warning:S.warn(D);break;case $.Error:S.error(D);break;case $.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function d(S,E=!1){let D="";for(let T=0;T<S.length;T++){let F=S[T];if(F instanceof Error&&(F=(0,N.$4i)(F,E)),typeof F=="object")try{F=JSON.stringify(F)}catch{}D+=(T>0?" ":"")+F}return D}class h extends O.$Tc{constructor(){super(...arguments),this.b=e.$Pj,this.c=this.B(new L.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==$.Off&&this.b<=E}}e.$Rj=h;class c extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...D){this.f($.Trace)&&this.g($.Trace,d([E,...D],!0))}debug(E,...D){this.f($.Debug)&&this.g($.Debug,d([E,...D]))}info(E,...D){this.f($.Info)&&this.g($.Info,d([E,...D]))}warn(E,...D){this.f($.Warning)&&this.g($.Warning,d([E,...D]))}error(E,...D){if(this.f($.Error))if(E instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=E.stack,this.g($.Error,d(T))}else this.g($.Error,d([E,...D]))}flush(){}}e.$Sj=c;class m extends h{constructor(E=e.$Pj){super(),this.setLevel(E),this.g=!P.$i}trace(E,...D){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...D):console.log(`[main ${u()}]`,E,...D))}debug(E,...D){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...D):console.log(`[main ${u()}]`,E,...D))}info(E,...D){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...D):console.log(`[main ${u()}]`,E,...D))}warn(E,...D){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...D):console.warn(`[main ${u()}]`,E,...D))}error(E,...D){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...D):console.error(`[main ${u()}]`,E,...D))}flush(){}}e.$Tj=m;class i extends h{constructor(E=e.$Pj,D=!0){super(),this.g=D,this.setLevel(E)}trace(E,...D){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...D):console.log(E,...D))}debug(E,...D){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...D):console.log(E,...D))}info(E,...D){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...D):console.log(E,...D))}warn(E,...D){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...D):console.log(E,...D))}error(E,...D){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...D):console.error(E,...D))}flush(){}}e.$Uj=i;class o extends h{constructor(E,D=e.$Pj){super(),this.g=E,this.setLevel(D)}trace(E,...D){this.f($.Trace)&&this.g.log($.Trace,[this.h(E),...D])}debug(E,...D){this.f($.Debug)&&this.g.log($.Debug,[this.h(E),...D])}info(E,...D){this.f($.Info)&&this.g.log($.Info,[this.h(E),...D])}warn(E,...D){this.f($.Warning)&&this.g.log($.Warning,[this.h(E),...D])}error(E,...D){this.f($.Error)&&this.g.log($.Error,[this.h(E),...D])}h(E){return typeof E=="string"?E:(0,N.$4i)(E,this.f($.Trace))}flush(){}}e.$Vj=o;class n extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const D of this.g)D.setLevel(E);super.setLevel(E)}trace(E,...D){for(const T of this.g)T.trace(E,...D)}debug(E,...D){for(const T of this.g)T.debug(E,...D)}info(E,...D){for(const T of this.g)T.info(E,...D)}warn(E,...D){for(const T of this.g)T.warn(E,...D)}error(E,...D){for(const T of this.g)T.error(E,...D)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$Wj=n;class s extends O.$Tc{constructor(E,D,T){if(super(),this.h=E,this.j=D,this.b=new R.$Ac,this.c=this.B(new L.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$6d),this.onDidChangeVisibility=this.g.event,T)for(const F of T)this.b.set(F.resource,{logger:void 0,info:F})}m(E){return(0,C.$Tf)(E)?[...this.b.values()].find(D=>D.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,D){const T=this.n(E),F=(0,C.$Tf)(E)?E:D?.id??(0,A.$7i)(T.toString()).toString(16);let q=this.b.get(T)?.logger;const Z=D?.logLevel==="always"?$.Trace:D?.logLevel;q||(q=this.s(T,Z??this.getLogLevel(T)??this.h,{...D,id:F}));const X={logger:q,info:{resource:T,id:F,logLevel:Z,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(X.info),this.b.set(T,X),q}n(E){return(0,C.$Tf)(E)?(0,g.$Tg)(this.j,`${E}.log`):E}setLogLevel(E,D){if(k.URI.isUri(E)){const T=E,F=D,q=this.b.get(T);q&&F!==q.info.logLevel&&(q.info.logLevel=F===this.h?void 0:F,q.logger?.setLevel(F),this.b.set(q.info.resource,q),this.f.fire([T,F]))}else{this.h=E;for(const[T,F]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,D){const T=this.m(E);T&&D!==!T.info.hidden&&(T.info.hidden=!D,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,D]))}getLogLevel(E){let D;return E&&(D=this.b.get(E)?.info.logLevel),D??this.h}registerLogger(E){const D=this.b.get(E.resource);D?D.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const D=this.b.get(E);D&&(D.logger&&D.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Xj=s;class t{constructor(){this.onDidChangeLogLevel=new L.$6d().event}setLevel(E){}getLevel(){return $.Info}trace(E,...D){}debug(E,...D){}info(E,...D){}warn(E,...D){}error(E,...D){}critical(E,...D){}dispose(){}flush(){}}e.$Yj=t;class r extends t{}e.$Zj=r;function a(S){if(S.verbose)return $.Trace;if(typeof S.logLevel=="string"){const E=p(S.logLevel.toLowerCase());if(E!==void 0)return E}return e.$Pj}function v(S){switch(S){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}function y(S){switch(S){case $.Trace:return{original:"Trace",value:I.localize(0,null)};case $.Debug:return{original:"Debug",value:I.localize(1,null)};case $.Info:return{original:"Info",value:I.localize(2,null)};case $.Warning:return{original:"Warning",value:I.localize(3,null)};case $.Error:return{original:"Error",value:I.localize(4,null)};case $.Off:return{original:"Off",value:I.localize(5,null)}}}function p(S){switch(S){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$5j=new w.$xj("logLevel",v($.Info))}),define(le[201],he([0,1,6,7,2,23,15,20,31,16,8]),function(se,e,I,N,L,A,O,R,P,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=void 0;let k=class extends L.$Tc{constructor(f,u){super(),this.a=f,this.b=u,this.B(new I.$sh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,R.$Qg)(this.a.logsHome),u=(0,R.$Sg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,l=(await P.Promises.readdir(u)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==f),d=l.slice(0,Math.max(0,l.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(h=>P.Promises.rm((0,O.$jc)(u,h)))))}catch(f){(0,N.$1)(f)}}};e.$Nbc=k,e.$Nbc=k=ye([Q(0,g.$ni),Q(1,C.$Mj)],k)}),define(le[98],he([0,1,7,4,8]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Vp=(0,N.$gi)("IExtensionSignatureVerificationService");let A=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,P)=>se(["@vscode/vsce-sign"],async g=>R(g),P))),this.a}async verify(R,P,g){let C;try{C=await this.c()}catch(k){return this.b.error("Could not load vsce-sign module",(0,I.$0)(k)),!1}return C.verify(R,P,g)}};e.$Wp=A,e.$Wp=A=ye([Q(0,L.$Mj)],A)}),define(le[202],he([0,1,17,6,7,3,2,15,51,8]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class C extends O.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new A.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$eh(0)),this.w=[],this.y=this.B(new N.$eh(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const u={path:this.H(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},b=(0,I.$Ub)(this.j,u);return this.r(),(0,O.$Rc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,L.$1)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,P.$xq)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,P.$tq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,P.$tq)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const u={path:this.H(w),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},b=(0,I.$Ub)(this.w,u);return this.C(),(0,O.$Rc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,L.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,P.$xq)(w)),w=>this.G(w),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,R.$hc)(w.fsPath)}}e.$Bq=C}),define(le[203],he([0,1,17,6,14,26,3,54,61,2,48,23,99,20,47,161,12,97,8,7]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;let m=class extends g.$Tc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$6d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$6d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$6d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$6d),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$6d),this.Y=this.B(new O.$6d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$6d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$ph)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${o}`);const s=new g.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new $.$6k(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,f.$Xg)(o))throw new $.$8k((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new h.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,$.$Sk)(n)||(0,$.$Pk)(n)||(0,$.$Tk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,$.$Sk)(n)||(0,$.$Pk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,$.$3k)(s)===$.FileSystemProviderErrorCode.FileNotFound?new $.$8k((0,b.localize)(2,null,this.sb(o)),1):(0,$.$1k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,y=await s.stat(o);let p;return this.t(s,o,y,void 0,!!v,(S,E)=>(p||(p=C.$mi.forUris(()=>!t),p.set(o,!0),r&&p.fill(!0,r)),p.get(S.resource)||p.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?E===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:v}=this.R(o),y={resource:n,name:v.basename(n),isFile:(s.type&$.FileType.File)!==0,isDirectory:(s.type&$.FileType.Directory)!==0,isSymbolicLink:(s.type&$.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&$.FilePermission.Locked),etag:(0,$.$gl)({mtime:s.mtime,size:s.size}),children:void 0};if(y.isDirectory&&a(y,t)){try{const p=await o.readdir(n),S=await N.Promises.settled(p.map(async([E,D])=>{try{const T=v.joinPath(n,E),F=r?await o.stat(T):{type:D};return await this.t(o,T,F,p.length,r,a)}catch(T){return this.b.trace(T),null}}));y.children=(0,I.$Hb)(S)}catch(p){this.b.trace(p),y.children=[]}return y}return y}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new $.$8k((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=L.$te.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new $.$5k(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,$.$Vk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...s,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let y;if((0,$.$Pk)(t)&&!(n instanceof L.$te))if((0,u.$fe)(n)){const p=await(0,u.$me)(n,3);p.ended?y=L.$te.concat(p.buffer):y=p}else y=(0,u.$je)(n,p=>L.$te.concat(p),3);else y=n;!(0,$.$Sk)(t)||(0,$.$Pk)(t)&&y instanceof L.$te||(0,$.$Pk)(t)&&(0,$.$Vk)(t)&&a?.atomic?await this.hb(t,o,a,y):await this.db(t,o,a,y instanceof L.$te?(0,L.$Ee)(y):y),this.r.fire(new $.$5k(o,4))}catch(v){throw new $.$8k((0,b.localize)(4,null,this.sb(o),(0,$.$1k)(v).toString()),(0,$.$4k)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&$.FileType.Directory)throw new $.$8k((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==$.$fl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,$.$gl)({mtime:s.mtime,size:a.size}))throw new $.$8k((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const v=await this.C(o,n,s,t);r(v)}catch(v){a(v)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,L.$Fe)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new A.$de(t);let a=s;(0,$.$Uk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const v=this.J(n,a).then(p=>p,p=>{throw r.dispose(!0),p});let y;try{return typeof a?.etag=="string"&&a.etag!==$.$fl&&await v,a?.atomic&&(0,$.$Uk)(o)||!((0,$.$Sk)(o)||(0,$.$Tk)(o))||(0,$.$Pk)(o)&&a?.preferUnbuffered?y=this.I(o,n,a):(0,$.$Tk)(o)?y=this.G(o,n,r.token,a):y=this.H(o,n,r.token,a),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await v,value:y}}catch(p){throw y&&await(0,u.$ke)(y),this.F(p,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,$.$1k)(o).toString());return o instanceof $.$0k?new $.$0k(t,o.stat,s):o instanceof $.$9k?new $.$9k(t,o.fileOperationResult,o.size,o.options):new $.$8k(t,(0,$.$4k)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,u.$qe)(r,{data:a=>a instanceof L.$te?a:L.$te.wrap(a),error:a=>this.F(a,n,t)},a=>L.$te.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,L.$Je)();return(0,l.$rq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,u.$he)(r=>L.$te.concat(r));return(async()=>{try{let r;s?.atomic&&(0,$.$Uk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(L.$te.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new $.$8k((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==$.$fl&&n.etag===s.etag)throw new $.$0k((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new $.$9k((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new $.$5k(o,a==="move"?2:3,v)),v}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new $.$5k(o,a==="copy"?3:2,v)),v}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:y}=await this.Q(o,n,s,t,r,a);if(v&&!y&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,$.$Qk)(o))await o.copy(n,t,{overwrite:a});else{const p=await this.resolve(n);p.isDirectory?await this.P(o,p,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,$.$Sk)(o)&&(0,$.$Sk)(s))return this.jb(o,n,s,t);if((0,$.$Sk)(o)&&(0,$.$Pk)(s))return this.pb(o,n,s,t);if((0,$.$Pk)(o)&&(0,$.$Sk)(s))return this.nb(o,n,s,t);if((0,$.$Pk)(o)&&(0,$.$Pk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let v=!1;if(o===s){const{providerExtUri:p,isPathCaseSensitive:S}=this.R(o);if(S||(v=p.isEqual(n,t)),v&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&p.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const y=await this.exists(t);if(y&&!v){if(!a)throw new $.$8k((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:p}=this.R(o);if(p.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?f.$Jg:f.$Lg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$5k(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&$.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,$.$3k)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,$.$3k)(a)!==$.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new $.$8k((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,$.$Wk)(s)&&!t?.atomic){const y=s.enforceAtomicDelete?.(o);y&&(t={...n,atomic:y})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new $.$5k(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,$.$Rk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,$.$Qk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Sc;let t=!1,r=()=>{t=!0};s.add((0,g.$Rc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,g.$Oc)(v):r=()=>(0,g.$Oc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=s.add(new O.$6d);return s.add(this.X.event(p=>{p.correlates(a)&&v.fire(p)})),{onDidChange:v.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$7i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,u.$fe)(t)||(0,u.$ge)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,$.$1k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,u.$ge)(s)){if(s.buffer.length>0){const a=L.$te.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,v)=>{(0,u.$le)(r,{onData:async y=>{r.pause();try{await this.gb(o,n,y,y.byteLength,t,0)}catch(p){return v(p)}t+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>v(y),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let v=0;for(;v<t;){const y=await o.write(n,r+v,s.buffer,a+v,t-v);v+=y}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof L.$te?r=t:(0,u.$fe)(t)?r=await(0,L.$Fe)(t):(0,u.$ge)(t)?r=await(0,L.$Ge)(t):r=(0,L.$De)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const v=L.$te.alloc(this.a);let y=0,p=0,S=0;do S=await o.read(r,y,v.buffer,p,v.byteLength-p),await this.gb(s,a,v,S,y,p),y+=S,p+=S,p===v.byteLength&&(p=0);while(S>0)}catch(v){throw(0,$.$1k)(v)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,L.$te.wrap(a),a.byteLength,0,0)}catch(a){throw(0,$.$1k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,L.$Fe)(this.H(o,n,A.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new $.$8k((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&$.FilePermission.Readonly)throw new $.$8k((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$sq=m,e.$sq=m=c=ye([Q(0,d.$Mj)],m)}),define(le[204],he([0,1,50,275,6,35,14,3,49,2,15,5,20,47,31,164,12,97,202,38,198,197]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,(()=>{try{(0,N.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$4i)(o)}`)}})();class i extends d.$Bq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new A.$Ac(t=>w.$Kg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await u.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await u.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,w.$Tg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=$.FileType.Unknown:n.isFile()?t=$.FileType.File:n.isDirectory()?t=$.FileType.Directory:t=$.FileType.Unknown,s&&(t|=$.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new L.$fh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await u.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,f.$he)(a=>O.$te.concat(a.map(v=>O.$te.wrap(v))).buffer);return(0,l.$rq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,w.$Tg)((0,w.$Sg)(n),`${(0,w.$Qg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await u.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Sc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(v){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await u.Promises.exists(v)){if(!t.overwrite)throw(0,$.$Zk)((0,b.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,$.$Zk)((0,b.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,$.$Nk)(s)&&!t&&(a=await this.O(n));let v;try{if((0,$.$Nk)(s)&&s.unlock)try{const{stat:p}=await u.SymlinkSupport.stat(r);p.mode&128||await u.Promises.chmod(r,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let y;if((0,$.$Nk)(s)){if(k.$i)try{await u.Promises.truncate(r,0),y="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}y||(y="w")}else y="r";v=await u.Promises.open(r,y)}catch(y){throw a?.dispose(),(0,$.$Nk)(s)?await this.gb(n,y):this.fb(y)}if(this.U.set(v,0),(0,$.$Nk)(s)&&this.X.set(v,n),a){const y=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),y.dispose())}return v}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await u.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await u.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const v=this.Z(n,s);let y=null;try{y=(await u.Promises.read(n,t,r,a,v)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(n,v,y)}return y}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,L.$Ah)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const v=this.Z(n,s);let y=null;try{y=(await u.Promises.write(n,t,r,a,v)).bytesWritten}catch(p){throw await this.gb(this.X.get(n),p)}finally{this.$(n,v,y)}return y}async mkdir(n){try{await u.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${s.atomic.postfix}`)),await u.Promises.rm(t,u.RimRafMode.MOVE,r)}else try{await u.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:y}=await u.SymlinkSupport.stat(t);a=v.isDirectory()&&!y}catch{}if(a)await u.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await u.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,b.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await u.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,b.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async bb(n,s,t,r){const a=this.H(n),v=this.H(s);let y=!1;if(!!(this.capabilities&1024)||(y=(0,P.$fg)(a,v,!0)),y){if(t==="copy")throw(0,$.$Zk)((0,b.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const S=await this.L(n);if(!S)throw(0,$.$Zk)((0,b.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const E=await this.L(s);if(E){if(!r)throw(0,$.$Zk)((0,b.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);S.type&$.FileType.File&&E.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),v=!!(this.capabilities&1024);if((0,P.$fg)(r,a,!v))return;const y=new g.$Sc;try{y.add(await this.O(n)),y.add(await this.O(s)),t&&await u.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await u.Promises.copyFile(r,a)}catch(p){if(p.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(p)}finally{y.dispose()}}t(n,s,t){return new c.$Iq(r=>n(r),r=>s(r),t)}F(n,s,t){return new m.$Qq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof $.$Yk)return n;let s=n,t;switch(n.code){case"ENOENT":t=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=$.FileSystemProviderErrorCode.Unknown;break;default:t=$.FileSystemProviderErrorCode.Unknown}return(0,$.$Zk)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await u.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,$.$Zk)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Rq=i}),define(le[100],he([0,1,3,2,4,8]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0,e.$acc=(0,L.$gi)("sharedProcessLifecycleService");let O=class extends N.$Tc{constructor(P){super(),this.b=P,this.a=this.B(new I.$6d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$bcc=O,e.$bcc=O=ye([Q(0,A.$Mj)],O)}),define(le[205],he([0,1,10,3,8,2]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=void 0;class O extends L.$Xj{constructor(k,w,f,u,b){super(w,f,u),this.r=k,this.t=b,this.B(b.listen("onDidChangeLogLevel",k)($=>{(0,L.$Oj)($)?super.setLogLevel($):super.setLogLevel(I.URI.revive($[0]),$[1])})),this.B(b.listen("onDidChangeVisibility",k)(([$,l])=>super.setVisibility(I.URI.revive($),l))),this.B(b.listen("onDidChangeLoggers",k)(({added:$,removed:l})=>{for(const d of $)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of l)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new L.$Vj({log:(k,w)=>{this.t.call("consoleLog",[k,w])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,w){super.setLogLevel(k,w),this.t.call("setLogLevel",[k,w])}setVisibility(k,w){super.setVisibility(k,w),this.t.call("setVisibility",[this.n(k),w])}s(k,w,f){return new R(this.t,k,w,f,this.r)}static setLogLevel(k,w,f){return k.call("setLogLevel",[w,f])}}e.$Qr=O;class R extends L.$Sj{constructor(k,w,f,u,b){super(u?.logLevel==="always"),this.r=k,this.s=w,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[w,u,b]).then(()=>{this.u(this.n),this.m=!0})}g(k,w){const f=[[k,w]];this.m?this.u(f):this.n.push(...f)}u(k){this.r.call("log",[this.s,k])}}class P{constructor(k,w){this.a=k,this.b=w}listen(k,w){const f=this.b(k);switch(w){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,u=>({added:[...u.added].map(b=>this.c(b,f)),removed:[...u.removed].map(b=>this.c(b,f))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,u=>[f.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,u=>(0,L.$Oj)(u)?u:[f.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${w}`)}async call(k,w,f){const u=this.b(k);switch(w){case"setLogLevel":return(0,L.$Oj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(I.URI.revive(u.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,u)))}throw new Error(`Call not found: ${w}`)}c(k,w){return{...k,resource:w.transformOutgoingURI(k.resource)}}}e.$Rr=P;class g extends A.$Tc{constructor(k,w){super(),w.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(f=>w.call("setLogLevel",[f]))),w.call("getRegisteredLoggers").then(f=>{for(const u of f)k.registerLogger({...u,resource:I.URI.revive(u.resource)})}),this.B(w.listen("onDidChangeVisibility")(([f,u])=>k.setVisibility(I.URI.revive(f),u))),this.B(w.listen("onDidChangeLoggers")(({added:f,removed:u})=>{for(const b of f)k.registerLogger({...b,resource:I.URI.revive(b.resource)});for(const b of u)k.deregisterLogger(b.resource)}))}}e.$Sr=g}),define(le[206],he([0,1,2,8]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class L extends I.$Tc{constructor(O,R=[]){super(),this.a=new N.$Wj([O,...R]),this.B(O.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$VP=L}),define(le[57],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=void 0,e.$9_b=(0,I.$gi)("nativeHostService")}),define(le[207],he([0,1,40,56]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;let L=class{constructor(O,R){return this.windowId=O,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const P=new Map;return P.set("windowId",O),P})()})}};e.$rbc=L,e.$rbc=L=ye([Q(1,N.$lbc)],L)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=e.$1n=void 0,e.$1n=(0,A.$gi)("policy");class O extends L.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$6d),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),N.Iterable.reduce(this.g.entries(),(k,[w,f])=>({...k,[w]:f}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(g,[C,k])=>({...g,[C]:{definition:k,value:this.g.get(C)}}),{})}}e.$2n=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$3n=R}),define(le[208],he([0,1,3,2,58]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=e.$Tac=void 0;class A{constructor(P){this.b=P,this.a=new N.$Sc}listen(P,g){switch(g){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((k,w)=>({...k,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(P,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$Tac=A;class O extends L.$2n{constructor(P,g){super(),this.a=g;for(const C in P){const{definition:k,value:w}=P[C];this.f[C]=k,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const k in C){const w=C[k];w===null?this.g.delete(k):this.g.set(k,w)}this.h.fire(Object.keys(C))})}async j(P){const g=await this.a.call("updatePolicyDefinitions",P);for(const C in g)this.g.set(C,g[C])}}e.$Uac=O}),define(le[101],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(le[24],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=void 0,e.$6j=(0,I.$gi)("productService"),e.$7j="vscode://schemas/vscode-product"}),define(le[209],he([0,1,6,7,2,15,31,8,24]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;let g=class extends L.$Tc{constructor(k,w,f){super(),this.b=w,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,k&&this.B(new I.$sh(()=>{this.f(k)},3e4)).schedule()}async f(k){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),f=(0,A.$mc)(k),u=(0,A.$nc)(k),b=await O.Promises.readdir(f);await Promise.all(b.map(async $=>{if($===u)return;const l=(0,A.$jc)(f,$),d=await O.Promises.stat(l);if(d.isDirectory()&&w-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${$}.`),O.Promises.rm(l)}))}catch(w){(0,N.$1)(w)}}};e.$Kbc=g,e.$Kbc=g=ye([Q(1,P.$6j),Q(2,R.$Mj)],g)}),define(le[210],he([0,1,6,7,2,15,31,16,8,24]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=void 0;let C=class extends L.$Tc{constructor(w,f,u){super(),this.b=w,this.c=f,this.f=u,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$sh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),f=JSON.parse(await O.Promises.readFile((0,A.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(f)){const h=f[d];w[`${h.hash}.${d}`]=!0}const u=(0,A.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(u))return;const $=await O.Promises.readdir(u);for(const d of $){if(w[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,A.$jc)(u,d))}const l=Date.now();for(const d of Object.keys(w)){const h=(0,A.$jc)(u,d),c=await O.Promises.readdir(h);for(const m of c){if(m==="tcf.json")continue;const i=(0,A.$jc)(h,m),o=await O.Promises.stat(i);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$jc)(d,m)}`),await O.Promises.rm(i))}}}catch(w){(0,N.$1)(w)}}};e.$Lbc=C,e.$Lbc=C=ye([Q(0,R.$oi),Q(1,P.$Mj),Q(2,g.$6j)],C)}),define(le[211],he([0,1,15,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$JF=void 0,e.$JF=(0,N.$gi)("IV8InspectProfilingService");var L;(function(A){function O(P){return!!(P.samples&&P.timeDeltas)}A.isValidProfile=O;function R(P,g="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,I.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$jc)(g,(0,I.$nc)(C.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(L||(e.Utils=L={}))}),define(le[212],he([0,1,32]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((g,C)=>{se(["v8-inspect-profiler"],g,C)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,I.$Cg)();return this.a.set(P,R),P}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const R=await O.stop();return this.a.delete(A),R.profile}}e.$3bc=N}),define(le[41],he([0,1,127,13]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0;class L{constructor(){this.a=new Map}add(O,R){I.ok(N.$Tf(O)),I.ok(N.$Vf(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$Yn=new L}),define(le[102],he([0,1,3,41]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0,e.$Zn={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new I.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,g){this.a[L(P)]=g,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$Yn.add(e.$Zn.JSONContribution,O)}),define(le[44],he([0,1,17,3,13,151,21,102,41]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.ConfigurationScope=e.$4n=e.EditPresentationTypes=void 0,e.$co=b,e.$do=$,e.$eo=l,e.$fo=h,e.$go=c;var g;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$4n={Configuration:"base.contributions.configuration"};var C;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n="vscode://schemas/settings/resourceLanguage",e.$_n="vscode://schemas/settings/configurationDefaults";const k=P.$Yn.as(R.$Zn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$6d,this.onDidSchemaChange=this.i.event,this.j=new N.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$$n,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),k.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),k.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),k.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$bo.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const E of Object.keys(s[r]))v.set(E,t);const y={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:y,valuesSources:v});const p=(0,O.$Wi)(r),S={type:"object",default:y,description:A.localize(1,null,p),$ref:e.$$n,defaultDefaultValue:y,source:L.$Tf(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=S,this.b.properties[r]=S}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=L.$Tf(s)?s:s?.id,v=L.$Tf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$bo.test(t))delete this.d[t],delete this.b.properties[t];else{const y=this.d[t];y&&(this.w(t,y),this.r(t,y))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=L.$3f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const y in a){const p=a[y];if(o&&h(y,p)){delete a[y];continue}if(p.source=n,p.defaultDefaultValue=a[y].default,this.w(y,p),e.$bo.test(y)?p.scope=void 0:(p.scope=L.$3f(p.scope)?t:p.scope,p.restricted=L.$3f(p.restricted)?!!s?.includes(y):p.restricted),a[y].hasOwnProperty("included")&&!a[y].included){this.f[y]=a[y],delete a[y];continue}else this.d[y]=a[y],a[y].policy?.name&&this.e.set(a[y].policy.name,y);!a[y].deprecationMessage&&a[y].markdownDeprecationMessage&&(a[y].deprecationMessage=a[y].markdownDeprecationMessage),r.add(y)}const v=i.allOf;if(v)for(const y of v)this.p(y,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$5n.properties[i]=o,o.scope){case 1:e.$6n.properties[i]=o;break;case 2:e.$7n.properties[i]=o;break;case 6:e.$8n.properties[i]=o;break;case 3:e.$9n.properties[i]=o;break;case 4:e.$0n.properties[i]=o;break;case 5:e.$0n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$5n.properties[i],o.scope){case 1:delete e.$6n.properties[i];break;case 2:delete e.$7n.properties[i];break;case 6:delete e.$8n.properties[i];break;case 3:delete e.$9n.properties[i];break;case 4:case 5:delete e.$0n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$$n};this.w(o,n),e.$5n.properties[o]=n,e.$6n.properties[o]=n,e.$7n.properties[o]=n,e.$8n.properties[o]=n,e.$9n.properties[o]=n,e.$0n.properties[o]=n}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$$n};e.$5n.patternProperties[e.$ao]=i,e.$6n.patternProperties[e.$ao]=i,e.$7n.patternProperties[e.$ao]=i,e.$8n.patternProperties[e.$ao]=i,e.$9n.patternProperties[e.$ao]=i,e.$0n.patternProperties[e.$ao]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;L.$1f(s)&&(s=o.defaultDefaultValue,t=void 0),L.$1f(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",u=new RegExp(f,"g");e.$ao=`^(${f})+$`,e.$bo=new RegExp(e.$ao);function b(m){const i=[];if(e.$bo.test(m)){let o=u.exec(m);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=u.exec(m)}}return(0,I.$Mb)(i)}function $(m){return m.reduce((i,o)=>`${i}[${o}]`,"")}function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new w;P.$Yn.add(e.$4n.Configuration,d);function h(m,i){return m.trim()?e.$bo.test(m)?A.localize(7,null,m):d.getConfigurationProperties()[m]!==void 0?A.localize(8,null,m):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,m,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function c(){const m=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))m.push([o,i[o].scope]);return m.push(["launch",4]),m.push(["task",4]),m}}),define(le[76],he([0,1,17,3,34,2,35,30,13,10,21,44,41]),function(se,e,I,N,L,A,O,R,P,g,C,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$ko=e.$jo=e.$io=e.$ho=void 0,e.$lo=h;function f(o){return Object.isFrozen(o)?o:R.$Nn(o)}class u{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof u)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Ui)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return f(t.rawConfiguration.getValue(n))},get override(){return s?f(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return f(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:v,keys:y}of t.rawConfiguration.overrides){const p=new u(a,y).getValue(n);p!==void 0&&r.push({identifiers:v,value:p})}return r.length?f(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Ui)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return I.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Mn(this.contents),t=R.$Mn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(s,v.contents);for(const y of v.overrides){const[p]=t.filter(S=>I.$ub(S.identifiers,y.identifiers));p?(this.h(p.contents,y.contents),p.keys.push(...y.keys),p.keys=I.$Mb(p.keys)):t.push(R.$Mn(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new u(s,r,t,a.every(v=>v instanceof u)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const v=s[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$Mn(a),this.h(a,v)):a=v),t[r]=a}return new u(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&P.$Vf(n[t])&&P.$Vf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Mn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Mn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Ti)(this.contents,n),k.$bo.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,k.$co)(n))),1))}j(n,s,t){(0,C.$Si)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),k.$bo.test(n)&&this.overrides.push({identifiers:(0,k.$co)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Ri)(this.contents[n],r=>console.error(r))})}}e.$ho=u;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new u}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!P.$3f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:y}=this.h(n,s);this.b=new u(t,r,a,y?[n]:void 0),this.c=v||[]}g(n){let s={},t=null,r=[];const a=[],v=[];function y(S){Array.isArray(r)?r.push(S):t!==null&&(r[t]=S)}const p={onObjectBegin:()=>{const S={};y(S),a.push(r),r=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];y(S),a.push(r),r=S,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:y,onError:(S,E,D)=>{v.push({error:S,offset:E,length:D})}};if(n)try{L.$An(n,p),s=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return s}h(n,s){const t=w.$Yn.as(k.$4n.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Ri)(n,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),v=Object.keys(n),y=this.j(n,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:a,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},y=[];for(const p in n)if(k.$bo.test(p)&&t){const S=this.i(n[p],s,!1,r);v[p]=S.raw,a=a||S.hasExcludedProperties,y.push(...S.restricted)}else{const S=s[p],E=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&y.push(p),!r.exclude?.includes(p)&&(r.include?.includes(p)||(E===void 0||r.scopes===void 0||r.scopes.includes(E))&&!(r.skipRestricted&&S?.restricted))?v[p]=n[p]:a=!0}return{raw:v,restricted:y,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(k.$bo.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,k.$co)(r),keys:Object.keys(a),contents:(0,C.$Ri)(a,s)})}return t}}e.$io=b;class $ extends A.$Tc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new N.$6d),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new u}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$jo=$;class l{constructor(n,s,t,r,a,v,y,p,S,E,D,T,F){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=y,this.h=p,this.i=S,this.j=E,this.k=D,this.l=T,this.m=F}get value(){return f(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(n,s,t,r,a=new u,v=new u,y=new O.$Ac,p=new u,S=new O.$Ac){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=v,this.j=y,this.l=p,this.m=S,this.a=null,this.b=new O.$Ac,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new u,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),v=s.resource?this.m.get(s.resource)||this.l:this.l,y=new Set;for(const p of r.overrides)for(const S of p.identifiers)r.getOverrideValue(n,S)!==void 0&&y.add(S);return new l(n,s,r.getValue(n),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:v}=m(this.c,n);s=[...r,...a,...v]}for(const r of s)for(const a of(0,k.$co)(r)){const v=this.c.getKeysForOverrideIdentifier(a),y=n.getKeysForOverrideIdentifier(a),p=[...y.filter(S=>v.indexOf(S)===-1),...v.filter(S=>y.indexOf(S)===-1),...v.filter(S=>!R.$Qn(this.c.override(a).getValue(S),n.override(a).getValue(S)))];t.push([a,p])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=m(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.applicationConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.localUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.remoteUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.workspaceConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:y}=m(t,s),p=[...r,...a,...v];return(p.length||!t)&&this.updateFolderConfiguration(n,s),{keys:p,overrides:y}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=m(s,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),y=n.folders.reduce((p,S)=>(p.set(g.URI.revive(S[0]),this.w(S[1])),p),new O.$Ac);return new d(s,t,r,a,new u,v,y,new u,new O.$Ac)}static w(n){return new u(n.contents,n.keys,n.overrides)}}e.$ko=d;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const y=(0,O.$xc)(s,a,new Set);v.forEach(p=>y.add(p))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(s){const y=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,p=this.g.getValue(n,s,this.h);return!R.$Qn(y,p)}return!0}}e.$mo=c;function m(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const p=y.filter(S=>!v.includes(S));for(const S of p)a.push([S,n.getKeysForOverrideIdentifier(S)])}if(o){const p=v.filter(S=>!y.includes(S));for(const S of p)a.push([S,o.getKeysForOverrideIdentifier(S)])}if(n&&o){for(const p of v)if(y.includes(p)){const S=i({contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)},{contents:n.getOverrideValue(void 0,p)||{},keys:n.getKeysForOverrideIdentifier(p)});a.push([p,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$Ui)(n.contents,a),y=(0,C.$Ui)(o.contents,a);R.$Qn(v,y)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[213],he([0,1,17,3,2,30,13,76,44,8,58,41]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=void 0;class w extends L.$Tc{constructor(){super(...arguments),this.a=this.B(new N.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$ho}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$Yn.as(P.$4n.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:l})=>this.c(Array.from($),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,l){this.h($,k.$Yn.as(P.$4n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new R.$ho;const $=k.$Yn.as(P.$4n.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,l){const d=this.f();for(const h of $){const c=d[h],m=l[h];c!==void 0?this.b.addValue(h,c):m?this.b.addValue(h,m.default):this.b.removeValue(h)}}}e.$no=w;class f{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$ho}async initialize(){return this.configurationModel}}e.$oo=f;let u=class extends L.$Tc{get configurationModel(){return this.b}constructor($,l,d){super(),this.c=$,this.f=l,this.g=d,this.a=this.B(new N.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$ho}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const l={},d=[],h=k.$Yn.as(P.$4n.Configuration).getConfigurationProperties();for(const c of $){const m=h[c];if(!m){d.push(c);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}d.push(c),l[m.policy.name]={type:m.type}}}return(0,O.$7f)(l)||await this.f.updatePolicyDefinitions(l),d}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const l=k.$Yn.as(P.$4n.Configuration).getPolicyConfigurations(),d=(0,I.$Hb)($.map(h=>l.get(h)));this.m(d,!0)}m($,l){this.g.trace("PolicyConfiguration#update",$);const d=k.$Yn.as(P.$4n.Configuration).getConfigurationProperties(),h=[],c=this.b.isEmpty();for(const m of $){const i=d[m]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,A.$Qn)(this.b.getValue(m),o))&&h.push([m,o])}else this.b.getValue(m)!==void 0&&h.push([m,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const m=this.b;this.b=new R.$ho;for(const i of m.keys)this.b.setValue(i,m.getValue(i));for(const[i,o]of h)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);l&&this.a.fire(this.b)}}};e.$po=u,e.$po=u=ye([Q(1,C.$1n),Q(2,g.$Mj)],u)}),define(le[214],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,213,58]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0;class l extends P.$Tc{constructor(c,m,i,o){super(),this.m=c,this.h=this.B(new A.$6d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$no),this.c=i instanceof $.$3n?new b.$oo:this.B(new b.$po(this.b,i,o)),this.f=this.B(new f.$jo(this.m,{},k.$Kg,m)),this.a=new f.$ko(this.b.configurationModel,this.c.configurationModel,new f.$ho,new f.$ho),this.j=new d(c,m,this),this.g=this.B(new N.$sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,m,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$ko(c,m,new f.$ho,i)}getConfigurationData(){return this.a.toData()}getValue(c,m){const i=typeof c=="string"?c:void 0,o=(0,w.$Ni)(c)?c:(0,w.$Ni)(m)?m:{};return this.a.getValue(i,o,void 0)}async updateValue(c,m,i,o,n){const s=(0,w.$Oi)(i)?i:(0,w.$Ni)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,I.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,g.$Qn)(m,r.defaultValue)&&(m=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const v=s.overrideIdentifiers.sort(),y=this.a.localUserConfiguration.overrides.find(p=>(0,I.$ub)([...p.identifiers].sort(),v));y&&(s.overrideIdentifiers=y.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,u.$do)(s.overrideIdentifiers),c]:[c];await this.j.write(a,m),await this.reloadConfiguration()}inspect(c,m={}){return this.a.inspect(c,m,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const m=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,m,2)}r(c,m){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,m);this.t(o,i,7)}s(c){const m=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,m,7)}t(c,m,i){const o=new f.$mo(c,{data:m},this.a);o.source=i,this.h.fire(o)}}e.$qo=l;class d{constructor(c,m,i){this.b=c,this.c=m,this.d=i,this.a=new N.$nh}write(c,m){return this.a.queue(()=>this.e(c,m))}async e(c,m){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,O.$tn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,m);i=(0,R.$Ln)(i,n),await this.c.writeFile(this.b,L.$te.fromString(i))}f(c,m,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!m.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$In)(c,m,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const m=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});m&&typeof m=="string"&&m!=="auto"&&(c=m),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[215],he([0,1,14,3,2,68]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mtb=e.$Ktb=e.$Jtb=void 0,e.$Ltb=R;const O=(g,C,k)=>{const w=new Uint8Array(16);for(let b=0;b<16;b++)w[b]=Math.round(Math.random()*256);const f=(0,I.$Ne)(I.$te.wrap(w));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.$Jtb=O,e.$Ktb=I.$te.fromString(`\r
\r
`);async function R(g,C,k,w,f){g.write(I.$te.fromString((0,e.$Jtb)(C,k,w)));const u=new L.$Sc;try{return await new Promise((b,$)=>{let l;u.add(g.onData(d=>{l?l=I.$te.concat([l,d],l.byteLength+d.byteLength):l=d;const h=l.indexOf(e.$Ktb);if(h===-1)return;b(g),g.pauseData();const c=l.slice(h+e.$Ktb.byteLength);c.byteLength&&f.onData.fire(c)})),u.add(g.onClose(d=>$(d??new Error("socket closed")))),u.add(g.onEnd(()=>$(new Error("socket ended"))))})}catch(b){throw g.dispose(),b}finally{u.dispose()}}class P extends L.$Tc{constructor(C,k){super(),this.g=C,this.a=this.B(new N.$9d),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$6d),this.onDidDispose=this.b.event,this.f=!1,this.B(k.onData),this.B(k.onData.event(w=>this.a.fire(w))),this.onClose=this.B(k.onClose).event,this.onEnd=this.B(k.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,k){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,k)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Mtb=P}),define(le[216],he([0,1,7,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.RemoteAuthorityResolverErrorCode=e.$tl=e.$sl=e.RemoteConnectionType=e.$rl=void 0,e.$vl=g,e.$rl=(0,N.$gi)("remoteAuthorityResolverService");var L;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$sl=A;class O{constructor(k,w){this.host=k,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$tl=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class P extends I.$bb{static isNotAvailable(k){return k instanceof P&&k._code===R.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof P&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof P&&k._code===R.NoResolverFound}static isInvalidAuthority(k){return k instanceof P&&k._code===R.InvalidAuthority}static isHandled(k){return k instanceof P&&k.isHandled}constructor(k,w=R.Unknown,f){super(k),this._message=k,this._code=w,this._detail=f,this.isHandled=w===R.NotAvailable&&f===!0,Object.setPrototypeOf(this,P.prototype)}}e.$ul=P;function g(C){const k=C.indexOf("+");return k===-1?C:C.substring(0,k)}}),define(le[217],he([0,1,6,14,26,7,3,2,23,99,63,32,68,216]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Al=v,e.$Bl=y,e.$Cl=S;const u=30*1e3;var b;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function $(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(z){const j=new L.$de;return setTimeout(()=>j.cancel(),z),j.token}function d(z,j){if(z.isCancellationRequested||j.isCancellationRequested)return L.CancellationToken.Cancelled;const M=new L.$de;return z.onCancellationRequested(()=>M.cancel()),j.onCancellationRequested(()=>M.cancel()),M.token}class h{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new R.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$_g)(),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function c(z,j){const M=new h(j);return M.registerDisposable(z.onControlMessage(B=>{const U=JSON.parse(B.toString()),Y=H(U);Y?M.reject(Y):M.resolve(U)})),M.promise}function m(z,j,M,B,U,Y,_,ne){const G=new h(ne),ie=C.$2d.create(!1);return z.info(`Creating a socket (${_})...`),g.mark(`code/willCreateSocket/${Y}`),j.connect(M,B,U,_).then(ce=>{G.didTimeout?(g.mark(`code/didCreateSocketError/${Y}`),z.info(`Creating a socket (${_}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(g.mark(`code/didCreateSocketOK/${Y}`),z.info(`Creating a socket (${_}) was successful after ${ie.elapsed()} ms.`),G.resolve(ce))},ce=>{g.mark(`code/didCreateSocketError/${Y}`),z.info(`Creating a socket (${_}) returned an error after ${ie.elapsed()} ms.`),z.error(ce),G.reject(ce)}),G.promise}function i(z,j){const M=new h(j);return z.then(B=>{M.didTimeout||M.resolve(B)},B=>{M.didTimeout||M.reject(B)}),M.promise}async function o(z,j,M,B){const U=ae(z,j);z.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await m(z.logService,z.remoteSocketFactoryService,z.connectTo,P.$tg.getServerRootPath(),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,$(j),`renderer-${$(j)}-${z.reconnectionToken}`,B)}catch(ce){throw z.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let _,ne;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(Y,null),_=z.reconnectionProtocol,ne=!1):(_=new w.$7h({socket:Y}),ne=!0),z.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const G=await i(z.signService.createNewMessage((0,k.$Cg)()),B),ie={type:"auth",auth:z.connectionToken||"00000000000000000000",data:G.data};_.sendControl(N.$te.fromString(JSON.stringify(ie)));try{const ce=await c(_,d(B,l(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(z.logService.trace(`${U} 4/6. received SignRequest control message.`),!await i(z.signService.validate(G,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(z.signService.sign(ce.data),B),me={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:j};return M&&(me.args=M),z.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$te.fromString(JSON.stringify(me))),{protocol:_,ownsProtocol:ne}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${U} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${U} received error control message when negotiating connection. Error:`),z.logService.error(ce)),ne&&V(_),ce}}async function n(z,j,M,B){const U=Date.now(),Y=ae(z,j),{protocol:_,ownsProtocol:ne}=await o(z,j,M,B),G=new h(B);return G.registerDisposable(_.onControlMessage(ie=>{const ce=JSON.parse(ie.toString()),fe=H(ce);fe?(z.logService.error(`${Y} received error control message when negotiating connection. Error:`),z.logService.error(fe),ne&&V(_),G.reject(fe)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${J(U)}!`),G.resolve({protocol:_,firstMessage:ce}))})),G.promise}async function s(z,j){const{protocol:M}=await n(z,1,void 0,j);return{protocol:M}}async function t(z,j,M){const{protocol:B,firstMessage:U}=await n(z,2,j,M),Y=U&&U.debugPort;return{protocol:B,debugPort:Y}}async function r(z,j,M){const B=Date.now(),U=ae(z,3),{protocol:Y}=await o(z,3,j,M);return z.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${J(B)}!`),Y}async function a(z,j,M){const{connectTo:B,connectionToken:U}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:U,reconnectionToken:j,reconnectionProtocol:M,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function v(z,j,M){return p(z,async B=>{const{protocol:U}=await s(B,L.CancellationToken.None);return new W(z,j,M,B.reconnectionToken,U)})}async function y(z,j){return p(z,async M=>{const{protocol:B,debugPort:U}=await t(M,j,L.CancellationToken.None);return new K(z,j,M.reconnectionToken,B,U)})}async function p(z,j){for(let B=1;;B++)try{const U=(0,k.$Cg)(),Y=await a(z,U,null);return await j(Y)}catch(U){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(U);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(U),x.triggerPermanentFailure(0,0,f.$ul.isHandled(U)),U}}async function S(z,j,M){const B=await a(z,(0,k.$Cg)(),null);return await r(B,{host:j,port:M},L.CancellationToken.None)}function E(z){return(0,I.$6g)(j=>new Promise((M,B)=>{const U=setTimeout(M,z*1e3);j.onCancellationRequested(()=>{clearTimeout(U),M()})}))}var D;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(D||(e.PersistentConnectionEventType=D={}));class T{constructor(j,M){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.type=0}}e.$Dl=T;class F{constructor(j,M,B,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.durationSeconds=B,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.$El=F;class q{constructor(j,M,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=B,this.type=2}}e.$Fl=q;class Z{constructor(j,M,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=B,this.type=4}}e.$Gl=Z;class X{constructor(j,M,B,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=B,this.handled=U,this.type=3}}e.$Hl=X;class x extends R.$Tc{static triggerPermanentFailure(j,M,B){this._permanentFailure=!0,this.f=j,this.g=M,this.h=B,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(j=>j.y())}static debugPauseSocketWriting(){this.j.forEach(j=>j.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(j,M,B,U,Y){super(),this.t=j,this.u=M,this.reconnectionToken=B,this.protocol=U,this.w=Y,this.m=this.B(new O.$6d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(U.onSocketClose(_=>{const ne=ee(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ne} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ne} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ne} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(_=>{const ne=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Rc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const j=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const U=B<M.length?M[B]:M[M.length-1];try{if(U>0){const _=E(U);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,_)),this.u.logService.info(`${j} waiting for ${U} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${j} resolving connection...`);const Y=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${j} connecting to ${Y.connectTo}...`),await this.G(Y,l(u)),this.u.logService.info(`${j} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(f.$ul.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,A.$4)(Y)){this.u.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof f.$ul){this.u.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,f.$ul.isHandled(Y));break}this.u.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(j,M,B){this.w?x.triggerPermanentFailure(j,M,B):this.D(j,M,B)}D(j,M,B){this.m.fire(new X(this.reconnectionToken,j,M,B)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Il=x;class W extends x{constructor(j,M,B,U,Y){super(1,j,U,Y,!0),this.client=this.B(new w.$5h(Y,{remoteAuthority:M,clientId:B},j.ipcLogger))}async G(j,M){await s(j,M)}}e.$Jl=W;class K extends x{constructor(j,M,B,U,Y){super(2,j,B,U,!1),this.H=M,this.debugPort=Y}async G(j,M){await t(j,this.H,M)}}e.$Kl=K;function V(z){try{z.acceptDisconnect();const j=z.getSocket();z.dispose(),j.dispose()}catch(j){(0,A.$1)(j)}}function H(z){if(z&&z.type==="error"){const j=new Error(`Connection error: ${z.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function te(z,j){for(;z.length<j;)z+=" ";return z}function re(z,j){return`[remote-connection][${te($(z),13)}][${j.substr(0,5)}\u2026]`}function ee(z,j,M){return`${re(z,j)}[${M?"reconnect":"initial"}]`}function ae(z,j){return`${ee(j,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function J(z){return`${Date.now()-z} ms`}}),define(le[103],he([0,1,23]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=N,e.$sm=L,e.$tm=A,e.$um=O;function N(P){return P.scheme===I.Schemas.vscodeRemote?P.authority:void 0}function L(P){if(!P)return;const g=P.indexOf("+");return g<0?P:P.substr(0,g)}function A(P){const{host:g,port:C}=R(P);if(typeof C>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:C}}function O(P,g){let{host:C,port:k}=R(P);return typeof k>"u"&&(k=g),{host:C,port:k}}function R(P){const g=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const C=P.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const k=P.match(/(.*):(\d+)$/);return k?{host:k[1],port:parseInt(k[2],10)}:{host:P,port:void 0}}}),define(le[45],he([0,1,27,4,103]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Dm=e.$Cm=e.$Bm=e.TargetPlatform=e.ExtensionType=e.$Am=e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$zm=A,e.$Em=k,e.$Fm=w,e.$Gm=f,e.$Hm=u,e.$vm="extensions.user.cache",e.$wm="extensions.builtin.cache",e.$xm="undefined_publisher",e.$ym=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class P{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,l){if(typeof $>"u"||$===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof $=="string"||typeof l=="string"){const d=typeof $=="string"?$:$.value,h=typeof l=="string"?l:l.value;return I.$kf(d,h)}return $._lower===l._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Bm=P;class g{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const l of $)this.add(l)}add($){this.c.add(P.toKey($))}delete($){return this.c.delete(P.toKey($))}has($){return this.c.has(P.toKey($))}}e.$Cm=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(P.toKey($))}get($){return this.c.get(P.toKey($))}has($){return this.c.has(P.toKey($))}set($,l){this.c.set(P.toKey($),l)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Dm=C;function k(b){return w(b)}function w(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function u(b,$){if($){const l=`onResolveRemoteAuthority:${(0,L.$sm)($)}`;return!!b.activationEvents?.includes(l)}return!1}e.$Im=(0,N.$gi)("IBuiltinExtensionsScannerService")}),define(le[218],he([0,1,2,45,12]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class A extends I.$Tc{constructor(R,P,g,C,k){super(),this.a=R,this.b=P,this.c=g,this.f=k,this.B(C.onDidInstallExtensions(w=>this.g(w))),this.B(C.onDidUninstallExtension(w=>this.h(w)))}g(R){for(const P of R)P.local&&this.invalidate(P.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,R)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$vm))}catch(P){(0,L.$4k)(P)!==1&&this.f.error(P)}}}e.$lq=A}),define(le[104],he([0,1,2,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=void 0,e.$wl=(0,N.$gi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Rc)(()=>{const P=this.a[O]?.indexOf(R);typeof P=="number"&&P>=0&&this.a[O]?.splice(P,1)})}b(O){return(this.a[O.type]||[]).find(P=>P.supports(O))}connect(O,R,P,g){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,P,g)}}e.$xl=L}),define(le[219],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=e.$Zbc=void 0,e.$Zbc=(0,I.$gi)("sharedProcessTunnelService"),e.$1bc="sharedProcessTunnel"}),define(le[105],he([0,1,4,167]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=e.$9bc=e.$8bc=e.$7bc=e.TunnelStates=e.$6bc=e.$5bc=void 0,e.$5bc=(0,I.$gi)("IRemoteTunnelService"),e.$6bc={active:!1};var L;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$7bc="remote.tunnels.access",e.$8bc=e.$7bc+".hostNameOverride",e.$9bc=e.$7bc+".preventSleep",e.$0bc="remoteTunnelService",e.$$bc=(0,N.localize)(0,null)}),define(le[59],he([0,1,14,7,2,169,44,4,8,41]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=void 0,e.$zp=w,e.$Ap=f,e.$Bp=u,e.$Cp=b,e.$Dp=$,e.$Ep=l,e.$xp=(0,R.$gi)("requestService");class C{constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?m[i]="*****":m[i]=this.b[i];this.a=m}return this.a}}class k extends L.$Tc{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,A.localize)(0,null),when:P.$5j.isEqualTo((0,P.$2j)(P.LogLevel.Trace)).serialize()})}async c(m,i,o){const n=`${m} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$0)(s)),s}}}e.$yp=k;function w(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function f(c){return c.res.statusCode===204}async function u(c){return f(c)?null:(await(0,I.$Fe)(c.stream)).toString()}async function b(c){if(!w(c))throw new Error("Server returned "+c.res.statusCode);return u(c)}async function $(c){if(!w(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const i=(await(0,I.$Fe)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function l(c){h(c)}let d;function h(c){const m=g.$Yn.as(O.$4n.Configuration),i=d;d={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},m.updateConfigurations({add:[d],remove:i?[i]:[]})}h(1)}),define(le[220],he([0,1,26,23,12,59]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=void 0;let O=class{constructor(P,g){this.a=P,this.b=g}async download(P,g,C=I.CancellationToken.None){if(P.scheme===N.Schemas.file||P.scheme===N.Schemas.vscodeRemote){await this.b.copy(P,g);return}const k={type:"GET",url:P.toString(!0)},w=await this.a.request(k,C);if(w.res.statusCode===200)await this.b.writeFile(g,w.stream);else{const f=await(0,A.$Cp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${f}`)}}};e.$$P=O,e.$$P=O=ye([Q(0,A.$xp),Q(1,L.$Mk)],O)}),define(le[221],he([0,1,14,26]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class L{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,g,C=N.CancellationToken.None){switch(P){case"request":return this.a.request(g[0],C).then(async({res:k,stream:w})=>{const f=await(0,I.$Fe)(w);return[{statusCode:k.statusCode,headers:k.headers},f]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Ar=L;class A{constructor(R){this.a=R}async request(R,P){const[g,C]=await this.a.call("request",[R],P);return{res:g,stream:(0,I.$He)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Br=A}),define(le[222],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.$sac=e.$rac=void 0,e.$rac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$sac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$tac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[223],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n9b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const O=String(I.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$n9b=I}),define(le[106],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl="signService",e.$zl=(0,I.$gi)(e.$yl)}),define(le[224],he([0,1,223]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;class N extends I.$n9b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>se(["vsda"],A,O))}}e.$hbc=N}),define(le[77],he([0,1,3,2]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Hb=e.$4Hb=e.$3Hb=e.$2Hb=void 0;class L extends N.$Tc{constructor(k,w,f){super(),this.a=k,this.b=w,this.c=f}async getItems(){const k={profile:this.b,workspace:this.c},w=await this.a.call("getItems",k);return new Map(w)}updateItems(k){const w={profile:this.b,workspace:this.c};return k.insert&&(w.insert=Array.from(k.insert.entries())),k.delete&&(w.delete=Array.from(k.delete.values())),this.a.call("updateItems",w)}optimize(){const k={profile:this.b,workspace:this.c};return this.a.call("optimize",k)}}class A extends L{constructor(k,w){super(k,w,void 0),this.f=this.B(new I.$6d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(k=>this.h(k)))}h(k){(Array.isArray(k.changed)||Array.isArray(k.deleted))&&this.f.fire({changed:k.changed?new Map(k.changed):void 0,deleted:k.deleted?new Set(k.deleted):void 0})}}class O extends A{constructor(k){super(k,void 0)}async close(){this.dispose()}}e.$2Hb=O;class R extends A{constructor(k,w){super(k,w)}async close(){this.dispose()}}e.$3Hb=R;class P extends L{constructor(k,w){super(k,void 0,w),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$4Hb=P;class g{constructor(k){this.a=k}isUsed(k){const w={payload:k,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$5Hb=g}),define(le[107],he([0,1,5,36,32]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=O,e.$1o=R;function A(P){if(I.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function O(P,g,C,k,w,f,u,b,$){const l=Object.create(null);l["common.machineId"]=f,l["common.sqmId"]=u,l.sessionID=(0,L.$Cg)()+Date.now(),l.commitHash=k,l.version=w,l["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,I.$h)(I.$u),l["common.nodePlatform"]=N.$dc,l["common.nodeArch"]=C,l["common.product"]=$||"desktop",b&&(l["common.msftInternal"]=b);let d=0;const h=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),I.$l&&(l["common.snap"]="true");const c=A(g);return c&&(l["common.platformDetail"]=c),l}function R(P){const g=N.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return P.some(k=>C===k)}}),define(le[22],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0,e.$Ll=(0,I.$gi)("telemetryService"),e.$Ml=(0,I.$gi)("customEndpointTelemetryService"),e.$Nl="telemetry.currentSessionDate",e.$Ol="telemetry.firstSessionDate",e.$Pl="telemetry.lastSessionDate",e.$Ql="telemetry.machineId",e.$Rl="telemetry.sqmId",e.$Sl="telemetry",e.$Tl="telemetry.telemetryLevel",e.$Ul="telemetry.enableCrashReporter",e.$Vl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(le[225],he([0,1,37,6,34,23,15,5,10,144,31,148,94,12,24,22]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0,e.$js=l,e.$ks=h,e.$ls=c;const $=new Map;async function l(i,o){const n=`${i}::${o.join(":")}`,s=$.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function y(S,E,D,T){const F=E.substring(S.length+1);return N.Promises.withAsyncBody(async q=>{let Z;try{Z=await C.Promises.readdir(E,{withFileTypes:!0})}catch{q();return}if(T.count>=v){T.count+=Z.length,T.maxReached=!0,q();return}let X=Z.length;if(X===0){q();return}let x=Z;T.count+Z.length>v&&(T.maxReached=!0,X=v-T.count,x=Z.slice(0,X)),T.count+=Z.length;for(const W of x)if(W.isDirectory()){if(D.includes(W.name)||await y(S,(0,O.$jc)(E,W.name),D,T),--X===0){q();return}}else{const K=W.name.lastIndexOf(".");if(K>=0){const V=W.name.substring(K+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(F)!==!1&&V.filePattern.test(W.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--X===0){q();return}}})}const p=N.Promises.withAsyncBody(async S=>{const E={count:0,maxReached:!1};await y(i,i,o,E);const D=await c(i);S({configFiles:d(a),fileTypes:d(r),fileCount:E.count,maxFilesReached:E.maxReached,launchConfigFiles:D})});return $.set(n,p),p}function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function h(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.$il.GB).toFixed(2)}GB (${(I.freemem()/f.$il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$on.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,O.$jc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,L.$tn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$Cn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return d(o)}catch{return[]}}let m=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/f.$il.GB).toFixed(2)}GB (${(I.freemem()/f.$il.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$on.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,k.$is)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(v=>{if((0,w.$1m)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const p=v.workspaceMetadata[y];let S=`${p.fileCount} files`;p.maxFilesReached&&(S=`more than ${S}`),r+=`|    Folder (${y}): ${S}`,r+=this.h(p)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=h(),v={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${I.loadavg().map(y=>Math.round(y)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const s=[];return(0,k.$is)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,w.$1m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),s.push(`Folder (${a}): ${y}`),s.push(this.h(v))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(p,S)=>{const E=` ${p}(${S})`;t+E.length>60?(n.push(a),a="|                 ",t=a.length):t+=E.length,a+=E};let a="|      File types:";const v=10,y=o.fileTypes.length>v?v:o.fileTypes.length;for(let p=0;p<y;p++){const S=o.fileTypes[p];r(S.name,S.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(p=>{r(p.name,p.count)}),n.push(a)),o.launchConfigFiles.length>0){let p="|      Launch Configs:";o.launchConfigFiles.forEach(S=>{const E=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;p+=E}),n.push(p)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===A.Schemas.file){const v=a.fsPath;s.push(l(v,["node_modules",".git"]).then(y=>{let p=`${y.fileCount} files`;y.maxFilesReached&&(p=`more than ${p}`),n.push(`|    Folder (${(0,O.$nc)(v)}): ${p}`),n.push(this.h(y))}).catch(y=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const y=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(y/f.$il.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(p=>this.n(o,n,s,p,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=P.URI.revive(s);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=P.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const t=s.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$ms=m,e.$ms=m=ye([Q(0,b.$Ll),Q(1,u.$6j)],m)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=void 0;class I{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:R,data:P}){return this.b.forEach(g=>g.log(R,P)),Promise.resolve(null)}}e.$wac=I;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$xac=N}),define(le[46],he([0,1,30,13,103,107,22]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=C,e.$0o=k,e.$$o=w,e.$_o=f,e.$ap=b,e.$bp=l,e.$cp=d,e.$dp=m;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$2o=R;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3o=P,e.$4o=new P;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$5o=g,e.$6o="telemetry",e.$7o="extensionTelemetryLog",e.$8o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function k(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function w(i){const o=i.getValue(O.$Tl),n=i.getValue(O.$Ul);if(i.getValue(O.$Vl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function f(i){const o={},n={},s={};$(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,L.$sm)(i);return u.has(o)?o:"other"}function $(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,I.$Rn)(r):r instanceof Date?o[a]=r.toISOString():(0,N.$Vf)(r)?n<2?$(r,o,n+1,a+"."):o[a]=(0,I.$Rn)(r):o[a]=r}}function l(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,A.$1o)(n)||s}function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function h(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const v of o)for(;;){const y=v.exec(i);if(!y)break;s.push([y.index,v.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const v=r.exec(i);if(!v)break;const y=s.some(([p,S])=>v.index<S&&p<r.lastIndex);!t.test(v[0])&&!y&&(n+=i.substring(a,v.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function m(i,o){return(0,I.$On)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=h(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(le[33],he([0,1,27,29,45,5,10,7,36,46]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$fp=void 0,e.$ep=C,e.$gp=u,e.$hp=b,e.$ip=$,e.$jp=l,e.$kp=d,e.$lp=h,e.$mp=c,e.$op=m,e.$pp=o;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$ff)(n.id,s.id)===0}const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,t,r)}static parse(s){const t=k.exec(s);return t&&t[1]&&t[2]?new w({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$fp=w;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(n){const s=f.exec(n);return s&&s[1]?[$(s[1]),s[2]]:[$(n),void 0]}function b(n,s){return`${n}.${s}`}function $(n){return n.toLowerCase()}function l(n,s){return $(b(n??L.$xm,s))}function d(n,s){const t=[],r=a=>{for(const v of t)if(v.some(y=>C(s(y),s(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new g.$2o(n.identifier.id),name:new g.$2o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$np=new L.$Bm("pprice.better-merge");function m(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(y=>C(y.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!A.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,N.$Lo)(t?"alpine":A.$u,P.$ec);return s.debug("ComputeTargetPlatform:",r),r}}),define(le[226],he([0,1,17,2,20,10,12,24,6,3,15,5,36,33]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=e.$u$b=void 0;let u=class extends N.$Tc{constructor(h,c){super(),this.b=h,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const c=[];for(const[m,i]of this.a)if(!(i.configScheme&&i.configScheme!==h.scheme))try{const o=(await this.b.readFile((0,L.$Tg)(h,m))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$u$b=u,e.$u$b=u=ye([Q(0,O.$Mk),Q(1,R.$6j)],u);const b="extensionTips/promptedExecutableTips",$="extensionTips/lastPromptedMediumImpExeTime";class l extends u{constructor(h,c,m,i,o,n,s,t){super(s,t),this.r=h,this.s=c,this.t=m,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],y=[],p=[];Object.entries(a.recommendations).forEach(([S,E])=>{E.important?a.important?v.push({extensionId:S,extensionName:E.name,isExtensionPack:!!E.isExtensionPack}):y.push({extensionId:S,extensionName:E.name,isExtensionPack:!!E.isExtensionPack}):p.push({extensionId:S,extensionName:E.name,isExtensionPack:!!E.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),p.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p})}),(0,P.$ih)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),c=await this.O(this.h);return[...h,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),c=await this.O(this.h),m=await this.u.getInstalled();this.m=this.D(h,m),this.n=this.D(c,m)}D(h,c){const m=new Map;h.forEach(t=>m.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...m.keys()],c);for(const t of i){const r=m.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=m.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=m.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[h,c]=[...this.m.entries()][0];this.H(c).then(m=>{switch(m){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new N.$Uc);i.value=(0,P.$ih)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),c=Date.now()-h,m=7*24*60*60*1e3;if(c<m){const n=this.B(new N.$Uc);n.value=(0,P.$ih)(()=>{n.dispose(),this.G()},m-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new N.$Uc);s.value=(0,P.$ih)(()=>{s.dispose(),this.G()},m);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Uc);s.value=(0,P.$ih)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const c=await this.u.getInstalled(1),m=h.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,f.$ep)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:m,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber($,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store($,h,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(h,c){const m=this.L();m[h]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify(m),-1,0)}N(h,c){const m=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{o.has(n.toLowerCase())?m.push(n):i.push(n)}),{installed:m,uninstalled:i}}async O(h){const c=[],m=new Map;for(const i of h.keys()){const o=h.get(i);if(!o||!(0,I.$Lb)(o.recommendations))continue;const n=[];k.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",i)),n.push((0,C.$jc)("/usr/bin",i)),n.push((0,C.$jc)(this.r.fsPath,i)));for(const s of n){let t=m.get(s);if(t===void 0&&(t=await this.b.exists(A.URI.file(s)),m.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:y}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:y})}}return c}}e.$v$b=l}),define(le[227],he([0,1,26,33]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s2b=L;async function L(A,O,R,P,g){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const k=await A.getInstalled(1);for(const[w,f]of Object.entries(C.deprecated)){if(!f?.extension)continue;const{id:u,autoMigrate:b,preRelease:$}=f.extension;if(!b)continue;const l=k.find(h=>(0,N.$ep)(h.identifier,{id:w}));if(!l)continue;const d=(await O.getExtensions([{id:u,preRelease:$}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!d){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${u}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${u}' extension...`);const h=!P.getDisabledExtensions().some(m=>(0,N.$ep)(m,l.identifier));await A.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let c=k.find(m=>(0,N.$ep)(m.identifier,{id:u}));(!c||!c.isPreReleaseVersion&&h)&&(c=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${c.identifier.id}'`),h||(await P.disableExtension(c.identifier),g.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),b.storage&&(R.addToMigrationList((0,N.$hp)(l.manifest.publisher,l.manifest.name),(0,N.$hp)(c.manifest.publisher,c.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${u}' extension.`)}catch(h){g.error(h)}}}catch(C){g.error(C)}}}),define(le[228],he([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,98,12,8]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;let c=class extends L.$Tc{static{h=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,O.$Tg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new u.$Qo(r.message,u.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${v.output}`),t===u.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===u.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(y){this.r.error(y)}throw new u.$Qo(k.$2p,u.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,P.$Zf)(o)?o:!0}async u(i){await this.g;const o=(0,O.$Tg)(this.extensionsDownloadDir,`${this.z(i)}${h.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new u.$Qo(n.message,u.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const s=(0,O.$Tg)(this.extensionsDownloadDir,`.${(0,g.$Cg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(h.c))s.push(a.resource);else{const v=b.$fp.parse(a.name);v&&n.push([v,a])}const t=(0,b.$kp)(n,([a])=>a),r=[];for(const a of t)a.sort((v,y)=>R.rcompare(v[0].version,y[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await I.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$fp.create(i).toString().toLowerCase():(0,g.$Cg)()}};e.$iq=c,e.$iq=c=h=ye([Q(0,f.$oi),Q(1,l.$Mk),Q(2,u.$Po),Q(3,w.$Mi),Q(4,$.$Vp),Q(5,d.$Mj)],c)}),define(le[229],he([0,1,3,2,35,33,45]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class R extends N.$Tc{constructor(g,C,k,w,f,u,b){super(),this.f=g,this.g=C,this.h=k,this.j=w,this.m=f,this.n=u,this.r=b,this.a=this.B(new I.$6d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$3c),this.s().then(null,$=>b.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,N.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const k=this.L(C.identifier,C.version);g.error?this.J(k,g.profileLocation):this.I(k,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],k=[];for(const w of g.extensions){const f=this.L(w.identifier,w.version);g.error?this.I(f,g.profileLocation):(this.J(f,g.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),k.push(this.f.scanInstalledExtensionAtLocation(w.location).then(u=>{u?C.push(u):this.r.info("Extension not found at the location",w.location.toString())},u=>this.r.error(u)))))}try{await Promise.all(k),C.length&&await this.H(C)}catch(w){this.r.error(w)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],k=[],w=await this.j.scanProfileExtensions(g),f=new Set,u=new Set;for(const[b,$]of this.b)$.has(g)&&u.add(b);for(const b of w){const $=this.L(b.identifier,b.version);f.add($),u.has($)||(C.push(b.identifier),this.I($,g))}for(const b of u)if(!f.has(b)){const $=this.M(b);$&&(k.push($.identifier),this.J(b,g))}(C.length||k.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:k.length?{extensions:k,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const k of C)this.I(this.L(k.identifier,k.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let k=this.b.get(g);k||this.b.set(g,k=new L.$Bc(w=>this.m.extUri.getComparisonKey(w))),k.add(C)}J(g,C){const k=this.b.get(g);k&&k.delete(C),k?.size||this.b.delete(g)}L(g,C){return`${O.$Bm.toKey(g.id)}@${C}`}M(g){const[C,k]=(0,A.$gp)(g);return k?{identifier:{id:C},version:k}:void 0}}e.$mq=R}),define(le[230],he([0,1,43,46]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=L;async function L(A,O,R,P,g,C,k){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$9o)(O,R)&&(0,N.$$o)(P)===3){const f=await(0,I.$Qp)(R,g,C);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=k.machineId||f}return w}}),define(le[231],he([0,1,73,17,6,2,23,15,31,16,29,33,8,75,10]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;let b=class extends f.$yr{constructor(h,c,m,i){super(m),this.h=h,this.j=i,this.g=this.B(new $(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(h,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[h];return o?u.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),c=Object.keys(h).map(m=>{const i=h[m];return{...this.f(m,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((m,i)=>m.label.localeCompare(i.label)),c}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const c=await this.g.getLanguagePacks();Object.keys(c).some(m=>c[m]&&c[m].extensions.some(i=>(0,k.$ep)(i.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),m=await this.g.update(c);return!(0,N.$ub)(Object.keys(h),Object.keys(m))}};e.$zr=b,e.$zr=b=ye([Q(0,C.$So),Q(1,g.$oi),Q(2,C.$Po),Q(3,w.$Mj)],b);let $=class extends A.$Tc{constructor(h,c){super(),this.j=c,this.c={},this.f=(0,R.$jc)(h.userDataPath,"languagepacks.json"),this.g=new L.$nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(c=>{Object.keys(c).forEach(m=>delete c[m]),this.m(c,...h)}).then(()=>this.c)}m(h,...c){for(const m of c)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.n(h,m);Object.keys(h).forEach(m=>this.r(h[m]))}n(h,c){const m=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===O.Schemas.file&&l(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},h[o.languageId]=n);const s=n.extensions.filter(t=>(0,k.$ep)(t.extensionIdentifier,m))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:m,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(c.location.fsPath,t.path)}}r(h){if(h){const c=(0,I.createHash)("md5");for(const m of h.extensions)c.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);h.hash=c.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let c=null;return P.Promises.readFile(this.f,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(c=h(m),m)).then(m=>{for(const o of Object.keys(m))m[o]||delete m[o];this.c=m,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),P.Promises.writeFile(this.f,i)}).then(()=>c,m=>this.j.error(m))})}};$=ye([Q(0,g.$oi),Q(1,w.$Mj)],$);function l(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const h of d.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(le[232],he([0,1,143,7,30,46]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function P(C,k,w){const f=await(0,I.$AD)("@microsoft/1ds-core-js","dist/ms.core.js"),u=await(0,I.$AD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new f.AppInsightsCore,$=new u.PostChannel,l={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(w){l.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};l.extensionConfig[$.identifier]=d}return b.initialize(l,[]),b.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',k&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),b}class g{constructor(k,w,f,u,b){this.e=k,this.f=w,this.g=f,this.h=b,this.c=O,this.d=R,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{k(w)},w=>{(0,N.$1)(w),console.error(w)})}}log(k,w){if(!this.a)return;w=(0,L.$Pn)(w,this.g),w=(0,A.$_o)(w);const f=this.f+"/"+k;try{this.i(u=>{u.pluginVersionString=w?.properties.version??"Unknown",u.track({name:f,baseData:{name:f,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$IP=g}),define(le[109],he([0,1,2,170,16,8,24,46]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=void 0;let P=class extends I.$Tc{constructor(C,k,w,f,u=""){super(),this.b=u;const b=k.getLogger(R.$6o);if(b)this.a=this.B(b);else{const l=(0,R.$0o)(f,w)?" (Not Sent)":"",d=()=>(0,R.$9o)(f,w)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(k.createLogger(R.$6o,{name:(0,N.localize)(0,null,l),hidden:!d()})),this.B(C.onDidChangeLogLevel(()=>k.setVisibility(R.$6o,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,k){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$_o)(k))}};e.$U0b=P,e.$U0b=P=ye([Q(0,A.$Mj),Q(1,A.$Nj),Q(2,L.$ni),Q(3,O.$6j)],P)}),define(le[110],he([0,1,2,30,5,27,171,21,44,101,24,41,22,46]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;let u=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,d,h){this.k=d,this.l=h,this.d={},this.i=new I.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,A.$Ye)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ye)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(w.$Tl)||c.affectsConfiguration(w.$Vl)||c.affectsConfiguration(w.$Ul))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,f.$$o)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;l=Math.min(l,h)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,d,h){this.g<d||(h=(0,N.$Pn)(h,this.d),h=(0,f.$dp)(h,this.j),h=(0,N.$Pn)(h,this.c),this.b.forEach(c=>c.log(l,h)))}publicLog(l,d){this.n(l,3,d)}publicLog2(l,d){this.publicLog(l,d)}publicLogError(l,d){this.h&&this.n(l,2,d)}publicLogError2(l,d){this.publicLogError(l,d)}};e.$Fr=u,e.$Fr=u=ye([Q(1,R.$Mi),Q(2,C.$6j)],u);function b(){const $=(0,O.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=L.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),c=(0,O.localize)(5,null),m=(0,O.localize)(6,null),i=(0,O.localize)(7,null),o=`
|       | ${h} | ${c} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${$} ${l} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}k.$Yn.as(P.$4n.Configuration).registerConfiguration({id:w.$Sl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$Tl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$Yn.as(P.$4n.Configuration).registerConfiguration({id:w.$Sl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$Vl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,O.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,O.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$Tl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[233],he([0,1,14,26,276,232]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=void 0;async function O(C,k){const w=await k.request(C,N.CancellationToken.None),f=(await(0,I.$Fe)(w.stream)).toString(),u=w.res.statusCode??200;return{headers:w.res.headers,statusCode:u,responseData:f}}async function R(C){const k={method:C.type,headers:C.headers};return new Promise((f,u)=>{const b=L.request(C.url??"",k,$=>{$.on("data",function(l){f({headers:$.headers,statusCode:$.statusCode??200,responseData:l.toString()})}),$.on("error",function(l){u(l)})});b.write(C.data,$=>{$&&u($)}),b.end()})}async function P(C,k,w){const f=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),u={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:f};try{const b=C?await O(u,C):await R(u);w(b.statusCode,b.headers,b.responseData)}catch{w(0,{})}}class g extends A.$IP{constructor(k,w,f,u,b){const $={sendPOST:(l,d)=>{P(k,l,d)}};super(w,f,u,b,$)}}e.$JP=g}),define(le[234],he([0,1,23,92,21,16,8,24,22,108,109,110]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;let w=class{constructor(u,b,$,l,d,h){this.b=u,this.c=b,this.d=$,this.e=l,this.f=d,this.g=h,this.a=new Map}h(u){if(!this.a.has(u.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const $=[u.id,JSON.stringify(b),u.aiKey],d=new N.$Hq(I.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:$,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new g.$xac(d),new C.$U0b(this.d,this.e,this.f,this.g,`[${u.id}] `)];this.a.set(u.id,new k.$Fr({appenders:h,sendErrorTelemetry:u.sendErrorTelemetry},this.b,this.g))}return this.a.get(u.id)}publicLog(u,b,$){this.h(u).publicLog(b,$)}publicLogError(u,b,$){this.h(u).publicLogError(b,$)}};e.$Rbc=w,e.$Rbc=w=ye([Q(0,L.$Mi),Q(1,P.$Ll),Q(2,O.$Mj),Q(3,O.$Nj),Q(4,A.$ni),Q(5,R.$6j)],w)}),define(le[78],he([0,1,3,10,21,4,8]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$Zv=e.$Xv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tv=e.$Sv=void 0,e.$Uv=g,e.$Vv=k,e.$Wv=w,e.$Yv=f,e.$1v=u,e.$2v=b,e.$Sv=(0,A.$gi)("tunnelService"),e.$Tv=(0,A.$gi)("sharedTunnelsService");var R;(function(d){d.Http="http",d.Https="https"})(R||(e.TunnelProtocol=R={}));var P;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(P||(e.TunnelPrivacyId=P={}));function g(d){return!!d.forwardPort}var C;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function k(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(h)return{address:h[1],port:+h[2]}}function w(d){if(d.scheme!=="http"&&d.scheme!=="https"||!d.query)return;const h=d.query.split("&");for(const c of h){const m=c.split("=")[1];if(/^https?:/.exec(m)){const i=k(N.URI.parse(m));if(i)return i}}}e.$Xv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(d){return e.$Xv.indexOf(d)>=0}e.$Zv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(d){return e.$Zv.indexOf(d)>=0}function b(d,h,c,m){if(c===1)return!1;if(c===2&&u(h)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(i?.length===4&&parseInt(i[1])>=18)return!1}return d<1024}class ${constructor(h,c,m){this.remoteAddress=h,this.localAddress=c,this.b=m,this.a=new I.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3v=$;let l=class{constructor(h,c){this.k=h,this.l=c,this.a=new I.$6d,this.onTunnelOpened=this.a.event,this.b=new I.$6d,this.onTunnelClosed=this.b.event,this.c=new I.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],c=Array.from(this.e.values());for(const m of c){const i=Array.from(m.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&h.push(n)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:c}of h.values())await c.then(m=>typeof m!="string"?m?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,c,m,i,o){this.q(h,c,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:c,localAddress:m,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,c){(u(h)||f(h))&&(h=e.$Xv[0]);const m=this.s(h,c);if(m)return++m.refcount,m.value}openTunnel(h,c,m,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${m} on local port ${o}.`);const r=this.f??h;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(m)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,m,i,o,n,s,t);return a?a.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,m),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,m);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.o(v);return(v.tunnelRemoteHost!==c||v.tunnelRemotePort!==m)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&v.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(y),y}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const c=this.e.get(h.tunnelRemoteHost);if(c){const m=c.get(h.tunnelRemotePort);m&&(m.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,m))}}}}async p(h,c,m){if(m.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${c}.`);const i=m.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(c),i}}async closeTunnel(h,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${c} `);const m=this.e.get(h);if(m&&m.has(c)){const i=m.get(c);i.refcount=0,await this.p(h,c,i)}}q(h,c,m){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(c,{refcount:1,value:m})}async r(h,c){const m=this.e.get(h);if(m){const i=m.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&m.delete(c),m.size===0&&this.e.delete(h)}}s(h,c){const m=[h];f(h)?(m.push(...e.$Xv),m.push(...e.$Zv)):u(h)&&m.push(...e.$Zv);const i=m.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(h){return!!k(h)}u(h,c,m,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${m} on local port ${i}.`);const t=m;this.j.add(t);const r=i===void 0?m:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},v={remoteAddress:{host:c,port:m},localAddressPort:i,privacy:n,public:n?n!==P.Private:void 0,protocol:s},y=h.forwardPort(v,a);return y?(this.q(c,m,y),y.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),y}};e.$4v=l,e.$4v=l=ye([Q(0,O.$Mj),Q(1,L.$Mi)],l)}),define(le[235],he([0,1,8,78,2,7,6]),function(se,e,I,N,L,A,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class P extends L.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Dh),this.b.p)}setAddress(k){this.a=k,this.b&&(this.b.complete(k),this.b=null)}setTunnel(k){this.B(k)}}let g=class extends L.$Tc{static{R=this}static{this.a=0}constructor(k,w){super(),this.f=k,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(k=>k.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(k,w,f,u,b,$,l){const d=new P,h=await Promise.resolve(this.f.openTunnel(k,d,f,u,b,$,l));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${u} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),d.dispose(),await h.dispose(),(0,A.$6)();return d.setTunnel(h),this.b.set(w,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${h.localAddress} (local) to ${f}:${u} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(k,w){const f=this.b.get(k);f&&f.setAddress(w)}async destroyTunnel(k){const w=this.b.get(k);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${k}.`),this.b.delete(k),await w.dispose();return}this.c.add(k)}};e.$2bc=g,e.$2bc=g=R=ye([Q(0,N.$Tv),Q(1,I.$Mj)],g)}),define(le[28],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=void 0,e.$kl=(0,I.$gi)("IUriIdentityService")}),define(le[236],he([0,1,28,189,12,20,128,3,2]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;class g{static{this._clock=0}constructor(w){this.uri=w,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(w){this.g=w,this.c=new P.$Sc,this.f=2**16;const f=new Map,u=b=>{let $=f.get(b.scheme);return $===void 0&&($=w.hasProvider(b)&&!this.g.hasCapability(b,1024),f.set(b.scheme,$)),$};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new A.$Ig(u),this.d=new O.$es((b,$)=>this.extUri.compare(b,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.$Ug)(w));const f=this.d.get(w);return f?f.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new g(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((u,b)=>u[1].time<b[1].time?1:u[1].time>b[1].time?-1:0);g._clock=0,this.d.clear();const f=this.f*.5;for(let u=0;u<f;u++)this.d.set(w[u][0],w[u][1].touch())}};e.$fs=C,e.$fs=C=ye([Q(0,L.$Mk)],C),(0,N.$cs)(I.$kl,C,1)}),define(le[237],he([0,1,3,2,12,48,35]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class R extends N.$Tc{constructor(g,C,k,w,f,u){super(),this.f=g,this.g=C,this.h=k,this.j=w,this.m=f,this.n=u,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$6d),this.onDidChangeFile=this.a.event,this.b=A.$mi.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,k,w,f){return this.g.read(g,C,k,w,f)}write(g,C,k,w,f){return this.g.write(g,C,k,w,f)}watch(g,C){this.b.set(g,g);const k=this.g.watch(this.t(g),C);return(0,N.$Rc)(()=>{this.b.delete(g),k.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,k){return this.g.rename(this.t(g),this.t(C),k)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,k){return this.g.readFileStream(this.t(g),C,k)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,k){return this.g.writeFile(this.t(g),C,k)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,k){if((0,L.$Qk)(this.g))return this.g.copy(this.t(g),this.t(C),k);throw new Error("copy not supported")}cloneFile(g,C){if((0,L.$Rk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const k of g){if(k.resource.scheme!==this.f)continue;const w=this.u(k.resource);this.b.findSubstr(w)&&C.push({resource:w,type:k.type,cId:k.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$kbc=R}),define(le[79],he([0,1,62]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$HHb=L,e.$IHb=A;function N(O,R,P,g){const C=(0,I.$In)(O,R,P,g)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}function L(O,R,P){let g=P;for(;g>=0;){if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&O.charAt(g)===R.charAt(0))return g+2}return 0}function A(O,R,P){let g=P;for(;g>=0;)if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&O.charAt(g)===R.charAt(1)))return g;return O.length-1}}),define(le[238],he([0,1,30,55,13]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=A;function A(f,u,b,$,l,d){const h=[],c=[],m=[];if(!u){const q=f.filter(({identifier:Z})=>l.every(X=>X.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:h,removed:c,updated:m},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}f=f.map(k),u=u.map(k),b=b?b.map(k):null;const i=new Map,o=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};f.forEach(({identifier:q})=>o(q)),u.forEach(({identifier:q})=>o(q)),b?.forEach(({identifier:q})=>o(q)),$?.forEach(({identifier:q})=>o(q)),d?.forEach(q=>o(q));const n=q=>{const Z=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,Z)=>(q.set(n(Z),Z),q),t=f.reduce(s,new Map),r=u.reduce(s,new Map),a=u.reduce((q,Z)=>s(q,(0,I.$Mn)(Z)),new Map),v=b?b.reduce(s,new Map):null,y=$.reduce(s,new Map),p=l.reduce((q,Z)=>{const X=i.get(Z.toLowerCase());return q.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)},new Set),S=d?d.reduce((q,{id:Z,uuid:X})=>(X=X??i.get(Z.toLowerCase()),q.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)),new Set):null,E=O(t,r,p,!1);if(E.added.size>0||E.removed.size>0||E.updated.size>0){const q=O(v,t,p,!1),Z=O(v,r,p,!0),X=(x,W,K,V)=>{let H,te,re;return W.installed?(H=V.pinned,re=V.preRelease,H&&(te=V.version)):(H=K.pinned,re=K.preRelease,H&&(te=K.version)),H===void 0&&(H=W.pinned,H&&(te=W.version)),re===void 0&&(re=W.preRelease),{...V,installed:W.installed||K.installed,pinned:H,preRelease:re,version:te??(K.version&&(!W.installed||N.gt(K.version,W.version))?K.version:W.version),state:P(W,K,v?.get(x))}};for(const x of Z.removed.values()){const W=t.get(x);if(!W)continue;const K=(0,L.$5f)(v?.get(x)),V=S&&!S.has(x)&&K.installed;W.installed&&V?c.push(W.identifier):a.set(x,W)}for(const x of Z.added.values()){const W=(0,L.$5f)(r.get(x)),K=t.get(x);if(K){if(E.updated.has(x)){const V=X(x,K,W,W);R(K,W,!1,!1)||m.push(w(V,x)),a.set(x,V)}}else W.installed&&h.push(w(W,x))}for(const x of Z.updated.values()){const W=(0,L.$5f)(r.get(x)),K=(0,L.$5f)(v?.get(x)),V=t.get(x);if(V)if(S&&!S.has(x)&&K.installed&&V.installed&&!W.installed)c.push(V.identifier);else{const te=X(x,V,W,W);m.push(w(te,x)),a.set(x,te)}else W.installed&&h.push(w(W,x))}for(const x of q.added.values())Z.added.has(x)||a.set(x,(0,L.$5f)(t.get(x)));for(const x of q.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const W=(0,L.$5f)(t.get(x)),K=(0,L.$5f)(r.get(x));a.set(x,X(x,W,K,W))}for(const x of q.removed.values())Z.updated.has(x)||Z.removed.has(x)||y.has(x)||(0,L.$5f)(r.get(x)).installed&&S&&(S.has(x)||!(0,L.$5f)(v?.get(x)).installed||a.delete(x))}const D=[],T=O(r,a,new Set,!0),F=T.added.size>0||T.updated.size>0||T.removed.size>0;return F&&a.forEach((q,Z)=>D.push(w(q,Z))),{local:{added:h,removed:c,updated:m},remote:F?{added:[...T.added].map(q=>a.get(q)),updated:[...T.updated].map(q=>a.get(q)),removed:[...T.removed].map(q=>r.get(q)),all:D}:null}}function O(f,u,b,$){const l=f?[...f.keys()].filter(i=>!b.has(i)):[],d=[...u.keys()].filter(i=>!b.has(i)),h=d.filter(i=>!l.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=l.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),m=new Set;for(const i of l){if(c.has(i))continue;const o=f.get(i),n=u.get(i);(!n||!R(o,n,$,!0))&&m.add(i)}return{added:h,removed:c,updated:m}}function R(f,u,b,$){return!(f.disabled!==u.disabled||!!f.isApplicationScoped!=!!u.isApplicationScoped||$&&f.installed!==u.installed||f.installed&&u.installed&&(f.preRelease!==u.preRelease||f.pinned!==u.pinned||u.pinned&&f.version!==u.version)||!C(f.state,u.state)||b&&f.version!==u.version)}function P(f,u,b){const $=f.state,l=u.state,d=b?.state;if(!u.version||$&&N.gt(f.version,u.version))return $;if(l&&N.gt(u.version,f.version)||!$)return l;if(!l)return $;const h=(0,I.$Mn)($),c=d?g(d,l):{added:Object.keys(l).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},m=d?g(d,$):{added:Object.keys($).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])h[i]=l[i];for(const i of c.removed.values())m.updated.has(i)||delete h[i];return h}function g(f,u){const b=Object.keys(f),$=Object.keys(u),l=$.filter(c=>!b.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),d=b.filter(c=>!$.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),h=new Set;for(const c of b){if(d.has(c))continue;const m=f[c],i=u[c];(0,I.$Qn)(m,i)||h.add(c)}return{added:l,removed:d,updated:h}}function C(f={},u={}){const{added:b,removed:$,updated:l}=g(f,u);return b.size===0&&$.size===0&&l.size===0}function k(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function w(f,u){const b={...f,identifier:{id:f.identifier.id,uuid:u.startsWith("uuid:")?u.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete b.disabled,f.installed||delete b.installed,f.state||delete b.state,f.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJb=e.$OJb=void 0,e.$OJb=(0,L.$gi)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),P&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,P){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),P&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const P=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),g=this.b().map(w=>w.toLowerCase()),C=[],k=[];if(Array.isArray(g))for(const w of g)w.startsWith("-")?k.push(w.substring(1)):C.push(w);return(0,I.$Mb)([...P,...C].filter(w=>!k.includes(w)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$PJb=A,e.$PJb=A=ye([Q(0,N.$Mi)],A)}),define(le[239],he([0,1,17,34,30,93,79]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=P;function R(c){return(0,N.$tn)(c)||[]}async function P(c,m,i,o,n){const s=R(c),t=R(m),r=i?R(i):null,a=[...s,...t,...r||[]].map(X=>X.key),v=await n.resolveUserBindings(a),y=C(s,t,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const p=w(s),S=w(t),E=r?w(r):null,D=u(p,S,v),T=E?u(E,p,v):{added:[...p.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},F=E?u(E,S,v):{added:[...S.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},q=g(D,T,F);let Z=c;for(const X of q.removed.values())q.conflicts.has(X)||(Z=d(Z,X,o));for(const X of q.added.values()){if(q.conflicts.has(X))continue;const x=S.get(X);if(x.some(W=>W.command!==`-${X}`&&y.conflicts.has(v[W.key]))){q.conflicts.add(X);continue}Z=l(Z,x,o)}for(const X of q.updated.values()){if(q.conflicts.has(X))continue;const x=S.get(X);if(x.some(W=>W.command!==`-${X}`&&y.conflicts.has(v[W.key]))){q.conflicts.add(X);continue}Z=h(Z,X,x,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:q.conflicts.size>0}}function g(c,m,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of m.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(m.updated.has(r)?t.add(r):n.add(r));for(const r of m.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(m.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of m.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(m.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,m,i,o){const n=new Set,s=k(c,o),t=k(m,o),r=i?k(i,o):null,a=f(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?f(r,s):{added:[...s.keys()].reduce((T,F)=>(T.add(F),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?f(r,t):{added:[...t.keys()].reduce((T,F)=>(T.add(F),T),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:p,removed:S,updated:E,conflicts:D}=g(a,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:p,removed:S,updated:E,conflicts:D}}function k(c,m){const i=new Map;for(const o of c){const n=m[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function w(c){const m=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=m.get(o);n||(n=[],m.set(o,n)),n.push(i)}return m}function f(c,m){const i=[...c.keys()],o=[...m.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(y=>({...y,key:r})),v=m.get(r).map(y=>({...y,key:r}));(0,I.$ub)(a,v,(y,p)=>$(y,p))||t.add(r)}return{added:n,removed:s,updated:t}}function u(c,m,i){const o=[...c.keys()],n=[...m.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=c.get(a).map(p=>({...p,key:i[p.key]})),y=m.get(a).map(p=>({...p,key:i[p.key]}));b(v,y)||r.add(a)}return{added:s,removed:t,updated:r}}function b(c,m){return!(!(0,I.$ub)(c.filter(({command:i})=>i[0]!=="-"),m.filter(({command:i})=>i[0]!=="-"),(i,o)=>$(i,o))||!(0,I.$ub)(c.filter(({command:i})=>i[0]==="-"),m.filter(({command:i})=>i[0]==="-"),(i,o)=>$(i,o)))}function $(c,m){if(c.command!==m.command||c.key!==m.key)return!1;const i=A.$ej.deserialize(c.when),o=A.$ej.deserialize(m.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!L.$Qn(c.args,m.args))}function l(c,m,i){for(const o of m)c=O.edit(c,[-1],o,i);return c}function d(c,m,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===m||o[n].command===`-${m}`)&&(c=O.edit(c,[n],void 0,i));return c}function h(c,m,i,o){const n=R(c),s=n.findIndex(t=>t.command===m||t.command===`-${m}`);for(let t=n.length-1;t>=0;t--)(n[t].command===m||n[t].command===`-${m}`)&&(c=O.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=O.edit(c,[s],i[t],o);return c}}),define(le[240],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=I,e.$O9b=L;function I(A,O,R){const P={},g={},C=new Set;if(!O)return{local:{added:P,updated:g,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const k=N(A,O);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{local:{added:P,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=N(R,A),f=N(R,O),u={},b={},$=new Set,l=new Set;for(const d of w.removed.values())f.updated.has(d)?P[d]=O[d]:$.add(d);for(const d of f.removed.values())l.has(d)||(w.updated.has(d)?l.add(d):C.add(d));for(const d of w.updated.values())l.has(d)||(f.updated.has(d)?k.updated.has(d)&&l.add(d):b[d]=A[d]);for(const d of f.updated.values())l.has(d)||(w.updated.has(d)?k.updated.has(d)&&l.add(d):A[d]!==void 0&&(g[d]=O[d]));for(const d of w.added.values())l.has(d)||(f.added.has(d)?k.updated.has(d)&&l.add(d):u[d]=A[d]);for(const d of f.added.values())l.has(d)||(w.added.has(d)?k.updated.has(d)&&l.add(d):P[d]=O[d]);return{local:{added:P,removed:[...C.values()],updated:g},remote:{added:u,removed:[...$.values()],updated:b},conflicts:[...l.values()]}}function N(A,O){const R=A?Object.keys(A):[],P=O?Object.keys(O):[],g=P.filter(w=>!R.includes(w)).reduce((w,f)=>(w.add(f),w),new Set),C=R.filter(w=>!P.includes(w)).reduce((w,f)=>(w.add(f),w),new Set),k=new Set;for(const w of R){if(C.has(w))continue;const f=A[w],u=O[w];f!==u&&k.add(w)}return{added:g,removed:C,updated:k}}function L(A,O){const{added:R,removed:P,updated:g}=N(A,O);return R.size===0&&P.size===0&&g.size===0}}),define(le[241],he([0,1,30]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=N;function N(A,O,R,P){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const w=A.filter(({id:f})=>!P.includes(f));return w.length?C.added=w:C=null,{local:g,remote:C}}const k=L(A,O,P);if(k.added.length>0||k.removed.length>0||k.updated.length>0){const w=L(R,A,P),f=L(R,O,P);for(const u of f.removed){const b=A.find($=>$.id===u);b&&g.removed.push(b)}for(const u of f.added){const b=O.find($=>$.id===u);w.added.includes(u)?k.updated.includes(u)&&g.updated.push(b):g.added.push(b)}for(const u of f.updated)g.updated.push(O.find(b=>b.id===u));for(const u of w.added)f.added.includes(u)||C.added.push(A.find(b=>b.id===u));for(const u of w.updated)f.removed.includes(u)||f.updated.includes(u)||C.updated.push(A.find(b=>b.id===u));for(const u of w.removed){const b=O.find($=>$.id===u);b&&C.removed.push(b)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}function L(A,O,R){A=A?A.filter(({id:f})=>!R.includes(f)):[],O=O.filter(({id:f})=>!R.includes(f));const P=A.map(({id:f})=>f),g=O.map(({id:f})=>f),C=g.filter(f=>!P.includes(f)),k=P.filter(f=>!g.includes(f)),w=[];for(const{id:f,name:u,shortName:b,icon:$,useDefaultFlags:l}of A){if(k.includes(f))continue;const d=O.find(h=>h.id===f);(!d||d.name!==u||d.shortName!==b||d.icon!==$||!(0,I.$Qn)(d.useDefaultFlags,l))&&w.push(f)}return{added:C,removed:k,updated:w}}}),define(le[25],he([0,1,17,13,177,44,29,4,102,41]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipb=e.$Hpb=e.$Gpb=e.$Fpb=e.$Epb=e.$Dpb=e.$Cpb=e.$Bpb=e.$Apb=e.$ypb=e.MergeState=e.Change=e.SyncStatus=e.$xpb=e.$wpb=e.$vpb=e.UserDataSyncErrorCode=e.$tpb=e.$spb=e.$rpb=e.$qpb=e.$ppb=e.$mpb=e.SyncResource=e.$jpb=e.$ipb=void 0,e.$gpb=C,e.$hpb=k,e.$kpb=w,e.$lpb=f,e.$npb=b,e.$opb=$,e.$upb=l,e.$zpb=s;function C(){const t=g.$Yn.as(A.$4n.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function k(){const t=g.$Yn.as(A.$4n.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(y=>!!t[y].ignoreSync),a=Object.keys(t).filter(y=>t[y].scope===2||t[y].scope===6),v=C();return(0,I.$Mb)([...r,...a,...v])}e.$ipb="settingsSync",e.$jpb="settingsSync.keybindingsPerPlatform";function w(){const t="vscode://schemas/ignoredSettings",r=g.$Yn.as(A.$4n.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$jpb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$Do,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Yn.as(P.$Zn.JSONContribution),v=()=>{const y=C(),p=k(),S=Object.keys(A.$5n.properties).filter(T=>!p.includes(T)),E=p.filter(T=>!y.includes(T)),D={items:{type:"string",enum:[...S,...E.map(T=>`-${T}`)]}};a.registerSchema(t,D)};return r.onDidUpdateConfiguration(()=>v())}function f(t){return t&&(0,N.$Vf)(t)&&(0,N.$Tf)(t.id)&&Array.isArray(t.scopes)}var u;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(u||(e.SyncResource=u={})),e.$mpb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}function $(t,r,a,v){return v.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$ppb=(0,R.$gi)("IUserDataSyncStoreManagementService"),e.$qpb=(0,R.$gi)("IUserDataSyncStoreService"),e.$rpb=(0,R.$gi)("IUserDataSyncLocalStoreService"),e.$spb="x-operation-id",e.$tpb="X-Execution-Id";function l(t){const r={};return r[e.$tpb]=t,r}var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class h extends Error{constructor(r,a,v,y){super(r),this.code=a,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$vpb=h;class c extends h{constructor(r,a,v,y,p){super(r,v,void 0,p),this.url=a,this.serverCode=y}}e.$wpb=c;class m extends h{constructor(r,a){super(r,a)}}e.$xpb=m,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],p=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],y,p)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$vpb=h={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$ypb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Apb=(0,R.$gi)("IUserDataSyncEnablementService"),e.$Bpb=(0,R.$gi)("IUserDataSyncService"),e.$Cpb=(0,R.$gi)("IUserDataSyncResourceProviderService"),e.$Dpb=(0,R.$gi)("IUserDataAutoSyncService"),e.$Epb=(0,R.$gi)("IUserDataSyncUtilService"),e.$Fpb=(0,R.$gi)("IUserDataSyncLogService"),e.$Gpb="userDataSync",e.$Hpb="vscode-userdata-sync",e.$Ipb="preview"}),define(le[242],he([0,1,30,25]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Ib=L;function L(O,R,P,g,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const k=A(O,R);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=P?A(P,R):{added:Object.keys(R).reduce((d,h)=>(d.add(h),d),new Set),removed:new Set,updated:new Set},f=P?A(P,O):{added:Object.keys(O).reduce((d,h)=>(d.add(h),d),new Set),removed:new Set,updated:new Set},u={added:{},removed:[],updated:{}},b=I.$Mn(R),$=!P;for(const d of f.added.values())d!==N.$ypb&&$&&w.added.has(d)||(b[d]=O[d]);for(const d of f.updated.values())b[d]=O[d];for(const d of f.removed.values())g.unregistered.includes(d)||delete b[d];for(const d of w.added.values()){const h=R[d];if(g.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&f.added.has(d))continue;const c=O[d];c&&c.value===h.value||d===N.$ypb&&$&&f.added.has(d)||(c?u.updated[d]=h:u.added[d]=h)}for(const d of w.updated.values()){const h=R[d];if(g.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(d)||f.removed.has(d))continue;const c=O[d];c&&c.value===h.value||(u.updated[d]=h)}for(const d of w.removed.values()){if(g.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}f.updated.has(d)||f.removed.has(d)||u.removed.push(d)}const l=A(R,b);return{local:u,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:b}}}function A(O,R){const P=Object.keys(O),g=Object.keys(R),C=g.filter(f=>!P.includes(f)).reduce((f,u)=>(f.add(u),f),new Set),k=P.filter(f=>!g.includes(f)).reduce((f,u)=>(f.add(u),f),new Set),w=new Set;for(const f of P){if(k.has(f))continue;const u=O[f],b=R[f];I.$Qn(u,b)||w.add(f)}return{added:C,removed:k,updated:w}}}),define(le[243],he([0,1,17,34,62,42,30,79,25]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JHb=g,e.$KHb=w,e.$LHb=f,e.$MHb=u,e.$NHb=$,e.$OHb=d;function g(a,v,y){let p=[];y?p=k(y):p=C(v);const S=[],E=[...(0,P.$gpb)()];if(Array.isArray(p))for(const D of p)D.startsWith("-")?E.push(D.substring(1)):S.push(D);return(0,I.$Mb)([...a,...S].filter(D=>!E.includes(D)))}function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function k(a){const v=(0,N.$tn)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function w(a,v){const y=(0,N.$tn)(a)||{};let p="{}";for(const S of Object.keys(y)){const E=(0,L.$In)(p,[S],y[S],v);p=(0,L.$Ln)(p,E)}return p}function f(a,v,y,p){if(y.length){const S=r(v),E=(0,N.$tn)(v)||{},D=(0,N.$tn)(a);if(!D)return a;const T=[];for(const F of y){const q=E[F],Z=D[F];q===void 0?a=R.edit(a,[F],void 0,p):Z!==void 0?a=R.edit(a,[F],q,p):T.push(i(F,S))}T.sort((F,q)=>F.startOffset-q.startOffset),T.forEach(F=>a=d(F.setting.key,v,a,p))}return a}function u(a,v,y,p,S,E){const D=f(a,v,p,E),T=y!==D,F=y!==v;if(!T&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!F)return{conflictsSettings:[],localContent:null,remoteContent:D,hasConflicts:!1};if(F&&!T)return{conflictsSettings:[],localContent:f(v,a,p,E),remoteContent:null,hasConflicts:!1};if(y===null&&$(a)){const M=b(a,v,p)?null:f(v,a,p,E);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let q=a,Z=v;const X=(0,N.$tn)(a),x=(0,N.$tn)(v),W=y?(0,N.$tn)(y):null,K=p.reduce((M,B)=>(M.add(B),M),new Set),V=l(X,x,K),H=l(W,X,K),te=l(W,x,K),re=new Map,ee=new Set,ae=M=>{ee.add(M);const B=S.filter(({key:U})=>U===M)[0];B?(q=R.edit(q,[M],B.value,E),Z=R.edit(Z,[M],B.value,E)):re.set(M,{key:M,localValue:X[M],remoteValue:x[M]})};for(const M of H.removed.values())te.updated.has(M)?ae(M):Z=R.edit(Z,[M],void 0,E);for(const M of te.removed.values())ee.has(M)||(H.updated.has(M)?ae(M):q=R.edit(q,[M],void 0,E));for(const M of H.updated.values())ee.has(M)||(te.updated.has(M)?V.updated.has(M)&&ae(M):Z=R.edit(Z,[M],X[M],E));for(const M of te.updated.values())ee.has(M)||(H.updated.has(M)?V.updated.has(M)&&ae(M):q=R.edit(q,[M],x[M],E));for(const M of H.added.values())ee.has(M)||(te.added.has(M)?V.updated.has(M)&&ae(M):Z=d(M,q,Z,E));for(const M of te.added.values())ee.has(M)||(H.added.has(M)?V.updated.has(M)&&ae(M):q=d(M,Z,q,E));const J=re.size>0||!b(q,Z,p),z=J||!b(q,a,[]),j=J||!b(Z,v,[]);return{localContent:z?q:null,remoteContent:j?Z:null,conflictsSettings:[...re.values()],hasConflicts:J}}function b(a,v,y){if(a===v)return!0;const p=(0,N.$tn)(a),S=(0,N.$tn)(v),E=y.reduce((F,q)=>(F.add(q),F),new Set),D=r(a).filter(F=>!(F.setting&&E.has(F.setting.key))),T=r(v).filter(F=>!(F.setting&&E.has(F.setting.key)));if(D.length!==T.length)return!1;for(let F=0;F<D.length;F++){const q=D[F],Z=T[F];if(q.setting&&Z.setting){if(q.setting.key!==Z.setting.key||!O.$Qn(p[q.setting.key],S[q.setting.key]))return!1}else if(!q.setting&&!Z.setting){if(q.value!==Z.value)return!1}else return!1}return!0}function $(a){return a?r(a).length===0:!0}function l(a,v,y){const p=a?Object.keys(a).filter(F=>!y.has(F)):[],S=Object.keys(v).filter(F=>!y.has(F)),E=S.filter(F=>!p.includes(F)).reduce((F,q)=>(F.add(q),F),new Set),D=p.filter(F=>!S.includes(F)).reduce((F,q)=>(F.add(q),F),new Set),T=new Set;if(a)for(const F of p){if(D.has(F))continue;const q=a[F],Z=v[F];O.$Qn(q,Z)||T.add(F)}return{added:E,removed:D,updated:T}}function d(a,v,y,p){const S=(0,N.$tn)(v),E=r(v),D=r(y),T=h(a,E,D);return c(y,a,S[a],T,D,p)}function h(a,v,y){const p=v.findIndex(E=>E.setting?.key===a),S=v[p-1];if(S){if(S.setting){const D=i(S.setting.key,y);if(D)return{index:y.indexOf(D),insertAfter:!0}}else{const D=o(p,v);if(D){const T=i(D.setting.key,y);if(T){const F=n(y.indexOf(T),y),q=s(v,D,v[p]);if(F){const Z=s(y,T,F),X=t(q,Z);return X?{index:y.indexOf(X),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const Z=s(y,T,y[y.length-1]),X=t(q,Z);return X?{index:y.indexOf(X),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const E=v[p+1];if(E)if(E.setting){const D=i(E.setting.key,y);if(D)return{index:y.indexOf(D),insertAfter:!1}}else{const D=n(p,v);if(D){const T=i(D.setting.key,y);if(T){const F=o(y.indexOf(T),y),q=s(v,v[p],D);if(F){const Z=s(y,F,T),X=t(q.reverse(),Z.reverse());return X?{index:y.indexOf(X),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const Z=s(y,y[0],T),X=t(q.reverse(),Z.reverse());return X?{index:y.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function c(a,v,y,p,S,E){let D;return p.index===-1?D=(0,L.$In)(a,[v],y,E):D=m(a,v,y,p,S,E).map(T=>(0,L.$Jn)(a,T,E)[0]),(0,L.$Ln)(a,D)}function m(a,v,y,p,S,E){const D=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,T=(0,A.$Fn)(E,a),F=S[p.index];if(p.insertAfter){const q=[];if(F.setting)q.push({offset:F.endOffset,length:0,content:","+D});else{const Z=n(p.index,S),X=o(p.index,S),x=X?.setting?.commaOffset;X&&x===void 0&&q.push({offset:X.endOffset,length:0,content:","});const W=x!==void 0&&x>F.endOffset;q.push({offset:W?x+1:F.endOffset,length:0,content:Z?T+D+",":T+D})}return q}else{if(F.setting)return[{offset:F.startOffset,length:0,content:D+","}];const q=(S[p.index-1]&&!S[p.index-1].setting?T:"")+D+(n(p.index,S)?",":"")+T;return[{offset:F.startOffset,length:0,content:q}]}}function i(a,v){return v.filter(y=>y.setting?.key===a)[0]}function o(a,v){for(let y=a-1;y>=0;y--)if(v[y].setting)return v[y]}function n(a,v){for(let y=a+1;y<v.length;y++)if(v[y].setting)return v[y]}function s(a,v,y){const p=a.indexOf(v),S=a.indexOf(y);return a.filter((E,D)=>p<D&&D<S)}function t(a,v){if(a.length&&v.length){let y=0;for(;y<v.length&&y<a.length;y++)if(a[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(a){const v=[];let y=-1,p,S;const E={onObjectBegin:D=>{y++},onObjectProperty:(D,T,F)=>{y===0&&(p=T,S=D)},onObjectEnd:(D,T)=>{y--,y===0&&v.push({startOffset:p,endOffset:D+T,value:a.substring(p,D+T),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(D,T)=>{y++},onArrayEnd:(D,T)=>{y--,y===0&&v.push({startOffset:p,endOffset:D+T,value:a.substring(p,D+T),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(D,T,F)=>{y===0&&v.push({startOffset:p,endOffset:T+F,value:a.substring(p,T+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(D,T,F)=>{if(y===0&&D===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Z=v[q];Z&&v.splice(q,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:T}})}},onComment:(D,T)=>{y===0&&v.push({startOffset:D,endOffset:D+T,value:a.substring(D,D+T)})}};return(0,N.$An)(a,E),v}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uHb=e.$tHb=void 0,e.$tHb=(0,L.$gi)("IUserDataSyncAccountService");let O=class extends N.$Tc{get account(){return this.a}constructor(P,g){super(),this.g=P,this.h=g,this.b=this.B(new I.$6d),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$6d),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$uHb=O,e.$uHb=O=ye([Q(0,A.$qpb),Q(1,A.$Fpb)],O)}),define(le[244],he([0,1,20,178,16,8,25]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJb=void 0;let R=class extends A.$Rj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,I.$Tg)(C.logsHome,`${O.$Gpb}.log`),{id:O.$Gpb,name:(0,N.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$QJb=R,e.$QJb=R=ye([Q(0,A.$Nj),Q(1,L.$ni)],R)}),define(le[245],he([0,1,6,3,2]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;class A extends L.$Tc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:P,getActiveWindowId:g}){super(),this.a=this.B(new L.$Sc),N.Event.latch(N.Event.any(R,P))(this.f,this,this.a),this.b=(0,I.$6g)(()=>g()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Rac=A}),define(le[112],he([0,1,181,15,48,20,10,4,23]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Ai=e.$zi=e.WorkbenchState=e.$ti=e.$si=e.$pi=void 0,e.$qi=g,e.$ri=C,e.$ui=k,e.$vi=w,e.$wi=f,e.$xi=b,e.$yi=$,e.$Bi=h,e.$Gi=c,e.$Hi=m,e.$Ji=i,e.$Ki=o,e.$Li=n,e.$pi=(0,R.$gi)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}function C(s){return typeof s?.id=="string"&&!g(s)&&!w(s)}e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function k(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$nc)(s)}:t?e.$si:e.$ti;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function w(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}function f(s){const t=s;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var u;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(u||(e.WorkbenchState=u={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function $(s){const t=s;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class l{constructor(t,r,a,v,y){this.h=t,this.j=a,this.k=v,this.l=y,this.c=L.$mi.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$mi.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=l;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$Tg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=d;function h(s){return new d({uri:s,index:0,name:(0,A.$Pg)(s)},{uri:s.toString()})}e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,I.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function c(s,t){return A.$Kg.isEqualOrParent(s,t.untitledWorkspacesHome)}function m(s){let t;return O.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===P.Schemas.tmp}e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ii}function o(s,t){return!c(s,t)&&!m(s)}function n(s){return(typeof s=="string"?(0,N.$oc)(s):(0,A.$Rg)(s))===e.$Di}}),define(le[18],he([0,1,54,3,2,20,10,172,16,12,4,8,112,35,28,6,32,27,13]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ml=e.ProfileResourceType=void 0,e.$ll=c,e.$nl=m,e.$ol=i;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$ml=(0,C.$gi)("IUserDataProfilesService");function m(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:t}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,v,y){return{id:s,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$Tg)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,A.$Tg)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$Tg)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$Tg)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$Tg)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$Tg)(r,"extensions.json"),cacheHome:(0,A.$Tg)(a,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let o=class extends L.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,d.$Tf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(i((0,A.$Qg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},t))}}catch(y){this.y.error(y)}const a=new f.$Ac,v=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[p,S]of Object.entries(y.workspaces)){const E=O.URI.parse(p),D=r.find(T=>T.id===S);D&&a.set(E,D)}if(y.emptyWindows)for(const[p,S]of Object.entries(y.emptyWindows)){const E=r.find(D=>D.id===S);E&&v.set(p,E)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Ye)(r)}\\s(\\d+)`);let v=0;for(const p of this.profiles){const S=a.exec(p.name),E=S?parseInt(S[1]):0;v=E>v?E:v}const y=`${r} ${v+1}`;return this.createProfile((0,I.$7i)((0,$.$Cg)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,I.$7i)((0,$.$Cg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,y),y}async F(t,r,a){if(!(0,d.$Tf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(E=>E.name===r||E.id===t);if(y)return y;const p=i(t,r,(0,A.$Tg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(p.location);const S=[];return this.j.fire({profile:p,join(E){S.push(E)}}),await b.Promises.settled(S),this.I([p],[],[]),p}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$4k)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,w.$qi)(t)?t.uri:(0,w.$vi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],y=[];this.s.profiles=[];for(let p of v)p.isDefault||r.some(S=>p.id===S.id)||(p=a.find(S=>p.id===S.id)??p,p.isTransient?this.s.profiles.push(p):y.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(y),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),y=a?this.s:this.C;O.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[y,p]of Object.entries(t.workspaces)){const S=O.URI.parse(p);r[y]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const v={};if(t.emptyWindows)for(const[y,p]of Object.entries(t.emptyWindows)){const S=O.URI.parse(p);v[y]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$pl=o,e.$pl=o=ye([Q(0,P.$ni),Q(1,g.$Mk),Q(2,u.$kl),Q(3,k.$Mj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$ql=n}),define(le[246],he([0,1,6,2,18]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;let A=class extends N.$Tc{constructor(R){super(),this.B(new I.$sh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$4bc=A,e.$4bc=A=ye([Q(0,L.$ml)],A)}),define(le[247],he([0,1,17,6,26,7,3,2,5,13,10,154,29,33,45,8,24,22,28,18]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$7p=void 0,e.$8p=m,e.$9p=i;let c=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,y,p){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=y,this.H=p,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$6d),this.s=this.B(new O.$6d),this.t=this.B(new O.$6d),this.u=this.B(new O.$6d),this.w=this.B(new O.$6d),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.m.forEach(S=>S.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,w.$No)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:y})=>(0,f.$ep)(y,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:new w.$Qo(`Unknown error while installing extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new w.$Qo(k.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:y})=>{try{const p=await this.N(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.G.version,date:this.G.date});a.push({...p,options:y})}catch(p){r.push({identifier:v.identifier,operation:2,source:v,error:p})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$mp)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,u.$Em)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(p=>(0,f.$ep)(p.identifier,t.identifier));y?this.w.fire(y):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,v=[],y=[],p=(E,D)=>`${f.$fp.create(E).toString()}-${D.toString()}`,S=(E,D,T)=>{const F=this.Y(E,D,T),q=C.URI.isUri(D)?D.path:`${D.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`;a.set(q,{task:F,manifest:E}),this.n.fire({identifier:F.identifier,source:D,profileLocation:T.profileLocation}),this.F.info("Installing extension:",F.identifier.id),C.URI.isUri(D)||this.j.set(p(D,T.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:E,extension:D,options:T}of t){const F=T.isApplicationScoped||T.isBuiltin||(0,u.$Em)(E),q={...T,installOnlyNewlyAddedFromExtensionPack:T.installOnlyNewlyAddedFromExtensionPack??!C.URI.isUri(D),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:T.profileLocation??this.X(),productVersion:T.productVersion??{version:this.G.version,date:this.G.date}},Z=C.URI.isUri(D)?void 0:this.j.get(p(D,q.profileLocation));Z?(this.F.info("Extension is already requested to install",Z.task.identifier.id),v.push(Z.task.waitUntilTaskIsFinished())):S(E,D,q)}await Promise.all([...a.values()].map(async({task:E,manifest:D})=>{if(E.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",E.identifier.id);else try{const T=await this.M(E.identifier,D,!!E.options.installOnlyNewlyAddedFromExtensionPack,!!E.options.installPreReleaseVersion,E.options.profileLocation,E.options.productVersion),F=await this.getInstalled(void 0,E.options.profileLocation,E.options.productVersion),q={...E.options,donotIncludePackAndDependencies:!0,context:{...E.options.context,[w.$Io]:!0}};for(const{gallery:Z,manifest:X}of(0,I.$Mb)(T,({gallery:x})=>x.identifier.id)){if(a.has(`${Z.identifier.id.toLowerCase()}-${q.profileLocation.toString()}`))continue;const x=this.j.get(p(Z,q.profileLocation));if(x){if(this.J(E,x.task)){const W=x.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,E.identifier.id),x.waitingTasks.push(E),v.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,K=>K.some(V=>(0,f.$ep)(V.identifier,W)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,E.identifier.id),!K.find(H=>(0,f.$ep)(H.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else F.some(({identifier:W})=>(0,f.$ep)(W,Z.identifier))||S(X,Z,q)}}catch(T){if(C.URI.isUri(E.source))(0,I.$Lb)(D.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",E.identifier.id,T.message),(0,I.$Lb)(D.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",E.identifier.id,T.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",E.identifier.id),T}})),await this.L([...a.values()].map(async({task:E})=>{const D=new Date().getTime();try{const T=await E.run();if(await this.L(this.y.map(F=>F.postInstall(T,E.source,E.options,L.CancellationToken.None))),!C.URI.isUri(E.source)){const F=E.operation===3,q=F?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(o(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$mp)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-D,durationSinceUpdate:q}),P.$o&&E.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}y.push({local:T,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw this.F.error("Error while installing the extension",E.identifier.id,(0,A.$0)(T)),T}})),v.length&&await this.L(v);for(const E of y)this.F.info("Extension installed successfully:",E.identifier.id),r.push(E);return r}catch(E){y.length&&await Promise.allSettled(y.map(async({local:D,profileLocation:T})=>{try{await this.Z(D,{versionOnly:!0,profileLocation:T}).run(),this.F.info("Rollback: Uninstalled extension",D.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",D.identifier.id,(0,A.$0)(F))}}));for(const{task:D}of a.values())D.cancel(),r.push({identifier:D.identifier,operation:2,source:D.source,context:D.options.context,profileLocation:D.profileLocation,error:E});throw E}finally{for(const{task:E}of a.values())E.source&&!C.URI.isUri(E.source)&&this.j.delete(p(E.source,E.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(y=>this.J(y,r)))||a===r&&v[0]&&!this.J(t,v[0]))return!1;return!0}async L(t){const r=[],a=[],v=await Promise.allSettled(t);for(const y of v)y.status==="fulfilled"?r.push(y.value):a.push(y.reason);if(a.length)throw m(a);return r}async M(t,r,a,v,y,p){if(!this.z.isEnabled())return[];const S=await this.getInstalled(void 0,y,p),E=[],D=[],T=async(F,q)=>{E.push(F);const Z=q.extensionDependencies||[],X=[...Z];if(q.extensionPack){const x=a?S.find(W=>(0,f.$ep)(W.identifier,F)):void 0;for(const W of q.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(K=>(0,f.$ep)({id:K},{id:W}))||X.every(K=>!(0,f.$ep)({id:K},{id:W}))&&X.push(W)}if(X.length){const x=X.filter(W=>E.every(K=>!(0,f.$ep)(K,{id:W})));if(x.length){const W=await this.z.getExtensions(x.map(K=>({id:K,preRelease:v})),L.CancellationToken.None);for(const K of W){if(E.find(te=>(0,f.$ep)(te,K.identifier)))continue;const V=Z.some(te=>(0,f.$ep)({id:te},K.identifier));let H;try{H=await this.N(K,!1,v,p)}catch(te){if(V)throw te;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,A.$0)(te));continue}D.push({gallery:H.extension,manifest:H.manifest}),await T(H.extension.identifier,H.manifest)}}}};return await T(t,r),D}async N(t,r,a,v){let y;const p=await this.getExtensionsControlManifest();if(p.malicious.some(D=>(0,f.$ep)(t.identifier,D)))throw new w.$Qo(k.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);const S=p.deprecated[t.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),y=(await this.z.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:v},L.CancellationToken.None))[0],!y)throw new w.$Qo(k.localize(2,null,t.identifier.id,S.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new w.$Qo(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,w.$Jo)(D)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.O(t,r,a,v),!y)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new w.$Qo(k.localize(4,null,t.displayName??t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$Qo(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",y.identifier.id);const E=await this.z.getManifest(y,L.CancellationToken.None);if(E===null)throw new w.$Qo(`Missing manifest for extension ${y.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(E.version!==y.version)throw new w.$Qo(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:E}}async O(t,r,a,v){const y=await this.getTargetPlatform();let p=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(p=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:y,compatible:!0,productVersion:v},L.CancellationToken.None))[0]||null),!p&&await this.z.isExtensionCompatible(t,a,y,v)&&(p=t),p||(r?p=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:y,compatible:!0,productVersion:v},L.CancellationToken.None))[0]||null:p=await this.z.getCompatibleExtension(t,a,y,v)),p}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},v=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,y=this.m.get(v(t.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const p=T=>{const F=this.Z(T,a);return this.m.set(v(F.extension.identifier),F),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),F},S=(T,F)=>{F?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,F.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$lp)(T),error:F}),this.u.fire({identifier:T.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},E=[],D=[];try{E.push(p(t));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,T);for(const q of F)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):E.push(p(q))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(E.map(F=>F.extension),T,t),await this.L(E.map(async F=>{try{if(await F.run(),await this.L(this.y.map(q=>q.postUninstall(F.extension,a,L.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}S(F.extension)}catch(q){const Z=q instanceof w.$Qo?q:new w.$Qo((0,A.$0)(q),w.ExtensionManagementErrorCode.Internal);throw S(F.extension,Z),Z}finally{D.push(F)}}))}catch(T){const F=T instanceof w.$Qo?T:new w.$Qo((0,A.$0)(T),w.ExtensionManagementErrorCode.Internal);for(const q of E){try{q.cancel()}catch{}D.includes(q)||S(q.extension,F)}throw F}finally{for(const T of E)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(t,r,a){for(const v of t){const y=this.U(v,r);if(y.length){const p=y.filter(S=>!t.some(E=>(0,f.$ep)(E.identifier,S.identifier)));if(p.length)throw new Error(this.R(v,p,a))}}}R(t,r,a){return a===t?r.length===1?k.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const y=r.filter(S=>!S.isBuiltin&&v.some(E=>(0,f.$ep)({id:E},S.identifier))),p=[];for(const S of y)p.push(...this.S(S,r,a));return[...y,...p]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,f.$ep)({id:v},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$7p=c,e.$7p=c=ye([Q(0,w.$Po),Q(1,l.$Ll),Q(2,d.$kl),Q(3,b.$Mj),Q(4,$.$6j),Q(5,h.$ml)],c);function m(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof w.$Qo)return s;if(s instanceof w.$Ro){const r=new w.$Qo(s.message,w.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new w.$Qo(s.message,w.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:v,error:y,durationSinceUpdate:p}){let S,E;(0,g.$2f)(a)&&(a===!0?a="Verified":(a===!1||(S=w.ExtensionManagementErrorCode.Signature,E=a),a="Unverified")),y&&(y instanceof w.$Qo||y instanceof w.$Ro?(S=y.code,y.code===w.ExtensionManagementErrorCode.Signature&&(E=y.message)):S=w.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!y,duration:v,errorcode:S,errorcodeDetail:E,durationSinceUpdate:p})}class n{constructor(){this.d=new N.$fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$6g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$6g)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$0p=n}),define(le[52],he([0,1,6,14,2,3,35,10,29,33,12,4,8,18,28,13,7,22]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class h extends Error{constructor(n,s){super(n),this.code=s}}e.$$p=h,e.$_p=(0,k.$gi)("IExtensionsProfileScannerService");let c=class extends L.$Tc{constructor(n,s,t,r,a,v){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new A.$6d),this.onAddExtensions=this.b.event,this.c=this.B(new A.$6d),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$6d),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$6d),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,v=>{const y=[];if(t)y.push(...v);else for(const p of v)n.some(([S])=>(0,g.$ep)(S.identifier,p.identifier)&&S.manifest.version!==p.version)?r.push(p):y.push(p);for(const[p,S]of n){const E=y.findIndex(T=>(0,g.$ep)(T.identifier,p.identifier)&&T.version===p.manifest.version),D={identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:S};E===-1?(a.push(D),y.push(D)):y.splice(E,1,D)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),y}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(v){throw a.length&&this.c.fire({extensions:a,error:v,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:v,profileLocation:s}),v}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const v of r){const y=n.find(([p])=>(0,g.$ep)(p.identifier,v.identifier)&&p.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const v of r)(0,g.$ep)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$4k)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new h((0,$.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const y of a){m(y)||this.w(n);let p;if((0,b.$Tf)(y.relativeLocation)&&y.relativeLocation)p=this.z(y.relativeLocation);else if((0,b.$Tf)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{p=R.URI.revive(y.location);const S=this.y(p);S&&(v=!0,y.relativeLocation=S)}(0,b.$1f)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(v=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:p,version:y.version,metadata:y.metadata})}v&&await this.m.writeFile(n,N.$te.fromString(JSON.stringify(a)))}if(s){r=s(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,N.$te.fromString(JSON.stringify(v)))}return r})}w(n){const s=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$4k)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>m(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$te.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$4k)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$4k)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$4k)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new I.$nh,this.h.set(n,s)),s}};e.$aq=c,e.$aq=c=ye([Q(1,C.$Mk),Q(2,f.$ml),Q(3,u.$kl),Q(4,l.$Ll),Q(5,w.$Mj)],c);function m(o){return(0,b.$Vf)(o)&&(0,P.$Oo)(o.identifier)&&(i(o.location)||(0,b.$Tf)(o.location)&&o.location)&&((0,b.$1f)(o.relativeLocation)||(0,b.$Tf)(o.relativeLocation))&&o.version&&(0,b.$Tf)(o.version)}function i(o){return o?(0,b.$Tf)(o.path)&&(0,b.$Tf)(o.scheme):!1}}),define(le[81],he([0,1,17,6,30,14,7,34,138,2,23,15,5,20,55,88,13,10,157,16,33,45,71,12,4,8,24,3,66,52,18,28,186]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a,v,y,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$fq=e.$eq=e.$dq=e.Translations=void 0,e.$gq=Z;var E;(function(x){function W(K,V){if(K===V)return!0;const H=Object.keys(K),te=new Set;for(const re of Object.keys(V))te.add(re);if(H.length!==te.size)return!1;for(const re of H){if(K[re]!==V[re])return!1;te.delete(re)}return te.size===0}x.equals=W})(E||(e.Translations=E={})),e.$dq=(0,n.$gi)("IExtensionsScannerService");let D=class extends g.$Tc{constructor(W,K,V,H,te,re,ee,ae,J,z,j,M){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=K,this.r=V,this.s=H,this.t=te,this.u=re,this.w=ee,this.y=ae,this.z=J,this.C=z,this.D=j,this.F=M,this.g=this.B(new r.$6d),this.onDidChangeCache=this.g.event,this.h=(0,f.$Tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$pp)(this.w,this.y)),this.G}async scanAllExtensions(W,K,V){const[H,te]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(K)]),re=V?await this.scanExtensionsUnderDevelopment(W,[...H,...te]):[];return this.L(H,te,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const K=[];K.push(this.M(!!W.useCache,W.language)),K.push(this.N(W.language,!!W.checkControlFile));const[V,H]=await Promise.all(K);return this.J([...V,...H],0,W,!1)}async scanUserExtensions(W){const K=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const V=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,H=await this.P(K,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V,W.productVersion??this.R()),te=W.useCache&&!H.devMode&&H.excludeObsolete?this.m:this.n;let re;try{re=await te.scanExtensions(H)}catch(ee){if(ee instanceof v.$$p&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await te.scanExtensions(H);else throw ee}return re=await this.J(re,1,W,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(H=>H.scheme===C.Schemas.file).map(async H=>{const te=await this.P(H,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=K.find(ae=>(0,c.$ep)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,te)))}))).flat();return this.J(V,"development",W,!0)}return[]}async scanExistingExtension(W,K,V){const H=await this.P(W,!1,K,!0,V.language,!0,void 0,V.productVersion??this.R()),te=await this.n.scanExtension(H);return!te||!V.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(W,K,V){const H=await this.P(W,!1,K,!0,V.language,!0,void 0,V.productVersion??this.R()),te=await this.n.scanOneOrMultipleExtensions(H);return this.J(te,K,V,!0)}async scanMetadata(W){const K=(0,f.$Tg)(W,"package.json"),V=(await this.w.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,K){const V=(0,f.$Tg)(W,"package.json"),H=(await this.w.readFile(V)).value.toString(),te=JSON.parse(H);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,te.__metadata={...te.__metadata,...K},await this.w.writeFile((0,f.$Tg)(W,"package.json"),A.$te.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof v.$$p&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$te.fromString(JSON.stringify([])))}catch(K){(0,o.$4k)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,K,V,H){return V.includeAllVersions||(W=this.L(K===0?W:void 0,K===1?W:void 0,K==="development"?W:void 0,await this.getTargetPlatform(),H)),V.includeInvalid||(W=W.filter(te=>te.isValid)),W.sort((te,re)=>{const ee=k.$nc(te.location.fsPath),ae=k.$nc(re.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(W,K,V,H,te){const re=(ae,J,z)=>{if(ae.isValid&&!J.isValid)return!1;if(ae.isValid===J.isValid){if(te&&u.gt(ae.manifest.version,J.manifest.version))return this.y.debug(`Skipping extension ${J.location.path} with lower version ${J.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(u.eq(ae.manifest.version,J.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${J.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===H)return this.y.debug(`Skipping extension ${J.location.path} from different target platform ${J.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${ae.location.path} with ${J.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${J.location.path}.`),!0},ee=new m.$Dm;return W?.forEach(ae=>{const J=ee.get(ae.identifier.id);(!J||re(J,ae,!1))&&ee.set(ae.identifier.id,ae)}),K?.forEach(ae=>{const J=ee.get(ae.identifier.id);if(!J&&W&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!J||re(J,ae,!1))&&ee.set(ae.identifier.id,ae)}),V?.forEach(ae=>{const J=ee.get(ae.identifier.id);(!J||re(J,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(W,K){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),te=await(W&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",te.length),te}async N(W,K){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const H=K?await this.O():{},te=[],re=l.URI.file(k.$hc(k.$jc(C.$Ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of V){const J=H[ae.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":te.push((0,f.$Tg)(re,ae.name));break;default:te.push(l.URI.file(J));break}}const ee=await Promise.all(te.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,I.$Hb)(ee)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,K,V,H,te,re,ee,ae){const J=await this.f(te??w.$w),z=await this.Q(W),j=K&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=j?await this.Q(j):void 0;return new T(W,z,j,M,K,ee,V,H,re,ae.version,ae.date,this.C.commit,!this.z.isBuilt,te,J)}async Q(W){try{const K=await this.w.stat(W);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$eq=D,e.$eq=D=ye([Q(4,y.$ml),Q(5,v.$_p),Q(6,o.$Mk),Q(7,s.$Mj),Q(8,h.$ni),Q(9,t.$6j),Q(10,p.$kl),Q(11,n.$fi)],D);class T{constructor(W,K,V,H,te,re,ee,ae,J,z,j,M,B,U,Y){this.location=W,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=H,this.profile=te,this.profileScanOptions=re,this.type=ee,this.excludeObsolete=ae,this.validate=J,this.productVersion=z,this.productDate=j,this.productCommit=M,this.devMode=B,this.language=U,this.translations=Y}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,K){return(0,f.$Mg)(W.location,K.location)&&W.mtime===K.mtime&&(0,f.$Mg)(W.applicationExtensionslocation,K.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&W.profile===K.profile&&L.$Qn(W.profileScanOptions,K.profileScanOptions)&&W.type===K.type&&W.excludeObsolete===K.excludeObsolete&&W.validate===K.validate&&W.productVersion===K.productVersion&&W.productDate===K.productDate&&W.productCommit===K.productCommit&&W.devMode===K.devMode&&W.language===K.language&&E.equals(W.translations,K.translations)}}e.$fq=T;let F=class extends g.$Tc{constructor(W,K,V,H,te){super(),this.f=W,this.g=K,this.h=V,this.j=H,this.m=te}async scanExtensions(W){const K=W.profile?await this.r(W):await this.n(W);let V={};if(W.excludeObsolete&&W.type===1)try{const H=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(H)}catch{}return(0,$.$7f)(V)?K:K.filter(H=>!V[c.$fp.create(H).toString()])}async n(W){const K=await this.j.resolve(W.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async H=>{if(!H.isDirectory||W.type===1&&(0,f.$Qg)(H.resource).indexOf(".")===0)return null;const te=new T(H.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te)}));return(0,I.$Hb)(V).sort((H,te)=>H.location.path<te.location.path?-1:1)}async r(W){let K=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){K=K.filter(H=>!H.metadata?.isApplicationScoped);const V=await this.s(W.applicationExtensionslocation,H=>!!H.metadata?.isBuiltin||!!H.metadata?.isApplicationScoped,W);K.push(...V)}return K}async s(W,K,V){const H=await this.g.scanProfileExtensions(W,V.profileScanOptions);if(!H.length)return[];const te=await Promise.all(H.map(async re=>{if(K(re)){const ee=new T(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ee,re.metadata)}return null}));return(0,I.$Hb)(te)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,f.$Tg)(W.location,"package.json"))){const K=await this.scanExtension(W);return K?[K]:[]}else return await this.scanExtensions(W)}catch(K){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$0)(K)),[]}}async scanExtension(W,K){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=m.$xm),K=K??V.__metadata,delete V.__metadata;const H=(0,c.$jp)(V.publisher,V.name),te=K?.id?{id:H,uuid:K.id}:{id:H},re=K?.isSystem?0:W.type,ee=re===0||!!K?.isBuiltin;V=await this.t(W.location,V,T.createNlsConfiguration(W));const ae={type:re,identifier:te,manifest:V,location:W.location,isBuiltin:ee,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return W.validate?this.validate(ae,W):ae}}catch(V){W.type!==0&&this.m.error(V)}return null}validate(W,K){let V=!0;const H=(0,i.$up)(K.productVersion,K.productDate,K.location,W.manifest,W.isBuiltin);for(const[te,re]of H)te===b.default.Error&&(V=!1,this.m.error(this.z(K.location,re)));return W.isValid=V,W.validations=H,W}async scanExtensionManifest(W){const K=(0,f.$Tg)(W,"package.json");let V;try{V=(await this.j.readFile(K)).value.toString()}catch(te){return(0,o.$4k)(te)!==1&&this.m.error(this.z(W,(0,d.localize)(0,null,K.path,te.message))),null}let H;try{H=JSON.parse(V)}catch{const re=[];(0,R.$tn)(V,re);for(const ee of re)this.m.error(this.z(W,(0,d.localize)(1,null,K.path,ee.offset,ee.length,(0,P.$bq)(ee.error))));return null}return(0,R.$Cn)(H)!=="object"?(this.m.error(this.z(W,(0,d.localize)(2,null,K.path))),null):H}async t(W,K,V){const H=await this.u(W,K,V);if(H)try{const te=[],re=await this.w(H.default,te);if(te.length>0)return te.forEach(ae=>{this.m.error(this.z(W,(0,d.localize)(3,null,H.default?.path,(0,P.$bq)(ae.error))))}),K;if((0,R.$Cn)(H)!=="object")return this.m.error(this.z(W,(0,d.localize)(4,null,H.default?.path))),K;const ee=H.values||Object.create(null);return(0,S.$cq)(this.m,K,ee,re)}catch{}return K}async u(W,K,V){const H=(0,f.$Tg)(W,"package.nls.json"),te=(J,z)=>{z.forEach(j=>{this.m.error(this.z(W,(0,d.localize)(5,null,J?.path,(0,P.$bq)(j.error))))})},re=J=>{this.m.error(this.z(W,(0,d.localize)(6,null,J?.path)))},ee=`${K.publisher}.${K.name}`,ae=V.translations[ee];if(ae)try{const J=l.URI.file(ae),z=(await this.j.readFile(J)).value.toString(),j=[],M=(0,R.$tn)(z,j);return j.length>0?(te(J,j),{values:void 0,default:H}):(0,R.$Cn)(M)!=="object"?(re(J),{values:void 0,default:H}):{values:M.contents?M.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.j.exists(H))return;let z;try{z=await this.y(W,V)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const j=(await this.j.readFile(z.localized)).value.toString(),M=[],B=(0,R.$tn)(j,M);return M.length>0?(te(z.localized,M),{values:void 0,default:z.original}):(0,R.$Cn)(B)!=="object"?(re(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(W,K){if(W)try{const V=(await this.j.readFile(W)).value.toString();return(0,R.$tn)(V,K)}catch{}}y(W,K){return new Promise((V,H)=>{const te=re=>{const ee=(0,f.$Tg)(W,`package.nls.${re}.json`);this.j.exists(ee).then(ae=>{ae&&V({localized:ee,original:(0,f.$Tg)(W,"package.nls.json")});const J=re.lastIndexOf("-");J===-1?V({localized:(0,f.$Tg)(W,"package.nls.json"),original:null}):(re=re.substring(0,J),te(re))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,f.$Tg)(W,"package.nls.json"),original:null});te(K.language)})}z(W,K){return`[${W.path}]: ${K}`}};F=ye([Q(1,v.$_p),Q(2,p.$kl),Q(3,o.$Mk),Q(4,s.$Mj)],F);let q=class extends F{constructor(W,K,V,H,te,re,ee){super(K,H,te,re,ee),this.G=W,this.H=V,this.D=this.B(new N.$eh(3e3)),this.F=this.B(new r.$6d),this.onDidChangeCache=this.F.event}async scanExtensions(W){const K=this.M(W),V=await this.I(K);if(this.C=W,V&&V.input&&T.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),V.result.map(te=>(te.location=l.URI.revive(te.location),te));const H=await super.scanExtensions(W);return await this.J(K,{input:W,result:H}),H}async I(W){try{const K=await this.j.readFile(W),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,a.$Ph)(V.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$0)(K))}return null}async J(W,K){try{await this.j.writeFile(W,A.$te.fromString(JSON.stringify(K)))}catch(V){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$0)(V))}}async L(){if(!this.C)return;const W=this.M(this.C),K=await this.I(W);if(!K)return;const V=K.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$Qn(H,V))try{this.m.info("Invalidating Cache",V,H),await this.j.del(W),this.F.fire()}catch(te){this.m.error(te)}}M(W){const K=this.N(W);return this.h.extUri.joinPath(K.cacheHome,W.type===0?m.$wm:m.$vm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(W.location,K.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([Q(2,y.$ml),Q(3,v.$_p),Q(4,p.$kl),Q(5,o.$Mk),Q(6,s.$Mj)],q);function Z(x,W){const K=(0,c.$hp)(x.manifest.publisher,x.manifest.name);return{id:K,identifier:new m.$Bm(K),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:W,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}class X extends D{constructor(W,K,V,H,te,re,ee,ae,J,z,j,M){super(W,K,(0,f.$Tg)(V,".vscode-oss-dev","extensions","control.json"),H,te,re,ee,ae,J,z,j,M),this.S=(async()=>{if(w.$z)try{const B=await this.w.readFile(l.URI.file(w.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$hq=X}),define(le[248],he([0,1,67,6,38,3,2,23,15,31,8,18]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;let w=class extends O.$Tc{constructor(u,b){super(),this.b=u,this.f=b,this.a=new N.$mh(5)}async postUninstall(u){const b=this.g(u,"uninstall");b&&(this.f.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,u),this.f.info("Finished running post uninstall script",u.identifier.id,u.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",u.identifier.id,u.manifest.version),this.f.error($)}}));try{await g.Promises.rm(this.m(u))}catch($){this.f.error("Error while removing extension storage path",u.identifier.id),this.f.error($)}}g(u,b){const $=`vscode:${b}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[$]=="string"){const l=u.manifest.scripts[$].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(u.identifier.id,u.manifest.version,`${$} should be a node script`),null):{script:(0,P.$jc)(u.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(u,b,$,l,d){return new Promise((h,c)=>{const m=this.j(u,b,$,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):h(void 0)};m.on("error",n=>{o((0,L.$4i)(n)||"Unknown")}),m.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),l&&(i=setTimeout(()=>{i=null,m.kill(),c("timed out")},5e3))})}j(u,b,$,l){const d={silent:!0,execArgv:void 0},h=(0,I.fork)(u,[`--type=extension-post-${b}`,...$],d);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const c=A.Event.fromNodeEventEmitter(h.stdout,"data"),m=A.Event.fromNodeEventEmitter(h.stderr,"data");c(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${b}`,n)),m(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${b}`,n));const i=A.Event.any(A.Event.map(c,n=>({data:`%c${n}`,format:[""]})),A.Event.map(m,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(u){return(0,P.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};e.$jq=w,e.$jq=w=ye([Q(0,k.$ml),Q(1,C.$Mj)],w)}),define(le[113],he([0,1,6,14,26,38,7,3,54,2,35,23,15,20,55,13,10,32,31,70,158,95,16,247,29,33,52,81,228,248,187,218,229,71,12,4,8,24,22,28,18]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a,v,y,p,S,E,D,T,F,q,Z,X,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.$nq=void 0,e.$nq=(0,T.$hi)(n.$So);const W=".vsctmp";let K=class extends o.$7p{constructor(J,z,j,M,B,U,Y,_,ne,G,ie,ce){super(J,z,ie,j,G,ce),this.eb=B,this.fb=U,this.gb=Y,this.hb=ne,this.db=new Map,this.qb=new C.$Bc;const fe=this.B(_.createInstance(v.$jq));this.ab=this.B(_.createInstance(V,me=>fe.postUninstall(me))),this.bb=this.B(new p.$lq(ce,ne,ie,this,this.F)),this.cb=this.B(_.createInstance(a.$iq));const de=this.B(new S.$mq(this,this.eb,ce,U,ie,ne,j));this.B(de.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$pp)(this.hb,this.F)),this.ib}async zip(J){this.F.trace("ExtensionManagementService#zip",J.identifier.id);const z=await this.ob(J),j=await(0,h.zip)((0,f.$Tg)(this.cb.extensionsDownloadDir,(0,l.$Cg)()).fsPath,z);return $.URI.file(j)}async unzip(J){return this.F.trace("ExtensionManagementService#unzip",J.toString()),(await this.install(J)).identifier}async getManifest(J){const{location:z,cleanup:j}=await this.kb(J),M=w.$kc(z.fsPath);try{return await(0,y.$kq)(M)}finally{await j()}}getInstalled(J,z=this.H.defaultProfile.extensionsResource,j={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(J??null,z,j)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(J){return this.ab.scanUserExtensionAtLocation(J)}async install(J,z={}){this.F.trace("ExtensionManagementService#install",J.toString());const{location:j,cleanup:M}=await this.kb(J);try{const B=await(0,y.$kq)(w.$kc(j.fsPath)),U=(0,s.$jp)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,E.$wp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,U,this.G.version));const _=(await this.I([{manifest:B,extension:j,options:z}])).find(({identifier:ne})=>(0,s.$ep)(ne,{id:U}));if(_?.local)return _.local;throw _?.error?_.error:(0,o.$9p)(new Error(`Unknown error while installing extension ${U}`))}finally{await M()}}async installFromLocation(J,z){this.F.trace("ExtensionManagementService#installFromLocation",J.toString());const j=await this.ab.scanUserExtensionAtLocation(J);if(!j||!j.manifest.name||!j.manifest.version)throw new Error(`Cannot find a valid extension from the location ${J.toString()}`);return await this.tb([[j,void 0]],z),this.F.info("Successfully installed extension",j.identifier.id,z.toString()),j}async installExtensionsFromProfile(J,z,j){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",J,z.toString(),j.toString());const M=(await this.getInstalled(1,z)).filter(B=>J.some(U=>(0,s.$ep)(U,B.identifier)));if(M.length){const B=await Promise.all(M.map(U=>this.ab.scanMetadata(U,z)));await this.tb(M.map((U,Y)=>[U,B[Y]]),j),this.F.info("Successfully installed extensions",M.map(U=>U.identifier.id),j.toString())}return M}async updateMetadata(J,z,j=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",J.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),J=await this.ab.updateMetadata(J,z,j),this.bb.invalidate(j),this.w.fire(J),J}async reinstallFromGallery(J){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",J.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const z=await this.getTargetPlatform(),[j]=await this.z.getExtensions([{...J.identifier,preRelease:J.preRelease}],{targetPlatform:z,compatible:!0},L.CancellationToken.None);if(!j)throw new Error(c.localize(2,null));await this.ab.setUninstalled(J);try{await this.ab.removeUninstalledExtension(J)}catch(M){throw new Error(c.localize(3,null,(0,A.$4i)(M)))}return this.installFromGallery(j)}$(J,z,j,M){return this.ab.copyExtension(J,z,j,M)}copyExtensions(J,z){return this.ab.copyExtensions(J,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...J){return this.ab.setUninstalled(...J)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(J){this.F.error(J)}}async download(J,z,j){const{location:M}=await this.cb.download(J,z,!j);return M}async kb(J){if(J.scheme===k.Schemas.file)return{location:J,async cleanup(){}};this.F.trace("Downloading extension from",J.toString());const z=(0,f.$Tg)(this.cb.extensionsDownloadDir,(0,l.$Cg)());return await this.gb.download(J,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(M){this.F.error(M)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(J,z,j){if($.URI.isUri(z))return new re(J,z,j,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const M=s.$fp.create(z).toString();let B=this.db.get(M);return B||(this.db.set(M,B=new te(J,z,j,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.db.delete(M))),B}Z(J,z){return new ee(J,z.profileLocation,this.fb)}async ob(J){const z=async M=>{let B=await d.Promises.readdir(M);B=B.map(_=>w.$jc(M,_));const U=await Promise.all(B.map(_=>d.Promises.stat(_)));let Y=Promise.resolve([]);return U.forEach((_,ne)=>{const G=B[ne];_.isFile()&&(Y=Y.then(ie=>[...ie,G])),_.isDirectory()&&(Y=Y.then(ie=>z(G).then(ce=>[...ie,...ce])))}),Y};return(await z(J.location.fsPath)).map(M=>({path:`extension/${w.$lc(J.location.fsPath,M)}`,localPath:M}))}async pb({added:J,removed:z}){if(z){const j=J&&this.D.extUri.isEqual(z.profileLocation,J.profileLocation)?z.extensions.filter(M=>J.extensions.every(B=>!(0,s.$ep)(B,M))):z.extensions;for(const M of j)this.F.info("Extensions removed from another source",M.id,z.profileLocation.toString()),this.u.fire({identifier:M,profileLocation:z.profileLocation})}if(J){const M=(await this.getInstalled(1,J.profileLocation)).filter(B=>J.extensions.some(U=>(0,s.$ep)(U,B.identifier)));this.s.fire(M.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,J.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:J.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const J=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of J.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(J){if(!J.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const j of J.rawAdded){if(this.qb.has(j)||!this.D.extUri.isEqual(this.D.extUri.dirname(j),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(j,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(j).startsWith(".")||!(await this.hb.stat(j)).isDirectory)continue;const M=await this.ab.scanUserExtensionAtLocation(j);M&&M.installedTimestamp===void 0&&(this.qb.add(j),z.push(M))}z.length&&(await this.tb(z.map(j=>[j,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(j=>j.identifier.id)))}async tb(J,z){const j=J.map(M=>M[0]);await this.ub(j),await this.fb.addExtensionsToProfile(J,z),this.s.fire(j.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:z})))}async ub(J){const z=await this.ab.getUninstalledExtensions();for(const j of J){const M=s.$fp.create(j);z[M.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",M.id),await this.ab.setInstalled(M),this.F.info("Removed the extension from uninstalled list:",M.id))}}};e.$oq=K,e.$oq=K=ye([Q(0,n.$Po),Q(1,Z.$Ll),Q(2,F.$Mj),Q(3,i.$oi),Q(4,r.$dq),Q(5,t.$_p),Q(6,m.$uo),Q(7,T.$fi),Q(8,D.$Mk),Q(9,q.$6j),Q(10,X.$kl),Q(11,x.$ml)],K);let V=class extends g.$Tc{constructor(J,z,j,M,B,U){super(),this.j=J,this.m=z,this.n=j,this.s=M,this.t=B,this.u=U,this.h=this.B(new R.$6d),this.onExtract=this.h.event,this.c=(0,f.$Tg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$nh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(J,z,j){const M={includeInvalid:!0,profileLocation:z,productVersion:j};let B=[];return J===null||J===0?B.push(...await this.n.scanAllExtensions({includeInvalid:!0},M,!1)):J===1&&B.push(...await this.n.scanUserExtensions(M)),B=J!==null?B.filter(U=>U.type===J):B,Promise.all(B.map(U=>this.F(U)))}async scanAllUserExtensions(J){const z=await this.n.scanUserExtensions({includeAllVersions:!J,includeInvalid:!0});return Promise.all(z.map(j=>this.F(j)))}async scanUserExtensionAtLocation(J){try{const z=await this.n.scanExistingExtension(J,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(J,z,j,M,B){const U=J.toString(),Y=$.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Cg)()}`)),_=$.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,U));let ne=await this.m.exists(_);if(ne&&M){try{await this.y(J.id,_,"removeExisting")}catch{throw new n.$Qo(c.localize(4,null,_.fsPath,J.id),n.ExtensionManagementErrorCode.Delete)}ne=!1}if(ne)await this.n.updateMetadata(_,j);else try{try{this.u.trace(`Started extracting the extension from ${z} to ${_.fsPath}`),await(0,h.$5p)(z,Y.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${_}:`,J.id)}catch(G){let ie=n.ExtensionManagementErrorCode.Extract;throw G instanceof h.$3p&&(G.type==="CorruptZip"?ie=n.ExtensionManagementErrorCode.CorruptZip:G.type==="Incomplete"&&(ie=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Qo(G.message,ie)}await this.n.updateMetadata(Y,j);try{this.u.trace(`Started renaming the extension from ${Y.fsPath} to ${_.fsPath}`),await this.C(Y.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(G){if(G.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",J.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(G)}. Deleted from extracted location`,Y),G}this.h.fire(_)}catch(G){try{await this.m.del(Y,{recursive:!0})}catch{}throw G}return this.D(_,1)}async scanMetadata(J,z){return z?(await this.w(J,z))?.metadata:this.n.scanMetadata(J.location)}async w(J,z){return(await this.s.scanProfileExtensions(z)).find(M=>(0,s.$ep)(M.identifier,J.identifier))}async updateMetadata(J,z,j){return j?await this.s.updateMetadata([[J,z]],j):await this.n.updateMetadata(J.location,z),this.D(J.location,J.type,j)}getUninstalledExtensions(){return this.z()}async setUninstalled(...J){const z=J.map(j=>s.$fp.create(j));await this.z(j=>z.forEach(M=>{j[M.toString()]=!0,this.u.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(J){await this.z(z=>delete z[J.toString()])}async removeExtension(J,z){if(this.t.extUri.isEqualOrParent(J.location,this.n.userExtensionsLocation))return this.y(J.identifier.id,J.location,z)}async removeUninstalledExtension(J){await this.removeExtension(J,"uninstalled"),await this.z(z=>delete z[s.$fp.create(J).toString()])}async copyExtension(J,z,j,M){const B=await this.w(J,z),U=await this.w(J,j);if(M={...B?.metadata,...M},U)if(this.t.extUri.isEqual(U.location,J.location))await this.s.updateMetadata([[J,{...U.metadata,...M}]],j);else{const Y=await this.D(U.location,J.type,j);await this.s.removeExtensionFromProfile(Y,j),await this.s.addExtensionsToProfile([[J,{...U.metadata,...M}]],j)}else await this.s.addExtensionsToProfile([[J,M]],j);return this.D(J.location,J.type,j)}async copyExtensions(J,z,j){const M=await this.scanExtensions(1,J,j),B=await Promise.all(M.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,J)]));await this.s.addExtensionsToProfile(B,z)}async y(J,z,j){this.u.trace(`Deleting ${j} extension from disk`,J,z.fsPath);const M=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,P.$7i)((0,l.$Cg)()).toString(16)}${W}`);await this.C(z.fsPath,M.fsPath),await this.m.del(M,{recursive:!0}),this.u.info(`Deleted ${j} extension from disk`,J,z.fsPath)}async z(J){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,D.$4k)(M)!==1)throw M}let j={};if(z)try{j=JSON.parse(z)}catch{}return J&&(J(j),Object.keys(j).length?await this.m.writeFile(this.c,N.$te.fromString(JSON.stringify(j))):await this.m.del(this.c)),j})}async C(J,z){try{await d.Promises.rename(J,z,2*60*1e3)}catch(j){throw new n.$Qo(j.message||c.localize(5,null,J,z),j.code||n.ExtensionManagementErrorCode.Rename)}}async D(J,z,j){if(j){const B=(await this.n.scanUserExtensions({profileLocation:j})).find(U=>this.t.extUri.isEqual(U.location,J));if(B)return this.F(B)}else{const M=await this.n.scanExistingExtension(J,z,{includeInvalid:!0});if(M)return this.F(M)}throw new Error(c.localize(6,null,J.path))}async F(J){const z=await this.m.resolve(J.location);let j,M;return z.children&&(j=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,M=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:J.identifier,type:J.type,isBuiltin:J.isBuiltin||!!J.metadata?.isBuiltin,location:J.location,manifest:J.manifest,targetPlatform:J.targetPlatform,validations:J.validations,isValid:J.isValid,readmeUrl:j,changelogUrl:M,publisherDisplayName:J.metadata?.publisherDisplayName||null,publisherId:J.metadata?.publisherId||null,isApplicationScoped:!!J.metadata?.isApplicationScoped,isMachineScoped:!!J.metadata?.isMachineScoped,isPreReleaseVersion:!!J.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!J.metadata?.hasPreReleaseVersion,preRelease:!!J.metadata?.preRelease,installedTimestamp:J.metadata?.installedTimestamp,updated:!!J.metadata?.updated,pinned:!!J.metadata?.pinned}}async G(){const J=await this.getUninstalledExtensions();if(Object.keys(J).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(J));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const B of z)J[s.$fp.create(B).toString()]||j.add(B.identifier.id.toLowerCase());try{const B=(0,s.$kp)(z,U=>U.identifier);await I.Promises.settled(B.map(async U=>{const Y=U.sort((_,ne)=>u.rcompare(_.manifest.version,ne.manifest.version))[0];j.has(Y.identifier.id.toLowerCase())||await this.j(await this.F(Y))}))}catch(B){this.u.error(B)}const M=z.filter(B=>B.metadata&&J[s.$fp.create(B).toString()]);await Promise.allSettled(M.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let J;try{J=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,D.$4k)(z)!==1&&this.u.error(z);return}if(J?.children)try{await Promise.allSettled(J.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(j){(0,D.$4k)(j)!==1&&this.u.error(j)}}}))}catch{}}};e.$pq=V,e.$pq=V=ye([Q(1,D.$Mk),Q(2,r.$dq),Q(3,t.$_p),Q(4,X.$kl),Q(5,F.$Mj)],V);class H extends o.$0p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$1f)(this.options.operation)?this.l:this.options.operation}constructor(J,z,j,M,B,U,Y,_,ne){super(),this.identifier=J,this.source=z,this.options=j,this.m=M,this.n=B,this.o=U,this.p=Y,this.q=_,this.s=ne,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(J){const[z,j]=await this.x(J);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,j]],this.j,!z.isValid),z}async u({zipPath:J,key:z,metadata:j},M,B){let U=await this.v(z);return U?U=await this.m.updateMetadata(U,j):(this.s.trace("Extracting extension...",z.id),U=await this.m.extractUserExtension(z,J,j,M,B),this.s.info("Extracting extension completed.",z.id)),U}async v(J){return await this.w(J)?(this.s.trace("Removing the extension from uninstalled list:",J.id),await this.m.setInstalled(J),this.s.info("Removed the extension from uninstalled list:",J.id),(await this.m.scanAllUserExtensions(!0)).find(M=>s.$fp.create(M).equals(J))):void 0}async w(J){return!!(await this.m.getUninstalledExtensions())[J.toString()]}}class te extends H{constructor(J,z,j,M,B,U,Y,_,ne,G){super(z.identifier,z,j,B,U,Y,_,ne,G),this.y=z,this.z=M}async x(J){let z;try{z=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(Y){throw new n.$Qo(Y,n.ExtensionManagementErrorCode.Scanning)}const j=z.find(Y=>(0,s.$ep)(Y.identifier,this.y.identifier));j&&(this.l=3);const M={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:j?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned,preRelease:(0,b.$Zf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||j?.preRelease};if(j?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(j,M),M]}catch(Y){throw new n.$Qo((0,O.$0)(Y),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:B,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$fp.create(this.y),metadata:M},!1,J),M]}catch(Y){try{await this.z.delete(B)}catch(_){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,O.$0)(_))}throw Y}}async B(J){try{await(0,y.$kq)(J)}catch(z){throw new n.$Qo((0,o.$8p)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$qq=te;class re extends H{constructor(J,z,j,M,B,U,Y,_,ne,G){super({id:(0,s.$jp)(J.publisher,J.name)},z,j,B,U,Y,_,ne,G),this.y=J,this.z=z,this.A=M}async h(J){const z=await super.h(J);return this.D(z,J),z}async x(J){const z=new s.$fp(this.identifier,this.y.version),M=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(Y=>(0,s.$ep)(this.identifier,Y.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned};if(M)if(this.l=3,z.equals(new s.$fp(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&u.gt(M.manifest.version,this.y.version)&&await this.m.setUninstalled(M);else{const Y=await this.v(z);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$kc(this.z.fsPath),key:z,metadata:B},!0,J),B]}async D(J,z){try{let[j]=await this.A.getExtensions([{id:J.identifier.id,version:J.manifest.version}],z);if(j||([j]=await this.A.getExtensions([{id:J.identifier.id}],z)),j){const M={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,hasPreReleaseVersion:J.hasPreReleaseVersion||j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(J,M,this.options.profileLocation)}}catch{}}}class ee extends o.$0p{constructor(J,z,j){super(),this.extension=J,this.j=z,this.k=j}async h(J){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[249],he([0,1,8,18,28,22,52,12,16,10]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=void 0;let C=class extends O.$aq{constructor(w,f,u,b,$,l){super(g.URI.file(w.extensionsPath),f,u,b,$,l)}};e.$UP=C,e.$UP=C=ye([Q(0,P.$oi),Q(1,R.$Mk),Q(2,N.$ml),Q(3,L.$kl),Q(4,A.$Ll),Q(5,I.$Mj)],C)}),define(le[250],he([0,1,10,16,52,81,12,4,8,24,28,18]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;let w=class extends A.$hq{constructor(u,b,$,l,d,h,c,m){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,u.defaultProfile,u,b,$,l,d,h,c,m)}};e.$Vac=w,e.$Vac=w=ye([Q(0,k.$ml),Q(1,L.$_p),Q(2,O.$Mk),Q(3,P.$Mj),Q(4,N.$oi),Q(5,g.$6j),Q(6,C.$kl),Q(7,R.$fi)],w)}),define(le[19],he([0,1,6,3,2,99,13,69,4,18]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Mp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Kp=e.$Jp=e.$Ip=void 0,e.$Lp=f,e.$Np=b,e.$Pp=l,e.$Ip="__$__isNewStorageMarker",e.$Jp="__$__targetStorageMarker",e.$Kp=(0,P.$gi)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var k;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function f(d){const h=d.get(e.$Jp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class u extends L.$Tc{static{this.a=60*1e3}constructor(h={flushInterval:u.a}){super(),this.m=h,this.b=this.B(new N.$9d),this.c=this.B(new N.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new I.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,c,m){return N.Event.filter(this.b.event,i=>i.scope===h&&(c===void 0||i.key===c),m)}n(){this.j.value=(0,I.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,c){const{key:m,external:i}=c;if(m===e.$Jp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:m,target:this.J(h)[m],external:i})}w(h){this.f.fire({reason:h})}get(h,c,m){return this.P(c)?.get(h,m)}getBoolean(h,c,m){return this.P(c)?.getBoolean(h,m)}getNumber(h,c,m){return this.P(c)?.getNumber(h,m)}getObject(h,c,m){return this.P(c)?.getObject(h,m)}storeAll(h,c){this.y(()=>{for(const m of h)this.store(m.key,m.value,m.scope,m.target,c)})}store(h,c,m,i,o=!1){if((0,O.$3f)(c)){this.remove(h,m,o);return}this.y(()=>{this.z(h,m,i),this.P(m)?.set(h,c,o)})}remove(h,c,m=!1){this.y(()=>{this.z(h,c,void 0),this.P(c)?.delete(h,m)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,c){const m=[],i=this.J(h);for(const o of Object.keys(i))i[o]===c&&m.push(o);return m}z(h,c,m,i=!1){const o=this.J(c);typeof m=="number"?o[h]!==m&&(o[h]=m,this.P(c)?.set(e.$Jp,JSON.stringify(o),i)):typeof o[h]=="number"&&(delete o[h],this.P(c)?.set(e.$Jp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const c=this.P(h);return c?f(c):Object.create(null)}isNew(h){return this.getBoolean(e.$Ip,h)===!0}async flush(h=C.NONE){this.f.fire({reason:h});const c=this.P(-1),m=this.P(0),i=this.P(1);switch(h){case C.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,m=this.P(1)?.items??new Map;return l(h,c,m,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,c){return this.w(C.NONE),(0,g.$ll)(h)?this.R(h,c):this.S(h,c)}M(h,c){return!(h.id===c.id||b(c)&&b(h))}N(h,c,m){this.y(()=>{const i=new Set;for(const[o,n]of h)i.add(o),c.get(o)!==n&&this.u(m,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(m,{key:o,external:!0})})}}e.$Mp=u;function b(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class $ extends u{constructor(){super(),this.U=this.B(new R.$Gp(new R.$Hp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Gp(new R.$Hp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Gp(new R.$Hp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Op=$;async function l(d,h,c,m,i,o){const n=E=>{try{return JSON.parse(E)}catch{return E}},s=new Map,t=new Map;d.forEach((E,D)=>{s.set(D,E),t.set(D,n(E))});const r=new Map,a=new Map;h.forEach((E,D)=>{r.set(D,E),a.set(D,n(E))});const v=new Map,y=new Map;c.forEach((E,D)=>{v.set(D,E),y.set(D,n(E))}),console.group(m!==i?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const p=[];if(s.forEach((E,D)=>{p.push({key:D,value:E})}),console.table(p),console.groupEnd(),console.log(t),m!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const E=[];r.forEach((D,T)=>{E.push({key:T,value:D})}),console.table(E),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const S=[];v.forEach((E,D)=>{S.push({key:D,value:E})}),console.table(S),console.groupEnd(),console.log(y)}}),define(le[114],he([0,1,3,2,13,29,33,19]),function(se,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sHb=e.$rHb=void 0;let P=class extends N.$Tc{constructor(k,w){super(),this.a=new I.$6d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(k)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(w.onDidInstallExtensions(f=>f.forEach(({local:u,operation:b})=>{u&&b===4&&this.f(u.identifier)})))}async enableExtension(k,w){return this.f(k)?(this.a.fire({extensions:[k],source:w}),!0):!1}async disableExtension(k,w){return this.c(k)?(this.a.fire({extensions:[k],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.$To)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(k){const w=this.getDisabledExtensions();return w.every(f=>!(0,O.$ep)(f,k))?(w.push(k),this.g(w),!0):!1}f(k){const w=this.getDisabledExtensions();for(let f=0;f<w.length;f++){const u=w[f];if((0,O.$ep)(u,k))return w.splice(f,1),this.g(w),!0}return!1}g(k){this.j(A.$To,k)}h(k){return this.b.get(k,0)}j(k,w){this.b.set(k,w,0)}};e.$rHb=P,e.$rHb=P=ye([Q(0,R.$Kp),Q(1,A.$So)],P);class g extends N.$Tc{constructor(k){super(),this.c=k,this.a=Object.create(null),this.b=this.B(new I.$6d),this.onDidChange=this.b.event,this.B(k.onDidChangeValue(0,void 0,this.B(new N.$Sc))(w=>this.f(w)))}get(k,w){let f;return w===0?((0,L.$3f)(this.a[k])&&(this.a[k]=this.g(k,w)),f=this.a[k]):f=this.g(k,w),JSON.parse(f)}set(k,w,f){const u=JSON.stringify(w.map(({id:$,uuid:l})=>({id:$,uuid:l})));this.g(k,f)!==u&&(f===0&&(w.length?this.a[k]=u:delete this.a[k]),this.h(k,w.length?u:void 0,f))}f(k){if(!(0,L.$3f)(this.a[k.key])&&this.g(k.key,k.scope)!==this.a[k.key]){const f=this.get(k.key,k.scope);delete this.a[k.key];const u=this.get(k.key,k.scope),b=f.filter(l=>!u.some(d=>(0,O.$ep)(l,d))),$=u.filter(l=>!f.some(d=>(0,O.$ep)(d,l)));(b.length||$.length)&&this.b.fire([...b,...$])}}g(k,w){return this.c.get(k,w,"[]")}h(k,w,f){w?this.c.store(k,w,f,1):this.c.remove(k,f)}}e.$sHb=g}),define(le[251],he([0,1,17,26,7,5,36,13,10,21,16,29,33,71,12,8,24,59,230,19,22,63]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Sp=re;const i=A.$o?"web":(0,k.$Lo)(A.$u,O.$ec),o="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce((B,U)=>B|U,0))}var t;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class p{constructor(B=y){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,U=this.d.pageSize){return new p({...this.d,pageNumber:B,pageSize:U})}withFilter(B,...U){const Y=[...this.d.criteria,...U.length?U.map(_=>({filterType:B,value:_})):[{filterType:B}]];return new p({...this.d,criteria:Y})}withSortBy(B){return new p({...this.d,sortBy:B})}withSortOrder(B){return new p({...this.d,sortOrder:B})}withFlags(...B){return new p({...this.d,flags:B.reduce((U,Y)=>U|Y,0)})}withAssetTypes(...B){return new p({...this.d,assetTypes:B})}withSource(B){return new p({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:U,pageSize:Y,sortBy:_,sortOrder:ne,flags:G,assetTypes:ie}=this.d;return{filters:[{criteria:B,pageNumber:U,pageSize:Y,sortBy:_,sortOrder:ne}],assetTypes:ie,flags:G}}get searchText(){const B=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(M,B){const U=(M||[]).filter(Y=>Y.statisticName===B)[0];return U?U.value:0}function E(M){const B="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(Y=>Y.assetType.indexOf(B)===0).reduce((Y,_)=>{const ne=F(M,_.assetType);return ne&&Y.push([_.assetType.substring(B.length),ne]),Y},[])}function D(M){if(M.properties){const B=M.properties.filter(_=>_.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=B.filter(_=>U.test(_.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return F(M,r.Repository)}function T(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,B){return M.files.filter(Y=>Y.assetType===B)[0]?{uri:`${M.assetUri}/${B}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${B}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function q(M,B){const U=M.properties?M.properties.filter(_=>_.key===B):[],Y=U.length>0&&U[0].value;return Y?Y.split(",").map(_=>(0,w.$ip)(_)):[]}function Z(M){const B=M.properties?M.properties.filter(U=>U.key===a.Engine):[];return B.length>0&&B[0].value||""}function X(M){const B=M.properties?M.properties.filter(U=>U.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(M){const B=M.properties?M.properties.filter(Y=>Y.key===a.LocalizedLanguages):[],U=B.length>0&&B[0].value||"";return U?U.split(","):[]}function W(M){return M.properties?.find(B=>B.key===a.SponsorLink)?.value}function K(M){return M.properties?.find(B=>B.key===a.SupportLink)?.value}function V(M){return M.indexOf("preview")!==-1}function H(M){return M.targetPlatform?(0,k.$Ko)(M.targetPlatform):"undefined"}function te(M){const B=(0,I.$Mb)(M.versions.map(H)),U=!!M.tags?.includes(k.$Fo),Y=B.indexOf("web");return U?Y===-1&&B.push("web"):Y!==-1&&B.splice(Y,1),B}function re(M,B){for(let U=0;U<M.length;U++){const Y=M[U];if(Y.version===M[U-1]?.version){let _=U;if(H(Y)===B)for(;_>0&&M[_-1].version===Y.version;)_--;_!==U&&(M.splice(U,1),M.splice(_,0,Y))}}return M}function ee(M,B,U){M.telemetryData={index:B,querySource:U,queryActivityId:M.queryContext?.[o]}}function ae(M,B,U,Y){const _=M.versions[0],ne={manifest:F(B,r.Manifest),readme:F(B,r.Details),changelog:F(B,r.Changelog),license:F(B,r.License),repository:D(B),download:T(B),icon:F(B,r.Icon),signature:F(B,r.Signature),coreTranslations:E(B)};return{identifier:{id:(0,w.$jp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:B.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(_),description:M.shortDescription??"",installCount:S(M.statistics,"install"),rating:S(M.statistics,"averagerating"),ratingCount:S(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:U,assets:ne,properties:{dependencies:q(B,a.Dependency),extensionPack:q(B,a.ExtensionPack),engine:Z(B),localizedLanguages:x(B),targetPlatform:H(B),isPreReleaseVersion:X(B)},hasPreReleaseVersion:X(_),hasReleaseVersion:!0,preview:V(M.flags),isSigned:!!ne.signature,queryContext:Y,supportLink:K(_)}}let J=class{constructor(B,U,Y,_,ne,G,ie,ce){this.k=U,this.l=Y,this.n=_,this.o=ne,this.q=G,this.u=ie,this.w=ce;const fe=ie.extensionsGallery,de=fe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?fe.servicePPEUrl:fe?.serviceUrl,this.g=de?void 0:fe?.searchUrl,this.h=fe?.controlUrl,this.j=(0,d.$Rp)(ie.version,ie,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,U,Y){const _=N.CancellationToken.isCancellationToken(U)?{}:U,ne=N.CancellationToken.isCancellationToken(U)?U:Y,G=[],ie=[],ce=[],fe=[];let de=!0;for(const Re of B){Re.uuid?ie.push(Re.uuid):G.push(Re.id);const Oe=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:Oe}),Re.version&&fe.push({id:Re.id,uuid:Re.uuid,version:Re.version}),de=de&&!!Re.hasPreRelease&&!Oe}if(!ie.length&&!G.length)return[];let me=new p().withPage(1,B.length);ie.length&&(me=me.withFilter(t.ExtensionId,...ie)),G.length&&(me=me.withFilter(t.ExtensionName,...G)),(_.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),_.source&&(me=me.withSource(_.source));const{extensions:Ee}=await this.z(me,{targetPlatform:_.targetPlatform??i,includePreRelease:ce,versions:fe,compatible:!!_.compatible,productVersion:_.productVersion??{version:this.u.version,date:this.u.date}},ne);return _.source&&Ee.forEach((Re,Oe)=>ee(Re,Oe,_.source)),Ee}async getCompatibleExtension(B,U,Y,_={version:this.u.version,date:this.u.date}){if((0,k.$Mo)(B.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(B,U,Y))return B;const ne=new p().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:G}=await this.z(ne,{targetPlatform:Y,compatible:!0,includePreRelease:U,productVersion:_},N.CancellationToken.None);return G[0]||null}async isExtensionCompatible(B,U,Y,_={version:this.u.version,date:this.u.date}){if(!(0,k.$No)(B.properties.targetPlatform,B.allTargetPlatforms,Y)||!U&&B.properties.isPreReleaseVersion)return!1;let ne=B.properties.engine;if(!ne){const G=await this.getManifest(B,N.CancellationToken.None);if(!G)throw new Error("Manifest was not found");ne=G.engines.vscode}return(0,f.$wp)(ne,_.version,_.date)}async y(B,U,Y,_,ne,G={version:this.u.version,date:this.u.date}){if(!(0,k.$No)(H(B),_,ne)||U!=="any"&&X(B)!==(U==="prerelease"))return!1;if(Y)try{const ie=await this.E(B);if(!(0,f.$wp)(ie,G.version,G.date))return!1}catch(ie){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,L.$0)(ie)),!1}return!0}async query(B,U){let Y=B.text||"";const _=B.pageSize??50;let ne=new p().withPage(1,_);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ne=ne.withFilter(t.Category,Ee||me),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ne=ne.withFilter(t.Tag,Ee||me),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(t.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),ne=ne.withFilter(t.SearchText,Y)),ne=ne.withSortBy(0)):B.ids?ne=ne.withFilter(t.ExtensionId,...B.ids):B.names?ne=ne.withFilter(t.ExtensionName,...B.names):ne=ne.withSortBy(4),typeof B.sortBy=="number"&&(ne=ne.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ne=ne.withSortOrder(B.sortOrder)),B.source&&(ne=ne.withSource(B.source));const G=async(de,me)=>{const{extensions:Ee,total:Re}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease,productVersion:B.productVersion??{version:this.u.version,date:this.u.date}},me);return Ee.forEach((Oe,Ne)=>ee(Oe,(de.pageNumber-1)*de.pageSize+Ne,B.source)),{extensions:Ee,total:Re}},{extensions:ie,total:ce}=await G(ne,U),fe=async(de,me)=>{if(me.isCancellationRequested)throw new L.$5;const{extensions:Ee}=await G(ne.withPage(de+1),me);return Ee};return{firstPage:ie,total:ce,pageSize:ne.pageSize,getPage:fe}}async z(B,U,Y){const _=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ne,total:G,context:ie}=await this.B(B,Y);if(!(B.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of ne){const Re=await this.A(Ee,U,ie);Re&&me.push(Re)}return{extensions:me,total:G}}const fe=[],de=new Map;for(let me=0;me<ne.length;me++){const Ee=ne[me],Re={id:(0,w.$jp)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,R.$Zf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ue=>(0,w.$ep)(ue,Re))?.includePreRelease;if(U.compatible&&(0,k.$Mo)(te(Ee),U.targetPlatform))continue;const Ne=await this.A(Ee,U,ie);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==U.targetPlatform&&Ne.hasPreReleaseVersion?de.set(Ee.extensionId,me):fe.push([me,Ne])}if(de.size){const me=new m.$2d,Ee=new p().withFlags(_&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Re}=await this.z(Ee,U,Y);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Oe of Re){const Ne=de.get(Oe.identifier.uuid);fe.push([Ne,Oe])}}return{extensions:fe.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:G}}async A(B,U,Y){const _={id:(0,w.$jp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},ne=U.versions?.find(fe=>(0,w.$ep)(fe,_))?.version,G=(0,R.$Zf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(fe=>(0,w.$ep)(fe,_))?.includePreRelease,ie=te(B),ce=re(B.versions,U.targetPlatform);if(U.compatible&&(0,k.$Mo)(ie,U.targetPlatform))return null;for(let fe=0;fe<ce.length;fe++){const de=ce[fe];if(!(ne&&de.version!==ne)){if(await this.y(de,G?"any":"release",U.compatible,ie,U.targetPlatform,U.productVersion))return ae(B,de,ie,Y);if(ne&&de.version===ne)return null}}return ne||U.compatible?null:ae(B,B.versions[0],ie)}async B(B,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const Y=await this.j,_=JSON.stringify(B.raw),ne={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},G=new m.$2d;let ie,ce,fe=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&B.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:ne},U),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:fe};const de=await(0,l.$Dp)(ie);if(de){const me=de.results[0],Ee=me.extensions,Re=me.resultMetadata&&me.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return fe=Re&&Re.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe,context:{[o]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(de){const me=(0,L.$4)(de)?k.ExtensionGalleryErrorCode.Cancelled:(0,L.$0)(de).startsWith("XHR timeout")?k.ExtensionGalleryErrorCode.Timeout:k.ExtensionGalleryErrorCode.Failed;throw ce=new k.$Ro((0,L.$0)(de),me),ce}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(_.length),duration:G.elapsed(),success:!!ie&&(0,l.$zp)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ce?.code,count:String(fe)})}}async reportStatistic(B,U,Y,_){if(!this.isEnabled())return;const ne=A.$o?this.x(`/itemName/${B}.${U}/version/${Y}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${U}/${Y}/stats?statType=${_}`),G=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:G};try{await this.k.request({type:"POST",url:ne,headers:ce},N.CancellationToken.None)}catch{}}async download(B,U,Y){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const _=(0,w.$mp)(B),ne=new Date().getTime(),G=me=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:me}),ie=Y===2?"install":Y===3?"update":"",ce=ie?{uri:`${B.assets.download.uri}${P.URI.parse(B.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${B.assets.download.fallbackUri}${P.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:B.assets.download,fe=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,de=await this.D(ce,fe?{headers:fe}:void 0);await this.q.writeFile(U,de.stream),G(new Date().getTime()-ne)}async downloadSignatureArchive(B,U){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const Y=await this.D(B.assets.signature);await this.q.writeFile(U,Y.stream)}async getReadme(B,U){if(B.assets.readme){const Y=await this.D(B.assets.readme,{},U);return await(0,l.$Cp)(Y)||""}return""}async getManifest(B,U){if(B.assets.manifest){const Y=await this.D(B.assets.manifest,{},U),_=await(0,l.$Cp)(Y);return _?JSON.parse(_):null}return null}async C(B,U){const Y=F(B,r.Manifest);if(!Y)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},ne=await this.D(Y,{headers:_});return await(0,l.$Dp)(ne)}async getCoreTranslation(B,U){const Y=B.assets.coreTranslations.filter(_=>_[0]===U.toUpperCase())[0];if(Y){const _=await this.D(Y[1]),ne=await(0,l.$Cp)(_);return ne?JSON.parse(ne):null}return null}async getChangelog(B,U){if(B.assets.changelog){const Y=await this.D(B.assets.changelog,{},U);return await(0,l.$Cp)(Y)||""}return""}async getAllCompatibleVersions(B,U,Y){let _=new p().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?_=_.withFilter(t.ExtensionId,B.identifier.uuid):_=_.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ne}=await this.B(_,N.CancellationToken.None);if(!ne.length)return[];const G=te(ne[0]);if((0,k.$Mo)(G,Y))return[];const ie=[];await Promise.all(ne[0].versions.map(async de=>{try{await this.y(de,U?"any":"release",!0,G,Y)&&ie.push(de)}catch{}}));const ce=[],fe=new Set;for(const de of re(ie,Y))fe.has(de.version)||(fe.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:X(de)}));return ce}async D(B,U={},Y=N.CancellationToken.None){const _=await this.j,ne={type:"GET"},G={..._,...U.headers||{}};U={...U,...ne,headers:G};const ie=B.uri,ce=B.fallbackUri,fe={...U,url:ie};try{const de=await this.k.request(fe,Y);if(de.res.statusCode===200)return de;const me=await(0,l.$Cp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${me}`)}catch(de){if((0,L.$4)(de))throw de;const me=(0,L.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:me});const Ee={...U,url:ce};return this.k.request(Ee,Y)}}async E(B){let U=Z(B);if(!U){const Y=await this.C(B,N.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");U=Y.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.$Dp)(B),Y=[],_={},ne=[];if(U){for(const G of U.malicious)Y.push({id:G});if(U.migrateToPreRelease)for(const[G,ie]of Object.entries(U.migrateToPreRelease))(!ie.engine||(0,f.$wp)(ie.engine,this.u.version,this.u.date))&&(_[G.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[G,ie]of Object.entries(U.deprecated))ie&&(_[G.toLowerCase()]=(0,R.$Zf)(ie)?{}:ie);if(U.search)for(const G of U.search)ne.push(G)}return{malicious:Y,deprecated:_,search:ne}}};J=ye([Q(1,l.$xp),Q(2,b.$Mj),Q(3,C.$ni),Q(4,c.$Ll),Q(5,u.$Mk),Q(6,$.$6j),Q(7,g.$Mi)],J);let z=class extends J{constructor(B,U,Y,_,ne,G,ie,ce){super(B,U,Y,_,ne,G,ie,ce)}};e.$Tp=z,e.$Tp=z=ye([Q(0,h.$Kp),Q(1,l.$xp),Q(2,b.$Mj),Q(3,C.$ni),Q(4,c.$Ll),Q(5,u.$Mk),Q(6,$.$6j),Q(7,g.$Mi)],z);let j=class extends J{constructor(B,U,Y,_,ne,G,ie){super(void 0,B,U,Y,_,ne,G,ie)}};e.$Up=j,e.$Up=j=ye([Q(0,l.$xp),Q(1,b.$Mj),Q(2,C.$ni),Q(3,c.$Ll),Q(4,u.$Mk),Q(5,$.$6j),Q(6,g.$Mi)],j)}),define(le[82],he([0,1,4,3,2,19,33,24,17,8,13]),function(se,e,I,N,L,A,O,R,P,g,C){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=void 0,e.$Ev=(0,I.$gi)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends L.$Tc{static{k=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,O.$ip)(b.id)}@${b.version}`}static c(b){const $=w.exec(b);if($&&$[1])return{id:$[1],version:$[2]}}static async removeOutdatedExtensionVersions(b,$){const l=await b.getInstalled(),d=[];for(const[h,c]of k.f($)){const m=l.find(i=>(0,O.$ep)(i.identifier,{id:h}))?.manifest.version;for(const i of c)m!==i&&d.push(k.b({id:h,version:i}))}for(const h of d)$.remove(h,0)}static f(b){const $=new Map,l=b.keys(0,1);for(const d of l){const h=k.c(d);if(h){let c=$.get(h.id.toLowerCase());c||$.set(h.id.toLowerCase(),c=[]),c.push(h.version)}}return $}constructor(b,$,l){super(),this.j=b,this.m=$,this.n=l,this.g=this.B(new N.$6d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=k.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Sc))(d=>this.r(d)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const $=k.c(b.key);if($){if(this.j.get(b.key,0)===void 0)this.h.delete($.id.toLowerCase());else{let l=this.h.get($.id.toLowerCase());l||this.h.set($.id.toLowerCase(),l=[]),l.push($.version),this.g.fire()}return}}s(b){if((0,C.$Tf)(b))return b;const $=b.manifest?b.manifest.publisher:b.publisher,l=b.manifest?b.manifest.name:b.name;return(0,O.$hp)($,l)}getExtensionState(b,$){const l=this.s(b),d=this.getExtensionStateRaw(b,$);if(d)try{return JSON.parse(d)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${$}): ${h}`)}}getExtensionStateRaw(b,$){const l=this.s(b),d=this.j.get(l,$?0:1);return d&&d?.length>k.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${$}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(b,$,l){const d=this.s(b);$===void 0?this.j.remove(d,l?0:1):this.j.store(d,JSON.stringify($),l?0:1,1)}setKeysForSync(b,$){this.j.store(k.b(b),JSON.stringify($),0,1)}getKeysForSync(b){const $=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],l=this.j.get(k.b(b),0),d=l?JSON.parse(l):void 0;return d&&$?(0,P.$Mb)([...d,...$]):d||$}addToMigrationList(b,$){if(b!==$){const l=this.t.filter(d=>!d.includes(b)&&!d.includes($));l.push([b,$]),this.t=l}}getSourceExtensionToMigrate(b){const $=this.t.find(([,l])=>b===l);return $?$[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const $=JSON.parse(b);if(Array.isArray($))return $}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Fv=f,e.$Fv=f=k=ye([Q(0,A.$Kp),Q(1,R.$6j),Q(2,g.$Mj)],f)}),define(le[252],he([0,1,2,29,82,227,113,8,19]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;let g=class extends I.$Tc{constructor(k,w,f,u,b,$){super(),k.cleanUp(),(0,A.$s2b)(k,w,f,u,$),L.$Fv.removeOutdatedExtensionVersions(k,b)}};e.$_bc=g,e.$_bc=g=ye([Q(0,O.$nq),Q(1,N.$Po),Q(2,L.$Ev),Q(3,N.$Vo),Q(4,P.$Kp),Q(5,R.$Mj)],g)}),define(le[253],he([0,1,29,12,24,16,96,57,19,22,226]),function(se,e,I,N,L,A,O,R,P,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;let k=class extends C.$v$b{constructor(f,u,b,$,l,d,h,c){super(f.userHome,l,u,b,$,d,h,c)}};e.$gcc=k,e.$gcc=k=ye([Q(0,A.$oi),Q(1,g.$Ll),Q(2,I.$So),Q(3,P.$Kp),Q(4,R.$9_b),Q(5,O.$c2b),Q(6,N.$Mk),Q(7,L.$6j)],k)}),define(le[254],he([0,1,105,3,22,16,2,8,15,67,24,5,6,100,21,168,37,19,13,132,20]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=void 0;const m=[I.$8bc,I.$9bc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Tc{constructor(a,v,y,p,S,E,D){super(),this.y=a,this.z=v,this.C=y,this.D=E,this.F=D,this.f=new N.$6d,this.onDidTokenFailed=this.f.event,this.g=new N.$6d,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$6d,this.onDidChangeMode=this.h.event,this.n=I.$6bc,this.w=!1,this.I=(T,F)=>{F?this.j.error(T):this.j.info(T)},this.j=this.B(p.createLogger((0,c.$Tg)(y.logsHome,`${I.$0bc}.log`),{id:I.$0bc,name:I.$$bc})),this.t=new w.$dh(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,R.$2j)(T)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(T=>{m.some(F=>T.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;k.$j?a=this.C.appRoot:a=(0,P.$mc)((0,P.$mc)(this.C.appRoot)),this.u=(0,P.$jc)(a,"bin",`${this.z.tunnelApplicationName}${k.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$6bc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const y=(F,q)=>{q?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,b.localize)(0,null)))},p=this.O("status",["status"],y);this.r=p;try{if(await p,this.r!==p)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(v=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(I.TunnelStates.disconnected());return}finally{this.r===p&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(I.TunnelStates.connecting((0,b.localize)(1,null,S.accountLabel,S.providerId)));const q=(X,x)=>{X=X.replaceAll(F,"*".repeat(4)),y(X,x)},Z=this.O("login",["user","login","--provider",S.providerId,"--access-token",F,"--log",(0,R.$2j)(this.j.getLevel())],q);this.r=Z;try{if(await Z,this.r!==Z)return}catch(X){this.j.error(X),this.r=void 0,this.f.fire(S),this.G(I.TunnelStates.disconnected(S));return}}const E=this.Q();E?this.G(I.TunnelStates.connecting((0,b.localize)(2,null,E))):this.G(I.TunnelStates.connecting((0,b.localize)(3,null)));const D=["--accept-server-license-terms","--log",(0,R.$2j)(this.j.getLevel())];E?D.push("--name",E):D.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(D)===!1),this.N(S,D,T)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(y){this.j.error(y),v=1}if(v!==0){const y=(0,b.localize)(4,null);return this.j.warn(y),this.G(I.TunnelStates.connecting(y)),!1}return!0}async N(a,v,y){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let p=!1;const S=this.O("tunnel",v,(E,D)=>{D?this.j.error(E):this.j.info(E),E.includes("Connected to an existing tunnel process")&&(p=!0);const T=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const F={link:T[1],domain:T[2],tunnelName:T[4],isAttached:p};this.G(I.TunnelStates.connected(F,y))}else E.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$6bc,this.G(I.TunnelStates.disconnected()))})}O(a,v,y=this.I){return(0,w.$6g)(p=>new Promise((S,E)=>{p.isCancellationRequested&&S(-1);let D;const T=["ignore","pipe","pipe"];if(p.onCancellationRequested(()=>{D&&(this.j.info(`${a} terminating(${D.pid})`),D.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),D=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,P.$jc)(this.C.appRoot,"cli"),stdio:T});else{y(`Running tunnel CLI
`,!1);const F=this.J();y(`${a} Spawning: ${F} tunnel ${v.join(" ")}
`,!1),D=(0,g.spawn)(F,["tunnel",...v],{cwd:(0,$.homedir)(),stdio:T})}D.stdout.pipe(new h.$SV(`
`)).on("data",F=>{if(D){const q=F.toString();y(q,!1)}}),D.stderr.pipe(new h.$SV(`
`)).on("data",F=>{if(D){const q=F.toString();y(q,!0)}}),D.on("exit",F=>{D&&(y(`${a} exit(${D.pid}): + ${F} `,!1),D=void 0,S(F||0))}),D.on("error",F=>{D&&(y(`${a} error(${D.pid}): + ${F} `,!0),D=void 0,E())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$9bc)}Q(){let a=this.D.getValue(I.$8bc)||(0,$.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),v=this.F.getBoolean(o,-1,!1);if(a){const y=JSON.parse(a);if(y&&(0,d.$Tf)(y.accountLabel)&&(0,d.$Tf)(y.sessionId)&&(0,d.$Tf)(y.providerId))return{active:!0,session:y,asService:v};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$6bc}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$ccc=n,e.$ccc=n=ye([Q(0,L.$Ll),Q(1,C.$6j),Q(2,A.$oi),Q(3,R.$Nj),Q(4,f.$acc),Q(5,u.$Mi),Q(6,l.$Kp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[255],he([0,1,6,2,23,20,69,19,77,18]),function(se,e,I,N,L,A,O,R,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class C extends R.$Mp{constructor(w,f,u,b){super(),this.bb=w,this.cb=f,this.db=u,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Sc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new P.$2Hb(this.db.getChannel("storage"))),f=this.B(new O.$Gp(w));return this.B(f.onDidChangeStorage(u=>this.u(-1,u))),f}gb(w){this.X.clear(),this.W=w;let f;if((0,R.$Np)(w))f=this.U;else{const u=this.X.add(new P.$3Hb(this.db.getChannel("storage"),w));f=this.X.add(new O.$Gp(u))}return this.X.add(f.onDidChangeStorage(u=>this.u(0,u))),f}hb(w){this.$.clear(),this.Z=w?.id;let f;if(w){const u=this.$.add(new P.$4Hb(this.db.getChannel("storage"),w));f=this.$.add(new O.$Gp(u)),this.$.add(f.onDidChangeStorage(b=>this.u(1,b)))}return f}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$Tg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const f=this.Y,u=f.items;f!==this.U&&await f.close(),this.Y=this.gb(w),await this.Y.init(),this.N(u,this.Y,0)}async S(w,f){const u=this.ab,b=u?.items??new Map;await u?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(b,this.ab,1)}hasScope(w){return(0,g.$ll)(w)?this.W.id===w.id:this.Z===w.id}}e.$hcc=C}),define(le[256],he([0,1,3,2,18,91]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0;class O{constructor(g,C){this.a=g,this.b=C}listen(g,C){const k=this.b(g);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(f=>(0,A.$kn)({...f},k)),added:w.added.map(f=>(0,A.$kn)({...f},k)),removed:w.removed.map(f=>(0,A.$kn)({...f},k)),updated:w.updated.map(f=>(0,A.$kn)({...f},k))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,k){const w=this.b(g);switch(C){case"createProfile":{const f=await this.a.createProfile(k[0],k[1],k[2]);return(0,A.$kn)({...f},w)}case"updateProfile":{let f=(0,L.$nl)((0,A.$ln)(k[0],w),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,k[1]),(0,A.$kn)({...f},w)}case"removeProfile":{const f=(0,L.$nl)((0,A.$ln)(k[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${C}`)}}e.$2P=O;class R extends N.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,k){super(),this.profilesHome=C,this.f=k,this.a=[],this.b=this.B(new I.$6d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(w=>(0,L.$nl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const f=w.added.map($=>(0,L.$nl)($,this.profilesHome.scheme)),u=w.removed.map($=>(0,L.$nl)($,this.profilesHome.scheme)),b=w.updated.map($=>(0,L.$nl)($,this.profilesHome.scheme));this.a=w.all.map($=>(0,L.$nl)($,this.profilesHome.scheme)),this.b.fire({added:f,removed:u,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,k){const w=await this.f.call("createNamedProfile",[g,C,k]);return(0,L.$nl)(w,this.profilesHome.scheme)}async createProfile(g,C,k,w){const f=await this.f.call("createProfile",[g,C,k,w]);return(0,L.$nl)(f,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,L.$nl)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const k=await this.f.call("updateProfile",[g,C]);return(0,L.$nl)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$3P=R}),define(le[60],he([0,1,2,69,4,19,3,77,18]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Hb=e.$7Hb=e.$6Hb=void 0,e.$6Hb=(0,L.$gi)("IUserDataProfileStorageService");let g=class extends I.$Tc{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async u=>this.b(u))}async updateStorageData(f,u,b){return this.withProfileScopedStorageService(f,async $=>this.c($,u,b))}async withProfileScopedStorageService(f,u){if(this.a.hasScope(f))return u(this.a);const b=await this.g(f),$=new k(b);try{await $.initialize();const l=await u($);return await $.flush(),l}finally{$.dispose(),await this.f(b)}}b(f){const u=new Map,b=$=>{for(const l of f.keys(0,$))u.set(l,{value:f.get(l,0),target:$})};return b(0),b(1),u}c(f,u,b){f.storeAll(Array.from(u.entries()).map(([$,l])=>({key:$,value:l,scope:0,target:b})),!0)}async f(f){try{await f.close()}finally{(0,I.$Nc)(f)&&f.dispose()}}};e.$7Hb=g,e.$7Hb=g=ye([Q(0,A.$Kp)],g);class C extends g{constructor(f,u,b,$){super(b),this.j=f;const l=f.getChannel("profileStorageListener"),d=this.B(new I.$Uc);this.h=this.B(new O.$6d({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(h=>{$.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(c=>(0,P.$nl)(c,u.profilesHome.scheme)),valueChanges:h.valueChanges.map(c=>({...c,profile:(0,P.$nl)(c.profile,u.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(f){const u=this.j.getChannel("storage");return(0,A.$Np)(f)?new R.$2Hb(u):new R.$3Hb(u,f)}}e.$8Hb=C;class k extends A.$Mp{constructor(f){super({flushInterval:100}),this.s=this.B(new N.$Gp(f))}O(){return this.s.init()}P(f){return f===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[257],he([0,1,19,8,18,56,60]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0;let R=class extends O.$8Hb{constructor(g,C,k,w){super(g,C,k,w)}};e.$Ybc=R,e.$Ybc=R=ye([Q(0,A.$lbc),Q(1,L.$ml),Q(2,I.$Kp),Q(3,N.$Mj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,13,173,21,16,12,8,43,19,22,28,25,18]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Ib=e.$6Ib=e.$5Ib=e.$4Ib=void 0,e.$1Ib=i,e.$2Ib=o,e.$3Ib=n;function i(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}function n(v,y){return`${(0,g.$Lf)(v)}${y.isDefault?"":` (${y.name})`}`}let s=class extends P.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,p,S,E,D,T,F,q,Z,X,x,W){super(),this.syncResource=y,this.collection=p,this.G=S,this.H=E,this.I=D,this.J=T,this.L=F,this.M=q,this.N=Z,this.O=X,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$6d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$6d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$eh(50)),this.w=this.B(new O.$6d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=W.extUri,this.f=this.h.joinPath(E.userDataSyncHome,...(0,c.$npb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,c.$Ipb),this.y=(0,c.$opb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,E,this.h),this.j=(0,$.$Qp)(E,S,D)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const p=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(p)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,p={}){await this.U(y,!0,this.ob(),p)}async preview(y,p,S={}){return this.U(y,!1,p,S)}async apply(y,p={}){try{this.F={...p};const S=await this.ab(y);return this.S(S),this.c}finally{this.F={}}}async U(y,p,S,E){try{if(this.F={...E},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let D="idle";try{const T=await this.getLastSyncUserData(),F=await this.X(y,T);return D=await this.Y(F,T,p,S),D==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):D==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(D)}}finally{this.F={}}}async replace(y){const p=this.kb(y);if(!p)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const S=await this.getLastSyncUserData(),E=await this.X(null,S),D=await this.W(E),T=await this.qb({ref:E.ref,syncData:p},S,D,this.ob(),A.CancellationToken.None),F=[];for(const q of T){const Z=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:X}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);F.push([q,{...Z,remoteChange:X!==0?X:2}])}await this.tb(E,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const p=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===p}async X(y,p){if(p){const S=y?y[this.resource]:void 0;if(p.ref===S||S===void 0&&p.syncData===null)return p}return this.getRemoteUserData(p)}async Y(y,p,S,E){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$vpb((0,k.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,p,S,E)}catch(D){if(D instanceof c.$vpb)switch(D.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,p,S,E);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),p=await this.getLastSyncUserData(),this.Y(y,p,S,E)}throw D}}async Z(y,p,S,E){try{const D=await this.W(y),T=!D&&p===null&&this.gb()!==void 0,F=S&&!T;this.c||(this.c=(0,N.$6g)(Z=>this.eb(y,p,D,F,E,Z)));let q=await this.c;if(S&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of q.resourcePreviews)q=await this.accept(Z.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":S?await this.ab(!1):"syncing"}catch(D){throw this.c=null,D}}async merge(y){return await this.$(y,async p=>{const S=await this.rb(p,A.CancellationToken.None);await this.G.writeFile(p.previewResource,L.$te.fromString(S?.content||""));const E=S&&!S.hasConflicts?await this.sb(p,p.previewResource,void 0,A.CancellationToken.None):void 0;return p.acceptResult=E,p.mergeState=S.hasConflicts?"conflict":E?"accepted":"preview",p.localChange=E?E.localChange:S.localChange,p.remoteChange=E?E.remoteChange:S.remoteChange,p}),this.c}async accept(y,p){return await this.$(y,async S=>{const E=await this.sb(S,y,p,A.CancellationToken.None);return S.acceptResult=E,S.mergeState="accepted",S.localChange=E.localChange,S.remoteChange=E.remoteChange,S}),this.c}async discard(y){return await this.$(y,async p=>{const S=await this.rb(p,A.CancellationToken.None);return await this.G.writeFile(p.previewResource,L.$te.fromString(S.content||"")),p.acceptResult=void 0,p.mergeState="preview",p.localChange=S.localChange,p.remoteChange=S.remoteChange,p}),this.c}async $(y,p){if(!this.c)return;let S=await this.c;const E=S.resourcePreviews.findIndex(({localResource:D,remoteResource:T,previewResource:F})=>this.h.isEqual(D,y)||this.h.isEqual(T,y)||this.h.isEqual(F,y));E!==-1&&(this.c=(0,N.$6g)(async D=>{const T=[...S.resourcePreviews];return T[E]=await p(T[E]),{...S,resourcePreviews:T}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:D})=>D==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const p=await this.c;return p.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":p.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.tb(p.remoteUserData,p.lastSyncUserData,p.resourcePreviews.map(S=>[S,S.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const p=y.filter(({mergeState:S})=>S==="conflict");(0,I.$ub)(this.s,p,(S,E)=>this.h.isEqual(S.previewResource,E.previewResource))||(this.s=p,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const p=this.c?await this.c:null;if(p)for(const S of p.resourcePreviews){if(this.h.isEqual(S.acceptedResource,y))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,y))return S.remoteContent;if(this.h.isEqual(S.localResource,y))return S.localContent;if(this.h.isEqual(S.baseResource,y))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,u.$4k)(y)!==1&&this.O.error(y)}}async eb(y,p,S,E,D,T){const F=await this.qb(y,p,S,D,T),q=[];for(const Z of F){const X=Z.previewResource.with({scheme:c.$Hpb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)q.push({...Z,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=E?await this.rb(Z,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,L.$te.fromString(x?.content||""));const W=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,T):void 0;q.push({...Z,acceptResult:W,mergeState:x?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:x?x.localChange:Z.localChange,remoteChange:W?W.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:p,resourcePreviews:q,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const p=JSON.parse(y),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!p.version&&!!S&&p.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${p.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let E,D=1;for(;E===void 0&&D++<6;)try{const T=await this.hb();T&&(T.ref===p.ref?E=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof u.$8k&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof c.$vpb)throw T;this.O.error(T,D)}}if(E===void 0)try{const T=await this.J.resolveResourceContent(this.resource,p.ref,this.collection,this.F);E=T===null?null:this.kb(T),await this.ib({ref:p.ref,syncData:E})}catch(T){if(T instanceof c.$vpb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return E===void 0?null:{...p,syncData:E}}async fb(y,p={}){if(p.ref||p.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),E={ref:y.ref,version:S,...p};this.I.store(this.z,JSON.stringify(E),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const p=y?JSON.parse(y):void 0;if(i(p))return p}catch(p){this.O.error(p)}}async ib(y){await this.G.writeFile(this.y,L.$te.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),p=JSON.parse(y.value.toString());await this.G.del(this.y),p.ref&&p.content!==void 0?(this.I.store(this.z,JSON.stringify({...p,content:void 0}),-1,1),await this.ib({ref:p.ref,syncData:p.content===null?null:JSON.parse(p.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,p)}catch(y){y instanceof u.$8k&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:p,content:S}=await this.lb(y);let E=null;return S!==null&&(E=this.kb(S)),{ref:p,syncData:E}}kb(y){try{const p=JSON.parse(y);if(o(p))return p}catch(p){this.O.error(p)}throw new c.$vpb((0,k.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const p=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,p,this.collection,this.F)}async mb(y,p){const S=await this.j,E={version:this.pb,machineId:S,content:y};try{return p=await this.J.writeResource(this.resource,JSON.stringify(E),p,this.collection,this.F),{ref:p,syncData:E}}catch(D){throw D instanceof c.$vpb&&D.code==="TooLarge"&&(D=new c.$vpb(D.message,D.code,this.resource)),D}}async nb(y){const p={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(p),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$ipb)}};e.$4Ib=s,e.$4Ib=s=ye([Q(2,u.$Mk),Q(3,f.$ni),Q(4,l.$Kp),Q(5,c.$qpb),Q(6,c.$rpb),Q(7,c.$Apb),Q(8,d.$Ll),Q(9,c.$Fpb),Q(10,w.$Mi),Q(11,h.$kl)],s);let t=class extends s{constructor(y,p,S,E,D,T,F,q,Z,X,x,W,K){super(p,S,E,D,T,F,q,Z,X,x,W,K),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,p,S){try{p?await this.G.writeFile(this.r,L.$te.fromString(y),S?void 0:p):await this.G.createFile(this.r,L.$te.fromString(y),{overwrite:S})}catch(E){throw E instanceof u.$8k&&E.fileOperationResult===1||E instanceof u.$8k&&E.fileOperationResult===3?new c.$vpb(E.message,"LocalPreconditionFailed"):E}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof u.$8k&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$5Ib=t,e.$5Ib=t=ye([Q(3,u.$Mk),Q(4,f.$ni),Q(5,l.$Kp),Q(6,c.$qpb),Q(7,c.$rpb),Q(8,c.$Apb),Q(9,d.$Ll),Q(10,c.$Fpb),Q(11,w.$Mi),Q(12,h.$kl)],t);let r=class extends t{constructor(y,p,S,E,D,T,F,q,Z,X,x,W,K,V){super(y,p,S,E,D,T,F,q,Z,X,x,K,V),this.zb=W,this.Bb=void 0}Ab(y,p){const S=[],E=(0,R.$tn)(y,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,C.$1f)(E)&&p!==Array.isArray(E)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$6Ib=r,e.$6Ib=r=ye([Q(3,u.$Mk),Q(4,f.$ni),Q(5,l.$Kp),Q(6,c.$qpb),Q(7,c.$rpb),Q(8,c.$Apb),Q(9,d.$Ll),Q(10,c.$Fpb),Q(11,c.$Epb),Q(12,w.$Mi),Q(13,h.$kl)],r);let a=class{constructor(y,p,S,E,D,T,F){this.resource=y,this.g=p,this.h=S,this.j=E,this.k=D,this.l=T,this.d=F.extUri,this.f=(0,c.$opb)(void 0,this.resource,S,this.d)}async initialize({ref:y,content:p}){if(!p){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(p);if(S)try{await this.o({ref:y,syncData:S})}catch(E){this.j.error(E)}}m(y){try{const p=JSON.parse(y);if(o(p))return p}catch(p){this.j.error(p)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,p={}){if(p.ref||p.version)throw new Error("Cannot have core properties as additional");const S={ref:y.ref,version:void 0,...p};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),-1,1),await this.k.writeFile(this.f,L.$te.fromString(JSON.stringify(y)))}};e.$7Ib=a,e.$7Ib=a=ye([Q(1,m.$ml),Q(2,f.$ni),Q(3,b.$Mj),Q(4,u.$Mk),Q(5,l.$Kp),Q(6,h.$kl)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,16,114,29,33,82,45,12,4,74,8,19,22,28,18,39,238,111,25,60]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F9b=e.$E9b=e.$D9b=void 0,e.$B9b=y,e.$C9b=p;async function v(T,F){const q=JSON.parse(T.content);if(T.version===1||T.version===2){const Z=(await F.getInstalled(0)).filter(X=>X.isBuiltin);for(const X of q)T.version===1&&(X.enabled===!1&&(X.disabled=!0),delete X.enabled),T.version===2&&Z.every(x=>!(0,f.$ep)(x.identifier,X.identifier))&&(X.installed=!0)}return q}function y(T){return JSON.parse(T.content)}function p(T,F){return T.sort((q,Z)=>!q.identifier.uuid&&Z.identifier.uuid?-1:q.identifier.uuid&&!Z.identifier.uuid?1:(0,P.$df)(q.identifier.id,Z.identifier.id)),F?(0,O.$En)(T,{}):JSON.stringify(T)}let S=class extends n.$4Ib{constructor(F,q,Z,X,x,W,K,V,H,te,re,ee,ae,J,z,j,M){super({syncResource:"extensions",profile:F},q,X,Z,x,W,K,ee,ae,te,re,z),this.Cb=V,this.Db=H,this.Eb=M,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Hpb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Hpb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Hpb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Hpb,authority:"accepted"}),this.Bb=this.Eb.createInstance(E),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:U})=>!!U)),A.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),A.Event.filter(j.onDidChange,B=>B.valueChanges.some(({profile:U,changes:Y})=>this.syncResource.profile.id===U.id&&Y.some(_=>_.key===w.$To))),J.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,q){const Z=F.syncData?await v(F.syncData,this.Cb):null,X=q?.skippedExtensions??[],x=q?.builtinExtensions??null,W=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:te}=(0,s.$A9b)(K,Z,W,X,V,x),re={local:H,remote:te,content:this.Hb(K,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.Ob(K,!1);return[{skippedExtensions:X,builtinExtensions:x,baseResource:this.xb,baseContent:W?this.Ob(W,!1):ee,localResource:this.yb,localContent:ee,localExtensions:K,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(F){const q=F.syncData?await v(F.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:X}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,s.$A9b)(Z,q,q,F.skippedExtensions||[],X,F.builtinExtensions||[]);return x!==null}Hb(F,q,Z,X){const x=[...q,...Z],W=new Set,K=V=>{W.add(V.id.toLowerCase()),V.uuid&&W.add(V.uuid)};x.forEach(({identifier:V})=>K(V)),X.forEach(K);for(const V of F)W.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&W.has(V.identifier.uuid)||x.push(V);return this.Ob(x,!1)}async rb(F,q){return{...F.previewResult,hasConflicts:!1}}async sb(F,q,Z,X){if(this.h.isEqual(q,this.yb))return this.Kb(F);if(this.h.isEqual(q,this.zb))return this.Lb(F);if(this.h.isEqual(q,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(F){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(q),X=(0,s.$A9b)(F.localExtensions,null,null,F.skippedExtensions,Z,F.builtinExtensions),{local:x,remote:W}=X;return{content:F.localContent,local:x,remote:W,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(F){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(q),X=F.remoteContent?JSON.parse(F.remoteContent):null;if(X!==null){const x=(0,s.$A9b)(F.localExtensions,X,F.localExtensions,[],Z,F.builtinExtensions),{local:W,remote:K}=x;return{content:F.remoteContent,local:W,remote:K,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,q,Z,X){let{skippedExtensions:x,builtinExtensions:W,localExtensions:K}=Z[0][0];const{local:V,remote:H,localChange:te,remoteChange:re}=Z[0][1];if(te===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(K)),x=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,x,this.syncResource.profile)),H){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(H.all);F=await this.mb(ee,X?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(ae=>ae.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(ae=>ae.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(ae=>ae.identifier.id))}.`:""}`)}q?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(K,W),await this.fb(F,{skippedExtensions:x,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(F,q){const Z=new Set,X=[];for(const x of F)Z.add(x.identifier.id.toLowerCase()),x.installed||X.push(x.identifier);if(q)for(const x of q)Z.has(x.id.toLowerCase())||X.push(x);return X}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const q=await this.db(F);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(F,q){return p(F,q)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$D9b=S,e.$D9b=S=ye([Q(2,C.$ni),Q(3,$.$Mk),Q(4,c.$Kp),Q(5,r.$qpb),Q(6,r.$rpb),Q(7,w.$So),Q(8,t.$OJb),Q(9,r.$Fpb),Q(10,g.$Mi),Q(11,r.$Apb),Q(12,m.$Ll),Q(13,u.$Ev),Q(14,i.$kl),Q(15,a.$6Hb),Q(16,l.$fi)],S);let E=class{constructor(F,q,Z,X,x,W){this.a=F,this.b=q,this.c=Z,this.d=X,this.f=x,this.g=W}async getLocalExtensions(F){const q=await this.a.getInstalled(void 0,F.extensionsResource),Z=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(F,async(x,W)=>{const K=x.getDisabledExtensions();return q.map(V=>{const{identifier:H,isBuiltin:te,manifest:re,preRelease:ee,pinned:ae,isApplicationScoped:J}=V,z={identifier:H,preRelease:ee,version:re.version,pinned:!!ae};J&&!(0,b.$Em)(re)&&(z.isApplicationScoped=J),K.some(j=>(0,f.$ep)(j,H))&&(z.disabled=!0),te||(z.installed=!0);try{const j=W.getKeysForSync({id:H.id,version:re.version});if(j){const M=W.getExtensionState(V,!0)||{};z.state=Object.keys(M).reduce((B,U)=>(j.includes(U)&&(B[U]=M[U]),B),{})}}catch(j){this.g.info(`${(0,n.$3Ib)("extensions",F)}: Error while parsing extension state`,(0,L.$0)(j))}return z})}),ignoredExtensions:Z}}async updateLocalExtensions(F,q,Z,X,x){const W=(0,n.$3Ib)("extensions",x),K=[],V=new Map,H=[],te=[],re=await this.a.getInstalled(void 0,x.extensionsResource);if((F.length||Z.length)&&await this.j(x,async(J,z)=>{await I.Promises.settled([...F,...Z].map(async j=>{const M=re.find(Y=>(0,f.$ep)(Y.identifier,j.identifier));if(M&&M.isBuiltin){j.state&&M.manifest.version===j.version&&this.h(j.state,M,M.manifest.version,z),J.getDisabledExtensions().some(_=>(0,f.$ep)(_,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${W}: Disabling extension...`,j.identifier.id),await J.disableExtension(j.identifier),this.g.info(`${W}: Disabled extension`,j.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,j.identifier.id),await J.enableExtension(j.identifier),this.g.info(`${W}: Enabled extension`,j.identifier.id))),H.push(j.identifier);return}const B=j.pinned?j.version:void 0,U=(await this.c.getExtensions([{...j.identifier,version:B,preRelease:B?void 0:j.preRelease}],N.CancellationToken.None))[0];if(j.state&&(M?M.manifest.version===j.version:U)&&this.h(j.state,M||U,M?.manifest.version,z),U)try{J.getDisabledExtensions().some(_=>(0,f.$ep)(_,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${W}: Disabling extension...`,j.identifier.id,U.version),await J.disableExtension(U.identifier),this.g.info(`${W}: Disabled extension`,j.identifier.id,U.version)):(this.g.trace(`${W}: Enabling extension...`,j.identifier.id,U.version),await J.enableExtension(U.identifier),this.g.info(`${W}: Enabled extension`,j.identifier.id,U.version))),(!M||M.preRelease!==j.preRelease||M.pinned!==j.pinned||B&&M.manifest.version!==B)&&(await this.a.canInstall(U)?(K.push({extension:U,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,installPreReleaseVersion:j.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[w.$Go]:!0,[w.$Ho]:!0}}}),V.set(U.identifier.id.toLowerCase(),j)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),te.push(j)))}catch(Y){te.push(j),this.g.error(Y),this.g.info(`${W}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else te.push(j),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),q.length){const J=re.filter(({identifier:z,isBuiltin:j})=>!j&&q.some(M=>(0,f.$ep)(z,M)));await I.Promises.settled(J.map(async z=>{this.g.trace(`${W}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,z.identifier.id),H.push(z.identifier)}))}const ee=await this.a.installGalleryExtensions(K);for(const{identifier:J,local:z,error:j,source:M}of ee){const B=M;if(z)this.g.info(`${W}: Installed extension.`,J.id,B.version),H.push(J);else{const U=V.get(J.id.toLowerCase());U&&(te.push(U),this.g.info(`${W}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),j instanceof w.$Qo&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):j&&this.g.error(j)}}const ae=[];for(const J of X)H.some(z=>(0,f.$ep)(z,J.identifier))||ae.push(J);for(const J of te)ae.some(z=>(0,f.$ep)(z.identifier,J.identifier))||ae.push(J);return ae}h(F,q,Z,X){const x=X.getExtensionState(q,!0)||{},W=Z?X.getKeysForSync({id:q.identifier.id,version:Z}):void 0;W?W.forEach(K=>{x[K]=F[K]}):Object.keys(F).forEach(K=>x[K]=F[K]),X.setExtensionState(q,x,!0)}async j(F,q){return this.b.withProfileScopedStorageService(F,async Z=>{const X=new R.$Sc,x=this.f.createChild(new d.$ei([c.$Kp,Z])),W=X.add(x.createInstance(k.$rHb)),K=X.add(x.createInstance(u.$Fv));try{return await q(W,K)}finally{X.dispose()}})}};e.$E9b=E,e.$E9b=E=ye([Q(0,w.$So),Q(1,a.$6Hb),Q(2,w.$Po),Q(3,t.$OJb),Q(4,l.$fi),Q(5,r.$Fpb)],E);let D=class extends n.$7Ib{constructor(F,q,Z,X,x,W,K,V){super("extensions",X,x,W,Z,K,V),this.p=F,this.q=q}async t(F){return F.syncData?await v(F.syncData,this.p):null}u(F,q){const Z=[],X=[],x=[];for(const W of F){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const K=q.find(V=>(0,f.$ep)(V.identifier,W.identifier));K?(Z.push(K),W.disabled&&x.push(W.identifier)):W.installed&&(X.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&x.push(W.identifier))}return{installedExtensions:Z,newExtensions:X,disabledExtensions:x,remoteExtensions:F}}};e.$F9b=D,e.$F9b=D=ye([Q(0,w.$So),Q(1,t.$OJb),Q(2,$.$Mk),Q(3,o.$ml),Q(4,C.$ni),Q(5,h.$Mj),Q(6,c.$Kp),Q(7,i.$kl)],D)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,16,12,8,43,19,22,28,39,79,242,25,18,60,4]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJb=e.$_Ib=e.$$Ib=e.$0Ib=void 0,e.$9Ib=t;const n="globalState.argv.",s=["locale"];function t(S,E){const D=S.storage?Object.keys(S.storage).sort():[],T={};return D.forEach(F=>T[F]=S.storage[F]),S.storage=T,E?(0,O.$En)(S,{}):JSON.stringify(S)}const r=1;let a=class extends l.$4Ib{constructor(E,D,T,F,q,Z,X,x,W,K,V,H,te,re){super({syncResource:"globalState",profile:E},D,F,x,H,q,Z,W,K,X,V,te),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$Hpb,authority:"base"}),this.xb=this.vb.with({scheme:c.$Hpb,authority:"local"}),this.yb=this.vb.with({scheme:c.$Hpb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$Hpb,authority:"accepted"}),this.Ab=re.createInstance(v),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(F.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),L.Event.filter(T.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:J})=>this.syncResource.profile.id===ae.id&&J.some(z=>z.target===0)))))(()=>this.Q()))}async qb(E,D,T){const F=E.syncData?JSON.parse(E.syncData.content):null;D=D===null&&T?E:D;const q=D&&D.syncData?JSON.parse(D.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Jb(q),{local:x,remote:W}=(0,h.$8Ib)(Z.storage,F?F.storage:null,q?q.storage:null,X,this.O),K={content:null,local:x,remote:W,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:W.all!==null?2:0},V=t(Z,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):V,localResource:this.xb,localContent:V,localUserData:Z,remoteResource:this.yb,remoteContent:F?t(F,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:X}]}async ub(E){const D=E.syncData?JSON.parse(E.syncData.content):null;if(D===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(D),{remote:q}=(0,h.$8Ib)(T.storage,D.storage,D.storage,F,this.O);return q.all!==null}async rb(E,D){return{...E.previewResult,hasConflicts:!1}}async sb(E,D,T,F){if(this.h.isEqual(D,this.xb))return this.Gb(E);if(this.h.isEqual(D,this.yb))return this.Hb(E);if(this.h.isEqual(D,this.vb))return E.previewResult;throw new Error(`Invalid Resource: ${D.toString()}`)}async Gb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:0,remoteChange:2}}async Hb(E){if(E.remoteContent!==null){const D=JSON.parse(E.remoteContent),{local:T,remote:F}=(0,h.$8Ib)(E.localUserData.storage,D.storage,null,E.storageKeys,this.O);return{content:E.remoteContent,local:T,remote:F,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(E,D,T,F){const{localUserData:q}=T[0][0],{local:Z,remote:X,localChange:x,remoteChange:W}=T[0][1];if(x===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:X.all});E=await this.mb(K,F?null:E.ref),this.O.info(`${this.D}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}D?.ref!==E.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(E),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.yb,E)||this.h.isEqual(this.wb,E)||this.h.isEqual(this.xb,E)||this.h.isEqual(this.zb,E)){const D=await this.db(E);return D&&t(JSON.parse(D),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(E){const D=await this.Bb.readStorageData(this.syncResource.profile),T=[],F=[];for(const[X,x]of D)x.target===0?T.push(X):x.target===1&&F.push(X);const q=[...T,...F],Z=E?.storage?Object.keys(E.storage).filter(X=>!X.startsWith(n)&&!q.includes(X)&&D.get(X)!==void 0):[];if(!R.$o){const X=[...c.$mpb.map(x=>(0,c.$zpb)(x)),c.$ypb];Z.push(...X),F.push(...X)}return{user:T,machine:F,unregistered:Z}}};e.$0Ib=a,e.$0Ib=a=ye([Q(2,i.$6Hb),Q(3,k.$Mk),Q(4,c.$qpb),Q(5,c.$rpb),Q(6,c.$Fpb),Q(7,C.$ni),Q(8,c.$Apb),Q(9,b.$Ll),Q(10,g.$Mi),Q(11,u.$Kp),Q(12,$.$kl),Q(13,o.$fi)],a);let v=class{constructor(E,D,T,F){this.a=E,this.b=D,this.c=T,this.d=F}async getLocalGlobalState(E){const D={};if(E.isDefault){const F=await this.f(),q=(0,A.$tn)(F);for(const Z of s)q[Z]!==void 0&&(D[`${n}${Z}`]={version:1,value:q[Z]})}const T=await this.c.readStorageData(E);for(const[F,q]of T)q.value&&q.target===0&&(D[F]={version:1,value:q.value});return{storage:D}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,N.$0)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:D,updated:T},F){const q=(0,l.$3Ib)("globalState",F),Z={},X=new Map,x=await this.c.readStorageData(F),W=(K,V)=>{for(const H of K){if(H.startsWith(n)){Z[H.substring(n.length)]=V?V[H].value:void 0;continue}if(V){const te=V[H];te.value!==x.get(H)?.value&&X.set(H,te.value)}else x.get(H)!==void 0&&X.set(H,void 0)}};if(W(Object.keys(E),E),W(Object.keys(T),T),W(D),Object.keys(Z).length){this.d.trace(`${q}: Updating locale...`);const K=await this.f();let V=K;for(const H of Object.keys(Z))V=(0,d.edit)(V,[H],Z[H],{});K!==V&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$te.fromString(V)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}X.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(F,X,0),this.d.info(`${q}: Updated global state`,[...X.keys()]))}};e.$$Ib=v,e.$$Ib=v=ye([Q(0,k.$Mk),Q(1,C.$ni),Q(2,i.$6Hb),Q(3,c.$Fpb)],v);let y=class extends l.$7Ib{constructor(E,D,T,F,q,Z){super("globalState",T,F,q,D,E,Z)}async o(E){const D=E.syncData?JSON.parse(E.syncData.content):null;if(!D){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},F={};for(const q of Object.keys(D.storage))q.startsWith(n)?T[q.substring(n.length)]=D.storage[q].value:this.l.get(q,0)===void 0&&(F[q]=D.storage[q].value);if(Object.keys(T).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(T))q=(0,d.edit)(q,[Z],T[Z],{});await this.k.writeFile(this.h.argvResource,I.$te.fromString(q))}if(Object.keys(F).length){const q=[];for(const Z of Object.keys(F))q.push({key:Z,value:F[Z],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$_Ib=y,e.$_Ib=y=ye([Q(0,u.$Kp),Q(1,k.$Mk),Q(2,m.$ml),Q(3,C.$ni),Q(4,c.$Fpb),Q(5,$.$kl)],y);let p=class{constructor(E,D,T,F,q){this.a=E,this.b=D,this.c=T,this.d=F,this.f=q}getSyncStoreType(E){return this.h(E)?.storage[c.$ypb]?.value}async sync(E){const D=(0,c.$upb)((0,P.$Cg)());try{return await this.g(E,D)}catch(T){if(T instanceof c.$vpb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,D)}throw T}}async g(E,D){const T=await this.a.readResource("globalState",null,void 0,D),F=this.h(T)||{storage:{}};F.storage[c.$ypb]={value:E,version:r};const q=await(0,f.$Qp)(this.c,this.d,this.b),Z={version:r,machineId:q,content:t(F,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),T.ref,void 0,D)}h({content:E}){if(!E)return null;const D=JSON.parse(E);if((0,l.$2Ib)(D))return D?JSON.parse(D.content):null;throw new Error("Invalid remote data")}};e.$aJb=p,e.$aJb=p=ye([Q(1,u.$Kp),Q(2,C.$ni),Q(3,k.$Mk),Q(4,w.$Mj)],p)}),define(le[117],he([0,1,17,14,3,34,5,13,174,21,16,12,19,22,28,18,39,239,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=e.$I9b=void 0,e.$H9b=h;function h(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$1f)(s.all)?null:s.all;switch(O.OS){case 2:return(0,R.$1f)(s.mac)?null:s.mac;case 3:return(0,R.$1f)(s.linux)?null:s.linux;case 1:return(0,R.$1f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends $.$6Ib{constructor(o,n,s,t,r,a,v,y,p,S,E,D,T){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,y,p,S,s,t,v,D,r,E,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$Hpb,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$Hpb,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$Hpb,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$Hpb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?h(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,v=await this.vb(),y=await this.Cb();let p=null,S=!1,E=!1,D=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new d.$vpb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,l.$G9b)(q,r,a,y,this.zb);Z.hasChanges&&(p=Z.mergeContent,D=Z.hasConflicts,S=D||Z.mergeContent!==q,E=D||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),p=v.value.toString(),E=!0);const T={content:D?a:p,localChange:S?v?2:1:0,remoteChange:E?2:0,hasConflicts:D},F=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,l.$G9b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:v,remoteChange:y}=s[0][1];if(v===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new d.$vpb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const p=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(p,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,A.$tn)(o.value.toString());if((0,I.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:h(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,O.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(d.$jpb)}};e.$I9b=c,e.$I9b=c=ye([Q(2,d.$qpb),Q(3,d.$rpb),Q(4,d.$Fpb),Q(5,g.$Mi),Q(6,d.$Apb),Q(7,k.$Mk),Q(8,C.$ni),Q(9,w.$Kp),Q(10,d.$Epb),Q(11,f.$Ll),Q(12,u.$kl)],c);let m=class extends $.$7Ib{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$te.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$tn)(o.value.toString());return!(0,I.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return h(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$J9b=m,e.$J9b=m=ye([Q(0,k.$Mk),Q(1,b.$ml),Q(2,C.$ni),Q(3,d.$Fpb),Q(4,w.$Kp),Q(5,u.$kl)],m)}),define(le[118],he([0,1,14,3,175,21,76,16,29,12,19,22,28,18,39,243,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=e.$L9b=void 0,e.$K9b=d;function l(m){return m&&m.settings&&typeof m.settings=="string"&&Object.keys(m).length===1}function d(m){const i=JSON.parse(m);return l(i)?i:{settings:m}}let h=class extends u.$6Ib{constructor(i,o,n,s,t,r,a,v,y,p,S,E,D,T){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,S,E,v,y,p,T),this.Eb=D,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:$.$Hpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Hpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Hpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Hpb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new O.$io($.$ipb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue($.$ipb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,v=await this.Pb();let y=null,p=!1,S=!1,E=!1;if(r){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,b.$MHb)(q,r.settings,a?a.settings:null,v,[],t);y=Z.localContent||Z.remoteContent,p=Z.localContent!==null,S=Z.remoteContent!==null,E=Z.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=s.value.toString().trim()||"{}",this.Qb(y),S=!0);const D=s?s.value.toString():null,T=a?.settings??null,F={content:E?T:y,localChange:p?2:0,remoteChange:S?2:0,hasConflicts:E};return[{fileContent:s,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:D,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$MHb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$LHb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$LHb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$LHb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$LHb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const y=await this.Cb(),p=this.Lb(i),S=await this.Pb(r);r=(0,b.$LHb)(r,p?p.settings:"{}",S,y),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$NHb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$LHb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return d(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$JHb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new $.$vpb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$L9b=h,e.$L9b=h=ye([Q(2,g.$Mk),Q(3,R.$ni),Q(4,C.$Kp),Q(5,$.$qpb),Q(6,$.$rpb),Q(7,$.$Fpb),Q(8,$.$Epb),Q(9,A.$Mi),Q(10,$.$Apb),Q(11,k.$Ll),Q(12,P.$So),Q(13,w.$kl)],h);let c=class extends u.$7Ib{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$te.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$NHb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return d(i)}catch(o){this.j.error(o)}return null}};e.$M9b=c,e.$M9b=c=ye([Q(0,g.$Mk),Q(1,f.$ml),Q(2,R.$ni),Q(3,$.$Fpb),Q(4,C.$Kp),Q(5,w.$kl)],c)}),define(le[119],he([0,1,14,3,30,21,16,12,19,22,28,18,39,240,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=void 0,e.$P9b=b;function b(d){return JSON.parse(d.content)}let $=class extends w.$4Ib{constructor(h,c,m,i,o,n,s,t,r,a,v,y){super({syncResource:"snippets",profile:h},c,i,m,o,n,s,a,v,t,r,y),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(m.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,p=>p.affects(this.vb))(()=>this.Q()))}async qb(h,c,m){const i=await this.Hb(),o=this.Gb(i),n=h.syncData?this.Fb(h.syncData):null;c=c===null&&m?h:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,f.$N9b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(h){const c=h.syncData?this.Fb(h.syncData):null;if(c===null)return!0;const m=await this.Hb(),i=this.Gb(m),o=(0,f.$N9b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(h,c){return h.previewResult}async sb(h,c,m,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:u.$Hpb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:u.$Hpb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return m===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:m,localChange:m===null?h.fileContent!==null?3:0:2,remoteChange:m===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(h,c,m,i){const o=m.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(o,h,i)),c?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(h,c,m,i){const o=new Map;for(const n of Object.keys(h.local.added)){const s={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const s={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of h.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const s={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const s={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of h.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of h.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:m[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:m[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"remote"}),remoteContent:m[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Hpb,authority:"accepted"})})}return[...o.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:u.$Hpb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:u.$Hpb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:u.$Hpb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:u.$Hpb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const c={};for(const m of h)m.fileContent&&(c[this.h.basename(m.localResource)]=m.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(h,c){for(const{fileContent:m,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of h)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$te.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$te.fromString(i.content),c?void 0:m),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,c,m){const i=c.syncData?this.Fb(c.syncData):{},o=(0,L.$Mn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of h)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,f.$O9b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),m?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(h){return b(h)}Gb(h){const c={};for(const m of Object.keys(h))c[m]=h[m].value.toString();return c}async Hb(){const h={};let c;try{c=await this.G.resolve(this.vb)}catch(m){if(m instanceof R.$8k&&m.fileOperationResult===1)return h;throw m}for(const m of c.children||[]){const i=m.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);h[n]=s}}return h}};e.$Q9b=$,e.$Q9b=$=ye([Q(2,O.$ni),Q(3,R.$Mk),Q(4,P.$Kp),Q(5,u.$qpb),Q(6,u.$rpb),Q(7,u.$Fpb),Q(8,A.$Mi),Q(9,u.$Apb),Q(10,g.$Ll),Q(11,C.$kl)],$);let l=class extends w.$7Ib{constructor(h,c,m,i,o,n){super("snippets",c,m,i,h,o,n)}async o(h){const c=h.syncData?JSON.parse(h.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,I.$te.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$R9b=l,e.$R9b=l=ye([Q(0,R.$Mk),Q(1,k.$ml),Q(2,O.$ni),Q(3,u.$Fpb),Q(4,P.$Kp),Q(5,C.$kl)],l)}),define(le[120],he([0,1,14,21,16,12,19,22,28,18,39,25]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=e.$T9b=void 0,e.$S9b=w;function w($,l){try{return JSON.parse($).tasks??null}catch(d){return l.error(d),null}}let f=class extends C.$5Ib{constructor(l,d,h,c,m,i,o,n,s,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,n,s,t,h,c,o,r,m,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:k.$Hpb,authority:"base"}),this.Cb=this.Ab.with({scheme:k.$Hpb,authority:"local"}),this.Db=this.Ab.with({scheme:k.$Hpb,authority:"remote"}),this.Eb=this.Ab.with({scheme:k.$Hpb,authority:"accepted"})}async qb(l,d,h,c){const m=l.syncData?w(l.syncData.content,this.O):null;d=d===null&&h?l:d;const i=d?.syncData?w(d.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(l.syncData){const y=o?o.value.toString():null;if(!i||i!==y||i!==m){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const p=b(y,m,i);n=p.content,r=p.hasConflicts,s=p.hasLocalChanged,t=p.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:m,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const d=l?.syncData?w(l.syncData.content,this.O):null;if(d===null)return!0;const h=await this.vb(),c=h?h.value.toString():null,m=b(c,d,d);return m.hasLocalChanged||m.hasRemoteChanged}async rb(l,d){return l.previewResult}async sb(l,d,h,c){if(this.h.isEqual(d,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.Ab))return h===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(l,d,h,c){const{fileContent:m}=h[0][0],{content:i,localChange:o,remoteChange:n}=h[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),m&&await this.nb(JSON.stringify(this.Kb(m.value.toString()))),i?await this.wb(i,m,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));l=await this.mb(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$T9b=f,e.$T9b=f=ye([Q(2,k.$qpb),Q(3,k.$rpb),Q(4,k.$Fpb),Q(5,N.$Mi),Q(6,k.$Apb),Q(7,A.$Mk),Q(8,L.$ni),Q(9,O.$Kp),Q(10,R.$Ll),Q(11,P.$kl)],f);let u=class extends C.$7Ib{constructor(l,d,h,c,m,i){super("tasks",d,h,c,l,m,i),this.c=this.g.defaultProfile.tasksResource}async o(l){const d=l.syncData?w(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$te.fromString(d)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$U9b=u,e.$U9b=u=ye([Q(0,A.$Mk),Q(1,g.$ml),Q(2,L.$ni),Q(3,k.$Fpb),Q(4,O.$Kp),Q(5,P.$kl)],u);function b($,l,d){if($===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if($===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=d!==$,c=d!==l;return!h&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!c?{content:$,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!h?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:$,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,16,12,19,22,28,18,39,241,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=void 0,e.$A$b=u,e.$B$b=b;let f=class extends C.$4Ib{constructor(l,d,h,c,m,i,o,n,s,t,r,a,v){super({syncResource:"profiles",profile:l},d,c,m,i,o,n,r,a,s,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$Hpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Hpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Hpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Hpb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?b(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),h=await this.X(l,d);return h?.syncData?b(h.syncData):null}async qb(l,d,h){if(!this.vb.isEnabled())throw new w.$vpb("Cannot sync profiles because they are disabled","LocalError");const c=l.syncData?b(l.syncData):null,m=d?.syncData?b(d.syncData):null,i=this.Db(),{local:o,remote:n}=(0,k.$y$b)(i,c,m,[]),s={local:o,remote:n,content:m?this.Eb(m):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=u(i,!1);return[{baseResource:this.baseResource,baseContent:m?this.Eb(m):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const d=l?.syncData?b(l.syncData):null,h=this.Db(),{remote:c}=(0,k.$y$b)(h,d,d,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(l,d){return{...l.previewResult,hasConflicts:!1}}async sb(l,d,h,c){if(this.h.isEqual(d,this.localResource))return this.Ab(l);if(this.h.isEqual(d,this.remoteResource))return this.Bb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(l){const d=this.Db(),h=(0,k.$y$b)(d,null,null,[]),{local:c,remote:m}=h;return{content:l.localContent,local:c,remote:m,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:m!==null?2:0}}async Bb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,h=[],c=[];for(const m of this.Db()){const i=d?.find(o=>o.id===m.id);i&&(h.push({id:m.id,name:m.name,collection:i.collection}),c.push(m))}if(d!==null){const m=(0,k.$y$b)(c,d,h,[]),{local:i,remote:o}=m;return{content:l.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,d,h,c){const{local:m,remote:i,localChange:o,remoteChange:n}=h[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=h[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new w.$vpb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(u(this.Db(),!1));const t=[];for(const r of m.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of m.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of m.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),s.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:v})=>a.id===v),1);for(const a of i?.updated||[]){const v=s.find(({id:y})=>a.id===y);v&&s.splice(s.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}d?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.mb(this.Eb(l),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.db(l);return d&&(0,I.$En)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((d,h)=>d.name.localeCompare(h.name)))}};e.$z$b=f,e.$z$b=f=ye([Q(2,g.$ml),Q(3,A.$Mk),Q(4,L.$ni),Q(5,O.$Kp),Q(6,w.$qpb),Q(7,w.$rpb),Q(8,w.$Fpb),Q(9,N.$Mi),Q(10,w.$Apb),Q(11,R.$Ll),Q(12,P.$kl)],f);function u($,l){const d=[...$].sort((h,c)=>h.name.localeCompare(c.name)).map(h=>({id:h.id,name:h.name}));return l?(0,I.$En)(d,{}):JSON.stringify(d)}function b($){return JSON.parse($.content)}}),define(le[258],he([0,1,3,2,5,16,19,22,25]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=void 0;const g="sync.enable";let C=class extends N.$Tc{constructor(w,f,u,b){super(),this.c=w,this.f=f,this.g=u,this.h=b,this.a=new I.$6d,this.onDidChangeEnablement=this.a.event,this.b=new I.$6d,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new N.$Sc))($=>this.m($)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:w}),this.c.store(g,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,P.$zpb)(w),-1,!0)}setResourceEnablement(w,f){if(this.isResourceEnabled(w)!==f){const u=(0,P.$zpb)(w);this.j(u,f)}}getResourceSyncStateVersion(w){}j(w,f){this.c.store(w,f,-1,L.$o?0:1)}m(w){if(g===w.key){this.a.fire(this.isEnabled());return}const f=P.$mpb.filter(u=>(0,P.$zpb)(u)===w.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$m$b=C,e.$m$b=C=ye([Q(0,O.$Kp),Q(1,R.$Ll),Q(2,A.$ni),Q(3,P.$ppb)],C)}),define(le[259],he([0,1,6,14,65,2,20,21,16,12,18,25]),function(se,e,I,N,L,A,O,R,P,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=void 0;let w=class extends A.$Tc{constructor(u,b,$,l,d){super(),this.a=u,this.b=b,this.c=$,this.f=l,this.g=d,this.h()}async h(){for(const b of this.g.profiles)for(const $ of k.$mpb)try{await this.m(this.j($,b.isDefault?void 0:b.id))}catch(l){this.f.error(l)}let u;try{u=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,g.$4k)(b)!==1&&this.f.error(b);return}if(u.children){for(const b of u.children)if(b.isDirectory&&!this.g.profiles.some($=>$.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch($){this.f.error($)}}}async getAllResourceRefs(u,b,$){const l=this.j(u,b,$);try{const d=await this.b.resolve(l);if(d.children)return d.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(d){if((0,g.$4k)(d)!==1)throw d}return[]}async resolveResourceContent(u,b,$,l){const d=this.j(u,$,l),h=(0,O.$Tg)(d,b);try{return(await this.b.readFile(h)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(u,b,$,l,d){const h=this.j(u,l,d),c=(0,O.$Tg)(h,`${(0,L.$Nm)($).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,N.$te.fromString(b))}catch(m){this.f.error(m)}}j(u,b,$=this.a.userDataSyncHome){return(0,O.$Tg)($,...b?[b,u]:[u])}async m(u){try{try{if(!await this.b.exists(u))return}catch{return}const b=await this.b.resolve(u);if(b.children){const $=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=$.filter(c=>Date.now()-this.n(c)>l);const h=$.length-d.length;h<10&&(d=d.slice(10-h)),await I.Promises.settled(d.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(b){this.f.error(b)}}n(u){return new Date(parseInt(u.name.substring(0,4)),parseInt(u.name.substring(4,6))-1,parseInt(u.name.substring(6,8)),parseInt(u.name.substring(9,11)),parseInt(u.name.substring(11,13)),parseInt(u.name.substring(13,15))).getTime()}};e.$x$b=w,e.$x$b=w=ye([Q(0,P.$ni),Q(1,g.$Mk),Q(2,R.$Mi),Q(3,k.$Fpb),Q(4,C.$ml)],w)}),define(le[83],he([0,1,3,2,5,27,179,16,12,4,24,43,19,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$fpb=e.$dpb=void 0,e.$epb=m,e.$dpb=(0,g.$gi)("IUserDataSyncMachinesService");const b="sync.currentMachineName",$="Safari",l="Chrome",d="Edge",h="Firefox",c="Android";function m(n){switch(n){case $:case l:case d:case h:case c:case(0,L.$h)(0):return!0}return!1}function i(){return L.$G?$:L.$E?l:L.$H?d:L.$F?h:L.$I?c:(0,L.$h)(L.$o?0:L.$u)}let o=class extends N.$Tc{static{u=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,v,y){super(),this.h=r,this.j=a,this.m=v,this.n=y,this.c=this.B(new I.$6d),this.onDidChange=this.c.event,this.g=null,this.f=(0,k.$Qp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),v=a.machines.find(({id:y})=>y===s);if(v){v.name=t,await this.t(a);const y=await this.f;s===y&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const v=t.machines.find(y=>y.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$Ye)(r)}\\s#(\\d+)`);let v=0;for(const y of s){const p=a.exec(y.name),S=p?parseInt(p[1]):0;v=S>v?S:v}return`${r} #${v+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==u.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(u.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[u.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(u.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:u.a,machines:[]}}};e.$fpb=o,e.$fpb=o=u=ye([Q(0,R.$ni),Q(1,P.$Mk),Q(2,w.$Kp),Q(3,f.$qpb),Q(4,f.$Fpb),Q(5,C.$6j)],o)}),define(le[260],he([0,1,6,65,38,7,3,2,5,20,10,176,24,19,22,25,80,83]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=void 0;const d="sync.disableMachineEventually",h="sync.sessionId",c="sync.storeUrl",m="sync.productQuality";let i=class extends R.$Tc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(m,-1)}set s(s){s?this.H.store(m,s,-1,1):this.H.remove(m,-1)}constructor(s,t,r,a,v,y,p,S,E,D){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=y,this.D=p,this.F=S,this.G=E,this.H=D,this.a=this.B(new R.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$6d),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$eh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Mg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(p.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$Nm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$vpb.toUserDataSyncError(s);t instanceof b.$xpb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?P.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(d,!0,-1,1),await(0,I.$hh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,-1,!1)}R(){this.H.remove(d,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$D$b=i,e.$D$b=i=ye([Q(0,w.$6j),Q(1,b.$ppb),Q(2,b.$qpb),Q(3,b.$Apb),Q(4,b.$Bpb),Q(5,b.$Fpb),Q(6,$.$tHb),Q(7,u.$Ll),Q(8,l.$dpb),Q(9,f.$Kp)],i);class o extends R.$Tc{static{this.a="Interval"}constructor(s,t,r,a,v,y,p,S,E){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=v,this.w=y,this.y=p,this.z=S,this.C=E,this.b=this.B(new R.$Uc),this.c=this.B(new O.$6d),this.onDidStartSync=this.c.event,this.f=this.B(new O.$6d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,I.$ih)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,I.$6g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$4)(v))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Mg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Mg)(t.defaultUrl,s.defaultUrl)||!(0,g.$Mg)(t.insidersUrl,s.insidersUrl)||!(0,g.$Mg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,b.$vpb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(y){this.y.error(y),a=y}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$xpb((0,k.localize)(0,null),"DefaultServiceChanged"):new b.$xpb((0,k.localize)(1,null),"ServiceChanged"):new b.$xpb((0,k.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$xpb((0,k.localize)(3,null),"DefaultServiceChanged"):new b.$xpb((0,k.localize)(4,null),"ServiceChanged"):new b.$xpb((0,k.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(p=>p.isCurrent);if(v?.disabled)throw new b.$xpb((0,k.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(p){throw new b.$xpb((0,L.$4i)(p),p instanceof b.$vpb?p.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[261],he([0,1,10,180,16,12,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,y,p,S,E,D,T){this.e=t,this.f=r,this.g=a,this.h=y,this.i=p,this.j=S,this.k=E,this.l=D,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$B$b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,c.$B$b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:y})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:y,ref:p})=>({created:y,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:p,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$Qp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,y){if(t){const{content:p}=await this.M(r,v,a);return p}return this.f.resolveResourceContent(r,v,a,y)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,f.$K9b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,u.$H9b)(t.content,!!this.l.getValue(g.$jpb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,$.$S9b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const y=(0,w.$P9b)(v),p=[];for(const S of Object.keys(y)){const E=this.d.joinPath(t,S),D=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(t,o.a);p.push({resource:E,comparableResource:D})}return p}}return[]}z(t,r){return(0,w.$P9b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$C9b)((0,l.$B9b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$E9b).getLocalExtensions(t);return(0,l.$C9b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,d.$9Ib)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(d.$$Ib).getLocalGlobalState(t);return(0,d.$9Ib)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,m.$En)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$A$b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$3e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(I.URI.from({scheme:g.$Hpb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$Hpb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,y;const p=[];let S,E,D,T,F;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?y=q.substring(10):q.startsWith("syncResource:")?S=q.substring(13):q.startsWith("profile:")?E=q.substring(8):q.startsWith("collection:")?D=q.substring(11):q.startsWith("ref:")?T=q.substring(4):S?F=q:p.push(q)}return{remote:a,syncResource:S,profile:E,collection:D,ref:T,node:F,location:v&&y!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:y,query:t.query,fragment:t.fragment,path:"/"}),...p):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,k.$2Ib)(a))return a}catch(a){this.g.error(a)}throw new g.$vpb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$_$b=n,e.$_$b=n=o=ye([Q(0,g.$qpb),Q(1,g.$rpb),Q(2,g.$Fpb),Q(3,P.$kl),Q(4,L.$ni),Q(5,R.$Kp),Q(6,A.$Mk),Q(7,C.$ml),Q(8,b.$Mi),Q(9,h.$fi)],n)}),define(le[262],he([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,E,D,T,F,q,Z,X,x,W,K){super(),this.C=S,this.D=E,this.F=D,this.G=T,this.H=F,this.I=q,this.J=Z,this.L=X,this.M=x,this.N=W,this.O=K,this.f="uninitialized",this.g=this.B(new O.$6d),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$6d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$6d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$6d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$6d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$6d),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$6d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=D.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Rc)(()=>this.bb()))}async createSyncTask(S,E){this.cb(),this.H.info("Sync started.");const D=new Date().getTime(),T=(0,C.$Cg)();try{const X=(0,s.$upb)(T);E&&(X["Cache-Control"]="no-cache"),S=await this.D.manifest(S,X)}catch(X){const x=s.$vpb.toUserDataSyncError(X);throw y(x,T,this.F,this.I),x}const F=!1,q=this;let Z;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");Z=(0,N.$6g)(X=>q.P(S,!1,T,X)),await Z.finally(()=>Z=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-D}ms`),q.$()},stop(){return Z?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$vpb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const S=new Date().getTime(),E=(0,C.$Cg)(),D=(0,s.$upb)(E);let T;try{T=await this.D.manifest(null,D)}catch(Z){const X=s.$vpb.toUserDataSyncError(Z);throw y(X,E,this.F,this.I),X}await this.resetLocal();const F=this,q=new L.$de;return{id:E,async merge(){return F.P(T,!0,E,q.token)},async apply(){try{try{await F.R(T,E,q.token)}catch(Z){if(s.$vpb.toUserDataSyncError(Z).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(T,E,q.token);else throw Z}}catch(Z){throw F.H.error(Z),Z}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.$()},async stop(){q.cancel(),await F.U(),await F.resetLocal()}}}async P(S,E,D,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,E,D,T));const q=F.enabled.find(Z=>Z.resource==="profiles");if(q){const Z=await q.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(Z,S,E,D,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(S,E,D,T,F){for(const q of S){if(F.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===q.id);if(!Z){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const X=this.getOrCreateActiveProfileSynchronizer(Z,q);this.n.push(...await this.S(X,E,D,T,F))}for(const[q,Z]of this.z.entries())this.M.profiles.some(X=>X.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(q))}async R(S,E,D){const T=this.ab();for(const x of T){if(D.isCancellationRequested)return;await x.apply(E,D)}const F=T.find(x=>x.profile.isDefault);if(!F)return;const q=F.enabled.find(x=>x.resource==="profiles");if(!q)return;const X=(await q.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>T.every(W=>W.profile.id!==x.id));X.length&&await this.Q(X,S,!1,E,D)}async S(S,E,D,T,F){return(await S.sync(E,D,T,F)).map(([Z,X])=>({profile:S.profile,syncResource:Z,error:X}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(S=>S.stop()))}async resolveContent(S){const E=await this.N.resolveContent(S);if(E)return E;for(const D of this.ab())for(const T of D.enabled){const F=await T.resolveContent(S);if(F)return F}return null}async replace(S){this.cb();const E=this.N.resolveUserDataSyncResource(S);if(!E)return;const D=await this.resolveContent(S.uri);D&&await this.W(E.profile,async T=>{if(E.syncResource===T.resource)return await T.replace(D),!0})}async accept(S,E,D,T){this.cb(),await this.W(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(E,D),T&&await F.apply((0,g.$Zf)(T)?!1:T.force,(0,s.$upb)((0,C.$Cg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async E=>{if(E.resource!=="globalState"&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[S]of this.z.values())try{await S.resetLocal()}catch(E){this.H.error(E)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),E=S.map(q=>q.collection),D=await this.D.getAllCollections(),T=D.filter(q=>!E.includes(q));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const F=S.filter(q=>D.includes(q.collection));if(F.length!==S.length){const q=this.G.createInstance(n.$z$b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(S){this.cb();const E=await this.D.getActivityData();await this.C.writeFile(S,E)}async extractActivityData(S,E){const D=(await this.C.readFile(S)).value.toString(),T=JSON.parse(D);if(T.resources)for(const F in T.resources)for(const q of T.resources[F])await this.O.writeResource(F,q.content,new Date(q.created*1e3),void 0,E);if(T.collections)for(const F in T.collections)for(const q in T.collections[F].resources)for(const Z of T.collections[F].resources?.[q]??[])await this.O.writeResource(q,Z.content,new Date(Z.created*1e3),F,E)}async W(S,E){const D=new R.$Sc;try{const T=this.z.get(S.id);if(T){const x=await this.X(T[0],E,D);return(0,g.$1f)(x)?null:x}if(S.isDefault){const x=D.add(this.G.createInstance(a,S,void 0)),W=await this.X(x,E,D);return(0,g.$1f)(W)?null:W}if(this.M.isEnabled())return null;const F=D.add(this.G.createInstance(n.$z$b,S,void 0)),q=await this.D.manifest(null),X=(await F.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===S.id);if(X){const x=D.add(this.G.createInstance(a,S,X.collection)),W=await this.X(x,E,D);return(0,g.$1f)(W)?null:W}return null}finally{D.dispose()}}async X(S,E,D){const T=[...S.enabled,...S.disabled.reduce((F,q)=>(q!=="workspaceState"&&F.push(D.add(S.createSynchronizer(q))),F),[])];for(const F of T){const q=await E(F);if(!(0,g.$1f)(q))return q}}Y(S){const E=this.f;this.f!==S&&(this.f=S,this.g.fire(S),E==="hasConflicts"&&this.$())}Z(){const S=this.ab().map(E=>E.conflicts).flat();(0,I.$ub)(this.j,S,(E,D)=>E.profile.id===D.profile.id&&E.syncResource===D.syncResource&&(0,I.$ub)(E.conflicts,D.conflicts,(T,F)=>(0,P.$Mg)(T.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,E){let D=this.z.get(S.id);if(D&&D[0].collection!==E?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.z.delete(S.id)),!D){const T=new R.$Sc,F=T.add(this.G.createInstance(a,S,E?.collection));T.add(F.onDidChangeStatus(q=>this.Y(q))),T.add(F.onDidChangeConflicts(q=>this.Z())),T.add(F.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(S.id,D=[F,T])}return D[0]}ab(){const S=[];for(const[E]of this.z.values())S.push(E);return S}bb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$C$b=r,e.$C$b=r=ye([Q(0,f.$Mk),Q(1,s.$qpb),Q(2,s.$ppb),Q(3,u.$fi),Q(4,s.$Fpb),Q(5,$.$Ll),Q(6,b.$Kp),Q(7,s.$Apb),Q(8,l.$ml),Q(9,s.$Cpb),Q(10,s.$rpb)],r);let a=class extends R.$Tc{get enabled(){return this.f.sort((S,E)=>S[1]-E[1]).map(([S])=>S)}get disabled(){return s.$mpb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,E,D,T,F,q,Z,X,x,W){super(),this.profile=S,this.collection=E,this.r=D,this.t=T,this.u=F,this.w=q,this.y=Z,this.z=X,this.C=x,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$6d),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$6d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$6d),this.onDidChangeConflicts=this.n.event,this.B(D.onDidChangeResourceEnablement(([K,V])=>this.F(K,V))),this.B((0,R.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of s.$mpb)D.isResourceEnabled(K)&&this.G(K)}F(S,E){E?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||S==="workspaceState")return;if(S!=="profiles"&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const E=new R.$Sc,D=E.add(this.createSynchronizer(S));E.add(D.onDidChangeStatus(()=>this.L())),E.add(D.onDidChangeConflicts(()=>this.M())),E.add(D.onDidChangeLocal(()=>this.j.fire(S)));const T=this.N(S);this.f.push([D,T,E])}H(S){const E=this.f.findIndex(([D])=>D.resource===S);if(E!==-1){const[[D,,T]]=this.f.splice(E,1);T.dispose(),this.L(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case"settings":return this.t.createInstance(m.$L9b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$I9b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$Q9b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$T9b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$0Ib,this.profile,this.collection);case"extensions":return this.t.createInstance(d.$D9b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$z$b,this.profile,this.collection)}}async sync(S,E,D,T){if(T.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const q=[],Z=(0,s.$upb)(D),X=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=E?await this.I(X):{};for(const W of F){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(E){const K=await W.preview(X,x,Z);if(K)for(const V of K.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await W.merge(V.previewResource)}else await W.sync(X,Z)}catch(K){const V=s.$vpb.toUserDataSyncError(K);if(y(V,D,this.w,this.y),v(K))throw V;this.z.error(K),this.z.error(`${W.resource}: ${(0,A.$4i)(K)}`),q.push([W.resource,V])}}return q}finally{this.L()}}async apply(S,E){const D=(0,s.$upb)(S);for(const T of this.enabled){if(E.isCancellationRequested)return;try{await T.apply(!1,D)}catch(F){const q=s.$vpb.toUserDataSyncError(F);if(y(q,S,this.w,this.y),v(F))throw q;this.z.error(F),this.z.error(`${T.resource}: ${(0,A.$4i)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(E){this.z.error(E)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(E){this.z.error(`${S.resource}: ${(0,A.$4i)(E)}`),this.z.error(E)}}async I(S){if(!this.profile.isDefault)return{};const E=this.D.getValue(s.$ipb),D=this.enabled.find(T=>T instanceof m.$L9b);if(D){const T=await D.getRemoteUserDataSyncConfiguration(S);return{...E,...T}}return E}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const S=this.enabled.filter(E=>E.status==="hasConflicts").filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,I.$ub)(this.m,S,(E,D)=>E.syncResource===D.syncResource&&(0,I.$ub)(E.conflicts,D.conflicts,(T,F)=>(0,P.$Mg)(T.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Q(2,s.$Apb),Q(3,u.$fi),Q(4,w.$Po),Q(5,s.$ppb),Q(6,$.$Ll),Q(7,s.$Fpb),Q(8,l.$ml),Q(9,k.$Mi)],a);function v(p){if(p instanceof s.$vpb)switch(p.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(p,S,E,D){D.publicLog2("sync/error",{code:p.code,serverCode:p instanceof s.$wpb?String(p.serverCode):void 0,url:p instanceof s.$wpb?p.url:void 0,resource:p.resource,executionId:S,service:E.userDataSyncStore.url.toString()})}}),define(le[263],he([0,1,3,2,10,18,25]),function(se,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0;function R(w,f){return{...w,profile:(0,A.$nl)(w.profile,f.profilesHome.scheme)}}function P(w){return{created:w.created,uri:L.URI.revive(w.uri)}}class g{constructor(f,u,b){this.c=f,this.d=u,this.f=b,this.a=new Map,this.b=new I.$6d}listen(f,u){switch(u){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${u}`)}async call(f,u,b){try{return await this.g(f,u,b)}catch($){throw this.f.error($),$}}async g(f,u,b){switch(u){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(b[0]));case"accept":return this.c.accept(R(b[0],this.d),L.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(P(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(b[0]),L.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(u.startsWith("manualSync/")){const $=u.substring(11),l=b[0],d=this.h(l);switch(b=b.slice(1),$){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(f){const u=this.a.get(this.j(f));if(!u)throw new Error(`Manual sync taks not found: ${f}`);return u}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$Wbc=g;let C=class extends N.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,u){super(),this.n=u,this.b="uninitialized",this.c=this.B(new I.$6d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$6d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$6d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$6d),this.onSyncErrors=this.m.event,this.a={call(b,$,l){return f.call(b,$,l).then(null,d=>{throw O.$vpb.toUserDataSyncError(d)})},listen(b,$){return f.listen(b,$)}},this.a.call("_getInitialData").then(([b,$,l])=>{this.s(b),this.t($),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map($=>({...$,error:O.$vpb.toUserDataSyncError($.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),u=this;return new k(f,{async call($,l,d){return u.a.call(`manualSync/${$}`,[f,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,u,b,$){return this.a.call("accept",[f,u,b,$])}resolveContent(f){return this.a.call("resolveContent",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}saveRemoteActivityData(f){return this.a.call("getRemoteActivityData",[f])}extractActivityData(f,u){return this.a.call("extractActivityData",[f,u])}async s(f){this.b=f,this.c.fire(f)}async t(f){this.f=f.map(u=>({syncResource:u.syncResource,profile:(0,A.$nl)(u.profile,this.n.profilesHome.scheme),conflicts:u.conflicts.map(b=>({...b,baseResource:L.URI.revive(b.baseResource),localResource:L.URI.revive(b.localResource),remoteResource:L.URI.revive(b.remoteResource),previewResource:L.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(f){this.h!==f&&(this.h=f,this.j.fire(f))}};e.$Xbc=C,e.$Xbc=C=ye([Q(1,A.$ml)],C);class k extends N.$Tc{constructor(f,u){super(),this.id=f,this.a=u}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,141,5,20,13,10,32,21,16,12,24,59,43,19,25]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZIb=e.$YIb=e.$XIb=e.$WIb=e.$VIb=void 0;const m="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$ypb,-1)}set c(D){this.h.store(c.$ypb,D,-1,P.$o?0:1)}constructor(D,T,F){super(),this.f=D,this.g=T,this.h=F,this.a=this.B(new A.$6d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Sc);this.B(A.Event.filter(F.onDidChangeValue(-1,c.$ypb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[m]),this.a.fire()}m(D){if(D&&(D=P.$o&&D.web?{...D,...D.web}:D,(0,C.$Tf)(D.url)&&(0,C.$Vf)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(T=>Array.isArray(D.authenticationProviders[T].scopes)))){const T=D,F=!!T.canSwitch,q=T.url===T.insidersUrl?"insiders":"stable",Z=(F?this.c:void 0)||q,X=Z==="insiders"?T.insidersUrl:Z==="stable"?T.stableUrl:T.url;return{url:k.URI.parse(X),type:Z,defaultType:q,defaultUrl:k.URI.parse(T.url),stableUrl:k.URI.parse(T.stableUrl),insidersUrl:k.URI.parse(T.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(T.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:T.authenticationProviders[W].scopes}),x),[])}}}};e.$VIb=a,e.$VIb=a=ye([Q(0,$.$6j),Q(1,f.$Mi),Q(2,h.$Kp)],a);let v=class extends a{constructor(D,T,F){super(D,T,F);const q=this.h.get(i,-1);q&&(this.n=JSON.parse(q));const Z=this.f[m];Z?this.h.store(i,JSON.stringify(Z),-1,1):this.h.remove(i,-1)}async switch(D){D!==this.c&&(this.c=D,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$WIb=v,e.$WIb=v=ye([Q(0,$.$6j),Q(1,f.$Mi),Q(2,h.$Kp)],v);let y=class extends O.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(D,T,F,q,Z,X,x){super(),this.n=F,this.r=q,this.s=x,this.g=this.B(new A.$6d),this.onTokenFailed=this.g.event,this.h=this.B(new A.$6d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$6d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(D),this.c=(0,d.$Qp)(Z,X,x).then(W=>{const K={"X-Client-Name":`${T.applicationName}${P.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(K["X-Client-Commit"]=T.commit),K}),this.f=new S(t,r,this.n,this.r),this.u(),this.B((0,O.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(D,T){this.b={token:D,type:T}}t(D){this.a=D?(0,g.$Tg)(D,"v1"):void 0}u(){const D=this.s.getNumber(o,-1);D&&Date.now()<D&&this.y(new Date(D))}y(D){this.j?.getTime()!==D?.getTime()&&(this.j=D,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,I.$6g)(T=>(0,I.$hh)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Tg)(this.a,"collection").toString();D={...D},D["Content-Type"]="application/json";const F=await this.D(T,{type:"GET",headers:D},[],N.CancellationToken.None);return(await(0,l.$Dp)(F))?.map(({id:q})=>q)||[]}async createCollection(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Tg)(this.a,"collection").toString();D={...D},D["Content-Type"]=R.$vs.text;const F=await this.D(T,{type:"POST",headers:D},[],N.CancellationToken.None),q=await(0,l.$Cp)(F);if(!q)throw new c.$wpb("Server did not return the collection id",T,"NoCollection",F.res.statusCode,F.res.headers[c.$spb]);return q}async deleteCollection(D,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=D?(0,g.$Tg)(this.a,"collection",D).toString():(0,g.$Tg)(this.a,"collection").toString();T={...T},await this.D(F,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(D,T){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,T,D),q={},Z=await this.D(F.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,l.$Dp)(Z)||[]).map(({url:x,created:W})=>({ref:(0,g.$Vg)(F,F.with({path:x})),created:W*1e3}))}async resolveResourceContent(D,T,F,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$Tg)(this.z(this.a,F,D),T).toString();q={...q},q["Cache-Control"]="no-cache";const X=await this.D(Z,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,l.$Cp)(X)}async deleteResource(D,T,F){if(!this.a)throw new Error("No settings sync store url configured.");const q=T!==null?(0,g.$Tg)(this.z(this.a,F,D),T).toString():this.z(this.a,F,D).toString(),Z={};await this.D(q,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,g.$Tg)(this.a,"resource").toString(),T={"Content-Type":R.$vs.text};await this.D(D,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(D,T,F,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$Tg)(this.z(this.a,F,D),"latest").toString();q={...q},q["Cache-Control"]="no-cache",T&&(q["If-None-Match"]=T.ref);const X=await this.D(Z,{type:"GET",headers:q},[304],N.CancellationToken.None);let x=null;if(X.res.statusCode===304&&(x=T),x===null){const W=X.res.headers.etag;if(!W)throw new c.$wpb("Server did not return the ref",Z,"NoRef",X.res.statusCode,X.res.headers[c.$spb]);const K=await(0,l.$Cp)(X);if(!K&&X.res.statusCode===304)throw new c.$wpb("Empty response",Z,"EmptyResponse",X.res.statusCode,X.res.headers[c.$spb]);x={ref:W,content:K}}return x}async writeResource(D,T,F,q,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=this.z(this.a,q,D).toString();Z={...Z},Z["Content-Type"]=R.$vs.text,F&&(Z["If-Match"]=F);const x=await this.D(X,{type:"POST",data:T,headers:Z},[],N.CancellationToken.None),W=x.res.headers.etag;if(!W)throw new c.$wpb("Server did not return the ref",X,"NoRef",x.res.statusCode,x.res.headers[c.$spb]);return W}async manifest(D,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Tg)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",D&&(T["If-None-Match"]=D.ref);const q=await this.D(F,{type:"GET",headers:T},[304],N.CancellationToken.None);let Z=null;if(q.res.statusCode===304&&(Z=D),!Z){const x=q.res.headers.etag;if(!x)throw new c.$wpb("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[c.$spb]);const W=await(0,l.$Cp)(q);if(!W&&q.res.statusCode===304)throw new c.$wpb("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[c.$spb]);W&&(Z={...JSON.parse(W),ref:x})}const X=this.s.get(n,-1);return X&&Z&&X!==Z.session&&this.C(),Z===null&&X&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,g.$Tg)(this.a,"download").toString(),T={},F=await this.D(D,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,l.$zp)(F))throw new c.$wpb("Server returned "+F.res.statusCode,D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$spb]);if((0,l.$Ap)(F))throw new c.$wpb("Empty response",D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$spb]);return F.stream}z(D,T,F){return T?(0,g.$Tg)(D,"collection",T,"resource",F):(0,g.$Tg)(D,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(D,T,F,q){if(!this.b)throw new c.$wpb("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$wpb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;T.headers={...T.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:D,type:T.type,headers:{...T.headers,authorization:void 0}});let X;try{X=await this.f.request(D,T,q)}catch(H){if(!(H instanceof c.$wpb)){let te="RequestFailed";const re=(0,L.$0)(H).toLowerCase();re.includes("xhr timeout")?te="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?te="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":re.includes("headers must be an object")?te="RequestHeadersNotObject":(0,L.$4)(H)&&(te="RequestCanceled"),H=new c.$wpb(`Connection refused for the request '${D}'.`,D,te,void 0,void 0)}throw this.r.info("Request failed",D),H}const x=X.res.headers[c.$spb],W={url:D,status:X.res.statusCode,"execution-id":T.headers[c.$tpb],"operation-id":x},K=(0,l.$zp)(X)||X.res.statusCode&&F.includes(X.res.statusCode);let V="";if(K?this.r.trace("Request succeeded",W):(V=await(0,l.$Bp)(X)||"",this.r.info("Request failed",W,V)),X.res.statusCode===401||X.res.statusCode===403){if(this.b=void 0,X.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$wpb(`${T.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",X.res.statusCode,x);if(X.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$wpb(`${T.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",X.res.statusCode,x)}if(this.h.fire(),X.res.statusCode===404)throw new c.$wpb(`${T.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",X.res.statusCode,x);if(X.res.statusCode===405)throw new c.$wpb(`${T.type} request '${D}' failed because the requested endpoint is not found (405). ${V}`,D,"MethodNotFound",X.res.statusCode,x);if(X.res.statusCode===409)throw new c.$wpb(`${T.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",X.res.statusCode,x);if(X.res.statusCode===410)throw new c.$wpb(`${T.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",X.res.statusCode,x);if(X.res.statusCode===412)throw new c.$wpb(`${T.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",X.res.statusCode,x);if(X.res.statusCode===413)throw new c.$wpb(`${T.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",X.res.statusCode,x);if(X.res.statusCode===426)throw new c.$wpb(`${T.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",X.res.statusCode,x);if(X.res.statusCode===429){const H=X.res.headers["retry-after"];throw H?(this.y(new Date(Date.now()+parseInt(H)*1e3)),new c.$wpb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",X.res.statusCode,x)):new c.$wpb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",X.res.statusCode,x)}if(!K)throw new c.$wpb("Server returned "+X.res.statusCode,D,"Unknown",X.res.statusCode,x);return X}F(D){let T=this.s.get(s,-1);T===void 0&&(T=(0,w.$Cg)(),this.s.store(s,T,-1,1)),D["X-Machine-Session-Id"]=T;const F=this.s.get(n,-1);F!==void 0&&(D["X-User-Session-Id"]=F)}};e.$XIb=y,e.$XIb=y=ye([Q(1,$.$6j),Q(2,l.$xp),Q(3,c.$Fpb),Q(4,u.$ni),Q(5,b.$Mk),Q(6,h.$Kp)],y);let p=class extends y{constructor(D,T,F,q,Z,X,x){super(D.userDataSyncStore?.url,T,F,q,Z,X,x),this.B(D.onDidChangeUserDataSyncStore(()=>this.t(D.userDataSyncStore?.url)))}};e.$YIb=p,e.$YIb=p=ye([Q(0,c.$ppb),Q(1,$.$6j),Q(2,l.$xp),Q(3,c.$Fpb),Q(4,u.$ni),Q(5,b.$Mk),Q(6,h.$Kp)],p);class S{constructor(D,T,F,q){this.c=D,this.d=T,this.f=F,this.g=q,this.a=[],this.b=void 0}request(D,T,F){if(this.h()&&this.i(),T.url=D,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$wpb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(D),this.f.request(T,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$ZIb=S}),define(le[264],he([0,1,3,2,10,21,24,19,122]),function(se,e,I,N,L,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=e.$Ubc=e.$Tbc=e.$Sbc=void 0;class g{constructor(u){this.a=u}listen(u,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(u,b,$){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$Sbc=g;class C extends N.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(u){super(),this.c=u,this.b=this.B(new I.$6d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")($=>{this.a=$,this.b.fire($)}))})}updateAccount(u){return this.c.call("updateAccount",u)}}e.$Tbc=C;class k{constructor(u){this.a=u}listen(u,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(u,b,$){switch(b){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Ubc=k;let w=class extends P.$VIb{constructor(u,b,$,l){super(b,$,l),this.n=u,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(u){return this.n.call("switch",[u])}async getPreviousUserDataSyncStore(){const u=await this.n.call("getPreviousUserDataSyncStore");return this.r(u)}r(u){return{url:L.URI.revive(u.url),type:u.type,defaultUrl:L.URI.revive(u.defaultUrl),insidersUrl:L.URI.revive(u.insidersUrl),stableUrl:L.URI.revive(u.stableUrl),canSwitch:u.canSwitch,authenticationProviders:u.authenticationProviders}}};e.$Vbc=w,e.$Vbc=w=ye([Q(1,O.$6j),Q(2,A.$Mi),Q(3,R.$Kp)],w)}),define(le[265],he([0,1,3,57,24,19,22,260,25,80,83]),function(se,e,I,N,L,A,O,R,P,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;let k=class extends R.$D$b{constructor(f,u,b,$,l,d,h,c,m,i,o){super(f,u,b,$,l,h,c,m,i,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$fcc=k,e.$fcc=k=ye([Q(0,L.$6j),Q(1,P.$ppb),Q(2,P.$qpb),Q(3,P.$Apb),Q(4,P.$Bpb),Q(5,N.$9_b),Q(6,P.$Fpb),Q(7,g.$tHb),Q(8,O.$Ll),Q(9,C.$dpb),Q(10,A.$Kp)],k)}),define(le[266],he([0,1,73,23,5,20]),function(se,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0,e.$x_b=O,e.$y_b=R,e.$z_b=P,e.$w_b=128/4;function O(g){function C(){let k=g.scheme===N.Schemas.file?(0,A.$Hg)(g):g.toString();return L.$k||(k=k.toLowerCase()),(0,I.createHash)("md5").update(k).digest("hex")}return{id:C(),configPath:g}}function R(g,C){function k(){if(g.scheme!==N.Schemas.file)return(0,I.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let f;return L.$k?f=C.ino:L.$j?f=C.birthtime.getTime():L.$i&&(typeof C.birthtimeMs=="number"?f=Math.floor(C.birthtimeMs):f=C.birthtime.getTime()),(0,I.createHash)("md5").update(g.fsPath).update(f?String(f):"").digest("hex")}const w=k();if(typeof w=="string")return{id:w,uri:g}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[267],he([0,1,6,7,2,15,31,16,8,77,112,266,57,56,23]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;let b=class extends L.$Tc{constructor(l,d,h,c){super(),this.a=l,this.b=d,this.c=h,this.f=c,this.B(new I.$sh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:u.Schemas.file}).fsPath,d=await O.Promises.readdir(l),h=new g.$5Hb(this.f.getChannel("storage"));await Promise.all(d.map(async c=>{const m=(0,A.$jc)(l,c);c.length===k.$w_b||c===C.$si.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await h.isUsed(m)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await O.Promises.rm(m))}))}catch(l){(0,N.$1)(l)}}};e.$Obc=b,e.$Obc=b=ye([Q(0,R.$oi),Q(1,P.$Mj),Q(2,w.$9_b),Q(3,f.$lbc)],b)}),define(le[123],he([0,1,73,64,37,277,14,7,3,2,15,5,32,40,68]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$0h=e.$9h=e.$8h=void 0,e.$$h=n,e.$_h=s,e.$bi=a,e.$ci=v;class b{traceSocketEvent(p,S){u.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,S)}constructor(p,S=""){this.f=!0,this.debugLabel=S,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,R.$1)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const S=E=>{this.traceSocketEvent("read",E),p(O.$te.wrap(E))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(p){const S=E=>{p({type:0,hadError:E,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(p){const S=()=>{p()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,R.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,R.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.$8h=b;var $;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var l;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(l||(l={}));class d extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,S){this.socket.traceSocketEvent(p,S)}constructor(p,S,E,D){super(),this.f=this.B(new P.$6d),this.g=this.B(new P.$6d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:E?.byteLength||0,recordInflateBytes:D}),this.a=this.B(new h(this,S,E,D,this.f,(T,F)=>this.m(T,F))),this.B(this.a.onError(T=>{console.error(T),(0,R.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new u.$3h,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let S=0;for(;S<p.byteLength;)this.a.writeMessage(p.slice(S,Math.min(S+262144,p.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(p,{compressed:S,opcode:E}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let D=2;p.byteLength<126?D+=0:p.byteLength<2**16?D+=2:D+=8;const T=O.$te.alloc(D),F=S?64:0,q=E&15;if(T.writeUInt8(128|F|q,0),p.byteLength<126)T.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){T.writeUInt8(126,1);let Z=1;T.writeUInt8(p.byteLength>>>8&255,++Z),T.writeUInt8(p.byteLength>>>0&255,++Z)}else{T.writeUInt8(127,1);let Z=1;T.writeUInt8(0,++Z),T.writeUInt8(0,++Z),T.writeUInt8(0,++Z),T.writeUInt8(0,++Z),T.writeUInt8(p.byteLength>>>24&255,++Z),T.writeUInt8(p.byteLength>>>16&255,++Z),T.writeUInt8(p.byteLength>>>8&255,++Z),T.writeUInt8(p.byteLength>>>0&255,++Z)}this.socket.write(O.$te.concat([T,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),E=S.readUInt8(0),D=(E&128)>>>7,T=(E&64)>>>6,F=E&15,q=S.readUInt8(1),Z=(q&128)>>>7,X=q&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=D,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!D,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),E=S.readUInt8(1),D=(E&128)>>>7;let T=E&127,F=1;T===126?T=S.readUInt8(++F)*2**8+S.readUInt8(++F):T===127&&(T=S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F));let q=0;D&&(q=S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F)),this.j.state=3,this.j.readLen=T,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),i(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$9h=d;class h extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$te.alloc(0)}constructor(p,S,E,D,T,F){super(),this.n=p,this.r=T,this.s=F,this.a=this.B(new P.$6d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$6d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$6d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new c(this.n,D,E,{windowBits:15})),this.f=this.B(new m(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(p,S){this.g.push({data:p,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:S}=this.g.shift();if(this.f&&S.compressed){const E=await this.w(this.f,p);this.s(E,S)}else this.s(p,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,S){return new Promise((E,D)=>{p.write(S),p.flush(T=>E(T))})}acceptFrame(p,S,E){this.h.push({data:p,isCompressed:S,isLastFrameOfMessage:E}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const S=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,S,E){return new Promise((D,T)=>{p.write(S),E&&p.write(O.$te.fromByteArray([0,0,255,255])),p.flush(F=>D(F))})}}class c extends g.$Tc{get recordedInflateBytes(){return this.j?O.$te.concat(this.f):O.$te.alloc(0)}constructor(p,S,E,D){super(),this.h=p,this.j=S,this.a=this.B(new P.$6d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(D),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(O.$te.wrap(T))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=O.$te.concat(this.g);this.g.length=0,p(S)})}}class m extends g.$Tc{constructor(p,S){super(),this.g=p,this.a=this.B(new P.$6d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(O.$te.wrap(E))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=O.$te.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),p(S)})}}function i(y,p){if(p===0)return;const S=y.byteLength>>>2;for(let Z=0;Z<S;Z++){const X=y.readUInt32BE(Z*4);y.writeUInt32BE(X^p,Z*4)}const E=S*4,D=y.byteLength-E,T=p>>>24&255,F=p>>>16&255,q=p>>>8&255;D>=1&&y.writeUInt8(y.readUInt8(E)^T,E),D>=2&&y.writeUInt8(y.readUInt8(E+1)^F,E+1),D>=3&&y.writeUInt8(y.readUInt8(E+2)^q,E+2)}e.$0h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const y=(0,w.$Cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const p=process.platform!=="darwin"&&e.$0h?e.$0h:(0,L.tmpdir)(),S=(0,C.$jc)(p,`vscode-ipc-${y}.sock`);return t(S),S}function s(y,p,S){const D=(0,I.createHash)("sha256").update(y).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${S}-${p}-sock`;const T=S.substr(0,4),F=p.substr(0,6);let q;return process.platform!=="darwin"&&e.$0h&&!process.env.VSCODE_PORTABLE?q=(0,C.$jc)(e.$0h,`vscode-${D}-${T}-${F}.sock`):q=(0,C.$jc)(y,`${T}-${F}.sock`),t(q),q}function t(y){const p=o[k.$u];typeof p=="number"&&y.length>=p&&console.warn(`WARNING: IPC handle "${y}" is longer than ${p} chars, try a shorter --user-data-dir`)}class r extends f.$Wh{static b(p){const S=P.Event.fromNodeEventEmitter(p,"connection");return P.Event.map(S,E=>({protocol:new u.$4h(new b(E,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(E,"close"))}))}constructor(p){super(r.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ai=r;function a(y){return new Promise((p,S)=>{const E=(0,N.createServer)();E.on("error",S),E.listen(y,()=>{E.removeListener("error",S),p(new r(E))})})}function v(y,p){return new Promise((S,E)=>{const D=(0,N.createConnection)(y,()=>{D.removeListener("error",E),S(u.$5h.fromSocket(new b(D,`ipc-client${p}`),p))});D.once("error",E)})}}),define(le[268],he([0,1,64,123,215]),function(se,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0,e.$icc=new class{supports(A){return!0}connect({host:A,port:O},R,P,g){return new Promise((C,k)=>{const w=I.createConnection({host:A,port:O},()=>{w.removeListener("error",k),w.write((0,L.$Jtb)(R,P,g));const f=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",f),C(new N.$8h(w,g)))};w.on("data",f)});w.setNoDelay(!0),w.once("error",k)})}}}),define(le[269],he([0,1,64,37,133,123,6,2,5,21,8,24,217,104,106,78,14]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=e.$ebc=e.$dbc=e.$cbc=void 0;async function l(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&L.$Fg[t]||!L.$Fg[r.tunnelLocalPort]));a--);return r}class d extends R.$Tc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=I.createServer(),this.c=new O.$fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$1v)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Gg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$Yv)(this.tunnelRemoteHost)||(0,b.$1v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Cl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof A.$8h?t.socket.destroy():t.end()}),t instanceof A.$8h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write($.$te.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$cbc=d;let h=class extends b.$4v{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$2v)(o,this.m,P.OS,N.release())}t(o,n,s,t,r,a,v,y){const p=this.s(n,s);if(p)return++p.refcount,p.value;if((0,b.$Uv)(o))return this.u(o,n,s,r,a,v,y);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},E=l(S,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,E),E}}};e.$dbc=h,e.$dbc=h=ye([Q(0,f.$wl),Q(1,C.$Mj),Q(2,u.$zl),Q(3,k.$6j),Q(4,g.$Mi)],h);let c=class extends h{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$ebc=c,e.$ebc=c=ye([Q(0,f.$wl),Q(1,C.$Mj),Q(2,u.$zl),Q(3,k.$6j),Q(4,g.$Mi)],c);let m=class extends R.$Tc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,v,y,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const S=new c(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(o,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,v,y,p)}};e.$fbc=m,e.$fbc=m=ye([Q(0,f.$wl),Q(1,C.$Mj),Q(2,k.$6j),Q(3,u.$zl),Q(4,g.$Mi)],m)}),define(le[278],he([0,1,37,38,7,2,23,10,17,3,40,149,209,210,200,201,267,191,193,21,214,94,225,95,220,16,114,251,29,98,192,113,96,12,203,204,72,4,199,74,75,231,8,205,101,24,59,19,107,22,108,109,110,46,234,82,111,25,80,259,264,244,83,258,262,263,122,60,257,245,106,224,78,269,219,235,28,236,5,237,194,212,211,81,250,18,52,208,58,256,233,246,105,261,252,9,206,100,254,249,221,188,57,207,265,253,56,255,104,268,185,222,145,140]),function(se,e,I,N,L,A,O,R,P,g,C,k,w,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a,v,y,p,S,E,D,T,F,q,Z,X,x,W,K,V,H,te,re,ee,ae,J,z,j,M,B,U,Y,_,ne,G,ie,ce,fe,de,me,Ee,Re,Oe,Ne,ue,$e,we,Pe,Ce,Me,De,ze,Te,Ue,qe,Le,oe,ge,be,pe,ve,ke,Ie,Ae,He,Be,Fe,Ke,Ge,_e,tt,Et,St,gt,kt,Pt,Ct,Rt,It,Ot,Dt,jt,$t,Lt,mt,At,Nt,st,Tt,Mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class Ft extends A.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new k.$0V(this)),this.b=void 0,this.c=this.B(new g.$6d),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,k.$$V)(process.parentPort,st.$rac.exit,je)}async init(){const Se=await this.h();(0,ne.$kpb)(),Se.invokeFunction(je=>{const We=je.get(K.$Mj),Ve=je.get(J.$Ll),Ye=je.get(ke.$ml);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(We),this.n(Ve,Ye),this.B(Ye.onDidChangeProfiles(()=>this.n(Ve,Ye))),this.r(Ve,We)}),this.B((0,A.$Qc)(Se.createInstance(w.$Kbc,this.f.codeCachePath),Se.createInstance(f.$Lbc),Se.createInstance($.$Obc),Se.createInstance(b.$Nbc),Se.createInstance(u.$Mbc),Se.createInstance(tt.$_bc),Se.createInstance(Ke.$4bc)))}async h(){const Se=new X.$ei,je={_serviceBrand:void 0,...H.default};Se.set(te.$6j,je);const We=new C.$1h(Je=>Je==="main"),Ve=new $t.$mbc(this.a,We);Se.set($t.$lbc,Ve);const Ye=this.f.policiesData?new Ae.$Uac(this.f.policiesData,Ve.getChannel("policy")):new He.$3n;Se.set(He.$1n,Ye);const Qe=new Nt.$Sm(this.f.args,je);Se.set(s.$oi,Qe);const et=new V.$Qr(void 0,this.f.logLevel,Qe.logsHome,this.f.loggers.map(Je=>({...Je,resource:R.URI.revive(Je.resource)})),Ve.getChannel("logger"));Se.set(K.$Nj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new K.$Uj(ot.getLevel())),Xe=this.B(new St.$VP(ot,[ht]));Se.set(K.$Mj,Xe),this.b=this.B(new gt.$bcc(Xe)),Se.set(gt.$acc,this.b);const Ze=this.B(new D.$sq(Xe));Se.set(E.$Mk,Ze);const ut=this.B(new T.$Rq(Xe));Ze.registerProvider(O.Schemas.file,ut);const at=new Ue.$fs(Ze);Se.set(Te.$kl,at);const xe=this.B(new Be.$3P(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Qe.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Se.set(ke.$ml,xe);const ft=this.B(new Le.$kbc(O.Schemas.file,this.B(new oe.$EP(Ve.getChannel(oe.$DP),{pathCaseSensitive:qe.$k})),O.Schemas.vscodeUserData,xe,at,Xe));Ze.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new c.$qo(xe.defaultProfile.settingsResource,Ze,Ye,Xe));Se.set(h.$Mi,it);const dt=new Lt.$hcc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Qe);Se.set(ee.$Kp,dt),this.B((0,A.$Rc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const wt=new Ct.$Br(Ve.getChannel("request"));Se.set(re.$xp,wt),Se.set(l.$Pbc,new F.$di(d.$Qbc,void 0,!1)),Se.set(be.$JF,new F.$di(ge.$3bc,void 0,!1));const bt=new Ot.$rbc(-1,Ve);Se.set(It.$9_b,bt),Se.set(o.$uo,new F.$di(n.$$P,void 0,!0));const qt=this.B(new $e.$Rac(bt)),zt=new C.$1h(Je=>qt.getActiveClientId().then(lt=>Je===lt));Se.set(S.$c2b,new Rt.$dcc(this.a.getChannel("extensionRecommendationNotification",zt)));let ct;const nt=[],yt=(0,B.$bp)(je,it);if((0,B.$9o)(je,Qe)){const Je=new j.$U0b(Xe,et,Qe,je);if(nt.push(Je),!(0,B.$0o)(je,Qe)&&je.aiConfig?.ariaKey){const lt=new Fe.$JP(wt,yt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Rc)(()=>lt.flush())),nt.push(lt)}ct=new M.$Fr({appenders:nt,commonProperties:(0,ae.$Zo)((0,I.release)(),(0,I.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,B.$cp)(Qe)},it,je)}else{ct=B.$4o;const Je=B.$8o;nt.push(Je)}this.a.registerChannel("telemetryAppender",new z.$wac(nt)),Se.set(J.$Ll,ct);const Bt=new U.$Rbc(it,ct,Xe,et,Qe,je);Se.set(J.$Ml,Bt),Se.set(Ie.$_p,new F.$di(Pt.$UP,void 0,!0)),Se.set(pe.$dq,new F.$di(ve.$Vac,void 0,!0)),Se.set(v.$Vp,new F.$di(v.$Wp,void 0,!0)),Se.set(p.$nq,new F.$di(p.$oq,void 0,!0)),Se.set(a.$Po,new F.$di(r.$Tp,void 0,!0)),Se.set(a.$Wo,new F.$di(jt.$gcc,void 0,!1)),Se.set(x.$xr,new F.$di(W.$zr,void 0,!1)),Se.set(m.$Zm,new F.$di(i.$ms,void 0,!1)),Se.set(G.$tHb,new F.$di(G.$uHb,void 0,!0)),Se.set(ne.$Fpb,new F.$di(fe.$QJb,void 0,!0)),Se.set(ne.$Epb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),Se.set(a.$Vo,new F.$di(t.$rHb,void 0,!1)),Se.set(_.$OJb,new F.$di(_.$PJb,void 0,!0)),Se.set(Y.$Ev,new F.$di(Y.$Fv)),Se.set(ne.$ppb,new F.$di(Oe.$WIb,void 0,!0)),Se.set(ne.$qpb,new F.$di(Oe.$YIb,void 0,!0)),Se.set(de.$dpb,new F.$di(de.$fpb,void 0,!0)),Se.set(ne.$rpb,new F.$di(ie.$x$b,void 0,!1)),Se.set(ne.$Apb,new F.$di(me.$m$b,void 0,!0)),Se.set(ne.$Bpb,new F.$di(Ee.$C$b,void 0,!1)),Se.set(Ne.$6Hb,new F.$di(ue.$Ybc,void 0,!0)),Se.set(ne.$Cpb,new F.$di(_e.$_$b,void 0,!0)),Se.set(we.$zl,new F.$di(Pe.$hbc,void 0,!1));const vt=new mt.$xl;return Se.set(mt.$wl,vt),vt.register(0,At.$icc),Se.set(Ce.$Tv,new F.$di(Me.$fbc)),Se.set(De.$Zbc,new F.$di(ze.$2bc)),Se.set(Ge.$5bc,new F.$di(kt.$ccc)),new Z.$Uq(Se)}j(Se){const je=new y.$Yp(Se.get(a.$So),()=>null);this.a.registerChannel("extensions",je);const We=C.ProxyChannel.fromService(Se.get(x.$xr),this.q);this.a.registerChannel("languagePacks",We);const Ve=C.ProxyChannel.fromService(Se.get(m.$Zm),this.q);this.a.registerChannel("diagnostics",Ve);const Ye=new y.$1p(Se.get(a.$Wo));this.a.registerChannel("extensionTipsService",Ye);const Qe=C.ProxyChannel.fromService(Se.get(l.$Pbc),this.q);this.a.registerChannel("checksum",Qe);const et=C.ProxyChannel.fromService(Se.get(be.$JF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(Se.get(de.$dpb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(Se.get(J.$Ml),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Xe=new ce.$Sbc(Se.get(G.$tHb));this.a.registerChannel("userDataSyncAccount",Xe);const Ze=new ce.$Ubc(Se.get(ne.$ppb));this.a.registerChannel("userDataSyncStoreManagement",Ze);const ut=new Re.$Wbc(Se.get(ne.$Bpb),Se.get(ke.$ml),Se.get(K.$Mj));this.a.registerChannel("userDataSync",ut);const at=this.B(Se.get(q.$fi).createInstance(Dt.$fcc));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(ne.$Cpb),this.q));const xe=C.ProxyChannel.fromService(Se.get(De.$Zbc),this.q);this.a.registerChannel(De.$1bc,xe);const ft=C.ProxyChannel.fromService(Se.get(Ge.$5bc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(Se){process.on("uncaughtException",je=>(0,L.$1)(je)),process.on("unhandledRejection",je=>(0,L.$1)(je)),(0,L.setUnexpectedErrorHandler)(je=>{const We=(0,N.$4i)(je,!0);We&&Se.error(`[uncaught exception in sharedProcess]: ${We}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}async r(Se,je){if(qe.$k){const We=await(0,Tt.$Dg)(je.error.bind(je)),Ve=(0,Mt.$yV)();We&&Se.publicLog2("clientPlatformInfo",{platformId:We.id,platformVersionId:We.version_id,platformIdLike:We.id_like,desktopEnvironment:Ve})}}handledClientConnection(Se){if(Se.data!==st.$tac.response)return!1;const je=(0,P.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function pt(rt){try{const Se=new Ft(rt);process.parentPort.postMessage(st.$rac.ipcReady),await Se.init(),process.parentPort.postMessage(st.$rac.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}const Ut=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(Ut),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
