/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(fe){for(var e=[],u=0,L=fe.length;u<L;u++)e[u]=Se[fe[u]];return e};define(Se[161],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const M=new Map,A=new Map,P=new Map,b=new Map;function p(S,y){S.has(y.detail)||S.set(y.detail,-y.timestamp)}function E(S,y){const h=S.get(y.detail);h&&(h>=0||S.set(y.detail,h+y.timestamp))}let R=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(R=fe.getStats().slice(0).sort((S,y)=>S.timestamp-y.timestamp));for(const S of R)switch(S.type){case 10:p(M,S);break;case 11:case 12:E(M,S);break;case 21:p(A,S);break;case 22:E(A,S);break;case 33:p(P,S);break;case 34:E(P,S);break;case 31:p(b,S);break;case 32:E(b,S);break}let I=0;P.forEach(S=>I+=S);function w(S){const y=[];return S.forEach((h,g)=>y.push([g,h])),y}return{amdLoad:w(M),amdInvoke:w(A),nodeRequire:w(P),nodeEval:w(b),nodeRequireTotal:I}}static toMarkdownTable(M,A){let P="";const b=[];return M.forEach((p,E)=>{b[E]=p.length}),A.forEach(p=>{p.forEach((E,R)=>{typeof E>"u"&&(E=p[R]="-");const I=E.toString().length;b[R]=Math.max(I,b[R])})}),M.forEach((p,E)=>{P+=`| ${p+" ".repeat(b[E]-p.toString().length)} `}),P+=`|
`,M.forEach((p,E)=>{P+=`| ${"-".repeat(b[E])} `}),P+=`|
`,A.forEach(p=>{p.forEach((E,R)=>{typeof E<"u"&&(P+=`| ${E+" ".repeat(b[R]-E.toString().length)} `)}),P+=`|
`}),P}}e.$U=u}),define(Se[162],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=L,e.$hb=M,e.$ib=A,e.$jb=P,e.$kb=b,e.$lb=p,e.$nb=R,e.$ob=I,e.$pb=w,e.$qb=S,e.$rb=y;function u(h,g,c){const n=L(h,g);if(n!==-1)return h[n]}function L(h,g,c=h.length-1){for(let n=c;n>=0;n--){const i=h[n];if(g(i))return n}return-1}function M(h,g){const c=A(h,g);return c===-1?void 0:h[c]}function A(h,g,c=0,n=h.length){let i=c,r=n;for(;i<r;){const a=Math.floor((i+r)/2);g(h[a])?i=a+1:r=a}return i-1}function P(h,g){const c=b(h,g);return c===h.length?void 0:h[c]}function b(h,g,c=0,n=h.length){let i=c,r=n;for(;i<r;){const a=Math.floor((i+r)/2);g(h[a])?r=a:i=a+1}return i}function p(h,g,c=0,n=h.length){const i=b(h,g,c,n);return i===h.length?-1:i}class E{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!g(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const c=A(this.e,g,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=E;function R(h,g){if(h.length===0)return;let c=h[0];for(let n=1;n<h.length;n++){const i=h[n];g(i,c)>0&&(c=i)}return c}function I(h,g){if(h.length===0)return;let c=h[0];for(let n=1;n<h.length;n++){const i=h[n];g(i,c)>=0&&(c=i)}return c}function w(h,g){return R(h,(c,n)=>-g(c,n))}function S(h,g){if(h.length===0)return-1;let c=0;for(let n=1;n<h.length;n++){const i=h[n];g(i,h[c])>0&&(c=n)}return c}function y(h,g){for(const c of h){const n=g(c);if(n!==void 0)return n}}}),define(Se[72],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=L,e.$M=M,e.$N=A;function u(P,b){const p=Object.create(null);for(const E of P){const R=b(E);let I=p[R];I||(I=p[R]=[]),I.push(E)}return p}function L(P,b){const p=[],E=[];for(const R of P)b.has(R)||p.push(R);for(const R of b)P.has(R)||E.push(R);return{removed:p,added:E}}function M(P,b){const p=[],E=[];for(const[R,I]of P)b.has(R)||p.push(I);for(const[R,I]of b)P.has(R)||E.push(I);return{removed:p,added:E}}function A(P,b){const p=new Set;for(const E of b)P.has(E)&&p.add(E);return p}}),define(Se[53],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=L,e.$Lh=M,e.$Mh=A;function u(P){return(b,p,E)=>{let R=null,I=null;if(typeof E.value=="function"?(R="value",I=E.value):typeof E.get=="function"&&(R="get",I=E.get),!I)throw new Error("not supported");E[R]=P(I,p)}}function L(P,b,p){let E=null,R=null;if(typeof p.value=="function"?(E="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",R=p.get),!R)throw new Error("not supported");const I=`$memoize$${b}`;p[E]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[I]}}function M(P,b,p){return u((E,R)=>{const I=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...S){this[w]||(this[w]=p?p():void 0),clearTimeout(this[I]),b&&(this[w]=b(this[w],...S),S=[this[w]]),this[I]=setTimeout(()=>{E.apply(this,S),this[w]=p?p():void 0},P)}})}function A(P,b,p){return u((E,R)=>{const I=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,y=`$throttle$pending$${R}`;return function(...h){if(this[w]||(this[w]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[w]=b(this[w],...h)),this[y])return;const g=this[S]+P;g<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[w]]),this[w]=p?p():void 0):(this[y]=!0,this[I]=setTimeout(()=>{this[y]=!1,this[S]=Date.now(),E.apply(this,[this[w]]),this[w]=p?p():void 0},g-Date.now()))}})}}),define(Se[13],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=M,e.$1=A,e.$2=P,e.$3=b,e.$4=E,e.$6=I,e.$7=w,e.$8=S,e.$0=h;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function L(a){e.$X.setUnexpectedErrorHandler(a)}function M(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(a){E(a)||e.$X.onUnexpectedError(a)}function P(a){E(a)||e.$X.onUnexpectedExternalError(a)}function b(a){if(a instanceof Error){const{name:t,message:f}=a,l=a.stacktrace||a.stack;return{$isError:!0,name:t,message:f,stack:l,noTelemetry:i.isErrorNoTelemetry(a)}}return a}const p="Canceled";function E(a){return a instanceof R?!0:a instanceof Error&&a.name===p&&a.message===p}class R extends Error{constructor(){super(p),this.name=this.message}}e.$5=R;function I(){const a=new Error(p);return a.name=a.message,a}function w(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function h(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Se[19],De([1,0,13,162]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=M,e.$tb=A,e.$ub=P,e.$vb=b,e.$wb=p,e.$xb=E,e.$yb=R,e.$zb=I,e.$Ab=w,e.$Bb=S,e.$Cb=y,e.$Db=h,e.$Eb=g,e.top=c,e.$Gb=n,e.$Hb=r,e.$Ib=a,e.$Jb=t,e.$Kb=f,e.$Lb=l,e.$Mb=s,e.$Nb=o,e.$Ob=d,e.$Pb=m,e.$Qb=D,e.$Rb=$,e.$Sb=v,e.$Tb=k,e.$Ub=C,e.$Vb=O,e.$Wb=B,e.$Xb=z,e.$Yb=T,e.$Zb=j,e.$1b=N,e.$2b=F,e.$3b=K,e.$4b=ee,e.$5b=Y,e.$6b=Q,e.$7b=_,e.$8b=ge,e.$$b=U;function M(le,ue=0){return le[le.length-(1+ue)]}function A(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}function P(le,ue,ce=(de,H)=>de===H){if(le===ue)return!0;if(!le||!ue||le.length!==ue.length)return!1;for(let de=0,H=le.length;de<H;de++)if(!ce(le[de],ue[de]))return!1;return!0}function b(le,ue){const ce=le.length-1;ue<ce&&(le[ue]=le[ce]),le.pop()}function p(le,ue,ce){return E(le.length,de=>ce(le[de],ue))}function E(le,ue){let ce=0,de=le-1;for(;ce<=de;){const H=(ce+de)/2|0,x=ue(H);if(x<0)ce=H+1;else if(x>0)de=H-1;else return H}return-(ce+1)}function R(le,ue,ce){if(le=le|0,le>=ue.length)throw new TypeError("invalid index");const de=ue[Math.floor(ue.length*Math.random())],H=[],x=[],he=[];for(const pe of ue){const Ae=ce(pe,de);Ae<0?H.push(pe):Ae>0?x.push(pe):he.push(pe)}return le<H.length?R(le,H,ce):le<H.length+he.length?he[0]:R(le-(H.length+he.length),x,ce)}function I(le,ue){const ce=[];let de;for(const H of le.slice(0).sort(ue))!de||ue(de[0],H)!==0?(de=[H],ce.push(de)):de.push(H);return ce}function*w(le,ue){let ce,de;for(const H of le)de!==void 0&&ue(de,H)?ce.push(H):(ce&&(yield ce),ce=[H]),de=H;ce&&(yield ce)}function S(le,ue){for(let ce=0;ce<=le.length;ce++)ue(ce===0?void 0:le[ce-1],ce===le.length?void 0:le[ce])}function y(le,ue){for(let ce=0;ce<le.length;ce++)ue(ce===0?void 0:le[ce-1],le[ce],ce+1===le.length?void 0:le[ce+1])}function h(le,ue,ce){const de=[];function H(pe,Ae,we){if(Ae===0&&we.length===0)return;const Pe=de[de.length-1];Pe&&Pe.start+Pe.deleteCount===pe?(Pe.deleteCount+=Ae,Pe.toInsert.push(...we)):de.push({start:pe,deleteCount:Ae,toInsert:we})}let x=0,he=0;for(;;){if(x===le.length){H(x,0,ue.slice(he));break}if(he===ue.length){H(x,le.length-x,[]);break}const pe=le[x],Ae=ue[he],we=ce(pe,Ae);we===0?(x+=1,he+=1):we<0?(H(x,1,[]),x+=1):we>0&&(H(x,0,[Ae]),he+=1)}return de}function g(le,ue,ce){const de=h(le,ue,ce),H=[],x=[];for(const he of de)H.push(...le.slice(he.start,he.start+he.deleteCount)),x.push(...he.toInsert);return{removed:H,added:x}}function c(le,ue,ce){if(ce===0)return[];const de=le.slice(0,ce).sort(ue);return i(le,ue,de,ce,le.length),de}function n(le,ue,ce,de,H){return ce===0?Promise.resolve([]):new Promise((x,he)=>{(async()=>{const pe=le.length,Ae=le.slice(0,ce).sort(ue);for(let we=ce,Pe=Math.min(ce+de,pe);we<pe;we=Pe,Pe=Math.min(Pe+de,pe)){if(we>ce&&await new Promise(Fe=>setTimeout(Fe)),H&&H.isCancellationRequested)throw new u.$5;i(le,ue,Ae,we,Pe)}return Ae})().then(x,he)})}function i(le,ue,ce,de,H){for(const x=ce.length;de<H;de++){const he=le[de];if(ue(he,ce[x-1])<0){ce.pop();const pe=(0,L.$kb)(ce,Ae=>ue(he,Ae)<0);ce.splice(pe,0,he)}}}function r(le){return le.filter(ue=>!!ue)}function a(le){let ue=0;for(let ce=0;ce<le.length;ce++)le[ce]&&(le[ue]=le[ce],ue+=1);le.length=ue}function t(le,ue,ce){le.splice(ce,0,le.splice(ue,1)[0])}function f(le){return!Array.isArray(le)||le.length===0}function l(le){return Array.isArray(le)&&le.length>0}function s(le,ue=ce=>ce){const ce=new Set;return le.filter(de=>{const H=ue(de);return ce.has(H)?!1:(ce.add(H),!0)})}function o(le){const ue=new Set;return ce=>{const de=le(ce);return ue.has(de)?!1:(ue.add(de),!0)}}function d(le,ue){return le.length>0?le[0]:ue}function m(le,ue){return le.length>0?le[le.length-1]:ue}function D(le,ue,ce=(de,H)=>de===H){let de=0;for(let H=0,x=Math.min(le.length,ue.length);H<x&&ce(le[H],ue[H]);H++)de++;return de}function $(le){return[].concat(...le)}function v(le,ue){let ce=typeof ue=="number"?le:0;typeof ue=="number"?ce=le:(ce=0,ue=le);const de=[];if(ce<=ue)for(let H=ce;H<ue;H++)de.push(H);else for(let H=ce;H>ue;H--)de.push(H);return de}function k(le,ue,ce){return le.reduce((de,H)=>(de[ue(H)]=ce?ce(H):H,de),Object.create(null))}function C(le,ue){return le.push(ue),()=>O(le,ue)}function O(le,ue){const ce=le.indexOf(ue);if(ce>-1)return le.splice(ce,1),ue}function B(le,ue,ce){const de=le.slice(0,ue),H=le.slice(ue);return de.concat(ce,H)}function z(le,ue){let ce;if(typeof ue=="number"){let de=ue;ce=()=>{const H=Math.sin(de++)*179426549;return H-Math.floor(H)}}else ce=Math.random;for(let de=le.length-1;de>0;de-=1){const H=Math.floor(ce()*(de+1)),x=le[de];le[de]=le[H],le[H]=x}}function T(le,ue){const ce=le.indexOf(ue);ce>-1&&(le.splice(ce,1),le.unshift(ue))}function j(le,ue){const ce=le.indexOf(ue);ce>-1&&(le.splice(ce,1),le.push(ue))}function N(le,ue){for(const ce of ue)le.push(ce)}function F(le,ue){return Array.isArray(le)?le.map(ue):ue(le)}function K(le){return Array.isArray(le)?le:[le]}function ee(le){return le[Math.floor(Math.random()*le.length)]}function Y(le,ue,ce){const de=Z(le,ue),H=le.length,x=ce.length;le.length=H+x;for(let he=H-1;he>=de;he--)le[he+x]=le[he];for(let he=0;he<x;he++)le[he+de]=ce[he]}function Q(le,ue,ce,de){const H=Z(le,ue);let x=le.splice(H,ce);return x===void 0&&(x=[]),Y(le,H,de),x}function Z(le,ue){return ue<0?Math.max(ue+le.length,0):Math.min(ue,le.length)}var ae;(function(le){function ue(x){return x<0}le.isLessThan=ue;function ce(x){return x<=0}le.isLessThanOrEqual=ce;function de(x){return x>0}le.isGreaterThan=de;function H(x){return x===0}le.isNeitherLessOrGreaterThan=H,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function _(le,ue){return(ce,de)=>ue(le(ce),le(de))}function ge(...le){return(ue,ce)=>{for(const de of le){const H=de(ue,ce);if(!ae.isNeitherLessOrGreaterThan(H))return H}return ae.neitherLessOrGreaterThan}}const se=(le,ue)=>le-ue;e.$9b=se;const re=(le,ue)=>(0,e.$9b)(le?1:0,ue?1:0);e.$0b=re;function U(le){return(ue,ce)=>-le(ue,ce)}class ie{constructor(ue){this.g=ue,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let ce=this.c;for(;ce<this.g.length&&ue(this.g[ce]);)ce++;const de=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,de}takeFromEndWhile(ue){let ce=this.d;for(;ce>=0&&ue(this.g[ce]);)ce--;const de=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,de}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ue=this.g[this.c];return this.c++,ue}removeLast(){const ue=this.g[this.d];return this.d--,ue}takeCount(ue){const ce=this.g.slice(this.c,this.c+ue);return this.c+=ue,ce}}e.$_b=ie;class ye{static{this.empty=new ye(ue=>{})}constructor(ue){this.iterate=ue}forEach(ue){this.iterate(ce=>(ue(ce),!0))}toArray(){const ue=[];return this.iterate(ce=>(ue.push(ce),!0)),ue}filter(ue){return new ye(ce=>this.iterate(de=>ue(de)?ce(de):!0))}map(ue){return new ye(ce=>this.iterate(de=>ce(ue(de))))}some(ue){let ce=!1;return this.iterate(de=>(ce=ue(de),!ce)),ce}findFirst(ue){let ce;return this.iterate(de=>ue(de)?(ce=de,!1):!0),ce}findLast(ue){let ce;return this.iterate(de=>(ue(de)&&(ce=de),!0)),ce}findLastMaxBy(ue){let ce,de=!0;return this.iterate(H=>((de||ae.isGreaterThan(ue(H,ce)))&&(de=!1,ce=H),!0)),ce}}e.$ac=ye}),define(Se[61],De([1,0,13]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$9c=M,e.$0c=A,e.$$c=P,e.$_c=b,e.$ad=p;function L(E,R){if(!E)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function M(E,R="Unreachable"){throw new Error(R)}function A(E){if(!E)throw new u.$cb("Assertion Failed")}function P(E){E||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function p(E,R){let I=0;for(;I<E.length-1;){const w=E[I],S=E[I+1];if(!R(w,S))return!1;I++}return!0}}),define(Se[73],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(L,M){const A=this;let P=!1,b;return function(){if(P)return b;if(P=!0,M)try{b=L.apply(A,arguments)}finally{M()}else b=L.apply(A,arguments);return b}}}),define(Se[124],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0;class u{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$CO=u,e.$DO=new u("id#")}),define(Se[48],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(L){function M(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=M;const A=Object.freeze([]);function P(){return A}L.empty=P;function*b(t){yield t}L.single=b;function p(t){return M(t)?t:b(t)}L.wrap=p;function E(t){return t||A}L.from=E;function*R(t){for(let f=t.length-1;f>=0;f--)yield t[f]}L.reverse=R;function I(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=I;function w(t){return t[Symbol.iterator]().next().value}L.first=w;function S(t,f){for(const l of t)if(f(l))return!0;return!1}L.some=S;function y(t,f){for(const l of t)if(f(l))return l}L.find=y;function*h(t,f){for(const l of t)f(l)&&(yield l)}L.filter=h;function*g(t,f){let l=0;for(const s of t)yield f(s,l++)}L.map=g;function*c(...t){for(const f of t)yield*f}L.concat=c;function n(t,f,l){let s=l;for(const o of t)s=f(s,o);return s}L.reduce=n;function*i(t,f,l=t.length){for(f<0&&(f+=t.length),l<0?l+=t.length:l>t.length&&(l=t.length);f<l;f++)yield t[f]}L.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const l=[];if(f===0)return[l,t];const s=t[Symbol.iterator]();for(let o=0;o<f;o++){const d=s.next();if(d.done)return[l,L.empty()];l.push(d.value)}return[l,{[Symbol.iterator](){return s}}]}L.consume=r;async function a(t){const f=[];for await(const l of t)f.push(l);return Promise.resolve(f)}L.asyncToArray=a})(u||(e.Iterable=u={}))}),define(Se[163],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$rn=P,e.$sn=I,e.$tn=w,e.$un=S,e.$vn=y,e.$wn=h,e.$xn=g,e.$yn=c,e.$zn=n,e.$An=i,e.$Bn=r,e.$Cn=a;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function P(t,f=!1){let l=0;const s=t.length;let o="",d=0,m=16,D=0;function $(T){let j=0,N=0;for(;j<T;){const F=t.charCodeAt(l);if(F>=48&&F<=57)N=N*16+F-48;else if(F>=65&&F<=70)N=N*16+F-65+10;else if(F>=97&&F<=102)N=N*16+F-97+10;else break;l++,j++}return j<T&&(N=-1),N}function v(T){l=T,o="",d=0,m=16,D=0}function k(){const T=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&E(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&E(t.charCodeAt(l)))for(l++;l<t.length&&E(t.charCodeAt(l));)l++;else return D=3,t.substring(T,l);let j=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&E(t.charCodeAt(l))){for(l++;l<t.length&&E(t.charCodeAt(l));)l++;j=l}else D=3;return t.substring(T,j)}function C(){let T="",j=l;for(;;){if(l>=s){T+=t.substring(j,l),D=2;break}const N=t.charCodeAt(l);if(N===34){T+=t.substring(j,l),l++;break}if(N===92){if(T+=t.substring(j,l),l++,l>=s){D=2;break}switch(t.charCodeAt(l++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const K=$(4);K>=0?T+=String.fromCharCode(K):D=4;break}default:D=5}j=l;continue}if(N>=0&&N<=31)if(p(N)){T+=t.substring(j,l),D=2;break}else D=6;l++}return T}function O(){if(o="",D=0,d=l,l>=s)return d=s,m=17;let T=t.charCodeAt(l);if(b(T)){do l++,o+=String.fromCharCode(T),T=t.charCodeAt(l);while(b(T));return m=15}if(p(T))return l++,o+=String.fromCharCode(T),T===13&&t.charCodeAt(l)===10&&(l++,o+=`
`),m=14;switch(T){case 123:return l++,m=1;case 125:return l++,m=2;case 91:return l++,m=3;case 93:return l++,m=4;case 58:return l++,m=6;case 44:return l++,m=5;case 34:return l++,o=C(),m=10;case 47:{const j=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<s&&!p(t.charCodeAt(l));)l++;return o=t.substring(j,l),m=12}if(t.charCodeAt(l+1)===42){l+=2;const N=s-1;let F=!1;for(;l<N;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,F=!0;break}l++}return F||(l++,D=1),o=t.substring(j,l),m=13}return o+=String.fromCharCode(T),l++,m=16}case 45:if(o+=String.fromCharCode(T),l++,l===s||!E(t.charCodeAt(l)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=k(),m=11;default:for(;l<s&&B(T);)l++,T=t.charCodeAt(l);if(d!==l){switch(o=t.substring(d,l),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(T),l++,m=16}}function B(T){if(b(T)||p(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let T;do T=O();while(T>=12&&T<=15);return T}return{setPosition:v,getPosition:()=>l,scan:f?z:O,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>l-d,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,f){const l=[],s=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D($,v,k,C){d.value=$,d.offset=v,d.length=k,d.type=C,d.colonOffset=void 0,o=d}try{i(t,{onObjectBegin:($,v)=>{if(f<=$)throw s;o=void 0,m=f>$,l.push("")},onObjectProperty:($,v,k)=>{if(f<v||(D($,v,k,"property"),l[l.length-1]=$,f<=v+k))throw s},onObjectEnd:($,v)=>{if(f<=$)throw s;o=void 0,l.pop()},onArrayBegin:($,v)=>{if(f<=$)throw s;o=void 0,l.push(0)},onArrayEnd:($,v)=>{if(f<=$)throw s;o=void 0,l.pop()},onLiteralValue:($,v,k)=>{if(f<v||(D($,v,k,a($)),f<=v+k))throw s},onSeparator:($,v,k)=>{if(f<=v)throw s;if($===":"&&o&&o.type==="property")o.colonOffset=v,m=!1,o=void 0;else if($===","){const C=l[l.length-1];typeof C=="number"?l[l.length-1]=C+1:(m=!0,l[l.length-1]=""),o=void 0}}})}catch($){if($!==s)throw $}return{path:l,previousNode:o,isAtPropertyKey:m,matches:$=>{let v=0;for(let k=0;v<$.length&&k<l.length;k++)if($[v]===l[k]||$[v]==="*")v++;else if($[v]!=="**")return!1;return v===$.length}}}function w(t,f=[],l=A.DEFAULT){let s=null,o=[];const d=[];function m($){Array.isArray(o)?o.push($):s!==null&&(o[s]=$)}return i(t,{onObjectBegin:()=>{const $={};m($),d.push(o),o=$,s=null},onObjectProperty:$=>{s=$},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const $=[];m($),d.push(o),o=$,s=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:m,onError:($,v,k)=>{f.push({error:$,offset:v,length:k})}},l),o[0]}function S(t,f=[],l=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o($){s.type==="property"&&(s.length=$-s.offset,s=s.parent)}function d($){return s.children.push($),$}i(t,{onObjectBegin:$=>{s=d({type:"object",offset:$,length:-1,parent:s,children:[]})},onObjectProperty:($,v,k)=>{s=d({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:$,offset:v,length:k,parent:s})},onObjectEnd:($,v)=>{s.length=$+v-s.offset,s=s.parent,o($+v)},onArrayBegin:($,v)=>{s=d({type:"array",offset:$,length:-1,parent:s,children:[]})},onArrayEnd:($,v)=>{s.length=$+v-s.offset,s=s.parent,o($+v)},onLiteralValue:($,v,k)=>{d({type:a($),offset:v,length:k,parent:s,value:$}),o(v+k)},onSeparator:($,v,k)=>{s.type==="property"&&($===":"?s.colonOffset=v:$===","&&o(v))},onError:($,v,k)=>{f.push({error:$,offset:v,length:k})}},l);const D=s.children[0];return D&&delete D.parent,D}function y(t,f){if(!t)return;let l=t;for(const s of f)if(typeof s=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let o=!1;for(const d of l.children)if(Array.isArray(d.children)&&d.children[0].value===s){l=d.children[1],o=!0;break}if(!o)return}else{const o=s;if(l.type!=="array"||o<0||!Array.isArray(l.children)||o>=l.children.length)return;l=l.children[o]}return l}function h(t){if(!t.parent||!t.parent.children)return[];const f=h(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;f.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&f.push(l)}return f}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const f=Object.create(null);for(const l of t.children){const s=l.children[1];s&&(f[l.children[0].value]=g(s))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,f,l=!1){return f>=t.offset&&f<t.offset+t.length||l&&f===t.offset+t.length}function n(t,f,l=!1){if(c(t,f,l)){const s=t.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=f;o++){const d=n(s[o],f,l);if(d)return d}return t}}function i(t,f,l=A.DEFAULT){const s=P(t,!1);function o(_){return _?()=>_(s.getTokenOffset(),s.getTokenLength()):()=>!0}function d(_){return _?ge=>_(ge,s.getTokenOffset(),s.getTokenLength()):()=>!0}const m=o(f.onObjectBegin),D=d(f.onObjectProperty),$=o(f.onObjectEnd),v=o(f.onArrayBegin),k=o(f.onArrayEnd),C=d(f.onLiteralValue),O=d(f.onSeparator),B=o(f.onComment),z=d(f.onError),T=l&&l.disallowComments,j=l&&l.allowTrailingComma;function N(){for(;;){const _=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:T||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(_){case 12:case 13:T?F(10):B();break;case 16:F(1);break;case 15:case 14:break;default:return _}}}function F(_,ge=[],se=[]){if(z(_),ge.length+se.length>0){let re=s.getToken();for(;re!==17;){if(ge.indexOf(re)!==-1){N();break}else if(se.indexOf(re)!==-1)break;re=N()}}}function K(_){const ge=s.getTokenValue();return _?C(ge):D(ge),N(),!0}function ee(){switch(s.getToken()){case 11:{let _=0;try{_=JSON.parse(s.getTokenValue()),typeof _!="number"&&(F(2),_=0)}catch{F(2)}C(_);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return N(),!0}function Y(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(K(!1),s.getToken()===6?(O(":"),N(),ae()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function Q(){m(),N();let _=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(_||F(4,[],[]),O(","),N(),s.getToken()===2&&j)break}else _&&F(6,[],[]);Y()||F(4,[],[2,5]),_=!0}return $(),s.getToken()!==2?F(7,[2],[]):N(),!0}function Z(){v(),N();let _=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(_||F(4,[],[]),O(","),N(),s.getToken()===4&&j)break}else _&&F(6,[],[]);ae()||F(4,[],[4,5]),_=!0}return k(),s.getToken()!==4?F(8,[4],[]):N(),!0}function ae(){switch(s.getToken()){case 3:return Z();case 1:return Q();case 10:return K(!0);default:return ee()}}return N(),s.getToken()===17?l.allowEmptyContent?!0:(F(4,[],[]),!1):ae()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}function r(t,f){const l=P(t),s=[];let o,d=0,m;do switch(m=l.getPosition(),o=l.scan(),o){case 12:case 13:case 17:d!==m&&s.push(t.substring(d,m)),f!==void 0&&s.push(l.getTokenValue().replace(/[^\r\n]/g,f)),d=l.getPosition();break}while(o!==17);return s.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[43],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(Se[74],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}class L{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let A=this.a;for(;A!==u.Undefined;){const P=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=P}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,P){const b=new u(A);if(this.a===u.Undefined)this.a=b,this.b=b;else if(P){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(b))}}shift(){if(this.a!==u.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==u.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const P=A.prev;P.next=A.next,A.next.prev=P}else A.prev===u.Undefined&&A.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):A.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):A.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.$4c=L}),define(Se[28],De([1,0]),function(fe,e){"use strict";var u,L,M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=P,e.$zc=b,e.$Hc=n;function A(i,r,a){let t=i.get(r);return t===void 0&&(t=a,i.set(r,t)),t}function P(i){const r=[];return i.forEach((a,t)=>{r.push(`${t} => ${a}`)}),`Map(${i.size}) {${r.join(", ")}}`}function b(i){const r=[];return i.forEach(a=>{r.push(a)}),`Set(${i.size}) {${r.join(", ")}}`}class p{constructor(r,a){this.uri=r,this.value=a}}function E(i){return Array.isArray(i)}class R{static{this.c=r=>r.toString()}constructor(r,a){if(this[u]="ResourceMap",r instanceof R)this.d=new Map(r.d),this.e=a??R.c;else if(E(r)){this.d=new Map,this.e=a??R.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??R.c}set(r,a){return this.d.set(this.e(r),new p(r,a)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,a){typeof a<"u"&&(r=r.bind(a));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Ac=R;class I{constructor(r,a){this[L]="ResourceSet",!r||typeof r=="function"?this.c=new R(r):(this.c=new R(a),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,a){this.c.forEach((t,f)=>r.call(a,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class S{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,a=0){const t=this.c.get(r);if(t)return a!==0&&this.l(t,a),t.value}set(r,a,t=0){let f=this.c.get(r);if(f)f.value=a,t!==0&&this.l(f,t);else{switch(f={key:r,value:a,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this.c.get(r);if(a)return this.c.delete(r),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,a){const t=this.g;let f=this.d;for(;f;){if(a?r.bind(a)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,a=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const l={value:t.key,done:!1};return t=t.next,l}else return{value:void 0,done:!0}}};return f}values(){const r=this,a=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const l={value:t.value,done:!1};return t=t.next,l}else return{value:void 0,done:!0}}};return f}entries(){const r=this,a=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const l={value:[t.key,t.value],done:!1};return t=t.next,l}else return{value:void 0,done:!0}}};return f}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>r;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const a=r.next,t=r.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}r.next=void 0,r.previous=void 0,this.g++}l(r,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(a===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((a,t)=>{r.push([t,a])}),r}fromJSON(r){this.clear();for(const[a,t]of r)this.set(a,t)}}e.$Cc=S;class y extends S{constructor(r,a=1){super(),this.m=r,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=y;class h{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let a=this.c.get(r)||0;return a===0?!1:(a--,a===0?this.c.delete(r):this.c.set(r,a),!0)}has(r){return this.c.has(r)}}e.$Ec=h;class g{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[a,t]of r)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(r,a){this.c.set(r,a),this.d.set(a,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const a=this.c.get(r);return a===void 0?!1:(this.c.delete(r),this.d.delete(a),!0)}forEach(r,a){this.c.forEach((t,f)=>{r.call(a,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class c{constructor(){this.c=new Map}add(r,a){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(a)}delete(r,a){const t=this.c.get(r);t&&(t.delete(a),t.size===0&&this.c.delete(r))}forEach(r,a){const t=this.c.get(r);t&&t.forEach(a)}get(r){const a=this.c.get(r);return a||new Set}}e.$Gc=c;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[a,t]of i)if(!r.has(a)||r.get(a)!==t)return!1;for(const[a]of r)if(!i.has(a))return!1;return!0}}),define(Se[3],De([1,0,19,72,28,73,48]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=R,e.$Kc=I,e.$Lc=w,e.$Mc=h,e.$Nc=g,e.$Oc=c,e.$Pc=n,e.$Qc=i,e.$Rc=r,e.$2c=$;const b=!1;let p=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let O=this.b.get(C);return O||(O={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,O)),O}trackDisposable(C){const O=this.c(C);O.source||(O.source=new Error().stack)}setParent(C,O){const B=this.c(C);B.parent=O}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,O){const B=O.get(C);if(B)return B;const z=C.parent?this.f(this.c(C.parent),O):C;return O.set(C,z),z}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,B])=>B.source!==null&&!this.f(B,C).isSingleton).flatMap(([B])=>B)}computeLeakingDisposables(C=10,O){let B;if(O)B=O;else{const F=new Map,K=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,F).isSingleton);if(K.length===0)return;const ee=new Set(K.map(Y=>Y.value));if(B=K.filter(Y=>!(Y.parent&&ee.has(Y.parent))),B.length===0)throw new Error("There are cyclic diposable chains!")}if(!B)return;function z(F){function K(Y,Q){for(;Y.length>0&&Q.some(Z=>typeof Z=="string"?Z===Y[0]:Y[0].match(Z));)Y.shift()}const ee=F.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const T=new M.$Gc;for(const F of B){const K=z(F);for(let ee=0;ee<=K.length;ee++)T.add(K.slice(0,ee).join(`
`),F)}B.sort((0,u.$7b)(F=>F.idx,u.$9b));let j="",N=0;for(const F of B.slice(0,C)){N++;const K=z(F),ee=[];for(let Y=0;Y<K.length;Y++){let Q=K[Y];Q=`(shared with ${T.get(K.slice(0,Y+1).join(`
`)).size}/${B.length} leaks) at ${Q}`;const ae=T.get(K.slice(0,Y).join(`
`)),_=(0,L.$K)([...ae].map(ge=>z(ge)[Y]),ge=>ge);delete _[K[Y]];for(const[ge,se]of Object.entries(_))ee.unshift(`    - stacktraces of ${se.length} other leaks continue with ${ge}`);ee.unshift(Q)}j+=`


==================== Leaking disposable ${N}/${B.length}: ${F.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return B.length>C&&(j+=`


... and ${B.length-C} more leaking disposables

`),{leaks:B,details:j}}}e.$Ic=E;function R(k){p=k}if(b){const k="__is_disposable_tracked__";R(new class{trackDisposable(C){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[k]||console.log(O)},3e3)}setParent(C,O){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsSingleton(C){}})}function I(k){return p?.trackDisposable(k),k}function w(k){p?.markAsDisposed(k)}function S(k,C){p?.setParent(k,C)}function y(k,C){if(p)for(const O of k)p.setParent(O,C)}function h(k){return p?.markAsSingleton(k),k}function g(k){return typeof k.dispose=="function"&&k.dispose.length===0}function c(k){if(P.Iterable.is(k)){const C=[];for(const O of k)if(O)try{O.dispose()}catch(B){C.push(B)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function n(k){for(const C of k)g(C)&&C.dispose();return[]}function i(...k){const C=r(()=>c(k));return y(k,C),C}function r(k){const C=I({dispose:(0,A.$db)(()=>{w(C),k()})});return C}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return S(C,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),S(C,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,I(this),S(this.q,this)}dispose(){w(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Tc=t;class f{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&S(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&S(C,null),C}}e.$Uc=f;class l{constructor(C){this.a=new f,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=l;class s{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(C){let O=C;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,w(this))},this}}e.$Xc=o;class d{constructor(){this.a=new Map}acquire(C,...O){let B=this.a.get(C);B||(B={counter:0,object:this.b(C,...O)},this.a.set(C,B));const{object:z}=B,T=(0,A.$db)(()=>{--B.counter===0&&(this.c(C,B.object),this.a.delete(C))});return B.counter++,{object:z,dispose:T}}}e.$Yc=d;class m{constructor(C){this.a=C}async acquire(C,...O){const B=this.a.acquire(C,...O);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(z){throw B.dispose(),z}}}e.$Zc=m;class D{constructor(C){this.object=C}dispose(){}}e.$1c=D;function $(k){const C=new a;try{k(C)}finally{C.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,O,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(C)?.dispose(),this.a.set(C,O)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=v}),function(fe,e){typeof define=="function"&&define.amd?define(Se[164],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(ue,ce){for(var de=0;de<ce.length;de++){var H=ce[de];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(ue,H.key,H)}}function u(ue,ce,de){return ce&&e(ue.prototype,ce),de&&e(ue,de),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function L(ue,ce){if(ue){if(typeof ue=="string")return M(ue,ce);var de=Object.prototype.toString.call(ue).slice(8,-1);if(de==="Object"&&ue.constructor&&(de=ue.constructor.name),de==="Map"||de==="Set")return Array.from(ue);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return M(ue,ce)}}function M(ue,ce){(ce==null||ce>ue.length)&&(ce=ue.length);for(var de=0,H=new Array(ce);de<ce;de++)H[de]=ue[de];return H}function A(ue,ce){var de=typeof Symbol<"u"&&ue[Symbol.iterator]||ue["@@iterator"];if(de)return(de=de.call(ue)).next.bind(de);if(Array.isArray(ue)||(de=L(ue))||ce&&ue&&typeof ue.length=="number"){de&&(ue=de);var H=0;return function(){return H>=ue.length?{done:!0}:{done:!1,value:ue[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=P();function b(ue){fe.defaults=ue}var p=/[&<>"']/,E=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ce){return w[ce]};function y(ue,ce){if(ce){if(p.test(ue))return ue.replace(E,S)}else if(R.test(ue))return ue.replace(I,S);return ue}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ue){return ue.replace(h,function(ce,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var c=/(^|[^\[])\^/g;function n(ue,ce){ue=typeof ue=="string"?ue:ue.source,ce=ce||"";var de={replace:function(x,he){return he=he.source||he,he=he.replace(c,"$1"),ue=ue.replace(x,he),de},getRegex:function(){return new RegExp(ue,ce)}};return de}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(ue,ce,de){if(ue){var H;try{H=decodeURIComponent(g(de)).replace(i,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}ce&&!r.test(de)&&(de=o(ce,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},f=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ue,ce){t[" "+ue]||(f.test(ue)?t[" "+ue]=ue+"/":t[" "+ue]=$(ue,"/",!0)),ue=t[" "+ue];var de=ue.indexOf(":")===-1;return ce.substring(0,2)==="//"?de?ce:ue.replace(l,"$1")+ce:ce.charAt(0)==="/"?de?ce:ue.replace(s,"$1")+ce:ue+ce}var d={exec:function(){}};function m(ue){for(var ce=1,de,H;ce<arguments.length;ce++){de=arguments[ce];for(H in de)Object.prototype.hasOwnProperty.call(de,H)&&(ue[H]=de[H])}return ue}function D(ue,ce){var de=ue.replace(/\|/g,function(he,pe,Ae){for(var we=!1,Pe=pe;--Pe>=0&&Ae[Pe]==="\\";)we=!we;return we?"|":" |"}),H=de.split(/ \|/),x=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>ce)H.splice(ce);else for(;H.length<ce;)H.push("");for(;x<H.length;x++)H[x]=H[x].trim().replace(/\\\|/g,"|");return H}function $(ue,ce,de){var H=ue.length;if(H===0)return"";for(var x=0;x<H;){var he=ue.charAt(H-x-1);if(he===ce&&!de)x++;else if(he!==ce&&de)x++;else break}return ue.slice(0,H-x)}function v(ue,ce){if(ue.indexOf(ce[1])===-1)return-1;for(var de=ue.length,H=0,x=0;x<de;x++)if(ue[x]==="\\")x++;else if(ue[x]===ce[0])H++;else if(ue[x]===ce[1]&&(H--,H<0))return x;return-1}function k(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ue,ce){if(ce<1)return"";for(var de="";ce>1;)ce&1&&(de+=ue),ce>>=1,ue+=ue;return de+ue}function O(ue,ce,de,H){var x=ce.href,he=ce.title?y(ce.title):null,pe=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){H.state.inLink=!0;var Ae={type:"link",raw:de,href:x,title:he,text:pe,tokens:H.inlineTokens(pe)};return H.state.inLink=!1,Ae}return{type:"image",raw:de,href:x,title:he,text:y(pe)}}function B(ue,ce){var de=ue.match(/^(\s+)(?:```)/);if(de===null)return ce;var H=de[1];return ce.split(`
`).map(function(x){var he=x.match(/^\s+/);if(he===null)return x;var pe=he[0];return pe.length>=H.length?x.slice(H.length):x}).join(`
`)}var z=function(){function ue(de){this.options=de||fe.defaults}var ce=ue.prototype;return ce.space=function(H){var x=this.rules.block.newline.exec(H);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},ce.code=function(H){var x=this.rules.block.code.exec(H);if(x){var he=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?he:$(he,`
`)}}},ce.fences=function(H){var x=this.rules.block.fences.exec(H);if(x){var he=x[0],pe=B(he,x[3]||"");return{type:"code",raw:he,lang:x[2]?x[2].trim():x[2],text:pe}}},ce.heading=function(H){var x=this.rules.block.heading.exec(H);if(x){var he=x[2].trim();if(/#$/.test(he)){var pe=$(he,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(he=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:he,tokens:this.lexer.inline(he)}}},ce.hr=function(H){var x=this.rules.block.hr.exec(H);if(x)return{type:"hr",raw:x[0]}},ce.blockquote=function(H){var x=this.rules.block.blockquote.exec(H);if(x){var he=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ce.list=function(H){var x=this.rules.block.list.exec(H);if(x){var he,pe,Ae,we,Pe,Fe,ze,q,V,J,X,me,ve=x[1].trim(),Te=ve.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Te?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Te?ve:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(me=!1,!(!(x=Ze.exec(H))||this.rules.block.hr.test(H)));){if(he=x[0],H=H.substring(he.length),q=x[2].split(`
`,1)[0],V=H.split(`
`,1)[0],this.options.pedantic?(we=2,X=q.trimLeft()):(we=x[2].search(/[^ ]/),we=we>4?1:we,X=q.slice(we),we+=x[1].length),Fe=!1,!q&&/^ *$/.test(V)&&(he+=V+`
`,H=H.substring(V.length+1),me=!0),!me)for(var tt=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,we-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,we-1)+"}#");H&&(J=H.split(`
`,1)[0],q=J,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(q)||rt.test(q)||tt.test(q)||nt.test(H)));){if(q.search(/[^ ]/)>=we||!q.trim())X+=`
`+q.slice(we);else if(!Fe)X+=`
`+q;else break;!Fe&&!q.trim()&&(Fe=!0),he+=J+`
`,H=H.substring(J.length+1)}He.loose||(ze?He.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(X),pe&&(Ae=pe[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:he,task:!!pe,checked:Ae,loose:!1,text:X}),He.raw+=he}He.items[He.items.length-1].raw=he.trimRight(),He.items[He.items.length-1].text=X.trimRight(),He.raw=He.raw.trimRight();var Ce=He.items.length;for(Pe=0;Pe<Ce;Pe++){this.lexer.state.top=!1,He.items[Pe].tokens=this.lexer.blockTokens(He.items[Pe].text,[]);var Be=He.items[Pe].tokens.filter(function(Ke){return Ke.type==="space"}),Me=Be.every(function(Ke){for(var ne=Ke.raw.split(""),oe=0,Ie=A(ne),Ge;!(Ge=Ie()).done;){var xe=Ge.value;if(xe===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&Be.length&&Me&&(He.loose=!0,He.items[Pe].loose=!0)}return He}},ce.html=function(H){var x=this.rules.block.html.exec(H);if(x){var he={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):y(x[0]);he.type="paragraph",he.text=pe,he.tokens=this.lexer.inline(pe)}return he}},ce.def=function(H){var x=this.rules.block.def.exec(H);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var he=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:x[0],href:x[2],title:x[3]}}},ce.table=function(H){var x=this.rules.block.table.exec(H);if(x){var he={type:"table",header:D(x[1]).map(function(ze){return{text:ze}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=x[0];var pe=he.align.length,Ae,we,Pe,Fe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(he.align[Ae])?he.align[Ae]="right":/^ *:-+: *$/.test(he.align[Ae])?he.align[Ae]="center":/^ *:-+ *$/.test(he.align[Ae])?he.align[Ae]="left":he.align[Ae]=null;for(pe=he.rows.length,Ae=0;Ae<pe;Ae++)he.rows[Ae]=D(he.rows[Ae],he.header.length).map(function(ze){return{text:ze}});for(pe=he.header.length,we=0;we<pe;we++)he.header[we].tokens=this.lexer.inline(he.header[we].text);for(pe=he.rows.length,we=0;we<pe;we++)for(Fe=he.rows[we],Pe=0;Pe<Fe.length;Pe++)Fe[Pe].tokens=this.lexer.inline(Fe[Pe].text);return he}}},ce.lheading=function(H){var x=this.rules.block.lheading.exec(H);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},ce.paragraph=function(H){var x=this.rules.block.paragraph.exec(H);if(x){var he=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:he,tokens:this.lexer.inline(he)}}},ce.text=function(H){var x=this.rules.block.text.exec(H);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},ce.escape=function(H){var x=this.rules.inline.escape.exec(H);if(x)return{type:"escape",raw:x[0],text:y(x[1])}},ce.tag=function(H){var x=this.rules.inline.tag.exec(H);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):y(x[0]):x[0]}},ce.link=function(H){var x=this.rules.inline.link.exec(H);if(x){var he=x[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var pe=$(he.slice(0,-1),"\\");if((he.length-pe.length)%2===0)return}else{var Ae=v(x[2],"()");if(Ae>-1){var we=x[0].indexOf("!")===0?5:4,Pe=we+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,Pe).trim(),x[3]=""}}var Fe=x[2],ze="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Fe);q&&(Fe=q[1],ze=q[3])}else ze=x[3]?x[3].slice(1,-1):"";return Fe=Fe.trim(),/^</.test(Fe)&&(this.options.pedantic&&!/>$/.test(he)?Fe=Fe.slice(1):Fe=Fe.slice(1,-1)),O(x,{href:Fe&&Fe.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},ce.reflink=function(H,x){var he;if((he=this.rules.inline.reflink.exec(H))||(he=this.rules.inline.nolink.exec(H))){var pe=(he[2]||he[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Ae=he[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(he,pe,he[0],this.lexer)}},ce.emStrong=function(H,x,he){he===void 0&&(he="");var pe=this.rules.inline.emStrong.lDelim.exec(H);if(pe&&!(pe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(he===""||this.rules.inline.punctuation.exec(he))){var we=pe[0].length-1,Pe,Fe,ze=we,q=0,V=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,x=x.slice(-1*H.length+we);(pe=V.exec(x))!=null;)if(Pe=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Pe){if(Fe=Pe.length,pe[3]||pe[4]){ze+=Fe;continue}else if((pe[5]||pe[6])&&we%3&&!((we+Fe)%3)){q+=Fe;continue}if(ze-=Fe,!(ze>0)){if(Fe=Math.min(Fe,Fe+ze+q),Math.min(we,Fe)%2){var J=H.slice(1,we+pe.index+Fe);return{type:"em",raw:H.slice(0,we+pe.index+Fe+1),text:J,tokens:this.lexer.inlineTokens(J)}}var X=H.slice(2,we+pe.index+Fe-1);return{type:"strong",raw:H.slice(0,we+pe.index+Fe+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},ce.codespan=function(H){var x=this.rules.inline.code.exec(H);if(x){var he=x[2].replace(/\n/g," "),pe=/[^ ]/.test(he),Ae=/^ /.test(he)&&/ $/.test(he);return pe&&Ae&&(he=he.substring(1,he.length-1)),he=y(he,!0),{type:"codespan",raw:x[0],text:he}}},ce.br=function(H){var x=this.rules.inline.br.exec(H);if(x)return{type:"br",raw:x[0]}},ce.del=function(H){var x=this.rules.inline.del.exec(H);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},ce.autolink=function(H,x){var he=this.rules.inline.autolink.exec(H);if(he){var pe,Ae;return he[2]==="@"?(pe=y(this.options.mangle?x(he[1]):he[1]),Ae="mailto:"+pe):(pe=y(he[1]),Ae=pe),{type:"link",raw:he[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.url=function(H,x){var he;if(he=this.rules.inline.url.exec(H)){var pe,Ae;if(he[2]==="@")pe=y(this.options.mangle?x(he[0]):he[0]),Ae="mailto:"+pe;else{var we;do we=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(we!==he[0]);pe=y(he[0]),he[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:he[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},ce.inlineText=function(H,x){var he=this.rules.inline.text.exec(H);if(he){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):y(he[0]):he[0]:pe=y(this.options.smartypants?x(he[0]):he[0]),{type:"text",raw:he[0],text:pe}}},ue}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=n(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=n(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=n(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=n(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=n(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=m({},T),T.gfm=m({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=n(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=m({},T.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:n(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=n(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=n(T._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=n(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=n(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=n(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=n(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=n(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=n(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=n(j.reflink).replace("label",j._label).replace("ref",T._label).getRegex(),j.nolink=n(j.nolink).replace("ref",T._label).getRegex(),j.reflinkSearch=n(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=m({},j),j.pedantic=m({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=m({},j.normal,{escape:n(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=n(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=m({},j.gfm,{br:n(j.br).replace("{2,}","*").getRegex(),text:n(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ue){var ce="",de,H,x=ue.length;for(de=0;de<x;de++)H=ue.charCodeAt(de),Math.random()>.5&&(H="x"+H.toString(16)),ce+="&#"+H+";";return ce}var K=function(){function ue(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||fe.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:T.normal,inline:j.normal};this.options.pedantic?(H.block=T.pedantic,H.inline=j.pedantic):this.options.gfm&&(H.block=T.gfm,this.options.breaks?H.inline=j.breaks:H.inline=j.gfm),this.tokenizer.rules=H}ue.lex=function(H,x){var he=new ue(x);return he.lex(H)},ue.lexInline=function(H,x){var he=new ue(x);return he.inlineTokens(H)};var ce=ue.prototype;return ce.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},ce.blockTokens=function(H,x){var he=this;x===void 0&&(x=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(ze,q,V){return q+"    ".repeat(V.length)});for(var pe,Ae,we,Pe;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(pe=ze.call({lexer:he},H,x))?(H=H.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(H)){H=H.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(H)){H=H.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(pe=this.tokenizer.fences(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(H)){H=H.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(we=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,q=H.slice(1),V=void 0;he.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},q),typeof V=="number"&&V>=0&&(ze=Math.min(ze,V))}),ze<1/0&&ze>=0&&(we=H.substring(0,ze+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(we))){Ae=x[x.length-1],Pe&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe),Pe=we.length!==H.length,H=H.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(H)){H=H.substring(pe.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(H){var Fe="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return this.state.top=!0,x},ce.inline=function(H,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:H,tokens:x}),x},ce.inlineTokens=function(H,x){var he=this;x===void 0&&(x=[]);var pe,Ae,we,Pe=H,Fe,ze,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Fe=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)V.includes(Fe[0].slice(Fe[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Fe.index)+"["+C("a",Fe[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Fe=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Fe.index)+"["+C("a",Fe[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Fe=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Fe.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(ze||(q=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(pe=X.call({lexer:he},H,x))?(H=H.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(H)){H=H.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(H,Pe,q)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(H)){H=H.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(H,F)){H=H.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(H,F))){H=H.substring(pe.raw.length),x.push(pe);continue}if(we=H,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,me=H.slice(1),ve=void 0;he.options.extensions.startInline.forEach(function(Te){ve=Te.call({lexer:this},me),typeof ve=="number"&&ve>=0&&(X=Math.min(X,ve))}),X<1/0&&X>=0&&(we=H.substring(0,X+1))}(),pe=this.tokenizer.inlineText(we,N)){H=H.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(q=pe.raw.slice(-1)),ze=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(H){var J="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return x},u(ue,null,[{key:"rules",get:function(){return{block:T,inline:j}}}]),ue}(),ee=function(){function ue(de){this.options=de||fe.defaults}var ce=ue.prototype;return ce.code=function(H,x,he){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(H,pe);Ae!=null&&Ae!==H&&(he=!0,H=Ae)}return H=H.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+y(pe,!0)+'">'+(he?H:y(H,!0))+`</code></pre>
`:"<pre><code>"+(he?H:y(H,!0))+`</code></pre>
`},ce.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},ce.html=function(H){return H},ce.heading=function(H,x,he,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(he);return"<h"+x+' id="'+Ae+'">'+H+"</h"+x+`>
`}return"<h"+x+">"+H+"</h"+x+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(H,x,he){var pe=x?"ol":"ul",Ae=x&&he!==1?' start="'+he+'"':"";return"<"+pe+Ae+`>
`+H+"</"+pe+`>
`},ce.listitem=function(H){return"<li>"+H+`</li>
`},ce.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(H){return"<p>"+H+`</p>
`},ce.table=function(H,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+x+`</table>
`},ce.tablerow=function(H){return`<tr>
`+H+`</tr>
`},ce.tablecell=function(H,x){var he=x.header?"th":"td",pe=x.align?"<"+he+' align="'+x.align+'">':"<"+he+">";return pe+H+("</"+he+`>
`)},ce.strong=function(H){return"<strong>"+H+"</strong>"},ce.em=function(H){return"<em>"+H+"</em>"},ce.codespan=function(H){return"<code>"+H+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(H){return"<del>"+H+"</del>"},ce.link=function(H,x,he){if(H=a(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var pe='<a href="'+y(H)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+he+"</a>",pe},ce.image=function(H,x,he){if(H=a(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var pe='<img src="'+H+'" alt="'+he+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},ce.text=function(H){return H},ue}(),Y=function(){function ue(){}var ce=ue.prototype;return ce.strong=function(H){return H},ce.em=function(H){return H},ce.codespan=function(H){return H},ce.del=function(H){return H},ce.html=function(H){return H},ce.text=function(H){return H},ce.link=function(H,x,he){return""+he},ce.image=function(H,x,he){return""+he},ce.br=function(){return""},ue}(),Q=function(){function ue(){this.seen={}}var ce=ue.prototype;return ce.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(H,x){var he=H,pe=0;if(this.seen.hasOwnProperty(he)){pe=this.seen[H];do pe++,he=H+"-"+pe;while(this.seen.hasOwnProperty(he))}return x||(this.seen[H]=pe,this.seen[he]=0),he},ce.slug=function(H,x){x===void 0&&(x={});var he=this.serialize(H);return this.getNextSafeSlug(he,x.dryrun)},ue}(),Z=function(){function ue(de){this.options=de||fe.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new Q}ue.parse=function(H,x){var he=new ue(x);return he.parse(H)},ue.parseInline=function(H,x){var he=new ue(x);return he.parseInline(H)};var ce=ue.prototype;return ce.parse=function(H,x){x===void 0&&(x=!0);var he="",pe,Ae,we,Pe,Fe,ze,q,V,J,X,me,ve,Te,He,Ze,tt,nt,at,rt,Ce=H.length;for(pe=0;pe<Ce;pe++){if(X=H[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(rt=this.options.extensions.renderers[X.type].call({parser:this},X),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){he+=rt||"";continue}switch(X.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(X.tokens),X.depth,g(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(V="",q="",Pe=X.header.length,Ae=0;Ae<Pe;Ae++)q+=this.renderer.tablecell(this.parseInline(X.header[Ae].tokens),{header:!0,align:X.align[Ae]});for(V+=this.renderer.tablerow(q),J="",Pe=X.rows.length,Ae=0;Ae<Pe;Ae++){for(ze=X.rows[Ae],q="",Fe=ze.length,we=0;we<Fe;we++)q+=this.renderer.tablecell(this.parseInline(ze[we].tokens),{header:!1,align:X.align[we]});J+=this.renderer.tablerow(q)}he+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(X.tokens),he+=this.renderer.blockquote(J);continue}case"list":{for(me=X.ordered,ve=X.start,Te=X.loose,Pe=X.items.length,J="",Ae=0;Ae<Pe;Ae++)Ze=X.items[Ae],tt=Ze.checked,nt=Ze.task,He="",Ze.task&&(at=this.renderer.checkbox(tt),Te?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=at+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=at+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(Ze.tokens,Te),J+=this.renderer.listitem(He,nt,tt);he+=this.renderer.list(J,me,ve);continue}case"html":{he+=this.renderer.html(X.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(J=X.tokens?this.parseInline(X.tokens):X.text;pe+1<Ce&&H[pe+1].type==="text";)X=H[++pe],J+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);he+=x?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return he},ce.parseInline=function(H,x){x=x||this.renderer;var he="",pe,Ae,we,Pe=H.length;for(pe=0;pe<Pe;pe++){if(Ae=H[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(we=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),we!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){he+=we||"";continue}switch(Ae.type){case"escape":{he+=x.text(Ae.text);break}case"html":{he+=x.html(Ae.text);break}case"link":{he+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{he+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{he+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{he+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{he+=x.codespan(Ae.text);break}case"br":{he+=x.br();break}case"del":{he+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{he+=x.text(Ae.text);break}default:{var Fe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}}return he},ue}();function ae(ue,ce,de){if(typeof ue>"u"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof ce=="function"&&(de=ce,ce=null),ce=m({},ae.defaults,ce||{}),k(ce),de){var H=ce.highlight,x;try{x=K.lex(ue,ce)}catch(Pe){return de(Pe)}var he=function(Fe){var ze;if(!Fe)try{ce.walkTokens&&ae.walkTokens(x,ce.walkTokens),ze=Z.parse(x,ce)}catch(q){Fe=q}return ce.highlight=H,Fe?de(Fe):de(null,ze)};if(!H||H.length<3||(delete ce.highlight,!x.length))return he();var pe=0;ae.walkTokens(x,function(Pe){Pe.type==="code"&&(pe++,setTimeout(function(){H(Pe.text,Pe.lang,function(Fe,ze){if(Fe)return he(Fe);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),pe--,pe===0&&he()})},0))}),pe===0&&he();return}function Ae(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+y(Pe.message+"",!0)+"</pre>";throw Pe}try{var we=K.lex(ue,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ae.walkTokens(we,ce.walkTokens)).then(function(){return Z.parse(we,ce)}).catch(Ae);ae.walkTokens(we,ce.walkTokens)}return Z.parse(we,ce)}catch(Pe){Ae(Pe)}}ae.options=ae.setOptions=function(ue){return m(ae.defaults,ue),b(ae.defaults),ae},ae.getDefaults=P,ae.defaults=fe.defaults,ae.use=function(){for(var ue=arguments.length,ce=new Array(ue),de=0;de<ue;de++)ce[de]=arguments[de];var H=m.apply(void 0,[{}].concat(ce)),x=ae.defaults.extensions||{renderers:{},childTokens:{}},he;ce.forEach(function(pe){if(pe.extensions&&(he=!0,pe.extensions.forEach(function(we){if(!we.name)throw new Error("extension name required");if(we.renderer){var Pe=x.renderers?x.renderers[we.name]:null;Pe?x.renderers[we.name]=function(){for(var Fe=arguments.length,ze=new Array(Fe),q=0;q<Fe;q++)ze[q]=arguments[q];var V=we.renderer.apply(this,ze);return V===!1&&(V=Pe.apply(this,ze)),V}:x.renderers[we.name]=we.renderer}if(we.tokenizer){if(!we.level||we.level!=="block"&&we.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[we.level]?x[we.level].unshift(we.tokenizer):x[we.level]=[we.tokenizer],we.start&&(we.level==="block"?x.startBlock?x.startBlock.push(we.start):x.startBlock=[we.start]:we.level==="inline"&&(x.startInline?x.startInline.push(we.start):x.startInline=[we.start]))}we.childTokens&&(x.childTokens[we.name]=we.childTokens)})),pe.renderer&&function(){var we=ae.defaults.renderer||new ee,Pe=function(q){var V=we[q];we[q]=function(){for(var J=arguments.length,X=new Array(J),me=0;me<J;me++)X[me]=arguments[me];var ve=pe.renderer[q].apply(we,X);return ve===!1&&(ve=V.apply(we,X)),ve}};for(var Fe in pe.renderer)Pe(Fe);H.renderer=we}(),pe.tokenizer&&function(){var we=ae.defaults.tokenizer||new z,Pe=function(q){var V=we[q];we[q]=function(){for(var J=arguments.length,X=new Array(J),me=0;me<J;me++)X[me]=arguments[me];var ve=pe.tokenizer[q].apply(we,X);return ve===!1&&(ve=V.apply(we,X)),ve}};for(var Fe in pe.tokenizer)Pe(Fe);H.tokenizer=we}(),pe.walkTokens){var Ae=ae.defaults.walkTokens;H.walkTokens=function(we){var Pe=[];return Pe.push(pe.walkTokens.call(this,we)),Ae&&(Pe=Pe.concat(Ae.call(this,we))),Pe}}he&&(H.extensions=x),ae.setOptions(H)})},ae.walkTokens=function(ue,ce){for(var de=[],H=function(){var Ae=he.value;switch(de=de.concat(ce.call(ae,Ae)),Ae.type){case"table":{for(var we=A(Ae.header),Pe;!(Pe=we()).done;){var Fe=Pe.value;de=de.concat(ae.walkTokens(Fe.tokens,ce))}for(var ze=A(Ae.rows),q;!(q=ze()).done;)for(var V=q.value,J=A(V),X;!(X=J()).done;){var me=X.value;de=de.concat(ae.walkTokens(me.tokens,ce))}break}case"list":{de=de.concat(ae.walkTokens(Ae.items,ce));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Ae.type]?ae.defaults.extensions.childTokens[Ae.type].forEach(function(ve){de=de.concat(ae.walkTokens(Ae[ve],ce))}):Ae.tokens&&(de=de.concat(ae.walkTokens(Ae.tokens,ce)))}},x=A(ue),he;!(he=x()).done;)H();return de},ae.parseInline=function(ue,ce){if(typeof ue>"u"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");ce=m({},ae.defaults,ce||{}),k(ce);try{var de=K.lexInline(ue,ce);return ce.walkTokens&&ae.walkTokens(de,ce.walkTokens),Z.parseInline(de,ce)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+y(H.message+"",!0)+"</pre>";throw H}},ae.Parser=Z,ae.parser=Z.parse,ae.Renderer=ee,ae.TextRenderer=Y,ae.Lexer=K,ae.lexer=K.lex,ae.Tokenizer=z,ae.Slugger=Q,ae.parse=ae;var _=ae.options,ge=ae.setOptions,se=ae.use,re=ae.walkTokens,U=ae.parseInline,ie=ae,ye=Z.parse,le=K.lex;fe.Lexer=K,fe.Parser=Z,fe.Renderer=ee,fe.Slugger=Q,fe.TextRenderer=Y,fe.Tokenizer=z,fe.getDefaults=P,fe.lexer=le,fe.marked=ae,fe.options=_,fe.parse=ie,fe.parseInline=U,fe.parser=ye,fe.setOptions=ge,fe.use=se,fe.walkTokens=re,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Se[165],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=u;function u(h){const g=A(h);if(g&&g.length>0)return new Uint32Array(g)}let L=0;const M=new Uint32Array(10);function A(h){if(L=0,P(h,I,4352),L>0||(P(h,w,4449),L>0)||(P(h,S,4520),L>0)||(P(h,y,12593),L))return M.subarray(0,L);if(h>=44032&&h<=55203){const g=h-44032,c=g%588,n=Math.floor(g/588),i=Math.floor(c/28),r=c%28-1;if(n<I.length?P(n,I,0):4352+n-12593<y.length&&P(4352+n,y,12593),i<w.length?P(i,w,0):4449+i-12593<y.length&&P(4449+i-12593,y,12593),r>=0&&(r<S.length?P(r,S,0):4520+r-12593<y.length&&P(4520+r-12593,y,12593)),L>0)return M.subarray(0,L)}}function P(h,g,c){h>=c&&h<c+g.length&&b(g[h-c])}function b(h){h!==0&&(M[L++]=h&255,h>>8&&(M[L++]=h>>8&255),h>>16&&(M[L++]=h>>16&255))}var p;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var E;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(E||(E={}));var R;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(R||(R={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),y=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[75],De([1,0,28]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=void 0,e.$Xl=M,e.$Yl=P;const L=new u.$Dc(1e4);function M(E){return p(E,"NFC",L)}const A=new u.$Dc(1e4);function P(E){return p(E,"NFD",A)}const b=/[^\u0000-\u0080]/;function p(E,R,I){if(!E)return E;const w=I.get(E);if(w)return w;let S;return b.test(E)?S=E.normalize(R):S=E,I.set(E,S),S}e.$Zl=function(){const E=/[\u0300-\u036f]/g;return function(R){return P(R).replace(E,"")}}()}),define(Se[125],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0,e.$lm=u,e.rot=L;function u(b,p,E){return Math.min(Math.max(b,p),E)}function L(b,p){return(p+b%p)%p}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$nm=M;class A{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$om=A;class P{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const E=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$pm=P}),function(){function fe(M){const A=[];typeof M=="number"&&A.push("code/timeOrigin",M);function P(p){A.push(p,Date.now())}function b(){const p=[];for(let E=0;E<A.length;E+=2)p.push({name:A[E],startTime:A[E+1]});return p}return{mark:P,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const P of performance.getEntriesByType("mark"))A.push({name:P.name,startTime:Math.round(M+P.startTime)});return A}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function u(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=u(L))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var L in u)(typeof exports=="object"?exports:fe)[L]=u[L]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function u(L){if(e[L])return e[L].exports;var M=e[L]={i:L,l:!1,exports:{}};return fe[L].call(M.exports,M,M.exports,u),M.l=!0,M.exports}return u.m=fe,u.c=e,u.d=function(L,M,A){u.o(L,M)||Object.defineProperty(L,M,{enumerable:!0,get:A})},u.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},u.t=function(L,M){if(1&M&&(L=u(L)),8&M||4&M&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&M&&typeof L!="string")for(var P in L)u.d(A,P,function(b){return L[b]}.bind(null,P));return A},u.n=function(L){var M=L&&L.__esModule?function(){return L.default}:function(){return L};return u.d(M,"a",M),M},u.o=function(L,M){return Object.prototype.hasOwnProperty.call(L,M)},u.p="",u(u.s=0)}([function(fe,e,u){(function(L){var M;e=fe.exports=se,M=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],p=e.src=[],E=0,R=E++;p[R]="0|[1-9]\\d*";var I=E++;p[I]="[0-9]+";var w=E++;p[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;p[S]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var y=E++;p[y]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var h=E++;p[h]="(?:"+p[R]+"|"+p[w]+")";var g=E++;p[g]="(?:"+p[I]+"|"+p[w]+")";var c=E++;p[c]="(?:-("+p[h]+"(?:\\."+p[h]+")*))";var n=E++;p[n]="(?:-?("+p[g]+"(?:\\."+p[g]+")*))";var i=E++;p[i]="[0-9A-Za-z-]+";var r=E++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var a=E++,t="v?"+p[S]+p[c]+"?"+p[r]+"?";p[a]="^"+t+"$";var f="[v=\\s]*"+p[y]+p[n]+"?"+p[r]+"?",l=E++;p[l]="^"+f+"$";var s=E++;p[s]="((?:<|>)?=?)";var o=E++;p[o]=p[I]+"|x|X|\\*";var d=E++;p[d]=p[R]+"|x|X|\\*";var m=E++;p[m]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[c]+")?"+p[r]+"?)?)?";var D=E++;p[D]="[v=\\s]*("+p[o]+")(?:\\.("+p[o]+")(?:\\.("+p[o]+")(?:"+p[n]+")?"+p[r]+"?)?)?";var $=E++;p[$]="^"+p[s]+"\\s*"+p[m]+"$";var v=E++;p[v]="^"+p[s]+"\\s*"+p[D]+"$";var k=E++;p[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;p[C]="(?:~>?)";var O=E++;p[O]="(\\s*)"+p[C]+"\\s+",b[O]=new RegExp(p[O],"g");var B=E++;p[B]="^"+p[C]+p[m]+"$";var z=E++;p[z]="^"+p[C]+p[D]+"$";var T=E++;p[T]="(?:\\^)";var j=E++;p[j]="(\\s*)"+p[T]+"\\s+",b[j]=new RegExp(p[j],"g");var N=E++;p[N]="^"+p[T]+p[m]+"$";var F=E++;p[F]="^"+p[T]+p[D]+"$";var K=E++;p[K]="^"+p[s]+"\\s*("+f+")$|^$";var ee=E++;p[ee]="^"+p[s]+"\\s*("+t+")$|^$";var Y=E++;p[Y]="(\\s*)"+p[s]+"\\s*("+f+"|"+p[m]+")",b[Y]=new RegExp(p[Y],"g");var Q=E++;p[Q]="^\\s*("+p[m]+")\\s+-\\s+("+p[m]+")\\s*$";var Z=E++;p[Z]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ae=E++;p[ae]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)M(_,p[_]),b[_]||(b[_]=new RegExp(p[_]));function ge(V,J){if(V instanceof se)return V;if(typeof V!="string"||V.length>A||!(J?b[l]:b[a]).test(V))return null;try{return new se(V,J)}catch{return null}}function se(V,J){if(V instanceof se){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof se))return new se(V,J);M("SemVer",V,J),this.loose=J;var X=V.trim().match(J?b[l]:b[a]);if(!X)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ve=+me;if(ve>=0&&ve<P)return ve}return me}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=ge,e.valid=function(V,J){var X=ge(V,J);return X?X.version:null},e.clean=function(V,J){var X=ge(V.trim().replace(/^[=v]+/,""),J);return X?X.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(V){return M("SemVer.compare",this.version,this.loose,V),V instanceof se||(V=new se(V,this.loose)),this.compareMain(V)||this.comparePre(V)},se.prototype.compareMain=function(V){return V instanceof se||(V=new se(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},se.prototype.comparePre=function(V){if(V instanceof se||(V=new se(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var X=this.prerelease[J],me=V.prerelease[J];if(M("prerelease compare",J,X,me),X===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(X===void 0)return-1;if(X!==me)return U(X,me)}while(++J)},se.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,X,me){typeof X=="string"&&(me=X,X=void 0);try{return new se(V,X).inc(J,me).version}catch{return null}},e.diff=function(V,J){if(ue(V,J))return null;var X=ge(V),me=ge(J);if(X.prerelease.length||me.prerelease.length){for(var ve in X)if((ve==="major"||ve==="minor"||ve==="patch")&&X[ve]!==me[ve])return"pre"+ve;return"prerelease"}for(var ve in X)if((ve==="major"||ve==="minor"||ve==="patch")&&X[ve]!==me[ve])return ve},e.compareIdentifiers=U;var re=/^[0-9]+$/;function U(V,J){var X=re.test(V),me=re.test(J);return X&&me&&(V=+V,J=+J),X&&!me?-1:me&&!X?1:V<J?-1:V>J?1:0}function ie(V,J,X){return new se(V,X).compare(new se(J,X))}function ye(V,J,X){return ie(V,J,X)>0}function le(V,J,X){return ie(V,J,X)<0}function ue(V,J,X){return ie(V,J,X)===0}function ce(V,J,X){return ie(V,J,X)!==0}function de(V,J,X){return ie(V,J,X)>=0}function H(V,J,X){return ie(V,J,X)<=0}function x(V,J,X,me){var ve;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),ve=V===X;break;case"!==":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),ve=V!==X;break;case"":case"=":case"==":ve=ue(V,X,me);break;case"!=":ve=ce(V,X,me);break;case">":ve=ye(V,X,me);break;case">=":ve=de(V,X,me);break;case"<":ve=le(V,X,me);break;case"<=":ve=H(V,X,me);break;default:throw new TypeError("Invalid operator: "+J)}return ve}function he(V,J){if(V instanceof he){if(V.loose===J)return V;V=V.value}if(!(this instanceof he))return new he(V,J);M("comparator",V,J),this.loose=J,this.parse(V),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(V,J){return U(J,V)},e.major=function(V,J){return new se(V,J).major},e.minor=function(V,J){return new se(V,J).minor},e.patch=function(V,J){return new se(V,J).patch},e.compare=ie,e.compareLoose=function(V,J){return ie(V,J,!0)},e.rcompare=function(V,J,X){return ie(J,V,X)},e.sort=function(V,J){return V.sort(function(X,me){return e.compare(X,me,J)})},e.rsort=function(V,J){return V.sort(function(X,me){return e.rcompare(X,me,J)})},e.gt=ye,e.lt=le,e.eq=ue,e.neq=ce,e.gte=de,e.lte=H,e.cmp=x,e.Comparator=he;var pe={};function Ae(V,J){if(V instanceof Ae)return V.loose===J?V:new Ae(V.raw,J);if(V instanceof he)return new Ae(V.value,J);if(!(this instanceof Ae))return new Ae(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function we(V){return!V||V.toLowerCase()==="x"||V==="*"}function Pe(V,J,X,me,ve,Te,He,Ze,tt,nt,at,rt,Ce){return((J=we(X)?"":we(me)?">="+X+".0.0":we(ve)?">="+X+"."+me+".0":">="+J)+" "+(Ze=we(tt)?"":we(nt)?"<"+(+tt+1)+".0.0":we(at)?"<"+tt+"."+(+nt+1)+".0":rt?"<="+tt+"."+nt+"."+at+"-"+rt:"<="+Ze)).trim()}function Fe(V,J){for(var X=0;X<V.length;X++)if(!V[X].test(J))return!1;if(J.prerelease.length){for(X=0;X<V.length;X++)if(M(V[X].semver),V[X].semver!==pe&&V[X].semver.prerelease.length>0){var me=V[X].semver;if(me.major===J.major&&me.minor===J.minor&&me.patch===J.patch)return!0}return!1}return!0}function ze(V,J,X){try{J=new Ae(J,X)}catch{return!1}return J.test(V)}function q(V,J,X,me){var ve,Te,He,Ze,tt;switch(V=new se(V,me),J=new Ae(J,me),X){case">":ve=ye,Te=H,He=le,Ze=">",tt=">=";break;case"<":ve=le,Te=de,He=ye,Ze="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(V,J,me))return!1;for(var nt=0;nt<J.set.length;++nt){var at=J.set[nt],rt=null,Ce=null;if(at.forEach(function(Be){Be.semver===pe&&(Be=new he(">=0.0.0")),rt=rt||Be,Ce=Ce||Be,ve(Be.semver,rt.semver,me)?rt=Be:He(Be.semver,Ce.semver,me)&&(Ce=Be)}),rt.operator===Ze||rt.operator===tt||(!Ce.operator||Ce.operator===Ze)&&Te(V,Ce.semver)||Ce.operator===tt&&He(V,Ce.semver))return!1}return!0}he.prototype.parse=function(V){var J=this.loose?b[K]:b[ee],X=V.match(J);if(!X)throw new TypeError("Invalid comparator: "+V);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new se(X[2],this.loose):this.semver=pe},he.prototype.toString=function(){return this.value},he.prototype.test=function(V){return M("Comparator.test",V,this.loose),this.semver===pe||(typeof V=="string"&&(V=new se(V,this.loose)),x(V,this.operator,this.semver,this.loose))},he.prototype.intersects=function(V,J){if(!(V instanceof he))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Ae(V.value,J),ze(this.value,X,J);if(V.operator==="")return X=new Ae(this.value,J),ze(V.semver,X,J);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Te=this.semver.version===V.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ze=x(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),tt=x(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ve||Te&&He||Ze||tt},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),M("range",V,J);var X=J?b[Z]:b[Q];V=V.replace(X,Pe),M("hyphen replace",V),V=V.replace(b[Y],"$1$2$3"),M("comparator trim",V,b[Y]),V=(V=(V=V.replace(b[O],"$1~")).replace(b[j],"$1^")).split(/\s+/).join(" ");var me=J?b[K]:b[ee],ve=V.split(" ").map(function(Te){return function(He,Ze){return M("comp",He),He=function(tt,nt){return tt.trim().split(/\s+/).map(function(at){return function(rt,Ce){M("caret",rt,Ce);var Be=Ce?b[F]:b[N];return rt.replace(Be,function(Me,Ke,ne,oe,Ie){var Ge;return M("caret",rt,Me,Ke,ne,oe,Ie),we(Ke)?Ge="":we(ne)?Ge=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":we(oe)?Ge=Ke==="0"?">="+Ke+"."+ne+".0 <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+".0 <"+(+Ke+1)+".0.0":Ie?(M("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ge=Ke==="0"?ne==="0"?">="+Ke+"."+ne+"."+oe+Ie+" <"+Ke+"."+ne+"."+(+oe+1):">="+Ke+"."+ne+"."+oe+Ie+" <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+"."+oe+Ie+" <"+(+Ke+1)+".0.0"):(M("no pr"),Ge=Ke==="0"?ne==="0"?">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+ne+"."+(+oe+1):">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+"."+oe+" <"+(+Ke+1)+".0.0"),M("caret return",Ge),Ge})}(at,nt)}).join(" ")}(He,Ze),M("caret",He),He=function(tt,nt){return tt.trim().split(/\s+/).map(function(at){return function(rt,Ce){var Be=Ce?b[z]:b[B];return rt.replace(Be,function(Me,Ke,ne,oe,Ie){var Ge;return M("tilde",rt,Me,Ke,ne,oe,Ie),we(Ke)?Ge="":we(ne)?Ge=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":we(oe)?Ge=">="+Ke+"."+ne+".0 <"+Ke+"."+(+ne+1)+".0":Ie?(M("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ge=">="+Ke+"."+ne+"."+oe+Ie+" <"+Ke+"."+(+ne+1)+".0"):Ge=">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+(+ne+1)+".0",M("tilde return",Ge),Ge})}(at,nt)}).join(" ")}(He,Ze),M("tildes",He),He=function(tt,nt){return M("replaceXRanges",tt,nt),tt.split(/\s+/).map(function(at){return function(rt,Ce){rt=rt.trim();var Be=Ce?b[v]:b[$];return rt.replace(Be,function(Me,Ke,ne,oe,Ie,Ge){M("xRange",rt,Me,Ke,ne,oe,Ie,Ge);var xe=we(ne),st=xe||we(oe),Le=st||we(Ie);return Ke==="="&&Le&&(Ke=""),xe?Me=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&Le?(st&&(oe=0),Le&&(Ie=0),Ke===">"?(Ke=">=",st?(ne=+ne+1,oe=0,Ie=0):Le&&(oe=+oe+1,Ie=0)):Ke==="<="&&(Ke="<",st?ne=+ne+1:oe=+oe+1),Me=Ke+ne+"."+oe+"."+Ie):st?Me=">="+ne+".0.0 <"+(+ne+1)+".0.0":Le&&(Me=">="+ne+"."+oe+".0 <"+ne+"."+(+oe+1)+".0"),M("xRange return",Me),Me})}(at,nt)}).join(" ")}(He,Ze),M("xrange",He),He=function(tt,nt){return M("replaceStars",tt,nt),tt.trim().replace(b[ae],"")}(He,Ze),M("stars",He),He}(Te,J)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Te){return!!Te.match(me)})),ve=ve.map(function(Te){return new he(Te,J)})},Ae.prototype.intersects=function(V,J){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(me){return V.set.some(function(ve){return ve.every(function(Te){return me.intersects(Te,J)})})})})},e.toComparators=function(V,J){return new Ae(V,J).set.map(function(X){return X.map(function(me){return me.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new se(V,this.loose));for(var J=0;J<this.set.length;J++)if(Fe(this.set[J],V))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(V,J,X){var me=null,ve=null;try{var Te=new Ae(J,X)}catch{return null}return V.forEach(function(He){Te.test(He)&&(me&&ve.compare(He)!==-1||(ve=new se(me=He,X)))}),me},e.minSatisfying=function(V,J,X){var me=null,ve=null;try{var Te=new Ae(J,X)}catch{return null}return V.forEach(function(He){Te.test(He)&&(me&&ve.compare(He)!==1||(ve=new se(me=He,X)))}),me},e.validRange=function(V,J){try{return new Ae(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,X){return q(V,J,"<",X)},e.gtr=function(V,J,X){return q(V,J,">",X)},e.outside=q,e.prerelease=function(V,J){var X=ge(V,J);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(V,J,X){return V=new Ae(V,X),J=new Ae(J,X),V.intersects(J)},e.coerce=function(V){if(V instanceof se)return V;if(typeof V!="string")return null;var J=V.match(b[k]);return J==null?null:ge((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,u(1))},function(fe,e){var u,L,M=fe.exports={};function A(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function b(g){if(u===setTimeout)return setTimeout(g,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(g,0);try{return u(g,0)}catch{try{return u.call(null,g,0)}catch{return u.call(this,g,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{L=typeof clearTimeout=="function"?clearTimeout:P}catch{L=P}})();var p,E=[],R=!1,I=-1;function w(){R&&p&&(R=!1,p.length?E=p.concat(E):I=-1,E.length&&S())}function S(){if(!R){var g=b(w);R=!0;for(var c=E.length;c;){for(p=E,E=[];++I<c;)p&&p[I].run();I=-1,c=E.length}p=null,R=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===P||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(g)}}function y(g,c){this.fun=g,this.array=c}function h(){}M.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)c[n-1]=arguments[n];E.push(new y(g,c)),E.length!==1||R||b(S)},y.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=h,M.addListener=h,M.once=h,M.off=h,M.removeListener=h,M.removeAllListeners=h,M.emit=h,M.prependListener=h,M.prependOnceListener=h,M.listeners=function(g){return[]},M.binding=function(g){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(g){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Se[38],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=u&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=L}),define(Se[4],De([1,0,13,73,3,74,38]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$4d=e.Event=void 0,e.$5d=w;const b=!1,p=!1;var E;(function($){$.None=()=>M.$Tc.None;function v(H){if(p){const{onDidAddListener:x}=H,he=y.create();let pe=0;H.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),x?.()}}}function k(H,x){return ee(H,()=>{},0,void 0,!0,void 0,x)}$.defer=k;function C(H){return(x,he=null,pe)=>{let Ae=!1,we;return we=H(Pe=>{if(!Ae)return we?we.dispose():Ae=!0,x.call(he,Pe)},null,pe),Ae&&we.dispose(),we}}$.once=C;function O(H,x,he){return F((pe,Ae=null,we)=>H(Pe=>pe.call(Ae,x(Pe)),null,we),he)}$.map=O;function B(H,x,he){return F((pe,Ae=null,we)=>H(Pe=>{x(Pe),pe.call(Ae,Pe)},null,we),he)}$.forEach=B;function z(H,x,he){return F((pe,Ae=null,we)=>H(Pe=>x(Pe)&&pe.call(Ae,Pe),null,we),he)}$.filter=z;function T(H){return H}$.signal=T;function j(...H){return(x,he=null,pe)=>{const Ae=(0,M.$Qc)(...H.map(we=>we(Pe=>x.call(he,Pe))));return K(Ae,pe)}}$.any=j;function N(H,x,he,pe){let Ae=he;return O(H,we=>(Ae=x(Ae,we),Ae),pe)}$.reduce=N;function F(H,x){let he;const pe={onWillAddFirstListener(){he=H(Ae.fire,Ae)},onDidRemoveLastListener(){he?.dispose()}};x||v(pe);const Ae=new i(pe);return x?.add(Ae),Ae.event}function K(H,x){return x instanceof Array?x.push(H):x&&x.add(H),H}function ee(H,x,he=100,pe=!1,Ae=!1,we,Pe){let Fe,ze,q,V=0,J;const X={leakWarningThreshold:we,onWillAddFirstListener(){Fe=H(ve=>{V++,ze=x(ze,ve),pe&&!q&&(me.fire(ze),ze=void 0),J=()=>{const Te=ze;ze=void 0,q=void 0,(!pe||V>1)&&me.fire(Te),V=0},typeof he=="number"?(clearTimeout(q),q=setTimeout(J,he)):q===void 0&&(q=0,queueMicrotask(J))})},onWillRemoveListener(){Ae&&V>0&&J?.()},onDidRemoveLastListener(){J=void 0,Fe.dispose()}};Pe||v(X);const me=new i(X);return Pe?.add(me),me.event}$.debounce=ee;function Y(H,x=0,he){return $.debounce(H,(pe,Ae)=>pe?(pe.push(Ae),pe):[Ae],x,void 0,!0,void 0,he)}$.accumulate=Y;function Q(H,x=(pe,Ae)=>pe===Ae,he){let pe=!0,Ae;return z(H,we=>{const Pe=pe||!x(we,Ae);return pe=!1,Ae=we,Pe},he)}$.latch=Q;function Z(H,x,he){return[$.filter(H,x,he),$.filter(H,pe=>!x(pe),he)]}$.split=Z;function ae(H,x=!1,he=[],pe){let Ae=he.slice(),we=H(ze=>{Ae?Ae.push(ze):Fe.fire(ze)});pe&&pe.add(we);const Pe=()=>{Ae?.forEach(ze=>Fe.fire(ze)),Ae=null},Fe=new i({onWillAddFirstListener(){we||(we=H(ze=>Fe.fire(ze)),pe&&pe.add(we))},onDidAddFirstListener(){Ae&&(x?setTimeout(Pe):Pe())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return pe&&pe.add(Fe),Fe.event}$.buffer=ae;function _(H,x){return(pe,Ae,we)=>{const Pe=x(new se);return H(function(Fe){const ze=Pe.evaluate(Fe);ze!==ge&&pe.call(Ae,ze)},void 0,we)}}$.chain=_;const ge=Symbol("HaltChainable");class se{constructor(){this.f=[]}map(x){return this.f.push(x),this}forEach(x){return this.f.push(he=>(x(he),he)),this}filter(x){return this.f.push(he=>x(he)?he:ge),this}reduce(x,he){let pe=he;return this.f.push(Ae=>(pe=x(pe,Ae),pe)),this}latch(x=(he,pe)=>he===pe){let he=!0,pe;return this.f.push(Ae=>{const we=he||!x(Ae,pe);return he=!1,pe=Ae,we?Ae:ge}),this}evaluate(x){for(const he of this.f)if(x=he(x),x===ge)break;return x}}function re(H,x,he=pe=>pe){const pe=(...Fe)=>Pe.fire(he(...Fe)),Ae=()=>H.on(x,pe),we=()=>H.removeListener(x,pe),Pe=new i({onWillAddFirstListener:Ae,onDidRemoveLastListener:we});return Pe.event}$.fromNodeEventEmitter=re;function U(H,x,he=pe=>pe){const pe=(...Fe)=>Pe.fire(he(...Fe)),Ae=()=>H.addEventListener(x,pe),we=()=>H.removeEventListener(x,pe),Pe=new i({onWillAddFirstListener:Ae,onDidRemoveLastListener:we});return Pe.event}$.fromDOMEventEmitter=U;function ie(H){return new Promise(x=>C(H)(x))}$.toPromise=ie;function ye(H){const x=new i;return H.then(he=>{x.fire(he)},()=>{x.fire(void 0)}).finally(()=>{x.dispose()}),x.event}$.fromPromise=ye;function le(H,x,he){return x(he),H(pe=>x(pe))}$.runAndSubscribe=le;class ue{constructor(x,he){this._observable=x,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};he||v(pe),this.emitter=new i(pe),he&&he.add(this.emitter)}beginUpdate(x){this.f++}handlePossibleChange(x){}handleChange(x,he){this.g=!0}endUpdate(x){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(H,x){return new ue(H,x).emitter.event}$.fromObservable=ce;function de(H){return(x,he,pe)=>{let Ae=0,we=!1;const Pe={beginUpdate(){Ae++},endUpdate(){Ae--,Ae===0&&(H.reportChanges(),we&&(we=!1,x.call(he)))},handlePossibleChange(){},handleChange(){we=!0}};H.addObserver(Pe),H.reportChanges();const Fe={dispose(){H.removeObserver(Pe)}};return pe instanceof M.$Sc?pe.add(Fe):Array.isArray(pe)&&pe.push(Fe),Fe}}$.fromObservableLight=de})(E||(e.Event=E={}));class R{static{this.all=new Set}static{this.f=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${R.f++}`,R.all.add(this)}start(v){this.g=new P.$2d,this.listenerCount=v}stop(){if(this.g){const v=this.g.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.g=void 0}}}e.$4d=R;let I=-1;function w($){const v=I;return I=$,{dispose(){I=v}}}class S{constructor(v,k=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=k,this.g=0}dispose(){this.f?.clear()}check(v,k){const C=this.threshold;if(C<=0||k<C)return;this.f||(this.f=new Map);const O=this.f.get(v.value)||0;if(this.f.set(v.value,O+1),this.g-=1,this.g<=0){this.g=C*.5;let B,z=0;for(const[T,j]of this.f)(!B||z<j)&&(B=T,z=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${z}):`),console.warn(B)}return()=>{const B=this.f.get(v.value)||0;this.f.set(v.value,B-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class g{constructor(v){this.value=v,this.id=h++}}const c=2,n=($,v)=>{if($ instanceof g)v($);else for(let k=0;k<$.length;k++){const C=$[k];C&&v(C)}};class i{constructor(v){this.w=0,this.f=v,this.g=I>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const v=this.t;queueMicrotask(()=>{n(v,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(v,k,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Tc.None;if(this.m)return M.$Tc.None;k&&(v=v.bind(k));const O=new g(v);let B,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=y.create(),B=this.g.check(O.stack,this.w+1)),b&&(O.stack=z??y.create()),this.t?this.t instanceof g?(this.u??=new a,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,M.$Rc)(()=>{B?.(),this.x(O)});return C instanceof M.$Sc?C.add(T):Array.isArray(C)&&C.push(T),T},this.q}x(v){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,C=k.indexOf(v);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[C]=void 0;const O=this.u.current===this;if(this.w*c<=k.length){let B=0;for(let z=0;z<k.length;z++)k[z]?k[B++]=k[z]:O&&(this.u.end--,B<this.u.i&&this.u.i--);k.length=B}}y(v,k){if(!v)return;const C=this.f?.onListenerError||u.$1;if(!C){v.value(k);return}try{v.value(k)}catch(O){C(O)}}z(v){const k=v.current.t;for(;v.i<v.end;)this.y(k[v.i++],v.value);v.reset()}fire(v){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,v);else{const k=this.u;k.enqueue(this,v,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=i;const r=()=>new a;e.$7d=r;class a{constructor(){this.i=-1,this.end=0}enqueue(v,k,C){this.i=0,this.end=C,this.current=v,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends i{async fireAsync(v,k,C){if(this.t)for(this.h||(this.h=new A.$4c),n(this.t,O=>this.h.push([O.value,v]));this.h.size>0&&!k.isCancellationRequested;){const[O,B]=this.h.shift(),z=[],T={...B,token:k,waitUntil:j=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");C&&(j=C(j,O)),z.push(j)}};try{O(T)}catch(j){(0,u.$1)(j);continue}Object.freeze(z),await Promise.allSettled(z).then(j=>{for(const N of j)N.status==="rejected"&&(0,u.$1)(N.reason)})}}}e.$8d=t;class f extends i{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new A.$4c,this.A=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.A(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.w&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$9d=f;class l extends f{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$0d=l;class s extends i{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$$d=s;class o{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(v){const k={event:v,listener:null};this.h.push(k),this.g&&this.m(k);const C=()=>{this.g&&this.o(k);const O=this.h.indexOf(k);this.h.splice(O,1)};return(0,M.$Rc)((0,L.$db)(C))}j(){this.g=!0,this.h.forEach(v=>this.m(v))}k(){this.g=!1,this.h.forEach(v=>this.o(v))}m(v){v.listener=v.event(k=>this.f.fire(k))}o(v){v.listener?.dispose(),v.listener=null}dispose(){this.f.dispose();for(const v of this.h)v.listener?.dispose();this.h=[]}}e.$_d=o;class d{constructor(v,k,C,O){this.f=new M.$Sc;const B=this.f.add(new o),z=this.f.add(new M.$3c);function T(j){z.set(j,B.add(O(j)))}for(const j of v)T(j);this.f.add(k(j=>{T(j)})),this.f.add(C(j=>{z.deleteAndDispose(j)})),this.event=B.event}dispose(){this.f.dispose()}}e.$ae=d;class m{constructor(){this.f=[]}wrapEvent(v){return(k,C,O)=>v(B=>{const z=this.f[this.f.length-1];z?z.push(()=>k.call(C,B)):k.call(C,B)},void 0,O)}bufferEvents(v){const k=[];this.f.push(k);const C=v();return this.f.pop(),k.forEach(O=>O()),C}}e.$be=m;class D{constructor(){this.f=!1,this.g=E.None,this.h=M.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(v){this.g=v,this.f&&(this.h.dispose(),this.h=v(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=D}),define(Se[22],De([1,0,4]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const L=Object.freeze(function(b,p){const E=setTimeout(b.bind(p),0);return{dispose(){clearTimeout(E)}}});var M;(function(b){function p(E){return E===b.None||E===b.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}b.isCancellationToken=p,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M||(e.CancellationToken=M={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new u.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=M.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=M.None}}e.$de=P}),define(Se[166],De([1,0,22]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class L{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new u.$de,p=this.b(b.token);return this.a={promise:p,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Oe=L;class M{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const p=JSON.stringify(b);return this.b!==p&&(this.b=p,this.a=this.c(b)),this.a}}e.$Pe=M;class A{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const p=this.b(b);return this.a.set(b,p),p}}e.$Qe=A}),define(Se[98],De([1,0,13,3]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=M,e.$fe=A,e.$ge=P,e.$he=b,e.$ie=E,e.$je=R,e.$ke=I,e.$le=w,e.$me=S,e.$ne=y,e.$oe=h,e.$pe=g,e.$qe=c,e.$re=n,e.$se=i;function M(r){const a=r;return a?typeof a.read=="function":!1}function A(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function P(r){const a=r;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function b(r,a){return new p(r,a)}class p{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,u.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let f;switch(a){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const l=f.indexOf(t);l>=0&&f.splice(l,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(r,a){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return a(t)}function R(r,a,t){const f=[];let l;for(;(l=r.read())!==null&&f.length<t;)f.push(l);return l===null&&f.length>0?a(f):{read:()=>{if(f.length>0)return f.shift();if(typeof l<"u"){const s=l;return l=void 0,s}return r.read()}}}function I(r,a){return new Promise((t,f)=>{const l=[];w(r,{onData:s=>{a&&l.push(s)},onError:s=>{a?f(s):t(void 0)},onEnd:()=>{t(a?a(l):void 0)}})})}function w(r,a,t){r.on("error",f=>{t?.isCancellationRequested||a.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||a.onData(f)})}function S(r,a){return new Promise((t,f)=>{const l=new L.$Sc,s=[],o=D=>{if(s.push(D),s.length>a)return l.dispose(),r.pause(),t({stream:r,buffer:s,ended:!1})},d=D=>(l.dispose(),f(D)),m=()=>(l.dispose(),t({stream:r,buffer:s,ended:!0}));l.add((0,L.$Rc)(()=>r.removeListener("error",d))),r.on("error",d),l.add((0,L.$Rc)(()=>r.removeListener("end",m))),r.on("end",m),l.add((0,L.$Rc)(()=>r.removeListener("data",o))),r.on("data",o)})}function y(r,a){const t=b(a);return t.end(r),t}function h(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}function g(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}function c(r,a,t){const f=b(t);return w(r,{onData:l=>f.write(a.data(l)),onError:l=>f.error(a.error?a.error(l):l),onEnd:()=>f.end()}),f}function n(r,a,t){let f=!1;return{read:()=>{const l=a.read();return f?l:(f=!0,l!==null?t([r,l]):r)}}}function i(r,a,t){let f=!1;const l=b(t);return w(a,{onData:s=>f?l.write(s):(f=!0,l.write(t([r,s]))),onError:s=>l.error(s),onEnd:()=>{f||(f=!0,l.write(r)),l.end()}}),l}}),define(Se[21],De([1,0,43,98]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=void 0,e.$ue=E,e.$ve=R,e.$we=I,e.$xe=w,e.$ye=S,e.$ze=y,e.$Ae=h,e.$Be=g,e.$Ce=c,e.$De=n,e.$Ee=i,e.$Fe=r,e.$Ge=a,e.$He=t,e.$Ie=f,e.$Je=l,e.$Ke=s,e.$Le=o,e.$Me=d,e.$Ne=$;const M=typeof Buffer<"u",A=new u.$V(()=>new Uint8Array(256));let P,b;class p{static alloc(k){return M?new p(Buffer.allocUnsafe(k)):new p(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new p(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&M?new p(Buffer.from(k)):(P||(P=new TextEncoder),new p(P.encode(k)))}static fromByteArray(k){const C=p.alloc(k.length);for(let O=0,B=k.length;O<B;O++)C.buffer[O]=k[O];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let z=0,T=k.length;z<T;z++)C+=k[z].byteLength}const O=p.alloc(C);let B=0;for(let z=0,T=k.length;z<T;z++){const j=k[z];O.set(j,B),B+=j.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=p.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,C){return new p(this.buffer.subarray(k,C))}set(k,C){if(k instanceof p)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return w(this.buffer,k)}writeUInt32BE(k,C){S(this.buffer,k,C)}readUInt32LE(k){return y(this.buffer,k)}writeUInt32LE(k,C){h(this.buffer,k,C)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,C){c(this.buffer,k,C)}indexOf(k,C=0){return E(this.buffer,k instanceof p?k.buffer:k,C)}}e.$te=p;function E(v,k,C=0){const O=k.byteLength,B=v.byteLength;if(O===0)return 0;if(O===1)return v.indexOf(k[0]);if(O>B-C)return-1;const z=A.value;z.fill(k.length);for(let F=0;F<k.length;F++)z[k[F]]=k.length-F-1;let T=C+k.length-1,j=T,N=-1;for(;T<B;)if(v[T]===k[j]){if(j===0){N=T;break}T--,j--}else T+=Math.max(k.length-j,z[v[T]]),j=k.length-1;return N}function R(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0}function I(v,k,C){v[C+0]=k&255,k=k>>>8,v[C+1]=k&255}function w(v,k){return v[k]*2**24+v[k+1]*2**16+v[k+2]*2**8+v[k+3]}function S(v,k,C){v[C+3]=k,k=k>>>8,v[C+2]=k,k=k>>>8,v[C+1]=k,k=k>>>8,v[C]=k}function y(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0|v[k+2]<<16>>>0|v[k+3]<<24>>>0}function h(v,k,C){v[C+0]=k&255,k=k>>>8,v[C+1]=k&255,k=k>>>8,v[C+2]=k&255,k=k>>>8,v[C+3]=k&255}function g(v,k){return v[k]}function c(v,k,C){v[C]=k}function n(v){return L.$ie(v,k=>p.concat(k))}function i(v){return L.$pe(v)}function r(v){return L.$ke(v,k=>p.concat(k))}async function a(v){return v.ended?p.concat(v.buffer):p.concat([...v.buffer,await r(v.stream)])}function t(v){return L.$ne(v,k=>p.concat(k))}function f(v){return L.$qe(v,{data:k=>typeof k=="string"?p.fromString(k):p.wrap(k)},k=>p.concat(k))}function l(v){return L.$he(k=>p.concat(k),v)}function s(v,k){return L.$re(v,k,C=>p.concat(C))}function o(v,k){return L.$se(v,k,C=>p.concat(C))}function d(v){let k=0,C=0,O=0;const B=new Uint8Array(Math.floor(v.length/4*3)),z=j=>{switch(C){case 3:B[O++]=k|j,C=0;break;case 2:B[O++]=k|j>>>2,k=j<<6,C=3;break;case 1:B[O++]=k|j>>>4,k=j<<4,C=2;break;default:k=j<<2,C=1}};for(let j=0;j<v.length;j++){const N=v.charCodeAt(j);if(N>=65&&N<=90)z(N-65);else if(N>=97&&N<=122)z(N-97+26);else if(N>=48&&N<=57)z(N-48+52);else if(N===43||N===45)z(62);else if(N===47||N===95)z(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${v[j]}`)}}const T=O;for(;C>0;)z(0);return p.wrap(B).slice(0,T)}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:v},k=!0,C=!1){const O=C?D:m;let B="";const z=v.byteLength%3;let T=0;for(;T<v.byteLength-z;T+=3){const j=v[T+0],N=v[T+1],F=v[T+2];B+=O[j>>>2],B+=O[(j<<4|N>>>4)&63],B+=O[(N<<2|F>>>6)&63],B+=O[F&63]}if(z===1){const j=v[T+0];B+=O[j>>>2],B+=O[j<<4&63],k&&(B+="==")}else if(z===2){const j=v[T+0],N=v[T+1];B+=O[j>>>2],B+=O[(j<<4|N>>>4)&63],B+=O[N<<2&63],k&&(B+="=")}return B}}),define(Se[14],De([1,0,166,43]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.GraphemeBreakType=e.$Gf=e.$Af=e.$tf=e.$sf=void 0,e.$Te=M,e.$Ue=P,e.$Ve=p,e.$We=E,e.$Xe=R,e.$Ye=I,e.$Ze=w,e.$1e=S,e.$2e=y,e.$3e=h,e.$4e=g,e.$5e=c,e.$6e=n,e.$7e=i,e.$8e=r,e.$9e=a,e.$0e=t,e.$$e=f,e.$_e=l,e.$af=s,e.$bf=o,e.$cf=d,e.$df=m,e.$ef=D,e.$ff=$,e.$gf=v,e.$hf=k,e.$if=C,e.$jf=O,e.$kf=B,e.$lf=z,e.$mf=T,e.$nf=j,e.$of=N,e.$pf=F,e.$qf=K,e.$rf=ee,e.$uf=ae,e.$vf=_,e.$wf=ge,e.$xf=se,e.$yf=ie,e.$zf=le,e.$Bf=ue,e.$Cf=ce,e.$Df=de,e.$Ef=H,e.$Ff=pe,e.$Hf=Ae,e.$If=we,e.$Jf=Pe,e.$Kf=Fe,e.$Lf=ze,e.$Mf=q,e.$Nf=V,e.$Of=J,e.$Pf=He;function M(Ce){return!Ce||typeof Ce!="string"?!0:Ce.trim().length===0}const A=/{(\d+)}/g;function P(Ce,...Be){return Be.length===0?Ce:Ce.replace(A,function(Me,Ke){const ne=parseInt(Ke,10);return isNaN(ne)||ne<0||ne>=Be.length?Me:Be[ne]})}const b=/{([^}]+)}/g;function p(Ce,Be){return Object.keys(Be).length===0?Ce:Ce.replace(b,(Me,Ke)=>Be[Ke]??Me)}function E(Ce){return Ce.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function R(Ce){return Ce.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function I(Ce){return Ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Ce,Be){let Me=0;const Ke=Be.charCodeAt(0);for(let ne=Ce.length-1;ne>=0;ne--)Ce.charCodeAt(ne)===Ke&&Me++;return Me}function S(Ce,Be,Me="\u2026"){return Ce.length<=Be?Ce:`${Ce.substr(0,Be)}${Me}`}function y(Ce,Be,Me="\u2026"){if(Ce.length<=Be)return Ce;const Ke=Math.ceil(Be/2)-Me.length/2,ne=Math.floor(Be/2)-Me.length/2;return`${Ce.substr(0,Ke)}${Me}${Ce.substr(Ce.length-ne)}`}function h(Ce,Be=" "){const Me=g(Ce,Be);return c(Me,Be)}function g(Ce,Be){if(!Ce||!Be)return Ce;const Me=Be.length;if(Me===0||Ce.length===0)return Ce;let Ke=0;for(;Ce.indexOf(Be,Ke)===Ke;)Ke=Ke+Me;return Ce.substring(Ke)}function c(Ce,Be){if(!Ce||!Be)return Ce;const Me=Be.length,Ke=Ce.length;if(Me===0||Ke===0)return Ce;let ne=Ke,oe=-1;for(;oe=Ce.lastIndexOf(Be,ne-1),!(oe===-1||oe+Me!==ne);){if(oe===0)return"";ne=oe}return Ce.substring(0,ne)}function n(Ce){return Ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ce){return Ce.replace(/\*/g,"")}function r(Ce,Be,Me={}){if(!Ce)throw new Error("Cannot create regex from empty string");Be||(Ce=I(Ce)),Me.wholeWord&&(/\B/.test(Ce.charAt(0))||(Ce="\\b"+Ce),/\B/.test(Ce.charAt(Ce.length-1))||(Ce=Ce+"\\b"));let Ke="";return Me.global&&(Ke+="g"),Me.matchCase||(Ke+="i"),Me.multiline&&(Ke+="m"),Me.unicode&&(Ke+="u"),new RegExp(Ce,Ke)}function a(Ce){return Ce.source==="^"||Ce.source==="^$"||Ce.source==="$"||Ce.source==="^\\s*$"?!1:!!(Ce.exec("")&&Ce.lastIndex===0)}function t(Ce){return Ce.split(/\r\n|\r|\n/)}function f(Ce){const Be=[],Me=Ce.split(/(\r\n|\r|\n)/);for(let Ke=0;Ke<Math.ceil(Me.length/2);Ke++)Be.push(Me[2*Ke]+(Me[2*Ke+1]??""));return Be}function l(Ce){for(let Be=0,Me=Ce.length;Be<Me;Be++){const Ke=Ce.charCodeAt(Be);if(Ke!==32&&Ke!==9)return Be}return-1}function s(Ce,Be=0,Me=Ce.length){for(let Ke=Be;Ke<Me;Ke++){const ne=Ce.charCodeAt(Ke);if(ne!==32&&ne!==9)return Ce.substring(Be,Ke)}return Ce.substring(Be,Me)}function o(Ce,Be=Ce.length-1){for(let Me=Be;Me>=0;Me--){const Ke=Ce.charCodeAt(Me);if(Ke!==32&&Ke!==9)return Me}return-1}function d(Ce,Be,Me){const Ke=[];let ne=0;for(const oe of Ce.matchAll(Be)){if(Ke.push(Ce.slice(ne,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ne=oe.index+oe[0].length,Ke.push(Me(oe[0],...oe.slice(1),oe.index,Ce,oe.groups))}return Ke.push(Ce.slice(ne)),Promise.all(Ke).then(oe=>oe.join(""))}function m(Ce,Be){return Ce<Be?-1:Ce>Be?1:0}function D(Ce,Be,Me=0,Ke=Ce.length,ne=0,oe=Be.length){for(;Me<Ke&&ne<oe;Me++,ne++){const xe=Ce.charCodeAt(Me),st=Be.charCodeAt(ne);if(xe<st)return-1;if(xe>st)return 1}const Ie=Ke-Me,Ge=oe-ne;return Ie<Ge?-1:Ie>Ge?1:0}function $(Ce,Be){return v(Ce,Be,0,Ce.length,0,Be.length)}function v(Ce,Be,Me=0,Ke=Ce.length,ne=0,oe=Be.length){for(;Me<Ke&&ne<oe;Me++,ne++){let xe=Ce.charCodeAt(Me),st=Be.charCodeAt(ne);if(xe===st)continue;if(xe>=128||st>=128)return D(Ce.toLowerCase(),Be.toLowerCase(),Me,Ke,ne,oe);C(xe)&&(xe-=32),C(st)&&(st-=32);const Le=xe-st;if(Le!==0)return Le}const Ie=Ke-Me,Ge=oe-ne;return Ie<Ge?-1:Ie>Ge?1:0}function k(Ce){return Ce>=48&&Ce<=57}function C(Ce){return Ce>=97&&Ce<=122}function O(Ce){return Ce>=65&&Ce<=90}function B(Ce,Be){return Ce.length===Be.length&&v(Ce,Be)===0}function z(Ce,Be){const Me=Be.length;return Be.length>Ce.length?!1:v(Ce,Be,0,Me)===0}function T(Ce,Be){const Me=Math.min(Ce.length,Be.length);let Ke;for(Ke=0;Ke<Me;Ke++)if(Ce.charCodeAt(Ke)!==Be.charCodeAt(Ke))return Ke;return Me}function j(Ce,Be){const Me=Math.min(Ce.length,Be.length);let Ke;const ne=Ce.length-1,oe=Be.length-1;for(Ke=0;Ke<Me;Ke++)if(Ce.charCodeAt(ne-Ke)!==Be.charCodeAt(oe-Ke))return Ke;return Me}function N(Ce){return 55296<=Ce&&Ce<=56319}function F(Ce){return 56320<=Ce&&Ce<=57343}function K(Ce,Be){return(Ce-55296<<10)+(Be-56320)+65536}function ee(Ce,Be,Me){const Ke=Ce.charCodeAt(Me);if(N(Ke)&&Me+1<Be){const ne=Ce.charCodeAt(Me+1);if(F(ne))return K(Ke,ne)}return Ke}function Y(Ce,Be){const Me=Ce.charCodeAt(Be-1);if(F(Me)&&Be>1){const Ke=Ce.charCodeAt(Be-2);if(N(Ke))return K(Ke,Me)}return Me}class Q{get offset(){return this.e}constructor(Be,Me=0){this.c=Be,this.d=Be.length,this.e=Me}setOffset(Be){this.e=Be}prevCodePoint(){const Be=Y(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=ee(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$sf=Q;class Z{get offset(){return this.c.offset}constructor(Be,Me=0){this.c=new Q(Be,Me)}nextGraphemeLength(){const Be=ve.getInstance(),Me=this.c,Ke=Me.offset;let ne=Be.getGraphemeBreakType(Me.nextCodePoint());for(;!Me.eol();){const oe=Me.offset,Ie=Be.getGraphemeBreakType(Me.nextCodePoint());if(X(ne,Ie)){Me.setOffset(oe);break}ne=Ie}return Me.offset-Ke}prevGraphemeLength(){const Be=ve.getInstance(),Me=this.c,Ke=Me.offset;let ne=Be.getGraphemeBreakType(Me.prevCodePoint());for(;Me.offset>0;){const oe=Me.offset,Ie=Be.getGraphemeBreakType(Me.prevCodePoint());if(X(Ie,ne)){Me.setOffset(oe);break}ne=Ie}return Ke-Me.offset}eol(){return this.c.eol()}}e.$tf=Z;function ae(Ce,Be){return new Z(Ce,Be).nextGraphemeLength()}function _(Ce,Be){return new Z(Ce,Be).prevGraphemeLength()}function ge(Ce,Be){Be>0&&F(Ce.charCodeAt(Be))&&Be--;const Me=Be+ae(Ce,Be);return[Me-_(Ce,Me),Me]}function se(Ce){const Be=new Z(Ce);let Me=0;for(;!Be.eol();)Me++,Be.nextGraphemeLength();return Me}let re;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(Ce){return re||(re=U()),re.test(Ce)}const ye=/^[\t\n\r\x20-\x7E]*$/;function le(Ce){return ye.test(Ce)}e.$Af=/[\u2028\u2029]/;function ue(Ce){return e.$Af.test(Ce)}function ce(Ce){return Ce>=11904&&Ce<=55215||Ce>=63744&&Ce<=64255||Ce>=65281&&Ce<=65374}function de(Ce){return Ce>=127462&&Ce<=127487||Ce===8986||Ce===8987||Ce===9200||Ce===9203||Ce>=9728&&Ce<=10175||Ce===11088||Ce===11093||Ce>=127744&&Ce<=128591||Ce>=128640&&Ce<=128764||Ce>=128992&&Ce<=129008||Ce>=129280&&Ce<=129535||Ce>=129648&&Ce<=129782}function H(Ce,Be,Me=""){const Ke=Ce.trimStart();if(Ke.length<Be)return Ke;const ne=/\b/g;let oe=0;for(;ne.test(Ke)&&!(Ke.length-ne.lastIndex<Be);)oe=ne.lastIndex,ne.lastIndex+=1;return oe===0?Ke:Me+Ke.substring(oe).trimStart()}const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function pe(Ce){return Ce&&(Ce=Ce.replace(x,"").replace(he,"")),Ce}e.$Gf="\uFEFF";function Ae(Ce){return!!(Ce&&Ce.length>0&&Ce.charCodeAt(0)===65279)}function we(Ce){return Ae(Ce)?Ce.substr(1):Ce}function Pe(Ce,Be){if(!Ce||!Be||Ce.length<Be.length)return!1;const Me=Be.length,Ke=Ce.toLowerCase();let ne=0,oe=-1;for(;ne<Me;){const Ie=Ke.indexOf(Be[ne],oe+1);if(Ie<0)return!1;oe=Ie,ne++}return!0}function Fe(Ce,Be=!1){return Ce?(Be&&(Ce=Ce.replace(/\\./g,"")),Ce.toLowerCase()!==Ce):!1}function ze(Ce){return Ce.charAt(0).toUpperCase()+Ce.slice(1)}function q(Ce,Be=1){if(Be===0)return"";let Me=-1;do Me=Ce.indexOf(`
`,Me+1),Be--;while(Be>0&&Me>=0);return Me===-1?Ce:(Ce[Me-1]==="\r"&&Me--,Ce.substr(0,Me))}function V(Ce){return Ce=Ce%(2*26),Ce<26?String.fromCharCode(97+Ce):String.fromCharCode(65+Ce-26)}function J(Ce){return ve.getInstance().getGraphemeBreakType(Ce)}function X(Ce,Be){return Ce===0?Be!==5&&Be!==7:Ce===2&&Be===3?!1:Ce===4||Ce===2||Ce===3||Be===4||Be===2||Be===3?!0:!(Ce===8&&(Be===8||Be===9||Be===11||Be===12)||(Ce===11||Ce===9)&&(Be===9||Be===10)||(Ce===12||Ce===10)&&Be===10||Be===5||Be===13||Be===7||Ce===1||Ce===13&&Be===14||Ce===6&&Be===6)}var me;(function(Ce){Ce[Ce.Other=0]="Other",Ce[Ce.Prepend=1]="Prepend",Ce[Ce.CR=2]="CR",Ce[Ce.LF=3]="LF",Ce[Ce.Control=4]="Control",Ce[Ce.Extend=5]="Extend",Ce[Ce.Regional_Indicator=6]="Regional_Indicator",Ce[Ce.SpacingMark=7]="SpacingMark",Ce[Ce.L=8]="L",Ce[Ce.V=9]="V",Ce[Ce.T=10]="T",Ce[Ce.LV=11]="LV",Ce[Ce.LVT=12]="LVT",Ce[Ce.ZWJ=13]="ZWJ",Ce[Ce.Extended_Pictographic=14]="Extended_Pictographic"})(me||(e.GraphemeBreakType=me={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Te()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Me=this.d,Ke=Me.length/3;let ne=1;for(;ne<=Ke;)if(Be<Me[3*ne])ne=2*ne;else if(Be>Me[3*ne+1])ne=2*ne+1;else return Me[3*ne+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ce,Be){if(Ce===0)return 0;const Me=Ze(Ce,Be);if(Me!==void 0)return Me;const Ke=new Q(Be,Ce);return Ke.prevCodePoint(),Ke.offset}function Ze(Ce,Be){const Me=new Q(Be,Ce);let Ke=Me.prevCodePoint();for(;tt(Ke)||Ke===65039||Ke===8419;){if(Me.offset===0)return;Ke=Me.prevCodePoint()}if(!de(Ke))return;let ne=Me.offset;return ne>0&&Me.prevCodePoint()===8205&&(ne=Me.offset),ne}function tt(Ce){return 127995<=Ce&&Ce<=127999}var nt;(function(Ce){Ce[Ce.zwj=8205]="zwj",Ce[Ce.emojiVariantSelector=65039]="emojiVariantSelector",Ce[Ce.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Qf="\xA0";class at{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Pe(Be=>{function Me(Le){const bt=new Map;for(let St=0;St<Le.length;St+=2)bt.set(Le[St],Le[St+1]);return bt}function Ke(Le,bt){const St=new Map(Le);for(const[It,Vt]of bt)St.set(It,Vt);return St}function ne(Le,bt){if(!Le)return bt;const St=new Map;for(const[It,Vt]of Le)bt.has(It)&&St.set(It,Vt);return St}const oe=this.c.value;let Ie=Be.filter(Le=>!Le.startsWith("_")&&Le in oe);Ie.length===0&&(Ie=["_default"]);let Ge;for(const Le of Ie){const bt=Me(oe[Le]);Ge=ne(Ge,bt)}const xe=Me(oe._common),st=Ke(xe,Ge);return new at(st)})}static getInstance(Be){return at.d.get(Array.from(Be))}static{this.e=new L.$V(()=>Object.keys(at.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return at.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=at;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Be){return rt.e().has(Be)}static get codePoints(){return rt.e()}}e.$Sf=rt}),define(Se[126],De([1,0,28,165,14]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.FuzzyScore=e.$ik=e.$hk=void 0,e.or=A,e.$jk=b,e.$kk=p,e.$lk=I,e.$mk=d,e.$nk=m,e.$ok=O,e.$pk=B,e.$qk=z,e.$rk=T,e.$sk=ie,e.$uk=ce,e.$vk=x,e.$wk=he;function A(...we){return function(Pe,Fe){for(let ze=0,q=we.length;ze<q;ze++){const V=we[ze](Pe,Fe);if(V)return V}return null}}e.$hk=P.bind(void 0,!1),e.$ik=P.bind(void 0,!0);function P(we,Pe,Fe){if(!Fe||Fe.length<Pe.length)return null;let ze;return we?ze=M.$lf(Fe,Pe):ze=Fe.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function b(we,Pe){const Fe=Pe.toLowerCase().indexOf(we.toLowerCase());return Fe===-1?null:[{start:Fe,end:Fe+we.length}]}function p(we,Pe){return E(we.toLowerCase(),Pe.toLowerCase(),0,0)}function E(we,Pe,Fe,ze){if(Fe===we.length)return[];if(ze===Pe.length)return null;if(we[Fe]===Pe[ze]){let q=null;return(q=E(we,Pe,Fe+1,ze+1))?r({start:ze,end:ze+1},q):null}return E(we,Pe,Fe,ze+1)}function R(we){return 97<=we&&we<=122}function I(we){return 65<=we&&we<=90}function w(we){return 48<=we&&we<=57}function S(we){return we===32||we===9||we===10||we===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(we=>y.add(we.charCodeAt(0)));function h(we){return S(we)||y.has(we)}function g(we,Pe){return we===Pe||h(we)&&h(Pe)}const c=new Map;function n(we){if(c.has(we))return c.get(we);let Pe;const Fe=(0,L.$fk)(we);return Fe&&(Pe=Fe),c.set(we,Pe),Pe}function i(we){return R(we)||I(we)||w(we)}function r(we,Pe){return Pe.length===0?Pe=[we]:we.end===Pe[0].start?Pe[0].start=we.start:Pe.unshift(we),Pe}function a(we,Pe){for(let Fe=Pe;Fe<we.length;Fe++){const ze=we.charCodeAt(Fe);if(I(ze)||w(ze)||Fe>0&&!i(we.charCodeAt(Fe-1)))return Fe}return we.length}function t(we,Pe,Fe,ze){if(Fe===we.length)return[];if(ze===Pe.length)return null;if(we[Fe]!==Pe[ze].toLowerCase())return null;{let q=null,V=ze+1;for(q=t(we,Pe,Fe+1,ze+1);!q&&(V=a(Pe,V))<Pe.length;)q=t(we,Pe,Fe+1,V),V++;return q===null?null:r({start:ze,end:ze+1},q)}}function f(we){let Pe=0,Fe=0,ze=0,q=0,V=0;for(let Te=0;Te<we.length;Te++)V=we.charCodeAt(Te),I(V)&&Pe++,R(V)&&Fe++,i(V)&&ze++,w(V)&&q++;const J=Pe/we.length,X=Fe/we.length,me=ze/we.length,ve=q/we.length;return{upperPercent:J,lowerPercent:X,alphaPercent:me,numericPercent:ve}}function l(we){const{upperPercent:Pe,lowerPercent:Fe}=we;return Fe===0&&Pe>.6}function s(we){const{upperPercent:Pe,lowerPercent:Fe,alphaPercent:ze,numericPercent:q}=we;return Fe>.2&&Pe<.8&&ze>.6&&q<.2}function o(we){let Pe=0,Fe=0,ze=0,q=0;for(let V=0;V<we.length;V++)ze=we.charCodeAt(V),I(ze)&&Pe++,R(ze)&&Fe++,S(ze)&&q++;return(Pe===0||Fe===0)&&q===0?we.length<=30:Pe<=5}function d(we,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!o(we))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Fe=f(Pe);if(!s(Fe)){if(!l(Fe))return null;Pe=Pe.toLowerCase()}let ze=null,q=0;for(we=we.toLowerCase();q<Pe.length&&(ze=t(we,Pe,0,q))===null;)q=a(Pe,q+1);return ze}function m(we,Pe,Fe=!1){if(!Pe||Pe.length===0)return null;let ze=null,q=0;for(we=we.toLowerCase(),Pe=Pe.toLowerCase();q<Pe.length&&(ze=D(we,Pe,0,q,Fe),ze===null);)q=$(Pe,q+1);return ze}function D(we,Pe,Fe,ze,q){let V=0;if(Fe===we.length)return[];if(ze===Pe.length)return null;if(!g(we.charCodeAt(Fe),Pe.charCodeAt(ze))){const me=n(we.charCodeAt(Fe));if(!me)return null;for(let ve=0;ve<me.length;ve++)if(!g(me[ve],Pe.charCodeAt(ze+ve)))return null;V+=me.length-1}let J=null,X=ze+V+1;if(J=D(we,Pe,Fe+1,X,q),!q)for(;!J&&(X=$(Pe,X))<Pe.length;)J=D(we,Pe,Fe+1,X,q),X++;if(!J)return null;if(we.charCodeAt(Fe)!==Pe.charCodeAt(ze)){const me=n(we.charCodeAt(Fe));if(!me)return J;for(let ve=0;ve<me.length;ve++)if(me[ve]!==Pe.charCodeAt(ze+ve))return J}return r({start:ze,end:ze+V+1},J)}function $(we,Pe){for(let Fe=Pe;Fe<we.length;Fe++)if(h(we.charCodeAt(Fe))||Fe>0&&h(we.charCodeAt(Fe-1)))return Fe;return we.length}const v=A(e.$ik,d,b),k=A(e.$ik,d,p),C=new u.$Dc(1e4);function O(we,Pe,Fe=!1){if(typeof we!="string"||typeof Pe!="string")return null;let ze=C.get(we);ze||(ze=new RegExp(M.$6e(we),"i"),C.set(we,ze));const q=ze.exec(Pe);return q?[{start:q.index,end:q.index+q[0].length}]:Fe?k(we,Pe):v(we,Pe)}function B(we,Pe){const Fe=ce(we,we.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Fe?T(Fe):null}function z(we,Pe,Fe,ze,q,V){const J=Math.min(13,we.length);for(;Fe<J;Fe++){const X=ce(we,Pe,Fe,ze,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,V]}function T(we){if(typeof we>"u")return[];const Pe=[],Fe=we[1];for(let ze=we.length-1;ze>1;ze--){const q=we[ze]+Fe,V=Pe[Pe.length-1];V&&V.end===q?V.end=q+1:Pe.push({start:q,end:q+1})}return Pe}const j=128;function N(){const we=[],Pe=[];for(let Fe=0;Fe<=j;Fe++)Pe[Fe]=0;for(let Fe=0;Fe<=j;Fe++)we.push(Pe.slice(0));return we}function F(we){const Pe=[];for(let Fe=0;Fe<=we;Fe++)Pe[Fe]=0;return Pe}const K=F(2*j),ee=F(2*j),Y=N(),Q=N(),Z=N(),ae=!1;function _(we,Pe,Fe,ze,q){function V(X,me,ve=" "){for(;X.length<me;)X=ve+X;return X}let J=` |   |${ze.split("").map(X=>V(X,3)).join("|")}
`;for(let X=0;X<=Fe;X++)X===0?J+=" |":J+=`${Pe[X-1]}|`,J+=we[X].slice(0,q+1).map(me=>V(me.toString(),3)).join("|")+`
`;return J}function ge(we,Pe,Fe,ze){we=we.substr(Pe),Fe=Fe.substr(ze),console.log(_(Q,we,we.length,Fe,Fe.length)),console.log(_(Z,we,we.length,Fe,Fe.length)),console.log(_(Y,we,we.length,Fe,Fe.length))}function se(we,Pe){if(Pe<0||Pe>=we.length)return!1;const Fe=we.codePointAt(Pe);switch(Fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Df(Fe)}}function re(we,Pe){if(Pe<0||Pe>=we.length)return!1;switch(we.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(we,Pe,Fe){return Pe[we]!==Fe[we]}function ie(we,Pe,Fe,ze,q,V,J=!1){for(;Pe<Fe&&q<V;)we[Pe]===ze[q]&&(J&&(K[Pe]=q),Pe+=1),q+=1;return Pe===Fe}var ye;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var le;(function(we){we.Default=[-100,0];function Pe(Fe){return!Fe||Fe.length===2&&Fe[0]===-100&&Fe[1]===0}we.isDefault=Pe})(le||(e.FuzzyScore=le={}));class ue{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Fe){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Fe}}e.$tk=ue;function ce(we,Pe,Fe,ze,q,V,J=ue.default){const X=we.length>j?j:we.length,me=ze.length>j?j:ze.length;if(Fe>=X||V>=me||X-Fe>me-V||!ie(Pe,Fe,X,q,V,me,!0))return;de(X,me,Fe,V,Pe,q);let ve=1,Te=1,He=Fe,Ze=V;const tt=[!1];for(ve=1,He=Fe;He<X;ve++,He++){const Be=K[He],Me=ee[He],Ke=He+1<X?ee[He+1]:me;for(Te=Be-V+1,Ze=Be;Ze<Ke;Te++,Ze++){let ne=Number.MIN_SAFE_INTEGER,oe=!1;Ze<=Me&&(ne=H(we,Pe,He,Fe,ze,q,Ze,me,V,Y[ve-1][Te-1]===0,tt));let Ie=0;ne!==Number.MAX_SAFE_INTEGER&&(oe=!0,Ie=ne+Q[ve-1][Te-1]);const Ge=Ze>Be,xe=Ge?Q[ve][Te-1]+(Y[ve][Te-1]>0?-5:0):0,st=Ze>Be+1&&Y[ve][Te-1]>0,Le=st?Q[ve][Te-2]+(Y[ve][Te-2]>0?-5:0):0;if(st&&(!Ge||Le>=xe)&&(!oe||Le>=Ie))Q[ve][Te]=Le,Z[ve][Te]=3,Y[ve][Te]=0;else if(Ge&&(!oe||xe>=Ie))Q[ve][Te]=xe,Z[ve][Te]=2,Y[ve][Te]=0;else if(oe)Q[ve][Te]=Ie,Z[ve][Te]=1,Y[ve][Te]=Y[ve-1][Te-1]+1;else throw new Error("not possible")}}if(ae&&ge(we,Fe,ze,V),!tt[0]&&!J.firstMatchCanBeWeak)return;ve--,Te--;const nt=[Q[ve][Te],V];let at=0,rt=0;for(;ve>=1;){let Be=Te;do{const Me=Z[ve][Be];if(Me===3)Be=Be-2;else if(Me===2)Be=Be-1;else break}while(Be>=1);at>1&&Pe[Fe+ve-1]===q[V+Te-1]&&!U(Be+V-1,ze,q)&&at+1>Y[ve][Be]&&(Be=Te),Be===Te?at++:at=1,rt||(rt=Be),ve--,Te=Be-1,nt.push(Te)}me===X&&J.boostFullMatch&&(nt[0]+=2);const Ce=rt-X;return nt[0]-=Ce,nt}function de(we,Pe,Fe,ze,q,V){let J=we-1,X=Pe-1;for(;J>=Fe&&X>=ze;)q[J]===V[X]&&(ee[J]=X,J--),X--}function H(we,Pe,Fe,ze,q,V,J,X,me,ve,Te){if(Pe[Fe]!==V[J])return Number.MIN_SAFE_INTEGER;let He=1,Ze=!1;return J===Fe-ze?He=we[Fe]===q[J]?7:5:U(J,q,V)&&(J===0||!U(J-1,q,V))?(He=we[Fe]===q[J]?7:5,Ze=!0):se(V,J)&&(J===0||!se(V,J-1))?He=5:(se(V,J-1)||re(V,J-1))&&(He=5,Ze=!0),He>1&&Fe===ze&&(Te[0]=!0),Ze||(Ze=U(J,q,V)||se(V,J-1)||re(V,J-1)),Fe===ze?J>me&&(He-=Ze?3:5):ve?He+=Ze?2:0:He+=Ze?0:1,J+1===X&&(He-=Ze?3:5),He}function x(we,Pe,Fe,ze,q,V,J){return pe(we,Pe,Fe,ze,q,V,!0,J)}function he(we,Pe,Fe,ze,q,V,J){return pe(we,Pe,Fe,ze,q,V,!1,J)}function pe(we,Pe,Fe,ze,q,V,J,X){let me=ce(we,Pe,Fe,ze,q,V,X);if(me&&!J)return me;if(we.length>=3){const ve=Math.min(7,we.length-1);for(let Te=Fe+1;Te<ve;Te++){const He=Ae(we,Te);if(He){const Ze=ce(He,He.toLowerCase(),Fe,ze,q,V,X);Ze&&(Ze[0]-=3,(!me||Ze[0]>me[0])&&(me=Ze))}}}return me}function Ae(we,Pe){if(Pe+1>=we.length)return;const Fe=we[Pe],ze=we[Pe+1];if(Fe!==ze)return we.slice(0,Pe)+ze+Fe+we.slice(Pe+2)}}),define(Se[54],De([1,0,14]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$$i=void 0,e.$7i=L,e.$8i=M,e.$9i=A,e.$0i=b,e.$_i=h;function L(c){return M(c,0)}function M(c,n){switch(typeof c){case"object":return c===null?A(349,n):Array.isArray(c)?p(c,n):E(c,n);case"string":return b(c,n);case"boolean":return P(c,n);case"number":return A(c,n);case"undefined":return A(937,n);default:return A(617,n)}}function A(c,n){return(n<<5)-n+c|0}function P(c,n){return A(c?433:863,n)}function b(c,n){n=A(149417,n);for(let i=0,r=c.length;i<r;i++)n=A(c.charCodeAt(i),n);return n}function p(c,n){return n=A(104579,n),c.reduce((i,r)=>M(r,i),n)}function E(c,n){return n=A(181387,n),Object.keys(c).sort().reduce((i,r)=>(i=b(r,i),M(c[r],i)),n)}class R{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=M(n,this.g),this.g}}e.$$i=R;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(c,n,i=32){const r=i-n,a=~((1<<r)-1);return(c<<n|(a&c)>>>r)>>>0}function S(c,n=0,i=c.byteLength,r=0){for(let a=0;a<i;a++)c[n+a]=r}function y(c,n,i="0"){for(;c.length<n;)c=i+c;return c}function h(c,n=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(i=>i.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),n/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let a=this.r,t=this.u,f,l;for(t!==0?(f=t,l=-1,t=0):(f=n.charCodeAt(0),l=0);;){let s=f;if(u.$of(f))if(l+1<i){const o=n.charCodeAt(l+1);u.$pf(o)?(l++,s=u.$qf(f,o)):s=65533}else{t=f;break}else u.$pf(f)&&(s=65533);if(a=this.w(r,a,s),l++,l<i)f=n.charCodeAt(l);else break}this.r=a,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=g.g,i=this.q;for(let m=0;m<64;m+=4)n.setUint32(m,i.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)n.setUint32(m,w(n.getUint32(m-12,!1)^n.getUint32(m-32,!1)^n.getUint32(m-56,!1)^n.getUint32(m-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,f=this.n,l=this.o,s,o,d;for(let m=0;m<80;m++)m<20?(s=a&t|~a&f,o=1518500249):m<40?(s=a^t^f,o=1859775393):m<60?(s=a&t|a&f|t&f,o=2400959708):(s=a^t^f,o=3395469782),d=w(r,5)+s+l+o+n.getUint32(m*4,!1)&4294967295,l=f,f=t,t=w(a,30),a=r,r=d;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+l&4294967295}}e.$aj=g}),define(Se[39],De([1,0,14]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(L||(L={})),function(M){const A="error",P="warning",b="warn",p="info",E="ignore";function R(w){return w?u.$kf(A,w)?M.Error:u.$kf(P,w)||u.$kf(b,w)?M.Warning:u.$kf(p,w)?M.Info:M.Ignore:M.Ignore}M.fromValue=R;function I(w){switch(w){case M.Error:return A;case M.Warning:return P;case M.Info:return p;default:return E}}M.toString=I}(L||(L={})),e.default=L}),define(Se[167],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(Se[76],De([1,0,19,14]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class M{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const y=S.charCodeAt(0),h=this.b.charCodeAt(this.c);return y-h}value(){return this.b[this.c]}}e.$ii=M;class A{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,L.$ef)(S,this.b,0,S.length,this.c,this.d):(0,L.$gf)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=A;class P{constructor(S=!0,y=!0){this.f=S,this.g=y}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let y=S.length-1;y>=0;y--,this.c--){const h=this.b.charCodeAt(y);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,L.$ef)(S,this.b,0,S.length,this.d,this.e):(0,L.$gf)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=P;var b;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(S,y){this.f=S,this.g=y,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,L.$ff)(S,this.c.scheme);if(this.d[this.e]===2)return(0,L.$ff)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,L.$df)(S,this.c.query);if(this.d[this.e]===5)return(0,L.$df)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=p;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(R||(R={}));class I{static forUris(S=()=>!1,y=()=>!1){return new I(new p(S,y))}static forPaths(S=!1){return new I(new P(void 0,!S))}static forStrings(){return new I(new M)}static forConfigKeys(){return new I(new A)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,y){if(y){const h=y.slice(0);(0,u.$Xb)(h);for(const g of h)this.set(g,S)}else{const h=S.slice(0);(0,u.$Xb)(h);for(const g of h)this.set(g[0],g[1])}}set(S,y){const h=this.b.reset(S);let g;this.c||(this.c=new E,this.c.segment=h.value());const c=[];for(g=this.c;;){const i=h.cmp(g.segment);if(i>0)g.left||(g.left=new E,g.left.segment=h.value()),c.push([-1,g]),g=g.left;else if(i<0)g.right||(g.right=new E,g.right.segment=h.value()),c.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new E,g.mid.segment=h.value()),c.push([0,g]),g=g.mid;else break}const n=g.value;g.value=y,g.key=S;for(let i=c.length-1;i>=0;i--){const r=c[i][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=c[i][0],f=c[i+1][0];if(t===1&&f===1)c[i][1]=r.rotateLeft();else if(t===-1&&f===-1)c[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=c[i+1][1]=c[i+1][1].rotateRight(),c[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=c[i+1][1]=c[i+1][1].rotateLeft(),c[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}return n}get(S){return this.d(S)?.value}d(S){const y=this.b.reset(S);let h=this.c;for(;h;){const g=y.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(y.hasNext())y.next(),h=h.mid;else break}return h}has(S){const y=this.d(S);return!(y?.value===void 0&&y?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,y){const h=this.b.reset(S),g=[];let c=this.c;for(;c;){const n=h.cmp(c.segment);if(n>0)g.push([-1,c]),c=c.left;else if(n<0)g.push([1,c]),c=c.right;else if(h.hasNext())h.next(),g.push([0,c]),c=c.mid;else break}if(c){if(y?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const n=this.f(c.right);if(n.key){const{key:i,value:r,segment:a}=n;this.e(n.key,!1),c.key=i,c.value=r,c.segment=a}}else{const n=c.left??c.right;if(g.length>0){const[i,r]=g[g.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const i=g[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),g[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),g[n][1]=i.rotateRight()),n>0)switch(g[n-1][0]){case-1:g[n-1][1].left=g[n][1];break;case 1:g[n-1][1].right=g[n][1];break;case 0:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const y=this.b.reset(S);let h=this.c,g;for(;h;){const c=y.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(y.hasNext())y.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(S){return this.g(S,!1)}g(S,y){const h=this.b.reset(S);let g=this.c;for(;g;){const c=h.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else return g.mid?this.h(g.mid):y?g.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[y,h]of this)S(h,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const y=[];return this.j(S,y),y[Symbol.iterator]()}j(S,y){S&&(S.left&&this.j(S.left,y),S.value&&y.push([S.key,S.value]),S.mid&&this.j(S.mid,y),S.right&&this.j(S.right,y))}_isBalanced(){const S=y=>{if(!y)return!0;const h=y.balanceFactor();return h<-1||h>1?!1:S(y.left)&&S(y.right)};return S(this.c)}}e.$mi=I}),define(Se[18],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=u,e.$Uf=L,e.$Vf=M,e.$Wf=A,e.$Xf=P,e.$Yf=b,e.$Zf=p,e.$1f=E,e.$2f=R,e.$3f=I,e.$4f=w,e.$5f=S,e.$6f=y,e.$7f=g,e.$8f=c,e.$9f=n,e.$0f=i,e.$$f=r;function u(a){return typeof a=="string"}function L(a){return Array.isArray(a)&&a.every(t=>u(t))}function M(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function P(a){return typeof a=="number"&&!isNaN(a)}function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}function p(a){return a===!0||a===!1}function E(a){return typeof a>"u"}function R(a){return!I(a)}function I(a){return E(a)||a===null}function w(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function S(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function y(...a){const t=[];for(let f=0;f<a.length;f++){const l=a[f];if(I(l))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(l)}return t}const h=Object.prototype.hasOwnProperty;function g(a){if(!M(a))return!1;for(const t in a)if(h.call(a,t))return!1;return!0}function c(a){return typeof a=="function"}function n(...a){return a.length>0&&a.every(c)}function i(a,t){const f=Math.min(a.length,t.length);for(let l=0;l<f;l++)r(a[l],t[l])}function r(a,t){if(u(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[99],De([1,0,18]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=M,e.$Bj=A;const L=Object.create(null);function M(P,b){if((0,u.$Tf)(b)){const p=L[b];if(p===void 0)throw new Error(`${P} references an unknown codicon: ${b}`);b=p}return L[P]=b,{id:P}}function A(){return L}}),define(Se[168],De([1,0,99]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=void 0,e.$Cj={add:(0,u.$Aj)("add",6e4),plus:(0,u.$Aj)("plus",6e4),gistNew:(0,u.$Aj)("gist-new",6e4),repoCreate:(0,u.$Aj)("repo-create",6e4),lightbulb:(0,u.$Aj)("lightbulb",60001),lightBulb:(0,u.$Aj)("light-bulb",60001),repo:(0,u.$Aj)("repo",60002),repoDelete:(0,u.$Aj)("repo-delete",60002),gistFork:(0,u.$Aj)("gist-fork",60003),repoForked:(0,u.$Aj)("repo-forked",60003),gitPullRequest:(0,u.$Aj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Aj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Aj)("record-keys",60005),keyboard:(0,u.$Aj)("keyboard",60005),tag:(0,u.$Aj)("tag",60006),gitPullRequestLabel:(0,u.$Aj)("git-pull-request-label",60006),tagAdd:(0,u.$Aj)("tag-add",60006),tagRemove:(0,u.$Aj)("tag-remove",60006),person:(0,u.$Aj)("person",60007),personFollow:(0,u.$Aj)("person-follow",60007),personOutline:(0,u.$Aj)("person-outline",60007),personFilled:(0,u.$Aj)("person-filled",60007),gitBranch:(0,u.$Aj)("git-branch",60008),gitBranchCreate:(0,u.$Aj)("git-branch-create",60008),gitBranchDelete:(0,u.$Aj)("git-branch-delete",60008),sourceControl:(0,u.$Aj)("source-control",60008),mirror:(0,u.$Aj)("mirror",60009),mirrorPublic:(0,u.$Aj)("mirror-public",60009),star:(0,u.$Aj)("star",60010),starAdd:(0,u.$Aj)("star-add",60010),starDelete:(0,u.$Aj)("star-delete",60010),starEmpty:(0,u.$Aj)("star-empty",60010),comment:(0,u.$Aj)("comment",60011),commentAdd:(0,u.$Aj)("comment-add",60011),alert:(0,u.$Aj)("alert",60012),warning:(0,u.$Aj)("warning",60012),search:(0,u.$Aj)("search",60013),searchSave:(0,u.$Aj)("search-save",60013),logOut:(0,u.$Aj)("log-out",60014),signOut:(0,u.$Aj)("sign-out",60014),logIn:(0,u.$Aj)("log-in",60015),signIn:(0,u.$Aj)("sign-in",60015),eye:(0,u.$Aj)("eye",60016),eyeUnwatch:(0,u.$Aj)("eye-unwatch",60016),eyeWatch:(0,u.$Aj)("eye-watch",60016),circleFilled:(0,u.$Aj)("circle-filled",60017),primitiveDot:(0,u.$Aj)("primitive-dot",60017),closeDirty:(0,u.$Aj)("close-dirty",60017),debugBreakpoint:(0,u.$Aj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Aj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Aj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Aj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Aj)("primitive-square",60018),edit:(0,u.$Aj)("edit",60019),pencil:(0,u.$Aj)("pencil",60019),info:(0,u.$Aj)("info",60020),issueOpened:(0,u.$Aj)("issue-opened",60020),gistPrivate:(0,u.$Aj)("gist-private",60021),gitForkPrivate:(0,u.$Aj)("git-fork-private",60021),lock:(0,u.$Aj)("lock",60021),mirrorPrivate:(0,u.$Aj)("mirror-private",60021),close:(0,u.$Aj)("close",60022),removeClose:(0,u.$Aj)("remove-close",60022),x:(0,u.$Aj)("x",60022),repoSync:(0,u.$Aj)("repo-sync",60023),sync:(0,u.$Aj)("sync",60023),clone:(0,u.$Aj)("clone",60024),desktopDownload:(0,u.$Aj)("desktop-download",60024),beaker:(0,u.$Aj)("beaker",60025),microscope:(0,u.$Aj)("microscope",60025),vm:(0,u.$Aj)("vm",60026),deviceDesktop:(0,u.$Aj)("device-desktop",60026),file:(0,u.$Aj)("file",60027),fileText:(0,u.$Aj)("file-text",60027),more:(0,u.$Aj)("more",60028),ellipsis:(0,u.$Aj)("ellipsis",60028),kebabHorizontal:(0,u.$Aj)("kebab-horizontal",60028),mailReply:(0,u.$Aj)("mail-reply",60029),reply:(0,u.$Aj)("reply",60029),organization:(0,u.$Aj)("organization",60030),organizationFilled:(0,u.$Aj)("organization-filled",60030),organizationOutline:(0,u.$Aj)("organization-outline",60030),newFile:(0,u.$Aj)("new-file",60031),fileAdd:(0,u.$Aj)("file-add",60031),newFolder:(0,u.$Aj)("new-folder",60032),fileDirectoryCreate:(0,u.$Aj)("file-directory-create",60032),trash:(0,u.$Aj)("trash",60033),trashcan:(0,u.$Aj)("trashcan",60033),history:(0,u.$Aj)("history",60034),clock:(0,u.$Aj)("clock",60034),folder:(0,u.$Aj)("folder",60035),fileDirectory:(0,u.$Aj)("file-directory",60035),symbolFolder:(0,u.$Aj)("symbol-folder",60035),logoGithub:(0,u.$Aj)("logo-github",60036),markGithub:(0,u.$Aj)("mark-github",60036),github:(0,u.$Aj)("github",60036),terminal:(0,u.$Aj)("terminal",60037),console:(0,u.$Aj)("console",60037),repl:(0,u.$Aj)("repl",60037),zap:(0,u.$Aj)("zap",60038),symbolEvent:(0,u.$Aj)("symbol-event",60038),error:(0,u.$Aj)("error",60039),stop:(0,u.$Aj)("stop",60039),variable:(0,u.$Aj)("variable",60040),symbolVariable:(0,u.$Aj)("symbol-variable",60040),array:(0,u.$Aj)("array",60042),symbolArray:(0,u.$Aj)("symbol-array",60042),symbolModule:(0,u.$Aj)("symbol-module",60043),symbolPackage:(0,u.$Aj)("symbol-package",60043),symbolNamespace:(0,u.$Aj)("symbol-namespace",60043),symbolObject:(0,u.$Aj)("symbol-object",60043),symbolMethod:(0,u.$Aj)("symbol-method",60044),symbolFunction:(0,u.$Aj)("symbol-function",60044),symbolConstructor:(0,u.$Aj)("symbol-constructor",60044),symbolBoolean:(0,u.$Aj)("symbol-boolean",60047),symbolNull:(0,u.$Aj)("symbol-null",60047),symbolNumeric:(0,u.$Aj)("symbol-numeric",60048),symbolNumber:(0,u.$Aj)("symbol-number",60048),symbolStructure:(0,u.$Aj)("symbol-structure",60049),symbolStruct:(0,u.$Aj)("symbol-struct",60049),symbolParameter:(0,u.$Aj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Aj)("symbol-type-parameter",60050),symbolKey:(0,u.$Aj)("symbol-key",60051),symbolText:(0,u.$Aj)("symbol-text",60051),symbolReference:(0,u.$Aj)("symbol-reference",60052),goToFile:(0,u.$Aj)("go-to-file",60052),symbolEnum:(0,u.$Aj)("symbol-enum",60053),symbolValue:(0,u.$Aj)("symbol-value",60053),symbolRuler:(0,u.$Aj)("symbol-ruler",60054),symbolUnit:(0,u.$Aj)("symbol-unit",60054),activateBreakpoints:(0,u.$Aj)("activate-breakpoints",60055),archive:(0,u.$Aj)("archive",60056),arrowBoth:(0,u.$Aj)("arrow-both",60057),arrowDown:(0,u.$Aj)("arrow-down",60058),arrowLeft:(0,u.$Aj)("arrow-left",60059),arrowRight:(0,u.$Aj)("arrow-right",60060),arrowSmallDown:(0,u.$Aj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Aj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Aj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Aj)("arrow-small-up",60064),arrowUp:(0,u.$Aj)("arrow-up",60065),bell:(0,u.$Aj)("bell",60066),bold:(0,u.$Aj)("bold",60067),book:(0,u.$Aj)("book",60068),bookmark:(0,u.$Aj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Aj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Aj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Aj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Aj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Aj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Aj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Aj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Aj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Aj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Aj)("briefcase",60076),broadcast:(0,u.$Aj)("broadcast",60077),browser:(0,u.$Aj)("browser",60078),bug:(0,u.$Aj)("bug",60079),calendar:(0,u.$Aj)("calendar",60080),caseSensitive:(0,u.$Aj)("case-sensitive",60081),check:(0,u.$Aj)("check",60082),checklist:(0,u.$Aj)("checklist",60083),chevronDown:(0,u.$Aj)("chevron-down",60084),chevronLeft:(0,u.$Aj)("chevron-left",60085),chevronRight:(0,u.$Aj)("chevron-right",60086),chevronUp:(0,u.$Aj)("chevron-up",60087),chromeClose:(0,u.$Aj)("chrome-close",60088),chromeMaximize:(0,u.$Aj)("chrome-maximize",60089),chromeMinimize:(0,u.$Aj)("chrome-minimize",60090),chromeRestore:(0,u.$Aj)("chrome-restore",60091),circleOutline:(0,u.$Aj)("circle-outline",60092),circle:(0,u.$Aj)("circle",60092),debugBreakpointUnverified:(0,u.$Aj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Aj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Aj)("circle-slash",60093),circuitBoard:(0,u.$Aj)("circuit-board",60094),clearAll:(0,u.$Aj)("clear-all",60095),clippy:(0,u.$Aj)("clippy",60096),closeAll:(0,u.$Aj)("close-all",60097),cloudDownload:(0,u.$Aj)("cloud-download",60098),cloudUpload:(0,u.$Aj)("cloud-upload",60099),code:(0,u.$Aj)("code",60100),collapseAll:(0,u.$Aj)("collapse-all",60101),colorMode:(0,u.$Aj)("color-mode",60102),commentDiscussion:(0,u.$Aj)("comment-discussion",60103),creditCard:(0,u.$Aj)("credit-card",60105),dash:(0,u.$Aj)("dash",60108),dashboard:(0,u.$Aj)("dashboard",60109),database:(0,u.$Aj)("database",60110),debugContinue:(0,u.$Aj)("debug-continue",60111),debugDisconnect:(0,u.$Aj)("debug-disconnect",60112),debugPause:(0,u.$Aj)("debug-pause",60113),debugRestart:(0,u.$Aj)("debug-restart",60114),debugStart:(0,u.$Aj)("debug-start",60115),debugStepInto:(0,u.$Aj)("debug-step-into",60116),debugStepOut:(0,u.$Aj)("debug-step-out",60117),debugStepOver:(0,u.$Aj)("debug-step-over",60118),debugStop:(0,u.$Aj)("debug-stop",60119),debug:(0,u.$Aj)("debug",60120),deviceCameraVideo:(0,u.$Aj)("device-camera-video",60121),deviceCamera:(0,u.$Aj)("device-camera",60122),deviceMobile:(0,u.$Aj)("device-mobile",60123),diffAdded:(0,u.$Aj)("diff-added",60124),diffIgnored:(0,u.$Aj)("diff-ignored",60125),diffModified:(0,u.$Aj)("diff-modified",60126),diffRemoved:(0,u.$Aj)("diff-removed",60127),diffRenamed:(0,u.$Aj)("diff-renamed",60128),diff:(0,u.$Aj)("diff",60129),diffSidebyside:(0,u.$Aj)("diff-sidebyside",60129),discard:(0,u.$Aj)("discard",60130),editorLayout:(0,u.$Aj)("editor-layout",60131),emptyWindow:(0,u.$Aj)("empty-window",60132),exclude:(0,u.$Aj)("exclude",60133),extensions:(0,u.$Aj)("extensions",60134),eyeClosed:(0,u.$Aj)("eye-closed",60135),fileBinary:(0,u.$Aj)("file-binary",60136),fileCode:(0,u.$Aj)("file-code",60137),fileMedia:(0,u.$Aj)("file-media",60138),filePdf:(0,u.$Aj)("file-pdf",60139),fileSubmodule:(0,u.$Aj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Aj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Aj)("file-symlink-file",60142),fileZip:(0,u.$Aj)("file-zip",60143),files:(0,u.$Aj)("files",60144),filter:(0,u.$Aj)("filter",60145),flame:(0,u.$Aj)("flame",60146),foldDown:(0,u.$Aj)("fold-down",60147),foldUp:(0,u.$Aj)("fold-up",60148),fold:(0,u.$Aj)("fold",60149),folderActive:(0,u.$Aj)("folder-active",60150),folderOpened:(0,u.$Aj)("folder-opened",60151),gear:(0,u.$Aj)("gear",60152),gift:(0,u.$Aj)("gift",60153),gistSecret:(0,u.$Aj)("gist-secret",60154),gist:(0,u.$Aj)("gist",60155),gitCommit:(0,u.$Aj)("git-commit",60156),gitCompare:(0,u.$Aj)("git-compare",60157),compareChanges:(0,u.$Aj)("compare-changes",60157),gitMerge:(0,u.$Aj)("git-merge",60158),githubAction:(0,u.$Aj)("github-action",60159),githubAlt:(0,u.$Aj)("github-alt",60160),globe:(0,u.$Aj)("globe",60161),grabber:(0,u.$Aj)("grabber",60162),graph:(0,u.$Aj)("graph",60163),gripper:(0,u.$Aj)("gripper",60164),heart:(0,u.$Aj)("heart",60165),home:(0,u.$Aj)("home",60166),horizontalRule:(0,u.$Aj)("horizontal-rule",60167),hubot:(0,u.$Aj)("hubot",60168),inbox:(0,u.$Aj)("inbox",60169),issueReopened:(0,u.$Aj)("issue-reopened",60171),issues:(0,u.$Aj)("issues",60172),italic:(0,u.$Aj)("italic",60173),jersey:(0,u.$Aj)("jersey",60174),json:(0,u.$Aj)("json",60175),kebabVertical:(0,u.$Aj)("kebab-vertical",60176),key:(0,u.$Aj)("key",60177),law:(0,u.$Aj)("law",60178),lightbulbAutofix:(0,u.$Aj)("lightbulb-autofix",60179),linkExternal:(0,u.$Aj)("link-external",60180),link:(0,u.$Aj)("link",60181),listOrdered:(0,u.$Aj)("list-ordered",60182),listUnordered:(0,u.$Aj)("list-unordered",60183),liveShare:(0,u.$Aj)("live-share",60184),loading:(0,u.$Aj)("loading",60185),location:(0,u.$Aj)("location",60186),mailRead:(0,u.$Aj)("mail-read",60187),mail:(0,u.$Aj)("mail",60188),markdown:(0,u.$Aj)("markdown",60189),megaphone:(0,u.$Aj)("megaphone",60190),mention:(0,u.$Aj)("mention",60191),milestone:(0,u.$Aj)("milestone",60192),gitPullRequestMilestone:(0,u.$Aj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Aj)("mortar-board",60193),move:(0,u.$Aj)("move",60194),multipleWindows:(0,u.$Aj)("multiple-windows",60195),mute:(0,u.$Aj)("mute",60196),noNewline:(0,u.$Aj)("no-newline",60197),note:(0,u.$Aj)("note",60198),octoface:(0,u.$Aj)("octoface",60199),openPreview:(0,u.$Aj)("open-preview",60200),package:(0,u.$Aj)("package",60201),paintcan:(0,u.$Aj)("paintcan",60202),pin:(0,u.$Aj)("pin",60203),play:(0,u.$Aj)("play",60204),run:(0,u.$Aj)("run",60204),plug:(0,u.$Aj)("plug",60205),preserveCase:(0,u.$Aj)("preserve-case",60206),preview:(0,u.$Aj)("preview",60207),project:(0,u.$Aj)("project",60208),pulse:(0,u.$Aj)("pulse",60209),question:(0,u.$Aj)("question",60210),quote:(0,u.$Aj)("quote",60211),radioTower:(0,u.$Aj)("radio-tower",60212),reactions:(0,u.$Aj)("reactions",60213),references:(0,u.$Aj)("references",60214),refresh:(0,u.$Aj)("refresh",60215),regex:(0,u.$Aj)("regex",60216),remoteExplorer:(0,u.$Aj)("remote-explorer",60217),remote:(0,u.$Aj)("remote",60218),remove:(0,u.$Aj)("remove",60219),replaceAll:(0,u.$Aj)("replace-all",60220),replace:(0,u.$Aj)("replace",60221),repoClone:(0,u.$Aj)("repo-clone",60222),repoForcePush:(0,u.$Aj)("repo-force-push",60223),repoPull:(0,u.$Aj)("repo-pull",60224),repoPush:(0,u.$Aj)("repo-push",60225),report:(0,u.$Aj)("report",60226),requestChanges:(0,u.$Aj)("request-changes",60227),rocket:(0,u.$Aj)("rocket",60228),rootFolderOpened:(0,u.$Aj)("root-folder-opened",60229),rootFolder:(0,u.$Aj)("root-folder",60230),rss:(0,u.$Aj)("rss",60231),ruby:(0,u.$Aj)("ruby",60232),saveAll:(0,u.$Aj)("save-all",60233),saveAs:(0,u.$Aj)("save-as",60234),save:(0,u.$Aj)("save",60235),screenFull:(0,u.$Aj)("screen-full",60236),screenNormal:(0,u.$Aj)("screen-normal",60237),searchStop:(0,u.$Aj)("search-stop",60238),server:(0,u.$Aj)("server",60240),settingsGear:(0,u.$Aj)("settings-gear",60241),settings:(0,u.$Aj)("settings",60242),shield:(0,u.$Aj)("shield",60243),smiley:(0,u.$Aj)("smiley",60244),sortPrecedence:(0,u.$Aj)("sort-precedence",60245),splitHorizontal:(0,u.$Aj)("split-horizontal",60246),splitVertical:(0,u.$Aj)("split-vertical",60247),squirrel:(0,u.$Aj)("squirrel",60248),starFull:(0,u.$Aj)("star-full",60249),starHalf:(0,u.$Aj)("star-half",60250),symbolClass:(0,u.$Aj)("symbol-class",60251),symbolColor:(0,u.$Aj)("symbol-color",60252),symbolConstant:(0,u.$Aj)("symbol-constant",60253),symbolEnumMember:(0,u.$Aj)("symbol-enum-member",60254),symbolField:(0,u.$Aj)("symbol-field",60255),symbolFile:(0,u.$Aj)("symbol-file",60256),symbolInterface:(0,u.$Aj)("symbol-interface",60257),symbolKeyword:(0,u.$Aj)("symbol-keyword",60258),symbolMisc:(0,u.$Aj)("symbol-misc",60259),symbolOperator:(0,u.$Aj)("symbol-operator",60260),symbolProperty:(0,u.$Aj)("symbol-property",60261),wrench:(0,u.$Aj)("wrench",60261),wrenchSubaction:(0,u.$Aj)("wrench-subaction",60261),symbolSnippet:(0,u.$Aj)("symbol-snippet",60262),tasklist:(0,u.$Aj)("tasklist",60263),telescope:(0,u.$Aj)("telescope",60264),textSize:(0,u.$Aj)("text-size",60265),threeBars:(0,u.$Aj)("three-bars",60266),thumbsdown:(0,u.$Aj)("thumbsdown",60267),thumbsup:(0,u.$Aj)("thumbsup",60268),tools:(0,u.$Aj)("tools",60269),triangleDown:(0,u.$Aj)("triangle-down",60270),triangleLeft:(0,u.$Aj)("triangle-left",60271),triangleRight:(0,u.$Aj)("triangle-right",60272),triangleUp:(0,u.$Aj)("triangle-up",60273),twitter:(0,u.$Aj)("twitter",60274),unfold:(0,u.$Aj)("unfold",60275),unlock:(0,u.$Aj)("unlock",60276),unmute:(0,u.$Aj)("unmute",60277),unverified:(0,u.$Aj)("unverified",60278),verified:(0,u.$Aj)("verified",60279),versions:(0,u.$Aj)("versions",60280),vmActive:(0,u.$Aj)("vm-active",60281),vmOutline:(0,u.$Aj)("vm-outline",60282),vmRunning:(0,u.$Aj)("vm-running",60283),watch:(0,u.$Aj)("watch",60284),whitespace:(0,u.$Aj)("whitespace",60285),wholeWord:(0,u.$Aj)("whole-word",60286),window:(0,u.$Aj)("window",60287),wordWrap:(0,u.$Aj)("word-wrap",60288),zoomIn:(0,u.$Aj)("zoom-in",60289),zoomOut:(0,u.$Aj)("zoom-out",60290),listFilter:(0,u.$Aj)("list-filter",60291),listFlat:(0,u.$Aj)("list-flat",60292),listSelection:(0,u.$Aj)("list-selection",60293),selection:(0,u.$Aj)("selection",60293),listTree:(0,u.$Aj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Aj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Aj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Aj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Aj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Aj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Aj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Aj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Aj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Aj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Aj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Aj)("symbol-string",60301),debugReverseContinue:(0,u.$Aj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Aj)("debug-step-back",60303),debugRestartFrame:(0,u.$Aj)("debug-restart-frame",60304),debugAlt:(0,u.$Aj)("debug-alt",60305),callIncoming:(0,u.$Aj)("call-incoming",60306),callOutgoing:(0,u.$Aj)("call-outgoing",60307),menu:(0,u.$Aj)("menu",60308),expandAll:(0,u.$Aj)("expand-all",60309),feedback:(0,u.$Aj)("feedback",60310),gitPullRequestReviewer:(0,u.$Aj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Aj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Aj)("ungroup-by-ref-type",60312),account:(0,u.$Aj)("account",60313),gitPullRequestAssignee:(0,u.$Aj)("git-pull-request-assignee",60313),bellDot:(0,u.$Aj)("bell-dot",60314),debugConsole:(0,u.$Aj)("debug-console",60315),library:(0,u.$Aj)("library",60316),output:(0,u.$Aj)("output",60317),runAll:(0,u.$Aj)("run-all",60318),syncIgnored:(0,u.$Aj)("sync-ignored",60319),pinned:(0,u.$Aj)("pinned",60320),githubInverted:(0,u.$Aj)("github-inverted",60321),serverProcess:(0,u.$Aj)("server-process",60322),serverEnvironment:(0,u.$Aj)("server-environment",60323),pass:(0,u.$Aj)("pass",60324),issueClosed:(0,u.$Aj)("issue-closed",60324),stopCircle:(0,u.$Aj)("stop-circle",60325),playCircle:(0,u.$Aj)("play-circle",60326),record:(0,u.$Aj)("record",60327),debugAltSmall:(0,u.$Aj)("debug-alt-small",60328),vmConnect:(0,u.$Aj)("vm-connect",60329),cloud:(0,u.$Aj)("cloud",60330),merge:(0,u.$Aj)("merge",60331),export:(0,u.$Aj)("export",60332),graphLeft:(0,u.$Aj)("graph-left",60333),magnet:(0,u.$Aj)("magnet",60334),notebook:(0,u.$Aj)("notebook",60335),redo:(0,u.$Aj)("redo",60336),checkAll:(0,u.$Aj)("check-all",60337),pinnedDirty:(0,u.$Aj)("pinned-dirty",60338),passFilled:(0,u.$Aj)("pass-filled",60339),circleLargeFilled:(0,u.$Aj)("circle-large-filled",60340),circleLarge:(0,u.$Aj)("circle-large",60341),circleLargeOutline:(0,u.$Aj)("circle-large-outline",60341),combine:(0,u.$Aj)("combine",60342),gather:(0,u.$Aj)("gather",60342),table:(0,u.$Aj)("table",60343),variableGroup:(0,u.$Aj)("variable-group",60344),typeHierarchy:(0,u.$Aj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Aj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Aj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Aj)("git-pull-request-create",60348),runAbove:(0,u.$Aj)("run-above",60349),runBelow:(0,u.$Aj)("run-below",60350),notebookTemplate:(0,u.$Aj)("notebook-template",60351),debugRerun:(0,u.$Aj)("debug-rerun",60352),workspaceTrusted:(0,u.$Aj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Aj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Aj)("workspace-unknown",60355),terminalCmd:(0,u.$Aj)("terminal-cmd",60356),terminalDebian:(0,u.$Aj)("terminal-debian",60357),terminalLinux:(0,u.$Aj)("terminal-linux",60358),terminalPowershell:(0,u.$Aj)("terminal-powershell",60359),terminalTmux:(0,u.$Aj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Aj)("terminal-ubuntu",60361),terminalBash:(0,u.$Aj)("terminal-bash",60362),arrowSwap:(0,u.$Aj)("arrow-swap",60363),copy:(0,u.$Aj)("copy",60364),personAdd:(0,u.$Aj)("person-add",60365),filterFilled:(0,u.$Aj)("filter-filled",60366),wand:(0,u.$Aj)("wand",60367),debugLineByLine:(0,u.$Aj)("debug-line-by-line",60368),inspect:(0,u.$Aj)("inspect",60369),layers:(0,u.$Aj)("layers",60370),layersDot:(0,u.$Aj)("layers-dot",60371),layersActive:(0,u.$Aj)("layers-active",60372),compass:(0,u.$Aj)("compass",60373),compassDot:(0,u.$Aj)("compass-dot",60374),compassActive:(0,u.$Aj)("compass-active",60375),azure:(0,u.$Aj)("azure",60376),issueDraft:(0,u.$Aj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Aj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Aj)("git-pull-request-draft",60379),debugAll:(0,u.$Aj)("debug-all",60380),debugCoverage:(0,u.$Aj)("debug-coverage",60381),runErrors:(0,u.$Aj)("run-errors",60382),folderLibrary:(0,u.$Aj)("folder-library",60383),debugContinueSmall:(0,u.$Aj)("debug-continue-small",60384),beakerStop:(0,u.$Aj)("beaker-stop",60385),graphLine:(0,u.$Aj)("graph-line",60386),graphScatter:(0,u.$Aj)("graph-scatter",60387),pieChart:(0,u.$Aj)("pie-chart",60388),bracket:(0,u.$Aj)("bracket",60175),bracketDot:(0,u.$Aj)("bracket-dot",60389),bracketError:(0,u.$Aj)("bracket-error",60390),lockSmall:(0,u.$Aj)("lock-small",60391),azureDevops:(0,u.$Aj)("azure-devops",60392),verifiedFilled:(0,u.$Aj)("verified-filled",60393),newline:(0,u.$Aj)("newline",60394),layout:(0,u.$Aj)("layout",60395),layoutActivitybarLeft:(0,u.$Aj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Aj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Aj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Aj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Aj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Aj)("layout-panel-right",60401),layoutPanel:(0,u.$Aj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Aj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Aj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Aj)("layout-statusbar",60405),layoutMenubar:(0,u.$Aj)("layout-menubar",60406),layoutCentered:(0,u.$Aj)("layout-centered",60407),target:(0,u.$Aj)("target",60408),indent:(0,u.$Aj)("indent",60409),recordSmall:(0,u.$Aj)("record-small",60410),errorSmall:(0,u.$Aj)("error-small",60411),terminalDecorationError:(0,u.$Aj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Aj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Aj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Aj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Aj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Aj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Aj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Aj)("layout-sidebar-left-off",60418),blank:(0,u.$Aj)("blank",60419),heartFilled:(0,u.$Aj)("heart-filled",60420),map:(0,u.$Aj)("map",60421),mapFilled:(0,u.$Aj)("map-filled",60422),circleSmall:(0,u.$Aj)("circle-small",60423),bellSlash:(0,u.$Aj)("bell-slash",60424),bellSlashDot:(0,u.$Aj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Aj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Aj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Aj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Aj)("search-fuzzy",60429),commentDraft:(0,u.$Aj)("comment-draft",60430),send:(0,u.$Aj)("send",60431),sparkle:(0,u.$Aj)("sparkle",60432),insert:(0,u.$Aj)("insert",60433),mic:(0,u.$Aj)("mic",60434),thumbsdownFilled:(0,u.$Aj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Aj)("thumbsup-filled",60436),coffee:(0,u.$Aj)("coffee",60437),snake:(0,u.$Aj)("snake",60438),game:(0,u.$Aj)("game",60439),vr:(0,u.$Aj)("vr",60440),chip:(0,u.$Aj)("chip",60441),piano:(0,u.$Aj)("piano",60442),music:(0,u.$Aj)("music",60443),micFilled:(0,u.$Aj)("mic-filled",60444),repoFetch:(0,u.$Aj)("repo-fetch",60445),copilot:(0,u.$Aj)("copilot",60446),lightbulbSparkle:(0,u.$Aj)("lightbulb-sparkle",60447),robot:(0,u.$Aj)("robot",60448),sparkleFilled:(0,u.$Aj)("sparkle-filled",60449),diffSingle:(0,u.$Aj)("diff-single",60450),diffMultiple:(0,u.$Aj)("diff-multiple",60451),surroundWith:(0,u.$Aj)("surround-with",60452),share:(0,u.$Aj)("share",60453),gitStash:(0,u.$Aj)("git-stash",60454),gitStashApply:(0,u.$Aj)("git-stash-apply",60455),gitStashPop:(0,u.$Aj)("git-stash-pop",60456),vscode:(0,u.$Aj)("vscode",60457),vscodeInsiders:(0,u.$Aj)("vscode-insiders",60458),codeOss:(0,u.$Aj)("code-oss",60459),runCoverage:(0,u.$Aj)("run-coverage",60460),runAllCoverage:(0,u.$Aj)("run-all-coverage",60461),coverage:(0,u.$Aj)("coverage",60462),githubProject:(0,u.$Aj)("github-project",60463)}}),define(Se[77],De([1,0,99,168]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Dj=M;function M(){return Object.values(e.$Fj)}e.$Ej={dialogError:(0,u.$Aj)("dialog-error","error"),dialogWarning:(0,u.$Aj)("dialog-warning","warning"),dialogInfo:(0,u.$Aj)("dialog-info","info"),dialogClose:(0,u.$Aj)("dialog-close","close"),treeItemExpanded:(0,u.$Aj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Aj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Aj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Aj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Aj)("tree-item-loading","loading"),menuSelection:(0,u.$Aj)("menu-selection","check"),menuSubmenu:(0,u.$Aj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Aj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Aj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Aj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Aj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Aj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Aj)("toolbar-more","more"),quickInputBack:(0,u.$Aj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Aj)("drop-down-button",60084),symbolCustomColor:(0,u.$Aj)("symbol-customcolor",60252),exportIcon:(0,u.$Aj)("export",60332),workspaceUnspecified:(0,u.$Aj)("workspace-unspecified",60355),newLine:(0,u.$Aj)("newline",60394),thumbsDownFilled:(0,u.$Aj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Aj)("thumbsup-filled",60436),gitFetch:(0,u.$Aj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Aj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Aj)("debug-breakpoint-pending",60377)},e.$Fj={...L.$Cj,...e.$Ej}}),define(Se[24],De([1,0,18]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=L,e.$Nn=M,e.$On=P,e.$Pn=p,e.$Qn=E,e.$Rn=R,e.$Sn=I,e.$Tn=w,e.$Un=S,e.$Vn=y,e.$Wn=h,e.$Xn=g;function L(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const n=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?L(r):r}),n}function M(c){if(!c||typeof c!="object")return c;const n=[c];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(A.call(i,r)){const a=i[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,u.$Wf)(a)&&n.push(a)}}return c}const A=Object.prototype.hasOwnProperty;function P(c,n){return b(c,n,new Set)}function b(c,n,i){if((0,u.$3f)(c))return c;const r=n(c);if(typeof r<"u")return r;if(Array.isArray(c)){const a=[];for(const t of c)a.push(b(t,n,i));return a}if((0,u.$Vf)(c)){if(i.has(c))throw new Error("Cannot clone recursive data-structure");i.add(c);const a={};for(const t in c)A.call(c,t)&&(a[t]=b(c[t],n,i));return i.delete(c),a}return c}function p(c,n,i=!0){return(0,u.$Vf)(c)?((0,u.$Vf)(n)&&Object.keys(n).forEach(r=>{r in c?i&&((0,u.$Vf)(c[r])&&(0,u.$Vf)(n[r])?p(c[r],n[r],i):c[r]=n[r]):c[r]=n[r]}),c):n}function E(c,n){if(c===n)return!0;if(c==null||n===null||n===void 0||typeof c!=typeof n||typeof c!="object"||Array.isArray(c)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(c)){if(c.length!==n.length)return!1;for(i=0;i<c.length;i++)if(!E(c[i],n[i]))return!1}else{const a=[];for(r in c)a.push(r);a.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!E(a,t))return!1;for(i=0;i<a.length;i++)if(!E(c[a[i]],n[a[i]]))return!1}return!0}function R(c){const n=new Set;return JSON.stringify(c,(i,r)=>{if((0,u.$Vf)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function I(c,n){const i=Object.create(null);return!c||!n||Object.keys(n).forEach(a=>{const t=c[a],f=n[a];E(t,f)||(i[a]=f)}),i}function w(c,n){const i=n.toLowerCase(),r=Object.keys(c).find(a=>a.toLowerCase()===i);return r?c[r]:c[n]}function S(c,n){const i=Object.create(null);for(const[r,a]of Object.entries(c))n(r,a)&&(i[r]=a);return i}function y(c){let n=[];for(;Object.prototype!==c;)n=n.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return n}function h(c){const n=[];for(const i of y(c))typeof c[i]=="function"&&n.push(i);return n}function g(c,n){const i=a=>function(){const t=Array.prototype.slice.call(arguments,0);return n(a,t)},r={};for(const a of c)r[a]=i(a);return r}}),define(Se[55],De([1,0,77]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Gj=M;var L;(function(P){function b(p){return p&&typeof p=="object"&&typeof p.id=="string"}P.isThemeColor=b})(L||(e.ThemeColor=L={}));function M(P){return{id:P}}var A;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function p(n){const i=b.exec(n.id);if(!i)return p(u.$Fj.error);const[,r,a]=i,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}P.asClassNameArray=p;function E(n){return p(n).join(" ")}P.asClassName=E;function R(n){return"."+p(n).join(".")}P.asCSSSelector=R;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}P.isThemeIcon=I;const w=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function S(n){const i=w.exec(n);if(!i)return;const[,r]=i;return{id:r}}P.fromString=S;function y(n){return{id:n}}P.fromId=y;function h(n,i){let r=n.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),i&&(r=`${r}~${i}`),{id:r}}P.modify=h;function g(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}P.getModifier=g;function c(n,i){return n.id===i.id&&n.color?.id===i.color?.id}P.isEqual=c})(A||(e.ThemeIcon=A={}))}),define(Se[169],De([1,0,126,14,55]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=p,e.$yk=R,e.$zk=w,e.$Ak=S,e.$Bk=h,e.$Ck=g;const A="$(",P=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${P.source}`,"g");function p(c){return c.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${P.source}`,"g");function R(c){return c.replace(E,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function w(c){return c.indexOf(A)===-1?c:c.replace(I,(n,i,r,a)=>r?n:i||a||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const y=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(c){y.lastIndex=0;let n="";const i=[];let r=0;for(;;){const a=y.lastIndex,t=y.exec(c),f=c.substring(a,t?.index);if(f.length>0){n+=f;for(let l=0;l<f.length;l++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function g(c,n,i=!1){const{text:r,iconOffsets:a}=n;if(!a||a.length===0)return(0,u.$ok)(c,r,i);const t=(0,L.$4e)(r," "),f=r.length-t.length,l=(0,u.$ok)(c,t,i);if(l)for(const s of l){const o=a[s.start+f]+f;s.start+=o,s.end+=o}return l}}),define(Se[127],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Re=L,e.$Se=M;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function L(A){return A<0?0:A>255?255:A|0}function M(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(Se[30],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=void 0,e.$Bg=L;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(M){return u.test(M)}e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(b){for(let p=0;p<b.length;p++)b[p]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),P=[];for(let b=0;b<256;b++)P.push(b.toString(16).padStart(2,"0"));return function(){M(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let p=0,E="";return E+=P[A[p++]],E+=P[A[p++]],E+=P[A[p++]],E+=P[A[p++]],E+="-",E+=P[A[p++]],E+=P[A[p++]],E+="-",E+=P[A[p++]],E+=P[A[p++]],E+="-",E+=P[A[p++]],E+=P[A[p++]],E+="-",E+=P[A[p++]],E+=P[A[p++]],E+=P[A[p++]],E+=P[A[p++]],E+=P[A[p++]],E+=P[A[p++]],E}}()}),define(Se[170],De([1,0,19,48,30]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Ft=void 0,e.$Dt=A,e.$Et=P,e.$Gt=E;function A(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function P(I,w,S){const y={id:(0,M.$Cg)(),name:I,uri:w,data:S};return{asString:async()=>"",asFile:()=>y,value:void 0}}class b{constructor(){this.a=new Map}get size(){let w=0;for(const S of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const S=[...this.a.keys()];return L.Iterable.some(this,([y,h])=>h.asFile())&&S.push("files"),R(p(w),S)}get(w){return this.a.get(this.b(w))?.[0]}append(w,S){const y=this.a.get(w);y?y.push(S):this.a.set(this.b(w),[S])}replace(w,S){this.a.set(this.b(w),[S])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,S]of this.a)for(const y of S)yield[w,y]}b(w){return p(w)}}e.$Ft=b;function p(I){return I.toLowerCase()}function E(I,w){return R(p(I),w.map(p))}function R(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[y,h,g]=S;return g==="*"?w.some(c=>c.startsWith(h+"/")):!1}e.$Ht=Object.freeze({create:I=>(0,u.$Mb)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Ht.split(I).filter(w=>!w.startsWith("#"))})}),define(Se[171],De([1,0,62]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=void 0,e.$Eg=L,e.$Gg=A;function L(b,p,E,R=1){let I=!1;return new Promise(w=>{const S=setTimeout(()=>{if(!I)return I=!0,w(0)},E);M(b,p,R,y=>{if(!I)return I=!0,clearTimeout(S),w(y)})})}function M(b,p,E,R){if(p===0)return R(0);const I=new u.Socket;I.once("connect",()=>(P(I),M(b+E,p-1,E,R))),I.once("data",()=>{}),I.once("error",w=>(P(I),w.code!=="ECONNREFUSED"?M(b+E,p-1,E,R):R(b))),I.connect(b,"127.0.0.1")}e.$Fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(b,p,E,R="127.0.0.1"){let I=!1,w,S=1;const y=u.createServer({pauseOnConnect:!0});function h(g,c){I||(I=!0,y.removeAllListeners(),y.close(),w&&clearTimeout(w),c(g))}return new Promise(g=>{w=setTimeout(()=>{h(0,g)},E),y.on("listening",()=>{h(b,g)}),y.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&S<p?(b++,S++,y.listen(b,R)):h(0,g)}),y.on("close",()=>{h(0,g)}),y.listen(b,R)})}function P(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(p){console.error(p)}}}),define(Se[128],De([1,0,127]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=void 0;class L{constructor(b){const p=(0,u.$Re)(b);this.c=p,this.a=L.d(p),this.b=new Map}static d(b){const p=new Uint8Array(256);return p.fill(b),p}set(b,p){const E=(0,u.$Re)(p);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$vt=L;var M;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(M||(M={}));class A{constructor(){this.a=new L(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$wt=A}),define(Se[172],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=L;var u;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function L(M){let A=0,P=0,b=0,p=0;for(let E=0,R=M.length;E<R;E++){const I=M.charCodeAt(E);I===13?(A===0&&(P=E),A++,E+1<R&&M.charCodeAt(E+1)===10?(p|=2,E++):p|=3,b=E+1):I===10&&(p|=1,A===0&&(P=E),A++,b=E+1)}return A===0&&(P=M.length),[A,P,M.length-b,p]}}),define(Se[49],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0;class u{constructor(M,A){this.lineNumber=M,this.column=A}with(M=this.lineNumber,A=this.column){return M===this.lineNumber&&A===this.column?this:new u(M,A)}delta(M=0,A=0){return this.with(this.lineNumber+M,this.column+A)}equals(M){return u.equals(this,M)}static equals(M,A){return!M&&!A?!0:!!M&&!!A&&M.lineNumber===A.lineNumber&&M.column===A.column}isBefore(M){return u.isBefore(this,M)}static isBefore(M,A){return M.lineNumber<A.lineNumber?!0:A.lineNumber<M.lineNumber?!1:M.column<A.column}isBeforeOrEqual(M){return u.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,A){return M.lineNumber<A.lineNumber?!0:A.lineNumber<M.lineNumber?!1:M.column<=A.column}static compare(M,A){const P=M.lineNumber|0,b=A.lineNumber|0;if(P===b){const p=M.column|0,E=A.column|0;return p-E}return P-b}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new u(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$0s=u}),define(Se[29],De([1,0,49]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class L{constructor(A,P,b,p){A>b||A===b&&P>p?(this.startLineNumber=b,this.startColumn=p,this.endLineNumber=A,this.endColumn=P):(this.startLineNumber=A,this.startColumn=P,this.endLineNumber=b,this.endColumn=p)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,P){return!(P.lineNumber<A.startLineNumber||P.lineNumber>A.endLineNumber||P.lineNumber===A.startLineNumber&&P.column<A.startColumn||P.lineNumber===A.endLineNumber&&P.column>A.endColumn)}static strictContainsPosition(A,P){return!(P.lineNumber<A.startLineNumber||P.lineNumber>A.endLineNumber||P.lineNumber===A.startLineNumber&&P.column<=A.startColumn||P.lineNumber===A.endLineNumber&&P.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,P){return!(P.startLineNumber<A.startLineNumber||P.endLineNumber<A.startLineNumber||P.startLineNumber>A.endLineNumber||P.endLineNumber>A.endLineNumber||P.startLineNumber===A.startLineNumber&&P.startColumn<A.startColumn||P.endLineNumber===A.endLineNumber&&P.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,P){return!(P.startLineNumber<A.startLineNumber||P.endLineNumber<A.startLineNumber||P.startLineNumber>A.endLineNumber||P.endLineNumber>A.endLineNumber||P.startLineNumber===A.startLineNumber&&P.startColumn<=A.startColumn||P.endLineNumber===A.endLineNumber&&P.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,P){let b,p,E,R;return P.startLineNumber<A.startLineNumber?(b=P.startLineNumber,p=P.startColumn):P.startLineNumber===A.startLineNumber?(b=P.startLineNumber,p=Math.min(P.startColumn,A.startColumn)):(b=A.startLineNumber,p=A.startColumn),P.endLineNumber>A.endLineNumber?(E=P.endLineNumber,R=P.endColumn):P.endLineNumber===A.endLineNumber?(E=P.endLineNumber,R=Math.max(P.endColumn,A.endColumn)):(E=A.endLineNumber,R=A.endColumn),new L(b,p,E,R)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,P){let b=A.startLineNumber,p=A.startColumn,E=A.endLineNumber,R=A.endColumn;const I=P.startLineNumber,w=P.startColumn,S=P.endLineNumber,y=P.endColumn;return b<I?(b=I,p=w):b===I&&(p=Math.max(p,w)),E>S?(E=S,R=y):E===S&&(R=Math.min(R,y)),b>E||b===E&&p>R?null:new L(b,p,E,R)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,P){return!A&&!P?!0:!!A&&!!P&&A.startLineNumber===P.startLineNumber&&A.startColumn===P.startColumn&&A.endLineNumber===P.endLineNumber&&A.endColumn===P.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new u.$0s(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new u.$0s(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,P){return new L(this.startLineNumber,this.startColumn,A,P)}setStartPosition(A,P){return new L(A,P,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,P=A){return new L(A.lineNumber,A.column,P.lineNumber,P.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,P){return!(A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn||P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn)}static areIntersecting(A,P){return!(A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn||P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,P){if(A&&P){const E=A.startLineNumber|0,R=P.startLineNumber|0;if(E===R){const I=A.startColumn|0,w=P.startColumn|0;if(I===w){const S=A.endLineNumber|0,y=P.endLineNumber|0;if(S===y){const h=A.endColumn|0,g=P.endColumn|0;return h-g}return S-y}return I-w}return E-R}return(A?1:0)-(P?1:0)}static compareRangesUsingEnds(A,P){return A.endLineNumber===P.endLineNumber?A.endColumn===P.endColumn?A.startLineNumber===P.startLineNumber?A.startColumn-P.startColumn:A.startLineNumber-P.startLineNumber:A.endColumn-P.endColumn:A.endLineNumber-P.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$$s=L}),define(Se[173],De([1,0,29]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=void 0;class L{static insert(A,P){return{range:new u.$$s(A.lineNumber,A.column,A.lineNumber,A.column),text:P,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,P){return{range:A,text:P}}static replaceMove(A,P){return{range:A,text:P,forceMoveMarkers:!0}}}e.$_s=L}),define(Se[174],De([1,0,49,29]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.SelectionDirection=void 0;var M;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(M||(e.SelectionDirection=M={}));class A extends L.$$s{constructor(b,p,E,R){super(b,p,E,R),this.selectionStartLineNumber=b,this.selectionStartColumn=p,this.positionLineNumber=E,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return A.selectionsEqual(this,b)}static selectionsEqual(b,p){return b.selectionStartLineNumber===p.selectionStartLineNumber&&b.selectionStartColumn===p.selectionStartColumn&&b.positionLineNumber===p.positionLineNumber&&b.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,p){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,b,p):new A(b,p,this.startLineNumber,this.startColumn)}getPosition(){return new u.$0s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$0s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,p){return this.getDirection()===0?new A(b,p,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,b,p)}static fromPositions(b,p=b){return new A(b.lineNumber,b.column,p.lineNumber,p.column)}static fromRange(b,p){return p===0?new A(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new A(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new A(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,p){if(b&&!p||!b&&p)return!1;if(!b&&!p)return!0;if(b.length!==p.length)return!1;for(let E=0,R=b.length;E<R;E++)if(!this.selectionsEqual(b[E],p[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,p,E,R,I){return I===0?new A(b,p,E,R):new A(E,R,b,p)}}e.$at=A}),define(Se[175],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0,e.$Is={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[176],De([1,0,128]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=e.$xt=e.WordCharacterClass=void 0;var L;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class M extends u.$vt{constructor(b){super(0);for(let p=0,E=b.length;p<E;p++)this.set(b.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}e.$xt=M;function A(P){const b={};return p=>(b.hasOwnProperty(p)||(b[p]=P(p)),b[p])}e.$yt=A(P=>new M(P))}),define(Se[129],De([1,0,48,3,74]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=void 0,e.$Ls=P,e.$Ms=p,e.$Ns=E,e.$Js="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Js)I.indexOf(S)>=0||(w+="\\"+S);return w+="\\s]+)",new RegExp(w,"g")}e.$Ks=A();function P(I){let w=e.$Ks;if(I&&I instanceof RegExp)if(I.global)w=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),w=new RegExp(I.source,S)}return w.lastIndex=0,w}const b=new M.$4c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(I){const w=b.unshift(I);return(0,L.$Rc)(w)}function E(I,w,S,y,h){if(w=P(w),h||(h=u.Iterable.first(b)),S.length>h.maxLen){let r=I-h.maxLen/2;return r<0?r=0:y+=r,S=S.substring(r,I+h.maxLen/2),E(I,w,S,y,h)}const g=Date.now(),c=I-1-y;let n=-1,i=null;for(let r=1;!(Date.now()-g>=h.timeBudget);r++){const a=c-h.windowSize*r;w.lastIndex=Math.max(0,a);const t=R(w,S,c,n);if(!t&&i||(i=t,a<=0))break;n=a}if(i){const r={word:i[0],startColumn:y+1+i.index,endColumn:y+1+i.index+i[0].length};return w.lastIndex=0,r}return null}function R(I,w,S,y){let h;for(;h=I.exec(w);){const g=h.index||0;if(g<=S&&I.lastIndex>=S)return h;if(y>0&&g>y)return null}return null}}),define(Se[177],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=e.IndentAction=void 0;var u;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class L{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let p=0,E=b.notIn.length;p<E;p++)switch(b.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,p){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset(p-2),R=b.getStandardTokenType(E);return this.isOK(R)}g(b,p){for(let E=b;E<=p;E++){const R=String.fromCharCode(E);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$0t=L;class M{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of b)A(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),A(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),A(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),A(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&A(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$$t=M;function A(P,b,p){P.has(b)?P.get(b).push(p):P.set(b,[p])}}),define(Se[178],De([1,0,128]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i2=e.$h2=e.State=void 0,e.$j2=w;var L;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class M{constructor(y,h,g){const c=new Uint8Array(y*h);for(let n=0,i=y*h;n<i;n++)c[n]=g;this.a=c,this.rows=y,this.cols=h}get(y,h){return this.a[y*this.cols+h]}set(y,h,g){this.a[y*this.cols+h]=g}}class A{constructor(y){let h=0,g=0;for(let n=0,i=y.length;n<i;n++){const[r,a,t]=y[n];a>h&&(h=a),r>g&&(g=r),t>g&&(g=t)}h++,g++;const c=new M(g,h,0);for(let n=0,i=y.length;n<i;n++){const[r,a,t]=y[n];c.set(r,a,t)}this.a=c,this.b=h}nextState(y,h){return h<0||h>=this.b?0:this.a.get(y,h)}}e.$h2=A;let P=null;function b(){return P===null&&(P=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var p;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let E=null;function R(){if(E===null){E=new u.$vt(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<S.length;h++)E.set(S.charCodeAt(h),1);const y=".,;:";for(let h=0;h<y.length;h++)E.set(y.charCodeAt(h),2)}return E}class I{static a(y,h,g,c,n){let i=n-1;do{const r=h.charCodeAt(i);if(y.get(r)!==2)break;i--}while(i>c);if(c>0){const r=h.charCodeAt(c-1),a=h.charCodeAt(i);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&i--}return{range:{startLineNumber:g,startColumn:c+1,endLineNumber:g,endColumn:i+2},url:h.substring(c,i+1)}}static computeLinks(y,h=b()){const g=R(),c=[];for(let n=1,i=y.getLineCount();n<=i;n++){const r=y.getLineContent(n),a=r.length;let t=0,f=0,l=0,s=1,o=!1,d=!1,m=!1,D=!1;for(;t<a;){let $=!1;const v=r.charCodeAt(t);if(s===13){let k;switch(v){case 40:o=!0,k=0;break;case 41:k=o?0:1;break;case 91:m=!0,d=!0,k=0;break;case 93:m=!1,k=d?0:1;break;case 123:D=!0,k=0;break;case 125:k=D?0:1;break;case 39:case 34:case 96:l===v?k=1:l===39||l===34||l===96?k=0:k=1;break;case 42:k=l===42?1:0;break;case 124:k=l===124?1:0;break;case 32:k=m?0:1;break;default:k=g.get(v)}k===1&&(c.push(I.a(g,r,n,f,t)),$=!0)}else if(s===12){let k;v===91?(d=!0,k=0):k=g.get(v),k===1?$=!0:s=13}else s=h.nextState(s,v),s===0&&($=!0);$&&(s=1,o=!1,d=!1,D=!1,f=t+1,l=v),t++}s===13&&c.push(I.a(g,r,n,f,a))}return c}}e.$i2=I;function w(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}}),define(Se[78],De([1,0,24]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$sv=e.$rv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$tv=S,e.$xv=i;var L;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var M;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(M||(e.GlyphMarginLane=M={}));var A;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var P;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(P||(e.InjectedTextCursorStops=P={}));var b;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var p;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.DefaultEndOfLine=p={}));var E;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,u.$Qn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$rv=R;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$sv=I;var w;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function S(r){return r&&typeof r.read=="function"}var y;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(y||(e.PositionAffinity=y={}));var h;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h||(e.ModelConstants=h={}));class g{constructor(a,t,f,l,s,o){this.identifier=a,this.range=t,this.text=f,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=s,this._isTracked=o}}e.$uv=g;class c{constructor(a,t,f){this.regex=a,this.wordSeparators=t,this.simpleSearch=f}}e.$vv=c;class n{constructor(a,t,f){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=f}}e.$wv=n;function i(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}}),define(Se[179],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.NodeColor=e.$_B=void 0,e.$bC=M,e.$cC=A,e.$dC=E,e.$eC=R,e.$fC=I,e.$gC=w,e.$hC=S,e.$iC=y;class u{constructor(g,c){this.piece=g,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$aC)return M(this.right);let g=this;for(;g.parent!==e.$aC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$aC?e.$aC:g.parent}prev(){if(this.left!==e.$aC)return A(this.left);let g=this;for(;g.parent!==e.$aC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$aC?e.$aC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$_B=u;var L;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$aC=new u(null,0),e.$aC.parent=e.$aC,e.$aC.left=e.$aC,e.$aC.right=e.$aC,e.$aC.color=0;function M(h){for(;h.left!==e.$aC;)h=h.left;return h}function A(h){for(;h.right!==e.$aC;)h=h.right;return h}function P(h){return h===e.$aC?0:h.size_left+h.piece.length+P(h.right)}function b(h){return h===e.$aC?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function p(){e.$aC.parent=e.$aC}function E(h,g){const c=g.right;c.size_left+=g.size_left+(g.piece?g.piece.length:0),c.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=c.left,c.left!==e.$aC&&(c.left.parent=g),c.parent=g.parent,g.parent===e.$aC?h.root=c:g.parent.left===g?g.parent.left=c:g.parent.right=c,c.left=g,g.parent=c}function R(h,g){const c=g.left;g.left=c.right,c.right!==e.$aC&&(c.right.parent=g),c.parent=g.parent,g.size_left-=c.size_left+(c.piece?c.piece.length:0),g.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),g.parent===e.$aC?h.root=c:g===g.parent.right?g.parent.right=c:g.parent.left=c,c.right=g,g.parent=c}function I(h,g){let c,n;if(g.left===e.$aC?(n=g,c=n.right):g.right===e.$aC?(n=g,c=n.left):(n=M(g.right),c=n.right),n===h.root){h.root=c,c.color=0,g.detach(),p(),h.root.parent=e.$aC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=c:n.parent.right=c,n===g?(c.parent=n.parent,y(h,c)):(n.parent===g?c.parent=n:c.parent=n.parent,y(h,c),n.left=g.left,n.right=g.right,n.parent=g.parent,n.color=g.color,g===h.root?h.root=n:g===g.parent.left?g.parent.left=n:g.parent.right=n,n.left!==e.$aC&&(n.left.parent=n),n.right!==e.$aC&&(n.right.parent=n),n.size_left=g.size_left,n.lf_left=g.lf_left,y(h,n)),g.detach(),c.parent.left===c){const a=P(c),t=b(c);if(a!==c.parent.size_left||t!==c.parent.lf_left){const f=a-c.parent.size_left,l=t-c.parent.lf_left;c.parent.size_left=a,c.parent.lf_left=t,S(h,c.parent,f,l)}}if(y(h,c.parent),i){p();return}let r;for(;c!==h.root&&c.color===0;)c===c.parent.left?(r=c.parent.right,r.color===1&&(r.color=0,c.parent.color=1,E(h,c.parent),r=c.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,c=c.parent):(r.right.color===0&&(r.left.color=0,r.color=1,R(h,r),r=c.parent.right),r.color=c.parent.color,c.parent.color=0,r.right.color=0,E(h,c.parent),c=h.root)):(r=c.parent.left,r.color===1&&(r.color=0,c.parent.color=1,R(h,c.parent),r=c.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,c=c.parent):(r.left.color===0&&(r.right.color=0,r.color=1,E(h,r),r=c.parent.left),r.color=c.parent.color,c.parent.color=0,r.left.color=0,R(h,c.parent),c=h.root));c.color=0,p()}function w(h,g){for(y(h,g);g!==h.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const c=g.parent.parent.right;c.color===1?(g.parent.color=0,c.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,E(h,g)),g.parent.color=0,g.parent.parent.color=1,R(h,g.parent.parent))}else{const c=g.parent.parent.left;c.color===1?(g.parent.color=0,c.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,R(h,g)),g.parent.color=0,g.parent.parent.color=1,E(h,g.parent.parent))}h.root.color=0}function S(h,g,c,n){for(;g!==h.root&&g!==e.$aC;)g.parent.left===g&&(g.parent.size_left+=c,g.parent.lf_left+=n),g=g.parent}function y(h,g){let c=0,n=0;if(g!==h.root){for(;g!==h.root&&g===g.parent.right;)g=g.parent;if(g!==h.root)for(g=g.parent,c=P(g.left)-g.size_left,n=b(g.left)-g.lf_left,g.size_left+=c,g.lf_left+=n;g!==h.root&&(c!==0||n!==0);)g.parent.left===g&&(g.parent.size_left+=c,g.parent.lf_left+=n),g=g.parent}}}),define(Se[180],De([1,0,19,127]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cv=e.$Bv=e.$Av=void 0;class M{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,E){p=(0,L.$Se)(p);const R=this.a,I=this.b,w=E.length;return w===0?!1:(this.a=new Uint32Array(R.length+w),this.a.set(R.subarray(0,p),0),this.a.set(R.subarray(p),p+w),this.a.set(E,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(p,E){return p=(0,L.$Se)(p),E=(0,L.$Se)(E),this.a[p]===E?!1:(this.a[p]=E,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,E){p=(0,L.$Se)(p),E=(0,L.$Se)(E);const R=this.a,I=this.b;if(p>=R.length)return!1;const w=R.length-p;return E>=w&&(E=w),E===0?!1:(this.a=new Uint32Array(R.length-E),this.a.set(R.subarray(0,p),0),this.a.set(R.subarray(p+E),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,L.$Se)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),p>=this.a.length&&(p=this.a.length-1);for(let R=E;R<=p;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let E=0,R=this.a.length-1,I=0,w=0,S=0;for(;E<=R;)if(I=E+(R-E)/2|0,w=this.b[I],S=w-this.a[I],p<S)R=I-1;else if(p>=w)E=I+1;else break;return new P(I,p-S)}}e.$Av=M;class A{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const E=this.e[p],R=E>0?this.d[E-1]:0;return new P(E,p-R)}removeValues(p,E){this.a.splice(p,E),this.f(p)}insertValues(p,E){this.a=(0,u.$Wb)(this.a,p,E),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,E=this.a.length;p<E;p++){const R=this.a[p],I=p>0?this.d[p-1]:0;this.d[p]=I+R;for(let w=0;w<R;w++)this.e[I+w]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,E){this.a[p]!==E&&(this.a[p]=E,this.f(p))}}e.$Bv=A;class P{constructor(p,E){this.index=p,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=E}}e.$Cv=P}),define(Se[181],De([1,0,14,49,180]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=void 0;class A{constructor(b,p,E,R){this.d=b,this.f=p,this.g=E,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const p=b.changes;for(const E of p)this.o(E.range),this.p(new L.$0s(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,p=this.f.length,E=new Uint32Array(p);for(let R=0;R<p;R++)E[R]=this.f[R].length+b;this.j=new M.$Av(E)}}n(b,p){this.f[b]=p,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,p){if(p.length===0)return;const E=(0,u.$0e)(p);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const R=new Uint32Array(E.length-1);for(let I=1;I<E.length;I++)this.f.splice(b.lineNumber+I-1,0,E[I]),R[I-1]=E[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$Dv=A}),define(Se[100],De([1,0,14,176,49,29,78]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.$mC=e.$jC=void 0,e.$kC=E,e.$lC=R,e.$nC=h;const b=999;class p{constructor(n,i,r,a){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$8e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new P.$vv(i,this.wordSeparators?(0,L.$yt)(this.wordSeparators):null,r?this.searchString:null)}}e.$jC=p;function E(c){if(!c||c.length===0)return!1;for(let n=0,i=c.length;n<i;n++){const r=c.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const a=c.charCodeAt(n);if(a===110||a===114||a===87)return!0}}return!1}function R(c,n,i){if(!i)return new P.$sv(c,null);const r=[];for(let a=0,t=n.length;a<t;a++)r[a]=n[a];return new P.$sv(c,r)}class I{constructor(n){const i=[];let r=0;for(let a=0,t=n.length;a<t;a++)n.charCodeAt(a)===10&&(i[r++]=a);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,a=i.length-1;if(a===-1||n<=i[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);i[t]>=n?a=t-1:i[t+1]>=n?(r=t,a=t):r=t+1}return r+1}}class w{static findMatches(n,i,r,a,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new g(f.wordSeparators,f.regex),a,t):this.c(n,r,f,a,t):[]}static a(n,i,r,a,t,f){let l,s=0;a?(s=a.findLineFeedCountBeforeOffset(t),l=i+t+s):l=i+t;let o;if(a){const $=a.findLineFeedCountBeforeOffset(t+f.length)-s;o=l+f.length+$}else o=l+f.length;const d=n.getPositionAt(l),m=n.getPositionAt(o);return new A.$$s(d.lineNumber,d.column,m.lineNumber,m.column)}static b(n,i,r,a,t){const f=n.getOffsetAt(i.getStartPosition()),l=n.getValueInRange(i,1),s=n.getEOL()===`\r
`?new I(l):null,o=[];let d=0,m;for(r.reset(0);m=r.next(l);)if(o[d++]=R(this.a(n,f,l,s,m.index,m[0]),m,a),d>=t)return o;return o}static c(n,i,r,a,t){const f=[];let l=0;if(i.startLineNumber===i.endLineNumber){const o=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return l=this.d(r,o,i.startLineNumber,i.startColumn-1,l,f,a,t),f}const s=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);l=this.d(r,s,i.startLineNumber,i.startColumn-1,l,f,a,t);for(let o=i.startLineNumber+1;o<i.endLineNumber&&l<t;o++)l=this.d(r,n.getLineContent(o),o,0,l,f,a,t);if(l<t){const o=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);l=this.d(r,o,i.endLineNumber,0,l,f,a,t)}return f}static d(n,i,r,a,t,f,l,s){const o=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,$=D.length,v=i.length;let k=-$;for(;(k=i.indexOf(D,k+$))!==-1;)if((!o||h(o,i,v,k,$))&&(f[t++]=new P.$sv(new A.$$s(r,k+1+a,r,k+1+$+a),null),t>=s))return t;return t}const d=new g(n.wordSeparators,n.regex);let m;d.reset(0);do if(m=d.next(i),m&&(f[t++]=R(new A.$$s(r,m.index+1+a,r,m.index+1+m[0].length+a),m,l),t>=s))return t;while(m);return t}static findNextMatch(n,i,r,a){const t=i.parseSearchRequest();if(!t)return null;const f=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,a):this.f(n,r,f,a)}static e(n,i,r,a){const t=new M.$0s(i.lineNumber,1),f=n.getOffsetAt(t),l=n.getLineCount(),s=n.getValueInRange(new A.$$s(t.lineNumber,t.column,l,n.getLineMaxColumn(l)),1),o=n.getEOL()===`\r
`?new I(s):null;r.reset(i.column-1);const d=r.next(s);return d?R(this.a(n,f,s,o,d.index,d[0]),d,a):i.lineNumber!==1||i.column!==1?this.e(n,new M.$0s(1,1),r,a):null}static f(n,i,r,a){const t=n.getLineCount(),f=i.lineNumber,l=n.getLineContent(f),s=this.g(r,l,f,i.column,a);if(s)return s;for(let o=1;o<=t;o++){const d=(f+o-1)%t,m=n.getLineContent(d+1),D=this.g(r,m,d+1,1,a);if(D)return D}return null}static g(n,i,r,a,t){n.reset(a-1);const f=n.next(i);return f?R(new A.$$s(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,a){const t=i.parseSearchRequest();if(!t)return null;const f=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,a):this.j(n,r,f,a)}static h(n,i,r,a){const t=this.b(n,new A.$$s(1,1,i.lineNumber,i.column),r,a,10*b);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new M.$0s(f,n.getLineMaxColumn(f)),r,a):null}static j(n,i,r,a){const t=n.getLineCount(),f=i.lineNumber,l=n.getLineContent(f).substring(0,i.column-1),s=this.k(r,l,f,a);if(s)return s;for(let o=1;o<=t;o++){const d=(t+f-o-1)%t,m=n.getLineContent(d+1),D=this.k(r,m,d+1,a);if(D)return D}return null}static k(n,i,r,a){let t=null,f;for(n.reset(0);f=n.next(i);)t=R(new A.$$s(r,f.index+1,r,f.index+1+f[0].length),f,a);return t}}e.$mC=w;function S(c,n,i,r,a){if(r===0)return!0;const t=n.charCodeAt(r-1);if(c.get(t)!==0||t===13||t===10)return!0;if(a>0){const f=n.charCodeAt(r);if(c.get(f)!==0)return!0}return!1}function y(c,n,i,r,a){if(r+a===i)return!0;const t=n.charCodeAt(r+a);if(c.get(t)!==0||t===13||t===10)return!0;if(a>0){const f=n.charCodeAt(r+a-1);if(c.get(f)!==0)return!0}return!1}function h(c,n,i,r,a){return S(c,n,i,r,a)&&y(c,n,i,r,a)}class g{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){u.$rf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,a,t))return r}while(r);return null}}e.$oC=g}),define(Se[130],De([1,0,49,29,78,179,100]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$sC=e.$rC=void 0,e.$pC=R,e.$qC=I;const b=65535;function p(c){let n;return c[c.length-1]<65536?n=new Uint16Array(c.length):n=new Uint32Array(c.length),n.set(c,0),n}class E{constructor(n,i,r,a,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function R(c,n=!0){const i=[0];let r=1;for(let a=0,t=c.length;a<t;a++){const f=c.charCodeAt(a);f===13?a+1<t&&c.charCodeAt(a+1)===10?(i[r++]=a+2,a++):i[r++]=a+1:f===10&&(i[r++]=a+1)}return n?p(i):i}function I(c,n){c.length=0,c[0]=0;let i=1,r=0,a=0,t=0,f=!0;for(let s=0,o=n.length;s<o;s++){const d=n.charCodeAt(s);d===13?s+1<o&&n.charCodeAt(s+1)===10?(t++,c[i++]=s+2,s++):(r++,c[i++]=s+1):d===10?(a++,c[i++]=s+1):f&&d!==9&&(d<32||d>126)&&(f=!1)}const l=new E(p(c),r,a,t,f);return c.length=0,l}class w{constructor(n,i,r,a,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$rC=w;class S{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$sC=S;class y{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==A.$aC&&n.iterate(n.root,r=>(r!==A.$aC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=n){r[a]=null,i=!0;continue}}if(i){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class g{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=A.$aC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let a=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=R(n[t].buffer));const l=new w(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),a=this.S(a,l)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,r=i-Math.floor(i/3),a=r*2;let t="",f=0;const l=[];if(this.iterate(this.root,s=>{const o=this.R(s),d=o.length;if(f<=r||f+d<a)return t+=o,f+=d,!0;const m=t.replace(/\r\n|\r|\n/g,n);return l.push(new S(m,R(m))),t=o,f=d,!0}),f>0){const s=t.replace(/\r\n|\r|\n/g,n);l.push(new S(s,R(s)))}this.create(l,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new y(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,a=>{if(a===A.$aC)return!0;const t=this.R(a),f=t.length,l=n.G(i),s=n.G(i+f),o=n.getValueInRange2(l,s);return i+=f,t===o})}getOffsetAt(n,i){let r=0,a=this.root;for(;a!==A.$aC;)if(a.left!==A.$aC&&a.lf_left+1>=n)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=n){r+=a.size_left;const t=this.B(a,n-a.lf_left-2);return r+=t+i-1}else n-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const a=n;for(;i!==A.$aC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),l=a-f;return new u.$0s(r+1,l+1)}return new u.$0s(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===A.$aC){const t=this.getOffsetAt(r+1,1),f=a-n-t;return new u.$0s(r+1,f+1)}else i=i.right;return new u.$0s(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),a=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,a);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const l=n.node,s=this.a[l.piece.bufferIndex].buffer,o=this.u(l.piece.bufferIndex,l.piece.start);return s.substring(o+n.remainder,o+i.remainder)}let r=n.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=a.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==A.$aC;){const l=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=l.substring(s,s+i.remainder);break}else f+=l.substr(s,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===A.$aC)return!0;const f=t.piece;let l=f.length;if(l===0)return!0;const s=this.a[f.bufferIndex].buffer,o=this.a[f.bufferIndex].lineStarts,d=f.start.line,m=f.end.line;let D=o[d]+f.start.column;if(a&&(s.charCodeAt(D)===10&&(D++,l--),n[i++]=r,r="",a=!1,l===0))return!0;if(d===m)return!this.f&&s.charCodeAt(D+l-1)===13?(a=!0,r+=s.substr(D,l-1)):r+=s.substr(D,l),!0;r+=this.f?s.substring(D,Math.max(D,o[d+1]-this.e)):s.substring(D,o[d+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let $=d+1;$<m;$++)r=this.f?s.substring(o[$],o[$+1]-this.e):s.substring(o[$],o[$+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&s.charCodeAt(o[m]+f.end.column-1)===13?(a=!0,f.end.column===0?i--:r=s.substr(o[m],f.end.column-1)):r=s.substr(o[m],f.end.column),!0}),a&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(a)}else{const i=this.a[n.node.piece.bufferIndex],a=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(a)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,a,t,f,l,s,o,d,m){const D=this.a[n.piece.bufferIndex],$=this.u(n.piece.bufferIndex,n.piece.start),v=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,f);let C;const O={line:0,column:0};let B,z;i._wordSeparators?(B=D.buffer.substring(v,k),z=T=>T+v,i.reset(0)):(B=D.buffer,z=T=>T,i.reset(v));do if(C=i.next(B),C){if(z(C.index)>=k)return d;this.s(n,z(C.index)-$,O);const T=this.t(n.piece.bufferIndex,t,O),j=O.line===t.line?O.column-t.column+a:O.column+1,N=j+C[0].length;if(m[d++]=(0,P.$lC)(new L.$$s(r+T,j,r+T,N),C,s),z(C.index)+C[0].length>=k||d>=o)return d}while(C);return d}findMatchesLineByLine(n,i,r,a){const t=[];let f=0;const l=new P.$oC(i.wordSeparators,i.regex);let s=this.H(n.startLineNumber,n.startColumn);if(s===null)return[];const o=this.H(n.endLineNumber,n.endColumn);if(o===null)return[];let d=this.s(s.node,s.remainder);const m=this.s(o.node,o.remainder);if(s.node===o.node)return this.findMatchesInNode(s.node,l,n.startLineNumber,n.startColumn,d,m,i,r,a,f,t),t;let D=n.startLineNumber,$=s.node;for(;$!==o.node;){const k=this.t($.piece.bufferIndex,d,$.piece.end);if(k>=1){const O=this.a[$.piece.bufferIndex].lineStarts,B=this.u($.piece.bufferIndex,$.piece.start),z=O[d.line+k],T=D===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode($,l,D,T,d,this.s($,z-B),i,r,a,f,t),f>=a)return t;D+=k}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const O=this.getLineContent(D).substring(C,n.endColumn-1);return f=this.n(i,l,O,n.endLineNumber,C,f,t,r,a),t}if(f=this.n(i,l,this.getLineContent(D).substr(C),D,C,f,t,r,a),f>=a)return t;D++,s=this.H(D,1),$=s.node,d=this.s(s.node,s.remainder)}if(D===n.endLineNumber){const k=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(k,n.endColumn-1);return f=this.n(i,l,C,n.endLineNumber,k,f,t,r,a),t}const v=D===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(o.node,l,D,v,d,m,i,r,a,f,t),t}n(n,i,r,a,t,f,l,s,o){const d=n.wordSeparators;if(!s&&n.simpleSearch){const D=n.simpleSearch,$=D.length,v=r.length;let k=-$;for(;(k=r.indexOf(D,k+$))!==-1;)if((!d||(0,P.$nC)(d,r,v,k,$))&&(l[f++]=new M.$sv(new L.$$s(a,k+1+t,a,k+1+$+t),null),f>=o))return f;return f}let m;i.reset(0);do if(m=i.next(r),m&&(l[f++]=(0,P.$lC)(new L.$$s(a,m.index+1+t,a,m.index+1+m[0].length+t),m,s),f>=o))return f;while(m);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==A.$aC){const{node:a,remainder:t,nodeStartOffset:f}=this.G(n),l=a.piece,s=l.bufferIndex,o=this.s(a,t);if(a.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&f+l.length===n&&i.length<b){this.F(a,i),this.y();return}if(f===n)this.o(i,a),this.h.validate(n);else if(f+a.piece.length>n){const d=[];let m=new w(l.bufferIndex,o,l.end,this.t(l.bufferIndex,o,l.end),this.u(s,l.end)-this.u(s,o));if(this.K()&&this.M(i)&&this.I(a,t)===10){const k={line:m.start.line+1,column:0};m=new w(m.bufferIndex,k,m.end,this.t(m.bufferIndex,k,m.end),m.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(a,t-1)===13){const k=this.s(a,t-1);this.C(a,k),i="\r"+i,a.piece.length===0&&d.push(a)}else this.C(a,o);else this.C(a,o);const D=this.w(i);m.length>0&&this.S(a,m);let $=a;for(let v=0;v<D.length;v++)$=this.S($,D[v]);this.v(d)}else this.q(i,a)}else{const a=this.w(i);let t=this.T(null,a[0]);for(let f=1;f<a.length;f++)t=this.S(t,a[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===A.$aC)return;const r=this.G(n),a=this.G(n+i),t=r.node,f=a.node;if(t===f){const D=this.s(t,r.remainder),$=this.s(t,a.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const v=t.next();(0,A.$fC)(this,t),this.N(v),this.y();return}this.D(t,$),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,$),this.y();return}const l=[],s=this.s(t,r.remainder);this.C(t,s),this.h.validate(n),t.piece.length===0&&l.push(t);const o=this.s(f,a.remainder);this.D(f,o),f.piece.length===0&&l.push(f);const d=t.next();for(let D=d;D!==A.$aC&&D!==f;D=D.next())l.push(D);const m=t.piece.length===0?t.prev():t;this.v(l),this.O(m),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,l={line:f.start.line+1,column:0},s=new w(f.bufferIndex,l,f.end,this.t(f.bufferIndex,l,f.end),f.length-1);i.piece=s,n+=`
`,(0,A.$hC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const a=this.w(n);let t=this.T(i,a[a.length-1]);for(let f=a.length-2;f>=0;f--)t=this.T(t,a[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),a=this.S(i,r[0]);let t=a;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(a)}s(n,i,r){const a=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,s=f[a.start.line]+a.start.column+i;let o=a.start.line,d=a.end.line,m=0,D=0,$=0;for(;o<=d&&(m=o+(d-o)/2|0,$=f[m],m!==d);)if(D=f[m+1],s<$)d=m-1;else if(s>=D)o=m+1;else break;return r?(r.line=m,r.column=s-$,null):{line:m,column:s-$}}t(n,i,r){if(r.column===0)return r.line-i.line;const a=this.a[n].lineStarts;if(r.line===a.length-1)return r.line-i.line;const t=a[r.line+1],f=a[r.line]+r.column;if(t>f+1)return r.line-i.line;const l=f-1;return this.a[n].buffer.charCodeAt(l)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,A.$fC)(this,n[i])}w(n){if(n.length>b){const d=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let $;D===13||D>=55296&&D<=56319?($=n.substring(0,b-1),n=n.substring(b-1)):($=n.substring(0,b),n=n.substring(b));const v=R($);d.push(new w(this.a.length,{line:0,column:0},{line:v.length-1,column:$.length-v[v.length-1]},v.length-1,$.length)),this.a.push(new S($,v))}const m=R(n);return d.push(new w(this.a.length,{line:0,column:0},{line:m.length-1,column:n.length-m[m.length-1]},m.length-1,n.length)),this.a.push(new S(n,m)),d}let i=this.a[0].buffer.length;const r=R(n,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let d=0;d<r.length;d++)r[d]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let d=0;d<r.length;d++)r[d]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,l=t-this.a[0].lineStarts[f],s={line:f,column:l},o=new w(0,a,s,this.t(0,a,s),t-i);return this.g=s,[o]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,a="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),l=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)a=l.substring(s+f,s+r.piece.length);else{const o=this.B(r,n-t.nodeStartLineNumber);return l.substring(s+f,s+o-i)}}else{let f=0;const l=n;for(;r!==A.$aC;)if(r.left!==A.$aC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const s=this.B(r,n-r.lf_left-2),o=this.B(r,n-r.lf_left-1),d=this.a[r.piece.bufferIndex].buffer,m=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:l-(n-1-r.lf_left)}),d.substring(m+s,m+o-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const s=this.B(r,n-r.lf_left-2),o=this.a[r.piece.bufferIndex].buffer,d=this.u(r.piece.bufferIndex,r.piece.start);a=o.substring(d+s,d+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==A.$aC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const l=this.B(r,0),s=this.u(r.piece.bufferIndex,r.piece.start);return a+=f.substring(s,s+l-i),a}else{const l=this.u(r.piece.bufferIndex,r.piece.start);a+=f.substr(l,r.piece.length)}r=r.next()}return a}y(){let n=this.root,i=1,r=0;for(;n!==A.$aC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,a=this.s(n,i),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,a);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:a.column}}B(n,i){if(i<0)return 0;const r=n.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(n,i){const r=n.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,l=this.u(r.bufferIndex,f),s=this.t(r.bufferIndex,r.start,f),o=s-a,d=l-t,m=r.length+d;n.piece=new w(r.bufferIndex,r.start,f,s,m),(0,A.$hC)(this,n,d,o)}D(n,i){const r=n.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,l=this.t(r.bufferIndex,f,r.end),s=this.u(r.bufferIndex,f),o=l-a,d=t-s,m=r.length+d;n.piece=new w(r.bufferIndex,f,r.end,l,m),(0,A.$hC)(this,n,d,o)}E(n,i,r){const a=n.piece,t=a.start,f=a.end,l=a.length,s=a.lineFeedCnt,o=i,d=this.t(a.bufferIndex,a.start,o),m=this.u(a.bufferIndex,i)-this.u(a.bufferIndex,t);n.piece=new w(a.bufferIndex,a.start,o,d,m),(0,A.$hC)(this,n,m-l,d-s);const D=new w(a.bufferIndex,r,f,this.t(a.bufferIndex,r,f),this.u(a.bufferIndex,f)-this.u(a.bufferIndex,r)),$=this.S(n,D);this.N($)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),a=this.a[0].buffer.length;this.a[0].buffer+=i;const t=R(i,!1);for(let $=0;$<t.length;$++)t[$]+=a;if(r){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[f],s={line:f,column:l},o=n.piece.length+i.length,d=n.piece.lineFeedCnt,m=this.t(0,n.piece.start,s),D=m-d;n.piece=new w(n.piece.bufferIndex,n.piece.start,s,m,o),this.g=s,(0,A.$hC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let a=0;for(;i!==A.$aC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){a+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:a};return this.h.set(t),t}else n-=i.size_left+i.piece.length,a+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,a=0;for(;r!==A.$aC;)if(r.left!==A.$aC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:a};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==A.$aC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(a)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$aC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,a=i.start.line,t=r[a]+i.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$aC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],a=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:a[n.piece.end.line]-a[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,l=n.piece.lineFeedCnt-1;n.piece=new w(n.piece.bufferIndex,n.piece.start,t,l,f),(0,A.$hC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const s={line:i.piece.start.line+1,column:0},o=i.piece.length-1,d=this.t(i.piece.bufferIndex,s,i.piece.end);i.piece=new w(i.piece.bufferIndex,s,i.piece.end,d,o),(0,A.$hC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const m=this.w(`\r
`);this.S(n,m[0]);for(let D=0;D<r.length;D++)(0,A.$fC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,A.$fC)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},f=a.length-1,l=this.t(a.bufferIndex,t,a.end);r.piece=new w(a.bufferIndex,t,a.end,l,f),(0,A.$hC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===A.$aC)return i(A.$aC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===A.$aC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(a,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),a=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,a)}S(n,i){const r=new A.$_B(i,1);if(r.left=A.$aC,r.right=A.$aC,r.parent=A.$aC,r.size_left=0,r.lf_left=0,this.root===A.$aC)this.root=r,r.color=0;else if(n.right===A.$aC)n.right=r,r.parent=n;else{const t=(0,A.$bC)(n.right);t.left=r,r.parent=t}return(0,A.$gC)(this,r),r}T(n,i){const r=new A.$_B(i,1);if(r.left=A.$aC,r.right=A.$aC,r.parent=A.$aC,r.size_left=0,r.lf_left=0,this.root===A.$aC)this.root=r,r.color=0;else if(n.left===A.$aC)n.left=r,r.parent=n;else{const a=(0,A.$cC)(n.left);a.right=r,r.parent=a}return(0,A.$gC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$tC=g}),define(Se[182],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9=e.$R9=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const P=this.a.get(A);return this.a.delete(A),P}}addDragOperationTransfer(A,P){this.a.set(A,P)}}e.$R9=u;class L{constructor(A){this.identifier=A}}e.$S9=L}),define(Se[183],De([1,0,4,3]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$6d,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,p){return this.a.set(b,p),this.handleChange([b]),(0,L.$Rc)(()=>{this.a.get(b)===p&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,p){this.b.get(b)?.dispose();const E=new A(this,b,p);return this.b.set(b,E),(0,L.$Rc)(()=>{const R=this.b.get(b);!R||R!==E||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const p=this.get(b);if(p)return p;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Jt=M;class A extends L.$Tc{get isResolved(){return this.c}constructor(b,p,E){super(),this.f=b,this.g=p,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[184],De([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Se[185],De([1,0,4,3,184]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=void 0,e.$3i=R;class A extends L.$Tc{constructor(w,S="",y="",h=!0,g){super(),this.h=this.B(new u.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=S,this.u=y,this.w=h,this.C=g}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,S){this.C&&await this.C(w)}}e.$Xi=A;class P extends L.$Tc{constructor(){super(...arguments),this.f=this.B(new u.$6d),this.onWillRun=this.f.event,this.m=this.B(new u.$6d),this.onDidRun=this.m.event}async run(w,S){if(!w.enabled)return;this.f.fire({action:w});let y;try{await this.u(w,S)}catch(h){y=h}this.m.fire({action:w,error:y})}async u(w,S){await w.run(S)}}e.$Yi=P;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let S=[];for(const y of w)y.length&&(S.length?S=[...S,new b,...y]:S=y);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$Zi=b;class p{get actions(){return this.a}constructor(w,S,y,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=S,this.class=h,this.a=y}async run(){}}e.$1i=p;class E extends A{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,M.localize(0,null),void 0,!1)}}e.$2i=E;function R(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...w)=>I.run(...w),tooltip:I.label}}}),define(Se[186],De([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Se[187],De([1,0,186]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=E,e.$Mm=R,e.$Nm=I;const L=60,M=L*60,A=M*24,P=A*7,b=A*30,p=A*365;function E(w,S,y,h){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,u.localize)(0,null,E(new Date().getTime()+g*1e3,!1));if(!h&&g<30)return(0,u.localize)(1,null);let c;return g<L?(c=g,S?c===1?y?(0,u.localize)(2,null,c):(0,u.localize)(3,null,c):y?(0,u.localize)(4,null,c):(0,u.localize)(5,null,c):c===1?y?(0,u.localize)(6,null,c):(0,u.localize)(7,null,c):y?(0,u.localize)(8,null,c):(0,u.localize)(9,null,c)):g<M?(c=Math.floor(g/L),S?c===1?y?(0,u.localize)(10,null,c):(0,u.localize)(11,null,c):y?(0,u.localize)(12,null,c):(0,u.localize)(13,null,c):c===1?y?(0,u.localize)(14,null,c):(0,u.localize)(15,null,c):y?(0,u.localize)(16,null,c):(0,u.localize)(17,null,c)):g<A?(c=Math.floor(g/M),S?c===1?y?(0,u.localize)(18,null,c):(0,u.localize)(19,null,c):y?(0,u.localize)(20,null,c):(0,u.localize)(21,null,c):c===1?y?(0,u.localize)(22,null,c):(0,u.localize)(23,null,c):y?(0,u.localize)(24,null,c):(0,u.localize)(25,null,c)):g<P?(c=Math.floor(g/A),S?c===1?(0,u.localize)(26,null,c):(0,u.localize)(27,null,c):c===1?(0,u.localize)(28,null,c):(0,u.localize)(29,null,c)):g<b?(c=Math.floor(g/P),S?c===1?y?(0,u.localize)(30,null,c):(0,u.localize)(31,null,c):y?(0,u.localize)(32,null,c):(0,u.localize)(33,null,c):c===1?y?(0,u.localize)(34,null,c):(0,u.localize)(35,null,c):y?(0,u.localize)(36,null,c):(0,u.localize)(37,null,c)):g<p?(c=Math.floor(g/b),S?c===1?y?(0,u.localize)(38,null,c):(0,u.localize)(39,null,c):y?(0,u.localize)(40,null,c):(0,u.localize)(41,null,c):c===1?y?(0,u.localize)(42,null,c):(0,u.localize)(43,null,c):y?(0,u.localize)(44,null,c):(0,u.localize)(45,null,c)):(c=Math.floor(g/p),S?c===1?y?(0,u.localize)(46,null,c):(0,u.localize)(47,null,c):y?(0,u.localize)(48,null,c):(0,u.localize)(49,null,c):c===1?y?(0,u.localize)(50,null,c):(0,u.localize)(51,null,c):y?(0,u.localize)(52,null,c):(0,u.localize)(53,null,c))}function R(w,S){const y=Math.abs(w/1e3);return y<1?S?(0,u.localize)(54,null,w):(0,u.localize)(55,null,w):y<L?S?(0,u.localize)(56,null,Math.round(w)/1e3):(0,u.localize)(57,null,Math.round(w)/1e3):y<M?S?(0,u.localize)(58,null,Math.round(w/(1e3*L))):(0,u.localize)(59,null,Math.round(w/(1e3*L))):y<A?S?(0,u.localize)(60,null,Math.round(w/(1e3*M))):(0,u.localize)(61,null,Math.round(w/(1e3*M))):(0,u.localize)(62,null,Math.round(w/(1e3*A)))}function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[188],De([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Se[44],De([1,0,19,18,188]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=p,e.$5i=E,e.$6i=R;function A(I,w){return w&&(I.stack||I.stacktrace)?M.localize(0,null,b(I),P(I.stack)||P(I.stacktrace)):b(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?M.localize(1,null,I.message):I.message||M.localize(2,null)}function p(I=null,w=!1){if(!I)return M.localize(3,null);if(Array.isArray(I)){const S=u.$Hb(I),y=p(S[0],w);return S.length>1?M.localize(4,null,y,S.length):y}if(L.$Tf(I))return I;if(I.detail){const S=I.detail;if(S.error)return A(S.error,w);if(S.exception)return A(S.exception,w)}return I.stack?A(I,w):I.message?I.message:M.localize(5,null)}function E(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}function R(I,w){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=w,S}}),define(Se[189],De([9,10]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(Se[11],De([1,0,189]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=D,e.$J=$,e.$g="en";let L=!1,M=!1,A=!1,P=!1,b=!1,p=!1,E=!1,R=!1,I=!1,w=!1,S,y=e.$g,h=e.$g,g,c;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&(i=process);const r=typeof i?.versions?.electron=="string",a=r&&i?.type==="renderer";if(typeof i=="object"){L=i.platform==="win32",M=i.platform==="darwin",A=i.platform==="linux",P=A&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=r,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,y=e.$g;const v=i.env.VSCODE_NLS_CONFIG;if(v)try{const k=JSON.parse(v),C=k.availableLanguages["*"];S=k.locale,h=k.osLocale,y=C||e.$g,g=k._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!a?(c=navigator.userAgent,L=c.indexOf("Windows")>=0,M=c.indexOf("Macintosh")>=0,R=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,w=c?.indexOf("Mobi")>=0,p=!0,S=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,y=S,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let l=0;M?l=1:L?l=3:A&&(l=2),e.$i=L,e.$j=M,e.$k=A,e.$l=P,e.$m=b,e.$n=E,e.$o=p,e.$p=p&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=R,e.$s=w,e.$t=I,e.$u=l,e.$v=c,e.$w=y;var s;(function(v){function k(){return e.$w}v.value=k;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=C;function O(){return e.$w==="en"}v.isDefault=O})(s||(e.Language=s={})),e.$x=S,e.$y=h,e.$z=g,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const v=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let O=0,B=v.length;O<B;O++){const z=v[O];if(z.id===C.data.vscodeScheduleAsyncWork){v.splice(O,1),z.callback();return}}});let k=0;return C=>{const O=++k;v.push({id:O,callback:C}),n.postMessage({vscodeScheduleAsyncWork:O},"*")}}return v=>setTimeout(v)})();var o;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=M||R?2:L?1:3;let d=!0,m=!1;function D(){if(!m){m=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,d=new Uint16Array(v.buffer)[0]===513}return d}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function $(v){return parseFloat(v)>=20}}),define(Se[50],De([1,0,11]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const A=M.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(Se[17],De([1,0,50]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,M=97,A=90,P=122,b=46,p=47,E=92,R=58,I=63;class w extends Error{constructor(f,l,s){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const d=f.indexOf(".")!==-1?"property":"argument";let m=`The "${f}" ${d} ${o} of type ${l}`;m+=`. Received type ${typeof s}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,f){if(t===null||typeof t!="object")throw new w(f,"Object",t)}function y(t,f){if(typeof t!="string")throw new w(f,"string",t)}const h=u.$dc==="win32";function g(t){return t===p||t===E}function c(t){return t===p}function n(t){return t>=L&&t<=A||t>=M&&t<=P}function i(t,f,l,s){let o="",d=0,m=-1,D=0,$=0;for(let v=0;v<=t.length;++v){if(v<t.length)$=t.charCodeAt(v);else{if(s($))break;$=p}if(s($)){if(!(m===v-1||D===1))if(D===2){if(o.length<2||d!==2||o.charCodeAt(o.length-1)!==b||o.charCodeAt(o.length-2)!==b){if(o.length>2){const k=o.lastIndexOf(l);k===-1?(o="",d=0):(o=o.slice(0,k),d=o.length-1-o.lastIndexOf(l)),m=v,D=0;continue}else if(o.length!==0){o="",d=0,m=v,D=0;continue}}f&&(o+=o.length>0?`${l}..`:"..",d=2)}else o.length>0?o+=`${l}${t.slice(m+1,v)}`:o=t.slice(m+1,v),d=v-m-1;m=v,D=0}else $===b&&D!==-1?++D:D=-1}return o}function r(t,f){S(f,"pathObject");const l=f.dir||f.root,s=f.base||`${f.name||""}${f.ext||""}`;return l?l===f.root?`${l}${s}`:`${l}${t}${s}`:s}e.$fc={resolve(...t){let f="",l="",s=!1;for(let o=t.length-1;o>=-1;o--){let d;if(o>=0){if(d=t[o],y(d,"path"),d.length===0)continue}else f.length===0?d=u.cwd():(d=u.env[`=${f}`]||u.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==f.toLowerCase()&&d.charCodeAt(2)===E)&&(d=`${f}\\`));const m=d.length;let D=0,$="",v=!1;const k=d.charCodeAt(0);if(m===1)g(k)&&(D=1,v=!0);else if(g(k))if(v=!0,g(d.charCodeAt(1))){let C=2,O=C;for(;C<m&&!g(d.charCodeAt(C));)C++;if(C<m&&C!==O){const B=d.slice(O,C);for(O=C;C<m&&g(d.charCodeAt(C));)C++;if(C<m&&C!==O){for(O=C;C<m&&!g(d.charCodeAt(C));)C++;(C===m||C!==O)&&($=`\\\\${B}\\${d.slice(O,C)}`,D=C)}}}else D=1;else n(k)&&d.charCodeAt(1)===R&&($=d.slice(0,2),D=2,m>2&&g(d.charCodeAt(2))&&(v=!0,D=3));if($.length>0)if(f.length>0){if($.toLowerCase()!==f.toLowerCase())continue}else f=$;if(s){if(f.length>0)break}else if(l=`${d.slice(D)}\\${l}`,s=v,v&&f.length>0)break}return l=i(l,!s,"\\",g),s?`${f}\\${l}`:`${f}${l}`||"."},normalize(t){y(t,"path");const f=t.length;if(f===0)return".";let l=0,s,o=!1;const d=t.charCodeAt(0);if(f===1)return c(d)?"\\":t;if(g(d))if(o=!0,g(t.charCodeAt(1))){let D=2,$=D;for(;D<f&&!g(t.charCodeAt(D));)D++;if(D<f&&D!==$){const v=t.slice($,D);for($=D;D<f&&g(t.charCodeAt(D));)D++;if(D<f&&D!==$){for($=D;D<f&&!g(t.charCodeAt(D));)D++;if(D===f)return`\\\\${v}\\${t.slice($)}\\`;D!==$&&(s=`\\\\${v}\\${t.slice($,D)}`,l=D)}}}else l=1;else n(d)&&t.charCodeAt(1)===R&&(s=t.slice(0,2),l=2,f>2&&g(t.charCodeAt(2))&&(o=!0,l=3));let m=l<f?i(t.slice(l),!o,"\\",g):"";return m.length===0&&!o&&(m="."),m.length>0&&g(t.charCodeAt(f-1))&&(m+="\\"),s===void 0?o?`\\${m}`:m:o?`${s}\\${m}`:`${s}${m}`},isAbsolute(t){y(t,"path");const f=t.length;if(f===0)return!1;const l=t.charCodeAt(0);return g(l)||f>2&&n(l)&&t.charCodeAt(1)===R&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,l;for(let d=0;d<t.length;++d){const m=t[d];y(m,"path"),m.length>0&&(f===void 0?f=l=m:f+=`\\${m}`)}if(f===void 0)return".";let s=!0,o=0;if(typeof l=="string"&&g(l.charCodeAt(0))){++o;const d=l.length;d>1&&g(l.charCodeAt(1))&&(++o,d>2&&(g(l.charCodeAt(2))?++o:s=!1))}if(s){for(;o<f.length&&g(f.charCodeAt(o));)o++;o>=2&&(f=`\\${f.slice(o)}`)}return e.$fc.normalize(f)},relative(t,f){if(y(t,"from"),y(f,"to"),t===f)return"";const l=e.$fc.resolve(t),s=e.$fc.resolve(f);if(l===s||(t=l.toLowerCase(),f=s.toLowerCase(),t===f))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===E;)o++;let d=t.length;for(;d-1>o&&t.charCodeAt(d-1)===E;)d--;const m=d-o;let D=0;for(;D<f.length&&f.charCodeAt(D)===E;)D++;let $=f.length;for(;$-1>D&&f.charCodeAt($-1)===E;)$--;const v=$-D,k=m<v?m:v;let C=-1,O=0;for(;O<k;O++){const z=t.charCodeAt(o+O);if(z!==f.charCodeAt(D+O))break;z===E&&(C=O)}if(O!==k){if(C===-1)return s}else{if(v>k){if(f.charCodeAt(D+O)===E)return s.slice(D+O+1);if(O===2)return s.slice(D+O)}m>k&&(t.charCodeAt(o+O)===E?C=O:O===2&&(C=3)),C===-1&&(C=0)}let B="";for(O=o+C+1;O<=d;++O)(O===d||t.charCodeAt(O)===E)&&(B+=B.length===0?"..":"\\..");return D+=C,B.length>0?`${B}${s.slice(D,$)}`:(s.charCodeAt(D)===E&&++D,s.slice(D,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$fc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const l=f.charCodeAt(2);if(l!==I&&l!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===R&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return t},dirname(t){y(t,"path");const f=t.length;if(f===0)return".";let l=-1,s=0;const o=t.charCodeAt(0);if(f===1)return g(o)?t:".";if(g(o)){if(l=s=1,g(t.charCodeAt(1))){let D=2,$=D;for(;D<f&&!g(t.charCodeAt(D));)D++;if(D<f&&D!==$){for($=D;D<f&&g(t.charCodeAt(D));)D++;if(D<f&&D!==$){for($=D;D<f&&!g(t.charCodeAt(D));)D++;if(D===f)return t;D!==$&&(l=s=D+1)}}}}else n(o)&&t.charCodeAt(1)===R&&(l=f>2&&g(t.charCodeAt(2))?3:2,s=l);let d=-1,m=!0;for(let D=f-1;D>=s;--D)if(g(t.charCodeAt(D))){if(!m){d=D;break}}else m=!1;if(d===-1){if(l===-1)return".";d=l}return t.slice(0,d)},basename(t,f){f!==void 0&&y(f,"ext"),y(t,"path");let l=0,s=-1,o=!0,d;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(l=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let m=f.length-1,D=-1;for(d=t.length-1;d>=l;--d){const $=t.charCodeAt(d);if(g($)){if(!o){l=d+1;break}}else D===-1&&(o=!1,D=d+1),m>=0&&($===f.charCodeAt(m)?--m===-1&&(s=d):(m=-1,s=D))}return l===s?s=D:s===-1&&(s=t.length),t.slice(l,s)}for(d=t.length-1;d>=l;--d)if(g(t.charCodeAt(d))){if(!o){l=d+1;break}}else s===-1&&(o=!1,s=d+1);return s===-1?"":t.slice(l,s)},extname(t){y(t,"path");let f=0,l=-1,s=0,o=-1,d=!0,m=0;t.length>=2&&t.charCodeAt(1)===R&&n(t.charCodeAt(0))&&(f=s=2);for(let D=t.length-1;D>=f;--D){const $=t.charCodeAt(D);if(g($)){if(!d){s=D+1;break}continue}o===-1&&(d=!1,o=D+1),$===b?l===-1?l=D:m!==1&&(m=1):l!==-1&&(m=-1)}return l===-1||o===-1||m===0||m===1&&l===o-1&&l===s+1?"":t.slice(l,o)},format:r.bind(null,"\\"),parse(t){y(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const l=t.length;let s=0,o=t.charCodeAt(0);if(l===1)return g(o)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(g(o)){if(s=1,g(t.charCodeAt(1))){let C=2,O=C;for(;C<l&&!g(t.charCodeAt(C));)C++;if(C<l&&C!==O){for(O=C;C<l&&g(t.charCodeAt(C));)C++;if(C<l&&C!==O){for(O=C;C<l&&!g(t.charCodeAt(C));)C++;C===l?s=C:C!==O&&(s=C+1)}}}}else if(n(o)&&t.charCodeAt(1)===R){if(l<=2)return f.root=f.dir=t,f;if(s=2,g(t.charCodeAt(2))){if(l===3)return f.root=f.dir=t,f;s=3}}s>0&&(f.root=t.slice(0,s));let d=-1,m=s,D=-1,$=!0,v=t.length-1,k=0;for(;v>=s;--v){if(o=t.charCodeAt(v),g(o)){if(!$){m=v+1;break}continue}D===-1&&($=!1,D=v+1),o===b?d===-1?d=v:k!==1&&(k=1):d!==-1&&(k=-1)}return D!==-1&&(d===-1||k===0||k===1&&d===D-1&&d===m+1?f.base=f.name=t.slice(m,D):(f.name=t.slice(m,d),f.base=t.slice(m,D),f.ext=t.slice(d,D))),m>0&&m!==s?f.dir=t.slice(0,m-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(h){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$gc={resolve(...t){let f="",l=!1;for(let s=t.length-1;s>=-1&&!l;s--){const o=s>=0?t[s]:a();y(o,"path"),o.length!==0&&(f=`${o}/${f}`,l=o.charCodeAt(0)===p)}return f=i(f,!l,"/",c),l?`/${f}`:f.length>0?f:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p,l=t.charCodeAt(t.length-1)===p;return t=i(t,!f,"/",c),t.length===0?f?"/":l?"./":".":(l&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let f;for(let l=0;l<t.length;++l){const s=t[l];y(s,"path"),s.length>0&&(f===void 0?f=s:f+=`/${s}`)}return f===void 0?".":e.$gc.normalize(f)},relative(t,f){if(y(t,"from"),y(f,"to"),t===f||(t=e.$gc.resolve(t),f=e.$gc.resolve(f),t===f))return"";const l=1,s=t.length,o=s-l,d=1,m=f.length-d,D=o<m?o:m;let $=-1,v=0;for(;v<D;v++){const C=t.charCodeAt(l+v);if(C!==f.charCodeAt(d+v))break;C===p&&($=v)}if(v===D)if(m>D){if(f.charCodeAt(d+v)===p)return f.slice(d+v+1);if(v===0)return f.slice(d+v)}else o>D&&(t.charCodeAt(l+v)===p?$=v:v===0&&($=0));let k="";for(v=l+$+1;v<=s;++v)(v===s||t.charCodeAt(v)===p)&&(k+=k.length===0?"..":"/..");return`${k}${f.slice(d+$)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p;let l=-1,s=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===p){if(!s){l=o;break}}else s=!1;return l===-1?f?"/":".":f&&l===1?"//":t.slice(0,l)},basename(t,f){f!==void 0&&y(f,"ext"),y(t,"path");let l=0,s=-1,o=!0,d;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let m=f.length-1,D=-1;for(d=t.length-1;d>=0;--d){const $=t.charCodeAt(d);if($===p){if(!o){l=d+1;break}}else D===-1&&(o=!1,D=d+1),m>=0&&($===f.charCodeAt(m)?--m===-1&&(s=d):(m=-1,s=D))}return l===s?s=D:s===-1&&(s=t.length),t.slice(l,s)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===p){if(!o){l=d+1;break}}else s===-1&&(o=!1,s=d+1);return s===-1?"":t.slice(l,s)},extname(t){y(t,"path");let f=-1,l=0,s=-1,o=!0,d=0;for(let m=t.length-1;m>=0;--m){const D=t.charCodeAt(m);if(D===p){if(!o){l=m+1;break}continue}s===-1&&(o=!1,s=m+1),D===b?f===-1?f=m:d!==1&&(d=1):f!==-1&&(d=-1)}return f===-1||s===-1||d===0||d===1&&f===s-1&&f===l+1?"":t.slice(f,s)},format:r.bind(null,"/"),parse(t){y(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const l=t.charCodeAt(0)===p;let s;l?(f.root="/",s=1):s=0;let o=-1,d=0,m=-1,D=!0,$=t.length-1,v=0;for(;$>=s;--$){const k=t.charCodeAt($);if(k===p){if(!D){d=$+1;break}continue}m===-1&&(D=!1,m=$+1),k===b?o===-1?o=$:v!==1&&(v=1):o!==-1&&(v=-1)}if(m!==-1){const k=d===0&&l?1:d;o===-1||v===0||v===1&&o===m-1&&o===d+1?f.base=f.name=t.slice(k,m):(f.name=t.slice(k,o),f.base=t.slice(k,m),f.ext=t.slice(o,m))}return d>0?f.dir=t.slice(0,d-1):l&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(Se[131],De([1,0,43,17]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=b,e.$Zq=p,e.$1q=E,e.$2q=R,e.$3q=I,e.$4q=w,e.$5q=S,e.$6q=y,e.$7q=h,e.$8q=g,e.$9q=o,e.$0q=d,e.$$q=m;const M=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,$,v=!1){const k=D||"",C=$||"",O=M.value.collator.compare(k,C);return M.value.collatorIsNumeric&&O===0&&k!==C?k<C?-1:1:O}function p(D,$){const v=A.value.collator;return D=D||"",$=$||"",r(v,D,$)}function E(D,$){const v=A.value.collator;return D=D||"",$=$||"",l(D,$)||r(v,D,$)}function R(D,$){const v=A.value.collator;return D=D||"",$=$||"",f(D,$)||r(v,D,$)}function I(D,$){return D=D||"",$=$||"",D===$?0:D<$?-1:1}function w(D,$){const[v,k]=n(D),[C,O]=n($);let B=M.value.collator.compare(k,O);if(B===0){if(M.value.collatorIsNumeric&&k!==O)return k<O?-1:1;if(B=M.value.collator.compare(v,C),M.value.collatorIsNumeric&&B===0&&v!==C)return v<C?-1:1}return B}function S(D,$){D=D||"",$=$||"";const v=i(D),k=i($),C=A.value.collator,O=P.value.collator;return r(O,v,k)||r(C,D,$)}function y(D,$){D=D||"",$=$||"";const v=i(D),k=i($),C=A.value.collator,O=P.value.collator;return r(O,v,k)||l(D,$)||r(C,D,$)}function h(D,$){D=D||"",$=$||"";const v=i(D),k=i($),C=A.value.collator,O=P.value.collator;return r(O,v,k)||f(D,$)||r(C,D,$)}function g(D,$){D=D||"",$=$||"";const v=i(D).toLowerCase(),k=i($).toLowerCase();return v!==k?v<k?-1:1:D!==$?D<$?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function n(D,$=!1){const v=D?c.exec(D):[];let k=[v&&v[1]||"",v&&v[3]||""];return $&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(D){const $=D?c.exec(D):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function r(D,$,v){const k=D.compare($,v);return k!==0?k:$.length!==v.length?$.length<v.length?-1:1:0}function a(D){const $=D.charAt(0);return $.toLocaleUpperCase()!==$}function t(D){const $=D.charAt(0);return $.toLocaleLowerCase()!==$}function f(D,$){return a(D)&&t($)?-1:t(D)&&a($)?1:0}function l(D,$){return t(D)&&a($)?-1:a(D)&&t($)?1:0}function s(D,$,v=!1){return v||(D=D&&D.toLowerCase(),$=$&&$.toLowerCase()),D===$?0:D<$?-1:1}function o(D,$,v=!1){const k=D.split(L.sep),C=$.split(L.sep),O=k.length-1,B=C.length-1;let z,T;for(let j=0;;j++){if(z=O===j,T=B===j,z&&T)return b(k[j],C[j],v);if(z)return-1;if(T)return 1;const N=s(k[j],C[j],v);if(N!==0)return N}}function d(D,$,v){const k=D.toLowerCase(),C=$.toLowerCase(),O=m(D,$,v);if(O)return O;const B=k.endsWith(v),z=C.endsWith(v);if(B!==z)return B?-1:1;const T=b(k,C);return T!==0?T:k.localeCompare(C)}function m(D,$,v){const k=D.toLowerCase(),C=$.toLowerCase(),O=k.startsWith(v),B=C.startsWith(v);if(O!==B)return O?-1:1;if(O&&B){if(k.length<C.length)return-1;if(k.length>C.length)return 1}return 0}}),define(Se[34],De([1,0,17,11,14,18]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=P,e.$ag=b,e.$bg=p,e.$cg=E,e.$dg=R,e.$eg=y,e.$fg=h,e.$gg=g,e.$hg=c,e.$ig=n,e.$jg=i,e.$kg=r,e.$lg=a,e.$mg=t,e.$ng=f,e.$og=o;function P(d){return d===47||d===92}function b(d){return d.replace(/[\\/]/g,u.$gc.sep)}function p(d){return d.indexOf("/")===-1&&(d=b(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}function E(d,m=u.$gc.sep){if(!d)return"";const D=d.length,$=d.charCodeAt(0);if(P($)){if(P(d.charCodeAt(1))&&!P(d.charCodeAt(2))){let k=3;const C=k;for(;k<D&&!P(d.charCodeAt(k));k++);if(C!==k&&!P(d.charCodeAt(k+1))){for(k+=1;k<D;k++)if(P(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,m)}}return m}else if(c($)&&d.charCodeAt(1)===58)return P(d.charCodeAt(2))?d.slice(0,2)+m:d.slice(0,2);let v=d.indexOf("://");if(v!==-1){for(v+=3;v<D;v++)if(P(d.charCodeAt(v)))return d.slice(0,v+1)}return""}function R(d){if(!L.$i||!d||d.length<5)return!1;let m=d.charCodeAt(0);if(m!==92||(m=d.charCodeAt(1),m!==92))return!1;let D=2;const $=D;for(;D<d.length&&(m=d.charCodeAt(D),m!==92);D++);return!($===D||(m=d.charCodeAt(D+1),isNaN(m)||m===92))}const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(d,m=L.$i){const D=m?I:w;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||m&&S.test(d)||d==="."||d===".."||m&&d[d.length-1]==="."||m&&d.length!==d.trim().length||d.length>255)}function h(d,m,D){const $=d===m;return!D||$?$:!d||!m?!1:(0,M.$kf)(d,m)}function g(d,m,D,$=u.sep){if(d===m)return!0;if(!d||!m||m.length>d.length)return!1;if(D){if(!(0,M.$lf)(d,m))return!1;if(m.length===d.length)return!0;let k=m.length;return m.charAt(m.length-1)===$&&k--,d.charAt(k)===$}return m.charAt(m.length-1)!==$&&(m+=$),d.indexOf(m)===0}function c(d){return d>=65&&d<=90||d>=97&&d<=122}function n(d,m){return L.$i&&d.endsWith(":")&&(d+=u.sep),(0,u.$ic)(d)||(d=(0,u.$jc)(m,d)),d=(0,u.$hc)(d),L.$i?(d=(0,M.$5e)(d,u.sep),d.endsWith(":")&&(d+=u.sep)):(d=(0,M.$5e)(d,u.sep),d||(d=u.sep)),d}function i(d){const m=(0,u.$hc)(d);return L.$i?d.length>3?!1:r(m)&&(d.length===2||m.charCodeAt(2)===92):m===u.$gc.sep}function r(d,m=L.$i){return m?c(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}function a(d,m=L.$i){return r(d,m)?d[0]:void 0}function t(d,m,D){return m.length>d.length?-1:d===m?0:(D&&(d=d.toLowerCase(),m=m.toLowerCase()),d.indexOf(m))}function f(d){const m=d.split(":");let D,$,v;for(const k of m){const C=Number(k);(0,A.$Xf)(C)?$===void 0?$=C:v===void 0&&(v=C):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:$!==void 0?$:void 0,column:v!==void 0?v:$!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(d,m,D=8){let $="";for(let k=0;k<D;k++){let C;k===0&&L.$i&&!m&&(D===3||D===4)?C=s:C=l,$+=C.charAt(Math.floor(Math.random()*C.length))}let v;return m?v=`${m}-${$}`:v=$,d?(0,u.$jc)(d,v):v}}),define(Se[132],De([1,0,131,126,54,17,11,14]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=R,e.$ar=g,e.$br=l,e.$cr=v,e.$dr=T,e.$er=N;const p=0,E=[p,[]];function R(F,K,ee,Y){if(!F||!K)return E;const Q=F.length,Z=K.length;if(Q<Z)return E;const ae=F.toLowerCase();return I(K,ee,Z,F,ae,Q,Y)}function I(F,K,ee,Y,Q,Z,ae){const _=[],ge=[];for(let ie=0;ie<ee;ie++){const ye=ie*Z,le=ye-Z,ue=ie>0,ce=F[ie],de=K[ie];for(let H=0;H<Z;H++){const x=H>0,he=ye+H,pe=he-1,Ae=le+H-1,we=x?_[pe]:0,Pe=ue&&x?_[Ae]:0,Fe=ue&&x?ge[Ae]:0;let ze;!Pe&&ue?ze=0:ze=w(ce,de,Y,Q,H,Fe),ze&&Pe+ze>=we&&(ae||ue||Q.startsWith(K,H))?(ge[he]=Fe+1,_[he]=Pe+ze):(ge[he]=p,_[he]=we)}}const se=[];let re=ee-1,U=Z-1;for(;re>=0&&U>=0;){const ie=re*Z+U;ge[ie]===p||(se.push(U),re--),U--}return[_[ee*Z-1],se.reverse()]}function w(F,K,ee,Y,Q,Z){let ae=0;if(!S(K,Y[Q]))return ae;if(ae+=1,Z>0&&(ae+=Z*5),F===ee[Q]&&(ae+=1),Q===0)ae+=8;else{const _=y(ee.charCodeAt(Q-1));_?ae+=_:(0,L.$lk)(ee.charCodeAt(Q))&&Z===0&&(ae+=2)}return ae}function S(F,K){return F===K?!0:F==="/"||F==="\\"?K==="/"||K==="\\":!1}function y(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function g(F,K,ee=0,Y=0){const Q=K;return Q.values&&Q.values.length>1?c(F,Q.values,ee,Y):n(F,K,ee,Y)}function c(F,K,ee,Y){let Q=0;const Z=[];for(const ae of K){const[_,ge]=n(F,ae,ee,Y);if(typeof _!="number")return h;Q+=_,Z.push(...ge)}return[Q,D(Z)]}function n(F,K,ee,Y){const Q=(0,L.$uk)(K.original,K.originalLowercase,ee,F,F.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,L.$rk)(Q)]:h}const i=Object.freeze({score:0}),r=1<<18,a=1<<17,t=65536;function f(F,K,ee,Y){const Q=Y.values?Y.values:[Y];return(0,M.$7i)({[Y.normalized]:{values:Q.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:F,description:K,allowNonContiguousMatches:ee}})}function l(F,K,ee,Y,Q){if(!F||!K.normalized)return i;const Z=Y.getItemLabel(F);if(!Z)return i;const ae=Y.getItemDescription(F),_=f(Z,ae,ee,K),ge=Q[_];if(ge)return ge;const se=s(Z,ae,Y.getItemPath(F),K,ee);return Q[_]=se,se}function s(F,K,ee,Y,Q){const Z=!ee||!Y.containsPathSeparator;return ee&&(P.$k?Y.pathNormalized===ee:(0,b.$kf)(Y.pathNormalized,ee))?{score:r,labelMatch:[{start:0,end:F.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:Y.values&&Y.values.length>1?o(F,K,ee,Y.values,Z,Q):d(F,K,ee,Y,Z,Q)}function o(F,K,ee,Y,Q,Z){let ae=0;const _=[],ge=[];for(const se of Y){const{score:re,labelMatch:U,descriptionMatch:ie}=d(F,K,ee,se,Q,Z);if(re===p)return i;ae+=re,U&&_.push(...U),ie&&ge.push(...ie)}return{score:ae,labelMatch:D(_),descriptionMatch:D(ge)}}function d(F,K,ee,Y,Q,Z){if(Q||!K){const[ae,_]=R(F,Y.normalized,Y.normalizedLowercase,Z&&!Y.expectContiguousMatch);if(ae){const ge=(0,L.$ik)(Y.normalized,F);let se;if(ge){se=a;const re=Math.round(Y.normalized.length/F.length*100);se+=re}else se=t;return{score:se+ae,labelMatch:ge||m(_)}}}if(K){let ae=K;ee&&(ae=`${K}${A.sep}`);const _=ae.length,ge=`${ae}${F}`,[se,re]=R(ge,Y.normalized,Y.normalizedLowercase,Z&&!Y.expectContiguousMatch);if(se){const U=m(re),ie=[],ye=[];return U.forEach(le=>{le.start<_&&le.end>_?(ie.push({start:0,end:le.end-_}),ye.push({start:le.start,end:_})):le.start>=_?ie.push({start:le.start-_,end:le.end-_}):ye.push(le)}),{score:se,labelMatch:ie,descriptionMatch:ye}}}return i}function m(F){const K=[];if(!F)return K;let ee;for(const Y of F)ee&&ee.end===Y?ee.end+=1:(ee={start:Y,end:Y+1},K.push(ee));return K}function D(F){const K=F.sort((Q,Z)=>Q.start-Z.start),ee=[];let Y;for(const Q of K)!Y||!$(Y,Q)?(Y=Q,ee.push(Q)):(Y.start=Math.min(Y.start,Q.start),Y.end=Math.max(Y.end,Q.end));return ee}function $(F,K){return!(F.end<K.start||K.end<F.start)}function v(F,K,ee,Y,Q,Z){const ae=l(F,ee,Y,Q,Z),_=l(K,ee,Y,Q,Z),ge=ae.score,se=_.score;if((ge===r||se===r)&&ge!==se)return ge===r?-1:1;if(ge>t||se>t){if(ge!==se)return ge>se?-1:1;if(ge<a&&se<a){const ce=C(ae.labelMatch,_.labelMatch);if(ce!==0)return ce}const le=Q.getItemLabel(F)||"",ue=Q.getItemLabel(K)||"";if(le.length!==ue.length)return le.length-ue.length}if(ge!==se)return ge>se?-1:1;const re=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,U=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(re&&!U)return-1;if(U&&!re)return 1;const ie=k(F,ae,Q),ye=k(K,_,Q);return ie&&ye&&ie!==ye?ye>ie?-1:1:O(F,K,ee,Q)}function k(F,K,ee){let Y=-1,Q=-1;if(K.descriptionMatch&&K.descriptionMatch.length?Y=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(Y=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(Q=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const Z=ee.getItemDescription(F);Z&&(Q+=Z.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(Q=K.descriptionMatch[K.descriptionMatch.length-1].end);return Q-Y}function C(F,K){if(!F&&!K||(!F||!F.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!F||!F.length)return 1;const ee=F[0].start,Q=F[F.length-1].end-ee,Z=K[0].start,_=K[K.length-1].end-Z;return Q===_?0:_<Q?1:-1}function O(F,K,ee,Y){const Q=Y.getItemLabel(F)||"",Z=Y.getItemLabel(K)||"",ae=Y.getItemDescription(F),_=Y.getItemDescription(K),ge=Q.length+(ae?ae.length:0),se=Z.length+(_?_.length:0);if(ge!==se)return ge-se;const re=Y.getItemPath(F),U=Y.getItemPath(K);return re&&U&&re.length!==U.length?re.length-U.length:Q!==Z?(0,u.$0q)(Q,Z,ee.normalized):ae&&_&&ae!==_?(0,u.$0q)(ae,_,ee.normalized):re&&U&&re!==U?(0,u.$0q)(re,U,ee.normalized):0}function B(F){return F.startsWith('"')&&F.endsWith('"')}const z=" ";function T(F){typeof F!="string"&&(F="");const K=F.toLowerCase(),{pathNormalized:ee,normalized:Y,normalizedLowercase:Q}=j(F),Z=ee.indexOf(A.sep)>=0,ae=B(F);let _;const ge=F.split(z);if(ge.length>1)for(const se of ge){const re=B(se),{pathNormalized:U,normalized:ie,normalizedLowercase:ye}=j(se);ie&&(_||(_=[]),_.push({original:se,originalLowercase:se.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:ye,expectContiguousMatch:re}))}return{original:F,originalLowercase:K,pathNormalized:ee,normalized:Y,normalizedLowercase:Q,values:_,containsPathSeparator:Z,expectContiguousMatch:ae}}function j(F){let K;P.$i?K=F.replace(/\//g,A.sep):K=F.replace(/\\/g,A.sep);const ee=(0,b.$7e)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:ee,normalizedLowercase:ee.toLowerCase()}}function N(F){return Array.isArray(F)?T(F.map(K=>K.original).join(z)):T(F.original)}}),define(Se[101],De([1,0,17]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0,e.$ws=A,e.$xs=P,e.$ys=b,e.$zs=E,e.$vs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const I=(0,u.$oc)(R),w=L[I.toLowerCase()];return w!==void 0?w:P(R)}function P(R){const I=(0,u.$oc)(R);return M[I.toLowerCase()]}function b(R){for(const I in M)if(M[I]===R)return I}const p=/^(.+)\/(.+?)(;.+)?$/;function E(R,I){const w=p.exec(R);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:R}}),define(Se[102],De([1,0,11]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$9l=A,e.$0l=P;var L;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(L||(e.Source=L={}));var M;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(M||(e.TerminateResponseCode=M={}));function A(b,...p){const E=p.reduce((w,S)=>(w[S]=!0,w),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(w=>!E[w]).forEach(w=>{for(let S=0;S<R.length;S++)if(w.search(R[S])!==-1){delete b[w];break}})}function P(b){b&&(delete b.DEBUG,u.$j&&delete b.DYLD_LIBRARY_PATH,u.$k&&delete b.LD_PRELOAD)}}),define(Se[2],De([1,0,17,11]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=y,e.$wc=r;const M=/^\w[\w\d+.-]*$/,A=/^\//,P=/^\/\//;function b(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!M.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(s,o){return!s&&!o?"file":s}function E(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const R="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(o){return o instanceof S?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,d,m,D,$,v=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=p(o,v),this.authority=d||R,this.path=E(this.scheme,m||R),this.query=D||R,this.fragment=$||R,b(this,v))}get fsPath(){return r(this,!1)}with(o){if(!o)return this;let{scheme:d,authority:m,path:D,query:$,fragment:v}=o;return d===void 0?d=this.scheme:d===null&&(d=R),m===void 0?m=this.authority:m===null&&(m=R),D===void 0?D=this.path:D===null&&(D=R),$===void 0?$=this.query:$===null&&($=R),v===void 0?v=this.fragment:v===null&&(v=R),d===this.scheme&&m===this.authority&&D===this.path&&$===this.query&&v===this.fragment?this:new g(d,m,D,$,v)}static parse(o,d=!1){const m=w.exec(o);return m?new g(m[2]||R,l(m[4]||R),l(m[5]||R),l(m[7]||R),l(m[9]||R),d):new g(R,R,R,R,R)}static file(o){let d=R;if(L.$i&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const m=o.indexOf(I,2);m===-1?(d=o.substring(2),o=I):(d=o.substring(2,m),o=o.substring(m)||I)}return new g("file",d,o,R,R)}static from(o,d){return new g(o.scheme,o.authority,o.path,o.query,o.fragment,d)}static joinPath(o,...d){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.$i&&o.scheme==="file"?m=S.file(u.$fc.join(r(o,!0),...d)).path:m=u.$gc.join(o.path,...d),o.with({path:m})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof S)return o;{const d=new g(o);return d._formatted=o.external??null,d._fsPath=o._sep===h?o.fsPath??null:null,d}}else return o}}e.URI=S;function y(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const h=L.$i?1:void 0;class g extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(s,o,d){let m,D=-1;for(let $=0;$<s.length;$++){const v=s.charCodeAt($);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||o&&v===47||d&&v===91||d&&v===93||d&&v===58)D!==-1&&(m+=encodeURIComponent(s.substring(D,$)),D=-1),m!==void 0&&(m+=s.charAt($));else{m===void 0&&(m=s.substr(0,$));const k=c[v];k!==void 0?(D!==-1&&(m+=encodeURIComponent(s.substring(D,$)),D=-1),m+=k):D===-1&&(D=$)}}return D!==-1&&(m+=encodeURIComponent(s.substring(D))),m!==void 0?m:s}function i(s){let o;for(let d=0;d<s.length;d++){const m=s.charCodeAt(d);m===35||m===63?(o===void 0&&(o=s.substr(0,d)),o+=c[m]):o!==void 0&&(o+=s[d])}return o!==void 0?o:s}function r(s,o){let d;return s.authority&&s.path.length>1&&s.scheme==="file"?d=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?d=s.path.substr(1):d=s.path[1].toLowerCase()+s.path.substr(2):d=s.path,L.$i&&(d=d.replace(/\//g,"\\")),d}function a(s,o){const d=o?i:n;let m="",{scheme:D,authority:$,path:v,query:k,fragment:C}=s;if(D&&(m+=D,m+=":"),($||D==="file")&&(m+=I,m+=I),$){let O=$.indexOf("@");if(O!==-1){const B=$.substr(0,O);$=$.substr(O+1),O=B.lastIndexOf(":"),O===-1?m+=d(B,!1,!1):(m+=d(B.substr(0,O),!1,!1),m+=":",m+=d(B.substr(O+1),!1,!0)),m+="@"}$=$.toLowerCase(),O=$.lastIndexOf(":"),O===-1?m+=d($,!1,!0):(m+=d($.substr(0,O),!1,!0),m+=$.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}m+=d(v,!0,!1)}return k&&(m+="?",m+=d(k,!1,!1)),C&&(m+="#",m+=o?C:n(C,!1,!1)),m}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(f)?s.replace(f,o=>t(o)):s}}),define(Se[190],De([1,0,2]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=L,e.$Dq=M,e.$Eq=A,e.log=b;function L(E){const R=E;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function M(E){const R=[];let I;try{const w=JSON.parse(E.arguments),S=w[w.length-1];S&&S.__$stack&&(w.pop(),I=S.__$stack),R.push(...w)}catch{R.push("Unable to log remote console arguments",E.arguments)}return{args:R,stack:I}}function A(E){if(typeof E!="string")return A(M(E).stack);const R=E;if(R){const I=P(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:u.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function P(E){if(!E)return E;const R=E.indexOf(`
`);return R===-1?E:E.substring(0,R)}function b(E,R){const{args:I,stack:w}=M(E),S=typeof I[0]=="string"&&I.length===1;let y=P(w);y&&(y=`(${y.trim()})`);let h=[];if(typeof I[0]=="string"?y&&S?h=[`%c[${R}] %c${I[0]} %c${y}`,p("blue"),p(""),p("grey")]:h=[`%c[${R}] %c${I[0]}`,p("blue"),p(""),...I.slice(1)]:h=[`%c[${R}]%`,p("blue"),...I],y&&!S&&h.push(y),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}function p(E){return`color: ${E}`}}),define(Se[56],De([1,0,21,2]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=M,e.$Oh=A,e.$Ph=b;function M(p){return JSON.stringify(p,P)}function A(p){let E=JSON.parse(p);return E=b(E),E}function P(p,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b(p,E=0){if(!p||E>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return L.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof u.$te||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let R=0;R<p.length;++R)p[R]=b(p[R],E+1);else for(const R in p)Object.hasOwnProperty.call(p,R)&&(p[R]=b(p[R],E+1))}return p}}),define(Se[15],De([1,0,13,11,14,2,17]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$tg=e.$sg=e.$rg=e.Schemas=void 0,e.$pg=p,e.$qg=E,e.$ug=I;var b;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatCodeBlock="vscode-chat-code-block",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm",y.codeSetting="code-setting"})(b||(e.Schemas=b={}));function p(y,h){return A.URI.isUri(y)?(0,M.$kf)(y.scheme,h):(0,M.$lf)(y,h+":")}function E(y,...h){return h.some(g=>p(y,g))}e.$rg="vscode-tkn",e.$sg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,g){this.f=I(h,g)}getServerRootPath(){return this.f}get g(){return P.$gc.join(this.f,b.vscodeRemoteResource)}set(h,g,c){this.a[h]=g,this.b[h]=c}setConnectionToken(h,g){this.c[h]=g}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(a){return u.$1(a),h}const g=h.authority;let c=this.a[g];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const n=this.b[g],i=this.c[g];let r=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(r+=`&${e.$sg}=${encodeURIComponent(i)}`),A.URI.from({scheme:L.$o?this.d:b.vscodeRemoteResource,authority:`${c}:${n}`,path:this.g,query:r})}}e.$tg=new R;function I(y,h){return P.$gc.join(h??"/",`${y.quality??"oss"}-${y.commit??"dev"}`)}e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class w{static{this.a=e.$zg}asBrowserUri(h){const g=this.b(h,fe);return this.uriToBrowserUri(g)}uriToBrowserUri(h){return h.scheme===b.vscodeRemote?e.$tg.rewrite(h):h.scheme===b.file&&(L.$m||L.$q===`${b.vscodeFileResource}://${w.a}`)?h.with({scheme:b.vscodeFileResource,authority:h.authority||w.a,query:null,fragment:null}):h}asFileUri(h){const g=this.b(h,fe);return this.uriToFileUri(g)}uriToFileUri(h){return h.scheme===b.vscodeFileResource?h.with({scheme:b.file,authority:h.authority!==w.a?h.authority:null,query:null,fragment:null}):h}b(h,g){return A.URI.isUri(h)?h:A.URI.parse(g.toUrl(h))}}e.$Ag=new w;var S;(function(y){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(h.get("3"));const g="vscode-coi";function c(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:A.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const a=r?.get(g);if(a)return h.get(a)}y.getHeadersFromQuery=c;function n(i,r,a){if(!globalThis.crossOriginIsolated)return;const t=r&&a?"3":a?"2":"1";i instanceof URLSearchParams?i.set(g,t):i[g]=t}y.addSearchParam=n})(S||(e.COI=S={}))}),define(Se[191],De([1,0,161,15,11,2]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=R;class P{constructor(w,S,y){this.id=w,this.dependencies=S,this.callback=y}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,S,y)=>{typeof w!="string"&&(y=S,S=w,w=null),(typeof S!="object"||!Array.isArray(S))&&(y=S,S=null),this.c.push(new P(w,S,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const S=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!S)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(w){return new Promise((S,y)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const g=()=>{h.removeEventListener("load",c),h.removeEventListener("error",n)},c=i=>{g(),S(this.c.pop())},n=i=>{g(),y(i)};h.addEventListener("load",c),h.addEventListener("error",n),this.f&&(w=this.f.createScriptURL(w)),h.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(w){return new Promise((S,y)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),S(this.c.pop())}catch(h){y(h)}})}async j(w){try{const S=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(w).fsPath,c=S.readFileSync(g).toString(),n=h.wrap(c.replace(/^#!.*/,""));return new y.Script(n).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const p=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function R(I,w,S){if(u.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[I]&&(I=E[I]);const y=`${I}/${w}`;if(p.has(y))return p.get(y);let h;if(/^\w[\w\d+.-]*:\/\//.test(y))h=y;else{const i=`${S&&!M.$o?L.$xg:L.$wg}/${y}`;h=L.$Ag.asBrowserUri(i).toString(!0)}const g=b.INSTANCE.load(h);return p.set(y,g),g}else return await new Promise((y,h)=>{fe([I],y,h)})}}),define(Se[23],De([1,0,34,15,17,11,14,2]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=void 0,e.$Hg=p,e.$3g=R,e.$4g=w;function p(S){return(0,b.$wc)(S,!0)}class E{constructor(y){this.a=y}compare(y,h,g=!1){return y===h?0:(0,P.$df)(this.getComparisonKey(y,g),this.getComparisonKey(h,g))}isEqual(y,h,g=!1){return y===h?!0:!y||!h?!1:this.getComparisonKey(y,g)===this.getComparisonKey(h,g)}getComparisonKey(y,h=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,h,g=!1){if(y.scheme===h.scheme){if(y.scheme===L.Schemas.file)return u.$gg(p(y),p(h),this.a(y))&&y.query===h.query&&(g||y.fragment===h.fragment);if((0,e.$Yg)(y.authority,h.authority))return u.$gg(y.path,h.path,this.a(y),"/")&&y.query===h.query&&(g||y.fragment===h.fragment)}return!1}joinPath(y,...h){return b.URI.joinPath(y,...h)}basenameOrAuthority(y){return(0,e.$Qg)(y)||y.authority}basename(y){return M.$gc.basename(y.path)}extname(y){return M.$gc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let h;return y.scheme===L.Schemas.file?h=b.URI.file(M.$mc(p(y))).path:(h=M.$gc.dirname(y.path),y.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),h="/")),y.with({path:h})}normalizePath(y){if(!y.path.length)return y;let h;return y.scheme===L.Schemas.file?h=b.URI.file(M.$hc(p(y))).path:h=M.$gc.normalize(y.path),y.with({path:h})}relativePath(y,h){if(y.scheme!==h.scheme||!(0,e.$Yg)(y.authority,h.authority))return;if(y.scheme===L.Schemas.file){const n=M.$lc(p(y),p(h));return A.$i?u.$ag(n):n}let g=y.path||"/";const c=h.path||"/";if(this.a(y)){let n=0;for(const i=Math.min(g.length,c.length);n<i&&!(g.charCodeAt(n)!==c.charCodeAt(n)&&g.charAt(n).toLowerCase()!==c.charAt(n).toLowerCase());n++);g=c.substr(0,n)+g.substr(n)}return M.$gc.relative(g,c)}resolvePath(y,h){if(y.scheme===L.Schemas.file){const g=b.URI.file(M.$kc(p(y),h));return y.with({authority:g.authority,path:g.path})}return h=u.$bg(h),y.with({path:M.$gc.resolve(y.path,h)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,h){return y===h||y!==void 0&&h!==void 0&&(0,P.$kf)(y,h)}hasTrailingPathSeparator(y,h=M.sep){if(y.scheme===L.Schemas.file){const g=p(y);return g.length>u.$cg(g).length&&g[g.length-1]===h}else{const g=y.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,h=M.sep){return(0,e.$Zg)(y,h)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,h=M.sep){let g=!1;if(y.scheme===L.Schemas.file){const c=p(y);g=c!==void 0&&c.length===u.$cg(c).length&&c[c.length-1]===h}else{h="/";const c=y.path;g=c.length===1&&c.charCodeAt(c.length-1)===47}return!g&&!(0,e.$Zg)(y,h)?y.with({path:y.path+"/"}):y}}e.$Ig=E,e.$Jg=new E(()=>!1),e.$Kg=new E(S=>S.scheme===L.Schemas.file?!A.$k:!0),e.$Lg=new E(S=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function R(S,y){const h=[];for(let g=0;g<S.length;g++){const c=y(S[g]);S.some((n,i)=>i===g?!1:(0,e.$Ng)(c,y(n)))||h.push(S[g])}return h}var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function y(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,a]=i.split(":");r&&a&&g.set(r,a)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&g.set(S.META_DATA_MIME,n),g}S.parseMetaData=y})(I||(e.DataUri=I={}));function w(S,y,h){if(y){let g=S.path;return g&&g[0]!==M.$gc.sep&&(g=M.$gc.sep+g),S.with({scheme:h,authority:y,path:g})}return S.with({scheme:h})}}),define(Se[8],De([1,0,22,13,4,3,23,11,167,43]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$5g=R,e.$6g=I,e.$7g=w,e.$8g=S,e.$9g=y,e.$0g=h,e.$$g=g,e.$_g=c,e.$hh=d,e.$ih=m,e.$jh=D,e.$kh=$,e.$lh=v,e.$Ah=Q,e.$Ih=ue;function R(de){return!!de&&typeof de.then=="function"}function I(de){const H=new u.$de,x=de(H.token),he=new Promise((pe,Ae)=>{const we=H.token.onCancellationRequested(()=>{we.dispose(),Ae(new L.$5)});Promise.resolve(x).then(Pe=>{we.dispose(),H.dispose(),pe(Pe)},Pe=>{we.dispose(),H.dispose(),Ae(Pe)})});return new class{cancel(){H.cancel(),H.dispose()}then(pe,Ae){return he.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return he.finally(pe)}}}function w(de,H,x){return new Promise((he,pe)=>{const Ae=H.onCancellationRequested(()=>{Ae.dispose(),he(x)});de.then(he,pe).finally(()=>Ae.dispose())})}function S(de,H){return new Promise((x,he)=>{const pe=H.onCancellationRequested(()=>{pe.dispose(),he(new L.$5)});de.then(x,he).finally(()=>pe.dispose())})}async function y(de){let H=-1;const x=de.map((he,pe)=>he.then(Ae=>(H=pe,Ae)));try{return await Promise.race(x)}finally{de.forEach((he,pe)=>{pe!==H&&he.cancel()})}}function h(de,H,x){let he;const pe=setTimeout(()=>{he?.(void 0),x?.()},H);return Promise.race([de.finally(()=>clearTimeout(pe)),new Promise(Ae=>he=Ae)])}function g(de){return new Promise((H,x)=>{const he=de();R(he)?he.then(H,x):H(he)})}function c(){let de,H;return{promise:new Promise((he,pe)=>{de=he,H=pe}),resolve:de,reject:H}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const x=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(x,x).then(he)})}return new Promise((x,he)=>{this.b.then(x,he)})}return this.a=H(),new Promise((x,he)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,he(pe)})})}dispose(){this.f=!0}}e.$ah=n;class i{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$bh=i;class r{constructor(){this.a=new Map}queue(H,x){const pe=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(H)===pe&&this.a.delete(H)});return this.a.set(H,pe),pe}}e.$ch=r;const a=(de,H)=>{let x=!0;const he=setTimeout(()=>{x=!1,H()},de);return{isTriggered:()=>x,dispose:()=>{clearTimeout(he),x=!1}}},t=de=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,de())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class f{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,x=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=x===p.$3d?t(he):a(x,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=f;class l{constructor(H){this.a=new f(H),this.b=new n}trigger(H,x){return this.a.trigger(()=>this.b.queue(H),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=l;class s{constructor(){this.a=!1,this.b=new Promise((H,x)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=s;class o extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$gh=o;function d(de,H){return H?new Promise((x,he)=>{const pe=setTimeout(()=>{Ae.dispose(),x()},de),Ae=H.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),he(new L.$5)})}):I(x=>d(de,x))}function m(de,H=0,x){const he=setTimeout(()=>{de(),x&&pe.dispose()},H),pe=(0,A.$Rc)(()=>{clearTimeout(he),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function D(de){const H=[];let x=0;const he=de.length;function pe(){return x<he?de[x++]():null}function Ae(we){we!=null&&H.push(we);const Pe=pe();return Pe?Pe.then(Ae):Promise.resolve(H)}return Promise.resolve(null).then(Ae)}function $(de,H=he=>!!he,x=null){let he=0;const pe=de.length,Ae=()=>{if(he>=pe)return Promise.resolve(x);const we=de[he++];return Promise.resolve(we()).then(Fe=>H(Fe)?Promise.resolve(Fe):Ae())};return Ae()}function v(de,H=he=>!!he,x=null){if(de.length===0)return Promise.resolve(x);let he=de.length;const pe=()=>{he=-1;for(const Ae of de)Ae.cancel?.()};return new Promise((Ae,we)=>{for(const Pe of de)Pe.then(Fe=>{--he>=0&&H(Fe)?(pe(),Ae(Fe)):he===0&&Ae(x)}).catch(Fe=>{--he>=0&&(pe(),we(Fe))})})}class k{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new M.$6d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,he)=>{this.g.push({factory:H,c:x,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const x=H.factory();x.then(H.c,H.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=k;class C extends k{constructor(){super(1)}}e.$nh=C;class O{constructor(){this.a=new Z,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$oh=O;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new ge;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,x=P.$Jg){const he=x.getComparisonKey(H);return this.a.get(he)?.size??0}queueFor(H,x,he=P.$Jg){const pe=he.getComparisonKey(H);let Ae=this.a.get(pe);if(!Ae){Ae=new C;const we=this.f++,Pe=M.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(we,Pe),this.a.set(pe,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=B;class z{constructor(H,x){this.a=-1,typeof H=="function"&&typeof x=="number"&&this.setIfNotSet(H,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},x)}setIfNotSet(H,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},x))}}e.$qh=z;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,x,he=globalThis){this.cancel();const pe=he.setInterval(()=>{H()},x);this.d=(0,A.$Rc)(()=>{he.clearInterval(pe),this.d=void 0})}dispose(){this.cancel()}}e.$rh=T;class j{constructor(H,x){this.b=-1,this.a=H,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=j;class N{constructor(H,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=H,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=N;class F extends j{constructor(H,x){super(H,x),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$uh=F;class K extends A.$Tc{constructor(H,x){super(),this.g=H,this.h=x,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of H)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(de,H)=>{(0,b.$B)(()=>{if(x)return;const he=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$xh=(de,H,x)=>{const he=de.requestIdleCallback(H,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,de.cancelIdleCallback(he))}}},e.$wh=de=>(0,e.$xh)(globalThis,de)}();class ee{constructor(H,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$xh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=ee;class Y extends ee{constructor(H){super(globalThis,H)}}e.$zh=Y;async function Q(de,H,x){let he;for(let pe=0;pe<x;pe++)try{return await de()}catch(Ae){he=Ae,await d(H)}throw he}class Z{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,x,he){return this.a={taskId:H,cancel:()=>he?.(),promise:x},x.then(()=>this.d(H),()=>this.d(H)),x}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:x,resolve:he,reject:pe}=c();this.b={run:H,promise:x,promiseResolve:he,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=Z;class ae{constructor(H,x=()=>Date.now()){this.d=H,this.f=x,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Ch=ae;var _;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(_||(_={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,x)=>{this.a=H,this.b=x})}complete(H){return new Promise(x=>{this.a(H),this.d={outcome:0,value:H},x()})}error(H){return new Promise(x=>{this.b(H),this.d={outcome:1,value:H},x()})}cancel(){return this.error(new L.$5)}}e.$Dh=ge;var se;(function(de){async function H(he){let pe;const Ae=await Promise.all(he.map(we=>we.then(Pe=>Pe,Pe=>{pe||(pe=Pe)})));if(typeof pe<"u")throw pe;return Ae}de.settled=H;function x(he){return new Promise(async(pe,Ae)=>{try{await he(pe,Ae)}catch(we){Ae(we)}})}de.withAsyncBody=x})(se||(e.Promises=se={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=re;class U{constructor(H){this.b=H,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=U;var ie;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(ie||(ie={}));class ye{static fromArray(H){return new ye(x=>{x.emitMany(H)})}static fromPromise(H){return new ye(async x=>{x.emitMany(await H)})}static fromPromises(H){return new ye(async x=>{await Promise.all(H.map(async he=>x.emitOne(await he)))})}static merge(H){return new ye(async x=>{await Promise.all(H.map(async he=>{for await(const pe of he)x.emitOne(pe)}))})}static{this.EMPTY=ye.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new M.$6d,queueMicrotask(async()=>{const x={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(H(x)),this.j()}catch(he){this.k(he)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(H,x){return new ye(async he=>{for await(const pe of H)he.emitOne(x(pe))})}map(H){return ye.map(this,H)}static filter(H,x){return new ye(async he=>{for await(const pe of H)x(pe)&&he.emitOne(pe)})}filter(H){return ye.filter(this,H)}static coalesce(H){return ye.filter(H,x=>!!x)}coalesce(){return ye.coalesce(this)}static async toPromise(H){const x=[];for await(const he of H)x.push(he);return x}toPromise(){return ye.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$Gh=ye;class le extends ye{constructor(H,x){super(x),this.l=H}cancel(){this.l.cancel()}}e.$Hh=le;function ue(de){const H=new u.$de,x=de(H.token);return new le(H,async he=>{const pe=H.token.onCancellationRequested(()=>{pe.dispose(),H.dispose(),he.reject(new L.$5)});try{for await(const Ae of x){if(H.token.isCancellationRequested)return;he.emitOne(Ae)}pe.dispose(),H.dispose()}catch(Ae){pe.dispose(),H.dispose(),he.reject(Ae)}})}class ce{constructor(){this.a=new ge,this.b=new ye(he=>{if(H){he.reject(H);return}return x&&he.emitMany(x),this.d=pe=>he.reject(pe),this.f=pe=>he.emitOne(pe),this.a.p});let H,x;this.f=he=>{x||(x=[]),x.push(he)},this.d=he=>{H||(H=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$Jh=ce}),define(Se[35],De([1,0,19,8,34,28,17,11,14]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=E,e.$$j=y,e.$_j=C,e.$ak=O,e.$bk=B,e.$ck=z,e.$dk=T,e.$ek=K;function E(){return Object.create(null)}e.$9j="**",e.$0j="/";const R="[/\\\\]",I="[^/\\\\]",w=/\//g;function S(ee,Y){switch(ee){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${Y?`|${R}${I}+`:""})*?`}}function y(ee,Y){if(!ee)return[];const Q=[];let Z=!1,ae=!1,_="";for(const ge of ee){switch(ge){case Y:if(!Z&&!ae){Q.push(_),_="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}_+=ge}return _&&Q.push(_),Q}function h(ee){if(!ee)return"";let Y="";const Q=y(ee,e.$0j);if(Q.every(Z=>Z===e.$9j))Y=".*";else{let Z=!1;Q.forEach((ae,_)=>{if(ae===e.$9j){if(Z)return;Y+=S(2,_===Q.length-1)}else{let ge=!1,se="",re=!1,U="";for(const ie of ae){if(ie!=="}"&&ge){se+=ie;continue}if(re&&(ie!=="]"||!U)){let ye;ie==="-"?ye=ie:(ie==="^"||ie==="!")&&!U?ye="^":ie===e.$0j?ye="":ye=(0,p.$Ye)(ie),U+=ye;continue}switch(ie){case"{":ge=!0;continue;case"[":re=!0;continue;case"}":{const le=`(?:${y(se,",").map(ue=>h(ue)).join("|")})`;Y+=le,ge=!1,se="";break}case"]":{Y+="["+U+"]",re=!1,U="";break}case"?":Y+=I;continue;case"*":Y+=S(1);continue;default:Y+=(0,p.$Ye)(ie)}}_<Q.length-1&&(Q[_+1]!==e.$9j||_+2<Q.length)&&(Y+=R)}Z=ae===e.$9j})}return Y}const g=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),f=function(){return!1},l=function(){return null};function s(ee,Y){if(!ee)return l;let Q;typeof ee!="string"?Q=ee.pattern:Q=ee,Q=Q.trim();const Z=`${Q}_${!!Y.trimForExclusions}`;let ae=t.get(Z);if(ae)return o(ae,ee);let _;return g.test(Q)?ae=m(Q.substr(4),Q):(_=c.exec(d(Q,Y)))?ae=D(_[1],Q):(Y.trimForExclusions?i:n).test(Q)?ae=$(Q,Y):(_=r.exec(d(Q,Y)))?ae=v(_[1].substr(1),Q,!0):(_=a.exec(d(Q,Y)))?ae=v(_[1],Q,!1):ae=k(Q),t.set(Z,ae),o(ae,ee)}function o(ee,Y){if(typeof Y=="string")return ee;const Q=function(Z,ae){return(0,M.$gg)(Z,Y.base,!b.$k)?ee((0,p.$4e)(Z.substr(Y.base.length),P.sep),ae):null};return Q.allBasenames=ee.allBasenames,Q.allPaths=ee.allPaths,Q.basenames=ee.basenames,Q.patterns=ee.patterns,Q}function d(ee,Y){return Y.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function m(ee,Y){return function(Q,Z){return typeof Q=="string"&&Q.endsWith(ee)?Y:null}}function D(ee,Y){const Q=`/${ee}`,Z=`\\${ee}`,ae=function(ge,se){return typeof ge!="string"?null:se?se===ee?Y:null:ge===ee||ge.endsWith(Q)||ge.endsWith(Z)?Y:null},_=[ee];return ae.basenames=_,ae.patterns=[Y],ae.allBasenames=_,ae}function $(ee,Y){const Q=F(ee.slice(1,-1).split(",").map(se=>s(se,Y)).filter(se=>se!==l),ee),Z=Q.length;if(!Z)return l;if(Z===1)return Q[0];const ae=function(se,re){for(let U=0,ie=Q.length;U<ie;U++)if(Q[U](se,re))return ee;return null},_=Q.find(se=>!!se.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=Q.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ge.length&&(ae.allPaths=ge),ae}function v(ee,Y,Q){const Z=P.sep===P.$gc.sep,ae=Z?ee:ee.replace(w,P.sep),_=P.sep+ae,ge=P.$gc.sep+ee;let se;return Q?se=function(re,U){return typeof re=="string"&&(re===ae||re.endsWith(_)||!Z&&(re===ee||re.endsWith(ge)))?Y:null}:se=function(re,U){return typeof re=="string"&&(re===ae||!Z&&re===ee)?Y:null},se.allPaths=[(Q?"*/":"./")+ee],se}function k(ee){try{const Y=new RegExp(`^${h(ee)}$`);return function(Q){return Y.lastIndex=0,typeof Q=="string"&&Y.test(Q)?ee:null}}catch{return l}}function C(ee,Y,Q){return!ee||typeof Y!="string"?!1:O(ee)(Y,void 0,Q)}function O(ee,Y={}){if(!ee)return f;if(typeof ee=="string"||B(ee)){const Q=s(ee,Y);if(Q===l)return f;const Z=function(ae,_){return!!Q(ae,_)};return Q.allBasenames&&(Z.allBasenames=Q.allBasenames),Q.allPaths&&(Z.allPaths=Q.allPaths),Z}return j(ee,Y)}function B(ee){const Y=ee;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}function z(ee){return ee.allBasenames||[]}function T(ee){return ee.allPaths||[]}function j(ee,Y){const Q=F(Object.getOwnPropertyNames(ee).map(se=>N(se,ee[se],Y)).filter(se=>se!==l)),Z=Q.length;if(!Z)return l;if(!Q.some(se=>!!se.requiresSiblings)){if(Z===1)return Q[0];const se=function(ie,ye){let le;for(let ue=0,ce=Q.length;ue<ce;ue++){const de=Q[ue](ie,ye);if(typeof de=="string")return de;(0,L.$5g)(de)&&(le||(le=[]),le.push(de))}return le?(async()=>{for(const ue of le){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},re=Q.find(ie=>!!ie.allBasenames);re&&(se.allBasenames=re.allBasenames);const U=Q.reduce((ie,ye)=>ye.allPaths?ie.concat(ye.allPaths):ie,[]);return U.length&&(se.allPaths=U),se}const ae=function(se,re,U){let ie,ye;for(let le=0,ue=Q.length;le<ue;le++){const ce=Q[le];ce.requiresSiblings&&U&&(re||(re=(0,P.$nc)(se)),ie||(ie=re.substr(0,re.length-(0,P.$oc)(se).length)));const de=ce(se,re,ie,U);if(typeof de=="string")return de;(0,L.$5g)(de)&&(ye||(ye=[]),ye.push(de))}return ye?(async()=>{for(const le of ye){const ue=await le;if(typeof ue=="string")return ue}return null})():null},_=Q.find(se=>!!se.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=Q.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ge.length&&(ae.allPaths=ge),ae}function N(ee,Y,Q){if(Y===!1)return l;const Z=s(ee,Q);if(Z===l)return l;if(typeof Y=="boolean")return Z;if(Y){const ae=Y.when;if(typeof ae=="string"){const _=(ge,se,re,U)=>{if(!U||!Z(ge,se))return null;const ie=ae.replace("$(basename)",()=>re),ye=U(ie);return(0,L.$5g)(ye)?ye.then(le=>le?ee:null):ye?ee:null};return _.requiresSiblings=!0,_}}return Z}function F(ee,Y){const Q=ee.filter(se=>!!se.basenames);if(Q.length<2)return ee;const Z=Q.reduce((se,re)=>{const U=re.basenames;return U?se.concat(U):se},[]);let ae;if(Y){ae=[];for(let se=0,re=Z.length;se<re;se++)ae.push(Y)}else ae=Q.reduce((se,re)=>{const U=re.patterns;return U?se.concat(U):se},[]);const _=function(se,re){if(typeof se!="string")return null;if(!re){let ie;for(ie=se.length;ie>0;ie--){const ye=se.charCodeAt(ie-1);if(ye===47||ye===92)break}re=se.substr(ie)}const U=Z.indexOf(re);return U!==-1?ae[U]:null};_.basenames=Z,_.patterns=ae,_.allBasenames=Z;const ge=ee.filter(se=>!se.basenames);return ge.push(_),ge}function K(ee,Y){return(0,u.$ub)(ee,Y,(Q,Z)=>typeof Q=="string"&&typeof Z=="string"?Q===Z:typeof Q!="string"&&typeof Z!="string"?Q.base===Z.base&&Q.pattern===Z.pattern:!1)}}),define(Se[79],De([1,0,13,169,23,14,2]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ek=E,e.$Fk=R,e.$Gk=I,e.$Hk=w,e.$Ik=S,e.$Jk=y,e.$Kk=h,e.$Lk=g;var b;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class p{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=w(this.supportThemeIcons?(0,L.$xk)(n):n).replace(/([ \t]+)/g,(r,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${S(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,A.$Ye)(i),"g");return n.replace(r,(a,t)=>n.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.$Dk=p;function E(c){return R(c)?!c.value:Array.isArray(c)?c.every(E):!0}function R(c){return c instanceof p?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function I(c,n){return c===n?!0:!c||!n?!1:c.value===n.value&&c.isTrusted===n.isTrusted&&c.supportThemeIcons===n.supportThemeIcons&&c.supportHtml===n.supportHtml&&(c.baseUri===n.baseUri||!!c.baseUri&&!!n.baseUri&&(0,M.$Mg)(P.URI.from(c.baseUri),P.URI.from(n.baseUri)))}function w(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,n){const i=c.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,c,`${"`".repeat(r)}`].join(`
`)}function y(c){return c.replace(/"/g,"&quot;")}function h(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(c){const n=[],i=c.split("|").map(a=>a.trim());c=i[0];const r=i[1];if(r){const a=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=a?a[1]:"",l=t?t[1]:"",s=isFinite(parseInt(l)),o=isFinite(parseInt(f));s&&n.push(`width="${l}"`),o&&n.push(`height="${f}"`)}return{href:c,dimensions:n}}}),define(Se[103],De([1,0,19,34,17,11,23,14]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=p,e.$dw=R,e.$ew=w,e.$fw=S,e.$gw=c,e.$hw=i,e.$iw=r,e.$jw=a,e.$kw=t,e.$lw=f;function p(s,o){const{os:d,tildify:m,relative:D}=o;if(D){const k=E(s,D,d);if(typeof k=="string")return k}let $=s.fsPath;if(d===1&&!A.$i?$=$.replace(/\//g,"\\"):d!==1&&A.$i&&($=$.replace(/\\/g,"/")),d!==1&&m?.userHome){const k=m.userHome.fsPath;let C;s.scheme!==m.userHome.scheme&&s.path[0]===M.$gc.sep&&s.path[1]!==M.$gc.sep?C=m.userHome.with({path:s.path}).fsPath:C=$,$=w(C,k,d)}return(d===1?M.$fc:M.$gc).normalize(R($,d===1))}function E(s,o,d){const m=d===1?M.$fc:M.$gc,D=d===3?P.$Jg:P.$Lg,$=o.getWorkspace(),v=(0,u.$Ob)($.folders);if(!v)return;s.scheme!==v.uri.scheme&&s.path[0]===M.$gc.sep&&s.path[1]!==M.$gc.sep&&(s=v.uri.with({path:s.path}));const k=o.getWorkspaceFolder(s);if(!k)return;let C;if(D.isEqual(k.uri,s)?C="":C=D.relativePath(k.uri,s)??"",C&&(C=m.normalize(C)),$.folders.length>1&&!o.noPrefix){const O=k.name?k.name:D.basenameOrAuthority(k.uri);C=C?`${O} \u2022 ${C}`:O}return C}function R(s,o=A.$i){return(0,L.$kg)(s,o)?s.charAt(0).toUpperCase()+s.slice(1):s}let I=Object.create(null);function w(s,o,d=A.OS){if(d===1||!s||!o)return s;let m=I.original===o?I.normalized:void 0;m||(m=o,A.$i&&(m=(0,L.$ag)(m)),m=`${(0,b.$5e)(m,M.$gc.sep)}${M.$gc.sep}`,I={original:o,normalized:m});let D=s;return A.$i&&(D=(0,L.$ag)(D)),(d===3?D.startsWith(m):(0,b.$lf)(D,m))?`~/${D.substr(m.length)}`:s}function S(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}const y="\u2026",h="\\\\",g="~";function c(s,o=M.sep){const d=new Array(s.length);let m=!1;for(let D=0;D<s.length;D++){const $=s[D];if($===""){d[D]=`.${o}`;continue}if(!$){d[D]=$;continue}m=!0;let v="",k=$;k.indexOf(h)===0?(v=k.substr(0,k.indexOf(h)+h.length),k=k.substr(k.indexOf(h)+h.length)):k.indexOf(o)===0?(v=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length)):k.indexOf(g)===0&&(v=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const C=k.split(o);for(let O=1;m&&O<=C.length;O++)for(let B=C.length-O;m&&B>=0;B--){m=!1;let z=C.slice(B,B+O).join(o);for(let T=0;!m&&T<s.length;T++)if(T!==D&&s[T]&&s[T].indexOf(z)>-1){const j=B+O===C.length,N=B>0&&s[T].indexOf(o)>-1?o+z:z,F=s[T].endsWith(N);m=!j||F}if(!m){let T="";(C[0].endsWith(":")||v!=="")&&(B===1&&(B=0,O++,z=C[0]+o+z),B>0&&(T=C[0]+o),T=v+T),B>0&&(T=T+y+o),T=T+z,B+O<C.length&&(T=T+o+y),d[D]=T}}m&&(d[D]=$)}return d}var n;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(s,o=Object.create(null)){const d=[];let m=!1,D="";for(const $ of s)if($==="$"||m&&$==="{")D&&d.push({value:D,type:n.TEXT}),D="",m=!0;else if($==="}"&&m){const v=o[D];if(typeof v=="string")v.length&&d.push({value:v,type:n.VARIABLE});else if(v){const k=d[d.length-1];(!k||k.type!==n.SEPARATOR)&&d.push({value:v.label,type:n.SEPARATOR})}D="",m=!1}else D+=$;return D&&!m&&d.push({value:D,type:n.TEXT}),d.filter(($,v)=>{if($.type===n.SEPARATOR){const k=d[v-1],C=d[v+1];return[k,C].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map($=>$.value).join("")}function r(s,o){return A.$j||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}function a(s,o){return A.$j||o?s.replace(/\(&&\w\)|&&/g,""):A.$i?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}function t(s){return s.replace(/&/g,"&&")}function f(s){if(s.endsWith("]")){const o=s.lastIndexOf(" [",s.length-2);if(o!==-1){const d=l(s.substring(0,o)),m=s.substring(o);return{name:d.name+m,parentPath:d.parentPath}}}return l(s)}function l(s){const o=s.indexOf("/")!==-1?M.$gc:M.$fc,d=o.basename(s),m=o.dirname(s);return d.length?{name:d,parentPath:m}:{name:m,parentPath:""}}}),define(Se[133],De([1,0,21,2]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$kn=b,e.$ln=E,e.$mn=R;function M(I){return I.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const S=this.a.transformIncoming(w);return S===w?w:M(L.URI.from(S))}transformOutgoing(w){const S=this.a.transformOutgoing(w);return S===w?w:M(L.URI.from(S))}transformOutgoingURI(w){const S=this.a.transformOutgoing(w);return S===w?w:L.URI.from(S)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$in=A,e.$jn=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function P(I,w,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof L.URI)return w.transformOutgoing(I);for(const y in I)if(Object.hasOwnProperty.call(I,y)){const h=P(I[y],w,S+1);h!==null&&(I[y]=h)}}return null}function b(I,w){const S=P(I,w,0);return S===null?I:S}function p(I,w,S,y){if(!I||y>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?L.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof u.$te)return null;for(const h in I)if(Object.hasOwnProperty.call(I,h)){const g=p(I[h],w,S,y+1);g!==null&&(I[h]=g)}}return null}function E(I,w){const S=p(I,w,!1,0);return S===null?I:S}function R(I,w){const S=p(I,w,!0,0);return S===null?I:S}}),define(Se[31],De([1,0,57,63,392,8,34,75,17,11,23,2]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=d,e.writeFileSync=D;var w;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function S(N,F=w.UNLINK,K){if((0,P.$jg)(N))throw new Error("rimraf - will refuse to recursively delete root");return F===w.UNLINK?h(N):y(N,K)}async function y(N,F=(0,P.$og)((0,L.tmpdir)())){try{try{await u.promises.rename(N,F)}catch(K){return K.code==="ENOENT"?void 0:h(N)}h(F).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function h(N){return(0,M.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function g(N){if((0,P.$jg)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}async function c(N,F){return r(await(F?n(N):(0,M.promisify)(u.readdir)(N)))}async function n(N){try{return await(0,M.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const F=[],K=await c(N);for(const ee of K){let Y=!1,Q=!1,Z=!1;try{const ae=await e.Promises.lstat((0,p.$jc)(N,ee));Y=ae.isFile(),Q=ae.isDirectory(),Z=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}F.push({name:ee,isFile:()=>Y,isDirectory:()=>Q,isSymbolicLink:()=>Z})}return F}function i(N){return r(u.readdirSync(N))}function r(N){return N.map(F=>typeof F=="string"?E.$j?(0,b.$Xl)(F):F:(F.name=E.$j?(0,b.$Xl)(F.name):F.name,F))}async function a(N){const F=await c(N),K=[];for(const ee of F)await f.existsDirectory((0,p.$jc)(N,ee))&&K.push(ee);return K}function t(N,F=1e3){return new Promise(K=>{let ee=!1;const Y=setInterval(()=>{ee||(ee=!0,u.access(N,Q=>{ee=!1,Q&&(clearInterval(Y),K(void 0))}))},F)})}var f;(function(N){async function F(Y){let Q;try{if(Q=await e.Promises.lstat(Y),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(E.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ae}throw Z}}N.stat=F;async function K(Y){try{const{stat:Q,symbolicLink:Z}=await N.stat(Y);return Q.isFile()&&Z?.dangling!==!0}catch{}return!1}N.existsFile=K;async function ee(Y){try{const{stat:Q,symbolicLink:Z}=await N.stat(Y);return Q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}N.existsDirectory=ee})(f||(e.SymlinkSupport=f={}));const l=new A.$ph;function s(N,F,K){return l.queueFor(I.URI.file(N),()=>{const ee=$(K);return new Promise((Y,Q)=>m(N,F,ee,Z=>Z?Q(Z):Y()))},R.$Kg)}let o=!0;function d(N){o=N}function m(N,F,K,ee){if(!o)return u.writeFile(N,F,{mode:K.mode,flag:K.flag},ee);u.open(N,K.flag,K.mode,(Y,Q)=>{if(Y)return ee(Y);u.writeFile(Q,F,Z=>{if(Z)return u.close(Q,()=>ee(Z));u.fdatasync(Q,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),d(!1)),u.close(Q,_=>ee(_))))})})}function D(N,F,K){const ee=$(K);if(!o)return u.writeFileSync(N,F,{mode:ee.mode,flag:ee.flag});const Y=u.openSync(N,ee.flag,ee.mode);try{u.writeFileSync(Y,F);try{u.fdatasyncSync(Y)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),d(!1)}}finally{u.closeSync(Y)}}function $(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function v(N,F,K=6e4){if(N!==F)try{E.$i&&typeof K=="number"?await k(N,F,Date.now(),K):await(0,M.promisify)(u.rename)(N,F)}catch(ee){if(N.toLowerCase()!==F.toLowerCase()&&ee.code==="EXDEV"||N.endsWith("."))await C(N,F,{preserveSymlinks:!1}),await S(N,w.MOVE);else throw ee}}async function k(N,F,K,ee,Y=0){try{return await(0,M.promisify)(u.rename)(N,F)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${Q}`),Q;if(Y===0){let Z=!1;try{const{stat:ae}=await f.stat(F);ae.isFile()||(Z=!0)}catch{}if(Z)throw Q}return await(0,A.$hh)(Math.min(100,Y*10)),k(N,F,K,ee,Y+1)}}async function C(N,F,K){return B(N,F,{root:{source:N,target:F},options:K,handledSourcePaths:new Set})}const O=511;async function B(N,F,K){if(K.handledSourcePaths.has(N))return;K.handledSourcePaths.add(N);const{stat:ee,symbolicLink:Y}=await f.stat(N);if(Y){if(K.options.preserveSymlinks)try{return await j(N,F,K)}catch{}if(Y.dangling)return}return ee.isDirectory()?z(N,F,ee.mode&O,K):T(N,F,ee.mode&O)}async function z(N,F,K,ee){await e.Promises.mkdir(F,{recursive:!0,mode:K});const Y=await c(N);for(const Q of Y)await B((0,p.$jc)(N,Q),(0,p.$jc)(F,Q),ee)}async function T(N,F,K){await e.Promises.copyFile(N,F),await e.Promises.chmod(F,K)}async function j(N,F,K){let ee=await e.Promises.readlink(N);(0,P.$gg)(ee,K.root.source,!E.$k)&&(ee=(0,p.$jc)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,F)}e.Promises=new class{get access(){return(0,M.promisify)(u.access)}get stat(){return(0,M.promisify)(u.stat)}get lstat(){return(0,M.promisify)(u.lstat)}get utimes(){return(0,M.promisify)(u.utimes)}get read(){return(N,F,K,ee,Y)=>new Promise((Q,Z)=>{u.read(N,F,K,ee,Y,(ae,_,ge)=>ae?Z(ae):Q({bytesRead:_,buffer:ge}))})}get readFile(){return(0,M.promisify)(u.readFile)}get write(){return(N,F,K,ee,Y)=>new Promise((Q,Z)=>{u.write(N,F,K,ee,Y,(ae,_,ge)=>ae?Z(ae):Q({bytesWritten:_,buffer:ge}))})}get appendFile(){return(0,M.promisify)(u.appendFile)}get fdatasync(){return(0,M.promisify)(u.fdatasync)}get truncate(){return(0,M.promisify)(u.truncate)}get copyFile(){return(0,M.promisify)(u.copyFile)}get open(){return(0,M.promisify)(u.open)}get close(){return(0,M.promisify)(u.close)}get symlink(){return(0,M.promisify)(u.symlink)}get readlink(){return(0,M.promisify)(u.readlink)}get chmod(){return(0,M.promisify)(u.chmod)}get mkdir(){return(0,M.promisify)(u.mkdir)}get unlink(){return(0,M.promisify)(u.unlink)}get rmdir(){return(0,M.promisify)(u.rmdir)}get realpath(){return(0,M.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return a}get writeFile(){return s}get rm(){return S}get rename(){return v}get copy(){return C}}}),define(Se[104],De([1,0,57,17,11,14,31]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=b,e.$Kq=p,e.$Lq=E,e.$Mq=R;function b(w){if(M.$k)return w;const S=(0,L.$mc)(w);if(w===S)return w;const y=((0,L.$nc)(w)||w).toLowerCase();try{const g=(0,P.readdirSync)(S).filter(c=>c.toLowerCase()===y);if(g.length===1){const c=b(S);if(c)return(0,L.$jc)(c,g[0])}else if(g.length>1){const c=g.indexOf(y);if(c>=0){const n=b(S);if(n)return(0,L.$jc)(n,g[c])}}}catch{}return null}async function p(w){if(M.$k)return w;const S=(0,L.$mc)(w);if(w===S)return w;const y=((0,L.$nc)(w)||w).toLowerCase();try{const g=(await P.Promises.readdir(S)).filter(c=>c.toLowerCase()===y);if(g.length===1){const c=await p(S);if(c)return(0,L.$jc)(c,g[0])}else if(g.length>1){const c=g.indexOf(y);if(c>=0){const n=await p(S);if(n)return(0,L.$jc)(n,g[c])}}}catch{}return null}async function E(w){try{return await P.Promises.realpath(w)}catch{const y=I(w);return await P.Promises.access(y,u.constants.R_OK),y}}function R(w){try{return u.realpathSync(w)}catch{const y=I(w);return u.accessSync(y,u.constants.R_OK),y}}function I(w){return(0,A.$5e)((0,L.$hc)(w),L.sep)}}),define(Se[105],De([1,0,17,11,50,102,18,31]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$$l=p,e.$_l=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function p(I=M.env){return I.comspec||"cmd.exe"}function E(I){let w=[],S=!1;const y=function(h){if(S){w.push(h);return}(!I.send(h,c=>{if(c&&console.error(c),S=!1,w.length>0){const n=w.slice(0);w=[],n.forEach(i=>y(i))}})||L.$i)&&(S=!0)};return{send:y}}var R;(function(I){async function w(S,y,h){if(u.$ic(S))return S;if(y===void 0&&(y=M.cwd()),u.$mc(S)!=="."||(h===void 0&&P.$Tf(M.env.PATH)&&(h=M.env.PATH.split(u.$tc)),h===void 0||h.length===0))return u.$jc(y,S);async function c(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(u.$ic(n)?i=u.$jc(n,S):i=u.$jc(y,n,S),await c(i))return i;let r=i+".com";if(await c(r)||(r=i+".exe",await c(r)))return r}return u.$jc(y,S)}I.findExecutable=w})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(fe,e,u,L){var M=arguments.length,A=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,u):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(fe,e,u,L);else for(var b=fe.length-1;b>=0;b--)(P=fe[b])&&(A=(M<3?P(A):M>3?P(e,u,A):P(e,u))||A);return M>3&&A&&Object.defineProperty(e,u,A),A};define(Se[80],De([1,0,19,8,21,22,53,13,4,3,56,14,18]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Rh=e.$Qh=void 0,e.$Sh=d,e.$Th=m,e.$Yh=O,e.$Zh=B;var S;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(S||(S={}));function y(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(h||(h={}));function g(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(c||(c={}));function n(Y){let Q=0;for(let Z=0;;Z+=7){const ae=Y.read(1);if(Q|=(ae.buffer[0]&127)<<Z,!(ae.buffer[0]&128))return Q}}const i=l(0);function r(Y,Q){if(Q===0){Y.write(i);return}let Z=0;for(let _=Q;_!==0;_=_>>>7)Z++;const ae=M.$te.alloc(Z);for(let _=0;Q!==0;_++)ae.buffer[_]=Q&127,Q=Q>>>7,Q>0&&(ae.buffer[_]|=128);Y.write(ae)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const Z=this.b.slice(this.a,this.a+Q);return this.a+=Z.byteLength,Z}}e.$Qh=a;class t{constructor(){this.a=[]}get buffer(){return M.$te.concat(this.a)}write(Q){this.a.push(Q)}}e.$Rh=t;var f;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(f||(f={}));function l(Y){const Q=M.$te.alloc(1);return Q.writeUInt8(Y,0),Q}const s={Undefined:l(f.Undefined),String:l(f.String),Buffer:l(f.Buffer),VSBuffer:l(f.VSBuffer),Array:l(f.Array),Object:l(f.Object),Uint:l(f.Int)},o=typeof Buffer<"u";function d(Y,Q){if(typeof Q>"u")Y.write(s.Undefined);else if(typeof Q=="string"){const Z=M.$te.fromString(Q);Y.write(s.String),r(Y,Z.byteLength),Y.write(Z)}else if(o&&Buffer.isBuffer(Q)){const Z=M.$te.wrap(Q);Y.write(s.Buffer),r(Y,Z.byteLength),Y.write(Z)}else if(Q instanceof M.$te)Y.write(s.VSBuffer),r(Y,Q.byteLength),Y.write(Q);else if(Array.isArray(Q)){Y.write(s.Array),r(Y,Q.length);for(const Z of Q)d(Y,Z)}else if(typeof Q=="number"&&(Q|0)===Q)Y.write(s.Uint),r(Y,Q);else{const Z=M.$te.fromString(JSON.stringify(Q));Y.write(s.Object),r(Y,Z.byteLength),Y.write(Z)}}function m(Y){switch(Y.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return Y.read(n(Y)).toString();case f.Buffer:return Y.read(n(Y)).buffer;case f.VSBuffer:return Y.read(n(Y));case f.Array:{const Z=n(Y),ae=[];for(let _=0;_<Z;_++)ae.push(m(Y));return ae}case f.Object:return JSON.parse(Y.read(n(Y)).toString());case f.Int:return n(Y)}}class D{constructor(Q,Z,ae=null,_=1e3){this.h=Q,this.j=Z,this.k=ae,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.q(ge)),this.m({type:200})}registerChannel(Q,Z){this.b.set(Q,Z),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const Z=this.o([Q.type]);this.k?.logOutgoing(Z,0,1,g(Q.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(Z,Q.id,1,g(Q.type),Q.data);return}}}o(Q,Z=void 0){const ae=new t;return d(ae,Q),d(ae,Z),this.p(ae.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const Z=new a(Q),ae=m(Z),_=m(Z),ge=ae[0];switch(ge){case 100:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${y(ge)}: ${ae[2]}.${ae[3]}`,_),this.s({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 102:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${y(ge)}: ${ae[2]}.${ae[3]}`,_),this.t({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 101:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${y(ge)}`),this.u({type:ge,id:ae[1]});case 103:return this.k?.logIncoming(Q.byteLength,ae[1],1,`${y(ge)}`),this.u({type:ge,id:ae[1]})}}s(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const ae=new A.$de;let _;try{_=Z.call(this.j,Q.name,Q.arg,ae.token)}catch(re){_=Promise.reject(re)}const ge=Q.id;_.then(re=>{this.m({id:ge,data:re,type:201})},re=>{re instanceof Error?this.m({id:ge,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split?re.stack.split(`
`):re.stack:void 0},type:202}):this.m({id:ge,data:re,type:203})}).finally(()=>{se.dispose(),this.d.delete(Q.id)});const se=(0,E.$Rc)(()=>ae.cancel());this.d.set(Q.id,se)}t(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const ae=Q.id,ge=Z.listen(this.j,Q.name,Q.arg)(se=>this.m({id:ae,data:se,type:204}));this.d.set(Q.id,ge)}u(Q){const Z=this.d.get(Q.id);Z&&(Z.dispose(),this.d.delete(Q.id))}v(Q){let Z=this.g.get(Q.channelName);Z||(Z=[],this.g.set(Q.channelName,Z));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Q,timeoutTimer:ae})}w(Q){const Z=this.g.get(Q);if(Z){for(const ae of Z)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=D;var $;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class v{constructor(Q,Z=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=Z}getChannel(Q){const Z=this;return{call(ae,_,ge){return Z.a?Promise.reject(new b.$5):Z.m(Q,ae,_,ge)},listen(ae,_){return Z.a?p.Event.None:Z.o(Q,ae,_)}}}m(Q,Z,ae,_=A.CancellationToken.None){const ge=this.g++,re={id:ge,type:100,channelName:Q,name:Z,arg:ae};if(_.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((ye,le)=>{if(_.isCancellationRequested)return le(new b.$5);const ue=()=>{const x=he=>{switch(he.type){case 201:this.f.delete(ge),ye(he.data);break;case 202:{this.f.delete(ge);const pe=new Error(he.data.message);pe.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,pe.name=he.data.name,le(pe);break}case 203:this.f.delete(ge),le(he.data);break}};this.f.set(ge,x),this.p(re)};let ce=null;this.b===c.Idle?ue():(ce=(0,L.$6g)(x=>this.u()),ce.then(()=>{ce=null,ue()}));const de=()=>{ce?(ce.cancel(),ce=null):this.p({id:ge,type:101}),le(new b.$5)},H=_.onCancellationRequested(de);U=(0,E.$Qc)((0,E.$Rc)(de),H),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,Z,ae){const _=this.g++,se={id:_,type:102,channelName:Q,name:Z,arg:ae};let re=null;const U=new p.$6d({onWillAddFirstListener:()=>{re=(0,L.$6g)(ye=>this.u()),re.then(()=>{re=null,this.d.add(U),this.p(se)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(U),this.p({id:_,type:103}))}}),ie=ye=>U.fire(ye.data);return this.f.set(_,ie),U.event}p(Q){switch(Q.type){case 100:case 102:{const Z=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(Z,Q.id,0,`${y(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Z=this.q([Q.type,Q.id]);this.j?.logOutgoing(Z,Q.id,0,y(Q.type));return}}}q(Q,Z=void 0){const ae=new t;return d(ae,Q),d(ae,Z),this.r(ae.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const Z=new a(Q),ae=m(Z),_=m(Z),ge=ae[0];switch(ge){case 200:return this.j?.logIncoming(Q.byteLength,0,0,g(ge)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ae[1],0,g(ge),_),this.t({type:ae[0],id:ae[1],data:_})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=v,Je([P.$Kh],v.prototype,"onDidInitializePromise",null);class k{get connections(){const Q=[];return this.f.forEach(Z=>Q.push(Z)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new p.$6d,this.onDidAddConnection=this.g.event,this.h=new p.$6d,this.onDidRemoveConnection=this.h.event,this.j=new E.$Sc,this.j.add(Q(({protocol:Z,onDidClientDisconnect:ae})=>{const _=p.Event.once(Z.onMessage);this.j.add(_(ge=>{const se=new a(ge),re=m(se),U=new D(Z,re),ie=new v(Z);this.a.forEach((le,ue)=>U.registerChannel(ue,le));const ye={channelServer:U,channelClient:ie,ctx:re};this.f.add(ye),this.g.fire(ye),this.j.add(ae(()=>{U.dispose(),ie.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Q,Z){const ae=this;return{call(_,ge,se){let re;if((0,w.$8f)(Z)){const ie=(0,u.$4b)(ae.connections.filter(Z));re=ie?Promise.resolve(ie):p.Event.toPromise(p.Event.filter(ae.onDidAddConnection,Z))}else re=Z.routeCall(ae,_,ge);const U=re.then(ie=>ie.channelClient.getChannel(Q));return O(U).call(_,ge,se)},listen(_,ge){if((0,w.$8f)(Z))return ae.k(Q,Z,_,ge);const se=Z.routeEvent(ae,_,ge).then(re=>re.channelClient.getChannel(Q));return O(se).listen(_,ge)}}}k(Q,Z,ae,_){const ge=this;let se;const re=new p.$6d({onWillAddFirstListener:()=>{se=new E.$Sc;const U=new p.$_d,ie=new Map,ye=ue=>{const de=ue.channelClient.getChannel(Q).listen(ae,_),H=U.add(de);ie.set(ue,H)},le=ue=>{const ce=ie.get(ue);ce&&(ce.dispose(),ie.delete(ue))};ge.connections.filter(Z).forEach(ye),p.Event.filter(ge.onDidAddConnection,Z)(ye,void 0,se),ge.onDidRemoveConnection(le,void 0,se),U.event(re.fire,re,se),se.add(U)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return re.event}registerChannel(Q,Z){this.a.set(Q,Z);for(const ae of this.f)ae.channelServer.registerChannel(Q,Z)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=k;class C{constructor(Q,Z,ae=null){const _=new t;d(_,Z),Q.send(_.buffer),this.a=new v(Q,ae),this.d=new D(Q,Z,ae)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,Z){this.d.registerChannel(Q,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=C;function O(Y){return{call(Q,Z,ae){return Y.then(_=>_.call(Q,Z,ae))},listen(Q,Z){const ae=new p.$ce;return Y.then(_=>ae.input=_.listen(Q,Z)),ae.event}}}function B(Y){let Q=!1;return{call(Z,ae,_){return Q?Y.call(Z,ae,_):(0,L.$hh)(0).then(()=>Q=!0).then(()=>Y.call(Z,ae,_))},listen(Z,ae){if(Q)return Y.listen(Z,ae);const _=new p.$ce;return(0,L.$hh)(0).then(()=>Q=!0).then(()=>_.input=Y.listen(Z,ae)),_.event}}}class z{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const Z of Q.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await p.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$1h=z;var T;(function(Y){function Q(ge,se,re){const U=ge,ie=re&&re.disableMarshalling,ye=new Map;for(const le in U)ae(le)&&ye.set(le,p.Event.buffer(U[le],!0,void 0,se));return new class{listen(le,ue,ce){const de=ye.get(ue);if(de)return de;const H=U[ue];if(typeof H=="function"){if(_(ue))return H.call(U,ce);if(ae(ue))return ye.set(ue,p.Event.buffer(U[ue],!0,void 0,se)),ye.get(ue)}throw new b.$bb(`Event not found: ${ue}`)}call(le,ue,ce){const de=U[ue];if(typeof de=="function"){if(!ie&&Array.isArray(ce))for(let x=0;x<ce.length;x++)ce[x]=(0,R.$Ph)(ce[x]);let H=de.apply(U,ce);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new b.$bb(`Method not found: ${ue}`)}}}Y.fromService=Q;function Z(ge,se){const re=se&&se.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return se?.properties?.has(ie)?se.properties.get(ie):_(ie)?function(ye){return ge.listen(ie,ye)}:ae(ie)?ge.listen(ie):async function(...ye){let le;se&&!(0,w.$3f)(se.context)?le=[se.context,...ye]:le=ye;const ue=await ge.call(ie,le);return re?ue:(0,R.$Ph)(ue)};throw new b.$bb(`Property not found: ${String(ie)}`)}})}Y.toService=Z;function ae(ge){return ge[0]==="o"&&ge[1]==="n"&&I.$jf(ge.charCodeAt(2))}function _(ge){return/^onDynamic/.test(ge)&&I.$jf(ge.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const Q=Y.toString();if(Q!=="[object Object]")return Q}return Y}function F(Y){return Array.isArray(Y)?Y.map(N):N(Y)}function K(Y,Q,Z,ae,_,ge,se){se=F(se);const re=j[_],U=re[ae%re.length];let ie=[`%c[${Y}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ge)?(ie=ie.concat(se),ie.push(")")):ie.push(se),console.log.apply(console,ie)}class ee{constructor(Q,Z){this.d=Q,this.f=Z,this.a=0,this.b=0}logOutgoing(Q,Z,ae,_,ge){this.b+=Q,K(this.d,this.b,Q,Z,ae,_,ge)}logIncoming(Q,Z,ae,_,ge){this.a+=Q,K(this.f,this.a,Q,Z,ae,_,ge)}}e.$2h=ee}),define(Se[81],De([1,0,21,4,3,80]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.ProtocolConstants=e.$3h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var b;(function(s){s.enableDiagnostics=!1,s.records=[];const o=new WeakMap;let d=0;function m($,v){if(!o.has($)){const k=String(++d);o.set($,k)}return o.get($)}function D($,v,k,C){if(!s.enableDiagnostics)return;const O=m($,v);if(C instanceof u.$te||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const B=u.$te.alloc(C.byteLength);B.set(C),s.records.push({timestamp:Date.now(),id:O,label:v,type:k,buff:B})}else s.records.push({timestamp:Date.now(),id:O,label:v,type:k,data:C})}s.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let E=null;function R(){return E||(E=u.$te.alloc(0)),E}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,d){if(o===0)return R();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const v=this.a[0];return d&&(this.a.shift(),this.b-=o),v}if(this.a[0].byteLength>o){const v=this.a[0].slice(0,o);return d&&(this.a[0]=this.a[0].slice(o),this.b-=o),v}const m=u.$te.alloc(o);let D=0,$=0;for(;o>0;){const v=this.a[$];if(v.byteLength>o){const k=v.slice(0,o);m.set(k,D),D+=o,d&&(this.a[$]=v.slice(o),this.b-=o),o-=o}else m.set(v,D),D+=v.byteLength,d?(this.a.shift(),this.b-=v.byteLength):$++,o-=v.byteLength}return m}}e.$3h=I;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function S(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class h{constructor(o,d,m,D){this.type=o,this.id=d,this.ack=m,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends M.$Tc{constructor(o){super(),this.f=this.B(new L.$6d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new I,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,D=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new h(m,D,$,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=u.$te.alloc(13);d.writeUInt8(o.type,0),d.writeUInt32BE(o.id,1),d.writeUInt32BE(o.ack,5),d.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(d,o.data)}g(o,d){const m=this.f===0;return this.d.push(o,d),this.f+=o.byteLength+d.byteLength,m}h(){const o=u.$te.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,d){this.g(o,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class n extends M.$Tc{constructor(o){super(),this.f=new L.$6d,this.onMessage=this.f.event,this.g=new L.$6d,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new c(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new h(1,0,0,o))}}e.$4h=n;class i extends A.$Xh{static fromSocket(o,d){return new i(new n(o),d)}get onDidDispose(){return this.b.onDidDispose}constructor(o,d,m=null){super(o,d,m),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$5h=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$6d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$6h=r;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,d=this.a;for(;d;)d=d.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let d=0,m=this.a;for(;m;)o[d++]=m.data,m=m.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const d=new a(o);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const o=Date.now();for(let d=0;d<f.a;d++)this.c[d]=o-1e3*d;setInterval(()=>{for(let d=f.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),d=(1+f.a)*1e3;let m=0;for(let D=0;D<f.a;D++)o-this.c[D]<=d&&m++;return 1-m/f.a}hasHighLoad(){return this.d()>=.5}}class l{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??f.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new M.$Sc,this.o=o.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new h(5,0,0,R());this.p.write(o),this.p.flush()}sendPause(){const o=new h(7,0,0,R());this.p.write(o)}sendResume(){const o=new h(8,0,0,R());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,d){this.a=!0,this.r.dispose(),this.r=new M.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new h(3,0,this.h,R());this.p.write(o);const d=this.b.toArray();for(let m=0,D=d.length;m<D;m++)this.p.write(d[m]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const d=this.b.peek();if(d&&d.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new h(6,0,0,R())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let m=0,D=d.length;m<D;m++)this.p.write(d[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const d=++this.c;this.h=this.g;const m=new h(1,d,this.h,o);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(o){const d=new h(2,0,0,o);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),d=Date.now()-o.writtenTime,m=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(d>=2e4&&m>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:m});return}const $=Math.max(2e4-d,2e4-m,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new h(3,0,this.h,R());this.p.write(o)}D(){this.h=this.g;const o=new h(9,0,this.h,R());this.p.write(o)}}e.$7h=l}),define(Se[192],De([1,0,51,8,21,22,190,13,4,3,24,105,102,80]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;class y extends S.$Uh{constructor(c){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",n=>M.$te.wrap(Buffer.from(n,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Gq=y;class h{constructor(c,n){this.i=c,this.j=n,this.c=new Set,this.g=new Map,this.h=new p.$6d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new L.$dh(i),this.d=null,this.f=null}getChannel(c){const n=this;return{call(i,r,a){return n.k(c,i,r,a)},listen(i,r){return n.l(c,i,r)}}}k(c,n,i,r=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const a=this.n(c),t=(0,L.$6g)(s=>a.call(n,i,s)),f=r.onCancellationRequested(()=>t.cancel()),l=(0,E.$Rc)(()=>t.cancel());return this.c.add(l),t.finally(()=>{f.dispose(),this.c.delete(l),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,n,i){if(!this.b)return p.Event.None;this.b.cancel();let r;const a=new p.$6d({onWillAddFirstListener:()=>{r=this.n(c).listen(n,i)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,R.$Mn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.$0l)(n.env),this.d=(0,u.fork)(this.i,c,n);const i=new p.$6d;p.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,P.$Cq)(o)){(0,P.log)(o,`IPC Library: ${this.j.serverName}`);return}i.fire(M.$te.wrap(Buffer.from(o,"base64")))});const a=this.j.useQueue?(0,I.$_l)(this.d):this.d,t=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),f=i.event,l={send:t,onMessage:f};this.f=new S.$Vh(l);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,d)=>{process.removeListener("exit",s),this.c.forEach(m=>(0,E.$Oc)(m)),this.c.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:d})})}return this.f}n(c){let n=this.g.get(c);return n||(n=this.m.getChannel(c),this.g.set(c,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Hq=h}),define(Se[193],De([1,0,8,4,3,56,18]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.StorageState=e.StorageHint=void 0,e.$Fp=p;var b;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function p(w){const S=w;return S?.changed instanceof Map||S?.deleted instanceof Set}var E;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(E||(e.StorageState=E={}));class R extends M.$Tc{static{this.a=100}constructor(S,y=Object.create(null)){super(),this.r=S,this.s=y,this.b=this.B(new L.$9d),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new u.$eh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((y,h)=>this.w(h,y)),S.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(S,y){if(this.c===E.Closed)return;let h=!1;(0,P.$3f)(y)?h=this.f.delete(S):this.f.get(S)!==y&&(this.f.set(S,y),h=!0),h&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,y){const h=this.f.get(S);return(0,P.$3f)(h)?y:h}getBoolean(S,y){const h=this.get(S);return(0,P.$3f)(h)?y:h==="true"}getNumber(S,y){const h=this.get(S);return(0,P.$3f)(h)?y:parseInt(h,10)}getObject(S,y){const h=this.get(S);return(0,P.$3f)(h)?y:(0,A.$Oh)(h)}async set(S,y,h=!1){if(this.c===E.Closed)return;if((0,P.$3f)(y))return this.delete(S,h);const g=(0,P.$Vf)(y)||Array.isArray(y)?(0,A.$Nh)(y):String(y);if(this.f.get(S)!==g)return this.f.set(S,g),this.j.set(S,g),this.h.delete(S),this.b.fire({key:S,external:h}),this.D()}async delete(S,y=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:y}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Gp=R;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((y,h)=>this.a.set(h,y)),S.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Hp=I}),define(Se[194],De([1,0,14,11,21]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0,e.$qt=R,e.$rt=I;let A;function P(){return A||(A=new TextDecoder("UTF-16LE")),A}let b;function p(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function R(){return E||(E=L.$D()?P():p()),E}function I(y,h,g){const c=new Uint16Array(y.buffer,h,g);return g>0&&(c[0]===65279||c[0]===65534)?w(y,h,g):P().decode(c)}function w(y,h,g){const c=[];let n=0;for(let i=0;i<g;i++){const r=M.$ve(y,h);h+=2,c[n++]=String.fromCharCode(r)}return c.join("")}class S{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return R().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const g=this.a-this.d;g<=1&&(g===0||u.$of(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const g=h.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=h;return}for(let c=0;c<g;c++)this.b[this.d++]=h.charCodeAt(c)}}e.$st=S}),define(Se[195],De([1,0,21,194]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$ut=P;function M(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,R,I,w){this.oldPosition=E,this.oldText=R,this.newPosition=I,this.newText=w}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,R,I){const w=R.length;u.$ye(E,w,I),I+=4;for(let S=0;S<w;S++)u.$we(E,R.charCodeAt(S),I),I+=2;return I}static d(E,R){const I=u.$xe(E,R);return R+=4,(0,L.$rt)(E,R,I)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(E,R){return u.$ye(E,this.oldPosition,R),R+=4,u.$ye(E,this.newPosition,R),R+=4,R=A.c(E,this.oldText,R),R=A.c(E,this.newText,R),R}static read(E,R,I){const w=u.$xe(E,R);R+=4;const S=u.$xe(E,R);R+=4;const y=A.d(E,R);R+=A.a(y);const h=A.d(E,R);return R+=A.a(h),I.push(new A(w,y,S,h)),R}}e.$tt=A;function P(p,E){return p===null||p.length===0?E:new b(p,E).compress()}class b{constructor(E,R){this.a=E,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,R=0,I=this.n(E),w=this.l(R);for(;E<this.f||R<this.h;){if(I===null){this.k(w),w=this.l(++R);continue}if(w===null){this.m(I),I=this.n(++E);continue}if(w.oldEnd<=I.newPosition){this.k(w),w=this.l(++R);continue}if(I.newEnd<=w.oldPosition){this.m(I),I=this.n(++E);continue}if(w.oldPosition<I.newPosition){const[c,n]=b.r(w,I.newPosition-w.oldPosition);this.k(c),w=n;continue}if(I.newPosition<w.oldPosition){const[c,n]=b.q(I,w.oldPosition-I.newPosition);this.m(c),I=n;continue}let h,g;if(w.oldEnd===I.newEnd)h=I,g=w,I=this.n(++E),w=this.l(++R);else if(w.oldEnd<I.newEnd){const[c,n]=b.q(I,w.oldLength);h=c,g=w,I=n,w=this.l(++R)}else{const[c,n]=b.r(w,I.newLength);h=I,g=c,I=this.n(++E),w=n}this.d[this.e++]=new A(h.oldPosition,h.oldText,g.newPosition,g.newText),this.g+=h.newLength-h.oldLength,this.j+=g.newLength-g.oldLength}const S=b.s(this.d);return b.t(S)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,R){return new A(R.oldPosition-E,R.oldText,R.newPosition,R.newText)}static p(E,R){return new A(R.oldPosition,R.oldText,R.newPosition+E,R.newText)}static q(E,R){const I=E.newText.substr(0,R),w=E.newText.substr(R);return[new A(E.oldPosition,E.oldText,E.newPosition,I),new A(E.oldEnd,"",E.newPosition+R,w)]}static r(E,R){const I=E.oldText.substr(0,R),w=E.oldText.substr(R);return[new A(E.oldPosition,I,E.newPosition,E.newText),new A(E.oldPosition+R,w,E.newEnd,"")]}static s(E){if(E.length===0)return E;const R=[];let I=0,w=E[0];for(let S=1;S<E.length;S++){const y=E[S];w.oldEnd===y.oldPosition?w=new A(w.oldPosition,w.oldText+y.oldText,w.newPosition,w.newText+y.newText):(R[I++]=w,w=y)}return R[I++]=w,R}static t(E){if(E.length===0)return E;const R=[];let I=0;for(let w=0;w<E.length;w++){const S=E[w];S.oldText!==S.newText&&(R[I++]=S)}return R}}}),define(Se[196],De([1,0,35,17]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=M,e.$St=A;function M(P,b,p,E,R,I){if(Array.isArray(P)){let w=0;for(const S of P){const y=M(S,b,p,E,R,I);if(y===10)return y;y>w&&(w=y)}return w}else{if(typeof P=="string")return E?P==="*"?5:P===p?10:0:0;if(P){const{language:w,pattern:S,scheme:y,hasAccessToAllModels:h,notebookType:g}=P;if(!E&&!h)return 0;g&&R&&(b=R);let c=0;if(y)if(y===b.scheme)c=10;else if(y==="*")c=5;else return 0;if(w)if(w===p)c=10;else if(w==="*")c=Math.max(c,5);else return 0;if(g)if(g===I)c=10;else if(g==="*"&&I!==void 0)c=Math.max(c,5);else return 0;if(S){let n;if(typeof S=="string"?n=S:n={...S,base:(0,L.$hc)(S.base)},n===b.fsPath||(0,u.$_j)(n,b.fsPath))c=10;else return 0}return c}else return 0}}function A(P){return typeof P=="string"?!1:Array.isArray(P)?P.some(A):!!P.notebookType}}),define(Se[197],De([1,0,4,14,29,78,130,172,195,3]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=void 0;class R extends E.$Tc{constructor(w,S,y,h,g,c,n){super(),this.m=this.B(new u.$6d),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=h,this.h=g,this.c=new P.$tC(w,y,n)}equals(w){return!(w instanceof R)||this.f!==w.f||this.getEOL()!==w.getEOL()?!1:this.c.equal(w.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(w){return this.c.createSnapshot(w?this.f:"")}getOffsetAt(w,S){return this.c.getOffsetAt(w,S)}getPositionAt(w){return this.c.getPositionAt(w)}getRangeAt(w,S){const y=w+S,h=this.getPositionAt(w),g=this.getPositionAt(y);return new M.$$s(h.lineNumber,h.column,g.lineNumber,g.column)}getValueInRange(w,S=0){if(w.isEmpty())return"";const y=this.n(S);return this.c.getValueInRange(w,y)}getValueLengthInRange(w,S=0){if(w.isEmpty())return 0;if(w.startLineNumber===w.endLineNumber)return w.endColumn-w.startColumn;const y=this.getOffsetAt(w.startLineNumber,w.startColumn),h=this.getOffsetAt(w.endLineNumber,w.endColumn);let g=0;const c=this.n(S),n=this.getEOL();if(c.length!==n.length){const i=c.length-n.length,r=w.endLineNumber-w.startLineNumber;g=i*r}return h-y+g}getCharacterCountInRange(w,S=0){if(this.j){let y=0;const h=w.startLineNumber,g=w.endLineNumber;for(let c=h;c<=g;c++){const n=this.getLineContent(c),i=c===h?w.startColumn-1:0,r=c===g?w.endColumn-1:n.length;for(let a=i;a<r;a++)L.$of(n.charCodeAt(a))?(y=y+1,a=a+1):y=y+1}return y+=this.n(S).length*(g-h),y}return this.getValueLengthInRange(w,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(w){return this.c.getLineContent(w)}getLineCharCode(w,S){return this.c.getLineCharCode(w,S)}getCharCode(w){return this.c.getCharCode(w)}getLineLength(w){return this.c.getLineLength(w)}getLineMinColumn(w){return 1}getLineMaxColumn(w){return this.getLineLength(w)+1}getLineFirstNonWhitespaceColumn(w){const S=L.$_e(this.getLineContent(w));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(w){const S=L.$bf(this.getLineContent(w));return S===-1?0:S+2}n(w){switch(w){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(w){this.c.setEOL(w)}applyEdits(w,S,y){let h=this.g,g=this.h,c=this.j,n=!0,i=[];for(let o=0;o<w.length;o++){const d=w[o];n&&d._isTracked&&(n=!1);const m=d.range;if(d.text){let C=!0;c||(C=!L.$zf(d.text),c=C),!h&&C&&(h=L.$yf(d.text)),!g&&C&&(g=L.$Bf(d.text))}let D="",$=0,v=0,k=0;if(d.text){let C;[$,v,k,C]=(0,b.$Kt)(d.text);const O=this.getEOL();C===0||C===(O===`\r
`?2:1)?D=d.text:D=d.text.replace(/\r\n|\r|\n/g,O)}i[o]={sortIndex:o,identifier:d.identifier||null,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m),text:D,eolCount:$,firstLineLength:v,lastLineLength:k,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let o=0,d=i.length-1;o<d;o++){const m=i[o].range.getEndPosition(),D=i[o+1].range.getStartPosition();if(D.isBeforeOrEqual(m)){if(D.isBefore(m))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const a=y||S?R._getInverseEditRanges(i):[],t=[];if(S)for(let o=0;o<i.length;o++){const d=i[o],m=a[o];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let D=m.startLineNumber;D<=m.endLineNumber;D++){let $="";D===m.startLineNumber&&($=this.getLineContent(d.range.startLineNumber),L.$_e($)!==-1)||t.push({lineNumber:D,oldContent:$})}}let f=null;if(y){let o=0;f=[];for(let d=0;d<i.length;d++){const m=i[d],D=a[d],$=this.getValueInRange(m.range),v=m.rangeOffset+o;o+=m.text.length-$.length,f[d]={sortIndex:m.sortIndex,identifier:m.identifier,range:D,text:$,textChange:new p.$tt(m.rangeOffset,$,v,m.text)}}r||f.sort((d,m)=>d.sortIndex-m.sortIndex)}this.g=h,this.h=g,this.j=c;const l=this.t(i);let s=null;if(S&&t.length>0){t.sort((o,d)=>d.lineNumber-o.lineNumber),s=[];for(let o=0,d=t.length;o<d;o++){const m=t[o].lineNumber;if(o>0&&t[o-1].lineNumber===m)continue;const D=t[o].oldContent,$=this.getLineContent(m);$.length===0||$===D||L.$_e($)!==-1||s.push(m)}}return this.m.fire(),new A.$wv(f,l,s)}s(w){return w.length<1e3?w:[this._toSingleEditOperation(w)]}_toSingleEditOperation(w){let S=!1;const y=w[0].range,h=w[w.length-1].range,g=new M.$$s(y.startLineNumber,y.startColumn,h.endLineNumber,h.endColumn);let c=y.startLineNumber,n=y.startColumn;const i=[];for(let l=0,s=w.length;l<s;l++){const o=w[l],d=o.range;S=S||o.forceMoveMarkers,i.push(this.getValueInRange(new M.$$s(c,n,d.startLineNumber,d.startColumn))),o.text.length>0&&i.push(o.text),c=d.endLineNumber,n=d.endColumn}const r=i.join(""),[a,t,f]=(0,b.$Kt)(r);return{sortIndex:0,identifier:w[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:f,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(w){w.sort(R.w);const S=[];for(let y=0;y<w.length;y++){const h=w[y],g=h.range.startLineNumber,c=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(g===n&&c===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const r=new M.$$s(g,c,n,i);S.push({range:r,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return S}findMatchesLineByLine(w,S,y,h){return this.c.findMatchesLineByLine(w,S,y,h)}getPieceTree(){return this.c}static _getInverseEditRange(w,S){const y=w.startLineNumber,h=w.startColumn,[g,c,n]=(0,b.$Kt)(S);let i;if(S.length>0){const r=g+1;r===1?i=new M.$$s(y,h,y,h+c):i=new M.$$s(y,h,y+r-1,n+1)}else i=new M.$$s(y,h,y,h);return i}static _getInverseEditRanges(w){const S=[];let y=0,h=0,g=null;for(let c=0,n=w.length;c<n;c++){const i=w[c];let r,a;g?g.range.endLineNumber===i.range.startLineNumber?(r=y,a=h+(i.range.startColumn-g.range.endColumn)):(r=y+(i.range.startLineNumber-g.range.endLineNumber),a=i.range.startColumn):(r=i.range.startLineNumber,a=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new M.$$s(r,a,r,a+i.firstLineLength):t=new M.$$s(r,a,r+f-1,i.lastLineLength+1)}else t=new M.$$s(r,a,r,a);y=t.endLineNumber,h=t.endColumn,S.push(t),g=i}return S}static u(w,S){const y=M.$$s.compareRangesUsingEnds(w.range,S.range);return y===0?w.sortIndex-S.sortIndex:y}static w(w,S){const y=M.$$s.compareRangesUsingEnds(w.range,S.range);return y===0?S.sortIndex-w.sortIndex:-y}}e.$uC=R}),define(Se[198],De([1,0,14,130,197]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class A{constructor(p,E,R,I,w,S,y,h,g){this.a=p,this.b=E,this.c=R,this.d=I,this.e=w,this.f=S,this.g=y,this.h=h,this.j=g}k(p){const E=this.c+this.d+this.e,R=this.c+this.e;return E===0?p===1?`
`:`\r
`:R>E/2?`\r
`:`
`}create(p){const E=this.k(p),R=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let w=0,S=R.length;w<S;w++){const y=R[w].buffer.replace(/\r\n|\r|\n/g,E),h=(0,L.$pC)(y);R[w]=new L.$sC(y,h)}const I=new M.$uC(R,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class P{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&u.$Hf(p)&&(this.b=u.$Gf,p=p.substr(1));const E=p.charCodeAt(p.length-1);E===13||E>=55296&&E<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=E):(this.m(p,!1),this.c=!1,this.d=E)}m(p,E){!E&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const E=(0,L.$qC)(this.e,p);this.a.push(new L.$sC(p,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=u.$yf(p)),this.k||(this.k=u.$Bf(p)))}finish(p=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const E=(0,L.$pC)(p.buffer);p.lineStarts=E,this.d===13&&this.f++}}}e.$vC=P}),define(Se[134],De([1,0,21,11]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lab=p,e.$mab=R;var M;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(M||(M={}));function A(I){for(let w=0,S=I.length;w<S;w+=4){const y=I[w+0],h=I[w+1],g=I[w+2],c=I[w+3];I[w+0]=c,I[w+1]=g,I[w+2]=h,I[w+3]=y}}function P(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.$D()||A(w),u.$te.wrap(w)}function b(I){const w=I.buffer;if(L.$D()||A(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const S=new Uint8Array(w.byteLength);return S.set(w),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function p(I){const w=new Uint32Array(E(I));let S=0;if(w[S++]=I.id,I.type==="full")w[S++]=1,w[S++]=I.data.length,w.set(I.data,S),S+=I.data.length;else{w[S++]=2,w[S++]=I.deltas.length;for(const y of I.deltas)w[S++]=y.start,w[S++]=y.deleteCount,y.data?(w[S++]=y.data.length,w.set(y.data,S),S+=y.data.length):w[S++]=0}return P(w)}function E(I){let w=0;if(w+=2,I.type==="full")w+=1+I.data.length;else{w+=1,w+=3*I.deltas.length;for(const S of I.deltas)S.data&&(w+=S.data.length)}return w}function R(I){const w=b(I);let S=0;const y=w[S++];if(w[S++]===1){const n=w[S++],i=w.subarray(S,S+n);return S+=n,{id:y,type:"full",data:i}}const g=w[S++],c=[];for(let n=0;n<g;n++){const i=w[S++],r=w[S++],a=w[S++];let t;a>0&&(t=w.subarray(S,S+a),S+=a),c[n]={start:i,deleteCount:r,data:t}}return{id:y,type:"delta",deltas:c}}}),define(Se[199],De([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Se[135],De([1,0,19,24,11,175,129,199]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=k,e.filterValidationDecorations=pe;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=E;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(oe,Ie,Ge,xe){this.id=oe,this.name=Ie,this.defaultValue=Ge,this.schema=xe}applyUpdate(oe,Ie){return S(oe,Ie)}compute(oe,Ie,Ge){return Ge}}class w{constructor(oe,Ie){this.newValue=oe,this.didChange=Ie}}e.ApplyUpdateResult=w;function S(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new w(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const Ge=Array.isArray(ne)&&Array.isArray(oe)&&u.$ub(ne,oe);return new w(oe,!Ge)}let Ie=!1;for(const Ge in oe)if(oe.hasOwnProperty(Ge)){const xe=S(ne[Ge],oe[Ge]);xe.didChange&&(ne[Ge]=xe.newValue,Ie=!0)}return new w(ne,Ie)}class y{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ie){return S(oe,Ie)}validate(oe){return this.defaultValue}}class h{constructor(oe,Ie,Ge,xe){this.id=oe,this.name=Ie,this.defaultValue=Ge,this.schema=xe}applyUpdate(oe,Ie){return S(oe,Ie)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ie,Ge){return Ge}}function g(ne,oe){return typeof ne>"u"?oe:ne==="false"?!1:!!ne}class c extends h{constructor(oe,Ie,Ge,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ge),super(oe,Ie,Ge,xe)}validate(oe){return g(oe,this.defaultValue)}}function n(ne,oe,Ie,Ge){if(typeof ne>"u")return oe;let xe=parseInt(ne,10);return isNaN(xe)?oe:(xe=Math.max(Ie,xe),xe=Math.min(Ge,xe),xe|0)}class i extends h{static clampedInt(oe,Ie,Ge,xe){return n(oe,Ie,Ge,xe)}constructor(oe,Ie,Ge,xe,st,Le=void 0){typeof Le<"u"&&(Le.type="integer",Le.default=Ge,Le.minimum=xe,Le.maximum=st),super(oe,Ie,Ge,Le),this.minimum=xe,this.maximum=st}validate(oe){return i.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function r(ne,oe,Ie,Ge){if(typeof ne>"u")return oe;const xe=a.float(ne,oe);return a.clamp(xe,Ie,Ge)}class a extends h{static clamp(oe,Ie,Ge){return oe<Ie?Ie:oe>Ge?Ge:oe}static float(oe,Ie){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ie;const Ge=parseFloat(oe);return isNaN(Ge)?Ie:Ge}constructor(oe,Ie,Ge,xe,st){typeof st<"u"&&(st.type="number",st.default=Ge),super(oe,Ie,Ge,st),this.validationFn=xe}validate(oe){return this.validationFn(a.float(oe,this.defaultValue))}}class t extends h{static string(oe,Ie){return typeof oe!="string"?Ie:oe}constructor(oe,Ie,Ge,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ge),super(oe,Ie,Ge,xe)}validate(oe){return t.string(oe,this.defaultValue)}}function f(ne,oe,Ie,Ge){return typeof ne!="string"?oe:Ge&&ne in Ge?Ge[ne]:Ie.indexOf(ne)===-1?oe:ne}class l extends h{constructor(oe,Ie,Ge,xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=xe,st.default=Ge),super(oe,Ie,Ge,st),this.c=xe}validate(oe){return f(oe,this.defaultValue,this.c)}}class s extends I{constructor(oe,Ie,Ge,xe,st,Le,bt=void 0){typeof bt<"u"&&(bt.type="string",bt.enum=st,bt.default=xe),super(oe,Ie,Ge,bt),this.c=st,this.d=Le}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function o(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ie,Ge){return Ge===0?oe.accessibilitySupport:Ge}}class m extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:b.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertSpace:g(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function $(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(v||(e.TextEditorCursorStyle=v={}));function k(ne){switch(ne){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}function C(ne){switch(ne){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class O extends y{constructor(){super(141)}compute(oe,Ie,Ge){const xe=["monaco-editor"];return Ie.get(39)&&xe.push(Ie.get(39)),oe.extraEditorClassName&&xe.push(oe.extraEditorClassName),Ie.get(74)==="default"?xe.push("mouse-default"):Ie.get(74)==="copy"&&xe.push("mouse-copy"),Ie.get(111)&&xe.push("showUnused"),Ie.get(139)&&xe.push("showDeprecated"),xe.join(" ")}}class B extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(oe,Ie,Ge){return Ge&&oe.emptySelectionClipboard}}class z extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:b.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:b.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{cursorMoveOnType:g(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":f(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":f(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ie.loop,this.defaultValue.loop)}}}class T extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"||oe.length===0?T.OFF:oe==="true"?T.ON:oe:oe?T.ON:T.OFF}}e.EditorFontLigatures=T;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?j.OFF:oe==="true"?j.TRANSLATE:oe:oe?j.TRANSLATE:j.OFF}compute(oe,Ie,Ge){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class N extends y{constructor(){super(50)}compute(oe,Ie,Ge){return oe.fontInfo}}class F extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(oe){const Ie=a.float(oe,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(oe,Ie,Ge){return oe.fontInfo.fontSize}}class K extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(i.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class ee extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:Ge,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:Ge,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:Ge,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:Ge,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:Ge,description:b.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{multiple:f(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??f(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??f(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??f(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??f(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??f(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends I{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:b.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:g(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ie.above,this.defaultValue.above)}}}var Q;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Z extends y{constructor(){super(144)}compute(oe,Ie,Ge){return Z.computeLayout(Ie,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ie=oe.height/oe.lineHeight,Ge=Math.floor(oe.paddingTop/oe.lineHeight);let xe=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(xe=Math.max(xe,Ie-1));const st=(Ge+oe.viewLineCount+xe)/(oe.pixelRatio*oe.height),Le=Math.floor(oe.viewLineCount/st);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:xe,desiredRatio:st,minimapLineCount:Le}}static c(oe,Ie){const Ge=oe.outerWidth,xe=oe.outerHeight,st=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Le=Ie.stableMinimapLayoutInput,bt=Le&&oe.outerHeight===Le.outerHeight&&oe.lineHeight===Le.lineHeight&&oe.typicalHalfwidthCharacterWidth===Le.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Le.pixelRatio&&oe.scrollBeyondLastLine===Le.scrollBeyondLastLine&&oe.paddingTop===Le.paddingTop&&oe.paddingBottom===Le.paddingBottom&&oe.minimap.enabled===Le.minimap.enabled&&oe.minimap.side===Le.minimap.side&&oe.minimap.size===Le.minimap.size&&oe.minimap.showSlider===Le.minimap.showSlider&&oe.minimap.renderCharacters===Le.minimap.renderCharacters&&oe.minimap.maxColumn===Le.minimap.maxColumn&&oe.minimap.scale===Le.minimap.scale&&oe.verticalScrollbarWidth===Le.verticalScrollbarWidth&&oe.isViewportWrapping===Le.isViewportWrapping,St=oe.lineHeight,It=oe.typicalHalfwidthCharacterWidth,Vt=oe.scrollBeyondLastLine,qt=oe.minimap.renderCharacters;let Ct=st>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const _t=oe.minimap.maxColumn,Ht=oe.minimap.size,si=oe.minimap.side,ei=oe.verticalScrollbarWidth,et=oe.viewLineCount,Lt=oe.remainingWidth,ti=oe.isViewportWrapping,dt=qt?2:3;let $t=Math.floor(st*xe);const ii=$t/st;let Kt=!1,Gt=!1,ht=dt*Ct,Ot=Ct/st,ni=1;if(Ht==="fill"||Ht==="fit"){const{typicalViewportLineCount:At,extraLinesBeforeFirstLine:Pt,extraLinesBeyondLastLine:Tt,desiredRatio:oi,minimapLineCount:Ut}=Z.computeContainedMinimapLineCount({viewLineCount:et,scrollBeyondLastLine:Vt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:xe,lineHeight:St,pixelRatio:st});if(et/Ut>1)Kt=!0,Gt=!0,Ct=1,ht=1,Ot=Ct/st;else{let vt=!1,Ft=Ct+1;if(Ht==="fit"){const Wt=Math.ceil((Pt+et+Tt)*ht);ti&&bt&&Lt<=Ie.stableFitRemainingWidth?(vt=!0,Ft=Ie.stableFitMaxMinimapScale):vt=Wt>$t}if(Ht==="fill"||vt){Kt=!0;const Wt=Ct;ht=Math.min(St*st,Math.max(1,Math.floor(1/oi))),ti&&bt&&Lt<=Ie.stableFitRemainingWidth&&(Ft=Ie.stableFitMaxMinimapScale),Ct=Math.min(Ft,Math.max(1,Math.floor(ht/dt))),Ct>Wt&&(ni=Math.min(2,Ct/Wt)),Ot=Ct/st/ni,$t=Math.ceil(Math.max(At,Pt+et+Tt)*ht),ti?(Ie.stableMinimapLayoutInput=oe,Ie.stableFitRemainingWidth=Lt,Ie.stableFitMaxMinimapScale=Ct):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const ri=Math.floor(_t*Ot),Xe=Math.min(ri,Math.max(0,Math.floor((Lt-ei-2)*Ot/(It+Ot)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*Xe);const Bt=Nt/st;Nt=Math.floor(Nt*ni);const Zt=qt?1:2,mt=si==="left"?0:Ge-Xe-ei;return{renderMinimap:Zt,minimapLeft:mt,minimapWidth:Xe,minimapHeightIsEditorHeight:Kt,minimapIsSampling:Gt,minimapScale:Ct,minimapLineHeight:ht,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:$t,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ii}}static computeLayout(oe,Ie){const Ge=Ie.outerWidth|0,xe=Ie.outerHeight|0,st=Ie.lineHeight|0,Le=Ie.lineNumbersDigitCount|0,bt=Ie.typicalHalfwidthCharacterWidth,St=Ie.maxDigitWidth,It=Ie.pixelRatio,Vt=Ie.viewLineCount,qt=oe.get(136),Ct=qt==="inherit"?oe.get(135):qt,_t=Ct==="inherit"?oe.get(131):Ct,Ht=oe.get(134),si=Ie.isDominatedByLongLines,ei=oe.get(57),et=oe.get(68).renderType!==0,Lt=oe.get(69),ti=oe.get(105),dt=oe.get(84),$t=oe.get(73),ii=oe.get(103),Kt=ii.verticalScrollbarSize,Gt=ii.verticalHasArrows,ht=ii.arrowSize,Ot=ii.horizontalScrollbarSize,ni=oe.get(43),ri=oe.get(110)!=="never";let Xe=oe.get(66);ni&&ri&&(Xe+=16);let Nt=0;if(et){const yt=Math.max(Le,Lt);Nt=Math.round(yt*St)}let Bt=0;ei&&(Bt=st*Ie.glyphMarginDecorationLaneCount);let Zt=0,mt=Zt+Bt,At=mt+Nt,Pt=At+Xe;const Tt=Ge-Bt-Nt-Xe;let oi=!1,Ut=!1,xt=-1;Ct==="inherit"&&si?(oi=!0,Ut=!0):_t==="on"||_t==="bounded"?Ut=!0:_t==="wordWrapColumn"&&(xt=Ht);const vt=Z.c({outerWidth:Ge,outerHeight:xe,lineHeight:st,typicalHalfwidthCharacterWidth:bt,pixelRatio:It,scrollBeyondLastLine:ti,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:$t,verticalScrollbarWidth:Kt,viewLineCount:Vt,remainingWidth:Tt,isViewportWrapping:Ut},Ie.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Zt+=vt.minimapWidth,mt+=vt.minimapWidth,At+=vt.minimapWidth,Pt+=vt.minimapWidth);const Ft=Tt-vt.minimapWidth,Wt=Math.max(1,Math.floor((Ft-Kt-2)/bt)),zt=Gt?ht:0;return Ut&&(xt=Math.max(1,Wt),_t==="bounded"&&(xt=Math.min(xt,Ht))),{width:Ge,height:xe,glyphMarginLeft:Zt,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Nt,decorationsLeft:At,decorationsWidth:Xe,contentLeft:Pt,contentWidth:Ft,minimap:vt,viewportColumn:Wt,isWordWrapMinified:oi,isViewportWrapping:Ut,wrappingColumn:xt,verticalScrollbarWidth:Kt,horizontalScrollbarHeight:Ot,overviewRuler:{top:zt,width:Kt,height:xe-2*zt,right:0}}}}e.EditorLayoutInfoComputer=Z;class ae extends I{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(oe){return f(oe,"simple",["simple","advanced"])}compute(oe,Ie,Ge){return Ie.get(2)===2?"advanced":Ge}}var _;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class ge extends I{constructor(){const oe={enabled:_.OnCode};super(65,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:oe.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:f(oe.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class se extends I{constructor(){const oe={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:b.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:b.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:f(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:g(Ie.padding,this.defaultValue.padding)}}}class U extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):i.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ie,Ge){return Ge<0?i.clampedInt(-Ge*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ie extends a{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>a.clamp(oe,0,150),{markdownDescription:b.localize(66,null)})}compute(oe,Ie,Ge){return oe.fontInfo.lineHeight}}class ye extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:oe.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:b.localize(77,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),autohide:g(Ie.autohide,this.defaultValue.autohide),size:f(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ie.side,this.defaultValue.side,["right","left"]),showSlider:f(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(ne){return ne==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ue extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class ce extends I{constructor(){const oe={enabled:!0,cycle:!0};super(86,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:b.localize(81,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),cycle:g(Ie.cycle,this.defaultValue.cycle)}}}class de extends y{constructor(){super(142)}compute(oe,Ie,Ge){return oe.pixelRatio}}class H extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(89,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:oe.strings,description:b.localize(85,null)},comments:{anyOf:Ie,default:oe.comments,description:b.localize(86,null)},other:{anyOf:Ie,default:oe.other,description:b.localize(87,null)}},default:oe,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const It=oe?"on":"off";return{comments:It,strings:It,other:It}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ie,comments:Ge,strings:xe}=oe,st=["on","inline","off"];let Le,bt,St;return typeof Ie=="boolean"?Le=Ie?"on":"off":Le=f(Ie,this.defaultValue.other,st),typeof Ge=="boolean"?bt=Ge?"on":"off":bt=f(Ge,this.defaultValue.comments,st),typeof xe=="boolean"?St=xe?"on":"off":St=f(xe,this.defaultValue.strings,st),{other:Le,comments:bt,strings:St}}}var x;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class he extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(oe){let Ie=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ie=4,Ge=oe):oe==="interval"?Ie=3:oe==="relative"?Ie=2:oe==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ge}}}function pe(ne){const oe=ne.get(98);return oe==="editable"?ne.get(91):oe!=="on"}class Ae extends I{constructor(){const oe=[],Ie={type:"number",description:b.localize(94,null)};super(102,"rulers",oe,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:oe,description:b.localize(96,null)})}validate(oe){if(Array.isArray(oe)){const Ie=[];for(const Ge of oe)if(typeof Ge=="number")Ie.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const xe=Ge;Ie.push({column:i.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Ie.sort((Ge,xe)=>Ge.column-xe.column),Ie}return this.defaultValue}}class we extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Pe(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Fe extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:oe.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe,Ge=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:g(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,xe,0,1e3),scrollByPage:g(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:b.localize(115,null)}})}applyUpdate(oe,Ie){let Ge=!1;Ie.allowedCharacters&&oe&&(L.$Qn(oe.allowedCharacters,Ie.allowedCharacters)||(oe={...oe,allowedCharacters:Ie.allowedCharacters},Ge=!0)),Ie.allowedLocales&&oe&&(L.$Qn(oe.allowedLocales,Ie.allowedLocales)||(oe={...oe,allowedLocales:Ie.allowedLocales},Ge=!0));const xe=super.applyUpdate(oe,Ie);return Ge?new w(xe.newValue,!0):xe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{nonBasicASCII:me(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ie){if(typeof oe!="object"||!oe)return Ie;const Ge={};for(const[xe,st]of Object.entries(oe))st===!0&&(Ge[xe]=!0);return Ge}}class q extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:b.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:oe.fontFamily,description:b.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),mode:f(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class V extends I{constructor(){const oe={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",oe,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:oe.enabled,description:b.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],description:b.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:oe.fontFamily,description:b.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:oe.backgroundColoring,description:b.localize(129,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends I{constructor(){const oe={enabled:A.$Is.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Is.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:b.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:b.localize(131,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null)],default:oe.bracketPairs,description:b.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(136,null),b.localize(137,null),b.localize(138,null)],default:oe.bracketPairsHorizontal,description:b.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:b.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:b.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(142,null),b.localize(143,null),b.localize(144,null)],default:oe.highlightActiveIndentation,description:b.localize(145,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{bracketPairs:me(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(ne,oe,Ie){const Ge=Ie.indexOf(ne);return Ge===-1?oe:Ie[Ge]}class ve extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(146,null),b.localize(147,null)],default:oe.insertMode,description:b.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:b.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:b.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:b.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(152,null),b.localize(153,null),b.localize(154,null),b.localize(155,null)],default:oe.selectionMode,markdownDescription:b.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:b.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:b.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:b.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:b.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:b.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertMode:f(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ie.preview,this.defaultValue.preview),previewMode:f(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ie.showMethods,this.defaultValue.showMethods),showFunctions:g(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ie.showFields,this.defaultValue.showFields),showVariables:g(Ie.showVariables,this.defaultValue.showVariables),showClasses:g(Ie.showClasses,this.defaultValue.showClasses),showStructs:g(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ie.showModules,this.defaultValue.showModules),showProperties:g(Ie.showProperties,this.defaultValue.showProperties),showEvents:g(Ie.showEvents,this.defaultValue.showEvents),showOperators:g(Ie.showOperators,this.defaultValue.showOperators),showUnits:g(Ie.showUnits,this.defaultValue.showUnits),showValues:g(Ie.showValues,this.defaultValue.showValues),showConstants:g(Ie.showConstants,this.defaultValue.showConstants),showEnums:g(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ie.showKeywords,this.defaultValue.showKeywords),showWords:g(Ie.showWords,this.defaultValue.showWords),showColors:g(Ie.showColors,this.defaultValue.showColors),showFiles:g(Ie.showFiles,this.defaultValue.showFiles),showReferences:g(Ie.showReferences,this.defaultValue.showReferences),showFolders:g(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ie.showUsers,this.defaultValue.showUsers),showIssues:g(Ie.showIssues,this.defaultValue.showIssues)}}}class Te extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(195,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Ze extends I{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(196,null),b.localize(197,null),b.localize(198,null),b.localize(199,null)],description:b.localize(200,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ie,Ge){return Ie.get(2)===2?0:Ge}}class tt extends y{constructor(){super(145)}compute(oe,Ie,Ge){const xe=Ie.get(144);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class nt extends I{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:b.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(203,null),b.localize(204,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showDropSelector:f(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends I{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:b.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(207,null),b.localize(208,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showPasteSelector:f(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ce="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?Ce:M.$k?Be:rt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ke;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSeparators=130]="wordSeparators",ne[ne.wordWrap=131]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=134]="wordWrapColumn",ne[ne.wordWrapOverride1=135]="wordWrapOverride1",ne[ne.wordWrapOverride2=136]="wordWrapOverride2",ne[ne.wrappingIndent=137]="wrappingIndent",ne[ne.wrappingStrategy=138]="wrappingStrategy",ne[ne.showDeprecated=139]="showDeprecated",ne[ne.inlayHints=140]="inlayHints",ne[ne.editorClassName=141]="editorClassName",ne[ne.pixelRatio=142]="pixelRatio",ne[ne.tabFocusMode=143]="tabFocusMode",ne[ne.layoutInfo=144]="layoutInfo",ne[ne.wrappingInfo=145]="wrappingInfo",ne[ne.defaultColorDecorators=146]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ke||(e.EditorOption=Ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(209,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(210,null),""],markdownDescription:b.localize(211,null)})),accessibilitySupport:Me(new d),accessibilityPageSize:Me(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(212,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",b.localize(213,null))),ariaRequired:Me(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Me(new l(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(215,null),b.localize(216,null),""],description:b.localize(217,null)})),autoClosingComments:Me(new l(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(218,null),b.localize(219,null),""],description:b.localize(220,null)})),autoClosingDelete:Me(new l(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(221,null),""],description:b.localize(222,null)})),autoClosingOvertype:Me(new l(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(223,null),""],description:b.localize(224,null)})),autoClosingQuotes:Me(new l(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(225,null),b.localize(226,null),""],description:b.localize(227,null)})),autoIndent:Me(new s(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[b.localize(228,null),b.localize(229,null),b.localize(230,null),b.localize(231,null),b.localize(232,null)],description:b.localize(233,null)})),automaticLayout:Me(new c(13,"automaticLayout",!1)),autoSurround:Me(new l(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(234,null),b.localize(235,null),b.localize(236,null),""],description:b.localize(237,null)})),bracketPairColorization:Me(new J),bracketPairGuides:Me(new X),stickyTabStops:Me(new c(116,"stickyTabStops",!1,{description:b.localize(238,null)})),codeLens:Me(new c(17,"codeLens",!0,{description:b.localize(239,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:b.localize(240,null)})),codeLensFontSize:Me(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(241,null)})),colorDecorators:Me(new c(20,"colorDecorators",!0,{description:b.localize(242,null)})),colorDecoratorActivatedOn:Me(new l(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),colorDecoratorsLimit:Me(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(247,null)})),columnSelection:Me(new c(22,"columnSelection",!1,{description:b.localize(248,null)})),comments:Me(new m),contextmenu:Me(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new c(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(249,null)})),cursorBlinking:Me(new s(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:b.localize(250,null)})),cursorSmoothCaretAnimation:Me(new l(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(251,null),b.localize(252,null),b.localize(253,null)],description:b.localize(254,null)})),cursorStyle:Me(new s(28,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(255,null)})),cursorSurroundingLines:Me(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(256,null)})),cursorSurroundingLinesStyle:Me(new l(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(257,null),b.localize(258,null)],markdownDescription:b.localize(259,null)})),cursorWidth:Me(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(260,null)})),disableLayerHinting:Me(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new c(34,"domReadOnly",!1)),dragAndDrop:Me(new c(35,"dragAndDrop",!0,{description:b.localize(261,null)})),emptySelectionClipboard:Me(new B),dropIntoEditor:Me(new nt),stickyScroll:Me(new se),experimentalWhitespaceRendering:Me(new l(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(262,null),b.localize(263,null),b.localize(264,null)],description:b.localize(265,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new a(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(266,null)})),find:Me(new z),fixedOverflowWidgets:Me(new c(42,"fixedOverflowWidgets",!1)),folding:Me(new c(43,"folding",!0,{description:b.localize(267,null)})),foldingStrategy:Me(new l(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),foldingHighlight:Me(new c(45,"foldingHighlight",!0,{description:b.localize(271,null)})),foldingImportsByDefault:Me(new c(46,"foldingImportsByDefault",!1,{description:b.localize(272,null)})),foldingMaximumRegions:Me(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(273,null)})),unfoldOnClickAfterEndOfLine:Me(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(274,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(275,null)})),fontInfo:Me(new N),fontLigatures2:Me(new T),fontSize:Me(new F),fontWeight:Me(new K),fontVariations:Me(new j),formatOnPaste:Me(new c(55,"formatOnPaste",!1,{description:b.localize(276,null)})),formatOnType:Me(new c(56,"formatOnType",!1,{description:b.localize(277,null)})),glyphMargin:Me(new c(57,"glyphMargin",!0,{description:b.localize(278,null)})),gotoLocation:Me(new ee),hideCursorInOverviewRuler:Me(new c(59,"hideCursorInOverviewRuler",!1,{description:b.localize(279,null)})),hover:Me(new Y),inDiffEditor:Me(new c(61,"inDiffEditor",!1)),letterSpacing:Me(new a(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>a.clamp(ne,-5,20),{description:b.localize(280,null)})),lightbulb:Me(new ge),lineDecorationsWidth:Me(new U),lineHeight:Me(new ie),lineNumbers:Me(new he),lineNumbersMinChars:Me(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new c(70,"linkedEditing",!1,{description:b.localize(281,null)})),links:Me(new c(71,"links",!0,{description:b.localize(282,null)})),matchBrackets:Me(new l(72,"matchBrackets","always",["always","near","never"],{description:b.localize(283,null)})),minimap:Me(new ye),mouseStyle:Me(new l(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new a(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(284,null)})),mouseWheelZoom:Me(new c(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?b.localize(285,null):b.localize(286,null)})),multiCursorMergeOverlapping:Me(new c(77,"multiCursorMergeOverlapping",!0,{description:b.localize(287,null)})),multiCursorModifier:Me(new s(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),multiCursorPaste:Me(new l(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(291,null),b.localize(292,null)],markdownDescription:b.localize(293,null)})),multiCursorLimit:Me(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(294,null)})),occurrencesHighlight:Me(new l(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(295,null),b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),overviewRulerBorder:Me(new c(82,"overviewRulerBorder",!0,{description:b.localize(299,null)})),overviewRulerLanes:Me(new i(83,"overviewRulerLanes",3,0,3)),padding:Me(new ue),pasteAs:Me(new at),parameterHints:Me(new ce),peekWidgetDefaultFocus:Me(new l(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(300,null),b.localize(301,null)],description:b.localize(302,null)})),definitionLinkOpensInPeek:Me(new c(88,"definitionLinkOpensInPeek",!1,{description:b.localize(303,null)})),quickSuggestions:Me(new H),quickSuggestionsDelay:Me(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(304,null)})),readOnly:Me(new c(91,"readOnly",!1)),readOnlyMessage:Me(new we),renameOnType:Me(new c(93,"renameOnType",!1,{description:b.localize(305,null),markdownDeprecationMessage:b.localize(306,null)})),renderControlCharacters:Me(new c(94,"renderControlCharacters",!0,{description:b.localize(307,null),restricted:!0})),renderFinalNewline:Me(new l(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(308,null)})),renderLineHighlight:Me(new l(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(309,null)],description:b.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Me(new c(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(311,null)})),renderValidationDecorations:Me(new l(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(312,null),b.localize(313,null),b.localize(314,null),""],description:b.localize(315,null)})),revealHorizontalRightPadding:Me(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new c(101,"roundedSelection",!0,{description:b.localize(316,null)})),rulers:Me(new Ae),scrollbar:Me(new Fe),scrollBeyondLastColumn:Me(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(317,null)})),scrollBeyondLastLine:Me(new c(105,"scrollBeyondLastLine",!0,{description:b.localize(318,null)})),scrollPredominantAxis:Me(new c(106,"scrollPredominantAxis",!0,{description:b.localize(319,null)})),selectionClipboard:Me(new c(107,"selectionClipboard",!0,{description:b.localize(320,null),included:M.$k})),selectionHighlight:Me(new c(108,"selectionHighlight",!0,{description:b.localize(321,null)})),selectOnLineNumbers:Me(new c(109,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(322,null),b.localize(323,null),b.localize(324,null)],description:b.localize(325,null)})),showUnused:Me(new c(111,"showUnused",!0,{description:b.localize(326,null)})),showDeprecated:Me(new c(139,"showDeprecated",!0,{description:b.localize(327,null)})),inlayHints:Me(new re),snippetSuggestions:Me(new l(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(328,null),b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),smartSelect:Me(new Te),smoothScrolling:Me(new c(114,"smoothScrolling",!1,{description:b.localize(333,null)})),stopRenderingLineAfter:Me(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ve),inlineSuggest:Me(new q),inlineEdit:Me(new V),inlineCompletionsAccessibilityVerbose:Me(new c(148,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(334,null)})),suggestFontSize:Me(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new c(121,"suggestOnTriggerCharacters",!0,{description:b.localize(337,null)})),suggestSelection:Me(new l(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),tabCompletion:Me(new l(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(342,null),b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),tabIndex:Me(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new ze),unusualLineTerminators:Me(new l(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(346,null),b.localize(347,null),b.localize(348,null)],description:b.localize(349,null)})),useShadowDOM:Me(new c(127,"useShadowDOM",!0)),useTabStops:Me(new c(128,"useTabStops",!0,{description:b.localize(350,null)})),wordBreak:Me(new l(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(351,null),b.localize(352,null)],description:b.localize(353,null)})),wordSeparators:Me(new t(130,"wordSeparators",P.$Js,{description:b.localize(354,null)})),wordWrap:Me(new l(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(355,null),b.localize(356,null),b.localize(357,null),b.localize(358,null)],description:b.localize(359,null)})),wordWrapBreakAfterCharacters:Me(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new i(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(360,null)})),wordWrapOverride1:Me(new l(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new O),defaultColorDecorators:Me(new c(146,"defaultColorDecorators",!1,{markdownDescription:b.localize(361,null)})),pixelRatio:Me(new de),tabFocusMode:Me(new c(143,"tabFocusMode",!1,{markdownDescription:b.localize(362,null)})),layoutInfo:Me(new Z),wrappingInfo:Me(new tt),wrappingIndent:Me(new Ze),wrappingStrategy:Me(new ae)}}),define(Se[200],De([9,10]),function(fe,e){return fe.create("vs/editor/common/languages",e)}),define(Se[82],De([1,0,77,2,173,29,183,200]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$5t=e.$4t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$3t=e.$2t=e.SymbolKinds=e.SymbolTag=e.$Zt=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Xt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Wt=e.$Vt=e.$Ut=void 0,e.$Yt=f,e.$1t=s;class p{constructor(K,ee,Y){this.offset=K,this.type=ee,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ut=p;class E{constructor(K,ee){this.tokens=K,this.endState=ee,this._tokenizationResultBrand=void 0}}e.$Vt=E;class R{constructor(K,ee){this.tokens=K,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}e.$Wt=R;var I;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var w;(function(F){const K=new Map;K.set(0,u.$Fj.symbolMethod),K.set(1,u.$Fj.symbolFunction),K.set(2,u.$Fj.symbolConstructor),K.set(3,u.$Fj.symbolField),K.set(4,u.$Fj.symbolVariable),K.set(5,u.$Fj.symbolClass),K.set(6,u.$Fj.symbolStruct),K.set(7,u.$Fj.symbolInterface),K.set(8,u.$Fj.symbolModule),K.set(9,u.$Fj.symbolProperty),K.set(10,u.$Fj.symbolEvent),K.set(11,u.$Fj.symbolOperator),K.set(12,u.$Fj.symbolUnit),K.set(13,u.$Fj.symbolValue),K.set(15,u.$Fj.symbolEnum),K.set(14,u.$Fj.symbolConstant),K.set(15,u.$Fj.symbolEnum),K.set(16,u.$Fj.symbolEnumMember),K.set(17,u.$Fj.symbolKeyword),K.set(27,u.$Fj.symbolSnippet),K.set(18,u.$Fj.symbolText),K.set(19,u.$Fj.symbolColor),K.set(20,u.$Fj.symbolFile),K.set(21,u.$Fj.symbolReference),K.set(22,u.$Fj.symbolCustomColor),K.set(23,u.$Fj.symbolFolder),K.set(24,u.$Fj.symbolTypeParameter),K.set(25,u.$Fj.account),K.set(26,u.$Fj.issues);function ee(Z){let ae=K.get(Z);return ae||(console.info("No codicon found for CompletionItemKind "+Z),ae=u.$Fj.symbolProperty),ae}F.toIcon=ee;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function Q(Z,ae){let _=Y.get(Z);return typeof _>"u"&&!ae&&(_=9),_}F.fromString=Q})(w||(e.CompletionItemKinds=w={}));var S;(function(F){F[F.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var y;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(y||(e.CompletionItemInsertTextRule=y={}));var h;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(h||(e.PartialAcceptTriggerKind=h={}));var g;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var c;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class n{constructor(K,ee,Y,Q){this.range=K,this.text=ee,this.completionKind=Y,this.isSnippetText=Q}equals(K){return A.$$s.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$Xt=n;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var a;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(a||(e.SignatureHelpTriggerKind=a={}));var t;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(F){return F&&L.URI.isUri(F.uri)&&A.$$s.isIRange(F.range)&&(A.$$s.isIRange(F.originSelectionRange)||A.$$s.isIRange(F.targetSelectionRange))}var l;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Zt={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function s(F,K){return(0,b.localize)(26,null,F,e.$Zt[K])}var o;(function(F){F[F.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var d;(function(F){const K=new Map;K.set(0,u.$Fj.symbolFile),K.set(1,u.$Fj.symbolModule),K.set(2,u.$Fj.symbolNamespace),K.set(3,u.$Fj.symbolPackage),K.set(4,u.$Fj.symbolClass),K.set(5,u.$Fj.symbolMethod),K.set(6,u.$Fj.symbolProperty),K.set(7,u.$Fj.symbolField),K.set(8,u.$Fj.symbolConstructor),K.set(9,u.$Fj.symbolEnum),K.set(10,u.$Fj.symbolInterface),K.set(11,u.$Fj.symbolFunction),K.set(12,u.$Fj.symbolVariable),K.set(13,u.$Fj.symbolConstant),K.set(14,u.$Fj.symbolString),K.set(15,u.$Fj.symbolNumber),K.set(16,u.$Fj.symbolBoolean),K.set(17,u.$Fj.symbolArray),K.set(18,u.$Fj.symbolObject),K.set(19,u.$Fj.symbolKey),K.set(20,u.$Fj.symbolNull),K.set(21,u.$Fj.symbolEnumMember),K.set(22,u.$Fj.symbolStruct),K.set(23,u.$Fj.symbolEvent),K.set(24,u.$Fj.symbolOperator),K.set(25,u.$Fj.symbolTypeParameter);function ee(Y){let Q=K.get(Y);return Q||(console.info("No codicon found for SymbolKind "+Y),Q=u.$Fj.symbolProperty),Q}F.toIcon=ee})(d||(e.SymbolKinds=d={}));class m{static asEditOperation(K){return M.$_s.replace(A.$$s.lift(K.range),K.text)}}e.$2t=m;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(K){switch(K){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(K)}constructor(K){this.value=K}}e.$3t=D;var $;(function(F){F[F.AIGenerated=1]="AIGenerated"})($||(e.NewSymbolNameTag=$={}));var v;(function(F){function K(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}F.is=K})(v||(e.Command=v={}));var k;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var C;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(C||(e.CommentThreadState=C={}));var O;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(O||(e.CommentMode=O={}));var B;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(B||(e.CommentState=B={}));var z;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class T{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$4t=T,e.$5t=new P.$Jt;var j;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}));var N;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(N||(e.InlineEditTriggerKind=N={}))}),define(Se[201],De([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[202],De([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[203],De([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Se[204],De([9,10]),function(fe,e){return fe.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[205],De([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[206],De([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[207],De([9,10]),function(fe,e){return fe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[208],De([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Se[209],De([9,10]),function(fe,e){return fe.create("vs/platform/files/common/io",e)}),define(Se[210],De([9,10]),function(fe,e){return fe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[211],De([9,10]),function(fe,e){return fe.create("vs/platform/log/common/log",e)}),define(Se[212],De([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Se[213],De([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[214],De([9,10]),function(fe,e){return fe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[215],De([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Se[216],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[217],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[218],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[219],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[220],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[221],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[222],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[223],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[224],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[225],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[226],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[227],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[228],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[229],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[230],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Se[231],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Se[232],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Se[233],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[234],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[235],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[236],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[237],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[238],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[239],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[240],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[241],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[242],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[243],De([1,0,13,203]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var M;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(M||(e.TokenType=M={}));function A(...E){switch(E.length){case 1:return(0,L.localize)(0,null,E[0]);case 2:return(0,L.localize)(1,null,E[0],E[1]);case 3:return(0,L.localize)(2,null,E[0],E[1],E[2]);default:return}}const P=(0,L.localize)(3,null),b=(0,L.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,w=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:R}),this.f.push(S)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),w=p.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,w=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const y=this.c.charCodeAt(R);if(I)I=!1;else if(y===47&&!w){R++;break}else y===91?w=!0:y===92?I=!0:y===93&&(w=!1);R++}for(;R<this.c.length&&p.a.has(this.c.charCodeAt(R));)R++;this.e=R;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=p}),define(Se[244],De([1,0,23,39,206,393]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=p,e.$rp=E,e.$sp=R,e.$tp=I,e.$up=w,e.$vp=S,e.$wp=y;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function p(c){return c=c.trim(),c==="*"||P.test(c)}function E(c){if(!p(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=c.match(P);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function R(c){if(!c)return null;const n=c.majorBase,i=c.majorMustEqual,r=c.minorBase;let a=c.minorMustEqual;const t=c.patchBase;let f=c.patchMustEqual;c.hasCaret&&(n===0||(a=!1),f=!1);let l=0;if(c.preRelease){const s=b.exec(c.preRelease);if(s){const[,o,d,m]=s;l=Date.UTC(Number(o),Number(d)-1,Number(m))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:f,isMinimum:c.hasGreaterEquals,notBefore:l}}function I(c,n,i){let r;typeof c=="string"?r=R(E(c)):r=c;let a;n instanceof Date?a=n.getTime():typeof n=="string"&&(a=new Date(n).getTime());let t;if(typeof i=="string"?t=R(E(i)):t=i,!r||!t)return!1;const f=r.majorBase,l=r.minorBase,s=r.patchBase;let o=t.majorBase,d=t.minorBase,m=t.patchBase;const D=t.notBefore;let $=t.majorMustEqual,v=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>o?!0:f<o?!1:l>d?!0:l<d||a&&a<D?!1:s>=m:(f===1&&o===0&&(!$||!v||!k)&&(o=1,d=0,m=0,$=!0,v=!1,k=!1),f<o?!1:f>o?!$:l<d?!1:l>d?!v:s<m?!1:s>m?!k:!(a&&a<D))}function w(c,n,i,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([L.default.Error,M.localize(0,null)]),t;if(typeof r.name!="string")return t.push([L.default.Error,M.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([L.default.Error,M.localize(2,null,"version")]),t;if(!r.engines)return t.push([L.default.Error,M.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([L.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!g(r.extensionDependencies))return t.push([L.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!g(r.activationEvents))return t.push([L.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([L.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([L.default.Warning,M.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([L.default.Error,M.localize(9,null,"main")]),t;{const s=(0,u.$Tg)(i,r.main);(0,u.$Ng)(s,i)||t.push([L.default.Warning,M.localize(10,null,s.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([L.default.Error,M.localize(11,null,"browser")]),t;{const s=(0,u.$Tg)(i,r.browser);(0,u.$Ng)(s,i)||t.push([L.default.Warning,M.localize(12,null,s.path,i.path)])}}if(!A.valid(r.version))return t.push([L.default.Error,M.localize(13,null)]),t;const f=[];if(!S(c,n,r,a,f))for(const s of f)t.push([L.default.Error,s]);return t}function S(c,n,i,r,a){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(c,n,i.engines.vscode,a)}function y(c,n,i){return c==="*"||h(n,i,c)}function h(c,n,i,r=[]){const a=R(E(i));if(!a)return r.push(M.localize(14,null,i)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push(M.localize(15,null,i)),!1}else if(!a.majorMustEqual)return r.push(M.localize(16,null,i)),!1;return I(c,n,a)?!0:(r.push(M.localize(17,null,c,i)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let n=0,i=c.length;n<i;n++)if(typeof c[n]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class u{constructor(M,A=[],P=!1){this.ctor=M,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.$di=u}),define(Se[83],De([1,0,106]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$cs=A,e.$ds=P;const L=[];var M;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function A(b,p,E){p instanceof u.$di||(p=new u.$di(p,[],!!E)),L.push([b,p])}function P(){return L}}),define(Se[245],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class u{constructor(A,P){this.key=A,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$Sq=u;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const P of this.a.values())P.outgoing.size===0&&A.push(P);return A}insertEdge(A,P){const b=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(P);b.outgoing.set(p.key,p),p.incoming.set(b.key,b)}removeNode(A){const P=this.b(A);this.a.delete(P);for(const b of this.a.values())b.outgoing.delete(P),b.incoming.delete(P)}lookupOrInsertNode(A){const P=this.b(A);let b=this.a.get(P);return b||(b=new u(P,A),this.a.set(P,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[P,b]of this.a)A.push(`${P}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,P]of this.a){const b=new Set([A]),p=this.c(P,b);if(p)return p}}c(A,P){for(const[b,p]of A.outgoing){if(P.has(b))return[...P,b].join(" -> ");P.add(b);const E=this.c(p,P);if(E)return E;P.delete(b)}}}e.$Tq=L}),define(Se[5],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e._util=void 0,e.$gi=M,e.$hi=A;var u;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function b(p){return p[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=b})(u||(e._util=u={})),e.$fi=M("instantiationService");function L(P,b,p){b[u.DI_TARGET]===b?b[u.DI_DEPENDENCIES].push({id:P,index:p}):(b[u.DI_DEPENDENCIES]=[{id:P,index:p}],b[u.DI_TARGET]=b)}function M(P){if(u.serviceIds.has(P))return u.serviceIds.get(P);const b=function(p,E,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(b,p,R)};return b.toString=()=>P,u.serviceIds.set(P,b),b}function A(P){return P}}),define(Se[52],De([1,0,18,2,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Mi=void 0,e.$Ni=A,e.$Oi=P,e.$Pi=p,e.$Qi=E,e.$Ri=R,e.$Si=I,e.$Ti=w,e.$Ui=y,e.$Vi=h,e.$Wi=g,e.$Mi=(0,M.$gi)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof L.URI)}function P(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof L.URI)}var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function p(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function R(c,n){const i=Object.create(null);for(const r in c)I(i,r,c[r],n);return i}function I(c,n,i,r){const a=n.split("."),t=a.pop();let f=c;for(let l=0;l<a.length;l++){const s=a[l];let o=f[s];switch(typeof o){case"undefined":o=f[s]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${a.slice(0,l+1).join(".")} is ${JSON.stringify(o)}`);return}f=o}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${a.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${a.join(".")} is ${JSON.stringify(f)}`)}function w(c,n){const i=n.split(".");S(c,i)}function S(c,n){const i=n.shift();if(n.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const r=c[i];typeof r=="object"&&!Array.isArray(r)&&(S(r,n),Object.keys(r).length===0&&delete c[i])}}function y(c,n,i){function r(f,l){let s=f;for(const o of l){if(typeof s!="object"||s===null)return;s=s[o]}return s}const a=n.split("."),t=r(c,a);return typeof t>"u"?i:t}function h(c,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in c?u.$Vf(c[r])&&u.$Vf(n[r])?h(c[r],n[r],i):i&&(c[r]=n[r]):c[r]=n[r])})}function g(c){return c.replace(/[\[\]]/g,"")}}),define(Se[45],De([1,0,11,14,243,5,202,13]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$ej=e.$dj=e.ContextKeyExprType=void 0,e.$cj=E,e.$fj=f,e.$gj=l,e.$zj=_;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",u.$j),p.set("isLinux",u.$k),p.set("isWindows",u.$i),p.set("isWeb",u.$o),p.set("isMacNative",u.$j&&!u.$o),p.set("isEdge",u.$H),p.set("isFirefox",u.$F),p.set("isChrome",u.$E),p.set("isSafari",u.$G);function E(re,U){if(p.get(re)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(re,U)}const R=Object.prototype.hasOwnProperty;var I;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},S=(0,P.localize)(0,null),y=(0,P.localize)(1,null),h=(0,P.localize)(2,null),g=(0,P.localize)(3,null),c=(0,P.localize)(4,null),n=(0,P.localize)(5,null),i=(0,P.localize)(6,null),r=(0,P.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=w){this.k=U,this.d=new M.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ye=this.D(),le=ye.type===17?n:void 0;throw this.h.push({message:c,offset:ye.offset,lexeme:M.$bj.getLexeme(ye),additionalInfo:le}),a.c}return ie}catch(ie){if(ie!==a.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,g),ie?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,g),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const ue=le.lexeme,ce=ue.lastIndexOf("/"),de=ce===ue.length-1?void 0:this.w(ue.substring(ce+1));let H;try{H=new RegExp(ue.substring(1,ce),de)}catch{throw this.B("REGEX",le)}return N.create(ie,H)}switch(le.type){case 10:case 19:{const ue=[le.lexeme];this.z();let ce=this.D(),de=0;for(let Ae=0;Ae<le.lexeme.length;Ae++)le.lexeme.charCodeAt(Ae)===40?de++:le.lexeme.charCodeAt(Ae)===41&&de--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?de++:le.lexeme.charCodeAt(Ae)===41&&de--}if(de<0)break;ue.push(M.$bj.getLexeme(ce)),this.z(),ce=this.D()}const H=ue.join(""),x=H.lastIndexOf("/"),he=x===H.length-1?void 0:this.w(H.substring(x+1));let pe;try{pe=new RegExp(H.substring(1,x),he)}catch{throw this.B("REGEX",le)}return t.regex(ie,pe)}case 18:{const ue=le.lexeme;this.z();let ce=null;if(!(0,L.$Te)(ue)){const de=ue.indexOf("/"),H=ue.lastIndexOf("/");if(de!==H&&de>=0){const x=ue.slice(de+1,H),he=ue[H+1]==="i"?"i":"";try{ce=new RegExp(x,he)}catch{throw this.B("REGEX",le)}}}if(ce===null)throw this.B("REGEX",le);return N.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const le=this.u();return t.notIn(ie,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ie,le);switch(le){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ie,le);switch(le){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,le)}}case 5:return this.z(),T.create(ie,this.u());case 6:return this.z(),j.create(ie,this.u());case 7:return this.z(),B.create(ie,this.u());case 8:return this.z(),z.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,ye){const le=(0,P.localize)(8,null,U,M.$bj.getLexeme(ie)),ue=ie.offset,ce=M.$bj.getLexeme(ie);return this.h.push({message:le,offset:ue,lexeme:ce,additionalInfo:ye}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=a;class t{static false(){return o.INSTANCE}static true(){return d.INSTANCE}static has(U){return m.create(U)}static equals(U,ie){return D.create(U,ie)}static notEquals(U,ie){return k.create(U,ie)}static regex(U,ie){return N.create(U,ie)}static in(U,ie){return $.create(U,ie)}static notIn(U,ie){return v.create(U,ie)}static not(U){return C.create(U)}static and(...U){return ee.create(U,null,!0)}static or(...U){return Y.create(U,null,!0)}static greater(U,ie){return B.create(U,ie)}static greaterEquals(U,ie){return z.create(U,ie)}static smaller(U,ie){return T.create(U,ie)}static smallerEquals(U,ie){return j.create(U,ie)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$ej=t;function f(re){const U=new a({regexParsingWithErrorRecovery:!1});return re.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,P.localize)(9,null,ye.additionalInfo):(0,P.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}function l(re,U){const ie=re?re.substituteConstants():void 0,ye=U?U.substituteConstants():void 0;return!ie&&!ye?!0:!ie||!ye?!1:ie.equals(ye)}function s(re,U){return re.cmp(U)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return d.INSTANCE}}e.$hj=o;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.$ij=d;class m{static create(U,ie=null){const ye=p.get(U);return typeof ye=="boolean"?ye?d.INSTANCE:o.INSTANCE:new m(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=p.get(this.key);return typeof U=="boolean"?U?d.INSTANCE:o.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$jj=m;class D{static create(U,ie,ye=null){if(typeof ie=="boolean")return ie?m.create(U,ye):C.create(U,ye);const le=p.get(U);return typeof le=="boolean"?ie===(le?"true":"false")?d.INSTANCE:o.INSTANCE:new D(U,ie,ye)}constructor(U,ie,ye){this.c=U,this.d=ie,this.f=ye,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=p.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?d.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$kj=D;class ${static create(U,ie){return new $(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),ye=U.getValue(this.d);return Array.isArray(ie)?ie.includes(ye):typeof ye=="string"&&typeof ie=="object"&&ie!==null?R.call(ie,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$lj=$;class v{static create(U,ie){return new v(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=$.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=v;class k{static create(U,ie,ye=null){if(typeof ie=="boolean")return ie?C.create(U,ye):m.create(U,ye);const le=p.get(U);return typeof le=="boolean"?ie===(le?"true":"false")?o.INSTANCE:d.INSTANCE:new k(U,ie,ye)}constructor(U,ie,ye){this.c=U,this.d=ie,this.f=ye,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=p.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?o.INSTANCE:d.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$nj=k;class C{static create(U,ie=null){const ye=p.get(U);return typeof ye=="boolean"?ye?o.INSTANCE:d.INSTANCE:new C(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=p.get(this.c);return typeof U=="boolean"?U?o.INSTANCE:d.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$oj=C;function O(re,U){if(typeof re=="string"){const ie=parseFloat(re);isNaN(ie)||(re=ie)}return typeof re=="string"||typeof re=="number"?U(re):o.INSTANCE}class B{static create(U,ie,ye=null){return O(ie,le=>new B(U,le,ye))}constructor(U,ie,ye){this.c=U,this.d=ie,this.f=ye,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$pj=B;class z{static create(U,ie,ye=null){return O(ie,le=>new z(U,le,ye))}constructor(U,ie,ye){this.c=U,this.d=ie,this.f=ye,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$qj=z;class T{static create(U,ie,ye=null){return O(ie,le=>new T(U,le,ye))}constructor(U,ie,ye){this.c=U,this.d=ie,this.f=ye,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$rj=T;class j{static create(U,ie,ye=null){return O(ie,le=>new j(U,le,ye))}constructor(U,ie,ye){this.c=U,this.d=ie,this.f=ye,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$sj=j;class N{static create(U,ie){return new N(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",ye=U.f?U.f.source:"";return ie<ye?-1:ie>ye?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",ye=U.f?U.f.source:"";return this.d===U.d&&ie===ye}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=F.create(this)),this.c}}e.$tj=N;class F{static create(U){return new F(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new F(this.c.map(U))}negate(){return this.c}}e.$uj=F;function K(re){let U=null;for(let ie=0,ye=re.length;ie<ye;ie++){const le=re[ie].substituteConstants();if(re[ie]!==le&&U===null){U=[];for(let ue=0;ue<ie;ue++)U[ue]=re[ue]}U!==null&&(U[ie]=le)}return U===null?re:U}class ee{static create(U,ie,ye){return ee.d(U,ie,ye)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const le=s(this.expr[ie],U.expr[ie]);if(le!==0)return le}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=K(this.expr);return U===this.expr?this:ee.create(U,this.c,!1)}evaluate(U){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,ye){const le=[];let ue=!1;for(const ce of U)if(ce){if(ce.type===1){ue=!0;continue}if(ce.type===0)return o.INSTANCE;if(ce.type===6){le.push(...ce.expr);continue}le.push(ce)}if(le.length===0&&ue)return d.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(s);for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];for(;le.length>1;){const ce=le[le.length-1];if(ce.type!==9)break;le.pop();const de=le.pop(),H=le.length===0,x=Y.create(ce.expr.map(he=>ee.create([he,de],null,ye)),null,H);x&&(le.push(x),le.sort(s))}if(le.length===1)return le[0];if(ye){for(let ce=0;ce<le.length;ce++)for(let de=ce+1;de<le.length;de++)if(le[ce].negate().equals(le[de]))return o.INSTANCE;if(le.length===1)return le[0]}return new ee(le,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new ee(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=Y.create(U,this,!0)}return this.c}}e.$vj=ee;class Y{static create(U,ie,ye){return Y.d(U,ie,ye)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const le=s(this.expr[ie],U.expr[ie]);if(le!==0)return le}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=K(this.expr);return U===this.expr?this:Y.create(U,this.c,!1)}evaluate(U){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,ye){let le=[],ue=!1;if(U){for(let ce=0,de=U.length;ce<de;ce++){const H=U[ce];if(H){if(H.type===0){ue=!0;continue}if(H.type===1)return d.INSTANCE;if(H.type===9){le=le.concat(H.expr);continue}le.push(H)}}if(le.length===0&&ue)return o.INSTANCE;le.sort(s)}if(le.length!==0){if(le.length===1)return le[0];for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];if(ye){for(let ce=0;ce<le.length;ce++)for(let de=ce+1;de<le.length;de++)if(le[ce].negate().equals(le[de]))return d.INSTANCE;if(le.length===1)return le[0]}return new Y(le,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Y(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),ye=U.shift(),le=[];for(const ue of se(ie))for(const ce of se(ye))le.push(ee.create([ue,ce],null,!1));U.unshift(Y.create(le,null,!1))}this.c=Y.create(U,this,!0)}return this.c}}e.$wj=Y;class Q extends m{static{this.d=[]}static all(){return Q.d.values()}constructor(U,ie,ye){super(U,null),this.f=ie,typeof ye=="object"?Q.d.push({...ye,key:U}):ye!==!0&&Q.d.push({key:U,description:ye,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$xj=Q,e.$yj=(0,A.$gi)("contextKeyService");function Z(re,U){return re<U?-1:re>U?1:0}function ae(re,U,ie,ye){return re<ie?-1:re>ie?1:U<ye?-1:U>ye?1:0}function _(re,U){if(re.type===0||U.type===1)return!0;if(re.type===9)return U.type===9?ge(re.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(_(re,ie))return!0;return!1}if(re.type===6){if(U.type===6)return ge(U.expr,re.expr);for(const ie of re.expr)if(_(ie,U))return!0;return!1}return re.equals(U)}function ge(re,U){let ie=0,ye=0;for(;ie<re.length&&ye<U.length;){const le=re[ie].cmp(U[ye]);if(le<0)return!1;le===0&&ie++,ye++}return ie===re.length}function se(re){return re.type===9?re.expr:[re]}}),define(Se[246],De([1,0,23,39,204,5,103,11,24]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$ow=e.$nw=e.$mw=void 0,e.$pw=S,e.$qw=y,e.$mw=(0,A.$gi)("dialogService");var E;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(E||(E={}));class R{a(g){return this.d(g,E.Confirmation)}b(g){return this.d(g,E.Prompt)}c(g){return this.d(g,E.Input)}d(g,c){const n=[];switch(c){case E.Confirmation:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(1,null));break}case E.Prompt:{const i=g;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,M.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,M.localize)(3,null))),n.length===0&&n.push((0,M.localize)(4,null));break}case E.Input:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(6,null));break}}return n}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===L.default.Info?"info":g===L.default.Error?"error":g===L.default.Warning?"warning":"none"}f(g,c,n){const i=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&i.push(g.cancelButton);let r=i[c]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$nw=R,e.$ow=(0,A.$gi)("fileDialogService");var I;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const w=10;function S(h){const g=[];return g.push(...h.slice(0,w).map(c=>typeof c=="string"?c:(0,u.$Qg)(c))),h.length>w&&(h.length-w===1?g.push((0,M.localize)(7,null)):g.push((0,M.localize)(8,null,h.length-w))),g.push(""),g.join(`
`)}function y(h,g){const c=(0,p.$Mn)(h);let n=(c.buttons??[]).map(t=>(0,P.$jw)(t)),i=(h.buttons||[]).map((t,f)=>f),r=0,a=c.cancelId??n.length-1;if(n.length>1){const t=typeof a=="number"?n[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&a!==1){n.splice(a,1),n.splice(1,0,t);const f=i[a];i.splice(a,1),i.splice(1,0,f),a=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(a=r-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&a!==n.length-1){n.splice(a,1),n.push(t);const f=i[a];i.splice(a,1),i.push(f),a=n.length-1}}return c.buttons=n,c.defaultId=r,c.cancelId=a,c.noLink=!0,c.title=c.title||g.nameLong,{options:c,buttonIndeces:i}}}),define(Se[136],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,u.$gi)("environmentService"),e.$oi=(0,u.$hi)(e.$ni)}),define(Se[137],De([1,0,205,5]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.ExtensionGalleryErrorCode=e.$Qo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Po=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0,e.$Jo=M,e.$Ko=A,e.$Lo=P,e.$Mo=b,e.$No=p,e.$Oo=E,e.$Do="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Eo=new RegExp(e.$Do),e.$Fo="__web_extension",e.$Go="skipWalkthrough",e.$Ho="extensionsSync",e.$Io="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,r){return r==="web"&&!i.includes("web")}function p(i,r,a){return b(r,a)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===a}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var R;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var w;(function(i){i.Install="install",i.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var S;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Po=(0,L.$gi)("extensionGalleryService");var y;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var h;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(h||(e.ExtensionSignaturetErrorCode=h={}));class g extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$Qo=g;var c;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class n extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$Ro=n,e.$So=(0,L.$gi)("extensionManagementService"),e.$To="extensionsIdentifiers/disabled",e.$Uo="extensionsIdentifiers/enabled",e.$Vo=(0,L.$gi)("IGlobalExtensionEnablementService"),e.$Wo=(0,L.$gi)("IExtensionTipsService"),e.$Xo=(0,u.localize2)(0,"Extensions"),e.$Yo=(0,u.localize2)(1,"Preferences")}),define(Se[247],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=e.$44b=void 0,e.$44b=(0,u.$gi)("externalTerminal"),e.$54b="Terminal.app"}),define(Se[248],De([1,0,51,53,15,17,11,102,31,105,207,247]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=e.$5_b=void 0;const w=R.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends S{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(u,a,E.$$l(),t)}spawnTerminal(a,t,f,l){const s=t.windowsExec||y.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const o=A.$nc(s,".exe").toLowerCase();if(o==="cmder")return a.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),o==="wt"&&d.push("-d ."),new Promise((m,D)=>{const $=c(process),v=a.spawn(f,d,{cwd:l,env:$,detached:!0});v.on("error",D),v.on("exit",()=>m())})}async runInTerminal(a,t,f,l,s){const o="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows(),d=await y.f();return new Promise((m,D)=>{const $=`"${t} - ${w}"`,v=`"${f.join('" "')}" & pause`,k=Object.assign({},c(process),l);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const C={cwd:t,env:k,windowsVerbatimArguments:!0};let O,B;A.$nc(o,".exe")==="wt"?(O=o,B=["-d",".",y.b,"/c",v]):d?(O=d,B=["-d",".",o,"/c",v]):(O=y.b,B=["/c","start",$,"/wait",o,"/c",`"${v}"`]),u.spawn(O,B,C).on("error",T=>{D(n(T))}),m(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y.d}static async f(){try{const a=await E.win32.findExecutable("wt");return await p.Promises.exists(a)?a:void 0}catch{return}}}e.$5_b=y,Je([L.$Kh],y,"f",null);class h extends S{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(u,a,t)}runInTerminal(a,t,f,l,s){const o=s.osxExec||I.$54b;return new Promise((d,m)=>{if(o===I.$54b||o==="iTerm.app"){const D=o===I.$54b?"TerminalHelper":"iTermHelper",v=[M.$Ag.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",a||w,"-w",t];for(const O of f)v.push("-a"),v.push(O);if(l){const O=Object.assign({},c(process),l);for(const B in O){const z=O[B];z===null?(v.push("-u"),v.push(B)):(v.push("-e"),v.push(`${B}=${z}`))}}let k="";const C=u.spawn(h.b,v);C.on("error",O=>{m(n(O))}),C.stderr.on("data",O=>{k+=O.toString()}),C.on("exit",O=>{if(O===0)d(void 0);else if(k){const B=k.split(`
`,1);m(new Error(B[0]))}else m(new Error(R.localize(1,null,D,O)))})}else m(new Error(R.localize(2,null,o)))})}spawnTerminal(a,t,f){const l=t.osxExec||I.$54b;return new Promise((s,o)=>{const d=["-a",l];f&&d.push(f);const m=c(process),D=a.spawn("/usr/bin/open",d,{cwd:f,env:m});D.on("error",o),D.on("exit",()=>s())})}}e.$6_b=h;class g extends S{static{this.b=R.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(u,a,t)}runInTerminal(a,t,f,l,s){const o=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((d,m)=>{const D=[];o.then($=>{$.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const v=`${i(f)}; echo; read -p "${g.b}" -n1;`;D.push(`''${v}''`);const k=Object.assign({},c(process),l);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const C={cwd:t,env:k};let O="";const B=u.spawn($,D,C);B.on("error",z=>{m(n(z))}),B.stderr.on("data",z=>{O+=z.toString()}),B.on("exit",z=>{if(z===0)d(void 0);else if(O){const T=O.split(`
`,1);m(new Error(T[0]))}else m(new Error(R.localize(4,null,$,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!P.$k)g.d=Promise.resolve("xterm");else{const a=await p.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(a,t,f){const l=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,o)=>{l.then(d=>{const m=c(process),D=a.spawn(d,[],{cwd:f,env:m});D.on("error",o),D.on("exit",()=>s())})})}}e.$7_b=g;function c(r){const a={...r.env};return(0,b.$9l)(a),a}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(R.localize(5,null,r.path)):r}function i(r){let a="";for(const t of r)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(Se[32],De([1,0,76,17,14,18,2,208,5,11,15,43]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$fl=e.FileKind=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileOperationResult=e.$0k=e.$9k=e.$8k=e.$6k=e.FileChangeType=e.$5k=e.FileOperation=e.$Yk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Mk=void 0,e.$Nk=w,e.$Ok=h,e.$Pk=c,e.$Qk=n,e.$Rk=i,e.$Sk=r,e.$Tk=a,e.$Uk=t,e.$Vk=f,e.$Wk=l,e.$Xk=s,e.$Zk=m,e.$1k=D,e.$2k=$,e.$3k=v,e.$4k=k,e.$7k=T,e.$gl=Y,e.$hl=Q,e.$jl=ae,e.$Mk=(0,p.$gi)("fileService");function w(_){return _.create===!0}var S;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var y;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function h(_){const ge=_;return!!ge&&typeof ge.onDidChange=="function"}var g;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function c(_){return!!(_.capabilities&2)}function n(_){return!!(_.capabilities&8)}function i(_){return!!(_.capabilities&131072)}function r(_){return!!(_.capabilities&4)}function a(_){return!!(_.capabilities&16)}function t(_){return c(_)?!!(_.capabilities&16384):!1}function f(_){return c(_)?!!(_.capabilities&32768):!1}function l(_){return!!(_.capabilities&65536)}function s(_){return!!(_.capabilities&2048)}var o;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class d extends Error{static create(ge,se){const re=new d(ge.toString(),se);return $(re,se),re}constructor(ge,se){super(ge),this.code=se}}e.$Yk=d;function m(_,ge){return d.create(_,ge)}function D(_){return _||m((0,b.localize)(0,null),o.Unknown)}function $(_,ge){return _.name=ge?`${ge} (FileSystemError)`:"FileSystemError",_}function v(_){if(!_)return o.Unknown;if(_ instanceof d)return _.code;const ge=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ge)return o.Unknown;switch(ge[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function k(_){if(_ instanceof j)return _.fileOperationResult;switch(v(_)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var C;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class O{constructor(ge,se,re){this.resource=ge,this.operation=se,this.target=re}isOperation(ge){return this.operation===ge}}e.$5k=O;var B;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(B||(e.FileChangeType=B={}));class z{static{this.a=null}constructor(ge,se){this.c=se,this.b=void 0,this.d=new I.$V(()=>{const re=u.$mi.forUris(()=>this.c);return re.fill(this.rawAdded.map(U=>[U,!0])),re}),this.f=new I.$V(()=>{const re=u.$mi.forUris(()=>this.c);return re.fill(this.rawUpdated.map(U=>[U,!0])),re}),this.g=new I.$V(()=>{const re=u.$mi.forUris(()=>this.c);return re.fill(this.rawDeleted.map(U=>[U,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of ge){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==z.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ge,...se){return this.h(ge,{includeChildren:!1},...se)}affects(ge,...se){return this.h(ge,{includeChildren:!0},...se)}h(ge,se,...re){if(!ge)return!1;const U=re.length>0;return!!((!U||re.includes(1))&&(this.d.value.get(ge)||se.includeChildren&&this.d.value.findSuperstr(ge))||(!U||re.includes(0))&&(this.f.value.get(ge)||se.includeChildren&&this.f.value.findSuperstr(ge))||(!U||re.includes(2))&&(this.g.value.findSubstr(ge)||se.includeChildren&&this.g.value.findSuperstr(ge)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ge){return this.b===ge}hasCorrelation(){return typeof this.b=="number"}}e.$6k=z;function T(_,ge,se){return!_||!ge||_===ge||ge.length>_.length?!1:(ge.charAt(ge.length-1)!==L.sep&&(ge+=L.sep),se?(0,M.$lf)(_,ge):_.indexOf(ge)===0)}class j extends Error{constructor(ge,se,re){super(ge),this.fileOperationResult=se,this.options=re}}e.$8k=j;class N extends j{constructor(ge,se,re,U){super(ge,se,U),this.fileOperationResult=se,this.size=re}}e.$9k=N;class F extends j{constructor(ge,se,re){super(ge,2,re),this.stat=se}}e.$0k=F;var K;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$$k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$_k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$al="files.associations",e.$bl="files.exclude",e.$cl="files.readonlyInclude",e.$dl="files.readonlyExclude",e.$el="files.readonlyFromPermissions";var ee;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$fl="";function Y(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}async function Q(_,ge){if(!ge.hasProvider(P.URI.from({scheme:_.scheme})))return new Promise(se=>{const re=ge.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===_.scheme&&U.added&&(re.dispose(),se())})})}class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(ge){return(0,A.$Xf)(ge)||(ge=0),ge<Z.KB?(0,b.localize)(1,null,ge.toFixed(0)):ge<Z.MB?(0,b.localize)(2,null,(ge/Z.KB).toFixed(2)):ge<Z.GB?(0,b.localize)(3,null,(ge/Z.MB).toFixed(2)):ge<Z.TB?(0,b.localize)(4,null,(ge/Z.GB).toFixed(2)):(0,b.localize)(5,null,(ge/Z.TB).toFixed(2))}}e.$il=Z;function ae(_){const ge=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*Z.MB:ge?10*Z.MB:E.$o?50*Z.MB:1024*Z.MB}}),define(Se[249],De([1,0,21,13,209,32]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=P;async function P(R,I,w,S,y,h){let g;try{await b(R,I,w,S,y,h)}catch(c){g=c}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}async function b(R,I,w,S,y,h){p(h);const g=await R.open(I,{create:!1});try{p(h);let c=0,n=0,i=y&&typeof y.length=="number"?y.length:void 0,r=u.$te.alloc(Math.min(y.bufferSize,typeof i=="number"?i:y.bufferSize)),a=y&&typeof y.position=="number"?y.position:0,t=0;do n=await R.read(g,a,r.buffer,t,r.byteLength-t),a+=n,t+=n,c+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await w.write(S(r)),r=u.$te.alloc(Math.min(y.bufferSize,typeof i=="number"?i:y.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&p(h)&&E(c,y));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),w.write(S(r.slice(0,f)))}}catch(c){throw(0,A.$1k)(c)}finally{await R.close(g)}}function p(R){if(R.isCancellationRequested)throw(0,L.$6)();return!0}function E(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,A.$Zk)((0,M.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,35,3,17,11,2,32]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0,e.$tq=p,e.$xq=w,e.$yq=S,e.$zq=y,e.$Aq=h;function p(c){return c.recursive===!0}class E extends L.$Tc{static{this.a=5}constructor(n,i,r,a){super(),this.h=n,this.j=i,this.m=r,this.n=a,this.c=this.B(new L.$Uc),this.f=void 0,this.g=0}s(){const n=new L.$Sc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(i=>this.h(i))),n.add(this.b.onDidLogMessage(i=>this.j(i))),n.add(this.b.onDidError(i=>this.t(i)))}t(n){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$uq=E;class R extends E{constructor(n,i,r){super(n,i,r,{type:"node.js",restartOnError:!1})}}e.$vq=R;class I extends E{constructor(n,i,r){super(n,i,r,{type:"universal",restartOnError:!0})}}e.$wq=I;function w(c){return c.map(n=>({type:n.type,resource:P.URI.revive(n.resource),cId:n.cId}))}function S(c){const n=new g;for(const i of c)n.processEvent(i);return n.coalesce()}function y(c,n){return typeof n=="string"&&!n.startsWith(u.$9j)&&!(0,M.$ic)(n)?{base:c,pattern:n}:n}function h(c,n){const i=[];for(const r of n)i.push((0,u.$ak)(y(c,r)));return i}class g{constructor(){this.a=new Set,this.b=new Map}c(n){return A.$k?n.resource.fsPath:n.resource.fsPath.toLowerCase()}processEvent(n){const i=this.b.get(this.c(n));let r=!1;if(i){const a=i.type,t=n.type;i.resource.fsPath!==n.resource.fsPath&&(n.type===2||n.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(n)),this.a.delete(i)):a===2&&t===1?i.type=0:a===1&&t===0||(i.type=t)}else r=!0;r&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],i=[];return Array.from(this.a).filter(r=>r.type!==2?(n.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>i.some(a=>(0,b.$7k)(r.resource.fsPath,a,!A.$k))?!1:(i.push(r.resource.fsPath),!0)).concat(n)}}}),define(Se[250],De([1,0,57,8,22,34,3,75,17,11,23,2,104,31,84]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,e.$Oq=g;class h extends P.$Tc{static{this.a=100}static{this.b=75}constructor(n,i,r,a){super(),this.m=n,this.n=i,this.r=r,this.s=a,this.c=this.B(new L.$vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new L.$uh(t=>this.z(t),h.b)),this.g=(0,y.$Aq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$Aq)(this.m.path,this.m.includes):void 0,this.j=new M.$de,this.ready=this.t()}async t(){try{const n=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const i=await S.Promises.stat(n);this.B(await this.w(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.D(n):this.G(n)}}async u(n){let i=n.path;try{i=await S.Promises.realpath(n.path),n.path===i&&(i=await(0,w.$Kq)(n.path)??n.path),n.path!==i&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async w(n,i){if(E.$j&&(0,A.$gg)(n,"/Volumes/",!0))return this.D(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.$Tc.None;const r=new M.$de(this.j.token),a=new P.$Sc;try{const t=I.URI.file(this.m.path),f=(0,p.$nc)(n),l=(0,u.watch)(n);a.add((0,P.$Rc)(()=>{l.removeAllListeners(),l.close()})),this.G(`Started watching: '${n}'`);const s=new Set;if(i)try{for(const d of await S.Promises.readdir(n))s.add(d)}catch(d){this.D(d)}const o=new Map;a.add((0,P.$Rc)(()=>{for(const[,d]of o)d.dispose();o.clear()})),l.on("error",(d,m)=>{this.D(`Failed to watch ${n} for changes using fs.watch() (${d}, ${m})`),this.dispose()}),l.on("change",(d,m)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${m}`);let D="";if(m&&(D=m.toString(),E.$j&&(D=(0,b.$Xl)(D))),!(!D||d!=="change"&&d!=="rename"))if(i)if(d==="rename"){o.get(D)?.dispose();const $=setTimeout(async()=>{if(o.delete(D),D===f&&!await S.Promises.exists(n)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.C((0,p.$jc)(n,D));if(r.token.isCancellationRequested)return;let k;v?s.has(D)?k=0:(k=1,s.add(D)):(s.delete(D),k=2),this.y({resource:(0,R.$Tg)(t,D),type:k,cId:this.m.correlationId})},h.a);o.set(D,(0,P.$Rc)(()=>clearTimeout($)))}else{let $;s.has(D)?$=0:($=1,s.add(D)),this.y({resource:(0,R.$Tg)(t,D),type:$,cId:this.m.correlationId})}else if(d==="rename"||D!==f){const $=setTimeout(async()=>{const v=await S.Promises.exists(n);r.token.isCancellationRequested||(v?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(n,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},h.a);a.clear(),a.add((0,P.$Rc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(n)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`)}return(0,P.$Rc)(()=>{r.dispose(!0),a.dispose()})}y(n,i=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}z(n){const i=(0,y.$yq)(n);if(i.length>0){if(this.s)for(const a of i)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(n){if(E.$k)return S.Promises.exists(n);try{const i=(0,p.$nc)(n);return(await S.Promises.readdir((0,p.$mc)(n))).some(a=>a===i)}catch(i){return this.G(i),!1}}setVerboseLogging(n){this.s=n}D(n){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}F(n){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}G(n){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Nq=h;async function g(c,n,i,r,a=512){const t=await S.Promises.open(c,"r"),f=Buffer.allocUnsafe(a),l=new M.$de(r);let s,o=!1;const d={path:c,excludes:[],recursive:!1},m=new h(d,D=>{(async()=>{for(const{type:$}of D)if($===0){if(o)return;o=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:v}=await S.Promises.read(t,f,0,a,null);if(!v||l.token.isCancellationRequested)break;n(f.slice(0,v))}}catch(v){s=new Error(v),l.dispose(!0)}finally{o=!1}}})()});return await m.ready,i(),new Promise((D,$)=>{l.token.onCancellationRequested(async()=>{m.dispose();try{await S.Promises.close(t)}catch(v){s=new Error(v)}s?$(s):D()})})}}),define(Se[251],De([1,0,4,35,3,11,250]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class b extends M.$Tc{constructor(){super(...arguments),this.a=this.B(new u.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new u.$6d),this.onDidLogMessage=this.b.event,this.onDidError=u.Event.None,this.c=new Map,this.f=!1}async watch(E){const R=this.j(E),I=R.filter(S=>{const y=this.c.get(S.path);return y?!(0,L.$ek)(y.request.excludes,S.excludes)||!(0,L.$ek)(y.request.includes,S.includes):!0}),w=Array.from(this.c.values()).filter(({request:S})=>!R.find(y=>y.path===S.path&&(0,L.$ek)(y.excludes,S.excludes)&&(0,L.$ek)(y.includes,S.includes))).map(({request:S})=>S.path);I.length&&this.m(`Request to start watching: ${I.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const S of w)this.h(S);for(const S of I)this.g(S)}g(E){const R=new P.$Nq(E,w=>this.a.fire(w),w=>this.b.fire(w),this.f),I={request:E,instance:R};this.c.set(E.path,I)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const R=this.c.get(E);R&&(this.c.delete(E),R.instance.dispose())}j(E){const R=new Map;for(const I of E){const w=A.$k?I.path:I.path.toLowerCase();let S=R.get(I.correlationId);S||(S=new Map,R.set(I.correlationId,S)),S.set(w,I)}return Array.from(R.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(E){this.f=E;for(const[,R]of this.c)R.instance.setVerboseLogging(E)}m(E){this.f&&this.b.fire({type:"trace",message:this.n(E)})}n(E,R){return R?`[File Watcher (node.js)] ${E} (path: ${R.request.path})`:`[File Watcher (node.js)] ${E}`}}e.$Pq=b}),define(Se[252],De([1,0,84,251]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class M extends u.$vq{constructor(P,b,p){super(P,b,p),this.s()}r(P){return P.add(new L.$Pq)}}e.$Qq=M}),define(Se[253],De([1,0,15,80,192,84]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class P extends A.$wq{constructor(p,E,R){super(p,E,R),this.s()}r(p){const E=p.add(new M.$Hq(u.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(E.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),L.ProxyChannel.toService((0,L.$Zh)(E.getChannel("watcher")))}}e.$Iq=P}),define(Se[107],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class u{constructor(...M){this.a=new Map;for(const[A,P]of M)this.set(A,P)}set(M,A){const P=this.a.get(M);return this.a.set(M,A),P}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$ei=u}),define(Se[254],De([1,0,8,13,3,106,245,5,107,74]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;const R=!1;class I extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new p.$ei,c=!1,n,i=R){this.f=g,this.g=c,this.h=n,this.i=i,this.o=new Set,this.f.set(b.$fi,this),this._globalGraph=i?n?._globalGraph??new P.$Tq(r=>r):void 0}createChild(g){return new w(g,this.g,this,this.i)}invokeFunction(g,...c){const n=y.traceInvocation(this.i,g);let i=!1;try{return g({get:a=>{if(i)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,n);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...c)}finally{i=!0,n.stop()}}createInstance(g,...c){let n,i;return g instanceof A.$di?(n=y.traceCreation(this.i,g.ctor),i=this.j(g.ctor,g.staticArguments.concat(c),n)):(n=y.traceCreation(this.i,g),i=this.j(g,c,n)),n.stop(),i}j(g,c=[],n){const i=b._util.getServiceDependencies(g).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.m(t.id,n);f||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const a=i.length>0?i[0].index:c.length;if(c.length!==a){console.trace(`[createInstance] First service dependency of ${g.name} at position ${a+1} conflicts with ${c.length} static arguments`);const t=a-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,a)}return Reflect.construct(g,c.concat(r))}k(g,c){if(this.f.get(g)instanceof A.$di)this.f.set(g,c);else if(this.h)this.h.k(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const c=this.f.get(g);return!c&&this.h?this.h.l(g):c}m(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const n=this.l(g);return n instanceof A.$di?this.q(g,n,c.branch(g,!0)):(c.branch(g,!1),n)}q(g,c,n){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,c,n)}finally{this.o.delete(g)}}r(g,c,n){const i=new P.$Tq(t=>t.id.toString());let r=0;const a=[{id:g,desc:c,_trace:n}];for(;a.length;){const t=a.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new I(i);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const l=this.l(f.id);if(l||this.u(`[createInstance] ${g} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),l instanceof A.$di){const s={id:f.id,desc:l,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,s),a.push(s)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:f}of t){if(this.l(f.id)instanceof A.$di){const s=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,s)}i.removeNode(f)}}return this.l(g)}s(g,c,n=[],i,r){if(this.f.get(g)instanceof A.$di)return this.t(g,c,n,i,r);if(this.h)return this.h.s(g,c,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(g,c,n=[],i,r){if(i){const a=new w(void 0,this.g,this,this.i);a.c=String(g);const t=new Map,f=new u.$zh(()=>{const l=a.j(c,n,r);for(const[s,o]of t){const d=l[s];if(typeof d=="function")for(const m of o)m.disposable=d.apply(l,m.listener)}return t.clear(),l});return new Proxy(Object.create(null),{get(l,s){if(!f.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let m=t.get(s);return m||(m=new E.$4c,t.set(s,m)),($,v,k)=>{if(f.isInitialized)return f.value[s]($,v,k);{const C={listener:[$,v,k],disposable:void 0},O=m.push(C);return(0,M.$Rc)(()=>{O(),C.disposable?.dispose()})}}}if(s in l)return l[s];const o=f.value;let d=o[s];return typeof d!="function"||(d=d.bind(o),l[s]=d),d},set(l,s,o){return f.value[s]=o,!0},getPrototypeOf(l){return c.prototype}})}else return this.j(c,n,r)}u(g,c){if(c&&console.warn(g),this.g)throw new Error(g)}}e.$Uq=w;var S;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(S||(S={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(g,c){return g?new y(1,c.name):y.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const n=new y(3,g.toString());return this.h.push([g,c,n]),n}stop(){const g=Date.now()-this.g;y.f+=g;let c=!1;function n(r,a){const t=[],f=new Array(r+1).join("	");for(const[l,s,o]of a.h)if(s&&o){c=!0,t.push(`${f}CREATES -> ${l}`);const d=n(r+1,o);d&&t.push(d)}else t.push(`${f}uses -> ${l}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(g>2||c)&&y.all.add(i.join(`
`))}}e.$Vq=y}),define(Se[12],De([1,0,211,44,4,54,3,28,11,23,18,2,45,5]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Pj=e.LogLevel=e.$Nj=e.$Mj=void 0,e.$Oj=h,e.log=c,e.$1j=m,e.$2j=D,e.$3j=$,e.$4j=v,e.$Mj=(0,S.$gi)("logService"),e.$Nj=(0,S.$gi)("loggerService");function y(){return new Date().toISOString()}function h(k){return(0,R.$Xf)(k)}var g;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$Pj=g.Info;function c(k,C,O){switch(C){case g.Trace:k.trace(O);break;case g.Debug:k.debug(O);break;case g.Info:k.info(O);break;case g.Warning:k.warn(O);break;case g.Error:k.error(O);break;case g.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(k,C=!1){let O="";for(let B=0;B<k.length;B++){let z=k[B];if(z instanceof Error&&(z=(0,L.$4i)(z,C)),typeof z=="object")try{z=JSON.stringify(z)}catch{}O+=(B>0?" ":"")+z}return O}class i extends P.$Tc{constructor(){super(...arguments),this.b=e.$Pj,this.c=this.B(new M.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==g.Off&&this.b<=C}}e.$Rj=i;class r extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...O){this.f(g.Trace)&&this.g(g.Trace,n([C,...O],!0))}debug(C,...O){this.f(g.Debug)&&this.g(g.Debug,n([C,...O]))}info(C,...O){this.f(g.Info)&&this.g(g.Info,n([C,...O]))}warn(C,...O){this.f(g.Warning)&&this.g(g.Warning,n([C,...O]))}error(C,...O){if(this.f(g.Error))if(C instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=C.stack,this.g(g.Error,n(B))}else this.g(g.Error,n([C,...O]))}flush(){}}e.$Sj=r;class a extends i{constructor(C=e.$Pj){super(),this.setLevel(C),this.g=!p.$i}trace(C,...O){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,C,...O):console.log(`[main ${y()}]`,C,...O))}debug(C,...O){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,C,...O):console.log(`[main ${y()}]`,C,...O))}info(C,...O){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,C,...O):console.log(`[main ${y()}]`,C,...O))}warn(C,...O){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,C,...O):console.warn(`[main ${y()}]`,C,...O))}error(C,...O){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,C,...O):console.error(`[main ${y()}]`,C,...O))}flush(){}}e.$Tj=a;class t extends i{constructor(C=e.$Pj,O=!0){super(),this.g=O,this.setLevel(C)}trace(C,...O){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...O):console.log(C,...O))}debug(C,...O){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...O):console.log(C,...O))}info(C,...O){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...O):console.log(C,...O))}warn(C,...O){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...O):console.log(C,...O))}error(C,...O){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...O):console.error(C,...O))}flush(){}}e.$Uj=t;class f extends i{constructor(C,O=e.$Pj){super(),this.g=C,this.setLevel(O)}trace(C,...O){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(C),...O])}debug(C,...O){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(C),...O])}info(C,...O){this.f(g.Info)&&this.g.log(g.Info,[this.h(C),...O])}warn(C,...O){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(C),...O])}error(C,...O){this.f(g.Error)&&this.g.log(g.Error,[this.h(C),...O])}h(C){return typeof C=="string"?C:(0,L.$4i)(C,this.f(g.Trace))}flush(){}}e.$Vj=f;class l extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const O of this.g)O.setLevel(C);super.setLevel(C)}trace(C,...O){for(const B of this.g)B.trace(C,...O)}debug(C,...O){for(const B of this.g)B.debug(C,...O)}info(C,...O){for(const B of this.g)B.info(C,...O)}warn(C,...O){for(const B of this.g)B.warn(C,...O)}error(C,...O){for(const B of this.g)B.error(C,...O)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$Wj=l;class s extends P.$Tc{constructor(C,O,B){if(super(),this.h=C,this.j=O,this.b=new b.$Ac,this.c=this.B(new M.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$6d),this.onDidChangeVisibility=this.g.event,B)for(const z of B)this.b.set(z.resource,{logger:void 0,info:z})}m(C){return(0,R.$Tf)(C)?[...this.b.values()].find(O=>O.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,O){const B=this.n(C),z=(0,R.$Tf)(C)?C:O?.id??(0,A.$7i)(B.toString()).toString(16);let T=this.b.get(B)?.logger;const j=O?.logLevel==="always"?g.Trace:O?.logLevel;T||(T=this.s(B,j??this.getLogLevel(B)??this.h,{...O,id:z}));const N={logger:T,info:{resource:B,id:z,logLevel:j,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(N.info),this.b.set(B,N),T}n(C){return(0,R.$Tf)(C)?(0,E.$Tg)(this.j,`${C}.log`):C}setLogLevel(C,O){if(I.URI.isUri(C)){const B=C,z=O,T=this.b.get(B);T&&z!==T.info.logLevel&&(T.info.logLevel=z===this.h?void 0:z,T.logger?.setLevel(z),this.b.set(T.info.resource,T),this.f.fire([B,z]))}else{this.h=C;for(const[B,z]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,O){const B=this.m(C);B&&O!==!B.info.hidden&&(B.info.hidden=!O,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,O]))}getLogLevel(C){let O;return C&&(O=this.b.get(C)?.info.logLevel),O??this.h}registerLogger(C){const O=this.b.get(C.resource);O?O.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const O=this.b.get(C);O&&(O.logger&&O.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Xj=s;class o{constructor(){this.onDidChangeLogLevel=new M.$6d().event}setLevel(C){}getLevel(){return g.Info}trace(C,...O){}debug(C,...O){}info(C,...O){}warn(C,...O){}error(C,...O){}critical(C,...O){}dispose(){}flush(){}}e.$Yj=o;class d extends o{}e.$Zj=d;function m(k){if(k.verbose)return g.Trace;if(typeof k.logLevel=="string"){const C=v(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Pj}function D(k){switch(k){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function $(k){switch(k){case g.Trace:return{original:"Trace",value:u.localize(0,null)};case g.Debug:return{original:"Debug",value:u.localize(1,null)};case g.Info:return{original:"Info",value:u.localize(2,null)};case g.Warning:return{original:"Warning",value:u.localize(3,null)};case g.Error:return{original:"Error",value:u.localize(4,null)};case g.Off:return{original:"Off",value:u.localize(5,null)}}}function v(k){switch(k){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$5j=new w.$xj("logLevel",D(g.Info))}),define(Se[255],De([1,0,19,8,13,4,3,17,84,12]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class R extends P.$Tc{constructor(w,S){super(),this.a=w,this.b=S,this.c=this.B(new A.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$eh(0)),this.w=[],this.y=this.B(new L.$eh(0))}watch(w,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(w,S):this.z(w,S)}n(w,S){const y={path:this.H(w),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},h=(0,u.$Ub)(this.j,y);return this.r(),(0,P.$Rc)(()=>{h(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,M.$1)(w))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,p.$xq)(S)),S=>this.G(S),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const S of this.j)(0,p.$tq)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const S of this.j)(0,p.$tq)(S)&&w.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,S){const y={path:this.H(w),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},h=(0,u.$Ub)(this.w,y);return this.C(),(0,P.$Rc)(()=>{h(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,M.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,p.$xq)(w)),w=>this.G(w),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,b.$hc)(w.fsPath)}}e.$Bq=R}),define(Se[256],De([1,0,57,394,8,28,21,4,34,3,17,11,23,98,31,210,32,249,255,44,253,252]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,(()=>{try{(0,L.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$4i)(f)}`)}})();class t extends n.$Bq{static{this.I=!1}constructor(l,s){super(l,s),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$Ac(o=>w.$Kg.getComparisonKey(o)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(l){try{const{stat:s,symbolicLink:o}=await y.SymlinkSupport.stat(this.H(l));return{type:this.M(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const s=await y.Promises.readdir(this.H(l),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async d=>{try{let m;d.isSymbolicLink()?m=(await this.stat((0,w.$Tg)(l,d.name))).type:m=this.M(d),o.push([d.name,m])}catch(m){this.a.trace(m)}})),o}catch(s){throw this.fb(s)}}M(l,s){let o;return s?.dangling?o=g.FileType.Unknown:l.isFile()?o=g.FileType.File:l.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,s&&(o|=g.FileType.SymbolicLink),o}async O(l){const s=this.H(l);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.N.get(l);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const d=new M.$fh;return this.N.set(l,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,E.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(l)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(l)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),d.open()})}async readFile(l,s){let o;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(l)})`),o=await this.O(l));const d=this.H(l);return await y.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{o?.dispose()}}P(l){t.I&&this.a.trace(l)}readFileStream(l,s,o){const d=(0,S.$he)(m=>P.$te.concat(m.map(D=>P.$te.wrap(D))).buffer);return(0,c.$rq)(this,l,d,m=>m.buffer,{...s,bufferSize:256*1024},o),d}async writeFile(l,s,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.Q(l)?this.R(l,(0,w.$Tg)((0,w.$Sg)(l),`${(0,w.$Qg)(l)}${o.atomic.postfix}`),s,o):this.S(l,s,o)}async Q(l){try{const s=this.H(l),{symbolicLink:o}=await y.SymlinkSupport.stat(s);if(o)return!1}catch{}return!0}async R(l,s,o,d){const m=new E.$Sc;try{m.add(await this.O(l)),m.add(await this.O(s)),await this.S(s,o,d,!0);try{await this.rename(s,l,{overwrite:!0})}catch(D){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{m.dispose()}}async S(l,s,o,d){let m;try{const D=this.H(l);if(!o.create||!o.overwrite){if(await y.Promises.exists(D)){if(!o.overwrite)throw(0,g.$Zk)((0,h.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.$Zk)((0,h.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(l,{create:!0,unlock:o.unlock},d),await this.write(m,0,s,0,s.byteLength)}catch(D){throw await this.gb(l,D)}finally{typeof m=="number"&&await this.close(m)}}static{this.Y=!0}static configureFlushOnWrite(l){t.Y=l}async open(l,s,o){const d=this.H(l);let m;(0,g.$Nk)(s)&&!o&&(m=await this.O(l));let D;try{if((0,g.$Nk)(s)&&s.unlock)try{const{stat:v}=await y.SymlinkSupport.stat(d);v.mode&128||await y.Promises.chmod(d,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let $;if((0,g.$Nk)(s)){if(I.$i)try{await y.Promises.truncate(d,0),$="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}$||($="w")}else $="r";D=await y.Promises.open(d,$)}catch($){throw m?.dispose(),(0,g.$Nk)(s)?await this.gb(l,$):this.fb($)}if(this.U.set(D,0),(0,g.$Nk)(s)&&this.X.set(D,l),m){const $=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${d})`),this.W.set(D,m),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${d})`),$.dispose())}return D}async close(l){const s=this.W.get(l);try{if(this.U.delete(l),this.X.delete(l)&&t.Y)try{await y.Promises.fdatasync(l)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await y.Promises.close(l)}catch(o){throw this.fb(o)}finally{s&&(this.W.get(l)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.W.delete(l)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),s.dispose())}}async read(l,s,o,d,m){const D=this.Z(l,s);let $=null;try{$=(await y.Promises.read(l,o,d,m,D)).bytesRead}catch(v){throw this.fb(v)}finally{this.$(l,D,$)}return $}Z(l,s){return s===this.U.get(l)?null:s}$(l,s,o){const d=this.U.get(l);typeof d=="number"&&(typeof s=="number"||(typeof o=="number"?this.U.set(l,d+o):this.U.delete(l)))}async write(l,s,o,d,m){return(0,M.$Ah)(()=>this.ab(l,s,o,d,m),100,3)}async ab(l,s,o,d,m){const D=this.Z(l,s);let $=null;try{$=(await y.Promises.write(l,o,d,m,D)).bytesWritten}catch(v){throw await this.gb(this.X.get(l),v)}finally{this.$(l,D,$)}return $}async mkdir(l){try{await y.Promises.mkdir(this.H(l))}catch(s){throw this.fb(s)}}async delete(l,s){try{const o=this.H(l);if(s.recursive){let d;s?.atomic!==!1&&s.atomic.postfix&&(d=(0,R.$jc)((0,R.$mc)(o),`${(0,R.$nc)(o)}${s.atomic.postfix}`)),await y.Promises.rm(o,y.RimRafMode.MOVE,d)}else try{await y.Promises.unlink(o)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let m=!1;try{const{stat:D,symbolicLink:$}=await y.SymlinkSupport.stat(o);m=D.isDirectory()&&!$}catch{}if(m)await y.Promises.rmdir(o);else throw d}else throw d}}catch(o){throw this.fb(o)}}async rename(l,s,o){const d=this.H(l),m=this.H(s);if(d!==m)try{await this.bb(l,s,"move",o.overwrite),await y.Promises.rename(d,m)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,h.localize)(2,null,(0,R.$nc)(d),(0,R.$nc)((0,R.$mc)(m)),D.toString()))),this.fb(D)}}async copy(l,s,o){const d=this.H(l),m=this.H(s);if(d!==m)try{await this.bb(l,s,"copy",o.overwrite),await y.Promises.copy(d,m,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,h.localize)(3,null,(0,R.$nc)(d),(0,R.$nc)((0,R.$mc)(m)),D.toString()))),this.fb(D)}}async bb(l,s,o,d){const m=this.H(l),D=this.H(s);let $=!1;if(!!(this.capabilities&1024)||($=(0,p.$fg)(m,D,!0)),$){if(o==="copy")throw(0,g.$Zk)((0,h.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const k=await this.L(l);if(!k)throw(0,g.$Zk)((0,h.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(s);if(C){if(!d)throw(0,g.$Zk)((0,h.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,s){return this.cb(l,s,!1)}async cb(l,s,o){const d=this.H(l),m=this.H(s),D=!!(this.capabilities&1024);if((0,p.$fg)(d,m,!D))return;const $=new E.$Sc;try{$.add(await this.O(l)),$.add(await this.O(s)),o&&await y.Promises.mkdir((0,R.$mc)(m),{recursive:!0}),await y.Promises.copyFile(d,m)}catch(v){if(v.code==="ENOENT"&&!o)return this.cb(l,s,!0);throw this.fb(v)}finally{$.dispose()}}t(l,s,o){return new r.$Iq(d=>l(d),d=>s(d),o)}F(l,s,o){return new a.$Qq(d=>l(d),d=>s(d),o)}fb(l){if(l instanceof g.$Yk)return l;let s=l,o;switch(l.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Zk)(s,o)}async gb(l,s){let o=this.fb(s);if(l&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await y.SymlinkSupport.stat(this.H(l));d.mode&128||(o=(0,g.$Zk)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return o}}e.$Rq=t}),define(Se[257],De([1,0,3,12]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class M extends u.$Tc{constructor(P,b=[]){super(),this.a=new L.$Wj([P,...b]),this.B(P.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...b){this.a.trace(P,...b)}debug(P,...b){this.a.debug(P,...b)}info(P,...b){this.a.info(P,...b)}warn(P,...b){this.a.warn(P,...b)}error(P,...b){this.a.error(P,...b)}flush(){this.a.flush()}}e.$VP=M}),define(Se[258],De([1,0,32,12]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=void 0;var M;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(M||(M={}));async function A(E,R,I,w,S){try{const y=await new Promise((g,c)=>{fe(["@vscode/spdlog"],g,c)});y.setFlushOn(M.Trace);const h=await y.createAsyncRotatingLogger(E,R,I,w);return S?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(y){console.error(y)}return null}function P(E,R,I){switch(R){case L.LogLevel.Trace:E.trace(I);break;case L.LogLevel.Debug:E.debug(I);break;case L.LogLevel.Info:E.info(I);break;case L.LogLevel.Warning:E.warn(I);break;case L.LogLevel.Error:E.error(I);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(E,R){switch(R){case L.LogLevel.Trace:E.setLevel(M.Trace);break;case L.LogLevel.Debug:E.setLevel(M.Debug);break;case L.LogLevel.Info:E.setLevel(M.Info);break;case L.LogLevel.Warning:E.setLevel(M.Warning);break;case L.LogLevel.Error:E.setLevel(M.Error);break;case L.LogLevel.Off:E.setLevel(M.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class p extends L.$Sj{constructor(R,I,w,S,y){super(),this.m=[],this.setLevel(y),this.n=this.s(R,I,w,S),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(R,I,w,S){const y=w?6:1,h=30/y*u.$il.MB,g=await A(R,I,h,y,S);if(g){this.r=g,b(this.r,this.getLevel());for(const{level:c,message:n}of this.m)P(this.r,c,n);this.m=[]}}g(R,I){this.r?P(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$KP=p}),define(Se[138],De([1,0,39,212,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var P;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(p){function E(y,h){return h-y}p.compare=E;const R=Object.create(null);R[p.Error]=(0,L.localize)(0,null),R[p.Warning]=(0,L.localize)(1,null),R[p.Info]=(0,L.localize)(2,null);function I(y){return R[y]||""}p.toString=I;function w(y){switch(y){case u.default.Error:return p.Error;case u.default.Warning:return p.Warning;case u.default.Info:return p.Info;case u.default.Ignore:return p.Hint}}p.fromSeverity=w;function S(y){switch(y){case p.Error:return u.default.Error;case p.Warning:return u.default.Warning;case p.Info:return u.default.Info;case p.Hint:return u.default.Ignore}}p.toSeverity=S}(P||(e.MarkerSeverity=P={}));var b;(function(p){const E="";function R(w){return I(w,!0)}p.makeKey=R;function I(w,S){const y=[E];return w.source?y.push(w.source.replace("\xA6","\\\xA6")):y.push(E),w.code?typeof w.code=="string"?y.push(w.code.replace("\xA6","\\\xA6")):y.push(w.code.value.replace("\xA6","\\\xA6")):y.push(E),w.severity!==void 0&&w.severity!==null?y.push(P.toString(w.severity)):y.push(E),w.message&&S?y.push(w.message.replace("\xA6","\\\xA6")):y.push(E),w.startLineNumber!==void 0&&w.startLineNumber!==null?y.push(w.startLineNumber.toString()):y.push(E),w.startColumn!==void 0&&w.startColumn!==null?y.push(w.startColumn.toString()):y.push(E),w.endLineNumber!==void 0&&w.endLineNumber!==null?y.push(w.endLineNumber.toString()):y.push(E),w.endColumn!==void 0&&w.endColumn!==null?y.push(w.endColumn.toString()):y.push(E),y.push(E),y.join("\xA6")}p.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$Qt=(0,M.$gi)("markerService")}),define(Se[259],De([1,0,4,39,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Hv=e.Severity=void 0,e.$Iv=b,e.Severity=L.default,e.$Hv=(0,M.$gi)("notificationService");var A;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var P;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));function b(I){if(I){const w=I;return typeof w.id=="string"&&typeof w.label=="string"}return!1}var p;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new R,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.$Jv=E;class R{infinite(){}done(){}total(w){}worked(w){}}e.$Kv=R}),define(Se[260],De([1,0,50]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.context<"u"){const A=M.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(Se[139],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=void 0,e.$6j=(0,u.$gi)("productService"),e.$7j="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(fe,e){return function(u,L){e(u,L,fe)}};define(Se[108],De([1,0,8,22,3,5]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.ProgressLocation=e.$Lv=void 0,e.$Lv=(0,A.$gi)("progressService");var P;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$Mv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.$Nv=b;class p{get value(){return this.a}constructor(w){this.e=w}report(w){this.b?this.b.push(w):this.b=[w],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const w=this.b.shift();this.a=w,await this.e(this.a)}}finally{this.c=!1;const w=this.d;this.d=void 0,w?.()}}drain(){return this.c?new Promise(w=>{const S=this.d;this.d=()=>{S?.(),w()}}):Promise.resolve()}}e.$Ov=p;let E=class extends M.$Tc{constructor(w,S){super(),this.a=new u.$Dh,S.withProgress(w,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,M.$Rc)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.$Pv=E,e.$Pv=E=Je([qe(1,e.$Lv)],E);class R extends M.$Tc{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new M.$Sc)}start(w){this.stop();const S=++this.a,y=new L.$de;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,M.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Rc)(()=>y.cancel())),this.b.add((0,M.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:y.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.$Qv=R,e.$Rv=(0,A.$gi)("editorProgressService")}),define(Se[37],De([1,0,61,18]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0;class M{constructor(){this.a=new Map}add(P,b){u.ok(L.$Tf(P)),u.ok(L.$Vf(b)),u.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,b)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$Yn=new M}),define(Se[109],De([1,0,4,37]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0,e.$Zn={JSONContribution:"base.contributions.json"};function M(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new u.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,E){this.a[M(p)]=E,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const P=new A;L.$Yn.add(e.$Zn.JSONContribution,P)}),define(Se[85],De([1,0,19,4,18,201,52,109,37]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.ConfigurationScope=e.$4n=e.EditPresentationTypes=void 0,e.$co=h,e.$do=g,e.$eo=c,e.$fo=i,e.$go=r;var E;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$4n={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n="vscode://schemas/settings/resourceLanguage",e.$_n="vscode://schemas/settings/configurationDefaults";const I=p.$Yn.as(b.$Zn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new L.$6d,this.onDidSchemaChange=this.i.event,this.j=new L.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$$n,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const l=new Set;this.n(t,f,l),I.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:l})}deregisterConfigurations(t){const f=new Set;this.o(t,f),I.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const l=new Set;this.o(f,l),this.n(t,!1,l),I.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:l})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const l=[];for(const{overrides:s,source:o}of t)for(const d in s)if(f.add(d),e.$bo.test(d)){const m=this.a.get(d),D=m?.valuesSources??new Map;if(o)for(const C of Object.keys(s[d]))D.set(C,o);const $={...m?.value||{},...s[d]};this.a.set(d,{source:o,value:$,valuesSources:D});const v=(0,P.$Wi)(d),k={type:"object",default:$,description:A.localize(1,null,v),$ref:e.$$n,defaultDefaultValue:$,source:M.$Tf(o)?void 0:o,defaultValueSource:o};l.push(...h(d)),this.d[d]=k,this.b.properties[d]=k}else{this.a.set(d,{value:s[d],source:o});const m=this.d[d];m&&(this.w(d,m),this.r(d,m))}this.m(l)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:l,source:s}of t)for(const o in l){const d=this.a.get(o),m=M.$Tf(s)?s:s?.id,D=M.$Tf(d?.source)?d?.source:d?.source?.id;if(m===D)if(f.add(o),this.a.delete(o),e.$bo.test(o))delete this.d[o],delete this.b.properties[o];else{const $=this.d[o];$&&(this.w(o,$),this.r(o,$))}}this.u()}deltaConfiguration(t){let f=!1;const l=new Set;t.removedDefaults&&(this.l(t.removedDefaults,l),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,l),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,l),t.addedConfigurations&&this.n(t.addedConfigurations,!1,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,l){t.forEach(s=>{this.p(s,f,s.extensionInfo,s.restrictedProperties,void 0,l),this.c.push(s),this.q(s)})}o(t,f){const l=s=>{if(s.properties)for(const o in s.properties){f.add(o);const d=this.d[o];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>l(o))};for(const s of t){l(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(t,f=!0,l,s,o=3,d){o=M.$3f(t.scope)?o:t.scope;const m=t.properties;if(m)for(const $ in m){const v=m[$];if(f&&i($,v)){delete m[$];continue}if(v.source=l,v.defaultDefaultValue=m[$].default,this.w($,v),e.$bo.test($)?v.scope=void 0:(v.scope=M.$3f(v.scope)?o:v.scope,v.restricted=M.$3f(v.restricted)?!!s?.includes($):v.restricted),m[$].hasOwnProperty("included")&&!m[$].included){this.f[$]=m[$],delete m[$];continue}else this.d[$]=m[$],m[$].policy?.name&&this.e.set(m[$].policy.name,$);!m[$].deprecationMessage&&m[$].markdownDeprecationMessage&&(m[$].deprecationMessage=m[$].markdownDeprecationMessage),d.add($)}const D=t.allOf;if(D)for(const $ of D)this.p($,f,l,s,o,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=l=>{const s=l.properties;if(s)for(const d in s)this.r(d,s[d]);l.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$5n.properties[t]=f,f.scope){case 1:e.$6n.properties[t]=f;break;case 2:e.$7n.properties[t]=f;break;case 6:e.$8n.properties[t]=f;break;case 3:e.$9n.properties[t]=f;break;case 4:e.$0n.properties[t]=f;break;case 5:e.$0n.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$5n.properties[t],f.scope){case 1:delete e.$6n.properties[t];break;case 2:delete e.$7n.properties[t];break;case 6:delete e.$8n.properties[t];break;case 3:delete e.$9n.properties[t];break;case 4:case 5:delete e.$0n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,l={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$$n};this.w(f,l),e.$5n.properties[f]=l,e.$6n.properties[f]=l,e.$7n.properties[f]=l,e.$8n.properties[f]=l,e.$9n.properties[f]=l,e.$0n.properties[f]=l}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$$n};e.$5n.patternProperties[e.$ao]=t,e.$6n.patternProperties[e.$ao]=t,e.$7n.patternProperties[e.$ao]=t,e.$8n.patternProperties[e.$ao]=t,e.$9n.patternProperties[e.$ao]=t,e.$0n.patternProperties[e.$ao]=t,this.i.fire()}w(t,f){const l=this.a.get(t);let s=l?.value,o=l?.source;M.$1f(s)&&(s=f.defaultDefaultValue,o=void 0),M.$1f(s)&&(s=c(f.type)),f.default=s,f.defaultValueSource=o}}const S="\\[([^\\]]+)\\]",y=new RegExp(S,"g");e.$ao=`^(${S})+$`,e.$bo=new RegExp(e.$ao);function h(a){const t=[];if(e.$bo.test(a)){let f=y.exec(a);for(;f?.length;){const l=f[1].trim();l&&t.push(l),f=y.exec(a)}}return(0,u.$Mb)(t)}function g(a){return a.reduce((t,f)=>`${t}[${f}]`,"")}function c(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new w;p.$Yn.add(e.$4n.Configuration,n);function i(a,t){return a.trim()?e.$bo.test(a)?A.localize(7,null,a):n.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function r(){const a=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))a.push([f,t[f].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(Se[261],De([1,0,19,4,163,3,28,24,18,2,52,85,37]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$ko=e.$jo=e.$io=e.$ho=void 0,e.$lo=i;function S(f){return Object.isFrozen(f)?f:b.$Nn(f)}class y{constructor(l={},s=[],o=[],d){this.b=l,this.c=s,this.d=o,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const l=this.raw.map(s=>{if(s instanceof y)return s;const o=new h("");return o.parseRaw(s),o.configurationModel});this.f=l.reduce((s,o)=>o===s?o:s.merge(o),l[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,R.$Ui)(this.contents,l):this.contents}inspect(l,s){const o=this;return{get value(){return S(o.rawConfiguration.getValue(l))},get override(){return s?S(o.rawConfiguration.getOverrideValue(l,s)):void 0},get merged(){return S(s?o.rawConfiguration.override(s).getValue(l):o.rawConfiguration.getValue(l))},get overrides(){const d=[];for(const{contents:m,identifiers:D,keys:$}of o.rawConfiguration.overrides){const v=new y(m,$).getValue(l);v!==void 0&&d.push({identifiers:D,value:v})}return d.length?S(d):void 0}}}getOverrideValue(l,s){const o=this.i(s);return o?l?(0,R.$Ui)(o,l):o:void 0}getKeysForOverrideIdentifier(l){const s=[];for(const o of this.overrides)o.identifiers.includes(l)&&s.push(...o.keys);return u.$Mb(s)}getAllOverrideIdentifiers(){const l=[];for(const s of this.overrides)l.push(...s.identifiers);return u.$Mb(l)}override(l){let s=this.a.get(l);return s||(s=this.g(l),this.a.set(l,s)),s}merge(...l){const s=b.$Mn(this.contents),o=b.$Mn(this.overrides),d=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const D of l)if(m.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(s,D.contents);for(const $ of D.overrides){const[v]=o.filter(k=>u.$ub(k.identifiers,$.identifiers));v?(this.h(v.contents,$.contents),v.keys.push(...$.keys),v.keys=u.$Mb(v.keys)):o.push(b.$Mn($))}for(const $ of D.keys)d.indexOf($)===-1&&d.push($)}return new y(s,d,o,m.every(D=>D instanceof y)?void 0:m)}g(l){const s=this.i(l);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const d of u.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let m=this.contents[d];const D=s[d];D&&(typeof m=="object"&&typeof D=="object"?(m=b.$Mn(m),this.h(m,D)):m=D),o[d]=m}return new y(o,this.keys,this.overrides)}h(l,s){for(const o of Object.keys(s)){if(o in l&&p.$Vf(l[o])&&p.$Vf(s[o])){this.h(l[o],s[o]);continue}l[o]=b.$Mn(s[o])}}i(l){let s=null,o=null;const d=m=>{m&&(o?this.h(o,m):o=b.$Mn(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===l?s=m.contents:m.identifiers.includes(l)&&d(m.contents);return d(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,s){this.j(l,s,!0)}setValue(l,s){this.j(l,s,!1)}removeValue(l){const s=this.keys.indexOf(l);s!==-1&&(this.keys.splice(s,1),(0,R.$Ti)(this.contents,l),I.$bo.test(l)&&this.overrides.splice(this.overrides.findIndex(o=>u.$ub(o.identifiers,(0,I.$co)(l))),1))}j(l,s,o){(0,R.$Si)(this.contents,l,s,d=>console.error(d)),o=o||this.keys.indexOf(l)===-1,o&&this.keys.push(l),I.$bo.test(l)&&this.overrides.push({identifiers:(0,I.$co)(l),keys:Object.keys(this.contents[l]),contents:(0,R.$Ri)(this.contents[l],d=>console.error(d))})}}e.$ho=y;class h{constructor(l){this.f=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,s){if(!p.$3f(l)){const o=this.g(l);this.parseRaw(o,s)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,s){this.a=l;const{contents:o,keys:d,overrides:m,restricted:D,hasExcludedProperties:$}=this.h(l,s);this.b=new y(o,d,m,$?[l]:void 0),this.c=D||[]}g(l){let s={},o=null,d=[];const m=[],D=[];function $(k){Array.isArray(d)?d.push(k):o!==null&&(d[o]=k)}const v={onObjectBegin:()=>{const k={};$(k),m.push(d),d=k,o=null},onObjectProperty:k=>{o=k},onObjectEnd:()=>{d=m.pop()},onArrayBegin:()=>{const k=[];$(k),m.push(d),d=k,o=null},onArrayEnd:()=>{d=m.pop()},onLiteralValue:$,onError:(k,C,O)=>{D.push({error:k,offset:C,length:O})}};if(l)try{M.$An(l,v),s=d[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}h(l,s){const o=w.$Yn.as(I.$4n.Configuration).getConfigurationProperties(),d=this.i(l,o,!0,s);l=d.raw;const m=(0,R.$Ri)(l,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),D=Object.keys(l),$=this.j(l,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:m,keys:D,overrides:$,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(l,s,o,d){let m=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:m};const D={},$=[];for(const v in l)if(I.$bo.test(v)&&o){const k=this.i(l[v],s,!1,d);D[v]=k.raw,m=m||k.hasExcludedProperties,$.push(...k.restricted)}else{const k=s[v],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&$.push(v),!d.exclude?.includes(v)&&(d.include?.includes(v)||(C===void 0||d.scopes===void 0||d.scopes.includes(C))&&!(d.skipRestricted&&k?.restricted))?D[v]=l[v]:m=!0}return{raw:D,restricted:$,hasExcludedProperties:m}}j(l,s){const o=[];for(const d of Object.keys(l))if(I.$bo.test(d)){const m={};for(const D in l[d])m[D]=l[d][D];o.push({identifiers:(0,I.$co)(d),keys:Object.keys(m),contents:(0,R.$Ri)(m,s)})}return o}}e.$io=h;class g extends A.$Tc{constructor(l,s,o,d){super(),this.c=l,this.f=s,this.g=d,this.b=this.B(new L.$6d),this.onDidChange=this.b.event,this.a=new h(this.c.toString()),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&o.isEqual(m.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$jo=g;class c{constructor(l,s,o,d,m,D,$,v,k,C,O,B,z){this.a=l,this.b=s,this.c=o,this.overrideIdentifiers=d,this.d=m,this.f=D,this.g=$,this.h=v,this.i=k,this.j=C,this.k=O,this.l=B,this.m=z}get value(){return S(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(l,s,o,d,m=new y,D=new y,$=new P.$Ac,v=new y,k=new P.$Ac){this.c=l,this.d=s,this.f=o,this.g=d,this.h=m,this.i=D,this.j=$,this.l=v,this.m=k,this.a=null,this.b=new P.$Ac,this.n=null}getValue(l,s,o){return this.p(l,s,o).getValue(l)}updateValue(l,s,o={}){let d;o.resource?(d=this.m.get(o.resource),d||(d=new y,this.m.set(o.resource,d))):d=this.l,s===void 0?d.removeValue(l):d.setValue(l,s),o.resource||(this.a=null)}inspect(l,s,o){const d=this.p(l,s,o),m=this.t(s.resource,o),D=s.resource?this.m.get(s.resource)||this.l:this.l,$=new Set;for(const v of d.overrides)for(const k of v.identifiers)d.getOverrideValue(l,k)!==void 0&&$.add(k);return new c(l,s,d.getValue(l),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,m||void 0,D)}keys(l){const s=this.t(void 0,l);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(l){this.c=l,this.a=null,this.b.clear()}updatePolicyConfiguration(l){this.d=l}updateApplicationConfiguration(l){this.f=l,this.a=null,this.b.clear()}updateLocalUserConfiguration(l){this.g=l,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(l){this.h=l,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(l){this.i=l,this.a=null,this.b.clear()}updateFolderConfiguration(l,s){this.j.set(l,s),this.b.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.b.delete(l)}compareAndUpdateDefaultConfiguration(l,s){const o=[];if(!s){const{added:d,updated:m,removed:D}=a(this.c,l);s=[...d,...m,...D]}for(const d of s)for(const m of(0,I.$co)(d)){const D=this.c.getKeysForOverrideIdentifier(m),$=l.getKeysForOverrideIdentifier(m),v=[...$.filter(k=>D.indexOf(k)===-1),...D.filter(k=>$.indexOf(k)===-1),...D.filter(k=>!b.$Qn(this.c.override(m).getValue(k),l.override(m).getValue(k)))];o.push([m,v])}return this.updateDefaultConfiguration(l),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(l){const{added:s,updated:o,removed:d}=a(this.d,l),m=[...s,...o,...d];return m.length&&this.updatePolicyConfiguration(l),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:s,updated:o,removed:d,overrides:m}=a(this.applicationConfiguration,l),D=[...s,...o,...d];return D.length&&this.updateApplicationConfiguration(l),{keys:D,overrides:m}}compareAndUpdateLocalUserConfiguration(l){const{added:s,updated:o,removed:d,overrides:m}=a(this.localUserConfiguration,l),D=[...s,...o,...d];return D.length&&this.updateLocalUserConfiguration(l),{keys:D,overrides:m}}compareAndUpdateRemoteUserConfiguration(l){const{added:s,updated:o,removed:d,overrides:m}=a(this.remoteUserConfiguration,l),D=[...s,...o,...d];return D.length&&this.updateRemoteUserConfiguration(l),{keys:D,overrides:m}}compareAndUpdateWorkspaceConfiguration(l){const{added:s,updated:o,removed:d,overrides:m}=a(this.workspaceConfiguration,l),D=[...s,...o,...d];return D.length&&this.updateWorkspaceConfiguration(l),{keys:D,overrides:m}}compareAndUpdateFolderConfiguration(l,s){const o=this.folderConfigurations.get(l),{added:d,updated:m,removed:D,overrides:$}=a(o,s),v=[...d,...m,...D];return(v.length||!o)&&this.updateFolderConfiguration(l,s),{keys:v,overrides:$}}compareAndDeleteFolderConfiguration(l){const s=this.folderConfigurations.get(l);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:o,updated:d,removed:m,overrides:D}=a(s,void 0);return{keys:[...o,...d,...m],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(l,s,o){let d=this.q(s,o);return s.overrideIdentifier&&(d=d.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(l)!==void 0&&(d=d.merge(this.d)),d}q({resource:l},s){let o=this.r();if(s&&l){const d=s.getFolder(l);d&&(o=this.s(d.uri)||o);const m=this.m.get(l);m&&(o=o.merge(m))}return o}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(l){let s=this.b.get(l);if(!s){const o=this.r(),d=this.j.get(l);d?(s=o.merge(d),this.b.set(l,s)):s=o}return s}t(l,s){if(s&&l){const o=s.getFolder(l);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((l,s)=>{const{contents:o,overrides:d,keys:m}=this.j.get(s);return l.push([s,{contents:o,overrides:d,keys:m}]),l},[])}}allKeys(){const l=new Set;return this.c.keys.forEach(s=>l.add(s)),this.userConfiguration.keys.forEach(s=>l.add(s)),this.i.keys.forEach(s=>l.add(s)),this.j.forEach(s=>s.keys.forEach(o=>l.add(o))),[...l.values()]}u(){const l=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>l.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>l.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>l.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>l.add(o))),[...l.values()]}v(l){const s=new Set;return this.c.getKeysForOverrideIdentifier(l).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(o=>s.add(o)),this.i.getKeysForOverrideIdentifier(l).forEach(o=>s.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(l).forEach(d=>s.add(d))),[...s.values()]}static parse(l){const s=this.w(l.defaults),o=this.w(l.policy),d=this.w(l.application),m=this.w(l.user),D=this.w(l.workspace),$=l.folders.reduce((v,k)=>(v.set(E.URI.revive(k[0]),this.w(k[1])),v),new P.$Ac);return new n(s,o,d,m,new y,D,$,new y,new P.$Ac)}static w(l){return new y(l.contents,l.keys,l.overrides)}}e.$ko=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const l=new Set,s=new Map;for(const d of f)d.keys.forEach(m=>l.add(m)),d.overrides.forEach(([m,D])=>{const $=(0,P.$xc)(s,m,new Set);D.forEach(v=>$.add(v))});const o=[];return s.forEach((d,m)=>o.push([m,[...d.values()]])),{keys:[...l.values()],overrides:o}}class r{constructor(l,s,o,d){this.change=l,this.f=s,this.g=o,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const m of l.keys)this.affectedKeys.add(m);for(const[,m]of l.overrides)for(const D of m)this.affectedKeys.add(D);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(l,s){const o=this.a+l,d=this.d.indexOf(o);if(d<0)return!1;const m=d+o.length;if(m>=this.d.length)return!1;const D=this.d.charCodeAt(m);if(D!==this.b&&D!==this.c)return!1;if(s){const $=this.previousConfiguration?this.previousConfiguration.getValue(l,s,this.f?.workspace):void 0,v=this.g.getValue(l,s,this.h);return!b.$Qn($,v)}return!0}}e.$mo=r;function a(f,l){const{added:s,removed:o,updated:d}=t(l?.rawConfiguration,f?.rawConfiguration),m=[],D=f?.getAllOverrideIdentifiers()||[],$=l?.getAllOverrideIdentifiers()||[];if(l){const v=$.filter(k=>!D.includes(k));for(const k of v)m.push([k,l.getKeysForOverrideIdentifier(k)])}if(f){const v=D.filter(k=>!$.includes(k));for(const k of v)m.push([k,f.getKeysForOverrideIdentifier(k)])}if(l&&f){for(const v of D)if($.includes(v)){const k=t({contents:f.getOverrideValue(void 0,v)||{},keys:f.getKeysForOverrideIdentifier(v)},{contents:l.getOverrideValue(void 0,v)||{},keys:l.getKeysForOverrideIdentifier(v)});m.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:o,updated:d,overrides:m}}function t(f,l){const s=f?l?f.keys.filter(m=>l.keys.indexOf(m)===-1):[...f.keys]:[],o=l?f?l.keys.filter(m=>f.keys.indexOf(m)===-1):[...l.keys]:[],d=[];if(f&&l){for(const m of l.keys)if(f.keys.indexOf(m)!==-1){const D=(0,R.$Ui)(l.contents,m),$=(0,R.$Ui)(f.contents,m);b.$Qn(D,$)||d.push(m)}}return{added:s,removed:o,updated:d}}}),define(Se[262],De([1,0,21,4,3,81]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mtb=e.$Ktb=e.$Jtb=void 0,e.$Ltb=b;const P=(E,R,I)=>{const w=new Uint8Array(16);for(let h=0;h<16;h++)w[h]=Math.round(Math.random()*256);const S=(0,u.$Ne)(u.$te.wrap(w));return[`GET ws://localhost${E}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Jtb=P,e.$Ktb=u.$te.fromString(`\r
\r
`);async function b(E,R,I,w,S){E.write(u.$te.fromString((0,e.$Jtb)(R,I,w)));const y=new M.$Sc;try{return await new Promise((h,g)=>{let c;y.add(E.onData(n=>{c?c=u.$te.concat([c,n],c.byteLength+n.byteLength):c=n;const i=c.indexOf(e.$Ktb);if(i===-1)return;h(E),E.pauseData();const r=c.slice(i+e.$Ktb.byteLength);r.byteLength&&S.onData.fire(r)})),y.add(E.onClose(n=>g(n??new Error("socket closed")))),y.add(E.onEnd(()=>g(new Error("socket ended"))))})}catch(h){throw E.dispose(),h}finally{y.dispose()}}class p extends M.$Tc{constructor(R,I){super(),this.g=R,this.a=this.B(new L.$9d),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new L.$6d),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(w=>this.a.fire(w))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){A.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Mtb=p}),define(Se[64],De([1,0,13,5]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.RemoteAuthorityResolverErrorCode=e.$tl=e.$sl=e.RemoteConnectionType=e.$rl=void 0,e.$vl=E,e.$rl=(0,L.$gi)("remoteAuthorityResolverService");var M;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class A{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$sl=A;class P{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$tl=P;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class p extends u.$bb{static isNotAvailable(I){return I instanceof p&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof p&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof p&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof p&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof p&&I.isHandled}constructor(I,w=b.Unknown,S){super(I),this._message=I,this._code=w,this._detail=S,this.isHandled=w===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,p.prototype)}}e.$ul=p;function E(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}}),define(Se[263],De([1,0,8,21,22,13,4,3,15,58,38,30,81,64]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Al=D,e.$Bl=$,e.$Cl=k;const y=30*1e3;var h;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function g(re){switch(re){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(re){const U=new M.$de;return setTimeout(()=>U.cancel(),re),U.token}function n(re,U){if(re.isCancellationRequested||U.isCancellationRequested)return M.CancellationToken.Cancelled;const ie=new M.$de;return re.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$_g)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(re,U){const ie=new i(U);return ie.registerDisposable(re.onControlMessage(ye=>{const le=JSON.parse(ye.toString()),ue=Q(le);ue?ie.reject(ue):ie.resolve(le)})),ie.promise}function a(re,U,ie,ye,le,ue,ce,de){const H=new i(de),x=R.$2d.create(!1);return re.info(`Creating a socket (${ce})...`),E.mark(`code/willCreateSocket/${ue}`),U.connect(ie,ye,le,ce).then(he=>{H.didTimeout?(E.mark(`code/didCreateSocketError/${ue}`),re.info(`Creating a socket (${ce}) finished after ${x.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(E.mark(`code/didCreateSocketOK/${ue}`),re.info(`Creating a socket (${ce}) was successful after ${x.elapsed()} ms.`),H.resolve(he))},he=>{E.mark(`code/didCreateSocketError/${ue}`),re.info(`Creating a socket (${ce}) returned an error after ${x.elapsed()} ms.`),re.error(he),H.reject(he)}),H.promise}function t(re,U){const ie=new i(U);return re.then(ye=>{ie.didTimeout||ie.resolve(ye)},ye=>{ie.didTimeout||ie.reject(ye)}),ie.promise}async function f(re,U,ie,ye){const le=ge(re,U);re.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let ue;try{ue=await a(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$tg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,g(U),`renderer-${g(U)}-${re.reconnectionToken}`,ye)}catch(he){throw re.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ce,de;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(ue,null),ce=re.reconnectionProtocol,de=!1):(ce=new w.$7h({socket:ue}),de=!0),re.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const H=await t(re.signService.createNewMessage((0,I.$Cg)()),ye),x={type:"auth",auth:re.connectionToken||"00000000000000000000",data:H.data};ce.sendControl(L.$te.fromString(JSON.stringify(x)));try{const he=await r(ce,n(ye,c(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(re.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(re.signService.validate(H,he.signedData),ye)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Ae=await t(re.signService.sign(he.data),ye),we={type:"connectionType",commit:re.commit,signedData:Ae,desiredConnectionType:U};return ie&&(we.args=ie),re.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(L.$te.fromString(JSON.stringify(we))),{protocol:ce,ownsProtocol:de}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${le} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${le} received error control message when negotiating connection. Error:`),re.logService.error(he)),de&&Y(ce),he}}async function l(re,U,ie,ye){const le=Date.now(),ue=ge(re,U),{protocol:ce,ownsProtocol:de}=await f(re,U,ie,ye),H=new i(ye);return H.registerDisposable(ce.onControlMessage(x=>{const he=JSON.parse(x.toString()),pe=Q(he);pe?(re.logService.error(`${ue} received error control message when negotiating connection. Error:`),re.logService.error(pe),de&&Y(ce),H.reject(pe)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${se(le)}!`),H.resolve({protocol:ce,firstMessage:he}))})),H.promise}async function s(re,U){const{protocol:ie}=await l(re,1,void 0,U);return{protocol:ie}}async function o(re,U,ie){const{protocol:ye,firstMessage:le}=await l(re,2,U,ie),ue=le&&le.debugPort;return{protocol:ye,debugPort:ue}}async function d(re,U,ie){const ye=Date.now(),le=ge(re,3),{protocol:ue}=await f(re,3,U,ie);return re.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${se(ye)}!`),ue}async function m(re,U,ie){const{connectTo:ye,connectionToken:le}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:ye,connectionToken:le,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function D(re,U,ie){return v(re,async ye=>{const{protocol:le}=await s(ye,M.CancellationToken.None);return new K(re,U,ie,ye.reconnectionToken,le)})}async function $(re,U){return v(re,async ie=>{const{protocol:ye,debugPort:le}=await o(ie,U,M.CancellationToken.None);return new ee(re,U,ie.reconnectionToken,ye,le)})}async function v(re,U){for(let ye=1;;ye++)try{const le=(0,I.$Cg)(),ue=await m(re,le,null);return await U(ue)}catch(le){if(ye<5)re.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(le);else throw re.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(le),F.triggerPermanentFailure(0,0,S.$ul.isHandled(le)),le}}async function k(re,U,ie){const ye=await m(re,(0,I.$Cg)(),null);return await d(ye,{host:U,port:ie},M.CancellationToken.None)}function C(re){return(0,u.$6g)(U=>new Promise((ie,ye)=>{const le=setTimeout(ie,re*1e3);U.onCancellationRequested(()=>{clearTimeout(le),ie()})}))}var O;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class B{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$Dl=B;class z{constructor(U,ie,ye,le){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=ye,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$El=z;class T{constructor(U,ie,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=2}}e.$Fl=T;class j{constructor(U,ie,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=4}}e.$Gl=j;class N{constructor(U,ie,ye,le){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.handled=le,this.type=3}}e.$Hl=N;class F extends b.$Tc{static triggerPermanentFailure(U,ie,ye){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=ye,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||F._permanentFailure}constructor(U,ie,ye,le,ue){super(),this.t=U,this.u=ie,this.reconnectionToken=ye,this.protocol=le,this.w=ue,this.m=this.B(new P.$6d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(le.onSocketClose(ce=>{const de=_(this.t,this.reconnectionToken,!0);ce?ce.type===0?(this.u.logService.info(`${de} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${de} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${de} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(ce=>{const de=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${de} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),F.j.push(this),this.B((0,b.$Rc)(()=>{const ce=F.j.indexOf(this);ce>=0&&F.j.splice(ce,1)})),this.n&&this.D(F.f,F.g,F.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const le=ye<ie.length?ie[ye]:ie[ie.length-1];try{if(le>0){const ce=C(le);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ce)),this.u.logService.info(`${U} waiting for ${le} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${U} resolving connection...`);const ue=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ue.connectTo}...`),await this.G(ue,c(y)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ue){if(ue.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(S.$ul.isTemporarilyNotAvailable(ue)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if((ue.code==="ETIMEDOUT"||ue.code==="ENETUNREACH"||ue.code==="ECONNREFUSED"||ue.code==="ECONNRESET")&&ue.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if((0,A.$4)(ue)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if(ue instanceof S.$ul){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,S.$ul.isHandled(ue));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,ye){this.w?F.triggerPermanentFailure(U,ie,ye):this.D(U,ie,ye)}D(U,ie,ye){this.m.fire(new N(this.reconnectionToken,U,ie,ye)),Y(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Il=F;class K extends F{constructor(U,ie,ye,le,ue){super(1,U,le,ue,!0),this.client=this.B(new w.$5h(ue,{remoteAuthority:ie,clientId:ye},U.ipcLogger))}async G(U,ie){await s(U,ie)}}e.$Jl=K;class ee extends F{constructor(U,ie,ye,le,ue){super(2,U,ye,le,!1),this.H=ie,this.debugPort=ue}async G(U,ie){await o(U,this.H,ie)}}e.$Kl=ee;function Y(re){try{re.acceptDisconnect();const U=re.getSocket();re.dispose(),U.dispose()}catch(U){(0,A.$1)(U)}}function Q(re){if(re&&re.type==="error"){const U=new Error(`Connection error: ${re.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Z(re,U){for(;re.length<U;)re+=" ";return re}function ae(re,U){return`[remote-connection][${Z(g(re),13)}][${U.substr(0,5)}\u2026]`}function _(re,U,ie){return`${ae(re,U)}[${ie?"reconnect":"initial"}]`}function ge(re,U){return`${_(U,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function se(re){return`${Date.now()-re} ms`}}),define(Se[86],De([1,0,15]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=L,e.$sm=M,e.$tm=A,e.$um=P;function L(p){return p.scheme===u.Schemas.vscodeRemote?p.authority:void 0}function M(p){if(!p)return;const E=p.indexOf("+");return E<0?p:p.substr(0,E)}function A(p){const{host:E,port:R}=b(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:R}}function P(p,E){let{host:R,port:I}=b(p);return typeof I>"u"&&(I=E),{host:R,port:I}}function b(p){const E=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const I=p.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:p,port:void 0}}}),define(Se[25],De([1,0,14,5,86]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Dm=e.$Cm=e.$Bm=e.TargetPlatform=e.ExtensionType=e.$Am=e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$zm=A,e.$Em=I,e.$Fm=w,e.$Gm=S,e.$Hm=y,e.$vm="extensions.user.cache",e.$wm="extensions.builtin.cache",e.$xm="undefined_publisher",e.$ym=["ui","workspace","web"];function A(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P||(e.ExtensionType=P={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class p{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const n=typeof g=="string"?g:g.value,i=typeof c=="string"?c:c.value;return u.$kf(n,i)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Bm=p;class E{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(p.toKey(g))}delete(g){return this.c.delete(p.toKey(g))}has(g){return this.c.has(p.toKey(g))}}e.$Cm=E;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(p.toKey(g))}get(g){return this.c.get(p.toKey(g))}has(g){return this.c.has(p.toKey(g))}set(g,c){this.c.set(p.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Dm=R;function I(h){return w(h)}function w(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function S(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function y(h,g){if(g){const c=`onResolveRemoteAuthority:${(0,M.$sm)(g)}`;return!!h.activationEvents?.includes(c)}return!1}e.$Im=(0,L.$gi)("IBuiltinExtensionsScannerService")}),define(Se[140],De([1,0,13,25]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=e.$HF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(P,b){this.a.set(P,b)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const b=Object.create(null);for(const p of P){const E=this.readActivationEvents(p);E.length>0&&(b[L.$Bm.toKey(p.identifier)]=E)}return b}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const b=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];for(let p=0;p<b.length;p++)b[p]==="onUri"&&(b[p]=`onUri:${L.$Bm.toKey(P.identifier)}`);if(!P.contributes)return b;for(const p in P.contributes){const E=this.a.get(p);if(!E)continue;const R=P.contributes[p],I=Array.isArray(R)?R:[R];try{E(I,b)}catch(w){(0,u.$1)(w)}}return b}}e.$HF=M,e.$IF=new M}),define(Se[264],De([1,0,3,5]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=void 0,e.$wl=(0,L.$gi)("remoteSocketFactoryService");class M{constructor(){this.a={}}register(P,b){return this.a[P]??=[],this.a[P].push(b),(0,u.$Rc)(()=>{const p=this.a[P]?.indexOf(b);typeof p=="number"&&p>=0&&this.a[P]?.splice(p,1)})}b(P){return(this.a[P.type]||[]).find(p=>p.supports(P))}connect(P,b,p,E){const R=this.b(P);if(!R)throw new Error(`No socket factory found for ${P}`);return R.connect(P,b,p,E)}}e.$xl=M}),define(Se[265],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n9b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(M){try{const A=await this.c();if(A){const P=String(u.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,A){if(!M.id)return!0;const P=this.b.get(M.id);if(!P)return!1;this.b.delete(M.id);try{return P.validate(A)==="ok"}catch{return!1}finally{P.dispose?.()}}async sign(M){try{return await this.d(M)}catch{}return M}}e.$n9b=u}),define(Se[110],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl="signService",e.$zl=(0,u.$gi)(e.$yl)}),define(Se[141],De([1,0,265]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;class L extends u.$n9b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(P=>new P.signer().sign(A))}h(){return new Promise((A,P)=>fe(["vsda"],A,P))}}e.$hbc=L}),define(Se[266],De([1,0,11,50,30]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=P,e.$1o=b;function A(p){if(u.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function P(p,E,R,I,w,S,y,h,g){const c=Object.create(null);c["common.machineId"]=S,c["common.sqmId"]=y,c.sessionID=(0,M.$Cg)()+Date.now(),c.commitHash=I,c.version=w,c["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,u.$h)(u.$u),c["common.nodePlatform"]=L.$dc,c["common.nodeArch"]=R,c["common.product"]=g||"desktop",h&&(c["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(c["common.snap"]="true");const r=A(E);return r&&(c["common.platformDetail"]=r),c}function b(p){const E=L.env.USERDNSDOMAIN;if(!E)return!1;const R=E.toLowerCase();return p.some(I=>R===I)}}),define(Se[267],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0,e.$Ll=(0,u.$gi)("telemetryService"),e.$Ml=(0,u.$gi)("customEndpointTelemetryService"),e.$Nl="telemetry.currentSessionDate",e.$Ol="telemetry.firstSessionDate",e.$Pl="telemetry.lastSessionDate",e.$Ql="telemetry.machineId",e.$Rl="telemetry.sqmId",e.$Sl="telemetry",e.$Tl="telemetry.telemetryLevel",e.$Ul="telemetry.enableCrashReporter",e.$Vl="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var M;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Se[87],De([1,0,24,18,86,266,267]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=R,e.$0o=I,e.$$o=w,e.$_o=S,e.$ap=h,e.$bp=c,e.$cp=n,e.$dp=a;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$2o=b;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3o=p,e.$4o=new p;class E{async publicLog(f,l,s){}async publicLogError(f,l,s){}}e.$5o=E,e.$6o="telemetry",e.$7o="extensionTelemetryLog",e.$8o={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function I(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const f=t.getValue(P.$Tl),l=t.getValue(P.$Ul);if(t.getValue(P.$Vl)===!1||l===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(t){const f={},l={},s={};g(t,s);for(let o in s){o=o.length>150?o.substr(o.length-149):o;const d=s[o];typeof d=="number"?l[o]=d:typeof d=="boolean"?l[o]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${d.length}`),f[o]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(f[o]=d)}return{properties:f,measurements:l}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const f=(0,M.$sm)(t);return y.has(f)?f:"other"}function g(t,f,l=0,s){if(t)for(const o of Object.getOwnPropertyNames(t)){const d=t[o],m=s?s+o:o;Array.isArray(d)?f[m]=(0,u.$Rn)(d):d instanceof Date?f[m]=d.toISOString():(0,L.$Vf)(d)?l<2?g(d,f,l+1,m+"."):f[m]=(0,u.$Rn)(d):f[m]=d}}function c(t,f){const l=t.msftInternalDomains||[],s=f.getValue("telemetry.internalTesting");return(0,A.$1o)(l)||s}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let l=t;const s=[];for(const D of f)for(;;){const $=D.exec(t);if(!$)break;s.push([$.index,D.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(l="";;){const D=d.exec(t);if(!D)break;const $=s.some(([v,k])=>D.index<k&&v<d.lastIndex);!o.test(D[0])&&!$&&(l+=t.substring(m,D.index)+"<REDACTED: user-file-path>",m=d.lastIndex)}return m<t.length&&(l+=t.substr(m)),l}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of f)if(l.regex.test(t))return`<REDACTED: ${l.label}>`;return t}function a(t,f){return(0,u.$On)(t,l=>{if(l instanceof b||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let s=l.replaceAll("%20"," ");s=i(s,f);for(const o of f)s=s.replace(o,"");return s=r(s),s}})}}),define(Se[268],De([1,0,14,137,25,11,2,13,50,87]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$fp=void 0,e.$ep=R,e.$gp=y,e.$hp=h,e.$ip=g,e.$jp=c,e.$kp=n,e.$lp=i,e.$mp=r,e.$op=a,e.$pp=f;function R(l,s){return l.uuid&&s.uuid?l.uuid===s.uuid:l.id===s.id?!0:(0,u.$ff)(l.id,s.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const o=s.manifest?s.manifest.version:s.version,d=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,o,d)}static parse(s){const o=I.exec(s);return o&&o[1]&&o[2]?new w({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,d="undefined"){this.version=o,this.targetPlatform=d,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?R(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$fp=w;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(l){const s=S.exec(l);return s&&s[1]?[g(s[1]),s[2]]:[g(l),void 0]}function h(l,s){return`${l}.${s}`}function g(l){return l.toLowerCase()}function c(l,s){return g(h(l??M.$xm,s))}function n(l,s){const o=[],d=m=>{for(const D of o)if(D.some($=>R(s($),s(m))))return D;return null};for(const m of l){const D=d(m);D?D.push(m):o.push([m])}return o}function i(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}function r(l){return{id:new E.$2o(l.identifier.id),name:new E.$2o(l.name),galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),isSigned:l.isSigned,...l.telemetryData}}e.$np=new M.$Bm("pprice.better-merge");function a(l,s){const o=[],d=s.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const m=d.shift();if(m&&o.every(D=>!R(D.identifier,{id:m}))){const D=l.filter($=>R($.identifier,{id:m}));D.length===1&&(o.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(l,s){if(!A.$k)return!1;let o;try{o=(await l.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await l.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){s.debug("Error while getting the os-release file.",(0,b.$0)(m))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(l,s){const o=await t(l,s),d=(0,L.$Lo)(o?"alpine":A.$u,p.$ec);return s.debug("ComputeTargetPlatform:",d),d}}),define(Se[269],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=u,e.$4r=L,e.$5r=M,e.$6r=A,e.$7r=P,e.$8r=b;function u(p){return[...p.entries()]}function L(p){return p?[...p.entries()]:[]}function M(p){return new Map(p)}function A(p){return new Map(p??[])}function P(p){return Array.from(p.entries()).map(E=>[E[0],u(E[1].map),L(E[1].descriptionMap)])}function b(p){return new Map(p.map(E=>[E[0],{map:M(E[1]),descriptionMap:A(E[2])}]))}}),define(Se[270],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4tb=void 0;class u{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,A,P=5){const b=A(p=>{const E=typeof p=="string"?p:p.data;let R=this.a.get(M);if(R){R.data.push(E);return}const I=setTimeout(()=>this.flushBuffer(M),P);R={data:[E],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(M),b.dispose()}},this.a.set(M,R)});return b}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const A=this.a.get(M);A&&(this.a.delete(M),this.b(M,A.data.join("")))}}e.$4tb=u}),define(Se[271],De([1,0,8,77,99,55,4,18,2,213,109,37]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=e.$Ww=e.$Vw=e.$Uw=e.$Tw=e.$Sw=e.IconFontDefinition=e.IconContribution=e.$Pw=void 0,e.$Qw=g,e.$Rw=c,e.$Pw={IconContribution:"base.contributions.icons"};var w;(function(a){function t(f,l){let s=f.defaults;for(;A.ThemeIcon.isThemeIcon(s);){const o=h.getIcon(s.id);if(!o)return;s=o.defaults}return s}a.getDefinition=t})(w||(e.IconContribution=w={}));var S;(function(a){function t(l){return{weight:l.weight,style:l.style,src:l.src.map(s=>({format:s.format,location:s.location.toString()}))}}a.toJSONObject=t;function f(l){const s=o=>(0,b.$Tf)(o)?o:void 0;if(l&&Array.isArray(l.src)&&l.src.every(o=>(0,b.$Tf)(o.format)&&(0,b.$Tf)(o.location)))return{weight:s(l.weight),style:s(l.style),src:l.src.map(o=>({format:o.format,location:p.URI.parse(o.location)}))}}a.fromJSONObject=f})(S||(e.IconFontDefinition=S={}));class y{constructor(){this.a=new P.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,l,s){const o=this.b[t];if(o){if(l&&!o.description){o.description=l,this.d.properties[t].markdownDescription=`${l} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=l),this.a.fire()}return o}const d={id:t,description:l,defaults:f,deprecationMessage:s};this.b[t]=d;const m={$ref:"#/definitions/icons"};return s&&(m.deprecationMessage=s),l&&(m.markdownDescription=`${l}: $(${t})`),this.d.properties[t]=m,this.e.enum.push(t),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const l=this.f[t];return l||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(o,d)=>o.id.localeCompare(d.id),f=o=>{for(;A.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(d=>!!d.description).sort(t))l.push(`|<i class="${f(o)}"></i>|${o.id}|${A.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const o of s.filter(d=>!A.ThemeIcon.isThemeIcon(d.defaults)).sort(t))l.push(`|<i class="${f(o)}"></i>|${o.id}|`);return l.join(`
`)}}const h=new y;I.$Yn.add(e.$Pw.IconContribution,h);function g(a,t,f,l){return h.registerIcon(a,t,f,l)}function c(){return h}function n(){const a=(0,M.$Bj)();for(const t in a){const f="\\"+a[t].toString(16);h.registerIcon(t,{fontCharacter:f})}}n(),e.$Sw="vscode://schemas/icons";const i=I.$Yn.as(R.$Zn.JSONContribution);i.registerSchema(e.$Sw,h.getIconSchema());const r=new u.$sh(()=>i.notifySchemaChanged(e.$Sw),200);h.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Tw=g("widget-close",L.$Fj.close,(0,E.localize)(2,null)),e.$Uw=g("goto-previous-location",L.$Fj.arrowUp,(0,E.localize)(3,null)),e.$Vw=g("goto-next-location",L.$Fj.arrowDown,(0,E.localize)(4,null)),e.$Ww=A.ThemeIcon.modify(L.$Fj.sync,"spin"),e.$Xw=A.ThemeIcon.modify(L.$Fj.loading,"spin")}),define(Se[88],De([1,0,4,2,52,5,12]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$Zv=e.$Xv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tv=e.$Sv=void 0,e.$Uv=E,e.$Vv=I,e.$Wv=w,e.$Yv=S,e.$1v=y,e.$2v=h,e.$Sv=(0,A.$gi)("tunnelService"),e.$Tv=(0,A.$gi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var p;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(n){return!!n.forwardPort}var R;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(R||(e.ProvidedOnAutoForward=R={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function w(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const a=r.split("=")[1];if(/^https?:/.exec(a)){const t=I(L.URI.parse(a));if(t)return t}}}e.$Xv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(n){return e.$Xv.indexOf(n)>=0}e.$Zv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(n){return e.$Zv.indexOf(n)>=0}function h(n,i,r,a){if(r===1)return!1;if(r===2&&y(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class g{constructor(i,r,a){this.remoteAddress=i,this.localAddress=r,this.b=a,this.a=new u.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3v=g;let c=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$6d,this.onTunnelOpened=this.a.event,this.b=new u.$6d,this.onTunnelClosed=this.b.event,this.c=new u.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const a of r){const t=Array.from(a.values());for(const f of t){const l=await f.value;l&&typeof l!="string"&&i.push(l)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(a=>typeof a!="string"?a?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,a,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:a,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(y(i)||S(i))&&(i=e.$Xv[0]);const a=this.s(i,r);if(a)return++a.refcount,a.value}openTunnel(i,r,a,t,f,l=!1,s,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${a} on local port ${f}.`);const d=this.f??i;if(!d)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(d,r,a,t,f,l,s,o);return m?m.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,a),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&D.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const a=r.get(i.tunnelRemotePort);a&&(a.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,a))}}}}async p(i,r,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=a.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const a=this.e.get(i);if(a&&a.has(r)){const t=a.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,a){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:a})}async r(i,r){const a=this.e.get(i);if(a){const t=a.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&a.delete(r),a.size===0&&this.e.delete(i)}}s(i,r){const a=[i];S(i)?(a.push(...e.$Xv),a.push(...e.$Zv)):y(i)&&a.push(...e.$Zv);const t=a.map(f=>this.e.get(f));for(const f of t){const l=f?.get(r);if(l)return l}}canTunnel(i){return!!I(i)}u(i,r,a,t,f,l,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${a} on local port ${t}.`);const o=a;this.j.add(o);const d=t===void 0?a:t,m={elevationRequired:f?this.isPortPrivileged(d):!1},D={remoteAddress:{host:r,port:a},localAddressPort:t,privacy:l,public:l?l!==p.Private:void 0,protocol:s},$=i.forwardPort(D,m);return $?(this.q(r,a,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),$}};e.$4v=c,e.$4v=c=Je([qe(0,P.$Mj),qe(1,M.$Mi)],c)}),define(Se[272],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=void 0,e.$kl=(0,u.$gi)("IUriIdentityService")}),define(Se[273],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$5v=void 0,e.$5v=(0,u.$gi)("editSessionIdentityService");var L;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Se[274],De([1,0,15]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=L,e.$OL=M,e.$PL=A,e.$QL=P,e.$RL=b;function L(p){return p.scheme!==u.Schemas.file&&p.scheme!==u.Schemas.vscodeRemote}function M(p){if(p.folders.length)return p.folders.every(E=>L(E.uri))?p.folders[0].uri:void 0;if(p.configuration&&L(p.configuration))return p.configuration}function A(p){return M(p)?.scheme}function P(p){return M(p)?.authority}function b(p){return M(p)!==void 0}}),define(Se[40],De([1,0,215,17,76,23,2,5,15]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Ai=e.$zi=e.WorkbenchState=e.$ti=e.$si=e.$pi=void 0,e.$qi=E,e.$ri=R,e.$ui=I,e.$vi=w,e.$wi=S,e.$xi=h,e.$yi=g,e.$Bi=i,e.$Gi=r,e.$Hi=a,e.$Ji=t,e.$Ki=f,e.$Li=l,e.$pi=(0,b.$gi)("contextService");function E(s){const o=s;return typeof o?.id=="string"&&P.URI.isUri(o.uri)}function R(s){return typeof s?.id=="string"&&!E(s)&&!w(s)}e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function I(s,o){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.$nc)(s)}:o?e.$si:e.$ti;const d=s;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}function w(s){const o=s;return typeof o?.id=="string"&&P.URI.isUri(o.configPath)}function S(s){const o=s;if(o?.uri)return{id:o.id,uri:P.URI.revive(o.uri)};const d=s;if(d?.configPath)return{id:d.id,configPath:P.URI.revive(d.configPath)};if(s?.id)return{id:s.id}}var y;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function h(s){const o=s;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function g(s){const o=s;return!!(o&&typeof o=="object"&&P.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class c{constructor(o,d,m,D,$){this.h=o,this.j=m,this.k=D,this.l=$,this.c=M.$mi.forUris(this.l,()=>!0),this.folders=d}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=M.$mi.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=c;class n{constructor(o,d){this.raw=d,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.$Tg)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=n;function i(s){return new n({uri:s,index:0,name:(0,A.$Pg)(s)},{uri:s.toString()})}e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,u.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function r(s,o){return A.$Kg.isEqualOrParent(s,o.untitledWorkspacesHome)}function a(s){let o;return P.URI.isUri(s)?o=s:o=s.configuration,o?.scheme===p.Schemas.tmp}e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Ii}function f(s,o){return!r(s,o)&&!a(s)}function l(s){return(typeof s=="string"?(0,L.$oc)(s):(0,A.$Rg)(s))===e.$Di}}),define(Se[275],De([1,0,54,4,3,23,2,214,136,32,5,12,40,28,272,8,30,14,18]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ml=e.ProfileResourceType=void 0,e.$ll=r,e.$nl=a,e.$ol=t;var i;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(s){const o=s;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&P.URI.isUri(o.location)&&P.URI.isUri(o.globalStorageHome)&&P.URI.isUri(o.settingsResource)&&P.URI.isUri(o.keybindingsResource)&&P.URI.isUri(o.tasksResource)&&P.URI.isUri(o.snippetsHome)&&P.URI.isUri(o.extensionsResource))}e.$ml=(0,R.$gi)("IUserDataProfilesService");function a(s,o){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:P.URI.revive(s.location).with({scheme:o}),globalStorageHome:P.URI.revive(s.globalStorageHome).with({scheme:o}),settingsResource:P.URI.revive(s.settingsResource).with({scheme:o}),keybindingsResource:P.URI.revive(s.keybindingsResource).with({scheme:o}),tasksResource:P.URI.revive(s.tasksResource).with({scheme:o}),snippetsHome:P.URI.revive(s.snippetsHome).with({scheme:o}),extensionsResource:P.URI.revive(s.extensionsResource).with({scheme:o}),cacheHome:P.URI.revive(s.cacheHome).with({scheme:o}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,o,d,m,D,$){return{id:s,name:o,location:d,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:$&&D?.useDefaultFlags?.globalState?$.globalStorageHome:(0,A.$Tg)(d,"globalStorage"),settingsResource:$&&D?.useDefaultFlags?.settings?$.settingsResource:(0,A.$Tg)(d,"settings.json"),keybindingsResource:$&&D?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,A.$Tg)(d,"keybindings.json"),tasksResource:$&&D?.useDefaultFlags?.tasks?$.tasksResource:(0,A.$Tg)(d,"tasks.json"),snippetsHome:$&&D?.useDefaultFlags?.snippets?$.snippetsHome:(0,A.$Tg)(d,"snippets"),extensionsResource:$&&D?.useDefaultFlags?.extensions?$.extensionsResource:(0,A.$Tg)(d,"extensions.json"),cacheHome:(0,A.$Tg)(m,s),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let f=class extends M.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,d,m,D){super(),this.t=o,this.u=d,this.w=m,this.y=D,this.f=!0,this.h=this.B(new L.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),d=[o];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,n.$Tf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}d.push(t((0,A.$Qg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},o))}}catch($){this.y.error($)}const m=new S.$Ac,D=new Map;if(d.length)try{const $=this.Q();if($.workspaces)for(const[v,k]of Object.entries($.workspaces)){const C=P.URI.parse(v),O=d.find(B=>B.id===k);O&&m.set(C,O)}if($.emptyWindows)for(const[v,k]of Object.entries($.emptyWindows)){const C=d.find(O=>O.id===k);C&&D.set(v,C)}}catch($){this.y.error($)}this.z={profiles:d,workspaces:m,emptyWindows:D}}return this.z}D(){const o=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const d="Temp",m=new RegExp(`${(0,c.$Ye)(d)}\\s(\\d+)`);let D=0;for(const v of this.profiles){const k=m.exec(v.name),C=k?parseInt(k[1]):0;D=C>D?C:D}const $=`${d} ${D+1}`;return this.createProfile((0,u.$7i)((0,g.$Cg)()).toString(16),$,{transient:!0},o)}async createNamedProfile(o,d,m){return this.createProfile((0,u.$7i)((0,g.$Cg)()).toString(16),o,d,m)}async createProfile(o,d,m,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(o,d,m);return D&&await this.setProfileForWorkspace(D,$),$}async F(o,d,m){if(!(0,n.$Tf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(d);return D||(D=(async()=>{try{const $=this.profiles.find(C=>C.name===d||C.id===o);if($)return $;const v=t(o,d,(0,A.$Tg)(this.profilesHome,o),this.g,m,this.defaultProfile);await this.u.createFolder(v.location);const k=[];return this.j.fire({profile:v,join(C){k.push(C)}}),await h.Promises.settled(k),this.I([v],[],[]),v}finally{this.r.delete(d)}})(),this.r.set(d,D)),D}async updateProfile(o,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(D=>D.id===o.id);if(!m)throw new Error(`Profile '${o.name}' does not exist`);return m=t(m.id,d.name??m.name,m.location,this.g,{shortName:d.shortName??m.shortName,icon:d.icon===null?void 0:d.icon??m.icon,transient:d.transient??m.isTransient,useDefaultFlags:d.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(D=>D.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);const m=[];this.m.fire({profile:d,join(D){m.push(D)}});try{await Promise.allSettled(m)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(D){(0,E.$4k)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(o,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(D=>D.id===d.id);if(!m)throw new Error(`Profile '${d.name}' does not exist`);this.L(o,m)}unsetWorkspace(o,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(d=>d.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(o.map(d=>this.removeProfile(d)))}getProfileForWorkspace(o){const d=this.G(o);return P.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(o){return(0,w.$qi)(o)?o.uri:(0,w.$vi)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,o.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,o.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,o.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,o.location)))}I(o,d,m){const D=[...this.profiles,...o],$=[];this.s.profiles=[];for(let v of D)v.isDefault||d.some(k=>v.id===k.id)||(v=m.find(k=>v.id===k.id)??v,v.isTransient?this.s.profiles.push(v):$.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P($),this.z=void 0,this.J(o,d,m)}J(o,d,m){this.h.fire({added:o,removed:d,updated:m,all:this.profiles})}L(o,d,m){m=d?.isTransient?!0:m,m||this.L(o,void 0,!0);const D=this.G(o),$=m?this.s:this.C;P.URI.isUri(D)?($.workspaces.delete(D),d&&$.workspaces.set(D,d)):($.emptyWindows.delete(D),d&&$.emptyWindows.set(D,d)),m||this.M()}M(){const o={};for(const[m,D]of this.C.workspaces.entries())o[m.toString()]=D.id;const d={};for(const[m,D]of this.C.emptyWindows.entries())d[m.toString()]=D.id;this.R({workspaces:o,emptyWindows:d}),this.z=void 0}N(o){const d={},m=this.D();if(o.workspaces)for(const[$,v]of Object.entries(o.workspaces)){const k=P.URI.parse(v);d[$]=this.w.extUri.isEqual(k,m.location)?m.id:this.w.extUri.basename(k)}const D={};if(o.emptyWindows)for(const[$,v]of Object.entries(o.emptyWindows)){const k=P.URI.parse(v);D[$]=this.w.extUri.isEqual(k,m.location)?m.id:this.w.extUri.basename(k)}return{workspaces:d,emptyWindows:D}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$pl=f,e.$pl=f=Je([qe(0,p.$ni),qe(1,E.$Mk),qe(2,y.$kl),qe(3,I.$Mj)],f);class l extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$ql=l}),define(Se[276],De([1,0,8,4,3,58,18,193,5,275]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Mp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Kp=e.$Jp=e.$Ip=void 0,e.$Lp=S,e.$Np=h,e.$Pp=c,e.$Ip="__$__isNewStorageMarker",e.$Jp="__$__targetStorageMarker",e.$Kp=(0,p.$gi)("storageService");var R;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var w;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function S(n){const i=n.get(e.$Jp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class y extends M.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:y.a}){super(),this.m=i,this.b=this.B(new L.$9d),this.c=this.B(new L.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,a){return L.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,u.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:a,external:t}=r;if(a===e.$Jp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:a,target:this.J(i)[a],external:t})}w(i){this.f.fire({reason:i})}get(i,r,a){return this.P(r)?.get(i,a)}getBoolean(i,r,a){return this.P(r)?.getBoolean(i,a)}getNumber(i,r,a){return this.P(r)?.getNumber(i,a)}getObject(i,r,a){return this.P(r)?.getObject(i,a)}storeAll(i,r){this.y(()=>{for(const a of i)this.store(a.key,a.value,a.scope,a.target,r)})}store(i,r,a,t,f=!1){if((0,P.$3f)(r)){this.remove(i,a,f);return}this.y(()=>{this.z(i,a,t),this.P(a)?.set(i,r,f)})}remove(i,r,a=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,a)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const a=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&a.push(f);return a}z(i,r,a,t=!1){const f=this.J(r);typeof a=="number"?f[i]!==a&&(f[i]=a,this.P(r)?.set(e.$Jp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Jp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?S(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Ip,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(i){case R.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return c(i,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,E.$ll)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||h(r)&&h(i))}N(i,r,a){this.y(()=>{const t=new Set;for(const[f,l]of i)t.add(f),r.get(f)!==l&&this.u(a,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(a,{key:f,external:!0})})}}e.$Mp=y;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class g extends y{constructor(){super(),this.U=this.B(new b.$Gp(new b.$Hp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Gp(new b.$Hp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Gp(new b.$Hp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Op=g;async function c(n,i,r,a,t,f){const l=C=>{try{return JSON.parse(C)}catch{return C}},s=new Map,o=new Map;n.forEach((C,O)=>{s.set(O,C),o.set(O,l(C))});const d=new Map,m=new Map;i.forEach((C,O)=>{d.set(O,C),m.set(O,l(C))});const D=new Map,$=new Map;r.forEach((C,O)=>{D.set(O,C),$.set(O,l(C))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const v=[];if(s.forEach((C,O)=>{v.push({key:O,value:C})}),console.table(v),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];d.forEach((O,B)=>{C.push({key:B,value:O})}),console.table(C),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${f})`);const k=[];D.forEach((C,O)=>{k.push({key:O,value:C})}),console.table(k),console.groupEnd(),console.log($)}}),define(Se[111],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class u{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const A=this.c++;return this.b.set(A,M),this.e(),A}get(M,A){return this.b.has(M)?this.b.get(M)[A]:void 0}delete(M){this.b.delete(M),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$oic=u}),define(Se[59],De([1,0,15,23,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=void 0;class A{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new L.$Ig(b=>{const p=this.b.get(b.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(b,p){p===null?this.b.delete(b.scheme):this.b.set(b.scheme,p)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$tic=A,e.$uic=(0,M.$gi)("IExtHostFileSystemInfo")}),define(Se[27],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=void 0,e.$NO=(0,u.$gi)("IExtHostInitDataService")}),define(Se[277],De([1,0,221,12,257,27]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;let P=class extends M.$VP{constructor(p,E,R){const I=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",w=R.remote.isRemote?(0,u.localize)(0,null):p?(0,u.localize)(1,null):(0,u.localize)(2,null);super(E.createLogger(I,{name:w}))}};e.$Akc=P,e.$Akc=P=Je([qe(1,L.$Nj),qe(2,A.$NO)],P)}),define(Se[278],De([1,0,8]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=void 0;class L{constructor(P,b,p){this.h=new Map,this.a=P,this.b=b,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new u.$sh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of E.values())R.complete()}catch(R){for(const I of E.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,b){let p=this.f[P];return typeof p>"u"&&(p=b),p}update(P,b){this.f[P]=b;const p=this.h.get(P);if(p!==void 0)return p.p;const E=new u.$Dh;return this.h.set(P,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$cjc=L;class M extends L{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,b){super(P.identifier.value,!0,b),this.j=P}}e.$djc=M}),define(Se[279],De([1,0,4,2]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;class M{constructor(P){this.c=P,this.a=new u.$6d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$6d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,b,p,E){const I=this.c.getNotebookDocument(L.URI.revive(P)).acceptModelChanged(b.value,p,E);this.b.fire(I)}$acceptDirtyStateChanged(P,b){this.c.getNotebookDocument(L.URI.revive(P)).acceptDirty(b)}$acceptModelSaved(P){const b=this.c.getNotebookDocument(L.URI.revive(P));this.a.fire(b.apiNotebook)}}e.$3jc=M}),define(Se[20],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=void 0,e.$xO=(0,u.$gi)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$yO=L}),define(Se[280],De([1,0,25,4]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class M{#e;constructor(P,b){this.b=new L.$6d,this.onDidChange=this.b.event,this.a=u.$Bm.toKey(P.identifier),this.#e=b,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(P){return this.#e.get(this.a,P)}store(P,b){return this.#e.store(this.a,P,b)}delete(P){return this.#e.delete(this.a,P)}}e.$kjc=M}),define(Se[65],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0,e.$Mic=(0,u.$gi)("IURITransformerService");class L{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$Nic=L}),define(Se[281],De([1,0,21]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnb=M,e.$xnb=P;class L{constructor(){this.buffers=[]}add(p){let E=this.buffers.indexOf(p);return E<0&&(E=this.buffers.length,this.buffers.push(p)),E}}function M(b,p){if(p.serializeBuffersForPostMessage){const E=new L,I=JSON.stringify(b,(S,y)=>{if(y instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(y)};if(ArrayBuffer.isView(y)){const h=A(y);if(h)return{$$vscode_array_buffer_reference$$:!0,index:E.add(y.buffer),view:{type:h,byteLength:y.byteLength,byteOffset:y.byteOffset}}}return y}),w=E.buffers.map(S=>{const y=new Uint8Array(S);return u.$te.wrap(y)});return{message:I,buffers:w}}else return{message:JSON.stringify(b),buffers:[]}}function A(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(b,p){const E=p.map(w=>{const S=new ArrayBuffer(w.byteLength);return new Uint8Array(S).set(w.buffer),S}),R=p.length?(w,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const y=S,{index:h}=y,g=E[h];if(y.view)switch(y.view.type){case 1:return new Int8Array(g,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return S}:void 0;return{message:JSON.parse(b,R),arrayBuffers:E}}}),define(Se[282],De([1,0,283,395,396,62,2,12,397]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=R;const E=!1;function R(i,r,a,t,f,l){const s=l.environment.useHostProxy,o=typeof s=="boolean"?s:!l.remote.isRemote,d={resolveProxy:$=>i.resolveProxy($),lookupProxyAuthorization:g.bind(void 0,t,f,r,{},l.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>w(r),addCertificatesV2:()=>S(r),log:t,getLogLevel:()=>{const $=t.getLevel();switch($){case b.LogLevel.Trace:return p.LogLevel.Trace;case b.LogLevel.Debug:return p.LogLevel.Debug;case b.LogLevel.Info:return p.LogLevel.Info;case b.LogLevel.Warning:return p.LogLevel.Warning;case b.LogLevel.Error:return p.LogLevel.Error;case b.LogLevel.Off:return p.LogLevel.Off;default:return v($)}function v(k){return t.error("Unknown log level",k),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:o,loadAdditionalCertificates:async()=>{const $=[];if(l.remote.isRemote&&$.push((0,p.loadSystemCertificates)({log:t})),o){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const v=i.loadCertificates();v.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),$.push(v)}return(await Promise.all($)).flat()},env:process.env},m=(0,p.createProxyResolver)(d),D=I(d,m);return h(a,D)}function I(i,r){return{http:Object.assign(u,(0,p.createHttpPatch)(i,u,r)),https:Object.assign(L,(0,p.createHttpPatch)(i,L,r)),net:Object.assign(A,(0,p.createNetPatch)(i,A)),tls:Object.assign(M,(0,p.createTlsPatch)(i,M))}}function w(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",E)&&!!r.get("systemCertificates")}function S(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",E)&&!!r.get("systemCertificates")}const y=new Map;function h(i,r){return i.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(s,o,d){if(s==="net")return r.net;if(s==="tls")return r.tls;if(s!=="http"&&s!=="https")return f.apply(this,arguments);const m=a.findSubstr(P.URI.file(o.filename));let D=y.get(m);if(D||y.set(m,D={}),!D[s]){const $=r[s];D[s]={...$}}return D[s]}})}async function g(i,r,a,t,f,l,s,o){const d=t[l];s&&(t[l]=s),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${l}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${d}`);const m=s||d,D=Array.isArray(m)?m:typeof m=="string"?[m]:[];if(n(r,D,f),D.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!o.kerberosRequested)try{o.kerberosRequested=!0;const $=await new Promise((B,z)=>{fe(["kerberos"],B,z)}),v=new URL(l),k=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${v.hostname}`:`HTTP@${v.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${l}`,`spn:${k}`),"Negotiate "+await(await $.initializeClient(k)).step("")}catch($){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let c=!1;function n(i,r,a){c||!r.length||(c=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Se[284],De([1,0,133]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=M;function L(A){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:A,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function M(A){return new u.$in(L(A))}}),define(Se[142],De([1,0,231,18,2,3,5,37,32,15,44,185,39]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$jF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aF=e.EditorInputCapabilities=e.$_E=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=void 0,e.$4E=h,e.$5E=g,e.$6E=c,e.$7E=n,e.$8E=i,e.$9E=r,e.$0E=a,e.$$E=t,e.$bF=m,e.$cF=$,e.$dF=v,e.$eF=k,e.$fF=C,e.$gF=O,e.$hF=B,e.$iF=K,e.$kF=Q,e.$lF=ae,e.$mF=_,e.$nF=ge,e.$YE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ZE={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$1E="workbench.editor.sidebysideEditor",e.$2E="workbench.editors.textDiffEditor",e.$3E="workbench.editors.binaryResourceDiffEditor";var S;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var y;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(y||(e.EditorPaneSelectionCompareResult=y={}));function h(se){const re=se;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}function g(se,re,U){for(const ie of U.visibleEditorPanes)if(ie.group.id===re&&se.matches(ie.input))return ie.getViewState()}function c(se){if(m(se))return!1;const re=se;return M.URI.isUri(re?.resource)}function n(se){if(m(se))return!1;const re=se;return re?.original!==void 0&&re.modified!==void 0}function i(se){if(m(se))return!1;const re=se;return!re||re.resources&&!Array.isArray(re.resources)?!1:!!re.resources||!!re.multiDiffSource}function r(se){if(m(se)||n(se))return!1;const re=se;return re?.primary!==void 0&&re.secondary!==void 0}function a(se){if(m(se))return!1;const re=se;return re?re.resource===void 0||re.resource.scheme===E.Schemas.untitled||re.forceUntitled===!0:!1}function t(se){if(m(se))return!1;const re=se;return M.URI.isUri(re?.base?.resource)&&M.URI.isUri(re?.input1?.resource)&&M.URI.isUri(re?.input2?.resource)&&M.URI.isUri(re?.result?.resource)}var f;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var l;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class s{constructor(){this.a=new Map}registerSource(re,U){let ie=this.a.get(re);return ie||(ie={source:re,label:U},this.a.set(re,ie)),ie.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.$_E=new s;var o;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(o||(e.EditorInputCapabilities=o={}));class d extends A.$Tc{}e.$aF=d;function m(se){return se instanceof d}function D(se){const re=se;return M.URI.isUri(re?.preferredResource)}function $(se){const re=se;return m(re?.primary)&&m(re?.secondary)}function v(se){const re=se;return m(re?.modified)&&m(re?.original)}function k(se,re,U,ie,ye){return ge(ie,[(0,I.$3i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const le={...U,limits:{size:Number.MAX_VALUE}};se.openEditor(re,le)}}),(0,I.$3i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}function C(se){return m(se?.editor)}function O(se){const re=se;return C(se)&&re?.group!==void 0}function B(se){const re=se;return typeof re?.groupId=="number"&&m(re.editor)}var z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var T;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",se[se.EDITOR_STICKY=12]="EDITOR_STICKY",se[se.EDITOR_DIRTY=13]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var j;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class N{getOriginalUri(re,U){if(!re)return;if(t(re))return e.$jF.getOriginalUri(re.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:le}=this.a(re);if(ye&&le){if(U?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===j.ANY)return this.getOriginalUri(ye,{filterByScheme:U.filterByScheme})??this.getOriginalUri(le,{filterByScheme:U.filterByScheme});re=U.supportSideBySide===j.PRIMARY?ye:le}}if(n(re)||i(re)||r(re)||t(re))return;const ie=D(re)?re.preferredResource:re.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}a(re){return $(re)||r(re)?{primary:re.primary,secondary:re.secondary}:v(re)||n(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,U){if(!re)return;if(t(re))return e.$jF.getCanonicalUri(re.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:le}=this.a(re);if(ye&&le){if(U?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===j.ANY)return this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:U.filterByScheme});re=U.supportSideBySide===j.PRIMARY?ye:le}}if(n(re)||i(re)||r(re)||t(re))return;const ie=re.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}b(re,U){if(Array.isArray(U)){if(U.some(ie=>re.scheme===ie))return re}else if(U===re.scheme)return re}}var F;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function K(se,re,U,ie){if(!se.isSticky(re))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return U===F.MOUSE||U===F.KEYBOARD;case"mouse":return U===F.MOUSE;case"keyboard":return U===F.KEYBOARD}return!1}e.$jF=new N;var ee;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(re){const U=this.a=re.get(P.$fi);for(const[ie,ye]of this.c)this.e(ie,ye,U);this.c.clear()}e(re,U,ie){const ye=ie.createInstance(U);this.d.set(re,ye)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,L.$5f)(this.b)}registerEditorSerializer(re,U){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,U,this.a):this.c.set(re,U),(0,A.$Rc)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}b.$Yn.add(e.$YE.EditorFactory,new Y);async function Q(se,re,U){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const ye=M.URI.revive(ie.fileUri);if(!ye){U.info("Cannot resolve the path because it is not valid.",ie);return}if(!await re.canHandleResource(ye)){U.info("Cannot resolve the path because it cannot be handled",ie);return}let ue=ie.exists,ce=ie.type;if(typeof ue!="boolean"||typeof ce!="number")try{ce=(await re.stat(ye)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ue=!0}catch(H){U.error(H),ue=!1}if(!ue&&ie.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ie);return}if(ce===p.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ie);return}const de={...ie.options,pinned:!0};return ue?{resource:ye,options:de}:{resource:ye,options:de,forceUntitled:!0}}))}var Z;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function ae(se){const re=se;if(!re)return!1;const U=re;if(U.modified)return ae(U.modified);const ie=re;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}function _(se){return(0,R.$5i)(se)}function ge(se,re,U){const ie=(0,R.$6i)(se,re);return ie.forceMessage=U?.forceMessage,ie.forceSeverity=U?.forceSeverity,ie.allowDialog=U?.allowDialog,ie}}),define(Se[285],De([1,0,4,232,5,3,28,37,19,24,77,271]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$tF=e.ViewContentGroups=e.$rF=e.ViewContainerLocation=e.Extensions=e.$qF=e.$pF=e.$oF=void 0,e.$sF=y,e.$oF="views",e.$pF=(0,L.localize)(0,null),e.$qF=(0,I.$Qw)("default-view-icon",R.$Fj.window,(0,L.localize)(1,null));var w;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var S;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$rF=[0,1,2];function y(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class h extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new u.$6d),this.onDidRegister=this.c.event,this.f=this.B(new u.$6d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(l,s,o){const d=this.get(l.id);if(d)return d;const m=l;return m.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,P.$xc)(this.g,s,[]).push(m),o?.isDefault&&this.h.push(m),this.c.fire({viewContainer:m,viewContainerLocation:s}),m}deregisterViewContainer(l){for(const s of this.g.keys()){const o=this.g.get(s),d=o?.indexOf(l);if(d!==-1){o?.splice(d,1),o.length===0&&this.g.delete(s),this.f.fire({viewContainer:l,viewContainerLocation:s});return}}}get(l){return this.all.filter(s=>s.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(o=>o?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(s=>this.getViewContainerLocation(s)===l)}}b.$Yn.add(w.ViewContainersRegistry,new h);var g;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(g||(e.ViewContentGroups=g={}));function c(f,l){const s=f.group??g.More,o=l.group??g.More;return s!==o?s.localeCompare(o):(f.order??5)-(l.order??5)}class n extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new u.$6d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$6d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$6d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$6d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new P.$Gc}registerViews(l,s){this.registerViews2([{views:l,viewContainer:s}])}registerViews2(l){l.forEach(({views:s,viewContainer:o})=>this.r(s,o)),this.c.fire(l)}deregisterViews(l,s){const o=this.s(l,s);o.length&&this.f.fire({views:o,viewContainer:s})}moveViews(l,s){for(const o of this.m.keys())if(o!==s){const d=this.s(l,o);d.length&&(this.r(d,s),this.g.fire({views:d,from:o,to:s}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const s of this.j){const o=(this.m.get(s)||[]).filter(d=>d.id===l)[0];if(o)return o}return null}getViewContainer(l){for(const s of this.j)if((this.m.get(s)||[]).filter(d=>d.id===l)[0])return s;return null}registerViewWelcomeContent(l,s){return this.n.add(l,s),this.h.fire(l),(0,A.$Rc)(()=>{this.n.delete(l,s),this.h.fire(l)})}registerViewWelcomeContent2(l,s){const o=new Map;for(const[d,m]of s)this.n.add(l,m),o.set(d,(0,A.$Rc)(()=>{this.n.delete(l,m),this.h.fire(l)}));return this.h.fire(l),o}getViewWelcomeContent(l){const s=[];return this.n.forEach(l,o=>s.push(o)),s.sort(c)}r(l,s){let o=this.m.get(s);o||(o=[],this.m.set(s,o),this.j.push(s));for(const d of l){if(this.getView(d.id)!==null)throw new Error((0,L.localize)(2,null,d.id));o.push(d)}}s(l,s){const o=this.m.get(s);if(!o)return[];const d=[],m=[];for(const D of o)l.includes(D)?d.push(D):m.push(D);return d.length&&(m.length?this.m.set(s,m):(this.m.delete(s),this.j.splice(this.j.indexOf(s),1))),d}}b.$Yn.add(w.ViewsRegistry,new n),e.$tF=(0,M.$gi)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(l,s){this.c=!1,this.d=!1,(0,E.$Pn)(this,l),this.d=!!s,this.resolve=async o=>{if(s&&!this.c){const d=await s(o);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}o.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$uF=a;class t extends Error{constructor(l){super((0,L.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$vF=t}),define(Se[286],De([1,0,2,29,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$DF=A,e.$EF=P;function A(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof u.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(L.$$s.isIRange)}function P(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(A)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var p;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$FF=(0,M.$gi)("IChatService"),e.$GF="accessibility.voice.keywordActivation"}),define(Se[143],De([1,0,4,8,233]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new u.$6d,this.o=new u.$6d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,p,E,R){const I={command:b};if(p&&Object.keys(p).length>0&&(I.arguments=p),this.u("request",I),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const y={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,M.localize)(0,null,R,b)};S(y)}},R)}return E&&this.f.set(I.seq,E),I.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,p){return b.type!=="event"||p.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,L.$hh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const p=b,E=this.f.get(p.request_seq);E&&(this.f.delete(p.request_seq),E(p));break}}}}u(b,p){p.type=b,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((p,E)=>b.set(E,p)),await(0,L.$hh)(500),b.forEach((p,E)=>{p({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$3nb=A}),define(Se[287],De([1,0,2,234,45,5]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$JI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$II=e.MemoryRangeType=e.State=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=void 0,e.$HI=p,e.$wH="workbench.view.debug",e.$xH="workbench.debug.variablesView",e.$yH="workbench.debug.watchExpressionsView",e.$zH="workbench.debug.callStackView",e.$AH="workbench.debug.loadedScriptsView",e.$BH="workbench.debug.breakPointsView",e.$CH="workbench.debug.disassemblyView",e.$DH="workbench.panel.repl",e.$EH="workbench.panel.repl.view",e.$FH=new M.$xj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$GH=new M.$xj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$HH=new M.$xj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$IH="debugUx",e.$JH=new M.$xj(e.$IH,"default",{type:"string",description:L.localize(3,null)}),e.$KH=new M.$xj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$LH=new M.$xj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$MH=new M.$xj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$NH=new M.$xj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$OH=new M.$xj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$PH=new M.$xj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$QH=new M.$xj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$RH=new M.$xj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$SH=new M.$xj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$TH=new M.$xj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$UH=new M.$xj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$VH=new M.$xj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$WH=new M.$xj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$XH=new M.$xj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$YH=new M.$xj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$ZH=new M.$xj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$1H=new M.$xj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$2H=new M.$xj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$3H=new M.$xj("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.$4H=new M.$xj("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.$5H=new M.$xj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.$6H=new M.$xj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.$7H=new M.$xj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.$8H=new M.$xj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.$9H=new M.$xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.$0H=new M.$xj("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$$H=new M.$xj("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.$_H=new M.$xj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.$aI=new M.$xj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$bI=new M.$xj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.$cI=new M.$xj("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.$dI=new M.$xj("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.$eI=new M.$xj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.$fI=new M.$xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.$gI=new M.$xj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$hI=new M.$xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$iI=new M.$xj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$jI=new M.$xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$kI=new M.$xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$lI=new M.$xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$mI=new M.$xj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.$nI=new M.$xj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.$oI=new M.$xj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.$pI=new M.$xj("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.$qI=new M.$xj("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.$rI=new M.$xj("variableType",!1,{type:"string",description:L.localize(49,null)}),e.$sI=new M.$xj("variableName",!1,{type:"string",description:L.localize(50,null)}),e.$tI=new M.$xj("variableLanguage",!1,{type:"string",description:L.localize(51,null)}),e.$uI=new M.$xj("variableExtensionId",!1,{type:"string",description:L.localize(52,null)}),e.$vI=new M.$xj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(53,null)}),e.$wI=new M.$xj("multiSessionRepl",!1,{type:"boolean",description:L.localize(54,null)}),e.$xI=new M.$xj("multiSessionDebug",!1,{type:"boolean",description:L.localize(55,null)}),e.$yI=new M.$xj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(56,null)}),e.$zI=new M.$xj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(57,null)}),e.$AI=new M.$xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(58,null)}),e.$BI=new M.$xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(59,null)});const P=n=>L.localize(60,null,n);e.$CI=P,e.$DI="editor.contrib.debug",e.$EI="editor.contrib.breakpoint",e.$FI="debug",e.$GI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(61,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function p(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$II="vscode-debug-memory";var R;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(R||(e.DataBreakpointSetType=R={}));var I;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(I||(e.DebugConfigurationProviderTriggerKind=I={}));var w;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$JI=(0,A.$gi)("debugService");var S;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(S||(e.BreakpointWidgetContext=S={}));var y;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(y||(e.DebugVisualizationType=y={}));var h;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(h||(e.DebugTreeItemCollapsibleState=h={}));var g;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(g||(e.IDebugVisualizationTreeItem=g={}));var c;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:u.URI.revive(i.iconPath.light),dark:u.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(c||(e.IDebugVisualization=c={}))}),define(Se[288],De([1,0,14,2,17,24,15,29,22,19]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=void 0,e.$yG=I,e.$zG=w,e.$AG=S,e.$BG=y,e.$CG=h,e.$DG=g,e.$EG=c,e.$FG=i,e.$GG=t,e.$HG=f,e.$IG=s,e.$JG=d;const R=/{([^}]+)}/g;function I(D,$,v){return D.replace(R,function(k,C){return $&&C.length>0&&C[0]!=="_"?k:v&&v.hasOwnProperty(C)?v[C]:k})}function w(D){const $={};for(const v of Object.keys(D))v.startsWith("!")||($[v]=D[v]);return $}function S(D){return D.configuration.request==="attach"&&!y(D)&&(!D.parentSession||S(D.parentSession))}function y(D){let $=D.configuration.type;if($)return $==="vslsShare"&&($=D.configuration.adapterProxy.configuration.type),(0,u.$kf)($,"extensionhost")||(0,u.$kf)($,"pwa-extensionhost")?D:D.parentSession?y(D.parentSession):void 0}function h(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,$,v){let k,C=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=O.exec(D);){const z=B.index+1,T=z+B[0].length;if(z<=$&&T>=v){k=B[0],C=z;break}}if(k){const z=/\w+/g;let T=null;for(;(T=z.exec(k))&&!(T.index+1+C+T[0].length>=v););T&&(k=k.substring(0,z.lastIndex))}return k?{start:C,end:C+k.length-1}:{start:0,end:0}}async function c(D,$,v,k){if(D.evaluatableExpressionProvider.has($)){const C=D.evaluatableExpressionProvider.ordered($),O=(0,E.$Hb)(await Promise.all(C.map(async B=>{try{return await B.provideEvaluatableExpression($,v,k??p.CancellationToken.None)}catch{return}})));if(O.length>0){let B=O[0].expression;const z=O[0].range;return B||(B=$.getLineContent(v.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:B}}}else{const C=$.getLineContent(v.lineNumber),{start:O,end:B}=g(C,v.column,v.column),z=C.substring(O-1,B);return{matchingExpression:z,range:new b.$$s(v.lineNumber,O,v.lineNumber,O+z.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return L.URI.parse(D.path);if((0,M.$ic)(D.path))return L.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const $=L.URI.revive(D.path);if($)return $.scheme===P.Schemas.file?$.fsPath:$.toString()}return D.path}function t(D,$){const v=$?r:a,k=(0,A.$Mn)(D);return l(k,(C,O)=>{C&&O&&(O.path=v(O))}),k}function f(D,$){const v=$?r:a,k=(0,A.$Mn)(D);return l(k,(C,O)=>{!C&&O&&(O.path=v(O))}),k}function l(D,$){switch(D.type){case"event":{const v=D;switch(v.event){case"output":$(!1,v.body.source);break;case"loadedSource":$(!1,v.body.source);break;case"breakpoint":$(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=D;switch(v.command){case"setBreakpoints":$(!0,v.arguments.source);break;case"breakpointLocations":$(!0,v.arguments.source);break;case"source":$(!0,v.arguments.source);break;case"gotoTargets":$(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(k=>$(!1,k));break;default:break}break}case"response":{const v=D;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(k=>$(!1,k.source));break;case"loadedSources":v.body.sources.forEach(k=>$(!1,k));break;case"scopes":v.body.scopes.forEach(k=>$(!1,k.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(k=>$(!1,k.source));break;case"setBreakpoints":v.body.breakpoints.forEach(k=>$(!1,k.source));break;case"disassemble":v.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function s(D){return D.filter($=>!$.presentation?.hidden).sort(($,v)=>$.presentation?v.presentation?$.presentation.group?v.presentation.group?$.presentation.group!==v.presentation.group?$.presentation.group.localeCompare(v.presentation.group):o($.presentation.order,v.presentation.order):-1:v.presentation.group?1:o($.presentation.order,v.presentation.order):-1:v.presentation?1:0)}function o(D,$){return typeof D!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:D-$}async function d(D,$){const v=D.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(v!=="none"&&(await $.saveAll(),v==="allEditorsInActiveGroup")){const k=$.activeEditorPane;k&&k.input.resource?.scheme===P.Schemas.untitled&&await $.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}const m=(D,$)=>!D||!$?D===$:D.name===$.name&&D.path===$.path&&D.sourceReference===$.sourceReference;e.$KG=m}),define(Se[289],De([1,0,51,62,24,17,11,14,31,235,143]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=e.$Ikc=e.$Hkc=e.$Gkc=void 0;class I extends R.$3nb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(c,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,c.on("data",i=>this.v(i))}sendMessage(c){if(this.l){const n=JSON.stringify(c);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(c){for(this.p=Buffer.concat([this.p,c]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(I.b);for(const a of r){const t=a.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$Gkc=I;class w extends I{startSession(){return new Promise((c,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),c(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Hkc=w;class S extends w{constructor(c){super(),this.z=c}y(c){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$Ikc=S;class y extends w{constructor(c){super(),this.z=c}y(c){return L.createConnection(this.z.path,c)}}e.$Jkc=y;class h extends I{constructor(c,n){super(),this.y=c,this.z=n}async startSession(){const c=this.y.command,n=this.y.args,i=this.y.options||{};try{if(c)if(A.$ic(c)){if(!await p.Promises.exists(c))throw new Error(E.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=M.$Pn(M.$Mn(process.env),i.env)),c==="node")if(Array.isArray(n)&&n.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(E.localize(2,null,n[0]));this.x=f}else throw new Error(E.localize(3,null));else{const a={env:r};i.cwd&&(a.cwd=i.cwd),this.x=u.spawn(c,n,a)}this.x.on("error",a=>{this.n.fire(a)}),this.x.on("exit",(a,t)=>{this.o.fire(a)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.n.fire(a)}),this.x.stdin.on("error",a=>{this.n.fire(a)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),P.$i?new Promise((c,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return n(r)});i.on("exit",c),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,n){if(!c)return;const i=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?i.runtime=A.$jc(n,c.runtime):i.runtime=c.runtime),c.runtimeArgs&&(i.runtimeArgs=c.runtimeArgs),c.program&&(A.$ic(c.program)?i.program=c.program:i.program=A.$jc(n,c.program)),c.args&&(i.args=c.args);const r=c;return r.win&&(i.win=h.A(r.win,n)),r.winx86&&(i.winx86=h.A(r.winx86,n)),r.windows&&(i.windows=h.A(r.windows,n)),r.osx&&(i.osx=h.A(r.osx,n)),r.linux&&(i.linux=h.A(r.linux,n)),i}static platformAdapterExecutable(c,n){let i=Object.create(null);n=n.toLowerCase();for(const s of c)if(s.contributes){const o=s.contributes.debuggers;o&&o.length>0&&o.filter(d=>typeof d.type=="string"&&b.$kf(d.type,n)).forEach(d=>{const m=h.A(d,s.extensionLocation.fsPath);i=M.$Pn(i,m,s.isBuiltin)})}let r;P.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:P.$i?r=i.win||i.windows:P.$j?r=i.osx:P.$k&&(r=i.linux),r=r||i;const a=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,l=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(l||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Kkc=h}),define(Se[290],De([1,0,51,34,11]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=P,e.$Mkc=p;function A(E,R){return new Promise((I,w)=>{let S="";const y=u.spawn(E,R);y.pid&&y.stdout.on("data",h=>{S+=h.toString()}),y.on("error",h=>{w(h)}),y.on("close",h=>{I(S)})})}async function P(E){if(E)if(M.$i){const R=await new Promise((I,w)=>{fe(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{R.getProcessTree(E,w=>{I(!!w&&w.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(E)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function p(E,R,I,w){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:M.$i?S=0:S=2;let y,h=" ";switch(S){case 1:if(y=g=>(g=g.replace(/\'/g,"''"),g.length>0&&g.charAt(g.length-1)==="\\"?`'${g}\\'`:`'${g}'`),w){const g=(0,L.$lg)(w);g&&(h+=`${g}:; `),h+=`cd ${y(w)}; `}if(R.length>0){const g=R.shift(),c=I?g:y(g);h+=c[0]==="'"?`& ${c} `:`${c} `;for(const n of R)h+=n==="<"||n===">"||I?n:y(n),h+=" "}break;case 0:if(y=g=>(g=g.replace(/\"/g,'""'),g=g.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(c=>g.includes(c))||g.length===0?`"${g}"`:g),w){const g=(0,L.$lg)(w);g&&(h+=`${g}: && `),h+=`cd ${y(w)} && `}for(const g of R)h+=g==="<"||g===">"||I?g:y(g),h+=" ";break;case 2:{y=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g),w&&(h+=`cd ${y(w)} ; `);for(const g of R)h+=g==="<"||g===">"||I?g:y(g),h+=" ";break}}return h}}),define(Se[291],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.CellExecutionUpdateType=void 0;var L;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$dK=(0,u.$gi)("INotebookExecutionService")}),define(Se[292],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghb=e.$fhb=e.ProxyKernelState=e.$ehb=void 0,e.$ehb=100;var L;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$fhb=(0,u.$gi)("INotebookKernelService"),e.$ghb=(0,u.$gi)("INotebookKernelHistoryService")}),define(Se[293],De([1,0,3,29,198,100]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RTb=void 0;class P extends u.$Tc{constructor(p,E,R){super(),this._source=p,this.b=E,this.c=R,this.a=void 0}f(p){const E=p.getLineCount();return new L.$$s(1,1,E,this.g(p,E))}g(p,E){if(E<1||E>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const p=new M.$vC;p.acceptChunk(this._source);const E=p.finish(!0),{textBuffer:R,disposable:I}=E.create(1);this.b=R,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const E=new M.$vC;E.acceptChunk(p);const R=E.finish(!0),{textBuffer:I,disposable:w}=R.create(1);return this.B(w),I})),this.a}findInInputs(p){const R=new A.$jC(p,!1,!1,null).parseSearchRequest();if(!R)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,R,!0,5e3)}findInOutputs(p){const R=new A.$jC(p,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(I=>{const w=I.findMatchesLineByLine(this.f(I),R,!0,5e3);if(w.length!==0)return{textBuffer:I,matches:w}}).filter(I=>!!I):[]}}e.$RTb=P}),define(Se[66],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class M{static fromExtHostTestItem(P,b,p=P.parent){if(P._isRoot)return new M([b]);const E=[P.id];for(let R=p;R&&R.id!==b;R=R.parent)E.push(R.id);return E.push(b),new M(E.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const b=P.indexOf("\0");return b===-1?P:P.slice(0,b)}static fromString(P){return new M(P.split("\0"))}static join(P,b){return new M([...P.path,b])}static joinToString(P,b){return P.toString()+"\0"+b}static parentId(P){const b=P.lastIndexOf("\0");return b===-1?void 0:P.slice(0,b)}static localId(P){const b=P.lastIndexOf("\0");return b===-1?P:P.slice(b+1)}static isChild(P,b){return b.startsWith(P)&&b[P.length]==="\0"}static compare(P,b){return P===b?0:M.isChild(P,b)?2:M.isChild(b,P)?3:1}constructor(P,b=P.length){if(this.path=P,this.d=b,P.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new M(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new M(this.path,P)}compare(P){if(typeof P=="string")return M.compare(this.toString(),P);for(let b=0;b<P.d&&b<this.d;b++)if(P.path[b]!==this.path[b])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$3K=M}),define(Se[89],De([1,0,2,49,29,66]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$$K=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$0K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$9K=e.$8K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$7K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$6K=e.$5K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$4K=e.TestResultState=void 0;var P;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(P||(e.TestResultState=P={})),e.$4K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var p;(function(j){j[j.Run=2]="Run",j[j.Debug=4]="Debug",j[j.Coverage=8]="Coverage",j[j.HasNonDefaultProfile=16]="HasNonDefaultProfile",j[j.HasConfigurable=32]="HasConfigurable",j[j.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$5K=[2,4,8,16,32,64];const E=j=>"runId"in j;e.$6K=E;var R;(function(j){j.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),j.deserialize=(N,F)=>({range:M.$$s.lift(F.range),uri:N.asCanonicalUri(u.URI.revive(F.uri))})})(R||(e.IRichLocation=R={}));var I;(function(j){j[j.Error=0]="Error",j[j.Output=1]="Output"})(I||(e.TestMessageType=I={}));var w;(function(j){j.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&R.serialize(N.location)}),j.deserialize=(N,F)=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.deserialize(N,F.location)})})(w||(e.ITestErrorMessage=w={}));const S=(j,N)=>`${N?"s":"e"}${j}`;e.$7K=S;var y;(function(j){j.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&R.serialize(N.location)}),j.deserialize=(N,F)=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&R.deserialize(N,F.location)})})(y||(e.ITestOutputMessage=y={}));var h;(function(j){j.serialize=N=>N.type===0?w.serialize(N):y.serialize(N),j.deserialize=(N,F)=>F.type===0?w.deserialize(N,F):y.deserialize(N,F)})(h||(e.ITestMessage=h={}));var g;(function(j){j.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),j.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(h.serialize)}),j.deserialize=(N,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(K=>h.deserialize(N,K))})})(g||(e.ITestTaskState=g={}));const c="\0",n=(j,N)=>j+c+N;e.$8K=n;const i=j=>{const N=j.indexOf(c);return{ctrlId:j.slice(0,N),tagId:j.slice(N+1)}};e.$9K=i;var r;(function(j){j.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),j.deserialize=(N,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?N.asCanonicalUri(u.URI.revive(F.uri)):void 0,range:F.range?M.$$s.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(r||(e.ITestItem=r={}));var a;(function(j){j[j.NotExpandable=0]="NotExpandable",j[j.Expandable=1]="Expandable",j[j.BusyExpanding=2]="BusyExpanding",j[j.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(j){j.serialize=N=>({expand:N.expand,item:r.serialize(N.item)}),j.deserialize=(N,F)=>({controllerId:A.$3K.root(F.item.extId),expand:F.expand,item:r.deserialize(N,F.item)})})(t||(e.InternalTestItem=t={}));var f;(function(j){j.serialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.uri!==void 0&&(F.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(F.range=N.item.range?.toJSON()),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}},j.deserialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.range!==void 0&&(F.range=N.item.range?M.$$s.lift(N.item.range):null),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}}})(f||(e.ITestItemUpdate=f={}));const l=(j,N)=>{N.expand!==void 0&&(j.expand=N.expand),N.item!==void 0&&(j.item=j.item?Object.assign(j.item,N.item):N.item)};e.$0K=l;var s;(function(j){j.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(g.serializeWithoutMessages)}),j.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(g.serialize)}),j.deserialize=(N,F)=>({...t.deserialize(N,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(K=>g.deserialize(N,K)),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(j){j.empty=()=>({covered:0,total:0}),j.sum=(N,F)=>{N.covered+=F.covered,N.total+=F.total}})(o||(e.ICoveredCount=o={}));var d;(function(j){j.serialize=N=>({statement:N.statement,branch:N.branch,declaration:N.declaration,details:N.details?.map(v.serialize),uri:N.uri.toJSON()}),j.deserialize=(N,F)=>({statement:F.statement,branch:F.branch,declaration:F.declaration,details:F.details?.map(v.deserialize),uri:N.asCanonicalUri(u.URI.revive(F.uri))})})(d||(e.IFileCoverage=d={}));function m(j){return{...j,location:j.location?.toJSON()}}function D(j){return j.location=j.location?L.$0s.isIPosition(j.location)?L.$0s.lift(j.location):M.$$s.lift(j.location):void 0,j}e.$$K=3;var $;(function(j){j[j.Declaration=0]="Declaration",j[j.Statement=1]="Statement",j[j.Branch=2]="Branch"})($||(e.DetailType=$={}));var v;(function(j){j.serialize=N=>N.type===0?C.serialize(N):O.serialize(N),j.deserialize=N=>N.type===0?C.deserialize(N):O.deserialize(N)})(v||(e.CoverageDetails=v={}));var k;(function(j){j.serialize=m,j.deserialize=D})(k||(e.IBranchCoverage=k={}));var C;(function(j){j.serialize=m,j.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var O;(function(j){j.serialize=N=>({...m(N),branches:N.branches?.map(k.serialize)}),j.deserialize=N=>({...D(N),branches:N.branches?.map(k.deserialize)})})(O||(e.IStatementCoverage=O={}));var B;(function(j){j[j.Add=0]="Add",j[j.Update=1]="Update",j[j.DocumentSynced=2]="DocumentSynced",j[j.Remove=3]="Remove",j[j.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",j[j.Retire=5]="Retire",j[j.AddTag=6]="AddTag",j[j.RemoveTag=7]="RemoveTag"})(B||(e.TestDiffOpType=B={}));var z;(function(j){j.deserialize=(N,F)=>F.op===0?{op:F.op,item:t.deserialize(N,F.item)}:F.op===1?{op:F.op,item:f.deserialize(F.item)}:F.op===2?{op:F.op,uri:N.asCanonicalUri(u.URI.revive(F.uri)),docv:F.docv}:F,j.serialize=N=>N.op===0?{op:N.op,item:t.serialize(N.item)}:N.op===1?{op:N.op,item:f.serialize(N.item)}:N})(z||(e.TestsDiffOp=z={}));class T{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const F=this.v();for(const K of N)switch(K.op){case 0:this.l(t.deserialize(this.k,K.item),F);break;case 1:this.o(f.deserialize(K.item),F);break;case 3:this.p(K.itemId,F);break;case 5:this.q(K.itemId);break;case 4:this.updatePendingRoots(K.amount);break;case 6:this.c.set(K.tag.id,K.tag);break;case 7:this.c.delete(K.id);break}F.complete?.()}l(N,F){const K=A.$3K.parentId(N.item.extId)?.toString();let ee;if(!K)ee=this.w(N),this.g.add(ee),this.f.set(N.item.extId,ee);else if(this.f.has(K)){const Y=this.f.get(K);Y.children.add(N.item.extId),ee=this.w(N,Y),this.f.set(N.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return F.add?.(ee),N.expand===2&&this.h++,ee}o(N,F){const K=this.f.get(N.extId);if(K)return N.expand!==void 0&&(K.expand===2&&this.h--,N.expand===2&&this.h++),(0,e.$0K)(K,N),F.update?.(K),K}p(N,F){const K=this.f.get(N);if(!K)return;const ee=A.$3K.parentId(K.item.extId)?.toString();ee?this.f.get(ee).children.delete(K.item.extId):this.g.delete(K);const Y=[[N]];for(;Y.length;)for(const Q of Y.pop()){const Z=this.f.get(Q);Z&&(Y.push(Z.children),this.f.delete(Q),F.remove?.(Z,Z!==K),Z.expand===2&&this.h--)}}q(N){}updatePendingRoots(N){this.j+=N}v(){return{}}}e.$_K=T}),define(Se[112],De([1,0,8,4,3,61,89,66]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.TestItemEventOp=void 0;var p;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const E=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),w=(n,i)=>{let r;for(const[a,t]of I)t(n[a],i[a])||(r?r[a]=i[a]:r={[a]:i[a]});return r};class S extends M.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$sh(()=>this.flushDiff(),200)),this.g=this.B(new L.$6d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,P.$0K)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,P.$0K)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const a=this.tree.get(i);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.M(a);return t.isOpen()?this.L(a,r-1):t.wait().then(()=>this.L(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.L(a,r-1)):this.L(a,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(b.$3K.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const a of r.ops)this.w(i,a);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,A.$9c)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const a=b.$3K.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(a.toString());if(!f){f={fullId:a,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(a.toString()),this.z(i,r);const l=this.s.getChildren(f.actual),s=f.actual,o=w(this.s.toITestItem(s),this.s.toITestItem(i));this.s.getApiFor(s).listener=void 0,f.actual=i,f.expand=0,o&&(o.hasOwnProperty("tags")&&(this.C(i.tags,s.tags,a.toString()),delete o.tags),this.w(f,{op:4,update:o})),this.I(i,f,r);for(const[d,m]of l)this.s.getChildren(i).get(m.id)||this.O(b.$3K.joinToString(a,m.id));this.y(f.actual.uri)}C(i,r,a){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:a,item:{tags:i.map(f=>(0,P.$8K)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$8K)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,P.$8K)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,a){this.G(i,a);const t=this.s.getApiFor(i);t.parent=a?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,a){this.H(i,r,a);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const a=[];for(const[t,f]of this.s.getChildren(i.actual)){const l=this.expand(b.$3K.joinToString(i.fullId,f.id),r);(0,u.$5g)(l)&&a.push(l)}if(a.length)return Promise.all(a).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$fh;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$fh,a=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){a(f)}return(0,u.$5g)(t)?t.catch(a).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,l]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$3K.joinToString(t.fullId,l.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$nO=S;class y extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$oO=y;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pO=h;class g extends Error{constructor(i,r,a){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$qO=g;const c=(n,i,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,f){for(const l of a.values())t.call(f,l,this)},[Symbol.iterator](){return a.entries()},replace(t){const f=new Map,l=new Set(a.keys()),s={op:5,ops:[]};for(const o of t){if(!(o instanceof r))throw new h(o.id);const d=i(o).controllerId;if(d!==n.controllerId)throw new g(o.id,d,n.controllerId);if(f.has(o.id))throw new y(o.id);f.set(o.id,o),l.delete(o.id),s.ops.push({op:0,item:o})}for(const o of l.keys())s.ops.push({op:3,id:o});n.listener?.(s),a=f},add(t){if(!(t instanceof r))throw new h(t.id);a.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){a.delete(t)&&n.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$rO=c}),define(Se[144],De([1,0,112]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=e.$sO=void 0;const L=new WeakMap,M=(P,b)=>{const p={controllerId:b};return L.set(P,p),p};e.$sO=M;const A=P=>{const b=L.get(P);if(!b)throw new u.$pO(P?.id||"<unknown>");return b};e.$tO=A}),define(Se[113],De([1,0,15,2]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xxb=e.$Wxb=e.$Vxb=void 0,e.$Yxb=M,e.$Zxb=P,e.$Vxb="vscode-cdn.net",e.$Wxb=`vscode-resource.${e.$Vxb}`,e.$Xxb=`'self' https://*.${e.$Vxb}`;function M(b,p){return b.scheme===u.Schemas.http||b.scheme===u.Schemas.https?b:(p&&p.authority&&p.isRemote&&b.scheme===u.Schemas.file&&(b=L.URI.from({scheme:u.Schemas.vscodeRemote,authority:p.authority,path:b.path})),L.URI.from({scheme:u.Schemas.https,authority:`${b.scheme}+${A(b.authority)}.${e.$Wxb}`,path:b.path,fragment:b.fragment,query:b.query}))}function A(b){return b.replace(/./g,p=>{const E=p.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?p:"-"+E.toString(16).padStart(4,"0")})}function P(b){return b.replace(/-([0-9a-f]{4})/g,(p,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Se[294],De([1,0,4,3,113]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class A{constructor(b,p,E){this.d=b,this.e=p,this.f=E,this.a=0,this.b=new L.$Sc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,p,E,R,I){let w;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){w=i;break}if(!w)throw new Error("not a visible editor");const S=this,y=this.a++,h=new u.$6d,g=new u.$6d,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$Yxb)(i,S.f)}get cspSource(){return M.$Xxb}set options(i){this.b=i,S.d.$setOptions(y,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(y,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return S.d.$postMessage(y,i)}},n=new class{constructor(){this.editor=b,this.line=p,this.height=E,this.webview=c,this.onDidDispose=g.event}dispose(){S.c.has(y)&&(S.c.delete(y),S.d.$disposeEditorInset(y),g.fire(),g.dispose(),h.dispose())}};return this.d.$createEditorInset(y,w.id,w.value.document.uri,p+1,E,R||{},I.identifier,I.extensionLocation),this.c.set(y,{editor:b,inset:n,onDidReceiveMessage:h}),n}$onDidDispose(b){const p=this.c.get(b);p&&p.inset.dispose()}$onDidReceiveMessage(b,p){this.c.get(b)?.onDidReceiveMessage.fire(p)}}e.$Kic=A}),define(Se[145],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$hL=e.$gL=void 0,e.$gL="__",e.$hL=(0,u.$gi)("IAuthenticationService"),e.$iL=(0,u.$gi)("IAuthenticationExtensionsService")}),define(Se[295],De([1,0,5]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.VariableKind=e.$jP=void 0,e.$jP=(0,u.$gi)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class M extends Error{constructor(P,b){super(b),this.variable=P}}e.$kP=M}),define(Se[296],De([1,0,17,50,18,24,11,103,238,295,14]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,y,h,g){this.h=new Map,this.a=S,this.b=y,this.g=h,g&&(this.c=g.then(c=>this.i(c)))}i(S){if(P.$i){const y=Object.create(null);return Object.keys(S).forEach(h=>{y[h.toLowerCase()]=S[h]}),y}return S}resolveWithEnvironment(S,y,h){return this.l({env:this.i(S),userHome:void 0},y?y.uri:void 0,h)}async resolveAsync(S,y){const h={env:await this.c,userHome:await this.g};return this.l(h,S?S.uri:void 0,y)}async j(S,y,h,g){const c=A.$Mn(y);P.$i&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):P.$j&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):P.$k&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,c,h,g)}async resolveAnyAsync(S,y,h){return this.j(S,y,h)}async resolveAnyMap(S,y,h){const g=new Map;return{newConfig:await this.j(S,y,h,g),resolvedVariables:g}}resolveWithInteractionReplace(S,y,h,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,y,h,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,y){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,y)}async l(S,y,h,g,c){if(M.$Tf(h))return this.m(S,y,h,g,c);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(S,y,n,g,c)));if(M.$Vf(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async r=>[await this.m(S,y,r,g,c),await this.l(S,y,h[r],g,c)]));for(const[r,a]of i)n[r]=a;return n}return h}m(S,y,h,g,c){return(0,R.$cf)(h,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let r=await this.o(S,n,i,y,g);return c?.set(i,r),r!==n&&M.$Tf(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.m(S,y,r,g,c)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,y,h,g,c){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const r=f=>{const l=this.a.getFilePath();if(l)return(0,b.$dw)(l);throw new E.$kP(f,(0,p.localize)(0,null,y))},a=f=>{const l=r(f);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,b.$dw)(s)}throw new E.$kP(f,(0,p.localize)(1,null,y,u.$nc(l)))},t=f=>{if(n){const l=this.a.getFolderUri(n);if(l)return l;throw new E.$kP(f,(0,p.localize)(2,null,y,n))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new E.$kP(f,(0,p.localize)(3,null,y)):new E.$kP(f,(0,p.localize)(4,null,y))};switch(h){case"env":if(n){if(S.env){const f=S.env[P.$i?n.toLowerCase():n];if(M.$Tf(f))return f}return""}throw new E.$kP(E.VariableKind.Env,(0,p.localize)(5,null,y));case"config":if(n){const f=this.a.getConfigurationValue(g,n);if(M.$3f(f))throw new E.$kP(E.VariableKind.Config,(0,p.localize)(6,null,y,n));if(M.$Vf(f))throw new E.$kP(E.VariableKind.Config,(0,p.localize)(7,null,y,n));return f}throw new E.$kP(E.VariableKind.Config,(0,p.localize)(8,null,y));case"command":return this.p(E.VariableKind.Command,y,n,c,"command");case"input":return this.p(E.VariableKind.Input,y,n,c,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new E.$kP(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,y,n));return this.n(f.extensionLocation)}throw new E.$kP(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,y));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$dw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return g||n?(0,b.$dw)(this.n(t(E.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$dw)(u.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$kP(E.VariableKind.UserHome,(0,p.localize)(11,null,y))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$kP(E.VariableKind.LineNumber,(0,p.localize)(12,null,y))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$kP(E.VariableKind.SelectedText,(0,p.localize)(13,null,y))}case"file":return r(E.VariableKind.File);case"fileWorkspaceFolder":return a(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$nc(a(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||n?u.$lc(this.n(t(E.VariableKind.RelativeFile)),r(E.VariableKind.RelativeFile)):r(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$mc(r(E.VariableKind.RelativeFileDirname));if(g||n){const l=u.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return l.length===0?".":l}return f}case"fileDirname":return u.$mc(r(E.VariableKind.FileDirname));case"fileExtname":return u.$oc(r(E.VariableKind.FileExtname));case"fileBasename":return u.$nc(r(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$nc(r(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$oc(f).length)}case"fileDirnameBasename":return u.$nc(u.$mc(r(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||y}case"execInstallFolder":{const f=this.a.getAppRoot();return f||y}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${h}:${n}`:h;return this.p(E.VariableKind.Unknown,y,f,c,void 0)}catch{return y}}}}p(S,y,h,g,c){if(h&&g){const n=c===void 0?g[h]:g[c+":"+h];if(typeof n=="string")return n;throw new E.$kP(S,(0,p.localize)(14,null,y))}return y}}e.$zP=I}),define(Se[146],De([1,0,5,142]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rD=void 0,e.$sD=E,e.$tD=w,e.$uD=S,e.$rD=(0,u.$gi)("editorGroupsService");var M;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var A;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var P;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var b;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EXPAND=1]="EXPAND",y[y.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var p;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function E(y){const h=y;return(0,L.$bF)(h?.editor)&&(0,L.$bF)(h?.replacement)}var R;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(y){const h=y;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function S(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[297],De([1,0,5,146]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yD=e.$xD=e.$wD=e.$vD=void 0,e.$zD=M,e.$vD=(0,u.$gi)("editorService"),e.$wD=-1,e.$xD=-2,e.$yD=-3;function M(A){const P=A;return typeof A=="number"||(0,L.$tD)(P)}}),define(Se[147],De([1,0,5,136]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=void 0,e.$BL=(0,u.$hi)(L.$ni)}),define(Se[148],De([1,0,25,4,17,3,8]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=e.$p0b=e.$o0b=e.$n0b=e.$m0b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$m0b=b;class p{static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const a=r.getExtensionDescription(n);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(n,i){this.j=n,this.c=new L.$6d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new u.$Dm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=g(this.e,i),this.e=this.e.concat(n);const r=p.l(this.e);return this.e=g(this.e,r.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,s){this.addNode(l),this.addNode(s),this.c.has(l)?this.c.get(l).push(s):this.c.set(l,[s])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,s){const o=i.getArcs(l);for(let d=0;d<o.length;d++)if(!s.has(o[d]))return!1;return!0}getNodes(){return this.e}},r=new u.$Dm;for(const l of n)if(r.set(l.identifier,l),l.extensionDependencies)for(const s of l.extensionDependencies)i.addArc(u.$Bm.toKey(l.identifier),u.$Bm.toKey(s));const a=new Set;i.getNodes().filter(l=>i.getArcs(l).length===0).forEach(l=>a.add(l));const t=i.getNodes().filter(l=>!a.has(l));let f;do{f=!1;for(let l=0;l<t.length;l++){const s=t[l];i.hasOnlyGoodArcs(s,a)&&(t.splice(l,1),l--,a.add(s),f=!0)}}while(f);return t.map(l=>r.get(l))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$n0b=p;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$o0b=E;class R{constructor(n){this.d=new S,this.c=new p(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$p0b=R;class I extends A.$Tc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$q0b=I;class w{constructor(n){this.name=n;const i=(0,P.$_g)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class S{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new w(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,A.$Rc)(a))}}var y;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(y||(y={}));function h(c,n){const i=c.isBuiltin?0:c.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const a=M.$gc.basename(c.extensionLocation.path),t=M.$gc.basename(n.extensionLocation.path);return a<t?-1:a>t?1:0}function g(c,n){const i=new u.$Cm(n);return c.filter(r=>!i.has(r.identifier))}}),define(Se[298],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.ExtHostConnectionType=void 0,e.$0m=b,e.$$m=p;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[L.ENV_KEY]=this.pipeName}}e.$7m=L;class M{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[M.ENV_KEY]="1"}}e.$8m=M;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[A.ENV_KEY]="1"}}e.$9m=A;function P(R){delete R[L.ENV_KEY],delete R[M.ENV_KEY],delete R[A.ENV_KEY]}function b(R,I){P(I),R.serialize(I)}function p(R){if(R[L.ENV_KEY])return E(R,new L(R[L.ENV_KEY]));if(R[M.ENV_KEY])return E(R,new M);if(R[A.ENV_KEY])return E(R,new A);throw new Error("No connection information defined in environment!")}function E(R,I){return P(R),I}}),define(Se[114],De([1,0,21]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Jm=P,e.$Km=b;var L;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(L||(e.UIKind=L={}));var M;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var A;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function P(E){const R=u.$te.alloc(1);switch(E){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}function b(E,R){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}var p;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Se[90],De([1,0,5,4,12,27,114,86,87,24,2,3,224]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$PO=e.$OO=void 0,e.$QO=h;let S=class extends I.$Tc{constructor(c,n){super(),this.s=c,this.t=n,this.a=this.B(new L.$6d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$6d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:p.$7o,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Oj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,n,i){const r=this.getTelemetryDetails(),a=new y(n,i,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(c,n,i){this.f=c,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const n=Object.create(null);switch(n["common.extname"]=`${c.publisher}.${c.name}`,n["common.extversion"]=c.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case P.UIKind.Web:n["common.uikind"]="web";break;case P.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$sm)((0,p.$ap)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const a=i.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,n){const r=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(c.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),a=!0);return a}};e.$OO=S,e.$OO=S=Je([qe(0,A.$NO),qe(1,M.$Nj)],S);class y{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,n,i,r,a,t,f){this.g=i,this.h=r,this.i=a,this.j=t,this.a=new L.$6d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(c,n){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let n="properties"in c?c.properties??{}:c;return n=(0,p.$dp)(n,[]),this.c&&(n=(0,E.$Pn)(n,this.c)),this.b||(n=(0,E.$Pn)(n,this.j)),"properties"in c?c.properties=n:c=n,c}k(c,n){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(c,n),this.h.trace(c,n))}logUsage(c,n){this.d.isUsageEnabled&&this.k(c,n)}logError(c,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,n);else{const i={name:c.name,message:c.message,stack:c.stack,cause:c.cause},r=(0,p.$dp)(i,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(a,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const c=this,n={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$PO=y;function h(g){const c=Date.now()-new Date(g).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$RO=(0,u.$gi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,268,140,25,5]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.ActivationKind=e.$6F=e.$5F=e.$2F=e.ExtensionHostStartup=e.$1F=e.$ZF=e.$YF=e.$XF=void 0,e.$3F=w,e.$4F=S,e.$7F=c,e.$8F=n,e.$XF=Object.freeze({identifier:new P.$Bm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YF="extensions.webWorker",e.$ZF=(0,b.$gi)("extensionService");class p{constructor(a){this.dependency=a}}e.$1F=p;var E;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,f){this.c=a,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$IF.createActivationEventsMap(this.d)}}set(a,t,f){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const l=[],s=[],o=[],d=[],m=I(this.d),D=I(t),$=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.d){const z=D.get(B.identifier);if(!z){l.push(B.identifier),m.delete(B.identifier);continue}if(!$(B,z)){l.push(B.identifier),m.delete(B.identifier);continue}}for(const B of t){const z=m.get(B.identifier);if(!z){s.push(B);continue}if(!$(z,B)){l.push(z.identifier),m.delete(z.identifier);continue}}const v=new P.$Cm(this.e),k=new P.$Cm(f);for(const B of this.e)k.has(B)||o.push(B);for(const B of f)v.has(B)||d.push(B);const C=A.$IF.createActivationEventsMap(s),O={versionId:a,toRemove:l,toAdd:s,addActivationEvents:C,myToRemove:o,myToAdd:d};return this.delta(O),O}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:l,myToAdd:s}=a,o=new P.$Cm(t),d=new P.$Cm(l);for(let m=0;m<this.d.length;m++)o.has(this.d[m].identifier)&&(this.d.splice(m,1),m--);for(let m=0;m<this.e.length;m++)d.has(this.e[m])&&(this.e.splice(m,1),m--);for(const m of f)this.d.push(m);for(const m of s)this.e.push(m);return this.f=null,a}containsExtension(a){for(const t of this.e)if(P.$Bm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=A.$IF.readActivationEvents(t);for(const l of f)a.add(l)}return a}}e.$2F=R;function I(r){const a=new P.$Dm;for(const t of r)a.set(t.identifier,t);return a}function w(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}function S(r,a){if(!w(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class y{constructor(a,t,f,l){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=l}}e.$5F=y;class h{constructor(a,t){this.description=a,this.value=t}}e.$6F=h;var g;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function c(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,M.$jp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,a){return{identifier:new P.$Bm((0,M.$hp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9F=i}),define(Se[299],De([1,0,13,148,25,26,12,8]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=e.$$ic=e.$0ic=e.$9ic=e.$8ic=e.$7ic=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(c,n,i,r){this.startup=c,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$7ic=p;class E{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,n){return c===-1||n===-1?-1:n-c}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$8ic=E;class R{constructor(c,n,i,r,a,t){this.activationFailed=c,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=a,this.subscriptions=t}}e.$9ic=R;class I extends R{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0ic=I;class w extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$ic=w;class S extends R{constructor(c){super(!0,c,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(c,n,i,r){this.g=r,this.a=c,this.b=n,this.c=i,this.d=new M.$Dm,this.f=Object.create(null)}dispose(){for(const[c,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const c=[];for(const[n,i]of this.d)c.push(i.wait());await Promise.all(c)}isActivated(c){const n=this.d.get(c);return!!(n&&n.value)}getActivatedExtension(c){const n=this.d.get(c);if(!n||!n.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return n.value}async activateByEvent(c,n){if(this.f[c])return;const i=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,n){const i=this.a.getExtensionDescription(c);if(!i)throw new Error(`Extension '${c}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(c){const n=c.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const n=this.a.getExtensionDescription(c.id);if(!n){const a=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new S(a));return this.c.onExtensionActivationError(c.id,a,new A.$1F(c.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){i.push(t);continue}if(this.l(a)){i.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:c.reason}));continue}const f=this.a.getExtensionDescription(a);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:c.reason}));continue}const l=n.displayName||n.identifier.value,s=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${a}'`),o=this.k(c,n.displayName,[],new S(s));return this.c.onExtensionActivationError(n.identifier,s,new A.$1F(a)),o}return this.k(c,n.displayName,i,null)}k(c,n,i,r){const a=new h(c.id,n,c.reason,i,r,this.c,this.g);return this.d.set(c.id,a),a}l(c){return L.$n0b.isHostExtension(c,this.a,this.b)}m(c){const n=this.b.getExtensionDescription(c);return n?!n.main&&!n.browser:!1}};e.$_ic=y,e.$_ic=y=Je([qe(3,P.$Mj)],y);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,n,i,r,a,t,f){this.c=c,this.d=n,this.f=i,this.g=r,this.h=a,this.j=t,this.k=f,this.a=new b.$fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const n=this.g[c];if(n.value&&!n.value.activationFailed){this.g.splice(c,1),c--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new S(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const n=new Error;if(c&&c.name&&(n.name=c.name),c&&c.message?n.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(n.stack=c.stack),this.h=new S(n),this.b&&u.$4(c))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};h=Je([qe(6,P.$Mj)],h)}),define(Se[300],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[301],De([1,0,240,13,39,137,109,37,25,300,139,140]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0;const w=b.$Yn.as(P.$Zn.JSONContribution);class S{constructor(a,t,f){this.a=a,this.b=t,this.c=f}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(M.default.Error,a)}warn(a){this.d(M.default.Warning,a)}info(a){this.d(M.default.Info,a)}}e.$RF=S;class y{static a(a){const t=new p.$Cm;for(let f=0,l=a.length;f<l;f++)t.add(a[f].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new y(t,[]);if(!t||!t.length)return new y([],a);const f=this.a(a),l=this.a(t),s=t.filter(d=>!f.has(d.description.identifier)),o=a.filter(d=>!l.has(d.description.identifier));return new y(s,o)}constructor(a,t){this.added=a,this.removed=t}}e.$SF=y;class h{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=y.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,L.$1)(a)}}}e.$TF=h;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$UF={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Am},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Do}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Do}},extensionKind:{description:u.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new h(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&I.$IF.register(a.extensionPoint,a.activationEventsGenerator),e.$UF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,w.registerSchema(c,e.$UF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$VF=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$Yn.add(i.ExtensionsRegistry,new n),e.$WF=b.$Yn.as(i.ExtensionsRegistry),w.registerSchema(c,e.$UF),w.registerSchema(R.$7j,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[302],De([1,0,236,18,24,301,45,4]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var E;(function(w){function S(y,h,g){if(!y)return;const c=L.$Tf(y.type)?y.type:void 0;if(!c||c.length===0){g.error(u.localize(3,null));return}const n=[];if(Array.isArray(y.required))for(const i of y.required)L.$Tf(i)&&n.push(i);return{extensionId:h.value,taskType:c,required:n,properties:y.properties?M.$Mn(y.properties):{},when:y.when?P.$ej.deserialize(y.when):void 0}}w.from=S})(E||(E={}));const R=A.$WF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,S)=>{for(const y of w)y.type&&S.push(`onTaskType:${y.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:p}});class I{constructor(){this.d=new b.$6d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,y)=>{R.setHandler((h,g)=>{this.c=void 0;try{for(const c of g.removed){const n=c.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of g.added){const n=c.value;for(const i of n){const r=E.from(i,c.description.identifier,c.collector);r&&(this.a[r.taskType]=r)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const y of this.all()){const h={type:"object",additionalProperties:!1};y.required.length>0&&(h.required=y.required.slice(0)),y.properties!==void 0?h.properties=M.$Mn(y.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[y.taskType]},S.push(h)}this.c={oneOf:S}}return this.c}}e.$lH=new I}),define(Se[303],De([1,0,237,18,23,24,45,302]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$vH=e.JsonSchemaVersion=e.ExecutionEngine=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$pH=e.ShellQuoting=e.$oH=e.$nH=e.$mH=void 0,e.$mH="settings",e.$nH=new P.$xj("taskRunning",!1,u.localize(0,null)),e.$oH=u.localize2(2,"Tasks");var p;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$pH="$customized",function(j){function N(F){if(!F)return j.Strong;switch(F.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=N}(p||(e.ShellQuoting=p={}));var E;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var R;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(R||(e.RevealKind=R={})),function(j){function N(F){switch(F.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=N}(R||(e.RevealKind=R={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function N(F){switch(F.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=N}(I||(e.RevealProblemKind=I={}));var w;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(w||(e.PanelKind=w={})),function(j){function N(F){switch(F.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=N}(w||(e.PanelKind=w={}));var S;(function(j){j.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var y;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(y||(e.RuntimeType=y={})),function(j){function N(K){switch(K.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=N;function F(K){switch(K){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=F}(y||(e.RuntimeType=y={}));var h;(function(j){function N(F){return L.$Tf(F)?F:F.value}j.value=N})(h||(e.CommandString=h={}));var g;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function N(K){return K===j.Clean._id||K===j.Build._id||K===j.Rebuild._id||K===j.Test._id}j.is=N;function F(K){if(K!==void 0)return L.$Tf(K)?N(K)?{_id:K,isDefault:!1}:void 0:K}j.from=F})(g||(e.TaskGroup=g={}));var c;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var n;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function N(F){switch(F){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var i;(function(j){j.parallel="parallel",j.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(N,F,K,ee,Y,Q){this._label="",this._id=N,F&&(this._label=F),K&&(this.type=K),this.runOptions=ee,this.configurationProperties=Y,this._source=Q}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,F=!1){if(N===void 0)return!1;if(L.$Tf(N))return N===this._label||N===this.configurationProperties.identifier||F&&N===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$qH=t;class f extends t{constructor(N,F,K,ee,Y,Q,Z,ae){super(N,K,void 0,Z,ae,F),this.command={},this._source=F,this.hasDefinedMatchers=Q,Y&&(this.command=Y)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case y.Shell:F="shell";break;case y.Process:F="process";break;case y.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(N){return N instanceof f}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$mH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let F=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(F+=this._source.kind);const K={type:e.$pH,folder:N,id:F};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Qg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new f(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$rH=f;class l extends t{constructor(N,F,K,ee,Y,Q,Z){super(N,K,ee,Q,Z,F),this._source=F,this.configures=Y}static is(N){return N instanceof l}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Qg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$mH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let F=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(F+=this._source.kind);const K={type:e.$pH,folder:N,id:F};return JSON.stringify(K)}}e.$sH=l;class s extends t{constructor(N,F,K,ee,Y,Q,Z,ae,_){super(N,K,ee,ae,_,F),this.defines=Y,this.hasDefinedMatchers=Z,this.command=Q,this.icon=_.icon,this.hide=_.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof s}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new s(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$tH=s;class o extends t{constructor(N,F,K,ee,Y,Q){super(N,K,ee,Y,Q,F),this._source=F}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new o(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$uH=o;var d;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(j){j._default=j.Terminal}(d||(e.ExecutionEngine=d={}));var m;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(m||(e.JsonSchemaVersion=m={}));class D{constructor(N){this.c=new Map;for(let F=0;F<N.length;F++)this.c.set(N[F].uri.toString(),F)}compare(N,F){const K=N.getWorkspaceFolder(),ee=F.getWorkspaceFolder();if(K&&ee){let Y=this.c.get(K.uri.toString());Y=Y===void 0?0:Y+1;let Q=this.c.get(ee.uri.toString());return Q=Q===void 0?0:Q+1,Y===Q?N._label.localeCompare(F._label):Y-Q}else return!K&&ee?-1:K&&!ee?1:0}}e.$vH=D;var $;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})($||(e.TaskEventKind=$={}));var v;(function(j){j.SingleRun="singleRun",j.Background="background"})(v||(e.TaskRunType=v={}));var k;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var C;(function(j){function N(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function F(ae,_,ge){return{...N(ae),kind:"start",terminalId:_,resolvedVariables:ge}}j.start=F;function K(ae,_,ge){return{...N(ae),kind:"processStarted",terminalId:_,processId:ge}}j.processStarted=K;function ee(ae,_,ge){return{...N(ae),kind:"processEnded",terminalId:_,exitCode:ge}}j.processEnded=ee;function Y(ae,_,ge){return{...N(ae),kind:"terminated",exitReason:ge,terminalId:_}}j.terminated=Y;function Q(ae,_,ge){return{...N(_),kind:ae,terminalId:ge}}j.general=Q;function Z(){return{kind:"changed"}}j.changed=Z})(C||(e.TaskEvent=C={}));var O;(function(j){function N(K){const ee=Object.keys(K).sort();let Y="";for(const Q of ee){let Z=K[Q];Z instanceof Object?Z=N(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),Y+=Q+","+Z+","}return Y}function F(K){const Y={_key:N(K),type:K.taskType};return Object.assign(Y,K),Y}j.create=F})(O||(e.KeyedTaskIdentifier=O={}));var B;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(B||(e.TaskSettingId=B={}));var z;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var T;(function(j){function N(F,K){const ee=b.$lH.get(F.type);if(ee===void 0){const ae=A.$Mn(F);return delete ae._key,O.create(ae)}const Y=Object.create(null);Y.type=ee.taskType;const Q=new Set;ee.required.forEach(ae=>Q.add(ae));const Z=ee.properties;for(const ae of Object.keys(Z)){const _=F[ae];if(_!=null)Y[ae]=_;else if(Q.has(ae)){const ge=Z[ae];if(ge.default!==void 0)Y[ae]=A.$Mn(ge.default);else switch(ge.type){case"boolean":Y[ae]=!1;break;case"number":case"integer":Y[ae]=0;break;case"string":Y[ae]="";break;default:K.error(u.localize(1,null,JSON.stringify(F,void 0,0),ae));return}}}return O.create(Y)}j.createTaskIdentifier=N})(T||(e.TaskDefinition=T={}))}),define(Se[304],De([1,0,13]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,b)=>{this.b=P,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,u.$1)(P))}then(P,b){return this.j().then(P,b)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$r0b=L;class M extends L{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$s0b=M}),define(Se[67],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$0v=void 0,e.$$v=M,e.$_v=A;class u{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++u.count}}e.$0v=u;const L=[];function M(b){const p=new u(b);return L[p.nid]=p,p}function A(b){return L[b].sid}class P{constructor(p){this.value=p}}e.$aw=P}),define(Se[6],De([1,0,67]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$dM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var M;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput"})(M||(e.TabInputKind=M={}));var A;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var P;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var p;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var E;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var R;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(g){return g._id=I.a++,g}}e.$dM=I;var w;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var S;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var y;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(y||(e.ExtHostTestingResource=y={})),e.$eM={MainThreadAuthentication:(0,u.$$v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$$v)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$$v)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$$v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$$v)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$$v)("MainThreadClipboard"),MainThreadCommands:(0,u.$$v)("MainThreadCommands"),MainThreadComments:(0,u.$$v)("MainThreadComments"),MainThreadConfiguration:(0,u.$$v)("MainThreadConfiguration"),MainThreadConsole:(0,u.$$v)("MainThreadConsole"),MainThreadDebugService:(0,u.$$v)("MainThreadDebugService"),MainThreadDecorations:(0,u.$$v)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$$v)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$$v)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$$v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$$v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$$v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$$v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$$v)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$$v)("MainThreadErrors"),MainThreadTreeViews:(0,u.$$v)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$$v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$$v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$$v)("MainThreadLanguages"),MainThreadLogger:(0,u.$$v)("MainThreadLogger"),MainThreadMessageService:(0,u.$$v)("MainThreadMessageService"),MainThreadOutputService:(0,u.$$v)("MainThreadOutputService"),MainThreadProgress:(0,u.$$v)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$$v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$$v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$$v)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$$v)("MainThreadSecretState"),MainThreadStorage:(0,u.$$v)("MainThreadStorage"),MainThreadSpeech:(0,u.$$v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$$v)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$$v)("MainThreadTerminalService"),MainThreadWebviews:(0,u.$$v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$$v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$$v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$$v)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$$v)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$$v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$$v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$$v)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$$v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$$v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$$v)("MainThreadExtensionService"),MainThreadSCM:(0,u.$$v)("MainThreadSCM"),MainThreadSearch:(0,u.$$v)("MainThreadSearch"),MainThreadShare:(0,u.$$v)("MainThreadShare"),MainThreadTask:(0,u.$$v)("MainThreadTask"),MainThreadWindow:(0,u.$$v)("MainThreadWindow"),MainThreadLabelService:(0,u.$$v)("MainThreadLabelService"),MainThreadNotebook:(0,u.$$v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$$v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$$v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$$v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$$v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$$v)("MainThreadInteractive"),MainThreadChat:(0,u.$$v)("MainThreadChat"),MainThreadInlineChat:(0,u.$$v)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$$v)("MainThreadTheming"),MainThreadTunnelService:(0,u.$$v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$$v)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$$v)("MainThreadTimeline"),MainThreadTesting:(0,u.$$v)("MainThreadTesting"),MainThreadLocalization:(0,u.$$v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$$v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$$v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,u.$$v)("MainThreadIssueReporter")},e.$fM={ExtHostCommands:(0,u.$$v)("ExtHostCommands"),ExtHostConfiguration:(0,u.$$v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$$v)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$$v)("ExtHostDebugService"),ExtHostDecorations:(0,u.$$v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$$v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$$v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$$v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$$v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$$v)("ExtHostEditors"),ExtHostTreeViews:(0,u.$$v)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$$v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$$v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$$v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$$v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$$v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$$v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$$v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$$v)("ExtHostStatusBar"),ExtHostShare:(0,u.$$v)("ExtHostShare"),ExtHostExtensionService:(0,u.$$v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$$v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$$v)("ExtHostTerminalService"),ExtHostSCM:(0,u.$$v)("ExtHostSCM"),ExtHostSearch:(0,u.$$v)("ExtHostSearch"),ExtHostTask:(0,u.$$v)("ExtHostTask"),ExtHostWorkspace:(0,u.$$v)("ExtHostWorkspace"),ExtHostWindow:(0,u.$$v)("ExtHostWindow"),ExtHostWebviews:(0,u.$$v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$$v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$$v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$$v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$$v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$$v)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$$v)("ExtHostProgress"),ExtHostComments:(0,u.$$v)("ExtHostComments"),ExtHostSecretState:(0,u.$$v)("ExtHostSecretState"),ExtHostStorage:(0,u.$$v)("ExtHostStorage"),ExtHostUrls:(0,u.$$v)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$$v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$$v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$$v)("ExtHostOutputService"),ExtHostLabelService:(0,u.$$v)("ExtHostLabelService"),ExtHostNotebook:(0,u.$$v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$$v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$$v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$$v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$$v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$$v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$$v)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$$v)("ExtHostInlineChatShape"),ExtHostChat:(0,u.$$v)("ExtHostChat"),ExtHostChatAgents2:(0,u.$$v)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$$v)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$$v)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$$v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$$v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$$v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$$v)("ExtHostTheming"),ExtHostTunnelService:(0,u.$$v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$$v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$$v)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$$v)("ExtHostTimeline"),ExtHostTesting:(0,u.$$v)("ExtHostTesting"),ExtHostTelemetry:(0,u.$$v)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$$v)("ExtHostLocalization"),ExtHostIssueReporter:(0,u.$$v)("ExtHostIssueReporter")}}),define(Se[91],De([1,0,5,12,6,20]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=void 0,e.$qic=(0,u.$gi)("IExtHostApiDeprecationService");let P=class{constructor(p,E){this.c=E,this.a=new Set,this.b=p.getProxy(M.$eM.MainThreadTelemetry)}report(p,E,R){const I=this.d(p,E);this.a.has(I)||(this.a.add(I),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:p}))}d(p,E){return`${p}-${E.identifier.value}`}};e.$ric=P,e.$ric=P=Je([qe(0,A.$xO),qe(1,L.$Mj)],P),e.$sic=Object.freeze(new class{report(b,p,E){}})}),define(Se[305],De([1,0,48,3,6]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class A{static{this.a=0}constructor(p,E){this.extension=p,this.provider=E,this.handle=A.a++}}class P{static{this.a=0}constructor(p){this.b=new Map,this.c=new Map,this.d=p.getProxy(M.$eM.MainThreadChat)}registerChatProvider(p,E,R){const I=new A(p,R);return this.b.set(I.handle,I),this.d.$registerChatProvider(I.handle,E),(0,L.$Rc)(()=>{this.d.$unregisterChatProvider(I.handle),this.b.delete(I.handle)})}transferChatSession(p,E){const R=u.Iterable.find(this.c.keys(),I=>this.c.get(I)===p)??0;typeof R=="number"&&this.d.$transferChatSession(R,E)}async $prepareChat(p,E){const R=this.b.get(p);if(!R)return;const I=await R.provider.prepareSession(E);if(!I)return;const w=P.a++;return this.c.set(w,I),{id:w}}$releaseSession(p){this.c.delete(p)}}e.$Dic=P}),define(Se[306],De([1,0,6]),function(fe,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class L{constructor(A){const P=A.getProxy(u.$eM.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(b){return P.$writeText(b)}})}}e.$Iic=L}),define(Se[307],De([1,0,24,6,27,20]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;let P=class{constructor(R,I){this.a=R.getProxy(L.$eM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,I){const w=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){w.e(R,I,S,arguments)}})}e(R,I,w,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:p(S,this.b)}),this.c&&this.f(R,w,S)}};e.$zkc=P,e.$zkc=P=Je([qe(0,A.$xO),qe(1,M.$NO)],P);const b=1e5;function p(E,R){const I=[];if(E.length)for(let w=0;w<E.length;w++){let S=E[w];if(typeof S>"u")S="undefined";else if(S instanceof Error){const y=S;y.stack?S=y.stack:S=y.toString()}I.push(S)}if(R){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,u.$Rn)(I);return w.length>b?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(Se[308],De([1,0,2,6,26]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;class A{constructor(b){this.a=b.getProxy(L.$eM.MainThreadDialogs)}showOpenDialog(b,p){return p?.allowUIResources&&(0,M.$4F)(b,"showLocal"),this.a.$showOpenDialog(p).then(E=>E?E.map(R=>u.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(p=>p?u.URI.revive(p):void 0)}}e.$Djc=A}),define(Se[309],De([1,0,3,6]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class M{constructor(P){this.b=0,this.a=P.getProxy(L.$eM.MainThreadLabelService)}$registerResourceLabelFormatter(P){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,P),(0,u.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Yjc=M}),define(Se[115],De([1,0,11,14,2,5,12,6,27,20]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=void 0;let R=class{constructor(w,S,y){this.f=y,this.d=new Map,this.a=S.getProxy(b.$eM.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===u.$g}getMessage(w,S){const{message:y,args:h,comment:g}=S;if(this.c)return(0,L.$Ve)(y,h??{});let c=y;g&&g.length>0&&(c+=`/${Array.isArray(g)?g.join(""):g}`);const n=this.d.get(w)?.contents[c];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,L.$Ve)(n??y,h??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let S;const y=await this.g(w);if(!y){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(y),g=JSON.parse(h);S=w.isBuiltin?g.contents?.bundle:g}catch(h){this.f.error(`Failed to load translations for ${w.identifier.value} from ${y}: ${h.message}`);return}S&&this.d.set(w.identifier.value,{contents:S,uri:y})}async g(w){if(w.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return M.URI.revive(S)}return w.l10n?M.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ljc=R,e.$ljc=R=Je([qe(0,p.$NO),qe(1,E.$xO),qe(2,P.$Mj)],R),e.$mjc=(0,A.$gi)("IExtHostLocalizationService")}),define(Se[149],De([1,0,12,6,27,20,2,56]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;let p=class extends u.$Xj{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(S=>(0,b.$Ph)(S))),this.r=I.getProxy(L.$eM.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(P.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.r.$setVisibility(I,w)}s(I,w,S){return new E(this.r,I,w,S)}};e.$ykc=p,e.$ykc=p=Je([qe(0,A.$xO),qe(1,M.$NO)],p);class E extends u.$Sj{constructor(I,w,S,y){super(y?.logLevel==="always"),this.r=I,this.s=w,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(w,y).then(()=>{this.u(this.n),this.m=!0})}g(I,w){const S=[[I,w]];this.m?this.u(S):this.n.push(...S)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[116],De([1,0,6,5,3,20,21]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0,e.$njc=(0,L.$gi)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(u.$eM.MainThreadManagedSockets)}setFactory(I,w){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,S=await this.c.makeConnection(),y=new M.$Sc;return this.d.set(w,new E(w,S,y)),y.add((0,M.$Rc)(()=>this.d.delete(w))),y.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),y.dispose()})),y.add(S.onDidClose(h=>{this.a.$onDidManagedSocketClose(w,h?.stack??h?.message),y.dispose()})),y.add(S.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(w,P.$te.wrap(h)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$ojc=b,e.$ojc=b=Je([qe(0,A.$xO)],b);class p{constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class E extends M.$Tc{constructor(I,w,S){super(),this.socketId=I,this.actual=w,this.B(S)}}}),define(Se[310],De([1,0,6,12,26]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;function A(b){return b&&b.title}let P=class{constructor(p,E){this.b=E,this.a=p.getProxy(u.$eM.MainThreadMessageService)}showMessage(p,E,R,I,w){const S={source:{identifier:p.identifier,label:p.displayName||p.name}};let y;typeof I=="string"||A(I)?y=[I,...w]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,y=w),S.useCustom&&(0,M.$4F)(p,"resolvers");const h=[];let g=!1;for(let c=0;c<y.length;c++){const n=y[c];if(typeof n=="string")h.push({title:n,handle:c,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;h.push({title:i,isCloseAffordance:!!r,handle:c}),r&&(g?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,n):g=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,R,S,h).then(c=>{if(typeof c=="number")return y[c]})}};e.$1jc=P,e.$1jc=P=Je([qe(1,L.$Mj)],P)}),define(Se[311],De([1,0,3,18,2,26,6]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(P.$eM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,R,I){if((0,A.$4F)(E,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,E.identifier.value),(0,u.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(E,R,I,w){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(R,I,w)}async $readProfile(E,R,I){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.readProfile((0,L.$Tf)(R)?R:M.URI.revive(R),I)}}e.$0jc=b}),define(Se[117],De([1,0,6,4,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=e.$ijc=void 0;class A{constructor(b){this.b=new L.$6d,this.onDidChangePassword=this.b.event,this.a=b.getProxy(u.$eM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,p){return this.a.$getPassword(b,p)}store(b,p,E){return this.a.$setPassword(b,p,E)}delete(b,p){return this.a.$deletePassword(b,p)}}e.$ijc=A,e.$jjc=(0,M.$gi)("IExtHostSecretState")}),define(Se[312],De([1,0,22,3,6]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class A{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(M.$eM.MainThreadSpeech)}async $createSpeechToTextSession(b,p,E){const R=this.c.get(b);if(!R)return;const I=new L.$Sc,w=new u.$de;this.d.set(p,w);const S=I.add(R.provideSpeechToTextSession(w.token,E?{language:E}:void 0));I.add(S.onDidChange(y=>{w.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,y)})),I.add(w.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,p){const E=this.c.get(b);if(!E)return;const R=new L.$Sc,I=new u.$de;this.d.set(p,I);const w=R.add(E.provideKeywordRecognitionSession(I.token));R.add(w.onDidChange(S=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,S)})),R.add(I.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,p,E){const R=A.a++;return this.c.set(R,E),this.b.$registerProvider(R,p,{extension:b,displayName:b.value}),(0,L.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$ekc=A}),define(Se[118],De([1,0,6,4,5]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=e.$ajc=void 0;class A{constructor(b,p){this.c=p,this.b=new L.$6d,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(u.$eM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,p){this.a.$registerExtensionStorageKeysToSync(b,p)}async initializeExtensionStorage(b,p,E){const R=await this.a.$initializeExtensionStorage(b,p);let I;return R&&(I=this.d(b,p,R)),I||E}setValue(b,p,E){return this.a.$setValue(b,p,E)}$acceptValue(b,p,E){const R=this.d(b,p,E);R&&this.b.fire({shared:b,key:p,value:R})}d(b,p,E){try{return JSON.parse(E)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${b}): ${R}`)}}}e.$ajc=A,e.$bjc=(0,M.$gi)("IExtHostStorage")}),define(Se[313],De([1,0,3,15,2,6]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class P{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(A.$eM.MainThreadUriOpeners)}registerExternalUriOpener(p,E,R,I){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const w=I.schemes.find(S=>!P.a.has(S));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(E,R),this.b.$registerUriOpener(E,I.schemes,p,I.label),(0,u.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(p,E,R){const I=this.c.get(p);if(!I)throw new Error(`Unknown opener with id: ${p}`);const w=M.URI.revive(E);return I.canOpenExternalUri(w,R)}async $openUri(p,E,R){const I=this.c.get(p);if(!I)throw new Error(`Unknown opener id: '${p}'`);return I.openExternalUri(M.URI.revive(E.resolvedUri),{sourceUri:M.URI.revive(E.sourceUri)},R)}}e.$skc=P}),define(Se[314],De([1,0,6,2,3,13,25]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class b{static{this.a=0}constructor(E){this.c=new P.$Cm,this.d=new Map,this.b=E.getProxy(u.$eM.MainThreadUrls)}registerUriHandler(E,R){const I=E.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=b.a++;return this.c.add(I),this.d.set(w,R),this.b.$registerUriHandler(w,I,E.displayName||E.name),(0,M.$Rc)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(E,R){const I=this.d.get(E);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(R))}catch(w){(0,A.$1)(w)}return Promise.resolve(void 0)}async createAppUri(E){return L.URI.revive(await this.b.$createAppUri(E))}}e.$tkc=b}),define(Se[92],De([1,0,4,3,15,24,2,244,281,113,6]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Xic=void 0,e.$Yic=w,e.$1ic=h,e.$2ic=g;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,a,t,f,l,s,o){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$6d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$6d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#o=t,this.#n=f,this.#s=l,this.#r=s,this.#l=w(s),this.#d=S(s),this.#i=o}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,E.$Yxb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===M.Schemas.https||r.scheme===M.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+E.$Xxb}return E.$Xxb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),A.$Qn(this.#o,r)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const a=(0,p.$wnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,l,s,o,d,m)=>{const D=P.URI.from({scheme:o||"file",path:decodeURIComponent(d)}),$=(0,E.$Yxb)(D,{isRemote:a,authority:t}).toString();return`${l}${$}${m}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,l,s,o,d,m)=>{const D=P.URI.from({scheme:o||"file",path:decodeURIComponent(d)}),$=(0,E.$Yxb)(D,{isRemote:a,authority:t}).toString();return`${l}${$}${m}`})}}e.$Xic=I;function w(i){try{const r=(0,b.$sp)((0,b.$rp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function S(i){try{const r=(0,b.$sp)((0,b.$rp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class y extends L.$Tc{constructor(r,a,t,f,l){super(),this.c=a,this.f=t,this.g=f,this.h=l,this.b=new Map,this.a=r.getProxy(R.$eM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const f=this.j(r);if(f){const{message:l}=(0,p.$xnb)(a,t.value);f._onMessageEmitter.fire(l)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const f=new I(r,this.a,c(a),this.c,this.f,t,this.h);this.b.set(r,f);const l=f._onDidDispose(()=>{l.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Zic=y;function h(i){return{id:i.identifier,location:i.extensionLocation}}function g(i,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||n(i,r)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>P.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),i.extensionLocation]}}),define(Se[150],De([1,0,4,6,2,15,14,5,20,26]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$vkc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(S){const y=this.d;return{get focused(){return y.focused},get active(){return(0,E.$4F)(S,"windowActivity"),y.active}}}constructor(S){this.c=new u.$6d,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=S.getProxy(L.$eM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:h})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,y){y!==this.d[S]&&(this.d={...this.d,[S]:y},this.c.fire(this.d))}openUri(S,y){let h;if(typeof S=="string"){h=S;try{S=M.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,P.$Te)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,h,y)}async asExternalUri(S,y){if((0,P.$Te)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(S,y);return M.URI.from(h)}};e.$vkc=I,e.$vkc=I=R=Je([qe(0,p.$xO)],I),e.$wkc=(0,b.$gi)("IExtHostWindow")}),define(Se[315],De([1,0,307,27,20]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;const A=1024*1024;let P=class extends u.$zkc{constructor(p,E){super(p,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(p,E,R){const I=p==="error"||p==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),E.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(p,E){const R=process[p],I=R.write;let w="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(S,y,h)=>{if(!this.g){w+=S.toString(y);const g=w.length>A?w.length:w.lastIndexOf(`
`);g!==-1&&(console[E](w.slice(0,g)),w=w.slice(g+1))}I.call(R,S,y,h)}})}};e.$$kc=P,e.$$kc=P=Je([qe(0,M.$xO),qe(1,L.$NO)],P)}),define(Se[316],De([1,0,149,15,258,30]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;class P extends u.$ykc{s(p,E,R){return p.scheme===L.Schemas.file?new M.$KP(R?.name||(0,A.$Cg)(),p.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,E):super.s(p,E,R)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$klc=P}),define(Se[317],De([1,0,8,21,22,13,4,3,133,304,67]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$v0b=e.ResponsiveState=e.RequestInitiator=void 0,e.$t0b=g,e.$u0b=c;function w(k,C){try{return JSON.stringify(k,C)}catch{return"null"}}const S="$$ref$$",y={[S]:-1};class h{constructor(C,O){this.jsonString=C,this.referencedBuffers=O}}function g(k,C=null,O=!1){const B=[];return{jsonString:(O?w:JSON.stringify)(k,(T,j)=>{if(typeof j>"u")return y;if(typeof j=="object"){if(j instanceof L.$te){const N=B.push(j)-1;return{[S]:N}}if(C)return C(T,j)}return j}),referencedBuffers:B}}function c(k,C,O){return JSON.parse(k,(B,z)=>{if(z){const T=z[S];if(typeof T=="number")return C[T];if(O&&z.$mid===1)return O.transformIncoming(z)}return z})}function n(k,C){return JSON.stringify(k,C)}function i(k){return k?(C,O)=>O&&O.$mid===1?k.transformOutgoing(O):O:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},f=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class s extends b.$Tc{static{I=f}static{this.a=3*1e3}constructor(C,O=null,B=null){super(),this[I]=!0,this.b=this.B(new P.$6d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=O,this.g=B,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,T=R.$0v.count;z<T;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$sh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const O=this.w[C];delete this.w[C],O.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+s.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+s.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,p.$ln)(C,this.g):C}getProxy(C){const{nid:O,sid:B}=C;return this.s[O]||(this.s[O]=this.J(O,B)),this.s[O]}J(C,O){const B={get:(z,T)=>(typeof T=="string"&&!z[T]&&T.charCodeAt(0)===36&&(z[T]=(...j)=>this.U(C,T,j)),T===l?O:z[T])};return new Proxy(Object.create(null),B)}set(C,O){return this.m[C.nid]=O,O}assertRegistered(C){for(let O=0,B=C.length;O<B;O++){const z=C[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(C){if(this.j)return;const O=C.byteLength,B=d.read(C,0),z=B.readUInt8(),T=B.readUInt32();switch(z){case 1:case 2:{let{rpcId:j,method:N,args:F}=D.deserializeRequestJSONArgs(B);this.g&&(F=(0,p.$ln)(F,this.g)),this.M(O,T,j,N,F,z===2);break}case 3:case 4:{let{rpcId:j,method:N,args:F}=D.deserializeRequestMixedArgs(B);this.g&&(F=(0,p.$ln)(F,this.g)),this.M(O,T,j,N,F,z===4);break}case 5:{this.f?.logIncoming(O,T,0,"ack"),this.G(T);break}case 6:{this.N(O,T);break}case 7:{this.O(O,T,void 0);break}case 9:{let j=D.deserializeReplyOKJSON(B);this.g&&(j=(0,p.$ln)(j,this.g)),this.O(O,T,j);break}case 10:{const j=D.deserializeReplyOKJSONWithBuffers(B,this.g);this.O(O,T,j);break}case 8:{const j=D.deserializeReplyOKVSBuffer(B);this.O(O,T,j);break}case 11:{let j=D.deserializeReplyErrError(B);this.g&&(j=(0,p.$ln)(j,this.g)),this.P(O,T,j);break}case 12:{this.P(O,T,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,O,B,z,T,j){this.f?.logIncoming(C,O,1,`receiveRequest ${(0,R.$_v)(B)}.${z}(`,T);const N=String(O);let F,K;if(j){const Y=new M.$de;T.push(Y.token),F=this.Q(B,z,T),K=()=>Y.cancel()}else F=this.Q(B,z,T),K=t;this.u[N]=K;const ee=D.serializeAcknowledged(O);this.f?.logOutgoing(ee.byteLength,O,1,"ack"),this.c.send(ee),F.then(Y=>{delete this.u[N];const Q=D.serializeReplyOK(O,Y,this.h);this.f?.logOutgoing(Q.byteLength,O,1,"reply:",Y),this.c.send(Q)},Y=>{delete this.u[N];const Q=D.serializeReplyErr(O,Y);this.f?.logOutgoing(Q.byteLength,O,1,"replyErr:",Y),this.c.send(Q)})}N(C,O){this.f?.logIncoming(C,O,1,"receiveCancel");const B=String(O);this.u[B]?.()}O(C,O,B){this.f?.logIncoming(C,O,0,"receiveReply:",B);const z=String(O);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z],T.resolveOk(B)}P(C,O,B){this.f?.logIncoming(C,O,0,"receiveReplyErr:",B);const z=String(O);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z];let j;B&&(B.$isError?(j=new Error,j.name=B.name,j.message=B.message,j.stack=B.stack):j=B),T.resolveErr(j)}Q(C,O,B){try{return Promise.resolve(this.S(C,O,B))}catch(z){return Promise.reject(z)}}S(C,O,B){const z=this.m[C];if(!z)throw new Error("Unknown actor "+(0,R.$_v)(C));const T=z[O];if(typeof T!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.$_v)(C));return T.apply(z,B)}U(C,O,B){if(this.j)return new E.$s0b;let z=null;if(B.length>0&&M.CancellationToken.isCancellationToken(B[B.length-1])&&(z=B.pop()),z&&z.isCancellationRequested)return Promise.reject(A.$6());const T=D.serializeRequestArguments(B,this.h),j=++this.t,N=String(j),F=new E.$r0b,K=new b.$Sc;z&&K.add(z.onCancellationRequested(()=>{const Y=D.serializeCancel(j);this.f?.logOutgoing(Y.byteLength,j,0,"cancel"),this.c.send(D.serializeCancel(j))})),this.w[N]=new o(F,K),this.F(j);const ee=D.serializeRequest(j,C,O,T,!!z);return this.f?.logOutgoing(ee.byteLength,j,0,`request: ${(0,R.$_v)(C)}.${O}(`,B),this.c.send(ee),F}}e.$v0b=s;class o{constructor(C,O){this.a=C,this.b=O}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class d{static alloc(C,O,B){const z=new d(L.$te.alloc(B+1+4),0);return z.writeUInt8(C),z.writeUInt32(O),z}static read(C,O){return new d(C,O)}get buffer(){return this.a}constructor(C,O){this.a=C,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const B=this.a.slice(this.b,this.b+C).toString();return this.b+=C,B}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+C).toString();return this.b+=C,B}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+C);return this.b+=C,O}static sizeMixedArray(C){let O=0;O+=1;for(let B=0,z=C.length;B<z;B++){const T=C[B];switch(O+=1,T.type){case 1:O+=this.sizeLongString(T.value);break;case 2:O+=this.sizeVSBuffer(T.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(T.value);for(let j=0;j<T.buffers.length;++j)O+=this.sizeVSBuffer(T.buffers[j]);break;case 4:break}}return O}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let O=0,B=C.length;O<B;O++){const z=C[O];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let T=0;T<z.buffers.length;++T)this.writeBuffer(z.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const O=new Array(C);for(let B=0;B<C;B++)switch(this.readUInt8()){case 1:O[B]=this.readLongString();break;case 2:O[B]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),j=this.readLongString(),N=[];for(let F=0;F<T;++F)N.push(this.readVSBuffer());O[B]=new R.$aw(c(j,N,null));break}case 4:O[B]=void 0;break}return O}}var m;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(m||(m={}));class D{static a(C){for(let O=0,B=C.length;O<B;O++)if(C[O]instanceof L.$te||C[O]instanceof R.$aw||typeof C[O]>"u")return!0;return!1}static serializeRequestArguments(C,O){if(this.a(C)){const B=[];for(let z=0,T=C.length;z<T;z++){const j=C[z];if(j instanceof L.$te)B[z]={type:2,value:j};else if(typeof j>"u")B[z]={type:4};else if(j instanceof R.$aw){const{jsonString:N,referencedBuffers:F}=g(j.value,O);B[z]={type:3,value:L.$te.fromString(N),buffers:F}}else B[z]={type:1,value:L.$te.fromString(n(j,O))}}return{type:1,args:B}}return{type:0,args:n(C,O)}}static serializeRequest(C,O,B,z,T){switch(z.type){case 0:return this.b(C,O,B,z.args,T);case 1:return this.c(C,O,B,z.args,T)}}static b(C,O,B,z,T){const j=L.$te.fromString(B),N=L.$te.fromString(z);let F=0;F+=d.sizeUInt8(),F+=d.sizeShortString(j),F+=d.sizeLongString(N);const K=d.alloc(T?2:1,C,F);return K.writeUInt8(O),K.writeShortString(j),K.writeLongString(N),K.buffer}static deserializeRequestJSONArgs(C){const O=C.readUInt8(),B=C.readShortString(),z=C.readLongString();return{rpcId:O,method:B,args:JSON.parse(z)}}static c(C,O,B,z,T){const j=L.$te.fromString(B);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(j),N+=d.sizeMixedArray(z);const F=d.alloc(T?4:3,C,N);return F.writeUInt8(O),F.writeShortString(j),F.writeMixedArray(z),F.buffer}static deserializeRequestMixedArgs(C){const O=C.readUInt8(),B=C.readShortString(),z=C.readMixedArray(),T=new Array(z.length);for(let j=0,N=z.length;j<N;j++){const F=z[j];typeof F=="string"?T[j]=JSON.parse(F):T[j]=F}return{rpcId:O,method:B,args:T}}static serializeAcknowledged(C){return d.alloc(5,C,0).buffer}static serializeCancel(C){return d.alloc(6,C,0).buffer}static serializeReplyOK(C,O,B){if(typeof O>"u")return this.d(C);if(O instanceof L.$te)return this.e(C,O);if(O instanceof R.$aw){const{jsonString:z,referencedBuffers:T}=g(O.value,B,!0);return this.g(C,z,T)}else return this.f(C,w(O,B))}static d(C){return d.alloc(7,C,0).buffer}static e(C,O){let B=0;B+=d.sizeVSBuffer(O);const z=d.alloc(8,C,B);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,O){const B=L.$te.fromString(O);let z=0;z+=d.sizeLongString(B);const T=d.alloc(9,C,z);return T.writeLongString(B),T.buffer}static g(C,O,B){const z=L.$te.fromString(O);let T=0;T+=d.sizeUInt32,T+=d.sizeLongString(z);for(const N of B)T+=d.sizeVSBuffer(N);const j=d.alloc(10,C,T);j.writeUInt32(B.length),j.writeLongString(z);for(const N of B)j.writeBuffer(N);return j.buffer}static deserializeReplyOKJSON(C){const O=C.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(C,O){const B=C.readUInt32(),z=C.readLongString(),T=[];for(let j=0;j<B;++j)T.push(C.readVSBuffer());return new R.$aw(c(z,T,O))}static serializeReplyErr(C,O){const B=O?w(A.$3(O),null):void 0;if(typeof B!="string")return this.h(C);const z=L.$te.fromString(B);let T=0;T+=d.sizeLongString(z);const j=d.alloc(11,C,T);return j.writeLongString(z),j.buffer}static deserializeReplyErrError(C){const O=C.readLongString();return JSON.parse(O)}static h(C){return d.alloc(12,C,0).buffer}}var $;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var v;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(v||(v={}))}),define(Se[318],De([1,0,21,28,15,83,5]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$SJ=void 0,e.$TJ=R,e.$UJ=I,e.$SJ=(0,P.$gi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${b.join("")}]+`),E=7;function R(S){if(S.scheme!==M.Schemas.vscodeNotebookCell)return;const y=S.fragment.indexOf("s");if(y<0)return;const h=parseInt(S.fragment.substring(0,y).replace(p,""),E),g=(0,u.$Me)(S.fragment.substring(y+1)).toString();if(!isNaN(h))return{handle:h,notebook:S.with({scheme:g,fragment:null})}}function I(S,y){const h=y.toString(E),c=`${h.length<b.length?b[h.length-1]:"z"}${h}s${(0,u.$Ne)(u.$te.fromString(S.scheme),!0,!0)}`;return S.with({scheme:M.Schemas.vscodeNotebookCell,fragment:c})}class w{constructor(){this.a=new L.$Ac}getNotebook(y){if(y.scheme===M.Schemas.vscodeNotebookCell){const h=R(y);if(h){const g=this.a.get(h.notebook);if(g)return g}}return this.a.get(y)}addNotebookDocument(y){this.a.set(y.uri,y)}removeNotebookDocument(y){this.a.delete(y.uri)}}e.$VJ=w,(0,A.$cs)(e.$SJ,w,1)}),define(Se[119],De([1,0,21,35,48,101,15,17,11,45,318]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$$J=e.CellStatusbarAlignment=e.$0J=e.NotebookEditorPriority=e.$7J=e.$6J=e.$4J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$3J=e.$2J=e.$1J=e.$ZJ=e.CellKind=e.$YJ=e.$XJ=e.$WJ=void 0,e.$5J=f,e.$8J=s,e.$9J=o,e.$_J=D,e.$aK=v,e.$WJ="workbench.editor.notebook",e.$XJ="workbench.editor.notebookTextDiffEditor",e.$YJ="workbench.editor.interactive";var I;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(I||(e.CellKind=I={})),e.$ZJ=["application/json","application/javascript","text/html","image/svg+xml",A.$vs.latex,A.$vs.markdown,"image/png","image/jpeg",A.$vs.text],e.$1J=[A.$vs.latex,A.$vs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$vs.text],e.$2J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$3J="_notAvailable";var w;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var S;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var y;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var h;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var g;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var c;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var n;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(F){F.scheme=P.Schemas.vscodeNotebookCell;function K(_,ge){return(0,R.$UJ)(_,ge)}F.generate=K;function ee(_){return(0,R.$TJ)(_)}F.parse=ee;function Y(_,ge){return _.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${_.scheme!==P.Schemas.file?_.scheme:""}`})}F.generateCellOutputUri=Y;function Q(_){if(_.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ge)return;const se=ge[1]&&ge[1]!==""?ge[1]:void 0,re=ge[2];return{outputId:se,notebook:_.with({scheme:re||P.Schemas.file,fragment:null})}}F.parseCellOutputUri=Q;function Z(_,ge,se){return F.generate(_,ge).with({scheme:se})}F.generateCellPropertyUri=Z;function ae(_,ge){if(_.scheme===ge)return F.parse(_.with({scheme:F.scheme}))}F.parseCellPropertyUri=ae})(r||(e.CellUri=r={}));const a=F=>p.$i?F.replace(/\//g,"\\"):F;class t{constructor(K=[],ee=e.$ZJ){this.e=ee,this.d=[...new Set(K)].map(Y=>({pattern:Y,matches:L.$ak(a(Y))}))}sort(K){const ee=new Map(M.Iterable.map(K,Q=>[Q,a(Q)]));let Y=[];for(const{matches:Q}of this.d)for(const[Z,ae]of ee)if(Q(ae)){Y.push(Z),ee.delete(Z);break}return ee.size&&(Y=Y.concat([...ee.keys()].sort((Q,Z)=>this.e.indexOf(Q)-this.e.indexOf(Z)))),Y}prioritize(K,ee){const Y=this.f(K);if(Y===-1){this.d.unshift({pattern:K,matches:L.$ak(a(K))});return}const Q=new Set(ee.map(ae=>this.f(ae,Y)));Q.delete(-1);const Z=Array.from(Q).sort();this.d.splice(Y+1,0,...Z.map(ae=>this.d[ae]));for(let ae=Z.length-1;ae>=0;ae--)this.d.splice(Z[ae],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,ee=this.d.length){const Y=a(K);for(let Q=0;Q<ee;Q++)if(this.d[Q].matches(Y))return Q;return-1}}e.$4J=t;function f(F,K,ee,Y=(Q,Z)=>Q===Z){const Q=[];function Z(ge,se,re){if(se===0&&re.length===0)return;const U=Q[Q.length-1];U&&U.start+U.deleteCount===ge?(U.deleteCount+=se,U.toInsert.push(...re)):Q.push({start:ge,deleteCount:se,toInsert:re})}let ae=0,_=0;for(;;){if(ae===F.length){Z(ae,0,K.slice(_));break}if(_===K.length){Z(ae,F.length-ae,[]);break}const ge=F[ae],se=K[_];if(Y(ge,se)){ae+=1,_+=1;continue}ee(se)?(Z(ae,1,[]),ae+=1):(Z(ae,0,[se]),_+=1)}return Q}e.$6J=new E.$xj("notebookEditorCursorAtBoundary","none"),e.$7J=new E.$xj("notebookEditorCursorAtLineBoundary","none");var l;(function(F){F.default="default",F.option="option"})(l||(e.NotebookEditorPriority=l={}));function s(F){const K=F;return!!((typeof K.include=="string"||L.$bk(K.include))&&(typeof K.exclude=="string"||L.$bk(K.exclude)))}function o(F,K,ee){if(Array.isArray(F.viewType)&&F.viewType.indexOf(K)>=0||F.viewType===K)return!0;if(F.filenamePattern){const Y=s(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Q=s(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(L.$_j(Y,(0,b.$nc)(ee.fsPath).toLowerCase()))return!(Q&&L.$_j(Q,(0,b.$nc)(ee.fsPath).toLowerCase()))}return!1}e.$0J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class m{static{this.d="notebook/"}static create(K){return`${m.d}${K}`}static parse(K){if(K.startsWith(m.d))return K.substring(m.d.length)}}e.$$J=m;function D(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const $=new TextDecoder;function v(F){const K=[];let ee=!1;for(const ae of F)(K.length===0||ee)&&(K.push(ae),ee=!0);let Y=O(K);const Q=u.$te.concat(K.map(ae=>u.$te.wrap(ae))),Z=N(Q);return Y=Y||Z.byteLength!==Q.byteLength,{data:Z,didCompression:Y}}e.$bK="\x1B[A";const k=e.$bK.split("").map(F=>F.charCodeAt(0)),C=10;function O(F){let K=!1;return F.forEach((ee,Y)=>{if(Y===0||ee.length<e.$bK.length)return;const Q=F[Y-1],Z=ee.subarray(0,e.$bK.length);if(Z[0]===k[0]&&Z[1]===k[1]&&Z[2]===k[2]){const ae=Q.lastIndexOf(C);if(ae===-1)return;K=!0,F[Y-1]=Q.subarray(0,ae),F[Y]=ee.subarray(e.$bK.length)}}),K}function B(F){let K=F;do F=K,K=F.replace(/[^\n]\x08/gm,"");while(K.length<F.length);return F}function z(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const K=F.match(/^(.*)\r+/m)[1];let ee=F.match(/\r+(.*)$/m)[1];ee=ee+K.slice(ee.length,K.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return F}const T=8,j=13;function N(F){return!F.buffer.includes(T)&&!F.buffer.includes(j)?F:u.$te.fromString(z(B($.decode(F.buffer))))}}),define(Se[7],De([1,0,19,13,79,28,101,14,18,2,30,25,32,64,119]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y){"use strict";var h,g,c,n,i,r,a,t,f,l,s,o,d,m,D,$,v;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$mO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$_N=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.TestRunProfileKind=e.TestResultState=e.$RN=e.$QN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PN=e.NotebookVariablesRequestKind=e.$ON=e.$NN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.ColorThemeKind=e.$GN=e.$FN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EN=e.$DN=e.DebugConsoleMode=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xN=e.$wN=e.FileChangeType=e.$vN=e.NewSymbolNameTag=e.$uN=e.$tN=e.$sN=e.$rN=e.InlineCompletionTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$eN=e.ConfigurationTarget=e.$dN=e.$cN=e.$bN=e.$aN=e.DocumentPasteTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6M=e.ViewBadge=e.ProgressLocation=e.$5M=e.$4M=e.TaskScope=e.ShellQuoting=e.$3M=e.$2M=e.$1M=e.TaskPanelKind=e.TaskRevealKind=e.$ZM=e.TerminalLocation=e.$YM=e.$XM=e.$WM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VM=e.$UM=e.$TM=e.$SM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MM=e.$LM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.LanguageStatusSeverity=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.CodeActionTriggerKind=e.$zM=e.$yM=e.SymbolTag=e.SymbolKind=e.$xM=e.$wM=e.DocumentHighlightKind=e.$vM=e.$uM=e.$tM=e.$sM=e.DiagnosticSeverity=e.DiagnosticTag=e.$rM=e.$qM=e.FileEditType=e.$pM=e.$oM=e.$nM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$RM=bt,e.$fN=_e;function k(G){return Object.assign(G,{apply:function(...be){if(be.length===0)return Reflect.construct(G,[]);{const Oe=be.length===1?[]:be[1];return Reflect.construct(G,Oe,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(G,[]);{const[Oe,...Ye]=be;return Reflect.construct(G,Ye,Oe.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var O;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let B=h=class{static from(...W){let be=W;return new h(function(){if(be){for(const Oe of be)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();be=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$gM=B,e.$gM=B=h=Je([k],B);let z=g=class{static Min(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Oe=1;Oe<W.length;Oe++){const Ye=W[Oe];Ye.isBefore(be)&&(be=Ye)}return be}static Max(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Oe=1;Oe<W.length;Oe++){const Ye=W[Oe];Ye.isAfter(be)&&(be=Ye)}return be}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:be,character:Oe}=W;return typeof be=="number"&&typeof Oe=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,be){if(W<0)throw(0,L.$7)("line must be non-negative");if(be<0)throw(0,L.$7)("character must be non-negative");this.c=W,this.e=be}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,be=0){if(W===null||be===null)throw(0,L.$7)();let Oe;return typeof W>"u"?Oe=0:typeof W=="number"?Oe=W:(Oe=typeof W.lineDelta=="number"?W.lineDelta:0,be=typeof W.characterDelta=="number"?W.characterDelta:0),Oe===0&&be===0?this:new g(this.line+Oe,this.character+be)}with(W,be=this.character){if(W===null||be===null)throw(0,L.$7)();let Oe;return typeof W>"u"?Oe=this.line:typeof W=="number"?Oe=W:(Oe=typeof W.line=="number"?W.line:this.line,be=typeof W.character=="number"?W.character:this.character),Oe===this.line&&be===this.character?this:new g(Oe,be)}toJSON(){return{line:this.line,character:this.character}}};e.$hM=z,e.$hM=z=g=Je([k],z);let T=c=class{static isRange(W){return W instanceof c?!0:W?z.isPosition(W.start)&&z.isPosition(W.end):!1}static of(W){if(W instanceof c)return W;if(this.isRange(W))return new c(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,be,Oe,Ye){let it,lt;if(typeof W=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(it=new z(W,be),lt=new z(Oe,Ye)):z.isPosition(W)&&z.isPosition(be)&&(it=z.of(W),lt=z.of(be)),!it||!lt)throw new Error("Invalid arguments");it.isBefore(lt)?(this.c=it,this.e=lt):(this.c=lt,this.e=it)}contains(W){return c.isRange(W)?this.contains(W.start)&&this.contains(W.end):z.isPosition(W)?!(z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const be=z.Max(W.start,this.c),Oe=z.Min(W.end,this.e);if(!be.isAfter(Oe))return new c(be,Oe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const be=z.Min(W.start,this.c),Oe=z.Max(W.end,this.end);return new c(be,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,be=this.end){if(W===null||be===null)throw(0,L.$7)();let Oe;return W?z.isPosition(W)?Oe=W:(Oe=W.start||this.start,be=W.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&be.isEqual(this.end)?this:new c(Oe,be)}toJSON(){return[this.start,this.end]}};e.$iM=T,e.$iM=T=c=Je([k],T);let j=n=class extends T{static isSelection(W){return W instanceof n?!0:W?T.isRange(W)&&z.isPosition(W.anchor)&&z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,be,Oe,Ye){let it,lt;if(typeof W=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(it=new z(W,be),lt=new z(Oe,Ye)):z.isPosition(W)&&z.isPosition(be)&&(it=z.of(W),lt=z.of(be)),!it||!lt)throw new Error("Invalid arguments");super(it,lt),this.f=it,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$jM=j,e.$jM=j=n=Je([k],j);const N=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,L.$7)("connectionToken")};class F{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be,Oe){if(typeof W!="string"||W.length===0)throw(0,L.$7)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,L.$7)("port");typeof Oe<"u"&&N(Oe),this.host=W,this.port=Math.round(be),this.connectionToken=Oe}}e.$kM=F;class K{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be){this.makeConnection=W,this.connectionToken=be,typeof be<"u"&&N(be)}}e.$lM=K;class ee extends Error{static NotAvailable(W,be){return new ee(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(W){return new ee(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,be=S.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(W),this._message=W,this._code=be,this._detail=Oe,Object.setPrototypeOf(this,ee.prototype)}}e.$mM=ee;var Y;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var Q;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let Z=i=class{static isTextEdit(W){return W instanceof i?!0:W?T.isRange(W)&&typeof W.newText=="string":!1}static replace(W,be){return new i(W,be)}static insert(W,be){return i.replace(new T(W,W),be)}static delete(W){return i.replace(W,"")}static setEndOfLine(W){const be=new i(new T(new z(0,0),new z(0,0)),"");return be.newEol=W,be}get range(){return this.c}set range(W){if(W&&!T.isRange(W))throw(0,L.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,L.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,L.$7)("newEol");this.f=W}constructor(W,be){this.c=W,this.e=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$nM=Z,e.$nM=Z=i=Je([k],Z);let ae=r=class{static isNotebookCellEdit(W){return W instanceof r?!0:W?hi.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,be){return new r(W,be)}static insertCells(W,be){return new r(new hi(W,W),be)}static deleteCells(W){return new r(W,[])}static updateCellMetadata(W,be){const Oe=new r(new hi(W,W),[]);return Oe.newCellMetadata=be,Oe}static updateNotebookMetadata(W){const be=new r(new hi(0,0),[]);return be.newNotebookMetadata=W,be}constructor(W,be){this.range=W,this.newCells=be}};e.$oM=ae,e.$oM=ae=r=Je([k],ae);class _{static isSnippetTextEdit(W){return W instanceof _?!0:W?T.isRange(W.range)&&re.isSnippetString(W.snippet):!1}static replace(W,be){return new _(W,be)}static insert(W,be){return _.replace(new T(W,W),be)}constructor(W,be){this.range=W,this.snippet=be}}e.$pM=_;var ge;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,be,Oe,Ye){this.c.push({_type:1,from:W,to:be,options:Oe,metadata:Ye})}createFile(W,be,Oe){this.c.push({_type:1,from:void 0,to:W,options:be,metadata:Oe})}deleteFile(W,be,Oe){this.c.push({_type:1,from:W,to:void 0,options:be,metadata:Oe})}e(W,be,Oe){this.c.push({_type:3,metadata:Oe,uri:W,edit:{editType:5,metadata:be},notebookMetadata:be})}f(W,be,Oe,Ye){const it=be.start,lt=be.end;(it!==lt||Oe.length>0)&&this.c.push({_type:5,uri:W,index:it,count:lt-it,cells:Oe,metadata:Ye})}g(W,be,Oe,Ye){this.c.push({_type:3,metadata:Ye,uri:W,edit:{editType:3,index:be,metadata:Oe}})}replace(W,be,Oe,Ye){this.c.push({_type:2,uri:W,edit:new Z(be,Oe),metadata:Ye})}insert(W,be,Oe,Ye){this.replace(W,new T(be,be),Oe,Ye)}delete(W,be,Oe){this.replace(W,be,"",Oe)}has(W){return this.c.some(be=>be._type===2&&be.uri.toString()===W.toString())}set(W,be){if(be)for(const Oe of be){if(!Oe)continue;let Ye,it;Array.isArray(Oe)?(Ye=Oe[0],it=Oe[1]):Ye=Oe,ae.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(W,Ye.range.start,Ye.newCellMetadata,it):Ye.newNotebookMetadata?this.e(W,Ye.newNotebookMetadata,it):this.f(W,Ye.range,Ye.newCells,it):_.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:W,range:Ye.range,edit:Ye.snippet,metadata:it}):this.c.push({_type:2,uri:W,edit:Ye,metadata:it})}else{for(let Oe=0;Oe<this.c.length;Oe++){const Ye=this.c[Oe];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===W.toString()&&(this.c[Oe]=void 0);break}}(0,u.$Ib)(this.c)}}get(W){const be=[];for(const Oe of this.c)Oe._type===2&&Oe.uri.toString()===W.toString()&&be.push(Oe.edit);return be}entries(){const W=new A.$Ac;for(const be of this.c)if(be._type===2){let Oe=W.get(be.uri);Oe||(Oe=[be.uri,[]],W.set(be.uri,Oe)),Oe[1].push(be.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$qM=se,e.$qM=se=Je([k],se);let re=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=a.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,be=this.e++){if(typeof W=="function"){const Oe=new a;Oe.e=this.e,W(Oe),this.e=Oe.e,W=Oe.value}else W=a.c(W);return this.value+="${",this.value+=be,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,be=this.e++){const Oe=W.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(W,be){if(typeof be=="function"){const Oe=new a;Oe.e=this.e,be(Oe),this.e=Oe.e,be=Oe.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.$rM=re,e.$rM=re=a=Je([k],re);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ie;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ye=t=class{static isLocation(W){return W instanceof t?!0:W?T.isRange(W.range)&&E.URI.isUri(W.uri):!1}constructor(W,be){if(this.uri=W,be)if(T.isRange(be))this.range=T.of(be);else if(z.isPosition(be))this.range=new T(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$sM=ye,e.$sM=ye=t=Je([k],ye);let le=class{static is(W){return W?typeof W.message=="string"&&W.location&&T.isRange(W.location.range)&&E.URI.isUri(W.location.uri):!1}constructor(W,be){this.location=W,this.message=be}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.location.range.isEqual(be.location.range)&&W.location.uri.toString()===be.location.uri.toString()}};e.$tM=le,e.$tM=le=Je([k],le);let ue=class{constructor(W,be,Oe=ie.Error){if(!T.isRange(W))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=W,this.message=be,this.severity=Oe}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.severity===be.severity&&W.code===be.code&&W.severity===be.severity&&W.source===be.source&&W.range.isEqual(be.range)&&(0,u.$ub)(W.tags,be.tags)&&(0,u.$ub)(W.relatedInformation,be.relatedInformation,le.isEqual)}};e.$uM=ue,e.$uM=ue=Je([k],ue);let ce=class{constructor(W,be){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=be}};e.$vM=ce,e.$vM=ce=Je([k],ce);var de;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let H=class{constructor(W,be=de.Text){this.range=W,this.kind=be}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$wM=H,e.$wM=H=Je([k],H);let x=class{constructor(W,be){this.uri=W,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map(W=>W.toJSON())}}};e.$xM=x,e.$xM=x=Je([k],x);var he;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var pe;(function(G){G[G.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Ae=f=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,be,Oe,Ye,it){this.name=W,this.kind=be,this.containerName=it,typeof Oe=="string"&&(this.containerName=Oe),Ye instanceof ye?this.location=Ye:Oe instanceof T&&(this.location=new ye(Ye,Oe)),f.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$yM=Ae,e.$yM=Ae=f=Je([k],Ae);let we=l=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(l.validate)}constructor(W,be,Oe,Ye,it){this.name=W,this.detail=be,this.kind=Oe,this.range=Ye,this.selectionRange=it,this.children=[],l.validate(this)}};e.$zM=we,e.$zM=we=l=Je([k],we);var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Fe=class{constructor(W,be){this.title=W,this.kind=be}};e.$AM=Fe,e.$AM=Fe=Je([k],Fe);let ze=class{static{s=this}static{this.c="."}constructor(W){this.value=W}append(W){return new s(this.value?this.value+s.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+s.c)}};e.$BM=ze,e.$BM=ze=s=Je([k],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let q=class{constructor(W,be){if(this.range=W,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CM=q,e.$CM=q=Je([k],q);class V{constructor(W,be,Oe,Ye,it,lt){this.kind=W,this.name=be,this.detail=Oe,this.uri=Ye,this.range=it,this.selectionRange=lt}}e.$DM=V;class J{constructor(W,be){this.fromRanges=be,this.from=W}}e.$EM=J;class X{constructor(W,be){this.fromRanges=be,this.to=W}}e.$FM=X;var me;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(me||(e.LanguageStatusSeverity=me={}));let ve=class{constructor(W,be){this.range=W,this.command=be}get isResolved(){return!!this.command}};e.$GM=ve,e.$GM=ve=Je([k],ve);let Te=o=class{#e;static isMarkdownString(W){return W instanceof o?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,be=!1){this.#e=new M.$Dk(W,{supportThemeIcons:be})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,be){return this.#e.appendCodeblock(be??"",W),this}};e.$HM=Te,e.$HM=Te=o=Je([k],Te);let He=class{constructor(W,be){this.label=W,this.documentation=be}};e.$IM=He,e.$IM=He=Je([k],He);let Ze=class{constructor(W,be){this.label=W,this.documentation=be,this.parameters=[]}};e.$JM=Ze,e.$JM=Ze=Je([k],Ze);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KM=tt,e.$KM=tt=Je([k],tt);var nt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var at;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let rt=class{constructor(W){this.value=W}};e.$LM=rt,e.$LM=rt=Je([k],rt);let Ce=class{constructor(W,be,Oe){this.position=W,this.label=be,this.kind=Oe}};e.$MM=Ce,e.$MM=Ce=Je([k],Ce);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Me;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Me||(e.CompletionItemKind=Me={}));var Ke;(function(G){G[G.Deprecated=1]="Deprecated"})(Ke||(e.CompletionItemTag=Ke={}));let ne=class{constructor(W,be){this.label=W,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NM=ne,e.$NM=ne=Je([k],ne);let oe=class{constructor(W=[],be=!1){this.items=W,this.isIncomplete=be}};e.$OM=oe,e.$OM=oe=Je([k],oe);let Ie=class{constructor(W,be,Oe){this.insertText=W,this.range=be,this.command=Oe}};e.$PM=Ie,e.$PM=Ie=Je([k],Ie);let Ge=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$QM=Ge,e.$QM=Ge=Je([k],Ge);var xe;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(xe||(e.PartialAcceptTriggerKind=xe={}));var st;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var Le;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Le||(e.StatusBarAlignment=Le={}));function bt(G,W){return`${I.$Bm.toKey(G)}.${W}`}var St;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(St||(e.TextEditorLineNumbersStyle=St={}));var It;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var Vt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var qt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(qt||(e.TextEditorSelectionChangeKind=qt={}));var Ct;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Ct||(e.TextDocumentChangeReason=Ct={}));var _t;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(_t||(e.DecorationRangeBehavior=_t={})),function(G){function W(be){switch(be){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(qt||(e.TextEditorSelectionChangeKind=qt={}));var Ht;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Ht||(e.SyntaxTokenType=Ht={})),function(G){function W(be){switch(be){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=W}(Ht||(e.SyntaxTokenType=Ht={}));let si=class{constructor(W,be){if(be&&!E.URI.isUri(be))throw(0,L.$7)("target");if(!T.isRange(W)||W.isEmpty)throw(0,L.$7)("range");this.range=W,this.target=be}};e.$SM=si,e.$SM=si=Je([k],si);let ei=class{constructor(W,be,Oe,Ye){this.red=W,this.green=be,this.blue=Oe,this.alpha=Ye}};e.$TM=ei,e.$TM=ei=Je([k],ei);let et=class{constructor(W,be){if(be&&!(be instanceof ei))throw(0,L.$7)("color");if(!T.isRange(W)||W.isEmpty)throw(0,L.$7)("range");this.range=W,this.color=be}};e.$UM=et,e.$UM=et=Je([k],et);let Lt=class{constructor(W){if(!W||typeof W!="string")throw(0,L.$7)("label");this.label=W}};e.$VM=Lt,e.$VM=Lt=Je([k],Lt);var ti;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var dt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var $t;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})($t||(e.TerminalExitReason=$t={}));class ii{constructor(W,be,Oe){if(this.startIndex=W,this.length=be,this.tooltip=Oe,typeof W!="number"||W<0)throw(0,L.$7)("startIndex");if(typeof be!="number"||be<1)throw(0,L.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,L.$7)("tooltip")}}e.$WM=ii;class Kt{constructor(W){this.uri=W}}e.$XM=Kt;class Gt{constructor(W){this.terminalCommand=W}}e.$YM=Gt;var ht;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(ht||(e.TerminalLocation=ht={}));class Ot{constructor(W){if(this.options=W,typeof W!="object")throw(0,L.$7)("options")}}e.$ZM=Ot;var ni;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(ni||(e.TaskRevealKind=ni={}));var ri;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(ri||(e.TaskPanelKind=ri={}));let Xe=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(W,be){if(this.label=be,typeof W!="string"||typeof be!="string")throw(0,L.$7)("name");this.c=W}get id(){return this.c}};e.$1M=Xe,e.$1M=Xe=d=Je([k],Xe);function Nt(G){let W="";for(let be=0;be<G.length;be++)W+=G[be].replace(/,/g,",,")+",";return W}let Bt=class{constructor(W,be,Oe){if(typeof W!="string")throw(0,L.$7)("process");this.e=[],this.c=W,be!==void 0&&(Array.isArray(be)?(this.e=be,this.f=Oe):this.f=be)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,L.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const be of this.e)W.push(be);return Nt(W)}};e.$2M=Bt,e.$2M=Bt=Je([k],Bt);let Zt=class{constructor(W,be,Oe){if(this.f=[],Array.isArray(be)){if(!W)throw(0,L.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.$7)("command");this.e=W,this.f=be,this.g=Oe}else{if(typeof W!="string")throw(0,L.$7)("commandLine");this.c=W,this.g=be}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,L.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const be of this.f)W.push(typeof be=="string"?be:be.value);return Nt(W)}};e.$3M=Zt,e.$3M=Zt=Je([k],Zt);var mt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(mt||(e.ShellQuoting=mt={}));var At;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(At||(e.TaskScope=At={}));class Pt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$Cg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$4M=Pt;let Tt=class{static{m=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,be,Oe,Ye,it,lt){this.k=!1,this.l=this.definition=W;let gt;typeof be=="string"?(this.o=this.name=be,this.w=this.source=Oe,this.execution=Ye,gt=it,this.k=!0):be===At.Global||be===At.Workspace?(this.target=be,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=it,gt=lt):(this.target=be,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=it,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(W){this.j=W}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:m.e,id:this.q.computeId()}:this.q instanceof Zt?this.l={type:m.f,id:this.q.computeId()}:this.q instanceof Pt?this.l={type:m.c,id:this.q.computeId()}:this.l={type:m.g,id:(0,R.$Cg)()}}get definition(){return this.l}set definition(W){if(W==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=W}get scope(){return this.m}set target(W){this.B(),this.m=W}get name(){return this.o}set name(W){if(typeof W!="string")throw(0,L.$7)("name");this.B(),this.o=W}get execution(){return this.q}set execution(W){W===null&&(W=void 0),this.B(),this.q=W;const be=this.l.type;(m.g===be||m.e===be||m.f===be||m.c===be)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(W){if(Array.isArray(W))this.B(),this.r=W,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.B(),this.u=W}get source(){return this.w}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=W}get group(){return this.x}set group(W){W===null&&(W=void 0),this.B(),this.x=W}get detail(){return this.A}set detail(W){W===null&&(W=void 0),this.A=W}get presentationOptions(){return this.y}set presentationOptions(W){W==null&&(W=Object.create(null)),this.B(),this.y=W}get runOptions(){return this.z}set runOptions(W){W==null&&(W=Object.create(null)),this.B(),this.z=W}};e.$5M=Tt,e.$5M=Tt=m=Je([k],Tt);var oi;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var Ut;(function(G){function W(be){const Oe=be;return(0,p.$Xf)(Oe.value)?Oe.tooltip&&!(0,p.$Tf)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}G.isViewBadge=W})(Ut||(e.ViewBadge=Ut={}));let xt=D=class{static isTreeItem(W,be){const Oe=W;if(Oe.checkboxState!==void 0){const Ye=(0,p.$Xf)(Oe.checkboxState)?Oe.checkboxState:(0,p.$Vf)(Oe.checkboxState)&&(0,p.$Xf)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,it=!(0,p.$Xf)(Oe.checkboxState)&&(0,p.$Vf)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Ft.Checked&&Ye!==Ft.Unchecked||it!==void 0&&!(0,p.$Tf)(it))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(W instanceof D)return!0;if(Oe.label!==void 0&&!(0,p.$Tf)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,p.$Tf)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,p.$Tf)(Oe.iconPath)&&!E.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,p.$Tf)(Oe.iconPath.id))){const Ye=Oe.iconPath;if(!Ye||!(0,p.$Tf)(Ye.light)&&!E.URI.isUri(Ye.light)&&!(0,p.$Tf)(Ye.dark)&&!E.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,p.$Tf)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!E.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,p.$Tf)(Oe.tooltip)&&!(Oe.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<vt.None&&Oe.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,p.$Tf)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(W,be=vt.None){this.collapsibleState=be,E.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$6M=xt,e.$6M=xt=D=Je([k],xt);var vt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Ft;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Ft||(e.TreeItemCheckboxState=Ft={}));let Wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$7M=Wt,e.$7M=Wt=Je([k],Wt);class zt extends Wt{}e.$8M=zt;class yt extends zt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$9M=yt;class Mt{constructor(W,be,Oe,Ye){this.name=W,this.uri=be,this._itemId=Oe,this.c=Ye}data(){return this.c()}}e.$0M=Mt;let Et=class{#e=new Map;constructor(W){for(const[be,Oe]of W??[]){const Ye=this.#e.get(this.#t(be));Ye?Ye.push(Oe):this.#e.set(this.#t(be),[Oe])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,be){this.#e.set(this.#t(W),[be])}forEach(W,be){for(const[Oe,Ye]of this.#e)for(const it of Ye)W.call(be,it,Oe,this)}*[Symbol.iterator](){for(const[W,be]of this.#e)for(const Oe of be)yield[W,Oe]}#t(W){return W.toLowerCase()}};e.$$M=Et,e.$$M=Et=Je([k],Et);let li=class{constructor(W,be,Oe){this.insertText=W,this.title=be,this.kind=Oe}};e.$_M=li,e.$_M=li=Je([k],li);var Qt;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(Qt||(e.DocumentPasteTriggerKind=Qt={}));class ci{static{this.c="."}constructor(W){this.value=W}append(...W){return new ci((this.value?[this.value,...W]:W).join(ci.c))}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+ci.c)}}e.$aN=ci,ci.Empty=new ci("");let Re=class{constructor(W,be,Oe){this.title=be,this.insertText=W,this.kind=Oe}};e.$bN=Re,e.$bN=Re=Je([k],Re);let Ne=class{constructor(W,be){this.id=W,this.color=be}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$cN=Ne,e.$cN=Ne=Je([k],Ne),Ne.File=new Ne("file"),Ne.Folder=new Ne("folder");let ke=class{constructor(W){this.id=W}};e.$dN=ke,e.$dN=ke=Je([k],ke);var te;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(te||(e.ConfigurationTarget=te={}));let je=class{get base(){return this.c}set base(W){this.c=W,this.e=E.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,be){if(typeof W!="string"&&(!W||!E.URI.isUri(W)&&!E.URI.isUri(W.uri)))throw(0,L.$7)("base");if(typeof be!="string")throw(0,L.$7)("pattern");typeof W=="string"?this.baseUri=E.URI.file(W):E.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eN=je,e.$eN=je=Je([k],je);const Ue=new WeakMap;function _e(G,W){Ue.set(G,W)}let Qe=class{constructor(W,be,Oe,Ye,it){this.enabled=typeof W=="boolean"?W:!0,typeof be=="string"&&(this.condition=be),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Ye=="string"&&(this.logMessage=Ye),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Ue.get(this)??(0,R.$Cg)()),this.c}};e.$gN=Qe,e.$gN=Qe=Je([k],Qe);let ut=class extends Qe{constructor(W,be,Oe,Ye,it,lt){if(super(be,Oe,Ye,it,lt),W===null)throw(0,L.$7)("location");this.location=W}};e.$hN=ut,e.$hN=ut=Je([k],ut);let kt=class extends Qe{constructor(W,be,Oe,Ye,it,lt){super(be,Oe,Ye,it,lt),this.functionName=W}};e.$iN=kt,e.$iN=kt=Je([k],kt);let Jt=class extends Qe{constructor(W,be,Oe,Ye,it,lt,gt,Xt){if(super(Ye,it,lt,gt,Xt),!be)throw(0,L.$7)("dataId");this.label=W,this.dataId=be,this.canPersist=Oe}};e.$jN=Jt,e.$jN=Jt=Je([k],Jt);let Dt=class{constructor(W,be,Oe){this.command=W,this.args=be||[],this.options=Oe}};e.$kN=Dt,e.$kN=Dt=Je([k],Dt);let Rt=class{constructor(W,be){this.port=W,this.host=be}};e.$lN=Rt,e.$lN=Rt=Je([k],Rt);let Yt=class{constructor(W){this.path=W}};e.$mN=Yt,e.$mN=Yt=Je([k],Yt);let bi=class{constructor(W){this.implementation=W}};e.$nN=bi,e.$nN=bi=Je([k],bi);class yi{constructor(W,be,Oe){this.session=W,this.threadId=be,this.frameId=Oe}}e.$oN=yi;class ft{constructor(W,be){this.session=W,this.threadId=be}}e.$pN=ft;let Mi=class{constructor(W,be){this.range=W,this.expression=be}};e.$qN=Mi,e.$qN=Mi=Je([k],Mi);var fi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(fi||(e.InlineCompletionTriggerKind=fi={}));let $i=class{constructor(W,be){this.range=W,this.text=be}};e.$rN=$i,e.$rN=$i=Je([k],$i);let ki=class{constructor(W,be,Oe=!0){this.range=W,this.variableName=be,this.caseSensitiveLookup=Oe}};e.$sN=ki,e.$sN=ki=Je([k],ki);let Ri=class{constructor(W,be){this.range=W,this.expression=be}};e.$tN=Ri,e.$tN=Ri=Je([k],Ri);let Oi=class{constructor(W,be){this.frameId=W,this.stoppedLocation=be}};e.$uN=Oi,e.$uN=Oi=Je([k],Oi);var Ji;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Ji||(e.NewSymbolNameTag=Ji={}));class Xi{constructor(W,be){this.newSymbolName=W,this.tags=be}}e.$vN=Xi;var Qi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ei=$=class extends Error{static FileExists(W){return new $(W,w.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,w.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,w.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,w.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,w.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,w.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,be=w.FileSystemProviderErrorCode.Unknown,Oe){super(E.URI.isUri(W)?W.toString(!0):W),this.code=Oe?.name??"Unknown",(0,w.$2k)(this,be),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$wN=Ei,e.$wN=Ei=$=Je([k],Ei);let ji=class{constructor(W,be,Oe){this.start=W,this.end=be,this.kind=Oe}};e.$xN=ji,e.$xN=ji=Je([k],ji);var Si;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Si||(e.FoldingRangeKind=Si={}));var Di;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Di||(e.CommentThreadCollapsibleState=Di={}));var Yi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Zi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var wi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class ln{constructor(W,be=[]){this.tokenTypes=W,this.tokenModifiers=be}}e.$yN=ln;function hn(G){return typeof G>"u"||(0,p.$Uf)(G)}class Fi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,W){this.m=!0;for(let be=0,Oe=W.tokenTypes.length;be<Oe;be++)this.k.set(W.tokenTypes[be],be);for(let be=0,Oe=W.tokenModifiers.length;be<Oe;be++)this.l.set(W.tokenModifiers[be],be)}}push(W,be,Oe,Ye,it){if(typeof W=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(W,be,Oe,Ye,it);if(T.isRange(W)&&typeof be=="string"&&hn(Oe))return this.o(W,be,Oe);throw(0,L.$7)()}o(W,be,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(be))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,it=W.start.character,lt=W.end.character-W.start.character,gt=this.k.get(be);let Xt=0;if(Oe)for(const ui of Oe){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ui);Xt|=1<<di>>>0}this.q(Ye,it,lt,gt,Xt)}q(W,be,Oe,Ye,it){if(this.f&&(W<this.c||W===this.c&&be<this.e)){this.f=!1;const Xt=this.g.length/5|0;let ui=0,di=0;for(let mi=0;mi<Xt;mi++){let pi=this.g[5*mi],Ki=this.g[5*mi+1];pi===0?(pi=ui,Ki+=di):pi+=ui,this.g[5*mi]=pi,this.g[5*mi+1]=Ki,ui=pi,di=Ki}}let lt=W,gt=be;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=Oe,this.g[this.j++]=Ye,this.g[this.j++]=it,this.c=W,this.e=be}static r(W){const be=[],Oe=W.length/5|0;for(let gt=0;gt<Oe;gt++)be[gt]=gt;be.sort((gt,Xt)=>{const ui=W[5*gt],di=W[5*Xt];if(ui===di){const mi=W[5*gt+1],pi=W[5*Xt+1];return mi-pi}return ui-di});const Ye=new Uint32Array(W.length);let it=0,lt=0;for(let gt=0;gt<Oe;gt++){const Xt=5*be[gt],ui=W[Xt+0],di=W[Xt+1],mi=W[Xt+2],pi=W[Xt+3],Ki=W[Xt+4],Rn=ui-it,ir=Rn===0?di-lt:di,Gi=5*gt;Ye[Gi+0]=Rn,Ye[Gi+1]=ir,Ye[Gi+2]=mi,Ye[Gi+3]=pi,Ye[Gi+4]=Ki,it=ui,lt=di}return Ye}build(W){return this.f?new Li(new Uint32Array(this.g),W):new Li(Fi.r(this.g),W)}}e.$zN=Fi;class Li{constructor(W,be){this.resultId=be,this.data=W}}e.$AN=Li;class dn{constructor(W,be,Oe){this.start=W,this.deleteCount=be,this.data=Oe}}e.$BN=dn;class xi{constructor(W,be){this.resultId=be,this.edits=W}}e.$CN=xi;var Ni;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Ni||(e.DebugConsoleMode=Ni={}));class fn{constructor(W){this.name=W}}e.$DN=fn;let Ci=class{static{this.Back={iconPath:new Ne("arrow-left")}}constructor(){}};e.$EN=Ci,e.$EN=Ci=Je([k],Ci);var Ti;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ti||(e.QuickPickItemKind=Ti={}));var _i;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var en;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(en||(e.ExtensionKind=en={}));class gn{static validate(W){if(typeof W.badge=="string"){let be=(0,b.$uf)(W.badge,0);if(be<W.badge.length&&(be+=(0,b.$uf)(W.badge,be)),W.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ne.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,be,Oe){this.badge=W,this.tooltip=be,this.color=Oe}}e.$FN=gn;let zi=class{constructor(W){this.kind=W}};e.$GN=zi,e.$GN=zi=Je([k],zi);var Ii;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Ii||(e.ColorThemeKind=Ii={}));class hi{static isNotebookRange(W){return W instanceof hi?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,be){if(W<0)throw(0,L.$7)("start must be positive");if(be<0)throw(0,L.$7)("end must be positive");W<=be?(this.c=W,this.e=be):(this.c=be,this.e=W)}with(W){let be=this.c,Oe=this.e;return W.start!==void 0&&(be=W.start),W.end!==void 0&&(Oe=W.end),be===this.c&&Oe===this.e?this:new hi(be,Oe)}}e.$HN=hi;class We{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(be=>We.isNotebookCellData(be))}static isNotebookCellData(W){return!0}constructor(W,be,Oe,Ye,it,lt,gt){this.kind=W,this.value=be,this.languageId=Oe,this.mime=Ye,this.outputs=it??[],this.metadata=lt,this.executionSummary=gt,We.validate(this)}}e.$IN=We;class gi{constructor(W){this.cells=W}}e.$JN=gi;class ai{static isNotebookCellOutputItem(W){return W instanceof ai?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const be={name:W.name,message:W.message,stack:W.stack};return ai.json(be,"application/vnd.code.notebook.error")}static stdout(W){return ai.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return ai.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,be="application/octet-stream"){return new ai(W,be)}static#e=new TextEncoder;static text(W,be=P.$vs.text){const Oe=ai.#e.encode(String(W));return new ai(Oe,be)}static json(W,be="text/x-json"){const Oe=JSON.stringify(W,void 0,"	");return ai.text(Oe,be)}constructor(W,be){this.data=W,this.mime=be;const Oe=(0,P.$zs)(be,!0);if(!Oe)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$KN=ai;class ot{static isNotebookCellOutput(W){return W instanceof ot?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,be=!1){const Oe=new Set,Ye=new Set;for(let it=0;it<W.length;it++){const lt=W[it],gt=(0,P.$zs)(lt.mime);if(!Oe.has(gt)||(0,y.$_J)(gt)){Oe.add(gt);continue}Ye.add(it),be&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?W:W.filter((it,lt)=>!Ye.has(lt))}constructor(W,be,Oe){this.items=ot.ensureUniqueMimeTypes(W,!0),typeof be=="string"?(this.id=be,this.metadata=Oe):(this.id=(0,R.$Cg)(),this.metadata=be??Oe)}}e.$LN=ot;var pt;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(pt||(e.NotebookCellKind=pt={}));var tn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Bi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Bi||(e.NotebookEditorRevealType=Bi={}));class mn{constructor(W,be){this.text=W,this.alignment=be}}e.$MN=mn;var vi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(vi||(e.NotebookControllerAffinity=vi={}));var rn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class $n{constructor(W,be=[]){this.uri=W,this.provides=(0,u.$3b)(be)}}e.$NN=$n;class pn{constructor(W){this.label=W}}e.$ON=pn;var Ui;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(Ui||(e.NotebookVariablesRequestKind=Ui={}));let Wi=class{constructor(W,be){this.label=W,this.timestamp=be}};e.$PN=Wi,e.$PN=Wi=Je([k],Wi);var sn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(sn||(e.ExtensionMode=sn={}));var on;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(on||(e.ExtensionRuntime=on={}));var an;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class bn{constructor(W,be){this.ranges=W,this.wordPattern=be}}e.$QN=bn;class wn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$RN=wn;var cn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Vi=class{constructor(W=void 0,be=void 0,Oe=void 0,Ye=!1){this.include=W,this.exclude=be,this.profile=Oe,this.continuous=Ye}};e.$SN=Vi,e.$SN=Vi=Je([k],Vi);let qi=v=class{static diff(W,be,Oe){const Ye=new v(W);return Ye.expectedOutput=be,Ye.actualOutput=Oe,Ye}constructor(W){this.message=W}};e.$TN=qi,e.$TN=qi=v=Je([k],qi);let Hi=class{constructor(W){this.id=W}};e.$UN=Hi,e.$UN=Hi=Je([k],Hi);class $e{constructor(W,be){this.covered=W,this.total=be}}e.$VN=$e;const Ee=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class Ve{static fromDetails(W,be){const Oe=new $e(0,0),Ye=new $e(0,0),it=new $e(0,0);for(const gt of be)if("branches"in gt){Oe.total+=1,Oe.covered+=gt.executed?1:0;for(const Xt of gt.branches)Ye.total+=1,Ye.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=gt.executed?1:0;const lt=new Ve(W,Oe,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return lt.detailedCoverage=be,lt}constructor(W,be,Oe,Ye){this.uri=W,this.statementCoverage=be,this.branchCoverage=Oe,this.declarationCoverage=Ye,Ee(be),Ee(Oe),Ee(Ye)}}e.$WN=Ve;class ct{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,be,Oe=[]){this.executed=W,this.location=be,this.branches=Oe}}e.$XN=ct;class wt{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,be,Oe){this.executed=W,this.location=be,this.label=Oe}}e.$YN=wt;class jt{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,be,Oe){this.name=W,this.executed=be,this.location=Oe}}e.$ZN=jt;var Ai;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Ai||(e.ExternalUriOpenerPriority=Ai={}));var vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var yn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn||(e.PortAutoForwardAction=yn={}));class On{constructor(W,be,Oe,Ye,it,lt){this.kind=W,this.name=be,this.detail=Oe,this.uri=Ye,this.range=it,this.selectionRange=lt}}e.$1N=On;class jn{constructor(W){this.uri=W}}e.$2N=jn;class Fn{constructor(W,be){this.original=W,this.modified=be}}e.$3N=Fn;class Ln{constructor(W,be,Oe,Ye){this.base=W,this.input1=be,this.input2=Oe,this.result=Ye}}e.$4N=Ln;class Nn{constructor(W,be){this.uri=W,this.viewType=be}}e.$5N=Nn;class Tn{constructor(W){this.viewType=W}}e.$6N=Tn;class zn{constructor(W,be){this.uri=W,this.notebookType=be}}e.$7N=zn;class Bn{constructor(W,be,Oe){this.original=W,this.modified=be,this.notebookType=Oe}}e.$8N=Bn;class Un{constructor(){}}e.$9N=Un;class Wn{constructor(W,be){this.uri=W,this.inputBoxUri=be}}e.$0N=Wn;class Vn{constructor(W){this.providerId=W}}e.$$N=Vn;var kn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var En;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var Sn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class qn{constructor(W,be){this.label=W,this.values=be}}e.$_N=qn;var Dn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Cn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Hn{constructor(W){this.value=typeof W=="string"?new Te(W):W}}e.$aO=Hn;class Kn{constructor(W,be){this.value=W,this.baseUri=be}}e.$bO=Kn;class Gn{constructor(W,be){this.value=W,this.title=be}}e.$cO=Gn;class Jn{constructor(W){this.value=W}}e.$dO=Jn;class Xn{constructor(W){this.value=W}}e.$eO=Xn;class Qn{constructor(W){this.value=W}}e.$fO=Qn;class Yn{constructor(W,be,Oe,Ye){this.prompt=W,this.command=be,this.variables=Oe,this.participant=Ye}}e.$gO=Yn;class Zn{constructor(W,be,Oe,Ye){this.response=W,this.result=be,this.participant=Oe,this.command=Ye}}e.$hO=Zn;class xn{constructor(W){this.content=W}}e.$iO=xn;class _n{constructor(W,be){this.content=W,this.name=be}}e.$jO=_n;class er{constructor(W){this.content=W}}e.$kO=er;class Pi extends Error{static NotFound(W){return new Pi(W,Pi.NotFound.name)}static NoPermissions(W){return new Pi(W,Pi.NoPermissions.name)}constructor(W,be,Oe){super(W,{cause:Oe}),this.name="LanguageModelError",this.code=be??""}}e.$lO=Pi;var In;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(In||(e.RelatedInformationType=In={}));var An;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(An||(e.SpeechToTextStatus=An={}));var Pn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Pn||(e.KeywordRecognitionStatus=Pn={}));class tr{constructor(W,be){this.text=W,this.range=be}}e.$mO=tr;var Mn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Mn||(e.InlineEditTriggerKind=Mn={}))}),define(Se[319],De([1,0,6,7]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class M{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(u.$eM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(P,b,p){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(P);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,p)??[]}getRelatedInformation(P,b,p){return this.c.$getAiRelatedInformation(b,p)}registerRelatedInformationProvider(P,b,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiRelatedInformationProvider(E,b),new L.$gM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$pic=M}),define(Se[120],De([1,0,4,6,7,25,145,5,20]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=void 0,e.$Aic=(0,b.$gi)("IExtHostAuthentication");let E=class{constructor(w){this.b=new Map,this.c=new u.$6d,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=w.getProxy(L.$eM.MainThreadAuthentication)}async getSession(w,S,y,h={}){const g=A.$Bm.toKey(w.identifier),c=[...y].sort().join(" ");return await this.d.getOrCreate(`${g} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const n=w.displayName||w.name;return this.a.$getSession(S,y,g,n,h)})}async getSessions(w,S,y){const h=A.$Bm.toKey(w.identifier),g=[...y].sort().join(" ");return await this.f.getOrCreate(`${h} ${g}`,async()=>{await this.a.$ensureProvider(S);const c=w.displayName||w.name;return this.a.$getSessions(S,y,h,c)})}async removeSession(w,S){const y=this.b.get(w);return y?y.provider.removeSession(S):this.a.$removeSession(w,S)}registerAuthenticationProvider(w,S,y,h){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:S,provider:y,options:h??{supportsMultipleAccounts:!1}});const g=y.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(w,c));return this.a.$registerAuthenticationProvider(w,S,h?.supportsMultipleAccounts??!1),new M.$gM(()=>{g.dispose(),this.b.delete(w),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,S,y){const h=this.b.get(w);if(h)return Promise.resolve(h.provider.createSession(S,y));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,S){const y=this.b.get(w);if(y)return Promise.resolve(y.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,S){const y=this.b.get(w);if(y)return Promise.resolve(y.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,S){return w.startsWith(P.$gL)||this.c.fire({provider:{id:w,label:S}}),Promise.resolve()}};e.$Bic=E,e.$Bic=E=Je([qe(0,p.$xO)],E);class R{constructor(){this.a=new Map}getOrCreate(w,S){const y=this.a.get(w);if(y)return y;const h=S().finally(()=>this.a.delete(w));return this.a.set(w,h),h}}}),define(Se[151],De([1,0,2,6,7,5,20,12,19,14,17,26]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=void 0;let S=class{static{w=this}static{this.c=0}static{this.d=250}constructor(h,g){this.h=g,this.f=new Map,this.g=h.getProxy(L.$eM.MainThreadDecorations)}registerFileDecorationProvider(h,g){const c=w.c++;this.f.set(c,{provider:h,extensionDescription:g}),this.g.$registerDecorationProvider(c,g.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const r=(0,p.$3b)(i);if(r.length<=w.d){this.g.$onDidChange(c,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,r.length);const a=r.map(l=>({uri:l,rank:(0,E.$Ze)(l.path,"/")})),t=(0,p.$zb)(a,(l,s)=>l.rank-s.rank||(0,E.$df)(l.uri.path,s.uri.path)),f=[];e:for(const l of t){let s;for(const o of l){const d=(0,R.$mc)(o.uri.path);if(s!==d&&(s=d,f.push(o.uri)>=w.d))break e}}this.g.$onDidChange(c,f)});return new M.$gM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(h,g,c){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(h);return await Promise.all(g.map(async a=>{try{const{uri:t,id:f}=a,l=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),c));if(!l)return;try{M.$FN.validate(l),l.badge&&typeof l.badge!="string"&&(0,I.$4F)(r,"codiconDecoration"),n[f]=[l.propagate,l.tooltip,l.badge,l.color]}catch(s){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${s}`)}}catch(t){this.h.error(t)}})),n}};e.$Bjc=S,e.$Bjc=S=w=Je([qe(0,P.$xO),qe(1,b.$Mj)],S),e.$Cjc=(0,A.$gi)("IExtHostDecorations")}),define(Se[320],De([1,0,13,2,7,6,15,22,14]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;class E{static{this.a=0}constructor(I,w,S){this.d=w,this.e=S,this.b=new Map,this.c=I.getProxy(A.$eM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(P.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=E.a++;this.b.set(S,w),this.c.$registerTextContentProvider(S,I);let y;if(typeof w.onDidChange=="function"){let h;y=w.onDidChange(async g=>{if(g.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;h&&await h;const c=this.$provideTextDocumentContent(S,g).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(g);if(!i)return;const r=(0,p.$0e)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(g,n)}).catch(u.$1).finally(()=>{h===c&&(h=void 0)});h=c})}return new M.$gM(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(I,w){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(L.URI.revive(w),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$Ejc=E}),define(Se[152],De([1,0,61,15,14,181,129,7,19]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=void 0,e.$zO=R;const E=new Map;function R(y,h){h?E.set(y,h):E.delete(y)}function I(y){return E.get(y)}class w extends A.$Dv{constructor(h,g,c,n,i,r,a){super(g,c,n,i),this.c=h,this.m=r,this.q=a,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,p.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===L.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(g){return g?h.s(g):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(g){return h.t(g)},offsetAt(g){return h.u(g)},positionAt(g){return h.v(g)},validateRange(g){return h.w(g)},validatePosition(g){return h.x(g)},getWordRangeAtPosition(g,c){return h.y(g,c)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,u.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,u.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const g=this.w(h);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const c=this.g,n=g.start.line,i=g.end.line,r=[];r.push(this.f[n].substring(g.start.character));for(let a=n+1;a<i;a++)r.push(this.f[a]);return r.push(this.f[i].substring(0,g.end.character)),r.join(c)}t(h){let g;if(h instanceof b.$hM?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new S(g,this.f[g],g===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const g=this.j.getIndexOf(h),c=this.f[g.index].length;return new b.$hM(g.index,Math.min(g.remainder,c))}w(h){if(!(h instanceof b.$iM))throw new Error("Invalid argument");const g=this.x(h.start),c=this.x(h.end);return g===h.start&&c===h.end?h:new b.$iM(g.line,g.character,c.line,c.character)}x(h){if(!(h instanceof b.$hM))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:g,character:c}=h,n=!1;if(g<0)g=0,c=0,n=!0;else if(g>=this.f.length)g=this.f.length-1,c=this.f[g].length,n=!0;else{const i=this.f[g].length;c<0?(c=0,n=!0):c>i&&(c=i,n=!0)}return n?new b.$hM(g,c):h}y(h,g){const c=this.x(h);if(!g)g=I(this.m);else if((0,M.$9e)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const n=(0,P.$Ns)(c.character+1,(0,P.$Ls)(g),this.f[c.line],0);if(n)return new b.$iM(c.line,n.startColumn-1,c.line,n.endColumn-1)}}e.$AO=w;class S{constructor(h,g,c){this.a=h,this.b=g,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$iM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$iM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$BO=S}),define(Se[321],De([1,0,6,7]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class M{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(u.$eM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(P,b,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(P);if(!E)throw new Error("Embedding vector provider not found");const R=await E.provideEmbeddingVector(b,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(P,b,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiEmbeddingVectorProvider(b,E),new L.$gM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$Gjc=M}),define(Se[68],De([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=void 0;let y=S=class{constructor(g,c){this.b=new Map,this.c=new R.$ph,this.a=g.getProxy(u.$eM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),r=await a.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===L.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return S.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return S.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return S.e(r)}},async writeFile(i,r){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,a.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(a.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,A.$te.wrap(r))}catch(a){return S.e(a)}},async delete(i,r){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await a.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return S.e(a)}},async rename(i,r,a){try{return await n.a.$rename(i,r,{overwrite:!1,...a})}catch(t){return S.e(t)}},async copy(i,r,a){try{return await n.a.$copy(i,r,{overwrite:!1,...a})}catch(t){return S.e(t)}},isWritableFileSystem(i){const r=c.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(g,c,n){const i=[];for(;!c.isEqual(n,c.dirname(n));)try{if(!((await g.stat(n)).type&L.FileType.Directory))throw M.$wN.FileExists(`Unable to create folder '${n.scheme===w.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(L.$3k(r)!==L.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(c.basename(n)),n=c.dirname(n)}for(let r=i.length-1;r>=0;r--){n=c.joinPath(n,i[r]);try{await g.createDirectory(n)}catch(a){if(L.$3k(a)!==L.FileSystemProviderErrorCode.FileExists)throw a}}}static e(g){if(g instanceof M.$wN)throw g;if(g instanceof L.$Yk)switch(g.code){case L.FileSystemProviderErrorCode.FileExists:throw M.$wN.FileExists(g.message);case L.FileSystemProviderErrorCode.FileNotFound:throw M.$wN.FileNotFound(g.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw M.$wN.FileNotADirectory(g.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw M.$wN.FileIsADirectory(g.message);case L.FileSystemProviderErrorCode.NoPermissions:throw M.$wN.NoPermissions(g.message);case L.FileSystemProviderErrorCode.Unavailable:throw M.$wN.Unavailable(g.message);default:throw new M.$wN(g.message,g.name)}if(!(g instanceof Error))throw new M.$wN(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw M.$wN.Unavailable(g.message);switch(g.name){case L.FileSystemProviderErrorCode.FileExists:throw M.$wN.FileExists(g.message);case L.FileSystemProviderErrorCode.FileNotFound:throw M.$wN.FileNotFound(g.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw M.$wN.FileNotADirectory(g.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw M.$wN.FileIsADirectory(g.message);case L.FileSystemProviderErrorCode.NoPermissions:throw M.$wN.NoPermissions(g.message);case L.FileSystemProviderErrorCode.Unavailable:throw M.$wN.Unavailable(g.message);default:throw new M.$wN(g.message,g.name)}}addFileSystemProvider(g,c,n){return this.b.set(g,{impl:c,extUri:n?.isCaseSensitive?I.$Jg:I.$Lg,isReadonly:!!n?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??I.$Jg}};e.$Tic=y,e.$Tic=y=S=Je([qe(0,b.$xO),qe(1,p.$uic)],y),e.$Uic=(0,P.$gi)("IExtHostConsumerFileSystem")}),define(Se[322],De([1,0,6,7]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;class M{constructor(P){this.a=new Map,this.b=new Map,this.c=P.getProxy(u.$eM.MainThreadIssueReporter)}async $getIssueReporterUri(P,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const p=this.a.get(P);if(!p)throw new Error("Issue request handler not found");const E=await p.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(P,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(P);if(!p)throw new Error("Issue data provider not found");const E=await p.provideIssueData(b);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(P,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(P);if(!p)throw new Error("Issue data provider not found");const E=await p.provideIssueTemplate(b);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(P,b){const p=P.identifier.value;return this.a.set(p,b),this.c.$registerIssueUriRequestHandler(p),new L.$gM(()=>{this.c.$unregisterIssueUriRequestHandler(p),this.a.delete(p)})}registerIssueDataProvider(P,b){const p=P.identifier.value;return this.b.set(p,b),this.c.$registerIssueDataProvider(p),new L.$gM(()=>{this.c.$unregisterIssueDataProvider(p),this.b.delete(p)})}}e.$Xjc=M}),define(Se[93],De([1,0,5,27,12,68,2]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=void 0,e.$Vic=(0,u.$gi)("IExtensionStoragePaths");let b=class{constructor(E,R,I){this.d=R,this.f=I,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(E){return P.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,R=await this.g(E);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(E){if(this.c)return P.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return P.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Wic=b,e.$Wic=b=Je([qe(0,L.$NO),qe(1,M.$Mj),qe(2,A.$Uic)],b)}),define(Se[323],De([1,0,7,20,4]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;let A=class{constructor(b){this.a=new u.$GN(u.ColorThemeKind.Dark),this.b=new M.$6d}get activeColorTheme(){return this.a}$onColorThemeChange(b){let p;switch(b){case"light":p=u.ColorThemeKind.Light;break;case"hcDark":p=u.ColorThemeKind.HighContrast;break;case"hcLight":p=u.ColorThemeKind.HighContrastLight;break;default:p=u.ColorThemeKind.Dark}this.a=new u.$GN(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$okc=A,e.$okc=A=Je([qe(0,L.$xO)],A)}),define(Se[69],De([1,0,22,4,3,227,5,12,88,6,27,20,7]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PAb=e.$OAb=e.TunnelDtoConverter=void 0;class S extends p.$3v{}var y;(function(g){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}g.fromApiTunnel=c;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}g.fromServiceTunnel=n})(y||(e.TunnelDtoConverter=y={})),e.$OAb=(0,P.$gi)("IExtHostTunnelService");let h=class extends M.$Tc{constructor(c,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$6d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(E.$eM.MainThreadTunnelService)}async openTunnel(c,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,c.displayName);if(i){const r=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,n){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:n}),this.a.$registerPortsAttributesProvider(c,i),new w.$gM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,n,i,r,a){const t=[];for(const l of c){const s=this.r.get(l);if(!s)return[];t.push(...await Promise.all(n.map(async o=>{let d;try{d=await s.provider.providePortAttributes({port:o,pid:i,commandLine:r},a)}catch{d=await s.provider.providePortAttributes(o,i,r,a)}return{providedAttributes:d,port:o}})))}const f=t.filter(l=>!!l.providedAttributes);return f.length>0?f.map(l=>({autoForwardAction:l.providedAttributes.autoForwardAction,port:l.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await c.provideTunnel(r,a,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,n){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const a=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,M.$Rc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,n){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(n&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:r,disposeListener:a}),y.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const n=await Promise.all(c.map(r=>this.f(r.host,r.port,r.detail??""))),i=c.filter((r,a)=>n[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$PAb=h,e.$PAb=h=Je([qe(0,I.$xO),qe(1,R.$NO),qe(2,b.$Mj)],h)}),define(Se[16],De([1,0,19,21,170,73,79,28,164,56,101,24,23,18,2,29,82,138,144,142,119,66,89,297,26,7]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$uO=j,e.$vO=F,e.$wO=K;var o;(function(Re){function Ne(te){const{selectionStartLineNumber:je,selectionStartColumn:Ue,positionLineNumber:_e,positionColumn:Qe}=te,ut=new s.$hM(je-1,Ue-1),kt=new s.$hM(_e-1,Qe-1);return new s.$jM(ut,kt)}Re.to=Ne;function ke(te){const{anchor:je,active:Ue}=te;return{selectionStartLineNumber:je.line+1,selectionStartColumn:je.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Re.from=ke})(o||(e.Selection=o={}));var d;(function(Re){function Ne(te){if(!te)return;const{start:je,end:Ue}=te;return{startLineNumber:je.line+1,startColumn:je.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Re.from=Ne;function ke(te){if(!te)return;const{startLineNumber:je,startColumn:Ue,endLineNumber:_e,endColumn:Qe}=te;return new s.$iM(je-1,Ue-1,_e-1,Qe-1)}Re.to=ke})(d||(e.Range=d={}));var m;(function(Re){function Ne(te){return{uri:te.uri,range:d.from(te.range)}}Re.from=Ne;function ke(te){return new s.$sM(y.URI.revive(te.uri),d.to(te.range))}Re.to=ke})(m||(e.Location=m={}));var D;(function(Re){function Ne(ke){switch(ke){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Ne})(D||(e.TokenType=D={}));var $;(function(Re){function Ne(te){return new s.$hM(te.lineNumber-1,te.column-1)}Re.to=Ne;function ke(te){return{lineNumber:te.line+1,column:te.character+1}}Re.from=ke})($||(e.Position=$={}));var v;(function(Re){function Ne(je,Ue,_e){return(0,u.$Hb)((0,u.$3b)(je).map(Qe=>ke(Qe,Ue,_e)))}Re.from=Ne;function ke(je,Ue,_e){if(typeof je=="string")return{$serialized:!0,language:je,isBuiltin:_e?.isBuiltin};if(je)return{$serialized:!0,language:je.language,scheme:te(je.scheme,Ue),pattern:oe.from(je.pattern)??void 0,exclusive:je.exclusive,notebookType:je.notebookType,isBuiltin:_e?.isBuiltin}}function te(je,Ue){return Ue&&typeof je=="string"?Ue.transformOutgoingScheme(je):je}})(v||(e.DocumentSelector=v={}));var k;(function(Re){function Ne(te){switch(te){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Ne;function ke(te){switch(te){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=ke})(k||(e.DiagnosticTag=k={}));var C;(function(Re){function Ne(te){let je;return te.code&&((0,S.$Tf)(te.code)||(0,S.$Xf)(te.code)?je=String(te.code):je={value:String(te.code.value),target:te.code.target}),{...d.from(te.range),message:te.message,source:te.source,code:je,severity:B.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(O.from),tags:Array.isArray(te.tags)?(0,u.$Hb)(te.tags.map(k.from)):void 0}}Re.from=Ne;function ke(te){const je=new s.$uM(d.to(te),te.message,B.to(te.severity));return je.source=te.source,je.code=(0,S.$Tf)(te.code)?te.code:te.code?.value,je.relatedInformation=te.relatedInformation&&te.relatedInformation.map(O.to),je.tags=te.tags&&(0,u.$Hb)(te.tags.map(k.to)),je}Re.to=ke})(C||(e.Diagnostic=C={}));var O;(function(Re){function Ne(te){return{...d.from(te.location.range),message:te.message,resource:te.location.uri}}Re.from=Ne;function ke(te){return new s.$tM(new s.$sM(te.resource,d.to(te)),te.message)}Re.to=ke})(O||(e.DiagnosticRelatedInformation=O={}));var B;(function(Re){function Ne(te){switch(te){case s.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}Re.from=Ne;function ke(te){switch(te){case c.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=ke})(B||(e.DiagnosticSeverity=B={}));var z;(function(Re){function Ne(te){return typeof te=="number"&&te>=s.ViewColumn.One?te-1:te===s.ViewColumn.Beside?f.$xD:f.$wD}Re.from=Ne;function ke(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=ke})(z||(e.ViewColumn=z={}));function T(Re){return typeof Re.range<"u"}function j(Re){return Re.length===0?!0:!!T(Re[0])}var N;(function(Re){function Ne(Qe){return Qe.map(Re.from)}Re.fromMany=Ne;function ke(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function te(Qe){let ut;if(ke(Qe)){const{language:Rt,value:Yt}=Qe;ut={value:"```"+Rt+`
`+Yt+"\n```\n"}}else s.$HM.isMarkdownString(Qe)?ut={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ut={value:Qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Jt=Rt=>{try{let Yt=y.URI.parse(Rt,!0);Yt=Yt.with({query:je(Yt.query,kt)}),kt[Rt]=Yt}catch{}return""},Dt=new p.marked.Renderer;return Dt.link=Jt,Dt.image=Rt=>typeof Rt=="string"?Jt(P.$Lk(Rt).href):"",(0,p.marked)(ut.value,{renderer:Dt}),ut}Re.from=te;function je(Qe,ut){if(!Qe)return Qe;let kt;try{kt=(0,E.$Oh)(Qe)}catch{}if(!kt)return Qe;let Jt=!1;return kt=(0,I.$On)(kt,Dt=>{if(y.URI.isUri(Dt)){const Rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Rt]=Dt,Jt=!0,Rt}else return}),Jt?JSON.stringify(kt):Qe}function Ue(Qe){const ut=new s.$HM(Qe.value,Qe.supportThemeIcons);return ut.isTrusted=Qe.isTrusted,ut.supportHtml=Qe.supportHtml,ut.baseUri=Qe.baseUri?y.URI.from(Qe.baseUri):void 0,ut}Re.to=Ue;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=_e})(N||(e.MarkdownString=N={}));function F(Re){return j(Re)?Re.map(Ne=>({range:d.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?N.fromMany(Ne.hoverMessage):Ne.hoverMessage?N.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Re.map(Ne=>({range:d.from(Ne)}))}function K(Re){return typeof Re>"u"?Re:typeof Re=="string"?y.URI.file(Re):Re}var ee;(function(Re){function Ne(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?K(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Re.from=Ne})(ee||(e.ThemableDecorationAttachmentRenderOptions=ee={}));var Y;(function(Re){function Ne(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?K(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?ee.from(ke.before):void 0,after:ke.after?ee.from(ke.after):void 0}}Re.from=Ne})(Y||(e.ThemableDecorationRenderOptions=Y={}));var Q;(function(Re){function Ne(ke){if(typeof ke>"u")return ke;switch(ke){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ne})(Q||(e.DecorationRangeBehavior=Q={}));var Z;(function(Re){function Ne(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?Q.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?Y.from(ke.light):void 0,dark:ke.dark?Y.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?K(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?ee.from(ke.before):void 0,after:ke.after?ee.from(ke.after):void 0}}Re.from=Ne})(Z||(e.DecorationRenderOptions=Z={}));var ae;(function(Re){function Ne(te){return{text:te.newText,eol:te.newEol&&Ce.from(te.newEol),range:d.from(te.range)}}Re.from=Ne;function ke(te){const je=new s.$nM(d.to(te.range),te.text);return je.newEol=typeof te.eol>"u"?void 0:Ce.to(te.eol),je}Re.to=ke})(ae||(e.TextEdit=ae={}));var _;(function(Re){function Ne(te,je){const Ue={edits:[]};if(te instanceof s.$qM){const _e=new b.$Bc;for(const Qe of te._allEntries())Qe._type===1&&y.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of te._allEntries())if(Qe._type===1){let ut;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ut={type:"base64",value:(0,L.$Ne)(L.$te.wrap(Qe.options.contents))}:ut={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ue.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ut},metadata:Qe.metadata})}else Qe._type===2?Ue.edits.push({resource:Qe.uri,textEdit:ae.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:je?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ue.edits.push({resource:Qe.uri,textEdit:{range:d.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:je?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ue.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:je?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ue.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:je?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(It.from)}})}return Ue}Re.from=Ne;function ke(te){const je=new s.$qM,Ue=new b.$Ac;for(const _e of te.edits)if(_e.textEdit){const Qe=_e,ut=y.URI.revive(Qe.resource),kt=d.to(Qe.textEdit.range),Jt=Qe.textEdit.text,Dt=Qe.textEdit.insertAsSnippet;let Rt;Dt?Rt=s.$pM.replace(kt,new s.$rM(Jt)):Rt=s.$nM.replace(kt,Jt);const Yt=Ue.get(ut);Yt?Yt.push(Rt):Ue.set(ut,[Rt])}else je.renameFile(y.URI.revive(_e.oldResource),y.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ue)je.set(_e,Qe);return je}Re.to=ke})(_||(e.WorkspaceEdit=_={}));var ge;(function(Re){const Ne=Object.create(null);Ne[s.SymbolKind.File]=0,Ne[s.SymbolKind.Module]=1,Ne[s.SymbolKind.Namespace]=2,Ne[s.SymbolKind.Package]=3,Ne[s.SymbolKind.Class]=4,Ne[s.SymbolKind.Method]=5,Ne[s.SymbolKind.Property]=6,Ne[s.SymbolKind.Field]=7,Ne[s.SymbolKind.Constructor]=8,Ne[s.SymbolKind.Enum]=9,Ne[s.SymbolKind.Interface]=10,Ne[s.SymbolKind.Function]=11,Ne[s.SymbolKind.Variable]=12,Ne[s.SymbolKind.Constant]=13,Ne[s.SymbolKind.String]=14,Ne[s.SymbolKind.Number]=15,Ne[s.SymbolKind.Boolean]=16,Ne[s.SymbolKind.Array]=17,Ne[s.SymbolKind.Object]=18,Ne[s.SymbolKind.Key]=19,Ne[s.SymbolKind.Null]=20,Ne[s.SymbolKind.EnumMember]=21,Ne[s.SymbolKind.Struct]=22,Ne[s.SymbolKind.Event]=23,Ne[s.SymbolKind.Operator]=24,Ne[s.SymbolKind.TypeParameter]=25;function ke(je){return typeof Ne[je]=="number"?Ne[je]:6}Re.from=ke;function te(je){for(const Ue in Ne)if(Ne[Ue]===je)return Number(Ue);return s.SymbolKind.Property}Re.to=te})(ge||(e.SymbolKind=ge={}));var se;(function(Re){function Ne(te){switch(te){case s.SymbolTag.Deprecated:return 1}}Re.from=Ne;function ke(te){switch(te){case 1:return s.SymbolTag.Deprecated}}Re.to=ke})(se||(e.SymbolTag=se={}));var re;(function(Re){function Ne(te){return{name:te.name,kind:ge.from(te.kind),tags:te.tags&&te.tags.map(se.from),containerName:te.containerName,location:ue.from(te.location)}}Re.from=Ne;function ke(te){const je=new s.$yM(te.name,ge.to(te.kind),te.containerName,ue.to(te.location));return je.tags=te.tags&&te.tags.map(se.to),je}Re.to=ke})(re||(e.WorkspaceSymbol=re={}));var U;(function(Re){function Ne(te){const je={name:te.name||"!!MISSING: name!!",detail:te.detail,range:d.from(te.range),selectionRange:d.from(te.selectionRange),kind:ge.from(te.kind),tags:te.tags?.map(se.from)??[]};return te.children&&(je.children=te.children.map(Ne)),je}Re.from=Ne;function ke(te){const je=new s.$zM(te.name,te.detail,ge.to(te.kind),d.to(te.range),d.to(te.selectionRange));return(0,u.$Lb)(te.tags)&&(je.tags=te.tags.map(se.to)),te.children&&(je.children=te.children.map(ke)),je}Re.to=ke})(U||(e.DocumentSymbol=U={}));var ie;(function(Re){function Ne(te){const je=new s.$DM(ge.to(te.kind),te.name,te.detail||"",y.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return je._sessionId=te._sessionId,je._itemId=te._itemId,je}Re.to=Ne;function ke(te,je,Ue){if(je=je??te._sessionId,Ue=Ue??te._itemId,je===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:Ue,name:te.name,detail:te.detail,kind:ge.from(te.kind),uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(se.from)}}Re.from=ke})(ie||(e.CallHierarchyItem=ie={}));var ye;(function(Re){function Ne(ke){return new s.$EM(ie.to(ke.from),ke.fromRanges.map(te=>d.to(te)))}Re.to=Ne})(ye||(e.CallHierarchyIncomingCall=ye={}));var le;(function(Re){function Ne(ke){return new s.$FM(ie.to(ke.to),ke.fromRanges.map(te=>d.to(te)))}Re.to=Ne})(le||(e.CallHierarchyOutgoingCall=le={}));var ue;(function(Re){function Ne(te){return{range:te.range&&d.from(te.range),uri:te.uri}}Re.from=Ne;function ke(te){return new s.$sM(y.URI.revive(te.uri),d.to(te.range))}Re.to=ke})(ue||(e.location=ue={}));var ce;(function(Re){function Ne(te){const je=te,Ue=te;return{originSelectionRange:je.originSelectionRange?d.from(je.originSelectionRange):void 0,uri:je.targetUri?je.targetUri:Ue.uri,range:d.from(je.targetRange?je.targetRange:Ue.range),targetSelectionRange:je.targetSelectionRange?d.from(je.targetSelectionRange):void 0}}Re.from=Ne;function ke(te){return{targetUri:y.URI.revive(te.uri),targetRange:d.to(te.range),targetSelectionRange:te.targetSelectionRange?d.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?d.to(te.originSelectionRange):void 0}}Re.to=ke})(ce||(e.DefinitionLink=ce={}));var de;(function(Re){function Ne(te){return{range:d.from(te.range),contents:N.fromMany(te.contents)}}Re.from=Ne;function ke(te){return new s.$vM(te.contents.map(N.to),d.to(te.range))}Re.to=ke})(de||(e.Hover=de={}));var H;(function(Re){function Ne(te){return{range:d.from(te.range),expression:te.expression}}Re.from=Ne;function ke(te){return new s.$qN(d.to(te.range),te.expression)}Re.to=ke})(H||(e.EvaluatableExpression=H={}));var x;(function(Re){function Ne(te){if(te instanceof s.$rN)return{type:"text",range:d.from(te.range),text:te.text};if(te instanceof s.$sN)return{type:"variable",range:d.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof s.$tN)return{type:"expression",range:d.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ne;function ke(te){switch(te.type){case"text":return{range:d.to(te.range),text:te.text};case"variable":return{range:d.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:d.to(te.range),expression:te.expression}}}Re.to=ke})(x||(e.InlineValue=x={}));var he;(function(Re){function Ne(te){return{frameId:te.frameId,stoppedLocation:d.from(te.stoppedLocation)}}Re.from=Ne;function ke(te){return new s.$uN(te.frameId,d.to(te.stoppedLocation))}Re.to=ke})(he||(e.InlineValueContext=he={}));var pe;(function(Re){function Ne(te){return{range:d.from(te.range),kind:te.kind}}Re.from=Ne;function ke(te){return new s.$wM(d.to(te.range),te.kind)}Re.to=ke})(pe||(e.DocumentHighlight=pe={}));var Ae;(function(Re){function Ne(te){return{uri:te.uri,highlights:te.highlights.map(pe.from)}}Re.from=Ne;function ke(te){return new s.$xM(y.URI.revive(te.uri),te.highlights.map(pe.to))}Re.to=ke})(Ae||(e.MultiDocumentHighlight=Ae={}));var we;(function(Re){function Ne(ke){switch(ke){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Ne})(we||(e.CompletionTriggerKind=we={}));var Pe;(function(Re){function Ne(ke){return{triggerKind:we.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Re.to=Ne})(Pe||(e.CompletionContext=Pe={}));var Fe;(function(Re){function Ne(te){switch(te){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Ne;function ke(te){switch(te){case 1:return s.CompletionItemTag.Deprecated}}Re.to=ke})(Fe||(e.CompletionItemTag=Fe={}));var ze;(function(Re){const Ne=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ke(Ue){return Ne.get(Ue)??9}Re.from=ke;const te=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function je(Ue){return te.get(Ue)??s.CompletionItemKind.Property}Re.to=je})(ze||(e.CompletionItemKind=ze={}));var q;(function(Re){function Ne(ke,te){const je=new s.$NM(ke.label);return je.insertText=ke.insertText,je.kind=ze.to(ke.kind),je.tags=ke.tags?.map(Fe.to),je.detail=ke.detail,je.documentation=P.$Fk(ke.documentation)?N.to(ke.documentation):ke.documentation,je.sortText=ke.sortText,je.filterText=ke.filterText,je.preselect=ke.preselect,je.commitCharacters=ke.commitCharacters,h.$$s.isIRange(ke.range)?je.range=d.to(ke.range):typeof ke.range=="object"&&(je.range={inserting:d.to(ke.range.insert),replacing:d.to(ke.range.replace)}),je.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&1),typeof ke.insertTextRules<"u"&&ke.insertTextRules&4?je.insertText=new s.$rM(ke.insertText):(je.insertText=ke.insertText,je.textEdit=je.range instanceof s.$iM?new s.$nM(je.range,je.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(je.additionalTextEdits=ke.additionalTextEdits.map(Ue=>ae.to(Ue))),je.command=te&&ke.command?te.fromInternal(ke.command):void 0,je}Re.to=Ne})(q||(e.CompletionItem=q={}));var V;(function(Re){function Ne(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:N.fromStrict(te.documentation)}}Re.from=Ne;function ke(te){return{label:te.label,documentation:P.$Fk(te.documentation)?N.to(te.documentation):te.documentation}}Re.to=ke})(V||(e.ParameterInformation=V={}));var J;(function(Re){function Ne(te){return{label:te.label,documentation:N.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(V.from):[],activeParameter:te.activeParameter}}Re.from=Ne;function ke(te){return{label:te.label,documentation:P.$Fk(te.documentation)?N.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(V.to):[],activeParameter:te.activeParameter}}Re.to=ke})(J||(e.SignatureInformation=J={}));var X;(function(Re){function Ne(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(J.from):[]}}Re.from=Ne;function ke(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(J.to):[]}}Re.to=ke})(X||(e.SignatureHelp=X={}));var me;(function(Re){function Ne(ke,te){const je=new s.$MM($.to(te.position),typeof te.label=="string"?te.label:te.label.map(ve.to.bind(void 0,ke)),te.kind&&Te.to(te.kind));return je.textEdits=te.textEdits&&te.textEdits.map(ae.to),je.tooltip=P.$Fk(te.tooltip)?N.to(te.tooltip):te.tooltip,je.paddingLeft=te.paddingLeft,je.paddingRight=te.paddingRight,je}Re.to=Ne})(me||(e.InlayHint=me={}));var ve;(function(Re){function Ne(ke,te){const je=new s.$LM(te.label);return je.tooltip=P.$Fk(te.tooltip)?N.to(te.tooltip):te.tooltip,g.Command.is(te.command)&&(je.command=ke.fromInternal(te.command)),te.location&&(je.location=ue.to(te.location)),je}Re.to=Ne})(ve||(e.InlayHintLabelPart=ve={}));var Te;(function(Re){function Ne(te){return te}Re.from=Ne;function ke(te){return te}Re.to=ke})(Te||(e.InlayHintKind=Te={}));var He;(function(Re){function Ne(te){return{range:d.from(te.range),url:te.target,tooltip:te.tooltip}}Re.from=Ne;function ke(te){let je;if(te.url)try{je=typeof te.url=="string"?y.URI.parse(te.url,!0):y.URI.revive(te.url)}catch{}return new s.$SM(d.to(te.range),je)}Re.to=ke})(He||(e.DocumentLink=He={}));var Ze;(function(Re){function Ne(te){const je=new s.$VM(te.label);return te.textEdit&&(je.textEdit=ae.to(te.textEdit)),te.additionalTextEdits&&(je.additionalTextEdits=te.additionalTextEdits.map(Ue=>ae.to(Ue))),je}Re.to=Ne;function ke(te){return{label:te.label,textEdit:te.textEdit?ae.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(je=>ae.from(je)):void 0}}Re.from=ke})(Ze||(e.ColorPresentation=Ze={}));var tt;(function(Re){function Ne(te){return new s.$TM(te[0],te[1],te[2],te[3])}Re.to=Ne;function ke(te){return[te.red,te.green,te.blue,te.alpha]}Re.from=ke})(tt||(e.Color=tt={}));var nt;(function(Re){function Ne(te){return{range:d.from(te.range)}}Re.from=Ne;function ke(te){return new s.$CM(d.to(te.range))}Re.to=ke})(nt||(e.SelectionRange=nt={}));var at;(function(Re){function Ne(ke){switch(ke){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Ne})(at||(e.TextDocumentSaveReason=at={}));var rt;(function(Re){function Ne(te){switch(te){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ne;function ke(te){switch(te){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=ke})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Ce;(function(Re){function Ne(te){if(te===s.EndOfLine.CRLF)return 1;if(te===s.EndOfLine.LF)return 0}Re.from=Ne;function ke(te){if(te===1)return s.EndOfLine.CRLF;if(te===0)return s.EndOfLine.LF}Re.to=ke})(Ce||(e.EndOfLine=Ce={}));var Be;(function(Re){function Ne(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ne})(Be||(e.ProgressLocation=Be={}));var Me;(function(Re){function Ne(te){const je={start:te.start+1,end:te.end+1};return te.kind&&(je.kind=Ke.from(te.kind)),je}Re.from=Ne;function ke(te){const je={start:te.start-1,end:te.end-1};return te.kind&&(je.kind=Ke.to(te.kind)),je}Re.to=ke})(Me||(e.FoldingRange=Me={}));var Ke;(function(Re){function Ne(te){if(te)switch(te){case s.FoldingRangeKind.Comment:return g.$3t.Comment;case s.FoldingRangeKind.Imports:return g.$3t.Imports;case s.FoldingRangeKind.Region:return g.$3t.Region}}Re.from=Ne;function ke(te){if(te)switch(te.value){case g.$3t.Comment.value:return s.FoldingRangeKind.Comment;case g.$3t.Imports.value:return s.FoldingRangeKind.Imports;case g.$3t.Region.value:return s.FoldingRangeKind.Region}}Re.to=ke})(Ke||(e.FoldingRangeKind=Ke={}));var ne;(function(Re){function Ne(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?d.from(ke.selection):void 0,override:typeof ke.override=="boolean"?i.$ZE.id:void 0}}Re.from=Ne})(ne||(e.TextEditorOpenOptions=ne={}));var oe;(function(Re){function Ne(Ue){return Ue instanceof s.$eN?Ue.toJSON():typeof Ue=="string"?Ue:ke(Ue)||te(Ue)?new s.$eN(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Re.from=Ne;function ke(Ue){const _e=Ue;return _e?y.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function te(Ue){const _e=Ue;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function je(Ue){return typeof Ue=="string"?Ue:new s.$eN(y.URI.revive(Ue.baseUri),Ue.pattern)}Re.to=je})(oe||(e.GlobPattern=oe={}));var Ie;(function(Re){function Ne(ke){if(ke){if(Array.isArray(ke))return ke.map(Ne);if(typeof ke=="string")return ke;{const te=ke;return{language:te.language,scheme:te.scheme,pattern:oe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Re.from=Ne})(Ie||(e.LanguageSelector=Ie={}));var Ge;(function(Re){function Ne(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(je=>Array.isArray(je)&&je.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&y.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(_e=>_e instanceof s.$iM)))}Re.is=Ne;function ke(te){return{documents:te.documents.map(je=>je.map(Ue=>({uri:y.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(_e=>d.from(_e))})))}}Re.from=ke})(Ge||(e.MappedEditsContext=Ge={}));var xe;(function(Re){function Ne(te){return{start:te.start,end:te.end}}Re.from=Ne;function ke(te){return new s.$HN(te.start,te.end)}Re.to=ke})(xe||(e.NotebookRange=xe={}));var st;(function(Re){function Ne(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Re.to=Ne;function ke(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Re.from=ke})(st||(e.NotebookCellExecutionSummary=st={}));var Le;(function(Re){function Ne(ke){if(ke===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ke===r.NotebookCellExecutionState.Pending)return;if(ke===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Re.to=Ne})(Le||(e.NotebookCellExecutionState=Le={}));var bt;(function(Re){function Ne(te){switch(te){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Re.from=Ne;function ke(te){switch(te){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=ke})(bt||(e.NotebookCellKind=bt={}));var St;(function(Re){function Ne(te){const je={metadata:te.metadata??Object.create(null),cells:[]};for(const Ue of te.cells)s.$IN.validate(Ue),je.cells.push(It.from(Ue));return je}Re.from=Ne;function ke(te){const je=new s.$JN(te.cells.map(It.to));return(0,S.$7f)(te.metadata)||(je.metadata=te.metadata),je}Re.to=ke})(St||(e.NotebookData=St={}));var It;(function(Re){function Ne(te){return{cellKind:bt.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:st.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(qt.from):[]}}Re.from=Ne;function ke(te){return new s.$IN(bt.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(qt.to):void 0,te.metadata,te.internalMetadata?st.to(te.internalMetadata):void 0)}Re.to=ke})(It||(e.NotebookCellData=It={}));var Vt;(function(Re){function Ne(te){return{mime:te.mime,valueBytes:L.$te.wrap(te.data)}}Re.from=Ne;function ke(te){return new s.$KN(te.valueBytes.buffer,te.mime)}Re.to=ke})(Vt||(e.NotebookCellOutputItem=Vt={}));var qt;(function(Re){function Ne(te){return{outputId:te.id,items:te.items.map(Vt.from),metadata:te.metadata}}Re.from=Ne;function ke(te){const je=te.items.map(Vt.to);return new s.$LN(je,te.outputId,te.metadata)}Re.to=ke})(qt||(e.NotebookCellOutput=qt={}));var Ct;(function(Re){function Ne(je){return te(je)?{include:oe.from(je.include)??void 0,exclude:oe.from(je.exclude)??void 0}:oe.from(je)??void 0}Re.from=Ne;function ke(je){return te(je)?{include:oe.to(je.include),exclude:oe.to(je.exclude)}:oe.to(je)}Re.to=ke;function te(je){const Ue=je;return Ue?!(0,S.$3f)(Ue.include)&&!(0,S.$3f)(Ue.exclude):!1}})(Ct||(e.NotebookExclusiveDocumentPattern=Ct={}));var _t;(function(Re){function Ne(ke,te,je){const Ue=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Ue,je),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Re.from=Ne})(_t||(e.NotebookStatusBarItem=_t={}));var Ht;(function(Re){function Ne(ke,te,je){const Ue=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:te.toInternal(Ue,je),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Re.from=Ne})(Ht||(e.NotebookKernelSourceAction=Ht={}));var si;(function(Re){function Ne(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Re.from=Ne})(si||(e.NotebookDocumentContentOptions=si={}));var ei;(function(Re){function Ne(te){return{uri:te.uri,provides:te.provides}}Re.from=Ne;function ke(te){return new s.$NN(y.URI.revive(te.uri),te.provides)}Re.to=ke})(ei||(e.NotebookRendererScript=ei={}));var et;(function(Re){function Ne(te){return{message:N.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:d.from(te.location.range),uri:te.location.uri}}}Re.from=Ne;function ke(te){const je=new s.$TN(typeof te.message=="string"?te.message:N.to(te.message));return je.actualOutput=te.actual,je.expectedOutput=te.expected,je.contextValue=te.contextValue,je.location=te.location?ue.to(te.location):void 0,je}Re.to=ke})(et||(e.TestMessage=et={}));var Lt;(function(Re){Re.namespace=t.$8K,Re.denamespace=t.$9K})(Lt||(e.TestTag=Lt={}));var ti;(function(Re){function Ne(te){const je=(0,n.$tO)(te).controllerId;return{extId:a.$3K.fromExtHostTestItem(te,je).toString(),label:te.label,uri:y.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ue=>Lt.namespace(je,Ue.id)),range:h.$$s.lift(d.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&N.fromStrict(te.error)||null}}Re.from=Ne;function ke(te){return{parent:void 0,error:void 0,id:a.$3K.fromString(te.extId).localId,label:te.label,uri:y.URI.revive(te.uri),tags:(te.tags||[]).map(je=>{const{tagId:Ue}=Lt.denamespace(je);return new s.$UN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Re.toPlain=ke})(ti||(e.TestItem=ti={})),function(Re){function Ne(te){return{id:te.id}}Re.from=Ne;function ke(te){return new s.$UN(te.id)}Re.to=ke}(Lt||(e.TestTag=Lt={}));var dt;(function(Re){const Ne=(te,je)=>{const Ue=[];for(const[Qe,ut]of je)a.$3K.compare(ut.item.extId,Qe)===2&&(je.delete(Qe),Ue.push(ut));const _e={...ti.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ut=>ut.type===0).map(et.to)})),children:Ue.map(Qe=>Ne(Qe,je))};for(const Qe of _e.children)Qe.parent=_e;return _e};function ke(te){const je=[],Ue=new Map;for(const _e of te.items){Ue.set(_e.item.extId,_e);const Qe=a.$3K.root(_e.item.extId);te.request.targets.some(ut=>ut.controllerId===Qe&&ut.testIds.includes(_e.item.extId))&&je.push(_e)}return{completedAt:te.completedAt,results:je.map(_e=>Ne(_e,Ue))}}Re.to=ke})(dt||(e.TestResults=dt={}));var $t;(function(Re){function Ne(Ue){return{covered:Ue.covered,total:Ue.total}}function ke(Ue){return"line"in Ue?$.from(Ue):d.from(Ue)}function te(Ue){return"branches"in Ue?{count:Ue.executed,location:ke(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(_e=>({count:_e.executed,location:_e.location&&ke(_e.location),label:_e.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:ke(Ue.location)}}Re.fromDetailed=te;function je(Ue){return{uri:Ue.uri,statement:Ne(Ue.statementCoverage),branch:Ue.branchCoverage&&Ne(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Ne(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(te)}}Re.fromFile=je})($t||(e.TestCoverage=$t={}));var ii;(function(Re){function Ne(ke){switch(ke){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Ne})(ii||(e.CodeActionTriggerKind=ii={}));var Kt;(function(Re){function Ne(te){const je=new s.$1N(ge.to(te.kind),te.name,te.detail||"",y.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return je._sessionId=te._sessionId,je._itemId=te._itemId,je}Re.to=Ne;function ke(te,je,Ue){if(je=je??te._sessionId,Ue=Ue??te._itemId,je===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:Ue,kind:ge.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(se.from)}}Re.from=ke})(Kt||(e.TypeHierarchyItem=Kt={}));var Gt;(function(Re){function Ne(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Re.from=Ne})(Gt||(e.ViewBadge=Gt={}));var ht;(function(Re){function Ne(Ue,_e,Qe){const ut=_e.fileData;return ut?new s.$9M(new s.$0M(ut.name,y.URI.revive(ut.uri),ut.id,(0,A.$db)(()=>Qe(ut.id)))):Ue===R.$vs.uriList&&_e.uriListData?new s.$8M(je(_e.uriListData)):new s.$8M(_e.asString)}Re.to=Ne;async function ke(Ue,_e){const Qe=await _e.asString();if(Ue===R.$vs.uriList)return{asString:Qe,fileData:void 0,uriListData:te(Qe)};const ut=_e.asFile();return{asString:Qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Re.from=ke;function te(Ue){return M.$Ht.split(Ue).map(_e=>{if(_e.startsWith("#"))return _e;try{return y.URI.parse(_e)}catch{}return _e})}function je(Ue){return M.$Ht.create(Ue.map(_e=>typeof _e=="string"?_e:y.URI.revive(_e)))}})(ht||(e.DataTransferItem=ht={}));var Ot;(function(Re){function Ne(te,je){const Ue=te.items.map(([_e,Qe])=>[_e,ht.to(_e,Qe,je)]);return new s.$$M(Ue)}Re.toDataTransfer=Ne;async function ke(te){const je={items:[]},Ue=[];for(const[_e,Qe]of te)Ue.push((async()=>{je.items.push([_e,await ht.from(_e,Qe)])})());return await Promise.all(Ue),je}Re.from=ke})(Ot||(e.DataTransfer=Ot={}));var ni;(function(Re){function Ne(te,je){return{kind:"reply",agentId:te.participant??je?.agentId??"",subCommand:te.command??je?.command,message:te.prompt,title:te.label}}Re.from=Ne;function ke(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Re.to=ke})(ni||(e.ChatFollowup=ni={}));var ri;(function(Re){function Ne(ke){return"commandId"in ke?{kind:"command",title:ke.title??"",commandId:ke.commandId??"",when:ke.when??"",args:ke.args}:{kind:"reply",message:ke.message,title:ke.title,tooltip:ke.tooltip}}Re.from=Ne})(ri||(e.ChatInlineFollowup=ri={}));var Xe;(function(Re){function Ne(te){switch(te.role){case 0:return new s.$iO(te.content);case 1:return new s.$jO(te.content);case 2:return new s.$kO(te.content)}}Re.to=Ne;function ke(te){if(te instanceof s.$iO)return{role:0,content:te.content};if(te instanceof s.$jO)return{role:1,content:te.content};if(te instanceof s.$kO)return{role:2,content:te.content};throw new Error("Invalid LanguageModelMessage")}Re.from=ke})(Xe||(e.LanguageModelMessage=Xe={}));var Nt;(function(Re){function Ne(je){const Ue={};for(const _e of Object.keys(je))Ue[_e]=je[_e].map(Re.to);return Ue}Re.objectTo=Ne;function ke(je){return{level:Bt.to(je.level),kind:je.kind,value:(0,y.$vc)(je.value)?y.URI.revive(je.value):je.value,description:je.description}}Re.to=ke;function te(je){return{level:Bt.from(je.level),kind:je.kind,value:je.value,description:je.description}}Re.from=te})(Nt||(e.ChatVariable=Nt={}));var Bt;(function(Re){function Ne(te){switch(te){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Re.to=Ne;function ke(te){switch(te){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Re.from=ke})(Bt||(e.ChatVariableLevel=Bt={}));var Zt;(function(Re){function Ne(ke){switch(ke){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Ne})(Zt||(e.InteractiveEditorResponseFeedbackKind=Zt={}));var mt;(function(Re){function Ne(te){return{kind:"markdownContent",content:N.from(te.value)}}Re.to=Ne;function ke(te){return new s.$aO(N.to(te.content))}Re.from=ke})(mt||(e.ChatResponseMarkdownPart=mt={}));var At;(function(Re){function Ne(te){const{value:je,baseUri:Ue}=te;function _e(Qe,ut){return Qe.map(kt=>{const Jt=y.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Jt,children:kt.children&&_e(kt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,w.$Qg)(Ue),uri:Ue,children:_e(je,Ue)}}}Re.to=Ne;function ke(te){const je=(0,E.$Ph)(te.treeData);function Ue(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&Ue(kt.children)}))}const _e=je.uri,Qe=je.children?Ue(je.children):[];return new s.$bO(Qe,_e)}Re.from=ke})(At||(e.ChatResponseFilesPart=At={}));var Pt;(function(Re){function Ne(te){return{kind:"inlineReference",name:te.title,inlineReference:y.URI.isUri(te.value)?te.value:m.from(te.value)}}Re.to=Ne;function ke(te){const je=(0,E.$Ph)(te);return new s.$cO(y.URI.isUri(je.inlineReference)?je.inlineReference:m.to(je.inlineReference),te.name)}Re.from=ke})(Pt||(e.ChatResponseAnchorPart=Pt={}));var Tt;(function(Re){function Ne(te){return{kind:"progressMessage",content:N.from(te.value)}}Re.to=Ne;function ke(te){return new s.$dO(te.content.value)}Re.from=ke})(Tt||(e.ChatResponseProgressPart=Tt={}));var oi;(function(Re){function Ne(te,je,Ue){return{kind:"command",command:je.toInternal(te.value,Ue)??{command:te.value.command,title:te.value.title}}}Re.to=Ne;function ke(te,je){return new s.$eO(je.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Re.from=ke})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Ut;(function(Re){function Ne(te){return{kind:"reference",reference:y.URI.isUri(te.value)?te.value:m.from(te.value)}}Re.to=Ne;function ke(te){const je=(0,E.$Ph)(te);return new s.$fO(y.URI.isUri(je.reference)?je.reference:m.to(je.reference))}Re.from=ke})(Ut||(e.ChatResponseReferencePart=Ut={}));var xt;(function(Re){function Ne(je){return je instanceof s.$aO?mt.to(je):je instanceof s.$cO?Pt.to(je):je instanceof s.$fO?Ut.to(je):je instanceof s.$dO?Tt.to(je):je instanceof s.$bO?At.to(je):{kind:"content",content:""}}Re.to=Ne;function ke(je,Ue){switch(je.kind){case"reference":return Ut.from(je);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(je,Ue)}}Re.from=ke;function te(je,Ue){switch(je.kind){case"markdownContent":return mt.from(je);case"inlineReference":return Pt.from(je);case"progressMessage":return;case"treeData":return At.from(je);case"command":return oi.from(je,Ue)}}Re.fromContent=te})(xt||(e.ChatResponsePart=xt={}));var vt;(function(Re){function Ne(je,Ue){return"markdownContent"in Ue?((0,l.$4F)(je,"chatParticipantAdditions"),{content:N.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,l.$4F)(je,"chatParticipantAdditions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,l.$4F)(je,"chatParticipantAdditions"),{content:N.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(_e=>({uri:_e.uri,version:_e.version,ranges:_e.ranges.map(Qe=>d.from(Qe))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:d.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:d.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"participant"in Ue?((0,l.$4F)(je,"chatParticipantAdditions"),{agentName:Ue.participant,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:N.from(Ue.message),kind:"progressMessage"}:void 0}Re.from=Ne;function ke(je){switch(je.kind){case"markdownContent":case"inlineReference":case"treeData":return Re.to(je);case"content":return{content:je.content};case"usedContext":return{documents:je.documents.map(Ue=>({uri:y.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(_e=>d.to(_e))}))};case"reference":return{reference:(0,y.$vc)(je.reference)?y.URI.revive(je.reference):m.to(je.reference)};case"agentDetection":return;case"progressMessage":return{message:je.content.value};case"vulnerability":return{content:je.content,vulnerabilities:je.vulnerabilities};default:return}}Re.to=ke;function te(je,Ue){switch(je.kind){case"markdownContent":return{content:je.content.value};case"inlineReference":return{inlineReference:(0,y.$vc)(je.inlineReference)?y.URI.revive(je.inlineReference):m.to(je.inlineReference),title:je.name};case"command":return{command:Ue.fromInternal(je.command)??{command:je.command.id,title:je.command.title}};default:return}}Re.toProgressContent=te})(vt||(e.ChatResponseProgress=vt={}));var Ft;(function(Re){function Ne(ke){return{prompt:ke.message,command:ke.command,variables:ke.variables.variables.map(Wt.to)}}Re.to=Ne})(Ft||(e.ChatAgentRequest=Ft={}));var Wt;(function(Re){function Ne(ke){return{name:ke.name,range:[ke.range.start,ke.range.endExclusive],values:ke.values.map(Nt.to)}}Re.to=Ne})(Wt||(e.ChatAgentResolvedVariable=Wt={}));var zt;(function(Re){function Ne(ke){return{label:ke.label,values:ke.values.map(Nt.from),insertText:ke.insertText,detail:ke.detail,documentation:ke.documentation}}Re.from=Ne})(zt||(e.ChatAgentCompletionItem=zt={}));var yt;(function(Re){function Ne(ke){return{errorDetails:ke.errorDetails,metadata:ke.metadata}}Re.to=Ne})(yt||(e.ChatAgentResult=yt={}));var Mt;(function(Re){function Ne(ke,te,je){if(te.action.kind==="vote")return;const Ue=yt.to(ke);return te.action.kind==="command"?{action:{kind:"command",commandButton:vt.toProgressContent(te.action.commandButton,je)},result:Ue}:te.action.kind==="followUp"?{action:{kind:"followUp",followup:ni.to(te.action.followup)},result:Ue}:{action:te.action,result:Ue}}Re.to=Ne})(Mt||(e.ChatAgentUserActionEvent=Mt={}));var Et;(function(Re){function Ne(ke,te,je){return"terminalCommand"in ke?{terminalCommand:ke.terminalCommand,shouldExecute:ke.shouldExecute}:"uri"in ke?{uri:ke.uri}:te.toInternal(ke,je)}Re.from=Ne})(Et||(e.TerminalQuickFix=Et={}));var li;(function(Re){function Ne(ke){return{kind:Qt.to(ke.kind)}}Re.to=Ne})(li||(e.PartialAcceptInfo=li={}));var Qt;(function(Re){function Ne(ke){switch(ke){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Re.to=Ne})(Qt||(e.PartialAcceptTriggerKind=Qt={}));var ci;(function(Re){function Ne(ke,te){return{id:te,label:ke.label,description:ke.description,canEdit:ke.canEdit,collapsibleState:ke.collapsibleState||0,contextValue:ke.contextValue}}Re.from=Ne})(ci||(e.DebugTreeItem=ci={}))}),define(Se[324],De([1,0,6,20,16]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;let A=class{constructor(b,p){this.a=b.getProxy(u.$eM.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>p.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,p,E){const R=M.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,E?.isRefactoring??!1)}};e.$Cic=A,e.$Cic=A=Je([qe(0,L.$xO)],A)}),define(Se[325],De([1,0,19,8,44,4,48,3,38,18,2,216,25,6,16,7,286,26]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;class n{constructor(t,f,l,s,o,d){this.i=t,this.j=f,this.k=l,this.l=s,this.m=o,this.n=d,this.b=p.$2d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(s){if(t.c){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,s),o}};const t=this;this.b.reset();const l=s=>{typeof this.d>"u"&&"content"in s&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,s)};this.g={markdown(s){f(this.markdown);const o=new h.$aO(s),d=y.ChatResponseMarkdownPart.to(o);return l(d),this},filetree(s,o){f(this.filetree);const d=new h.$bO(s,o),m=y.ChatResponseFilesPart.to(d);return l(m),this},anchor(s,o){f(this.anchor);const d=new h.$cO(s,o),m=y.ChatResponseAnchorPart.to(d);return l(m),this},button(s){f(this.anchor);const o=new h.$eO(s),d=y.ChatResponseCommandButtonPart.to(o,t.m,t.n);return l(d),this},progress(s){f(this.progress);const o=new h.$dO(s),d=y.ChatResponseProgressPart.to(o);return l(d),this},reference(s){f(this.reference);const o=new h.$fO(s),d=y.ChatResponseReferencePart.to(o);return l(d),this},push(s){f(this.push);const o=y.ChatResponsePart.to(s);return l(o),this},report(s){if(f(this.report),"placeholder"in s&&"resolvedContent"in s)return;const o=y.ChatResponseProgress.from(t.i,s);if(!o){t.l.error("Unknown progress type: "+JSON.stringify(s));return}return l(o),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,l){this.i=f,this.j=l,this.c=new Map,this.g=new b.$3c,this.d=t.getProxy(S.$eM.MainThreadChatAgents2)}createChatAgent(t,f,l){const s=i.b++,o=new r(t,f,this.d,s,l);return this.c.set(s,o),this.d.$registerAgent(s,t.identifier,f,{},(0,c.$3F)(t,"chatParticipantAdditions")),o.apiAgent}async $invokeAgent(t,f,l,s){const o=this.c.get(t);if(!o)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let d=this.g.get(f.sessionId);d||(d=new b.$Sc,this.g.set(f.sessionId,d));const m=new n(o.extension,f,this.d,this.i,this.j.converter,d);try{const D=await this.k(f.agentId,l),$=o.invoke(y.ChatAgentRequest.to(f),{history:D},m.apiObject,s);return await(0,L.$7g)(Promise.resolve($).then(v=>{if(v?.metadata)try{JSON.stringify(v.metadata)}catch(k){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${o.extension.identifier.value}] [@${o.id}] ${C}`,o.extension),{errorDetails:{message:C},timings:m.timings}}return{errorDetails:v?.errorDetails,timings:m.timings,metadata:v?.metadata}}),s)}catch(D){return this.i.error(D,o.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,M.$4i)(D)),responseIsIncomplete:!0}}}finally{m.close()}}async k(t,f){const l=[];for(const s of f.history){const o=y.ChatAgentResult.to(s.result),d=t===s.request.agentId?o:{...o,metadata:void 0};l.push(new h.$gO(s.request.message,s.request.command,s.request.variables.variables.map(y.ChatAgentResolvedVariable.to),{extensionId:"",name:s.request.agentId}));const m=(0,u.$Hb)(s.response.map(D=>y.ChatResponsePart.fromContent(D,this.j.converter)));l.push(new h.$hO(m,d,{extensionId:"",name:s.request.agentId},s.request.command))}return l}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,l,s,o){const d=this.c.get(f);if(!d)return Promise.resolve([]);const m=await this.k(d.id,s),D=y.ChatAgentResult.to(l);return(await d.provideFollowups(D,{history:m},o)).filter($=>{const v=!$.participant||P.Iterable.some(this.c.values(),k=>k.id===$.participant&&w.$Bm.equals(k.extension.identifier,d.extension.identifier));return v||this.i.warn(`[@${d.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),v}).map($=>y.ChatFollowup.from($,t))}$acceptFeedback(t,f,l,s){const o=this.c.get(t);if(!o)return;const d=y.ChatAgentResult.to(f);let m;switch(l){case g.InteractiveSessionVoteDirection.Down:m=h.ChatResultFeedbackKind.Unhelpful;break;case g.InteractiveSessionVoteDirection.Up:m=h.ChatResultFeedbackKind.Helpful;break}o.acceptFeedback(Object.freeze(s?{result:d,kind:m,reportIssue:s}:{result:d,kind:m}))}$acceptAction(t,f,l){const s=this.c.get(t);if(!s||l.action.kind==="vote")return;const o=y.ChatAgentUserActionEvent.to(f,l,this.j.converter);o&&s.acceptAction(Object.freeze(o))}async $invokeCompletionProvider(t,f,l){const s=this.c.get(t);return s?(await s.invokeCompletionProvider(f,l)).map(y.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const l=this.c.get(t);if(l)return await l.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const l=this.c.get(t);if(l)return(await l.provideSampleQuestions(f)).map(s=>y.ChatFollowup.from(s,void 0))}}e.$Eic=i;class r{constructor(t,f,l,s,o){this.extension=t,this.id=f,this.x=l,this.y=s,this.z=o,this.o=new A.$6d,this.p=new A.$6d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,f){return this.s?await this.s.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,l){if(!this.b)return[];const s=await this.b.provideFollowups(t,f,l);return s?s.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const f=await this.t.provideWelcomeMessage(t);return f?f.map(l=>typeof l=="string"?l:y.MarkdownString.from(l)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const f=await this.t.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const l=()=>{t||f||(f=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof R.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof h.$cN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),f=!1}))},s=this;return{get name(){return s.id},get description(){return s.c??""},set description(o){s.c=o,l()},get fullName(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.d??s.extension.displayName??s.extension.name},set fullName(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.d=o,l()},get iconPath(){return s.g},set iconPath(o){s.g=o,l()},get requestHandler(){return s.z},set requestHandler(o){(0,E.$4f)(typeof o=="function","Invalid request handler"),s.z=o},get followupProvider(){return s.b},set followupProvider(o){s.b=o,l()},get isDefault(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.i},set isDefault(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.i=o,l()},get helpTextPrefix(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.j},set helpTextPrefix(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.j=o,l()},get helpTextVariablesPrefix(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.k},set helpTextVariablesPrefix(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.k=o,l()},get helpTextPostfix(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.l},set helpTextPostfix(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.l=o,l()},get isSecondary(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.n},set isSecondary(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.n=o,l()},get sampleRequest(){return s.m},set sampleRequest(o){s.m=o,l()},get supportIssueReporting(){return(0,c.$4F)(s.extension,"chatParticipantAdditions"),s.q},set supportIssueReporting(o){(0,c.$4F)(s.extension,"chatParticipantAdditions"),s.q=o,l()},get onDidReceiveFeedback(){return s.o.event},set participantVariableProvider(o){if((0,c.$4F)(s.extension,"chatParticipantAdditions"),s.s=o,o){if(!o.triggerCharacters.length)throw new Error("triggerCharacters are required");s.x.$registerAgentCompletionsProvider(s.y,o.triggerCharacters)}else s.x.$unregisterAgentCompletionsProvider(s.y)},get participantVariableProvider(){return(0,c.$4F)(s.extension,"chatParticipantAdditions"),s.s},set welcomeMessageProvider(o){(0,c.$4F)(s.extension,"defaultChatParticipant"),s.t=o,l()},get welcomeMessageProvider(){return(0,c.$4F)(s.extension,"defaultChatParticipant"),s.t},onDidPerformAction:(0,c.$3F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return s.u},set isSticky(o){s.u=o,l()},set requester(o){s.w=o,l()},get requester(){return s.w},dispose(){t=!0,s.b=void 0,s.o.dispose(),s.x.$unregisterAgent(s.y)}}}invoke(t,f,l,s){return this.z(t,f,l,s)}}}),define(Se[326],De([1,0,13,3,6,16,7,26]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class p{static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(M.$eM.MainThreadChatVariables)}async $resolveVariable(I,w,S,y){const h=this.b.get(I);if(h)try{if(h.resolver.resolve2){(0,b.$4F)(h.extension,"chatParticipantAdditions");const g=new E(w,this.c),c=await h.resolver.resolve2(h.data.name,{prompt:S},g.apiObject,y);if(c)return c.map(A.ChatVariable.from)}else{const g=await h.resolver.resolve(h.data.name,{prompt:S},y);if(g)return g.map(A.ChatVariable.from)}}catch(g){(0,u.$2)(g)}}registerVariableResolver(I,w,S,y){const h=p.a++;return this.b.set(h,{extension:I,data:{name:w,description:S},resolver:y}),this.c.$registerVariable(h,{name:w,description:S}),(0,L.$Rc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$Hic=p;class E{constructor(I,w){this.c=I,this.d=w,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let w=function(y){if(I.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,y),h}};const I=this,S=y=>{this.d.$handleProgressChunk(this.c,y)};this.b={progress(y){w(this.progress);const h=new P.$dO(y),g=A.ChatResponseProgressPart.to(h);return S(g),this},reference(y){w(this.reference);const h=new P.$fO(y),g=A.ChatResponseReferencePart.to(h);return S(g),this},push(y){w(this.push);const h=A.ChatResponsePart.to(y);return S(h),this}}}return this.b}}}),define(Se[327],De([1,0,8,53,4,3,2,82,25,16,7,6,26]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=S;function S(y,h,g){const c=y.getProxy(I.$eM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$Dm,h.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const m=this.b.get(d.handle);return m?m.value:d}else if(d&&d.$mid===7){const m=this.b.get(d.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.commentThreadHandle);return D?D.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const m=this.b.get(d.thread.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.thread.commentThreadHandle);return D?d.$mid===8?D.value:{thread:D.value,text:d.text}:d}else if(d&&d.$mid===10){const m=this.b.get(d.thread.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const $=d.commentUniqueId,v=D.getCommentByUniqueId($);return v||d}else if(d&&d.$mid===11){const m=this.b.get(d.thread.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const $=d.text,v=d.commentUniqueId,k=D.getCommentByUniqueId(v);return k?(typeof k.body=="string"?k.body=$:k.body=new R.$HM($),k):d}return d}})}createCommentController(d,m,D){const $=n.a++,v=new r(d,$,m,D);this.b.set(v.handle,v);const k=this.c.get(d.identifier)||[];return k.push(v),this.c.set(d.identifier,k),v.value}async $createCommentThreadTemplate(d,m,D){const $=this.b.get(d);$&&$.$createCommentThreadTemplate(m,D)}async $setActiveComment(d,m){const D=this.b.get(d);D&&D.$setActiveComment(m??void 0)}async $updateCommentThreadTemplate(d,m,D){const $=this.b.get(d);$&&$.$updateCommentThreadTemplate(m,D)}$deleteCommentThread(d,m){this.b.get(d)?.$deleteCommentThread(m)}async $provideCommentingRanges(d,m,D){const $=this.b.get(d);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const v=await g.ensureDocumentData(P.URI.revive(m));return(0,u.$$g)(async()=>{const k=await $.commentingRangeProvider.provideCommentingRanges(v.document,D);let C;return Array.isArray(k)?C={ranges:k,fileComments:!1}:k?C={ranges:k.ranges||[],fileComments:k.fileComments||!1}:C=k??void 0,C}).then(k=>{let C;return k&&(C={ranges:k.ranges.map(O=>E.Range.from(O)),fileComments:k.fileComments}),C})}$toggleReaction(d,m,D,$,v){const k=this.b.get(d);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,u.$$g)(()=>{const C=k.getCommentThread(m);if(C){const O=C.getCommentByUniqueId($.uniqueIdInThread);if(k!==void 0&&O&&k.reactionHandler)return k.reactionHandler(O,f(v))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,m,D,$,v,k,C,O){this.m=m,this.n=D,this.o=$,this.p=v,this.q=k,this.extensionDescription=C,this.r=O,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$6d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),c.$createCommentThread(m,this.handle,this.n,this.o,E.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{c.$deleteCommentThread(m,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(z){B.range=z},get comments(){return B.comments},set comments(z){B.comments=z},get collapsibleState(){return B.collapsibleState},set collapsibleState(z){B.collapsibleState=z},get canReply(){return B.canReply},set canReply(z){B.canReply=z},get contextValue(){return B.contextValue},set contextValue(z){B.contextValue=z},get label(){return B.label},set label(z){B.label=z},get state(){return B.state},set state(z){B.state=z},dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const d=D=>Object.prototype.hasOwnProperty.call(this.b,D),m={};d("range")&&(m.range=E.Range.from(this.p)),d("label")&&(m.label=this.label),d("contextValue")&&(m.contextValue=this.contextValue??null),d("comments")&&(m.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),d("collapsibleState")&&(m.collapseState=l(this.g)),d("canReply")&&(m.canReply=this.canReply),d("state")&&(m.state=s(this.h)),d("isTemplate")&&(m.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(d){for(const m of this.k){const D=m[0],$=m[1];if(d===$)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,L.$Lh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,w.$4F)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,w.$4F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,w.$4F)(this.h,"activeComment"),this.f}constructor(d,m,D,$){this.h=d,this.i=m,this.j=D,this.k=$,this.a=new Map,c.$registerCommentController(this.handle,D,$,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(k){v.options=k},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(k){v.commentingRangeProvider=k},get reactionHandler(){return v.reactionHandler},set reactionHandler(k){v.reactionHandler=k},get activeCommentThread(){return v.activeCommentThread},createCommentThread(k,C,O){return v.createCommentThread(k,C,O).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(d,m,D){m===void 0&&(0,w.$4F)(this.h,"fileComments");const $=new i(this.id,this.handle,void 0,d,m,D,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const m=this.a.get(d.commentThreadHandle);m&&(this.e=d.uniqueIdInThread?m.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=m)}$createCommentThreadTemplate(d,m){const D=new i(this.id,this.handle,void 0,P.URI.revive(d),E.Range.to(m),[],this.h,!0);return D.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(d,m){const D=this.a.get(d);D&&(D.range=E.Range.to(m))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function a(o,d,m,D){let $=m.get(d);return $||($=++o.commentHandle,m.set(d,$)),d.state!==void 0&&(0,w.$4F)(D,"commentsDraftState"),d.reactions?.some(v=>v.reactors!==void 0)&&(0,w.$4F)(D,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:$,body:typeof d.body=="string"?d.body:E.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(v=>t(v)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(o){return{label:o.label,iconPath:o.iconPath?E.$wO(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted,reactors:o.reactors&&o.reactors.length>0&&typeof o.reactors[0]!="string"?o.reactors.map(d=>d.name):o.reactors}}function f(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?P.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1,reactors:o.reactors?.map(d=>({name:d}))}}function l(o){if(o!==void 0)switch(o){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function s(o){if(o!==void 0)switch(o){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new n}}),define(Se[328],De([1,0,22,54,3,15,23,2,16,92,111,6,7]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class S{constructor(f,l){this.document=f,this.b=l,this.a=1,this.c=new R.$oic("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,l){await this.f(f).undo(),l||this.disposeBackup()}async redo(f,l){await this.f(f).redo(),l||this.disposeBackup()}disposeEdits(f){for(const l of f)this.c.delete(l)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=a(this.document.uri)+this.a++;return(0,P.$Tg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const l=this.c.get(f,0);if(!l)throw new Error("No edit found");return l}}class y{constructor(){this.a=new Map}get(f,l){return this.a.get(this.b(f,l))}add(f,l,s){const o=this.b(f,l.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${f} resource:${l.uri}`);const d=new S(l,s);return this.a.set(o,d),d}delete(f,l){const s=this.b(f,l.uri);this.a.delete(s)}b(f,l){return`${f}@@@${l}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this.a=new Map}addTextProvider(f,l,s){return this.b(0,f,l,s)}addCustomProvider(f,l,s){return this.b(1,f,l,s)}get(f){return this.a.get(f)}b(f,l,s,o){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,{type:f,extension:s,provider:o}),new w.$gM(()=>this.a.delete(l))}}class c{constructor(f,l,s,o,d){this.d=l,this.f=s,this.g=o,this.h=d,this.b=new g,this.c=new y,this.a=f.getProxy(I.$eM.MainThreadCustomEditors)}registerCustomEditorProvider(f,l,s,o){const d=new M.$Sc;return i(s)?(d.add(this.b.addTextProvider(l,f,s)),this.a.$registerTextEditorProvider((0,E.$1ic)(f),l,o.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,E.$Yic)(f))):(d.add(this.b.addCustomProvider(l,f,s)),n(s)&&d.add(s.onDidChangeCustomDocument(m=>{const D=this.i(l,m.document.uri);if(r(m)){const $=D.addEdit(m);this.a.$onDidEdit(m.document.uri,l,$,m.label)}else this.a.$onContentChange(m.document.uri,l)})),this.a.$registerCustomEditorProvider((0,E.$1ic)(f),l,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,E.$Yic)(f))),w.$gM.from(d,new w.$gM(()=>{this.a.$unregisterEditorProvider(l)}))}async $createCustomDocument(f,l,s,o,d){const m=this.b.get(l);if(!m)throw new Error(`No provider found for '${l}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${l}'`);const D=b.URI.revive(f),$=await m.provider.openCustomDocument(D,{backupId:s,untitledDocumentData:o?.buffer},d);let v;return n(m.provider)&&this.f&&(v=this.f.workspaceValue(m.extension)??this.f.globalValue(m.extension)),this.c.add(l,$,v),{editable:n(m.provider)}}async $disposeCustomDocument(f,l){const s=this.b.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${l}'`);const o=b.URI.revive(f),{document:d}=this.i(l,o);this.c.delete(l,d),d.dispose()}async $resolveCustomEditor(f,l,s,o,d,m){const D=this.b.get(s);if(!D)throw new Error(`No provider found for '${s}'`);const $=p.ViewColumn.to(d),v=this.g.createNewWebview(l,o.contentOptions,D.extension),k=this.h.createNewWebviewPanel(l,s,o.title,$,o.options,v,o.active),C=b.URI.revive(f);switch(D.type){case 1:{const{document:O}=this.i(s,C);return D.provider.resolveCustomEditor(O,k,m)}case 0:{const O=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(O,k,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,l,s){this.i(l,f).disposeEdits(s)}async $onMoveCustomEditor(f,l,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const d=this.h.getWebviewPanel(f);if(!d)throw new Error("No webview found");const m=b.URI.revive(l),D=this.d.getDocument(m);await o.provider.moveCustomTextEditor(D,d,u.CancellationToken.None)}async $undo(f,l,s,o){return this.i(l,f).undo(s,o)}async $redo(f,l,s,o){return this.i(l,f).redo(s,o)}async $revert(f,l,s){const o=this.i(l,f);await this.j(l).revertCustomDocument(o.document,s),o.disposeBackup()}async $onSave(f,l,s){const o=this.i(l,f);await this.j(l).saveCustomDocument(o.document,s),o.disposeBackup()}async $onSaveAs(f,l,s,o){const d=this.i(l,f);return this.j(l).saveCustomDocumentAs(d.document,b.URI.revive(s),o)}async $backup(f,l,s){const o=this.i(l,f),m=await this.j(l).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},s);return o.updateBackup(m),m.id}i(f,l){const s=this.c.get(f,b.URI.revive(l));if(!s)throw new Error("No custom document found");return s}j(f){const s=this.b.get(f)?.provider;if(!s||!n(s))throw new Error("Custom document is not editable");return s}}e.$4ic=c;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const f=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,L.$7i)(f)+""}}),define(Se[329],De([1,0,217,138,2,6,7,16,4,12,28,59]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;class S{#e;#t;#i;constructor(g,c,n,i,r,a,t,f){this.d=g,this.e=c,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new R.$Ac(l=>a.getComparisonKey(l)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,c){if(!g){this.clear();return}this.j();let n=[];if(M.URI.isUri(g)){if(!c){this.delete(g);return}this.#i.set(g,c.slice()),n=[g]}else if(Array.isArray(g)){n=[];let a;g=[...g].sort(S.k);for(const t of g){const[f,l]=t;if((!a||f.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=f,n.push(f),this.#i.set(f,[])),l)this.#i.get(f)?.push(...l);else{const s=this.#i.get(f);s&&(s.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const a of n){let t=[];const f=this.#i.get(a);if(f)if(f.length>this.g){t=[];const l=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const o of f)if(o.severity===l[s]&&t.push({...b.Diagnostic.from(o),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(l=>({...b.Diagnostic.from(l),modelVersionId:this.h(a)}));if(i.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,c){this.j();for(const[n,i]of this)g.call(c,n,i,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const c=this.#i.get(g);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,c){return g[0].toString()<c[0].toString()?-1:g[0].toString()>c[0].toString()?1:0}}e.$vic=S;let y=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(g){const c=new R.$Ac;for(const n of g)c.set(n,n);return{uris:Object.freeze(Array.from(c.values()))}}constructor(g,c,n,i){this.j=c,this.k=n,this.l=i,this.g=new Map,this.h=new p.$0d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,w._mapper),this.f=g.getProxy(A.$eM.MainThreadDiagnostics)}createDiagnosticCollection(g,c){const{g:n,f:i,h:r,j:a,k:t,l:f}=this,l=new class{$changeMany(d,m){i.$changeMany(d,m),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,d,m.length===0?"CLEARING":m)}$clear(d){i.$clear(d),a.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,d)}dispose(){i.dispose()}};let s;if(!c)c="_generated_diagnostic_collection_name_#"+w.c++,s=c;else if(!n.has(c))s=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do s=c+w.c++;while(n.has(s))}return new class extends S{constructor(){super(c,s,w.e,w.d,d=>f.getDocument(d)?.version,t.extUri,l,r),n.set(s,this)}dispose(){super.dispose(),n.delete(s)}}}getDiagnostics(g){if(g)return this.m(g);{const c=new Map,n=[];for(const i of this.g.values())i.forEach((r,a)=>{let t=c.get(r.toString());typeof t>"u"&&(t=n.length,c.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...a)});return n}}m(g){let c=[];for(const n of this.g.values())n.has(g)&&(c=c.concat(n.get(g)));return c}$acceptMarkersChange(g){if(!this.n){const c="_generated_mirror",n=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,n),this.n=n}for(const[c,n]of g)this.n.set(M.URI.revive(c),n.map(b.Diagnostic.to))}};e.$wic=y,e.$wic=y=w=Je([qe(1,E.$Mj),qe(2,I.$uic)],y)}),define(Se[330],De([1,0,2,13,7,16,74]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class b{constructor(E,R,I,w={timeout:1500,errors:3}){this.c=E,this.d=R,this.f=I,this.g=w,this.a=new P.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(R,I,w)=>{const y={dispose:this.a.push([R,I,E])};return Array.isArray(w)&&w.push(y),y}}async $participateInSave(E,R){const I=u.URI.revive(E);let w=!1;const S=setTimeout(()=>w=!0,this.g.timeout),y=[];try{for(const h of[...this.a]){if(w)break;const g=this.d.getDocument(I),c=await this.h(h,{document:g,reason:A.TextDocumentSaveReason.to(R)});y.push(c)}}finally{clearTimeout(S)}return y}h([E,R,I],w){const S=this.b.get(E);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(I,E,R,w).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const h=this.b.get(E);this.b.set(E,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,R,I,w){const S=[],y=Date.now(),{document:h,reason:g}=w,{version:c}=h,n=Object.freeze({document:h,reason:g,waitUntil(i){if(Object.isFrozen(S))throw(0,L.$8)("waitUntil can not be called async");S.push(Promise.resolve(i))}});try{R.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(S),new Promise((i,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(a),i(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(i=>{const r={edits:[]};for(const a of i)if(Array.isArray(a)&&a.every(t=>t instanceof M.$nM))for(const{newText:t,newEol:f,range:l}of a)r.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:l&&A.Range.from(l),text:t,eol:f&&A.EndOfLine.from(f)}});if(r.edits.length!==0)return c===h.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Fjc=b}),define(Se[331],De([1,0,4,3,2,6,152,16,18,24,7]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class I{constructor(S,y){this.a=new u.$6d,this.b=new u.$6d,this.c=new u.$6d,this.d=new u.$6d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Sc,this.h=new Map,this.f=S.getProxy(A.$eM.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(h=>{for(const g of h)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const g of h)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const y=this.g.getDocument(S);if(y)return y}getDocument(S){const y=this.getDocumentData(S);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return y.document}ensureDocumentData(S){const y=this.g.getDocument(S);if(y)return Promise.resolve(y);let h=this.h.get(S.toString());return h||(h=this.f.$tryOpenDocument(S).then(g=>{this.h.delete(S.toString());const c=M.URI.revive(g);return(0,p.$5f)(this.g.getDocument(c))},g=>(this.h.delete(S.toString()),Promise.reject(g))),this.h.set(S.toString(),h)),h}createDocumentData(S){return this.f.$tryCreateDocument(S).then(y=>M.URI.revive(y))}$acceptModelLanguageChanged(S,y){const h=M.URI.revive(S),g=this.g.getDocument(h);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(y),this.a.fire(g.document)}$acceptModelSaved(S){const y=M.URI.revive(S),h=this.g.getDocument(y);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(S,y){const h=M.URI.revive(S),g=this.g.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(y),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,y,h){const g=M.URI.revive(S),c=this.g.getDocument(g);if(!c)throw new Error("unknown document");c._acceptIsDirty(h),c.onEvents(y);let n;y.isUndoing?n=R.TextDocumentChangeReason.Undo:y.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Nn)({document:c.document,contentChanges:y.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(S,y){(0,P.$zO)(S,y)}}e.$xic=I}),define(Se[70],De([1,0,72,4,18,2,5,6,20,16,7]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=void 0,e.$5ic=(0,P.$gi)("IExtHostEditorTabs");class I{constructor(g,c,n){this.e=n,this.d=c,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,c={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$2N(A.URI.revive(this.b.input.uri));case 2:return new R.$3N(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new R.$4N(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new R.$5N(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$6N(this.b.input.viewType);case 4:return new R.$7N(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$8N(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$9N;case 9:return new R.$0N(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$$N(this.b.input.providerId);default:return}}}class w{constructor(g,c){this.c=[],this.d="",this.b=g,this.e=c;for(const n of g.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,c={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return E.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(n=>n.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(n=>n.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const n=new I(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,n),g.tabDto.isActive&&(this.d=n.tabId),n}else if(g.kind===1){const n=this.c.splice(g.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(g.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,n),n}const c=this.c.find(n=>n.tabId===g.tabDto.id);if(!c)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(g.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(g){this.b=new L.$6d,this.c=new L.$6d,this.e=[],this.a=g.getProxy(b.$eM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,c={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(n=>n.apiObject))},get activeTabGroup(){const n=g.d;return(0,M.$5f)(g.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?y(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(g){const c=new Set(this.e.map(l=>l.groupId)),n=new Set(g.map(l=>l.groupId)),i=(0,u.$L)(c,n),r=this.e.filter(l=>i.removed.includes(l.groupId)).map(l=>l.apiObject),a=[],t=[];this.e=g.map(l=>{const s=new w(l,()=>this.d);return i.added.includes(s.groupId)?a.push(s.apiObject):t.push(s.apiObject),s});const f=(0,M.$5f)(g.find(l=>l.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(g){const c=this.e.find(n=>n.groupId===g.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const c=this.e.find(i=>i.groupId===g.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const n=c.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(g){for(const c of this.e)for(const n of c.tabs)if(n.apiObject===g)return n}h(g){return this.e.find(c=>c.apiObject===g)}async i(g,c){const n=[];for(const i of g){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,c)}async j(g,c){const n=[];for(const i of g){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,c)}};e.$6ic=S,e.$6ic=S=Je([qe(0,p.$xO)],S);function y(h){return h.tabs!==void 0}}),define(Se[332],De([1,0,2,6,3,7,16,178,14,21,26,79]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class w{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const g=this.a.indexOf(h);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),g=[];let c,n,i=14,r=14;for(const a of h){let t=c?(0,p.$mf)(c,a):0;for(t===0?n=1:n=r;t<a.length;t++)t+1===a.length?(i=r,r=9):r+=1,g.push([n,a.toUpperCase().charCodeAt(t),r]),g.push([n,a.toLowerCase().charCodeAt(t),r]),n=r;c=a,r=i}g.push([9,58,10]),g.push([10,47,12]),this.b=new b.$h2(g)}}provideDocumentLinks(h){this.c();const g=[],c=b.$i2.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of c){const i=P.DocumentLink.to(n);i.target&&g.push(i)}return g}}class S{constructor(h,g){this.i=g,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(L.$eM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,g,c,n={}){if(S.j(c),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,c);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof c.copy=="function"&&(r+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,R.$4F)(h,"fsChunks"),r+=4);let a;n.isReadonly&&(0,I.$Fk)(n.isReadonly)&&n.isReadonly.value!==""&&(a={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,r,a).catch(f=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${g}`),console.error(f)});const t=c.onDidChangeFile(f=>{const l=[];for(const s of f){const{uri:o,type:d}=s;if(o.scheme!==g)continue;let m;switch(d){case A.FileChangeType.Changed:m=0;break;case A.FileChangeType.Created:m=1;break;case A.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:o,type:m})}this.a.$onFileSystemChange(i,l)});return(0,M.$Rc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:g,ctime:c,mtime:n,size:i,permissions:r}=h;return{type:g,ctime:c,mtime:n,size:i,permissions:r}}$stat(h,g){return Promise.resolve(this.l(h).stat(u.URI.revive(g))).then(c=>S.k(c))}$readdir(h,g){return Promise.resolve(this.l(h).readDirectory(u.URI.revive(g)))}$readFile(h,g){return Promise.resolve(this.l(h).readFile(u.URI.revive(g))).then(c=>E.$te.wrap(c))}$writeFile(h,g,c,n){return Promise.resolve(this.l(h).writeFile(u.URI.revive(g),c.buffer,n))}$delete(h,g,c){return Promise.resolve(this.l(h).delete(u.URI.revive(g),c))}$rename(h,g,c,n){return Promise.resolve(this.l(h).rename(u.URI.revive(g),u.URI.revive(c),n))}$copy(h,g,c,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(g),u.URI.revive(c),n))}$mkdir(h,g){return Promise.resolve(this.l(h).createDirectory(u.URI.revive(g)))}$watch(h,g,c,n){const i=this.l(h).watch(u.URI.revive(c),n);this.f.set(g,i)}$unwatch(h,g){const c=this.f.get(g);c&&(c.dispose(),this.f.delete(g))}$open(h,g,c){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(g),c))}$close(h,g){const c=this.l(h);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(g))}$read(h,g,c,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=E.$te.alloc(n);return Promise.resolve(i.read(g,c,r.buffer,0,n)).then(a=>r.slice(0,a))}$write(h,g,c,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,c,n.buffer,0,n.byteLength))}l(h){const g=this.c.get(h);if(!g){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return g}}e.$Hjc=S}),define(Se[333],De([1,0,4,35,2,6,16,7,43]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,y,h,g,c,n){this.a=Math.random(),this.b=new u.$6d,this.c=new u.$6d,this.d=new u.$6d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,L.$ak)(c),r=typeof c=="string",a=n?.correlate,t=g(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(a&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const l of f.created){const s=M.URI.revive(l);i(s.fsPath)&&(!r||y.getWorkspaceFolder(s))&&this.b.fire(s)}if(!n?.ignoreChangeEvents)for(const l of f.changed){const s=M.URI.revive(l);i(s.fsPath)&&(!r||y.getWorkspaceFolder(s))&&this.c.fire(s)}if(!n?.ignoreDeleteEvents)for(const l of f.deleted){const s=M.URI.revive(l);i(s.fsPath)&&(!r||y.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=b.$gM.from(this.i(S,h,c,n,n?.correlate),this.b,this.c,this.d,t)}i(S,y,h,g,c){const n=b.$gM.from();if(typeof h=="string")return n;const i=S.getProxy(A.$eM.MainThreadFileSystemEventService);let r=!1;return(h.pattern.includes(L.$9j)||h.pattern.includes(L.$0j))&&(r=!0),i.$watch(y.identifier.value,this.a,h.baseUri,{recursive:r,excludes:g?.excludes??[]},!!c),b.$gM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(S){this.a=S,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map(M.URI.revive)),this.c=new p.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(S,y,h){this.j=S,this.k=y,this.l=h,this.a=new u.$6d,this.b=new u.$6d,this.c=new u.$6d,this.d=new u.$6d,this.g=new u.$8d,this.h=new u.$8d,this.i=new u.$8d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,y,h,g){return new E(this.j,S,y,this.a.event,P.GlobPattern.from(h),g)}$onFileEvent(S){this.a.fire(new R(S))}$onDidRunFileOperation(S,y){switch(S){case 2:this.b.fire(Object.freeze({files:y.map(h=>({oldUri:M.URI.revive(h.source),newUri:M.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:y.map(h=>M.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:y.map(h=>M.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,y){return(h,g,c)=>{const n=function(r){h.call(g,r)};return n.extension=S,y.event(n,void 0,c)}}async $onWillRunFileOperation(S,y,h,g){switch(S){case 2:return await this.n(this.g,{files:y.map(c=>({oldUri:M.URI.revive(c.source),newUri:M.URI.revive(c.target)}))},h,g);case 1:return await this.n(this.i,{files:y.map(c=>M.URI.revive(c.target))},h,g);case 0:case 3:return await this.n(this.h,{files:y.map(c=>M.URI.revive(c.target))},h,g)}}async n(S,y,h,g){const c=new Set,n=[];if(await S.fireAsync(y,g,async(r,a)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof b.$qM&&(n.push([a.extension,f]),c.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:a}=P.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(a)}return{edit:i,extensionNames:Array.from(c)}}}e.$Ijc=I}),define(Se[334],De([1,0,19,8,22,13,124,3,24,38,14,18,2,29,174,82,134,219,25,16,7,26,111,6]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class l{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const J=this.d.getDocument(q),X=await this.e.provideDocumentSymbols(J,V);if(!(0,u.$Kb)(X))return X[0]instanceof r.$zM?X.map(i.DocumentSymbol.from):l.f(X)}static f(q){q=q.slice(0).sort((X,me)=>{let ve=X.location.range.start.compareTo(me.location.range.start);return ve===0&&(ve=me.location.range.end.compareTo(X.location.range.end)),ve});const V=[],J=[];for(const X of q){const me={name:X.name||"!!MISSING: name!!",kind:i.SymbolKind.from(X.kind),tags:X.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:i.Range.from(X.location.range),selectionRange:i.Range.from(X.location.range),children:[]};for(;;){if(J.length===0){J.push(me),V.push(me);break}const ve=J[J.length-1];if(S.$$s.containsRange(ve.range,me.range)&&!S.$$s.equalsRange(ve.range,me.range)){ve.children?.push(me),J.push(me);break}J.pop()}}return V}}class s{constructor(q,V,J,X,me,ve){this.f=q,this.g=V,this.h=J,this.j=X,this.k=me,this.l=ve,this.d=new t.$oic("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const J=this.f.getDocument(q),X=await this.h.provideCodeLenses(J,V);if(!X||V.isCancellationRequested)return;const me=this.d.add(X),ve=new b.$Sc;this.e.set(me,ve);const Te={cacheId:me,lenses:[]};for(let He=0;He<X.length;He++)Te.lenses.push({cacheId:[me,He],range:i.Range.from(X[He].range),command:this.g.toInternal(X[He].command,ve)});return Te}async resolveCodeLens(q,V){const J=q.cacheId&&this.d.get(...q.cacheId);if(!J)return;let X;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?X=J:X=await this.h.resolveCodeLens(J,V),X||(X=J),V.isCancellationRequested)return;const me=q.cacheId&&this.e.get(q.cacheId[0]);if(me){if(!X.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return q.command=this.g.toInternal(X.command,me),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function o(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class d{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideDefinition(X,me,J);return o(ve)}}class m{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideDeclaration(X,me,J);return o(ve)}}class D{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideImplementation(X,me,J);return o(ve)}}class ${constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideTypeDefinition(X,me,J);return o(ve)}}class v{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideHover(X,me,J);if(!(!ve||(0,u.$Kb)(ve.contents)))return ve.range||(ve.range=X.getWordRangeAtPosition(me)),ve.range||(ve.range=new r.$iM(me,me)),i.Hover.from(ve)}}class k{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideEvaluatableExpression(X,me,J);if(ve)return i.EvaluatableExpression.from(ve)}}class C{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,J,X){const me=this.d.getDocument(q),ve=await this.e.provideInlineValues(me,i.Range.to(V),i.InlineValueContext.to(J),X);if(Array.isArray(ve))return ve.map(Te=>i.InlineValue.from(Te))}}class O{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideDocumentHighlights(X,me,J);if(Array.isArray(ve))return ve.map(i.DocumentHighlight.from)}}class B{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,J,X){const me=this.d.getDocument(q),ve=J.map(Ze=>this.d.getDocument(Ze)),Te=i.Position.to(V),He=await this.e.provideMultiDocumentHighlights(me,Te,ve,X);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class z{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,J){const X=this.d.getDocument(q),me=i.Position.to(V),ve=await this.e.provideLinkedEditingRanges(X,me,J);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,u.$Hb)(ve.ranges.map(i.Range.from)),wordPattern:ve.wordPattern}}}class T{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,J,X){const me=this.d.getDocument(q),ve=i.Position.to(V),Te=await this.e.provideReferences(me,ve,J,X);if(Array.isArray(Te))return Te.map(i.location.from)}}class j{static{this.d=1e3}constructor(q,V,J,X,me,ve,Te){this.g=q,this.h=V,this.j=J,this.k=X,this.l=me,this.m=ve,this.n=Te,this.e=new t.$oic("CodeAction"),this.f=new Map}async provideCodeActions(q,V,J,X){const me=this.g.getDocument(q),ve=y.$at.isISelection(V)?i.Selection.to(V):i.Range.to(V),Te=[];for(const rt of this.j.getDiagnostics(q))if(ve.intersection(rt.range)&&Te.push(rt)>j.d)break;const He={diagnostics:Te,only:J.only?new r.$BM(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ze=await this.k.provideCodeActions(me,ve,He,X);if(!(0,u.$Lb)(Ze)||X.isCancellationRequested)return;const tt=this.e.add(Ze),nt=new b.$Sc;this.f.set(tt,nt);const at=[];for(let rt=0;rt<Ze.length;rt++){const Ce=Ze[rt];if(Ce)if(j.o(Ce))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Ce.title,command:this.h.toInternal(Ce,nt)});else{He.only&&(Ce.kind?He.only.contains(Ce.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ce.ranges??[];at.push({cacheId:[tt,rt],title:Ce.title,command:Ce.command&&this.h.toInternal(Ce.command,nt),diagnostics:Ce.diagnostics&&Ce.diagnostics.map(i.Diagnostic.from),edit:Ce.edit&&i.WorkspaceEdit.from(Ce.edit,void 0),kind:Ce.kind&&Ce.kind.value,isPreferred:Ce.isPreferred,isAI:(0,a.$3F)(this.m,"codeActionAI")?Ce.isAI:!1,ranges:(0,a.$3F)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:Ce.disabled?.reason})}}return{cacheId:tt,actions:at}}async resolveCodeAction(q,V){const[J,X]=q,me=this.e.get(J,X);if(!me||j.o(me))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction(me,V)??me;let Te;ve.edit&&(Te=i.WorkspaceEdit.from(ve.edit,void 0));let He;if(ve.command){const Ze=this.f.get(J);Ze&&(He=this.h.toInternal(ve.command,Ze))}return{edit:Te,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class N{constructor(q,V,J,X,me){this.e=q,this.f=V,this.g=J,this.h=X,this.j=me,this.d=new t.$oic("DocumentPasteEdit")}async prepareDocumentPaste(q,V,J,X){if(!this.g.prepareDocumentPaste)return;const me=this.f.getDocument(q),ve=V.map(Ze=>i.Range.to(Ze)),Te=i.DataTransfer.toDataTransfer(J,()=>{throw new A.$$});if(await this.g.prepareDocumentPaste(me,ve,Te,X),X.isCancellationRequested)return;const He=Array.from(Te).filter(([,Ze])=>!(Ze instanceof r.$8M));return i.DataTransfer.from(He)}async providePasteEdits(q,V,J,X,me,ve){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(V),He=J.map(at=>i.Range.to(at)),Ze=i.DataTransfer.toDataTransfer(X,async at=>(await this.e.$resolvePasteFileData(this.h,q,at)).buffer),tt=await this.g.provideDocumentPasteEdits(Te,He,Ze,{only:me.only?new r.$aN(me.only):void 0,triggerKind:me.triggerKind},ve);if(!tt||ve.isCancellationRequested)return[];const nt=this.d.add(tt);return tt.map((at,rt)=>({_cacheId:[nt,rt],title:at.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,detail:this.j.displayName||this.j.name,yieldTo:at.yieldTo?.map(Ce=>"mimeType"in Ce?Ce:{kind:Ce.kind.value}),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[J,X]=q,me=this.d.get(J,X);if(!me||!this.g.resolveDocumentPasteEdit)return{};const ve=await this.g.resolveDocumentPasteEdit(me,V)??me;return{additionalEdit:ve.additionalEdit?i.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class F{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,J){const X=this.d.getDocument(q),me=await this.e.provideDocumentFormattingEdits(X,V,J);if(Array.isArray(me))return me.map(i.TextEdit.from)}}class K{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,J,X){const me=this.d.getDocument(q),ve=i.Range.to(V),Te=await this.e.provideDocumentRangeFormattingEdits(me,ve,J,X);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,J,X){(0,I.$4f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const me=this.d.getDocument(q),ve=V.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(me,ve,J,X);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class ee{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,J,X,me){const ve=this.d.getDocument(q),Te=i.Position.to(V),He=await this.e.provideOnTypeFormattingEdits(ve,Te,J,X,me);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class Y{constructor(q,V){this.e=q,this.f=V,this.d=new t.$oic("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const J=await this.e.provideWorkspaceSymbols(q,V);if(!(0,u.$Lb)(J))return{symbols:[]};const X=this.d.add(J),me={cacheId:X,symbols:[]};for(let ve=0;ve<J.length;ve++){const Te=J[ve];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}me.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[X,ve]})}return me}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const J=this.d.get(...q.cacheId);if(J){const X=await this.e.resolveWorkspaceSymbol(J,V);return X&&(0,p.$Pn)(q,i.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class Q{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideRenameEdits(q,V,J,X){const me=this.d.getDocument(q),ve=i.Position.to(V);try{const Te=await this.e.provideRenameEdits(me,ve,J,X);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=Q.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(q,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(q),me=i.Position.to(V);try{const ve=await this.e.prepareRename(X,me,J);let Te,He;if(r.$iM.isRange(ve)?(Te=ve,He=X.getText(ve)):(0,I.$Vf)(ve)&&(Te=ve.range,He=ve.placeholder),!Te||!He)return;if(Te.start.line>me.line||Te.end.line<me.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(ve){const Te=Q.g(ve);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ve)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Z{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideNewSymbolNames(q,V,J){const X=this.d.getDocument(q),me=i.Range.to(V);try{const ve=await this.e.provideNewSymbolNames(X,me,J);return ve?ve.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(ve){this.f.error(Z.g(ve)??JSON.stringify(ve,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ae{constructor(q,V){this.resultId=q,this.tokens=V}}class _{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,J){const X=this.f.getDocument(q),me=V!==0?this.d.get(V):null;let ve=typeof me?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,me.resultId,J):await this.g.provideDocumentSemanticTokens(X,J);return me&&this.d.delete(V),ve?(ve=_.h(ve),this.o(_.n(me,ve),ve)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return _.j(q)?_.k(q)?q:new r.$AN(new Uint32Array(q.data),q.resultId):_.l(q)?_.m(q)?q:new r.$CN(q.edits.map(V=>new r.$BN(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!_.j(V)||!q||!q.tokens)return V;const J=q.tokens,X=J.length,me=V.data,ve=me.length;let Te=0;const He=Math.min(X,ve);for(;Te<He&&J[Te]===me[Te];)Te++;if(Te===X&&Te===ve)return new r.$CN([],V.resultId);let Ze=0;const tt=He-Te;for(;Ze<tt&&J[X-Ze-1]===me[ve-Ze-1];)Ze++;return new r.$CN([{start:Te,deleteCount:X-Te-Ze,data:me.subarray(Te,ve-Ze)}],V.resultId)}o(q,V){if(_.j(q)){const J=this.e++;return this.d.set(J,new ae(q.resultId,q.data)),(0,g.$lab)({id:J,type:"full",data:q.data})}if(_.l(q)){const J=this.e++;return _.j(V)?this.d.set(J,new ae(V.resultId,V.data)):this.d.set(J,new ae(q.resultId)),(0,g.$lab)({id:J,type:"delta",deltas:(q.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class ge{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,J){const X=this.d.getDocument(q),me=await this.e.provideDocumentRangeSemanticTokens(X,i.Range.to(V),J);return me?this.f(me):null}f(q){return(0,g.$lab)({id:0,type:"full",data:q.data})}}class se{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,J,X,me){this.f=q,this.g=V,this.h=J,this.j=X,this.k=me,this.d=new t.$oic("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,J,X){const me=this.f.getDocument(q),ve=i.Position.to(V),Te=me.getWordRangeAtPosition(ve)||new r.$iM(ve,ve),He=Te.with({end:ve}),Ze=new E.$2d,tt=await this.h.provideCompletionItems(me,ve,X,i.CompletionContext.to(J));if(!tt||X.isCancellationRequested)return;const nt=Array.isArray(tt)?new r.$OM(tt):tt,at=se.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new b.$Sc;this.e.set(at,rt);const Ce=[],Be={x:at,b:Ce,a:{replace:i.Range.from(Te),insert:i.Range.from(He)},c:nt.isIncomplete||void 0,d:Ze.elapsed()};for(let Me=0;Me<nt.items.length;Me++){const Ke=nt.items[Me],ne=this.l(Ke,[at,Me],He,Te);Ce.push(ne)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...q);if(!J)return;const X=this.l(J,q),me=await this.h.resolveCompletionItem(J,V);if(!me)return;const ve=this.l(me,q);return(X.h!==ve.h||X.i!==ve.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==ve.n||X.o!==ve.o||!(0,p.$Qn)(X.p,ve.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:ve.d,c:ve.c,l:ve.l,h:ve.h,i:ve.i,n:ve.n,o:ve.o,p:ve.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,J,X){const me=this.e.get(V[0]);if(!me)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(q.command,me),Te={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=q.textEdit.newText):typeof q.insertText=="string"?Te.h=q.insertText:q.insertText instanceof r.$rM&&(Te.h=q.insertText.value,Te.i|=4);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),r.$iM.isRange(He)?Te.j=i.Range.from(He):He&&(!J?.isEqual(He.inserting)||!X?.isEqual(He.replacing))&&(Te.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class re{async provideInlineCompletions(q,V,J,X){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,J){}handlePartialAccept(q,V,J,X){}}class U extends re{constructor(q,V,J,X){super(),this.f=q,this.g=V,this.h=J,this.j=X,this.d=new ye,this.e=(0,a.$3F)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,a.$3F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,J,X){const me=this.g.getDocument(q),ve=i.Position.to(V),Te=await this.h.provideInlineCompletionItems(me,ve,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},X);if(!Te||X.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Ze=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],tt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,Ce)=>{let Be;rt.command&&(nt||(nt=new b.$Sc),Be=this.j.toInternal(rt.command,nt));const Me=rt.insertText;return{insertText:typeof Me=="string"?Me:{snippet:Me.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:Be,idx:Ce,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ze.map(rt=>(nt||(nt=new b.$Sc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,J){const X=this.d.get(q)?.items[V];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,J)}handlePartialAccept(q,V,J,X){const me=this.d.get(q)?.items[V];me&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(me,J),this.h.handleDidPartiallyAcceptCompletionItem(me,i.PartialAcceptInfo.to(X)))}}class ie{async provideInlineEdits(q,V,J){const X=this.f.getDocument(q),me=await this.g.provideInlineEdit(X,{triggerKind:this.e[V.triggerKind]},J);if(!me||J.isCancellationRequested)return;let ve;const Te=this.d.createReferenceId({dispose(){ve?.dispose()},item:me});let He;me.accepted&&(ve||(ve=new b.$Sc),He=this.h.toInternal(me.accepted,ve));let Ze;return me.rejected&&(ve||(ve=new b.$Sc),Ze=this.h.toInternal(me.rejected,ve)),{pid:Te,text:me.text,range:i.Range.from(me.range),accepted:He,rejected:Ze}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,J,X){this.f=V,this.g=J,this.h=X,this.d=new ye,this.e={[h.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ye{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class le{constructor(q,V){this.e=q,this.f=V,this.d=new t.$oic("SignatureHelp")}async provideSignatureHelp(q,V,J,X){const me=this.e.getDocument(q),ve=i.Position.to(V),Te=this.g(J),He=await this.f.provideSignatureHelp(me,ve,X,Te);if(He){const Ze=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Ze}}}g(q){let V;if(q.activeSignatureHelp){const J=i.SignatureHelp.to(q.activeSignatureHelp),X=this.d.get(q.activeSignatureHelp.id,0);X?(V=X,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class ue{constructor(q,V,J,X,me){this.f=q,this.g=V,this.h=J,this.j=X,this.k=me,this.d=new t.$oic("InlayHints"),this.e=new Map}async provideInlayHints(q,V,J){const X=this.f.getDocument(q),me=i.Range.to(V),ve=await this.h.provideInlayHints(X,me,J);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const Te=this.d.add(ve);this.e.set(Te,new b.$Sc);const He={hints:[],cacheId:Te};for(let Ze=0;Ze<ve.length;Ze++)this.l(ve[Ze],me)&&He.hints.push(this.m(ve[Ze],[Te,Ze]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),He}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...q);if(!J)return;const X=await this.h.resolveInlayHint(J,V);if(X&&this.l(X))return this.m(X,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const X={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")X.label=q.label;else{const me=[];X.label=me;for(const ve of q.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:ve.value,tooltip:i.MarkdownString.fromStrict(ve.tooltip)};r.$sM.isLocation(ve.location)&&(Te.location=i.location.from(ve.location)),ve.command&&(Te.command=this.g.toInternal(ve.command,J)),me.push(Te)}}return X}}class ce{constructor(q,V){this.e=q,this.f=V,this.d=new t.$oic("DocumentLink")}async provideLinks(q,V){const J=this.e.getDocument(q),X=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(X)||X.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(ce.g).map(i.DocumentLink.from)};{const me=this.d.add(X),ve={links:[],cacheId:me};for(let Te=0;Te<X.length;Te++){if(!ce.g(X[Te]))continue;const He=i.DocumentLink.from(X[Te]);He.cacheId=[me,Te],ve.links.push(He)}return ve}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...q);if(!J)return;const X=await this.f.resolveDocumentLink(J,V);if(!(!X||!ce.g(X)))return i.DocumentLink.from(X)}releaseLinks(q){this.d.delete(q)}}class de{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const J=this.d.getDocument(q),X=await this.e.provideDocumentColors(J,V);return Array.isArray(X)?X.map(ve=>({color:i.Color.from(ve.color),range:i.Range.from(ve.range)})):[]}async provideColorPresentations(q,V,J){const X=this.d.getDocument(q),me=i.Range.to(V.range),ve=i.Color.to(V.color),Te=await this.e.provideColorPresentations(ve,{document:X,range:me},J);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class H{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,J){const X=this.d.getDocument(q),me=await this.e.provideFoldingRanges(X,V,J);if(Array.isArray(me))return me.map(i.FoldingRange.from)}}class x{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideSelectionRanges(q,V,J){const X=this.d.getDocument(q),me=V.map(i.Position.to),ve=await this.e.provideSelectionRanges(X,me,J);if(!(0,u.$Lb)(ve))return[];if(ve.length!==me.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<me.length;He++){const Ze=[];Te.push(Ze);let tt=me[He],nt=ve[He];for(;;){if(!nt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(i.SelectionRange.from(nt)),!nt.parent)break;tt=nt.range,nt=nt.parent}}return Te}}class he{constructor(q,V){this.f=q,this.g=V,this.d=new P.$CO(""),this.e=new Map}async prepareSession(q,V,J){const X=this.f.getDocument(q),me=i.Position.to(V),ve=await this.g.prepareCallHierarchy(X,me,J);if(!ve)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ve)?ve.map(He=>this.h(Te,He)):[this.h(Te,ve)]}async provideCallsTo(q,V,J){const X=this.j(q,V);if(!X)throw new Error("missing call hierarchy item");const me=await this.g.provideCallHierarchyIncomingCalls(X,J);if(me)return me.map(ve=>({from:this.h(q,ve.from),fromRanges:ve.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(q,V,J){const X=this.j(q,V);if(!X)throw new Error("missing call hierarchy item");const me=await this.g.provideCallHierarchyOutgoingCalls(X,J);if(me)return me.map(ve=>({to:this.h(q,ve.to),fromRanges:ve.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),X=i.CallHierarchyItem.from(V,q,J.size.toString(36));return J.set(X._itemId,V),X}j(q,V){return this.e.get(q)?.get(V)}}class pe{constructor(q,V){this.f=q,this.g=V,this.d=new P.$CO(""),this.e=new Map}async prepareSession(q,V,J){const X=this.f.getDocument(q),me=i.Position.to(V),ve=await this.g.prepareTypeHierarchy(X,me,J);if(!ve)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ve)?ve.map(He=>this.h(Te,He)):[this.h(Te,ve)]}async provideSupertypes(q,V,J){const X=this.j(q,V);if(!X)throw new Error("missing type hierarchy item");const me=await this.g.provideTypeHierarchySupertypes(X,J);if(me)return me.map(ve=>this.h(q,ve))}async provideSubtypes(q,V,J){const X=this.j(q,V);if(!X)throw new Error("missing type hierarchy item");const me=await this.g.provideTypeHierarchySubtypes(X,J);if(me)return me.map(ve=>this.h(q,ve))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),X=i.TypeHierarchyItem.from(V,q,J.size.toString(36));return J.set(X._itemId,V),X}j(q,V){return this.e.get(q)?.get(V)}}class Ae{constructor(q,V,J,X,me){this.d=q,this.e=V,this.f=J,this.g=X,this.h=me}async provideDocumentOnDropEdits(q,V,J,X,me){const ve=this.e.getDocument(V),Te=i.Position.to(J),He=i.DataTransfer.toDataTransfer(X,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,q,tt)).buffer),Ze=await this.f.provideDocumentDropEdits(ve,Te,He,me);if(Ze)return(0,u.$3b)(Ze).map(tt=>({title:tt.title??(0,c.localize)(1,null,this.h.displayName||this.h.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>"mimeType"in nt?nt:{kind:nt.kind.value}),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}}class we{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,J,X){const me=w.URI.revive(q),ve=this.d.getDocument(me),Te=J.documents.map(tt=>tt.map(nt=>({uri:w.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(at=>i.Range.to(at))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(ve,V,He,X);return Ze?i.WorkspaceEdit.from(Ze):null}}class Pe{constructor(q,V){this.adapter=q,this.extension=V}}class Fe{static{this.d=0}constructor(q,V,J,X,me,ve,Te,He){this.g=V,this.h=J,this.j=X,this.k=me,this.l=ve,this.m=Te,this.n=He,this.f=new Map,this.e=q.getProxy(f.$eM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new r.$gM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Fe.d++}async s(q,V,J,X,me,ve=!1){const Te=this.f.get(q);if(!Te||!(Te.adapter instanceof V))return X;const He=Date.now();ve||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ze=J(Te.adapter,Te.extension);return Promise.resolve(Ze).catch(tt=>{(0,A.$4)(tt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Te.extension.identifier,tt))}).finally(()=>{ve||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),M.CancellationToken.isCancellationToken(me)?(0,L.$8g)(Ze,me):Ze}t(q,V){const J=this.q();return this.f.set(J,new Pe(q,V)),J}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,J,X){const me=this.t(new l(this.h,J),q),ve=X&&X.label||Fe.u(q);return this.e.$registerDocumentSymbolProvider(me,this.o(V,q),ve),this.p(me)}$provideDocumentSymbols(q,V,J){return this.s(q,l,X=>X.provideDocumentSymbols(w.URI.revive(V),J),void 0,J)}registerCodeLensProvider(q,V,J){const X=this.q(),me=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new Pe(new s(this.h,this.j.converter,J,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(X,this.o(V,q),me);let ve=this.p(X);if(me!==void 0){const Te=J.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(me));ve=r.$gM.from(ve,Te)}return ve}$provideCodeLenses(q,V,J){return this.s(q,s,X=>X.provideCodeLenses(w.URI.revive(V),J),void 0,J)}$resolveCodeLens(q,V,J){return this.s(q,s,X=>X.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,s,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,J){const X=this.t(new d(this.h,J),q);return this.e.$registerDefinitionSupport(X,this.o(V,q)),this.p(X)}$provideDefinition(q,V,J,X){return this.s(q,d,me=>me.provideDefinition(w.URI.revive(V),J,X),[],X)}registerDeclarationProvider(q,V,J){const X=this.t(new m(this.h,J),q);return this.e.$registerDeclarationSupport(X,this.o(V,q)),this.p(X)}$provideDeclaration(q,V,J,X){return this.s(q,m,me=>me.provideDeclaration(w.URI.revive(V),J,X),[],X)}registerImplementationProvider(q,V,J){const X=this.t(new D(this.h,J),q);return this.e.$registerImplementationSupport(X,this.o(V,q)),this.p(X)}$provideImplementation(q,V,J,X){return this.s(q,D,me=>me.provideImplementation(w.URI.revive(V),J,X),[],X)}registerTypeDefinitionProvider(q,V,J){const X=this.t(new $(this.h,J),q);return this.e.$registerTypeDefinitionSupport(X,this.o(V,q)),this.p(X)}$provideTypeDefinition(q,V,J,X){return this.s(q,$,me=>me.provideTypeDefinition(w.URI.revive(V),J,X),[],X)}registerHoverProvider(q,V,J,X){const me=this.t(new v(this.h,J),q);return this.e.$registerHoverProvider(me,this.o(V,q)),this.p(me)}$provideHover(q,V,J,X){return this.s(q,v,me=>me.provideHover(w.URI.revive(V),J,X),void 0,X)}registerEvaluatableExpressionProvider(q,V,J,X){const me=this.t(new k(this.h,J),q);return this.e.$registerEvaluatableExpressionProvider(me,this.o(V,q)),this.p(me)}$provideEvaluatableExpression(q,V,J,X){return this.s(q,k,me=>me.provideEvaluatableExpression(w.URI.revive(V),J,X),void 0,X)}registerInlineValuesProvider(q,V,J,X){const me=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new C(this.h,J),q);this.e.$registerInlineValuesProvider(ve,this.o(V,q),me);let Te=this.p(ve);if(me!==void 0){const He=J.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(me));Te=r.$gM.from(Te,He)}return Te}$provideInlineValues(q,V,J,X,me){return this.s(q,C,ve=>ve.provideInlineValues(w.URI.revive(V),J,X,me),void 0,me)}registerDocumentHighlightProvider(q,V,J){const X=this.t(new O(this.h,J),q);return this.e.$registerDocumentHighlightProvider(X,this.o(V,q)),this.p(X)}registerMultiDocumentHighlightProvider(q,V,J){const X=this.t(new B(this.h,J),q);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(V,q)),this.p(X)}$provideDocumentHighlights(q,V,J,X){return this.s(q,O,me=>me.provideDocumentHighlights(w.URI.revive(V),J,X),void 0,X)}$provideMultiDocumentHighlights(q,V,J,X,me){return this.s(q,B,ve=>ve.provideMultiDocumentHighlights(w.URI.revive(V),J,X.map(Te=>w.URI.revive(Te)),me),void 0,me)}registerLinkedEditingRangeProvider(q,V,J){const X=this.t(new z(this.h,J),q);return this.e.$registerLinkedEditingRangeProvider(X,this.o(V,q)),this.p(X)}$provideLinkedEditingRanges(q,V,J,X){return this.s(q,z,async me=>{const ve=await me.provideLinkedEditingRanges(w.URI.revive(V),J,X);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Fe.w(ve.wordPattern):void 0}},void 0,X)}registerReferenceProvider(q,V,J){const X=this.t(new T(this.h,J),q);return this.e.$registerReferenceSupport(X,this.o(V,q)),this.p(X)}$provideReferences(q,V,J,X,me){return this.s(q,T,ve=>ve.provideReferences(w.URI.revive(V),J,X,me),void 0,me)}registerCodeActionProvider(q,V,J,X){const me=new b.$Sc,ve=this.t(new j(this.h,this.j.converter,this.k,J,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(ve,this.o(V,q),{providedKinds:X?.providedCodeActionKinds?.map(Te=>Te.value),documentation:X?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,me)}))},Fe.u(q),!!J.resolveCodeAction),me.add(this.p(ve)),me}$provideCodeActions(q,V,J,X,me){return this.s(q,j,ve=>ve.provideCodeActions(w.URI.revive(V),J,X,me),void 0,me)}$resolveCodeAction(q,V,J){return this.s(q,j,X=>X.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(q,V){this.s(q,j,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,J){const X=this.t(new F(this.h,J),q);return this.e.$registerDocumentFormattingSupport(X,this.o(V,q),q.identifier,q.displayName||q.name),this.p(X)}$provideDocumentFormattingEdits(q,V,J,X){return this.s(q,F,me=>me.provideDocumentFormattingEdits(w.URI.revive(V),J,X),void 0,X)}registerDocumentRangeFormattingEditProvider(q,V,J){const X=typeof J.provideDocumentRangesFormattingEdits=="function",me=this.t(new K(this.h,J),q);return this.e.$registerRangeFormattingSupport(me,this.o(V,q),q.identifier,q.displayName||q.name,X),this.p(me)}$provideDocumentRangeFormattingEdits(q,V,J,X,me){return this.s(q,K,ve=>ve.provideDocumentRangeFormattingEdits(w.URI.revive(V),J,X,me),void 0,me)}$provideDocumentRangesFormattingEdits(q,V,J,X,me){return this.s(q,K,ve=>ve.provideDocumentRangesFormattingEdits(w.URI.revive(V),J,X,me),void 0,me)}registerOnTypeFormattingEditProvider(q,V,J,X){const me=this.t(new ee(this.h,J),q);return this.e.$registerOnTypeFormattingSupport(me,this.o(V,q),X,q.identifier),this.p(me)}$provideOnTypeFormattingEdits(q,V,J,X,me,ve){return this.s(q,ee,Te=>Te.provideOnTypeFormattingEdits(w.URI.revive(V),J,X,me,ve),void 0,ve)}registerWorkspaceSymbolProvider(q,V){const J=this.t(new Y(V,this.l),q);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(q,V,J){return this.s(q,Y,X=>X.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(q,V,J){return this.s(q,Y,X=>X.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,Y,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,J){const X=this.t(new Q(this.h,J,this.l),q);return this.e.$registerRenameSupport(X,this.o(V,q),Q.supportsResolving(J)),this.p(X)}$provideRenameEdits(q,V,J,X,me){return this.s(q,Q,ve=>ve.provideRenameEdits(w.URI.revive(V),J,X,me),void 0,me)}$resolveRenameLocation(q,V,J,X){return this.s(q,Q,me=>me.resolveRenameLocation(w.URI.revive(V),J,X),void 0,X)}registerNewSymbolNamesProvider(q,V,J){const X=this.t(new Z(this.h,J,this.l),q);return this.e.$registerNewSymbolNamesProvider(X,this.o(V,q)),this.p(X)}$provideNewSymbolNames(q,V,J,X){return this.s(q,Z,me=>me.provideNewSymbolNames(w.URI.revive(V),J,X),void 0,X)}registerDocumentSemanticTokensProvider(q,V,J,X){const me=this.t(new _(this.h,J),q),ve=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(me,this.o(V,q),X,ve);let Te=this.p(me);if(ve){const He=J.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(ve));Te=r.$gM.from(Te,He)}return Te}$provideDocumentSemanticTokens(q,V,J,X){return this.s(q,_,me=>me.provideDocumentSemanticTokens(w.URI.revive(V),J,X),null,X)}$releaseDocumentSemanticTokens(q,V){this.s(q,_,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,J,X){const me=this.t(new ge(this.h,J),q);return this.e.$registerDocumentRangeSemanticTokensProvider(me,this.o(V,q),X),this.p(me)}$provideDocumentRangeSemanticTokens(q,V,J,X){return this.s(q,ge,me=>me.provideDocumentRangeSemanticTokens(w.URI.revive(V),J,X),null,X)}registerCompletionItemProvider(q,V,J,X){const me=this.t(new se(this.h,this.j.converter,J,this.m,q),q);return this.e.$registerCompletionsProvider(me,this.o(V,q),X,se.supportsResolving(J),q.identifier),this.p(me)}$provideCompletionItems(q,V,J,X,me){return this.s(q,se,ve=>ve.provideCompletionItems(w.URI.revive(V),J,X,me),void 0,me)}$resolveCompletionItem(q,V,J){return this.s(q,se,X=>X.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(q,V){this.s(q,se,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,J,X){const me=new U(q,this.h,J,this.j.converter),ve=this.t(me,q);return this.e.$registerInlineCompletionsSupport(ve,this.o(V,q),me.supportsHandleEvents,n.$Bm.toKey(q.identifier.value),X?.yieldTo?.map(Te=>n.$Bm.toKey(Te))||[]),this.p(ve)}$provideInlineCompletions(q,V,J,X,me){return this.s(q,re,ve=>ve.provideInlineCompletions(w.URI.revive(V),J,X,me),void 0,me)}$handleInlineCompletionDidShow(q,V,J,X){this.s(q,re,async me=>{me.handleDidShowCompletionItem(V,J,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,J,X,me){this.s(q,re,async ve=>{ve.handlePartialAccept(V,J,X,me)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,re,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,J){const X=new ie(q,this.h,J,this.j.converter),me=this.t(X,q);return this.e.$registerInlineEditProvider(me,this.o(V,q),q.identifier),this.p(me)}$provideInlineEdit(q,V,J,X){return this.s(q,ie,me=>me.provideInlineEdits(w.URI.revive(V),J,X),void 0,X)}$freeInlineEdit(q,V){this.s(q,ie,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,J,X){const me=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,ve=this.t(new le(this.h,J),q);return this.e.$registerSignatureHelpProvider(ve,this.o(V,q),me),this.p(ve)}$provideSignatureHelp(q,V,J,X,me){return this.s(q,le,ve=>ve.provideSignatureHelp(w.URI.revive(V),J,X,me),void 0,me)}$releaseSignatureHelp(q,V){this.s(q,le,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,J){const X=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,me=this.t(new ue(this.h,this.j.converter,J,this.l,q),q);this.e.$registerInlayHintsProvider(me,this.o(V,q),typeof J.resolveInlayHint=="function",X,Fe.u(q));let ve=this.p(me);if(X!==void 0){const Te=J.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(X));ve=r.$gM.from(ve,Te)}return ve}$provideInlayHints(q,V,J,X){return this.s(q,ue,me=>me.provideInlayHints(w.URI.revive(V),J,X),void 0,X)}$resolveInlayHint(q,V,J){return this.s(q,ue,X=>X.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(q,V){this.s(q,ue,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,J){const X=this.t(new ce(this.h,J),q);return this.e.$registerDocumentLinkProvider(X,this.o(V,q),typeof J.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(q,V,J){return this.s(q,ce,X=>X.provideLinks(w.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(q,V,J){return this.s(q,ce,X=>X.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,ce,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,J){const X=this.t(new de(this.h,J),q);return this.e.$registerDocumentColorProvider(X,this.o(V,q)),this.p(X)}$provideDocumentColors(q,V,J){return this.s(q,de,X=>X.provideColors(w.URI.revive(V),J),[],J)}$provideColorPresentations(q,V,J,X){return this.s(q,de,me=>me.provideColorPresentations(w.URI.revive(V),J,X),void 0,X)}registerFoldingRangeProvider(q,V,J){const X=this.q(),me=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new Pe(new H(this.h,J),q)),this.e.$registerFoldingRangeProvider(X,this.o(V,q),q.identifier,me);let ve=this.p(X);if(me!==void 0){const Te=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(me));ve=r.$gM.from(ve,Te)}return ve}$provideFoldingRanges(q,V,J,X){return this.s(q,H,me=>me.provideFoldingRanges(w.URI.revive(V),J,X),void 0,X)}registerSelectionRangeProvider(q,V,J){const X=this.t(new x(this.h,J,this.l),q);return this.e.$registerSelectionRangeProvider(X,this.o(V,q)),this.p(X)}$provideSelectionRanges(q,V,J,X){return this.s(q,x,me=>me.provideSelectionRanges(w.URI.revive(V),J,X),[],X)}registerCallHierarchyProvider(q,V,J){const X=this.t(new he(this.h,J),q);return this.e.$registerCallHierarchyProvider(X,this.o(V,q)),this.p(X)}$prepareCallHierarchy(q,V,J,X){return this.s(q,he,me=>Promise.resolve(me.prepareSession(w.URI.revive(V),J,X)),void 0,X)}$provideCallHierarchyIncomingCalls(q,V,J,X){return this.s(q,he,me=>me.provideCallsTo(V,J,X),void 0,X)}$provideCallHierarchyOutgoingCalls(q,V,J,X){return this.s(q,he,me=>me.provideCallsFrom(V,J,X),void 0,X)}$releaseCallHierarchy(q,V){this.s(q,he,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,J){const X=this.t(new pe(this.h,J),q);return this.e.$registerTypeHierarchyProvider(X,this.o(V,q)),this.p(X)}$prepareTypeHierarchy(q,V,J,X){return this.s(q,pe,me=>Promise.resolve(me.prepareSession(w.URI.revive(V),J,X)),void 0,X)}$provideTypeHierarchySupertypes(q,V,J,X){return this.s(q,pe,me=>me.provideSupertypes(V,J,X),void 0,X)}$provideTypeHierarchySubtypes(q,V,J,X){return this.s(q,pe,me=>me.provideSubtypes(V,J,X),void 0,X)}$releaseTypeHierarchy(q,V){this.s(q,pe,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,J,X){const me=this.q();return this.f.set(me,new Pe(new Ae(this.e,this.h,J,me,q),q)),this.e.$registerDocumentOnDropEditProvider(me,this.o(V,q),(0,a.$3F)(q,"dropMetadata")?X:void 0),this.p(me)}$provideDocumentOnDropEdits(q,V,J,X,me,ve){return this.s(q,Ae,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(V,w.URI.revive(J),X,me,ve)),void 0,void 0)}registerMappedEditsProvider(q,V,J){const X=this.t(new we(this.h,J),q);return this.e.$registerMappedEditsProvider(X,this.o(V,q)),this.p(X)}$provideMappedEdits(q,V,J,X,me){return this.s(q,we,ve=>Promise.resolve(ve.provideMappedEdits(V,J,X,me)),null,me)}registerDocumentPasteEditProvider(q,V,J,X){const me=this.q();return this.f.set(me,new Pe(new N(this.e,this.h,J,me,q),q)),this.e.$registerPasteEditProvider(me,this.o(V,q),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:X.providedPasteEditKinds?.map(ve=>ve.value),copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(me)}$prepareDocumentPaste(q,V,J,X,me){return this.s(q,N,ve=>ve.prepareDocumentPaste(w.URI.revive(V),J,X,me),void 0,me)}$providePasteEdits(q,V,J,X,me,ve,Te){return this.s(q,N,He=>He.providePasteEdits(V,w.URI.revive(J),X,me,ve,Te),void 0,Te)}$resolvePasteEdit(q,V,J){return this.s(q,N,X=>X.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(q,V){this.s(q,N,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Fe.w(q.decreaseIndentPattern),increaseIndentPattern:Fe.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Fe.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Fe.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Fe.w(q.beforeText),afterText:q.afterText?Fe.w(q.afterText):void 0,previousLineText:q.previousLineText?Fe.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Fe.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>r.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Fe.C)}setLanguageConfiguration(q,V,J){const{wordPattern:X}=J;if(X&&(0,R.$9e)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(V,X):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const me=this.q(),ve={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Fe.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Fe.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Fe.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Fe.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(me,V,ve),this.p(me)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$yic=Fe}),define(Se[121],De([1,0,3,6,16,7,108,25,8,4,220,145,13,5,20,120,12]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0,e.$Fic=(0,S.$gi)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new p.$Jh,this.stream=f??new p.$Jh}}class i{constructor(){this.a=new Map,this.b=new p.$Jh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{c=this}static{this.a=1}constructor(t,f,l){this.j=f,this.k=l,this.c=new E.$6d,this.d=new E.$6d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Dm,this.i=new Map,this.o=new Set,this.b=t.getProxy(L.$eM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,l,s){const o=c.a++;this.f.set(o,{extension:t.identifier,provider:l,languageModelId:f});let d;return s.auth&&(d={providerLabel:t.displayName||t.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerLanguageModelProvider(o,f,{extension:t.identifier,identifier:f,model:s.name??"",auth:d}),(0,u.$Rc)(()=>{this.f.delete(o),this.b.$unregisterProvider(o)})}async $provideLanguageModelResponse(t,f,l,s,o,d){const m=this.f.get(t);if(!m)return;const D=new P.$Nv(async $=>{if(d.isCancellationRequested){this.j.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:$.index,part:$.part})});return m.provider.provideLanguageModelResponse2(s.map(M.LanguageModelMessage.to),o,b.$Bm.toKey(l),D,d)}$updateLanguageModels(t){const f=[],l=[];if(t.added)for(const s of t.added)this.g.set(s.identifier,s),f.push(s.model);if(t.removed)for(const s of t.removed){this.g.delete(s),l.push(s);for(const[o,d]of this.i)d.languageModelId===s&&(d.res.reject(new w.$5),this.i.delete(o))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(l)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:l,to:s,enabled:o}of t){const d=this.h.get(l)??new b.$Cm;if(d.has(s)!==o){o?d.add(s):d.delete(s),this.h.set(l,d);const D={from:l,to:s};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,l,s,o){const d=t.identifier,m=await this.b.$prepareChatAccess(d,f,s.justification);if(!m||!this.g.has(f))throw A.$lO.NotFound(`Language model '${f}' is unknown.`);if(this.m(d,m)&&(!await this.l(t,{identifier:m.extension,displayName:m.auth.providerLabel},s.justification,s.silent)||!this.h.get(d)?.has(m.extension)))throw A.$lO.NoPermissions(`Language model '${f}' cannot be used by '${d.value}'.`);const D=Math.random()*1e6|0,$=this.b.$fetchResponse(d,f,D,l.map(M.LanguageModelMessage.from),s.modelOptions??{},o),v=new p.$fh,k=new i;this.i.set(D,{languageModelId:f,res:k});let C;if($.catch(O=>{v.isOpen()?k.reject(O):C=O}).finally(()=>{this.i.delete(D),k.resolve(),v.open()}),await v.wait(),C)throw new A.$lO(`Language model '${f}' errored, check cause for more details`,"Unknown",C);return k.apiObject}async $handleResponseFragment(t,f){const l=this.i.get(t);l&&l.res.handleFragment(f)}async l(t,f,l,s){const o=I.$gL+f.identifier.value;if(await this.k.getSession(t,o,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(s)return!1;try{const m=l?(0,R.localize)(0,null,f.displayName,l):(0,R.localize)(1,null,f.displayName);return await this.k.getSession(t,o,[],{forceNewSession:{detail:m}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!b.$Bm.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(l){this.j.error("Fake Auth request failed"),this.j.error(l)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,l=E.Event.signal(E.Event.filter(this.c.event,o=>b.$Bm.equals(o.from,t.identifier))),s=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(l,s)},canSendRequest(o){const d=f.g.get(o);if(!d)return;if(!f.m(t.identifier,d))return!0;const m=f.h.get(t.identifier);if(m)return m.has(d.extension)}}}};e.$Gic=r,e.$Gic=r=c=Je([qe(0,y.$xO),qe(1,g.$Mj),qe(2,h.$Aic)],r)}),define(Se[335],De([1,0,6,16,7,39,8,3,26]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class E{constructor(I,w,S,y){this.c=w,this.d=S,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(u.$eM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,w){await this.a.$changeLanguage(I,w);const S=this.c.getDocumentData(I);if(!S)throw new Error(`document '${I.toString()}' NOT found`);return S.document}async tokenAtPosition(I,w){const S=I.version,y=L.Position.from(w),h=await this.a.$tokensAtPosition(I.uri,y),g={type:M.StandardTokenType.Other,range:I.getWordRangeAtPosition(w)??new M.$iM(w.line,w.character,w.line,w.character)};if(!h)return g;const c={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!c.range.contains(w)||S!==I.version?g:c}createLanguageStatusItem(I,w,S){const y=this.f++,h=this.a,g=this.g,c=`${I.identifier.value}/${w}`;if(g.has(c))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);g.add(c);const n={selector:S,id:w,name:I.displayName??I.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new b.$Sc,a=()=>{if(i?.dispose(),!g.has(c)){console.warn(`LanguageStatusItem (${w}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,P.$ih)(()=>{r.clear(),this.a.$setLanguageStatus(y,{id:c,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?A.default.Error:n.severity===M.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),h.$removeLanguageStatus(y),g.delete(c)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,a()},get selector(){return n.selector},set selector(f){n.selector=f,a()},get text(){return n.text},set text(f){n.text=f,a()},set text2(f){(0,p.$4F)(I,"languageStatusText"),n.text=f,a()},get text2(){return(0,p.$4F)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,a()},get severity(){return n.severity},set severity(f){n.severity=f,a()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,a()},get command(){return n.command},set command(f){n.command=f,a()},get busy(){return n.busy},set busy(f){n.busy=f,a()}};return a(),t}}e.$Zjc=E}),define(Se[336],De([1,0,15,2,16,7,119]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0;class b{constructor(I,w,S,y){this.start=I,this.deletedCount=w,this.deletedItems=S,this.items=y}asApiEvent(){return{range:new A.$HN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,w,S){this.notebook=I,this.h=w,this.j=S,this.handle=S.handle,this.uri=L.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(M.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(y){I.g=y},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(M.NotebookCellOutput.to)}setOutputItems(I,w,S){const y=S.map(M.NotebookCellOutputItem.to),h=this.a.find(g=>g.id===I);if(h&&(w||(h.items.length=0),h.items.push(...y),h.items.length>1&&h.items.every(g=>P.$_J(g.mime)))){const g=new Map,c=[];h.items.forEach(n=>{let i;g.has(n.mime)?i=g.get(n.mime):(i=[],g.set(n.mime,i),c.push(n.mime)),i.push(n.data)}),h.items.length=0,c.forEach(n=>{const i=P.$aK(g.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Kjc=p;class E{static{this.a=0}constructor(I,w,S,y,h){this.k=I,this.l=w,this.m=S,this.uri=y,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(h=>h.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,S){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:S});const y={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},h=[];for(const c of I.rawEvents)c.kind===P.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,y.contentChanges):c.kind===P.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,y.contentChanges):c.kind===P.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),h.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===P.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),h.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),h.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===P.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),h.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),h.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const g=new Map;for(let c=0;c<h.length;c++){const n=h[c],i=g.get(n.cell);if(i===void 0){const r=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});g.set(n.cell,r-1)}else y.cellChanges[i]={...y.cellChanges[i],...n}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,S=I.end|0;return w<0&&(w=0),S>this.b.length&&(S=this.b.length),I.with({start:w,end:S})}p(I){I=this.o(I);const w=[];for(let S=I.start;S<I.end;S++)w.push(this.b[S]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,S){if(this.j)return;const y=[],h=[],g=[];if(I.reverse().forEach(c=>{const i=c[2].map(t=>{const f=new p(this,this.l,t);return w||h.push(p.asModelAddData(t)),f}),r=new b(c[0],c[1],[],i),a=this.b.splice(c[0],c[1],...i);for(const t of a)g.push(t.uri),r.deletedItems.push(t.apiCell);y.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),S)for(const c of y)S.push(c.asApiEvent())}s(I,w,S,y){const h=this.b.splice(I,w);this.b.splice(S,0,...h);const g=[new b(I,w,h.map(c=>c.apiCell),[]),new b(S,0,[],h)];for(const c of g)y.push(c.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,S,y){this.b[I].setOutputItems(w,S,y)}v(I,w){const S=this.b[I];S.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(S.uri,w)}w(I,w){const S=this.b[I];S.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Ljc=E}),define(Se[337],De([1,0,4,2,16,7]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class P{constructor(p,E,R,I={timeout:1500,errors:3}){this.b=p,this.c=E,this.d=R,this.f=I,this.a=new u.$8d}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(E,R,I)=>{const w=function(y){E.call(R,y)};return w.extension=p,this.a.event(w,void 0,I)}}async $participateInSave(p,E,R){const I=L.URI.revive(p),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:M.TextDocumentSaveReason.to(E)},R,async(h,g)=>{const c=Date.now(),n=await await Promise.resolve(h);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof A.$qM?S.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(S.length===0)return!0;const y={edits:[]};for(const h of S){const{edits:g}=M.WorkspaceEdit.from(h);y.edits=y.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(y)}}e.$2jc=P}),define(Se[153],De([1,0,13,16,7]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,p,E,R,I,w){this.id=b,this.f=p,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=w}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(p){this.selections=[p]},get selections(){return b.a},set selections(p){if(!Array.isArray(p)||!p.every(M.$HN.isNotebookRange))throw(0,u.$7)("selections");b.a=p,b.g(p)},get visibleRanges(){return b.b},revealRange(p,E){b.f.$tryRevealRange(b.id,L.NotebookRange.from(p),E??M.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(L.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Mjc=A}),define(Se[338],De([1,0,4,12,16]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=void 0;let A=class{constructor(b,p){this.c=b,this.d=p,this.a=new u.$6d,this.b=new u.$6d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,p);const E=this.d.getEditorById(b);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(M.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(M.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const p in b)this.d.getEditorById(p)._acceptViewColumn(M.ViewColumn.to(b[p]))}};e.$4jc=A,e.$4jc=A=Je([qe(0,L.$Mj)],A)}),define(Se[339],De([1,0,4,6,153]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=void 0;class A{constructor(b,p){this.c=p,this.a=new Map,this.b=b.getProxy(L.$eM.MainThreadNotebookRenderers)}$postRendererMessage(b,p,E){const R=this.c.getEditorById(b);this.a.get(p)?.fire({editor:R.apiEditor,message:E})}createRendererMessaging(b,p){if(!b.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,I,w)=>this.d(p).event(R,I,w),postMessage:(R,I)=>{M.$Mjc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const w=I&&M.$Mjc.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,p,R)}}}d(b){let p=this.a.get(b);return p||(p=new u.$6d({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(b)}}),this.a.set(b,p),p)}}e.$7jc=A}),define(Se[340],De([1,0,16,108,22,53,13]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class b{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,w,S){const y=this.b++,{title:h,location:g,cancellable:c}=w,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(y,{location:u.ProgressLocation.from(g),title:h,source:n,cancellable:c},I.isUnderDevelopment?void 0:I.identifier.value).catch(P.$2),this.d(y,S,!!c)}d(I,w,S){let y;S&&(y=new M.$de,this.c.set(I,y));const h=c=>{this.a.$progressEnd(c),this.c.delete(c),y?.dispose()};let g;try{g=w(new E(this.a,I),S&&y?y.token:M.CancellationToken.None)}catch(c){throw h(I),c}return g.then(c=>h(I),c=>h(I)),g}$acceptProgressCanceled(I){const w=this.c.get(I);w&&(w.cancel(),this.c.delete(I))}}e.$$jc=b;function p(R,I){return R.message=I.message,typeof I.increment=="number"&&(typeof R.increment=="number"?R.increment+=I.increment:R.increment=I.increment),R}class E extends L.$Nv{constructor(I,w){super(S=>this.throttledReport(S)),this.c=I,this.d=w}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,A.$Mh)(100,(R,I)=>p(R,I),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[341],De([1,0,2,6,8,16]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class P{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(L.$eM.MainThreadQuickDiff)}$provideOriginalResource(p,E,R){const I=u.URI.revive(E),w=this.c.get(p);return w?(0,M.$$g)(()=>w.provideOriginalResource(I,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(p,E,R,I){const w=P.a++;return this.c.set(w,E),this.b.$registerQuickDiffProvider(w,A.DocumentSelector.from(p,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$_jc=P}),define(Se[342],De([1,0,22,4,3,6,2,7,13,19,39,55,26,16]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=y;function y(h,g,c){const n=h.getProxy(A.$eM.MainThreadQuickOpen);class i{constructor(m,D){this.e=new Map,this.f=0,this.a=m,this.b=D}showQuickPick(m,D,$,v=u.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),C=++this.f,O=n.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},v),B={},z=O.then(()=>B);return Promise.race([z,k]).then(T=>{if(T===B)return;const j=(0,w.$3F)(m,"quickPickItemTooltip");return k.then(N=>{const F=[];for(let K=0;K<N.length;K++){const ee=N[K];if(typeof ee=="string")F.push({label:ee,handle:K});else if(ee.kind===b.QuickPickItemKind.Separator)F.push({type:"separator",label:ee.label});else{ee.tooltip&&!j&&console.warn(`Extension '${m.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`);const Y=ee.iconPath?l(ee.iconPath):void 0;F.push({label:ee.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:j?S.MarkdownString.fromStrict(ee.tooltip):void 0,handle:K})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=K=>{$.onDidSelectItem(N[K])}),n.$setItems(C,F),O.then(K=>{if(typeof K=="number")return N[K];if(Array.isArray(K))return K.map(ee=>N[ee])})})}).then(void 0,T=>{if(!(0,p.$4)(T))return n.$setError(C,T),Promise.reject(T)})}$onItemSelected(m){this.c?.(m)}showInput(m,D=u.CancellationToken.None){return this.d=m?.validateInput,n.$input(m,typeof this.d=="function",D).then(void 0,$=>{if(!(0,p.$4)($))return Promise.reject($)})}async $validateInput(m){if(!this.d)return;const D=await this.d(m);if(!D||typeof D=="string")return D;let $;switch(D.severity){case b.InputBoxValidationSeverity.Info:$=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:$=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:$=R.default.Error;break;default:$=D.message?R.default.Error:R.default.Ignore;break}return{content:D.message,severity:$}}async showWorkspaceFolderPick(m,D=u.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!$)return;const v=await this.a.getWorkspaceFolders2();if(v)return v.find(k=>k.uri.toString()===$.uri.toString())}createQuickPick(m){const D=new s(m,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(m){const D=new o(m,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(m,D){this.e.get(m)?._fireDidChangeValue(D)}$onDidAccept(m){this.e.get(m)?._fireDidAccept()}$onDidChangeActive(m,D){const $=this.e.get(m);$ instanceof s&&$._fireDidChangeActive(D)}$onDidChangeSelection(m,D){const $=this.e.get(m);$ instanceof s&&$._fireDidChangeSelection(D)}$onDidTriggerButton(m,D){this.e.get(m)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(m,D,$){const v=this.e.get(m);v instanceof s&&v._fireDidTriggerItemButton(D,$)}$onDidHide(m){this.e.get(m)?._fireDidHide()}}class r{static{this.a=1}constructor(m,D){this.x=m,this.y=D,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$6d,this.q=new L.$6d,this.r=new L.$6d,this.s=new L.$6d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(m){this.b=m,this.z({title:m})}get step(){return this.c}set step(m){this.c=m,this.z({step:m})}get totalSteps(){return this.d}set totalSteps(m){this.d=m,this.z({totalSteps:m})}get enabled(){return this.g}set enabled(m){this.g=m,this.z({enabled:m})}get busy(){return this.j}set busy(m){this.j=m,this.z({busy:m})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(m){this.k=m,this.z({ignoreFocusOut:m})}get value(){return this.l}set value(m){this.l=m,this.z({value:m})}get placeholder(){return this.m}set placeholder(m){this.m=m,this.z({placeholder:m})}get buttons(){return this.n}set buttons(m){this.n=m.slice(),this.o.clear(),m.forEach((D,$)=>{const v=D===b.$EN.Back?-1:$;this.o.set(v,D)}),this.z({buttons:m.map((D,$)=>({...l(D.iconPath),tooltip:D.tooltip,handle:D===b.$EN.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(m){this.l=m,this.q.fire(m)}_fireDidTriggerButton(m){const D=this.o.get(m);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(m){if(!this.v){for(const D of Object.keys(m)){const $=m[D];this.u[D]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function a(d){if(d instanceof b.$cN)return{id:d.id};const m=f(d),D=t(d);return{dark:typeof m=="string"?P.URI.file(m):m,light:typeof D=="string"?P.URI.file(D):D}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function f(d){return typeof d=="object"&&"dark"in d?d.dark:d}function l(d){const m=a(d);let D,$;return"id"in m?$=I.ThemeIcon.asClassName(m):D=m,{iconPath:D,iconClass:$}}class s extends r{constructor(m,D){super(m.identifier,D),this.O=m,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$6d,this.L=[],this.M=new L.$6d,this.N=new L.$6d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(m){this.B=m.slice(),this.C.clear(),this.D.clear(),m.forEach((v,k)=>{this.C.set(k,v),this.D.set(v,k)});const D=(0,w.$3F)(this.O,"quickPickItemTooltip"),$=[];for(let v=0;v<m.length;v++){const k=m[v];if(k.kind===b.QuickPickItemKind.Separator)$.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=k.iconPath?l(k.iconPath):void 0;$.push({handle:v,label:k.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((O,B)=>({...l(O.iconPath),tooltip:O.tooltip,handle:B}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(m){this.E=m,this.z({canSelectMany:m})}get matchOnDescription(){return this.F}set matchOnDescription(m){this.F=m,this.z({matchOnDescription:m})}get matchOnDetail(){return this.G}set matchOnDetail(m){this.G=m,this.z({matchOnDetail:m})}get sortByLabel(){return this.H}set sortByLabel(m){this.H=m,this.z({sortByLabel:m})}get keepScrollPosition(){return this.I}set keepScrollPosition(m){this.I=m,this.z({keepScrollPosition:m})}get activeItems(){return this.J}set activeItems(m){this.J=m.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(m){this.L=m.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(m){const D=(0,E.$Hb)(m.map($=>this.C.get($)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(m){const D=(0,E.$Hb)(m.map($=>this.C.get($)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(m,D){const $=this.C.get(m);if(!$||!$.buttons||!$.buttons.length)return;const v=$.buttons[D];v&&this.N.fire({button:v,item:$})}}class o extends r{constructor(m,D){super(m.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(m){this.B=m,this.z({password:m})}get prompt(){return this.C}set prompt(m){this.C=m,this.z({prompt:m})}get valueSelection(){return this.D}set valueSelection(m){this.D=m,this.z({valueSelection:m})}get validationMessage(){return this.E}set validationMessage(m){this.E=m,m?typeof m=="string"?this.z({validationMessage:m,severity:R.default.Error}):this.z({validationMessage:m.message,severity:m.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(g,c)}}),define(Se[343],De([1,0,2,4,53,3,8,6,19,131,12,25,55,16,26,15,11]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0;function n(C){return C instanceof u.URI}function i(C,O){return C.scheme===h.Schemas.file&&O.scheme===h.Schemas.file&&g.$k?C.toString()===O.toString():C.toString().toLowerCase()===O.toString().toLowerCase()}function r(C){if(C)return typeof C.iconPath=="string"?u.URI.file(C.iconPath):u.URI.isUri(C.iconPath)||w.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function a(C){if(C.icon){if(u.URI.isUri(C.icon))return C.icon;if(w.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const O=C.icon;return{light:O.light,dark:O.dark}}}else return}function t(C,O){if(!C.iconPath&&!O.iconPath)return 0;if(C.iconPath){if(!O.iconPath)return 1}else return-1;const B=typeof C.iconPath=="string"?C.iconPath:u.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:u.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,E.$9q)(B,z)}function f(C,O){let B=0;if(C.strikeThrough!==O.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==O.faded)return C.faded?1:-1;if(C.tooltip!==O.tooltip)return(C.tooltip||"").localeCompare(O.tooltip||"");if(B=t(C,O),B!==0)return B;if(C.light&&O.light)B=t(C.light,O.light);else{if(C.light)return 1;if(O.light)return-1}if(B!==0)return B;if(C.dark&&O.dark)B=t(C.dark,O.dark);else{if(C.dark)return 1;if(O.dark)return-1}return B}function l(C,O){if(C.command!==O.command)return C.command<O.command?-1:1;if(C.title!==O.title)return C.title<O.title?-1:1;if(C.tooltip!==O.tooltip){if(C.tooltip!==void 0&&O.tooltip!==void 0)return C.tooltip<O.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(C.arguments===O.arguments)return 0;if(C.arguments)if(O.arguments){if(C.arguments.length!==O.arguments.length)return C.arguments.length-O.arguments.length}else return 1;else return-1;for(let B=0;B<C.arguments.length;B++){const z=C.arguments[B],T=O.arguments[B];if(z!==T&&!(n(z)&&n(T)&&i(z,T)))return z<T?-1:1}return 0}function s(C,O){let B=(0,E.$9q)(C.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(B!==0)return B;if(C.command&&O.command)B=l(C.command,O.command);else{if(C.command)return 1;if(O.command)return-1}if(B!==0)return B;if(C.decorations&&O.decorations)B=f(C.decorations,O.decorations);else{if(C.decorations)return 1;if(O.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)B=(0,E.$9q)(C.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)B=(0,E.$9q)(C.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return B}function o(C,O){for(let B=0;B<C.length;B++)if(C[B]!==O[B])return!1;return!0}function d(C,O){return C.command===O.command&&C.title===O.title&&C.tooltip===O.tooltip&&(C.arguments&&O.arguments?o(C.arguments,O.arguments):C.arguments===O.arguments)}function m(C,O){return(0,p.$ub)(C,O,d)}class D{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,y.$4F)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,y.$4F)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,y.$4F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,B,z,T,j){this.k=O,this.l=T,this.m=j,this.d="",this.e=new L.$6d,this.f="",this.h=!0,this.j=!0,this.#t=B,this.#e=z}showValidationMessage(O,B){(0,y.$4F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,B)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$bkc=D;class ${static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,B,z,T,j,N,F){this.q=O,this.s=B,this.t=z,this.u=T,this.v=j,this.multiDiffEditorEnableViewChanges=N,this.w=F,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$6d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$6d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,B){const z=this.h.get(O);return z?(0,P.$$g)(()=>this.s.executeCommand(z.command,...z.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(s),z=(0,p.$Db)(this.o,O,s).map(N=>{const F=N.toInsert.map(K=>{const ee=this.e++;this.g.set(ee,K);const Y=K.resourceUri;let Q;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"||K.command.command==="vscode.changes"){const de=new A.$Sc;Q=this.s.converter.toInternal(K.command,de),this.j.set(ee,de)}else this.h.set(ee,K.command);const Z=(0,y.$3F)(this.w,"scmMultiDiffEditor"),ae=Z?K.multiDiffEditorOriginalUri:void 0,_=Z?K.multiFileDiffEditorModifiedUri:void 0,ge=r(K.decorations),se=K.decorations&&r(K.decorations.light)||ge,re=K.decorations&&r(K.decorations.dark)||ge,U=[se,re],ie=K.decorations&&K.decorations.tooltip||"",ye=K.decorations&&!!K.decorations.strikeThrough,le=K.decorations&&!!K.decorations.faded,ue=K.contextValue||"";return{rawResource:[ee,Y,U,ie,ye,le,ue,Q,ae,_],handle:ee}});return{start:N.start,deleteCount:N.deleteCount,toInsert:F}}),T=z.map(({start:N,deleteCount:F,toInsert:K})=>[N,F,K.map(ee=>ee.rawResource)]),j=z.reverse();for(const{start:N,deleteCount:F,toInsert:K}of j){const ee=K.map(Q=>Q.handle),Y=this.n.splice(N,F,...ee);for(const Q of Y)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=O,T}dispose(){this.l=!0,this.m.fire()}}class v{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let B;(0,y.$3F)(this.x,"quickDiffProvider")&&(B=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:B})}get historyProvider(){return(0,y.$4F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,y.$4F)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new A.$Sc,this.o=O;const B=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:B})}get actionButton(){return(0,y.$4F)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,y.$4F)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=O;const B=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(T=>this.y.converter.toInternal(T,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:B??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&m(this.t,O))return;this.s.value=new A.$Sc,this.t=O;const B=(O||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:B})}get selected(){return this.u}constructor(O,B,z,T,j,N,F){this.x=O,this.y=T,this.z=j,this.A=N,this.B=F,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new L.$6d,this.onDidChangeSelection=this.v.event,this.w=v.d++,this.C=new Map,this.D=new Set,this.#e=z;const K=u.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${j}/scm${this.w}/input`,query:F?`rootUri=${encodeURIComponent(F.toString())}`:void 0});this.f=new D(O,B,this.#e,this.w,K),this.#e.$registerSourceControl(this.w,j,N,F,K)}createResourceGroup(O,B,z){const T=(0,y.$3F)(this.x,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,j=new $(this.#e,this.y,this.w,O,B,T,this.x),N=L.Event.once(j.onDidDispose)(()=>this.C.delete(j));return this.C.set(j,N),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const O=[],B=[];for(const[z,T]of this.C){T.dispose();const j=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});L.Event.once(z.onDidDispose)(()=>{this.D.delete(z),j.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),O.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const N=z._takeResourceStateSnapshot();N.length>0&&B.push([z.handle,N]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,O,B),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(B=>{const z=B._takeResourceStateSnapshot();z.length!==0&&O.push([B.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Lh)(100)],v.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Lh)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,B,z,T){this.l=B,this.m=z,this.n=T,this.g=new Map,this.h=new I.$Dm,this.j=new L.$6d,this.e=O.getProxy(b.$eM.MainThreadSCM),this.f=O.getProxy(b.$eM.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const N=this.g.get(j.sourceControlHandle);if(!N)return j;const F=N.getResourceGroup(j.groupHandle);return F?F.getResourceState(j.handle):j}else if(j&&j.$mid===4){const N=this.g.get(j.sourceControlHandle);return N?N.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const N=this.g.get(j.handle);return N||j}return j}})}createSourceControl(O,B,z,T){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,B,z,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const j=c.d++,N=new v(O,this.m,this.e,this.l,B,z,T);this.g.set(j,N);const F=this.h.get(O.identifier)||[];return F.push(N),this.h.set(O.identifier,F),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const B=this.h.get(O.identifier),z=B&&B[B.length-1];return z&&z.inputBox}$provideOriginalResource(O,B,z){const T=u.URI.revive(B);this.n.trace("ExtHostSCM#$provideOriginalResource",O,T.toString());const j=this.g.get(O);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$$g)(()=>j.quickDiffProvider.provideOriginalResource(T,z)).then(N=>N||null)}$onInputBoxValueChange(O,B){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(O,B,z,T){this.n.trace("ExtHostSCM#$executeResourceCommand",O,B,z);const j=this.g.get(O);if(!j)return Promise.resolve(void 0);const N=j.getResourceGroup(B);return N?N.$executeResourceCommand(z,T):Promise.resolve(void 0)}$validateInput(O,B,z){this.n.trace("ExtHostSCM#$validateInput",O);const T=this.g.get(O);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,P.$$g)(()=>T.inputBox.validateInput(B,z)).then(j=>{if(!j)return Promise.resolve(void 0);const N=S.MarkdownString.fromStrict(j.message);return N?Promise.resolve([N,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,B,z,T){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,z,T)??void 0}async $provideHistoryItems(O,B,z,T){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(B,z,T))?.map(F=>({...F,icon:a(F)}))??void 0}async $provideHistoryItemSummary(O,B,z,T){const j=this.g.get(O)?.historyProvider;if(typeof j?.provideHistoryItemSummary!="function")return;const N=await j.provideHistoryItemSummary(B,z,T);return N?{...N,icon:a(N)}:void 0}async $provideHistoryItemChanges(O,B,z,T){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(B,z,T)??void 0}};e.$ckc=k,e.$ckc=k=c=Je([qe(3,R.$Mj)],k)}),define(Se[344],De([1,0,6,16,2]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class A{static{this.a=0}constructor(b,p){this.d=p,this.c=new Map,this.b=b.getProxy(u.$eM.MainThreadShare)}async $provideShare(b,p,E){return await this.c.get(b)?.provideShare({selection:L.Range.to(p.selection),resourceUri:M.URI.revive(p.resourceUri)},E)??void 0}registerShareProvider(b,p){const E=A.a++;return this.c.set(E,p),this.b.$registerShareProvider(E,L.DocumentSelector.from(b,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$dkc=A}),define(Se[345],De([1,0,7,6,223,3,16,18]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=e.$fkc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$dN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$dN("statusBarItem.warningForeground")]])}#e;#t;constructor(w,S,y,h,g,c=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=w,this.#t=S,g&&h){this.c=(0,u.$RM)(h.identifier,g);const i=y.get(this.c);i&&(c=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=h,this.f=g,this.g=c,this.h=this.u(n)}u(w){if((0,b.$Xf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!p.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let S;this.m?S=this.m:S=(0,M.localize)(0,null,this.e.displayName||this.e.name);let y=this.n;this.o&&(y=p.b.get(this.o.id));const h=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,S,this.k,h,this.r?.internal,y,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$fkc=p;class E{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const S={message:w};return this.b.unshift(S),this.c(),new u.$gM(()=>{const y=this.b.indexOf(S);y>=0&&(this.b.splice(y,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(w,S){this.e=new Map,this.a=w.getProxy(L.$eM.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries(w){for(const S of w)this.e.set(S.entryId,S)}createStatusBarEntry(w,S,y,h){return new p(this.a,this.b,this.e,w,S,y,h)}setStatusBarMessage(w,S){const y=this.c.setMessage(w);let h;return typeof S=="number"?h=setTimeout(()=>y.dispose(),S):typeof S<"u"&&S.then(()=>y.dispose(),()=>y.dispose()),new u.$gM(()=>{y.dispose(),clearTimeout(h)})}}e.$gkc=R}),define(Se[154],De([1,0,29,144,66,112,89,16,2]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=e.$KO=e.$JO=void 0;const E=(i,r,a,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(l){if(!a(f,l)){const s=f;f=l,i.listener?.(t(l,s))}}}},R=(i,r)=>i===r,I={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(a=>!r.find(t=>a.id===t.id)))},w=i=>r=>({op:4,update:i(r)}),S=(i,r)=>({range:(()=>{let a;const t=w(f=>({range:u.$$s.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return a},set(f){i.listener?.({op:6}),I.range(a,f)||(a=f,i.listener?.(t(f)))}}})(),label:E(i,r,I.label,w(a=>({label:a}))),description:E(i,void 0,I.description,w(a=>({description:a}))),sortText:E(i,void 0,I.sortText,w(a=>({sortText:a}))),canResolveChildren:E(i,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:E(i,!1,I.busy,w(a=>({busy:a}))),error:E(i,void 0,I.error,w(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:E(i,[],I.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),y=i=>{const r=M.$3K.fromString(i.extId),a=new g(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return a.range=b.Range.to(i.range||void 0),a.description=i.description||void 0,a.sortText=i.sortText||void 0,a.tags=i.tags.map(t=>b.TestTag.to({id:(0,P.$9K)(t).tagId})),a},h=i=>{let r;for(const a of i.tests){const t=y(a.item);(0,L.$tO)(t).parent=r,r=t}return r};e.$JO=h;class g{constructor(r,a,t,f){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const l=(0,L.$sO)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof c?void 0:l.parent}},children:{value:(0,A.$rO)(l,L.$tO,g),enumerable:!0,writable:!1},...S(l,t)})}}e.$KO=g;class c extends g{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$LO=c;class n extends A.$nO{constructor(r,a,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:L.$tO,getChildren:f=>f.children,root:new c(r,a),toITestItem:b.TestItem.from})}}e.$MO=n}),define(Se[33],De([1,0,18,7,16,24,6,19,12,56,29,49,2,3,5,20,154,21,67,44,38,87,90,30]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=void 0;let l=class{#e;#t;#i;constructor($,v,k){this.b=new Map,this.c=new Map,this.#e=$.getProxy(P.$eM.MainThreadCommands),this.d=v,this.#i=k,this.#t=$.getProxy(P.$eM.MainThreadTelemetry),this.converter=new s(this,C=>{const O=this.c.get(C);return O?.result===d.Void?O:void 0},v),this.f=[{processArgument(C){return(0,E.$Ph)(C)}},{processArgument(C){return(0,A.$On)(C,function(O){if(R.$$s.isIRange(O))return M.Range.to(O);if(I.$0s.isIPosition(O))return M.Position.to(O);if(R.$$s.isIRange(O.range)&&w.URI.isUri(O.uri))return M.location.to(O);if(O instanceof c.$te)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor($){this.f.push($)}registerApiCommand($){const v=this.registerCommand(!1,$.id,async(...k)=>{const C=$.args.map((B,z)=>{if(!B.validate(k[z]))throw new Error(`Invalid argument '${B.name}' when running '${$.id}', received: ${typeof k[z]=="object"?JSON.stringify(k[z],null,"	"):k[z]} `);return B.convert(k[z])}),O=await this.executeCommand($.internalId,...C);return $.result.convert(O,k,this.converter)},void 0,{description:$.description,args:$.args,returns:$.result.description});return this.c.set($.id,$),new L.$gM(()=>{v.dispose(),this.c.delete($.id)})}registerCommand($,v,k,C,O,B){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:k,thisArg:C,metadata:O,extension:B}),$&&this.#e.$registerCommand(v),new L.$gM(()=>{this.b.delete(v)&&$&&this.#e.$unregisterCommand(v)})}executeCommand($,...v){return this.d.trace("ExtHostCommands#executeCommand",$),this.g($,v,!0)}async g($,v,k){if(this.b.has($))return this.#e.$fireCommandActivationEvent($),this.h($,v,!1);{let C=!1;const O=(0,A.$On)(v,function(B){if(B instanceof L.$hM)return M.Position.from(B);if(B instanceof L.$iM)return M.Range.from(B);if(B instanceof L.$sM)return M.location.from(B);if(L.$HN.isNotebookRange(B))return M.NotebookRange.from(B);if(B instanceof ArrayBuffer)return C=!0,c.$te.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return C=!0,c.$te.wrap(B);if(B instanceof c.$te)return C=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand($,C?new n.$aw(O):O,k);return(0,E.$Ph)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g($,v,!1);throw B}}}async h($,v,k){const C=this.b.get($);if(!C)throw new Error("Unknown command");const{callback:O,thisArg:B,metadata:z}=C;if(z?.args)for(let j=0;j<z.args.length;j++)try{(0,u.$$f)(v[j],z.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${$}' failed. Illegal argument '${z.args[j].name}' - ${z.args[j].description}`)}const T=r.$2d.create();try{return await O.apply(B,v)}catch(j){if($===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...v);N&&($=N.command)}if(this.d.error(j,$,C.extension?.identifier),!k)throw j;if(C.extension?.identifier){const N=this.#i.onExtensionError(C.extension.identifier,j);this.d.trace("forwarded error to extension?",N,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$4i)(j)),this.id=$,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,$,T.elapsed())}}j($,v,k){$.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:$.extension.identifier.value,id:new a.$2o(v),duration:k})}$executeContributedCommand($,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",$);const k=this.b.get($);return k?(v=v.map(C=>this.f.reduce((O,B)=>B.processArgument(O,k.extension?.identifier),C)),this.h($,v,!0)):Promise.reject(new Error(`Contributed command '${$}' does not exist.`))}getCommands($=!1){return this.d.trace("ExtHostCommands#getCommands",$),this.#e.$getCommands().then(v=>($&&(v=v.filter(k=>k[0]!=="_")),v))}$getContributedCommandMetadata(){const $=Object.create(null);for(const[v,k]of this.b){const{metadata:C}=k;C&&($[v]=C)}return Promise.resolve($)}};e.$SO=l,e.$SO=l=Je([qe(0,h.$xO),qe(1,p.$Mj),qe(2,t.$RO)],l),e.$TO=(0,y.$gi)("IExtHostCommands");class s{constructor($,v,k){this.d=$,this.f=v,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$Cg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal($,v){if(!$)return;const k={$ident:void 0,id:$.command,title:$.title,tooltip:$.tooltip};if(!$.command)return k;const C=this.f($.command);if(C)k.id=C.internalId,k.arguments=C.args.map((O,B)=>O.convert($.arguments&&$.arguments[B]));else if((0,b.$Lb)($.arguments)){const O=`${$.command} /${++this.c}`;this.b.set(O,$),v.add((0,S.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),k.$ident=O,k.id=this.delegatingCommandId,k.arguments=[O],this.g.trace("CommandsConverter#CREATE",$.command,O)}return k}fromInternal($){return typeof $.$ident=="string"?this.b.get($.$ident):{command:$.id,title:$.title,arguments:$.arguments}}getActualCommand(...$){return this.b.get($[0])}h(...$){const v=this.getActualCommand(...$);return this.g.trace("CommandsConverter#EXECUTE",$[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${$[0]}`)}}e.$UO=s;class o{static{this.Uri=new o("uri","Uri of a text document",$=>w.URI.isUri($),$=>$)}static{this.Position=new o("position","A position in a text document",$=>L.$hM.isPosition($),M.Position.from)}static{this.Range=new o("range","A range in a text document",$=>L.$iM.isRange($),M.Range.from)}static{this.Selection=new o("selection","A selection in a text document",$=>L.$jM.isSelection($),M.Selection.from)}static{this.Number=new o("number","",$=>typeof $=="number",$=>$)}static{this.String=new o("string","",$=>typeof $=="string",$=>$)}static{this.StringArray=o.Arr(o.String)}static Arr($){return new o(`${$.name}_array`,`Array of ${$.name}, ${$.description}`,v=>Array.isArray(v)&&v.every(k=>$.validate(k)),v=>v.map(k=>$.convert(k)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",$=>$ instanceof L.$DM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",$=>$ instanceof L.$1N,M.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",$=>$ instanceof g.$KO,M.TestItem.from)}constructor($,v,k,C){this.name=$,this.description=v,this.validate=k,this.convert=C}optional(){return new o(this.name,`(optional) ${this.description}`,$=>$==null||this.validate($),$=>$===void 0?void 0:$===null?null:this.convert($))}with($,v){return new o($??this.name,v??this.description,this.validate,this.convert)}}e.$VO=o;class d{static{this.Void=new d("no result",$=>$)}constructor($,v){this.description=$,this.convert=v}}e.$WO=d;class m{constructor($,v,k,C,O){this.id=$,this.internalId=v,this.description=k,this.args=C,this.result=O}}e.$XO=m}),define(Se[346],De([1,0,19,15,2,82,134,45,33,16,7]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;const I=[new p.$XO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new p.$XO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$VO.Uri],new p.$WO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,g)=>{if((0,u.$Kb)(h))return;class c extends R.$yM{static to(i){const r=new c(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new R.$sM(g[0],E.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=E.Range.to(i.selectionRange),r.children=i.children?i.children.map(c.to):[],r}}return h.map(c.to)})),new p.$XO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$VO.Uri,new p.$VO("options","Formatting options",h=>!0,h=>h)],new p.$WO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$XO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$VO.Uri,p.$VO.Range,new p.$VO("options","Formatting options",h=>!0,h=>h)],new p.$WO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$XO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$VO.Uri,p.$VO.Position,new p.$VO("ch","Trigger character",h=>typeof h=="string",h=>h),new p.$VO("options","Formatting options",h=>!0,h=>h)],new p.$WO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$XO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$XO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$XO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$XO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$XO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of Location-instances.",S(E.location.to))),new p.$XO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new p.$XO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$VO.Uri,new p.$VO("position","A position in a text document",h=>Array.isArray(h)&&h.every(g=>R.$hM.isPosition(g)),h=>h.map(E.Position.from))],new p.$WO("A promise that resolves to an array of ranges.",h=>h.map(g=>{let c;for(const n of g.reverse())c=new R.$CM(E.Range.to(n),c);return c}))),new p.$XO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$VO.String.with("query","Search string")],new p.$WO("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(E.WorkspaceSymbol.to))),new p.$XO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(E.CallHierarchyItem.to))),new p.$XO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$VO.CallHierarchyItem],new p.$WO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(E.CallHierarchyIncomingCall.to))),new p.$XO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$VO.CallHierarchyItem],new p.$WO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(E.CallHierarchyOutgoingCall.to))),new p.$XO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:E.Range.to(h.range),placeholder:h.text}})),new p.$XO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$VO.Uri,p.$VO.Position,p.$VO.String.with("newName","The new symbol name")],new p.$WO("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return E.WorkspaceEdit.to(h)}})),new p.$XO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$VO.Uri,p.$VO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$WO("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(E.DocumentLink.to))),new p.$XO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$VO.Uri],new p.$WO("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new R.$yN(h.tokenTypes,h.tokenModifiers)})),new p.$XO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$VO.Uri],new p.$WO("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,P.$mab)(h);if(g.type==="full")return new R.$AN(g.data,void 0)})),new p.$XO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$VO.Uri,p.$VO.Range.optional()],new p.$WO("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new R.$yN(h.tokenTypes,h.tokenModifiers)})),new p.$XO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$VO.Uri,p.$VO.Range],new p.$WO("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,P.$mab)(h);if(g.type==="full")return new R.$AN(g.data,void 0)})),new p.$XO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$VO.Uri,p.$VO.Position,p.$VO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$VO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$WO("A promise that resolves to a CompletionList-instance.",(h,g,c)=>{if(!h)return new R.$OM([]);const n=h.suggestions.map(i=>E.CompletionItem.to(i,c));return new R.$OM(n,h.incomplete)})),new p.$XO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$VO.Uri,p.$VO.Position,p.$VO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$WO("A promise that resolves to SignatureHelp.",h=>{if(h)return E.SignatureHelp.to(h)})),new p.$XO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$VO.Uri,p.$VO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$WO("A promise that resolves to an array of CodeLens-instances.",(h,g,c)=>S(n=>new R.$GM(E.Range.to(n.range),n.command&&c.fromInternal(n.command)))(h))),new p.$XO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$VO.Uri,new p.$VO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>R.$iM.isRange(h),h=>R.$jM.isSelection(h)?E.Selection.from(h):E.Range.from(h)),p.$VO.String.with("kind","Code action kind to return code actions for").optional(),p.$VO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$WO("A promise that resolves to an array of Command-instances.",(h,g,c)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(n.command)}else{const i=new R.$AM(n.title,n.kind?new R.$BM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=c.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new p.$XO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$VO.Uri],new p.$WO("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(g=>new R.$UM(E.Range.to(g.range),E.Color.to(g.color))):[])),new p.$XO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$VO("color","The color to show and insert",h=>h instanceof R.$TM,E.Color.from),new p.$VO("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:E.Range.from(h.range)}))],new p.$WO("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(E.ColorPresentation.to):[])),new p.$XO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$VO.Uri,p.$VO.Range],new p.$WO("A promise that resolves to an array of Inlay objects",(h,g,c)=>h.map(E.InlayHint.to.bind(void 0,c)))),new p.$XO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$VO.Uri],new p.$WO("A promise that resolves to an array of FoldingRange objects",(h,g)=>{if(h)return h.map(E.FoldingRange.to)})),new p.$XO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$WO("A promise that resolves to an array of NotebookContentProvider static info objects.",S(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(g=>E.NotebookExclusiveDocumentPattern.to(g))})))),new p.$XO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$VO.Uri,p.$VO.Range,new p.$VO("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof R.$iM,h=>E.InlineValueContext.from(h))],new p.$WO("A promise that resolves to an array of InlineValue objects",h=>h.map(E.InlineValue.to))),new p.$XO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$VO("uriOrString","Uri-instance or string (only http/https)",h=>M.URI.isUri(h)||typeof h=="string"&&(0,L.$qg)(h,L.Schemas.http,L.Schemas.https),h=>h),new p.$VO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional(),p.$VO.String.with("label","").optional()],p.$WO.Void),new p.$XO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$VO.Uri.with("resource","Resource to open"),p.$VO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$VO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional()],p.$WO.Void),new p.$XO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$VO.Uri.with("left","Left-hand side resource of the diff editor"),p.$VO.Uri.with("right","Right-hand side resource of the diff editor"),p.$VO.String.with("title","Human readable title for the diff editor").optional(),new p.$VO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)]).optional()],p.$WO.Void),new p.$XO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$VO.String.with("title","Human readable title for the changes editor"),new p.$VO("resourceList","List of resources to compare",h=>{for(const g of h){if(g.length!==3)return!1;const[c,n,i]=g;if(!M.URI.isUri(c)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],p.$WO.Void),new p.$XO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$VO.Uri,p.$VO.Position],new p.$WO("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new p.$XO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$VO.TypeHierarchyItem],new p.$WO("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new p.$XO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$VO.TypeHierarchyItem],new p.$WO("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new p.$XO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$VO.TestItem],p.$WO.Void),new p.$XO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$VO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$WO.Void),new p.$XO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$VO.String.with("name","The context key name"),new p.$VO("value","The context key value",()=>!0,h=>h)],p.$WO.Void),new p.$XO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$VO.Uri,p.$VO.StringArray,new p.$VO("MappedEditsContext","Mapped Edits Context",h=>E.MappedEditsContext.is(h),h=>E.MappedEditsContext.from(h))],new p.$WO("A promise that resolves to a workspace edit or null",h=>h?E.WorkspaceEdit.to(h):null))];class w{static register(g){I.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",b.$fj)}}e.$zic=w;function S(h){return g=>{if(Array.isArray(g))return g.map(h)}}function y(h){if(!Array.isArray(h))return;const g=[];for(const c of h)A.$Yt(c)?g.push(E.DefinitionLink.to(c)):g.push(E.location.to(c));return g}}),define(Se[347],De([1,0,8,3,2,6,33,16,7]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;class E{static{this.a=0}constructor(S,y){this.extension=S,this.provider=y,this.handle=E.a++}}class R{constructor(S){this.session=S,this.responses=[]}}class I{static{this.a=0}constructor(S,y,h,g){this.f=h,this.g=g,this.b=new Map,this.d=new Map,this.e=S.getProxy(A.$eM.MainThreadInlineChat),y.registerApiCommand(new P.$XO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new P.$VO("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?b.Range.from(c.initialRange):void 0,initialSelection:p.$jM.isSelection(c.initialSelection)?b.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?b.Position.from(c.position):void 0}})],P.$WO.Void))}registerProvider(S,y,h){const g=new E(S,y);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,h?.label??S.displayName??S.name,S.identifier.value,typeof y.handleInteractiveEditorResponseFeedback=="function",typeof y.provideFollowups=="function",h?.supportReportIssue??!1),(0,L.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(S,y,h,g){const c=this.b.get(S);if(!c){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(y)),i=b.Selection.to(h),r=await c.provider.prepareInteractiveEditorSession({document:n,selection:i},g);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I.a++;return this.d.set(a,new R(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(r.wholeRange),message:r.message}}async $provideResponse(S,y,h,g){const c=this.b.get(S);if(!c)return;const n=this.d.get(y.id);if(!n)return;const i={prompt:h.prompt,selection:b.Selection.to(h.selection),wholeRange:b.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,previewDocument:this.f.getDocument(M.URI.revive(h.previewDocument)),withIntentDetection:h.withIntentDetection};let r=!1;const a={report:async D=>{if(!h.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||g.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.$HM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(c.provider.provideInteractiveEditorResponse(n.session,i,a,g));let f;try{f=await(0,u.$7g)(t,g)}finally{r=!0}if(!f)return;const l=n.responses.push(f)-1,s={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!I.h(f))return{...s,id:l,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:o,contents:d}=f,m=d!==void 0?b.MarkdownString.from(d):void 0;return o instanceof p.$qM?{...s,id:l,type:"bulkEdit",edits:b.WorkspaceEdit.from(o),message:m}:{...s,id:l,type:"editorEdit",edits:o.map(b.TextEdit.from),message:m}}async $provideFollowups(S,y,h,g){const c=this.b.get(S),n=this.d.get(y),i=n?.responses[h];if(c&&i&&c.provider.provideFollowups){const r=Promise.resolve(c.provider.provideFollowups(n.session,i,g));return(await(0,u.$7g)(r,g))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(S,y,h,g){const c=this.b.get(S),n=this.d.get(y),i=n?.responses[h];if(c&&i){const r=b.InteractiveEditorResponseFeedbackKind.to(g);c.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(S,y){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$Jjc=I}),define(Se[348],De([1,0,2,33]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class M{constructor(P,b,p,E,R){this.a=b,this.b=p,this.c=E;const I=new L.$XO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$VO("showOptions","Show Options",w=>!0,w=>w),new L.$VO("resource","Interactive resource Uri",w=>!0,w=>w),new L.$VO("controllerId","Notebook controller Id",w=>!0,w=>w),new L.$VO("title","Interactive editor title",w=>!0,w=>w)],new L.$WO("Notebook and input URI",w=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const S=this.a.getEditorById(w.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:u.URI.revive(w.notebookUri),inputUri:u.URI.revive(w.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:u.URI.revive(w.notebookUri),inputUri:u.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(P,b,p,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:p,uri:P,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(P,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Wjc=M}),define(Se[349],De([1,0,19,8,22,4,3,28,2,25,12,6,33,16,7,113,291,26,67,292]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=void 0,e.$6jc=o;let r=class{constructor(m,D,$,v,k){this.m=D,this.n=$,this.o=v,this.q=k,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$6d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=m.getProxy(I.$eM.MainThreadNotebookKernels);const C=new w.$XO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$VO("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const z=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:z}}else if(B&&"notebookEditor"in B){const z=this.n.getIdByEditor(B.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return B})],w.$WO.Void),O=new w.$XO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[w.$VO.Uri],new w.$WO("A promise that resolves to an array of variables",(B,z)=>B.map(T=>({name:T.name,value:T.value,type:T.type,editable:!1}))));this.o.registerApiCommand(C),this.o.registerApiCommand(O)}createNotebookController(m,D,$,v,k,C){for(const ge of this.j.values())if(ge.controller.id===D&&E.$Bm.equals(m.identifier,ge.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const O=this.k++,B=this;this.q.trace(`NotebookController[${O}], CREATED by ${m.identifier.value}, ${D}`);const z=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${m.identifier}'`);let T=!1;const j=new A.$6d,N=new A.$6d,F={id:o(m.identifier,D),notebookType:$,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:v||m.identifier.value,preloads:C?C.map(S.NotebookRendererScript.from):[]};let K=k??z,ee,Y;this.a.$addKernel(O,F).catch(ge=>{console.log(ge),T=!0});let Q=0;const Z=()=>{if(T)return;const ge=++Q;Promise.resolve().then(()=>{ge===Q&&this.a.$updateKernel(O,F)})},ae=new b.$Ac,_={get id(){return D},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return F.label},set label(ge){F.label=ge??m.displayName??m.name,Z()},get detail(){return F.detail??""},set detail(ge){F.detail=ge,Z()},get description(){return F.description??""},set description(ge){F.description=ge,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ge){F.supportedLanguages=ge,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){F.supportsExecutionOrder=ge,Z()},get rendererScripts(){return F.preloads?F.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ge){K=ge??z},get interruptHandler(){return ee},set interruptHandler(ge){ee=ge,F.supportsInterrupt=!!ge,Z()},set variableProvider(ge){(0,c.$4F)(m,"notebookVariableProvider"),Y=ge,F.hasVariableProvider=!!ge,ge?.onDidChangeVariables(se=>B.a.$variablesUpdated(se.uri)),Z()},get variableProvider(){return Y},createNotebookCellExecution(ge){if(T)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.notebook.uri))throw B.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return B._createNotebookCellExecution(ge,o(m.identifier,this.id))},createNotebookExecution(ge){if((0,c.$4F)(m,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.uri))throw B.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return B._createNotebookExecution(ge,o(m.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${O}], DISPOSED`),T=!0,this.j.delete(O),j.dispose(),N.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ge,se){se===y.NotebookControllerAffinity2.Hidden&&(0,c.$4F)(m,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(O,ge.uri,se)},onDidReceiveMessage:N.event,postMessage(ge,se){return(0,c.$4F)(m,"notebookMessaging"),B.a.$postMessage(O,se&&B.n.getIdByEditor(se),ge)},asWebviewUri(ge){return(0,c.$4F)(m,"notebookMessaging"),(0,h.$Yxb)(ge,B.m.remote)}};return this.j.set(O,{extensionId:m.identifier,controller:_,onDidReceiveMessage:N,onDidChangeSelection:j,associatedNotebooks:ae}),_}getIdByController(m){for(const[D,$]of this.j)if($.controller===m)return o($.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,D){const $=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${$}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask($,D);const k={dispose:()=>{this.f.delete($),v.a.$removeKernelDetectionTask($)}};return this.f.set($,k),k}registerKernelSourceActionProvider(m,D,$){const v=this.i++,k=typeof $.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,C=this;this.h.set(v,$),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,D);let O;return k!==void 0&&(O=$.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(v),C.a.$removeKernelSourceActionProvider(v,v),O?.dispose()}}}async $provideKernelSourceActions(m,D){const $=this.h.get(m);if($){const v=new P.$Sc;return(await $.provideNotebookKernelSourceActions(D)??[]).map(C=>S.NotebookKernelSourceAction.from(C,this.o.converter,v))}return[]}$acceptNotebookAssociation(m,D,$){const v=this.j.get(m);if(v){const k=this.n.getNotebookDocument(p.URI.revive(D));$?v.associatedNotebooks.set(k.uri,!0):v.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${m}] ASSOCIATE notebook`,k.uri.toString(),$),v.onDidChangeSelection.fire({selected:$,notebook:k.apiNotebook})}}async $executeCells(m,D,$){const v=this.j.get(m);if(!v)return;const k=this.n.getNotebookDocument(p.URI.revive(D)),C=[];for(const O of $){const B=k.getCell(O);B&&C.push(B.apiCell)}try{this.q.trace(`NotebookController[${m}] EXECUTE cells`,k.uri.toString(),C.length),await v.controller.executeHandler.call(v.controller,C,k.apiNotebook,v.controller)}catch(O){this.q.error(`NotebookController[${m}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(m,D,$){const v=this.j.get(m);if(!v)return;const k=this.n.getNotebookDocument(p.URI.revive(D));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,k.apiNotebook);else for(const C of $){const O=k.getCell(C);O&&this.b.get(O.uri)?.cancel()}if(v.controller.interruptHandler){const C=this.c.get(k.uri);$.length&&Array.isArray(C)&&C.length&&C.forEach(O=>O.dispose())}}async $provideVariables(m,D,$,v,k,C,O){const B=this.j.get(m);if(!B)return;const z=this.n.getNotebookDocument(p.URI.revive($)),T=B.controller.variableProvider;if(!T)return;let j;if(v!==void 0){if(j=this.s[v],!j)return}else this.s={};const N=k==="named"?y.NotebookVariablesRequestKind.Named:y.NotebookVariablesRequestKind.Indexed,F=T.provideVariables(z.apiNotebook,j,N,C,O);let K=0;for await(const ee of F){if(O.isCancellationRequested)return;const Y={id:this.r++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:B.extensionId.value};if(this.s[Y.id]=ee.variable,this.a.$receiveVariable(D,Y),K++>=i.$ehb)return}}$acceptKernelMessageFromRenderer(m,D,$){const v=this.j.get(m);if(!v)return;const k=this.n.getEditorById(D);v.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:$}))}$cellExecutionChanged(m,D,$){const k=this.n.getNotebookDocument(p.URI.revive(m)).getCell(D);if(k){const C=$?S.NotebookCellExecutionState.to($):y.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:k.apiCell,state:C})}}_createNotebookCellExecution(m,D){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const k=new t(D,v,this.a);this.b.set(v.uri,k);const C=k.onDidChangeState(()=>{k.state===a.Resolved&&(k.dispose(),C.dispose(),this.b.delete(v.uri))});return k.asApiObject()}_createNotebookExecution(m,D){const $=this.n.getNotebookDocument(m.uri),v=m.getCells().find(O=>{const B=$.getCellFromApiCell(O);return B&&this.b.has(B.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has($.uri))throw new Error(`duplicate notebook execution for ${$.uri}`);const k=new l(D,$,this.a),C=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),C.dispose(),this.c.delete($.uri))});return this.c.set($.uri,[k,C]),k.asApiObject()}};e.$5jc=r,e.$5jc=r=Je([qe(4,R.$Mj)],r);var a;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(a||(a={}));class t extends P.$Tc{static{this.a=0}get state(){return this.f}constructor(m,D,$){super(),this.m=D,this.n=$,this.b=t.a++,this.c=new A.$6d,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new M.$de),this.h=new s(10,v=>this.s(v)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const D=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$aw(D))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let D=this.m;if(m&&(D=this.m.notebook.getCellFromApiCell(m)),!D)throw new Error("INVALID cell");return D.handle}y(m){return m.map(D=>{const $=y.$LN.ensureUniqueMimeTypes(D.items,!0);return $===D.items?S.NotebookCellOutput.from(D):S.NotebookCellOutput.from({items:$,id:D.id,metadata:D.metadata})})}async z(m,D,$){const v=this.w(D),k=this.y((0,u.$3b)(m));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:v,append:$,outputs:k})}async C(m,D,$){return m=y.$LN.ensureUniqueMimeTypes((0,u.$3b)(m),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:m.map(S.NotebookCellOutputItem.from),outputId:D.id,append:$})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder($){m.j=$,m.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start($){if(m.f===a.Resolved||m.f===a.Started)throw new Error("Cannot call start again");m.f=a.Started,m.c.fire(),m.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:$})},end($,v){if(m.f===a.Resolved)throw new Error("Cannot call resolve twice");m.f=a.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$aw({runEndTime:v,lastRunSuccess:$}))},clearOutput($){return m.t(),m.z([],$,!1)},appendOutput($,v){return m.t(),m.z($,v,!0)},replaceOutput($,v){return m.t(),m.z($,v,!1)},appendOutputItems($,v){return m.t(),m.C($,v,!0)},replaceOutputItems($,v){return m.t(),m.C($,v,!1)}})}}var f;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(f||(f={}));class l extends P.$Tc{static{this.a=0}get state(){return this.f}constructor(m,D,$){super(),this.h=D,this.j=$,this.b=l.a++,this.c=new A.$6d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new M.$de),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(m,D){this.f=m,this.g=D,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$Dh,this.b=Date.now(),(0,L.$hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>m.complete())}}function o(d,m){return`${d.value}/${m}`}}),define(Se[46],De([1,0,4,6,5,2,20,3,7,225,13,269,22,30,270,55,8,16,33]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=e.$fjc=e.$ejc=void 0,e.$ejc=(0,M.$gi)("IExtHostTerminalService");class i{constructor($,v,k,C){this.l=$,this._id=v,this.m=k,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(B=>this.f=B);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(B,z=!0){O.q(),O.l.$sendText(O._id,B,z)},show(B){O.q(),O.l.$show(O._id,B)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create($,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??v?.cwd??void 0,env:$.env??void 0,icon:o($.iconPath)??void 0,color:h.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.o($.location,v?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,v,k,C,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:C,color:h.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.o($,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,v){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in $?{viewColumn:c.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,v){this.h=Object.freeze({code:$,reason:v})}setDimensions($,v){return $===this.d&&v===this.g||$===0||v===0?!1:(this.d=$,this.g=v,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(v=>{v!==$&&(this.b=Promise.resolve($))})}}e.$fjc=i;class r{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new u.$6d,this.onProcessData=this.a.event,this.b=new u.$6d,this.d=new u.$6d,this.onDidChangeProperty=this.d.event,this.f=new u.$6d,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,v){this.g.setDimensions?.({columns:$,rows:v})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:"overrideDimensions",value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:"title",value:v})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,v,k){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$6d,this.onDidCloseTerminal=this.H.event,this.I=new u.$6d,this.onDidOpenTerminal=this.I.event,this.J=new u.$6d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$6d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$6d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$6d,this.onDidChangeShell=this.N.event,this.O=new u.$6d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$6d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(L.$eM.MainThreadTerminalService),this.y=new y.$4tb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const O=B=>{const z=B;return this.W(z.instanceId)?.value};switch(C?.$mid){case 15:return O(C);default:{if(Array.isArray(C))for(let B=0;B<C.length&&C[B].$mid===15;B++)C[B]=O(C[B]);return C}}}}),this.B({dispose:()=>{for(const[C,O]of this.g)O.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,v){const k=new i(this.a,(0,S.$Cg)(),$,$.name),C=new r($.pty);return k.createExtensionTerminal($.location,v,this.R($,v).resolvedExtHostIdentifier,o($.iconPath),d($.color)).then(O=>{const B=this.S(O,C);this.h[O]=B}),this.f.push(k),k.value}R($,v){if(v=v||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const k=$.location.parentTerminal;if(k){const C=this.f.find(O=>O.value===k);C&&(v.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?v.location=$.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal($,v){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new r(v),O=this.S($,C);this.h[$]=O}async $acceptActiveTerminalChanged($){const v=this.b;if($===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const k=this.W($);k&&(this.b=k,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,v){const k=this.W($);k&&this.O.fire({terminal:k.value,data:v})}async $acceptTerminalDimensions($,v,k){const C=this.W($);C&&C.setDimensions(v,k)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,v){const k=this.W($);k&&this.P.fire({terminal:k.value,...v})}async $acceptTerminalMaximumDimensions($,v,k){this.g.get($)?.resize(v,k)}async $acceptTerminalTitleChange($,v){const k=this.W($);k&&(k.name=v)}async $acceptTerminalClosed($,v,k){const C=this.Y(this.f,$);if(C!==null){const O=this.f.splice(C,1)[0];O.setExitStatus(v,k),this.H.fire(O.value)}}$acceptTerminalOpened($,v,k,C){if(v){const z=this.Y(this.f,v);if(z!==null){this.f[z]._id=$,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},B=new i(this.a,$,O,k);this.f.push(B),this.I.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId($,v){this.W($)?._setProcessId(v)}async $startExtensionTerminal($,v){const k=this.W($);if(!k)return{message:(0,E.localize)(0,null,$)};k.isOpen||await new Promise(O=>{const B=this.onDidOpenTerminal(async z=>{z===k.value&&(B.dispose(),O())})});const C=this.g.get($);C?C.startSendingEvents(v):this.j[$]={initialDimensions:v}}S($,v){const k=new b.$Sc;k.add(v.onProcessReady(O=>this.a.$sendProcessReady($,O.pid,O.cwd,O.windowsPty))),k.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty($,O))),this.y.startBuffering($,v.onProcessData),k.add(v.onProcessExit(O=>this.U($,O))),this.g.set($,v);const C=this.j[$];return C&&v instanceof r&&(v.startSendingEvents(C.initialDimensions),delete this.j[$]),k}$acceptProcessAckDataEvent($,v){this.g.get($)?.acknowledgeDataEvent(v)}$acceptProcessInput($,v){this.g.get($)?.input(v)}$acceptTerminalInteraction($){const v=this.W($);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection($,v){this.W($)?.setSelection(v)}$acceptProcessResize($,v,k){try{this.g.get($)?.resize(v,k)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,v){this.g.get($)?.shutdown(v)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(v=>this.a.$sendProcessProperty($,{type:"initialCwd",value:v}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(v=>this.a.$sendProcessProperty($,{type:"cwd",value:v}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new p.$gM(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,v,k){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,k),this.a.$registerProfileProvider(v,$.identifier.value),new p.$gM(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider($,v,k){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,k),this.a.$registerQuickFixProvider($,v),new p.$gM(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,v){const k=new w.$de().token;if(k.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const O=await C.provideTerminalQuickFixes(v,k);if(O===null||Array.isArray(O)&&O.length===0)return;const B=new b.$Sc;if(this.w.value=B,!Array.isArray(O))return O?c.TerminalQuickFix.from(O,this.Q.converter,B):void 0;const z=[];for(const T of O){const j=c.TerminalQuickFix.from(T,this.Q.converter,B);j&&z.push(j)}return z}async $createContributedProfileTerminal($,v){const k=new w.$de().token;let C=await this.C.get($)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,v);return}this.createTerminalFromOptions(C.options,v)}}async $provideLinks($,v){const k=this.W($);if(!k)return[];this.F.delete($),this.G.get($)?.dispose(!0);const O=new w.$de;this.G.set($,O);const B=[],z={terminal:k.value,line:v},T=[];for(const F of this.z)T.push(g.Promises.withAsyncBody(async K=>{O.token.onCancellationRequested(()=>K({provider:F,links:[]}));const ee=await F.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||K({provider:F,links:ee})}));const j=await Promise.all(T);if(O.token.isCancellationRequested)return[];const N=new Map;for(const F of j)F&&F.links.length>0&&B.push(...F.links.map(K=>{const ee={id:a++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return N.set(ee.id,{provider:F.provider,link:K}),ee}));return this.F.set($,N),B}$activateLink($,v){const k=this.F.get($)?.get(v);k&&k.provider.handleTerminalLink(k.link)}U($,v){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const k=this.h[$];k&&(k.dispose(),delete this.h[$]),this.a.$sendProcessExit($,v)}W($){return this.X(this.f,$)}X($,v){const k=this.Y($,v);return k!==null?$[k]:null}Y($,v){const k=$.findIndex(C=>C._id===v);return k===-1?null:k}getEnvironmentVariableCollection($){let v=this.n.get($.identifier.value);return v||(v=new f,this.$($.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Z($,v){const k=(0,I.$3r)(v.map),C=(0,I.$4r)(v.descriptionMap);this.a.$setEnvironmentVariableCollection($,v.persistent,k.length===0?void 0:k,C)}$initEnvironmentVariableCollections($){$.forEach(v=>{const k=v[0],C=new f(v[1]);this.$(k,C)})}$acceptDefaultProfile($,v){const k=this.s;this.s=$,this.u=v,k?.path!==$.path&&this.N.fire($.path)}$($,v){this.n.set($,v),v.onDidChangeCollection(()=>{this.Z($,v)})}};e.$gjc=t,e.$gjc=t=Je([qe(1,n.$TO),qe(2,P.$xO)],t);class f{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$6d,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const v=this.h($);let k=this.a.get(v);return k||(k=new l(this,$),this.a.set(v,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace($,v,k,C){this.f($,{value:v,type:p.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:C})}append($,v,k,C){this.f($,{value:v,type:p.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:C})}prepend($,v,k,C){this.f($,{value:v,type:p.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:C})}f($,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g($,v.scope),C=this.map.get(k),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==v.value||C.type!==v.type||C.options?.applyAtProcessCreation!==O.applyAtProcessCreation||C.options?.applyAtShellIntegration!==O.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const B=this.g($,v.scope),z={variable:$,...v,options:O};this.map.set(B,z),this.d.fire()}}get($,v){const k=this.g($,v),C=this.map.get(k);return C?m(C):void 0}g($,v){const k=this.h(v);return k.length?`${$}:::${k}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const v=new Map;for(const[k,C]of this.map)this.h(C.scope)===this.h($)&&v.set(C.variable,m(C));return v}delete($,v){const k=this.g($,v);this.map.delete(k),this.d.fire()}clear($){if($?.workspaceFolder){for(const[v,k]of this.map)k.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(v);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,v){const k=this.h(v),C=this.descriptionMap.get(k);if(!C||C.description!==$){let O;typeof $=="string"?O=$:O=$?.value.split(`

`)[0];const B={description:O,scope:v};this.descriptionMap.set(k,B),this.d.fire()}}getDescription($){const v=this.h($);return this.descriptionMap.get(v)?.description}k($){const v=this.h($);this.descriptionMap.delete(v)}}class l{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,v){this.b=$,this.d=v,this.a=new u.$6d}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,v,k){this.b.replace($,v,k,this.d)}append($,v,k){this.b.append($,v,k,this.d)}prepend($,v,k){this.b.prepend($,v,k,this.d)}get($){return this.b.get($,this.d)}forEach($,v){this.b.getVariableMap(this.d).forEach((k,C)=>$.call(v,C,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let s=class extends t{constructor($,v){super(!1,$,v)}createTerminal($,v,k){throw new R.$_}createTerminalFromOptions($,v){throw new R.$_}};e.$hjc=s,e.$hjc=s=Je([qe(0,n.$TO),qe(1,P.$xO)],s);function o(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function d(D){return h.ThemeColor.isThemeColor(D)?D:void 0}function m(D){const $={...D};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Se[350],De([1,0,8,21,22,4,73,54,3,24,18,30,12,6,20,154,16,7,66,112,89,26]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=e.$mkc=e.$lkc=e.$kkc=void 0;let t=class extends p.$Tc{constructor(T,j,N,F){super(),this.w=F,this.f=this.B(new A.$6d),this.g=new Map,this.s=this.B(new A.$6d),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(S.$eM.MainThreadTesting),this.m=new k(this.h),this.j=new o(this.h,j),N.registerArgumentProcessor({processArgument:K=>{switch(K?.$mid){case 16:{const ee=K,Y=ee.tests[ee.tests.length-1].item.extId;return this.g.get(n.$3K.root(Y))?.collection.tree.get(Y)?.actual??(0,h.$JO)(K)}case 18:{const{test:ee,message:Y}=K,Q=ee.item.extId;return{test:this.g.get(n.$3K.root(Q))?.collection.tree.get(Q)?.actual??(0,h.$JO)({$mid:16,tests:[ee]}),message:g.TestMessage.to(Y)}}default:return K}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const K=await N.executeCommand("_testing.getExplorerSelection"),ee=Y=>{const Q=this.g.get(n.$3K.root(Y));if(Q)return n.$3K.isRoot(Y)?Q.controller:Q.collection.tree.get(Y)?.actual};return{include:K?.include.map(ee).filter(R.$2f)||[],exclude:K?.exclude.map(ee).filter(R.$2f)||[]}})}createTestController(T,j,N,F){if(this.g.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const K=new p.$Sc,ee=K.add(new h.$MO(j,N,this.w));ee.root.label=N;const Y=new Map,Q=new Set,Z=this.h,ae={items:ee.root.children,get label(){return N},set label(ge){N=ge,ee.root.label=ge,Z.$updateController(j,{label:N})},get refreshHandler(){return F},set refreshHandler(ge){F=ge,Z.$updateController(j,{canRefresh:!!ge})},get id(){return j},createRunProfile:(ge,se,re,U,ie,ye)=>{let le=(0,b.$7i)(ge);for(;Y.has(le);)le++;return new O(this.h,Y,Q,this.s.event,j,le,ge,se,re,U,ie,ye)},createTestItem(ge,se,re){return new h.$KO(j,ge,se,re)},createTestRun:(ge,se,re=!0)=>this.j.createTestRun(T,j,ee,ge,se,re),invalidateTestResults:ge=>{if(ge===void 0)this.h.$markTestRetired(void 0);else{const se=ge instanceof Array?ge:[ge];this.h.$markTestRetired(se.map(re=>n.$3K.fromExtHostTestItem(re,j).toString()))}},set resolveHandler(ge){ee.resolveHandler=ge},get resolveHandler(){return ee.resolveHandler},dispose:()=>{K.dispose()}};Z.$registerTestController(j,N,!!F),K.add((0,p.$Rc)(()=>Z.$unregisterTestController(j)));const _={controller:ae,collection:ee,profiles:Y,extension:T,activeProfiles:Q};return this.g.set(j,_),K.add((0,p.$Rc)(()=>this.g.delete(j))),K.add(ee.onDidGenerateDiff(ge=>Z.$publishDiff(j,ge.map(r.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.m.checkout()}async runTests(T,j=M.CancellationToken.None){const N=d(T);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.g.get(N.controllerId);if(!F)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(K=>n.$3K.fromExtHostTestItem(K,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:B[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:T.exclude?.map(K=>K.id)},j)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $provideFileCoverage(T,j,N){return await this.j.getCoverageReport(T,j)?.provideFileCoverage(N)??[]}async $resolveFileCoverage(T,j,N,F){return await this.j.getCoverageReport(T,j)?.resolveFileCoverage(N,F)??[]}$configureRunProfile(T,j){this.g.get(T)?.profiles.get(j)?.configureHandler?.()}$setDefaultRunProfiles(T){const j=new Map;for(const[N,F]of Object.entries(T)){const K=this.g.get(N);if(!K)continue;const ee=new Map,Y=F.filter(Z=>!K.activeProfiles.has(Z)),Q=[...K.activeProfiles].filter(Z=>!F.includes(Z));for(const Z of Y)ee.set(Z,!0),K.activeProfiles.add(Z);for(const Z of Q)ee.set(Z,!1),K.activeProfiles.delete(Z);ee.size&&j.set(N,ee)}this.s.fire(j)}async $refreshTests(T,j){await this.g.get(T)?.controller.refreshHandler?.(j)}$publishTestResults(T){this.results=Object.freeze(T.map(j=>(0,E.$Nn)(g.TestResults.to(j))).concat(this.results).sort((j,N)=>N.completedAt-j.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,j){const N=this.g.get(n.$3K.fromString(T).controllerId)?.collection;N&&(await N.expand(T,j<0?1/0:j),N.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(j=>r.TestsDiffOp.deserialize({asCanonicalUri:N=>N},j)))}async $runControllerTests(T,j){return Promise.all(T.map(N=>this.y(N,!1,j)))}async $startContinuousRun(T,j){const N=new M.$de(j),F=await Promise.all(T.map(K=>this.y(K,!0,N.token)));return!j.isCancellationRequested&&!F.some(K=>K.error)&&await new Promise(K=>j.onCancellationRequested(K)),N.dispose(!0),F}async y(T,j,N){const F=this.g.get(T.controllerId);if(!F)return{};const{collection:K,profiles:ee,extension:Y}=F,Q=ee.get(T.profileId);if(!Q)return{};const Z=T.testIds.map(se=>K.tree.get(se)).filter(R.$2f),ae=T.excludeExtIds.map(se=>F.collection.tree.get(se)).filter(R.$2f).filter(se=>Z.some(re=>re.fullId.compare(se.fullId)===2));if(!Z.length)return{};const _=new c.$SN(Z.some(se=>se.actual instanceof h.$LO)?void 0:Z.map(se=>se.actual),ae.map(se=>se.actual),Q,j),ge=(0,r.$6K)(T)&&this.j.prepareForMainThreadTestRun(_,m.fromInternal(T,F.collection),Y,N);try{return await Q.runHandler(_,N),{}}catch(se){return{error:String(se)}}finally{ge&&(ge.hasRunningTasks&&!N.isCancellationRequested&&await A.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$kkc=t,e.$kkc=t=Je([qe(0,y.$xO),qe(1,w.$Mj)],t);const f=1e4;var l;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(l||(l={}));class s extends p.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(T,j,N,F,K){super(),this.s=T,this.w=j,this.y=N,this.z=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$6d),this.m=this.B(new A.$6d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new M.$de(K));const ee=this.B(new u.$sh(()=>this.C(),f));this.B(this.h.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(T){const j=this.s.id,N=this.s.controllerId,F=(0,I.$Cg)(),K=this.y,ee=this.m;let Y;const Q=ge=>(se,...re)=>{if(ae){this.z.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.s.isIncluded(se)&&(this.F(se),ge(se,...re))},Z=(ge,se)=>{const re=se instanceof Array?se.map(g.TestMessage.from):[g.TestMessage.from(se)];if(ge.uri&&ge.range){const U={range:g.Range.from(ge.range),uri:ge.uri};for(const ie of re)ie.location=ie.location||U}this.w.$appendTestMessagesInRun(j,F,n.$3K.fromExtHostTestItem(ge,N).toString(),re)};let ae=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:T,get coverageProvider(){return Y?.provider},set coverageProvider(ge){(0,a.$4F)(K,"testCoverage"),Y=ge&&new D(ge),ee.fire({taskId:F,runId:j,coverage:Y})},enqueued:Q(ge=>{this.w.$updateTestStateInRun(j,F,n.$3K.fromExtHostTestItem(ge,N).toString(),1)}),skipped:Q(ge=>{this.w.$updateTestStateInRun(j,F,n.$3K.fromExtHostTestItem(ge,N).toString(),5)}),started:Q(ge=>{this.w.$updateTestStateInRun(j,F,n.$3K.fromExtHostTestItem(ge,N).toString(),2)}),errored:Q((ge,se,re)=>{Z(ge,se),this.w.$updateTestStateInRun(j,F,n.$3K.fromExtHostTestItem(ge,N).toString(),6,re)}),failed:Q((ge,se,re)=>{Z(ge,se),this.w.$updateTestStateInRun(j,F,n.$3K.fromExtHostTestItem(ge,N).toString(),4,re)}),passed:Q((ge,se)=>{this.w.$updateTestStateInRun(j,F,n.$3K.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,se)}),appendOutput:(ge,se,re)=>{ae||(re&&(this.s.isIncluded(re)?this.F(re):re=void 0),this.w.$appendOutputToRun(j,F,L.$te.fromString(ge),se&&g.location.from(se),re&&n.$3K.fromExtHostTestItem(re,N).toString()))},end:()=>{ae||(ae=!0,this.w.$finishedTestRunTask(j,F),this.f.delete(F),this.f.size||this.D())}};return this.f.set(F,{run:_}),this.w.$startedTestRunTask(j,{id:F,name:T,running:!0}),_}C(){for(const{run:T}of this.f.values())T.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(T){if(!(T instanceof h.$KO))throw new i.$pO(T.id);if(this.g.has(n.$3K.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const j=[],N=this.s.colllection.root;for(;;){const F=g.TestItem.from(T);if(j.unshift(F),this.g.has(F.extId)||(this.g.add(F.extId),T===N))break;T=T.parent||N}this.w.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.D(),super.dispose()}}class o{get trackers(){return this.c.values()}constructor(T,j){this.g=T,this.h=j,this.c=new Map,this.f=[]}getCoverageReport(T,j){return this.f.find(N=>N.runId===T)?.coverage.get(j)}prepareForMainThreadTestRun(T,j,N,F){return this.j(T,j,N,F)}cancelRunById(T){for(const j of this.c.values())if(j.id===T){j.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,j,N,F,K,ee){const Y=this.c.get(F);if(Y)return Y.createRun(K);const Q=m.fromPublic(j,N,F,ee),Z=d(F);this.g.$startedExtensionTestRun({controllerId:j,continuous:!!F.continuous,profile:Z&&{group:B[Z.kind],id:Z.profileId},exclude:F.exclude?.map(_=>n.$3K.fromExtHostTestItem(_,N.root.id).toString())??[],id:Q.id,include:F.include?.map(_=>n.$3K.fromExtHostTestItem(_,N.root.id).toString())??[N.root.id],persist:ee});const ae=this.j(F,Q,T);return A.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(Q.id),ae.dispose()}),ae.createRun(K)}j(T,j,N,F){const K=new s(j,this.g,N,this.h,F);this.c.set(T,K);let ee;const Y=K.onDidCoverage(({runId:Q,taskId:Z,coverage:ae})=>{ee||(ee={runId:Q,coverage:new Map},this.f.unshift(ee),this.f.length>r.$$K&&this.f.pop()),ee.coverage.set(Z,ae),this.g.$signalCoverageAvailable(Q,Z,!!ae)});return A.Event.once(K.onEnd)(()=>{this.c.delete(T),Y.dispose()}),K}}e.$lkc=o;const d=z=>{if(z.profile){if(!(z.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class m{static fromPublic(T,j,N,F){return new m(T,(0,I.$Cg)(),N.include?.map(K=>n.$3K.fromExtHostTestItem(K,T).toString())??[T],N.exclude?.map(K=>n.$3K.fromExtHostTestItem(K,T).toString())??[],F,j)}static fromInternal(T,j){return new m(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,j)}constructor(T,j,N,F,K,ee){this.controllerId=T,this.id=j,this.isPersisted=K,this.colllection=ee,this.c=N.map(Y=>Y+"\0"),this.f=F.map(Y=>Y+"\0")}isIncluded(T){const j=n.$3K.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const N of this.f)if(j===N||j.startsWith(N))return!1;for(const N of this.c)if(j===N||j.startsWith(N))return!0;return!1}}e.$mkc=m;class D{constructor(T){this.provider=T}async provideFileCoverage(T){this.c||(this.c=(async()=>this.provider.provideFileCoverage(T))());try{return(await this.c)?.map(g.TestCoverage.fromFile)??[]}catch(j){throw this.c=void 0,j}}async resolveFileCoverage(T,j){const N=await this.c;let F=N?.[T];return!this.provider||!N||!F?[]:(F.detailedCoverage||(F=N[T]=await this.provider.resolveFileCoverage?.(F,j)??F),F.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,g.TestItem.toPlain(T.item)),this.c.has(T)||this.f.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.f.delete(T);const j=n.$3K.parentId(T.item.extId);if(j&&this.h.has(j.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{c:T,f:j,g:N}=this;return{get added(){return[...T].map(F=>F.revived)},get updated(){return[...j].map(F=>F.revived)},get removed(){return[...N].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends r.$_K{constructor(){super(...arguments),this.s=new A.$6d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}w(T,j){return{...T,revived:g.TestItem.toPlain(T.item),depth:j?j.depth+1:0,children:new Set}}v(){return new $(this.s)}}class k{constructor(T){this.f=T}checkout(){this.c||(this.c=this.g());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(j=>j.revived)},dispose:(0,P.$db)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}g(){const T=new v({asCanonicalUri:j=>j});return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}const C=(z,T,j,N)=>{j?Object.assign(j,N):T.$updateTestRunConfig(z.controllerId,z.profileId,N)};class O{#e;#t;#i;#n;#s;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,C(this,this.#e,this.#n,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,C(this,this.#e,this.#n,{supportsContinuousRun:T}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?this.#t.add(this.profileId):this.#t.delete(this.profileId),C(this,this.#e,this.#n,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,C(this,this.#e,this.#n,{tag:T?g.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,C(this,this.#e,this.#n,{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return A.Event.chain(this.#i,T=>T.map(j=>j.get(this.controllerId)?.get(this.profileId)).filter(R.$2f))}constructor(T,j,N,F,K,ee,Y,Q,Z,ae=!1,_=void 0,ge=!1){this.controllerId=K,this.profileId=ee,this.f=Y,this.kind=Q,this.runHandler=Z,this._tag=_,this.g=ge,this.#e=T,this.#s=j,this.#t=N,this.#i=F,j.set(ee,this);const se=B[Q];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);ae&&N.add(ee),this.#n={profileId:ee,controllerId:K,tag:_?g.TestTag.namespace(this.controllerId,_.id):null,label:Y,group:se,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:ge},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$nkc=O;const B={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(Se[155],De([1,0,61,13,124,16,7]),function(fe,e,u,L,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=void 0;class b{static{this.c=new M.$CO("TextEditorDecorationType")}constructor(w,S,y){const h=b.c.nextId();w.$registerTextEditorDecorationType(S.identifier,h,A.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:h,dispose(){w.$removeTextEditorDecorationType(h)}})}}e.$EO=b;class p{constructor(w,S){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,S){this.k();let y=null;if(w instanceof P.$hM)y=new P.$iM(w,w);else if(w instanceof P.$iM)y=w;else throw new Error("Unrecognized location");this.l(y,S,!1)}insert(w,S){this.k(),this.l(new P.$iM(w,w),S,!0)}delete(w){this.k();let S=null;if(w instanceof P.$iM)S=w;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(w,S,y){const h=this.c.validateRange(w);this.g.push({range:h,text:S,forceMoveMarkers:y})}setEndOfLine(w){if(this.k(),w!==P.EndOfLine.LF&&w!==P.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=w}}class E{constructor(w,S,y,h){this.c=w,this.d=S,this._accept(y),this.e=h;const g=this;this.value={get tabSize(){return g.f},set tabSize(c){g.n(c)},get indentSize(){return g.g},set indentSize(c){g.p(c)},get insertSpaces(){return g.j},set insertSpaces(c){g.s(c)},get cursorStyle(){return g.k},set cursorStyle(c){g.t(c)},get lineNumbers(){return g.l},set lineNumbers(c){g.u(c)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.originalIndentSize,this.j=w.insertSpaces,this.k=w.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(w.lineNumbers)}m(w){if(w==="auto")return"auto";if(typeof w=="number"){const S=Math.floor(w);return S>0?S:null}if(typeof w=="string"){const S=parseInt(w,10);return isNaN(S)?null:S>0?S:null}return null}n(w){const S=this.m(w);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const S=Math.floor(w);return S>0?S:null}if(typeof w=="string"){const S=parseInt(w,10);return isNaN(S)?null:S>0?S:null}return null}p(w){const S=this.o(w);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(w){return w==="auto"?"auto":w==="false"?!1:!!w}s(w){const S=this.q(w);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(w){this.k!==w&&(this.k=w,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}u(w){this.l!==w&&(this.l=w,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(w)})))}assign(w){const S={};let y=!1;if(typeof w.tabSize<"u"){const h=this.m(w.tabSize);h==="auto"?(y=!0,S.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,y=!0,S.tabSize=h)}if(typeof w.indentSize<"u"){const h=this.o(w.indentSize);h==="tabSize"?(y=!0,S.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,y=!0,S.indentSize=h)}if(typeof w.insertSpaces<"u"){const h=this.q(w.insertSpaces);h==="auto"?(y=!0,S.insertSpaces=h):this.j!==h&&(this.j=h,y=!0,S.insertSpaces=h)}typeof w.cursorStyle<"u"&&this.k!==w.cursorStyle&&(this.k=w.cursorStyle,y=!0,S.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.l!==w.lineNumbers&&(this.l=w.lineNumbers,y=!0,S.lineNumbers=A.TextEditorLineNumbersStyle.from(w.lineNumbers)),y&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(w,S){S.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(y)})}}e.$FO=E;class R{constructor(w,S,y,h,g,c,n,i){this.id=w,this.j=S,this.k=y,this.g=!1,this.h=new Set,this.c=g,this.d=new E(this.j,this.id,c,y),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return h.value},set document(a){throw new L.$9("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof P.$jM))throw(0,L.$7)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof P.$jM)))throw(0,L.$7)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new L.$9("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new L.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(h.value,t);return a(f),r.m(f)},insertSnippet(a,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=r.c.map(s=>A.Range.from(s));else if(t instanceof P.$hM){const{lineNumber:s,column:o}=A.Position.from(t);l=[{startLineNumber:s,startColumn:o,endLineNumber:s,endColumn:o}]}else if(t instanceof P.$iM)l=[A.Range.from(t)];else{l=[];for(const s of t)if(s instanceof P.$iM)l.push(A.Range.from(s));else{const{lineNumber:o,column:d}=A.Position.from(s);l.push({startLineNumber:o,startColumn:d,endLineNumber:o,endColumn:d})}}return S.$tryInsertSnippet(w,h.value.version,a.value,l,f)},setDecorations(a,t){const f=t.length===0;f&&!r.h.has(a.key)||(f?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(A.$uO(t))return S.$trySetDecorations(w,a.key,A.$vO(t));{const l=new Array(4*t.length);for(let s=0,o=t.length;s<o;s++){const d=t[s];l[4*s]=d.start.line+1,l[4*s+1]=d.start.character+1,l[4*s+2]=d.end.line+1,l[4*s+3]=d.end.character+1}return S.$trySetDecorationsFast(w,a.key,l)}}))},revealRange(a,t){r.n(()=>S.$tryRevealRange(w,A.Range.from(a),t||P.TextEditorRevealType.Default))},show(a){S.$tryShowEditor(w,A.ViewColumn.from(a))},hide(){S.$tryHideEditor(w)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,u.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,u.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,u.ok)(!this.g),this.f=w}_acceptSelections(w){(0,u.ok)(!this.g),this.c=w}async l(){const w=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const S=w.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const y=S.edits.map(g=>g.range);y.sort((g,c)=>g.end.line===c.end.line?g.end.character===c.end.character?g.start.line===c.start.line?g.start.character-c.start.character:g.start.line-c.start.line:g.end.character-c.end.character:g.end.line-c.end.line);for(let g=0,c=y.length-1;g<c;g++){const n=y[g].end;if(y[g+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=S.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,h,{setEndOfLine:typeof S.setEndOfLine=="number"?A.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$GO=R}),define(Se[71],De([1,0,61,4,3,2,5,6,152,20,155,16,12,28,15,48,43]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0;class c{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new L.$6d,this.e=new L.$6d,this.f=new L.$6d,this.g=new L.$6d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],f=[];if(r.removedDocuments)for(const l of r.removedDocuments){const s=A.URI.revive(l),o=this.c.get(s);o?.unref()&&(this.c.delete(s),a.push(o.value))}if(r.addedDocuments)for(const l of r.addedDocuments){const s=A.URI.revive(l.uri);let o=this.c.get(s);if(o&&s.scheme!==y.Schemas.vscodeNotebookCell&&s.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);o||(o=new c(new p.$AO(this.h.getProxy(b.$eM.MainThreadDocuments),s,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty)),this.c.set(s,o),t.push(o.value)),o.ref()}if(r.removedEditors)for(const l of r.removedEditors){const s=this.b.get(l);this.b.delete(l),s&&f.push(s)}if(r.addedEditors)for(const l of r.addedEditors){const s=A.URI.revive(l.documentUri);u.ok(this.c.has(s),`document '${s}' does not exist`),u.ok(!this.b.has(l.id),`editor '${l.id}' already exists!`);const o=this.c.get(s).value,d=new R.$GO(l.id,this.h.getProxy(b.$eM.MainThreadTextEditors),this.i,new g.$V(()=>o.document),l.selections.map(I.Selection.to),l.options,l.visibleRanges.map(m=>I.Range.to(m)),typeof l.editorPosition=="number"?I.ViewColumn.to(l.editorPosition):void 0);this.b.set(l.id,d)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,M.$Oc)(a),(0,M.$Oc)(f),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(l=>l.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return h.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$HO=n,e.$HO=n=Je([qe(0,E.$xO),qe(1,w.$Mj)],n),e.$IO=(0,P.$gi)("IExtHostDocumentsAndEditors")}),define(Se[351],De([1,0,19,4,6,155,16,7]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class p{constructor(R,I){this.i=I,this.a=new L.$6d,this.b=new L.$6d,this.c=new L.$6d,this.d=new L.$6d,this.f=new L.$6d,this.g=new L.$6d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(M.$eM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const I=this.i.allEditors();return R?I:I.map(w=>w.value)}async showTextDocument(R,I,w){let S;typeof I=="number"?S={position:P.ViewColumn.from(I),preserveFocus:w}:typeof I=="object"?S={position:P.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?P.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:S={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(R.uri,S),h=y&&this.i.getEditor(y);if(h)return h.value;throw y?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,I){return new A.$EO(this.h,R,I).value}$acceptEditorPropertiesChanged(R,I){const w=this.i.getEditor(R);if(!w)throw new Error("unknown text editor");if(I.options&&w._acceptOptions(I.options),I.selections){const S=I.selections.selections.map(P.Selection.to);w._acceptSelections(S)}if(I.visibleRanges){const S=u.$Hb(I.visibleRanges.map(P.Range.to));w._acceptVisibleRanges(S)}if(I.options&&this.b.fire({textEditor:w.value,options:{...I.options,lineNumbers:P.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const S=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),y=I.selections.selections.map(P.Selection.to);this.a.fire({textEditor:w.value,selections:y,kind:S})}if(I.visibleRanges){const S=u.$Hb(I.visibleRanges.map(P.Range.to));this.c.fire({textEditor:w.value,visibleRanges:S})}}$acceptEditorPositionData(R){for(const I in R){const w=this.i.getEditor(I);if(!w)throw new Error("Unknown text editor");const S=P.ViewColumn.to(R[I]);w.value.viewColumn!==S&&(w._acceptViewColumn(S),this.d.fire({textEditor:w.value,viewColumn:S}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$Jic=p}),define(Se[352],De([1,0,2,5,6,3,7,16,25,18]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0,e.$pkc=(0,L.$gi)("IExtHostTimeline");class R{constructor(S,y){this.b=new Map,this.c=new Map,this.a=S.getProxy(M.$eM.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(h,g)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&p.$Bm.equals(g,this.b.get(h.source)?.extension)){const c=h.uri===void 0?void 0:u.URI.revive(h.uri);return this.c.get(h.source)?.get(I(c))?.get(h.handle)}else return;return h}})}async $getTimeline(S,y,h,g){return this.b.get(S)?.provider.provideTimeline(u.URI.revive(y),h,g)}registerTimelineProvider(S,y,h,g){const c=new A.$Sc,n=this.d(y.id,g,c).bind(this);let i;y.onDidChange&&(i=y.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:y.id}),this));const r=this.c;return this.f({...y,scheme:S,onDidChange:void 0,async provideTimeline(a,t,f){t?.resetCache&&(c.clear(),r.get(y.id)?.clear());const l=await y.provideTimeline(a,t,f);if(l==null)return;const s=n(a,t);return{...l,source:y.id,items:l.items.map(s)}},dispose(){for(const a of r.values())a.get(y.id)?.clear();i?.dispose(),c.dispose()}},h)}d(S,y,h){return(g,c)=>{let n;if(c?.cacheResults){let i=this.c.get(S);i===void 0&&(i=new Map,this.c.set(S,i));const r=I(g);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...a}=i,t=`${S}|${i.id??i.timestamp}`;n?.set(t,i);let f,l,s;i.iconPath&&(r instanceof P.$cN?s={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,l=r):{light:f,dark:l}=r);let o;return P.$HM.isMarkdownString(a.tooltip)?o=b.MarkdownString.from(a.tooltip):(0,E.$Tf)(a.tooltip)?o=a.tooltip:P.$HM.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=b.MarkdownString.from(a.detail)):(0,E.$Tf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=a.detail),{...a,id:a.id??void 0,handle:t,source:S,command:i.command?y.toInternal(i.command,h):void 0,icon:f,iconDark:l,themeIcon:s,tooltip:o,accessibilityInformation:i.accessibilityInformation}}}}f(S,y){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:y}),(0,A.$Rc)(()=>{for(const g of this.c.values())g.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$qkc=R;function I(w){return w?.toString()}}),define(Se[353],De([1,0,226,23,2,4,3,285,8,7,18,19,16,79,22,182,26]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;function c(r,a){if((0,R.$Tf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends P.$Tc{constructor(a,t,f){super(),this.f=a,this.g=t,this.h=f,this.a=new Map,this.b=new h.$R9;function l(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>l(s)?this.r(s):Array.isArray(s)&&s.length>0?s.map(o=>l(o)?this.r(o):o):s})}registerTreeDataProvider(a,t,f){const l=this.createTreeView(a,{treeDataProvider:t},f);return{dispose:()=>l.dispose()}}createTreeView(a,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],o=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,m=this.m(a,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:l,dragMimeTypes:s,hasHandleDrag:o,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(a,D),v={get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get activeItem(){return(0,g.$4F)(f,"treeViewActiveItem"),m.focusedElement},get onDidChangeActiveItem(){return(0,g.$4F)(f,"treeViewActiveItem"),m.onDidChangeActiveItem},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get onDidChangeCheckboxState(){return m.onDidChangeCheckboxState},get message(){return m.message},set message(k){(0,S.$Fk)(k)&&(0,g.$4F)(f,"treeViewMarkdownMessage"),m.message=k},get title(){return m.title},set title(k){m.title=k},get description(){return m.description},set description(k){m.description=k},get badge(){return m.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?m.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(m.badge=void 0)},reveal:(k,C)=>m.reveal(k,C),dispose:async()=>{await $,this.a.delete(a),m.dispose()}};return this.B(v),v}$getChildren(a,t){const f=this.a.get(a);return f?f.getChildren(t):Promise.reject(new b.$vF(a))}async $handleDrop(a,t,f,l,s,o,d,m){const D=this.a.get(a);if(!D)return Promise.reject(new b.$vF(a));const $=w.DataTransfer.toDataTransfer(f,async v=>(await this.f.$resolveDropFileData(a,t,v)).buffer);return d===a&&m&&await this.j($,D,m,s,o),D.onDrop($,l,s)}async j(a,t,f,l,s){const o=this.b.removeDragOperationTransfer(s);if(o)(await o)?.forEach((d,m)=>{d&&a.set(m,d)});else if(s&&t.handleDrag){const d=t.handleDrag(f,a,l);this.b.addDragOperationTransfer(s,d),await d}return a}async $handleDrag(a,t,f,l){const s=this.a.get(a);if(!s)return Promise.reject(new b.$vF(a));const o=await this.j(new E.$$M,s,t,l,f);if(!(!o||l.isCancellationRequested))return w.DataTransfer.from(o)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$vF(a);return t.hasResolve}$resolve(a,t,f){const l=this.a.get(a);if(!l)throw new b.$vF(a);return l.resolveTreeItem(t,f)}$setExpanded(a,t,f){const l=this.a.get(a);if(!l)throw new b.$vF(a);l.setExpanded(t,f)}$setSelectionAndFocus(a,t,f){const l=this.a.get(a);if(!l)throw new b.$vF(a);l.setSelectionAndFocus(t,f)}$setVisible(a,t){const f=this.a.get(a);if(!f){if(!t)return;throw new b.$vF(a)}f.setVisible(t)}$changeCheckboxState(a,t){const f=this.a.get(a);if(!f)throw new b.$vF(a);f.setCheckboxState(t)}m(a,t,f){const l=this.B(new i(a,t,this.f,this.g.converter,this.h,f));return this.a.set(a,l),l}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$rkc=n;class i extends P.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.$3f)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,f,l,s,o){if(super(),this.I=a,this.J=f,this.L=l,this.M=s,this.N=o,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$6d),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$6d),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$6d),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$6d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$6d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$6d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$6d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new y.$de,o.contributes&&o.contributes.views)for(const $ in o.contributes.views)for(const v of o.contributes.views[$])v.id===a&&(this.P=v.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let d,m;const D=A.Event.debounce(this.F.event,($,v)=>($||($={message:!1,elements:[]}),v.element!==!1&&(d||(d=new Promise(k=>m=k),this.G=this.G.then(()=>d)),Array.isArray(v.element)?$.elements.push(...v.element):$.elements.push(v.element)),v.message&&($.message=!0),$),200,!0);this.B(D(({message:$,elements:v})=>{v.length&&(this.H=this.H.then(()=>{const k=m;return d=null,this.$(v).then(()=>k())})),$&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let f=this.X(a);return f||(f=await this.Y(t)),f?f.map(l=>l.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const f=(0,R.$3f)(t.select)?!0:t.select,l=(0,R.$3f)(t.focus)?!1:t.focus,s=(0,R.$3f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(o=>this.W(a,o[o.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:o.map(m=>m.item)},{select:f,focus:l,expand:s})),o=>this.M.error(o)):this.J.$reveal(this.I,void 0,{select:f,focus:l,expand:s})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=w.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const f=this.getExtensionElement(a);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(a,t){const f=!(0,I.$ub)(this.s,a);this.s=a;const l=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),l&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async f=>{const l=this.getExtensionElement(f.treeItemHandle);return l?{extensionItem:l,treeItem:await this.f.getTreeItem(l),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(a,t,f){const l=[];for(const s of a){const o=this.getExtensionElement(s);o&&l.push(o)}if(!(!this.g?.handleDrag||l.length===0))return await this.g.handleDrag(l,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,f){const l=t?this.getExtensionElement(t):void 0;if(!(!l&&t||!this.g?.handleDrop))return(0,p.$$g)(()=>this.g?.handleDrop?this.g.handleDrop(l,a,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(a);if(f){const l=this.m.get(f);if(l){const s=await this.f.resolveTreeItem(l.extensionItem,f,t)??l.extensionItem;return this.hb(s),l.item.tooltip=this.eb(s.tooltip),l.item.command=this.fb(l.disposableStore,s.command),l.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(l=>(f.push(l),f))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$$g)(()=>this.f.getParent(a))}W(a,t){const f=this.m.get(a);return f?Promise.resolve(f):(0,p.$$g)(()=>this.f.getTreeItem(a)).then(l=>this.kb(a,l,t,!0)).then(l=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(l);if(s){const o=this.m.get(s);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${l} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const f=this.getExtensionElement(a);t=f?this.m.get(f):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new y.$de(this.Z.token);try{const f=a?this.m.get(a):void 0,l=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const s=(0,I.$Hb)(l||[]),o=await Promise.all((0,I.$Hb)(s).map(m=>this.f.getTreeItem(m)));if(t.token.isCancellationRequested)return;const d=o.map((m,D)=>m?this.db(s[D],m,f):null);return(0,I.$Hb)(d)}finally{t.dispose()}}$(a){if(a.some(f=>!f))return this.Z.dispose(!0),this.Z=new y.$de,this.tb(),this.J.$refresh(this.I);{const f=this.ab(a);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(a){const t=new Set,f=a.map(s=>this.m.get(s));for(const s of f)if(s&&!t.has(s.item.handle)){let o=s;for(;o&&o.parent&&f.findIndex(d=>o&&o.parent&&d&&d.item.handle===o.parent.item.handle)===-1;){const d=this.j.get(o.parent.item.handle);o=d?this.m.get(d):void 0}o&&!o.parent&&t.add(s.item.handle)}const l=[];return t.forEach(s=>{const o=this.j.get(s);if(o){const d=this.m.get(o);d&&(!d.parent||!t.has(d.parent.item.handle))&&l.push(s)}}),l}bb(a){const t={};return Promise.all(a.map(f=>this.cb(f).then(l=>{l&&(t[f]=l.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,p.$$g)(()=>this.f.getTreeItem(t)).then(l=>{if(l){const s=this.ib(t,l,f.parent);return this.pb(t,s,f,f.parent),f.dispose(),s}return null})}return Promise.resolve(null)}db(a,t,f){const l=this.ib(a,t,f);if(t.id&&this.j.has(l.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(a,l),this.qb(l,f),l}eb(a){return E.$HM.isMarkdownString(a)?w.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,f,l;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,f=a.checkboxState.tooltip,l=a.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:l}}hb(a){if(!E.$6M.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,f){this.hb(t);const l=this.B(new P.$Sc),s=this.kb(a,t,f),o=this.lb(t);return{item:{handle:s,parentHandle:f?f.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(l,t.command),contextValue:t.contextValue,icon:o,iconDark:this.mb(t)||o,themeIcon:this.jb(t),collapsibleState:(0,R.$3f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:l,dispose(){l.dispose()}}}jb(a){return a.iconPath instanceof E.$cN?a.iconPath:void 0}kb(a,{id:t,label:f,resourceUri:l},s,o){if(t)return`${i.b}/${t}`;const d=c(f,this.N),m=s?s.item.handle:i.a;let D=d?d.label:l?(0,L.$Qg)(l):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const $=this.m.has(a)?this.m.get(a).item.handle:void 0,v=this.X(s)||[];let k,C=0;do{if(k=`${m}/${C}:${D}`,o||!this.j.has(k)||$===k)break;C++}while(C<=v.length);return k}lb(a){if(a.iconPath&&!(a.iconPath instanceof E.$cN))return typeof a.iconPath=="string"||M.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof E.$cN)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return M.URI.isUri(a)?a:M.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,f,l){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(a,t);const s=this.X(l)||[],o=s.filter(d=>d.item.handle===f.item.handle)[0];o&&s.splice(s.indexOf(o),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const f of t.children){const l=this.j.get(f.item.handle);l&&this.sb(l)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const f of t.children){const l=this.j.get(f.item.handle);l&&this.sb(l)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[354],De([1,0,4,3,2,30,16,92,6,7]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class R extends L.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(y,h,g,c){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$6d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$6d),this.onDidChangeViewState=this.#h.event,this.#e=y,this.#t=h,this.#n=g,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#u=c.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(y){this.c(),this.#r!==y&&(this.#r=y,this.#t.$setTitle(this.#e,y))}get iconPath(){return this.c(),this.#a}set iconPath(y){this.c(),this.#a!==y&&(this.#a=y,this.#t.$setIconPath(this.#e,M.URI.isUri(y)?{light:y,dark:y}:y))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(y){this.#l||(this.active!==y.active||this.visible!==y.visible||this.viewColumn!==y.viewColumn)&&(this.#u=y.active,this.#c=y.visible,this.#o=y.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(y,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof y>"u"?void 0:P.ViewColumn.from(y),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends L.$Tc{static c(){return(0,A.$Cg)()}constructor(y,h,g){super(),this.j=h,this.m=g,this.g=new Map,this.h=new Map,this.f=y.getProxy(p.$eM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(y=>y.dispose()),this.g.clear()}createWebviewPanel(y,h,g,c,n={}){const i=typeof c=="object"?c.viewColumn:c,r={viewColumn:P.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},a=(0,b.$Yic)(y),t=I.c();this.f.$createWebviewPanel((0,b.$1ic)(y),t,h,{title:g,panelOptions:w(n),webviewOptions:(0,b.$2ic)(y,this.m,n),serializeBuffersForPostMessage:a},r);const f=this.j.createNewWebview(t,n,y);return this.createNewWebviewPanel(t,h,g,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(y){const h=Object.keys(y);h.sort((g,c)=>{const n=y[g],i=y[c];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const g of h){const c=this.getWebviewPanel(g);if(!c)continue;const n=y[g];c._updateViewState({active:n.active,visible:n.visible,viewColumn:P.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(y){this.getWebviewPanel(y)?.dispose(),this.g.delete(y),this.j.deleteWebview(y)}registerWebviewPanelSerializer(y,h,g){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:g,extension:y}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$Yic)(y)}),new E.$gM(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(y,h,g,c){const n=this.h.get(h);if(!n)throw new Error(`No serializer found for '${h}'`);const{serializer:i,extension:r}=n,a=this.j.createNewWebview(y,g.webviewOptions,r),t=this.createNewWebviewPanel(y,h,g.title,c,g.panelOptions,a,g.active);await i.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(y,h,g,c,n,i,r){const a=new R(y,this.f,i,{viewType:h,title:g,viewColumn:c,panelOptions:n,active:r});return this.g.set(y,a),a}getWebviewPanel(y){return this.g.get(y)}}e.$3ic=I;function w(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Se[355],De([1,0,4,3,92,16,6,7]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class p extends L.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,w,S,y,h,g){super(),this.#s=!1,this.#u=this.B(new u.$6d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$6d),this.onDidDispose=this.#l.event,this.#i=S,this.#a=y,this.#e=I,this.#t=w,this.#n=h,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(I,w){this.d=w,this.b=new Map,this.c=new Map,this.a=I.getProxy(P.$eM.MainThreadWebviewViews)}registerWebviewViewProvider(I,w,S,y){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:S,extension:I}),this.a.$registerWebviewViewProvider((0,M.$1ic)(I),w,{retainContextWhenHidden:y?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$Yic)(I)}),new b.$gM(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(I,w,S,y,h){const g=this.b.get(w);if(!g)throw new Error(`No view provider found for '${w}'`);const{provider:c,extension:n}=g,i=this.d.createNewWebview(I,{},n),r=new p(I,this.a,w,S,i,!0);this.c.set(I,r),await c.resolveWebviewView(r,{state:y},h)}async $onDidChangeWebviewViewVisibility(I,w){this.e(I)._setVisible(w)}async $disposeWebviewView(I){const w=this.e(I);this.c.delete(I),w.dispose(),this.d.deleteWebview(I)}e(I){const w=this.c.get(I);if(!w)throw new Error("No webview found");return w}}e.$ukc=E}),define(Se[356],De([1,0,68,15,12,256,32,11]),function(fe,e,u,L,M,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;let p=class{constructor(I,w){I.addFileSystemProvider(L.Schemas.file,new E(w),{isCaseSensitive:b.$k})}};e.$_kc=p,e.$_kc=p=Je([qe(0,u.$Uic),qe(1,M.$Mj)],p);class E{constructor(I){this.b=I,this.a=new A.$Rq(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===P.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,S){return this.a.writeFile(I,w,{...S,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,S){return this.a.rename(I,w,S)}copy(I,w,S){return this.a.copy(I,w,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(Se[357],De([1,0,17,63,30,33,3,6,2,20]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;let R=class extends P.$Tc{constructor(w,S){super();const y=w.getProxy(b.$eM.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async h=>{const g=p.URI.file((0,u.$jc)((0,L.tmpdir)(),(0,M.$Cg)()));return await y.$download(h,g),g})}};e.$0kc=R,e.$0kc=R=Je([qe(0,E.$xO),qe(1,A.$TO)],R)}),define(Se[358],De([1,0,57,17,2,93,3,15,8,31]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;class R extends A.$Wic{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==b.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const l=f.fsPath;let s=0;do{let o;s===0?o=l:o=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${s}`:`${l}-${s}`,await I(o);const d=L.$jc(o,"vscode.lock"),m=await h(this.d,d,!1);if(m)return this.i=m,process.on("exit",()=>{m.dispose()}),M.URI.file(o);s++}while(s<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$jlc=R;async function I(a){try{await E.Promises.stat(a);return}catch{}try{await E.Promises.mkdir(a,{recursive:!0})}catch{}}const w=1e3,S=10*60*1e3;class y extends P.$Tc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new p.$rh),this.a.cancelAndSet(async()=>{const l=await g(t,f);(!l||l.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(f,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${f}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function h(a,t,f){try{const s={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){a.error(s)}const l=await g(a,t);return!l||l.pid!==process.pid?f?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new y(a,t))}async function g(a,t){let f;try{f=await E.Promises.readFile(t)}catch(l){return a.error(l),null}try{return JSON.parse(String(f))}catch(l){return a.error(l),null}}async function c(a,t){let f;try{f=await E.Promises.stat(t)}catch(l){return a.error(l),0}return f.mtime.getTime()}function n(a){try{return process.kill(a,0),!0}catch{return!1}}async function i(a,t){const f=await g(a,t);if(!f)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(f.willReleaseAt){let m=f.willReleaseAt-Date.now();if(m<5e3){for(m>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${m} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);m>0;){if(await(0,p.$hh)(Math.min(100,m)),await c(a,t)===0)return r(a,t);m=f.willReleaseAt-Date.now()}return r(a,t)}}if(!n(f.pid))return a.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(a,t);const l=await c(a,t),s=Date.now()-l;if(s<=S)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$hh)(2e3);const o=await c(a,t),d=Date.now()-o;return d<=S?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return h(a,t,!0)}}),define(Se[359],De([1,0,30,20,46,33]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;let P=class extends M.$gjc{constructor(p,E){super(!0,p,E)}createTerminal(p,E,R){return this.createTerminalFromOptions({name:p,shellPath:E,shellArgs:R})}createTerminalFromOptions(p,E){const R=new M.$fjc(this.a,(0,u.$Cg)(),p,p.name);return this.f.push(R),R.create(p,this.R(p,E)),R.value}};e.$Ekc=P,e.$Ekc=P=Je([qe(0,A.$TO),qe(1,L.$xO)],P)}),define(Se[360],De([1,0,4,37,45,5]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=e.OutputChannelUpdateMode=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=void 0,e.$mL="text/x-code-output",e.$nL="output",e.$oL="Log",e.$pL="text/x-code-log-output",e.$qL="log",e.$rL="workbench.panel.output",e.$sL=new M.$xj("inOutput",!1),e.$tL=new M.$xj("activeLogOutput",!1),e.$uL=new M.$xj("activeLogOutput.levelSettable",!1),e.$vL=new M.$xj("activeLogOutput.level",""),e.$wL=new M.$xj("activeLogOutput.levelIsDefault",!1),e.$xL=new M.$xj("outputView.scrollLock",!1),e.$yL=(0,A.$gi)("outputService");var P;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$zL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new u.$6d,this.onDidRegisterChannel=this.b.event,this.c=new u.$6d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(R=>E.push(R)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}L.$Yn.add(e.$zL.OutputChannels,new b),e.$AL=new M.$xj("activeOutputChannel","")}),define(Se[156],De([1,0,6,5,20,25,12,360,68,27,59,187,21,18,32,4,3]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$8jc=void 0;class c extends P.$Sj{get disposed(){return this.n}constructor(a,t,f,l,s){super(),this.id=a,this.name=t,this.r=f,this.s=l,this.extension=s,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=w.$te.fromString(t).byteLength,(0,P.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends c{appendLine(a){this.append(a)}}let i=class{constructor(a,t,f,l,s,o){this.i=t,this.j=f,this.k=l,this.l=s,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(u.$eM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Nm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(a,t,f){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const l=typeof t=="object"&&t.log,s=(0,S.$Tf)(t)?t:void 0;if((0,S.$Tf)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const d=this.i.environment.extensionLogLevel?.find(([D])=>A.$Bm.equals(f.identifier,D))?.[1];d&&(o=(0,P.$4j)(d));const m=l?this.o(a,o,f):this.n(a,s,f);return m.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),l?this.r(a,o??this.m.getLevel(),m):this.q(a,m)}async n(a,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const l=await this.c,s=this.k.extUri.joinPath(l,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(a,s,t,f.identifier.value);return new c(d,a,o,this.a,f)}async o(a,t,f){const l=await this.p(f),s=a.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(l,`${s}.log`),d=`${f.identifier.value}.${s}`,m=this.l.createLogger(o,{id:d,name:a,logLevel:t,extensionId:f.identifier.value});return new n(d,a,m,this.a,f)}p(a){let t=this.d.get(a.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(l){if((0,y.$3k)(l)!==y.FileSystemProviderErrorCode.FileExists)throw l}return f})())}return t}q(a,t){let f=!1;const l=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return a},append(s){l(),t.then(o=>o.append(s))},appendLine(s){l(),t.then(o=>o.appendLine(s))},clear(){l(),t.then(s=>s.clear())},replace(s){l(),t.then(o=>o.replace(s))},show(s,o){l(),t.then(d=>d.show(s,o))},hide(){l(),t.then(s=>s.hide())},dispose(){f=!0,t.then(s=>s.dispose())}}}r(a,t,f){const l=new g.$Sc,s=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},o=l.add(new h.$6d);function d(m){t=m,o.fire(m)}return f.then(m=>{l.add(m),m.logLevel!==t&&d(m.logLevel),l.add(m.onDidChangeLogLevel(D=>d(D)))}),{...this.q(a,f),get logLevel(){return t},onDidChangeLogLevel:o.event,trace(m,...D){s(),f.then($=>$.trace(m,...D))},debug(m,...D){s(),f.then($=>$.debug(m,...D))},info(m,...D){s(),f.then($=>$.info(m,...D))},warn(m,...D){s(),f.then($=>$.warn(m,...D))},error(m,...D){s(),f.then($=>$.error(m,...D))},dispose(){l.dispose()}}}};e.$8jc=i,e.$8jc=i=Je([qe(0,M.$xO),qe(1,E.$NO),qe(2,p.$Uic),qe(3,R.$uic),qe(4,P.$Nj),qe(5,P.$Mj)],i),e.$9jc=(0,L.$gi)("IExtHostOutputService")}),define(Se[157],De([1,0,5,8]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$3m=(0,u.$gi)("remoteAgentService"),e.$4m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let A=1/0;for(let b=0;b<this.maxSampleCount;b++){const p=await M.getRoundTripTime();if(p===void 0)return;A=Math.min(A,p/2),await(0,L.$hh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(A):P=this.initial.reduce((b,p)=>b+p,0)/this.initial.length,this.lastMeasurement={initial:P,current:A,average:this.average.reduce((b,p)=>b+p,0)/this.average.length,high:typeof P>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>P*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[361],De([1,0,230,85,37,40,52,3,4,157,11,24,8]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=void 0,e.$RI=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$SI=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$TI=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$UI=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$VI={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new p.$6d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const y=new S;M.$Yn.add(e.$VI.ConfigurationMigration,y);let h=class extends b.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const a of r.added)await this.f(a,y.migrations)})),this.c(y.migrations),this.B(y.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),a=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of a){const l=r[t];if(!l)continue;const s=[];if(l.value!==void 0){const o=await this.h(n,t,l.value,i,void 0);for(const d of o??[])s.push([d,[]])}for(const{identifiers:o,value:d}of l.overrides??[])if(d!==void 0){const m=await this.h(n,t,d,i,o);for(const D of m??[])s.push([D,o])}s.length&&await Promise.allSettled(s.map(async([[o,d],m])=>this.a.updateValue(o,d.value,{resource:i,overrideIdentifiers:m},f)))}}async h(n,i,r,a,t){const f=s=>{const d=this.a.inspect(s,{resource:a})[i];if(d)return t?d.overrides?.find(({identifiers:m})=>(0,I.$Qn)(m,t))?.value:d.value},l=await n.migrateFn(r,f);return Array.isArray(l)?l:[[n.key,l]]}};e.$WI=h,e.$WI=h=Je([qe(0,P.$Mi),qe(1,A.$pi)],h);let g=class extends b.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new w.$Dh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$Yn.as(L.$4n.Configuration).registerConfiguration({...e.$TI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$XI=g,e.$XI=g=Je([qe(0,E.$3m)],g)}),define(Se[362],De([1,0,35,15,17,23,239,361,85,5,37]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$dfb=e.$cfb=void 0,e.$efb=h,e.$ffb=g,e.$cfb=(0,E.$gi)("editorResolverService"),e.$dfb="workbench.editorAssociations";const I=R.$Yn.as(p.$4n.Configuration),w={...b.$SI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,P.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(w);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var y;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(y||(e.ResolvedStatus=y={}));function h(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function g(c,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const a=typeof c=="string"&&c.indexOf(M.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$Qg)(n);return u.$_j(typeof c=="string"?c.toLowerCase():c,a.toLowerCase())}}),define(Se[363],De([1,0,34,15,17,11,23,2,5,274,40,147,157]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=void 0,e.$SL=(0,p.$gi)("pathService");let y=S=class{constructor(g,c,n,i){this.d=g,this.e=c,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??g})()}hasValidBasename(g,c,n){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(g,i,c)):this.h(g,c,n)}h(g,c,n){return g.scheme===L.Schemas.file||g.scheme===L.Schemas.vscodeRemote?(0,u.$eg)(n??(0,P.$Qg)(g),c===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,c){if(g.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,E.$PL)(c.getWorkspace());if(n)return n;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=c.getWorkspace().configuration;return r?r.scheme:L.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?M.$fc:M.$gc)}async fileURI(g){let c="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const i=g.indexOf("/",2);i===-1?(c=g.substring(2),g="/"):(c=g.substring(2,i),g=g.substring(i)||"/")}return b.URI.from({scheme:L.Schemas.file,authority:c,path:g,query:"",fragment:""})}};e.$TL=y,e.$TL=y=S=Je([qe(1,w.$3m),qe(2,I.$BL),qe(3,R.$pi)],y)}),define(Se[364],De([1,0,241,19,53,4,54,3,2,52,246,12,64,276,88,40,147,26,22,18,24,45]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=e.OnPortForward=e.$GL=e.$FL=e.TunnelSource=e.TunnelCloseReason=e.$DL=e.$CL=void 0,e.$EL=o,e.$HL=D,e.$IL=$,e.$JL=v,e.$KL=C;const t=10*1e3,f="remote.tunnels.toRestore",l="remote.tunnels.toRestoreExpiration",s=1e3*60*60*24*14;e.$CL="onTunnel",e.$DL=new a.$xj("forwardedPortsViewEnabled",!1,u.localize(0,null));function o(z){const T=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var d;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var m;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(m||(e.TunnelSource=m={})),e.$FL={source:m.User,description:u.localize(1,null)},e.$GL={source:m.Auto,description:u.localize(2,null)};function D(z,T,j){const N=z.get(v(T,j));if(N)return N;if((0,y.$Yv)(T))for(const F of y.$Xv){const K=v(F,j);if(z.has(K))return z.get(K)}else if((0,y.$1v)(T))for(const F of y.$Zv){const K=v(F,j);if(z.has(K))return z.get(K)}}function $(z,T,j){const N=D(z,T,j);if(N)return N;const F=(0,y.$1v)(T)?"localhost":(0,y.$Yv)(T)?"0.0.0.0":void 0;if(F)return D(z,F,j)}function v(z,T){return z+":"+T}var k;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(k||(e.OnPortForward=k={}));function C(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}class O extends b.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new A.$6d,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(j=>{(j.affectsConfiguration(O.c)||j.affectsConfiguration(O.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,j,N){let F=this.w(T,j,N,this.j,0);const K={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const ee=this.j[F];ee.key===T?(K.onAutoForward=ee.onAutoForward??K.onAutoForward,K.elevateIfNeeded=ee.elevateIfNeeded!==void 0?ee.elevateIfNeeded:K.elevateIfNeeded,K.label=ee.label??K.label,K.requireLocalPort=ee.requireLocalPort,K.protocol=ee.protocol):(K.onAutoForward=K.onAutoForward??ee.onAutoForward,K.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:ee.elevateIfNeeded,K.label=K.label??ee.label,K.requireLocalPort=K.requireLocalPort!==void 0?K.requireLocalPort:void 0,K.protocol=K.protocol??ee.protocol),F=this.w(T,j,N,this.j,F+1)}return K.onAutoForward!==void 0||K.elevateIfNeeded!==void 0||K.label!==void 0||K.requireLocalPort!==void 0||K.protocol!==void 0?K:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,i.$Tf)(T.host)&&(0,i.$Xf)(T.port)}w(T,j,N,F,K){if(K>=F.length)return-1;const ee=!(0,y.$Yv)(j)&&!(0,y.$1v)(j),Q=F.slice(K).findIndex(Z=>(0,i.$Xf)(Z.key)?ee?!1:Z.key===T:this.t(Z.key)?ee?!1:T>=Z.key.start&&T<=Z.key.end:this.u(Z.key)?T===Z.key.port&&j===Z.key.host:N?Z.key.test(N):!1);return Q>=0?Q+K:-1}y(){const T=this.r.getValue(O.c);if(!T||!(0,i.$Vf)(T))return[];const j=[];for(const F in T){if(F===void 0)continue;const K=T[F];let ee;if(Number(F))ee=Number(F);else if((0,i.$Tf)(F))if(O.g.test(F)){const Y=F.match(O.g);ee={start:Number(Y[1]),end:Number(Y[2])}}else if(O.h.test(F)){const Y=F.match(O.h);ee={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(F)}catch{}Y&&(ee=Y)}ee&&j.push({key:ee,elevateIfNeeded:K.elevateIfNeeded,onAutoForward:K.onAutoForward,label:K.label,requireLocalPort:K.requireLocalPort,protocol:K.protocol})}const N=this.r.getValue(O.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(j)}z(T){function j(N,F){return(0,i.$Xf)(N.key)?N.key:F.t(N.key)?N.key.start:F.u(N.key)?N.key.port:Number.MAX_VALUE}return T.sort((N,F)=>j(N,this)-j(F,this))}C(){return this.m}static providedActionToAction(T){switch(T){case y.ProvidedOnAutoForward.Notify:return k.Notify;case y.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case y.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case y.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case y.ProvidedOnAutoForward.Silent:return k.Silent;case y.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(T,j,N){const K=this.r.inspect(O.c).userRemoteValue;let ee;!K||!(0,i.$Vf)(K)?ee={}:ee=(0,r.$Mn)(K),ee[`${T}`]||(ee[`${T}`]={});for(const Y in j)ee[`${T}`][Y]=j[Y];return this.r.updateValue(O.c,ee,N)}}e.$LL=O;let B=class extends b.$Tc{constructor(T,j,N,F,K,ee,Y,Q,Z,ae){super(),this.H=T,this.I=j,this.J=N,this.L=F,this.M=K,this.N=ee,this.O=Y,this.P=Q,this.Q=Z,this.R=ae,this.c=new Map,this.g=new A.$6d,this.onForwardPort=this.g.event,this.h=new A.$6d,this.onClosePort=this.h.event,this.j=new A.$6d,this.onPortName=this.j.event,this.n=new A.$6d,this.onCandidatesChanged=this.n.event,this.t=new A.$6d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$6d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new O(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ge=await this.getAttributes(_.map(se=>({port:se.tunnelRemotePort,host:se.tunnelRemoteHost})));for(const se of _)if(se.localAddress){const re=v(se.tunnelRemoteHost,se.tunnelRemotePort),U=$(this.m??new Map,se.tunnelRemoteHost,se.tunnelRemotePort);this.forwarded.set(re,{remotePort:se.tunnelRemotePort,remoteHost:se.tunnelRemoteHost,localAddress:se.localAddress,protocol:ge?.get(se.tunnelRemotePort)?.protocol??y.TunnelProtocol.Http,localUri:await this.X(se.localAddress,ge?.get(se.tunnelRemotePort)),localPort:se.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:se.privacy,source:e.$FL}),this.f.set(re,se)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ge=v(_.tunnelRemoteHost,_.tunnelRemotePort);if(!$(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!$(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!$(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const se=$(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),re=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:re?.protocol??y.TunnelProtocol.Http,localUri:await this.X(_.localAddress,re),localPort:_.tunnelLocalPort,closeable:!0,runningProcess:se?.detail,hasRunningProcess:!!se,pid:se?.pid,privacy:_.privacy,source:e.$FL})}await this.cb(),this.f.set(ge,_),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(_=>this.W(_,d.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$CL))?(this.R.createKey(e.$DL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,j){const N=v(T.host,T.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(T))}X(T,j){if(T.startsWith("http"))return p.URI.parse(T);const N=j?.protocol??"http";return p.URI.parse(`${N}://${T}`)}async Y(T){const j=this.N.getWorkspace(),N=j.configuration?(0,P.$7i)(j.configuration.path):j.folders.length>0?(0,P.$7i)(j.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(f)}async $(){return this.Y(l)}async ab(){const T=this.I.get(f,1);if(T)return this.I.remove(f,1),await this.cb(),T;const j=await this.Z();if(j)return this.I.get(j,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const j=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(N=>N.remotePort).join(", ")}`);for(const N of j){const F=$(this.detected,N.remoteHost,N.remotePort);N.source.source!==m.Extension&&!F||N.source.source===m.Extension&&F?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===m.Extension&&!F&&this.D.set(v(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new b.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async j=>{j.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(j=>j.startsWith(l));for(const j of T){const N=this.I.getNumber(j,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const F=j.replace(l,f);this.I.remove(j,0),this.I.remove(F,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),j=T.map(ee=>({remoteHost:ee.remoteHost,remotePort:ee.remotePort,localPort:ee.localPort,name:ee.name,localAddress:ee.localAddress,localUri:ee.localUri,protocol:ee.protocol,source:ee.source}));let N;T.length>0&&(N=JSON.stringify(j));const F=await this.Z(),K=await this.$();!N&&F&&K?(this.I.remove(F,0),this.I.remove(K,0)):N!==this.y&&F&&K&&(this.I.store(F,N,0,0),this.I.store(K,Date.now()+s,0,0)),this.y=N}}async eb(T,j,N){if(!T.tunnelLocalPort||!N?.requireLocalPort||T.tunnelLocalPort===j)return;const F=new Date;if(this.db.getTime()+t>F.getTime())return;this.db=F;const K=u.localize(3,null,j,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(K)}async forward(T,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(T,j)}async fb(T,j){await this.Q.activateByEvent(e.$CL);const N=$(this.forwarded,T.remote.host,T.remote.port);j=j??(j!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const F=T.local!==void 0?T.local:T.remote.port;let K;if(N)return this.hb(N,T,j);{const ee=this.L.remoteAuthority,Y=ee?{getAddress:async()=>(await this.M.resolveAuthority(ee)).authority}:void 0,Q=v(T.remote.host,T.remote.port);this.c.set(Q,!0),T=this.gb(Q,T);const Z=await this.H.openTunnel(Y,T.remote.host,T.remote.port,void 0,F,T.elevateIfNeeded?T.elevateIfNeeded:j?.elevateIfNeeded,T.privacy,j?.protocol);if(typeof Z=="string")K=Z;else if(Z&&Z.localAddress){const ae=$(this.m??new Map,T.remote.host,T.remote.port),_=Z.protocol?Z.protocol===y.TunnelProtocol.Https?y.TunnelProtocol.Https:y.TunnelProtocol.Http:j?.protocol??y.TunnelProtocol.Http,ge={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:j?.label??T.name,closeable:!0,localAddress:Z.localAddress,protocol:_,localUri:await this.X(Z.localAddress,j),runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,source:T.source??e.$FL,privacy:Z.privacy};return this.forwarded.set(Q,ge),this.f.set(Q,Z),this.c.delete(Q),await this.cb(),await this.eb(Z,F,j),this.g.fire(ge),Z}this.c.delete(Q)}return K}gb(T,j){const N=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(N){const F=N.get(T);N.delete(T),F&&(j.name=F.name??j.name,j.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(T,j,N){const F=N?.label??j.name;let K;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(K||(K={}));let ee=K.None;switch(F!==T.name&&(T.name=F,ee=K.Fire),(N?.protocol||T.protocol!==y.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&(j.source=T.source,ee=K.Reopen),j.privacy&&T.privacy!==j.privacy&&(ee=K.Reopen),ee){case K.Fire:{this.g.fire();break}case K.Reopen:await this.close(T.remoteHost,T.remotePort,d.User),await this.fb(j,N)}return $(this.f,j.remote.host,j.remote.port)}async name(T,j,N){const F=$(this.forwarded,T,j),K=v(T,j);if(F){F.name=N,await this.cb(),this.j.fire({host:T,port:j});return}else this.detected.has(K)&&(this.detected.get(K).name=N,this.j.fire({host:T,port:j}))}async close(T,j,N){const F=v(T,j),K=this.forwarded.get(F);return N===d.AutoForwardEnd&&K&&K.source.source===m.Auto&&this.F.set(F,{local:K.localPort,name:K.name,privacy:K.privacy}),await this.H.closeTunnel(T,j),this.W({host:T,port:j},N)}address(T,j){const N=v(T,j);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const j of T){const N=$(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),F=typeof j.localAddress=="string"?j.localAddress:v(j.localAddress.host,j.localAddress.port);this.detected.set(v(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:F,protocol:y.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:y.TunnelPrivacyId.ConstantPrivate,source:{source:m.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,F,y.TunnelPrivacyId.ConstantPrivate,y.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let j=T;this.r&&(j=await this.r(T));const N=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(F=>F.port).join(", ")}`),this.n.fire(N)}ib(T){const j=this.m??new Map,N=new Map;return this.m=N,T.forEach(F=>{const K=v(F.host,F.port);N.set(K,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),j.has(K)&&j.delete(K);const ee=$(this.forwarded,F.host,F.port);ee&&(ee.runningProcess=F.detail,ee.hasRunningProcess=!0,ee.pid=F.pid)}),j.forEach((F,K)=>{const ee=o(K);if(!ee)return;const Y=$(this.forwarded,ee.host,ee.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const Q=$(this.detected,ee.host,ee.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),j=await this.getAttributes(T.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(j)for(const N of T){const F=j.get(N.remotePort);(F?.protocol||N.protocol!==y.TunnelProtocol.Http)&&F?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},F),F&&F.label&&F.label!==N.name&&await this.name(N.remoteHost,N.remotePort,F.label)}}async getAttributes(T,j=!0){const N=new Map,F=new Map;T.forEach(Z=>{const ae=$(this.m??new Map,y.$Xv[0],Z.port)??Z;if(ae){N.set(Z.port,ae);const _=C(ae)?ae.pid:void 0;F.has(_)||F.set(_,[]),F.get(_)?.push(Z.port)}});const K=new Map;if(T.forEach(Z=>{const ae=this.configPortsAttributes.getAttributes(Z.port,Z.host,N.get(Z.port)?.detail);ae&&K.set(Z.port,ae)}),this.G.length===0||!j)return K.size>0?K:void 0;const ee=await Promise.all((0,L.$Rb)(this.G.map(Z=>Array.from(F.entries()).map(ae=>{const _=ae[1],ge=N.get(_[0]);return Z.providePortAttributes(_,ge?.pid,ge?.detail,n.CancellationToken.None)})))),Y=new Map;if(ee.forEach(Z=>Z.forEach(ae=>{ae&&Y.set(ae.port,ae)})),!K&&!Y)return;const Q=new Map;return T.forEach(Z=>{const ae=K.get(Z.port),_=Y.get(Z.port);Q.set(Z.port,{elevateIfNeeded:ae?.elevateIfNeeded,label:ae?.label,onAutoForward:ae?.onAutoForward??O.providedActionToAction(_?.autoForwardAction),requireLocalPort:ae?.requireLocalPort,protocol:ae?.protocol})}),Q}addAttributesProvider(T){this.G.push(T)}};e.$ML=B,Je([(0,M.$Lh)(1e3)],B.prototype,"cb",null),e.$ML=B=Je([qe(0,y.$Sv),qe(1,S.$Kp),qe(2,E.$Mi),qe(3,g.$BL),qe(4,w.$rl),qe(5,h.$pi),qe(6,I.$Mj),qe(7,R.$mw),qe(8,c.$ZF),qe(9,a.$yj)],B)}),define(Se[94],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$mK=e.$lK=void 0;class u{constructor(P,b){this.line=P,this.character=b}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,b){return new u(0,0)}with(P){return new u(0,0)}}e.$lK=u;class L{constructor(P,b,p,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(P,b),this.end=new u(p,E)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new L(0,0,0,0)}with(P){return new L(0,0,0,0)}}e.$mK=L;var M;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Se[36],De([1,0,19,35,24,34,14,5,17,13,94,8]),function(fe,e,u,L,M,A,P,b,p,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$JK=e.$CK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$zK=e.$yK=e.$xK=e.$wK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.TextSearchCompleteMessageType=void 0,e.$tK=c,e.$uK=n,e.$vK=i,e.$AK=m,e.$BK=D,e.$DK=k,e.$EK=C,e.$FK=O,e.$GK=B,e.$HK=z,e.$IK=T,e.$KK=N,e.$MK=ee,e.$NK=Y,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$nK="workbench.view.search",e.$oK="workbench.panel.search",e.$pK="workbench.view.search",e.$qK="search-result",e.$rK="search.exclude";const w="\u27EA ",S=" characters skipped \u27EB",y=(w.length+S.length+5)*2;e.$sK=(0,b.$gi)("searchService");var h;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var g;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(g||(e.QueryType=g={}));function c(Z){return!!Z.preview}function n(Z){return!!Z.resource}function i(Z){return!!Z.message}var r;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(ae){this.resource=ae,this.results=[]}}e.$wK=a;class t{constructor(ae,_,ge,se){this.ranges=_,this.webviewIndex=se;const re=Array.isArray(_)?_:[_];if(ge&&ge.matchLines===1&&f(re)){ae=(0,P.$Mf)(ae,ge.matchLines);let U="",ie=0,ye=0;const le=Math.floor(ge.charsPerLine/5),ue=[];for(const ce of re){const de=Math.max(ce.startColumn-le,0),H=ce.startColumn+ge.charsPerLine;if(de>ye+le+y){const x=w+(de-ye)+S;U+=x+ae.slice(de,H),ie+=de-(ye+x.length)}else U+=ae.slice(ye,H);ue.push(new s(0,ce.startColumn-ie,ce.endColumn-ie)),ye=H}this.preview={text:U,matches:Array.isArray(this.ranges)?ue:ue[0]}}else{const U=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ae,matches:(0,u.$2b)(_,ie=>new l(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$xK=t;function f(Z){const ae=Z[0].startLineNumber;for(const _ of Z)if(_.startLineNumber!==ae||_.endLineNumber!==ae)return!1;return!0}class l{constructor(ae,_,ge,se){this.startLineNumber=ae,this.startColumn=_,this.endLineNumber=ge,this.endColumn=se}}e.$yK=l;class s extends l{constructor(ae,_,ge){super(ae,_,ae,ge)}}e.$zK=s;var o;(function(Z){Z.List="list",Z.Tree="tree"})(o||(e.ViewMode=o={}));var d;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function m(Z,ae=!0){const _=Z&&Z.files&&Z.files.exclude,ge=ae&&Z&&Z.search&&Z.search.exclude;if(!_&&!ge)return;if(!_||!ge)return _||ge;let se=Object.create(null);return se=M.$Pn(se,M.$Mn(_)),se=M.$Pn(se,M.$Mn(ge),!0),se}function D(Z,ae){return Z.excludePattern&&L.$_j(Z.excludePattern,ae)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&L.$_j(Z.includePattern,ae)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(_=>{const ge=_.folder.fsPath;if(A.$gg(ae,ge)){const se=p.$lc(ge,ae);return!_.includePattern||!!L.$_j(_.includePattern,se)}else return!1}):!1:!0}var $;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class v extends Error{constructor(ae,_){super(ae),this.code=_}}e.$CK=v;function k(Z){const ae=Z.message;if((0,E.$4)(Z))return new v(ae,$.canceled);try{const _=JSON.parse(ae);return new v(_.message,_.code)}catch{return new v(ae,$.other)}}function C(Z){const ae={message:Z.message,code:Z.code};return new Error(JSON.stringify(ae))}function O(Z){return Z.type==="error"?!0:Z.type==="success"}function B(Z){return Z.type==="success"}function z(Z){return!!Z.path}function T(Z,ae,_=!0){const ge=Z.searchPath?Z.searchPath:Z.relativePath;return _?(0,P.$Jf)(ge,ae):L.$_j(ae,ge)}class j{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$JK=j;function N(Z,ae){const _={...Z||{},...ae||{}};return Object.keys(_).filter(ge=>{const se=_[ge];return typeof se=="boolean"&&se})}class F{constructor(ae,_){this.c=null,this.a={...ae.excludePattern||{},..._.excludePattern||{}},this.b=L.$ak(this.a);let ge=ae.includePattern;_.includePattern&&(ge?ge={...ge,..._.includePattern}:ge=_.includePattern),ge&&(this.c=L.$ak(ge))}matchesExcludesSync(ae,_,ge){return!!(this.b&&this.b(ae,_,ge))}includedInQuerySync(ae,_,ge){return!(this.b&&this.b(ae,_,ge)||this.c&&!this.c(ae,_,ge))}includedInQuery(ae,_,ge){const se=this.b(ae,_,ge),re=()=>this.c?!!this.c(ae,_,ge):!0;return(0,I.$5g)(se)?se.then(U=>U?!1:re()):re()}hasSiblingExcludeClauses(){return K(this.a)}}e.$LK=F;function K(Z){for(const ae in Z)if(typeof Z[ae]!="boolean")return!0;return!1}function ee(Z){if(!Z)return;let ae;return _=>(ae||(ae=(Z()||Promise.resolve([])).then(ge=>ge?Q(ge):{})),ae.then(ge=>!!ge[_]))}function Y(Z){if(!Z)return;let ae;return _=>{if(!ae){const ge=Z();ae=ge?Q(ge):{}}return!!ae[_]}}function Q(Z){const ae={};for(const _ of Z)ae[_]=!0;return ae}}),define(Se[41],De([1,0,19,8,22,4,3,76,15,125,23,14,2,228,5,12,259,40,59,27,20,16,7,65,36,6,56]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f,l,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;function d(B,z,T){return new R.$Ig(j=>v(j,T)).isEqual(B,z)}function m(B,z,T){return d(B.uri,z.uri,T)?0:(0,I.$df)(B.uri.toString(),z.uri.toString())}function D(B,z,T){return B.index!==z.index?B.index<z.index?-1:1:d(B.uri,z.uri,T)?(0,I.$df)(B.name,z.name):(0,I.$df)(B.uri.toString(),z.uri.toString())}function $(B,z,T,j){const N=B.slice(0).sort((K,ee)=>T(K,ee,j)),F=z.slice(0).sort((K,ee)=>T(K,ee,j));return(0,u.$Eb)(N,F,(K,ee)=>T(K,ee,j))}function v(B,z){const T=z.getCapabilities(B.scheme);return!(T&&T&1024)}class k extends c.$zi{static toExtHostWorkspace(z,T,j,N){if(!z)return{workspace:null,added:[],removed:[]};const{id:F,name:K,folders:ee,configuration:Y,transient:Q,isUntitled:Z}=z,ae=[],_=T;T?ee.forEach((U,ie)=>{const ye=w.URI.revive(U.uri),le=k.o(j||T,ye,N);le?(le.name=U.name,le.index=U.index,ae.push(le)):ae.push({uri:ye,name:U.name,index:ie})}):ae.push(...ee.map(({uri:U,name:ie,index:ye})=>({uri:w.URI.revive(U),name:ie,index:ye}))),ae.sort((U,ie)=>U.index<ie.index?-1:1);const ge=new k(F,K,ae,!!Q,Y?w.URI.revive(Y):null,!!Z,U=>v(U,N)),{added:se,removed:re}=$(_?_.workspaceFolders:[],ge.workspaceFolders,m,N);return{workspace:ge,added:se,removed:re}}static o(z,T,j){for(let N=0;N<z.folders.length;N++){const F=z.workspaceFolders[N];if(d(F.uri,T,j))return F}}constructor(z,T,j,N,F,K,ee){super(z,j.map(Y=>new c.$Ai(Y)),N,F,ee),this.t=T,this.u=K,this.q=[],this.s=b.$mi.forUris(ee),j.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,T){return T&&this.s.get(z)&&(z=(0,R.$Sg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let C=class{constructor(z,T,j,N,F){this.c=new A.$6d,this.onDidChangeWorkspace=this.c.event,this.g=new A.$6d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$8d,this.C=new Map,this.h=N,this.s=j,this.t=F,this.j=new E.$nm,this.k=new L.$fh,this.o=z.getProxy(s.$eM.MainThreadWorkspace),this.q=z.getProxy(s.$eM.MainThreadMessageService);const K=T.workspace;this.l=K?new k(K.id,K.name,[],!!K.transient,K.configuration?w.URI.revive(K.configuration):null,!!K.isUntitled,ee=>v(ee,j)):void 0}$initializeWorkspace(z,T){this.v=T,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:p.Schemas.untitled,path:(0,R.$Qg)((0,R.$Sg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,T,j,...N){const F=[];if(Array.isArray(N)&&N.forEach(Z=>{w.URI.isUri(Z.uri)&&!F.some(ae=>d(ae.uri,Z.uri,this.s))&&F.push({uri:Z.uri,name:Z.name||(0,R.$Pg)(Z.uri)})}),this.n||[T,j].some(Z=>typeof Z!="number"||Z<0)||j===0&&F.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(T+j>K.length)return!1;const ee=K.slice(0);ee.splice(T,j,...F.map(Z=>({uri:Z.uri,name:Z.name||(0,R.$Pg)(Z.uri),index:void 0})));for(let Z=0;Z<ee.length;Z++){const ae=ee[Z];if(ee.some((_,ge)=>ge!==Z&&d(ae.uri,_.uri,this.s)))return!1}ee.forEach((Z,ae)=>Z.index=ae);const{added:Y,removed:Q}=$(K,ee,D,this.s);if(Y.length===0&&Q.length===0)return!1;if(this.o){const Z=z.displayName||z.name;this.o.$updateWorkspaceFolders(Z,T,j,F).then(void 0,ae=>{this.n=void 0;const _={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(g.Severity.Error,(0,S.localize)(0,null,Z,ae.toString()),_,[])})}return this.y(ee),!0}getWorkspaceFolder(z,T){if(this.x)return this.x.getWorkspaceFolder(z,T)}async getWorkspaceFolder2(z,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,T)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,T){let j,N="";if(typeof z=="string"?(j=w.URI.file(z),N=z):typeof z<"u"&&(j=z,N=z.fsPath),!j)return N;const F=this.getWorkspaceFolder(j,!0);if(!F)return N;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let K=(0,R.$Vg)(F.uri,j);return T&&F.name&&(K=`${F.name}/${K}`),K}y(z){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:T,added:j,removed:N}=k.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:N}))}findFiles(z,T,j,N,F=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let K="",ee=!0;return T===null?ee=!1:T!==void 0&&(typeof T=="string"?K=T:K=T.pattern),this.z(z,void 0,{exclude:K,maxResults:j,useDefaultExcludes:ee,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},F)}findFiles2(z,T={},j,N=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,z,T,N)}async z(z,T,j,N=M.CancellationToken.None){if(N&&N.isCancellationRequested)return Promise.resolve([]);const F=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,K={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:F,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let ee;if(z){const{includePattern:Y,folder:Q}=O(a.GlobPattern.from(z));ee=Q,K.includePattern=Y}else{const{includePattern:Y,folder:Q}=O(a.GlobPattern.from(T));ee=Q,K.filePattern=Y}return this.o.$startFileSearch(ee??null,K,N).then(Y=>Array.isArray(Y)?Y.map(Q=>w.URI.revive(Q)):[])}async findTextInFiles(z,T,j,N,F=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),ee=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:Y,folder:Q}=O(a.GlobPattern.from(T.include)),Z=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,ae={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:ee,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:Y,excludePattern:Z},_=!1;if(this.u[K]=ge=>{if(_)return;const se=w.URI.revive(ge.resource);ge.results.forEach(re=>{const U=(0,o.$Ph)(re);(0,l.$tK)(U)?j({uri:se,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ie=>new t.$iM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(U.ranges,ie=>new t.$iM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):j({uri:se,text:U.text,lineNumber:U.lineNumber})})},F.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(z,Q??null,ae,K,F);return delete this.u[K],ge||{}}catch(ge){throw delete this.u[K],ge}}$handleTextSearchResult(z,T){this.u[T]?.(z)}async save(z){const T=await this.o.$save(z,{saveAs:!1});return w.URI.revive(T)}async saveAs(z){const T=await this.o.$save(z,{saveAs:!0});return w.URI.revive(T)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,T){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,T);const j=this.t.transformOutgoingScheme(z),N=this.A++;return this.o.$registerEditSessionIdentityProvider(N,j),(0,P.$Rc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(z,T){this.h.info("Getting edit session identifier for workspaceFolder",z);const j=await this.resolveWorkspaceFolder(w.URI.revive(z));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const N=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!N),!N)return;const F=await N.provideEditSessionIdentity(j,T);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(z,T,j,N){this.h.info("Getting edit session identifier for workspaceFolder",z);const F=await this.resolveWorkspaceFolder(w.URI.revive(z));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const K=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!K),!K)return;const ee=await K.provideEditSessionIdentityMatch?.(T,j,N);if(this.h.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent(z){return(T,j,N)=>{const F=function(ee){T.call(j,ee)};return F.extension=z,this.B.event(F,void 0,N)}}async $onWillCreateEditSessionIdentity(z,T,j){const N=await this.resolveWorkspaceFolder(w.URI.revive(z));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:N},T,async(F,K)=>{const ee=Date.now();await Promise.resolve(F),Date.now()-ee>j&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(z,T){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,T);const j=this.t.transformOutgoingScheme(z),N=this.A++;return this.o.$registerCanonicalUriProvider(N,j),(0,P.$Rc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(z,T,j){const N=this.C.get(z.scheme);if(!N)return;const F=await N.provideCanonicalUri?.(w.URI.revive(z),T,j);if(F)return F}async $provideCanonicalUri(z,T,j){return this.provideCanonicalUri(w.URI.revive(z),{targetScheme:T},j)}};e.$Oic=C,e.$Oic=C=Je([qe(0,r.$xO),qe(1,i.$NO),qe(2,n.$uic),qe(3,h.$Mj),qe(4,f.$Mic)],C),e.$Pic=(0,y.$gi)("IExtHostWorkspace");function O(B){let z,T;return B&&(typeof B=="string"?z=B:(z=B.pattern,T=w.URI.revive(B.baseUri))),{includePattern:z,folder:T}}}),define(Se[42],De([1,0,24,4,41,6,7,261,85,18,8,5,20,12,2]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=e.$Qic=void 0;function h(f,l){if(l){const s=l.split(".");let o=f;for(let d=0;o&&d<s.length;d++)o=o[s[d]];return o}}function g(f){return f instanceof y.URI}function c(f){return f&&f.uri instanceof y.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof y.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(g(f))return{resource:f};if(c(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let a=class{constructor(l,s,o){this.a=l.getProxy(A.$eM.MainThreadConfiguration),this.c=s,this.b=o,this.d=new R.$fh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new t(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,s){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(l,s))}};e.$Qic=a,e.$Qic=a=Je([qe(0,w.$xO),qe(1,M.$Pic),qe(2,S.$Mj)],a);class t{constructor(l,s,o,d){this.a=new L.$6d,this.b=l,this.f=d,this.c=s,this.e=b.$ko.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,s){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$ko.parse(l),this.d=this.k(l.configurationScopes),this.a.fire(this.j(s,o))}getConfiguration(l,s,o){const d=r(s)||{},m=this.g(l?h(this.e.getValue(void 0,d,this.c.workspace),l):this.e.getValue(void 0,d,this.c.workspace));l&&this.h(l,d,o?.identifier);function D(v){if(v==null)return null;if(typeof v=="boolean")return v?2:5;switch(v){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(v){return typeof h(m,v)<"u"},get:(v,k)=>{this.h(l?`${l}.${v}`:v,d,o?.identifier);let C=h(m,v);if(typeof C>"u")C=k;else{let O;const B=(z,T)=>{if((0,E.$Vf)(z)){let j;const N=()=>{O=O||(0,u.$Mn)(m),j=j||h(O,T)};return new Proxy(z,{get:(F,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return N(),()=>j;if(O)return j=j||h(O,T),j[K];const ee=F[K];return typeof K=="string"?B(ee,`${T}.${K}`):ee},set:(F,K,ee)=>(N(),j&&(j[K]=ee),!0),deleteProperty:(F,K)=>(N(),j&&delete j[K],!0),defineProperty:(F,K,ee)=>(N(),j&&Object.defineProperty(j,K,ee),!0)})}return Array.isArray(z)?(0,u.$Mn)(z):z};C=B(C,v)}return C},update:(v,k,C,O)=>{v=l?`${l}.${v}`:v;const B=D(C);return k!==void 0?this.b.$updateConfigurationOption(B,v,k,d,O):this.b.$removeConfigurationOption(B,v,d,O)},inspect:v=>{v=l?`${l}.${v}`:v;const k=this.e.inspect(v,d,this.c.workspace);if(k)return{key:v,defaultValue:(0,u.$Mn)(k.policy?.value??k.default?.value),globalValue:(0,u.$Mn)(k.user?.value??k.application?.value),workspaceValue:(0,u.$Mn)(k.workspace?.value),workspaceFolderValue:(0,u.$Mn)(k.workspaceFolder?.value),defaultLanguageValue:(0,u.$Mn)(k.default?.override),globalLanguageValue:(0,u.$Mn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,u.$Mn)(k.workspace?.override),workspaceFolderLanguageValue:(0,u.$Mn)(k.workspaceFolder?.override),languageIds:(0,u.$Mn)(k.overrideIdentifiers)}}};return typeof m=="object"&&(0,u.$Pn)($,m,!1),Object.freeze($)}g(l){const s=o=>(0,E.$Vf)(o)?new Proxy(o,{get:(d,m)=>s(d[m]),set:(d,m,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(d,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(d,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return s(l)}h(l,s,o){const d=p.$bo.test(l)?4:this.d.get(l),m=o?`[${o.value}] `:"";if(d===4){typeof s?.resource>"u"&&this.f.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){s?.resource&&this.f.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,s){const o=new b.$mo(l,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,m)=>o.affectsConfiguration(d,r(m))})}k(l){return l.reduce((s,o)=>(s.set(o[0],o[1]),s),new Map)}}e.$Ric=t,e.$Sic=(0,I.$gi)("IExtHostConfiguration")}),define(Se[95],De([1,0,2,8,4,6,7,41,71,42,22,46,20,27,5,15,11,12,91,303,13]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=e.$hkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(B){function z(j){if(j!=null)return j}B.from=z;function T(j){if(j!=null)return j}B.to=T})(a||(a={}));var t;(function(B){function z(j){if(j!=null)return j}B.from=z;function T(j){if(j!=null)return j}B.to=T})(t||(t={}));var f;(function(B){function z(j){if(j!=null)return j}B.from=z;function T(j){if(j!=null)return j}B.to=T})(f||(f={}));var l;(function(B){function z(N){if(N){const F=N;return F&&!!F.process}else return!1}B.is=z;function T(N){if(N==null)return;const F={process:N.process,args:N.args};return N.options&&(F.options=f.from(N.options)),F}B.from=T;function j(N){if(N!=null)return new P.$2M(N.process,N.args,N.options)}B.to=j})(l||(l={}));var s;(function(B){function z(j){if(j!=null)return j}B.from=z;function T(j){if(j!=null)return j}B.to=T})(s||(s={}));var o;(function(B){function z(N){if(N){const F=N;return F&&(!!F.commandLine||!!F.command)}else return!1}B.is=z;function T(N){if(N==null)return;const F={};return N.commandLine!==void 0?F.commandLine=N.commandLine:(F.command=N.command,F.args=N.args),N.options&&(F.options=s.from(N.options)),F}B.from=T;function j(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new P.$3M(N.commandLine,N.options):new P.$3M(N.command,N.args?N.args:[],N.options)}B.to=j})(o||(o={}));var d;(function(B){function z(N){if(N){const F=N;return F&&F.customExecution==="customExecution"}else return!1}B.is=z;function T(N){return{customExecution:"customExecution"}}B.from=T;function j(N,F){return F.get(N)}B.to=j})(d||(e.CustomExecutionDTO=d={}));var m;(function(B){function z(T,j){let N;return T.scope!==void 0&&typeof T.scope!="number"?N=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===P.TaskScope.Workspace&&j&&j.workspaceFile?N=j.workspaceFile:N=i.$mH),{id:T._id,workspaceFolder:N}}B.from=z})(m||(e.TaskHandleDTO=m={}));var D;(function(B){function z(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}B.from=z})(D||(D={}));var $;(function(B){function z(N,F){if(N==null)return[];const K=[];for(const ee of N){const Y=T(ee,F);Y&&K.push(Y)}return K}B.fromMany=z;function T(N,F){if(N==null)return;let K;N.execution instanceof P.$2M?K=l.from(N.execution):N.execution instanceof P.$3M?K=o.from(N.execution):N.execution&&N.execution instanceof P.$4M&&(K=d.from(N.execution));const ee=a.from(N.definition);let Y;return N.scope?typeof N.scope=="number"?Y=N.scope:Y=N.scope.uri:Y=P.TaskScope.Workspace,!ee||!Y?void 0:{_id:N._id,definition:ee,name:N.name,source:{extensionId:F.identifier.value,label:N.source,scope:Y},execution:K,isBackground:N.isBackground,group:D.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}B.from=T;async function j(N,F,K){if(N==null)return;let ee;l.is(N.execution)?ee=l.to(N.execution):o.is(N.execution)?ee=o.to(N.execution):d.is(N.execution)&&(ee=d.to(N._id,K));const Y=a.to(N.definition);let Q;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Q=N.source.scope:Q=await F.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):Q=P.TaskScope.Workspace),!Y||!Q)return;const Z=new P.$5M(Y,Q,N.name,N.source.label,ee,N.problemMatchers);return N.isBackground!==void 0&&(Z.isBackground=N.isBackground),N.group!==void 0&&(Z.group=P.$1M.from(N.group._id),Z.group&&N.group.isDefault&&(Z.group=new P.$1M(Z.group.id,Z.group.label),N.group.isDefault===!0&&(Z.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Z.presentationOptions=t.to(N.presentationOptions)),N._id&&(Z._id=N._id),N.detail&&(Z.detail=N.detail),Z}B.to=j})($||(e.TaskDTO=$={}));var v;(function(B){function z(j){return j}B.from=z;function T(j){if(j)return Object.assign(Object.create(null),j)}B.to=T})(v||(v={}));class k{#e;constructor(z,T,j){this._id=T,this.a=j,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let C=class{constructor(z,T,j,N,F,K,ee,Y){this.q=new M.$6d,this.r=new M.$6d,this.s=new M.$6d,this.u=new M.$6d,this.a=z.getProxy(A.$eM.MainThreadTask),this.b=j,this.c=N,this.d=F,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,T,j){if(!j)return new P.$gM(()=>{});const N=this.x();return this.j.set(N,{type:T,provider:j,extension:z}),this.a.$registerTaskProvider(N,T),new P.$gM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(z,T){this.a.$registerTaskSystem(z,T)}fetchTasks(z){return this.a.$fetchTasks(v.from(z)).then(async T=>{const j=[];for(const N of T){const F=await $.to(N,this.b,this.m);F&&j.push(F)}return j})}get taskExecutions(){const z=[];return this.k.forEach(T=>z.push(T)),z}terminateTask(z){if(!(z instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,T,j){const N=this.m.get(z.id);N&&(this.o.set(z.id,N),this.e.attachPtyToTerminal(T,await N.callback(j))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const T=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const T=await this.z(z.id);this.s.fire({execution:T,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const T=await this.z(z.id);this.u.fire({execution:T,exitCode:z.exitCode})}$provideTasks(z,T){const j=this.j.get(z);if(!j)return Promise.reject(new Error("no handler found"));const N=[],F=(0,L.$$g)(()=>j.provider.provideTasks(R.CancellationToken.None)).then(K=>this.v(T,N,j,K));return new Promise(K=>{F.then(ee=>{Promise.all(N).then(()=>{K(ee)})})})}async $resolveTask(z,T){const j=this.j.get(z);if(!j)return Promise.reject(new Error("no handler found"));if(T.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${j.type}].`);const N=await $.to(T,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const F=await j.provider.resolveTask(N,R.CancellationToken.None);if(!F)return;this.A(F,j);const K=$.from(F,j.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(K.execution)&&await this.y(K,F,!0),await this.w(K)}x(){return this.h++}async y(z,T,j){const N=await this.a.$createTaskId(z);!j&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,T.execution)),this.m.set(N,T.execution)}async z(z,T){if(typeof z=="string"){const F=this.l.get(z);if(!F)throw new r.$bb("Unexpected: The specified task is missing an execution");return F}const j=this.l.get(z.id);if(j)return j;let N;return T?N=Promise.resolve(new k(this,z.id,T)):N=$.to(z.task,this.b,this.m).then(F=>{if(!F)throw new r.$bb("Unexpected: Task does not exist.");return new k(this,z.id,F)}),this.l.set(z.id,N),N.then(F=>(this.k.set(z.id,F),F))}A(z,T){z._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const j=this.n.values();let N=j.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=j.next()}};e.$hkc=C,e.$hkc=C=Je([qe(0,w.$xO),qe(1,S.$NO),qe(2,b.$Pic),qe(3,p.$IO),qe(4,E.$Sic),qe(5,I.$ejc),qe(6,c.$Mj),qe(7,n.$qic)],C);let O=class extends C{constructor(z,T,j,N,F,K,ee,Y){super(z,T,j,N,F,K,ee,Y),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(z,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const j=$.from(T,z);if(j===void 0)throw new Error("Task is not valid");if(d.is(j.execution))await this.y(j,T,!1);else throw new r.$_;const N=await this.z(await this.a.$getTaskExecution(j),T);return this.a.$executeTask(j).catch(F=>{throw new Error(F)}),N}v(z,T,j,N){const F=[];if(N)for(const K of N){if(this.A(K,j),!K.definition||!z[K.definition.type]){const Y=K.source?K.source:"No task source";this.f.warn(`The task [${Y}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=$.from(K,j.extension);ee&&d.is(ee.execution)?(F.push(ee),T.push(this.y(ee,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:F,extension:j.extension}}async w(z){if(d.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,T,j){}};e.$ikc=O,e.$ikc=O=Je([qe(0,w.$xO),qe(1,S.$NO),qe(2,b.$Pic),qe(3,p.$IO),qe(4,E.$Sic),qe(5,I.$ejc),qe(6,c.$Mj),qe(7,n.$qic)],O),e.$jkc=(0,y.$gi)("IExtHostTask")}),define(Se[365],De([1,0,36,29]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=void 0,e.$TK=M,e.$VK=A;function M(P){return"cellResults"in P}e.$UK="rawCell#";function A(P,b){let p=-1;const E=[];let R=[];return P.forEach(w=>{w.range.startLineNumber!==p&&R.length>0&&(E.push([...R]),R=[]),R.push(w),p=w.range.endLineNumber}),R.length>0&&E.push([...R]),E.map(w=>{const S=[],y=w[0].range.startLineNumber,h=w[w.length-1].range.endLineNumber;for(let g=y;g<=h;g++)S.push(b.getLineContent(g));return new u.$xK(S.join(`
`)+`
`,w.map(g=>new L.$$s(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(Se[366],De([1,0,222,21,4,3,28,14,18,2,32,111,6,33,16,7,67,336,153,24,15,293,365,362]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;class l{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,d,m,D,$,v){this.q=m,this.r=D,this.s=$,this.t=v,this.f=new Map,this.g=new P.$Ac,this.h=new Map,this.j=new M.$6d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$6d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$6d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$6d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$oic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=o.getProxy(w.$eM.MainThreadNotebook),this.c=o.getProxy(w.$eM.MainThreadNotebookDocuments),this.d=o.getProxy(w.$eM.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const C=k.notebookEditor?.notebookUri,O=k.cell.handle,z=this.g.get(C)?.getCell(O);if(z)return z.apiCell}if(k&&k.$mid===14){const C=k.uri,O=this.g.get(C);if(O)return O.apiNotebook}return k}}),l.B(d)}getEditorById(o){const d=this.h.get(o);if(!d)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(o){for(const[d,m]of this.h)if(m.apiEditor===o)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,d){const m=this.g.get(o);if(!m&&!d)throw new Error(`NO notebook document for '${o}'`);return m}static u(o,d){if(!d)return;const m=d.filenamePattern.map(D=>y.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(d.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:d.displayName,filenamePattern:m,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,d,m){const D=l.a++,$=typeof m.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(D,m),this.b.$registerNotebookCellStatusBarItemProvider(D,$,d);let v;return $!==void 0&&(v=m.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent($))),new h.$gM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,$),v?.dispose()})}async createNotebookDocument(o){const d=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&y.NotebookData.from(o.content)});return E.URI.revive(d)}async openNotebookDocument(o){const d=this.g.get(o);if(d)return d.apiNotebook;const m=await this.c.$tryOpenNotebook(o),D=this.g.get(E.URI.revive(m));return(0,p.$5f)(D?.apiNotebook)}async showNotebookDocument(o,d){E.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let m;typeof d=="object"?m={position:y.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(y.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:m={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,m),$=D&&this.h.get(D)?.apiEditor;if($)return $;throw D?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,d,m,D){const $=this.f.get(o),v=E.URI.revive(d),k=this.g.get(v);if(!k||!$)return;const C=k.getCellFromIndex(m);if(!C)return;const O=await $.provideCellStatusBarItems(C.apiCell,D);if(!O)return;const B=new A.$Sc,z=this.p.add([B]),j=(Array.isArray(O)?O:[O]).map(N=>y.NotebookStatusBarItem.from(N,this.i,B));return{cacheId:z,items:j}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,d,m,D,$){if((0,b.$Te)(d))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:d,serializer:m,options:D}),this.b.$registerNotebookSerializer(v,{id:o.identifier,location:o.extensionLocation},d,y.NotebookDocumentContentOptions.from(D),l.u(o,$)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(o,d,m){const D=this.x.get(o);if(!D)throw new Error("NO serializer found");const $=await D.serializer.deserializeNotebook(d.buffer,m);return new g.$aw(y.NotebookData.from($))}async $notebookToData(o,d,m){const D=this.x.get(o);if(!D)throw new Error("NO serializer found");const $=await D.serializer.serializeNotebook(y.NotebookData.to(d.value),m);return L.$te.wrap($)}async $saveNotebook(o,d,m,D,$){const v=E.URI.revive(d),k=this.x.get(o);if(!k)throw new Error("NO serializer found");const C=this.g.get(v);if(!C)throw new Error("Document NOT found");if(C.versionId!==m)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new R.$8k((0,u.localize)(0,null,this.z(v)),6);await this.y(v,D);const O={metadata:(0,i.$Un)(C.apiNotebook.metadata,N=>!(k.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of C.apiNotebook.getCells()){const F=new h.$IN(N.kind,N.document.getText(),N.document.languageId,N.mime,k.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);F.metadata=(0,i.$Un)(N.metadata,K=>!(k.options?.transientCellMetadata??{})[K]),O.cells.push(F)}const B=await k.serializer.serializeNotebook(O,$);await this.s.value.writeFile(v,B);const z=this.s.getFileSystemProviderExtUri(v.scheme),T=await this.s.value.stat(v);return{name:z.basename(v),isFile:(T.type&R.FileType.File)!==0,isDirectory:(T.type&R.FileType.Directory)!==0,isSymbolicLink:(T.type&R.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((T.permissions??0)&R.FilePermission.Locked),etag:R.$gl({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(o,d,m,D,$){const v=this.x.get(o)?.serializer;if(!v)return{limitHit:!1,results:[]};const k=new P.$Bc;await(async(T,j,N)=>{await Promise.all(T.map(async F=>await Promise.all(F.filenamePatterns.map(K=>{const ee={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:K};return this.t.doInternalFileSearchWithCustomCallback(ee,j,Y=>{Y.forEach(Q=>{k.has(Q)||D.some(ae=>F.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(_=>(0,f.$ffb)(_,Q)))||k.add(Q)})}).catch(Y=>{if(Y.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Y})}))))})(m,$,d);const O=new P.$Ac;let B=!1;const z=Array.from(k).map(async T=>{const j=[];try{if($.isCancellationRequested)return;if(d.maxResults&&[...O.values()].reduce((ee,Y)=>ee+Y.cellResults.length,0)>d.maxResults){B=!0;return}const N=[],F=this.g.get(T);if(F)F.apiNotebook.getCells().forEach(Y=>N.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(Q=>Q.items.map(Z=>Z.data.toString()))}));else{const ee=await this.s.value.readFile(T),Y=L.$te.fromString(ee.toString()),Q=await v.deserializeNotebook(Y.buffer,$);if($.isCancellationRequested)return;y.NotebookData.from(Q).cells.forEach(ae=>N.push({input:ae.source,outputs:ae.outputs.flatMap(_=>_.items.map(ge=>ge.valueBytes.toString()))}))}if($.isCancellationRequested)return;N.forEach((ee,Y)=>{const Q=d.contentPattern.pattern,Z=new a.$RTb(ee.input,void 0,ee.outputs),ae=Z.findInInputs(Q),_=Z.findInOutputs(Q),ge=_.flatMap(se=>(0,t.$VK)(se.matches,se.textBuffer)).map((se,re)=>(se.webviewIndex=re,se));if(ae.length>0||_.length>0){const se={index:Y,contentResults:(0,t.$VK)(ae,Z.inputTextBuffer),webviewResults:ge};j.push(se)}});const K={resource:T,cellResults:j};O.set(T,K);return}catch{return}});return await Promise.all(z),{limitHit:B,results:[...O.values()]}}async y(o,d){const m=await this.s.value.stat(o);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==R.$fl&&typeof m.mtime=="number"&&typeof m.size=="number"&&d.mtime<m.mtime&&d.etag!==R.$gl({mtime:d.mtime,size:m.size}))throw new R.$8k((0,u.localize)(1,null),3,d)}z(o){return o.scheme===r.Schemas.file?o.fsPath:o.toString()}A(o,d,m){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const D=new n.$Mjc(d,this.d,o,m.visibleRanges.map(y.NotebookRange.to),m.selections.map(y.NotebookRange.to),typeof m.viewColumn=="number"?y.ViewColumn.to(m.viewColumn):void 0);this.h.set(d,D)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const m of o.value.removedDocuments){const D=E.URI.revive(m),$=this.g.get(D);$&&($.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire($.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===D.toString()&&this.h.delete(v.id)}if(o.value.addedDocuments){const m=[];for(const D of o.value.addedDocuments){const $=E.URI.revive(D.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const v=new c.$Ljc(this.c,this.q,this.r,$,D);m.push(...D.cells.map(k=>c.$Kjc.asModelAddData(k))),this.g.get($)?.dispose(),this.g.set($,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this.m.fire(v.apiNotebook)}}if(o.value.addedEditors)for(const m of o.value.addedEditors){if(this.h.has(m.id))return;const D=E.URI.revive(m.documentUri),$=this.g.get(D);$&&this.A($,m.id,m)}const d=[];if(o.value.removedEditors)for(const m of o.value.removedEditors){const D=this.h.get(m);D&&(this.h.delete(m),this.k?.id===D.id&&(this.k=void 0),d.push(D))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const m=new Set;this.l.forEach(D=>m.add(D.id));for(const D of this.h.values()){const $=m.has(D.id);D._acceptVisibility($)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(o){const d=S.$VO.String.with("notebookType","A notebook type"),m=new S.$XO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new S.$VO("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>L.$te.wrap($))],new S.$WO("Notebook Data",$=>y.NotebookData.to($.value))),D=new S.$XO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new S.$VO("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new g.$aw(y.NotebookData.from($)))],new S.$WO("Bytes",$=>$.buffer));o.registerApiCommand(m),o.registerApiCommand(D)}}e.$Vjc=l}),define(Se[367],De([1,0,17,22,44,35,23,38,36]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class E{constructor(w,S,y){this.k=w,this.l=S,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&A.$ak(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&A.$ak(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const S=this.k.folderQueries||[];return new Promise((y,h)=>{const g=c=>{this.f++,w(c)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const n=c.toString(),i=u.$nc(n);this.j&&this.j(n,i)||this.v(g,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,g))).then(c=>{y({limitHit:this.e,stats:c[0]||void 0})},c=>{h(new Error((0,M.$4i)(c)))})})}async p(w,S){const y=new L.$de,h=this.q(w),g=this.r(),c=new p.$LK(this.k,w),n=!c.hasSiblingExcludeClauses();let i;try{this.h.add(y),i=b.$2d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,y.token),a=i.elapsed(),t=b.$2d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const l=u.$gc.relative(w.folder.path,f.path);if(n){const s=u.$nc(f.path);this.v(S,{base:w.folder,relativePath:l,basename:s});return}this.s(g,w.folder,l,S)}),this.g&&!this.e)?null:(this.u(g,c,S),{providerTime:a,postProcessTime:t.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(w){const S=(0,p.$KK)(this.k.includePattern,w.includePattern),y=(0,p.$KK)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:y,includes:S,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},S,y,h){if(y===this.a){const c=u.$nc(this.a);this.v(h,{base:S,relativePath:this.a,basename:c})}function g(c){const n=u.$nc(c),i=u.$mc(c);let r=w[i];r||(r=w[i]=[],g(i)),r.push({base:S,relativePath:c,basename:n})}g(y)}u({rootEntries:w,pathToEntries:S},y,h){const g=this,c=this.a;function n(i){const r=(0,p.$NK)(()=>i.map(a=>a.basename));for(let a=0,t=i.length;a<t;a++){const f=i[a],{relativePath:l,basename:s}=f;if(y.matchesExcludesSync(l,s,c!==s?r:void 0))continue;const o=S[l];if(o)n(o);else{if(l===c)continue;g.v(h,f)}if(g.e)break}}n(w)}v(w,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(S))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,S,y,h){const g=this.c(w.cacheKey),c=new E(w,S,g&&g.token);let n=0;const i=r=>{n+=r.length,y(r.map(a=>this.d(a)))};return this.e(c,R.a,i,h).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new L.$de),this.b.get(w)}d(w){return w.relativePath?{resource:P.$Tg(w.base,w.relativePath)}:{resource:w.base}}e(w,S,y,h){const g=h.onCancellationRequested(()=>{w.cancel()}),c=i=>{i&&(n.push(i),S>0&&n.length>=S&&(y(n),n=[]))};let n=[];return w.search(c).then(i=>(n.length&&y(n),g.dispose(),i),i=>(n.length&&y(n),g.dispose(),Promise.reject(i)))}}e.$Njc=R}),define(Se[368],De([1,0,19,72,35,103,28,15,17,23,14,18,2,100,242,52,12,40,146,363,36]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=void 0,e.$VL=D;let a=class{constructor(v,k,C,O,B){this.a=v,this.b=k,this.c=C,this.d=O,this.e=B}text(v,k,C={}){v=this.f(v,C);const O=this.a.getValue(),B=k&&k.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(k?.map(c.$Bi),C),type:2,contentPattern:v,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:O.search.usePCRE2||B||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(v,k){const C=this.a.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const O={...v,wordSeparators:C.editor.wordSeparators};return this.j(v,k)&&(O.isCaseSensitive=!0),this.k(v)&&(O.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),O}file(v,k={}){return{...this.h(v,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(v,k){return v?(v=Array.isArray(v)?v.map(o):o(v),k?this.parseSearchPaths(v):{pattern:f(...Array.isArray(v)?v:[v])}):{}}h(v=[],k={}){const C=this.g(k.includePattern,k.expandPatterns),O=this.g(k.excludePattern,k.expandPatterns),B=v.length>1,z=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(N=>this.q(N,k,O)):v.map(N=>this.r(N,k,O,B))).filter(N=>!!N),T={_reason:k._reason,folderQueries:z,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:O.pattern,includePattern:C.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const N=u.$Hb(u.$Rb(this.c.groups.map(ee=>ee.editors.map(Y=>Y.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const F=N.filter(ee=>(0,r.$BK)(T,ee.fsPath)),K=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...T,...K}}const j=k.extraFileResources&&k.extraFileResources.filter(N=>(0,r.$BK)(T,N.fsPath));return T.extraFileResources=j&&j.length?j:void 0,T}i(v){const k=[],C=new P.$Ac,O={};let B=!1;return v.forEach(z=>{if(z.scheme===b.Schemas.walkThrough)return;if((0,E.$Xg)(z)){const j=this.b.getWorkspaceFolder(z)?.uri??z.with({path:p.$mc(z.fsPath)});let N=C.get(j);N||(B=!0,N={folder:j,includePattern:{}},k.push(N),C.set(j,N));const F=p.$lc(j.fsPath,z.fsPath);(0,I.$5f)(N.includePattern)[F.replace(/\\/g,"/")]=!0}else z.fsPath&&(B=!0,O[z.fsPath]=!0)}),{folderQueries:k,includePattern:O,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(v,k){if(k.isSmartCase){if(v.isRegExp){if(R.$Kf(v.pattern,!0))return!0}else if(R.$Kf(v.pattern))return!0}return!!v.isCaseSensitive}k(v){return v.isMultiline||v.isRegExp&&(0,S.$kC)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const k=K=>p.$ic(K)||/^\.\.?([\/\\]|$)/.test(K),O=(Array.isArray(v)?v:l(v)).map(K=>{const ee=this.e.resolvedUserHome;return ee?(0,A.$fw)(K,ee.scheme===b.Schemas.file?ee.fsPath:ee.path):K}),B=L.$K(O,K=>k(K)?"searchPaths":"exprSegments"),z=(B.exprSegments||[]).map(K=>R.$5e(K,"/")).map(K=>R.$5e(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),s(K))),T={},j=this.m(B.searchPaths||[]);j&&j.length&&(T.searchPaths=j);const N=u.$Rb(z),F=f(...N);return F&&(T.pattern=F),T}l(v,k){return k.disregardExcludeSettings?void 0:(0,r.$AK)(v,!k.disregardSearchExcludeSettings)}m(v){if(!v||!v.length)return[];const k=v.flatMap(O=>{let{pathPortion:B,globPortion:z}=t(O);return z&&(z=d(z)),this.n(B).flatMap(j=>this.o(j,z))}),C=new Map;return k.forEach(O=>{const B=O.searchPath.toString(),z=C.get(B);z?O.pattern&&(z.pattern=z.pattern||{},z.pattern[O.pattern]=!0):C.set(B,{searchPath:O.searchPath,pattern:O.pattern?f(O.pattern):void 0})}),Array.from(C.values())}n(v){if(p.$ic(v)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:v})}]:[{searchPath:w.URI.file(p.$hc(v))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(v=o(v),v.startsWith("../")||v===".."){const O=p.$gc.resolve(k.path,v);return[{searchPath:k.with({path:O})}]}const C=d(v);return[{searchPath:k,pattern:C}]}else{if(v==="./"||v===".\\")return[];{const k=v.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(B=>{const z=k.match(new RegExp(`^${R.$Ye(B.name)}(?:/(.*)|$)`));return z?{match:z,folder:B}:null}).filter(I.$2f);if(O.length)return O.map(B=>{const z=B.match[1];return{searchPath:B.folder.uri,pattern:z&&d(z)}});{const B=v.match(/\.[\/\\](.+)[\/\\]?/),z=B?B[1]:v,T=y.localize(0,null,z);throw new Error(T)}}}}o(v,k){const C=v.pattern&&k?`${v.pattern}/${k}`:v.pattern||k,O=[{searchPath:v.searchPath,pattern:C}];return C&&!C.endsWith("**")&&O.push({searchPath:v.searchPath,pattern:C+"/**"}),O}q(v,k,C){const O=this.r((0,c.$Bi)(v.searchPath),k,C,!1);return O?{...O,includePattern:v.pattern}:null}r(v,k,C,O){let B;const z=w.URI.isUri(v)?v:v.uri;if(C.searchPaths){const K=C.searchPaths.filter(ee=>(0,E.$Mg)(ee.searchPath,z))[0];if(K&&!K.pattern)return null;K&&(B=K.pattern)}const T=this.a.getValue({resource:z}),N={...this.l(T,k)||{},...B||{}},F=w.URI.isUri(v)?(0,E.$Qg)(v):v.name;return{folder:z,folderName:O?F:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!T.search.followSymlinks}}};e.$UL=a,e.$UL=a=Je([qe(0,h.$Mi),qe(1,c.$pi),qe(2,n.$rD),qe(3,g.$Mj),qe(4,i.$SL)],a);function t($){const v=$.match(/[\*\{\}\(\)\[\]\?]/);if(v){const k=v.index,C=$.substr(0,k).match(/[/|\\][^/\\]*$/);if(C){let O=$.substr(0,C.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function f(...$){return $.length?$.reduce((v,k)=>(v[k]=!0,v),Object.create(null)):void 0}function l($){return M.$$j($,",").map(v=>v.trim()).filter(v=>!!v.length)}function s($){return[`**/${$}/**`,`**/${$}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function o($){return $.replace(/\\/g,"/")}function d($){return o($).replace(/^\.\//,"").replace(/\/+$/g,"")}function m($){return $.replace(/([?*[\]])/g,"[$1]")}function D($,v){$=u.$Mb($,O=>O.toString());const k=[],C=v.getWorkspace();return $&&$.forEach(O=>{let B;if(v.getWorkbenchState()===2)B=(0,E.$Vg)(C.folders[0].uri,O),B&&B!=="."&&(B="./"+B);else{const z=v.getWorkspaceFolder(O);if(z){const T=z.name;if(C.folders.filter(N=>N.name===T).length===1){const N=(0,E.$Vg)(z.uri,O);N===""?B=`./${z.name}`:B=`./${z.name}/${N}`}else B=O.fsPath}}B&&k.push(m(B))}),k}}),define(Se[369],De([1,0,23,2,22,13,5,368,36,40,8]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jub=w,e.$Kub=h;const I=7e3;function w(g,c){const n=c.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const o of n)if(/^workspaceContains:/.test(o)){const d=o.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||g.forceUsingSearch?r.push(d):i.push(d)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:a,resolve:t}=(0,R.$_g)(),f=o=>t({activationEvent:o}),l=Promise.all(i.map(o=>S(g,o,f))).then(()=>{}),s=y(g,c.identifier,r,f);return Promise.all([l,s]).then(()=>{t(void 0)}),a}async function S(g,c,n){for(const i of g.folders)if(await g.exists(u.$Tg(L.URI.revive(i),c))){n(`workspaceContains:${c}`);return}}async function y(g,c,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new M.$de,a=g.checkExists(g.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),g.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let f=!1;try{f=await a}catch(l){A.$4(l)||A.$1(l)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function h(g,c,n,i){const r=g.get(P.$fi),a=g.get(p.$sK),f=r.createInstance(b.$UL).file(c.map(l=>(0,E.$Bi)(L.URI.revive(l))),{_reason:"checkExists",includePattern:n,exists:!0});return a.fileSearch(f,i).then(l=>!!l.limitHit,l=>A.$4(l)?!1:Promise.reject(l))}}),define(Se[47],De([1,0,218,17,58,23,8,3,76,2,12,6,42,299,118,41,26,148,13,25,21,278,7,64,5,27,93,20,107,69,46,121,4,369,117,280,15,115,38,11,116]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f,l,s,o,d,m,D,$,v,k,C,O,B,z,T,j,N,F){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=e.$rjc=e.$qjc=e.$pjc=void 0,e.$pjc=(0,l.$gi)("IHostUtils");let ee=K=class extends b.$Tc{constructor(U,ie,ye,le,ue,ce,de,H,x,he,pe,Ae,we){super(),this.X=Ae,this.Y=we,this.a=this.B(new k.$6d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ie,this.g=ye,this.f=de,this.j=le,this.m=ue,this.s=ce,this.t=x,this.u=he,this.w=pe,this.y=this.g.getProxy(I.$eM.MainThreadWorkspace),this.z=this.g.getProxy(I.$eM.MainThreadTelemetry),this.C=this.g.getProxy(I.$eM.MainThreadExtensionService),this.D=new P.$fh,this.F=new P.$fh,this.G=new P.$fh,this.H=new P.$fh,this.I=new se(this.f.extensions.activationEvents),this.L=new c.$n0b(this.I,this.f.extensions.allExtensions);const Pe=new i.$Cm(this.f.extensions.myExtensions);this.J=new c.$n0b(this.I,_(this.L,Pe)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new y.$ajc(this.g,this.s),this.N=new O.$ijc(this.g),this.O=H,this.h=U.createChild(new m.$ei([y.$bjc,this.M],[O.$jjc,this.N])),this.P=this.B(new S.$_ic(this.J,this.L,{onExtensionActivationError:(Fe,ze,q)=>{this.C.$onExtensionActivationError(Fe,n.$3(ze),q)},actualActivateExtension:async(Fe,ze)=>{if(c.$n0b.isHostExtension(Fe,this.J,this.L))return await this.C.$activateExtension(Fe,ze),new S.$$ic;const q=this.J.getExtensionDescription(Fe);return this.eb(q,ze)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(U){n.$1(U)}}async Z(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this.db(ue))}catch{}await Promise.all(U)}terminate(U,ie=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const ye=this.Z();Promise.race([(0,P.$hh)(5e3),ye]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ie=await this.C.$getExtension(U);return ie&&{...ie,identifier:new i.$Bm(ie.identifier.value),extensionLocation:E.URI.revive(ie.extensionLocation)}}$(U,ie){return this.P.activateByEvent(U,ie)}ab(U,ie){return this.P.activateById(U,ie)}activateByIdWithErrors(U,ie){return this.ab(U,ie).then(()=>{const ye=this.P.getActivatedExtension(U);if(ye.activationFailed)return Promise.reject(ye.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async bb(U){if(U.scheme===z.Schemas.file&&this.c.fsRealpath){const ie=await this.c.fsRealpath(U.fsPath);return E.URI.file(ie)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(U=>new ge(U))),this.Q}async cb(U){const ie=p.$mi.forUris(ye=>A.$Kg.ignorePathCasing(ye));return await Promise.all(U.map(async ye=>{if(this.vb(ye)){const le=await this.bb(ye.extensionLocation);ie.set(le,ye)}})),ie}db(U){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ie;const ye=this.P.getActivatedExtension(U);if(!ye)return ie;try{typeof ye.module.deactivate=="function"&&(ie=Promise.resolve(ye.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(le)}try{(0,b.$Oc)(ye.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(le)}return ie}async eb(U,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.gb(U,ie).then(ye=>{const le=ye.activationTimes;return this.C.$onDidActivateExtension(U.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,ie),this.fb(U,ie,"success",le),ye},ye=>{throw this.fb(U,ie,"failure"),ye})}fb(U,ie,ye,le){const ue=Q(U,ie);this.z.$publicLog2("extensionActivationTimes",{...ue,...le||{},outcome:ye})}gb(U,ie){const ye=Q(U,ie);this.z.$publicLog2("activatePlugin",ye);const le=this.vb(U);if(!le)return Promise.resolve(new S.$0ic(S.$7ic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${U.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const ue=new S.$8ic(ie.startup);return Promise.all([this.wb(U,(0,A.$Tg)(U.extensionLocation,le),ue),this.hb(U)]).then(ce=>(M.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),K.ib(this.s,U.identifier,ce[0],ce[1],ue))).then(ce=>(M.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ce))}hb(U){const ie=this.Y.createLanguageModelAccessInformation(U),ye=new a.$djc(U,this.M),le=new a.$cjc(U.identifier.value,!1,this.M),ue=new B.$kjc(U,this.N),ce=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([ye.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const H=this;let x,he;const pe=(0,g.$3F)(U,"ipc")?this.f.messagePorts?.get(i.$Bm.toKey(U.identifier)):void 0;return Object.freeze({globalState:ye,workspaceState:le,secrets:ue,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return L.$jc(U.extensionLocation.fsPath,Ae)},get storagePath(){return H.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return H.O.globalValue(U).fsPath},get logPath(){return L.$jc(H.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(H.f.logsLocation,U.identifier.value)},get storageUri(){return H.O.workspaceValue(U)},get globalStorageUri(){return H.O.globalValue(U)},get extensionMode(){return ce},get extension(){return x===void 0&&(x=new ae(H,U.identifier,U,de,!1)),x},get extensionRuntime(){return(0,g.$4F)(U,"extensionRuntime"),H.extensionRuntime},get environmentVariableCollection(){return H.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!he){if(!pe)return;const Ae=k.Event.buffer(k.Event.fromDOMEventEmitter(pe,"message",we=>we.data));pe.start(),he={onDidReceiveMessage:Ae,postMessage:pe.postMessage.bind(pe)}}return he}})})}static ib(U,ie,ye,le,ue){return ye=ye||{activate:void 0,deactivate:void 0},this.jb(U,ie,ye,le,ue).then(ce=>new S.$9ic(!1,null,ue.build(),ye,ce,le.subscriptions))}static jb(U,ie,ye,le,ue){if(typeof ye.activate=="function")try{ue.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ce=typeof global=="object"?global:self,de=ye.activate.apply(ce,[le]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(de).then(H=>(ue.activateResolveStop(),H))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(ye)}kb(U,ie){this.ab(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ie}).then(void 0,ye=>{this.s.error(ye)})}lb(U,ie=0){const le=Date.now();(0,N.$B)(()=>{for(let ue=ie;ue<U.length;ue+=1){const ce=U[ue];for(const de of ce.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-le>50){this.lb(U,ue);break}else this.kb(ce,de)}})}mb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(U=>{const ie=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ye=this.J.getAllExtensionDescriptions();if(ie)this.lb(ye);else for(const le of ye)if(le.activationEvents)for(const ue of le.activationEvents)ue==="onStartupFinished"&&this.kb(le,ue)})}nb(){const U=this.$("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.ob(ce.added)));const ie=this.j.workspace?this.j.workspace.folders:[],ye=this.ob(ie),le=this.qb(),ue=Promise.all([le,U,ye]).then(()=>{});return Promise.race([ue,(0,P.$hh)(1e4)]).then(()=>{this.mb()}),ue}ob(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.pb(U,ie))).then(()=>{})}async pb(U,ie){if(this.isActivated(ie.identifier))return;const ye=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:U.map(ce=>ce.uri),forceUsingSearch:ye||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,de,H)=>this.y.$checkExists(ce,de,H)},ue=await(0,C.$Jub)(le,ie);if(ue)return this.ab(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ue.activationEvent}).then(void 0,ce=>this.s.error(ce))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(U){throw console.error(U),U}}async rb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ie}=this.f.environment;if(!U||!ie)throw new Error(u.localize(0,null));const ye=await this.wb(null,ie,new S.$8ic(!1));if(!ye||typeof ye.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((le,ue)=>{const ce=(x,he)=>{x?(N.$t&&this.s.error("Test runner called back with error",x),ue(x)):(N.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},de=(0,A.$Hg)(ie),H=ye.run(de,ce);H&&H.then&&H.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),le(0)}).catch(x=>{N.$t&&this.s.error("Test runner finished with error",x),ue(x instanceof Error&&x.stack?x.stack:String(x))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,P.$hh)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ie){return this.R[U]=ie,(0,b.$Rc)(()=>{delete this.R[U]})}async getRemoteExecServer(U){const{resolver:ie}=await this.tb(U);return ie?.resolveExecServer?.(U,{resolveAttempt:0})}async tb(U){const ie=U.indexOf("+");if(ie===-1)throw new t.$mM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ye=U.substr(0,ie);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ye}`,!1),{authorityPrefix:ye,resolver:this.R[ye]}}async $resolveAuthority(U,ie){const ye=j.$2d.create(!1),le=()=>`[resolveAuthority(${(0,f.$vl)(U)},${ie})][${ye.elapsed()}ms] `,ue=V=>this.s.info(`${le()}${V}`),ce=V=>this.s.warn(`${le()}${V}`),de=(V,J=void 0)=>this.s.error(`${le()}${V}`,J),H=V=>{if(V instanceof t.$mM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},x=async V=>{ue(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:X}=await this.tb(V);if(!J)throw de(`no resolver for ${X}`),new t.$mM(`No remote extension installed to resolve ${X}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:X,remoteAuthority:V}},he=U.split(/@|%40/g).reverse();ue(`activating remote resolvers ${he.join(" -> ")}`);let pe;try{pe=await Promise.all(he.map(x)).catch(async V=>{if(!(V instanceof t.$mM)||V._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return ce(`resolving nested authorities failed: ${V.message}`),[await x(U)]})}catch(V){return H(V)}const Ae=new P.$rh;Ae.cancelAndSet(()=>ue("waiting..."),1e3);let we,Pe;for(const[V,{authorityPrefix:J,resolver:X,remoteAuthority:me}]of pe.entries())try{if(V===pe.length-1)ue("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${J}`),we=await X.resolve(me,{resolveAttempt:ie,execServer:Pe}),M.mark(`code/extHost/didResolveAuthorityOK/${J}`),ue("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,t.$lM.isManagedResolvedAuthority(we)?we:void 0));else{if(ue(`invoking resolveExecServer() for ${me}`),M.mark(`code/extHost/willResolveExecServer/${J}`),Pe=await X.resolveExecServer?.(me,{resolveAttempt:ie,execServer:Pe}),!Pe)throw new t.$mM(`Exec server was not available for ${me}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(ve){return M.mark(`code/extHost/didResolveAuthorityError/${J}`),de("returned an error",ve),Ae.dispose(),H(ve)}Ae.dispose();const Fe={environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures?{elevation:we.tunnelFeatures.elevation,privacyOptions:we.tunnelFeatures.privacyOptions,protocol:we.tunnelFeatures.protocol===void 0?!0:we.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${t.$lM.isManagedResolvedAuthority(we)?"managed authority":`${we.host}:${we.port}`}`);let q;if(t.$lM.isManagedResolvedAuthority(we)){const V=ie;this.X.setFactory(V,we.makeConnection),q={authority:U,connectTo:new f.$sl(V),connectionToken:we.connectionToken}}else q={authority:U,connectTo:new f.$tl(we.host,we.port),connectionToken:we.connectionToken};return{type:"ok",value:{authority:q,options:ze,tunnelInformation:Fe}}}async $getCanonicalURI(U,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$vl)(U)})`);const{resolver:ye}=await this.tb(U);if(!ye)return null;const le=E.URI.revive(ie);if(typeof ye.getCanonicalURI>"u")return le;const ue=await(0,P.$$g)(()=>ye.getCanonicalURI(le));return ue||le}$startExtensionHost(U){U.toAdd.forEach(le=>le.extensionLocation=E.URI.revive(le.extensionLocation));const{globalRegistry:ie,myExtensions:ye}=Y(this.I,this.L,this.J,U);return this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ye),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.sb()}$activateByEvent(U,ie){return ie===1?this.D.wait().then(ye=>this.$(U,!1)):this.G.wait().then(ye=>this.$(U,!1))}async $activate(U,ie){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.ab(U,ie),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ce=>ce.extensionLocation=E.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:ye}=Y(this.I,this.L,this.J,U),le=await this.cb(ye);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ye),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ie=r.$te.alloc(U),ye=Math.random()%256;for(let le=0;le<U;le++)ie.writeUInt8(ye,le);return ie}async $updateRemoteConnectionData(U){this.W=U,this.a.fire()}};e.$qjc=ee,e.$qjc=ee=K=Je([qe(0,l.$fi),qe(1,e.$pjc),qe(2,d.$xO),qe(3,h.$Pic),qe(4,w.$Sic),qe(5,R.$Mj),qe(6,s.$NO),qe(7,o.$Vic),qe(8,D.$OAb),qe(9,$.$ejc),qe(10,T.$mjc),qe(11,F.$njc),qe(12,v.$Fic)],ee);function Y(re,U,ie,ye){re.addActivationEvents(ye.addActivationEvents);const le=new c.$n0b(re,U.getAllExtensionDescriptions());le.deltaExtensions(ye.toAdd,ye.toRemove);const ue=new i.$Cm(ie.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ye.myToRemove)ue.delete(de);for(const de of ye.myToAdd)ue.add(de);const ce=_(le,ue);return{globalRegistry:le,myExtensions:ce}}function Q(re,U){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Z(re){return re.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$rjc=(0,l.$gi)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(U,ie,ye,le,ue){this.#e=U,this.#t=ie,this.#i=ye.identifier,this.id=ye.identifier.value,this.extensionUri=ye.extensionLocation,this.extensionPath=L.$hc((0,A.$Hg)(ye.extensionLocation)),this.packageJSON=ye,this.extensionKind=le,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$sjc=ae;function _(re,U){return re.getAllExtensionDescriptions().filter(ie=>U.has(ie.identifier))}class ge{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$tjc=ge;class se{constructor(U){this.a=new i.$Dm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ie of Object.keys(U))this.a.set(ie,U[ie])}}}),define(Se[370],De([1,0,58,2,6,42,26,25,20,27,5,47,12,14]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;let h=class{constructor(r,a,t,f,l,s,o){this.c=r,this.d=a,this.e=t,this.f=f,this.g=l,this.h=s,this.i=o,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new c(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$Bkc=h,e.$Bkc=h=Je([qe(2,R.$fi),qe(3,A.$Sic),qe(4,I.$rjc),qe(5,E.$NO),qe(6,w.$Mj)],h);let g=class{static{y=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&y.a.size){const a=(0,S.$Ye)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${l}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,f,l]=a,s=y.a.get(f);if(s!==void 0)return console.warn(`${f} as been renamed to ${s}, please update your imports`),t+s+l}c(r){return r.replace(/\\/g,"/")}};g=y=Je([qe(0,E.$NO)],g);class c{constructor(r,a,t,f,l){this.c=r,this.d=a,this.e=t,this.f=f,this.g=l,this.nodeModuleName="vscode",this.a=new b.$Dm}load(r,a){const t=this.d.findSubstr(a);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((l,s)=>f+=`	${s} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${f}`),this.b=this.c(P.$XF,this.e,this.f)}return this.b}}let n=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$eM.MainThreadTelemetry);const f=t.getProxy(M.$eM.MainThreadWindow);this.c=(l,s)=>{const o=L.URI.parse(l);return s?this.g(l,s):o.scheme==="http"||o.scheme==="https"?f.$openUri(o,l,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this.f?f.$openUri(o,l,{}):this.g(l,s)}}load(r,a,t){const f=this.e.findSubstr(a);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,p.$xO)],n)}),define(Se[60],De([1,0,43,3,17,50,5,71,70,47,7,41,296,42]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0,e.$ujc=(0,P.$gi)("IExtHostVariableResolverProvider");class y extends w.$zP{constructor(c,n,i,r,a,t,f){function l(){if(i){const s=i.activeEditor();if(s)return s.document.uri;const o=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof R.$3N||o.input instanceof R.$8N)return o.input.modified;if(o.input instanceof R.$2N||o.input instanceof R.$7N||o.input instanceof R.$5N)return o.input.uri}}}super({getFolderUri:s=>{const o=t.folders.filter(d=>d.name===s);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,o)=>a.getConfiguration(void 0,s).get(o),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=l();if(s)return M.$hc(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const s=l();if(s){const o=n.getWorkspaceFolder(s);if(o)return M.$hc(o.uri.fsPath)}}},getSelectedText:()=>{if(i){const s=i.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(i){const s=i.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>c.getExtension(s)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(A.env))}}let h=class extends L.$Tc{constructor(c,n,i,r,a){super(),this.b=c,this.c=n,this.g=i,this.h=r,this.j=a,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),l={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{l.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.j,t,l,this.m())})}getResolver(){return this.a.value}m(){}};e.$vjc=h,e.$vjc=h=Je([qe(0,E.$rjc),qe(1,I.$Pic),qe(2,b.$IO),qe(3,S.$Sic),qe(4,p.$5ic)],h)}),define(Se[96],De([1,0,8,4,2,25,5,6,70,47,20,7,41,143,288,42,60,3,55,33,16]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=e.$zjc=e.$yjc=e.$xjc=e.$wjc=void 0,e.$wjc=(0,P.$gi)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(m,D,$,v,k,C,O){this.N=D,this.O=$,this.P=v,this.Q=k,this.R=C,this.S=O,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$6d,this.o=new L.$6d,this.q=new L.$6d,this.w=new L.$6d,this.l=m.getProxy(b.$eM.MainThreadDebugService),this.A=new L.$6d,this.C=new L.$6d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(B=>{B.onDidChange(z=>{this.V(B)}),this.V(B)})}async $getVisualizerTreeItem(m,D){const $=this.W(D);if(!$)return;const v=await this.H.get(m)?.getTreeItem?.($);return v?this.U(m,v):void 0}registerDebugVisualizationTree(m,D,$){const v=A.$Bm.toKey(m.identifier),k=this.jb(v,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(k,$),this.l.$registerDebugVisualizerTree(k,!!$.editItem),(0,c.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(D)})}async $getVisualizerTreeItemChildren(m,D){const $=this.J.get(D)?.item;return $?(await this.H.get(m)?.getChildren?.($))?.map(k=>this.U(m,k))||[]:[]}async $editVisualizerTreeItem(m,D){const $=this.J.get(m);if(!$)return;const v=await this.H.get($.provider)?.editItem?.($.item,D);return this.U($.provider,v||$.item)}$disposeVisualizedTree(m){const D=this.J.get(m);if(!D)return;const $=[D.children];for(const v of $)if(v)for(const k of v)$.push(this.J.get(k)?.children),this.J.delete(k)}U(m,D){let $=this.I.get(D);return $||($=this.F++,this.I.set(D,$),this.J.set($,{provider:m,item:D})),r.DebugTreeItem.from(D,$)}asDebugSourceUri(m,D){const $=m;if(typeof $.sourceReference=="number"&&$.sourceReference>0){let v=`debug:${encodeURIComponent($.path||"")}`,k="?";return D&&(v+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),v+=`${k}ref=${$.sourceReference}`,M.URI.parse(v)}else{if($.path)return M.URI.file($.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(m){const D=[];for(const $ of m.getAllExtensionDescriptions())if($.contributes){const v=$.contributes.debuggers;if(v&&v.length>0)for(const k of v)(0,y.$CG)(k)&&D.push(k.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const m=[];return this.z.forEach(D=>m.push(D)),m}async $resolveDebugVisualizer(m,D){const $=this.L.get(m);if(!$)throw new Error(`No debug visualizer found with id '${m}'`);let{v,provider:k,extensionId:C}=$;if(v.visualization||(v=await k.resolveDebugVisualization?.(v,D)||v,$.v=v),!v.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(C,v.visualization)}async $executeDebugVisualizerCommand(m){const D=this.L.get(m);if(!D)throw new Error(`No debug visualizer found with id '${m}'`);const $=D.v.visualization;$&&"command"in $&&this.S.executeCommand($.command,...$.arguments||[])}W(m){const D=this.m.get(m.sessionId);return D&&{session:D.api,variable:m.variable,containerId:m.containerId,frameId:m.frameId,threadId:m.threadId}}async $provideDebugVisualizers(m,D,$,v){const k=this.W($),C=this.jb(m,D),O=this.G.get(C);if(!k||!O)return[];const B=await O.provideDebugVisualization(k,v);return B?B.map(z=>{const T=++this.M;this.L.set(T,{v:z,provider:O,extensionId:m});const j=z.iconPath?this.lb(z.iconPath):void 0;return{id:T,name:z.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(m,z.visualization)}}):[]}$disposeDebugVisualizers(m){for(const D of m)this.L.delete(D)}registerDebugVisualizationProvider(m,D,$){if(!m.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const v=A.$Bm.toKey(m.identifier),k=this.jb(v,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(k,$),this.l.$registerDebugVisualizer(v,D),(0,c.$Rc)(()=>{this.l.$unregisterDebugVisualizer(v,D),this.G.delete(D)})}addBreakpoints(m){const D=m.filter(k=>{const C=k.id;return this.z.has(C)?!1:(this.z.set(C,k),!0)});this.gb(D,[],[]);const $=[],v=new Map;for(const k of D)if(k instanceof I.$hN){let C=v.get(k.location.uri.toString());C||(C={type:"sourceMulti",uri:k.location.uri,lines:[]},v.set(k.location.uri.toString(),C),$.push(C)),C.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof I.$iN&&$.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints($)}removeBreakpoints(m){const D=m.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const $=D.filter(C=>C instanceof I.$hN).map(C=>C.id),v=D.filter(C=>C instanceof I.$iN).map(C=>C.id),k=D.filter(C=>C instanceof I.$jN).map(C=>C.id);return this.l.$unregisterBreakpoints($,v,k)}startDebugging(m,D,$){return this.l.$startDebugging(m?m.uri:void 0,D,{parentSessionID:$.parentSession?$.parentSession.id:void 0,lifecycleManagedByParent:$.lifecycleManagedByParent,repl:$.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:$.noDebug,compact:$.compact,suppressSaveBeforeStart:$.suppressSaveBeforeStart,suppressDebugStatusbar:$.suppressDebugStatusbar??$.debugUI?.simple,suppressDebugToolbar:$.suppressDebugToolbar??$.debugUI?.simple,suppressDebugView:$.suppressDebugView??$.debugUI?.simple})}stopDebugging(m){return this.l.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,D,$){if(!D)return new I.$gM(()=>{});const v=this.d++;return this.f.push({type:m,handle:v,provider:D}),this.l.$registerDebugConfigurationProvider(m,$,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,v),new I.$gM(()=>{this.f=this.f.filter(k=>k.provider!==D),this.l.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(m,D,$){if(!$)return new I.$gM(()=>{});if(!this.cb(m,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:D,handle:v,factory:$}),this.l.$registerDebugAdapterDescriptorFactory(D,v),new I.$gM(()=>{this.h=this.h.filter(k=>k.factory!==$),this.l.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(m,D){if(!D)return new I.$gM(()=>{});const $=this.j++;return this.k.push({type:m,handle:$,factory:D}),new I.$gM(()=>{this.k=this.k.filter(v=>v.factory!==D)})}async $runInTerminal(m,D){return Promise.resolve(void 0)}async $substituteVariables(m,D){let $;const v=await this.ib(m);return v&&($={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync($,D)}X(m,D){if(m.type==="implementation")return new s(m.implementation)}Y(){}async $startDASession(m,D){const $=this,v=await this.hb(D);return this.eb(this.$(v.type),v).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const C=this.Z(k),O=this.X(C,v);if(!O)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const B=O;return this.D.set(m,B),this.db(v).then(z=>(z&&this.E.set(m,z),B.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const j=T,N={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const F=await this.K.sign(j.arguments.value);N.body={signature:F},B.sendResponse(N)}else throw new Error("no signer")}catch(F){N.success=!1,N.message=F.message,B.sendResponse(N)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(T),T=(0,y.$HG)(T,!0),$.l.$acceptDAMessage(m,T)}),B.onError(T=>{z&&z.onError&&z.onError(T),this.l.$acceptDAError(m,T.name,T.message,T.stack)}),B.onExit(T=>{z&&z.onExit&&z.onExit(T??void 0,void 0),this.l.$acceptDAExit(m,T??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),B.startSession()))})}$sendDAMessage(m,D){D=(0,y.$GG)(D,!1);const $=this.E.get(m);$&&$.onWillReceiveMessage&&$.onWillReceiveMessage(D),this.D.get(m)?.sendMessage(D)}$stopDASession(m){const D=this.E.get(m);this.E.delete(m),D&&D.onWillStopSession&&D.onWillStopSession();const $=this.D.get(m);return this.D.delete(m),$?$.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const D=[],$=[],v=[];if(m.added)for(const k of m.added){const C=k.id;if(C&&!this.z.has(C)){let O;if(k.type==="function")O=new I.$iN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")O=new I.$jN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const B=M.URI.revive(k.uri);O=new I.$hN(new I.$sM(B,new I.$hM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,I.$fN)(O,C),this.z.set(C,O),D.push(O)}}if(m.removed)for(const k of m.removed){const C=this.z.get(k);C&&(this.z.delete(k),$.push(C))}if(m.changed){for(const k of m.changed)if(k.id){const C=this.z.get(k.id);if(C){if(C instanceof I.$iN&&k.type==="function"){const O=C;O.enabled=k.enabled,O.condition=k.condition,O.hitCondition=k.hitCondition,O.logMessage=k.logMessage,O.functionName=k.functionName}else if(C instanceof I.$hN&&k.type==="source"){const O=C;O.enabled=k.enabled,O.condition=k.condition,O.hitCondition=k.hitCondition,O.logMessage=k.logMessage,O.location=new I.$sM(M.URI.revive(k.uri),new I.$hM(k.line,k.character))}v.push(C)}}}this.gb(D,$,v)}async $acceptStackFrameFocus(m){let D;if(m){const $=await this.hb(m.sessionId);m.kind==="thread"?D=new I.$pN($.api,m.threadId):D=new I.$oN($.api,m.threadId,m.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(m,D,$){return(0,u.$$g)(async()=>{const v=this.bb(m);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(D);return v.provideDebugConfigurations(k,$)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(m,D,$,v){return(0,u.$$g)(async()=>{const k=this.bb(m);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return k.resolveDebugConfiguration(C,$,v)})}$resolveDebugConfigurationWithSubstitutedVariables(m,D,$,v){return(0,u.$$g)(async()=>{const k=this.bb(m);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return k.resolveDebugConfigurationWithSubstitutedVariables(C,$,v)})}async $provideDebugAdapter(m,D){const $=this.ab(m);if(!$)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.hb(D);return this.eb($,v).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(m){const D=await this.hb(m);this.n.fire(D.api)}async $acceptDebugSessionTerminated(m){const D=await this.hb(m);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(m){this.u=m?await this.hb(m):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(m,D){(await this.hb(m))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(m,D){const v={session:(await this.hb(m)).api,event:D.event,body:D.body};this.w.fire(v)}Z(m){if(m instanceof I.$kN)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.$lN)return{type:"server",port:m.port,host:m.host};if(m instanceof I.$mN)return{type:"pipeServer",path:m.path};if(m instanceof I.$nN)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}$(m){const D=this.h.filter($=>$.type===m);if(D.length>0)return D[0].factory}ab(m){const D=this.h.filter($=>$.handle===m);if(D.length>0)return D[0].factory}bb(m){const D=this.f.filter($=>$.handle===m);if(D.length>0)return D[0].provider}cb(m,D){if(m.contributes){const $=m.contributes.debuggers;if($&&$.length>0){for(const v of $)if(v.label&&v.type&&v.type===D)return!0}}return!1}db(m){const $=m.configuration.type,v=this.k.filter(k=>k.type===$||k.type==="*").map(k=>(0,u.$$g)(()=>k.factory.createDebugAdapterTracker(m.api)).then(C=>C,C=>null));return Promise.race([Promise.all(v).then(k=>{const C=k.filter(O=>!!O);if(C.length>0)return new l(C)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(m,D){const $=D.configuration.debugServer;if(typeof $=="number")return Promise.resolve(new I.$lN($));if(m){const k=await this.O.getExtensionRegistry();return(0,u.$$g)(()=>m.createDebugAdapterDescriptor(D.api,this.fb(D,k))).then(C=>{if(C)return C})}const v=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,v))}fb(m,D){}gb(m,D,$){(m.length>0||D.length>0||$.length>0)&&this.A.fire(Object.freeze({added:m,removed:D,changed:$}))}async hb(m){if(m)if(typeof m=="string"){const D=this.m.get(m);if(D)return D}else{let D=this.m.get(m.id);if(!D){const $=await this.ib(m.folderUri),v=m.parent?this.m.get(m.parent):void 0;D=new t(this.l,m.id,m.type,m.name,$,m.configuration,v?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(m){if(m){const D=M.URI.revive(m);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(m,D){return`${m}\0${D}`}kb(m,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${m}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(m){const D=this.mb(m);let $,v;return"id"in D?v=n.ThemeIcon.asClassName(D):$=D,{iconPath:$,iconClass:v}}mb(m){if(m instanceof I.$cN)return{id:m.id};const D=typeof m=="object"&&"dark"in m?m.dark:m,$=typeof m=="object"&&"light"in m?m.light:m;return{dark:typeof D=="string"?M.URI.file(D):D,light:typeof $=="string"?M.URI.file($):$}}};e.$xjc=a,e.$xjc=a=Je([qe(0,R.$xO),qe(1,w.$Pic),qe(2,E.$rjc),qe(3,h.$Sic),qe(4,p.$5ic),qe(5,g.$ujc),qe(6,i.$TO)],a);class t{constructor(m,D,$,v,k,C,O){this.f=m,this.g=D,this.h=$,this.j=v,this.k=k,this.l=C,this.m=O}get api(){const m=this;return this.d??=Object.freeze({id:m.g,type:m.h,get name(){return m.j},set name(D){m.j=D,m.f.$setDebugSessionName(m.g,D)},parentSession:m.m,workspaceFolder:m.k,configuration:m.l,customRequest(D,$){return m.f.$customDebugAdapterRequest(m.g,D,$)},getDebugProtocolBreakpoint(D){return m.f.$getDebugProtocolBreakpoint(m.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(m){this.j=m}get configuration(){return this.l}}e.$yjc=t;class f{constructor(m){this.value=Object.freeze({append(D){m.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$zjc=f;class l{constructor(m){this.d=m}onWillStartSession(){this.d.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(m):void 0)}onWillStopSession(){this.d.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.d.forEach(D=>D.onError?D.onError(m):void 0)}onExit(m,D){this.d.forEach($=>$.onExit?$.onExit(m,D):void 0)}}class s extends S.$3nb{constructor(m){super(),this.h=m,m.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.h.handleMessage(m)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let o=class extends a{constructor(m,D,$,v,k,C,O){super(m,D,$,v,k,C,O)}};e.$Ajc=o,e.$Ajc=o=Je([qe(0,R.$xO),qe(1,w.$Pic),qe(2,E.$rjc),qe(3,h.$Sic),qe(4,p.$5ic),qe(5,g.$ujc),qe(6,i.$TO)],o)}),define(Se[371],De([1,0,13,58,2,6,317,12,83,107,27,254,20,65,47,90]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=void 0;class g{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(b.$Mj),t=i.get(w.$xO).getProxy(A.$eM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const l=u.$3(f);t.$onUnexpectedError(l)})}static async installFullHandler(i){const r=i.get(b.$Mj),a=i.get(w.$xO),t=i.get(y.$rjc),f=i.get(h.$RO),l=a.getProxy(A.$eM.MainThreadExtensionService),s=a.getProxy(A.$eM.MainThreadErrors),o=await t.getExtensionPathIndex(),d=new WeakMap;function m(v,k){if(d.has(v))return d.get(v).stack;let C="",O,B;for(const T of k)C+=`
	at ${T.toString()}`,B=T.getFileName(),!O&&B&&(O=o.findSubstr(M.URI.file(B)));const z=`${v.name||"Error"}: ${v.message||""}${C}`;return d.set(v,{extensionIdentifier:O?.identifier,stack:z}),z}const D=Symbol("prepareStackTrace wrapped");let $=m;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(v){if(v===m||!v||v[D]){$=v||m;return}$=function(k,C){return m(k,C),v.call(Error,k,C)},Object.assign($,{[D]:!0})}}),u.setUnexpectedErrorHandler(v=>{r.error(v);const k=u.$3(v),C=d.get(v);if(!C?.extensionIdentifier){s.$onUnexpectedError(k);return}l.$onExtensionRuntimeError(C.extensionIdentifier,k);const O=f.onExtensionError(C.extensionIdentifier,v);r.trace("forwarded error to extension?",O,C)})}}e.$Ckc=g;class c{constructor(i,r,a,t,f){this.a=a,this.b=new P.$v0b(i,null,t),r=c.e(r,this.b);const l=new E.$ei(...(0,p.$ds)());l.set(R.$NO,{_serviceBrand:void 0,...r,messagePorts:f}),l.set(w.$xO,new w.$yO(this.b)),l.set(S.$Mic,new S.$Nic(t)),l.set(y.$pjc,a);const s=new I.$Uq(l,!0);s.invokeFunction(g.installEarlyHandler),this.d=s.invokeFunction(o=>o.get(b.$Mj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=s.invokeFunction(o=>o.get(y.$rjc)),this.c.initialize(),s.invokeFunction(g.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(A.$eM.MainThreadExtensionService);return M.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const a=i.environment.extensionDevelopmentLocationURI;return a&&(i.environment.extensionDevelopmentLocationURI=a.map(t=>M.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Dkc=c}),define(Se[372],De([1,0,8,11,229,248,141,96,70,47,20,46,7,60,41,289,290,42,33,373]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;let r=class extends b.$xjc{constructor(o,d,m,D,$,v,k,C){super(o,d,m,D,v,k,C),this.pb=$,this.nb=new l}X(o,d){switch(o.type){case"server":return new h.$Ikc(o);case"pipeServer":return new h.$Jkc(o);case"executable":return new h.$Kkc(o,d.type)}return super.X(o,d)}fb(o,d){const m=h.$Kkc.platformAdapterExecutable(d.getAllExtensionDescriptions(),o.type);if(m)return new w.$kN(m.command,m.args,m.options)}Y(){return new P.$hbc}async $runInTerminal(o,d){if(o.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(N=>{this.nb.onTerminalClosed(N)}));const m=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),$=this.pb.getDefaultShellArgs(!0),v=o.title||M.localize(0,null),k=a(D,$,o);let C=await this.nb.checkout(k,v,!0),O,B=!1;if(C)O=o.cwd;else{const N={shellPath:D,shellArgs:$,cwd:o.cwd,name:v,iconPath:new w.$cN("debug"),env:o.env};B=!0,C=this.pb.createTerminalFromOptions(N,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,k)}C.show(!0);const z=await C.processId;B?await new Promise(N=>setTimeout(N,1e3)):(C.state.isInteractedWith&&C.sendText(""),m.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?C.sendText("cls"):D.indexOf("bash")>=0?C.sendText("clear"):L.$i?C.sendText("cls"):C.sendText("clear")));const T=(0,g.$Mkc)(D,o.args,!!o.argsCanBeInterpretedByShell,O);C.sendText(T);const j=this.onDidTerminateDebugSession(N=>{N.id===d&&(this.nb.free(C),j.dispose())});return z}else if(o.kind==="external")return f(o,await this.P.getConfigProvider());return super.$runInTerminal(o,d)}};e.$Nkc=r,e.$Nkc=r=Je([qe(0,R.$xO),qe(1,y.$Pic),qe(2,E.$rjc),qe(3,c.$Sic),qe(4,I.$ejc),qe(5,p.$5ic),qe(6,S.$ujc),qe(7,n.$TO)],r);function a(s,o,d){const m=(0,i.createHash)("sha256");return m.update(JSON.stringify({shell:s,shellArgs:o})),m.update(JSON.stringify(Object.entries(d.env||{}).sort(([D],[$])=>D.localeCompare($)))),m.digest("base64")}let t;function f(s,o){if(!t)if(L.$i)t=new A.$5_b;else if(L.$j)t=new A.$6_b;else if(L.$k)t=new A.$7_b;else throw new Error("external terminals not supported on this platform");const d=o.getConfiguration("terminal");return t.runInTerminal(s.title,s.cwd,s.args,s.env||{},d.external||{})}class l{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,d,m=!1){const $=[...this.b.entries()].map(([v,k])=>(0,u.$6g)(async C=>{if(v.name!==d||k.lastUsedAt!==-1&&await(0,g.$Lkc)(await v.processId))return null;const O=Date.now();return k.lastUsedAt+l.a>O||C.isCancellationRequested?null:k.config!==o?(m&&v.dispose(),null):(k.lastUsedAt=O,v)}));return await(0,u.$lh)($,v=>!!v)}insert(o,d){this.b.set(o,{lastUsedAt:Date.now(),config:d})}free(o){const d=this.b.get(o);d&&(d.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(Se[374],De([1,0,17,2,105,41,71,42,40,46,20,27,95,15,12,91,23,63,60]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;let i=class extends w.$hkc{constructor(a,t,f,l,s,o,d,m,D){super(a,t,f,l,s,o,d,m),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const l=w.TaskHandleDTO.from(f,this.C),s=await this.a.$getTaskExecution(l);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.z(s,t);return this.a.$executeTask(l).catch(()=>{}),o}else{const l=w.TaskDTO.from(t,a);if(l===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(l.execution)&&await this.y(l,t,!1);const s=await this.z(await this.a.$getTaskExecution(l),t);return this.a.$executeTask(l).catch(()=>{}),s}}v(a,t,f,l){const s=[];if(l)for(const o of l){this.A(o,f),(!o.definition||!a[o.definition.type])&&this.f.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const d=w.TaskDTO.from(o,f.extension);d&&(s.push(d),w.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,o,!0)))}return{tasks:s,extension:f.extension}}async w(a){return a}async G(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const f=L.URI.file((0,c.homedir)());t=new p.$Ai({uri:f,name:g.$Qg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const f=L.URI.revive(a),l={process:void 0,variables:Object.create(null)},s=await this.b.resolveWorkspaceFolder(f),o=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),m=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(o);for(const D of t.variables)l.variables[D]=await d.resolveAsync(m,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$tc);for(let $=0;$<D.length;$++)D[$]=await d.resolveAsync(m,D[$])}l.process=await M.win32.findExecutable(await d.resolveAsync(m,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(m,t.process.cwd):void 0,D)}return l}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,f){return M.win32.findExecutable(a,t,f)}};e.$Fkc=i,e.$Fkc=i=Je([qe(0,R.$xO),qe(1,I.$NO),qe(2,A.$Pic),qe(3,P.$IO),qe(4,b.$Sic),qe(5,E.$ejc),qe(6,y.$Mj),qe(7,h.$qic),qe(8,n.$ujc)],i)}),define(Se[375],De([1,0,63,60]),function(fe,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class M extends L.$vjc{m(){return(0,u.homedir)()}}e.$llc=M}),define(Se[158],De([1,0,19,8,22,44,15,17,23,2,36]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=e.$Pjc=e.$Ojc=void 0,e.$Qjc=h;class I{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],a=new M.$de(i);return new Promise((t,f)=>{this.a=new S(n);let l=!1;const s=(o,d)=>{if(!l&&!this.b){const m=this.h(o);h(o)&&typeof this.g.maxResults=="number"&&this.c+m>this.g.maxResults&&(this.b=!0,l=!0,a.cancel(),o=this.j(o,this.g.maxResults-this.c));const D=this.h(o);this.c+=D,(D>0||!h(o))&&this.a.add(o,d)}};Promise.all(r.map((o,d)=>this.k(o,m=>s(m,d),a.token))).then(o=>{a.dispose(),this.a.flush();const d=o.some(m=>!!m&&!!m.limitHit);t({limitHit:this.b||d,messages:(0,u.$Rb)(o.map(m=>m?.message?Array.isArray(m.message)?m.message:[m.message]:[])),stats:{type:this.f}})},o=>{a.dispose();const d=(0,A.$4i)(o);f(new Error(d))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],a=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:a.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const a=new R.$LK(this.g,n),t=[],f={report:o=>{if(!this.l(o))return;const d=n.folder.scheme===P.Schemas.file?(0,R.$MK)(()=>this.e.readdir(p.$Sg(o.uri))):void 0,m=p.$Vg(n.folder,o.uri);if(m){const D=a.includedInQuery(m,b.$nc(m),d);(0,L.$5g)(D)?t.push(D.then($=>{$&&i(o)})):D&&i(o)}}},l=this.n(n);let s;return this.d.query.type===3?s=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,l,f,r):s=await this.d.provider.provideTextSearchResults(w(this.d.query.contentPattern),l,f,r),t.length&&await Promise.all(t),s}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,R.$KK)(this.g.includePattern,n.includePattern),r=(0,R.$KK)(this.g.excludePattern,n.excludePattern),a={folder:E.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(a.usePCRE2=this.g.usePCRE2),a}}e.$Ojc=I;function w(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new g(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!p.$Mg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(y(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Pjc=S;function y(c){return h(c)?{preview:{matches:(0,u.$2b)(c.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:c.preview.text},ranges:(0,u.$2b)(c.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function h(c){return!!c.preview}class g{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Rjc=g}),define(Se[97],De([1,0,3,6,5,367,20,65,12,2,158]),function(fe,e,u,L,M,A,P,b,p,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=e.$Sjc=void 0,e.$Ujc=w,e.$Sjc=(0,M.$gi)("IExtHostSearch");let I=class{constructor(h,g,c){this.n=h,this.o=g,this.q=c,this.c=this.n.getProxy(L.$eM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$Njc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const c=this.d++;return this.e.set(c,g),this.c.$registerTextSearchProvider(c,this.s(h)),(0,u.$Rc)(()=>{this.g.delete(h),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(h,g){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const c=this.d++;return this.h.set(c,g),this.c.$registerAITextSearchProvider(c,this.s(h)),(0,u.$Rc)(()=>{this.i.delete(h),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(h,g){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const c=this.d++;return this.j.set(c,g),this.c.$registerFileSearchProvider(c,this.s(h)),(0,u.$Rc)(()=>{this.k.delete(h),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(h,g,c,n){const i=w(c),r=this.j.get(h);if(r)return this.l.fileSearch(i,r,a=>{this.c.$handleFileMatch(h,g,a.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,g,c){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,c,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const r=w(c);return this.t(r,i).search(t=>this.c.$handleTextMatch(h,g,t),n)}$provideAITextSearchResults(h,g,c,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const r=w(c);return this.v(r,i).search(t=>this.c.$handleTextMatch(h,g,t),n)}$enableExtensionHostSearch(){}t(h,g){return new R.$Ojc({query:h,provider:g},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(h,g){return new R.$Ojc({query:h,provider:g},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$Tjc=I,e.$Tjc=I=Je([qe(0,P.$xO),qe(1,b.$Mic),qe(2,p.$Mj)],I);function w(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(S),extraFileResources:y.extraFileResources&&y.extraFileResources.map(h=>E.URI.revive(h))}}function S(y){return{...y,folder:E.URI.revive(y.folder)}}}),define(Se[376],De([1,0,22,13,4,3,15,39,2,135,196,177,78,25,32,12,86,87,273,6,319,346,91,120,324,305,325,121,326,306,294,33,327,42,328,96,151,329,308,320,330,331,71,70,321,47,332,68,333,59,27,347,348,322,309,334,335,115,116,310,366,337,279,338,349,339,156,311,340,341,342,20,343,97,117,344,312,345,118,93,95,90,46,350,351,323,352,353,69,16,7,313,65,314,92,354,355,150,41,287,114,26,94]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f,l,s,o,d,m,D,$,v,k,C,O,B,z,T,j,N,F,K,ee,Y,Q,Z,ae,_,ge,se,re,U,ie,ye,le,ue,ce,de,H,x,he,pe,Ae,we,Pe,Fe,ze,q,V,J,X,me,ve,Te,He,Ze,tt,nt,at,rt,Ce,Be,Me,Ke,ne,oe,Ie,Ge,xe,st,Le,bt,St,It,Vt,qt,Ct,_t,Ht,si,ei,et,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=ti;function ti(dt){const $t=dt.get(re.$NO),ii=dt.get(se.$uic),Kt=dt.get(_.$Uic),Gt=dt.get(Z.$rjc),ht=dt.get(Ht.$Pic),Ot=dt.get(Be.$RO),ni=dt.get(C.$Sic),ri=dt.get(St.$Mic),Xe=dt.get(me.$xO),Nt=dt.get(at.$bjc),Bt=dt.get(rt.$Vic),Zt=dt.get(h.$Nj),mt=dt.get(h.$Mj),At=dt.get(xe.$OAb),Pt=dt.get(t.$qic),Tt=dt.get(_t.$wkc),oi=dt.get(He.$jjc),Ut=dt.get(Y.$5ic),xt=dt.get(H.$njc),vt=dt.get(f.$Aic),Ft=dt.get(d.$Fic);Xe.set(i.$fM.ExtHostFileSystemInfo,ii),Xe.set(i.$fM.ExtHostLogLevelServiceShape,Zt),Xe.set(i.$fM.ExtHostWorkspace,ht),Xe.set(i.$fM.ExtHostConfiguration,ni),Xe.set(i.$fM.ExtHostExtensionService,Gt),Xe.set(i.$fM.ExtHostStorage,Nt),Xe.set(i.$fM.ExtHostTunnelService,At),Xe.set(i.$fM.ExtHostWindow,Tt),Xe.set(i.$fM.ExtHostSecretState,oi),Xe.set(i.$fM.ExtHostTelemetry,Ot),Xe.set(i.$fM.ExtHostEditorTabs,Ut),Xe.set(i.$fM.ExtHostManagedSockets,xt),Xe.set(i.$fM.ExtHostAuthentication,vt),Xe.set(i.$fM.ExtHostChatProvider,Ft);const Wt=Xe.set(i.$fM.ExtHostDecorations,dt.get(z.$Cjc)),zt=Xe.set(i.$fM.ExtHostDocumentsAndEditors,dt.get(ee.$IO)),yt=Xe.set(i.$fM.ExtHostCommands,dt.get(v.$TO)),Mt=Xe.set(i.$fM.ExtHostTerminalService,dt.get(Me.$ejc)),Et=Xe.set(i.$fM.ExtHostDebugService,dt.get(B.$wjc)),li=Xe.set(i.$fM.ExtHostSearch,dt.get(Te.$Sjc)),Qt=Xe.set(i.$fM.ExtHostTask,dt.get(Ce.$jkc)),ci=Xe.set(i.$fM.ExtHostOutputService,dt.get(ze.$9jc)),Re=Xe.set(i.$fM.ExtHostLocalization,dt.get(de.$mjc)),Ne=Xe.set(i.$fM.ExtHostUrls,new It.$tkc(Xe)),ke=Xe.set(i.$fM.ExtHostDocuments,new K.$xic(Xe,zt)),te=Xe.set(i.$fM.ExtHostDocumentContentProviders,new N.$Ejc(Xe,zt,mt)),je=Xe.set(i.$fM.ExtHostDocumentSaveParticipant,new F.$Fjc(mt,ke,Xe.getProxy(i.$eM.MainThreadBulkEdits))),Ue=Xe.set(i.$fM.ExtHostNotebook,new he.$Vjc(Xe,yt,zt,ke,Kt,li)),_e=Xe.set(i.$fM.ExtHostNotebookDocuments,new Ae.$3jc(Ue)),Qe=Xe.set(i.$fM.ExtHostNotebookEditors,new we.$4jc(mt,Ue)),ut=Xe.set(i.$fM.ExtHostNotebookKernels,new Pe.$5jc(Xe,$t,Ue,yt,mt)),kt=Xe.set(i.$fM.ExtHostNotebookRenderers,new Fe.$7jc(Xe,Ue)),Jt=Xe.set(i.$fM.ExtHostNotebookDocumentSaveParticipant,new pe.$2jc(mt,Ue,Xe.getProxy(i.$eM.MainThreadBulkEdits))),Dt=Xe.set(i.$fM.ExtHostEditors,new ne.$Jic(Xe,zt)),Rt=Xe.set(i.$fM.ExtHostTreeViews,new Ge.$rkc(Xe.getProxy(i.$eM.MainThreadTreeViews),yt,mt)),Yt=Xe.set(i.$fM.ExtHostEditorInsets,new $.$Kic(Xe.getProxy(i.$eM.MainThreadEditorInsets),Dt,$t.remote)),bi=Xe.set(i.$fM.ExtHostDiagnostics,new T.$wic(Xe,mt,ii,zt)),yi=Xe.set(i.$fM.ExtHostLanguages,new ce.$Zjc(Xe,ke,yt.converter,ri)),ft=Xe.set(i.$fM.ExtHostLanguageFeatures,new ue.$yic(Xe,ri,ke,yt,bi,mt,Pt,Ot)),Mi=Xe.set(i.$fM.ExtHostFileSystem,new ae.$Hjc(Xe,ft)),fi=Xe.set(i.$fM.ExtHostFileSystemEventService,new ge.$Ijc(Xe,mt,zt)),$i=Xe.set(i.$fM.ExtHostQuickOpen,(0,X.$akc)(Xe,ht,yt)),ki=Xe.set(i.$fM.ExtHostSCM,new ve.$ckc(Xe,yt,ke,mt)),Ri=Xe.set(i.$fM.ExtHostQuickDiff,new J.$_jc(Xe,ri)),Oi=Xe.set(i.$fM.ExtHostShare,new Ze.$dkc(Xe,ri)),Ji=Xe.set(i.$fM.ExtHostComments,(0,k.$Lic)(Xe,yt,ke)),Xi=Xe.set(i.$fM.ExtHostProgress,new V.$$jc(Xe.getProxy(i.$eM.MainThreadProgress))),Qi=Xe.set(i.$fM.ExtHostLabelService,new le.$Yjc(Xe)),Ei=Xe.set(i.$fM.ExtHostTheming,new oe.$okc(Xe)),ji=Xe.set(i.$fM.ExtHostTimeline,new Ie.$qkc(Xe,yt)),Si=Xe.set(i.$fM.ExtHostWebviews,new Vt.$Zic(Xe,$t.remote,ht,mt,Pt)),Di=Xe.set(i.$fM.ExtHostWebviewPanels,new qt.$3ic(Xe,Si,ht)),Yi=Xe.set(i.$fM.ExtHostCustomEditors,new O.$4ic(Xe,ke,Bt,Si,Di)),Zi=Xe.set(i.$fM.ExtHostWebviewViews,new Ct.$ukc(Xe,Si)),wi=Xe.set(i.$fM.ExtHostTesting,new Ke.$kkc(Xe,mt,yt,zt)),ln=Xe.set(i.$fM.ExtHostUriOpeners,new bt.$skc(Xe)),hn=Xe.set(i.$fM.ExtHostProfileContentHandlers,new q.$0jc(Xe));Xe.set(i.$fM.ExtHostInteractive,new ie.$Wjc(Xe,Ue,zt,yt,mt));const Fi=Xe.set(i.$fM.ExtHostInlineChat,new U.$Jjc(Xe,yt,ke,mt)),Li=Xe.set(i.$fM.ExtHostChatAgents2,new o.$Eic(Xe,mt,yt)),dn=Xe.set(i.$fM.ExtHostChatVariables,new m.$Hic(Xe)),xi=Xe.set(i.$fM.ExtHostChat,new s.$Dic(Xe)),Ni=Xe.set(i.$fM.ExtHostAiRelatedInformation,new r.$pic(Xe)),fn=Xe.set(i.$fM.ExtHostAiEmbeddingVector,new Q.$Gjc(Xe)),Ci=Xe.set(i.$fM.ExtHostIssueReporter,new ye.$Xjc(Xe)),Ti=Xe.set(i.$fM.ExtHostStatusBar,new nt.$gkc(Xe,yt.converter)),_i=Xe.set(i.$fM.ExtHostSpeech,new tt.$ekc(Xe)),en=Object.values(i.$fM);Xe.assertRegistered(en);const gn=new l.$Cic(Xe,zt),zi=new D.$Iic(Xe),Ii=new x.$1jc(Xe,mt),hi=new j.$Djc(Xe);return a.$zic.register(yt),function(We,gi,ai){function ot($e){return(Ee,Ve,ct)=>{const wt=$e(jt=>{try{Ee.call(Ve,jt)}catch(Ai){L.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Ot.onExtensionError(We.identifier,Ai)}});return ct?.push(wt),wt}}const pt=function(){let $e=!We.isUnderDevelopment;function Ee(){$e||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ve(ct){if(Array.isArray(ct))ct.forEach(Ve);else if(typeof ct=="string")Ee();else{const wt=ct;typeof wt.scheme>"u"&&Ee(),typeof wt.exclusive=="boolean"&&(0,et.$4F)(We,"documentFiltersExclusive")}return ct}}(),tn={getSession($e,Ee,Ve){return typeof Ve?.forceNewSession=="object"&&Ve.forceNewSession.learnMore&&(0,et.$4F)(We,"authLearnMore"),vt.getSession(We,$e,Ee,Ve)},getSessions($e,Ee){return(0,et.$4F)(We,"authGetSessions"),vt.getSessions(We,$e,Ee)},async hasSession($e,Ee){return(0,et.$4F)(We,"authSession"),!!await vt.getSession(We,$e,Ee,{silent:!0})},get onDidChangeSessions(){return ot(vt.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,Ve,ct){return vt.registerAuthenticationProvider($e,Ee,Ve,ct)}},nn={registerCommand($e,Ee,Ve){return yt.registerCommand(!0,$e,Ee,Ve,void 0,We)},registerTextEditorCommand($e,Ee,Ve){return yt.registerCommand(!0,$e,(...ct)=>{const wt=Dt.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return wt.edit(jt=>{Ee.apply(Ve,[wt,jt,...ct])}).then(jt=>{jt||mt.warn("Edits from command "+$e+" were not applied.")},jt=>{mt.warn("An error occurred while running command "+$e,jt)})},void 0,void 0,We)},registerDiffInformationCommand:($e,Ee,Ve)=>((0,et.$4F)(We,"diffCommand"),yt.registerCommand(!0,$e,async(...ct)=>{const wt=zt.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const jt=await Dt.getDiffInformation(wt.id);Ee.apply(Ve,[jt,...ct])},void 0,void 0,We)),executeCommand($e,...Ee){return yt.executeCommand($e,...Ee)},getCommands($e=!1){return yt.getCommands($e)}},Bi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return Mt.getDefaultShell(!1)},get onDidChangeShell(){return ot(Mt.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$4F)(We,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$4F)(We,"telemetry"),ot(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.$QO)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Be.$PO.validateSender($e),Ot.instantiateLogger(We,$e,Ee)},openExternal($e,Ee){return Tt.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return Ne.createAppUri($e);try{return await Tt.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,P.$pg)($e,P.Schemas.http)||(0,P.$pg)($e,P.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,g.$sm)($t.remote.authority)},get remoteAuthority(){return(0,et.$4F)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return ot(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,et.$4F)(We,"handleIssueUri"),Ci.registerIssueUriRequestHandler(We,$e)},registerIssueDataProvider($e){return(0,et.$4F)(We,"handleIssueUri"),Ci.registerIssueDataProvider(We,$e)},get appQuality(){return(0,et.$4F)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$4F)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Bi);const mn={createTestController($e,Ee,Ve){return wi.createTestController(We,$e,Ee,Ve)},createTestObserver(){return(0,et.$4F)(We,"testObserver"),wi.createTestObserver()},runTests($e){return(0,et.$4F)(We,"testObserver"),wi.runTests($e)},get onDidChangeTestResults(){return(0,et.$4F)(We,"testObserver"),ot(wi.onResultsChanged)},get testResults(){return(0,et.$4F)(We,"testObserver"),wi.results}},vi=$t.remote.isRemote?Le.ExtensionKind.Workspace:Le.ExtensionKind.UI,rn={getExtension($e,Ee){(0,et.$3F)(We,"extensionsAny")||(Ee=!1);const Ve=gi.mine.getExtensionDescription($e);if(Ve)return new Z.$sjc(Gt,We.identifier,Ve,vi,!1);if(Ee){const ct=gi.all.getExtensionDescription($e);if(ct)return new Z.$sjc(Gt,We.identifier,ct,vi,!0)}},get all(){const $e=[];for(const Ee of gi.mine.getAllExtensionDescriptions())$e.push(new Z.$sjc(Gt,We.identifier,Ee,vi,!1));return $e},get allAcrossExtensionHosts(){(0,et.$4F)(We,"extensionsAny");const $e=new S.$Cm(gi.mine.getAllExtensionDescriptions().map(Ve=>Ve.identifier)),Ee=[];for(const Ve of gi.all.getAllExtensionDescriptions()){const ct=!$e.has(Ve.identifier);Ee.push(new Z.$sjc(Gt,We.identifier,Ve,vi,ct))}return Ee},get onDidChange(){return(0,et.$3F)(We,"extensionsAny")?ot(M.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):ot(gi.mine.onDidChange)}},$n={createDiagnosticCollection($e){return bi.createDiagnosticCollection(We.identifier,$e)},get onDidChangeDiagnostics(){return ot(bi.onDidChangeDiagnostics)},getDiagnostics:$e=>bi.getDiagnostics($e),getLanguages(){return yi.getLanguages()},setTextDocumentLanguage($e,Ee){return yi.changeLanguage($e.uri,Ee)},match($e,Ee){const Ve=st.LanguageSelector.from($e);let ct;return(0,R.$St)(Ve)&&(ct=Ue.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(jt=>jt.document===Ee))?.apiNotebook),(0,R.$Rt)(Ve,Ee.uri,Ee.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider($e,Ee,Ve){return ft.registerCodeActionProvider(We,pt($e),Ee,Ve)},registerDocumentPasteEditProvider($e,Ee,Ve){return(0,et.$4F)(We,"documentPaste"),ft.registerDocumentPasteEditProvider(We,pt($e),Ee,Ve)},registerCodeLensProvider($e,Ee){return ft.registerCodeLensProvider(We,pt($e),Ee)},registerDefinitionProvider($e,Ee){return ft.registerDefinitionProvider(We,pt($e),Ee)},registerDeclarationProvider($e,Ee){return ft.registerDeclarationProvider(We,pt($e),Ee)},registerImplementationProvider($e,Ee){return ft.registerImplementationProvider(We,pt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return ft.registerTypeDefinitionProvider(We,pt($e),Ee)},registerHoverProvider($e,Ee){return ft.registerHoverProvider(We,pt($e),Ee,We.identifier)},registerEvaluatableExpressionProvider($e,Ee){return ft.registerEvaluatableExpressionProvider(We,pt($e),Ee,We.identifier)},registerInlineValuesProvider($e,Ee){return ft.registerInlineValuesProvider(We,pt($e),Ee,We.identifier)},registerDocumentHighlightProvider($e,Ee){return ft.registerDocumentHighlightProvider(We,pt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return ft.registerMultiDocumentHighlightProvider(We,pt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return ft.registerLinkedEditingRangeProvider(We,pt($e),Ee)},registerReferenceProvider($e,Ee){return ft.registerReferenceProvider(We,pt($e),Ee)},registerRenameProvider($e,Ee){return ft.registerRenameProvider(We,pt($e),Ee)},registerNewSymbolNamesProvider($e,Ee){return(0,et.$4F)(We,"newSymbolNamesProvider"),ft.registerNewSymbolNamesProvider(We,pt($e),Ee)},registerDocumentSymbolProvider($e,Ee,Ve){return ft.registerDocumentSymbolProvider(We,pt($e),Ee,Ve)},registerWorkspaceSymbolProvider($e){return ft.registerWorkspaceSymbolProvider(We,$e)},registerDocumentFormattingEditProvider($e,Ee){return ft.registerDocumentFormattingEditProvider(We,pt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return ft.registerDocumentRangeFormattingEditProvider(We,pt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,Ve,...ct){return ft.registerOnTypeFormattingEditProvider(We,pt($e),Ee,[Ve].concat(ct))},registerDocumentSemanticTokensProvider($e,Ee,Ve){return ft.registerDocumentSemanticTokensProvider(We,pt($e),Ee,Ve)},registerDocumentRangeSemanticTokensProvider($e,Ee,Ve){return ft.registerDocumentRangeSemanticTokensProvider(We,pt($e),Ee,Ve)},registerSignatureHelpProvider($e,Ee,Ve,...ct){return typeof Ve=="object"?ft.registerSignatureHelpProvider(We,pt($e),Ee,Ve):ft.registerSignatureHelpProvider(We,pt($e),Ee,typeof Ve>"u"?[]:[Ve,...ct])},registerCompletionItemProvider($e,Ee,...Ve){return ft.registerCompletionItemProvider(We,pt($e),Ee,Ve)},registerInlineCompletionItemProvider($e,Ee,Ve){return Ee.handleDidShowCompletionItem&&(0,et.$4F)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$4F)(We,"inlineCompletionsAdditions"),Ve&&(0,et.$4F)(We,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(We,pt($e),Ee,Ve)},registerInlineEditProvider($e,Ee){return(0,et.$4F)(We,"inlineEdit"),ft.registerInlineEditProvider(We,pt($e),Ee)},registerDocumentLinkProvider($e,Ee){return ft.registerDocumentLinkProvider(We,pt($e),Ee)},registerColorProvider($e,Ee){return ft.registerColorProvider(We,pt($e),Ee)},registerFoldingRangeProvider($e,Ee){return ft.registerFoldingRangeProvider(We,pt($e),Ee)},registerSelectionRangeProvider($e,Ee){return ft.registerSelectionRangeProvider(We,$e,Ee)},registerCallHierarchyProvider($e,Ee){return ft.registerCallHierarchyProvider(We,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return ft.registerTypeHierarchyProvider(We,$e,Ee)},setLanguageConfiguration:($e,Ee)=>ft.setLanguageConfiguration(We,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,et.$4F)(We,"tokenInformation"),yi.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return ft.registerInlayHintsProvider(We,$e,Ee)},createLanguageStatusItem($e,Ee){return yi.createLanguageStatusItem(We,$e,Ee)},registerDocumentDropEditProvider($e,Ee,Ve){return ft.registerDocumentOnDropEditProvider(We,$e,Ee,(0,et.$3F)(We,"dropMetadata")?Ve:void 0)}},pn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return Mt.activeTerminal},get terminals(){return Mt.terminals},async showTextDocument($e,Ee,Ve){p.URI.isUri($e)&&$e.scheme===P.Schemas.vscodeRemote&&!$e.authority&&Pt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(p.URI.isUri($e)?Promise.resolve(Ui.openTextDocument($e)):Promise.resolve($e));return Dt.showTextDocument(ct,Ee,Ve)},createTextEditorDecorationType($e){return Dt.createTextEditorDecorationType(We,$e)},onDidChangeActiveTextEditor($e,Ee,Ve){return ot(Dt.onDidChangeActiveTextEditor)($e,Ee,Ve)},onDidChangeVisibleTextEditors($e,Ee,Ve){return ot(Dt.onDidChangeVisibleTextEditors)($e,Ee,Ve)},onDidChangeTextEditorSelection($e,Ee,Ve){return ot(Dt.onDidChangeTextEditorSelection)($e,Ee,Ve)},onDidChangeTextEditorOptions($e,Ee,Ve){return ot(Dt.onDidChangeTextEditorOptions)($e,Ee,Ve)},onDidChangeTextEditorVisibleRanges($e,Ee,Ve){return ot(Dt.onDidChangeTextEditorVisibleRanges)($e,Ee,Ve)},onDidChangeTextEditorViewColumn($e,Ee,Ve){return ot(Dt.onDidChangeTextEditorViewColumn)($e,Ee,Ve)},onDidCloseTerminal($e,Ee,Ve){return ot(Mt.onDidCloseTerminal)($e,Ee,Ve)},onDidOpenTerminal($e,Ee,Ve){return ot(Mt.onDidOpenTerminal)($e,Ee,Ve)},onDidChangeActiveTerminal($e,Ee,Ve){return ot(Mt.onDidChangeActiveTerminal)($e,Ee,Ve)},onDidChangeTerminalDimensions($e,Ee,Ve){return(0,et.$4F)(We,"terminalDimensions"),ot(Mt.onDidChangeTerminalDimensions)($e,Ee,Ve)},onDidChangeTerminalState($e,Ee,Ve){return ot(Mt.onDidChangeTerminalState)($e,Ee,Ve)},onDidWriteTerminalData($e,Ee,Ve){return(0,et.$4F)(We,"terminalDataWriteEvent"),ot(Mt.onDidWriteTerminalData)($e,Ee,Ve)},onDidExecuteTerminalCommand($e,Ee,Ve){return(0,et.$4F)(We,"terminalExecuteCommandEvent"),ot(Mt.onDidExecuteTerminalCommand)($e,Ee,Ve)},get state(){return Tt.getState(We)},onDidChangeWindowState($e,Ee,Ve){return ot(Tt.onDidChangeWindowState)($e,Ee,Ve)},showInformationMessage($e,...Ee){return Ii.showMessage(We,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return Ii.showMessage(We,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return Ii.showMessage(We,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,Ve){return $i.showQuickPick(We,$e,Ee,Ve)},showWorkspaceFolderPick($e){return $i.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return $i.showInput($e,Ee)},showOpenDialog($e){return hi.showOpenDialog(We,$e)},showSaveDialog($e){return hi.showSaveDialog($e)},createStatusBarItem($e,Ee,Ve){let ct,wt,jt;return typeof $e=="string"?(ct=$e,wt=Ee,jt=Ve):(wt=$e,jt=Ee),Ti.createStatusBarEntry(We,ct,wt,jt)},setStatusBarMessage($e,Ee){return Ti.setStatusBarMessage($e,Ee)},withScmProgress($e){return Pt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Xi.withProgress(We,{location:Le.ProgressLocation.SourceControl},(Ee,Ve)=>$e({report(ct){}}))},withProgress($e,Ee){return Xi.withProgress(We,$e,Ee)},createOutputChannel($e,Ee){return ci.createOutputChannel($e,Ee,We)},createWebviewPanel($e,Ee,Ve,ct){return Di.createWebviewPanel(We,$e,Ee,Ve,ct)},createWebviewTextEditorInset($e,Ee,Ve,ct){return(0,et.$4F)(We,"editorInsets"),Yt.createWebviewEditorInset($e,Ee,Ve,ct,We)},createTerminal($e,Ee,Ve){return typeof $e=="object"?"pty"in $e?Mt.createExtensionTerminal($e):Mt.createTerminalFromOptions($e):Mt.createTerminal($e,Ee,Ve)},registerTerminalLinkProvider($e){return Mt.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return Mt.registerProfileProvider(We,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,et.$4F)(We,"terminalQuickFixProvider"),Mt.registerTerminalQuickFixProvider($e,We.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return Rt.registerTreeDataProvider($e,Ee,We)},createTreeView($e,Ee){return Rt.createTreeView($e,Ee,We)},registerWebviewPanelSerializer:($e,Ee)=>Di.registerWebviewPanelSerializer(We,$e,Ee),registerCustomEditorProvider:($e,Ee,Ve={})=>Yi.registerCustomEditorProvider(We,$e,Ee,Ve),registerFileDecorationProvider($e){return Wt.registerFileDecorationProvider($e,We)},registerUriHandler($e){return Ne.registerUriHandler(We,$e)},createQuickPick(){return $i.createQuickPick(We)},createInputBox(){return $i.createInputBox(We)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,Ve){return ot(Ei.onDidChangeActiveColorTheme)($e,Ee,Ve)},registerWebviewViewProvider($e,Ee,Ve){return Zi.registerWebviewViewProvider(We,$e,Ee,Ve?.webviewOptions)},get activeNotebookEditor(){return Ue.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,Ve){return ot(Ue.onDidChangeActiveNotebookEditor)($e,Ee,Ve)},get visibleNotebookEditors(){return Ue.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Ue.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,Ve){return ot(Qe.onDidChangeNotebookEditorSelection)($e,Ee,Ve)},onDidChangeNotebookEditorVisibleRanges($e,Ee,Ve){return ot(Qe.onDidChangeNotebookEditorVisibleRanges)($e,Ee,Ve)},showNotebookDocument($e,Ee){return Ue.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,Ve){return(0,et.$4F)(We,"externalUriOpener"),ln.registerExternalUriOpener(We.identifier,$e,Ee,Ve)},registerProfileContentHandler($e,Ee){return(0,et.$4F)(We,"profileContentHandlers"),hn.registerProfileContentHandler(We,$e,Ee)},registerQuickDiffProvider($e,Ee,Ve,ct){return(0,et.$4F)(We,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt($e),Ee,Ve,ct)},get tabGroups(){return Ut.tabGroups},registerShareProvider($e,Ee){return(0,et.$4F)(We,"shareProvider"),Oi.registerShareProvider(pt($e),Ee)}},Ui={get rootPath(){return Pt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath($e){throw new L.$9("rootPath")},getWorkspaceFolder($e){return ht.getWorkspaceFolder($e)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name($e){throw new L.$9("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile($e){throw new L.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...Ve)=>ht.updateWorkspaceFolders(We,$e,Ee||0,...Ve),onDidChangeWorkspaceFolders:function($e,Ee,Ve){return ot(ht.onDidChangeWorkspace)($e,Ee,Ve)},asRelativePath:($e,Ee)=>ht.getRelativePath($e,Ee),findFiles:($e,Ee,Ve,ct)=>ht.findFiles($e,Ee,Ve,We.identifier,ct),findFiles2:($e,Ee,Ve)=>((0,et.$4F)(We,"findFiles2"),ht.findFiles2($e,Ee,We.identifier,Ve)),findTextInFiles:($e,Ee,Ve,ct)=>{(0,et.$4F)(We,"findTextInFiles");let wt,jt;return typeof Ee=="object"?(wt=Ee,jt=Ve):(wt={},jt=Ee,ct=Ve),ht.findTextInFiles($e,wt||{},jt,We.identifier,ct)},save:$e=>ht.save($e),saveAs:$e=>ht.saveAs($e),saveAll:$e=>ht.saveAll($e),applyEdit($e,Ee){return gn.applyWorkspaceEdit($e,We,Ee)},createFileSystemWatcher:($e,Ee,Ve,ct)=>{let wt;return typeof Ee=="boolean"?wt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ve,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,et.$4F)(We,"createFileSystemWatcher"),wt={...Ee,correlate:!0}),fi.createFileSystemWatcher(ht,We,$e,wt)},get textDocuments(){return ke.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new L.$9("textDocuments")},openTextDocument($e){let Ee;const Ve=$e;if(typeof $e=="string")Ee=Promise.resolve(p.URI.file($e));else if(p.URI.isUri($e))Ee=Promise.resolve($e);else if(!Ve||typeof Ve=="object")Ee=ke.createDocumentData(Ve);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>(ct.scheme===P.Schemas.vscodeRemote&&!ct.authority&&Pt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),ke.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:($e,Ee,Ve)=>ot(ke.onDidAddDocument)($e,Ee,Ve),onDidCloseTextDocument:($e,Ee,Ve)=>ot(ke.onDidRemoveDocument)($e,Ee,Ve),onDidChangeTextDocument:($e,Ee,Ve)=>ot(ke.onDidChangeDocument)($e,Ee,Ve),onDidSaveTextDocument:($e,Ee,Ve)=>ot(ke.onDidSaveDocument)($e,Ee,Ve),onWillSaveTextDocument:($e,Ee,Ve)=>ot(je.getOnWillSaveTextDocumentEvent(We))($e,Ee,Ve),get notebookDocuments(){return Ue.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let Ve;if(p.URI.isUri($e))Ve=$e,await Ue.openNotebookDocument($e);else if(typeof $e=="string")Ve=p.URI.revive(await Ue.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Ue.getNotebookDocument(Ve).apiNotebook},onDidSaveNotebookDocument($e,Ee,Ve){return ot(_e.onDidSaveNotebookDocument)($e,Ee,Ve)},onDidChangeNotebookDocument($e,Ee,Ve){return ot(_e.onDidChangeNotebookDocument)($e,Ee,Ve)},onWillSaveNotebookDocument($e,Ee,Ve){return ot(Jt.getOnWillSaveNotebookDocumentEvent(We))($e,Ee,Ve)},get onDidOpenNotebookDocument(){return ot(Ue.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Ue.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,Ve,ct){return Ue.registerNotebookSerializer(We,$e,Ee,Ve,(0,et.$3F)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:($e,Ee,Ve)=>ot(ai.onDidChangeConfiguration)($e,Ee,Ve),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,ai.getConfiguration($e,Ee,We)},registerTextDocumentContentProvider($e,Ee){return te.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Pt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(We,$e,Ee)),registerFileSystemProvider($e,Ee,Ve){return(0,A.$Qc)(Mi.registerFileSystemProvider(We,$e,Ee,Ve),Kt.addFileSystemProvider($e,Ee,Ve))},get fs(){return Kt.value},registerFileSearchProvider:($e,Ee)=>((0,et.$4F)(We,"fileSearchProvider"),li.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,et.$4F)(We,"textSearchProvider"),li.registerTextSearchProvider($e,Ee)),registerAITextSearchProvider:($e,Ee)=>((0,et.$4F)(We,"aiTextSearchProvider"),(0,et.$4F)(We,"textSearchProvider"),li.registerAITextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,et.$4F)(We,"resolvers"),Gt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,et.$4F)(We,"resolvers"),Qi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,et.$4F)(We,"resolvers"),Gt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,Ve)=>ot(fi.onDidCreateFile)($e,Ee,Ve),onDidDeleteFiles:($e,Ee,Ve)=>ot(fi.onDidDeleteFile)($e,Ee,Ve),onDidRenameFiles:($e,Ee,Ve)=>ot(fi.onDidRenameFile)($e,Ee,Ve),onWillCreateFiles:($e,Ee,Ve)=>ot(fi.getOnWillCreateFileEvent(We))($e,Ee,Ve),onWillDeleteFiles:($e,Ee,Ve)=>ot(fi.getOnWillDeleteFileEvent(We))($e,Ee,Ve),onWillRenameFiles:($e,Ee,Ve)=>ot(fi.getOnWillRenameFileEvent(We))($e,Ee,Ve),openTunnel:$e=>((0,et.$4F)(We,"tunnels"),At.openTunnel(We,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$4F)(We,"tunnels"),At.getTunnels()},onDidChangeTunnels:($e,Ee,Ve)=>((0,et.$4F)(We,"tunnels"),ot(At.onDidChangeTunnels)($e,Ee,Ve)),registerPortAttributesProvider:($e,Ee)=>((0,et.$4F)(We,"portsAttributes"),At.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,et.$4F)(We,"tunnelFactory"),At.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,et.$4F)(We,"timeline"),ji.registerTimelineProvider($e,Ee,We.identifier,yt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:$e=>((0,et.$4F)(We,"workspaceTrust"),ht.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,Ve)=>ot(ht.onDidGrantWorkspaceTrust)($e,Ee,Ve),registerEditSessionIdentityProvider:($e,Ee)=>((0,et.$4F)(We,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,Ve)=>((0,et.$4F)(We,"editSessionIdentityProvider"),ot(ht.getOnWillCreateEditSessionIdentityEvent(We))($e,Ee,Ve)),registerCanonicalUriProvider:($e,Ee)=>((0,et.$4F)(We,"canonicalUriProvider"),ht.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,Ve)=>((0,et.$4F)(We,"canonicalUriProvider"),ht.provideCanonicalUri($e,Ee,Ve))},Wi={get inputBox(){return Pt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(We)},createSourceControl($e,Ee,Ve){return ki.createSourceControl(We,$e,Ee,Ve)}},sn={createCommentController($e,Ee){return Ji.createCommentController(We,$e,Ee)}},on={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,et.$3F)(We,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider($e,Ee){return(0,et.$4F)(We,"debugVisualization"),Et.registerDebugVisualizationProvider(We,$e,Ee)},registerDebugVisualizationTreeProvider($e,Ee){return(0,et.$4F)(We,"debugVisualization"),Et.registerDebugVisualizationTree(We,$e,Ee)},onDidStartDebugSession($e,Ee,Ve){return ot(Et.onDidStartDebugSession)($e,Ee,Ve)},onDidTerminateDebugSession($e,Ee,Ve){return ot(Et.onDidTerminateDebugSession)($e,Ee,Ve)},onDidChangeActiveDebugSession($e,Ee,Ve){return ot(Et.onDidChangeActiveDebugSession)($e,Ee,Ve)},onDidReceiveDebugSessionCustomEvent($e,Ee,Ve){return ot(Et.onDidReceiveDebugSessionCustomEvent)($e,Ee,Ve)},onDidChangeBreakpoints($e,Ee,Ve){return ot(Et.onDidChangeBreakpoints)($e,Ee,Ve)},onDidChangeActiveStackItem($e,Ee,Ve){return(0,et.$4F)(We,"debugFocus"),ot(Et.onDidChangeActiveStackItem)($e,Ee,Ve)},registerDebugConfigurationProvider($e,Ee,Ve){return Et.registerDebugConfigurationProvider($e,Ee,Ve||si.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return Et.registerDebugAdapterDescriptorFactory(We,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return Et.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,Ve){return!Ve||typeof Ve=="object"&&"configuration"in Ve?Et.startDebugging($e,Ee,{parentSession:Ve}):Et.startDebugging($e,Ee,Ve||{})},stopDebugging($e){return Et.stopDebugging($e)},addBreakpoints($e){return Et.addBreakpoints($e)},removeBreakpoints($e){return Et.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return Et.asDebugSourceUri($e,Ee)}},an={registerTaskProvider:($e,Ee)=>Qt.registerTaskProvider(We,$e,Ee),fetchTasks:$e=>Qt.fetchTasks($e),executeTask:$e=>Qt.executeTask(We,$e),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:($e,Ee,Ve)=>ot(Qt.onDidStartTask)($e,Ee,Ve),onDidEndTask:($e,Ee,Ve)=>ot(Qt.onDidEndTask)($e,Ee,Ve),onDidStartTaskProcess:($e,Ee,Ve)=>ot(Qt.onDidStartTaskProcess)($e,Ee,Ve),onDidEndTaskProcess:($e,Ee,Ve)=>ot(Qt.onDidEndTaskProcess)($e,Ee,Ve)},bn={createNotebookController($e,Ee,Ve,ct,wt){return ut.createNotebookController(We,$e,Ee,Ve,ct,(0,et.$3F)(We,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Ue.registerNotebookCellStatusBarItemProvider(We,$e,Ee),createRendererMessaging($e){return kt.createRendererMessaging(We,$e)},createNotebookControllerDetectionTask($e){return(0,et.$4F)(We,"notebookKernelSource"),ut.createNotebookControllerDetectionTask(We,$e)},registerKernelSourceActionProvider($e,Ee){return(0,et.$4F)(We,"notebookKernelSource"),ut.registerKernelSourceActionProvider(We,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,Ve){return(0,et.$4F)(We,"notebookCellExecutionState"),ot(ut.onDidChangeNotebookCellExecutionState)($e,Ee,Ve)}},wn={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),Ve=!$e||typeof $e[0]!="object"?$e:$e[0];return Re.getMessage(We.identifier.value,{message:Ee,args:Ve})}return Re.getMessage(We.identifier.value,$e[0])},get bundle(){return Re.getBundle(We.identifier.value)},get uri(){return Re.getBundleUri(We.identifier.value)}},cn={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,et.$4F)(We,"interactive"),Fi.registerProvider(We,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,et.$4F)(We,"interactive"),xi.registerChatProvider(We,$e,Ee)},transferChatSession($e,Ee){return(0,et.$4F)(We,"interactive"),xi.transferChatSession($e,Ee)}},un={getRelatedInformation($e,Ee){return(0,et.$4F)(We,"aiRelatedInformation"),Ni.getRelatedInformation(We,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,et.$4F)(We,"aiRelatedInformation"),Ni.registerRelatedInformationProvider(We,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,et.$4F)(We,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(We,$e,Ee)}},Vi={registerChatResponseProvider($e,Ee,Ve){return(0,et.$4F)(We,"chatProvider"),Ft.registerLanguageModel(We,$e,Ee,Ve)},registerChatVariableResolver($e,Ee,Ve){return(0,et.$4F)(We,"chatVariableResolver"),dn.registerVariableResolver(We,$e,Ee,Ve)},registerMappedEditsProvider($e,Ee){return(0,et.$4F)(We,"mappedEditsProvider"),ft.registerMappedEditsProvider(We,$e,Ee)},createChatParticipant($e,Ee){return(0,et.$4F)(We,"chatParticipant"),Li.createChatAgent(We,$e,Ee)}},qi={get languageModels(){return(0,et.$4F)(We,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:($e,Ee,Ve)=>((0,et.$4F)(We,"languageModels"),Ft.onDidChangeProviders($e,Ee,Ve)),sendChatRequest($e,Ee,Ve,ct){return(0,et.$4F)(We,"languageModels"),Ft.sendChatRequest(We,$e,Ee,Ve,ct)}},Hi={registerSpeechProvider($e,Ee){return(0,et.$4F)(We,"speech"),_i.registerProvider(We.identifier,$e,Ee)}};return{version:$t.version,ai:un,authentication:tn,commands:nn,comments:sn,chat:Vi,debug:on,env:Bi,extensions:rn,interactive:cn,l10n:wn,languages:$n,lm:qi,notebooks:bn,scm:Wi,speech:Hi,tasks:an,tests:mn,window:pn,workspace:Ui,Breakpoint:Le.$gN,TerminalOutputAnchor:Le.TerminalOutputAnchor,ChatResultFeedbackKind:Le.ChatResultFeedbackKind,ChatVariableLevel:Le.ChatVariableLevel,ChatCompletionItem:Le.$_N,CallHierarchyIncomingCall:Le.$EM,CallHierarchyItem:Le.$DM,CallHierarchyOutgoingCall:Le.$FM,CancellationError:L.$5,CancellationTokenSource:u.$de,CandidatePortSource:i.CandidatePortSource,CodeAction:Le.$AM,CodeActionKind:Le.$BM,CodeActionTriggerKind:Le.CodeActionTriggerKind,CodeLens:Le.$GM,Color:Le.$TM,ColorInformation:Le.$UM,ColorPresentation:Le.$VM,ColorThemeKind:Le.ColorThemeKind,CommentMode:Le.CommentMode,CommentState:Le.CommentState,CommentThreadCollapsibleState:Le.CommentThreadCollapsibleState,CommentThreadState:Le.CommentThreadState,CompletionItem:Le.$NM,CompletionItemKind:Le.CompletionItemKind,CompletionItemTag:Le.CompletionItemTag,CompletionList:Le.$OM,CompletionTriggerKind:Le.CompletionTriggerKind,ConfigurationTarget:Le.ConfigurationTarget,CustomExecution:Le.$4M,DebugAdapterExecutable:Le.$kN,DebugAdapterInlineImplementation:Le.$nN,DebugAdapterNamedPipeServer:Le.$mN,DebugAdapterServer:Le.$lN,DebugConfigurationProviderTriggerKind:si.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Le.DebugConsoleMode,DebugVisualization:Le.$DN,DecorationRangeBehavior:Le.DecorationRangeBehavior,Diagnostic:Le.$uM,DiagnosticRelatedInformation:Le.$tM,DiagnosticSeverity:Le.DiagnosticSeverity,DiagnosticTag:Le.DiagnosticTag,Disposable:Le.$gM,DocumentHighlight:Le.$wM,DocumentHighlightKind:Le.DocumentHighlightKind,MultiDocumentHighlight:Le.$xM,DocumentLink:Le.$SM,DocumentSymbol:Le.$zM,EndOfLine:Le.EndOfLine,EnvironmentVariableMutatorType:Le.EnvironmentVariableMutatorType,EvaluatableExpression:Le.$qN,InlineValueText:Le.$rN,InlineValueVariableLookup:Le.$sN,InlineValueEvaluatableExpression:Le.$tN,InlineCompletionTriggerKind:Le.InlineCompletionTriggerKind,EventEmitter:M.$6d,ExtensionKind:Le.ExtensionKind,ExtensionMode:Le.ExtensionMode,ExternalUriOpenerPriority:Le.ExternalUriOpenerPriority,FileChangeType:Le.FileChangeType,FileDecoration:Le.$FN,FileDecoration2:Le.$FN,FileSystemError:Le.$wN,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:Le.$xN,FoldingRangeKind:Le.FoldingRangeKind,FunctionBreakpoint:Le.$iN,InlineCompletionItem:Le.$PM,InlineCompletionList:Le.$QM,Hover:Le.$vM,IndentAction:I.IndentAction,Location:Le.$sM,MarkdownString:Le.$HM,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:Le.$IM,PortAutoForwardAction:Le.PortAutoForwardAction,Position:Le.$hM,ProcessExecution:Le.$2M,ProgressLocation:Le.ProgressLocation,QuickInputButtons:Le.$EN,Range:Le.$iM,RelativePattern:Le.$eN,Selection:Le.$jM,SelectionRange:Le.$CM,SemanticTokens:Le.$AN,SemanticTokensBuilder:Le.$zN,SemanticTokensEdit:Le.$BN,SemanticTokensEdits:Le.$CN,SemanticTokensLegend:Le.$yN,ShellExecution:Le.$3M,ShellQuoting:Le.ShellQuoting,SignatureHelp:Le.$KM,SignatureHelpTriggerKind:Le.SignatureHelpTriggerKind,SignatureInformation:Le.$JM,SnippetString:Le.$rM,SourceBreakpoint:Le.$hN,StandardTokenType:Le.StandardTokenType,StatusBarAlignment:Le.StatusBarAlignment,SymbolInformation:Le.$yM,SymbolKind:Le.SymbolKind,SymbolTag:Le.SymbolTag,Task:Le.$5M,TaskGroup:Le.$1M,TaskPanelKind:Le.TaskPanelKind,TaskRevealKind:Le.TaskRevealKind,TaskScope:Le.TaskScope,TerminalLink:Le.$WM,TerminalQuickFixTerminalCommand:Le.$YM,TerminalQuickFixOpener:Le.$XM,TerminalLocation:Le.TerminalLocation,TerminalProfile:Le.$ZM,TerminalExitReason:Le.TerminalExitReason,TextDocumentSaveReason:Le.TextDocumentSaveReason,TextEdit:Le.$nM,SnippetTextEdit:Le.$pM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Le.TextEditorLineNumbersStyle,TextEditorRevealType:Le.TextEditorRevealType,TextEditorSelectionChangeKind:Le.TextEditorSelectionChangeKind,SyntaxTokenType:Le.SyntaxTokenType,TextDocumentChangeReason:Le.TextDocumentChangeReason,ThemeColor:Le.$dN,ThemeIcon:Le.$cN,TreeItem:Le.$6M,TreeItemCheckboxState:Le.TreeItemCheckboxState,TreeItemCollapsibleState:Le.TreeItemCollapsibleState,TypeHierarchyItem:Le.$1N,UIKind:ei.UIKind,Uri:p.URI,ViewColumn:Le.ViewColumn,WorkspaceEdit:Le.$qM,DocumentPasteTriggerKind:Le.DocumentPasteTriggerKind,DocumentDropEdit:Le.$_M,DocumentPasteEditKind:Le.$aN,DocumentPasteEdit:Le.$bN,InlayHint:Le.$MM,InlayHintLabelPart:Le.$LM,InlayHintKind:Le.InlayHintKind,RemoteAuthorityResolverError:Le.$mM,ResolvedAuthority:Le.$kM,ManagedResolvedAuthority:Le.$lM,SourceControlInputBoxValidationType:Le.SourceControlInputBoxValidationType,ExtensionRuntime:Le.ExtensionRuntime,TimelineItem:Le.$PN,NotebookRange:Le.$HN,NotebookCellKind:Le.NotebookCellKind,NotebookCellExecutionState:Le.NotebookCellExecutionState,NotebookCellData:Le.$IN,NotebookData:Le.$JN,NotebookRendererScript:Le.$NN,NotebookCellStatusBarAlignment:Le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Le.NotebookEditorRevealType,NotebookCellOutput:Le.$LN,NotebookCellOutputItem:Le.$KN,NotebookCellStatusBarItem:Le.$MN,NotebookControllerAffinity:Le.NotebookControllerAffinity,NotebookControllerAffinity2:Le.NotebookControllerAffinity2,NotebookEdit:Le.$oM,NotebookKernelSourceAction:Le.$ON,NotebookVariablesRequestKind:Le.NotebookVariablesRequestKind,PortAttributes:Le.$RN,LinkedEditingRanges:Le.$QN,TestResultState:Le.TestResultState,TestRunRequest:Le.$SN,TestMessage:Le.$TN,TestTag:Le.$UN,TestRunProfileKind:Le.TestRunProfileKind,TextSearchCompleteMessageType:Lt.TextSearchCompleteMessageType,DataTransfer:Le.$$M,DataTransferItem:Le.$7M,CoveredCount:Le.$VN,FileCoverage:Le.$WN,StatementCoverage:Le.$XN,BranchCoverage:Le.$YN,DeclarationCoverage:Le.$ZN,FunctionCoverage:Le.$ZN,WorkspaceTrustState:Le.WorkspaceTrustState,LanguageStatusSeverity:Le.LanguageStatusSeverity,QuickPickItemKind:Le.QuickPickItemKind,InputBoxValidationSeverity:Le.InputBoxValidationSeverity,TabInputText:Le.$2N,TabInputTextDiff:Le.$3N,TabInputTextMerge:Le.$4N,TabInputCustom:Le.$5N,TabInputNotebook:Le.$7N,TabInputNotebookDiff:Le.$8N,TabInputWebview:Le.$6N,TabInputTerminal:Le.$9N,TabInputInteractiveWindow:Le.$0N,TabInputChat:Le.$$N,TelemetryTrustedValue:c.$2o,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Le.InteractiveSessionVoteDirection,ChatCopyKind:Le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Le.InteractiveEditorResponseFeedbackKind,StackFrame:Le.$oN,Thread:Le.$pN,RelatedInformationType:Le.RelatedInformationType,SpeechToTextStatus:Le.SpeechToTextStatus,PartialAcceptTriggerKind:Le.PartialAcceptTriggerKind,KeywordRecognitionStatus:Le.KeywordRecognitionStatus,ChatResponseMarkdownPart:Le.$aO,ChatResponseFileTreePart:Le.$bO,ChatResponseAnchorPart:Le.$cO,ChatResponseProgressPart:Le.$dO,ChatResponseReferencePart:Le.$fO,ChatResponseCommandButtonPart:Le.$eO,ChatRequestTurn:Le.$gO,ChatResponseTurn:Le.$hO,LanguageModelChatSystemMessage:Le.$iO,LanguageModelChatUserMessage:Le.$jO,LanguageModelChatAssistantMessage:Le.$kO,LanguageModelSystemMessage:Le.$iO,LanguageModelUserMessage:Le.$jO,LanguageModelAssistantMessage:Le.$kO,LanguageModelError:Le.$lO,NewSymbolName:Le.$vN,NewSymbolNameTag:Le.NewSymbolNameTag,InlineEdit:Le.$mO,InlineEditTriggerKind:Le.InlineEditTriggerKind}}}}),define(Se[377],De([1,0,83,156,41,151,42,33,71,46,95,96,97,118,69,91,150,68,59,117,90,70,149,12,60,115,116,120,121]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f,l,s,o,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$cs)(s.$mjc,s.$ljc,1),(0,u.$cs)(f.$Nj,t.$ykc,1),(0,u.$cs)(h.$qic,h.$ric,1),(0,u.$cs)(b.$TO,b.$SO,0),(0,u.$cs)(d.$Aic,d.$Bic,0),(0,u.$cs)(m.$Fic,m.$Gic,0),(0,u.$cs)(P.$Sic,P.$Qic,0),(0,u.$cs)(c.$Uic,c.$Tic,0),(0,u.$cs)(I.$wjc,I.$Ajc,0),(0,u.$cs)(A.$Cjc,A.$Bjc,0),(0,u.$cs)(p.$IO,p.$HO,0),(0,u.$cs)(o.$njc,o.$ojc,0),(0,u.$cs)(n.$uic,n.$tic,0),(0,u.$cs)(L.$9jc,L.$8jc,1),(0,u.$cs)(w.$Sjc,w.$Tjc,0),(0,u.$cs)(S.$bjc,S.$ajc,0),(0,u.$cs)(R.$jkc,R.$ikc,0),(0,u.$cs)(E.$ejc,E.$hjc,0),(0,u.$cs)(y.$OAb,y.$PAb,0),(0,u.$cs)(g.$wkc,g.$vkc,0),(0,u.$cs)(M.$Pic,M.$Oic,0),(0,u.$cs)(i.$jjc,i.$ijc,0),(0,u.$cs)(r.$RO,r.$OO,0),(0,u.$cs)(a.$5ic,a.$6ic,0),(0,u.$cs)(l.$ujc,l.$vjc,0)}),define(Se[122],De([1,0,19,12,36,94]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0,e.$Okc=P,e.$Pkc=b;function P(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,w,S,y){const h=(0,u.$2b)(S,p),g=new M.$xK(w,h,y),c=g.preview.matches;return{ranges:(0,u.$2b)(h,E),uri:I,preview:{text:g.preview.text,matches:(0,u.$2b)(c,E)}}}function p(I){return new M.$yK(I.start.line,I.start.character,I.end.line,I.end.character)}function E(I){return new A.$mK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(w,S){this.a=w,this.b=S}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$Qkc=R,e.$Qkc=R=Je([qe(1,L.$Mj)],R)}),define(Se[378],De([1,0,51,17,75,34,11,14,122,379]),function(fe,e,u,L,M,A,P,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=I,e.$Skc=g,e.$Tkc=n;const R=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,r,a,t){const f=w(i,r,a,t),l=r.folder.fsPath;return{cmd:u.spawn(R,f.args,{cwd:l}),rgDiskPath:R,siblingClauses:f.siblingClauses,rgArgs:f,cwd:l}}function w(i,r,a,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];y([r],a,!1).forEach(s=>{const o=(0,p.$Okc)(s);if(f.push("-g",o),P.$j){const d=(0,M.$Yl)(o);d!==o&&f.push("-g",d)}});const l=S([r],t,void 0,!1);return l.globArgs.forEach(s=>{const o=`!${(0,p.$Okc)(s)}`;if(f.push("-g",o),P.$j){const d=(0,M.$Yl)(o);d!==o&&f.push("-g",d)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:l.siblingClauses}}function S(i,r,a,t=!0){const f=[];let l={};return i.forEach(s=>{const o=Object.assign({},s.excludePattern||{},r||{}),d=h(o,t?s.folder.fsPath:void 0,a);f.push(...d.globArgs),d.siblingClauses&&(l=Object.assign(l,d.siblingClauses))}),{globArgs:f,siblingClauses:l}}function y(i,r,a=!0){const t=[];return i.forEach(f=>{const l=Object.assign({},r||{},f.includePattern||{}),s=h(l,a?f.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function h(i,r,a){const t=[],f={};return Object.keys(i).forEach(l=>{if(a&&a.has(l)||!l)return;const s=i[l];l=c(r?g(r,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof s=="boolean"&&s?(l.startsWith("\\\\")&&(l+="**"),t.push(n(l))):s&&s.when&&(f[l]=s)}),{globArgs:t,siblingClauses:f}}function g(i,r){return L.$ic(r)?r:L.$jc(i,r)}function c(i){return i=b.$5e(i,"\\"),b.$5e(i,"/")}function n(i){return A.$cg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Se[380],De([1,0,51,57,17,381,19,44,35,75,34,11,38,14,18,31,36,378,132]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(l=>l())});class r{constructor(s){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=s,this.b=s.filePattern||"",this.d=s.includePattern&&p.$ak(s.includePattern),this.f=s.maxResults||null,this.g=!!s.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=s.shouldGlobMatchFilePattern?null:(0,n.$dr)(this.b).normalizedLowercase),this.u=s.excludePattern&&p.$ak(s.excludePattern),this.t=new Map,s.folderQueries.forEach(o=>{const d=Object.assign({},o.excludePattern||{},this.a.excludePattern||{}),m=o.folder.fsPath;s.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==m).forEach(D=>{(0,R.$gg)(D,m)&&(d[M.$lc(m,D)]=!0)}),this.t.set(m,new t(d,m))})}cancel(){this.l=!0,i.forEach(s=>s())}walk(s,o,d,m,D){if(this.m=w.$2d.create(!1),this.l)return D(null,this.j);o.forEach($=>{const v=M.$nc($.fsPath);this.u&&this.u($.fsPath,v)||this.J(d,{relativePath:$.fsPath,searchPath:void 0})}),this.r=w.$2d.create(!1),this.w(s,($,v)=>{this.x(this.y,this,$,d,m,k=>{if(k){const C=(0,b.$4i)(k);console.error(C),this.q.push(C),v(k,void 0)}else v(null,void 0)})},($,v)=>{this.m.stop();const k=$?P.$Hb($)[0]:null;D(k,this.j)})}w(s,o,d){const m=new Array(s.length),D=new Array(s.length);let $=!1,v=0;if(s.length===0)return d(null,[]);s.forEach((k,C)=>{o(k,(O,B)=>{if(O?($=!0,m[C]=null,D[C]=O):(m[C]=B,D[C]=null),++v===s.length)return d($?D:null,m)})})}x(s,o,...d){try{s.apply(o,d)}catch(m){d[d.length-1](m)}}y(s,o,d,m){const D=s.folder.fsPath,$=I.$j,v=()=>z&&z.kill();i.add(v);let k=F=>{i.delete(v),k=()=>{},m(F)},C="";const O=this.D(),B=(0,c.$Rkc)(this.a,s,this.a.includePattern,this.t.get(s.folder.fsPath).expression),z=B.cmd,T=!Object.keys(B.siblingClauses).length,j=B.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let N=`${B.rgDiskPath} ${j}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),d({message:N}),this.s=0,this.z(z,"utf8",d,(F,K,ee)=>{if(F){k(F);return}if(this.j){k();return}const Q=(C+($?E.$Xl(K||""):K)).split(`
`);if(ee){const Z=Q.length;Q[Z-1]=Q[Z-1].trim(),Q[Z-1]||Q.pop()}else C=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=Q.length,T){for(const Z of Q)if(this.J(o,{base:D,relativePath:Z,searchPath:this.N(s,Z)}),this.j){v();break}(ee||this.j)&&k();return}this.G(s,O,D,Q,o),ee&&(this.H(O,D,o),k())})}spawnFindCmd(s){const o=this.t.get(s.folder.fsPath),d=o.getBasenameTerms(),m=o.getPathTerms(),D=["-L","."];if(d.length||m.length){D.push("-not","(","(");for(const $ of d)D.push("-name",$),D.push("-o");for(const $ of m)D.push("-path",$),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:s.folder.fsPath})}readStdout(s,o,d){let m="";this.z(s,o,()=>{},(D,$,v)=>{if(D){d(D);return}m+=$,v&&d(null,m)})}z(s,o,d,m){let D=(k,C,O)=>{(k||O)&&(D=()=>{},this.r?.stop()),m(k,C,O)},$=!1;s.stdout?(this.A(s.stdout,o,D),s.stdout.once("data",()=>$=!0)):d({message:"stdout is null"});let v;s.stderr?v=this.B(s.stderr):d({message:"stderr is null"}),s.on("error",k=>{D(k)}),s.on("close",k=>{let C;!$&&(C=this.C(v,o))&&f(C)?D(new Error(`command failed with error code ${k}: ${this.C(v,o)}`)):(this.g&&k===0&&(this.j=!0),D(null,"",!0))})}A(s,o,d){const m=new A.StringDecoder(o);return s.on("data",D=>{d(null,m.write(D))}),m}B(s){const o=[];return s.on("data",d=>{o.push(d)}),o}C(s,o){const d=new A.StringDecoder(o);return s.map(m=>d.write(m)).join("")}D(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}G(s,{pathToEntries:o},d,m,D){m.indexOf(this.b)!==-1&&this.J(D,{base:d,relativePath:this.b,searchPath:this.N(s,this.b)});const $=v=>{const k=M.$nc(v),C=M.$mc(v);let O=o[C];O||(O=o[C]=[],$(C)),O.push({base:d,relativePath:v,basename:k,searchPath:this.N(s,v)})};m.forEach($)}H({rootEntries:s,pathToEntries:o},d,m){const D=this,$=this.t.get(d),v=this.b;function k(C){D.o++;const O=(0,g.$NK)(()=>C.map(B=>B.basename));for(let B=0,z=C.length;B<z;B++){const T=C[B],{relativePath:j,basename:N}=T;if($.test(j,N,v!==N?O:void 0))continue;const F=o[j];if(F)k(F);else{if(D.p++,j===v)continue;D.J(m,T)}if(D.j)break}}k(s)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(s,o,d,m,D){const $=s.folder,v=(0,g.$NK)(()=>d);this.w(d,(k,C)=>{if(this.l||this.j)return C(null);const O=o?[o,k].join(M.sep):k;if(this.t.get(s.folder.fsPath).test(O,k,this.a.filePattern!==k?v:void 0))return C(null);const B=[$.fsPath,O].join(M.sep);L.lstat(B,(z,T)=>{if(z||this.l||this.j)return C(null);this.L(B,T,(j,N)=>j||this.l||this.j?C(null):N.isDirectory()?(this.o++,this.M(B,T,(F,K)=>F||this.l||this.j||(K=K||"",this.v[K])?C(null):(this.v[K]=!0,h.Promises.readdir(B).then(ee=>{if(this.l||this.j)return C(null);this.I(s,O,ee,m,Y=>C(Y||null))},ee=>{C(null)})))):(this.p++,O===this.b||this.h&&y.$Xf(N.size)&&N.size>this.h||this.J(m,{base:$.fsPath,relativePath:O,searchPath:this.N(s,O)}),C(null,void 0)))})},k=>{const C=k&&P.$Hb(k);return D(C&&C.length>0?C[0]:void 0)})}J(s,o){this.K(o)&&(!this.d||this.d(o.relativePath,M.$nc(o.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||s(o))}K(s){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$IK)(s,this.c);if(this.b)return(0,g.$IK)(s,this.b,!1)}return!0}L(s,o,d){return o.isSymbolicLink()?L.stat(s,d):d(null,o)}M(s,o,d){return o.isSymbolicLink()?L.realpath(s,(m,D)=>m?d(m):d(null,D)):d(null,s)}N(s,o){return s.folderName?M.$jc(s.folderName,o):o}}e.$Ukc=r;class a{constructor(s){this.a=s.folderQueries,this.b=s.extraFileResources||[],this.c=new r(s)}search(s,o,d){this.c.walk(this.a,this.b,s,o,(m,D)=>{d(m,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Vkc=a;class t{constructor(s,o){this.expression=s,this.c=o,this.d(s)}d(s){let o,d;Object.keys(s).filter(m=>s[m]).forEach(m=>{M.$ic(m)?(o=o||p.$8j(),o[m]=s[m]):(d=d||p.$8j(),d[m]=s[m])}),this.a=o&&p.$ak(o,{trimForExclusions:!0}),this.b=d&&p.$ak(d,{trimForExclusions:!0})}test(s,o,d){return this.b&&this.b(s,o,d)||this.a&&this.a(M.$jc(this.c,s),o,d)}getBasenameTerms(){const s=[];return this.a&&s.push(...p.$ck(this.a)),this.b&&s.push(...p.$ck(this.b)),s}getPathTerms(){const s=[];return this.a&&s.push(...p.$dk(this.a)),this.b&&s.push(...p.$dk(this.b)),s}}function f(l){const s=l.trim().split(`
`),o=s[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return S.$Lf(s[s.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(Se[382],De([1,0,98,21,191,22]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=e.$JD=e.DecodeStreamErrorKind=e.$ID=e.$HD=e.$GD=e.$ED=e.$DD=e.$CD=e.$BD=void 0,e.$FD=P,e.$KD=y,e.$LD=h,e.$MD=g,e.$ND=c,e.$OD=n,e.$PD=l,e.$QD=s,e.$BD="utf8",e.$CD="utf8bom",e.$DD="utf16be",e.$ED="utf16le";function P(o){return[e.$BD,e.$CD,e.$DD,e.$ED].some(d=>d===o)}e.$GD=[254,255],e.$HD=[255,254],e.$ID=[239,187,191];const b=512,p=512,E=512*8,R=512*128;var I;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class w extends Error{constructor(d,m){super(d),this.decodeStreamErrorKind=m}}e.$JD=w;class S{static async create(d){let m;if(d!==e.$BD)m=(await(0,M.$AD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(d));else{const D=new TextDecoder;m={write($){return D.decode($,{stream:!0})},end(){return D.decode()}}}return new S(m)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function y(o,d){const m=d.minBytesRequiredForDetection??d.guessEncoding?E:p;return new Promise((D,$)=>{const v=(0,u.$he)(T=>T.join("")),k=[];let C=0,O;const B=new A.$de,z=async()=>{try{const T=await s({buffer:L.$te.concat(k),bytesRead:C},d.guessEncoding);if(T.seemsBinary&&d.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);T.encoding=await d.overwriteEncoding(T.encoding),O=await S.create(T.encoding);const j=O.write(L.$te.concat(k).buffer);v.write(j),k.length=0,C=0,D({stream:v,detected:T})}catch(T){B.cancel(),v.destroy(),$(T)}};(0,u.$le)(o,{onData:async T=>{O?v.write(O.write(T.buffer)):(k.push(T),C+=T.byteLength,C>=m&&(o.pause(),await z(),setTimeout(()=>o.resume())))},onError:T=>v.error(T),onEnd:async()=>{O||await z(),v.end(O?.end())}},B.token)})}async function h(o,d,m){const $=(await(0,M.$AD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(d),m);let v=!1,k=!1;return{read(){if(k)return null;const C=o.read();if(typeof C!="string"){if(k=!0,!v&&m?.addBOM)switch(d){case e.$BD:case e.$CD:return L.$te.wrap(Uint8Array.from(e.$ID));case e.$DD:return L.$te.wrap(Uint8Array.from(e.$GD));case e.$ED:return L.$te.wrap(Uint8Array.from(e.$HD))}const O=$.end();return O&&O.length>0?(v=!0,L.$te.wrap(O)):null}return v=!0,L.$te.wrap($.write(C))}}}async function g(o){return(await(0,M.$AD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(o))}function c(o){return o===e.$CD||o===null?e.$BD:o}function n(o,d){if(!o||d<e.$GD.length)return null;const m=o.readUInt8(0),D=o.readUInt8(1);if(m===e.$GD[0]&&D===e.$GD[1])return e.$DD;if(m===e.$HD[0]&&D===e.$HD[1])return e.$ED;if(d<e.$ID.length)return null;const $=o.readUInt8(2);return m===e.$ID[0]&&D===e.$ID[1]&&$===e.$ID[2]?e.$CD:null}const i=["ascii","utf-16","utf-32"];async function r(o){const d=await(0,M.$AD)("jschardet","dist/jschardet.min.js"),m=o.slice(0,R),D=f(m.buffer),$=d.detect(D);if(!$||!$.encoding)return null;const v=$.encoding.toLowerCase();return 0<=i.indexOf(v)?null:t($.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(o){const d=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[d]||d}function f(o){let d="";for(let m=0;m<o.length;m++)d+=String.fromCharCode(o[m]);return d}function l(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=o.match(/windows(\d+)/);return d?"windows-"+d[1]:o}}}function s({buffer:o,bytesRead:d},m){let D=n(o,d),$=!1;if(D!==e.$DD&&D!==e.$ED&&o){let v=!0,k=!0,C=!1;for(let O=0;O<d&&O<b;O++){const B=O%2===1,z=o.readUInt8(O)===0;if(z&&(C=!0),v&&(B&&!z||!B&&z)&&(v=!1),k&&(B&&z||!B&&!z)&&(k=!1),z&&!v&&!k)break}C&&(v?D=e.$ED:k?D=e.$DD:$=!0)}return m&&!$&&!D&&o?r(o.slice(0,d)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:$,encoding:D}}e.$RD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[159],De([1,0,382,31,158]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=void 0;class A extends M.$Ojc{constructor(b,p,E=L,R="searchProcess"){super({query:b,provider:p},{readdir:I=>E.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.$PD)(I)},R)}}e.$4kc=A}),define(Se[160],De([1,0,51,398,381,19,72,35,14,2,36,94,399,379,122]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0,e.$Ykc=t,e.$Zkc=l,e.$1kc=o,e.$2kc=d,e.$3kc=D;const h=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(v){this.a=v}provideTextSearchResults(v,k,C,O){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((B,z)=>{O.onCancellationRequested(()=>Q());const T=t(v,k),j=k.folder.fsPath,N=T.map(se=>se.match(/^-/)?se:`'${se}'`).join(" ");this.a.appendLine(`${h} ${N}
 - cwd: ${j}`);let F=u.spawn(h,T,{cwd:j});F.on("error",se=>{console.error(se),this.a.appendLine("Error: "+(se&&se.message)),z((0,R.$EK)(new R.$CK(se&&se.message,R.SearchErrorCode.rgProcessError)))});let K=!1;const ee=new i(k.maxResults,k.folder,k.previewOptions);ee.on("result",se=>{K=!0,ae="",C.report(se)});let Y=!1;const Q=()=>{Y=!0,F?.kill(),ee?.cancel()};let Z=!1;ee.on("hitLimit",()=>{Z=!0,Q()});let ae="";F.stdout.on("data",se=>{ee.handleData(se),K||(ae+=se)});let _=!1;F.stdout.once("data",()=>_=!0);let ge="";F.stderr.on("data",se=>{const re=se.toString();this.a.appendLine(re),ge.length+re.length<1e6&&(ge+=re)}),F.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(K?"Got result from parser":"No result from parser"),ae&&this.a.appendLine(`Got data without result: ${ae}`),this.a.appendLine(""),Y)B({limitHit:Z});else{ee.flush(),F=null;let se;ge&&!_&&(se=c(ge))?z((0,R.$EK)(new R.$CK(se.message,se.code))):B({limitHit:Z})}})})}}e.$Wkc=g;function c($){const v=$.split(`
`),k=v[0].trim();if(v.some(O=>O.startsWith("regex parse error")))return new R.$CK(n(v),R.SearchErrorCode.regexParseError);const C=k.match(/grep config error: unknown encoding: (.*)/);if(C)return new R.$CK(`Unknown encoding: ${C[1]}`,R.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new R.$CK(k.charAt(0).toUpperCase()+k.substr(1),R.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new R.$CK(k.charAt(0).toUpperCase()+k.substr(1),R.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new R.$CK(k,R.SearchErrorCode.regexParseError)}function n($){const v=["Regex parse error"],k=$.filter(C=>C.startsWith("PCRE2:"));if(k.length>=1){const C=k[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const O=C.split(":")[1];v.push(":"+O)}}return v.join("")}class i extends L.EventEmitter{constructor(v,k,C){super(),this.g=v,this.h=k,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new M.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,k){return super.on(v,k),this}handleData(v){if(this.b)return;const k=typeof v=="string"?v:this.d.write(v);this.k(k)}k(v){let k=v.indexOf(`
`);const C=this.a+v;if(k>=0)k+=this.a.length;else{this.a=C;return}let O=0;for(;k>=0;)this.m(C.substring(O,k).trim()),O=k+1,k=C.indexOf(`
`,O);this.a=C.substring(O)}m(v){if(this.b||!v)return;let k;try{k=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(k.type==="match"){const C=r(k.data.path),O=E.URI.joinPath(this.h,C),B=this.n(k.data,O);this.p(B),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const C=r(k.data.path),O=E.URI.joinPath(this.h,C);this.o(k.data,O).forEach(z=>this.p(z))}}n(v,k){const C=v.line_number-1,O=r(v.lines),B=Buffer.from(O);let z=0,T=0,j=C;v.submatches.length===0&&v.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const N=(0,A.$Hb)(v.submatches.map((F,K)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=r(F.match),Y=B.slice(z,F.start).toString(),Q=a(Y),Z=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+T,ae=a(ee),_=Q.numLines+j,ge=ae.numLines+_,se=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+Z;return z=F.end,T=se,j=ge,new I.$mK(_,Z,ge,se)}));return(0,y.$Pkc)(k,O,N,this.j)}o(v,k){const C=r(v.lines),O=v.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((B,z)=>({text:B,uri:k,lineNumber:O+z}))}p(v){this.emit("result",v)}}e.$Xkc=i;function r($){return $.bytes?Buffer.from($.bytes,"base64").toString():$.text}function a($){const v=/\n/g;let k=0,C=-1,O;for(;O=v.exec($);)k++,C=O.index;const B=C>=0?$.length-C-1:$.length;return{numLines:k,lastLineLength:B}}function t($,v){const k=["--hidden","--no-require-git"];k.push($.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:O}=(0,P.$K)(v.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const z=new Set;O.forEach(T=>{z.add(T)}),k.push("-g","!*"),z.forEach(T=>{f(T).map(y.$Okc).forEach(j=>{k.push("-g",j)})})}C&&C.length&&C.forEach(z=>{k.push("-g",z)}),v.excludes.map(y.$Okc).forEach(z=>k.push("-g",`!${z}`)),v.maxFileSize&&k.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),v.followSymlinks&&k.push("--follow"),v.encoding&&v.encoding!=="utf8"&&k.push("--encoding",v.encoding),$.pattern==="--"&&($.isRegExp=!0,$.pattern="\\-\\-"),$.isMultiline&&!$.isRegExp&&($.pattern=(0,p.$Ye)($.pattern),$.isRegExp=!0),v.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),$.isRegExp&&($.pattern=l($.pattern),k.push("--engine","auto"));let B;if($.isWordMatch){const T=(0,p.$8e)($.pattern,!!$.isRegExp,{wholeWord:$.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",T)}else if($.isRegExp){let z=o($.pattern);z=d(z),k.push("--regexp",z)}else B=$.pattern,k.push("--fixed-strings");return k.push("--no-config"),v.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),$.isMultiline&&k.push("--multiline"),v.beforeContext&&k.push("--before-context",v.beforeContext+""),v.afterContext&&k.push("--after-context",v.afterContext+""),k.push("--"),B&&k.push(B),k.push("."),k}function f($){return D($).flatMap(k=>{const C=(0,b.$$j)(k,"/");return C.map((O,B)=>C.slice(0,B+1).join("/"))})}function l($){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;$.match(v);)$=$.replace(v,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;$.match(k);)$=$.replace(k,"$1\\x{$2}");return $}const s=$=>$.type==="Assertion"&&$.kind==="lookbehind";function o($){let v;try{v=new w.RegExpParser().parsePattern($)}catch{return $}let k="",C=0;const O=(T,j,N)=>{k+=$.slice(C,T)+N,C=j},B=[];return new w.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const j=B[0];if(!j)O(T.start,T.end,"\\r?\\n");else if(!B.some(s))if(j.type==="CharacterClass")if(j.negate){const N=$.slice(j.start+2,T.start)+$.slice(T.end,j.end-1);j.parent?.type==="Quantifier"?O(j.start,j.end,N?`[^${N}]`:"."):O(j.start,j.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=$.slice(j.start+1,T.start)+$.slice(T.end,j.end-1);O(j.start,j.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else j.type==="Quantifier"&&O(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){B.unshift(T)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(T){B.unshift(T)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(T){B.unshift(T)},onCharacterClassLeave(){B.shift()},onAssertionEnter(T){s(T)&&B.push(T)},onAssertionLeave(T){B[0]===T&&B.shift()}}).visit(v),k+=$.slice(C),k}function d($){return $.replace(/\n/g,"\\r?\\n")}function m($){let v=!1,k=!1,C="",O="";for(let B=0;B<$.length;B++){const z=$[B];switch(z){case"\\":k?(v?O+="\\"+z:C+="\\"+z,k=!1):k=!0;break;case"{":if(k)v?O+=z:C+=z,k=!1;else{if(v)return{strInBraces:C+"{"+O+"{"+$.substring(B+1)};v=!0}break;case"}":if(k)v?O+=z:C+=z,k=!1;else{if(v)return{fixedStart:C,strInBraces:O,fixedEnd:$.substring(B+1)};C+=z}break;default:v?O+=(k?"\\":"")+z:C+=(k?"\\":"")+z,k=!1;break}}return{strInBraces:C+(v?"{"+O:"")}}function D($){const{fixedStart:v,strInBraces:k,fixedEnd:C}=m($);if(v===void 0||C===void 0)return[k];let O=(0,b.$$j)(k,",");O.length||(O=[""]);const B=D(C);return O.flatMap(z=>{const T=v+z;return B.map(j=>T+j)})}}),define(Se[383],De([1,0,22,160,108,15]),function(fe,e,u,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;class P{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,R,I,w){const S=new L.$Wkc(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const y={...R,folder:R.folder.with({scheme:A.Schemas.file})},h=new M.$Nv(g=>I.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(w,g=>S.provideTextSearchResults(E,y,h,g))}else return this.c(w,y=>S.provideTextSearchResults(E,R,I,y))}async c(E,R){const I=b(E);this.a.add(I);const w=await R(I.token);return this.a.delete(I),w}d(){this.a.forEach(E=>E.cancel())}}e.$7kc=P;function b(p){const E=new u.$de;return p.onCancellationRequested(()=>E.cancel()),E}}),define(Se[384],De([1,0,31,160,159]),function(fe,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=void 0;class A{constructor(p){this.a=p}search(p,E,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){R({message:S})}},w=new M.$4kc(this.a,new L.$Wkc(I),u);return new Promise((S,y)=>w.search(h=>{E(h.map(P))},p).then(h=>S({limitHit:h.limitHit,type:"success",stats:h.stats}),y))}}e.$5kc=A;function P(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((p,E)=>{if(E.ranges){const R=E;return p+(Array.isArray(R.ranges)?R.ranges.length:1)}else return p+1},0)}}}),define(Se[385],De([1,0,19,8,13,4,132,17,38,2,32,36,380,384]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=void 0;class y{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=c(r),f=new A.$6d({onDidAddFirstListener:()=>{a=(0,L.$6g)(l=>this.doFileSearchWithEngine(w.$Vkc,t,s=>f.fire(s),l)),a.then(l=>f.fire(l),l=>f.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return f.event}textSearch(r){let a;const t=c(r),f=new A.$6d({onDidAddFirstListener:()=>{a=(0,L.$6g)(l=>this.f(t,s=>f.fire(s),l)),a.then(l=>f.fire(l),l=>f.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return f.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new S.$5kc(r).search(t,a,a)}g(){return{maxFileSize:16*R.$il.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine(w.$Vkc,r,a,t)}doFileSearchWithEngine(r,a,t,f,l=y.a){let s=0;const o=m=>{Array.isArray(m)?(s+=m.length,t(m.map(D=>this.h(D)))):m.relativePath?(s++,t(this.h(m))):t(m)};if(a.sortByScore){let m=this.l(a,o,f);if(!m){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,$=new r(D);m=this.j($,a,t,o,f)}return new Promise((D,$)=>{m.then(([v,k])=>{const C=k.map(O=>this.h(O));this.o(C,t,l),D(v)},$)})}const d=new r(a);return this.r(d,o,l,f).then(m=>({limitHit:m.limitHit,type:"success",stats:{detailStats:m.stats,type:this.d,fromCache:!1,resultCount:s,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$jc)(r.base,r.relativePath):r.relativePath}}j(r,a,t,f,l){const s=new A.$6d;let o=(0,L.$6g)(m=>{let D=[];const $=v=>{Array.isArray(v)?D=v:(f(v),s.fire(v))};return this.r(r,$,-1,m).then(v=>[v,D])}),d;if(a.cacheKey){d=this.k(a.cacheKey);const m={promise:o,event:s.event,resolved:!1};d.resultsToSearchCache[a.filePattern||""]=m,o.then(()=>{m.resolved=!0},D=>{delete d.resultsToSearchCache[a.filePattern||""]}),o=this.s(o)}return o.then(([m,D])=>{const $=d?d.scorerCache:Object.create(null),v=(typeof a.maxResults!="number"||a.maxResults>0)&&p.$2d.create(!1);return this.n(a,D,$,l).then(k=>{const C=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:m.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:k.length},messages:m.messages,limitHit:m.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},k]})})}k(r){const a=this.b[r];return a||(this.b[r]=new h)}l(r,a,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const l=this.q(f,r.filePattern||"",a,t);if(l)return l.then(([s,o,d])=>{const m=p.$2d.create(!1);return this.n(r,o,f.scorerCache,t).then(D=>{const $=m.elapsed(),v={fromCache:!0,detailStats:d,type:this.d,resultCount:o.length,sortingTime:$};return[{type:"success",limitHit:s.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults,stats:v},D]})})}n(r,a,t,f){const l=(0,P.$dr)(r.filePattern||""),s=(d,m)=>(0,P.$cr)(d,m,l,!0,g,t),o=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(a,s,o,1e4,f)}o(r,a,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)a(r.slice(f,f+t));else a(r)}q(r,a,t,f){const l=p.$2d.create(!1),s=a.indexOf(b.sep)>=0;let o;for(const $ in r.resultsToSearchCache)if(a.startsWith($)){if(s&&$.indexOf(b.sep)<0&&$!=="")continue;const v=r.resultsToSearchCache[$];o={promise:this.s(v.promise),event:v.event,resolved:v.resolved};break}if(!o)return null;const d=l.elapsed(),m=p.$2d.create(!1),D=o.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),o.promise.then(([$,v])=>{if(f&&f.isCancellationRequested)throw(0,M.$6)();const k=[],C=(0,P.$dr)(a).normalizedLowercase;for(const O of v)(0,I.$IK)(O,C)&&k.push(O);return[$,k,{cacheWasResolved:o.resolved,cacheLookupTime:d,cacheFilterTime:m.elapsed(),cacheEntryCount:v.length}]})}r(r,a,t,f){return new Promise((l,s)=>{let o=[];f?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(t?(o.push(d),t>0&&o.length>=t&&(a(o),o=[])):a(d))},d=>{a(d)},(d,m)=>{o.length&&a(o),d?(a({message:"Search finished. Error: "+d.message}),s(d)):(a({message:"Search finished. Stats: "+JSON.stringify(m.stats)}),l(m))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$6kc=y;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(i){return(0,b.$nc)(i.relativePath)}getItemDescription(i){return(0,b.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function c(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>E.URI.revive(r))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(Se[386],De([1,0,3,15,2,31,12,27,20,97,65,36,385,383,122,159]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;let g=class extends E.$Tjc{constructor(n,i,r,a){super(n,r,a),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Sc;const t=new y.$Qkc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.vscodeUserData,new S.$7kc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new y.$Qkc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.file,new S.$7kc(n))),this.A.add(this.C(L.Schemas.file,new w.$6kc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Rc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,a){const t=(0,E.$Ujc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,a).then(l=>{const s=Date.now()-f;return this.q.debug(`Ext host file search time: ${s}ms`),l})}return super.$provideFileSearchResults(n,i,r,a)}doInternalFileSearchWithCustomCallback(n,i,r){const a=t=>{if((0,I.$HK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>M.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,a,i)}async D(n,i,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$4kc(n,i,void 0,"textSearchProvider")}};e.$8kc=g,e.$8kc=g=Je([qe(0,p.$xO),qe(1,b.$NO),qe(2,R.$Mic),qe(3,P.$Mj)],g)}),define(Se[123],De([1,0,373,62,63,400,21,13,4,3,17,11,30,80,81]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$0h=e.$9h=e.$8h=void 0,e.$$h=l,e.$_h=s,e.$bi=m,e.$ci=D;class h{traceSocketEvent(v,k){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,k)}constructor(v,k=""){this.f=!0,this.debugLabel=k,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const k=C=>{this.traceSocketEvent("read",C),v(P.$te.wrap(C))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(v){const k=C=>{v({type:0,hadError:C,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(v){const k=()=>{v()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$8h=h;var g;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var c;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(c||(c={}));class n extends E.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,k){this.socket.traceSocketEvent(v,k)}constructor(v,k,C,O){super(),this.f=this.B(new p.$6d),this.g=this.B(new p.$6d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:C?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new i(this,k,C,O,this.f,(B,z)=>this.m(B,z))),this.B(this.a.onError(B=>{console.error(B),(0,b.$1)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new y.$3h,this.B(this.socket.onData(B=>this.n(B))),this.B(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let k=0;for(;k<v.byteLength;)this.a.writeMessage(v.slice(k,Math.min(k+262144,v.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(v,{compressed:k,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let O=2;v.byteLength<126?O+=0:v.byteLength<2**16?O+=2:O+=8;const B=P.$te.alloc(O),z=k?64:0,T=C&15;if(B.writeUInt8(128|z|T,0),v.byteLength<126)B.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){B.writeUInt8(126,1);let j=1;B.writeUInt8(v.byteLength>>>8&255,++j),B.writeUInt8(v.byteLength>>>0&255,++j)}else{B.writeUInt8(127,1);let j=1;B.writeUInt8(0,++j),B.writeUInt8(0,++j),B.writeUInt8(0,++j),B.writeUInt8(0,++j),B.writeUInt8(v.byteLength>>>24&255,++j),B.writeUInt8(v.byteLength>>>16&255,++j),B.writeUInt8(v.byteLength>>>8&255,++j),B.writeUInt8(v.byteLength>>>0&255,++j)}this.socket.write(P.$te.concat([B,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),C=k.readUInt8(0),O=(C&128)>>>7,B=(C&64)>>>6,z=C&15,T=k.readUInt8(1),j=(T&128)>>>7,N=T&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!B),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),C=k.readUInt8(1),O=(C&128)>>>7;let B=C&127,z=1;B===126?B=k.readUInt8(++z)*2**8+k.readUInt8(++z):B===127&&(B=k.readUInt8(++z)*0+k.readUInt8(++z)*0+k.readUInt8(++z)*0+k.readUInt8(++z)*0+k.readUInt8(++z)*2**24+k.readUInt8(++z)*2**16+k.readUInt8(++z)*2**8+k.readUInt8(++z));let T=0;O&&(T=k.readUInt8(++z)*2**24+k.readUInt8(++z)*2**16+k.readUInt8(++z)*2**8+k.readUInt8(++z)),this.j.state=3,this.j.readLen=B,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$9h=n;class i extends E.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.$te.alloc(0)}constructor(v,k,C,O,B,z){super(),this.n=v,this.r=B,this.s=z,this.a=this.B(new p.$6d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$6d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$6d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,O,C,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(v,k){this.g.push({data:v,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:k}=this.g.shift();if(this.f&&k.compressed){const C=await this.w(this.f,v);this.s(C,k)}else this.s(v,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,k){return new Promise((C,O)=>{v.write(k),v.flush(B=>C(B))})}acceptFrame(v,k,C){this.h.push({data:v,isCompressed:k,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const k=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,k,C){return new Promise((O,B)=>{v.write(k),C&&v.write(P.$te.fromByteArray([0,0,255,255])),v.flush(z=>O(z))})}}class r extends E.$Tc{get recordedInflateBytes(){return this.j?P.$te.concat(this.f):P.$te.alloc(0)}constructor(v,k,C,O){super(),this.h=v,this.j=k,this.a=this.B(new p.$6d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(O),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(P.$te.wrap(B))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=P.$te.concat(this.g);this.g.length=0,v(k)})}}class a extends E.$Tc{constructor(v,k){super(),this.g=v,this.a=this.B(new p.$6d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(P.$te.wrap(C))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=P.$te.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),v(k)})}}function t($,v){if(v===0)return;const k=$.byteLength>>>2;for(let j=0;j<k;j++){const N=$.readUInt32BE(j*4);$.writeUInt32BE(N^v,j*4)}const C=k*4,O=$.byteLength-C,B=v>>>24&255,z=v>>>16&255,T=v>>>8&255;O>=1&&$.writeUInt8($.readUInt8(C)^B,C),O>=2&&$.writeUInt8($.readUInt8(C+1)^z,C+1),O>=3&&$.writeUInt8($.readUInt8(C+2)^T,C+2)}e.$0h=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function l(){const $=(0,w.$Cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const v=process.platform!=="darwin"&&e.$0h?e.$0h:(0,M.tmpdir)(),k=(0,R.$jc)(v,`vscode-ipc-${$}.sock`);return o(k),k}function s($,v,k){const O=(0,u.createHash)("sha256").update($).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${k}-${v}-sock`;const B=k.substr(0,4),z=v.substr(0,6);let T;return process.platform!=="darwin"&&e.$0h&&!process.env.VSCODE_PORTABLE?T=(0,R.$jc)(e.$0h,`vscode-${O}-${B}-${z}.sock`):T=(0,R.$jc)($,`${B}-${z}.sock`),o(T),T}function o($){const v=f[I.$u];typeof v=="number"&&$.length>=v&&console.warn(`WARNING: IPC handle "${$}" is longer than ${v} chars, try a shorter --user-data-dir`)}class d extends S.$Wh{static b(v){const k=p.Event.fromNodeEventEmitter(v,"connection");return p.Event.map(k,C=>({protocol:new y.$4h(new h(C,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(C,"close"))}))}constructor(v){super(d.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ai=d;function m($){return new Promise((v,k)=>{const C=(0,L.createServer)();C.on("error",k),C.listen($,()=>{C.removeListener("error",k),v(new d(C))})})}function D($,v){return new Promise((k,C)=>{const O=(0,L.createConnection)($,()=>{O.removeListener("error",C),k(y.$5h.fromSocket(new h(O,`ipc-client${v}`),v))});O.once("error",C)})}}),define(Se[387],De([1,0,62,63,171,123,8,3,11,52,12,139,263,264,110,88,21]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=e.$ebc=e.$dbc=e.$cbc=void 0;async function c(t,f,l,s,o){let d;for(let m=3;m&&(d?.dispose(),d=await new n(t,f,l,s,o).waitForReady(),!(o&&M.$Fg[o]||!M.$Fg[d.tunnelLocalPort]));m--);return d}class n extends b.$Tc{constructor(f,l,s,o,d){super(),this.m=l,this.n=d,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new P.$fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(l=>{l()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,l=(0,h.$1v)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,M.$Gg)(f,2,1e3,l),o=null;return this.b.listen(s,this.m),await this.c.wait(),o=this.b.address(),o||(s=0,this.b.listen(s,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(f){f.pause();const l=(0,h.$Yv)(this.tunnelRemoteHost)||(0,h.$1v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Cl)(this.a,l,this.tunnelRemotePort),o=s.getSocket(),d=s.readEntireBuffer();s.dispose(),d.byteLength>0&&f.write(d.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),o.end()}),f.on("close",()=>o.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),o instanceof A.$8h?o.socket.destroy():o.end()}),o instanceof A.$8h?this.t(f,o):this.s(f,o),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),o.end()})}s(f,l){l.onClose(()=>f.destroy()),l.onEnd(()=>f.end()),l.onData(s=>f.write(s.buffer)),f.on("data",s=>l.write(g.$te.wrap(s))),f.resume()}t(f,l){const s=l.socket;s.on("end",()=>f.end()),s.on("close",()=>f.end()),s.on("error",()=>{f.destroy()}),s.pipe(f),f.pipe(s)}}e.$cbc=n;let i=class extends h.$4v{constructor(f,l,s,o,d){super(l,d),this.v=f,this.w=s,this.y=o}isPortPrivileged(f){return(0,h.$2v)(f,this.m,p.OS,L.release())}t(f,l,s,o,d,m,D,$){const v=this.s(l,s);if(v)return++v.refcount,v.value;if((0,h.$Uv)(f))return this.u(f,l,s,d,m,D,$);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${s} on local port ${d}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=c(k,o,l,s,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(l,s,C),C}}};e.$dbc=i,e.$dbc=i=Je([qe(0,S.$wl),qe(1,R.$Mj),qe(2,y.$zl),qe(3,I.$6j),qe(4,E.$Mi)],i);let r=class extends i{constructor(f,l,s,o,d){super(f,l,s,o,d)}};e.$ebc=r,e.$ebc=r=Je([qe(0,S.$wl),qe(1,R.$Mj),qe(2,y.$zl),qe(3,I.$6j),qe(4,E.$Mi)],r);let a=class extends b.$Tc{constructor(f,l,s,o,d){super(),this.b=f,this.c=l,this.f=s,this.g=o,this.h=d,this.a=new Map}async openTunnel(f,l,s,o,d,m,D,$,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${o} on local port ${m}.`),!this.a.has(f)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(f,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(l,s,o,d,m,D,$,v)}};e.$fbc=a,e.$fbc=a=Je([qe(0,S.$wl),qe(1,R.$Mj),qe(2,I.$6j),qe(3,y.$zl),qe(4,E.$Mi)],a)}),define(Se[388],De([1,0,123,283,57,33,2,12,40]),function(fe,e,u,L,M,A,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0;class E{constructor(w,S,y){this.b=w,this.c=S,this.f=y,this.a=L.createServer((h,g)=>this.h(h,g)),this.g().catch(h=>(S.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,S){const y=(g,c)=>{S.writeHead(g,{"content-type":"application/json"}),S.end(JSON.stringify(c||null),n=>n&&this.c.error(n))},h=[];w.setEncoding("utf8"),w.on("data",g=>h.push(g)),w.on("end",async()=>{try{const g=JSON.parse(h.join(""));let c;switch(g.type){case"open":c=await this.i(g);break;case"openExternal":c=await this.j(g);break;case"status":c=await this.l(g);break;case"extensionManagement":c=await this.k(g);break;default:y(404,`Unknown message type: ${g.type}`);break}y(200,c)}catch(g){const c=g instanceof Error?g.message:JSON.stringify(g);y(500,c),this.c.error("Error while processing pipe request",g)}})}async i(w){const{fileURIs:S,folderURIs:y,forceNewWindow:h,diffMode:g,mergeMode:c,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=w,f=[];if(Array.isArray(y))for(const d of y)try{f.push({folderUri:P.URI.parse(d)})}catch{}if(Array.isArray(S))for(const d of S)try{(0,p.$Li)(d)?f.push({workspaceUri:P.URI.parse(d)}):f.push({fileUri:P.URI.parse(d)})}catch{}const l=a?P.URI.file(a):void 0,o={forceNewWindow:h,diffMode:g,mergeMode:c,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!l&&!n,waitMarkerFileURI:l,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,o)}async j(w){for(const S of w.uris){const y=P.URI.parse(S),h=y.scheme==="file"?y:S;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(w){const S=h=>h?.map(g=>/\.vsix$/i.test(g)?P.URI.parse(g):g),y={list:w.list,install:S(w.install),uninstall:S(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&M.existsSync(this.f)&&M.unlinkSync(this.f)}}e.$YO=E;let R=class extends E{constructor(w,S){super(w,S,(0,u.$$h)())}};e.$ZO=R,e.$ZO=R=Je([qe(0,A.$TO),qe(1,b.$Mj)],R)}),define(Se[389],De([1,0,58,376,370,282,47,357,2,15,7,388,104,315,356]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class h extends M.$Bkc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(l,s,o){return l=t(l),n.a.has(l)?n.a.get(l).load(l,p.URI.file((0,w.$Mq)(s.filename)),d=>r.apply(this,[d,s,o])):r.apply(this,arguments)};const a=i._resolveLookupPaths;i._resolveLookupPaths=(f,l)=>a.call(this,t(f),l);const t=f=>{for(const l of n.b){const s=l(f);if(s){f=s;break}}return f}}}class g extends P.$qjc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async ub(){this.h.createInstance(S.$$kc);const n=this.h.invokeFunction(L.$xkc);if(this.h.createInstance(b.$0kc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(I.$ZO);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(y.$_kc),await this.h.createInstance(h,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,A.$9kc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}vb(n){return n.main}async wb(n,i,r){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),a=fe.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$alc=g}),define(Se[390],De([1,0,51,21,4,3,125,11,23,2,31,12,262,64,110,88,387,27,20,69,364]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0,e.$blc=a,e.$clc=t,e.$dlc=f,e.$elc=l,e.$flc=o,e.$glc=d,e.$hlc=m;function a(v){const k=v.trim().split(`
`),C=[];return k.forEach(B=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(B);z&&z.length>=3&&C.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),C.reduce((B,z)=>(B[z.socket]=z,B),{})}function t(...v){const k=[].concat(...v.map(l));return[...new Map(k.filter(C=>C.st==="0A").map(C=>{const O=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:f(O[0]),port:parseInt(O[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function f(v){let k="";if(v.length===8)for(let C=v.length-2;C>=0;C-=2)k+=parseInt(v.substr(C,2),16),C!==0&&(k+=".");else for(let C=0;C<v.length;C+=8){const O=v.substring(C,C+8);let B="";for(let z=8;z>=2;z-=2)B+=O.substring(z-2,z),(z===6||z===2)&&(B=parseInt(B,16).toString(16),k+=`${B}`,B="",C+z!==v.length-6&&(k+=":"))}return k}function l(v){const k=v.trim().split(`
`),C=k.shift().trim().split(/\s+/).filter(B=>B!=="rx_queue"&&B!=="tm->when");return k.map(B=>B.trim().split(/\s+/).reduce((z,T,j)=>(z[C[j]||j]=T,z),{}))}function s(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function o(v){const k=v.trim().split(`
`),C=[];return k.forEach(O=>{const B=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);B&&B.length>=4&&C.push({pid:parseInt(B[1],10),ppid:parseInt(B[2]),cmd:B[3]})}),C}async function d(v,k,C){const O=C.reduce((z,T)=>(z[T.pid]=T,z),{}),B=[];return v.forEach(({socket:z,ip:T,port:j})=>{const N=k[z]?k[z].pid:void 0,F=N?O[N]?.cmd:void 0;N&&F&&!s(F)&&B.push({host:T,port:j,detail:F,pid:N})}),B}function m(v,k,C){const O=new Map,B=o(k);for(const z of v){const T=C.get(z.port);if(T){O.set(z.port,T);continue}const j=B.find(N=>N.cmd.includes(`${z.port}`));if(j){let N=j,F;do F=B.find(K=>K.ppid===N.pid),F&&(N=F);while(F);O.set(z.port,{host:z.ip,port:z.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else O.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return O}let D=class extends i.$PAb{constructor(k,C,O,B){super(k,C,O),this.D=C,this.F=B,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new P.$om;let B=0;for(;this.C;){const z=new Date().getTime(),T=(await this.I()).filter(F=>(0,h.$Yv)(F.host)||(0,h.$1v)(F.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(F=>F.port).join(", ")}`);const j=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),B++>3&&O.update(j),(!C||JSON.stringify(C)!==JSON.stringify(T))&&(C=T,await this.a.$onFoundNewCandidates(C));const N=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(F=>setTimeout(()=>F(),N))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",C="";try{k=await R.Promises.readFile("/proc/net/tcp","utf8"),C=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(k,C),B=await new Promise(Y=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Z,ae)=>{Y(Z)})}),z=a(B),T=await R.Promises.readdir("/proc"),j=[];for(const Y of T)try{const Q=Number(Y),Z=p.$Tg(E.URI.file("/proc"),Y);if((await R.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Q)){const _=await R.Promises.readlink(p.$Tg(Z,"cwd").fsPath),ge=await R.Promises.readFile(p.$Tg(Z,"cmdline").fsPath,"utf8");j.push({pid:Q,cwd:_,cmd:ge})}}catch{}const N=[],F=O.filter(Y=>{const Q=z[Y.socket];return Q||N.push(Y),Q}),K=d(F,z,j);let ee;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const Y=await new Promise(Q=>{(0,u.exec)("ps -F -A -l | grep root",(Z,ae,_)=>{Q(ae)})});this.z=m(N,Y,this.z),ee=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ee.map(Q=>Q.port).join(", ")}`)}return K.then(Y=>ee?Y.concat(ee):Y)}w(k){return async C=>{const O=new g.$cbc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,T,j,N){const F=await k.makeConnection();return $.connect(F,T,j,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$sl(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await O.waitForReady();const B=new M.$6d;return{localAddress:(0,r.$EL)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:B.event,dispose:()=>{O.dispose(),B.fire(),B.dispose()}}}}};e.$ilc=D,e.$ilc=D=Je([qe(0,n.$xO),qe(1,c.$NO),qe(2,I.$Mj),qe(3,y.$zl)],D);class $ extends w.$Mtb{static connect(k,C,O,B){const z=new A.$Sc,T={onClose:z.add(new M.$6d),onData:z.add(new M.$6d),onEnd:z.add(new M.$6d)};z.add(k.onDidReceiveMessage(N=>T.onData.fire(L.$te.wrap(N)))),z.add(k.onDidEnd(()=>T.onEnd.fire())),z.add(k.onDidClose(N=>T.onClose.fire({type:0,error:N,hadError:!!N})));const j=new $(k,B,T);return j.B(z),(0,w.$Ltb)(j,C,O,B,T)}constructor(k,C,O){super(C,O),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[391],De([1,0,83,359,374,372,386,389,390,96,47,97,95,46,69,93,358,316,12,375,60,277,106,110,141]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c,n,i,r,a,t,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$cs)(R.$rjc,b.$alc,0),(0,u.$cs)(n.$Nj,c.$klc,1),(0,u.$cs)(n.$Mj,new t.$di(a.$Akc,[!1],!0)),(0,u.$cs)(f.$zl,l.$hbc,1),(0,u.$cs)(h.$Vic,g.$jlc,0),(0,u.$cs)(E.$wjc,A.$Nkc,0),(0,u.$cs)(I.$Sjc,P.$8kc,0),(0,u.$cs)(w.$jkc,M.$Fkc,0),(0,u.$cs)(S.$ejc,L.$Ekc,0),(0,u.$cs)(y.$OAb,p.$ilc,0),(0,u.$cs)(r.$ujc,i.$llc,0)}),define(Se[401],De([1,0,62,402,58,13,81,123,260,114,371,21,31,104,8,135,284,298,377,391]),function(fe,e,u,L,M,A,P,b,p,E,R,I,w,S,y,h,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const n=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,m=d._load;d._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function a(d){process.exit=function(m){if(d)i(m);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(m,D){m==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(m,D)}}let t=function(d){i()};function f(){const d=(0,c.$$m)(process.env);if(d.type===3)return new Promise((m,D)=>{const $=v=>{const k=v[0],C=new P.$6h;k.on("message",O=>C.fire(I.$te.wrap(O.data))),k.on("close",()=>{t("renderer closed the MessagePort")}),k.start(),m({onMessage:C.event,send:O=>k.postMessage(O.buffer)})};process.parentPort.on("message",v=>$(v.ports))});if(d.type===2)return new Promise((m,D)=>{let $=null;const v=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,C=3e5,O=new y.$th(()=>t("renderer disconnected for too long (1)"),k),B=new y.$th(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(T,j)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const N=I.$te.wrap(Buffer.from(T.initialDataChunk,"base64"));let F;if(T.skipWebSocketFrames)F=new b.$8h(j,"extHost-socket");else{const K=I.$te.wrap(Buffer.from(T.inflateBytes,"base64"));F=new b.$9h(new b.$8h(j,"extHost-socket"),T.permessageDeflate,K,!1)}$?(O.cancel(),B.cancel(),$.beginAcceptReconnection(F,N),$.endAcceptReconnection(),$.sendResume()):(clearTimeout(v),$=new P.$7h({socket:F,initialChunk:N}),$.sendResume(),$.onDidDispose(()=>t("renderer disconnected")),m($),$.onSocketClose(()=>{O.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;O.isScheduled()&&B.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const m=d.pipeName;return new Promise((D,$)=>{const v=u.createConnection(m,()=>{v.removeListener("error",$);const k=new P.$7h({socket:new b.$8h(v,"extHost-renderer")});k.sendResume(),D(k)});v.once("error",$),v.on("close",()=>{t("renderer closed the socket")})})}}async function l(){const d=await f();return new class{constructor(){this.a=new P.$6h,this.onMessage=this.a.event,this.b=!1,d.onMessage(m=>{(0,E.$Km)(m,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||d.send(m)}async drain(){if(d.drain)return d.drain()}}}function s(d){return new Promise(m=>{const D=d.onMessage($=>{D.dispose();const v=JSON.parse($.toString()),k=v.commit,C=p.default.commit;if(k&&C&&k!==C&&i(55),v.parentPid){let O=0;setInterval(function(){try{process.kill(v.parentPid,0),O=0}catch(z){z&&z.code==="EPERM"?(O++,O>=3&&t(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):t(`parent process ${v.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let B;try{B=globalThis._VSCODE_NODE_MODULES["native-watchdog"],B.start(v.parentPid)}catch(z){(0,A.$1)(z)}}d.send((0,E.$Jm)(0)),m({protocol:d,initData:v})});d.send((0,E.$Jm)(1))})}async function o(){const d=[];process.on("unhandledRejection",(O,B)=>{d.push(B),setTimeout(()=>{const z=d.indexOf(B);z>=0&&B.catch(T=>{d.splice(z,1),(0,A.$4)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),O&&(0,A.$1)(O))})},1e3)}),process.on("rejectionHandled",O=>{const B=d.indexOf(O);B>=0&&d.splice(B,1)}),process.on("uncaughtException",function(O){(0,A.$Z)(O)||(0,A.$1)(O)}),M.mark("code/extHost/willConnectToRenderer");const m=await l();M.mark("code/extHost/didConnectToRenderer");const D=await s(m);M.mark("code/extHost/didWaitForInitData");const{initData:$}=D;a(!!$.environment.extensionTestsLocationURI),$.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,$.environment.skipWorkspaceStorageLock=(0,h.boolean)(n.skipWorkspaceStorageLock,!1);const v=new class{constructor(){this.pid=process.pid}exit(B){i(B)}fsExists(B){return w.Promises.exists(B)}fsRealpath(B){return(0,S.$Lq)(B)}};let k=null;$.remote.authority&&n.transformURIs&&(k=(0,g.$gs)($.remote.authority));const C=new R.$Dkc(D.protocol,$,v,k);t=O=>C.terminate(O)}o().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/workbench/api/node/extensionHostProcess.js.map
