/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Me=function(me){for(var e=[],S=0,F=me.length;S<F;S++)e[S]=Pe[me[S]];return e};define(Pe[68],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=F,e.$Lh=M,e.$Mh=O;function S(R){return(m,f,k)=>{let N=null,E=null;if(typeof k.value=="function"?(N="value",E=k.value):typeof k.get=="function"&&(N="get",E=k.get),!E)throw new Error("not supported");k[N]=R(E,f)}}function F(R,m,f){let k=null,N=null;if(typeof f.value=="function"?(k="value",N=f.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(k="get",N=f.get),!N)throw new Error("not supported");const E=`$memoize$${m}`;f[k]=function(...l){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,l)}),this[E]}}function M(R,m,f){return S((k,N)=>{const E=`$debounce$${N}`,l=`$debounce$result$${N}`;return function(...w){this[l]||(this[l]=f?f():void 0),clearTimeout(this[E]),m&&(this[l]=m(this[l],...w),w=[this[l]]),this[E]=setTimeout(()=>{k.apply(this,w),this[l]=f?f():void 0},R)}})}function O(R,m,f){return S((k,N)=>{const E=`$throttle$timer$${N}`,l=`$throttle$result$${N}`,w=`$throttle$lastRun$${N}`,d=`$throttle$pending$${N}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...s)),this[d])return;const a=this[w]+R;a<=Date.now()?(this[w]=Date.now(),k.apply(this,[this[l]]),this[l]=f?f():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[w]=Date.now(),k.apply(this,[this[l]]),this[l]=f?f():void 0},a-Date.now()))}})}}),define(Pe[90],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0;class S{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$CO=S,e.$DO=new S("id#")}),define(Pe[122],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$rn=R,e.$sn=E,e.$tn=l,e.$un=w,e.$vn=d,e.$wn=s,e.$xn=a,e.$yn=r,e.$zn=i,e.$An=n,e.$Bn=c,e.$Cn=h;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function R(t,p=!1){let u=0;const o=t.length;let v="",b=0,$=16,I=0;function g(U){let C=0,T=0;for(;C<U;){const q=t.charCodeAt(u);if(q>=48&&q<=57)T=T*16+q-48;else if(q>=65&&q<=70)T=T*16+q-65+10;else if(q>=97&&q<=102)T=T*16+q-97+10;else break;u++,C++}return C<U&&(T=-1),T}function D(U){u=U,v="",b=0,$=16,I=0}function y(){const U=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&k(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&k(t.charCodeAt(u)))for(u++;u<t.length&&k(t.charCodeAt(u));)u++;else return I=3,t.substring(U,u);let C=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&k(t.charCodeAt(u))){for(u++;u<t.length&&k(t.charCodeAt(u));)u++;C=u}else I=3;return t.substring(U,C)}function P(){let U="",C=u;for(;;){if(u>=o){U+=t.substring(C,u),I=2;break}const T=t.charCodeAt(u);if(T===34){U+=t.substring(C,u),u++;break}if(T===92){if(U+=t.substring(C,u),u++,u>=o){I=2;break}switch(t.charCodeAt(u++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ne=g(4);ne>=0?U+=String.fromCharCode(ne):I=4;break}default:I=5}C=u;continue}if(T>=0&&T<=31)if(f(T)){U+=t.substring(C,u),I=2;break}else I=6;u++}return U}function A(){if(v="",I=0,b=u,u>=o)return b=o,$=17;let U=t.charCodeAt(u);if(m(U)){do u++,v+=String.fromCharCode(U),U=t.charCodeAt(u);while(m(U));return $=15}if(f(U))return u++,v+=String.fromCharCode(U),U===13&&t.charCodeAt(u)===10&&(u++,v+=`
`),$=14;switch(U){case 123:return u++,$=1;case 125:return u++,$=2;case 91:return u++,$=3;case 93:return u++,$=4;case 58:return u++,$=6;case 44:return u++,$=5;case 34:return u++,v=P(),$=10;case 47:{const C=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<o&&!f(t.charCodeAt(u));)u++;return v=t.substring(C,u),$=12}if(t.charCodeAt(u+1)===42){u+=2;const T=o-1;let q=!1;for(;u<T;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,q=!0;break}u++}return q||(u++,I=1),v=t.substring(C,u),$=13}return v+=String.fromCharCode(U),u++,$=16}case 45:if(v+=String.fromCharCode(U),u++,u===o||!k(t.charCodeAt(u)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=y(),$=11;default:for(;u<o&&G(U);)u++,U=t.charCodeAt(u);if(b!==u){switch(v=t.substring(b,u),v){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return v+=String.fromCharCode(U),u++,$=16}}function G(U){if(m(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=A();while(U>=12&&U<=15);return U}return{setPosition:D,getPosition:()=>u,scan:p?W:A,getToken:()=>$,getTokenValue:()=>v,getTokenOffset:()=>b,getTokenLength:()=>u-b,getTokenError:()=>I}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function E(t,p){const u=[],o=new Object;let v;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function I(g,D,y,P){b.value=g,b.offset=D,b.length=y,b.type=P,b.colonOffset=void 0,v=b}try{n(t,{onObjectBegin:(g,D)=>{if(p<=g)throw o;v=void 0,$=p>g,u.push("")},onObjectProperty:(g,D,y)=>{if(p<D||(I(g,D,y,"property"),u[u.length-1]=g,p<=D+y))throw o},onObjectEnd:(g,D)=>{if(p<=g)throw o;v=void 0,u.pop()},onArrayBegin:(g,D)=>{if(p<=g)throw o;v=void 0,u.push(0)},onArrayEnd:(g,D)=>{if(p<=g)throw o;v=void 0,u.pop()},onLiteralValue:(g,D,y)=>{if(p<D||(I(g,D,y,h(g)),p<=D+y))throw o},onSeparator:(g,D,y)=>{if(p<=D)throw o;if(g===":"&&v&&v.type==="property")v.colonOffset=D,$=!1,v=void 0;else if(g===","){const P=u[u.length-1];typeof P=="number"?u[u.length-1]=P+1:($=!0,u[u.length-1]=""),v=void 0}}})}catch(g){if(g!==o)throw g}return{path:u,previousNode:v,isAtPropertyKey:$,matches:g=>{let D=0;for(let y=0;D<g.length&&y<u.length;y++)if(g[D]===u[y]||g[D]==="*")D++;else if(g[D]!=="**")return!1;return D===g.length}}}function l(t,p=[],u=O.DEFAULT){let o=null,v=[];const b=[];function $(g){Array.isArray(v)?v.push(g):o!==null&&(v[o]=g)}return n(t,{onObjectBegin:()=>{const g={};$(g),b.push(v),v=g,o=null},onObjectProperty:g=>{o=g},onObjectEnd:()=>{v=b.pop()},onArrayBegin:()=>{const g=[];$(g),b.push(v),v=g,o=null},onArrayEnd:()=>{v=b.pop()},onLiteralValue:$,onError:(g,D,y)=>{p.push({error:g,offset:D,length:y})}},u),v[0]}function w(t,p=[],u=O.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(g){o.type==="property"&&(o.length=g-o.offset,o=o.parent)}function b(g){return o.children.push(g),g}n(t,{onObjectBegin:g=>{o=b({type:"object",offset:g,length:-1,parent:o,children:[]})},onObjectProperty:(g,D,y)=>{o=b({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:g,offset:D,length:y,parent:o})},onObjectEnd:(g,D)=>{o.length=g+D-o.offset,o=o.parent,v(g+D)},onArrayBegin:(g,D)=>{o=b({type:"array",offset:g,length:-1,parent:o,children:[]})},onArrayEnd:(g,D)=>{o.length=g+D-o.offset,o=o.parent,v(g+D)},onLiteralValue:(g,D,y)=>{b({type:h(g),offset:D,length:y,parent:o,value:g}),v(D+y)},onSeparator:(g,D,y)=>{o.type==="property"&&(g===":"?o.colonOffset=D:g===","&&v(D))},onError:(g,D,y)=>{p.push({error:g,offset:D,length:y})}},u);const I=o.children[0];return I&&delete I.parent,I}function d(t,p){if(!t)return;let u=t;for(const o of p)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const b of u.children)if(Array.isArray(b.children)&&b.children[0].value===o){u=b.children[1],v=!0;break}if(!v)return}else{const v=o;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}function s(t){if(!t.parent||!t.parent.children)return[];const p=s(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;p.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&p.push(u)}return p}function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const p=Object.create(null);for(const u of t.children){const o=u.children[1];o&&(p[u.children[0].value]=a(o))}return p}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function r(t,p,u=!1){return p>=t.offset&&p<t.offset+t.length||u&&p===t.offset+t.length}function i(t,p,u=!1){if(r(t,p,u)){const o=t.children;if(Array.isArray(o))for(let v=0;v<o.length&&o[v].offset<=p;v++){const b=i(o[v],p,u);if(b)return b}return t}}function n(t,p,u=O.DEFAULT){const o=R(t,!1);function v(re){return re?()=>re(o.getTokenOffset(),o.getTokenLength()):()=>!0}function b(re){return re?$e=>re($e,o.getTokenOffset(),o.getTokenLength()):()=>!0}const $=v(p.onObjectBegin),I=b(p.onObjectProperty),g=v(p.onObjectEnd),D=v(p.onArrayBegin),y=v(p.onArrayEnd),P=b(p.onLiteralValue),A=b(p.onSeparator),G=v(p.onComment),W=b(p.onError),U=u&&u.disallowComments,C=u&&u.allowTrailingComma;function T(){for(;;){const re=o.scan();switch(o.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:U||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(re){case 12:case 13:U?q(10):G();break;case 16:q(1);break;case 15:case 14:break;default:return re}}}function q(re,$e=[],ie=[]){if(W(re),$e.length+ie.length>0){let le=o.getToken();for(;le!==17;){if($e.indexOf(le)!==-1){T();break}else if(ie.indexOf(le)!==-1)break;le=T()}}}function ne(re){const $e=o.getTokenValue();return re?P($e):I($e),T(),!0}function ce(){switch(o.getToken()){case 11:{let re=0;try{re=JSON.parse(o.getTokenValue()),typeof re!="number"&&(q(2),re=0)}catch{q(2)}P(re);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function ye(){return o.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),o.getToken()===6?(A(":"),T(),ve()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Ie(){$(),T();let re=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),A(","),T(),o.getToken()===2&&C)break}else re&&q(6,[],[]);ye()||q(4,[],[2,5]),re=!0}return g(),o.getToken()!==2?q(7,[2],[]):T(),!0}function ue(){D(),T();let re=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),A(","),T(),o.getToken()===4&&C)break}else re&&q(6,[],[]);ve()||q(4,[],[4,5]),re=!0}return y(),o.getToken()!==4?q(8,[4],[]):T(),!0}function ve(){switch(o.getToken()){case 3:return ue();case 1:return Ie();case 10:return ne(!0);default:return ce()}}return T(),o.getToken()===17?u.allowEmptyContent?!0:(q(4,[],[]),!1):ve()?(o.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}function c(t,p){const u=R(t),o=[];let v,b=0,$;do switch($=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:b!==$&&o.push(t.substring(b,$)),p!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,p)),b=u.getPosition();break}while(v!==17);return o.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(me,e){typeof define=="function"&&define.amd?define(Pe[123],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Se,be){for(var ge=0;ge<be.length;ge++){var J=be[ge];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Se,J.key,J)}}function S(Se,be,ge){return be&&e(Se.prototype,be),ge&&e(Se,ge),Object.defineProperty(Se,"prototype",{writable:!1}),Se}function F(Se,be){if(Se){if(typeof Se=="string")return M(Se,be);var ge=Object.prototype.toString.call(Se).slice(8,-1);if(ge==="Object"&&Se.constructor&&(ge=Se.constructor.name),ge==="Map"||ge==="Set")return Array.from(Se);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return M(Se,be)}}function M(Se,be){(be==null||be>Se.length)&&(be=Se.length);for(var ge=0,J=new Array(be);ge<be;ge++)J[ge]=Se[ge];return J}function O(Se,be){var ge=typeof Symbol<"u"&&Se[Symbol.iterator]||Se["@@iterator"];if(ge)return(ge=ge.call(Se)).next.bind(ge);if(Array.isArray(Se)||(ge=F(Se))||be&&Se&&typeof Se.length=="number"){ge&&(Se=ge);var J=0;return function(){return J>=Se.length?{done:!0}:{done:!1,value:Se[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function m(Se){me.defaults=Se}var f=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(be){return l[be]};function d(Se,be){if(be){if(f.test(Se))return Se.replace(k,w)}else if(N.test(Se))return Se.replace(E,w);return Se}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Se){return Se.replace(s,function(be,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var r=/(^|[^\[])\^/g;function i(Se,be){Se=typeof Se=="string"?Se:Se.source,be=be||"";var ge={replace:function(Z,he){return he=he.source||he,he=he.replace(r,"$1"),Se=Se.replace(Z,he),ge},getRegex:function(){return new RegExp(Se,be)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Se,be,ge){if(Se){var J;try{J=decodeURIComponent(a(ge)).replace(n,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}be&&!c.test(ge)&&(ge=v(be,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},p=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Se,be){t[" "+Se]||(p.test(Se)?t[" "+Se]=Se+"/":t[" "+Se]=g(Se,"/",!0)),Se=t[" "+Se];var ge=Se.indexOf(":")===-1;return be.substring(0,2)==="//"?ge?be:Se.replace(u,"$1")+be:be.charAt(0)==="/"?ge?be:Se.replace(o,"$1")+be:Se+be}var b={exec:function(){}};function $(Se){for(var be=1,ge,J;be<arguments.length;be++){ge=arguments[be];for(J in ge)Object.prototype.hasOwnProperty.call(ge,J)&&(Se[J]=ge[J])}return Se}function I(Se,be){var ge=Se.replace(/\|/g,function(he,fe,Te){for(var de=!1,Ce=fe;--Ce>=0&&Te[Ce]==="\\";)de=!de;return de?"|":" |"}),J=ge.split(/ \|/),Z=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>be)J.splice(be);else for(;J.length<be;)J.push("");for(;Z<J.length;Z++)J[Z]=J[Z].trim().replace(/\\\|/g,"|");return J}function g(Se,be,ge){var J=Se.length;if(J===0)return"";for(var Z=0;Z<J;){var he=Se.charAt(J-Z-1);if(he===be&&!ge)Z++;else if(he!==be&&ge)Z++;else break}return Se.slice(0,J-Z)}function D(Se,be){if(Se.indexOf(be[1])===-1)return-1;for(var ge=Se.length,J=0,Z=0;Z<ge;Z++)if(Se[Z]==="\\")Z++;else if(Se[Z]===be[0])J++;else if(Se[Z]===be[1]&&(J--,J<0))return Z;return-1}function y(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Se,be){if(be<1)return"";for(var ge="";be>1;)be&1&&(ge+=Se),be>>=1,Se+=Se;return ge+Se}function A(Se,be,ge,J){var Z=be.href,he=be.title?d(be.title):null,fe=Se[1].replace(/\\([\[\]])/g,"$1");if(Se[0].charAt(0)!=="!"){J.state.inLink=!0;var Te={type:"link",raw:ge,href:Z,title:he,text:fe,tokens:J.inlineTokens(fe)};return J.state.inLink=!1,Te}return{type:"image",raw:ge,href:Z,title:he,text:d(fe)}}function G(Se,be){var ge=Se.match(/^(\s+)(?:```)/);if(ge===null)return be;var J=ge[1];return be.split(`
`).map(function(Z){var he=Z.match(/^\s+/);if(he===null)return Z;var fe=he[0];return fe.length>=J.length?Z.slice(J.length):Z}).join(`
`)}var W=function(){function Se(ge){this.options=ge||me.defaults}var be=Se.prototype;return be.space=function(J){var Z=this.rules.block.newline.exec(J);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},be.code=function(J){var Z=this.rules.block.code.exec(J);if(Z){var he=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?he:g(he,`
`)}}},be.fences=function(J){var Z=this.rules.block.fences.exec(J);if(Z){var he=Z[0],fe=G(he,Z[3]||"");return{type:"code",raw:he,lang:Z[2]?Z[2].trim():Z[2],text:fe}}},be.heading=function(J){var Z=this.rules.block.heading.exec(J);if(Z){var he=Z[2].trim();if(/#$/.test(he)){var fe=g(he,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(he=fe.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:he,tokens:this.lexer.inline(he)}}},be.hr=function(J){var Z=this.rules.block.hr.exec(J);if(Z)return{type:"hr",raw:Z[0]}},be.blockquote=function(J){var Z=this.rules.block.blockquote.exec(J);if(Z){var he=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},be.list=function(J){var Z=this.rules.block.list.exec(J);if(Z){var he,fe,Te,de,Ce,Re,je,z,j,K,H,_,se=Z[1].trim(),Oe=se.length>1,Ve={type:"list",raw:"",ordered:Oe,start:Oe?+se.slice(0,-1):"",loose:!1,items:[]};se=Oe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Oe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(_=!1,!(!(Z=Qe.exec(J))||this.rules.block.hr.test(J)));){if(he=Z[0],J=J.substring(he.length),z=Z[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=Z[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=Z[1].length),Re=!1,!z&&/^ *$/.test(j)&&(he+=j+`
`,J=J.substring(j.length+1),_=!0),!_)for(var xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");J&&(K=J.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(z)||rt.test(z)||xe.test(z)||et.test(J)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Re)H+=`
`+z;else break;!Re&&!z.trim()&&(Re=!0),he+=K+`
`,J=J.substring(K.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(H),fe&&(Te=fe[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:he,task:!!fe,checked:Te,loose:!1,text:H}),Ve.raw+=he}Ve.items[Ve.items.length-1].raw=he.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var tt=Ve.items.length;for(Ce=0;Ce<tt;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var at=Ve.items[Ce].tokens.filter(function(it){return it.type==="space"}),Be=at.every(function(it){for(var Y=it.raw.split(""),X=0,pe=O(Y),We;!(We=pe()).done;){var Xe=We.value;if(Xe===`
`&&(X+=1),X>1)return!0}return!1});!Ve.loose&&at.length&&Be&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},be.html=function(J){var Z=this.rules.block.html.exec(J);if(Z){var he={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]);he.type="paragraph",he.text=fe,he.tokens=this.lexer.inline(fe)}return he}},be.def=function(J){var Z=this.rules.block.def.exec(J);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var he=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Z[0],href:Z[2],title:Z[3]}}},be.table=function(J){var Z=this.rules.block.table.exec(J);if(Z){var he={type:"table",header:I(Z[1]).map(function(je){return{text:je}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Z[0];var fe=he.align.length,Te,de,Ce,Re;for(Te=0;Te<fe;Te++)/^ *-+: *$/.test(he.align[Te])?he.align[Te]="right":/^ *:-+: *$/.test(he.align[Te])?he.align[Te]="center":/^ *:-+ *$/.test(he.align[Te])?he.align[Te]="left":he.align[Te]=null;for(fe=he.rows.length,Te=0;Te<fe;Te++)he.rows[Te]=I(he.rows[Te],he.header.length).map(function(je){return{text:je}});for(fe=he.header.length,de=0;de<fe;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(fe=he.rows.length,de=0;de<fe;de++)for(Re=he.rows[de],Ce=0;Ce<Re.length;Ce++)Re[Ce].tokens=this.lexer.inline(Re[Ce].text);return he}}},be.lheading=function(J){var Z=this.rules.block.lheading.exec(J);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},be.paragraph=function(J){var Z=this.rules.block.paragraph.exec(J);if(Z){var he=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:he,tokens:this.lexer.inline(he)}}},be.text=function(J){var Z=this.rules.block.text.exec(J);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},be.escape=function(J){var Z=this.rules.inline.escape.exec(J);if(Z)return{type:"escape",raw:Z[0],text:d(Z[1])}},be.tag=function(J){var Z=this.rules.inline.tag.exec(J);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]):Z[0]}},be.link=function(J){var Z=this.rules.inline.link.exec(J);if(Z){var he=Z[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var fe=g(he.slice(0,-1),"\\");if((he.length-fe.length)%2===0)return}else{var Te=D(Z[2],"()");if(Te>-1){var de=Z[0].indexOf("!")===0?5:4,Ce=de+Z[1].length+Te;Z[2]=Z[2].substring(0,Te),Z[0]=Z[0].substring(0,Ce).trim(),Z[3]=""}}var Re=Z[2],je="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);z&&(Re=z[1],je=z[3])}else je=Z[3]?Z[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(he)?Re=Re.slice(1):Re=Re.slice(1,-1)),A(Z,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},be.reflink=function(J,Z){var he;if((he=this.rules.inline.reflink.exec(J))||(he=this.rules.inline.nolink.exec(J))){var fe=(he[2]||he[1]).replace(/\s+/g," ");if(fe=Z[fe.toLowerCase()],!fe||!fe.href){var Te=he[0].charAt(0);return{type:"text",raw:Te,text:Te}}return A(he,fe,he[0],this.lexer)}},be.emStrong=function(J,Z,he){he===void 0&&(he="");var fe=this.rules.inline.emStrong.lDelim.exec(J);if(fe&&!(fe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=fe[1]||fe[2]||"";if(!Te||Te&&(he===""||this.rules.inline.punctuation.exec(he))){var de=fe[0].length-1,Ce,Re,je=de,z=0,j=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,Z=Z.slice(-1*J.length+de);(fe=j.exec(Z))!=null;)if(Ce=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ce){if(Re=Ce.length,fe[3]||fe[4]){je+=Re;continue}else if((fe[5]||fe[6])&&de%3&&!((de+Re)%3)){z+=Re;continue}if(je-=Re,!(je>0)){if(Re=Math.min(Re,Re+je+z),Math.min(de,Re)%2){var K=J.slice(1,de+fe.index+Re);return{type:"em",raw:J.slice(0,de+fe.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=J.slice(2,de+fe.index+Re-1);return{type:"strong",raw:J.slice(0,de+fe.index+Re+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(J){var Z=this.rules.inline.code.exec(J);if(Z){var he=Z[2].replace(/\n/g," "),fe=/[^ ]/.test(he),Te=/^ /.test(he)&&/ $/.test(he);return fe&&Te&&(he=he.substring(1,he.length-1)),he=d(he,!0),{type:"codespan",raw:Z[0],text:he}}},be.br=function(J){var Z=this.rules.inline.br.exec(J);if(Z)return{type:"br",raw:Z[0]}},be.del=function(J){var Z=this.rules.inline.del.exec(J);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},be.autolink=function(J,Z){var he=this.rules.inline.autolink.exec(J);if(he){var fe,Te;return he[2]==="@"?(fe=d(this.options.mangle?Z(he[1]):he[1]),Te="mailto:"+fe):(fe=d(he[1]),Te=fe),{type:"link",raw:he[0],text:fe,href:Te,tokens:[{type:"text",raw:fe,text:fe}]}}},be.url=function(J,Z){var he;if(he=this.rules.inline.url.exec(J)){var fe,Te;if(he[2]==="@")fe=d(this.options.mangle?Z(he[0]):he[0]),Te="mailto:"+fe;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);fe=d(he[0]),he[1]==="www."?Te="http://"+fe:Te=fe}return{type:"link",raw:he[0],text:fe,href:Te,tokens:[{type:"text",raw:fe,text:fe}]}}},be.inlineText=function(J,Z){var he=this.rules.inline.text.exec(J);if(he){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):d(he[0]):he[0]:fe=d(this.options.smartypants?Z(he[0]):he[0]),{type:"text",raw:he[0],text:fe}}},Se}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=$({},U),U.gfm=$({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=$({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=$({},C),C.pedantic=$({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=$({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=$({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Se){var be="",ge,J,Z=Se.length;for(ge=0;ge<Z;ge++)J=Se.charCodeAt(ge),Math.random()>.5&&(J="x"+J.toString(16)),be+="&#"+J+";";return be}var ne=function(){function Se(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:U.normal,inline:C.normal};this.options.pedantic?(J.block=U.pedantic,J.inline=C.pedantic):this.options.gfm&&(J.block=U.gfm,this.options.breaks?J.inline=C.breaks:J.inline=C.gfm),this.tokenizer.rules=J}Se.lex=function(J,Z){var he=new Se(Z);return he.lex(J)},Se.lexInline=function(J,Z){var he=new Se(Z);return he.inlineTokens(J)};var be=Se.prototype;return be.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},be.blockTokens=function(J,Z){var he=this;Z===void 0&&(Z=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(je,z,j){return z+"    ".repeat(j.length)});for(var fe,Te,de,Ce;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(fe=je.call({lexer:he},J,Z))?(J=J.substring(fe.raw.length),Z.push(fe),!0):!1}))){if(fe=this.tokenizer.space(J)){J=J.substring(fe.raw.length),fe.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(fe);continue}if(fe=this.tokenizer.code(J)){J=J.substring(fe.raw.length),Te=Z[Z.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(fe);continue}if(fe=this.tokenizer.fences(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.heading(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.hr(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.blockquote(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.list(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.html(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.def(J)){J=J.substring(fe.raw.length),Te=Z[Z.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.lheading(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(de=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,z=J.slice(1),j=void 0;he.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},z),typeof j=="number"&&j>=0&&(je=Math.min(je,j))}),je<1/0&&je>=0&&(de=J.substring(0,je+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(de))){Te=Z[Z.length-1],Ce&&Te.type==="paragraph"?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(fe),Ce=de.length!==J.length,J=J.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(J)){J=J.substring(fe.raw.length),Te=Z[Z.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(fe);continue}if(J){var Re="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Z},be.inline=function(J,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:J,tokens:Z}),Z},be.inlineTokens=function(J,Z){var he=this;Z===void 0&&(Z=[]);var fe,Te,de,Ce=J,Re,je,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)j.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Re.index)+"["+P("a",Re[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Re.index)+"["+P("a",Re[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Re.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(je||(z=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(fe=H.call({lexer:he},J,Z))?(J=J.substring(fe.raw.length),Z.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.tag(J)){J=J.substring(fe.raw.length),Te=Z[Z.length-1],Te&&fe.type==="text"&&Te.type==="text"?(Te.raw+=fe.raw,Te.text+=fe.text):Z.push(fe);continue}if(fe=this.tokenizer.link(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(fe.raw.length),Te=Z[Z.length-1],Te&&fe.type==="text"&&Te.type==="text"?(Te.raw+=fe.raw,Te.text+=fe.text):Z.push(fe);continue}if(fe=this.tokenizer.emStrong(J,Ce,z)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.codespan(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.br(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.del(J)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.autolink(J,q)){J=J.substring(fe.raw.length),Z.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(J,q))){J=J.substring(fe.raw.length),Z.push(fe);continue}if(de=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,_=J.slice(1),se=void 0;he.options.extensions.startInline.forEach(function(Oe){se=Oe.call({lexer:this},_),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(de=J.substring(0,H+1))}(),fe=this.tokenizer.inlineText(de,T)){J=J.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(z=fe.raw.slice(-1)),je=!0,Te=Z[Z.length-1],Te&&Te.type==="text"?(Te.raw+=fe.raw,Te.text+=fe.text):Z.push(fe);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Z},S(Se,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Se}(),ce=function(){function Se(ge){this.options=ge||me.defaults}var be=Se.prototype;return be.code=function(J,Z,he){var fe=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(J,fe);Te!=null&&Te!==J&&(he=!0,J=Te)}return J=J.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+d(fe,!0)+'">'+(he?J:d(J,!0))+`</code></pre>
`:"<pre><code>"+(he?J:d(J,!0))+`</code></pre>
`},be.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},be.html=function(J){return J},be.heading=function(J,Z,he,fe){if(this.options.headerIds){var Te=this.options.headerPrefix+fe.slug(he);return"<h"+Z+' id="'+Te+'">'+J+"</h"+Z+`>
`}return"<h"+Z+">"+J+"</h"+Z+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(J,Z,he){var fe=Z?"ol":"ul",Te=Z&&he!==1?' start="'+he+'"':"";return"<"+fe+Te+`>
`+J+"</"+fe+`>
`},be.listitem=function(J){return"<li>"+J+`</li>
`},be.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(J){return"<p>"+J+`</p>
`},be.table=function(J,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Z+`</table>
`},be.tablerow=function(J){return`<tr>
`+J+`</tr>
`},be.tablecell=function(J,Z){var he=Z.header?"th":"td",fe=Z.align?"<"+he+' align="'+Z.align+'">':"<"+he+">";return fe+J+("</"+he+`>
`)},be.strong=function(J){return"<strong>"+J+"</strong>"},be.em=function(J){return"<em>"+J+"</em>"},be.codespan=function(J){return"<code>"+J+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(J){return"<del>"+J+"</del>"},be.link=function(J,Z,he){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var fe='<a href="'+d(J)+'"';return Z&&(fe+=' title="'+Z+'"'),fe+=">"+he+"</a>",fe},be.image=function(J,Z,he){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var fe='<img src="'+J+'" alt="'+he+'"';return Z&&(fe+=' title="'+Z+'"'),fe+=this.options.xhtml?"/>":">",fe},be.text=function(J){return J},Se}(),ye=function(){function Se(){}var be=Se.prototype;return be.strong=function(J){return J},be.em=function(J){return J},be.codespan=function(J){return J},be.del=function(J){return J},be.html=function(J){return J},be.text=function(J){return J},be.link=function(J,Z,he){return""+he},be.image=function(J,Z,he){return""+he},be.br=function(){return""},Se}(),Ie=function(){function Se(){this.seen={}}var be=Se.prototype;return be.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(J,Z){var he=J,fe=0;if(this.seen.hasOwnProperty(he)){fe=this.seen[J];do fe++,he=J+"-"+fe;while(this.seen.hasOwnProperty(he))}return Z||(this.seen[J]=fe,this.seen[he]=0),he},be.slug=function(J,Z){Z===void 0&&(Z={});var he=this.serialize(J);return this.getNextSafeSlug(he,Z.dryrun)},Se}(),ue=function(){function Se(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ie}Se.parse=function(J,Z){var he=new Se(Z);return he.parse(J)},Se.parseInline=function(J,Z){var he=new Se(Z);return he.parseInline(J)};var be=Se.prototype;return be.parse=function(J,Z){Z===void 0&&(Z=!0);var he="",fe,Te,de,Ce,Re,je,z,j,K,H,_,se,Oe,Ve,Qe,xe,et,ot,rt,tt=J.length;for(fe=0;fe<tt;fe++){if(H=J[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(rt=this.options.extensions.renderers[H.type].call({parser:this},H),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=rt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,a(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",z="",Ce=H.header.length,Te=0;Te<Ce;Te++)z+=this.renderer.tablecell(this.parseInline(H.header[Te].tokens),{header:!0,align:H.align[Te]});for(j+=this.renderer.tablerow(z),K="",Ce=H.rows.length,Te=0;Te<Ce;Te++){for(je=H.rows[Te],z="",Re=je.length,de=0;de<Re;de++)z+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:H.align[de]});K+=this.renderer.tablerow(z)}he+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(H.tokens),he+=this.renderer.blockquote(K);continue}case"list":{for(_=H.ordered,se=H.start,Oe=H.loose,Ce=H.items.length,K="",Te=0;Te<Ce;Te++)Qe=H.items[Te],xe=Qe.checked,et=Qe.task,Ve="",Qe.task&&(ot=this.renderer.checkbox(xe),Oe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=ot+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=ot+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:ot}):Ve+=ot),Ve+=this.parse(Qe.tokens,Oe),K+=this.renderer.listitem(Ve,et,xe);he+=this.renderer.list(K,_,se);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;fe+1<tt&&J[fe+1].type==="text";)H=J[++fe],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Z?this.renderer.paragraph(K):K;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},be.parseInline=function(J,Z){Z=Z||this.renderer;var he="",fe,Te,de,Ce=J.length;for(fe=0;fe<Ce;fe++){if(Te=J[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(de=this.options.extensions.renderers[Te.type].call({parser:this},Te),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){he+=de||"";continue}switch(Te.type){case"escape":{he+=Z.text(Te.text);break}case"html":{he+=Z.html(Te.text);break}case"link":{he+=Z.link(Te.href,Te.title,this.parseInline(Te.tokens,Z));break}case"image":{he+=Z.image(Te.href,Te.title,Te.text);break}case"strong":{he+=Z.strong(this.parseInline(Te.tokens,Z));break}case"em":{he+=Z.em(this.parseInline(Te.tokens,Z));break}case"codespan":{he+=Z.codespan(Te.text);break}case"br":{he+=Z.br();break}case"del":{he+=Z.del(this.parseInline(Te.tokens,Z));break}case"text":{he+=Z.text(Te.text);break}default:{var Re='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return he},Se}();function ve(Se,be,ge){if(typeof Se>"u"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof be=="function"&&(ge=be,be=null),be=$({},ve.defaults,be||{}),y(be),ge){var J=be.highlight,Z;try{Z=ne.lex(Se,be)}catch(Ce){return ge(Ce)}var he=function(Re){var je;if(!Re)try{be.walkTokens&&ve.walkTokens(Z,be.walkTokens),je=ue.parse(Z,be)}catch(z){Re=z}return be.highlight=J,Re?ge(Re):ge(null,je)};if(!J||J.length<3||(delete be.highlight,!Z.length))return he();var fe=0;ve.walkTokens(Z,function(Ce){Ce.type==="code"&&(fe++,setTimeout(function(){J(Ce.text,Ce.lang,function(Re,je){if(Re)return he(Re);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),fe--,fe===0&&he()})},0))}),fe===0&&he();return}function Te(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ne.lex(Se,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(de,be.walkTokens)).then(function(){return ue.parse(de,be)}).catch(Te);ve.walkTokens(de,be.walkTokens)}return ue.parse(de,be)}catch(Ce){Te(Ce)}}ve.options=ve.setOptions=function(Se){return $(ve.defaults,Se),m(ve.defaults),ve},ve.getDefaults=R,ve.defaults=me.defaults,ve.use=function(){for(var Se=arguments.length,be=new Array(Se),ge=0;ge<Se;ge++)be[ge]=arguments[ge];var J=$.apply(void 0,[{}].concat(be)),Z=ve.defaults.extensions||{renderers:{},childTokens:{}},he;be.forEach(function(fe){if(fe.extensions&&(he=!0,fe.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Z.renderers?Z.renderers[de.name]:null;Ce?Z.renderers[de.name]=function(){for(var Re=arguments.length,je=new Array(Re),z=0;z<Re;z++)je[z]=arguments[z];var j=de.renderer.apply(this,je);return j===!1&&(j=Ce.apply(this,je)),j}:Z.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[de.level]?Z[de.level].unshift(de.tokenizer):Z[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Z.startBlock?Z.startBlock.push(de.start):Z.startBlock=[de.start]:de.level==="inline"&&(Z.startInline?Z.startInline.push(de.start):Z.startInline=[de.start]))}de.childTokens&&(Z.childTokens[de.name]=de.childTokens)})),fe.renderer&&function(){var de=ve.defaults.renderer||new ce,Ce=function(z){var j=de[z];de[z]=function(){for(var K=arguments.length,H=new Array(K),_=0;_<K;_++)H[_]=arguments[_];var se=fe.renderer[z].apply(de,H);return se===!1&&(se=j.apply(de,H)),se}};for(var Re in fe.renderer)Ce(Re);J.renderer=de}(),fe.tokenizer&&function(){var de=ve.defaults.tokenizer||new W,Ce=function(z){var j=de[z];de[z]=function(){for(var K=arguments.length,H=new Array(K),_=0;_<K;_++)H[_]=arguments[_];var se=fe.tokenizer[z].apply(de,H);return se===!1&&(se=j.apply(de,H)),se}};for(var Re in fe.tokenizer)Ce(Re);J.tokenizer=de}(),fe.walkTokens){var Te=ve.defaults.walkTokens;J.walkTokens=function(de){var Ce=[];return Ce.push(fe.walkTokens.call(this,de)),Te&&(Ce=Ce.concat(Te.call(this,de))),Ce}}he&&(J.extensions=Z),ve.setOptions(J)})},ve.walkTokens=function(Se,be){for(var ge=[],J=function(){var Te=he.value;switch(ge=ge.concat(be.call(ve,Te)),Te.type){case"table":{for(var de=O(Te.header),Ce;!(Ce=de()).done;){var Re=Ce.value;ge=ge.concat(ve.walkTokens(Re.tokens,be))}for(var je=O(Te.rows),z;!(z=je()).done;)for(var j=z.value,K=O(j),H;!(H=K()).done;){var _=H.value;ge=ge.concat(ve.walkTokens(_.tokens,be))}break}case"list":{ge=ge.concat(ve.walkTokens(Te.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Te.type]?ve.defaults.extensions.childTokens[Te.type].forEach(function(se){ge=ge.concat(ve.walkTokens(Te[se],be))}):Te.tokens&&(ge=ge.concat(ve.walkTokens(Te.tokens,be)))}},Z=O(Se),he;!(he=Z()).done;)J();return ge},ve.parseInline=function(Se,be){if(typeof Se>"u"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");be=$({},ve.defaults,be||{}),y(be);try{var ge=ne.lexInline(Se,be);return be.walkTokens&&ve.walkTokens(ge,be.walkTokens),ue.parseInline(ge,be)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(J.message+"",!0)+"</pre>";throw J}},ve.Parser=ue,ve.parser=ue.parse,ve.Renderer=ce,ve.TextRenderer=ye,ve.Lexer=ne,ve.lexer=ne.lex,ve.Tokenizer=W,ve.Slugger=Ie,ve.parse=ve;var re=ve.options,$e=ve.setOptions,ie=ve.use,le=ve.walkTokens,V=ve.parseInline,ee=ve,ke=ue.parse,Ne=ne.lex;me.Lexer=ne,me.Parser=ue,me.Renderer=ce,me.Slugger=Ie,me.TextRenderer=ye,me.Tokenizer=W,me.getDefaults=R,me.lexer=Ne,me.marked=ve,me.options=re,me.parse=ee,me.parseInline=V,me.parser=ke,me.setOptions=$e,me.use=ie,me.walkTokens=le,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[124],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=S;function S(s){const a=O(s);if(a&&a.length>0)return new Uint32Array(a)}let F=0;const M=new Uint32Array(10);function O(s){if(F=0,R(s,E,4352),F>0||(R(s,l,4449),F>0)||(R(s,w,4520),F>0)||(R(s,d,12593),F))return M.subarray(0,F);if(s>=44032&&s<=55203){const a=s-44032,r=a%588,i=Math.floor(a/588),n=Math.floor(r/28),c=r%28-1;if(i<E.length?R(i,E,0):4352+i-12593<d.length&&R(4352+i,d,12593),n<l.length?R(n,l,0):4449+n-12593<d.length&&R(4449+n-12593,d,12593),c>=0&&(c<w.length?R(c,w,0):4520+c-12593<d.length&&R(4520+c-12593,d,12593)),F>0)return M.subarray(0,F)}}function R(s,a,r){s>=r&&s<r+a.length&&m(a[s-r])}function m(s){s!==0&&(M[F++]=s&255,s>>8&&(M[F++]=s>>8&255),s>>16&&(M[F++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var N;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(N||(N={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[125],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0,e.$lm=S,e.rot=F;function S(m,f,k){return Math.min(Math.max(m,f),k)}function F(m,f){return(f+m%f)%f}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$nm=M;class O{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$om=O;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const k=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$pm=R}),function(){function me(M){const O=[];typeof M=="number"&&O.push("code/timeOrigin",M);function R(f){O.push(f,Date.now())}function m(){const f=[];for(let k=0;k<O.length;k+=2)f.push({name:O[k],startTime:O[k+1]});return f}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))O.push({name:R.name,startTime:Math.round(M+R.startTime)});return O}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:me)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(F){if(e[F])return e[F].exports;var M=e[F]={i:F,l:!1,exports:{}};return me[F].call(M.exports,M,M.exports,S),M.l=!0,M.exports}return S.m=me,S.c=e,S.d=function(F,M,O){S.o(F,M)||Object.defineProperty(F,M,{enumerable:!0,get:O})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,M){if(1&M&&(F=S(F)),8&M||4&M&&typeof F=="object"&&F&&F.__esModule)return F;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:F}),2&M&&typeof F!="string")for(var R in F)S.d(O,R,function(m){return F[m]}.bind(null,R));return O},S.n=function(F){var M=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(M,"a",M),M},S.o=function(F,M){return Object.prototype.hasOwnProperty.call(F,M)},S.p="",S(S.s=0)}([function(me,e,S){(function(F){var M;e=me.exports=ie,M=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],k=0,N=k++;f[N]="0|[1-9]\\d*";var E=k++;f[E]="[0-9]+";var l=k++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=k++;f[w]="("+f[N]+")\\.("+f[N]+")\\.("+f[N]+")";var d=k++;f[d]="("+f[E]+")\\.("+f[E]+")\\.("+f[E]+")";var s=k++;f[s]="(?:"+f[N]+"|"+f[l]+")";var a=k++;f[a]="(?:"+f[E]+"|"+f[l]+")";var r=k++;f[r]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var i=k++;f[i]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var n=k++;f[n]="[0-9A-Za-z-]+";var c=k++;f[c]="(?:\\+("+f[n]+"(?:\\."+f[n]+")*))";var h=k++,t="v?"+f[w]+f[r]+"?"+f[c]+"?";f[h]="^"+t+"$";var p="[v=\\s]*"+f[d]+f[i]+"?"+f[c]+"?",u=k++;f[u]="^"+p+"$";var o=k++;f[o]="((?:<|>)?=?)";var v=k++;f[v]=f[E]+"|x|X|\\*";var b=k++;f[b]=f[N]+"|x|X|\\*";var $=k++;f[$]="[v=\\s]*("+f[b]+")(?:\\.("+f[b]+")(?:\\.("+f[b]+")(?:"+f[r]+")?"+f[c]+"?)?)?";var I=k++;f[I]="[v=\\s]*("+f[v]+")(?:\\.("+f[v]+")(?:\\.("+f[v]+")(?:"+f[i]+")?"+f[c]+"?)?)?";var g=k++;f[g]="^"+f[o]+"\\s*"+f[$]+"$";var D=k++;f[D]="^"+f[o]+"\\s*"+f[I]+"$";var y=k++;f[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;f[P]="(?:~>?)";var A=k++;f[A]="(\\s*)"+f[P]+"\\s+",m[A]=new RegExp(f[A],"g");var G=k++;f[G]="^"+f[P]+f[$]+"$";var W=k++;f[W]="^"+f[P]+f[I]+"$";var U=k++;f[U]="(?:\\^)";var C=k++;f[C]="(\\s*)"+f[U]+"\\s+",m[C]=new RegExp(f[C],"g");var T=k++;f[T]="^"+f[U]+f[$]+"$";var q=k++;f[q]="^"+f[U]+f[I]+"$";var ne=k++;f[ne]="^"+f[o]+"\\s*("+p+")$|^$";var ce=k++;f[ce]="^"+f[o]+"\\s*("+t+")$|^$";var ye=k++;f[ye]="(\\s*)"+f[o]+"\\s*("+p+"|"+f[$]+")",m[ye]=new RegExp(f[ye],"g");var Ie=k++;f[Ie]="^\\s*("+f[$]+")\\s+-\\s+("+f[$]+")\\s*$";var ue=k++;f[ue]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var ve=k++;f[ve]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)M(re,f[re]),m[re]||(m[re]=new RegExp(f[re]));function $e(j,K){if(j instanceof ie)return j;if(typeof j!="string"||j.length>O||!(K?m[u]:m[h]).test(j))return null;try{return new ie(j,K)}catch{return null}}function ie(j,K){if(j instanceof ie){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ie))return new ie(j,K);M("SemVer",j,K),this.loose=K;var H=j.trim().match(K?m[u]:m[h]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(_){if(/^[0-9]+$/.test(_)){var se=+_;if(se>=0&&se<R)return se}return _}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,K){var H=$e(j,K);return H?H.version:null},e.clean=function(j,K){var H=$e(j.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(j){return M("SemVer.compare",this.version,this.loose,j),j instanceof ie||(j=new ie(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ie.prototype.compareMain=function(j){return j instanceof ie||(j=new ie(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},ie.prototype.comparePre=function(j){if(j instanceof ie||(j=new ie(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],_=j.prerelease[K];if(M("prerelease compare",K,H,_),H===void 0&&_===void 0)return 0;if(_===void 0)return 1;if(H===void 0)return-1;if(H!==_)return V(H,_)}while(++K)},ie.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,H,_){typeof H=="string"&&(_=H,H=void 0);try{return new ie(j,H).inc(K,_).version}catch{return null}},e.diff=function(j,K){if(Se(j,K))return null;var H=$e(j),_=$e(K);if(H.prerelease.length||_.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==_[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==_[se])return se},e.compareIdentifiers=V;var le=/^[0-9]+$/;function V(j,K){var H=le.test(j),_=le.test(K);return H&&_&&(j=+j,K=+K),H&&!_?-1:_&&!H?1:j<K?-1:j>K?1:0}function ee(j,K,H){return new ie(j,H).compare(new ie(K,H))}function ke(j,K,H){return ee(j,K,H)>0}function Ne(j,K,H){return ee(j,K,H)<0}function Se(j,K,H){return ee(j,K,H)===0}function be(j,K,H){return ee(j,K,H)!==0}function ge(j,K,H){return ee(j,K,H)>=0}function J(j,K,H){return ee(j,K,H)<=0}function Z(j,K,H,_){var se;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j!==H;break;case"":case"=":case"==":se=Se(j,H,_);break;case"!=":se=be(j,H,_);break;case">":se=ke(j,H,_);break;case">=":se=ge(j,H,_);break;case"<":se=Ne(j,H,_);break;case"<=":se=J(j,H,_);break;default:throw new TypeError("Invalid operator: "+K)}return se}function he(j,K){if(j instanceof he){if(j.loose===K)return j;j=j.value}if(!(this instanceof he))return new he(j,K);M("comparator",j,K),this.loose=K,this.parse(j),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(j,K){return V(K,j)},e.major=function(j,K){return new ie(j,K).major},e.minor=function(j,K){return new ie(j,K).minor},e.patch=function(j,K){return new ie(j,K).patch},e.compare=ee,e.compareLoose=function(j,K){return ee(j,K,!0)},e.rcompare=function(j,K,H){return ee(K,j,H)},e.sort=function(j,K){return j.sort(function(H,_){return e.compare(H,_,K)})},e.rsort=function(j,K){return j.sort(function(H,_){return e.rcompare(H,_,K)})},e.gt=ke,e.lt=Ne,e.eq=Se,e.neq=be,e.gte=ge,e.lte=J,e.cmp=Z,e.Comparator=he;var fe={};function Te(j,K){if(j instanceof Te)return j.loose===K?j:new Te(j.raw,K);if(j instanceof he)return new Te(j.value,K);if(!(this instanceof Te))return new Te(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function de(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ce(j,K,H,_,se,Oe,Ve,Qe,xe,et,ot,rt,tt){return((K=de(H)?"":de(_)?">="+H+".0.0":de(se)?">="+H+"."+_+".0":">="+K)+" "+(Qe=de(xe)?"":de(et)?"<"+(+xe+1)+".0.0":de(ot)?"<"+xe+"."+(+et+1)+".0":rt?"<="+xe+"."+et+"."+ot+"-"+rt:"<="+Qe)).trim()}function Re(j,K){for(var H=0;H<j.length;H++)if(!j[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<j.length;H++)if(M(j[H].semver),j[H].semver!==fe&&j[H].semver.prerelease.length>0){var _=j[H].semver;if(_.major===K.major&&_.minor===K.minor&&_.patch===K.patch)return!0}return!1}return!0}function je(j,K,H){try{K=new Te(K,H)}catch{return!1}return K.test(j)}function z(j,K,H,_){var se,Oe,Ve,Qe,xe;switch(j=new ie(j,_),K=new Te(K,_),H){case">":se=ke,Oe=J,Ve=Ne,Qe=">",xe=">=";break;case"<":se=Ne,Oe=ge,Ve=ke,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(j,K,_))return!1;for(var et=0;et<K.set.length;++et){var ot=K.set[et],rt=null,tt=null;if(ot.forEach(function(at){at.semver===fe&&(at=new he(">=0.0.0")),rt=rt||at,tt=tt||at,se(at.semver,rt.semver,_)?rt=at:Ve(at.semver,tt.semver,_)&&(tt=at)}),rt.operator===Qe||rt.operator===xe||(!tt.operator||tt.operator===Qe)&&Oe(j,tt.semver)||tt.operator===xe&&Ve(j,tt.semver))return!1}return!0}he.prototype.parse=function(j){var K=this.loose?m[ne]:m[ce],H=j.match(K);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ie(H[2],this.loose):this.semver=fe},he.prototype.toString=function(){return this.value},he.prototype.test=function(j){return M("Comparator.test",j,this.loose),this.semver===fe||(typeof j=="string"&&(j=new ie(j,this.loose)),Z(j,this.operator,this.semver,this.loose))},he.prototype.intersects=function(j,K){if(!(j instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Te(j.value,K),je(this.value,H,K);if(j.operator==="")return H=new Te(this.value,K),je(j.semver,H,K);var _=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Oe=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Qe=Z(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=Z(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return _||se||Oe&&Ve||Qe||xe},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),M("range",j,K);var H=K?m[ue]:m[Ie];j=j.replace(H,Ce),M("hyphen replace",j),j=j.replace(m[ye],"$1$2$3"),M("comparator trim",j,m[ye]),j=(j=(j=j.replace(m[A],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var _=K?m[ne]:m[ce],se=j.split(" ").map(function(Oe){return function(Ve,Qe){return M("comp",Ve),Ve=function(xe,et){return xe.trim().split(/\s+/).map(function(ot){return function(rt,tt){M("caret",rt,tt);var at=tt?m[q]:m[T];return rt.replace(at,function(Be,it,Y,X,pe){var We;return M("caret",rt,Be,it,Y,X,pe),de(it)?We="":de(Y)?We=">="+it+".0.0 <"+(+it+1)+".0.0":de(X)?We=it==="0"?">="+it+"."+Y+".0 <"+it+"."+(+Y+1)+".0":">="+it+"."+Y+".0 <"+(+it+1)+".0.0":pe?(M("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=it==="0"?Y==="0"?">="+it+"."+Y+"."+X+pe+" <"+it+"."+Y+"."+(+X+1):">="+it+"."+Y+"."+X+pe+" <"+it+"."+(+Y+1)+".0":">="+it+"."+Y+"."+X+pe+" <"+(+it+1)+".0.0"):(M("no pr"),We=it==="0"?Y==="0"?">="+it+"."+Y+"."+X+" <"+it+"."+Y+"."+(+X+1):">="+it+"."+Y+"."+X+" <"+it+"."+(+Y+1)+".0":">="+it+"."+Y+"."+X+" <"+(+it+1)+".0.0"),M("caret return",We),We})}(ot,et)}).join(" ")}(Ve,Qe),M("caret",Ve),Ve=function(xe,et){return xe.trim().split(/\s+/).map(function(ot){return function(rt,tt){var at=tt?m[W]:m[G];return rt.replace(at,function(Be,it,Y,X,pe){var We;return M("tilde",rt,Be,it,Y,X,pe),de(it)?We="":de(Y)?We=">="+it+".0.0 <"+(+it+1)+".0.0":de(X)?We=">="+it+"."+Y+".0 <"+it+"."+(+Y+1)+".0":pe?(M("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=">="+it+"."+Y+"."+X+pe+" <"+it+"."+(+Y+1)+".0"):We=">="+it+"."+Y+"."+X+" <"+it+"."+(+Y+1)+".0",M("tilde return",We),We})}(ot,et)}).join(" ")}(Ve,Qe),M("tildes",Ve),Ve=function(xe,et){return M("replaceXRanges",xe,et),xe.split(/\s+/).map(function(ot){return function(rt,tt){rt=rt.trim();var at=tt?m[D]:m[g];return rt.replace(at,function(Be,it,Y,X,pe,We){M("xRange",rt,Be,it,Y,X,pe,We);var Xe=de(Y),st=Xe||de(X),Fe=st||de(pe);return it==="="&&Fe&&(it=""),Xe?Be=it===">"||it==="<"?"<0.0.0":"*":it&&Fe?(st&&(X=0),Fe&&(pe=0),it===">"?(it=">=",st?(Y=+Y+1,X=0,pe=0):Fe&&(X=+X+1,pe=0)):it==="<="&&(it="<",st?Y=+Y+1:X=+X+1),Be=it+Y+"."+X+"."+pe):st?Be=">="+Y+".0.0 <"+(+Y+1)+".0.0":Fe&&(Be=">="+Y+"."+X+".0 <"+Y+"."+(+X+1)+".0"),M("xRange return",Be),Be})}(ot,et)}).join(" ")}(Ve,Qe),M("xrange",Ve),Ve=function(xe,et){return M("replaceStars",xe,et),xe.trim().replace(m[ve],"")}(Ve,Qe),M("stars",Ve),Ve}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Oe){return!!Oe.match(_)})),se=se.map(function(Oe){return new he(Oe,K)})},Te.prototype.intersects=function(j,K){if(!(j instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(_){return j.set.some(function(se){return se.every(function(Oe){return _.intersects(Oe,K)})})})})},e.toComparators=function(j,K){return new Te(j,K).set.map(function(H){return H.map(function(_){return _.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ie(j,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],j))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(j,K,H){var _=null,se=null;try{var Oe=new Te(K,H)}catch{return null}return j.forEach(function(Ve){Oe.test(Ve)&&(_&&se.compare(Ve)!==-1||(se=new ie(_=Ve,H)))}),_},e.minSatisfying=function(j,K,H){var _=null,se=null;try{var Oe=new Te(K,H)}catch{return null}return j.forEach(function(Ve){Oe.test(Ve)&&(_&&se.compare(Ve)!==1||(se=new ie(_=Ve,H)))}),_},e.validRange=function(j,K){try{return new Te(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,H){return z(j,K,"<",H)},e.gtr=function(j,K,H){return z(j,K,">",H)},e.outside=z,e.prerelease=function(j,K){var H=$e(j,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,K,H){return j=new Te(j,H),K=new Te(K,H),j.intersects(K)},e.coerce=function(j){if(j instanceof ie)return j;if(typeof j!="string")return null;var K=j.match(m[y]);return K==null?null:$e((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(me,e){var S,F,M=me.exports={};function O(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(a){if(S===setTimeout)return setTimeout(a,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var f,k=[],N=!1,E=-1;function l(){N&&f&&(N=!1,f.length?k=f.concat(k):E=-1,k.length&&w())}function w(){if(!N){var a=m(l);N=!0;for(var r=k.length;r;){for(f=k,k=[];++E<r;)f&&f[E].run();E=-1,r=k.length}f=null,N=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(a)}}function d(a,r){this.fun=a,this.array=r}function s(){}M.nextTick=function(a){var r=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)r[i-1]=arguments[i];k.push(new d(a,r)),k.length!==1||N||m(w)},d.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=s,M.addListener=s,M.once=s,M.off=s,M.removeListener=s,M.removeAllListeners=s,M.emit=s,M.prependListener=s,M.prependOnceListener=s,M.listeners=function(a){return[]},M.binding=function(a){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(a){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Pe[126],Me([1,0,14,6]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=M,e.$fe=O,e.$ge=R,e.$he=m,e.$ie=k,e.$je=N,e.$ke=E,e.$le=l,e.$me=w,e.$ne=d,e.$oe=s,e.$pe=a,e.$qe=r,e.$re=i,e.$se=n;function M(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function R(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(c,h){return new f(c,h)}class f{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let p;switch(h){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const u=p.indexOf(t);u>=0&&p.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(c,h){const t=[];let p;for(;(p=c.read())!==null;)t.push(p);return h(t)}function N(c,h,t){const p=[];let u;for(;(u=c.read())!==null&&p.length<t;)p.push(u);return u===null&&p.length>0?h(p):{read:()=>{if(p.length>0)return p.shift();if(typeof u<"u"){const o=u;return u=void 0,o}return c.read()}}}function E(c,h){return new Promise((t,p)=>{const u=[];l(c,{onData:o=>{h&&u.push(o)},onError:o=>{h?p(o):t(void 0)},onEnd:()=>{t(h?h(u):void 0)}})})}function l(c,h,t){c.on("error",p=>{t?.isCancellationRequested||h.onError(p)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",p=>{t?.isCancellationRequested||h.onData(p)})}function w(c,h){return new Promise((t,p)=>{const u=new F.$Sc,o=[],v=I=>{if(o.push(I),o.length>h)return u.dispose(),c.pause(),t({stream:c,buffer:o,ended:!1})},b=I=>(u.dispose(),p(I)),$=()=>(u.dispose(),t({stream:c,buffer:o,ended:!0}));u.add((0,F.$Rc)(()=>c.removeListener("error",b))),c.on("error",b),u.add((0,F.$Rc)(()=>c.removeListener("end",$))),c.on("end",$),u.add((0,F.$Rc)(()=>c.removeListener("data",v))),c.on("data",v)})}function d(c,h){const t=m(h);return t.end(c),t}function s(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}function a(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function r(c,h,t){const p=m(t);return l(c,{onData:u=>p.write(h.data(u)),onError:u=>p.error(h.error?h.error(u):u),onEnd:()=>p.end()}),p}function i(c,h,t){let p=!1;return{read:()=>{const u=h.read();return p?u:(p=!0,u!==null?t([c,u]):c)}}}function n(c,h,t){let p=!1;const u=m(t);return l(h,{onData:o=>p?u.write(o):(p=!0,u.write(t([c,o]))),onError:o=>u.error(o),onEnd:()=>{p||(p=!0,u.write(c)),u.end()}}),u}}),define(Pe[23],Me([1,0,39,126]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=void 0,e.$ue=k,e.$ve=N,e.$we=E,e.$xe=l,e.$ye=w,e.$ze=d,e.$Ae=s,e.$Be=a,e.$Ce=r,e.$De=i,e.$Ee=n,e.$Fe=c,e.$Ge=h,e.$He=t,e.$Ie=p,e.$Je=u,e.$Ke=o,e.$Le=v,e.$Me=b,e.$Ne=g;const M=typeof Buffer<"u",O=new S.$V(()=>new Uint8Array(256));let R,m;class f{static alloc(y){return M?new f(Buffer.allocUnsafe(y)):new f(new Uint8Array(y))}static wrap(y){return M&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new f(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&M?new f(Buffer.from(y)):(R||(R=new TextEncoder),new f(R.encode(y)))}static fromByteArray(y){const P=f.alloc(y.length);for(let A=0,G=y.length;A<G;A++)P.buffer[A]=y[A];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let W=0,U=y.length;W<U;W++)P+=y[W].byteLength}const A=f.alloc(P);let G=0;for(let W=0,U=y.length;W<U;W++){const C=y[W];A.set(C,G),G+=C.byteLength}return A}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=f.alloc(this.byteLength);return y.set(this),y}toString(){return M?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,P){return new f(this.buffer.subarray(y,P))}set(y,P){if(y instanceof f)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return l(this.buffer,y)}writeUInt32BE(y,P){w(this.buffer,y,P)}readUInt32LE(y){return d(this.buffer,y)}writeUInt32LE(y,P){s(this.buffer,y,P)}readUInt8(y){return a(this.buffer,y)}writeUInt8(y,P){r(this.buffer,y,P)}indexOf(y,P=0){return k(this.buffer,y instanceof f?y.buffer:y,P)}}e.$te=f;function k(D,y,P=0){const A=y.byteLength,G=D.byteLength;if(A===0)return 0;if(A===1)return D.indexOf(y[0]);if(A>G-P)return-1;const W=O.value;W.fill(y.length);for(let q=0;q<y.length;q++)W[y[q]]=y.length-q-1;let U=P+y.length-1,C=U,T=-1;for(;U<G;)if(D[U]===y[C]){if(C===0){T=U;break}U--,C--}else U+=Math.max(y.length-C,W[D[U]]),C=y.length-1;return T}function N(D,y){return D[y+0]<<0>>>0|D[y+1]<<8>>>0}function E(D,y,P){D[P+0]=y&255,y=y>>>8,D[P+1]=y&255}function l(D,y){return D[y]*2**24+D[y+1]*2**16+D[y+2]*2**8+D[y+3]}function w(D,y,P){D[P+3]=y,y=y>>>8,D[P+2]=y,y=y>>>8,D[P+1]=y,y=y>>>8,D[P]=y}function d(D,y){return D[y+0]<<0>>>0|D[y+1]<<8>>>0|D[y+2]<<16>>>0|D[y+3]<<24>>>0}function s(D,y,P){D[P+0]=y&255,y=y>>>8,D[P+1]=y&255,y=y>>>8,D[P+2]=y&255,y=y>>>8,D[P+3]=y&255}function a(D,y){return D[y]}function r(D,y,P){D[P]=y}function i(D){return F.$ie(D,y=>f.concat(y))}function n(D){return F.$pe(D)}function c(D){return F.$ke(D,y=>f.concat(y))}async function h(D){return D.ended?f.concat(D.buffer):f.concat([...D.buffer,await c(D.stream)])}function t(D){return F.$ne(D,y=>f.concat(y))}function p(D){return F.$qe(D,{data:y=>typeof y=="string"?f.fromString(y):f.wrap(y)},y=>f.concat(y))}function u(D){return F.$he(y=>f.concat(y),D)}function o(D,y){return F.$re(D,y,P=>f.concat(P))}function v(D,y){return F.$se(D,y,P=>f.concat(P))}function b(D){let y=0,P=0,A=0;const G=new Uint8Array(Math.floor(D.length/4*3)),W=C=>{switch(P){case 3:G[A++]=y|C,P=0;break;case 2:G[A++]=y|C>>>2,y=C<<6,P=3;break;case 1:G[A++]=y|C>>>4,y=C<<4,P=2;break;default:y=C<<2,P=1}};for(let C=0;C<D.length;C++){const T=D.charCodeAt(C);if(T>=65&&T<=90)W(T-65);else if(T>=97&&T<=122)W(T-97+26);else if(T>=48&&T<=57)W(T-48+52);else if(T===43||T===45)W(62);else if(T===47||T===95)W(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${D[C]}`)}}const U=A;for(;P>0;)W(0);return f.wrap(G).slice(0,U)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:D},y=!0,P=!1){const A=P?I:$;let G="";const W=D.byteLength%3;let U=0;for(;U<D.byteLength-W;U+=3){const C=D[U+0],T=D[U+1],q=D[U+2];G+=A[C>>>2],G+=A[(C<<4|T>>>4)&63],G+=A[(T<<2|q>>>6)&63],G+=A[q&63]}if(W===1){const C=D[U+0];G+=A[C>>>2],G+=A[C<<4&63],y&&(G+="==")}else if(W===2){const C=D[U+0],T=D[U+1];G+=A[C>>>2],G+=A[(C<<4|T>>>4)&63],G+=A[T<<2&63],y&&(G+="=")}return G}}),define(Pe[127],Me([1,0,28,124,15]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.FuzzyScore=e.$ik=e.$hk=void 0,e.or=O,e.$jk=m,e.$kk=f,e.$lk=E,e.$mk=b,e.$nk=$,e.$ok=A,e.$pk=G,e.$qk=W,e.$rk=U,e.$sk=ee,e.$uk=be,e.$vk=Z,e.$wk=he;function O(...de){return function(Ce,Re){for(let je=0,z=de.length;je<z;je++){const j=de[je](Ce,Re);if(j)return j}return null}}e.$hk=R.bind(void 0,!1),e.$ik=R.bind(void 0,!0);function R(de,Ce,Re){if(!Re||Re.length<Ce.length)return null;let je;return de?je=M.$lf(Re,Ce):je=Re.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(de,Ce){const Re=Ce.toLowerCase().indexOf(de.toLowerCase());return Re===-1?null:[{start:Re,end:Re+de.length}]}function f(de,Ce){return k(de.toLowerCase(),Ce.toLowerCase(),0,0)}function k(de,Ce,Re,je){if(Re===de.length)return[];if(je===Ce.length)return null;if(de[Re]===Ce[je]){let z=null;return(z=k(de,Ce,Re+1,je+1))?c({start:je,end:je+1},z):null}return k(de,Ce,Re,je+1)}function N(de){return 97<=de&&de<=122}function E(de){return 65<=de&&de<=90}function l(de){return 48<=de&&de<=57}function w(de){return de===32||de===9||de===10||de===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>d.add(de.charCodeAt(0)));function s(de){return w(de)||d.has(de)}function a(de,Ce){return de===Ce||s(de)&&s(Ce)}const r=new Map;function i(de){if(r.has(de))return r.get(de);let Ce;const Re=(0,F.$fk)(de);return Re&&(Ce=Re),r.set(de,Ce),Ce}function n(de){return N(de)||E(de)||l(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function h(de,Ce){for(let Re=Ce;Re<de.length;Re++){const je=de.charCodeAt(Re);if(E(je)||l(je)||Re>0&&!n(de.charCodeAt(Re-1)))return Re}return de.length}function t(de,Ce,Re,je){if(Re===de.length)return[];if(je===Ce.length)return null;if(de[Re]!==Ce[je].toLowerCase())return null;{let z=null,j=je+1;for(z=t(de,Ce,Re+1,je+1);!z&&(j=h(Ce,j))<Ce.length;)z=t(de,Ce,Re+1,j),j++;return z===null?null:c({start:je,end:je+1},z)}}function p(de){let Ce=0,Re=0,je=0,z=0,j=0;for(let Oe=0;Oe<de.length;Oe++)j=de.charCodeAt(Oe),E(j)&&Ce++,N(j)&&Re++,n(j)&&je++,l(j)&&z++;const K=Ce/de.length,H=Re/de.length,_=je/de.length,se=z/de.length;return{upperPercent:K,lowerPercent:H,alphaPercent:_,numericPercent:se}}function u(de){const{upperPercent:Ce,lowerPercent:Re}=de;return Re===0&&Ce>.6}function o(de){const{upperPercent:Ce,lowerPercent:Re,alphaPercent:je,numericPercent:z}=de;return Re>.2&&Ce<.8&&je>.6&&z<.2}function v(de){let Ce=0,Re=0,je=0,z=0;for(let j=0;j<de.length;j++)je=de.charCodeAt(j),E(je)&&Ce++,N(je)&&Re++,w(je)&&z++;return(Ce===0||Re===0)&&z===0?de.length<=30:Ce<=5}function b(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!v(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Re=p(Ce);if(!o(Re)){if(!u(Re))return null;Ce=Ce.toLowerCase()}let je=null,z=0;for(de=de.toLowerCase();z<Ce.length&&(je=t(de,Ce,0,z))===null;)z=h(Ce,z+1);return je}function $(de,Ce,Re=!1){if(!Ce||Ce.length===0)return null;let je=null,z=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(je=I(de,Ce,0,z,Re),je===null);)z=g(Ce,z+1);return je}function I(de,Ce,Re,je,z){let j=0;if(Re===de.length)return[];if(je===Ce.length)return null;if(!a(de.charCodeAt(Re),Ce.charCodeAt(je))){const _=i(de.charCodeAt(Re));if(!_)return null;for(let se=0;se<_.length;se++)if(!a(_[se],Ce.charCodeAt(je+se)))return null;j+=_.length-1}let K=null,H=je+j+1;if(K=I(de,Ce,Re+1,H,z),!z)for(;!K&&(H=g(Ce,H))<Ce.length;)K=I(de,Ce,Re+1,H,z),H++;if(!K)return null;if(de.charCodeAt(Re)!==Ce.charCodeAt(je)){const _=i(de.charCodeAt(Re));if(!_)return K;for(let se=0;se<_.length;se++)if(_[se]!==Ce.charCodeAt(je+se))return K}return c({start:je,end:je+j+1},K)}function g(de,Ce){for(let Re=Ce;Re<de.length;Re++)if(s(de.charCodeAt(Re))||Re>0&&s(de.charCodeAt(Re-1)))return Re;return de.length}const D=O(e.$ik,b,m),y=O(e.$ik,b,f),P=new S.$Dc(1e4);function A(de,Ce,Re=!1){if(typeof de!="string"||typeof Ce!="string")return null;let je=P.get(de);je||(je=new RegExp(M.$6e(de),"i"),P.set(de,je));const z=je.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Re?y(de,Ce):D(de,Ce)}function G(de,Ce){const Re=be(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?U(Re):null}function W(de,Ce,Re,je,z,j){const K=Math.min(13,de.length);for(;Re<K;Re++){const H=be(de,Ce,Re,je,z,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}function U(de){if(typeof de>"u")return[];const Ce=[],Re=de[1];for(let je=de.length-1;je>1;je--){const z=de[je]+Re,j=Ce[Ce.length-1];j&&j.end===z?j.end=z+1:Ce.push({start:z,end:z+1})}return Ce}const C=128;function T(){const de=[],Ce=[];for(let Re=0;Re<=C;Re++)Ce[Re]=0;for(let Re=0;Re<=C;Re++)de.push(Ce.slice(0));return de}function q(de){const Ce=[];for(let Re=0;Re<=de;Re++)Ce[Re]=0;return Ce}const ne=q(2*C),ce=q(2*C),ye=T(),Ie=T(),ue=T(),ve=!1;function re(de,Ce,Re,je,z){function j(H,_,se=" "){for(;H.length<_;)H=se+H;return H}let K=` |   |${je.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Re;H++)H===0?K+=" |":K+=`${Ce[H-1]}|`,K+=de[H].slice(0,z+1).map(_=>j(_.toString(),3)).join("|")+`
`;return K}function $e(de,Ce,Re,je){de=de.substr(Ce),Re=Re.substr(je),console.log(re(Ie,de,de.length,Re,Re.length)),console.log(re(ue,de,de.length,Re,Re.length)),console.log(re(ye,de,de.length,Re,Re.length))}function ie(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Re=de.codePointAt(Ce);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Df(Re)}}function le(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function V(de,Ce,Re){return Ce[de]!==Re[de]}function ee(de,Ce,Re,je,z,j,K=!1){for(;Ce<Re&&z<j;)de[Ce]===je[z]&&(K&&(ne[Ce]=z),Ce+=1),z+=1;return Ce===Re}var ke;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Ne;(function(de){de.Default=[-100,0];function Ce(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}de.isDefault=Ce})(Ne||(e.FuzzyScore=Ne={}));class Se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Re){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Re}}e.$tk=Se;function be(de,Ce,Re,je,z,j,K=Se.default){const H=de.length>C?C:de.length,_=je.length>C?C:je.length;if(Re>=H||j>=_||H-Re>_-j||!ee(Ce,Re,H,z,j,_,!0))return;ge(H,_,Re,j,Ce,z);let se=1,Oe=1,Ve=Re,Qe=j;const xe=[!1];for(se=1,Ve=Re;Ve<H;se++,Ve++){const at=ne[Ve],Be=ce[Ve],it=Ve+1<H?ce[Ve+1]:_;for(Oe=at-j+1,Qe=at;Qe<it;Oe++,Qe++){let Y=Number.MIN_SAFE_INTEGER,X=!1;Qe<=Be&&(Y=J(de,Ce,Ve,Re,je,z,Qe,_,j,ye[se-1][Oe-1]===0,xe));let pe=0;Y!==Number.MAX_SAFE_INTEGER&&(X=!0,pe=Y+Ie[se-1][Oe-1]);const We=Qe>at,Xe=We?Ie[se][Oe-1]+(ye[se][Oe-1]>0?-5:0):0,st=Qe>at+1&&ye[se][Oe-1]>0,Fe=st?Ie[se][Oe-2]+(ye[se][Oe-2]>0?-5:0):0;if(st&&(!We||Fe>=Xe)&&(!X||Fe>=pe))Ie[se][Oe]=Fe,ue[se][Oe]=3,ye[se][Oe]=0;else if(We&&(!X||Xe>=pe))Ie[se][Oe]=Xe,ue[se][Oe]=2,ye[se][Oe]=0;else if(X)Ie[se][Oe]=pe,ue[se][Oe]=1,ye[se][Oe]=ye[se-1][Oe-1]+1;else throw new Error("not possible")}}if(ve&&$e(de,Re,je,j),!xe[0]&&!K.firstMatchCanBeWeak)return;se--,Oe--;const et=[Ie[se][Oe],j];let ot=0,rt=0;for(;se>=1;){let at=Oe;do{const Be=ue[se][at];if(Be===3)at=at-2;else if(Be===2)at=at-1;else break}while(at>=1);ot>1&&Ce[Re+se-1]===z[j+Oe-1]&&!V(at+j-1,je,z)&&ot+1>ye[se][at]&&(at=Oe),at===Oe?ot++:ot=1,rt||(rt=at),se--,Oe=at-1,et.push(Oe)}_===H&&K.boostFullMatch&&(et[0]+=2);const tt=rt-H;return et[0]-=tt,et}function ge(de,Ce,Re,je,z,j){let K=de-1,H=Ce-1;for(;K>=Re&&H>=je;)z[K]===j[H]&&(ce[K]=H,K--),H--}function J(de,Ce,Re,je,z,j,K,H,_,se,Oe){if(Ce[Re]!==j[K])return Number.MIN_SAFE_INTEGER;let Ve=1,Qe=!1;return K===Re-je?Ve=de[Re]===z[K]?7:5:V(K,z,j)&&(K===0||!V(K-1,z,j))?(Ve=de[Re]===z[K]?7:5,Qe=!0):ie(j,K)&&(K===0||!ie(j,K-1))?Ve=5:(ie(j,K-1)||le(j,K-1))&&(Ve=5,Qe=!0),Ve>1&&Re===je&&(Oe[0]=!0),Qe||(Qe=V(K,z,j)||ie(j,K-1)||le(j,K-1)),Re===je?K>_&&(Ve-=Qe?3:5):se?Ve+=Qe?2:0:Ve+=Qe?0:1,K+1===H&&(Ve-=Qe?3:5),Ve}function Z(de,Ce,Re,je,z,j,K){return fe(de,Ce,Re,je,z,j,!0,K)}function he(de,Ce,Re,je,z,j,K){return fe(de,Ce,Re,je,z,j,!1,K)}function fe(de,Ce,Re,je,z,j,K,H){let _=be(de,Ce,Re,je,z,j,H);if(_&&!K)return _;if(de.length>=3){const se=Math.min(7,de.length-1);for(let Oe=Re+1;Oe<se;Oe++){const Ve=Te(de,Oe);if(Ve){const Qe=be(Ve,Ve.toLowerCase(),Re,je,z,j,H);Qe&&(Qe[0]-=3,(!_||Qe[0]>_[0])&&(_=Qe))}}}return _}function Te(de,Ce){if(Ce+1>=de.length)return;const Re=de[Ce],je=de[Ce+1];if(Re!==je)return de.slice(0,Ce)+je+Re+de.slice(Ce+2)}}),define(Pe[32],Me([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(F||(F={})),function(M){const O="error",R="warning",m="warn",f="info",k="ignore";function N(l){return l?S.$kf(O,l)?M.Error:S.$kf(R,l)||S.$kf(m,l)?M.Warning:S.$kf(f,l)?M.Info:M.Ignore:M.Ignore}M.fromValue=N;function E(l){switch(l){case M.Error:return O;case M.Warning:return R;case M.Info:return f;default:return k}}M.toString=E}(F||(F={})),e.default=F}),define(Pe[128],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(Pe[50],Me([1,0,18,15]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class M{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const d=w.charCodeAt(0),s=this.b.charCodeAt(this.c);return d-s}value(){return this.b[this.c]}}e.$ii=M;class O{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,F.$ef)(w,this.b,0,w.length,this.c,this.d):(0,F.$gf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=O;class R{constructor(w=!0,d=!0){this.f=w,this.g=d}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let d=w.length-1;d>=0;d--,this.c--){const s=this.b.charCodeAt(d);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,F.$ef)(w,this.b,0,w.length,this.d,this.e):(0,F.$gf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class f{constructor(w,d){this.f=w,this.g=d,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,F.$ff)(w,this.c.scheme);if(this.d[this.e]===2)return(0,F.$ff)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,F.$df)(w,this.c.query);if(this.d[this.e]===5)return(0,F.$df)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=f;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(N||(N={}));class E{static forUris(w=()=>!1,d=()=>!1){return new E(new f(w,d))}static forPaths(w=!1){return new E(new R(void 0,!w))}static forStrings(){return new E(new M)}static forConfigKeys(){return new E(new O)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,d){if(d){const s=d.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a,w)}else{const s=w.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(w,d){const s=this.b.reset(w);let a;this.c||(this.c=new k,this.c.segment=s.value());const r=[];for(a=this.c;;){const n=s.cmp(a.segment);if(n>0)a.left||(a.left=new k,a.left.segment=s.value()),r.push([-1,a]),a=a.left;else if(n<0)a.right||(a.right=new k,a.right.segment=s.value()),r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new k,a.mid.segment=s.value()),r.push([0,a]),a=a.mid;else break}const i=a.value;a.value=d,a.key=w;for(let n=r.length-1;n>=0;n--){const c=r[n][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=r[n][0],p=r[n+1][0];if(t===1&&p===1)r[n][1]=c.rotateLeft();else if(t===-1&&p===-1)r[n][1]=c.rotateRight();else if(t===1&&p===-1)c.right=r[n+1][1]=r[n+1][1].rotateRight(),r[n][1]=c.rotateLeft();else if(t===-1&&p===1)c.left=r[n+1][1]=r[n+1][1].rotateLeft(),r[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const d=this.b.reset(w);let s=this.c;for(;s;){const a=d.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(d.hasNext())d.next(),s=s.mid;else break}return s}has(w){const d=this.d(w);return!(d?.value===void 0&&d?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,d){const s=this.b.reset(w),a=[];let r=this.c;for(;r;){const i=s.cmp(r.segment);if(i>0)a.push([-1,r]),r=r.left;else if(i<0)a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),a.push([0,r]),r=r.mid;else break}if(r){if(d?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const i=this.f(r.right);if(i.key){const{key:n,value:c,segment:h}=i;this.e(i.key,!1),r.key=n,r.value=c,r.segment=h}}else{const i=r.left??r.right;if(a.length>0){const[n,c]=a[a.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=a.length-1;i>=0;i--){const n=a[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),a[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),a[i][1]=n.rotateRight()),i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const d=this.b.reset(w);let s=this.c,a;for(;s;){const r=d.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(d.hasNext())d.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(w){return this.g(w,!1)}g(w,d){const s=this.b.reset(w);let a=this.c;for(;a;){const r=s.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):d?a.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[d,s]of this)w(s,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const d=[];return this.j(w,d),d[Symbol.iterator]()}j(w,d){w&&(w.left&&this.j(w.left,d),w.value&&d.push([w.key,w.value]),w.mid&&this.j(w.mid,d),w.right&&this.j(w.right,d))}_isBalanced(){const w=d=>{if(!d)return!0;const s=d.balanceFactor();return s<-1||s>1?!1:w(d.left)&&w(d.right)};return w(this.c)}}e.$mi=E}),define(Pe[40],Me([1,0,91]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Gj=M;var F;(function(R){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=m})(F||(e.ThemeColor=F={}));function M(R){return{id:R}}var O;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(i){const n=m.exec(i.id);if(!n)return f(S.$Fj.error);const[,c,h]=n,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}R.asClassNameArray=f;function k(i){return f(i).join(" ")}R.asClassName=k;function N(i){return"."+f(i).join(".")}R.asCSSSelector=N;function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}R.isThemeIcon=E;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(i){const n=l.exec(i);if(!n)return;const[,c]=n;return{id:c}}R.fromString=w;function d(i){return{id:i}}R.fromId=d;function s(i,n){let c=i.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),n&&(c=`${c}~${n}`),{id:c}}R.modify=s;function a(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=a;function r(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=r})(O||(e.ThemeIcon=O={}))}),define(Pe[129],Me([1,0,127,15,40]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=f,e.$yk=N,e.$zk=l,e.$Ak=w,e.$Bk=s,e.$Ck=a;const O="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function f(r){return r.replace(m,(i,n)=>n?i:`\\${i}`)}const k=new RegExp(`\\\\${R.source}`,"g");function N(r){return r.replace(k,i=>`\\${i}`)}const E=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(r){return r.indexOf(O)===-1?r:r.replace(E,(i,n,c,h)=>c?i:n||h||"")}function w(r){return r?r.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const d=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){d.lastIndex=0;let i="";const n=[];let c=0;for(;;){const h=d.lastIndex,t=d.exec(r),p=r.substring(h,t?.index);if(p.length>0){i+=p;for(let u=0;u<p.length;u++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function a(r,i,n=!1){const{text:c,iconOffsets:h}=i;if(!h||h.length===0)return(0,S.$ok)(r,c,n);const t=(0,F.$4e)(c," "),p=c.length-t.length,u=(0,S.$ok)(r,t,n);if(u)for(const o of u){const v=h[o.start+p]+p;o.start+=v,o.end+=v}return u}}),define(Pe[33],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=void 0,e.$Bg=F;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(M){return S.test(M)}e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const O=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){M(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,k="";return k+=R[O[f++]],k+=R[O[f++]],k+=R[O[f++]],k+=R[O[f++]],k+="-",k+=R[O[f++]],k+=R[O[f++]],k+="-",k+=R[O[f++]],k+=R[O[f++]],k+="-",k+=R[O[f++]],k+=R[O[f++]],k+="-",k+=R[O[f++]],k+=R[O[f++]],k+=R[O[f++]],k+=R[O[f++]],k+=R[O[f++]],k+=R[O[f++]],k}}()}),define(Pe[130],Me([1,0,18,51,33]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Ft=void 0,e.$Dt=O,e.$Et=R,e.$Gt=k;function O(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function R(E,l,w){const d={id:(0,M.$Cg)(),name:E,uri:l,data:w};return{asString:async()=>"",asFile:()=>d,value:void 0}}class m{constructor(){this.a=new Map}get size(){let l=0;for(const w of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const w=[...this.a.keys()];return F.Iterable.some(this,([d,s])=>s.asFile())&&w.push("files"),N(f(l),w)}get(l){return this.a.get(this.b(l))?.[0]}append(l,w){const d=this.a.get(l);d?d.push(w):this.a.set(this.b(l),[w])}replace(l,w){this.a.set(this.b(l),[w])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,w]of this.a)for(const d of w)yield[l,d]}b(l){return f(l)}}e.$Ft=m;function f(E){return E.toLowerCase()}function k(E,l){return N(f(E),l.map(f))}function N(E,l){if(E==="*/*")return l.length>0;if(l.includes(E))return!0;const w=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[d,s,a]=w;return a==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$Ht=Object.freeze({create:E=>(0,S.$Mb)(E.map(l=>l.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Ht.split(E).filter(l=>!l.startsWith("#"))})}),define(Pe[131],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=F;var S;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function F(M){let O=0,R=0,m=0,f=0;for(let k=0,N=M.length;k<N;k++){const E=M.charCodeAt(k);E===13?(O===0&&(R=k),O++,k+1<N&&M.charCodeAt(k+1)===10?(f|=2,k++):f|=3,m=k+1):E===10&&(f|=1,O===0&&(R=k),O++,m=k+1)}return O===0&&(R=M.length),[O,R,M.length-m,f]}}),define(Pe[132],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0,e.$Is={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[133],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let f=0,k=m.notIn.length;f<k;f++)switch(m.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const k=m.findTokenIndexAtOffset(f-2),N=m.getStandardTokenType(k);return this.isOK(N)}g(m,f){for(let k=m;k<=f;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$0t=F;class M{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)O(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),O(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),O(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),O(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&O(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$$t=M;function O(R,m,f){R.has(m)?R.get(m).push(f):R.set(m,[f])}}),define(Pe[134],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.NodeColor=e.$_B=void 0,e.$bC=M,e.$cC=O,e.$dC=k,e.$eC=N,e.$fC=E,e.$gC=l,e.$hC=w,e.$iC=d;class S{constructor(a,r){this.piece=a,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$aC)return M(this.right);let a=this;for(;a.parent!==e.$aC&&a.parent.left!==a;)a=a.parent;return a.parent===e.$aC?e.$aC:a.parent}prev(){if(this.left!==e.$aC)return O(this.left);let a=this;for(;a.parent!==e.$aC&&a.parent.right!==a;)a=a.parent;return a.parent===e.$aC?e.$aC:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$_B=S;var F;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$aC=new S(null,0),e.$aC.parent=e.$aC,e.$aC.left=e.$aC,e.$aC.right=e.$aC,e.$aC.color=0;function M(s){for(;s.left!==e.$aC;)s=s.left;return s}function O(s){for(;s.right!==e.$aC;)s=s.right;return s}function R(s){return s===e.$aC?0:s.size_left+s.piece.length+R(s.right)}function m(s){return s===e.$aC?0:s.lf_left+s.piece.lineFeedCnt+m(s.right)}function f(){e.$aC.parent=e.$aC}function k(s,a){const r=a.right;r.size_left+=a.size_left+(a.piece?a.piece.length:0),r.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=r.left,r.left!==e.$aC&&(r.left.parent=a),r.parent=a.parent,a.parent===e.$aC?s.root=r:a.parent.left===a?a.parent.left=r:a.parent.right=r,r.left=a,a.parent=r}function N(s,a){const r=a.left;a.left=r.right,r.right!==e.$aC&&(r.right.parent=a),r.parent=a.parent,a.size_left-=r.size_left+(r.piece?r.piece.length:0),a.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),a.parent===e.$aC?s.root=r:a===a.parent.right?a.parent.right=r:a.parent.left=r,r.right=a,a.parent=r}function E(s,a){let r,i;if(a.left===e.$aC?(i=a,r=i.right):a.right===e.$aC?(i=a,r=i.left):(i=M(a.right),r=i.right),i===s.root){s.root=r,r.color=0,a.detach(),f(),s.root.parent=e.$aC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=r:i.parent.right=r,i===a?(r.parent=i.parent,d(s,r)):(i.parent===a?r.parent=i:r.parent=i.parent,d(s,r),i.left=a.left,i.right=a.right,i.parent=a.parent,i.color=a.color,a===s.root?s.root=i:a===a.parent.left?a.parent.left=i:a.parent.right=i,i.left!==e.$aC&&(i.left.parent=i),i.right!==e.$aC&&(i.right.parent=i),i.size_left=a.size_left,i.lf_left=a.lf_left,d(s,i)),a.detach(),r.parent.left===r){const h=R(r),t=m(r);if(h!==r.parent.size_left||t!==r.parent.lf_left){const p=h-r.parent.size_left,u=t-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=t,w(s,r.parent,p,u)}}if(d(s,r.parent),n){f();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,k(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,k(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,N(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,k(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,N(s,r.parent),r=s.root));r.color=0,f()}function l(s,a){for(d(s,a);a!==s.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const r=a.parent.parent.right;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,k(s,a)),a.parent.color=0,a.parent.parent.color=1,N(s,a.parent.parent))}else{const r=a.parent.parent.left;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,N(s,a)),a.parent.color=0,a.parent.parent.color=1,k(s,a.parent.parent))}s.root.color=0}function w(s,a,r,i){for(;a!==s.root&&a!==e.$aC;)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=i),a=a.parent}function d(s,a){let r=0,i=0;if(a!==s.root){for(;a!==s.root&&a===a.parent.right;)a=a.parent;if(a!==s.root)for(a=a.parent,r=R(a.left)-a.size_left,i=m(a.left)-a.lf_left,a.size_left+=r,a.lf_left+=i;a!==s.root&&(r!==0||i!==0);)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=i),a=a.parent}}}),define(Pe[92],Me([1,0,93,29,94,134,95]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$sC=e.$rC=void 0,e.$pC=N,e.$qC=E;const m=65535;function f(r){let i;return r[r.length-1]<65536?i=new Uint16Array(r.length):i=new Uint32Array(r.length),i.set(r,0),i}class k{constructor(i,n,c,h,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function N(r,i=!0){const n=[0];let c=1;for(let h=0,t=r.length;h<t;h++){const p=r.charCodeAt(h);p===13?h+1<t&&r.charCodeAt(h+1)===10?(n[c++]=h+2,h++):n[c++]=h+1:p===10&&(n[c++]=h+1)}return i?f(n):n}function E(r,i){r.length=0,r[0]=0;let n=1,c=0,h=0,t=0,p=!0;for(let o=0,v=i.length;o<v;o++){const b=i.charCodeAt(o);b===13?o+1<v&&i.charCodeAt(o+1)===10?(t++,r[n++]=o+2,o++):(c++,r[n++]=o+1):b===10?(h++,r[n++]=o+1):p&&b!==9&&(b<32||b>126)&&(p=!1)}const u=new k(f(r),c,h,t,p);return r.length=0,u}class l{constructor(i,n,c,h,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$rC=l;class w{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$sC=w;class d{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==O.$aC&&i.iterate(i.root,c=>(c!==O.$aC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=i){c[h]=null,n=!0;continue}}if(n){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class a{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=O.$aC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let h=null;for(let t=0,p=i.length;t<p;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=N(i[t].buffer));const u=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),h=this.S(h,u)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=m,c=n-Math.floor(n/3),h=c*2;let t="",p=0;const u=[];if(this.iterate(this.root,o=>{const v=this.R(o),b=v.length;if(p<=c||p+b<h)return t+=v,p+=b,!0;const $=t.replace(/\r\n|\r|\n/g,i);return u.push(new w($,N($))),t=v,p=b,!0}),p>0){const o=t.replace(/\r\n|\r|\n/g,i);u.push(new w(o,N(o)))}this.create(u,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new d(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,h=>{if(h===O.$aC)return!0;const t=this.R(h),p=t.length,u=i.G(n),o=i.G(n+p),v=i.getValueInRange2(u,o);return n+=p,t===v})}getOffsetAt(i,n){let c=0,h=this.root;for(;h!==O.$aC;)if(h.left!==O.$aC&&h.lf_left+1>=i)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=i){c+=h.size_left;const t=this.B(h,i-h.lf_left-2);return c+=t+n-1}else i-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const h=i;for(;n!==O.$aC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const p=this.getOffsetAt(c+1,1),u=h-p;return new S.$0s(c+1,u+1)}return new S.$0s(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===O.$aC){const t=this.getOffsetAt(c+1,1),p=h-i-t;return new S.$0s(c+1,p+1)}else n=n.right;return new S.$0s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),h=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,h);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const u=i.node,o=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return o.substring(v+i.remainder,v+n.remainder)}let c=i.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let p=h.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==O.$aC;){const u=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){p+=u.substring(o,o+n.remainder);break}else p+=u.substr(o,c.piece.length);c=c.next()}return p}getLinesContent(){const i=[];let n=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===O.$aC)return!0;const p=t.piece;let u=p.length;if(u===0)return!0;const o=this.a[p.bufferIndex].buffer,v=this.a[p.bufferIndex].lineStarts,b=p.start.line,$=p.end.line;let I=v[b]+p.start.column;if(h&&(o.charCodeAt(I)===10&&(I++,u--),i[n++]=c,c="",h=!1,u===0))return!0;if(b===$)return!this.f&&o.charCodeAt(I+u-1)===13?(h=!0,c+=o.substr(I,u-1)):c+=o.substr(I,u),!0;c+=this.f?o.substring(I,Math.max(I,v[b+1]-this.e)):o.substring(I,v[b+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let g=b+1;g<$;g++)c=this.f?o.substring(v[g],v[g+1]-this.e):o.substring(v[g],v[g+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&o.charCodeAt(v[$]+p.end.column-1)===13?(h=!0,p.end.column===0?n--:c=o.substr(v[$],p.end.column-1)):c=o.substr(v[$],p.end.column),!0}),h&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(h)}else{const n=this.a[i.node.piece.bufferIndex],h=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(h)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,h,t,p,u,o,v,b,$){const I=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start),D=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,p);let P;const A={line:0,column:0};let G,W;n._wordSeparators?(G=I.buffer.substring(D,y),W=U=>U+D,n.reset(0)):(G=I.buffer,W=U=>U,n.reset(D));do if(P=n.next(G),P){if(W(P.index)>=y)return b;this.s(i,W(P.index)-g,A);const U=this.t(i.piece.bufferIndex,t,A),C=A.line===t.line?A.column-t.column+h:A.column+1,T=C+P[0].length;if($[b++]=(0,R.$lC)(new F.$$s(c+U,C,c+U,T),P,o),W(P.index)+P[0].length>=y||b>=v)return b}while(P);return b}findMatchesLineByLine(i,n,c,h){const t=[];let p=0;const u=new R.$oC(n.wordSeparators,n.regex);let o=this.H(i.startLineNumber,i.startColumn);if(o===null)return[];const v=this.H(i.endLineNumber,i.endColumn);if(v===null)return[];let b=this.s(o.node,o.remainder);const $=this.s(v.node,v.remainder);if(o.node===v.node)return this.findMatchesInNode(o.node,u,i.startLineNumber,i.startColumn,b,$,n,c,h,p,t),t;let I=i.startLineNumber,g=o.node;for(;g!==v.node;){const y=this.t(g.piece.bufferIndex,b,g.piece.end);if(y>=1){const A=this.a[g.piece.bufferIndex].lineStarts,G=this.u(g.piece.bufferIndex,g.piece.start),W=A[b.line+y],U=I===i.startLineNumber?i.startColumn:1;if(p=this.findMatchesInNode(g,u,I,U,b,this.s(g,W-G),n,c,h,p,t),p>=h)return t;I+=y}const P=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const A=this.getLineContent(I).substring(P,i.endColumn-1);return p=this.n(n,u,A,i.endLineNumber,P,p,t,c,h),t}if(p=this.n(n,u,this.getLineContent(I).substr(P),I,P,p,t,c,h),p>=h)return t;I++,o=this.H(I,1),g=o.node,b=this.s(o.node,o.remainder)}if(I===i.endLineNumber){const y=I===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(I).substring(y,i.endColumn-1);return p=this.n(n,u,P,i.endLineNumber,y,p,t,c,h),t}const D=I===i.startLineNumber?i.startColumn:1;return p=this.findMatchesInNode(v.node,u,I,D,b,$,n,c,h,p,t),t}n(i,n,c,h,t,p,u,o,v){const b=i.wordSeparators;if(!o&&i.simpleSearch){const I=i.simpleSearch,g=I.length,D=c.length;let y=-g;for(;(y=c.indexOf(I,y+g))!==-1;)if((!b||(0,R.$nC)(b,c,D,y,g))&&(u[p++]=new M.$sv(new F.$$s(h,y+1+t,h,y+1+g+t),null),p>=v))return p;return p}let $;n.reset(0);do if($=n.next(c),$&&(u[p++]=(0,R.$lC)(new F.$$s(h,$.index+1+t,h,$.index+1+$[0].length+t),$,o),p>=v))return p;while($);return p}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$aC){const{node:h,remainder:t,nodeStartOffset:p}=this.G(i),u=h.piece,o=u.bufferIndex,v=this.s(h,t);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&p+u.length===i&&n.length<m){this.F(h,n),this.y();return}if(p===i)this.o(n,h),this.h.validate(i);else if(p+h.piece.length>i){const b=[];let $=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(o,u.end)-this.u(o,v));if(this.K()&&this.M(n)&&this.I(h,t)===10){const y={line:$.start.line+1,column:0};$=new l($.bufferIndex,y,$.end,this.t($.bufferIndex,y,$.end),$.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),n="\r"+n,h.piece.length===0&&b.push(h)}else this.C(h,v);else this.C(h,v);const I=this.w(n);$.length>0&&this.S(h,$);let g=h;for(let D=0;D<I.length;D++)g=this.S(g,I[D]);this.v(b)}else this.q(n,h)}else{const h=this.w(n);let t=this.T(null,h[0]);for(let p=1;p<h.length;p++)t=this.S(t,h[p])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===O.$aC)return;const c=this.G(i),h=this.G(i+n),t=c.node,p=h.node;if(t===p){const I=this.s(t,c.remainder),g=this.s(t,h.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const D=t.next();(0,O.$fC)(this,t),this.N(D),this.y();return}this.D(t,g),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,g),this.y();return}const u=[],o=this.s(t,c.remainder);this.C(t,o),this.h.validate(i),t.piece.length===0&&u.push(t);const v=this.s(p,h.remainder);this.D(p,v),p.piece.length===0&&u.push(p);const b=t.next();for(let I=b;I!==O.$aC&&I!==p;I=I.next())u.push(I);const $=t.piece.length===0?t.prev():t;this.v(u),this.O($),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const p=n.piece,u={line:p.start.line+1,column:0},o=new l(p.bufferIndex,u,p.end,this.t(p.bufferIndex,u,p.end),p.length-1);n.piece=o,i+=`
`,(0,O.$hC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const h=this.w(i);let t=this.T(n,h[h.length-1]);for(let p=h.length-2;p>=0;p--)t=this.T(t,h[p]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),h=this.S(n,c[0]);let t=h;for(let p=1;p<c.length;p++)t=this.S(t,c[p]);this.N(h)}s(i,n,c){const h=i.piece,t=i.piece.bufferIndex,p=this.a[t].lineStarts,o=p[h.start.line]+h.start.column+n;let v=h.start.line,b=h.end.line,$=0,I=0,g=0;for(;v<=b&&($=v+(b-v)/2|0,g=p[$],$!==b);)if(I=p[$+1],o<g)b=$-1;else if(o>=I)v=$+1;else break;return c?(c.line=$,c.column=o-g,null):{line:$,column:o-g}}t(i,n,c){if(c.column===0)return c.line-n.line;const h=this.a[i].lineStarts;if(c.line===h.length-1)return c.line-n.line;const t=h[c.line+1],p=h[c.line]+c.column;if(t>p+1)return c.line-n.line;const u=p-1;return this.a[i].buffer.charCodeAt(u)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,O.$fC)(this,i[n])}w(i){if(i.length>m){const b=[];for(;i.length>m;){const I=i.charCodeAt(m-1);let g;I===13||I>=55296&&I<=56319?(g=i.substring(0,m-1),i=i.substring(m-1)):(g=i.substring(0,m),i=i.substring(m));const D=N(g);b.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:g.length-D[D.length-1]},D.length-1,g.length)),this.a.push(new w(g,D))}const $=N(i);return b.push(new l(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new w(i,$)),b}let n=this.a[0].buffer.length;const c=N(i,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let b=0;b<c.length;b++)c[b]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let b=0;b<c.length;b++)c[b]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,u=t-this.a[0].lineStarts[p],o={line:p,column:u},v=new l(0,h,o,this.t(0,h,o),t-n);return this.g=o,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,h="";const t=this.h.get2(i);if(t){c=t.node;const p=this.B(c,i-t.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)h=u.substring(o+p,o+c.piece.length);else{const v=this.B(c,i-t.nodeStartLineNumber);return u.substring(o+p,o+v-n)}}else{let p=0;const u=i;for(;c!==O.$aC;)if(c.left!==O.$aC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const o=this.B(c,i-c.lf_left-2),v=this.B(c,i-c.lf_left-1),b=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);return p+=c.size_left,this.h.set({node:c,nodeStartOffset:p,nodeStartLineNumber:u-(i-1-c.lf_left)}),b.substring($+o,$+v-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const o=this.B(c,i-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);h=v.substring(b+o,b+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,p+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$aC;){const p=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),o=this.u(c.piece.bufferIndex,c.piece.start);return h+=p.substring(o,o+u-n),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=p.substr(u,c.piece.length)}c=c.next()}return h}y(){let i=this.root,n=1,c=0;for(;i!==O.$aC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,h=this.s(i,n),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const p=this.t(i.piece.bufferIndex,c.start,h);if(p!==t)return{index:p,remainder:0}}return{index:t,remainder:h.column}}B(i,n){if(n<0)return 0;const c=i.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(i,n){const c=i.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),p=n,u=this.u(c.bufferIndex,p),o=this.t(c.bufferIndex,c.start,p),v=o-h,b=u-t,$=c.length+b;i.piece=new l(c.bufferIndex,c.start,p,o,$),(0,O.$hC)(this,i,b,v)}D(i,n){const c=i.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),p=n,u=this.t(c.bufferIndex,p,c.end),o=this.u(c.bufferIndex,p),v=u-h,b=t-o,$=c.length+b;i.piece=new l(c.bufferIndex,p,c.end,u,$),(0,O.$hC)(this,i,b,v)}E(i,n,c){const h=i.piece,t=h.start,p=h.end,u=h.length,o=h.lineFeedCnt,v=n,b=this.t(h.bufferIndex,h.start,v),$=this.u(h.bufferIndex,n)-this.u(h.bufferIndex,t);i.piece=new l(h.bufferIndex,h.start,v,b,$),(0,O.$hC)(this,i,$-u,b-o);const I=new l(h.bufferIndex,c,p,this.t(h.bufferIndex,c,p),this.u(h.bufferIndex,p)-this.u(h.bufferIndex,c)),g=this.S(i,I);this.N(g)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),h=this.a[0].buffer.length;this.a[0].buffer+=n;const t=N(n,!1);for(let g=0;g<t.length;g++)t[g]+=h;if(c){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const p=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[p],o={line:p,column:u},v=i.piece.length+n.length,b=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,o),I=$-b;i.piece=new l(i.piece.bufferIndex,i.piece.start,o,$,v),this.g=o,(0,O.$hC)(this,i,n.length,I)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let h=0;for(;n!==O.$aC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){h+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:h};return this.h.set(t),t}else i-=n.size_left+n.piece.length,h+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,h=0;for(;c!==O.$aC;)if(c.left!==O.$aC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),p=this.B(c,i-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+n-1,p),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:h};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$aC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),p=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:p}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(h)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===O.$aC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,h=n.start.line,t=c[h]+n.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===O.$aC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],h=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:h[i.piece.end.line]-h[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const p=i.piece.length-1,u=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,u,p),(0,O.$hC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const o={line:n.piece.start.line+1,column:0},v=n.piece.length-1,b=this.t(n.piece.bufferIndex,o,n.piece.end);n.piece=new l(n.piece.bufferIndex,o,n.piece.end,b,v),(0,O.$hC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const $=this.w(`\r
`);this.S(i,$[0]);for(let I=0;I<c.length;I++)(0,O.$fC)(this,c[I])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,O.$fC)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},p=h.length-1,u=this.t(h.bufferIndex,t,h.end);c.piece=new l(h.bufferIndex,t,h.end,u,p),(0,O.$hC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===O.$aC)return n(O.$aC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===O.$aC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(h,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),h=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,h)}S(i,n){const c=new O.$_B(n,1);if(c.left=O.$aC,c.right=O.$aC,c.parent=O.$aC,c.size_left=0,c.lf_left=0,this.root===O.$aC)this.root=c,c.color=0;else if(i.right===O.$aC)i.right=c,c.parent=i;else{const t=(0,O.$bC)(i.right);t.left=c,c.parent=t}return(0,O.$gC)(this,c),c}T(i,n){const c=new O.$_B(n,1);if(c.left=O.$aC,c.right=O.$aC,c.parent=O.$aC,c.size_left=0,c.lf_left=0,this.root===O.$aC)this.root=c,c.color=0;else if(i.left===O.$aC)i.left=c,c.parent=i;else{const h=(0,O.$cC)(i.left);h.right=c,c.parent=h}return(0,O.$gC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$tC=a}),define(Pe[135],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9=e.$R9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const R=this.a.get(O);return this.a.delete(O),R}}addDragOperationTransfer(O,R){this.a.set(O,R)}}e.$R9=S;class F{constructor(O){this.identifier=O}}e.$S9=F}),define(Pe[136],Me([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[137],Me([1,0,5,6,136]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=void 0,e.$3i=N;class O extends F.$Tc{constructor(l,w="",d="",s=!0,a){super(),this.h=this.B(new S.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=w,this.u=d,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,w){this.C&&await this.C(l)}}e.$Xi=O;class R extends F.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$6d),this.onWillRun=this.f.event,this.m=this.B(new S.$6d),this.onDidRun=this.m.event}async run(l,w){if(!l.enabled)return;this.f.fire({action:l});let d;try{await this.u(l,w)}catch(s){d=s}this.m.fire({action:l,error:d})}async u(l,w){await l.run(w)}}e.$Yi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const d of l)d.length&&(w.length?w=[...w,new m,...d]:w=d);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$Zi=m;class f{get actions(){return this.a}constructor(l,w,d,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=s,this.a=d}async run(){}}e.$1i=f;class k extends O{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,M.localize(0,null),void 0,!1)}}e.$2i=k;function N(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...l)=>E.run(...l),tooltip:E.label}}}),define(Pe[138],Me([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[139],Me([1,0,138]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=k,e.$Mm=N,e.$Nm=E;const F=60,M=F*60,O=M*24,R=O*7,m=O*30,f=O*365;function k(l,w,d,s){typeof l!="number"&&(l=l.getTime());const a=Math.round((new Date().getTime()-l)/1e3);if(a<-30)return(0,S.localize)(0,null,k(new Date().getTime()+a*1e3,!1));if(!s&&a<30)return(0,S.localize)(1,null);let r;return a<F?(r=a,w?r===1?d?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):d?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?d?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):d?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):a<M?(r=Math.floor(a/F),w?r===1?d?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):d?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?d?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):d?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):a<O?(r=Math.floor(a/M),w?r===1?d?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):d?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?d?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):d?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):a<R?(r=Math.floor(a/O),w?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):a<m?(r=Math.floor(a/R),w?r===1?d?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):d?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?d?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):d?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):a<f?(r=Math.floor(a/m),w?r===1?d?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):d?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?d?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):d?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(a/f),w?r===1?d?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):d?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?d?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):d?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}function N(l,w){const d=Math.abs(l/1e3);return d<1?w?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):d<F?w?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):d<M?w?(0,S.localize)(58,null,Math.round(l/(1e3*F))):(0,S.localize)(59,null,Math.round(l/(1e3*F))):d<O?w?(0,S.localize)(60,null,Math.round(l/(1e3*M))):(0,S.localize)(61,null,Math.round(l/(1e3*M))):(0,S.localize)(62,null,Math.round(l/(1e3*O)))}function E(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[140],Me([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[41],Me([1,0,18,16,140]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=f,e.$5i=k,e.$6i=N;function O(E,l){return l&&(E.stack||E.stacktrace)?M.localize(0,null,m(E),R(E.stack)||R(E.stacktrace)):m(E)}function R(E){return Array.isArray(E)?E.join(`
`):E}function m(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?M.localize(1,null,E.message):E.message||M.localize(2,null)}function f(E=null,l=!1){if(!E)return M.localize(3,null);if(Array.isArray(E)){const w=S.$Hb(E),d=f(w[0],l);return w.length>1?M.localize(4,null,d,w.length):d}if(F.$Tf(E))return E;if(E.detail){const w=E.detail;if(w.error)return O(w.error,l);if(w.exception)return O(w.exception,l)}return E.stack?O(E,l):E.message?E.message:M.localize(5,null)}function k(E){const l=E;return l instanceof Error&&Array.isArray(l.actions)}function N(E,l){let w;return typeof E=="string"?w=new Error(E):w=E,w.actions=l,w}}),define(Pe[141],Me([1,0,39,19]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=m,e.$Zq=f,e.$1q=k,e.$2q=N,e.$3q=E,e.$4q=l,e.$5q=w,e.$6q=d,e.$7q=s,e.$8q=a,e.$9q=v,e.$0q=b,e.$$q=$;const M=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),O=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(I,g,D=!1){const y=I||"",P=g||"",A=M.value.collator.compare(y,P);return M.value.collatorIsNumeric&&A===0&&y!==P?y<P?-1:1:A}function f(I,g){const D=O.value.collator;return I=I||"",g=g||"",c(D,I,g)}function k(I,g){const D=O.value.collator;return I=I||"",g=g||"",u(I,g)||c(D,I,g)}function N(I,g){const D=O.value.collator;return I=I||"",g=g||"",p(I,g)||c(D,I,g)}function E(I,g){return I=I||"",g=g||"",I===g?0:I<g?-1:1}function l(I,g){const[D,y]=i(I),[P,A]=i(g);let G=M.value.collator.compare(y,A);if(G===0){if(M.value.collatorIsNumeric&&y!==A)return y<A?-1:1;if(G=M.value.collator.compare(D,P),M.value.collatorIsNumeric&&G===0&&D!==P)return D<P?-1:1}return G}function w(I,g){I=I||"",g=g||"";const D=n(I),y=n(g),P=O.value.collator,A=R.value.collator;return c(A,D,y)||c(P,I,g)}function d(I,g){I=I||"",g=g||"";const D=n(I),y=n(g),P=O.value.collator,A=R.value.collator;return c(A,D,y)||u(I,g)||c(P,I,g)}function s(I,g){I=I||"",g=g||"";const D=n(I),y=n(g),P=O.value.collator,A=R.value.collator;return c(A,D,y)||p(I,g)||c(P,I,g)}function a(I,g){I=I||"",g=g||"";const D=n(I).toLowerCase(),y=n(g).toLowerCase();return D!==y?D<y?-1:1:I!==g?I<g?-1:1:0}const r=/^(.*?)(\.([^.]*))?$/;function i(I,g=!1){const D=I?r.exec(I):[];let y=[D&&D[1]||"",D&&D[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(I){const g=I?r.exec(I):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function c(I,g,D){const y=I.compare(g,D);return y!==0?y:g.length!==D.length?g.length<D.length?-1:1:0}function h(I){const g=I.charAt(0);return g.toLocaleUpperCase()!==g}function t(I){const g=I.charAt(0);return g.toLocaleLowerCase()!==g}function p(I,g){return h(I)&&t(g)?-1:t(I)&&h(g)?1:0}function u(I,g){return t(I)&&h(g)?-1:h(I)&&t(g)?1:0}function o(I,g,D=!1){return D||(I=I&&I.toLowerCase(),g=g&&g.toLowerCase()),I===g?0:I<g?-1:1}function v(I,g,D=!1){const y=I.split(F.sep),P=g.split(F.sep),A=y.length-1,G=P.length-1;let W,U;for(let C=0;;C++){if(W=A===C,U=G===C,W&&U)return m(y[C],P[C],D);if(W)return-1;if(U)return 1;const T=o(y[C],P[C],D);if(T!==0)return T}}function b(I,g,D){const y=I.toLowerCase(),P=g.toLowerCase(),A=$(I,g,D);if(A)return A;const G=y.endsWith(D),W=P.endsWith(D);if(G!==W)return G?-1:1;const U=m(y,P);return U!==0?U:y.localeCompare(P)}function $(I,g,D){const y=I.toLowerCase(),P=g.toLowerCase(),A=y.startsWith(D),G=P.startsWith(D);if(A!==G)return A?-1:1;if(A&&G){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}}),define(Pe[45],Me([1,0,19,21,15,16]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=R,e.$ag=m,e.$bg=f,e.$cg=k,e.$dg=N,e.$eg=d,e.$fg=s,e.$gg=a,e.$hg=r,e.$ig=i,e.$jg=n,e.$kg=c,e.$lg=h,e.$mg=t,e.$ng=p,e.$og=v;function R(b){return b===47||b===92}function m(b){return b.replace(/[\\/]/g,S.$gc.sep)}function f(b){return b.indexOf("/")===-1&&(b=m(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function k(b,$=S.$gc.sep){if(!b)return"";const I=b.length,g=b.charCodeAt(0);if(R(g)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let y=3;const P=y;for(;y<I&&!R(b.charCodeAt(y));y++);if(P!==y&&!R(b.charCodeAt(y+1))){for(y+=1;y<I;y++)if(R(b.charCodeAt(y)))return b.slice(0,y+1).replace(/[\\/]/g,$)}}return $}else if(r(g)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+$:b.slice(0,2);let D=b.indexOf("://");if(D!==-1){for(D+=3;D<I;D++)if(R(b.charCodeAt(D)))return b.slice(0,D+1)}return""}function N(b){if(!F.$i||!b||b.length<5)return!1;let $=b.charCodeAt(0);if($!==92||($=b.charCodeAt(1),$!==92))return!1;let I=2;const g=I;for(;I<b.length&&($=b.charCodeAt(I),$!==92);I++);return!(g===I||($=b.charCodeAt(I+1),isNaN($)||$===92))}const E=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(b,$=F.$i){const I=$?E:l;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||$&&w.test(b)||b==="."||b===".."||$&&b[b.length-1]==="."||$&&b.length!==b.trim().length||b.length>255)}function s(b,$,I){const g=b===$;return!I||g?g:!b||!$?!1:(0,M.$kf)(b,$)}function a(b,$,I,g=S.sep){if(b===$)return!0;if(!b||!$||$.length>b.length)return!1;if(I){if(!(0,M.$lf)(b,$))return!1;if($.length===b.length)return!0;let y=$.length;return $.charAt($.length-1)===g&&y--,b.charAt(y)===g}return $.charAt($.length-1)!==g&&($+=g),b.indexOf($)===0}function r(b){return b>=65&&b<=90||b>=97&&b<=122}function i(b,$){return F.$i&&b.endsWith(":")&&(b+=S.sep),(0,S.$ic)(b)||(b=(0,S.$jc)($,b)),b=(0,S.$hc)(b),F.$i?(b=(0,M.$5e)(b,S.sep),b.endsWith(":")&&(b+=S.sep)):(b=(0,M.$5e)(b,S.sep),b||(b=S.sep)),b}function n(b){const $=(0,S.$hc)(b);return F.$i?b.length>3?!1:c($)&&(b.length===2||$.charCodeAt(2)===92):$===S.$gc.sep}function c(b,$=F.$i){return $?r(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function h(b,$=F.$i){return c(b,$)?b[0]:void 0}function t(b,$,I){return $.length>b.length?-1:b===$?0:(I&&(b=b.toLowerCase(),$=$.toLowerCase()),b.indexOf($))}function p(b){const $=b.split(":");let I,g,D;for(const y of $){const P=Number(y);(0,O.$Xf)(P)?g===void 0?g=P:D===void 0&&(D=P):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:g!==void 0?g:void 0,column:D!==void 0?D:g!==void 0?1:void 0}}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(b,$,I=8){let g="";for(let y=0;y<I;y++){let P;y===0&&F.$i&&!$&&(I===3||I===4)?P=o:P=u,g+=P.charAt(Math.floor(Math.random()*P.length))}let D;return $?D=`${$}-${g}`:D=g,b?(0,S.$jc)(b,D):D}}),define(Pe[69],Me([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0,e.$ws=O,e.$xs=R,e.$ys=m,e.$zs=k,e.$vs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(N){const E=(0,S.$oc)(N),l=F[E.toLowerCase()];return l!==void 0?l:R(N)}function R(N){const E=(0,S.$oc)(N);return M[E.toLowerCase()]}function m(N){for(const E in M)if(M[E]===N)return E}const f=/^(.+)\/(.+?)(;.+)?$/;function k(N,E){const l=f.exec(N);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:E?void 0:N}}),define(Pe[52],Me([1,0,23,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=M,e.$Oh=O,e.$Ph=m;function M(f){return JSON.stringify(f,R)}function O(f){let k=JSON.parse(f);return k=m(k),k}function R(f,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function m(f,k=0){if(!f||k>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return F.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$te||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let N=0;N<f.length;++N)f[N]=m(f[N],k+1);else for(const N in f)Object.hasOwnProperty.call(f,N)&&(f[N]=m(f[N],k+1))}return f}}),define(Pe[12],Me([1,0,14,21,15,2,19]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$tg=e.$sg=e.$rg=e.Schemas=void 0,e.$pg=f,e.$qg=k,e.$ug=E;var m;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.codeSetting="code-setting"})(m||(e.Schemas=m={}));function f(d,s){return O.URI.isUri(d)?(0,M.$kf)(d.scheme,s):(0,M.$lf)(d,s+":")}function k(d,...s){return s.some(a=>f(d,a))}e.$rg="vscode-tkn",e.$sg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,a){this.f=E(s,a)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,m.vscodeRemoteResource)}set(s,a,r){this.a[s]=a,this.b[s]=r}setConnectionToken(s,a){this.c[s]=a}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(h){return S.$1(h),s}const a=s.authority;let r=this.a[a];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const i=this.b[a],n=this.c[a];let c=`path=${encodeURIComponent(s.path)}`;return typeof n=="string"&&(c+=`&${e.$sg}=${encodeURIComponent(n)}`),O.URI.from({scheme:F.$o?this.d:m.vscodeRemoteResource,authority:`${r}:${i}`,path:this.g,query:c})}}e.$tg=new N;function E(d,s){return R.$gc.join(s??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class l{static{this.a=e.$zg}asBrowserUri(s){const a=this.b(s,me);return this.uriToBrowserUri(a)}uriToBrowserUri(s){return s.scheme===m.vscodeRemote?e.$tg.rewrite(s):s.scheme===m.file&&(F.$m||F.$q===`${m.vscodeFileResource}://${l.a}`)?s.with({scheme:m.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const a=this.b(s,me);return this.uriToFileUri(a)}uriToFileUri(s){return s.scheme===m.vscodeFileResource?s.with({scheme:m.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,a){return O.URI.isUri(s)?s:O.URI.parse(a.toUrl(s))}}e.$Ag=new l;var w;(function(d){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(s.get("3"));const a="vscode-coi";function r(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:O.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const h=c?.get(a);if(h)return s.get(h)}d.getHeadersFromQuery=r;function i(n,c,h){if(!globalThis.crossOriginIsolated)return;const t=c&&h?"3":h?"2":"1";n instanceof URLSearchParams?n.set(a,t):n[a]=t}d.addSearchParam=i})(w||(e.COI=w={}))}),define(Pe[24],Me([1,0,45,12,19,21,15,2]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=void 0,e.$Hg=f,e.$3g=N,e.$4g=l;function f(w){return(0,m.$wc)(w,!0)}class k{constructor(d){this.a=d}compare(d,s,a=!1){return d===s?0:(0,R.$df)(this.getComparisonKey(d,a),this.getComparisonKey(s,a))}isEqual(d,s,a=!1){return d===s?!0:!d||!s?!1:this.getComparisonKey(d,a)===this.getComparisonKey(s,a)}getComparisonKey(d,s=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,s,a=!1){if(d.scheme===s.scheme){if(d.scheme===F.Schemas.file)return S.$gg(f(d),f(s),this.a(d))&&d.query===s.query&&(a||d.fragment===s.fragment);if((0,e.$Yg)(d.authority,s.authority))return S.$gg(d.path,s.path,this.a(d),"/")&&d.query===s.query&&(a||d.fragment===s.fragment)}return!1}joinPath(d,...s){return m.URI.joinPath(d,...s)}basenameOrAuthority(d){return(0,e.$Qg)(d)||d.authority}basename(d){return M.$gc.basename(d.path)}extname(d){return M.$gc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let s;return d.scheme===F.Schemas.file?s=m.URI.file(M.$mc(f(d))).path:(s=M.$gc.dirname(d.path),d.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),s="/")),d.with({path:s})}normalizePath(d){if(!d.path.length)return d;let s;return d.scheme===F.Schemas.file?s=m.URI.file(M.$hc(f(d))).path:s=M.$gc.normalize(d.path),d.with({path:s})}relativePath(d,s){if(d.scheme!==s.scheme||!(0,e.$Yg)(d.authority,s.authority))return;if(d.scheme===F.Schemas.file){const i=M.$lc(f(d),f(s));return O.$i?S.$ag(i):i}let a=d.path||"/";const r=s.path||"/";if(this.a(d)){let i=0;for(const n=Math.min(a.length,r.length);i<n&&!(a.charCodeAt(i)!==r.charCodeAt(i)&&a.charAt(i).toLowerCase()!==r.charAt(i).toLowerCase());i++);a=r.substr(0,i)+a.substr(i)}return M.$gc.relative(a,r)}resolvePath(d,s){if(d.scheme===F.Schemas.file){const a=m.URI.file(M.$kc(f(d),s));return d.with({authority:a.authority,path:a.path})}return s=S.$bg(s),d.with({path:M.$gc.resolve(d.path,s)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,s){return d===s||d!==void 0&&s!==void 0&&(0,R.$kf)(d,s)}hasTrailingPathSeparator(d,s=M.sep){if(d.scheme===F.Schemas.file){const a=f(d);return a.length>S.$cg(a).length&&a[a.length-1]===s}else{const a=d.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,s=M.sep){return(0,e.$Zg)(d,s)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,s=M.sep){let a=!1;if(d.scheme===F.Schemas.file){const r=f(d);a=r!==void 0&&r.length===S.$cg(r).length&&r[r.length-1]===s}else{s="/";const r=d.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Zg)(d,s)?d.with({path:d.path+"/"}):d}}e.$Ig=k,e.$Jg=new k(()=>!1),e.$Kg=new k(w=>w.scheme===F.Schemas.file?!O.$k:!0),e.$Lg=new k(w=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function N(w,d){const s=[];for(let a=0;a<w.length;a++){const r=d(w[a]);w.some((i,n)=>n===a?!1:(0,e.$Ng)(r,d(i)))||s.push(w[a])}return s}var E;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function d(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,h]=n.split(":");c&&h&&a.set(c,h)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&a.set(w.META_DATA_MIME,i),a}w.parseMetaData=d})(E||(e.DataUri=E={}));function l(w,d,s){if(d){let a=w.path;return a&&a[0]!==M.$gc.sep&&(a=M.$gc.sep+a),w.with({scheme:s,authority:d,path:a})}return w.with({scheme:s})}}),define(Pe[11],Me([1,0,25,14,5,6,24,21,128,39]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$5g=N,e.$6g=E,e.$7g=l,e.$8g=w,e.$9g=d,e.$0g=s,e.$$g=a,e.$_g=r,e.$hh=b,e.$ih=$,e.$jh=I,e.$kh=g,e.$lh=D,e.$Ah=Ie,e.$Ih=Se;function N(ge){return!!ge&&typeof ge.then=="function"}function E(ge){const J=new S.$de,Z=ge(J.token),he=new Promise((fe,Te)=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),Te(new F.$5)});Promise.resolve(Z).then(Ce=>{de.dispose(),J.dispose(),fe(Ce)},Ce=>{de.dispose(),J.dispose(),Te(Ce)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,Te){return he.then(fe,Te)}catch(fe){return this.then(void 0,fe)}finally(fe){return he.finally(fe)}}}function l(ge,J,Z){return new Promise((he,fe)=>{const Te=J.onCancellationRequested(()=>{Te.dispose(),he(Z)});ge.then(he,fe).finally(()=>Te.dispose())})}function w(ge,J){return new Promise((Z,he)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),he(new F.$5)});ge.then(Z,he).finally(()=>fe.dispose())})}async function d(ge){let J=-1;const Z=ge.map((he,fe)=>he.then(Te=>(J=fe,Te)));try{return await Promise.race(Z)}finally{ge.forEach((he,fe)=>{fe!==J&&he.cancel()})}}function s(ge,J,Z){let he;const fe=setTimeout(()=>{he?.(void 0),Z?.()},J);return Promise.race([ge.finally(()=>clearTimeout(fe)),new Promise(Te=>he=Te)])}function a(ge){return new Promise((J,Z)=>{const he=ge();N(he)?he.then(J,Z):J(he)})}function r(){let ge,J;return{promise:new Promise((he,fe)=>{ge=he,J=fe}),resolve:ge,reject:J}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Z=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Z,Z).then(he)})}return new Promise((Z,he)=>{this.b.then(Z,he)})}return this.a=J(),new Promise((Z,he)=>{this.a.then(fe=>{this.a=null,Z(fe)},fe=>{this.a=null,he(fe)})})}dispose(){this.f=!0}}e.$ah=i;class n{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$bh=n;class c{constructor(){this.a=new Map}queue(J,Z){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$ch=c;const h=(ge,J)=>{let Z=!0;const he=setTimeout(()=>{Z=!1,J()},ge);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(he),Z=!1}}},t=ge=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ge())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class p{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Z=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,Te)=>{this.d=fe,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Z===f.$3d?t(he):h(Z,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=p;class u{constructor(J){this.a=new p(J),this.b=new i}trigger(J,Z){return this.a.trigger(()=>this.b.queue(J),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=u;class o{constructor(){this.a=!1,this.b=new Promise((J,Z)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=o;class v extends o{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$gh=v;function b(ge,J){return J?new Promise((Z,he)=>{const fe=setTimeout(()=>{Te.dispose(),Z()},ge),Te=J.onCancellationRequested(()=>{clearTimeout(fe),Te.dispose(),he(new F.$5)})}):E(Z=>b(ge,Z))}function $(ge,J=0,Z){const he=setTimeout(()=>{ge(),Z&&fe.dispose()},J),fe=(0,O.$Rc)(()=>{clearTimeout(he),Z?.deleteAndLeak(fe)});return Z?.add(fe),fe}function I(ge){const J=[];let Z=0;const he=ge.length;function fe(){return Z<he?ge[Z++]():null}function Te(de){de!=null&&J.push(de);const Ce=fe();return Ce?Ce.then(Te):Promise.resolve(J)}return Promise.resolve(null).then(Te)}function g(ge,J=he=>!!he,Z=null){let he=0;const fe=ge.length,Te=()=>{if(he>=fe)return Promise.resolve(Z);const de=ge[he++];return Promise.resolve(de()).then(Re=>J(Re)?Promise.resolve(Re):Te())};return Te()}function D(ge,J=he=>!!he,Z=null){if(ge.length===0)return Promise.resolve(Z);let he=ge.length;const fe=()=>{he=-1;for(const Te of ge)Te.cancel?.()};return new Promise((Te,de)=>{for(const Ce of ge)Ce.then(Re=>{--he>=0&&J(Re)?(fe(),Te(Re)):he===0&&Te(Z)}).catch(Re=>{--he>=0&&(fe(),de(Re))})})}class y{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new M.$6d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,he)=>{this.g.push({factory:J,c:Z,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Z=J.factory();Z.then(J.c,J.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=y;class P extends y{constructor(){super(1)}}e.$nh=P;class A{constructor(){this.a=new ue,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$oh=A;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new $e;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Z=R.$Jg){const he=Z.getComparisonKey(J);return this.a.get(he)?.size??0}queueFor(J,Z,he=R.$Jg){const fe=he.getComparisonKey(J);let Te=this.a.get(fe);if(!Te){Te=new P;const de=this.f++,Ce=M.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(de,Ce),this.a.set(fe,Te)}return Te.queue(Z)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=G;class W{constructor(J,Z){this.a=-1,typeof J=="function"&&typeof Z=="number"&&this.setIfNotSet(J,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Z)}setIfNotSet(J,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Z))}}e.$qh=W;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Z,he=globalThis){this.cancel();const fe=he.setInterval(()=>{J()},Z);this.d=(0,O.$Rc)(()=>{he.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$rh=U;class C{constructor(J,Z){this.b=-1,this.a=J,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=C;class T{constructor(J,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=J,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=T;class q extends C{constructor(J,Z){super(J,Z),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$uh=q;class ne extends O.$Tc{constructor(J,Z){super(),this.g=J,this.h=Z,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of J)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(ge,J)=>{(0,m.$B)(()=>{if(Z)return;const he=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$xh=(ge,J,Z)=>{const he=ge.requestIdleCallback(J,typeof Z=="number"?{timeout:Z}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ge.cancelIdleCallback(he))}}},e.$wh=ge=>(0,e.$xh)(globalThis,ge)}();class ce{constructor(J,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$xh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=ce;class ye extends ce{constructor(J){super(globalThis,J)}}e.$zh=ye;async function Ie(ge,J,Z){let he;for(let fe=0;fe<Z;fe++)try{return await ge()}catch(Te){he=Te,await b(J)}throw he}class ue{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Z,he){return this.a={taskId:J,cancel:()=>he?.(),promise:Z},Z.then(()=>this.d(J),()=>this.d(J)),Z}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Z,resolve:he,reject:fe}=r();this.b={run:J,promise:Z,promiseResolve:he,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=ue;class ve{constructor(J,Z=()=>Date.now()){this.d=J,this.f=Z,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Ch=ve;var re;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(re||(re={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Z)=>{this.a=J,this.b=Z})}complete(J){return new Promise(Z=>{this.a(J),this.d={outcome:0,value:J},Z()})}error(J){return new Promise(Z=>{this.b(J),this.d={outcome:1,value:J},Z()})}cancel(){return this.error(new F.$5)}}e.$Dh=$e;var ie;(function(ge){async function J(he){let fe;const Te=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{fe||(fe=Ce)})));if(typeof fe<"u")throw fe;return Te}ge.settled=J;function Z(he){return new Promise(async(fe,Te)=>{try{await he(fe,Te)}catch(de){Te(de)}})}ge.withAsyncBody=Z})(ie||(e.Promises=ie={}));class le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=le;class V{constructor(J){this.b=J,this.a=new k.$V(()=>new le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=V;var ee;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ee||(ee={}));class ke{static fromArray(J){return new ke(Z=>{Z.emitMany(J)})}static fromPromise(J){return new ke(async Z=>{Z.emitMany(await J)})}static fromPromises(J){return new ke(async Z=>{await Promise.all(J.map(async he=>Z.emitOne(await he)))})}static merge(J){return new ke(async Z=>{await Promise.all(J.map(async he=>{for await(const fe of he)Z.emitOne(fe)}))})}static{this.EMPTY=ke.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new M.$6d,queueMicrotask(async()=>{const Z={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(J(Z)),this.j()}catch(he){this.k(he)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(J,Z){return new ke(async he=>{for await(const fe of J)he.emitOne(Z(fe))})}map(J){return ke.map(this,J)}static filter(J,Z){return new ke(async he=>{for await(const fe of J)Z(fe)&&he.emitOne(fe)})}filter(J){return ke.filter(this,J)}static coalesce(J){return ke.filter(J,Z=>!!Z)}coalesce(){return ke.coalesce(this)}static async toPromise(J){const Z=[];for await(const he of J)Z.push(he);return Z}toPromise(){return ke.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Gh=ke;class Ne extends ke{constructor(J,Z){super(Z),this.l=J}cancel(){this.l.cancel()}}e.$Hh=Ne;function Se(ge){const J=new S.$de,Z=ge(J.token);return new Ne(J,async he=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),he.reject(new F.$5)});try{for await(const Te of Z){if(J.token.isCancellationRequested)return;he.emitOne(Te)}fe.dispose(),J.dispose()}catch(Te){fe.dispose(),J.dispose(),he.reject(Te)}})}class be{constructor(){this.a=new $e,this.b=new ke(he=>{if(J){he.reject(J);return}return Z&&he.emitMany(Z),this.d=fe=>he.reject(fe),this.f=fe=>he.emitOne(fe),this.a.p});let J,Z;this.f=he=>{Z||(Z=[]),Z.push(he)},this.d=he=>{J||(J=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Jh=be}),define(Pe[34],Me([1,0,18,11,45,28,19,21,15]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=k,e.$$j=d,e.$_j=P,e.$ak=A,e.$bk=G,e.$ck=W,e.$dk=U,e.$ek=ne;function k(){return Object.create(null)}e.$9j="**",e.$0j="/";const N="[/\\\\]",E="[^/\\\\]",l=/\//g;function w(ce,ye){switch(ce){case 0:return"";case 1:return`${E}*?`;default:return`(?:${N}|${E}+${N}${ye?`|${N}${E}+`:""})*?`}}function d(ce,ye){if(!ce)return[];const Ie=[];let ue=!1,ve=!1,re="";for(const $e of ce){switch($e){case ye:if(!ue&&!ve){Ie.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}re+=$e}return re&&Ie.push(re),Ie}function s(ce){if(!ce)return"";let ye="";const Ie=d(ce,e.$0j);if(Ie.every(ue=>ue===e.$9j))ye=".*";else{let ue=!1;Ie.forEach((ve,re)=>{if(ve===e.$9j){if(ue)return;ye+=w(2,re===Ie.length-1)}else{let $e=!1,ie="",le=!1,V="";for(const ee of ve){if(ee!=="}"&&$e){ie+=ee;continue}if(le&&(ee!=="]"||!V)){let ke;ee==="-"?ke=ee:(ee==="^"||ee==="!")&&!V?ke="^":ee===e.$0j?ke="":ke=(0,f.$Ye)(ee),V+=ke;continue}switch(ee){case"{":$e=!0;continue;case"[":le=!0;continue;case"}":{const Ne=`(?:${d(ie,",").map(Se=>s(Se)).join("|")})`;ye+=Ne,$e=!1,ie="";break}case"]":{ye+="["+V+"]",le=!1,V="";break}case"?":ye+=E;continue;case"*":ye+=w(1);continue;default:ye+=(0,f.$Ye)(ee)}}re<Ie.length-1&&(Ie[re+1]!==e.$9j||re+2<Ie.length)&&(ye+=N)}ue=ve===e.$9j})}return ye}const a=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Dc(1e4),p=function(){return!1},u=function(){return null};function o(ce,ye){if(!ce)return u;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ye.trimForExclusions}`;let ve=t.get(ue);if(ve)return v(ve,ce);let re;return a.test(Ie)?ve=$(Ie.substr(4),Ie):(re=r.exec(b(Ie,ye)))?ve=I(re[1],Ie):(ye.trimForExclusions?n:i).test(Ie)?ve=g(Ie,ye):(re=c.exec(b(Ie,ye)))?ve=D(re[1].substr(1),Ie,!0):(re=h.exec(b(Ie,ye)))?ve=D(re[1],Ie,!1):ve=y(Ie),t.set(ue,ve),v(ve,ce)}function v(ce,ye){if(typeof ye=="string")return ce;const Ie=function(ue,ve){return(0,M.$gg)(ue,ye.base,!m.$k)?ce((0,f.$4e)(ue.substr(ye.base.length),R.sep),ve):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function b(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function $(ce,ye){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ye:null}}function I(ce,ye){const Ie=`/${ce}`,ue=`\\${ce}`,ve=function($e,ie){return typeof $e!="string"?null:ie?ie===ce?ye:null:$e===ce||$e.endsWith(Ie)||$e.endsWith(ue)?ye:null},re=[ce];return ve.basenames=re,ve.patterns=[ye],ve.allBasenames=re,ve}function g(ce,ye){const Ie=q(ce.slice(1,-1).split(",").map(ie=>o(ie,ye)).filter(ie=>ie!==u),ce),ue=Ie.length;if(!ue)return u;if(ue===1)return Ie[0];const ve=function(ie,le){for(let V=0,ee=Ie.length;V<ee;V++)if(Ie[V](ie,le))return ce;return null},re=Ie.find(ie=>!!ie.allBasenames);re&&(ve.allBasenames=re.allBasenames);const $e=Ie.reduce((ie,le)=>le.allPaths?ie.concat(le.allPaths):ie,[]);return $e.length&&(ve.allPaths=$e),ve}function D(ce,ye,Ie){const ue=R.sep===R.$gc.sep,ve=ue?ce:ce.replace(l,R.sep),re=R.sep+ve,$e=R.$gc.sep+ce;let ie;return Ie?ie=function(le,V){return typeof le=="string"&&(le===ve||le.endsWith(re)||!ue&&(le===ce||le.endsWith($e)))?ye:null}:ie=function(le,V){return typeof le=="string"&&(le===ve||!ue&&le===ce)?ye:null},ie.allPaths=[(Ie?"*/":"./")+ce],ie}function y(ce){try{const ye=new RegExp(`^${s(ce)}$`);return function(Ie){return ye.lastIndex=0,typeof Ie=="string"&&ye.test(Ie)?ce:null}}catch{return u}}function P(ce,ye,Ie){return!ce||typeof ye!="string"?!1:A(ce)(ye,void 0,Ie)}function A(ce,ye={}){if(!ce)return p;if(typeof ce=="string"||G(ce)){const Ie=o(ce,ye);if(Ie===u)return p;const ue=function(ve,re){return!!Ie(ve,re)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return C(ce,ye)}function G(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function U(ce){return ce.allPaths||[]}function C(ce,ye){const Ie=q(Object.getOwnPropertyNames(ce).map(ie=>T(ie,ce[ie],ye)).filter(ie=>ie!==u)),ue=Ie.length;if(!ue)return u;if(!Ie.some(ie=>!!ie.requiresSiblings)){if(ue===1)return Ie[0];const ie=function(ee,ke){let Ne;for(let Se=0,be=Ie.length;Se<be;Se++){const ge=Ie[Se](ee,ke);if(typeof ge=="string")return ge;(0,F.$5g)(ge)&&(Ne||(Ne=[]),Ne.push(ge))}return Ne?(async()=>{for(const Se of Ne){const be=await Se;if(typeof be=="string")return be}return null})():null},le=Ie.find(ee=>!!ee.allBasenames);le&&(ie.allBasenames=le.allBasenames);const V=Ie.reduce((ee,ke)=>ke.allPaths?ee.concat(ke.allPaths):ee,[]);return V.length&&(ie.allPaths=V),ie}const ve=function(ie,le,V){let ee,ke;for(let Ne=0,Se=Ie.length;Ne<Se;Ne++){const be=Ie[Ne];be.requiresSiblings&&V&&(le||(le=(0,R.$nc)(ie)),ee||(ee=le.substr(0,le.length-(0,R.$oc)(ie).length)));const ge=be(ie,le,ee,V);if(typeof ge=="string")return ge;(0,F.$5g)(ge)&&(ke||(ke=[]),ke.push(ge))}return ke?(async()=>{for(const Ne of ke){const Se=await Ne;if(typeof Se=="string")return Se}return null})():null},re=Ie.find(ie=>!!ie.allBasenames);re&&(ve.allBasenames=re.allBasenames);const $e=Ie.reduce((ie,le)=>le.allPaths?ie.concat(le.allPaths):ie,[]);return $e.length&&(ve.allPaths=$e),ve}function T(ce,ye,Ie){if(ye===!1)return u;const ue=o(ce,Ie);if(ue===u)return u;if(typeof ye=="boolean")return ue;if(ye){const ve=ye.when;if(typeof ve=="string"){const re=($e,ie,le,V)=>{if(!V||!ue($e,ie))return null;const ee=ve.replace("$(basename)",()=>le),ke=V(ee);return(0,F.$5g)(ke)?ke.then(Ne=>Ne?ce:null):ke?ce:null};return re.requiresSiblings=!0,re}}return ue}function q(ce,ye){const Ie=ce.filter(ie=>!!ie.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((ie,le)=>{const V=le.basenames;return V?ie.concat(V):ie},[]);let ve;if(ye){ve=[];for(let ie=0,le=ue.length;ie<le;ie++)ve.push(ye)}else ve=Ie.reduce((ie,le)=>{const V=le.patterns;return V?ie.concat(V):ie},[]);const re=function(ie,le){if(typeof ie!="string")return null;if(!le){let ee;for(ee=ie.length;ee>0;ee--){const ke=ie.charCodeAt(ee-1);if(ke===47||ke===92)break}le=ie.substr(ee)}const V=ue.indexOf(le);return V!==-1?ve[V]:null};re.basenames=ue,re.patterns=ve,re.allBasenames=ue;const $e=ce.filter(ie=>!ie.basenames);return $e.push(re),$e}function ne(ce,ye){return(0,S.$ub)(ce,ye,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Pe[53],Me([1,0,14,129,24,15,2]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ek=k,e.$Fk=N,e.$Gk=E,e.$Hk=l,e.$Ik=w,e.$Jk=d,e.$Kk=s,e.$Lk=a;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=l(this.supportThemeIcons?(0,F.$xk)(i):i).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${w(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,O.$Ye)(n),"g");return i.replace(c,(h,t)=>i.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Dk=f;function k(r){return N(r)?!r.value:Array.isArray(r)?r.every(k):!0}function N(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}function E(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,M.$Mg)(R.URI.from(r.baseUri),R.URI.from(i.baseUri)))}function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(r,i){const n=r.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,r,`${"`".repeat(c)}`].join(`
`)}function d(r){return r.replace(/"/g,"&quot;")}function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(r){const i=[],n=r.split("|").map(h=>h.trim());r=n[0];const c=n[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),p=h?h[1]:"",u=t?t[1]:"",o=isFinite(parseInt(u)),v=isFinite(parseInt(p));o&&i.push(`width="${u}"`),v&&i.push(`height="${p}"`)}return{href:r,dimensions:i}}}),define(Pe[96],Me([1,0,18,45,19,21,24,15]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=f,e.$dw=N,e.$ew=l,e.$fw=w,e.$gw=r,e.$hw=n,e.$iw=c,e.$jw=h,e.$kw=t,e.$lw=p;function f(o,v){const{os:b,tildify:$,relative:I}=v;if(I){const y=k(o,I,b);if(typeof y=="string")return y}let g=o.fsPath;if(b===1&&!O.$i?g=g.replace(/\//g,"\\"):b!==1&&O.$i&&(g=g.replace(/\\/g,"/")),b!==1&&$?.userHome){const y=$.userHome.fsPath;let P;o.scheme!==$.userHome.scheme&&o.path[0]===M.$gc.sep&&o.path[1]!==M.$gc.sep?P=$.userHome.with({path:o.path}).fsPath:P=g,g=l(P,y,b)}return(b===1?M.$fc:M.$gc).normalize(N(g,b===1))}function k(o,v,b){const $=b===1?M.$fc:M.$gc,I=b===3?R.$Jg:R.$Lg,g=v.getWorkspace(),D=(0,S.$Ob)(g.folders);if(!D)return;o.scheme!==D.uri.scheme&&o.path[0]===M.$gc.sep&&o.path[1]!==M.$gc.sep&&(o=D.uri.with({path:o.path}));const y=v.getWorkspaceFolder(o);if(!y)return;let P;if(I.isEqual(y.uri,o)?P="":P=I.relativePath(y.uri,o)??"",P&&(P=$.normalize(P)),g.folders.length>1&&!v.noPrefix){const A=y.name?y.name:I.basenameOrAuthority(y.uri);P=P?`${A} \u2022 ${P}`:A}return P}function N(o,v=O.$i){return(0,F.$kg)(o,v)?o.charAt(0).toUpperCase()+o.slice(1):o}let E=Object.create(null);function l(o,v,b=O.OS){if(b===1||!o||!v)return o;let $=E.original===v?E.normalized:void 0;$||($=v,O.$i&&($=(0,F.$ag)($)),$=`${(0,m.$5e)($,M.$gc.sep)}${M.$gc.sep}`,E={original:v,normalized:$});let I=o;return O.$i&&(I=(0,F.$ag)(I)),(b===3?I.startsWith($):(0,m.$lf)(I,$))?`~/${I.substr($.length)}`:o}function w(o,v){return o.replace(/^~($|\/|\\)/,`${v}$1`)}const d="\u2026",s="\\\\",a="~";function r(o,v=M.sep){const b=new Array(o.length);let $=!1;for(let I=0;I<o.length;I++){const g=o[I];if(g===""){b[I]=`.${v}`;continue}if(!g){b[I]=g;continue}$=!0;let D="",y=g;y.indexOf(s)===0?(D=y.substr(0,y.indexOf(s)+s.length),y=y.substr(y.indexOf(s)+s.length)):y.indexOf(v)===0?(D=y.substr(0,y.indexOf(v)+v.length),y=y.substr(y.indexOf(v)+v.length)):y.indexOf(a)===0&&(D=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length));const P=y.split(v);for(let A=1;$&&A<=P.length;A++)for(let G=P.length-A;$&&G>=0;G--){$=!1;let W=P.slice(G,G+A).join(v);for(let U=0;!$&&U<o.length;U++)if(U!==I&&o[U]&&o[U].indexOf(W)>-1){const C=G+A===P.length,T=G>0&&o[U].indexOf(v)>-1?v+W:W,q=o[U].endsWith(T);$=!C||q}if(!$){let U="";(P[0].endsWith(":")||D!=="")&&(G===1&&(G=0,A++,W=P[0]+v+W),G>0&&(U=P[0]+v),U=D+U),G>0&&(U=U+d+v),U=U+W,G+A<P.length&&(U=U+v+d),b[I]=U}}$&&(b[I]=g)}return b}var i;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(o,v=Object.create(null)){const b=[];let $=!1,I="";for(const g of o)if(g==="$"||$&&g==="{")I&&b.push({value:I,type:i.TEXT}),I="",$=!0;else if(g==="}"&&$){const D=v[I];if(typeof D=="string")D.length&&b.push({value:D,type:i.VARIABLE});else if(D){const y=b[b.length-1];(!y||y.type!==i.SEPARATOR)&&b.push({value:D.label,type:i.SEPARATOR})}I="",$=!1}else I+=g;return I&&!$&&b.push({value:I,type:i.TEXT}),b.filter((g,D)=>{if(g.type===i.SEPARATOR){const y=b[D-1],P=b[D+1];return[y,P].every(A=>A&&(A.type===i.VARIABLE||A.type===i.TEXT)&&A.value.length>0)}return!0}).map(g=>g.value).join("")}function c(o,v){return O.$j||v?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):o.replace(/&&|&/g,b=>b==="&"?"&&":"&")}function h(o,v){return O.$j||v?o.replace(/\(&&\w\)|&&/g,""):O.$i?o.replace(/&&|&/g,b=>b==="&"?"&&":"&"):o.replace(/&&/g,"_")}function t(o){return o.replace(/&/g,"&&")}function p(o){if(o.endsWith("]")){const v=o.lastIndexOf(" [",o.length-2);if(v!==-1){const b=u(o.substring(0,v)),$=o.substring(v);return{name:b.name+$,parentPath:b.parentPath}}}return u(o)}function u(o){const v=o.indexOf("/")!==-1?M.$gc:M.$fc,b=v.basename(o),$=v.dirname(o);return b.length?{name:b,parentPath:$}:{name:$,parentPath:""}}}),define(Pe[142],Me([1,0,23,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$kn=m,e.$ln=k,e.$mn=N;function M(E){return E.toJSON()}class O{constructor(l){this.a=l}transformIncoming(l){const w=this.a.transformIncoming(l);return w===l?l:M(F.URI.from(w))}transformOutgoing(l){const w=this.a.transformOutgoing(l);return w===l?l:M(F.URI.from(w))}transformOutgoingURI(l){const w=this.a.transformOutgoing(l);return w===l?l:F.URI.from(w)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$in=O,e.$jn=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function R(E,l,w){if(!E||w>200)return null;if(typeof E=="object"){if(E instanceof F.URI)return l.transformOutgoing(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const s=R(E[d],l,w+1);s!==null&&(E[d]=s)}}return null}function m(E,l){const w=R(E,l,0);return w===null?E:w}function f(E,l,w,d){if(!E||d>200)return null;if(typeof E=="object"){if(E.$mid===1)return w?F.URI.revive(l.transformIncoming(E)):l.transformIncoming(E);if(E instanceof S.$te)return null;for(const s in E)if(Object.hasOwnProperty.call(E,s)){const a=f(E[s],l,w,d+1);a!==null&&(E[s]=a)}}return null}function k(E,l){const w=f(E,l,!1,0);return w===null?E:w}function N(E,l){const w=f(E,l,!0,0);return w===null?E:w}}),define(Pe[143],Me([1,0,15,21,23]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0,e.$qt=N,e.$rt=E;let O;function R(){return O||(O=new TextDecoder("UTF-16LE")),O}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let k;function N(){return k||(k=F.$D()?R():f()),k}function E(d,s,a){const r=new Uint16Array(d.buffer,s,a);return a>0&&(r[0]===65279||r[0]===65534)?l(d,s,a):R().decode(r)}function l(d,s,a){const r=[];let i=0;for(let n=0;n<a;n++){const c=M.$ve(d,s);s+=2,r[i++]=String.fromCharCode(c)}return r.join("")}class w{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return N().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const a=this.a-this.d;a<=1&&(a===0||S.$of(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const a=s.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<a;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$st=w}),define(Pe[144],Me([1,0,23,143]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$ut=R;function M(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,N,E,l){this.oldPosition=k,this.oldText=N,this.newPosition=E,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,N,E){const l=N.length;S.$ye(k,l,E),E+=4;for(let w=0;w<l;w++)S.$we(k,N.charCodeAt(w),E),E+=2;return E}static d(k,N){const E=S.$xe(k,N);return N+=4,(0,F.$rt)(k,N,E)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(k,N){return S.$ye(k,this.oldPosition,N),N+=4,S.$ye(k,this.newPosition,N),N+=4,N=O.c(k,this.oldText,N),N=O.c(k,this.newText,N),N}static read(k,N,E){const l=S.$xe(k,N);N+=4;const w=S.$xe(k,N);N+=4;const d=O.d(k,N);N+=O.a(d);const s=O.d(k,N);return N+=O.a(s),E.push(new O(l,d,w,s)),N}}e.$tt=O;function R(f,k){return f===null||f.length===0?k:new m(f,k).compress()}class m{constructor(k,N){this.a=k,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,N=0,E=this.n(k),l=this.l(N);for(;k<this.f||N<this.h;){if(E===null){this.k(l),l=this.l(++N);continue}if(l===null){this.m(E),E=this.n(++k);continue}if(l.oldEnd<=E.newPosition){this.k(l),l=this.l(++N);continue}if(E.newEnd<=l.oldPosition){this.m(E),E=this.n(++k);continue}if(l.oldPosition<E.newPosition){const[r,i]=m.r(l,E.newPosition-l.oldPosition);this.k(r),l=i;continue}if(E.newPosition<l.oldPosition){const[r,i]=m.q(E,l.oldPosition-E.newPosition);this.m(r),E=i;continue}let s,a;if(l.oldEnd===E.newEnd)s=E,a=l,E=this.n(++k),l=this.l(++N);else if(l.oldEnd<E.newEnd){const[r,i]=m.q(E,l.oldLength);s=r,a=l,E=i,l=this.l(++N)}else{const[r,i]=m.r(l,E.newLength);s=E,a=r,E=this.n(++k),l=i}this.d[this.e++]=new O(s.oldPosition,s.oldText,a.newPosition,a.newText),this.g+=s.newLength-s.oldLength,this.j+=a.newLength-a.oldLength}const w=m.s(this.d);return m.t(w)}k(k){this.d[this.e++]=m.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=m.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,N){return new O(N.oldPosition-k,N.oldText,N.newPosition,N.newText)}static p(k,N){return new O(N.oldPosition,N.oldText,N.newPosition+k,N.newText)}static q(k,N){const E=k.newText.substr(0,N),l=k.newText.substr(N);return[new O(k.oldPosition,k.oldText,k.newPosition,E),new O(k.oldEnd,"",k.newPosition+N,l)]}static r(k,N){const E=k.oldText.substr(0,N),l=k.oldText.substr(N);return[new O(k.oldPosition,E,k.newPosition,k.newText),new O(k.oldPosition+N,l,k.newEnd,"")]}static s(k){if(k.length===0)return k;const N=[];let E=0,l=k[0];for(let w=1;w<k.length;w++){const d=k[w];l.oldEnd===d.oldPosition?l=new O(l.oldPosition,l.oldText+d.oldText,l.newPosition,l.newText+d.newText):(N[E++]=l,l=d)}return N[E++]=l,N}static t(k){if(k.length===0)return k;const N=[];let E=0;for(let l=0;l<k.length;l++){const w=k[l];w.oldText!==w.newText&&(N[E++]=w)}return N}}}),define(Pe[145],Me([1,0,34,19]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=M,e.$St=O;function M(R,m,f,k,N,E){if(Array.isArray(R)){let l=0;for(const w of R){const d=M(w,m,f,k,N,E);if(d===10)return d;d>l&&(l=d)}return l}else{if(typeof R=="string")return k?R==="*"?5:R===f?10:0:0;if(R){const{language:l,pattern:w,scheme:d,hasAccessToAllModels:s,notebookType:a}=R;if(!k&&!s)return 0;a&&N&&(m=N);let r=0;if(d)if(d===m.scheme)r=10;else if(d==="*")r=5;else return 0;if(l)if(l===f)r=10;else if(l==="*")r=Math.max(r,5);else return 0;if(a)if(a===E)r=10;else if(a==="*"&&E!==void 0)r=Math.max(r,5);else return 0;if(w){let i;if(typeof w=="string"?i=w:i={...w,base:(0,F.$hc)(w.base)},i===m.fsPath||(0,S.$_j)(i,m.fsPath))r=10;else return 0}return r}else return 0}}function O(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(O):!!R.notebookType}}),define(Pe[146],Me([1,0,5,15,29,94,92,131,144,6]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=void 0;class N extends k.$Tc{constructor(l,w,d,s,a,r,i){super(),this.m=this.B(new S.$6d),this.onDidChangeContent=this.m.event,this.f=w,this.j=!r,this.g=s,this.h=a,this.c=new R.$tC(l,d,i)}equals(l){return!(l instanceof N)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,w){return this.c.getOffsetAt(l,w)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,w){const d=l+w,s=this.getPositionAt(l),a=this.getPositionAt(d);return new M.$$s(s.lineNumber,s.column,a.lineNumber,a.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const d=this.n(w);return this.c.getValueInRange(l,d)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const d=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const r=this.n(w),i=this.getEOL();if(r.length!==i.length){const n=r.length-i.length,c=l.endLineNumber-l.startLineNumber;a=n*c}return s-d+a}getCharacterCountInRange(l,w=0){if(this.j){let d=0;const s=l.startLineNumber,a=l.endLineNumber;for(let r=s;r<=a;r++){const i=this.getLineContent(r),n=r===s?l.startColumn-1:0,c=r===a?l.endColumn-1:i.length;for(let h=n;h<c;h++)F.$of(i.charCodeAt(h))?(d=d+1,h=h+1):d=d+1}return d+=this.n(w).length*(a-s),d}return this.getValueLengthInRange(l,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,w){return this.c.getLineCharCode(l,w)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=F.$_e(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=F.$bf(this.getLineContent(l));return w===-1?0:w+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,w,d){let s=this.g,a=this.h,r=this.j,i=!0,n=[];for(let v=0;v<l.length;v++){const b=l[v];i&&b._isTracked&&(i=!1);const $=b.range;if(b.text){let P=!0;r||(P=!F.$zf(b.text),r=P),!s&&P&&(s=F.$yf(b.text)),!a&&P&&(a=F.$Bf(b.text))}let I="",g=0,D=0,y=0;if(b.text){let P;[g,D,y,P]=(0,m.$Kt)(b.text);const A=this.getEOL();P===0||P===(A===`\r
`?2:1)?I=b.text:I=b.text.replace(/\r\n|\r|\n/g,A)}n[v]={sortIndex:v,identifier:b.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:I,eolCount:g,firstLineLength:D,lastLineLength:y,forceMoveMarkers:!!b.forceMoveMarkers,isAutoWhitespaceEdit:b.isAutoWhitespaceEdit||!1}}n.sort(N.u);let c=!1;for(let v=0,b=n.length-1;v<b;v++){const $=n[v].range.getEndPosition(),I=n[v+1].range.getStartPosition();if(I.isBeforeOrEqual($)){if(I.isBefore($))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const h=d||w?N._getInverseEditRanges(n):[],t=[];if(w)for(let v=0;v<n.length;v++){const b=n[v],$=h[v];if(b.isAutoWhitespaceEdit&&b.range.isEmpty())for(let I=$.startLineNumber;I<=$.endLineNumber;I++){let g="";I===$.startLineNumber&&(g=this.getLineContent(b.range.startLineNumber),F.$_e(g)!==-1)||t.push({lineNumber:I,oldContent:g})}}let p=null;if(d){let v=0;p=[];for(let b=0;b<n.length;b++){const $=n[b],I=h[b],g=this.getValueInRange($.range),D=$.rangeOffset+v;v+=$.text.length-g.length,p[b]={sortIndex:$.sortIndex,identifier:$.identifier,range:I,text:g,textChange:new f.$tt($.rangeOffset,g,D,$.text)}}c||p.sort((b,$)=>b.sortIndex-$.sortIndex)}this.g=s,this.h=a,this.j=r;const u=this.t(n);let o=null;if(w&&t.length>0){t.sort((v,b)=>b.lineNumber-v.lineNumber),o=[];for(let v=0,b=t.length;v<b;v++){const $=t[v].lineNumber;if(v>0&&t[v-1].lineNumber===$)continue;const I=t[v].oldContent,g=this.getLineContent($);g.length===0||g===I||F.$_e(g)!==-1||o.push($)}}return this.m.fire(),new O.$wv(p,u,o)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const d=l[0].range,s=l[l.length-1].range,a=new M.$$s(d.startLineNumber,d.startColumn,s.endLineNumber,s.endColumn);let r=d.startLineNumber,i=d.startColumn;const n=[];for(let u=0,o=l.length;u<o;u++){const v=l[u],b=v.range;w=w||v.forceMoveMarkers,n.push(this.getValueInRange(new M.$$s(r,i,b.startLineNumber,b.startColumn))),v.text.length>0&&n.push(v.text),r=b.endLineNumber,i=b.endColumn}const c=n.join(""),[h,t,p]=(0,m.$Kt)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:p,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(l){l.sort(N.w);const w=[];for(let d=0;d<l.length;d++){const s=l[d],a=s.range.startLineNumber,r=s.range.startColumn,i=s.range.endLineNumber,n=s.range.endColumn;if(a===i&&r===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new M.$$s(a,r,i,n);w.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,d,s){return this.c.findMatchesLineByLine(l,w,d,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,w){const d=l.startLineNumber,s=l.startColumn,[a,r,i]=(0,m.$Kt)(w);let n;if(w.length>0){const c=a+1;c===1?n=new M.$$s(d,s,d,s+r):n=new M.$$s(d,s,d+c-1,i+1)}else n=new M.$$s(d,s,d,s);return n}static _getInverseEditRanges(l){const w=[];let d=0,s=0,a=null;for(let r=0,i=l.length;r<i;r++){const n=l[r];let c,h;a?a.range.endLineNumber===n.range.startLineNumber?(c=d,h=s+(n.range.startColumn-a.range.endColumn)):(c=d+(n.range.startLineNumber-a.range.endLineNumber),h=n.range.startColumn):(c=n.range.startLineNumber,h=n.range.startColumn);let t;if(n.text.length>0){const p=n.eolCount+1;p===1?t=new M.$$s(c,h,c,h+n.firstLineLength):t=new M.$$s(c,h,c+p-1,n.lastLineLength+1)}else t=new M.$$s(c,h,c,h);d=t.endLineNumber,s=t.endColumn,w.push(t),a=n}return w}static u(l,w){const d=M.$$s.compareRangesUsingEnds(l.range,w.range);return d===0?l.sortIndex-w.sortIndex:d}static w(l,w){const d=M.$$s.compareRangesUsingEnds(l.range,w.range);return d===0?w.sortIndex-l.sortIndex:-d}}e.$uC=N}),define(Pe[147],Me([1,0,15,92,146]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class O{constructor(f,k,N,E,l,w,d,s,a){this.a=f,this.b=k,this.c=N,this.d=E,this.e=l,this.f=w,this.g=d,this.h=s,this.j=a}k(f){const k=this.c+this.d+this.e,N=this.c+this.e;return k===0?f===1?`
`:`\r
`:N>k/2?`\r
`:`
`}create(f){const k=this.k(f),N=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let l=0,w=N.length;l<w;l++){const d=N[l].buffer.replace(/\r\n|\r|\n/g,k),s=(0,F.$pC)(d);N[l]=new F.$sC(d,s)}const E=new M.$uC(N,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$Hf(f)&&(this.b=S.$Gf,f=f.substr(1));const k=f.charCodeAt(f.length-1);k===13||k>=55296&&k<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=k):(this.m(f,!1),this.c=!1,this.d=k)}m(f,k){!k&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const k=(0,F.$qC)(this.e,f);this.a.push(new F.$sC(f,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=S.$yf(f)),this.k||(this.k=S.$Bf(f)))}finish(f=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const k=(0,F.$pC)(f.buffer);f.lineStarts=k,this.d===13&&this.f++}}}e.$vC=R}),define(Pe[97],Me([1,0,23,21]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lab=f,e.$mab=N;var M;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(M||(M={}));function O(E){for(let l=0,w=E.length;l<w;l+=4){const d=E[l+0],s=E[l+1],a=E[l+2],r=E[l+3];E[l+0]=r,E[l+1]=a,E[l+2]=s,E[l+3]=d}}function R(E){const l=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return F.$D()||O(l),S.$te.wrap(l)}function m(E){const l=E.buffer;if(F.$D()||O(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function f(E){const l=new Uint32Array(k(E));let w=0;if(l[w++]=E.id,E.type==="full")l[w++]=1,l[w++]=E.data.length,l.set(E.data,w),w+=E.data.length;else{l[w++]=2,l[w++]=E.deltas.length;for(const d of E.deltas)l[w++]=d.start,l[w++]=d.deleteCount,d.data?(l[w++]=d.data.length,l.set(d.data,w),w+=d.data.length):l[w++]=0}return R(l)}function k(E){let l=0;if(l+=2,E.type==="full")l+=1+E.data.length;else{l+=1,l+=3*E.deltas.length;for(const w of E.deltas)w.data&&(l+=w.data.length)}return l}function N(E){const l=m(E);let w=0;const d=l[w++];if(l[w++]===1){const i=l[w++],n=l.subarray(w,w+i);return w+=i,{id:d,type:"full",data:n}}const a=l[w++],r=[];for(let i=0;i<a;i++){const n=l[w++],c=l[w++],h=l[w++];let t;h>0&&(t=l.subarray(w,w+h),w+=h),r[i]={start:n,deleteCount:c,data:t}}return{id:d,type:"delta",deltas:r}}}),define(Pe[148],Me([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[149],Me([1,0,18,26,21,132,150,148]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=a,e.clampedInt=i,e.clampedFloat=c,e.stringSet=p,e.cursorStyleToString=y,e.filterValidationDecorations=fe;var f;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class E{constructor(X,pe,We,Xe){this.id=X,this.name=pe,this.defaultValue=We,this.schema=Xe}applyUpdate(X,pe){return w(X,pe)}compute(X,pe,We){return We}}class l{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=l;function w(Y,X){if(typeof Y!="object"||typeof X!="object"||!Y||!X)return new l(X,Y!==X);if(Array.isArray(Y)||Array.isArray(X)){const We=Array.isArray(Y)&&Array.isArray(X)&&S.$ub(Y,X);return new l(X,!We)}let pe=!1;for(const We in X)if(X.hasOwnProperty(We)){const Xe=w(Y[We],X[We]);Xe.didChange&&(Y[We]=Xe.newValue,pe=!0)}return new l(Y,pe)}class d{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return w(X,pe)}validate(X){return this.defaultValue}}class s{constructor(X,pe,We,Xe){this.id=X,this.name=pe,this.defaultValue=We,this.schema=Xe}applyUpdate(X,pe){return w(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,We){return We}}function a(Y,X){return typeof Y>"u"?X:Y==="false"?!1:!!Y}class r extends s{constructor(X,pe,We,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=We),super(X,pe,We,Xe)}validate(X){return a(X,this.defaultValue)}}function i(Y,X,pe,We){if(typeof Y>"u")return X;let Xe=parseInt(Y,10);return isNaN(Xe)?X:(Xe=Math.max(pe,Xe),Xe=Math.min(We,Xe),Xe|0)}class n extends s{static clampedInt(X,pe,We,Xe){return i(X,pe,We,Xe)}constructor(X,pe,We,Xe,st,Fe=void 0){typeof Fe<"u"&&(Fe.type="integer",Fe.default=We,Fe.minimum=Xe,Fe.maximum=st),super(X,pe,We,Fe),this.minimum=Xe,this.maximum=st}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Y,X,pe,We){if(typeof Y>"u")return X;const Xe=h.float(Y,X);return h.clamp(Xe,pe,We)}class h extends s{static clamp(X,pe,We){return X<pe?pe:X>We?We:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const We=parseFloat(X);return isNaN(We)?pe:We}constructor(X,pe,We,Xe,st){typeof st<"u"&&(st.type="number",st.default=We),super(X,pe,We,st),this.validationFn=Xe}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class t extends s{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,We,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=We),super(X,pe,We,Xe)}validate(X){return t.string(X,this.defaultValue)}}function p(Y,X,pe,We){return typeof Y!="string"?X:We&&Y in We?We[Y]:pe.indexOf(Y)===-1?X:Y}class u extends s{constructor(X,pe,We,Xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Xe,st.default=We),super(X,pe,We,st),this.c=Xe}validate(X){return p(X,this.defaultValue,this.c)}}class o extends E{constructor(X,pe,We,Xe,st,Fe,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=st,Dt.default=Xe),super(X,pe,We,Dt),this.c=st,this.d=Fe}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function v(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,We){return We===0?X.accessibilitySupport:We}}class $ extends E{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:m.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:a(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function g(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function y(Y){switch(Y){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function P(Y){switch(Y){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class A extends d{constructor(){super(141)}compute(X,pe,We){const Xe=["monaco-editor"];return pe.get(39)&&Xe.push(pe.get(39)),X.extraEditorClassName&&Xe.push(X.extraEditorClassName),pe.get(74)==="default"?Xe.push("mouse-default"):pe.get(74)==="copy"&&Xe.push("mouse-copy"),pe.get(111)&&Xe.push("showUnused"),pe.get(139)&&Xe.push("showDeprecated"),Xe.join(" ")}}class G extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(X,pe,We){return We&&X.emptySelectionClipboard}}class W extends E{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:m.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:m.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:a(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":p(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":p(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(pe.loop,this.defaultValue.loop)}}}class U extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?U.OFF:X==="true"?U.ON:X:X?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?C.OFF:X==="true"?C.TRANSLATE:X:X?C.TRANSLATE:C.OFF}compute(X,pe,We){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class T extends d{constructor(){super(50)}compute(X,pe,We){return X.fontInfo}}class q extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(X){const pe=h.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(X,pe,We){return X.fontInfo.fontSize}}class ne extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ne.d,maximum:ne.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ne.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ne.d,ne.e))}}class ce extends E{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:We,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:We,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:We,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:We,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:We,description:m.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:p(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??p(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??p(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??p(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??p(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??p(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends E{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:m.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:a(pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(pe.above,this.defaultValue.above)}}}var Ie;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends d{constructor(){super(144)}compute(X,pe,We){return ue.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,We=Math.floor(X.paddingTop/X.lineHeight);let Xe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Xe=Math.max(Xe,pe-1));const st=(We+X.viewLineCount+Xe)/(X.pixelRatio*X.height),Fe=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Xe,desiredRatio:st,minimapLineCount:Fe}}static c(X,pe){const We=X.outerWidth,Xe=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const Fe=pe.stableMinimapLayoutInput,Dt=Fe&&X.outerHeight===Fe.outerHeight&&X.lineHeight===Fe.lineHeight&&X.typicalHalfwidthCharacterWidth===Fe.typicalHalfwidthCharacterWidth&&X.pixelRatio===Fe.pixelRatio&&X.scrollBeyondLastLine===Fe.scrollBeyondLastLine&&X.paddingTop===Fe.paddingTop&&X.paddingBottom===Fe.paddingBottom&&X.minimap.enabled===Fe.minimap.enabled&&X.minimap.side===Fe.minimap.side&&X.minimap.size===Fe.minimap.size&&X.minimap.showSlider===Fe.minimap.showSlider&&X.minimap.renderCharacters===Fe.minimap.renderCharacters&&X.minimap.maxColumn===Fe.minimap.maxColumn&&X.minimap.scale===Fe.minimap.scale&&X.verticalScrollbarWidth===Fe.verticalScrollbarWidth&&X.isViewportWrapping===Fe.isViewportWrapping,Jt=X.lineHeight,jt=X.typicalHalfwidthCharacterWidth,ri=X.scrollBeyondLastLine,Vt=X.minimap.renderCharacters;let St=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const xt=X.minimap.maxColumn,Wt=X.minimap.size,si=X.minimap.side,_t=X.verticalScrollbarWidth,Ze=X.viewLineCount,Ot=X.remainingWidth,ei=X.isViewportWrapping,dt=Vt?2:3;let $t=Math.floor(st*Xe);const ti=$t/st;let qt=!1,Ht=!1,ht=dt*St,Rt=St/st,ii=1;if(Wt==="fill"||Wt==="fit"){const{typicalViewportLineCount:It,extraLinesBeforeFirstLine:Ct,extraLinesBeyondLastLine:Nt,desiredRatio:oi,minimapLineCount:Ut}=ue.computeContainedMinimapLineCount({viewLineCount:Ze,scrollBeyondLastLine:ri,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Xe,lineHeight:Jt,pixelRatio:st});if(Ze/Ut>1)qt=!0,Ht=!0,St=1,ht=1,Rt=St/st;else{let bt=!1,Ft=St+1;if(Wt==="fit"){const Bt=Math.ceil((Ct+Ze+Nt)*ht);ei&&Dt&&Ot<=pe.stableFitRemainingWidth?(bt=!0,Ft=pe.stableFitMaxMinimapScale):bt=Bt>$t}if(Wt==="fill"||bt){qt=!0;const Bt=St;ht=Math.min(Jt*st,Math.max(1,Math.floor(1/oi))),ei&&Dt&&Ot<=pe.stableFitRemainingWidth&&(Ft=pe.stableFitMaxMinimapScale),St=Math.min(Ft,Math.max(1,Math.floor(ht/dt))),St>Bt&&(ii=Math.min(2,St/Bt)),Rt=St/st/ii,$t=Math.ceil(Math.max(It,Ct+Ze+Nt)*ht),ei?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Ot,pe.stableFitMaxMinimapScale=St):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ni=Math.floor(xt*Rt),He=Math.min(ni,Math.max(0,Math.floor((Ot-_t-2)*Rt/(jt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Tt=Math.floor(st*He);const zt=Tt/st;Tt=Math.floor(Tt*ii);const Yt=Vt?1:2,mt=si==="left"?0:We-He-_t;return{renderMinimap:Yt,minimapLeft:mt,minimapWidth:He,minimapHeightIsEditorHeight:qt,minimapIsSampling:Ht,minimapScale:St,minimapLineHeight:ht,minimapCanvasInnerWidth:Tt,minimapCanvasInnerHeight:$t,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:ti}}static computeLayout(X,pe){const We=pe.outerWidth|0,Xe=pe.outerHeight|0,st=pe.lineHeight|0,Fe=pe.lineNumbersDigitCount|0,Dt=pe.typicalHalfwidthCharacterWidth,Jt=pe.maxDigitWidth,jt=pe.pixelRatio,ri=pe.viewLineCount,Vt=X.get(136),St=Vt==="inherit"?X.get(135):Vt,xt=St==="inherit"?X.get(131):St,Wt=X.get(134),si=pe.isDominatedByLongLines,_t=X.get(57),Ze=X.get(68).renderType!==0,Ot=X.get(69),ei=X.get(105),dt=X.get(84),$t=X.get(73),ti=X.get(103),qt=ti.verticalScrollbarSize,Ht=ti.verticalHasArrows,ht=ti.arrowSize,Rt=ti.horizontalScrollbarSize,ii=X.get(43),ni=X.get(110)!=="never";let He=X.get(66);ii&&ni&&(He+=16);let Tt=0;if(Ze){const wt=Math.max(Fe,Ot);Tt=Math.round(wt*Jt)}let zt=0;_t&&(zt=st*pe.glyphMarginDecorationLaneCount);let Yt=0,mt=Yt+zt,It=mt+Tt,Ct=It+He;const Nt=We-zt-Tt-He;let oi=!1,Ut=!1,Zt=-1;St==="inherit"&&si?(oi=!0,Ut=!0):xt==="on"||xt==="bounded"?Ut=!0:xt==="wordWrapColumn"&&(Zt=Wt);const bt=ue.c({outerWidth:We,outerHeight:Xe,lineHeight:st,typicalHalfwidthCharacterWidth:Dt,pixelRatio:jt,scrollBeyondLastLine:ei,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:$t,verticalScrollbarWidth:qt,viewLineCount:ri,remainingWidth:Nt,isViewportWrapping:Ut},pe.memory||new N);bt.renderMinimap!==0&&bt.minimapLeft===0&&(Yt+=bt.minimapWidth,mt+=bt.minimapWidth,It+=bt.minimapWidth,Ct+=bt.minimapWidth);const Ft=Nt-bt.minimapWidth,Bt=Math.max(1,Math.floor((Ft-qt-2)/Dt)),Lt=Ht?ht:0;return Ut&&(Zt=Math.max(1,Bt),xt==="bounded"&&(Zt=Math.min(Zt,Wt))),{width:We,height:Xe,glyphMarginLeft:Yt,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Tt,decorationsLeft:It,decorationsWidth:He,contentLeft:Ct,contentWidth:Ft,minimap:bt,viewportColumn:Bt,isWordWrapMinified:oi,isViewportWrapping:Ut,wrappingColumn:Zt,verticalScrollbarWidth:qt,horizontalScrollbarHeight:Rt,overviewRuler:{top:Lt,width:qt,height:Xe-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=ue;class ve extends E{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(X){return p(X,"simple",["simple","advanced"])}compute(X,pe,We){return pe.get(2)===2?"advanced":We}}var re;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class $e extends E{constructor(){const X={enabled:re.OnCode};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:X.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:p(X.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class ie extends E{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:m.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class le extends E{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:m.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:p(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:a(pe.padding,this.defaultValue.padding)}}}class V extends E{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,We){return We<0?n.clampedInt(-We*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class ee extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>h.clamp(X,0,150),{markdownDescription:m.localize(66,null)})}compute(X,pe,We){return X.fontInfo.lineHeight}}class ke extends E{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:X.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:m.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),autohide:a(pe.autohide,this.defaultValue.autohide),size:p(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(pe.side,this.defaultValue.side,["right","left"]),showSlider:p(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(pe.scale,1,1,3),maxColumn:n.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ne(Y){return Y==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class Se extends E{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:n.clampedInt(pe.top,0,0,1e3),bottom:n.clampedInt(pe.bottom,0,0,1e3)}}}class be extends E{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:m.localize(81,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),cycle:a(pe.cycle,this.defaultValue.cycle)}}}class ge extends d{constructor(){super(142)}compute(X,pe,We){return X.pixelRatio}}class J extends E{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:X.comments,description:m.localize(86,null)},other:{anyOf:pe,default:X.other,description:m.localize(87,null)}},default:X,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const jt=X?"on":"off";return{comments:jt,strings:jt,other:jt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:We,strings:Xe}=X,st=["on","inline","off"];let Fe,Dt,Jt;return typeof pe=="boolean"?Fe=pe?"on":"off":Fe=p(pe,this.defaultValue.other,st),typeof We=="boolean"?Dt=We?"on":"off":Dt=p(We,this.defaultValue.comments,st),typeof Xe=="boolean"?Jt=Xe?"on":"off":Jt=p(Xe,this.defaultValue.strings,st),{other:Fe,comments:Dt,strings:Jt}}}var Z;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class he extends E{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(X){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,We=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function fe(Y){const X=Y.get(98);return X==="editable"?Y.get(91):X!=="on"}class Te extends E{constructor(){const X=[],pe={type:"number",description:m.localize(94,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:X,description:m.localize(96,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const We of X)if(typeof We=="number")pe.push({column:n.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Xe=We;pe.push({column:n.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return pe.sort((We,Xe)=>We.column-Xe.column),pe}return this.defaultValue}}class de extends E{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ce(Y,X){if(typeof Y!="string")return X;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends E{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,We=n.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=n.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(pe.vertical,this.defaultValue.vertical),horizontal:Ce(pe.horizontal,this.defaultValue.horizontal),useShadows:a(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:n.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:n.clampedInt(pe.verticalSliderSize,Xe,0,1e3),scrollByPage:a(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends E{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:m.localize(115,null)}})}applyUpdate(X,pe){let We=!1;pe.allowedCharacters&&X&&(F.$Qn(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},We=!0)),pe.allowedLocales&&X&&(F.$Qn(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},We=!0));const Xe=super.applyUpdate(X,pe);return We?new l(Xe.newValue,!0):Xe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:_(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const We={};for(const[Xe,st]of Object.entries(X))st===!0&&(We[Xe]=!0);return We}}class z extends E{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(122,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),mode:p(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends E{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:m.localize(129,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:a(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends E{constructor(){const X={enabled:O.$Is.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Is.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends E{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:X.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:X.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:X.highlightActiveIndentation,description:m.localize(145,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:_(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Y,X,pe){const We=pe.indexOf(Y);return We===-1?X:pe[We]}class se extends E{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:X.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:X.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:p(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(pe.showIcons,this.defaultValue.showIcons),showStatusBar:a(pe.showStatusBar,this.defaultValue.showStatusBar),preview:a(pe.preview,this.defaultValue.preview),previewMode:p(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(pe.showMethods,this.defaultValue.showMethods),showFunctions:a(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:a(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(pe.showFields,this.defaultValue.showFields),showVariables:a(pe.showVariables,this.defaultValue.showVariables),showClasses:a(pe.showClasses,this.defaultValue.showClasses),showStructs:a(pe.showStructs,this.defaultValue.showStructs),showInterfaces:a(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:a(pe.showModules,this.defaultValue.showModules),showProperties:a(pe.showProperties,this.defaultValue.showProperties),showEvents:a(pe.showEvents,this.defaultValue.showEvents),showOperators:a(pe.showOperators,this.defaultValue.showOperators),showUnits:a(pe.showUnits,this.defaultValue.showUnits),showValues:a(pe.showValues,this.defaultValue.showValues),showConstants:a(pe.showConstants,this.defaultValue.showConstants),showEnums:a(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:a(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(pe.showKeywords,this.defaultValue.showKeywords),showWords:a(pe.showWords,this.defaultValue.showWords),showColors:a(pe.showColors,this.defaultValue.showColors),showFiles:a(pe.showFiles,this.defaultValue.showFiles),showReferences:a(pe.showReferences,this.defaultValue.showReferences),showFolders:a(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:a(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(pe.showSnippets,this.defaultValue.showSnippets),showUsers:a(pe.showUsers,this.defaultValue.showUsers),showIssues:a(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends E{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(X.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Qe extends E{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(196,null),m.localize(197,null),m.localize(198,null),m.localize(199,null)],description:m.localize(200,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,We){return pe.get(2)===2?0:We}}class xe extends d{constructor(){super(145)}compute(X,pe,We){const Xe=pe.get(144);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class et extends E{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(203,null),m.localize(204,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),showDropSelector:p(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends E{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(207,null),m.localize(208,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:a(pe.enabled,this.defaultValue.enabled),showPasteSelector:p(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",at="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?tt:M.$k?at:rt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var it;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSeparators=130]="wordSeparators",Y[Y.wordWrap=131]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=134]="wordWrapColumn",Y[Y.wordWrapOverride1=135]="wordWrapOverride1",Y[Y.wordWrapOverride2=136]="wordWrapOverride2",Y[Y.wrappingIndent=137]="wrappingIndent",Y[Y.wrappingStrategy=138]="wrappingStrategy",Y[Y.showDeprecated=139]="showDeprecated",Y[Y.inlayHints=140]="inlayHints",Y[Y.editorClassName=141]="editorClassName",Y[Y.pixelRatio=142]="pixelRatio",Y[Y.tabFocusMode=143]="tabFocusMode",Y[Y.layoutInfo=144]="layoutInfo",Y[Y.wrappingInfo=145]="wrappingInfo",Y[Y.defaultColorDecorators=146]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(it||(e.EditorOption=it={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(209,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(210,null),""],markdownDescription:m.localize(211,null)})),accessibilitySupport:Be(new b),accessibilityPageSize:Be(new n(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",m.localize(213,null))),ariaRequired:Be(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),""],description:m.localize(217,null)})),autoClosingComments:Be(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoClosingDelete:Be(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(221,null),""],description:m.localize(222,null)})),autoClosingOvertype:Be(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingQuotes:Be(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(225,null),m.localize(226,null),""],description:m.localize(227,null)})),autoIndent:Be(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),automaticLayout:Be(new r(13,"automaticLayout",!1)),autoSurround:Be(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),""],description:m.localize(237,null)})),bracketPairColorization:Be(new K),bracketPairGuides:Be(new H),stickyTabStops:Be(new r(116,"stickyTabStops",!1,{description:m.localize(238,null)})),codeLens:Be(new r(17,"codeLens",!0,{description:m.localize(239,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:m.localize(240,null)})),codeLensFontSize:Be(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(241,null)})),colorDecorators:Be(new r(20,"colorDecorators",!0,{description:m.localize(242,null)})),colorDecoratorActivatedOn:Be(new u(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),colorDecoratorsLimit:Be(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(247,null)})),columnSelection:Be(new r(22,"columnSelection",!1,{description:m.localize(248,null)})),comments:Be(new $),contextmenu:Be(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(249,null)})),cursorBlinking:Be(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(250,null)})),cursorSmoothCaretAnimation:Be(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),cursorStyle:Be(new o(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(255,null)})),cursorSurroundingLines:Be(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(256,null)})),cursorSurroundingLinesStyle:Be(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],markdownDescription:m.localize(259,null)})),cursorWidth:Be(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(260,null)})),disableLayerHinting:Be(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(34,"domReadOnly",!1)),dragAndDrop:Be(new r(35,"dragAndDrop",!0,{description:m.localize(261,null)})),emptySelectionClipboard:Be(new G),dropIntoEditor:Be(new et),stickyScroll:Be(new ie),experimentalWhitespaceRendering:Be(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new h(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:m.localize(266,null)})),find:Be(new W),fixedOverflowWidgets:Be(new r(42,"fixedOverflowWidgets",!1)),folding:Be(new r(43,"folding",!0,{description:m.localize(267,null)})),foldingStrategy:Be(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),foldingHighlight:Be(new r(45,"foldingHighlight",!0,{description:m.localize(271,null)})),foldingImportsByDefault:Be(new r(46,"foldingImportsByDefault",!1,{description:m.localize(272,null)})),foldingMaximumRegions:Be(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(274,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(275,null)})),fontInfo:Be(new T),fontLigatures2:Be(new U),fontSize:Be(new q),fontWeight:Be(new ne),fontVariations:Be(new C),formatOnPaste:Be(new r(55,"formatOnPaste",!1,{description:m.localize(276,null)})),formatOnType:Be(new r(56,"formatOnType",!1,{description:m.localize(277,null)})),glyphMargin:Be(new r(57,"glyphMargin",!0,{description:m.localize(278,null)})),gotoLocation:Be(new ce),hideCursorInOverviewRuler:Be(new r(59,"hideCursorInOverviewRuler",!1,{description:m.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new r(61,"inDiffEditor",!1)),letterSpacing:Be(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>h.clamp(Y,-5,20),{description:m.localize(280,null)})),lightbulb:Be(new $e),lineDecorationsWidth:Be(new V),lineHeight:Be(new ee),lineNumbers:Be(new he),lineNumbersMinChars:Be(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(70,"linkedEditing",!1,{description:m.localize(281,null)})),links:Be(new r(71,"links",!0,{description:m.localize(282,null)})),matchBrackets:Be(new u(72,"matchBrackets","always",["always","near","never"],{description:m.localize(283,null)})),minimap:Be(new ke),mouseStyle:Be(new u(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new h(75,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:m.localize(284,null)})),mouseWheelZoom:Be(new r(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?m.localize(285,null):m.localize(286,null)})),multiCursorMergeOverlapping:Be(new r(77,"multiCursorMergeOverlapping",!0,{description:m.localize(287,null)})),multiCursorModifier:Be(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ne,{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),multiCursorPaste:Be(new u(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(291,null),m.localize(292,null)],markdownDescription:m.localize(293,null)})),multiCursorLimit:Be(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(294,null)})),occurrencesHighlight:Be(new u(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(295,null),m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),overviewRulerBorder:Be(new r(82,"overviewRulerBorder",!0,{description:m.localize(299,null)})),overviewRulerLanes:Be(new n(83,"overviewRulerLanes",3,0,3)),padding:Be(new Se),pasteAs:Be(new ot),parameterHints:Be(new be),peekWidgetDefaultFocus:Be(new u(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(300,null),m.localize(301,null)],description:m.localize(302,null)})),definitionLinkOpensInPeek:Be(new r(88,"definitionLinkOpensInPeek",!1,{description:m.localize(303,null)})),quickSuggestions:Be(new J),quickSuggestionsDelay:Be(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(304,null)})),readOnly:Be(new r(91,"readOnly",!1)),readOnlyMessage:Be(new de),renameOnType:Be(new r(93,"renameOnType",!1,{description:m.localize(305,null),markdownDeprecationMessage:m.localize(306,null)})),renderControlCharacters:Be(new r(94,"renderControlCharacters",!0,{description:m.localize(307,null),restricted:!0})),renderFinalNewline:Be(new u(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(308,null)})),renderLineHighlight:Be(new u(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(309,null)],description:m.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(311,null)})),renderValidationDecorations:Be(new u(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(312,null),m.localize(313,null),m.localize(314,null),""],description:m.localize(315,null)})),revealHorizontalRightPadding:Be(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(101,"roundedSelection",!0,{description:m.localize(316,null)})),rulers:Be(new Te),scrollbar:Be(new Re),scrollBeyondLastColumn:Be(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(317,null)})),scrollBeyondLastLine:Be(new r(105,"scrollBeyondLastLine",!0,{description:m.localize(318,null)})),scrollPredominantAxis:Be(new r(106,"scrollPredominantAxis",!0,{description:m.localize(319,null)})),selectionClipboard:Be(new r(107,"selectionClipboard",!0,{description:m.localize(320,null),included:M.$k})),selectionHighlight:Be(new r(108,"selectionHighlight",!0,{description:m.localize(321,null)})),selectOnLineNumbers:Be(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),showUnused:Be(new r(111,"showUnused",!0,{description:m.localize(326,null)})),showDeprecated:Be(new r(139,"showDeprecated",!0,{description:m.localize(327,null)})),inlayHints:Be(new le),snippetSuggestions:Be(new u(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(328,null),m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),smartSelect:Be(new Oe),smoothScrolling:Be(new r(114,"smoothScrolling",!1,{description:m.localize(333,null)})),stopRenderingLineAfter:Be(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new se),inlineSuggest:Be(new z),inlineEdit:Be(new j),inlineCompletionsAccessibilityVerbose:Be(new r(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(334,null)})),suggestFontSize:Be(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(121,"suggestOnTriggerCharacters",!0,{description:m.localize(337,null)})),suggestSelection:Be(new u(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),tabCompletion:Be(new u(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(342,null),m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),tabIndex:Be(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new je),unusualLineTerminators:Be(new u(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(346,null),m.localize(347,null),m.localize(348,null)],description:m.localize(349,null)})),useShadowDOM:Be(new r(127,"useShadowDOM",!0)),useTabStops:Be(new r(128,"useTabStops",!0,{description:m.localize(350,null)})),wordBreak:Be(new u(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(351,null),m.localize(352,null)],description:m.localize(353,null)})),wordSeparators:Be(new t(130,"wordSeparators",R.$Js,{description:m.localize(354,null)})),wordWrap:Be(new u(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(355,null),m.localize(356,null),m.localize(357,null),m.localize(358,null)],description:m.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(360,null)})),wordWrapOverride1:Be(new u(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new A),defaultColorDecorators:Be(new r(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new r(143,"tabFocusMode",!1,{markdownDescription:m.localize(362,null)})),layoutInfo:Be(new ue),wrappingInfo:Be(new xe),wrappingIndent:Be(new Qe),wrappingStrategy:Be(new ve)}}),define(Pe[151],Me([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[152],Me([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[153],Me([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[154],Me([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[155],Me([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[156],Me([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[157],Me([9,10]),function(me,e){return me.create("vs/platform/log/common/log",e)}),define(Pe[158],Me([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[159],Me([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[160],Me([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[161],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[162],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[163],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[164],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[165],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[166],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[167],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[168],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[169],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[170],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[171],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[172],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[173],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[174],Me([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[175],Me([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[176],Me([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[177],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[178],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[179],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[180],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[181],Me([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[182],Me([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[183],Me([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[184],Me([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[185],Me([1,0,14,153]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var M;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(M||(e.TokenType=M={}));function O(...k){switch(k.length){case 1:return(0,F.localize)(0,null,k[0]);case 2:return(0,F.localize)(1,null,k[0],k[1]);case 3:return(0,F.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,F.localize)(3,null),m=(0,F.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const E=this.d,l=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:l};this.g.push({offset:E,lexeme:l,additionalInfo:N}),this.f.push(w)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const E=this.c.substring(this.d,this.e),l=f.b.get(E);l?this.k(l):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,E=!1,l=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(m);return}const d=this.c.charCodeAt(N);if(E)E=!1;else if(d===47&&!l){N++;break}else d===91?l=!0:d===92?E=!0:d===93&&(l=!1);N++}for(;N<this.c.length&&f.a.has(this.c.charCodeAt(N));)N++;this.e=N;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=f}),define(Pe[186],Me([1,0,24,32,155,298]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=f,e.$rp=k,e.$sp=N,e.$tp=E,e.$up=l,e.$vp=w,e.$wp=d;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(r){return r=r.trim(),r==="*"||R.test(r)}function k(r){if(!f(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=r.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function N(r){if(!r)return null;const i=r.majorBase,n=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const t=r.patchBase;let p=r.patchMustEqual;r.hasCaret&&(i===0||(h=!1),p=!1);let u=0;if(r.preRelease){const o=m.exec(r.preRelease);if(o){const[,v,b,$]=o;u=Date.UTC(Number(v),Number(b)-1,Number($))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:p,isMinimum:r.hasGreaterEquals,notBefore:u}}function E(r,i,n){let c;typeof r=="string"?c=N(k(r)):c=r;let h;i instanceof Date?h=i.getTime():typeof i=="string"&&(h=new Date(i).getTime());let t;if(typeof n=="string"?t=N(k(n)):t=n,!c||!t)return!1;const p=c.majorBase,u=c.minorBase,o=c.patchBase;let v=t.majorBase,b=t.minorBase,$=t.patchBase;const I=t.notBefore;let g=t.majorMustEqual,D=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?p>v?!0:p<v?!1:u>b?!0:u<b||h&&h<I?!1:o>=$:(p===1&&v===0&&(!g||!D||!y)&&(v=1,b=0,$=0,g=!0,D=!1,y=!1),p<v?!1:p>v?!g:u<b?!1:u>b?!D:o<$?!1:o>$?!y:!(h&&h<I))}function l(r,i,n,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([F.default.Error,M.localize(0,null)]),t;if(typeof c.name!="string")return t.push([F.default.Error,M.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([F.default.Error,M.localize(2,null,"version")]),t;if(!c.engines)return t.push([F.default.Error,M.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([F.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([F.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([F.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([F.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([F.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([F.default.Error,M.localize(9,null,"main")]),t;{const o=(0,S.$Tg)(n,c.main);(0,S.$Ng)(o,n)||t.push([F.default.Warning,M.localize(10,null,o.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([F.default.Error,M.localize(11,null,"browser")]),t;{const o=(0,S.$Tg)(n,c.browser);(0,S.$Ng)(o,n)||t.push([F.default.Warning,M.localize(12,null,o.path,n.path)])}}if(!O.valid(c.version))return t.push([F.default.Error,M.localize(13,null)]),t;const p=[];if(!w(r,i,c,h,p))for(const o of p)t.push([F.default.Error,o]);return t}function w(r,i,n,c,h){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(r,i,n.engines.vscode,h)}function d(r,i,n){return r==="*"||s(i,n,r)}function s(r,i,n,c=[]){const h=N(k(n));if(!h)return c.push(M.localize(14,null,n)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(M.localize(15,null,n)),!1}else if(!h.majorMustEqual)return c.push(M.localize(16,null,n)),!1;return E(r,i,h)?!0:(c.push(M.localize(17,null,r,n)),!1)}function a(r){if(!Array.isArray(r))return!1;for(let i=0,n=r.length;i<n;i++)if(typeof r[i]!="string")return!1;return!0}}),define(Pe[70],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class S{constructor(M,O=[],R=!1){this.ctor=M,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.$di=S}),define(Pe[54],Me([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$cs=O,e.$ds=R;const F=[];var M;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function O(m,f,k){f instanceof S.$di||(f=new S.$di(f,[],!!k)),F.push([m,f])}function R(){return F}}),define(Pe[187],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class S{constructor(O,R){this.key=O,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Sq=S;class F{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const R of this.a.values())R.outgoing.size===0&&O.push(R);return O}insertEdge(O,R){const m=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(R);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(O){const R=this.b(O);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(O){const R=this.b(O);let m=this.a.get(R);return m||(m=new S(R,O),this.a.set(R,m)),m}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[R,m]of this.a)O.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,R]of this.a){const m=new Set([O]),f=this.c(R,m);if(f)return f}}c(O,R){for(const[m,f]of O.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const k=this.c(f,R);if(k)return k;R.delete(m)}}}e.$Tq=F}),define(Pe[3],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e._util=void 0,e.$gi=M,e.$hi=O;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(S||(e._util=S={})),e.$fi=M("instantiationService");function F(R,m,f){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:R,index:f}):(m[S.DI_DEPENDENCIES]=[{id:R,index:f}],m[S.DI_TARGET]=m)}function M(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const m=function(f,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(m,f,N)};return m.toString=()=>R,S.serviceIds.set(R,m),m}function O(R){return R}}),define(Pe[46],Me([1,0,16,2,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Mi=void 0,e.$Ni=O,e.$Oi=R,e.$Pi=f,e.$Qi=k,e.$Ri=N,e.$Si=E,e.$Ti=l,e.$Ui=d,e.$Vi=s,e.$Wi=a,e.$Mi=(0,M.$gi)("configurationService");function O(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof F.URI)}function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof F.URI)}var m;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}function N(r,i){const n=Object.create(null);for(const c in r)E(n,c,r[c],i);return n}function E(r,i,n,c){const h=i.split("."),t=h.pop();let p=r;for(let u=0;u<h.length;u++){const o=h[u];let v=p[o];switch(typeof v){case"undefined":v=p[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}p=v}if(typeof p=="object"&&p!==null)try{p[t]=n}catch{c(`Ignoring ${i} as ${h.join(".")} is ${JSON.stringify(p)}`)}else c(`Ignoring ${i} as ${h.join(".")} is ${JSON.stringify(p)}`)}function l(r,i){const n=i.split(".");w(r,n)}function w(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const c=r[n];typeof c=="object"&&!Array.isArray(c)&&(w(c,i),Object.keys(c).length===0&&delete r[n])}}function d(r,i,n){function c(p,u){let o=p;for(const v of u){if(typeof o!="object"||o===null)return;o=o[v]}return o}const h=i.split("."),t=c(r,h);return typeof t>"u"?n:t}function s(r,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in r?S.$Vf(r[c])&&S.$Vf(i[c])?s(r[c],i[c],n):n&&(r[c]=i[c]):r[c]=i[c])})}function a(r){return r.replace(/[\[\]]/g,"")}}),define(Pe[35],Me([1,0,21,15,185,3,152,14]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$ej=e.$dj=e.ContextKeyExprType=void 0,e.$cj=k,e.$fj=p,e.$gj=u,e.$zj=re;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function k(le,V){if(f.get(le)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(le,V)}const N=Object.prototype.hasOwnProperty;var E;(function(le){le[le.False=0]="False",le[le.True=1]="True",le[le.Defined=2]="Defined",le[le.Not=3]="Not",le[le.Equals=4]="Equals",le[le.NotEquals=5]="NotEquals",le[le.And=6]="And",le[le.Regex=7]="Regex",le[le.NotRegex=8]="NotRegex",le[le.Or=9]="Or",le[le.In=10]="In",le[le.NotIn=11]="NotIn",le[le.Greater=12]="Greater",le[le.GreaterEquals=13]="GreaterEquals",le[le.Smaller=14]="Smaller",le[le.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const l={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),d=(0,R.localize)(1,null),s=(0,R.localize)(2,null),a=(0,R.localize)(3,null),r=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new M.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const ke=this.D(),Ne=ke.type===17?i:void 0;throw this.h.push({message:r,offset:ke.offset,lexeme:M.$bj.getLexeme(ke),additionalInfo:Ne}),h.c}return ee}catch(ee){if(ee!==h.c)throw ee;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ee=this.o();V.push(ee)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ee=this.s();V.push(ee)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const ee=this.l();return this.A(1,a),ee?.negate()}case 17:return this.z(),P.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ee=this.l();return this.A(1,a),ee}case 17:{const ee=V.lexeme;if(this.z(),this.y(9)){const Ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ne.type!==10)throw this.B("REGEX",Ne);const Se=Ne.lexeme,be=Se.lastIndexOf("/"),ge=be===Se.length-1?void 0:this.w(Se.substring(be+1));let J;try{J=new RegExp(Se.substring(1,be),ge)}catch{throw this.B("REGEX",Ne)}return T.create(ee,J)}switch(Ne.type){case 10:case 19:{const Se=[Ne.lexeme];this.z();let be=this.D(),ge=0;for(let Te=0;Te<Ne.lexeme.length;Te++)Ne.lexeme.charCodeAt(Te)===40?ge++:Ne.lexeme.charCodeAt(Te)===41&&ge--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Te=0;Te<be.lexeme.length;Te++)be.lexeme.charCodeAt(Te)===40?ge++:Ne.lexeme.charCodeAt(Te)===41&&ge--}if(ge<0)break;Se.push(M.$bj.getLexeme(be)),this.z(),be=this.D()}const J=Se.join(""),Z=J.lastIndexOf("/"),he=Z===J.length-1?void 0:this.w(J.substring(Z+1));let fe;try{fe=new RegExp(J.substring(1,Z),he)}catch{throw this.B("REGEX",Ne)}return t.regex(ee,fe)}case 18:{const Se=Ne.lexeme;this.z();let be=null;if(!(0,F.$Te)(Se)){const ge=Se.indexOf("/"),J=Se.lastIndexOf("/");if(ge!==J&&ge>=0){const Z=Se.slice(ge+1,J),he=Se[J+1]==="i"?"i":"";try{be=new RegExp(Z,he)}catch{throw this.B("REGEX",Ne)}}}if(be===null)throw this.B("REGEX",Ne);return T.create(ee,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Ne=this.u();return t.notIn(ee,Ne)}switch(this.D().type){case 3:{this.z();const Ne=this.u();if(this.x().type===18)return t.equals(ee,Ne);switch(Ne){case"true":return t.has(ee);case"false":return t.not(ee);default:return t.equals(ee,Ne)}}case 4:{this.z();const Ne=this.u();if(this.x().type===18)return t.notEquals(ee,Ne);switch(Ne){case"true":return t.not(ee);case"false":return t.has(ee);default:return t.notEquals(ee,Ne)}}case 5:return this.z(),U.create(ee,this.u());case 6:return this.z(),C.create(ee,this.u());case 7:return this.z(),G.create(ee,this.u());case 8:return this.z(),W.create(ee,this.u());case 13:return this.z(),t.in(ee,this.u());default:return t.has(ee)}}case 20:throw this.h.push({message:n,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ee){if(this.C(V))return this.z();throw this.B(ee,this.D())}B(V,ee,ke){const Ne=(0,R.localize)(8,null,V,M.$bj.getLexeme(ee)),Se=ee.offset,be=M.$bj.getLexeme(ee);return this.h.push({message:Ne,offset:Se,lexeme:be,additionalInfo:ke}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=h;class t{static false(){return v.INSTANCE}static true(){return b.INSTANCE}static has(V){return $.create(V)}static equals(V,ee){return I.create(V,ee)}static notEquals(V,ee){return y.create(V,ee)}static regex(V,ee){return T.create(V,ee)}static in(V,ee){return g.create(V,ee)}static notIn(V,ee){return D.create(V,ee)}static not(V){return P.create(V)}static and(...V){return ce.create(V,null,!0)}static or(...V){return ye.create(V,null,!0)}static greater(V,ee){return G.create(V,ee)}static greaterEquals(V,ee){return W.create(V,ee)}static smaller(V,ee){return U.create(V,ee)}static smallerEquals(V,ee){return C.create(V,ee)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$ej=t;function p(le){const V=new h({regexParsingWithErrorRecovery:!1});return le.map(ee=>(V.parse(ee),V.lexingErrors.length>0?V.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,R.localize)(9,null,ke.additionalInfo):(0,R.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}function u(le,V){const ee=le?le.substituteConstants():void 0,ke=V?V.substituteConstants():void 0;return!ee&&!ke?!0:!ee||!ke?!1:ee.equals(ke)}function o(le,V){return le.cmp(V)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return b.INSTANCE}}e.$hj=v;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return v.INSTANCE}}e.$ij=b;class ${static create(V,ee=null){const ke=f.get(V);return typeof ke=="boolean"?ke?b.INSTANCE:v.INSTANCE:new $(V,ee)}constructor(V,ee){this.key=V,this.c=ee,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?b.INSTANCE:v.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$jj=$;class I{static create(V,ee,ke=null){if(typeof ee=="boolean")return ee?$.create(V,ke):P.create(V,ke);const Ne=f.get(V);return typeof Ne=="boolean"?ee===(Ne?"true":"false")?b.INSTANCE:v.INSTANCE:new I(V,ee,ke)}constructor(V,ee,ke){this.c=V,this.d=ee,this.f=ke,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ee=V?"true":"false";return this.d===ee?b.INSTANCE:v.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$kj=I;class g{static create(V,ee){return new g(V,ee)}constructor(V,ee){this.d=V,this.f=ee,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ee=V.getValue(this.f),ke=V.getValue(this.d);return Array.isArray(ee)?ee.includes(ke):typeof ke=="string"&&typeof ee=="object"&&ee!==null?N.call(ee,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$lj=g;class D{static create(V,ee){return new D(V,ee)}constructor(V,ee){this.d=V,this.f=ee,this.type=11,this.c=g.create(V,ee)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=D;class y{static create(V,ee,ke=null){if(typeof ee=="boolean")return ee?P.create(V,ke):$.create(V,ke);const Ne=f.get(V);return typeof Ne=="boolean"?ee===(Ne?"true":"false")?v.INSTANCE:b.INSTANCE:new y(V,ee,ke)}constructor(V,ee,ke){this.c=V,this.d=ee,this.f=ke,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ee=V?"true":"false";return this.d===ee?v.INSTANCE:b.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$nj=y;class P{static create(V,ee=null){const ke=f.get(V);return typeof ke=="boolean"?ke?v.INSTANCE:b.INSTANCE:new P(V,ee)}constructor(V,ee){this.c=V,this.d=ee,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=f.get(this.c);return typeof V=="boolean"?V?v.INSTANCE:b.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$oj=P;function A(le,V){if(typeof le=="string"){const ee=parseFloat(le);isNaN(ee)||(le=ee)}return typeof le=="string"||typeof le=="number"?V(le):v.INSTANCE}class G{static create(V,ee,ke=null){return A(ee,Ne=>new G(V,Ne,ke))}constructor(V,ee,ke){this.c=V,this.d=ee,this.f=ke,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$pj=G;class W{static create(V,ee,ke=null){return A(ee,Ne=>new W(V,Ne,ke))}constructor(V,ee,ke){this.c=V,this.d=ee,this.f=ke,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$qj=W;class U{static create(V,ee,ke=null){return A(ee,Ne=>new U(V,Ne,ke))}constructor(V,ee,ke){this.c=V,this.d=ee,this.f=ke,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$rj=U;class C{static create(V,ee,ke=null){return A(ee,Ne=>new C(V,Ne,ke))}constructor(V,ee,ke){this.c=V,this.d=ee,this.f=ke,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$sj=C;class T{static create(V,ee){return new T(V,ee)}constructor(V,ee){this.d=V,this.f=ee,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ee=this.f?this.f.source:"",ke=V.f?V.f.source:"";return ee<ke?-1:ee>ke?1:0}equals(V){if(V.type===this.type){const ee=this.f?this.f.source:"",ke=V.f?V.f.source:"";return this.d===V.d&&ee===ke}return!1}substituteConstants(){return this}evaluate(V){const ee=V.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$tj=T;class q{static create(V){return new q(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new q(this.c.map(V))}negate(){return this.c}}e.$uj=q;function ne(le){let V=null;for(let ee=0,ke=le.length;ee<ke;ee++){const Ne=le[ee].substituteConstants();if(le[ee]!==Ne&&V===null){V=[];for(let Se=0;Se<ee;Se++)V[Se]=le[Se]}V!==null&&(V[ee]=Ne)}return V===null?le:V}class ce{static create(V,ee,ke){return ce.d(V,ee,ke)}constructor(V,ee){this.expr=V,this.c=ee,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ee=0,ke=this.expr.length;ee<ke;ee++){const Ne=o(this.expr[ee],V.expr[ee]);if(Ne!==0)return Ne}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(!this.expr[ee].equals(V.expr[ee]))return!1;return!0}return!1}substituteConstants(){const V=ne(this.expr);return V===this.expr?this:ce.create(V,this.c,!1)}evaluate(V){for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(!this.expr[ee].evaluate(V))return!1;return!0}static d(V,ee,ke){const Ne=[];let Se=!1;for(const be of V)if(be){if(be.type===1){Se=!0;continue}if(be.type===0)return v.INSTANCE;if(be.type===6){Ne.push(...be.expr);continue}Ne.push(be)}if(Ne.length===0&&Se)return b.INSTANCE;if(Ne.length!==0){if(Ne.length===1)return Ne[0];Ne.sort(o);for(let be=1;be<Ne.length;be++)Ne[be-1].equals(Ne[be])&&(Ne.splice(be,1),be--);if(Ne.length===1)return Ne[0];for(;Ne.length>1;){const be=Ne[Ne.length-1];if(be.type!==9)break;Ne.pop();const ge=Ne.pop(),J=Ne.length===0,Z=ye.create(be.expr.map(he=>ce.create([he,ge],null,ke)),null,J);Z&&(Ne.push(Z),Ne.sort(o))}if(Ne.length===1)return Ne[0];if(ke){for(let be=0;be<Ne.length;be++)for(let ge=be+1;ge<Ne.length;ge++)if(Ne[be].negate().equals(Ne[ge]))return v.INSTANCE;if(Ne.length===1)return Ne[0]}return new ce(Ne,ee)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ee of this.expr)V.push(...ee.keys());return V}map(V){return new ce(this.expr.map(ee=>ee.map(V)),null)}negate(){if(!this.c){const V=[];for(const ee of this.expr)V.push(ee.negate());this.c=ye.create(V,this,!0)}return this.c}}e.$vj=ce;class ye{static create(V,ee,ke){return ye.d(V,ee,ke)}constructor(V,ee){this.expr=V,this.c=ee,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ee=0,ke=this.expr.length;ee<ke;ee++){const Ne=o(this.expr[ee],V.expr[ee]);if(Ne!==0)return Ne}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(!this.expr[ee].equals(V.expr[ee]))return!1;return!0}return!1}substituteConstants(){const V=ne(this.expr);return V===this.expr?this:ye.create(V,this.c,!1)}evaluate(V){for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(this.expr[ee].evaluate(V))return!0;return!1}static d(V,ee,ke){let Ne=[],Se=!1;if(V){for(let be=0,ge=V.length;be<ge;be++){const J=V[be];if(J){if(J.type===0){Se=!0;continue}if(J.type===1)return b.INSTANCE;if(J.type===9){Ne=Ne.concat(J.expr);continue}Ne.push(J)}}if(Ne.length===0&&Se)return v.INSTANCE;Ne.sort(o)}if(Ne.length!==0){if(Ne.length===1)return Ne[0];for(let be=1;be<Ne.length;be++)Ne[be-1].equals(Ne[be])&&(Ne.splice(be,1),be--);if(Ne.length===1)return Ne[0];if(ke){for(let be=0;be<Ne.length;be++)for(let ge=be+1;ge<Ne.length;ge++)if(Ne[be].negate().equals(Ne[ge]))return b.INSTANCE;if(Ne.length===1)return Ne[0]}return new ye(Ne,ee)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ee of this.expr)V.push(...ee.keys());return V}map(V){return new ye(this.expr.map(ee=>ee.map(V)),null)}negate(){if(!this.c){const V=[];for(const ee of this.expr)V.push(ee.negate());for(;V.length>1;){const ee=V.shift(),ke=V.shift(),Ne=[];for(const Se of ie(ee))for(const be of ie(ke))Ne.push(ce.create([Se,be],null,!1));V.unshift(ye.create(Ne,null,!1))}this.c=ye.create(V,this,!0)}return this.c}}e.$wj=ye;class Ie extends ${static{this.d=[]}static all(){return Ie.d.values()}constructor(V,ee,ke){super(V,null),this.f=ee,typeof ke=="object"?Ie.d.push({...ke,key:V}):ke!==!0&&Ie.d.push({key:V,description:ke,type:ee!=null?typeof ee:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return I.create(this.key,V)}notEqualsTo(V){return y.create(this.key,V)}}e.$xj=Ie,e.$yj=(0,O.$gi)("contextKeyService");function ue(le,V){return le<V?-1:le>V?1:0}function ve(le,V,ee,ke){return le<ee?-1:le>ee?1:V<ke?-1:V>ke?1:0}function re(le,V){if(le.type===0||V.type===1)return!0;if(le.type===9)return V.type===9?$e(le.expr,V.expr):!1;if(V.type===9){for(const ee of V.expr)if(re(le,ee))return!0;return!1}if(le.type===6){if(V.type===6)return $e(V.expr,le.expr);for(const ee of le.expr)if(re(ee,V))return!0;return!1}return le.equals(V)}function $e(le,V){let ee=0,ke=0;for(;ee<le.length&&ke<V.length;){const Ne=le[ee].cmp(V[ke]);if(Ne<0)return!1;Ne===0&&ee++,ke++}return ee===le.length}function ie(le){return le.type===9?le.expr:[le]}}),define(Pe[188],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,S.$gi)("environmentService"),e.$oi=(0,S.$hi)(e.$ni)}),define(Pe[98],Me([1,0,154,3]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.ExtensionGalleryErrorCode=e.$Qo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Po=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0,e.$Jo=M,e.$Ko=O,e.$Lo=R,e.$Mo=m,e.$No=f,e.$Oo=k,e.$Do="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Eo=new RegExp(e.$Do),e.$Fo="__web_extension",e.$Go="skipWalkthrough",e.$Ho="extensionsSync",e.$Io="dependecyOrPackExtensionInstall";function M(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(n,c){switch(n){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(n,c){return c==="web"&&!n.includes("web")}function f(n,c,h){return m(c,h)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===h}function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var N;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var E;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Po=(0,F.$gi)("extensionGalleryService");var d;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var s;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class a extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Qo=a;var r;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class i extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Ro=i,e.$So=(0,F.$gi)("extensionManagementService"),e.$To="extensionsIdentifiers/disabled",e.$Uo="extensionsIdentifiers/enabled",e.$Vo=(0,F.$gi)("IGlobalExtensionEnablementService"),e.$Wo=(0,F.$gi)("IExtensionTipsService"),e.$Xo=(0,S.localize2)(0,"Extensions"),e.$Yo=(0,S.localize2)(1,"Preferences")}),define(Pe[42],Me([1,0,50,19,15,16,2,156,3,21,12,39]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$fl=e.FileKind=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileOperationResult=e.$0k=e.$9k=e.$8k=e.$6k=e.FileChangeType=e.$5k=e.FileOperation=e.$Yk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Mk=void 0,e.$Nk=l,e.$Ok=s,e.$Pk=r,e.$Qk=i,e.$Rk=n,e.$Sk=c,e.$Tk=h,e.$Uk=t,e.$Vk=p,e.$Wk=u,e.$Xk=o,e.$Zk=$,e.$1k=I,e.$2k=g,e.$3k=D,e.$4k=y,e.$7k=U,e.$gl=ye,e.$hl=Ie,e.$jl=ve,e.$Mk=(0,f.$gi)("fileService");function l(re){return re.create===!0}var w;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function s(re){const $e=re;return!!$e&&typeof $e.onDidChange=="function"}var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(re){return!!(re.capabilities&2)}function i(re){return!!(re.capabilities&8)}function n(re){return!!(re.capabilities&131072)}function c(re){return!!(re.capabilities&4)}function h(re){return!!(re.capabilities&16)}function t(re){return r(re)?!!(re.capabilities&16384):!1}function p(re){return r(re)?!!(re.capabilities&32768):!1}function u(re){return!!(re.capabilities&65536)}function o(re){return!!(re.capabilities&2048)}var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class b extends Error{static create($e,ie){const le=new b($e.toString(),ie);return g(le,ie),le}constructor($e,ie){super($e),this.code=ie}}e.$Yk=b;function $(re,$e){return b.create(re,$e)}function I(re){return re||$((0,m.localize)(0,null),v.Unknown)}function g(re,$e){return re.name=$e?`${$e} (FileSystemError)`:"FileSystemError",re}function D(re){if(!re)return v.Unknown;if(re instanceof b)return re.code;const $e=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!$e)return v.Unknown;switch($e[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function y(re){if(re instanceof C)return re.fileOperationResult;switch(D(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var P;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class A{constructor($e,ie,le){this.resource=$e,this.operation=ie,this.target=le}isOperation($e){return this.operation===$e}}e.$5k=A;var G;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor($e,ie){this.c=ie,this.b=void 0,this.d=new E.$V(()=>{const le=S.$mi.forUris(()=>this.c);return le.fill(this.rawAdded.map(V=>[V,!0])),le}),this.f=new E.$V(()=>{const le=S.$mi.forUris(()=>this.c);return le.fill(this.rawUpdated.map(V=>[V,!0])),le}),this.g=new E.$V(()=>{const le=S.$mi.forUris(()=>this.c);return le.fill(this.rawDeleted.map(V=>[V,!0])),le}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const le of $e){switch(le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}this.b!==W.a&&(typeof le.cId=="number"?this.b===void 0?this.b=le.cId:this.b!==le.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains($e,...ie){return this.h($e,{includeChildren:!1},...ie)}affects($e,...ie){return this.h($e,{includeChildren:!0},...ie)}h($e,ie,...le){if(!$e)return!1;const V=le.length>0;return!!((!V||le.includes(1))&&(this.d.value.get($e)||ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||le.includes(0))&&(this.f.value.get($e)||ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||le.includes(2))&&(this.g.value.findSubstr($e)||ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$6k=W;function U(re,$e,ie){return!re||!$e||re===$e||$e.length>re.length?!1:($e.charAt($e.length-1)!==F.sep&&($e+=F.sep),ie?(0,M.$lf)(re,$e):re.indexOf($e)===0)}class C extends Error{constructor($e,ie,le){super($e),this.fileOperationResult=ie,this.options=le}}e.$8k=C;class T extends C{constructor($e,ie,le,V){super($e,ie,V),this.fileOperationResult=ie,this.size=le}}e.$9k=T;class q extends C{constructor($e,ie,le){super($e,2,le),this.stat=ie}}e.$0k=q;var ne;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$$k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$_k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$al="files.associations",e.$bl="files.exclude",e.$cl="files.readonlyInclude",e.$dl="files.readonlyExclude",e.$el="files.readonlyFromPermissions";var ce;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$fl="";function ye(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Ie(re,$e){if(!$e.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(ie=>{const le=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===re.scheme&&V.added&&(le.dispose(),ie())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize($e){return(0,O.$Xf)($e)||($e=0),$e<ue.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<ue.MB?(0,m.localize)(2,null,($e/ue.KB).toFixed(2)):$e<ue.GB?(0,m.localize)(3,null,($e/ue.MB).toFixed(2)):$e<ue.TB?(0,m.localize)(4,null,($e/ue.GB).toFixed(2)):(0,m.localize)(5,null,($e/ue.TB).toFixed(2))}}e.$il=ue;function ve(re){const $e=typeof re=="string"||re?.scheme===N.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===N.Schemas.file?1024*ue.MB:$e?10*ue.MB:k.$o?50*ue.MB:1024*ue.MB}}),define(Pe[71],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class S{constructor(...M){this.a=new Map;for(const[O,R]of M)this.set(O,R)}set(M,O){const R=this.a.get(M);return this.a.set(M,O),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$ei=S}),define(Pe[189],Me([1,0,11,14,6,70,187,3,71,190]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;const N=!1;class E extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new f.$ei,r=!1,i,n=N){this.f=a,this.g=r,this.h=i,this.i=n,this.o=new Set,this.f.set(m.$fi,this),this._globalGraph=n?i?._globalGraph??new R.$Tq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...r){const i=d.traceInvocation(this.i,a);let n=!1;try{return a({get:h=>{if(n)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,i);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...r)}finally{n=!0,i.stop()}}createInstance(a,...r){let i,n;return a instanceof O.$di?(i=d.traceCreation(this.i,a.ctor),n=this.j(a.ctor,a.staticArguments.concat(r),i)):(i=d.traceCreation(this.i,a),n=this.j(a,r,i)),i.stop(),n}j(a,r=[],i){const n=m._util.getServiceDependencies(a).sort((t,p)=>t.index-p.index),c=[];for(const t of n){const p=this.m(t.id,i);p||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(p)}const h=n.length>0?n[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${r.length} static arguments`);const t=h-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,h)}return Reflect.construct(a,r.concat(c))}k(a,r){if(this.f.get(a)instanceof O.$di)this.f.set(a,r);else if(this.h)this.h.k(a,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const r=this.f.get(a);return!r&&this.h?this.h.l(a):r}m(a,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const i=this.l(a);return i instanceof O.$di?this.q(a,i,r.branch(a,!0)):(r.branch(a,!1),i)}q(a,r,i){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,r,i)}finally{this.o.delete(a)}}r(a,r,i){const n=new R.$Tq(t=>t.id.toString());let c=0;const h=[{id:a,desc:r,_trace:i}];for(;h.length;){const t=h.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new E(n);for(const p of m._util.getServiceDependencies(t.desc.ctor)){const u=this.l(p.id);if(u||this.u(`[createInstance] ${a} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(p.id)),u instanceof O.$di){const o={id:p.id,desc:u,_trace:t._trace.branch(p.id,!0)};n.insertEdge(t,o),h.push(o)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:p}of t){if(this.l(p.id)instanceof O.$di){const o=this.s(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.k(p.id,o)}n.removeNode(p)}}return this.l(a)}s(a,r,i=[],n,c){if(this.f.get(a)instanceof O.$di)return this.t(a,r,i,n,c);if(this.h)return this.h.s(a,r,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(a,r,i=[],n,c){if(n){const h=new l(void 0,this.g,this,this.i);h.c=String(a);const t=new Map,p=new S.$zh(()=>{const u=h.j(r,i,c);for(const[o,v]of t){const b=u[o];if(typeof b=="function")for(const $ of v)$.disposable=b.apply(u,$.listener)}return t.clear(),u});return new Proxy(Object.create(null),{get(u,o){if(!p.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let $=t.get(o);return $||($=new k.$4c,t.set(o,$)),(g,D,y)=>{if(p.isInitialized)return p.value[o](g,D,y);{const P={listener:[g,D,y],disposable:void 0},A=$.push(P);return(0,M.$Rc)(()=>{A(),P.disposable?.dispose()})}}}if(o in u)return u[o];const v=p.value;let b=v[o];return typeof b!="function"||(b=b.bind(v),u[o]=b),b},set(u,o,v){return p.value[o]=v,!0},getPrototypeOf(u){return r.prototype}})}else return this.j(r,i,c)}u(a,r){if(r&&console.warn(a),this.g)throw new Error(a)}}e.$Uq=l;var w;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(w||(w={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,r){return a?new d(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(a,r){return a?new d(1,r.name):d.c}static{this.f=0}constructor(a,r){this.type=a,this.name=r,this.g=Date.now(),this.h=[]}branch(a,r){const i=new d(3,a.toString());return this.h.push([a,r,i]),i}stop(){const a=Date.now()-this.g;d.f+=a;let r=!1;function i(c,h){const t=[],p=new Array(c+1).join("	");for(const[u,o,v]of h.h)if(o&&v){r=!0,t.push(`${p}CREATES -> ${u}`);const b=i(c+1,v);b&&t.push(b)}else t.push(`${p}uses -> ${u}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(a>2||r)&&d.all.add(n.join(`
`))}}e.$Vq=d}),define(Pe[13],Me([1,0,157,41,5,99,6,28,21,24,16,2,35,3]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Pj=e.LogLevel=e.$Nj=e.$Mj=void 0,e.$Oj=s,e.log=r,e.$1j=$,e.$2j=I,e.$3j=g,e.$4j=D,e.$Mj=(0,w.$gi)("logService"),e.$Nj=(0,w.$gi)("loggerService");function d(){return new Date().toISOString()}function s(y){return(0,N.$Xf)(y)}var a;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$Pj=a.Info;function r(y,P,A){switch(P){case a.Trace:y.trace(A);break;case a.Debug:y.debug(A);break;case a.Info:y.info(A);break;case a.Warning:y.warn(A);break;case a.Error:y.error(A);break;case a.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function i(y,P=!1){let A="";for(let G=0;G<y.length;G++){let W=y[G];if(W instanceof Error&&(W=(0,F.$4i)(W,P)),typeof W=="object")try{W=JSON.stringify(W)}catch{}A+=(G>0?" ":"")+W}return A}class n extends R.$Tc{constructor(){super(...arguments),this.b=e.$Pj,this.c=this.B(new M.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==a.Off&&this.b<=P}}e.$Rj=n;class c extends n{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...A){this.f(a.Trace)&&this.g(a.Trace,i([P,...A],!0))}debug(P,...A){this.f(a.Debug)&&this.g(a.Debug,i([P,...A]))}info(P,...A){this.f(a.Info)&&this.g(a.Info,i([P,...A]))}warn(P,...A){this.f(a.Warning)&&this.g(a.Warning,i([P,...A]))}error(P,...A){if(this.f(a.Error))if(P instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=P.stack,this.g(a.Error,i(G))}else this.g(a.Error,i([P,...A]))}flush(){}}e.$Sj=c;class h extends n{constructor(P=e.$Pj){super(),this.setLevel(P),this.g=!f.$i}trace(P,...A){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,P,...A):console.log(`[main ${d()}]`,P,...A))}debug(P,...A){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,P,...A):console.log(`[main ${d()}]`,P,...A))}info(P,...A){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,P,...A):console.log(`[main ${d()}]`,P,...A))}warn(P,...A){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,P,...A):console.warn(`[main ${d()}]`,P,...A))}error(P,...A){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,P,...A):console.error(`[main ${d()}]`,P,...A))}flush(){}}e.$Tj=h;class t extends n{constructor(P=e.$Pj,A=!0){super(),this.g=A,this.setLevel(P)}trace(P,...A){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...A):console.log(P,...A))}debug(P,...A){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...A):console.log(P,...A))}info(P,...A){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...A):console.log(P,...A))}warn(P,...A){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...A):console.log(P,...A))}error(P,...A){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...A):console.error(P,...A))}flush(){}}e.$Uj=t;class p extends n{constructor(P,A=e.$Pj){super(),this.g=P,this.setLevel(A)}trace(P,...A){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(P),...A])}debug(P,...A){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(P),...A])}info(P,...A){this.f(a.Info)&&this.g.log(a.Info,[this.h(P),...A])}warn(P,...A){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(P),...A])}error(P,...A){this.f(a.Error)&&this.g.log(a.Error,[this.h(P),...A])}h(P){return typeof P=="string"?P:(0,F.$4i)(P,this.f(a.Trace))}flush(){}}e.$Vj=p;class u extends n{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const A of this.g)A.setLevel(P);super.setLevel(P)}trace(P,...A){for(const G of this.g)G.trace(P,...A)}debug(P,...A){for(const G of this.g)G.debug(P,...A)}info(P,...A){for(const G of this.g)G.info(P,...A)}warn(P,...A){for(const G of this.g)G.warn(P,...A)}error(P,...A){for(const G of this.g)G.error(P,...A)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$Wj=u;class o extends R.$Tc{constructor(P,A,G){if(super(),this.h=P,this.j=A,this.b=new m.$Ac,this.c=this.B(new M.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$6d),this.onDidChangeVisibility=this.g.event,G)for(const W of G)this.b.set(W.resource,{logger:void 0,info:W})}m(P){return(0,N.$Tf)(P)?[...this.b.values()].find(A=>A.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,A){const G=this.n(P),W=(0,N.$Tf)(P)?P:A?.id??(0,O.$7i)(G.toString()).toString(16);let U=this.b.get(G)?.logger;const C=A?.logLevel==="always"?a.Trace:A?.logLevel;U||(U=this.s(G,C??this.getLogLevel(G)??this.h,{...A,id:W}));const T={logger:U,info:{resource:G,id:W,logLevel:C,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(T.info),this.b.set(G,T),U}n(P){return(0,N.$Tf)(P)?(0,k.$Tg)(this.j,`${P}.log`):P}setLogLevel(P,A){if(E.URI.isUri(P)){const G=P,W=A,U=this.b.get(G);U&&W!==U.info.logLevel&&(U.info.logLevel=W===this.h?void 0:W,U.logger?.setLevel(W),this.b.set(U.info.resource,U),this.f.fire([G,W]))}else{this.h=P;for(const[G,W]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,A){const G=this.m(P);G&&A!==!G.info.hidden&&(G.info.hidden=!A,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,A]))}getLogLevel(P){let A;return P&&(A=this.b.get(P)?.info.logLevel),A??this.h}registerLogger(P){const A=this.b.get(P.resource);A?A.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const A=this.b.get(P);A&&(A.logger&&A.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Xj=o;class v{constructor(){this.onDidChangeLogLevel=new M.$6d().event}setLevel(P){}getLevel(){return a.Info}trace(P,...A){}debug(P,...A){}info(P,...A){}warn(P,...A){}error(P,...A){}critical(P,...A){}dispose(){}flush(){}}e.$Yj=v;class b extends v{}e.$Zj=b;function $(y){if(y.verbose)return a.Trace;if(typeof y.logLevel=="string"){const P=D(y.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Pj}function I(y){switch(y){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}function g(y){switch(y){case a.Trace:return{original:"Trace",value:S.localize(0,null)};case a.Debug:return{original:"Debug",value:S.localize(1,null)};case a.Info:return{original:"Info",value:S.localize(2,null)};case a.Warning:return{original:"Warning",value:S.localize(3,null)};case a.Error:return{original:"Error",value:S.localize(4,null)};case a.Off:return{original:"Off",value:S.localize(5,null)}}}function D(y){switch(y){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$5j=new l.$xj("logLevel",I(a.Info))}),define(Pe[191],Me([1,0,6,13]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class M extends S.$Tc{constructor(R,m=[]){super(),this.a=new F.$Wj([R,...m]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$VP=M}),define(Pe[100],Me([1,0,32,158,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function k(d,s){return s-d}f.compare=k;const N=Object.create(null);N[f.Error]=(0,F.localize)(0,null),N[f.Warning]=(0,F.localize)(1,null),N[f.Info]=(0,F.localize)(2,null);function E(d){return N[d]||""}f.toString=E;function l(d){switch(d){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=l;function w(d){switch(d){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=w}(R||(e.MarkerSeverity=R={}));var m;(function(f){const k="";function N(l){return E(l,!0)}f.makeKey=N;function E(l,w){const d=[k];return l.source?d.push(l.source.replace("\xA6","\\\xA6")):d.push(k),l.code?typeof l.code=="string"?d.push(l.code.replace("\xA6","\\\xA6")):d.push(l.code.value.replace("\xA6","\\\xA6")):d.push(k),l.severity!==void 0&&l.severity!==null?d.push(R.toString(l.severity)):d.push(k),l.message&&w?d.push(l.message.replace("\xA6","\\\xA6")):d.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?d.push(l.startLineNumber.toString()):d.push(k),l.startColumn!==void 0&&l.startColumn!==null?d.push(l.startColumn.toString()):d.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?d.push(l.endLineNumber.toString()):d.push(k),l.endColumn!==void 0&&l.endColumn!==null?d.push(l.endColumn.toString()):d.push(k),d.push(k),d.join("\xA6")}f.makeKeyOptionalMessage=E})(m||(e.IMarkerData=m={})),e.$Qt=(0,M.$gi)("markerService")}),define(Pe[192],Me([1,0,5,32,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Hv=e.Severity=void 0,e.$Iv=m,e.Severity=F.default,e.$Hv=(0,M.$gi)("notificationService");var O;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var R;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(E){if(E){const l=E;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var f;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class k{constructor(){this.progress=new N,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Jv=k;class N{infinite(){}done(){}total(l){}worked(l){}}e.$Kv=N}),define(Pe[193],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=void 0,e.$6j=(0,S.$gi)("productService"),e.$7j="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(me,e,S,F){var M=arguments.length,O=M<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(me,e,S,F);else for(var m=me.length-1;m>=0;m--)(R=me[m])&&(O=(M<3?R(O):M>3?R(e,S,O):R(e,S))||O);return M>3&&O&&Object.defineProperty(e,S,O),O},qe=this&&this.__param||function(me,e){return function(S,F){e(S,F,me)}};define(Pe[101],Me([1,0,11,25,6,3]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.ProgressLocation=e.$Lv=void 0,e.$Lv=(0,O.$gi)("progressService");var R;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Mv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Nv=m;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const w=this.d;this.d=()=>{w?.(),l()}}):Promise.resolve()}}e.$Ov=f;let k=class extends M.$Tc{constructor(l,w){super(),this.a=new S.$Dh,w.withProgress(l,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,M.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Pv=k,e.$Pv=k=Je([qe(1,e.$Lv)],k);class N extends M.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new M.$Sc)}start(l){this.stop();const w=++this.a,d=new F.$de;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,M.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Rc)(()=>d.cancel())),this.b.add((0,M.$Rc)(()=>this.c?this.c.done():void 0)),{id:w,token:d.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Qv=N,e.$Rv=(0,O.$gi)("editorProgressService")}),define(Pe[30],Me([1,0,55,16]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0;class M{constructor(){this.a=new Map}add(R,m){S.ok(F.$Tf(R)),S.ok(F.$Vf(m)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Yn=new M}),define(Pe[72],Me([1,0,5,30]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0,e.$Zn={JSONContribution:"base.contributions.json"};function M(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class O{constructor(){this.b=new S.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,k){this.a[M(f)]=k,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new O;F.$Yn.add(e.$Zn.JSONContribution,R)}),define(Pe[56],Me([1,0,18,5,16,151,46,72,30]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.ConfigurationScope=e.$4n=e.EditPresentationTypes=void 0,e.$co=s,e.$do=a,e.$eo=r,e.$fo=n,e.$go=c;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$4n={Configuration:"base.contributions.configuration"};var N;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n="vscode://schemas/settings/resourceLanguage",e.$_n="vscode://schemas/settings/configurationDefaults";const E=f.$Yn.as(m.$Zn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new F.$6d,this.onDidSchemaChange=this.i.event,this.j=new F.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$$n,this.g),this.v()}registerConfiguration(t,p=!0){this.registerConfigurations([t],p)}registerConfigurations(t,p=!0){const u=new Set;this.n(t,p,u),E.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(t){const p=new Set;this.o(t,p),E.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:p})}updateConfigurations({add:t,remove:p}){const u=new Set;this.o(p,u),this.n(t,!1,u),E.registerSchema(e.$$n,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(t){const p=new Set;this.k(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}k(t,p){const u=[];for(const{overrides:o,source:v}of t)for(const b in o)if(p.add(b),e.$bo.test(b)){const $=this.a.get(b),I=$?.valuesSources??new Map;if(v)for(const P of Object.keys(o[b]))I.set(P,v);const g={...$?.value||{},...o[b]};this.a.set(b,{source:v,value:g,valuesSources:I});const D=(0,R.$Wi)(b),y={type:"object",default:g,description:O.localize(1,null,D),$ref:e.$$n,defaultDefaultValue:g,source:M.$Tf(v)?void 0:v,defaultValueSource:v};u.push(...s(b)),this.d[b]=y,this.b.properties[b]=y}else{this.a.set(b,{value:o[b],source:v});const $=this.d[b];$&&(this.w(b,$),this.r(b,$))}this.m(u)}deregisterDefaultConfigurations(t){const p=new Set;this.l(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}l(t,p){for(const{overrides:u,source:o}of t)for(const v in u){const b=this.a.get(v),$=M.$Tf(o)?o:o?.id,I=M.$Tf(b?.source)?b?.source:b?.source?.id;if($===I)if(p.add(v),this.a.delete(v),e.$bo.test(v))delete this.d[v],delete this.b.properties[v];else{const g=this.d[v];g&&(this.w(v,g),this.r(v,g))}}this.u()}deltaConfiguration(t){let p=!1;const u=new Set;t.removedDefaults&&(this.l(t.removedDefaults,u),p=!0),t.addedDefaults&&(this.k(t.addedDefaults,u),p=!0),t.removedConfigurations&&this.o(t.removedConfigurations,u),t.addedConfigurations&&this.n(t.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const p of t)this.h.add(p);this.u()}n(t,p,u){t.forEach(o=>{this.p(o,p,o.extensionInfo,o.restrictedProperties,void 0,u),this.c.push(o),this.q(o)})}o(t,p){const u=o=>{if(o.properties)for(const v in o.properties){p.add(v);const b=this.d[v];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[v],this.s(v,o.properties[v])}o.allOf?.forEach(v=>u(v))};for(const o of t){u(o);const v=this.c.indexOf(o);v!==-1&&this.c.splice(v,1)}}p(t,p=!0,u,o,v=3,b){v=M.$3f(t.scope)?v:t.scope;const $=t.properties;if($)for(const g in $){const D=$[g];if(p&&n(g,D)){delete $[g];continue}if(D.source=u,D.defaultDefaultValue=$[g].default,this.w(g,D),e.$bo.test(g)?D.scope=void 0:(D.scope=M.$3f(D.scope)?v:D.scope,D.restricted=M.$3f(D.restricted)?!!o?.includes(g):D.restricted),$[g].hasOwnProperty("included")&&!$[g].included){this.f[g]=$[g],delete $[g];continue}else this.d[g]=$[g],$[g].policy?.name&&this.e.set($[g].policy.name,g);!$[g].deprecationMessage&&$[g].markdownDeprecationMessage&&($[g].deprecationMessage=$[g].markdownDeprecationMessage),b.add(g)}const I=t.allOf;if(I)for(const g of I)this.p(g,p,u,o,v,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const p=u=>{const o=u.properties;if(o)for(const b in o)this.r(b,o[b]);u.allOf?.forEach(p)};p(t)}r(t,p){switch(e.$5n.properties[t]=p,p.scope){case 1:e.$6n.properties[t]=p;break;case 2:e.$7n.properties[t]=p;break;case 6:e.$8n.properties[t]=p;break;case 3:e.$9n.properties[t]=p;break;case 4:e.$0n.properties[t]=p;break;case 5:e.$0n.properties[t]=p,this.g.properties[t]=p;break}}s(t,p){switch(delete e.$5n.properties[t],p.scope){case 1:delete e.$6n.properties[t];break;case 2:delete e.$7n.properties[t];break;case 6:delete e.$8n.properties[t];break;case 3:delete e.$9n.properties[t];break;case 4:case 5:delete e.$0n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const p=`[${t}]`,u={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$$n};this.w(p,u),e.$5n.properties[p]=u,e.$6n.properties[p]=u,e.$7n.properties[p]=u,e.$8n.properties[p]=u,e.$9n.properties[p]=u,e.$0n.properties[p]=u}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$$n};e.$5n.patternProperties[e.$ao]=t,e.$6n.patternProperties[e.$ao]=t,e.$7n.patternProperties[e.$ao]=t,e.$8n.patternProperties[e.$ao]=t,e.$9n.patternProperties[e.$ao]=t,e.$0n.patternProperties[e.$ao]=t,this.i.fire()}w(t,p){const u=this.a.get(t);let o=u?.value,v=u?.source;M.$1f(o)&&(o=p.defaultDefaultValue,v=void 0),M.$1f(o)&&(o=r(p.type)),p.default=o,p.defaultValueSource=v}}const w="\\[([^\\]]+)\\]",d=new RegExp(w,"g");e.$ao=`^(${w})+$`,e.$bo=new RegExp(e.$ao);function s(h){const t=[];if(e.$bo.test(h)){let p=d.exec(h);for(;p?.length;){const u=p[1].trim();u&&t.push(u),p=d.exec(h)}}return(0,S.$Mb)(t)}function a(h){return h.reduce((t,p)=>`${t}[${p}]`,"")}function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new l;f.$Yn.add(e.$4n.Configuration,i);function n(h,t){return h.trim()?e.$bo.test(h)?O.localize(7,null,h):i.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,h,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function c(){const h=[],t=i.getConfigurationProperties();for(const p of Object.keys(t))h.push([p,t[p].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Pe[194],Me([1,0,18,5,122,6,28,26,16,2,46,56,30]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$ko=e.$jo=e.$io=e.$ho=void 0,e.$lo=n;function w(p){return Object.isFrozen(p)?p:m.$Nn(p)}class d{constructor(u={},o=[],v=[],b){this.b=u,this.c=o,this.d=v,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(o=>{if(o instanceof d)return o;const v=new s("");return v.parseRaw(o),v.configurationModel});this.f=u.reduce((o,v)=>v===o?v:o.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,N.$Ui)(this.contents,u):this.contents}inspect(u,o){const v=this;return{get value(){return w(v.rawConfiguration.getValue(u))},get override(){return o?w(v.rawConfiguration.getOverrideValue(u,o)):void 0},get merged(){return w(o?v.rawConfiguration.override(o).getValue(u):v.rawConfiguration.getValue(u))},get overrides(){const b=[];for(const{contents:$,identifiers:I,keys:g}of v.rawConfiguration.overrides){const D=new d($,g).getValue(u);D!==void 0&&b.push({identifiers:I,value:D})}return b.length?w(b):void 0}}}getOverrideValue(u,o){const v=this.i(o);return v?u?(0,N.$Ui)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const o=[];for(const v of this.overrides)v.identifiers.includes(u)&&o.push(...v.keys);return S.$Mb(o)}getAllOverrideIdentifiers(){const u=[];for(const o of this.overrides)u.push(...o.identifiers);return S.$Mb(u)}override(u){let o=this.a.get(u);return o||(o=this.g(u),this.a.set(u,o)),o}merge(...u){const o=m.$Mn(this.contents),v=m.$Mn(this.overrides),b=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const I of u)if($.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const g of I.overrides){const[D]=v.filter(y=>S.$ub(y.identifiers,g.identifiers));D?(this.h(D.contents,g.contents),D.keys.push(...g.keys),D.keys=S.$Mb(D.keys)):v.push(m.$Mn(g))}for(const g of I.keys)b.indexOf(g)===-1&&b.push(g)}return new d(o,b,v,$.every(I=>I instanceof d)?void 0:$)}g(u){const o=this.i(u);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const v={};for(const b of S.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let $=this.contents[b];const I=o[b];I&&(typeof $=="object"&&typeof I=="object"?($=m.$Mn($),this.h($,I)):$=I),v[b]=$}return new d(v,this.keys,this.overrides)}h(u,o){for(const v of Object.keys(o)){if(v in u&&f.$Vf(u[v])&&f.$Vf(o[v])){this.h(u[v],o[v]);continue}u[v]=m.$Mn(o[v])}}i(u){let o=null,v=null;const b=$=>{$&&(v?this.h(v,$):v=m.$Mn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===u?o=$.contents:$.identifiers.includes(u)&&b($.contents);return b(o),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,o){this.j(u,o,!0)}setValue(u,o){this.j(u,o,!1)}removeValue(u){const o=this.keys.indexOf(u);o!==-1&&(this.keys.splice(o,1),(0,N.$Ti)(this.contents,u),E.$bo.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>S.$ub(v.identifiers,(0,E.$co)(u))),1))}j(u,o,v){(0,N.$Si)(this.contents,u,o,b=>console.error(b)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),E.$bo.test(u)&&this.overrides.push({identifiers:(0,E.$co)(u),keys:Object.keys(this.contents[u]),contents:(0,N.$Ri)(this.contents[u],b=>console.error(b))})}}e.$ho=d;class s{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,o){if(!f.$3f(u)){const v=this.g(u);this.parseRaw(v,o)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,o){this.a=u;const{contents:v,keys:b,overrides:$,restricted:I,hasExcludedProperties:g}=this.h(u,o);this.b=new d(v,b,$,g?[u]:void 0),this.c=I||[]}g(u){let o={},v=null,b=[];const $=[],I=[];function g(y){Array.isArray(b)?b.push(y):v!==null&&(b[v]=y)}const D={onObjectBegin:()=>{const y={};g(y),$.push(b),b=y,v=null},onObjectProperty:y=>{v=y},onObjectEnd:()=>{b=$.pop()},onArrayBegin:()=>{const y=[];g(y),$.push(b),b=y,v=null},onArrayEnd:()=>{b=$.pop()},onLiteralValue:g,onError:(y,P,A)=>{I.push({error:y,offset:P,length:A})}};if(u)try{M.$An(u,D),o=b[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return o}h(u,o){const v=l.$Yn.as(E.$4n.Configuration).getConfigurationProperties(),b=this.i(u,v,!0,o);u=b.raw;const $=(0,N.$Ri)(u,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),I=Object.keys(u),g=this.j(u,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:$,keys:I,overrides:g,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(u,o,v,b){let $=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:$};const I={},g=[];for(const D in u)if(E.$bo.test(D)&&v){const y=this.i(u[D],o,!1,b);I[D]=y.raw,$=$||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=o[D],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(D),!b.exclude?.includes(D)&&(b.include?.includes(D)||(P===void 0||b.scopes===void 0||b.scopes.includes(P))&&!(b.skipRestricted&&y?.restricted))?I[D]=u[D]:$=!0}return{raw:I,restricted:g,hasExcludedProperties:$}}j(u,o){const v=[];for(const b of Object.keys(u))if(E.$bo.test(b)){const $={};for(const I in u[b])$[I]=u[b][I];v.push({identifiers:(0,E.$co)(b),keys:Object.keys($),contents:(0,N.$Ri)($,o)})}return v}}e.$io=s;class a extends O.$Tc{constructor(u,o,v,b){super(),this.c=u,this.f=o,this.g=b,this.b=this.B(new F.$6d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&v.isEqual($.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$jo=a;class r{constructor(u,o,v,b,$,I,g,D,y,P,A,G,W){this.a=u,this.b=o,this.c=v,this.overrideIdentifiers=b,this.d=$,this.f=I,this.g=g,this.h=D,this.i=y,this.j=P,this.k=A,this.l=G,this.m=W}get value(){return w(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(u,o,v,b,$=new d,I=new d,g=new R.$Ac,D=new d,y=new R.$Ac){this.c=u,this.d=o,this.f=v,this.g=b,this.h=$,this.i=I,this.j=g,this.l=D,this.m=y,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,o,v){return this.p(u,o,v).getValue(u)}updateValue(u,o,v={}){let b;v.resource?(b=this.m.get(v.resource),b||(b=new d,this.m.set(v.resource,b))):b=this.l,o===void 0?b.removeValue(u):b.setValue(u,o),v.resource||(this.a=null)}inspect(u,o,v){const b=this.p(u,o,v),$=this.t(o.resource,v),I=o.resource?this.m.get(o.resource)||this.l:this.l,g=new Set;for(const D of b.overrides)for(const y of D.identifiers)b.getOverrideValue(u,y)!==void 0&&g.add(y);return new r(u,o,b.getValue(u),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,$||void 0,I)}keys(u){const o=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,o){this.j.set(u,o),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,o){const v=[];if(!o){const{added:b,updated:$,removed:I}=h(this.c,u);o=[...b,...$,...I]}for(const b of o)for(const $ of(0,E.$co)(b)){const I=this.c.getKeysForOverrideIdentifier($),g=u.getKeysForOverrideIdentifier($),D=[...g.filter(y=>I.indexOf(y)===-1),...I.filter(y=>g.indexOf(y)===-1),...I.filter(y=>!m.$Qn(this.c.override($).getValue(y),u.override($).getValue(y)))];v.push([$,D])}return this.updateDefaultConfiguration(u),{keys:o,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:o,updated:v,removed:b}=h(this.d,u),$=[...o,...v,...b];return $.length&&this.updatePolicyConfiguration(u),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=h(this.applicationConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:$}}compareAndUpdateLocalUserConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=h(this.localUserConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:$}}compareAndUpdateRemoteUserConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=h(this.remoteUserConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:$}}compareAndUpdateWorkspaceConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=h(this.workspaceConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:$}}compareAndUpdateFolderConfiguration(u,o){const v=this.folderConfigurations.get(u),{added:b,updated:$,removed:I,overrides:g}=h(v,o),D=[...b,...$,...I];return(D.length||!v)&&this.updateFolderConfiguration(u,o),{keys:D,overrides:g}}compareAndDeleteFolderConfiguration(u){const o=this.folderConfigurations.get(u);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:b,removed:$,overrides:I}=h(o,void 0);return{keys:[...v,...b,...$],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,o,v){let b=this.q(o,v);return o.overrideIdentifier&&(b=b.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(b=b.merge(this.d)),b}q({resource:u},o){let v=this.r();if(o&&u){const b=o.getFolder(u);b&&(v=this.s(b.uri)||v);const $=this.m.get(u);$&&(v=v.merge($))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let o=this.b.get(u);if(!o){const v=this.r(),b=this.j.get(u);b?(o=v.merge(b),this.b.set(u,o)):o=v}return o}t(u,o){if(o&&u){const v=o.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,o)=>{const{contents:v,overrides:b,keys:$}=this.j.get(o);return u.push([o,{contents:v,overrides:b,keys:$}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(o=>u.add(o)),this.userConfiguration.keys.forEach(o=>u.add(o)),this.i.keys.forEach(o=>u.add(o)),this.j.forEach(o=>o.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const o=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(b=>o.add(b))),[...o.values()]}static parse(u){const o=this.w(u.defaults),v=this.w(u.policy),b=this.w(u.application),$=this.w(u.user),I=this.w(u.workspace),g=u.folders.reduce((D,y)=>(D.set(k.URI.revive(y[0]),this.w(y[1])),D),new R.$Ac);return new i(o,v,b,$,new d,I,g,new d,new R.$Ac)}static w(u){return new d(u.contents,u.keys,u.overrides)}}e.$ko=i;function n(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const u=new Set,o=new Map;for(const b of p)b.keys.forEach($=>u.add($)),b.overrides.forEach(([$,I])=>{const g=(0,R.$xc)(o,$,new Set);I.forEach(D=>g.add(D))});const v=[];return o.forEach((b,$)=>v.push([$,[...b.values()]])),{keys:[...u.values()],overrides:v}}class c{constructor(u,o,v,b){this.change=u,this.f=o,this.g=v,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of u.keys)this.affectedKeys.add($);for(const[,$]of u.overrides)for(const I of $)this.affectedKeys.add(I);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(u,o){const v=this.a+u,b=this.d.indexOf(v);if(b<0)return!1;const $=b+v.length;if($>=this.d.length)return!1;const I=this.d.charCodeAt($);if(I!==this.b&&I!==this.c)return!1;if(o){const g=this.previousConfiguration?this.previousConfiguration.getValue(u,o,this.f?.workspace):void 0,D=this.g.getValue(u,o,this.h);return!m.$Qn(g,D)}return!0}}e.$mo=c;function h(p,u){const{added:o,removed:v,updated:b}=t(u?.rawConfiguration,p?.rawConfiguration),$=[],I=p?.getAllOverrideIdentifiers()||[],g=u?.getAllOverrideIdentifiers()||[];if(u){const D=g.filter(y=>!I.includes(y));for(const y of D)$.push([y,u.getKeysForOverrideIdentifier(y)])}if(p){const D=I.filter(y=>!g.includes(y));for(const y of D)$.push([y,p.getKeysForOverrideIdentifier(y)])}if(u&&p){for(const D of I)if(g.includes(D)){const y=t({contents:p.getOverrideValue(void 0,D)||{},keys:p.getKeysForOverrideIdentifier(D)},{contents:u.getOverrideValue(void 0,D)||{},keys:u.getKeysForOverrideIdentifier(D)});$.push([D,[...y.added,...y.removed,...y.updated]])}}return{added:o,removed:v,updated:b,overrides:$}}function t(p,u){const o=p?u?p.keys.filter($=>u.keys.indexOf($)===-1):[...p.keys]:[],v=u?p?u.keys.filter($=>p.keys.indexOf($)===-1):[...u.keys]:[],b=[];if(p&&u){for(const $ of u.keys)if(p.keys.indexOf($)!==-1){const I=(0,N.$Ui)(u.contents,$),g=(0,N.$Ui)(p.contents,$);m.$Qn(I,g)||b.push($)}}return{added:o,removed:v,updated:b}}}),define(Pe[102],Me([1,0,14,3]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.RemoteAuthorityResolverErrorCode=e.$tl=e.$sl=e.RemoteConnectionType=e.$rl=void 0,e.$vl=k,e.$rl=(0,F.$gi)("remoteAuthorityResolverService");var M;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class O{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$sl=O;class R{constructor(E,l){this.host=E,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$tl=R;var m;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends S.$bb{static isNotAvailable(E){return E instanceof f&&E._code===m.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof f&&E._code===m.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof f&&E._code===m.NoResolverFound}static isInvalidAuthority(E){return E instanceof f&&E._code===m.InvalidAuthority}static isHandled(E){return E instanceof f&&E.isHandled}constructor(E,l=m.Unknown,w){super(E),this._message=E,this._code=l,this._detail=w,this.isHandled=l===m.NotAvailable&&w===!0,Object.setPrototypeOf(this,f.prototype)}}e.$ul=f;function k(N){const E=N.indexOf("+");return E===-1?N:N.substring(0,E)}}),define(Pe[57],Me([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=F,e.$sm=M,e.$tm=O,e.$um=R;function F(f){return f.scheme===S.Schemas.vscodeRemote?f.authority:void 0}function M(f){if(!f)return;const k=f.indexOf("+");return k<0?f:f.substr(0,k)}function O(f){const{host:k,port:N}=m(f);if(typeof N>"u")throw new Error(`Invalid remote authority: ${f}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:N}}function R(f,k){let{host:N,port:E}=m(f);return typeof E>"u"&&(E=k),{host:N,port:E}}function m(f){const k=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const N=f.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const E=f.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:f,port:void 0}}}),define(Pe[20],Me([1,0,15,3,57]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Dm=e.$Cm=e.$Bm=e.TargetPlatform=e.ExtensionType=e.$Am=e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$zm=O,e.$Em=E,e.$Fm=l,e.$Gm=w,e.$Hm=d,e.$vm="extensions.user.cache",e.$wm="extensions.builtin.cache",e.$xm="undefined_publisher",e.$ym=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,r){if(typeof a>"u"||a===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof a=="string"||typeof r=="string"){const i=typeof a=="string"?a:a.value,n=typeof r=="string"?r:r.value;return S.$kf(i,n)}return a._lower===r._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$Bm=f;class k{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const r of a)this.add(r)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$Cm=k;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,r){this.c.set(f.toKey(a),r)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Dm=N;function E(s){return l(s)}function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function w(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function d(s,a){if(a){const r=`onResolveRemoteAuthority:${(0,M.$sm)(a)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Im=(0,F.$gi)("IBuiltinExtensionsScannerService")}),define(Pe[103],Me([1,0,14,20]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=e.$HF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const f of R){const k=this.readActivationEvents(f);k.length>0&&(m[F.$Bm.toKey(f.identifier)]=k)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${F.$Bm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const f in R.contributes){const k=this.a.get(f);if(!k)continue;const N=R.contributes[f],E=Array.isArray(N)?N:[N];try{k(E,m)}catch(l){(0,S.$1)(l)}}return m}}e.$HF=M,e.$IF=new M}),define(Pe[195],Me([1,0,21,73,33]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=R,e.$1o=m;function O(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,k,N,E,l,w,d,s,a){const r=Object.create(null);r["common.machineId"]=w,r["common.sqmId"]=d,r.sessionID=(0,M.$Cg)()+Date.now(),r.commitHash=E,r.version=l,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=F.$dc,r["common.nodeArch"]=N,r["common.product"]=a||"desktop",s&&(r["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const c=O(k);return c&&(r["common.platformDetail"]=c),r}function m(f){const k=F.env.USERDNSDOMAIN;if(!k)return!1;const N=k.toLowerCase();return f.some(E=>N===E)}}),define(Pe[196],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0,e.$Ll=(0,S.$gi)("telemetryService"),e.$Ml=(0,S.$gi)("customEndpointTelemetryService"),e.$Nl="telemetry.currentSessionDate",e.$Ol="telemetry.firstSessionDate",e.$Pl="telemetry.lastSessionDate",e.$Ql="telemetry.machineId",e.$Rl="telemetry.sqmId",e.$Sl="telemetry",e.$Tl="telemetry.telemetryLevel",e.$Ul="telemetry.enableCrashReporter",e.$Vl="telemetry.enableTelemetry";var F;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var M;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Pe[58],Me([1,0,26,16,57,195,196]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=N,e.$0o=E,e.$$o=l,e.$_o=w,e.$ap=s,e.$bp=r,e.$cp=i,e.$dp=h;class m{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$2o=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$3o=f,e.$4o=new f;class k{async publicLog(p,u,o){}async publicLogError(p,u,o){}}e.$5o=k,e.$6o="telemetry",e.$7o="extensionTelemetryLog",e.$8o={log:()=>null,flush:()=>Promise.resolve(null)};function N(t,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!t.enableTelemetry)}function E(t,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const p=t.getValue(R.$Tl),u=t.getValue(R.$Ul);if(t.getValue(R.$Vl)===!1||u===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const p={},u={},o={};a(t,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const b=o[v];typeof b=="number"?u[v]=b:typeof b=="boolean"?u[v]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${b.length}`),p[v]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(p[v]=b)}return{properties:p,measurements:u}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const p=(0,M.$sm)(t);return d.has(p)?p:"other"}function a(t,p,u=0,o){if(t)for(const v of Object.getOwnPropertyNames(t)){const b=t[v],$=o?o+v:v;Array.isArray(b)?p[$]=(0,S.$Rn)(b):b instanceof Date?p[$]=b.toISOString():(0,F.$Vf)(b)?u<2?a(b,p,u+1,$+"."):p[$]=(0,S.$Rn)(b):p[$]=b}}function r(t,p){const u=t.msftInternalDomains||[],o=p.getValue("telemetry.internalTesting");return(0,O.$1o)(u)||o}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,p){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let u=t;const o=[];for(const I of p)for(;;){const g=I.exec(t);if(!g)break;o.push([g.index,I.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(u="";;){const I=b.exec(t);if(!I)break;const g=o.some(([D,y])=>I.index<y&&D<b.lastIndex);!v.test(I[0])&&!g&&(u+=t.substring($,I.index)+"<REDACTED: user-file-path>",$=b.lastIndex)}return $<t.length&&(u+=t.substr($)),u}function c(t){if(!t)return t;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of p)if(u.regex.test(t))return`<REDACTED: ${u.label}>`;return t}function h(t,p){return(0,S.$On)(t,u=>{if(u instanceof m||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let o=u.replaceAll("%20"," ");o=n(o,p);for(const v of p)o=o.replace(v,"");return o=c(o),o}})}}),define(Pe[197],Me([1,0,15,98,20,21,2,14,73,58]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$fp=void 0,e.$ep=N,e.$gp=d,e.$hp=s,e.$ip=a,e.$jp=r,e.$kp=i,e.$lp=n,e.$mp=c,e.$op=h,e.$pp=p;function N(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,S.$ff)(u.id,o.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(o){const v=o.manifest?o.manifest.version:o.version,b=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new l(o.identifier,v,b)}static parse(o){const v=E.exec(o);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(o,v,b="undefined"){this.version=v,this.targetPlatform=b,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof l?N(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$fp=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(u){const o=w.exec(u);return o&&o[1]?[a(o[1]),o[2]]:[a(u),void 0]}function s(u,o){return`${u}.${o}`}function a(u){return u.toLowerCase()}function r(u,o){return a(s(u??M.$xm,o))}function i(u,o){const v=[],b=$=>{for(const I of v)if(I.some(g=>N(o(g),o($))))return I;return null};for(const $ of u){const I=b($);I?I.push($):v.push([$])}return v}function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}function c(u){return{id:new k.$2o(u.identifier.id),name:new k.$2o(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$np=new M.$Bm("pprice.better-merge");function h(u,o){const v=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const $=b.shift();if($&&v.every(I=>!N(I.identifier,{id:$}))){const I=u.filter(g=>N(g.identifier,{id:$}));I.length===1&&(v.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}async function t(u,o){if(!O.$k)return!1;let v;try{v=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){o.debug("Error while getting the os-release file.",(0,m.$0)($))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function p(u,o){const v=await t(u,o),b=(0,F.$Lo)(v?"alpine":O.$u,f.$ec);return o.debug("ComputeTargetPlatform:",b),b}}),define(Pe[198],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=S,e.$4r=F,e.$5r=M,e.$6r=O,e.$7r=R,e.$8r=m;function S(f){return[...f.entries()]}function F(f){return f?[...f.entries()]:[]}function M(f){return new Map(f)}function O(f){return new Map(f??[])}function R(f){return Array.from(f.entries()).map(k=>[k[0],S(k[1].map),F(k[1].descriptionMap)])}function m(f){return new Map(f.map(k=>[k[0],{map:M(k[1]),descriptionMap:O(k[2])}]))}}),define(Pe[199],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4tb=void 0;class S{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,O,R=5){const m=O(f=>{const k=typeof f=="string"?f:f.data;let N=this.a.get(M);if(N){N.data.push(k);return}const E=setTimeout(()=>this.flushBuffer(M),R);N={data:[k],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(M),m.dispose()}},this.a.set(M,N)});return m}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const O=this.a.get(M);O&&(this.a.delete(M),this.b(M,O.data.join("")))}}e.$4tb=S}),define(Pe[200],Me([1,0,11,91,299,40,5,16,2,159,72,30]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=e.$Ww=e.$Vw=e.$Uw=e.$Tw=e.$Sw=e.IconFontDefinition=e.IconContribution=e.$Pw=void 0,e.$Qw=a,e.$Rw=r,e.$Pw={IconContribution:"base.contributions.icons"};var l;(function(h){function t(p,u){let o=p.defaults;for(;O.ThemeIcon.isThemeIcon(o);){const v=s.getIcon(o.id);if(!v)return;o=v.defaults}return o}h.getDefinition=t})(l||(e.IconContribution=l={}));var w;(function(h){function t(u){return{weight:u.weight,style:u.style,src:u.src.map(o=>({format:o.format,location:o.location.toString()}))}}h.toJSONObject=t;function p(u){const o=v=>(0,m.$Tf)(v)?v:void 0;if(u&&Array.isArray(u.src)&&u.src.every(v=>(0,m.$Tf)(v.format)&&(0,m.$Tf)(v.location)))return{weight:o(u.weight),style:o(u.style),src:u.src.map(v=>({format:v.format,location:f.URI.parse(v.location)}))}}h.fromJSONObject=p})(w||(e.IconFontDefinition=w={}));class d{constructor(){this.a=new R.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,p,u,o){const v=this.b[t];if(v){if(u&&!v.description){v.description=u,this.d.properties[t].markdownDescription=`${u} $(${t})`;const I=this.e.enum.indexOf(t);I!==-1&&(this.e.enumDescriptions[I]=u),this.a.fire()}return v}const b={id:t,description:u,defaults:p,deprecationMessage:o};this.b[t]=b;const $={$ref:"#/definitions/icons"};return o&&($.deprecationMessage=o),u&&($.markdownDescription=`${u}: $(${t})`),this.d.properties[t]=$,this.e.enum.push(t),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const p=this.e.enum.indexOf(t);p!==-1&&(this.e.enum.splice(p,1),this.e.enumDescriptions.splice(p,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,p){const u=this.f[t];return u||(this.f[t]=p,this.a.fire(),p)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(v,b)=>v.id.localeCompare(b.id),p=v=>{for(;O.ThemeIcon.isThemeIcon(v.defaults);)v=this.b[v.defaults.id];return`codicon codicon-${v?v.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(v=>this.b[v]);for(const v of o.filter(b=>!!b.description).sort(t))u.push(`|<i class="${p(v)}"></i>|${v.id}|${O.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const v of o.filter(b=>!O.ThemeIcon.isThemeIcon(b.defaults)).sort(t))u.push(`|<i class="${p(v)}"></i>|${v.id}|`);return u.join(`
`)}}const s=new d;E.$Yn.add(e.$Pw.IconContribution,s);function a(h,t,p,u){return s.registerIcon(h,t,p,u)}function r(){return s}function i(){const h=(0,M.$Bj)();for(const t in h){const p="\\"+h[t].toString(16);s.registerIcon(t,{fontCharacter:p})}}i(),e.$Sw="vscode://schemas/icons";const n=E.$Yn.as(N.$Zn.JSONContribution);n.registerSchema(e.$Sw,s.getIconSchema());const c=new S.$sh(()=>n.notifySchemaChanged(e.$Sw),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$Tw=a("widget-close",F.$Fj.close,(0,k.localize)(2,null)),e.$Uw=a("goto-previous-location",F.$Fj.arrowUp,(0,k.localize)(3,null)),e.$Vw=a("goto-next-location",F.$Fj.arrowDown,(0,k.localize)(4,null)),e.$Ww=O.ThemeIcon.modify(F.$Fj.sync,"spin"),e.$Xw=O.ThemeIcon.modify(F.$Fj.loading,"spin")}),define(Pe[201],Me([1,0,5,2,46,3,13]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$Zv=e.$Xv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tv=e.$Sv=void 0,e.$Uv=k,e.$Vv=E,e.$Wv=l,e.$Yv=w,e.$1v=d,e.$2v=s,e.$Sv=(0,O.$gi)("tunnelService"),e.$Tv=(0,O.$gi)("sharedTunnelsService");var m;(function(i){i.Http="http",i.Https="https"})(m||(e.TunnelProtocol=m={}));var f;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(f||(e.TunnelPrivacyId=f={}));function k(i){return!!i.forwardPort}var N;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function E(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function l(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const h=c.split("=")[1];if(/^https?:/.exec(h)){const t=E(F.URI.parse(h));if(t)return t}}}e.$Xv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(i){return e.$Xv.indexOf(i)>=0}e.$Zv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(i){return e.$Zv.indexOf(i)>=0}function s(i,n,c,h){if(c===1)return!1;if(c===2&&d(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class a{constructor(n,c,h){this.remoteAddress=n,this.localAddress=c,this.b=h,this.a=new S.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3v=a;let r=class{constructor(n,c){this.k=n,this.l=c,this.a=new S.$6d,this.onTunnelOpened=this.a.event,this.b=new S.$6d,this.onTunnelClosed=this.b.event,this.c=new S.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const h of c){const t=Array.from(h.values());for(const p of t){const u=await p.value;u&&typeof u!="string"&&n.push(u)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,h,t,p){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:h,privacy:t,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(d(n)||w(n))&&(n=e.$Xv[0]);const h=this.s(n,c);if(h)return++h.refcount,h.value}openTunnel(n,c,h,t,p,u=!1,o,v){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${p}.`);const b=this.f??n;if(!b)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const $=this.t(b,c,h,t,p,u,o,v);return $?$.then(I=>{if(I){if(typeof I=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),I}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(I);return(I.tunnelRemoteHost!==c||I.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&I.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),$)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const h=c.get(n.tunnelRemotePort);h&&(h.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,h))}}}}async p(n,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=h.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const h=this.e.get(n);if(h&&h.has(c)){const t=h.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,h){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:h})}async r(n,c){const h=this.e.get(n);if(h){const t=h.get(c),p=t?await t.value:void 0;(!p||typeof p=="string")&&h.delete(c),h.size===0&&this.e.delete(n)}}s(n,c){const h=[n];w(n)?(h.push(...e.$Xv),h.push(...e.$Zv)):d(n)&&h.push(...e.$Zv);const t=h.map(p=>this.e.get(p));for(const p of t){const u=p?.get(c);if(u)return u}}canTunnel(n){return!!E(n)}u(n,c,h,t,p,u,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${t}.`);const v=h;this.j.add(v);const b=t===void 0?h:t,$={elevationRequired:p?this.isPortPrivileged(b):!1},I={remoteAddress:{host:c,port:h},localAddressPort:t,privacy:u,public:u?u!==f.Private:void 0,protocol:o},g=n.forwardPort(I,$);return g?(this.q(c,h,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(v)})):this.j.delete(v),g}};e.$4v=r,e.$4v=r=Je([qe(0,R.$Mj),qe(1,M.$Mi)],r)}),define(Pe[202],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$5v=void 0,e.$5v=(0,S.$gi)("editSessionIdentityService");var F;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Pe[203],Me([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=F,e.$OL=M,e.$PL=O,e.$QL=R,e.$RL=m;function F(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}function M(f){if(f.folders.length)return f.folders.every(k=>F(k.uri))?f.folders[0].uri:void 0;if(f.configuration&&F(f.configuration))return f.configuration}function O(f){return M(f)?.scheme}function R(f){return M(f)?.authority}function m(f){return M(f)!==void 0}}),define(Pe[47],Me([1,0,160,19,50,24,2,3,12]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Ai=e.$zi=e.WorkbenchState=e.$ti=e.$si=e.$pi=void 0,e.$qi=k,e.$ri=N,e.$ui=E,e.$vi=l,e.$wi=w,e.$xi=s,e.$yi=a,e.$Bi=n,e.$Gi=c,e.$Hi=h,e.$Ji=t,e.$Ki=p,e.$Li=u,e.$pi=(0,m.$gi)("contextService");function k(o){const v=o;return typeof v?.id=="string"&&R.URI.isUri(v.uri)}function N(o){return typeof o?.id=="string"&&!k(o)&&!l(o)}e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function E(o,v){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,F.$nc)(o)}:v?e.$si:e.$ti;const b=o;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}function l(o){const v=o;return typeof v?.id=="string"&&R.URI.isUri(v.configPath)}function w(o){const v=o;if(v?.uri)return{id:v.id,uri:R.URI.revive(v.uri)};const b=o;if(b?.configPath)return{id:b.id,configPath:R.URI.revive(b.configPath)};if(o?.id)return{id:o.id}}var d;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function s(o){const v=o;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}function a(o){const v=o;return!!(v&&typeof v=="object"&&R.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}class r{constructor(v,b,$,I,g){this.h=v,this.j=$,this.k=I,this.l=g,this.c=M.$mi.forUris(this.l,()=>!0),this.folders=b}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=M.$mi.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=r;class i{constructor(v,b){this.raw=b,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,O.$Tg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=i;function n(o){return new i({uri:o,index:0,name:(0,O.$Pg)(o)},{uri:o.toString()})}e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,S.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function c(o,v){return O.$Kg.isEqualOrParent(o,v.untitledWorkspacesHome)}function h(o){let v;return R.URI.isUri(o)?v=o:v=o.configuration,v?.scheme===f.Schemas.tmp}e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$Ii}function p(o,v){return!c(o,v)&&!h(o)}function u(o){return(typeof o=="string"?(0,F.$oc)(o):(0,O.$Rg)(o))===e.$Di}}),define(Pe[74],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class S{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const O=this.c++;return this.b.set(O,M),this.e(),O}get(M,O){return this.b.has(M)?this.b.get(M)[O]:void 0}delete(M){this.b.delete(M),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$oic=S}),define(Pe[43],Me([1,0,12,24,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=void 0;class O{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new F.$Ig(m=>{const f=this.b.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this.b.delete(m.scheme):this.b.set(m.scheme,f)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$tic=O,e.$uic=(0,M.$gi)("IExtHostFileSystemInfo")}),define(Pe[27],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=void 0,e.$NO=(0,S.$gi)("IExtHostInitDataService")}),define(Pe[204],Me([1,0,166,13,191,27]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;let R=class extends M.$VP{constructor(f,k,N){const E=N.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=N.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(k.createLogger(E,{name:l}))}};e.$Akc=R,e.$Akc=R=Je([qe(1,F.$Nj),qe(2,O.$NO)],R)}),define(Pe[205],Me([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=void 0;class F{constructor(R,m,f){this.h=new Map,this.a=R,this.b=m,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new S.$sh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const E of k.values())E.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let f=this.f[R];return typeof f>"u"&&(f=m),f}update(R,m){this.f[R]=m;const f=this.h.get(R);if(f!==void 0)return f.p;const k=new S.$Dh;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$cjc=F;class M extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$djc=M}),define(Pe[206],Me([1,0,5,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;class M{constructor(R){this.c=R,this.a=new S.$6d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$6d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,f,k){const E=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(m.value,f,k);this.b.fire(E)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$3jc=M}),define(Pe[17],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=void 0,e.$xO=(0,S.$gi)("IExtHostRpcService");class F{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$yO=F}),define(Pe[207],Me([1,0,20,5]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class M{#e;constructor(R,m){this.b=new F.$6d,this.onDidChange=this.b.event,this.a=S.$Bm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$kjc=M}),define(Pe[59],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0,e.$Mic=(0,S.$gi)("IURITransformerService");class F{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Nic=F}),define(Pe[208],Me([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnb=M,e.$xnb=R;class F{constructor(){this.buffers=[]}add(f){let k=this.buffers.indexOf(f);return k<0&&(k=this.buffers.length,this.buffers.push(f)),k}}function M(m,f){if(f.serializeBuffersForPostMessage){const k=new F,E=JSON.stringify(m,(w,d)=>{if(d instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(d)};if(ArrayBuffer.isView(d)){const s=O(d);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(d.buffer),view:{type:s,byteLength:d.byteLength,byteOffset:d.byteOffset}}}return d}),l=k.buffers.map(w=>{const d=new Uint8Array(w);return S.$te.wrap(d)});return{message:E,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}function O(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,f){const k=f.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),N=f.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const d=w,{index:s}=d,a=k[s];if(d.view)switch(d.view.type){case 1:return new Int8Array(a,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return w}:void 0;return{message:JSON.parse(m,N),arrayBuffers:k}}}),define(Pe[104],Me([1,0,175,16,2,6,3,30,42,12,41,137,32]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$jF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aF=e.EditorInputCapabilities=e.$_E=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=void 0,e.$4E=s,e.$5E=a,e.$6E=r,e.$7E=i,e.$8E=n,e.$9E=c,e.$0E=h,e.$$E=t,e.$bF=$,e.$cF=g,e.$dF=D,e.$eF=y,e.$fF=P,e.$gF=A,e.$hF=G,e.$iF=ne,e.$kF=Ie,e.$lF=ve,e.$mF=re,e.$nF=$e,e.$YE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ZE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$1E="workbench.editor.sidebysideEditor",e.$2E="workbench.editors.textDiffEditor",e.$3E="workbench.editors.binaryResourceDiffEditor";var w;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var d;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function s(ie){const le=ie;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}function a(ie,le,V){for(const ee of V.visibleEditorPanes)if(ee.group.id===le&&ie.matches(ee.input))return ee.getViewState()}function r(ie){if($(ie))return!1;const le=ie;return M.URI.isUri(le?.resource)}function i(ie){if($(ie))return!1;const le=ie;return le?.original!==void 0&&le.modified!==void 0}function n(ie){if($(ie))return!1;const le=ie;return!le||le.resources&&!Array.isArray(le.resources)?!1:!!le.resources||!!le.multiDiffSource}function c(ie){if($(ie)||i(ie))return!1;const le=ie;return le?.primary!==void 0&&le.secondary!==void 0}function h(ie){if($(ie))return!1;const le=ie;return le?le.resource===void 0||le.resource.scheme===k.Schemas.untitled||le.forceUntitled===!0:!1}function t(ie){if($(ie))return!1;const le=ie;return M.URI.isUri(le?.base?.resource)&&M.URI.isUri(le?.input1?.resource)&&M.URI.isUri(le?.input2?.resource)&&M.URI.isUri(le?.result?.resource)}var p;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var u;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class o{constructor(){this.a=new Map}registerSource(le,V){let ee=this.a.get(le);return ee||(ee={source:le,label:V},this.a.set(le,ee)),ee.source}getSourceLabel(le){return this.a.get(le)?.label??le}}e.$_E=new o;var v;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad",ie[ie.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class b extends O.$Tc{}e.$aF=b;function $(ie){return ie instanceof b}function I(ie){const le=ie;return M.URI.isUri(le?.preferredResource)}function g(ie){const le=ie;return $(le?.primary)&&$(le?.secondary)}function D(ie){const le=ie;return $(le?.modified)&&$(le?.original)}function y(ie,le,V,ee,ke){return $e(ee,[(0,E.$3i)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Ne={...V,limits:{size:Number.MAX_VALUE}};ie.openEditor(le,Ne)}}),(0,E.$3i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function P(ie){return $(ie?.editor)}function A(ie){const le=ie;return P(ie)&&le?.group!==void 0}function G(ie){const le=ie;return typeof le?.groupId=="number"&&$(le.editor)}var W;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var U;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class T{getOriginalUri(le,V){if(!le)return;if(t(le))return e.$jF.getOriginalUri(le.result,V);if(V?.supportSideBySide){const{primary:ke,secondary:Ne}=this.a(le);if(ke&&Ne){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(ke,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:V.filterByScheme});le=V.supportSideBySide===C.PRIMARY?ke:Ne}}if(i(le)||n(le)||c(le)||t(le))return;const ee=I(le)?le.preferredResource:le.resource;return!ee||!V||!V.filterByScheme?ee:this.b(ee,V.filterByScheme)}a(le){return g(le)||c(le)?{primary:le.primary,secondary:le.secondary}:D(le)||i(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,V){if(!le)return;if(t(le))return e.$jF.getCanonicalUri(le.result,V);if(V?.supportSideBySide){const{primary:ke,secondary:Ne}=this.a(le);if(ke&&Ne){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(ke,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:V.filterByScheme});le=V.supportSideBySide===C.PRIMARY?ke:Ne}}if(i(le)||n(le)||c(le)||t(le))return;const ee=le.resource;return!ee||!V||!V.filterByScheme?ee:this.b(ee,V.filterByScheme)}b(le,V){if(Array.isArray(V)){if(V.some(ee=>le.scheme===ee))return le}else if(V===le.scheme)return le}}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(q||(e.EditorCloseMethod=q={}));function ne(ie,le,V,ee){if(!ie.isSticky(le))return!1;switch(ee.preventPinnedEditorClose){case"keyboardAndMouse":return V===q.MOUSE||V===q.KEYBOARD;case"mouse":return V===q.MOUSE;case"keyboard":return V===q.KEYBOARD}return!1}e.$jF=new T;var ce;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(le){const V=this.a=le.get(R.$fi);for(const[ee,ke]of this.c)this.e(ee,ke,V);this.c.clear()}e(le,V,ee){const ke=ee.createInstance(V);this.d.set(le,ke)}registerFileEditorFactory(le){if(this.b)throw new Error("Can only register one file editor factory.");this.b=le}getFileEditorFactory(){return(0,F.$5f)(this.b)}registerEditorSerializer(le,V){if(this.c.has(le)||this.d.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.a?this.e(le,V,this.a):this.c.set(le,V),(0,O.$Rc)(()=>{this.c.delete(le),this.d.delete(le)})}getEditorSerializer(le){return this.d.get(typeof le=="string"?le:le.typeId)}}m.$Yn.add(e.$YE.EditorFactory,new ye);async function Ie(ie,le,V){return!ie||!ie.length?[]:await Promise.all(ie.map(async ee=>{const ke=M.URI.revive(ee.fileUri);if(!ke){V.info("Cannot resolve the path because it is not valid.",ee);return}if(!await le.canHandleResource(ke)){V.info("Cannot resolve the path because it cannot be handled",ee);return}let Se=ee.exists,be=ee.type;if(typeof Se!="boolean"||typeof be!="number")try{be=(await le.stat(ke)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Se=!0}catch(J){V.error(J),Se=!1}if(!Se&&ee.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ee);return}if(be===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ee);return}const ge={...ee.options,pinned:!0};return Se?{resource:ke,options:ge}:{resource:ke,options:ge,forceUntitled:!0}}))}var ue;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ve(ie){const le=ie;if(!le)return!1;const V=le;if(V.modified)return ve(V.modified);const ee=le;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}function re(ie){return(0,N.$5i)(ie)}function $e(ie,le,V){const ee=(0,N.$6i)(ie,le);return ee.forceMessage=V?.forceMessage,ee.forceSeverity=V?.forceSeverity,ee.allowDialog=V?.allowDialog,ee}}),define(Pe[209],Me([1,0,5,176,3,6,28,30,18,26,91,200]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$tF=e.ViewContentGroups=e.$rF=e.ViewContainerLocation=e.Extensions=e.$qF=e.$pF=e.$oF=void 0,e.$sF=d,e.$oF="views",e.$pF=(0,F.localize)(0,null),e.$qF=(0,E.$Qw)("default-view-icon",N.$Fj.window,(0,F.localize)(1,null));var l;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var w;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$rF=[0,1,2];function d(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$6d),this.onDidRegister=this.c.event,this.f=this.B(new S.$6d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(u,o,v){const b=this.get(u.id);if(b)return b;const $=u;return $.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,o,[]).push($),v?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:o}),$}deregisterViewContainer(u){for(const o of this.g.keys()){const v=this.g.get(o),b=v?.indexOf(u);if(b!==-1){v?.splice(b,1),v.length===0&&this.g.delete(o),this.f.fire({viewContainer:u,viewContainerLocation:o});return}}}get(u){return this.all.filter(o=>o.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(o=>this.getViewContainerLocation(o)===u)}}m.$Yn.add(l.ViewContainersRegistry,new s);var a;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(a||(e.ViewContentGroups=a={}));function r(p,u){const o=p.group??a.More,v=u.group??a.More;return o!==v?o.localeCompare(v):(p.order??5)-(u.order??5)}class i extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$6d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$6d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$6d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$6d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,o){this.registerViews2([{views:u,viewContainer:o}])}registerViews2(u){u.forEach(({views:o,viewContainer:v})=>this.r(o,v)),this.c.fire(u)}deregisterViews(u,o){const v=this.s(u,o);v.length&&this.f.fire({views:v,viewContainer:o})}moveViews(u,o){for(const v of this.m.keys())if(v!==o){const b=this.s(u,v);b.length&&(this.r(b,o),this.g.fire({views:b,from:v,to:o}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const o of this.j){const v=(this.m.get(o)||[]).filter(b=>b.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const o of this.j)if((this.m.get(o)||[]).filter(b=>b.id===u)[0])return o;return null}registerViewWelcomeContent(u,o){return this.n.add(u,o),this.h.fire(u),(0,O.$Rc)(()=>{this.n.delete(u,o),this.h.fire(u)})}registerViewWelcomeContent2(u,o){const v=new Map;for(const[b,$]of o)this.n.add(u,$),v.set(b,(0,O.$Rc)(()=>{this.n.delete(u,$),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const o=[];return this.n.forEach(u,v=>o.push(v)),o.sort(r)}r(u,o){let v=this.m.get(o);v||(v=[],this.m.set(o,v),this.j.push(o));for(const b of u){if(this.getView(b.id)!==null)throw new Error((0,F.localize)(2,null,b.id));v.push(b)}}s(u,o){const v=this.m.get(o);if(!v)return[];const b=[],$=[];for(const I of v)u.includes(I)?b.push(I):$.push(I);return b.length&&($.length?this.m.set(o,$):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),b}}m.$Yn.add(l.ViewsRegistry,new i),e.$tF=(0,M.$gi)("viewDescriptorService");var n;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,o){this.c=!1,this.d=!1,(0,k.$Pn)(this,u),this.d=!!o,this.resolve=async v=>{if(o&&!this.c){const b=await o(v);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$uF=h;class t extends Error{constructor(u){super((0,F.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$vF=t}),define(Pe[210],Me([1,0,2,29,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$DF=O,e.$EF=R;function O(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof S.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(F.$$s.isIRange)}function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(O)}var m;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$FF=(0,M.$gi)("IChatService"),e.$GF="accessibility.voice.keywordActivation"}),define(Pe[211],Me([1,0,5,11,177]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new S.$6d,this.o=new S.$6d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,f,k,N){const E={command:m};if(f&&Object.keys(f).length>0&&(E.arguments=f),this.u("request",E),typeof N=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.f.get(E.seq);if(w){this.f.delete(E.seq);const d={type:"response",seq:0,request_seq:E.seq,success:!1,command:m,message:(0,M.localize)(0,null,N,m)};w(d)}},N)}return k&&this.f.set(E.seq,k),E.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,f){return m.type!=="event"||f.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,F.$hh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const f=m,k=this.f.get(f.request_seq);k&&(this.f.delete(f.request_seq),k(f));break}}}}u(m,f){f.type=m,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((f,k)=>m.set(k,f)),await(0,F.$hh)(500),m.forEach((f,k)=>{f({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$3nb=O}),define(Pe[212],Me([1,0,2,178,35,3]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$JI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$II=e.MemoryRangeType=e.State=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=void 0,e.$HI=f,e.$wH="workbench.view.debug",e.$xH="workbench.debug.variablesView",e.$yH="workbench.debug.watchExpressionsView",e.$zH="workbench.debug.callStackView",e.$AH="workbench.debug.loadedScriptsView",e.$BH="workbench.debug.breakPointsView",e.$CH="workbench.debug.disassemblyView",e.$DH="workbench.panel.repl",e.$EH="workbench.panel.repl.view",e.$FH=new M.$xj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$GH=new M.$xj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$HH=new M.$xj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$IH="debugUx",e.$JH=new M.$xj(e.$IH,"default",{type:"string",description:F.localize(3,null)}),e.$KH=new M.$xj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$LH=new M.$xj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$MH=new M.$xj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$NH=new M.$xj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$OH=new M.$xj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$PH=new M.$xj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$QH=new M.$xj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$RH=new M.$xj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$SH=new M.$xj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$TH=new M.$xj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$UH=new M.$xj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$VH=new M.$xj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$WH=new M.$xj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$XH=new M.$xj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$YH=new M.$xj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$ZH=new M.$xj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$1H=new M.$xj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$2H=new M.$xj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$3H=new M.$xj("breakpointItemBytes",void 0,{type:"boolean",description:F.localize(22,null)}),e.$4H=new M.$xj("breakpointHasModes",!1,{type:"boolean",description:F.localize(23,null)}),e.$5H=new M.$xj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(24,null)}),e.$6H=new M.$xj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(25,null)}),e.$7H=new M.$xj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(26,null)}),e.$8H=new M.$xj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(27,null)}),e.$9H=new M.$xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(28,null)}),e.$0H=new M.$xj("stepBackSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.$$H=new M.$xj("restartFrameSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.$_H=new M.$xj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(31,null)}),e.$aI=new M.$xj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.$bI=new M.$xj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(33,null)}),e.$cI=new M.$xj("breakpointsExist",!1,{type:"boolean",description:F.localize(34,null)}),e.$dI=new M.$xj("debuggersAvailable",!1,{type:"boolean",description:F.localize(35,null)}),e.$eI=new M.$xj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(36,null)}),e.$fI=new M.$xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(37,null)}),e.$gI=new M.$xj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$hI=new M.$xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$iI=new M.$xj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$jI=new M.$xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$kI=new M.$xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$lI=new M.$xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.$mI=new M.$xj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(44,null)}),e.$nI=new M.$xj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(45,null)}),e.$oI=new M.$xj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(46,null)}),e.$pI=new M.$xj("variableIsReadonly",!1,{type:"boolean",description:F.localize(47,null)}),e.$qI=new M.$xj("variableValue",!1,{type:"string",description:F.localize(48,null)}),e.$rI=new M.$xj("variableType",!1,{type:"string",description:F.localize(49,null)}),e.$sI=new M.$xj("variableName",!1,{type:"string",description:F.localize(50,null)}),e.$tI=new M.$xj("variableLanguage",!1,{type:"string",description:F.localize(51,null)}),e.$uI=new M.$xj("variableExtensionId",!1,{type:"string",description:F.localize(52,null)}),e.$vI=new M.$xj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(53,null)}),e.$wI=new M.$xj("multiSessionRepl",!1,{type:"boolean",description:F.localize(54,null)}),e.$xI=new M.$xj("multiSessionDebug",!1,{type:"boolean",description:F.localize(55,null)}),e.$yI=new M.$xj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(56,null)}),e.$zI=new M.$xj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(57,null)}),e.$AI=new M.$xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(58,null)}),e.$BI=new M.$xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(59,null)});const R=i=>F.localize(60,null,i);e.$CI=R,e.$DI="editor.contrib.debug",e.$EI="editor.contrib.breakpoint",e.$FI="debug",e.$GI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(61,null)};var m;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(m||(e.State=m={}));function f(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$II="vscode-debug-memory";var N;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(N||(e.DataBreakpointSetType=N={}));var E;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(E||(e.DebugConfigurationProviderTriggerKind=E={}));var l;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(l||(e.DebuggerString=l={})),e.$JI=(0,O.$gi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var d;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(d||(e.DebugVisualizationType=d={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var a;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(a||(e.IDebugVisualizationTreeItem=a={}));var r;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(r||(e.IDebugVisualization=r={}))}),define(Pe[213],Me([1,0,15,2,19,26,12,29,25,18]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=void 0,e.$yG=E,e.$zG=l,e.$AG=w,e.$BG=d,e.$CG=s,e.$DG=a,e.$EG=r,e.$FG=n,e.$GG=t,e.$HG=p,e.$IG=o,e.$JG=b;const N=/{([^}]+)}/g;function E(I,g,D){return I.replace(N,function(y,P){return g&&P.length>0&&P[0]!=="_"?y:D&&D.hasOwnProperty(P)?D[P]:y})}function l(I){const g={};for(const D of Object.keys(I))D.startsWith("!")||(g[D]=I[D]);return g}function w(I){return I.configuration.request==="attach"&&!d(I)&&(!I.parentSession||w(I.parentSession))}function d(I){let g=I.configuration.type;if(g)return g==="vslsShare"&&(g=I.configuration.adapterProxy.configuration.type),(0,S.$kf)(g,"extensionhost")||(0,S.$kf)(g,"pwa-extensionhost")?I:I.parentSession?d(I.parentSession):void 0}function s(I){return I.type&&(I.label||I.program||I.runtime)}function a(I,g,D){let y,P=0;const A=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=A.exec(I);){const W=G.index+1,U=W+G[0].length;if(W<=g&&U>=D){y=G[0],P=W;break}}if(y){const W=/\w+/g;let U=null;for(;(U=W.exec(y))&&!(U.index+1+P+U[0].length>=D););U&&(y=y.substring(0,W.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}async function r(I,g,D,y){if(I.evaluatableExpressionProvider.has(g)){const P=I.evaluatableExpressionProvider.ordered(g),A=(0,k.$Hb)(await Promise.all(P.map(async G=>{try{return await G.provideEvaluatableExpression(g,D,y??f.CancellationToken.None)}catch{return}})));if(A.length>0){let G=A[0].expression;const W=A[0].range;return G||(G=g.getLineContent(D.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const P=g.getLineContent(D.lineNumber),{start:A,end:G}=a(P,D.column,D.column),W=P.substring(A-1,G);return{matchingExpression:W,range:new m.$$s(D.lineNumber,A,D.lineNumber,A+W.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(i))}function c(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return F.URI.parse(I.path);if((0,M.$ic)(I.path))return F.URI.file(I.path)}return I.path}function h(I){if(typeof I.path=="object"){const g=F.URI.revive(I.path);if(g)return g.scheme===R.Schemas.file?g.fsPath:g.toString()}return I.path}function t(I,g){const D=g?c:h,y=(0,O.$Mn)(I);return u(y,(P,A)=>{P&&A&&(A.path=D(A))}),y}function p(I,g){const D=g?c:h,y=(0,O.$Mn)(I);return u(y,(P,A)=>{!P&&A&&(A.path=D(A))}),y}function u(I,g){switch(I.type){case"event":{const D=I;switch(D.event){case"output":g(!1,D.body.source);break;case"loadedSource":g(!1,D.body.source);break;case"breakpoint":g(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=I;switch(D.command){case"setBreakpoints":g(!0,D.arguments.source);break;case"breakpointLocations":g(!0,D.arguments.source);break;case"source":g(!0,D.arguments.source);break;case"gotoTargets":g(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const D=I;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":D.body.sources.forEach(y=>g(!1,y));break;case"scopes":D.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":D.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":D.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function o(I){return I.filter(g=>!g.presentation?.hidden).sort((g,D)=>g.presentation?D.presentation?g.presentation.group?D.presentation.group?g.presentation.group!==D.presentation.group?g.presentation.group.localeCompare(D.presentation.group):v(g.presentation.order,D.presentation.order):-1:D.presentation.group?1:v(g.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function v(I,g){return typeof I!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:I-g}async function b(I,g){const D=I.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(D!=="none"&&(await g.saveAll(),D==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}const $=(I,g)=>!I||!g?I===g:I.name===g.name&&I.path===g.path&&I.sourceReference===g.sourceReference;e.$KG=$}),define(Pe[214],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.CellExecutionUpdateType=void 0;var F;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$dK=(0,S.$gi)("INotebookExecutionService")}),define(Pe[215],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghb=e.$fhb=e.ProxyKernelState=e.$ehb=void 0,e.$ehb=100;var F;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$fhb=(0,S.$gi)("INotebookKernelService"),e.$ghb=(0,S.$gi)("INotebookKernelHistoryService")}),define(Pe[216],Me([1,0,6,29,147,95]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RTb=void 0;class R extends S.$Tc{constructor(f,k,N){super(),this._source=f,this.b=k,this.c=N,this.a=void 0}f(f){const k=f.getLineCount();return new F.$$s(1,1,k,this.g(f,k))}g(f,k){if(k<1||k>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const f=new M.$vC;f.acceptChunk(this._source);const k=f.finish(!0),{textBuffer:N,disposable:E}=k.create(1);this.b=N,this.B(E)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const k=new M.$vC;k.acceptChunk(f);const N=k.finish(!0),{textBuffer:E,disposable:l}=N.create(1);return this.B(l),E})),this.a}findInInputs(f){const N=new O.$jC(f,!1,!1,null).parseSearchRequest();if(!N)return[];const E=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(E,N,!0,5e3)}findInOutputs(f){const N=new O.$jC(f,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(E=>{const l=E.findMatchesLineByLine(this.f(E),N,!0,5e3);if(l.length!==0)return{textBuffer:E,matches:l}}).filter(E=>!!E):[]}}e.$RTb=R}),define(Pe[48],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(O){O.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class M{static fromExtHostTestItem(R,m,f=R.parent){if(R._isRoot)return new M([m]);const k=[R.id];for(let N=f;N&&N.id!==m;N=N.parent)k.push(N.id);return k.push(m),new M(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new M(R.split("\0"))}static join(R,m){return new M([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:M.isChild(R,m)?2:M.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$3K=M}),define(Pe[60],Me([1,0,2,93,29,48]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$$K=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$0K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$9K=e.$8K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$7K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$6K=e.$5K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$4K=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$4K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$5K=[2,4,8,16,32,64];const k=C=>"runId"in C;e.$6K=k;var N;(function(C){C.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),C.deserialize=(T,q)=>({range:M.$$s.lift(q.range),uri:T.asCanonicalUri(S.URI.revive(q.uri))})})(N||(e.IRichLocation=N={}));var E;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(E||(e.TestMessageType=E={}));var l;(function(C){C.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&N.serialize(T.location)}),C.deserialize=(T,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&N.deserialize(T,q.location)})})(l||(e.ITestErrorMessage=l={}));const w=(C,T)=>`${T?"s":"e"}${C}`;e.$7K=w;var d;(function(C){C.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&N.serialize(T.location)}),C.deserialize=(T,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&N.deserialize(T,q.location)})})(d||(e.ITestOutputMessage=d={}));var s;(function(C){C.serialize=T=>T.type===0?l.serialize(T):d.serialize(T),C.deserialize=(T,q)=>q.type===0?l.deserialize(T,q):d.deserialize(T,q)})(s||(e.ITestMessage=s={}));var a;(function(C){C.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),C.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(s.serialize)}),C.deserialize=(T,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(ne=>s.deserialize(T,ne))})})(a||(e.ITestTaskState=a={}));const r="\0",i=(C,T)=>C+r+T;e.$8K=i;const n=C=>{const T=C.indexOf(r);return{ctrlId:C.slice(0,T),tagId:C.slice(T+1)}};e.$9K=n;var c;(function(C){C.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),C.deserialize=(T,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?T.asCanonicalUri(S.URI.revive(q.uri)):void 0,range:q.range?M.$$s.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(C){C.serialize=T=>({expand:T.expand,item:c.serialize(T.item)}),C.deserialize=(T,q)=>({controllerId:O.$3K.root(q.item.extId),expand:q.expand,item:c.deserialize(T,q.item)})})(t||(e.InternalTestItem=t={}));var p;(function(C){C.serialize=T=>{let q;return T.item&&(q={},T.item.label!==void 0&&(q.label=T.item.label),T.item.tags!==void 0&&(q.tags=T.item.tags),T.item.busy!==void 0&&(q.busy=T.item.busy),T.item.uri!==void 0&&(q.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(q.range=T.item.range?.toJSON()),T.item.description!==void 0&&(q.description=T.item.description),T.item.error!==void 0&&(q.error=T.item.error),T.item.sortText!==void 0&&(q.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:q}},C.deserialize=T=>{let q;return T.item&&(q={},T.item.label!==void 0&&(q.label=T.item.label),T.item.tags!==void 0&&(q.tags=T.item.tags),T.item.busy!==void 0&&(q.busy=T.item.busy),T.item.range!==void 0&&(q.range=T.item.range?M.$$s.lift(T.item.range):null),T.item.description!==void 0&&(q.description=T.item.description),T.item.error!==void 0&&(q.error=T.item.error),T.item.sortText!==void 0&&(q.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:q}}})(p||(e.ITestItemUpdate=p={}));const u=(C,T)=>{T.expand!==void 0&&(C.expand=T.expand),T.item!==void 0&&(C.item=C.item?Object.assign(C.item,T.item):T.item)};e.$0K=u;var o;(function(C){C.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(a.serializeWithoutMessages)}),C.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(a.serialize)}),C.deserialize=(T,q)=>({...t.deserialize(T,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(ne=>a.deserialize(T,ne)),retired:!0})})(o||(e.TestResultItem=o={}));var v;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(T,q)=>{T.covered+=q.covered,T.total+=q.total}})(v||(e.ICoveredCount=v={}));var b;(function(C){C.serialize=T=>({statement:T.statement,branch:T.branch,declaration:T.declaration,details:T.details?.map(D.serialize),uri:T.uri.toJSON()}),C.deserialize=(T,q)=>({statement:q.statement,branch:q.branch,declaration:q.declaration,details:q.details?.map(D.deserialize),uri:T.asCanonicalUri(S.URI.revive(q.uri))})})(b||(e.IFileCoverage=b={}));function $(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?F.$0s.isIPosition(C.location)?F.$0s.lift(C.location):M.$$s.lift(C.location):void 0,C}e.$$K=3;var g;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(g||(e.DetailType=g={}));var D;(function(C){C.serialize=T=>T.type===0?P.serialize(T):A.serialize(T),C.deserialize=T=>T.type===0?P.deserialize(T):A.deserialize(T)})(D||(e.CoverageDetails=D={}));var y;(function(C){C.serialize=$,C.deserialize=I})(y||(e.IBranchCoverage=y={}));var P;(function(C){C.serialize=$,C.deserialize=I})(P||(e.IDeclarationCoverage=P={}));var A;(function(C){C.serialize=T=>({...$(T),branches:T.branches?.map(y.serialize)}),C.deserialize=T=>({...I(T),branches:T.branches?.map(y.deserialize)})})(A||(e.IStatementCoverage=A={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(C){C.deserialize=(T,q)=>q.op===0?{op:q.op,item:t.deserialize(T,q.item)}:q.op===1?{op:q.op,item:p.deserialize(q.item)}:q.op===2?{op:q.op,uri:T.asCanonicalUri(S.URI.revive(q.uri)),docv:q.docv}:q,C.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:p.serialize(T.item)}:T})(W||(e.TestsDiffOp=W={}));class U{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const q=this.v();for(const ne of T)switch(ne.op){case 0:this.l(t.deserialize(this.k,ne.item),q);break;case 1:this.o(p.deserialize(ne.item),q);break;case 3:this.p(ne.itemId,q);break;case 5:this.q(ne.itemId);break;case 4:this.updatePendingRoots(ne.amount);break;case 6:this.c.set(ne.tag.id,ne.tag);break;case 7:this.c.delete(ne.id);break}q.complete?.()}l(T,q){const ne=O.$3K.parentId(T.item.extId)?.toString();let ce;if(!ne)ce=this.w(T),this.g.add(ce),this.f.set(T.item.extId,ce);else if(this.f.has(ne)){const ye=this.f.get(ne);ye.children.add(T.item.extId),ce=this.w(T,ye),this.f.set(T.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return q.add?.(ce),T.expand===2&&this.h++,ce}o(T,q){const ne=this.f.get(T.extId);if(ne)return T.expand!==void 0&&(ne.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$0K)(ne,T),q.update?.(ne),ne}p(T,q){const ne=this.f.get(T);if(!ne)return;const ce=O.$3K.parentId(ne.item.extId)?.toString();ce?this.f.get(ce).children.delete(ne.item.extId):this.g.delete(ne);const ye=[[T]];for(;ye.length;)for(const Ie of ye.pop()){const ue=this.f.get(Ie);ue&&(ye.push(ue.children),this.f.delete(Ie),q.remove?.(ue,ue!==ne),ue.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$_K=U}),define(Pe[75],Me([1,0,11,5,6,55,60,48]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.TestItemEventOp=void 0;var f;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const k=(i,n)=>i===n,E=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),l=(i,n)=>{let c;for(const[h,t]of E)t(i[h],n[h])||(c?c[h]=n[h]:c={[h]:n[h]});return c};class w extends M.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new S.$sh(()=>this.flushDiff(),200)),this.g=this.B(new F.$6d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,R.$0K)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,R.$0K)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const h=this.tree.get(n);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(m.$3K.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const h of c.ops)this.w(n,h);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,O.$9c)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const h=m.$3K.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let p=this.tree.get(h.toString());if(!p){p={fullId:h,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(p.fullId.toString(),p),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:p.expand,item:this.s.toITestItem(n)}}),this.I(n,p,c);return}if(p.actual===n){this.H(n,p,c);return}if(p.actual.uri?.toString()!==n.uri?.toString())return this.O(h.toString()),this.z(n,c);const u=this.s.getChildren(p.actual),o=p.actual,v=l(this.s.toITestItem(o),this.s.toITestItem(n));this.s.getApiFor(o).listener=void 0,p.actual=n,p.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(n.tags,o.tags,h.toString()),delete v.tags),this.w(p,{op:4,update:v})),this.I(n,p,c);for(const[b,$]of u)this.s.getChildren(n).get($.id)||this.O(m.$3K.joinToString(h,$.id));this.y(p.actual.uri)}C(n,c,h){const t=new Set(c.map(p=>p.id));for(const p of n)t.delete(p.id)||this.D(p);this.pushDiff({op:1,item:{extId:h,item:{tags:n.map(p=>(0,R.$8K)(this.s.controllerId,p.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$8K)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$8K)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,h){this.G(n,h);const t=this.s.getApiFor(n);t.parent=h?.actual,t.listener=p=>this.w(c,p),this.J(c)}I(n,c,h){this.H(n,c,h);for(const[t,p]of this.s.getChildren(n))this.z(p,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const h=[];for(const[t,p]of this.s.getChildren(n.actual)){const u=this.expand(m.$3K.joinToString(n.fullId,p.id),c);(0,S.$5g)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const p=new S.$fh;return p.open(),p}n.expand=2,this.N(n);const c=n.resolveBarrier=new S.$fh,h=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,p)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(p){h(p)}return(0,S.$5g)(t)?t.catch(h).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const p of t.actual.tags)this.F(p.id);this.tree.delete(t.fullId.toString());for(const[p,u]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$3K.joinToString(t.fullId,u.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$nO=w;class d extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$oO=d;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pO=s;class a extends Error{constructor(n,c,h){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$qO=a;const r=(i,n,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,p){for(const u of h.values())t.call(p,u,this)},[Symbol.iterator](){return h.entries()},replace(t){const p=new Map,u=new Set(h.keys()),o={op:5,ops:[]};for(const v of t){if(!(v instanceof c))throw new s(v.id);const b=n(v).controllerId;if(b!==i.controllerId)throw new a(v.id,b,i.controllerId);if(p.has(v.id))throw new d(v.id);p.set(v.id,v),u.delete(v.id),o.ops.push({op:0,item:v})}for(const v of u.keys())o.ops.push({op:3,id:v});i.listener?.(o),h=p},add(t){if(!(t instanceof c))throw new s(t.id);h.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){h.delete(t)&&i.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$rO=r}),define(Pe[105],Me([1,0,75]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=e.$sO=void 0;const F=new WeakMap,M=(R,m)=>{const f={controllerId:m};return F.set(R,f),f};e.$sO=M;const O=R=>{const m=F.get(R);if(!m)throw new S.$pO(R?.id||"<unknown>");return m};e.$tO=O}),define(Pe[76],Me([1,0,12,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xxb=e.$Wxb=e.$Vxb=void 0,e.$Yxb=M,e.$Zxb=R,e.$Vxb="vscode-cdn.net",e.$Wxb=`vscode-resource.${e.$Vxb}`,e.$Xxb=`'self' https://*.${e.$Vxb}`;function M(m,f){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===S.Schemas.file&&(m=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:m.path})),F.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${O(m.authority)}.${e.$Wxb}`,path:m.path,fragment:m.fragment,query:m.query}))}function O(m){return m.replace(/./g,f=>{const k=f.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?f:"-"+k.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(f,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Pe[217],Me([1,0,5,6,76]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class O{constructor(m,f,k){this.d=m,this.e=f,this.f=k,this.a=0,this.b=new F.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const N=f.getVisibleTextEditors();for(const E of this.c.values())N.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,f,k,N,E){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===m){l=n;break}if(!l)throw new Error("not a visible editor");const w=this,d=this.a++,s=new S.$6d,a=new S.$6d,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,M.$Yxb)(n,w.f)}get cspSource(){return M.$Xxb}set options(n){this.b=n,w.d.$setOptions(d,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(d,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return w.d.$postMessage(d,n)}},i=new class{constructor(){this.editor=m,this.line=f,this.height=k,this.webview=r,this.onDidDispose=a.event}dispose(){w.c.has(d)&&(w.c.delete(d),w.d.$disposeEditorInset(d),a.fire(),a.dispose(),s.dispose())}};return this.d.$createEditorInset(d,l.id,l.value.document.uri,f+1,k,N||{},E.identifier,E.extensionLocation),this.c.set(d,{editor:m,inset:i,onDidReceiveMessage:s}),i}$onDidDispose(m){const f=this.c.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this.c.get(m)?.onDidReceiveMessage.fire(f)}}e.$Kic=O}),define(Pe[106],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$hL=e.$gL=void 0,e.$gL="__",e.$hL=(0,S.$gi)("IAuthenticationService"),e.$iL=(0,S.$gi)("IAuthenticationExtensionsService")}),define(Pe[218],Me([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.VariableKind=e.$jP=void 0,e.$jP=(0,S.$gi)("configurationResolverService");var F;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class M extends Error{constructor(R,m){super(m),this.variable=R}}e.$kP=M}),define(Pe[219],Me([1,0,19,73,16,26,21,96,181,218,15]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,d,s,a){this.h=new Map,this.a=w,this.b=d,this.g=s,a&&(this.c=a.then(r=>this.i(r)))}i(w){if(R.$i){const d=Object.create(null);return Object.keys(w).forEach(s=>{d[s.toLowerCase()]=w[s]}),d}return w}resolveWithEnvironment(w,d,s){return this.l({env:this.i(w),userHome:void 0},d?d.uri:void 0,s)}async resolveAsync(w,d){const s={env:await this.c,userHome:await this.g};return this.l(s,w?w.uri:void 0,d)}async j(w,d,s,a){const r=O.$Mn(d);R.$i&&r.windows?Object.keys(r.windows).forEach(n=>r[n]=r.windows[n]):R.$j&&r.osx?Object.keys(r.osx).forEach(n=>r[n]=r.osx[n]):R.$k&&r.linux&&Object.keys(r.linux).forEach(n=>r[n]=r.linux[n]),delete r.windows,delete r.osx,delete r.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,w?w.uri:void 0,r,s,a)}async resolveAnyAsync(w,d,s){return this.j(w,d,s)}async resolveAnyMap(w,d,s){const a=new Map;return{newConfig:await this.j(w,d,s,a),resolvedVariables:a}}resolveWithInteractionReplace(w,d,s,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,d,s,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,d){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,d)}async l(w,d,s,a,r){if(M.$Tf(s))return this.m(w,d,s,a,r);if(Array.isArray(s))return Promise.all(s.map(i=>this.l(w,d,i,a,r)));if(M.$Vf(s)){const i=Object.create(null),n=await Promise.all(Object.keys(s).map(async c=>[await this.m(w,d,c,a,r),await this.l(w,d,s[c],a,r)]));for(const[c,h]of n)i[c]=h;return i}return s}m(w,d,s,a,r){return(0,N.$cf)(s,E.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(E.VARIABLE_LHS))return i;let c=await this.o(w,i,n,d,a);return r?.set(n,c),c!==i&&M.$Tf(c)&&c.match(E.VARIABLE_REGEXP)&&(c=await this.m(w,d,c,a,r)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,d,s,a,r){let i;const n=s.split(":");n.length>1&&(s=n[0],i=n[1]);const c=p=>{const u=this.a.getFilePath();if(u)return(0,m.$dw)(u);throw new k.$kP(p,(0,f.localize)(0,null,d))},h=p=>{const u=c(p);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,m.$dw)(o)}throw new k.$kP(p,(0,f.localize)(1,null,d,S.$nc(u)))},t=p=>{if(i){const u=this.a.getFolderUri(i);if(u)return u;throw new k.$kP(p,(0,f.localize)(2,null,d,i))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new k.$kP(p,(0,f.localize)(3,null,d)):new k.$kP(p,(0,f.localize)(4,null,d))};switch(s){case"env":if(i){if(w.env){const p=w.env[R.$i?i.toLowerCase():i];if(M.$Tf(p))return p}return""}throw new k.$kP(k.VariableKind.Env,(0,f.localize)(5,null,d));case"config":if(i){const p=this.a.getConfigurationValue(a,i);if(M.$3f(p))throw new k.$kP(k.VariableKind.Config,(0,f.localize)(6,null,d,i));if(M.$Vf(p))throw new k.$kP(k.VariableKind.Config,(0,f.localize)(7,null,d,i));return p}throw new k.$kP(k.VariableKind.Config,(0,f.localize)(8,null,d));case"command":return this.p(k.VariableKind.Command,d,i,r,"command");case"input":return this.p(k.VariableKind.Input,d,i,r,"input");case"extensionInstallFolder":if(i){const p=await this.a.getExtension(i);if(!p)throw new k.$kP(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,d,i));return this.n(p.extensionLocation)}throw new k.$kP(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,d));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,m.$dw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return a||i?(0,m.$dw)(this.n(t(k.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$dw)(S.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new k.$kP(k.VariableKind.UserHome,(0,f.localize)(11,null,d))}case"lineNumber":{const p=this.a.getLineNumber();if(p)return p;throw new k.$kP(k.VariableKind.LineNumber,(0,f.localize)(12,null,d))}case"selectedText":{const p=this.a.getSelectedText();if(p)return p;throw new k.$kP(k.VariableKind.SelectedText,(0,f.localize)(13,null,d))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||i?S.$lc(this.n(t(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const p=S.$mc(c(k.VariableKind.RelativeFileDirname));if(a||i){const u=S.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),p);return u.length===0?".":u}return p}case"fileDirname":return S.$mc(c(k.VariableKind.FileDirname));case"fileExtname":return S.$oc(c(k.VariableKind.FileExtname));case"fileBasename":return S.$nc(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const p=S.$nc(c(k.VariableKind.FileBasenameNoExtension));return p.slice(0,p.length-S.$oc(p).length)}case"fileDirnameBasename":return S.$nc(S.$mc(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const p=this.a.getExecPath();return p||d}case"execInstallFolder":{const p=this.a.getAppRoot();return p||d}case"pathSeparator":case"/":return S.sep;default:try{const p=i?`${s}:${i}`:s;return this.p(k.VariableKind.Unknown,d,p,r,void 0)}catch{return d}}}}p(w,d,s,a,r){if(s&&a){const i=r===void 0?a[s]:a[r+":"+s];if(typeof i=="string")return i;throw new k.$kP(w,(0,f.localize)(14,null,d))}return d}}e.$zP=E}),define(Pe[107],Me([1,0,3,104]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rD=void 0,e.$sD=k,e.$tD=l,e.$uD=w,e.$rD=(0,S.$gi)("editorGroupsService");var M;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var R;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function k(d){const s=d;return(0,F.$bF)(s?.editor)&&(0,F.$bF)(s?.replacement)}var N;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var E;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function l(d){const s=d;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function w(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[220],Me([1,0,3,107]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yD=e.$xD=e.$wD=e.$vD=void 0,e.$zD=M,e.$vD=(0,S.$gi)("editorService"),e.$wD=-1,e.$xD=-2,e.$yD=-3;function M(O){const R=O;return typeof O=="number"||(0,F.$tD)(R)}}),define(Pe[221],Me([1,0,3,188]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=void 0,e.$BL=(0,S.$hi)(F.$ni)}),define(Pe[108],Me([1,0,20,5,19,6,11]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=e.$p0b=e.$o0b=e.$n0b=e.$m0b=void 0;class m{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$m0b=m;class f{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const h=c.getExtensionDescription(i);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(i,n){this.j=i,this.c=new F.$6d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new S.$Dm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=a(this.e,n),this.e=this.e.concat(i);const c=f.l(this.e);return this.e=a(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,o){this.addNode(u),this.addNode(o),this.c.has(u)?this.c.get(u).push(o):this.c.set(u,[o])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,o){const v=n.getArcs(u);for(let b=0;b<v.length;b++)if(!o.has(v[b]))return!1;return!0}getNodes(){return this.e}},c=new S.$Dm;for(const u of i)if(c.set(u.identifier,u),u.extensionDependencies)for(const o of u.extensionDependencies)n.addArc(S.$Bm.toKey(u.identifier),S.$Bm.toKey(o));const h=new Set;n.getNodes().filter(u=>n.getArcs(u).length===0).forEach(u=>h.add(u));const t=n.getNodes().filter(u=>!h.has(u));let p;do{p=!1;for(let u=0;u<t.length;u++){const o=t[u];n.hasOnlyGoodArcs(o,h)&&(t.splice(u,1),u--,h.add(o),p=!0)}}while(p);return t.map(u=>c.get(u))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$n0b=f;class k{constructor(i,n){this.versionId=i,this.extensions=n}}e.$o0b=k;class N{constructor(i){this.d=new w,this.c=new f(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new E(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$p0b=N;class E extends O.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$q0b=E;class l{constructor(i){this.name=i;const n=(0,R.$_g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class w{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new l(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,O.$Rc)(h))}}var d;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(d||(d={}));function s(r,i){const n=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const h=M.$gc.basename(r.extensionLocation.path),t=M.$gc.basename(i.extensionLocation.path);return h<t?-1:h>t?1:0}function a(r,i){const n=new S.$Cm(i);return r.filter(c=>!n.has(c.identifier))}}),define(Pe[77],Me([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Jm=R,e.$Km=m;var F;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(F||(e.UIKind=F={}));var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var O;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function R(k){const N=S.$te.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function m(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var f;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[61],Me([1,0,3,5,13,27,77,57,58,26,2,6,169]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$PO=e.$OO=void 0,e.$QO=s;let w=class extends E.$Tc{constructor(r,i){super(),this.s=r,this.t=i,this.a=this.B(new F.$6d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$6d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:f.$7o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,M.$Oj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,i,n){const c=this.getTelemetryDetails(),h=new d(i,n,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,i,n){this.f=r,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const i=Object.create(null);switch(i["common.extname"]=`${r.publisher}.${r.name}`,i["common.extversion"]=r.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$sm)((0,f.$ap)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const h=n.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,i){const c=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),h=!0);return h}};e.$OO=w,e.$OO=w=Je([qe(0,O.$NO),qe(1,M.$Nj)],w);class d{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,i,n,c,h,t,p){this.g=n,this.h=c,this.i=h,this.j=t,this.a=new F.$6d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(r,i){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let i="properties"in r?r.properties??{}:r;return i=(0,f.$dp)(i,[]),this.c&&(i=(0,k.$Pn)(i,this.c)),this.b||(i=(0,k.$Pn)(i,this.j)),"properties"in r?r.properties=i:r=i,r}k(r,i){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(r,i),this.h.trace(r,i))}logUsage(r,i){this.d.isUsageEnabled&&this.k(r,i)}logError(r,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,i);else{const n={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,f.$dp)(n,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(h,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const r=this,i={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$PO=d;function s(a){const r=Date.now()-new Date(a).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$RO=(0,S.$gi)("IExtHostTelemetry")}),define(Pe[22],Me([1,0,5,2,197,103,20,3]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.ActivationKind=e.$6F=e.$5F=e.$2F=e.ExtensionHostStartup=e.$1F=e.$ZF=e.$YF=e.$XF=void 0,e.$3F=l,e.$4F=w,e.$7F=r,e.$8F=i,e.$XF=Object.freeze({identifier:new R.$Bm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YF="extensions.webWorker",e.$ZF=(0,m.$gi)("extensionService");class f{constructor(h){this.dependency=h}}e.$1F=f;var k;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,p){this.c=h,this.d=t.slice(0),this.e=p.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$IF.createActivationEventsMap(this.d)}}set(h,t,p){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],o=[],v=[],b=[],$=E(this.d),I=E(t),g=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=I.get(G.identifier);if(!W){u.push(G.identifier),$.delete(G.identifier);continue}if(!g(G,W)){u.push(G.identifier),$.delete(G.identifier);continue}}for(const G of t){const W=$.get(G.identifier);if(!W){o.push(G);continue}if(!g(W,G)){u.push(W.identifier),$.delete(W.identifier);continue}}const D=new R.$Cm(this.e),y=new R.$Cm(p);for(const G of this.e)y.has(G)||v.push(G);for(const G of p)D.has(G)||b.push(G);const P=O.$IF.createActivationEventsMap(o),A={versionId:h,toRemove:u,toAdd:o,addActivationEvents:P,myToRemove:v,myToAdd:b};return this.delta(A),A}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:p,myToRemove:u,myToAdd:o}=h,v=new R.$Cm(t),b=new R.$Cm(u);for(let $=0;$<this.d.length;$++)v.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)b.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of p)this.d.push($);for(const $ of o)this.e.push($);return this.f=null,h}containsExtension(h){for(const t of this.e)if(R.$Bm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const p=O.$IF.readActivationEvents(t);for(const u of p)h.add(u)}return h}}e.$2F=N;function E(c){const h=new R.$Dm;for(const t of c)h.set(t.identifier,t);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function w(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class d{constructor(h,t,p,u){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=p,this.activationReason=u}}e.$5F=d;class s{constructor(h,t){this.description=h,this.value=t}}e.$6F=s;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$jp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,h){return{identifier:new R.$Bm((0,M.$hp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}class n{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9F=n}),define(Pe[222],Me([1,0,14,108,20,22,13,11]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=e.$$ic=e.$0ic=e.$9ic=e.$8ic=e.$7ic=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(r,i,n,c){this.startup=r,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$7ic=f;class k{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,i){return r===-1||i===-1?-1:i-r}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$8ic=k;class N{constructor(r,i,n,c,h,t){this.activationFailed=r,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=h,this.subscriptions=t}}e.$9ic=N;class E extends N{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0ic=E;class l extends N{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$ic=l;class w extends N{constructor(r){super(!0,r,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(r,i,n,c){this.g=c,this.a=r,this.b=i,this.c=n,this.d=new M.$Dm,this.f=Object.create(null)}dispose(){for(const[r,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const r=[];for(const[i,n]of this.d)r.push(n.wait());await Promise.all(r)}isActivated(r){const i=this.d.get(r);return!!(i&&i.value)}getActivatedExtension(r){const i=this.d.get(r);if(!i||!i.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return i.value}async activateByEvent(r,i){if(this.f[r])return;const n=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,i){const n=this.a.getExtensionDescription(r);if(!n)throw new Error(`Extension '${r}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(r){const i=r.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const i=this.a.getExtensionDescription(r.id);if(!i){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new w(h));return this.c.onExtensionActivationError(r.id,h,new O.$1F(r.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){n.push(t);continue}if(this.l(h)){n.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const p=this.a.getExtensionDescription(h);if(p){if(!p.main&&!p.browser)continue;n.push(this.j({id:p.identifier,reason:r.reason}));continue}const u=i.displayName||i.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),v=this.k(r,i.displayName,[],new w(o));return this.c.onExtensionActivationError(i.identifier,o,new O.$1F(h)),v}return this.k(r,i.displayName,n,null)}k(r,i,n,c){const h=new s(r.id,i,r.reason,n,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return F.$n0b.isHostExtension(r,this.a,this.b)}m(r){const i=this.b.getExtensionDescription(r);return i?!i.main&&!i.browser:!1}};e.$_ic=d,e.$_ic=d=Je([qe(3,R.$Mj)],d);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,i,n,c,h,t,p){this.c=r,this.d=i,this.f=n,this.g=c,this.h=h,this.j=t,this.k=p,this.a=new m.$fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const i=this.g[r];if(i.value&&!i.value.activationFailed){this.g.splice(r,1),r--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const i=new Error;if(r&&r.name&&(i.name=r.name),r&&r.message?i.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(i.stack=r.stack),this.h=new w(i),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([qe(6,R.$Mj)],s)}),define(Pe[223],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[224],Me([1,0,183,14,32,98,72,30,20,223,193,103]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0;const l=m.$Yn.as(R.$Zn.JSONContribution);class w{constructor(h,t,p){this.a=h,this.b=t,this.c=p}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(M.default.Error,h)}warn(h){this.d(M.default.Warning,h)}info(h){this.d(M.default.Info,h)}}e.$RF=w;class d{static a(h){const t=new f.$Cm;for(let p=0,u=h.length;p<u;p++)t.add(h[p].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new d(t,[]);if(!t||!t.length)return new d([],h);const p=this.a(h),u=this.a(t),o=t.filter(b=>!p.has(b.description.identifier)),v=h.filter(b=>!u.has(b.description.identifier));return new d(o,v)}constructor(h,t){this.added=h,this.removed=t}}e.$SF=d;class s{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=d.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$1)(h)}}}e.$TF=s;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$UF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$Am},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Do}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$Do}},extensionKind:{description:S.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&E.$IF.register(h.extensionPoint,h.activationEventsGenerator),e.$UF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(r,e.$UF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$VF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};m.$Yn.add(n.ExtensionsRegistry,new i),e.$WF=m.$Yn.as(n.ExtensionsRegistry),l.registerSchema(r,e.$UF),l.registerSchema(N.$7j,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Pe[225],Me([1,0,179,16,26,224,35,5]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var k;(function(l){function w(d,s,a){if(!d)return;const r=F.$Tf(d.type)?d.type:void 0;if(!r||r.length===0){a.error(S.localize(3,null));return}const i=[];if(Array.isArray(d.required))for(const n of d.required)F.$Tf(n)&&i.push(n);return{extensionId:s.value,taskType:r,required:i,properties:d.properties?M.$Mn(d.properties):{},when:d.when?R.$ej.deserialize(d.when):void 0}}l.from=w})(k||(k={}));const N=O.$WF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const d of l)d.type&&w.push(`onTaskType:${d.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class E{constructor(){this.d=new m.$6d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,d)=>{N.setHandler((s,a)=>{this.c=void 0;try{for(const r of a.removed){const i=r.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const r of a.added){const i=r.value;for(const n of i){const c=k.from(n,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const d of this.all()){const s={type:"object",additionalProperties:!1};d.required.length>0&&(s.required=d.required.slice(0)),d.properties!==void 0?s.properties=M.$Mn(d.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[d.taskType]},w.push(s)}this.c={oneOf:w}}return this.c}}e.$lH=new E}),define(Pe[226],Me([1,0,180,16,24,26,35,225]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$vH=e.JsonSchemaVersion=e.ExecutionEngine=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$pH=e.ShellQuoting=e.$oH=e.$nH=e.$mH=void 0,e.$mH="settings",e.$nH=new R.$xj("taskRunning",!1,S.localize(0,null)),e.$oH=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$pH="$customized",function(C){function T(q){if(!q)return C.Strong;switch(q.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=T}(f||(e.ShellQuoting=f={}));var k;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var N;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(N||(e.RevealKind=N={})),function(C){function T(q){switch(q.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=T}(N||(e.RevealKind=N={}));var E;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(C){function T(q){switch(q.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=T}(E||(e.RevealProblemKind=E={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function T(q){switch(q.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=T}(l||(e.PanelKind=l={}));var w;(function(C){C.defaults={echo:!0,reveal:N.Always,revealProblems:E.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var d;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(d||(e.RuntimeType=d={})),function(C){function T(ne){switch(ne.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=T;function q(ne){switch(ne){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=q}(d||(e.RuntimeType=d={}));var s;(function(C){function T(q){return F.$Tf(q)?q:q.value}C.value=T})(s||(e.CommandString=s={}));var a;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function T(ne){return ne===C.Clean._id||ne===C.Build._id||ne===C.Rebuild._id||ne===C.Test._id}C.is=T;function q(ne){if(ne!==void 0)return F.$Tf(ne)?T(ne)?{_id:ne,isDefault:!1}:void 0:ne}C.from=q})(a||(e.TaskGroup=a={}));var r;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function T(q){switch(q){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var n;(function(C){C.parallel="parallel",C.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(T,q,ne,ce,ye,Ie){this._label="",this._id=T,q&&(this._label=q),ne&&(this.type=ne),this.runOptions=ce,this.configurationProperties=ye,this._source=Ie}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,q=!1){if(T===void 0)return!1;if(F.$Tf(T))return T===this._label||T===this.configurationProperties.identifier||q&&T===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$qH=t;class p extends t{constructor(T,q,ne,ce,ye,Ie,ue,ve){super(T,ne,void 0,ue,ve,q),this.command={},this._source=q,this.hasDefinedMatchers=Ie,ye&&(this.command=ye)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case d.Shell:q="shell";break;case d.Process:q="process";break;case d.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(T){return T instanceof p}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$mH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ne={type:e.$pH,folder:T,id:q};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Qg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new p(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$rH=p;class u extends t{constructor(T,q,ne,ce,ye,Ie,ue){super(T,ne,ce,Ie,ue,q),this._source=q,this.configures=ye}static is(T){return T instanceof u}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Qg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$mH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ne={type:e.$pH,folder:T,id:q};return JSON.stringify(ne)}}e.$sH=u;class o extends t{constructor(T,q,ne,ce,ye,Ie,ue,ve,re){super(T,ne,ce,ve,re,q),this.defines=ye,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=re.icon,this.hide=re.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof o}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new o(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$tH=o;class v extends t{constructor(T,q,ne,ce,ye,Ie){super(T,ne,ce,ye,Ie,q),this._source=q}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new v(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$uH=v;var b;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(C){C._default=C.Terminal}(b||(e.ExecutionEngine=b={}));var $;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class I{constructor(T){this.c=new Map;for(let q=0;q<T.length;q++)this.c.set(T[q].uri.toString(),q)}compare(T,q){const ne=T.getWorkspaceFolder(),ce=q.getWorkspaceFolder();if(ne&&ce){let ye=this.c.get(ne.uri.toString());ye=ye===void 0?0:ye+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ye===Ie?T._label.localeCompare(q._label):ye-Ie}else return!ne&&ce?-1:ne&&!ce?1:0}}e.$vH=I;var g;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(g||(e.TaskEventKind=g={}));var D;(function(C){C.SingleRun="singleRun",C.Background="background"})(D||(e.TaskRunType=D={}));var y;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(C){function T(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function q(ve,re,$e){return{...T(ve),kind:"start",terminalId:re,resolvedVariables:$e}}C.start=q;function ne(ve,re,$e){return{...T(ve),kind:"processStarted",terminalId:re,processId:$e}}C.processStarted=ne;function ce(ve,re,$e){return{...T(ve),kind:"processEnded",terminalId:re,exitCode:$e}}C.processEnded=ce;function ye(ve,re,$e){return{...T(ve),kind:"terminated",exitReason:$e,terminalId:re}}C.terminated=ye;function Ie(ve,re,$e){return{...T(re),kind:ve,terminalId:$e}}C.general=Ie;function ue(){return{kind:"changed"}}C.changed=ue})(P||(e.TaskEvent=P={}));var A;(function(C){function T(ne){const ce=Object.keys(ne).sort();let ye="";for(const Ie of ce){let ue=ne[Ie];ue instanceof Object?ue=T(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ye+=Ie+","+ue+","}return ye}function q(ne){const ye={_key:T(ne),type:ne.taskType};return Object.assign(ye,ne),ye}C.create=q})(A||(e.KeyedTaskIdentifier=A={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(C){function T(q,ne){const ce=m.$lH.get(q.type);if(ce===void 0){const ve=O.$Mn(q);return delete ve._key,A.create(ve)}const ye=Object.create(null);ye.type=ce.taskType;const Ie=new Set;ce.required.forEach(ve=>Ie.add(ve));const ue=ce.properties;for(const ve of Object.keys(ue)){const re=q[ve];if(re!=null)ye[ve]=re;else if(Ie.has(ve)){const $e=ue[ve];if($e.default!==void 0)ye[ve]=O.$Mn($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:ne.error(S.localize(1,null,JSON.stringify(q,void 0,0),ve));return}}}return A.create(ye)}C.createTaskIdentifier=T})(U||(e.TaskDefinition=U={}))}),define(Pe[227],Me([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$r0b=F;class M extends F{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$s0b=M}),define(Pe[49],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$0v=void 0,e.$$v=M,e.$_v=O;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$0v=S;const F=[];function M(m){const f=new S(m);return F[f.nid]=f,f}function O(m){return F[m].sid}class R{constructor(f){this.value=f}}e.$aw=R}),define(Pe[4],Me([1,0,49]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$dM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var M;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(M||(e.TabInputKind=M={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class E{static{this.a=0}static mixin(a){return a._id=E.a++,a}}e.$dM=E;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var d;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$eM={MainThreadAuthentication:(0,S.$$v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$$v)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.$$v)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,S.$$v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$$v)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$$v)("MainThreadClipboard"),MainThreadCommands:(0,S.$$v)("MainThreadCommands"),MainThreadComments:(0,S.$$v)("MainThreadComments"),MainThreadConfiguration:(0,S.$$v)("MainThreadConfiguration"),MainThreadConsole:(0,S.$$v)("MainThreadConsole"),MainThreadDebugService:(0,S.$$v)("MainThreadDebugService"),MainThreadDecorations:(0,S.$$v)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$$v)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$$v)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$$v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$$v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$$v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$$v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$$v)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$$v)("MainThreadErrors"),MainThreadTreeViews:(0,S.$$v)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$$v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$$v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$$v)("MainThreadLanguages"),MainThreadLogger:(0,S.$$v)("MainThreadLogger"),MainThreadMessageService:(0,S.$$v)("MainThreadMessageService"),MainThreadOutputService:(0,S.$$v)("MainThreadOutputService"),MainThreadProgress:(0,S.$$v)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$$v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$$v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$$v)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$$v)("MainThreadSecretState"),MainThreadStorage:(0,S.$$v)("MainThreadStorage"),MainThreadSpeech:(0,S.$$v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$$v)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$$v)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$$v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$$v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$$v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$$v)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$$v)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$$v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$$v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$$v)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$$v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$$v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$$v)("MainThreadExtensionService"),MainThreadSCM:(0,S.$$v)("MainThreadSCM"),MainThreadSearch:(0,S.$$v)("MainThreadSearch"),MainThreadShare:(0,S.$$v)("MainThreadShare"),MainThreadTask:(0,S.$$v)("MainThreadTask"),MainThreadWindow:(0,S.$$v)("MainThreadWindow"),MainThreadLabelService:(0,S.$$v)("MainThreadLabelService"),MainThreadNotebook:(0,S.$$v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$$v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$$v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$$v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$$v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$$v)("MainThreadInteractive"),MainThreadChat:(0,S.$$v)("MainThreadChat"),MainThreadInlineChat:(0,S.$$v)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$$v)("MainThreadTheming"),MainThreadTunnelService:(0,S.$$v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$$v)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$$v)("MainThreadTimeline"),MainThreadTesting:(0,S.$$v)("MainThreadTesting"),MainThreadLocalization:(0,S.$$v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$$v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$$v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$$v)("MainThreadIssueReporter")},e.$fM={ExtHostCommands:(0,S.$$v)("ExtHostCommands"),ExtHostConfiguration:(0,S.$$v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$$v)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$$v)("ExtHostDebugService"),ExtHostDecorations:(0,S.$$v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$$v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$$v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$$v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$$v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$$v)("ExtHostEditors"),ExtHostTreeViews:(0,S.$$v)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$$v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$$v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$$v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$$v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$$v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$$v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$$v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$$v)("ExtHostStatusBar"),ExtHostShare:(0,S.$$v)("ExtHostShare"),ExtHostExtensionService:(0,S.$$v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$$v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$$v)("ExtHostTerminalService"),ExtHostSCM:(0,S.$$v)("ExtHostSCM"),ExtHostSearch:(0,S.$$v)("ExtHostSearch"),ExtHostTask:(0,S.$$v)("ExtHostTask"),ExtHostWorkspace:(0,S.$$v)("ExtHostWorkspace"),ExtHostWindow:(0,S.$$v)("ExtHostWindow"),ExtHostWebviews:(0,S.$$v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$$v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$$v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$$v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$$v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$$v)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$$v)("ExtHostProgress"),ExtHostComments:(0,S.$$v)("ExtHostComments"),ExtHostSecretState:(0,S.$$v)("ExtHostSecretState"),ExtHostStorage:(0,S.$$v)("ExtHostStorage"),ExtHostUrls:(0,S.$$v)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$$v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$$v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$$v)("ExtHostOutputService"),ExtHostLabelService:(0,S.$$v)("ExtHostLabelService"),ExtHostNotebook:(0,S.$$v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$$v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$$v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$$v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$$v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$$v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$$v)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$$v)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$$v)("ExtHostChat"),ExtHostChatAgents2:(0,S.$$v)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$$v)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$$v)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$$v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$$v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$$v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$$v)("ExtHostTheming"),ExtHostTunnelService:(0,S.$$v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$$v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$$v)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$$v)("ExtHostTimeline"),ExtHostTesting:(0,S.$$v)("ExtHostTesting"),ExtHostTelemetry:(0,S.$$v)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$$v)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$$v)("ExtHostIssueReporter")}}),define(Pe[78],Me([1,0,3,13,4,17]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=void 0,e.$qic=(0,S.$gi)("IExtHostApiDeprecationService");let R=class{constructor(f,k){this.c=k,this.a=new Set,this.b=f.getProxy(M.$eM.MainThreadTelemetry)}report(f,k,N){const E=this.d(f,k);this.a.has(E)||(this.a.add(E),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:f}))}d(f,k){return`${f}-${k.identifier.value}`}};e.$ric=R,e.$ric=R=Je([qe(0,O.$xO),qe(1,F.$Mj)],R),e.$sic=Object.freeze(new class{report(m,f,k){}})}),define(Pe[228],Me([1,0,51,6,4]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class O{static{this.a=0}constructor(f,k){this.extension=f,this.provider=k,this.handle=O.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(M.$eM.MainThreadChat)}registerChatProvider(f,k,N){const E=new O(f,N);return this.b.set(E.handle,E),this.d.$registerChatProvider(E.handle,k),(0,F.$Rc)(()=>{this.d.$unregisterChatProvider(E.handle),this.b.delete(E.handle)})}transferChatSession(f,k){const N=S.Iterable.find(this.c.keys(),E=>this.c.get(E)===f)??0;typeof N=="number"&&this.d.$transferChatSession(N,k)}async $prepareChat(f,k){const N=this.b.get(f);if(!N)return;const E=await N.provider.prepareSession(k);if(!E)return;const l=R.a++;return this.c.set(l,E),{id:l}}$releaseSession(f){this.c.delete(f)}}e.$Dic=R}),define(Pe[229],Me([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class F{constructor(O){const R=O.getProxy(S.$eM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$Iic=F}),define(Pe[230],Me([1,0,26,4,27,17]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;let R=class{constructor(N,E){this.a=N.getProxy(F.$eM.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,E){const l=this,w=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){l.e(N,E,w,arguments)}})}e(N,E,l,w){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:f(w,this.b)}),this.c&&this.f(N,l,w)}};e.$zkc=R,e.$zkc=R=Je([qe(0,O.$xO),qe(1,M.$NO)],R);const m=1e5;function f(k,N){const E=[];if(k.length)for(let l=0;l<k.length;l++){let w=k[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const d=w;d.stack?w=d.stack:w=d.toString()}E.push(w)}if(N){const l=new Error().stack;l&&E.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Rn)(E);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[231],Me([1,0,2,4,22]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;class O{constructor(m){this.a=m.getProxy(F.$eM.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,M.$4F)(m,"showLocal"),this.a.$showOpenDialog(f).then(k=>k?k.map(N=>S.URI.revive(N)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(f=>f?S.URI.revive(f):void 0)}}e.$Djc=O}),define(Pe[232],Me([1,0,6,4]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(F.$eM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Yjc=M}),define(Pe[79],Me([1,0,21,15,2,3,13,4,27,17]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=void 0;let N=class{constructor(l,w,d){this.f=d,this.d=new Map,this.a=w.getProxy(m.$eM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,w){const{message:d,args:s,comment:a}=w;if(this.c)return(0,F.$Ve)(d,s??{});let r=d;a&&a.length>0&&(r+=`/${Array.isArray(a)?a.join(""):a}`);const i=this.d.get(l)?.contents[r];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,F.$Ve)(i??d,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let w;const d=await this.g(l);if(!d){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(d),a=JSON.parse(s);w=l.isBuiltin?a.contents?.bundle:a}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${d}: ${s.message}`);return}w&&this.d.set(l.identifier.value,{contents:w,uri:d})}async g(l){if(l.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return M.URI.revive(w)}return l.l10n?M.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ljc=N,e.$ljc=N=Je([qe(0,f.$NO),qe(1,k.$xO),qe(2,R.$Mj)],N),e.$mjc=(0,O.$gi)("IExtHostLocalizationService")}),define(Pe[233],Me([1,0,13,4,27,17,2,52]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;let f=class extends S.$Xj{constructor(E,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,m.$Ph)(w))),this.r=E.getProxy(F.$eM.MainThreadLogger)}$setLogLevel(E,l){l?this.setLogLevel(R.URI.revive(l),E):this.setLogLevel(E)}setVisibility(E,l){super.setVisibility(E,l),this.r.$setVisibility(E,l)}s(E,l,w){return new k(this.r,E,l,w)}};e.$ykc=f,e.$ykc=f=Je([qe(0,O.$xO),qe(1,M.$NO)],f);class k extends S.$Sj{constructor(E,l,w,d){super(d?.logLevel==="always"),this.r=E,this.s=l,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(l,d).then(()=>{this.u(this.n),this.m=!0})}g(E,l){const w=[[E,l]];this.m?this.u(w):this.n.push(...w)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Me([1,0,4,3,6,17,23]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0,e.$njc=(0,F.$gi)("IExtHostManagedSockets");let m=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(S.$eM.MainThreadManagedSockets)}setFactory(E,l){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(E,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const l=++this.b,w=await this.c.makeConnection(),d=new M.$Sc;return this.d.set(l,new k(l,w,d)),d.add((0,M.$Rc)(()=>this.d.delete(l))),d.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),d.dispose()})),d.add(w.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),d.dispose()})),d.add(w.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$te.wrap(s)))),l}$remoteSocketWrite(E,l){this.d.get(E)?.actual.send(l.buffer)}$remoteSocketEnd(E){const l=this.d.get(E);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$ojc=m,e.$ojc=m=Je([qe(0,O.$xO)],m);class f{constructor(E,l){this.socketFactoryId=E,this.makeConnection=l}}class k extends M.$Tc{constructor(E,l,w){super(),this.socketId=E,this.actual=l,this.B(w)}}}),define(Pe[234],Me([1,0,4,13,22]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;function O(m){return m&&m.title}let R=class{constructor(f,k){this.b=k,this.a=f.getProxy(S.$eM.MainThreadMessageService)}showMessage(f,k,N,E,l){const w={source:{identifier:f.identifier,label:f.displayName||f.name}};let d;typeof E=="string"||O(E)?d=[E,...l]:(w.modal=E?.modal,w.useCustom=E?.useCustom,w.detail=E?.detail,d=l),w.useCustom&&(0,M.$4F)(f,"resolvers");const s=[];let a=!1;for(let r=0;r<d.length;r++){const i=d[r];if(typeof i=="string")s.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;s.push({title:n,isCloseAffordance:!!c,handle:r}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,i):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,N,w,s).then(r=>{if(typeof r=="number")return d[r]})}};e.$1jc=R,e.$1jc=R=Je([qe(1,F.$Mj)],R)}),define(Pe[235],Me([1,0,6,16,2,22,4]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class m{constructor(k){this.b=new Map,this.a=k.getProxy(R.$eM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,N,E){if((0,O.$4F)(k,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,E),this.a.$registerProfileContentHandler(N,E.name,E.description,k.identifier.value),(0,S.$Rc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(k,N,E,l){const w=this.b.get(k);if(!w)throw new Error(`Unknown handler with id: ${k}`);return w.saveProfile(N,E,l)}async $readProfile(k,N,E){const l=this.b.get(k);if(!l)throw new Error(`Unknown handler with id: ${k}`);return l.readProfile((0,F.$Tf)(N)?N:M.URI.revive(N),E)}}e.$0jc=m}),define(Pe[81],Me([1,0,4,5,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=e.$ijc=void 0;class O{constructor(m){this.b=new F.$6d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$eM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,f){return this.a.$getPassword(m,f)}store(m,f,k){return this.a.$setPassword(m,f,k)}delete(m,f){return this.a.$deletePassword(m,f)}}e.$ijc=O,e.$jjc=(0,M.$gi)("IExtHostSecretState")}),define(Pe[236],Me([1,0,25,6,4]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class O{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(M.$eM.MainThreadSpeech)}async $createSpeechToTextSession(m,f,k){const N=this.c.get(m);if(!N)return;const E=new F.$Sc,l=new S.$de;this.d.set(f,l);const w=E.add(N.provideSpeechToTextSession(l.token,k?{language:k}:void 0));E.add(w.onDidChange(d=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,d)})),E.add(l.token.onCancellationRequested(()=>E.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,f){const k=this.c.get(m);if(!k)return;const N=new F.$Sc,E=new S.$de;this.d.set(f,E);const l=N.add(k.provideKeywordRecognitionSession(E.token));N.add(l.onDidChange(w=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,w)})),N.add(E.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,f,k){const N=O.a++;return this.c.set(N,k),this.b.$registerProvider(N,f,{extension:m,displayName:m.value}),(0,F.$Rc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$ekc=O}),define(Pe[82],Me([1,0,4,5,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=e.$ajc=void 0;class O{constructor(m,f){this.c=f,this.b=new F.$6d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$eM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this.a.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,k){const N=await this.a.$initializeExtensionStorage(m,f);let E;return N&&(E=this.d(m,f,N)),E||k}setValue(m,f,k){return this.a.$setValue(m,f,k)}$acceptValue(m,f,k){const N=this.d(m,f,k);N&&this.b.fire({shared:m,key:f,value:N})}d(m,f,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${N}`)}}}e.$ajc=O,e.$bjc=(0,M.$gi)("IExtHostStorage")}),define(Pe[237],Me([1,0,6,12,2,4]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(O.$eM.MainThreadUriOpeners)}registerExternalUriOpener(f,k,N,E){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=E.schemes.find(w=>!R.a.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,E.schemes,f,E.label),(0,S.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(f,k,N){const E=this.c.get(f);if(!E)throw new Error(`Unknown opener with id: ${f}`);const l=M.URI.revive(k);return E.canOpenExternalUri(l,N)}async $openUri(f,k,N){const E=this.c.get(f);if(!E)throw new Error(`Unknown opener id: '${f}'`);return E.openExternalUri(M.URI.revive(k.resolvedUri),{sourceUri:M.URI.revive(k.sourceUri)},N)}}e.$skc=R}),define(Pe[238],Me([1,0,4,2,6,14,20]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class m{static{this.a=0}constructor(k){this.c=new R.$Cm,this.d=new Map,this.b=k.getProxy(S.$eM.MainThreadUrls)}registerUriHandler(k,N){const E=k.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const l=m.a++;return this.c.add(E),this.d.set(l,N),this.b.$registerUriHandler(l,E,k.displayName||k.name),(0,M.$Rc)(()=>{this.c.delete(E),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(k,N){const E=this.d.get(k);if(!E)return Promise.resolve(void 0);try{E.handleUri(F.URI.revive(N))}catch(l){(0,O.$1)(l)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this.b.$createAppUri(k))}}e.$tkc=m}),define(Pe[62],Me([1,0,5,6,12,26,2,186,208,76,4]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Xic=void 0,e.$Yic=l,e.$1ic=s,e.$2ic=a;class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,t,p,u,o,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$6d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$6d,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=t,this.#n=p,this.#s=u,this.#r=o,this.#l=l(o),this.#d=w(o),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,k.$Yxb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$Xxb}return k.$Xxb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$Qn(this.#o,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,f.$wnb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,v,b,$)=>{const I=R.URI.from({scheme:v||"file",path:decodeURIComponent(b)}),g=(0,k.$Yxb)(I,{isRemote:h,authority:t}).toString();return`${u}${g}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,v,b,$)=>{const I=R.URI.from({scheme:v||"file",path:decodeURIComponent(b)}),g=(0,k.$Yxb)(I,{isRemote:h,authority:t}).toString();return`${u}${g}${$}`})}}e.$Xic=E;function l(n){try{const c=(0,m.$sp)((0,m.$rp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(n){try{const c=(0,m.$sp)((0,m.$rp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class d extends F.$Tc{constructor(c,h,t,p,u){super(),this.c=h,this.f=t,this.g=p,this.h=u,this.b=new Map,this.a=c.getProxy(N.$eM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,t){const p=this.j(c);if(p){const{message:u}=(0,f.$xnb)(h,t.value);p._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,t){const p=new E(c,this.a,r(h),this.c,this.f,t,this.h);this.b.set(c,p);const u=p._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return p}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Zic=d;function s(n){return{id:n.identifier,location:n.extensionLocation}}function a(n,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||i(n,c)}}function r(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>R.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),n.extensionLocation]}}),define(Pe[109],Me([1,0,5,4,2,12,15,3,17,22]),function(me,e,S,F,M,O,R,m,f,k){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$vkc=void 0;let E=class{static{N=this}static{this.a={focused:!0,active:!0}}getState(w){const d=this.d;return{get focused(){return d.focused},get active(){return(0,k.$4F)(w,"windowActivity"),d.active}}}constructor(w){this.c=new S.$6d,this.onDidChangeWindowState=this.c.event,this.d=N.a,this.b=w.getProxy(F.$eM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:d,isActive:s})=>{this.onDidChangeWindowProperty("focused",d),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,d){d!==this.d[w]&&(this.d={...this.d,[w]:d},this.c.fire(this.d))}openUri(w,d){let s;if(typeof w=="string"){s=w;try{w=M.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.$Te)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,s,d)}async asExternalUri(w,d){if((0,R.$Te)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(w,d);return M.URI.from(s)}};e.$vkc=E,e.$vkc=E=N=Je([qe(0,f.$xO)],E),e.$wkc=(0,m.$gi)("IExtHostWindow")}),define(Pe[239],Me([1,0,230,27,17]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;let O=class extends S.$zkc{constructor(m,f){super(m,f)}f(m,f,k){f.apply(console,k)}};e.$Hmc=O,e.$Hmc=O=Je([qe(0,M.$xO),qe(1,F.$NO)],O)}),define(Pe[240],Me([1,0,11,23,25,14,5,6,142,227,49]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$v0b=e.ResponsiveState=e.RequestInitiator=void 0,e.$t0b=a,e.$u0b=r;function l(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const w="$$ref$$",d={[w]:-1};class s{constructor(P,A){this.jsonString=P,this.referencedBuffers=A}}function a(y,P=null,A=!1){const G=[];return{jsonString:(A?l:JSON.stringify)(y,(U,C)=>{if(typeof C>"u")return d;if(typeof C=="object"){if(C instanceof F.$te){const T=G.push(C)-1;return{[w]:T}}if(P)return P(U,C)}return C}),referencedBuffers:G}}function r(y,P,A){return JSON.parse(y,(G,W)=>{if(W){const U=W[w];if(typeof U=="number")return P[U];if(A&&W.$mid===1)return A.transformIncoming(W)}return W})}function i(y,P){return JSON.stringify(y,P)}function n(y){return y?(P,A)=>A&&A.$mid===1?y.transformOutgoing(A):A:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},p=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class o extends m.$Tc{static{E=p}static{this.a=3*1e3}constructor(P,A=null,G=null){super(),this[E]=!0,this.b=this.B(new R.$6d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=A,this.g=G,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=N.$0v.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$sh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const A=this.w[P];delete this.w[P],A.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,f.$ln)(P,this.g):P}getProxy(P){const{nid:A,sid:G}=P;return this.s[A]||(this.s[A]=this.J(A,G)),this.s[A]}J(P,A){const G={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...C)=>this.U(P,U,C)),U===u?A:W[U])};return new Proxy(Object.create(null),G)}set(P,A){return this.m[P.nid]=A,A}assertRegistered(P){for(let A=0,G=P.length;A<G;A++){const W=P[A];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(P){if(this.j)return;const A=P.byteLength,G=b.read(P,0),W=G.readUInt8(),U=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:C,method:T,args:q}=I.deserializeRequestJSONArgs(G);this.g&&(q=(0,f.$ln)(q,this.g)),this.M(A,U,C,T,q,W===2);break}case 3:case 4:{let{rpcId:C,method:T,args:q}=I.deserializeRequestMixedArgs(G);this.g&&(q=(0,f.$ln)(q,this.g)),this.M(A,U,C,T,q,W===4);break}case 5:{this.f?.logIncoming(A,U,0,"ack"),this.G(U);break}case 6:{this.N(A,U);break}case 7:{this.O(A,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(G);this.g&&(C=(0,f.$ln)(C,this.g)),this.O(A,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(A,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(G);this.O(A,U,C);break}case 11:{let C=I.deserializeReplyErrError(G);this.g&&(C=(0,f.$ln)(C,this.g)),this.P(A,U,C);break}case 12:{this.P(A,U,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,A,G,W,U,C){this.f?.logIncoming(P,A,1,`receiveRequest ${(0,N.$_v)(G)}.${W}(`,U);const T=String(A);let q,ne;if(C){const ye=new M.$de;U.push(ye.token),q=this.Q(G,W,U),ne=()=>ye.cancel()}else q=this.Q(G,W,U),ne=t;this.u[T]=ne;const ce=I.serializeAcknowledged(A);this.f?.logOutgoing(ce.byteLength,A,1,"ack"),this.c.send(ce),q.then(ye=>{delete this.u[T];const Ie=I.serializeReplyOK(A,ye,this.h);this.f?.logOutgoing(Ie.byteLength,A,1,"reply:",ye),this.c.send(Ie)},ye=>{delete this.u[T];const Ie=I.serializeReplyErr(A,ye);this.f?.logOutgoing(Ie.byteLength,A,1,"replyErr:",ye),this.c.send(Ie)})}N(P,A){this.f?.logIncoming(P,A,1,"receiveCancel");const G=String(A);this.u[G]?.()}O(P,A,G){this.f?.logIncoming(P,A,0,"receiveReply:",G);const W=String(A);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(G)}P(P,A,G){this.f?.logIncoming(P,A,0,"receiveReplyErr:",G);const W=String(A);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),U.resolveErr(C)}Q(P,A,G){try{return Promise.resolve(this.S(P,A,G))}catch(W){return Promise.reject(W)}}S(P,A,G){const W=this.m[P];if(!W)throw new Error("Unknown actor "+(0,N.$_v)(P));const U=W[A];if(typeof U!="function")throw new Error("Unknown method "+A+" on actor "+(0,N.$_v)(P));return U.apply(W,G)}U(P,A,G){if(this.j)return new k.$s0b;let W=null;if(G.length>0&&M.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(O.$6());const U=I.serializeRequestArguments(G,this.h),C=++this.t,T=String(C),q=new k.$r0b,ne=new m.$Sc;W&&ne.add(W.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[T]=new v(q,ne),this.F(C);const ce=I.serializeRequest(C,P,A,U,!!W);return this.f?.logOutgoing(ce.byteLength,C,0,`request: ${(0,N.$_v)(P)}.${A}(`,G),this.c.send(ce),q}}e.$v0b=o;class v{constructor(P,A){this.a=P,this.b=A}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class b{static alloc(P,A,G){const W=new b(F.$te.alloc(G+1+4),0);return W.writeUInt8(P),W.writeUInt32(A),W}static read(P,A){return new b(P,A)}get buffer(){return this.a}constructor(P,A){this.a=P,this.b=A}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+P).toString();return this.b+=P,G}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+P).toString();return this.b+=P,G}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const A=this.a.slice(this.b,this.b+P);return this.b+=P,A}static sizeMixedArray(P){let A=0;A+=1;for(let G=0,W=P.length;G<W;G++){const U=P[G];switch(A+=1,U.type){case 1:A+=this.sizeLongString(U.value);break;case 2:A+=this.sizeVSBuffer(U.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)A+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return A}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let A=0,G=P.length;A<G;A++){const W=P[A];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const A=new Array(P);for(let G=0;G<P;G++)switch(this.readUInt8()){case 1:A[G]=this.readLongString();break;case 2:A[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),T=[];for(let q=0;q<U;++q)T.push(this.readVSBuffer());A[G]=new N.$aw(r(C,T,null));break}case 4:A[G]=void 0;break}return A}}var $;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})($||($={}));class I{static a(P){for(let A=0,G=P.length;A<G;A++)if(P[A]instanceof F.$te||P[A]instanceof N.$aw||typeof P[A]>"u")return!0;return!1}static serializeRequestArguments(P,A){if(this.a(P)){const G=[];for(let W=0,U=P.length;W<U;W++){const C=P[W];if(C instanceof F.$te)G[W]={type:2,value:C};else if(typeof C>"u")G[W]={type:4};else if(C instanceof N.$aw){const{jsonString:T,referencedBuffers:q}=a(C.value,A);G[W]={type:3,value:F.$te.fromString(T),buffers:q}}else G[W]={type:1,value:F.$te.fromString(i(C,A))}}return{type:1,args:G}}return{type:0,args:i(P,A)}}static serializeRequest(P,A,G,W,U){switch(W.type){case 0:return this.b(P,A,G,W.args,U);case 1:return this.c(P,A,G,W.args,U)}}static b(P,A,G,W,U){const C=F.$te.fromString(G),T=F.$te.fromString(W);let q=0;q+=b.sizeUInt8(),q+=b.sizeShortString(C),q+=b.sizeLongString(T);const ne=b.alloc(U?2:1,P,q);return ne.writeUInt8(A),ne.writeShortString(C),ne.writeLongString(T),ne.buffer}static deserializeRequestJSONArgs(P){const A=P.readUInt8(),G=P.readShortString(),W=P.readLongString();return{rpcId:A,method:G,args:JSON.parse(W)}}static c(P,A,G,W,U){const C=F.$te.fromString(G);let T=0;T+=b.sizeUInt8(),T+=b.sizeShortString(C),T+=b.sizeMixedArray(W);const q=b.alloc(U?4:3,P,T);return q.writeUInt8(A),q.writeShortString(C),q.writeMixedArray(W),q.buffer}static deserializeRequestMixedArgs(P){const A=P.readUInt8(),G=P.readShortString(),W=P.readMixedArray(),U=new Array(W.length);for(let C=0,T=W.length;C<T;C++){const q=W[C];typeof q=="string"?U[C]=JSON.parse(q):U[C]=q}return{rpcId:A,method:G,args:U}}static serializeAcknowledged(P){return b.alloc(5,P,0).buffer}static serializeCancel(P){return b.alloc(6,P,0).buffer}static serializeReplyOK(P,A,G){if(typeof A>"u")return this.d(P);if(A instanceof F.$te)return this.e(P,A);if(A instanceof N.$aw){const{jsonString:W,referencedBuffers:U}=a(A.value,G,!0);return this.g(P,W,U)}else return this.f(P,l(A,G))}static d(P){return b.alloc(7,P,0).buffer}static e(P,A){let G=0;G+=b.sizeVSBuffer(A);const W=b.alloc(8,P,G);return W.writeVSBuffer(A),W.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,A){const G=F.$te.fromString(A);let W=0;W+=b.sizeLongString(G);const U=b.alloc(9,P,W);return U.writeLongString(G),U.buffer}static g(P,A,G){const W=F.$te.fromString(A);let U=0;U+=b.sizeUInt32,U+=b.sizeLongString(W);for(const T of G)U+=b.sizeVSBuffer(T);const C=b.alloc(10,P,U);C.writeUInt32(G.length),C.writeLongString(W);for(const T of G)C.writeBuffer(T);return C.buffer}static deserializeReplyOKJSON(P){const A=P.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(P,A){const G=P.readUInt32(),W=P.readLongString(),U=[];for(let C=0;C<G;++C)U.push(P.readVSBuffer());return new N.$aw(r(W,U,A))}static serializeReplyErr(P,A){const G=A?l(O.$3(A),null):void 0;if(typeof G!="string")return this.h(P);const W=F.$te.fromString(G);let U=0;U+=b.sizeLongString(W);const C=b.alloc(11,P,U);return C.writeLongString(W),C.buffer}static deserializeReplyErrError(P){const A=P.readLongString();return JSON.parse(A)}static h(P){return b.alloc(12,P,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var D;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(D||(D={}))}),define(Pe[241],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;const S=function(O){const R=m=>{globalThis.removeEventListener("message",R);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(k,N){f.postMessage(k,N)}},onmessage:{get(){return f.onmessage},set(k){f.onmessage=k}}}),f.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(O,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,k=new Blob([f],{type:"application/javascript"}),N=URL.createObjectURL(k),E=new MessageChannel,l=N,w={type:"_newWorker",id:l,port:E.port2,url:N,options:m};O(w,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{O({type:"_terminateWorker",id:l}),URL.revokeObjectURL(N),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(d){E.port1.onmessage=d}},onmessageerror:{get(){return E.port1.onmessageerror},set(d){E.port1.onmessageerror=d}}}),E.port1.addEventListener("messageerror",d=>{const s=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(s)}),E.port1.addEventListener("message",d=>{const s=new MessageEvent("message",{data:d.data});this.dispatchEvent(s)}),E.port1.start()}}e.$Jmc=F}),define(Pe[242],Me([1,0,23,28,12,54,3]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$SJ=void 0,e.$TJ=N,e.$UJ=E,e.$SJ=(0,R.$gi)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),k=7;function N(w){if(w.scheme!==M.Schemas.vscodeNotebookCell)return;const d=w.fragment.indexOf("s");if(d<0)return;const s=parseInt(w.fragment.substring(0,d).replace(f,""),k),a=(0,S.$Me)(w.fragment.substring(d+1)).toString();if(!isNaN(s))return{handle:s,notebook:w.with({scheme:a,fragment:null})}}function E(w,d){const s=d.toString(k),r=`${s.length<m.length?m[s.length-1]:"z"}${s}s${(0,S.$Ne)(S.$te.fromString(w.scheme),!0,!0)}`;return w.with({scheme:M.Schemas.vscodeNotebookCell,fragment:r})}class l{constructor(){this.a=new F.$Ac}getNotebook(d){if(d.scheme===M.Schemas.vscodeNotebookCell){const s=N(d);if(s){const a=this.a.get(s.notebook);if(a)return a}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$VJ=l,(0,O.$cs)(e.$SJ,l,1)}),define(Pe[83],Me([1,0,23,34,51,69,12,19,21,35,242]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$$J=e.CellStatusbarAlignment=e.$0J=e.NotebookEditorPriority=e.$7J=e.$6J=e.$4J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$3J=e.$2J=e.$1J=e.$ZJ=e.CellKind=e.$YJ=e.$XJ=e.$WJ=void 0,e.$5J=p,e.$8J=o,e.$9J=v,e.$_J=I,e.$aK=D,e.$WJ="workbench.editor.notebook",e.$XJ="workbench.editor.notebookTextDiffEditor",e.$YJ="workbench.editor.interactive";var E;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(E||(e.CellKind=E={})),e.$ZJ=["application/json","application/javascript","text/html","image/svg+xml",O.$vs.latex,O.$vs.markdown,"image/png","image/jpeg",O.$vs.text],e.$1J=[O.$vs.latex,O.$vs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$vs.text],e.$2J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$3J="_notAvailable";var l;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var d;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var s;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var a;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var r;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(q){q.scheme=R.Schemas.vscodeNotebookCell;function ne(re,$e){return(0,N.$UJ)(re,$e)}q.generate=ne;function ce(re){return(0,N.$TJ)(re)}q.parse=ce;function ye(re,$e){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}q.generateCellOutputUri=ye;function Ie(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!$e)return;const ie=$e[1]&&$e[1]!==""?$e[1]:void 0,le=$e[2];return{outputId:ie,notebook:re.with({scheme:le||R.Schemas.file,fragment:null})}}q.parseCellOutputUri=Ie;function ue(re,$e,ie){return q.generate(re,$e).with({scheme:ie})}q.generateCellPropertyUri=ue;function ve(re,$e){if(re.scheme===$e)return q.parse(re.with({scheme:q.scheme}))}q.parseCellPropertyUri=ve})(c||(e.CellUri=c={}));const h=q=>f.$i?q.replace(/\//g,"\\"):q;class t{constructor(ne=[],ce=e.$ZJ){this.e=ce,this.d=[...new Set(ne)].map(ye=>({pattern:ye,matches:F.$ak(h(ye))}))}sort(ne){const ce=new Map(M.Iterable.map(ne,Ie=>[Ie,h(Ie)]));let ye=[];for(const{matches:Ie}of this.d)for(const[ue,ve]of ce)if(Ie(ve)){ye.push(ue),ce.delete(ue);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ye}prioritize(ne,ce){const ye=this.f(ne);if(ye===-1){this.d.unshift({pattern:ne,matches:F.$ak(h(ne))});return}const Ie=new Set(ce.map(ve=>this.f(ve,ye)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ye+1,0,...ue.map(ve=>this.d[ve]));for(let ve=ue.length-1;ve>=0;ve--)this.d.splice(ue[ve],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,ce=this.d.length){const ye=h(ne);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ye))return Ie;return-1}}e.$4J=t;function p(q,ne,ce,ye=(Ie,ue)=>Ie===ue){const Ie=[];function ue($e,ie,le){if(ie===0&&le.length===0)return;const V=Ie[Ie.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=ie,V.toInsert.push(...le)):Ie.push({start:$e,deleteCount:ie,toInsert:le})}let ve=0,re=0;for(;;){if(ve===q.length){ue(ve,0,ne.slice(re));break}if(re===ne.length){ue(ve,q.length-ve,[]);break}const $e=q[ve],ie=ne[re];if(ye($e,ie)){ve+=1,re+=1;continue}ce(ie)?(ue(ve,1,[]),ve+=1):(ue(ve,0,[ie]),re+=1)}return Ie}e.$6J=new k.$xj("notebookEditorCursorAtBoundary","none"),e.$7J=new k.$xj("notebookEditorCursorAtLineBoundary","none");var u;(function(q){q.default="default",q.option="option"})(u||(e.NotebookEditorPriority=u={}));function o(q){const ne=q;return!!((typeof ne.include=="string"||F.$bk(ne.include))&&(typeof ne.exclude=="string"||F.$bk(ne.exclude)))}function v(q,ne,ce){if(Array.isArray(q.viewType)&&q.viewType.indexOf(ne)>=0||q.viewType===ne)return!0;if(q.filenamePattern){const ye=o(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,Ie=o(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(F.$_j(ye,(0,m.$nc)(ce.fsPath).toLowerCase()))return!(Ie&&F.$_j(Ie,(0,m.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$0J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var b;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class ${static{this.d="notebook/"}static create(ne){return`${$.d}${ne}`}static parse(ne){if(ne.startsWith($.d))return ne.substring($.d.length)}}e.$$J=$;function I(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const g=new TextDecoder;function D(q){const ne=[];let ce=!1;for(const ve of q)(ne.length===0||ce)&&(ne.push(ve),ce=!0);let ye=A(ne);const Ie=S.$te.concat(ne.map(ve=>S.$te.wrap(ve))),ue=T(Ie);return ye=ye||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ye}}e.$bK="\x1B[A";const y=e.$bK.split("").map(q=>q.charCodeAt(0)),P=10;function A(q){let ne=!1;return q.forEach((ce,ye)=>{if(ye===0||ce.length<e.$bK.length)return;const Ie=q[ye-1],ue=ce.subarray(0,e.$bK.length);if(ue[0]===y[0]&&ue[1]===y[1]&&ue[2]===y[2]){const ve=Ie.lastIndexOf(P);if(ve===-1)return;ne=!0,q[ye-1]=Ie.subarray(0,ve),q[ye]=ce.subarray(e.$bK.length)}}),ne}function G(q){let ne=q;do q=ne,ne=q.replace(/[^\n]\x08/gm,"");while(ne.length<q.length);return q}function W(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const ne=q.match(/^(.*)\r+/m)[1];let ce=q.match(/\r+(.*)$/m)[1];ce=ce+ne.slice(ce.length,ne.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return q}const U=8,C=13;function T(q){return!q.buffer.includes(U)&&!q.buffer.includes(C)?q:S.$te.fromString(W(G(g.decode(q.buffer))))}}),define(Pe[7],Me([1,0,18,14,53,28,69,15,16,2,33,20,42,102,83]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d){"use strict";var s,a,r,i,n,c,h,t,p,u,o,v,b,$,I,g,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$mO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$_N=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.TestRunProfileKind=e.TestResultState=e.$RN=e.$QN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PN=e.NotebookVariablesRequestKind=e.$ON=e.$NN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.ColorThemeKind=e.$GN=e.$FN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EN=e.$DN=e.DebugConsoleMode=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xN=e.$wN=e.FileChangeType=e.$vN=e.NewSymbolNameTag=e.$uN=e.$tN=e.$sN=e.$rN=e.InlineCompletionTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$eN=e.ConfigurationTarget=e.$dN=e.$cN=e.$bN=e.$aN=e.DocumentPasteTriggerKind=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6M=e.ViewBadge=e.ProgressLocation=e.$5M=e.$4M=e.TaskScope=e.ShellQuoting=e.$3M=e.$2M=e.$1M=e.TaskPanelKind=e.TaskRevealKind=e.$ZM=e.TerminalLocation=e.$YM=e.$XM=e.$WM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VM=e.$UM=e.$TM=e.$SM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MM=e.$LM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.LanguageStatusSeverity=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.CodeActionTriggerKind=e.$zM=e.$yM=e.SymbolTag=e.SymbolKind=e.$xM=e.$wM=e.DocumentHighlightKind=e.$vM=e.$uM=e.$tM=e.$sM=e.DiagnosticSeverity=e.DiagnosticTag=e.$rM=e.$qM=e.FileEditType=e.$pM=e.$oM=e.$nM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$RM=Dt,e.$fN=Ye;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ge]=te;return Reflect.construct(B,Ge,Ee.constructor)}}})}var P;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var A;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(A||(e.TerminalQuickFixType=A={}));let G=s=class{static from(...L){let te=L;return new s(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$gM=G,e.$gM=G=s=Je([y],G);let W=a=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ge=L[Ee];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ge=L[Ee];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(L){if(!L)return!1;if(L instanceof a)return!0;const{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}static of(L){if(L instanceof a)return L;if(this.isPosition(L))return new a(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,te){if(L<0)throw(0,F.$7)("line must be non-negative");if(te<0)throw(0,F.$7)("character must be non-negative");this.c=L,this.e=te}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,te=0){if(L===null||te===null)throw(0,F.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new a(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,F.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new a(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$hM=W,e.$hM=W=a=Je([y],W);let U=r=class{static isRange(L){return L instanceof r?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof r)return L;if(this.isRange(L))return new r(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,te,Ee,Ge){let _e,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(_e=new W(L,te),lt=new W(Ee,Ge)):W.isPosition(L)&&W.isPosition(te)&&(_e=W.of(L),lt=W.of(te)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(L){return r.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const te=W.Max(L.start,this.c),Ee=W.Min(L.end,this.e);if(!te.isAfter(Ee))return new r(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=W.Min(L.start,this.c),Ee=W.Max(L.end,this.end);return new r(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,te=this.end){if(L===null||te===null)throw(0,F.$7)();let Ee;return L?W.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new r(Ee,te)}toJSON(){return[this.start,this.end]}};e.$iM=U,e.$iM=U=r=Je([y],U);let C=i=class extends U{static isSelection(L){return L instanceof i?!0:L?U.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,te,Ee,Ge){let _e,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(_e=new W(L,te),lt=new W(Ee,Ge)):W.isPosition(L)&&W.isPosition(te)&&(_e=W.of(L),lt=W.of(te)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$jM=C,e.$jM=C=i=Je([y],C);const T=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$7)("connectionToken")};class q{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,F.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,F.$7)("port");typeof Ee<"u"&&T(Ee),this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.$kM=q;class ne{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te){this.makeConnection=L,this.connectionToken=te,typeof te<"u"&&T(te)}}e.$lM=ne;class ce extends Error{static NotAvailable(L,te){return new ce(L,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ce(L,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$mM=ce;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=n=class{static isTextEdit(L){return L instanceof n?!0:L?U.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new n(L,te)}static insert(L,te){return n.replace(new U(L,L),te)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const te=new n(new U(new W(0,0),new W(0,0)),"");return te.newEol=L,te}get range(){return this.c}set range(L){if(L&&!U.isRange(L))throw(0,F.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,F.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,F.$7)("newEol");this.f=L}constructor(L,te){this.c=L,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$nM=ue,e.$nM=ue=n=Je([y],ue);let ve=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?hi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new c(L,te)}static insertCells(L,te){return new c(new hi(L,L),te)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,te){const Ee=new c(new hi(L,L),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(L){const te=new c(new hi(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.$oM=ve,e.$oM=ve=c=Je([y],ve);class re{static isSnippetTextEdit(L){return L instanceof re?!0:L?U.isRange(L.range)&&le.isSnippetString(L.snippet):!1}static replace(L,te){return new re(L,te)}static insert(L,te){return re.replace(new U(L,L),te)}constructor(L,te){this.range=L,this.snippet=te}}e.$pM=re;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,te,Ee,Ge){this.c.push({_type:1,from:L,to:te,options:Ee,metadata:Ge})}createFile(L,te,Ee){this.c.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this.c.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}e(L,te,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}f(L,te,Ee,Ge){const _e=te.start,lt=te.end;(_e!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:_e,count:lt-_e,cells:Ee,metadata:Ge})}g(L,te,Ee,Ge){this.c.push({_type:3,metadata:Ge,uri:L,edit:{editType:3,index:te,metadata:Ee}})}replace(L,te,Ee,Ge){this.c.push({_type:2,uri:L,edit:new ue(te,Ee),metadata:Ge})}insert(L,te,Ee,Ge){this.replace(L,new U(te,te),Ee,Ge)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this.c.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te){if(!Ee)continue;let Ge,_e;Array.isArray(Ee)?(Ge=Ee[0],_e=Ee[1]):Ge=Ee,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(L,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(L,Ge.newNotebookMetadata,_e):this.f(L,Ge.range,Ge.newCells,_e):re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:L,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:L,edit:Ge,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ge=this.c[Ee];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,S.$Ib)(this.c)}}get(L){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new O.$Ac;for(const te of this.c)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$qM=ie,e.$qM=ie=Je([y],ie);let le=h=class{static isSnippetString(L){return L instanceof h?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=h.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this.e++){if(typeof L=="function"){const Ee=new h;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=h.c(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this.e++){const Ee=L.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new h;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$rM=le,e.$rM=le=h=Je([y],le);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ee;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ke=t=class{static isLocation(L){return L instanceof t?!0:L?U.isRange(L.range)&&k.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(U.isRange(te))this.range=U.of(te);else if(W.isPosition(te))this.range=new U(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$sM=ke,e.$sM=ke=t=Je([y],ke);let Ne=class{static is(L){return L?typeof L.message=="string"&&L.location&&U.isRange(L.location.range)&&k.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.$tM=Ne,e.$tM=Ne=Je([y],Ne);let Se=class{constructor(L,te,Ee=ee.Error){if(!U.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,S.$ub)(L.tags,te.tags)&&(0,S.$ub)(L.relatedInformation,te.relatedInformation,Ne.isEqual)}};e.$uM=Se,e.$uM=Se=Je([y],Se);let be=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.$vM=be,e.$vM=be=Je([y],be);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let J=class{constructor(L,te=ge.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$wM=J,e.$wM=J=Je([y],J);let Z=class{constructor(L,te){this.uri=L,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$xM=Z,e.$xM=Z=Je([y],Z);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var fe;(function(B){B[B.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Te=p=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,Ee,Ge,_e){this.name=L,this.kind=te,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof ke?this.location=Ge:Ee instanceof U&&(this.location=new ke(Ge,Ee)),p.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$yM=Te,e.$yM=Te=p=Je([y],Te);let de=u=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(u.validate)}constructor(L,te,Ee,Ge,_e){this.name=L,this.detail=te,this.kind=Ee,this.range=Ge,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$zM=de,e.$zM=de=u=Je([y],de);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Re=class{constructor(L,te){this.title=L,this.kind=te}};e.$AM=Re,e.$AM=Re=Je([y],Re);let je=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$BM=je,e.$BM=je=o=Je([y],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let z=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CM=z,e.$CM=z=Je([y],z);class j{constructor(L,te,Ee,Ge,_e,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$DM=j;class K{constructor(L,te){this.fromRanges=te,this.from=L}}e.$EM=K;class H{constructor(L,te){this.fromRanges=te,this.to=L}}e.$FM=H;var _;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(_||(e.LanguageStatusSeverity=_={}));let se=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.$GM=se,e.$GM=se=Je([y],se);let Oe=v=class{#e;static isMarkdownString(L){return L instanceof v?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){this.#e=new M.$Dk(L,{supportThemeIcons:te})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,te){return this.#e.appendCodeblock(te??"",L),this}};e.$HM=Oe,e.$HM=Oe=v=Je([y],Oe);let Ve=class{constructor(L,te){this.label=L,this.documentation=te}};e.$IM=Ve,e.$IM=Ve=Je([y],Ve);let Qe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.$JM=Qe,e.$JM=Qe=Je([y],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KM=xe,e.$KM=xe=Je([y],xe);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var ot;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let rt=class{constructor(L){this.value=L}};e.$LM=rt,e.$LM=rt=Je([y],rt);let tt=class{constructor(L,te,Ee){this.position=L,this.label=te,this.kind=Ee}};e.$MM=tt,e.$MM=tt=Je([y],tt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var it;(function(B){B[B.Deprecated=1]="Deprecated"})(it||(e.CompletionItemTag=it={}));let Y=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NM=Y,e.$NM=Y=Je([y],Y);let X=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.$OM=X,e.$OM=X=Je([y],X);let pe=class{constructor(L,te,Ee){this.insertText=L,this.range=te,this.command=Ee}};e.$PM=pe,e.$PM=pe=Je([y],pe);let We=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$QM=We,e.$QM=We=Je([y],We);var Xe;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var st;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var Fe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Fe||(e.StatusBarAlignment=Fe={}));function Dt(B,L){return`${E.$Bm.toKey(B)}.${L}`}var Jt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Jt||(e.TextEditorLineNumbersStyle=Jt={}));var jt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(jt||(e.TextDocumentSaveReason=jt={}));var ri;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ri||(e.TextEditorRevealType=ri={}));var Vt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Vt||(e.TextEditorSelectionChangeKind=Vt={}));var St;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var xt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(B){function L(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(Vt||(e.TextEditorSelectionChangeKind=Vt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function L(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=L}(Wt||(e.SyntaxTokenType=Wt={}));let si=class{constructor(L,te){if(te&&!k.URI.isUri(te))throw(0,F.$7)("target");if(!U.isRange(L)||L.isEmpty)throw(0,F.$7)("range");this.range=L,this.target=te}};e.$SM=si,e.$SM=si=Je([y],si);let _t=class{constructor(L,te,Ee,Ge){this.red=L,this.green=te,this.blue=Ee,this.alpha=Ge}};e.$TM=_t,e.$TM=_t=Je([y],_t);let Ze=class{constructor(L,te){if(te&&!(te instanceof _t))throw(0,F.$7)("color");if(!U.isRange(L)||L.isEmpty)throw(0,F.$7)("range");this.range=L,this.color=te}};e.$UM=Ze,e.$UM=Ze=Je([y],Ze);let Ot=class{constructor(L){if(!L||typeof L!="string")throw(0,F.$7)("label");this.label=L}};e.$VM=Ot,e.$VM=Ot=Je([y],Ot);var ei;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ei||(e.ColorFormat=ei={}));var dt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var $t;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})($t||(e.TerminalExitReason=$t={}));class ti{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,F.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,F.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,F.$7)("tooltip")}}e.$WM=ti;class qt{constructor(L){this.uri=L}}e.$XM=qt;class Ht{constructor(L){this.terminalCommand=L}}e.$YM=Ht;var ht;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ht||(e.TerminalLocation=ht={}));class Rt{constructor(L){if(this.options=L,typeof L!="object")throw(0,F.$7)("options")}}e.$ZM=Rt;var ii;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ii||(e.TaskRevealKind=ii={}));var ni;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let He=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,F.$7)("name");this.c=L}get id(){return this.c}};e.$1M=He,e.$1M=He=b=Je([y],He);function Tt(B){let L="";for(let te=0;te<B.length;te++)L+=B[te].replace(/,/g,",,")+",";return L}let zt=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,F.$7)("process");this.e=[],this.c=L,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,F.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const te of this.e)L.push(te);return Tt(L)}};e.$2M=zt,e.$2M=zt=Je([y],zt);let Yt=class{constructor(L,te,Ee){if(this.f=[],Array.isArray(te)){if(!L)throw(0,F.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,F.$7)("command");this.e=L,this.f=te,this.g=Ee}else{if(typeof L!="string")throw(0,F.$7)("commandLine");this.c=L,this.g=te}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,F.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,F.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)L.push(typeof te=="string"?te:te.value);return Tt(L)}};e.$3M=Yt,e.$3M=Yt=Je([y],Yt);var mt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(mt||(e.ShellQuoting=mt={}));var It;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(It||(e.TaskScope=It={}));class Ct{constructor(L){this.c=L}computeId(){return"customExecution"+(0,N.$Cg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$4M=Ct;let Nt=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,te,Ee,Ge,_e,lt){this.k=!1,this.l=this.definition=L;let gt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ge,gt=_e,this.k=!0):te===It.Global||te===It.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ge,this.execution=_e,gt=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ge,this.execution=_e,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof zt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Yt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Ct?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,N.$Cg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,F.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const te=this.l.type;($.g===te||$.e===te||$.f===te||$.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$5M=Nt,e.$5M=Nt=$=Je([y],Nt);var oi;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var Ut;(function(B){function L(te){const Ee=te;return(0,f.$Xf)(Ee.value)?Ee.tooltip&&!(0,f.$Tf)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=L})(Ut||(e.ViewBadge=Ut={}));let Zt=I=class{static isTreeItem(L,te){const Ee=L;if(Ee.checkboxState!==void 0){const Ge=(0,f.$Xf)(Ee.checkboxState)?Ee.checkboxState:(0,f.$Vf)(Ee.checkboxState)&&(0,f.$Xf)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,f.$Xf)(Ee.checkboxState)&&(0,f.$Vf)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ft.Checked&&Ge!==Ft.Unchecked||_e!==void 0&&!(0,f.$Tf)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof I)return!0;if(Ee.label!==void 0&&!(0,f.$Tf)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,f.$Tf)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,f.$Tf)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,f.$Tf)(Ee.iconPath.id))){const Ge=Ee.iconPath;if(!Ge||!(0,f.$Tf)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,f.$Tf)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,f.$Tf)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,f.$Tf)(Ee.tooltip)&&!(Ee.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<bt.None&&Ee.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,f.$Tf)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,te=bt.None){this.collapsibleState=te,k.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$6M=Zt,e.$6M=Zt=I=Je([y],Zt);var bt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Ft;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ft||(e.TreeItemCheckboxState=Ft={}));let Bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$7M=Bt,e.$7M=Bt=Je([y],Bt);class Lt extends Bt{}e.$8M=Lt;class wt extends Lt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$9M=wt;class Pt{constructor(L,te,Ee,Ge){this.name=L,this.uri=te,this._itemId=Ee,this.c=Ge}data(){return this.c()}}e.$0M=Pt;let kt=class{#e=new Map;constructor(L){for(const[te,Ee]of L??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,te){this.#e.set(this.#t(L),[te])}forEach(L,te){for(const[Ee,Ge]of this.#e)for(const _e of Ge)L.call(te,_e,Ee,this)}*[Symbol.iterator](){for(const[L,te]of this.#e)for(const Ee of te)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$$M=kt,e.$$M=kt=Je([y],kt);let li=class{constructor(L,te,Ee){this.insertText=L,this.title=te,this.kind=Ee}};e.$_M=li,e.$_M=li=Je([y],li);var Qt;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Qt||(e.DocumentPasteTriggerKind=Qt={}));class ci{static{this.c="."}constructor(L){this.value=L}append(...L){return new ci((this.value?[this.value,...L]:L).join(ci.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+ci.c)}}e.$aN=ci,ci.Empty=new ci("");let we=class{constructor(L,te,Ee){this.title=te,this.insertText=L,this.kind=Ee}};e.$bN=we,e.$bN=we=Je([y],we);let Ae=class{constructor(L,te){this.id=L,this.color=te}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$cN=Ae,e.$cN=Ae=Je([y],Ae),Ae.File=new Ae("file"),Ae.Folder=new Ae("folder");let oe=class{constructor(L){this.id=L}};e.$dN=oe,e.$dN=oe=Je([y],oe);var Q;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Q||(e.ConfigurationTarget=Q={}));let De=class{get base(){return this.c}set base(L){this.c=L,this.e=k.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!k.URI.isUri(L)&&!k.URI.isUri(L.uri)))throw(0,F.$7)("base");if(typeof te!="string")throw(0,F.$7)("pattern");typeof L=="string"?this.baseUri=k.URI.file(L):k.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eN=De,e.$eN=De=Je([y],De);const Le=new WeakMap;function Ye(B,L){Le.set(B,L)}let Ke=class{constructor(L,te,Ee,Ge,_e){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=Le.get(this)??(0,N.$Cg)()),this.c}};e.$gN=Ke,e.$gN=Ke=Je([y],Ke);let ut=class extends Ke{constructor(L,te,Ee,Ge,_e,lt){if(super(te,Ee,Ge,_e,lt),L===null)throw(0,F.$7)("location");this.location=L}};e.$hN=ut,e.$hN=ut=Je([y],ut);let yt=class extends Ke{constructor(L,te,Ee,Ge,_e,lt){super(te,Ee,Ge,_e,lt),this.functionName=L}};e.$iN=yt,e.$iN=yt=Je([y],yt);let Kt=class extends Ke{constructor(L,te,Ee,Ge,_e,lt,gt,Gt){if(super(Ge,_e,lt,gt,Gt),!te)throw(0,F.$7)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};e.$jN=Kt,e.$jN=Kt=Je([y],Kt);let Et=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};e.$kN=Et,e.$kN=Et=Je([y],Et);let Mt=class{constructor(L,te){this.port=L,this.host=te}};e.$lN=Mt,e.$lN=Mt=Je([y],Mt);let Xt=class{constructor(L){this.path=L}};e.$mN=Xt,e.$mN=Xt=Je([y],Xt);let vi=class{constructor(L){this.implementation=L}};e.$nN=vi,e.$nN=vi=Je([y],vi);class yi{constructor(L,te,Ee){this.session=L,this.threadId=te,this.frameId=Ee}}e.$oN=yi;class ft{constructor(L,te){this.session=L,this.threadId=te}}e.$pN=ft;let Ri=class{constructor(L,te){this.range=L,this.expression=te}};e.$qN=Ri,e.$qN=Ri=Je([y],Ri);var fi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(fi||(e.InlineCompletionTriggerKind=fi={}));let $i=class{constructor(L,te){this.range=L,this.text=te}};e.$rN=$i,e.$rN=$i=Je([y],$i);let ki=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$sN=ki,e.$sN=ki=Je([y],ki);let Ai=class{constructor(L,te){this.range=L,this.expression=te}};e.$tN=Ai,e.$tN=Ai=Je([y],Ai);let Fi=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.$uN=Fi,e.$uN=Fi=Je([y],Fi);var Ji;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ji||(e.NewSymbolNameTag=Ji={}));class Qi{constructor(L,te){this.newSymbolName=L,this.tags=te}}e.$vN=Qi;var Xi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ei=g=class extends Error{static FileExists(L){return new g(L,l.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(L){return new g(L,l.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(L){return new g(L,l.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(L){return new g(L,l.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(L){return new g(L,l.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(L){return new g(L,l.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(L,te=l.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,l.$2k)(this,te),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$wN=Ei,e.$wN=Ei=g=Je([y],Ei);let Oi=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};e.$xN=Oi,e.$xN=Oi=Je([y],Oi);var Di;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Di||(e.FoldingRangeKind=Di={}));var Si;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Si||(e.CommentThreadCollapsibleState=Si={}));var Yi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Zi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class ln{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.$yN=ln;function hn(B){return typeof B>"u"||(0,f.$Uf)(B)}class Ti{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this.k.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this.l.set(L.tokenModifiers[te],te)}}push(L,te,Ee,Ge,_e){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(L,te,Ee,Ge,_e);if(U.isRange(L)&&typeof te=="string"&&hn(Ee))return this.o(L,te,Ee);throw(0,F.$7)()}o(L,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,_e=L.start.character,lt=L.end.character-L.start.character,gt=this.k.get(te);let Gt=0;if(Ee)for(const ui of Ee){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ui);Gt|=1<<di>>>0}this.q(Ge,_e,lt,gt,Gt)}q(L,te,Ee,Ge,_e){if(this.f&&(L<this.c||L===this.c&&te<this.e)){this.f=!1;const Gt=this.g.length/5|0;let ui=0,di=0;for(let mi=0;mi<Gt;mi++){let pi=this.g[5*mi],Ki=this.g[5*mi+1];pi===0?(pi=ui,Ki+=di):pi+=ui,this.g[5*mi]=pi,this.g[5*mi+1]=Ki,ui=pi,di=Ki}}let lt=L,gt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=Ee,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=L,this.e=te}static r(L){const te=[],Ee=L.length/5|0;for(let gt=0;gt<Ee;gt++)te[gt]=gt;te.sort((gt,Gt)=>{const ui=L[5*gt],di=L[5*Gt];if(ui===di){const mi=L[5*gt+1],pi=L[5*Gt+1];return mi-pi}return ui-di});const Ge=new Uint32Array(L.length);let _e=0,lt=0;for(let gt=0;gt<Ee;gt++){const Gt=5*te[gt],ui=L[Gt+0],di=L[Gt+1],mi=L[Gt+2],pi=L[Gt+3],Ki=L[Gt+4],An=ui-_e,ir=An===0?di-lt:di,Gi=5*gt;Ge[Gi+0]=An,Ge[Gi+1]=ir,Ge[Gi+2]=mi,Ge[Gi+3]=pi,Ge[Gi+4]=Ki,_e=ui,lt=di}return Ge}build(L){return this.f?new Ni(new Uint32Array(this.g),L):new Ni(Ti.r(this.g),L)}}e.$zN=Ti;class Ni{constructor(L,te){this.resultId=te,this.data=L}}e.$AN=Ni;class dn{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.$BN=dn;class xi{constructor(L,te){this.resultId=te,this.edits=L}}e.$CN=xi;var Li;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Li||(e.DebugConsoleMode=Li={}));class fn{constructor(L){this.name=L}}e.$DN=fn;let Ii=class{static{this.Back={iconPath:new Ae("arrow-left")}}constructor(){}};e.$EN=Ii,e.$EN=Ii=Je([y],Ii);var ji;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var en;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(en||(e.ExtensionKind=en={}));class gn{static validate(L){if(typeof L.badge=="string"){let te=(0,m.$uf)(L.badge,0);if(te<L.badge.length&&(te+=(0,m.$uf)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Ae.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}}e.$FN=gn;let zi=class{constructor(L){this.kind=L}};e.$GN=zi,e.$GN=zi=Je([y],zi);var Ci;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ci||(e.ColorThemeKind=Ci={}));class hi{static isNotebookRange(L){return L instanceof hi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,te){if(L<0)throw(0,F.$7)("start must be positive");if(te<0)throw(0,F.$7)("end must be positive");L<=te?(this.c=L,this.e=te):(this.c=te,this.e=L)}with(L){let te=this.c,Ee=this.e;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this.c&&Ee===this.e?this:new hi(te,Ee)}}e.$HN=hi;class ze{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>ze.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,Ee,Ge,_e,lt,gt){this.kind=L,this.value=te,this.languageId=Ee,this.mime=Ge,this.outputs=_e??[],this.metadata=lt,this.executionSummary=gt,ze.validate(this)}}e.$IN=ze;class gi{constructor(L){this.cells=L}}e.$JN=gi;class ai{static isNotebookCellOutputItem(L){return L instanceof ai?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(L){return ai.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ai.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new ai(L,te)}static#e=new TextEncoder;static text(L,te=R.$vs.text){const Ee=ai.#e.encode(String(L));return new ai(Ee,te)}static json(L,te="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return ai.text(Ee,te)}constructor(L,te){this.data=L,this.mime=te;const Ee=(0,R.$zs)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$KN=ai;class nt{static isNotebookCellOutput(L){return L instanceof nt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,Ge=new Set;for(let _e=0;_e<L.length;_e++){const lt=L[_e],gt=(0,R.$zs)(lt.mime);if(!Ee.has(gt)||(0,d.$_J)(gt)){Ee.add(gt);continue}Ge.add(_e),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?L:L.filter((_e,lt)=>!Ge.has(lt))}constructor(L,te,Ee){this.items=nt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,N.$Cg)(),this.metadata=te??Ee)}}e.$LN=nt;var pt;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(pt||(e.NotebookCellKind=pt={}));var tn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ui;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ui||(e.NotebookEditorRevealType=Ui={}));class mn{constructor(L,te){this.text=L,this.alignment=te}}e.$MN=mn;var wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(wi||(e.NotebookControllerAffinity=wi={}));var rn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class $n{constructor(L,te=[]){this.uri=L,this.provides=(0,S.$3b)(te)}}e.$NN=$n;class pn{constructor(L){this.label=L}}e.$ON=pn;var Bi;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(Bi||(e.NotebookVariablesRequestKind=Bi={}));let Vi=class{constructor(L,te){this.label=L,this.timestamp=te}};e.$PN=Vi,e.$PN=Vi=Je([y],Vi);var sn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(sn||(e.ExtensionMode=sn={}));var on;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(on||(e.ExtensionRuntime=on={}));var an;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class vn{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.$QN=vn;class bn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$RN=bn;var cn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Wi=class{constructor(L=void 0,te=void 0,Ee=void 0,Ge=!1){this.include=L,this.exclude=te,this.profile=Ee,this.continuous=Ge}};e.$SN=Wi,e.$SN=Wi=Je([y],Wi);let qi=D=class{static diff(L,te,Ee){const Ge=new D(L);return Ge.expectedOutput=te,Ge.actualOutput=Ee,Ge}constructor(L){this.message=L}};e.$TN=qi,e.$TN=qi=D=Je([y],qi);let Hi=class{constructor(L){this.id=L}};e.$UN=Hi,e.$UN=Hi=Je([y],Hi);class x{constructor(L,te){this.covered=L,this.total=te}}e.$VN=x;const ae=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Ue{static fromDetails(L,te){const Ee=new x(0,0),Ge=new x(0,0),_e=new x(0,0);for(const gt of te)if("branches"in gt){Ee.total+=1,Ee.covered+=gt.executed?1:0;for(const Gt of gt.branches)Ge.total+=1,Ge.covered+=Gt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const lt=new Ue(L,Ee,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=te,lt}constructor(L,te,Ee,Ge){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ge,ae(te),ae(Ee),ae(Ge)}}e.$WN=Ue;class ct{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee=[]){this.executed=L,this.location=te,this.branches=Ee}}e.$XN=ct;class vt{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.executed=L,this.location=te,this.label=Ee}}e.$YN=vt;class At{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.name=L,this.executed=te,this.location=Ee}}e.$ZN=At;var Pi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Pi||(e.ExternalUriOpenerPriority=Pi={}));var wn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var yn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn||(e.PortAutoForwardAction=yn={}));class Fn{constructor(L,te,Ee,Ge,_e,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$1N=Fn;class On{constructor(L){this.uri=L}}e.$2N=On;class Tn{constructor(L,te){this.original=L,this.modified=te}}e.$3N=Tn;class Nn{constructor(L,te,Ee,Ge){this.base=L,this.input1=te,this.input2=Ee,this.result=Ge}}e.$4N=Nn;class Ln{constructor(L,te){this.uri=L,this.viewType=te}}e.$5N=Ln;class jn{constructor(L){this.viewType=L}}e.$6N=jn;class zn{constructor(L,te){this.uri=L,this.notebookType=te}}e.$7N=zn;class Un{constructor(L,te,Ee){this.original=L,this.modified=te,this.notebookType=Ee}}e.$8N=Un;class Bn{constructor(){}}e.$9N=Bn;class Vn{constructor(L,te){this.uri=L,this.inputBoxUri=te}}e.$0N=Vn;class Wn{constructor(L){this.providerId=L}}e.$$N=Wn;var kn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var En;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var Dn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class qn{constructor(L,te){this.label=L,this.values=te}}e.$_N=qn;var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(In||(e.ChatResultFeedbackKind=In={}));class Hn{constructor(L){this.value=typeof L=="string"?new Oe(L):L}}e.$aO=Hn;class Kn{constructor(L,te){this.value=L,this.baseUri=te}}e.$bO=Kn;class Gn{constructor(L,te){this.value=L,this.title=te}}e.$cO=Gn;class Jn{constructor(L){this.value=L}}e.$dO=Jn;class Qn{constructor(L){this.value=L}}e.$eO=Qn;class Xn{constructor(L){this.value=L}}e.$fO=Xn;class Yn{constructor(L,te,Ee,Ge){this.prompt=L,this.command=te,this.variables=Ee,this.participant=Ge}}e.$gO=Yn;class Zn{constructor(L,te,Ee,Ge){this.response=L,this.result=te,this.participant=Ee,this.command=Ge}}e.$hO=Zn;class xn{constructor(L){this.content=L}}e.$iO=xn;class _n{constructor(L,te){this.content=L,this.name=te}}e.$jO=_n;class er{constructor(L){this.content=L}}e.$kO=er;class Mi extends Error{static NotFound(L){return new Mi(L,Mi.NotFound.name)}static NoPermissions(L){return new Mi(L,Mi.NoPermissions.name)}constructor(L,te,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$lO=Mi;var Cn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Pn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Pn||(e.SpeechToTextStatus=Pn={}));var Mn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class tr{constructor(L,te){this.text=L,this.range=te}}e.$mO=tr;var Rn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(Pe[243],Me([1,0,4,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$eM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,f){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(m,f)??[]}getRelatedInformation(R,m,f){return this.c.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(R,m,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiRelatedInformationProvider(k,m),new F.$gM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$pic=M}),define(Pe[84],Me([1,0,5,4,7,20,106,3,17]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=void 0,e.$Aic=(0,m.$gi)("IExtHostAuthentication");let k=class{constructor(l){this.b=new Map,this.c=new S.$6d,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=l.getProxy(F.$eM.MainThreadAuthentication)}async getSession(l,w,d,s={}){const a=O.$Bm.toKey(l.identifier),r=[...d].sort().join(" ");return await this.d.getOrCreate(`${a} ${w} ${r}`,async()=>{await this.a.$ensureProvider(w);const i=l.displayName||l.name;return this.a.$getSession(w,d,a,i,s)})}async getSessions(l,w,d){const s=O.$Bm.toKey(l.identifier),a=[...d].sort().join(" ");return await this.f.getOrCreate(`${s} ${a}`,async()=>{await this.a.$ensureProvider(w);const r=l.displayName||l.name;return this.a.$getSessions(w,d,s,r)})}async removeSession(l,w){const d=this.b.get(l);return d?d.provider.removeSession(w):this.a.$removeSession(l,w)}registerAuthenticationProvider(l,w,d,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:w,provider:d,options:s??{supportsMultipleAccounts:!1}});const a=d.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(l,r));return this.a.$registerAuthenticationProvider(l,w,s?.supportsMultipleAccounts??!1),new M.$gM(()=>{a.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,w,d){const s=this.b.get(l);if(s)return Promise.resolve(s.provider.createSession(w,d));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,w){const d=this.b.get(l);if(d)return Promise.resolve(d.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,w){const d=this.b.get(l);if(d)return Promise.resolve(d.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,w){return l.startsWith(R.$gL)||this.c.fire({provider:{id:l,label:w}}),Promise.resolve()}};e.$Bic=k,e.$Bic=k=Je([qe(0,f.$xO)],k);class N{constructor(){this.a=new Map}getOrCreate(l,w){const d=this.a.get(l);if(d)return d;const s=w().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Pe[110],Me([1,0,2,4,7,3,17,13,18,15,19,22]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=void 0;let w=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,a){this.h=a,this.f=new Map,this.g=s.getProxy(F.$eM.MainThreadDecorations)}registerFileDecorationProvider(s,a){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:a}),this.g.$registerDecorationProvider(r,a.identifier.value);const i=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(r,null);return}const c=(0,f.$3b)(n);if(c.length<=l.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,k.$Ze)(u.path,"/")})),t=(0,f.$zb)(h,(u,o)=>u.rank-o.rank||(0,k.$df)(u.uri.path,o.uri.path)),p=[];e:for(const u of t){let o;for(const v of u){const b=(0,N.$mc)(v.uri.path);if(o!==b&&(o=b,p.push(v.uri)>=l.d))break e}}this.g.$onDidChange(r,p)});return new M.$gM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,a,r){if(!this.f.has(s))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(s);return await Promise.all(a.map(async h=>{try{const{uri:t,id:p}=h,u=await Promise.resolve(n.provideFileDecoration(S.URI.revive(t),r));if(!u)return;try{M.$FN.validate(u),u.badge&&typeof u.badge!="string"&&(0,E.$4F)(c,"codiconDecoration"),i[p]=[u.propagate,u.tooltip,u.badge,u.color]}catch(o){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),i}};e.$Bjc=w,e.$Bjc=w=l=Je([qe(0,R.$xO),qe(1,m.$Mj)],w),e.$Cjc=(0,O.$gi)("IExtHostDecorations")}),define(Pe[244],Me([1,0,14,2,7,4,12,25,15]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;class k{static{this.a=0}constructor(E,l,w){this.d=l,this.e=w,this.b=new Map,this.c=E.getProxy(O.$eM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,l){if(Object.keys(R.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const w=k.a++;this.b.set(w,l),this.c.$registerTextContentProvider(w,E);let d;if(typeof l.onDidChange=="function"){let s;d=l.onDidChange(async a=>{if(a.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;s&&await s;const r=this.$provideTextDocumentContent(w,a).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(a);if(!n)return;const c=(0,f.$0e)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(a,i)}).catch(S.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new M.$gM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(E,l){const w=this.b.get(E);return w?Promise.resolve(w.provideTextDocumentContent(F.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Ejc=k}),define(Pe[111],Me([1,0,55,12,15,300,150,7,18]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=void 0,e.$zO=N;const k=new Map;function N(d,s){s?k.set(d,s):k.delete(d)}function E(d){return k.get(d)}class l extends O.$Dv{constructor(s,a,r,i,n,c,h){super(a,r,i,n),this.c=s,this.m=c,this.q=h,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===F.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(a){return a?s.s(a):s.getText()},get eol(){return s.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(a){return s.t(a)},offsetAt(a){return s.u(a)},positionAt(a){return s.v(a)},validateRange(a){return s.w(a)},validatePosition(a){return s.x(a)},getWordRangeAtPosition(a,r){return s.y(a,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const a=this.w(s);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const r=this.g,i=a.start.line,n=a.end.line,c=[];c.push(this.f[i].substring(a.start.character));for(let h=i+1;h<n;h++)c.push(this.f[h]);return c.push(this.f[n].substring(0,a.end.character)),c.join(r)}t(s){let a;if(s instanceof m.$hM?a=s.line:typeof s=="number"&&(a=s),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new w(a,this.f[a],a===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const a=this.j.getIndexOf(s),r=this.f[a.index].length;return new m.$hM(a.index,Math.min(a.remainder,r))}w(s){if(!(s instanceof m.$iM))throw new Error("Invalid argument");const a=this.x(s.start),r=this.x(s.end);return a===s.start&&r===s.end?s:new m.$iM(a.line,a.character,r.line,r.character)}x(s){if(!(s instanceof m.$hM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:a,character:r}=s,i=!1;if(a<0)a=0,r=0,i=!0;else if(a>=this.f.length)a=this.f.length-1,r=this.f[a].length,i=!0;else{const n=this.f[a].length;r<0?(r=0,i=!0):r>n&&(r=n,i=!0)}return i?new m.$hM(a,r):s}y(s,a){const r=this.x(s);if(!a)a=E(this.m);else if((0,M.$9e)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const i=(0,R.$Ns)(r.character+1,(0,R.$Ls)(a),this.f[r.line],0);if(i)return new m.$iM(r.line,i.startColumn-1,r.line,i.endColumn-1)}}e.$AO=l;class w{constructor(s,a,r){this.a=s,this.b=a,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$iM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$iM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$BO=w}),define(Pe[245],Me([1,0,4,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$eM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const N=await k.provideEmbeddingVector(m,f);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(R,m,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiEmbeddingVectorProvider(m,k),new F.$gM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Gjc=M}),define(Pe[63],Me([1,0,4,42,7,23,3,17,43,6,11,24,12]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=void 0;let d=w=class{constructor(a,r){this.b=new Map,this.c=new N.$ph,this.a=a.getProxy(S.$eM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const h=i.b.get(n.scheme);return h?(await i.a.$ensureActivation(n.scheme),c=await h.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===F.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return w.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return w.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return w.e(c)}},async writeFile(n,c){try{const h=i.b.get(n.scheme);return h&&!h.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(h.impl,h.extUri,h.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(h.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,O.$te.wrap(c))}catch(h){return w.e(h)}},async delete(n,c){try{const h=i.b.get(n.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await h.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return w.e(h)}},async rename(n,c,h){try{return await i.a.$rename(n,c,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(n,c,h){try{return await i.a.$copy(n,c,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(n){const c=r.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(a,r,i){const n=[];for(;!r.isEqual(i,r.dirname(i));)try{if(!((await a.stat(i)).type&F.FileType.Directory))throw M.$wN.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(F.$3k(c)!==F.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(r.basename(i)),i=r.dirname(i)}for(let c=n.length-1;c>=0;c--){i=r.joinPath(i,n[c]);try{await a.createDirectory(i)}catch(h){if(F.$3k(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof M.$wN)throw a;if(a instanceof F.$Yk)switch(a.code){case F.FileSystemProviderErrorCode.FileExists:throw M.$wN.FileExists(a.message);case F.FileSystemProviderErrorCode.FileNotFound:throw M.$wN.FileNotFound(a.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw M.$wN.FileNotADirectory(a.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw M.$wN.FileIsADirectory(a.message);case F.FileSystemProviderErrorCode.NoPermissions:throw M.$wN.NoPermissions(a.message);case F.FileSystemProviderErrorCode.Unavailable:throw M.$wN.Unavailable(a.message);default:throw new M.$wN(a.message,a.name)}if(!(a instanceof Error))throw new M.$wN(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw M.$wN.Unavailable(a.message);switch(a.name){case F.FileSystemProviderErrorCode.FileExists:throw M.$wN.FileExists(a.message);case F.FileSystemProviderErrorCode.FileNotFound:throw M.$wN.FileNotFound(a.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw M.$wN.FileNotADirectory(a.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw M.$wN.FileIsADirectory(a.message);case F.FileSystemProviderErrorCode.NoPermissions:throw M.$wN.NoPermissions(a.message);case F.FileSystemProviderErrorCode.Unavailable:throw M.$wN.Unavailable(a.message);default:throw new M.$wN(a.message,a.name)}}addFileSystemProvider(a,r,i){return this.b.set(a,{impl:r,extUri:i?.isCaseSensitive?E.$Jg:E.$Lg,isReadonly:!!i?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??E.$Jg}};e.$Tic=d,e.$Tic=d=w=Je([qe(0,m.$xO),qe(1,f.$uic)],d),e.$Uic=(0,R.$gi)("IExtHostConsumerFileSystem")}),define(Pe[246],Me([1,0,4,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;class M{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$eM.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const k=await f.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueData(m);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueTemplate(m);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(R,m){const f=R.identifier.value;return this.a.set(f,m),this.c.$registerIssueUriRequestHandler(f),new F.$gM(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,m){const f=R.identifier.value;return this.b.set(f,m),this.c.$registerIssueDataProvider(f),new F.$gM(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$Xjc=M}),define(Pe[85],Me([1,0,3,27,13,63,2]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=void 0,e.$Vic=(0,S.$gi)("IExtensionStoragePaths");let m=class{constructor(k,N,E){this.d=N,this.f=E,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(R.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Wic=m,e.$Wic=m=Je([qe(0,F.$NO),qe(1,M.$Mj),qe(2,O.$Uic)],m)}),define(Pe[247],Me([1,0,7,17,5]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;let O=class{constructor(m){this.a=new S.$GN(S.ColorThemeKind.Dark),this.b=new M.$6d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let f;switch(m){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$GN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$okc=O,e.$okc=O=Je([qe(0,F.$xO)],O)}),define(Pe[86],Me([1,0,25,5,6,172,3,13,201,4,27,17,7]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PAb=e.$OAb=e.TunnelDtoConverter=void 0;class w extends f.$3v{}var d;(function(a){function r(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:n.protocol}}a.fromApiTunnel=r;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==f.TunnelPrivacyId.ConstantPrivate&&n.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}a.fromServiceTunnel=i})(d||(e.TunnelDtoConverter=d={})),e.$OAb=(0,R.$gi)("IExtHostTunnelService");let s=class extends M.$Tc{constructor(r,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$6d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(k.$eM.MainThreadTunnelService)}async openTunnel(r,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,r.displayName);if(n){const c=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,i){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:r,provider:i}),this.a.$registerPortsAttributesProvider(r,n),new l.$gM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(r,i,n,c,h){const t=[];for(const u of r){const o=this.r.get(u);if(!o)return[];t.push(...await Promise.all(i.map(async v=>{let b;try{b=await o.provider.providePortAttributes({port:v,pid:n,commandLine:c},h)}catch{b=await o.provider.providePortAttributes(v,n,c,h)}return{providedAttributes:b,port:v}})))}const p=t.filter(u=>!!u.providedAttributes);return p.length>0?p.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,S.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,M.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,i){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const n=r.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,M.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,i){if(this.g.has(r.host)){const n=this.g.get(r.host);n.has(r.port)&&(i&&n.get(r.port).disposeListener.dispose(),await n.get(r.port).tunnel.dispose(),n.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(r,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),d.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(r){const i=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),n=r.filter((c,h)=>i[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$PAb=s,e.$PAb=s=Je([qe(0,E.$xO),qe(1,N.$NO),qe(2,m.$Mj)],s)}),define(Pe[8],Me([1,0,18,23,130,248,53,28,123,52,69,26,24,16,2,29,87,100,105,104,83,48,60,220,22,7]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$uO=C,e.$vO=q,e.$wO=ne;var v;(function(we){function Ae(Q){const{selectionStartLineNumber:De,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:Ke}=Q,ut=new o.$hM(De-1,Le-1),yt=new o.$hM(Ye-1,Ke-1);return new o.$jM(ut,yt)}we.to=Ae;function oe(Q){const{anchor:De,active:Le}=Q;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}we.from=oe})(v||(e.Selection=v={}));var b;(function(we){function Ae(Q){if(!Q)return;const{start:De,end:Le}=Q;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}we.from=Ae;function oe(Q){if(!Q)return;const{startLineNumber:De,startColumn:Le,endLineNumber:Ye,endColumn:Ke}=Q;return new o.$iM(De-1,Le-1,Ye-1,Ke-1)}we.to=oe})(b||(e.Range=b={}));var $;(function(we){function Ae(Q){return{uri:Q.uri,range:b.from(Q.range)}}we.from=Ae;function oe(Q){return new o.$sM(d.URI.revive(Q.uri),b.to(Q.range))}we.to=oe})($||(e.Location=$={}));var I;(function(we){function Ae(oe){switch(oe){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}we.to=Ae})(I||(e.TokenType=I={}));var g;(function(we){function Ae(Q){return new o.$hM(Q.lineNumber-1,Q.column-1)}we.to=Ae;function oe(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=oe})(g||(e.Position=g={}));var D;(function(we){function Ae(De,Le,Ye){return(0,S.$Hb)((0,S.$3b)(De).map(Ke=>oe(Ke,Le,Ye)))}we.from=Ae;function oe(De,Le,Ye){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:Ye?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:Q(De.scheme,Le),pattern:X.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:Ye?.isBuiltin}}function Q(De,Le){return Le&&typeof De=="string"?Le.transformOutgoingScheme(De):De}})(D||(e.DocumentSelector=D={}));var y;(function(we){function Ae(Q){switch(Q){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}we.from=Ae;function oe(Q){switch(Q){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}we.to=oe})(y||(e.DiagnosticTag=y={}));var P;(function(we){function Ae(Q){let De;return Q.code&&((0,w.$Tf)(Q.code)||(0,w.$Xf)(Q.code)?De=String(Q.code):De={value:String(Q.code.value),target:Q.code.target}),{...b.from(Q.range),message:Q.message,source:Q.source,code:De,severity:G.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(A.from),tags:Array.isArray(Q.tags)?(0,S.$Hb)(Q.tags.map(y.from)):void 0}}we.from=Ae;function oe(Q){const De=new o.$uM(b.to(Q),Q.message,G.to(Q.severity));return De.source=Q.source,De.code=(0,w.$Tf)(Q.code)?Q.code:Q.code?.value,De.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(A.to),De.tags=Q.tags&&(0,S.$Hb)(Q.tags.map(y.to)),De}we.to=oe})(P||(e.Diagnostic=P={}));var A;(function(we){function Ae(Q){return{...b.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Ae;function oe(Q){return new o.$tM(new o.$sM(Q.resource,b.to(Q)),Q.message)}we.to=oe})(A||(e.DiagnosticRelatedInformation=A={}));var G;(function(we){function Ae(Q){switch(Q){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}we.from=Ae;function oe(Q){switch(Q){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}we.to=oe})(G||(e.DiagnosticSeverity=G={}));var W;(function(we){function Ae(Q){return typeof Q=="number"&&Q>=o.ViewColumn.One?Q-1:Q===o.ViewColumn.Beside?p.$xD:p.$wD}we.from=Ae;function oe(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(W||(e.ViewColumn=W={}));function U(we){return typeof we.range<"u"}function C(we){return we.length===0?!0:!!U(we[0])}var T;(function(we){function Ae(Ke){return Ke.map(we.from)}we.fromMany=Ae;function oe(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let ut;if(oe(Ke)){const{language:Mt,value:Xt}=Ke;ut={value:"```"+Mt+`
`+Xt+"\n```\n"}}else o.$HM.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Kt=Mt=>{try{let Xt=d.URI.parse(Mt,!0);Xt=Xt.with({query:De(Xt.query,yt)}),yt[Mt]=Xt}catch{}return""},Et=new f.marked.Renderer;return Et.link=Kt,Et.image=Mt=>typeof Mt=="string"?Kt(R.$Lk(Mt).href):"",(0,f.marked)(ut.value,{renderer:Et}),ut}we.from=Q;function De(Ke,ut){if(!Ke)return Ke;let yt;try{yt=(0,k.$Oh)(Ke)}catch{}if(!yt)return Ke;let Kt=!1;return yt=(0,E.$On)(yt,Et=>{if(d.URI.isUri(Et)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Mt]=Et,Kt=!0,Mt}else return}),Kt?JSON.stringify(yt):Ke}function Le(Ke){const ut=new o.$HM(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut.supportHtml=Ke.supportHtml,ut.baseUri=Ke.baseUri?d.URI.from(Ke.baseUri):void 0,ut}we.to=Le;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:we.from(Ke)}we.fromStrict=Ye})(T||(e.MarkdownString=T={}));function q(we){return C(we)?we.map(Ae=>({range:b.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?T.fromMany(Ae.hoverMessage):Ae.hoverMessage?T.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):we.map(Ae=>({range:b.from(Ae)}))}function ne(we){return typeof we>"u"?we:typeof we=="string"?d.URI.file(we):we}var ce;(function(we){function Ae(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ne(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=Ae})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var ye;(function(we){function Ae(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ne(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ce.from(oe.before):void 0,after:oe.after?ce.from(oe.after):void 0}}we.from=Ae})(ye||(e.ThemableDecorationRenderOptions=ye={}));var Ie;(function(we){function Ae(oe){if(typeof oe>"u")return oe;switch(oe){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ae})(Ie||(e.DecorationRangeBehavior=Ie={}));var ue;(function(we){function Ae(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?Ie.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?ye.from(oe.light):void 0,dark:oe.dark?ye.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ne(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ce.from(oe.before):void 0,after:oe.after?ce.from(oe.after):void 0}}we.from=Ae})(ue||(e.DecorationRenderOptions=ue={}));var ve;(function(we){function Ae(Q){return{text:Q.newText,eol:Q.newEol&&tt.from(Q.newEol),range:b.from(Q.range)}}we.from=Ae;function oe(Q){const De=new o.$nM(b.to(Q.range),Q.text);return De.newEol=typeof Q.eol>"u"?void 0:tt.to(Q.eol),De}we.to=oe})(ve||(e.TextEdit=ve={}));var re;(function(we){function Ae(Q,De){const Le={edits:[]};if(Q instanceof o.$qM){const Ye=new m.$Bc;for(const Ke of Q._allEntries())Ke._type===1&&d.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of Q._allEntries())if(Ke._type===1){let ut;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ut={type:"base64",value:(0,F.$Ne)(F.$te.wrap(Ke.options.contents))}:ut={type:"dataTransferItem",id:Ke.options.contents._itemId}),Le.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ut},metadata:Ke.metadata})}else Ke._type===2?Le.edits.push({resource:Ke.uri,textEdit:ve.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:De?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Le.edits.push({resource:Ke.uri,textEdit:{range:b.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:De?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Le.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Le.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:De?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(jt.from)}})}return Le}we.from=Ae;function oe(Q){const De=new o.$qM,Le=new m.$Ac;for(const Ye of Q.edits)if(Ye.textEdit){const Ke=Ye,ut=d.URI.revive(Ke.resource),yt=b.to(Ke.textEdit.range),Kt=Ke.textEdit.text,Et=Ke.textEdit.insertAsSnippet;let Mt;Et?Mt=o.$pM.replace(yt,new o.$rM(Kt)):Mt=o.$nM.replace(yt,Kt);const Xt=Le.get(ut);Xt?Xt.push(Mt):Le.set(ut,[Mt])}else De.renameFile(d.URI.revive(Ye.oldResource),d.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Le)De.set(Ye,Ke);return De}we.to=oe})(re||(e.WorkspaceEdit=re={}));var $e;(function(we){const Ae=Object.create(null);Ae[o.SymbolKind.File]=0,Ae[o.SymbolKind.Module]=1,Ae[o.SymbolKind.Namespace]=2,Ae[o.SymbolKind.Package]=3,Ae[o.SymbolKind.Class]=4,Ae[o.SymbolKind.Method]=5,Ae[o.SymbolKind.Property]=6,Ae[o.SymbolKind.Field]=7,Ae[o.SymbolKind.Constructor]=8,Ae[o.SymbolKind.Enum]=9,Ae[o.SymbolKind.Interface]=10,Ae[o.SymbolKind.Function]=11,Ae[o.SymbolKind.Variable]=12,Ae[o.SymbolKind.Constant]=13,Ae[o.SymbolKind.String]=14,Ae[o.SymbolKind.Number]=15,Ae[o.SymbolKind.Boolean]=16,Ae[o.SymbolKind.Array]=17,Ae[o.SymbolKind.Object]=18,Ae[o.SymbolKind.Key]=19,Ae[o.SymbolKind.Null]=20,Ae[o.SymbolKind.EnumMember]=21,Ae[o.SymbolKind.Struct]=22,Ae[o.SymbolKind.Event]=23,Ae[o.SymbolKind.Operator]=24,Ae[o.SymbolKind.TypeParameter]=25;function oe(De){return typeof Ae[De]=="number"?Ae[De]:6}we.from=oe;function Q(De){for(const Le in Ae)if(Ae[Le]===De)return Number(Le);return o.SymbolKind.Property}we.to=Q})($e||(e.SymbolKind=$e={}));var ie;(function(we){function Ae(Q){switch(Q){case o.SymbolTag.Deprecated:return 1}}we.from=Ae;function oe(Q){switch(Q){case 1:return o.SymbolTag.Deprecated}}we.to=oe})(ie||(e.SymbolTag=ie={}));var le;(function(we){function Ae(Q){return{name:Q.name,kind:$e.from(Q.kind),tags:Q.tags&&Q.tags.map(ie.from),containerName:Q.containerName,location:Se.from(Q.location)}}we.from=Ae;function oe(Q){const De=new o.$yM(Q.name,$e.to(Q.kind),Q.containerName,Se.to(Q.location));return De.tags=Q.tags&&Q.tags.map(ie.to),De}we.to=oe})(le||(e.WorkspaceSymbol=le={}));var V;(function(we){function Ae(Q){const De={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:b.from(Q.range),selectionRange:b.from(Q.selectionRange),kind:$e.from(Q.kind),tags:Q.tags?.map(ie.from)??[]};return Q.children&&(De.children=Q.children.map(Ae)),De}we.from=Ae;function oe(Q){const De=new o.$zM(Q.name,Q.detail,$e.to(Q.kind),b.to(Q.range),b.to(Q.selectionRange));return(0,S.$Lb)(Q.tags)&&(De.tags=Q.tags.map(ie.to)),Q.children&&(De.children=Q.children.map(oe)),De}we.to=oe})(V||(e.DocumentSymbol=V={}));var ee;(function(we){function Ae(Q){const De=new o.$DM($e.to(Q.kind),Q.name,Q.detail||"",d.URI.revive(Q.uri),b.to(Q.range),b.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Ae;function oe(Q,De,Le){if(De=De??Q._sessionId,Le=Le??Q._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,name:Q.name,detail:Q.detail,kind:$e.from(Q.kind),uri:Q.uri,range:b.from(Q.range),selectionRange:b.from(Q.selectionRange),tags:Q.tags?.map(ie.from)}}we.from=oe})(ee||(e.CallHierarchyItem=ee={}));var ke;(function(we){function Ae(oe){return new o.$EM(ee.to(oe.from),oe.fromRanges.map(Q=>b.to(Q)))}we.to=Ae})(ke||(e.CallHierarchyIncomingCall=ke={}));var Ne;(function(we){function Ae(oe){return new o.$FM(ee.to(oe.to),oe.fromRanges.map(Q=>b.to(Q)))}we.to=Ae})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var Se;(function(we){function Ae(Q){return{range:Q.range&&b.from(Q.range),uri:Q.uri}}we.from=Ae;function oe(Q){return new o.$sM(d.URI.revive(Q.uri),b.to(Q.range))}we.to=oe})(Se||(e.location=Se={}));var be;(function(we){function Ae(Q){const De=Q,Le=Q;return{originSelectionRange:De.originSelectionRange?b.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Le.uri,range:b.from(De.targetRange?De.targetRange:Le.range),targetSelectionRange:De.targetSelectionRange?b.from(De.targetSelectionRange):void 0}}we.from=Ae;function oe(Q){return{targetUri:d.URI.revive(Q.uri),targetRange:b.to(Q.range),targetSelectionRange:Q.targetSelectionRange?b.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?b.to(Q.originSelectionRange):void 0}}we.to=oe})(be||(e.DefinitionLink=be={}));var ge;(function(we){function Ae(Q){return{range:b.from(Q.range),contents:T.fromMany(Q.contents)}}we.from=Ae;function oe(Q){return new o.$vM(Q.contents.map(T.to),b.to(Q.range))}we.to=oe})(ge||(e.Hover=ge={}));var J;(function(we){function Ae(Q){return{range:b.from(Q.range),expression:Q.expression}}we.from=Ae;function oe(Q){return new o.$qN(b.to(Q.range),Q.expression)}we.to=oe})(J||(e.EvaluatableExpression=J={}));var Z;(function(we){function Ae(Q){if(Q instanceof o.$rN)return{type:"text",range:b.from(Q.range),text:Q.text};if(Q instanceof o.$sN)return{type:"variable",range:b.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof o.$tN)return{type:"expression",range:b.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ae;function oe(Q){switch(Q.type){case"text":return{range:b.to(Q.range),text:Q.text};case"variable":return{range:b.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:b.to(Q.range),expression:Q.expression}}}we.to=oe})(Z||(e.InlineValue=Z={}));var he;(function(we){function Ae(Q){return{frameId:Q.frameId,stoppedLocation:b.from(Q.stoppedLocation)}}we.from=Ae;function oe(Q){return new o.$uN(Q.frameId,b.to(Q.stoppedLocation))}we.to=oe})(he||(e.InlineValueContext=he={}));var fe;(function(we){function Ae(Q){return{range:b.from(Q.range),kind:Q.kind}}we.from=Ae;function oe(Q){return new o.$wM(b.to(Q.range),Q.kind)}we.to=oe})(fe||(e.DocumentHighlight=fe={}));var Te;(function(we){function Ae(Q){return{uri:Q.uri,highlights:Q.highlights.map(fe.from)}}we.from=Ae;function oe(Q){return new o.$xM(d.URI.revive(Q.uri),Q.highlights.map(fe.to))}we.to=oe})(Te||(e.MultiDocumentHighlight=Te={}));var de;(function(we){function Ae(oe){switch(oe){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}we.to=Ae})(de||(e.CompletionTriggerKind=de={}));var Ce;(function(we){function Ae(oe){return{triggerKind:de.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=Ae})(Ce||(e.CompletionContext=Ce={}));var Re;(function(we){function Ae(Q){switch(Q){case o.CompletionItemTag.Deprecated:return 1}}we.from=Ae;function oe(Q){switch(Q){case 1:return o.CompletionItemTag.Deprecated}}we.to=oe})(Re||(e.CompletionItemTag=Re={}));var je;(function(we){const Ae=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function oe(Le){return Ae.get(Le)??9}we.from=oe;const Q=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function De(Le){return Q.get(Le)??o.CompletionItemKind.Property}we.to=De})(je||(e.CompletionItemKind=je={}));var z;(function(we){function Ae(oe,Q){const De=new o.$NM(oe.label);return De.insertText=oe.insertText,De.kind=je.to(oe.kind),De.tags=oe.tags?.map(Re.to),De.detail=oe.detail,De.documentation=R.$Fk(oe.documentation)?T.to(oe.documentation):oe.documentation,De.sortText=oe.sortText,De.filterText=oe.filterText,De.preselect=oe.preselect,De.commitCharacters=oe.commitCharacters,s.$$s.isIRange(oe.range)?De.range=b.to(oe.range):typeof oe.range=="object"&&(De.range={inserting:b.to(oe.range.insert),replacing:b.to(oe.range.replace)}),De.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?De.insertText=new o.$rM(oe.insertText):(De.insertText=oe.insertText,De.textEdit=De.range instanceof o.$iM?new o.$nM(De.range,De.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(De.additionalTextEdits=oe.additionalTextEdits.map(Le=>ve.to(Le))),De.command=Q&&oe.command?Q.fromInternal(oe.command):void 0,De}we.to=Ae})(z||(e.CompletionItem=z={}));var j;(function(we){function Ae(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:T.fromStrict(Q.documentation)}}we.from=Ae;function oe(Q){return{label:Q.label,documentation:R.$Fk(Q.documentation)?T.to(Q.documentation):Q.documentation}}we.to=oe})(j||(e.ParameterInformation=j={}));var K;(function(we){function Ae(Q){return{label:Q.label,documentation:T.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.from):[],activeParameter:Q.activeParameter}}we.from=Ae;function oe(Q){return{label:Q.label,documentation:R.$Fk(Q.documentation)?T.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.to):[],activeParameter:Q.activeParameter}}we.to=oe})(K||(e.SignatureInformation=K={}));var H;(function(we){function Ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(K.from):[]}}we.from=Ae;function oe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(K.to):[]}}we.to=oe})(H||(e.SignatureHelp=H={}));var _;(function(we){function Ae(oe,Q){const De=new o.$MM(g.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(se.to.bind(void 0,oe)),Q.kind&&Oe.to(Q.kind));return De.textEdits=Q.textEdits&&Q.textEdits.map(ve.to),De.tooltip=R.$Fk(Q.tooltip)?T.to(Q.tooltip):Q.tooltip,De.paddingLeft=Q.paddingLeft,De.paddingRight=Q.paddingRight,De}we.to=Ae})(_||(e.InlayHint=_={}));var se;(function(we){function Ae(oe,Q){const De=new o.$LM(Q.label);return De.tooltip=R.$Fk(Q.tooltip)?T.to(Q.tooltip):Q.tooltip,a.Command.is(Q.command)&&(De.command=oe.fromInternal(Q.command)),Q.location&&(De.location=Se.to(Q.location)),De}we.to=Ae})(se||(e.InlayHintLabelPart=se={}));var Oe;(function(we){function Ae(Q){return Q}we.from=Ae;function oe(Q){return Q}we.to=oe})(Oe||(e.InlayHintKind=Oe={}));var Ve;(function(we){function Ae(Q){return{range:b.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Ae;function oe(Q){let De;if(Q.url)try{De=typeof Q.url=="string"?d.URI.parse(Q.url,!0):d.URI.revive(Q.url)}catch{}return new o.$SM(b.to(Q.range),De)}we.to=oe})(Ve||(e.DocumentLink=Ve={}));var Qe;(function(we){function Ae(Q){const De=new o.$VM(Q.label);return Q.textEdit&&(De.textEdit=ve.to(Q.textEdit)),Q.additionalTextEdits&&(De.additionalTextEdits=Q.additionalTextEdits.map(Le=>ve.to(Le))),De}we.to=Ae;function oe(Q){return{label:Q.label,textEdit:Q.textEdit?ve.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(De=>ve.from(De)):void 0}}we.from=oe})(Qe||(e.ColorPresentation=Qe={}));var xe;(function(we){function Ae(Q){return new o.$TM(Q[0],Q[1],Q[2],Q[3])}we.to=Ae;function oe(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=oe})(xe||(e.Color=xe={}));var et;(function(we){function Ae(Q){return{range:b.from(Q.range)}}we.from=Ae;function oe(Q){return new o.$CM(b.to(Q.range))}we.to=oe})(et||(e.SelectionRange=et={}));var ot;(function(we){function Ae(oe){switch(oe){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}we.to=Ae})(ot||(e.TextDocumentSaveReason=ot={}));var rt;(function(we){function Ae(Q){switch(Q){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ae;function oe(Q){switch(Q){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}we.to=oe})(rt||(e.TextEditorLineNumbersStyle=rt={}));var tt;(function(we){function Ae(Q){if(Q===o.EndOfLine.CRLF)return 1;if(Q===o.EndOfLine.LF)return 0}we.from=Ae;function oe(Q){if(Q===1)return o.EndOfLine.CRLF;if(Q===0)return o.EndOfLine.LF}we.to=oe})(tt||(e.EndOfLine=tt={}));var at;(function(we){function Ae(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ae})(at||(e.ProgressLocation=at={}));var Be;(function(we){function Ae(Q){const De={start:Q.start+1,end:Q.end+1};return Q.kind&&(De.kind=it.from(Q.kind)),De}we.from=Ae;function oe(Q){const De={start:Q.start-1,end:Q.end-1};return Q.kind&&(De.kind=it.to(Q.kind)),De}we.to=oe})(Be||(e.FoldingRange=Be={}));var it;(function(we){function Ae(Q){if(Q)switch(Q){case o.FoldingRangeKind.Comment:return a.$3t.Comment;case o.FoldingRangeKind.Imports:return a.$3t.Imports;case o.FoldingRangeKind.Region:return a.$3t.Region}}we.from=Ae;function oe(Q){if(Q)switch(Q.value){case a.$3t.Comment.value:return o.FoldingRangeKind.Comment;case a.$3t.Imports.value:return o.FoldingRangeKind.Imports;case a.$3t.Region.value:return o.FoldingRangeKind.Region}}we.to=oe})(it||(e.FoldingRangeKind=it={}));var Y;(function(we){function Ae(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?b.from(oe.selection):void 0,override:typeof oe.override=="boolean"?n.$ZE.id:void 0}}we.from=Ae})(Y||(e.TextEditorOpenOptions=Y={}));var X;(function(we){function Ae(Le){return Le instanceof o.$eN?Le.toJSON():typeof Le=="string"?Le:oe(Le)||Q(Le)?new o.$eN(Le.baseUri??Le.base,Le.pattern).toJSON():Le}we.from=Ae;function oe(Le){const Ye=Le;return Ye?d.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Q(Le){const Ye=Le;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function De(Le){return typeof Le=="string"?Le:new o.$eN(d.URI.revive(Le.baseUri),Le.pattern)}we.to=De})(X||(e.GlobPattern=X={}));var pe;(function(we){function Ae(oe){if(oe){if(Array.isArray(oe))return oe.map(Ae);if(typeof oe=="string")return oe;{const Q=oe;return{language:Q.language,scheme:Q.scheme,pattern:X.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Ae})(pe||(e.LanguageSelector=pe={}));var We;(function(we){function Ae(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(De=>Array.isArray(De)&&De.every(Le=>Le&&typeof Le=="object"&&"uri"in Le&&d.URI.isUri(Le.uri)&&"version"in Le&&typeof Le.version=="number"&&"ranges"in Le&&Array.isArray(Le.ranges)&&Le.ranges.every(Ye=>Ye instanceof o.$iM)))}we.is=Ae;function oe(Q){return{documents:Q.documents.map(De=>De.map(Le=>({uri:d.URI.from(Le.uri),version:Le.version,ranges:Le.ranges.map(Ye=>b.from(Ye))})))}}we.from=oe})(We||(e.MappedEditsContext=We={}));var Xe;(function(we){function Ae(Q){return{start:Q.start,end:Q.end}}we.from=Ae;function oe(Q){return new o.$HN(Q.start,Q.end)}we.to=oe})(Xe||(e.NotebookRange=Xe={}));var st;(function(we){function Ae(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Ae;function oe(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=oe})(st||(e.NotebookCellExecutionSummary=st={}));var Fe;(function(we){function Ae(oe){if(oe===c.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(oe===c.NotebookCellExecutionState.Pending)return;if(oe===c.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}we.to=Ae})(Fe||(e.NotebookCellExecutionState=Fe={}));var Dt;(function(we){function Ae(Q){switch(Q){case o.NotebookCellKind.Markup:return c.CellKind.Markup;case o.NotebookCellKind.Code:default:return c.CellKind.Code}}we.from=Ae;function oe(Q){switch(Q){case c.CellKind.Markup:return o.NotebookCellKind.Markup;case c.CellKind.Code:default:return o.NotebookCellKind.Code}}we.to=oe})(Dt||(e.NotebookCellKind=Dt={}));var Jt;(function(we){function Ae(Q){const De={metadata:Q.metadata??Object.create(null),cells:[]};for(const Le of Q.cells)o.$IN.validate(Le),De.cells.push(jt.from(Le));return De}we.from=Ae;function oe(Q){const De=new o.$JN(Q.cells.map(jt.to));return(0,w.$7f)(Q.metadata)||(De.metadata=Q.metadata),De}we.to=oe})(Jt||(e.NotebookData=Jt={}));var jt;(function(we){function Ae(Q){return{cellKind:Dt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:st.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Vt.from):[]}}we.from=Ae;function oe(Q){return new o.$IN(Dt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Vt.to):void 0,Q.metadata,Q.internalMetadata?st.to(Q.internalMetadata):void 0)}we.to=oe})(jt||(e.NotebookCellData=jt={}));var ri;(function(we){function Ae(Q){return{mime:Q.mime,valueBytes:F.$te.wrap(Q.data)}}we.from=Ae;function oe(Q){return new o.$KN(Q.valueBytes.buffer,Q.mime)}we.to=oe})(ri||(e.NotebookCellOutputItem=ri={}));var Vt;(function(we){function Ae(Q){return{outputId:Q.id,items:Q.items.map(ri.from),metadata:Q.metadata}}we.from=Ae;function oe(Q){const De=Q.items.map(ri.to);return new o.$LN(De,Q.outputId,Q.metadata)}we.to=oe})(Vt||(e.NotebookCellOutput=Vt={}));var St;(function(we){function Ae(De){return Q(De)?{include:X.from(De.include)??void 0,exclude:X.from(De.exclude)??void 0}:X.from(De)??void 0}we.from=Ae;function oe(De){return Q(De)?{include:X.to(De.include),exclude:X.to(De.exclude)}:X.to(De)}we.to=oe;function Q(De){const Le=De;return Le?!(0,w.$3f)(Le.include)&&!(0,w.$3f)(Le.exclude):!1}})(St||(e.NotebookExclusiveDocumentPattern=St={}));var xt;(function(we){function Ae(oe,Q,De){const Le=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,De),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=Ae})(xt||(e.NotebookStatusBarItem=xt={}));var Wt;(function(we){function Ae(oe,Q,De){const Le=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:Q.toInternal(Le,De),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}we.from=Ae})(Wt||(e.NotebookKernelSourceAction=Wt={}));var si;(function(we){function Ae(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}we.from=Ae})(si||(e.NotebookDocumentContentOptions=si={}));var _t;(function(we){function Ae(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Ae;function oe(Q){return new o.$NN(d.URI.revive(Q.uri),Q.provides)}we.to=oe})(_t||(e.NotebookRendererScript=_t={}));var Ze;(function(we){function Ae(Q){return{message:T.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:b.from(Q.location.range),uri:Q.location.uri}}}we.from=Ae;function oe(Q){const De=new o.$TN(typeof Q.message=="string"?Q.message:T.to(Q.message));return De.actualOutput=Q.actual,De.expectedOutput=Q.expected,De.contextValue=Q.contextValue,De.location=Q.location?Se.to(Q.location):void 0,De}we.to=oe})(Ze||(e.TestMessage=Ze={}));var Ot;(function(we){we.namespace=t.$8K,we.denamespace=t.$9K})(Ot||(e.TestTag=Ot={}));var ei;(function(we){function Ae(Q){const De=(0,i.$tO)(Q).controllerId;return{extId:h.$3K.fromExtHostTestItem(Q,De).toString(),label:Q.label,uri:d.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Le=>Ot.namespace(De,Le.id)),range:s.$$s.lift(b.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&T.fromStrict(Q.error)||null}}we.from=Ae;function oe(Q){return{parent:void 0,error:void 0,id:h.$3K.fromString(Q.extId).localId,label:Q.label,uri:d.URI.revive(Q.uri),tags:(Q.tags||[]).map(De=>{const{tagId:Le}=Ot.denamespace(De);return new o.$UN(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=oe})(ei||(e.TestItem=ei={})),function(we){function Ae(Q){return{id:Q.id}}we.from=Ae;function oe(Q){return new o.$UN(Q.id)}we.to=oe}(Ot||(e.TestTag=Ot={}));var dt;(function(we){const Ae=(Q,De)=>{const Le=[];for(const[Ke,ut]of De)h.$3K.compare(ut.item.extId,Ke)===2&&(De.delete(Ke),Le.push(ut));const Ye={...ei.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ut=>ut.type===0).map(Ze.to)})),children:Le.map(Ke=>Ae(Ke,De))};for(const Ke of Ye.children)Ke.parent=Ye;return Ye};function oe(Q){const De=[],Le=new Map;for(const Ye of Q.items){Le.set(Ye.item.extId,Ye);const Ke=h.$3K.root(Ye.item.extId);Q.request.targets.some(ut=>ut.controllerId===Ke&&ut.testIds.includes(Ye.item.extId))&&De.push(Ye)}return{completedAt:Q.completedAt,results:De.map(Ye=>Ae(Ye,Le))}}we.to=oe})(dt||(e.TestResults=dt={}));var $t;(function(we){function Ae(Le){return{covered:Le.covered,total:Le.total}}function oe(Le){return"line"in Le?g.from(Le):b.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executed,location:oe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&oe(Ye.location),label:Ye.label})):void 0}:{type:0,name:Le.name,count:Le.executed,location:oe(Le.location)}}we.fromDetailed=Q;function De(Le){return{uri:Le.uri,statement:Ae(Le.statementCoverage),branch:Le.branchCoverage&&Ae(Le.branchCoverage),declaration:Le.declarationCoverage&&Ae(Le.declarationCoverage),details:Le.detailedCoverage?.map(Q)}}we.fromFile=De})($t||(e.TestCoverage=$t={}));var ti;(function(we){function Ae(oe){switch(oe){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}we.to=Ae})(ti||(e.CodeActionTriggerKind=ti={}));var qt;(function(we){function Ae(Q){const De=new o.$1N($e.to(Q.kind),Q.name,Q.detail||"",d.URI.revive(Q.uri),b.to(Q.range),b.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Ae;function oe(Q,De,Le){if(De=De??Q._sessionId,Le=Le??Q._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,kind:$e.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:b.from(Q.range),selectionRange:b.from(Q.selectionRange),tags:Q.tags?.map(ie.from)}}we.from=oe})(qt||(e.TypeHierarchyItem=qt={}));var Ht;(function(we){function Ae(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}we.from=Ae})(Ht||(e.ViewBadge=Ht={}));var ht;(function(we){function Ae(Le,Ye,Ke){const ut=Ye.fileData;return ut?new o.$9M(new o.$0M(ut.name,d.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>Ke(ut.id)))):Le===N.$vs.uriList&&Ye.uriListData?new o.$8M(De(Ye.uriListData)):new o.$8M(Ye.asString)}we.to=Ae;async function oe(Le,Ye){const Ke=await Ye.asString();if(Le===N.$vs.uriList)return{asString:Ke,fileData:void 0,uriListData:Q(Ke)};const ut=Ye.asFile();return{asString:Ke,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=oe;function Q(Le){return M.$Ht.split(Le).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return d.URI.parse(Ye)}catch{}return Ye})}function De(Le){return M.$Ht.create(Le.map(Ye=>typeof Ye=="string"?Ye:d.URI.revive(Ye)))}})(ht||(e.DataTransferItem=ht={}));var Rt;(function(we){function Ae(Q,De){const Le=Q.items.map(([Ye,Ke])=>[Ye,ht.to(Ye,Ke,De)]);return new o.$$M(Le)}we.toDataTransfer=Ae;async function oe(Q){const De={items:[]},Le=[];for(const[Ye,Ke]of Q)Le.push((async()=>{De.items.push([Ye,await ht.from(Ye,Ke)])})());return await Promise.all(Le),De}we.from=oe})(Rt||(e.DataTransfer=Rt={}));var ii;(function(we){function Ae(Q,De){return{kind:"reply",agentId:Q.participant??De?.agentId??"",subCommand:Q.command??De?.command,message:Q.prompt,title:Q.label}}we.from=Ae;function oe(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=oe})(ii||(e.ChatFollowup=ii={}));var ni;(function(we){function Ae(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}we.from=Ae})(ni||(e.ChatInlineFollowup=ni={}));var He;(function(we){function Ae(Q){switch(Q.role){case 0:return new o.$iO(Q.content);case 1:return new o.$jO(Q.content);case 2:return new o.$kO(Q.content)}}we.to=Ae;function oe(Q){if(Q instanceof o.$iO)return{role:0,content:Q.content};if(Q instanceof o.$jO)return{role:1,content:Q.content};if(Q instanceof o.$kO)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=oe})(He||(e.LanguageModelMessage=He={}));var Tt;(function(we){function Ae(De){const Le={};for(const Ye of Object.keys(De))Le[Ye]=De[Ye].map(we.to);return Le}we.objectTo=Ae;function oe(De){return{level:zt.to(De.level),kind:De.kind,value:(0,d.$vc)(De.value)?d.URI.revive(De.value):De.value,description:De.description}}we.to=oe;function Q(De){return{level:zt.from(De.level),kind:De.kind,value:De.value,description:De.description}}we.from=Q})(Tt||(e.ChatVariable=Tt={}));var zt;(function(we){function Ae(Q){switch(Q){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}we.to=Ae;function oe(Q){switch(Q){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}we.from=oe})(zt||(e.ChatVariableLevel=zt={}));var Yt;(function(we){function Ae(oe){switch(oe){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Ae})(Yt||(e.InteractiveEditorResponseFeedbackKind=Yt={}));var mt;(function(we){function Ae(Q){return{kind:"markdownContent",content:T.from(Q.value)}}we.to=Ae;function oe(Q){return new o.$aO(T.to(Q.content))}we.from=oe})(mt||(e.ChatResponseMarkdownPart=mt={}));var It;(function(we){function Ae(Q){const{value:De,baseUri:Le}=Q;function Ye(Ke,ut){return Ke.map(yt=>{const Kt=d.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Kt,children:yt.children&&Ye(yt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,l.$Qg)(Le),uri:Le,children:Ye(De,Le)}}}we.to=Ae;function oe(Q){const De=(0,k.$Ph)(Q.treeData);function Le(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Le(yt.children)}))}const Ye=De.uri,Ke=De.children?Le(De.children):[];return new o.$bO(Ke,Ye)}we.from=oe})(It||(e.ChatResponseFilesPart=It={}));var Ct;(function(we){function Ae(Q){return{kind:"inlineReference",name:Q.title,inlineReference:d.URI.isUri(Q.value)?Q.value:$.from(Q.value)}}we.to=Ae;function oe(Q){const De=(0,k.$Ph)(Q);return new o.$cO(d.URI.isUri(De.inlineReference)?De.inlineReference:$.to(De.inlineReference),Q.name)}we.from=oe})(Ct||(e.ChatResponseAnchorPart=Ct={}));var Nt;(function(we){function Ae(Q){return{kind:"progressMessage",content:T.from(Q.value)}}we.to=Ae;function oe(Q){return new o.$dO(Q.content.value)}we.from=oe})(Nt||(e.ChatResponseProgressPart=Nt={}));var oi;(function(we){function Ae(Q,De,Le){return{kind:"command",command:De.toInternal(Q.value,Le)??{command:Q.value.command,title:Q.value.title}}}we.to=Ae;function oe(Q,De){return new o.$eO(De.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.from=oe})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Ut;(function(we){function Ae(Q){return{kind:"reference",reference:d.URI.isUri(Q.value)?Q.value:$.from(Q.value)}}we.to=Ae;function oe(Q){const De=(0,k.$Ph)(Q);return new o.$fO(d.URI.isUri(De.reference)?De.reference:$.to(De.reference))}we.from=oe})(Ut||(e.ChatResponseReferencePart=Ut={}));var Zt;(function(we){function Ae(De){return De instanceof o.$aO?mt.to(De):De instanceof o.$cO?Ct.to(De):De instanceof o.$fO?Ut.to(De):De instanceof o.$dO?Nt.to(De):De instanceof o.$bO?It.to(De):{kind:"content",content:""}}we.to=Ae;function oe(De,Le){switch(De.kind){case"reference":return Ut.from(De);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(De,Le)}}we.from=oe;function Q(De,Le){switch(De.kind){case"markdownContent":return mt.from(De);case"inlineReference":return Ct.from(De);case"progressMessage":return;case"treeData":return It.from(De);case"command":return oi.from(De,Le)}}we.fromContent=Q})(Zt||(e.ChatResponsePart=Zt={}));var bt;(function(we){function Ae(De,Le){return"markdownContent"in Le?((0,u.$4F)(De,"chatParticipantAdditions"),{content:T.from(Le.markdownContent),kind:"markdownContent"}):"content"in Le?"vulnerabilities"in Le&&Le.vulnerabilities?((0,u.$4F)(De,"chatParticipantAdditions"),{content:Le.content,vulnerabilities:Le.vulnerabilities,kind:"vulnerability"}):typeof Le.content=="string"?{content:Le.content,kind:"content"}:((0,u.$4F)(De,"chatParticipantAdditions"),{content:T.from(Le.content),kind:"markdownContent"}):"documents"in Le?{documents:Le.documents.map(Ye=>({uri:Ye.uri,version:Ye.version,ranges:Ye.ranges.map(Ke=>b.from(Ke))})),kind:"usedContext"}:"reference"in Le?{reference:"uri"in Le.reference?{uri:Le.reference.uri,range:b.from(Le.reference.range)}:Le.reference,kind:"reference"}:"inlineReference"in Le?{inlineReference:"uri"in Le.inlineReference?{uri:Le.inlineReference.uri,range:b.from(Le.inlineReference.range)}:Le.inlineReference,name:Le.title,kind:"inlineReference"}:"participant"in Le?((0,u.$4F)(De,"chatParticipantAdditions"),{agentName:Le.participant,command:Le.command,kind:"agentDetection"}):"message"in Le?{content:T.from(Le.message),kind:"progressMessage"}:void 0}we.from=Ae;function oe(De){switch(De.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(De);case"content":return{content:De.content};case"usedContext":return{documents:De.documents.map(Le=>({uri:d.URI.revive(Le.uri),version:Le.version,ranges:Le.ranges.map(Ye=>b.to(Ye))}))};case"reference":return{reference:(0,d.$vc)(De.reference)?d.URI.revive(De.reference):$.to(De.reference)};case"agentDetection":return;case"progressMessage":return{message:De.content.value};case"vulnerability":return{content:De.content,vulnerabilities:De.vulnerabilities};default:return}}we.to=oe;function Q(De,Le){switch(De.kind){case"markdownContent":return{content:De.content.value};case"inlineReference":return{inlineReference:(0,d.$vc)(De.inlineReference)?d.URI.revive(De.inlineReference):$.to(De.inlineReference),title:De.name};case"command":return{command:Le.fromInternal(De.command)??{command:De.command.id,title:De.command.title}};default:return}}we.toProgressContent=Q})(bt||(e.ChatResponseProgress=bt={}));var Ft;(function(we){function Ae(oe){return{prompt:oe.message,command:oe.command,variables:oe.variables.variables.map(Bt.to)}}we.to=Ae})(Ft||(e.ChatAgentRequest=Ft={}));var Bt;(function(we){function Ae(oe){return{name:oe.name,range:[oe.range.start,oe.range.endExclusive],values:oe.values.map(Tt.to)}}we.to=Ae})(Bt||(e.ChatAgentResolvedVariable=Bt={}));var Lt;(function(we){function Ae(oe){return{label:oe.label,values:oe.values.map(Tt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation}}we.from=Ae})(Lt||(e.ChatAgentCompletionItem=Lt={}));var wt;(function(we){function Ae(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}we.to=Ae})(wt||(e.ChatAgentResult=wt={}));var Pt;(function(we){function Ae(oe,Q,De){if(Q.action.kind==="vote")return;const Le=wt.to(oe);return Q.action.kind==="command"?{action:{kind:"command",commandButton:bt.toProgressContent(Q.action.commandButton,De)},result:Le}:Q.action.kind==="followUp"?{action:{kind:"followUp",followup:ii.to(Q.action.followup)},result:Le}:{action:Q.action,result:Le}}we.to=Ae})(Pt||(e.ChatAgentUserActionEvent=Pt={}));var kt;(function(we){function Ae(oe,Q,De){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:Q.toInternal(oe,De)}we.from=Ae})(kt||(e.TerminalQuickFix=kt={}));var li;(function(we){function Ae(oe){return{kind:Qt.to(oe.kind)}}we.to=Ae})(li||(e.PartialAcceptInfo=li={}));var Qt;(function(we){function Ae(oe){switch(oe){case 0:return o.PartialAcceptTriggerKind.Word;case 1:return o.PartialAcceptTriggerKind.Line;case 2:return o.PartialAcceptTriggerKind.Suggest;default:return o.PartialAcceptTriggerKind.Unknown}}we.to=Ae})(Qt||(e.PartialAcceptTriggerKind=Qt={}));var ci;(function(we){function Ae(oe,Q){return{id:Q,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}we.from=Ae})(ci||(e.DebugTreeItem=ci={}))}),define(Pe[249],Me([1,0,4,17,8]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;let O=class{constructor(m,f){this.a=m.getProxy(S.$eM.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>f.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,k){const N=M.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,k?.isRefactoring??!1)}};e.$Cic=O,e.$Cic=O=Je([qe(0,F.$xO)],O)}),define(Pe[250],Me([1,0,18,11,41,5,51,6,64,16,2,161,20,4,8,7,210,22]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;class i{constructor(t,p,u,o,v,b){this.i=t,this.j=p,this.k=u,this.l=o,this.m=v,this.n=b,this.b=f.$2d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function(o){if(t.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,o),v}};const t=this;this.b.reset();const u=o=>{typeof this.d>"u"&&"content"in o&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,o)};this.g={markdown(o){p(this.markdown);const v=new s.$aO(o),b=d.ChatResponseMarkdownPart.to(v);return u(b),this},filetree(o,v){p(this.filetree);const b=new s.$bO(o,v),$=d.ChatResponseFilesPart.to(b);return u($),this},anchor(o,v){p(this.anchor);const b=new s.$cO(o,v),$=d.ChatResponseAnchorPart.to(b);return u($),this},button(o){p(this.anchor);const v=new s.$eO(o),b=d.ChatResponseCommandButtonPart.to(v,t.m,t.n);return u(b),this},progress(o){p(this.progress);const v=new s.$dO(o),b=d.ChatResponseProgressPart.to(v);return u(b),this},reference(o){p(this.reference);const v=new s.$fO(o),b=d.ChatResponseReferencePart.to(v);return u(b),this},push(o){p(this.push);const v=d.ChatResponsePart.to(o);return u(v),this},report(o){if(p(this.report),"placeholder"in o&&"resolvedContent"in o)return;const v=d.ChatResponseProgress.from(t.i,o);if(!v){t.l.error("Unknown progress type: "+JSON.stringify(o));return}return u(v),this}}}return this.g}}class n{static{this.b=0}constructor(t,p,u){this.i=p,this.j=u,this.c=new Map,this.g=new m.$3c,this.d=t.getProxy(w.$eM.MainThreadChatAgents2)}createChatAgent(t,p,u){const o=n.b++,v=new c(t,p,this.d,o,u);return this.c.set(o,v),this.d.$registerAgent(o,t.identifier,p,{},(0,r.$3F)(t,"chatParticipantAdditions")),v.apiAgent}async $invokeAgent(t,p,u,o){const v=this.c.get(t);if(!v)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let b=this.g.get(p.sessionId);b||(b=new m.$Sc,this.g.set(p.sessionId,b));const $=new i(v.extension,p,this.d,this.i,this.j.converter,b);try{const I=await this.k(p.agentId,u),g=v.invoke(d.ChatAgentRequest.to(p),{history:I},$.apiObject,o);return await(0,F.$7g)(Promise.resolve(g).then(D=>{if(D?.metadata)try{JSON.stringify(D.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${v.extension.identifier.value}] [@${v.id}] ${P}`,v.extension),{errorDetails:{message:P},timings:$.timings}}return{errorDetails:D?.errorDetails,timings:$.timings,metadata:D?.metadata}}),o)}catch(I){return this.i.error(I,v.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,M.$4i)(I)),responseIsIncomplete:!0}}}finally{$.close()}}async k(t,p){const u=[];for(const o of p.history){const v=d.ChatAgentResult.to(o.result),b=t===o.request.agentId?v:{...v,metadata:void 0};u.push(new s.$gO(o.request.message,o.request.command,o.request.variables.variables.map(d.ChatAgentResolvedVariable.to),{extensionId:"",name:o.request.agentId}));const $=(0,S.$Hb)(o.response.map(I=>d.ChatResponsePart.fromContent(I,this.j.converter)));u.push(new s.$hO($,b,{extensionId:"",name:o.request.agentId},o.request.command))}return u}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,p,u,o,v){const b=this.c.get(p);if(!b)return Promise.resolve([]);const $=await this.k(b.id,o),I=d.ChatAgentResult.to(u);return(await b.provideFollowups(I,{history:$},v)).filter(g=>{const D=!g.participant||R.Iterable.some(this.c.values(),y=>y.id===g.participant&&l.$Bm.equals(y.extension.identifier,b.extension.identifier));return D||this.i.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${g.participant}`),D}).map(g=>d.ChatFollowup.from(g,t))}$acceptFeedback(t,p,u,o){const v=this.c.get(t);if(!v)return;const b=d.ChatAgentResult.to(p);let $;switch(u){case a.InteractiveSessionVoteDirection.Down:$=s.ChatResultFeedbackKind.Unhelpful;break;case a.InteractiveSessionVoteDirection.Up:$=s.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(o?{result:b,kind:$,reportIssue:o}:{result:b,kind:$}))}$acceptAction(t,p,u){const o=this.c.get(t);if(!o||u.action.kind==="vote")return;const v=d.ChatAgentUserActionEvent.to(p,u,this.j.converter);v&&o.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(t,p,u){const o=this.c.get(t);return o?(await o.invokeCompletionProvider(p,u)).map(d.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,p){const u=this.c.get(t);if(u)return await u.provideWelcomeMessage(p)}async $provideSampleQuestions(t,p){const u=this.c.get(t);if(u)return(await u.provideSampleQuestions(p)).map(o=>d.ChatFollowup.from(o,void 0))}}e.$Eic=n;class c{constructor(t,p,u,o,v){this.extension=t,this.id=p,this.x=u,this.y=o,this.z=v,this.o=new O.$6d,this.p=new O.$6d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,p){return this.s?await this.s.provider.provideCompletionItems(t,p)??[]:[]}async provideFollowups(t,p,u){if(!this.b)return[];const o=await this.b.provideFollowups(t,p,u);return o?o.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const p=await this.t.provideWelcomeMessage(t);return p?p.map(u=>typeof u=="string"?u:d.MarkdownString.from(u)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const p=await this.t.provideSampleQuestions(t);return p||[]}get apiAgent(){let t=!1,p=!1;const u=()=>{t||p||(p=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof N.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof s.$cN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:d.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),p=!1}))},o=this;return{get name(){return o.id},get description(){return o.c??""},set description(v){o.c=v,u()},get fullName(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.d??o.extension.displayName??o.extension.name},set fullName(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.d=v,u()},get iconPath(){return o.g},set iconPath(v){o.g=v,u()},get requestHandler(){return o.z},set requestHandler(v){(0,k.$4f)(typeof v=="function","Invalid request handler"),o.z=v},get followupProvider(){return o.b},set followupProvider(v){o.b=v,u()},get isDefault(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.i},set isDefault(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.i=v,u()},get helpTextPrefix(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.j},set helpTextPrefix(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.j=v,u()},get helpTextVariablesPrefix(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.k},set helpTextVariablesPrefix(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.k=v,u()},get helpTextPostfix(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.l},set helpTextPostfix(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.l=v,u()},get isSecondary(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.n},set isSecondary(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.n=v,u()},get sampleRequest(){return o.m},set sampleRequest(v){o.m=v,u()},get supportIssueReporting(){return(0,r.$4F)(o.extension,"chatParticipantAdditions"),o.q},set supportIssueReporting(v){(0,r.$4F)(o.extension,"chatParticipantAdditions"),o.q=v,u()},get onDidReceiveFeedback(){return o.o.event},set participantVariableProvider(v){if((0,r.$4F)(o.extension,"chatParticipantAdditions"),o.s=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");o.x.$registerAgentCompletionsProvider(o.y,v.triggerCharacters)}else o.x.$unregisterAgentCompletionsProvider(o.y)},get participantVariableProvider(){return(0,r.$4F)(o.extension,"chatParticipantAdditions"),o.s},set welcomeMessageProvider(v){(0,r.$4F)(o.extension,"defaultChatParticipant"),o.t=v,u()},get welcomeMessageProvider(){return(0,r.$4F)(o.extension,"defaultChatParticipant"),o.t},onDidPerformAction:(0,r.$3F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return o.u},set isSticky(v){o.u=v,u()},set requester(v){o.w=v,u()},get requester(){return o.w},dispose(){t=!0,o.b=void 0,o.o.dispose(),o.x.$unregisterAgent(o.y)}}}invoke(t,p,u,o){return this.z(t,p,u,o)}}}),define(Pe[251],Me([1,0,14,6,4,8,7,22]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class f{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$eM.MainThreadChatVariables)}async $resolveVariable(E,l,w,d){const s=this.b.get(E);if(s)try{if(s.resolver.resolve2){(0,m.$4F)(s.extension,"chatParticipantAdditions");const a=new k(l,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:w},a.apiObject,d);if(r)return r.map(O.ChatVariable.from)}else{const a=await s.resolver.resolve(s.data.name,{prompt:w},d);if(a)return a.map(O.ChatVariable.from)}}catch(a){(0,S.$2)(a)}}registerVariableResolver(E,l,w,d){const s=f.a++;return this.b.set(s,{extension:E,data:{name:l,description:w},resolver:d}),this.c.$registerVariable(s,{name:l,description:w}),(0,F.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Hic=f;class k{constructor(E,l){this.c=E,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(d){if(E.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,d),s}};const E=this,w=d=>{this.d.$handleProgressChunk(this.c,d)};this.b={progress(d){l(this.progress);const s=new R.$dO(d),a=O.ChatResponseProgressPart.to(s);return w(a),this},reference(d){l(this.reference);const s=new R.$fO(d),a=O.ChatResponseReferencePart.to(s);return w(a),this},push(d){l(this.push);const s=O.ChatResponsePart.to(d);return w(s),this}}}return this.b}}}),define(Pe[252],Me([1,0,11,68,5,6,2,87,20,8,7,4,22]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=w;function w(d,s,a){const r=d.getProxy(E.$eM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$Dm,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const $=this.b.get(b.handle);return $?$.value:b}else if(b&&b.$mid===7){const $=this.b.get(b.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.commentThreadHandle);return I?I.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const g=b.commentUniqueId,D=I.getCommentByUniqueId(g);return D||b}else if(b&&b.$mid===11){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const g=b.text,D=b.commentUniqueId,y=I.getCommentByUniqueId(D);return y?(typeof y.body=="string"?y.body=g:y.body=new N.$HM(g),y):b}return b}})}createCommentController(b,$,I){const g=i.a++,D=new c(b,g,$,I);this.b.set(D.handle,D);const y=this.c.get(b.identifier)||[];return y.push(D),this.c.set(b.identifier,y),D.value}async $createCommentThreadTemplate(b,$,I){const g=this.b.get(b);g&&g.$createCommentThreadTemplate($,I)}async $setActiveComment(b,$){const I=this.b.get(b);I&&I.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(b,$,I){const g=this.b.get(b);g&&g.$updateCommentThreadTemplate($,I)}$deleteCommentThread(b,$){this.b.get(b)?.$deleteCommentThread($)}async $provideCommentingRanges(b,$,I){const g=this.b.get(b);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const D=await a.ensureDocumentData(R.URI.revive($));return(0,S.$$g)(async()=>{const y=await g.commentingRangeProvider.provideCommentingRanges(D.document,I);let P;return Array.isArray(y)?P={ranges:y,fileComments:!1}:y?P={ranges:y.ranges||[],fileComments:y.fileComments||!1}:P=y??void 0,P}).then(y=>{let P;return y&&(P={ranges:y.ranges.map(A=>k.Range.from(A)),fileComments:y.fileComments}),P})}$toggleReaction(b,$,I,g,D){const y=this.b.get(b);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,S.$$g)(()=>{const P=y.getCommentThread($);if(P){const A=P.getCommentByUniqueId(g.uniqueIdInThread);if(y!==void 0&&A&&y.reactionHandler)return y.reactionHandler(A,p(D))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,$,I,g,D,y,P,A){this.m=$,this.n=I,this.o=g,this.p=D,this.q=y,this.extensionDescription=P,this.r=A,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$6d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Uc,this.l.value=new O.$Sc,this.n===void 0&&(this.n=`${b}.${this.handle}`),r.$createCommentThread($,this.handle,this.n,this.o,k.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{r.$deleteCommentThread($,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Sc);const b=I=>Object.prototype.hasOwnProperty.call(this.b,I),$={};b("range")&&($.range=k.Range.from(this.p)),b("label")&&($.label=this.label),b("contextValue")&&($.contextValue=this.contextValue??null),b("comments")&&($.comments=this.q.map(I=>h(this,I,this.k,this.extensionDescription))),b("collapsibleState")&&($.collapseState=u(this.g)),b("canReply")&&($.canReply=this.canReply),b("state")&&($.state=o(this.h)),b("isTemplate")&&($.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(b){for(const $ of this.k){const I=$[0],g=$[1];if(b===g)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Je([(0,F.$Lh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,l.$4F)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$4F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$4F)(this.h,"activeComment"),this.f}constructor(b,$,I,g){this.h=b,this.i=$,this.j=I,this.k=g,this.a=new Map,r.$registerCommentController(this.handle,I,g,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(y){D.options=y},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(y){D.commentingRangeProvider=y},get reactionHandler(){return D.reactionHandler},set reactionHandler(y){D.reactionHandler=y},get activeCommentThread(){return D.activeCommentThread},createCommentThread(y,P,A){return D.createCommentThread(y,P,A).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(b,$,I){$===void 0&&(0,l.$4F)(this.h,"fileComments");const g=new n(this.id,this.handle,void 0,b,$,I,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const $=this.a.get(b.commentThreadHandle);$&&(this.e=b.uniqueIdInThread?$.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(b,$){const I=new n(this.id,this.handle,void 0,R.URI.revive(b),k.Range.to($),[],this.h,!0);return I.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(b,$){const I=this.a.get(b);I&&(I.range=k.Range.to($))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function h(v,b,$,I){let g=$.get(b);return g||(g=++v.commentHandle,$.set(b,g)),b.state!==void 0&&(0,l.$4F)(I,"commentsDraftState"),b.reactions?.some(D=>D.reactors!==void 0)&&(0,l.$4F)(I,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:g,body:typeof b.body=="string"?b.body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(D=>t(D)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?k.$wO(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(b=>b.name):v.reactors}}function p(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(b=>({name:b}))}}function u(v){if(v!==void 0)switch(v){case N.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function o(v){if(v!==void 0)switch(v){case N.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new i}}),define(Pe[253],Me([1,0,25,99,6,12,24,2,8,62,74,4,7]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class w{constructor(p,u){this.document=p,this.b=u,this.a=1,this.c=new N.$oic("custom documents")}addEdit(p){return this.c.add([p])}async undo(p,u){await this.f(p).undo(),u||this.disposeBackup()}async redo(p,u){await this.f(p).redo(),u||this.disposeBackup()}disposeEdits(p){for(const u of p)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const p=h(this.document.uri)+this.a++;return(0,R.$Tg)(this.b,p)}updateBackup(p){this.d?.delete(),this.d=p}disposeBackup(){this.d?.delete(),this.d=void 0}f(p){const u=this.c.get(p,0);if(!u)throw new Error("No edit found");return u}}class d{constructor(){this.a=new Map}get(p,u){return this.a.get(this.b(p,u))}add(p,u,o){const v=this.b(p,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${p} resource:${u.uri}`);const b=new w(u,o);return this.a.set(v,b),b}delete(p,u){const o=this.b(p,u.uri);this.a.delete(o)}b(p,u){return`${p}@@@${u}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class a{constructor(){this.a=new Map}addTextProvider(p,u,o){return this.b(0,p,u,o)}addCustomProvider(p,u,o){return this.b(1,p,u,o)}get(p){return this.a.get(p)}b(p,u,o,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:p,extension:o,provider:v}),new l.$gM(()=>this.a.delete(u))}}class r{constructor(p,u,o,v,b){this.d=u,this.f=o,this.g=v,this.h=b,this.b=new a,this.c=new d,this.a=p.getProxy(E.$eM.MainThreadCustomEditors)}registerCustomEditorProvider(p,u,o,v){const b=new M.$Sc;return n(o)?(b.add(this.b.addTextProvider(u,p,o)),this.a.$registerTextEditorProvider((0,k.$1ic)(p),u,v.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.$Yic)(p))):(b.add(this.b.addCustomProvider(u,p,o)),i(o)&&b.add(o.onDidChangeCustomDocument($=>{const I=this.i(u,$.document.uri);if(c($)){const g=I.addEdit($);this.a.$onDidEdit($.document.uri,u,g,$.label)}else this.a.$onContentChange($.document.uri,u)})),this.a.$registerCustomEditorProvider((0,k.$1ic)(p),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,k.$Yic)(p))),l.$gM.from(b,new l.$gM(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(p,u,o,v,b){const $=this.b.get(u);if(!$)throw new Error(`No provider found for '${u}'`);if($.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=m.URI.revive(p),g=await $.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:v?.buffer},b);let D;return i($.provider)&&this.f&&(D=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(u,g,D),{editable:i($.provider)}}async $disposeCustomDocument(p,u){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=m.URI.revive(p),{document:b}=this.i(u,v);this.c.delete(u,b),b.dispose()}async $resolveCustomEditor(p,u,o,v,b,$){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const g=f.ViewColumn.to(b),D=this.g.createNewWebview(u,v.contentOptions,I.extension),y=this.h.createNewWebviewPanel(u,o,v.title,g,v.options,D,v.active),P=m.URI.revive(p);switch(I.type){case 1:{const{document:A}=this.i(o,P);return I.provider.resolveCustomEditor(A,y,$)}case 0:{const A=this.d.getDocument(P);return I.provider.resolveCustomTextEditor(A,y,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(p,u,o){this.i(u,p).disposeEdits(o)}async $onMoveCustomEditor(p,u,o){const v=this.b.get(o);if(!v)throw new Error(`No provider found for '${o}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const b=this.h.getWebviewPanel(p);if(!b)throw new Error("No webview found");const $=m.URI.revive(u),I=this.d.getDocument($);await v.provider.moveCustomTextEditor(I,b,S.CancellationToken.None)}async $undo(p,u,o,v){return this.i(u,p).undo(o,v)}async $redo(p,u,o,v){return this.i(u,p).redo(o,v)}async $revert(p,u,o){const v=this.i(u,p);await this.j(u).revertCustomDocument(v.document,o),v.disposeBackup()}async $onSave(p,u,o){const v=this.i(u,p);await this.j(u).saveCustomDocument(v.document,o),v.disposeBackup()}async $onSaveAs(p,u,o,v){const b=this.i(u,p);return this.j(u).saveCustomDocumentAs(b.document,m.URI.revive(o),v)}async $backup(p,u,o){const v=this.i(u,p),$=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},o);return v.updateBackup($),$.id}i(p,u){const o=this.c.get(p,m.URI.revive(u));if(!o)throw new Error("No custom document found");return o}j(p){const o=this.b.get(p)?.provider;if(!o||!i(o))throw new Error("Custom document is not editable");return o}}e.$4ic=r;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const p=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,F.$7i)(p)+""}}),define(Pe[254],Me([1,0,162,100,2,4,7,8,5,13,28,43]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;class w{#e;#t;#i;constructor(a,r,i,n,c,h,t,p){this.d=a,this.e=r,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new N.$Ac(u=>h.getComparisonKey(u)),this.#e=t,this.#t=p}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,r){if(!a){this.clear();return}this.j();let i=[];if(M.URI.isUri(a)){if(!r){this.delete(a);return}this.#i.set(a,r.slice()),i=[a]}else if(Array.isArray(a)){i=[];let h;a=[...a].sort(w.k);for(const t of a){const[p,u]=t;if((!h||p.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=p,i.push(p),this.#i.set(p,[])),u)this.#i.get(p)?.push(...u);else{const o=this.#i.get(p);o&&(o.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const h of i){let t=[];const p=this.#i.get(h);if(p)if(p.length>this.g){t=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const v of p)if(v.severity===u[o]&&t.push({...m.Diagnostic.from(v),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,p.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=p.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(n.push([h,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,r){this.j();for(const[i,n]of this)a.call(r,i,n,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const r=this.#i.get(a);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,r){return a[0].toString()<r[0].toString()?-1:a[0].toString()>r[0].toString()?1:0}}e.$vic=w;let d=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const r=new N.$Ac;for(const i of a)r.set(i,i);return{uris:Object.freeze(Array.from(r.values()))}}constructor(a,r,i,n){this.j=r,this.k=i,this.l=n,this.g=new Map,this.h=new f.$0d({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=a.getProxy(O.$eM.MainThreadDiagnostics)}createDiagnosticCollection(a,r){const{g:i,f:n,h:c,j:h,k:t,l:p}=this,u=new class{$changeMany(b,$){n.$changeMany(b,$),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,b,$.length===0?"CLEARING":$)}$clear(b){n.$clear(b),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,b)}dispose(){n.dispose()}};let o;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,o=r;else if(!i.has(r))o=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do o=r+l.c++;while(i.has(o))}return new class extends w{constructor(){super(r,o,l.e,l.d,b=>p.getDocument(b)?.version,t.extUri,u,c),i.set(o,this)}dispose(){super.dispose(),i.delete(o)}}}getDiagnostics(a){if(a)return this.m(a);{const r=new Map,i=[];for(const n of this.g.values())n.forEach((c,h)=>{let t=r.get(c.toString());typeof t>"u"&&(t=i.length,r.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...h)});return i}}m(a){let r=[];for(const i of this.g.values())i.has(a)&&(r=r.concat(i.get(a)));return r}$acceptMarkersChange(a){if(!this.n){const r="_generated_mirror",i=new w(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(r,i),this.n=i}for(const[r,i]of a)this.n.set(M.URI.revive(r),i.map(m.Diagnostic.to))}};e.$wic=d,e.$wic=d=l=Je([qe(1,k.$Mj),qe(2,E.$uic)],d)}),define(Pe[255],Me([1,0,2,14,7,8,190]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class m{constructor(k,N,E,l={timeout:1500,errors:3}){this.c=k,this.d=N,this.f=E,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(N,E,l)=>{const d={dispose:this.a.push([N,E,k])};return Array.isArray(l)&&l.push(d),d}}async $participateInSave(k,N){const E=S.URI.revive(k);let l=!1;const w=setTimeout(()=>l=!0,this.g.timeout),d=[];try{for(const s of[...this.a]){if(l)break;const a=this.d.getDocument(E),r=await this.h(s,{document:a,reason:O.TextDocumentSaveReason.to(N)});d.push(r)}}finally{clearTimeout(w)}return d}h([k,N,E],l){const w=this.b.get(k);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(E,k,N,l).then(()=>!0,d=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const s=this.b.get(k);this.b.set(k,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,N,E,l){const w=[],d=Date.now(),{document:s,reason:a}=l,{version:r}=s,i=Object.freeze({document:s,reason:a,waitUntil(n){if(Object.isFrozen(w))throw(0,F.$8)("waitUntil can not be called async");w.push(Promise.resolve(n))}});try{N.apply(E,[i])}catch(n){return Promise.reject(n)}return Object.freeze(w),new Promise((n,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(w).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(h),n(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(n=>{const c={edits:[]};for(const h of n)if(Array.isArray(h)&&h.every(t=>t instanceof M.$nM))for(const{newText:t,newEol:p,range:u}of h)c.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:u&&O.Range.from(u),text:t,eol:p&&O.EndOfLine.from(p)}});if(c.edits.length!==0)return r===s.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$Fjc=m}),define(Pe[256],Me([1,0,5,6,2,4,111,8,16,26,7]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class E{constructor(w,d){this.a=new S.$6d,this.b=new S.$6d,this.c=new S.$6d,this.d=new S.$6d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Sc,this.h=new Map,this.f=w.getProxy(O.$eM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(s=>{for(const a of s)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const a of s)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const d=this.g.getDocument(w);if(d)return d}getDocument(w){const d=this.getDocumentData(w);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return d.document}ensureDocumentData(w){const d=this.g.getDocument(w);if(d)return Promise.resolve(d);let s=this.h.get(w.toString());return s||(s=this.f.$tryOpenDocument(w).then(a=>{this.h.delete(w.toString());const r=M.URI.revive(a);return(0,f.$5f)(this.g.getDocument(r))},a=>(this.h.delete(w.toString()),Promise.reject(a))),this.h.set(w.toString(),s)),s}createDocumentData(w){return this.f.$tryCreateDocument(w).then(d=>M.URI.revive(d))}$acceptModelLanguageChanged(w,d){const s=M.URI.revive(w),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(d),this.a.fire(a.document)}$acceptModelSaved(w){const d=M.URI.revive(w),s=this.g.getDocument(d);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(w,d){const s=M.URI.revive(w),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,d,s){const a=M.URI.revive(w),r=this.g.getDocument(a);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(d);let i;d.isUndoing?i=N.TextDocumentChangeReason.Undo:d.isRedoing&&(i=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Nn)({document:r.document,contentChanges:d.changes.map(n=>({range:m.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(w,d){(0,R.$zO)(w,d)}}e.$xic=E}),define(Pe[65],Me([1,0,257,5,16,2,3,4,17,8,7]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=void 0,e.$5ic=(0,R.$gi)("IExtHostEditorTabs");class E{constructor(a,r,i){this.e=i,this.d=r,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$2N(O.URI.revive(this.b.input.uri));case 2:return new N.$3N(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new N.$4N(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new N.$5N(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$6N(this.b.input.viewType);case 4:return new N.$7N(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$8N(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$9N;case 9:return new N.$0N(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$$N(this.b.input.providerId);default:return}}}class l{constructor(a,r){this.c=[],this.d="",this.b=a,this.e=r;for(const i of a.tabs)i.isActive&&(this.d=i.id),this.c.push(new E(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return k.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(i=>i.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(i=>i.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const i=new E(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,i),a.tabDto.isActive&&(this.d=i.tabId),i}else if(a.kind===1){const i=this.c.splice(a.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(a.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,i),i}const r=this.c.find(i=>i.tabId===a.tabDto.id);if(!r)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(a.tabDto),r}activeTabId(){return this.d}}let w=class{constructor(a){this.b=new F.$6d,this.c=new F.$6d,this.e=[],this.a=a.getProxy(m.$eM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,r={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(i=>i.apiObject))},get activeTabGroup(){const i=a.d;return(0,M.$5f)(a.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?d(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(a){const r=new Set(this.e.map(u=>u.groupId)),i=new Set(a.map(u=>u.groupId)),n=(0,S.$L)(r,i),c=this.e.filter(u=>n.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],t=[];this.e=a.map(u=>{const o=new l(u,()=>this.d);return n.added.includes(o.groupId)?h.push(o.apiObject):t.push(o.apiObject),o});const p=(0,M.$5f)(a.find(u=>u.isActive===!0)?.groupId);p!==void 0&&this.d!==p&&(this.d=p),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const r=this.e.find(i=>i.groupId===a.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const r=this.e.find(n=>n.groupId===a.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const i=r.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(a){for(const r of this.e)for(const i of r.tabs)if(i.apiObject===a)return i}h(a){return this.e.find(r=>r.apiObject===a)}async i(a,r){const i=[];for(const n of a){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,r)}async j(a,r){const i=[];for(const n of a){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,r)}};e.$6ic=w,e.$6ic=w=Je([qe(0,f.$xO)],w);function d(s){return s.tabs!==void 0}}),define(Pe[258],Me([1,0,2,4,6,7,8,301,15,23,22,53]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const a=this.a.indexOf(s);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),a=[];let r,i,n=14,c=14;for(const h of s){let t=r?(0,f.$mf)(r,h):0;for(t===0?i=1:i=c;t<h.length;t++)t+1===h.length?(n=c,c=9):c+=1,a.push([i,h.toUpperCase().charCodeAt(t),c]),a.push([i,h.toLowerCase().charCodeAt(t),c]),i=c;r=h,c=n}a.push([9,58,10]),a.push([10,47,12]),this.b=new m.$h2(a)}}provideDocumentLinks(s){this.c();const a=[],r=m.$i2.computeLinks({getLineContent(i){return s.lineAt(i-1).text},getLineCount(){return s.lineCount}},this.b);for(const i of r){const n=R.DocumentLink.to(i);n.target&&a.push(n)}return a}}class w{constructor(s,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(F.$eM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,a,r,i={}){if(w.j(r),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(a),this.d.add(a),this.c.set(n,r);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,N.$4F)(s,"fsChunks"),c+=4);let h;i.isReadonly&&(0,E.$Fk)(i.isReadonly)&&i.isReadonly.value!==""&&(h={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,a,c,h).catch(p=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(p)});const t=r.onDidChangeFile(p=>{const u=[];for(const o of p){const{uri:v,type:b}=o;if(v.scheme!==a)continue;let $;switch(b){case O.FileChangeType.Changed:$=0;break;case O.FileChangeType.Created:$=1;break;case O.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:$})}this.a.$onFileSystemChange(n,u)});return(0,M.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:a,ctime:r,mtime:i,size:n,permissions:c}=s;return{type:a,ctime:r,mtime:i,size:n,permissions:c}}$stat(s,a){return Promise.resolve(this.l(s).stat(S.URI.revive(a))).then(r=>w.k(r))}$readdir(s,a){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this.l(s).readFile(S.URI.revive(a))).then(r=>k.$te.wrap(r))}$writeFile(s,a,r,i){return Promise.resolve(this.l(s).writeFile(S.URI.revive(a),r.buffer,i))}$delete(s,a,r){return Promise.resolve(this.l(s).delete(S.URI.revive(a),r))}$rename(s,a,r,i){return Promise.resolve(this.l(s).rename(S.URI.revive(a),S.URI.revive(r),i))}$copy(s,a,r,i){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(S.URI.revive(a),S.URI.revive(r),i))}$mkdir(s,a){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(a)))}$watch(s,a,r,i){const n=this.l(s).watch(S.URI.revive(r),i);this.f.set(a,n)}$unwatch(s,a){const r=this.f.get(a);r&&(r.dispose(),this.f.delete(a))}$open(s,a,r){const i=this.l(s);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(a),r))}$close(s,a){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(a))}$read(s,a,r,i){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=k.$te.alloc(i);return Promise.resolve(n.read(a,r,c.buffer,0,i)).then(h=>c.slice(0,h))}$write(s,a,r,i){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(a,r,i.buffer,0,i.byteLength))}l(s){const a=this.c.get(s);if(!a){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return a}}e.$Hjc=w}),define(Pe[259],Me([1,0,5,34,2,4,8,7,39]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,d,s,a,r,i){this.a=Math.random(),this.b=new S.$6d,this.c=new S.$6d,this.d=new S.$6d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$ak)(r),c=typeof r=="string",h=i?.correlate,t=a(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(h&&typeof p.session>"u")){if(!i?.ignoreCreateEvents)for(const u of p.created){const o=M.URI.revive(u);n(o.fsPath)&&(!c||d.getWorkspaceFolder(o))&&this.b.fire(o)}if(!i?.ignoreChangeEvents)for(const u of p.changed){const o=M.URI.revive(u);n(o.fsPath)&&(!c||d.getWorkspaceFolder(o))&&this.c.fire(o)}if(!i?.ignoreDeleteEvents)for(const u of p.deleted){const o=M.URI.revive(u);n(o.fsPath)&&(!c||d.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=m.$gM.from(this.i(w,s,r,i,i?.correlate),this.b,this.c,this.d,t)}i(w,d,s,a,r){const i=m.$gM.from();if(typeof s=="string")return i;const n=w.getProxy(O.$eM.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(F.$9j)||s.pattern.includes(F.$0j))&&(c=!0),n.$watch(d.identifier.value,this.a,s.baseUri,{recursive:c,excludes:a?.excludes??[]},!!r),m.$gM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(w){this.a=w,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(M.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class E{constructor(w,d,s){this.j=w,this.k=d,this.l=s,this.a=new S.$6d,this.b=new S.$6d,this.c=new S.$6d,this.d=new S.$6d,this.g=new S.$8d,this.h=new S.$8d,this.i=new S.$8d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,d,s,a){return new k(this.j,w,d,this.a.event,R.GlobPattern.from(s),a)}$onFileEvent(w){this.a.fire(new N(w))}$onDidRunFileOperation(w,d){switch(w){case 2:this.b.fire(Object.freeze({files:d.map(s=>({oldUri:M.URI.revive(s.source),newUri:M.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:d.map(s=>M.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:d.map(s=>M.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,d){return(s,a,r)=>{const i=function(c){s.call(a,c)};return i.extension=w,d.event(i,void 0,r)}}async $onWillRunFileOperation(w,d,s,a){switch(w){case 2:return await this.n(this.g,{files:d.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))},s,a);case 1:return await this.n(this.i,{files:d.map(r=>M.URI.revive(r.target))},s,a);case 0:case 3:return await this.n(this.h,{files:d.map(r=>M.URI.revive(r.target))},s,a)}}async n(w,d,s,a){const r=new Set,i=[];if(await w.fireAsync(d,a,async(c,h)=>{const t=Date.now(),p=await Promise.resolve(c);p instanceof m.$qM&&(i.push([h.extension,p]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(h)}return{edit:n,extensionNames:Array.from(r)}}}e.$Ijc=E}),define(Pe[260],Me([1,0,18,11,25,14,90,6,26,64,15,16,2,29,302,87,97,164,20,8,7,22,74,4]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class u{constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(K,j);if(!(0,S.$Kb)(H))return H[0]instanceof c.$zM?H.map(n.DocumentSymbol.from):u.f(H)}static f(z){z=z.slice(0).sort((H,_)=>{let se=H.location.range.start.compareTo(_.location.range.start);return se===0&&(se=_.location.range.end.compareTo(H.location.range.end)),se});const j=[],K=[];for(const H of z){const _={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(_),j.push(_);break}const se=K[K.length-1];if(w.$$s.containsRange(se.range,_.range)&&!w.$$s.equalsRange(se.range,_.range)){se.children?.push(_),K.push(_);break}K.pop()}}return j}}class o{constructor(z,j,K,H,_,se){this.f=z,this.g=j,this.h=K,this.j=H,this.k=_,this.l=se,this.d=new t.$oic("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const K=this.f.getDocument(z),H=await this.h.provideCodeLenses(K,j);if(!H||j.isCancellationRequested)return;const _=this.d.add(H),se=new m.$Sc;this.e.set(_,se);const Oe={cacheId:_,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Oe.lenses.push({cacheId:[_,Ve],range:n.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,se)});return Oe}async resolveCodeLens(z,j){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,j),H||(H=K),j.isCancellationRequested)return;const _=z.cacheId&&this.e.get(z.cacheId[0]);if(_){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return z.command=this.g.toInternal(H.command,_),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function v(je){return Array.isArray(je)?je.map(n.DefinitionLink.from):je?[n.DefinitionLink.from(je)]:[]}class b{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideDefinition(H,_,K);return v(se)}}class ${constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideDeclaration(H,_,K);return v(se)}}class I{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideImplementation(H,_,K);return v(se)}}class g{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideTypeDefinition(H,_,K);return v(se)}}class D{constructor(z,j){this.d=z,this.e=j}async provideHover(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideHover(H,_,K);if(!(!se||(0,S.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(_)),se.range||(se.range=new c.$iM(_,_)),n.Hover.from(se)}}class y{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideEvaluatableExpression(H,_,K);if(se)return n.EvaluatableExpression.from(se)}}class P{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,K,H){const _=this.d.getDocument(z),se=await this.e.provideInlineValues(_,n.Range.to(j),n.InlineValueContext.to(K),H);if(Array.isArray(se))return se.map(Oe=>n.InlineValue.from(Oe))}}class A{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideDocumentHighlights(H,_,K);if(Array.isArray(se))return se.map(n.DocumentHighlight.from)}}class G{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,K,H){const _=this.d.getDocument(z),se=K.map(Qe=>this.d.getDocument(Qe)),Oe=n.Position.to(j),Ve=await this.e.provideMultiDocumentHighlights(_,Oe,se,H);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class W{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,K){const H=this.d.getDocument(z),_=n.Position.to(j),se=await this.e.provideLinkedEditingRanges(H,_,K);if(se&&Array.isArray(se.ranges))return{ranges:(0,S.$Hb)(se.ranges.map(n.Range.from)),wordPattern:se.wordPattern}}}class U{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,K,H){const _=this.d.getDocument(z),se=n.Position.to(j),Oe=await this.e.provideReferences(_,se,K,H);if(Array.isArray(Oe))return Oe.map(n.location.from)}}class C{static{this.d=1e3}constructor(z,j,K,H,_,se,Oe){this.g=z,this.h=j,this.j=K,this.k=H,this.l=_,this.m=se,this.n=Oe,this.e=new t.$oic("CodeAction"),this.f=new Map}async provideCodeActions(z,j,K,H){const _=this.g.getDocument(z),se=d.$at.isISelection(j)?n.Selection.to(j):n.Range.to(j),Oe=[];for(const rt of this.j.getDiagnostics(z))if(se.intersection(rt.range)&&Oe.push(rt)>C.d)break;const Ve={diagnostics:Oe,only:K.only?new c.$BM(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},Qe=await this.k.provideCodeActions(_,se,Ve,H);if(!(0,S.$Lb)(Qe)||H.isCancellationRequested)return;const xe=this.e.add(Qe),et=new m.$Sc;this.f.set(xe,et);const ot=[];for(let rt=0;rt<Qe.length;rt++){const tt=Qe[rt];if(tt)if(C.o(tt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,et)});else{Ve.only&&(tt.kind?Ve.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=tt.ranges??[];ot.push({cacheId:[xe,rt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,et),diagnostics:tt.diagnostics&&tt.diagnostics.map(n.Diagnostic.from),edit:tt.edit&&n.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,h.$3F)(this.m,"codeActionAI")?tt.isAI:!1,ranges:(0,h.$3F)(this.m,"codeActionRanges")?(0,S.$Hb)(at.map(n.Range.from)):void 0,disabled:tt.disabled?.reason})}}return{cacheId:xe,actions:ot}}async resolveCodeAction(z,j){const[K,H]=z,_=this.e.get(K,H);if(!_||C.o(_))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(_,j)??_;let Oe;se.edit&&(Oe=n.WorkspaceEdit.from(se.edit,void 0));let Ve;if(se.command){const Qe=this.f.get(K);Qe&&(Ve=this.h.toInternal(se.command,Qe))}return{edit:Oe,command:Ve}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class T{constructor(z,j,K,H,_){this.e=z,this.f=j,this.g=K,this.h=H,this.j=_,this.d=new t.$oic("DocumentPasteEdit")}async prepareDocumentPaste(z,j,K,H){if(!this.g.prepareDocumentPaste)return;const _=this.f.getDocument(z),se=j.map(Qe=>n.Range.to(Qe)),Oe=n.DataTransfer.toDataTransfer(K,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(_,se,Oe,H),H.isCancellationRequested)return;const Ve=Array.from(Oe).filter(([,Qe])=>!(Qe instanceof c.$8M));return n.DataTransfer.from(Ve)}async providePasteEdits(z,j,K,H,_,se){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(j),Ve=K.map(ot=>n.Range.to(ot)),Qe=n.DataTransfer.toDataTransfer(H,async ot=>(await this.e.$resolvePasteFileData(this.h,z,ot)).buffer),xe=await this.g.provideDocumentPasteEdits(Oe,Ve,Qe,{only:_.only?new c.$aN(_.only):void 0,triggerKind:_.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const et=this.d.add(xe);return xe.map((ot,rt)=>({_cacheId:[et,rt],title:ot.title??(0,r.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,detail:this.j.displayName||this.j.name,yieldTo:ot.yieldTo?.map(tt=>"mimeType"in tt?tt:{kind:tt.kind.value}),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,j){const[K,H]=z,_=this.d.get(K,H);if(!_||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(_,j)??_;return{additionalEdit:se.additionalEdit?n.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class q{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,K){const H=this.d.getDocument(z),_=await this.e.provideDocumentFormattingEdits(H,j,K);if(Array.isArray(_))return _.map(n.TextEdit.from)}}class ne{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,K,H){const _=this.d.getDocument(z),se=n.Range.to(j),Oe=await this.e.provideDocumentRangeFormattingEdits(_,se,K,H);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,K,H){(0,E.$4f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(z),se=j.map(n.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(_,se,K,H);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}}class ce{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,K,H,_){const se=this.d.getDocument(z),Oe=n.Position.to(j),Ve=await this.e.provideOnTypeFormattingEdits(se,Oe,K,H,_);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class ye{constructor(z,j){this.e=z,this.f=j,this.d=new t.$oic("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const K=await this.e.provideWorkspaceSymbols(z,j);if(!(0,S.$Lb)(K))return{symbols:[]};const H=this.d.add(K),_={cacheId:H,symbols:[]};for(let se=0;se<K.length;se++){const Oe=K[se];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}_.symbols.push({...n.WorkspaceSymbol.from(Oe),cacheId:[H,se]})}return _}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,j);return H&&(0,f.$Pn)(z,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideRenameEdits(z,j,K,H){const _=this.d.getDocument(z),se=n.Position.to(j);try{const Oe=await this.e.provideRenameEdits(_,se,K,H);return Oe?n.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Ve=Ie.g(Oe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(z,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),_=n.Position.to(j);try{const se=await this.e.prepareRename(H,_,K);let Oe,Ve;if(c.$iM.isRange(se)?(Oe=se,Ve=H.getText(se)):(0,E.$Vf)(se)&&(Oe=se.range,Ve=se.placeholder),!Oe||!Ve)return;if(Oe.start.line>_.line||Oe.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Oe),text:Ve}}catch(se){const Oe=Ie.g(se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(se)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideNewSymbolNames(z,j,K){const H=this.d.getDocument(z),_=n.Range.to(j);try{const se=await this.e.provideNewSymbolNames(H,_,K);return se?se.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(se){this.f.error(ue.g(se)??JSON.stringify(se,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ve{constructor(z,j){this.resultId=z,this.tokens=j}}class re{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,K){const H=this.f.getDocument(z),_=j!==0?this.d.get(j):null;let se=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,_.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return _&&this.d.delete(j),se?(se=re.h(se),this.o(re.n(_,se),se)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return re.j(z)?re.k(z)?z:new c.$AN(new Uint32Array(z.data),z.resultId):re.l(z)?re.m(z)?z:new c.$CN(z.edits.map(j=>new c.$BN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!re.j(j)||!z||!z.tokens)return j;const K=z.tokens,H=K.length,_=j.data,se=_.length;let Oe=0;const Ve=Math.min(H,se);for(;Oe<Ve&&K[Oe]===_[Oe];)Oe++;if(Oe===H&&Oe===se)return new c.$CN([],j.resultId);let Qe=0;const xe=Ve-Oe;for(;Qe<xe&&K[H-Qe-1]===_[se-Qe-1];)Qe++;return new c.$CN([{start:Oe,deleteCount:H-Oe-Qe,data:_.subarray(Oe,se-Qe)}],j.resultId)}o(z,j){if(re.j(z)){const K=this.e++;return this.d.set(K,new ve(z.resultId,z.data)),(0,a.$lab)({id:K,type:"full",data:z.data})}if(re.l(z)){const K=this.e++;return re.j(j)?this.d.set(K,new ve(j.resultId,j.data)):this.d.set(K,new ve(z.resultId)),(0,a.$lab)({id:K,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,K){const H=this.d.getDocument(z),_=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(j),K);return _?this.f(_):null}f(z){return(0,a.$lab)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,K,H,_){this.f=z,this.g=j,this.h=K,this.j=H,this.k=_,this.d=new t.$oic("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,K,H){const _=this.f.getDocument(z),se=n.Position.to(j),Oe=_.getWordRangeAtPosition(se)||new c.$iM(se,se),Ve=Oe.with({end:se}),Qe=new k.$2d,xe=await this.h.provideCompletionItems(_,se,H,n.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const et=Array.isArray(xe)?new c.$OM(xe):xe,ot=ie.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),rt=new m.$Sc;this.e.set(ot,rt);const tt=[],at={x:ot,b:tt,a:{replace:n.Range.from(Oe),insert:n.Range.from(Ve)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let Be=0;Be<et.items.length;Be++){const it=et.items[Be],Y=this.l(it,[ot,Be],Ve,Oe);tt.push(Y)}return at}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const H=this.l(K,z),_=await this.h.resolveCompletionItem(K,j);if(!_)return;const se=this.l(_,z);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,f.$Qn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,K,H){const _=this.e.get(j[0]);if(!_)throw Error("DisposableStore is missing...");const se=this.g.toInternal(z.command,_),Oe={x:j,a:z.label,b:z.kind!==void 0?n.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(n.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:n.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(n.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof c.$rM&&(Oe.h=z.insertText.value,Oe.i|=4);let Ve;return z.textEdit?Ve=z.textEdit.range:z.range&&(Ve=z.range),c.$iM.isRange(Ve)?Oe.j=n.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Oe.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Oe}}class le{async provideInlineCompletions(z,j,K,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,K){}handlePartialAccept(z,j,K,H){}}class V extends le{constructor(z,j,K,H){super(),this.f=z,this.g=j,this.h=K,this.j=H,this.d=new ke,this.e=(0,h.$3F)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$3F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,K,H){const _=this.g.getDocument(z),se=n.Position.to(j),Oe=await this.h.provideInlineCompletionItems(_,se,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Ve=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],xe=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Ve}),items:Ve.map((rt,tt)=>{let at;rt.command&&(et||(et=new m.$Sc),at=this.j.toInternal(rt.command,et));const Be=rt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Qe.map(rt=>(et||(et=new m.$Sc),this.j.toInternal(rt,et))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,K){const H=this.d.get(z)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(z,j,K,H){const _=this.d.get(z)?.items[j];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(_,K),this.h.handleDidPartiallyAcceptCompletionItem(_,n.PartialAcceptInfo.to(H)))}}class ee{async provideInlineEdits(z,j,K){const H=this.f.getDocument(z),_=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},K);if(!_||K.isCancellationRequested)return;let se;const Oe=this.d.createReferenceId({dispose(){se?.dispose()},item:_});let Ve;_.accepted&&(se||(se=new m.$Sc),Ve=this.h.toInternal(_.accepted,se));let Qe;return _.rejected&&(se||(se=new m.$Sc),Qe=this.h.toInternal(_.rejected,se)),{pid:Oe,text:_.text,range:n.Range.from(_.range),accepted:Ve,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,K,H){this.f=j,this.g=K,this.h=H,this.d=new ke,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class Ne{constructor(z,j){this.e=z,this.f=j,this.d=new t.$oic("SignatureHelp")}async provideSignatureHelp(z,j,K,H){const _=this.e.getDocument(z),se=n.Position.to(j),Oe=this.g(K),Ve=await this.f.provideSignatureHelp(_,se,H,Oe);if(Ve){const Qe=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Qe}}}g(z){let j;if(z.activeSignatureHelp){const K=n.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class Se{constructor(z,j,K,H,_){this.f=z,this.g=j,this.h=K,this.j=H,this.k=_,this.d=new t.$oic("InlayHints"),this.e=new Map}async provideInlayHints(z,j,K){const H=this.f.getDocument(z),_=n.Range.to(j),se=await this.h.provideInlayHints(H,_,K);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Oe=this.d.add(se);this.e.set(Oe,new m.$Sc);const Ve={hints:[],cacheId:Oe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],_)&&Ve.hints.push(this.m(se[Qe],[Oe,Qe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ve}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.h.resolveInlayHint(K,j);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:n.MarkdownString.fromStrict(z.tooltip),position:n.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(n.TextEdit.from),kind:z.kind&&n.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const _=[];H.label=_;for(const se of z.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:se.value,tooltip:n.MarkdownString.fromStrict(se.tooltip)};c.$sM.isLocation(se.location)&&(Oe.location=n.location.from(se.location)),se.command&&(Oe.command=this.g.toInternal(se.command,K)),_.push(Oe)}}return H}}class be{constructor(z,j){this.e=z,this.f=j,this.d=new t.$oic("DocumentLink")}async provideLinks(z,j){const K=this.e.getDocument(z),H=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(n.DocumentLink.from)};{const _=this.d.add(H),se={links:[],cacheId:_};for(let Oe=0;Oe<H.length;Oe++){if(!be.g(H[Oe]))continue;const Ve=n.DocumentLink.from(H[Oe]);Ve.cacheId=[_,Oe],se.links.push(Ve)}return se}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.f.resolveDocumentLink(K,j);if(!(!H||!be.g(H)))return n.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentColors(K,j);return Array.isArray(H)?H.map(se=>({color:n.Color.from(se.color),range:n.Range.from(se.range)})):[]}async provideColorPresentations(z,j,K){const H=this.d.getDocument(z),_=n.Range.to(j.range),se=n.Color.to(j.color),Oe=await this.e.provideColorPresentations(se,{document:H,range:_},K);if(Array.isArray(Oe))return Oe.map(n.ColorPresentation.from)}}class J{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,K){const H=this.d.getDocument(z),_=await this.e.provideFoldingRanges(H,j,K);if(Array.isArray(_))return _.map(n.FoldingRange.from)}}class Z{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideSelectionRanges(z,j,K){const H=this.d.getDocument(z),_=j.map(n.Position.to),se=await this.e.provideSelectionRanges(H,_,K);if(!(0,S.$Lb)(se))return[];if(se.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Ve=0;Ve<_.length;Ve++){const Qe=[];Oe.push(Qe);let xe=_[Ve],et=se[Ve];for(;;){if(!et.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(n.SelectionRange.from(et)),!et.parent)break;xe=et.range,et=et.parent}}return Oe}}class he{constructor(z,j){this.f=z,this.g=j,this.d=new R.$CO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),_=n.Position.to(j),se=await this.g.prepareCallHierarchy(H,_,K);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,se)]}async provideCallsTo(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(H,K);if(_)return _.map(se=>({from:this.h(z,se.from),fromRanges:se.fromRanges.map(Oe=>n.Range.from(Oe))}))}async provideCallsFrom(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(_)return _.map(se=>({to:this.h(z,se.to),fromRanges:se.fromRanges.map(Oe=>n.Range.from(Oe))}))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=n.CallHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class fe{constructor(z,j){this.f=z,this.g=j,this.d=new R.$CO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),_=n.Position.to(j),se=await this.g.prepareTypeHierarchy(H,_,K);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,se)]}async provideSupertypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(H,K);if(_)return _.map(se=>this.h(z,se))}async provideSubtypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(H,K);if(_)return _.map(se=>this.h(z,se))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=n.TypeHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class Te{constructor(z,j,K,H,_){this.d=z,this.e=j,this.f=K,this.g=H,this.h=_}async provideDocumentOnDropEdits(z,j,K,H,_){const se=this.e.getDocument(j),Oe=n.Position.to(K),Ve=n.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,xe)).buffer),Qe=await this.f.provideDocumentDropEdits(se,Oe,Ve,_);if(Qe)return(0,S.$3b)(Qe).map(xe=>({title:xe.title??(0,r.localize)(1,null,this.h.displayName||this.h.name),kind:xe.kind?.value,yieldTo:xe.yieldTo?.map(et=>"mimeType"in et?et:{kind:et.kind.value}),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?n.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}))}}class de{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,K,H){const _=l.URI.revive(z),se=this.d.getDocument(_),Oe=K.documents.map(xe=>xe.map(et=>({uri:l.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(ot=>n.Range.to(ot))}))),Ve={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,j,Ve,H);return Qe?n.WorkspaceEdit.from(Qe):null}}class Ce{constructor(z,j){this.adapter=z,this.extension=j}}class Re{static{this.d=0}constructor(z,j,K,H,_,se,Oe,Ve){this.g=j,this.h=K,this.j=H,this.k=_,this.l=se,this.m=Oe,this.n=Ve,this.f=new Map,this.e=z.getProxy(p.$eM.MainThreadLanguageFeatures)}o(z,j){return n.DocumentSelector.from(z,this.g,j)}p(z){return new c.$gM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Re.d++}async s(z,j,K,H,_,se=!1){const Oe=this.f.get(z);if(!Oe||!(Oe.adapter instanceof j))return H;const Ve=Date.now();se||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Qe=K(Oe.adapter,Oe.extension);return Promise.resolve(Qe).catch(xe=>{(0,O.$4)(xe)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Oe.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),M.CancellationToken.isCancellationToken(_)?(0,F.$8g)(Qe,_):Qe}t(z,j){const K=this.q();return this.f.set(K,new Ce(z,j)),K}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,j,K,H){const _=this.t(new u(this.h,K),z),se=H&&H.label||Re.u(z);return this.e.$registerDocumentSymbolProvider(_,this.o(j,z),se),this.p(_)}$provideDocumentSymbols(z,j,K){return this.s(z,u,H=>H.provideDocumentSymbols(l.URI.revive(j),K),void 0,K)}registerCodeLensProvider(z,j,K){const H=this.q(),_=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new o(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(j,z),_);let se=this.p(H);if(_!==void 0){const Oe=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(_));se=c.$gM.from(se,Oe)}return se}$provideCodeLenses(z,j,K){return this.s(z,o,H=>H.provideCodeLenses(l.URI.revive(j),K),void 0,K)}$resolveCodeLens(z,j,K){return this.s(z,o,H=>H.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,o,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,K){const H=this.t(new b(this.h,K),z);return this.e.$registerDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideDefinition(z,j,K,H){return this.s(z,b,_=>_.provideDefinition(l.URI.revive(j),K,H),[],H)}registerDeclarationProvider(z,j,K){const H=this.t(new $(this.h,K),z);return this.e.$registerDeclarationSupport(H,this.o(j,z)),this.p(H)}$provideDeclaration(z,j,K,H){return this.s(z,$,_=>_.provideDeclaration(l.URI.revive(j),K,H),[],H)}registerImplementationProvider(z,j,K){const H=this.t(new I(this.h,K),z);return this.e.$registerImplementationSupport(H,this.o(j,z)),this.p(H)}$provideImplementation(z,j,K,H){return this.s(z,I,_=>_.provideImplementation(l.URI.revive(j),K,H),[],H)}registerTypeDefinitionProvider(z,j,K){const H=this.t(new g(this.h,K),z);return this.e.$registerTypeDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideTypeDefinition(z,j,K,H){return this.s(z,g,_=>_.provideTypeDefinition(l.URI.revive(j),K,H),[],H)}registerHoverProvider(z,j,K,H){const _=this.t(new D(this.h,K),z);return this.e.$registerHoverProvider(_,this.o(j,z)),this.p(_)}$provideHover(z,j,K,H){return this.s(z,D,_=>_.provideHover(l.URI.revive(j),K,H),void 0,H)}registerEvaluatableExpressionProvider(z,j,K,H){const _=this.t(new y(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(_,this.o(j,z)),this.p(_)}$provideEvaluatableExpression(z,j,K,H){return this.s(z,y,_=>_.provideEvaluatableExpression(l.URI.revive(j),K,H),void 0,H)}registerInlineValuesProvider(z,j,K,H){const _=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new P(this.h,K),z);this.e.$registerInlineValuesProvider(se,this.o(j,z),_);let Oe=this.p(se);if(_!==void 0){const Ve=K.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(_));Oe=c.$gM.from(Oe,Ve)}return Oe}$provideInlineValues(z,j,K,H,_){return this.s(z,P,se=>se.provideInlineValues(l.URI.revive(j),K,H,_),void 0,_)}registerDocumentHighlightProvider(z,j,K){const H=this.t(new A(this.h,K),z);return this.e.$registerDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,j,K){const H=this.t(new G(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}$provideDocumentHighlights(z,j,K,H){return this.s(z,A,_=>_.provideDocumentHighlights(l.URI.revive(j),K,H),void 0,H)}$provideMultiDocumentHighlights(z,j,K,H,_){return this.s(z,G,se=>se.provideMultiDocumentHighlights(l.URI.revive(j),K,H.map(Oe=>l.URI.revive(Oe)),_),void 0,_)}registerLinkedEditingRangeProvider(z,j,K){const H=this.t(new W(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,z)),this.p(H)}$provideLinkedEditingRanges(z,j,K,H){return this.s(z,W,async _=>{const se=await _.provideLinkedEditingRanges(l.URI.revive(j),K,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Re.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,j,K){const H=this.t(new U(this.h,K),z);return this.e.$registerReferenceSupport(H,this.o(j,z)),this.p(H)}$provideReferences(z,j,K,H,_){return this.s(z,U,se=>se.provideReferences(l.URI.revive(j),K,H,_),void 0,_)}registerCodeActionProvider(z,j,K,H){const _=new m.$Sc,se=this.t(new C(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(se,this.o(j,z),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,_)}))},Re.u(z),!!K.resolveCodeAction),_.add(this.p(se)),_}$provideCodeActions(z,j,K,H,_){return this.s(z,C,se=>se.provideCodeActions(l.URI.revive(j),K,H,_),void 0,_)}$resolveCodeAction(z,j,K){return this.s(z,C,H=>H.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(z,j){this.s(z,C,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,K){const H=this.t(new q(this.h,K),z);return this.e.$registerDocumentFormattingSupport(H,this.o(j,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,j,K,H){return this.s(z,q,_=>_.provideDocumentFormattingEdits(l.URI.revive(j),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,j,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",_=this.t(new ne(this.h,K),z);return this.e.$registerRangeFormattingSupport(_,this.o(j,z),z.identifier,z.displayName||z.name,H),this.p(_)}$provideDocumentRangeFormattingEdits(z,j,K,H,_){return this.s(z,ne,se=>se.provideDocumentRangeFormattingEdits(l.URI.revive(j),K,H,_),void 0,_)}$provideDocumentRangesFormattingEdits(z,j,K,H,_){return this.s(z,ne,se=>se.provideDocumentRangesFormattingEdits(l.URI.revive(j),K,H,_),void 0,_)}registerOnTypeFormattingEditProvider(z,j,K,H){const _=this.t(new ce(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(_,this.o(j,z),H,z.identifier),this.p(_)}$provideOnTypeFormattingEdits(z,j,K,H,_,se){return this.s(z,ce,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(j),K,H,_,se),void 0,se)}registerWorkspaceSymbolProvider(z,j){const K=this.t(new ye(j,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,j,K){return this.s(z,ye,H=>H.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,j,K){return this.s(z,ye,H=>H.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,ye,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,K){const H=this.t(new Ie(this.h,K,this.l),z);return this.e.$registerRenameSupport(H,this.o(j,z),Ie.supportsResolving(K)),this.p(H)}$provideRenameEdits(z,j,K,H,_){return this.s(z,Ie,se=>se.provideRenameEdits(l.URI.revive(j),K,H,_),void 0,_)}$resolveRenameLocation(z,j,K,H){return this.s(z,Ie,_=>_.resolveRenameLocation(l.URI.revive(j),K,H),void 0,H)}registerNewSymbolNamesProvider(z,j,K){const H=this.t(new ue(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,z)),this.p(H)}$provideNewSymbolNames(z,j,K,H){return this.s(z,ue,_=>_.provideNewSymbolNames(l.URI.revive(j),K,H),void 0,H)}registerDocumentSemanticTokensProvider(z,j,K,H){const _=this.t(new re(this.h,K),z),se=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(j,z),H,se);let Oe=this.p(_);if(se){const Ve=K.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Oe=c.$gM.from(Oe,Ve)}return Oe}$provideDocumentSemanticTokens(z,j,K,H){return this.s(z,re,_=>_.provideDocumentSemanticTokens(l.URI.revive(j),K,H),null,H)}$releaseDocumentSemanticTokens(z,j){this.s(z,re,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,K,H){const _=this.t(new $e(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(j,z),H),this.p(_)}$provideDocumentRangeSemanticTokens(z,j,K,H){return this.s(z,$e,_=>_.provideDocumentRangeSemanticTokens(l.URI.revive(j),K,H),null,H)}registerCompletionItemProvider(z,j,K,H){const _=this.t(new ie(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(_,this.o(j,z),H,ie.supportsResolving(K),z.identifier),this.p(_)}$provideCompletionItems(z,j,K,H,_){return this.s(z,ie,se=>se.provideCompletionItems(l.URI.revive(j),K,H,_),void 0,_)}$resolveCompletionItem(z,j,K){return this.s(z,ie,H=>H.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(z,j){this.s(z,ie,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,K,H){const _=new V(z,this.h,K,this.j.converter),se=this.t(_,z);return this.e.$registerInlineCompletionsSupport(se,this.o(j,z),_.supportsHandleEvents,i.$Bm.toKey(z.identifier.value),H?.yieldTo?.map(Oe=>i.$Bm.toKey(Oe))||[]),this.p(se)}$provideInlineCompletions(z,j,K,H,_){return this.s(z,le,se=>se.provideInlineCompletions(l.URI.revive(j),K,H,_),void 0,_)}$handleInlineCompletionDidShow(z,j,K,H){this.s(z,le,async _=>{_.handleDidShowCompletionItem(j,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,K,H,_){this.s(z,le,async se=>{se.handlePartialAccept(j,K,H,_)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,le,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,K){const H=new ee(z,this.h,K,this.j.converter),_=this.t(H,z);return this.e.$registerInlineEditProvider(_,this.o(j,z),z.identifier),this.p(_)}$provideInlineEdit(z,j,K,H){return this.s(z,ee,_=>_.provideInlineEdits(l.URI.revive(j),K,H),void 0,H)}$freeInlineEdit(z,j){this.s(z,ee,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,K,H){const _=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Ne(this.h,K),z);return this.e.$registerSignatureHelpProvider(se,this.o(j,z),_),this.p(se)}$provideSignatureHelp(z,j,K,H,_){return this.s(z,Ne,se=>se.provideSignatureHelp(l.URI.revive(j),K,H,_),void 0,_)}$releaseSignatureHelp(z,j){this.s(z,Ne,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new Se(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(_,this.o(j,z),typeof K.resolveInlayHint=="function",H,Re.u(z));let se=this.p(_);if(H!==void 0){const Oe=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));se=c.$gM.from(se,Oe)}return se}$provideInlayHints(z,j,K,H){return this.s(z,Se,_=>_.provideInlayHints(l.URI.revive(j),K,H),void 0,H)}$resolveInlayHint(z,j,K){return this.s(z,Se,H=>H.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(z,j){this.s(z,Se,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,K){const H=this.t(new be(this.h,K),z);return this.e.$registerDocumentLinkProvider(H,this.o(j,z),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,j,K){return this.s(z,be,H=>H.provideLinks(l.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(z,j,K){return this.s(z,be,H=>H.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,be,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,K){const H=this.t(new ge(this.h,K),z);return this.e.$registerDocumentColorProvider(H,this.o(j,z)),this.p(H)}$provideDocumentColors(z,j,K){return this.s(z,ge,H=>H.provideColors(l.URI.revive(j),K),[],K)}$provideColorPresentations(z,j,K,H){return this.s(z,ge,_=>_.provideColorPresentations(l.URI.revive(j),K,H),void 0,H)}registerFoldingRangeProvider(z,j,K){const H=this.q(),_=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new J(this.h,K),z)),this.e.$registerFoldingRangeProvider(H,this.o(j,z),z.identifier,_);let se=this.p(H);if(_!==void 0){const Oe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));se=c.$gM.from(se,Oe)}return se}$provideFoldingRanges(z,j,K,H){return this.s(z,J,_=>_.provideFoldingRanges(l.URI.revive(j),K,H),void 0,H)}registerSelectionRangeProvider(z,j,K){const H=this.t(new Z(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(j,z)),this.p(H)}$provideSelectionRanges(z,j,K,H){return this.s(z,Z,_=>_.provideSelectionRanges(l.URI.revive(j),K,H),[],H)}registerCallHierarchyProvider(z,j,K){const H=this.t(new he(this.h,K),z);return this.e.$registerCallHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareCallHierarchy(z,j,K,H){return this.s(z,he,_=>Promise.resolve(_.prepareSession(l.URI.revive(j),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,j,K,H){return this.s(z,he,_=>_.provideCallsTo(j,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,j,K,H){return this.s(z,he,_=>_.provideCallsFrom(j,K,H),void 0,H)}$releaseCallHierarchy(z,j){this.s(z,he,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,K){const H=this.t(new fe(this.h,K),z);return this.e.$registerTypeHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareTypeHierarchy(z,j,K,H){return this.s(z,fe,_=>Promise.resolve(_.prepareSession(l.URI.revive(j),K,H)),void 0,H)}$provideTypeHierarchySupertypes(z,j,K,H){return this.s(z,fe,_=>_.provideSupertypes(j,K,H),void 0,H)}$provideTypeHierarchySubtypes(z,j,K,H){return this.s(z,fe,_=>_.provideSubtypes(j,K,H),void 0,H)}$releaseTypeHierarchy(z,j){this.s(z,fe,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,K,H){const _=this.q();return this.f.set(_,new Ce(new Te(this.e,this.h,K,_,z),z)),this.e.$registerDocumentOnDropEditProvider(_,this.o(j,z),(0,h.$3F)(z,"dropMetadata")?H:void 0),this.p(_)}$provideDocumentOnDropEdits(z,j,K,H,_,se){return this.s(z,Te,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(j,l.URI.revive(K),H,_,se)),void 0,void 0)}registerMappedEditsProvider(z,j,K){const H=this.t(new de(this.h,K),z);return this.e.$registerMappedEditsProvider(H,this.o(j,z)),this.p(H)}$provideMappedEdits(z,j,K,H,_){return this.s(z,de,se=>Promise.resolve(se.provideMappedEdits(j,K,H,_)),null,_)}registerDocumentPasteEditProvider(z,j,K,H){const _=this.q();return this.f.set(_,new Ce(new T(this.e,this.h,K,_,z),z)),this.e.$registerPasteEditProvider(_,this.o(j,z),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(z,j,K,H,_){return this.s(z,T,se=>se.prepareDocumentPaste(l.URI.revive(j),K,H,_),void 0,_)}$providePasteEdits(z,j,K,H,_,se,Oe){return this.s(z,T,Ve=>Ve.providePasteEdits(j,l.URI.revive(K),H,_,se,Oe),void 0,Oe)}$resolvePasteEdit(z,j,K){return this.s(z,T,H=>H.resolvePasteEdit(j,K),{},void 0)}$releasePasteEdits(z,j){this.s(z,T,K=>Promise.resolve(K.releasePasteEdits(j)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Re.w(z.decreaseIndentPattern),increaseIndentPattern:Re.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Re.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Re.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Re.w(z.beforeText),afterText:z.afterText?Re.w(z.afterText):void 0,previousLineText:z.previousLineText?Re.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Re.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>c.SyntaxTokenType.toString(j)):void 0}}static D(z){return z.map(Re.C)}setLanguageConfiguration(z,j,K){const{wordPattern:H}=K;if(H&&(0,N.$9e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const _=this.q(),se={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,j,se),this.p(_)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$yic=Re}),define(Pe[88],Me([1,0,6,4,8,7,101,20,11,5,165,106,14,3,17,84,13]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0,e.$Fic=(0,w.$gi)("IExtHostLanguageModels");class i{constructor(t,p){this.option=t,this.stream=new f.$Jh,this.stream=p??new f.$Jh}}class n{constructor(){this.a=new Map,this.b=new f.$Jh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let p=this.a.get(t.index);p||(this.a.size===0?p=new i(t.index,this.b):p=new i(t.index),this.a.set(t.index,p)),p.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const p of this.f())p.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let c=class{static{r=this}static{this.a=1}constructor(t,p,u){this.j=p,this.k=u,this.c=new k.$6d,this.d=new k.$6d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Dm,this.i=new Map,this.o=new Set,this.b=t.getProxy(F.$eM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,p,u,o){const v=r.a++;this.f.set(v,{extension:t.identifier,provider:u,languageModelId:p});let b;return o.auth&&(b={providerLabel:t.displayName||t.name,accountLabel:typeof o.auth=="object"?o.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,p,{extension:t.identifier,identifier:p,model:o.name??"",auth:b}),(0,S.$Rc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(t,p,u,o,v,b){const $=this.f.get(t);if(!$)return;const I=new R.$Nv(async g=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:g.index,part:g.part})});return $.provider.provideLanguageModelResponse2(o.map(M.LanguageModelMessage.to),v,m.$Bm.toKey(u),I,b)}$updateLanguageModels(t){const p=[],u=[];if(t.added)for(const o of t.added)this.g.set(o.identifier,o),p.push(o.model);if(t.removed)for(const o of t.removed){this.g.delete(o),u.push(o);for(const[v,b]of this.i)b.languageModelId===o&&(b.res.reject(new l.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(p),removed:Object.freeze(u)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const p=new Array;for(const{from:u,to:o,enabled:v}of t){const b=this.h.get(u)??new m.$Cm;if(b.has(o)!==v){v?b.add(o):b.delete(o),this.h.set(u,b);const I={from:u,to:o};p.push(I),this.c.fire(I)}}}async sendChatRequest(t,p,u,o,v){const b=t.identifier,$=await this.b.$prepareChatAccess(b,p,o.justification);if(!$||!this.g.has(p))throw O.$lO.NotFound(`Language model '${p}' is unknown.`);if(this.m(b,$)&&(!await this.l(t,{identifier:$.extension,displayName:$.auth.providerLabel},o.justification,o.silent)||!this.h.get(b)?.has($.extension)))throw O.$lO.NoPermissions(`Language model '${p}' cannot be used by '${b.value}'.`);const I=Math.random()*1e6|0,g=this.b.$fetchResponse(b,p,I,u.map(M.LanguageModelMessage.from),o.modelOptions??{},v),D=new f.$fh,y=new n;this.i.set(I,{languageModelId:p,res:y});let P;if(g.catch(A=>{D.isOpen()?y.reject(A):P=A}).finally(()=>{this.i.delete(I),y.resolve(),D.open()}),await D.wait(),P)throw new O.$lO(`Language model '${p}' errored, check cause for more details`,"Unknown",P);return y.apiObject}async $handleResponseFragment(t,p){const u=this.i.get(t);u&&u.res.handleFragment(p)}async l(t,p,u,o){const v=E.$gL+p.identifier.value;if(await this.k.getSession(t,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0;if(o)return!1;try{const $=u?(0,N.localize)(0,null,p.displayName,u):(0,N.localize)(1,null,p.displayName);return await this.k.getSession(t,v,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}m(t,p){return!!p.auth&&!m.$Bm.equals(p.extension,t)}async n(t){for(const p of this.o)try{await this.l(p,{identifier:t.extension,displayName:""},void 0,!0)}catch(u){this.j.error("Fake Auth request failed"),this.j.error(u)}}createLanguageModelAccessInformation(t){this.o.add(t);const p=this,u=k.Event.signal(k.Event.filter(this.c.event,v=>m.$Bm.equals(v.from,t.identifier))),o=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(u,o)},canSendRequest(v){const b=p.g.get(v);if(!b)return;if(!p.m(t.identifier,b))return!0;const $=p.h.get(t.identifier);if($)return $.has(b.extension)}}}};e.$Gic=c,e.$Gic=c=r=Je([qe(0,d.$xO),qe(1,a.$Mj),qe(2,s.$Aic)],c)}),define(Pe[261],Me([1,0,4,8,7,32,11,6,22]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class k{constructor(E,l,w,d){this.c=l,this.d=w,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(S.$eM.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,l){await this.a.$changeLanguage(E,l);const w=this.c.getDocumentData(E);if(!w)throw new Error(`document '${E.toString()}' NOT found`);return w.document}async tokenAtPosition(E,l){const w=E.version,d=F.Position.from(l),s=await this.a.$tokensAtPosition(E.uri,d),a={type:M.StandardTokenType.Other,range:E.getWordRangeAtPosition(l)??new M.$iM(l.line,l.character,l.line,l.character)};if(!s)return a;const r={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!r.range.contains(l)||w!==E.version?a:r}createLanguageStatusItem(E,l,w){const d=this.f++,s=this.a,a=this.g,r=`${E.identifier.value}/${l}`;if(a.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(r);const i={selector:w,id:l,name:E.displayName??E.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new m.$Sc,h=()=>{if(n?.dispose(),!a.has(r)){console.warn(`LanguageStatusItem (${l}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$ih)(()=>{c.clear(),this.a.$setLanguageStatus(d,{id:r,name:i.name??E.displayName??E.name,source:E.displayName??E.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===M.LanguageStatusSeverity.Error?O.default.Error:i.severity===M.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),s.$removeLanguageStatus(d),a.delete(r)},get id(){return i.id},get name(){return i.name},set name(p){i.name=p,h()},get selector(){return i.selector},set selector(p){i.selector=p,h()},get text(){return i.text},set text(p){i.text=p,h()},set text2(p){(0,f.$4F)(E,"languageStatusText"),i.text=p,h()},get text2(){return(0,f.$4F)(E,"languageStatusText"),i.text},get detail(){return i.detail},set detail(p){i.detail=p,h()},get severity(){return i.severity},set severity(p){i.severity=p,h()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(p){i.accessibilityInformation=p,h()},get command(){return i.command},set command(p){i.command=p,h()},get busy(){return i.busy},set busy(p){i.busy=p,h()}};return h(),t}}e.$Zjc=k}),define(Pe[262],Me([1,0,12,2,8,7,83]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0;class m{constructor(E,l,w,d){this.start=E,this.deletedCount=l,this.deletedItems=w,this.items=d}asApiEvent(){return{range:new O.$HN(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,l,w){this.notebook=E,this.h=l,this.j=w,this.handle=w.handle,this.uri=F.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(M.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return E.g},set mime(d){E.g=d},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(w)}return this.f}setOutputs(E){this.a=E.map(M.NotebookCellOutput.to)}setOutputItems(E,l,w){const d=w.map(M.NotebookCellOutputItem.to),s=this.a.find(a=>a.id===E);if(s&&(l||(s.items.length=0),s.items.push(...d),s.items.length>1&&s.items.every(a=>R.$_J(a.mime)))){const a=new Map,r=[];s.items.forEach(i=>{let n;a.has(i.mime)?n=a.get(i.mime):(n=[],a.set(i.mime,n),r.push(i.mime)),n.push(i.data)}),s.items.length=0,r.forEach(i=>{const n=R.$aK(a.get(i));s.items.push({mime:i,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Kjc=f;class k{static{this.a=0}constructor(E,l,w,d,s){this.k=E,this.l=l,this.m=w,this.uri=d,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,l={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===S.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(w){return w=E.n(w),E.b[w].apiCell},getCells(w){return(w?E.p(w):E.b).map(s=>s.apiCell)},save(){return E.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,l,w){this.g=E.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:w});const d={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},s=[];for(const r of E.rawEvents)r.kind===R.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,d.contentChanges):r.kind===R.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,d.contentChanges):r.kind===R.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const a=new Map;for(let r=0;r<s.length;r++){const i=s[r],n=a.get(i.cell);if(n===void 0){const c=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});a.set(i.cell,c-1)}else d.cellChanges[n]={...d.cellChanges[n],...i}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let l=E.start|0,w=E.end|0;return l<0&&(l=0),w>this.b.length&&(w=this.b.length),E.with({start:l,end:w})}p(E){E=this.o(E);const l=[];for(let w=E.start;w<E.end;w++)l.push(this.b[w]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,l,w){if(this.j)return;const d=[],s=[],a=[];if(E.reverse().forEach(r=>{const n=r[2].map(t=>{const p=new f(this,this.l,t);return l||s.push(f.asModelAddData(t)),p}),c=new m(r[0],r[1],[],n),h=this.b.splice(r[0],r[1],...n);for(const t of h)a.push(t.uri),c.deletedItems.push(t.apiCell);d.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),w)for(const r of d)w.push(r.asApiEvent())}s(E,l,w,d){const s=this.b.splice(E,l);this.b.splice(w,0,...s);const a=[new m(E,l,s.map(r=>r.apiCell),[]),new m(w,0,[],s)];for(const r of a)d.push(r.asApiEvent())}t(E,l){this.b[E].setOutputs(l)}u(E,l,w,d){this.b[E].setOutputItems(l,w,d)}v(E,l){const w=this.b[E];w.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(w.uri,l)}w(E,l){const w=this.b[E];w.apiCell.mime=l}x(E,l){this.b[E].setMetadata(l)}y(E,l){this.b[E].setInternalMetadata(l)}getCellFromApiCell(E){return this.b.find(l=>l.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(l=>l.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Ljc=k}),define(Pe[263],Me([1,0,5,2,8,7]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class R{constructor(f,k,N,E={timeout:1500,errors:3}){this.b=f,this.c=k,this.d=N,this.f=E,this.a=new S.$8d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(k,N,E)=>{const l=function(d){k.call(N,d)};return l.extension=f,this.a.event(l,void 0,E)}}async $participateInSave(f,k,N){const E=F.URI.revive(f),l=this.c.getNotebookDocument(E);if(!l)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:M.TextDocumentSaveReason.to(k)},N,async(s,a)=>{const r=Date.now(),i=await await Promise.resolve(s);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!N.isCancellationRequested&&i&&(i instanceof O.$qM?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),N.isCancellationRequested)return!1;if(w.length===0)return!0;const d={edits:[]};for(const s of w){const{edits:a}=M.WorkspaceEdit.from(s);d.edits=d.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(d)}}e.$2jc=R}),define(Pe[112],Me([1,0,14,8,7]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,k,N,E,l){this.id=m,this.f=f,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=N,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(f){this.selections=[f]},get selections(){return m.a},set selections(f){if(!Array.isArray(f)||!f.every(M.$HN.isNotebookRange))throw(0,S.$7)("selections");m.a=f,m.g(f)},get visibleRanges(){return m.b},revealRange(f,k){m.f.$tryRevealRange(m.id,F.NotebookRange.from(f),k??M.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(F.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Mjc=O}),define(Pe[264],Me([1,0,5,13,8]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=void 0;let O=class{constructor(m,f){this.c=m,this.d=f,this.a=new S.$6d,this.b=new S.$6d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const k=this.d.getEditorById(m);f.visibleRanges&&k._acceptVisibleRanges(f.visibleRanges.ranges.map(M.NotebookRange.to)),f.selections&&k._acceptSelections(f.selections.selections.map(M.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this.d.getEditorById(f)._acceptViewColumn(M.ViewColumn.to(m[f]))}};e.$4jc=O,e.$4jc=O=Je([qe(0,F.$Mj)],O)}),define(Pe[265],Me([1,0,5,4,112]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=void 0;class O{constructor(m,f){this.c=f,this.a=new Map,this.b=m.getProxy(F.$eM.MainThreadNotebookRenderers)}$postRendererMessage(m,f,k){const N=this.c.getEditorById(m);this.a.get(f)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(N=>N.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(N,E,l)=>this.d(f).event(N,E,l),postMessage:(N,E)=>{M.$Mjc.apiEditorsToExtHost.has(N)&&([N,E]=[E,N]);const l=E&&M.$Mjc.apiEditorsToExtHost.get(E);return this.b.$postMessage(l?.id,f,N)}}}d(m){let f=this.a.get(m);return f||(f=new S.$6d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(m)}}),this.a.set(m,f),f)}}e.$7jc=O}),define(Pe[266],Me([1,0,8,101,25,68,14]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class m{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,l,w){const d=this.b++,{title:s,location:a,cancellable:r}=l,i={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(d,{location:S.ProgressLocation.from(a),title:s,source:i,cancellable:r},E.isUnderDevelopment?void 0:E.identifier.value).catch(R.$2),this.d(d,w,!!r)}d(E,l,w){let d;w&&(d=new M.$de,this.c.set(E,d));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),d?.dispose()};let a;try{a=l(new k(this.a,E),w&&d?d.token:M.CancellationToken.None)}catch(r){throw s(E),r}return a.then(r=>s(E),r=>s(E)),a}$acceptProgressCanceled(E){const l=this.c.get(E);l&&(l.cancel(),this.c.delete(E))}}e.$$jc=m;function f(N,E){return N.message=E.message,typeof E.increment=="number"&&(typeof N.increment=="number"?N.increment+=E.increment:N.increment=E.increment),N}class k extends F.$Nv{constructor(E,l){super(w=>this.throttledReport(w)),this.c=E,this.d=l}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,O.$Mh)(100,(N,E)=>f(N,E),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Pe[267],Me([1,0,2,4,11,8]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class R{static{this.a=0}constructor(f,k){this.d=k,this.c=new Map,this.b=f.getProxy(F.$eM.MainThreadQuickDiff)}$provideOriginalResource(f,k,N){const E=S.URI.revive(k),l=this.c.get(f);return l?(0,M.$$g)(()=>l.provideOriginalResource(E,N)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(f,k,N,E){const l=R.a++;return this.c.set(l,k),this.b.$registerQuickDiffProvider(l,O.DocumentSelector.from(f,this.d),N,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$_jc=R}),define(Pe[268],Me([1,0,25,5,6,4,2,7,14,18,32,40,22,8]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=d;function d(s,a,r){const i=s.getProxy(O.$eM.MainThreadQuickOpen);class n{constructor($,I){this.e=new Map,this.f=0,this.a=$,this.b=I}showQuickPick($,I,g,D=S.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),P=++this.f,A=i.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},D),G={},W=A.then(()=>G);return Promise.race([W,y]).then(U=>{if(U===G)return;const C=(0,l.$3F)($,"quickPickItemTooltip");return y.then(T=>{const q=[];for(let ne=0;ne<T.length;ne++){const ce=T[ne];if(typeof ce=="string")q.push({label:ce,handle:ne});else if(ce.kind===m.QuickPickItemKind.Separator)q.push({type:"separator",label:ce.label});else{ce.tooltip&&!C&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const ye=ce.iconPath?u(ce.iconPath):void 0;q.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:C?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ne})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=ne=>{g.onDidSelectItem(T[ne])}),i.$setItems(P,q),A.then(ne=>{if(typeof ne=="number")return T[ne];if(Array.isArray(ne))return ne.map(ce=>T[ce])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return i.$setError(P,U),Promise.reject(U)})}$onItemSelected($){this.c?.($)}showInput($,I=S.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",I).then(void 0,g=>{if(!(0,f.$4)(g))return Promise.reject(g)})}async $validateInput($){if(!this.d)return;const I=await this.d($);if(!I||typeof I=="string")return I;let g;switch(I.severity){case m.InputBoxValidationSeverity.Info:g=N.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=N.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=N.default.Error;break;default:g=I.message?N.default.Error:N.default.Ignore;break}return{content:I.message,severity:g}}async showWorkspaceFolderPick($,I=S.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!g)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick($){const I=new o($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox($){const I=new v($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue($,I){this.e.get($)?._fireDidChangeValue(I)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,I){const g=this.e.get($);g instanceof o&&g._fireDidChangeActive(I)}$onDidChangeSelection($,I){const g=this.e.get($);g instanceof o&&g._fireDidChangeSelection(I)}$onDidTriggerButton($,I){this.e.get($)?._fireDidTriggerButton(I)}$onDidTriggerItemButton($,I,g){const D=this.e.get($);D instanceof o&&D._fireDidTriggerItemButton(I,g)}$onDidHide($){this.e.get($)?._fireDidHide()}}class c{static{this.a=1}constructor($,I){this.x=$,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$6d,this.q=new F.$6d,this.r=new F.$6d,this.s=new F.$6d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((I,g)=>{const D=I===m.$EN.Back?-1:g;this.o.set(D,I)}),this.z({buttons:$.map((I,g)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===m.$EN.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const I=this.o.get($);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const I of Object.keys($)){const g=$[I];this.u[I]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function h(b){if(b instanceof m.$cN)return{id:b.id};const $=p(b),I=t(b);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof I=="string"?R.URI.file(I):I}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function p(b){return typeof b=="object"&&"dark"in b?b.dark:b}function u(b){const $=h(b);let I,g;return"id"in $?g=E.ThemeIcon.asClassName($):I=$,{iconPath:I,iconClass:g}}class o extends c{constructor($,I){super($.identifier,I),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$6d,this.L=[],this.M=new F.$6d,this.N=new F.$6d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((D,y)=>{this.C.set(y,D),this.D.set(D,y)});const I=(0,l.$3F)(this.O,"quickPickItemTooltip"),g=[];for(let D=0;D<$.length;D++){const y=$[D];if(y.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?u(y.iconPath):void 0;g.push({handle:D,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?w.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((A,G)=>({...u(A.iconPath),tooltip:A.tooltip,handle:G}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive($){const I=(0,k.$Hb)($.map(g=>this.C.get(g)));this.J=I,this.K.fire(I)}_fireDidChangeSelection($){const I=(0,k.$Hb)($.map(g=>this.C.get(g)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton($,I){const g=this.C.get($);if(!g||!g.buttons||!g.buttons.length)return;const D=g.buttons[I];D&&this.N.fire({button:D,item:g})}}class v extends c{constructor($,I){super($.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:N.default.Error}):this.z({validationMessage:$.message,severity:$.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new n(a,r)}}),define(Pe[269],Me([1,0,2,5,68,6,11,4,18,141,13,20,40,8,22,12,21]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0;function i(P){return P instanceof S.URI}function n(P,A){return P.scheme===s.Schemas.file&&A.scheme===s.Schemas.file&&a.$k?P.toString()===A.toString():P.toString().toLowerCase()===A.toString().toLowerCase()}function c(P){if(P)return typeof P.iconPath=="string"?S.URI.file(P.iconPath):S.URI.isUri(P.iconPath)||l.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function h(P){if(P.icon){if(S.URI.isUri(P.icon))return P.icon;if(l.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const A=P.icon;return{light:A.light,dark:A.dark}}}else return}function t(P,A){if(!P.iconPath&&!A.iconPath)return 0;if(P.iconPath){if(!A.iconPath)return 1}else return-1;const G=typeof P.iconPath=="string"?P.iconPath:S.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,W=typeof A.iconPath=="string"?A.iconPath:S.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id;return(0,k.$9q)(G,W)}function p(P,A){let G=0;if(P.strikeThrough!==A.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==A.faded)return P.faded?1:-1;if(P.tooltip!==A.tooltip)return(P.tooltip||"").localeCompare(A.tooltip||"");if(G=t(P,A),G!==0)return G;if(P.light&&A.light)G=t(P.light,A.light);else{if(P.light)return 1;if(A.light)return-1}if(G!==0)return G;if(P.dark&&A.dark)G=t(P.dark,A.dark);else{if(P.dark)return 1;if(A.dark)return-1}return G}function u(P,A){if(P.command!==A.command)return P.command<A.command?-1:1;if(P.title!==A.title)return P.title<A.title?-1:1;if(P.tooltip!==A.tooltip){if(P.tooltip!==void 0&&A.tooltip!==void 0)return P.tooltip<A.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(A.tooltip!==void 0)return-1}if(P.arguments===A.arguments)return 0;if(P.arguments)if(A.arguments){if(P.arguments.length!==A.arguments.length)return P.arguments.length-A.arguments.length}else return 1;else return-1;for(let G=0;G<P.arguments.length;G++){const W=P.arguments[G],U=A.arguments[G];if(W!==U&&!(i(W)&&i(U)&&n(W,U)))return W<U?-1:1}return 0}function o(P,A){let G=(0,k.$9q)(P.resourceUri.fsPath,A.resourceUri.fsPath,!0);if(G!==0)return G;if(P.command&&A.command)G=u(P.command,A.command);else{if(P.command)return 1;if(A.command)return-1}if(G!==0)return G;if(P.decorations&&A.decorations)G=p(P.decorations,A.decorations);else{if(P.decorations)return 1;if(A.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&A.multiFileDiffEditorModifiedUri)G=(0,k.$9q)(P.multiFileDiffEditorModifiedUri.fsPath,A.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(A.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&A.multiDiffEditorOriginalUri)G=(0,k.$9q)(P.multiDiffEditorOriginalUri.fsPath,A.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(A.multiDiffEditorOriginalUri)return-1}return G}function v(P,A){for(let G=0;G<P.length;G++)if(P[G]!==A[G])return!1;return!0}function b(P,A){return P.command===A.command&&P.title===A.title&&P.tooltip===A.tooltip&&(P.arguments&&A.arguments?v(P.arguments,A.arguments):P.arguments===A.arguments)}function $(P,A){return(0,f.$ub)(P,A,b)}class I{#e;#t;get value(){return this.d}set value(A){A=A??"",this.#e.$setInputBoxValue(this.l,A),this.n(A)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(A){this.#e.$setInputBoxPlaceholder(this.l,A),this.f=A}get validateInput(){return(0,d.$4F)(this.k,"scmValidation"),this.g}set validateInput(A){if((0,d.$4F)(this.k,"scmValidation"),A&&typeof A!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=A,this.#e.$setValidationProviderIsEnabled(this.l,!!A)}get enabled(){return this.h}set enabled(A){A=!!A,this.h!==A&&(this.h=A,this.#e.$setInputBoxEnablement(this.l,A))}get visible(){return this.j}set visible(A){A=!!A,this.j!==A&&(this.j=A,this.#e.$setInputBoxVisibility(this.l,A))}get document(){return(0,d.$4F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(A,G,W,U,C){this.k=A,this.l=U,this.m=C,this.d="",this.e=new F.$6d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(A,G){(0,d.$4F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,A,G)}$onInputBoxValueChange(A){this.n(A)}n(A){this.d=A,this.e.fire(A)}}e.$bkc=I;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(A){this.v=A,this.q.$updateGroupLabel(this.t,this.handle,A)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(A){this.p=A,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(A){this.f=[...A],this.k.fire()}constructor(A,G,W,U,C,T,q){this.q=A,this.s=G,this.t=W,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=T,this.w=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$6d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$6d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(A){return this.g.get(A)}$executeResourceCommand(A,G){const W=this.h.get(A);return W?(0,R.$$g)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const A=[...this.f].sort(o),W=(0,f.$Db)(this.o,A,o).map(T=>{const q=T.toInsert.map(ne=>{const ce=this.e++;this.g.set(ce,ne);const ye=ne.resourceUri;let Ie;if(ne.command)if(ne.command.command==="vscode.open"||ne.command.command==="vscode.diff"||ne.command.command==="vscode.changes"){const ge=new O.$Sc;Ie=this.s.converter.toInternal(ne.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ne.command);const ue=(0,d.$3F)(this.w,"scmMultiDiffEditor"),ve=ue?ne.multiDiffEditorOriginalUri:void 0,re=ue?ne.multiFileDiffEditorModifiedUri:void 0,$e=c(ne.decorations),ie=ne.decorations&&c(ne.decorations.light)||$e,le=ne.decorations&&c(ne.decorations.dark)||$e,V=[ie,le],ee=ne.decorations&&ne.decorations.tooltip||"",ke=ne.decorations&&!!ne.decorations.strikeThrough,Ne=ne.decorations&&!!ne.decorations.faded,Se=ne.contextValue||"";return{rawResource:[ce,ye,V,ee,ke,Ne,Se,Ie,ve,re],handle:ce}});return{start:T.start,deleteCount:T.deleteCount,toInsert:q}}),U=W.map(({start:T,deleteCount:q,toInsert:ne})=>[T,q,ne.map(ce=>ce.rawResource)]),C=W.reverse();for(const{start:T,deleteCount:q,toInsert:ne}of C){const ce=ne.map(Ie=>Ie.handle),ye=this.n.splice(T,q,...ce);for(const Ie of ye)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=A,U}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(A){this.g!==A&&(this.g=A,this.#e.$updateSourceControl(this.w,{count:A}))}get quickDiffProvider(){return this.h}set quickDiffProvider(A){this.h=A;let G;(0,d.$3F)(this.x,"quickDiffProvider")&&(G=A?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!A,quickDiffLabel:G})}get historyProvider(){return(0,d.$4F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(A){(0,d.$4F)(this.x,"scmHistoryProvider"),this.j=A,this.k.value=new O.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!A}),A&&this.k.value.add(A.onDidChangeCurrentHistoryItemGroup(()=>{this.l=A?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(A){A!==this.m&&(this.m=A,this.#e.$updateSourceControl(this.w,{commitTemplate:A}))}get acceptInputCommand(){return this.o}set acceptInputCommand(A){this.n.value=new O.$Sc,this.o=A;const G=this.y.converter.toInternal(A,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,d.$4F)(this.x,"scmActionButton"),this.q}set actionButton(A){(0,d.$4F)(this.x,"scmActionButton"),this.p.value=new O.$Sc,this.q=A;const G=A!==void 0?{command:this.y.converter.toInternal(A.command,this.p.value),secondaryCommands:A.secondaryCommands?.map(W=>W.map(U=>this.y.converter.toInternal(U,this.p.value))),description:A.description,enabled:A.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(A){if(this.t&&A&&$(this.t,A))return;this.s.value=new O.$Sc,this.t=A;const G=(A||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(A,G,W,U,C,T,q){this.x=A,this.y=U,this.z=C,this.A=T,this.B=q,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Uc,this.m=void 0,this.n=new O.$Uc,this.o=void 0,this.p=new O.$Uc,this.s=new O.$Uc,this.t=void 0,this.u=!1,this.v=new F.$6d,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=W;const ne=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:q?`rootUri=${encodeURIComponent(q.toString())}`:void 0});this.f=new I(A,G,this.#e,this.w,ne),this.#e.$registerSourceControl(this.w,C,T,q,ne)}createResourceGroup(A,G,W){const U=(0,d.$3F)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,C=new g(this.#e,this.y,this.w,A,G,U,this.x),T=F.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,T),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const A=[],G=[];for(const[W,U]of this.C){U.dispose();const C=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});F.Event.once(W.onDidDispose)(()=>{this.D.delete(W),C.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),A.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const T=W._takeResourceStateSnapshot();T.length>0&&G.push([W.handle,T]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,A,G),this.C.clear()}eventuallyUpdateResourceStates(){const A=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&A.push([G.handle,W])}),A.length>0&&this.#e.$spliceResourceStates(this.w,A),this.D.clear()}getResourceGroup(A){return this.e.get(A)}setSelectionState(A){this.u=A,this.v.fire(A)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(A=>A.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Lh)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Lh)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(A,G,W,U){this.l=G,this.m=W,this.n=U,this.g=new Map,this.h=new E.$Dm,this.j=new F.$6d,this.e=A.getProxy(m.$eM.MainThreadSCM),this.f=A.getProxy(m.$eM.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const T=this.g.get(C.sourceControlHandle);if(!T)return C;const q=T.getResourceGroup(C.groupHandle);return q?q.getResourceState(C.handle):C}else if(C&&C.$mid===4){const T=this.g.get(C.sourceControlHandle);return T?T.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const T=this.g.get(C.handle);return T||C}return C}})}createSourceControl(A,G,W,U){this.n.trace("ExtHostSCM#createSourceControl",A.identifier.value,G,W,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:A.identifier.value});const C=r.d++,T=new D(A,this.m,this.e,this.l,G,W,U);this.g.set(C,T);const q=this.h.get(A.identifier)||[];return q.push(T),this.h.set(A.identifier,q),T}getLastInputBox(A){this.n.trace("ExtHostSCM#getLastInputBox",A.identifier.value);const G=this.h.get(A.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(A,G,W){const U=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",A,U.toString());const C=this.g.get(A);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$$g)(()=>C.quickDiffProvider.provideOriginalResource(U,W)).then(T=>T||null)}$onInputBoxValueChange(A,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",A);const W=this.g.get(A);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(A,G,W,U){this.n.trace("ExtHostSCM#$executeResourceCommand",A,G,W);const C=this.g.get(A);if(!C)return Promise.resolve(void 0);const T=C.getResourceGroup(G);return T?T.$executeResourceCommand(W,U):Promise.resolve(void 0)}$validateInput(A,G,W){this.n.trace("ExtHostSCM#$validateInput",A);const U=this.g.get(A);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$$g)(()=>U.inputBox.validateInput(G,W)).then(C=>{if(!C)return Promise.resolve(void 0);const T=w.MarkdownString.fromStrict(C.message);return T?Promise.resolve([T,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(A){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",A),A!==void 0&&this.g.get(A)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=A,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(A,G,W,U){return await this.g.get(A)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,U)??void 0}async $provideHistoryItems(A,G,W,U){return(await this.g.get(A)?.historyProvider?.provideHistoryItems(G,W,U))?.map(q=>({...q,icon:h(q)}))??void 0}async $provideHistoryItemSummary(A,G,W,U){const C=this.g.get(A)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const T=await C.provideHistoryItemSummary(G,W,U);return T?{...T,icon:h(T)}:void 0}async $provideHistoryItemChanges(A,G,W,U){return await this.g.get(A)?.historyProvider?.provideHistoryItemChanges(G,W,U)??void 0}};e.$ckc=y,e.$ckc=y=r=Je([qe(3,N.$Mj)],y)}),define(Pe[270],Me([1,0,4,8,2]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class O{static{this.a=0}constructor(m,f){this.d=f,this.c=new Map,this.b=m.getProxy(S.$eM.MainThreadShare)}async $provideShare(m,f,k){return await this.c.get(m)?.provideShare({selection:F.Range.to(f.selection),resourceUri:M.URI.revive(f.resourceUri)},k)??void 0}registerShareProvider(m,f){const k=O.a++;return this.c.set(k,f),this.b.$registerShareProvider(k,F.DocumentSelector.from(m,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$dkc=O}),define(Pe[271],Me([1,0,7,4,168,6,8,16]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=e.$fkc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$dN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$dN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,w,d,s,a,r=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new O.$Sc,this.#e=l,this.#t=w,a&&s){this.c=(0,S.$RM)(s.identifier,a);const n=d.get(this.c);n&&(r=n.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=a,this.g=r,this.h=this.u(i)}u(l){if((0,m.$Xf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new O.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let w;this.m?w=this.m:w=(0,M.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,w,this.k,s,this.r?.internal,d,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$fkc=f;class k{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const w={message:l};return this.b.unshift(w),this.c(),new S.$gM(()=>{const d=this.b.indexOf(w);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(l,w){this.e=new Map,this.a=l.getProxy(F.$eM.MainThreadStatusBar),this.b=w,this.c=new k(this)}$acceptStaticEntries(l){for(const w of l)this.e.set(w.entryId,w)}createStatusBarEntry(l,w,d,s){return new f(this.a,this.b,this.e,l,w,d,s)}setStatusBarMessage(l,w){const d=this.c.setMessage(l);let s;return typeof w=="number"?s=setTimeout(()=>d.dispose(),w):typeof w<"u"&&w.then(()=>d.dispose(),()=>d.dispose()),new S.$gM(()=>{d.dispose(),clearTimeout(s)})}}e.$gkc=N}),define(Pe[113],Me([1,0,29,105,48,75,60,8,2]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=e.$KO=e.$JO=void 0;const k=(n,c,h,t)=>{let p=c;return{enumerable:!0,configurable:!1,get(){return p},set(u){if(!h(p,u)){const o=p;p=u,n.listener?.(t(u,o))}}}},N=(n,c)=>n===c,E={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(n,c)=>!(n.length!==c.length||n.some(h=>!c.find(t=>h.id===t.id)))},l=n=>c=>({op:4,update:n(c)}),w=(n,c)=>({range:(()=>{let h;const t=l(p=>({range:S.$$s.lift(m.Range.from(p))}));return{enumerable:!0,configurable:!1,get(){return h},set(p){n.listener?.({op:6}),E.range(h,p)||(h=p,n.listener?.(t(p)))}}})(),label:k(n,c,E.label,l(h=>({label:h}))),description:k(n,void 0,E.description,l(h=>({description:h}))),sortText:k(n,void 0,E.sortText,l(h=>({sortText:h}))),canResolveChildren:k(n,!1,E.canResolveChildren,h=>({op:2,state:h})),busy:k(n,!1,E.busy,l(h=>({busy:h}))),error:k(n,void 0,E.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:k(n,[],E.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),d=n=>{const c=M.$3K.fromString(n.extId),h=new a(c.controllerId,c.localId,n.label,f.URI.revive(n.uri)||void 0);return h.range=m.Range.to(n.range||void 0),h.description=n.description||void 0,h.sortText=n.sortText||void 0,h.tags=n.tags.map(t=>m.TestTag.to({id:(0,R.$9K)(t).tagId})),h},s=n=>{let c;for(const h of n.tests){const t=d(h.item);(0,F.$tO)(t).parent=c,c=t}return c};e.$JO=s;class a{constructor(c,h,t,p){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,F.$sO)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:p,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof r?void 0:u.parent}},children:{value:(0,O.$rO)(u,F.$tO,a),enumerable:!0,writable:!1},...w(u,t)})}}e.$KO=a;class r extends a{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$LO=r;class i extends O.$nO{constructor(c,h,t){super({controllerId:c,getDocumentVersion:p=>p&&t.getDocument(p)?.version,getApiFor:F.$tO,getChildren:p=>p.children,root:new r(c,h),toITestItem:m.TestItem.from})}}e.$MO=i}),define(Pe[31],Me([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,23,49,41,64,58,61,33]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=void 0;let u=class{#e;#t;#i;constructor(g,D,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(R.$eM.MainThreadCommands),this.d=D,this.#i=y,this.#t=g.getProxy(R.$eM.MainThreadTelemetry),this.converter=new o(this,P=>{const A=this.c.get(P);return A?.result===b.Void?A:void 0},D),this.f=[{processArgument(P){return(0,k.$Ph)(P)}},{processArgument(P){return(0,O.$On)(P,function(A){if(N.$$s.isIRange(A))return M.Range.to(A);if(E.$0s.isIPosition(A))return M.Position.to(A);if(N.$$s.isIRange(A.range)&&l.URI.isUri(A.uri))return M.location.to(A);if(A instanceof r.$te)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const D=this.registerCommand(!1,g.id,async(...y)=>{const P=g.args.map((G,W)=>{if(!G.validate(y[W]))throw new Error(`Invalid argument '${G.name}' when running '${g.id}', received: ${typeof y[W]=="object"?JSON.stringify(y[W],null,"	"):y[W]} `);return G.convert(y[W])}),A=await this.executeCommand(g.internalId,...P);return g.result.convert(A,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new F.$gM(()=>{D.dispose(),this.c.delete(g.id)})}registerCommand(g,D,y,P,A,G){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:y,thisArg:P,metadata:A,extension:G}),g&&this.#e.$registerCommand(D),new F.$gM(()=>{this.b.delete(D)&&g&&this.#e.$unregisterCommand(D)})}executeCommand(g,...D){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,D,!0)}async g(g,D,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,D,!1);{let P=!1;const A=(0,O.$On)(D,function(G){if(G instanceof F.$hM)return M.Position.from(G);if(G instanceof F.$iM)return M.Range.from(G);if(G instanceof F.$sM)return M.location.from(G);if(F.$HN.isNotebookRange(G))return M.NotebookRange.from(G);if(G instanceof ArrayBuffer)return P=!0,r.$te.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return P=!0,r.$te.wrap(G);if(G instanceof r.$te)return P=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(g,P?new i.$aw(A):A,y);return(0,k.$Ph)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(g,D,!1);throw G}}}async h(g,D,y){const P=this.b.get(g);if(!P)throw new Error("Unknown command");const{callback:A,thisArg:G,metadata:W}=P;if(W?.args)for(let C=0;C<W.args.length;C++)try{(0,S.$$f)(D[C],W.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${W.args[C].name}' - ${W.args[C].description}`)}const U=c.$2d.create();try{return await A.apply(G,D)}catch(C){if(g===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...D);T&&(g=T.command)}if(this.d.error(C,g,P.extension?.identifier),!y)throw C;if(P.extension?.identifier){const T=this.#i.onExtensionError(P.extension.identifier,C);this.d.trace("forwarded error to extension?",T,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$4i)(C)),this.id=g,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,g,U.elapsed())}}j(g,D,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new h.$2o(D),duration:y})}$executeContributedCommand(g,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(D=D.map(P=>this.f.reduce((A,G)=>G.processArgument(A,y.extension?.identifier),P)),this.h(g,D,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(D=>(g&&(D=D.filter(y=>y[0]!=="_")),D))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[D,y]of this.b){const{metadata:P}=y;P&&(g[D]=P)}return Promise.resolve(g)}};e.$SO=u,e.$SO=u=Je([qe(0,s.$xO),qe(1,f.$Mj),qe(2,t.$RO)],u),e.$TO=(0,d.$gi)("IExtHostCommands");class o{constructor(g,D,y){this.d=g,this.f=D,this.g=y,this.delegatingCommandId=`__vsc${(0,p.$Cg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,D){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const P=this.f(g.command);if(P)y.id=P.internalId,y.arguments=P.args.map((A,G)=>A.convert(g.arguments&&g.arguments[G]));else if((0,m.$Lb)(g.arguments)){const A=`${g.command} /${++this.c}`;this.b.set(A,g),D.add((0,w.$Rc)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),y.$ident=A,y.id=this.delegatingCommandId,y.arguments=[A],this.g.trace("CommandsConverter#CREATE",g.command,A)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const D=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$UO=o;class v{static{this.Uri=new v("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g)}static{this.Position=new v("position","A position in a text document",g=>F.$hM.isPosition(g),M.Position.from)}static{this.Range=new v("range","A range in a text document",g=>F.$iM.isRange(g),M.Range.from)}static{this.Selection=new v("selection","A selection in a text document",g=>F.$jM.isSelection(g),M.Selection.from)}static{this.Number=new v("number","",g=>typeof g=="number",g=>g)}static{this.String=new v("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=v.Arr(v.String)}static Arr(g){return new v(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,D=>Array.isArray(D)&&D.every(y=>g.validate(y)),D=>D.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",g=>g instanceof F.$DM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",g=>g instanceof F.$1N,M.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",g=>g instanceof a.$KO,M.TestItem.from)}constructor(g,D,y,P){this.name=g,this.description=D,this.validate=y,this.convert=P}optional(){return new v(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,D){return new v(g??this.name,D??this.description,this.validate,this.convert)}}e.$VO=v;class b{static{this.Void=new b("no result",g=>g)}constructor(g,D){this.description=g,this.convert=D}}e.$WO=b;class ${constructor(g,D,y,P,A){this.id=g,this.internalId=D,this.description=y,this.args=P,this.result=A}}e.$XO=$}),define(Pe[272],Me([1,0,18,12,2,87,97,35,31,8,7]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;const E=[new f.$XO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of DocumentHighlight-instances.",w(k.DocumentHighlight.to))),new f.$XO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$VO.Uri],new f.$WO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,a)=>{if((0,S.$Kb)(s))return;class r extends N.$yM{static to(n){const c=new r(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new N.$sM(a[0],k.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=k.Range.to(n.selectionRange),c.children=n.children?n.children.map(r.to):[],c}}return s.map(r.to)})),new f.$XO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$VO.Uri,new f.$VO("options","Formatting options",s=>!0,s=>s)],new f.$WO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new f.$XO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$VO.Uri,f.$VO.Range,new f.$VO("options","Formatting options",s=>!0,s=>s)],new f.$WO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new f.$XO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$VO.Uri,f.$VO.Position,new f.$VO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$VO("options","Formatting options",s=>!0,s=>s)],new f.$WO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new f.$XO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$XO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$XO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$XO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$XO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of Location-instances.",w(k.location.to))),new f.$XO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of Hover-instances.",w(k.Hover.to))),new f.$XO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$VO.Uri,new f.$VO("position","A position in a text document",s=>Array.isArray(s)&&s.every(a=>N.$hM.isPosition(a)),s=>s.map(k.Position.from))],new f.$WO("A promise that resolves to an array of ranges.",s=>s.map(a=>{let r;for(const i of a.reverse())r=new N.$CM(k.Range.to(i),r);return r}))),new f.$XO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$VO.String.with("query","Search string")],new f.$WO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new f.$XO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new f.$XO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$VO.CallHierarchyItem],new f.$WO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new f.$XO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$VO.CallHierarchyItem],new f.$WO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new f.$XO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new f.$XO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$VO.Uri,f.$VO.Position,f.$VO.String.with("newName","The new symbol name")],new f.$WO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new f.$XO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$VO.Uri,f.$VO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$WO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new f.$XO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$VO.Uri],new f.$WO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$yN(s.tokenTypes,s.tokenModifiers)})),new f.$XO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$VO.Uri],new f.$WO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$mab)(s);if(a.type==="full")return new N.$AN(a.data,void 0)})),new f.$XO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$VO.Uri,f.$VO.Range.optional()],new f.$WO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$yN(s.tokenTypes,s.tokenModifiers)})),new f.$XO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$VO.Uri,f.$VO.Range],new f.$WO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$mab)(s);if(a.type==="full")return new N.$AN(a.data,void 0)})),new f.$XO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$VO.Uri,f.$VO.Position,f.$VO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$VO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$WO("A promise that resolves to a CompletionList-instance.",(s,a,r)=>{if(!s)return new N.$OM([]);const i=s.suggestions.map(n=>k.CompletionItem.to(n,r));return new N.$OM(i,s.incomplete)})),new f.$XO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$VO.Uri,f.$VO.Position,f.$VO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$WO("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new f.$XO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$VO.Uri,f.$VO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$WO("A promise that resolves to an array of CodeLens-instances.",(s,a,r)=>w(i=>new N.$GM(k.Range.to(i.range),i.command&&r.fromInternal(i.command)))(s))),new f.$XO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$VO.Uri,new f.$VO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>N.$iM.isRange(s),s=>N.$jM.isSelection(s)?k.Selection.from(s):k.Range.from(s)),f.$VO.String.with("kind","Code action kind to return code actions for").optional(),f.$VO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$WO("A promise that resolves to an array of Command-instances.",(s,a,r)=>w(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(i.command)}else{const n=new N.$AM(i.title,i.kind?new N.$BM(i.kind):void 0);return i.edit&&(n.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(n.command=r.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(s))),new f.$XO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$VO.Uri],new f.$WO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(a=>new N.$UM(k.Range.to(a.range),k.Color.to(a.color))):[])),new f.$XO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$VO("color","The color to show and insert",s=>s instanceof N.$TM,k.Color.from),new f.$VO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new f.$WO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new f.$XO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$VO.Uri,f.$VO.Range],new f.$WO("A promise that resolves to an array of Inlay objects",(s,a,r)=>s.map(k.InlayHint.to.bind(void 0,r)))),new f.$XO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$VO.Uri],new f.$WO("A promise that resolves to an array of FoldingRange objects",(s,a)=>{if(s)return s.map(k.FoldingRange.to)})),new f.$XO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$WO("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(a=>k.NotebookExclusiveDocumentPattern.to(a))})))),new f.$XO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$VO.Uri,f.$VO.Range,new f.$VO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof N.$iM,s=>k.InlineValueContext.from(s))],new f.$WO("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new f.$XO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$VO("uriOrString","Uri-instance or string (only http/https)",s=>M.URI.isUri(s)||typeof s=="string"&&(0,F.$qg)(s,F.Schemas.http,F.Schemas.https),s=>s),new f.$VO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),f.$VO.String.with("label","").optional()],f.$WO.Void),new f.$XO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$VO.Uri.with("resource","Resource to open"),f.$VO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$VO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],f.$WO.Void),new f.$XO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$VO.Uri.with("left","Left-hand side resource of the diff editor"),f.$VO.Uri.with("right","Right-hand side resource of the diff editor"),f.$VO.String.with("title","Human readable title for the diff editor").optional(),new f.$VO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],f.$WO.Void),new f.$XO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$VO.String.with("title","Human readable title for the changes editor"),new f.$VO("resourceList","List of resources to compare",s=>{for(const a of s){if(a.length!==3)return!1;const[r,i,n]=a;if(!M.URI.isUri(r)||!M.URI.isUri(i)&&i!==void 0&&i!==null||!M.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],f.$WO.Void),new f.$XO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$VO.Uri,f.$VO.Position],new f.$WO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$XO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$VO.TypeHierarchyItem],new f.$WO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$XO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$VO.TypeHierarchyItem],new f.$WO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$XO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$VO.TestItem],f.$WO.Void),new f.$XO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$VO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$WO.Void),new f.$XO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$VO.String.with("name","The context key name"),new f.$VO("value","The context key value",()=>!0,s=>s)],f.$WO.Void),new f.$XO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$VO.Uri,f.$VO.StringArray,new f.$VO("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new f.$WO("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class l{static register(a){E.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",m.$fj)}}e.$zic=l;function w(s){return a=>{if(Array.isArray(a))return a.map(s)}}function d(s){if(!Array.isArray(s))return;const a=[];for(const r of s)O.$Yt(r)?a.push(k.DefinitionLink.to(r)):a.push(k.location.to(r));return a}}),define(Pe[273],Me([1,0,11,6,2,4,31,8,7]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;class k{static{this.a=0}constructor(w,d){this.extension=w,this.provider=d,this.handle=k.a++}}class N{constructor(w){this.session=w,this.responses=[]}}class E{static{this.a=0}constructor(w,d,s,a){this.f=s,this.g=a,this.b=new Map,this.d=new Map,this.e=w.getProxy(O.$eM.MainThreadInlineChat),d.registerApiCommand(new R.$XO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$VO("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?m.Range.from(r.initialRange):void 0,initialSelection:f.$jM.isSelection(r.initialSelection)?m.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?m.Position.from(r.position):void 0}})],R.$WO.Void))}registerProvider(w,d,s){const a=new k(w,d);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,s?.label??w.displayName??w.name,w.identifier.value,typeof d.handleInteractiveEditorResponseFeedback=="function",typeof d.provideFollowups=="function",s?.supportReportIssue??!1),(0,F.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(w,d,s,a){const r=this.b.get(w);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(d)),n=m.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:i,selection:n},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=E.a++;return this.d.set(h,new N(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,d,s,a){const r=this.b.get(w);if(!r)return;const i=this.d.get(d.id);if(!i)return;const n={prompt:s.prompt,selection:m.Selection.to(s.selection),wholeRange:m.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(M.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(m.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$HM.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(i.session,n,h,a));let p;try{p=await(0,S.$7g)(t,a)}finally{c=!0}if(!p)return;const u=i.responses.push(p)-1,o={wholeRange:m.Range.from(p.wholeRange),placeholder:p.placeholder};if(!E.h(p))return{...o,id:u,type:"editorEdit",message:m.MarkdownString.from(p.contents),edits:[]};const{edits:v,contents:b}=p,$=b!==void 0?m.MarkdownString.from(b):void 0;return v instanceof f.$qM?{...o,id:u,type:"bulkEdit",edits:m.WorkspaceEdit.from(v),message:$}:{...o,id:u,type:"editorEdit",edits:v.map(m.TextEdit.from),message:$}}async $provideFollowups(w,d,s,a){const r=this.b.get(w),i=this.d.get(d),n=i?.responses[s];if(r&&n&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(i.session,n,a));return(await(0,S.$7g)(c,a))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(w,d,s,a){const r=this.b.get(w),i=this.d.get(d),n=i?.responses[s];if(r&&n){const c=m.InteractiveEditorResponseFeedbackKind.to(a);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,c)}}$releaseSession(w,d){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$Jjc=E}),define(Pe[274],Me([1,0,2,31]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class M{constructor(R,m,f,k,N){this.a=m,this.b=f,this.c=k;const E=new F.$XO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$VO("showOptions","Show Options",l=>!0,l=>l),new F.$VO("resource","Interactive resource Uri",l=>!0,l=>l),new F.$VO("controllerId","Notebook controller Id",l=>!0,l=>l),new F.$VO("title","Interactive editor title",l=>!0,l=>l)],new F.$WO("Notebook and input URI",l=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this.a.getEditorById(l.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(R,m,f,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Wjc=M}),define(Pe[275],Me([1,0,18,11,25,5,6,28,2,20,13,4,31,8,7,76,214,22,49,215]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=void 0,e.$6jc=v;let c=class{constructor($,I,g,D,y){this.m=I,this.n=g,this.o=D,this.q=y,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$6d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(E.$eM.MainThreadNotebookKernels);const P=new l.$XO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$VO("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const W=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:W}}else if(G&&"notebookEditor"in G){const W=this.n.getIdByEditor(G.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return G})],l.$WO.Void),A=new l.$XO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$VO.Uri],new l.$WO("A promise that resolves to an array of variables",(G,W)=>G.map(U=>({name:U.name,value:U.value,type:U.type,editable:!1}))));this.o.registerApiCommand(P),this.o.registerApiCommand(A)}createNotebookController($,I,g,D,y,P){for(const $e of this.j.values())if($e.controller.id===I&&k.$Bm.equals($.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const A=this.k++,G=this;this.q.trace(`NotebookController[${A}], CREATED by ${$.identifier.value}, ${I}`);const W=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${$.identifier}'`);let U=!1;const C=new O.$6d,T=new O.$6d,q={id:v($.identifier,I),notebookType:g,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:D||$.identifier.value,preloads:P?P.map(w.NotebookRendererScript.from):[]};let ne=y??W,ce,ye;this.a.$addKernel(A,q).catch($e=>{console.log($e),U=!0});let Ie=0;const ue=()=>{if(U)return;const $e=++Ie;Promise.resolve().then(()=>{$e===Ie&&this.a.$updateKernel(A,q)})},ve=new m.$Ac,re={get id(){return I},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return q.label},set label($e){q.label=$e??$.displayName??$.name,ue()},get detail(){return q.detail??""},set detail($e){q.detail=$e,ue()},get description(){return q.description??""},set description($e){q.description=$e,ue()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages($e){q.supportedLanguages=$e,ue()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder($e){q.supportsExecutionOrder=$e,ue()},get rendererScripts(){return q.preloads?q.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ne},set executeHandler($e){ne=$e??W},get interruptHandler(){return ce},set interruptHandler($e){ce=$e,q.supportsInterrupt=!!$e,ue()},set variableProvider($e){(0,r.$4F)($,"notebookVariableProvider"),ye=$e,q.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ie=>G.a.$variablesUpdated(ie.uri)),ue()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw G.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,v($.identifier,this.id))},createNotebookExecution($e){if((0,r.$4F)($,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw G.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,v($.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${A}], DISPOSED`),U=!0,this.j.delete(A),C.dispose(),T.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity($e,ie){ie===d.NotebookControllerAffinity2.Hidden&&(0,r.$4F)($,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(A,$e.uri,ie)},onDidReceiveMessage:T.event,postMessage($e,ie){return(0,r.$4F)($,"notebookMessaging"),G.a.$postMessage(A,ie&&G.n.getIdByEditor(ie),$e)},asWebviewUri($e){return(0,r.$4F)($,"notebookMessaging"),(0,s.$Yxb)($e,G.m.remote)}};return this.j.set(A,{extensionId:$.identifier,controller:re,onDidReceiveMessage:T,onDidChangeSelection:C,associatedNotebooks:ve}),re}getIdByController($){for(const[I,g]of this.j)if(g.controller===$)return v(g.extensionId,$.id);return null}createNotebookControllerDetectionTask($,I){const g=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(g,I);const y={dispose:()=>{this.f.delete(g),D.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider($,I,g){const D=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,P=this;this.h.set(D,g),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,I);let A;return y!==void 0&&(A=g.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(D),P.a.$removeKernelSourceActionProvider(D,D),A?.dispose()}}}async $provideKernelSourceActions($,I){const g=this.h.get($);if(g){const D=new R.$Sc;return(await g.provideNotebookKernelSourceActions(I)??[]).map(P=>w.NotebookKernelSourceAction.from(P,this.o.converter,D))}return[]}$acceptNotebookAssociation($,I,g){const D=this.j.get($);if(D){const y=this.n.getNotebookDocument(f.URI.revive(I));g?D.associatedNotebooks.set(y.uri,!0):D.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,y.uri.toString(),g),D.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells($,I,g){const D=this.j.get($);if(!D)return;const y=this.n.getNotebookDocument(f.URI.revive(I)),P=[];for(const A of g){const G=y.getCell(A);G&&P.push(G.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,y.uri.toString(),P.length),await D.controller.executeHandler.call(D.controller,P,y.apiNotebook,D.controller)}catch(A){this.q.error(`NotebookController[${$}] execute cells FAILED`,A),console.error(A)}}async $cancelCells($,I,g){const D=this.j.get($);if(!D)return;const y=this.n.getNotebookDocument(f.URI.revive(I));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,y.apiNotebook);else for(const P of g){const A=y.getCell(P);A&&this.b.get(A.uri)?.cancel()}if(D.controller.interruptHandler){const P=this.c.get(y.uri);g.length&&Array.isArray(P)&&P.length&&P.forEach(A=>A.dispose())}}async $provideVariables($,I,g,D,y,P,A){const G=this.j.get($);if(!G)return;const W=this.n.getNotebookDocument(f.URI.revive(g)),U=G.controller.variableProvider;if(!U)return;let C;if(D!==void 0){if(C=this.s[D],!C)return}else this.s={};const T=y==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,q=U.provideVariables(W.apiNotebook,C,T,P,A);let ne=0;for await(const ce of q){if(A.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(I,ye),ne++>=n.$ehb)return}}$acceptKernelMessageFromRenderer($,I,g){const D=this.j.get($);if(!D)return;const y=this.n.getEditorById(I);D.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged($,I,g){const y=this.n.getNotebookDocument(f.URI.revive($)).getCell(I);if(y){const P=g?w.NotebookCellExecutionState.to(g):d.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution($,I){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const y=new t(I,D,this.a);this.b.set(D.uri,y);const P=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),P.dispose(),this.b.delete(D.uri))});return y.asApiObject()}_createNotebookExecution($,I){const g=this.n.getNotebookDocument($.uri),D=$.getCells().find(A=>{const G=g.getCellFromApiCell(A);return G&&this.b.has(G.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new u(I,g,this.a),P=y.onDidChangeState(()=>{y.state===p.Resolved&&(y.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,P]),y.asApiObject()}};e.$5jc=c,e.$5jc=c=Je([qe(4,N.$Mj)],c);var h;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(h||(h={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,g){super(),this.m=I,this.n=g,this.b=t.a++,this.c=new O.$6d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new M.$de),this.h=new o(10,D=>this.s(D)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const I=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$aw(I))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let I=this.m;if($&&(I=this.m.notebook.getCellFromApiCell($)),!I)throw new Error("INVALID cell");return I.handle}y($){return $.map(I=>{const g=d.$LN.ensureUniqueMimeTypes(I.items,!0);return g===I.items?w.NotebookCellOutput.from(I):w.NotebookCellOutput.from({items:g,id:I.id,metadata:I.metadata})})}async z($,I,g){const D=this.w(I),y=this.y((0,S.$3b)($));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:D,append:g,outputs:y})}async C($,I,g){return $=d.$LN.ensureUniqueMimeTypes((0,S.$3b)($),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:$.map(w.NotebookCellOutputItem.from),outputId:I.id,append:g})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(g){$.j=g,$.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(g){if($.f===h.Resolved||$.f===h.Started)throw new Error("Cannot call start again");$.f=h.Started,$.c.fire(),$.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,D){if($.f===h.Resolved)throw new Error("Cannot call resolve twice");$.f=h.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$aw({runEndTime:D,lastRunSuccess:g}))},clearOutput(g){return $.t(),$.z([],g,!1)},appendOutput(g,D){return $.t(),$.z(g,D,!0)},replaceOutput(g,D){return $.t(),$.z(g,D,!1)},appendOutputItems(g,D){return $.t(),$.C(g,D,!0)},replaceOutputItems(g,D){return $.t(),$.C(g,D,!1)}})}}var p;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(p||(p={}));class u extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,g){super(),this.h=I,this.j=g,this.b=u.a++,this.c=new O.$6d,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new M.$de),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===p.Resolved||this.f===p.Started)throw new Error("Cannot call start again");this.f=p.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===p.Resolved)throw new Error("Cannot call resolve twice");this.f=p.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor($,I){this.f=$,this.g=I,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new F.$Dh,this.b=Date.now(),(0,F.$hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>$.complete())}}function v(b,$){return`${b.value}/${$}`}}),define(Pe[66],Me([1,0,5,4,3,2,17,6,7,170,14,198,25,33,199,40,11,8,31]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=e.$fjc=e.$ejc=void 0,e.$ejc=(0,M.$gi)("IExtHostTerminalService");class n{constructor(g,D,y,P){this.l=g,this._id=D,this.m=y,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const A=this;this.value={get name(){return A.n||""},get processId(){return A.b},get creationOptions(){return A.m},get exitStatus(){return A.h},get state(){return A.j},get selection(){return A.k},sendText(G,W=!0){A.q(),A.l.$sendText(A._id,G,W)},show(G){A.q(),A.l.$show(A._id,G)},hide(){A.q(),A.l.$hide(A._id)},dispose(){A.a||(A.a=!0,A.l.$dispose(A._id))},get dimensions(){if(!(A.d===void 0||A.g===void 0))return{columns:A.d,rows:A.g}}}}async create(g,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??D?.cwd??void 0,env:g.env??void 0,icon:v(g.iconPath)??void 0,color:s.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.o(g.location,D?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,D,y,P,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:s.ThemeColor.isThemeColor(A)?A.id:void 0,location:D?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,D){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in g?{viewColumn:r.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,D){this.h=Object.freeze({code:g,reason:D})}setDimensions(g,D){return g===this.d&&D===this.g||g===0||D===0?!1:(this.d=g,this.g=D,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(D=>{D!==g&&(this.b=Promise.resolve(g))})}}e.$fjc=n;class c{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new S.$6d,this.onProcessData=this.a.event,this.b=new S.$6d,this.d=new S.$6d,this.onDidChangeProperty=this.d.event,this.f=new S.$6d,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,D){this.g.setDimensions?.({columns:g,rows:D})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,D,y){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$6d,this.onDidCloseTerminal=this.H.event,this.I=new S.$6d,this.onDidOpenTerminal=this.I.event,this.J=new S.$6d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$6d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$6d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$6d,this.onDidChangeShell=this.N.event,this.O=new S.$6d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$6d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(F.$eM.MainThreadTerminalService),this.y=new d.$4tb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const A=G=>{const W=G;return this.W(W.instanceId)?.value};switch(P?.$mid){case 15:return A(P);default:{if(Array.isArray(P))for(let G=0;G<P.length&&P[G].$mid===15;G++)P[G]=A(P[G]);return P}}}}),this.B({dispose:()=>{for(const[P,A]of this.g)A.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,D){const y=new n(this.a,(0,w.$Cg)(),g,g.name),P=new c(g.pty);return y.createExtensionTerminal(g.location,D,this.R(g,D).resolvedExtHostIdentifier,v(g.iconPath),b(g.color)).then(A=>{const G=this.S(A,P);this.h[A]=G}),this.f.push(y),y.value}R(g,D){if(D=D||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const P=this.f.find(A=>A.value===y);P&&(D.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?D.location=g.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(g,D){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new c(D),A=this.S(g,P);this.h[g]=A}async $acceptActiveTerminalChanged(g){const D=this.b;if(g===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,D){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:D})}async $acceptTerminalDimensions(g,D,y){const P=this.W(g);P&&P.setDimensions(D,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,D){const y=this.W(g);y&&this.P.fire({terminal:y.value,...D})}async $acceptTerminalMaximumDimensions(g,D,y){this.g.get(g)?.resize(D,y)}async $acceptTerminalTitleChange(g,D){const y=this.W(g);y&&(y.name=D)}async $acceptTerminalClosed(g,D,y){const P=this.Y(this.f,g);if(P!==null){const A=this.f.splice(P,1)[0];A.setExitStatus(D,y),this.H.fire(A.value)}}$acceptTerminalOpened(g,D,y,P){if(D){const W=this.Y(this.f,D);if(W!==null){this.f[W]._id=g,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const A={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:O.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},G=new n(this.a,g,A,y);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,D){this.W(g)?._setProcessId(D)}async $startExtensionTerminal(g,D){const y=this.W(g);if(!y)return{message:(0,k.localize)(0,null,g)};y.isOpen||await new Promise(A=>{const G=this.onDidOpenTerminal(async W=>{W===y.value&&(G.dispose(),A())})});const P=this.g.get(g);P?P.startSendingEvents(D):this.j[g]={initialDimensions:D}}S(g,D){const y=new m.$Sc;y.add(D.onProcessReady(A=>this.a.$sendProcessReady(g,A.pid,A.cwd,A.windowsPty))),y.add(D.onDidChangeProperty(A=>this.a.$sendProcessProperty(g,A))),this.y.startBuffering(g,D.onProcessData),y.add(D.onProcessExit(A=>this.U(g,A))),this.g.set(g,D);const P=this.j[g];return P&&D instanceof c&&(D.startSendingEvents(P.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,D){this.g.get(g)?.acknowledgeDataEvent(D)}$acceptProcessInput(g,D){this.g.get(g)?.input(D)}$acceptTerminalInteraction(g){const D=this.W(g);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(g,D){this.W(g)?.setSelection(D)}$acceptProcessResize(g,D,y){try{this.g.get(g)?.resize(D,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,D){this.g.get(g)?.shutdown(D)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(D=>this.a.$sendProcessProperty(g,{type:"cwd",value:D}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new f.$gM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,D,y){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,y),this.a.$registerProfileProvider(D,g.identifier.value),new f.$gM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(g,D,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,D),new f.$gM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,D){const y=new l.$de().token;if(y.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const A=await P.provideTerminalQuickFixes(D,y);if(A===null||Array.isArray(A)&&A.length===0)return;const G=new m.$Sc;if(this.w.value=G,!Array.isArray(A))return A?r.TerminalQuickFix.from(A,this.Q.converter,G):void 0;const W=[];for(const U of A){const C=r.TerminalQuickFix.from(U,this.Q.converter,G);C&&W.push(C)}return W}async $createContributedProfileTerminal(g,D){const y=new l.$de().token;let P=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,D);return}this.createTerminalFromOptions(P.options,D)}}async $provideLinks(g,D){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const A=new l.$de;this.G.set(g,A);const G=[],W={terminal:y.value,line:D},U=[];for(const q of this.z)U.push(a.Promises.withAsyncBody(async ne=>{A.token.onCancellationRequested(()=>ne({provider:q,links:[]}));const ce=await q.provideTerminalLinks(W,A.token)||[];A.token.isCancellationRequested||ne({provider:q,links:ce})}));const C=await Promise.all(U);if(A.token.isCancellationRequested)return[];const T=new Map;for(const q of C)q&&q.links.length>0&&G.push(...q.links.map(ne=>{const ce={id:h++,startIndex:ne.startIndex,length:ne.length,label:ne.tooltip};return T.set(ce.id,{provider:q.provider,link:ne}),ce}));return this.F.set(g,T),G}$activateLink(g,D){const y=this.F.get(g)?.get(D);y&&y.provider.handleTerminalLink(y.link)}U(g,D){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,D)}W(g){return this.X(this.f,g)}X(g,D){const y=this.Y(g,D);return y!==null?g[y]:null}Y(g,D){const y=g.findIndex(P=>P._id===D);return y===-1?null:y}getEnvironmentVariableCollection(g){let D=this.n.get(g.identifier.value);return D||(D=new p,this.$(g.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Z(g,D){const y=(0,E.$3r)(D.map),P=(0,E.$4r)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(g,D.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(g){g.forEach(D=>{const y=D[0],P=new p(D[1]);this.$(y,P)})}$acceptDefaultProfile(g,D){const y=this.s;this.s=g,this.u=D,y?.path!==g.path&&this.N.fire(g.path)}$(g,D){this.n.set(g,D),D.onDidChangeCollection(()=>{this.Z(g,D)})}};e.$gjc=t,e.$gjc=t=Je([qe(1,i.$TO),qe(2,R.$xO)],t);class p{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$6d,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const D=this.h(g);let y=this.a.get(D);return y||(y=new u(this,g),this.a.set(D,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,D,y,P){this.f(g,{value:D,type:f.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(g,D,y,P){this.f(g,{value:D,type:f.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(g,D,y,P){this.f(g,{value:D,type:f.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(g,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,D.scope),P=this.map.get(y),A=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==D.value||P.type!==D.type||P.options?.applyAtProcessCreation!==A.applyAtProcessCreation||P.options?.applyAtShellIntegration!==A.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const G=this.g(g,D.scope),W={variable:g,...D,options:A};this.map.set(G,W),this.d.fire()}}get(g,D){const y=this.g(g,D),P=this.map.get(y);return P?$(P):void 0}g(g,D){const y=this.h(D);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const D=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(g)&&D.set(P.variable,$(P));return D}delete(g,D){const y=this.g(g,D);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[D,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(D);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,D){const y=this.h(D),P=this.descriptionMap.get(y);if(!P||P.description!==g){let A;typeof g=="string"?A=g:A=g?.value.split(`

`)[0];const G={description:A,scope:D};this.descriptionMap.set(y,G),this.d.fire()}}getDescription(g){const D=this.h(g);return this.descriptionMap.get(D)?.description}k(g){const D=this.h(g);this.descriptionMap.delete(D)}}class u{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,D){this.b=g,this.d=D,this.a=new S.$6d}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,D,y){this.b.replace(g,D,y,this.d)}append(g,D,y){this.b.append(g,D,y,this.d)}prepend(g,D,y){this.b.prepend(g,D,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,D){this.b.getVariableMap(this.d).forEach((y,P)=>g.call(D,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(g,D){super(!1,g,D)}createTerminal(g,D,y){throw new N.$_}createTerminalFromOptions(g,D){throw new N.$_}};e.$hjc=o,e.$hjc=o=Je([qe(0,i.$TO),qe(1,R.$xO)],o);function v(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function $(I){const g={...I};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Pe[276],Me([1,0,11,23,25,5,248,99,6,26,16,33,13,4,17,113,8,7,48,75,60,22]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=e.$mkc=e.$lkc=e.$kkc=void 0;let t=class extends f.$Tc{constructor(U,C,T,q){super(),this.w=q,this.f=this.B(new O.$6d),this.g=new Map,this.s=this.B(new O.$6d),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(w.$eM.MainThreadTesting),this.m=new y(this.h),this.j=new v(this.h,C),T.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case 16:{const ce=ne,ye=ce.tests[ce.tests.length-1].item.extId;return this.g.get(i.$3K.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$JO)(ne)}case 18:{const{test:ce,message:ye}=ne,Ie=ce.item.extId;return{test:this.g.get(i.$3K.root(Ie))?.collection.tree.get(Ie)?.actual??(0,s.$JO)({$mid:16,tests:[ce]}),message:a.TestMessage.to(ye)}}default:return ne}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await T.executeCommand("_testing.getExplorerSelection"),ce=ye=>{const Ie=this.g.get(i.$3K.root(ye));if(Ie)return i.$3K.isRoot(ye)?Ie.controller:Ie.collection.tree.get(ye)?.actual};return{include:ne?.include.map(ce).filter(N.$2f)||[],exclude:ne?.exclude.map(ce).filter(N.$2f)||[]}})}createTestController(U,C,T,q){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const ne=new f.$Sc,ce=ne.add(new s.$MO(C,T,this.w));ce.root.label=T;const ye=new Map,Ie=new Set,ue=this.h,ve={items:ce.root.children,get label(){return T},set label($e){T=$e,ce.root.label=$e,ue.$updateController(C,{label:T})},get refreshHandler(){return q},set refreshHandler($e){q=$e,ue.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ie,le,V,ee,ke)=>{let Ne=(0,m.$7i)($e);for(;ye.has(Ne);)Ne++;return new A(this.h,ye,Ie,this.s.event,C,Ne,$e,ie,le,V,ee,ke)},createTestItem($e,ie,le){return new s.$KO(C,$e,ie,le)},createTestRun:($e,ie,le=!0)=>this.j.createTestRun(U,C,ce,$e,ie,le),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ie=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ie.map(le=>i.$3K.fromExtHostTestItem(le,C).toString()))}},set resolveHandler($e){ce.resolveHandler=$e},get resolveHandler(){return ce.resolveHandler},dispose:()=>{ne.dispose()}};ue.$registerTestController(C,T,!!q),ne.add((0,f.$Rc)(()=>ue.$unregisterTestController(C)));const re={controller:ve,collection:ce,profiles:ye,extension:U,activeProfiles:Ie};return this.g.set(C,re),ne.add((0,f.$Rc)(()=>this.g.delete(C))),ne.add(ce.onDidGenerateDiff($e=>ue.$publishDiff(C,$e.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=M.CancellationToken.None){const T=b(U);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(T.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ne=>i.$3K.fromExtHostTestItem(ne,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:G[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:U.exclude?.map(ne=>ne.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,T){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(T)??[]}async $resolveFileCoverage(U,C,T,q){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(T,q)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[T,q]of Object.entries(U)){const ne=this.g.get(T);if(!ne)continue;const ce=new Map,ye=q.filter(ue=>!ne.activeProfiles.has(ue)),Ie=[...ne.activeProfiles].filter(ue=>!q.includes(ue));for(const ue of ye)ce.set(ue,!0),ne.activeProfiles.add(ue);for(const ue of Ie)ce.set(ue,!1),ne.activeProfiles.delete(ue);ce.size&&C.set(T,ce)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,k.$Nn)(a.TestResults.to(C))).concat(this.results).sort((C,T)=>T.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const T=this.g.get(i.$3K.fromString(U).controllerId)?.collection;T&&(await T.expand(U,C<0?1/0:C),T.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>c.TestsDiffOp.deserialize({asCanonicalUri:T=>T},C)))}async $runControllerTests(U,C){return Promise.all(U.map(T=>this.y(T,!1,C)))}async $startContinuousRun(U,C){const T=new M.$de(C),q=await Promise.all(U.map(ne=>this.y(ne,!0,T.token)));return!C.isCancellationRequested&&!q.some(ne=>ne.error)&&await new Promise(ne=>C.onCancellationRequested(ne)),T.dispose(!0),q}async y(U,C,T){const q=this.g.get(U.controllerId);if(!q)return{};const{collection:ne,profiles:ce,extension:ye}=q,Ie=ce.get(U.profileId);if(!Ie)return{};const ue=U.testIds.map(ie=>ne.tree.get(ie)).filter(N.$2f),ve=U.excludeExtIds.map(ie=>q.collection.tree.get(ie)).filter(N.$2f).filter(ie=>ue.some(le=>le.fullId.compare(ie.fullId)===2));if(!ue.length)return{};const re=new r.$SN(ue.some(ie=>ie.actual instanceof s.$LO)?void 0:ue.map(ie=>ie.actual),ve.map(ie=>ie.actual),Ie,C),$e=(0,c.$6K)(U)&&this.j.prepareForMainThreadTestRun(re,$.fromInternal(U,q.collection),ye,T);try{return await Ie.runHandler(re,T),{}}catch(ie){return{error:String(ie)}}finally{$e&&($e.hasRunningTasks&&!T.isCancellationRequested&&await O.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$kkc=t,e.$kkc=t=Je([qe(0,d.$xO),qe(1,l.$Mj)],t);const p=1e4;var u;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(u||(u={}));class o extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,T,q,ne){super(),this.s=U,this.w=C,this.y=T,this.z=q,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new O.$6d),this.m=this.B(new O.$6d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new M.$de(ne));const ce=this.B(new S.$sh(()=>this.C(),p));this.B(this.h.token.onCancellationRequested(()=>ce.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,T=this.s.controllerId,q=(0,E.$Cg)(),ne=this.y,ce=this.m;let ye;const Ie=$e=>(ie,...le)=>{if(ve){this.z.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.F(ie),$e(ie,...le))},ue=($e,ie)=>{const le=ie instanceof Array?ie.map(a.TestMessage.from):[a.TestMessage.from(ie)];if($e.uri&&$e.range){const V={range:a.Range.from($e.range),uri:$e.uri};for(const ee of le)ee.location=ee.location||V}this.w.$appendTestMessagesInRun(C,q,i.$3K.fromExtHostTestItem($e,T).toString(),le)};let ve=!1;const re={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,h.$4F)(ne,"testCoverage"),ye=$e&&new I($e),ce.fire({taskId:q,runId:C,coverage:ye})},enqueued:Ie($e=>{this.w.$updateTestStateInRun(C,q,i.$3K.fromExtHostTestItem($e,T).toString(),1)}),skipped:Ie($e=>{this.w.$updateTestStateInRun(C,q,i.$3K.fromExtHostTestItem($e,T).toString(),5)}),started:Ie($e=>{this.w.$updateTestStateInRun(C,q,i.$3K.fromExtHostTestItem($e,T).toString(),2)}),errored:Ie(($e,ie,le)=>{ue($e,ie),this.w.$updateTestStateInRun(C,q,i.$3K.fromExtHostTestItem($e,T).toString(),6,le)}),failed:Ie(($e,ie,le)=>{ue($e,ie),this.w.$updateTestStateInRun(C,q,i.$3K.fromExtHostTestItem($e,T).toString(),4,le)}),passed:Ie(($e,ie)=>{this.w.$updateTestStateInRun(C,q,i.$3K.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ie)}),appendOutput:($e,ie,le)=>{ve||(le&&(this.s.isIncluded(le)?this.F(le):le=void 0),this.w.$appendOutputToRun(C,q,F.$te.fromString($e),ie&&a.location.from(ie),le&&i.$3K.fromExtHostTestItem(le,T).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,q),this.f.delete(q),this.f.size||this.D())}};return this.f.set(q,{run:re}),this.w.$startedTestRunTask(C,{id:q,name:U,running:!0}),re}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$KO))throw new n.$pO(U.id);if(this.g.has(i.$3K.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],T=this.s.colllection.root;for(;;){const q=a.TestItem.from(U);if(C.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),U===T))break;U=U.parent||T}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(T=>T.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,T,q){return this.j(U,C,T,q)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,T,q,ne,ce){const ye=this.c.get(q);if(ye)return ye.createRun(ne);const Ie=$.fromPublic(C,T,q,ce),ue=b(q);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!q.continuous,profile:ue&&{group:G[ue.kind],id:ue.profileId},exclude:q.exclude?.map(re=>i.$3K.fromExtHostTestItem(re,T.root.id).toString())??[],id:Ie.id,include:q.include?.map(re=>i.$3K.fromExtHostTestItem(re,T.root.id).toString())??[T.root.id],persist:ce});const ve=this.j(q,Ie,U);return O.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(Ie.id),ve.dispose()}),ve.createRun(ne)}j(U,C,T,q){const ne=new o(C,this.g,T,this.h,q);this.c.set(U,ne);let ce;const ye=ne.onDidCoverage(({runId:Ie,taskId:ue,coverage:ve})=>{ce||(ce={runId:Ie,coverage:new Map},this.f.unshift(ce),this.f.length>c.$$K&&this.f.pop()),ce.coverage.set(ue,ve),this.g.$signalCoverageAvailable(Ie,ue,!!ve)});return O.Event.once(ne.onEnd)(()=>{this.c.delete(U),ye.dispose()}),ne}}e.$lkc=v;const b=W=>{if(W.profile){if(!(W.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class ${static fromPublic(U,C,T,q){return new $(U,(0,E.$Cg)(),T.include?.map(ne=>i.$3K.fromExtHostTestItem(ne,U).toString())??[U],T.exclude?.map(ne=>i.$3K.fromExtHostTestItem(ne,U).toString())??[],q,C)}static fromInternal(U,C){return new $(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,T,q,ne,ce){this.controllerId=U,this.id=C,this.isPersisted=ne,this.colllection=ce,this.c=T.map(ye=>ye+"\0"),this.f=q.map(ye=>ye+"\0")}isIncluded(U){const C=i.$3K.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const T of this.f)if(C===T||C.startsWith(T))return!1;for(const T of this.c)if(C===T||C.startsWith(T))return!0;return!1}}e.$mkc=$;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const T=await this.c;let q=T?.[U];return!this.provider||!T||!q?[]:(q.detailedCoverage||(q=T[U]=await this.provider.resolveFileCoverage?.(q,C)??q),q.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$3K.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:T}=this;return{get added(){return[...U].map(q=>q.revived)},get updated(){return[...C].map(q=>q.revived)},get removed(){return[...T].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class D extends c.$_K{constructor(){super(...arguments),this.s=new O.$6d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:a.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new g(this.s)}}class y{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new D({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const P=(W,U,C,T)=>{C?Object.assign(C,T):U.$updateTestRunConfig(W.controllerId,W.profileId,T)};class A{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,P(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,P(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,P(this,this.#e,this.#n,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,P(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return O.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(N.$2f))}constructor(U,C,T,q,ne,ce,ye,Ie,ue,ve=!1,re=void 0,$e=!1){this.controllerId=ne,this.profileId=ce,this.f=ye,this.kind=Ie,this.runHandler=ue,this._tag=re,this.g=$e,this.#e=U,this.#s=C,this.#t=T,this.#i=q,C.set(ce,this);const ie=G[Ie];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${Ie}`);ve&&T.add(ce),this.#n={profileId:ce,controllerId:ne,tag:re?a.TestTag.namespace(this.controllerId,re.id):null,label:ye,group:ie,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$nkc=A;const G={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Pe[114],Me([1,0,55,14,90,8,7]),function(me,e,S,F,M,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=void 0;class m{static{this.c=new M.$CO("TextEditorDecorationType")}constructor(l,w,d){const s=m.c.nextId();l.$registerTextEditorDecorationType(w.identifier,s,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$EO=m;class f{constructor(l,w){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,w){this.k();let d=null;if(l instanceof R.$hM)d=new R.$iM(l,l);else if(l instanceof R.$iM)d=l;else throw new Error("Unrecognized location");this.l(d,w,!1)}insert(l,w){this.k(),this.l(new R.$iM(l,l),w,!0)}delete(l){this.k();let w=null;if(l instanceof R.$iM)w=l;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(l,w,d){const s=this.c.validateRange(l);this.g.push({range:s,text:w,forceMoveMarkers:d})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=l}}class k{constructor(l,w,d,s){this.c=l,this.d=w,this._accept(d),this.e=s;const a=this;this.value={get tabSize(){return a.f},set tabSize(r){a.n(r)},get indentSize(){return a.g},set indentSize(r){a.p(r)},get insertSpaces(){return a.j},set insertSpaces(r){a.s(r)},get cursorStyle(){return a.k},set cursorStyle(r){a.t(r)},get lineNumbers(){return a.l},set lineNumbers(r){a.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}n(l){const w=this.m(l);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}p(l){const w=this.o(l);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const w=this.q(l);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let d=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(d=!0,w.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,d=!0,w.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(d=!0,w.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,d=!0,w.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(d=!0,w.insertSpaces=s):this.j!==s&&(this.j=s,d=!0,w.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,d=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,d=!0,w.lineNumbers=O.TextEditorLineNumbersStyle.from(l.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(l,w){w.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(d)})}}e.$FO=k;class N{constructor(l,w,d,s,a,r,i,n){this.id=l,this.j=w,this.k=d,this.g=!1,this.h=new Set,this.c=a,this.d=new k(this.j,this.id,r,d),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new F.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$jM))throw(0,F.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof R.$jM)))throw(0,F.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new F.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new F.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new f(s.value,t);return h(p),c.m(p)},insertSnippet(h,t,p={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=c.c.map(o=>O.Range.from(o));else if(t instanceof R.$hM){const{lineNumber:o,column:v}=O.Position.from(t);u=[{startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v}]}else if(t instanceof R.$iM)u=[O.Range.from(t)];else{u=[];for(const o of t)if(o instanceof R.$iM)u.push(O.Range.from(o));else{const{lineNumber:v,column:b}=O.Position.from(o);u.push({startLineNumber:v,startColumn:b,endLineNumber:v,endColumn:b})}}return w.$tryInsertSnippet(l,s.value.version,h.value,u,p)},setDecorations(h,t){const p=t.length===0;p&&!c.h.has(h.key)||(p?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$uO(t))return w.$trySetDecorations(l,h.key,O.$vO(t));{const u=new Array(4*t.length);for(let o=0,v=t.length;o<v;o++){const b=t[o];u[4*o]=b.start.line+1,u[4*o+1]=b.start.character+1,u[4*o+2]=b.end.line+1,u[4*o+3]=b.end.character+1}return w.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,t){c.n(()=>w.$tryRevealRange(l,O.Range.from(h),t||R.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(l,O.ViewColumn.from(h))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const d=w.edits.map(a=>a.range);d.sort((a,r)=>a.end.line===r.end.line?a.end.character===r.end.character?a.start.line===r.start.line?a.start.character-r.start.character:a.start.line-r.start.line:a.end.character-r.end.character:a.end.line-r.end.line);for(let a=0,r=d.length-1;a<r;a++){const i=d[a].end;if(d[a+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=w.edits.map(a=>({range:O.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,s,{setEndOfLine:typeof w.setEndOfLine=="number"?O.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$GO=N}),define(Pe[67],Me([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,51,39]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new F.$6d,this.e=new F.$6d,this.f=new F.$6d,this.g=new F.$6d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],p=[];if(c.removedDocuments)for(const u of c.removedDocuments){const o=O.URI.revive(u),v=this.c.get(o);v?.unref()&&(this.c.delete(o),h.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const o=O.URI.revive(u.uri);let v=this.c.get(o);if(v&&o.scheme!==d.Schemas.vscodeNotebookCell&&o.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);v||(v=new r(new f.$AO(this.h.getProxy(m.$eM.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this.c.set(o,v),t.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const o=this.b.get(u);this.b.delete(u),o&&p.push(o)}if(c.addedEditors)for(const u of c.addedEditors){const o=O.URI.revive(u.documentUri);S.ok(this.c.has(o),`document '${o}' does not exist`),S.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(o).value,b=new N.$GO(u.id,this.h.getProxy(m.$eM.MainThreadTextEditors),this.i,new a.$V(()=>v.document),u.selections.map(E.Selection.to),u.options,u.visibleRanges.map($=>E.Range.to($)),typeof u.editorPosition=="number"?E.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,b)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Oc)(h),(0,M.$Oc)(p),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$HO=i,e.$HO=i=Je([qe(0,k.$xO),qe(1,l.$Mj)],i),e.$IO=(0,R.$gi)("IExtHostDocumentsAndEditors")}),define(Pe[277],Me([1,0,18,5,4,114,8,7]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class f{constructor(N,E){this.i=E,this.a=new F.$6d,this.b=new F.$6d,this.c=new F.$6d,this.d=new F.$6d,this.f=new F.$6d,this.g=new F.$6d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(M.$eM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const E=this.i.allEditors();return N?E:E.map(l=>l.value)}async showTextDocument(N,E,l){let w;typeof E=="number"?w={position:R.ViewColumn.from(E),preserveFocus:l}:typeof E=="object"?w={position:R.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?R.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:w={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(N.uri,w),s=d&&this.i.getEditor(d);if(s)return s.value;throw d?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,E){return new O.$EO(this.h,N,E).value}$acceptEditorPropertiesChanged(N,E){const l=this.i.getEditor(N);if(!l)throw new Error("unknown text editor");if(E.options&&l._acceptOptions(E.options),E.selections){const w=E.selections.selections.map(R.Selection.to);l._acceptSelections(w)}if(E.visibleRanges){const w=S.$Hb(E.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(w)}if(E.options&&this.b.fire({textEditor:l.value,options:{...E.options,lineNumbers:R.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const w=m.TextEditorSelectionChangeKind.fromValue(E.selections.source),d=E.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:d,kind:w})}if(E.visibleRanges){const w=S.$Hb(E.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(N){for(const E in N){const l=this.i.getEditor(E);if(!l)throw new Error("Unknown text editor");const w=R.ViewColumn.to(N[E]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this.d.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$Jic=f}),define(Pe[278],Me([1,0,2,3,4,6,7,8,20,16]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0,e.$pkc=(0,F.$gi)("IExtHostTimeline");class N{constructor(w,d){this.b=new Map,this.c=new Map,this.a=w.getProxy(M.$eM.MainThreadTimeline),d.registerArgumentProcessor({processArgument:(s,a)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$Bm.equals(a,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(E(r))?.get(s.handle)}else return;return s}})}async $getTimeline(w,d,s,a){return this.b.get(w)?.provider.provideTimeline(S.URI.revive(d),s,a)}registerTimelineProvider(w,d,s,a){const r=new O.$Sc,i=this.d(d.id,a,r).bind(this);let n;d.onDidChange&&(n=d.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:d.id}),this));const c=this.c;return this.f({...d,scheme:w,onDidChange:void 0,async provideTimeline(h,t,p){t?.resetCache&&(r.clear(),c.get(d.id)?.clear());const u=await d.provideTimeline(h,t,p);if(u==null)return;const o=i(h,t);return{...u,source:d.id,items:u.items.map(o)}},dispose(){for(const h of c.values())h.get(d.id)?.clear();n?.dispose(),r.dispose()}},s)}d(w,d,s){return(a,r)=>{let i;if(r?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const c=E(a);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...h}=n,t=`${w}|${n.id??n.timestamp}`;i?.set(t,n);let p,u,o;n.iconPath&&(c instanceof R.$cN?o={id:c.id,color:c.color}:S.URI.isUri(c)?(p=c,u=c):{light:p,dark:u}=c);let v;return R.$HM.isMarkdownString(h.tooltip)?v=m.MarkdownString.from(h.tooltip):(0,k.$Tf)(h.tooltip)?v=h.tooltip:R.$HM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(h.detail)):(0,k.$Tf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:n.command?d.toInternal(n.command,s):void 0,icon:p,iconDark:u,themeIcon:o,tooltip:v,accessibilityInformation:n.accessibilityInformation}}}}f(w,d){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:d}),(0,O.$Rc)(()=>{for(const a of this.c.values())a.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$qkc=N;function E(l){return l?.toString()}}),define(Pe[279],Me([1,0,171,24,2,5,6,209,11,7,16,18,8,53,25,135,22]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;function r(c,h){if((0,N.$Tf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends R.$Tc{constructor(h,t,p){super(),this.f=h,this.g=t,this.h=p,this.a=new Map,this.b=new s.$R9;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>u(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(v=>u(v)?this.r(v):v):o})}registerTreeDataProvider(h,t,p){const u=this.createTreeView(h,{treeDataProvider:t},p);return{dispose:()=>u.dispose()}}createTreeView(h,t,p){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,$=this.m(h,t,p),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:v,hasHandleDrop:b,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(h,I),D={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,a.$4F)(p,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,a.$4F)(p,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(y){(0,w.$Fk)(y)&&(0,a.$4F)(p,"treeViewMarkdownMessage"),$.message=y},get title(){return $.title},set title(y){$.title=y},get description(){return $.description},set description(y){$.description=y},get badge(){return $.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?$.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&($.badge=void 0)},reveal:(y,P)=>$.reveal(y,P),dispose:async()=>{await g,this.a.delete(h),$.dispose()}};return this.B(D),D}$getChildren(h,t){const p=this.a.get(h);return p?p.getChildren(t):Promise.reject(new m.$vF(h))}async $handleDrop(h,t,p,u,o,v,b,$){const I=this.a.get(h);if(!I)return Promise.reject(new m.$vF(h));const g=l.DataTransfer.toDataTransfer(p,async D=>(await this.f.$resolveDropFileData(h,t,D)).buffer);return b===h&&$&&await this.j(g,I,$,o,v),I.onDrop(g,u,o)}async j(h,t,p,u,o){const v=this.b.removeDragOperationTransfer(o);if(v)(await v)?.forEach((b,$)=>{b&&h.set($,b)});else if(o&&t.handleDrag){const b=t.handleDrag(p,h,u);this.b.addDragOperationTransfer(o,b),await b}return h}async $handleDrag(h,t,p,u){const o=this.a.get(h);if(!o)return Promise.reject(new m.$vF(h));const v=await this.j(new k.$$M,o,t,u,p);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$vF(h);return t.hasResolve}$resolve(h,t,p){const u=this.a.get(h);if(!u)throw new m.$vF(h);return u.resolveTreeItem(t,p)}$setExpanded(h,t,p){const u=this.a.get(h);if(!u)throw new m.$vF(h);u.setExpanded(t,p)}$setSelectionAndFocus(h,t,p){const u=this.a.get(h);if(!u)throw new m.$vF(h);u.setSelectionAndFocus(t,p)}$setVisible(h,t){const p=this.a.get(h);if(!p){if(!t)return;throw new m.$vF(h)}p.setVisible(t)}$changeCheckboxState(h,t){const p=this.a.get(h);if(!p)throw new m.$vF(h);p.setCheckboxState(t)}m(h,t,p){const u=this.B(new n(h,t,this.f,this.g.converter,this.h,p));return this.a.set(h,u),u}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$rkc=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,N.$3f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,p,u,o,v){if(super(),this.I=h,this.J=p,this.L=u,this.M=o,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$6d),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$6d),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$6d),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$6d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$6d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$6d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$6d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$de,v.contributes&&v.contributes.views)for(const g in v.contributes.views)for(const D of v.contributes.views[g])D.id===h&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let b,$;const I=O.Event.debounce(this.F.event,(g,D)=>(g||(g={message:!1,elements:[]}),D.element!==!1&&(b||(b=new Promise(y=>$=y),this.G=this.G.then(()=>b)),Array.isArray(D.element)?g.elements.push(...D.element):g.elements.push(D.element)),D.message&&(g.message=!0),g),200,!0);this.B(I(({message:g,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const y=$;return b=null,this.$(D).then(()=>y())})),g&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let p=this.X(h);return p||(p=await this.Y(t)),p?p.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const p=(0,N.$3f)(t.select)?!0:t.select,u=(0,N.$3f)(t.focus)?!1:t.focus,o=(0,N.$3f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(v=>this.W(h,v[v.length-1]).then(b=>this.J.$reveal(this.I,{item:b.item,parentChain:v.map($=>$.item)},{select:p,focus:u,expand:o})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:p,focus:u,expand:o})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const p=this.getExtensionElement(h);p&&(t?this.u.fire(Object.freeze({element:p})):this.w.fire(Object.freeze({element:p})))}setSelectionAndFocus(h,t){const p=!(0,E.$ub)(this.s,h);this.s=h;const u=this.t!==t;this.t=t,p&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async p=>{const u=this.getExtensionElement(p.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:p.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(p=>p!==void 0);t.forEach(p=>{p.treeItem.checkboxState=p.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(p=>[p.extensionItem,p.newState])})}async handleDrag(h,t,p){const u=[];for(const o of h){const v=this.getExtensionElement(o);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,t,p),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,p){const u=t?this.getExtensionElement(t):void 0;if(!(!u&&t||!this.g?.handleDrop))return(0,f.$$g)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,p):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const p=this.j.get(h);if(p){const u=this.m.get(p);if(u){const o=await this.f.resolveTreeItem(u.extensionItem,p,t)??u.extensionItem;return this.hb(o),u.item.tooltip=this.eb(o.tooltip),u.item.command=this.fb(u.disposableStore,o.command),u.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(p=>this.W(t,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$$g)(()=>this.f.getParent(h))}W(h,t){const p=this.m.get(h);return p?Promise.resolve(p):(0,f.$$g)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,t,!0)).then(u=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const v=this.m.get(o);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const p=this.getExtensionElement(h);t=p?this.m.get(p):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new d.$de(this.Z.token);try{const p=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const o=(0,E.$Hb)(u||[]),v=await Promise.all((0,E.$Hb)(o).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const b=v.map(($,I)=>$?this.db(o[I],$,p):null);return(0,E.$Hb)(b)}finally{t.dispose()}}$(h){if(h.some(p=>!p))return this.Z.dispose(!0),this.Z=new d.$de,this.tb(),this.J.$refresh(this.I);{const p=this.ab(h);if(p.length)return this.bb(p)}return Promise.resolve(void 0)}ab(h){const t=new Set,p=h.map(o=>this.m.get(o));for(const o of p)if(o&&!t.has(o.item.handle)){let v=o;for(;v&&v.parent&&p.findIndex(b=>v&&v.parent&&b&&b.item.handle===v.parent.item.handle)===-1;){const b=this.j.get(v.parent.item.handle);v=b?this.m.get(b):void 0}v&&!v.parent&&t.add(o.item.handle)}const u=[];return t.forEach(o=>{const v=this.j.get(o);if(v){const b=this.m.get(v);b&&(!b.parent||!t.has(b.parent.item.handle))&&u.push(o)}}),u}bb(h){const t={};return Promise.all(h.map(p=>this.cb(p).then(u=>{u&&(t[p]=u.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const p=this.m.get(t);if(p)return this.rb(t),(0,f.$$g)(()=>this.f.getTreeItem(t)).then(u=>{if(u){const o=this.ib(t,u,p.parent);return this.pb(t,o,p,p.parent),p.dispose(),o}return null})}return Promise.resolve(null)}db(h,t,p){const u=this.ib(h,t,p);if(t.id&&this.j.has(u.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(h,u),this.qb(u,p),u}eb(h){return k.$HM.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,p,u;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,p=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:p,accessibilityInformation:u}}hb(h){if(!k.$6M.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,p){this.hb(t);const u=this.B(new R.$Sc),o=this.kb(h,t,p),v=this.lb(t);return{item:{handle:o,parentHandle:p?p.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(u,t.command),contextValue:t.contextValue,icon:v,iconDark:this.mb(t)||v,themeIcon:this.jb(t),collapsibleState:(0,N.$3f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof k.$cN?h.iconPath:void 0}kb(h,{id:t,label:p,resourceUri:u},o,v){if(t)return`${n.b}/${t}`;const b=r(p,this.N),$=o?o.item.handle:n.a;let I=b?b.label:u?(0,F.$Qg)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const g=this.m.has(h)?this.m.get(h).item.handle:void 0,D=this.X(o)||[];let y,P=0;do{if(y=`${$}/${P}:${I}`,v||!this.j.has(y)||g===y)break;P++}while(P<=D.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$cN))return typeof h.iconPath=="string"||M.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$cN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return M.URI.isUri(h)?h:M.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,p,u){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==p.item.handle&&this.j.delete(p.item.handle),this.ob(h,t);const o=this.X(u)||[],v=o.filter(b=>b.item.handle===p.item.handle)[0];v&&o.splice(o.indexOf(v),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const p of t.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const p of t.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[280],Me([1,0,5,6,2,33,8,62,4,7]),function(me,e,S,F,M,O,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class N extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,s,a,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$6d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$6d),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=s,this.#n=a,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,M.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:R.ViewColumn.from(d),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class E extends F.$Tc{static c(){return(0,O.$Cg)()}constructor(d,s,a){super(),this.j=s,this.m=a,this.g=new Map,this.h=new Map,this.f=d.getProxy(f.$eM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,s,a,r,i={}){const n=typeof r=="object"?r.viewColumn:r,c={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,m.$Yic)(d),t=E.c();this.f.$createWebviewPanel((0,m.$1ic)(d),t,s,{title:a,panelOptions:l(i),webviewOptions:(0,m.$2ic)(d,this.m,i),serializeBuffersForPostMessage:h},c);const p=this.j.createNewWebview(t,i,d);return this.createNewWebviewPanel(t,s,a,n,i,p,!0)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((a,r)=>{const i=d[a],n=d[r];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const a of s){const r=this.getWebviewPanel(a);if(!r)continue;const i=d[a];r._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,s,a){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:a,extension:d}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,m.$Yic)(d)}),new k.$gM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,a,r){const i=this.h.get(s);if(!i)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:c}=i,h=this.j.createNewWebview(d,a.webviewOptions,c),t=this.createNewWebviewPanel(d,s,a.title,r,a.panelOptions,h,a.active);await n.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(d,s,a,r,i,n,c){const h=new N(d,this.f,n,{viewType:s,title:a,viewColumn:r,panelOptions:i,active:c});return this.g.set(d,h),h}getWebviewPanel(d){return this.g.get(d)}}e.$3ic=E;function l(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Pe[281],Me([1,0,5,6,62,8,4,7]),function(me,e,S,F,M,O,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class f extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,l,w,d,s,a){super(),this.#s=!1,this.#u=this.B(new S.$6d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$6d),this.onDidDispose=this.#l.event,this.#i=w,this.#a=d,this.#e=E,this.#t=l,this.#n=s,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(E,l){this.d=l,this.b=new Map,this.c=new Map,this.a=E.getProxy(R.$eM.MainThreadWebviewViews)}registerWebviewViewProvider(E,l,w,d){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:w,extension:E}),this.a.$registerWebviewViewProvider((0,M.$1ic)(E),l,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$Yic)(E)}),new m.$gM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(E,l,w,d,s){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:i}=a,n=this.d.createNewWebview(E,{},i),c=new f(E,this.a,l,w,n,!0);this.c.set(E,c),await r.resolveWebviewView(c,{state:d},s)}async $onDidChangeWebviewViewVisibility(E,l){this.e(E)._setVisible(l)}async $disposeWebviewView(E){const l=this.e(E);this.c.delete(E),l.dispose(),this.d.deleteWebview(E)}e(E){const l=this.c.get(E);if(!l)throw new Error("No webview found");return l}}e.$ukc=k}),define(Pe[282],Me([1,0,5,30,35,3]),function(me,e,S,F,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=e.OutputChannelUpdateMode=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=void 0,e.$mL="text/x-code-output",e.$nL="output",e.$oL="Log",e.$pL="text/x-code-log-output",e.$qL="log",e.$rL="workbench.panel.output",e.$sL=new M.$xj("inOutput",!1),e.$tL=new M.$xj("activeLogOutput",!1),e.$uL=new M.$xj("activeLogOutput.levelSettable",!1),e.$vL=new M.$xj("activeLogOutput.level",""),e.$wL=new M.$xj("activeLogOutput.levelIsDefault",!1),e.$xL=new M.$xj("outputView.scrollLock",!1),e.$yL=(0,O.$gi)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$zL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$6d,this.onDidRegisterChannel=this.b.event,this.c=new S.$6d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(N=>k.push(N)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}F.$Yn.add(e.$zL.OutputChannels,new m),e.$AL=new M.$xj("activeOutputChannel","")}),define(Pe[115],Me([1,0,4,3,17,20,13,282,63,27,43,139,23,16,42,5,6]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$8jc=void 0;class r extends R.$Sj{get disposed(){return this.n}constructor(h,t,p,u,o){super(),this.id=h,this.name=t,this.r=p,this.s=u,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(p.getLevel()),this.B(p.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$te.fromString(t).byteLength,(0,R.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends r{appendLine(h){this.append(h)}}let n=class{constructor(h,t,p,u,o,v){this.i=t,this.j=p,this.k=u,this.l=o,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(S.$eM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$Nm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,p]of this.g)p.visible=t===this.h}createOutputChannel(h,t,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof t=="object"&&t.log,o=(0,w.$Tf)(t)?t:void 0;if((0,w.$Tf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const b=this.i.environment.extensionLogLevel?.find(([I])=>O.$Bm.equals(p.identifier,I))?.[1];b&&(v=(0,R.$4j)(b));const $=u?this.o(h,v,p):this.n(h,o,p);return $.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(h,v??this.m.getLevel(),$):this.q(h,$)}async n(h,t,p){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,o=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(h,o,t,p.identifier.value);return new r(b,h,v,this.a,p)}async o(h,t,p){const u=await this.p(p),o=h.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${o}.log`),b=`${p.identifier.value}.${o}`,$=this.l.createLogger(v,{id:b,name:h,logLevel:t,extensionId:p.identifier.value});return new i(b,h,$,this.a,p)}p(h){let t=this.d.get(h.identifier.value);if(!t){const p=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(p)}catch(u){if((0,d.$3k)(u)!==d.FileSystemProviderErrorCode.FileExists)throw u}return p})())}return t}q(h,t){let p=!1;const u=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return h},append(o){u(),t.then(v=>v.append(o))},appendLine(o){u(),t.then(v=>v.appendLine(o))},clear(){u(),t.then(o=>o.clear())},replace(o){u(),t.then(v=>v.replace(o))},show(o,v){u(),t.then(b=>b.show(o,v))},hide(){u(),t.then(o=>o.hide())},dispose(){p=!0,t.then(o=>o.dispose())}}}r(h,t,p){const u=new a.$Sc,o=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new s.$6d);function b($){t=$,v.fire($)}return p.then($=>{u.add($),$.logLevel!==t&&b($.logLevel),u.add($.onDidChangeLogLevel(I=>b(I)))}),{...this.q(h,p),get logLevel(){return t},onDidChangeLogLevel:v.event,trace($,...I){o(),p.then(g=>g.trace($,...I))},debug($,...I){o(),p.then(g=>g.debug($,...I))},info($,...I){o(),p.then(g=>g.info($,...I))},warn($,...I){o(),p.then(g=>g.warn($,...I))},error($,...I){o(),p.then(g=>g.error($,...I))},dispose(){u.dispose()}}}};e.$8jc=n,e.$8jc=n=Je([qe(0,M.$xO),qe(1,k.$NO),qe(2,f.$Uic),qe(3,N.$uic),qe(4,R.$Nj),qe(5,R.$Mj)],n),e.$9jc=(0,F.$gi)("IExtHostOutputService")}),define(Pe[116],Me([1,0,3,11]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$3m=(0,S.$gi)("remoteAgentService"),e.$4m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let O=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await M.getRoundTripTime();if(f===void 0)return;O=Math.min(O,f/2),await(0,F.$hh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(O):R=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:O,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:typeof R>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[283],Me([1,0,174,56,30,47,46,6,5,116,21,26,11]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=void 0,e.$RI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$SI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$TI=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$UI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$VI={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new f.$6d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const d=new w;M.$Yn.add(e.$VI.ConfigurationMigration,d);let s=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,d.migrations)})),this.c(d.migrations),this.B(d.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,p]of h){const u=c[t];if(!u)continue;const o=[];if(u.value!==void 0){const v=await this.h(i,t,u.value,n,void 0);for(const b of v??[])o.push([b,[]])}for(const{identifiers:v,value:b}of u.overrides??[])if(b!==void 0){const $=await this.h(i,t,b,n,v);for(const I of $??[])o.push([I,v])}o.length&&await Promise.allSettled(o.map(async([[v,b],$])=>this.a.updateValue(v,b.value,{resource:n,overrideIdentifiers:$},p)))}}async h(i,n,c,h,t){const p=o=>{const b=this.a.inspect(o,{resource:h})[n];if(b)return t?b.overrides?.find(({identifiers:$})=>(0,E.$Qn)($,t))?.value:b.value},u=await i.migrateFn(c,p);return Array.isArray(u)?u:[[i.key,u]]}};e.$WI=s,e.$WI=s=Je([qe(0,R.$Mi),qe(1,O.$pi)],s);let a=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$Dh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$Yn.as(F.$4n.Configuration).registerConfiguration({...e.$TI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$XI=a,e.$XI=a=Je([qe(0,k.$3m)],a)}),define(Pe[284],Me([1,0,34,12,19,24,182,283,56,3,30]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$dfb=e.$cfb=void 0,e.$efb=s,e.$ffb=a,e.$cfb=(0,k.$gi)("editorResolverService"),e.$dfb="workbench.editorAssociations";const E=N.$Yn.as(f.$4n.Configuration),l={...m.$SI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(l);var w;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(w||(e.RegisteredEditorPriority=w={}));var d;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function s(r){switch(r){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function a(r,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const h=typeof r=="string"&&r.indexOf(M.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,O.$Qg)(i);return S.$_j(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}}),define(Pe[285],Me([1,0,45,12,19,21,24,2,3,203,47,221,116]),function(me,e,S,F,M,O,R,m,f,k,N,E,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=void 0,e.$SL=(0,f.$gi)("pathService");let d=w=class{constructor(a,r,i,n){this.d=a,this.e=r,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,r,i){return typeof r=="string"||typeof r>"u"?this.a.then(n=>this.h(a,n,r)):this.h(a,r,i)}h(a,r,i){return a.scheme===F.Schemas.file||a.scheme===F.Schemas.vscodeRemote?(0,S.$eg)(i??(0,R.$Qg)(a),r===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,r){if(a.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,k.$PL)(r.getWorkspace());if(i)return i;const n=r.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:F.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?M.$fc:M.$gc)}async fileURI(a){let r="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const n=a.indexOf("/",2);n===-1?(r=a.substring(2),a="/"):(r=a.substring(2,n),a=a.substring(n)||"/")}return m.URI.from({scheme:F.Schemas.file,authority:r,path:a,query:"",fragment:""})}};e.$TL=d,e.$TL=d=w=Je([qe(1,l.$3m),qe(2,E.$BL),qe(3,N.$pi)],d)}),define(Pe[117],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$mK=e.$lK=void 0;class S{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new S(0,0)}with(R){return new S(0,0)}}e.$lK=S;class F{constructor(R,m,f,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,m),this.end=new S(f,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$mK=F;var M;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Pe[44],Me([1,0,18,34,26,45,15,3,19,14,117,11]),function(me,e,S,F,M,O,R,m,f,k,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$JK=e.$CK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$zK=e.$yK=e.$xK=e.$wK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.TextSearchCompleteMessageType=void 0,e.$tK=r,e.$uK=i,e.$vK=n,e.$AK=$,e.$BK=I,e.$DK=y,e.$EK=P,e.$FK=A,e.$GK=G,e.$HK=W,e.$IK=U,e.$KK=T,e.$MK=ce,e.$NK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$nK="workbench.view.search",e.$oK="workbench.panel.search",e.$pK="workbench.view.search",e.$qK="search-result",e.$rK="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",d=(l.length+w.length+5)*2;e.$sK=(0,m.$gi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var a;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(a||(e.QueryType=a={}));function r(ue){return!!ue.preview}function i(ue){return!!ue.resource}function n(ue){return!!ue.message}var c;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$wK=h;class t{constructor(ve,re,$e,ie){this.ranges=re,this.webviewIndex=ie;const le=Array.isArray(re)?re:[re];if($e&&$e.matchLines===1&&p(le)){ve=(0,R.$Mf)(ve,$e.matchLines);let V="",ee=0,ke=0;const Ne=Math.floor($e.charsPerLine/5),Se=[];for(const be of le){const ge=Math.max(be.startColumn-Ne,0),J=be.startColumn+$e.charsPerLine;if(ge>ke+Ne+d){const Z=l+(ge-ke)+w;V+=Z+ve.slice(ge,J),ee+=ge-(ke+Z.length)}else V+=ve.slice(ke,J);Se.push(new o(0,be.startColumn-ee,be.endColumn-ee)),ke=J}this.preview={text:V,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const V=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(re,ee=>new u(ee.startLineNumber-V,ee.startColumn,ee.endLineNumber-V,ee.endColumn))}}}}e.$xK=t;function p(ue){const ve=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==ve||re.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,re,$e,ie){this.startLineNumber=ve,this.startColumn=re,this.endLineNumber=$e,this.endColumn=ie}}e.$yK=u;class o extends u{constructor(ve,re,$e){super(ve,re,ve,$e)}}e.$zK=o;var v;(function(ue){ue.List="list",ue.Tree="tree"})(v||(e.ViewMode=v={}));var b;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function $(ue,ve=!0){const re=ue&&ue.files&&ue.files.exclude,$e=ve&&ue&&ue.search&&ue.search.exclude;if(!re&&!$e)return;if(!re||!$e)return re||$e;let ie=Object.create(null);return ie=M.$Pn(ie,M.$Mn(re)),ie=M.$Pn(ie,M.$Mn($e),!0),ie}function I(ue,ve){return ue.excludePattern&&F.$_j(ue.excludePattern,ve)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&F.$_j(ue.includePattern,ve)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const $e=re.folder.fsPath;if(O.$gg(ve,$e)){const ie=f.$lc($e,ve);return!re.includePattern||!!F.$_j(re.includePattern,ie)}else return!1}):!1:!0}var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class D extends Error{constructor(ve,re){super(ve),this.code=re}}e.$CK=D;function y(ue){const ve=ue.message;if((0,k.$4)(ue))return new D(ve,g.canceled);try{const re=JSON.parse(ve);return new D(re.message,re.code)}catch{return new D(ve,g.other)}}function P(ue){const ve={message:ue.message,code:ue.code};return new Error(JSON.stringify(ve))}function A(ue){return ue.type==="error"?!0:ue.type==="success"}function G(ue){return ue.type==="success"}function W(ue){return!!ue.path}function U(ue,ve,re=!0){const $e=ue.searchPath?ue.searchPath:ue.relativePath;return re?(0,R.$Jf)($e,ve):F.$_j(ve,$e)}class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$JK=C;function T(ue,ve){const re={...ue||{},...ve||{}};return Object.keys(re).filter($e=>{const ie=re[$e];return typeof ie=="boolean"&&ie})}class q{constructor(ve,re){this.c=null,this.a={...ve.excludePattern||{},...re.excludePattern||{}},this.b=F.$ak(this.a);let $e=ve.includePattern;re.includePattern&&($e?$e={...$e,...re.includePattern}:$e=re.includePattern),$e&&(this.c=F.$ak($e))}matchesExcludesSync(ve,re,$e){return!!(this.b&&this.b(ve,re,$e))}includedInQuerySync(ve,re,$e){return!(this.b&&this.b(ve,re,$e)||this.c&&!this.c(ve,re,$e))}includedInQuery(ve,re,$e){const ie=this.b(ve,re,$e),le=()=>this.c?!!this.c(ve,re,$e):!0;return(0,E.$5g)(ie)?ie.then(V=>V?!1:le()):le()}hasSiblingExcludeClauses(){return ne(this.a)}}e.$LK=q;function ne(ue){for(const ve in ue)if(typeof ue[ve]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let ve;return re=>(ve||(ve=(ue()||Promise.resolve([])).then($e=>$e?Ie($e):{})),ve.then($e=>!!$e[re]))}function ye(ue){if(!ue)return;let ve;return re=>{if(!ve){const $e=ue();ve=$e?Ie($e):{}}return!!ve[re]}}function Ie(ue){const ve={};for(const re of ue)ve[re]=!0;return ve}}),define(Pe[36],Me([1,0,18,11,25,5,6,50,12,125,24,15,2,173,3,13,192,47,43,27,17,8,7,59,44,4,52]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p,u,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;function b(G,W,U){return new N.$Ig(C=>D(C,U)).isEqual(G,W)}function $(G,W,U){return b(G.uri,W.uri,U)?0:(0,E.$df)(G.uri.toString(),W.uri.toString())}function I(G,W,U){return G.index!==W.index?G.index<W.index?-1:1:b(G.uri,W.uri,U)?(0,E.$df)(G.name,W.name):(0,E.$df)(G.uri.toString(),W.uri.toString())}function g(G,W,U,C){const T=G.slice(0).sort((ne,ce)=>U(ne,ce,C)),q=W.slice(0).sort((ne,ce)=>U(ne,ce,C));return(0,S.$Eb)(T,q,(ne,ce)=>U(ne,ce,C))}function D(G,W){const U=W.getCapabilities(G.scheme);return!(U&&U&1024)}class y extends r.$zi{static toExtHostWorkspace(W,U,C,T){if(!W)return{workspace:null,added:[],removed:[]};const{id:q,name:ne,folders:ce,configuration:ye,transient:Ie,isUntitled:ue}=W,ve=[],re=U;U?ce.forEach((V,ee)=>{const ke=l.URI.revive(V.uri),Ne=y.o(C||U,ke,T);Ne?(Ne.name=V.name,Ne.index=V.index,ve.push(Ne)):ve.push({uri:ke,name:V.name,index:ee})}):ve.push(...ce.map(({uri:V,name:ee,index:ke})=>({uri:l.URI.revive(V),name:ee,index:ke}))),ve.sort((V,ee)=>V.index<ee.index?-1:1);const $e=new y(q,ne,ve,!!Ie,ye?l.URI.revive(ye):null,!!ue,V=>D(V,T)),{added:ie,removed:le}=g(re?re.workspaceFolders:[],$e.workspaceFolders,$,T);return{workspace:$e,added:ie,removed:le}}static o(W,U,C){for(let T=0;T<W.folders.length;T++){const q=W.workspaceFolders[T];if(b(q.uri,U,C))return q}}constructor(W,U,C,T,q,ne,ce){super(W,C.map(ye=>new r.$Ai(ye)),T,q,ce),this.t=U,this.u=ne,this.q=[],this.s=m.$mi.forUris(ce),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,N.$Sg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let P=class{constructor(W,U,C,T,q){this.c=new O.$6d,this.onDidChangeWorkspace=this.c.event,this.g=new O.$6d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$8d,this.C=new Map,this.h=T,this.s=C,this.t=q,this.j=new k.$nm,this.k=new F.$fh,this.o=W.getProxy(o.$eM.MainThreadWorkspace),this.q=W.getProxy(o.$eM.MainThreadMessageService);const ne=U.workspace;this.l=ne?new y(ne.id,ne.name,[],!!ne.transient,ne.configuration?l.URI.revive(ne.configuration):null,!!ne.isUntitled,ce=>D(ce,C)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,N.$Qg)((0,N.$Sg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,C,...T){const q=[];if(Array.isArray(T)&&T.forEach(ue=>{l.URI.isUri(ue.uri)&&!q.some(ve=>b(ve.uri,ue.uri,this.s))&&q.push({uri:ue.uri,name:ue.name||(0,N.$Pg)(ue.uri)})}),this.n||[U,C].some(ue=>typeof ue!="number"||ue<0)||C===0&&q.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(U+C>ne.length)return!1;const ce=ne.slice(0);ce.splice(U,C,...q.map(ue=>({uri:ue.uri,name:ue.name||(0,N.$Pg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const ve=ce[ue];if(ce.some((re,$e)=>$e!==ue&&b(ve.uri,re.uri,this.s)))return!1}ce.forEach((ue,ve)=>ue.index=ve);const{added:ye,removed:Ie}=g(ne,ce,I,this.s);if(ye.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,U,C,q).then(void 0,ve=>{this.n=void 0;const re={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(a.Severity.Error,(0,w.localize)(0,null,ue,ve.toString()),re,[])})}return this.y(ce),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let C,T="";if(typeof W=="string"?(C=l.URI.file(W),T=W):typeof W<"u"&&(C=W,T=W.fsPath),!C)return T;const q=this.getWorkspaceFolder(C,!0);if(!q)return T;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ne=(0,N.$Vg)(q.uri,C);return U&&q.name&&(ne=`${q.name}/${ne}`),ne}y(W){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:C,removed:T}=y.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:T}))}findFiles(W,U,C,T,q=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let ne="",ce=!0;return U===null?ce=!1:U!==void 0&&(typeof U=="string"?ne=U:ne=U.pattern),this.z(W,void 0,{exclude:ne,maxResults:C,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},q)}findFiles2(W,U={},C,T=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,W,U,T)}async z(W,U,C,T=M.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const q=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,ne={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:q,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ye,folder:Ie}=A(h.GlobPattern.from(W));ce=Ie,ne.includePattern=ye}else{const{includePattern:ye,folder:Ie}=A(h.GlobPattern.from(U));ce=Ie,ne.filePattern=ye}return this.o.$startFileSearch(ce??null,ne,T).then(ye=>Array.isArray(ye)?ye.map(Ie=>l.URI.revive(Ie)):[])}async findTextInFiles(W,U,C,T,q=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),ce=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:Ie}=A(h.GlobPattern.from(U.include)),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ce,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:ue},re=!1;if(this.u[ne]=$e=>{if(re)return;const ie=l.URI.revive($e.resource);$e.results.forEach(le=>{const V=(0,v.$Ph)(le);(0,u.$tK)(V)?C({uri:ie,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,ee=>new t.$iM(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,S.$2b)(V.ranges,ee=>new t.$iM(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):C({uri:ie,text:V.text,lineNumber:V.lineNumber})})},q.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(W,Ie??null,ve,ne,q);return delete this.u[ne],$e||{}}catch($e){throw delete this.u[ne],$e}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return l.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return l.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const C=this.t.transformOutgoingScheme(W),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,C),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const C=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const T=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!T),!T)return;const q=await T.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch(W,U,C,T){this.h.info("Getting edit session identifier for workspaceFolder",W);const q=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const ne=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!ne),!ne)return;const ce=await ne.provideEditSessionIdentityMatch?.(U,C,T);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(U,C,T)=>{const q=function(ce){U.call(C,ce)};return q.extension=W,this.B.event(q,void 0,T)}}async $onWillCreateEditSessionIdentity(W,U,C){const T=await this.resolveWorkspaceFolder(l.URI.revive(W));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},U,async(q,ne)=>{const ce=Date.now();await Promise.resolve(q),Date.now()-ce>C&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,U);const C=this.t.transformOutgoingScheme(W),T=this.A++;return this.o.$registerCanonicalUriProvider(T,C),(0,R.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(W,U,C){const T=this.C.get(W.scheme);if(!T)return;const q=await T.provideCanonicalUri?.(l.URI.revive(W),U,C);if(q)return q}async $provideCanonicalUri(W,U,C){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:U},C)}};e.$Oic=P,e.$Oic=P=Je([qe(0,c.$xO),qe(1,n.$NO),qe(2,i.$uic),qe(3,s.$Mj),qe(4,p.$Mic)],P),e.$Pic=(0,d.$gi)("IExtHostWorkspace");function A(G){let W,U;return G&&(typeof G=="string"?W=G:(W=G.pattern,U=l.URI.revive(G.baseUri))),{includePattern:W,folder:U}}}),define(Pe[37],Me([1,0,26,5,36,4,7,194,56,16,11,3,17,13,2]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=e.$Qic=void 0;function s(p,u){if(u){const o=u.split(".");let v=p;for(let b=0;v&&b<o.length;b++)v=v[o[b]];return v}}function a(p){return p instanceof d.URI}function r(p){return p&&p.uri instanceof d.URI&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function n(p){return p&&p.uri instanceof d.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function c(p){if(a(p))return{resource:p};if(r(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(i(p))return{overrideIdentifier:p.languageId};if(n(p))return{resource:p.uri};if(p===null)return{resource:null}}let h=class{constructor(u,o,v){this.a=u.getProxy(O.$eM.MainThreadConfiguration),this.c=o,this.b=v,this.d=new N.$fh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new t(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,o))}};e.$Qic=h,e.$Qic=h=Je([qe(0,l.$xO),qe(1,M.$Pic),qe(2,w.$Mj)],h);class t{constructor(u,o,v,b){this.a=new F.$6d,this.b=u,this.f=b,this.c=o,this.e=m.$ko.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,o){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$ko.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(o,v))}getConfiguration(u,o,v){const b=c(o)||{},$=this.g(u?s(this.e.getValue(void 0,b,this.c.workspace),u):this.e.getValue(void 0,b,this.c.workspace));u&&this.h(u,b,v?.identifier);function I(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(D){return typeof s($,D)<"u"},get:(D,y)=>{this.h(u?`${u}.${D}`:D,b,v?.identifier);let P=s($,D);if(typeof P>"u")P=y;else{let A;const G=(W,U)=>{if((0,k.$Vf)(W)){let C;const T=()=>{A=A||(0,S.$Mn)($),C=C||s(A,U)};return new Proxy(W,{get:(q,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return T(),()=>C;if(A)return C=C||s(A,U),C[ne];const ce=q[ne];return typeof ne=="string"?G(ce,`${U}.${ne}`):ce},set:(q,ne,ce)=>(T(),C&&(C[ne]=ce),!0),deleteProperty:(q,ne)=>(T(),C&&delete C[ne],!0),defineProperty:(q,ne,ce)=>(T(),C&&Object.defineProperty(C,ne,ce),!0)})}return Array.isArray(W)?(0,S.$Mn)(W):W};P=G(P,D)}return P},update:(D,y,P,A)=>{D=u?`${u}.${D}`:D;const G=I(P);return y!==void 0?this.b.$updateConfigurationOption(G,D,y,b,A):this.b.$removeConfigurationOption(G,D,b,A)},inspect:D=>{D=u?`${u}.${D}`:D;const y=this.e.inspect(D,b,this.c.workspace);if(y)return{key:D,defaultValue:(0,S.$Mn)(y.policy?.value??y.default?.value),globalValue:(0,S.$Mn)(y.user?.value??y.application?.value),workspaceValue:(0,S.$Mn)(y.workspace?.value),workspaceFolderValue:(0,S.$Mn)(y.workspaceFolder?.value),defaultLanguageValue:(0,S.$Mn)(y.default?.override),globalLanguageValue:(0,S.$Mn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,S.$Mn)(y.workspace?.override),workspaceFolderLanguageValue:(0,S.$Mn)(y.workspaceFolder?.override),languageIds:(0,S.$Mn)(y.overrideIdentifiers)}}};return typeof $=="object"&&(0,S.$Pn)(g,$,!1),Object.freeze(g)}g(u){const o=v=>(0,k.$Vf)(v)?new Proxy(v,{get:(b,$)=>o(b[$]),set:(b,$,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(b,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(b,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return o(u)}h(u,o,v){const b=f.$bo.test(u)?4:this.d.get(u),$=v?`[${v.value}] `:"";if(b===4){typeof o?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){o?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,o){const v=new m.$mo(u,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,$)=>v.affectsConfiguration(b,c($))})}k(u){return u.reduce((o,v)=>(o.set(v[0],v[1]),o),new Map)}}e.$Ric=t,e.$Sic=(0,E.$gi)("IExtHostConfiguration")}),define(Pe[118],Me([1,0,2,11,5,4,7,36,67,37,25,66,17,27,3,12,21,13,78,226,14]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=e.$hkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(h||(h={}));var t;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(t||(t={}));var p;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(p||(p={}));var u;(function(G){function W(T){if(T){const q=T;return q&&!!q.process}else return!1}G.is=W;function U(T){if(T==null)return;const q={process:T.process,args:T.args};return T.options&&(q.options=p.from(T.options)),q}G.from=U;function C(T){if(T!=null)return new R.$2M(T.process,T.args,T.options)}G.to=C})(u||(u={}));var o;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(o||(o={}));var v;(function(G){function W(T){if(T){const q=T;return q&&(!!q.commandLine||!!q.command)}else return!1}G.is=W;function U(T){if(T==null)return;const q={};return T.commandLine!==void 0?q.commandLine=T.commandLine:(q.command=T.command,q.args=T.args),T.options&&(q.options=o.from(T.options)),q}G.from=U;function C(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$3M(T.commandLine,T.options):new R.$3M(T.command,T.args?T.args:[],T.options)}G.to=C})(v||(v={}));var b;(function(G){function W(T){if(T){const q=T;return q&&q.customExecution==="customExecution"}else return!1}G.is=W;function U(T){return{customExecution:"customExecution"}}G.from=U;function C(T,q){return q.get(T)}G.to=C})(b||(e.CustomExecutionDTO=b={}));var $;(function(G){function W(U,C){let T;return U.scope!==void 0&&typeof U.scope!="number"?T=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?T=C.workspaceFile:T=n.$mH),{id:U._id,workspaceFolder:T}}G.from=W})($||(e.TaskHandleDTO=$={}));var I;(function(G){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=W})(I||(I={}));var g;(function(G){function W(T,q){if(T==null)return[];const ne=[];for(const ce of T){const ye=U(ce,q);ye&&ne.push(ye)}return ne}G.fromMany=W;function U(T,q){if(T==null)return;let ne;T.execution instanceof R.$2M?ne=u.from(T.execution):T.execution instanceof R.$3M?ne=v.from(T.execution):T.execution&&T.execution instanceof R.$4M&&(ne=b.from(T.execution));const ce=h.from(T.definition);let ye;return T.scope?typeof T.scope=="number"?ye=T.scope:ye=T.scope.uri:ye=R.TaskScope.Workspace,!ce||!ye?void 0:{_id:T._id,definition:ce,name:T.name,source:{extensionId:q.identifier.value,label:T.source,scope:ye},execution:ne,isBackground:T.isBackground,group:I.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}G.from=U;async function C(T,q,ne){if(T==null)return;let ce;u.is(T.execution)?ce=u.to(T.execution):v.is(T.execution)?ce=v.to(T.execution):b.is(T.execution)&&(ce=b.to(T._id,ne));const ye=h.to(T.definition);let Ie;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Ie=T.source.scope:Ie=await q.resolveWorkspaceFolder(S.URI.revive(T.source.scope)):Ie=R.TaskScope.Workspace),!ye||!Ie)return;const ue=new R.$5M(ye,Ie,T.name,T.source.label,ce,T.problemMatchers);return T.isBackground!==void 0&&(ue.isBackground=T.isBackground),T.group!==void 0&&(ue.group=R.$1M.from(T.group._id),ue.group&&T.group.isDefault&&(ue.group=new R.$1M(ue.group.id,ue.group.label),T.group.isDefault===!0&&(ue.group.isDefault=T.group.isDefault))),T.presentationOptions&&(ue.presentationOptions=t.to(T.presentationOptions)),T._id&&(ue._id=T._id),T.detail&&(ue.detail=T.detail),ue}G.to=C})(g||(e.TaskDTO=g={}));var D;(function(G){function W(C){return C}G.from=W;function U(C){if(C)return Object.assign(Object.create(null),C)}G.to=U})(D||(D={}));class y{#e;constructor(W,U,C){this._id=U,this.a=C,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let P=class{constructor(W,U,C,T,q,ne,ce,ye){this.q=new M.$6d,this.r=new M.$6d,this.s=new M.$6d,this.u=new M.$6d,this.a=W.getProxy(O.$eM.MainThreadTask),this.b=C,this.c=T,this.d=q,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,C){if(!C)return new R.$gM(()=>{});const T=this.x();return this.j.set(T,{type:U,provider:C,extension:W}),this.a.$registerTaskProvider(T,U),new R.$gM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(D.from(W)).then(async U=>{const C=[];for(const T of U){const q=await g.to(T,this.b,this.m);q&&C.push(q)}return C})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,C){const T=this.m.get(W.id);T&&(this.o.set(W.id,T),this.e.attachPtyToTerminal(U,await T.callback(C))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const U=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.z(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const U=await this.z(W.id);this.u.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));const T=[],q=(0,F.$$g)(()=>C.provider.provideTasks(N.CancellationToken.None)).then(ne=>this.v(U,T,C,ne));return new Promise(ne=>{q.then(ce=>{Promise.all(T).then(()=>{ne(ce)})})})}async $resolveTask(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const T=await g.to(U,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const q=await C.provider.resolveTask(T,N.CancellationToken.None);if(!q)return;this.A(q,C);const ne=g.from(q,C.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(ne.execution)&&await this.y(ne,q,!0),await this.w(ne)}x(){return this.h++}async y(W,U,C){const T=await this.a.$createTaskId(W);!C&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,U.execution)),this.m.set(T,U.execution)}async z(W,U){if(typeof W=="string"){const q=this.l.get(W);if(!q)throw new c.$bb("Unexpected: The specified task is missing an execution");return q}const C=this.l.get(W.id);if(C)return C;let T;return U?T=Promise.resolve(new y(this,W.id,U)):T=g.to(W.task,this.b,this.m).then(q=>{if(!q)throw new c.$bb("Unexpected: Task does not exist.");return new y(this,W.id,q)}),this.l.set(W.id,T),T.then(q=>(this.k.set(W.id,q),q))}A(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const C=this.n.values();let T=C.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=C.next()}};e.$hkc=P,e.$hkc=P=Je([qe(0,l.$xO),qe(1,w.$NO),qe(2,m.$Pic),qe(3,f.$IO),qe(4,k.$Sic),qe(5,E.$ejc),qe(6,r.$Mj),qe(7,i.$qic)],P);let A=class extends P{constructor(W,U,C,T,q,ne,ce,ye){super(W,U,C,T,q,ne,ce,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=g.from(U,W);if(C===void 0)throw new Error("Task is not valid");if(b.is(C.execution))await this.y(C,U,!1);else throw new c.$_;const T=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(q=>{throw new Error(q)}),T}v(W,U,C,T){const q=[];if(T)for(const ne of T){if(this.A(ne,C),!ne.definition||!W[ne.definition.type]){const ye=ne.source?ne.source:"No task source";this.f.warn(`The task [${ye}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=g.from(ne,C.extension);ce&&b.is(ce.execution)?(q.push(ce),U.push(this.y(ce,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:C.extension}}async w(W){if(b.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,C){}};e.$ikc=A,e.$ikc=A=Je([qe(0,l.$xO),qe(1,w.$NO),qe(2,m.$Pic),qe(3,f.$IO),qe(4,k.$Sic),qe(5,E.$ejc),qe(6,r.$Mj),qe(7,i.$qic)],A),e.$jkc=(0,d.$gi)("IExtHostTask")}),define(Pe[286],Me([1,0,44,29]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=void 0,e.$TK=M,e.$VK=O;function M(R){return"cellResults"in R}e.$UK="rawCell#";function O(R,m){let f=-1;const k=[];let N=[];return R.forEach(l=>{l.range.startLineNumber!==f&&N.length>0&&(k.push([...N]),N=[]),N.push(l),f=l.range.endLineNumber}),N.length>0&&k.push([...N]),k.map(l=>{const w=[],d=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let a=d;a<=s;a++)w.push(m.getLineContent(a));return new S.$xK(w.join(`
`)+`
`,l.map(a=>new F.$$s(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}}),define(Pe[287],Me([1,0,167,23,5,6,28,15,16,2,42,74,4,31,8,7,49,262,112,26,12,216,286,284]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(v=>v.apiEditor)}constructor(v,b,$,I,g,D){this.q=$,this.r=I,this.s=g,this.t=D,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new M.$6d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$6d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$6d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$6d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$oic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=v.getProxy(l.$eM.MainThreadNotebook),this.c=v.getProxy(l.$eM.MainThreadNotebookDocuments),this.d=v.getProxy(l.$eM.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,A=y.cell.handle,W=this.g.get(P)?.getCell(A);if(W)return W.apiCell}if(y&&y.$mid===14){const P=y.uri,A=this.g.get(P);if(A)return A.apiNotebook}return y}}),u.B(b)}getEditorById(v){const b=this.h.get(v);if(!b)throw new Error(`unknown text editor: ${v}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(v){for(const[b,$]of this.h)if($.apiEditor===v)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(v,b){const $=this.g.get(v);if(!$&&!b)throw new Error(`NO notebook document for '${v}'`);return $}static u(v,b){if(!b)return;const $=b.filenamePattern.map(I=>d.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(b.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:b.displayName,filenamePattern:$,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,b,$){const I=u.a++,g=typeof $.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(I,$),this.b.$registerNotebookCellStatusBarItemProvider(I,g,b);let D;return g!==void 0&&(D=$.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new s.$gM(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,g),D?.dispose()})}async createNotebookDocument(v){const b=await this.c.$tryCreateNotebook({viewType:v.viewType,content:v.content&&d.NotebookData.from(v.content)});return k.URI.revive(b)}async openNotebookDocument(v){const b=this.g.get(v);if(b)return b.apiNotebook;const $=await this.c.$tryOpenNotebook(v),I=this.g.get(k.URI.revive($));return(0,f.$5f)(I?.apiNotebook)}async showNotebookDocument(v,b){k.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let $;typeof b=="object"?$={position:d.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(d.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:$={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(v.uri,v.notebookType,$),g=I&&this.h.get(I)?.apiEditor;if(g)return g;throw I?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,b,$,I){const g=this.f.get(v),D=k.URI.revive(b),y=this.g.get(D);if(!y||!g)return;const P=y.getCellFromIndex($);if(!P)return;const A=await g.provideCellStatusBarItems(P.apiCell,I);if(!A)return;const G=new O.$Sc,W=this.p.add([G]),C=(Array.isArray(A)?A:[A]).map(T=>d.NotebookStatusBarItem.from(T,this.i,G));return{cacheId:W,items:C}}$releaseNotebookCellStatusBarItems(v){this.p.delete(v)}registerNotebookSerializer(v,b,$,I,g){if((0,m.$Te)(b))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:b,serializer:$,options:I}),this.b.$registerNotebookSerializer(D,{id:v.identifier,location:v.extensionLocation},b,d.NotebookDocumentContentOptions.from(I),u.u(v,g)),(0,O.$Rc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(v,b,$){const I=this.x.get(v);if(!I)throw new Error("NO serializer found");const g=await I.serializer.deserializeNotebook(b.buffer,$);return new a.$aw(d.NotebookData.from(g))}async $notebookToData(v,b,$){const I=this.x.get(v);if(!I)throw new Error("NO serializer found");const g=await I.serializer.serializeNotebook(d.NotebookData.to(b.value),$);return F.$te.wrap(g)}async $saveNotebook(v,b,$,I,g){const D=k.URI.revive(b),y=this.x.get(v);if(!y)throw new Error("NO serializer found");const P=this.g.get(D);if(!P)throw new Error("Document NOT found");if(P.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new N.$8k((0,S.localize)(0,null,this.z(D)),6);await this.y(D,I);const A={metadata:(0,n.$Un)(P.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const q=new s.$IN(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);q.metadata=(0,n.$Un)(T.metadata,ne=>!(y.options?.transientCellMetadata??{})[ne]),A.cells.push(q)}const G=await y.serializer.serializeNotebook(A,g);await this.s.value.writeFile(D,G);const W=this.s.getFileSystemProviderExtUri(D.scheme),U=await this.s.value.stat(D);return{name:W.basename(D),isFile:(U.type&N.FileType.File)!==0,isDirectory:(U.type&N.FileType.Directory)!==0,isSymbolicLink:(U.type&N.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((U.permissions??0)&N.FilePermission.Locked),etag:N.$gl({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(v,b,$,I,g){const D=this.x.get(v)?.serializer;if(!D)return{limitHit:!1,results:[]};const y=new R.$Bc;await(async(U,C,T)=>{await Promise.all(U.map(async q=>await Promise.all(q.filenamePatterns.map(ne=>{const ce={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:ne};return this.t.doInternalFileSearchWithCustomCallback(ce,C,ye=>{ye.forEach(Ie=>{y.has(Ie)||I.some(ve=>q.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(re=>(0,p.$ffb)(re,Ie)))||y.add(Ie)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})($,g,b);const A=new R.$Ac;let G=!1;const W=Array.from(y).map(async U=>{const C=[];try{if(g.isCancellationRequested)return;if(b.maxResults&&[...A.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>b.maxResults){G=!0;return}const T=[],q=this.g.get(U);if(q)q.apiNotebook.getCells().forEach(ye=>T.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(U),ye=F.$te.fromString(ce.toString()),Ie=await D.deserializeNotebook(ye.buffer,g);if(g.isCancellationRequested)return;d.NotebookData.from(Ie).cells.forEach(ve=>T.push({input:ve.source,outputs:ve.outputs.flatMap(re=>re.items.map($e=>$e.valueBytes.toString()))}))}if(g.isCancellationRequested)return;T.forEach((ce,ye)=>{const Ie=b.contentPattern.pattern,ue=new h.$RTb(ce.input,void 0,ce.outputs),ve=ue.findInInputs(Ie),re=ue.findInOutputs(Ie),$e=re.flatMap(ie=>(0,t.$VK)(ie.matches,ie.textBuffer)).map((ie,le)=>(ie.webviewIndex=le,ie));if(ve.length>0||re.length>0){const ie={index:ye,contentResults:(0,t.$VK)(ve,ue.inputTextBuffer),webviewResults:$e};C.push(ie)}});const ne={resource:U,cellResults:C};A.set(U,ne);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...A.values()]}}async y(v,b){const $=await this.s.value.stat(v);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==N.$fl&&typeof $.mtime=="number"&&typeof $.size=="number"&&b.mtime<$.mtime&&b.etag!==N.$gl({mtime:b.mtime,size:$.size}))throw new N.$8k((0,S.localize)(1,null),3,b)}z(v){return v.scheme===c.Schemas.file?v.fsPath:v.toString()}A(v,b,$){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const I=new i.$Mjc(b,this.d,v,$.visibleRanges.map(d.NotebookRange.to),$.selections.map(d.NotebookRange.to),typeof $.viewColumn=="number"?d.ViewColumn.to($.viewColumn):void 0);this.h.set(b,I)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const $ of v.value.removedDocuments){const I=k.URI.revive($),g=this.g.get(I);g&&(g.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(g.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===I.toString()&&this.h.delete(D.id)}if(v.value.addedDocuments){const $=[];for(const I of v.value.addedDocuments){const g=k.URI.revive(I.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const D=new r.$Ljc(this.c,this.q,this.r,g,I);$.push(...I.cells.map(y=>r.$Kjc.asModelAddData(y))),this.g.get(g)?.dispose(),this.g.set(g,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(D.apiNotebook)}}if(v.value.addedEditors)for(const $ of v.value.addedEditors){if(this.h.has($.id))return;const I=k.URI.revive($.documentUri),g=this.g.get(I);g&&this.A(g,$.id,$)}const b=[];if(v.value.removedEditors)for(const $ of v.value.removedEditors){const I=this.h.get($);I&&(this.h.delete($),this.k?.id===I.id&&(this.k=void 0),b.push(I))}if(v.value.visibleEditors){this.l=v.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const $=new Set;this.l.forEach(I=>$.add(I.id));for(const I of this.h.values()){const g=$.has(I.id);I._acceptVisibility(g)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this.k=void 0:v.value.newActiveEditor&&(this.h.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this.k=this.h.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(v){const b=w.$VO.String.with("notebookType","A notebook type"),$=new w.$XO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new w.$VO("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>F.$te.wrap(g))],new w.$WO("Notebook Data",g=>d.NotebookData.to(g.value))),I=new w.$XO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new w.$VO("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new a.$aw(d.NotebookData.from(g)))],new w.$WO("Bytes",g=>g.buffer));v.registerApiCommand($),v.registerApiCommand(I)}}e.$Vjc=u}),define(Pe[288],Me([1,0,19,25,41,34,24,64,44]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class k{constructor(l,w,d){this.k=l,this.l=w,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&O.$ak(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&O.$ak(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const w=this.k.folderQueries||[];return new Promise((d,s)=>{const a=r=>{this.f++,l(r)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const i=r.toString(),n=S.$nc(i);this.j&&this.j(i,n)||this.v(a,{base:r,basename:n})}),Promise.all(w.map(r=>this.p(r,a))).then(r=>{d({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,M.$4i)(r)))})})}async p(l,w){const d=new F.$de,s=this.q(l),a=this.r(),r=new f.$LK(this.k,l),i=!r.hasSiblingExcludeClauses();let n;try{this.h.add(d),n=m.$2d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,d.token),h=n.elapsed(),t=m.$2d.create();return this.g&&!this.e||(c&&c.forEach(p=>{const u=S.$gc.relative(l.folder.path,p.path);if(i){const o=S.$nc(p.path);this.v(w,{base:l.folder,relativePath:u,basename:o});return}this.s(a,l.folder,u,w)}),this.g&&!this.e)?null:(this.u(a,r,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(l){const w=(0,f.$KK)(this.k.includePattern,l.includePattern),d=(0,f.$KK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:d,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},w,d,s){if(d===this.a){const r=S.$nc(this.a);this.v(s,{base:w,relativePath:this.a,basename:r})}function a(r){const i=S.$nc(r),n=S.$mc(r);let c=l[n];c||(c=l[n]=[],a(n)),c.push({base:w,relativePath:r,basename:i})}a(d)}u({rootEntries:l,pathToEntries:w},d,s){const a=this,r=this.a;function i(n){const c=(0,f.$NK)(()=>n.map(h=>h.basename));for(let h=0,t=n.length;h<t;h++){const p=n[h],{relativePath:u,basename:o}=p;if(d.matchesExcludesSync(u,o,r!==o?c:void 0))continue;const v=w[u];if(v)i(v);else{if(u===r)continue;a.v(s,p)}if(a.e)break}}i(l)}v(l,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(w))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,w,d,s){const a=this.c(l.cacheKey),r=new k(l,w,a&&a.token);let i=0;const n=c=>{i+=c.length,d(c.map(h=>this.d(h)))};return this.e(r,N.a,n,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new F.$de),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Tg(l.base,l.relativePath)}:{resource:l.base}}e(l,w,d,s){const a=s.onCancellationRequested(()=>{l.cancel()}),r=n=>{n&&(i.push(n),w>0&&i.length>=w&&(d(i),i=[]))};let i=[];return l.search(r).then(n=>(i.length&&d(i),a.dispose(),n),n=>(i.length&&d(i),a.dispose(),Promise.reject(n)))}}e.$Njc=N}),define(Pe[289],Me([1,0,18,257,34,96,28,12,19,24,15,16,2,95,184,46,13,47,107,285,44]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=void 0,e.$VL=I;let h=class{constructor(D,y,P,A,G){this.a=D,this.b=y,this.c=P,this.d=A,this.e=G}text(D,y,P={}){D=this.f(D,P);const A=this.a.getValue(),G=y&&y.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(y?.map(r.$Bi),P),type:2,contentPattern:D,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:A.search.usePCRE2||G||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(D,y){const P=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const A={...D,wordSeparators:P.editor.wordSeparators};return this.j(D,y)&&(A.isCaseSensitive=!0),this.k(D)&&(A.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),A}file(D,y={}){return{...this.h(D,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(D,y){return D?(D=Array.isArray(D)?D.map(v):v(D),y?this.parseSearchPaths(D):{pattern:p(...Array.isArray(D)?D:[D])}):{}}h(D=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),A=this.g(y.excludePattern,y.expandPatterns),G=D.length>1,W=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,y,A)):D.map(T=>this.r(T,y,A,G))).filter(T=>!!T),U={_reason:y._reason,folderQueries:W,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:A.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=S.$Hb(S.$Rb(this.c.groups.map(ce=>ce.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const q=T.filter(ce=>(0,c.$BK)(U,ce.fsPath)),ne=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ne)),{...U,...ne}}const C=y.extraFileResources&&y.extraFileResources.filter(T=>(0,c.$BK)(U,T.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(D){const y=[],P=new R.$Ac,A={};let G=!1;return D.forEach(W=>{if(W.scheme===m.Schemas.walkThrough)return;if((0,k.$Xg)(W)){const C=this.b.getWorkspaceFolder(W)?.uri??W.with({path:f.$mc(W.fsPath)});let T=P.get(C);T||(G=!0,T={folder:C,includePattern:{}},y.push(T),P.set(C,T));const q=f.$lc(C.fsPath,W.fsPath);(0,E.$5f)(T.includePattern)[q.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,A[W.fsPath]=!0)}),{folderQueries:y,includePattern:A,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(D,y){if(y.isSmartCase){if(D.isRegExp){if(N.$Kf(D.pattern,!0))return!0}else if(N.$Kf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,w.$kC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const y=ne=>f.$ic(ne)||/^\.\.?([\/\\]|$)/.test(ne),A=(Array.isArray(D)?D:u(D)).map(ne=>{const ce=this.e.resolvedUserHome;return ce?(0,O.$fw)(ne,ce.scheme===m.Schemas.file?ce.fsPath:ce.path):ne}),G=F.$K(A,ne=>y(ne)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(ne=>N.$5e(ne,"/")).map(ne=>N.$5e(ne,"\\")).map(ne=>(ne[0]==="."&&(ne="*"+ne),o(ne))),U={},C=this.m(G.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const T=S.$Rb(W),q=p(...T);return q&&(U.pattern=q),U}l(D,y){return y.disregardExcludeSettings?void 0:(0,c.$AK)(D,!y.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const y=D.flatMap(A=>{let{pathPortion:G,globPortion:W}=t(A);return W&&(W=b(W)),this.n(G).flatMap(C=>this.o(C,W))}),P=new Map;return y.forEach(A=>{const G=A.searchPath.toString(),W=P.get(G);W?A.pattern&&(W.pattern=W.pattern||{},W.pattern[A.pattern]=!0):P.set(G,{searchPath:A.searchPath,pattern:A.pattern?p(A.pattern):void 0})}),Array.from(P.values())}n(D){if(f.$ic(D)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:D})}]:[{searchPath:l.URI.file(f.$hc(D))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(D=v(D),D.startsWith("../")||D===".."){const A=f.$gc.resolve(y.path,D);return[{searchPath:y.with({path:A})}]}const P=b(D);return[{searchPath:y,pattern:P}]}else{if(D==="./"||D===".\\")return[];{const y=D.replace(/^\.[\/\\]/,""),A=this.b.getWorkspace().folders.map(G=>{const W=y.match(new RegExp(`^${N.$Ye(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(E.$2f);if(A.length)return A.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&b(W)}});{const G=D.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:D,U=d.localize(0,null,W);throw new Error(U)}}}}o(D,y){const P=D.pattern&&y?`${D.pattern}/${y}`:D.pattern||y,A=[{searchPath:D.searchPath,pattern:P}];return P&&!P.endsWith("**")&&A.push({searchPath:D.searchPath,pattern:P+"/**"}),A}q(D,y,P){const A=this.r((0,r.$Bi)(D.searchPath),y,P,!1);return A?{...A,includePattern:D.pattern}:null}r(D,y,P,A){let G;const W=l.URI.isUri(D)?D:D.uri;if(P.searchPaths){const ne=P.searchPaths.filter(ce=>(0,k.$Mg)(ce.searchPath,W))[0];if(ne&&!ne.pattern)return null;ne&&(G=ne.pattern)}const U=this.a.getValue({resource:W}),T={...this.l(U,y)||{},...G||{}},q=l.URI.isUri(D)?(0,k.$Qg)(D):D.name;return{folder:W,folderName:A?q:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!U.search.followSymlinks}}};e.$UL=h,e.$UL=h=Je([qe(0,s.$Mi),qe(1,r.$pi),qe(2,i.$rD),qe(3,a.$Mj),qe(4,n.$SL)],h);function t(g){const D=g.match(/[\*\{\}\(\)\[\]\?]/);if(D){const y=D.index,P=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let A=g.substr(0,P.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function p(...g){return g.length?g.reduce((D,y)=>(D[y]=!0,D),Object.create(null)):void 0}function u(g){return M.$$j(g,",").map(D=>D.trim()).filter(D=>!!D.length)}function o(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function v(g){return g.replace(/\\/g,"/")}function b(g){return v(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(g){return g.replace(/([?*[\]])/g,"[$1]")}function I(g,D){g=S.$Mb(g,A=>A.toString());const y=[],P=D.getWorkspace();return g&&g.forEach(A=>{let G;if(D.getWorkbenchState()===2)G=(0,k.$Vg)(P.folders[0].uri,A),G&&G!=="."&&(G="./"+G);else{const W=D.getWorkspaceFolder(A);if(W){const U=W.name;if(P.folders.filter(T=>T.name===U).length===1){const T=(0,k.$Vg)(W.uri,A);T===""?G=`./${W.name}`:G=`./${W.name}/${T}`}else G=A.fsPath}}G&&y.push($(G))}),y}}),define(Pe[290],Me([1,0,24,2,25,14,3,289,44,47,11]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jub=l,e.$Kub=s;const E=7e3;function l(a,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const v of i)if(/^workspaceContains:/.test(v)){const b=v.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||a.forceUsingSearch?c.push(b):n.push(b)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,N.$_g)(),p=v=>t({activationEvent:v}),u=Promise.all(n.map(v=>w(a,v,p))).then(()=>{}),o=d(a,r.identifier,c,p);return Promise.all([u,o]).then(()=>{t(void 0)}),h}async function w(a,r,i){for(const n of a.folders)if(await a.exists(S.$Tg(F.URI.revive(n),r))){i(`workspaceContains:${r}`);return}}async function d(a,r,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new M.$de,h=a.checkExists(a.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),a.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},E);let p=!1;try{p=await h}catch(u){O.$4(u)||O.$1(u)}c.dispose(),clearTimeout(t),p&&n(`workspaceContains:${i.join(",")}`)}function s(a,r,i,n){const c=a.get(R.$fi),h=a.get(f.$sK),p=c.createInstance(m.$UL).file(r.map(u=>(0,k.$Bi)(F.URI.revive(u))),{_reason:"checkExists",includePattern:i,exists:!0});return h.fileSearch(p,n).then(u=>!!u.limitHit,u=>O.$4(u)?!1:Promise.reject(u))}}),define(Pe[38],Me([1,0,163,19,89,24,11,6,50,2,13,4,37,222,82,36,22,108,14,20,23,205,7,102,3,27,85,17,71,86,66,88,5,290,81,207,12,79,64,21,80]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p,u,o,v,b,$,I,g,D,y,P,A,G,W,U,C,T,q){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=e.$rjc=e.$qjc=e.$pjc=void 0,e.$pjc=(0,u.$gi)("IHostUtils");let ce=ne=class extends m.$Tc{constructor(V,ee,ke,Ne,Se,be,ge,J,Z,he,fe,Te,de){super(),this.X=Te,this.Y=de,this.a=this.B(new y.$6d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ee,this.g=ke,this.f=ge,this.j=Ne,this.m=Se,this.s=be,this.t=Z,this.u=he,this.w=fe,this.y=this.g.getProxy(E.$eM.MainThreadWorkspace),this.z=this.g.getProxy(E.$eM.MainThreadTelemetry),this.C=this.g.getProxy(E.$eM.MainThreadExtensionService),this.D=new R.$fh,this.F=new R.$fh,this.G=new R.$fh,this.H=new R.$fh,this.I=new ie(this.f.extensions.activationEvents),this.L=new r.$n0b(this.I,this.f.extensions.allExtensions);const Ce=new n.$Cm(this.f.extensions.myExtensions);this.J=new r.$n0b(this.I,re(this.L,Ce)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new d.$ajc(this.g,this.s),this.N=new A.$ijc(this.g),this.O=J,this.h=V.createChild(new $.$ei([d.$bjc,this.M],[A.$jjc,this.N])),this.P=this.B(new w.$_ic(this.J,this.L,{onExtensionActivationError:(Re,je,z)=>{this.C.$onExtensionActivationError(Re,i.$3(je),z)},actualActivateExtension:async(Re,je)=>{if(r.$n0b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,je),new w.$$ic;const z=this.J.getExtensionDescription(Re);return this.eb(z,je)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(V){i.$1(V)}}async Z(){this.O.onWillDeactivateAll();let V=[];try{V=this.J.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this.db(Se))}catch{}await Promise.all(V)}terminate(V,ee=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${V}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ne=>{this.s.error(Ne)}),this.g.dispose();const ke=this.Z();Promise.race([(0,R.$hh)(5e3),ke]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ee}`):this.s.info(`Extension host exiting with code ${ee}`),this.s.flush(),this.s.dispose(),this.c.exit(ee)})}isActivated(V){return this.G.isOpen()?this.P.isActivated(V):!1}async getExtension(V){const ee=await this.C.$getExtension(V);return ee&&{...ee,identifier:new n.$Bm(ee.identifier.value),extensionLocation:k.URI.revive(ee.extensionLocation)}}$(V,ee){return this.P.activateByEvent(V,ee)}ab(V,ee){return this.P.activateById(V,ee)}activateByIdWithErrors(V,ee){return this.ab(V,ee).then(()=>{const ke=this.P.getActivatedExtension(V);if(ke.activationFailed)return Promise.reject(ke.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(V=>this.J)}getExtensionExports(V){if(this.G.isOpen())return this.P.getActivatedExtension(V).exports;try{return this.P.getActivatedExtension(V).exports}catch{return null}}async bb(V){if(V.scheme===W.Schemas.file&&this.c.fsRealpath){const ee=await this.c.fsRealpath(V.fsPath);return k.URI.file(ee)}return V}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(V=>new $e(V))),this.Q}async cb(V){const ee=f.$mi.forUris(ke=>O.$Kg.ignorePathCasing(ke));return await Promise.all(V.map(async ke=>{if(this.vb(ke)){const Ne=await this.bb(ke.extensionLocation);ee.set(Ne,ke)}})),ee}db(V){let ee=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(V))return ee;const ke=this.P.getActivatedExtension(V);if(!ke)return ee;try{typeof ke.module.deactivate=="function"&&(ee=Promise.resolve(ke.module.deactivate()).then(void 0,Ne=>(this.s.error(Ne),Promise.resolve(void 0))))}catch(Ne){this.s.error(`An error occurred when deactivating the extension '${V.value}':`),this.s.error(Ne)}try{(0,m.$Oc)(ke.subscriptions)}catch(Ne){this.s.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this.s.error(Ne)}return ee}async eb(V,ee){return this.f.remote.isRemote?this.C.$onWillActivateExtension(V.identifier):await this.C.$onWillActivateExtension(V.identifier),this.gb(V,ee).then(ke=>{const Ne=ke.activationTimes;return this.C.$onDidActivateExtension(V.identifier,Ne.codeLoadingTime,Ne.activateCallTime,Ne.activateResolvedTime,ee),this.fb(V,ee,"success",Ne),ke},ke=>{throw this.fb(V,ee,"failure"),ke})}fb(V,ee,ke,Ne){const Se=Ie(V,ee);this.z.$publicLog2("extensionActivationTimes",{...Se,...Ne||{},outcome:ke})}gb(V,ee){const ke=Ie(V,ee);this.z.$publicLog2("activatePlugin",ke);const Ne=this.vb(V);if(!Ne)return Promise.resolve(new w.$0ic(w.$7ic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${V.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this.s.flush();const Se=new w.$8ic(ee.startup);return Promise.all([this.wb(V,(0,O.$Tg)(V.extensionLocation,Ne),Se),this.hb(V)]).then(be=>(M.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),ne.ib(this.s,V.identifier,be[0],be[1],Se))).then(be=>(M.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),be))}hb(V){const ee=this.Y.createLanguageModelAccessInformation(V),ke=new h.$djc(V,this.M),Ne=new h.$cjc(V.identifier.value,!1,this.M),Se=new G.$kjc(V,this.N),be=V.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([ke.whenReady,Ne.whenReady,this.O.whenReady]).then(()=>{const J=this;let Z,he;const fe=(0,a.$3F)(V,"ipc")?this.f.messagePorts?.get(n.$Bm.toKey(V.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:Ne,secrets:Se,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Te){return F.$jc(V.extensionLocation.fsPath,Te)},get storagePath(){return J.O.workspaceValue(V)?.fsPath},get globalStoragePath(){return J.O.globalValue(V).fsPath},get logPath(){return F.$jc(J.f.logsLocation.fsPath,V.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,V.identifier.value)},get storageUri(){return J.O.workspaceValue(V)},get globalStorageUri(){return J.O.globalValue(V)},get extensionMode(){return be},get extension(){return Z===void 0&&(Z=new ve(J,V.identifier,V,ge,!1)),Z},get extensionRuntime(){return(0,a.$4F)(V,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!he){if(!fe)return;const Te=y.Event.buffer(y.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),he={onDidReceiveMessage:Te,postMessage:fe.postMessage.bind(fe)}}return he}})})}static ib(V,ee,ke,Ne,Se){return ke=ke||{activate:void 0,deactivate:void 0},this.jb(V,ee,ke,Ne,Se).then(be=>new w.$9ic(!1,null,Se.build(),ke,be,Ne.subscriptions))}static jb(V,ee,ke,Ne,Se){if(typeof ke.activate=="function")try{Se.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const be=typeof global=="object"?global:self,ge=ke.activate.apply(be,[Ne]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(ge).then(J=>(Se.activateResolveStop(),J))}catch(be){return Promise.reject(be)}else return Promise.resolve(ke)}kb(V,ee){this.ab(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:ee}).then(void 0,ke=>{this.s.error(ke)})}lb(V,ee=0){const Ne=Date.now();(0,T.$B)(()=>{for(let Se=ee;Se<V.length;Se+=1){const be=V[Se];for(const ge of be.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Ne>50){this.lb(V,Se);break}else this.kb(be,ge)}})}mb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(V=>{const ee=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ke=this.J.getAllExtensionDescriptions();if(ee)this.lb(ke);else for(const Ne of ke)if(Ne.activationEvents)for(const Se of Ne.activationEvents)Se==="onStartupFinished"&&this.kb(Ne,Se)})}nb(){const V=this.$("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.ob(be.added)));const ee=this.j.workspace?this.j.workspace.folders:[],ke=this.ob(ee),Ne=this.qb(),Se=Promise.all([Ne,V,ke]).then(()=>{});return Promise.race([Se,(0,R.$hh)(1e4)]).then(()=>{this.mb()}),Se}ob(V){return V.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ee=>this.pb(V,ee))).then(()=>{})}async pb(V,ee){if(this.isActivated(ee.identifier))return;const ke=!this.f.remote.isRemote&&!!this.f.remote.authority,Ne={logService:this.s,folders:V.map(be=>be.uri),forceUsingSearch:ke||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,ge,J)=>this.y.$checkExists(be,ge,J)},Se=await(0,P.$Jub)(Ne,ee);if(Se)return this.ab(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Se.activationEvent}).then(void 0,be=>this.s.error(be))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(V){throw console.error(V),V}}async rb(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:ee}=this.f.environment;if(!V||!ee)throw new Error(S.localize(0,null));const ke=await this.wb(null,ee,new w.$8ic(!1));if(!ke||typeof ke.run!="function")throw new Error(S.localize(1,null,ee.toString()));return new Promise((Ne,Se)=>{const be=(Z,he)=>{Z?(T.$t&&this.s.error("Test runner called back with error",Z),Se(Z)):(T.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Ne(typeof he=="number"&&he>0?1:0))},ge=(0,O.$Hg)(ee),J=ke.run(ge,be);J&&J.then&&J.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Ne(0)}).catch(Z=>{T.$t&&this.s.error("Test runner finished with error",Z),Se(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$hh)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,ee){return this.R[V]=ee,(0,m.$Rc)(()=>{delete this.R[V]})}async getRemoteExecServer(V){const{resolver:ee}=await this.tb(V);return ee?.resolveExecServer?.(V,{resolveAttempt:0})}async tb(V){const ee=V.indexOf("+");if(ee===-1)throw new t.$mM("Not an authority that can be resolved!",p.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ke=V.substr(0,ee);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ke}`,!1),{authorityPrefix:ke,resolver:this.R[ke]}}async $resolveAuthority(V,ee){const ke=C.$2d.create(!1),Ne=()=>`[resolveAuthority(${(0,p.$vl)(V)},${ee})][${ke.elapsed()}ms] `,Se=j=>this.s.info(`${Ne()}${j}`),be=j=>this.s.warn(`${Ne()}${j}`),ge=(j,K=void 0)=>this.s.error(`${Ne()}${j}`,K),J=j=>{if(j instanceof t.$mM)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Z=async j=>{Se(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:H}=await this.tb(j);if(!K)throw ge(`no resolver for ${H}`),new t.$mM(`No remote extension installed to resolve ${H}.`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:j}},he=V.split(/@|%40/g).reverse();Se(`activating remote resolvers ${he.join(" -> ")}`);let fe;try{fe=await Promise.all(he.map(Z)).catch(async j=>{if(!(j instanceof t.$mM)||j._code!==p.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return be(`resolving nested authorities failed: ${j.message}`),[await Z(V)]})}catch(j){return J(j)}const Te=new R.$rh;Te.cancelAndSet(()=>Se("waiting..."),1e3);let de,Ce;for(const[j,{authorityPrefix:K,resolver:H,remoteAuthority:_}]of fe.entries())try{if(j===fe.length-1)Se("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${K}`),de=await H.resolve(_,{resolveAttempt:ee,execServer:Ce}),M.mark(`code/extHost/didResolveAuthorityOK/${K}`),Se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$lM.isManagedResolvedAuthority(de)?de:void 0));else{if(Se(`invoking resolveExecServer() for ${_}`),M.mark(`code/extHost/willResolveExecServer/${K}`),Ce=await H.resolveExecServer?.(_,{resolveAttempt:ee,execServer:Ce}),!Ce)throw new t.$mM(`Exec server was not available for ${_}`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(se){return M.mark(`code/extHost/didResolveAuthorityError/${K}`),ge("returned an error",se),Te.dispose(),J(se)}Te.dispose();const Re={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};Se(`returned ${t.$lM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(t.$lM.isManagedResolvedAuthority(de)){const j=ee;this.X.setFactory(j,de.makeConnection),z={authority:V,connectTo:new p.$sl(j),connectionToken:de.connectionToken}}else z={authority:V,connectTo:new p.$tl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:je,tunnelInformation:Re}}}async $getCanonicalURI(V,ee){this.s.info(`$getCanonicalURI invoked for authority (${(0,p.$vl)(V)})`);const{resolver:ke}=await this.tb(V);if(!ke)return null;const Ne=k.URI.revive(ee);if(typeof ke.getCanonicalURI>"u")return Ne;const Se=await(0,R.$$g)(()=>ke.getCanonicalURI(Ne));return Se||Ne}$startExtensionHost(V){V.toAdd.forEach(Ne=>Ne.extensionLocation=k.URI.revive(Ne.extensionLocation));const{globalRegistry:ee,myExtensions:ke}=ye(this.I,this.L,this.J,V);return this.L.set(ee.getAllExtensionDescriptions()),this.J.set(ke),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.sb()}$activateByEvent(V,ee){return ee===1?this.D.wait().then(ke=>this.$(V,!1)):this.G.wait().then(ke=>this.$(V,!1))}async $activate(V,ee){return await this.G.wait(),this.J.getExtensionDescription(V)?(await this.ab(V,ee),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(be=>be.extensionLocation=k.URI.revive(be.extensionLocation));const{globalRegistry:ee,myExtensions:ke}=ye(this.I,this.L,this.J,V),Ne=await this.cb(ke);return(await this.getExtensionPathIndex()).setSearchTree(Ne),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(ke),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const ee=c.$te.alloc(V),ke=Math.random()%256;for(let Ne=0;Ne<V;Ne++)ee.writeUInt8(ke,Ne);return ee}async $updateRemoteConnectionData(V){this.W=V,this.a.fire()}};e.$qjc=ce,e.$qjc=ce=ne=Je([qe(0,u.$fi),qe(1,e.$pjc),qe(2,b.$xO),qe(3,s.$Pic),qe(4,l.$Sic),qe(5,N.$Mj),qe(6,o.$NO),qe(7,v.$Vic),qe(8,I.$OAb),qe(9,g.$ejc),qe(10,U.$mjc),qe(11,q.$njc),qe(12,D.$Fic)],ce);function ye(le,V,ee,ke){le.addActivationEvents(ke.addActivationEvents);const Ne=new r.$n0b(le,V.getAllExtensionDescriptions());Ne.deltaExtensions(ke.toAdd,ke.toRemove);const Se=new n.$Cm(ee.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ke.myToRemove)Se.delete(ge);for(const ge of ke.myToAdd)Se.add(ge);const be=re(Ne,Se);return{globalRegistry:Ne,myExtensions:be}}function Ie(le,V){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}function ue(le){return le.getAllExtensionDescriptions().map(V=>V.identifier.value).join(",")}e.$rjc=(0,u.$gi)("IExtHostExtensionService");class ve{#e;#t;#i;constructor(V,ee,ke,Ne,Se){this.#e=V,this.#t=ee,this.#i=ke.identifier,this.id=ke.identifier.value,this.extensionUri=ke.extensionLocation,this.extensionPath=F.$hc((0,O.$Hg)(ke.extensionLocation)),this.packageJSON=ke,this.extensionKind=Ne,this.isFromDifferentExtensionHost=Se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$sjc=ve;function re(le,V){return le.getAllExtensionDescriptions().filter(ee=>V.has(ee.identifier))}class $e{constructor(V){this.a=V}setSearchTree(V){this.a=V}findSubstr(V){return this.a.findSubstr(V)}forEach(V){return this.a.forEach(V)}}e.$tjc=$e;class ie{constructor(V){this.a=new n.$Dm,this.addActivationEvents(V)}readActivationEvents(V){return this.a.get(V.identifier)??[]}addActivationEvents(V){for(const ee of Object.keys(V))this.a.set(ee,V[ee])}}}),define(Pe[291],Me([1,0,89,2,4,37,22,20,17,27,3,38,13,15]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;let s=class{constructor(c,h,t,p,u,o,v){this.c=c,this.d=h,this.e=t,this.f=p,this.g=u,this.h=o,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Bkc=s,e.$Bkc=s=Je([qe(2,N.$fi),qe(3,O.$Sic),qe(4,E.$rjc),qe(5,k.$NO),qe(6,l.$Mj)],s);let a=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&d.a.size){const h=(0,w.$Ye)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",p=`@${t}+\\/${t}+|${t}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${p})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,p,u]=h,o=d.a.get(p);if(o!==void 0)return console.warn(`${p} as been renamed to ${o}, please update your imports`),t+o+u}c(c){return c.replace(/\\/g,"/")}};a=d=Je([qe(0,k.$NO)],a);class r{constructor(c,h,t,p,u){this.c=c,this.d=h,this.e=t,this.f=p,this.g=u,this.nodeModuleName="vscode",this.a=new m.$Dm}load(c,h){const t=this.d.findSubstr(h);if(t){let p=this.a.get(t.identifier);return p||(p=this.c(t,this.e,this.f),this.a.set(t.identifier,p)),p}if(!this.b){let p="";this.d.forEach((u,o)=>p+=`	${o} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${p}`),this.b=this.c(R.$XF,this.e,this.f)}return this.b}}let i=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$eM.MainThreadTelemetry);const p=t.getProxy(M.$eM.MainThreadWindow);this.c=(u,o)=>{const v=F.URI.parse(u);return o?this.g(u,o):v.scheme==="http"||v.scheme==="https"?p.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?p.$openUri(v,u,{}):this.g(u,o)}}load(c,h,t){const p=this.e.findSubstr(h);return p&&(this.a=p.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([qe(2,f.$xO)],i)}),define(Pe[119],Me([1,0,39,6,19,73,3,67,65,38,7,36,219,37]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0,e.$ujc=(0,R.$gi)("IExtHostVariableResolverProvider");class d extends l.$zP{constructor(r,i,n,c,h,t,p){function u(){if(n){const o=n.activeEditor();if(o)return o.document.uri;const v=c.tabGroups.all.find(b=>b.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof N.$3N||v.input instanceof N.$8N)return v.input.modified;if(v.input instanceof N.$2N||v.input instanceof N.$7N||v.input instanceof N.$5N)return v.input.uri}}}super({getFolderUri:o=>{const v=t.folders.filter(b=>b.name===o);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,v)=>h.getConfiguration(void 0,o).get(v),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=u();if(o)return M.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const o=u();if(o){const v=i.getWorkspaceFolder(o);if(v)return M.$hc(v.uri.fsPath)}}},getSelectedText:()=>{if(n){const o=n.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(n){const o=n.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>r.getExtension(o)},void 0,p?Promise.resolve(p):void 0,Promise.resolve(O.env))}}let s=class extends F.$Tc{constructor(r,i,n,c,h){super(),this.b=r,this.c=i,this.g=n,this.h=c,this.j=h,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$vjc=s,e.$vjc=s=Je([qe(0,k.$rjc),qe(1,E.$Pic),qe(2,m.$IO),qe(3,w.$Sic),qe(4,f.$5ic)],s)}),define(Pe[120],Me([1,0,11,5,2,20,3,4,65,38,17,7,36,211,213,37,119,6,40,31,8]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=e.$zjc=e.$yjc=e.$xjc=e.$wjc=void 0,e.$wjc=(0,R.$gi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,I,g,D,y,P,A){this.N=I,this.O=g,this.P=D,this.Q=y,this.R=P,this.S=A,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$6d,this.o=new F.$6d,this.q=new F.$6d,this.w=new F.$6d,this.l=$.getProxy(m.$eM.MainThreadDebugService),this.A=new F.$6d,this.C=new F.$6d,this.y=new p(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(W=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem($,I){const g=this.W(I);if(!g)return;const D=await this.H.get($)?.getTreeItem?.(g);return D?this.U($,D):void 0}registerDebugVisualizationTree($,I,g){const D=O.$Bm.toKey($.identifier),y=this.jb(D,I);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(y,g),this.l.$registerDebugVisualizerTree(y,!!g.editItem),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(I)})}async $getVisualizerTreeItemChildren($,I){const g=this.J.get(I)?.item;return g?(await this.H.get($)?.getChildren?.(g))?.map(y=>this.U($,y))||[]:[]}async $editVisualizerTreeItem($,I){const g=this.J.get($);if(!g)return;const D=await this.H.get(g.provider)?.editItem?.(g.item,I);return this.U(g.provider,D||g.item)}$disposeVisualizedTree($){const I=this.J.get($);if(!I)return;const g=[I.children];for(const D of g)if(D)for(const y of D)g.push(this.J.get(y)?.children),this.J.delete(y)}U($,I){let g=this.I.get(I);return g||(g=this.F++,this.I.set(I,g),this.J.set(g,{provider:$,item:I})),c.DebugTreeItem.from(I,g)}asDebugSourceUri($,I){const g=$;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let D=`debug:${encodeURIComponent(g.path||"")}`,y="?";return I&&(D+=`${y}session=${encodeURIComponent(I.id)}`,y="&"),D+=`${y}ref=${g.sourceReference}`,M.URI.parse(D)}else{if(g.path)return M.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const I=[];for(const g of $.getAllExtensionDescriptions())if(g.contributes){const D=g.contributes.debuggers;if(D&&D.length>0)for(const y of D)(0,d.$CG)(y)&&I.push(y.type)}this.l.$registerDebugTypes(I)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(I=>$.push(I)),$}async $resolveDebugVisualizer($,I){const g=this.L.get($);if(!g)throw new Error(`No debug visualizer found with id '${$}'`);let{v:D,provider:y,extensionId:P}=g;if(D.visualization||(D=await y.resolveDebugVisualization?.(D,I)||D,g.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,D.visualization)}async $executeDebugVisualizerCommand($){const I=this.L.get($);if(!I)throw new Error(`No debug visualizer found with id '${$}'`);const g=I.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W($){const I=this.m.get($.sessionId);return I&&{session:I.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,I,g,D){const y=this.W(g),P=this.jb($,I),A=this.G.get(P);if(!y||!A)return[];const G=await A.provideDebugVisualization(y,D);return G?G.map(W=>{const U=++this.M;this.L.set(U,{v:W,provider:A,extensionId:$});const C=W.iconPath?this.lb(W.iconPath):void 0;return{id:U,name:W.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb($,W.visualization)}}):[]}$disposeDebugVisualizers($){for(const I of $)this.L.delete(I)}registerDebugVisualizationProvider($,I,g){if(!$.contributes?.debugVisualizers?.some(P=>P.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const D=O.$Bm.toKey($.identifier),y=this.jb(D,I);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(y,g),this.l.$registerDebugVisualizer(D,I),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizer(D,I),this.G.delete(I)})}addBreakpoints($){const I=$.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(I,[],[]);const g=[],D=new Map;for(const y of I)if(y instanceof E.$hN){let P=D.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},D.set(y.location.uri.toString(),P),g.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof E.$iN&&g.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints($){const I=$.filter(P=>this.z.delete(P.id));this.gb([],I,[]);const g=I.filter(P=>P instanceof E.$hN).map(P=>P.id),D=I.filter(P=>P instanceof E.$iN).map(P=>P.id),y=I.filter(P=>P instanceof E.$jN).map(P=>P.id);return this.l.$unregisterBreakpoints(g,D,y)}startDebugging($,I,g){return this.l.$startDebugging($?$.uri:void 0,I,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,I,g){if(!I)return new E.$gM(()=>{});const D=this.d++;return this.f.push({type:$,handle:D,provider:I}),this.l.$registerDebugConfigurationProvider($,g,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,D),new E.$gM(()=>{this.f=this.f.filter(y=>y.provider!==I),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory($,I,g){if(!g)return new E.$gM(()=>{});if(!this.cb($,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:I,handle:D,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(I,D),new E.$gM(()=>{this.h=this.h.filter(y=>y.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory($,I){if(!I)return new E.$gM(()=>{});const g=this.j++;return this.k.push({type:$,handle:g,factory:I}),new E.$gM(()=>{this.k=this.k.filter(D=>D.factory!==I)})}async $runInTerminal($,I){return Promise.resolve(void 0)}async $substituteVariables($,I){let g;const D=await this.ib($);return D&&(g={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,I)}X($,I){if($.type==="implementation")return new o($.implementation)}Y(){}async $startDASession($,I){const g=this,D=await this.hb(I);return this.eb(this.$(D.type),D).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const P=this.Z(y),A=this.X(P,D);if(!A)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const G=A;return this.D.set($,G),this.db(D).then(W=>(W&&this.E.set($,W),G.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,T={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const q=await this.K.sign(C.arguments.value);T.body={signature:q},G.sendResponse(T)}else throw new Error("no signer")}catch(q){T.success=!1,T.message=q.message,G.sendResponse(T)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(U),U=(0,d.$HG)(U,!0),g.l.$acceptDAMessage($,U)}),G.onError(U=>{W&&W.onError&&W.onError(U),this.l.$acceptDAError($,U.name,U.message,U.stack)}),G.onExit(U=>{W&&W.onExit&&W.onExit(U??void 0,void 0),this.l.$acceptDAExit($,U??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),G.startSession()))})}$sendDAMessage($,I){I=(0,d.$GG)(I,!1);const g=this.E.get($);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(I),this.D.get($)?.sendMessage(I)}$stopDASession($){const I=this.E.get($);this.E.delete($),I&&I.onWillStopSession&&I.onWillStopSession();const g=this.D.get($);return this.D.delete($),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const I=[],g=[],D=[];if($.added)for(const y of $.added){const P=y.id;if(P&&!this.z.has(P)){let A;if(y.type==="function")A=new E.$iN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")A=new E.$jN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const G=M.URI.revive(y.uri);A=new E.$hN(new E.$sM(G,new E.$hM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,E.$fN)(A,P),this.z.set(P,A),I.push(A)}}if($.removed)for(const y of $.removed){const P=this.z.get(y);P&&(this.z.delete(y),g.push(P))}if($.changed){for(const y of $.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof E.$iN&&y.type==="function"){const A=P;A.enabled=y.enabled,A.condition=y.condition,A.hitCondition=y.hitCondition,A.logMessage=y.logMessage,A.functionName=y.functionName}else if(P instanceof E.$hN&&y.type==="source"){const A=P;A.enabled=y.enabled,A.condition=y.condition,A.hitCondition=y.hitCondition,A.logMessage=y.logMessage,A.location=new E.$sM(M.URI.revive(y.uri),new E.$hM(y.line,y.character))}D.push(P)}}}this.gb(I,g,D)}async $acceptStackFrameFocus($){let I;if($){const g=await this.hb($.sessionId);$.kind==="thread"?I=new E.$pN(g.api,$.threadId):I=new E.$oN(g.api,$.threadId,$.frameId)}this.B=I,this.C.fire(this.B)}$provideDebugConfigurations($,I,g){return(0,S.$$g)(async()=>{const D=this.bb($);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(I);return D.provideDebugConfigurations(y,g)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration($,I,g,D){return(0,S.$$g)(async()=>{const y=this.bb($);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(I);return y.resolveDebugConfiguration(P,g,D)})}$resolveDebugConfigurationWithSubstitutedVariables($,I,g,D){return(0,S.$$g)(async()=>{const y=this.bb($);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(I);return y.resolveDebugConfigurationWithSubstitutedVariables(P,g,D)})}async $provideDebugAdapter($,I){const g=this.ab($);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(I);return this.eb(g,D).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted($){const I=await this.hb($);this.n.fire(I.api)}async $acceptDebugSessionTerminated($){const I=await this.hb($);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,I){(await this.hb($))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent($,I){const D={session:(await this.hb($)).api,event:I.event,body:I.body};this.w.fire(D)}Z($){if($ instanceof E.$kN)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof E.$lN)return{type:"server",port:$.port,host:$.host};if($ instanceof E.$mN)return{type:"pipeServer",path:$.path};if($ instanceof E.$nN)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const I=this.h.filter(g=>g.type===$);if(I.length>0)return I[0].factory}ab($){const I=this.h.filter(g=>g.handle===$);if(I.length>0)return I[0].factory}bb($){const I=this.f.filter(g=>g.handle===$);if(I.length>0)return I[0].provider}cb($,I){if($.contributes){const g=$.contributes.debuggers;if(g&&g.length>0){for(const D of g)if(D.label&&D.type&&D.type===I)return!0}}return!1}db($){const g=$.configuration.type,D=this.k.filter(y=>y.type===g||y.type==="*").map(y=>(0,S.$$g)(()=>y.factory.createDebugAdapterTracker($.api)).then(P=>P,P=>null));return Promise.race([Promise.all(D).then(y=>{const P=y.filter(A=>!!A);if(P.length>0)return new u(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb($,I){const g=I.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new E.$lN(g));if($){const y=await this.O.getExtensionRegistry();return(0,S.$$g)(()=>$.createDebugAdapterDescriptor(I.api,this.fb(I,y))).then(P=>{if(P)return P})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,D))}fb($,I){}gb($,I,g){($.length>0||I.length>0||g.length>0)&&this.A.fire(Object.freeze({added:$,removed:I,changed:g}))}async hb($){if($)if(typeof $=="string"){const I=this.m.get($);if(I)return I}else{let I=this.m.get($.id);if(!I){const g=await this.ib($.folderUri),D=$.parent?this.m.get($.parent):void 0;I=new t(this.l,$.id,$.type,$.name,g,$.configuration,D?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib($){if($){const I=M.URI.revive($);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb($,I){return`${$}\0${I}`}kb($,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${$}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const I=this.mb($);let g,D;return"id"in I?D=i.ThemeIcon.asClassName(I):g=I,{iconPath:g,iconClass:D}}mb($){if($ instanceof E.$cN)return{id:$.id};const I=typeof $=="object"&&"dark"in $?$.dark:$,g=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof I=="string"?M.URI.file(I):I,light:typeof g=="string"?M.URI.file(g):g}}};e.$xjc=h,e.$xjc=h=Je([qe(0,N.$xO),qe(1,l.$Pic),qe(2,k.$rjc),qe(3,s.$Sic),qe(4,f.$5ic),qe(5,a.$ujc),qe(6,n.$TO)],h);class t{constructor($,I,g,D,y,P,A){this.f=$,this.g=I,this.h=g,this.j=D,this.k=y,this.l=P,this.m=A}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(I){$.j=I,$.f.$setDebugSessionName($.g,I)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(I,g){return $.f.$customDebugAdapterRequest($.g,I,g)},getDebugProtocolBreakpoint(I){return $.f.$getDebugProtocolBreakpoint($.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$yjc=t;class p{constructor($){this.value=Object.freeze({append(I){$.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$zjc=p;class u{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(I=>I.onError?I.onError($):void 0)}onExit($,I){this.d.forEach(g=>g.onExit?g.onExit($,I):void 0)}}class o extends w.$3nb{constructor($){super(),this.h=$,$.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor($,I,g,D,y,P,A){super($,I,g,D,y,P,A)}};e.$Ajc=v,e.$Ajc=v=Je([qe(0,N.$xO),qe(1,l.$Pic),qe(2,k.$rjc),qe(3,s.$Sic),qe(4,f.$5ic),qe(5,a.$ujc),qe(6,n.$TO)],v)}),define(Pe[292],Me([1,0,14,89,2,4,240,13,54,71,27,189,17,59,38,61]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=void 0;class a{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(m.$Mj),t=n.get(l.$xO).getProxy(O.$eM.MainThreadErrors);S.setUnexpectedErrorHandler(p=>{c.error(p);const u=S.$3(p);t.$onUnexpectedError(u)})}static async installFullHandler(n){const c=n.get(m.$Mj),h=n.get(l.$xO),t=n.get(d.$rjc),p=n.get(s.$RO),u=h.getProxy(O.$eM.MainThreadExtensionService),o=h.getProxy(O.$eM.MainThreadErrors),v=await t.getExtensionPathIndex(),b=new WeakMap;function $(D,y){if(b.has(D))return b.get(D).stack;let P="",A,G;for(const U of y)P+=`
	at ${U.toString()}`,G=U.getFileName(),!A&&G&&(A=v.findSubstr(M.URI.file(G)));const W=`${D.name||"Error"}: ${D.message||""}${P}`;return b.set(D,{extensionIdentifier:A?.identifier,stack:W}),W}const I=Symbol("prepareStackTrace wrapped");let g=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(D){if(D===$||!D||D[I]){g=D||$;return}g=function(y,P){return $(y,P),D.call(Error,y,P)},Object.assign(g,{[I]:!0})}}),S.setUnexpectedErrorHandler(D=>{c.error(D);const y=S.$3(D),P=b.get(D);if(!P?.extensionIdentifier){o.$onUnexpectedError(y);return}u.$onExtensionRuntimeError(P.extensionIdentifier,y);const A=p.onExtensionError(P.extensionIdentifier,D);c.trace("forwarded error to extension?",A,P)})}}e.$Ckc=a;class r{constructor(n,c,h,t,p){this.a=h,this.b=new R.$v0b(n,null,t),c=r.e(c,this.b);const u=new k.$ei(...(0,f.$ds)());u.set(N.$NO,{_serviceBrand:void 0,...c,messagePorts:p}),u.set(l.$xO,new l.$yO(this.b)),u.set(w.$Mic,new w.$Nic(t)),u.set(d.$pjc,h);const o=new E.$Uq(u,!0);o.invokeFunction(a.installEarlyHandler),this.d=o.invokeFunction(v=>v.get(m.$Mj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=o.invokeFunction(v=>v.get(d.$rjc)),this.c.initialize(),o.invokeFunction(a.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(O.$eM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=M.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const h=n.environment.extensionDevelopmentLocationURI;return h&&(n.environment.extensionDevelopmentLocationURI=h.map(t=>M.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=M.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$Dkc=r}),define(Pe[293],Me([1,0,18,11,25,41,12,19,24,2,44]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=e.$Pjc=e.$Ojc=void 0,e.$Qjc=s;class E{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],h=new M.$de(n);return new Promise((t,p)=>{this.a=new w(i);let u=!1;const o=(v,b)=>{if(!u&&!this.b){const $=this.h(v);s(v)&&typeof this.g.maxResults=="number"&&this.c+$>this.g.maxResults&&(this.b=!0,u=!0,h.cancel(),v=this.j(v,this.g.maxResults-this.c));const I=this.h(v);this.c+=I,(I>0||!s(v))&&this.a.add(v,b)}};Promise.all(c.map((v,b)=>this.k(v,$=>o($,b),h.token))).then(v=>{h.dispose(),this.a.flush();const b=v.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||b,messages:(0,S.$Rb)(v.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.f}})},v=>{h.dispose();const b=(0,O.$4i)(v);p(new Error(b))})})}h(i){return s(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],h=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:h.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const h=new N.$LK(this.g,i),t=[],p={report:v=>{if(!this.l(v))return;const b=i.folder.scheme===R.Schemas.file?(0,N.$MK)(()=>this.e.readdir(f.$Sg(v.uri))):void 0,$=f.$Vg(i.folder,v.uri);if($){const I=h.includedInQuery($,m.$nc($),b);(0,F.$5g)(I)?t.push(I.then(g=>{g&&n(v)})):I&&n(v)}}},u=this.n(i);let o;return this.d.query.type===3?o=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,u,p,c):o=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),u,p,c),t.length&&await Promise.all(t),o}l(i){if(s(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,N.$KK)(this.g.includePattern,i.includePattern),c=(0,N.$KK)(this.g.excludePattern,i.excludePattern),h={folder:k.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$Ojc=E;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class w{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new a(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!f.$Mg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(d(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Pjc=w;function d(r){return s(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}class a{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Rjc=a}),define(Pe[121],Me([1,0,6,4,3,288,17,59,13,2,293]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=e.$Sjc=void 0,e.$Ujc=l,e.$Sjc=(0,M.$gi)("IExtHostSearch");let E=class{constructor(s,a,r){this.n=s,this.o=a,this.q=r,this.c=this.n.getProxy(F.$eM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Njc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,a){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,a),this.c.$registerTextSearchProvider(r,this.s(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,a){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,a),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,a){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,a),this.c.$registerFileSearchProvider(r,this.s(s)),(0,S.$Rc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,a,r,i){const n=l(r),c=this.j.get(s);if(c)return this.l.fileSearch(n,c,h=>{this.c.$handleFileMatch(s,a,h.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,a,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,a,r,i){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(r);return this.t(c,n).search(t=>this.c.$handleTextMatch(s,a,t),i)}$provideAITextSearchResults(s,a,r,i){const n=this.h.get(s);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(r);return this.v(c,n).search(t=>this.c.$handleTextMatch(s,a,t),i)}$enableExtensionHostSearch(){}t(s,a){return new N.$Ojc({query:s,provider:a},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,a){return new N.$Ojc({query:s,provider:a},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$Tjc=E,e.$Tjc=E=Je([qe(0,R.$xO),qe(1,m.$Mic),qe(2,f.$Mj)],E);function l(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(w),extraFileResources:d.extraFileResources&&d.extraFileResources.map(s=>k.URI.revive(s))}}function w(d){return{...d,folder:k.URI.revive(d.folder)}}}),define(Pe[294],Me([1,0,25,14,5,6,12,32,2,149,145,133,94,20,42,13,57,58,202,4,243,272,78,84,249,228,250,88,251,229,217,31,252,37,253,120,110,254,231,244,255,256,67,65,245,38,258,63,259,43,27,273,274,246,232,260,261,79,80,234,287,263,206,264,275,265,115,235,266,267,268,17,269,121,81,270,236,271,82,85,118,61,66,276,277,247,278,279,86,8,7,237,59,238,62,280,281,109,36,212,77,22,117]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p,u,o,v,b,$,I,g,D,y,P,A,G,W,U,C,T,q,ne,ce,ye,Ie,ue,ve,re,$e,ie,le,V,ee,ke,Ne,Se,be,ge,J,Z,he,fe,Te,de,Ce,Re,je,z,j,K,H,_,se,Oe,Ve,Qe,xe,et,ot,rt,tt,at,Be,it,Y,X,pe,We,Xe,st,Fe,Dt,Jt,jt,ri,Vt,St,xt,Wt,si,_t,Ze,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=ei;function ei(dt){const $t=dt.get(le.$NO),ti=dt.get(ie.$uic),qt=dt.get(re.$Uic),Ht=dt.get(ue.$rjc),ht=dt.get(Wt.$Pic),Rt=dt.get(at.$RO),ii=dt.get(P.$Sic),ni=dt.get(Jt.$Mic),He=dt.get(_.$xO),Tt=dt.get(ot.$bjc),zt=dt.get(rt.$Vic),Yt=dt.get(s.$Nj),mt=dt.get(s.$Mj),It=dt.get(Xe.$OAb),Ct=dt.get(t.$qic),Nt=dt.get(xt.$wkc),oi=dt.get(Ve.$jjc),Ut=dt.get(ye.$5ic),Zt=dt.get(J.$njc),bt=dt.get(p.$Aic),Ft=dt.get(b.$Fic);He.set(n.$fM.ExtHostFileSystemInfo,ti),He.set(n.$fM.ExtHostLogLevelServiceShape,Yt),He.set(n.$fM.ExtHostWorkspace,ht),He.set(n.$fM.ExtHostConfiguration,ii),He.set(n.$fM.ExtHostExtensionService,Ht),He.set(n.$fM.ExtHostStorage,Tt),He.set(n.$fM.ExtHostTunnelService,It),He.set(n.$fM.ExtHostWindow,Nt),He.set(n.$fM.ExtHostSecretState,oi),He.set(n.$fM.ExtHostTelemetry,Rt),He.set(n.$fM.ExtHostEditorTabs,Ut),He.set(n.$fM.ExtHostManagedSockets,Zt),He.set(n.$fM.ExtHostAuthentication,bt),He.set(n.$fM.ExtHostChatProvider,Ft);const Bt=He.set(n.$fM.ExtHostDecorations,dt.get(W.$Cjc)),Lt=He.set(n.$fM.ExtHostDocumentsAndEditors,dt.get(ce.$IO)),wt=He.set(n.$fM.ExtHostCommands,dt.get(D.$TO)),Pt=He.set(n.$fM.ExtHostTerminalService,dt.get(Be.$ejc)),kt=He.set(n.$fM.ExtHostDebugService,dt.get(G.$wjc)),li=He.set(n.$fM.ExtHostSearch,dt.get(Oe.$Sjc)),Qt=He.set(n.$fM.ExtHostTask,dt.get(tt.$jkc)),ci=He.set(n.$fM.ExtHostOutputService,dt.get(je.$9jc)),we=He.set(n.$fM.ExtHostLocalization,dt.get(ge.$mjc)),Ae=He.set(n.$fM.ExtHostUrls,new jt.$tkc(He)),oe=He.set(n.$fM.ExtHostDocuments,new ne.$xic(He,Lt)),Q=He.set(n.$fM.ExtHostDocumentContentProviders,new T.$Ejc(He,Lt,mt)),De=He.set(n.$fM.ExtHostDocumentSaveParticipant,new q.$Fjc(mt,oe,He.getProxy(n.$eM.MainThreadBulkEdits))),Le=He.set(n.$fM.ExtHostNotebook,new he.$Vjc(He,wt,Lt,oe,qt,li)),Ye=He.set(n.$fM.ExtHostNotebookDocuments,new Te.$3jc(Le)),Ke=He.set(n.$fM.ExtHostNotebookEditors,new de.$4jc(mt,Le)),ut=He.set(n.$fM.ExtHostNotebookKernels,new Ce.$5jc(He,$t,Le,wt,mt)),yt=He.set(n.$fM.ExtHostNotebookRenderers,new Re.$7jc(He,Le)),Kt=He.set(n.$fM.ExtHostNotebookDocumentSaveParticipant,new fe.$2jc(mt,Le,He.getProxy(n.$eM.MainThreadBulkEdits))),Et=He.set(n.$fM.ExtHostEditors,new Y.$Jic(He,Lt)),Mt=He.set(n.$fM.ExtHostTreeViews,new We.$rkc(He.getProxy(n.$eM.MainThreadTreeViews),wt,mt)),Xt=He.set(n.$fM.ExtHostEditorInsets,new g.$Kic(He.getProxy(n.$eM.MainThreadEditorInsets),Et,$t.remote)),vi=He.set(n.$fM.ExtHostDiagnostics,new U.$wic(He,mt,ti,Lt)),yi=He.set(n.$fM.ExtHostLanguages,new be.$Zjc(He,oe,wt.converter,ni)),ft=He.set(n.$fM.ExtHostLanguageFeatures,new Se.$yic(He,ni,oe,wt,vi,mt,Ct,Rt)),Ri=He.set(n.$fM.ExtHostFileSystem,new ve.$Hjc(He,ft)),fi=He.set(n.$fM.ExtHostFileSystemEventService,new $e.$Ijc(He,mt,Lt)),$i=He.set(n.$fM.ExtHostQuickOpen,(0,H.$akc)(He,ht,wt)),ki=He.set(n.$fM.ExtHostSCM,new se.$ckc(He,wt,oe,mt)),Ai=He.set(n.$fM.ExtHostQuickDiff,new K.$_jc(He,ni)),Fi=He.set(n.$fM.ExtHostShare,new Qe.$dkc(He,ni)),Ji=He.set(n.$fM.ExtHostComments,(0,y.$Lic)(He,wt,oe)),Qi=He.set(n.$fM.ExtHostProgress,new j.$$jc(He.getProxy(n.$eM.MainThreadProgress))),Xi=He.set(n.$fM.ExtHostLabelService,new Ne.$Yjc(He)),Ei=He.set(n.$fM.ExtHostTheming,new X.$okc(He)),Oi=He.set(n.$fM.ExtHostTimeline,new pe.$qkc(He,wt)),Di=He.set(n.$fM.ExtHostWebviews,new ri.$Zic(He,$t.remote,ht,mt,Ct)),Si=He.set(n.$fM.ExtHostWebviewPanels,new Vt.$3ic(He,Di,ht)),Yi=He.set(n.$fM.ExtHostCustomEditors,new A.$4ic(He,oe,zt,Di,Si)),Zi=He.set(n.$fM.ExtHostWebviewViews,new St.$ukc(He,Di)),bi=He.set(n.$fM.ExtHostTesting,new it.$kkc(He,mt,wt,Lt)),ln=He.set(n.$fM.ExtHostUriOpeners,new Dt.$skc(He)),hn=He.set(n.$fM.ExtHostProfileContentHandlers,new z.$0jc(He));He.set(n.$fM.ExtHostInteractive,new ee.$Wjc(He,Le,Lt,wt,mt));const Ti=He.set(n.$fM.ExtHostInlineChat,new V.$Jjc(He,wt,oe,mt)),Ni=He.set(n.$fM.ExtHostChatAgents2,new v.$Eic(He,mt,wt)),dn=He.set(n.$fM.ExtHostChatVariables,new $.$Hic(He)),xi=He.set(n.$fM.ExtHostChat,new o.$Dic(He)),Li=He.set(n.$fM.ExtHostAiRelatedInformation,new c.$pic(He)),fn=He.set(n.$fM.ExtHostAiEmbeddingVector,new Ie.$Gjc(He)),Ii=He.set(n.$fM.ExtHostIssueReporter,new ke.$Xjc(He)),ji=He.set(n.$fM.ExtHostStatusBar,new et.$gkc(He,wt.converter)),_i=He.set(n.$fM.ExtHostSpeech,new xe.$ekc(He)),en=Object.values(n.$fM);He.assertRegistered(en);const gn=new u.$Cic(He,Lt),zi=new I.$Iic(He),Ci=new Z.$1jc(He,mt),hi=new C.$Djc(He);return h.$zic.register(wt),function(ze,gi,ai){function nt(x){return(ae,Ue,ct)=>{const vt=x(At=>{try{ae.call(Ue,At)}catch(Pi){F.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Rt.onExtensionError(ze.identifier,Pi)}});return ct?.push(vt),vt}}const pt=function(){let x=!ze.isUnderDevelopment;function ae(){x||(mt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ae();else{const vt=ct;typeof vt.scheme>"u"&&ae(),typeof vt.exclusive=="boolean"&&(0,Ze.$4F)(ze,"documentFiltersExclusive")}return ct}}(),tn={getSession(x,ae,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,Ze.$4F)(ze,"authLearnMore"),bt.getSession(ze,x,ae,Ue)},getSessions(x,ae){return(0,Ze.$4F)(ze,"authGetSessions"),bt.getSessions(ze,x,ae)},async hasSession(x,ae){return(0,Ze.$4F)(ze,"authSession"),!!await bt.getSession(ze,x,ae,{silent:!0})},get onDidChangeSessions(){return nt(bt.onDidChangeSessions)},registerAuthenticationProvider(x,ae,Ue,ct){return bt.registerAuthenticationProvider(x,ae,Ue,ct)}},nn={registerCommand(x,ae,Ue){return wt.registerCommand(!0,x,ae,Ue,void 0,ze)},registerTextEditorCommand(x,ae,Ue){return wt.registerCommand(!0,x,(...ct)=>{const vt=Et.getActiveTextEditor();if(!vt){mt.warn("Cannot execute "+x+" because there is no active text editor.");return}return vt.edit(At=>{ae.apply(Ue,[vt,At,...ct])}).then(At=>{At||mt.warn("Edits from command "+x+" were not applied.")},At=>{mt.warn("An error occurred while running command "+x,At)})},void 0,void 0,ze)},registerDiffInformationCommand:(x,ae,Ue)=>((0,Ze.$4F)(ze,"diffCommand"),wt.registerCommand(!0,x,async(...ct)=>{const vt=Lt.activeEditor(!0);if(!vt){mt.warn("Cannot execute "+x+" because there is no active text editor.");return}const At=await Et.getDiffInformation(vt.id);ae.apply(Ue,[At,...ct])},void 0,void 0,ze)),executeCommand(x,...ae){return wt.executeCommand(x,...ae)},getCommands(x=!1){return wt.getCommands(x)}},Ui={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$4F)(ze,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$4F)(ze,"telemetry"),nt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$QO)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,ae){return at.$PO.validateSender(x),Rt.instantiateLogger(ze,x,ae)},openExternal(x,ae){return Nt.openUri(x,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===$t.environment.appUriScheme)return Ae.createAppUri(x);try{return await Nt.asExternalUri(x,{allowTunneling:!!$t.remote.authority})}catch(ae){if((0,R.$pg)(x,R.Schemas.http)||(0,R.$pg)(x,R.Schemas.https))return x;throw ae}},get remoteName(){return(0,a.$sm)($t.remote.authority)},get remoteAuthority(){return(0,Ze.$4F)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return nt(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Ze.$4F)(ze,"handleIssueUri"),Ii.registerIssueUriRequestHandler(ze,x)},registerIssueDataProvider(x){return(0,Ze.$4F)(ze,"handleIssueUri"),Ii.registerIssueDataProvider(ze,x)},get appQuality(){return(0,Ze.$4F)(ze,"resolvers"),$t.quality},get appCommit(){return(0,Ze.$4F)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ui);const mn={createTestController(x,ae,Ue){return bi.createTestController(ze,x,ae,Ue)},createTestObserver(){return(0,Ze.$4F)(ze,"testObserver"),bi.createTestObserver()},runTests(x){return(0,Ze.$4F)(ze,"testObserver"),bi.runTests(x)},get onDidChangeTestResults(){return(0,Ze.$4F)(ze,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Ze.$4F)(ze,"testObserver"),bi.results}},wi=$t.remote.isRemote?Fe.ExtensionKind.Workspace:Fe.ExtensionKind.UI,rn={getExtension(x,ae){(0,Ze.$3F)(ze,"extensionsAny")||(ae=!1);const Ue=gi.mine.getExtensionDescription(x);if(Ue)return new ue.$sjc(Ht,ze.identifier,Ue,wi,!1);if(ae){const ct=gi.all.getExtensionDescription(x);if(ct)return new ue.$sjc(Ht,ze.identifier,ct,wi,!0)}},get all(){const x=[];for(const ae of gi.mine.getAllExtensionDescriptions())x.push(new ue.$sjc(Ht,ze.identifier,ae,wi,!1));return x},get allAcrossExtensionHosts(){(0,Ze.$4F)(ze,"extensionsAny");const x=new w.$Cm(gi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ae=[];for(const Ue of gi.all.getAllExtensionDescriptions()){const ct=!x.has(Ue.identifier);ae.push(new ue.$sjc(Ht,ze.identifier,Ue,wi,ct))}return ae},get onDidChange(){return(0,Ze.$3F)(ze,"extensionsAny")?nt(M.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):nt(gi.mine.onDidChange)}},$n={createDiagnosticCollection(x){return vi.createDiagnosticCollection(ze.identifier,x)},get onDidChangeDiagnostics(){return nt(vi.onDidChangeDiagnostics)},getDiagnostics:x=>vi.getDiagnostics(x),getLanguages(){return yi.getLanguages()},setTextDocumentLanguage(x,ae){return yi.changeLanguage(x.uri,ae)},match(x,ae){const Ue=st.LanguageSelector.from(x);let ct;return(0,N.$St)(Ue)&&(ct=Le.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(At=>At.document===ae))?.apiNotebook),(0,N.$Rt)(Ue,ae.uri,ae.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(x,ae,Ue){return ft.registerCodeActionProvider(ze,pt(x),ae,Ue)},registerDocumentPasteEditProvider(x,ae,Ue){return(0,Ze.$4F)(ze,"documentPaste"),ft.registerDocumentPasteEditProvider(ze,pt(x),ae,Ue)},registerCodeLensProvider(x,ae){return ft.registerCodeLensProvider(ze,pt(x),ae)},registerDefinitionProvider(x,ae){return ft.registerDefinitionProvider(ze,pt(x),ae)},registerDeclarationProvider(x,ae){return ft.registerDeclarationProvider(ze,pt(x),ae)},registerImplementationProvider(x,ae){return ft.registerImplementationProvider(ze,pt(x),ae)},registerTypeDefinitionProvider(x,ae){return ft.registerTypeDefinitionProvider(ze,pt(x),ae)},registerHoverProvider(x,ae){return ft.registerHoverProvider(ze,pt(x),ae,ze.identifier)},registerEvaluatableExpressionProvider(x,ae){return ft.registerEvaluatableExpressionProvider(ze,pt(x),ae,ze.identifier)},registerInlineValuesProvider(x,ae){return ft.registerInlineValuesProvider(ze,pt(x),ae,ze.identifier)},registerDocumentHighlightProvider(x,ae){return ft.registerDocumentHighlightProvider(ze,pt(x),ae)},registerMultiDocumentHighlightProvider(x,ae){return ft.registerMultiDocumentHighlightProvider(ze,pt(x),ae)},registerLinkedEditingRangeProvider(x,ae){return ft.registerLinkedEditingRangeProvider(ze,pt(x),ae)},registerReferenceProvider(x,ae){return ft.registerReferenceProvider(ze,pt(x),ae)},registerRenameProvider(x,ae){return ft.registerRenameProvider(ze,pt(x),ae)},registerNewSymbolNamesProvider(x,ae){return(0,Ze.$4F)(ze,"newSymbolNamesProvider"),ft.registerNewSymbolNamesProvider(ze,pt(x),ae)},registerDocumentSymbolProvider(x,ae,Ue){return ft.registerDocumentSymbolProvider(ze,pt(x),ae,Ue)},registerWorkspaceSymbolProvider(x){return ft.registerWorkspaceSymbolProvider(ze,x)},registerDocumentFormattingEditProvider(x,ae){return ft.registerDocumentFormattingEditProvider(ze,pt(x),ae)},registerDocumentRangeFormattingEditProvider(x,ae){return ft.registerDocumentRangeFormattingEditProvider(ze,pt(x),ae)},registerOnTypeFormattingEditProvider(x,ae,Ue,...ct){return ft.registerOnTypeFormattingEditProvider(ze,pt(x),ae,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(x,ae,Ue){return ft.registerDocumentSemanticTokensProvider(ze,pt(x),ae,Ue)},registerDocumentRangeSemanticTokensProvider(x,ae,Ue){return ft.registerDocumentRangeSemanticTokensProvider(ze,pt(x),ae,Ue)},registerSignatureHelpProvider(x,ae,Ue,...ct){return typeof Ue=="object"?ft.registerSignatureHelpProvider(ze,pt(x),ae,Ue):ft.registerSignatureHelpProvider(ze,pt(x),ae,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(x,ae,...Ue){return ft.registerCompletionItemProvider(ze,pt(x),ae,Ue)},registerInlineCompletionItemProvider(x,ae,Ue){return ae.handleDidShowCompletionItem&&(0,Ze.$4F)(ze,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$4F)(ze,"inlineCompletionsAdditions"),Ue&&(0,Ze.$4F)(ze,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(ze,pt(x),ae,Ue)},registerInlineEditProvider(x,ae){return(0,Ze.$4F)(ze,"inlineEdit"),ft.registerInlineEditProvider(ze,pt(x),ae)},registerDocumentLinkProvider(x,ae){return ft.registerDocumentLinkProvider(ze,pt(x),ae)},registerColorProvider(x,ae){return ft.registerColorProvider(ze,pt(x),ae)},registerFoldingRangeProvider(x,ae){return ft.registerFoldingRangeProvider(ze,pt(x),ae)},registerSelectionRangeProvider(x,ae){return ft.registerSelectionRangeProvider(ze,x,ae)},registerCallHierarchyProvider(x,ae){return ft.registerCallHierarchyProvider(ze,x,ae)},registerTypeHierarchyProvider(x,ae){return ft.registerTypeHierarchyProvider(ze,x,ae)},setLanguageConfiguration:(x,ae)=>ft.setLanguageConfiguration(ze,x,ae),getTokenInformationAtPosition(x,ae){return(0,Ze.$4F)(ze,"tokenInformation"),yi.tokenAtPosition(x,ae)},registerInlayHintsProvider(x,ae){return ft.registerInlayHintsProvider(ze,x,ae)},createLanguageStatusItem(x,ae){return yi.createLanguageStatusItem(ze,x,ae)},registerDocumentDropEditProvider(x,ae,Ue){return ft.registerDocumentOnDropEditProvider(ze,x,ae,(0,Ze.$3F)(ze,"dropMetadata")?Ue:void 0)}},pn={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(x,ae,Ue){f.URI.isUri(x)&&x.scheme===R.Schemas.vscodeRemote&&!x.authority&&Ct.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(f.URI.isUri(x)?Promise.resolve(Bi.openTextDocument(x)):Promise.resolve(x));return Et.showTextDocument(ct,ae,Ue)},createTextEditorDecorationType(x){return Et.createTextEditorDecorationType(ze,x)},onDidChangeActiveTextEditor(x,ae,Ue){return nt(Et.onDidChangeActiveTextEditor)(x,ae,Ue)},onDidChangeVisibleTextEditors(x,ae,Ue){return nt(Et.onDidChangeVisibleTextEditors)(x,ae,Ue)},onDidChangeTextEditorSelection(x,ae,Ue){return nt(Et.onDidChangeTextEditorSelection)(x,ae,Ue)},onDidChangeTextEditorOptions(x,ae,Ue){return nt(Et.onDidChangeTextEditorOptions)(x,ae,Ue)},onDidChangeTextEditorVisibleRanges(x,ae,Ue){return nt(Et.onDidChangeTextEditorVisibleRanges)(x,ae,Ue)},onDidChangeTextEditorViewColumn(x,ae,Ue){return nt(Et.onDidChangeTextEditorViewColumn)(x,ae,Ue)},onDidCloseTerminal(x,ae,Ue){return nt(Pt.onDidCloseTerminal)(x,ae,Ue)},onDidOpenTerminal(x,ae,Ue){return nt(Pt.onDidOpenTerminal)(x,ae,Ue)},onDidChangeActiveTerminal(x,ae,Ue){return nt(Pt.onDidChangeActiveTerminal)(x,ae,Ue)},onDidChangeTerminalDimensions(x,ae,Ue){return(0,Ze.$4F)(ze,"terminalDimensions"),nt(Pt.onDidChangeTerminalDimensions)(x,ae,Ue)},onDidChangeTerminalState(x,ae,Ue){return nt(Pt.onDidChangeTerminalState)(x,ae,Ue)},onDidWriteTerminalData(x,ae,Ue){return(0,Ze.$4F)(ze,"terminalDataWriteEvent"),nt(Pt.onDidWriteTerminalData)(x,ae,Ue)},onDidExecuteTerminalCommand(x,ae,Ue){return(0,Ze.$4F)(ze,"terminalExecuteCommandEvent"),nt(Pt.onDidExecuteTerminalCommand)(x,ae,Ue)},get state(){return Nt.getState(ze)},onDidChangeWindowState(x,ae,Ue){return nt(Nt.onDidChangeWindowState)(x,ae,Ue)},showInformationMessage(x,...ae){return Ci.showMessage(ze,m.default.Info,x,ae[0],ae.slice(1))},showWarningMessage(x,...ae){return Ci.showMessage(ze,m.default.Warning,x,ae[0],ae.slice(1))},showErrorMessage(x,...ae){return Ci.showMessage(ze,m.default.Error,x,ae[0],ae.slice(1))},showQuickPick(x,ae,Ue){return $i.showQuickPick(ze,x,ae,Ue)},showWorkspaceFolderPick(x){return $i.showWorkspaceFolderPick(x)},showInputBox(x,ae){return $i.showInput(x,ae)},showOpenDialog(x){return hi.showOpenDialog(ze,x)},showSaveDialog(x){return hi.showSaveDialog(x)},createStatusBarItem(x,ae,Ue){let ct,vt,At;return typeof x=="string"?(ct=x,vt=ae,At=Ue):(vt=x,At=ae),ji.createStatusBarEntry(ze,ct,vt,At)},setStatusBarMessage(x,ae){return ji.setStatusBarMessage(x,ae)},withScmProgress(x){return Ct.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Qi.withProgress(ze,{location:Fe.ProgressLocation.SourceControl},(ae,Ue)=>x({report(ct){}}))},withProgress(x,ae){return Qi.withProgress(ze,x,ae)},createOutputChannel(x,ae){return ci.createOutputChannel(x,ae,ze)},createWebviewPanel(x,ae,Ue,ct){return Si.createWebviewPanel(ze,x,ae,Ue,ct)},createWebviewTextEditorInset(x,ae,Ue,ct){return(0,Ze.$4F)(ze,"editorInsets"),Xt.createWebviewEditorInset(x,ae,Ue,ct,ze)},createTerminal(x,ae,Ue){return typeof x=="object"?"pty"in x?Pt.createExtensionTerminal(x):Pt.createTerminalFromOptions(x):Pt.createTerminal(x,ae,Ue)},registerTerminalLinkProvider(x){return Pt.registerLinkProvider(x)},registerTerminalProfileProvider(x,ae){return Pt.registerProfileProvider(ze,x,ae)},registerTerminalQuickFixProvider(x,ae){return(0,Ze.$4F)(ze,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(x,ze.identifier.value,ae)},registerTreeDataProvider(x,ae){return Mt.registerTreeDataProvider(x,ae,ze)},createTreeView(x,ae){return Mt.createTreeView(x,ae,ze)},registerWebviewPanelSerializer:(x,ae)=>Si.registerWebviewPanelSerializer(ze,x,ae),registerCustomEditorProvider:(x,ae,Ue={})=>Yi.registerCustomEditorProvider(ze,x,ae,Ue),registerFileDecorationProvider(x){return Bt.registerFileDecorationProvider(x,ze)},registerUriHandler(x){return Ae.registerUriHandler(ze,x)},createQuickPick(){return $i.createQuickPick(ze)},createInputBox(){return $i.createInputBox(ze)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(x,ae,Ue){return nt(Ei.onDidChangeActiveColorTheme)(x,ae,Ue)},registerWebviewViewProvider(x,ae,Ue){return Zi.registerWebviewViewProvider(ze,x,ae,Ue?.webviewOptions)},get activeNotebookEditor(){return Le.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,ae,Ue){return nt(Le.onDidChangeActiveNotebookEditor)(x,ae,Ue)},get visibleNotebookEditors(){return Le.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(Le.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,ae,Ue){return nt(Ke.onDidChangeNotebookEditorSelection)(x,ae,Ue)},onDidChangeNotebookEditorVisibleRanges(x,ae,Ue){return nt(Ke.onDidChangeNotebookEditorVisibleRanges)(x,ae,Ue)},showNotebookDocument(x,ae){return Le.showNotebookDocument(x,ae)},registerExternalUriOpener(x,ae,Ue){return(0,Ze.$4F)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,x,ae,Ue)},registerProfileContentHandler(x,ae){return(0,Ze.$4F)(ze,"profileContentHandlers"),hn.registerProfileContentHandler(ze,x,ae)},registerQuickDiffProvider(x,ae,Ue,ct){return(0,Ze.$4F)(ze,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt(x),ae,Ue,ct)},get tabGroups(){return Ut.tabGroups},registerShareProvider(x,ae){return(0,Ze.$4F)(ze,"shareProvider"),Fi.registerShareProvider(pt(x),ae)}},Bi={get rootPath(){return Ct.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(x){throw new F.$9("rootPath")},getWorkspaceFolder(x){return ht.getWorkspaceFolder(x)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(x){throw new F.$9("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(x){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(x,ae,...Ue)=>ht.updateWorkspaceFolders(ze,x,ae||0,...Ue),onDidChangeWorkspaceFolders:function(x,ae,Ue){return nt(ht.onDidChangeWorkspace)(x,ae,Ue)},asRelativePath:(x,ae)=>ht.getRelativePath(x,ae),findFiles:(x,ae,Ue,ct)=>ht.findFiles(x,ae,Ue,ze.identifier,ct),findFiles2:(x,ae,Ue)=>((0,Ze.$4F)(ze,"findFiles2"),ht.findFiles2(x,ae,ze.identifier,Ue)),findTextInFiles:(x,ae,Ue,ct)=>{(0,Ze.$4F)(ze,"findTextInFiles");let vt,At;return typeof ae=="object"?(vt=ae,At=Ue):(vt={},At=ae,ct=Ue),ht.findTextInFiles(x,vt||{},At,ze.identifier,ct)},save:x=>ht.save(x),saveAs:x=>ht.saveAs(x),saveAll:x=>ht.saveAll(x),applyEdit(x,ae){return gn.applyWorkspaceEdit(x,ze,ae)},createFileSystemWatcher:(x,ae,Ue,ct)=>{let vt;return typeof ae=="boolean"?vt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ae&&((0,Ze.$4F)(ze,"createFileSystemWatcher"),vt={...ae,correlate:!0}),fi.createFileSystemWatcher(ht,ze,x,vt)},get textDocuments(){return oe.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new F.$9("textDocuments")},openTextDocument(x){let ae;const Ue=x;if(typeof x=="string")ae=Promise.resolve(f.URI.file(x));else if(f.URI.isUri(x))ae=Promise.resolve(x);else if(!Ue||typeof Ue=="object")ae=oe.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Ct.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),oe.ensureDocumentData(ct).then(vt=>vt.document)))},onDidOpenTextDocument:(x,ae,Ue)=>nt(oe.onDidAddDocument)(x,ae,Ue),onDidCloseTextDocument:(x,ae,Ue)=>nt(oe.onDidRemoveDocument)(x,ae,Ue),onDidChangeTextDocument:(x,ae,Ue)=>nt(oe.onDidChangeDocument)(x,ae,Ue),onDidSaveTextDocument:(x,ae,Ue)=>nt(oe.onDidSaveDocument)(x,ae,Ue),onWillSaveTextDocument:(x,ae,Ue)=>nt(De.getOnWillSaveTextDocumentEvent(ze))(x,ae,Ue),get notebookDocuments(){return Le.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,ae){let Ue;if(f.URI.isUri(x))Ue=x,await Le.openNotebookDocument(x);else if(typeof x=="string")Ue=f.URI.revive(await Le.createNotebookDocument({viewType:x,content:ae}));else throw new Error("Invalid arguments");return Le.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(x,ae,Ue){return nt(Ye.onDidSaveNotebookDocument)(x,ae,Ue)},onDidChangeNotebookDocument(x,ae,Ue){return nt(Ye.onDidChangeNotebookDocument)(x,ae,Ue)},onWillSaveNotebookDocument(x,ae,Ue){return nt(Kt.getOnWillSaveNotebookDocumentEvent(ze))(x,ae,Ue)},get onDidOpenNotebookDocument(){return nt(Le.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(Le.onDidCloseNotebookDocument)},registerNotebookSerializer(x,ae,Ue,ct){return Le.registerNotebookSerializer(ze,x,ae,Ue,(0,Ze.$3F)(ze,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(x,ae,Ue)=>nt(ai.onDidChangeConfiguration)(x,ae,Ue),getConfiguration(x,ae){return ae=arguments.length===1?void 0:ae,ai.getConfiguration(x,ae,ze)},registerTextDocumentContentProvider(x,ae){return Q.registerTextDocumentContentProvider(x,ae)},registerTaskProvider:(x,ae)=>(Ct.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(ze,x,ae)),registerFileSystemProvider(x,ae,Ue){return(0,O.$Qc)(Ri.registerFileSystemProvider(ze,x,ae,Ue),qt.addFileSystemProvider(x,ae,Ue))},get fs(){return qt.value},registerFileSearchProvider:(x,ae)=>((0,Ze.$4F)(ze,"fileSearchProvider"),li.registerFileSearchProvider(x,ae)),registerTextSearchProvider:(x,ae)=>((0,Ze.$4F)(ze,"textSearchProvider"),li.registerTextSearchProvider(x,ae)),registerAITextSearchProvider:(x,ae)=>((0,Ze.$4F)(ze,"aiTextSearchProvider"),(0,Ze.$4F)(ze,"textSearchProvider"),li.registerAITextSearchProvider(x,ae)),registerRemoteAuthorityResolver:(x,ae)=>((0,Ze.$4F)(ze,"resolvers"),Ht.registerRemoteAuthorityResolver(x,ae)),registerResourceLabelFormatter:x=>((0,Ze.$4F)(ze,"resolvers"),Xi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Ze.$4F)(ze,"resolvers"),Ht.getRemoteExecServer(x)),onDidCreateFiles:(x,ae,Ue)=>nt(fi.onDidCreateFile)(x,ae,Ue),onDidDeleteFiles:(x,ae,Ue)=>nt(fi.onDidDeleteFile)(x,ae,Ue),onDidRenameFiles:(x,ae,Ue)=>nt(fi.onDidRenameFile)(x,ae,Ue),onWillCreateFiles:(x,ae,Ue)=>nt(fi.getOnWillCreateFileEvent(ze))(x,ae,Ue),onWillDeleteFiles:(x,ae,Ue)=>nt(fi.getOnWillDeleteFileEvent(ze))(x,ae,Ue),onWillRenameFiles:(x,ae,Ue)=>nt(fi.getOnWillRenameFileEvent(ze))(x,ae,Ue),openTunnel:x=>((0,Ze.$4F)(ze,"tunnels"),It.openTunnel(ze,x).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ze.$4F)(ze,"tunnels"),It.getTunnels()},onDidChangeTunnels:(x,ae,Ue)=>((0,Ze.$4F)(ze,"tunnels"),nt(It.onDidChangeTunnels)(x,ae,Ue)),registerPortAttributesProvider:(x,ae)=>((0,Ze.$4F)(ze,"portsAttributes"),It.registerPortsAttributesProvider(x,ae)),registerTunnelProvider:(x,ae)=>((0,Ze.$4F)(ze,"tunnelFactory"),It.registerTunnelProvider(x,ae)),registerTimelineProvider:(x,ae)=>((0,Ze.$4F)(ze,"timeline"),Oi.registerTimelineProvider(x,ae,ze.identifier,wt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:x=>((0,Ze.$4F)(ze,"workspaceTrust"),ht.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,ae,Ue)=>nt(ht.onDidGrantWorkspaceTrust)(x,ae,Ue),registerEditSessionIdentityProvider:(x,ae)=>((0,Ze.$4F)(ze,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(x,ae)),onWillCreateEditSessionIdentity:(x,ae,Ue)=>((0,Ze.$4F)(ze,"editSessionIdentityProvider"),nt(ht.getOnWillCreateEditSessionIdentityEvent(ze))(x,ae,Ue)),registerCanonicalUriProvider:(x,ae)=>((0,Ze.$4F)(ze,"canonicalUriProvider"),ht.registerCanonicalUriProvider(x,ae)),getCanonicalUri:(x,ae,Ue)=>((0,Ze.$4F)(ze,"canonicalUriProvider"),ht.provideCanonicalUri(x,ae,Ue))},Vi={get inputBox(){return Ct.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(ze)},createSourceControl(x,ae,Ue){return ki.createSourceControl(ze,x,ae,Ue)}},sn={createCommentController(x,ae){return Ji.createCommentController(ze,x,ae)}},on={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ze.$3F)(ze,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(x,ae){return(0,Ze.$4F)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,x,ae)},registerDebugVisualizationTreeProvider(x,ae){return(0,Ze.$4F)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,x,ae)},onDidStartDebugSession(x,ae,Ue){return nt(kt.onDidStartDebugSession)(x,ae,Ue)},onDidTerminateDebugSession(x,ae,Ue){return nt(kt.onDidTerminateDebugSession)(x,ae,Ue)},onDidChangeActiveDebugSession(x,ae,Ue){return nt(kt.onDidChangeActiveDebugSession)(x,ae,Ue)},onDidReceiveDebugSessionCustomEvent(x,ae,Ue){return nt(kt.onDidReceiveDebugSessionCustomEvent)(x,ae,Ue)},onDidChangeBreakpoints(x,ae,Ue){return nt(kt.onDidChangeBreakpoints)(x,ae,Ue)},onDidChangeActiveStackItem(x,ae,Ue){return(0,Ze.$4F)(ze,"debugFocus"),nt(kt.onDidChangeActiveStackItem)(x,ae,Ue)},registerDebugConfigurationProvider(x,ae,Ue){return kt.registerDebugConfigurationProvider(x,ae,Ue||si.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,ae){return kt.registerDebugAdapterDescriptorFactory(ze,x,ae)},registerDebugAdapterTrackerFactory(x,ae){return kt.registerDebugAdapterTrackerFactory(x,ae)},startDebugging(x,ae,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?kt.startDebugging(x,ae,{parentSession:Ue}):kt.startDebugging(x,ae,Ue||{})},stopDebugging(x){return kt.stopDebugging(x)},addBreakpoints(x){return kt.addBreakpoints(x)},removeBreakpoints(x){return kt.removeBreakpoints(x)},asDebugSourceUri(x,ae){return kt.asDebugSourceUri(x,ae)}},an={registerTaskProvider:(x,ae)=>Qt.registerTaskProvider(ze,x,ae),fetchTasks:x=>Qt.fetchTasks(x),executeTask:x=>Qt.executeTask(ze,x),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(x,ae,Ue)=>nt(Qt.onDidStartTask)(x,ae,Ue),onDidEndTask:(x,ae,Ue)=>nt(Qt.onDidEndTask)(x,ae,Ue),onDidStartTaskProcess:(x,ae,Ue)=>nt(Qt.onDidStartTaskProcess)(x,ae,Ue),onDidEndTaskProcess:(x,ae,Ue)=>nt(Qt.onDidEndTaskProcess)(x,ae,Ue)},vn={createNotebookController(x,ae,Ue,ct,vt){return ut.createNotebookController(ze,x,ae,Ue,ct,(0,Ze.$3F)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(x,ae)=>Le.registerNotebookCellStatusBarItemProvider(ze,x,ae),createRendererMessaging(x){return yt.createRendererMessaging(ze,x)},createNotebookControllerDetectionTask(x){return(0,Ze.$4F)(ze,"notebookKernelSource"),ut.createNotebookControllerDetectionTask(ze,x)},registerKernelSourceActionProvider(x,ae){return(0,Ze.$4F)(ze,"notebookKernelSource"),ut.registerKernelSourceActionProvider(ze,x,ae)},onDidChangeNotebookCellExecutionState(x,ae,Ue){return(0,Ze.$4F)(ze,"notebookCellExecutionState"),nt(ut.onDidChangeNotebookCellExecutionState)(x,ae,Ue)}},bn={t(...x){if(typeof x[0]=="string"){const ae=x.shift(),Ue=!x||typeof x[0]!="object"?x:x[0];return we.getMessage(ze.identifier.value,{message:ae,args:Ue})}return we.getMessage(ze.identifier.value,x[0])},get bundle(){return we.getBundle(ze.identifier.value)},get uri(){return we.getBundleUri(ze.identifier.value)}},cn={_version:1,registerInteractiveEditorSessionProvider(x,ae){return(0,Ze.$4F)(ze,"interactive"),Ti.registerProvider(ze,x,ae)},registerInteractiveSessionProvider(x,ae){return(0,Ze.$4F)(ze,"interactive"),xi.registerChatProvider(ze,x,ae)},transferChatSession(x,ae){return(0,Ze.$4F)(ze,"interactive"),xi.transferChatSession(x,ae)}},un={getRelatedInformation(x,ae){return(0,Ze.$4F)(ze,"aiRelatedInformation"),Li.getRelatedInformation(ze,x,ae)},registerRelatedInformationProvider(x,ae){return(0,Ze.$4F)(ze,"aiRelatedInformation"),Li.registerRelatedInformationProvider(ze,x,ae)},registerEmbeddingVectorProvider(x,ae){return(0,Ze.$4F)(ze,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(ze,x,ae)}},Wi={registerChatResponseProvider(x,ae,Ue){return(0,Ze.$4F)(ze,"chatProvider"),Ft.registerLanguageModel(ze,x,ae,Ue)},registerChatVariableResolver(x,ae,Ue){return(0,Ze.$4F)(ze,"chatVariableResolver"),dn.registerVariableResolver(ze,x,ae,Ue)},registerMappedEditsProvider(x,ae){return(0,Ze.$4F)(ze,"mappedEditsProvider"),ft.registerMappedEditsProvider(ze,x,ae)},createChatParticipant(x,ae){return(0,Ze.$4F)(ze,"chatParticipant"),Ni.createChatAgent(ze,x,ae)}},qi={get languageModels(){return(0,Ze.$4F)(ze,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(x,ae,Ue)=>((0,Ze.$4F)(ze,"languageModels"),Ft.onDidChangeProviders(x,ae,Ue)),sendChatRequest(x,ae,Ue,ct){return(0,Ze.$4F)(ze,"languageModels"),Ft.sendChatRequest(ze,x,ae,Ue,ct)}},Hi={registerSpeechProvider(x,ae){return(0,Ze.$4F)(ze,"speech"),_i.registerProvider(ze.identifier,x,ae)}};return{version:$t.version,ai:un,authentication:tn,commands:nn,comments:sn,chat:Wi,debug:on,env:Ui,extensions:rn,interactive:cn,l10n:bn,languages:$n,lm:qi,notebooks:vn,scm:Vi,speech:Hi,tasks:an,tests:mn,window:pn,workspace:Bi,Breakpoint:Fe.$gN,TerminalOutputAnchor:Fe.TerminalOutputAnchor,ChatResultFeedbackKind:Fe.ChatResultFeedbackKind,ChatVariableLevel:Fe.ChatVariableLevel,ChatCompletionItem:Fe.$_N,CallHierarchyIncomingCall:Fe.$EM,CallHierarchyItem:Fe.$DM,CallHierarchyOutgoingCall:Fe.$FM,CancellationError:F.$5,CancellationTokenSource:S.$de,CandidatePortSource:n.CandidatePortSource,CodeAction:Fe.$AM,CodeActionKind:Fe.$BM,CodeActionTriggerKind:Fe.CodeActionTriggerKind,CodeLens:Fe.$GM,Color:Fe.$TM,ColorInformation:Fe.$UM,ColorPresentation:Fe.$VM,ColorThemeKind:Fe.ColorThemeKind,CommentMode:Fe.CommentMode,CommentState:Fe.CommentState,CommentThreadCollapsibleState:Fe.CommentThreadCollapsibleState,CommentThreadState:Fe.CommentThreadState,CompletionItem:Fe.$NM,CompletionItemKind:Fe.CompletionItemKind,CompletionItemTag:Fe.CompletionItemTag,CompletionList:Fe.$OM,CompletionTriggerKind:Fe.CompletionTriggerKind,ConfigurationTarget:Fe.ConfigurationTarget,CustomExecution:Fe.$4M,DebugAdapterExecutable:Fe.$kN,DebugAdapterInlineImplementation:Fe.$nN,DebugAdapterNamedPipeServer:Fe.$mN,DebugAdapterServer:Fe.$lN,DebugConfigurationProviderTriggerKind:si.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Fe.DebugConsoleMode,DebugVisualization:Fe.$DN,DecorationRangeBehavior:Fe.DecorationRangeBehavior,Diagnostic:Fe.$uM,DiagnosticRelatedInformation:Fe.$tM,DiagnosticSeverity:Fe.DiagnosticSeverity,DiagnosticTag:Fe.DiagnosticTag,Disposable:Fe.$gM,DocumentHighlight:Fe.$wM,DocumentHighlightKind:Fe.DocumentHighlightKind,MultiDocumentHighlight:Fe.$xM,DocumentLink:Fe.$SM,DocumentSymbol:Fe.$zM,EndOfLine:Fe.EndOfLine,EnvironmentVariableMutatorType:Fe.EnvironmentVariableMutatorType,EvaluatableExpression:Fe.$qN,InlineValueText:Fe.$rN,InlineValueVariableLookup:Fe.$sN,InlineValueEvaluatableExpression:Fe.$tN,InlineCompletionTriggerKind:Fe.InlineCompletionTriggerKind,EventEmitter:M.$6d,ExtensionKind:Fe.ExtensionKind,ExtensionMode:Fe.ExtensionMode,ExternalUriOpenerPriority:Fe.ExternalUriOpenerPriority,FileChangeType:Fe.FileChangeType,FileDecoration:Fe.$FN,FileDecoration2:Fe.$FN,FileSystemError:Fe.$wN,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:Fe.$xN,FoldingRangeKind:Fe.FoldingRangeKind,FunctionBreakpoint:Fe.$iN,InlineCompletionItem:Fe.$PM,InlineCompletionList:Fe.$QM,Hover:Fe.$vM,IndentAction:E.IndentAction,Location:Fe.$sM,MarkdownString:Fe.$HM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Fe.$IM,PortAutoForwardAction:Fe.PortAutoForwardAction,Position:Fe.$hM,ProcessExecution:Fe.$2M,ProgressLocation:Fe.ProgressLocation,QuickInputButtons:Fe.$EN,Range:Fe.$iM,RelativePattern:Fe.$eN,Selection:Fe.$jM,SelectionRange:Fe.$CM,SemanticTokens:Fe.$AN,SemanticTokensBuilder:Fe.$zN,SemanticTokensEdit:Fe.$BN,SemanticTokensEdits:Fe.$CN,SemanticTokensLegend:Fe.$yN,ShellExecution:Fe.$3M,ShellQuoting:Fe.ShellQuoting,SignatureHelp:Fe.$KM,SignatureHelpTriggerKind:Fe.SignatureHelpTriggerKind,SignatureInformation:Fe.$JM,SnippetString:Fe.$rM,SourceBreakpoint:Fe.$hN,StandardTokenType:Fe.StandardTokenType,StatusBarAlignment:Fe.StatusBarAlignment,SymbolInformation:Fe.$yM,SymbolKind:Fe.SymbolKind,SymbolTag:Fe.SymbolTag,Task:Fe.$5M,TaskGroup:Fe.$1M,TaskPanelKind:Fe.TaskPanelKind,TaskRevealKind:Fe.TaskRevealKind,TaskScope:Fe.TaskScope,TerminalLink:Fe.$WM,TerminalQuickFixTerminalCommand:Fe.$YM,TerminalQuickFixOpener:Fe.$XM,TerminalLocation:Fe.TerminalLocation,TerminalProfile:Fe.$ZM,TerminalExitReason:Fe.TerminalExitReason,TextDocumentSaveReason:Fe.TextDocumentSaveReason,TextEdit:Fe.$nM,SnippetTextEdit:Fe.$pM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Fe.TextEditorLineNumbersStyle,TextEditorRevealType:Fe.TextEditorRevealType,TextEditorSelectionChangeKind:Fe.TextEditorSelectionChangeKind,SyntaxTokenType:Fe.SyntaxTokenType,TextDocumentChangeReason:Fe.TextDocumentChangeReason,ThemeColor:Fe.$dN,ThemeIcon:Fe.$cN,TreeItem:Fe.$6M,TreeItemCheckboxState:Fe.TreeItemCheckboxState,TreeItemCollapsibleState:Fe.TreeItemCollapsibleState,TypeHierarchyItem:Fe.$1N,UIKind:_t.UIKind,Uri:f.URI,ViewColumn:Fe.ViewColumn,WorkspaceEdit:Fe.$qM,DocumentPasteTriggerKind:Fe.DocumentPasteTriggerKind,DocumentDropEdit:Fe.$_M,DocumentPasteEditKind:Fe.$aN,DocumentPasteEdit:Fe.$bN,InlayHint:Fe.$MM,InlayHintLabelPart:Fe.$LM,InlayHintKind:Fe.InlayHintKind,RemoteAuthorityResolverError:Fe.$mM,ResolvedAuthority:Fe.$kM,ManagedResolvedAuthority:Fe.$lM,SourceControlInputBoxValidationType:Fe.SourceControlInputBoxValidationType,ExtensionRuntime:Fe.ExtensionRuntime,TimelineItem:Fe.$PN,NotebookRange:Fe.$HN,NotebookCellKind:Fe.NotebookCellKind,NotebookCellExecutionState:Fe.NotebookCellExecutionState,NotebookCellData:Fe.$IN,NotebookData:Fe.$JN,NotebookRendererScript:Fe.$NN,NotebookCellStatusBarAlignment:Fe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Fe.NotebookEditorRevealType,NotebookCellOutput:Fe.$LN,NotebookCellOutputItem:Fe.$KN,NotebookCellStatusBarItem:Fe.$MN,NotebookControllerAffinity:Fe.NotebookControllerAffinity,NotebookControllerAffinity2:Fe.NotebookControllerAffinity2,NotebookEdit:Fe.$oM,NotebookKernelSourceAction:Fe.$ON,NotebookVariablesRequestKind:Fe.NotebookVariablesRequestKind,PortAttributes:Fe.$RN,LinkedEditingRanges:Fe.$QN,TestResultState:Fe.TestResultState,TestRunRequest:Fe.$SN,TestMessage:Fe.$TN,TestTag:Fe.$UN,TestRunProfileKind:Fe.TestRunProfileKind,TextSearchCompleteMessageType:Ot.TextSearchCompleteMessageType,DataTransfer:Fe.$$M,DataTransferItem:Fe.$7M,CoveredCount:Fe.$VN,FileCoverage:Fe.$WN,StatementCoverage:Fe.$XN,BranchCoverage:Fe.$YN,DeclarationCoverage:Fe.$ZN,FunctionCoverage:Fe.$ZN,WorkspaceTrustState:Fe.WorkspaceTrustState,LanguageStatusSeverity:Fe.LanguageStatusSeverity,QuickPickItemKind:Fe.QuickPickItemKind,InputBoxValidationSeverity:Fe.InputBoxValidationSeverity,TabInputText:Fe.$2N,TabInputTextDiff:Fe.$3N,TabInputTextMerge:Fe.$4N,TabInputCustom:Fe.$5N,TabInputNotebook:Fe.$7N,TabInputNotebookDiff:Fe.$8N,TabInputWebview:Fe.$6N,TabInputTerminal:Fe.$9N,TabInputInteractiveWindow:Fe.$0N,TabInputChat:Fe.$$N,TelemetryTrustedValue:r.$2o,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Fe.InteractiveSessionVoteDirection,ChatCopyKind:Fe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Fe.InteractiveEditorResponseFeedbackKind,StackFrame:Fe.$oN,Thread:Fe.$pN,RelatedInformationType:Fe.RelatedInformationType,SpeechToTextStatus:Fe.SpeechToTextStatus,PartialAcceptTriggerKind:Fe.PartialAcceptTriggerKind,KeywordRecognitionStatus:Fe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Fe.$aO,ChatResponseFileTreePart:Fe.$bO,ChatResponseAnchorPart:Fe.$cO,ChatResponseProgressPart:Fe.$dO,ChatResponseReferencePart:Fe.$fO,ChatResponseCommandButtonPart:Fe.$eO,ChatRequestTurn:Fe.$gO,ChatResponseTurn:Fe.$hO,LanguageModelChatSystemMessage:Fe.$iO,LanguageModelChatUserMessage:Fe.$jO,LanguageModelChatAssistantMessage:Fe.$kO,LanguageModelSystemMessage:Fe.$iO,LanguageModelUserMessage:Fe.$jO,LanguageModelAssistantMessage:Fe.$kO,LanguageModelError:Fe.$lO,NewSymbolName:Fe.$vN,NewSymbolNameTag:Fe.NewSymbolNameTag,InlineEdit:Fe.$mO,InlineEditTriggerKind:Fe.InlineEditTriggerKind}}}}),define(Pe[295],Me([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,43,81,61,65,233,13,119,79,80,84,88]),function(me,e,S,F,M,O,R,m,f,k,N,E,l,w,d,s,a,r,i,n,c,h,t,p,u,o,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$cs)(o.$mjc,o.$ljc,1),(0,S.$cs)(p.$Nj,t.$ykc,1),(0,S.$cs)(s.$qic,s.$ric,1),(0,S.$cs)(m.$TO,m.$SO,0),(0,S.$cs)(b.$Aic,b.$Bic,0),(0,S.$cs)($.$Fic,$.$Gic,0),(0,S.$cs)(R.$Sic,R.$Qic,0),(0,S.$cs)(r.$Uic,r.$Tic,0),(0,S.$cs)(E.$wjc,E.$Ajc,0),(0,S.$cs)(O.$Cjc,O.$Bjc,0),(0,S.$cs)(f.$IO,f.$HO,0),(0,S.$cs)(v.$njc,v.$ojc,0),(0,S.$cs)(i.$uic,i.$tic,0),(0,S.$cs)(F.$9jc,F.$8jc,1),(0,S.$cs)(l.$Sjc,l.$Tjc,0),(0,S.$cs)(w.$bjc,w.$ajc,0),(0,S.$cs)(N.$jkc,N.$ikc,0),(0,S.$cs)(k.$ejc,k.$hjc,0),(0,S.$cs)(d.$OAb,d.$PAb,0),(0,S.$cs)(a.$wkc,a.$vkc,0),(0,S.$cs)(M.$Pic,M.$Oic,0),(0,S.$cs)(n.$jjc,n.$ijc,0),(0,S.$cs)(c.$RO,c.$OO,0),(0,S.$cs)(h.$5ic,h.$6ic,0),(0,S.$cs)(u.$ujc,u.$vjc,0)}),define(Pe[296],Me([1,0,294,38,2,291,7,11,239]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class k extends O.$Bkc{j(){}getModule(w,d){for(const s of this.b){const a=s(w);if(a){w=a;break}}if(this.a.has(w))return this.a.get(w).load(w,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends F.$qjc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async ub(){this.h.createInstance(f.$Hmc);const w=this.h.invokeFunction(S.$xkc);this.r=this.h.createInstance(k,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Ab()}vb(w){return w.browser}async wb(w,d,s){d=d.with({path:E(d.path,".js")});const a=w?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const r=M.URI.revive(await this.C.$asBrowserUri(d)),i=await fetch(r.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${d.toString(!0)}#vscode-extension`,h=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch(v){throw console.error(a?`Loading code for extension ${a} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${d.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}w&&await this.w.initializeLocalizedMessages(w);const p={},u={exports:p},o=v=>{const b=this.r.getModule(v,d);if(b===void 0)throw new Error(`Cannot load module '${v}'`);return b};try{return s.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(u,p,o),u.exports!==p?u.exports:p}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),s.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Ab(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+w;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,m.$hh)(10)}}e.$Imc=N;function E(l,w){return l.endsWith(w)?l:l+w}}),define(Pe[297],Me([1,0,70,54,13,38,204,85,296]),function(me,e,S,F,M,O,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$cs)(M.$Mj,new S.$di(R.$Akc,[!0],!0)),(0,F.$cs)(O.$rjc,f.$Imc,0),(0,F.$cs)(m.$Vic,m.$Wic,0)}),define(Pe[303],Me([1,0,23,5,77,292,241,19,89,12,2,295,297]),function(me,e,S,F,M,O,R,m,f,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function s(t){self.fetch=async function(p,u){return p instanceof Request||w(String(p))&&(p=(await t(N.URI.parse(String(p)))).toString(!0)),d(p,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(p,u,o,v,b){(async()=>(w(u.toString())&&(u=(await t(N.URI.parse(u.toString()))).toString(!0)),super.open(p,u,o??!0,v,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(p,u){if(/^file:/i.test(p.toString()))p=k.$Ag.uriToBrowserUri(N.URI.parse(p.toString())).toString(!0);else if(/^vscode-remote:/i.test(p.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(g){function D(A){return typeof A=="string"||A instanceof URL?String(A).replace(/^file:\/\//i,"vscode-file://vscode-app"):A}const y=fetch.bind(self);self.fetch=function(A,G){return A instanceof Request?y(A,G):y(D(A),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(A,G,W,U,C){return super.open(A,D(G),W??!0,U,C)}};const P=importScripts.bind(self);self.importScripts=(...A)=>{P(...A.map(D))},P(g)}.toString()}('${p}'))`;u=u||{},u.name=`${name} -> ${u.name||m.$nc(p.toString())}`;const b=new Blob([v],{type:"application/javascript"}),$=URL.createObjectURL(b);return new t($,u)}}else self.Worker=class extends R.$Jmc{constructor(t,p){super(l,t,{name:m.$nc(t.toString()),...p})}};const a=new class{constructor(){this.pid=void 0}exit(t){E()}};class r{constructor(){const p=new MessageChannel,u=new F.$6d;let o=!1;l(p.port2,[p.port2]),p.port1.onmessage=v=>{const{data:b}=v;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const $=S.$te.wrap(new Uint8Array(b,0,b.byteLength));if((0,M.$Km)($,2)){o=!0,n("received terminate message from renderer");return}u.fire($)},this.protocol={onMessage:u.event,send:v=>{if(!o){const b=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);p.port1.postMessage(b,[b])}}}}}function i(t){return new Promise(p=>{const u=t.onMessage(o=>{u.dispose();const v=JSON.parse(o.toString());t.send((0,M.$Jm)(0)),p({protocol:t,initData:v})});t.send((0,M.$Jm)(1))})}let n=t=>E();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const t=new r;return{onmessage(p){c(p)&&i(t.protocol).then(u=>{f.mark("code/extHost/didWaitForInitData");const o=new O.$Dkc(u.protocol,u.initData,a,null,p.data);s(v=>o.asBrowserUri(v)),n=v=>o.terminate(v)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/workbench/api/worker/extensionHostWorker.js.map
