/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(p){for(var e=[],P=0,S=p.length;P<S;P++)e[P]=J[p[P]];return e};define(J[24],K([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class P{static get(){const k=new Map,C=new Map,r=new Map,c=new Map;function i(h,n){h.has(n.detail)||h.set(n.detail,-n.timestamp)}function u(h,n){const t=h.get(n.detail);t&&(t>=0||h.set(n.detail,t+n.timestamp))}let m=[];typeof p=="function"&&typeof p.getStats=="function"&&(m=p.getStats().slice(0).sort((h,n)=>h.timestamp-n.timestamp));for(const h of m)switch(h.type){case 10:i(k,h);break;case 11:case 12:u(k,h);break;case 21:i(C,h);break;case 22:u(C,h);break;case 33:i(r,h);break;case 34:u(r,h);break;case 31:i(c,h);break;case 32:u(c,h);break}let l=0;r.forEach(h=>l+=h);function b(h){const n=[];return h.forEach((t,s)=>n.push([s,t])),n}return{amdLoad:b(k),amdInvoke:b(C),nodeRequire:b(r),nodeEval:b(c),nodeRequireTotal:l}}static toMarkdownTable(k,C){let r="";const c=[];return k.forEach((i,u)=>{c[u]=i.length}),C.forEach(i=>{i.forEach((u,m)=>{typeof u>"u"&&(u=i[m]="-");const l=u.toString().length;c[m]=Math.max(l,c[m])})}),k.forEach((i,u)=>{r+=`| ${i+" ".repeat(c[u]-i.toString().length)} `}),r+=`|
`,k.forEach((i,u)=>{r+=`| ${"-".repeat(c[u])} `}),r+=`|
`,C.forEach(i=>{i.forEach((u,m)=>{typeof u<"u"&&(r+=`| ${u+" ".repeat(c[m]-u.toString().length)} `)}),r+=`|
`}),r}}e.$U=P}),define(J[4],K([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=C,e.$7c=b;class P{constructor(n,t,s){this.owner=n,this.debugNameSource=t,this.referenceFn=s}getDebugName(n){return C(n,this)}}e.$5c=P;const S=new Map,k=new WeakMap;function C(h,n){const t=k.get(h);if(t)return t;const s=r(h,n);if(s){let d=S.get(s)??0;d++,S.set(s,d);const T=d===1?s:`${s}#${d}`;return k.set(h,T),T}}function r(h,n){const t=k.get(h);if(t)return t;const s=n.owner?m(n.owner)+".":"";let d;const T=n.debugNameSource;if(T!==void 0)if(typeof T=="function"){if(d=T(),d!==void 0)return s+d}else return s+T;const N=n.referenceFn;if(N!==void 0&&(d=b(N),d!==void 0))return s+d;if(n.owner!==void 0){const I=c(n.owner,h);if(I!==void 0)return s+I}}function c(h,n){for(const t in h)if(h[t]===n)return t}const i=new Map,u=new WeakMap;function m(h){const n=u.get(h);if(n)return n;const t=l(h);let s=i.get(t)??0;s++,i.set(t,s);const d=s===1?t:`${t}#${s}`;return u.set(h,d),d}function l(h){const n=h.constructor;return n?n.name:"Object"}function b(h){const n=h.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(s?s[1]:void 0)?.trim()}}),define(J[5],K([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zd=void 0,e.$xd=S,e.$yd=k;let P;function S(t){P=t}function k(){return P}class C{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([c(h("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[c(" "),u(m(s.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),u(m(s.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),u(m(s.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([i("observable value changed"),u(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return u(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,N)=>(this.d.get(s).add(T),d.apply(s,[T,N]))}handleDerivedRecomputed(s,d){const T=this.d.get(s);console.log(...this.b([i("derived recomputed"),u(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(T),{data:[{fn:s._computeFn}]}])),T.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([i("observable from event triggered"),u(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,N)=>(this.d.get(s).add(T),d.apply(s,[T,N]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([i("autorun"),u(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([i("transaction"),u(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$zd=C;function r(t){const s=new Array,d=[];let T="";function N(E){if("length"in E)for(const a of E)a&&N(a);else"text"in E?(T+=`%c${E.text}`,s.push(E.style),E.data&&d.push(...E.data)):"data"in E&&d.push(...E.data)}N(t);const I=[T,...s];return I.push(...d),I}function c(t){return u(t,{color:"black"})}function i(t){return u(n(`${t}: `,10),{color:"black",bold:!0})}function u(t,s={color:"black"}){function d(N){return Object.entries(N).reduce((I,[E,a])=>`${I}${E}:${a};`,"")}const T={color:s.color};return s.strikeThrough&&(T["text-decoration"]="line-through"),s.bold&&(T["font-weight"]="bold"),{text:t,style:d(T)}}function m(t,s){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=s?`"${t}"`:`"${t.substr(0,s-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?l(t,s):b(t,s);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function l(t,s){let d="[ ",T=!0;for(const N of t){if(T||(d+=", "),d.length-5>s){d+="...";break}T=!1,d+=`${m(N,s-d.length)}`}return d+=" ]",d}function b(t,s){let d="{ ",T=!0;for(const[N,I]of Object.entries(t)){if(T||(d+=", "),d.length-5>s){d+="...";break}T=!1,d+=`${N}: ${m(I,s-d.length)}`}return d+=" }",d}function h(t,s){let d="";for(let T=1;T<=s;T++)d+=t;return d}function n(t,s){for(;t.length<s;)t+=" ";return t}}),define(J[7],K([0,1,25,2,4,5]),function(p,e,P,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=void 0,e.$bd=r,e.$cd=c,e.$dd=i,e.$ed=u,e.$fd=m,e.$gd=l;function r(n){return new h(new k.$5c(void 0,void 0,n),n,void 0,void 0)}function c(n,t){return new h(new k.$5c(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}function i(n,t){return new h(new k.$5c(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}function u(n,t){const s=new S.$Sc,d=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(T,N)=>{s.clear(),t(T,N,s)});return(0,S.$Rc)(()=>{d.dispose(),s.dispose()})}function m(n){const t=new S.$Sc,s=c({owner:void 0,debugName:void 0,debugReferenceFn:n},d=>{t.clear(),n(d,t)});return(0,S.$Rc)(()=>{s.dispose(),t.dispose()})}function l(n,t){let s;return c({debugReferenceFn:t},d=>{const T=n.read(d),N=s;s=T,t({lastValue:N,newValue:T})})}var b;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(b||(b={}));class h{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,s,d,T){this.h=t,this._runFn=s,this.i=d,this.j=T,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,C.$yd)()?.handleAutorunCreated(this),this.k(),(0,S.$Kc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,S.$Lc)(this)}k(){if(this.a===3)return;const t=this.f;this.f=this.e,this.e=t,this.a=3;const s=this.c;try{if(!s){(0,C.$yd)()?.handleAutorunTriggered(this);const d=this.g;this.g=this.i?.(),this._runFn(this,d)}}finally{s||(0,C.$yd)()?.handleAutorunFinished(this);for(const d of this.f)d.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const t of this.e)if(t.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$_c)(()=>this.b>=0)}handlePossibleChange(t){this.a===3&&this.e.has(t)&&!this.f.has(t)&&(this.a=1)}handleChange(t,s){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:s,didChange:T=>T===t},this.g))&&(this.a=2)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const s=t.get();return this.e.add(t),this.f.delete(t),s}}e.$hd=h,function(n){n.Observer=h}(r||(e.$bd=r={}))}),define(J[6],K([0,1,4,5]),function(p,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Sd=e.$Qd=e.$Ld=e.$Kd=void 0,e.$Hd=C,e.$Id=c,e.$Jd=u,e.$Md=b,e.$Nd=n,e.$Od=t,e.$Pd=s,e.$Rd=T,e.$Td=I;let k;function C(a){k=a}let r;function c(a){r=a}let i;function u(a){i=a}class m{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,w){const D=w===void 0?void 0:$,z=w===void 0?$:w;return i({owner:D,debugName:()=>{const f=(0,P.$7c)(z);if(f!==void 0)return f;const L=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(z.toString());if(L)return`${this.debugName}.${L[2]}`;if(!D)return`${this.debugName} (mapped)`}},f=>z(this.read(f),f))}recomputeInitiallyAndOnChange($,w){return $.add(k(this,w)),this}keepObserved($){return $.add(r(this)),this}}e.$Kd=m;class l extends m{constructor(){super(...arguments),this.c=new Set}addObserver($){const w=this.c.size;this.c.add($),w===0&&this.f()}removeObserver($){this.c.delete($)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Ld=l;function b(a,$){const w=new d(a,$);try{a(w)}finally{w.finish()}}let h;function n(a){if(h)a(h);else{const $=new d(a,void 0);h=$;try{a($)}finally{$.finish(),h=void 0}}}async function t(a,$){const w=new d(a,$);try{await a(w)}finally{w.finish()}}function s(a,$,w){a?$(a):b($,w)}class d{constructor($,w){this._fn=$,this.b=w,this.a=[],(0,S.$yd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,P.$7c)(this._fn)}updateObserver($,w){this.a.push({observer:$,observable:w}),$.beginUpdate(w)}finish(){const $=this.a;for(let w=0;w<$.length;w++){const{observer:D,observable:z}=$[w];D.endUpdate(z)}this.a=null,(0,S.$yd)()?.handleEndTransaction()}}e.$Qd=d;function T(a,$){return typeof a=="string"?new N(void 0,a,$):new N(a,void 0,$)}class N extends l{get debugName(){return new P.$5c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor($,w,D){super(),this.b=$,this.d=w,this.a=D}get(){return this.a}set($,w,D){if(this.a===$)return;let z;w||(w=z=new d(()=>{},()=>`Setting ${this.debugName}`));try{const f=this.a;this.e($),(0,S.$yd)()?.handleObservableChanged(this,{oldValue:f,newValue:$,change:D,didChange:!0,hadValue:!0});for(const v of this.c)w.updateObserver(v,this),v.handleChange(this,D)}finally{z&&z.finish()}}toString(){return`${this.debugName}: ${this.a}`}e($){this.a=$}}e.$Sd=N;function I(a,$){return typeof a=="string"?new E(void 0,a,$):new E(a,void 0,$)}class E extends N{e($){this.a!==$&&(this.a&&this.a.dispose(),this.a=$)}dispose(){this.a?.dispose()}}e.$Ud=E}),define(J[8],K([0,1,25,2,6,4,5]),function(p,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gd=e.$Ad=void 0,e.$Bd=i,e.$Cd=u,e.$Dd=m,e.$Ed=l,e.$Fd=b;const c=(t,s)=>t===s;e.$Ad=c;function i(t,s){return s!==void 0?new n(new C.$5c(t,void 0,s),s,void 0,void 0,void 0,e.$Ad):new n(new C.$5c(void 0,void 0,t),t,void 0,void 0,void 0,e.$Ad)}function u(t,s){return new n(new C.$5c(t.owner,t.debugName,t.debugReferenceFn),s,void 0,void 0,t.onLastObserverRemoved,t.equalityComparer??e.$Ad)}(0,k.$Jd)(u);function m(t,s){return new n(new C.$5c(t.owner,t.debugName,void 0),s,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??e.$Ad)}function l(t,s){let d,T;s===void 0?(d=t,T=void 0):(T=t,d=s);const N=new S.$Sc;return new n(new C.$5c(T,void 0,d),I=>(N.clear(),d(I,N)),void 0,void 0,()=>N.dispose(),e.$Ad)}function b(t,s){let d,T;s===void 0?(d=t,T=void 0):(T=t,d=s);const N=new S.$Sc;return new n(new C.$5c(T,void 0,d),I=>{N.clear();const E=d(I);return E&&N.add(E),E},void 0,void 0,()=>N.dispose(),e.$Ad)}var h;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(h||(h={}));class n extends k.$Ld{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,d,T,N,I=void 0,E){super(),this.n=s,this._computeFn=d,this.p=T,this.q=N,this.s=I,this.t=E,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$yd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const d=this.e!==0,T=this.h;this.e=3;const N=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,N)}finally{for(const E of this.l)E.removeObserver(this);this.l.clear()}const I=d&&!this.t(T,this.h);if((0,r.$yd)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.h,change:void 0,didChange:I,hadValue:d}),I)for(const E of this.c)E.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const d=this.j===1;if(this.e===3&&(this.e=1,!d))for(const T of this.c)T.handlePossibleChange(this);if(d)for(const T of this.c)T.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const d=[...this.c];for(const T of d)T.endUpdate(this)}(0,P.$_c)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const d of this.c)d.handlePossibleChange(this)}}handleChange(s,d){if(this.k.has(s)&&!this.l.has(s)){const T=this.q?this.q({changedObservable:s,change:d,didChange:I=>I===s},this.m):!0,N=this.e===3;if(T&&(this.e===1||N)&&(this.e=2,N))for(const I of this.c)I.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const d=s.get();return this.k.add(s),this.l.delete(s),d}addObserver(s){const d=!this.c.has(s)&&this.j>0;super.addObserver(s),d&&s.beginUpdate(this)}removeObserver(s){const d=this.c.has(s)&&this.j>0;super.removeObserver(s),d&&s.endUpdate(this)}}e.$Gd=n}),define(J[26],K([0,1,2,7,6,4,8,5]),function(p,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$td=e.$ld=void 0,e.$id=i,e.$jd=m,e.$kd=l,e.$md=h,e.$nd=t,e.$od=d,e.$pd=T,e.$qd=N,e.$rd=I,e.$sd=E,e.$ud=$,e.$vd=w,e.$wd=D;function i(f){return new u(f)}class u extends k.$Kd{constructor(v){super(),this.a=v}get debugName(){return this.toString()}get(){return this.a}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.a}`}}function m(f){const v=(0,k.$Rd)("promiseValue",{});return f.then(L=>{v.set({value:L},void 0)}),v}function l(f,v){return new b(f,v)}class b extends k.$Ld{constructor(v,L){super(),this.h=v,this._getValue=L,this.b=!1,this.l=U=>{const O=this._getValue(U),g=this.a,R=!this.b||g!==O;let q=!1;R&&(this.a=O,this.b&&(q=!0,(0,k.$Pd)(b.globalTransaction,B=>{(0,c.$yd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:R,hadValue:this.b});for(const V of this.c)B.updateObserver(V,this),V.handleChange(this,void 0)},()=>{const B=this.j();return"Event fired"+(B?`: ${B}`:"")})),this.b=!0),q||(0,c.$yd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:R,hadValue:this.b})}}j(){return(0,C.$7c)(this._getValue)}get debugName(){const v=this.j();return"From Event"+(v?`: ${v}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$ld=b,function(f){f.Observer=b;function v(L,U){let O=!1;b.globalTransaction===void 0&&(b.globalTransaction=L,O=!0);try{U()}finally{O&&(b.globalTransaction=void 0)}}f.batchEventsGlobally=v}(l||(e.$kd=l={}));function h(f,v){return new n(f,v)}class n extends k.$Ld{constructor(v,L){super(),this.debugName=v,this.b=L,this.h=()=>{(0,k.$Md)(U=>{for(const O of this.c)U.updateObserver(O,this),O.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function t(f){return typeof f=="string"?new s(f):new s(void 0,f)}class s extends k.$Ld{get debugName(){return new C.$5c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(v,L){super(),this.a=v,this.b=L}trigger(v,L){if(!v){(0,k.$Md)(U=>{this.trigger(U,L)},()=>`Trigger signal ${this.debugName}`);return}for(const U of this.c)v.updateObserver(U,this),U.handleChange(this,L)}get(){}}function d(f,v,L){const U=(0,k.$Rd)("debounced",void 0);let O;return L.add((0,S.$bd)(g=>{const R=f.read(g);O&&clearTimeout(O),O=setTimeout(()=>{(0,k.$Md)(q=>{U.set(R,q)})},v)})),U}function T(f,v){let L=!1,U,O;return l(g=>{const R=(0,S.$bd)(q=>{const B=f.read(q);L?(O&&clearTimeout(O),O=setTimeout(()=>{U=B,g()},v)):(L=!0,U=B)});return{dispose(){R.dispose(),L=!1,U=void 0}}},()=>L?U:f.get())}function N(f,v,L){const U=(0,k.$Rd)("triggeredRecently",!1);let O;return L.add(f(()=>{U.set(!0,void 0),O&&clearTimeout(O),O=setTimeout(()=>{U.set(!1,void 0)},v)})),U}function I(f){const v=new a(!1,void 0);return f.addObserver(v),(0,P.$Rc)(()=>{f.removeObserver(v)})}(0,k.$Id)(I);function E(f,v){const L=new a(!0,v);return f.addObserver(L),v?v(f.get()):f.reportChanges(),(0,P.$Rc)(()=>{f.removeObserver(L)})}(0,k.$Hd)(E);class a{constructor(v,L){this.b=v,this.c=L,this.a=0}beginUpdate(v){this.a++}endUpdate(v){this.a--,this.a===0&&this.b&&(this.c?this.c(v.get()):v.reportChanges())}handlePossibleChange(v){}handleChange(v,L){}}e.$td=a;function $(f){let v;return(0,r.$Bd)(U=>(v=f(U,v),v))}function w(f,v){let L;const U=(0,k.$Rd)("derivedObservableWithWritableCache.counter",0),O=(0,r.$Bd)(f,g=>(U.read(g),L=v(g,L),L));return Object.assign(O,{clearCache:g=>{L=void 0,U.set(U.get()+1,g)}})}function D(f,v,L,U){let O=new z(L,U);return(0,r.$Cd)({debugReferenceFn:L,owner:f,onLastObserverRemoved:()=>{O.dispose(),O=new z(L)}},R=>(O.setItems(v.read(R)),O.getItems()))}class z{constructor(v,L){this.c=v,this.e=L,this.a=new Map,this.b=[]}dispose(){this.a.forEach(v=>v.store.dispose()),this.a.clear()}setItems(v){const L=[],U=new Set(this.a.keys());for(const O of v){const g=this.e?this.e(O):O;let R=this.a.get(g);if(R)U.delete(g);else{const q=new P.$Sc;R={out:this.c(O,q),store:q},this.a.set(g,R)}L.push(R.out)}for(const O of U)this.a.get(O).store.dispose(),this.a.delete(O);this.b=L}getItems(){return this.b}}}),define(J[27],K([0,1,7,6,8,28,4]),function(p,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=void 0,e.$Zd=l,e.$1d=b;class c{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,S.$Rd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}e.$Vd=c;class i{constructor(n){this.a=(0,S.$Rd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(t=>((0,S.$Md)(s=>{this.a.set(new u(t,void 0),s)}),t),t=>{throw(0,S.$Md)(s=>{this.a.set(new u(void 0,t),s)}),t})}}e.$Wd=i;class u{constructor(n,t){this.data=n,this.error=t}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$Xd=u;class m{constructor(n){this.b=n,this.a=new c(()=>new i(this.b())),this.cachedPromiseResult=(0,k.$Bd)(this,t=>this.a.cachedValue.read(t)?.promiseResult.read(t))}getPromise(){return this.a.getValue().promise}}e.$Yd=m;function l(h,n,t){return new Promise((s,d)=>{let T=!0,N=!1;const I=h.map(a=>({isFinished:n(a),error:t?t(a):!1,state:a})),E=(0,P.$bd)(a=>{const{isFinished:$,error:w,state:D}=I.read(a);($||w)&&(T?N=!0:E.dispose(),w?d(w===!0?D:w):s(D))});T=!1,N&&E.dispose()})}function b(h,n){let t,s;n===void 0?(t=h,s=void 0):(s=h,t=n);let d;return new k.$Gd(new r.$5c(s,void 0,t),T=>(d&&d.dispose(!0),d=new C.$de,t(T,d.token)),void 0,void 0,()=>d?.dispose(),k.$Ad)}}),define(J[12],K([0,1,6,8,7,26,27,5]),function(p,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Rd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Td}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Md}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Pd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$Bd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$Cd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$Dd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$Ed}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.$bd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.$gd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.$dd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.$fd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.$cd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.$ed}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return C.$id}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return C.$od}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return C.$ud}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return C.$vd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return C.$rd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return C.$sd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return C.$kd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return C.$jd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return C.$nd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return C.$md}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return C.$qd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$Vd}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$Yd}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$Wd}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$Xd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$Zd}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$1d}}),!1&&(0,c.$xd)(new c.$zd)}),define(J[29],K([0,1,9,2]),function(p,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=k,e.$fe=C,e.$ge=r,e.$he=c,e.$ie=u,e.$je=m,e.$ke=l,e.$le=b,e.$me=h,e.$ne=n,e.$oe=t,e.$pe=s,e.$qe=d,e.$re=T,e.$se=N;function k(I){const E=I;return E?typeof E.read=="function":!1}function C(I){const E=I;return E?[E.on,E.pause,E.resume,E.destroy].every(a=>typeof a=="function"):!1}function r(I){const E=I;return E?C(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}function c(I,E){return new i(I,E)}class i{constructor(E,a){this.e=E,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(a=>a(E))}h(E){this.c.error.length===0?(0,P.$1)(E):this.c.error.slice(0).forEach(a=>a(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,a){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(E,a){if(this.a.destroyed)return;let $;switch(E){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const w=$.indexOf(a);w>=0&&$.splice(w,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach($=>$())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(I,E){const a=[];let $;for(;($=I.read())!==null;)a.push($);return E(a)}function m(I,E,a){const $=[];let w;for(;(w=I.read())!==null&&$.length<a;)$.push(w);return w===null&&$.length>0?E($):{read:()=>{if($.length>0)return $.shift();if(typeof w<"u"){const D=w;return w=void 0,D}return I.read()}}}function l(I,E){return new Promise((a,$)=>{const w=[];b(I,{onData:D=>{E&&w.push(D)},onError:D=>{E?$(D):a(void 0)},onEnd:()=>{a(E?E(w):void 0)}})})}function b(I,E,a){I.on("error",$=>{a?.isCancellationRequested||E.onError($)}),I.on("end",()=>{a?.isCancellationRequested||E.onEnd()}),I.on("data",$=>{a?.isCancellationRequested||E.onData($)})}function h(I,E){return new Promise((a,$)=>{const w=new S.$Sc,D=[],z=L=>{if(D.push(L),D.length>E)return w.dispose(),I.pause(),a({stream:I,buffer:D,ended:!1})},f=L=>(w.dispose(),$(L)),v=()=>(w.dispose(),a({stream:I,buffer:D,ended:!0}));w.add((0,S.$Rc)(()=>I.removeListener("error",f))),I.on("error",f),w.add((0,S.$Rc)(()=>I.removeListener("end",v))),I.on("end",v),w.add((0,S.$Rc)(()=>I.removeListener("data",z))),I.on("data",z)})}function n(I,E){const a=c(E);return a.end(I),a}function t(){const I=c(()=>{throw new Error("not supported")});return I.end(),I}function s(I){let E=!1;return{read:()=>E?null:(E=!0,I)}}function d(I,E,a){const $=c(a);return b(I,{onData:w=>$.write(E.data(w)),onError:w=>$.error(E.error?E.error(w):w),onEnd:()=>$.end()}),$}function T(I,E,a){let $=!1;return{read:()=>{const w=E.read();return $?w:($=!0,w!==null?a([I,w]):I)}}}function N(I,E,a){let $=!1;const w=c(a);return b(E,{onData:D=>$?w.write(D):($=!0,w.write(a([I,D]))),onError:D=>w.error(D),onEnd:()=>{$||($=!0,w.write(I)),w.end()}}),w}}),define(J[13],K([0,1,30,29]),function(p,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=void 0,e.$ue=u,e.$ve=m,e.$we=l,e.$xe=b,e.$ye=h,e.$ze=n,e.$Ae=t,e.$Be=s,e.$Ce=d,e.$De=T,e.$Ee=N,e.$Fe=I,e.$Ge=E,e.$He=a,e.$Ie=$,e.$Je=w,e.$Ke=D,e.$Le=z,e.$Me=f,e.$Ne=U;const k=typeof Buffer<"u",C=new P.$V(()=>new Uint8Array(256));let r,c;class i{static alloc(g){return k?new i(Buffer.allocUnsafe(g)):new i(new Uint8Array(g))}static wrap(g){return k&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new i(g)}static fromString(g,R){return!(R?.dontUseNodeBuffer||!1)&&k?new i(Buffer.from(g)):(r||(r=new TextEncoder),new i(r.encode(g)))}static fromByteArray(g){const R=i.alloc(g.length);for(let q=0,B=g.length;q<B;q++)R.buffer[q]=g[q];return R}static concat(g,R){if(typeof R>"u"){R=0;for(let V=0,H=g.length;V<H;V++)R+=g[V].byteLength}const q=i.alloc(R);let B=0;for(let V=0,H=g.length;V<H;V++){const W=g[V];q.set(W,B),B+=W.byteLength}return q}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=i.alloc(this.byteLength);return g.set(this),g}toString(){return k?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(g,R){return new i(this.buffer.subarray(g,R))}set(g,R){if(g instanceof i)this.buffer.set(g.buffer,R);else if(g instanceof Uint8Array)this.buffer.set(g,R);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),R);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,R){h(this.buffer,g,R)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,R){t(this.buffer,g,R)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,R){d(this.buffer,g,R)}indexOf(g,R=0){return u(this.buffer,g instanceof i?g.buffer:g,R)}}e.$te=i;function u(O,g,R=0){const q=g.byteLength,B=O.byteLength;if(q===0)return 0;if(q===1)return O.indexOf(g[0]);if(q>B-R)return-1;const V=C.value;V.fill(g.length);for(let X=0;X<g.length;X++)V[g[X]]=g.length-X-1;let H=R+g.length-1,W=H,G=-1;for(;H<B;)if(O[H]===g[W]){if(W===0){G=H;break}H--,W--}else H+=Math.max(g.length-W,V[O[H]]),W=g.length-1;return G}function m(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0}function l(O,g,R){O[R+0]=g&255,g=g>>>8,O[R+1]=g&255}function b(O,g){return O[g]*2**24+O[g+1]*2**16+O[g+2]*2**8+O[g+3]}function h(O,g,R){O[R+3]=g,g=g>>>8,O[R+2]=g,g=g>>>8,O[R+1]=g,g=g>>>8,O[R]=g}function n(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0|O[g+2]<<16>>>0|O[g+3]<<24>>>0}function t(O,g,R){O[R+0]=g&255,g=g>>>8,O[R+1]=g&255,g=g>>>8,O[R+2]=g&255,g=g>>>8,O[R+3]=g&255}function s(O,g){return O[g]}function d(O,g,R){O[R]=g}function T(O){return S.$ie(O,g=>i.concat(g))}function N(O){return S.$pe(O)}function I(O){return S.$ke(O,g=>i.concat(g))}async function E(O){return O.ended?i.concat(O.buffer):i.concat([...O.buffer,await I(O.stream)])}function a(O){return S.$ne(O,g=>i.concat(g))}function $(O){return S.$qe(O,{data:g=>typeof g=="string"?i.fromString(g):i.wrap(g)},g=>i.concat(g))}function w(O){return S.$he(g=>i.concat(g),O)}function D(O,g){return S.$re(O,g,R=>i.concat(R))}function z(O,g){return S.$se(O,g,R=>i.concat(R))}function f(O){let g=0,R=0,q=0;const B=new Uint8Array(Math.floor(O.length/4*3)),V=W=>{switch(R){case 3:B[q++]=g|W,R=0;break;case 2:B[q++]=g|W>>>2,g=W<<6,R=3;break;case 1:B[q++]=g|W>>>4,g=W<<4,R=2;break;default:g=W<<2,R=1}};for(let W=0;W<O.length;W++){const G=O.charCodeAt(W);if(G>=65&&G<=90)V(G-65);else if(G>=97&&G<=122)V(G-97+26);else if(G>=48&&G<=57)V(G-48+52);else if(G===43||G===45)V(62);else if(G===47||G===95)V(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${O[W]}`)}}const H=q;for(;R>0;)V(0);return i.wrap(B).slice(0,H)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:O},g=!0,R=!1){const q=R?L:v;let B="";const V=O.byteLength%3;let H=0;for(;H<O.byteLength-V;H+=3){const W=O[H+0],G=O[H+1],X=O[H+2];B+=q[W>>>2],B+=q[(W<<4|G>>>4)&63],B+=q[(G<<2|X>>>6)&63],B+=q[X&63]}if(V===1){const W=O[H+0];B+=q[W>>>2],B+=q[W<<4&63],g&&(B+="==")}else if(V===2){const W=O[H+0],G=O[H+1];B+=q[W>>>2],B+=q[(W<<4|G>>>4)&63],B+=q[G<<2&63],g&&(B+="=")}return B}}),define(J[31],K([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(J[14],K([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=S;var P;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function S(k){let C=0,r=0,c=0,i=0;for(let u=0,m=k.length;u<m;u++){const l=k.charCodeAt(u);l===13?(C===0&&(r=u),C++,u+1<m&&k.charCodeAt(u+1)===10?(i|=2,u++):i|=3,c=u+1):l===10&&(i|=1,C===0&&(r=u),C++,c=u+1)}return C===0&&(r=k.length),[C,r,k.length-c,i]}}),define(J[15],K([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var S;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var k;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var C;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var r;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class c{static getLanguageId(u){return(u&255)>>>0}static getTokenType(u){return(u&768)>>>8}static containsBalancedBrackets(u){return(u&1024)!==0}static getFontStyle(u){return(u&30720)>>>11}static getForeground(u){return(u&16744448)>>>15}static getBackground(u){return(u&4278190080)>>>24}static getClassNameFromMetadata(u){let l="mtk"+this.getForeground(u);const b=this.getFontStyle(u);return b&1&&(l+=" mtki"),b&2&&(l+=" mtkb"),b&4&&(l+=" mtku"),b&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(u,m){const l=this.getForeground(u),b=this.getFontStyle(u);let h=`color: ${m[l]};`;b&1&&(h+="font-style: italic;"),b&2&&(h+="font-weight: bold;");let n="";return b&4&&(n+=" underline"),b&8&&(n+=" line-through"),n&&(h+=`text-decoration:${n};`),h}static getPresentationFromMetadata(u){const m=this.getForeground(u),l=this.getFontStyle(u);return{foreground:m,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$It=c}),define(J[32],K([0,1,33]),function(p,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,c){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=c}replace(r,c,i){if(r>=this.a.length)return;if(c===0){this.insert(r,i);return}else if(i===0){this.delete(r,c);return}const u=this.a.slice(0,r),m=this.a.slice(r+c),l=k(i,this.b);this.a=u.concat(l,m)}delete(r,c){c===0||r>=this.a.length||this.a.splice(r,c)}insert(r,c){if(c===0||r>=this.a.length)return;const i=[];for(let u=0;u<c;u++)i[u]=this.b;this.a=(0,P.$Wb)(this.a,r,i)}}e.$zC=S;function k(C,r){const c=[];for(let i=0;i<C;i++)c[i]=r;return c}}),define(J[10],K([0,1,15]),function(p,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class S{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,c){const i=S.defaultTokenMetadata,u=new Uint32Array(2);return u[0]=r.length,u[1]=i,new S(u,r,c)}constructor(r,c,i){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=c,this.d=i}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,c,i){if(this.c!==r.c||this.b!==r.b)return!1;const u=c<<1,m=u+(i<<1);for(let l=u;l<m;l++)if(this.a[l]!==r.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const c=this.a[(r<<1)+1],i=P.$It.getLanguageId(c);return this.d.decodeLanguageId(i)}getStandardTokenType(r){const c=this.a[(r<<1)+1];return P.$It.getTokenType(c)}getForeground(r){const c=this.a[(r<<1)+1];return P.$It.getForeground(c)}getClassName(r){const c=this.a[(r<<1)+1];return P.$It.getClassNameFromMetadata(c)}getInlineStyle(r,c){const i=this.a[(r<<1)+1];return P.$It.getInlineStyleFromMetadata(i,c)}getPresentation(r){const c=this.a[(r<<1)+1];return P.$It.getPresentationFromMetadata(c)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,c,i){return new k(this,r,c,i)}static convertToEndOffset(r,c){const u=(r.length>>>1)-1;for(let m=0;m<u;m++)r[m<<1]=r[m+1<<1];r[u<<1]=c}static findIndexInTokensArray(r,c){if(r.length<=2)return 0;let i=0,u=(r.length>>>1)-1;for(;i<u;){const m=i+Math.floor((u-i)/2),l=r[m<<1];if(l===c)return m+1;l<c?i=m+1:l>c&&(u=m)}return i}withInserted(r){if(r.length===0)return this;let c=0,i=0,u="";const m=new Array;let l=0;for(;;){const b=c<this.b?this.a[c<<1]:-1,h=i<r.length?r[i]:null;if(b!==-1&&(h===null||b<=h.offset)){u+=this.c.substring(l,b);const n=this.a[(c<<1)+1];m.push(u.length,n),c++,l=b}else if(h){if(h.offset>l){u+=this.c.substring(l,h.offset);const n=this.a[(c<<1)+1];m.push(u.length,n),l=h.offset}u+=h.text,m.push(u.length,h.tokenMetadata),i++}else break}return new S(new Uint32Array(m),u,this.d)}}e.$Lt=S;class k{constructor(r,c,i,u){this.a=r,this.b=c,this.c=i,this.d=u,this.e=r.findTokenIndexAtOffset(c),this.f=0;for(let m=this.e,l=r.getCount();m<l&&!(r.getStartOffset(m)>=i);m++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof k?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const c=this.a.getEndOffset(this.e+r);return Math.min(this.c,c)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,c){return this.a.getInlineStyle(this.e+r,c)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(J[34],K([0,1,10]),function(p,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Mt=void 0,e.$Ot=k,e.$Mt=new Uint32Array(0).buffer;class S{static deleteBeginning(r,c){return r===null||r===e.$Mt?r:S.delete(r,0,c)}static deleteEnding(r,c){if(r===null||r===e.$Mt)return r;const i=k(r),u=i[i.length-2];return S.delete(r,c,u)}static delete(r,c,i){if(r===null||r===e.$Mt||c===i)return r;const u=k(r),m=u.length>>>1;if(c===0&&u[u.length-2]===i)return e.$Mt;const l=P.$Lt.findIndexInTokensArray(u,c),b=l>0?u[l-1<<1]:0,h=u[l<<1];if(i<h){const T=i-c;for(let N=l;N<m;N++)u[N<<1]-=T;return r}let n,t;b!==c?(u[l<<1]=c,n=l+1<<1,t=c):(n=l<<1,t=b);const s=i-c;for(let T=l+1;T<m;T++){const N=u[T<<1]-s;N>t&&(u[n++]=N,u[n++]=u[(T<<1)+1],t=N)}if(n===u.length)return r;const d=new Uint32Array(n);return d.set(u.subarray(0,n),0),d.buffer}static append(r,c){if(c===e.$Mt)return r;if(r===e.$Mt)return c;if(r===null)return r;if(c===null)return null;const i=k(r),u=k(c),m=u.length>>>1,l=new Uint32Array(i.length+u.length);l.set(i,0);let b=i.length;const h=i[i.length-2];for(let n=0;n<m;n++)l[b++]=u[n<<1]+h,l[b++]=u[(n<<1)+1];return l.buffer}static insert(r,c,i){if(r===null||r===e.$Mt)return r;const u=k(r),m=u.length>>>1;let l=P.$Lt.findIndexInTokensArray(u,c);l>0&&u[l-1<<1]===c&&l--;for(let b=l;b<m;b++)u[b<<1]+=i;return r}}e.$Nt=S;function k(C){return C instanceof Uint32Array?C:new Uint32Array(C)}}),define(J[35],K([0,1,33,13,47,14,34,16]),function(p,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class i{static deserialize(m,l,b){const h=new Uint32Array(m.buffer),n=(0,S.$xe)(m,l);l+=4;const t=(0,S.$xe)(m,l);l+=4;const s=[];for(let d=0;d<t;d++){const T=(0,S.$xe)(m,l);l+=4,s.push(h.subarray(l/4,l/4+T/4)),l+=T}return b.push(new i(n,s)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(m,l){this.a=m,this.b=l}getLineRange(){return new c.$ht(this.a,this.a+this.b.length)}getLineTokens(m){return this.b[m-this.a]}appendLineTokens(m){this.b.push(m)}serializeSize(){let m=0;m+=4,m+=4;for(let l=0;l<this.b.length;l++){const b=this.b[l];if(!(b instanceof Uint32Array))throw new Error("Not supported!");m+=4,m+=b.byteLength}return m}serialize(m,l){(0,S.$ye)(m,this.a,l),l+=4,(0,S.$ye)(m,this.b.length,l),l+=4;for(let b=0;b<this.b.length;b++){const h=this.b[b];if(!(h instanceof Uint32Array))throw new Error("Not supported!");(0,S.$ye)(m,h.byteLength,l),l+=4,m.set(new Uint8Array(h.buffer),l),l+=h.byteLength}return l}applyEdit(m,l){const[b,h]=(0,C.$Kt)(l);this.c(m),this.d(new k.$0s(m.startLineNumber,m.startColumn),b,h)}c(m){if(m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn)return;const l=m.startLineNumber-this.a,b=m.endLineNumber-this.a;if(b<0){const h=b-l;this.a-=h;return}if(!(l>=this.b.length)){if(l<0&&b>=this.b.length){this.a=0,this.b=[];return}if(l===b){this.b[l]=r.$Nt.delete(this.b[l],m.startColumn-1,m.endColumn-1);return}if(l>=0)if(this.b[l]=r.$Nt.deleteEnding(this.b[l],m.startColumn-1),b<this.b.length){const h=r.$Nt.deleteBeginning(this.b[b],m.endColumn-1);this.b[l]=r.$Nt.append(this.b[l],h),this.b.splice(l+1,b-l)}else this.b[l]=r.$Nt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const h=-l;this.a-=h,this.b[b]=r.$Nt.deleteBeginning(this.b[b],m.endColumn-1),this.b=this.b.slice(b)}}}d(m,l,b){if(l===0&&b===0)return;const h=m.lineNumber-this.a;if(h<0){this.a+=l;return}if(!(h>=this.b.length)){if(l===0){this.b[h]=r.$Nt.insert(this.b[h],m.column-1,b);return}this.b[h]=r.$Nt.deleteEnding(this.b[h],m.column-1),this.b[h]=r.$Nt.insert(this.b[h],m.column-1,b),this.e(m.lineNumber,l)}}e(m,l){if(l===0)return;const b=[];for(let h=0;h<l;h++)b[h]=null;this.b=P.$Wb(this.b,m,b)}}e.$Pt=i}),define(J[17],K([0,1,13,35]),function(p,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0;class k{static deserialize(r){let c=0;const i=(0,P.$xe)(r,c);c+=4;const u=[];for(let m=0;m<i;m++)c=S.$Pt.deserialize(r,c,u);return u}constructor(){this.a=[]}add(r,c){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===r){i.appendLineTokens(c);return}}this.a.push(new S.$Pt(r,[c]))}finalize(){return this.a}serialize(){const r=this.b(),c=new Uint8Array(r);return this.c(c),c}b(){let r=0;r+=4;for(let c=0;c<this.a.length;c++)r+=this.a[c].serializeSize();return r}c(r){let c=0;(0,P.$ye)(r,this.a.length,c),c+=4;for(let i=0;i<this.a.length;i++)c=this.a[i].serialize(r,c)}}e.$AC=k}),define(J[36],K([0,1,18,3,19,48]),function(p,e,P,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=r,e.$ag=c,e.$bg=i,e.$cg=u,e.$dg=m,e.$eg=n,e.$fg=t,e.$gg=s,e.$hg=d,e.$ig=T,e.$jg=N,e.$kg=I,e.$lg=E,e.$mg=a,e.$ng=$,e.$og=z;function r(f){return f===47||f===92}function c(f){return f.replace(/[\\/]/g,P.$gc.sep)}function i(f){return f.indexOf("/")===-1&&(f=c(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function u(f,v=P.$gc.sep){if(!f)return"";const L=f.length,U=f.charCodeAt(0);if(r(U)){if(r(f.charCodeAt(1))&&!r(f.charCodeAt(2))){let g=3;const R=g;for(;g<L&&!r(f.charCodeAt(g));g++);if(R!==g&&!r(f.charCodeAt(g+1))){for(g+=1;g<L;g++)if(r(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,v)}}return v}else if(d(U)&&f.charCodeAt(1)===58)return r(f.charCodeAt(2))?f.slice(0,2)+v:f.slice(0,2);let O=f.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(r(f.charCodeAt(O)))return f.slice(0,O+1)}return""}function m(f){if(!S.$i||!f||f.length<5)return!1;let v=f.charCodeAt(0);if(v!==92||(v=f.charCodeAt(1),v!==92))return!1;let L=2;const U=L;for(;L<f.length&&(v=f.charCodeAt(L),v!==92);L++);return!(U===L||(v=f.charCodeAt(L+1),isNaN(v)||v===92))}const l=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,v=S.$i){const L=v?l:b;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||v&&h.test(f)||f==="."||f===".."||v&&f[f.length-1]==="."||v&&f.length!==f.trim().length||f.length>255)}function t(f,v,L){const U=f===v;return!L||U?U:!f||!v?!1:(0,k.$kf)(f,v)}function s(f,v,L,U=P.sep){if(f===v)return!0;if(!f||!v||v.length>f.length)return!1;if(L){if(!(0,k.$lf)(f,v))return!1;if(v.length===f.length)return!0;let g=v.length;return v.charAt(v.length-1)===U&&g--,f.charAt(g)===U}return v.charAt(v.length-1)!==U&&(v+=U),f.indexOf(v)===0}function d(f){return f>=65&&f<=90||f>=97&&f<=122}function T(f,v){return S.$i&&f.endsWith(":")&&(f+=P.sep),(0,P.$ic)(f)||(f=(0,P.$jc)(v,f)),f=(0,P.$hc)(f),S.$i?(f=(0,k.$5e)(f,P.sep),f.endsWith(":")&&(f+=P.sep)):(f=(0,k.$5e)(f,P.sep),f||(f=P.sep)),f}function N(f){const v=(0,P.$hc)(f);return S.$i?f.length>3?!1:I(v)&&(f.length===2||v.charCodeAt(2)===92):v===P.$gc.sep}function I(f,v=S.$i){return v?d(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function E(f,v=S.$i){return I(f,v)?f[0]:void 0}function a(f,v,L){return v.length>f.length?-1:f===v?0:(L&&(f=f.toLowerCase(),v=v.toLowerCase()),f.indexOf(v))}function $(f){const v=f.split(":");let L,U,O;for(const g of v){const R=Number(g);(0,C.$Xf)(R)?U===void 0?U=R:O===void 0&&(O=R):L=L?[L,g].join(":"):g}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:U!==void 0?U:void 0,column:O!==void 0?O:U!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(f,v,L=8){let U="";for(let g=0;g<L;g++){let R;g===0&&S.$i&&!v&&(L===3||L===4)?R=D:R=w,U+=R.charAt(Math.floor(Math.random()*R.length))}let O;return v?O=`${v}-${U}`:O=U,f?(0,P.$jc)(f,O):O}}),define(J[20],K([0,1,9,3,19,11,18]),function(p,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$tg=e.$sg=e.$rg=e.Schemas=void 0,e.$pg=i,e.$qg=u,e.$ug=l;var c;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.codeSetting="code-setting"})(c||(e.Schemas=c={}));function i(n,t){return C.URI.isUri(n)?(0,k.$kf)(n.scheme,t):(0,k.$lf)(n,t+":")}function u(n,...t){return t.some(s=>i(n,s))}e.$rg="vscode-tkn",e.$sg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,s){this.f=l(t,s)}getServerRootPath(){return this.f}get g(){return r.$gc.join(this.f,c.vscodeRemoteResource)}set(t,s,d){this.a[t]=s,this.b[t]=d}setConnectionToken(t,s){this.c[t]=s}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(E){return P.$1(E),t}const s=t.authority;let d=this.a[s];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const T=this.b[s],N=this.c[s];let I=`path=${encodeURIComponent(t.path)}`;return typeof N=="string"&&(I+=`&${e.$sg}=${encodeURIComponent(N)}`),C.URI.from({scheme:S.$o?this.d:c.vscodeRemoteResource,authority:`${d}:${T}`,path:this.g,query:I})}}e.$tg=new m;function l(n,t){return r.$gc.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class b{static{this.a=e.$zg}asBrowserUri(t){const s=this.b(t,p);return this.uriToBrowserUri(s)}uriToBrowserUri(t){return t.scheme===c.vscodeRemote?e.$tg.rewrite(t):t.scheme===c.file&&(S.$m||S.$q===`${c.vscodeFileResource}://${b.a}`)?t.with({scheme:c.vscodeFileResource,authority:t.authority||b.a,query:null,fragment:null}):t}asFileUri(t){const s=this.b(t,p);return this.uriToFileUri(s)}uriToFileUri(t){return t.scheme===c.vscodeFileResource?t.with({scheme:c.file,authority:t.authority!==b.a?t.authority:null,query:null,fragment:null}):t}b(t,s){return C.URI.isUri(t)?t:C.URI.parse(s.toUrl(t))}}e.$Ag=new b;var h;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const s="vscode-coi";function d(N){let I;typeof N=="string"?I=new URL(N).searchParams:N instanceof URL?I=N.searchParams:C.URI.isUri(N)&&(I=new URL(N.toString(!0)).searchParams);const E=I?.get(s);if(E)return t.get(E)}n.getHeadersFromQuery=d;function T(N,I,E){if(!globalThis.crossOriginIsolated)return;const a=I&&E?"3":E?"2":"1";N instanceof URLSearchParams?N.set(s,a):N[s]=a}n.addSearchParam=T})(h||(e.COI=h={}))}),define(J[37],K([0,1,24,20,3,11]),function(p,e,P,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=m;class r{constructor(b,h,n){this.id=b,this.dependencies=h,this.callback=n}}class c{static{this.INSTANCE=new c}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,h,n)=>{typeof b!="string"&&(n=h,h=b,b=null),(typeof h!="object"||!Array.isArray(h))&&(n=h,h=null),this.c.push(new r(b,h,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const h=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!h)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(b){return new Promise((h,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const s=()=>{t.removeEventListener("load",d),t.removeEventListener("error",T)},d=N=>{s(),h(this.c.pop())},T=N=>{s(),n(N)};t.addEventListener("load",d),t.addEventListener("error",T),this.f&&(b=this.f.createScriptURL(b)),t.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(t)})}i(b){return new Promise((h,n)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),h(this.c.pop())}catch(t){n(t)}})}async j(b){try{const h=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,s=C.URI.parse(b).fsPath,d=h.readFileSync(s).toString(),T=t.wrap(d.replace(/^#!.*/,""));return new n.Script(T).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const i=new Map;let u={};typeof globalThis.require=="object"&&(u=globalThis.require.paths??{});async function m(l,b,h){if(P.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),u[l]&&(l=u[l]);const n=`${l}/${b}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const N=`${h&&!k.$o?S.$xg:S.$wg}/${n}`;t=S.$Ag.asBrowserUri(N).toString(!0)}const s=c.INSTANCE.load(t);return i.set(n,s),s}else return await new Promise((n,t)=>{p([l],n,t)})}}),define(J[21],K([0,1,36,20,18,3,19,11]),function(p,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=void 0,e.$Hg=i,e.$3g=m,e.$4g=b;function i(h){return(0,c.$wc)(h,!0)}class u{constructor(n){this.a=n}compare(n,t,s=!1){return n===t?0:(0,r.$df)(this.getComparisonKey(n,s),this.getComparisonKey(t,s))}isEqual(n,t,s=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,s)===this.getComparisonKey(t,s)}getComparisonKey(n,t=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,t,s=!1){if(n.scheme===t.scheme){if(n.scheme===S.Schemas.file)return P.$gg(i(n),i(t),this.a(n))&&n.query===t.query&&(s||n.fragment===t.fragment);if((0,e.$Yg)(n.authority,t.authority))return P.$gg(n.path,t.path,this.a(n),"/")&&n.query===t.query&&(s||n.fragment===t.fragment)}return!1}joinPath(n,...t){return c.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.$Qg)(n)||n.authority}basename(n){return k.$gc.basename(n.path)}extname(n){return k.$gc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===S.Schemas.file?t=c.URI.file(k.$mc(i(n))).path:(t=k.$gc.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===S.Schemas.file?t=c.URI.file(k.$hc(i(n))).path:t=k.$gc.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.$Yg)(n.authority,t.authority))return;if(n.scheme===S.Schemas.file){const T=k.$lc(i(n),i(t));return C.$i?P.$ag(T):T}let s=n.path||"/";const d=t.path||"/";if(this.a(n)){let T=0;for(const N=Math.min(s.length,d.length);T<N&&!(s.charCodeAt(T)!==d.charCodeAt(T)&&s.charAt(T).toLowerCase()!==d.charAt(T).toLowerCase());T++);s=d.substr(0,T)+s.substr(T)}return k.$gc.relative(s,d)}resolvePath(n,t){if(n.scheme===S.Schemas.file){const s=c.URI.file(k.$kc(i(n),t));return n.with({authority:s.authority,path:s.path})}return t=P.$bg(t),n.with({path:k.$gc.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,r.$kf)(n,t)}hasTrailingPathSeparator(n,t=k.sep){if(n.scheme===S.Schemas.file){const s=i(n);return s.length>P.$cg(s).length&&s[s.length-1]===t}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=k.sep){return(0,e.$Zg)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=k.sep){let s=!1;if(n.scheme===S.Schemas.file){const d=i(n);s=d!==void 0&&d.length===P.$cg(d).length&&d[d.length-1]===t}else{t="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$Zg)(n,t)?n.with({path:n.path+"/"}):n}}e.$Ig=u,e.$Jg=new u(()=>!1),e.$Kg=new u(h=>h.scheme===S.Schemas.file?!C.$k:!0),e.$Lg=new u(h=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function m(h,n){const t=[];for(let s=0;s<h.length;s++){const d=n(h[s]);h.some((T,N)=>N===s?!1:(0,e.$Ng)(d,n(T)))||t.push(h[s])}return t}var l;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function n(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(N=>{const[I,E]=N.split(":");I&&E&&s.set(I,E)});const T=t.path.substring(0,t.path.indexOf(";"));return T&&s.set(h.META_DATA_MIME,T),s}h.parseMetaData=n})(l||(e.DataUri=l={}));function b(h,n,t){if(n){let s=h.path;return s&&s[0]!==k.$gc.sep&&(s=k.$gc.sep+s),h.with({scheme:t,authority:n,path:s})}return h.with({scheme:t})}}),define(J[22],K([0,1,28,9,38,2,21,3,31,30]),function(p,e,P,S,k,C,r,c,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$5g=m,e.$6g=l,e.$7g=b,e.$8g=h,e.$9g=n,e.$0g=t,e.$$g=s,e.$_g=d,e.$hh=f,e.$ih=v,e.$jh=L,e.$kh=U,e.$lh=O,e.$Ah=ue,e.$Ih=le;function m(M){return!!M&&typeof M.then=="function"}function l(M){const o=new P.$de,y=M(o.token),A=new Promise((j,F)=>{const _=o.token.onCancellationRequested(()=>{_.dispose(),F(new S.$5)});Promise.resolve(y).then(Z=>{_.dispose(),o.dispose(),j(Z)},Z=>{_.dispose(),o.dispose(),F(Z)})});return new class{cancel(){o.cancel(),o.dispose()}then(j,F){return A.then(j,F)}catch(j){return this.then(void 0,j)}finally(j){return A.finally(j)}}}function b(M,o,y){return new Promise((A,j)=>{const F=o.onCancellationRequested(()=>{F.dispose(),A(y)});M.then(A,j).finally(()=>F.dispose())})}function h(M,o){return new Promise((y,A)=>{const j=o.onCancellationRequested(()=>{j.dispose(),A(new S.$5)});M.then(y,A).finally(()=>j.dispose())})}async function n(M){let o=-1;const y=M.map((A,j)=>A.then(F=>(o=j,F)));try{return await Promise.race(y)}finally{M.forEach((A,j)=>{j!==o&&A.cancel()})}}function t(M,o,y){let A;const j=setTimeout(()=>{A?.(void 0),y?.()},o);return Promise.race([M.finally(()=>clearTimeout(j)),new Promise(F=>A=F)])}function s(M){return new Promise((o,y)=>{const A=M();m(A)?A.then(o,y):o(A)})}function d(){let M,o;return{promise:new Promise((A,j)=>{M=A,o=j}),resolve:M,reject:o}}class T{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const y=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(y,y).then(A)})}return new Promise((y,A)=>{this.b.then(y,A)})}return this.a=o(),new Promise((y,A)=>{this.a.then(j=>{this.a=null,y(j)},j=>{this.a=null,A(j)})})}dispose(){this.f=!0}}e.$ah=T;class N{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$bh=N;class I{constructor(){this.a=new Map}queue(o,y){const j=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(o)===j&&this.a.delete(o)});return this.a.set(o,j),j}}e.$ch=I;const E=(M,o)=>{let y=!0;const A=setTimeout(()=>{y=!1,o()},M);return{isTriggered:()=>y,dispose:()=>{clearTimeout(A),y=!1}}},a=M=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,M())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class ${constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,y=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((j,F)=>{this.d=j,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=y===i.$3d?a(A):E(y,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=$;class w{constructor(o){this.a=new $(o),this.b=new T}trigger(o,y){return this.a.trigger(()=>this.b.queue(o),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=w;class D{constructor(){this.a=!1,this.b=new Promise((o,y)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=D;class z extends D{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$gh=z;function f(M,o){return o?new Promise((y,A)=>{const j=setTimeout(()=>{F.dispose(),y()},M),F=o.onCancellationRequested(()=>{clearTimeout(j),F.dispose(),A(new S.$5)})}):l(y=>f(M,y))}function v(M,o=0,y){const A=setTimeout(()=>{M(),y&&j.dispose()},o),j=(0,C.$Rc)(()=>{clearTimeout(A),y?.deleteAndLeak(j)});return y?.add(j),j}function L(M){const o=[];let y=0;const A=M.length;function j(){return y<A?M[y++]():null}function F(_){_!=null&&o.push(_);const Z=j();return Z?Z.then(F):Promise.resolve(o)}return Promise.resolve(null).then(F)}function U(M,o=A=>!!A,y=null){let A=0;const j=M.length,F=()=>{if(A>=j)return Promise.resolve(y);const _=M[A++];return Promise.resolve(_()).then(Q=>o(Q)?Promise.resolve(Q):F())};return F()}function O(M,o=A=>!!A,y=null){if(M.length===0)return Promise.resolve(y);let A=M.length;const j=()=>{A=-1;for(const F of M)F.cancel?.()};return new Promise((F,_)=>{for(const Z of M)Z.then(Q=>{--A>=0&&o(Q)?(j(),F(Q)):A===0&&F(y)}).catch(Q=>{--A>=0&&(j(),_(Q))})})}class g{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new k.$6d}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((y,A)=>{this.g.push({factory:o,c:y,e:A}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const y=o.factory();y.then(o.c,o.e),y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=g;class R extends g{constructor(){super(1)}}e.$nh=R;class q{constructor(){this.a=new te,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$oh=q;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new x;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,y=r.$Jg){const A=y.getComparisonKey(o);return this.a.get(A)?.size??0}queueFor(o,y,A=r.$Jg){const j=A.getComparisonKey(o);let F=this.a.get(j);if(!F){F=new R;const _=this.f++,Z=k.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(j),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$3c),this.d.set(_,Z),this.a.set(j,F)}return F.queue(y)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=B;class V{constructor(o,y){this.a=-1,typeof o=="function"&&typeof y=="number"&&this.setIfNotSet(o,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},y)}setIfNotSet(o,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},y))}}e.$qh=V;class H{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,y,A=globalThis){this.cancel();const j=A.setInterval(()=>{o()},y);this.d=(0,C.$Rc)(()=>{A.clearInterval(j),this.d=void 0})}dispose(){this.cancel()}}e.$rh=H;class W{constructor(o,y){this.b=-1,this.a=o,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=W;class G{constructor(o,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=o,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=G;class X extends W{constructor(o,y){super(o,y),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$uh=X;class oe extends C.$Tc{constructor(o,y){super(),this.g=o,this.h=y,this.a=[],this.b=this.B(new C.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of o)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(M,o)=>{(0,c.$B)(()=>{if(y)return;const A=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$xh=(M,o,y)=>{const A=M.requestIdleCallback(o,typeof y=="number"?{timeout:y}:void 0);let j=!1;return{dispose(){j||(j=!0,M.cancelIdleCallback(A))}}},e.$wh=M=>(0,e.$xh)(globalThis,M)}();class ee{constructor(o,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(A){this.l=A}finally{this.g=!0}},this.f=(0,e.$xh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=ee;class he extends ee{constructor(o){super(globalThis,o)}}e.$zh=he;async function ue(M,o,y){let A;for(let j=0;j<y;j++)try{return await M()}catch(F){A=F,await f(o)}throw A}class te{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,y,A){return this.a={taskId:o,cancel:()=>A?.(),promise:y},y.then(()=>this.d(o),()=>this.d(o)),y}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:y,resolve:A,reject:j}=d();this.b={run:o,promise:y,promiseResolve:A,promiseReject:j}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=te;class ce{constructor(o,y=()=>Date.now()){this.d=o,this.f=y,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$Ch=ce;var ne;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,y)=>{this.a=o,this.b=y})}complete(o){return new Promise(y=>{this.a(o),this.d={outcome:0,value:o},y()})}error(o){return new Promise(y=>{this.b(o),this.d={outcome:1,value:o},y()})}cancel(){return this.error(new S.$5)}}e.$Dh=x;var ie;(function(M){async function o(A){let j;const F=await Promise.all(A.map(_=>_.then(Z=>Z,Z=>{j||(j=Z)})));if(typeof j<"u")throw j;return F}M.settled=o;function y(A){return new Promise(async(j,F)=>{try{await A(j,F)}catch(_){F(_)}})}M.withAsyncBody=y})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(y=>(this.a=y,this.d=!0,y),y=>{throw this.b=y,this.d=!0,y})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=se;class de{constructor(o){this.b=o,this.a=new u.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=de;var re;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(re||(re={}));class Y{static fromArray(o){return new Y(y=>{y.emitMany(o)})}static fromPromise(o){return new Y(async y=>{y.emitMany(await o)})}static fromPromises(o){return new Y(async y=>{await Promise.all(o.map(async A=>y.emitOne(await A)))})}static merge(o){return new Y(async y=>{await Promise.all(o.map(async A=>{for await(const j of A)y.emitOne(j)}))})}static{this.EMPTY=Y.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new k.$6d,queueMicrotask(async()=>{const y={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(o(y)),this.j()}catch(A){this.k(A)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(o,y){return new Y(async A=>{for await(const j of o)A.emitOne(y(j))})}map(o){return Y.map(this,o)}static filter(o,y){return new Y(async A=>{for await(const j of o)y(j)&&A.emitOne(j)})}filter(o){return Y.filter(this,o)}static coalesce(o){return Y.filter(o,y=>!!y)}coalesce(){return Y.coalesce(this)}static async toPromise(o){const y=[];for await(const A of o)y.push(A);return y}toPromise(){return Y.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$Gh=Y;class ae extends Y{constructor(o,y){super(y),this.l=o}cancel(){this.l.cancel()}}e.$Hh=ae;function le(M){const o=new P.$de,y=M(o.token);return new ae(o,async A=>{const j=o.token.onCancellationRequested(()=>{j.dispose(),o.dispose(),A.reject(new S.$5)});try{for await(const F of y){if(o.token.isCancellationRequested)return;A.emitOne(F)}j.dispose(),o.dispose()}catch(F){j.dispose(),o.dispose(),A.reject(F)}})}class fe{constructor(){this.a=new x,this.b=new Y(A=>{if(o){A.reject(o);return}return y&&A.emitMany(y),this.d=j=>A.reject(j),this.f=j=>A.emitOne(j),this.a.p});let o,y;this.f=A=>{y||(y=[]),y.push(A)},this.d=A=>{o||(o=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$Jh=fe}),define(J[23],K([0,1,39]),function(p,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=void 0,e.$xC=S,e.$yC=k,e.$wC=new class{clone(){return this}equals(C){return this===C}};function S(C,r){return new P.$Vt([new P.$Ut(0,"",C)],r)}function k(C,r){const c=new Uint32Array(2);return c[0]=0,c[1]=(C<<0|0|0|32768|2<<24)>>>0,new P.$Wt(c,r===null?e.$wC:r)}}),define(J[40],K([0,1,22,9,3,41,14,16,49,23,32,17,10]),function(p,e,P,S,k,C,r,c,i,u,m,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.$FC=e.$EC=e.$DC=e.$CC=e.$BC=void 0;var h;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(h||(h={}));class n{constructor(a,$){this.tokenizationSupport=$,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(a)}getStartState(a){return this.store.getStartState(a,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$BC=n;class t extends n{constructor(a,$,w,D){super(a,$),this._textModel=w,this._languageIdCodec=D}updateTokensUntilLine(a,$){const w=this._textModel.getLanguageId();for(;;){const D=this.getFirstInvalidLine();if(!D||D.lineNumber>$)break;const z=this._textModel.getLineContent(D.lineNumber),f=N(this._languageIdCodec,w,this.tokenizationSupport,z,!0,D.startState);a.add(D.lineNumber,f.tokens),this.store.setEndState(D.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(a,$){const w=this.getStartState(a.lineNumber);if(!w)return 0;const D=this._textModel.getLanguageId(),z=this._textModel.getLineContent(a.lineNumber),f=z.substring(0,a.column-1)+$+z.substring(a.column-1),v=N(this._languageIdCodec,D,this.tokenizationSupport,f,!0,w),L=new b.$Lt(v.tokens,f,this._languageIdCodec);if(L.getCount()===0)return 0;const U=L.findTokenIndexAtOffset(a.column-1);return L.getStandardTokenType(U)}tokenizeLineWithEdit(a,$,w){const D=a.lineNumber,z=a.column,f=this.getStartState(D);if(!f)return null;const v=this._textModel.getLineContent(D),L=v.substring(0,z-1)+w+v.substring(z-1+$),U=this._textModel.getLanguageIdAtPosition(D,0),O=N(this._languageIdCodec,U,this.tokenizationSupport,L,!0,f);return new b.$Lt(O.tokens,L,this._languageIdCodec)}isCheapToTokenize(a){const $=this.store.getFirstInvalidEndStateLineNumberOrMax();return a<$||a===$&&this._textModel.getLineLength(a)<2048}tokenizeHeuristically(a,$,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if($<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(a,w),{heuristicTokens:!1};let D=this.b($);const z=this._textModel.getLanguageId();for(let f=$;f<=w;f++){const v=this._textModel.getLineContent(f),L=N(this._languageIdCodec,z,this.tokenizationSupport,v,!0,D);a.add(f,L.tokens),D=L.endState}return{heuristicTokens:!0}}b(a){let $=this._textModel.getLineFirstNonWhitespaceColumn(a);const w=[];let D=null;for(let v=a-1;$>1&&v>=1;v--){const L=this._textModel.getLineFirstNonWhitespaceColumn(v);if(L!==0&&L<$&&(w.push(this._textModel.getLineContent(v)),$=L,D=this.getStartState(v),D))break}D||(D=this.tokenizationSupport.getInitialState()),w.reverse();const z=this._textModel.getLanguageId();let f=D;for(const v of w)f=N(this._languageIdCodec,z,this.tokenizationSupport,v,!1,f).endState;return f}}e.$CC=t;class s{constructor(a){this.d=a,this.a=new d,this.b=new T,this.b.addRange(new i.$ft(1,a+1))}getEndState(a){return this.a.getEndState(a)}setEndState(a,$){if(!$)throw new S.$cb("Cannot set null/undefined state");this.b.delete(a);const w=this.a.setEndState(a,$);return w&&a<this.d&&this.b.addRange(new i.$ft(a+1,a+2)),w}acceptChange(a,$){this.d+=$-a.length,this.a.acceptChange(a,$),this.b.addRangeAndResize(new i.$ft(a.startLineNumber,a.endLineNumberExclusive),$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Kt)($.text);this.acceptChange(new c.$ht($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}invalidateEndStateRange(a){this.b.addRange(new i.$ft(a.startLineNumber,a.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(a,$){return a===1?$:this.getEndState(a-1)}getFirstInvalidLine(a){const $=this.getFirstInvalidEndStateLineNumber();if($===null)return null;const w=this.getStartState($,a);if(!w)throw new S.$cb("Start state must be defined");return{lineNumber:$,startState:w}}}e.$DC=s;class d{constructor(){this.a=new m.$zC(null)}getEndState(a){return this.a.get(a)}setEndState(a,$){const w=this.a.get(a);return w&&w.equals($)?!1:(this.a.set(a,$),!0)}acceptChange(a,$){let w=a.length;$>0&&w>0&&(w--,$--),this.a.replace(a.startLineNumber,w,$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Kt)($.text);this.acceptChange(new c.$ht($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}}e.$EC=d;class T{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const a=this.a[0];return a.start+1===a.endExclusive?this.a.shift():this.a[0]=new i.$ft(a.start+1,a.endExclusive),a.start}delete(a){const $=this.a.findIndex(w=>w.contains(a));if($!==-1){const w=this.a[$];w.start===a?w.endExclusive===a+1?this.a.splice($,1):this.a[$]=new i.$ft(a+1,w.endExclusive):w.endExclusive===a+1?this.a[$]=new i.$ft(w.start,a):this.a.splice($,1,new i.$ft(w.start,a),new i.$ft(a+1,w.endExclusive))}}addRange(a){i.$ft.addRange(a,this.a)}addRangeAndResize(a,$){let w=0;for(;!(w>=this.a.length||a.start<=this.a[w].endExclusive);)w++;let D=w;for(;!(D>=this.a.length||a.endExclusive<this.a[D].start);)D++;const z=$-a.length;for(let f=D;f<this.a.length;f++)this.a[f]=this.a[f].delta(z);if(w===D){const f=new i.$ft(a.start,a.start+$);f.isEmpty||this.a.splice(w,0,f)}else{const f=Math.min(a.start,this.a[w].start),v=Math.max(a.endExclusive,this.a[D-1].endExclusive),L=new i.$ft(f,v+z);L.isEmpty?this.a.splice(w,D-w):this.a.splice(w,D-w,L)}}toString(){return this.a.map(a=>a.toString()).join(" + ")}}e.$FC=T;function N(E,a,$,w,D,z){let f=null;if($)try{f=$.tokenizeEncoded(w,D,z.clone())}catch(v){(0,S.$1)(v)}return f||(f=(0,u.$yC)(E.encodeLanguageId(a),z)),b.$Lt.convertToEndOffset(f.tokens,w.length),f}class I{constructor(a,$){this.b=a,this.d=$,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$wh)(a=>{this.f=!1,this.h(a)}))}h(a){const $=Date.now()+a.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<$?(0,k.$B)(w):this.g())};w()}j(){const a=this.b._textModel.getLineCount(),$=new l.$AC,w=C.$2d.create(!1);do if(w.elapsed()>1||this.l($)>=a)break;while(this.k());this.d.setTokens($.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(a){const $=this.b?.getFirstInvalidLine();return $?(this.b.updateTokensUntilLine(a,$.lineNumber),$.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(a,$){this.b.store.invalidateEndStateRange(new c.$ht(a,$))}}e.$GC=I}),define(J[42],K([0,1,38,2,41,15,39]),function(p,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJb=void 0;class c extends S.$Tc{constructor(u,m,l,b,h,n,t){super(),this.c=u,this.f=m,this.g=l,this.h=b,this.j=h,this.m=n,this.n=t,this.a=[],this.b=this.B(new P.$6d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(u,m,l){throw new Error("Not supported!")}createBackgroundTokenizer(u,m){if(this.h)return this.h(u,m)}tokenizeEncoded(u,m,l){const b=Math.random()*1e4<1,h=this.n||b,n=h?new k.$2d(!0):void 0,t=this.c.tokenizeLine2(u,l,500);if(h){const d=n.elapsed();(b||d>32)&&this.m(d,u.length,b)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${u.substring(0,100)}`),new r.$Wt(t.tokens,l);if(this.g){const d=this.a,T=t.tokens;for(let N=0,I=T.length>>>1;N<I;N++){const E=T[(N<<1)+1],a=C.$It.getLanguageId(E);d[a]||(d[a]=!0,this.b.fire(a))}}let s;return l.equals(t.ruleStack)?s=l:s=t.ruleStack,new r.$Wt(t.tokens,s)}}e.$qJb=c}),define(J[43],K([0,1,23,2,12]),function(p,e,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJb=void 0;class C extends S.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,i,u){super(),this.a=c,this.b=i,this.c=u,this.B((0,k.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,i,u){throw new Error("Not supported!")}tokenizeEncoded(c,i,u){return c.length>=this.c.get()?(0,P.$yC)(this.a,u):this.b.tokenizeEncoded(c,i,u)}createBackgroundTokenizer(c,i){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,i)}}e.$rJb=C}),define(J[44],K([0,1,37,22,12,3,16,50,40,17,10,42,43]),function(p,e,P,S,k,C,r,c,i,u,m,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJb=void 0;class h extends c.$Dv{constructor(s,d,T,N,I,E,a,$){super(s,d,T,N),this.s=I,this.t=E,this.u=a,this.a=null,this.b=!1,this.c=(0,k.observableValue)(this,-1),this.q=new S.$sh(()=>this.w(),10),this.c.set($,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$ht(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,T=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!T)){if(T.grammar){const N=new b.$rJb(this.u,new l.$qJb(T.grammar,T.initialState,!1,void 0,()=>!1,(I,E,a)=>{this.s.reportTokenizationTime(I,s,T.sourceExtensionId,E,a)},!1),this.c);this.a=new i.$BC(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,P.$AD)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const T=new u.$AC,N=new n;for(;;){const a=this.a.getFirstInvalidLine();if(a===null||d>200)break;d++;const $=this.f[a.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded($,!0,a.startState);if(this.a.store.setEndState(a.lineNumber,w.endState)){const z=this.m(a.startState,w.endState);N.setState(a.lineNumber,z)}else N.setState(a.lineNumber,null);if(m.$Lt.convertToEndOffset(w.tokens,$.length),T.add(a.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(d===0)break;const I=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,T.serialize(),I),new Date().getTime()-s>20){(0,C.$B)(()=>this.w());return}}}}e.$wJb=h;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(J[45],K([0,1,21]),function(p,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(C){if(this.a[C.scopeName]){const r=this.a[C.scopeName];P.$Mg(r.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${C.location.toString()}`)}this.a[C.scopeName]=C}getGrammarDefinition(C){return this.a[C]||null}}e.$tJb=S}),define(J[46],K([0,1,2,45]),function(p,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJb=e.$uJb=void 0,e.$uJb="No TM Grammar registered for this language.";class k extends P.$Tc{constructor(r,c,i,u){super(),this.a=r,this.b=i.INITIAL,this.c=new S.$tJb,this.f={},this.g={},this.h=new Map,this.j=this.B(new i.Registry({onigLib:u,loadGrammar:async m=>{const l=this.c.getGrammarDefinition(m);if(!l)return this.a.logTrace(`No grammar found for scope ${m}`),null;const b=l.location;try{const h=await this.a.readFile(b);return i.parseRawGrammar(h,b.path)}catch(h){return this.a.logError(`Unable to load and parse grammar for scope ${m} from ${b}`,h),null}},getInjections:m=>{const l=m.split(".");let b=[];for(let h=1;h<=l.length;h++){const n=l.slice(0,h).join(".");b=[...b,...this.f[n]||[]]}return b}}));for(const m of c){if(this.c.register(m),m.injectTo){for(const l of m.injectTo){let b=this.f[l];b||(this.f[l]=b=[]),b.push(m.scopeName)}if(m.embeddedLanguages)for(const l of m.injectTo){let b=this.g[l];b||(this.g[l]=b=[]),b.push(m.embeddedLanguages)}}m.language&&this.h.set(m.language,m.scopeName)}}has(r){return this.h.has(r)}setTheme(r,c){this.j.setTheme(r,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,c){const i=this.h.get(r);if(typeof i!="string")throw new Error(e.$uJb);const u=this.c.getGrammarDefinition(i);if(!u)throw new Error(e.$uJb);const m=u.embeddedLanguages;if(this.g[i]){const h=this.g[i];for(const n of h)for(const t of Object.keys(n))m[t]=n[t]}const l=Object.keys(m).length>0;let b;try{b=await this.j.loadGrammarWithConfiguration(i,c,{embeddedLanguages:m,tokenTypes:u.tokenTypes,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors})}catch(h){throw h.message&&h.message.startsWith("No grammar provided for")?new Error(e.$uJb):h}return{languageId:r,grammar:b,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:u.sourceExtensionId}}}e.$vJb=k}),define(J[51],K([0,1,11,46,44]),function(p,e,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=C;function C(c,i){return new r(c,i)}class r{constructor(i,u){this.f=u,this.b=new Map,this.c=[],this.a=i.host;const m=u.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g(m)}async g(i){const u=this.f.textmateMainUri,m=await new Promise((t,s)=>{p([u],t,s)}),l=await new Promise((t,s)=>{p([this.f.onigurumaMainUri],t,s)}),h=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(h);const n=Promise.resolve({createOnigScanner:t=>l.createOnigScanner(t),createOnigString:t=>l.createOnigString(t)});return new S.$vJb({logTrace:t=>{},logError:(t,s)=>console.error(t,s),readFile:t=>this.a.readFile(t)},i,m,n)}acceptNewModel(i){const u=P.URI.revive(i.uri),m=this;this.b.set(i.controllerId,new k.$wJb(u,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(l,b){const h=await m.d;return h?(m.c[b]||(m.c[b]=h.createGrammar(l,b)),m.c[b]):Promise.resolve(null)},setTokensAndStates(l,b,h){m.a.setTokensAndStates(i.controllerId,l,b,h)},reportTokenizationTime(l,b,h,n,t){m.a.reportTokenizationTime(l,b,h,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,u){this.b.get(i).onEvents(u)}retokenize(i,u,m){this.b.get(i).retokenize(u,m)}acceptModelLanguageChanged(i,u,m){this.b.get(i).onLanguageId(u,m)}acceptRemovedModel(i){const u=this.b.get(i);u&&(u.dispose(),this.b.delete(i))}async acceptTheme(i,u){(await this.d)?.setTheme(i,u)}acceptMaxTokenizationLineLength(i,u){this.b.get(i).acceptMaxTokenizationLineLength(u)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c19c003574b02afc604c0c1c471b1441b33a3d3/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
